import numpy as np


#1st order terms
class WA1:
    def l1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 8*1j*C*D1**4*Pk1*Pk2*b1*f*k1*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))/(35*d*k3**4) - 24*1j*C*D1**4*Pk1*Pk2*f**2*k1*k2**2*st**4*(3*b1 + f)*(2*r + 2*s - 1)/(35*d*k3**4) + 8*1j*C*D1**4*Pk1*Pk2*f*k1*st**2*(-63*b1**2*k2**2*(r + s) + 3*b1*f*(k1**2*(r + s + 3) + 2*k2**2*(5*r + 5*s - 6)) + f**2*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)))/(105*d*k3**4) - 8*1j*C*D1**4*Pk2*Pkd1*b1*f*k1**2*(7*b1*r + f*(6*r - 3))/(35*d*k3**2) + 8*1j*C*D1**4*Pk2*Pkd1*f**2*k2**2*st**4*(3*b1*r + f)/(35*d*k3**2) + 4*1j*C*D1**4*Pk2*Pkd1*f*st**2*(21*b1**2*k2**2*r - 3*b1*f*(k1**2*r + k2**2*(r - 4)) + f**2*k1**2*(4 - 3*r))/(105*d*k3**2) + 8*1j*D1**4*Pk1*Pk2*ct**7*f**2*k2**3*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 5))/(21*d*k3**4) - 4*1j*D1**4*Pk1*Pk2*ct**6*f**2*k2**2*(-9*b1*k1**2*(2*C*(9*r + 9*s - 8) - 28*r - 28*s + 21) + 45*b1*k2**2*(2*r + 2*s - 1) + 5*f*k1**2*(-6*C*(3*r + 3*s - 2) + 30*r + 30*s - 17) + 5*f*k2**2*(12*r + 12*s - 5))/(105*d*k1*k3**4) + 16*1j*D1**4*Pk1*Pk2*ct**5*f**2*k2**3*st**2*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(48*r + 48*s - 23))/(105*d*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct**5*f*k2*(126*b1**2*k2**2*(C - 1)*(r + s) - 9*b1*f*(k1**2*(2*C*(5*r + 5*s + 1) - r - s - 10) + k2**2*(14*C*(3*r + 3*s - 2) - 13*r - 13*s + 10)) - 5*f**2*(6*C*k1**2*(3*r + 3*s - 1) + 4*C*k2**2*(15*r + 15*s - 7) - 9*k1**2*(r + s) - 3*k2**2*(9*r + 9*s - 4)))/(105*d*k3**4) - 8*1j*D1**4*Pk1*Pk2*ct**4*f**2*k2**2*st**2*(-9*b1*k1**2*(C*(15*r + 15*s - 11) - 25*r - 25*s + 16) + 45*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(-9*C*(9*r + 9*s - 5) + 129*r + 129*s - 68) + f*k2**2*(48*r + 48*s - 23))/(105*d*k1*k3**4) - 4*1j*D1**4*Pk1*Pk2*ct**4*f*(21*b1**2*k2**2*(r + s)*(k1**2*(2*C + 1) + 3*k2**2) + 9*b1*f*(k1**4*(C*(8*r + 8*s - 4) - 13*r - 13*s + 3) + 2*k1**2*k2**2*(7*C*(5*r + 5*s - 4) - 34*r - 34*s + 24) + k2**4*(-11*r - 11*s + 9)) + 5*f**2*(k1**4*(4*C*(3*r + 3*s - 2) - 21*r - 21*s + 11) + 3*k1**2*k2**2*(8*C*(3*r + 3*s - 2) - 27*r - 27*s + 16) - 9*k2**4*(2*r + 2*s - 1)))/(105*d*k1*k3**4) + 8*1j*D1**4*Pk1*Pk2*ct**3*f**2*k2**3*st**4*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 7))/(35*d*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct**3*f*k2*st**2*(126*b1**2*k2**2*(C - 1)*(r + s) + 3*b1*f*(k1**2*(2*C*(5*r + 5*s - 13) - 55*r - 55*s + 59) + k2**2*(-14*C*(13*r + 13*s - 7) + 17*r + 17*s - 5)) + f**2*(9*k1**2*(2*C*(r + s - 1) - 11*r - 11*s + 7) + k2**2*(-2*C*(150*r + 150*s - 73) + 27*r + 27*s - 9)))/(105*d*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct**3*f*(-21*b1**2*k2**2*(r + s)*(k1**2*(12*C - 13) + k2**2*(16*C - 11)) + 18*b1*f*(k1**4*(2*r + 2*s - 1) - 2*k1**2*k2**2*(7*C*(r + s - 1) - 17*r - 17*s + 12) + k2**4*(C*(4*r + 4*s - 9) + 20*r + 20*s - 10)) + 5*f**2*(k1**4*(6*r + 6*s - 4) + k1**2*k2**2*(12*C + 51*r + 51*s - 40) + 9*k2**4*(C*(4*r + 4*s - 2) + 3*r + 3*s - 2)))/(105*d*k2*k3**4) - 4*1j*D1**4*Pk1*Pk2*ct**2*f**2*k2**2*st**4*(-3*b1*(k1**2*(6*C - 11) - 5*k2**2)*(2*r + 2*s - 1) + f*(k1**2*(-6*C*(2*r + 2*s - 1) + 24*r + 24*s - 13) + k2**2*(12*r + 12*s - 7)))/(35*d*k1*k3**4) - 4*1j*D1**4*Pk1*Pk2*ct**2*f*st**2*(63*b1**2*k2**2*(r + s)*(k1**2*(3 - 2*C) + k2**2) + 3*b1*f*(k1**4*(2*C*(r + s + 3) + 3*r + 3*s - 19) + 2*k1**2*k2**2*(5*C*(11*r + 11*s - 9) - 23*r - 23*s + 15) + k2**4*(-31*r - 31*s + 19)) + f**2*(k1**4*(C*(6*r + 6*s + 2) + 3*r + 3*s - 11) + 9*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 11*r - 11*s + 6) - 27*k2**4*(2*r + 2*s - 1)))/(105*d*k1*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct**2*f*(-21*b1**2*(r + s)*(k1**4*(4*C - 10) + k1**2*k2**2*(8*C - 21) - 5*k2**4) + 9*b1*f*(k1**4*(27*r + 27*s - 17) + k1**2*k2**2*(C*(38*r + 38*s - 40) + 40*r + 40*s - 13) + 7*k2**4*(r + s)) + 5*f**2*k1**2*(k1**2*(4*C*(3*r + 3*s - 2) + 9*r + 9*s - 9) + 9*k2**2*(C*(6*r + 6*s - 4) + r + s - 1)))/(105*d*k1*k3**4) - 4*1j*D1**4*Pk1*Pk2*ct*f**2*k2*st**4*(3*b1*(3*k1**2 + k2**2*(10*C + 3))*(2*r + 2*s - 1) + f*(k1**2*(6*r + 6*s - 3) + k2**2*(2*C*(12*r + 12*s - 7) + 6*r + 6*s - 3)))/(35*d*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct*f*st**2*(-63*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(r + s) + 3*b1*f*(k1**4*(r + s + 3) + k1**2*k2**2*(-2*C*(5*r + 5*s - 13) + 11*r + 11*s - 9) + 2*k2**4*(C*(31*r + 31*s - 19) + 5*r + 5*s - 6)) + f**2*(k1**4*(3*r + 3*s + 1) + k1**2*k2**2*(-18*C*(r + s - 1) + 30*r + 30*s - 17) + 9*k2**4*(6*C*(2*r + 2*s - 1) + 3*r + 3*s - 2)))/(105*d*k2*k3**4) + 4*1j*D1**4*Pk1*Pk2*ct*f*(30*C*f**2*k1**2*k2**2*(r + s - 1) + 7*b1**2*(r + s)*(2*k1**4 + k1**2*k2**2*(12*C + 7) + k2**4*(10*C + 5)) + 3*b1*f*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(C*(38*r + 38*s - 26) + 11*r + 11*s - 2) + k2**4*(14*C + 7)*(r + s)))/(35*d*k2*k3**4) - 1j*D1**4*Pk1*b1*f*(7*b1**2*k2*(2*Pk2*k2*(6*r + 5*s) + 5*Pkd2*k1**2*s + 5*Pkd2*k2**2*s) + b1*(28*Pk2*k1**2*s + 42*Pkd2*f*k1**2*k2*s + 21*Pkd2*f*k2**3*s + k2**2*(6*Pk2*f*(12*r + 7*s - 6) + 28*Pk2*(3*K*(r - 1) + 3*r + s - 3))) + 3*k2*(28*Pk2*b2*k2*(r - 1) - 56*Pk2*g2*k2*(r - 1) + 5*Pkd2*f**2*k1**2*s))/(35*d*k1*k2**2) - 2*1j*D1**4*Pk1*b1*f*(2*C*k1**2*k2**2*(70*Pk2*b1*(r + s) + 6*Pk2*f*(10*r + 7*s - 5) + 35*Pkd2*b1*k2*s + 21*Pkd2*f*k2*s) + Pk2*(k1**2 + k2**2)*(7*b1*(2*k1**2*s + 5*k2**2*r) + 3*f*(4*k1**2*s + 7*k2**2*r)))/(35*d*k1*k2**2*k3**2) - 4*1j*D1**4*Pk1*ct**7*f**2*k2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(9*b1*(2*s - 1) + f*(12*s - 7))/(21*d*k3**2) - 1j*D1**4*Pk1*ct**6*f**3*(4*Pk2 - Pkd2*k2)*(11*b1*(33*s - 14) + 21*f*(13*s - 6))/(231*d*k1) + 2*1j*D1**4*Pk1*ct**6*f**2*(9*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(26*s - 20) - 36*s + 25) + k2**2*(Pk2*(-r*(56*C - 56) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + 5*f*k1**2*(4*Pk2 - Pkd2*k2)*(C*(30*s - 28) - 42*s + 35) - 5*f*k2**2*(Pk2*(60*C*r + 28*C - 60*r + 24*s - 42) + Pkd2*k2*(7 - 12*s)))/(105*d*k1*k3**2) - 8*1j*D1**4*Pk1*ct**5*f**2*k2*st**2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(45*b1*(2*s - 1) + f*(48*s - 25))/(105*d*k3**2) + 2*1j*D1**4*Pk1*ct**5*f*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-7*K*s + 7*K + 5*f*(2*s - 1) + 7*s - 7) - 33*b1*(5*f**2*(-Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(12*s - 7)) - 3*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(3*s - 5) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 35*f**3*(Pk2*k2**2*(r - 14) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(14*s - 9)) - 198*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 5))/(1155*d*k1**2*k2) + 2*1j*D1**4*Pk1*ct**5*f*(-126*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) + 9*b1*f*(18*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(3*s - 5) - 19*s + 20) + k1**2*k2**2*(C*Pk2*(-56*r - 68*s + 40) + 6*C*Pkd2*k2*(7*s - 4) + 2*Pk2*(33*r + s) + Pkd2*k2*(4 - 9*s))) + 5*f**2*(6*Pk2*k2**4*(3*r + 2) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(3*s - 7) - 21*s + 28) + k1**2*k2**2*(-6*Pk2*(16*C*s + r*(8*C - 9) - 3*s - 12) + Pkd2*k2*(4*C*(15*s - 8) - 21*s + 4))))/(105*d*k1**2*k2*k3**2) - 2*1j*D1**4*Pk1*ct**4*f**3*st**2*(4*Pk2 - Pkd2*k2)*(11*b1*(12*s - 5) + 5*f*(17*s - 7))/(77*d*k1) + 4*1j*D1**4*Pk1*ct**4*f**2*st**2*(9*b1*k1**2*(4*Pk2 - Pkd2*k2)*(C*(17*s - 12) - 27*s + 17) + 9*b1*k2**2*(Pk2*(-r*(44*C - 44) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(C*(99*s - 60) - 147*s + 85) + f*k2**2*(-2*Pk2*(2*C*(39*r + 5) - 78*r + 48*s - 35) + Pkd2*k2*(48*s - 25)))/(105*d*k1*k3**2) + 1j*D1**4*Pk1*ct**4*f*(792*Pk2*f*g2*k2**2*(4*r + 5) - 33*b1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(f*(13*s - 10) + 14*s - 14) + 2*k2**2*(Pk2*(6*f*(13*s - 5) + r*(70*K - 70) + 42*s - 42) + 3*Pkd2*k2*(f*(5 - 13*s) - 7*s + 7))) - 11*b1*(-840*Pk2*g2*k2**2*r + 5*f**2*(2*k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 14) + k2**2*(Pk2*(36*r - 30*s - 20) + Pkd2*k2*(15*s - 4))) + 18*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k2**2*(2*Pk2*(4*K*r + 5*K - 4*r + 3*s - 10) + Pkd2*k2*(5 - 3*s)))) - 35*f**3*(k1**2*(4*Pk2 - Pkd2*k2)*(17*s - 18) + k2**2*(2*Pk2*(24*r - 55*s - 6) + 11*Pkd2*k2*(5*s - 2))))/(1155*d*k1*k2**2) - 2*1j*D1**4*Pk1*ct**4*f*(-21*b1**2*k2**2*(Pk2*k1**2*s*(4*C - 10) + Pk2*k2**2*r*(20 - 20*C) + Pkd2*k1**2*k2*s*(5 - 2*C) + 3*Pkd2*k2**3*s) + 9*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(Pk2*(108*C*s - 80*C + r - 68*s + 42) + 2*Pkd2*k2*(-35*C*s + 24*C + 26*s - 15)) + k2**4*(Pk2*(-40*C*r + 20*C + 25*r + 4*s - 22) + Pkd2*k2*(11*s - 7))) - 5*f**2*(-k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 7) + k1**2*k2**2*(Pk2*(12*C*(r - 10*s + 7) - 27*r + 84*s + 2) + Pkd2*k2*(C*(84*s - 64) - 69*s + 38)) + k2**4*(Pk2*(60*C*r + 28*C - 63*r - 6*s + 26) + 9*Pkd2*k2*(1 - 2*s))))/(105*d*k1*k2**2*k3**2) - 4*1j*D1**4*Pk1*ct**3*f**2*k2*st**4*(C - 1)*(-4*Pk2 + Pkd2*k2)*(15*b1*(2*s - 1) + f*(12*s - 5))/(35*d*k3**2) + 2*1j*D1**4*Pk1*ct**3*f*st**2*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-7*K*s + 7*K + 10*f*(2*s - 1) + 7*s - 7) - 33*b1*(2*f**2*(5*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(48*s - 25)) - f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(11*s - 9) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 10*f**3*(5*Pk2*k2**2*(13*r - 6) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(74*s - 35)) - 66*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 9))/(1155*d*k1**2*k2) - 2*1j*D1**4*Pk1*ct**3*f*(693*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 33*b1**2*(-14*K*k1**2*(Pk2*(6 - 8*s) + Pkd2*k2*(5*s - 4)) - 49*Pk2*k2**2*r + 3*f*(-2*Pk2*k2**2*r + k1**2*(Pk2*(7*r - 4*s + 4) + 2*Pkd2*k2*(s - 1))) - 7*k1**2*(3*Pk2*r + 4*Pk2*s - 4*Pkd2*k2*s + 2*Pkd2*k2)) + 11*b1*(63*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 5*f**2*(2*Pk2*k2**2*(3*r - 10) + k1**2*(Pk2*(30*r - 90*s + 26) + 5*Pkd2*k2*(9*s - 4))) + 9*f*(-Pk2*k2**2*(5*r + 8) + k1**2*(Pk2*(4*K*(3*s - 5) + 3*r - 12) + 2*Pkd2*k2*(K*(6 - 5*s) + 2*s - 1))) + 84*g2*k1**2*(Pk2*(6 - 8*s) + Pkd2*k2*(5*s - 4))) + f*k1**2*(99*b2*(2*Pk2 - Pkd2*k2)*(3*s - 5) + 35*f**2*(Pk2*(23*r - 88*s + 30) + 22*Pkd2*k2*(2*s - 1)) + 396*g2*(Pk2*(10 - 6*s) + Pkd2*k2*(5*s - 6))))/(1155*d*k1**2*k2) - 2*1j*D1**4*Pk1*ct**3*f*st**2*(126*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) - 3*b1*f*(72*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(11*s - 9) - 73*s + 54) + k1**2*k2**2*(-2*C*(2*Pk2*(36*r + 85*s - 48) + Pkd2*k2*(51 - 91*s)) + 204*Pk2*r - 2*Pk2*s + Pkd2*k2*(6 - 11*s))) + f**2*(-4*Pk2*k2**4*(15*r + 4) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(9*s - 5) - 51*s + 30) + k1**2*k2**2*(Pk2*(8*C*(27*r + 66*s - 40) - 240*r + 54*s - 64) + Pkd2*k2*(C*(154 - 300*s) + 9*s + 6))))/(105*d*k1**2*k2*k3**2) + 2*1j*D1**4*Pk1*ct**3*f*(21*b1**2*(7*Pk2*k2**4*r - k1**4*s*(4*C - 3)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(3*Pk2*r + Pk2*s*(8*C - 8) + Pkd2*k2*s*(16*C - 9))) - 9*b1*f*(Pk2*k2**4*(9*r - 8) + k1**4*(Pk2*(40*C*(s - 1) + 11*r - 64*s + 44) + 4*Pkd2*k2*(C*(6 - 7*s) + 11*s - 7)) + 2*k1**2*k2**2*(-4*Pk2*(C*(10*r + 2*s - 5) - 16*r - 3*s + 7) + Pkd2*k2*(C*(4*s - 7) + 18*s - 7))) + 5*f**2*(-18*Pk2*k2**4*r + k1**4*(Pk2*(-8*C*(3*s - 7) - 21*r + 54*s - 44) + Pkd2*k2*(8*C*(3*s - 4) - 45*s + 36)) + k1**2*k2**2*(Pk2*(8*C*(6*r + 7) - 135*r - 12*s + 16) - 9*Pkd2*k2*(C*(4*s - 2) + 3*s - 2))))/(105*d*k1**2*k2*k3**2) - 3*1j*D1**4*Pk1*ct**2*f**3*st**4*(4*Pk2 - Pkd2*k2)*(11*b1*(5*s - 2) + f*(29*s - 10))/(77*d*k1) + 2*1j*D1**4*Pk1*ct**2*f**2*st**4*(3*b1*k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 3*b1*k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(3*s - 1) - 24*s + 9) + f*k2**2*(-2*Pk2*(6*C*(3*r - 1) - 18*r + 12*s + 1) + Pkd2*k2*(12*s - 5)))/(35*d*k1*k3**2) + 1j*D1**4*Pk1*ct**2*f*st**2*(264*Pk2*f*g2*k2**2*(2*r - 1) - 11*b1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(f*(17*s - 12) + 14*s - 14) + 2*k2**2*(2*Pk2*(3*f*(17*s - 6) + r*(14*K - 14) + 21*s - 21) + 3*Pkd2*k2*(f*(6 - 17*s) - 7*s + 7))) - 22*b1*(-56*Pk2*g2*k2**2*r + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(33*s - 20) + 4*k2**2*(Pk2*(18*r - 6*s - 1) + Pkd2*k2*(3*s - 2))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 9) + k2**2*(2*Pk2*(6*K*r - 3*K - 6*r + 11*s - 6) + Pkd2*k2*(9 - 11*s)))) - 5*f**3*(4*Pk2*k2**2*(48*r - 55*s + 10) + 22*Pkd2*k2**3*(5*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(57*s - 28)))/(385*d*k1*k2**2) + 1j*D1**4*Pk1*ct**2*f*(-36*Pk2*f*k2**2*(b2*(3*r - 5) + 2*g2*(4*r + 5)) + 21*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) + 3*b1**2*(k1**2*(2*Pk2*(69*f*s - 42*f + 84*s - 56) + Pkd2*k2*(-69*f*s + 42*f - 98*s + 70)) + k2**2*(-4*Pk2*(-56*K*r + 21*K + 3*f*(12*r - 5) + 56*r + 7*s - 28) + Pkd2*k2*(f*(42 - 129*s) - 98*s + 70))) + 3*b1*(56*Pk2*g2*k2**2*(3 - 8*r) + 5*f**2*(-4*Pk2*k2**2*(6*r - 5) + 6*Pkd2*k2**3*(1 - 3*s) + k1**2*(2*Pk2 - Pkd2*k2)*(19*s - 12)) + 6*f*(k1**2*(2*Pk2*(5*s - 6) - 7*Pkd2*k2*(s - 1)) + k2**2*(2*K*Pk2*(4*r + 5) - 4*Pk2*(5*r + s - 3) - 7*Pkd2*k2*(s - 1)))) + 35*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(105*d*k1*k2**2) + 2*1j*D1**4*Pk1*ct**2*f*st**2*(21*b1**2*k2**2*(Pk2*k1**2*s*(8*C - 14) + Pk2*k2**2*r*(8 - 8*C) + Pkd2*k1**2*k2*s*(7 - 4*C) + 3*Pkd2*k2**3*s) - 3*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 9) + k1**2*k2**2*(Pk2*(4*C*(5*r + 54*s - 54) - 29*r - 46*s + 93) + 2*Pkd2*k2*(C*(50 - 60*s) + 19*s - 20)) + k2**4*(-3*Pk2*(48*C*r + 4*C - 41*r - 2*s - 3) + Pkd2*k2*(31*s - 21))) + f**2*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(9*s - 5) + k1**2*k2**2*(Pk2*(-4*C*(15*r + 108*s - 95) + 33*r + 72*s - 113) + 3*Pkd2*k2*(C*(84*s - 52) - 27*s + 16)) + 3*k2**4*(Pk2*(8*C*(3*r + 5) - 69*r - 6*s + 1) + 9*Pkd2*k2*(1 - 2*s))))/(105*d*k1*k2**2*k3**2) + 2*1j*D1**4*Pk1*ct**2*f*(-21*b1**2*(k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(29 - 20*C) + Pk2*s*(18 - 16*C) + Pkd2*k2*s*(17 - 12*C)) + k2**4*(Pk2*r*(21 - 20*C) + 12*Pk2*s + 5*Pkd2*k2*s)) + 9*b1*f*(k1**4*(6*Pk2*(3*s - 2) + Pkd2*k2*(7 - 11*s)) + k1**2*k2**2*(2*Pk2*(2*C*(10*r + 8*s - 5) - 58*r - 20*s + 23) + Pkd2*k2*(C*(28 - 30*s) - 32*s + 7)) + k2**4*(2*Pk2*(8*C*r + 10*C - 30*r - 9*s + 8) - 7*Pkd2*k2*s)) - 5*f**2*(27*Pk2*k2**4*r + k1**4*(-4*Pk2*(3*s - 4) + 9*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(4*C*(3*r - 7) + 63*r + 6*s - 2) + 9*Pkd2*k2*(C*(6*s - 4) + s - 1))))/(105*d*k1*k2**2*k3**2) - 2*1j*D1**4*Pk1*ct*f**2*st**4*(165*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 33*b1*f*(5*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(12*s - 5)) + f**2*(5*Pk2*k2**2*(25*r + 2) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(78*s - 25)))/(385*d*k1**2*k2) - 4*1j*D1**4*Pk1*ct*f**2*st**4*(3*b1*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + f*(Pk2*k2**4*(2 - 3*r) + k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(3*r + 6*s - 4) - 15*r + 6*s + 4) + Pkd2*k2*(C*(5 - 12*s) - 3*s + 1))))/(35*d*k1**2*k2*k3**2) - 2*1j*D1**4*Pk1*ct*f*st**2*(231*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 11*b1**2*(Pk2*k2**2*r*(30*f - 7) + k1**2*(Pk2*f*(21*r + 4*s + 24) + 7*Pk2*(8*K*(s - 1) - 3*r + 4*s - 4) - 2*Pkd2*f*k2*(s + 6) + Pkd2*k2*(-21*K - 21)*(s - 1))) + 11*b1*(21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + f**2*(2*Pk2*k2**2*(15*r - 2) + k1**2*(Pk2*(42*r - 54*s + 34) + Pkd2*k2*(27*s - 22))) + f*(-Pk2*k2**2*(r - 4) + k1**2*(Pk2*(4*K*(5*s - 6) + r + 24*s - 16) - Pkd2*k2*(K + 1)*(11*s - 9))) - 14*g2*k1**2*(8*Pk2 - 3*Pkd2*k2)*(s - 1)) + f*k1**2*(11*b2*(2*Pk2 - Pkd2*k2)*(11*s - 9) + 5*f**2*(Pk2*(35*r - 88*s + 38) + 22*Pkd2*k2*(2*s - 1)) + 22*g2*(-4*Pk2*(5*s - 6) + Pkd2*k2*(11*s - 9))))/(385*d*k1**2*k2) - 2*1j*D1**4*Pk1*ct*f*(63*Pkd2*f*k1**2*k2*(b2 - 2*g2)*(s - 1) + 21*b1**3*(Pk2*k2**2*r + k1**2*(5*Pk2*r + 7*Pkd2*k2*s)) + 3*b1**2*(Pk2*k2**2*(3*f*(5*r - 6) + 63*r - 28) + k1**2*(6*Pk2*f*(13*r - 5) + 7*Pk2*(-4*K*s + 13*r + 4*s - 8) + 3*Pkd2*f*k2*(32*s - 7) + Pkd2*k2*(7*K + 7)*(7*s - 5))) + b1*(5*f**2*k1**2*(Pk2*(21*r - 10) + 9*Pkd2*k2*(3*s - 1)) + 63*f*(Pk2*k2**2*r + k1**2*(Pk2*r + Pkd2*k2*(K + 1)*(s - 1))) + 21*k1**2*(8*Pk2*g2*s + Pkd2*b2*k2*(7*s - 5) + 2*Pkd2*g2*k2*(5 - 7*s))))/(105*d*k1**2*k2) - 2*1j*D1**4*Pk1*ct*f*st**2*(-21*b1**2*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) + 3*b1*f*(Pk2*k2**4*(41*r + 4) + k1**4*(Pk2*(8*C*(5*s - 6) + 3*r - 8*s + 44) + Pkd2*k2*(C*(18 - 22*s) + 9*s - 14)) + k1**2*k2**2*(2*Pk2*(2*C*(12*r - s - 6) + 40*r + 5*s + 12) + Pkd2*k2*(C*(62*s - 42) + 9*s - 14))) + f**2*(54*Pk2*k2**4*r + k1**4*(Pk2*(96*C*s - 80*C + 3*r - 24*s + 64) + 3*Pkd2*k2*(-18*C*s + 10*C + 9*s - 6)) + k1**2*k2**2*(Pk2*(24*C*(6*r - 5) + 159*r + 18*s + 16) + 9*Pkd2*k2*(6*C*(2*s - 1) + 3*s - 2))))/(105*d*k1**2*k2*k3**2) - 2*1j*D1**4*Pk1*ct*f*(7*b1**2*(5*Pk2*k2**4*r + k1**4*(4*Pk2*(3*r + s*(3 - 2*C)) + Pkd2*k2*s*(4*C + 5)) + k1**2*k2**2*(33*Pk2*r + Pk2*s*(20*C + 14) + Pkd2*k2*s*(10*C + 5))) + 3*b1*f*(7*Pk2*k2**4*r + k1**4*(2*C*Pkd2*k2*(11*s - 7) + 31*Pk2*r - 4*Pk2*(s*(4*C - 6) + 3) + 7*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(4*C*(6*r + 7*s - 10) + 58*r + 22*s - 8) + Pkd2*k2*s*(14*C + 7))) + 15*f**2*k1**2*(2*C*Pkd2*k1**2*k2*(s - 1) + Pk2*r*(k1**2 + k2**2)))/(35*d*k1**2*k2*k3**2) - 2*1j*D1**4*Pk1*f**3*st**6*(4*Pk2 - Pkd2*k2)*(11*b1*(3*s - 1) + 3*f*(4*s - 1))/(231*d*k1) + 2*1j*D1**4*Pk1*f**2*st**4*(-3*b1*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + f*(Pk2*k2**2*(C*(4 - 12*r) + 6*r - 3) + k1**2*(4*C*Pkd2*k2*(3*s - 1) + Pk2*(-24*C*s + 8*C + 6*r - 3))))/(35*d*k1*k3**2) - 1j*D1**4*Pk1*f**2*st**4*(66*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*b1*f*(4*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(36*r - 6*s + 4) + Pkd2*k2*(3*s - 4))) + f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(72*r - 55*s + 26) + 11*Pkd2*k2*(5*s - 2))))/(385*d*k1*k2**2) + 1j*D1**4*Pk1*f*st**2*(-36*Pk2*f*k2**2*(b2 - 2*g2)*(2*r - 1) + 42*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - 3*b1**2*(k1**2*(2*Pk2*(3*f*s + 14*f - 7*s + 7) - Pkd2*f*k2*(3*s + 14)) + 2*k2**2*(Pk2*(48*f*r - 6*f - 7*s + 7) + Pkd2*f*k2*(15*s - 7))) + 6*b1*f*(k1**2*(Pk2*(8*f*s - 12*f - s - 3) + 2*Pkd2*f*k2*(3 - 2*s)) - k2**2*(Pk2*(12*K*r - 6*K + 24*f*r - 2*f + 12*r + s - 3) + 3*Pkd2*f*k2*(3*s - 1))) + 5*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(105*d*k1*k2**2) - 2*1j*D1**4*Pk1*f*st**2*(-21*b1**2*(Pk2*k2**4*(2*r + s) + k1**2*k2**2*(4*C*Pkd2*k2*s + 2*Pk2*r + Pk2*s)) + 3*b1*f*(Pk2*k1**4*(s + 3) + Pk2*k2**4*(12*C*(2*r - 1) + 9*r + s + 6) + k1**2*k2**2*(2*C*Pkd2*k2*(9*s - 14) + Pk2*(28*C*r + 9*r + 2*s + 9))) + f**2*(Pk2*k1**4*(3*s + 5) + 27*Pk2*k2**4*r + k1**2*k2**2*(18*C*Pkd2*k2*(3*s - 2) + Pk2*(60*C*r - 20*C + 27*r + 3*s + 5))))/(105*d*k1*k2**2*k3**2) - 4*1j*D1**4*Pk2*Pkd1*b1*ct*f*k1*(k1**2 + k2**2*(4*C + 1))*(7*b1*r + f*(6*r - 3))/(35*d*k2*k3**2) - 4*1j*D1**4*Pk2*Pkd1*b1*ct*f*(21*b1**2*r*(k1**2 + k2**2) + 3*b1*(k1**2*(12*f*r - 3*f + 7*r - 7) + k2**2*(6*f*r - 3*f + 7*r - 7)) + 5*f**2*k1**2*(3*r - 1))/(105*d*k1*k2) - 4*1j*D1**4*Pk2*Pkd1*b1*f*(7*b1**2*r + b1*f*(6*r - 3) + 7*b1*(K + 1)*(r - 1) + (7*b2 - 14*g2)*(r - 1))/(35*d) + 8*1j*D1**4*Pk2*Pkd1*ct**6*f**2*k2**2*(C - 1)*(18*b1*r + 5*f*(3*r - 1))/(105*d*k3**2) - 4*1j*D1**4*Pk2*Pkd1*ct**5*f**3*k2*(33*b1*r + 7*f*(4*r - 1))/(231*d*k1) - 4*1j*D1**4*Pk2*Pkd1*ct**5*f**2*k2*(18*b1*r + 5*f*(3*r - 1))*(k1**2*(5 - 4*C) + k2**2)/(105*d*k1*k3**2) + 8*1j*D1**4*Pk2*Pkd1*ct**4*f**2*k2**2*st**2*(C - 1)*(3*b1*r + f*(3*r - 4))/(35*d*k3**2) - 4*1j*D1**4*Pk2*Pkd1*ct**4*f*(33*b1**2*r*(-7*K + 6*f + 7) + 11*b1*(5*f**2*(9*r - 1) - 9*f*(K - 1)*(2*r - 1) + 42*g2*r) + 70*f**3*(4*r - 1) + 198*f*g2*(2*r - 1))/(1155*d) + 8*1j*D1**4*Pk2*Pkd1*ct**4*f*(21*b1**2*k2**2*r*(C - 1) - 9*b1*f*(k1**2*r*(4 - 2*C) + k2**2*(C + 4*r - 1)) + 5*f**2*(3*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)))/(105*d*k3**2) - 4*1j*D1**4*Pk2*Pkd1*ct**3*f**3*k2*st**2*(33*b1*r + 5*f*(5*r - 4))/(231*d*k1) - 4*1j*D1**4*Pk2*Pkd1*ct**3*f**2*k2*st**2*(3*b1*r + f*(3*r - 4))*(k1**2*(3 - 2*C) + k2**2)/(35*d*k1*k3**2) - 4*1j*D1**4*Pk2*Pkd1*ct**3*f*(33*b1**2*r*(k1**2*(6*f + 7) + k2**2*(12*f + 7)) + 11*b1*f*(k1**2*(30*f*r - 5*f + 18*r - 9) + k2**2*(30*f*r - 10*f + 18*r - 9)) + 35*f**3*k1**2*(4*r - 1))/(1155*d*k1*k2) - 4*1j*D1**4*Pk2*Pkd1*ct**3*f*(21*b1**2*k2**2*r*(k1**2*(5 - 4*C) + k2**2) + 9*b1*f*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**4*(2*r - 1)) + 5*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(3*r - 1))/(105*d*k1*k2*k3**2) - 8*1j*D1**4*Pk2*Pkd1*ct**2*f**2*k2**2*st**4*(C - 1)*(3*b1*r + f)/(35*d*k3**2) - 2*1j*D1**4*Pk2*Pkd1*ct**2*f*st**2*(11*b1**2*r*(7*K + 6*f - 7) + 11*b1*(2*f**2*(9*r - 4) - f*(K - 1)*(r - 4) - 14*g2*r) + 20*f**3*(5*r - 4) + 22*f*g2*(r - 4))/(385*d) - 4*1j*D1**4*Pk2*Pkd1*ct**2*f*(7*b1**3*r + b1**2*(7*K + 3*f*(8*r - 1) + 14*r - 7) + b1*(7*b2*r + 5*f**2*(3*r - 1) + 3*f*(K + 1)*(2*r - 1) - 14*g2) + 3*f*(b2 - 2*g2)*(2*r - 1))/(35*d) - 4*1j*D1**4*Pk2*Pkd1*ct**2*f*st**2*(21*b1**2*k2**2*r*(C - 1) + 3*b1*f*(-k1**2*r*(C - 4) + k2**2*(5*C*r + 4*C + 4*r - 4)) - f**2*(3*r - 4)*(k1**2*(C - 4) - k2**2*(6*C + 3)))/(105*d*k3**2) - 8*1j*D1**4*Pk2*Pkd1*ct**2*f*(5*C*f**2*k1**2*(3*r - 1) - 21*b1**2*r*(k1**2*(C - 2) - k2**2*(C + 1)) + 9*b1*f*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1)))/(105*d*k3**2) - 4*1j*D1**4*Pk2*Pkd1*ct*f**4*k2*st**4*(r - 3)/(77*d*k1) + 4*1j*D1**4*Pk2*Pkd1*ct*f**2*k2*st**4*(k1**2 + k2**2)*(3*b1*r + f)/(35*d*k1*k3**2) - 2*1j*D1**4*Pk2*Pkd1*ct*f*st**2*(11*b1**2*r*(k1**2*(3*f - 7) + k2**2*(6*f - 7)) + 11*b1*f*(k1**2*(6*f*r - 4*f + r - 4) + k2**2*(6*f*r - 8*f + r - 4)) + 5*f**3*k1**2*(5*r - 4))/(385*d*k1*k2) - 2*1j*D1**4*Pk2*Pkd1*ct*f*st**2*(-21*b1**2*k2**2*r*(k1**2 + k2**2) + 3*b1*f*(k1**4*r + 2*k1**2*k2**2*(6*C*r + r - 2) + k2**4*(r - 4)) + f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(3*r - 4))/(105*d*k1*k2*k3**2) + 4*1j*D1**4*Pk2*Pkd1*f**2*st**4*(33*b1**2*r + 11*b1*f - 2*f**2*(r - 3))/(385*d) - 2*1j*D1**4*Pk2*Pkd1*f*st**2*(-7*b1**3*r + b1**2*(4*f*(r - 1) - r*(7*K + 7)) + b1*(f**2*(3*r - 4) + f*(K + 1)*(r - 4) - r*(7*b2 - 14*g2)) + f*(b2 - 2*g2)*(r - 4))/(35*d)
        perm13 = 12*1j*D1**4*Pk1*Pk3*b1*ct**4*f*(7*b1*(s - 1) + f*(3*s - 5))/(35*d*k1) - 2*1j*D1**4*Pk1*Pk3*b1*ct**3*f*(42*b1*k1**2*(2*C - 1)*(s - 1) + 49*b1*k2**2*r + f*k1**2*(12*C - 6)*(3*s - 5) + 3*f*k2**2*(5*r + 8))/(35*d*k1**2*k2) + 4*1j*D1**4*Pk1*Pk3*b1*ct**2*f*st**2*(21*b1*(s - 1) + f*(11*s - 9))/(35*d*k1) + 4*1j*D1**4*Pk1*Pk3*b1*ct**2*f*(7*b1*(s - 1) + 3*f*(C*(10 - 6*r) + 3*r + 2*s - 6))/(35*d*k1) + 2*1j*D1**4*Pk1*Pk3*b1*ct*f*k2*(7*b1**2*r + 3*b1*f*(5*r - 6) + 7*b1*(9*r - 4) + 21*f*r)/(35*d*k1**2) - 2*1j*D1**4*Pk1*Pk3*b1*ct*f*st**2*(42*b1*k1**2*(2*C - 1)*(s - 1) + 7*b1*k2**2*r + f*k1**2*(4*C - 2)*(11*s - 9) + f*k2**2*(r - 4))/(35*d*k1**2*k2) - 2*1j*D1**4*Pk1*Pk3*b1*f*st**2*(7*b1*(s - 1) + f*(12*C*(2*r - 1) - 12*r - s + 3))/(35*d*k1) + 2*1j*D1**4*Pk1*Pk3*b1*f*(5*b1**2*(s - 1) + b1*(-6*K*r + 6*K + 3*f*(s - 1) + 2*s) + (-6*b2 + 12*g2)*(r - 1))/(5*d*k1) + 16*1j*D1**4*Pk1*Pk3*ct**7*f**2*k2**5*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 5))/(21*d*k3**6) + 8*1j*D1**4*Pk1*Pk3*ct**7*f**2*k2**3*(C - 1)*(9*b1*(2*s - 1) + f*(12*s - 7))/(21*d*k3**4) + 4*1j*D1**4*Pk1*Pk3*ct**6*f**2*k2**4*(11*b1*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(58*r + 58*s - 36) - 48*r - 48*s + 31)) + 5*f*(21*f*k2**2*(13*r + 13*s - 7) + 22*k1**2*(66*C*r + 66*C*s - 32*C - 54*r - 54*s + 27)))/(1155*d*k1*k3**6) + 4*1j*D1**4*Pk1*Pk3*ct**6*f**2*k2**2*(9*b1*(2*s - 1) + f*(12*s - 7))/(21*d*k1*k3**2) + 4*1j*D1**4*Pk1*Pk3*ct**6*f**2*k2**2*(9*b1*(k1**2*(66*C*s - 40*C - 56*s + 35) + k2**2*(-28*C*r + 38*r + 10*s - 5)) + 5*f*(k1**2*(C*(78*s - 56) - 66*s + 49) + k2**2*(-2*C*(15*r + 7) + 42*r + 12*s + 9)))/(105*d*k1*k3**4) + 32*1j*D1**4*Pk1*Pk3*ct**5*f**2*k2**5*st**2*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(48*r + 48*s - 23))/(105*d*k3**6) + 16*1j*D1**4*Pk1*Pk3*ct**5*f**2*k2**3*st**2*(C - 1)*(45*b1*(2*s - 1) + f*(48*s - 25))/(105*d*k3**4) - 8*1j*D1**4*Pk1*Pk3*ct**5*f*k2**3*(99*b1**2*k2**2*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(5*f**2*k2**2*(6*r + 6*s - 5) + 3*f*(k1**2*(C*(46*r + 46*s - 44) - 27*r - 27*s + 31) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16)) - 42*g2*k2**2*(r + s)) + f*(-70*f**2*k2**2*(17*r + 17*s - 10) - 55*f*k1**2*(14*C*(3*r + 3*s - 2) - 21*r - 21*s + 17) + f*k2**2*(990*C - 990)*(2*r + 2*s - 1) + 198*g2*k2**2*(3*r + 3*s + 2)))/(1155*d*k3**6) - 4*1j*D1**4*Pk1*Pk3*ct**5*f*k2*(-126*b1**2*k1**2*(C - 1)*(s - 1) + 9*b1*f*(k1**2*(14*C*s - 17*s + 5) + 9*k2**2*r) + 5*f**2*(k1**2*(24*C*s - 14*C - 27*s + 21) + 3*k2**2*(3*r + 2)))/(105*d*k1**2*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct**5*f*k2*(2772*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) - 33*b1*f*(5*f*k2**4*r - 6*k1**4*(C*(78*s - 60) - 55*s + 45) + 6*k1**2*k2**2*(6*C*s + r*(62*C - 56) - 5*s + 3)) + 5*f**2*(7*f*k2**4*(r - 14) + 66*k1**4*(30*C*s - 28*C - 21*s + 21) - 66*k1**2*k2**2*(2*C*(10*r + 2*s + 9) - 18*r - 3*s - 15)))/(1155*d*k1**2*k3**4) + 8*1j*D1**4*Pk1*Pk3*ct**4*f**2*k2**4*st**2*(33*b1*(5*f*k2**2*(12*r + 12*s - 7) + 6*k1**2*(C*(55*r + 55*s - 31) - 45*r - 45*s + 26)) + f*(75*f*k2**2*(17*r + 17*s - 10) + 22*k1**2*(C*(273*r + 273*s - 137) - 225*r - 225*s + 114)))/(1155*d*k1*k3**6) + 8*1j*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(45*b1*(2*s - 1) + f*(48*s - 25))/(105*d*k1*k3**2) + 8*1j*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(9*b1*k1**2*(C*(57*s - 32) - 47*s + 27) + 9*b1*k2**2*(r*(32 - 22*C) + 10*s - 5) + f*k1**2*(C*(291*s - 160) - 243*s + 135) + f*k2**2*(-2*C*(39*r + 5) + 126*r + 48*s - 13))/(105*d*k1*k3**4) - 4*1j*D1**4*Pk1*Pk3*ct**4*f*k2**2*(33*b1**2*k1**2*k2**2*(f*(93*r + 93*s - 57) + (28 - 70*K)*(r + s)) + 11*b1*(5*f**2*k2**2*(k1**2*(24*r + 24*s + 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(2*C*(5*r + 5*s + 8) - 14*r - 14*s - 7) - k2**2*(-14*C*(7*r + 7*s - 4) + K*(r + s + 10) + 86*r + 86*s - 57)) + 420*g2*k1**2*k2**2*(r + s)) + f*(35*f**2*k2**2*(k1**2*(-3*r - 3*s + 5) + 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(C*(30*r + 30*s - 8) - 30*r - 30*s + 11) + 9*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) + 396*g2*k1**2*k2**2*(r + s + 10)))/(1155*d*k1*k3**6) + 2*1j*D1**4*Pk1*Pk3*ct**4*f*(42*b1**2*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(10 - 10*C)) - 9*b1*f*(k1**2*s*(28*C - 14) + k2**2*(4*C*(4*r + 5) - r - 4*s - 18)) - 5*f**2*(k1**2*(C*(60*s - 56) - 36*s + 42) + k2**2*(4*C*(3*r - 7) + 3*r - 6*s + 40)))/(105*d*k1*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct**4*f*(66*b1**2*(k1**2*k2**2*(56*C - 35)*(r + s - 1) + k2**4*(3*f*(13*r + 13*s - 8) + r*(56 - 35*K) + 21*s)) + 11*b1*(5*f**2*k2**4*(42*r + 75*s - 29) + 9*f*(k1**4*(76*C*s - 80*C - 44*s + 50) + k1**2*k2**2*(-8*C*r + 20*C*s - 5*r - 38*s + 6) - 2*k2**4*(-28*C*r + 4*K*r + 5*K + 35*r + 11*s - 14)) + 420*g2*k2**4*r) + f*(35*f**2*k2**4*(36*r + 55*s - 75) + 55*f*(2*k1**4*(14*C*(3*s - 4) - 24*s + 35) + k1**2*k2**2*(12*C*(6*r + 3*s - 16) - 75*r - 66*s + 158) + 18*k2**4*(r*(4*C - 6) - 2*s + 1)) + 396*g2*k2**4*(4*r + 5)))/(1155*d*k1*k3**4) + 16*1j*D1**4*Pk1*Pk3*ct**3*f**2*k2**5*st**4*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 7))/(35*d*k3**6) + 8*1j*D1**4*Pk1*Pk3*ct**3*f**2*k2**3*st**4*(C - 1)*(15*b1*(2*s - 1) + f*(12*s - 5))/(35*d*k3**4) + 8*1j*D1**4*Pk1*Pk3*ct**3*f*k2**3*st**2*(-99*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + 33*b1*(2*f**2*k2**2*(27*r + 27*s - 20) + f*k1**2*(C*(310*r + 310*s - 218) - 205*r - 205*s + 155) + f*k2**2*(-42*C*(2*r + 2*s - 1) + K*(11*r + 11*s - 2) + 73*r + 73*s - 40) - 42*g2*k2**2*(r + s)) + f*(10*f**2*k2**2*(197*r + 197*s - 123) + 11*f*(k1**2*(C*(534*r + 534*s - 290) - 357*r - 357*s + 199) + k2**2*(54 - 54*C)*(2*r + 2*s - 1)) - 66*g2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**6) + 8*1j*D1**4*Pk1*Pk3*ct**3*f*k2*(33*b1**2*k2**2*(3*f*(k1**2*(3*r + 3*s + 2) + 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(5*K - 7) - 7*k2**2*(5*K - 5))) - 11*b1*(5*f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 9*k2**2*(4*r + 4*s - 3)) + 9*f*(k1**4*(C*(26*r + 26*s - 6) - 17*r - 17*s + 5) + k1**2*k2**2*(42*C*(3*r + 3*s - 2) + 19*K*r + 19*K*s - 20*K - 108*r - 108*s + 75) + k2**4*(7*K - 7)*(r + s)) - 210*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(-35*f**2*(k1**2*k2**2*(21*r + 21*s - 13) + 22*k2**4*(3*r + 3*s - 2)) - 55*f*(k1**4*(C*(42*r + 42*s - 22) - 27*r - 27*s + 15) + 9*k1**2*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*g2*k2**2*(k1**2*(19*r + 19*s - 20) + 7*k2**2*(r + s))))/(1155*d*k3**6) - 2*1j*D1**4*Pk1*Pk3*ct**3*f*(1386*b1**3*k2**4*(r + s - 1) + 33*b1**2*(k1**2*k2**2*(28*C - 42)*(r + s - 1) + k2**4*(140*C*(r + s - 1) + 28*K*(4*r - s - 1) + f*(75*r + 96*s - 60) - 175*r - 56*s + 168)) + 33*b1*(10*f**2*k2**4*(r - 11*s) - 3*f*(k1**4*(4*C - 2)*(3*s - 5) + k1**2*k2**2*(r*(104*C - 63) + s*(48*C - 40) + 4) + k2**4*(28*C*s + 4*K*(3*r + 4*s - 12) + r*(168*C - 193) - 74*s + 58)) + 14*k2**4*(3*b2*(r + s) + 4*g2*(-4*r + s + 1))) + f*(-35*f**2*k2**4*(69*r + 132*s - 130) - 55*f*(k1**4*(4*C - 2)*(3*s - 7) + k1**2*k2**2*(4*C*(57*r + 27*s - 43) - 147*r - 90*s + 118) + 18*k2**4*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) + 198*k2**4*(b2*(3*r + 3*s + 2) + 4*g2*(3*r + 4*s - 12))))/(1155*d*k2*k3**4) - 4*1j*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(-126*b1**2*k1**2*(C - 1)*(s - 1) + 3*b1*f*(k1**2*(98*C*s - 42*C - 89*s + 48) + 36*k2**2*r) + f**2*(k1**2*(4*C*(48*s - 25) - 195*s + 110) + 2*k2**2*(15*r + 4)))/(105*d*k1**2*k3**2) + 4*1j*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(1386*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 33*b1*f*(5*f*k2**4*r + k1**4*(C*(346*s - 222) - 235*s + 156) + k1**2*k2**2*(C*(-290*r - 86*s + 32) + 245*r + 71*s - 35)) + f**2*(25*f*k2**4*(13*r - 6) + 11*k1**4*(C*(642*s - 370) - 447*s + 260) - 11*k1**2*k2**2*(6*C*(58*r + 26*s + 5) - 321*r - 141*s + 1)))/(1155*d*k1**2*k3**4) + 2*1j*D1**4*Pk1*Pk3*ct**3*f*(3*b1**2*(k1**4*(84*C - 42)*(s - 1) - 7*k1**2*k2**2*(4*C*(3*r - 2*s + 2) - 9*r + 8*s - 8) - k2**4*r*(6*f + 49)) + b1*f*k2**2*(-72*k1**2*(C*(2*r - 2*s + 7) - r + s - 5) + k2**2*(30*f*r - 100*f + 81*r - 72)) - 5*f**2*(k1**4*(4*C - 2)*(3*s - 7) + k1**2*k2**2*(C*(60*r - 56) - 39*r - 12*s + 44) - 18*k2**4*r))/(105*d*k1**2*k2*k3**2) + 4*1j*D1**4*Pk1*Pk3*ct**2*f**2*k2**4*st**4*(33*b1*(5*f*k2**2*(5*r + 5*s - 3) + k1**2*(52*C - 42)*(2*r + 2*s - 1)) + f*(15*f*k2**2*(29*r + 29*s - 19) + 22*k1**2*(C*(60*r + 60*s - 34) - 48*r - 48*s + 27)))/(385*d*k1*k3**6) + 4*1j*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(15*b1*(2*s - 1) + f*(12*s - 5))/(35*d*k1*k3**2) + 4*1j*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(3*b1*k1**2*(24*C - 19)*(2*s - 1) + 3*b1*k2**2*(r*(26 - 16*C) + 10*s - 5) + f*k1**2*(12*C*(5*s - 2) - 48*s + 19) + f*k2**2*(C*(6 - 18*r) + 30*r + 12*s - 13))/(35*d*k1*k3**4) + 4*1j*D1**4*Pk1*Pk3*ct**2*f*k1*(33*b1**2*k2**2*(3*f*(k1**2*(25*r + 25*s - 9) + 7*k2**2*(9*r + 9*s - 5)) + (r + s)*(-14*k1**2*(15*K - 8) - 14*k2**2*(15*K - 10))) + 33*b1*(5*f**2*k2**2*(k1**2*(9*r + 9*s - 5) + 6*k2**2) - 6*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(5*r + 5*s - 4) + K*(33*r + 33*s - 20) - 58*r - 58*s + 43) + k2**4*(21*K - 14)*(r + s)) + 420*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(-35*f**2*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) - 110*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) + 396*g2*k2**2*(k1**2*(33*r + 33*s - 20) + 21*k2**2*(r + s))))/(1155*d*k3**6) - 4*1j*D1**4*Pk1*Pk3*ct**2*f*k2**2*st**2*(99*b1**2*k1**2*k2**2*(f*(47*r + 47*s - 27) + (28 - 42*K)*(r + s)) + 66*b1*(f**2*k2**2*(4*k1**2*(3*r + 3*s + 1) + 9*k2**2*(5*r + 5*s - 3)) + f*k1**2*(-2*k1**2*(C*(54*r + 54*s - 62) - 29*r - 29*s + 39) + k2**2*(14*C*(15*r + 15*s - 8) + K*(-33*r - 33*s + 6) - 146*r - 146*s + 87)) + 126*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(-3*k1**2*(37*r + 37*s - 25) + 22*k2**2*(5*r + 5*s - 3)) - 22*f*k1**2*(2*k1**2*(32*C*(3*r + 3*s - 2) - 51*r - 51*s + 37) - 9*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 396*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k1*k3**6) + 2*1j*D1**4*Pk1*Pk3*ct**2*f*st**2*(14*b1**2*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(4 - 4*C)) + b1*f*(-k1**2*(4*C - 2)*(29*s - 18) + 3*k2**2*(-8*C*r + 4*C + r + 2*s - 5)) + f**2*(k1**2*(-132*C*s + 80*C + 84*s - 50) + k2**2*(-48*C*r + 40*C + 21*r + 6*s - 21)))/(35*d*k1*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct**2*f*(3*b1**2*(14*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(42*K*(r - 1) + 18*f*(2*r + 7*s - 3) + 7*r*(20*C - 25) + 84*s + 42)) + 6*b1*(5*f**2*k2**2*(6*r + 9*s - 11) + 3*f*(k1**2*(2*C - 1)*(4*s - 9) + k2**2*(14*C*r - 3*K*r + 5*K + 2*r + 9*s - 8)) - 42*g2*k2**2*(r - 1)) + f*(-10*f*k1**2*(2*C*(12*r - 7) - 12*r - 3*s + 8) + 135*f*k2**2*r - k2**2*(18*b2 - 36*g2)*(3*r - 5)))/(105*d*k1*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct**2*f*st**2*(66*b1**2*(k1**2*k2**2*(98*C - 77)*(r + s - 1) + k2**4*(f*(51*r + 51*s - 33) + r*(35 - 14*K) + 21*s)) + 33*b1*(2*f**2*k2**4*(57*r + 78*s - 40) + f*(2*k1**4*(2*C*(73*s - 54) - 84*s + 63) - k1**2*k2**2*(4*C*(32*r + 12*s - 13) - 73*r + 4*s + 37) + 2*k2**4*(84*C*r + K*(3 - 6*r) - 109*r - 31*s + 16)) + 56*g2*k2**4*r) + f*(30*f**2*k2**4*(72*r + 55*s - 51) + 11*f*(6*k1**4*(6*C*(17*s - 10) - 60*s + 35) + k1**2*k2**2*(-4*C*(15*r + 45*s + 43) + 51*r + 54*s + 85) + 54*k2**4*(r*(4*C - 6) - 2*s + 1)) + 396*g2*k2**4*(2*r - 1)))/(1155*d*k1*k3**4) + 2*1j*D1**4*Pk1*Pk3*ct**2*f*(693*b1**3*k1**2*k2**2*(r + s - 1) - 33*b1**2*(k1**4*(56*C - 28)*(r + s - 1) + k1**2*k2**2*(280*C*(r + s - 1) - 14*K*(11*r + 16*s + 6) + 3*f*(58*r + 79*s - 39) - 49*r + 28*s + 266) + 14*k2**4*(f*(9*r + 9*s - 6) + r*(10 - 5*K) + 5*s)) - 33*b1*(5*f**2*(k1**2*k2**2*(29*r + 13*s - 17) + 6*k2**4*(3*r + 3*s - 2)) - 6*f*(k1**4*(8*C*s + r*(22*C - 11) - 6*s + 1) + k1**2*k2**2*(70*C*r + 14*C*s + K*(49*r + 38*s - 42) - 88*r - 43*s + 23) + 7*k2**4*(r*(K - 2) - s)) - 14*k2**2*(b2*k1**2*(r + s) - 2*g2*(k1**2*(11*r + 16*s + 6) + 5*k2**2*r))) + f*(35*f**2*k1**2*k2**2*(34*r + 99*s - 91) + 55*f*k1**2*(k1**2*(12*C*(8*r + 4*s - 5) - 48*r - 30*s + 32) + 9*k2**2*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) - 198*k2**2*(b2*k1**2*(-5*r - 5*s + 6) + 2*g2*(k1**2*(49*r + 38*s - 42) + 7*k2**2*r))))/(1155*d*k1*k3**4) + 8*1j*D1**4*Pk1*Pk3*ct*f**2*k2**3*st**4*(-165*b1**2*k2**2*(2*r + 2*s - 1) + 33*b1*(f*k2**2*(8*r + 8*s - 5) + k1**2*(22*C - 14)*(2*r + 2*s - 1)) + 2*f*(f*k2**2*(112*r + 112*s - 73) + 11*k1**2*(C*(24*r + 24*s - 13) - 15*r - 15*s + 8)))/(385*d*k3**6) - 4*1j*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(3*b1*k1**2*(10*C - 7)*(2*s - 1) + 9*b1*k2**2*r + f*k1**2*(2*C*(12*s - 5) - 18*s + 7) + f*k2**2*(3*r - 2))/(35*d*k1**2*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(33*b1*(5*f*k2**4*r + k1**4*(36*C - 22)*(2*s - 1) + 2*k1**2*k2**2*(-12*C*(4*r + 2*s - 1) + 39*r + 20*s - 10)) + f*(5*f*k2**4*(25*r + 2) + 22*k1**4*(6*C*(8*s - 3) - 30*s + 11) - 22*k1**2*k2**2*(4*C*(12*r + 6*s - 5) - 39*r - 18*s + 16)))/(385*d*k1**2*k3**4) + 8*1j*D1**4*Pk1*Pk3*ct*f*k1**2*k2*(3*b1**2*(3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(3*r + 3*s - 2)) + (r + s)*(-7*k1**2*(10*K - 2) - 7*k2**2*(15*K - 5))) + b1*(5*f**2*(k1**2*(6*r + 6*s - 4) + 9*k2**2*(2*r + 2*s - 1)) - 9*f*(k1**2*(14*C*(r + s - 1) + 10*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(21*K - 7)*(r + s)) + 210*g2*(2*k1**2 + 3*k2**2)*(r + s)) + f*(-35*f**2*k2**2*(r + s - 1) + f*k1**2*(45 - 90*C)*(r + s - 1) + 180*g2*k1**2*(2*r + 2*s - 1) + 378*g2*k2**2*(r + s)))/(105*d*k3**6) + 2*1j*D1**4*Pk1*Pk3*ct*f*k2*(42*b1**3*(2*k1**2 + 5*k2**2)*(r + s - 1) - 3*b1**2*(k1**2*(140*C*(r + s - 1) - 42*K*(7*r + 7*s + 2) + 9*f*(7*r + 14*s - 8) + 14*r + 56*s + 98) + 7*k2**2*(6*f*(2*r + 2*s - 1) - 5*r*(6*K - 5) - 5*s*(2*K - 2))) - b1*(-42*b2*(6*k1**2 + 5*k2**2)*(r + s) + 5*f**2*(k1**2*(45*r + 48*s - 40) + 18*k2**2*(3*r + 3*s - 2)) - 9*f*(k1**2*(28*C*r + 2*K*(57*r + 45*s - 32) - 53*r - 38*s + 16) + 7*k2**2*(r*(6*K - 5) + s*(2*K - 2))) + 84*g2*(3*k1**2*(7*r + 7*s + 2) + 5*k2**2*(3*r + s))) + f*(18*b2*(6*k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s)) + 70*f**2*k1**2*(s - 1) + 45*f*k1**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2) - 36*g2*(k1**2*(57*r + 45*s - 32) + 7*k2**2*(3*r + s))))/(105*d*k3**4) - 8*1j*D1**4*Pk1*Pk3*ct*f*k2*st**2*(33*b1**2*k2**2*(f*k1**2*(24*r + 24*s - 19) - 21*f*k2**2*(2*r + 2*s - 1) + k1**2*(21 - 63*K)*(r + s)) + 33*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 5) + 9*k2**2*(4*r + 4*s - 3)) + f*k1**2*(2*k1**2*(C*(-3*r - 3*s + 19) + r + s - 11) + k2**2*(14*C*(12*r + 12*s - 7) + K*(-33*r - 33*s + 6) - 94*r - 94*s + 61)) + 126*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k2**2*(k1**2*(-3*r - 3*s + 5) + 33*k2**2*(3*r + 3*s - 2)) - 22*f*k1**4*(C*(3*r + 3*s - 11) + 6) + 99*f*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) + 198*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**6) - 2*1j*D1**4*Pk1*Pk3*ct*f*st**2*(1386*b1**3*k2**4*(r + s - 1) - 33*b1**2*(k1**2*k2**2*(140*C - 84)*(r + s - 1) + k2**4*(f*(-31*r - 52*s + 36) + r*(91 - 112*K) - s*(56*K - 56))) - 33*b1*(6*f**2*k2**4*(7*r + 19*s - 8) + f*(k1**4*(4*C - 2)*(11*s - 9) + k1**2*k2**2*(136*C*r + 44*C*(s + 1) - 71*r - 30*s - 40) + k2**4*(84*C*(5*r + 2*s - 1) - 4*K*(11*r + 5*s - 2) - 291*r - 106*s + 58)) - 14*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + f*(-15*f**2*k2**4*(105*r + 132*s - 106) - 11*f*(k1**4*(12*C - 6)*(9*s - 5) + k1**2*k2**2*(4*C*(75*r + 12*s - 32) - 159*r - 54*s + 44) + 18*k2**4*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) + 66*k2**4*(b2*(11*r + 11*s - 2) - 4*g2*(11*r + 5*s - 2))))/(1155*d*k2*k3**4) + 2*1j*D1**4*Pk1*Pk3*ct*f*k2*(-105*b1**3*k1**2*(r + 2*s - 2) + 3*b1**2*(k1**2*(14*K*(3*r - 3*s - 8) + 12*f*(7*s - 1) + 7*r*(20*C - 15) + 70*s + 56) + 35*k2**2*r) + b1*(5*f**2*k1**2*(21*r + 54*s - 46) + 9*f*(2*k1**2*(14*C*r + K*(-13*r - 7*s + 10) + r + 11*s - 4) + 7*k2**2*r) - 42*k1**2*(5*b2*(r + s) + 2*g2*(3*r - 3*s - 8))) + 9*f*k1**2*(-2*b2*(13*r + 7*s - 10) + 5*f*r + 4*g2*(13*r + 7*s - 10)))/(105*d*k1**2*k3**2) + 2*1j*D1**4*Pk1*Pk3*ct*f*st**2*(3*b1**2*(k1**4*(84*C - 42)*(s - 1) - 7*k1**2*k2**2*(4*C*(3*r + s - 1) - 9*r - 4*s + 4) + k2**4*r*(30*f - 7)) + 3*b1*f*k2**2*(k1**2*(C*(-80*r + 4*s - 4) + 40*r + 2*s + 4) + k2**2*(f*(30*r - 4) + 41*r + 4)) + f**2*(-k1**4*(12*C - 6)*(9*s - 5) + k1**2*k2**2*(C*(120 - 252*r) + 123*r + 18*s - 44) + 54*k2**4*r))/(105*d*k1**2*k2*k3**2) + 8*1j*D1**4*Pk1*Pk3*f**3*k2**6*st**6*(11*b1*(3*r + 3*s - 2) + 3*f*(4*r + 4*s - 3))/(231*d*k1*k3**6) - 4*1j*D1**4*Pk1*Pk3*f**2*k2**2*st**4*(264*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 11*b1*(-2*f*k1**2*k2**2 - 3*f*k2**4*(5*r + 5*s - 3) + k1**4*(36*C - 18)*(2*r + 2*s - 1)) + f*(-2*f*k1**2*k2**2*(54*r + 54*s - 35) + 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(66 - 132*C)*(2*r + 2*s - 1)))/(385*d*k1*k3**6) - 2*1j*D1**4*Pk1*Pk3*f**2*st**4*(12*b1*k1**2*(2*C - 1)*(2*s - 1) + 3*b1*k2**2*(4*r + 2*s - 1) + f*k1**2*(8*C - 4)*(3*s - 1) + f*k2**2*(4*C*(3*r - 1) - 1))/(35*d*k1*k3**2) + 2*1j*D1**4*Pk1*Pk3*f**2*st**4*(66*b1**2*k2**4*(4*r + 4*s - 3) + 11*b1*(f*k2**4*(24*r + 27*s - 17) + k1**4*(24*C - 12)*(2*s - 1) - 3*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9)) + f*(f*k2**4*(108*r + 55*s - 27) + k1**4*(88*C - 44)*(3*s - 1) - 33*k1**2*k2**2*(4*C*(3*r + 2*s - 1) - 8*r - 4*s + 3)))/(385*d*k1*k3**4) + 4*1j*D1**4*Pk1*Pk3*f*k1**3*(15*b1*f**2*k2**2*(r + s - 1) - 14*b1*(2*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 3*f*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))))/(35*d*k3**6) + 2*1j*D1**4*Pk1*Pk3*f*k1*(35*b1**3*k2**2*(r + s - 1) + 7*b1**2*(2*K*(k1**2*(7*r + 7*s + 2) + 5*k2**2*(2*r + s)) - 3*f*k1**2*(s - 1) - 2*k1**2*s - 5*k2**2*r) + b1*(14*b2*(2*k1**2 + 5*k2**2)*(r + s) - 15*f**2*(k1**2*(s - 1) + k2**2*(r + s - 1)) + 3*f*(6*K*k1**2*(6*r + 5*s - 3) + 14*K*k2**2*(2*r + s) - 4*k1**2*s - 7*k2**2*r) - 28*g2*(k1**2*(7*r + 7*s + 2) + 5*k2**2*(2*r + s))) + 6*f*(b2*k1**2*(4*r + 4*s - 2) + 7*b2*k2**2*(r + s) - 6*g2*k1**2*(6*r + 5*s - 3) - 14*g2*k2**2*(2*r + s)))/(35*d*k3**4) - 4*1j*D1**4*Pk1*Pk3*f*k1*st**2*(-33*b1**2*k2**2*(42*K*k1**2*(r + s) - 2*f*k1**2*(3*r + 3*s - 5) + 7*f*k2**2*(9*r + 9*s - 5)) + 66*b1*(-f**2*k2**2*(k1**2*(-3*r - 3*s + 1) + 3*k2**2) + f*k1**2*(k1**2*(2*C - 1)*(r + s + 3) + k2**2*(14*C*(3*r + 3*s - 2) + K*(-11*r - 11*s + 2) - 21*r - 21*s + 14)) + 42*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(9*r + 9*s - 7)) + f*k1**2*(44*C - 22)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) + 132*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**6) + 2*1j*D1**4*Pk1*Pk3*f*st**2*(-3*b1**2*(7*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(f*(-24*r - 42*s + 22) + 14*r + 7*s)) + 3*b1*f*(k1**2*(4*C - 2)*(s - 4) + k2**2*(-12*K*r + 6*K + 2*f*(12*r + 9*s - 7) + 9*r + s + 6)) + f*(f*k1**2*(C*(20 - 60*r) + 30*r + 3*s - 5) + 27*f*k2**2*r - k2**2*(18*b2 - 36*g2)*(2*r - 1)))/(105*d*k1*k3**2) - 2*1j*D1**4*Pk1*Pk3*f*(35*b1**3*k1**2*(s - 1) + 7*b1**2*(2*K*k1**2*(3*s + 5) - 5*k2**2*r) + b1*(-15*f**2*k1**2*(s - 1) + 3*f*(2*K*k1**2*(10*r + 7*s - 5) - 4*k1**2*s - 7*k2**2*r) + 14*k1**2*(5*b2*(r + s) - 2*g2*(3*s + 5))) + 6*f*k1**2*(b2 - 2*g2)*(10*r + 7*s - 5))/(35*d*k1*k3**2) - 2*1j*D1**4*Pk1*Pk3*f*st**2*(924*b1**3*k1**2*k2**2*(r + s - 1) - 33*b1**2*(-14*f*k2**4*(3*r + 3*s - 2) + k1**4*(28*C - 14)*(r + s - 1) + k1**2*k2**2*(-84*K*r - 56*K*s + f*(-46*r - 67*s + 43) + 14*r + 7*s)) + 33*b1*(2*f**2*k2**2*(k1**2*(8*r - 2*s - 2) + 3*k2**2*(3*r + 3*s - 2)) + f*k1**2*(k1**2*(-4*C*(8*r + s + 7) + 16*r + 3*s + 17) + k2**2*(-28*C*(6*r + 3*s - 2) + K*(32*r + 20*s - 2) + 93*r + 43*s - 22)) + 14*k1**2*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) + f*k1**2*(-5*f**2*k2**2*(46*r + 99*s - 83) - 11*f*(k1**2*(12*C*(7*r + 2*s - 1) - 42*r - 15*s + 1) + 9*k2**2*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) + 66*k2**2*(b2*(11*r + 11*s - 2) - 2*g2*(16*r + 10*s - 1))))/(1155*d*k1*k3**4) - 6*1j*D1**4*Pk1*Pkd3*b1*ct**4*f*k2**2*(7*b1 + 3*f)*(r + s - 1)/(35*d*k1*k3) + 2*1j*D1**4*Pk1*Pkd3*b1*ct**3*f*k2*(r + s - 1)*(18*C*f + 7*b1*(6*C - 1) + 3*f)/(35*d*k3) - 2*1j*D1**4*Pk1*Pkd3*b1*ct**2*f*k2**2*st**2*(21*b1 + 11*f)*(r + s - 1)/(35*d*k1*k3) - 1j*D1**4*Pk1*Pkd3*b1*ct**2*f*(r + s - 1)*(7*b1**2*k2**2 + 28*b1*k1**2*(2*C - 1) - b1*k2**2*(3*f + 98) + f*k1**2*(48*C - 24) - 42*f*k2**2)/(35*d*k1*k3) + 4*1j*D1**4*Pk1*Pkd3*b1*ct*f*k2*st**2*(7*b1*(3*C - 2) + f*(11*C - 5))*(r + s - 1)/(35*d*k3) + 2*1j*D1**4*Pk1*Pkd3*b1*ct*f*k2*(r + s - 1)*(-42*C*f + 14*b1**2 + b1*(-70*C - 14*K + 12*f + 49) - 14*b2 + 21*f + 28*g2)/(35*d*k3) - 2*1j*D1**4*Pk1*Pkd3*b1*f*st**2*(r + s - 1)*(7*b1**2*k2**2 + 6*b1*f*k2**2 + b1*k1**2*(7 - 14*C) + f*k1**2*(2*C - 1))/(35*d*k1*k3) + 1j*D1**4*Pk1*Pkd3*b1*f*(r + s - 1)*(-4*K*b1*k1**2 + b1*k2**2*(5*b1 + 3*f) - 4*b2*k1**2 + 8*g2*k1**2)/(5*d*k1*k3) - 4*1j*D1**4*Pk1*Pkd3*ct**7*f**2*k2**5*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 5))/(21*d*k3**5) - 2*1j*D1**4*Pk1*Pkd3*ct**6*f**2*k2**4*(9*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 5))/(21*d*k1*k3**3) - 1j*D1**4*Pk1*Pkd3*ct**6*f**2*k2**4*(11*b1*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(58*r + 58*s - 36) - 48*r - 48*s + 31)) + 5*f*(21*f*k2**2*(13*r + 13*s - 7) + 22*k1**2*(66*C*r + 66*C*s - 32*C - 54*r - 54*s + 27)))/(1155*d*k1*k3**5) - 8*1j*D1**4*Pk1*Pkd3*ct**5*f**2*k2**5*st**2*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(48*r + 48*s - 23))/(105*d*k3**5) + 2*1j*D1**4*Pk1*Pkd3*ct**5*f*k2**3*(-126*b1**2*(C - 1)*(r + s - 1) + 9*b1*f*(2*C*(7*r + 7*s - 2) - 13*r - 13*s + 7) + 5*f**2*(2*C*(12*r + 12*s - 5) - 21*r - 21*s + 11))/(105*d*k3**3) + 2*1j*D1**4*Pk1*Pkd3*ct**5*f*k2**3*(99*b1**2*k2**2*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(5*f**2*k2**2*(6*r + 6*s - 5) + 3*f*(k1**2*(C*(46*r + 46*s - 44) - 27*r - 27*s + 31) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16)) - 42*g2*k2**2*(r + s)) + f*(-70*f**2*k2**2*(17*r + 17*s - 10) - 55*f*k1**2*(14*C*(3*r + 3*s - 2) - 21*r - 21*s + 17) + f*k2**2*(990*C - 990)*(2*r + 2*s - 1) + 198*g2*k2**2*(3*r + 3*s + 2)))/(1155*d*k3**5) - 4*1j*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(45*b1*(2*r + 2*s - 1) + f*(48*r + 48*s - 23))/(105*d*k1*k3**3) - 2*1j*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(33*b1*(5*f*k2**2*(12*r + 12*s - 7) + 6*k1**2*(C*(55*r + 55*s - 31) - 45*r - 45*s + 26)) + f*(75*f*k2**2*(17*r + 17*s - 10) + 22*k1**2*(C*(273*r + 273*s - 137) - 225*r - 225*s + 114)))/(1155*d*k1*k3**5) + 2*1j*D1**4*Pk1*Pkd3*ct**4*f*k2**2*(-3*b1**2*(k1**2*(56*C - 35)*(r + s - 1) + 3*k2**2*(f*(13*r + 13*s - 8) + 7*r + 7*s)) + b1*f*(9*k1**2*(2*C*(7*r + 7*s - 6) - 3*r - 3*s + 8) + k2**2*(-5*f*(15*r + 15*s - 8) + 99*r + 99*s - 81)) + 15*f**2*(k1**2*(C*(6*r + 6*s - 4) + 1) + 3*k2**2*(2*r + 2*s - 1)))/(105*d*k1*k3**3) + 1j*D1**4*Pk1*Pkd3*ct**4*f*k2**2*(33*b1**2*k1**2*k2**2*(f*(93*r + 93*s - 57) + (28 - 70*K)*(r + s)) + 11*b1*(5*f**2*k2**2*(k1**2*(24*r + 24*s + 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(2*C*(5*r + 5*s + 8) - 14*r - 14*s - 7) - k2**2*(-14*C*(7*r + 7*s - 4) + K*(r + s + 10) + 86*r + 86*s - 57)) + 420*g2*k1**2*k2**2*(r + s)) + f*(35*f**2*k2**2*(k1**2*(-3*r - 3*s + 5) + 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(C*(30*r + 30*s - 8) - 30*r - 30*s + 11) + 9*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) + 396*g2*k1**2*k2**2*(r + s + 10)))/(1155*d*k1*k3**5) - 4*1j*D1**4*Pk1*Pkd3*ct**3*f**2*k2**5*st**4*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 7))/(35*d*k3**5) + 2*1j*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(-126*b1**2*(C - 1)*(r + s - 1) + 3*b1*f*(C*(98*r + 98*s - 38) - 83*r - 83*s + 41) + f**2*(4*C*(48*r + 48*s - 23) - 177*r - 177*s + 91))/(105*d*k3**3) + 2*1j*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(99*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(2*f**2*k2**2*(27*r + 27*s - 20) + f*k1**2*(C*(310*r + 310*s - 218) - 205*r - 205*s + 155) + f*k2**2*(-42*C*(2*r + 2*s - 1) + K*(11*r + 11*s - 2) + 73*r + 73*s - 40) - 42*g2*k2**2*(r + s)) + f*(-10*f**2*k2**2*(197*r + 197*s - 123) - 11*f*k1**2*(C*(534*r + 534*s - 290) - 357*r - 357*s + 199) + f*k2**2*(594*C - 594)*(2*r + 2*s - 1) + 66*g2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**5) + 2*1j*D1**4*Pk1*Pkd3*ct**3*f*k2*(63*b1**3*k2**2*(r + s - 1) + 3*b1**2*(k1**2*(14*C - 21)*(r + s - 1) + k2**2*(70*C*(r + s - 1) + 7*K*(5*r + 5*s - 2) + f*(6*r + 6*s - 9) - 77*r - 77*s + 84)) + 3*b1*(5*f**2*k2**2*(r + s - 2) + f*(k1**2*(24 - 36*C) + 3*k2**2*(-14*C*r - 14*C*s + K*(3*r + 3*s + 2) + 26*r + 26*s - 13)) + 7*k2**2*(3*b2*(r + s) - 2*g2*(5*r + 5*s - 2))) + f*(-5*f*(k1**2*(6*C*(3*r + 3*s - 1) - 15*r - 15*s + 7) + 9*k2**2*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3)) + k2**2*(9*b2 - 18*g2)*(3*r + 3*s + 2)))/(105*d*k3**3) - 2*1j*D1**4*Pk1*Pkd3*ct**3*f*k2*(33*b1**2*k2**2*(3*f*(k1**2*(3*r + 3*s + 2) + 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(5*K - 7) - 7*k2**2*(5*K - 5))) - 11*b1*(5*f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 9*k2**2*(4*r + 4*s - 3)) + 9*f*(k1**4*(C*(26*r + 26*s - 6) - 17*r - 17*s + 5) + k1**2*k2**2*(42*C*(3*r + 3*s - 2) + 19*K*r + 19*K*s - 20*K - 108*r - 108*s + 75) + k2**4*(7*K - 7)*(r + s)) - 210*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(-35*f**2*(k1**2*k2**2*(21*r + 21*s - 13) + 22*k2**4*(3*r + 3*s - 2)) - 55*f*(k1**4*(C*(42*r + 42*s - 22) - 27*r - 27*s + 15) + 9*k1**2*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*g2*k2**2*(k1**2*(19*r + 19*s - 20) + 7*k2**2*(r + s))))/(1155*d*k3**5) - 2*1j*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(15*b1*(2*r + 2*s - 1) + f*(12*r + 12*s - 7))/(35*d*k1*k3**3) - 1j*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(33*b1*(5*f*k2**2*(5*r + 5*s - 3) + k1**2*(52*C - 42)*(2*r + 2*s - 1)) + f*(15*f*k2**2*(29*r + 29*s - 19) + 22*k1**2*(C*(60*r + 60*s - 34) - 48*r - 48*s + 27)))/(385*d*k1*k3**5) - 1j*D1**4*Pk1*Pkd3*ct**2*f*k1*(33*b1**2*k2**2*(3*f*(k1**2*(25*r + 25*s - 9) + 7*k2**2*(9*r + 9*s - 5)) + (r + s)*(-14*k1**2*(15*K - 8) - 14*k2**2*(15*K - 10))) + 33*b1*(5*f**2*k2**2*(k1**2*(9*r + 9*s - 5) + 6*k2**2) - 6*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(5*r + 5*s - 4) + K*(33*r + 33*s - 20) - 58*r - 58*s + 43) + k2**4*(21*K - 14)*(r + s)) + 420*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(-35*f**2*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) - 110*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) + 396*g2*k2**2*(k1**2*(33*r + 33*s - 20) + 21*k2**2*(r + s))))/(1155*d*k3**5) - 2*1j*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(b1**2*(k1**2*(98*C - 77)*(r + s - 1) + 3*k2**2*(f*(17*r + 17*s - 11) + 7*r + 7*s)) + b1*f*(k1**2*(-24*C*(2*r + 2*s - 1) + 19*r + 19*s - 15) + k2**2*(f*(33*r + 33*s - 23) - 31*r - 31*s + 19)) - 3*f**2*(2*k1**2*(C*(9*r + 9*s - 5) - 5*r - 5*s + 3) + 3*k2**2*(2*r + 2*s - 1)))/(35*d*k1*k3**3) + 1j*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(99*b1**2*k1**2*k2**2*(f*(47*r + 47*s - 27) + (28 - 42*K)*(r + s)) + 66*b1*(f**2*k2**2*(4*k1**2*(3*r + 3*s + 1) + 9*k2**2*(5*r + 5*s - 3)) + f*k1**2*(-2*k1**2*(C*(54*r + 54*s - 62) - 29*r - 29*s + 39) + k2**2*(14*C*(15*r + 15*s - 8) + K*(-33*r - 33*s + 6) - 146*r - 146*s + 87)) + 126*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(-3*k1**2*(37*r + 37*s - 25) + 22*k2**2*(5*r + 5*s - 3)) - 22*f*k1**2*(2*k1**2*(32*C*(3*r + 3*s - 2) - 51*r - 51*s + 37) - 9*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 396*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k1*k3**5) + 1j*D1**4*Pk1*Pkd3*ct**2*f*(-63*b1**3*k1**2*k2**2*(r + s - 1) + 6*b1**2*(k1**4*(28*C - 14)*(r + s - 1) + k1**2*k2**2*(140*C*(r + s - 1) + 7*K*(5*r + 5*s - 6) + 6*f*(4*r + 4*s - 1) - 91*r - 91*s + 133) + 7*k2**4*(f*(9*r + 9*s - 6) + 5*r + 5*s)) + 3*b1*(5*f**2*(k1**2*k2**2*(13*r + 13*s - 9) + 6*k2**4*(3*r + 3*s - 2)) - 6*f*(k1**4*(4*C - 2) + k1**2*k2**2*(14*C*r + 14*C*s + K*(5*r + 5*s - 6) - 19*r - 19*s + 6) - 7*k2**4*(r + s)) - 14*k1**2*k2**2*(b2*(r + s) + 2*g2*(5*r + 5*s - 6))) - 2*f*k1**2*(5*f*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + k2**2*(9*b2 - 18*g2)*(5*r + 5*s - 6)))/(105*d*k1*k3**3) + 4*1j*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(3*b1*(5*C - 4)*(2*r + 2*s - 1) + f*(C*(12*r + 12*s - 7) - 9*r - 9*s + 5))/(35*d*k3**3) + 2*1j*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(165*b1**2*k2**2*(2*r + 2*s - 1) - 33*b1*(f*k2**2*(8*r + 8*s - 5) + k1**2*(22*C - 14)*(2*r + 2*s - 1)) - 2*f*(f*k2**2*(112*r + 112*s - 73) + 11*k1**2*(C*(24*r + 24*s - 13) - 15*r - 15*s + 8)))/(385*d*k3**5) - 2*1j*D1**4*Pk1*Pkd3*ct*f*k1**2*k2*(3*b1**2*(3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(3*r + 3*s - 2)) + (r + s)*(-7*k1**2*(10*K - 2) - 7*k2**2*(15*K - 5))) + b1*(5*f**2*(k1**2*(6*r + 6*s - 4) + 9*k2**2*(2*r + 2*s - 1)) - 9*f*(k1**2*(14*C*(r + s - 1) + 10*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(21*K - 7)*(r + s)) + 210*g2*(2*k1**2 + 3*k2**2)*(r + s)) + f*(-35*f**2*k2**2*(r + s - 1) + f*k1**2*(45 - 90*C)*(r + s - 1) + 180*g2*k1**2*(2*r + 2*s - 1) + 378*g2*k2**2*(r + s)))/(105*d*k3**5) + 2*1j*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(63*b1**3*k2**2*(r + s - 1) - 3*b1**2*(k1**2*(70*C - 42)*(r + s - 1) + k2**2*(f*(16*r + 16*s - 3) + (21 - 21*K)*(r + s))) - 3*b1*(3*f**2*k2**2*(7*r + 7*s - 4) + f*k1**2*(8*C*(r + s + 1) - 4*r - 4*s - 8) + f*k2**2*(42*C*(2*r + 2*s - 1) + K*(-11*r - 11*s + 2) - 52*r - 52*s + 33) + k2**2*(-21*b2 + 42*g2)*(r + s)) + f*(2*f*k1**2*(9*C*(r + s - 1) - 3*r - 3*s + 5) - 9*f*k2**2*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5) + k2**2*(3*b2 - 6*g2)*(11*r + 11*s - 2)))/(105*d*k3**3) - 2*1j*D1**4*Pk1*Pkd3*ct*f*k2*(21*b1**3*(2*k1**2 + 5*k2**2)*(r + s - 1) - 3*b1**2*(k1**2*(70*C*(r + s - 1) - 42*K + 6*f - 35*r - 35*s + 49) + 7*k2**2*(f*(6*r + 6*s - 3) + (5 - 5*K)*(r + s))) + b1*(21*b2*(6*k1**2 + 5*k2**2)*(r + s) - 5*f**2*(2*k1**2 + 9*k2**2)*(3*r + 3*s - 2) + 18*f*k1**2*(3*K - 1)*(2*r + 2*s - 1) + 63*f*k2**2*(K - 1)*(r + s) - 42*g2*(6*k1**2 + 5*k2**2*(r + s))) + 9*f*(b2*(6*k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s)) + f*k1**2*(10*C - 5)*(r + s - 1) - 2*g2*(6*k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s))))/(105*d*k3**3) + 2*1j*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(33*b1**2*k2**2*(f*k1**2*(24*r + 24*s - 19) - 21*f*k2**2*(2*r + 2*s - 1) + k1**2*(21 - 63*K)*(r + s)) + 33*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 5) + 9*k2**2*(4*r + 4*s - 3)) + f*k1**2*(2*k1**2*(C*(-3*r - 3*s + 19) + r + s - 11) + k2**2*(14*C*(12*r + 12*s - 7) + K*(-33*r - 33*s + 6) - 94*r - 94*s + 61)) + 126*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k2**2*(k1**2*(-3*r - 3*s + 5) + 33*k2**2*(3*r + 3*s - 2)) - 22*f*k1**4*(C*(3*r + 3*s - 11) + 6) + 99*f*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) + 198*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**5) - 2*1j*D1**4*Pk1*Pkd3*f**3*k2**6*st**6*(11*b1*(3*r + 3*s - 2) + 3*f*(4*r + 4*s - 3))/(231*d*k1*k3**5) - 2*1j*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(3*b1**2*k2**2*(4*r + 4*s - 3) + b1*f*k2**2*(6*r + 6*s - 5) - 9*b1*k1**2*(2*C - 1)*(2*r + 2*s - 1) - f*k1**2*(6*C - 3)*(2*r + 2*s - 1))/(35*d*k1*k3**3) + 1j*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(264*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 11*b1*(-2*f*k1**2*k2**2 - 3*f*k2**4*(5*r + 5*s - 3) + k1**4*(36*C - 18)*(2*r + 2*s - 1)) + f*(-2*f*k1**2*k2**2*(54*r + 54*s - 35) + 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(66 - 132*C)*(2*r + 2*s - 1)))/(385*d*k1*k3**5) - 1j*D1**4*Pk1*Pkd3*f*k1**3*(15*b1*f**2*k2**2*(r + s - 1) - 14*b1*(2*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 3*f*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))))/(35*d*k3**5) + 1j*D1**4*Pk1*Pkd3*f*k1*(-14*K*b1**2*(2*k1**2 + 5*k2**2*(r + s)) - 35*b1**3*k2**2*(r + s - 1) + b1*(3*f*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 5*f*k2**2*(r + s - 1)) + 28*g2*(2*k1**2 + 5*k2**2*(r + s))) - 2*b2*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))) + 12*f*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))/(35*d*k3**3) + 1j*D1**4*Pk1*Pkd3*f*k1*st**2*(-33*b1**2*k2**2*(42*K*k1**2*(r + s) - 2*f*k1**2*(3*r + 3*s - 5) + 7*f*k2**2*(9*r + 9*s - 5)) + 66*b1*(-f**2*k2**2*(k1**2*(-3*r - 3*s + 1) + 3*k2**2) + f*k1**2*(k1**2*(2*C - 1)*(r + s + 3) + k2**2*(14*C*(3*r + 3*s - 2) + K*(-11*r - 11*s + 2) - 21*r - 21*s + 14)) + 42*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(9*r + 9*s - 7)) + f*k1**2*(44*C - 22)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) + 132*g2*k1**2*k2**2*(11*r + 11*s - 2)))/(1155*d*k3**5) + 2*1j*D1**4*Pk1*Pkd3*f*st**2*(42*b1**3*k1**2*k2**2*(r + s - 1) + 3*b1**2*(7*f*k2**4*(3*r + 3*s - 2) + k1**4*(7 - 14*C)*(r + s - 1) + k1**2*k2**2*(21*K*(r + s) + 2*f*(r + s - 2))) - 3*b1*(f**2*k2**2*(2*k1**2*(r + s) + k2**2*(-9*r - 9*s + 6)) + f*k1**2*(k1**2*(8*C - 4) + k2**2*(14*C*(3*r + 3*s - 2) + K*(-11*r - 11*s + 2) - 21*r - 21*s + 14)) + k1**2*k2**2*(-21*b2 + 42*g2)*(r + s)) + f*k1**2*(-f*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) + k2**2*(3*b2 - 6*g2)*(11*r + 11*s - 2)))/(105*d*k1*k3**3) + 4*1j*D1**4*Pk3*Pkd1*b1**2*ct*f*k2*(7*b1*r + f*(6*r - 3) + 7*r - 7)/(35*d*k1) + 4*1j*D1**4*Pk3*Pkd1*b1*ct**3*f*k2*(7*b1*r + f*(6*r - 3))/(35*d*k1) - 4*1j*D1**4*Pk3*Pkd1*b1*ct**2*f*(2*C - 1)*(7*b1*r + f*(6*r - 3))/(35*d) - 2*1j*D1**4*Pk3*Pkd1*b1*ct*f*k2*st**2*(7*b1*r - f*(r - 4))/(35*d*k1) + 2*1j*D1**4*Pk3*Pkd1*b1*f*st**2*(2*C - 1)*(7*b1*r - f*(r - 4))/(35*d) - 4*1j*D1**4*Pk3*Pkd1*b1*f*(r - 1)*(K*b1 + b2 - 2*g2)/(5*d) + 8*1j*D1**4*Pk3*Pkd1*ct**6*f**2*k2**4*(C - 1)*(18*b1*r + 5*f*(3*r - 1))/(105*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**5*f**2*k2**3*(18*b1*r + 5*f*(3*r - 1))/(105*d*k1*k3**2) + 4*1j*D1**4*Pk3*Pkd1*ct**5*f**2*k2**3*(198*b1*k1**2*r*(8*C - 7) + 35*f**2*k2**2*(4*r - 1) + 55*f*(3*b1*k2**2*r + k1**2*(8*C - 7)*(3*r - 1)))/(1155*d*k1*k3**4) + 8*1j*D1**4*Pk3*Pkd1*ct**4*f**2*k2**4*st**2*(C - 1)*(3*b1*r + f*(3*r - 4))/(35*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**4*f*k2**2*(42*b1**2*r*(C - 1) - 18*b1*f*(C - r - 1) - f**2*(10*C - 15)*(3*r - 1))/(105*d*k3**2) + 4*1j*D1**4*Pk3*Pkd1*ct**4*f*k2**2*(231*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 105*f**3*k2**2*(4*r - 1) + 55*f**2*(b1*k2**2*(6*r + 1) + k1**2*(12*C - 9)*(3*r - 1)) - 99*f*(2*b1**2*k2**2*r + 6*b1*k1**2*r*(3 - 4*C) + b1*k2**2*(-2*K*r + K + 2*r - 1) + 2*g2*k2**2*(2*r - 1)))/(1155*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(3*b1*r + f*(3*r - 4))/(35*d*k1*k3**2) + 4*1j*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(99*b1*k1**2*r*(6*C - 5) + 25*f**2*k2**2*(5*r - 4) + 33*f*(5*b1*k2**2*r + k1**2*(6*C - 5)*(3*r - 4)))/(1155*d*k1*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**3*f*k1*k2*(231*b1*k2**2*r*(b1*(4*K - 3) - 8*g2) + 105*f**3*k2**2*(4*r - 1) + 55*f**2*(3*b1*k2**2 + k1**2*(8*C - 5)*(3*r - 1)) - 99*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(5 - 8*C) + b1*k2**2*(K*(4 - 8*r) + 6*r - 3) + 8*g2*k2**2*(2*r - 1)))/(1155*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**3*f*k2*(3*b1**2*r*(k1**2*(28*C - 21) + k2**2*(12*f + 7)) + b1*f*(k1**2*(27 - 36*C) + k2**2*(30*f*r - 10*f + 18*r - 9)) - f**2*k1**2*(20*C - 15)*(3*r - 1))/(105*d*k1*k3**2) - 8*1j*D1**4*Pk3*Pkd1*ct**2*f**2*k2**4*st**4*(C - 1)*(3*b1*r + f)/(35*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**2*f*k1**2*(693*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 35*f**3*k2**2*(4*r - 1) + 55*f**2*(3*b1*k2**2*(1 - 2*r) + k1**2*(2*C - 1)*(3*r - 1)) - 99*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(1 - 2*C) - 3*b1*k2**2*(2*K - 1)*(2*r - 1) + 12*g2*k2**2*(2*r - 1)))/(1155*d*k3**4) - 4*1j*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(C - 1)*(7*b1**2*r + b1*f*(5*r + 4) + 2*f**2*(3*r - 4))/(35*d*k3**2) + 2*1j*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(-231*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 90*f**3*k2**2*(5*r - 4) + 22*f**2*(6*b1*k2**2*(3*r + 2) + k1**2*(19*C - 13)*(3*r - 4)) - 33*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(13 - 19*C) - b1*k2**2*(K - 1)*(r - 4) + 2*g2*k2**2*(r - 4)))/(1155*d*k3**4) + 4*1j*D1**4*Pk3*Pkd1*ct**2*f*(-21*b1**3*k2**2*r + 3*b1**2*(k1**2*r*(14*C - 7) + k2**2*(-7*K + 12*f*r + 3*f + 7*r + 7)) + 3*b1*(5*f**2*k2**2*(3*r - 1) + 3*f*(k1**2*(1 - 2*C) + k2**2*(-2*K*r + K + 4*r - 2)) + 7*k2**2*(-b2*r + 2*g2)) + f*(-f*k1**2*(10*C - 5)*(3*r - 1) + k2**2*(-9*b2 + 18*g2)*(2*r - 1)))/(105*d*k3**2) - 4*1j*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(3*b1*r + f)/(35*d*k1*k3**2) + 4*1j*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(33*b1*k1**2*r*(3 - 4*C) + 5*f**2*k2**2*(r - 3) + f*k1**2*(33 - 44*C))/(385*d*k1*k3**4) - 4*1j*D1**4*Pk3*Pkd1*ct*f*k1**3*k2*(3*b1**2*r*(-28*K + 6*f + 7) + b1*(5*f**2*(3*r - 1) - 9*f*(4*K - 1)*(2*r - 1) + 168*g2*r) + 72*f*g2*(2*r - 1))/(105*d*k3**4) - 4*1j*D1**4*Pk3*Pkd1*ct*f*k1*k2*(21*b1**3*r - 3*b1**2*(-14*K + 3*f + 7) + b1*(42*b2*r + f**2*(5 - 15*r) + 9*f*(2*K - 1)*(2*r - 1) - 84*g2) + 18*f*(b2 - 2*g2)*(2*r - 1))/(105*d*k3**2) + 2*1j*D1**4*Pk3*Pkd1*ct*f*k1*k2*st**2*(231*b1*k2**2*r*(-2*K*b1 + b1 + 4*g2) + 45*f**3*k2**2*(5*r - 4) + 11*f**2*(36*b1*k2**2 + k1**2*(16*C - 9)*(3*r - 4)) - 33*f*(9*b1**2*k2**2*r + b1*k1**2*r*(9 - 16*C) + b1*k2**2*(-2*K*(r - 4) + r - 4) + 4*g2*k2**2*(r - 4)))/(1155*d*k3**4) - 2*1j*D1**4*Pk3*Pkd1*ct*f*k2*st**2*(3*b1**2*r*(k1**2*(28*C - 21) + k2**2*(7 - 6*f)) - 3*b1*f*(-4*k1**2*(2*C*(r + 2) - r - 3) + k2**2*(f*(6*r - 8) + r - 4)) + f**2*k1**2*(12*C - 7)*(3*r - 4))/(105*d*k1*k3**2) + 4*1j*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(2*C - 1)*(3*b1*r + f)/(35*d*k3**2) + 4*1j*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(33*b1*r*(b1*k2**2 + k1**2*(1 - 2*C)) + 3*f**2*k2**2*(r - 3) + 11*f*(b1*k2**2 + k1**2*(1 - 2*C)))/(385*d*k3**4) - 4*1j*D1**4*Pk3*Pkd1*f*k1**4*(-K*b1 + 2*g2)*(7*b1*r + f*(6*r - 3))/(35*d*k3**4) - 4*1j*D1**4*Pk3*Pkd1*f*k1**2*(7*b1*b2*r + b2*f*(6*r - 3) + (K*b1 - 2*g2)*(7*b1 + 6*f*r - 3*f))/(35*d*k3**2) + 2*1j*D1**4*Pk3*Pkd1*f*k1**2*st**2*(-231*b1*k2**2*r*(K*b1 - 2*g2) + 5*f**3*k2**2*(5*r - 4) + 11*f**2*(-6*b1*k2**2*(r - 2) + k1**2*(2*C - 1)*(3*r - 4)) - 33*f*(-K*b1*k2**2*(r - 4) + b1*r*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(r - 4)))/(1155*d*k3**4) + 2*1j*D1**4*Pk3*Pkd1*f*st**2*(21*b1**3*k2**2*r + 3*b1**2*(2*f*k2**2*(r + 2) + r*(-14*C*k1**2 + 7*K*k2**2 + 7*k1**2)) + 3*b1*(-K*f*k2**2*(r - 4) + f**2*k2**2*(3*r - 4) + f*k1**2*(4 - 8*C) + k2**2*r*(7*b2 - 14*g2)) + f*(f*k1**2*(-6*C*r + 8*C + 3*r - 4) + k2**2*(-3*b2 + 6*g2)*(r - 4)))/(105*d*k3**2)
        perm23 = 4*1j*D1**4*Pk2*Pk3*b1*f*k1*(b1*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1))) - 15*f**2*k1**4*(r + s - 1) - f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s))/(35*d*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct**7*f**2*k1**2*k2**3*(99*b1*(K - 1)*(2*r + 2*s - 1) + 7*f**2*(25*r + 25*s - 16) + f*(22*C - 22)*(12*r + 12*s - 5) - 198*g2*(2*r + 2*s - 1))/(231*d*k3**6) - 4*1j*D1**4*Pk2*Pk3*ct**6*f**2*k1*k2**2*(-198*b1*k1**2*(K - 1)*(9*r + 9*s - 8) + 55*b1*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)) - 35*f**2*k1**2*(101*r + 101*s - 73) - 110*f*(k1**2*(6*C - 6)*(3*r + 3*s - 2) + k2**2*(4*C - 3)*(12*r + 12*s - 5)) + 396*g2*(k1**2*(9*r + 9*s - 8) + 10*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct**5*f**2*k1**2*k2**3*st**2*(990*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(141*r + 141*s - 92) + f*(44*C - 44)*(48*r + 48*s - 23) - 1980*g2*(2*r + 2*s - 1))/(1155*d*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct**5*f*k2*(693*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 33*b1*(5*f**2*k1**2*k2**2*(6*r + 6*s - 5) + 3*f*(-5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s + 1) + k1**2*k2**2*(-2*C*(3*r + 3*s + 2) + K*(-4*r - 4*s + 9) + r + s + 3)) + 42*g2*k1**2*k2**2*(r + s)) + f*(35*f**2*k1**2*(k1**2*(18*r + 18*s - 19) - 11*k2**2*(3*r + 3*s - 2)) - 55*f*(k1**4*(6*C - 6)*(3*r + 3*s - 1) + 3*k1**2*k2**2*(2*C - 3*r - 3*s) - k2**4*(2*C - 1)*(12*r + 12*s - 5)) + 198*g2*(k1**4*(5*r + 5*s + 1) + k1**2*k2**2*(-4*r - 4*s + 9) - 5*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**6) - 8*1j*D1**4*Pk2*Pk3*ct**4*f**2*k1*k2**2*st**2*(-33*b1*(k1**2*(3*K - 3)*(15*r + 15*s - 11) - 5*k2**2*(f*(12*r + 12*s - 7) + (6 - 12*K)*(2*r + 2*s - 1))) - 50*f**2*k1**2*(69*r + 69*s - 49) - 22*f*(k1**2*(9*C - 9)*(9*r + 9*s - 5) + k2**2*(4*C - 3)*(48*r + 48*s - 23)) + 198*g2*(k1**2*(15*r + 15*s - 11) + 20*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**6) - 4*1j*D1**4*Pk2*Pk3*ct**4*f*k1*(33*b1**2*(3*f*k2**4*(13*r + 13*s - 3) + 14*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(3 - 6*K))) - 11*b1*(5*f**2*k2**2*(k1**2*(24*r + 24*s + 2) + 9*k2**2*(5*r + 5*s - 3)) - 18*f*(k1**4*(2*K - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(2*C*(5*r + 5*s - 6) + K*(31*r + 31*s - 12) - 36*r - 36*s + 25) - k2**4*(4*C*(3*r + 3*s + 2) + K*(-19*r - 19*s + 6) + 5*r + 5*s - 13)) + 84*g2*k2**2*(k1**2 - 6*k2**2)*(r + s)) + f*(35*f**2*k1**2*(k1**2*(31*r + 31*s - 15) + 11*k2**2*(15*r + 15*s - 11)) + 110*f*(k1**4*(4*C - 4)*(3*r + 3*s - 2) + 3*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 27*r - 27*s + 15) + 3*k2**4*(2*C*(9*r + 9*s - 4) - 15*r - 15*s + 7)) - 396*g2*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(31*r + 31*s - 12) + k2**4*(19*r + 19*s - 6))))/(1155*d*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct**3*f**2*k1**2*k2**3*st**4*(165*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(107*r + 107*s - 72) + f*(22*C - 22)*(12*r + 12*s - 7) - 330*g2*(2*r + 2*s - 1))/(385*d*k3**6) - 8*1j*D1**4*Pk2*Pk3*ct**3*f*k2*st**2*(-693*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 33*b1*(2*f**2*k1**2*k2**2*(27*r + 27*s - 20) - f*(30*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 13) + k1**2*k2**2*(C*(22*r + 22*s - 4) + K*(48*r + 48*s - 45) - 25*r - 25*s + 16)) + 42*g2*k1**2*k2**2*(r + s)) + f*(-10*f**2*k1**2*(k1**2*(147*r + 147*s - 124) - 55*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**4*(18*C - 18)*(r + s - 1) + 9*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) + k2**4*(4*C - 2)*(48*r + 48*s - 23)) + 66*g2*(k1**4*(5*r + 5*s - 13) + 3*k1**2*k2**2*(16*r + 16*s - 15) + 30*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**6) - 8*1j*D1**4*Pk2*Pk3*ct**3*f*(231*b1*k2**2*(r + s)*(b1*(-3*K*k2**4 + k1**4*(6*K - 6) + k1**2*k2**2*(7*K - 6)) - 2*g2*(6*k1**4 + 7*k1**2*k2**2 - 3*k2**4)) + 35*f**3*(k1**6*(8*r + 8*s - 6) + 11*k1**4*k2**2*(6*r + 6*s - 5)) - 55*f**2*(k1**4*k2**2*(C*(-42*r - 42*s + 34) + b1*(6*r + 6*s - 1) + 36*r + 36*s - 30) + 3*k1**2*k2**4*(C*(-42*r - 42*s + 26) + 3*b1*(4*r + 4*s - 3) + 30*r + 30*s - 19) + k2**6*(9 - 18*C)*(2*r + 2*s - 1)) + 99*f*k2**2*(b1**2*k1**2*k2**2*(5*r + 5*s + 1) + b1*(k1**4*(12*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 35*r - 35*s + 21) + k1**2*k2**2*(C*(34*r + 34*s - 24) + K*(47*r + 47*s - 27) - 50*r - 50*s + 32) + k2**4*(-2*C*(3*r + 3*s + 2) + 7*K*(2*r + 2*s - 1) + 3*r + 3*s + 2)) - 2*g2*(k1**4*(15*r + 15*s - 11) + k1**2*k2**2*(47*r + 47*s - 27) + 7*k2**4*(2*r + 2*s - 1))))/(1155*d*k2*k3**6) - 4*1j*D1**4*Pk2*Pk3*ct**2*f**2*k1*k2**2*st**4*(-33*b1*(k1**2*(6*K - 6)*(2*r + 2*s - 1) - 5*k2**2*(f*(5*r + 5*s - 3) + (2 - 4*K)*(2*r + 2*s - 1))) - 5*f**2*k1**2*(249*r + 249*s - 173) - 22*f*(k1**2*(6*C - 6)*(2*r + 2*s - 1) + k2**2*(4*C - 3)*(12*r + 12*s - 7)) + 132*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(385*d*k3**6) - 4*1j*D1**4*Pk2*Pk3*ct**2*f*k1*st**2*(99*b1**2*(f*k2**4*(17*r + 17*s - 5) - 14*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) - 66*b1*(f**2*k2**2*(4*k1**2*(3*r + 3*s + 1) + 9*k2**2*(5*r + 5*s - 3)) - f*(k1**4*(K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-22*r - 22*s + 4) + K*(11*r + 11*s + 12) + 6*r + 6*s - 3) + k2**4*(C*(-44*r - 44*s + 8) + K*(39*r + 39*s - 9) - 9*r - 9*s + 15)) - 42*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(15*f**2*k1**2*(k1**2*(3*r + 3*s + 17) + 22*k2**2*(15*r + 15*s - 11)) + 22*f*(k1**4*(2*C - 2)*(3*r + 3*s + 1) + 9*k1**2*k2**2*(2*C*s + r*(2*C - 3) - 3*s + 1) + 9*k2**4*(C*(6*r + 6*s - 2) - 9*r - 9*s + 4)) - 132*g2*(k1**4*(r + s + 3) + k1**2*k2**2*(11*r + 11*s + 12) + 3*k2**4*(13*r + 13*s - 3))))/(1155*d*k3**6) + 4*1j*D1**4*Pk2*Pk3*ct**2*f*k1*(3*b1**2*(3*f*k2**2*(k1**2*(27*r + 27*s - 17) + 7*k2**2*(3*r + 3*s - 1)) + (r + s)*(-14*k1**4*(2*K - 2) - 14*k1**2*k2**2*(17*K - 11) - 14*k2**4*(11*K - 5))) - 3*b1*(5*f**2*(k1**4*(9*r + 9*s - 5) + 6*k1**2*k2**2) + 6*f*(k1**4*(4*C - 4)*(2*r + 2*s - 1) + k1**2*k2**2*(C*(62*r + 62*s - 24) + 2*K*(9*r + 9*s - 8) - 57*r - 57*s + 25) + k2**4*(2*C*(19*r + 19*s - 6) + 7*K*(3*r + 3*s - 2) - 26*r - 26*s + 6)) - 28*g2*(r + s)*(2*k1**4 + 17*k1**2*k2**2 + 11*k2**4)) + f*(-105*f**2*k1**4*(r + s - 1) - 10*f*k2**2*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(3*r + 3*s - 2)) + 36*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct*f**4*k1**2*k2**3*st**6*(73*r + 73*s - 52)/(231*d*k3**6) - 8*1j*D1**4*Pk2*Pk3*ct*f**2*k2*st**4*(f**2*(-51*k1**4*(4*r + 4*s - 3) + 55*k1**2*k2**2*(3*r + 3*s - 2)) + 11*f*(3*k1**2*k2**2*(b1*(8*r + 8*s - 5) - (4*C - 3)*(2*r + 2*s - 1)) - k2**4*(2*C - 1)*(12*r + 12*s - 7)) - 33*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(385*d*k3**6) - 8*1j*D1**4*Pk2*Pk3*ct*f*st**2*(-693*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(5*r + 5*s - 1) + 11*k1**4*k2**2*(6*r + 6*s - 5)) - 11*f**2*(k1**4*k2**2*(3*b1*(18*r + 18*s - 5) - (4*C - 3)*(3*r + 3*s + 1)) + 9*k1**2*k2**4*(-2*C*(5*r + 5*s - 3) + 3*b1*(4*r + 4*s - 3) + 8*r + 8*s - 5) + k2**6*(27 - 54*C)*(2*r + 2*s - 1)) + 33*f*k2**2*(2*b1**2*k1**2*k2**2*(15*r + 15*s - 4) + b1*(k1**4*(2*K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-44*r - 44*s + 8) + K*(37*r + 37*s - 15) + 12*r + 12*s + 8) + k2**4*(C*(-22*r - 22*s + 4) + 21*K*(2*r + 2*s - 1) + 11*r + 11*s - 2)) - 2*g2*(2*k1**4*(r + s + 3) + k1**2*k2**2*(37*r + 37*s - 15) + 21*k2**4*(2*r + 2*s - 1))))/(1155*d*k2*k3**6) + 8*1j*D1**4*Pk2*Pk3*ct*f*(3*b1**2*k2**2*(3*f*k1**2*(8*k1**2*(2*r + 2*s - 1) + 7*k2**2*(3*r + 3*s - 1)) + (r + s)*(-35*K*k2**4 - 7*k1**4*(4*K - 2) - 7*k1**2*k2**2*(16*K - 5))) + b1*(-5*f**2*k1**4*(k1**2*(6*r + 6*s - 4) + 9*k2**2*(2*r + 2*s - 1)) - 9*f*k2**2*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(13*r + 13*s - 3) + 7*K*(r + s - 1) - 33*r - 33*s + 6) + k2**4*(14*C - 7)*(r + s)) + 42*g2*k2**2*(r + s)*(4*k1**4 + 16*k1**2*k2**2 + 5*k2**4)) - 9*f*k1**2*k2**4*(f*(10*C - 5) - 14*g2)*(r + s - 1))/(105*d*k2*k3**6) + 8*1j*D1**4*Pk2*Pk3*f**3*k1*k2**2*st**6*(-11*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(37*r + 37*s - 25))/(231*d*k3**6) + 4*1j*D1**4*Pk2*Pk3*f**2*k1*st**4*(f**2*(4*k1**4*(7*r + 7*s - 8) - 11*k1**2*k2**2*(15*r + 15*s - 11)) + 11*f*(2*b1*k1**2*k2**2 + 3*b1*k2**4*(5*r + 5*s - 3) + k2**4*(12*C - 6)*(2*r + 2*s - 1)) + k2**4*(2*r + 2*s - 1)*(198*K*b1 - 66*b1**2 - 396*g2))/(385*d*k3**6) - 4*1j*D1**4*Pk2*Pk3*f*k1*st**2*(-3*b1**2*k2**2*(42*K*k2**2*(r + s) + f*k1**2*(-30*r - 30*s + 8) + 7*f*k2**2*(3*r + 3*s - 1)) - 6*b1*(f**2*(k1**4*(3*r + 3*s - 1) - 3*k1**2*k2**2) - f*(K*k1**2*k2**2*(r + s + 3) + 7*K*k2**4*(3*r + 3*s - 2) - k2**4*(2*C - 1)*(11*r + 11*s - 2)) - 42*g2*k2**4*(r + s)) + f*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) - 12*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**6) - 12*1j*D1**4*Pk2*Pkd3*b1**2*f**2*k1*st**4*(r + s - 1)/(35*d*k3) + 1j*D1**4*Pk2*Pkd3*b1**2*f*k1*(-8*C + 5*b1 + 4)*(r + s - 1)/(5*d*k3) - 3*1j*D1**4*Pk2*Pkd3*b1*ct**4*f*k1*(b1*(13*f + 14) + 6*f)*(r + s - 1)/(35*d*k3) + 2*1j*D1**4*Pk2*Pkd3*b1*ct**3*f*(r + s - 1)*(21*K*b1*k2**2 + 2*b1*k1**2*(6*f + 7) + 12*f*k1**2 + f*k2**2*(18*C - 9) + k2**2*(21*b2 - 42*g2))/(35*d*k2*k3) - 1j*D1**4*Pk2*Pkd3*b1*ct**2*f*k1*st**2*(b1*(51*f + 42) + 22*f)*(r + s - 1)/(35*d*k3) - 1j*D1**4*Pk2*Pkd3*b1*ct**2*f*k1*(r + s - 1)*(48*C*f + 7*b1**2 - 7*b1*(-4*K + 9*f + 14) + 28*b2 - 66*f - 56*g2)/(35*d*k3) + 2*1j*D1**4*Pk2*Pkd3*b1*ct*f*st**2*(r + s - 1)*(21*K*b1*k2**2 + b1*k1**2*(3*f - 7) + f*k1**2 + f*k2**2*(22*C - 11) + k2**2*(21*b2 - 42*g2))/(35*d*k2*k3) + 2*1j*D1**4*Pk2*Pkd3*b1*ct*f*(r + s - 1)*(2*b1**2*k1**2 + 2*b1*k1**2 + b1*k2**2*(-4*C - 5*K + 2) + k2**2*(-5*b2 + f*(3 - 6*C) + 10*g2))/(5*d*k2*k3) - 2*1j*D1**4*Pk2*Pkd3*b1*f**3*k1*k2**2*st**6*(3*r + 3*s - 2)/(21*d*k3**3) - 1j*D1**4*Pk2*Pkd3*b1*f*k1*st**2*(r + s - 1)*(4*C*f + 14*b1**2 - 7*b1*(2*K + 3*f) - 14*b2 - 2*f + 28*g2)/(35*d*k3) - 1j*D1**4*Pk2*Pkd3*b1*f*k1*(7*b1**2*(4*k1**2 + 5*k2**2)*(r + s - 1) - 14*b1*(-2*K*k1**2*(r + s) + 3*f*k1**2*(r + s - 1) + k2**2*(4*C*(r + s - 1) - 5*K*r - 5*K*s - 2*r - 2*s + 2)) + f*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + (14*b2 - 28*g2)*(2*k1**2 + 5*k2**2)*(r + s))/(35*d*k3**3) - 1j*D1**4*Pk2*Pkd3*b1*f*k1*(b1*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1))) - 15*f**2*k1**4*(r + s - 1) - f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s))/(35*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**7*f**2*k1**2*k2**3*(99*b1*(K - 1)*(2*r + 2*s - 1) + 7*f**2*(25*r + 25*s - 16) + f*(22*C - 22)*(12*r + 12*s - 5) - 198*g2*(2*r + 2*s - 1))/(231*d*k3**5) - 1j*D1**4*Pk2*Pkd3*ct**6*f**2*k1*k2**2*(b1*f*(33*r + 33*s - 19) + 18*b1*(2*r + 2*s - 1) + 2*f*(12*r + 12*s - 5))/(21*d*k3**3) + 1j*D1**4*Pk2*Pkd3*ct**6*f**2*k1*k2**2*(-198*b1*k1**2*(K - 1)*(9*r + 9*s - 8) + 55*b1*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)) - 35*f**2*k1**2*(101*r + 101*s - 73) - 110*f*(k1**2*(6*C - 6)*(3*r + 3*s - 2) + k2**2*(4*C - 3)*(12*r + 12*s - 5)) + 396*g2*(k1**2*(9*r + 9*s - 8) + 10*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**5*f**2*k1**2*k2**3*st**2*(990*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(141*r + 141*s - 92) + f*(44*C - 44)*(48*r + 48*s - 23) - 1980*g2*(2*r + 2*s - 1))/(1155*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**5*f*k2*(63*b1**2*k1**2*(K - 1)*(r + s - 1) + 3*b1*(5*f**2*k1**2*(10*r + 10*s - 9) + 3*f*(-5*K*k2**2*(2*r + 2*s - 1) + k1**2*(6*C*(r + s - 1) + 3*r + 3*s - 2)) - 42*g2*k1**2*(r + s - 1)) - 5*f*(f*k1**2*(-9*r - 9*s + 6) + f*k2**2*(2*C - 1)*(12*r + 12*s - 5) + k2**2*(9*b2 - 18*g2)*(2*r + 2*s - 1)))/(105*d*k3**3) - 2*1j*D1**4*Pk2*Pkd3*ct**5*f*k2*(693*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 33*b1*(5*f**2*k1**2*k2**2*(6*r + 6*s - 5) + 3*f*(-5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s + 1) + k1**2*k2**2*(-2*C*(3*r + 3*s + 2) + K*(-4*r - 4*s + 9) + r + s + 3)) + 42*g2*k1**2*k2**2*(r + s)) + f*(35*f**2*k1**2*(k1**2*(18*r + 18*s - 19) - 11*k2**2*(3*r + 3*s - 2)) - 55*f*(k1**4*(6*C - 6)*(3*r + 3*s - 1) + 3*k1**2*k2**2*(2*C - 3*r - 3*s) - k2**4*(2*C - 1)*(12*r + 12*s - 5)) + 198*g2*(k1**4*(5*r + 5*s + 1) + k1**2*k2**2*(-4*r - 4*s + 9) - 5*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(15*b1*(f*(12*r + 12*s - 7) + 12*r + 12*s - 6) + 2*f*(48*r + 48*s - 23))/(105*d*k3**3) + 2*1j*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(-33*b1*(k1**2*(3*K - 3)*(15*r + 15*s - 11) - 5*k2**2*(f*(12*r + 12*s - 7) + (6 - 12*K)*(2*r + 2*s - 1))) - 50*f**2*k1**2*(69*r + 69*s - 49) - 22*f*(k1**2*(9*C - 9)*(9*r + 9*s - 5) + k2**2*(4*C - 3)*(48*r + 48*s - 23)) + 198*g2*(k1**2*(15*r + 15*s - 11) + 20*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**5) + 1j*D1**4*Pk2*Pkd3*ct**4*f*k1*(b1**2*(k1**2*(28*K - 28)*(r + s - 1) - 6*k2**2*(14*K*(r + s - 1) + 5*f + 7)) + b1*(5*f**2*(2*k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3)) + 6*f*(k1**2*(8*C*(r + s - 1) - 3*r - 3*s + 9) + k2**2*(-12*C*(r + s - 1) + K*(9*r + 9*s - 8) + 20*r + 20*s - 18)) - 56*g2*(k1**2 - 3*k2**2)*(r + s - 1)) + 2*f*(5*f*(k1**2*(3*r + 3*s - 1) + k2**2*(C*(6*r + 6*s - 4) + 3*r + 3*s - 1)) + k2**2*(3*b2 - 6*g2)*(9*r + 9*s - 8)))/(35*d*k3**3) + 1j*D1**4*Pk2*Pkd3*ct**4*f*k1*(33*b1**2*(3*f*k2**4*(13*r + 13*s - 3) + 14*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(3 - 6*K))) - 11*b1*(5*f**2*k2**2*(k1**2*(24*r + 24*s + 2) + 9*k2**2*(5*r + 5*s - 3)) - 18*f*(k1**4*(2*K - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(2*C*(5*r + 5*s - 6) + K*(31*r + 31*s - 12) - 36*r - 36*s + 25) - k2**4*(4*C*(3*r + 3*s + 2) + K*(-19*r - 19*s + 6) + 5*r + 5*s - 13)) + 84*g2*k2**2*(k1**2 - 6*k2**2)*(r + s)) + f*(35*f**2*k1**2*(k1**2*(31*r + 31*s - 15) + 11*k2**2*(15*r + 15*s - 11)) + 110*f*(k1**4*(4*C - 4)*(3*r + 3*s - 2) + 3*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 27*r - 27*s + 15) + 3*k2**4*(2*C*(9*r + 9*s - 4) - 15*r - 15*s + 7)) - 396*g2*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(31*r + 31*s - 12) + k2**4*(19*r + 19*s - 6))))/(1155*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**3*f**2*k1**2*k2**3*st**4*(165*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(107*r + 107*s - 72) + f*(22*C - 22)*(12*r + 12*s - 7) - 330*g2*(2*r + 2*s - 1))/(385*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(63*b1**2*k1**2*(K - 1)*(r + s - 1) + 3*b1*(-30*K*f*k2**2*(2*r + 2*s - 1) + 2*f**2*k1**2*(43*r + 43*s - 36) + f*k1**2*(22*C*(r + s - 1) + 23*r + 23*s - 11) - 42*g2*k1**2*(r + s - 1)) + f*(9*f*k1**2*(9*r + 9*s - 5) - f*k2**2*(4*C - 2)*(48*r + 48*s - 23) + k2**2*(-90*b2 + 180*g2)*(2*r + 2*s - 1)))/(105*d*k3**3) + 2*1j*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(-693*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 33*b1*(2*f**2*k1**2*k2**2*(27*r + 27*s - 20) - f*(30*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 13) + k1**2*k2**2*(C*(22*r + 22*s - 4) + K*(48*r + 48*s - 45) - 25*r - 25*s + 16)) + 42*g2*k1**2*k2**2*(r + s)) + f*(-10*f**2*k1**2*(k1**2*(147*r + 147*s - 124) - 55*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**4*(18*C - 18)*(r + s - 1) + 9*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) + k2**4*(4*C - 2)*(48*r + 48*s - 23)) + 66*g2*(k1**4*(5*r + 5*s - 13) + 3*k1**2*k2**2*(16*r + 16*s - 15) + 30*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**5) + 2*1j*D1**4*Pk2*Pkd3*ct**3*f*(3*b1**2*(21*K*k2**4 + k1**2*k2**2*(28*C*(r + s - 1) + 63*K*(r + s - 1) - 3*f*(6*r + 6*s - 5) - 70*r - 70*s + 77)) + b1*(5*f**2*k1**2*(2*k1**2 + 9*k2**2)*(6*r + 6*s - 5) + 9*f*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(30*C*(r + s - 1) - K*(5*r + 5*s + 1) + 6) + k2**4*(10*C - 7*K*(2*r + 2*s - 1) - 5)) + 63*k2**2*(b2*k2**2*(r + s) - 2*g2*(3*k1**2*(r + s - 1) + k2**2))) + f*(5*f*(k1**4*(6*r + 6*s - 4) - 3*k1**2*k2**2*(C*(6*r + 6*s - 2) - 12*r - 12*s + 7) + k2**4*(9 - 18*C)*(2*r + 2*s - 1)) + k2**2*(-9*b2 + 18*g2)*(k1**2*(5*r + 5*s + 1) + 7*k2**2*(2*r + 2*s - 1))))/(105*d*k2*k3**3) + 2*1j*D1**4*Pk2*Pkd3*ct**3*f*(231*b1*k2**2*(r + s)*(b1*(-3*K*k2**4 + k1**4*(6*K - 6) + k1**2*k2**2*(7*K - 6)) - 2*g2*(6*k1**4 + 7*k1**2*k2**2 - 3*k2**4)) + 35*f**3*(k1**6*(8*r + 8*s - 6) + 11*k1**4*k2**2*(6*r + 6*s - 5)) - 55*f**2*(k1**4*k2**2*(C*(-42*r - 42*s + 34) + b1*(6*r + 6*s - 1) + 36*r + 36*s - 30) + 3*k1**2*k2**4*(C*(-42*r - 42*s + 26) + 3*b1*(4*r + 4*s - 3) + 30*r + 30*s - 19) + k2**6*(9 - 18*C)*(2*r + 2*s - 1)) + 99*f*k2**2*(b1**2*k1**2*k2**2*(5*r + 5*s + 1) + b1*(k1**4*(12*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 35*r - 35*s + 21) + k1**2*k2**2*(C*(34*r + 34*s - 24) + K*(47*r + 47*s - 27) - 50*r - 50*s + 32) + k2**4*(-2*C*(3*r + 3*s + 2) + 7*K*(2*r + 2*s - 1) + 3*r + 3*s + 2)) - 2*g2*(k1**4*(15*r + 15*s - 11) + k1**2*k2**2*(47*r + 47*s - 27) + 7*k2**4*(2*r + 2*s - 1))))/(1155*d*k2*k3**5) - 1j*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(15*b1*(f*(5*r + 5*s - 3) + 4*r + 4*s - 2) + 2*f*(12*r + 12*s - 7))/(35*d*k3**3) + 1j*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(-33*b1*(k1**2*(6*K - 6)*(2*r + 2*s - 1) - 5*k2**2*(f*(5*r + 5*s - 3) + (2 - 4*K)*(2*r + 2*s - 1))) - 5*f**2*k1**2*(249*r + 249*s - 173) - 22*f*(k1**2*(6*C - 6)*(2*r + 2*s - 1) + k2**2*(4*C - 3)*(12*r + 12*s - 7)) + 132*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(385*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(b1**2*(k1**2*(7*K - 7)*(r + s - 1) + 3*k2**2*(14*K*(r + s - 1) + 6*f + 7)) + b1*(3*f**2*(k1**2*(5*r + 5*s - 7) - 3*k2**2*(5*r + 5*s - 3)) + f*(k1**2*(-2*C*(r + s - 1) + 7*r + 7*s - 15) + k2**2*(44*C*(r + s - 1) + K*(-45*r - 45*s + 33) - 64*r - 64*s + 52)) - 14*g2*(k1**2 + 6*k2**2)*(r + s - 1)) + 3*f*(f*k1**2*(r + s - 1) + f*k2**2*(-2*C*(9*r + 9*s - 5) + 3*r + 3*s - 2) - k2**2*(b2 - 2*g2)*(15*r + 15*s - 11)))/(35*d*k3**3) + 1j*D1**4*Pk2*Pkd3*ct**2*f*k1*(21*b1**3*k2**2*(r + s - 1) + 6*b1**2*(k1**2*(28*C*(r + s - 1) + 9*f*(3*r + 3*s - 1) + 14*r + 14*s + 28) + 7*k2**2*(8*C*(r + s - 1) + 11*K*r + 11*K*s - 12*K + 3*f - 6*r - 6*s + 11)) + 6*b1*(45*f**2*k1**2*(r + s - 1) - 3*f*(k1**2*(K*(4*r + 4*s - 2) - 19*r - 19*s + 13) + k2**2*(C*(-26*r - 26*s + 24) + 7*K*(3*r + 3*s - 2) + 13*r + 13*s - 19)) - 7*k2**2*(b2*(r + s) + g2*(22*r + 22*s - 24))) - 2*f*(9*b2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(3*r + 3*s - 2)) + 5*f*(k1**2*(4*C*(3*r + 3*s - 2) - 15*r - 15*s + 13) + k2**2*(18*C - 9)*(3*r + 3*s - 2)) - 18*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**3) + 1j*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(99*b1**2*(f*k2**4*(17*r + 17*s - 5) - 14*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) - 66*b1*(f**2*k2**2*(4*k1**2*(3*r + 3*s + 1) + 9*k2**2*(5*r + 5*s - 3)) - f*(k1**4*(K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-22*r - 22*s + 4) + K*(11*r + 11*s + 12) + 6*r + 6*s - 3) + k2**4*(C*(-44*r - 44*s + 8) + K*(39*r + 39*s - 9) - 9*r - 9*s + 15)) - 42*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(15*f**2*k1**2*(k1**2*(3*r + 3*s + 17) + 22*k2**2*(15*r + 15*s - 11)) + 22*f*(k1**4*(2*C - 2)*(3*r + 3*s + 1) + 9*k1**2*k2**2*(2*C*s + r*(2*C - 3) - 3*s + 1) + 9*k2**4*(C*(6*r + 6*s - 2) - 9*r - 9*s + 4)) - 132*g2*(k1**4*(r + s + 3) + k1**2*k2**2*(11*r + 11*s + 12) + 3*k2**4*(13*r + 13*s - 3))))/(1155*d*k3**5) - 1j*D1**4*Pk2*Pkd3*ct**2*f*k1*(3*b1**2*(3*f*k2**2*(k1**2*(27*r + 27*s - 17) + 7*k2**2*(3*r + 3*s - 1)) + (r + s)*(-14*k1**4*(2*K - 2) - 14*k1**2*k2**2*(17*K - 11) - 14*k2**4*(11*K - 5))) - 3*b1*(5*f**2*(k1**4*(9*r + 9*s - 5) + 6*k1**2*k2**2) + 6*f*(k1**4*(4*C - 4)*(2*r + 2*s - 1) + k1**2*k2**2*(C*(62*r + 62*s - 24) + 2*K*(9*r + 9*s - 8) - 57*r - 57*s + 25) + k2**4*(2*C*(19*r + 19*s - 6) + 7*K*(3*r + 3*s - 2) - 26*r - 26*s + 6)) - 28*g2*(r + s)*(2*k1**4 + 17*k1**2*k2**2 + 11*k2**4)) + f*(-105*f**2*k1**4*(r + s - 1) - 10*f*k2**2*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(3*r + 3*s - 2)) + 36*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct*f**4*k1**2*k2**3*st**6*(73*r + 73*s - 52)/(231*d*k3**5) + 2*1j*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(15*K*b1*k2**2*(2*r + 2*s - 1) - 9*b1*k1**2*(f*(4*r + 4*s - 3) + 2*r + 2*s - 1) + f*k1**2*(-6*r - 6*s + 3) + f*k2**2*(2*C - 1)*(12*r + 12*s - 7) + k2**2*(15*b2 - 30*g2)*(2*r + 2*s - 1))/(35*d*k3**3) + 2*1j*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(f**2*(-51*k1**4*(4*r + 4*s - 3) + 55*k1**2*k2**2*(3*r + 3*s - 2)) + 11*f*(3*k1**2*k2**2*(b1*(8*r + 8*s - 5) - (4*C - 3)*(2*r + 2*s - 1)) - k2**4*(2*C - 1)*(12*r + 12*s - 7)) - 33*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(385*d*k3**5) + 2*1j*D1**4*Pk2*Pkd3*ct*f*st**2*(-3*b1**2*(-21*K*k2**4 + k1**2*k2**2*(14*K*(r + s - 1) + f*(22*r + 22*s - 9) + 14*r + 14*s + 7)) + 3*b1*(f**2*k1**2*(k1**2*(6*r + 6*s - 2) + 9*k2**2*(6*r + 6*s - 5)) + f*(k1**4*(r + s + 3) + k1**2*k2**2*(4*C*(r + s - 1) + K*(5*r + 5*s - 13) + 7*r + 7*s - 9) + 3*k2**4*(6*C - 7*K*(2*r + 2*s - 1) - 3)) + 7*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + f*(f*(k1**4*(3*r + 3*s + 1) + 9*k1**2*k2**2*(2*C*(r + s - 1) + 2*r + 2*s - 1) + k2**4*(27 - 54*C)*(2*r + 2*s - 1)) + k2**2*(3*b2 - 6*g2)*(k1**2*(5*r + 5*s - 13) - 21*k2**2*(2*r + 2*s - 1))))/(105*d*k2*k3**3) - 2*1j*D1**4*Pk2*Pkd3*ct*f*(28*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(-3*f*k1**2*(k1**2*(8*r + 8*s - 6) + 7*k2**2*(2*r + 2*s - 1)) - 14*k1**4*(r + s) + 7*k1**2*k2**2*(-8*C*(r + s - 1) + 6*K*r + 6*K*s + r + s - 6) - 7*k2**4*(4*C*(r + s - 1) - 5*K - 2*r - 2*s + 2)) + b1*(-3*f*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(-12*C*(2*r + 2*s - 1) - 7*K*(r + s - 1) + 19*r + 19*s - 6) + k2**4*(7 - 14*C)) + 7*k2**2*(b2*(6*k1**2 + 5*k2**2)*(r + s) - 2*g2*(6*k1**2*(r + s) + 5*k2**2))) + 3*f*k1**2*k2**2*(7*b2 + f*(10*C - 5) - 14*g2)*(r + s - 1))/(35*d*k2*k3**3) + 2*1j*D1**4*Pk2*Pkd3*ct*f*st**2*(-693*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(5*r + 5*s - 1) + 11*k1**4*k2**2*(6*r + 6*s - 5)) - 11*f**2*(k1**4*k2**2*(3*b1*(18*r + 18*s - 5) - (4*C - 3)*(3*r + 3*s + 1)) + 9*k1**2*k2**4*(-2*C*(5*r + 5*s - 3) + 3*b1*(4*r + 4*s - 3) + 8*r + 8*s - 5) + k2**6*(27 - 54*C)*(2*r + 2*s - 1)) + 33*f*k2**2*(2*b1**2*k1**2*k2**2*(15*r + 15*s - 4) + b1*(k1**4*(2*K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-44*r - 44*s + 8) + K*(37*r + 37*s - 15) + 12*r + 12*s + 8) + k2**4*(C*(-22*r - 22*s + 4) + 21*K*(2*r + 2*s - 1) + 11*r + 11*s - 2)) - 2*g2*(2*k1**4*(r + s + 3) + k1**2*k2**2*(37*r + 37*s - 15) + 21*k2**4*(2*r + 2*s - 1))))/(1155*d*k2*k3**5) - 2*1j*D1**4*Pk2*Pkd3*ct*f*(3*b1**2*k2**2*(3*f*k1**2*(8*k1**2*(2*r + 2*s - 1) + 7*k2**2*(3*r + 3*s - 1)) + (r + s)*(-35*K*k2**4 - 7*k1**4*(4*K - 2) - 7*k1**2*k2**2*(16*K - 5))) + b1*(-5*f**2*k1**4*(k1**2*(6*r + 6*s - 4) + 9*k2**2*(2*r + 2*s - 1)) - 9*f*k2**2*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(13*r + 13*s - 3) + 7*K*(r + s - 1) - 33*r - 33*s + 6) + k2**4*(14*C - 7)*(r + s)) + 42*g2*k2**2*(r + s)*(4*k1**4 + 16*k1**2*k2**2 + 5*k2**4)) - 9*f*k1**2*k2**4*(f*(10*C - 5) - 14*g2)*(r + s - 1))/(105*d*k2*k3**5) + 2*1j*D1**4*Pk2*Pkd3*f**3*k1*k2**2*st**6*(11*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(-37*r - 37*s + 25))/(231*d*k3**5) - 3*1j*D1**4*Pk2*Pkd3*f**2*k1*st**4*(2*b1**2*k2**2 + b1*(-6*K*k2**2*(2*r + 2*s - 1) + 4*f*k1**2*(r + s - 1) + f*k2**2*(-5*r - 5*s + 3)) - k2**2*(6*b2 + 2*f*(2*C - 1) - 12*g2)*(2*r + 2*s - 1))/(35*d*k3**3) + 1j*D1**4*Pk2*Pkd3*f**2*k1*st**4*(f**2*(-4*k1**4*(7*r + 7*s - 8) + 11*k1**2*k2**2*(15*r + 15*s - 11)) - 11*f*(2*b1*k1**2*k2**2 + 3*b1*k2**4*(5*r + 5*s - 3) + k2**4*(12*C - 6)*(2*r + 2*s - 1)) + k2**4*(2*r + 2*s - 1)*(-198*K*b1 + 66*b1**2 + 396*g2))/(385*d*k3**5) + 2*1j*D1**4*Pk2*Pkd3*f*k1*st**2*(21*b1**3*k2**2*(r + s - 1) + 3*b1**2*(7*K*k2**2*(2*r + 2*s + 1) - 2*f*k1**2*(5*r + 5*s - 4) + 7*f*k2**2) + 3*b1*(9*f**2*k1**2*(r + s - 1) - f*(K*k1**2*(r + s + 3) + 7*K*k2**2*(3*r + 3*s - 2) - k2**2*(6*C - 3)*(4*r + 4*s - 1)) + 7*k2**2*(3*b2*(r + s) - 2*g2*(2*r + 2*s + 1))) + f*(-3*b2*(k1**2*(r + s + 3) + 7*k2**2*(3*r + 3*s - 2)) - f*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) + 6*g2*(k1**2*(r + s + 3) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**3) + 1j*D1**4*Pk2*Pkd3*f*k1*st**2*(-3*b1**2*k2**2*(42*K*k2**2*(r + s) + f*k1**2*(-30*r - 30*s + 8) + 7*f*k2**2*(3*r + 3*s - 1)) - 6*b1*(f**2*(k1**4*(3*r + 3*s - 1) - 3*k1**2*k2**2) - f*(K*k1**2*k2**2*(r + s + 3) + 7*K*k2**4*(3*r + 3*s - 2) - k2**4*(2*C - 1)*(11*r + 11*s - 2)) - 42*g2*k2**4*(r + s)) + f*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(3*r + 3*s - 2)) - 12*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(3*r + 3*s - 2))))/(105*d*k3**5) - 6*1j*D1**4*Pk3*b1**2*f**2*k1*st**4*(-4*Pk2 + Pkd2*k2)*(2*s - 1)/(35*d*k2**2) + 1j*D1**4*Pk3*b1**2*f*(4*Pk2*k1**2*s + Pk2*k2**2*(12 - 24*C)*(r - 1) + 5*Pkd2*b1*k1**2*k2*s)/(5*d*k1*k2**2) + 3*1j*D1**4*Pk3*b1*ct**4*f*k1*(4*Pk2 - Pkd2*k2)*(b1*f*(13*s - 10) + 14*b1*(s - 1) + 2*f*(3*s - 5))/(35*d*k2**2) + 6*1j*D1**4*Pk3*b1*ct**3*f*(-7*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 7*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-12*C*s + 20*C + 7*b1*(r - 1) + 3*r + 6*s - 22) + Pkd2*k2*(2*C - 1)*(3*s - 5)) + 14*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(35*d*k2) + 1j*D1**4*Pk3*b1*ct**2*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(b1*f*(51*s - 36) + 42*b1*(s - 1) + 2*f*(11*s - 9))/(35*d*k2**2) - 1j*D1**4*Pk3*b1*ct**2*f*(7*b1**2*k1**2*s*(-2*Pk2 + Pkd2*k2) + 7*b1*k1**2*(Pk2*(6*f + 8)*(3*s - 2) + Pkd2*k2*(-9*f*s + 6*f - 14*s + 10)) + 6*f*(Pk2*k2**2*(4*C - 2)*(3*r - 5) + k1**2*(2*Pk2*(5*s - 6) - 7*Pkd2*k2*(s - 1))))/(35*d*k1*k2**2) + 2*1j*D1**4*Pk3*b1*ct*f*st**2*(-21*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 21*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-44*C*s + 36*C + 21*b1*(r - 1) + r + 22*s - 22) + Pkd2*k2*(2*C - 1)*(11*s - 9)) + 42*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(35*d*k2) + 2*1j*D1**4*Pk3*b1*ct*f*(-6*C*Pkd2*f*k2*s + 6*C*Pkd2*f*k2 + 5*Pk2*b1**2*(r - 1) + Pk2*b1*(13*r - 8) + 3*Pk2*f*r + Pkd2*b1*k2*(-5*K*(s - 1) + s*(2 - 4*C)) - 5*Pkd2*b2*k2*(s - 1) + 3*Pkd2*f*k2*s - 3*Pkd2*f*k2 + 10*Pkd2*g2*k2*s - 10*Pkd2*g2*k2)/(5*d*k2) + 2*1j*D1**4*Pk3*b1*f**3*k1*st**6*(4*Pk2 - Pkd2*k2)*(3*s - 1)/(21*d*k3**2) + 1j*D1**4*Pk3*b1*f*k1*(14*Pk2*b1**2*k2*(4*k1**2 + 5*k2**2)*(r + s - 1) + 15*Pkd2*f**2*k1**4*s - 7*b1*k2*(-10*K*Pkd2*k2**3*s + 4*Pk2*k1**2*(-2*K*(r + 2*s) + s) + 2*Pk2*k2**2*(8*C*(r + s - 1) - 30*K*r - 30*K*s + r - 4*s + 4) + 3*f*k1**2*(2*Pk2*(6*r + 5*s - 4) + 3*Pkd2*k2*s)) + 6*f*k2*(4*Pk2*k1**2*(C*(4*r + 8*s - 2) - 2*r - 5*s + 1) + k2**2*(Pk2*(4*C*(24*r + 21*s - 5) - 55*r - 42*s + 10) + Pkd2*k2*s*(14*C - 7))) - 28*k2*(-Pk2*b2*(2*k1**2 + 5*k2**2)*(r + s) + 4*Pk2*g2*k1**2*(r + 2*s) + 5*g2*k2**2*(6*Pk2*(r + s) + Pkd2*k2*s)))/(35*d*k2*k3**4) + 1j*D1**4*Pk3*b1*f*st**2*(2*Pk2*f*(k1**2*(s + 3) + k2**2*(6 - 12*C)*(2*r - 1)) + 14*b1**2*k1**2*s*(2*Pk2 - Pkd2*k2) - 7*b1*k1**2*(2*Pk2*(3*f*s - 2*f + s - 1) + Pkd2*f*k2*(2 - 3*s)))/(35*d*k1*k2**2) - 1j*D1**4*Pk3*b1*f*(35*b1**2*k1**2*k2**2*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s) - 14*b1*(-5*K*Pkd2*k1**2*k2**3*s + 2*Pk2*k1**4*s + Pk2*k1**2*k2**2*(r*(5 - 10*K) + s*(8*C - 10*K - 6)) + Pk2*k2**4*(12*C - 6)*(r - 1) + 3*Pkd2*f*k1**4*k2*s) + 2*k1**2*(3*f*(-4*Pk2*k1**2*s + Pk2*k2**2*(4*C*(10*r + 7*s - 5) - 27*r - 14*s + 10) + Pkd2*k2**3*s*(14*C - 7)) + k2**2*(35*b2 - 70*g2)*(2*Pk2*(r + s) + Pkd2*k2*s)))/(35*d*k1*k2**2*k3**2) + 2*1j*D1**4*Pk3*ct**7*f**2*k1**2*k2*(4*Pk2 - Pkd2*k2)*(99*b1*(K - 1)*(2*s - 1) + 7*f**2*(25*s - 9) + f*(22*C - 22)*(12*s - 7) + 198*g2*(1 - 2*s))/(231*d*k3**4) + 1j*D1**4*Pk3*ct**6*f**2*k1*(4*Pk2 - Pkd2*k2)*(b1*(f*(33*s - 14) + 36*s - 18) + 2*f*(12*s - 7))/(21*d*k3**2) + 1j*D1**4*Pk3*ct**6*f**2*k1*(11*b1*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(13*s - 10) + 5*k2**2*(-72*K*Pk2*(r - 2*s + 1) - 36*K*Pkd2*k2*(2*s - 1) + 144*Pk2*r + 36*Pkd2*k2*s - 18*Pkd2*k2 + f*(2*Pk2*(33*r - 5) + Pkd2*k2*(33*s - 14)))) + 35*f**2*(44*Pk2*k2**2*(r - 1) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 6)) + 110*f*(k1**2*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(15*s - 14) + k2**2*(Pk2*(-4*C*(9*r - 24*s + 23) + 60*r - 48*s + 68) - Pkd2*k2*(4*C - 3)*(12*s - 7))) + 396*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 10) + 10*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(1155*d*k3**4) + 2*1j*D1**4*Pk3*ct**5*f**2*k1**2*k2*st**2*(4*Pk2 - Pkd2*k2)*(990*b1*(K - 1)*(2*s - 1) + 15*f**2*(141*s - 49) + f*(44*C - 44)*(48*s - 25) + 1980*g2*(1 - 2*s))/(1155*d*k3**4) - 2*1j*D1**4*Pk3*ct**5*f*(-63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) - 3*b1*(6*C*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 5) + 5*f**2*(3*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(12*s - 7)) + 3*f*(5*K*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 28*Pk2*k1**2*s - 10*Pk2*k2**2*r - 7*Pkd2*k1**2*k2*s) - 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 5*f*(f*k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 14) + f*k2**2*(C*Pk2*(28 - 48*s) - 6*Pk2*(r - 4*s + 5) + Pkd2*k2*(2*C - 1)*(12*s - 7)) + k2**2*(-2*Pk2 + Pkd2*k2)*(9*b2 - 18*g2)*(2*s - 1)))/(105*d*k2*k3**2) + 2*1j*D1**4*Pk3*ct**5*f*(-693*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 33*b1*(5*f**2*k2**2*(-3*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2*(5*r + s - 1) + Pkd2*k2*(8*s - 7))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(2*Pk2*(6*C*(r + 2*s - 1) + K*(-6*r + 16*s - 15) + 9*r - 6*s + 3) + Pkd2*k2*(K*(13 - 12*s) + s*(5 - 6*C) - 3)) - 5*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 42*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(-990*Pk2*b2*k2**4*(2*r + 2*s - 1) + 35*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(14*s - 9) + 11*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 55*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(3*s - 7) + k1**2*k2**2*(2*Pk2*(6*C*(6*s - 13) + 9*r - 12*s + 58) + Pkd2*k2*(C*(38 - 24*s) + 9*s - 24)) + k2**4*(Pk2*(-4*C*(18*r + 12*s + 11) + 42*r + 24*s + 38) - Pkd2*k2*(2*C - 1)*(12*s - 7))) - 198*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(-2*Pk2*(6*r - 16*s + 15) + Pkd2*k2*(13 - 12*s)) - 5*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(1155*d*k2*k3**4) + 2*1j*D1**4*Pk3*ct**4*f**2*k1*st**2*(4*Pk2 - Pkd2*k2)*(15*b1*(f*(12*s - 5) + 12*s - 6) + 2*f*(48*s - 25))/(105*d*k3**2) + 2*1j*D1**4*Pk3*ct**4*f**2*k1*st**2*(33*b1*(k1**2*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(17*s - 12) + 5*k2**2*(-24*K*Pk2*(r - 2*s + 1) - 12*K*Pkd2*k2*(2*s - 1) + 48*Pk2*r + 12*Pkd2*k2*s - 6*Pkd2*k2 + f*(4*Pk2*(6*r - 1) + Pkd2*k2*(12*s - 5)))) + 75*f**2*(22*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(17*s - 7)) + 22*f*(k1**2*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(33*s - 20) + k2**2*(-4*Pk2*(C*(30*r - 96*s + 67) - 54*r + 48*s - 43) - Pkd2*k2*(4*C - 3)*(48*s - 25))) + 198*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(17*s - 12) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(1155*d*k3**4) + 1j*D1**4*Pk3*ct**4*f*(-18*b1**2*k1**2*k2**2*(-2*Pk2*(-7*K*(r - 2*s + 2) + 5*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 5*f + 7)) + b1*k1**2*(5*f**2*(2*k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 14) + 9*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) + 18*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k2**2*(Pk2*(24*C*s - 68*C - 26*K*s + 20*K + r - 36*s + 70) + Pkd2*k2*(-12*C*s + 20*C + 13*K*s - 10*K + 20*s - 22))) + 504*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + 2*f*(5*f*(Pk2*k2**4*(2 - 4*C)*(3*r - 7) + k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 7) + k1**2*k2**2*(Pk2*(-60*C*s + 56*C + 15*r - 44) + Pkd2*k2*(30*C*s - 28*C + 3*s + 5))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(9*b2 - 18*g2)*(13*s - 10)))/(105*d*k1*k2**2*k3**2) + 1j*D1**4*Pk3*ct**4*f*(-462*b1*k1**2*k2**2*(b1*(k1**2*(K - 1)*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s) + 3*k2**2*(-2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(2*K - 1))) - 2*g2*(k1**2*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s) + 6*k2**2*(-Pk2*(r + 2*s - 2) + Pkd2*k2*s))) + 35*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(17*s - 18) + 11*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 55*f**2*(Pk2*k2**6*(4 - 8*C)*(3*r - 7) + 2*k1**4*k2**2*(Pk2*(-36*C*(r - s - 1) + 6*b1*(r + s - 6) + 54*r - 24*s - 28) + Pkd2*k2*(C*(8 - 42*s) + 21*b1 + 45*s - 15)) + k1**2*k2**4*(2*Pk2*(C*(-96*r + 12*s + 112) + 9*b1*(9*r + 5*s - 5) + 135*r + 36*s - 108) + Pkd2*k2*(C*(16 - 84*s) + 9*b1*(5*s - 2) + 78*s - 26))) + 99*f*k1**2*k2**2*(-4*Pk2*b2*k2**2*(9*r + 9*s - 8) + b1**2*k2**2*(20*Pk2 + 13*Pkd2*k2*s) - 2*b1*(k1**2*(2*Pk2*(2*C*(4*r + 5*s - 4) - 4*K*r + 7*K*s + r - 15*s + 14) + Pkd2*k2*(-2*C*s + K*(4 - 15*s) + 20*s - 9)) + k2**2*(Pk2*(-4*C*(6*r + 6*s - 13) - 2*K*(6*r - 5*s + 6) + 69*r + 44*s - 66) + Pkd2*k2*(K*(4 - 15*s) + s*(12*C + 5) - 7))) - 4*g2*(2*Pk2*k1**2*(4*r - 7*s) + 2*Pk2*k2**2*(6*r - 5*s + 6) + Pkd2*k1**2*k2*(15*s - 4) + Pkd2*k2**3*(15*s - 4))))/(1155*d*k1*k2**2*k3**4) + 2*1j*D1**4*Pk3*ct**3*f**2*k1**2*k2*st**4*(4*Pk2 - Pkd2*k2)*(165*b1*(K - 1)*(2*s - 1) + 5*f**2*(107*s - 35) + f*(22*C - 22)*(12*s - 5) + 330*g2*(1 - 2*s))/(385*d*k3**4) - 2*1j*D1**4*Pk3*ct**3*f*st**2*(-63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) - 3*b1*(f**2*(30*Pk2*k2**2*(r - 1) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(48*s - 25)) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(11*s - 9) + 29*s - 18) + 30*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(f*(4*Pk2*k2**2*(C*(96*s - 50) + 6*r - 48*s + 41) - Pkd2*k2**3*(4*C - 2)*(48*s - 25) - 3*k1**2*(4*Pk2 - Pkd2*k2)*(33*s - 20)) + k2**2*(-2*Pk2 + Pkd2*k2)*(-90*b2 + 180*g2)*(2*s - 1)))/(105*d*k2*k3**2) + 2*1j*D1**4*Pk3*ct**3*f*(3*b1**2*(21*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(6*Pk2*f*(6*s + 5) - 14*Pk2*(3*K*(s - 1) + s*(4*C - 8) + 3) - 3*Pkd2*f*k2*(6*s + 5) + 7*Pkd2*k2*(5*K*(s - 1) + s*(4*C - 10) + 5))) + 3*b1*(21*Pkd2*b2*k2**3*s + 15*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) - 3*f*(k1**2*(Pk2*(4*C*(3*s - 5) + 6*K*s - 10*K - 11*r + 24*s - 4) + Pkd2*k2*(-14*C*(s - 1) - 3*K*s + 5*K - 8*s)) + k2**2*(-2*Pk2*(6*C*(r - 4) - 7*K*r + 4*r + 12) + Pkd2*k2*(-10*C + 14*K*s - 7*K + 5))) + 14*g2*k1**2*(6*Pk2 - 5*Pkd2*k2)*(s - 1) - 42*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-9*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 5) + 7*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) - 5*f*(k1**2*(Pk2*(4*C*(3*s - 7) - 21*r + 36*s - 2) + Pkd2*k2*(C*(14 - 6*s) - 24*s + 11)) + k2**2*(4*Pk2*(15*C*r - 14*C - 12*r + 7) + Pkd2*k2*(18*C - 9)*(2*s - 1))) + 18*g2*(k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 5) + 7*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1)))))/(105*d*k2*k3**2) - 2*1j*D1**4*Pk3*ct**3*f*st**2*(693*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 33*b1*(2*f**2*k2**2*(-15*Pk2*k2**2*(r - 1) + k1**2*(86*Pk2*r + 22*Pk2*(s - 1) + Pkd2*k2*(32*s - 25))) + f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(11*s - 9) + k1**2*k2**2*(2*Pk2*(22*C*(r + 2*s - 1) - 6*K*(5*r - 11*s + 9) + 53*r - 14*s + 7) + Pkd2*k2*(K*(51 - 60*s) + s*(31 - 22*C) - 15)) - 30*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 42*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(1980*Pk2*b2*k2**4*(2*r + 2*s - 1) - 10*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(74*s - 35) + 55*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 11*f*(k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(9*s - 5) - 3*k1**2*k2**2*(2*Pk2*(4*C*(6*r - 27*s + 19) - 51*r + 48*s - 41) + Pkd2*k2*(C*(96*s - 62) - 63*s + 42)) - 2*k2**4*(2*Pk2*(6*C*(20*r + 16*s + 3) - 66*r - 48*s - 25) + Pkd2*k2*(2*C - 1)*(48*s - 25))) + 66*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 9) - 3*k1**2*k2**2*(4*Pk2*(5*r - 11*s + 9) + Pkd2*k2*(20*s - 17)) - 30*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(1155*d*k2*k3**4) - 2*1j*D1**4*Pk3*ct**3*f*(-3*b1**2*(k1**4*s*(14 - 14*K)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(-2*Pk2*(28*C*(r + s - 1) + 7*K*(5*r + 7*s - 9) - 3*f*(6*r + 6*s - 5) - 42*r - 56*s + 77) + Pkd2*k2*s*(21*K + 27*f - 28)) - 21*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + b1*(126*Pk2*b2*k2**4*(r + s) + 5*f**2*k1**2*(k1**2*(2*Pk2*(12*r + 6*s - 17) + Pkd2*k2*(6*s + 7)) + 9*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + 9*f*(k1**4*(2*Pk2*(8*C*s + K*(3*s - 5) + 4*r - 7*s + 3) + Pkd2*k2*(-8*C*s - 7*K*(s - 1) + 15*s - 7)) + k1**2*k2**2*(Pk2*(4*C*(r + 11*s - 1) + K*(-74*r - 26*s + 6) + 109*r + 24*s - 48) + Pkd2*k2*(-18*C*s - 39*K*s + 23*K + 38*s - 14)) + k2**4*(Pk2*(C*(-12*r + 12*s + 68) - 14*K*(5*r + 4*s - 2) + 23*r - 6*s - 46) + Pkd2*k2*(6*C*s - 14*K*s + 7*K - 3*s))) + 42*g2*(k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(-2*Pk2*(5*r + 7*s - 9) + 3*Pkd2*k2*s) - 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(-18*Pk2*b2*k2**2*(k1**2*(5*r + 5*s + 1) + 7*k2**2*(2*r + 2*s - 1)) - 35*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + 5*f*(2*k1**4*(2*Pk2*(3*C*s - 7*C + 3*r + 5) + 9*Pkd2*k2*(-C*s + C + s - 1)) + k1**2*k2**2*(Pk2*(-4*C*(57*r + 21*s - 23) + 243*r + 108*s - 102) + Pkd2*k2*(C*(58 - 102*s) + 78*s - 47)) + k2**4*(-4*C*Pk2*(51*r + 36*s - 32) + 8*Pk2*(15*r + 9*s - 8) + Pkd2*k2*(9 - 18*C)*(2*s - 1))) - 18*g2*(k1**4*(2*Pk2*(3*s - 5) - 7*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(-74*r - 26*s + 6) + Pkd2*k2*(23 - 39*s)) - 7*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(105*d*k2*k3**4) + 1j*D1**4*Pk3*ct**2*f**2*k1*st**4*(4*Pk2 - Pkd2*k2)*(15*b1*(f*(5*s - 2) + 4*s - 2) + 2*f*(12*s - 5))/(35*d*k3**2) + 1j*D1**4*Pk3*ct**2*f**2*k1*st**4*(33*b1*(k1**2*(4*K - 4)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-8*K*Pk2*(r - 2*s + 1) - 4*K*Pkd2*k2*(2*s - 1) + 2*Pk2*f*(5*r - 1) + 16*Pk2*r + Pkd2*f*k2*(5*s - 2) + 4*Pkd2*k2*s - 2*Pkd2*k2)) + 15*f**2*(44*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(29*s - 10)) + 22*f*(k1**2*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-12*Pk2*(C*(3*r - 8*s + 3) - 5*r + 4*s - 1) - Pkd2*k2*(4*C - 3)*(12*s - 5))) + 264*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(385*d*k3**4) + 1j*D1**4*Pk3*ct**2*f*k1*(21*Pkd2*b1**3*k2**3*s + 6*b1**2*(Pk2*k1**2*s*(-6*f - 28) + 7*Pk2*k2**2*(20*C*(r - 1) + 10*K*r + 4*K*s - 4*K + 12*f*r - 6*f - 21*r + 22) + Pkd2*k1**2*k2*s*(3*f + 14) + 7*Pkd2*k2**3*(8*C*s + 11*K*s - 10*K + 3*f - 6*s + 5)) - 6*b1*(15*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) + 3*f*(k1**2*(6*Pk2*(3*s - 2) + Pkd2*k2*(7 - 11*s)) + k2**2*(2*Pk2*(-2*C*(7*r + 4*s - 2) + r*(7*K - 10) + 4*s + 9) + Pkd2*k2*(C*(28 - 26*s) + 7*K*(3*s - 2) + 13*s - 21))) + 7*k2**2*(4*Pk2*g2*(5*r + 2*s - 2) - Pkd2*b2*k2*s + 2*Pkd2*g2*k2*(11*s - 10))) - 2*f*(5*f*(k1**2*(4*Pk2*(3*s - 4) - 9*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(48*C*r - 28*C - 51*r + 14) + Pkd2*k2*(18*C - 9)*(3*s - 2))) + k2**2*(63*b2 - 126*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(105*d*k2**2*k3**2) - 2*1j*D1**4*Pk3*ct**2*f*st**2*(3*b1**2*k1**2*k2**2*(-2*Pk2*(-7*K*(r - 2*s + 2) + 6*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 6*f + 7)) + b1*k1**2*(f**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(33*s - 20) + 9*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) + f*(-k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 9) + k2**2*(Pk2*(4*C*(5*r - 22*s + 19) + 102*K*s - 72*K - 11*r + 122*s - 97) + Pkd2*k2*(4*C*(11*s - 9) - 51*K*s + 36*K - 64*s + 48))) - 84*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(8*C - 4)*(6*r - 5) - k1**4*(4*Pk2 - Pkd2*k2)*(9*s - 5) + k1**2*k2**2*(Pk2*(132*C*s - 80*C - 9*r - 36*s + 39) + Pkd2*k2*(-66*C*s + 40*C + 15*s - 11))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-3*b2 + 6*g2)*(17*s - 12)))/(35*d*k1*k2**2*k3**2) + 1j*D1**4*Pk3*ct**2*f*st**2*(-462*b1*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 15*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(57*s - 28) + 22*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 22*f**2*(Pk2*k2**6*(12 - 24*C)*(6*r - 5) - k1**4*k2**2*(2*Pk2*(C*(-24*r + 90*s + 2) + 9*b1*(5*r + 5*s + 3) + 33*r - 54*s - 26) - 3*Pkd2*k2*(2*C*(9*s - 4) + 30*b1 - 9*s + 3)) + 3*k1**2*k2**4*(Pk2*(84*C*s + 8*C + 18*b1*(9*r + 5*s - 5) + 81*r - 39) + Pkd2*k2*(-6*C*s - 4*C + 9*b1*(5*s - 2) + 21*s - 7))) + 33*f*k1**2*k2**2*(-12*Pk2*b2*k2**2*(15*r + 15*s - 11) + 3*b1**2*k2**2*(24*Pk2 + 17*Pkd2*k2*s) - 2*b1*(k1**2*(2*Pk2*(2*C*(r - 11*s - 1) + 4*K*r - 7*K*s - 11*r + 13*s + 24) + Pkd2*k2*(24*C*s + K*(s - 4) - 14*s - 5)) + k2**2*(Pk2*(C*(-68*r - 88*s + 92) + 6*K*(4*r + 13*s - 10) + 183*r + 134*s - 111) + Pkd2*k2*(K*(6 - 33*s) + s*(44*C + 9) - 21))) - 4*g2*(2*Pk2*k1**2*(-4*r + 7*s) - 6*Pk2*k2**2*(4*r + 13*s - 10) - Pkd2*k1**2*k2*(s - 4) + 3*Pkd2*k2**3*(11*s - 2))))/(1155*d*k1*k2**2*k3**4) - 1j*D1**4*Pk3*ct**2*f*(42*b1*k1**2*k2**2*(Pk2*b1**2*k2**2*(r + s - 1) - 2*Pk2*b2*k2**2*(r + s) + b1*(k1**2*(2*Pk2*(4*C*(r + s - 1) - 7*K*r - 4*K*s + 9*r + 6*s + 4) + Pkd2*k2*s*(7 - 9*K)) + k2**2*(Pk2*(16*C*(r + s - 1) - 6*K*(r + 4) + 7*r + 22) + Pkd2*k2*s*(5 - 9*K))) + 2*g2*(2*Pk2*k1**2*(7*r + 4*s) + 6*Pk2*k2**2*(r + 4) + 9*Pkd2*k1**2*k2*s + 9*Pkd2*k2**3*s)) + 35*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) - 5*f**2*(3*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) + 2*k1**4*k2**2*(2*Pk2*(6*C*(5*r + 4*s - 2) + 9*b1*r - 27*b1*s - 33*r - 24*s + 16) + 9*Pkd2*k2*(3*b1 + (4*C - 3)*(s - 1))) + 2*k1**2*k2**4*(Pk2*(4*C*(66*r + 54*s - 43) - 159*r - 108*s + 86) + Pkd2*k2*(18*C - 9)*(3*s - 2))) + 9*f*k2**2*(b1**2*k1**2*(3*k1**2*(4*Pk2*(3*r + 3*s - 1) + Pkd2*k2*s) + 7*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) - 2*b1*(Pk2*k2**4*(4*C - 2)*(3*r - 5) + k1**4*(2*Pk2*(2*C*(14*r + 8*s - 7) + K*(11*r + 8*s - 4) - 54*r - 37*s + 28) + Pkd2*k2*(14*K*(s - 1) + s*(30*C - 33) + 7)) + k1**2*k2**2*(2*Pk2*(6*C*(7*r + 2*s - 4) + 7*K*(7*r + 6*s - 4) - 52*r - 15*s + 17) + Pkd2*k2*(7*K*(3*s - 2) + s*(30*C - 22)))) - 4*k1**2*(Pk2*b2*k1**2*(4*r + 4*s - 2) + 7*Pk2*b2*k2**2*(3*r + 3*s - 2) - 2*g2*k1**2*(Pk2*(11*r + 8*s - 4) + 7*Pkd2*k2*(s - 1)) - 7*g2*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2)))))/(105*d*k1*k2**2*k3**4) - 2*1j*D1**4*Pk3*ct*f**4*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(73*s - 21)/(231*d*k3**4) + 2*1j*D1**4*Pk3*ct*f**2*st**4*(3*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(12*s - 5) + 4*s - 2) + 5*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Pk2*f*(r - 1) - 2*Pk2*r)) + 2*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + f*k2**2*(-2*Pk2*(2*C*(12*s - 5) + 3*r - 12*s + 5) + Pkd2*k2*(2*C - 1)*(12*s - 5)) + k2**2*(-2*Pk2 + Pkd2*k2)*(15*b2 - 30*g2)*(2*s - 1))/(35*d*k2*k3**2) + 2*1j*D1**4*Pk3*ct*f**2*st**4*(f**2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(78*s - 25) + 55*k1**2*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 11*f*(k1**2*k2**2*(Pk2*(-24*C*r + 48*C*s - 4*C + 24*b1*(3*r + s - 1) + 36*r - 24*s - 6) + Pkd2*k2*(3*b1*(8*s - 5) + (6 - 8*C)*(3*s - 1))) + k2**4*(Pk2*(-4*C*(18*r + 12*s - 7) - 15*b1*(r - 1) + 42*r + 24*s - 14) - Pkd2*k2*(2*C - 1)*(12*s - 5))) - 33*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(385*d*k2*k3**4) + 2*1j*D1**4*Pk3*ct*f*st**2*(3*b1**2*(21*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(-7*K*s + 7*K + 22*f*s + 9*f + 21*s - 7) - Pkd2*k2*(22*f*s + 9*f + 14*s))) + 3*b1*(28*Pk2*g2*k1**2*(s - 1) + 21*Pkd2*b2*k2**3*s + 9*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(4*C*(s + 3) - 22*K*s + 18*K + 3*r - 16*s + 20) + Pkd2*k2*(K*(11*s - 9) + 9*s - 14)) + k2**2*(2*Pk2*(2*C*(r - 4) - 21*K*r + 20*r + 4) + 3*Pkd2*k2*(6*C - 14*K*s + 7*K - 3))) - 42*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-3*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(11*s - 9) + 21*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*k1**2*(Pk2*(-12*C*(9*s - 5) + 3*r + 18*s + 14) + 3*Pkd2*k2*(2*C*(9*s - 5) - 1)) - 3*f*k2**2*(4*Pk2*(21*C*r - 10*C - 15*r + 5) + Pkd2*k2*(18*C - 9)*(2*s - 1)) + 6*g2*k1**2*(2*Pk2 - Pkd2*k2)*(11*s - 9) + 126*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))))/(105*d*k2*k3**2) - 2*1j*D1**4*Pk3*ct*f*(7*b1**3*k2*(5*Pk2*k2*(r - 1) + 2*Pkd2*k1**2*s) - 7*b1**2*(4*Pk2*k1**2*(3*r + s*(2*C - 1)) + 2*Pk2*k2**2*(4*C*(4*r + s - 4) - 5*K - 12*r - 2*s + 12) + Pkd2*k1**2*k2*s*(5 - 2*K) + Pkd2*k2**3*(4*C*s - 5*K - 2*s) + 3*f*k1**2*(Pk2*(6*r - 4) + Pkd2*k2*(2*s + 1))) + b1*(-3*f*k1**2*(Pk2*(31*r + 8*s - 12) + Pkd2*k2*(-8*C*s - 7*K*s + 7*K + 11*s)) + f*k2**2*(6*C - 3)*(6*Pk2*(2*r - 1) + 7*Pkd2*k2) + 7*k2*(b2*(10*Pk2*k2*(r + s) + 2*Pkd2*k1**2*s + 5*Pkd2*k2**2*s) - 2*g2*(10*Pk2*k2 + 2*Pkd2*k1**2*s + 5*Pkd2*k2**2))) + 3*f*k1**2*(-5*Pk2*f*r + 7*Pkd2*b2*k2*(s - 1) + Pkd2*f*k2*(10*C - 5)*(s - 1) - 14*Pkd2*g2*k2*(s - 1)))/(35*d*k2*k3**2) + 2*1j*D1**4*Pk3*ct*f*st**2*(3*b1**2*(k1**2*k2**2*(2*Pk2*(7*K*(s - 2) + f*(22*r + 22*s - 9) + 28*r + 21*s + 7) + Pkd2*k2*s*(-28*K + 33*f + 14)) - 21*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) - 3*b1*(f**2*k1**2*(k1**2*(2*Pk2*(6*r - 12*s - 7) + Pkd2*k2*(18*s + 5)) + 9*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + f*(2*Pk2*k1**4*(-K*(s + 3) + r + 2*s + 6) + k1**2*k2**2*(Pk2*(4*C*(14*r + s - 8) - 2*K*(19*r + s + 17) + 11*r + 24*s + 10) + Pkd2*k2*(K*(19 - 31*s) + s*(48*C - 15) - 14)) + k2**4*(Pk2*(C*(-4*r + 44*s + 52) - 42*K*(5*r + 4*s - 2) + 45*r - 22*s - 30) + Pkd2*k2*(K*(21 - 42*s) + s*(22*C - 11)))) - 14*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(-6*Pk2*b2*k2**2*(k1**2*(5*r + 5*s - 13) - 21*k2**2*(2*r + 2*s - 1)) + 15*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*(-2*Pk2*k1**4*(-2*C*(3*s + 5) + 3*r + 9*s + 11) + k1**2*k2**2*(Pk2*(4*C*(21*r + 9*s + 17) - 153*r - 90*s - 6) + 3*Pkd2*k2*(2*C*(9*s - 7) - 18*s + 13)) + 3*k2**4*(4*Pk2*(C*(57*r + 36*s - 28) - 33*r - 18*s + 14) + Pkd2*k2*(18*C - 9)*(2*s - 1))) - 6*g2*(2*Pk2*k1**4*(s + 3) + k1**2*k2**2*(2*Pk2*(19*r + s + 17) + Pkd2*k2*(31*s - 19)) + 21*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(105*d*k2*k3**4) + 2*1j*D1**4*Pk3*ct*f*(56*Pk2*b1**3*k1**2*k2**2*(r + s - 1) - b1**2*(28*Pk2*k1**4*(r - s*(K - 2)) + 3*f*k1**2*(4*k1**2*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s) + 7*k2**2*(Pk2*(13*r + 10*s - 7) + 3*Pkd2*k2*s)) + 7*k1**2*k2**2*(2*Pk2*(8*C*(r + s - 1) - 23*K*r - 22*K*s + 10*r + 6*s + 6) + Pkd2*k2*s*(5 - 12*K)) + 7*k2**4*(-5*K*Pkd2*k2*s + Pk2*(8*C*(r + s - 1) - 10*K*(2*r + 2*s + 1) + r - 4*s + 4))) + b1*(14*Pk2*b2*k2**2*(6*k1**2 + 5*k2**2)*(r + s) + 15*f**2*k1**4*(Pk2*(5*r - 3) + Pkd2*k2*(2*s + 1)) + 3*f*(-4*Pk2*k1**4*(2*r + s*(6 - 4*C) - 1) + k1**2*k2**2*(Pk2*(4*C*(43*r + 38*s - 18) + 28*K*(r + s - 1) - 145*r - 112*s + 48) + Pkd2*k2*(7*K*(s - 1) + s*(36*C - 25))) + k2**4*(Pk2*(4*C*(20*r + 14*s - 3) - 47*r - 28*s + 6) + Pkd2*k2*s*(14*C - 7))) - 14*g2*(4*Pk2*k1**4*s + 2*Pk2*k1**2*k2**2*(23*r + 22*s) + 10*Pk2*k2**4*(2*r + 2*s + 1) + 12*Pkd2*k1**2*k2**3*s + 5*Pkd2*k2**5*s)) + 3*f*k1**2*k2**2*(14*Pk2*b2*(r + s - 1) + 5*f*(Pk2*(8*C*(r + s - 1) - 5*r - 4*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1)) - 14*g2*(4*Pk2*(r + s - 1) + Pkd2*k2*(s - 1))))/(35*d*k2*k3**4) + 2*1j*D1**4*Pk3*f**3*k1*st**6*(11*b1*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(22*Pk2*k2**2*(r - 1) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(231*d*k3**4) - 1j*D1**4*Pk3*f**2*st**4*(6*b1**2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + b1*k1**2*(f*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 3*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) - 6*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) + 2*k2**2*(Pk2*f*k2**2*(4*C - 2)*(3*r - 1) + 6*b2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + f*k1**2*(Pk2*(24*C*s - 8*C + 6*r - 12*s + 1) + 2*Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) - 12*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(35*d*k1*k2**2*k3**2) + 1j*D1**4*Pk3*f**2*st**4*(f**2*(10*k1**6*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 11*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 11*f*(4*Pk2*k2**6*(C*(2 - 6*r) + 3*r - 1) + 3*b1*(k1**4*k2**2*(Pk2*(-8*r - 8*s + 4) + 2*Pkd2*k2) + k1**2*k2**4*(2*Pk2*(9*r + 5*s - 5) + Pkd2*k2*(5*s - 2))) + 2*k1**2*k2**4*(3*Pk2*(8*C*(2*r + s - 1) - 10*r - 4*s + 5) + Pkd2*k2*(4*C - 2)*(3*s - 1))) + 66*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1))))/(385*d*k1*k2**2*k3**4) + 2*1j*D1**4*Pk3*f*k1*st**2*(21*Pkd2*b1**3*k2**3*s + 3*b1**2*(24*Pk2*f*k1**2*s - 7*Pk2*k2**2*(2*K*(s - 1) + f*(2 - 4*r) + 2*r + 1) - 12*Pkd2*f*k1**2*k2*s + 7*Pkd2*k2**3*(2*K*s + f)) - 3*b1*(3*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) - f*(Pk2*k1**2*(s + 3) + k2**2*(Pk2*(4*C*(s + 3) - 14*K*r + 9*r - 2*s - 3) + Pkd2*k2*(-7*K*(3*s - 2) + s*(24*C - 12)))) + 14*k2**2*(-Pkd2*b2*k2*s + 2*g2*(-Pk2*s + Pk2 + Pkd2*k2*s))) + f*(f*(Pk2*k1**2*(3*s + 5) + k2**2*(Pk2*(-60*C*r + 20*C + 57*r - 10) - Pkd2*k2*(18*C - 9)*(3*s - 2))) + k2**2*(-21*b2 + 42*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(105*d*k2**2*k3**2) - 1j*D1**4*Pk3*f*st**2*(42*b1*k1**2*k2**4*(2*K*b1*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) + 2*Pk2*b1**2*(r + s - 1) - Pk2*b1*(2*r + s) + 6*Pk2*b2*(r + s) - 4*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s)) + 5*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) + 2*f**2*(15*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) + k1**4*k2**2*(Pk2*(-12*C*(r + 2*s + 2) - 18*b1*r + 54*b1*s + 6*r + 15*s + 17) - 27*Pkd2*b1*k2) + k1**2*k2**4*(Pk2*(-4*C*(69*r + 54*s - 41) + 165*r + 108*s - 82) + Pkd2*k2*(9 - 18*C)*(3*s - 2))) - 3*f*k2**2*(b1**2*k1**2*(4*k1**2*(2*Pk2*(5*r + 5*s - 4) + 9*Pkd2*k2*s) - 7*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) + 2*b1*(Pk2*k1**4*(2*K*(r + 2*s + 6) - s - 3) + Pk2*k2**4*(12*C - 6)*(2*r - 1) + k1**2*k2**2*(Pk2*(-4*C*(24*r + 23*s - 9) + 14*K*(7*r + 6*s - 4) + 39*r + 45*s - 24) + Pkd2*k2*(7*K*(3*s - 2) + s*(12 - 24*C)))) + 4*k1**2*(Pk2*b2*k1**2*(r + s + 3) + 7*Pk2*b2*k2**2*(3*r + 3*s - 2) - 2*Pk2*g2*k1**2*(r + 2*s + 6) - 7*g2*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2)))))/(105*d*k1*k2**2*k3**4)
        
        return np.sqrt((4*np.pi)/3)*(perm12+perm13+perm23)
    
    
    def l1m1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 8*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f**2*k2**3*st**5*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k2*st**3*(-7*b1**2*k2**2*(r + s) + b1*f*(k1**2*(r + s + 3) + 6*k2**2*(2*r + 2*s - 1)) + f**2*k2**2*(2*r + 2*s - 1))/(35*d*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k2*st*(7*b1**2*(2*k1**2 + 5*k2**2)*(r + s) + b1*f*(2*k1**2*(5*r + 5*s - 6) + 7*k2**2*(r + s)) + 3*f**2*k1**2*(r + s - 1))/(105*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*b1*f*k1*k2*st*(21*b1*r + f*(9*r - 8))/(105*d*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f**2*k1*k2*st**3*(9*b1*r + f*(3*r - 4))/(105*d*k3**2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**6*f**2*k2**3*st*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(39*r + 39*s - 14))/(315*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**5*f**2*k2**2*st*(-9*b1*k1**2*(2*C*(3*r + 3*s - 5) - 16*r - 16*s + 15) + 45*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(-6*C*(3*r + 3*s - 1) + 57*r + 57*s - 20) + f*k2**2*(39*r + 39*s - 14))/(315*d*k1*k3**4) - 16*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f**2*k2**3*st**3*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 4))/(105*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f*k2*st*(-126*b1**2*k2**2*(C - 1)*(r + s) + 3*b1*f*(k1**2*(C*(46*r + 46*s - 2) - 37*r - 37*s - 13) + k2**2*(2*C*(68*r + 68*s - 41) - 67*r - 67*s + 37)) + f**2*(k1**2*(36*C*(2*r + 2*s - 1) - 63*r - 63*s + 33) + k2**2*(2*C*(93*r + 93*s - 41) - 99*r - 99*s + 51)))/(315*d*k3**4) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f**2*k2**2*st**3*(b1*k1**2*(-3*C*(3*r + 3*s - 5) + 39*r + 39*s - 30) + 15*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(C*(-9*r - 9*s + 3) + 18*r + 18*s - 7) + f*k2**2*(9*r + 9*s - 4))/(105*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f*st*(21*b1**2*k2**2*(r + s)*(k1**2*(8*C - 5) + 3*k2**2) + 3*b1*f*(k1**4*(2*C*(9*r + 9*s - 1) - 41*r - 41*s + 3) + k1**2*k2**2*(2*C*(57*r + 57*s - 53) - 157*r - 157*s + 103) - 2*k2**4*(19*r + 19*s - 13)) + f**2*(2*k1**4*(C*(15*r + 15*s - 7) - 33*r - 33*s + 16) + 3*k1**2*k2**2*(C*(42*r + 42*s - 26) - 66*r - 66*s + 39) - 27*k2**4*(2*r + 2*s - 1)))/(315*d*k1*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f**2*k2**3*st**5*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*k2*st**3*(-42*b1**2*k2**2*(C - 1)*(r + s) + 3*b1*f*(k1**2*(2*C*(r + s + 3) + r + s - 11) + k2**2*(32*C*(2*r + 2*s - 1) - 21*r - 21*s + 7)) + f**2*(k1**2*(9*r + 9*s - 3) + k2**2*(C*(48*r + 48*s - 22) - 3*r - 3*s + 3)))/(105*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*st*(-42*b1**2*k2**2*(r + s)*(k1**2*(2*C - 4) + k2**2*(8*C - 7)) + 3*b1*f*(k1**4*(9*r + 9*s - 1) + k1**2*k2**2*(C*(26*r + 26*s + 22) + 77*r + 77*s - 63) + 2*k2**4*(C*(31*r + 31*s - 26) + 31*r + 31*s - 19)) + f**2*(k1**4*(15*r + 15*s - 7) + k1**2*k2**2*(18*C*(3*r + 3*s - 1) + 87*r + 87*s - 61) + 18*k2**4*(C*(6*r + 6*s - 3) + 3*r + 3*s - 2)))/(315*d*k2*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f**2*k2**2*st**5*(k1**2 + k2**2)*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st**3*(7*b1**2*k2**2*(k1**2 + k2**2)*(r + s) - b1*f*(k1**4*(r + s + 3) + k1**2*k2**2*(-2*C*(3*r + 3*s - 5) + 13*r + 13*s - 3) + 6*k2**4*(2*r + 2*s - 1)) + f**2*k2**2*(k1**2*(C*(6*r + 6*s - 2) - 2*r - 2*s + 1) + k2**2*(-2*r - 2*s + 1)))/(35*d*k1*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st*(21*b1**2*(r + s)*(2*k1**4 + k1**2*k2**2*(8*C + 7) + 5*k2**4) + 3*b1*f*(2*k1**4*(C*(9*r + 9*s - 1) + 5*r + 5*s - 6) + k1**2*k2**2*(C*(96*r + 96*s - 76) + 17*r + 17*s - 12) + 7*k2**4*(r + s)) + f**2*k1**2*(k1**2*(2*C*(15*r + 15*s - 7) + 9*r + 9*s - 9) + 9*k2**2*(4*C*(3*r + 3*s - 2) + r + s - 1)))/(315*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**6*f**2*k2*st*(C - 1)*(-4*Pk2 + Pkd2*k2)*(45*b1*(2*s - 1) + f*(39*s - 25))/(315*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**3*st*(4*Pk2 - Pkd2*k2)*(11*b1*(9*s - 4) + f*(57*s - 28))/(231*d*k1) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**2*st*(9*b1*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(9*s - 8) - 28*s + 21) + 9*b1*k2**2*(Pk2*(-r*(64*C - 64) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(C*(78*s - 80) - 117*s + 105) + f*k2**2*(-2*Pk2*(6*C*(21*r + 5) - 126*r + 39*s - 55) + Pkd2*k2*(39*s - 25)))/(315*d*k1*k3**2) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**2*k2*st**3*(C - 1)*(-4*Pk2 + Pkd2*k2)*(15*b1*(2*s - 1) + f*(9*s - 5))/(105*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*st*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-7*K*s + 7*K + 5*f*(2*s - 1) + 7*s - 7) - 33*b1*(f**2*(-10*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(39*s - 25)) - f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 9) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 5*f**3*(-15*Pk2*k2**2*(3*r + 2) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(52*s - 35)) - 66*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 9))/(3465*d*k1**2*k2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*st*(-126*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) + 3*b1*f*(66*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(4*s - 9) - 35*s + 42) + k1**2*k2**2*(-4*C*(Pk2*(33*r + 50*s - 27) + 2*Pkd2*k2*(9 - 17*s)) + 162*Pk2*r + 26*Pk2*s - 49*Pkd2*k2*s + 18*Pkd2*k2)) + f**2*(Pk2*k2**4*(87*r + 19) + k1**4*(4*Pk2 - Pkd2*k2)*(6*C*(3*s - 5) - 57*s + 70) + k1**2*k2**2*(Pk2*(-4*C*(48*r + 63*s - 25) + 219*r + 18*s + 131) + Pkd2*k2*(2*C*(93*s - 52) - 69*s + 14))))/(315*d*k1**2*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**3*st**3*(4*Pk2 - Pkd2*k2)*(11*b1*(9*s - 4) + f*(47*s - 20))/(231*d*k1) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**2*st**3*(3*b1*k1**2*(4*Pk2 - Pkd2*k2)*(C*(9*s - 8) - 19*s + 13) + 3*b1*k2**2*(Pk2*(-r*(52*C - 52) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(C*(15*s - 8) - 24*s + 13) + f*k2**2*(Pk2*(-36*C*r + 4*C + 36*r - 18*s + 6) + Pkd2*k2*(9*s - 5)))/(105*d*k1*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st*(264*Pk2*f*g2*k2**2*(8*r + 3) - 99*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(9*s - 8) + 14*s - 14) - 2*k2**2*(-2*Pk2*(f*(9*s - 4) + 7*r*(2*K - 2) + 7*s - 7) + Pkd2*k2*(9*f*s - 4*f + 7*s - 7))) - 22*b1*(-504*Pk2*g2*k2**2*r + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(39*s - 40) + k2**2*(2*Pk2*(18*r - 51*s - 4) + Pkd2*k2*(51*s - 16))) + 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 9) + k2**2*(2*K*Pk2*(8*r + 3) + 8*Pk2*(-2*r + s - 3) + Pkd2*k2*(9 - 4*s)))) - 5*f**3*(8*Pk2*k2**2*(4*r - 55*s + 10) + 44*Pkd2*k2**3*(5*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(59*s - 56)))/(3465*d*k1*k2**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st*(-21*b1**2*k2**2*(-Pk2*k1**2*s*(4*C + 2) + Pk2*k2**2*r*(24 - 24*C) + Pkd2*k1**2*k2*s*(2*C + 1) + 3*Pkd2*k2**3*s) + 3*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 9) + k1**2*k2**2*(Pk2*(-4*C*(r - 39*s + 42) + 19*r - 98*s + 87) + 4*Pkd2*k2*(C*(26 - 33*s) + 28*s - 17)) + k2**4*(Pk2*(-136*C*r + 12*C + 97*r + 18*s - 21) + Pkd2*k2*(38*s - 21))) + f**2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(Pk2*(4*C*(3*r + 48*s - 65) + 21*r - 96*s + 43) + Pkd2*k2*(-2*C*(93*s - 76) + 153*s - 84)) + k2**4*(Pk2*(-16*C*(12*r + 5) + 159*r + 30*s - 33) + 27*Pkd2*k2*(2*s - 1))))/(315*d*k1*k2**2*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**2*k2*st**5*(C - 1)*(-4*Pk2 + Pkd2*k2)*(9*b1*(2*s - 1) + f*(3*s - 1))/(63*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-7*K*s + 7*K + 10*f*(2*s - 1) + 7*s - 7) + 33*b1*k1**2*(4*Pk2 - Pkd2*k2)*(2*f**2*(9*s - 5) + f*(-2*K*s + K + 2*s - 1) + 14*g2*(s - 1)) + 2*f**3*(5*Pk2*k2**2*(3*r + 2) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(56*s - 25)) + 66*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1))/(1155*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st*(231*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 11*b1**2*(Pk2*k2**2*r*(-12*f - 63) + k1**2*(Pk2*f*(21*r - 52*s + 24) - 7*Pk2*(K*(10 - 8*s) + 3*r - 4*s + 2) + 2*Pkd2*f*k2*(13*s - 6) + 7*Pkd2*k2*(K*(8 - 7*s) + s - 2))) + 11*b1*(21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + f**2*(-2*Pk2*k2**2*(3*r + 2) + k1**2*(Pk2*(24*r - 90*s + 34) + Pkd2*k2*(45*s - 22))) + f*(-Pk2*k2**2*(12*r + 1) + k1**2*(Pk2*(4*K*s - 30*K + 6*r + 12*s - 23) + Pkd2*k2*(-11*K*s + 16*K + 3*s + 2))) + 14*g2*k1**2*(Pk2*(10 - 8*s) + Pkd2*k2*(7*s - 8))) + f*k1**2*(11*b2*(2*Pk2 - Pkd2*k2)*(4*s - 9) + 5*f**2*(Pk2*(13*r - 88*s + 38) + 22*Pkd2*k2*(2*s - 1)) + 22*g2*(Pk2*(30 - 4*s) + Pkd2*k2*(11*s - 16))))/(1155*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(42*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) - 3*b1*f*(32*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(C*(4*s - 2) - 13*s + 10) + k1**2*k2**2*(-2*C*(2*Pk2*(5*r + 26*s - 14) + Pkd2*k2*(17 - 32*s)) + 40*Pk2*r + 6*Pk2*s + 3*Pkd2*k2*(2 - 5*s))) + f**2*(6*Pk2*k2**4*(1 - 3*r) - k1**4*(4*Pk2 - Pkd2*k2)*(C*(6*s - 2) - 21*s + 10) + k1**2*k2**2*(6*Pk2*(4*C*(2*r + 3*s - 3) - 9*r + 5*s + 1) + Pkd2*k2*(C*(26 - 48*s) - 3*s + 2))))/(105*d*k1**2*k2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st*(-21*b1**2*(-9*Pk2*k2**4*r - k1**4*s*(2*C - 1)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(-3*Pk2*(r*(4*C - 3) + s*(4*C - 4)) + Pkd2*k2*s*(11 - 16*C))) + 3*b1*f*(Pk2*k2**4*(1 - 30*r) + k1**4*(Pk2*(4*C*(4*s + 15) - 24*r + 19*s - 70) + Pkd2*k2*(2*C*(5*s - 16) - 41*s + 42)) + k1**2*k2**2*(3*Pk2*(r*(28*C - 74) + s*(12*C - 21) + 9) + Pkd2*k2*(C*(42 - 62*s) - 53*s + 28))) + f**2*(-54*Pk2*k2**4*r + k1**4*(Pk2*(-12*C*s + 100*C - 33*r + 39*s - 83) + 6*Pkd2*k2*(6*C*s - 8*C - 12*s + 9)) + k1**2*k2**2*(Pk2*(24*C*(3*r + 5) - 273*r - 45*s + 13) - 18*Pkd2*k2*(C*(6*s - 3) + 3*s - 2))))/(315*d*k1**2*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**3*st**5*(4*Pk2 - Pkd2*k2)*(11*b1*(9*s - 4) + f*(37*s - 12))/(231*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**5*(9*b1*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 9*b1*k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + f*k2**2*(2*Pk2*(C*(6*r - 2) - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s)))/(63*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(264*Pk2*f*g2*k2**2*(1 - 2*r) + 33*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(9*s - 8) + 14*s - 14) - 2*k2**2*(-2*Pk2*(f*(9*s - 4) + 7*r*(K - 1) + 7*s - 7) + Pkd2*k2*(9*f*s - 4*f + 7*s - 7))) + 22*b1*(-84*Pk2*g2*k2**2*r + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 8) + k2**2*(Pk2*(36*r - 30*s + 8) + Pkd2*k2*(15*s - 8))) + 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(4*K*Pk2*r - 2*K*Pk2 - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + f**3*(8*Pk2*k2**2*(28*r - 55*s + 26) + 44*Pkd2*k2**3*(5*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(21*s - 8)))/(1155*d*k1*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st*(21*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - 3*b1**2*(k1**2*(Pk2*(8*f*(9*s - 7) + 70*s - 98) + 2*Pkd2*k2*(-2*f*(9*s - 7) - 28*s + 35)) + k2**2*(-8*Pk2*f*(10*r - 3) + 14*Pk2*(K*(8*r + 2) - 8*r - 3*s + 1) + Pkd2*k2*(f*(28 - 81*s) - 56*s + 70))) - 3*b1*(-56*Pk2*g2*k2**2*(4*r + 1) + f**2*(k1**2*(2*Pk2 - Pkd2*k2)*(31*s - 24) + 4*k2**2*(-6*Pk2*r + 2*Pk2 - 9*Pkd2*k2*s + 3*Pkd2*k2)) + 2*f*(k1**2*(Pk2*(5*s - 13) - 7*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(4*K*(r + 3) - 24*r - 9*s + 13) - 7*Pkd2*k2*(s - 1)))) + 2*f*(6*Pk2*k2**2*(b2*(5*r - 6) + 4*g2*(r + 3)) - 5*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2)))/(315*d*k1*k2**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(-21*b1**2*k2**2*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + 3*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(r + 3*s - 5) - 3*r - 2*s + 17) + 2*Pkd2*k2*(C*(8 - 9*s) + 5*s - 3)) + k2**4*(Pk2*(-48*C*r - 4*C + 47*r + 6*s + 1) + Pkd2*k2*(12*s - 7))) + f**2*(k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(3*r + 12*s - 11) - 15*r + 12*s + 15) + Pkd2*k2*(C*(16 - 30*s) + 3*s - 2)) + k2**4*(Pk2*(-16*C + 15*r + 6*s + 7) + 3*Pkd2*k2*(2*s - 1))))/(105*d*k1*k2**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st*(-21*b1**2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) - k1**2*k2**2*(Pk2*r*(4*C + 7) + Pk2*s*(15 - 12*C) + Pkd2*k2*s*(2*C + 4)) - k2**4*(Pk2*r*(25 - 20*C) + 13*Pk2*s + 5*Pkd2*k2*s)) + 3*b1*f*(k1**4*(Pk2*(7*s + 13) + Pkd2*k2*(s - 7)) + k1**2*k2**2*(Pk2*(4*C*(13*r - 9*s - 3) + 67*r + 54*s - 3) + Pkd2*k2*(C*(78*s - 56) + 8*s - 7)) + k2**4*(Pk2*(-8*C*(r + 3) + 73*r + 23*s + 2) + 7*Pkd2*k2*s)) + f**2*(54*Pk2*k2**4*r + k1**4*(Pk2*(19 - 3*s) + 9*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(8*C*(6*r - 5) + 90*r + 15*s + 1) + 9*Pkd2*k2*(4*C*(3*s - 2) + s - 1))))/(315*d*k1*k2**2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*k2*st**5*(-18*b1*(C*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - Pk2*r*(k1**2 + k2**2)) - f*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2)))/(63*d*k1**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**5*(99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 33*b1*f*(2*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + f**2*(5*Pk2*k2**2*(3*r + 2) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(693*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(231*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 33*b1**2*(Pk2*k2**2*r*(8*f - 7) + k1**2*(Pk2*(14*K*(s - 1) + f*(7*r - 12*s + 12) - 7*r + 14*s - 14) + Pkd2*k2*(s - 1)*(-7*K + 6*f - 7))) + 11*b1*(21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + f**2*(2*Pk2*k2**2*(3*r + 2) + k1**2*(2*Pk2*(6*r - 9*s + 7) + Pkd2*k2*(9*s - 8))) + 3*f*(Pk2*k2**2*(1 - 2*r) + k1**2*(Pk2*(4*K*s - 2*K - 2*r + 4*s - 1) - Pkd2*k2*(K + 1)*(2*s - 1))) - 42*g2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + f*k1**2*(33*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + f**2*(Pk2*(25*r - 88*s + 46) + 22*Pkd2*k2*(2*s - 1)) - 66*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(1155*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st*(21*Pkd2*f*k1**2*k2*(b2 - 2*g2)*(s - 1) + 21*b1**3*(2*Pk2*k2**2*r + k1**2*(5*Pk2*r + 4*Pkd2*k2*s)) + 3*b1**2*(Pk2*k2**2*(f*(3*r + 2) + 28*r + 7) + k1**2*(Pk2*(6*f*(4*r - 1) + 28*r + 7) + Pkd2*k2*(f*(22*s - 7) + (7*K + 7)*(4*s - 5)))) + b1*(Pkd2*k1**2*k2*(21*b2 - 42*g2)*(4*s - 5) + f**2*k1**2*(Pk2*(15*r - 2) + 9*Pkd2*k2*(3*s - 1)) + 21*f*(Pk2*k2**2*r + k1**2*(Pk2*r + Pkd2*k2*(K + 1)*(s - 1)))))/(315*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(-21*b1**2*(Pk2*k2**4*r + k1**2*k2**2*(2*C*Pkd2*k2*s + Pk2*r)) + 3*b1*f*(Pk2*k2**4*(12*r + 1) + k1**4*(2*C*Pkd2*k2*(1 - 2*s) + Pk2*(8*C*s - 4*C - 2*r + 3*s + 2)) + k1**2*k2**2*(2*C*Pkd2*k2*(12*s - 7) + Pk2*(28*C*r + 10*r + 3*s + 3))) + f**2*(6*Pk2*k2**4*r + k1**4*(2*C*Pkd2*k2*(1 - 3*s) + Pk2*(12*C*s - 4*C - 3*r + 3*s + 3)) + k1**2*k2**2*(8*C*Pk2*(3*r - 1) + 6*C*Pkd2*k2*(2*s - 1) + 3*Pk2*(r + s + 1))))/(105*d*k1**2*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st*(-7*b1**2*(-5*Pk2*k2**4*r + k1**4*(2*C*Pkd2*k2*s + Pk2*(r - 3*s)) - k1**2*k2**2*(10*C*Pkd2*k2*s + Pk2*r*(20*C + 4) + Pk2*s*(20*C + 3))) + b1*f*(7*Pk2*k2**4*r + k1**4*(2*C*Pkd2*k2*(s - 7) + Pk2*(r + 9*s + 3)) + k1**2*k2**2*(14*C*Pkd2*k2*s + Pk2*(4*C*(12*r + 7*s - 6) + 8*r + 9*s + 3))) + 3*f**2*k1**2*(2*C*Pkd2*k1**2*k2*(s - 1) + Pk2*r*(k1**2 + k2**2)))/(105*d*k1**2*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*b1*f*st*(63*b1**2*r*(k1**2 + k2**2) + 3*b1*f*(2*k1**2*(9*r - 4) + k2**2*(9*r - 8)) + f**2*k1**2*(15*r - 8))/(315*d*k1*k2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**5*f**2*k2**2*st*(C - 1)*(27*b1*r + f*(15*r - 8))/(315*d*k3**2) + 5*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**3*k2*st*(33*b1*r + f*(21*r - 8))/(693*d*k1) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**2*k2*st*(27*b1*r + f*(15*r - 8))*(k1**2*(4 - 3*C) + k2**2)/(315*d*k1*k3**2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**2*k2**2*st**3*(C - 1)*(9*b1*r + f*(3*r - 4))/(105*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*st*(99*b1**2*r*(-7*K + 6*f + 7) + 11*b1*(2*f**2*(45*r - 8) - 3*f*(K - 1)*(9*r - 8) + 126*g2*r) + 20*f**3*(21*r - 8) + 66*f*g2*(9*r - 8))/(3465*d) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*st*(126*b1**2*k2**2*r*(C - 1) - 3*b1*f*(k1**2*r*(45 - 18*C) + k2**2*(2*C*(9*r + 8) + 45*r - 16)) + f**2*(15*r - 8)*(k1**2*(2*C - 5) - k2**2*(4*C + 3)))/(315*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**3*k2*st**3*(11*b1*r + f*(5*r - 4))/(77*d*k1) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**2*k2*st**3*(9*b1*r + f*(3*r - 4))*(-k1**2*(C - 2) + k2**2)/(105*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st*(33*b1**2*r*(k1**2*(9*f + 14) + k2**2*(18*f + 14)) + 22*b1*f*(k1**2*(15*f*r - 4*f + 9*r - 8) + k2**2*(15*f*r - 8*f + 9*r - 8)) + 5*f**3*k1**2*(21*r - 8))/(1155*d*k1*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st*(63*b1**2*k2**2*r*(k1**2*(3 - 2*C) + k2**2) + 3*b1*f*(9*k1**4*r + 4*k1**2*k2**2*(C*(9*r + 4) + 9*r - 6) + k2**4*(9*r - 8)) + f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(15*r - 8))/(315*d*k1*k2*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(99*b1**2*r + 11*b1*f*(9*r - 4) + 6*f**2*(5*r - 4))/(1155*d) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(k1**2 + k2**2*(4*C + 1))*(9*b1*r + f*(3*r - 4))/(105*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st*(21*b1**3*r + b1**2*(4*f*(9*r - 2) + r*(21*K + 21)) + b1*(f**2*(15*r - 8) + f*(K + 1)*(9*r - 8) + r*(21*b2 - 42*g2)) + f*(b2 - 2*g2)*(9*r - 8))/(105*d) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st*(2*C*f**2*k1**2*(15*r - 8) + 63*b1**2*r*(k1**2 + k2**2*(2*C + 1)) + 3*b1*f*(k1**2*(18*C*r + 9*r - 8) + k2**2*(2*C + 1)*(9*r - 8)))/(315*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**3*k2*st**5*(33*b1*r + f*(9*r - 16))/(693*d*k1) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**2*st**3*(99*b1**2*r*(k1**2 + 2*k2**2) + 22*b1*f*(k1**2*(3*r - 2) + k2**2*(3*r - 4)) + 3*f**2*k1**2*(5*r - 4))/(1155*d*k1*k2)
        perm13 = -4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**3*f*st*(21*b1*(s - 1) + f*(4*s - 9))/(105*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**2*f*st*(42*b1*k1**2*(2*C - 1)*(s - 1) + 63*b1*k2**2*r + f*k1**2*(4*C - 2)*(4*s - 9) + f*k2**2*(12*r + 1))/(105*d*k1**2*k2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st**3*(7*b1*(s - 1) + f*(2*s - 1))/(35*d*k1) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st*(21*b1*(s - 1) + f*(-4*C*(5*r - 6) + 10*r + 9*s - 13))/(105*d*k1) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*k2*st*(14*b1**2*r + b1*(f*(3*r + 2) + 28*r + 7) + 7*f*r)/(105*d*k1**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*st**3*(14*b1*k1**2*(2*C - 1)*(s - 1) + 7*b1*k2**2*r + f*k1**2*(4*C - 2)*(2*s - 1) + f*k2**2*(2*r - 1))/(35*d*k1**2*k2) - 16*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**5*st*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(39*r + 39*s - 14))/(315*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**3*st*(C - 1)*(45*b1*(2*s - 1) + f*(39*s - 25))/(315*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**4*st*(33*b1*(5*f*k2**2*(9*r + 9*s - 5) + 6*k1**2*(C*(46*r + 46*s - 30) - 36*r - 36*s + 25)) + f*(15*f*k2**2*(57*r + 57*s - 29) + 22*k1**2*(2*C*(87*r + 87*s - 31) - 135*r - 135*s + 48)))/(3465*d*k1*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**2*st*(45*b1*(2*s - 1) + f*(39*s - 25))/(315*d*k1*k3**2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**2*st*(9*b1*k1**2*(C*(58*s - 36) - 48*s + 31) + 9*b1*k2**2*(r*(42 - 32*C) + 10*s - 5) + f*k1**2*(18*C*(13*s - 10) - 195*s + 155) + f*k2**2*(-6*C*(21*r + 5) + 165*r + 39*s + 16))/(315*d*k1*k3**4) - 32*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**5*st**3*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 4))/(105*d*k3**6) - 16*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**3*st**3*(C - 1)*(15*b1*(2*s - 1) + f*(9*s - 5))/(105*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2**3*st*(198*b1**2*k2**2*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(f**2*k2**2*(27*r + 27*s - 25) + 2*f*(k1**2*(C*(50*r + 50*s - 88) - 11*r - 11*s + 58) + k2**2*(-42*C*(2*r + 2*s - 1) + K*(4*r + 4*s + 5) + 80*r + 80*s - 47)) - 84*g2*k2**2*(r + s)) + f*(-5*f**2*k2**2*(207*r + 207*s - 103) - 22*f*(k1**2*(C*(42*r + 42*s - 4) + 6*r + 6*s - 13) + k2**2*(54 - 54*C)*(2*r + 2*s - 1)) + 132*g2*k2**2*(4*r + 4*s + 5)))/(3465*d*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2*st*(-252*b1**2*k1**2*(C - 1)*(s - 1) + 6*b1*f*(k1**2*(52*C*s - 12*C - 49*s + 21) + 33*k2**2*r) + f**2*(2*k1**2*(78*C*s - 50*C - 78*s + 65) + k2**2*(87*r + 19)))/(315*d*k1**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2*st*(-2772*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 66*b1*f*(5*f*k2**4*r + k1**4*(-176*C*s + 144*C + 119*s - 105) + k1**2*k2**2*(2*C*(89*r + 8*s - 2) - 142*r + 5*s + 4)) + f**2*(75*f*k2**4*(3*r + 2) - 22*k1**4*(12*C*(21*s - 20) - 174*s + 175) + 11*k1**2*k2**2*(4*C*(114*r + 9*s + 64) - 369*r + 24*s - 227)))/(3465*d*k1**2*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**4*st**3*(55*b1*f*k2**2*(9*r + 9*s - 5) + 66*b1*k1**2*(C*(43*r + 43*s - 25) - 33*r - 33*s + 20) + 5*f**2*k2**2*(47*r + 47*s - 27) + 22*f*k1**2*(C*(45*r + 45*s - 19) - 36*r - 36*s + 15))/(1155*d*k1*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(15*b1*(2*s - 1) + f*(9*s - 5))/(105*d*k1*k3**2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(3*b1*k1**2*(7*C*(7*s - 4) - 39*s + 23) + 3*b1*k2**2*(r*(36 - 26*C) + 10*s - 5) + f*k1**2*(C*(51*s - 28) - 42*s + 23) + f*k2**2*(C*(2 - 18*r) + 27*r + 9*s - 6))/(105*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2**2*st*(33*b1**2*k1**2*k2**2*(f*(45*r + 45*s - 33) + (-28*K - 14)*(r + s)) + 44*b1*(f**2*k2**2*(5*k1**2*(6*r + 6*s - 1) + 9*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(2*C*(23*r + 23*s + 6) - 39*r - 39*s - 5) + k2**2*(14*C*(9*r + 9*s - 5) - K*(r + s + 10) - 106*r - 106*s + 67)) + 42*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(k1**2*(75*r + 75*s - 59) + 44*k2**2*(5*r + 5*s - 3)) + 22*f*k1**2*(k1**2*(4*C*(39*r + 39*s - 20) - 129*r - 129*s + 65) + 9*k2**2*(4*C*(9*r + 9*s - 5) - 30*r - 30*s + 17)) + 264*g2*k1**2*k2**2*(r + s + 10)))/(3465*d*k1*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*st*(-126*b1**2*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(4 - 4*C)) + 3*b1*f*(k1**2*(4*C - 2)*(19*s - 6) + k2**2*(4*C*(8*r + 3) + 7*r - 18*s - 3)) + f**2*(2*k1**2*(78*C*s - 80*C - 48*s + 55) + k2**2*(24*C*r - 80*C + 45*r - 30*s + 73)))/(315*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*st*(198*b1**2*(k1**2*k2**2*(14*C - 7)*(r + s - 1) + k2**4*(f*(9*r + 9*s - 5) + 7*r*(3 - 2*K) + 7*s)) + 11*b1*(2*f**2*k2**4*(51*r + 129*s - 53) + 3*f*(2*k1**4*(14*C*(5*s - 6) - 39*s + 51) + k1**2*k2**2*(4*C*(24*r + 35*s - 3) - 101*r - 178*s + 27) - 2*k2**4*(-84*C*r + K*(8*r + 3) + 114*r + 38*s - 29)) + 504*g2*k2**4*r) + f*(20*f**2*k2**4*(6*r + 55*s - 51) + 11*f*(2*k1**4*(2*C*(57*s - 70) - 66*s + 85) + k1**2*k2**2*(4*C*(57*r + 66*s - 125) - 213*r - 324*s + 389) + 54*k2**4*(r*(4*C - 6) - 2*s + 1)) + 132*g2*k2**4*(8*r + 3)))/(3465*d*k1*k3**4) - 16*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**5*st**5*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**3*st**5*(C - 1)*(9*b1*(2*s - 1) + f*(3*s - 1))/(63*d*k3**4) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2**3*st**3*(33*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(f**2*k2**2*(7*r + 7*s - 5) + f*k1**2*(C*(50*r + 50*s - 46) - 27*r - 27*s + 31) - f*k2**2*(14*C - K - 13)*(2*r + 2*s - 1) - 14*g2*k2**2*(r + s)) + f*(f**2*k2**2*(-261*r - 261*s + 149) - 11*f*k1**2*(4*C*(18*r + 18*s - 7) - 45*r - 45*s + 17) + f*k2**2*(66*C - 66)*(2*r + 2*s - 1) + 66*g2*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st*(33*b1**2*k2**2*(f*(k1**2*(57*r + 57*s - 11) + 42*k2**2*(2*r + 2*s - 1)) + (r + s)*(-14*k1**2*(7*K - 6) - 14*k2**2*(5*K - 5))) - 66*b1*(f**2*k2**2*(k1**2*(6*r + 6*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + f*(k1**4*(C*(82*r + 82*s - 6) - 50*r - 50*s + 4) + k1**2*k2**2*(14*C*(19*r + 19*s - 12) + K*(11*r + 11*s - 30) - 191*r - 191*s + 134) + k2**4*(7*K - 7)*(r + s)) - 14*g2*k2**2*(7*k1**2 + 5*k2**2)*(r + s)) + f*(-5*f**2*(k1**2*k2**2*(153*r + 153*s - 101) + 132*k2**4*(3*r + 3*s - 2)) - 22*f*(k1**4*(4*C*(33*r + 33*s - 16) - 81*r - 81*s + 39) + 9*k1**2*k2**2*(C*(38*r + 38*s - 24) - 26*r - 26*s + 17)) + 132*g2*k2**2*(k1**2*(11*r + 11*s - 30) + 7*k2**2*(r + s))))/(3465*d*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st*(1386*b1**3*k2**4*(r + s - 1) + 33*b1**2*(k1**2*k2**2*(84*C - 84)*(r + s - 1) + k2**4*(140*C*(r + s - 1) + 14*K*(2*r - 6*s + 1) + f*(101*r + 122*s - 78) - 49*r + 42*s + 126)) + 33*b1*(6*f**2*k2**4*(2*r - 10*s + 1) + f*(k1**4*(2 - 4*C)*(4*s - 9) + k1**2*k2**2*(-4*C*(81*r + 45*s + 2) + 186*r + 135*s + 8) + k2**4*(-28*C*(17*r + 5*s - 2) - 4*K*(r + 6*s - 11) + 452*r + 184*s - 107)) + 14*k2**4*(3*b2*(r + s) - 2*g2*(2*r - 6*s + 1))) + f*(-15*f**2*k2**4*(39*r + 132*s - 106) - 11*f*(k1**4*(12*C - 6)*(3*s - 5) + k1**2*k2**2*(8*C*(75*r + 48*s - 50) - 363*r - 297*s + 241) + 18*k2**4*(6*C*(6*r + 2*s - 1) - 33*r - 12*s + 7)) + 66*k2**4*(b2*(4*r + 4*s + 5) + 4*g2*(r + 6*s - 11))))/(3465*d*k2*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(-42*b1**2*k1**2*(C - 1)*(s - 1) + 3*b1*f*(k1**2*(36*C*s - 18*C - 25*s + 16) + 16*k2**2*r) + f**2*(k1**2*(4*C*(9*s - 5) - 33*s + 18) + 3*k2**2*(3*r - 1)))/(105*d*k1**2*k3**2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(462*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 33*b1*f*k1**2*(k1**2*(C*(80*s - 54) - 51*s + 36) + k2**2*(-2*C*(43*r + 12*s - 5) + 59*r + 7*s - 5)) + f**2*(5*f*k2**4*(3*r + 2) + 33*k1**4*(2*C*(17*s - 9) - 23*s + 12) - 33*k1**2*k2**2*(C*(24*r + 8*s - 2) - 20*r - 5*s + 2)))/(1155*d*k1**2*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st*(-9*b1**2*(k1**4*(28*C - 14)*(s - 1) - 7*k1**2*k2**2*(4*C*(r - s + 1) - 3*r + 4*s - 4) - k2**4*r*(4*f + 21)) + 3*b1*f*k2**2*(k1**2*(12*C*(5*r - 3*s + 6) - 30*r + 9*s - 45) + k2**2*(f*(6*r + 4) - 30*r + 1)) + f**2*(k1**4*(12*C - 6)*(3*s - 5) + k1**2*k2**2*(24*C*(6*r - 5) - 75*r - 45*s + 73) - 54*k2**4*r))/(315*d*k1**2*k2*k3**2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**4*st**5*(33*b1*(f*k2**2*(9*r + 9*s - 5) + k1**2*(24*C - 18)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(37*r + 37*s - 25) + k1**2*(88*C - 66)*(3*r + 3*s - 2)))/(693*d*k1*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(9*b1*(2*s - 1) + f*(3*s - 1))/(63*d*k1*k3**2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(9*b1*k1**2*(4*C - 3)*(2*s - 1) + 9*b1*k2**2*(r*(6 - 4*C) + 2*s - 1) + f*k1**2*(4*C - 3)*(3*s - 1) + f*k2**2*(C*(2 - 6*r) + 9*r + 3*s - 4))/(63*d*k1*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k1*st*(33*b1**2*k2**2*(f*(3*k1**2*(17*r + 17*s - 5) + 14*k2**2*(9*r + 9*s - 5)) + (r + s)*(-14*k1**2*(8*K - 2) - 14*k2**2*(10*K - 5))) + 33*b1*(f**2*k2**2*(k1**2*(15*r + 15*s - 11) + 12*k2**2) - 2*f*(k1**4*(2*C - 1)*(9*r + 9*s - 1) + 2*k1**2*k2**2*(14*C*(4*r + 4*s - 3) + 2*K*(3*r + 3*s - 5) - 33*r - 33*s + 27) + k2**4*(14*K - 7)*(r + s)) + 56*g2*k2**2*(4*k1**2 + 5*k2**2)*(r + s)) - 2*f*(5*f**2*k2**2*(k1**2*(21*r + 21*s - 13) + 11*k2**2*(9*r + 9*s - 7)) + 11*f*k1**2*(k1**2*(2*C - 1)*(15*r + 15*s - 7) + 9*k2**2*(4*C*(4*r + 4*s - 3) - 9*r - 9*s + 7)) - 132*g2*k2**2*(2*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2**2*st**3*(33*b1**2*k1**2*k2**2*(f*(15*r + 15*s - 11) + (14 - 28*K)*(r + s)) + 44*b1*(f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 3*k2**2*(5*r + 5*s - 3)) - 3*f*k1**4*(C*(r + s - 11) + 7) + 3*f*k1**2*k2**2*(14*C - K - 10)*(2*r + 2*s - 1) + 42*g2*k1**2*k2**2*(r + s)) + f*(f**2*k2**2*(k1**2*(-135*r - 135*s + 71) + 44*k2**2*(5*r + 5*s - 3)) - 66*f*k1**2*(k1**2*(2*C - 1)*(3*r + 3*s - 1) - k2**2*(4*C - 3)*(2*r + 2*s - 1)) + 264*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(1155*d*k1*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(-42*b1**2*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 3*b1*f*(k1**2*(4*C - 2)*(5*s - 6) + k2**2*(8*C*r - 4*C - 7*r - 6*s + 7)) + f**2*(2*k1**2*(2*C*(15*s - 8) - 18*s + 9) + k2**2*(8*C*(3*r - 2) - 3*r - 6*s + 1)))/(105*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st*(3*b1**2*(21*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(140*C*r - 14*K*r + 14*K + 4*f*(5*r + 21*s - 11) - 91*r + 91*s - 14)) + 3*b1*(4*f**2*k2**2*(3*r + 9*s - 7) + f*k1**2*(12*C - 6)*(3*s - 5) + f*k2**2*(28*C*r - 2*K*(5*r - 6) + 17*r + 23*s + 2) + 28*g2*k2**2*(r - 1)) + f*(f*k1**2*(C*(40 - 84*r) + 42*r + 15*s - 19) + 54*f*k2**2*r - k2**2*(6*b2 - 12*g2)*(5*r - 6)))/(315*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(66*b1**2*(k1**2*k2**2*(28*C - 21)*(r + s - 1) + k2**4*(f*(9*r + 9*s - 5) + r*(14 - 7*K) + 7*s)) + 11*b1*(2*f**2*k2**4*(27*r + 45*s - 25) + 3*f*(k1**4*(52*C*s - 40*C - 30*s + 22) + k1**2*k2**2*(40*C*r + 40*C*s - 27*r - 38*s - 3) + 2*k2**4*(28*C*r - 2*K*r + K - 38*r - 12*s + 5)) + 84*g2*k2**4*r) + f*(4*f**2*k2**4*(42*r + 55*s - 27) + 11*f*(k1**4*(C*(84*s - 40) - 48*s + 22) + k1**2*k2**2*(-4*C*(3*r + 7) + 15*r - 12*s + 9) + 6*k2**4*(r*(4*C - 6) - 2*s + 1)) + 132*g2*k2**4*(2*r - 1)))/(1155*d*k1*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st*(-1617*b1**3*k1**2*k2**2*(r + s - 1) + 33*b1**2*(k1**4*(84*C - 42)*(r + s - 1) + k1**2*k2**2*(280*C*(r + s - 1) - 7*K*(38*r + 44*s - 4) + 2*f*(60*r + 81*s - 43) - 105*r - 35*s + 196) + 14*k2**4*(f*(6*r + 6*s - 4) + r*(10 - 5*K) + 5*s)) + 33*b1*(f**2*k2**2*(k1**2*(53*r + 25*s - 29) + 12*k2**2*(3*r + 3*s - 2)) + f*(k1**4*(-4*C*(23*r + 9*s + 7) + 46*r + 27*s + 13) + k1**2*k2**2*(-28*C*(11*r + 4*s - 2) + K*(-70*r - 76*s + 70) + 225*r + 103*s - 46) + 14*k2**4*(-r*(K - 2) + s)) + 28*k2**2*(-2*b2*k1**2*(r + s) + g2*k1**2*(19*r + 22*s - 2) + 5*g2*k2**2*r)) + f*(-10*f**2*k1**2*k2**2*(24*r + 99*s - 83) - 11*f*k1**2*(k1**2*(12*C*(17*r + 10*s - 8) - 102*r - 75*s + 47) + 18*k2**2*(2*C*(13*r + 6*s - 4) - 18*r - 7*s + 5)) + 132*k2**2*(b2*k1**2*(-3*r - 3*s + 5) + g2*k1**2*(35*r + 38*s - 35) + 7*g2*k2**2*r)))/(3465*d*k1*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2**3*st**5*(-198*b1**2*k2**2*(2*r + 2*s - 1) + 33*b1*(f*k2**2*(3*r + 3*s - 1) + k1**2*(12*C - 6)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(21*r + 21*s - 13) + k1**2*(44*C - 22)*(3*r + 3*s - 2)))/(693*d*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(18*b1*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + f*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1)))/(63*d*k1**2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(66*b1*(f*k2**4*r + k1**4*(6*C - 3)*(2*s - 1) - 3*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + f*(5*f*k2**4*(3*r + 2) + k1**4*(44*C - 22)*(3*s - 1) - 11*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7)))/(693*d*k1**2*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1**2*k2*st*(3*b1**2*(-14*K*(2*k1**2 + 5*k2**2)*(r + s) + f*k1**2*(9*r + 9*s - 1) + 14*f*k2**2*(3*r + 3*s - 2)) + b1*(f**2*(k1**2*(15*r + 15*s - 7) + 18*k2**2*(2*r + 2*s - 1)) - 6*f*(7*K*k2**2*(r + s) + k1**2*(14*C*(r + s - 1) + K*(3*r + 3*s - 5) - 7*r - 7*s + 7)) + 84*g2*(2*k1**2 + 5*k2**2)*(r + s)) - 2*f*(5*f**2*k2**2*(r + s - 1) + f*k1**2*(18*C - 9)*(r + s - 1) - 6*g2*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))))/(315*d*k3**6) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st*(21*b1**3*(3*k1**2 + 10*k2**2)*(r + s - 1) - 3*b1**2*(k1**2*(140*C*(r + s - 1) - 7*K*(20*r + 22*s - 2) + f*(21*r + 42*s - 20) - 77*r - 49*s + 70) + 7*k2**2*(-20*K*r - 10*K*s + f*(4*r + 4*s - 2) + 5*r)) + b1*(42*b2*(2*k1**2 + 5*k2**2)*(r + s) - f**2*(k1**2*(45*r + 51*s - 35) + 18*k2**2*(3*r + 3*s - 2)) + 3*f*(k1**2*(28*C*r + K*(36*r + 38*s - 32) - 15*r - 9*s - 3) + 7*k2**2*(2*K*s + r*(4*K - 1))) - 84*g2*(k1**2*(10*r + 11*s - 1) + 5*k2**2*(2*r + s))) + f*(6*b2*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)) + 10*f**2*k1**2*(s - 1) + 9*f*k1**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2) - 12*g2*(k1**2*(18*r + 19*s - 16) + 7*k2**2*(2*r + s))))/(315*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st**3*(-33*b1**2*k2**2*(14*K*k1**2*(r + s) + f*k1**2*(-3*r - 3*s + 5) + 14*f*k2**2*(2*r + 2*s - 1)) + 22*b1*(f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 3*k2**2*(4*r + 4*s - 3)) + 3*f*k1**2*(k1**2*(2*C - 1)*(r + s + 3) + k2**2*(14*C - K - 7)*(2*r + 2*s - 1)) + 42*g2*k1**2*k2**2*(r + s)) + f*k2**2*(f**2*(k1**2*(5*r + 5*s - 1) + 44*k2**2*(3*r + 3*s - 2)) + f*k1**2*(132*C - 66)*(2*r + 2*s - 1) + 132*g2*k1**2*(2*r + 2*s - 1)))/(1155*d*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(462*b1**3*k2**4*(r + s - 1) - 33*b1**2*(k1**2*k2**2*(28*C - 14)*(r + s - 1) - k2**4*(14*K*s + f*(19*r + 26*s - 18) + r*(28*K - 7))) - 33*b1*(2*f**2*k2**4*(2*r + 6*s - 3) + f*(k1**4*(4*C - 2)*(2*s - 1) + k1**2*k2**2*(4*C*(11*r + 6*s + 3) - 20*r - 15*s - 8) + k2**4*(28*C*(4*r + 2*s - 1) - 4*K*(2*r + s - 1) - 68*r - 28*s + 13)) - 14*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + f*(f**2*k2**4*(-75*r - 132*s + 82) - 11*f*(k1**4*(4*C - 2)*(3*s - 1) + 3*k1**2*k2**2*(4*C*(2*r + s - 1) - 3*r - 3*s + 1) + 6*k2**4*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + 66*k2**4*(b2*(2*r + 2*s - 1) - 4*g2*(2*r + s - 1))))/(1155*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st*(-105*b1**3*k1**2*(r + 2*s - 2) + 3*b1**2*(k1**2*(-14*K*(6*r + 5*s - 1) + 4*f*(7*s - 2) + 7*r*(20*C - 15) + 21*s - 7) + 35*k2**2*r) + b1*(f**2*k1**2*(15*r + 54*s - 38) + 3*f*(k1**2*(-2*K*(12*r + 7*s - 6) + r*(28*C - 20) + 9*s + 3) + 7*k2**2*r) + 42*k1**2*(-5*b2*(r + s) + 2*g2*(6*r + 5*s - 1))) + 3*f*k1**2*(-2*b2*(12*r + 7*s - 6) + 3*f*r + 4*g2*(12*r + 7*s - 6)))/(315*d*k1**2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(3*b1**2*(k1**4*(28*C - 14)*(s - 1) + k1**2*k2**2*r*(21 - 28*C) + k2**4*r*(8*f - 7)) + b1*f*k2**2*(k1**2*(-108*C*r + 12*C + 54*r + 9*s - 3) + k2**2*(6*f*r + 4*f + 36*r + 3)) + f**2*(-k1**4*(4*C - 2)*(3*s - 1) + k1**2*k2**2*(-24*C*r + 8*C + 9*r + 3*s - 1) + 6*k2**4*r))/(105*d*k1**2*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**3*f*k2**2*st*(21*b1 + 4*f)*(r + s - 1)/(105*d*k1*k3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**2*f*k2*st*(42*C*b1 + f*(8*C + 5))*(r + s - 1)/(105*d*k3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2**2*st**3*(7*b1 + 2*f)*(r + s - 1)/(35*d*k1*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*st*(r + s - 1)*(7*b1**2*k2**2 + b1*k1**2*(42 - 84*C) + b1*k2**2*(56 - 3*f) + f*k1**2*(18 - 36*C) + 14*f*k2**2)/(105*d*k1*k3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*k2*st**3*(2*C - 1)*(7*b1 + 2*f)*(r + s - 1)/(35*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*k2*st*(r + s - 1)*(-28*C*f + 21*b1**2 + b1*(-140*C + 14*K + 9*f + 70) + 14*b2 + 14*f - 28*g2)/(105*d*k3) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**6*f**2*k2**5*st*(C - 1)*(45*b1*(2*r + 2*s - 1) + f*(39*r + 39*s - 14))/(315*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**4*st*(45*b1*(2*r + 2*s - 1) + f*(39*r + 39*s - 14))/(315*d*k1*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**4*st*(33*b1*(5*f*k2**2*(9*r + 9*s - 5) + 6*k1**2*(C*(46*r + 46*s - 30) - 36*r - 36*s + 25)) + f*(15*f*k2**2*(57*r + 57*s - 29) + 22*k1**2*(2*C*(87*r + 87*s - 31) - 135*r - 135*s + 48)))/(3465*d*k1*k3**5) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**5*st**3*(C - 1)*(15*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 4))/(105*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**3*st*(126*b1**2*(C - 1)*(r + s - 1) - 3*b1*f*(C*(52*r + 52*s - 22) - 31*r - 31*s + 22) + f**2*(C*(-78*r - 78*s + 28) + 48*r + 48*s - 17))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**3*st*(198*b1**2*k2**2*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(f**2*k2**2*(27*r + 27*s - 25) + 2*f*(k1**2*(C*(50*r + 50*s - 88) - 11*r - 11*s + 58) + k2**2*(-42*C*(2*r + 2*s - 1) + K*(4*r + 4*s + 5) + 80*r + 80*s - 47)) - 84*g2*k2**2*(r + s)) + f*(-5*f**2*k2**2*(207*r + 207*s - 103) - 22*f*(k1**2*(C*(42*r + 42*s - 4) + 6*r + 6*s - 13) + k2**2*(54 - 54*C)*(2*r + 2*s - 1)) + 132*g2*k2**2*(4*r + 4*s + 5)))/(3465*d*k3**5) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(15*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 4))/(105*d*k1*k3**3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(55*b1*f*k2**2*(9*r + 9*s - 5) + 66*b1*k1**2*(C*(43*r + 43*s - 25) - 33*r - 33*s + 20) + 5*f**2*k2**2*(47*r + 47*s - 27) + 22*f*k1**2*(C*(45*r + 45*s - 19) - 36*r - 36*s + 15))/(1155*d*k1*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**2*st*(9*b1**2*(k1**2*(14*C - 7)*(r + s - 1) + k2**2*(f*(9*r + 9*s - 5) + 7*r + 7*s)) + b1*f*(-12*k1**2*(C*(5*r + 5*s - 8) + 2*r + 2*s + 5) + k2**2*(f*(39*r + 39*s - 19) - 114*r - 114*s + 78)) - 3*f**2*(k1**2*(C*(6*r + 6*s - 2) + 9*r + 9*s - 5) + 9*k2**2*(2*r + 2*s - 1)))/(315*d*k1*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**2*st*(33*b1**2*k1**2*k2**2*(f*(45*r + 45*s - 33) + (-28*K - 14)*(r + s)) + 44*b1*(f**2*k2**2*(5*k1**2*(6*r + 6*s - 1) + 9*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(2*C*(23*r + 23*s + 6) - 39*r - 39*s - 5) + k2**2*(14*C*(9*r + 9*s - 5) - K*(r + s + 10) - 106*r - 106*s + 67)) + 42*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(k1**2*(75*r + 75*s - 59) + 44*k2**2*(5*r + 5*s - 3)) + 22*f*k1**2*(k1**2*(4*C*(39*r + 39*s - 20) - 129*r - 129*s + 65) + 9*k2**2*(4*C*(9*r + 9*s - 5) - 30*r - 30*s + 17)) + 264*g2*k1**2*k2**2*(r + s + 10)))/(3465*d*k1*k3**5) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**5*st**5*(C - 1)*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(42*b1**2*(C - 1)*(r + s - 1) - 3*b1*f*(4*C*(9*r + 9*s - 4) - 19*r - 19*s + 11) + f**2*(-4*C*(9*r + 9*s - 4) + 27*r + 27*s - 11))/(105*d*k3**3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(33*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) - 33*b1*(f**2*k2**2*(7*r + 7*s - 5) + f*k1**2*(C*(50*r + 50*s - 46) - 27*r - 27*s + 31) - f*k2**2*(14*C - K - 13)*(2*r + 2*s - 1) - 14*g2*k2**2*(r + s)) + f*(f**2*k2**2*(-261*r - 261*s + 149) - 11*f*k1**2*(4*C*(18*r + 18*s - 7) - 45*r - 45*s + 17) + f*k2**2*(66*C - 66)*(2*r + 2*s - 1) + 66*g2*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2*st*(63*b1**3*k2**2*(r + s - 1) + 3*b1**2*(k1**2*(42*C - 42)*(r + s - 1) + k2**2*(70*C*(r + s - 1) + 14*K*r + 14*K*s + 7*K + f*(19*r + 19*s - 18) - 35*r - 35*s + 63)) + 3*b1*(3*f**2*k2**2*(2*r + 2*s - 3) + f*(k1**2*(-2*C*(9*r + 9*s + 13) + 9*r + 9*s + 21) + k2**2*(-14*C*(5*r + 5*s - 2) + K*(4*r + 4*s + 5) + 76*r + 76*s - 45)) - 7*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + f*(f*k1**2*(-36*C*(2*r + 2*s - 1) + 51*r + 51*s - 25) - 9*f*k2**2*(6*C*(2*r + 2*s - 1) - 12*r - 12*s + 7) + k2**2*(3*b2 - 6*g2)*(4*r + 4*s + 5)))/(315*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2*st*(33*b1**2*k2**2*(f*(k1**2*(57*r + 57*s - 11) + 42*k2**2*(2*r + 2*s - 1)) + (r + s)*(-14*k1**2*(7*K - 6) - 14*k2**2*(5*K - 5))) - 66*b1*(f**2*k2**2*(k1**2*(6*r + 6*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + f*(k1**4*(C*(82*r + 82*s - 6) - 50*r - 50*s + 4) + k1**2*k2**2*(14*C*(19*r + 19*s - 12) + K*(11*r + 11*s - 30) - 191*r - 191*s + 134) + k2**4*(7*K - 7)*(r + s)) - 14*g2*k2**2*(7*k1**2 + 5*k2**2)*(r + s)) + f*(-5*f**2*(k1**2*k2**2*(153*r + 153*s - 101) + 132*k2**4*(3*r + 3*s - 2)) - 22*f*(k1**4*(4*C*(33*r + 33*s - 16) - 81*r - 81*s + 39) + 9*k1**2*k2**2*(C*(38*r + 38*s - 24) - 26*r - 26*s + 17)) + 132*g2*k2**2*(k1**2*(11*r + 11*s - 30) + 7*k2**2*(r + s))))/(3465*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k1*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(33*b1*(f*k2**2*(9*r + 9*s - 5) + k1**2*(24*C - 18)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(37*r + 37*s - 25) + k1**2*(88*C - 66)*(3*r + 3*s - 2)))/(693*d*k1*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k1*st*(33*b1**2*k2**2*(f*(3*k1**2*(17*r + 17*s - 5) + 14*k2**2*(9*r + 9*s - 5)) + (r + s)*(-14*k1**2*(8*K - 2) - 14*k2**2*(10*K - 5))) + 33*b1*(f**2*k2**2*(k1**2*(15*r + 15*s - 11) + 12*k2**2) - 2*f*(k1**4*(2*C - 1)*(9*r + 9*s - 1) + 2*k1**2*k2**2*(14*C*(4*r + 4*s - 3) + 2*K*(3*r + 3*s - 5) - 33*r - 33*s + 27) + k2**4*(14*K - 7)*(r + s)) + 56*g2*k2**2*(4*k1**2 + 5*k2**2)*(r + s)) - 2*f*(5*f**2*k2**2*(k1**2*(21*r + 21*s - 13) + 11*k2**2*(9*r + 9*s - 7)) + 11*f*k1**2*(k1**2*(2*C - 1)*(15*r + 15*s - 7) + 9*k2**2*(4*C*(4*r + 4*s - 3) - 9*r - 9*s + 7)) - 132*g2*k2**2*(2*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))))/(3465*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(3*b1**2*(k1**2*(28*C - 21)*(r + s - 1) + k2**2*(f*(9*r + 9*s - 5) + 7*r + 7*s)) + b1*f*(6*k1**2*(C*(r + s + 1) - 2*r - 2*s - 1) + k2**2*(f*(15*r + 15*s - 11) - 36*r - 36*s + 18)) - 3*f**2*(k1**2*(2*C - 1)*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1)))/(105*d*k1*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(33*b1**2*k1**2*k2**2*(f*(15*r + 15*s - 11) + (14 - 28*K)*(r + s)) + 44*b1*(f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 3*k2**2*(5*r + 5*s - 3)) - 3*f*k1**4*(C*(r + s - 11) + 7) + 3*f*k1**2*k2**2*(14*C - K - 10)*(2*r + 2*s - 1) + 42*g2*k1**2*k2**2*(r + s)) + f*(f**2*k2**2*(k1**2*(-135*r - 135*s + 71) + 44*k2**2*(5*r + 5*s - 3)) - 66*f*k1**2*(k1**2*(2*C - 1)*(3*r + 3*s - 1) - k2**2*(4*C - 3)*(2*r + 2*s - 1)) + 264*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(1155*d*k1*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*st*(-147*b1**3*k1**2*k2**2*(r + s - 1) + 6*b1**2*(k1**4*(42*C - 21)*(r + s - 1) + 2*k1**2*k2**2*(70*C*(r + s - 1) - 7*K*(3*r + 3*s - 1) + f*(9*r + 9*s - 4) - 42*r - 42*s + 49) + 7*k2**4*(f*(6*r + 6*s - 4) + 5*r + 5*s)) + 3*b1*(f**2*k2**2*(k1**2*(25*r + 25*s - 21) + 12*k2**2*(3*r + 3*s - 2)) - 2*f*(k1**4*(16*C - 8) + k1**2*k2**2*(28*C*(2*r + 2*s - 1) + 2*K*(3*r + 3*s - 5) - 31*r - 31*s + 19) - 7*k2**4*(r + s)) - 56*k1**2*k2**2*(b2*(r + s) + g2*(-3*r - 3*s + 1))) - 2*f*k1**2*(f*k1**2*(2*C - 1)*(15*r + 15*s - 7) + 9*f*k2**2*(4*C*(3*r + 3*s - 2) - 7*r - 7*s + 5) + k2**2*(6*b2 - 12*g2)*(3*r + 3*s - 5)))/(315*d*k1*k3**3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(2*C - 1)*(9*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(63*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(-198*b1**2*k2**2*(2*r + 2*s - 1) + 33*b1*(f*k2**2*(3*r + 3*s - 1) + k1**2*(12*C - 6)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(21*r + 21*s - 13) + k1**2*(44*C - 22)*(3*r + 3*s - 2)))/(693*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1**2*k2*st*(3*b1**2*(-14*K*(2*k1**2 + 5*k2**2)*(r + s) + f*k1**2*(9*r + 9*s - 1) + 14*f*k2**2*(3*r + 3*s - 2)) + b1*(f**2*(k1**2*(15*r + 15*s - 7) + 18*k2**2*(2*r + 2*s - 1)) - 6*f*(7*K*k2**2*(r + s) + k1**2*(14*C*(r + s - 1) + K*(3*r + 3*s - 5) - 7*r - 7*s + 7)) + 84*g2*(2*k1**2 + 5*k2**2)*(r + s)) - 2*f*(5*f**2*k2**2*(r + s - 1) + f*k1**2*(18*C - 9)*(r + s - 1) - 6*g2*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))))/(315*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(-7*b1**3*k2**2*(r + s - 1) + b1**2*(k1**2*(14*C - 7)*(r + s - 1) + k2**2*(-7*K*(r + s) + f*(r + s + 2))) + b1*(f**2*k2**2*(2*r + 2*s - 1) + f*k1**2*(2*C - 1)*(3*r + 3*s + 1) + f*k2**2*(14*C - K - 7)*(2*r + 2*s - 1) + k2**2*(-7*b2 + 14*g2)*(r + s)) - f*k2**2*(2*r + 2*s - 1)*(-2*C*f + b2 + f - 2*g2))/(35*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st*(21*b1**3*(3*k1**2 + 10*k2**2)*(r + s - 1) - 6*b1**2*(k1**2*(70*C*(r + s - 1) - 7*K*(3*r + 3*s - 1) + 4*f - 35*r - 35*s + 35) + 7*k2**2*(-5*K*(r + s) + f*(2*r + 2*s - 1))) + b1*(6*K*f*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)) + 42*b2*(2*k1**2 + 5*k2**2)*(r + s) - f**2*(k1**2*(15*r + 15*s - 7) + 18*k2**2*(3*r + 3*s - 2)) - 84*g2*(k1**2*(3*r + 3*s - 1) + 5*k2**2*(r + s))) + 6*f*(b2*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)) + f*k1**2*(6*C - 3)*(r + s - 1) - 2*g2*(k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(-33*b1**2*k2**2*(14*K*k1**2*(r + s) + f*k1**2*(-3*r - 3*s + 5) + 14*f*k2**2*(2*r + 2*s - 1)) + 22*b1*(f**2*k2**2*(k1**2*(6*r + 6*s - 1) + 3*k2**2*(4*r + 4*s - 3)) + 3*f*k1**2*(k1**2*(2*C - 1)*(r + s + 3) + k2**2*(14*C - K - 7)*(2*r + 2*s - 1)) + 42*g2*k1**2*k2**2*(r + s)) + f*k2**2*(f**2*(k1**2*(5*r + 5*s - 1) + 44*k2**2*(3*r + 3*s - 2)) + f*k1**2*(132*C - 66)*(2*r + 2*s - 1) + 132*g2*k1**2*(2*r + 2*s - 1)))/(1155*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1**2*f*k2*st*(21*b1*r + f*(9*r - 8))/(105*d*k1) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct**2*f*k2*st*(21*b1*r + f*(9*r - 8))/(105*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct*f*st*(2*C - 1)*(21*b1*r + f*(9*r - 8))/(105*d) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**5*f**2*k2**4*st*(C - 1)*(27*b1*r + f*(15*r - 8))/(315*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**3*st*(27*b1*r + f*(15*r - 8))/(315*d*k1*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**3*st*(825*b1*f*k2**2*r + 1188*b1*k1**2*r*(7*C - 6) + 25*f**2*k2**2*(21*r - 8) + f*k1**2*(308*C - 264)*(15*r - 8))/(3465*d*k1*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**4*st**3*(C - 1)*(9*b1*r + f*(3*r - 4))/(105*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k2**2*st*(-126*b1**2*r*(C - 1) + 3*b1*f*(2*C*(9*r + 8) - 27*r - 16) + f**2*(4*C - 5)*(15*r - 8))/(315*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k2**2*st*(693*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 30*f**3*k2**2*(21*r - 8) + 11*f**2*(4*b1*k2**2*(15*r + 4) + k1**2*(18*C - 13)*(15*r - 8)) - 33*f*(18*b1**2*k2**2*r + 9*b1*k1**2*r*(13 - 18*C) - b1*k2**2*(K - 1)*(9*r - 8) + 2*g2*k2**2*(9*r - 8)))/(3465*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(9*b1*r + f*(3*r - 4))/(105*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(165*b1*f*k2**2*r + 198*b1*k1**2*r*(5*C - 4) + 15*f**2*k2**2*(5*r - 4) + f*k1**2*(110*C - 88)*(3*r - 4))/(1155*d*k1*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k1*k2*st*(1386*b1*k2**2*r*(b1*(3*K - 2) - 6*g2) + 45*f**3*k2**2*(21*r - 8) + 44*f**2*(18*b1*k2**2 + k1**2*(5*C - 3)*(15*r - 8)) - 33*f*(81*b1**2*k2**2*r - 2*b1*(k1**2*r*(90*C - 54) + k2**2*(3*K - 2)*(9*r - 8)) + 12*g2*k2**2*(9*r - 8)))/(3465*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2*st*(9*b1**2*r*(k1**2*(28*C - 21) + k2**2*(9*f + 7)) + 3*b1*f*(k1**2*(-2*C*(9*r + 16) + 9*r + 24) + k2**2*(f*(15*r - 8) + 9*r - 8)) - f**2*k1**2*(6*C - 4)*(15*r - 8))/(315*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(4*C - 3)*(9*b1*r + f*(3*r - 4))/(105*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(-99*b1*r*(2*b1*k2**2 + k1**2*(5 - 8*C)) + 18*f**2*k2**2*(5*r - 4) + 11*f*(4*b1*k2**2*(3*r + 2) + k1**2*(8*C - 5)*(3*r - 4)))/(1155*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1**2*st*(693*b1*k2**2*r*(b1*(3*K - 1) - 6*g2) + 5*f**3*k2**2*(21*r - 8) + 11*f**2*(6*b1*k2**2*(4 - 5*r) + k1**2*(2*C - 1)*(15*r - 8)) - 33*f*(27*b1**2*k2**2*r + 9*b1*k1**2*r*(1 - 2*C) - b1*k2**2*(3*K - 1)*(9*r - 8) + 6*g2*k2**2*(9*r - 8)))/(3465*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*st*(63*b1**3*k2**2*r - 3*b1**2*(2*f*k2**2*(9*r + 4) + r*(21*k1**2*(2*C - 1) - 21*k2**2*(K - 1))) - 3*b1*(f**2*k2**2*(15*r - 8) + f*k1**2*(8 - 16*C) - f*k2**2*(K - 1)*(9*r - 8) - k2**2*r*(21*b2 - 42*g2)) + f*(f*k1**2*(2*C - 1)*(15*r - 8) + k2**2*(3*b2 - 6*g2)*(9*r - 8)))/(315*d*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**3*k2**5*st**5*(33*b1*r + f*(9*r - 16))/(693*d*k1*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k1*k2*st**3*(-99*b1*r*(3*b1*k2**2 + k1**2*(2 - 4*C)) + 9*f**2*k2**2*(5*r - 4) + 22*f*(6*b1*k2**2 + k1**2*(2*C - 1)*(3*r - 4)))/(1155*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2*st**3*(b1*k2**2 + k1**2*(1 - 2*C))*(9*b1*r + f*(3*r - 4))/(105*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**3*k2*st*(9*b1**2*r*(-14*K + 3*f) + b1*(-6*K*f*(9*r - 8) + f**2*(15*r - 8) + 252*g2*r) + 12*f*g2*(9*r - 8))/(315*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1*k2*st*(63*b1**3*r - 6*b1**2*(-21*K*r + 4*f) + b1*(6*K*f*(9*r - 8) + f**2*(8 - 15*r) + r*(126*b2 - 252*g2)) + 6*f*(b2 - 2*g2)*(9*r - 8))/(315*d*k3**2)
        perm23 = -8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**6*f**2*k1**2*k2**3*st*(495*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(130*r + 130*s - 81) + f*(22*C - 22)*(39*r + 39*s - 14) - 990*g2*(2*r + 2*s - 1))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**5*f**2*k1*k2**2*st*(-33*b1*(k1**2*(6*K - 6)*(3*r + 3*s - 5) - 5*k2**2*(f*(9*r + 9*s - 5) + (6 - 12*K)*(2*r + 2*s - 1))) - 5*f**2*k1**2*(387*r + 387*s - 271) - 22*f*(k1**2*(6*C - 6)*(3*r + 3*s - 1) + k2**2*(4*C - 3)*(39*r + 39*s - 14)) + 396*g2*(k1**2*(3*r + 3*s - 5) + 10*k2**2*(2*r + 2*s - 1)))/(3465*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f**2*k1**2*k2**3*st**3*(330*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(96*r + 96*s - 61) + f*(44*C - 44)*(9*r + 9*s - 4) - 660*g2*(2*r + 2*s - 1))/(1155*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f*k2*st*(-1386*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 33*b1*(f**2*k1**2*k2**2*(27*r + 27*s - 25) + 2*f*(-15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(23*r + 23*s - 1) + k1**2*k2**2*(-2*C*(4*r + 4*s + 5) + 3*K*(8*r + 8*s + 3) - 25*r - 25*s + 16)) + 84*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k1**2*(3*k1**2*(r + s + 13) + 110*k2**2*(3*r + 3*s - 2)) + 22*f*(k1**4*(36*C - 36)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 27*r - 27*s + 15) - k2**4*(2*C - 1)*(39*r + 39*s - 14)) - 132*g2*(k1**4*(23*r + 23*s - 1) + 3*k1**2*k2**2*(8*r + 8*s + 3) - 15*k2**4*(2*r + 2*s - 1))))/(3465*d*k3**6) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f**2*k1*k2**2*st**3*(-33*b1*k1**2*(K - 1)*(3*r + 3*s - 5) + 55*b1*k2**2*(f*(9*r + 9*s - 5) + (6 - 12*K)*(2*r + 2*s - 1)) - 15*f**2*k1**2*(37*r + 37*s - 25) - 22*f*(k1**2*(3*C - 3)*(3*r + 3*s - 1) + k2**2*(4*C - 3)*(9*r + 9*s - 4)) + 66*g2*(k1**2*(3*r + 3*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f*k1*st*(33*b1**2*(3*f*k2**4*(9*r + 9*s - 1) + 14*k2**2*(r + s)*(k1**2*(4*K - 4) + k2**2*(3 - 6*K))) - 22*b1*(2*f**2*k2**2*(5*k1**2*(6*r + 6*s - 1) + 9*k2**2*(5*r + 5*s - 3)) - 3*f*(k1**4*(K - 1)*(9*r + 9*s - 1) + k1**2*k2**2*(4*C*(3*r + 3*s - 5) + K*(88*r + 88*s - 30) - 77*r - 77*s + 49) - k2**4*(4*C*(4*r + 4*s + 5) - 3*K*(25*r + 25*s - 9) + 30*r + 30*s - 36)) + 84*g2*k2**2*(2*k1**2 - 3*k2**2)*(r + s)) + f*(5*f**2*(k1**4*(193*r + 193*s - 109) + 44*k1**2*k2**2*(15*r + 15*s - 11)) + 22*f*(k1**4*(2*C - 2)*(15*r + 15*s - 7) + 18*k1**2*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7) + 3*k2**4*(C*(66*r + 66*s - 34) - 51*r - 51*s + 26)) - 132*g2*(k1**4*(9*r + 9*s - 1) + 2*k1**2*k2**2*(44*r + 44*s - 15) + 3*k2**4*(25*r + 25*s - 9))))/(3465*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f**2*k1**2*k2**3*st**5*(99*b1*(K - 1)*(2*r + 2*s - 1) + 3*f**2*(62*r + 62*s - 41) + f*(22*C - 22)*(3*r + 3*s - 2) - 198*g2*(2*r + 2*s - 1))/(693*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k2*st**3*(231*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 33*b1*(f**2*k1**2*k2**2*(7*r + 7*s - 5) + f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-4*r - 4*s + 2) + K*(8*r + 8*s + 3) - 7*r - 7*s)) + 14*g2*k1**2*k2**2*(r + s)) + f*(f**2*k1**2*(k1**2*(111*r + 111*s - 97) - 110*k2**2*(3*r + 3*s - 2)) + 11*f*k2**2*(3*k1**2*(C*(8*r + 8*s - 2) - 5*r - 5*s + 1) + k2**2*(4*C - 2)*(9*r + 9*s - 4)) + 66*g2*(k1**4*(r + s + 3) + k1**2*k2**2*(8*r + 8*s + 3) - 10*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*st*(462*b1*k2**2*(r + s)*(b1*(-3*K*k2**4 + k1**4*(2*K - 2) + k1**2*k2**2*(13*K - 9)) - 2*g2*(2*k1**4 + 13*k1**2*k2**2 - 3*k2**4)) + 15*f**3*(k1**6*(21*r + 21*s - 13) + 22*k1**4*k2**2*(6*r + 6*s - 5)) - 22*f**2*(k1**4*k2**2*(C*(-78*r - 78*s + 46) + 3*b1*(6*r + 6*s + 1) + 63*r + 63*s - 39) + 9*k1**2*k2**4*(-4*C*(8*r + 8*s - 5) + 3*b1*(4*r + 4*s - 3) + 22*r + 22*s - 14) + k2**6*(27 - 54*C)*(2*r + 2*s - 1)) - 33*f*k2**2*(b1**2*k1**2*k2**2*(3*r + 3*s - 19) - 2*b1*(k1**4*(2*C*(3*r + 3*s - 5) + K*(25*r + 25*s - 9) - 22*r - 22*s + 18) + k1**2*k2**2*(C*(38*r + 38*s - 40) + K*(107*r + 107*s - 57) - 74*r - 74*s + 58) + k2**4*(-2*C*(4*r + 4*s + 5) + 21*K*(2*r + 2*s - 1) + 4*r + 4*s + 5)) + 4*g2*(k1**4*(25*r + 25*s - 9) + k1**2*k2**2*(107*r + 107*s - 57) + 21*k2**4*(2*r + 2*s - 1))))/(3465*d*k2*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(279*r + 279*s - 179) - 11*f*k2**2*(3*b1*(9*r + 9*s - 5) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(396*K*b1 - 198*b1 - 792*g2))/(693*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*k1*st**3*(462*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + f**3*(15*k1**4*(5*r + 5*s - 1) + 44*k1**2*k2**2*(15*r + 15*s - 11)) - 22*f**2*(2*b1*(k1**2*k2**2*(6*r + 6*s - 1) + 3*k2**4*(5*r + 5*s - 3)) + 3*k2**4*(-2*C*(r + s - 1) + 3*r + 3*s - 2)) + 33*f*k2**2*(b1**2*k2**2*(9*r + 9*s - 1) + 2*b1*(k1**2*(2*K - 1)*(r + s + 3) + k2**2*(C*(-8*r - 8*s + 4) + K*(25*r + 25*s - 9) - 8*r - 8*s + 4)) - 4*g2*(2*k1**2*(r + s + 3) + k2**2*(25*r + 25*s - 9))))/(1155*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*k1*st*(3*b1**2*k2**2*(f*(k1**2*(45*r + 45*s - 33) + 14*k2**2*(3*r + 3*s - 1)) + (r + s)*(-14*k1**2*(4*K - 2) - 14*k2**2*(14*K - 5))) - 3*b1*(f**2*(k1**4*(15*r + 15*s - 11) + 12*k1**2*k2**2) + 2*f*k2**2*(k1**2*(4*C*(3*r + 3*s - 5) + K*(23*r + 23*s - 15) - 16*r - 16*s + 22) + k2**2*(20*C*(2*r + 2*s - 1) + 14*K*(3*r + 3*s - 2) - 27*r - 27*s + 10)) - 56*g2*k2**2*(2*k1**2 + 7*k2**2)*(r + s)) - 2*f*(15*f**2*k1**4*(r + s - 1) + 2*f*(k1**2*k2**2*(C*(33*r + 33*s - 25) - 21*r - 21*s + 17) + k2**4*(18*C - 9)*(3*r + 3*s - 2)) - 6*g2*k2**2*(k1**2*(23*r + 23*s - 15) + 14*k2**2*(3*r + 3*s - 2))))/(315*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(99*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**2*k2*st**5*(f**2*(k1**4*(-45*r - 45*s + 31) + 22*k1**2*k2**2*(3*r + 3*s - 2)) + 11*f*(3*b1*k1**2*k2**2*(3*r + 3*s - 1) + k2**4*(2 - 4*C)*(3*r + 3*s - 2)) + k2**4*(-198*K*b1 + 396*g2)*(2*r + 2*s - 1))/(693*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*st**3*(-462*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*(3*k1**6*(5*r + 5*s - 1) + 22*k1**4*k2**2*(6*r + 6*s - 5)) - 22*f**2*(b1*k1**4*k2**2*(6*r + 6*s - 1) + 3*b1*k1**2*k2**4*(4*r + 4*s - 3) + k2**6*(3 - 6*C)*(2*r + 2*s - 1)) + 33*f*k2**4*(b1**2*k1**2*(9*r + 9*s - 1) + 2*b1*(K*k1**2*(r + s + 3) + 7*K*k2**2*(2*r + 2*s - 1) - k2**2*(2*C - 1)*(2*r + 2*s - 1)) - 4*g2*(k1**2*(r + s + 3) + 7*k2**2*(2*r + 2*s - 1))))/(1155*d*k2*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*st*(-3*b1**2*(-14*K*k2**4*(2*k1**2 + 5*k2**2)*(r + s) + f*k1**4*k2**2*(15*r + 15*s - 11) + 14*f*k1**2*k2**4*(3*r + 3*s - 1)) + b1*(f**2*k1**4*(k1**2*(15*r + 15*s - 7) + 18*k2**2*(2*r + 2*s - 1)) + 6*f*k2**4*(k1**2*(2*C*(3*r + 3*s - 5) + 7*K*(r + s - 1) - 3*r - 3*s + 5) + k2**2*(14*C - 7)*(r + s)) - 84*g2*k2**4*(2*k1**2 + 5*k2**2)*(r + s)) + 6*f*k1**2*k2**4*(f*(6*C - 3) - 14*g2)*(r + s - 1))/(315*d*k2*k3**6) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**3*f*k1*st*(3*b1*(9*f + 14) + 8*f)*(r + s - 1)/(105*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**2*f*st*(r + s - 1)*(42*K*b1*k2**2 + 3*b1*k1**2*(9*f + 14) + 18*f*k1**2 + f*k2**2*(16*C - 8) + k2**2*(42*b2 - 84*g2))/(105*d*k2*k3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*k1*st**3*(b1*(9*f + 14) + 4*f)*(r + s - 1)/(35*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*k1*st*(r + s - 1)*(-36*C*f + 7*b1**2 + 14*b1*(-3*K + 3*f + 4) - 42*b2 + 32*f + 84*g2)/(105*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*st**3*(b1*(14*K*k2**2 + 3*f*k1**2) + k2**2*(8*C*f + 14*b2 - 4*f - 28*g2))*(r + s - 1)/(35*d*k2*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*st*(r + s - 1)*(3*b1**2*k1**2 + 2*b1*k2**2*(2*C - 5*K - 1) + k2**2*(-4*C*f - 10*b2 + 2*f + 20*g2))/(15*d*k2*k3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**6*f**2*k1**2*k2**3*st*(495*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(130*r + 130*s - 81) + f*(22*C - 22)*(39*r + 39*s - 14) - 990*g2*(2*r + 2*s - 1))/(3465*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1*k2**2*st*(15*b1*(f*(9*r + 9*s - 5) + 12*r + 12*s - 6) + 2*f*(39*r + 39*s - 14))/(315*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1*k2**2*st*(33*b1*(k1**2*(6*K - 6)*(3*r + 3*s - 5) - 5*k2**2*(f*(9*r + 9*s - 5) + (6 - 12*K)*(2*r + 2*s - 1))) + 5*f**2*k1**2*(387*r + 387*s - 271) + 22*f*(k1**2*(6*C - 6)*(3*r + 3*s - 1) + k2**2*(4*C - 3)*(39*r + 39*s - 14)) - 396*g2*(k1**2*(3*r + 3*s - 5) + 10*k2**2*(2*r + 2*s - 1)))/(3465*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1**2*k2**3*st**3*(330*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(96*r + 96*s - 61) + f*(44*C - 44)*(9*r + 9*s - 4) - 660*g2*(2*r + 2*s - 1))/(1155*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k2*st*(126*b1**2*k1**2*(K - 1)*(r + s - 1) + 3*b1*(-30*K*f*k2**2*(2*r + 2*s - 1) + f**2*k1**2*(53*r + 53*s - 51) + 2*f*k1**2*(8*C*(r + s - 1) + r + s - 7) - 84*g2*k1**2*(r + s - 1)) - 2*f*(f*k1**2*(-9*r - 9*s + 3) + f*k2**2*(2*C - 1)*(39*r + 39*s - 14) + k2**2*(45*b2 - 90*g2)*(2*r + 2*s - 1)))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k2*st*(-1386*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 33*b1*(f**2*k1**2*k2**2*(27*r + 27*s - 25) + 2*f*(-15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(23*r + 23*s - 1) + k1**2*k2**2*(-2*C*(4*r + 4*s + 5) + 3*K*(8*r + 8*s + 3) - 25*r - 25*s + 16)) + 84*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k1**2*(3*k1**2*(r + s + 13) + 110*k2**2*(3*r + 3*s - 2)) + 22*f*(k1**4*(36*C - 36)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 27*r - 27*s + 15) - k2**4*(2*C - 1)*(39*r + 39*s - 14)) - 132*g2*(k1**4*(23*r + 23*s - 1) + 3*k1**2*k2**2*(8*r + 8*s + 3) - 15*k2**4*(2*r + 2*s - 1))))/(3465*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(5*b1*(f*(9*r + 9*s - 5) + 12*r + 12*s - 6) + 2*f*(9*r + 9*s - 4))/(105*d*k3**3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(11*b1*(k1**2*(3*K - 3)*(3*r + 3*s - 5) - 5*k2**2*(f*(9*r + 9*s - 5) + (6 - 12*K)*(2*r + 2*s - 1))) + 15*f**2*k1**2*(37*r + 37*s - 25) + 22*f*(k1**2*(3*C - 3)*(3*r + 3*s - 1) + k2**2*(4*C - 3)*(9*r + 9*s - 4)) - 66*g2*(k1**2*(3*r + 3*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k1*st*(3*b1**2*(k1**2*(7*K - 7)*(r + s - 1) - k2**2*(14*K*(r + s - 1) + 4*f + 7)) + b1*(f**2*(k1**2*(17*r + 17*s - 7) + 6*k2**2*(5*r + 5*s - 3)) + f*(k1**2*(18*C*(r + s - 1) + 5*r + 5*s + 17) + k2**2*(-16*C*(r + s - 1) + 3*K*(3*r + 3*s - 5) + 50*r + 50*s - 38)) - 42*g2*(k1**2 - 2*k2**2)*(r + s - 1)) + f*(6*f*k1**2*(2*r + 2*s - 1) + f*k2**2*(C*(6*r + 6*s - 2) + 15*r + 15*s - 8) + k2**2*(3*b2 - 6*g2)*(3*r + 3*s - 5)))/(105*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k1*st*(33*b1**2*(3*f*k2**4*(9*r + 9*s - 1) + 14*k2**2*(r + s)*(k1**2*(4*K - 4) + k2**2*(3 - 6*K))) - 22*b1*(2*f**2*k2**2*(5*k1**2*(6*r + 6*s - 1) + 9*k2**2*(5*r + 5*s - 3)) - 3*f*(k1**4*(K - 1)*(9*r + 9*s - 1) + k1**2*k2**2*(4*C*(3*r + 3*s - 5) + K*(88*r + 88*s - 30) - 77*r - 77*s + 49) - k2**4*(4*C*(4*r + 4*s + 5) - 3*K*(25*r + 25*s - 9) + 30*r + 30*s - 36)) + 84*g2*k2**2*(2*k1**2 - 3*k2**2)*(r + s)) + f*(5*f**2*(k1**4*(193*r + 193*s - 109) + 44*k1**2*k2**2*(15*r + 15*s - 11)) + 22*f*(k1**4*(2*C - 2)*(15*r + 15*s - 7) + 18*k1**2*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7) + 3*k2**4*(C*(66*r + 66*s - 34) - 51*r - 51*s + 26)) - 132*g2*(k1**4*(9*r + 9*s - 1) + 2*k1**2*k2**2*(44*r + 44*s - 15) + 3*k2**4*(25*r + 25*s - 9))))/(3465*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1**2*k2**3*st**5*(99*b1*(K - 1)*(2*r + 2*s - 1) + 3*f**2*(62*r + 62*s - 41) + f*(22*C - 22)*(3*r + 3*s - 2) - 198*g2*(2*r + 2*s - 1))/(693*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(-21*b1**2*k1**2*(K - 1)*(r + s - 1) + 3*b1*(10*K*f*k2**2*(2*r + 2*s - 1) + f**2*k1**2*(-13*r - 13*s + 11) + f*k1**2*(-4*C*(r + s - 1) + r + s + 1) + 14*g2*k1**2*(r + s - 1)) + f*(f*k1**2*(-9*r - 9*s + 3) + f*k2**2*(4*C - 2)*(9*r + 9*s - 4) + k2**2*(30*b2 - 60*g2)*(2*r + 2*s - 1)))/(105*d*k3**3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(231*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 33*b1*(f**2*k1**2*k2**2*(7*r + 7*s - 5) + f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(r + s + 3) + k1**2*k2**2*(C*(-4*r - 4*s + 2) + K*(8*r + 8*s + 3) - 7*r - 7*s)) + 14*g2*k1**2*k2**2*(r + s)) + f*(f**2*k1**2*(k1**2*(111*r + 111*s - 97) - 110*k2**2*(3*r + 3*s - 2)) + 11*f*k2**2*(3*k1**2*(C*(8*r + 8*s - 2) - 5*r - 5*s + 1) + k2**2*(4*C - 2)*(9*r + 9*s - 4)) + 66*g2*(k1**4*(r + s + 3) + k1**2*k2**2*(8*r + 8*s + 3) - 10*k2**4*(2*r + 2*s - 1))))/(1155*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*st*(-3*b1**2*(-21*K*k2**4 + k1**2*k2**2*(14*C*(r + s - 1) - 77*K*(r + s - 1) + f*(8*r + 8*s - 9) + 14*r + 14*s - 42)) + 3*b1*(f**2*k1**2*(k1**2*(15*r + 15*s - 11) + 9*k2**2*(6*r + 6*s - 5)) + f*(k1**4*(9*r + 9*s - 1) + k1**2*k2**2*(50*C*(r + s - 1) - 23*K*r - 23*K*s + K + 7*r + 7*s + 3) + 3*k2**4*(6*C - 7*K*(2*r + 2*s - 1) - 3)) + 7*k2**2*(3*b2*k2**2*(r + s) - 22*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + f*(f*(k1**4*(15*r + 15*s - 7) - 18*k1**2*k2**2*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3) + k2**4*(27 - 54*C)*(2*r + 2*s - 1)) + k2**2*(-3*b2 + 6*g2)*(k1**2*(23*r + 23*s - 1) + 21*k2**2*(2*r + 2*s - 1))))/(315*d*k2*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*st*(462*b1*k2**2*(r + s)*(b1*(-3*K*k2**4 + k1**4*(2*K - 2) + k1**2*k2**2*(13*K - 9)) - 2*g2*(2*k1**4 + 13*k1**2*k2**2 - 3*k2**4)) + 15*f**3*(k1**6*(21*r + 21*s - 13) + 22*k1**4*k2**2*(6*r + 6*s - 5)) - 22*f**2*(k1**4*k2**2*(C*(-78*r - 78*s + 46) + 3*b1*(6*r + 6*s + 1) + 63*r + 63*s - 39) + 9*k1**2*k2**4*(-4*C*(8*r + 8*s - 5) + 3*b1*(4*r + 4*s - 3) + 22*r + 22*s - 14) + k2**6*(27 - 54*C)*(2*r + 2*s - 1)) - 33*f*k2**2*(b1**2*k1**2*k2**2*(3*r + 3*s - 19) - 2*b1*(k1**4*(2*C*(3*r + 3*s - 5) + K*(25*r + 25*s - 9) - 22*r - 22*s + 18) + k1**2*k2**2*(C*(38*r + 38*s - 40) + K*(107*r + 107*s - 57) - 74*r - 74*s + 58) + k2**4*(-2*C*(4*r + 4*s + 5) + 21*K*(2*r + 2*s - 1) + 4*r + 4*s + 5)) + 4*g2*(k1**4*(25*r + 25*s - 9) + k1**2*k2**2*(107*r + 107*s - 57) + 21*k2**4*(2*r + 2*s - 1))))/(3465*d*k2*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(3*b1*(f*(9*r + 9*s - 5) + 12*r + 12*s - 6) + 2*f*(3*r + 3*s - 2))/(63*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(279*r + 279*s - 179) - 11*f*k2**2*(3*b1*(9*r + 9*s - 5) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(396*K*b1 - 198*b1 - 792*g2))/(693*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(-b1**2*k2**2*(14*K*(r + s - 1) + 4*f + 7) + b1*(f**2*(k1**2*(r + s + 1) + 2*k2**2*(5*r + 5*s - 3)) + f*(k1**2*(r + s + 3) + k2**2*(-8*C*(r + s - 1) + K*(3*r + 3*s - 5) + 18*r + 18*s - 12)) + 28*g2*k2**2*(r + s - 1)) + f*k2**2*(2*C*f*(3*r + 3*s - 1) + b2*(3*r + 3*s - 5) - f*r - f*s - 6*g2*r - 6*g2*s + 10*g2))/(35*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st*(-21*b1**3*k2**2*(r + s - 1) + 6*b1**2*(f*(5*k1**2*(3*r + 3*s - 1) + 14*k2**2) + 14*k1**2*(r + s) + 7*k2**2*(-4*C*(r + s - 1) + K*(9*r + 9*s - 13) + 3*r + 3*s + 2)) + 6*b1*(18*f**2*k1**2*(r + s - 1) + f*(k1**2*(-9*K*r - 9*K*s + K + 10*r + 10*s - 12) + k2**2*(C*(34*r + 34*s - 26) - 14*K*(3*r + 3*s - 2) - 17*r - 17*s + 20)) - 14*k2**2*(2*b2*(r + s) + g2*(9*r + 9*s - 13))) - 2*f*(3*b2*k1**2*(9*r + 9*s - 1) + 42*b2*k2**2*(3*r + 3*s - 2) + 2*f*k1**2*(C*(15*r + 15*s - 7) - 12*r - 12*s + 8) + f*k2**2*(36*C - 18)*(3*r + 3*s - 2) - 6*g2*k1**2*(9*r + 9*s - 1) - 84*g2*k2**2*(3*r + 3*s - 2)))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(462*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + f**3*(15*k1**4*(5*r + 5*s - 1) + 44*k1**2*k2**2*(15*r + 15*s - 11)) - 22*f**2*(2*b1*(k1**2*k2**2*(6*r + 6*s - 1) + 3*k2**4*(5*r + 5*s - 3)) + 3*k2**4*(-2*C*(r + s - 1) + 3*r + 3*s - 2)) + 33*f*k2**2*(b1**2*k2**2*(9*r + 9*s - 1) + 2*b1*(k1**2*(2*K - 1)*(r + s + 3) + k2**2*(C*(-8*r - 8*s + 4) + K*(25*r + 25*s - 9) - 8*r - 8*s + 4)) - 4*g2*(2*k1**2*(r + s + 3) + k2**2*(25*r + 25*s - 9))))/(1155*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st*(3*b1**2*k2**2*(f*(k1**2*(45*r + 45*s - 33) + 14*k2**2*(3*r + 3*s - 1)) + (r + s)*(-14*k1**2*(4*K - 2) - 14*k2**2*(14*K - 5))) - 3*b1*(f**2*(k1**4*(15*r + 15*s - 11) + 12*k1**2*k2**2) + 2*f*k2**2*(k1**2*(4*C*(3*r + 3*s - 5) + K*(23*r + 23*s - 15) - 16*r - 16*s + 22) + k2**2*(20*C*(2*r + 2*s - 1) + 14*K*(3*r + 3*s - 2) - 27*r - 27*s + 10)) - 56*g2*k2**2*(2*k1**2 + 7*k2**2)*(r + s)) - 2*f*(15*f**2*k1**4*(r + s - 1) + 2*f*(k1**2*k2**2*(C*(33*r + 33*s - 25) - 21*r - 21*s + 17) + k2**4*(18*C - 9)*(3*r + 3*s - 2)) - 6*g2*k2**2*(k1**2*(23*r + 23*s - 15) + 14*k2**2*(3*r + 3*s - 2))))/(315*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(99*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(3*b1*(-6*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(5*r + 5*s - 3)) + 2*k2**2*(-9*b2*(2*r + 2*s - 1) - f*(2*C - 1)*(3*r + 3*s - 2) + 18*g2*(2*r + 2*s - 1)))/(63*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(-33*b1*f*k1**2*k2**2*(3*r + 3*s - 1) + f**2*(k1**4*(45*r + 45*s - 31) - 22*k1**2*k2**2*(3*r + 3*s - 2)) + f*k2**4*(44*C - 22)*(3*r + 3*s - 2) + k2**4*(198*K*b1 - 396*g2)*(2*r + 2*s - 1))/(693*d*k3**5) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(3*b1**2*(-7*K*k2**4 + f*k1**2*k2**2*(4*r + 4*s - 1)) + b1*(f**2*(k1**4*(-3*r - 3*s + 1) - 3*k1**2*k2**2*(6*r + 6*s - 5)) + 3*f*(K*k1**2*k2**2*(r + s + 3) + 7*K*k2**4*(2*r + 2*s - 1) + k2**4*(1 - 2*C)) - 21*k2**4*(b2*(r + s) - 2*g2)) + 3*f*k2**2*(b2*(k1**2*(r + s + 3) + 7*k2**2*(2*r + 2*s - 1)) + f*k2**2*(2*C - 1)*(2*r + 2*s - 1) - 2*g2*(k1**2*(r + s + 3) + 7*k2**2*(2*r + 2*s - 1))))/(105*d*k2*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st*(7*b1**3*k1**2*k2**2*(r + s - 1) - 2*b1**2*(-14*K*k1**2*k2**2*(r + s) + f*k1**4*(9*r + 9*s - 5) + 7*f*k1**2*k2**2*(2*r + 2*s - 1) - 7*k2**4*(2*C*(r + s - 1) + 5*K - r - s + 1)) + 2*b1*k2**2*(7*b2*(2*k1**2 + 5*k2**2)*(r + s) + f*k1**2*(2*C*(3*r + 3*s - 5) + 7*K*(r + s - 1) - 3*r - 3*s + 5) + f*k2**2*(14*C - 7) - 14*g2*(2*k1**2*(r + s) + 5*k2**2)) + 2*f*k1**2*k2**2*(7*b2 + f*(6*C - 3) - 14*g2)*(r + s - 1))/(105*d*k2*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(-462*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*(3*k1**6*(5*r + 5*s - 1) + 22*k1**4*k2**2*(6*r + 6*s - 5)) - 22*f**2*(b1*k1**4*k2**2*(6*r + 6*s - 1) + 3*b1*k1**2*k2**4*(4*r + 4*s - 3) + k2**6*(3 - 6*C)*(2*r + 2*s - 1)) + 33*f*k2**4*(b1**2*k1**2*(9*r + 9*s - 1) + 2*b1*(K*k1**2*(r + s + 3) + 7*K*k2**2*(2*r + 2*s - 1) - k2**2*(2*C - 1)*(2*r + 2*s - 1)) - 4*g2*(k1**2*(r + s + 3) + 7*k2**2*(2*r + 2*s - 1))))/(1155*d*k2*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st*(3*b1**2*(-14*K*k2**4*(2*k1**2 + 5*k2**2)*(r + s) + f*k1**4*k2**2*(15*r + 15*s - 11) + 14*f*k1**2*k2**4*(3*r + 3*s - 1)) + b1*(-f**2*k1**4*(k1**2*(15*r + 15*s - 7) + 18*k2**2*(2*r + 2*s - 1)) - 6*f*k2**4*(k1**2*(2*C*(3*r + 3*s - 5) + 7*K*(r + s - 1) - 3*r - 3*s + 5) + k2**2*(14*C - 7)*(r + s)) + 84*g2*k2**4*(2*k1**2 + 5*k2**2)*(r + s)) - 6*f*k1**2*k2**4*(f*(6*C - 3) - 14*g2)*(r + s - 1))/(315*d*k2*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**3*f*k1*st*(-4*Pk2 + Pkd2*k2)*(3*b1*f*(9*s - 8) + 42*b1*(s - 1) + 2*f*(4*s - 9))/(105*d*k2**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**2*f*st*(-21*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 21*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-16*C*s + 36*C + 21*b1*(r - 1) + 6*r + 8*s - 35) + Pkd2*k2*(2*C - 1)*(4*s - 9)) + 42*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(105*d*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*k1*st**3*(-4*Pk2 + Pkd2*k2)*(b1*f*(9*s - 8) + 14*b1*(s - 1) + 2*f*(2*s - 1))/(35*d*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*st*(7*b1**2*k1**2*s*(2*Pk2 - Pkd2*k2) + 14*b1*k1**2*(Pk2*(6*f*s - 4*f + 5*s - 7) + Pkd2*k2*(-3*f*s + 2*f - 4*s + 5)) + 2*f*(Pk2*k2**2*(4*C - 2)*(5*r - 6) + k1**2*(Pk2*(5*s - 13) - 7*Pkd2*k2*(s - 1))))/(105*d*k1*k2**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st**3*(-7*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 7*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-8*C*s + 4*C + 7*b1*(r - 1) - 2*r + 4*s - 1) + Pkd2*k2*(2*C - 1)*(2*s - 1)) + 14*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(35*d*k2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st*(-2*C*Pkd2*f*k2*s + 2*C*Pkd2*f*k2 + 5*Pk2*b1**2*(r - 1) + Pk2*f*r - 5*Pkd2*b2*k2*(s - 1) + Pkd2*f*k2*s - Pkd2*f*k2 + 10*Pkd2*g2*k2*s - 10*Pkd2*g2*k2 + b1*(4*Pk2*r + Pk2 - Pkd2*k2*(-2*C*s + 5*K*(s - 1) + s)))/(15*d*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**6*f**2*k1**2*k2*st*(-4*Pk2 + Pkd2*k2)*(495*b1*(K - 1)*(2*s - 1) + 5*f**2*(130*s - 49) + f*(22*C - 22)*(39*s - 25) + 990*g2*(1 - 2*s))/(3465*d*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1*st*(4*Pk2 - Pkd2*k2)*(15*b1*(f*(9*s - 4) + 12*s - 6) + 2*f*(39*s - 25))/(315*d*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1*st*(33*b1*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(9*s - 8) + 5*k2**2*(-24*K*Pk2*(r - 2*s + 1) - 12*K*Pkd2*k2*(2*s - 1) + 48*Pk2*r + 12*Pkd2*k2*s - 6*Pkd2*k2 + f*(2*Pk2*(9*r - 1) + Pkd2*k2*(9*s - 4)))) + 15*f**2*(88*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(57*s - 28)) + 22*f*(k1**2*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(39*s - 40) + k2**2*(-6*Pk2*(C*(22*r - 52*s + 54) - 35*r + 26*s - 41) - Pkd2*k2*(4*C - 3)*(39*s - 25))) + 396*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(9*s - 8) + 10*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(3465*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1**2*k2*st**3*(-4*Pk2 + Pkd2*k2)*(330*b1*(K - 1)*(2*s - 1) + 5*f**2*(96*s - 35) + f*(44*C - 44)*(9*s - 5) + 660*g2*(1 - 2*s))/(1155*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*st*(63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + 3*b1*(f**2*(15*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(39*s - 25)) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(4*s - 9) + 19*s - 6) + 15*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(f*k1**2*(4*Pk2 - Pkd2*k2)*(39*s - 40) + f*k2**2*(Pk2*(-4*C*(39*s - 25) - 27*r + 78*s - 101) + Pkd2*k2*(2*C - 1)*(39*s - 25)) + k2**2*(-2*Pk2 + Pkd2*k2)*(45*b2 - 90*g2)*(2*s - 1)))/(315*d*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*st*(693*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 33*b1*(f**2*k2**2*(-15*Pk2*k2**2*(r - 1) + k1**2*(Pk2*(53*r + s - 1) + Pkd2*k2*(26*s - 25))) + f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 9) - k1**2*k2**2*(-2*Pk2*(8*C*(r + 2*s - 1) - 6*K*(r - 5*s + 6) + 7*r - 10*s + 5) + Pkd2*k2*(3*K*(4*s - 9) + s*(8*C + 7) + 3)) - 15*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 42*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(990*Pk2*b2*k2**4*(2*r + 2*s - 1) - 5*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(52*s - 35) + 55*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 11*f*(k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(-4*C*Pk2*(3*r - 54*s + 104) + 30*Pk2*(r - 4*s + 11) + Pkd2*k2*(C*(106 - 48*s) + 9*s - 66)) + k2**4*(Pk2*(-4*C*(66*r + 39*s + 37) + 159*r + 78*s + 125) - Pkd2*k2*(2*C - 1)*(39*s - 25))) + 66*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 9) - 3*k1**2*k2**2*(4*Pk2*(r - 5*s + 6) + Pkd2*k2*(4*s - 9)) - 15*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(9*s - 4) + 12*s - 6) + 2*f*(9*s - 5))/(105*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(11*b1*(k1**2*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(9*s - 8) + 5*k2**2*(-24*K*Pk2*(r - 2*s + 1) - 12*K*Pkd2*k2*(2*s - 1) + 48*Pk2*r + 12*Pkd2*k2*s - 6*Pkd2*k2 + f*(2*Pk2*(9*r - 1) + Pkd2*k2*(9*s - 4)))) + 5*f**2*(88*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(47*s - 20)) + 22*f*(k1**2*(C - 1)*(4*Pk2 - Pkd2*k2)*(15*s - 8) + k2**2*(Pk2*(-4*C*(6*r - 18*s + 13) + 42*r - 36*s + 34) - Pkd2*k2*(4*C - 3)*(9*s - 5))) + 66*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(9*s - 8) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(1155*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st*(-9*b1**2*k1**2*k2**2*(-2*Pk2*(-7*K*(r - 2*s + 2) + 4*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 4*f + 7)) + b1*k1**2*(f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(39*s - 40) + 18*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) + 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 9) + k2**2*(Pk2*(4*C*(r + 8*s - 29) - 6*K*(9*s - 8) + 11*r - 82*s + 131) + Pkd2*k2*(-4*C*(4*s - 9) + 3*K*(9*s - 8) + 50*s - 48))) + 252*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(4 - 8*C)*(3*r - 10) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 5) + k1**2*k2**2*(Pk2*(-156*C*s + 160*C + 33*r - 107) + Pkd2*k2*(78*C*s - 80*C + 15*s + 13))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(9*b2 - 18*g2)*(9*s - 8)))/(315*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st*(-462*b1*k1**2*k2**2*(b1*k1**2*(K - 1)*(Pk2*(-6*r - 8*s + 6) + Pkd2*k2*s) + 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 2*g2*k1**2*(Pk2*(6*r + 8*s - 6) - Pkd2*k2*s) + 12*g2*k2**2*(-Pk2*(r + 2*s - 2) + Pkd2*k2*s)) - 5*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(59*s - 56) + 44*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) + 22*f**2*(Pk2*k2**6*(4 - 8*C)*(3*r - 10) + k1**4*k2**2*(2*Pk2*(-2*C*(12*r + 9*s - 13) + b1*(51*r + 51*s - 81) + 60*r + 45*s - 29) + 3*Pkd2*k2*(C*(4 - 24*s) + 20*b1 + 27*s - 9)) + k1**2*k2**4*(3*Pk2*(-4*C*(26*r + 7*s - 26) + 12*b1*(9*r + 5*s - 5) + 135*r + 60*s - 97) + Pkd2*k2*(-138*C*s + 28*C + 18*b1*(5*s - 2) + 123*s - 41))) + 33*f*k1**2*k2**2*(12*Pk2*b2*k2**2*(3*r + 3*s - 5) - 3*b1**2*k2**2*(16*Pk2 + 9*Pkd2*k2*s) + 2*b1*k1**2*(2*Pk2*(6*C*(3*r + 2*s - 3) - 10*K*r + 7*K*s + 15*r + 26) + Pkd2*k2*(6*C*s + K*(10 - 34*s) + 32*s - 19)) + 2*b1*k2**2*(-Pk2*(4*C*(9*r + 8*s - 19) + 6*K*(16*r + 3*s + 2) - 203*r - 118*s + 129) + Pkd2*k2*(K*(18 - 57*s) + s*(16*C + 30) - 21)) + 4*g2*(2*Pk2*k1**2*(10*r - 7*s) + 6*Pk2*k2**2*(16*r + 3*s + 2) + 2*Pkd2*k1**2*k2*(17*s - 5) + 3*Pkd2*k2**3*(19*s - 6))))/(3465*d*k1*k2**2*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1**2*k2*st**5*(-4*Pk2 + Pkd2*k2)*(99*b1*(K - 1)*(2*s - 1) + 3*f**2*(62*s - 21) + f*(22*C - 22)*(3*s - 1) + 198*g2*(1 - 2*s))/(693*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(21*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + 3*b1*(2*f**2*(5*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(9*s - 5)) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(4*s - 2) + 5*s - 6) + 10*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 14*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(f*k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 8) + 2*f*k2**2*(-4*C*Pk2*(9*s - 5) - 3*Pk2*(r - 6*s + 5) + Pkd2*k2*(2*C - 1)*(9*s - 5)) + k2**2*(-2*Pk2 + Pkd2*k2)*(30*b2 - 60*g2)*(2*s - 1)))/(105*d*k2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st*(3*b1**2*(21*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(14*C*s - 14*K*(s - 1) + f*(8*s + 9) - 7*s - 14) - Pkd2*k2*(-35*K*(s - 1) + f*(8*s + 9) + 7*s*(2*C + 2) - 35))) + 3*b1*(21*Pkd2*b2*k2**3*s + 9*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(8*C*(s + 3) - 8*K*s + 18*K + 24*r - 59*s + 22) + Pkd2*k2*(14*C*(s - 1) + 4*K*s - 9*K + 25*s - 14)) + k2**2*(Pk2*(24*C*r - 68*C - 42*K*r + 30*r + 34) + 3*Pkd2*k2*(6*C - 14*K*s + 7*K - 3))) + 14*g2*k1**2*(4*Pk2 - 5*Pkd2*k2)*(s - 1) - 42*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-3*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 9) + 21*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*k1**2*(Pk2*(-36*C*s + 60*C + 33*r - 45*s + 13) + 3*Pkd2*k2*(6*C*s - 10*C + 15*s - 7)) - 3*f*k2**2*(Pk2*(8*C*(6*r - 5) - 42*r + 20) + Pkd2*k2*(18*C - 9)*(2*s - 1)) + 6*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 9) + 126*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))))/(315*d*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(231*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 33*b1*(2*f**2*k2**2*(-5*Pk2*k2**2*(r - 1) + k1**2*(Pk2*(13*r + s - 1) + Pkd2*k2*(6*s - 5))) + f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k1**2*k2**2*(-2*Pk2*(4*C*(r + 2*s - 1) - 2*K*(r - 5*s + 6) + r - 6*s + 3) + Pkd2*k2*(4*C*s + K*(4*s - 9) + s + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 14*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(660*Pk2*b2*k2**4*(2*r + 2*s - 1) - 2*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(56*s - 25) + 55*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 11*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-12*C*(3*r - 10*s + 4) + 54*r - 72*s + 26) + Pkd2*k2*(C*(26 - 48*s) + 33*s - 18)) + 2*k2**4*(Pk2*(-4*C*(12*r + 9*s + 1) + 27*r + 18*s + 7) - Pkd2*k2*(2*C - 1)*(9*s - 5))) + 66*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(-4*Pk2*(r - 5*s + 6) + Pkd2*k2*(9 - 4*s)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(1155*d*k2*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st*(3*b1**2*(k1**4*s*(7 - 7*K)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(-2*Pk2*(14*C*(r + s - 1) - 7*K*(5*r + 8*s - 11) + f*(8*r + 8*s - 9) - 28*r - 7*s - 42) + Pkd2*k2*s*(-49*K - 12*f + 42)) + 21*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + 3*b1*(42*Pk2*b2*k2**4*(r + s) + f**2*k1**2*(k1**2*(2*Pk2*(15*r + 9*s - 16) + Pkd2*k2*(6*s + 5)) + 9*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) - f*(k1**4*(2*Pk2*(12*C*s + 2*K*(s + 3) - 9*r - 23*s - 5) + Pkd2*k2*(-12*C*s + 7*K*(s - 1) + 5*s + 7)) + k1**2*k2**2*(Pk2*(C*(-64*r - 64*s + 68) + 2*K*(89*r + 50*s - 11) - 158*r - 77*s + 36) + Pkd2*k2*(K*(80*s - 47) + s*(2*C - 47) + 28)) + k2**4*(Pk2*(8*C*(3*r - 2*s - 13) + 42*K*(5*r + 4*s - 2) - 60*r + 8*s + 69) + Pkd2*k2*(21*K*(2*s - 1) + s*(4 - 8*C)))) - 14*g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(2*Pk2*(5*r + 8*s - 11) - 7*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(-6*Pk2*b2*k2**2*(k1**2*(23*r + 23*s - 1) + 21*k2**2*(2*r + 2*s - 1)) - 15*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*(-2*k1**4*(Pk2*(4*C*(3*s + 5) - 15*r - 27*s - 13) + Pkd2*k2*(9*C - 9)*(s - 1)) + k1**2*k2**2*(Pk2*(-4*C*(123*r + 81*s - 47) + 495*r + 315*s - 195) + 3*Pkd2*k2*(C*(38 - 66*s) + 51*s - 31)) - 3*k2**4*(2*Pk2*(8*C*(12*r + 9*s - 7) - 57*r - 36*s + 28) + Pkd2*k2*(18*C - 9)*(2*s - 1))) + 6*g2*(k1**4*(4*Pk2*(s + 3) + 7*Pkd2*k2*(s - 1)) + k1**2*k2**2*(2*Pk2*(89*r + 50*s - 11) + Pkd2*k2*(80*s - 47)) + 21*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(315*d*k2*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(4*Pk2 - Pkd2*k2)*(3*b1*(f*(9*s - 4) + 12*s - 6) + 2*f*(3*s - 1))/(63*d*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(3*f**2*(88*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(37*s - 12)) + 11*f*k2**2*(6*Pk2*b1*(9*r - 1) - 4*Pk2*(2*C*(3*r - 6*s + 1) - 9*r + 6*s + 1) + 3*Pkd2*b1*k2*(9*s - 4) - Pkd2*k2*(8*C - 6)*(3*s - 1)) - 198*k2**2*(b1*(4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(2*s - 1) - 8*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2) - 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(693*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*k1*st*(21*Pkd2*b1**3*k2**3*s + 6*b1**2*(Pk2*k1**2*s*(-6*f - 14) + 7*Pk2*k2**2*(4*C*(r - 1) - 10*K*r - 6*K*s + 6*K - 8*f*r + 4*f - 5*r + 1) + Pkd2*k1**2*k2*s*(3*f + 7) - 7*Pkd2*k2**3*(-4*C*s + 9*K*s - 10*K + 2*f + 3*s + 5)) + 6*b1*(6*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) - f*(k1**2*(Pk2*(7*s + 13) + Pkd2*k2*(s - 7)) + k2**2*(Pk2*(4*C*(7*r + 9*s - 1) - 28*K*r + 35*r - 18*s - 11) + Pkd2*k2*(C*(34*s - 28) - 42*K*s + 28*K - 17*s + 21))) + 7*k2**2*(4*Pk2*g2*(5*r + 3*s - 3) + Pkd2*b2*k2*s + 2*Pkd2*g2*k2*(9*s - 10))) + 2*f*(f*(k1**2*(Pk2*(3*s - 19) - 9*Pkd2*k2*(s - 1)) + 2*k2**2*(2*Pk2*(21*C*r - 10*C - 24*r + 5) + Pkd2*k2*(18*C - 9)*(3*s - 2))) + k2**2*(42*b2 - 84*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(315*d*k2**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(3*b1**2*k1**2*k2**2*(-2*Pk2*(-7*K*(r - 2*s + 2) + 4*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 4*f + 7)) + b1*k1**2*(f**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 8) + 6*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) - 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-4*C*(2*r - 4*s + 1) - 18*K*s + 16*K + 13*r - 30*s + 13) + Pkd2*k2*(C*(4 - 8*s) + 9*K*s - 8*K + 18*s - 10))) - 84*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(8*C - 4)*(3*r - 2) - k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(60*C*s - 32*C + 3*r - 24*s + 11) + Pkd2*k2*(-30*C*s + 16*C + 9*s - 5))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-3*b2 + 6*g2)*(9*s - 8)))/(105*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(462*b1*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + f**3*(-5*k1**6*(4*Pk2 - Pkd2*k2)*(21*s - 8) - 44*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) + 22*f**2*(4*Pk2*k2**6*(C*(4 - 6*r) + 3*r - 2) + k1**4*k2**2*(2*Pk2*(2*C*(3*r - 9*s - 1) + 3*b1*(r + s - 3) - 6*r + 15*s + 3) + Pkd2*k2*(12*b1 + (4*C - 3)*(3*s - 1))) + k1**2*k2**4*(Pk2*(4*C*(6*r + 3*s - 2) + 12*b1*(9*r + 5*s - 5) + 9*r + 12*s - 3) + Pkd2*k2*(C*(6*s - 4) + 6*b1*(5*s - 2) + 3*s - 1))) - 33*f*k1**2*k2**2*(-4*Pk2*b2*k2**2*(3*r + 3*s - 5) + b1**2*k2**2*(16*Pk2 + 9*Pkd2*k2*s) - 2*b1*(k1**2*(2*Pk2*(-7*K*s + r*(2*K - 1) + 6*s + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + k2**2*(-Pk2*(4*C*(2*r + 4*s - 3) + K*(32*r + 6*s + 4) - 61*r - 42*s + 23) + Pkd2*k2*(K*(6 - 19*s) + s*(8*C + 8) - 7))) - 4*g2*(2*Pk2*k1**2*(-2*r + 7*s) + 2*Pk2*k2**2*(16*r + 3*s + 2) + 2*Pkd2*k1**2*k2*(1 - 2*s) + Pkd2*k2**3*(19*s - 6))))/(1155*d*k1*k2**2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st*(-42*b1*k1**2*k2**2*(Pk2*b1**2*k2**2*(r + s - 1) + 8*Pk2*b2*k2**2*(r + s) + 4*Pk2*g2*k1**2*(r - 3*s) - 4*Pk2*g2*k2**2*(7*r + 5*s + 13) + 4*Pkd2*g2*k1**2*k2*s - 22*Pkd2*g2*k2**3*s + b1*(-2*Pk2*k1**2*(K*r - 3*K*s + r + 5*s) + Pk2*k2**2*(8*C*(r + s - 1) + 2*K*(7*r + 5*s + 13) - 27*r - 19*s - 4) + Pkd2*k1**2*k2*s*(1 - 2*K) + Pkd2*k2**3*s*(11*K - 5))) + 10*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) + f**2*(15*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) - 2*k1**4*k2**2*(Pk2*(24*C*(4*r + 5*s - 1) + 36*b1*r - 108*b1*s - 84*r - 93*s + 29) + 9*Pkd2*k2*(6*b1 + (4*C - 3)*(s - 1))) - 4*k1**2*k2**4*(2*Pk2*(C*(129*r + 108*s - 82) - 78*r - 54*s + 41) + Pkd2*k2*(18*C - 9)*(3*s - 2))) - 3*f*k2**2*(-b1**2*k1**2*(k1**2*(20*Pk2*(3*r + 3*s - 1) - 9*Pkd2*k2*s) + 14*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) + 2*b1*(Pk2*k2**4*(4*C - 2)*(5*r - 6) + k1**4*(Pk2*(C*(-24*r + 36*s + 12) + 4*K*(8*r + 9*s - 1) - 10*r - 65*s + 13) + Pkd2*k2*(14*K*(s - 1) + s*(11 - 24*C) + 7)) + k1**2*k2**2*(Pk2*(4*C*(11*r + 3*s - 1) + 28*K*(7*r + 6*s - 4) - 99*r - 29*s + 2) + 2*Pkd2*k2*(7*K*(3*s - 2) + s*(11*C - 9)))) + 4*k1**2*(Pk2*b2*(k1**2*(9*r + 9*s - 1) + 14*k2**2*(3*r + 3*s - 2)) - 2*g2*(k1**2*(2*Pk2*(8*r + 9*s - 1) + 7*Pkd2*k2*(s - 1)) + 7*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2))))))/(315*d*k1*k2**2*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**4*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)/(99*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(3*b1*(3*K*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 3*Pk2*f*k2**2*(r - 1) - 6*Pk2*k2**2*r + f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + k2**2*(-9*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - f*(Pk2*(12*C*s - 4*C + 3*r - 6*s + 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) + 18*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(63*d*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(f**2*(-9*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 11*k1**2*k2**2*(Pk2*(-9*r + 6*s + 5) + Pkd2*k2*(1 - 3*s))) - 11*f*(-9*Pk2*b1*k2**4*(r - 1) + Pk2*k2**4*(-12*C*(2*r + s - 1) + 15*r + 6*s - 7) + Pkd2*k2**5*(C*(2 - 6*s) + 3*s - 1) + 3*b1*k1**2*k2**2*(Pk2*(5*r + s - 1) + Pkd2*k2*(2*s - 1))) + 99*k2**4*(2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(693*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(3*b1**2*(7*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) + 3*b1*(f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) - f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(4*K*s - 2*K + 2*r - 3*s - 2)) + k2**2*(2*Pk2*(4*C*r - 2*C + 7*K*r - 9*r + 1) + Pkd2*k2*(-2*C + 14*K*s - 7*K + 1))) + 7*k2**2*(4*Pk2*g2*r + Pkd2*b2*k2*s - 2*Pkd2*g2*k2)) + f*(-3*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 7*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*k1**2*(Pk2*(-12*C*s + 4*C - 3*r + 9*s + 1) + Pkd2*k2*(2*C - 1)*(3*s - 1)) + f*k2**2*(Pk2*(-24*C*r + 8*C + 18*r - 4) + 3*Pkd2*k2*(-4*C*s + 2*C + 2*s - 1)) + 6*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 42*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))))/(105*d*k2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st*(7*b1**3*k2*(-5*Pk2*k2*(r - 1) + Pkd2*k1**2*s) + 7*b1**2*(K*Pkd2*k1**2*k2*s - Pk2*k1**2*(r - 3*s) + Pk2*k2**2*(-4*C*(r + s - 1) - 10*K + 3*r + 2*s - 3) + Pkd2*k2**3*(-2*C*s - 5*K + s) + f*k1**2*(Pk2*(6*r - 4) + Pkd2*k2*(2*s + 1))) + b1*(7*b2*k2*(-10*Pk2*k2*(r + s) + Pkd2*k1**2*s - 5*Pkd2*k2**2*s) + f*k1**2*(Pk2*(r + 9*s + 3) + Pkd2*k2*(-7*K*(s - 1) + s*(12*C - 6))) - f*k2**2*(2*C - 1)*(2*Pk2*(5*r + 1) + 7*Pkd2*k2) + 14*g2*k2*(10*Pk2*k2 - Pkd2*k1**2*s + 5*Pkd2*k2**2)) + f*k1**2*(3*Pk2*f*r - 7*Pkd2*b2*k2*(s - 1) - Pkd2*f*k2*(6*C - 3)*(s - 1) + 14*Pkd2*g2*k2*(s - 1)))/(105*d*k2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(-3*b1**2*(f*(-7*Pk2*k2**4*(r - 1) + k1**2*k2**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) - 7*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + b1*(f**2*k1**2*(k1**2*(Pk2*(6*r - 6*s - 4) + Pkd2*k2*(6*s + 1)) + 3*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + 3*f*k2**2*(k1**2*(K*Pkd2*k2*(2*s - 1) + Pk2*(2*K*(r - 4*s - 5) - 2*r + 3*s + 2)) + k2**2*(Pk2*(8*C*s - 14*K*(5*r + 4*s - 2) + r*(8*C + 8) - 4*s + 1) + Pkd2*k2*(4*C*s - 14*K*s + 7*K - 2*s))) - 42*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) - f*(f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*k2**2*(k1**2*(Pk2*(9 - 12*C)*(r - s - 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) + k2**2*(2*Pk2*(4*C*(9*r + 6*s - 4) - 21*r - 12*s + 8) + Pkd2*k2*(6*C - 3)*(2*s - 1))) + 6*k2**2*(Pk2*b2*k1**2*(r + s + 3) + 7*Pk2*b2*k2**2*(2*r + 2*s - 1) + g2*k1**2*(2*Pk2*(r - 4*s - 5) + Pkd2*k2*(2*s - 1)) - 7*g2*k2**2*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(105*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st*(7*Pk2*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(-f*k1**2*(2*k1**2*(Pk2*(9*r + 9*s - 5) - 3*Pkd2*k2*s) + 7*k2**2*(Pk2*(13*r + 10*s - 7) + 3*Pkd2*k2*s)) + 7*k2**2*(-K*Pkd2*k1**2*k2*s + 5*K*Pkd2*k2**3*s + Pk2*k1**2*(2*K*r + r + s*(8*K - 3)) + Pk2*k2**2*(4*C*(r + s - 1) + 10*K*(2*r + 2*s + 1) - 7*r - 2*s + 2))) + b1*(3*f**2*k1**4*(Pk2*(5*r - 3) + Pkd2*k2*(2*s + 1)) + f*k2**2*(k1**2*(Pk2*(-4*C*(3*r - 6*s + 2) + 28*K*(r + s - 1) + 5*r - 21*s + 1) + Pkd2*k2*(7*K*(s - 1) + s*(6 - 12*C))) + k2**2*(Pk2*(C*(76*r + 56*s + 4) - 45*r - 28*s - 2) + Pkd2*k2*s*(14*C - 7))) + 14*k2**2*(Pk2*b2*(2*k1**2 + 5*k2**2)*(r + s) - g2*(2*Pk2*k1**2*(r + 4*s) + 10*Pk2*k2**2*(2*r + 2*s + 1) - Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s))) + f*k1**2*k2**2*(14*Pk2*b2*(r + s - 1) + 3*f*(Pk2*(8*C*(r + s - 1) - 5*r - 4*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1)) - 14*g2*(4*Pk2*(r + s - 1) + Pkd2*k2*(s - 1))))/(105*d*k2*k3**4)
        
        return (perm12+perm13+perm23)
    
    def l3(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -32*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*b1*f*k1*(9*b1*k1**2*(r + s) + f*k1**2*(2*r + 2*s - 1) - 9*f*k2**2*(r + s))/(315*d*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f**2*k1*k2**2*st**4*(33*b1*(2*r + 2*s - 1) + f*(7*r + 7*s - 1))/(1155*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k1*st**2*(-297*b1**2*k2**2*(r + s) + 11*b1*f*(k1**2*(7*r + 7*s + 1) + 6*k2**2*(5*r + 5*s - 4)) + f**2*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)))/(3465*d*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*b1*f*k1**2*(9*b1*r + f*(2*r - 1))/(315*d*k3**2) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f**2*k2**2*st**4*(-22*b1*r + f*(5*r - 9))/(1155*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f*st**2*(-99*b1**2*k2**2*r + 11*b1*f*(7*k1**2*r + k2**2*(7*r - 8)) + f**2*k1**2*(37*r - 16))/(3465*d*k3**2) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**7*f**2*k2**3*(C - 1)*(22*b1*(2*r + 2*s - 1) + f*(41*r + 41*s - 20))/(693*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**6*f**2*k2**2*(-22*b1*(k1**2*(3*C*(11*r + 11*s - 7) - 43*r - 43*s + 26) - 5*k2**2*(2*r + 2*s - 1)) - 5*f*(k1**2*(38*C*(3*r + 3*s - 2) - 155*r - 155*s + 96) + k2**2*(-41*r - 41*s + 20)))/(3465*d*k1*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**5*f**2*k2**3*st**2*(C - 1)*(-55*b1*(2*r + 2*s - 1) + f*(108*r + 108*s - 83))/(3465*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**5*f*k2*(-198*b1**2*k2**2*(C - 1)*(r + s) - 11*b1*f*(3*k1**2*(2*C*(5*r + 5*s - 4) - 21*r - 21*s + 15) - k2**2*(18*C*(3*r + 3*s - 2) + 19*r + 19*s - 5)) - 5*f**2*(k1**2*(C*(26*r + 26*s - 32) - 83*r - 83*s + 70) + k2**2*(-2*C*(85*r + 85*s - 42) + 31*r + 31*s - 6)))/(3465*d*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f**2*k2**2*st**2*(11*b1*k1**2*(9*C*(5*r + 5*s - 1) - 35*r - 35*s + 4) + 55*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(C*(501*r + 501*s - 345) - 609*r - 609*s + 428) + f*k2**2*(-108*r - 108*s + 83))/(3465*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f*(99*b1**2*k2**2*(r + s)*(k1**2*(7 - 6*C) + k2**2) - 11*b1*f*(k1**4*(C*(4*r + 4*s - 2) - 19*r - 19*s + 14) - 2*k1**2*k2**2*(9*C*(5*r + 5*s - 4) - 8*r - 8*s + 13) + k2**4*(7*r + 7*s - 8)) + 5*f**2*(k1**4*(C*(6*r + 6*s - 4) + 7*r + 7*s - 12) + k1**2*k2**2*(82*C*(3*r + 3*s - 2) - 163*r - 163*s + 94) - 22*k2**4*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f**2*k2**3*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(19*r + 19*s - 9))/(1155*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f*k2*st**2*(594*b1**2*k2**2*(C - 1)*(r + s) - 11*b1*f*(k1**2*(18*C - 27)*(5*r + 5*s - 1) + k2**2*(2*C*(77*r + 77*s - 43) - 159*r - 159*s + 75)) + f**2*(k1**2*(C*(-578*r - 578*s + 378) + 1079*r + 1079*s - 723) + k2**2*(C*(300*r + 300*s - 266) + 633*r + 633*s - 411)))/(3465*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f*(-99*b1**2*k2**2*(r + s)*(k1**2*(6*C - 9) - k2**2*(2*C + 3)) + 11*b1*f*(k1**4*(2*r + 2*s - 1) + 2*k1**2*k2**2*(18*C*(r + s - 1) - 8*r - 8*s + 13) + k2**4*(4*C*(r + s + 4) - 30*r - 30*s + 15)) - 5*f**2*(k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(C*(-70*r - 70*s + 76) + 113*r + 113*s - 90) + 22*k2**4*(C*(4*r + 4*s - 2) + 3*r + 3*s - 2)))/(3465*d*k2*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f**2*k2**2*st**4*(-11*b1*(k1**2*(6*C - 11) - 5*k2**2)*(2*r + 2*s - 1) + f*(k1**2*(-2*C*(7*r + 7*s - 1) + 33*r + 33*s - 11) + k2**2*(19*r + 19*s - 9)))/(1155*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*st**2*(-297*b1**2*k2**2*(r + s)*(k1**2*(3 - 2*C) + k2**2) - 11*b1*f*(k1**4*(2*C*(7*r + 7*s + 1) - 59*r - 59*s + 7) - 6*k1**2*k2**2*(5*C*(r + s + 1) + 27*r + 27*s - 15) - 3*k2**4*(19*r + 19*s - 11)) + f**2*(k1**4*(C*(-74*r - 74*s + 42) + 363*r + 363*s - 231) + k1**2*k2**2*(C*(936*r + 936*s - 646) + 421*r + 421*s - 266) + 33*k2**4*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*(99*b1**2*k1**2*(r + s)*(k1**2*(2*C - 5) - k2**2*(6*C + 3)) - 11*b1*f*(k1**4*(r + s + 4) - 6*k1**2*k2**2*(C*(r + s - 5) + 5*r + 5*s - 1) - 9*k2**4*(r + s)) + 10*f**2*k1**2*(k1**2*(C*(3*r + 3*s - 2) + 11*r + 11*s - 11) + 11*k2**2*(C*(6*r + 6*s - 4) + r + s - 1)))/(3465*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f**2*k2*st**4*(11*b1*(3*k1**2 + k2**2*(10*C + 3))*(2*r + 2*s - 1) + f*(k1**2*(7*r + 7*s - 1) + k2**2*(2*C*(19*r + 19*s - 9) + 7*r + 7*s - 1)))/(1155*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st**2*(-297*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(r + s) + 11*b1*f*(k1**4*(7*r + 7*s + 1) + k1**2*k2**2*(18*C*(5*r + 5*s - 1) + 37*r + 37*s - 23) + 6*k2**4*(C*(19*r + 19*s - 11) + 5*r + 5*s - 4)) + f**2*(k1**4*(37*r + 37*s - 21) + k1**2*k2**2*(C*(578*r + 578*s - 378) + 70*r + 70*s - 43) + 11*k2**4*(6*C*(2*r + 2*s - 1) + 3*r + 3*s - 2)))/(3465*d*k2*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*(20*C*f**2*k1**2*k2**2*(r + s - 1) - 9*b1**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(r + s) + b1*f*(k1**4*(-2*r - 2*s + 1) + k1**2*k2**2*(6*C*(r + s - 2) + 7*r + 7*s + 1) + k2**4*(18*C + 9)*(r + s)))/(315*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*b1*f*(36*Pk2*b1**2*k2**2*r + b1*(-18*Pk2*k1**2*s + 2*Pk2*k2**2*(18*K*(r - 1) + f*(44*r + 9*s - 22) + 18*r - 9*s - 18) + 18*Pkd2*f*k1**2*k2*s + 9*Pkd2*f*k2**3*s) + 2*k2*(18*Pk2*b2*k2*(r - 1) - 36*Pk2*g2*k2*(r - 1) + 5*Pkd2*f**2*k1**2*s))/(315*d*k1*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*b1*f*(-2*C*f*k1**2*k2**2*(2*Pk2*(20*r + 9*s - 10) + 9*Pkd2*k2*s) + Pk2*(k1**2 + k2**2)*(9*b1*k1**2*s + 2*f*k1**2*s - 9*f*k2**2*r))/(315*d*k1*k2**2*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**7*f**2*k2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(22*b1*(2*s - 1) + f*(41*s - 21))/(693*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**6*f**3*(4*Pk2 - Pkd2*k2)*(26*b1*(52*s - 21) + 63*f*(19*s - 8))/(9009*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**6*f**2*(22*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(31*s - 20) - 41*s + 25) + k2**2*(Pk2*(-r*(36*C - 36) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + 5*f*k1**2*(4*Pk2 - Pkd2*k2)*(12*C*(10*s - 7) - 161*s + 105) - 5*f*k2**2*(2*Pk2*(C*(50*r + 42) - 50*r + 41*s - 63) + Pkd2*k2*(21 - 41*s)))/(3465*d*k1*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**2*k2*st**2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(-55*b1*(2*s - 1) + f*(108*s - 25))/(3465*d*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + 13*b1*(5*f**2*(16*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(41*s - 21)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(11*s - 10) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 105*f**3*(Pk2*k2**2*(23*r - 22) + 4*k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 6)) + 286*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 10))/(45045*d*k1**2*k2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f*(-198*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) + 11*b1*f*(16*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(C*(22*s - 20) - 53*s + 40) + k1**2*k2**2*(-2*C*(Pk2*(36*r + 58*s - 40) + Pkd2*k2*(19 - 27*s)) + 92*Pk2*r - 26*Pk2*s + Pkd2*k2*(17*s - 2))) + 5*f**2*(Pk2*k2**4*(9*r + 41) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(C*(19*s - 21) - 49*s + 42) + k1**2*k2**2*(Pk2*(-24*C*r - 328*C*s + 27*r + 44*s + 211) + 2*Pkd2*k2*(85*C*s - 43*C - 14*s + 1))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**3*st**2*(4*Pk2 - Pkd2*k2)*(13*b1*(56*s - 15) + 15*f*(71*s - 21))/(9009*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**2*st**2*(11*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(s + 4) + 7*s - 17) + k2**2*(2*Pk2*(r*(62*C - 62) + 10*s - 5) + 5*Pkd2*k2*(1 - 2*s))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(93*s - 20) - 387*s + 85) + k2**2*(Pk2*(4*C*(81*r - 5) - 324*r - 216*s + 70) + Pkd2*k2*(108*s - 25))))/(3465*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*(-2288*Pk2*f*g2*k2**2*(r - 5) - 143*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(31*s - 20) + 18*s - 18) - 2*k2**2*(-2*Pk2 + Pkd2*k2)*(31*f*s - 10*f + 9*s - 9)) - 26*b1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(30*f*(10*s - 7) + 121*s - 110) + k2**2*(Pk2*(-44*K*(r - 5) + 570*f*r + 50*f*(s - 4) + 44*r + 242*s - 440) - Pkd2*k2*(5*f*(5*s + 1) + 121*s - 110))) - 105*f**3*(k1**2*(4*Pk2 - Pkd2*k2)*(31*s - 24) + k2**2*(2*Pk2*(72*r - 65*s - 18) + 13*Pkd2*k2*(5*s - 2))))/(45045*d*k1*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*(99*b1**2*k2**2*s*(Pkd2*k2**3 + k1**2*(4*C - 5)*(2*Pk2 - Pkd2*k2)) - 11*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 10) + k1**2*k2**2*(Pk2*(4*C*(49*s - 40) - 13*r - 66*s + 79) + Pkd2*k2*(C*(76 - 90*s) + 24*s - 35)) + k2**4*(Pk2*(-80*C*r + 40*C + 75*r - 2*s - 39) + Pkd2*k2*(7*s - 9))) + 5*f**2*(-k1**4*(4*Pk2 - Pkd2*k2)*(19*s - 21) + k1**2*k2**2*(Pk2*(4*C*(19*r - 120*s + 63) - 136*r + 287*s + 1) + Pkd2*k2*(4*C*(63*s - 43) - 157*s + 89)) + k2**4*(Pk2*(100*C*r + 84*C - 224*r - 3*s + 83) + 22*Pkd2*k2*(1 - 2*s))))/(3465*d*k1*k2**2*k3**2) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**2*k2*st**4*(C - 1)*(-4*Pk2 + Pkd2*k2)*(55*b1*(2*s - 1) + f*(19*s - 10))/(1155*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st**2*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(10*f*(2*s - 1) + (27 - 27*K)*(s - 1)) - 39*b1*(f**2*(210*Pk2*k2**2*r + 2*k1**2*(4*Pk2 - Pkd2*k2)*(108*s - 25)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s + 1) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 10*f**3*(5*Pk2*k2**2*(219*r - 58) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(114*s - 35)) - 858*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s + 1))/(45045*d*k1**2*k2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*(1287*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 143*b1**2*(9*K*k1**2*(2*Pk2*(s - 2) + Pkd2*k2) + 26*Pk2*f*k2**2*r + 9*Pk2*k2**2*r + f*k1**2*(Pk2*(9*r + 52*s - 2) + Pkd2*k2*(1 - 26*s)) + 9*k1**2*(-Pk2*r + 2*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2)) + 13*b1*(99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 5*f**2*(4*Pk2*k2**2*(27*r - 20) + 3*k1**2*(2*Pk2*(20*r - 25*s + 8) + 5*Pkd2*k2*(5*s - 3))) + 11*f*(3*Pk2*k2**2*(5*r - 7) + k1**2*(Pk2*(44*K*s - 40*K + 11*r - 19) + Pkd2*k2*(-20*K*s + 19*K - 2*s + 1))) - 198*g2*k1**2*(2*Pk2*(s - 2) + Pkd2*k2)) + f*k1**2*(143*b2*(2*Pk2 - Pkd2*k2)*(11*s - 10) + 105*f**2*(Pk2*(49*r - 104*s + 30) + 26*Pkd2*k2*(2*s - 1)) + 286*g2*(Pk2*(40 - 44*s) + Pkd2*k2*(20*s - 19))))/(45045*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st**2*(-594*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) - 11*b1*f*(-104*Pk2*k2**4*r + 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(s + 1) - 3*s - 6) + k1**2*k2**2*(2*C*(Pk2*(24*r + 70*s - 32) + Pkd2*k2*(37 - 77*s)) - 68*Pk2*r - 66*Pk2*s + 117*Pkd2*k2*s - 42*Pkd2*k2)) + f**2*(4*Pk2*k2**4*(135*r - 34) - k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(67*s - 15) - 413*s + 90) + k1**2*k2**2*(Pk2*(-8*C*(33*r - 186*s + 40) + 360*r - 66*s + 56) + Pkd2*k2*(C*(34 - 300*s) - 411*s + 126))))/(3465*d*k1**2*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*(-99*b1**2*(Pk2*k2**4*r - k1**4*s*(2*C - 4)*(2*Pk2 - Pkd2*k2) - k1**2*k2**2*(Pk2*(-4*C*s + r + 4*s) + Pkd2*k2*s*(2*C + 2))) - 11*b1*f*(3*Pk2*k2**4*(11*r - 7) + k1**4*(Pk2*(80*C*(s - 1) + 7*r - 68*s + 78) + 2*Pkd2*k2*(-18*C*s + 19*C + 14*s - 18)) - k1**2*k2**2*(Pk2*(8*C*(20*r - s - 10) - 236*r + 12*s + 97) + 2*Pkd2*k2*(C*(2*s + 9) - 16*s + 9))) + 5*f**2*(-44*Pk2*k2**4*r + k1**4*(Pk2*(-152*C*s + 168*C - 63*r + 202*s - 127) + 2*Pkd2*k2*(41*C*s - 43*C - 55*s + 44)) + k1**2*k2**2*(Pk2*(24*C*(r + 7) - 365*r - 6*s + 43) + 22*Pkd2*k2*(C*(2 - 4*s) - 3*s + 2))))/(3465*d*k1**2*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**3*st**4*(4*Pk2 - Pkd2*k2)*(13*b1*(25*s - 12) + 6*f*(7*s - 5))/(3003*d*k1) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**2*st**4*(11*b1*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(8*C*(3*s - 1) - 43*s + 18) + k2**2*(Pk2*(-72*C*r + 24*C + 72*r - 38*s - 4) + Pkd2*k2*(19*s - 10))))/(1155*d*k1*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**2*(1144*Pk2*f*g2*k2**2*(2*r - 1) + 429*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(s + 4) - 18*s + 18) - 2*k2**2*(-2*Pk2*(-6*K*r + f*(s + 2) + 6*r - 9*s + 9) + Pkd2*k2*(f*(s + 2) - 9*s + 9))) + 26*b1*(792*Pk2*g2*k2**2*r + 3*f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(93*s - 20) + 4*k2**2*(Pk2*(78*r + 74*s - 21) + Pkd2*k2*(8 - 37*s))) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s + 1) + k2**2*(Pk2*(-4*K*r + 2*K + 4*r + 6*s + 4) - 3*Pkd2*k2*(s + 1)))) + 15*f**3*(4*Pk2*k2**2*(464*r - 65*s - 90) + 26*Pkd2*k2**3*(5*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(271*s - 84)))/(45045*d*k1*k2**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*(44*Pk2*f*k2**2*(b2*(10 - 11*r) + 4*g2*(r - 5)) + 198*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) + 11*b1**2*(k1**2*(2*Pk2*(f*(s - 18) - 9*s - 9) + Pkd2*k2*(-f*(s - 18) + 18*s)) + k2**2*(-8*Pk2*f*(22*r - 5) + 18*Pk2*(2*K*(r - 1) - 2*r + s + 1) + Pkd2*k2*(f*(18 - 41*s) + 18*s))) + 2*b1*(-396*Pk2*g2*k2**2*(r - 1) + 10*f**2*(k1**2*(2*Pk2 - Pkd2*k2)*(29*s - 22) + k2**2*(Pk2*(60 - 114*r) + 11*Pkd2*k2*(1 - 3*s))) + 11*f*(k1**2*(Pk2*(20*s - 19) - 9*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(-4*K*(r - 5) - 40*r + 2*s + 19) - 9*Pkd2*k2*(s - 1)))) + 105*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(3465*d*k1*k2**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**2*(99*b1**2*k2**2*(Pk2*k1**2*s*(8*C - 14) + Pk2*k2**2*r*(8 - 8*C) + Pkd2*k1**2*k2*s*(7 - 4*C) + 3*Pkd2*k2**3*s) + 11*b1*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s + 1) + k1**2*k2**2*(Pk2*(4*C*(5*r + 22*s + 18) - 77*r + 2*s - 51) + 2*Pkd2*k2*(10*C*(2*s - 3) - 53*s + 30)) + k2**4*(Pk2*(208*C*r + 4*C - 181*r - 42*s + 17) + 3*Pkd2*k2*(9 - 19*s))) + f**2*(k1**4*(4*Pk2 - Pkd2*k2)*(67*s - 15) + k1**2*k2**2*(Pk2*(4*C*(15*r + 468*s - 95) - 93*r - 712*s + 173) + Pkd2*k2*(C*(76 - 492*s) - 199*s + 92)) + 3*k2**4*(Pk2*(8*C*(37*r - 5) + 49*r - 74*s - 21) + 11*Pkd2*k2*(1 - 2*s))))/(3465*d*k1*k2**2*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*(-99*b1**2*(Pk2*k2**4*(-2*r + s) + k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(2*Pk2*r + Pk2*s*(9 - 8*C) + Pkd2*k2*s*(4*C + 1))) - 11*b1*f*(k1**4*(Pk2*(16*s - 19) + Pkd2*k2*(9 - 7*s)) + k1**2*k2**2*(Pk2*(8*C*(10*r - 2*s - 5) - 192*r + 20*s + 77) + Pkd2*k2*(C*(36 - 10*s) - 34*s + 9)) - k2**4*(2*Pk2*(4*C*(r - 5) + 60*r + 8*s - 21) + 9*Pkd2*k2*s)) + 5*f**2*(66*Pk2*k2**4*r + k1**4*(Pk2*(43 - 41*s) + 22*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(76*C*r - 84*C + 154*r + 3*s - 1) + 22*Pkd2*k2*(6*C*s - 4*C + s - 1))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**4*(715*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 13*b1*f*(5*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(19*s - 10)) + 2*f**2*(5*Pk2*k2**2*(16 - 25*r) + k1**2*(4*Pk2 - Pkd2*k2)*(48*s - 25)))/(15015*d*k1**2*k2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**4*(22*b1*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + f*(Pk2*k2**4*(13 - 17*r) + 4*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(8*C*(6*r + 7*s - 8) - 55*r + 44*s + 11) + 2*Pkd2*k2*(C*(10 - 19*s) - 6*s + 2))))/(1155*d*k1**2*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**2*(3861*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 429*b1**2*(-Pk2*k2**2*r*(10*f + 3) + k1**2*(Pk2*f*(9*r - 44*s + 16) + 3*Pk2*(8*K*(s - 1) - 3*r + 4*s - 4) + Pkd2*f*k2*(22*s - 8) - Pkd2*k2*(9*K + 9)*(s - 1))) + 13*b1*(297*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) - 3*f**2*(2*Pk2*k2**2*(115*r - 42) + k1**2*(Pk2*(82*r + 266*s - 86) + 19*Pkd2*k2*(2 - 7*s))) - 11*f*(Pk2*k2**2*(7*r - 8) + k1**2*(Pk2*(20*K*s + 8*K - 7*r - 8*s + 12) + Pkd2*k2*(-3*K - 3)*(s + 1))) - 198*g2*k1**2*(8*Pk2 - 3*Pkd2*k2)*(s - 1)) + f*k1**2*(-429*b2*(2*Pk2 - Pkd2*k2)*(s + 1) - 15*f**2*(Pk2*(245*r - 104*s - 6) + 26*Pkd2*k2*(2*s - 1)) + 286*g2*(4*Pk2*(5*s + 2) - 3*Pkd2*k2*(s + 1))))/(45045*d*k1**2*k2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*(99*Pkd2*f*k1**2*k2*(b2 - 2*g2)*(s - 1) + 99*b1**3*k2*(2*Pk2*k2*r - Pkd2*k1**2*s) + 11*b1**2*(Pk2*k2**2*(f*(35*r - 22) + 27*r - 27) + k1**2*(Pk2*f*(62*r - 20) + 9*Pk2*(r + s*(2*K - 2) - 1) + Pkd2*f*k2*(34*s - 9) - Pkd2*k2*s*(9*K + 9))) + b1*(10*f**2*k1**2*(Pk2*(49*r - 20) + 11*Pkd2*k2*(3*s - 1)) + 99*f*(Pk2*k2**2*r + k1**2*(Pk2*r + Pkd2*k2*(K + 1)*(s - 1))) - 99*k1**2*s*(4*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2)))/(3465*d*k1**2*k2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**2*(-99*b1**2*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) - 11*b1*f*(-Pk2*k2**4*(47*r + 8) + k1**4*(Pk2*(8*C*(5*s + 2) - 21*r - 24*s - 28) - Pkd2*k2*(6*C*(s + 1) + 23*s - 18)) + k1**2*k2**2*(-2*Pk2*(2*C*(4*r - 7*s - 2) + 80*r + 35*s - 6) + Pkd2*k2*(-6*C*(19*s - 9) - 23*s + 18))) + f**2*(66*Pk2*k2**4*r + k1**4*(Pk2*(-416*C*s + 80*C + 37*r + 304*s - 44) + Pkd2*k2*(134*C*s - 30*C + 33*s - 22)) + k1**2*k2**2*(Pk2*(-624*C*r + 120*C + 161*r + 222*s - 36) + 11*Pkd2*k2*(12*C*s - 6*C + 3*s - 2))))/(3465*d*k1**2*k2*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*(-9*b1**2*(-Pk2*k1**2*k2**2*(r - 2*s) + k1**4*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r + 6*s))) + b1*f*(9*Pk2*k2**4*r + k1**4*(Pk2*(8*C*s + 47*r - 12*s - 19) + Pkd2*k2*(2*C*(7*s - 9) + 9*s)) + k1**2*k2**2*(Pk2*(4*C*(22*r + 9*s - 20) + 96*r + 14*s - 21) + Pkd2*k2*s*(18*C + 9))) + 10*f**2*k1**2*(2*C*Pkd2*k1**2*k2*(s - 1) + Pk2*r*(k1**2 + k2**2)))/(315*d*k1**2*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**3*st**6*(4*Pk2 - Pkd2*k2)*(39*b1*(3*s - 1) + 7*f*(4*s - 1))/(3003*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**4*(11*b1*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + f*(Pk2*k2**2*(8*C*(3*r - 1) - 12*r + 5*s + 6) + k1**2*(8*C*Pkd2*k2*(1 - 3*s) + Pk2*(48*C*s - 16*C - 12*r + 5*s + 6))))/(1155*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**4*(286*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*b1*f*(8*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(72*r - 62*s + 28) + Pkd2*k2*(31*s - 18))) - 2*f**2*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(24*r + 65*s - 58) + 13*Pkd2*k2*(2 - 5*s))))/(15015*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**2*(44*Pk2*f*k2**2*(b2 - 2*g2)*(2*r - 1) - 198*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - 11*b1**2*(k1**2*(2*Pk2*(19*f*s - 18*f + 9*s - 9) + Pkd2*f*k2*(18 - 19*s)) + 2*k2**2*(Pk2*(-16*f*r + 2*f + 9*s - 9) + Pkd2*f*k2*(9 - 25*s))) + 2*b1*f*(k1**2*(Pk2*(-96*f*s + 44*f + 77*s + 11) + 2*Pkd2*f*k2*(24*s - 11)) + k2**2*(-6*Pk2*f*(52*r - 21) + 11*Pk2*(K*(4*r - 2) + 4*r + 7*s - 1) + 11*Pkd2*f*k2*(3*s - 1))) + 5*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(3465*d*k1*k2**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**2*(-99*b1**2*(Pk2*k2**4*(2*r + s) + k1**2*k2**2*(4*C*Pkd2*k2*s + 2*Pk2*r + Pk2*s)) + 11*b1*f*(Pk2*k2**4*(C*(8*r - 4) + 23*r + 7*s + 2) + k1**4*(7*Pk2*s + Pk2) + k1**2*k2**2*(2*C*Pkd2*k2*(23*s - 18) + Pk2*(36*C*r + 23*r + 14*s + 3))) + f**2*(Pk2*k1**4*(37*s - 5) + 33*Pk2*k2**4*r + k1**2*k2**2*(22*C*Pkd2*k2*(3*s - 2) + Pk2*(-60*C*r + 20*C + 33*r + 37*s - 5))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*b1*ct*f*k1*(k1**2 + k2**2*(4*C + 1))*(9*b1*r + f*(2*r - 1))/(315*d*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*b1*ct*f*(99*b1**2*r*(k1**2 + k2**2) + 11*b1*(k1**2*(4*f*r - f + 9*r - 9) + k2**2*(2*f*r - f + 9*r - 9)) + 5*f**2*k1**2*(1 - 3*r))/(3465*d*k1*k2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*b1*f*(9*b1**2*r + b1*f*(2*r - 1) + 9*b1*(K + 1)*(r - 1) + (9*b2 - 18*g2)*(r - 1))/(315*d) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**6*f**2*k2**2*(C - 1)*(-22*b1*r + 5*f*(3*r - 1))/(3465*d*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**5*f**3*k2*(13*b1*r + 7*f*(4*r - 1))/(3003*d*k1) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**5*f**2*k2*(-22*b1*r + 5*f*(3*r - 1))*(k1**2*(5 - 4*C) + k2**2)/(3465*d*k1*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**2*k2**2*st**2*(C - 1)*(77*b1*r + f*(37*r - 16))/(1155*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f*(143*b1**2*r*(-9*K + 2*f + 9) - 13*b1*(5*f**2*(9*r - 1) + 11*f*(K - 1)*(2*r - 1) - 198*g2*r) - 210*f**3*(4*r - 1) + 286*f*g2*(2*r - 1))/(45045*d) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f*(-99*b1**2*k2**2*r*(C - 1) + 11*b1*f*(k1**2*r*(4 - 2*C) + k2**2*(C + 4*r - 1)) + 5*f**2*(3*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)))/(3465*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**3*k2*st**2*(481*b1*r + 5*f*(45*r - 8))/(9009*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**2*k2*st**2*(77*b1*r + f*(37*r - 16))*(k1**2*(3 - 2*C) + k2**2)/(1155*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*(143*b1**2*r*(k1**2*(2*f + 9) + k2**2*(4*f + 9)) - 13*b1*f*(k1**2*(30*f*r - 5*f - 22*r + 11) + k2**2*(30*f*r - 10*f - 22*r + 11)) + 105*f**3*k1**2*(1 - 4*r))/(45045*d*k1*k2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*(-99*b1**2*k2**2*r*(k1**2*(5 - 4*C) + k2**2) - 11*b1*f*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**4*(2*r - 1)) + 5*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(3*r - 1))/(3465*d*k1*k2*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**2*k2**2*st**4*(C - 1)*(-22*b1*r + f*(5*r - 9))/(1155*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st**2*(429*b1**2*r*(3*K + 14*f - 3) + 13*b1*(f**2*(666*r - 96) - 11*f*(K - 1)*(7*r - 8) - 198*g2*r) + 60*f**3*(45*r - 8) + 286*f*g2*(7*r - 8))/(45045*d) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*(99*b1**3*r + 11*b1**2*(9*K + f*(8*r - 1) + 18*r - 9) + b1*(99*b2*r + f**2*(15 - 45*r) + 11*f*(K + 1)*(2*r - 1) - 198*g2) + 11*f*(b2 - 2*g2)*(2*r - 1))/(3465*d) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st**2*(99*b1**2*k2**2*r*(C - 1) + 11*b1*f*(k1**2*r*(28 - 7*C) + k2**2*(35*C*r + 8*C + 28*r - 8)) - f**2*(37*r - 16)*(k1**2*(C - 4) - k2**2*(6*C + 3)))/(3465*d*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*(5*C*f**2*k1**2*(3*r - 1) + 99*b1**2*r*(k1**2*(C - 2) - k2**2*(C + 1)) - 11*b1*f*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1)))/(3465*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**3*k2*st**4*(65*b1*r + f*(32*r - 21))/(3003*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*k2*st**4*(k1**2 + k2**2)*(-22*b1*r + f*(5*r - 9))/(1155*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st**2*(429*b1**2*r*(k1**2*(7*f - 3) + k2**2*(14*f - 3)) + 13*b1*f*(k1**2*(6*f*(37*r - 8) + 77*r - 88) + k2**2*(6*f*(37*r - 16) + 77*r - 88)) + 15*f**3*k1**2*(45*r - 8))/(45045*d*k1*k2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st**2*(-99*b1**2*k2**2*r*(k1**2 + k2**2) + 11*b1*f*(7*k1**4*r + 2*k1**2*k2**2*(42*C*r + 7*r - 4) + k2**4*(7*r - 8)) + f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(37*r - 16))/(3465*d*k1*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**2*st**4*(-286*b1**2*r + 39*b1*f*(5*r - 3) + 2*f**2*(32*r - 21))/(15015*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f*st**2*(99*b1**3*r + 11*b1**2*(f*(8 - 28*r) + r*(9*K + 9)) + b1*(f**2*(48 - 111*r) - 11*f*(K + 1)*(7*r - 8) + r*(99*b2 - 198*g2)) - 11*f*(b2 - 2*g2)*(7*r - 8))/(3465*d)
        perm13 = 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**4*f*(9*b1*(s - 1) + f*(11*s - 10))/(315*d*k1) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**3*f*(18*b1*k1**2*(2*C - 1)*(s - 1) - 9*b1*k2**2*r + f*k1**2*(4*C - 2)*(11*s - 10) + 3*f*k2**2*(7 - 5*r))/(315*d*k1**2*k2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**2*f*st**2*(9*b1*(s - 1) - f*(s + 1))/(105*d*k1) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**2*f*(9*b1*(s - 1) + f*(C*(44*r - 40) - 22*r + 2*s + 19))/(315*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*k2*(18*b1**2*r + b1*f*(35*r - 22) + 27*b1*(r - 1) + 9*f*r)/(315*d*k1**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st**2*(54*b1*k1**2*(2*C - 1)*(s - 1) + 9*b1*k2**2*r - f*k1**2*(12*C - 6)*(s + 1) + f*k2**2*(7*r - 8))/(315*d*k1**2*k2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*st**2*(9*b1*(s - 1) + f*(C*(8*r - 4) - 4*r - 7*s + 1))/(315*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*(-b1*(2*K*(r - 1) - f*s + f + s) - 2*b2*(r - 1) + 4*g2*(r - 1))/(35*d*k1) + 64*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**7*f**2*k2**5*(C - 1)*(22*b1*(2*r + 2*s - 1) + f*(41*r + 41*s - 20))/(693*d*k3**6) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**7*f**2*k2**3*(C - 1)*(22*b1*(2*s - 1) + f*(41*s - 21))/(693*d*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**4*(26*b1*(5*f*k2**2*(52*r + 52*s - 31) + 22*k1**2*(C*(73*r + 73*s - 41) - 63*r - 63*s + 36)) + 5*f*(63*f*k2**2*(19*r + 19*s - 11) + 26*k1**2*(2*C*(139*r + 139*s - 78) - 237*r - 237*s + 136)))/(45045*d*k1*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**2*(22*b1*(2*s - 1) + f*(41*s - 21))/(693*d*k1*k3**2) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**2*(22*b1*(k1**2*(71*C*s - 40*C - 61*s + 35) + k2**2*(-18*C*r + 28*r + 10*s - 5)) + 5*f*(k1**2*(4*C*(71*s - 42) - 243*s + 147) + k2**2*(-2*C*(25*r + 21) + 91*r + 41*s + 22)))/(3465*d*k1*k3**4) + 64*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**5*st**2*(C - 1)*(-55*b1*(2*r + 2*s - 1) + f*(108*r + 108*s - 83))/(3465*d*k3**6) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**3*st**2*(C - 1)*(-55*b1*(2*s - 1) + f*(108*s - 25))/(3465*d*k3**4) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f*k2**3*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(5*f**2*k2**2*(79*r + 79*s - 60) + 11*f*(k1**2*(2*C*(101*r + 101*s - 64) - 149*r - 149*s + 97) + k2**2*(-18*C*(2*r + 2*s - 1) + K*(11*r + 11*s - 1) + 25*r + 25*s - 17)) - 198*g2*k2**2*(r + s)) - 2*f*(105*f**2*k2**2*(31*r + 31*s - 20) + 65*f*(k1**2*(56*C*(3*r + 3*s - 2) - 119*r - 119*s + 83) + k2**2*(22 - 22*C)*(2*r + 2*s - 1)) - 143*g2*k2**2*(11*r + 11*s - 1)))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f*k2*(-396*b1**2*k1**2*(C - 1)*(s - 1) + 22*b1*f*(k1**2*(18*C*s - 29*s + 10) + 8*k2**2*r) + 5*f**2*(2*k1**2*(82*C*s - 42*C - 101*s + 63) + k2**2*(9*r + 41)))/(3465*d*k1**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f*k2*(5148*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 26*b1*f*(40*f*k2**4*r + 33*k1**4*(C*(62*s - 40) - 45*s + 30) - 11*k1**2*k2**2*(22*C*s + r*(94*C - 97) - 35*s + 11)) + 5*f**2*(21*f*k2**4*(23*r - 22) + 26*k1**4*(36*C*(10*s - 7) - 259*s + 189) - 13*k1**2*k2**2*(8*C*(25*r + 19*s + 33) - 229*r - 184*s - 185)))/(45045*d*k1**2*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**4*st**2*(65*b1*f*k2**2*(56*r + 56*s - 41) + 286*b1*k1**2*(C*(5*r + 5*s + 11) - 15*r - 15*s - 6) + 75*f**2*k2**2*(71*r + 71*s - 50) + 26*f*k1**2*(C*(933*r + 933*s - 677) - 825*r - 825*s + 594))/(45045*d*k1*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(-55*b1*(2*s - 1) + f*(108*s - 25))/(3465*d*k1*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(11*b1*(k1**2*(37*C*s - 32*C - 27*s + 27) + k2**2*(-62*C*r + 72*r + 10*s - 5)) + f*(k1**2*(-711*C*s + 160*C + 603*s - 135) + k2**2*(-162*C*r + 10*C + 54*r - 108*s + 73)))/(3465*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2**2*(143*b1**2*k1**2*k2**2*(f*(97*r + 97*s - 53) + (72 - 90*K)*(r + s)) + 26*b1*(5*f**2*k2**2*(6*k1**2*(r + s + 3) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*k1**2*(k1**2*(2*C*(65*r + 65*s - 46) - 82*r - 82*s + 59) + k2**2*(-18*C*(7*r + 7*s - 4) + K*(37*r + 37*s - 5) + 82*r + 82*s - 59)) + 990*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(-69*r - 69*s + 55) + 13*k2**2*(5*r + 5*s - 3)) - 260*f*k1**2*(k1**2*(C*(80*r + 80*s - 68) - 45*r - 45*s + 41) - 11*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) + 572*g2*k1**2*k2**2*(37*r + 37*s - 5)))/(45045*d*k1*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*(198*b1**2*k1**2*(4*C - 3)*(s - 1) + 11*b1*f*(k1**2*s*(18 - 36*C) + k2**2*(8*C*(r - 5) - 13*r - 2*s + 41)) - 5*f**2*(2*k1**2*(120*C*s - 84*C - 79*s + 63) + k2**2*(76*C*r - 84*C - 86*r - 3*s + 125)))/(3465*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*(286*b1**2*(k1**2*k2**2*(54*C - 45)*(r + s - 1) + k2**4*(f*(31*r + 31*s - 21) + 9*r + 9*s)) + 13*b1*f*(44*k1**4*(C*(53*s - 40) - 32*s + 25) - 11*k1**2*k2**2*(r*(96*C - 65) + s*(60*C - 44) + 3) + 2*k2**4*(22*K*(r - 5) + 5*f*(98*r + 115*s - 51) + 11*r*(36*C - 45) - 77*s + 198)) + f*(105*f**2*k2**4*(108*r + 65*s - 105) + 65*f*(k1**4*(56*C*(7*s - 6) - 234*s + 210) + k1**2*k2**2*(8*C*(22*r - 24*s - 47) - 160*r + 107*s + 289) + 44*k2**4*(r*(4*C - 6) - 2*s + 1)) - 1144*g2*k2**4*(r - 5)))/(45045*d*k1*k3**4) - 64*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**5*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(19*r + 19*s - 9))/(1155*d*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**3*st**4*(C - 1)*(55*b1*(2*s - 1) + f*(19*s - 10))/(1155*d*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2**3*st**2*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (27 - 27*K)*(r + s)) + 13*b1*(2*f**2*k2**2*(401*r + 401*s - 260) + 11*f*(k1**2*(C*(230*r + 230*s - 34) - 205*r - 205*s + 35) + 3*k2**2*(18*C*(2*r + 2*s - 1) + K*(r + s - 2) - 37*r - 37*s + 20)) + 594*g2*k2**2*(r + s)) + f*(90*f**2*k2**2*(139*r + 139*s - 101) + 13*f*(k1**2*(22*C*(137*r + 137*s - 95) - 2297*r - 2297*s + 1579) + k2**2*(66*C - 66)*(2*r + 2*s - 1)) - 858*g2*k2**2*(r + s - 2)))/(45045*d*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2*(429*b1**2*k2**2*(f*k1**2*(13*r + 13*s - 8) - 3*f*k2**2*(2*r + 2*s - 1) + k1**2*(18 - 30*K)*(r + s)) + 13*b1*(10*f**2*k2**2*(k1**2*(19*r + 19*s - 9) + 11*k2**2*(4*r + 4*s - 3)) - 11*f*(k1**4*(C*(38*r + 38*s - 28) - 21*r - 21*s + 15) + k1**2*k2**2*(-54*C*(3*r + 3*s - 2) + K*(47*r + 47*s - 10) + 96*r + 96*s - 75) + k2**4*(9 - 9*K)*(r + s)) + 1980*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(3*r + 3*s + 1) + 26*k2**2*(3*r + 3*s - 2)) - 130*f*k1**2*(k1**2*(C*(7*r + 7*s - 12) - 2*r - 2*s + 5) - 11*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) - 286*g2*k2**2*(k1**2*(-47*r - 47*s + 10) + 9*k2**2*(r + s))))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*(2574*b1**3*k2**4*(r + s - 1) - 143*b1**2*(k1**2*k2**2*(108*C - 72)*(r + s - 1) + k2**4*(-18*K*(r + s + 1) + f*(25*r + 16*s - 10) + 45*r + 54*s + 18)) - 13*b1*(10*f**2*k2**4*(51*r + 139*s - 35) + 11*f*(k1**4*(4*C - 2)*(11*s - 10) + k1**2*k2**2*(-24*C*s + r*(48*C - 31) + 20*s - 2) + k2**4*(216*C*r + 36*C*s + K*(44*r - 8*s - 76) - 241*r - 38*s + 71)) - 198*k2**4*(b2*(r + s) - 2*g2*(r + s + 1))) + f*(-105*f**2*k2**4*(147*r + 156*s - 170) - 65*f*(k1**4*(4*C - 2)*(19*s - 21) + k1**2*k2**2*(8*C*(58*r - 2*s - 37) - 301*r - 10*s + 199) + 44*k2**4*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) + 286*k2**4*(b2*(11*r + 11*s - 1) + 4*g2*(11*r - 2*s - 19))))/(45045*d*k2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(-594*b1**2*k1**2*(C - 1)*(s - 1) + 11*b1*f*(k1**2*(46*C*s - 14*C - 23*s + 16) + 52*k2**2*r) + f**2*(k1**2*(-432*C*s + 100*C + 495*s - 110) + 2*k2**2*(135*r - 34)))/(3465*d*k1**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(-7722*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 13*b1*f*(315*f*k2**4*r - 11*k1**4*(C*(22*s - 74) - 5*s + 52) + 11*k1**2*k2**2*(2*C*(55*r - 19*s + 8) - 35*r + 103*s - 35)) + f**2*(25*f*k2**4*(219*r - 58) + 13*k1**4*(2*C*(841*s - 185) - 1187*s + 260) - 13*k1**2*k2**2*(6*C*(18*r + 146*s - 95) - 441*r - 1161*s + 721)))/(45045*d*k1**2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*(11*b1**2*(k1**4*(36*C - 18)*(s - 1) - 9*k1**2*k2**2*(4*C*(r + s - 1) - 3*r - 4*s + 4) + k2**4*r*(26*f + 9)) + b1*f*k2**2*(11*k1**2*(8*C*(r - s - 9) - 4*r + 4*s + 55) + k2**2*(540*f*r - 400*f + 363*r - 231)) - 5*f**2*(k1**4*(4*C - 2)*(19*s - 21) + k1**2*k2**2*(24*C*(10*r - 7) - 177*r - 6*s + 127) - 44*k2**4*r))/(3465*d*k1**2*k2*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**4*st**4*(65*b1*f*k2**2*(25*r + 25*s - 13) + 286*b1*k1**2*(26*C - 21)*(2*r + 2*s - 1) + 30*f**2*k2**2*(7*r + 7*s - 2) + 26*f*k1**2*(C*(90*r + 90*s - 38) - 71*r - 71*s + 29))/(15015*d*k1*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(55*b1*(2*s - 1) + f*(19*s - 10))/(1155*d*k1*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(11*b1*(k1**2*(24*C - 19)*(2*s - 1) + k2**2*(-16*C*r + 26*r + 10*s - 5)) + f*(k1**2*(100*C*s - 48*C - 81*s + 38) + k2**2*(-36*C*r + 12*C + 55*r + 19*s - 21)))/(1155*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k1*(143*b1**2*k2**2*(f*k1**2*(25*r + 25*s - 17) - 9*f*k2**2*(9*r + 9*s - 5) + k1**2*(72 - 180*K)*(r + s)) + 26*b1*(5*f**2*k2**2*(k1**2*(2*r + 2*s - 5) - 22*k2**2) - 11*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(-18*C*(5*r + 5*s - 4) + K*(29*r + 29*s - 10) + 46*r + 46*s - 41) + k2**4*(18 - 27*K)*(r + s)) + 1980*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(8*r + 8*s - 6) + 13*k2**2*(9*r + 9*s - 7)) + 130*f*k1**2*(k1**2*(2*C - 1)*(3*r + 3*s - 2) + 22*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 572*g2*k2**2*(k1**2*(-29*r - 29*s + 10) + 27*k2**2*(r + s))))/(45045*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2**2*st**2*(-429*b1**2*k1**2*k2**2*(f*(31*r + 31*s - 11) + (54*K - 36)*(r + s)) + 26*b1*(3*f**2*k2**2*(4*k1**2*(37*r + 37*s - 21) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**2*(2*C*(71*r + 71*s - 13) - 97*r - 97*s + 17) + 3*k2**2*(6*C*(15*r + 15*s - 8) + 3*K*(r + s - 2) - 74*r - 74*s + 43)) + 1782*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*(3*k1**2*k2**2*(451*r + 451*s - 335) - 26*k2**4*(5*r + 5*s - 3)) + 26*f*(2*k1**4*(372*C*(3*r + 3*s - 2) - 721*r - 721*s + 477) + 11*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) - 5148*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k1*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st**2*(198*b1**2*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(4 - 4*C)) - 11*b1*f*(k1**2*(12*C - 6)*(s - 2) + k2**2*(8*C*r - 4*C + 19*r - 42*s + 25)) + f**2*(2*k1**2*(6*C*(93*s - 20) - 346*s + 75) + 3*k2**2*(8*C*(26*r - 5) - 241*r + 74*s + 41)))/(3465*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*(11*b1**2*(9*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(-18*K*r + 18*K - 2*f*(22*r + 27*s - 8) + 9*s - 18)) - 20*b1*f**2*k2**2*(57*r + 33*s - 52) + 22*b1*f*(k1**2*(4*C - 2)*(s + 4) + k2**2*(K*(11*r - 10) - r*(18*C + 24) - 8*s + 21)) + 396*b1*g2*k2**2*(r - 1) + f*(5*f*(k1**2*(164*C*r - 84*C - 82*r - 3*s + 43) - 66*k2**2*r) + k2**2*(22*b2 - 44*g2)*(11*r - 10)))/(3465*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st**2*(-858*b1**2*(k1**2*k2**2*(42*C - 33)*(r + s - 1) - k2**4*(f*(r + s - 3) + r*(6*K - 15) - 9*s)) + 13*b1*(6*f**2*k2**4*(197*r + 38*s - 40) + 11*f*(6*k1**4*(6*C*(s + 2) - 4*s - 7) + k1**2*k2**2*(-4*C*(136*r + 116*s - 29) + 409*r + 428*s - 101) - 2*k2**4*(108*C*r - 2*K*r + K - 163*r - 57*s + 32)) - 792*g2*k2**4*r) + f*(30*f**2*k2**4*(696*r + 65*s - 213) + 13*f*(2*k1**4*(2*C*(413*s - 90) - 480*s + 105) + k1**2*k2**2*(-12*C*(205*r + 315*s - 199) + 1871*r + 3134*s - 1815) - 66*k2**4*(r*(4*C - 6) - 2*s + 1)) + 572*g2*k2**4*(1 - 2*r)))/(45045*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*(5148*b1**3*k1**2*k2**2*(r + s - 1) - 143*b1**2*(-18*f*k2**4*(3*r + 3*s - 2) + k1**4*(36*C - 18)*(r + s - 1) + k1**2*k2**2*(-54*K*(r + s + 1) + f*(-46*r - 73*s + 43) + 36*r + 63*s + 36)) + 13*b1*(10*f**2*k2**2*(k1**2*(83*r + s - 39) + 22*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**4*(r*(28*C - 14) + s*(6 - 8*C) - 1) + 2*k1**2*k2**2*(18*C*s + 63*K*r + 6*K*(s - 9) + r*(90*C - 106) - 16*s + 26) + 18*k2**4*(r*(K - 2) - s)) + 594*k1**2*k2**2*(b2*(r + s) - 2*g2*(r + s + 1))) + f*(-105*f**2*k1**2*k2**2*(62*r + 117*s - 113) - 65*f*k1**2*(k1**2*(4*C*(47*r + 6*s - 25) - 94*r - 15*s + 51) + 22*k2**2*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) + 858*k2**2*(b2*k1**2*(5*r + 5*s - 1) + 2*g2*k1**2*(21*r + 2*s - 18) + 6*g2*k2**2*r)))/(45045*d*k1*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**3*st**4*(715*b1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(f*k2**2*(13*r + 13*s - 5) + k1**2*(242*C - 154)*(2*r + 2*s - 1)) + 2*f*(8*f*k2**2*(r + s - 4) - 13*k1**2*(11*C*(3*r + 3*s - 1) - 20*r - 20*s + 6)))/(15015*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(22*b1*k1**2*(10*C - 7)*(2*s - 1) + 66*b1*k2**2*r + f*k1**2*(C*(76*s - 40) - 62*s + 28) + f*k2**2*(17*r - 13))/(1155*d*k1**2*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(13*b1*(5*f*k2**4*r + k1**4*(396*C - 242)*(2*s - 1) - 22*k1**2*k2**2*(12*C*(4*r + 2*s - 1) - 39*r - 20*s + 10)) + f*(10*f*k2**4*(16 - 25*r) + 26*k1**4*(C*(86*s - 36) - 55*s + 22) - 13*k1**2*k2**2*(8*C*(19*r + 7*s - 5) - 121*r - 32*s + 29)))/(15015*d*k1**2*k3**4) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k1**2*k2*(11*b1**2*(f*k1**2*(2*r + 2*s - 1) - 9*f*k2**2*(3*r + 3*s - 2) + k1**2*(9 - 45*K)*(r + s)) + b1*(-5*f**2*(k1**2*(3*r + 3*s - 2) + 22*k2**2*(2*r + 2*s - 1)) + 11*f*(k1**2*(18*C*(r + s - 1) - 5*K*(2*r + 2*s - 1) - 7*r - 7*s + 8) + k2**2*(27*K - 9)*(r + s)) + 990*g2*k1**2*(r + s)) + f*(105*f**2*k2**2*(r + s - 1) + f*k1**2*(220*C - 110)*(r + s - 1) + 22*g2*(5*k1**2*(2*r + 2*s - 1) - 27*k2**2*(r + s))))/(3465*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2*(198*b1**3*k1**2*(r + s - 1) + 11*b1**2*(18*f*k2**2*(2*r + 2*s - 1) + k1**2*(54*K*(r + s + 1) + f*(27*r + 54*s - 38) - 9*r - 36*s - 18)) + b1*(10*f**2*(k1**2*(55*r + 47*s - 45) + 22*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**2*(36*C*r + 2*K*(59*r + 15*s - 34) - 61*r - 6*s + 17) + 9*k2**2*(r*(6*K - 5) + s*(2*K - 2))) + 594*k1**2*(b2*(r + s) - 2*g2*(r + s + 1))) + 2*f*(33*b2*(k1**2*(2*r + 2*s - 1) - 3*k2**2*(r + s)) - 105*f**2*k1**2*(s - 1) - 55*f*k1**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2) + 22*g2*(k1**2*(59*r + 15*s - 34) + 9*k2**2*(3*r + s))))/(3465*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2*st**2*(1287*b1**2*k2**2*(f*k1**2*(8*r + 8*s - 3) + 3*f*k2**2*(2*r + 2*s - 1) + k1**2*(9*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(k1**2*(134*r + 134*s - 115) - 33*k2**2*(4*r + 4*s - 3)) - 11*f*k1**2*(2*k1**2*(C*(59*r + 59*s - 7) - 33*r - 33*s + 3) + 3*k2**2*(6*C*(12*r + 12*s - 7) + 3*K*(r + s - 2) - 46*r - 46*s + 29)) - 1782*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k2**2*(k1**2*(-309*r - 309*s + 235) + 39*k2**2*(3*r + 3*s - 2)) - 13*f*k1**2*(k1**2*(66*C*(11*r + 11*s - 7) - 400*r - 400*s + 252) + 11*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k3**6) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**2*(7722*b1**3*k2**4*(r + s - 1) - 429*b1**2*(k1**2*k2**2*(60*C - 36)*(r + s - 1) + k2**4*(f*(-59*r - 68*s + 44) + r*(39 - 48*K) - s*(24*K - 24))) + 13*b1*(2*f**2*k2**4*(423*r + 291*s - 212) + 11*f*(k1**4*(12*C - 6)*(s + 1) + k1**2*k2**2*(-4*C*(118*r + 77*s - 3) + 257*r + 210*s) + k2**4*(-108*C*(5*r + 2*s - 1) - 4*K*(3*r + 5*s - 6) + 437*r + 182*s - 106)) + 198*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + f*(15*f**2*k2**4*(735*r + 156*s - 278) + 13*f*(k1**4*(4*C - 2)*(67*s - 15) + k1**2*k2**2*(-4*C*(425*r + 548*s - 328) + 961*r + 1466*s - 776) - 22*k2**4*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) - 286*k2**4*(3*b2*(r + s - 2) - 4*g2*(3*r + 5*s - 6))))/(45045*d*k2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2*(11*b1**2*k1**2*(18*K*(r - s - 1) + f*(36*s + 2) + 9) + b1*(10*f**2*k1**2*(49*r + 66*s - 64) + 11*f*k1**2*(36*C*r - 2*K*(31*r + 9*s - 20) + 24*r + 14*s - 21) + 99*f*k2**2*r - 396*g2*k1**2*(r - s - 1)) + 22*f*k1**2*(b2*(-31*r - 9*s + 20) + 5*f*r + 2*g2*(31*r + 9*s - 20)))/(3465*d*k1**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**2*(33*b1**2*(k1**4*(36*C - 18)*(s - 1) - 3*k1**2*k2**2*(4*C*(3*r + s - 1) - 9*r - 4*s + 4) - k2**4*r*(10*f + 3)) + b1*f*k2**2*(-22*k1**2*(2*C*(20*r - 7*s + 7) - 20*r - 7*s - 4) + k2**2*(f*(252 - 690*r) + 517*r + 88)) + f**2*(k1**4*(4*C - 2)*(67*s - 15) + k1**2*k2**2*(12*C*(41*r - 10) - 283*r + 222*s + 24) + 66*k2**4*r))/(3465*d*k1**2*k2*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**3*k2**6*st**6*(39*b1*(3*r + 3*s - 2) + 7*f*(4*r + 4*s - 3))/(3003*d*k1*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2**2*st**4*(1144*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(-2*f*k1**2*k2**2*(10*r + 10*s - 3) - 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(2*r + 2*s - 1)) + 2*f*(4*f*k1**2*k2**2*(9*r + 9*s - 10) + 13*f*k2**4*(5*r + 5*s - 3) - k1**4*(26*C - 13)*(7*r + 7*s - 1)))/(15015*d*k1*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*st**4*(44*b1*k1**2*(2*C - 1)*(2*s - 1) + 11*b1*k2**2*(4*r + 2*s - 1) + f*k1**2*(16*C - 8)*(3*s - 1) + f*k2**2*(8*C*(3*r - 1) - 5*s - 2))/(1155*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*st**4*(286*b1**2*k2**4*(4*r + 4*s - 3) + 13*b1*(f*k2**4*(48*r + 79*s - 49) + k1**4*(88*C - 44)*(2*s - 1) - 11*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9)) + f*(2*f*k2**4*(-36*r + 65*s + 9) + k1**4*(208*C - 104)*(3*s - 1) - 13*k1**2*k2**2*(8*C*(4*r + s + 2) - 28*r + s - 2)))/(15015*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1**3*(10*b1*f**2*k2**2*(r + s - 1) + b1*f*(2*K*(k1**2*(2*r + 2*s - 1) - 9*k2**2*(r + s)) + 9*b1*k2**2*(r + s - 1)) + 18*b1*k1**2*(r + s)*(K*b1 - 2*g2) + 4*f*g2*(k1**2*(-2*r - 2*s + 1) + 9*k2**2*(r + s)))/(315*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1*(9*b1**2*k1**2*(2*K*(r + s + 1) + f*(s - 1) - s) + b1*(10*f**2*(k1**2*(s - 1) + k2**2*(r + s - 1)) - f*(2*K*(k1**2*(16*r + 5*s - 8) + 9*k2**2*(2*r + s)) + 2*k1**2*s - 9*k2**2*r) + 18*k1**2*(b2*(r + s) - 2*g2*(r + s + 1))) + 2*f*(b2*k1**2*(2*r + 2*s - 1) - 9*b2*k2**2*(r + s) + 2*g2*k1**2*(16*r + 5*s - 8) + 18*g2*k2**2*(2*r + s)))/(315*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1*st**2*(143*b1**2*k2**2*(54*K*k1**2*(r + s) + 2*f*k1**2*(19*r + 19*s - 5) + 9*f*k2**2*(9*r + 9*s - 5)) + 26*b1*(f**2*k2**2*(k1**2*(89*r + 89*s - 63) + 11*k2**2) - 11*f*k1**2*(k1**2*(2*C - 1)*(7*r + 7*s + 1) + 3*k2**2*(6*C*(3*r + 3*s - 2) + K*(r + s - 2) - 9*r - 9*s + 6)) - 594*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(k1**2*(-90*r - 90*s + 74) + 13*k2**2*(9*r + 9*s - 7)) - f*k1**2*(52*C - 26)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**2*(-11*b1**2*(9*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(f*(-8*r - 54*s + 34) + 18*r + 9*s)) + b1*f*(k1**2*(44*C - 22)*(7*s - 8) + k2**2*(-44*K*r + 22*K + f*(-312*r + 66*s + 82) + 253*r + 77*s + 22)) + f*(f*k1**2*(20*C*(3*r - 1) - 30*r + 37*s + 5) + 33*f*k2**2*r - k2**2*(22*b2 - 44*g2)*(2*r - 1)))/(3465*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*(-18*K*b1**2*k1**2*s + b1*(10*f**2*k1**2*(s - 1) + f*(-2*K*k1**2*(20*r + 9*s - 10) - 2*k1**2*s + 9*k2**2*r) + 36*g2*k1**2*s) - 2*b2*f*k1**2*(20*r + 9*s - 10) + 4*f*g2*k1**2*(20*r + 9*s - 10))/(315*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**2*(5148*b1**3*k1**2*k2**2*(r + s - 1) - 143*b1**2*(-18*f*k2**4*(3*r + 3*s - 2) + k1**4*(36*C - 18)*(r + s - 1) + k1**2*k2**2*(-108*K*r - 72*K*s + f*(-82*r - 109*s + 61) + 18*r + 9*s)) + 13*b1*(2*f**2*k2**2*(2*k1**2*(48*r + 63*s - 37) + 11*k2**2*(3*r + 3*s - 2)) - 11*f*k1**2*(k1**2*(4*C*(16*r + 7*s + 9) - 32*r - 21*s - 19) + k2**2*(36*C*(6*r + 3*s - 2) + 2*K*(8*r + 10*s - 13) - 131*r - 61*s + 34)) + 198*k1**2*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) + f*k1**2*(5*f**2*k2**2*(258*r + 117*s - 149) - 13*f*(k1**2*(4*C*(59*r + 74*s - 37) - 118*r - 185*s + 79) + 11*k2**2*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) - 286*k2**2*(3*b2*(r + s - 2) - 2*g2*(8*r + 10*s - 13))))/(45045*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**4*f*k2**2*(9*b1 + 11*f)*(r + s - 1)/(315*d*k1*k3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**3*f*k2*(18*b1*(C - 1) + f*(22*C - 13))*(r + s - 1)/(315*d*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**2*f*k2**2*st**2*(9*b1 - f)*(r + s - 1)/(105*d*k1*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**2*f*(r + s - 1)*(18*b1**2*k2**2 + b1*(k1**2*(18 - 36*C) + k2**2*(13*f + 18)) - 2*f*(k1**2*(4*C - 2) + 9*k2**2))/(315*d*k1*k3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2*st**2*(9*b1*(3*C - 2) + f*(5 - 3*C))*(r + s - 1)/(315*d*k3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2*(r + s - 1)*(18*C*f + 9*b1**2 + b1*(-9*K + 2*f + 9) - 9*b2 - 9*f + 18*g2)/(315*d*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*st**2*(r + s - 1)*(9*b1**2*k2**2 + 2*b1*f*k2**2 + b1*k1**2*(9 - 18*C) + f*k1**2*(14*C - 7))/(315*d*k1*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*(r + s - 1)*(2*K*b1*k1**2 + b1*f*k2**2 + 2*b2*k1**2 - 4*g2*k1**2)/(35*d*k1*k3) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**7*f**2*k2**5*(C - 1)*(22*b1*(2*r + 2*s - 1) + f*(41*r + 41*s - 20))/(693*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**6*f**2*k2**4*(22*b1*(2*r + 2*s - 1) + f*(41*r + 41*s - 20))/(693*d*k1*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**6*f**2*k2**4*(26*b1*(5*f*k2**2*(52*r + 52*s - 31) + 22*k1**2*(C*(73*r + 73*s - 41) - 63*r - 63*s + 36)) + 5*f*(63*f*k2**2*(19*r + 19*s - 11) + 26*k1**2*(2*C*(139*r + 139*s - 78) - 237*r - 237*s + 136)))/(45045*d*k1*k3**5) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**5*st**2*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(-108*r - 108*s + 83))/(3465*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f*k2**3*(-198*b1**2*(C - 1)*(r + s - 1) + 11*b1*f*(2*C*(9*r + 9*s + 1) - 31*r - 31*s + 9) + 10*f**2*(C*(41*r + 41*s - 20) - 49*r - 49*s + 29))/(3465*d*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f*k2**3*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(5*f**2*k2**2*(79*r + 79*s - 60) + 11*f*(k1**2*(2*C*(101*r + 101*s - 64) - 149*r - 149*s + 97) + k2**2*(-18*C*(2*r + 2*s - 1) + K*(11*r + 11*s - 1) + 25*r + 25*s - 17)) - 198*g2*k2**2*(r + s)) - 2*f*(105*f**2*k2**2*(31*r + 31*s - 20) + 65*f*(k1**2*(56*C*(3*r + 3*s - 2) - 119*r - 119*s + 83) + k2**2*(22 - 22*C)*(2*r + 2*s - 1)) - 143*g2*k2**2*(11*r + 11*s - 1)))/(45045*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(55*b1*(2*r + 2*s - 1) + f*(-108*r - 108*s + 83))/(3465*d*k1*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(65*b1*f*k2**2*(56*r + 56*s - 41) + 286*b1*k1**2*(C*(5*r + 5*s + 11) - 15*r - 15*s - 6) + 75*f**2*k2**2*(71*r + 71*s - 50) + 26*f*k1**2*(C*(933*r + 933*s - 677) - 825*r - 825*s + 594))/(45045*d*k1*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**2*(11*b1**2*(k1**2*(54*C - 45)*(r + s - 1) + k2**2*(f*(31*r + 31*s - 21) + 9*r + 9*s)) + b1*f*(-11*k1**2*(6*C*(3*r + 3*s + 1) - 11*r - 11*s - 4) + k2**2*(15*f*(20*r + 20*s - 13) - 77*r - 77*s + 88)) - 10*f**2*(k1**2*(19*C*(3*r + 3*s - 2) - 35*r - 35*s + 27) + 11*k2**2*(2*r + 2*s - 1)))/(3465*d*k1*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**2*(143*b1**2*k1**2*k2**2*(f*(97*r + 97*s - 53) + (72 - 90*K)*(r + s)) + 26*b1*(5*f**2*k2**2*(6*k1**2*(r + s + 3) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*k1**2*(k1**2*(2*C*(65*r + 65*s - 46) - 82*r - 82*s + 59) + k2**2*(-18*C*(7*r + 7*s - 4) + K*(37*r + 37*s - 5) + 82*r + 82*s - 59)) + 990*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(-69*r - 69*s + 55) + 13*k2**2*(5*r + 5*s - 3)) - 260*f*k1**2*(k1**2*(C*(80*r + 80*s - 68) - 45*r - 45*s + 41) - 11*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) + 572*g2*k1**2*k2**2*(37*r + 37*s - 5)))/(45045*d*k1*k3**5) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**5*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(19*r + 19*s - 9))/(1155*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(594*b1**2*(C - 1)*(r + s - 1) - 11*b1*f*(C*(46*r + 46*s - 26) + 19*r + 19*s + 7) + f**2*(4*C*(108*r + 108*s - 83) - 717*r - 717*s + 511))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (27 - 27*K)*(r + s)) + 13*b1*(2*f**2*k2**2*(401*r + 401*s - 260) + 11*f*(k1**2*(C*(230*r + 230*s - 34) - 205*r - 205*s + 35) + 3*k2**2*(18*C*(2*r + 2*s - 1) + K*(r + s - 2) - 37*r - 37*s + 20)) + 594*g2*k2**2*(r + s)) + f*(90*f**2*k2**2*(139*r + 139*s - 101) + 13*f*(k1**2*(22*C*(137*r + 137*s - 95) - 2297*r - 2297*s + 1579) + k2**2*(66*C - 66)*(2*r + 2*s - 1)) - 858*g2*k2**2*(r + s - 2)))/(45045*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2*(-99*b1**3*k2**2*(r + s - 1) + 11*b1**2*(k1**2*(54*C - 36)*(r + s - 1) + k2**2*(-9*K + 2*f*(13*r + 13*s - 7) + 18*r + 18*s + 9)) + b1*(5*f**2*k2**2*(51*r + 51*s - 32) - 11*f*(k1**2*(6*C - 4) + k2**2*(-18*C*r - 18*C*s + K*(11*r + 11*s - 1) + 12*r + 12*s - 6)) - 99*k2**2*(b2*(r + s) - 2*g2)) + f*(-10*f*k1**2*(C*(13*r + 13*s - 16) - 5*r - 5*s + 7) + 110*f*k2**2*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3) + k2**2*(-11*b2 + 22*g2)*(11*r + 11*s - 1)))/(3465*d*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2*(429*b1**2*k2**2*(f*k1**2*(13*r + 13*s - 8) - 3*f*k2**2*(2*r + 2*s - 1) + k1**2*(18 - 30*K)*(r + s)) + 13*b1*(10*f**2*k2**2*(k1**2*(19*r + 19*s - 9) + 11*k2**2*(4*r + 4*s - 3)) - 11*f*(k1**4*(C*(38*r + 38*s - 28) - 21*r - 21*s + 15) + k1**2*k2**2*(-54*C*(3*r + 3*s - 2) + K*(47*r + 47*s - 10) + 96*r + 96*s - 75) + k2**4*(9 - 9*K)*(r + s)) + 1980*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(3*r + 3*s + 1) + 26*k2**2*(3*r + 3*s - 2)) - 130*f*k1**2*(k1**2*(C*(7*r + 7*s - 12) - 2*r - 2*s + 5) - 11*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) - 286*g2*k2**2*(k1**2*(-47*r - 47*s + 10) + 9*k2**2*(r + s))))/(45045*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(55*b1*(2*r + 2*s - 1) + f*(19*r + 19*s - 9))/(1155*d*k1*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(65*b1*f*k2**2*(25*r + 25*s - 13) + 286*b1*k1**2*(26*C - 21)*(2*r + 2*s - 1) + 30*f**2*k2**2*(7*r + 7*s - 2) + 26*f*k1**2*(C*(90*r + 90*s - 38) - 71*r - 71*s + 29))/(15015*d*k1*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k1*(143*b1**2*k2**2*(f*k1**2*(25*r + 25*s - 17) - 9*f*k2**2*(9*r + 9*s - 5) + k1**2*(72 - 180*K)*(r + s)) + 26*b1*(5*f**2*k2**2*(k1**2*(2*r + 2*s - 5) - 22*k2**2) - 11*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(-18*C*(5*r + 5*s - 4) + K*(29*r + 29*s - 10) + 46*r + 46*s - 41) + k2**4*(18 - 27*K)*(r + s)) + 1980*g2*k1**2*k2**2*(r + s)) + f*(105*f**2*k2**2*(k1**2*(8*r + 8*s - 6) + 13*k2**2*(9*r + 9*s - 7)) + 130*f*k1**2*(k1**2*(2*C - 1)*(3*r + 3*s - 2) + 22*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 572*g2*k2**2*(k1**2*(-29*r - 29*s + 10) + 27*k2**2*(r + s))))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(-33*b1**2*(k1**2*(42*C - 33)*(r + s - 1) + k2**2*(-f*(r + s - 3) + 9*r + 9*s)) + b1*f*(-11*k1**2*(8*C*(8*r + 8*s + 1) - 67*r - 67*s - 5) + 3*k2**2*(f*(93*r + 93*s - 83) + 209*r + 209*s - 121)) + f**2*(-2*k1**2*(C*(501*r + 501*s - 345) - 395*r - 395*s + 267) + 33*k2**2*(2*r + 2*s - 1)))/(3465*d*k1*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(-429*b1**2*k1**2*k2**2*(f*(31*r + 31*s - 11) + (54*K - 36)*(r + s)) + 26*b1*(3*f**2*k2**2*(4*k1**2*(37*r + 37*s - 21) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**2*(2*C*(71*r + 71*s - 13) - 97*r - 97*s + 17) + 3*k2**2*(6*C*(15*r + 15*s - 8) + 3*K*(r + s - 2) - 74*r - 74*s + 43)) + 1782*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*(3*k1**2*k2**2*(451*r + 451*s - 335) - 26*k2**4*(5*r + 5*s - 3)) + 26*f*(2*k1**4*(372*C*(3*r + 3*s - 2) - 721*r - 721*s + 477) + 11*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) - 5148*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k1*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*(198*b1**3*k1**2*k2**2*(r + s - 1) - 11*b1**2*(-9*f*k2**4*(3*r + 3*s - 2) + k1**4*(18*C - 9)*(r + s - 1) + k1**2*k2**2*(-27*K + f*(4*r + 4*s - 1) + 9*r + 9*s + 18)) + b1*(5*f**2*k2**2*(k1**2*(r + s + 2) + 22*k2**2*(3*r + 3*s - 2)) + 11*f*(k1**4*(2*C - 1) + 3*k1**2*k2**2*(-6*C*r - 6*C*s + K*(5*r + 5*s - 1) + r + s + 1) + 9*k2**4*(r + s)) + 297*k1**2*k2**2*(b2*(r + s) - 2*g2)) + f*k1**2*(-5*f*(k1**2*(2*C - 1)*(3*r + 3*s - 2) + 22*k2**2*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + k2**2*(33*b2 - 66*g2)*(5*r + 5*s - 1)))/(3465*d*k1*k3**3) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(11*b1*(5*C - 4)*(2*r + 2*s - 1) + f*(C*(19*r + 19*s - 9) - 13*r - 13*s + 5))/(1155*d*k3**3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(715*b1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(f*k2**2*(13*r + 13*s - 5) + k1**2*(242*C - 154)*(2*r + 2*s - 1)) + 2*f*(8*f*k2**2*(r + s - 4) - 13*k1**2*(11*C*(3*r + 3*s - 1) - 20*r - 20*s + 6)))/(15015*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k1**2*k2*(11*b1**2*(f*k1**2*(2*r + 2*s - 1) - 9*f*k2**2*(3*r + 3*s - 2) + k1**2*(9 - 45*K)*(r + s)) + b1*(-5*f**2*(k1**2*(3*r + 3*s - 2) + 22*k2**2*(2*r + 2*s - 1)) + 11*f*(k1**2*(18*C*(r + s - 1) - 5*K*(2*r + 2*s - 1) - 7*r - 7*s + 8) + k2**2*(27*K - 9)*(r + s)) + 990*g2*k1**2*(r + s)) + f*(105*f**2*k2**2*(r + s - 1) + f*k1**2*(220*C - 110)*(r + s - 1) + 22*g2*(5*k1**2*(2*r + 2*s - 1) - 27*k2**2*(r + s))))/(3465*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(297*b1**3*k2**2*(r + s - 1) - 33*b1**2*(k1**2*(30*C - 18)*(r + s - 1) + k2**2*(f*(-16*r - 16*s + 13) - (9*K - 9)*(r + s))) + b1*(f**2*k2**2*(423*r + 423*s - 356) - 11*f*(4*k1**2*(2*C*(7*r + 7*s + 2) - 7*r - 7*s - 4) + 3*k2**2*(18*C*(2*r + 2*s - 1) + K*(r + s - 2) - 28*r - 28*s + 17)) + k2**2*(297*b2 - 594*g2)*(r + s)) + f*(f*k1**2*(C*(-578*r - 578*s + 378) + 326*r + 326*s - 210) - 11*f*k2**2*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5) + k2**2*(-33*b2 + 66*g2)*(r + s - 2)))/(3465*d*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2*(99*b1**3*k1**2*(r + s - 1) - 11*b1**2*(-9*f*k2**2*(2*r + 2*s - 1) + k1**2*(-27*K + f + 9)) + b1*(5*f**2*(k1**2 + 22*k2**2)*(3*r + 3*s - 2) + 11*f*(k1**2*(3*K - 1)*(2*r + 2*s - 1) + k2**2*(9 - 9*K)*(r + s)) + 297*k1**2*(b2*(r + s) - 2*g2)) + 11*f*(b2*k1**2*(6*r + 6*s - 3) - 9*b2*k2**2*(r + s) + f*k1**2*(10 - 20*C)*(r + s - 1) - 6*g2*k1**2*(2*r + 2*s - 1) + 18*g2*k2**2*(r + s)))/(3465*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(1287*b1**2*k2**2*(f*k1**2*(8*r + 8*s - 3) + 3*f*k2**2*(2*r + 2*s - 1) + k1**2*(9*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(k1**2*(134*r + 134*s - 115) - 33*k2**2*(4*r + 4*s - 3)) - 11*f*k1**2*(2*k1**2*(C*(59*r + 59*s - 7) - 33*r - 33*s + 3) + 3*k2**2*(6*C*(12*r + 12*s - 7) + 3*K*(r + s - 2) - 46*r - 46*s + 29)) - 1782*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k2**2*(k1**2*(-309*r - 309*s + 235) + 39*k2**2*(3*r + 3*s - 2)) - 13*f*k1**2*(k1**2*(66*C*(11*r + 11*s - 7) - 400*r - 400*s + 252) + 11*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**3*k2**6*st**6*(39*b1*(3*r + 3*s - 2) + 7*f*(4*r + 4*s - 3))/(3003*d*k1*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(11*b1**2*k2**2*(4*r + 4*s - 3) + 2*b1*f*k2**2*(6*r + 6*s - 5) - 33*b1*k1**2*(2*C - 1)*(2*r + 2*s - 1) - f*k1**2*(2*C - 1)*(7*r + 7*s - 1))/(1155*d*k1*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(1144*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(-2*f*k1**2*k2**2*(10*r + 10*s - 3) - 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(2*r + 2*s - 1)) + 2*f*(4*f*k1**2*k2**2*(9*r + 9*s - 10) + 13*f*k2**4*(5*r + 5*s - 3) - k1**4*(26*C - 13)*(7*r + 7*s - 1)))/(15015*d*k1*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1**3*(10*b1*f**2*k2**2*(r + s - 1) + b1*f*(2*K*(k1**2*(2*r + 2*s - 1) - 9*k2**2*(r + s)) + 9*b1*k2**2*(r + s - 1)) + 18*b1*k1**2*(r + s)*(K*b1 - 2*g2) + 4*f*g2*(k1**2*(-2*r - 2*s + 1) + 9*k2**2*(r + s)))/(315*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1*(9*K*b1**2*k1**2 - b1*(f*(K*k1**2*(-2*r - 2*s + 1) + 9*K*k2**2*(r + s) - 5*f*k2**2*(r + s - 1)) + 18*g2*k1**2) + b2*(9*b1*k1**2*(r + s) + f*k1**2*(2*r + 2*s - 1) - 9*f*k2**2*(r + s)) + 2*f*g2*(k1**2*(-2*r - 2*s + 1) + 9*k2**2*(r + s)))/(315*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1*st**2*(143*b1**2*k2**2*(54*K*k1**2*(r + s) + 2*f*k1**2*(19*r + 19*s - 5) + 9*f*k2**2*(9*r + 9*s - 5)) + 26*b1*(f**2*k2**2*(k1**2*(89*r + 89*s - 63) + 11*k2**2) - 11*f*k1**2*(k1**2*(2*C - 1)*(7*r + 7*s + 1) + 3*k2**2*(6*C*(3*r + 3*s - 2) + K*(r + s - 2) - 9*r - 9*s + 6)) - 594*g2*k1**2*k2**2*(r + s)) + f*(5*f**2*k2**2*(k1**2*(-90*r - 90*s + 74) + 13*k2**2*(9*r + 9*s - 7)) - f*k1**2*(52*C - 26)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(r + s - 2)))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*st**2*(198*b1**3*k1**2*k2**2*(r + s - 1) - 11*b1**2*(-9*f*k2**4*(3*r + 3*s - 2) + k1**4*(18*C - 9)*(r + s - 1) - k1**2*k2**2*(27*K*(r + s) + 2*f*(7*r + 7*s - 4))) + b1*(f**2*k2**2*(2*k1**2*(63*r + 63*s - 50) + 11*k2**2*(3*r + 3*s - 2)) - 11*f*k1**2*(k1**2*(16*C - 8) + 3*k2**2*(6*C*(3*r + 3*s - 2) + K*(r + s - 2) - 9*r - 9*s + 6)) + k1**2*k2**2*(297*b2 - 594*g2)*(r + s)) + f*k1**2*(-f*(2*C - 1)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + k2**2*(-33*b2 + 66*g2)*(r + s - 2)))/(3465*d*k1*k3**3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1**2*ct*f*k2*(9*b1*r + f*(2*r - 1) + 9*r - 9)/(315*d*k1) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct**3*f*k2*(9*b1*r + f*(2*r - 1))/(315*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct**2*f*(2*C - 1)*(9*b1*r + f*(2*r - 1))/(315*d) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct*f*k2*st**2*(9*b1*r + f*(8 - 7*r))/(315*d*k1) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*f*st**2*(2*C - 1)*(9*b1*r + f*(8 - 7*r))/(315*d) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*f*(r - 1)*(K*b1 + b2 - 2*g2)/(35*d) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**6*f**2*k2**4*(C - 1)*(-22*b1*r + 5*f*(3*r - 1))/(3465*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**5*f**2*k2**3*(-22*b1*r + 5*f*(3*r - 1))/(3465*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**5*f**2*k2**3*(-286*b1*k1**2*r*(8*C - 7) + 105*f**2*k2**2*(4*r - 1) + 65*f*(3*b1*k2**2*r + k1**2*(8*C - 7)*(3*r - 1)))/(45045*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**4*st**2*(C - 1)*(77*b1*r + f*(37*r - 16))/(1155*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f*k2**2*(198*b1**2*r*(C - 1) - 22*b1*f*(C - r - 1) + f**2*(10*C - 15)*(3*r - 1))/(3465*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f*k2**2*(-1287*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 315*f**3*k2**2*(4*r - 1) + 65*f**2*(b1*k2**2*(6*r + 1) + k1**2*(12*C - 9)*(3*r - 1)) + 143*f*(2*b1**2*k2**2*r + 6*b1*k1**2*r*(3 - 4*C) + b1*k2**2*(-2*K*r + K + 2*r - 1) + 2*g2*k2**2*(2*r - 1)))/(45045*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(77*b1*r + f*(37*r - 16))/(1155*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(2405*b1*f*k2**2*r + 3003*b1*k1**2*r*(6*C - 5) + 25*f**2*k2**2*(45*r - 8) + f*k1**2*(234*C - 195)*(37*r - 16))/(45045*d*k1*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k1*k2*(-1287*b1*k2**2*r*(b1*(4*K - 3) - 8*g2) + 315*f**3*k2**2*(4*r - 1) + 65*f**2*(3*b1*k2**2 + k1**2*(8*C - 5)*(3*r - 1)) + 143*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(5 - 8*C) + b1*k2**2*(K*(4 - 8*r) + 6*r - 3) + 8*g2*k2**2*(2*r - 1)))/(45045*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k2*(11*b1**2*r*(k1**2*(36*C - 27) + k2**2*(4*f + 9)) + b1*f*(k1**2*(33 - 44*C) + k2**2*(-30*f*r + 10*f + 22*r - 11)) + f**2*k1**2*(20*C - 15)*(3*r - 1))/(3465*d*k1*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**4*st**4*(C - 1)*(-22*b1*r + f*(5*r - 9))/(1155*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k1**2*(-3861*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 105*f**3*k2**2*(4*r - 1) + 65*f**2*(3*b1*k2**2*(1 - 2*r) + k1**2*(2*C - 1)*(3*r - 1)) + 143*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(1 - 2*C) - 3*b1*k2**2*(2*K - 1)*(2*r - 1) + 12*g2*k2**2*(2*r - 1)))/(45045*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(C - 1)*(99*b1**2*r + 11*b1*f*(35*r + 8) + 6*f**2*(37*r - 16))/(3465*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(-1287*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 90*f**3*k2**2*(45*r - 8) + 26*f**2*(6*b1*k2**2*(37*r + 8) + k1**2*(19*C - 13)*(37*r - 16)) - 143*f*(42*b1**2*k2**2*r + 14*b1*k1**2*r*(13 - 19*C) - b1*k2**2*(K - 1)*(7*r - 8) + 2*g2*k2**2*(7*r - 8)))/(45045*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*(-99*b1**3*k2**2*r + 11*b1**2*(k1**2*r*(18*C - 9) + k2**2*(-9*K + 4*f*r + f + 9*r + 9)) + b1*(15*f**2*k2**2*(1 - 3*r) - 11*f*(k1**2*(2*C - 1) + k2**2*(K - 2)*(2*r - 1)) + 99*k2**2*(-b2*r + 2*g2)) + f*(f*k1**2*(10*C - 5)*(3*r - 1) + k2**2*(-11*b2 + 22*g2)*(2*r - 1)))/(3465*d*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(-22*b1*r + f*(5*r - 9))/(1155*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(286*b1*k1**2*r*(3 - 4*C) + 5*f**2*k2**2*(32*r - 21) + 13*f*(25*b1*k2**2*r + k1**2*(4*C - 3)*(5*r - 9)))/(15015*d*k1*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1**3*k2*(11*b1**2*r*(-36*K + 2*f + 9) + b1*(f**2*(5 - 15*r) - 11*f*(4*K - 1)*(2*r - 1) + 792*g2*r) + 88*f*g2*(2*r - 1))/(3465*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1*k2*(99*b1**3*r - 11*b1**2*(-18*K + f + 9) + b1*(198*b2*r + 5*f**2*(3*r - 1) + 11*f*(2*K - 1)*(2*r - 1) - 396*g2) + 22*f*(b2 - 2*g2)*(2*r - 1))/(3465*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1*k2*st**2*(-1287*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 45*f**3*k2**2*(45*r - 8) + 13*f**2*(144*b1*k2**2 + k1**2*(16*C - 9)*(37*r - 16)) - 143*f*(63*b1**2*k2**2*r + 7*b1*k1**2*r*(9 - 16*C) - b1*k2**2*(2*K - 1)*(7*r - 8) + 4*g2*k2**2*(7*r - 8)))/(45045*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k2*st**2*(33*b1**2*r*(k1**2*(12*C - 9) + k2**2*(3 - 14*f)) + b1*f*(44*k1**2*(14*C*r + 8*C - 7*r - 6) + k2**2*(-222*f*r + 96*f - 77*r + 88)) + f**2*k1**2*(12*C - 7)*(37*r - 16))/(3465*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(2*C - 1)*(-22*b1*r + f*(5*r - 9))/(1155*d*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(286*b1*r*(b1*k2**2 + k1**2*(1 - 2*C)) + 3*f**2*k2**2*(32*r - 21) + 13*f*(b1*k2**2*(10*r + 9) + k1**2*(2*C - 1)*(5*r - 9)))/(15015*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**4*(-K*b1 + 2*g2)*(9*b1*r + f*(2*r - 1))/(315*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**2*(b2*(9*b1*r + f*(2*r - 1)) + (9*b1 + f*(2*r - 1))*(K*b1 - 2*g2))/(315*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**2*st**2*(-1287*b1*k2**2*r*(K*b1 - 2*g2) + 5*f**3*k2**2*(45*r - 8) + 13*f**2*(2*b1*k2**2*(24 - 37*r) + k1**2*(2*C - 1)*(37*r - 16)) - 143*f*(K*b1*k2**2*(8 - 7*r) + 7*b1*r*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(7*r - 8)))/(45045*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*st**2*(99*b1**3*k2**2*r + 11*b1**2*(2*f*k2**2*(7*r + 4) + r*(-18*C*k1**2 + 9*K*k2**2 + 9*k1**2)) + b1*(3*f**2*k2**2*(37*r - 16) - 11*f*(K*k2**2*(7*r - 8) + k1**2*(16*C - 8)) + k2**2*r*(99*b2 - 198*g2)) + f*(-f*k1**2*(2*C - 1)*(37*r - 16) + k2**2*(-11*b2 + 22*g2)*(7*r - 8)))/(3465*d*k3**2)
        perm23 = -8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*b1**2*f*(k1**2*s + k2**2*(4*C - 2)*(r - 1))/(35*d*k1*k2**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*b1*f*k1*(b1*k1**2*(-18*K*k2**2*(r + s) + f*k1**2*(4*r + 4*s - 2) - 9*f*k2**2*(3*r + 3*s - 1)) + 10*f**2*k1**4*(r + s - 1) + 2*f*k2**2*(2*C - 1)*(k1**2*(-2*r - 2*s + 1) + 9*k2**2*(r + s)) + 36*g2*k1**2*k2**2*(r + s))/(315*d*k3**6) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**7*f**2*k1**2*k2**3*(286*b1*(K - 1)*(2*r + 2*s - 1) + 21*f**2*(35*r + 35*s - 23) + f*(26*C - 26)*(41*r + 41*s - 20) - 572*g2*(2*r + 2*s - 1))/(9009*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**6*f**2*k1*k2**2*(-26*b1*(k1**2*(33*K - 33)*(11*r + 11*s - 7) - 5*k2**2*(f*(52*r + 52*s - 31) + (22 - 44*K)*(2*r + 2*s - 1))) - 105*f**2*k1**2*(163*r + 163*s - 119) - 130*f*(k1**2*(38*C - 38)*(3*r + 3*s - 2) + k2**2*(4*C - 3)*(41*r + 41*s - 20)) + 572*g2*(3*k1**2*(11*r + 11*s - 7) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**5*f**2*k1**2*k2**3*st**2*(-1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(523*r + 523*s - 376) + f*(52*C - 52)*(108*r + 108*s - 83) + 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**5*f*k2*(-1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(5*f**2*k1**2*k2**2*(79*r + 79*s - 60) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(5*r + 5*s - 4) + k1**2*k2**2*(C*(22*r + 22*s - 2) + K*(48*r + 48*s - 33) - 37*r - 37*s + 14)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-105*f**2*k1**2*(k1**2*(54*r + 54*s - 47) - 13*k2**2*(3*r + 3*s - 2)) - 65*f*(k1**4*(2*C - 2)*(13*r + 13*s - 16) + k1**2*k2**2*(4*C*(35*r + 35*s - 27) - 83*r - 83*s + 70) + k2**4*(2*C - 1)*(41*r + 41*s - 20)) + 286*g2*(3*k1**4*(5*r + 5*s - 4) + 3*k1**2*k2**2*(16*r + 16*s - 11) + 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f**2*k1*k2**2*st**2*(13*b1*(k1**2*(99*K - 99)*(5*r + 5*s - 1) - 5*k2**2*(f*(56*r + 56*s - 41) + (44*K - 22)*(2*r + 2*s - 1))) + 50*f**2*k1**2*(387*r + 387*s - 287) + 26*f*(k1**2*(3*C - 3)*(167*r + 167*s - 115) + k2**2*(4*C - 3)*(108*r + 108*s - 83)) - 286*g2*(9*k1**2*(5*r + 5*s - 1) - 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f*k1*(143*b1**2*(f*k2**4*(31*r + 31*s - 11) - 18*k2**2*(r + s)*(k1**2*(3*K - 3) + k2**2*(2*K - 1))) - 26*b1*(5*f**2*k2**2*(6*k1**2*(r + s + 3) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**4*(K - 1)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(2*C*(5*r + 5*s - 1) + K*(r + s - 2) - 6*r - 6*s) + k2**4*(C*(44*r + 44*s - 4) - 3*K*(r + s + 1) - 15*r - 15*s - 6)) - 198*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + f*(-105*f**2*k1**2*(k1**2*(7*r + 7*s - 15) - 13*k2**2*(15*r + 15*s - 11)) + 130*f*(k1**4*(2*C - 2)*(3*r + 3*s - 2) + k1**2*k2**2*(8*C*(10*r + 10*s - 3) - 93*r - 93*s + 40) + k2**4*(2*C*(31*r + 31*s - 6) - 75*r - 75*s + 28)) + 572*g2*(k1**4*(2*r + 2*s - 1) + 3*k1**2*k2**2*(r + s - 2) - 3*k2**4*(r + s + 1))))/(45045*d*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f**2*k1**2*k2**3*st**4*(715*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(62*r + 62*s - 27) + f*(26*C - 26)*(19*r + 19*s - 9) - 1430*g2*(2*r + 2*s - 1))/(15015*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f*k2*st**2*(3861*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(2*f**2*k1**2*k2**2*(401*r + 401*s - 260) - 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 1) + 3*k1**2*k2**2*(2*C*(r + s - 2) + 3*K*(16*r + 16*s - 5) - 35*r - 35*s + 16)) - 594*g2*k1**2*k2**2*(r + s)) + f*(-10*f**2*k1**2*(k1**2*(1701*r + 1701*s - 1292) - 65*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(2*C - 2)*(289*r + 289*s - 189) + 3*k1**2*k2**2*(C*(712*r + 712*s - 482) - 545*r - 545*s + 367) + k2**4*(4*C - 2)*(108*r + 108*s - 83)) + 286*g2*(9*k1**4*(5*r + 5*s - 1) + 9*k1**2*k2**2*(16*r + 16*s - 5) - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f*(-1287*b1*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 105*f**3*(k1**6*(4*r + 4*s - 3) + 13*k1**4*k2**2*(6*r + 6*s - 5)) - 65*f**2*(k1**4*k2**2*(C*(-56*r - 56*s + 52) + 2*b1*(19*r + 19*s - 9) + 53*r + 53*s - 50) + k1**2*k2**4*(-2*C*(119*r + 119*s - 72) + 22*b1*(4*r + 4*s - 3) + 185*r + 185*s - 116) + k2**6*(22 - 44*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(b1**2*k1**2*k2**2*(35*r + 35*s - 13) + b1*(k1**4*(-6*C*(2*r + 2*s - 1) + K*(5*r + 5*s - 7) + 5*r + 5*s + 2) + 3*k1**2*k2**2*(-2*C*(7*r + 7*s - 2) + K*(13*r + 13*s - 8) + 3) + k2**4*(C*(-22*r - 22*s + 2) + 9*K*(2*r + 2*s - 1) + 11*r + 11*s - 1)) - 2*g2*(k1**4*(5*r + 5*s - 7) + 3*k1**2*k2**2*(13*r + 13*s - 8) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f**2*k1*k2**2*st**4*(-858*b1*k1**2*(K - 1)*(2*r + 2*s - 1) + 65*b1*k2**2*(f*(25*r + 25*s - 13) + (22 - 44*K)*(2*r + 2*s - 1)) + 10*f**2*k1**2*(33*r + 33*s - 41) - 26*f*(k1**2*(2*C - 2)*(7*r + 7*s - 1) + k2**2*(4*C - 3)*(19*r + 19*s - 9)) + 572*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(15015*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k1*st**2*(429*b1**2*(f*k2**4*(r + s - 5) + 18*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) + 26*b1*(3*f**2*k2**2*(4*k1**2*(37*r + 37*s - 21) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(7*r + 7*s + 1) + 3*k1**2*k2**2*(2*C*(r + s - 2) + 3*K*(13*r + 13*s - 4) - 26*r - 26*s + 13) + 3*k2**4*(4*C*(r + s - 2) + 3*K*(17*r + 17*s - 7) - 21*r - 21*s + 15)) - 594*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(-15*f**2*(k1**4*(811*r + 811*s - 631) - 26*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f*(k1**4*(2*C - 2)*(37*r + 37*s - 21) + k1**2*k2**2*(2*C*(611*r + 611*s - 400) - 933*r - 933*s + 611) + 3*k2**4*(C*(422*r + 422*s - 274) - 233*r - 233*s + 148)) + 572*g2*(k1**4*(7*r + 7*s + 1) + 9*k1**2*k2**2*(13*r + 13*s - 4) + 9*k2**4*(17*r + 17*s - 7))))/(45045*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k1*(33*b1**2*(f*k2**2*(k1**2*(17*r + 17*s - 7) - 3*k2**2*(3*r + 3*s - 1)) + (r + s)*(-18*K*k2**4 - 6*k1**4*(K - 1) - 6*k1**2*k2**2*(6*K - 3))) - 2*b1*(5*f**2*(k1**4*(2*r + 2*s - 5) - 22*k1**2*k2**2) + 11*f*(k1**4*(2*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(6*C*(r + s - 2) + K*(-16*r - 16*s + 17) + 9*r + 9*s) - 3*k2**4*(2*C*(r + s + 1) + K*(9*r + 9*s - 6) - 4*r - 4*s - 1)) - 198*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) + f*(315*f**2*k1**4*(r + s - 1) + 10*f*k2**2*(k1**2*(C*(94*r + 94*s - 92) - 69*r - 69*s + 68) + k2**2*(44*C - 22)*(3*r + 3*s - 2)) - 44*g2*k2**2*(k1**2*(16*r + 16*s - 17) + 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**4*k1**2*k2**3*st**6*(157*r + 157*s - 108)/(3003*d*k3**6) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**2*k2*st**4*(f**2*(84*k1**4*(4*r + 4*s - 3) + 130*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(k1**2*k2**2*(b1*(13*r + 13*s - 5) - (4*C - 3)*(7*r + 7*s - 1)) - k2**4*(2*C - 1)*(19*r + 19*s - 9)) - 143*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(15015*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*st**2*(-3861*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(45*r + 45*s - 37) - 13*k1**4*k2**2*(6*r + 6*s - 5)) + 13*f**2*(k1**4*k2**2*(b1*(134*r + 134*s - 115) + (4*C - 3)*(37*r + 37*s - 21)) + k1**2*k2**4*(C*(710*r + 710*s - 466) - 33*b1*(4*r + 4*s - 3) - 388*r - 388*s + 255) + k2**6*(66*C - 33)*(2*r + 2*s - 1)) - 143*f*k2**2*(6*b1**2*k1**2*k2**2*(5*r + 5*s - 4) + b1*(-k1**4*(2*K - 1)*(7*r + 7*s + 1) - 3*k1**2*k2**2*(4*C*(r + s - 2) + 3*K*(11*r + 11*s - 5) - 12*r - 12*s + 12) + 3*k2**4*(-2*C*(r + s - 2) - 9*K*(2*r + 2*s - 1) + r + s - 2)) + 2*g2*(2*k1**4*(7*r + 7*s + 1) + 9*k1**2*k2**2*(11*r + 11*s - 5) + 27*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**6) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*(11*b1**2*k1**2*k2**2*(f*(k1**2*(8*r + 8*s - 4) - 9*k2**2*(3*r + 3*s - 1)) + (r + s)*(-27*K*k2**2 - 9*k1**2*(2*K - 1))) + b1*(5*f**2*k1**4*(k1**2*(3*r + 3*s - 2) + 22*k2**2*(2*r + 2*s - 1)) + 11*f*k2**2*(-k1**4*(4*C - 3)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(C*(8*r + 8*s + 2) + 3*K*(r + s - 1) - 7*r - 7*s - 1) + k2**4*(18*C - 9)*(r + s)) + 198*g2*k1**2*k2**2*(2*k1**2 + 3*k2**2)*(r + s)) + 22*f*k1**2*k2**4*(f*(10*C - 5) - 9*g2)*(r + s - 1))/(3465*d*k2*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**3*k1*k2**2*st**6*(-39*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(73*r + 73*s - 45))/(3003*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**2*k1*st**4*(2*f**2*(k1**4*(76*r + 76*s - 44) + 13*k1**2*k2**2*(15*r + 15*s - 11)) - 13*f*(b1*k1**2*k2**2*(20*r + 20*s - 6) + 11*b1*k2**4*(5*r + 5*s - 3) + k2**4*(4*C - 2)*(7*r + 7*s - 1)) + k2**4*(2*r + 2*s - 1)*(-858*K*b1 + 286*b1**2 + 1716*g2))/(15015*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*k1*st**2*(33*b1**2*(18*K*k2**4*(r + s) + 2*f*k1**2*k2**2*(5*r + 5*s - 4) + 3*f*k2**4*(3*r + 3*s - 1)) - 2*b1*(f**2*(k1**4*(89*r + 89*s - 63) + 11*k1**2*k2**2) + 11*f*(K*k1**2*k2**2*(7*r + 7*s + 1) + 9*K*k2**4*(3*r + 3*s - 2) + k2**4*(6*C - 3)*(r + s - 2)) + 594*g2*k2**4*(r + s)) + f*(15*f**2*k1**4*(r + s - 1) - f*k2**2*(4*C - 2)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + 44*g2*k2**2*(k1**2*(7*r + 7*s + 1) + 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1**2*f**2*k1*st**4*(r + s - 1)/(105*d*k3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1**2*f*k1*(2*C - 1)*(r + s - 1)/(35*d*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**4*f*k1*(b1*(31*f + 18) + 22*f)*(r + s - 1)/(315*d*k3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**3*f*(r + s - 1)*(-9*K*b1*k2**2 + b1*k1**2*(2*f + 9) + 2*f*k1**2 + f*k2**2*(11 - 22*C) - k2**2*(9*b2 - 18*g2))/(315*d*k2*k3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**2*f*k1*st**2*(b1*(f - 18) + 2*f)*(r + s - 1)/(105*d*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**2*f*k1*(r + s - 1)*(-8*C*f + 18*b1**2 - 9*b1*(2*K + 3*f - 2) - 18*b2 - 14*f + 36*g2)/(315*d*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*st**2*(r + s - 1)*(3*b1*(9*K*k2**2 + k1**2*(7*f - 3)) + 7*f*k1**2 + f*k2**2*(3 - 6*C) + k2**2*(27*b2 - 54*g2))/(315*d*k2*k3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*(r + s - 1)*(b1**2*k1**2 + b1*(k1**2 + k2**2*(1 - 2*C)) + f*k2**2*(2*C - 1))/(35*d*k2*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f**3*k1*k2**2*st**6*(3*r + 3*s - 2)/(77*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*k1*st**2*(r + s - 1)*(28*C*f + 18*b1**2 - 9*b1*(2*K + 3*f) - 18*b2 - 14*f + 36*g2)/(315*d*k3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*k1*(9*b1**2*k1**2*(r + s - 1) + 9*b1*(K*k1**2*(r + s) + f*k1**2*(r + s - 1) - k2**2*(2*C - 1)*(r + s - 1)) + f*(2*C - 1)*(k1**2*(2*r + 2*s - 1) - 9*k2**2*(r + s)) + k1**2*(9*b2 - 18*g2)*(r + s))/(315*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*k1*(b1*k1**2*(-18*K*k2**2*(r + s) + f*k1**2*(4*r + 4*s - 2) - 9*f*k2**2*(3*r + 3*s - 1)) + 10*f**2*k1**4*(r + s - 1) + 2*f*k2**2*(2*C - 1)*(k1**2*(-2*r - 2*s + 1) + 9*k2**2*(r + s)) + 36*g2*k1**2*k2**2*(r + s))/(315*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**7*f**2*k1**2*k2**3*(286*b1*(K - 1)*(2*r + 2*s - 1) + 21*f**2*(35*r + 35*s - 23) + f*(26*C - 26)*(41*r + 41*s - 20) - 572*g2*(2*r + 2*s - 1))/(9009*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**6*f**2*k1*k2**2*(b1*f*(52*r + 52*s - 31) + 22*b1*(2*r + 2*s - 1) + f*(41*r + 41*s - 20))/(693*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**6*f**2*k1*k2**2*(-26*b1*(k1**2*(33*K - 33)*(11*r + 11*s - 7) - 5*k2**2*(f*(52*r + 52*s - 31) + (22 - 44*K)*(2*r + 2*s - 1))) - 105*f**2*k1**2*(163*r + 163*s - 119) - 130*f*(k1**2*(38*C - 38)*(3*r + 3*s - 2) + k2**2*(4*C - 3)*(41*r + 41*s - 20)) + 572*g2*(3*k1**2*(11*r + 11*s - 7) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1**2*k2**3*st**2*(-1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(523*r + 523*s - 376) + f*(52*C - 52)*(108*r + 108*s - 83) + 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f*k2*(99*b1**2*k1**2*(K - 1)*(r + s - 1) + b1*(5*f**2*k1**2*(120*r + 120*s - 101) + 11*f*(-10*K*k2**2*(2*r + 2*s - 1) + k1**2*(22*C*(r + s - 1) + 11*r + 11*s + 1)) - 198*g2*k1**2*(r + s - 1)) - 5*f*(-19*f*k1**2*(3*r + 3*s - 2) + f*k2**2*(2*C - 1)*(41*r + 41*s - 20) + k2**2*(22*b2 - 44*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f*k2*(-1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(5*f**2*k1**2*k2**2*(79*r + 79*s - 60) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(5*r + 5*s - 4) + k1**2*k2**2*(C*(22*r + 22*s - 2) + K*(48*r + 48*s - 33) - 37*r - 37*s + 14)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-105*f**2*k1**2*(k1**2*(54*r + 54*s - 47) - 13*k2**2*(3*r + 3*s - 2)) - 65*f*(k1**4*(2*C - 2)*(13*r + 13*s - 16) + k1**2*k2**2*(4*C*(35*r + 35*s - 27) - 83*r - 83*s + 70) + k2**4*(2*C - 1)*(41*r + 41*s - 20)) + 286*g2*(3*k1**4*(5*r + 5*s - 4) + 3*k1**2*k2**2*(16*r + 16*s - 11) + 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(5*b1*(f*(56*r + 56*s - 41) - 44*r - 44*s + 22) + 2*f*(108*r + 108*s - 83))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(13*b1*(k1**2*(99*K - 99)*(5*r + 5*s - 1) - 5*k2**2*(f*(56*r + 56*s - 41) + (44*K - 22)*(2*r + 2*s - 1))) + 50*f**2*k1**2*(387*r + 387*s - 287) + 26*f*(k1**2*(3*C - 3)*(167*r + 167*s - 115) + k2**2*(4*C - 3)*(108*r + 108*s - 83)) - 286*g2*(9*k1**2*(5*r + 5*s - 1) - 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k1*(11*b1**2*(k1**2*(9*K - 9)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 10*f + 9)) + b1*(5*f**2*(k1**2*(51*r + 51*s - 54) - 11*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**2*(4*C*(r + s - 1) + 11*r + 11*s - 8) + k2**2*(44*C*(r + s - 1) - 3*K*(11*r + 11*s - 7) - 40*r - 40*s + 41)) - 198*g2*(k1**2 + 2*k2**2)*(r + s - 1)) + f*(5*f*(k1**2*(13*r + 13*s - 16) + k2**2*(-38*C*(3*r + 3*s - 2) + 13*r + 13*s - 16)) + k2**2*(-33*b2 + 66*g2)*(11*r + 11*s - 7)))/(3465*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k1*(143*b1**2*(f*k2**4*(31*r + 31*s - 11) - 18*k2**2*(r + s)*(k1**2*(3*K - 3) + k2**2*(2*K - 1))) - 26*b1*(5*f**2*k2**2*(6*k1**2*(r + s + 3) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**4*(K - 1)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(2*C*(5*r + 5*s - 1) + K*(r + s - 2) - 6*r - 6*s) + k2**4*(C*(44*r + 44*s - 4) - 3*K*(r + s + 1) - 15*r - 15*s - 6)) - 198*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + f*(-105*f**2*k1**2*(k1**2*(7*r + 7*s - 15) - 13*k2**2*(15*r + 15*s - 11)) + 130*f*(k1**4*(2*C - 2)*(3*r + 3*s - 2) + k1**2*k2**2*(8*C*(10*r + 10*s - 3) - 93*r - 93*s + 40) + k2**4*(2*C*(31*r + 31*s - 6) - 75*r - 75*s + 28)) + 572*g2*(k1**4*(2*r + 2*s - 1) + 3*k1**2*k2**2*(r + s - 2) - 3*k2**4*(r + s + 1))))/(45045*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1**2*k2**3*st**4*(715*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(62*r + 62*s - 27) + f*(26*C - 26)*(19*r + 19*s - 9) - 1430*g2*(2*r + 2*s - 1))/(15015*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(297*b1**2*k1**2*(K - 1)*(r + s - 1) - b1*(2*f**2*k1**2*(509*r + 509*s - 368) + 11*f*(10*K*k2**2*(2*r + 2*s - 1) + k1**2*(6*C*(r + s - 1) + 39*r + 39*s - 3)) + 594*g2*k1**2*(r + s - 1)) + f*(f*k1**2*(-501*r - 501*s + 345) + f*k2**2*(4*C - 2)*(108*r + 108*s - 83) - k2**2*(110*b2 - 220*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(3861*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(2*f**2*k1**2*k2**2*(401*r + 401*s - 260) - 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 1) + 3*k1**2*k2**2*(2*C*(r + s - 2) + 3*K*(16*r + 16*s - 5) - 35*r - 35*s + 16)) - 594*g2*k1**2*k2**2*(r + s)) + f*(-10*f**2*k1**2*(k1**2*(1701*r + 1701*s - 1292) - 65*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(2*C - 2)*(289*r + 289*s - 189) + 3*k1**2*k2**2*(C*(712*r + 712*s - 482) - 545*r - 545*s + 367) + k2**4*(4*C - 2)*(108*r + 108*s - 83)) + 286*g2*(9*k1**4*(5*r + 5*s - 1) + 9*k1**2*k2**2*(16*r + 16*s - 5) - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*(-11*b1**2*(-9*K*k2**4 + k1**2*k2**2*(18*C*(r + s - 1) + 18*K*(r + s - 1) + 2*f*(11*r + 11*s - 5) + 27)) + b1*(5*f**2*k1**2*(k1**2 + 22*k2**2)*(6*r + 6*s - 5) - 11*f*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(-10*C*(r + s - 1) - 3*K*(5*r + 5*s - 4) + 3) + k2**4*(-20*C + 9*K*(2*r + 2*s - 1) + 10)) + 99*k2**2*(b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 2*g2*k2**2)) + f*(5*f*(k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(C*(26*r + 26*s - 32) + 53*r + 53*s - 28) + k2**4*(22 - 44*C)*(2*r + 2*s - 1)) + k2**2*(33*b2 - 66*g2)*(k1**2*(5*r + 5*s - 4) - 3*k2**2*(2*r + 2*s - 1))))/(3465*d*k2*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*(-1287*b1*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 105*f**3*(k1**6*(4*r + 4*s - 3) + 13*k1**4*k2**2*(6*r + 6*s - 5)) - 65*f**2*(k1**4*k2**2*(C*(-56*r - 56*s + 52) + 2*b1*(19*r + 19*s - 9) + 53*r + 53*s - 50) + k1**2*k2**4*(-2*C*(119*r + 119*s - 72) + 22*b1*(4*r + 4*s - 3) + 185*r + 185*s - 116) + k2**6*(22 - 44*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(b1**2*k1**2*k2**2*(35*r + 35*s - 13) + b1*(k1**4*(-6*C*(2*r + 2*s - 1) + K*(5*r + 5*s - 7) + 5*r + 5*s + 2) + 3*k1**2*k2**2*(-2*C*(7*r + 7*s - 2) + K*(13*r + 13*s - 8) + 3) + k2**4*(C*(-22*r - 22*s + 2) + 9*K*(2*r + 2*s - 1) + 11*r + 11*s - 1)) - 2*g2*(k1**4*(5*r + 5*s - 7) + 3*k1**2*k2**2*(13*r + 13*s - 8) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(5*b1*(f*(25*r + 25*s - 13) + 44*r + 44*s - 22) + 2*f*(19*r + 19*s - 9))/(1155*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(-858*b1*k1**2*(K - 1)*(2*r + 2*s - 1) + 65*b1*k2**2*(f*(25*r + 25*s - 13) + (22 - 44*K)*(2*r + 2*s - 1)) + 10*f**2*k1**2*(33*r + 33*s - 41) - 26*f*(k1**2*(2*C - 2)*(7*r + 7*s - 1) + k2**2*(4*C - 3)*(19*r + 19*s - 9)) + 572*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(-33*b1**2*(k1**2*(3*K - 3)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 2*f + 9)) + b1*(3*f**2*(k1**2*(315*r + 315*s - 241) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**2*(14*C*(r + s - 1) + 31*r + 31*s + 5) + 3*k2**2*(4*C*(r + s - 1) - 3*K*(5*r + 5*s - 1) + 16*r + 16*s - 8)) + 198*g2*(k1**2 + 6*k2**2)*(r + s - 1)) + f*(f*k1**2*(289*r + 289*s - 189) + 3*f*k2**2*(C*(-334*r - 334*s + 230) + 189*r + 189*s - 126) + k2**2*(-99*b2 + 198*g2)*(5*r + 5*s - 1)))/(3465*d*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*(99*b1**3*k2**2*(r + s - 1) - 11*b1**2*(k1**2*(18*C*(r + s - 1) + f*(17*r + 17*s - 14) + 9*r + 9*s + 18) - 9*k2**2*(-4*C*(r + s - 1) + 2*K*r + 2*K*s + K + f + 3*r + 3*s - 3)) + 11*b1*(30*f**2*k1**2*(r + s - 1) + f*(k1**2*(K*(2*r + 2*s - 1) + 3*r + 3*s - 6) + k2**2*(C*(62*r + 62*s - 38) - 9*K*(3*r + 3*s - 2) - 31*r - 31*s + 28)) - 9*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + f*(11*b2*(k1**2*(2*r + 2*s - 1) - 9*k2**2*(3*r + 3*s - 2)) - 5*f*(k1**2*(C*(6*r + 6*s - 4) - 25*r - 25*s + 24) + k2**2*(44*C - 22)*(3*r + 3*s - 2)) - 22*g2*(k1**2*(2*r + 2*s - 1) - 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(429*b1**2*(f*k2**4*(r + s - 5) + 18*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) + 26*b1*(3*f**2*k2**2*(4*k1**2*(37*r + 37*s - 21) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(7*r + 7*s + 1) + 3*k1**2*k2**2*(2*C*(r + s - 2) + 3*K*(13*r + 13*s - 4) - 26*r - 26*s + 13) + 3*k2**4*(4*C*(r + s - 2) + 3*K*(17*r + 17*s - 7) - 21*r - 21*s + 15)) - 594*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(-15*f**2*(k1**4*(811*r + 811*s - 631) - 26*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f*(k1**4*(2*C - 2)*(37*r + 37*s - 21) + k1**2*k2**2*(2*C*(611*r + 611*s - 400) - 933*r - 933*s + 611) + 3*k2**4*(C*(422*r + 422*s - 274) - 233*r - 233*s + 148)) + 572*g2*(k1**4*(7*r + 7*s + 1) + 9*k1**2*k2**2*(13*r + 13*s - 4) + 9*k2**4*(17*r + 17*s - 7))))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*(33*b1**2*(f*k2**2*(k1**2*(17*r + 17*s - 7) - 3*k2**2*(3*r + 3*s - 1)) + (r + s)*(-18*K*k2**4 - 6*k1**4*(K - 1) - 6*k1**2*k2**2*(6*K - 3))) - 2*b1*(5*f**2*(k1**4*(2*r + 2*s - 5) - 22*k1**2*k2**2) + 11*f*(k1**4*(2*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(6*C*(r + s - 2) + K*(-16*r - 16*s + 17) + 9*r + 9*s) - 3*k2**4*(2*C*(r + s + 1) + K*(9*r + 9*s - 6) - 4*r - 4*s - 1)) - 198*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) + f*(315*f**2*k1**4*(r + s - 1) + 10*f*k2**2*(k1**2*(C*(94*r + 94*s - 92) - 69*r - 69*s + 68) + k2**2*(44*C - 22)*(3*r + 3*s - 2)) - 44*g2*k2**2*(k1**2*(16*r + 16*s - 17) + 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**4*k1**2*k2**3*st**6*(157*r + 157*s - 108)/(3003*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(-55*K*b1*k2**2*(2*r + 2*s - 1) + b1*k1**2*(8*f*(4*r + 4*s - 3) + 66*r + 66*s - 33) + f*k1**2*(7*r + 7*s - 1) - f*k2**2*(2*C - 1)*(19*r + 19*s - 9) + k2**2*(-55*b2 + 110*g2)*(2*r + 2*s - 1))/(1155*d*k3**3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(f**2*(84*k1**4*(4*r + 4*s - 3) + 130*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(k1**2*k2**2*(b1*(13*r + 13*s - 5) - (4*C - 3)*(7*r + 7*s - 1)) - k2**4*(2*C - 1)*(19*r + 19*s - 9)) - 143*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*st**2*(33*b1**2*(9*K*k2**4 + k1**2*k2**2*(-6*K*(r + s - 1) + f*(2*r + 2*s + 1) - 6*r - 6*s - 3)) + b1*(3*f**2*k1**2*(k1**2*(74*r + 74*s - 58) + 11*k2**2*(6*r + 6*s - 5)) + 11*f*(k1**4*(7*r + 7*s + 1) + k1**2*k2**2*(28*C*(r + s - 1) - 9*K*(5*r + 5*s - 1) + 9*r + 9*s - 3) + 3*k2**4*(2*C - 9*K*(2*r + 2*s - 1) - 1)) + 99*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + f*(f*(k1**4*(37*r + 37*s - 21) + k1**2*k2**2*(C*(-578*r - 578*s + 378) + 322*r + 322*s - 211) + k2**4*(33 - 66*C)*(2*r + 2*s - 1)) + k2**2*(-99*b2 + 198*g2)*(k1**2*(5*r + 5*s - 1) + 3*k2**2*(2*r + 2*s - 1))))/(3465*d*k2*k3**3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*(18*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(f*k1**2*(k1**2*(-4*r - 4*s + 3) + 9*k2**2*(2*r + 2*s - 1)) - 9*k1**4*(r + s) - 9*k1**2*k2**2*(4*C*(r + s - 1) - 3*K*r - 3*K*s - 3*r - 3*s + 3) - 9*k2**4*(2*C - 1)*(r + s - 1)) + b1*(f*(k1**4*(-2*r - 2*s + 1) + 3*k1**2*k2**2*(C*(4*r + 4*s - 2) - 3*K*(r + s - 1) + r + s + 1) + k2**4*(9 - 18*C)) + k1**2*k2**2*(27*b2 - 54*g2)*(r + s)) - f*k1**2*k2**2*(r + s - 1)*(20*C*f + 9*b2 - 10*f - 18*g2))/(315*d*k2*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*st**2*(-3861*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(45*r + 45*s - 37) - 13*k1**4*k2**2*(6*r + 6*s - 5)) + 13*f**2*(k1**4*k2**2*(b1*(134*r + 134*s - 115) + (4*C - 3)*(37*r + 37*s - 21)) + k1**2*k2**4*(C*(710*r + 710*s - 466) - 33*b1*(4*r + 4*s - 3) - 388*r - 388*s + 255) + k2**6*(66*C - 33)*(2*r + 2*s - 1)) - 143*f*k2**2*(6*b1**2*k1**2*k2**2*(5*r + 5*s - 4) + b1*(-k1**4*(2*K - 1)*(7*r + 7*s + 1) - 3*k1**2*k2**2*(4*C*(r + s - 2) + 3*K*(11*r + 11*s - 5) - 12*r - 12*s + 12) + 3*k2**4*(-2*C*(r + s - 2) - 9*K*(2*r + 2*s - 1) + r + s - 2)) + 2*g2*(2*k1**4*(7*r + 7*s + 1) + 9*k1**2*k2**2*(11*r + 11*s - 5) + 27*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*(11*b1**2*k1**2*k2**2*(f*(k1**2*(8*r + 8*s - 4) - 9*k2**2*(3*r + 3*s - 1)) + (r + s)*(-27*K*k2**2 - 9*k1**2*(2*K - 1))) + b1*(5*f**2*k1**4*(k1**2*(3*r + 3*s - 2) + 22*k2**2*(2*r + 2*s - 1)) + 11*f*k2**2*(-k1**4*(4*C - 3)*(2*r + 2*s - 1) + 3*k1**2*k2**2*(C*(8*r + 8*s + 2) + 3*K*(r + s - 1) - 7*r - 7*s - 1) + k2**4*(18*C - 9)*(r + s)) + 198*g2*k1**2*k2**2*(2*k1**2 + 3*k2**2)*(r + s)) + 22*f*k1**2*k2**4*(f*(10*C - 5) - 9*g2)*(r + s - 1))/(3465*d*k2*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**3*k1*k2**2*st**6*(-39*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(73*r + 73*s - 45))/(3003*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k1*st**4*(-22*b1**2*k2**2 + b1*(66*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(6*r + 6*s + 4) + 11*f*k2**2*(5*r + 5*s - 3)) + 2*k2**2*(33*b2*(2*r + 2*s - 1) + f*(2*C - 1)*(7*r + 7*s - 1) - 66*g2*(2*r + 2*s - 1)))/(1155*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k1*st**4*(2*f**2*(k1**4*(76*r + 76*s - 44) + 13*k1**2*k2**2*(15*r + 15*s - 11)) - 13*f*(b1*k1**2*k2**2*(20*r + 20*s - 6) + 11*b1*k2**4*(5*r + 5*s - 3) + k2**4*(4*C - 2)*(7*r + 7*s - 1)) + k2**4*(2*r + 2*s - 1)*(-858*K*b1 + 286*b1**2 + 1716*g2))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*k1*st**2*(99*b1**3*k2**2*(r + s - 1) + 11*b1**2*(9*K*k2**2*(2*r + 2*s + 1) + 2*f*k1**2*(5*r + 5*s - 2) + 9*f*k2**2) + 11*b1*(3*f**2*k1**2*(r + s - 1) - f*(K*k1**2*(7*r + 7*s + 1) + 9*K*k2**2*(3*r + 3*s - 2) - k2**2*(2*C - 1)*(4*r + 4*s - 1)) + 9*k2**2*(3*b2*(r + s) - 2*g2*(2*r + 2*s + 1))) + f*(-11*b2*(k1**2*(7*r + 7*s + 1) + 9*k2**2*(3*r + 3*s - 2)) - f*(2*C - 1)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + 22*g2*(k1**2*(7*r + 7*s + 1) + 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*k1*st**2*(33*b1**2*(18*K*k2**4*(r + s) + 2*f*k1**2*k2**2*(5*r + 5*s - 4) + 3*f*k2**4*(3*r + 3*s - 1)) - 2*b1*(f**2*(k1**4*(89*r + 89*s - 63) + 11*k1**2*k2**2) + 11*f*(K*k1**2*k2**2*(7*r + 7*s + 1) + 9*K*k2**4*(3*r + 3*s - 2) + k2**4*(6*C - 3)*(r + s - 2)) + 594*g2*k2**4*(r + s)) + f*(15*f**2*k1**4*(r + s - 1) - f*k2**2*(4*C - 2)*(k1**2*(37*r + 37*s - 21) + 11*k2**2*(3*r + 3*s - 2)) + 44*g2*k2**2*(k1**2*(7*r + 7*s + 1) + 9*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1**2*f**2*k1*st**4*(-4*Pk2 + Pkd2*k2)*(2*s - 1)/(105*d*k2**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**4*f*k1*(4*Pk2 - Pkd2*k2)*(b1*f*(31*s - 20) + 18*b1*(s - 1) + 2*f*(11*s - 10))/(315*d*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**3*f*(-9*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 9*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-44*C*s + 40*C + 9*b1*(r - 1) + 11*r + 22*s - 39) + Pkd2*k2*(2*C - 1)*(11*s - 10)) + 18*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(315*d*k2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**2*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(b1*f*(s + 4) - 18*b1*(s - 1) + 2*f*(s + 1))/(105*d*k2**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**2*f*(18*b1**2*k1**2*s*(2*Pk2 - Pkd2*k2) - 9*b1*k1**2*(Pk2*f*(6*s - 4) - 2*Pk2*(s + 1) + Pkd2*f*k2*(2 - 3*s) + 2*Pkd2*k2*s) + 2*f*(Pk2*k2**2*(2 - 4*C)*(11*r - 10) + k1**2*(Pk2*(19 - 20*s) + 9*Pkd2*k2*(s - 1))))/(315*d*k1*k2**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*st**2*(-27*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 27*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(12*C*(s + 1) + 27*b1*(r - 1) + 7*r - 6*s - 14) + Pkd2*k2*(3 - 6*C)*(s + 1)) + 54*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(315*d*k2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*(Pk2*b1*(r - 1) + Pk2*f*r + Pkd2*b1*k2*s*(2*C - 1) + Pkd2*f*k2*(-2*C*(s - 1) + s - 1))/(35*d*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f**3*k1*st**6*(4*Pk2 - Pkd2*k2)*(3*s - 1)/(77*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*k1*(36*Pk2*b1**2*k1**2*k2*(r + s - 1) + 36*Pk2*k1**2*k2*(b2*(r + s) - 2*g2*(r + 2*s)) - 10*Pkd2*f**2*k1**4*s + 9*b1*k2*(2*Pk2*(k1**2*(2*K*r + 4*K*s - s) + k2**2*(2 - 4*C)*(r + s - 1)) + f*k1**2*(2*Pk2*(6*r + 5*s - 4) + 3*Pkd2*k2*s)) + 2*f*k2*(2*Pk2*k1**2*(C*(4*r + 8*s - 2) - 2*r - 5*s + 1) + k2**2*(Pk2*(-4*C*(38*r + 27*s - 10) + 85*r + 54*s - 20) + Pkd2*k2*s*(9 - 18*C))))/(315*d*k2*k3**4) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st**2*(2*Pk2*f*(k1**2*(7*s + 1) + 2*k2**2*(-4*C*r + 2*C + 2*r - 1)) + 18*b1**2*k1**2*s*(2*Pk2 - Pkd2*k2) - 9*b1*k1**2*(2*Pk2*(3*f*s - 2*f + s - 1) + Pkd2*f*k2*(2 - 3*s)))/(315*d*k1*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*(-9*Pk2*b1*(k1**4*s + k1**2*k2**2*s*(4*C - 3) + k2**4*(2 - 4*C)*(r - 1)) + f*k1**2*(-2*Pk2*k1**2*s + Pk2*k2**2*(-4*C*(20*r + 9*s - 10) + 49*r + 18*s - 20) + 9*Pkd2*b1*k1**2*k2*s + Pkd2*k2**3*s*(9 - 18*C)))/(315*d*k1*k2**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**7*f**2*k1**2*k2*(4*Pk2 - Pkd2*k2)*(286*b1*(K - 1)*(2*s - 1) + 21*f**2*(35*s - 12) + f*(26*C - 26)*(41*s - 21) + 572*g2*(1 - 2*s))/(9009*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**6*f**2*k1*(4*Pk2 - Pkd2*k2)*(b1*(f*(52*s - 21) + 44*s - 22) + f*(41*s - 21))/(693*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**6*f**2*k1*(26*b1*(k1**2*(11*K - 11)*(4*Pk2 - Pkd2*k2)*(31*s - 20) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(4*Pk2*(26*r - 5) + Pkd2*k2*(52*s - 21)))) + 105*f**2*(52*Pk2*k2**2*(r - 1) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(19*s - 8)) + 130*f*(k1**2*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(10*s - 7) + k2**2*(-2*Pk2*(4*C*(11*r - 41*s + 32) - 85*r + 82*s - 87) - Pkd2*k2*(4*C - 3)*(41*s - 21))) + 572*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(31*s - 20) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1**2*k2*st**2*(-4*Pk2 + Pkd2*k2)*(-1430*b1*(K - 1)*(2*s - 1) + 15*f**2*(523*s - 147) + f*(52*C - 52)*(108*s - 25) + 2860*g2*(2*s - 1))/(45045*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(22*C*f*k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 10) + 5*f**2*(22*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(41*s - 21)) + 11*f*(10*K*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 36*Pk2*k1**2*s - 20*Pk2*k2**2*r - 9*Pkd2*k1**2*k2*s) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 5*f*(6*f*k1**2*(4*Pk2 - Pkd2*k2)*(10*s - 7) + f*k2**2*(Pk2*(C*(84 - 164*s) - 3*r + 82*s - 85) + Pkd2*k2*(2*C - 1)*(41*s - 21)) + k2**2*(-2*Pk2 + Pkd2*k2)*(22*b2 - 44*g2)*(2*s - 1)))/(3465*d*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f*(-1287*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 13*b1*(5*f**2*k2**2*(-22*Pk2*k2**2*(r - 1) + k1**2*(240*Pk2*r + 76*Pk2*(s - 1) + Pkd2*k2*(82*s - 63))) + 11*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(11*s - 10) + k1**2*k2**2*(Pk2*(44*C*(r + 2*s - 1) - 44*K*r + 84*K*s - 60*K + 66*r - 44*s + 22) + Pkd2*k2*(-22*C*s + K*(31 - 44*s) + 35*s - 11)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 198*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(-2860*Pk2*b2*k2**4*(2*r + 2*s - 1) + 105*f**2*k1**2*(6*k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 6) + 13*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 65*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(19*s - 21) - 2*k1**2*k2**2*(Pk2*(-158*C*s + 214*C - 57*r + 41*s - 134) + Pkd2*k2*(76*C*s - 62*C - 46*s + 41)) + k2**4*(Pk2*(-4*C*(44*r + 41*s + 23) + 91*r + 82*s + 89) - Pkd2*k2*(2*C - 1)*(41*s - 21))) - 286*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 10) + k1**2*k2**2*(Pk2*(-44*r + 84*s - 60) + Pkd2*k2*(31 - 44*s)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(45045*d*k2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1*st**2*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(56*s - 15) - 44*s + 22) + 2*f*(108*s - 25))/(3465*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1*st**2*(13*b1*(k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(s + 4) + 5*k2**2*(88*K*Pk2*(r - 2*s + 1) + 44*K*Pkd2*k2*(2*s - 1) - 176*Pk2*r - 44*Pkd2*k2*s + 22*Pkd2*k2 + f*(4*Pk2*(28*r - 13) + Pkd2*k2*(56*s - 15)))) + 75*f**2*(26*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(71*s - 21)) + 26*f*(k1**2*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(93*s - 20) - k2**2*(4*Pk2*(C*(30*r - 216*s + 7) - 84*r + 108*s + 47) + Pkd2*k2*(4*C - 3)*(108*s - 25))) - 286*g2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s + 4) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*(-11*b1**2*k1**2*k2**2*(-2*Pk2*(-9*K*(r - 2*s + 2) + 10*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 10*f + 9)) + b1*k1**2*(5*f**2*(6*k1**2*(4*Pk2 - Pkd2*k2)*(10*s - 7) + 11*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(11*s - 10) + k2**2*(Pk2*(88*C*s - 116*C - 62*K*s + 40*K - 13*r - 82*s + 115) + Pkd2*k2*(-44*C*s + 40*C + 31*K*s - 20*K + 40*s - 39))) + 396*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(5*f*(Pk2*k2**4*(2 - 4*C)*(19*r - 21) + k1**4*(4*Pk2 - Pkd2*k2)*(19*s - 21) + k1**2*k2**2*(Pk2*(-240*C*s + 168*C + 60*r + 35*s - 127) + 4*Pkd2*k2*(30*C*s - 21*C - 4*s + 5))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(11*b2 - 22*g2)*(31*s - 20)))/(3465*d*k1*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*(-2574*b1*k1**2*k2**2*(-b1*(k1**2*(2*K - 2)*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K))) + 4*g2*(k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s))) + 105*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(31*s - 24) + 13*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 130*f**2*(Pk2*k2**6*(2 - 4*C)*(19*r - 21) - k1**4*k2**2*(2*Pk2*(44*C*(r - s - 1) + b1*(51*r + 51*s + 9) - 31*r + 76*s + 7) + Pkd2*k2*(C*(56*s - 4) - 63*b1 - 75*s + 25)) + k1**2*k2**4*(Pk2*(-4*C*(47*r - 54*s - 49) + 22*b1*(9*r + 5*s - 5) + 330*r - 17*s - 229) + Pkd2*k2*(-56*C*s + 4*C + 11*b1*(5*s - 2) + 72*s - 24))) + 143*f*k1**2*k2**2*(-12*Pk2*b2*k2**2*(11*r + 11*s - 7) + b1**2*k2**2*(40*Pk2 + 31*Pkd2*k2*s) + 2*b1*(k1**2*(2*Pk2*(C*(4*r + 30*s - 4) - 2*K*r - 9*K*s + 13*r + 5*s - 18) + Pkd2*k2*(-26*C*s + K*(5*s + 2) + 10*s + 8)) + k2**2*(Pk2*(4*C*(22*r + 22*s - 31) + K*(-56*r - 70*s + 44) - 103*r - 78*s + 117) + Pkd2*k2*(K*(5*s + 2) + s*(15 - 44*C) + 9))) - 4*g2*(-2*Pk2*k1**2*(2*r + 9*s) - 2*Pk2*k2**2*(28*r + 35*s - 22) + Pkd2*k1**2*k2*(5*s + 2) + Pkd2*k2**3*(5*s + 2))))/(45045*d*k1*k2**2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1**2*k2*st**4*(-4*Pk2 + Pkd2*k2)*(715*b1*(K - 1)*(2*s - 1) + 5*f**2*(62*s - 35) + f*(26*C - 26)*(19*s - 10) + 1430*g2*(1 - 2*s))/(15015*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st**2*(-297*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(2*f**2*(-55*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(108*s - 25)) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(s + 1) - s + 2) + 10*k2**2*(K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*Pk2*r)) + 594*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(3*f*k1**2*(4*Pk2 - Pkd2*k2)*(93*s - 20) + 2*f*k2**2*(2*Pk2*(C*(50 - 216*s) + 24*r + 108*s - 11) + Pkd2*k2*(2*C - 1)*(108*s - 25)) + k2**2*(-2*Pk2 + Pkd2*k2)*(-110*b2 + 220*g2)*(2*s - 1)))/(3465*d*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*(11*b1**2*(9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + 2*k1**2*(Pk2*(18*C*s - 9*K*s + 9*K + 2*f*(11*s + 5) + 9*s - 9) - Pkd2*k2*(9*C*s + f*(11*s + 5)))) + 11*b1*(36*Pk2*g2*k1**2*(s - 1) + 9*Pkd2*b2*k2**3*s + 10*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(C*(40 - 44*s) - 22*K*s + 20*K + 7*r + 12*s - 2) + Pkd2*k2*(18*C*(s - 1) + 11*K*s - 10*K - 4*s)) + k2**2*(2*Pk2*(22*C*r - 38*C - 9*K*r - 2*r + 19) + Pkd2*k2*(20*C - 18*K*s + 9*K - 10))) - 18*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-11*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(11*s - 10) + 9*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) - 5*f*(k1**2*(Pk2*(76*C*s - 84*C - 63*r + 88*s - 1) + Pkd2*k2*(-38*C*s + 42*C - 47*s + 23)) + 2*k2**2*(2*Pk2*(60*C*r - 42*C - 41*r + 21) + Pkd2*k2*(22*C - 11)*(2*s - 1))) + 22*g2*(k1**2*(2*Pk2 - Pkd2*k2)*(11*s - 10) + 9*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st**2*(-3861*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 13*b1*(2*f**2*k2**2*(55*Pk2*k2**2*(r - 1) + k1**2*(1018*Pk2*r + 586*Pk2*(s - 1) + 3*Pkd2*k2*(72*s - 25))) + 11*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(s + 1) - 3*k1**2*k2**2*(-2*Pk2*(2*C*(r + 2*s - 1) + K*(-10*r + 6*s + 6) + 23*r + 6*s - 3) + Pkd2*k2*(K*(20*s - 1) + s*(2*C - 21) + 5)) + 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 594*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(-2860*Pk2*b2*k2**4*(2*r + 2*s - 1) - 10*f**2*k1**2*(9*k1**2*(4*Pk2 - Pkd2*k2)*(114*s - 35) + 65*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 13*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(67*s - 15) - 3*k1**2*k2**2*(2*Pk2*(4*C*(26*r - 67*s - 1) - 271*r + 8*s + 139) + Pkd2*k2*(2*C*(208*s - 51) - 323*s + 82)) + 2*k2**4*(Pk2*(-12*C*(20*r + 36*s - 37) + 72*r + 216*s - 250) - Pkd2*k2*(2*C - 1)*(108*s - 25))) + 286*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s + 1) + 3*k1**2*k2**2*(-20*Pk2*r + 12*Pk2*(s + 1) + Pkd2*k2*(1 - 20*s)) + 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(45045*d*k2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*(-11*b1**2*(k1**4*s*(9 - 9*K)*(2*Pk2 - Pkd2*k2) - k1**2*k2**2*(2*Pk2*(18*C*(r + s - 1) + 9*K*(s - 2) + 2*f*(11*r + 11*s - 5) + 18*r + 9*s + 27) + Pkd2*k2*s*(-36*K + 33*f + 18)) + 9*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + b1*(-198*Pk2*b2*k2**4*(r + s) - 5*f**2*k1**2*(k1**2*(4*Pk2*(3*r - 16*s - 13) + Pkd2*k2*(38*s + 21)) + 22*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) - 11*f*(k1**4*(-2*Pk2*(4*C*s + K*(10 - 11*s) + 2*r + 9*s - 11) + Pkd2*k2*(4*C*s - 9*K*(s - 1) + 5*s - 9)) + k1**2*k2**2*(Pk2*(C*(-52*r + 28*s + 52) + K*(-38*r + 38*s - 28) + 133*r - 12*s - 76) + Pkd2*k2*(K*(26 - 43*s) + s*(34*C + 6) - 18)) + k2**4*(Pk2*(C*(-44*r + 44*s + 116) - 18*K*(5*r + 4*s - 2) + 51*r - 22*s - 77) + Pkd2*k2*(K*(9 - 18*s) + s*(22*C - 11)))) + 198*g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(-Pk2*(s - 2) + 2*Pkd2*k2*s) + k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(-66*Pk2*b2*k2**2*(k1**2*(5*r + 5*s - 4) - 3*k2**2*(2*r + 2*s - 1)) + 105*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) - 5*f*(k1**4*(Pk2*(76*C*s - 84*C + 6*r - 70*s + 80) + Pkd2*k2*(44 - 44*C)*(s - 1)) + k1**2*k2**2*(Pk2*(C*(-464*r + 28*s + 116) + 559*r + 124*s - 191) + Pkd2*k2*(C*(134 - 226*s) + 179*s - 111)) + 2*k2**4*(-2*Pk2*(2*C*(74*r + 44*s - 43) - 85*r - 44*s + 43) + Pkd2*k2*(11 - 22*C)*(2*s - 1))) - 22*g2*(k1**4*(Pk2*(20 - 22*s) + 9*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(38*r - 38*s + 28) + Pkd2*k2*(43*s - 26)) + 9*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1*st**4*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(25*s - 12) + 44*s - 22) + 2*f*(19*s - 10))/(1155*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1*st**4*(13*b1*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(Pk2*(50*r - 2) + Pkd2*k2*(25*s - 12)))) + 30*f**2*(52*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(7*s - 5)) + 26*f*(k1**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-4*C*(13*r - 38*s + 23) + 90*r - 76*s + 54) - Pkd2*k2*(4*C - 3)*(19*s - 10))) - 1144*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(15015*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*k1*(99*Pkd2*b1**3*k2**3*s + 11*b1**2*(Pk2*k1**2*s*(26*f + 18) - 9*Pk2*k2**2*(2*K*(s - 1) + f*(2 - 4*r) + 2*r + 1) - Pkd2*k1**2*k2*s*(13*f + 9) + 9*Pkd2*k2**3*(f + s*(-4*C + 2*K + 3))) - 11*b1*(-18*Pkd2*b2*k2**3*s + 10*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) + f*k1**2*(Pk2*(16*s - 19) + Pkd2*k2*(9 - 7*s)) + f*k2**2*(Pk2*(-4*C*(9*r - 2*s + 1) + r*(18*K - 40) - 4*s + 41) + Pkd2*k2*(C*(36 - 62*s) + 9*K*(3*s - 2) + 31*s - 27)) + 36*g2*k2**2*(-Pk2*s + Pk2 + Pkd2*k2*s)) + f*(-5*f*(k1**2*(Pk2*(41*s - 43) - 22*Pkd2*k2*(s - 1)) + 2*k2**2*(Pk2*(82*C*r - 42*C - 74*r + 21) + Pkd2*k2*(22*C - 11)*(3*s - 2))) + k2**2*(-99*b2 + 198*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(3465*d*k2**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**2*(-33*b1**2*k1**2*k2**2*(-2*Pk2*(-9*K*(r - 2*s + 2) + 2*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 2*f + 9)) + b1*k1**2*(-3*f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(93*s - 20) + 11*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) + 11*f*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(s + 1) + k2**2*(Pk2*(4*C*(5*r - 6*s - 13) + 6*K*(s + 4) + 37*r - 54*s + 79) + 3*Pkd2*k2*(4*C*(s + 1) - K*(s + 4) + 16*s - 12))) + 1188*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(24*C - 12)*(26*r - 5) - k1**4*(4*Pk2 - Pkd2*k2)*(67*s - 15) - 3*k1**2*k2**2*(Pk2*(-372*C*s + 80*C - 11*r + 156*s - 19) + Pkd2*k2*(186*C*s - 40*C - 115*s + 31))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-33*b2 + 66*g2)*(s + 4)))/(3465*d*k1*k2**2*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**2*(2574*b1*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 15*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(271*s - 84) + 26*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 26*f**2*(Pk2*k2**6*(12 - 24*C)*(26*r - 5) + k1**4*k2**2*(-2*Pk2*(-2*C*(52*r + 55*s - 21) + b1*(945*r + 945*s - 633) + 393*r + 466*s - 246) + Pkd2*k2*(2*C*(167*s - 52) + 90*b1 - 267*s + 89)) - 3*k1**2*k2**4*(Pk2*(C*(-800*r - 964*s + 632) + 22*b1*(9*r + 5*s - 5) + 499*r + 600*s - 381) + Pkd2*k2*(-274*C*s + 84*C + 11*b1*(5*s - 2) + 159*s - 53))) + 143*f*k1**2*k2**2*(-36*Pk2*b2*k2**2*(5*r + 5*s - 1) + 3*b1**2*k2**2*(-8*Pk2 + Pkd2*k2*s) + 2*b1*(k1**2*(2*Pk2*(2*C*(7*r + 3*s - 7) - 12*K*r - 9*K*s + 43*r + 51*s + 8) + Pkd2*k2*(8*C*s + K*(12 - 33*s) + 22*s - 15)) + k2**2*(Pk2*(4*C*(r + 6*s + 1) - 6*K*(52*r + 29*s - 10) + 281*r + 138*s - 97) - 3*Pkd2*k2*(K*(37*s - 14) + s*(4*C - 21) + 9))) + 12*g2*(2*Pk2*k1**2*(4*r + 3*s) + 2*Pk2*k2**2*(52*r + 29*s - 10) + Pkd2*k1**2*k2*(11*s - 4) + Pkd2*k2**3*(37*s - 14))))/(45045*d*k1*k2**2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*(-198*b1*k1**2*k2**2*(2*Pk2*b1**2*k2**2*(r + s - 1) + 6*Pk2*b2*k2**2*(r + s) + b1*(-k1**2*(Pk2*(4*C*(r + s - 1) - 2*K*r - 4*K*s + 4*r + 6*s + 4) + Pkd2*k2*s*(1 - 2*K)) + k2**2*(2*K*Pkd2*k2*s + Pk2*(-8*C*(r + s - 1) + 2*K*(4*r + 5*s + 1) + 4*r + 5*s - 6))) - 4*g2*(Pk2*k1**2*(r + 2*s) + Pk2*k2**2*(4*r + 5*s + 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s)) - 105*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) - 10*f**2*(8*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) + k1**4*k2**2*(Pk2*(-4*C*(25*r + 6*s - 3) - 44*b1*r + 132*b1*s + 138*r + 59*s - 51) - 22*Pkd2*k2*(3*b1 + (4*C - 3)*(s - 1))) + 2*k1**2*k2**4*(Pk2*(C*(-346*r - 264*s + 218) + 206*r + 132*s - 109) + 11*Pkd2*k2*(C*(4 - 6*s) + 3*s - 2))) + 11*f*k2**2*(b1**2*k1**2*(k1**2*(Pk2*(68*r + 68*s - 56) + 39*Pkd2*k2*s) - 9*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) + 2*b1*(Pk2*k2**4*(4*C - 2)*(11*r - 10) + k1**4*(Pk2*(4*C*(18*r - 4*s - 9) + 2*K*(7*r - 4*s + 2) - 96*r + 12*s + 47) + Pkd2*k2*(18*K*(s - 1) + s*(10*C - 21) + 9)) + k1**2*k2**2*(2*Pk2*(C*(54*r - 56*s - 38) + 9*K*(7*r + 6*s - 4) - 74*r + 20*s + 29) + Pkd2*k2*(9*K*(3*s - 2) + s*(10*C - 14)))) - 4*k1**2*(Pk2*b2*k1**2*(2*r + 2*s - 1) - 9*Pk2*b2*k2**2*(3*r + 3*s - 2) + 2*g2*k1**2*(Pk2*(7*r - 4*s + 2) + 9*Pkd2*k2*(s - 1)) + 9*g2*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2)))))/(3465*d*k1*k2**2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**4*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(157*s - 49)/(3003*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*st**4*(b1*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(57*s - 30) + 44*s - 22) + 55*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Pk2*f*(r - 1) - 2*Pk2*r)) + 4*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + f*k2**2*(Pk2*(C*(40 - 76*s) - 7*r + 38*s - 25) + Pkd2*k2*(2*C - 1)*(19*s - 10)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(2*s - 1))/(1155*d*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*st**4*(f**2*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(48*s - 25) - 130*k1**2*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 13*f*(2*k1**2*k2**2*(Pk2*(C*(-24*r + 58*s - 4) + b1*(32*r - 6*s + 6) + 31*r - 39*s - 1) + Pkd2*k2*(b1*(19*s - 15) + (6 - 8*C)*(3*s - 1))) + k2**4*(Pk2*(-4*C*(26*r + 19*s - 4) - 55*b1*(r - 1) + 59*r + 38*s - 3) - Pkd2*k2*(2*C - 1)*(19*s - 10))) + 143*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(15015*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**2*(-33*b1**2*(-9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(3*K*(s - 1) + f*(2*s - 1) - 9*s + 3) + Pkd2*k2*(-2*f*s + f + 6*s))) + 11*b1*(36*Pk2*g2*k1**2*(s - 1) + 27*Pkd2*b2*k2**3*s + 3*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(4*C*(7*s + 1) + 6*K*(s + 1) + 21*r - 32*s + 20) - Pkd2*k2*(3*K*(s + 1) - 23*s + 18)) + k2**2*(2*Pk2*(2*C*(7*r - 8) - 27*K*r + 20*r + 8) + 3*Pkd2*k2*(2*C - 18*K*s + 9*K - 1))) - 54*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(33*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(s + 1) + 9*k2**2*(-2*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + f*k1**2*(Pk2*(268*C*s - 60*C + 37*r + 22*s + 6) + Pkd2*k2*(-134*C*s + 30*C + 100*s - 37)) + 3*f*k2**2*(4*Pk2*(41*C*r - 10*C - 15*r + 5) - Pkd2*k2*(22*C - 11)*(2*s - 1)) - 66*g2*k1**2*(2*Pk2 - Pkd2*k2)*(s + 1) + 594*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))))/(3465*d*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*(9*Pkd2*b1**3*k1**2*k2*s + 9*b1**2*(K*Pkd2*k1**2*k2*s - Pk2*k1**2*(4*C*s + r - 2*s) + Pk2*k2**2*(4*C*(r - s - 1) - 3*r + 2*s + 3) + Pkd2*k2**3*s*(1 - 2*C) + f*k1**2*(Pk2*(6*r - 4) + Pkd2*k2*(2*s + 1))) + b1*(Pkd2*k1**2*k2*s*(9*b2 - 18*g2) + f*k1**2*(Pk2*(47*r - 4*s - 19) + Pkd2*k2*(-9*K*(s - 1) + s*(4*C + 7))) - f*k2**2*(2*C - 1)*(22*Pk2*(2*r - 1) + 9*Pkd2*k2)) + f*k1**2*(10*Pk2*f*r - 9*Pkd2*b2*k2*(s - 1) - 2*Pkd2*f*k2*(10*C - 5)*(s - 1) + 18*Pkd2*g2*k2*(s - 1)))/(315*d*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**2*(33*b1**2*(k1**2*k2**2*(2*Pk2*f*(2*r + 2*s + 1) - 6*Pk2*(K*(s - 2) + 4*r + 3*s + 1) + Pkd2*k2*s*(12*K + 3*f - 6)) + 9*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + b1*(f**2*k1**2*(k1**2*(Pk2*(444*r + 712*s - 318) - Pkd2*k2*(134*s + 15)) + 33*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) - 11*f*(2*Pk2*k1**4*(7*K*s + K - 7*r - 14*s - 2) - k1**2*k2**2*(Pk2*(4*C*(18*r + 7*s - 16) - 6*K*(31*r + 29*s - 7) + 77*r + 88*s - 10) + Pkd2*k2*(K*(33 - 57*s) + s*(16*C + 15) - 18)) + k2**4*(Pk2*(4*C*(7*r + 3*s - 11) + 54*K*(5*r + 4*s - 2) - 75*r - 6*s + 30) + 3*Pkd2*k2*(9*K*(2*s - 1) + s*(2*C - 1)))) - 198*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(-198*Pk2*b2*k2**2*(k1**2*(5*r + 5*s - 1) + 3*k2**2*(2*r + 2*s - 1)) + 15*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*(2*Pk2*k1**4*(C*(10 - 74*s) + 37*r + 111*s - 31) + k1**2*k2**2*(Pk2*(-4*C*(359*r + 511*s - 257) + 887*r + 1310*s - 626) + Pkd2*k2*(C*(118 - 266*s) + 166*s - 81)) + 3*k2**4*(-4*Pk2*(C*(3*r + 44*s - 12) - 7*r - 22*s + 6) + Pkd2*k2*(11 - 22*C)*(2*s - 1))) + 22*g2*(2*k1**4*(7*Pk2*s + Pk2) + 3*k1**2*k2**2*(2*Pk2*(31*r + 29*s - 7) + Pkd2*k2*(19*s - 11)) + 27*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*(-36*Pk2*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(18*Pk2*k1**4*(r - s*(K - 2)) + Pk2*k2**4*(36*C - 18)*(r + s - 1) + 2*f*k1**4*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s) - 9*f*k1**2*k2**2*(Pk2*(13*r + 10*s - 7) + 3*Pkd2*k2*s) - 9*k1**2*k2**2*(K*Pkd2*k2*s + Pk2*(-8*C*(r + s - 1) + 8*K*r + 12*K*s + 5*r + 4*s - 6))) + b1*(10*f**2*k1**4*(Pk2*(5*r - 3) + Pkd2*k2*(2*s + 1)) + f*(2*Pk2*k1**4*(2*r + s*(6 - 4*C) - 1) + k1**2*k2**2*(Pk2*(4*C*(41*r + 6*s - 16) + 36*K*(r + s - 1) - 165*r - 44*s + 51) + Pkd2*k2*(9*K*(s - 1) + s*(32*C - 25))) + k2**4*(Pk2*(4*C*(40*r + 18*s - 11) - 89*r - 36*s + 22) + Pkd2*k2*s*(18*C - 9))) + 18*k1**2*(-3*Pk2*b2*k2**2*(r + s) + g2*(2*Pk2*k1**2*s + 4*Pk2*k2**2*(2*r + 3*s) + Pkd2*k2**3*s))) + 2*f*k1**2*k2**2*(9*Pk2*b2*(r + s - 1) + 5*f*(Pk2*(8*C*(r + s - 1) - 5*r - 4*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1)) - 9*g2*(4*Pk2*(r + s - 1) + Pkd2*k2*(s - 1))))/(315*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**3*k1*st**6*(13*b1*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(26*Pk2*k2**2*(r - 1) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(1001*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**4*(22*b1**2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + b1*k1**2*(f*(-8*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 11*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) - 22*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) - 2*k2**2*(4*Pk2*f*k2**2*(C*(2 - 6*r) + 3*r - 1) - 22*b2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + f*k1**2*(Pk2*(-48*C*s + 16*C - 12*r + 29*s - 2) + Pkd2*k2*(8*C - 4)*(3*s - 1)) + 44*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(1155*d*k1*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**4*(-2*f**2*(5*k1**6*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 13*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) + 13*f*(8*Pk2*k2**6*(C*(2 - 6*r) + 3*r - 1) + b1*k1**2*k2**2*(4*k1**2*(Pk2*(3*r + 3*s - 4) + 3*Pkd2*k2) + 11*k2**2*(2*Pk2*(9*r + 5*s - 5) + Pkd2*k2*(5*s - 2))) + 2*k1**2*k2**4*(Pk2*(4*C*(19*r + 2*s - 7) - 50*r + s + 20) + Pkd2*k2*(8*C - 4)*(3*s - 1))) - 286*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1))))/(15015*d*k1*k2**2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*k1*st**2*(99*Pkd2*b1**3*k2**3*s + 11*b1**2*(8*Pk2*f*k1**2*s - 9*Pk2*k2**2*(2*K*(s - 1) + f*(2 - 4*r) + 2*r + 1) - 4*Pkd2*f*k1**2*k2*s + 9*Pkd2*k2**3*(2*K*s + f)) - 11*b1*(f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) - f*(k1**2*(7*Pk2*s + Pk2) + k2**2*(Pk2*(28*C*s + 4*C - 18*K*r + 23*r - 14*s - 1) + Pkd2*k2*(8*C*s - 27*K*s + 18*K - 4*s))) + 18*k2**2*(-Pkd2*b2*k2*s + 2*g2*(-Pk2*s + Pk2 + Pkd2*k2*s))) + f*(f*(Pk2*k1**2*(37*s - 5) + k2**2*(Pk2*(60*C*r - 20*C + 3*r + 10) + 11*Pkd2*k2*(-6*C*s + 4*C + 3*s - 2))) + k2**2*(-99*b2 + 198*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(3465*d*k2**2*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**2*(198*b1*k1**2*k2**4*(2*K*b1*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) + 2*Pk2*b1**2*(r + s - 1) - Pk2*b1*(2*r + s) + 6*Pk2*b2*(r + s) - 4*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s)) - 5*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) - 2*f**2*(15*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) + k1**4*k2**2*(Pk2*(4*C*(37*r + 74*s - 26) + 22*b1*r - 66*b1*s - 74*r - 185*s + 57) + 33*Pkd2*b1*k2) + k1**2*k2**4*(3*Pk2*(C*(68*r + 88*s - 52) - 45*r - 44*s + 26) + Pkd2*k2*(22*C - 11)*(3*s - 2))) - 11*f*k2**2*(-b1**2*k1**2*(4*k1**2*(2*Pk2*(5*r + 5*s - 2) - 3*Pkd2*k2*s) + 9*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) + 2*b1*(Pk2*k1**4*(2*K*(7*r + 14*s + 2) - 7*s - 1) + Pk2*k2**4*(4*C - 2)*(2*r - 1) - k1**2*k2**2*(Pk2*(4*C*(8*r + s - 3) - 18*K*(7*r + 6*s - 4) + 7*r + 5*s + 8) + Pkd2*k2*(8*C*s - 27*K*s + 18*K - 4*s))) + 4*k1**2*(Pk2*b2*k1**2*(7*r + 7*s + 1) + 9*Pk2*b2*k2**2*(3*r + 3*s - 2) - 2*Pk2*g2*k1**2*(7*r + 14*s + 2) - 9*g2*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2)))))/(3465*d*k1*k2**2*k3**4)

        return (perm12+perm13+perm23)
    
    def l3m1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 16*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f**2*k2**3*st**5*(-11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k2*st**3*(33*b1**2*k2**2*(r + s) - 11*b1*f*(k1**2*(9*r + 9*s - 3) + 4*k2**2*(2*r + 2*s - 1)) + f**2*(-10*k1**2*(3*r + 3*s - 2) + 11*k2**2*(2*r + 2*s - 1)))/(1155*d*k3**4) + 32*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k2*st*(9*b1**2*k1**2*(r + s) + 3*b1*f*(k1**2 - k2**2*(r + s)) - 2*f**2*k1**2*(r + s - 1))/(315*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*b1*f*k1*k2*st*(6*b1*r - f*(r - 2))/(315*d*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f**2*k1*k2*st**3*(77*b1*r + f*(9*r + 8))/(1155*d*k3**2) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**6*f**2*k2**3*st*(C - 1)*(110*b1*(2*r + 2*s - 1) + f*(137*r + 137*s - 62))/(3465*d*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**5*f**2*k2**2*st*(-22*b1*k1**2*(3*C*(7*r + 7*s - 5) - 31*r - 31*s + 20) + 110*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(-4*C*(61*r + 61*s - 37) + 381*r + 381*s - 210) + f*k2**2*(137*r + 137*s - 62))/(3465*d*k1*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f**2*k2**3*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(83*r + 83*s - 48))/(1155*d*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f*k2*st*(-198*b1**2*k2**2*(C - 1)*(r + s) - 11*b1*f*(3*k1**2*(2*C*(r + s - 2) - 9*r - 9*s + 9) + k2**2*(C*(-64*r - 64*s + 38) + 3*r + 3*s - 3)) + 2*f**2*(k1**2*(C*(13*r + 13*s + 6) + 48*r + 48*s - 43) + k2**2*(C*(269*r + 269*s - 128) - 71*r - 71*s + 29)))/(3465*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f**2*k2**2*st**3*(-11*b1*k1**2*(3*C*(11*r + 11*s - 5) - 43*r - 43*s + 20) + 55*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(C*(-153*r - 153*s + 91) + 236*r + 236*s - 139) + f*k2**2*(83*r + 83*s - 48))/(1155*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f*st*(99*b1**2*k2**2*(r + s)*(k1**2*(5 - 4*C) + k2**2) + 11*b1*f*(k1**4*(2*C*(r + s + 1) + r + s - 8) + k1**2*k2**2*(6*C - 3)*(11*r + 11*s - 9) - 3*k2**4*(4*r + 4*s - 3)) + f**2*(k1**4*(4*C*(10*r + 10*s - 3) - 53*r - 53*s + 6) + k1**2*k2**2*(4*C*(127*r + 127*s - 81) - 409*r - 409*s + 236) - 66*k2**4*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f**2*k2**3*st**5*(C - 1)*(11*b1*(2*r + 2*s - 1) + f*(-3*r - 3*s + 2))/(693*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*k2*st**3*(66*b1**2*k2**2*(C - 1)*(r + s) - 11*b1*f*(3*k1**2*(C*(6*r + 6*s - 2) - 17*r - 17*s + 7) - k2**2*(12*C*(2*r + 2*s - 1) + 49*r + 49*s - 23)) + f**2*(k1**2*(-20*C*(3*r + 3*s - 2) + 213*r + 213*s - 131) + k2**2*(C*(376*r + 376*s - 214) + 109*r + 109*s - 69)))/(1155*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*st*(198*b1**2*k2**2*(r + s)*(k1**2*(C - 2) - k2**2*(C + 1)) + 11*b1*f*(k1**4*(r + s + 1) + k1**2*k2**2*(-6*C*(r + s - 3) + 13*r + 13*s - 17) + 6*k2**4*(3*C*(r + s - 1) + 3*r + 3*s - 2)) + 2*f**2*(k1**4*(10*r + 10*s - 3) + k1**2*k2**2*(C*(-9*r - 9*s + 28) + 98*r + 98*s - 69) + 22*k2**4*(C*(6*r + 6*s - 3) + 3*r + 3*s - 2)))/(3465*d*k2*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f**2*k2**2*st**5*(k1**2 + k2**2)*(-11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k1*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st**3*(-33*b1**2*k2**2*(k1**2 + k2**2)*(r + s) + 11*b1*f*(k1**4*(9*r + 9*s - 3) + k1**2*k2**2*(6*C*(11*r + 11*s - 5) + 17*r + 17*s - 7) + 4*k2**4*(2*r + 2*s - 1)) + f**2*(10*k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(2*C*(153*r + 153*s - 91) + 8*r + 8*s - 9) - 11*k2**4*(2*r + 2*s - 1)))/(1155*d*k1*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st*(-99*b1**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(r + s) + 11*b1*f*(k1**4*(2*C*(r + s + 1) - 3) + k1**2*k2**2*(24*C + 3)*(r + s - 1) + 3*k2**4*(r + s)) + 2*f**2*k1**2*(k1**2*(C*(20*r + 20*s - 6) + 11*r + 11*s - 11) + 11*k2**2*(4*C*(3*r + 3*s - 2) + r + s - 1)))/(3465*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**6*f**2*k2*st*(C - 1)*(-4*Pk2 + Pkd2*k2)*(110*b1*(2*s - 1) + f*(137*s - 75))/(3465*d*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**3*st*(4*Pk2 - Pkd2*k2)*(26*b1*(43*s - 18) + 3*f*(253*s - 112))/(9009*d*k1) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**2*st*(22*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(23*s - 16) - 33*s + 21) + k2**2*(Pk2*(-r*(44*C - 44) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(12*C*(27*s - 20) - 461*s + 315) + k2**2*(-2*Pk2*(258*C*r + 90*C - 258*r + 137*s - 165) + Pkd2*k2*(137*s - 75))))/(3465*d*k1*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**2*k2*st**3*(C - 1)*(-4*Pk2 + Pkd2*k2)*(55*b1*(2*s - 1) + f*(83*s - 35))/(1155*d*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*st*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + 13*b1*(f**2*(10*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(137*s - 75)) - 66*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 5*f**3*(5*Pk2*k2**2*(19*r - 34) + 8*k1**2*(4*Pk2 - Pkd2*k2)*(62*s - 35)) + 1716*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1))/(45045*d*k1**2*k2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f*st*(-198*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) + 11*b1*f*(24*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(12*C*(s - 1) - 35*s + 28) + k1**2*k2**2*(-2*C*(Pk2*(34*r + 60*s - 36) + Pkd2*k2*(19 - 32*s)) + 88*Pk2*r - 6*Pk2*s - Pkd2*k2*(s - 2))) + f**2*(11*Pk2*k2**4*(11*r + 7) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(C*(47*s - 45) - 128*s + 105) + k1**2*k2**2*(Pk2*(-4*C*(84*r + 229*s - 75) + 377*r + 44*s + 373) + 2*Pkd2*k2*(C*(269*s - 141) - 51*s + 6))))/(3465*d*k1**2*k2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**3*st**3*(4*Pk2 - Pkd2*k2)*(13*b1*(73*s - 28) + f*(607*s - 220))/(3003*d*k1) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**2*st**3*(11*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(19*s - 8) - 29*s + 13) + k2**2*(-2*Pk2*(r*(6*C - 6) + 10*s - 5) + 5*Pkd2*k2*(2*s - 1))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(135*s - 56) - 218*s + 91) + k2**2*(-2*Pk2*(86*C*r - 14*C - 86*r + 83*s - 21) + Pkd2*k2*(83*s - 35))))/(1155*d*k1*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st*(2288*Pk2*f*g2*k2**2*(r + 1) - 143*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(23*s - 16) + 18*s - 18) - 2*k2**2*(-2*Pk2*(3*K*r + 23*f*s - 8*f - 3*r + 9*s - 9) + Pkd2*k2*(23*f*s - 8*f + 9*s - 9))) - 52*b1*(-66*Pk2*g2*k2**2*r + f**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + k2**2*(2*Pk2*(72*r - 29*s - 16) + Pkd2*k2*(29*s - 14))) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + k2**2*(2*Pk2*(K*r + K - r + 3*s - 4) - 3*Pkd2*k2*(s - 1)))) - 5*f**3*(k1**2*(4*Pk2 - Pkd2*k2)*(311*s - 224) + 4*k2**2*(Pk2*(232*r - 390*s + 20) + 39*Pkd2*k2*(5*s - 2))))/(45045*d*k1*k2**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st*(-33*b1**2*k2**2*(Pk2*k1**2*s*(16*C - 22) + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s*(11 - 8*C) + 3*Pkd2*k2**3*s) + 11*b1*f*(6*k1**4*(4*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(Pk2*(4*C*(r + 31*s - 28) - 9*r - 42*s + 53) + Pkd2*k2*(C*(56 - 68*s) + 28*s - 27)) + k2**4*(Pk2*(-64*C*r + 8*C + 53*r + 2*s - 9) + 3*Pkd2*k2*(4*s - 3))) + f**2*(k1**4*(4*Pk2 - Pkd2*k2)*(47*s - 45) + k1**2*k2**2*(-2*Pk2*(2*C*(r - 234*s + 195) - 59*r + 209*s - 72) + Pkd2*k2*(C*(416 - 588*s) + 349*s - 197)) + 2*k2**4*(Pk2*(-24*C*(7*r + 5) + 261*r + 20*s - 57) + 33*Pkd2*k2*(2*s - 1))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**2*k2*st**5*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(2*s - 1) - 3*f*s + f)/(693*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(10*f*(2*s - 1) + (3*K - 3)*(s - 1)) + 13*b1*(2*f**2*(100*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(83*s - 35)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 2*f**3*(5*Pk2*k2**2*(243*r - 38) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(736*s - 275)) + 286*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1))/(15015*d*k1**2*k2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st*(1287*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 429*b1**2*(Pk2*k2**2*r*(4*f + 1) + k1**2*(Pk2*(8*K*s - 10*K + f*(3*r + 4*s + 2) - 3*r + 4*s - 2) - Pkd2*k2*(2*K*s - 3*K + 2*f*s + f + 4*s - 3))) + 13*b1*(99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*f**2*(4*Pk2*k2**2*(13*r - 8) + k1**2*(2*Pk2*(46*r - 85*s + 36) + 17*Pkd2*k2*(5*s - 3))) + 11*f*(2*Pk2*k2**2*(r - 2) + k1**2*(4*Pk2*(4*K*s - 5*K + r + 2*s - 3) + Pkd2*k2*(-9*K - 3)*(s - 1))) + 66*g2*k1**2*(Pk2*(10 - 8*s) + Pkd2*k2*(2*s - 3))) + f*k1**2*(858*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + 15*f**2*(Pk2*(97*r - 312*s + 122) + 78*Pkd2*k2*(2*s - 1)) + 286*g2*(-4*Pk2*(4*s - 5) + 9*Pkd2*k2*(s - 1))))/(45045*d*k1**2*k2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(-66*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) - 11*b1*f*(-8*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(C*(4*s - 2) - 23*s + 10) + k1**2*k2**2*(-2*C*(Pk2*(30*r + 52*s - 28) + Pkd2*k2*(7 - 12*s)) + 2*Pk2*(40*r - 7*s) + 7*Pkd2*k2*(5*s - 2))) + f**2*(2*Pk2*k2**4*(1 - 3*r) - k1**4*(4*Pk2 - Pkd2*k2)*(14*C*(3*s - 1) - 177*s + 70) + k1**2*k2**2*(2*Pk2*(4*C*(42*r + 103*s - 63) - 189*r + 55*s + 41) + Pkd2*k2*(C*(162 - 376*s) - 91*s + 34))))/(1155*d*k1**2*k2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st*(33*b1**2*(Pk2*k2**4*r - k1**4*s*(2*C - 6)*(2*Pk2 - Pkd2*k2) - k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(8*C - 8) + Pkd2*k2*s*(6*C + 4))) + 11*b1*f*(4*Pk2*k2**4*(5*r - 1) + k1**4*(Pk2*(8*C*(2*s - 5) + 6*r - 11*s + 40) + Pkd2*k2*(-2*C*(5*s - 9) + 9*s - 18)) + k1**2*k2**2*(Pk2*(-4*C*s + r*(98 - 36*C) + 7*s - 8) + Pkd2*k2*(18*C*(s - 1) + 17*s - 12))) + f**2*(132*Pk2*k2**4*r + k1**4*(Pk2*(4*C*(49*s - 75) + 89*r - 212*s + 239) - 2*Pkd2*k2*(C*(69*s - 67) - 88*s + 66)) + k1**2*k2**2*(Pk2*(24*C*(r - 15) + 709*r + 60*s - 29) + 44*Pkd2*k2*(C*(6*s - 3) + 3*s - 2))))/(3465*d*k1**2*k2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**3*st**5*(4*Pk2 - Pkd2*k2)*(13*b1*(47*s - 12) + 3*f*(131*s - 36))/(9009*d*k1) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**5*(-11*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s))))/(693*d*k1*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(1144*Pk2*f*g2*k2**2*(1 - 2*r) + 143*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(19*s - 8) - 6*s + 6) - 2*k2**2*(Pk2*(f*(8 - 38*s) + 6*r*(K - 1) + 6*s - 6) + Pkd2*k2*(f*(19*s - 4) - 3*s + 3))) + 26*b1*(132*Pk2*g2*k2**2*r + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(135*s - 56) + k2**2*(Pk2*(372*r + 50*s - 24) - Pkd2*k2*(25*s + 16))) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(4*K*Pk2*r - 2*K*Pk2 - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + f**3*(5*k1**2*(4*Pk2 - Pkd2*k2)*(261*s - 88) + 4*k2**2*(2*Pk2*(668*r - 455*s + 106) + 91*Pkd2*k2*(5*s - 2))))/(15015*d*k1*k2**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st*(44*Pk2*f*k2**2*(b2*(4 - 5*r) + 4*g2*(r - 2)) + 132*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) + 11*b1**2*(2*k1**2*(4*Pk2*f*(s - 3) - 6*Pk2 - 2*Pkd2*f*k2*(s - 3) + 3*Pkd2*k2*s) + k2**2*(-4*Pk2*(3*K*(r - 1) + 4*f*(5*r - 1) - 3*r - 3*s + 6) + Pkd2*k2*(f*(12 - 29*s) + 6*s))) + 2*b1*(132*Pk2*g2*k2**2*(r - 1) + f**2*(k1**2*(2*Pk2 - Pkd2*k2)*(97*s - 88) + 4*k2**2*(Pk2*(24 - 72*r) + 11*Pkd2*k2*(1 - 3*s))) + 11*f*(k1**2*(Pk2*(5*s - 7) - 3*Pkd2*k2*(s - 1)) - k2**2*(Pk2*(4*K*(r - 2) + 16*r + s - 7) + 3*Pkd2*k2*(s - 1)))) + 30*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(3465*d*k1*k2**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(33*b1**2*k2**2*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + 11*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(r + 13*s - 5) - 33*r - 22*s + 7) + 2*Pkd2*k2*(C*(8 - 19*s) - 5*s + 2)) + k2**4*(Pk2*(32*C*r - 4*C - 43*r - 14*s + 11) + Pkd2*k2*(3 - 8*s))) + f**2*(7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(21*r + 144*s - 77) - 135*r - 56*s + 115) + Pkd2*k2*(C*(112 - 270*s) + s - 4)) + k2**4*(Pk2*(16*C*(10*r - 7) + 55*r - 18*s + 39) + 11*Pkd2*k2*(2*s - 1))))/(1155*d*k1*k2**2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st*(-33*b1**2*(2*Pk2*k2**4*s + k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(8 - 4*C) + Pk2*s*(10 - 8*C) + Pkd2*k2*s*(8*C + 1))) + 11*b1*f*(k1**4*(Pk2*(3*s + 7) - Pkd2*k2*(s + 3)) + k1**2*k2**2*(Pk2*(4*C*(7*r - s - 2) + 23*r + 6*s + 3) + Pkd2*k2*(C*(22*s - 24) + 2*s - 3)) + k2**4*(Pk2*(8*C*(r - 2) + 37*r + 7*s - 2) + 3*Pkd2*k2*s)) + 2*f**2*(66*Pk2*k2**4*r + k1**4*(Pk2*(26 - 12*s) + 11*Pkd2*k2*(s - 1)) + k1**2*k2**2*(2*Pk2*(46*C*r - 30*C + 55*r + 5*s + 2) + 11*Pkd2*k2*(12*C*s - 8*C + s - 1))))/(3465*d*k1*k2**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*k2*st**5*(-22*C*b1*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 22*Pk2*b1*r*(k1**2 + k2**2) + Pk2*f*k2**2*(1 - 3*r) + f*k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2))/(693*d*k1**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**5*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 39*b1*f*(2*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + f**2*(5*Pk2*k2**2*(21*r - 2) + 18*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(9009*d*k1**2*k2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(-429*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) - 143*b1**2*(-Pk2*k2**2*r*(8*f + 3) + k1**2*(Pk2*(6*K*(s - 1) + f*(3*r - 28*s + 8) - 3*r + 6*s - 6) + Pkd2*k2*(2*f*(7*s - 2) + (-3*K - 3)*(s - 1)))) - 13*b1*(33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + f**2*(6*Pk2*k2**2*(2 - 17*r) + k1**2*(Pk2*(-84*r + 6*s - 38) + Pkd2*k2*(26 - 3*s))) - 11*f*(Pk2*k2**2*(1 - 2*r) + k1**2*(Pk2*(4*K*s - 2*K - 2*r + 4*s - 1) - Pkd2*k2*(K + 1)*(2*s - 1))) - 66*g2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + f*k1**2*(143*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + f**2*(Pk2*(425*r - 728*s + 326) + 182*Pkd2*k2*(2*s - 1)) - 286*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(15015*d*k1**2*k2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st*(33*Pkd2*f*k1**2*k2*(b2 - 2*g2)*(s - 1) + 33*b1**3*k2*(2*Pk2*k2*r - Pkd2*k1**2*s) + 11*b1**2*(Pk2*k2**2*(f*(7*r - 2) - 3*r + 3) + k1**2*(Pk2*(4*f*(4*r - 1) - 3*r + 3) + Pkd2*k2*(f*(8*s - 3) + s*(-3*K - 3)))) + b1*(-Pkd2*k1**2*k2*s*(33*b2 - 66*g2) + 2*f**2*k1**2*(Pk2*(35*r - 8) + 11*Pkd2*k2*(3*s - 1)) + 33*f*(Pk2*k2**2*r + k1**2*(Pk2*r + Pkd2*k2*(K + 1)*(s - 1)))))/(3465*d*k1**2*k2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(33*b1**2*(Pk2*k2**4*r + k1**2*k2**2*(2*C*Pkd2*k2*s + Pk2*r)) + 11*b1*f*(Pk2*k2**4*(1 - 8*r) + k1**4*(2*C*Pkd2*k2*(1 - 2*s) + Pk2*(8*C*s - 4*C - 2*r - 7*s + 2)) - k1**2*k2**2*(2*C*Pkd2*k2*(8*s - 3) + Pk2*(r*(12*C + 10) + 7*s - 3))) + f**2*(22*Pk2*k2**4*r + k1**4*(14*C*Pkd2*k2*(1 - 3*s) + Pk2*(84*C*s - 28*C - 21*r - 9*s + 21)) + k1**2*k2**2*(22*C*Pkd2*k2*(2*s - 1) + Pk2*(56*C*(3*r - 1) + r - 9*s + 21))))/(1155*d*k1**2*k2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st*(-3*b1**2*(Pk2*k1**2*k2**2*(r + 2*s) + k1**4*(2*C*Pkd2*k2*s + Pk2*r + 2*Pk2*s)) + b1*f*(3*Pk2*k2**4*r + k1**4*(-2*C*Pkd2*k2*(s + 3) + Pk2*(-r + s + 2)) + k1**2*k2**2*(6*C*Pkd2*k2*s + Pk2*(4*C*(8*r + 3*s - 4) + 2*r + s + 2))) + 2*f**2*k1**2*(2*C*Pkd2*k1**2*k2*(s - 1) + Pk2*r*(k1**2 + k2**2)))/(315*d*k1**2*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*b1*f*st*(66*b1**2*r*(k1**2 + k2**2) - 11*b1*f*(2*k1**2*(r - 1) + k2**2*(r - 2)) + 2*f**2*k1**2*(7 - 10*r))/(3465*d*k1*k2) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**5*f**2*k2**2*st*(C - 1)*(11*b1*r + 2*f*(10*r - 7))/(3465*d*k3**2) + 20*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**3*k2*st*(52*b1*r + f*(49*r - 22))/(9009*d*k1) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**2*k2*st*(11*b1*r + 2*f*(10*r - 7))*(k1**2*(4 - 3*C) + k2**2)/(3465*d*k1*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**2*k2**2*st**3*(C - 1)*(77*b1*r + f*(9*r + 8))/(1155*d*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*st*(286*b1**2*r*(3*K + f - 3) + 13*b1*(4*f**2*(30*r - 7) - 11*f*(K - 1)*(r - 2) - 132*g2*r) + 20*f**3*(49*r - 22) + 286*f*g2*(r - 2))/(45045*d) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f*st*(132*b1**2*k2**2*r*(C - 1) + 11*b1*f*(k1**2*r*(5 - 2*C) + k2**2*(2*C*(r + 2) + 5*r - 4)) - 2*f**2*(10*r - 7)*(k1**2*(2*C - 5) - k2**2*(4*C + 3)))/(3465*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**3*k2*st**3*(-39*b1*r + f*(5*r - 24))/(1001*d*k1) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**2*k2*st**3*(77*b1*r + f*(9*r + 8))*(k1**2*(C - 2) - k2**2)/(1155*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st*(429*b1**2*r*(k1**2*(f - 4) + k2**2*(2*f - 4)) + 26*b1*f*(k1**2*(60*f*r - 21*f + 11*r - 22) + k2**2*(60*f*r - 42*f + 11*r - 22)) + 15*f**3*k1**2*(49*r - 22))/(45045*d*k1*k2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st*(-66*b1**2*k2**2*r*(k1**2*(3 - 2*C) + k2**2) + 11*b1*f*(k1**4*r + 2*k1**2*k2**2*(2*C*(r + 1) + 2*r - 3) + k2**4*(r - 2)) + 2*f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(10*r - 7))/(3465*d*k1*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(1001*b1**2*r + 13*b1*f*(27*r + 8) + 6*f**2*(24 - 5*r))/(15015*d) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(k1**2 + k2**2*(4*C + 1))*(77*b1*r + f*(9*r + 8))/(1155*d*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st*(66*b1**3*r + 22*b1**2*(-2*f*r + f + r*(3*K + 3)) + b1*(f**2*(42 - 60*r) - 11*f*(K + 1)*(r - 2) + r*(66*b2 - 132*g2)) - 11*f*(b2 - 2*g2)*(r - 2))/(3465*d) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st*(4*C*f**2*k1**2*(10*r - 7) - 66*b1**2*r*(k1**2 + k2**2*(2*C + 1)) + 11*b1*f*(k1**2*(2*C*r + r - 2) + k2**2*(2*C + 1)*(r - 2)))/(3465*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**3*k2*st**5*(221*b1*r + f*(33*r + 8))/(9009*d*k1) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**2*st**3*(1001*b1**2*r*(k1**2 + 2*k2**2) + 26*b1*f*(k1**2*(9*r + 4) + k2**2*(9*r + 8)) + 3*f**2*k1**2*(24 - 5*r))/(15015*d*k1*k2)
        perm13 = -16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**3*f*st*(3*b1 + 2*f)*(s - 1)/(105*d*k1) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**2*f*st*(18*b1*k1**2*(2*C - 1)*(s - 1) - 3*b1*k2**2*r + f*k1**2*(24*C - 12)*(s - 1) - 2*f*k2**2*(r - 2))/(315*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st**3*(3*b1*(s - 1) - 2*f*s + f)/(105*d*k1) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st*(6*b1*(s - 1) + f*(4*C*(5*r - 4) - 10*r - s + 7))/(315*d*k1) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*k2*st*(6*b1**2*r + b1*(f*(7*r - 2) - 3*r + 3) + 3*f*r)/(315*d*k1**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*st**3*(6*b1*k1**2*(2*C - 1)*(s - 1) + 3*b1*k2**2*r + f*k1**2*(C*(4 - 8*s) + 4*s - 2) + f*k2**2*(1 - 2*r))/(105*d*k1**2*k2) - 64*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**5*st*(C - 1)*(110*b1*(2*r + 2*s - 1) + f*(137*r + 137*s - 62))/(3465*d*k3**6) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**6*f**2*k2**3*st*(C - 1)*(110*b1*(2*s - 1) + f*(137*s - 75))/(3465*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**4*st*(26*b1*(5*f*k2**2*(43*r + 43*s - 25) + 22*k1**2*(C*(61*r + 61*s - 35) - 51*r - 51*s + 30)) + f*(15*f*k2**2*(253*r + 253*s - 141) + 26*k1**2*(396*C*(2*r + 2*s - 1) - 655*r - 655*s + 334)))/(45045*d*k1*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**2*st*(110*b1*(2*s - 1) + f*(137*s - 75))/(3465*d*k1*k3**2) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**2*st*(22*b1*(k1**2*(9*C*(7*s - 4) - 53*s + 31) + k2**2*(r*(32 - 22*C) + 10*s - 5)) + f*(k1**2*(C*(872*s - 540) - 735*s + 465) + k2**2*(-6*C*(43*r + 15) + 395*r + 137*s + 28)))/(3465*d*k1*k3**4) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**5*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(83*r + 83*s - 48))/(1155*d*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**3*st**3*(C - 1)*(55*b1*(2*s - 1) + f*(83*s - 35))/(1155*d*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2**3*st*(286*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 26*b1*(7*f**2*k2**2*(32*r + 32*s - 25) + 11*f*(k1**2*(2*C*(65*r + 65*s - 46) - 89*r - 89*s + 67) + 6*k2**2*(C*(-6*r - 6*s + 3) + K*s + r*(K + 5) + 5*s - 3)) - 198*g2*k2**2*(r + s)) + f*(-5*f**2*k2**2*(1243*r + 1243*s - 747) - 26*f*k1**2*(16*C*(46*r + 46*s - 27) - 477*r - 477*s + 296) + f*k2**2*(3432*C - 3432)*(2*r + 2*s - 1) + 3432*g2*k2**2*(r + s)))/(45045*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2*st*(-396*b1**2*k1**2*(C - 1)*(s - 1) + 22*b1*f*(k1**2*(28*C*s - 8*C - 31*s + 14) + 12*k2**2*r) + f**2*(k1**2*(548*C*s - 300*C - 598*s + 390) + 11*k2**2*(11*r + 7)))/(3465*d*k1**2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f*k2*st*(5148*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 26*b1*f*(5*f*k2**4*r + 11*k1**4*(48*C*(3*s - 2) - 101*s + 70) - 11*k1**2*k2**2*(6*C*(17*r + 4*s - 1) - 93*r - 25*s + 11)) + f**2*(25*f*k2**4*(19*r - 34) + 26*k1**4*(8*C*(127*s - 90) - 717*s + 525) - 13*k1**2*k2**2*(4*C*(262*r + 97*s + 137) - 977*r - 358*s - 391)))/(45045*d*k1**2*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**4*st**3*(65*b1*f*k2**2*(73*r + 73*s - 45) + 286*b1*k1**2*(C*(73*r + 73*s - 35) - 63*r - 63*s + 30) + 5*f**2*k2**2*(607*r + 607*s - 387) + 26*f*k1**2*(C*(485*r + 485*s - 283) - 402*r - 402*s + 235))/(15015*d*k1*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(55*b1*(2*s - 1) + f*(83*s - 35))/(1155*d*k1*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(11*b1*(k1**2*(59*C*s - 28*C - 49*s + 23) + k2**2*(-6*C*r + 16*r + 10*s - 5)) + f*(k1**2*(467*C*s - 196*C - 384*s + 161) + k2**2*(-86*C*r + 14*C + 169*r + 83*s - 62)))/(1155*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2**2*st*(143*b1**2*k1**2*k2**2*(f*(65*r + 65*s - 37) + (54 - 72*K)*(r + s)) + 26*b1*(4*f**2*(5*k1**2*k2**2*(4*r + 4*s + 1) + 11*k2**4*(5*r + 5*s - 3)) - 11*f*(k1**4*(C*(52*r + 52*s - 56) - 28*r - 28*s + 35) + 3*k1**2*k2**2*(-4*C*(9*r + 9*s - 5) + 6*K*r + 6*K*s + 26*r + 26*s - 17)) + 792*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(k1**2*(-115*r - 115*s + 83) + 52*k2**2*(5*r + 5*s - 3)) - 26*f*k1**2*(k1**2*(8*C*(19*r + 19*s - 20) - 43*r - 43*s + 80) - 22*k2**2*(4*C*(9*r + 9*s - 5) - 30*r - 30*s + 17)) + 10296*g2*k1**2*k2**2*(r + s)))/(45045*d*k1*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*st*(-66*b1**2*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(2 - 2*C)) + 11*b1*f*(k1**2*(4*C - 2)*(11*s - 4) + k2**2*(8*C*(r + 1) + 3*r - 2*s - 7)) + 2*f**2*(k1**2*(12*C*(27*s - 20) - 209*s + 165) + k2**2*(24*C*(4*r - 5) - 45*r - 20*s + 117)))/(3465*d*k1*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*st*(286*b1**2*(k1**2*k2**2*(48*C - 39)*(r + s - 1) + k2**4*(f*(23*r + 23*s - 15) + r*(12 - 3*K) + 9*s)) + 13*b1*(4*f**2*k2**4*(129*r + 191*s - 87) + 11*f*(2*k1**4*(14*C*(5*s - 4) - 41*s + 34) - k1**2*k2**2*(4*C*(14*r + 5*s - 3) - 31*r + 2*s + 7) - 2*k2**4*(-36*C*r + 2*K*(r + 1) + 46*r + 12*s - 11)) + 132*g2*k2**4*r) + 2*f*(30*f**2*k2**4*(58*r + 65*s - 73) + 13*f*(k1**4*(C*(512*s - 420) - 303*s + 255) + k1**2*k2**2*(2*C*(81*r - 22*s - 225) - 152*r - 71*s + 331) + 66*k2**4*(r*(4*C - 6) - 2*s + 1)) + 572*g2*k2**4*(r + 1)))/(45045*d*k1*k3**4) + 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**5*st**5*(C - 1)*(11*b1*(2*r + 2*s - 1) + f*(-3*r - 3*s + 2))/(693*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**3*st**5*(C - 1)*(11*b1*(2*s - 1) - 3*f*s + f)/(693*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2**3*st**3*(-143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (3*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(377*r + 377*s - 255) + 11*f*(k1**2*(2*C*(95*r + 95*s - 43) - 137*r - 137*s + 61) + k2**2*(6*C + K - 7)*(2*r + 2*s - 1)) + 66*g2*k2**2*(r + s)) + f*(f**2*k2**2*(4341*r + 4341*s - 2869) + 13*f*(k1**2*(4*C*(251*r + 251*s - 149) - 685*r - 685*s + 409) + k2**2*(22 - 22*C)*(2*r + 2*s - 1)) - 286*g2*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st*(429*b1**2*k2**2*(f*k1**2*(9*r + 9*s - 7) - 6*f*k2**2*(2*r + 2*s - 1) + k1**2*(18 - 36*K)*(r + s)) + 26*b1*(2*f**2*k2**2*(k1**2*(47*r + 47*s - 13) + 33*k2**2*(4*r + 4*s - 3)) - 11*f*(k1**4*(2*C*(r + s - 8) + 9) + 3*k1**2*k2**2*(C*(-38*r - 38*s + 24) + 7*K*s + r*(7*K + 23) + 23*s - 17) + k2**4*(3 - 3*K)*(r + s)) + 1188*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(k1**2*(79*r + 79*s - 43) + 156*k2**2*(3*r + 3*s - 2)) + 26*f*k1**2*(k1**2*(2*C*(53*r + 53*s - 6) - 73*r - 73*s + 12) + 22*k2**2*(C*(38*r + 38*s - 24) - 26*r - 26*s + 17)) - 1716*g2*k2**2*(-7*k1**2 + k2**2)*(r + s)))/(45045*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st*(2574*b1**3*k2**4*(r + s - 1) - 429*b1**2*(k1**2*k2**2*(28*C - 18)*(r + s - 1) + k2**4*(-2*K*(7*r + 4*s + 1) + f*(-3*r - 6*s + 4) + 17*r + 14*s + 2)) - 13*b1*(2*f**2*k2**4*(81*r + 345*s - 97) + 11*f*(k1**4*(24*C - 12)*(s - 1) + k1**2*k2**2*(4*C*(19*r + 5*s + 3) - 44*r - 15*s - 12) + 2*k2**4*(6*C*(17*r + 5*s - 2) - 2*K*(r + s + 4) - 89*r - 28*s + 19)) + 66*k2**4*(-3*b2*(r + s) + 2*g2*(7*r + 4*s + 1))) - f*(45*f**2*k2**4*(97*r + 156*s - 138) + 13*f*(k1**4*(4*C - 2)*(47*s - 45) + k1**2*k2**2*(4*C*(300*r + 93*s - 175) - 729*r - 326*s + 403) + 44*k2**4*(6*C*(6*r + 2*s - 1) - 33*r - 12*s + 7)) + 572*k2**4*(-3*b2*(r + s) + 2*g2*(r + s + 4))))/(45045*d*k2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(66*b1**2*k1**2*(C - 1)*(s - 1) + 11*b1*f*(k1**2*(36*C*s - 18*C - 35*s + 16) - 4*k2**2*r) + f**2*(k1**2*(4*C*(83*s - 35) - 301*s + 126) + k2**2*(3*r - 1)))/(1155*d*k1**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(858*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) - 13*b1*f*(100*f*k2**4*r + 33*k1**4*(2*C*(20*s - 9) - 27*s + 12) - 11*k1**2*k2**2*(2*C*(53*r + 32*s - 15) - 109*r - 77*s + 35)) + f**2*(5*f*k2**4*(38 - 243*r) - 13*k1**4*(C*(914*s - 378) - 613*s + 252) + 13*k1**2*k2**2*(C*(584*r + 368*s - 222) - 550*r - 355*s + 232)))/(15015*d*k1**2*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st*(33*b1**2*(k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*(-4*C*(3*r + 2*s - 2) + 9*r + 8*s - 8) + k2**4*r*(4*f + 1)) + b1*f*k2**2*(-11*k1**2*(4*C*(5*r - s + 7) - 10*r + s - 20) + 4*k2**2*(3*f*(13*r - 8) + 55*r - 11)) + f**2*(-k1**4*(4*C - 2)*(47*s - 45) + k1**2*k2**2*(C*(360 - 552*r) + 325*r + 60*s - 209) + 132*k2**4*r))/(3465*d*k1**2*k2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**4*st**5*(-13*b1*(f*k2**2*(-47*r - 47*s + 35) + k1**2*(88*C - 66)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(131*r + 131*s - 95) + k1**2*(104*C - 78)*(3*r + 3*s - 2)))/(9009*d*k1*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(11*b1*(2*s - 1) - 3*f*s + f)/(693*d*k1*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(11*b1*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + f*(-k1**2*(4*C - 3)*(3*s - 1) + k2**2*(6*C*r - 2*C - 9*r - 3*s + 4)))/(693*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k1*st*(143*b1**2*k2**2*(f*k1**2*(r + s - 5) - 6*f*k2**2*(9*r + 9*s - 5) - k1**2*(72*K - 18)*(r + s)) - 26*b1*(f**2*k2**2*(k1**2*(5*r + 5*s - 7) + 44*k2**2) - 11*f*(k1**4*(2*C - 1)*(r + s + 1) + 3*k1**2*k2**2*(4*C*(4*r + 4*s - 3) - 4*K*s - r*(4*K + 8) - 8*s + 7) + k2**4*(6*K - 3)*(r + s)) - 792*g2*k1**2*k2**2*(r + s)) + 2*f*(5*f**2*k2**2*(k1**2*(49*r + 49*s - 27) + 39*k2**2*(9*r + 9*s - 7)) + 26*f*k1**2*(k1**2*(2*C - 1)*(10*r + 10*s - 3) + 11*k2**2*(4*C*(4*r + 4*s - 3) - 9*r - 9*s + 7)) - 1716*g2*k2**2*(-2*k1**2 + k2**2)*(r + s)))/(45045*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2**2*st**3*(143*b1**2*k1**2*k2**2*(f*(85*r + 85*s - 41) + (12*K - 6)*(r + s)) - 52*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 23) - 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(3*k1**2*(C*(17*r + 17*s - 7) - 10*r - 10*s + 4) + k2**2*(6*C + K - 5)*(2*r + 2*s - 1)) + 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*(k1**2*k2**2*(-3735*r - 3735*s + 2551) + 364*k2**4*(5*r + 5*s - 3)) - 26*f*(k1**4*(C*(426*r + 426*s - 262) - 243*r - 243*s + 151) + k1**2*k2**2*(33 - 44*C)*(2*r + 2*s - 1)) + 1144*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(15015*d*k1*k3**6) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(66*b1**2*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 11*b1*f*(k1**2*(12*C - 6)*(5*s - 2) + k2**2*(8*C*r - 4*C + 3*r + 14*s - 3)) + f**2*(2*k1**2*(2*C*(135*s - 56) - 156*s + 63) + k2**2*(8*C*(31*r - 14) - 91*r + 18*s + 17)))/(1155*d*k1*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st*(-22*b1**2*(3*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(3*K*(r - 1) - 2*f*(5*r + 9*s - 4) - 3*r + 3*s + 3)) + b1*(8*f**2*k2**2*(36*r + 33*s - 34) + 11*f*(k1**2*(4*C - 2)*(s - 5) + k2**2*(12*C*r - 10*K*r + 8*K + 13*r + 7*s - 2)) + 132*g2*k2**2*(r - 1)) + 2*f*(f*k1**2*(C*(60 - 136*r) + 68*r + 10*s - 26) + 66*f*k2**2*r - k2**2*(11*b2 - 22*g2)*(5*r - 4)))/(3465*d*k1*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(-286*b1**2*(k1**2*k2**2*(12*C - 9)*(r + s - 1) + k2**4*(f*(-19*r - 19*s + 15) + r*(6 - 3*K) + 3*s)) + 13*b1*(2*f**2*k2**4*(259*r + 245*s - 145) + 11*f*(k1**4*(C*(92*s - 40) - 50*s + 22) + k1**2*k2**2*(-40*C*(7*r + 5*s - 2) + 183*r + 142*s - 53) + 2*k2**4*(-12*C*r - 2*K*r + K + 22*r + 8*s - 5)) - 132*g2*k2**4*r) + f*(4*f**2*k2**4*(1002*r + 455*s - 387) + 13*f*(2*k1**4*(2*C*(177*s - 70) - 198*s + 77) + k1**2*k2**2*(-4*C*(181*r + 180*s - 91) + 515*r + 456*s - 287) + 22*k2**4*(r*(4*C - 6) - 2*s + 1)) + 572*g2*k2**4*(2*r - 1)))/(15015*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st*(3432*b1**3*k1**2*k2**2*(r + s - 1) - 286*b1**2*(-6*f*k2**4*(3*r + 3*s - 2) + k1**4*(12*C - 6)*(r + s - 1) + k1**2*k2**2*(-3*K*(11*r + 8*s + 2) + f*(-20*r - 29*s + 17) + 15*r + 15*s + 3)) + 13*b1*(2*f**2*k2**2*(k1**2*(161*r + 25*s - 73) + 44*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**4*(4*C*(7*r + s + 3) - 14*r - 3*s - 7) + k1**2*k2**2*(12*C*(11*r + 4*s - 2) + 2*K*(5*r + 2*s - 10) - 85*r - 27*s + 14) + 6*k2**4*(r*(K - 2) - s)) - 132*k1**2*k2**2*(-3*b2*(r + s) + g2*(11*r + 8*s + 2))) + 2*f*(-5*f**2*k1**2*k2**2*(136*r + 351*s - 307) - 26*f*(k1**4*(2*C*(54*r + 20*s - 21) - 54*r - 25*s + 19) + 11*k1**2*k2**2*(2*C*(13*r + 6*s - 4) - 18*r - 7*s + 5)) + 286*k2**2*(3*b2*k1**2*(r + s) + g2*k1**2*(5*r + 2*s - 10) + 3*g2*k2**2*r)))/(45045*d*k1*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2**3*st**5*(286*b1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(f*k2**2*(-29*r - 29*s + 23) + k1**2*(44*C - 22)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(83*r + 83*s - 59) + k1**2*(52*C - 26)*(3*r + 3*s - 2)))/(9009*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(-22*b1*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + f*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1)))/(693*d*k1**2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(-26*b1*(-3*f*k2**4*r + k1**4*(22*C - 11)*(2*s - 1) - 11*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + f*(5*f*k2**4*(21*r - 2) + k1**4*(52*C - 26)*(3*s - 1) - 13*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7)))/(9009*d*k1**2*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1**2*k2*st*(11*b1**2*(18*K*k1**2*(r + s) + f*k1**2*(r + s + 1) + 6*f*k2**2*(3*r + 3*s - 2)) + 2*b1*(f**2*(k1**2*(10*r + 10*s - 3) + 22*k2**2*(2*r + 2*s - 1)) - 33*f*(K*k2**2*(r + s) - k1**2*(-2*C*(r + s - 1) + K*r + K*s + r + s - 1)) - 198*g2*k1**2*(r + s)) - 2*f*(15*f**2*k2**2*(r + s - 1) + f*k1**2*(44*C - 22)*(r + s - 1) + 66*g2*(k1**2 - k2**2)*(r + s)))/(3465*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st*(66*b1**3*k1**2*(r + s - 1) + 11*b1**2*(f*(k1**2*(9*r + 18*s - 10) + 6*k2**2*(2*r + 2*s - 1)) + 3*k1**2*(2*K*(5*r + 4*s + 1) - r - 2*s)) + b1*(2*f**2*(k1**2*(55*r + 54*s - 40) + 22*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**2*(12*C*r + 2*K*(2*r + s - 4) - 5*r - s - 2) + 3*k2**2*(2*K*s + r*(4*K - 1))) + 66*k1**2*(3*b2*(r + s) - 2*g2*(5*r + 4*s + 1))) + 2*f*(33*b2*(k1**2 - k2**2)*(r + s) - 15*f**2*k1**2*(s - 1) - 11*f*k1**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2) + 22*g2*k1**2*(2*r + s - 4) + 66*g2*k2**2*(2*r + s)))/(3465*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st**3*(429*b1**2*k2**2*(2*K*k1**2*(r + s) + f*k1**2*(11*r + 11*s - 5) + 2*f*k2**2*(2*r + 2*s - 1)) + 26*b1*(f**2*k2**2*(k1**2*(42*r + 42*s - 17) + 11*k2**2*(4*r + 4*s - 3)) - 11*f*k1**2*(k1**2*(6*C - 3)*(3*r + 3*s - 1) + k2**2*(6*C + K - 3)*(2*r + 2*s - 1)) - 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*k2**2*(k1**2*(-395*r - 395*s + 319) + 364*k2**2*(3*r + 3*s - 2)) - f*k1**2*(52*C - 26)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1)) + 572*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**6) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(858*b1**3*k2**4*(r + s - 1) - 143*b1**2*(k1**2*k2**2*(12*C - 6)*(r + s - 1) - k2**4*(6*K*s + f*(31*r + 34*s - 22) + r*(12*K - 3))) + 13*b1*(2*f**2*k2**4*(72*r + 116*s - 63) + 11*f*(k1**4*(4*C - 2)*(2*s - 1) + k1**2*k2**2*(-4*C*(19*r + 14*s - 3) + 40*r + 35*s - 8) + k2**4*(-12*C*(4*r + 2*s - 1) - 4*K*(2*r + s - 1) + 32*r + 12*s - 7)) + 66*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + f*(f**2*k2**4*(1275*r + 1092*s - 842) + 13*f*(k1**4*(28*C - 14)*(3*s - 1) + k1**2*k2**2*(-4*C*(18*r + 39*s - 19) + 57*r + 87*s - 59) + 22*k2**4*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + 286*k2**4*(b2*(-2*r - 2*s + 1) + 4*g2*(2*r + s - 1))))/(15015*d*k2*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st*(-11*b1**2*k1**2*(6*K*(r - 1) + f*(2 - 12*s) + 6*s + 3) + b1*(2*f**2*k1**2*(35*r + 66*s - 52) + 11*f*(k1**2*(-2*K*(8*r + 3*s - 4) + r*(12*C - 10) + s + 2) + 3*k2**2*r) + 132*g2*k1**2*(r - 1)) + 22*f*k1**2*(b2*(-8*r - 3*s + 4) + f*r + 2*g2*(8*r + 3*s - 4)))/(3465*d*k1**2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(11*b1**2*(k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*r*(9 - 12*C) - k2**4*r*(8*f + 3)) + b1*f*k2**2*(-11*k1**2*(4*C*(r + 1) - 2*r - 7*s - 1) + k2**2*(-6*f*(17*r - 2) + 88*r - 11)) + f**2*(k1**4*(28*C - 14)*(3*s - 1) + k1**2*k2**2*(56*C*(3*r - 1) - 63*r + 9*s + 7) - 22*k2**4*r))/(1155*d*k1**2*k2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**3*f*k2**2*st*(3*b1 + 2*f)*(r + s - 1)/(105*d*k1*k3) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**2*f*k2*st*(3*b1*(6*C - 5) + f*(12*C - 5))*(r + s - 1)/(315*d*k3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2**2*st**3*(3*b1 - 2*f)*(r + s - 1)/(105*d*k1*k3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*st*(r + s - 1)*(12*b1**2*k2**2 + b1*k1**2*(12 - 24*C) + b1*k2**2*(7*f + 6) + f*k1**2*(4*C - 2) - 6*f*k2**2)/(315*d*k1*k3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*k2*st**3*(2*C - 1)*(3*b1 - 2*f)*(r + s - 1)/(105*d*k3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*k2*st*(r + s - 1)*(12*C*f + 6*b1**2 - b1*(6*K + f) - 6*b2 - 6*f + 12*g2)/(315*d*k3) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**6*f**2*k2**5*st*(C - 1)*(110*b1*(2*r + 2*s - 1) + f*(137*r + 137*s - 62))/(3465*d*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**4*st*(110*b1*(2*r + 2*s - 1) + f*(137*r + 137*s - 62))/(3465*d*k1*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**4*st*(26*b1*(5*f*k2**2*(43*r + 43*s - 25) + 22*k1**2*(C*(61*r + 61*s - 35) - 51*r - 51*s + 30)) + f*(15*f*k2**2*(253*r + 253*s - 141) + 26*k1**2*(396*C*(2*r + 2*s - 1) - 655*r - 655*s + 334)))/(45045*d*k1*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**5*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(83*r + 83*s - 48))/(1155*d*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**3*st*(198*b1**2*(C - 1)*(r + s - 1) - 11*b1*f*(4*C*(7*r + 7*s - 2) - 29*r - 29*s + 13) + f**2*(-2*C*(137*r + 137*s - 62) + 259*r + 259*s - 136))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f*k2**3*st*(286*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 26*b1*(7*f**2*k2**2*(32*r + 32*s - 25) + 11*f*(k1**2*(2*C*(65*r + 65*s - 46) - 89*r - 89*s + 67) + 6*k2**2*(C*(-6*r - 6*s + 3) + K*s + r*(K + 5) + 5*s - 3)) - 198*g2*k2**2*(r + s)) + f*(-5*f**2*k2**2*(1243*r + 1243*s - 747) - 26*f*k1**2*(16*C*(46*r + 46*s - 27) - 477*r - 477*s + 296) + f*k2**2*(3432*C - 3432)*(2*r + 2*s - 1) + 3432*g2*k2**2*(r + s)))/(45045*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(55*b1*(2*r + 2*s - 1) + f*(83*r + 83*s - 48))/(1155*d*k1*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(65*b1*f*k2**2*(73*r + 73*s - 45) + 286*b1*k1**2*(C*(73*r + 73*s - 35) - 63*r - 63*s + 30) + 5*f**2*k2**2*(607*r + 607*s - 387) + 26*f*k1**2*(C*(485*r + 485*s - 283) - 402*r - 402*s + 235))/(15015*d*k1*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**2*st*(11*b1**2*(k1**2*(48*C - 39)*(r + s - 1) + k2**2*(f*(23*r + 23*s - 15) + 9*r + 9*s)) + b1*f*(-11*k1**2*(4*C*(5*r + 5*s - 2) - 8*r - 8*s + 5) + 3*k2**2*(f*(54*r + 54*s - 34) - 44*r - 44*s + 33)) + f**2*(k1**2*(-4*C*(61*r + 61*s - 37) + 109*r + 109*s - 80) - 66*k2**2*(2*r + 2*s - 1)))/(3465*d*k1*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**2*st*(143*b1**2*k1**2*k2**2*(f*(65*r + 65*s - 37) + (54 - 72*K)*(r + s)) + 26*b1*(4*f**2*(5*k1**2*k2**2*(4*r + 4*s + 1) + 11*k2**4*(5*r + 5*s - 3)) - 11*f*(k1**4*(C*(52*r + 52*s - 56) - 28*r - 28*s + 35) + 3*k1**2*k2**2*(-4*C*(9*r + 9*s - 5) + 6*K*r + 6*K*s + 26*r + 26*s - 17)) + 792*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(k1**2*(-115*r - 115*s + 83) + 52*k2**2*(5*r + 5*s - 3)) - 26*f*k1**2*(k1**2*(8*C*(19*r + 19*s - 20) - 43*r - 43*s + 80) - 22*k2**2*(4*C*(9*r + 9*s - 5) - 30*r - 30*s + 17)) + 10296*g2*k1**2*k2**2*(r + s)))/(45045*d*k1*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**5*st**5*(C - 1)*(-11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(66*b1**2*(C - 1)*(r + s - 1) + 11*b1*f*(4*C*(9*r + 9*s - 4) - 49*r - 49*s + 21) + f**2*(4*C*(83*r + 83*s - 48) - 319*r - 319*s + 187))/(1155*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(-143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (3*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(377*r + 377*s - 255) + 11*f*(k1**2*(2*C*(95*r + 95*s - 43) - 137*r - 137*s + 61) + k2**2*(6*C + K - 7)*(2*r + 2*s - 1)) + 66*g2*k2**2*(r + s)) + f*(f**2*k2**2*(4341*r + 4341*s - 2869) + 13*f*(k1**2*(4*C*(251*r + 251*s - 149) - 685*r - 685*s + 409) + k2**2*(22 - 22*C)*(2*r + 2*s - 1)) - 286*g2*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**5) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2*st*(99*b1**3*k2**2*(r + s - 1) - 33*b1**2*(k1**2*(14*C - 9)*(r + s - 1) - k2**2*(2*K*r + 2*K*s + K - 3*f*r - 3*f*s + f - 5*r - 5*s - 1)) + b1*(f**2*k2**2*(-81*r - 81*s + 34) - 11*f*(k1**2*(2*C*(r + s + 2) - r - s - 4) + 3*k2**2*(2*C*(5*r + 5*s - 2) - 2*K*s - r*(2*K + 8) - 8*s + 5)) - 33*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + f*(-2*C*f*(k1**2*(13*r + 13*s + 6) + 66*k2**2*(2*r + 2*s - 1)) + 33*f*k1**2*(r + s) + 22*f*k2**2*(12*r + 12*s - 7) + 11*k2**2*(6*b2 - 12*g2)*(r + s)))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2*st*(429*b1**2*k2**2*(f*k1**2*(9*r + 9*s - 7) - 6*f*k2**2*(2*r + 2*s - 1) + k1**2*(18 - 36*K)*(r + s)) + 26*b1*(2*f**2*k2**2*(k1**2*(47*r + 47*s - 13) + 33*k2**2*(4*r + 4*s - 3)) - 11*f*(k1**4*(2*C*(r + s - 8) + 9) + 3*k1**2*k2**2*(C*(-38*r - 38*s + 24) + 7*K*s + r*(7*K + 23) + 23*s - 17) + k2**4*(3 - 3*K)*(r + s)) + 1188*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*k2**2*(k1**2*(79*r + 79*s - 43) + 156*k2**2*(3*r + 3*s - 2)) + 26*f*k1**2*(k1**2*(2*C*(53*r + 53*s - 6) - 73*r - 73*s + 12) + 22*k2**2*(C*(38*r + 38*s - 24) - 26*r - 26*s + 17)) - 1716*g2*k2**2*(-7*k1**2 + k2**2)*(r + s)))/(45045*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(-11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k1*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(-13*b1*(f*k2**2*(-47*r - 47*s + 35) + k1**2*(88*C - 66)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(131*r + 131*s - 95) + k1**2*(104*C - 78)*(3*r + 3*s - 2)))/(9009*d*k1*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k1*st*(143*b1**2*k2**2*(f*k1**2*(r + s - 5) - 6*f*k2**2*(9*r + 9*s - 5) - k1**2*(72*K - 18)*(r + s)) - 26*b1*(f**2*k2**2*(k1**2*(5*r + 5*s - 7) + 44*k2**2) - 11*f*(k1**4*(2*C - 1)*(r + s + 1) + 3*k1**2*k2**2*(4*C*(4*r + 4*s - 3) - 4*K*s - r*(4*K + 8) - 8*s + 7) + k2**4*(6*K - 3)*(r + s)) - 792*g2*k1**2*k2**2*(r + s)) + 2*f*(5*f**2*k2**2*(k1**2*(49*r + 49*s - 27) + 39*k2**2*(9*r + 9*s - 7)) + 26*f*k1**2*(k1**2*(2*C - 1)*(10*r + 10*s - 3) + 11*k2**2*(4*C*(4*r + 4*s - 3) - 9*r - 9*s + 7)) - 1716*g2*k2**2*(-2*k1**2 + k2**2)*(r + s)))/(45045*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(-11*b1**2*(k1**2*(12*C - 9)*(r + s - 1) + k2**2*(f*(-19*r - 19*s + 15) + 3*r + 3*s)) + b1*f*(-22*k1**2*(29*C*r + 29*C*s - 11*C - 18*r - 18*s + 6) + k2**2*(135*f*r + 135*f*s - 107*f + 88*r + 88*s - 44)) + f**2*(k1**2*(-2*C*(153*r + 153*s - 91) + 183*r + 183*s - 111) - 11*k2**2*(2*r + 2*s - 1)))/(1155*d*k1*k3**3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(-143*b1**2*k1**2*k2**2*(f*(85*r + 85*s - 41) + (12*K - 6)*(r + s)) + 52*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 23) - 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(3*k1**2*(C*(17*r + 17*s - 7) - 10*r - 10*s + 4) + k2**2*(6*C + K - 5)*(2*r + 2*s - 1)) + 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*(k1**2*k2**2*(3735*r + 3735*s - 2551) - 364*k2**4*(5*r + 5*s - 3)) + 26*f*(k1**4*(C*(426*r + 426*s - 262) - 243*r - 243*s + 151) + k1**2*k2**2*(33 - 44*C)*(2*r + 2*s - 1)) - 1144*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(15015*d*k1*k3**5) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*st*(132*b1**3*k1**2*k2**2*(r + s - 1) - 11*b1**2*(-6*f*k2**4*(3*r + 3*s - 2) + k1**4*(12*C - 6)*(r + s - 1) + k1**2*k2**2*(-2*f*(r + s - 1) - (6*K - 3)*(2*r + 2*s + 1))) + b1*(f**2*k2**2*(k1**2*(25*r + 25*s - 27) + 44*k2**2*(3*r + 3*s - 2)) - 11*f*(k1**4*(4*C - 2) - 3*k1**2*k2**2*(C*(-8*r - 8*s + 4) + 2*K*r + 2*K*s + 3*r + 3*s - 2) - 3*k2**4*(r + s)) - 66*k1**2*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + 2*f*k1**2*(-f*k1**2*(2*C - 1)*(10*r + 10*s - 3) - 11*f*k2**2*(4*C*(3*r + 3*s - 2) - 7*r - 7*s + 5) + k2**2*(33*b2 - 66*g2)*(r + s)))/(3465*d*k1*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(2*C - 1)*(11*b1*(2*r + 2*s - 1) + f*(-3*r - 3*s + 2))/(693*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(286*b1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(f*k2**2*(-29*r - 29*s + 23) + k1**2*(44*C - 22)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(83*r + 83*s - 59) + k1**2*(52*C - 26)*(3*r + 3*s - 2)))/(9009*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1**2*k2*st*(11*b1**2*(18*K*k1**2*(r + s) + f*k1**2*(r + s + 1) + 6*f*k2**2*(3*r + 3*s - 2)) + 2*b1*(f**2*(k1**2*(10*r + 10*s - 3) + 22*k2**2*(2*r + 2*s - 1)) - 33*f*(K*k2**2*(r + s) - k1**2*(-2*C*(r + s - 1) + K*r + K*s + r + s - 1)) - 198*g2*k1**2*(r + s)) - 2*f*(15*f**2*k2**2*(r + s - 1) + f*k1**2*(44*C - 22)*(r + s - 1) + 66*g2*(k1**2 - k2**2)*(r + s)))/(3465*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(33*b1**3*k2**2*(r + s - 1) - 11*b1**2*(k1**2*(6*C - 3)*(r + s - 1) - k2**2*(3*K*(r + s) + f*(11*r + 11*s - 8))) + b1*(3*f**2*k2**2*(24*r + 24*s - 17) - 11*f*(k1**2*(2*C - 1)*(7*r + 7*s - 1) + k2**2*(6*C + K - 3)*(2*r + 2*s - 1)) + k2**2*(33*b2 - 66*g2)*(r + s)) + f*(-f*(2*C - 1)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1)) + k2**2*(-11*b2 + 22*g2)*(2*r + 2*s - 1)))/(1155*d*k3**3) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st*(33*b1**3*k1**2*(r + s - 1) + 11*b1**2*(3*K*k1**2*(2*r + 2*s + 1) + f*(k1**2 + 3*k2**2*(2*r + 2*s - 1))) + b1*(33*K*f*(k1**2 - k2**2)*(r + s) + f**2*(k1**2*(10*r + 10*s - 3) + 22*k2**2*(3*r + 3*s - 2)) + 33*k1**2*(3*b2*(r + s) - 2*g2*(2*r + 2*s + 1))) + 11*f*(f*k1**2*(2 - 4*C)*(r + s - 1) + (3*b2 - 6*g2)*(k1**2 - k2**2)*(r + s)))/(3465*d*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(429*b1**2*k2**2*(2*K*k1**2*(r + s) + f*k1**2*(11*r + 11*s - 5) + 2*f*k2**2*(2*r + 2*s - 1)) + 26*b1*(f**2*k2**2*(k1**2*(42*r + 42*s - 17) + 11*k2**2*(4*r + 4*s - 3)) - 11*f*k1**2*(k1**2*(6*C - 3)*(3*r + 3*s - 1) + k2**2*(6*C + K - 3)*(2*r + 2*s - 1)) - 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*k2**2*(k1**2*(-395*r - 395*s + 319) + 364*k2**2*(3*r + 3*s - 2)) - f*k1**2*(52*C - 26)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1)) + 572*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1**2*f*k2*st*(6*b1*r - f*(r - 2))/(315*d*k1) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct**2*f*k2*st*(6*b1*r - f*(r - 2))/(315*d*k1) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct*f*st*(2*C - 1)*(6*b1*r - f*(r - 2))/(315*d) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**5*f**2*k2**4*st*(C - 1)*(11*b1*r + 2*f*(10*r - 7))/(3465*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**3*st*(11*b1*r + 2*f*(10*r - 7))/(3465*d*k1*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**3*st*(572*b1*k1**2*r*(7*C - 6) + 25*f**2*k2**2*(49*r - 22) + 52*f*(25*b1*k2**2*r + k1**2*(14*C - 12)*(10*r - 7)))/(45045*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**4*st**3*(C - 1)*(77*b1*r + f*(9*r + 8))/(1155*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k2**2*st*(132*b1**2*r*(C - 1) + 11*b1*f*(2*C*(r + 2) - 3*r - 4) + f**2*(8*C - 10)*(10*r - 7))/(3465*d*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f*k2**2*st*(-858*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 30*f**3*k2**2*(49*r - 22) + 26*f**2*(2*b1*k2**2*(20*r + 7) + k1**2*(18*C - 13)*(10*r - 7)) - 143*f*(2*b1**2*k2**2*r + b1*k1**2*r*(13 - 18*C) - b1*k2**2*(K - 1)*(r - 2) + 2*g2*k2**2*(r - 2)))/(45045*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(77*b1*r + f*(9*r + 8))/(1155*d*k1*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(585*b1*f*k2**2*r + 2002*b1*k1**2*r*(5*C - 4) + 15*f**2*k2**2*(24 - 5*r) + f*k1**2*(130*C - 104)*(9*r + 8))/(15015*d*k1*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k1*k2*st*(-1716*b1*k2**2*r*(b1*(3*K - 2) - 6*g2) + 45*f**3*k2**2*(49*r - 22) + 26*f**2*(63*b1*k2**2 + k1**2*(20*C - 12)*(10*r - 7)) - 143*f*(9*b1**2*k2**2*r - 2*b1*(k1**2*r*(10*C - 6) + k2**2*(3*K - 2)*(r - 2)) + 12*g2*k2**2*(r - 2)))/(45045*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2*st*(33*b1**2*r*(k1**2*(8*C - 6) - k2**2*(f - 2)) + b1*f*(11*k1**2*(2*C*(r + 4) - r - 6) + k2**2*(-60*f*r + 42*f - 11*r + 22)) + f**2*k1**2*(12*C - 8)*(10*r - 7))/(3465*d*k1*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(4*C - 3)*(77*b1*r + f*(9*r + 8))/(1155*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(1001*b1*r*(2*b1*k2**2 + k1**2*(5 - 8*C)) + 18*f**2*k2**2*(5*r - 24) - 13*f*(4*b1*k2**2*(9*r - 4) + k1**2*(8*C - 5)*(9*r + 8)))/(15015*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1**2*st*(-858*b1*k2**2*r*(b1*(3*K - 1) - 6*g2) + 5*f**3*k2**2*(49*r - 22) + 26*f**2*(b1*k2**2*(21 - 20*r) + k1**2*(2*C - 1)*(10*r - 7)) - 143*f*(3*b1**2*k2**2*r + b1*k1**2*r*(1 - 2*C) + b1*k2**2*(-3*K*(r - 2) + r - 2) + 6*g2*k2**2*(r - 2)))/(45045*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*st*(66*b1**3*k2**2*r + 22*b1**2*(f*k2**2*(r + 1) + r*(3*k1**2*(1 - 2*C) + 3*k2**2*(K - 1))) + b1*(6*f**2*k2**2*(10*r - 7) - 11*f*(k1**2*(4*C - 2) + k2**2*(K - 1)*(r - 2)) + k2**2*r*(66*b2 - 132*g2)) + f*(-f*k1**2*(4*C - 2)*(10*r - 7) + k2**2*(-11*b2 + 22*g2)*(r - 2)))/(3465*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**3*k2**5*st**5*(221*b1*r + f*(33*r + 8))/(9009*d*k1*k3**4) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k1*k2*st**3*(1001*b1*r*(3*b1*k2**2 + k1**2*(2 - 4*C)) + 9*f**2*k2**2*(5*r - 24) - 26*f*(-12*b1*k2**2 + k1**2*(2*C - 1)*(9*r + 8)))/(15015*d*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2*st**3*(b1*k2**2 + k1**2*(1 - 2*C))*(77*b1*r + f*(9*r + 8))/(1155*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**3*k2*st*(11*b1**2*r*(12*K + f) + 2*b1*(-11*K*f*(r - 2) + f**2*(10*r - 7) - 132*g2*r) + 44*f*g2*(r - 2))/(3465*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1*k2*st*(33*b1**3*r + 11*b1**2*(6*K*r + f) + b1*(-11*K*f*(r - 2) + f**2*(10*r - 7) + r*(66*b2 - 132*g2)) - 11*f*(b2 - 2*g2)*(r - 2))/(3465*d*k3**2)
        perm23 = -64*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**6*f**2*k1**2*k2**3*st*(715*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(275*r + 275*s - 177) + f*(13*C - 13)*(137*r + 137*s - 62) - 1430*g2*(2*r + 2*s - 1))/(45045*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**5*f**2*k1*k2**2*st*(-26*b1*(k1**2*(33*K - 33)*(7*r + 7*s - 5) - 5*k2**2*(f*(43*r + 43*s - 25) + (22 - 44*K)*(2*r + 2*s - 1))) - 15*f**2*k1**2*(661*r + 661*s - 473) - 26*f*(k1**2*(4*C - 4)*(61*r + 61*s - 37) + k2**2*(4*C - 3)*(137*r + 137*s - 62)) + 572*g2*(3*k1**2*(7*r + 7*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f**2*k1**2*k2**3*st**3*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 35*f**2*(168*r + 168*s - 113) + f*(52*C - 52)*(83*r + 83*s - 48) - 2860*g2*(2*r + 2*s - 1))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f*k2*st*(-2574*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 26*b1*(7*f**2*k1**2*k2**2*(32*r + 32*s - 25) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s - 2) + 3*k1**2*k2**2*(4*C*s + K*(8*r + 8*s - 7) + r*(4*C - 5) - 5*s + 2)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-15*f**2*k1**2*(k1**2*(251*r + 251*s - 237) - 130*k2**2*(3*r + 3*s - 2)) + 26*f*(k1**4*(2*C - 2)*(13*r + 13*s + 6) - 2*k1**2*k2**2*(2*C*(56*r + 56*s - 41) - 51*r - 51*s + 45) - k2**4*(2*C - 1)*(137*r + 137*s - 62)) + 572*g2*(3*k1**4*(r + s - 2) + 3*k1**2*k2**2*(8*r + 8*s - 7) + 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f**2*k1*k2**2*st**3*(-429*b1*k1**2*(K - 1)*(11*r + 11*s - 5) + 65*b1*k2**2*(f*(73*r + 73*s - 45) + (22 - 44*K)*(2*r + 2*s - 1)) - 15*f**2*k1**2*(597*r + 597*s - 425) - 26*f*(k1**2*(C - 1)*(153*r + 153*s - 91) + k2**2*(4*C - 3)*(83*r + 83*s - 48)) + 286*g2*(3*k1**2*(11*r + 11*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f*k1*st*(143*b1**2*(f*k2**4*(23*r + 23*s - 7) - 18*k2**2*(r + s)*(k1**2*(2*K - 2) + k2**2*(2*K - 1))) - 26*b1*(4*f**2*k2**2*(5*k1**2*(4*r + 4*s + 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(r + s + 1) - 3*k1**2*k2**2*(4*C*r + 4*C*s - 4*K*r - 4*K*s + r + s - 2) - 3*k2**4*(8*C*(r + s) + K*(-5*r - 5*s + 1) - 3)) - 396*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(5*f**2*k1**2*(k1**2*(277*r + 277*s - 81) + 156*k2**2*(15*r + 15*s - 11)) + 26*f*(k1**4*(4*C - 4)*(10*r + 10*s - 3) + k1**2*k2**2*(4*C*(79*r + 79*s - 38) - 303*r - 303*s + 158) + 2*k2**4*(2*C*(71*r + 71*s - 29) - 137*r - 137*s + 62)) - 572*g2*(k1**4*(r + s + 1) + 12*k1**2*k2**2*(r + s) + 3*k2**4*(5*r + 5*s - 1))))/(45045*d*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f**2*k1**2*k2**3*st**5*(-143*b1*(K - 1)*(2*r + 2*s - 1) + f**2*(678*r + 678*s - 489) + f*(26*C - 26)*(3*r + 3*s - 2) + 286*g2*(2*r + 2*s - 1))/(9009*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k2*st**3*(429*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(f**2*k1**2*k2**2*(377*r + 377*s - 255) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 1) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(72*r + 72*s - 33) - 43*r - 43*s + 20)) - 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*k1**2*(k1**2*(-4191*r - 4191*s + 3257) + 910*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(20*C - 20)*(3*r + 3*s - 2) + k1**2*k2**2*(C*(568*r + 568*s - 342) - 415*r - 415*s + 251) + k2**4*(4*C - 2)*(83*r + 83*s - 48)) + 286*g2*(k1**4*(9*r + 9*s - 3) + 3*k1**2*k2**2*(24*r + 24*s - 11) + 10*k2**4*(2*r + 2*s - 1))))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*st*(-2574*b1*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 15*f**3*(k1**6*(49*r + 49*s - 27) + 78*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(2*k1**4*k2**2*(C*(-62*r - 62*s + 34) + b1*(47*r + 47*s - 13) + 52*r + 52*s - 31) + k1**2*k2**4*(C*(-554*r - 554*s + 340) + 66*b1*(4*r + 4*s - 3) + 409*r + 409*s - 258) + k2**6*(66 - 132*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(3*b1**2*k1**2*k2**2*(11*r + 11*s - 3) + 2*b1*(k1**4*(-6*C*r - 6*C*s + K*(5*r + 5*s - 1) + 2*r + 2*s + 2) + 3*k1**2*k2**2*(-6*C*r - 6*C*s + K*(11*r + 11*s - 6) - 2*r - 2*s + 4) + 3*k2**4*(K*(6*r + 6*s - 3) + (2 - 4*C)*(r + s))) - 4*g2*(k1**4*(5*r + 5*s - 1) + 3*k1**2*k2**2*(11*r + 11*s - 6) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(1377*r + 1377*s - 997) - 13*f*k2**2*(b1*(47*r + 47*s - 35) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(-572*K*b1 + 286*b1 + 1144*g2))/(9009*d*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*k1*st**3*(858*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + f**3*(15*k1**4*(75*r + 75*s - 79) - 364*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f**2*(2*k1**2*k2**2*(b1*(18*r + 18*s - 23) + (15 - 20*C)*(3*r + 3*s - 2)) + k2**4*(-218*C*r - 218*C*s + 138*C - 22*b1*(5*r + 5*s - 3) + 87*r + 87*s - 58)) - 143*f*k2**2*(b1**2*k2**2*(19*r + 19*s - 11) - 2*b1*(k1**2*(6*K - 3)*(3*r + 3*s - 1) + k2**2*(C*(8*r + 8*s - 4) + 3*K*(15*r + 15*s - 7) - 12*r - 12*s + 6)) + 12*g2*(k1**2*(6*r + 6*s - 2) + k2**2*(15*r + 15*s - 7))))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*k1*st*(-33*b1**2*k2**2*(f*(k1**2*(-5*r - 5*s + 1) + 2*k2**2*(3*r + 3*s - 1)) + (r + s)*(12*K*k2**2 + 6*k1**2*(2*K - 1))) + 2*b1*(f**2*(k1**4*(5*r + 5*s - 7) + 44*k1**2*k2**2) + 11*f*(k1**2*k2**2*(-12*C*r - 12*C*s + K*(7*r + 7*s - 5) + 6*r + 6*s + 3) + 3*k2**4*(K*(6*r + 6*s - 4) - r - s)) + 396*g2*k2**2*(k1**2 + k2**2)*(r + s)) + 2*f*(45*f**2*k1**4*(r + s - 1) + 2*f*k2**2*(k1**2*(C*(64*r + 64*s - 50) - 43*r - 43*s + 36) + k2**2*(44*C - 22)*(3*r + 3*s - 2)) - 22*g2*k2**2*(k1**2*(7*r + 7*s - 5) + 6*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(1287*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**2*k2*st**5*(f**2*(k1**4*(-315*r - 315*s + 233) + 26*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(b1*k1**2*k2**2*(29*r + 29*s - 23) + k2**4*(2 - 4*C)*(3*r + 3*s - 2)) + k2**4*(286*K*b1 - 572*g2)*(2*r + 2*s - 1))/(9009*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*st**3*(858*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*(3*k1**6*(5*r + 5*s + 19) + 182*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(b1*k1**2*k2**2*(k1**2*(42*r + 42*s - 17) + 11*k2**2*(4*r + 4*s - 3)) + k2**4*(2*C - 1)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1))) + 143*f*k2**4*(b1**2*k1**2*(19*r + 19*s - 11) - 2*b1*(K*k1**2*(9*r + 9*s - 3) + 3*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 12*g2*(k1**2*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1))))/(15015*d*k2*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*st*(11*b1**2*k1**2*k2**2*(-18*K*k2**2*(r + s) + f*k1**2*(5*r + 5*s - 1) - 6*f*k2**2*(3*r + 3*s - 1)) + 2*b1*(f**2*k1**4*(k1**2*(10*r + 10*s - 3) + 22*k2**2*(2*r + 2*s - 1)) + 33*f*k2**4*(K*k1**2*(r + s - 1) - (2*C - 1)*(k1**2 - k2**2)*(r + s)) + 198*g2*k1**2*k2**4*(r + s)) + 44*f*k1**2*k2**4*(f*(2*C - 1) - 3*g2)*(r + s - 1))/(3465*d*k2*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**3*f*k1*st*(b1*(23*f + 18) + 12*f)*(r + s - 1)/(315*d*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**2*f*st*(r + s - 1)*(18*K*b1*k2**2 + 3*b1*k1**2*(f - 4) + 2*f*(k1**2 + k2**2*(12*C - 6)) + k2**2*(18*b2 - 36*g2))/(315*d*k2*k3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*k1*st**3*(b1*(19*f - 6) + 4*f)*(r + s - 1)/(105*d*k3) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*k1*st*(r + s - 1)*(2*C*f + 6*b1**2 + b1*(-6*K - 9*f + 3) - 6*b2 - 4*f + 12*g2)/(315*d*k3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*st**3*(b1*(6*K*k2**2 + 7*f*k1**2) + k2**2*(-8*C*f + 6*b2 + 4*f - 12*g2))*(r + s - 1)/(105*d*k2*k3) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*st*(r + s - 1)*(b1**2*k1**2 + b1*k2**2*(1 - 2*C) + f*k2**2*(2*C - 1))/(105*d*k2*k3) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**6*f**2*k1**2*k2**3*st*(715*b1*(K - 1)*(2*r + 2*s - 1) + 5*f**2*(275*r + 275*s - 177) + f*(13*C - 13)*(137*r + 137*s - 62) - 1430*g2*(2*r + 2*s - 1))/(45045*d*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1*k2**2*st*(5*b1*(f*(43*r + 43*s - 25) + 44*r + 44*s - 22) + f*(137*r + 137*s - 62))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1*k2**2*st*(-26*b1*(k1**2*(33*K - 33)*(7*r + 7*s - 5) - 5*k2**2*(f*(43*r + 43*s - 25) + (22 - 44*K)*(2*r + 2*s - 1))) - 15*f**2*k1**2*(661*r + 661*s - 473) - 26*f*(k1**2*(4*C - 4)*(61*r + 61*s - 37) + k2**2*(4*C - 3)*(137*r + 137*s - 62)) + 572*g2*(3*k1**2*(7*r + 7*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1**2*k2**3*st**3*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 35*f**2*(168*r + 168*s - 113) + f*(52*C - 52)*(83*r + 83*s - 48) - 2860*g2*(2*r + 2*s - 1))/(15015*d*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k2*st*(99*b1**2*k1**2*(K - 1)*(r + s - 1) + b1*(-110*K*f*k2**2*(2*r + 2*s - 1) + f**2*k1**2*(361*r + 361*s - 312) + 33*f*k1**2*(4*C*(r + s - 1) + 3*r + 3*s - 1) - 198*g2*k1**2*(r + s - 1)) + f*(2*f*k1**2*(61*r + 61*s - 37) - f*k2**2*(2*C - 1)*(137*r + 137*s - 62) + k2**2*(-110*b2 + 220*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f*k2*st*(-2574*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 26*b1*(7*f**2*k1**2*k2**2*(32*r + 32*s - 25) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s - 2) + 3*k1**2*k2**2*(4*C*s + K*(8*r + 8*s - 7) + r*(4*C - 5) - 5*s + 2)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-15*f**2*k1**2*(k1**2*(251*r + 251*s - 237) - 130*k2**2*(3*r + 3*s - 2)) + 26*f*(k1**4*(2*C - 2)*(13*r + 13*s + 6) - 2*k1**2*k2**2*(2*C*(56*r + 56*s - 41) - 51*r - 51*s + 45) - k2**4*(2*C - 1)*(137*r + 137*s - 62)) + 572*g2*(3*k1**4*(r + s - 2) + 3*k1**2*k2**2*(8*r + 8*s - 7) + 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(5*b1*(f*(73*r + 73*s - 45) + 44*r + 44*s - 22) + 2*f*(83*r + 83*s - 48))/(1155*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(13*b1*(k1**2*(33*K - 33)*(11*r + 11*s - 5) - 5*k2**2*(f*(73*r + 73*s - 45) + (22 - 44*K)*(2*r + 2*s - 1))) + 15*f**2*k1**2*(597*r + 597*s - 425) + 26*f*(k1**2*(C - 1)*(153*r + 153*s - 91) + k2**2*(4*C - 3)*(83*r + 83*s - 48)) - 286*g2*(3*k1**2*(11*r + 11*s - 5) + 20*k2**2*(2*r + 2*s - 1)))/(15015*d*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k1*st*(11*b1**2*(k1**2*(6*K - 6)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 8*f + 9)) + b1*(2*f**2*(k1**2*(21*r + 21*s - 41) - 22*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**2*(2*C*(r + s - 1) - 5*r - 5*s + 8) - 3*k2**2*(8*C*(r + s - 1) + K*(-7*r - 7*s + 5) - 10*r - 10*s + 9)) - 132*g2*(k1**2 + 3*k2**2)*(r + s - 1)) - f*(f*k1**2*(13*r + 13*s + 6) + 2*f*k2**2*(2*C*(61*r + 61*s - 37) + 5*r + 5*s + 4) + k2**2*(33*b2 - 66*g2)*(7*r + 7*s - 5)))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k1*st*(143*b1**2*(f*k2**4*(23*r + 23*s - 7) - 18*k2**2*(r + s)*(k1**2*(2*K - 2) + k2**2*(2*K - 1))) - 26*b1*(4*f**2*k2**2*(5*k1**2*(4*r + 4*s + 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(r + s + 1) - 3*k1**2*k2**2*(4*C*r + 4*C*s - 4*K*r - 4*K*s + r + s - 2) - 3*k2**4*(8*C*(r + s) + K*(-5*r - 5*s + 1) - 3)) - 396*g2*k2**2*(k1**2 + k2**2)*(r + s)) + f*(5*f**2*k1**2*(k1**2*(277*r + 277*s - 81) + 156*k2**2*(15*r + 15*s - 11)) + 26*f*(k1**4*(4*C - 4)*(10*r + 10*s - 3) + k1**2*k2**2*(4*C*(79*r + 79*s - 38) - 303*r - 303*s + 158) + 2*k2**4*(2*C*(71*r + 71*s - 29) - 137*r - 137*s + 62)) - 572*g2*(k1**4*(r + s + 1) + 12*k1**2*k2**2*(r + s) + 3*k2**4*(5*r + 5*s - 1))))/(45045*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1**2*k2**3*st**5*(-143*b1*(K - 1)*(2*r + 2*s - 1) + f**2*(678*r + 678*s - 489) + f*(26*C - 26)*(3*r + 3*s - 2) + 286*g2*(2*r + 2*s - 1))/(9009*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(33*b1**2*k1**2*(K - 1)*(r + s - 1) - b1*(f**2*k1**2*(543*r + 543*s - 421) + 11*f*(-10*K*k2**2*(2*r + 2*s - 1) + k1**2*(4*C*(r + s - 1) + 29*r + 29*s - 11)) + 66*g2*k1**2*(r + s - 1)) + f*(f*k1**2*(-153*r - 153*s + 91) + f*k2**2*(4*C - 2)*(83*r + 83*s - 48) + k2**2*(110*b2 - 220*g2)*(2*r + 2*s - 1)))/(1155*d*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(429*b1**2*k1**2*k2**2*(K - 1)*(r + s) + 13*b1*(f**2*k1**2*k2**2*(377*r + 377*s - 255) - 11*f*(10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 1) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(72*r + 72*s - 33) - 43*r - 43*s + 20)) - 66*g2*k1**2*k2**2*(r + s)) + f*(f**2*k1**2*(k1**2*(-4191*r - 4191*s + 3257) + 910*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(20*C - 20)*(3*r + 3*s - 2) + k1**2*k2**2*(C*(568*r + 568*s - 342) - 415*r - 415*s + 251) + k2**4*(4*C - 2)*(83*r + 83*s - 48)) + 286*g2*(k1**4*(9*r + 9*s - 3) + 3*k1**2*k2**2*(24*r + 24*s - 11) + 10*k2**4*(2*r + 2*s - 1))))/(15015*d*k3**5) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*st*(-33*b1**2*(-3*K*k2**4 + 2*k1**2*k2**2*(C*(r + s - 1) + 2*K*r + 2*K*s - 2*K + f*(2*r + 2*s - 1) + r + s + 2)) + b1*(3*f**2*k1**2*(k1**2*(20*r + 20*s - 13) + 22*k2**2*(6*r + 6*s - 5)) + 11*f*(k1**4*(r + s + 1) + k1**2*k2**2*(10*C*(r + s - 1) + 3*K*(r + s - 2) + 3*r + 3*s - 3) + 3*k2**4*(4*C + K*(-6*r - 6*s + 3) - 2)) + 33*k2**2*(3*b2*k2**2*(r + s) + 8*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + f*(f*(k1**4*(20*r + 20*s - 6) - k1**2*k2**2*(2*C*(13*r + 13*s + 6) - 145*r - 145*s + 82) + k2**4*(66 - 132*C)*(2*r + 2*s - 1)) + k2**2*(33*b2 - 66*g2)*(k1**2*(r + s - 2) - 3*k2**2*(2*r + 2*s - 1))))/(3465*d*k2*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*st*(-2574*b1*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 15*f**3*(k1**6*(49*r + 49*s - 27) + 78*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(2*k1**4*k2**2*(C*(-62*r - 62*s + 34) + b1*(47*r + 47*s - 13) + 52*r + 52*s - 31) + k1**2*k2**4*(C*(-554*r - 554*s + 340) + 66*b1*(4*r + 4*s - 3) + 409*r + 409*s - 258) + k2**6*(66 - 132*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(3*b1**2*k1**2*k2**2*(11*r + 11*s - 3) + 2*b1*(k1**4*(-6*C*r - 6*C*s + K*(5*r + 5*s - 1) + 2*r + 2*s + 2) + 3*k1**2*k2**2*(-6*C*r - 6*C*s + K*(11*r + 11*s - 6) - 2*r - 2*s + 4) + 3*k2**4*(K*(6*r + 6*s - 3) + (2 - 4*C)*(r + s))) - 4*g2*(k1**4*(5*r + 5*s - 1) + 3*k1**2*k2**2*(11*r + 11*s - 6) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(b1*f*(47*r + 47*s - 35) - 22*b1*(2*r + 2*s - 1) + 2*f*(3*r + 3*s - 2))/(693*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(1377*r + 1377*s - 997) - 13*f*k2**2*(b1*(47*r + 47*s - 35) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(-572*K*b1 + 286*b1 + 1144*g2))/(9009*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(11*b1**2*k2**2*(-6*K*(r + s - 1) + 4*f - 3) + b1*(f**2*(9*k1**2*(21*r + 21*s - 19) - 22*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**2*(9*r + 9*s - 3) + k2**2*(8*C*(r + s - 1) - 3*K*(11*r + 11*s - 5) + 2*r + 2*s + 2)) + 132*g2*k2**2*(r + s - 1)) + f*(10*f*k1**2*(3*r + 3*s - 2) + f*k2**2*(-2*C*(153*r + 153*s - 91) + 131*r + 131*s - 80) - k2**2*(33*b2 - 66*g2)*(11*r + 11*s - 5)))/(1155*d*k3**3) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st*(66*b1**3*k2**2*(r + s - 1) - 11*b1**2*(f*(5*k1**2*(r + s - 1) - 6*k2**2) + 9*k1**2*(r + s) + 3*k2**2*(4*C*(r + s - 1) - 2*K*(2*r + 2*s + 1) - 3*r - 3*s + 3)) + 11*b1*(12*f**2*k1**2*(r + s - 1) - f*(k1**2*(K*(r + s + 1) + 3) + k2**2*(-2*C*(13*r + 13*s - 7) + 6*K*(3*r + 3*s - 2) + 13*r + 13*s - 10)) - 6*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + f*(-11*b2*(k1**2*(r + s + 1) + 6*k2**2*(3*r + 3*s - 2)) + 2*f*k1**2*(C*(-20*r - 20*s + 6) + 21*r + 21*s - 14) - 2*f*k2**2*(44*C - 22)*(3*r + 3*s - 2) + 22*g2*k1**2*(r + s + 1) + 132*g2*k2**2*(3*r + 3*s - 2)))/(3465*d*k3**3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(858*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + f**3*(15*k1**4*(75*r + 75*s - 79) - 364*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f**2*(2*k1**2*k2**2*(b1*(18*r + 18*s - 23) + (15 - 20*C)*(3*r + 3*s - 2)) + k2**4*(-218*C*r - 218*C*s + 138*C - 22*b1*(5*r + 5*s - 3) + 87*r + 87*s - 58)) - 143*f*k2**2*(b1**2*k2**2*(19*r + 19*s - 11) - 2*b1*(k1**2*(6*K - 3)*(3*r + 3*s - 1) + k2**2*(C*(8*r + 8*s - 4) + 3*K*(15*r + 15*s - 7) - 12*r - 12*s + 6)) + 12*g2*(k1**2*(6*r + 6*s - 2) + k2**2*(15*r + 15*s - 7))))/(15015*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st*(-33*b1**2*k2**2*(f*(k1**2*(-5*r - 5*s + 1) + 2*k2**2*(3*r + 3*s - 1)) + (r + s)*(12*K*k2**2 + 6*k1**2*(2*K - 1))) + 2*b1*(f**2*(k1**4*(5*r + 5*s - 7) + 44*k1**2*k2**2) + 11*f*(k1**2*k2**2*(-12*C*r - 12*C*s + K*(7*r + 7*s - 5) + 6*r + 6*s + 3) + 3*k2**4*(K*(6*r + 6*s - 4) - r - s)) + 396*g2*k2**2*(k1**2 + k2**2)*(r + s)) + 2*f*(45*f**2*k1**4*(r + s - 1) + 2*f*k2**2*(k1**2*(C*(64*r + 64*s - 50) - 43*r - 43*s + 36) + k2**2*(44*C - 22)*(3*r + 3*s - 2)) - 22*g2*k2**2*(k1**2*(7*r + 7*s - 5) + 6*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(1287*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(b1*(22*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(35*r + 35*s - 29)) + 2*k2**2*(11*b2*(2*r + 2*s - 1) - f*(2*C - 1)*(3*r + 3*s - 2) - 22*g2*(2*r + 2*s - 1)))/(693*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(f**2*(k1**4*(315*r + 315*s - 233) - 26*k1**2*k2**2*(3*r + 3*s - 2)) - 13*f*(b1*k1**2*k2**2*(29*r + 29*s - 23) + k2**4*(2 - 4*C)*(3*r + 3*s - 2)) + k2**4*(-286*K*b1 + 572*g2)*(2*r + 2*s - 1))/(9009*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(11*b1**2*(3*K*k2**4 + f*k1**2*k2**2*(4*r + 4*s - 1)) + b1*(f**2*(k1**4*(9*r + 9*s - 13) - 11*k1**2*k2**2*(6*r + 6*s - 5)) - 11*f*(K*k1**2*k2**2*(9*r + 9*s - 3) + 3*K*k2**4*(2*r + 2*s - 1) + k2**4*(2*C - 1)) + 33*k2**4*(b2*(r + s) - 2*g2)) + f*k2**2*(-33*b2*(k1**2*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1)) - f*(2*C - 1)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1)) + 66*g2*(k1**2*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1))))/(1155*d*k2*k3**3) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st*(6*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(9*K*k1**2*k2**2*(r + s) + f*k1**4*(r + s) + f*k1**2*k2**2*(6*r + 6*s - 3) + k2**4*(3 - 6*C)*(r + s - 1)) - 3*b1*k2**2*(K*f*k1**2*(r + s - 1) + f*(2*C - 1)*(-k1**2*(r + s) + k2**2) - k1**2*(3*b2 - 6*g2)*(r + s)) - f*k1**2*k2**2*(3*b2 + f*(4*C - 2) - 6*g2)*(r + s - 1))/(315*d*k2*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(858*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*(3*k1**6*(5*r + 5*s + 19) + 182*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(b1*k1**2*k2**2*(k1**2*(42*r + 42*s - 17) + 11*k2**2*(4*r + 4*s - 3)) + k2**4*(2*C - 1)*(10*k1**2*(3*r + 3*s - 2) - 11*k2**2*(2*r + 2*s - 1))) + 143*f*k2**4*(b1**2*k1**2*(19*r + 19*s - 11) - 2*b1*(K*k1**2*(9*r + 9*s - 3) + 3*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 12*g2*(k1**2*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1))))/(15015*d*k2*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st*(11*b1**2*k1**2*k2**2*(-18*K*k2**2*(r + s) + f*k1**2*(5*r + 5*s - 1) - 6*f*k2**2*(3*r + 3*s - 1)) + 2*b1*(f**2*k1**4*(k1**2*(10*r + 10*s - 3) + 22*k2**2*(2*r + 2*s - 1)) + 33*f*k2**4*(K*k1**2*(r + s - 1) - (2*C - 1)*(k1**2 - k2**2)*(r + s)) + 198*g2*k1**2*k2**4*(r + s)) + 44*f*k1**2*k2**4*(f*(2*C - 1) - 3*g2)*(r + s - 1))/(3465*d*k2*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**3*f*k1*st*(-4*Pk2 + Pkd2*k2)*(b1*f*(23*s - 16) + 18*b1*(s - 1) + 12*f*(s - 1))/(315*d*k2**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**2*f*st*(-9*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 9*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(9*Pk2*b1*(r - 1) + 4*Pk2*(-6*C*(s - 1) + r + 3*s - 5) + Pkd2*k2*(12*C - 6)*(s - 1)) + 18*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(315*d*k2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*k1*st**3*(-4*Pk2 + Pkd2*k2)*(b1*(f*(19*s - 8) - 6*s + 6) + 2*f*(2*s - 1))/(105*d*k2**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*st*(6*b1**2*k1**2*s*(-2*Pk2 + Pkd2*k2) + 3*b1*k1**2*(Pk2*(6*f*s - 4*f - 2) + Pkd2*k2*(-3*f*s + 2*f + s)) + f*(Pk2*k2**2*(4*C - 2)*(5*r - 4) + k1**2*(Pk2*(5*s - 7) - 3*Pkd2*k2*(s - 1))))/(315*d*k1*k2**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st**3*(-3*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 3*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(8*C*s - 4*C + 3*b1*(r - 1) + 2*r - 4*s + 1) + Pkd2*k2*(C*(2 - 4*s) + 2*s - 1)) + 6*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(105*d*k2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st*(Pk2*b1*(r - 1) - Pk2*f*r + Pkd2*b1*k2*s*(1 - 2*C) + Pkd2*f*k2*(2*C - 1)*(s - 1))/(105*d*k2) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**6*f**2*k1**2*k2*st*(-4*Pk2 + Pkd2*k2)*(715*b1*(K - 1)*(2*s - 1) + 5*f**2*(275*s - 98) + f*(13*C - 13)*(137*s - 75) + 1430*g2*(1 - 2*s))/(45045*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1*st*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(43*s - 18) + 44*s - 22) + f*(137*s - 75))/(3465*d*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1*st*(26*b1*(k1**2*(11*K - 11)*(4*Pk2 - Pkd2*k2)*(23*s - 16) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(2*Pk2*(43*r - 7) + Pkd2*k2*(43*s - 18)))) + 45*f**2*(104*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(253*s - 112)) + 26*f*(k1**2*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(27*s - 20) + k2**2*(Pk2*(-4*C*(89*r - 274*s + 223) + 630*r - 548*s + 618) - Pkd2*k2*(4*C - 3)*(137*s - 75))) + 572*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(23*s - 16) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1**2*k2*st**3*(-4*Pk2 + Pkd2*k2)*(1430*b1*(K - 1)*(2*s - 1) + 35*f**2*(168*s - 55) + f*(52*C - 52)*(83*s - 35) + 2860*g2*(1 - 2*s))/(15015*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*st*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(f**2*(110*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(137*s - 75)) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(12*C*(s - 1) + 11*s - 4) + 10*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(6*f*k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + f*k2**2*(Pk2*(C*(300 - 548*s) - 41*r + 274*s - 283) + Pkd2*k2*(2*C - 1)*(137*s - 75)) + k2**2*(-2*Pk2 + Pkd2*k2)*(110*b2 - 220*g2)*(2*s - 1)))/(3465*d*k2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f*st*(-1287*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 13*b1*(f**2*k2**2*(-110*Pk2*k2**2*(r - 1) + k1**2*(722*Pk2*r + 174*Pk2*(s - 1) + Pkd2*k2*(274*s - 225))) + 11*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(2*Pk2*(12*C*(r + 2*s - 1) - 2*K*(7*r - 15*s + 12) + 23*r - 10*s + 5) + Pkd2*k2*(K*(23 - 28*s) + s*(17 - 12*C) - 7)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 198*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(-2860*Pk2*b2*k2**4*(2*r + 2*s - 1) + 15*f**2*k1**2*(4*k1**2*(4*Pk2 - Pkd2*k2)*(62*s - 35) + 65*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 13*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(47*s - 45) + 2*k1**2*k2**2*(-2*Pk2*(C*(24*r - 232*s + 282) - 85*r + 90*s - 185) - 3*Pkd2*k2*(C*(64*s - 58) - 37*s + 38)) + k2**4*(Pk2*(-4*C*(178*r + 137*s + 71) + 397*r + 274*s + 275) - Pkd2*k2*(2*C - 1)*(137*s - 75))) - 286*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(-4*Pk2*(7*r - 15*s + 12) + Pkd2*k2*(23 - 28*s)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(45045*d*k2*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(73*s - 28) + 44*s - 22) + 2*f*(83*s - 35))/(1155*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(13*b1*(k1**2*(11*K - 11)*(4*Pk2 - Pkd2*k2)*(19*s - 8) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(2*Pk2*(73*r - 17) + Pkd2*k2*(73*s - 28)))) + 5*f**2*(728*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(607*s - 220)) + 26*f*(k1**2*(C - 1)*(4*Pk2 - Pkd2*k2)*(135*s - 56) + k2**2*(Pk2*(-4*C*(52*r - 166*s + 71) + 374*r - 332*s + 118) - Pkd2*k2*(4*C - 3)*(83*s - 35))) + 286*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(19*s - 8) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(15015*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st*(11*b1**2*k1**2*k2**2*(-2*Pk2*(-9*K*(r - 2*s + 2) + 8*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 8*f + 9)) + b1*k1**2*(-2*f**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + 22*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) + 11*f*(-6*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + k2**2*(Pk2*(4*C*(r - 12*s + 16) + 46*K*s - 32*K + r + 58*s - 69) + Pkd2*k2*(24*C*(s - 1) - 23*K*s + 16*K - 30*s + 27))) - 396*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(48*C - 24)*(4*r - 5) - k1**4*(4*Pk2 - Pkd2*k2)*(47*s - 45) - 2*k1**2*k2**2*(Pk2*(-324*C*s + 240*C + 57*r + 50*s - 153) + 3*Pkd2*k2*(54*C*s - 40*C - 5*s + 9))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-11*b2 + 22*g2)*(23*s - 16)))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st*(-858*b1*k1**2*k2**2*(4*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 8*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 5*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(311*s - 224) + 156*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 26*f**2*(Pk2*k2**6*(24 - 48*C)*(4*r - 5) - k1**4*k2**2*(2*Pk2*(C*(42*r + 44*s - 58) + 14*b1*(3*r + 3*s + 7) - 55*r - 10*s + 7) + Pkd2*k2*(C*(76*s + 4) - 180*b1 - 123*s + 41)) + 2*k1**2*k2**4*(Pk2*(-4*C*(62*r - 41*s - 62) + 44*b1*(9*r + 5*s - 5) + 445*r + 70*s - 289) + Pkd2*k2*(3*C*(4 - 34*s) + 22*b1*(5*s - 2) + 117*s - 39))) + 143*f*k1**2*k2**2*(-12*Pk2*b2*k2**2*(7*r + 7*s - 5) + b1**2*k2**2*(32*Pk2 + 23*Pkd2*k2*s) - 2*b1*(2*k1**2*(Pk2*(2*C*(r - 6*s - 1) + 3*K*s - 5*r + 14) + Pkd2*k2*(s*(7*C - 3*K - 1) - 3)) + k2**2*(Pk2*(C*(-44*r - 48*s + 64) + 2*K*(8*r + 19*s - 14) + 87*r + 62*s - 71) + Pkd2*k2*(24*C*s + K*(2 - 13*s) - 9))) - 4*g2*(-6*Pk2*k1**2*s - 2*Pk2*k2**2*(8*r + 19*s - 14) + 6*Pkd2*k1**2*k2*s + Pkd2*k2**3*(13*s - 2))))/(45045*d*k1*k2**2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1**2*k2*st**5*(-4*Pk2 + Pkd2*k2)*(-143*b1*(K - 1)*(2*s - 1) + 3*f**2*(226*s - 63) + f*(26*C - 26)*(3*s - 1) + 286*g2*(2*s - 1))/(9009*d*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(33*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(-2*f**2*(55*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(83*s - 35)) - 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(4*s - 2) + 15*s - 6) + 10*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(-f*k1**2*(4*Pk2 - Pkd2*k2)*(135*s - 56) + 2*f*k2**2*(Pk2*(4*C*(83*s - 35) + 21*r - 166*s + 85) - Pkd2*k2*(2*C - 1)*(83*s - 35)) + k2**2*(-2*Pk2 + Pkd2*k2)*(-110*b2 + 220*g2)*(2*s - 1)))/(1155*d*k2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st*(33*b1**2*(3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(4*Pk2*(C*s - K*s + K + 2*f*s + f + 2*s - 1) - 2*Pkd2*k2*(C*s + 2*f*s + f + s))) + 11*b1*(24*Pk2*g2*k1**2*(s - 1) + 9*Pkd2*b2*k2**3*s + 6*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(-8*C*(s - 2) - 12*K*(s - 1) + 6*r - 11*s + 8) + Pkd2*k2*(6*C*(s - 1) + 6*K*(s - 1) + 5*s - 6)) + k2**2*(2*Pk2*(8*C*(r - 2) - 9*K*r + 5*r + 8) + 3*Pkd2*k2*(4*C - 6*K*s + 3*K - 2))) - 18*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-33*b2*(2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*(k1**2*(Pk2*(-188*C*s + 180*C + 89*r - 110*s + 29) + Pkd2*k2*(94*C*s - 90*C + 85*s - 43)) - 6*k2**2*(Pk2*(92*C*r - 60*C - 68*r + 30) + Pkd2*k2*(22*C - 11)*(2*s - 1))) + 66*g2*(2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(-429*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 13*b1*(2*f**2*k2**2*(-55*Pk2*k2**2*(r - 1) + k1**2*(543*Pk2*r + 211*Pk2*(s - 1) + Pkd2*k2*(166*s - 105))) + 11*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(4*C*(r + 2*s - 1) - 2*K*(11*r - 15*s + 6) + 51*r + 14*s - 7) + Pkd2*k2*(K*(19 - 44*s) + s*(29 - 4*C) - 11)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 66*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(2860*Pk2*b2*k2**4*(2*r + 2*s - 1) + 2*f**2*k1**2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(736*s - 275) - 455*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 13*f*(k1**4*(14*C - 14)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k1**2*k2**2*(Pk2*(4*C*(93*r - 230*s + 64) - 678*r + 344*s + 38) + Pkd2*k2*(C*(496*s - 202) - 361*s + 146)) + 2*k2**4*(Pk2*(-4*C*(104*r + 83*s - 33) + 229*r + 166*s - 51) - Pkd2*k2*(2*C - 1)*(83*s - 35))) + 286*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(-4*Pk2*(11*r - 15*s + 6) + Pkd2*k2*(19 - 44*s)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(15015*d*k2*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st*(33*b1**2*(-k1**4*s*(K - 1)*(2*Pk2 - Pkd2*k2) - 2*k1**2*k2**2*(2*Pk2*(C*(r + s - 1) + K*s - 2*K + f*(2*r + 2*s - 1) + 3*r + 2*s + 2) + Pkd2*k2*s*(-4*K + 3*f + 2)) + 3*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + b1*(198*Pk2*b2*k2**4*(r + s) + f**2*k1**2*(k1**2*(4*Pk2*(30*r - 17*s - 42) + Pkd2*k2*(94*s + 45)) + 66*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + 11*f*(k1**4*(2*Pk2*(-8*C*s + 2*K*(s - 2) + r + 7*s + 5) + Pkd2*k2*(8*C*s - 3*K*(s - 1) - 5*s - 3)) + k1**2*k2**2*(Pk2*(4*C*(4*r + 4*s - 3) - 6*K*(7*r + 2) + 52*r + 13*s - 14) + Pkd2*k2*(-6*K*(5*s - 3) + s*(22*C + 3) - 12)) + k2**4*(-2*Pk2*(4*C*(2*r - 3*s - 7) + 9*K*(5*r + 4*s - 2) - 15*r + 6*s + 18) + 3*Pkd2*k2*(4*C*s - 6*K*s + 3*K - 2*s))) - 66*g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 4*k1**2*k2**2*(-Pk2*(s - 2) + 2*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(66*Pk2*b2*k2**2*(k1**2*(r + s - 2) - 3*k2**2*(2*r + 2*s - 1)) - 45*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*(4*k1**4*(Pk2*(2*C*(s - 15) + 10*r + 8*s + 27) + Pkd2*k2*(11 - 11*C)*(s - 1)) + k1**2*k2**2*(Pk2*(-4*C*(234*r + 73*s - 51) + 1085*r + 470*s - 335) + Pkd2*k2*(C*(262 - 434*s) + 349*s - 219)) - 6*k2**4*(2*Pk2*(2*C*(67*r + 44*s - 37) - 78*r - 44*s + 37) + Pkd2*k2*(22*C - 11)*(2*s - 1))) + 22*g2*(k1**4*(-4*Pk2*(s - 2) + 3*Pkd2*k2*(s - 1)) + 6*k1**2*k2**2*(Pk2*(7*r + 2) + Pkd2*k2*(5*s - 3)) + 9*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(4*Pk2 - Pkd2*k2)*(b1*(f*(47*s - 12) - 44*s + 22) + 2*f*(3*s - 1))/(693*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(3*f**2*(104*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(131*s - 36)) + 13*f*k2**2*(Pk2*b1*(94*r - 46) - 4*Pk2*(2*C*(3*r - 6*s + 1) - 9*r + 6*s + 1) + Pkd2*b1*k2*(47*s - 12) - Pkd2*k2*(8*C - 6)*(3*s - 1)) + 286*k2**2*(b1*(4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(2*s - 1) - 8*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2) - 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(9009*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*k1*st*(66*Pkd2*b1**3*k2**3*s - 11*b1**2*(Pk2*k1**2*s*(-14*f - 6) + 6*Pk2*k2**2*(2*C*(r - 1) + 2*K*s - 2*K - 4*f*r + 2*f + 3) + Pkd2*k1**2*k2*s*(7*f + 3) - 3*Pkd2*k2**3*(2*f + s*(-4*C + 4*K + 3))) - 11*b1*(-12*Pkd2*b2*k2**3*s + 4*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) + f*k1**2*(-Pk2*(3*s + 7) + Pkd2*k2*(s + 3)) + f*k2**2*(Pk2*(-4*C*(3*r + s + 1) + r*(12*K - 15) + 2*s + 9) + Pkd2*k2*(C*(12 - 26*s) + 6*K*(3*s - 2) + 13*s - 9)) + 24*g2*k2**2*(-Pk2*s + Pk2 + Pkd2*k2*s)) - 2*f*(f*(k1**2*(2*Pk2*(6*s - 13) - 11*Pkd2*k2*(s - 1)) + 2*k2**2*(Pk2*(68*C*r - 30*C - 67*r + 15) + Pkd2*k2*(22*C - 11)*(3*s - 2))) + k2**2*(33*b2 - 66*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(3465*d*k2**2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(11*b1**2*k1**2*k2**2*(-2*Pk2*(3*K*(r - 2*s + 2) + 4*f - 3*r - 3) + Pkd2*k2*(-6*K*(s - 1) + 4*f - 3)) + b1*k1**2*(f**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(135*s - 56) - 22*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) - 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(Pk2*(4*C*(2*r - 4*s + 1) + 38*K*s - 16*K + 17*r + 10*s - 3) + Pkd2*k2*(C*(8*s - 4) - 19*K*s + 8*K + 2*s))) + 132*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(8*C - 4)*(31*r - 14) - 7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(540*C*s - 224*C + 51*r - 208*s + 67) + Pkd2*k2*(-270*C*s + 112*C + 113*s - 45))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-11*b2 + 22*g2)*(19*s - 8)))/(1155*d*k1*k2**2*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(-858*b1*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + f**3*(-5*k1**6*(4*Pk2 - Pkd2*k2)*(261*s - 88) - 364*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) + 26*f**2*(Pk2*k2**6*(4 - 8*C)*(31*r - 14) + k1**4*k2**2*(-2*Pk2*(C*(-42*r + 66*s + 14) + 3*b1*(63*r + 63*s - 29) + 72*r - 15*s - 41) + 7*Pkd2*k2*(12*b1 + (4*C - 3)*(3*s - 1))) + k1**2*k2**4*(Pk2*(C*(728*r + 684*s - 456) + 44*b1*(9*r + 5*s - 5) - 327*r - 316*s + 229) + Pkd2*k2*(2*C*(91*s - 34) + 22*b1*(5*s - 2) - 69*s + 23))) - 143*f*k1**2*k2**2*(-12*Pk2*b2*k2**2*(11*r + 11*s - 5) + b1**2*k2**2*(16*Pk2 + 19*Pkd2*k2*s) - 2*b1*(k1**2*(Pk2*(6*K*s + r*(4*K - 22) - 28*s + 8) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + k2**2*(Pk2*(-4*C*(2*r + 4*s - 3) + 2*K*(64*r + 47*s - 22) - 49*r - 18*s + 7) + Pkd2*k2*(K*(31*s - 14) + s*(8*C - 12) + 3))) + 4*g2*(2*Pk2*k1**2*(2*r + 3*s) + 2*Pk2*k2**2*(64*r + 47*s - 22) + 2*Pkd2*k1**2*k2*(2*s - 1) + Pkd2*k2**3*(31*s - 14))))/(15015*d*k1*k2**2*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st*(-66*b1*k1**2*k2**2*(4*Pk2*b1**2*k2**2*(r + s - 1) + 12*Pk2*b2*k2**2*(r + s) + b1*(4*K*Pkd2*k2**3*s + 2*Pk2*k1**2*(r*(K - 4) + s*(2*K - 5)) + 2*Pk2*k2**2*(-4*C*(r + s - 1) + 2*K*(4*r + 5*s + 1) + r + 2*s - 3) + Pkd2*k1**2*k2*s*(2*K - 1)) - 4*g2*(Pk2*k1**2*(r + 2*s) + 2*Pk2*k2**2*(4*r + 5*s + 1) + Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*s)) - 30*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) - 2*f**2*(35*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) - 2*k1**4*k2**2*(2*Pk2*(C*(42*r + 40*s + 2) + 22*b1*r - 66*b1*s - 43*r - 36*s + 8) + 11*Pkd2*k2*(6*b1 + (4*C - 3)*(s - 1))) - 4*k1**2*k2**4*(Pk2*(C*(332*r + 264*s - 206) - 199*r - 132*s + 103) + Pkd2*k2*(22*C - 11)*(3*s - 2))) + 11*f*k2**2*(b1**2*k1**2*(k1**2*(20*Pk2*(r + s - 1) + 21*Pkd2*k2*s) - 6*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) - 2*b1*(Pk2*k2**4*(2 - 4*C)*(5*r - 4) + k1**4*(-Pk2*(4*C*(-4*r + s + 2) + 4*K*(2*r + s + 1) + 10*r - 5*s - 3) + Pkd2*k2*(-6*K*(s - 1) + s*(16*C - 9) - 3)) + k1**2*k2**2*(Pk2*(4*C*(r + 13*s - 1) - 12*K*(7*r + 6*s - 4) + 31*r - 19*s + 2) + 2*Pkd2*k2*(C*s - 9*K*s + 6*K + s))) + 4*k1**2*(Pk2*b2*(k1**2*(r + s + 1) + 6*k2**2*(3*r + 3*s - 2)) - 2*g2*(k1**2*(2*Pk2*(2*r + s + 1) + 3*Pkd2*k2*(s - 1)) + 3*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2))))))/(3465*d*k1*k2**2*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**4*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)/(1287*d*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(b1*(f*(-11*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*k2**2*(K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*Pk2*r)) + k2**2*(11*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - f*(Pk2*(12*C*s - 4*C + 3*r - 6*s + 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) - 22*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(693*d*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(f**2*(27*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 13*k1**2*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 13*f*(11*Pk2*b1*k2**4*(r - 1) + Pk2*k2**4*(-12*C*(2*r + s - 1) + 15*r + 6*s - 7) + Pkd2*k2**5*(C*(2 - 6*s) + 3*s - 1) + b1*k1**2*k2**2*(35*Pk2*r + 23*Pk2*(s - 1) + 3*Pkd2*k2*(2*s - 1))) + 143*k2**4*(2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(9009*d*k2*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(-11*b1**2*(-3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) - 11*b1*(f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) - f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(4*K*s - 2*K + 2*r + 7*s - 2)) + k2**2*(2*Pk2*(4*C*r - 2*C - 3*K*r + r + 1) + Pkd2*k2*(-2*C - 6*K*s + 3*K + 1))) + 3*k2**2*(-4*Pk2*g2*r - Pkd2*b2*k2*s + 2*Pkd2*g2*k2)) + f*(11*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 3*k2**2*(-2*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + f*k1**2*(Pk2*(84*C*s - 28*C + 21*r - 33*s - 7) + Pkd2*k2*(7 - 14*C)*(3*s - 1)) + f*k2**2*(2*Pk2*(84*C*r - 28*C - 53*r + 14) + Pkd2*k2*(22*C - 11)*(2*s - 1)) - 22*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 66*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))))/(1155*d*k2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st*(3*Pkd2*b1**3*k1**2*k2*s + 3*b1**2*(K*Pkd2*k1**2*k2*s - Pk2*k1**2*(r + 2*s) + Pk2*k2**2*(-4*C*(r + s - 1) + 3*r + 2*s - 3) + Pkd2*k2**3*s*(1 - 2*C) + f*k1**2*(Pk2*(6*r - 4) + Pkd2*k2*(2*s + 1))) + b1*(Pkd2*k1**2*k2*s*(3*b2 - 6*g2) + f*k1**2*(Pk2*(-r + s + 2) + Pkd2*k2*(8*C*s - 3*K*s + 3*K - 4*s)) - f*k2**2*(2*C - 1)*(2*Pk2*(5*r - 1) + 3*Pkd2*k2)) + f*k1**2*(2*Pk2*f*r - 3*Pkd2*b2*k2*(s - 1) - Pkd2*f*k2*(4*C - 2)*(s - 1) + 6*Pkd2*g2*k2*(s - 1)))/(315*d*k2*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(11*b1**2*(f*(3*Pk2*k2**4*(r - 1) + k1**2*k2**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) + 3*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + b1*(f**2*k1**2*(k1**2*(6*Pk2*(3*r + 17*s - 2) - 7*Pkd2*k2*(6*s + 1)) - 11*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) - 11*f*k2**2*(k1**2*(K*Pkd2*k2*(2*s - 1) + Pk2*(2*K*(11*r + 16*s - 5) - 2*r - 7*s + 2)) + k2**2*(Pk2*(8*C*r + 8*C*s + 6*K*(5*r + 4*s - 2) - 12*r - 4*s + 1) + Pkd2*k2*(4*C*s + 6*K*s - 3*K - 2*s))) - 66*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) + f*(7*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*k2**2*(k1**2*(Pk2*(-4*C*(51*r + 39*s - 41) + 123*r + 87*s - 103) + Pkd2*k2*(7 - 14*C)*(3*s - 1)) + k2**2*(2*Pk2*(4*C*(43*r + 22*s - 18) - 97*r - 44*s + 36) + Pkd2*k2*(22*C - 11)*(2*s - 1))) + 22*k2**2*(-3*Pk2*b2*(k1**2*(3*r + 3*s - 1) + k2**2*(2*r + 2*s - 1)) + g2*(k1**2*(2*Pk2*(11*r + 16*s - 5) + Pkd2*k2*(2*s - 1)) + 3*k2**2*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))))/(1155*d*k2*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st*(12*Pk2*b1**3*k1**2*k2**2*(r + s - 1) + b1**2*(f*k1**2*(2*Pk2*k1**2*(r + s) + 3*Pk2*k2**2*(13*r + 10*s - 7) - 4*Pkd2*k1**2*k2*s + 9*Pkd2*k2**3*s) - 3*k2**2*(-K*Pkd2*k1**2*k2*s + Pk2*k1**2*(-8*K*r - 12*K*s + r + 2*s) + Pk2*k2**2*(4*C - 2)*(r + s - 1))) - b1*(2*f**2*k1**4*(Pk2*(5*r - 3) + Pkd2*k2*(2*s + 1)) + f*k2**2*(k1**2*(Pk2*(-4*C*(7*r + 6*s - 2) + 12*K*(r + s - 1) + 15*r + 11*s - 6) + Pkd2*k2*(3*K*(s - 1) + s*(4 - 8*C))) + k2**2*(Pk2*(4*C*(11*r + 6*s - 1) - 25*r - 12*s + 2) + Pkd2*k2*s*(6*C - 3))) + 6*k1**2*k2**2*(-3*Pk2*b2*(r + s) + g2*(8*Pk2*r + 12*Pk2*s + Pkd2*k2*s))) - 2*f*k1**2*k2**2*(3*Pk2*b2*(r + s - 1) + f*(Pk2*(8*C*(r + s - 1) - 5*r - 4*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1)) - 3*g2*(4*Pk2*(r + s - 1) + Pkd2*k2*(s - 1))))/(315*d*k2*k3**4)

        return (perm12+perm13+perm23)
    
    def l3m2(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -16*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f**2*k1*k2**2*st**4*(33*b1*(2*r + 2*s - 1) + f*(16*r + 16*s - 7))/(3465*d*k3**4) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k1*st**2*(-99*b1**2*k2**2*(r + s) + 11*b1*f*(k1**2*(r + s + 1) + 6*k2**2*(r + s - 1)) + f**2*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)))/(3465*d*k3**4) - 16*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f**2*k2**2*st**4*(-11*b1*r + f*(r - 4))/(3465*d*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f*st**2*(-33*b1**2*k2**2*r + 11*b1*f*(k1**2*r + k2**2*(r - 2)) + f**2*k1**2*(7*r - 6))/(3465*d*k3**2) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**5*f**2*k2**3*st**2*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(42*r + 42*s - 17))/(3465*d*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f**2*k2**2*st**2*(-11*b1*k1**2*(9*C*(r + s - 1) - 19*r - 19*s + 14) + 55*b1*k2**2*(2*r + 2*s - 1) + f*k1**2*(-3*C*(13*r + 13*s - 5) + 81*r + 81*s - 32) + f*k2**2*(42*r + 42*s - 17))/(3465*d*k1*k3**4) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f**2*k2**3*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(34*r + 34*s - 19))/(3465*d*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f*k2*st**2*(-198*b1**2*k2**2*(C - 1)*(r + s) + 11*b1*f*(3*k1**2*(2*C*(r + s + 1) + r + s - 5) + k2**2*(C*(70*r + 70*s - 38) - 21*r - 21*s + 9)) + f**2*(k1**2*(2*C*(19*r + 19*s - 9) + r + s + 3) + k2**2*(2*C*(150*r + 150*s - 67) - 93*r - 93*s + 51)))/(3465*d*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f**2*k2**2*st**4*(-11*b1*(k1**2*(6*C - 11) - 5*k2**2)*(2*r + 2*s - 1) + f*(k1**2*(-32*C*r - 32*C*s + 14*C + 66*r + 66*s - 33) + k2**2*(34*r + 34*s - 19)))/(3465*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*st**2*(-99*b1**2*k2**2*(r + s)*(k1**2*(3 - 2*C) + k2**2) - 11*b1*f*(k1**4*(2*C - 5)*(r + s + 1) + 6*k1**2*k2**2*(5*C*(r + s - 1) - 5*r - 5*s + 3) - 3*k2**4*(5*r + 5*s - 3)) + f**2*(k1**4*(-2*C*(7*r + 7*s - 1) + 33*r + 33*s - 11) + k1**2*k2**2*(-2*C*(72*r + 72*s - 37) + 151*r + 151*s - 86) + 33*k2**4*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f**2*k2*st**4*(11*b1*(3*k1**2 + k2**2*(10*C + 3))*(2*r + 2*s - 1) + f*(k1**2*(16*r + 16*s - 7) + k2**2*(C*(68*r + 68*s - 38) + 16*r + 16*s - 7)))/(3465*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st**2*(-99*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(r + s) + 11*b1*f*(k1**4*(r + s + 1) + k1**2*k2**2*(6*C*(r + s + 1) + 7*r + 7*s - 5) + 6*k2**4*(C*(5*r + 5*s - 3) + r + s - 1)) + f**2*(k1**4*(7*r + 7*s - 1) + k1**2*k2**2*(2*C*(19*r + 19*s - 9) + 40*r + 40*s - 23) + 11*k2**4*(6*C*(2*r + 2*s - 1) + 3*r + 3*s - 2)))/(3465*d*k2*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**5*f**2*k2*st**2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(55*b1*(2*s - 1) + f*(42*s - 25))/(3465*d*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**3*st**2*(4*Pk2 - Pkd2*k2)*(13*b1*(34*s - 15) + 15*f*(15*s - 7))/(9009*d*k1) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**2*st**2*(11*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(5*s - 4) - 25*s + 17) + k2**2*(Pk2*(-r*(52*C - 52) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(81*s - 60) - 123*s + 85) + k2**2*(Pk2*(-4*C*(51*r + 5) + 204*r - 84*s + 70) + Pkd2*k2*(42*s - 25))))/(3465*d*k1*k3**2) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**2*k2*st**4*(C - 1)*(-4*Pk2 + Pkd2*k2)*(55*b1*(2*s - 1) + f*(34*s - 15))/(3465*d*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st**2*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) - 39*b1*(2*f**2*(-5*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(42*s - 25)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) - 10*f**3*(-5*Pk2*k2**2*(5*r + 2) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(62*s - 35)) - 858*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1))/(45045*d*k1**2*k2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f*st**2*(-198*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) + 11*b1*f*(32*Pk2*k2**4*r + 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(s - 1) - 7*s + 6) + k1**2*k2**2*(-2*C*(Pk2*(24*r + 58*s - 32) + Pkd2*k2*(19 - 35*s)) + 68*Pk2*r + 6*Pk2*s + 3*Pkd2*k2*(2 - 5*s))) + f**2*(4*Pk2*k2**4*(30*r + 1) + k1**4*(4*Pk2 - Pkd2*k2)*(C*(46*s - 30) - 127*s + 90) + k1**2*k2**2*(Pk2*(-8*C*(33*r + 54*s - 40) + 300*r - 66*s + 76) + Pkd2*k2*(2*C*(150*s - 83) - 51*s + 6))))/(3465*d*k1**2*k2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**3*st**4*(4*Pk2 - Pkd2*k2)*(13*b1*(43*s - 18) + 9*f*(27*s - 10))/(9009*d*k1) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**2*st**4*(11*b1*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(12*C*(3*s - 1) - 70*s + 27) + k2**2*(-2*Pk2*(54*C*r - 18*C - 54*r + 34*s + 3) + Pkd2*k2*(34*s - 15))))/(3465*d*k1*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**2*(1144*Pk2*f*g2*k2**2*(2*r - 1) - 429*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(5*f*s - 4*f + 6*s - 6) + 2*k2**2*(2*Pk2*(2*K*r + 5*f*s - 2*f - 2*r + 3*s - 3) + Pkd2*k2*(-5*f*s + 2*f - 3*s + 3))) - 26*b1*(-264*Pk2*g2*k2**2*r + 3*f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + 4*k2**2*(12*Pk2*r - 14*Pk2*s + Pk2 + 7*Pkd2*k2*s - 3*Pkd2*k2)) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + k2**2*(Pk2*(4*K*r - 2*K - 4*r + 6*s - 4) - 3*Pkd2*k2*(s - 1)))) - 15*f**3*(4*Pk2*k2**2*(16*r - 65*s + 22) + 26*Pkd2*k2**3*(5*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(47*s - 28)))/(45045*d*k1*k2**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**2*(-33*b1**2*k2**2*(Pk2*k1**2*s*(8*C - 14) + Pk2*k2**2*r*(8 - 8*C) + Pkd2*k1**2*k2*s*(7 - 4*C) + 3*Pkd2*k2**3*s) + 11*b1*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(Pk2*(4*C*(r + 14*s - 18) - r - 14*s + 33) + 2*Pkd2*k2*(C*(18 - 20*s) + 11*s - 9)) + k2**4*(Pk2*(-64*C*r - 4*C + 55*r + 6*s + 1) + 3*Pkd2*k2*(5*s - 3))) + f**2*(k1**4*(4*Pk2 - Pkd2*k2)*(23*s - 15) + k1**2*k2**2*(Pk2*(4*C*(15*r + 72*s - 95) - 27*r - 8*s + 107) + Pkd2*k2*(-4*C*(57*s - 41) + 109*s - 62)) + 3*k2**4*(Pk2*(-8*C*(7*r + 5) + 71*r + 14*s + 1) + 11*Pkd2*k2*(2*s - 1))))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**4*(715*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 13*b1*f*(35*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(34*s - 15)) + 3*f**2*(15*Pk2*k2**2*(5*r + 2) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(74*s - 25)))/(45045*d*k1**2*k2) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**4*(11*b1*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + f*(Pk2*k2**4*(7 - 10*r) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(9*r + 16*s - 12) - 44*r + 22*s + 11) + Pkd2*k2*(C*(15 - 34*s) - 9*s + 3))))/(3465*d*k1**2*k2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**2*(1287*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 429*b1**2*(Pk2*k2**2*r*(2*f - 1) + k1**2*(Pk2*(8*K*(s - 1) + f*(3*r - 4*s + 4) - 3*r + 4*s - 4) + Pkd2*k2*(s - 1)*(-3*K + 2*f - 3))) + 13*b1*(99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*f**2*(2*Pk2*k2**2*(5*r + 2) + k1**2*(Pk2*(38*r - 86*s + 46) + Pkd2*k2*(43*s - 28))) + 11*f*(-Pk2*k2**2*(r - 2) + k1**2*(Pk2*(4*K*(s - 2) + r + 8*s - 6) + Pkd2*k2*(-3*K - 3)*(s - 1))) - 66*g2*k1**2*(8*Pk2 - 3*Pkd2*k2)*(s - 1)) + f*k1**2*(429*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + 15*f**2*(Pk2*(21*r - 104*s + 50) + 26*Pkd2*k2*(2*s - 1)) + 286*g2*(-4*Pk2*(s - 2) + 3*Pkd2*k2*(s - 1))))/(45045*d*k1**2*k2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**2*(-33*b1**2*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) + 11*b1*f*(Pk2*k2**4*(17*r + 2) + k1**4*(Pk2*(8*C*(s - 2) + 3*r + 16) + Pkd2*k2*(-6*C*(s - 1) + 5*s - 6)) + k1**2*k2**2*(2*Pk2*(8*C*r - 2*C*(s + 2) + 20*r + 5*s + 3) + Pkd2*k2*(6*C*(5*s - 3) + 5*s - 6))) + f**2*(66*Pk2*k2**4*r + k1**4*(Pk2*(64*C*s - 80*C + 7*r + 4*s + 66) + Pkd2*k2*(-46*C*s + 30*C + 33*s - 22)) + k1**2*k2**2*(Pk2*(24*C*(4*r - 5) + 191*r + 42*s + 14) + 11*Pkd2*k2*(6*C*(2*s - 1) + 3*s - 2))))/(3465*d*k1**2*k2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**3*st**6*(4*Pk2 - Pkd2*k2)*(13*b1*(3*s - 1) + 3*f*(4*s - 1))/(3003*d*k1) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**4*(11*b1*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + f*(Pk2*k2**2*(12*C*(3*r - 1) - 18*r + 2*s + 9) + k1**2*(12*C*Pkd2*k2*(1 - 3*s) + Pk2*(72*C*s - 24*C - 18*r + 2*s + 9))))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**4*(286*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*b1*f*(12*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(54*r - 19*s + 10) + Pkd2*k2*(19*s - 16))) + 3*f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(56*r - 65*s + 38) + 13*Pkd2*k2*(5*s - 2))))/(45045*d*k1*k2**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**2*(44*Pk2*f*k2**2*(b2 - 2*g2)*(2*r - 1) - 66*b1**3*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - 11*b1**2*(k1**2*(2*Pk2*f*(s - 6) + 6*Pk2*(s - 1) - Pkd2*f*k2*(s - 6)) + 2*k2**2*(Pk2*(-16*f*r + 2*f + 3*s - 3) + Pkd2*f*k2*(3 - 7*s))) + 2*b1*f*(k1**2*(Pk2*f*(44 - 36*s) + 11*Pk2*(s + 1) + 2*Pkd2*f*k2*(9*s - 11)) + k2**2*(6*Pk2*f*(8*r + 1) + 11*Pk2*(K*(4*r - 2) + 4*r + s - 1) + 11*Pkd2*f*k2*(3*s - 1))) - 5*f**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2))/(3465*d*k1*k2**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**2*(-33*b1**2*(Pk2*k2**4*(2*r + s) + k1**2*k2**2*(4*C*Pkd2*k2*s + Pk2*(2*r + s))) + 11*b1*f*(Pk2*k1**4*(s + 1) + Pk2*k2**4*(C*(8*r - 4) + 5*r + s + 2) + k1**2*k2**2*(2*C*Pkd2*k2*(5*s - 6) + Pk2*(12*C*r + 5*r + 2*s + 3))) + f**2*(Pk2*k1**4*(7*s + 5) + 33*Pk2*k2**4*r + k1**2*k2**2*(22*C*Pkd2*k2*(3*s - 2) + Pk2*(60*C*r - 20*C + 33*r + 7*s + 5))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**4*f**2*k2**2*st**2*(C - 1)*(11*b1*r + f*(7*r - 6))/(1155*d*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**3*k2*st**2*(91*b1*r + 5*f*(11*r - 6))/(9009*d*k1) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**2*k2*st**2*(11*b1*r + f*(7*r - 6))*(k1**2*(3 - 2*C) + k2**2)/(1155*d*k1*k3**2) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**2*k2**2*st**4*(C - 1)*(-11*b1*r + f*(r - 4))/(3465*d*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st**2*(429*b1**2*r*(K + 2*f - 1) + 13*b1*(18*f**2*(7*r - 2) - 11*f*(K - 1)*(r - 2) - 66*g2*r) + 60*f**3*(11*r - 6) + 286*f*g2*(r - 2))/(45045*d) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f*st**2*(-33*b1**2*k2**2*r*(C - 1) - 11*b1*f*(-k1**2*r*(C - 4) + k2**2*(C*(5*r + 2) + 4*r - 2)) + f**2*(7*r - 6)*(k1**2*(C - 4) - k2**2*(6*C + 3)))/(3465*d*k3**2) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**3*k2*st**4*(13*b1*r + 3*f*(3*r - 4))/(9009*d*k1) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*k2*st**4*(k1**2 + k2**2)*(-11*b1*r + f*(r - 4))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st**2*(429*b1**2*r*(k1**2*(f - 1) + k2**2*(2*f - 1)) + 13*b1*f*(k1**2*(6*f*(7*r - 3) + 11*r - 22) + k2**2*(6*f*(7*r - 6) + 11*r - 22)) + 15*f**3*k1**2*(11*r - 6))/(45045*d*k1*k2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f*st**2*(-33*b1**2*k2**2*r*(k1**2 + k2**2) + 11*b1*f*(k1**4*r + 2*k1**2*k2**2*(6*C*r + r - 1) + k2**4*(r - 2)) + f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(7*r - 6))/(3465*d*k1*k2*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**2*st**4*(143*b1**2*r + 13*b1*f*(4 - 3*r) + 6*f**2*(4 - 3*r))/(45045*d) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f*st**2*(33*b1**3*r + 11*b1**2*(f*(2 - 4*r) + r*(3*K + 3)) + b1*(-3*f**2*(7*r - 6) - 11*f*(K + 1)*(r - 2) + r*(33*b2 - 66*g2)) - 11*f*(b2 - 2*g2)*(r - 2))/(3465*d)
        perm13 = 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct**2*f*st**2*(3*b1 + f)*(s - 1)/(105*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st**2*(18*b1*k1**2*(2*C - 1)*(s - 1) + 3*b1*k2**2*r + f*k1**2*(12*C - 6)*(s - 1) + f*k2**2*(r - 2))/(315*d*k1**2*k2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*st**2*(3*b1*(s - 1) + f*(C*(8*r - 4) - 4*r - s + 1))/(315*d*k1) + 32*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**5*st**2*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(42*r + 42*s - 17))/(3465*d*k3**6) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**5*f**2*k2**3*st**2*(C - 1)*(55*b1*(2*s - 1) + f*(42*s - 25))/(3465*d*k3**4) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**4*st**2*(65*b1*f*k2**2*(34*r + 34*s - 19) + 286*b1*k1**2*(C*(49*r + 49*s - 29) - 39*r - 39*s + 24) + 75*f**2*k2**2*(15*r + 15*s - 8) + 26*f*k1**2*(C*(207*r + 207*s - 83) - 165*r - 165*s + 66))/(45045*d*k1*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(55*b1*(2*s - 1) + f*(42*s - 25))/(3465*d*k1*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**2*st**2*(11*b1*(k1**2*(55*C*s - 32*C - 45*s + 27) + k2**2*(-26*C*r + 36*r + 10*s - 5)) + f*(k1**2*(C*(249*s - 160) - 207*s + 135) + k2**2*(-2*C*(51*r + 5) + 144*r + 42*s - 7)))/(3465*d*k1*k3**4) + 32*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**5*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(34*r + 34*s - 19))/(3465*d*k3**6) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**3*st**4*(C - 1)*(55*b1*(2*s - 1) + f*(34*s - 15))/(3465*d*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2**3*st**2*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(2*f**2*k2**2*(49*r + 49*s - 40) + 11*f*(k1**2*(C*(70*r + 70*s - 62) - 41*r - 41*s + 43) + 3*k2**2*(-6*C*(2*r + 2*s - 1) + K*s + r*(K + 11) + 11*s - 6)) - 198*g2*k2**2*(r + s)) + f*(-10*f**2*k2**2*(131*r + 131*s - 69) - 13*f*k1**2*(22*C*(13*r + 13*s - 5) - 163*r - 163*s + 61) + f*k2**2*(858*C - 858)*(2*r + 2*s - 1) + 858*g2*k2**2*(r + s)))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(-198*b1**2*k1**2*(C - 1)*(s - 1) + 11*b1*f*(k1**2*(34*C*s - 14*C - 29*s + 16) + 16*k2**2*r) + f**2*(k1**2*(4*C*(42*s - 25) - 165*s + 110) + 2*k2**2*(30*r + 1)))/(3465*d*k1**2*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f*k2*st**2*(-2574*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 13*b1*f*(15*f*k2**4*r - 11*k1**4*(2*C*(53*s - 37) - 71*s + 52) + 11*k1**2*k2**2*(C*(98*r + 22*s - 8) - 77*r - 11*s + 7)) + f**2*(25*f*k2**4*(5*r + 2) - 13*k1**4*(C*(538*s - 370) - 373*s + 260) + 13*k1**2*k2**2*(6*C*(62*r + 14*s + 15) - 309*r - 39*s - 71)))/(45045*d*k1**2*k3**4) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**4*st**4*(65*b1*f*k2**2*(43*r + 43*s - 25) + 286*b1*k1**2*(26*C - 21)*(2*r + 2*s - 1) + 45*f**2*k2**2*(27*r + 27*s - 17) + 26*f*k1**2*(6*C*(28*r + 28*s - 15) - 134*r - 134*s + 71))/(45045*d*k1*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(55*b1*(2*s - 1) + f*(34*s - 15))/(3465*d*k1*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**2*st**4*(11*b1*(k1**2*(24*C - 19)*(2*s - 1) + k2**2*(-16*C*r + 26*r + 10*s - 5)) + f*(k1**2*(172*C*s - 72*C - 138*s + 57) + k2**2*(-54*C*r + 18*C + 88*r + 34*s - 37)))/(3465*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2**2*st**2*(-429*b1**2*k1**2*k2**2*(f*(11*r + 11*s - 7) + (12 - 18*K)*(r + s)) - 26*b1*(3*f**2*k2**2*(4*k1**2*(7*r + 7*s - 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*k1**2*(2*k1**2*(2*C*(r + s - 8) + r + s + 10) + 3*k2**2*(-2*C*(15*r + 15*s - 8) + 3*K*r + 3*K*s + 22*r + 22*s - 13)) + 594*g2*k1**2*k2**2*(r + s)) + f*(15*f**2*(k1**2*k2**2*(9*r + 9*s + 3) - 26*k2**4*(5*r + 5*s - 3)) - 26*f*(2*k1**4*(C*(6*r + 6*s - 4) - 16*r - 16*s + 7) + 11*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) - 5148*g2*k1**2*k2**2*(r + s)))/(45045*d*k1*k3**6) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st**2*(-66*b1**2*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(4 - 4*C)) + 11*b1*f*(k1**2*(12*C - 6)*(3*s - 2) + k2**2*(8*C*r - 4*C + r - 6*s + 7)) + f**2*(2*k1**2*(6*C*(27*s - 20) - 104*s + 75) + 3*k2**2*(8*C*(4*r - 5) + r - 14*s + 19)))/(3465*d*k1*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*st**2*(858*b1**2*(k1**2*k2**2*(14*C - 11)*(r + s - 1) + k2**4*(f*(5*r + 5*s - 3) + r*(5 - 2*K) + 3*s)) + 13*b1*(6*f**2*k2**4*(43*r + 82*s - 40) + 11*f*(6*k1**4*(2*C*(7*s - 6) - 8*s + 7) + k1**2*k2**2*(4*C*(4*r + 8*s + 1) - 19*r - 44*s - 1) + 2*k2**4*(36*C*r - 2*K*r + K - 49*r - 15*s + 8)) + 264*g2*k2**4*r) + f*(30*f**2*k2**4*(24*r + 65*s - 45) + 13*f*(k1**4*(4*C*(127*s - 90) - 300*s + 210) + k1**2*k2**2*(4*C*(45*r + 45*s - 107) - 131*r - 254*s + 275) + 66*k2**4*(r*(4*C - 6) - 2*s + 1)) + 572*g2*k2**4*(2*r - 1)))/(45045*d*k1*k3**4) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**3*st**4*(-715*b1**2*k2**2*(2*r + 2*s - 1) + 13*b1*f*k2**2*(58*r + 58*s - 35) + 286*b1*k1**2*(11*C - 7)*(2*r + 2*s - 1) + 6*f**2*k2**2*(96*r + 96*s - 59) + 26*f*k1**2*(33*C*(2*r + 2*s - 1) - 41*r - 41*s + 20))/(45045*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(11*b1*k1**2*(10*C - 7)*(2*s - 1) + 33*b1*k2**2*r + f*k1**2*(C*(68*s - 30) - 52*s + 21) + f*k2**2*(10*r - 7))/(3465*d*k1**2*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2*st**4*(13*b1*(35*f*k2**4*r + k1**4*(396*C - 242)*(2*s - 1) - 22*k1**2*k2**2*(12*C*(4*r + 2*s - 1) - 39*r - 20*s + 10)) + f*(45*f*k2**4*(5*r + 2) + 26*k1**4*(2*C*(70*s - 27) - 88*s + 33) - 26*k1**2*k2**2*(4*C*(34*r + 16*s - 13) - 110*r - 46*s + 41)))/(45045*d*k1**2*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2*st**2*(-429*b1**2*k2**2*(f*(k1**2 + 3*k2**2*(2*r + 2*s - 1)) + k1**2*(9*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(k1**2*(46*r + 46*s - 5) + 33*k2**2*(4*r + 4*s - 3)) + 11*f*k1**2*(k1**2*(10*C - 6)*(r + s + 1) - 3*k2**2*(-2*C*(12*r + 12*s - 7) + 3*K*r + 3*K*s + 14*r + 14*s - 9)) + 594*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*(k1**2*k2**2*(27*r + 27*s - 17) + 39*k2**4*(3*r + 3*s - 2)) + 13*f*(2*k1**4*(11*C*(3*r + 3*s - 1) - 20*r - 20*s + 6) + 11*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(r + s)))/(45045*d*k3**6) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**2*(2574*b1**3*k2**4*(r + s - 1) - 429*b1**2*(k1**2*k2**2*(20*C - 12)*(r + s - 1) + k2**4*(f*(-9*r - 12*s + 8) + r*(13 - 16*K) - s*(8*K - 8))) - 13*b1*(2*f**2*k2**4*(27*r + 159*s - 58) + 11*f*(k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*(4*C*(22*r + 11*s + 3) - 47*r - 30*s - 12) + k2**4*(36*C*(5*r + 2*s - 1) - 12*K*r - 4*K*s - 131*r - 50*s + 28)) - 66*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + f*(-15*f**2*k2**4*(63*r + 156*s - 110) - 13*f*(k1**4*(4*C - 2)*(23*s - 15) + k1**2*k2**2*(500*C*r + 272*C*(s - 1) - 271*r - 206*s + 126) + 22*k2**4*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) + 286*k2**4*(3*b2*(r + s) - 4*g2*(3*r + s))))/(45045*d*k2*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**2*(33*b1**2*(k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*(-4*C*(3*r + s - 1) + 9*r + 4*s - 4) + k2**4*r*(2*f - 1)) + b1*f*k2**2*(-22*k1**2*(2*C*(8*r - s + 1) - 8*r - s - 1) + k2**2*(6*f*(5*r + 2) + 187*r + 22)) + f**2*(-k1**4*(4*C - 2)*(23*s - 15) + k1**2*k2**2*(C*(120 - 228*r) + 107*r + 42*s - 46) + 66*k2**4*r))/(3465*d*k1**2*k2*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**3*k2**6*st**6*(13*b1*(3*r + 3*s - 2) + 3*f*(4*r + 4*s - 3))/(3003*d*k1*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2**2*st**4*(1144*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(-2*f*k1**2*k2**2*(4*r + 4*s + 1) - 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(2*r + 2*s - 1)) + f*(-6*f*k1**2*k2**2*(42*r + 42*s - 25) + 39*f*k2**4*(5*r + 5*s - 3) - k1**4*(52*C - 26)*(16*r + 16*s - 7)))/(45045*d*k1*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*st**4*(44*b1*k1**2*(2*C - 1)*(2*s - 1) + 11*b1*k2**2*(4*r + 2*s - 1) + f*k1**2*(24*C - 12)*(3*s - 1) + f*k2**2*(12*C*(3*r - 1) - 2*s - 3))/(3465*d*k1*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*st**4*(286*b1**2*k2**4*(4*r + 4*s - 3) + 13*b1*(f*k2**4*(72*r + 91*s - 57) + k1**4*(88*C - 44)*(2*s - 1) - 11*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9)) + f*(3*f*k2**4*(84*r + 65*s - 21) + k1**4*(312*C - 156)*(3*s - 1) - 13*k1**2*k2**2*(4*C*(23*r + 14*s - 5) - 64*r - 26*s + 19)))/(45045*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k1*st**2*(143*b1**2*k2**2*(18*K*k1**2*(r + s) + 2*f*k1**2*(r + s + 1) + 3*f*k2**2*(9*r + 9*s - 5)) - 26*b1*(f**2*k2**2*(k1**2*(r + s + 3) - 11*k2**2) + 11*f*k1**2*(k1**2*(2*C - 1)*(r + s + 1) - 3*k2**2*(C*(-6*r - 6*s + 4) + K*s + r*(K + 3) + 3*s - 2)) + 198*g2*k1**2*k2**2*(r + s)) - f*(5*f**2*k2**2*(2*k1**2*(11*r + 11*s - 5) + 13*k2**2*(9*r + 9*s - 7)) + f*k1**2*(52*C - 26)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(r + s)))/(45045*d*k3**6) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**2*(-11*b1**2*(3*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(-2*f*(4*r + 9*s - 5) + 6*r + 3*s)) + b1*f*(k1**2*(44*C - 22)*(s - 2) + k2**2*(-44*K*r + 22*K + f*(48*r + 66*s - 38) + 55*r + 11*s + 22)) + f*(f*k1**2*(C*(20 - 60*r) + 30*r + 7*s - 5) + 33*f*k2**2*r - k2**2*(22*b2 - 44*g2)*(2*r - 1)))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**2*(1716*b1**3*k1**2*k2**2*(r + s - 1) - 143*b1**2*(-6*f*k2**4*(3*r + 3*s - 2) + k1**4*(12*C - 6)*(r + s - 1) + k1**2*k2**2*(-36*K*r - 24*K*s + f*(-22*r - 31*s + 19) + 6*r + 3*s)) + 13*b1*(2*f**2*k2**2*(2*k1**2*(18*r + 3*s - 7) + 11*k2**2*(3*r + 3*s - 2)) - 11*f*k1**2*(k1**2*(4*C*(4*r + s + 3) - 8*r - 3*s - 7) + k2**2*(12*C*(6*r + 3*s - 2) - 2*K*(4*r + 2*s + 1) - 41*r - 19*s + 10)) + 66*k1**2*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) - f*k1**2*(5*f**2*k2**2*(34*r + 117*s - 93) + 13*f*(k1**2*(4*C*(29*r + 14*s - 7) - 58*r - 35*s + 9) + 11*k2**2*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) + 286*k2**2*(-3*b2*(r + s) + g2*(8*r + 4*s + 2))))/(45045*d*k1*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct**2*f*k2**2*st**2*(3*b1 + f)*(r + s - 1)/(105*d*k1*k3) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2*st**2*(b1*(9*C - 6) + f*(3*C - 1))*(r + s - 1)/(315*d*k3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*st**2*(r + s - 1)*(3*b1**2*k2**2 + 2*b1*f*k2**2 + b1*k1**2*(3 - 6*C) + f*k1**2*(2*C - 1))/(315*d*k1*k3) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**5*f**2*k2**5*st**2*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(42*r + 42*s - 17))/(3465*d*k3**5) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(55*b1*(2*r + 2*s - 1) + f*(42*r + 42*s - 17))/(3465*d*k1*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**4*st**2*(65*b1*f*k2**2*(34*r + 34*s - 19) + 286*b1*k1**2*(C*(49*r + 49*s - 29) - 39*r - 39*s + 24) + 75*f**2*k2**2*(15*r + 15*s - 8) + 26*f*k1**2*(C*(207*r + 207*s - 83) - 165*r - 165*s + 66))/(45045*d*k1*k3**5) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**5*st**4*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(34*r + 34*s - 19))/(3465*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(-198*b1**2*(C - 1)*(r + s - 1) + 11*b1*f*(2*C*(17*r + 17*s - 7) - 23*r - 23*s + 13) + f**2*(4*C*(42*r + 42*s - 17) - 123*r - 123*s + 49))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f*k2**3*st**2*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(2*f**2*k2**2*(49*r + 49*s - 40) + 11*f*(k1**2*(C*(70*r + 70*s - 62) - 41*r - 41*s + 43) + 3*k2**2*(-6*C*(2*r + 2*s - 1) + K*s + r*(K + 11) + 11*s - 6)) - 198*g2*k2**2*(r + s)) + f*(-10*f**2*k2**2*(131*r + 131*s - 69) - 13*f*k1**2*(22*C*(13*r + 13*s - 5) - 163*r - 163*s + 61) + f*k2**2*(858*C - 858)*(2*r + 2*s - 1) + 858*g2*k2**2*(r + s)))/(45045*d*k3**5) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(55*b1*(2*r + 2*s - 1) + f*(34*r + 34*s - 19))/(3465*d*k1*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**4*st**4*(65*b1*f*k2**2*(43*r + 43*s - 25) + 286*b1*k1**2*(26*C - 21)*(2*r + 2*s - 1) + 45*f**2*k2**2*(27*r + 27*s - 17) + 26*f*k1**2*(6*C*(28*r + 28*s - 15) - 134*r - 134*s + 71))/(45045*d*k1*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(-33*b1**2*(k1**2*(14*C - 11)*(r + s - 1) + k2**2*(f*(5*r + 5*s - 3) + 3*r + 3*s)) + b1*f*(11*k1**2*(8*C*(r + s - 1) + r + s + 5) + 3*k2**2*(f*(-27*r - 27*s + 17) + 55*r + 55*s - 33)) + f**2*(k1**2*(6*C*(13*r + 13*s - 5) - 20*r - 20*s + 6) + 33*k2**2*(2*r + 2*s - 1)))/(3465*d*k1*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**2*st**2*(429*b1**2*k1**2*k2**2*(f*(11*r + 11*s - 7) + (12 - 18*K)*(r + s)) + 26*b1*(3*f**2*k2**2*(4*k1**2*(7*r + 7*s - 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*k1**2*(2*k1**2*(2*C*(r + s - 8) + r + s + 10) + 3*k2**2*(-2*C*(15*r + 15*s - 8) + 3*K*r + 3*K*s + 22*r + 22*s - 13)) + 594*g2*k1**2*k2**2*(r + s)) + f*(-15*f**2*(k1**2*k2**2*(9*r + 9*s + 3) - 26*k2**4*(5*r + 5*s - 3)) + 26*f*(2*k1**4*(C*(6*r + 6*s - 4) - 16*r - 16*s + 7) + 11*k1**2*k2**2*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 5148*g2*k1**2*k2**2*(r + s)))/(45045*d*k1*k3**5) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(11*b1*(5*C - 4)*(2*r + 2*s - 1) + f*(C*(34*r + 34*s - 19) - 25*r - 25*s + 13))/(3465*d*k3**3) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**3*st**4*(-715*b1**2*k2**2*(2*r + 2*s - 1) + 13*b1*f*k2**2*(58*r + 58*s - 35) + 286*b1*k1**2*(11*C - 7)*(2*r + 2*s - 1) + 6*f**2*k2**2*(96*r + 96*s - 59) + 26*f*k1**2*(33*C*(2*r + 2*s - 1) - 41*r - 41*s + 20))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(99*b1**3*k2**2*(r + s - 1) - 33*b1**2*(k1**2*(10*C - 6)*(r + s - 1) + k2**2*(f - (3*K - 3)*(r + s))) + b1*(f**2*k2**2*(-27*r - 27*s + 4) - 44*f*k1**2*(2*C*r + 2*C*s + C - r - s - 1) + 33*f*k2**2*(-6*C*(2*r + 2*s - 1) + K*s + r*(K + 8) + 8*s - 5) + k2**2*(99*b2 - 198*g2)*(r + s)) + f*(-2*f*k1**2*(C*(19*r + 19*s - 9) - 13*r - 13*s + 5) - 11*f*k2**2*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5) + k2**2*(33*b2 - 66*g2)*(r + s)))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2*st**2*(-429*b1**2*k2**2*(f*(k1**2 + 3*k2**2*(2*r + 2*s - 1)) + k1**2*(9*K - 3)*(r + s)) + 13*b1*(f**2*k2**2*(k1**2*(46*r + 46*s - 5) + 33*k2**2*(4*r + 4*s - 3)) + 11*f*k1**2*(k1**2*(10*C - 6)*(r + s + 1) - 3*k2**2*(-2*C*(12*r + 12*s - 7) + 3*K*r + 3*K*s + 14*r + 14*s - 9)) + 594*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*(k1**2*k2**2*(27*r + 27*s - 17) + 39*k2**4*(3*r + 3*s - 2)) + 13*f*(2*k1**4*(11*C*(3*r + 3*s - 1) - 20*r - 20*s + 6) + 11*k1**2*k2**2*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(r + s)))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**3*k2**6*st**6*(13*b1*(3*r + 3*s - 2) + 3*f*(4*r + 4*s - 3))/(3003*d*k1*k3**5) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(11*b1**2*k2**2*(4*r + 4*s - 3) - 3*b1*(f*k2**2*(-6*r - 6*s + 5) + k1**2*(22*C - 11)*(2*r + 2*s - 1)) - f*k1**2*(2*C - 1)*(16*r + 16*s - 7))/(3465*d*k1*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**2*st**4*(1144*b1**2*k1**2*k2**2*(2*r + 2*s - 1) - 13*b1*(-2*f*k1**2*k2**2*(4*r + 4*s + 1) - 11*f*k2**4*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(2*r + 2*s - 1)) + f*(-6*f*k1**2*k2**2*(42*r + 42*s - 25) + 39*f*k2**4*(5*r + 5*s - 3) - k1**4*(52*C - 26)*(16*r + 16*s - 7)))/(45045*d*k1*k3**5) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k1*st**2*(143*b1**2*k2**2*(18*K*k1**2*(r + s) + 2*f*k1**2*(r + s + 1) + 3*f*k2**2*(9*r + 9*s - 5)) - 26*b1*(f**2*k2**2*(k1**2*(r + s + 3) - 11*k2**2) + 11*f*k1**2*(k1**2*(2*C - 1)*(r + s + 1) - 3*k2**2*(C*(-6*r - 6*s + 4) + K*s + r*(K + 3) + 3*s - 2)) + 198*g2*k1**2*k2**2*(r + s)) - f*(5*f**2*k2**2*(2*k1**2*(11*r + 11*s - 5) + 13*k2**2*(9*r + 9*s - 7)) + f*k1**2*(52*C - 26)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(r + s)))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*st**2*(66*b1**3*k1**2*k2**2*(r + s - 1) - 11*b1**2*(-3*f*k2**4*(3*r + 3*s - 2) + k1**4*(6*C - 3)*(r + s - 1) - k1**2*k2**2*(9*K*(r + s) + 2*f*(r + s - 1))) + b1*(f**2*k2**2*(2*k1**2*(3*r + 3*s - 5) + 11*k2**2*(3*r + 3*s - 2)) - 11*f*k1**2*(k1**2*(4*C - 2) - 3*k2**2*(C*(-6*r - 6*s + 4) + K*s + r*(K + 3) + 3*s - 2)) + k1**2*k2**2*(99*b2 - 198*g2)*(r + s)) + f*k1**2*(-f*(2*C - 1)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) + k2**2*(33*b2 - 66*g2)*(r + s)))/(3465*d*k1*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*ct*f*k2*st**2*(3*b1*r - f*(r - 2))/(315*d*k1) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*b1*f*st**2*(2*C - 1)*(3*b1*r - f*(r - 2))/(315*d) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**4*f**2*k2**4*st**2*(C - 1)*(11*b1*r + f*(7*r - 6))/(1155*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(11*b1*r + f*(7*r - 6))/(1155*d*k1*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**3*st**2*(455*b1*f*k2**2*r + 429*b1*k1**2*r*(6*C - 5) + 25*f**2*k2**2*(11*r - 6) + f*k1**2*(234*C - 195)*(7*r - 6))/(45045*d*k1*k3**4) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**4*st**4*(C - 1)*(-11*b1*r + f*(r - 4))/(3465*d*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(C - 1)*(33*b1**2*r + 11*b1*f*(5*r + 2) + 6*f**2*(7*r - 6))/(3465*d*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f*k2**2*st**2*(-429*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 90*f**3*k2**2*(11*r - 6) + 26*f**2*(6*b1*k2**2*(7*r + 3) + k1**2*(19*C - 13)*(7*r - 6)) - 143*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(13 - 19*C) - b1*k2**2*(K - 1)*(r - 2) + 2*g2*k2**2*(r - 2)))/(45045*d*k3**4) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(-11*b1*r + f*(r - 4))/(3465*d*k1*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**3*st**4*(143*b1*k1**2*r*(3 - 4*C) + 15*f**2*k2**2*(3*r - 4) + 13*f*(5*b1*k2**2*r + k1**2*(4*C - 3)*(r - 4)))/(45045*d*k1*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k1*k2*st**2*(-429*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 45*f**3*k2**2*(11*r - 6) + 13*f**2*(54*b1*k2**2 + k1**2*(16*C - 9)*(7*r - 6)) - 143*f*(9*b1**2*k2**2*r + b1*k1**2*r*(9 - 16*C) + b1*k2**2*(-2*K*(r - 2) + r - 2) + 4*g2*k2**2*(r - 2)))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f*k2*st**2*(-33*b1**2*r*(k1**2*(4*C - 3) + k2**2*(1 - 2*f)) + b1*f*(-22*k1**2*(4*C*(r + 1) - 2*r - 3) + k2**2*(6*f*(7*r - 6) + 11*r - 22)) - f**2*k1**2*(12*C - 7)*(7*r - 6))/(3465*d*k1*k3**2) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(2*C - 1)*(-11*b1*r + f*(r - 4))/(3465*d*k3**2) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2**2*st**4*(143*b1*r*(b1*k2**2 + k1**2*(1 - 2*C)) + 9*f**2*k2**2*(3*r - 4) + 13*f*(2*b1*k2**2*(r + 2) + k1**2*(2*C - 1)*(r - 4)))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*k1**2*st**2*(-429*b1*k2**2*r*(K*b1 - 2*g2) + 5*f**3*k2**2*(11*r - 6) + 13*f**2*(2*b1*k2**2*(9 - 7*r) + k1**2*(2*C - 1)*(7*r - 6)) - 143*f*(-K*b1*k2**2*(r - 2) + b1*r*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(r - 2)))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f*st**2*(33*b1**3*k2**2*r + 11*b1**2*(2*f*k2**2*(r + 1) + r*(-6*C*k1**2 + 3*K*k2**2 + 3*k1**2)) + b1*(3*f**2*k2**2*(7*r - 6) - 11*f*(K*k2**2*(r - 2) + k1**2*(4*C - 2)) + k2**2*r*(33*b2 - 66*g2)) + f*(-f*k1**2*(2*C - 1)*(7*r - 6) + k2**2*(-11*b2 + 22*g2)*(r - 2)))/(3465*d*k3**2)
        perm23 = 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**5*f**2*k1**2*k2**3*st**2*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(131*r + 131*s - 82) + f*(52*C - 52)*(42*r + 42*s - 17) - 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f**2*k1*k2**2*st**2*(-13*b1*(k1**2*(99*K - 99)*(r + s - 1) - 5*k2**2*(f*(34*r + 34*s - 19) + (22 - 44*K)*(2*r + 2*s - 1))) - 50*f**2*k1**2*(51*r + 51*s - 35) - 26*f*(k1**2*(3*C - 3)*(13*r + 13*s - 5) + k2**2*(4*C - 3)*(42*r + 42*s - 17)) + 286*g2*(9*k1**2*(r + s - 1) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) + 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f**2*k1**2*k2**3*st**4*(715*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(101*r + 101*s - 66) + f*(26*C - 26)*(34*r + 34*s - 19) - 1430*g2*(2*r + 2*s - 1))/(45045*d*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f*k2*st**2*(1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 13*b1*(2*f**2*k1**2*k2**2*(49*r + 49*s - 40) + 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s + 1) - 3*k1**2*k2**2*(-3*K + (2*C + 1)*(r + s))) + 198*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k1**2*(k1**2*(21*r + 21*s - 32) - 65*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(2*C - 2)*(19*r + 19*s - 9) - 3*k1**2*k2**2*(C*(8*r + 8*s + 2) + 5*r + 5*s - 7) - k2**4*(4*C - 2)*(42*r + 42*s - 17)) + 286*g2*(3*k1**4*(r + s + 1) + 9*k1**2*k2**2 - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f**2*k1*k2**2*st**4*(-858*b1*k1**2*(K - 1)*(2*r + 2*s - 1) + 65*b1*k2**2*(f*(43*r + 43*s - 25) + (22 - 44*K)*(2*r + 2*s - 1)) - 15*f**2*k1**2*(207*r + 207*s - 139) - 26*f*(k1**2*(2*C - 2)*(16*r + 16*s - 7) + k2**2*(4*C - 3)*(34*r + 34*s - 19)) + 572*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k1*st**2*(429*b1**2*(f*k2**4*(5*r + 5*s - 1) - 6*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) - 26*b1*(3*f**2*k2**2*(4*k1**2*(7*r + 7*s - 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(r + s + 1) - 3*k1**2*k2**2*(r*(2*C - 5*K + 2) + s*(2*C - 5*K + 2) - 1) - 3*k2**4*(4*C*s + K*(-9*r - 9*s + 3) + r*(4*C + 3) + 3*s - 3)) - 198*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(15*f**2*k1**2*(k1**2*(85*r + 85*s - 41) + 26*k2**2*(15*r + 15*s - 11)) + 26*f*(k1**4*(2*C - 2)*(7*r + 7*s - 1) + k1**2*k2**2*(2*C*(71*r + 71*s - 40) - 123*r - 123*s + 71) + 3*k2**4*(C*(62*r + 62*s - 34) - 53*r - 53*s + 28)) - 572*g2*(k1**4*(r + s + 1) + 15*k1**2*k2**2*(r + s) + 9*k2**4*(3*r + 3*s - 1))))/(45045*d*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**4*k1**2*k2**3*st**6*(71*r + 71*s - 50)/(3003*d*k3**6) - 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**2*k2*st**4*(f**2*(-99*k1**4*(4*r + 4*s - 3) + 195*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(k1**2*k2**2*(b1*(58*r + 58*s - 35) - (4*C - 3)*(16*r + 16*s - 7)) - k2**4*(2*C - 1)*(34*r + 34*s - 19)) - 143*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(45045*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*st**2*(-1287*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(11*r + 11*s - 5) + 13*k1**4*k2**2*(6*r + 6*s - 5)) - 13*f**2*(k1**4*k2**2*(b1*(46*r + 46*s - 5) - (4*C - 3)*(7*r + 7*s - 1)) + k1**2*k2**4*(-2*C*(85*r + 85*s - 53) + 33*b1*(4*r + 4*s - 3) + 118*r + 118*s - 75) + k2**6*(33 - 66*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(6*b1**2*k1**2*k2**2*(r + s) + b1*(k1**4*(2*K - 1)*(r + s + 1) + 3*k1**2*k2**2*(-4*C*(r + s) + K*(7*r + 7*s - 3) + 2) + 3*k2**4*(K*(6*r + 6*s - 3) - (2*C - 1)*(r + s))) - 2*g2*(2*k1**4*(r + s + 1) + 3*k1**2*k2**2*(7*r + 7*s - 3) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**3*k1*k2**2*st**6*(-13*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(35*r + 35*s - 23))/(3003*d*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**2*k1*st**4*(3*f**2*(4*k1**4*(r + s - 4) - 13*k1**2*k2**2*(15*r + 15*s - 11)) + 13*f*(b1*k1**2*k2**2*(8*r + 8*s + 2) + 11*b1*k2**4*(5*r + 5*s - 3) + k2**4*(4*C - 2)*(16*r + 16*s - 7)) + k2**4*(2*r + 2*s - 1)*(858*K*b1 - 286*b1**2 - 1716*g2))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*k1*st**2*(-33*b1**2*(6*K*k2**4*(r + s) - 2*f*k1**2*k2**2*(r + s) + f*k2**4*(3*r + 3*s - 1)) - 2*b1*f**2*(k1**4*(r + s + 3) - 11*k1**2*k2**2) + 22*b1*f*k2**2*(K*k1**2*(r + s + 1) + 3*K*k2**2*(3*r + 3*s - 2) + k2**2*(3 - 6*C)*(r + s)) + 396*b1*g2*k2**4*(r + s) + f*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) - 44*g2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1**2*f**2*k1*st**4*(r + s - 1)/(315*d*k3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct**2*f*k1*st**2*(b1*(5*f + 6) + 2*f)*(r + s - 1)/(105*d*k3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*st**2*(r + s - 1)*(9*K*b1*k2**2 + 3*b1*k1**2*(f - 1) + f*k1**2 + f*k2**2*(6*C - 3) + k2**2*(9*b2 - 18*g2))/(315*d*k2*k3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f**3*k1*k2**2*st**6*(3*r + 3*s - 2)/(231*d*k3**3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*k1*st**2*(r + s - 1)*(4*C*f - 6*K*b1 + 6*b1**2 - 9*b1*f - 6*b2 - 2*f + 12*g2)/(315*d*k3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**5*f**2*k1**2*k2**3*st**2*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(131*r + 131*s - 82) + f*(52*C - 52)*(42*r + 42*s - 17) - 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(5*b1*(f*(34*r + 34*s - 19) + 44*r + 44*s - 22) + 2*f*(42*r + 42*s - 17))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1*k2**2*st**2*(-13*b1*(k1**2*(99*K - 99)*(r + s - 1) - 5*k2**2*(f*(34*r + 34*s - 19) + (22 - 44*K)*(2*r + 2*s - 1))) - 50*f**2*k1**2*(51*r + 51*s - 35) - 26*f*(k1**2*(3*C - 3)*(13*r + 13*s - 5) + k2**2*(4*C - 3)*(42*r + 42*s - 17)) + 286*g2*(9*k1**2*(r + s - 1) + 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1**2*k2**3*st**4*(715*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(101*r + 101*s - 66) + f*(26*C - 26)*(34*r + 34*s - 19) - 1430*g2*(2*r + 2*s - 1))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(99*b1**2*k1**2*(K - 1)*(r + s - 1) + b1*(-110*K*f*k2**2*(2*r + 2*s - 1) + 2*f**2*k1**2*(91*r + 91*s - 82) + f*k1**2*(66*C + 33)*(r + s - 1) - 198*g2*k1**2*(r + s - 1)) + f*(3*f*k1**2*(13*r + 13*s - 5) - f*k2**2*(4*C - 2)*(42*r + 42*s - 17) + k2**2*(-110*b2 + 220*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f*k2*st**2*(1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 13*b1*(2*f**2*k1**2*k2**2*(49*r + 49*s - 40) + 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s + 1) - 3*k1**2*k2**2*(-3*K + (2*C + 1)*(r + s))) + 198*g2*k1**2*k2**2*(r + s)) + f*(10*f**2*k1**2*(k1**2*(21*r + 21*s - 32) - 65*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(2*C - 2)*(19*r + 19*s - 9) - 3*k1**2*k2**2*(C*(8*r + 8*s + 2) + 5*r + 5*s - 7) - k2**4*(4*C - 2)*(42*r + 42*s - 17)) + 286*g2*(3*k1**4*(r + s + 1) + 9*k1**2*k2**2 - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(5*b1*(f*(43*r + 43*s - 25) + 44*r + 44*s - 22) + 2*f*(34*r + 34*s - 19))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1*k2**2*st**4*(-858*b1*k1**2*(K - 1)*(2*r + 2*s - 1) + 65*b1*k2**2*(f*(43*r + 43*s - 25) + (22 - 44*K)*(2*r + 2*s - 1)) - 15*f**2*k1**2*(207*r + 207*s - 139) - 26*f*(k1**2*(2*C - 2)*(16*r + 16*s - 7) + k2**2*(4*C - 3)*(34*r + 34*s - 19)) + 572*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(-33*b1**2*(k1**2*(K - 1)*(r + s - 1) + k2**2*(6*K*(r + s - 1) + 2*f + 3)) + b1*(3*f**2*(k1**2*(15*r + 15*s - 1) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*(k1**2*(2*C*(r + s - 1) + r + s + 5) - 3*k2**2*(4*C*(r + s - 1) - 3*K*(r + s - 1) - 8*r - 8*s + 6)) + 66*g2*(k1**2 + 6*k2**2)*(r + s - 1)) + f*(f*k1**2*(19*r + 19*s - 9) + 3*f*k2**2*(2*C*(13*r + 13*s - 5) + 9*r + 9*s - 6) + k2**2*(99*b2 - 198*g2)*(r + s - 1)))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k1*st**2*(429*b1**2*(f*k2**4*(5*r + 5*s - 1) - 6*k2**2*(r + s)*(k1**2*(K - 1) + k2**2*(2*K - 1))) - 26*b1*(3*f**2*k2**2*(4*k1**2*(7*r + 7*s - 1) + 11*k2**2*(5*r + 5*s - 3)) - 11*f*(k1**4*(K - 1)*(r + s + 1) - 3*k1**2*k2**2*(r*(2*C - 5*K + 2) + s*(2*C - 5*K + 2) - 1) - 3*k2**4*(4*C*s + K*(-9*r - 9*s + 3) + r*(4*C + 3) + 3*s - 3)) - 198*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + f*(15*f**2*k1**2*(k1**2*(85*r + 85*s - 41) + 26*k2**2*(15*r + 15*s - 11)) + 26*f*(k1**4*(2*C - 2)*(7*r + 7*s - 1) + k1**2*k2**2*(2*C*(71*r + 71*s - 40) - 123*r - 123*s + 71) + 3*k2**4*(C*(62*r + 62*s - 34) - 53*r - 53*s + 28)) - 572*g2*(k1**4*(r + s + 1) + 15*k1**2*k2**2*(r + s) + 9*k2**4*(3*r + 3*s - 1))))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**4*k1**2*k2**3*st**6*(71*r + 71*s - 50)/(3003*d*k3**5) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(55*K*b1*k2**2*(2*r + 2*s - 1) - b1*k1**2*(23*f*(4*r + 4*s - 3) + 66*r + 66*s - 33) + f*k1**2*(-16*r - 16*s + 7) + f*k2**2*(2*C - 1)*(34*r + 34*s - 19) + k2**2*(55*b2 - 110*g2)*(2*r + 2*s - 1))/(3465*d*k3**3) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k2*st**4*(f**2*(-99*k1**4*(4*r + 4*s - 3) + 195*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(k1**2*k2**2*(b1*(58*r + 58*s - 35) - (4*C - 3)*(16*r + 16*s - 7)) - k2**4*(2*C - 1)*(34*r + 34*s - 19)) - 143*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2)))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*st**2*(-33*b1**2*(-3*K*k2**4 + k1**2*k2**2*(2*K*(r + s - 1) + f*(2*r + 2*s - 1) + 2*r + 2*s + 1)) + b1*(3*f**2*k1**2*(2*k1**2*(7*r + 7*s - 4) + 11*k2**2*(6*r + 6*s - 5)) + 11*f*(k1**4*(r + s + 1) + k1**2*k2**2*(4*C*(r + s - 1) - 3*K*(r + s + 1) + 3*r + 3*s - 3) + 3*k2**4*(2*C + K*(-6*r - 6*s + 3) - 1)) + 33*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + f*(f*(k1**4*(7*r + 7*s - 1) + k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 52*r + 52*s - 31) + k2**4*(33 - 66*C)*(2*r + 2*s - 1)) + k2**2*(-33*b2 + 66*g2)*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1))))/(3465*d*k2*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*st**2*(-1287*b1*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*(k1**6*(11*r + 11*s - 5) + 13*k1**4*k2**2*(6*r + 6*s - 5)) - 13*f**2*(k1**4*k2**2*(b1*(46*r + 46*s - 5) - (4*C - 3)*(7*r + 7*s - 1)) + k1**2*k2**4*(-2*C*(85*r + 85*s - 53) + 33*b1*(4*r + 4*s - 3) + 118*r + 118*s - 75) + k2**6*(33 - 66*C)*(2*r + 2*s - 1)) + 143*f*k2**2*(6*b1**2*k1**2*k2**2*(r + s) + b1*(k1**4*(2*K - 1)*(r + s + 1) + 3*k1**2*k2**2*(-4*C*(r + s) + K*(7*r + 7*s - 3) + 2) + 3*k2**4*(K*(6*r + 6*s - 3) - (2*C - 1)*(r + s))) - 2*g2*(2*k1**4*(r + s + 1) + 3*k1**2*k2**2*(7*r + 7*s - 3) + 9*k2**4*(2*r + 2*s - 1))))/(45045*d*k2*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**3*k1*k2**2*st**6*(-13*b1*k2**2*(3*r + 3*s - 2) + f*k1**2*(35*r + 35*s - 23))/(3003*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k1*st**4*(22*b1**2*k2**2 + b1*(-66*K*k2**2*(2*r + 2*s - 1) + 4*f*k1**2*(6*r + 6*s - 7) - 11*f*k2**2*(5*r + 5*s - 3)) - 2*k2**2*(33*b2*(2*r + 2*s - 1) + f*(2*C - 1)*(16*r + 16*s - 7) - 66*g2*(2*r + 2*s - 1)))/(3465*d*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k1*st**4*(3*f**2*(4*k1**4*(r + s - 4) - 13*k1**2*k2**2*(15*r + 15*s - 11)) + 13*f*(b1*k1**2*k2**2*(8*r + 8*s + 2) + 11*b1*k2**4*(5*r + 5*s - 3) + k2**4*(4*C - 2)*(16*r + 16*s - 7)) + k2**4*(2*r + 2*s - 1)*(858*K*b1 - 286*b1**2 - 1716*g2))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*k1*st**2*(33*b1**3*k2**2*(r + s - 1) - 11*b1**2*(-3*K*k2**2*(2*r + 2*s + 1) + 2*f*k1**2*(r + s - 1) - 3*f*k2**2) + 11*b1*(-K*f*k1**2*(r + s + 1) - 3*K*f*k2**2*(3*r + 3*s - 2) + 9*b2*k2**2*(r + s) + 3*f**2*k1**2*(r + s - 1) + f*k2**2*(2*C - 1)*(4*r + 4*s - 1) - 6*g2*k2**2*(2*r + 2*s + 1)) + f*(-11*b2*(k1**2*(r + s + 1) + 3*k2**2*(3*r + 3*s - 2)) - f*(2*C - 1)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) + 22*g2*(k1**2*(r + s + 1) + 3*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*k1*st**2*(-33*b1**2*(6*K*k2**4*(r + s) - 2*f*k1**2*k2**2*(r + s) + f*k2**4*(3*r + 3*s - 1)) - 2*b1*f**2*(k1**4*(r + s + 3) - 11*k1**2*k2**2) + 22*b1*f*k2**2*(K*k1**2*(r + s + 1) + 3*K*k2**2*(3*r + 3*s - 2) + k2**2*(3 - 6*C)*(r + s)) + 396*b1*g2*k2**4*(r + s) + f*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(7*r + 7*s - 1) + 11*k2**2*(3*r + 3*s - 2)) - 44*g2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(3*r + 3*s - 2))))/(3465*d*k3**5) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1**2*f**2*k1*st**4*(-4*Pk2 + Pkd2*k2)*(2*s - 1)/(315*d*k2**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct**2*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(b1*(5*f*s - 4*f + 6*s - 6) + 2*f*(s - 1))/(105*d*k2**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*st**2*(-9*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 9*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-12*C*(s - 1) + 9*b1*(r - 1) + r + 6*s - 8) + Pkd2*k2*(6*C - 3)*(s - 1)) + 18*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(315*d*k2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f**3*k1*st**6*(4*Pk2 - Pkd2*k2)*(3*s - 1)/(231*d*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st**2*(2*Pk2*f*(k1**2*(s + 1) + 2*k2**2*(-4*C*r + 2*C + 2*r - 1)) + 6*b1**2*k1**2*s*(2*Pk2 - Pkd2*k2) - 3*b1*k1**2*(2*Pk2*(3*f*s - 2*f + s - 1) + Pkd2*f*k2*(2 - 3*s)))/(315*d*k1*k2**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**5*f**2*k1**2*k2*st**2*(4*Pk2 - Pkd2*k2)*(1430*b1*(K - 1)*(2*s - 1) + 15*f**2*(131*s - 49) + f*(52*C - 52)*(42*s - 25) + 2860*g2*(1 - 2*s))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1*st**2*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(34*s - 15) + 44*s - 22) + 2*f*(42*s - 25))/(3465*d*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1*st**2*(13*b1*(k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(5*s - 4) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(Pk2*(68*r - 8) + Pkd2*k2*(34*s - 15)))) + 75*f**2*(26*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(15*s - 7)) + 26*f*(k1**2*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(27*s - 20) + k2**2*(-4*Pk2*(C*(30*r - 84*s + 73) - 51*r + 42*s - 52) - Pkd2*k2*(4*C - 3)*(42*s - 25))) + 286*g2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(5*s - 4) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1**2*k2*st**4*(4*Pk2 - Pkd2*k2)*(715*b1*(K - 1)*(2*s - 1) + 15*f**2*(101*s - 35) + f*(26*C - 26)*(34*s - 15) + 1430*g2*(1 - 2*s))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st**2*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(2*f**2*(55*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(42*s - 25)) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(s - 1) + 3*s - 2) + 10*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(3*f*k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + 2*f*k2**2*(-2*Pk2*(C*(84*s - 50) + 9*r - 42*s + 44) + Pkd2*k2*(2*C - 1)*(42*s - 25)) + k2**2*(-2*Pk2 + Pkd2*k2)*(110*b2 - 220*g2)*(2*s - 1)))/(3465*d*k2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f*st**2*(-1287*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 13*b1*(2*f**2*k2**2*(-55*Pk2*k2**2*(r - 1) + k1**2*(14*Pk2*(13*r + s - 1) + 3*Pkd2*k2*(28*s - 25))) + 11*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(s - 1) - 3*k1**2*k2**2*(-2*Pk2*(2*C*(r + 2*s - 1) - 2*K*(r - 3*s + 3) + 3*r - 2*s + 1) + Pkd2*k2*(K*(4*s - 5) + s*(2*C - 1) + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 198*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(-2860*Pk2*b2*k2**4*(2*r + 2*s - 1) + 10*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(62*s - 35) + 65*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 13*f*(k1**4*(2*C - 2)*(4*Pk2 - Pkd2*k2)*(23*s - 15) - 3*k1**2*k2**2*(2*Pk2*(4*C*(4*r - 23*s + 21) - 29*r + 52*s - 59) + Pkd2*k2*(C*(64*s - 58) - 37*s + 38)) - 2*k2**4*(2*Pk2*(6*C*(20*r + 14*s + 7) - 69*r - 42*s - 40) + Pkd2*k2*(2*C - 1)*(42*s - 25))) - 286*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s - 1) - 3*k1**2*k2**2*(4*Pk2*(r - 3*s + 3) + Pkd2*k2*(4*s - 5)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(45045*d*k2*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1*st**4*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(43*s - 18) + 44*s - 22) + 2*f*(34*s - 15))/(3465*d*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1*st**4*(13*b1*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(2*Pk2*(43*r - 7) + Pkd2*k2*(43*s - 18)))) + 45*f**2*(52*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 10)) + 26*f*(k1**2*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-4*Pk2*(C*(25*r - 68*s + 29) - 42*r + 34*s - 12) - Pkd2*k2*(4*C - 3)*(34*s - 15))) + 1144*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**2*(-33*b1**2*k1**2*k2**2*(-2*Pk2*(-3*K*(r - 2*s + 2) + 2*f + 3*r + 3) + Pkd2*k2*(6*K*(s - 1) + 2*f + 3)) + b1*k1**2*(3*f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(27*s - 20) + 11*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + k2**2*(Pk2*(-4*C*(r - 6*s + 7) - 30*K*s + 24*K + 7*r - 42*s + 37) + 3*Pkd2*k2*(-4*C*(s - 1) + 5*K*s - 4*K + 8*s - 6))) + 396*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(12 - 24*C)*(4*r - 5) + k1**4*(4*Pk2 - Pkd2*k2)*(23*s - 15) + 3*k1**2*k2**2*(Pk2*(-108*C*s + 80*C + 11*r + 24*s - 41) + Pkd2*k2*(54*C*s - 40*C - 5*s + 9))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(33*b2 - 66*g2)*(5*s - 4)))/(3465*d*k1*k2**2*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**2*(858*b1*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) - 15*f**3*(k1**6*(4*Pk2 - Pkd2*k2)*(47*s - 28) + 26*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) + 26*f**2*(Pk2*k2**6*(12 - 24*C)*(4*r - 5) + k1**4*k2**2*(2*Pk2*(2*C*(8*r - 55*s + 1) + b1*(45*r + 45*s - 93) + 3*r + 106*s + 4) + Pkd2*k2*(2*C*(13*s - 8) + 90*b1 - 3*s + 1)) + 3*k1**2*k2**4*(Pk2*(-4*C*(20*r + s - 18) + 22*b1*(9*r + 5*s - 5) + 139*r + 60*s - 81) + Pkd2*k2*(C*(4 - 34*s) + 11*b1*(5*s - 2) + 39*s - 13))) - 143*f*k1**2*k2**2*(-36*Pk2*b2*k2**2*(r + s - 1) + 3*b1**2*k2**2*(8*Pk2 + 5*Pkd2*k2*s) - 2*b1*(k1**2*(2*Pk2*(2*C*(r - 3*s - 1) - 3*K*s + r + 9*s + 8) + Pkd2*k2*(s*(8*C - 3*K - 2) - 3)) + k2**2*(Pk2*(-4*C*(5*r + 6*s - 7) - 6*K*(4*r - s + 2) + 83*r + 54*s - 43) + 3*Pkd2*k2*(K*(2 - 7*s) + s*(4*C + 3) - 3))) - 12*g2*(2*Pk2*k1**2*s + 2*Pk2*k2**2*(4*r - s + 2) + Pkd2*k1**2*k2*s + Pkd2*k2**3*(7*s - 2))))/(45045*d*k1*k2**2*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**4*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(71*s - 21)/(3003*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*st**4*(b1*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(34*s - 15) + 44*s - 22) + 55*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Pk2*f*(r - 1) - 2*Pk2*r)) + 6*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + f*k2**2*(-4*Pk2*(C*(34*s - 15) + 4*r - 17*s + 8) + Pkd2*k2*(2*C - 1)*(34*s - 15)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(2*s - 1))/(3465*d*k2*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*st**4*(3*f**2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(74*s - 25) + 65*k1**2*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 13*f*(k1**2*k2**2*(2*Pk2*(C*(-36*r + 76*s - 6) + 4*b1*(23*r + 6*s - 6) + 52*r - 42*s - 7) + Pkd2*k2*(b1*(68*s - 45) + (18 - 24*C)*(3*s - 1))) + k2**4*(Pk2*(-4*C*(50*r + 34*s - 17) - 55*b1*(r - 1) + 116*r + 68*s - 32) - Pkd2*k2*(2*C - 1)*(34*s - 15))) - 143*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(45045*d*k2*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**2*(33*b1**2*(3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(-K*s + K + 2*f*s + f + 3*s - 1) - Pkd2*k2*(2*f*s + f + 2*s))) + 11*b1*(12*Pk2*g2*k1**2*(s - 1) + 9*Pkd2*b2*k2**3*s + 3*f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) + f*(k1**2*(Pk2*(4*C*(s + 1) - 6*K*s + 6*K + 3*r - 8*s + 8) + Pkd2*k2*(3*K*(s - 1) + 5*s - 6)) + k2**2*(2*Pk2*(2*C*(r - 2) - 9*K*r + 8*r + 2) + 3*Pkd2*k2*(2*C - 6*K*s + 3*K - 1))) - 18*g2*k2**2*(-2*Pk2*r + Pkd2*k2)) + f*(-33*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*(k1**2*(Pk2*(-92*C*s + 60*C + 7*r + 22*s + 16) + Pkd2*k2*(46*C*s - 30*C + 10*s - 7)) - 3*k2**2*(4*Pk2*(19*C*r - 10*C - 15*r + 5) + Pkd2*k2*(22*C - 11)*(2*s - 1))) + 66*g2*(k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + 3*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**2*(33*b1**2*(k1**2*k2**2*(2*Pk2*(K*(s - 2) + f*(2*r + 2*s - 1) + 4*r + 3*s + 1) + Pkd2*k2*s*(-4*K + 3*f + 2)) - 3*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s + Pk2*f*(r - 1) - Pk2*r)) + b1*(-f**2*k1**2*(k1**2*(Pk2*(84*r - 8*s - 78) + Pkd2*k2*(46*s + 15)) + 33*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + 11*f*(2*Pk2*k1**4*(K*s + K - r - 2*s - 2) + k1**2*k2**2*(Pk2*(-4*C*(6*r + s - 4) + 6*K*(5*r + 3*s + 1) - 11*r - 16*s - 2) + Pkd2*k2*(3*K*(5*s - 3) + s*(3 - 16*C) + 6)) + k2**4*(Pk2*(4*C*(r - 3*s - 5) + 18*K*(5*r + 4*s - 2) - 21*r + 6*s + 12) + 3*Pkd2*k2*(-2*C*s + K*(6*s - 3) + s))) + 66*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + f*(66*Pk2*b2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1)) + 15*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*(2*Pk2*k1**4*(2*C*(7*s + 5) - 7*r - 21*s - 9) + k1**2*k2**2*(Pk2*(4*C*(59*r + 61*s - 7) - 257*r - 230*s + 56) + Pkd2*k2*(C*(86*s - 58) - 76*s + 51)) + 3*k2**4*(4*Pk2*(C*(63*r + 44*s - 32) - 37*r - 22*s + 16) + Pkd2*k2*(22*C - 11)*(2*s - 1))) - 22*g2*(2*Pk2*k1**4*(s + 1) + 3*k1**2*k2**2*(2*Pk2*(5*r + 3*s + 1) + Pkd2*k2*(5*s - 3)) + 9*k2**4*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**3*k1*st**6*(13*b1*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(26*Pk2*k2**2*(r - 1) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(3003*d*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**4*(22*b1**2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + b1*k1**2*(f*(-12*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 11*k2**2*(Pk2*(-12*r + 10*s + 4) + Pkd2*k2*(2 - 5*s))) - 22*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) - 2*k2**2*(Pk2*f*k2**2*(6 - 12*C)*(3*r - 1) - 22*b2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + f*k1**2*(Pk2*(-72*C*s + 24*C - 18*r + 38*s - 3) + Pkd2*k2*(12*C - 6)*(3*s - 1)) + 44*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(3465*d*k1*k2**2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**4*(3*f**2*(10*k1**6*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 13*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 13*f*(Pk2*k2**6*(12 - 24*C)*(3*r - 1) + b1*k1**4*k2**2*(-4*Pk2*(12*r + 12*s - 5) + 18*Pkd2*k2) + 11*b1*k1**2*k2**4*(2*Pk2*(9*r + 5*s - 5) + Pkd2*k2*(5*s - 2)) + 2*k1**2*k2**4*(Pk2*(8*C*(17*r + 7*s - 8) - 86*r - 26*s + 41) + Pkd2*k2*(12*C - 6)*(3*s - 1))) + 286*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1))))/(45045*d*k1*k2**2*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*k1*st**2*(33*Pkd2*b1**3*k2**3*s + 11*b1**2*(8*Pk2*f*k1**2*s - 3*Pk2*k2**2*(2*K*(s - 1) + f*(2 - 4*r) + 2*r + 1) - 4*Pkd2*f*k1**2*k2*s + 3*Pkd2*k2**3*(2*K*s + f)) - 11*b1*(f**2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 2) - f*(Pk2*k1**2*(s + 1) + k2**2*(Pk2*(4*C*(s + 1) - 6*K*r + 5*r - 2*s - 1) + Pkd2*k2*(8*C*s - 9*K*s + 6*K - 4*s))) + 6*k2**2*(-Pkd2*b2*k2*s + 2*g2*(-Pk2*s + Pk2 + Pkd2*k2*s))) + f*(f*(Pk2*k1**2*(7*s + 5) + k2**2*(Pk2*(-60*C*r + 20*C + 63*r - 10) + 11*Pkd2*k2*(-6*C*s + 4*C + 3*s - 2))) + k2**2*(-33*b2 + 66*g2)*(2*Pk2*r + Pkd2*k2*(3*s - 2))))/(3465*d*k2**2*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**2*(-66*b1*k1**2*k2**4*(2*K*b1*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) + 2*Pk2*b1**2*(r + s - 1) - Pk2*b1*(2*r + s) + 6*Pk2*b2*(r + s) - 4*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s)) - 5*f**3*k1**6*(2*Pk2 - Pkd2*k2)*(3*s - 2) - 2*f**2*(15*b1*k1**6*s*(-2*Pk2 + Pkd2*k2) + k1**4*k2**2*(Pk2*(-4*C*(7*r + 14*s + 4) - 22*b1*r + 66*b1*s + 14*r + 35*s + 13) - 33*Pkd2*b1*k2) + k1**2*k2**4*(Pk2*(-4*C*(81*r + 66*s - 49) + 195*r + 132*s - 98) + 11*Pkd2*k2*(C*(4 - 6*s) + 3*s - 2))) + 11*f*k2**2*(b1**2*k1**2*(4*k1**2*(2*Pk2*(r + s - 1) + 3*Pkd2*k2*s) - 3*k2**2*(2*Pk2*(6*r + 3*s - 2) + 3*Pkd2*k2*s)) + 2*b1*(Pk2*k1**4*(2*K*(r + 2*s + 2) - s - 1) + Pk2*k2**4*(4*C - 2)*(2*r - 1) + k1**2*k2**2*(Pk2*(-4*C*(8*r + 7*s - 3) + 6*K*(7*r + 6*s - 4) + 11*r + 13*s - 8) + Pkd2*k2*(K*(9*s - 6) + s*(4 - 8*C)))) + 4*k1**2*(Pk2*b2*k1**2*(r + s + 1) + 3*Pk2*b2*k2**2*(3*r + 3*s - 2) - 2*Pk2*g2*k1**2*(r + 2*s + 2) - 3*g2*k2**2*(2*Pk2*(7*r + 6*s - 4) + Pkd2*k2*(3*s - 2)))))/(3465*d*k1*k2**2*k3**4)

        return (perm12+perm13+perm23)
    
    def l3m3(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 16*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f**2*k2**3*st**5*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**4) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**4*Pk1*Pk2*f*k2*st**3*(-99*b1**2*k2**2*(r + s) + 11*b1*f*(3*k1**2*(r + s + 1) + 8*k2**2*(2*r + 2*s - 1)) + f**2*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1)))/(3465*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**4*Pk2*Pkd1*f**2*k1*k2*st**3*(55*b1*r + f*(15*r - 16))/(3465*d*k3**2) - 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**4*f**2*k2**3*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(23*r + 23*s - 8))/(3465*d*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**3*f**2*k2**2*st**3*(11*b1*k1**2*(3*C*(r + s + 1) + 7*r + 7*s - 8) + 55*b1*k2**2*(2*r + 2*s - 1) - f*k1**2*(C*(9*r + 9*s + 5) - 32*r - 32*s + 3) + f*k2**2*(23*r + 23*s - 8))/(3465*d*k1*k3**4) - 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f**2*k2**3*st**5*(C - 1)*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct**2*f*k2*st**3*(-198*b1**2*k2**2*(C - 1)*(r + s) + 11*b1*f*(k1**2*(6*C - 9)*(r + s + 1) + k2**2*(36*C*(2*r + 2*s - 1) - 35*r - 35*s + 13)) + f**2*(k1**2*(4*C*(3*r + 3*s - 2) - 3*r - 3*s + 13) + k2**2*(2*C*(68*r + 68*s - 27) - 35*r - 35*s + 27)))/(3465*d*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f**2*k2**2*st**5*(k1**2 + k2**2)*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k1*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk2*ct*f*st**3*(-99*b1**2*k2**2*(k1**2 + k2**2)*(r + s) + 11*b1*f*(3*k1**4*(r + s + 1) + k1**2*k2**2*(6*C*(r + s + 1) + 19*r + 19*s - 5) + 8*k2**4*(2*r + 2*s - 1)) + f**2*(k1**4*(6*r + 6*s - 4) - k1**2*k2**2*(2*C*(9*r + 9*s + 5) - 28*r - 28*s + 15) + 11*k2**4*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**4*f**2*k2*st**3*(C - 1)*(-4*Pk2 + Pkd2*k2)*(55*b1*(2*s - 1) + f*(23*s - 15))/(3465*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**3*st**3*(4*Pk2 - Pkd2*k2)*(13*b1*(25*s - 12) + 3*f*(41*s - 20))/(9009*d*k1) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**3*f**2*st**3*(11*b1*k1**2*(4*Pk2 - Pkd2*k2)*(C*(7*s - 8) - 17*s + 13) + 55*b1*k2**2*(-2*Pk2*(r*(6*C - 6) + 2*s - 1) + Pkd2*k2*(2*s - 1)) + f*k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(13*s - 8) - 62*s + 39) + f*k2**2*(-2*Pk2*(C*(62*r - 6) - 62*r + 23*s - 9) + Pkd2*k2*(23*s - 15)))/(3465*d*k1*k3**2) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f**2*k2*st**5*(C - 1)*(-4*Pk2 + Pkd2*k2)*(11*b1*(2*s - 1) + f*(3*s - 1))/(693*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + 13*b1*(2*f**2*(-20*Pk2*k2**2*r + 3*k1**2*(4*Pk2 - Pkd2*k2)*(23*s - 15)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 6*f**3*(5*Pk2*k2**2*(6 - 11*r) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(48*s - 25)) + 286*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1))/(45045*d*k1**2*k2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct**2*f*st**3*(198*b1**2*k1**2*k2**2*s*(C - 1)*(-2*Pk2 + Pkd2*k2) - 11*b1*f*(40*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(C*(4*s - 2) - 11*s + 10) + k1**2*k2**2*(-2*C*(Pk2*(6*r + 52*s - 28) + Pkd2*k2*(19 - 36*s)) + 32*Pk2*r + 10*Pk2*s - 25*Pkd2*k2*s + 10*Pkd2*k2)) + f**2*(26*Pk2*k2**4*(1 - 3*r) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(C*(6*s - 2) - 19*s + 10) + k1**2*k2**2*(2*Pk2*(4*C*(18*r + 19*s - 27) - 81*r + 55*s + 5) + Pkd2*k2*(C*(82 - 136*s) + 5*s + 2))))/(3465*d*k1**2*k2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**3*st**5*(4*Pk2 - Pkd2*k2)*(13*b1*(25*s - 12) + 3*f*(35*s - 12))/(9009*d*k1) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f**2*st**5*(11*b1*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s))))/(693*d*k1*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(1144*Pk2*f*g2*k2**2*(1 - 2*r) + 143*b1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(7*s - 8) + 18*s - 18) - 2*k2**2*(-2*Pk2*(f*(7*s - 4) + 9*r*(K - 1) + 9*s - 9) + Pkd2*k2*(7*f*s - 4*f + 9*s - 9))) + 26*b1*(-396*Pk2*g2*k2**2*r + f**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 8) + k2**2*(2*Pk2*(42*r - 71*s + 20) + Pkd2*k2*(71*s - 32))) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(4*K*Pk2*r - 2*K*Pk2 - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + 3*f**3*(8*Pk2*k2**2*(4*r - 65*s + 38) + 52*Pkd2*k2**3*(5*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(19*s - 8)))/(45045*d*k1*k2**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*ct*f*st**3*(-99*b1**2*k2**2*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + 11*b1*f*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(r + s - 5) + 3*r + 2*s + 19) + 2*Pkd2*k2*(C*(8 - 7*s) + 7*s - 4)) + k2**4*(Pk2*(-64*C*r - 4*C + 65*r + 10*s - 1) + Pkd2*k2*(16*s - 9))) + f**2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(12*C*(3*r + 8*s - 11) - 39*r + 64*s + 43) - Pkd2*k2*(6*C - 1)*(13*s - 8)) + k2**4*(Pk2*(-16*C*(2*r + 3) + 55*r + 30*s + 23) + 11*Pkd2*k2*(2*s - 1))))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*k2*st**5*(-22*b1*(C*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - Pk2*r*(k1**2 + k2**2)) - f*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2)))/(693*d*k1**2*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*f**2*st**5*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 39*b1*f*(2*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + f**2*(Pk2*k2**2*(9*r + 14) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(9009*d*k1**2*k2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(1287*b1**3*k1**2*s*(2*Pk2 - Pkd2*k2) + 143*b1**2*(Pk2*k2**2*r*(8*f - 9) + k1**2*(Pk2*f*(9*r - 20*s + 16) - 9*Pk2*(-2*K*(s - 1) + r - 2*s + 2) + 2*Pkd2*f*k2*(5*s - 4) - Pkd2*k2*(9*K + 9)*(s - 1))) + 13*b1*(99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1) + f**2*(2*Pk2*k2**2*(3*r + 10) + k1**2*(6*Pk2*(6*r - 13*s + 9) + 3*Pkd2*k2*(13*s - 10))) + 11*f*(Pk2*k2**2*(1 - 2*r) + k1**2*(Pk2*(4*K*s - 2*K - 2*r + 4*s - 1) - Pkd2*k2*(K + 1)*(2*s - 1))) - 198*g2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + f*k1**2*(143*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 3*f**2*(Pk2*(15*r - 104*s + 58) + 26*Pkd2*k2*(2*s - 1)) - 286*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(45045*d*k1**2*k2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*f*st**3*(-99*b1**2*(Pk2*k2**4*r + k1**2*k2**2*(2*C*Pkd2*k2*s + Pk2*r)) + 11*b1*f*(Pk2*k2**4*(16*r + 1) + k1**4*(2*C*Pkd2*k2*(1 - 2*s) + Pk2*(8*C*s - 4*C - 2*r + 5*s + 2)) + k1**2*k2**2*(2*C*Pkd2*k2*(16*s - 9) + Pk2*(36*C*r + 14*r + 5*s + 3))) + f**2*(22*Pk2*k2**4*r + 3*k1**4*(2*C*Pkd2*k2*(1 - 3*s) + Pk2*(12*C*s - 4*C - 3*r + 5*s + 3)) + k1**2*k2**2*(22*C*Pkd2*k2*(2*s - 1) + Pk2*(72*C*r - 24*C + 13*r + 15*s + 9))))/(3465*d*k1**2*k2*k3**2) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**3*f**2*k2**2*st**3*(C - 1)*(55*b1*r + f*(15*r - 16))/(3465*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**3*k2*st**3*(65*b1*r + f*(25*r - 16))/(3003*d*k1) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct**2*f**2*k2*st**3*(55*b1*r + f*(15*r - 16))*(-k1**2*(C - 2) + k2**2)/(3465*d*k1*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(715*b1**2*r + 13*b1*f*(45*r - 16) + 6*f**2*(25*r - 16))/(45045*d) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*ct*f**2*st**3*(k1**2 + k2**2*(4*C + 1))*(55*b1*r + f*(15*r - 16))/(3465*d*k3**2) + 10*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**3*k2*st**5*(13*b1*r + f*(3*r - 4))/(9009*d*k1) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd1*f**2*st**3*(715*b1**2*r*(k1**2 + 2*k2**2) + 26*b1*f*(k1**2*(15*r - 8) + k2**2*(15*r - 16)) + 3*f**2*k1**2*(25*r - 16))/(45045*d*k1*k2)
        perm13 = -4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*ct*f*st**3*(9*b1*(s - 1) + f*(2*s - 1))/(315*d*k1) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*b1*f*st**3*(18*b1*k1**2*(2*C - 1)*(s - 1) + 9*b1*k2**2*r + f*k1**2*(4*C - 2)*(2*s - 1) + f*k2**2*(2*r - 1))/(315*d*k1**2*k2) - 32*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**5*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(23*r + 23*s - 8))/(3465*d*k3**6) - 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**4*f**2*k2**3*st**3*(C - 1)*(55*b1*(2*s - 1) + f*(23*s - 15))/(3465*d*k3**4) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**4*st**3*(65*b1*f*k2**2*(25*r + 25*s - 13) + 286*b1*k1**2*(C*(37*r + 37*s - 23) - 27*r - 27*s + 18) + 15*f**2*k2**2*(41*r + 41*s - 21) + 26*f*k1**2*(C*(101*r + 101*s - 27) - 78*r - 78*s + 19))/(45045*d*k1*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(55*b1*(2*s - 1) + f*(23*s - 15))/(3465*d*k1*k3**2) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**3*f**2*k2**2*st**3*(11*b1*k1**2*(C*(47*s - 28) - 37*s + 23) - 55*b1*k2**2*(r*(6*C - 8) - 2*s + 1) + f*k1**2*(C*(131*s - 84) - 108*s + 69) + f*k2**2*(C*(6 - 62*r) + 85*r + 23*s - 14))/(3465*d*k1*k3**4) - 32*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**5*st**5*(C - 1)*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**6) - 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f**2*k2**3*st**5*(C - 1)*(11*b1*(2*s - 1) + f*(3*s - 1))/(693*d*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2**3*st**3*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(f**2*k2**2*(17*r + 17*s - 15) + 11*f*(k1**2*(C*(22*r + 22*s - 38) - 5*r - 5*s + 25) - k2**2*(18*C - K - 17)*(2*r + 2*s - 1)) - 198*g2*k2**2*(r + s)) + f*(-3*f**2*k2**2*(163*r + 163*s - 67) - 13*f*k1**2*(4*C*(29*r + 29*s - 1) - 61*r - 61*s - 7) + f*k2**2*(286*C - 286)*(2*r + 2*s - 1) + 286*g2*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(-198*b1**2*k1**2*(C - 1)*(s - 1) + 11*b1*f*(k1**2*(36*C*s - 18*C - 23*s + 16) + 20*k2**2*r) + f**2*(k1**2*(92*C*s - 60*C - 85*s + 54) + 13*k2**2*(3*r - 1)))/(3465*d*k1**2*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct**2*f*k2*st**3*(-2574*b1**2*k1**2*k2**2*(C - 1)*(r + s - 1) + 13*b1*f*(20*f*k2**4*r - 99*k1**4*(C*(8*s - 6) - 5*s + 4) + 11*k1**2*k2**2*(2*C*(41*r + 8*s - 3) - 49*r + 7*s - 1)) + f**2*(15*f*k2**4*(11*r - 6) - 13*k1**4*(2*C*(133*s - 81) - 181*s + 108) + 13*k1**2*k2**2*(2*C*(100*r + 16*s + 9) - 154*r + 5*s - 20)))/(45045*d*k1**2*k3**4) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**4*st**5*(13*b1*(f*k2**2*(25*r + 25*s - 13) + k1**2*(88*C - 66)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(35*r + 35*s - 23) + k1**2*(104*C - 78)*(3*r + 3*s - 2)))/(9009*d*k1*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(11*b1*(2*s - 1) + f*(3*s - 1))/(693*d*k1*k3**2) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f**2*k2**2*st**5*(11*b1*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + f*(k1**2*(4*C - 3)*(3*s - 1) + k2**2*(-6*C*r + 2*C + 9*r + 3*s - 4)))/(693*d*k1*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*k2**2*st**3*(143*b1**2*k1**2*k2**2*(f*(r + s - 5) - (36*K - 18)*(r + s)) + 52*b1*(f**2*k2**2*(k1**2*(30*r + 30*s - 9) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(k1**2*(9*C - 6)*(r + s + 1) + k2**2*(18*C - K - 13)*(2*r + 2*s - 1)) + 198*g2*k1**2*k2**2*(r + s)) + f*(3*f**2*k2**2*(k1**2*(15*r + 15*s - 47) + 52*k2**2*(5*r + 5*s - 3)) + 26*f*k1**2*(k1**2*(C*(6*r + 6*s - 26) - 9*r - 9*s + 17) + k2**2*(44*C - 33)*(2*r + 2*s - 1)) + 1144*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(45045*d*k1*k3**6) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(-198*b1**2*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 11*b1*f*(k1**2*(12*C - 6)*(s - 2) + k2**2*(8*C*r - 4*C - 9*r - 10*s + 9)) + f**2*(6*k1**2*(2*C*(13*s - 8) - 16*s + 9) + k2**2*(8*C*(7*r - 6) + 5*r - 30*s + 1)))/(3465*d*k1*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*ct*f*st**3*(286*b1**2*(k1**2*k2**2*(36*C - 27)*(r + s - 1) + k2**4*(f*(7*r + 7*s - 3) + r*(18 - 9*K) + 9*s)) + 13*b1*(2*f**2*k2**4*(67*r + 149*s - 81) + 11*f*(k1**4*(C*(44*s - 40) - 26*s + 22) + k1**2*k2**2*(8*C*(13*r + 11*s - 2) - 69*r - 74*s + 7) + 2*k2**4*(36*C*r - 2*K*r + K - 50*r - 16*s + 7)) + 396*g2*k2**4*r) + f*(12*f**2*k2**4*(6*r + 65*s - 21) + 13*f*(6*k1**4*(C*(38*s - 20) - 22*s + 11) + k1**2*k2**2*(4*C*(23*r + 36*s - 49) - 37*r - 144*s + 97) + 22*k2**4*(r*(4*C - 6) - 2*s + 1)) + 572*g2*k2**4*(2*r - 1)))/(45045*d*k1*k3**4) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2**3*st**5*(-286*b1**2*k2**2*(2*r + 2*s - 1) + 13*b1*(f*k2**2*(7*r + 7*s - 1) + k1**2*(44*C - 22)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(19*r + 19*s - 11) + k1**2*(52*C - 26)*(3*r + 3*s - 2)))/(9009*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(22*b1*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + f*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1)))/(693*d*k1**2*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f**2*k2*st**5*(26*b1*(3*f*k2**4*r + k1**4*(22*C - 11)*(2*s - 1) - 11*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + f*(f*k2**4*(9*r + 14) + k1**4*(52*C - 26)*(3*s - 1) - 13*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7)))/(9009*d*k1**2*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*k2*st**3*(429*b1**2*k2**2*(6*K*k1**2*(r + s) + f*k1**2*(r + s + 1) + 6*f*k2**2*(2*r + 2*s - 1)) - 26*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 1) + 11*k2**2*(4*r + 4*s - 3)) + 11*f*k1**2*(k1**2*(6*C - 3)*(r + s + 1) + k2**2*(18*C - K - 9)*(2*r + 2*s - 1)) + 198*g2*k1**2*k2**2*(r + s)) - f*(3*f**2*k2**2*(k1**2*(35*r + 35*s - 23) + 52*k2**2*(3*r + 3*s - 2)) + f*k1**2*(52*C - 26)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1)) + 572*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(2574*b1**3*k2**4*(r + s - 1) - 143*b1**2*(k1**2*k2**2*(36*C - 18)*(r + s - 1) - k2**4*(18*K*s + f*(29*r + 38*s - 26) + r*(36*K - 9))) - 13*b1*(2*f**2*k2**4*(12*r + 56*s - 27) + 11*f*(k1**4*(4*C - 2)*(2*s - 1) + k1**2*k2**2*(4*C*(17*r + 10*s + 3) - 32*r - 25*s - 8) + k2**4*(36*C*(4*r + 2*s - 1) - 4*K*(2*r + s - 1) - 88*r - 36*s + 17)) - 198*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + f*(-3*f**2*k2**4*(45*r + 156*s - 86) - 13*f*(k1**4*(12*C - 6)*(3*s - 1) + k1**2*k2**2*(4*C*(30*r + 21*s - 17) - 51*r - 57*s + 25) + 22*k2**4*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + 286*k2**4*(b2*(2*r + 2*s - 1) - 4*g2*(2*r + s - 1))))/(45045*d*k2*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pk3*f*st**3*(11*b1**2*(k1**4*(36*C - 18)*(s - 1) + k1**2*k2**2*r*(27 - 36*C) + k2**4*r*(8*f - 9)) + b1*f*k2**2*(-11*k1**2*(44*C*r - 4*C - 22*r - 5*s + 1) + k2**2*(6*f*r + 20*f + 176*r + 11)) + f**2*(-k1**4*(12*C - 6)*(3*s - 1) - 3*k1**2*k2**2*(24*C*r - 8*C - 9*r - 5*s + 1) + 22*k2**4*r))/(3465*d*k1**2*k2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*ct*f*k2**2*st**3*(9*b1 + 2*f)*(r + s - 1)/(315*d*k1*k3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*b1*f*k2*st**3*(2*C - 1)*(9*b1 + 2*f)*(r + s - 1)/(315*d*k3) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**4*f**2*k2**5*st**3*(C - 1)*(55*b1*(2*r + 2*s - 1) + f*(23*r + 23*s - 8))/(3465*d*k3**5) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(55*b1*(2*r + 2*s - 1) + f*(23*r + 23*s - 8))/(3465*d*k1*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**3*f**2*k2**4*st**3*(65*b1*f*k2**2*(25*r + 25*s - 13) + 286*b1*k1**2*(C*(37*r + 37*s - 23) - 27*r - 27*s + 18) + 15*f**2*k2**2*(41*r + 41*s - 21) + 26*f*k1**2*(C*(101*r + 101*s - 27) - 78*r - 78*s + 19))/(45045*d*k1*k3**5) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f**2*k2**5*st**5*(C - 1)*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(198*b1**2*(C - 1)*(r + s - 1) - 11*b1*f*(4*C*(9*r + 9*s - 4) - 13*r - 13*s + 9) + f**2*(-4*C*(23*r + 23*s - 8) + 55*r + 55*s - 11))/(3465*d*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct**2*f*k2**3*st**3*(143*b1**2*k2**2*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) - 13*b1*(f**2*k2**2*(17*r + 17*s - 15) + 11*f*(k1**2*(C*(22*r + 22*s - 38) - 5*r - 5*s + 25) - k2**2*(18*C - K - 17)*(2*r + 2*s - 1)) - 198*g2*k2**2*(r + s)) + f*(-3*f**2*k2**2*(163*r + 163*s - 67) - 13*f*k1**2*(4*C*(29*r + 29*s - 1) - 61*r - 61*s - 7) + f*k2**2*(286*C - 286)*(2*r + 2*s - 1) + 286*g2*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k1*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f**2*k2**4*st**5*(13*b1*(f*k2**2*(25*r + 25*s - 13) + k1**2*(88*C - 66)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(35*r + 35*s - 23) + k1**2*(104*C - 78)*(3*r + 3*s - 2)))/(9009*d*k1*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(11*b1**2*(k1**2*(36*C - 27)*(r + s - 1) + k2**2*(f*(7*r + 7*s - 3) + 9*r + 9*s)) + b1*f*(22*C*k1**2*(7*r + 7*s - 1) - 132*k1**2*(r + s) + k2**2*(3*f*(13*r + 13*s - 9) - 176*r - 176*s + 88)) + f**2*(k1**2*(-2*C*(9*r + 9*s + 5) + 3*r + 3*s + 9) - 11*k2**2*(2*r + 2*s - 1)))/(3465*d*k1*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*ct*f*k2**2*st**3*(143*b1**2*k1**2*k2**2*(f*(r + s - 5) - (36*K - 18)*(r + s)) + 52*b1*(f**2*k2**2*(k1**2*(30*r + 30*s - 9) + 11*k2**2*(5*r + 5*s - 3)) + 11*f*k1**2*(k1**2*(9*C - 6)*(r + s + 1) + k2**2*(18*C - K - 13)*(2*r + 2*s - 1)) + 198*g2*k1**2*k2**2*(r + s)) + f*(3*f**2*k2**2*(k1**2*(15*r + 15*s - 47) + 52*k2**2*(5*r + 5*s - 3)) + 26*f*k1**2*(k1**2*(C*(6*r + 6*s - 26) - 9*r - 9*s + 17) + k2**2*(44*C - 33)*(2*r + 2*s - 1)) + 1144*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(45045*d*k1*k3**5) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(2*C - 1)*(11*b1*(2*r + 2*s - 1) + f*(3*r + 3*s - 2))/(693*d*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f**2*k2**3*st**5*(-286*b1**2*k2**2*(2*r + 2*s - 1) + 13*b1*(f*k2**2*(7*r + 7*s - 1) + k1**2*(44*C - 22)*(2*r + 2*s - 1)) + f*(3*f*k2**2*(19*r + 19*s - 11) + k1**2*(52*C - 26)*(3*r + 3*s - 2)))/(9009*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(99*b1**3*k2**2*(r + s - 1) - 11*b1**2*(k1**2*(18*C - 9)*(r + s - 1) - k2**2*(9*K*(r + s) + f*(r + s - 4))) + b1*(-3*f**2*k2**2*(4*r + 4*s - 1) - 11*f*(k1**2*(2*C - 1)*(5*r + 5*s + 1) + k2**2*(18*C - K - 9)*(2*r + 2*s - 1)) + k2**2*(99*b2 - 198*g2)*(r + s)) + f*(-f*(2*C - 1)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1)) + k2**2*(11*b2 - 22*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk1*Pkd3*f*k2*st**3*(429*b1**2*k2**2*(6*K*k1**2*(r + s) + f*k1**2*(r + s + 1) + 6*f*k2**2*(2*r + 2*s - 1)) - 26*b1*(f**2*k2**2*(k1**2*(18*r + 18*s - 1) + 11*k2**2*(4*r + 4*s - 3)) + 11*f*k1**2*(k1**2*(6*C - 3)*(r + s + 1) + k2**2*(18*C - K - 9)*(2*r + 2*s - 1)) + 198*g2*k1**2*k2**2*(r + s)) - f*(3*f**2*k2**2*(k1**2*(35*r + 35*s - 23) + 52*k2**2*(3*r + 3*s - 2)) + f*k1**2*(52*C - 26)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1)) + 572*g2*k1**2*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**3*f**2*k2**4*st**3*(C - 1)*(55*b1*r + f*(15*r - 16))/(3465*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(55*b1*r + f*(15*r - 16))/(3465*d*k1*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct**2*f**2*k2**3*st**3*(975*b1*f*k2**2*r + 1430*b1*k1**2*r*(5*C - 4) + 15*f**2*k2**2*(25*r - 16) + f*k1**2*(130*C - 104)*(15*r - 16))/(45045*d*k1*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(4*C - 3)*(55*b1*r + f*(15*r - 16))/(3465*d*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*ct*f**2*k2**2*st**3*(-715*b1*r*(2*b1*k2**2 + k1**2*(5 - 8*C)) + 18*f**2*k2**2*(25*r - 16) + 13*f*(4*b1*k2**2*(15*r + 8) + k1**2*(8*C - 5)*(15*r - 16)))/(45045*d*k3**4) - 10*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**3*k2**5*st**5*(13*b1*r + f*(3*r - 4))/(9009*d*k1*k3**4) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k1*k2*st**3*(-715*b1*r*(3*b1*k2**2 + k1**2*(2 - 4*C)) + 9*f**2*k2**2*(25*r - 16) + 26*f*(24*b1*k2**2 + k1**2*(2*C - 1)*(15*r - 16)))/(45045*d*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*Pkd1*f**2*k2*st**3*(b1*k2**2 + k1**2*(1 - 2*C))*(55*b1*r + f*(15*r - 16))/(3465*d*k1*k3**2)
        perm23 = -8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**4*f**2*k1**2*k2**3*st**3*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(88*r + 88*s - 53) + f*(52*C - 52)*(23*r + 23*s - 8) - 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**3*f**2*k1*k2**2*st**3*(-13*b1*(k1**2*(33*K - 33)*(r + s + 1) + 5*k2**2*(f*(25*r + 25*s - 13) + (22 - 44*K)*(2*r + 2*s - 1))) + 15*f**2*k1**2*(73*r + 73*s - 45) + 26*f*(k1**2*(C - 1)*(9*r + 9*s + 5) + k2**2*(4*C - 3)*(23*r + 23*s - 8)) + 286*g2*(3*k1**2*(r + s + 1) - 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**6) - 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f**2*k1**2*k2**3*st**5*(143*b1*(K - 1)*(2*r + 2*s - 1) + 3*f**2*(58*r + 58*s - 37) + f*(26*C - 26)*(3*r + 3*s - 2) - 286*g2*(2*r + 2*s - 1))/(9009*d*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct**2*f*k2*st**3*(1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 13*b1*(f**2*k1**2*k2**2*(17*r + 17*s - 15) + 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s + 1) + k1**2*k2**2*(C*(-4*r - 4*s + 2) + 3*K*(8*r + 8*s - 1) - 17*r - 17*s + 4)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-3*f**2*k1**2*(k1**2*(87*r + 87*s - 49) + 130*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(4*C - 4)*(3*r + 3*s - 2) + k1**2*k2**2*(C*(8*r + 8*s - 42) - 17*r - 17*s + 37) - k2**4*(4*C - 2)*(23*r + 23*s - 8)) + 286*g2*(3*k1**4*(r + s + 1) + 3*k1**2*k2**2*(8*r + 8*s - 1) - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(225*r + 225*s - 133) - 13*f*k2**2*(b1*(25*r + 25*s - 13) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(572*K*b1 - 286*b1 - 1144*g2))/(9009*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*ct*f*k1*st**3*(2574*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + 3*f**3*(5*k1**4*(41*r + 41*s - 21) + 52*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f**2*(2*k1**2*k2**2*(b1*(30*r + 30*s - 9) - (4*C - 3)*(3*r + 3*s - 2)) + k2**4*(-70*C*r - 70*C*s + 54*C + 22*b1*(5*r + 5*s - 3) + 57*r + 57*s - 38)) + 143*f*k2**2*(b1**2*k2**2*(7*r + 7*s + 1) + 2*b1*(k1**2*(6*K - 3)*(r + s + 1) + k2**2*(C*(-8*r - 8*s + 4) + 3*K*(13*r + 13*s - 5) - 12*r - 12*s + 6)) - 12*g2*(2*k1**2*(r + s + 1) + k2**2*(13*r + 13*s - 5))))/(45045*d*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(429*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f**2*k2*st**5*(f**2*(k1**4*(-27*r - 27*s + 17) + 26*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(b1*k1**2*k2**2*(7*r + 7*s - 1) + k2**4*(2 - 4*C)*(3*r + 3*s - 2)) + k2**4*(-286*K*b1 + 572*g2)*(2*r + 2*s - 1))/(9009*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pk3*f*st**3*(-2574*b1*k2**6*(r + s)*(K*b1 - 2*g2) + 3*f**3*(k1**6*(25*r + 25*s - 9) + 26*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(b1*k1**2*k2**2*(k1**2*(18*r + 18*s - 1) + 11*k2**2*(4*r + 4*s - 3)) - k2**4*(2*C - 1)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1))) + 143*f*k2**4*(b1**2*k1**2*(7*r + 7*s + 1) + 2*b1*(3*K*k1**2*(r + s + 1) + 9*K*k2**2*(2*r + 2*s - 1) - k2**2*(2*C - 1)*(2*r + 2*s - 1)) - 12*g2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1))))/(45045*d*k2*k3**6) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*ct*f*k1*st**3*(b1*(7*f + 18) + 4*f)*(r + s - 1)/(315*d*k3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*b1*f*st**3*(b1*(18*K*k2**2 + 5*f*k1**2) + k2**2*(8*C*f + 18*b2 - 4*f - 36*g2))*(r + s - 1)/(315*d*k2*k3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**4*f**2*k1**2*k2**3*st**3*(1430*b1*(K - 1)*(2*r + 2*s - 1) + 15*f**2*(88*r + 88*s - 53) + f*(52*C - 52)*(23*r + 23*s - 8) - 2860*g2*(2*r + 2*s - 1))/(45045*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(5*b1*(f*(25*r + 25*s - 13) + 44*r + 44*s - 22) + 2*f*(23*r + 23*s - 8))/(3465*d*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**3*f**2*k1*k2**2*st**3*(-13*b1*(k1**2*(33*K - 33)*(r + s + 1) + 5*k2**2*(f*(25*r + 25*s - 13) + (22 - 44*K)*(2*r + 2*s - 1))) + 15*f**2*k1**2*(73*r + 73*s - 45) + 26*f*(k1**2*(C - 1)*(9*r + 9*s + 5) + k2**2*(4*C - 3)*(23*r + 23*s - 8)) + 286*g2*(3*k1**2*(r + s + 1) - 20*k2**2*(2*r + 2*s - 1)))/(45045*d*k3**5) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f**2*k1**2*k2**3*st**5*(143*b1*(K - 1)*(2*r + 2*s - 1) + 3*f**2*(58*r + 58*s - 37) + f*(26*C - 26)*(3*r + 3*s - 2) - 286*g2*(2*r + 2*s - 1))/(9009*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(99*b1**2*k1**2*(K - 1)*(r + s - 1) + b1*(f**2*k1**2*(63*r + 63*s - 61) + 11*f*(-10*K*k2**2*(2*r + 2*s - 1) + k1**2*(4*C*(r + s - 1) - 7*r - 7*s + 1)) - 198*g2*k1**2*(r + s - 1)) + f*(f*k1**2*(9*r + 9*s + 5) - f*k2**2*(4*C - 2)*(23*r + 23*s - 8) + k2**2*(-110*b2 + 220*g2)*(2*r + 2*s - 1)))/(3465*d*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct**2*f*k2*st**3*(1287*b1**2*k1**2*k2**2*(K - 1)*(r + s) - 13*b1*(f**2*k1**2*k2**2*(17*r + 17*s - 15) + 11*f*(-10*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(r + s + 1) + k1**2*k2**2*(C*(-4*r - 4*s + 2) + 3*K*(8*r + 8*s - 1) - 17*r - 17*s + 4)) + 198*g2*k1**2*k2**2*(r + s)) + f*(-3*f**2*k1**2*(k1**2*(87*r + 87*s - 49) + 130*k2**2*(3*r + 3*s - 2)) - 13*f*(k1**4*(4*C - 4)*(3*r + 3*s - 2) + k1**2*k2**2*(C*(8*r + 8*s - 42) - 17*r - 17*s + 37) - k2**4*(4*C - 2)*(23*r + 23*s - 8)) + 286*g2*(3*k1**4*(r + s + 1) + 3*k1**2*k2**2*(8*r + 8*s - 1) - 10*k2**4*(2*r + 2*s - 1))))/(45045*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(b1*f*(25*r + 25*s - 13) + 22*b1*(2*r + 2*s - 1) + 2*f*(3*r + 3*s - 2))/(693*d*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f**2*k1*k2**2*st**5*(f**2*k1**2*(225*r + 225*s - 133) - 13*f*k2**2*(b1*(25*r + 25*s - 13) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(572*K*b1 - 286*b1 - 1144*g2))/(9009*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(-11*b1**2*k2**2*(18*K*(r + s - 1) + 4*f + 9) + b1*(f**2*(3*k1**2*(17*r + 17*s - 7) + 22*k2**2*(5*r + 5*s - 3)) + 11*f*(3*k1**2*(r + s + 1) - k2**2*(8*C*(r + s - 1) + 3*K*(r + s + 1) - 22*r - 22*s + 14)) + 396*g2*k2**2*(r + s - 1)) + f*(f*k1**2*(6*r + 6*s - 4) + f*k2**2*(2*C*(9*r + 9*s + 5) + 13*r + 13*s - 16) + k2**2*(-33*b2 + 66*g2)*(r + s + 1)))/(3465*d*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*ct*f*k1*st**3*(2574*b1*k2**4*(r + s)*(-2*K*b1 + b1 + 4*g2) + 3*f**3*(5*k1**4*(41*r + 41*s - 21) + 52*k1**2*k2**2*(15*r + 15*s - 11)) - 26*f**2*(2*k1**2*k2**2*(b1*(30*r + 30*s - 9) - (4*C - 3)*(3*r + 3*s - 2)) + k2**4*(-70*C*r - 70*C*s + 54*C + 22*b1*(5*r + 5*s - 3) + 57*r + 57*s - 38)) + 143*f*k2**2*(b1**2*k2**2*(7*r + 7*s + 1) + 2*b1*(k1**2*(6*K - 3)*(r + s + 1) + k2**2*(C*(-8*r - 8*s + 4) + 3*K*(13*r + 13*s - 5) - 12*r - 12*s + 6)) - 12*g2*(2*k1**2*(r + s + 1) + k2**2*(13*r + 13*s - 5))))/(45045*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**4*k1**2*k2**3*st**7*(4*r + 4*s - 3)/(429*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(b1*(22*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(-13*r - 13*s + 7)) + 2*k2**2*(11*b2*(2*r + 2*s - 1) + f*(2*C - 1)*(3*r + 3*s - 2) - 22*g2*(2*r + 2*s - 1)))/(693*d*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f**2*k2*st**5*(f**2*(k1**4*(-27*r - 27*s + 17) + 26*k1**2*k2**2*(3*r + 3*s - 2)) + 13*f*(b1*k1**2*k2**2*(7*r + 7*s - 1) + k2**4*(2 - 4*C)*(3*r + 3*s - 2)) + k2**4*(-286*K*b1 + 572*g2)*(2*r + 2*s - 1))/(9009*d*k3**5) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(11*b1**2*(-9*K*k2**4 + f*k1**2*k2**2*(4*r + 4*s - 1)) + b1*(-f**2*(k1**4*(15*r + 15*s - 7) + 11*k1**2*k2**2*(6*r + 6*s - 5)) + 11*f*(3*K*k1**2*k2**2*(r + s + 1) + 9*K*k2**4*(2*r + 2*s - 1) + k2**4*(1 - 2*C)) - 99*k2**4*(b2*(r + s) - 2*g2)) + f*k2**2*(33*b2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1)) + f*(2*C - 1)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1)) - 66*g2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1))))/(3465*d*k2*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk2*Pkd3*f*st**3*(-2574*b1*k2**6*(r + s)*(K*b1 - 2*g2) + 3*f**3*(k1**6*(25*r + 25*s - 9) + 26*k1**4*k2**2*(6*r + 6*s - 5)) - 26*f**2*(b1*k1**2*k2**2*(k1**2*(18*r + 18*s - 1) + 11*k2**2*(4*r + 4*s - 3)) - k2**4*(2*C - 1)*(k1**2*(6*r + 6*s - 4) + 11*k2**2*(2*r + 2*s - 1))) + 143*f*k2**4*(b1**2*k1**2*(7*r + 7*s + 1) + 2*b1*(3*K*k1**2*(r + s + 1) + 9*K*k2**2*(2*r + 2*s - 1) - k2**2*(2*C - 1)*(2*r + 2*s - 1)) - 12*g2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1))))/(45045*d*k2*k3**5) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*ct*f*k1*st**3*(-4*Pk2 + Pkd2*k2)*(b1*f*(7*s - 8) + 18*b1*(s - 1) + 2*f*(2*s - 1))/(315*d*k2**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*b1*f*st**3*(-9*b1*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*r) - 9*b2*(2*Pk2 - Pkd2*k2)*(s - 1) + f*(Pk2*(-8*C*s + 4*C + 9*b1*(r - 1) - 2*r + 4*s - 1) + Pkd2*k2*(2*C - 1)*(2*s - 1)) + 18*g2*(2*Pk2 - Pkd2*k2)*(s - 1))/(315*d*k2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**4*f**2*k1**2*k2*st**3*(-4*Pk2 + Pkd2*k2)*(1430*b1*(K - 1)*(2*s - 1) + 15*f**2*(88*s - 35) + f*(52*C - 52)*(23*s - 15) + 2860*g2*(1 - 2*s))/(45045*d*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(4*Pk2 - Pkd2*k2)*(5*b1*(f*(25*s - 12) + 44*s - 22) + 2*f*(23*s - 15))/(3465*d*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**3*f**2*k1*st**3*(13*b1*(k1**2*(11*K - 11)*(4*Pk2 - Pkd2*k2)*(7*s - 8) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + f*(Pk2*(50*r - 2) + Pkd2*k2*(25*s - 12)))) + 15*f**2*(104*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(41*s - 20)) + 26*f*(k1**2*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(13*s - 8) + k2**2*(-2*Pk2*(C*(32*r - 92*s + 86) - 55*r + 46*s - 63) - Pkd2*k2*(4*C - 3)*(23*s - 15))) + 286*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(7*s - 8) + 20*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(45045*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f**2*k1**2*k2*st**5*(-4*Pk2 + Pkd2*k2)*(143*b1*(K - 1)*(2*s - 1) + 3*f**2*(58*s - 21) + f*(26*C - 26)*(3*s - 1) + 286*g2*(1 - 2*s))/(9009*d*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 1) + b1*(2*f**2*(55*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(23*s - 15)) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*C*s - 2*C + 3*s - 6) + 10*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + f*(3*f*k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 8) + 2*f*k2**2*(Pk2*(C*(60 - 92*s) - 9*r + 46*s - 49) + Pkd2*k2*(2*C - 1)*(23*s - 15)) + k2**2*(-2*Pk2 + Pkd2*k2)*(110*b2 - 220*g2)*(2*s - 1)))/(3465*d*k2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct**2*f*st**3*(1287*b1**2*k1**2*k2**2*(K - 1)*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s) - 13*b1*(2*f**2*k2**2*(-55*Pk2*k2**2*(r - 1) + k1**2*(Pk2*(63*r - 29*s + 29) + Pkd2*k2*(46*s - 45))) + 11*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(4*C*(r + 2*s - 1) + 2*K*(r + 3*s - 6) - 9*r - 10*s + 5) + Pkd2*k2*(K*(4*s + 7) - s*(4*C + 7) + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 198*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + f*(2860*Pk2*b2*k2**4*(2*r + 2*s - 1) - 6*f**2*k1**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(48*s - 25) + 65*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) - 13*f*(k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-2*Pk2*(2*C*(21*r - 86*s + 40) - 51*r + 124*s - 61) + Pkd2*k2*(C*(74 - 112*s) + 73*s - 50)) + 2*k2**4*(Pk2*(-4*C*(32*r + 23*s + 11) + 73*r + 46*s + 41) - Pkd2*k2*(2*C - 1)*(23*s - 15))) + 286*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*Pk2*(r + 3*s - 6) + Pkd2*k2*(4*s + 7)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))))/(45045*d*k2*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(4*Pk2 - Pkd2*k2)*(b1*(f*(25*s - 12) + 44*s - 22) + 2*f*(3*s - 1))/(693*d*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f**2*k1*st**5*(3*f**2*(104*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(35*s - 12)) + 13*f*k2**2*(Pk2*b1*(50*r - 2) - 4*Pk2*(2*C*(3*r - 6*s + 1) - 9*r + 6*s + 1) + Pkd2*b1*k2*(25*s - 12) - Pkd2*k2*(8*C - 6)*(3*s - 1)) - 286*k2**2*(b1*(4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(2*s - 1) - 8*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2) - 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))))/(9009*d*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(11*b1**2*k1**2*k2**2*(-2*Pk2*(-9*K*(r - 2*s + 2) + 4*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 4*f + 9)) + b1*k1**2*(f**2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 8) - 22*k2**2*(2*Pk2*(6*r - 5*s - 2) + Pkd2*k2*(5*s - 2))) - 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-4*C*(2*r - 4*s + 1) - 14*K*s + 16*K + 19*r - 34*s + 15) + Pkd2*k2*(C*(4 - 8*s) + 7*K*s - 8*K + 22*s - 12))) - 396*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + f*(f*(Pk2*k2**4*(8*C - 4)*(7*r - 6) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(156*C*s - 96*C + 3*r - 64*s + 35) + Pkd2*k2*(-78*C*s + 48*C + 17*s - 13))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-11*b2 + 22*g2)*(7*s - 8)))/(3465*d*k1*k2**2*k3**2) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*ct*f*st**3*(-2574*b1*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + 3*f**3*(5*k1**6*(4*Pk2 - Pkd2*k2)*(19*s - 8) + 52*k1**4*k2**2*(Pk2*(24*r - 30*s - 4) + 3*Pkd2*k2*(5*s - 2))) - 26*f**2*(Pk2*k2**6*(4 - 8*C)*(7*r - 6) + k1**4*k2**2*(2*Pk2*(6*C*(3*r - 11*s - 1) + b1*(51*r + 51*s - 57) - 12*r + 63*s + 5) + 3*Pkd2*k2*(12*b1 + (4*C - 3)*(3*s - 1))) + k1**2*k2**4*(Pk2*(C*(-40*r - 84*s + 56) + 44*b1*(9*r + 5*s - 5) + 105*r + 116*s - 59) + Pkd2*k2*(-2*C*(5*s + 2) + 22*b1*(5*s - 2) + 27*s - 9))) + 143*f*k1**2*k2**2*(12*Pk2*b2*k2**2*(r + s + 1) + b1**2*k2**2*(16*Pk2 + 7*Pkd2*k2*s) - 2*b1*(k1**2*(2*Pk2*(2*K*r - 9*K*s + r + 10*s + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + k2**2*(Pk2*(-4*C*(2*r + 4*s - 3) + K*(-64*r - 26*s + 4) + 83*r + 54*s - 29) + Pkd2*k2*(K*(10 - 29*s) + s*(8*C + 12) - 9))) + 4*g2*(2*Pk2*k1**2*(2*r - 9*s) - 2*Pk2*k2**2*(32*r + 13*s - 2) + 2*Pkd2*k1**2*k2*(2*s - 1) + Pkd2*k2**3*(10 - 29*s))))/(45045*d*k1*k2**2*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**4*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)/(429*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(b1*(f*(11*Pk2*k2**2*(r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) + k2**2*(-11*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - f*(Pk2*(12*C*s - 4*C + 3*r - 6*s + 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) + 22*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1)))/(693*d*k2*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*f**2*st**5*(f**2*(9*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 13*k1**2*k2**2*(Pk2*(9*r - 6*s - 5) + Pkd2*k2*(3*s - 1))) + 13*f*(-11*Pk2*b1*k2**4*(r - 1) + Pk2*k2**4*(-12*C*(2*r + s - 1) + 15*r + 6*s - 7) + Pkd2*k2**5*(C*(2 - 6*s) + 3*s - 1) + b1*k1**2*k2**2*(Pk2*(13*r + s - 1) + 3*Pkd2*k2*(2*s - 1))) + 143*k2**4*(-2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(-8*r - 4*s + 2) + K*Pkd2*k2*(1 - 2*s) + 2*Pk2*r) + 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))/(9009*d*k2*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(11*b1**2*(9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) + 11*b1*(f**2*k1**2*(2*Pk2*(3*r - 6*s + 1) + 3*Pkd2*k2*(2*s - 1)) - f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(4*K*s - 2*K + 2*r - 5*s - 2)) + k2**2*(2*Pk2*(4*C*r - 2*C + 9*K*r - 11*r + 1) + Pkd2*k2*(-2*C + 18*K*s - 9*K + 1))) + 9*k2**2*(4*Pk2*g2*r + Pkd2*b2*k2*s - 2*Pkd2*g2*k2)) + f*(-11*b2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + f*(3*k1**2*(Pk2*(-12*C*s + 4*C - 3*r + 11*s + 1) + Pkd2*k2*(2*C - 1)*(3*s - 1)) + k2**2*(Pk2*(-72*C*r + 24*C + 58*r - 12) - Pkd2*k2*(22*C - 11)*(2*s - 1))) + 22*g2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1)))))/(3465*d*k2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**4*Pk3*f*st**3*(-11*b1**2*(f*(-9*Pk2*k2**4*(r - 1) + k1**2*k2**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) - 9*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + b1*(f**2*k1**2*(k1**2*(Pk2*(30*r - 6*s - 20) + 3*Pkd2*k2*(6*s + 1)) + 11*k2**2*(4*Pk2*(3*r + 3*s - 2) + Pkd2*k2*(4*s - 3))) + 11*f*k2**2*(-k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(2*K*(r + 8*s + 5) + 2*r - 5*s - 2)) + k2**2*(Pk2*(8*C*r + 8*C*s - 18*K*(5*r + 4*s - 2) + 12*r - 4*s + 1) + Pkd2*k2*(4*C*s - 18*K*s + 9*K - 2*s))) - 198*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) + f*(-3*f**2*k1**4*(Pk2*(5*r - 12*s + 3) + 3*Pkd2*k2*(2*s - 1)) + f*k2**2*(k1**2*(Pk2*(4*C*(3*r - 21*s - 5) - 15*r + 57*s + 19) + Pkd2*k2*(6*C - 3)*(3*s - 1)) + k2**2*(-2*Pk2*(4*C*(31*r + 22*s - 14) - 73*r - 44*s + 28) + Pkd2*k2*(11 - 22*C)*(2*s - 1))) + 22*k2**2*(-3*Pk2*b2*(k1**2*(r + s + 1) + 3*k2**2*(2*r + 2*s - 1)) + g2*(k1**2*(2*Pk2*(r + 8*s + 5) + Pkd2*k2*(1 - 2*s)) + 9*k2**2*(2*Pk2*(5*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))))/(3465*d*k2*k3**4)

        return (perm12+perm13+perm23)
    
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        