import numpy as np

class WARR:
    def l0(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        #get derivs for RR
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)
        
        perm12 = 32*C*D1**3*Pk1*Pk2*f*k2**4*st**6*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(63*d**2*k3**6) - 32*C*D1**3*Pk1*Pk2*k1**2*(D1*bd1*f*(14*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(r + s - 1) + b1*(D1*fd*(7*b1*(2*k1**2 + 5*k2**2)*(r + s)**2 + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + 2*Dd*f*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(2*r + 2*s - 1)))/(105*d**2*k3**6) + 32*C*D1**3*Pk1*Pk2*k2**2*st**4*(D1*bd1*f*(r + s - 1)*(14*b1*k2**2*(r + s) + f*k1**2*(5*r + 5*s - 6) - 6*f*k2**2*(2*r + 2*s - 1)) + 7*b1**2*k2**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(D1*fd + 2*Dd*f)*(k1**2*(5*r + 5*s - 6) - 6*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + f**2*(k1**2 - k2**2)*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(2*r + 2*s - 1))/(35*d**2*k3**6) - 32*C*D1**3*Pk1*Pk2*st**2*(3*D1*bd1*f*(-14*b1*k2**2*(k1**2 - 5*k2**2)*(r + s) + f*(k1**4*(r + s + 3) + 4*k1**2*k2**2*(5*r + 5*s - 6) + 7*k2**4*(r + s)))*(r + s - 1) - 21*b1**2*k2**2*(k1**2 - 5*k2**2)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 3*b1*f*(D1*fd + 2*Dd*f)*(k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + 4*k1**2*k2**2*(10*r**2 + r*(20*s - 17) + 10*s**2 - 17*s + 6) + 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + f**2*k1**2*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k3**6) - 8*C*D1**3*Pk2*Pkd1*f*k1*k2**2*st**4*(D1*bd1*f*(5*r**2 + r*(5*s - 8) - 6*s + 3) + b1*(5*D1*fd*r + Dd*f*(10*r - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r**2 + 3*r*(s + 1) + 4*s - 3) + Dd*f*(2*r + 3)*(2*r + 2*s - 1)))/(35*d**2*k3**4) + 8*C*D1**3*Pk2*Pkd1*k1*st**2*(3*D1*bd1*f*(-7*b1*k2**2*(2*r**2 + 2*r*s + r - 3*s) + f*k1**2*(2*r**2 + 2*r*s + r - s - 3) + f*k2**2*(20*r**2 + 5*r*(4*s - 11) - 33*s + 26)) - 21*b1**2*k2**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s + r - 3*s)) + 3*b1*f*(D1*fd*(k1**2*r*(4*r + 4*s + 5) + k2**2*(40*r**2 + 40*r*s - 47*r - 13*s + 10)) + Dd*f*(k1**2*(8*r**2 + 8*r*s + 9*r - s - 3) + 2*k2**2*(40*r**2 + 40*r*s - 63*r - 29*s + 18))) + f**2*(D1*fd*(k1**2*(18*r**2 + 18*r*(s - 1) - 15*s + 7) + 9*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(k1**2*(24*r**2 + 3*r*(8*s - 7) - 19*s + 7) + 9*k2**2*(4*r - 1)*(3*r + 3*s - 2))))/(315*d**2*k3**4) + 8*C*D1**3*Pk2*Pkd1*k1*(D1*bd1*f*(7*b1*(k1**2*(8*r**2 + 8*r*s - 6*r - 2*s) + 5*k2**2*(r + s)*(2*r - 1)) + 3*f*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s))) + b1*(D1*fd*(7*b1*r*(4*k1**2 + 5*k2**2)*(r + s) + 3*f*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))) + Dd*f*(14*b1*k1**2*(8*r**2 + r*(8*s - 3) - s) + 35*b1*k2**2*(r + s)*(4*r - 1) + 6*f*k1**2*(8*r - 3)*(2*r + 2*s - 1) + 21*f*k2**2*(r + s)*(4*r - 1))))/(105*d**2*k3**4) + 8*C*D1**3*Pk2*Pkdd1*f*k2**2*st**4*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k3**2) - 8*C*D1**3*Pk2*Pkdd1*k1**2*(3*D1*bd1*f**2*r*(2*r - 1) + 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(7*D1*bd1*r + D1*fd*(6*r - 3) + 3*Dd*f*(4*r - 1)))/(105*d**2*k3**2) - 4*C*D1**3*Pk2*Pkdd1*st**2*(D1*(-21*b1**2*fd*k2**2*r**2 + 3*b1*f*(7*bd1*k2**2*r*(1 - 2*r) + 2*fd*k1**2*r**2 + fd*k2**2*(2*r**2 - 9*r + 4)) + f**2*(3*bd1*r*(k1**2*(r - 1) + k2**2*(r - 4)) + fd*k1**2*(9*r**2 - 15*r + 4))) + Dd*f*(4*r - 1)*(-21*b1**2*k2**2*r + 3*b1*f*(k1**2*r + k2**2*(r - 4)) + f**2*k1**2*(3*r - 4)))/(315*d**2*k3**2) - D1**3*Pk1*Pk2*ct**8*f*k2**4*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(12*r + 12*s - 5))/(63*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**7*f*k2**3*(-9*D1*bd1*f*(k1**2*(C*(38*r + 38*s - 26) - 48*r - 48*s + 31) - 5*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 9*b1*(D1*fd + 2*Dd*f)*(k1**2*(C*(38*r + 38*s - 26) - 48*r - 48*s + 31) - 5*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 5*f*(k1**2*(C*(42*r + 42*s - 22) - 54*r - 54*s + 27) + k2**2*(-12*r - 12*s + 5))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**6*f*k2**4*st**2*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(9*r + 9*s - 4))/(21*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**6*k2**2*(-9*D1*bd1*f*(r + s - 1)*(28*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(2*C*(4*r + 4*s - 9) - 27*r - 27*s + 31) + f*k2**2*(-14*C*(3*r + 3*s - 2) + 3*r + 3*s - 5)) - 126*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 9*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(2*C*(4*r + 4*s - 9) - 27*r - 27*s + 31) + k2**2*(-14*C*(3*r + 3*s - 2) + 3*r + 3*s - 5))*(2*r + 2*s - 1) + 5*f**2*(k1**2*(6*C + 21*r + 21*s - 17) + k2**2*(4*C - 1)*(15*r + 15*s - 7))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**5*f*k2**3*st**2*(-9*D1*bd1*f*(k1**2*(C*(76*r + 76*s - 52) - 106*r - 106*s + 67) - 15*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 9*b1*(D1*fd + 2*Dd*f)*(k1**2*(C*(76*r + 76*s - 52) - 106*r - 106*s + 67) - 15*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - f*(k1**2*(4*C*(93*r + 93*s - 47) - 507*r - 507*s + 248) - 15*k2**2*(9*r + 9*s - 4))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct**5*k2*(-3*D1*bd1*f*(14*b1*k2**2*(r + s)*(k1**2*(7 - 4*C) + 3*k2**2) + 3*f*(k1**4*(2*C*(9*r + 9*s - 1) - 14*r - 14*s - 7) + k1**2*k2**2*(28*C*(4*r + 4*s - 3) - 81*r - 81*s + 58) + k2**4*(-11*r - 11*s + 9)))*(r + s - 1) - 21*b1**2*k2**2*(r + s)*(k1**2*(7 - 4*C) + 3*k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C*(9*r + 9*s - 1) - 14*r - 14*s - 7) + k1**2*k2**2*(28*C*(4*r + 4*s - 3) - 81*r - 81*s + 58) + k2**4*(-11*r - 11*s + 9)) - 5*f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(2*C*(15*r + 15*s - 7) - 30*r - 30*s + 11) + 4*k1**2*k2**2*(C*(33*r + 33*s - 19) - 27*r - 27*s + 15) - 9*k2**4*(2*r + 2*s - 1)))/(315*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**4*f*k2**4*st**4*(32*C - 32)*(2*r + 2*s - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(7*d**2*k3**6) - 32*D1**3*Pk1*Pk2*ct**4*k2**2*st**2*(9*D1*bd1*f*(r + s - 1)*(28*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(3*C*(3*r + 3*s - 5) - 28*r - 28*s + 28) + f*k2**2*(C*(-53*r - 53*s + 30) + 4*r + 4*s - 2)) + 126*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(3*C*(3*r + 3*s - 5) - 28*r - 28*s + 28) + k2**2*(C*(-53*r - 53*s + 30) + 4*r + 4*s - 2))*(2*r + 2*s - 1) + f**2*(k1**2*(18*C*(3*r + 3*s - 2) - 147*r - 147*s + 83) + k2**2*(-3*C*(81*r + 81*s - 38) + 15*r + 15*s - 7))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**4*(3*D1*bd1*f*(28*b1*k2**2*(r + s)*(k1**2*(7*C - 6) + k2**2*(8*C - 4)) + 3*f*(k1**4*(C*(8*r + 8*s - 4) - 17*r - 17*s + 5) + 2*k1**2*k2**2*(7*C*(7*r + 7*s - 6) - 68*r - 68*s + 48) - k2**4*(2*C*(4*r + 4*s - 9) + 51*r + 51*s - 29)))*(r + s - 1) + 42*b1**2*k2**2*(r + s)*(k1**2*(7*C - 6) + k2**2*(8*C - 4))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(C*(8*r + 8*s - 4) - 17*r - 17*s + 5) + 2*k1**2*k2**2*(7*C*(7*r + 7*s - 6) - 68*r - 68*s + 48) - k2**4*(2*C*(4*r + 4*s - 9) + 51*r + 51*s - 29)) + 5*f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(4*C*(3*r + 3*s - 2) - 27*r - 27*s + 15) + 4*k1**2*k2**2*(3*C*(6*r + 6*s - 5) - 33*r - 33*s + 22) - 9*k2**4*(C*(4*r + 4*s - 2) + 5*r + 5*s - 3)))/(315*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**3*f*k2**3*st**4*(-3*D1*bd1*f*(k1**2*(C*(38*r + 38*s - 26) - 68*r - 68*s + 41) - 15*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 3*b1*(D1*fd + 2*Dd*f)*(k1**2*(C*(38*r + 38*s - 26) - 68*r - 68*s + 41) - 15*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - f*(k1**2*(C*(54*r + 54*s - 26) - 84*r - 84*s + 41) - 15*k2**2*(2*r + 2*s - 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct**3*k2*st**2*(-3*D1*bd1*f*(28*b1*k2**2*(r + s)*(k1**2*(5 - 2*C) + 3*k2**2) + f*(k1**4*(10*C*(r + s + 3) + 17*r + 17*s - 75) + 2*k1**2*k2**2*(7*C*(29*r + 29*s - 21) - 110*r - 110*s + 69) - 3*k2**4*(23*r + 23*s - 15)))*(r + s - 1) - 42*b1**2*k2**2*(r + s)*(k1**2*(5 - 2*C) + 3*k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 3*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(10*C*(r + s + 3) + 17*r + 17*s - 75) + 2*k1**2*k2**2*(7*C*(29*r + 29*s - 21) - 110*r - 110*s + 69) - 3*k2**4*(23*r + 23*s - 15)) - 2*f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*k1**4*(3*C*r + 3*C*s + C + 6*r + 6*s - 7) + k1**2*k2**2*(C*(321*r + 321*s - 175) - 162*r - 162*s + 90) - 27*k2**4*(2*r + 2*s - 1)))/(315*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct**3*(3*D1*bd1*f*(14*b1*k2**2*(r + s)*(k1**4*(23 - 16*C) - k1**2*k2**2*(24*C - 32) + 5*k2**4) + 3*f*(k1**6*(4*r + 4*s - 2) + k1**4*k2**2*(-28*C*(r + s - 1) + 95*r + 95*s - 65) + k1**2*k2**4*(C*(46*r + 46*s - 58) + 80*r + 80*s - 33) + 7*k2**6*(r + s)))*(r + s - 1) + 21*b1**2*k2**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(23 - 16*C) - k1**2*k2**2*(24*C - 32) + 5*k2**4) + 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**6*(4*r + 4*s - 2) + k1**4*k2**2*(-28*C*(r + s - 1) + 95*r + 95*s - 65) + k1**2*k2**4*(C*(46*r + 46*s - 58) + 80*r + 80*s - 33) + 7*k2**6*(r + s)) + 5*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(6*r + 6*s - 4) + k1**2*k2**2*(4*C*(3*r + 3*s + 1) + 60*r + 60*s - 49) + 9*k2**4*(2*C*(5*r + 5*s - 3) + 4*r + 4*s - 3)))/(315*d**2*k1*k2*k3**6) - D1**3*Pk1*Pk2*ct**2*f*k2**4*st**6*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(63*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct**2*k2**2*st**4*(-3*D1*bd1*f*(r + s - 1)*(28*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(2*C*(5*r + 5*s - 6) - 29*r - 29*s + 25) + f*k2**2*(-42*C*(2*r + 2*s - 1) + 5*r + 5*s + 1)) - 42*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 3*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(2*C*(5*r + 5*s - 6) - 29*r - 29*s + 25) + k2**2*(-42*C*(2*r + 2*s - 1) + 5*r + 5*s + 1))*(2*r + 2*s - 1) - f**2*(k1**2*(6*C*(2*r + 2*s - 1) - 39*r - 39*s + 19) - k2**2*(36*C*(2*r + 2*s - 1) + 15*r + 15*s - 7))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d**2*k3**6) - 16*D1**3*Pk1*Pk2*ct**2*st**2*(-3*D1*bd1*f*(28*b1*k2**2*(r + s)*(-k1**2*(C - 2) + k2**2*(11*C - 4)) + f*(k1**4*(2*C - 7)*(r + s + 3) + 2*k1**2*k2**2*(C*(47*r + 47*s - 69) - 67*r - 67*s + 51) - k2**4*(2*C*(62*r + 62*s - 45) + 103*r + 103*s - 69)))*(r + s - 1) + 42*b1**2*k2**2*(r + s)*(k1**2*(C - 2) + k2**2*(4 - 11*C))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 3*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 7)*(r + s + 3) + 2*k1**2*k2**2*(C*(47*r + 47*s - 69) - 67*r - 67*s + 51) - k2**4*(2*C*(62*r + 62*s - 45) + 103*r + 103*s - 69)) - f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(2*C - 5)*(3*r + 3*s + 1) + 6*k1**2*k2**2*(3*C*(10*r + 10*s - 7) - 36*r - 36*s + 22) - 27*k2**4*(C*(8*r + 8*s - 4) + 5*r + 5*s - 3)))/(315*d**2*k3**6) - 16*D1**3*Pk1*Pk2*ct**2*(3*D1*bd1*f*(-28*b1*(r + s)*(k1**4*(2*C - 6) - k1**2*k2**2*(2*C + 14) - k2**4*(5*C + 5)) + 3*f*(k1**4*(31*r + 31*s - 19) + k1**2*k2**2*(C*(76*r + 76*s - 66) + 51*r + 51*s - 15) + k2**4*(14*C + 14)*(r + s)))*(r + s - 1) - 42*b1**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(2*C - 6) - k1**2*k2**2*(2*C + 14) - k2**4*(5*C + 5)) + 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(31*r + 31*s - 19) + k1**2*k2**2*(C*(76*r + 76*s - 66) + 51*r + 51*s - 15) + k2**4*(14*C + 14)*(r + s)) + 5*f**2*k1**2*(k1**2*(4*C*(3*r + 3*s - 2) + 9*r + 9*s - 9) + 9*k2**2*(C*(8*r + 8*s - 6) + r + s - 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d**2*k3**6) + 16*D1**3*Pk1*Pk2*ct*f*k2**3*st**6*(k1**2 + k2**2)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(63*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct*k1*(30*C*f**2*k1**2*k2**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) + D1*bd1*f*(14*b1*(r + s)*(2*k1**4 + k1**2*k2**2*(16*C + 7) + k2**4*(20*C + 5)) + 3*f*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(C*(46*r + 46*s - 30) + 11*r + 11*s - 2) + k2**4*(28*C + 7)*(r + s)))*(r + s - 1) + 7*b1**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1))*(2*k1**4 + k1**2*k2**2*(16*C + 7) + k2**4*(20*C + 5)) + 3*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(C*(46*r + 46*s - 30) + 11*r + 11*s - 2) + k2**4*(28*C + 7)*(r + s)))/(105*d**2*k2*k3**6) + 16*D1**3*Pk1*Pk2*ct*k2*st**4*(3*D1*bd1*f*(14*b1*k2**2*(k1**2 + k2**2)*(r + s) + f*(k1**4*(5*r + 5*s - 6) + k1**2*k2**2*(C*(38*r + 38*s - 26) - 7*r - 7*s) - 6*k2**4*(2*r + 2*s - 1)))*(r + s - 1) + 21*b1**2*k2**2*(k1**2 + k2**2)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 3*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(5*r + 5*s - 6) + k1**2*k2**2*(C*(38*r + 38*s - 26) - 7*r - 7*s) - 6*k2**4*(2*r + 2*s - 1)) + f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(2*C*k1**2*k2**2*(27*r + 27*s - 13) + k1**4*(6*r + 6*s - 3) - 3*k2**4*(2*r + 2*s - 1)))/(105*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct*st**2*(3*D1*bd1*f*(-14*b1*k2**2*(r + s)*(k1**4 + k1**2*k2**2*(4*C - 4) - 5*k2**4) + f*(k1**6*(r + s + 3) + k1**4*k2**2*(10*C*(r + s + 3) + 21*r + 21*s - 21) + k1**2*k2**4*(2*C*(89*r + 89*s - 69) + 27*r + 27*s - 24) + 7*k2**6*(r + s)))*(r + s - 1) - 21*b1**2*k2**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4 + k1**2*k2**2*(4*C - 4) - 5*k2**4) + 3*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**6*(r + s + 3) + k1**4*k2**2*(10*C*(r + s + 3) + 21*r + 21*s - 21) + k1**2*k2**4*(2*C*(89*r + 89*s - 69) + 27*r + 27*s - 24) + 7*k2**6*(r + s)) + f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(3*r + 3*s + 1) + k1**2*k2**2*(6*C*(3*r + 3*s + 1) + 39*r + 39*s - 26) + 9*k2**4*(6*C*(5*r + 5*s - 3) + 4*r + 4*s - 3)))/(315*d**2*k1*k2*k3**6) + D1**3*Pk1*ct**8*f*k2**2*(8*C - 8)*(-4*Pk2 + Pkd2*k2)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*D1*fd*(2*s - 1) + Dd*f*(8*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(72*r*s - 33*r + 72*s**2 - 72*s + 19) + Dd*f*(96*r*s - 40*r + 96*s**2 - 84*s + 19)))/(63*d**2*k3**4) - D1**3*Pk1*ct**8*f*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(36*s**2 - 33*s + 7) + Dd*f*(48*s**2 - 40*s + 7)))/(63*d**2*k3**2) + D1**3*Pk1*ct**7*f**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(11*b1*(33*s - 14)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s*(33*s - 14) + 21*D1*fd*(52*s**2 - 37*s + 6) + 21*Dd*f*(52*s**2 - 37*s + 6)))/(693*d**2*k1*k2) - 4*D1**3*Pk1*ct**7*f*k2*(9*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(64*s - 30) + 64*s**2 - 92*s + 30) - 7*r*(12*s - 5) - 84*s**2 + 112*s - 35) + k2**2*(-2*Pk2*(r**2*(28*C - 28) + r*(28*C*(s - 1) - 8*s + 23) + 5*(1 - 2*s)**2) + 5*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + 9*b1*(2*D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(64*s - 39) + 64*s**2 - 78*s + 23) - 84*r*s + 49*r - 84*s**2 + 98*s - 28) + k2**2*(Pk2*(-r*(28*C - 28) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(128*s - 69) + 128*s**2 - 147*s + 38) - 168*r*(2*s - 1) - 336*s**2 + 364*s - 91) + k2**2*(-2*Pk2*(r*(56*C - 56) + 40*s - 15) + 5*Pkd2*k2*(8*s - 3))*(2*r + 2*s - 1))) + f*(D1*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(24*C*(3*s - 2)*(3*r + 3*s - 2) - 3*r*(96*s - 59) - 288*s**2 + 360*s - 115) + k2**2*(Pk2*(-8*C*(39*r + 17)*(3*r + 3*s - 2) + 936*r**2 + 216*r*s + 114*r - 720*s**2 + 1128*s - 462) + 5*Pkd2*k2*(r*(72*s - 33) + 72*s**2 - 72*s + 19))) + Dd*f*(5*k1**2*(4*Pk2 - Pkd2*k2)*(6*C*(r*(48*s - 31) + 48*s**2 - 57*s + 16) + r*(226 - 384*s) - 384*s**2 + 426*s - 115) + k2**2*(-2*Pk2*(2*C*(312*r**2 + 3*r*(104*s - 7) + 137*s - 68) - 624*r**2 - 2*r*(72*s + 79) + 480*s**2 - 694*s + 231) + 5*Pkd2*k2*(8*r*(12*s - 5) + 96*s**2 - 84*s + 19)))))/(315*d**2*k1*k3**4) - 2*D1**3*Pk1*ct**7*f*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(26*s - 20) - 36*s + 25) + k2**2*(-8*Pk2*(r*(28*C - 28) + 10*s - 5) + k2*(Pkd2*(r*(56*C - 56) + 50*s - 25) + 5*Pkdd2*k2*(1 - 2*s)))) + f*(9*D1*bd1*s*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(26*s - 20) - 36*s + 25) + k2**2*(-8*Pk2*(r*(28*C - 28) + 10*s - 5) + k2*(Pkd2*(r*(56*C - 56) + 50*s - 25) + 5*Pkdd2*k2*(1 - 2*s)))) + D1*fd*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(C*(30*s - 28) - 42*s + 35) + k2**2*(-4*Pk2*(C*(1098*r*s - 393*r + 354*s - 109) - 1098*r*s + 393*r + 360*s**2 - 684*s + 179) + k2*(Pkd2*(4*C*(3*r*(96*s - 35) + 84*s - 25) - 1152*r*s + 420*r + 900*s**2 - 1161*s + 275) - 5*Pkdd2*k2*(36*s**2 - 33*s + 7)))) + 5*Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(30*s - 28) - 42*s + 35) + Dd*f*k2**2*(-4*Pk2*(C*(8*r*(183*s - 53) + 494*s - 109) - 1464*r*s + 424*r + 480*s**2 - 894*s + 179) + k2*(Pkd2*(4*C*(384*r*s - 115*r + 119*s - 25) - 1536*r*s + 460*r + 1200*s**2 - 1476*s + 275) - 5*Pkdd2*k2*(48*s**2 - 40*s + 7)))))/(315*d**2*k1*k2*k3**2) + D1**3*Pk1*ct**6*f*k2**2*st**2*(8*C - 8)*(-4*Pk2 + Pkd2*k2)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*D1*fd*(2*s - 1) + Dd*f*(8*s - 3))*(2*r + 2*s - 1) + f*(2*D1*fd*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) + Dd*f*(r*(72*s - 29) + 72*s**2 - 63*s + 14)))/(21*d**2*k3**4) - D1**3*Pk1*ct**6*f*st**2*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(27*s**2 - 24*s + 5) + Dd*f*(36*s**2 - 29*s + 5)))/(21*d**2*k3**2) - 4*D1**3*Pk1*ct**6*(3*D1*bd1*f*(-42*b1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + f*(3*Pk2*k2**4*(8*r**2 + r*(8*s - 3) + 10*s - 5) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(22*s - 30) + 22*s**2 - 64*s + 30) - 9*r*(6*s - 5) - 54*s**2 + 110*s - 45) + k1**2*k2**2*(Pk2*(-4*C*(105*r**2 + 333*r*s - 140*r + 228*s**2 - 192*s + 50) + 480*r**2 + 960*r*s - 485*r + 480*s**2 - 282*s + 65) + 3*Pkd2*k2*(2*C*(42*r*s - 9*r + 42*s**2 - 44*s + 14) - 12*r*s - 7*r - 12*s**2 + 2*s - 3)))) - 126*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*D1*fd*s*(r + s) + Dd*f*(r*(8*s - 1) + s*(8*s - 3))) + 3*b1*f*(D1*fd*(24*Pk2*k2**4*r*(2*r + 2*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(44*s - 50) + 44*s**2 - 86*s + 32) + r*(89 - 108*s) - 108*s**2 + 164*s - 55) + k1**2*k2**2*(-2*Pk2*(2*C*(210*r**2 + 666*r*s - 358*r + 456*s**2 - 495*s + 123) - 480*r**2 - 960*r*s + 509*r - 480*s**2 + 516*s - 117) + 3*Pkd2*k2*(2*C*(84*r*s - 48*r + 84*s**2 - 97*s + 24) - 24*r*s + 17*r - 24*s**2 + 36*s - 5))) + Dd*f*(3*Pk2*k2**4*(16*r + 5)*(2*r + 2*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(11*r*(4*s - 5) + 44*s**2 - 91*s + 31) + r*(179 - 216*s) - 216*s**2 + 329*s - 100) + k1**2*k2**2*(Pk2*(-4*C*(420*r**2 + 2*r*(666*s - 271) + 912*s**2 - 816*s + 173) + 1920*r**2 + 8*r*(480*s - 193) + 1920*s**2 - 1572*s + 299) + 3*Pkd2*k2*(2*C*(3*r*(56*s - 23) + 168*s**2 - 167*s + 38) + r*(9 - 48*s) - 48*s**2 + 47*s - 8)))) + f**2*(D1*fd*(3*Pk2*k2**4*(36*r**2 + r*(36*s + 39) + 78*s - 47) + 30*k1**4*(4*Pk2 - Pkd2*k2)*(C*(9*r*(s - 2) + 9*s**2 - 27*s + 13) - 3*r*(9*s - 10) - 27*s**2 + 51*s - 21) + k1**2*k2**2*(-Pk2*(4*C*(459*r**2 + 1935*r*s - 600*r + 1476*s**2 - 999*s + 103) - 2124*r**2 - 5508*r*s + 993*r - 3384*s**2 + 942*s + 579) + 10*Pkd2*k2*(2*C*(90*r*s - 39*r + 90*s**2 - 90*s + 23) - 54*r*s + 9*r - 54*s**2 + 36*s - 3))) + Dd*f*(3*Pk2*k2**4*(48*r**2 + 6*r*(8*s + 11) + 98*s - 47) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(24*s - 50) + 24*s**2 - 66*s + 26) - 9*r*(8*s - 9) - 72*s**2 + 123*s - 42) + k1**2*k2**2*(-Pk2*(4*C*(612*r**2 + 2580*r*s - 580*r + 1968*s**2 - 1122*s + 103) - 2832*r**2 - 7344*r*s + 512*r - 4512*s**2 + 844*s + 579) + 5*Pkd2*k2*(4*C*(120*r*s - 47*r + 120*s**2 - 105*s + 23) - 144*r*s + 15*r - 144*s**2 + 81*s - 6)))))/(315*d**2*k1**2*k3**4) + D1**3*Pk1*ct**6*(198*b1**2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd*(5*f*(1 - 2*s)**2 - (7*K - 7)*(s - 1)**2) + Dd*f*(4*s - 1)*(-7*K*s + 7*K + 5*f*(2*s - 1) + 7*s - 7)) + 11*b1*(3*D1*(f**2*(60*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 33*s + 7) + k2**2*r*(Pk2*(345*s - 178) + 5*Pkd2*k2*(8 - 15*s)))) - 6*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(fd*(K - 1)*(6*s**2 - 13*s + 5) + s*(s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) + 84*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + Dd*f*(f**2*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(48*s**2 - 40*s + 7) + k2**2*(Pk2*(4*r*(345*s - 188) - 465*s + 218) + 5*Pkd2*k2*(r*(34 - 60*s) + 21*s - 10))) - 18*f*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + 252*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*f**2*(11*bd1*(720*Pk2*k1**2*s*(12*s - 7) - 270*Pkd2*k1**2*k2*s*(12*s - 7) + 5*Pkd2*k2**3*(-5*r*(3*s - 2) + 21*s - 10) + k2**2*(Pk2*(345*r*s - 218*r - 465*s + 218) + 30*Pkdd2*k1**2*s*(12*s - 7))) + 5*fd*(28*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(56*s**2 - 50*s + 9) + k2**2*(Pk2*(1988*r*s - 992*r - 3577*s + 1018) + Pkd2*k2*(-332*r*s + 182*r + 853*s - 238)))) + 198*D1*f*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 5)*(-K*bd1 + bd1 + 2*gd2) + 396*D1*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7*bd1*s*(s - 1) + fd*(6*s**2 - 13*s + 5)) + 5*Dd*f**3*(28*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(56*s**2 - 50*s + 9) + k2**2*(Pk2*(4*r*(497*s - 248) - 3577*s + 1018) + Pkd2*k2*(r*(182 - 332*s) + 853*s - 238))) + 396*Dd*f*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5)))/(3465*d**2*k1**2*k2**2) - 2*D1**3*Pk1*ct**6*(126*b1**2*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1*f*(D1*(42*bd1*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(2*C*(3*s - 5) - 19*s + 20) + k1**2*k2**2*(-4*Pk2*(7*C*r*(81*s - 46) + 12*C*(110*s**2 - 116*s + 29) + r*(382 - 687*s) - 924*s**2 + 954*s - 228) - 3*k2*(Pkd2*(-4*C*(7*r*(7*s - 4) + 173*s**2 - 188*s + 47) + 4*r*(59*s - 33) + 362*s**2 - 387*s + 88) + Pkdd2*k2*(12*C*(7*s**2 - 8*s + 2) - 18*s**2 + 23*s - 4))) - 24*k2**4*r*(2*Pk2*(r*(9*C - 9) - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(2*C*(3*s - 5) - 19*s + 20) + k1**2*k2**2*(-2*Pk2*(C*(28*r*(81*s - 34) + 5280*s**2 - 4335*s + 850) - 2748*r*s + 1132*r - 3696*s**2 + 3039*s - 640) - 3*k2*(Pkd2*(-4*C*(98*r*s - 42*r + 346*s**2 - 285*s + 54) + 472*r*s - 198*r + 724*s**2 - 585*s + 121) + Pkdd2*k2*(4*s - 1)*(6*C*(7*s - 4) - 9*s + 4))) - 3*k2**4*(2*Pk2*(r**2*(144*C - 144) + r*(-36*C - 32*s + 34) - 10*s + 5) + Pkd2*k2*(r*(32*s + 2) + 10*s - 5)))) + f**2*(D1*(3*bd1*(3*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*C*(3*s - 5) - 19*s + 20) + k1**2*k2**2*(-2*Pk2*(C*(7*r*(81*s - 22) + 1320*s**2 - 855*s + 154) - 687*r*s + 184*r - 924*s**2 + 675*s - 184) + 3*k2*(Pkd2*(C*(98*r*s - 28*r + 346*s**2 - 200*s + 28) - 118*r*s + 33*r - 181*s**2 + 110*s - 33) + Pkdd2*k2*s*(-6*C*(7*s - 3) + 9*s + 2))) - 3*k2**4*(2*Pk2*(r**2*(36*C - 36) + r*(-36*C - 8*s + 31) - 10*s + 5) + Pkd2*k2*(r*(8*s + 5) + 10*s - 5))) + fd*(5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(2*C*(3*s - 7) - 21*s + 28) + k1**2*k2**2*(-2*Pk2*(C*(3*r*(987*s - 626) + 8208*s**2 - 6459*s + 1538) - 27*r*(137*s - 83) - 5868*s**2 + 3705*s - 919) + k2*(Pkd2*(2*C*(r*(801*s - 510) + 3402*s**2 - 2805*s + 638) - 27*r*(74*s - 45) - 3879*s**2 + 2397*s - 551) - 5*Pkdd2*k2*(3*s - 1)*(4*C*(15*s - 8) - 21*s + 4))) + k2**4*(-4*Pk2*(C*(261*r**2 - 102*r + 5) - 261*r**2 - 135*r*s + 138*r - 90*s + 28) + 3*Pkd2*k2*(r*(15 - 72*s) - 66*s + 25)))) + Dd*f*(5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(2*C*(3*s - 7) - 21*s + 28) + k1**2*k2**2*(-2*Pk2*(C*(4*r*(987*s - 586) + 10944*s**2 - 7531*s + 1538) - 4932*r*s + 2808*r - 7824*s**2 + 4057*s - 919) + k2*(Pkd2*(2*C*(1068*r*s - 640*r + 4536*s**2 - 3313*s + 638) - 2664*r*s + 1530*r - 5172*s**2 + 2633*s - 551) - 5*Pkdd2*k2*(4*s - 1)*(4*C*(15*s - 8) - 21*s + 4))) + k2**4*(-4*Pk2*(C*(348*r**2 - 107*r + 5) - 348*r**2 - 20*r*(9*s - 7) - 120*s + 28) + 3*Pkd2*k2*(r*(10 - 96*s) - 86*s + 25)))))/(315*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*ct**5*f**2*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(11*b1*(33*s - 14)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s*(33*s - 14) + D1*fd*(908*s**2 - 619*s + 98) + Dd*f*(908*s**2 - 619*s + 98)))/(231*d**2*k1*k2) + 4*D1**3*Pk1*ct**5*f*k2*st**2*(-9*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + r*(75 - 188*s) - 188*s**2 + 244*s - 75) + k2**2*(-2*Pk2*(2*C*(48*r**2 + 48*r*s - 53*r - 10*s + 5) - 96*r**2 - 36*r*s + 91*r + 60*s**2 - 40*s + 5) + 15*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) - 9*b1*(2*D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(64*s - 39) + 64*s**2 - 78*s + 23) - 4*r*(47*s - 27) - 188*s**2 + 216*s - 61) + 3*k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(128*s - 69) + 128*s**2 - 147*s + 38) + r*(366 - 752*s) - 752*s**2 + 798*s - 197) + k2**2*(Pk2*(-4*C*(96*r - 5) + 384*r - 240*s + 70) + 15*Pkd2*k2*(8*s - 3))*(2*r + 2*s - 1))) + f*(2*D1*fd*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(9*r*(9*s - 5) + 81*s**2 - 96*s + 29) + r*(240 - 459*s) - 459*s**2 + 519*s - 151) + k2**2*(2*Pk2*(C*(522*r**2 + 522*r*s - 252*r + 42*s - 46) - 522*r**2 - 117*r*s + 72*r + 405*s**2 - 447*s + 151) - 15*Pkd2*k2*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7))) + Dd*f*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(216*s - 115) + 216*s**2 - 225*s + 58) + r*(605 - 1224*s) - 1224*s**2 + 1215*s - 302) + k2**2*(2*Pk2*(2*C*(696*r**2 + 696*r*s - 231*r + 67*s - 46) - 1392*r**2 - 312*r*s + 27*r + 1080*s**2 - 1079*s + 302) - 15*Pkd2*k2*(r*(72*s - 29) + 72*s**2 - 63*s + 14)))))/(315*d**2*k1*k3**4) - 2*D1**3*Pk1*ct**5*f*st**2*(9*b1*(D1*fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(52*s - 40) - 82*s + 55) + 3*k2**2*(-8*Pk2*(r*(32*C - 32) + 10*s - 5) + k2*(Pkd2*(r*(64*C - 64) + 50*s - 25) + 5*Pkdd2*k2*(1 - 2*s)))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(52*s - 40) - 82*s + 55) + k2**2*(-8*Pk2*(2*C*(192*r*s - 58*r - 10*s + 5) - 384*r*s + 116*r + 120*s**2 - 70*s + 5) + k2*(Pkd2*(4*C*(192*r*s - 58*r - 10*s + 5) - 768*r*s + 232*r + 600*s**2 - 410*s + 55) - 15*Pkdd2*k2*(8*s**2 - 6*s + 1))))) + f*(-9*D1*bd1*(-24*Pk2*k1**2*s*(C*(52*s - 40) - 82*s + 55) + 9*Pkd2*k1**2*k2*s*(C*(52*s - 40) - 82*s + 55) + Pkd2*k2**3*(-4*C*(r*(48*s - 5) - 10*s + 5) + 4*r*(48*s - 5) - 150*s**2 + 35*s + 20) + 15*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(8*Pk2*(2*C*(r*(48*s - 5) - 10*s + 5) + r*(10 - 96*s) + 30*s**2 + 5*s - 10) + Pkdd2*k1**2*s*(C*(40 - 52*s) + 82*s - 55))) + D1*fd*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(4*C*(69*s - 50) - 411*s + 275) + k2**2*(-8*Pk2*(2*C*(684*r*s - 309*r - 12*s + 31) - 1368*r*s + 618*r + 405*s**2 - 336*s + 13) + k2*(Pkd2*(8*C*(369*r*s - 168*r - 15*s + 20) - 2952*r*s + 1344*r + 2025*s**2 - 1680*s + 215) - 15*Pkdd2*k2*(27*s**2 - 24*s + 5)))) + Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(4*C*(69*s - 50) - 411*s + 275) - Dd*f*k2**2*(8*Pk2*(2*C*(r*(912*s - 365) + 13*s + 31) + r*(730 - 1824*s) + 540*s**2 - 461*s + 13) + k2*(Pkd2*(-4*C*(984*r*s - 401*r - 5*s + 40) + 4*r*(984*s - 401) - 2700*s**2 + 2155*s - 215) + 15*Pkdd2*k2*(36*s**2 - 29*s + 5)))))/(315*d**2*k1*k2*k3**2) + 4*D1**3*Pk1*ct**5*(3*D1*bd1*f*(-7*b1*k1**2*k2**2*(2*Pk2 - Pkd2*k2)*(r*(2*C*(6*s + 1) - 24*s + 1) + s*(2*C*(6*s - 7) - 24*s + 23)) + 7*b1*k2**4*(Pk2*r*(40*C - 40)*(r + s - 1) + 3*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 3*f*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(s + 5) + s**2 + 6*s - 5) + r*(9*s - 25) + 9*s**2 - 44*s + 25) + f*k1**2*k2**2*(2*Pk2*(C*(56*r**2 + 668*r*s - 266*r + 612*s**2 - 760*s + 216) - 104*r**2 - 650*r*s + 214*r - 546*s**2 + 535*s - 131) - 3*Pkd2*k2*(2*C*(91*r*s - 41*r + 91*s**2 - 125*s + 42) - 129*r*s + 41*r - 129*s**2 + 150*s - 48)) + f*k2**4*(-2*Pk2*(C*(64*r**2 + 64*r*s - 92*r - 30*s + 30) - 7*r**2 + 86*r*s + 36*r + 93*s**2 - 18*s - 31) + 3*Pkd2*k2*(r*(22*s - 4) + 22*s**2 - 24*s + 9))) - 21*b1**2*k2**2*(2*D1*fd*(r + s)*(Pk2*k1**2*s*(6*C - 12) + Pk2*k2**2*r*(10 - 10*C) - Pkd2*k1**2*k2*s*(3*C - 6) + 3*Pkd2*k2**3*s) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(C*(24*s + 2) - 48*s + 1) + s*(2*C*(12*s - 7) - 48*s + 23)) + k2**2*(Pk2*r*(40 - 40*C)*(2*r + 2*s - 1) + 3*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) + 3*b1*f*(D1*fd*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(s + 3)*(2*r + 2*s - 1) + r*(18*s - 37) + 18*s**2 - 53*s + 22) + k1**2*k2**2*(Pk2*(4*C*(56*r**2 + 668*r*s - 381*r + 612*s**2 - 785*s + 229) - 416*r**2 - 2600*r*s + 1391*r - 2184*s**2 + 2660*s - 721) - 3*Pkd2*k2*(4*C*(91*r*s - 51*r + 91*s**2 - 107*s + 29) - 258*r*s + 129*r - 258*s**2 + 286*s - 68)) + k2**4*(Pk2*(-64*C*(2*r - 1)*(2*r + 2*s - 1) + 28*r**2 - 344*r*s + 37*r - 372*s**2 + 244*s - 29) + 3*Pkd2*k2*(4*r*(11*s - 7) + 44*s**2 - 57*s + 14))) + Dd*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*C*(s + 4)*(2*r + 2*s - 1) + r*(36*s - 87) + 36*s**2 - 119*s + 47) + k1**2*k2**2*(Pk2*(4*C*(112*r**2 + 1336*r*s - 604*r + 1224*s**2 - 1412*s + 337) - 832*r**2 - 5200*r*s + 1997*r - 4368*s**2 + 4535*s - 983) - 6*Pkd2*k2*(C*(364*r*s - 179*r + 364*s**2 - 403*s + 100) - 258*r*s + 102*r - 258*s**2 + 259*s - 58)) + k2**4*(Pk2*(-4*C*(64*r - 31)*(2*r + 2*s - 1) + 56*r**2 - 688*r*s - 101*r - 744*s**2 + 313*s + 33) + 3*Pkd2*k2*(r*(88*s - 39) + 88*s**2 - 97*s + 23)))) + f**2*(D1*fd*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(3*s + 5)*(3*r + 3*s - 2) + r*(9*s - 84) + 9*s**2 - 99*s + 59) + k1**2*k2**2*(Pk2*(-12*C*(27*r**2 - 540*r*s + 180*r - 567*s**2 + 555*s - 125) + 216*r**2 - 6300*r*s + 435*r - 6516*s**2 + 4158*s - 131) - 15*Pkd2*k2*(8*C*(9*s - 5)*(3*r + 3*s - 2) - 171*r*s + 69*r - 171*s**2 + 177*s - 44)) + k2**4*(Pk2*(-4*C*(288*r**2 + 9*r*(32*s - 11) + 84*s - 59) + 918*r**2 - 3*r*(48*s + 275) - 1062*s**2 + 126*s + 265) + 45*Pkd2*k2*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + Dd*f*(5*k1**4*(4*Pk2 - Pkd2*k2)*(4*C*(r*(6*s + 11) + 6*s**2 + 6*s - 5) + r*(12*s - 119) + 12*s**2 - 123*s + 59) + k1**2*k2**2*(Pk2*(-12*C*(36*r**2 - 720*r*s + 205*r - 756*s**2 + 655*s - 125) + 288*r**2 - 8400*r*s + 5*r - 8688*s**2 + 4719*s - 131) - 15*Pkd2*k2*(8*C*(36*r*s - 19*r + 36*s**2 - 39*s + 10) - 228*r*s + 83*r - 228*s**2 + 207*s - 44)) + k2**4*(Pk2*(-4*C*(384*r**2 + 384*r*s - 75*r + 119*s - 59) + 1224*r**2 - 192*r*s - 1051*r - 1416*s**2 + 87*s + 265) + 45*Pkd2*k2*(8*s - 3)*(2*r + 2*s - 1)))))/(315*d**2*k1*k2*k3**4) + D1**3*Pk1*ct**5*(33*b1**2*k1**2*(D1*fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + k2**2*(8*Pk2*(3*f*(52*s**2 - 33*s + 10) + (14*s - 14)*(5*K*r - 5*r + 3*s - 3)) + k2*(-5*Pkd2*(3*f*(52*s**2 - 33*s + 10) + (14*s - 14)*(2*K*r - 2*r + 3*s - 3)) + 3*Pkdd2*k2*(f*(52*s**2 - 33*s + 10) + 14*(s - 1)**2)))) + Dd*f*(4*s - 1)*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(f*(13*s - 10) + 14*s - 14) + 2*k2**2*(8*Pk2*(3*f*(13*s - 5) + r*(35*K - 35) + 21*s - 21) + k2*(-5*Pkd2*(3*f*(13*s - 5) + r*(14*K - 14) + 21*s - 21) + 3*Pkdd2*k2*(13*f*s - 5*f + 7*s - 7))))) + 11*b1*(D1*(f**2*(9*bd1*k1**2*s*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(52*s - 33)) + fd*(-360*Pk2*k2**4*r**2 + 10*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(45*s**2 - 57*s + 14) + k1**2*k2**2*(-12*Pk2*(3*r*(6*s - 11) + 1230*s**2 - 850*s + 133) + k2*(3*Pkd2*(72*r*s - 60*r + 1455*s**2 - 1066*s + 156) - 5*Pkdd2*k2*(45*s**2 - 42*s + 4))))) + 6*f*k1**2*(fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + k2**2*(2*Pk2*(K*(122*r*s - 82*r + 107*s - 43) - 122*r*s + 82*r + 72*s**2 - 263*s + 103) + k2*(Pkd2*(K*(-68*r*s + 48*r - 50*s + 18) + 68*r*s - 48*r - 90*s**2 + 245*s - 93) + 3*Pkdd2*k2*(6*s**2 - 13*s + 5)))) + 14*s*(3*bd1*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + bd1*k2**2*(8*Pk2*(r*(5*K - 5) + 3*s - 3) + k2*(-5*Pkd2*(2*K*r - 2*r + 3*s - 3) + 3*Pkdd2*k2*(s - 1))) + 10*gd2*k2**2*r*(-4*Pk2 + Pkd2*k2))) + 840*fd*g2*k1**2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(s - 1)) + Dd*f*(f**2*(120*Pk2*k2**4*r*(1 - 4*r) + 10*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(60*s**2 - 71*s + 14) + k1**2*k2**2*(-4*Pk2*(24*r*(3*s - 8) + 4920*s**2 - 2900*s + 461) + k2*(Pkd2*(288*r*s - 300*r + 5820*s**2 - 3419*s + 548) - 5*Pkdd2*k2*(60*s**2 - 31*s + 4)))) + 6*f*k1**2*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + k2**2*(2*Pk2*(K*(4*r*(61*s - 29) + 227*s - 43) - 4*r*(61*s - 29) + 144*s**2 - 503*s + 103) + k2*(Pkd2*(-2*K*(4*r*(17*s - 9) + 55*s - 9) + 8*r*(17*s - 9) - 180*s**2 + 455*s - 93) + 3*Pkdd2*k2*(12*s**2 - 23*s + 5)))) + 840*g2*k1**2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(4*s - 1))) + f*(D1*f**2*(11*bd1*(-120*Pk2*k2**4*r*(r - 1) + 10*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(15*s - 14) - k1**2*k2**2*(4*Pk2*(3*r*(6*s - 31) + 1230*s**2 - 350*s + 62) + k2*(Pkd2*(-72*r*s + 120*r - 1455*s**2 + 221*s - 80) + 5*Pkdd2*k2*s*(15*s + 11)))) + 5*fd*(-60*Pk2*k2**4*(12*r**2 + 5*r - 2) + 7*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 89*s + 18) + k1**2*k2**2*(8*Pk2*(16*r*(7*s + 12) - 5060*s**2 + 2909*s - 466) + k2*(Pkd2*(16*r*(8*s - 35) + 14740*s**2 - 8909*s + 1438) - 77*Pkdd2*k2*(20*s**2 - 13*s + 2))))) + 66*D1*f*k1**2*(bd1*(72*Pk2*k1**2*s*(3*s - 5) - 27*Pkd2*k1**2*k2*s*(3*s - 5) + Pkd2*k2**3*(-r*(2*K - 2)*(17*s - 6) - 15*s*(2*K + 3*s - 7)) + 3*Pkdd2*k2**4*s*(3*s - 5) + k2**2*(Pk2*r*(2*K - 2)*(61*s - 17) + 24*Pk2*s*(5*K + 3*s - 10) + 3*Pkdd2*k1**2*s*(3*s - 5))) + 4*gd2*k2**2*(Pk2*r*(17 - 61*s) - 60*Pk2*s + Pkd2*k2*r*(17*s - 6) + 15*Pkd2*k2*s)) + 264*D1*g2*k1**2*k2**2*(Pk2*fd*(r*(82 - 122*s) - 107*s + 43) + Pkd2*fd*k2*(r*(34*s - 24) + 25*s - 9) + 35*bd1*r*s*(-4*Pk2 + Pkd2*k2)) + 5*Dd*f**3*(-60*Pk2*k2**4*(12*r**2 + 5*r - 2) + 7*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 89*s + 18) + k1**2*k2**2*(8*Pk2*(16*r*(7*s + 12) - 5060*s**2 + 2909*s - 466) + k2*(Pkd2*(16*r*(8*s - 35) + 14740*s**2 - 8909*s + 1438) - 77*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 264*Dd*f*g2*k1**2*k2**2*(Pk2*(-4*r*(61*s - 29) - 227*s + 43) + Pkd2*k2*(4*r*(17*s - 9) + 55*s - 9))))/(3465*d**2*k1**3*k2**3) - 2*D1**3*Pk1*ct**5*(-21*b1**2*k1**2*k2**2*(D1*fd*s + Dd*f*(4*s - 1))*(Pk2*k1**2*s*(40 - 16*C) + Pkd2*k1**2*k2*s*(10*C - 25) + Pkd2*k2**3*(r*(20 - 20*C) - 3*s) + 3*Pkdd2*k2**4*s + k2**2*(Pk2*r*(40*C - 40) + Pkdd2*k1**2*s*(5 - 2*C))) - 3*b1*f*(D1*(-7*bd1*k1**2*k2**2*(2*s - 1)*(Pk2*k1**2*s*(16*C - 40) - Pkd2*k1**2*k2*s*(10*C - 25) + Pkd2*k2**3*(r*(20*C - 20) + 3*s) - 3*Pkdd2*k2**4*s + k2**2*(Pk2*r*(40 - 40*C) + Pkdd2*k1**2*s*(2*C - 5))) + fd*(-264*Pk2*k2**6*r**2 + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + k1**4*k2**2*(2*Pk2*(4*C*(49*r*s - 77*r + 816*s**2 - 1042*s + 320) - 571*r*s + 576*r - 3576*s**2 + 4300*s - 1250) + k2*(Pkd2*(-4*C*(28*r*s - 42*r + 723*s**2 - 890*s + 268) + 310*r*s - 309*r + 2724*s**2 - 3167*s + 895) + 3*Pkdd2*k2*(4*C*(35*s**2 - 41*s + 12) - 104*s**2 + 113*s - 30))) + k1**2*k2**4*(2*Pk2*(86*C*s + r**2*(12*C - 12) + r*(-1444*C*s + 804*C + 1285*s - 721) - 372*s**2 + 286*s - 93) + k2*(Pkd2*(r*(8*C*(25*s - 21) - 62*s + 99) + 438*s**2 - s*(100*C + 356) + 114) - 3*Pkdd2*k2*(22*s**2 - 28*s + 7))))) + Dd*f*(132*Pk2*k2**6*r*(1 - 4*r) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + k1**4*k2**2*(Pk2*(4*C*(28*r*(7*s - 11) + 3264*s**2 - 3425*s + 717) - 2284*r*s + 2316*r - 14304*s**2 + 14159*s - 3082) + k2*(Pkd2*(-2*C*(56*r*(2*s - 3) + 2892*s**2 - 2895*s + 578) + 620*r*s - 621*r + 5448*s**2 - 5100*s + 1051) + 6*Pkdd2*k2*(4*s - 1)*(C*(35*s - 24) - 26*s + 15))) + k1**2*k2**4*(Pk2*(4*C*(12*r**2 - 1444*r*s + 387*r + 115*s - 36) - 48*r**2 + 5140*r*s - 1306*r - 1488*s**2 + 725*s - 80) + k2*(Pkd2*(20*C*(20*r*s - 6*r - 11*s + 3) - 124*r*s + 27*r + 876*s**2 - 479*s + 66) - 3*Pkdd2*k2*(44*s**2 - 39*s + 7))))) - f**2*(D1*(3*bd1*(-132*Pk2*k2**6*r*(r - 1) + 3*k1**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 5) + k1**4*k2**2*(Pk2*(4*C*(49*r*s - 77*r + 816*s**2 - 701*s + 77) - 571*r*s + 582*r - 3576*s**2 + 3059*s - 582) + k2*(Pkd2*(-2*C*(28*r*s - 42*r + 723*s**2 - 579*s + 42) + 155*r*s - 156*r + 1362*s**2 - 1038*s + 156) + 3*Pkdd2*k2*s*(10*C*(7*s - 5) - 52*s + 29))) + k1**2*k2**4*(Pk2*(4*C*(3*r**2 - 361*r*s - 21*r + 42*s - 36) - 12*r**2 + 1285*r*s + 122*r - 372*s**2 + 87*s + 106) + k2*(Pkd2*(4*C*(25*r*s + 12*r - 15*s + 15) - 31*r*s - 60*r + 219*s**2 - 69*s - 48) + 3*Pkdd2*k2*s*(4 - 11*s)))) + fd*(2*Pk2*k2**6*(-315*r**2 + 48*r + 19) + 5*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*s**2 - 24*s + 7) + k1**4*k2**2*(Pk2*(8*C*(3*r*(3*s - 91) + 2322*s**2 - 2829*s + 775) - 9*r*(177*s - 458) - 21024*s**2 + 21891*s - 6158) + k2*(Pkd2*(-8*C*(r*(9*s - 75) + 1053*s**2 - 1227*s + 316) + 9*r*(57*s - 125) + 8361*s**2 - 8256*s + 2141) + 5*Pkdd2*k2*(3*s - 1)*(C*(84*s - 64) - 69*s + 38))) + k1**2*k2**4*(Pk2*(12*C*(57*r**2 - 786*r*s + 155*r - 272*s + 120) - 774*r**2 + 8127*r*s - 816*r - 2124*s**2 + 4215*s - 1714) + k2*(Pkd2*(4*C*(396*r*s - 159*r + 48*s - 7) - 1161*r*s + 351*r + 1332*s**2 - 816*s + 136) - 45*Pkdd2*k2*(6*s**2 - 5*s + 1))))) + Dd*f*(2*Pk2*k2**6*(-420*r**2 + 29*r + 19) + 5*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 31*s + 7) + k1**4*k2**2*(Pk2*(8*C*(12*r*s - 374*r + 3096*s**2 - 3503*s + 775) - 2124*r*s + 5676*r - 28032*s**2 + 26495*s - 6158) + k2*(Pkd2*(-4*C*(24*r*s - 205*r + 2808*s**2 - 3031*s + 632) + 684*r*s - 1545*r + 11148*s**2 - 9977*s + 2141) + 5*Pkdd2*k2*(4*s - 1)*(C*(84*s - 64) - 69*s + 38))) + k1**2*k2**4*(Pk2*(4*C*(228*r**2 + r*(415 - 3144*s) - 1126*s + 360) - 1032*r**2 + 4*r*(2709*s - 67) - 2832*s**2 + 5381*s - 1714) + k2*(Pkd2*(4*C*(528*r*s - 187*r + 83*s - 7) - 1548*r*s + 363*r + 1776*s**2 - 964*s + 136) - 45*Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(315*d**2*k1**3*k2**3*k3**2) + D1**3*Pk1*ct**4*f*k2**2*st**4*(8*C - 8)*(-4*Pk2 + Pkd2*k2)*(3*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*b1*(2*D1*fd*(2*s - 1) + Dd*f*(8*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(r*(12*s - 5) + 3*(1 - 2*s)**2) + Dd*f*(8*s - 3)*(2*r + 2*s - 1)))/(7*d**2*k3**4) - D1**3*Pk1*ct**4*f*st**4*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(3*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(7*d**2*k3**2) - 4*D1**3*Pk1*ct**4*st**2*(3*D1*bd1*f*(-84*b1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + f*(3*Pk2*k2**4*(36*r**2 + r*(36*s - 31) + 10*s - 5) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(8*s - 9) + 8*s**2 - 22*s + 9) + r*(33 - 48*s) - 48*s**2 + 90*s - 33) + k1**2*k2**2*(Pk2*(-4*C*(165*r**2 + r*(645*s - 254) + 480*s**2 - 408*s + 107) + 840*r**2 + r*(1656*s - 881) + 816*s**2 - 450*s + 113) + 6*Pkd2*k2*(C*(2*r*(53*s - 12) + 106*s**2 - 107*s + 30) - 2*r*(7*s + 3) - 14*s**2 + s)))) - 252*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*D1*fd*s*(r + s) + Dd*f*(r*(8*s - 1) + s*(8*s - 3))) + 3*b1*f*(2*D1*fd*(54*Pk2*k2**4*r*(2*r + 2*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(32*s - 30) + 32*s**2 - 60*s + 22) + r*(69 - 96*s) - 96*s**2 + 138*s - 45) + k1**2*k2**2*(-2*Pk2*(C*(330*r**2 + 1290*r*s - 703*r + 960*s**2 - 1011*s + 255) - 420*r**2 - 828*r*s + 451*r - 408*s**2 + 417*s - 96) + 3*Pkd2*k2*(C*(4*r*(53*s - 29) + 212*s**2 - 229*s + 58) - 28*r*s + 17*r - 28*s**2 + 31*s - 5))) + Dd*f*(3*Pk2*k2**4*(72*r + 5)*(2*r + 2*s - 1) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(32*s - 33) + 32*s**2 - 63*s + 20) - 3*r*(64*s - 45) - 192*s**2 + 273*s - 78) + k1**2*k2**2*(Pk2*(-4*C*(660*r**2 + 2580*r*s - 1061*r + 1920*s**2 - 1677*s + 362) + 3360*r**2 + 6624*r*s - 2786*r + 3264*s**2 - 2514*s + 497) + 6*Pkd2*k2*(C*(424*r*s - 169*r + 424*s**2 - 395*s + 88) - (28*s - 5)*(2*r + 2*s - 1))))) + f**2*(2*D1*fd*(Pk2*k2**4*(117*r**2 + 9*r*(13*s + 2) + 87*s - 61) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*C*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) - 9*r*(30*s - 19) - 270*s**2 + 354*s - 115) + k1**2*k2**2*(Pk2*(-2*C*(567*r**2 + 3*r*(921*s - 400) + 2196*s**2 - 1971*s + 443) + 1395*r**2 + 15*r*(213*s - 76) + 1800*s**2 - 1059*s + 23) + 6*Pkd2*k2*(C*(3*r*(81*s - 35) + 243*s**2 - 243*s + 62) - 27*s**2 - s*(27*r - 12) + 2))) + Dd*f*(Pk2*k2**4*(312*r**2 + 3*r*(104*s + 41) + 209*s - 122) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(3*C*(r*(48*s - 37) + 48*s**2 - 63*s + 19) + r*(226 - 360*s) - 360*s**2 + 414*s - 115) + k1**2*k2**2*(Pk2*(-4*C*(756*r**2 + 3684*r*s - 1298*r + 2928*s**2 - 2316*s + 443) + 3720*r**2 + 8520*r*s - 1997*r + 4800*s**2 - 2447*s + 46) + 6*Pkd2*k2*(C*(648*r*s - 253*r + 648*s**2 - 567*s + 124) - 72*r*s - 7*r - 72*s**2 + 27*s + 4)))))/(315*d**2*k1**2*k3**4) + D1**3*Pk1*ct**4*st**2*(198*b1**2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd*(15*f*(1 - 2*s)**2 - (14*K - 14)*(s - 1)**2) + Dd*f*(4*s - 1)*(15*f*(2*s - 1) + (14 - 14*K)*(s - 1))) + 33*b1*(3*D1*(f**2*(60*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(27*s**2 - 24*s + 5) + k2**2*r*(Pk2*(165*s - 82) + 5*Pkd2*k2*(2 - 3*s)))) - 2*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(fd*(K - 1)*(10*s**2 - 17*s + 6) + s*(s - 1)*(28*K*bd1 - 28*bd1 - 28*gd2)) + 56*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + Dd*f*(f**2*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 29*s + 5) + k2**2*(4*r - 1)*(Pk2*(165*s - 82) + 5*Pkd2*k2*(2 - 3*s))) - 6*f*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + 168*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*f**2*(33*bd1*(720*Pk2*k1**2*s*(9*s - 5) - 270*Pkd2*k1**2*k2*s*(9*s - 5) - 5*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(Pk2*(r - 1)*(165*s - 82) + 30*Pkdd2*k1**2*s*(9*s - 5))) + fd*(100*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(160*s**2 - 124*s + 21) + k2**2*(Pk2*(4*r*(2455*s + 632) - 13455*s + 2118) + 5*Pkd2*k2*(r*(268*s - 430) + 483*s - 30)))) + 198*D1*f*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(5*s - 6)*(-K*bd1 + bd1 + 2*gd2) + 396*D1*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(14*bd1*s*(s - 1) + fd*(10*s**2 - 17*s + 6)) + Dd*f**3*(100*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(160*s**2 - 124*s + 21) + k2**2*(Pk2*(4*r*(2455*s + 632) - 13455*s + 2118) + 5*Pkd2*k2*(r*(268*s - 430) + 483*s - 30))) + 396*Dd*f*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6)))/(3465*d**2*k1**2*k2**2) + D1**3*Pk1*ct**4*(1386*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(-42*D1*bd1*f*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + 2*D1*fd*(k1**2*(Pk2*(-112*K*(8*s**2 - 14*s + 7) + f*(7*r*(9*s - 10) + 1440*s**2 - 1704*s + 384) + 168*r*s - 168*r + 560*s**2 - 896*s + 448) + k2*(-3*Pkd2*f*(7*r*(s - 1) + 132*s**2 - 187*s + 38) + 14*Pkd2*(K*(31*s**2 - 52*s + 26) - 3*r*s + 3*r - 16*s**2 + 22*s - 11) + 3*Pkdd2*f*k2*(4*s**2 - 15*s + 2) - 14*Pkdd2*k2*(K*(5*s**2 - 8*s + 4) - 2*s**2 + 2*s - 1))) + k2**2*r*(2*Pk2*(f*(3*s + 8) - 7*r*(7*K - 7) + 28*s - 28) + Pkd2*k2*(3*f*(6*s - 5) - 28*s + 28))) + Dd*f*k1**2*(Pk2*f*(28*r*(9*s - 16) + 5760*s**2 - 4743*s + 922) - 56*Pk2*(4*K*(32*s**2 - 36*s + 7) - 3*r*(8*s - 5) - 80*s**2 + 87*s - 19) + Pkd2*k2*(14*K*(248*s**2 - 270*s + 52) - 3*f*(14*r*(2*s - 3) + 528*s**2 - 457*s + 90) - 336*r*s + 210*r - 1792*s**2 + 1722*s - 350) + 4*Pkdd2*k2**2*(4*s - 1)*(7*K*(4 - 5*s) + 3*f*(s - 1) + 14*s - 7)) + 2*Dd*f*k2**2*(Pk2*f*(4*r*(3*s + 8) + 9*s - 11) - 14*Pk2*(r**2*(28*K - 28) + r*(-7*K - 16*s + 2) - 3*s + 3) + 3*Pkd2*f*k2*(2*r*(6*s - 5) - 5*s + 3) - 7*Pkd2*k2*(16*r*s + 5*r + 3*s - 3))) - 11*b1*(-3936*D1*K*Pk2*f*fd*k1**2*s**2 + 8976*D1*K*Pk2*f*fd*k1**2*s - 3504*D1*K*Pk2*f*fd*k1**2 - 432*D1*K*Pk2*f*fd*k2**2*r**2 + 432*D1*K*Pk2*f*fd*k2**2*r - 108*D1*K*Pk2*f*fd*k2**2 + 2064*D1*K*Pkd2*f*fd*k1**2*k2*s**2 - 4080*D1*K*Pkd2*f*fd*k1**2*k2*s + 1524*D1*K*Pkd2*f*fd*k1**2*k2 - 360*D1*K*Pkdd2*f*fd*k1**2*k2**2*s**2 + 612*D1*K*Pkdd2*f*fd*k1**2*k2**2*s - 216*D1*K*Pkdd2*f*fd*k1**2*k2**2 - 1008*D1*Pk2*bd2*f*k1**2*s**2 + 1008*D1*Pk2*bd2*f*k1**2*s - 558*D1*Pk2*f**2*fd*k1**2*r*s - 1596*D1*Pk2*f**2*fd*k1**2*r + 34128*D1*Pk2*f**2*fd*k1**2*s**2 - 29739*D1*Pk2*f**2*fd*k1**2*s + 6258*D1*Pk2*f**2*fd*k1**2 + 108*D1*Pk2*f**2*fd*k2**2*r**2 + 225*D1*Pk2*f**2*fd*k2**2*r*s - 102*D1*Pk2*f**2*fd*k2**2*r + 1050*D1*Pk2*f**2*fd*k2**2*s - 186*D1*Pk2*f**2*fd*k2**2 + 312*D1*Pk2*f*fd*k1**2*r*s - 912*D1*Pk2*f*fd*k1**2*r + 2208*D1*Pk2*f*fd*k1**2*s**2 - 3876*D1*Pk2*f*fd*k1**2*s + 1764*D1*Pk2*f*fd*k1**2 + 432*D1*Pk2*f*fd*k2**2*r**2 + 552*D1*Pk2*f*fd*k2**2*r*s - 708*D1*Pk2*f*fd*k2**2*r + 480*D1*Pk2*f*fd*k2**2*s - 132*D1*Pk2*f*fd*k2**2 + 10752*D1*Pk2*f*gd2*k1**2*s**2 - 9408*D1*Pk2*f*gd2*k1**2*s + 1176*D1*Pk2*f*gd2*k2**2*r**2 + 10752*D1*Pk2*fd*g2*k1**2*s**2 - 18816*D1*Pk2*fd*g2*k1**2*s + 9408*D1*Pk2*fd*g2*k1**2 + 1176*D1*Pk2*fd*g2*k2**2*r**2 + 630*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 630*D1*Pkd2*bd2*f*k1**2*k2*s + 18*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 480*D1*Pkd2*f**2*fd*k1**2*k2*r - 12582*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 10785*D1*Pkd2*f**2*fd*k1**2*k2*s - 2178*D1*Pkd2*f**2*fd*k1**2*k2 - 207*D1*Pkd2*f**2*fd*k2**3*r*s + 102*D1*Pkd2*f**2*fd*k2**3*r - 606*D1*Pkd2*f**2*fd*k2**3*s + 110*D1*Pkd2*f**2*fd*k2**3 - 120*D1*Pkd2*f*fd*k1**2*k2*r*s + 270*D1*Pkd2*f*fd*k1**2*k2*r - 984*D1*Pkd2*f*fd*k1**2*k2*s**2 + 1422*D1*Pkd2*f*fd*k1**2*k2*s - 570*D1*Pkd2*f*fd*k1**2*k2 - 192*D1*Pkd2*f*fd*k2**3*r*s + 54*D1*Pkd2*f*fd*k2**3*r - 282*D1*Pkd2*f*fd*k2**3*s + 162*D1*Pkd2*f*fd*k2**3 - 5208*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 4368*D1*Pkd2*f*gd2*k1**2*k2*s - 5208*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 8736*D1*Pkd2*fd*g2*k1**2*k2*s - 4368*D1*Pkd2*fd*g2*k1**2*k2 - 126*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 126*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 1350*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 1110*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 200*D1*Pkdd2*f**2*fd*k1**2*k2**2 + 144*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 - 144*D1*Pkdd2*f*fd*k1**2*k2**2*s + 36*D1*Pkdd2*f*fd*k1**2*k2**2 + 840*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 672*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 840*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 1344*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 672*D1*Pkdd2*fd*g2*k1**2*k2**2 + 3*D1*bd1*f*(k1**2*(Pk2*(f*(14*r*(9*s - 22) + 2880*s**2 - 1335*s + 154) + 336*r*(2*s - 1) - 56*s**2*(64*K - 40) + 56*s*(60*K - 39) + 168) + k2*(-3*Pkd2*f*(14*r*(s - 2) + 264*s**2 - 83*s + 14) + 14*Pkd2*(r*(6 - 12*s) + s**2*(124*K - 64) - s*(114*K - 57) - 3) + 6*Pkdd2*f*k2*s*(4*s + 5) - 28*Pkdd2*k2*s*(K*(10*s - 9) - 4*s + 3))) + 2*k2**2*(Pk2*f*(2*r*(3*s + 8) + 9*s - 11) - 14*Pk2*(r**2*(14*K - 14) + r*(-7*K - 8*s + 1) - 3*s + 3) + 3*Pkd2*f*k2*(r*(6*s - 5) - 5*s + 3) - 7*Pkd2*k2*(8*r*s + 6*r + 3*s - 3))) - 7872*Dd*K*Pk2*f**2*k1**2*s**2 + 15984*Dd*K*Pk2*f**2*k1**2*s - 3504*Dd*K*Pk2*f**2*k1**2 - 864*Dd*K*Pk2*f**2*k2**2*r**2 + 648*Dd*K*Pk2*f**2*k2**2*r - 108*Dd*K*Pk2*f**2*k2**2 + 4128*Dd*K*Pkd2*f**2*k1**2*k2*s**2 - 7128*Dd*K*Pkd2*f**2*k1**2*k2*s + 1524*Dd*K*Pkd2*f**2*k1**2*k2 - 720*Dd*K*Pkdd2*f**2*k1**2*k2**2*s**2 + 1044*Dd*K*Pkdd2*f**2*k1**2*k2**2*s - 216*Dd*K*Pkdd2*f**2*k1**2*k2**2 - 744*Dd*Pk2*f**3*k1**2*r*s - 2528*Dd*Pk2*f**3*k1**2*r + 45504*Dd*Pk2*f**3*k1**2*s**2 - 35558*Dd*Pk2*f**3*k1**2*s + 6724*Dd*Pk2*f**3*k1**2 + 144*Dd*Pk2*f**3*k2**2*r**2 + 300*Dd*Pk2*f**3*k2**2*r*s - 206*Dd*Pk2*f**3*k2**2*r + 1135*Dd*Pk2*f**3*k2**2*s - 260*Dd*Pk2*f**3*k2**2 + 624*Dd*Pk2*f**2*k1**2*r*s - 2040*Dd*Pk2*f**2*k1**2*r + 4416*Dd*Pk2*f**2*k1**2*s**2 - 6276*Dd*Pk2*f**2*k1**2*s + 1764*Dd*Pk2*f**2*k1**2 + 864*Dd*Pk2*f**2*k2**2*r**2 + 1104*Dd*Pk2*f**2*k2**2*r*s - 1020*Dd*Pk2*f**2*k2**2*r + 1056*Dd*Pk2*f**2*k2**2*s - 132*Dd*Pk2*f**2*k2**2 + 43008*Dd*Pk2*f*g2*k1**2*s**2 - 48384*Dd*Pk2*f*g2*k1**2*s + 9408*Dd*Pk2*f*g2*k1**2 + 4704*Dd*Pk2*f*g2*k2**2*r**2 - 1176*Dd*Pk2*f*g2*k2**2*r + 24*Dd*Pkd2*f**3*k1**2*k2*r*s + 740*Dd*Pkd2*f**3*k1**2*k2*r - 16776*Dd*Pkd2*f**3*k1**2*k2*s**2 + 12680*Dd*Pkd2*f**3*k1**2*k2*s - 2308*Dd*Pkd2*f**3*k1**2*k2 - 276*Dd*Pkd2*f**3*k2**3*r*s + 116*Dd*Pkd2*f**3*k2**3*r - 671*Dd*Pkd2*f**3*k2**3*s + 156*Dd*Pkd2*f**3*k2**3 - 240*Dd*Pkd2*f**2*k1**2*k2*r*s + 594*Dd*Pkd2*f**2*k1**2*k2*r - 1968*Dd*Pkd2*f**2*k1**2*k2*s**2 + 2238*Dd*Pkd2*f**2*k1**2*k2*s - 570*Dd*Pkd2*f**2*k1**2*k2 - 384*Dd*Pkd2*f**2*k2**3*r*s + 18*Dd*Pkd2*f**2*k2**3*r - 570*Dd*Pkd2*f**2*k2**3*s + 162*Dd*Pkd2*f**2*k2**3 - 20832*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 22680*Dd*Pkd2*f*g2*k1**2*k2*s - 4368*Dd*Pkd2*f*g2*k1**2*k2 + 1800*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 1250*Dd*Pkdd2*f**3*k1**2*k2**2*s + 200*Dd*Pkdd2*f**3*k1**2*k2**2 + 288*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 - 216*Dd*Pkdd2*f**2*k1**2*k2**2*s + 36*Dd*Pkdd2*f**2*k1**2*k2**2 + 3360*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 3528*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 672*Dd*Pkdd2*f*g2*k1**2*k2**2 - 126*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(4752*D1*Pk2*bd2*f*k1**2*s**2 - 7920*D1*Pk2*bd2*f*k1**2*s + 9940*D1*Pk2*f**2*fd*k1**2*r*s + 12640*D1*Pk2*f**2*fd*k1**2*r - 267520*D1*Pk2*f**2*fd*k1**2*s**2 + 217075*D1*Pk2*f**2*fd*k1**2*s - 41330*D1*Pk2*f**2*fd*k1**2 - 5440*D1*Pk2*f**2*fd*k2**2*r**2 - 3300*D1*Pk2*f**2*fd*k2**2*r*s + 7010*D1*Pk2*f**2*fd*k2**2*r + 23375*D1*Pk2*f**2*fd*k2**2*s - 7050*D1*Pk2*f**2*fd*k2**2 - 43296*D1*Pk2*f*gd2*k1**2*s**2 + 77088*D1*Pk2*f*gd2*k1**2*s - 4752*D1*Pk2*f*gd2*k2**2*r**2 + 2376*D1*Pk2*f*gd2*k2**2*r - 86592*D1*Pk2*fd*g2*k1**2*s**2 + 197472*D1*Pk2*fd*g2*k1**2*s - 77088*D1*Pk2*fd*g2*k1**2 - 9504*D1*Pk2*fd*g2*k2**2*r**2 + 9504*D1*Pk2*fd*g2*k2**2*r - 2376*D1*Pk2*fd*g2*k2**2 - 2970*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 4950*D1*Pkd2*bd2*f*k1**2*k2*s - 1660*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 3710*D1*Pkd2*f**2*fd*k1**2*k2*r + 103840*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 82195*D1*Pkd2*f**2*fd*k1**2*k2*s + 15090*D1*Pkd2*f**2*fd*k1**2*k2 + 1100*D1*Pkd2*f**2*fd*k2**3*r*s - 440*D1*Pkd2*f**2*fd*k2**3*r - 275*D1*Pkd2*f**2*fd*k2**3*s + 110*D1*Pkd2*f**2*fd*k2**3 + 22704*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 33528*D1*Pkd2*f*gd2*k1**2*k2*s + 45408*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 89760*D1*Pkd2*fd*g2*k1**2*k2*s + 33528*D1*Pkd2*fd*g2*k1**2*k2 + 594*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 - 990*D1*Pkdd2*bd2*f*k1**2*k2**2*s - 12320*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 + 9240*D1*Pkdd2*f**2*fd*k1**2*k2**2*s - 1540*D1*Pkdd2*f**2*fd*k1**2*k2**2 - 3960*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 + 4752*D1*Pkdd2*f*gd2*k1**2*k2**2*s - 7920*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 + 13464*D1*Pkdd2*fd*g2*k1**2*k2**2*s - 4752*D1*Pkdd2*fd*g2*k1**2*k2**2 + 11*D1*bd1*(f**2*(k1**2*(Pk2*(2*r*(93*s + 466) - 11376*s**2 + 5819*s - 466) + k2*(Pkd2*(-6*r*s - 260*r + 4194*s**2 - 1895*s + 130) + 10*Pkdd2*k2*s*(14 - 45*s))) + k2**2*(Pk2*(-36*r**2 - 75*r*s + 104*r - 85*s + 74) + Pkd2*k2*(69*r*s - 14*r + 65*s - 46))) - 6*f*(k1**2*(2*Pk2*r*(13*s - 47) + 8*Pk2*s*(K*(73 - 41*s) + 23*s - 25) + Pkd2*k2*(r*(27 - 10*s) + 2*s*(86*K*s - 127*K - 41*s + 34)) - 6*Pkdd2*k2**2*s*(K*(5*s - 6) - 2*s + 1)) + k2**2*(Pk2*(r**2*(36 - 36*K) + 2*r*(9*K + 23*s - 13) + 48*s) - Pkd2*k2*(r*(16*s + 3) + 24*s))) - 168*g2*(64*Pk2*k1**2*s*(s - 1) - 31*Pkd2*k1**2*k2*s*(s - 1) + k2**2*(7*Pk2*r*(r - 1) + 5*Pkdd2*k1**2*s*(s - 1)))) + 9940*Dd*Pk2*f**3*k1**2*r*s + 12640*Dd*Pk2*f**3*k1**2*r - 267520*Dd*Pk2*f**3*k1**2*s**2 + 217075*Dd*Pk2*f**3*k1**2*s - 41330*Dd*Pk2*f**3*k1**2 - 5440*Dd*Pk2*f**3*k2**2*r**2 - 3300*Dd*Pk2*f**3*k2**2*r*s + 7010*Dd*Pk2*f**3*k2**2*r + 23375*Dd*Pk2*f**3*k2**2*s - 7050*Dd*Pk2*f**3*k2**2 - 173184*Dd*Pk2*f*g2*k1**2*s**2 + 351648*Dd*Pk2*f*g2*k1**2*s - 77088*Dd*Pk2*f*g2*k1**2 - 19008*Dd*Pk2*f*g2*k2**2*r**2 + 14256*Dd*Pk2*f*g2*k2**2*r - 2376*Dd*Pk2*f*g2*k2**2 - 1660*Dd*Pkd2*f**3*k1**2*k2*r*s - 3710*Dd*Pkd2*f**3*k1**2*k2*r + 103840*Dd*Pkd2*f**3*k1**2*k2*s**2 - 82195*Dd*Pkd2*f**3*k1**2*k2*s + 15090*Dd*Pkd2*f**3*k1**2*k2 + 1100*Dd*Pkd2*f**3*k2**3*r*s - 440*Dd*Pkd2*f**3*k2**3*r - 275*Dd*Pkd2*f**3*k2**3*s + 110*Dd*Pkd2*f**3*k2**3 + 90816*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 156816*Dd*Pkd2*f*g2*k1**2*k2*s + 33528*Dd*Pkd2*f*g2*k1**2*k2 - 12320*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 + 9240*Dd*Pkdd2*f**3*k1**2*k2**2*s - 1540*Dd*Pkdd2*f**3*k1**2*k2**2 - 15840*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 + 22968*Dd*Pkdd2*f*g2*k1**2*k2**2*s - 4752*Dd*Pkdd2*f*g2*k1**2*k2**2 + 198*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(7*D1*bd1*s*(s - 1) + D1*fd*(6*s**2 - 13*s + 5) + Dd*f*(12*s**2 - 23*s + 5))))/(3465*d**2*k1**2*k2**2) - 2*D1**3*Pk1*ct**4*st**2*(252*b1**2*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1*f*(2*D1*(42*bd1*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(C*(5*s - 6) - 18*s + 16) + k1**2*k2**2*(-8*Pk2*(C*(11*r*(27*s - 17) + 642*s**2 - 672*s + 168) + r*(232 - 387*s) - 384*s**2 + 393*s - 93) - 3*k2*(Pkd2*(C*(r*(134 - 212*s) - 746*s**2 + 796*s - 199) + 4*r*(68*s - 41) + 316*s**2 - 331*s + 74) + Pkdd2*k2*(C*(106*s**2 - 116*s + 29) - 20*s**2 + 23*s - 4))) - 6*k2**4*r*(2*Pk2*(r*(2*C - 2) - 18*s + 9) + 9*Pkd2*k2*(2*s - 1)))) + Dd*f*(6*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(5*s - 6) - 18*s + 16) + k1**2*k2**2*(-4*Pk2*(2*C*(1188*r*s - 610*r + 2568*s**2 - 2145*s + 454) - 3096*r*s + 1490*r - 3072*s**2 + 2664*s - 653) - 3*k2*(Pkd2*(C*(-848*r*s + 444*r - 2984*s**2 + 2458*s - 486) + 1088*r*s - 534*r + 1264*s**2 - 1058*s + 251) + 2*Pkdd2*k2*(4*s - 1)*(C*(53*s - 29) - 10*s + 4))) + 3*k2**4*(Pk2*(-r**2*(32*C - 32) + 4*r*(2*C + 72*s - 15) + 20*s - 10) + Pkd2*k2*(r*(26 - 144*s) - 10*s + 5)))) + f**2*(D1*(3*bd1*(6*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(5*s - 6) - 18*s + 16) + k1**2*k2**2*(-4*Pk2*(2*C*(297*r*s - 118*r + 642*s**2 - 465*s + 118) - 774*r*s + 281*r - 768*s**2 + 720*s - 281) + 3*k2*(Pkd2*(C*(212*r*s - 88*r + 746*s**2 - 468*s + 88) - 272*r*s + 103*r - 316*s**2 + 248*s - 103) + 2*Pkdd2*k2*s*(C*(24 - 53*s) + 10*s + 1))) - 3*k2**4*(2*Pk2*(r**2*(4*C - 4) - r*(4*C + 36*s + 1) - 10*s + 5) + Pkd2*k2*(r*(36*s + 5) + 10*s - 5))) + 2*fd*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(6*C*(6*s - 5) - 105*s + 80) + k1**2*k2**2*(-2*Pk2*(3*C*(951*r*s - 650*r + 1956*s**2 - 1885*s + 522) - 3699*r*s + 2412*r - 3420*s**2 + 3225*s - 1088) + k2*(Pkd2*(3*C*(516*r*s - 352*r + 1707*s**2 - 1586*s + 399) - 2025*r*s + 1314*r - 2061*s**2 + 1824*s - 592) - Pkdd2*k2*(3*s - 1)*(3*C*(81*s - 43) - 39*s + 4))) - k2**4*(-2*Pk2*(C*(99*r**2 + 294*r - 109) - 99*r**2 + 63*r*(7*s - 8) - 21*s + 137) + Pkd2*k2*(333*r*s - 156*r + 15*s + 10)))) + Dd*f*(2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(6*C*(6*s - 5) - 105*s + 80) + k1**2*k2**2*(-4*Pk2*(C*(4*r*(951*s - 616) + 7824*s**2 - 6707*s + 1566) - 4932*r*s + 3063*r - 4560*s**2 + 3662*s - 1088) + k2*(Pkd2*(2*C*(4*r*(516*s - 335) + 6828*s**2 - 5671*s + 1197) - 5400*r*s + 3351*r - 5496*s**2 + 4109*s - 1184) - 2*Pkdd2*k2*(4*s - 1)*(3*C*(81*s - 43) - 39*s + 4))) - k2**4*(-2*Pk2*(C*(264*r**2 + 806*r - 218) - 264*r**2 + 3*r*(392*s - 439) - 7*s + 274) + Pkd2*k2*(r*(888*s - 367) + 65*s + 20)))))/(315*d**2*k1**2*k2**2*k3**2) + 2*D1**3*Pk1*ct**4*(3*D1*bd1*f*(7*b1*(k1**4*s*(4*C - 3)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(6*Pk2*(r*s*(10*C - 14) + r + s*(C*(16*s - 13) - 16*s + 14)) + k2*(Pkd2*r*(-s*(20*C - 32) - 3) + 2*Pkd2*s*(-5*C*(8*s - 5) + 33*s - 23) + Pkdd2*k2*s*(16*C - 9)*(2*s - 1))) + k2**4*(Pk2*r*(28*C - 28)*(2*r - 1) + Pkd2*k2*(r*(8*s - 7) + 3*s))) + f*(k1**4*(-2*Pk2*(r*(s - 107) + s**2*(982 - 424*C) + s*(680*C - 1123) + 107) + k2*(Pkd2*(r*(4*s - 57) + s**2*(887 - 464*C) + s*(628*C - 898) + 57) + 3*Pkdd2*k2*s*(4*C*(7*s - 8) - 44*s + 37))) - k1**2*k2**2*(-2*Pk2*(C*(24*r**2 - 3*r*(339*s - 80) - 520*s**2 + 658*s - 312) - 24*r**2 + 2*r*(544*s - 69) + s**2 - 237*s + 237) + k2*(Pkd2*(C*(-606*r*s + 296*r - 820*s**2 + 814*s - 344) + 628*r*s - 215*r + 169*s**2 - 352*s + 290) + 3*Pkdd2*k2*s*(C*(8*s + 6) + 36*s - 29))) + k2**4*(-6*Pk2*(r**2*(16*C - 7) + r*(-22*C - 57*s + 15) + 4*s - 2) + Pkd2*k2*(4*r*(4*s - 9) - 18*s - 3)))) + 21*b1**2*(D1*fd*(Pk2*k1**4*s**2*(32*C - 24) - Pkd2*k1**4*k2*s**2*(20*C - 15) + Pkd2*k1**2*k2**3*s*(r*(16 - 10*C) + s*(33 - 40*C)) + 4*Pkd2*k2**5*r*s + k1**2*k2**2*s*(6*Pk2*(r*(5*C - 7) + s*(8*C - 8)) + Pkdd2*k1**2*s*(4*C - 3)) + k2**4*(Pk2*r**2*(28*C - 28) + Pkdd2*k1**2*s**2*(16*C - 9))) + Dd*f*(k1**4*s*(4*C - 3)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(6*Pk2*(r*s*(20*C - 28) + r + s*(C*(32*s - 13) - 32*s + 14)) + k2*(Pkd2*r*(-s*(40*C - 64) - 3) + 2*Pkd2*s*(C*(25 - 80*s) + 66*s - 23) + Pkdd2*k2*s*(16*C - 9)*(4*s - 1))) + k2**4*(Pk2*r*(28*C - 28)*(4*r - 1) + Pkd2*k2*(r*(16*s - 7) + 3*s)))) + 3*b1*f*(D1*fd*(k1**4*(4*Pk2*(4*C*(106*s**2 - 187*s + 73) - r*s + 74*r - 982*s**2 + 1385*s - 474) + k2*(Pkd2*(-4*C*(232*s**2 - 340*s + 127) + 8*r*s - 81*r + 1774*s**2 - 2204*s + 726) + 3*Pkdd2*k2*(4*C*(14*s**2 - 17*s + 6) - 88*s**2 + 91*s - 28))) - k1**2*k2**2*(Pk2*(C*(-96*r**2 + 4068*r*s - 2040*r + 2080*s**2 - 2754*s + 564) + 96*r**2 - 4352*r*s + 2034*r - 4*s**2 + 504*s + 88) + k2*(Pkd2*(-2*C*(606*r*s - 308*r + 820*s**2 - 1059*s + 231) + 1256*r*s - 571*r + 338*s**2 - 685*s + 52) + 3*Pkdd2*k2*(2*C*(8*s**2 - 28*s + 7) + 72*s**2 - 49*s + 14))) + k2**4*(-6*Pk2*(C*(32*r**2 + 24*r - 6) - 14*r**2 - 114*r*s + 40*r - 7*s + 6) + Pkd2*k2*s*(32*r + 47))) + Dd*f*(k1**4*(2*Pk2*(8*C*(212*s**2 - 345*s + 73) - 4*r*s + 362*r - 3928*s**2 + 4841*s - 1055) + k2*(Pkd2*(-4*C*(464*s**2 - 624*s + 127) + 16*r*s - 195*r + 3548*s**2 - 3828*s + 783) + 12*Pkdd2*k2*(4*s - 1)*(C*(7*s - 6) - 11*s + 7))) - k1**2*k2**2*(-2*Pk2*(C*(96*r**2 - 4068*r*s + 1452*r - 2080*s**2 + 2437*s - 594) - 96*r**2 + 4352*r*s - 1236*r + 4*s**2 - 601*s + 193) + k2*(Pkd2*(-2*C*(1212*r*s - 568*r + 1640*s**2 - 1757*s + 403) + 2512*r*s - 920*r + 676*s**2 - 1245*s + 342) + 6*Pkdd2*k2*(4*s - 1)*(C*(4*s - 7) + 18*s - 7))) + k2**4*(-6*Pk2*(C*(64*r**2 + 8*r - 6) - 28*r**2 - 228*r*s + 51*r - 3*s + 4) + Pkd2*k2*(r*(64*s - 57) + 53*s - 3)))) + f**2*(D1*fd*(k1**4*(4*Pk2*(96*C*(9*s**2 - 24*s + 7) + 3*r*(57*s + 101) - 2511*s**2 + 3903*s - 1142) + k2*(-Pkd2*(72*C*(27*s**2 - 57*s + 16) + 6*r*(24*s + 55) - 4536*s**2 + 6207*s - 1691) + 5*Pkdd2*k2*(3*s - 1)*(8*C*(3*s - 4) - 45*s + 36))) - k1**2*k2**2*(-2*Pk2*(2*C*(261*r**2 + r*(930 - 2448*s) - 1692*s**2 + 405*s - 14) - 882*r**2 + r*(5553*s - 723) + 423*s**2 + 2511*s - 1162) + k2*(Pkd2*(-2*C*(12*r*(141*s - 92) + 2754*s**2 - 2427*s + 683) + 9*r*(468*s - 209) + 1602*s**2 - 1563*s + 502) + 45*Pkdd2*k2*(3*s - 1)*(C*(4*s - 2) + 3*s - 2))) + k2**4*(2*Pk2*(C*(-342*r**2 + 84*r + 10) + 99*r**2 + 3*r*(318*s - 83) + 474*s - 192) + 9*Pkd2*k2*(r*(7 - 24*s) - 2*s + 1))) + Dd*f*(k1**4*(4*Pk2*(96*C*(12*s**2 - 31*s + 7) + 228*r*s + 439*r - 3348*s**2 + 4909*s - 1142) + k2*(-Pkd2*(72*C*(36*s**2 - 73*s + 16) + 192*r*s + 475*r - 6048*s**2 + 7753*s - 1691) + 5*Pkdd2*k2*(4*s - 1)*(8*C*(3*s - 4) - 45*s + 36))) - k1**2*k2**2*(-4*Pk2*(C*(348*r**2 - 3264*r*s + 1115*r - 2256*s**2 + 234*s - 14) - 588*r**2 + 3702*r*s - 292*r + 282*s**2 + 1767*s - 581) + k2*(Pkd2*(-2*C*(8*r*(282*s - 179) + 3672*s**2 - 2782*s + 683) + 5616*r*s - 2283*r + 2136*s**2 - 1663*s + 502) + 45*Pkdd2*k2*(4*s - 1)*(C*(4*s - 2) + 3*s - 2))) + k2**4*(Pk2*(C*(-912*r**2 + 148*r + 20) + 264*r**2 + 2544*r*s - 452*r + 1286*s - 384) + 9*Pkd2*k2*(r*(6 - 32*s) - 2*s + 1)))))/(315*d**2*k1**2*k2**2*k3**2) - 4*D1**3*Pk1*ct**4*(3*D1*bd1*f*(7*b1*k2**2*(Pk2*k2**4*(8*r**2 + r*(8*s - 11) + 3*s) - k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*C*(7*s - 3) - 22*s + 13) + s*(4*C*(7*s - 4) - 22*s + 9)) + k1**2*k2**2*(Pk2*(r**2*(52 - 40*C) + r*(-88*C*s + 72*C + 100*s - 81) + s*(-48*C*s + 16*C + 48*s - 19)) + Pkd2*k2*(r*(64*C*s - 16*C - 34*s + 11) + s*(64*C*s - 48*C - 34*s + 23)))) + f*(Pk2*k2**6*(2*r**2 + 2*r*(s - 8) - 18*s - 3) + 3*k1**6*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) + k1**4*k2**2*(Pk2*(4*C*(21*r**2 + r*(91 - 68*s) - 89*s**2 + 261*s - 94) - 163*r**2 + 8*r*(62*s - 27) + 659*s**2 - 1123*s + 313) + 3*Pkd2*k2*(6*C*(r*(21*s - 16) + 21*s**2 - 37*s + 14) + r*(87 - 164*s) - 164*s**2 + 231*s - 76)) - k1**2*k2**4*(Pk2*(-4*C*(180*r**2 + r*(379*s - 234) + 199*s**2 - 222*s + 107) + 785*r**2 + 2*r*(585*s - 518) + 385*s**2 - 659*s + 450) + 3*Pkd2*k2*(2*C*(r*(8*s + 3) + 8*s**2 - 10*s + 9) + r*(87*s - 40) + 87*s**2 - 107*s + 27)))) + 21*b1**2*k2**2*(D1*fd*(r + s)*(4*Pk2*k2**4*r - k1**4*s*(14*C - 11)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(26 - 20*C) - Pk2*s*(24*C - 24) + Pkd2*k2*s*(32*C - 17))) + Dd*f*(Pk2*k2**4*(16*r**2 + r*(16*s - 11) + 3*s) - k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*C*(14*s - 3) - 44*s + 13) + s*(8*C*(7*s - 2) - 44*s + 9)) + k1**2*k2**2*(Pk2*(r**2*(104 - 80*C) + r*(-176*C*s + 72*C + 200*s - 81) + s*(-96*C*s + 16*C + 96*s - 19)) + Pkd2*k2*(r*(16*C*(8*s - 1) - 68*s + 11) + s*(16*C*(8*s - 3) - 68*s + 23))))) + 3*b1*f*(D1*fd*(Pk2*k2**6*(4*r**2 + r*(4*s + 38) + 61*s - 20) + 3*k1**6*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(4*C*(42*r**2 - 136*r*s + 94*r - 178*s**2 + 323*s - 117) - 326*r**2 + 992*r*s - 463*r + 1318*s**2 - 1845*s + 572) + 3*Pkd2*k2*(2*C*(126*r*s - 74*r + 126*s**2 - 151*s + 44) - 328*r*s + 155*r - 328*s**2 + 347*s - 88)) - k1**2*k2**4*(Pk2*(-4*C*(360*r**2 + 758*r*s - 535*r + 398*s**2 - 589*s + 167) + 1570*r**2 + 2340*r*s - 1847*r + 770*s**2 - 1468*s + 440) + 3*Pkd2*k2*(4*C*(8*r*s - 14*r + 8*s**2 - 25*s + 7) + 174*r*s - 63*r + 174*s**2 - 150*s + 35))) + Dd*f*(Pk2*k2**6*(8*r**2 + r*(8*s + 21) + 67*s - 23) + 6*k1**6*(4*Pk2 - Pkd2*k2)*(s + 4)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(4*C*(84*r**2 - 272*r*s + 261*r - 356*s**2 + 719*s - 211) - 652*r**2 + 1984*r*s - 884*r + 2636*s**2 - 3648*s + 885) + 12*Pkd2*k2*(C*(126*r*s - 79*r + 126*s**2 - 156*s + 43) - 164*r*s + 75*r - 164*s**2 + 171*s - 41)) - k1**2*k2**4*(Pk2*(-4*C*(720*r**2 + 1516*r*s - 873*r + 796*s**2 - 981*s + 274) + 3140*r**2 + 4680*r*s - 3329*r + 1540*s**2 - 2571*s + 890) + 6*Pkd2*k2*(C*(32*r*(s - 1) + 32*s**2 - 76*s + 23) + (87*s - 31)*(2*r + 2*s - 1))))) + f**2*(D1*fd*(-9*Pk2*k2**6*(12*r**2 + r*(12*s - 5) + 6*s - 3) + 5*k1**6*(4*Pk2 - Pkd2*k2)*(3*s + 5)*(3*r + 3*s - 2) + k1**4*k2**2*(Pk2*(4*C*(225*r**2 + 9*r*(16*s + 17) - 81*s**2 + 582*s - 277) - 2007*r**2 + 3*r*(108*s + 311) + 2331*s**2 - 2508*s + 453) + 5*Pkd2*k2*(12*C*(3*r*(9*s - 8) + 27*s**2 - 45*s + 17) - 495*r*s + 273*r - 495*s**2 + 621*s - 188)) - 3*k1**2*k2**4*(Pk2*(-4*C*(261*r**2 + 9*r*(75*s - 28) + 414*s**2 - 264*s + 22) + 1647*r**2 + 6*r*(426*s - 293) + 909*s**2 - 1146*s + 400) + 30*Pkd2*k2*(C*r*(12*s - 5) + 3*C*(1 - 2*s)**2 + (4*s - 2)*(3*r + 3*s - 2)))) + Dd*f*(-9*Pk2*k2**6*(8*r + 3)*(2*r + 2*s - 1) + 10*k1**6*(4*Pk2 - Pkd2*k2)*(r*(6*s + 11) + 6*s**2 + 6*s - 5) + k1**4*k2**2*(Pk2*(4*C*(300*r**2 + 3*r*(64*s + 95) - 108*s**2 + 727*s - 277) - 2676*r**2 + 432*r*s + 970*r + 3108*s**2 - 2998*s + 453) + 5*Pkd2*k2*(12*C*(4*r*(9*s - 8) + 36*s**2 - 54*s + 17) - 660*r*s + 347*r - 660*s**2 + 735*s - 188)) - 3*k1**2*k2**4*(-4*Pk2*(C*(348*r**2 + 900*r*s - 246*r + 552*s**2 - 292*s + 22) - 549*r**2 - 852*r*s + 490*r - 303*s**2 + 336*s - 100) + 15*Pkd2*k2*(2*C*(8*s - 3)*(2*r + 2*s - 1) + 32*r*s - 15*r + 32*s**2 - 33*s + 8)))))/(315*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*ct**3*f**2*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(11*b1*(33*s - 14)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s*(33*s - 14) + D1*fd*(724*s**2 - 461*s + 70) + Dd*f*(724*s**2 - 461*s + 70)))/(231*d**2*k1*k2) - 4*D1**3*Pk1*ct**3*f*k2*st**4*(6*D1*b1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(64*s - 39) + 64*s**2 - 78*s + 23) - 124*r*s + 69*r - 124*s**2 + 138*s - 38) + 3*k2**2*(Pk2*(-r*(36*C - 36) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)) + 3*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(64*s - 30) + 64*s**2 - 92*s + 30) + r*(45 - 124*s) - 124*s**2 + 152*s - 45) + k2**2*(2*Pk2*(-4*C*(27*r**2 + 27*r*s - 32*r - 10*s + 5) + 108*r**2 + 48*r*s - 113*r - 60*s**2 + 20*s + 5) + 15*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + D1*f*fd*(k1**2*(24*C - 39)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 3*(1 - 2*s)**2) + k2**2*(-2*Pk2*(4*C*(63*r**2 + 63*r*s - 48*r - 15*s + 7) - 252*r**2 - 72*r*s + 117*r + 180*s**2 - 120*s + 17) + 15*Pkd2*k2*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + 3*Dd*b1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(128*s - 69) + 128*s**2 - 147*s + 38) + r*(228 - 496*s) - 496*s**2 + 504*s - 121) + k2**2*(Pk2*(-8*C*(54*r - 5) + 432*r - 240*s + 50) + 15*Pkd2*k2*(8*s - 3))*(2*r + 2*s - 1)) + Dd*f**2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(64*s - 25) + 64*s**2 - 55*s + 12) + r*(80 - 208*s) - 208*s**2 + 180*s - 39) + k2**2*(-2*Pk2*(14*C*(24*r**2 + 3*r*(8*s - 5) - 5*s + 2) - 336*r**2 - 96*r*s + 120*r + 240*s**2 - 140*s + 17) + 15*Pkd2*k2*(8*s - 3)*(2*r + 2*s - 1))))/(105*d**2*k1*k3**4) - 2*D1**3*Pk1*ct**3*f*st**4*(3*b1*(D1*fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(26*s - 20) - 56*s + 35) + 3*k2**2*(-8*Pk2*(r*(36*C - 36) + 10*s - 5) + k2*(Pkd2*(r*(72*C - 72) + 50*s - 25) + 5*Pkdd2*k2*(1 - 2*s)))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(26*s - 20) - 56*s + 35) + k2**2*(-8*Pk2*(4*C*(108*r*s - 37*r - 10*s + 5) - 432*r*s + 148*r + 120*s**2 - 50*s - 5) + k2*(Pkd2*(8*C*(108*r*s - 37*r - 10*s + 5) - 864*r*s + 296*r + 600*s**2 - 370*s + 35) - 15*Pkdd2*k2*(8*s**2 - 6*s + 1))))) + f*(3*D1*bd1*(24*Pk2*k1**2*s*(C*(26*s - 20) - 56*s + 35) - 9*Pkd2*k1**2*k2*s*(C*(26*s - 20) - 56*s + 35) + Pkd2*k2**3*(8*C*(r*(27*s - 5) - 10*s + 5) - 8*r*(27*s - 5) + 150*s**2 + 5*s - 40) + 15*Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(-8*Pk2*(4*C*(27*r*s - 5*r - 10*s + 5) - 108*r*s + 20*r + 30*s**2 + 25*s - 20) + Pkdd2*k1**2*s*(C*(26*s - 20) - 56*s + 35))) + D1*fd*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(C*(42*s - 20) - 72*s + 35) - k2**2*(4*Pk2*(C*(666*r*s - 321*r - 174*s + 91) - 666*r*s + 321*r + 180*s**2 + 24*s - 61) + k2*(Pkd2*(-4*C*(180*r*s - 87*r - 48*s + 25) + 720*r*s - 348*r - 450*s**2 + 183*s + 25) + 15*Pkdd2*k2*(6*s**2 - 5*s + 1)))) + Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(42*s - 20) - 72*s + 35) - Dd*f*k2**2*(4*Pk2*(C*(888*r*s - 392*r - 194*s + 91) - 888*r*s + 392*r + 240*s**2 + 14*s - 61) + k2*(Pkd2*(-4*C*(240*r*s - 107*r - 53*s + 25) + 960*r*s - 428*r - 600*s**2 + 238*s + 25) + 15*Pkdd2*k2*(8*s**2 - 6*s + 1)))))/(105*d**2*k1*k2*k3**2) + 4*D1**3*Pk1*ct**3*st**2*(-3*D1*bd1*f*(14*b1*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(6*C*s + C - 18*s + 2) + s*(C*(6*s - 7) - 18*s + 16)) + k2**2*(-Pk2*(2*C - 2)*(22*r**2 + r*(22*s - 19) - 3*s) + 3*Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3)))) + f*(2*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(s - 9) + s**2 - 22*s + 9) + r*(36 - 25*s) - 25*s**2 + 88*s - 36) + k1**2*k2**2*(-2*Pk2*(C*(6*r**2 + 760*r*s - 282*r + 754*s**2 - 920*s + 302) - 81*r**2 - 685*r*s + 182*r - 604*s**2 + 485*s - 145) + Pkd2*k2*(C*(658*r*s - 296*r + 658*s**2 - 926*s + 322) - 364*r*s + 89*r - 364*s**2 + 383*s - 133)) + k2**4*(2*Pk2*(14*C*(16*r**2 + 16*r*s - 21*r - 6*s + 3) - 155*r**2 - 11*r*s + 226*r + 144*s**2 + 21*s - 43) - 3*Pkd2*k2*(r*(46*s - 9) + 46*s**2 - 47*s + 15)))) - 42*b1**2*k2**2*(D1*fd*(r + s)*(Pk2*k1**2*s*(6*C - 18) + Pk2*k2**2*r*(22 - 22*C) - Pkd2*k1**2*k2*s*(3*C - 9) + 6*Pkd2*k2**3*s) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(12*C*s + C - 36*s + 2) + s*(C*(12*s - 7) - 36*s + 16)) + k2**2*(-Pk2*(2*C - 2)*(44*r**2 + r*(44*s - 19) - 3*s) + 3*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) - 3*b1*f*(D1*fd*(2*k1**4*(4*Pk2 - Pkd2*k2)*(C*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + r*(53 - 50*s) - 50*s**2 + 113*s - 44) + k1**2*k2**2*(-2*Pk2*(4*C*(3*r**2 + 5*r*(76*s - 53) + 377*s**2 - 515*s + 158) - 162*r**2 - 1370*r*s + 917*r - 1208*s**2 + 1559*s - 446) + Pkd2*k2*(2*C*(47*r*(14*s - 9) + 658*s**2 - 836*s + 243) - 728*r*s + 456*r - 728*s**2 + 883*s - 228)) + k2**4*(4*Pk2*(14*C*(16*r**2 + 2*r*(8*s - 5) + 1) - 155*r**2 - 11*r*s + 30*r + 144*s**2 - 144*s + 22) - 3*Pkd2*k2*(r*(92*s - 56) + 92*s**2 - 109*s + 28))) + Dd*f*(2*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(4*s - 26) + 4*s**2 - 56*s + 20) - 25*r*(4*s - 5) - 100*s**2 + 245*s - 80) + k1**2*k2**2*(-2*Pk2*(2*C*(12*r**2 + 1520*r*s - 814*r + 1508*s**2 - 1814*s + 467) - 324*r**2 - 2740*r*s + 1225*r - 2416*s**2 + 2509*s - 591) + Pkd2*k2*(4*C*(658*r*s - 362*r + 658*s**2 - 775*s + 202) - 1456*r*s + 659*r - 1456*s**2 + 1513*s - 361)) + k2**4*(2*Pk2*(14*C*(64*r**2 + 64*r*s - 46*r - 6*s + 5) - 620*r**2 - 44*r*s + 357*r + 576*s**2 - 339*s + 1) - 3*Pkd2*k2*(r*(184*s - 79) + 184*s**2 - 185*s + 43)))) + f**2*(D1*fd*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + r*(99 - 126*s) - 126*s**2 + 204*s - 73) + k1**2*k2**2*(2*Pk2*(24*C*(162*r*s - 87*r + 162*s**2 - 180*s + 53) - 81*r**2 - 3015*r*s + 1068*r - 2934*s**2 + 2466*s - 508) - 3*Pkd2*k2*(8*C*(9*r*(15*s - 8) + 135*s**2 - 159*s + 47) - 45*r*(12*s - 5) - 540*s**2 + 558*s - 141)) + 2*k2**4*(Pk2*(-4*C*(198*r**2 + 9*r*(22*s - 7) + 42*s - 37) + 999*r**2 + 333*r*s - 597*r - 666*s**2 + 279*s + 32) + 27*Pkd2*k2*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + Dd*f*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(4*C*(r*(6*s - 7) + 6*s**2 - 12*s + 4) + r*(139 - 168*s) - 168*s**2 + 237*s - 73) + k1**2*k2**2*(-6*C*Pkd2*k2*(5*r*(144*s - 73) + 720*s**2 - 747*s + 188) + 4*Pk2*(12*C*(8*r*(27*s - 13) + 216*s**2 - 216*s + 53) - 54*r**2 - 2010*r*s + 533*r - 1956*s**2 + 1488*s - 254) + 9*Pkd2*k2*(r*(240*s - 89) + 240*s**2 - 219*s + 47)) + 2*k2**4*(-2*Pk2*(2*C*(264*r**2 + 264*r*s - 51*r + 67*s - 37) - 666*r**2 - 222*r*s + 358*r + 444*s**2 - 183*s - 16) + 27*Pkd2*k2*(8*s - 3)*(2*r + 2*s - 1)))))/(315*d**2*k1*k2*k3**4) - 4*D1**3*Pk1*ct**3*(3*D1*bd1*f*(7*b1*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(C*(8*s - 2) - 15*s + 5) + s*(C*(8*s - 6) - 15*s + 10)) + k1**2*k2**2*(2*Pk2*(r**2*(60*C - 67) + 4*r*(C*(27*s - 13) - 26*s + 13) + s*(8*C*(6*s - 7) - 37*s + 52)) + Pkd2*k2*(r*(8*C*(9*s - 1) - 94*s + 21) + s*(8*C*(9*s - 8) - 94*s + 73))) + k2**4*(2*Pk2*(r**2*(20*C - 13) + 2*r*(10*C*(s - 1) - 11*s + 6) + s*(10 - 9*s)) + 5*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)))) + f*(k1**4*(Pk2*(4*C*(3*r*(s + 14) + 3*s**2 + 59*s - 36) - 87*r**2 + 76*r*s - 167*r + 163*s**2 - 533*s + 194) + 3*Pkd2*k2*(4*C*(7*r*s - 8*r + 7*s**2 - 15*s + 7) - 82*r*s + 55*r - 82*s**2 + 127*s - 45)) - k1**2*k2**2*(-2*Pk2*(C*(346*r**2 + 868*r*s - 488*r + 522*s**2 - 648*s + 238) - 683*r**2 - 1288*r*s + 921*r - 605*s**2 + 803*s - 378) + 3*Pkd2*k2*(2*C*(38*r*s - 19*r + 38*s**2 - 58*s + 27) + 108*r*s - 54*r + 108*s**2 - 135*s + 27)) + k2**4*(Pk2*(4*C*(17*r**2 + 17*r*s + 4*r + 15*s - 15) - 295*r**2 - 564*r*s + 335*r - 269*s**2 + 291*s - 120) + 21*Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) - 21*b1**2*(-D1*fd*(r + s)*(-k1**4*s*(8*C - 15)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(60*C - 67) + Pk2*s*(48*C - 37) + Pkd2*k2*s*(36*C - 47)) - k2**4*(Pk2*r*(13 - 20*C) + 9*Pk2*s + 10*Pkd2*k2*s)) + Dd*f*(2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*C*(8*s - 1) - 30*s + 5) + 2*s*(C*(8*s - 3) - 15*s + 5)) + k1**2*k2**2*(-4*Pk2*(r**2*(60*C - 67) + 2*r*(54*C*s - 13*C - 52*s + 13) + s*(48*C*s - 28*C - 37*s + 26)) + Pkd2*k2*(r*(-144*C*s + 8*C + 188*s - 21) + s*(-144*C*s + 64*C + 188*s - 73))) + k2**4*(-4*Pk2*(r**2*(20*C - 13) + 2*r*(10*C*s - 5*C - 11*s + 3) + s*(5 - 9*s)) + 5*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) + 3*b1*f*(D1*fd*(k1**4*(Pk2*(4*C*(3*r*(2*s + 5) + 6*s**2 + 19*s - 11) - 174*r**2 + 8*r*(19*s - 4) + 326*s**2 - 485*s + 161) + 3*Pkd2*k2*(4*C*(7*s - 5)*(2*r + 2*s - 1) - 164*r*s + 77*r - 164*s**2 + 166*s - 42)) - k1**2*k2**2*(-4*Pk2*(C*(346*r**2 + 868*r*s - 556*r + 522*s**2 - 770*s + 223) - 683*r**2 - 1288*r*s + 854*r - 605*s**2 + 871*s - 244) + 3*Pkd2*k2*(2*C*(76*r*s - 63*r + 76*s**2 - 122*s + 35) + 216*r*s - 49*r + 216*s**2 - 143*s + 28)) + k2**4*(Pk2*(4*C*(34*r**2 + 34*r*s + 15*r + 25*s - 16) - 590*r**2 - 1128*r*s + 688*r - 538*s**2 + 753*s - 193) - 21*Pkd2*k2*s*(4*r + 4*s - 1))) + Dd*f*(k1**4*(Pk2*(4*C*(12*r*s + 87*r + 12*s**2 + 95*s - 47) - 348*r**2 + 304*r*s - 333*r + 652*s**2 - 1239*s + 355) + 3*Pkd2*k2*(8*C*(7*s - 6)*(2*r + 2*s - 1) - 328*r*s + 167*r - 328*s**2 + 345*s - 87)) - k1**2*k2**2*(-4*Pk2*(2*C*(346*r**2 + 868*r*s - 452*r + 522*s**2 - 666*s + 171) - 1366*r**2 - 2576*r*s + 1493*r - 1210*s**2 + 1527*s - 433) + 3*Pkd2*k2*(2*C*(152*r*s - 103*r + 152*s**2 - 221*s + 62) + 432*r*s - 124*r + 432*s**2 - 312*s + 55)) + k2**4*(Pk2*(4*C*(68*r**2 + 68*r*s + 35*r + 55*s - 31) - 1180*r**2 - 2256*r*s + 1125*r - 1076*s**2 + 1255*s - 313) - 21*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) + f**2*(D1*fd*(-9*Pk2*k2**4*(4*C*(3*r - 1)*(2*r + 2*s - 1) + 102*r**2 + 3*r*(80*s - 41) + 138*s**2 - 124*s + 29) + k1**4*(Pk2*(4*C*(15*r*(15*s + 7) + 225*s**2 - 36*s - 73) - 765*r**2 - 3*r*(396*s - 83) - 423*s**2 - 330*s + 291) + 5*Pkd2*k2*(4*C*(3*s - 7)*(3*r + 3*s - 2) - 189*r*s + 144*r - 189*s**2 + 279*s - 99)) - 3*k1**2*k2**2*(Pk2*(-4*C*(36*r**2 + r*(405*s - 78) + 369*s**2 - 258*s + 22) + 1683*r**2 + 6*r*(606*s - 359) + 1953*s**2 - 2106*s + 612) + 15*Pkd2*k2*(8*C*(2*s - 1)*(3*r + 3*s - 2) + 5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + Dd*f*(-9*Pk2*k2**4*(4*C*(4*r - 1)*(2*r + 2*s - 1) + 136*r**2 + 320*r*s - 129*r + 184*s**2 - 147*s + 29) + k1**4*(Pk2*(4*C*(25*r*(12*s + 7) + 300*s**2 - 33*s - 73) - 1020*r**2 - 1584*r*s + 55*r - 564*s**2 - 427*s + 291) + 5*Pkd2*k2*(4*C*(r*(12*s - 29) + 12*s**2 - 33*s + 14) - 63*r*(4*s - 3) - 252*s**2 + 333*s - 99)) - 3*k1**2*k2**2*(-4*Pk2*(C*(48*r**2 + 540*r*s - 54*r + 492*s**2 - 304*s + 22) - 561*r**2 - 1212*r*s + 592*r - 651*s**2 + 626*s - 153) + 15*Pkd2*k2*(2*C*(32*r*s - 15*r + 32*s**2 - 33*s + 8) + 20*r*s - 13*r + 20*s**2 - 25*s + 7)))))/(315*d**2*k1*k2*k3**4) + 2*D1**3*Pk1*ct**3*st**2*(33*b1**2*k1**2*(D1*fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + k2**2*(8*Pk2*(3*f*(52*s**2 - 33*s + 10) + (s - 1)*(7*r*(11*K - 11) + 42*s - 42)) + k2*(-15*Pkd2*f*(52*s**2 - 33*s + 10) - 14*Pkd2*(s - 1)*(r*(11*K - 11) + 15*s - 15) + 3*Pkdd2*f*k2*(52*s**2 - 33*s + 10) + 42*Pkdd2*k2*(s - 1)**2))) + Dd*f*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(f*(13*s - 10) + 14*s - 14) + 2*k2**2*(4*Pk2*(7*K*(44*r*s - 20*r - 3*s + 3) + 6*f*(52*s**2 - 33*s + 5) - 308*r*s + 140*r + 168*s**2 - 189*s + 21) + k2*(-15*Pkd2*f*(52*s**2 - 33*s + 5) - 7*Pkd2*(K*(44*r*s - 20*r - 3*s + 3) - 44*r*s + 20*r + 60*s**2 - 72*s + 12) + 3*Pkdd2*k2*(4*s - 1)*(13*f*s - 5*f + 7*s - 7))))) + 11*b1*(D1*(f**2*(9*bd1*k1**2*s*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(52*s - 33)) + fd*(360*Pk2*k2**4*r**2 + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 219*s + 50) + k1**2*k2**2*(-24*Pk2*(3*r*(6*s - 17) + 537*s**2 - 406*s + 73) + k2*(Pkd2*(432*r*s - 468*r + 4005*s**2 - 3300*s + 576) + Pkdd2*k2*(-261*s**2 + 276*s - 40))))) + 3*f*k1**2*(14*bd1*(144*Pk2*k1**2*s*(s - 1) - 54*Pkd2*k1**2*k2*s*(s - 1) + Pkd2*k2**3*(K*(-22*r*s + 6*r + 3*s - 3) + 22*r*s - 6*r - 30*s**2 + 27*s + 3) + 6*Pkdd2*k2**4*s*(s - 1) + 2*k2**2*(2*Pk2*(K*(22*r*s - 6*r - 3*s + 3) - 22*r*s + 6*r + 12*s**2 - 9*s - 3) + 3*Pkdd2*k1**2*s*(s - 1))) + 3*fd*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) + fd*k2**2*(2*Pk2*(7*K*(r*(22*s - 30) - 3*s + 11) + r*(210 - 154*s) + 120*s**2 - 183*s - 5) + k2*(Pkd2*(-14*K*(r*(6*s - 8) - s + 3) + 28*r*(3*s - 4) - 150*s**2 + 241*s - 48) + 3*Pkdd2*k2*(10*s**2 - 17*s + 6))) + 28*gd2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(11*s - 3)) + 924*fd*g2*k1**2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(s - 1)) + Dd*f*(f**2*(120*Pk2*k2**4*r*(4*r - 1) + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 269*s + 50) + k1**2*k2**2*(-8*Pk2*(6*r*(12*s - 41) + 2148*s**2 - 1433*s + 281) + k2*(Pkd2*(576*r*s - 708*r + 5340*s**2 - 3715*s + 736) + Pkdd2*k2*(-348*s**2 + 247*s - 40)))) + 3*f*k1**2*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + k2**2*(2*Pk2*(7*K*(r*(44*s - 52) - 3*s + 11) + r*(364 - 308*s) + 240*s**2 - 327*s - 5) + k2*(Pkd2*(-14*K*(2*r*(6*s - 7) - s + 3) + 28*r*(6*s - 7) - 300*s**2 + 421*s - 48) + 3*Pkdd2*k2*(20*s**2 - 29*s + 6)))) + 84*g2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(4*r*(11*s - 5) - 3*s + 3))) + f*(D1*f**2*(11*bd1*(120*Pk2*k2**4*r*(r - 1) + 2*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(69*s - 50) - k1**2*k2**2*(8*Pk2*(3*r*(6*s - 31) + 537*s**2 - 215*s + 62) + k2*(-48*Pkd2*r*(3*s - 5) - 5*Pkd2*(267*s**2 - 83*s + 32) + 29*Pkdd2*k2*s*(3*s + 1)))) + fd*(420*Pk2*k2**4*(12*r**2 + 5*r - 2) + 25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(92*s**2 - 79*s + 14) + k1**2*k2**2*(-8*Pk2*(48*r*(9*s - 38) + 18260*s**2 - 11801*s + 2238) + k2*(Pkd2*(3328*r*s - 4880*r + 53020*s**2 - 34943*s + 6434) - 275*Pkdd2*k2*(20*s**2 - 13*s + 2))))) + 33*D1*f*k1**2*(bd1*(72*Pk2*k1**2*s*(5*s - 6) - 27*Pkd2*k1**2*k2*s*(5*s - 6) + 3*Pkd2*k2**3*(r*(14 - 14*K)*(s - 1) + s*(30 - 25*s)) + 3*Pkdd2*k2**4*s*(5*s - 6) + k2**2*(Pk2*r*(154*K - 154)*(s - 1) + 24*Pk2*s*(5*s - 6) + 3*Pkdd2*k1**2*s*(5*s - 6))) + 28*gd2*k2**2*r*(-11*Pk2 + 3*Pkd2*k2)*(s - 1)) + 924*D1*g2*k1**2*k2**2*(-bd1*(4*Pk2 - Pkd2*k2)*(r*(11*s - 3) - 3*s + 3) + fd*(Pk2*(-22*r*s + 30*r + 3*s - 11) + Pkd2*k2*(6*r*s - 8*r - s + 3))) + Dd*f**3*(420*Pk2*k2**4*(12*r**2 + 5*r - 2) + 25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(92*s**2 - 79*s + 14) + k1**2*k2**2*(-8*Pk2*(48*r*(9*s - 38) + 18260*s**2 - 11801*s + 2238) + k2*(Pkd2*(3328*r*s - 4880*r + 53020*s**2 - 34943*s + 6434) - 275*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 924*Dd*f*g2*k1**2*k2**2*(Pk2*(r*(52 - 44*s) + 3*s - 11) + Pkd2*k2*(2*r*(6*s - 7) - s + 3))))/(3465*d**2*k1**3*k2**3) + D1**3*Pk1*ct**3*(231*b1**3*k1**2*s*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(D1*(-7*bd1*f*k1**2*s*(3*s - 1)*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2)) + fd*(Pk2*k2**4*r**2*(96*f + 252) + k1**4*(8*Pk2*(f*(306*s**2 - 371*s + 112) + 175*s**2 - 294*s + 147) + k2*(-Pkd2*(f*(1026*s**2 - 1183*s + 350) + 644*s**2 - 1008*s + 504) + Pkdd2*k2*(3*f*(46*s**2 - 49*s + 14) + 98*s**2 - 140*s + 70))) + k1**2*k2**2*(-4*Pk2*(84*K*s + f*(4*r*(2*s + 5) - 336*s**2 + 181*s - 70) - r*(21*K - 21)*(17*s - 13) - 77*s**2 + 70*s - 77) + k2*(Pkd2*f*(4*r*(32*s + 3) - 930*s**2 + 495*s - 182) - 28*Pkd2*(r*(K - 1)*(11*s - 5) + 9*s**2 - s*(6*K + 10) + 8) + 3*Pkdd2*f*k2*(86*s**2 - 49*s + 14) + 14*Pkdd2*k2*(7*s**2 - 10*s + 5))))) + Dd*f*(Pk2*k2**4*r*(48*f + 252)*(4*r - 1) + k1**4*(4*s - 1)*(8*Pk2*(153*f*s - 112*f + 175*s - 147) + k2*(Pkd2*(-513*f*s + 350*f - 644*s + 504) + Pkdd2*k2*(69*f*s - 42*f + 98*s - 70))) + k1**2*k2**2*(4*Pk2*f*(-4*r*(4*s + 1) + 672*s**2 - 396*s + 59) + 28*Pk2*(4*s - 1)*(K*(51*r - 8) - 51*r + 11*s - 3) + Pkd2*k2*(-28*K*(44*r*s - 8*r - 15*s + 3) + f*(16*r*(16*s - 3) - 1860*s**2 + 1033*s - 146) + 1232*r*s - 224*r - 1008*s**2 + 728*s - 140) + Pkdd2*k2**2*(4*s - 1)*(3*f*(43*s - 14) + 98*s - 70)))) - 11*b1*(D1*(f**2*(6*bd1*(24*Pk2*k2**4*r*(2*r - 1) + k1**4*s*(8*Pk2*(153*s - 115) + k2*(-513*Pkd2*s + 365*Pkd2 + 69*Pkdd2*k2*s - 45*Pkdd2*k2)) + k1**2*k2**2*(-2*Pk2*(8*r*(s - 2) - 336*s**2 + 215*s + 11) + k2*(Pkd2*(64*r*s - 30*r - 465*s**2 + 269*s + 18) + 3*Pkdd2*k2*s*(43*s - 25)))) + fd*(24*Pk2*k2**4*(9*r**2 + 3*r - 2) + 9*k1**4*(8*Pk2*(203*s**2 - 234*s + 56) + k2*(Pkd2*(-691*s**2 + 738*s - 172) + 5*Pkdd2*k2*(19*s**2 - 18*s + 4))) + k1**2*k2**2*(12*Pk2*(78*r**2 - 2*r*(18*s + 41) - 126*s**2 + 72*s + 61) + k2*(Pkd2*(48*r*(45*s - 11) + 486*s**2 - 1647*s + 110) + 45*Pkdd2*k2*(18*s**2 - 9*s + 2))))) + 6*f*(2*Pk2*fd*k2**4*(38*r**2 - 17*r - 1) + 14*bd1*(9*Pk2*k2**4*r*(2*r - 1) + k1**4*s*(4*Pk2*(25*s - 23) + k2*(Pkd2*(41 - 46*s) + Pkdd2*k2*(7*s - 6))) + k1**2*k2**2*(2*Pk2*(K*(51*r*s - 5*r - 7*s + 4) - 51*r*s + 5*r + 11*s**2 - 4*s - 4) + k2*(Pkd2*(K*(-22*r*s + 3*r + 6*s - 3) + 22*r*s - 3*r - 18*s**2 + 11*s + 3) + Pkdd2*k2*s*(7*s - 6)))) + fd*k1**4*(2*s - 1)*(4*Pk2*(67*s - 107) + k2*(Pkd2*(170 - 130*s) + 21*Pkdd2*k2*(s - 1))) + fd*k1**2*k2**2*(2*Pk2*(K*(226*r*s - 141*r + 160*s - 66) + 20*r**2 - 230*r*s + 53*r + 50*s**2 - 229*s + 128) + k2*(-2*Pkd2*(K*(62*r*s - 52*r + 11*s + 5) - 78*r*s + 46*r + 46*s**2 - 70*s + 20) + 21*Pkdd2*k2*(2*s**2 - 3*s + 1))) + 28*gd2*k1**2*k2**2*(Pk2*r*(2 - 51*s) + 6*Pk2*s + Pkd2*k2*s*(11*r - 3))) + 168*fd*g2*k1**2*k2**2*(Pk2*r*(39 - 51*s) + 12*Pk2*s + Pkd2*k2*r*(11*s - 5) - 6*Pkd2*k2*s)) + Dd*f*(f**2*(24*Pk2*k2**4*(12*r**2 + 5*r - 2) + 3*k1**4*(4*s - 1)*(56*Pk2*(29*s - 24) + k2*(-691*Pkd2*s + 516*Pkd2 + 95*Pkdd2*k2*s - 60*Pkdd2*k2)) + 2*k1**2*k2**2*(2*Pk2*(312*r**2 - 2*r*(72*s + 91) - 504*s**2 + 150*s + 29) + k2*(Pkd2*(1440*r*s - 452*r + 324*s**2 - 897*s + 227) + 45*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 6*f*(2*Pk2*k2**4*(76*r**2 - 15*r - 1) + k1**4*(4*s - 1)*(4*Pk2*(67*s - 107) + k2*(Pkd2*(170 - 130*s) + 21*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(K*(452*r*s - 201*r + 352*s - 66) + 40*r**2 - 460*r*s - r + 100*s**2 - 431*s + 128) + k2*(-2*Pkd2*(K*(124*r*s - 92*r + 41*s + 5) - 156*r*s + 62*r + 92*s**2 - 126*s + 20) + 21*Pkdd2*k2*(4*s**2 - 5*s + 1)))) + 168*g2*k1**2*k2**2*(-Pk2*(51*r - 8)*(4*s - 1) + Pkd2*k2*(r*(44*s - 8) - 15*s + 3)))) - f*(D1*(f**2*(11*bd1*(24*Pk2*k2**4*r*(3*r + 2) + 3*k1**4*s*(8*Pk2*(203*s - 173) + k2*(-691*Pkd2*s + 541*Pkd2 + 95*Pkdd2*k2*s - 65*Pkdd2*k2)) + k1**2*k2**2*(8*Pk2*(39*r**2 + r*(32 - 18*s) - 63*s**2 - 33*s - 77) + k2*(Pkd2*(8*r*(90*s - 47) + 162*s**2 - 147*s + 344) + 45*Pkdd2*k2*s*(6*s - 5)))) + 5*fd*k1**2*(11*k1**2*(4*s - 1)*(40*Pk2*(9*s - 8) + k2*(Pkd2*(122 - 153*s) + 7*Pkdd2*k2*(3*s - 2))) + 8*k2**2*(Pk2*(244*r**2 + 176*r*s - 133*r - 1540*s**2 + 253*s + 40) + 44*Pkd2*k2*(8*r*s - 4*r + 20*s**2 - 15*s + 3)))) + 66*f*(bd1*(2*Pk2*k2**4*r*(19*r + 1) + k1**4*s*(4*Pk2*(67*s - 107) + k2*(Pkd2*(170 - 130*s) + 21*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(10*r**2 + r*(113*K*s - 30*K - 115*s - 27) + s*(96*K + 25*s - 101)) + k2*(-2*Pkd2*(r*(31*K*s - 20*K - 39*s + 8) + s*(15*K + 23*s - 28)) + 21*Pkdd2*k2*s*(s - 1)))) + 2*k1**2*k2**2*(bd2*(-Pk2*r*(s + 19) + 30*Pk2*s + Pkd2*k2*(r*(4*s + 6) - 15*s)) + 2*gd2*(Pk2*r*(30 - 113*s) - 96*Pk2*s + Pkd2*k2*r*(31*s - 20) + 15*Pkd2*k2*s))) + 132*k1**2*k2**2*(b2*fd*(-Pk2*(2*r*(s + 10) - 43*s + 11) + Pkd2*k2*(r*(8*s + 3) - 25*s + 9)) + 2*g2*(-7*bd1*(Pk2*(51*r*s - 8*r - 8*s + 8) + Pkd2*k2*(-11*r*s + 3*r + 3*s - 3)) + fd*(Pk2*(-226*r*s + 141*r - 160*s + 66) + Pkd2*k2*(62*r*s - 52*r + 11*s + 5))))) + Dd*f*k1**2*(5*f**2*(11*k1**2*(4*s - 1)*(40*Pk2*(9*s - 8) + k2*(Pkd2*(122 - 153*s) + 7*Pkdd2*k2*(3*s - 2))) + 8*k2**2*(Pk2*(244*r**2 + 176*r*s - 133*r - 1540*s**2 + 253*s + 40) + 44*Pkd2*k2*(8*r*s - 4*r + 20*s**2 - 15*s + 3))) + 132*k2**2*(-Pk2*b2*(r*(4*s + 58) - 103*s + 11) + 2*Pk2*g2*(r*(201 - 452*s) - 352*s + 66) + Pkd2*b2*k2*(r*(16*s + 15) - 55*s + 9) + 2*Pkd2*g2*k2*(4*r*(31*s - 23) + 41*s + 5)))))/(3465*d**2*k1**3*k2**3) - 2*D1**3*Pk1*ct**3*st**2*(42*b1**2*k1**2*k2**2*(D1*fd*s*(Pk2*k1**2*s*(8*C - 32) - Pkd2*k1**2*k2*s*(5*C - 20) + Pkd2*k2**3*(r*(22*C - 22) + 3*s) - 3*Pkdd2*k2**4*s + k2**2*(Pk2*r*(44 - 44*C) + Pkdd2*k1**2*s*(C - 4))) + Dd*f*(Pk2*k1**2*s*(8*C - 32)*(4*s - 1) - Pkd2*k1**2*k2*s*(5*C - 20)*(4*s - 1) + Pkd2*k2**3*(r*(8*C - 8)*(11*s - 2) + 3*s*(-2*C + 4*s + 1)) + 3*Pkdd2*k2**4*s*(1 - 4*s) + k2**2*(-Pk2*(4*C - 4)*(r*(44*s - 8) - 3*s) + Pkdd2*k1**2*s*(C - 4)*(4*s - 1)))) - 3*b1*f*(D1*(-14*bd1*k1**2*k2**2*(Pk2*k1**2*s*(8*C - 32)*(2*s - 1) - Pkd2*k1**2*k2*s*(5*C - 20)*(2*s - 1) + Pkd2*k2**3*(r*(4*C - 4)*(11*s - 4) + 3*s*(-2*C + 2*s + 1)) + 3*Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(-Pk2*(4*C - 4)*(r*(22*s - 8) - 3*s) + Pkdd2*k1**2*s*(C - 4)*(2*s - 1))) + fd*(-240*Pk2*k2**6*r**2 + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) + k1**4*k2**2*(8*Pk2*(C*(81*r*s - 121*r + 912*s**2 - 1294*s + 404) - 258*r*s + 248*r - 996*s**2 + 1303*s - 380) + k2*(Pkd2*(-2*C*(88*r*s - 128*r + 1668*s**2 - 2329*s + 710) + 572*r*s - 538*r + 2892*s**2 - 3839*s + 1084) + 3*Pkdd2*k2*(2*C*(84*s**2 - 115*s + 34) - 100*s**2 + 137*s - 36))) - 2*k1**2*k2**4*(Pk2*r**2*(240*C - 240) + 4*Pk2*r*(C*(599*s - 324) - 497*s + 259) + 6*Pk2*(96*s**2 + s*(7*C - 103) + 24) - Pkd2*k2*(6*r*(14*C*(5*s - 3) - 43*s + 25) + 357*s**2 + s*(14*C - 386) + 93) + 3*Pkdd2*k2**2*(23*s**2 - 28*s + 7)))) + Dd*f*(120*Pk2*k2**6*r*(1 - 4*r) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + 2*k1**4*k2**2*(2*Pk2*(C*(36*r*(9*s - 13) + 3648*s**2 - 4209*s + 921) - 1032*r*s + 982*r - 3984*s**2 + 4284*s - 1003) + k2*(Pkd2*(-2*C*(88*r*s - 124*r + 1668*s**2 - 1855*s + 385) + 572*r*s - 533*r + 2892*s**2 - 3029*s + 674) + 3*Pkdd2*k2*(4*s - 1)*(C*(42*s - 34) - 25*s + 18))) + k1**2*k2**4*(-4*Pk2*(C*(240*r**2 + 2396*r*s - 752*r - 51*s + 36) - 240*r**2 - 1988*r*s + 522*r + 576*s**2 - 453*s + 86) + k2*(Pkd2*(28*C*(60*r*s - 22*r - 5*s + 3) - 1032*r*s + 268*r + 1428*s**2 - 1063*s + 174) - 3*Pkdd2*k2*(92*s**2 - 79*s + 14))))) + f**2*(D1*(-3*bd1*(-120*Pk2*k2**6*r*(r - 1) + 3*k1**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(5*s - 6) + k1**4*k2**2*(4*Pk2*(C*(81*r*s - 113*r + 912*s**2 - 813*s + 113) - 258*r*s + 243*r - 996*s**2 + 918*s - 243) + k2*(Pkd2*(-2*C*(44*r*s - 60*r + 834*s**2 - 671*s + 60) + 286*r*s - 264*r + 1446*s**2 - 1135*s + 264) + 3*Pkdd2*k2*s*(C*(84*s - 58) - 50*s + 21))) - k1**2*k2**4*(4*Pk2*(C*(60*r**2 + 599*r*s - 68*r - 72*s + 36) - 60*r**2 - 497*r*s + 18*r + 144*s**2 - 72*s + 14) + k2*(Pkd2*(-28*C*(15*r*s - r - 6*s + 3) + 258*r*s + 44*r - 357*s**2 + 105*s + 12) + 3*Pkdd2*k2*s*(23*s - 9)))) - 2*fd*(-2*Pk2*k2**6*(9*r**2 - 114*r + 37) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(18*s**2 - 21*s + 5) + k1**4*k2**2*(4*C*Pk2*(9*r*(45*s - 37) + 2502*s**2 - 2793*s + 719) - 3*Pk2*(r*(1083*s - 958) + 3408*s**2 - 3533*s + 998) + Pkd2*k2*(C*(-72*r*(6*s - 5) - 4473*s**2 + 4845*s - 1190) + r*(900*s - 786) + 3609*s**2 - 3624*s + 969) + Pkdd2*k2**2*(3*s - 1)*(C*(219*s - 154) - 117*s + 66)) + k1**2*k2**4*(3*Pk2*(2*C*(6*r**2 - 870*r*s + 235*r - 10*s + 21) - 42*r**2 + 1179*r*s + 82*r - 444*s**2 + 419*s - 244) + k2*(2*C*Pkd2*(r*(774*s - 375) - 42*s + 53) + 3*Pkd2*(r*(95 - 348*s) + 276*s**2 - 179*s + 36) - 27*Pkdd2*k2*(6*s**2 - 5*s + 1))))) - 2*Dd*f*(-2*Pk2*k2**6*(12*r**2 - 151*r + 37) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(24*s**2 - 26*s + 5) + k1**4*k2**2*(Pk2*(4*C*(108*r*(5*s - 4) + 3336*s**2 - 3413*s + 719) + r*(3824 - 4332*s) - 13632*s**2 + 12643*s - 2994) + k2*(Pkd2*(C*(r*(468 - 576*s) - 5964*s**2 + 5927*s - 1190) + 2*r*(600*s - 523) + 4812*s**2 - 4333*s + 969) + Pkdd2*k2*(4*s - 1)*(C*(219*s - 154) - 117*s + 66))) + k1**2*k2**4*(Pk2*(2*C*(24*r**2 - 3480*r*s + 758*r - 146*s + 63) - 168*r**2 + 4716*r*s + 716*r - 1776*s**2 + 1519*s - 732) + k2*(Pkd2*(2*C*(1032*r*s - 478*r + 8*s + 53) - 1392*r*s + 319*r + 1104*s**2 - 679*s + 108) - 27*Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(315*d**2*k1**3*k2**3*k3**2) - 2*D1**3*Pk1*ct**3*(21*b1**2*(D1*fd*(18*Pk2*k2**6*r**2 + 2*k1**6*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**4*k2**2*s*(Pk2*(80*C*r + 24*C*s - 81*r - 2*s) + k2*(Pkd2*r*(43 - 40*C) - 16*Pkd2*s + Pkdd2*k2*s*(17 - 12*C))) + k1**2*k2**4*(Pk2*r*(r*(4*C - 4) + s*(116*C - 101)) + k2*s*(Pkd2*r*(17 - 20*C) + 4*Pkd2*s + 5*Pkdd2*k2*s))) + Dd*f*(18*Pk2*k2**6*r*(4*r - 1) + 2*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**4*k2**2*(Pk2*(r*(40*C*(8*s - 1) - 324*s + 58) + s*(32*C*(3*s - 2) - 8*s + 25)) + k2*(Pkd2*r*(-20*C*(8*s - 1) + 172*s - 29) + 2*Pkd2*s*(10*C - 32*s + 1) - Pkdd2*k2*s*(12*C - 17)*(4*s - 1))) + k1**2*k2**4*(Pk2*(r**2*(16*C - 16) + 4*r*(4*C*(29*s - 7) - 101*s + 28) - s*(8*C + 7)) + k2*(Pkd2*r*(C*(20 - 80*s) + 68*s - 21) + 16*Pkd2*s**2 + 5*Pkdd2*k2*s*(4*s - 1))))) + 3*b1*f*(D1*(7*bd1*(18*Pk2*k2**6*r*(2*r - 1) + 2*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**4*k2**2*(Pk2*(2*r*(80*C*s - 20*C - 81*s + 29) + s*(48*C*s - 64*C - 4*s + 25)) + k2*(Pkd2*r*(C*(20 - 80*s) + 86*s - 29) + 2*Pkd2*s*(10*C - 16*s + 1) - Pkdd2*k2*s*(12*C - 17)*(2*s - 1))) + k1**2*k2**4*(Pk2*(r**2*(8*C - 8) + 2*r*(116*C*s - 56*C - 101*s + 56) - s*(8*C + 7)) + k2*(Pkd2*r*(C*(20 - 40*s) + 34*s - 21) + 8*Pkd2*s**2 + 5*Pkdd2*k2*s*(2*s - 1)))) + fd*(-2*Pk2*k2**6*(46*r**2 + 17*r + 1) + k1**6*(4*Pk2*(182*s**2 - 281*s + 107) + k2*(-10*Pkd2*(38*s**2 - 47*s + 17) + 3*Pkdd2*k2*(22*s**2 - 21*s + 7))) + k1**4*k2**2*(Pk2*(4*C*(358*r*s - 171*r + 648*s**2 - 870*s + 240) + 196*r**2 - 2472*r*s + 866*r - 1552*s**2 + 2185*s - 396) + k2*(Pkd2*(C*(-872*r*s + 448*r - 2244*s**2 + 2802*s - 756) + 1588*r*s - 651*r + 1520*s**2 - 1976*s + 411) + 3*Pkdd2*k2*(C*(60*s**2 - 98*s + 28) + 64*s**2 - 21*s + 7))) + k1**2*k2**4*(Pk2*(-4*C*(156*r**2 + 262*r*s - 387*r - 110*s + 60) + 704*r**2 + 856*r*s - 1408*r + 336*s**2 - 923*s + 362) + k2*(Pkd2*(-44*C*s + r*(-248*C*s + 580*s - 119) + 496*s**2 - 584*s + 105) + 42*Pkdd2*k2*s**2)))) + Dd*f*(-2*Pk2*k2**6*(92*r**2 - 27*r + 1) + k1**6*(4*s - 1)*(4*Pk2*(91*s - 107) + k2*(Pkd2*(170 - 190*s) + 3*Pkdd2*k2*(11*s - 7))) + k1**4*k2**2*(2*Pk2*(2*C*r*(716*s - 411) + 8*C*(324*s**2 - 383*s + 90) + 196*r**2 + r*(931 - 2472*s) - 1552*s**2 + 2038*s - 503) + k2*(Pkd2*(-2*C*(r*(872*s - 508) + 2244*s**2 - 2351*s + 520) + 4*r*(794*s - 339) + 3040*s**2 - 3378*s + 795) + 3*Pkdd2*k2*(4*s - 1)*(C*(30*s - 28) + 32*s - 7))) + k1**2*k2**4*(-4*Pk2*(C*(312*r**2 + r*(524*s - 471) - 242*s + 126) - 352*r**2 - 428*r*s + 455*r - 168*s**2 + 398*s - 154) + k2*(Pkd2*(C*(r*(48 - 496*s) - 164*s + 60) + 4*r*(290*s - 73) + 992*s**2 - 970*s + 181) + 21*Pkdd2*k2*s*(4*s - 1))))) + f**2*(D1*(3*bd1*(2*Pk2*k2**6*r*(43 - 23*r) + k1**6*s*(4*Pk2*(91*s - 131) + k2*(Pkd2*(230 - 190*s) + 33*Pkdd2*k2*(s - 1))) + k1**4*k2**2*(Pk2*(4*C*(179*r*s - 150*r + 324*s**2 - 392*s + 120) + 98*r**2 - 1236*r*s + 650*r - 776*s**2 + 1231*s - 610) + k2*(Pkd2*(-2*C*(218*r*s - 172*r + 561*s**2 - 542*s + 142) + 794*r*s - 453*r + 760*s**2 - 859*s + 384) + 6*Pkdd2*k2*s*(C*(15*s - 8) + 16*s - 16))) + k1**2*k2**4*(Pk2*(-4*C*(78*r**2 + 131*r*s - 24*r - 66*s + 66) + 352*r**2 + 4*r*(107*s - 36) + 168*s**2 - 321*s + 254) + k2*(Pkd2*(C*(-124*r*s + 48*r - 60*s + 60) + 145*r*(2*s - 1) + 248*s**2 - 233*s + 76) + 21*Pkdd2*k2*s*(s - 1)))) + fd*(144*Pk2*k2**6*r*(1 - 3*r) + k1**6*(3*s - 1)*(Pk2*(516*s - 964) + k2*(-8*Pkd2*(33*s - 47) + 45*Pkdd2*k2*(s - 1))) + k1**4*k2**2*(4*C*Pk2*(63*r*s - 597*r + 1602*s**2 - 1764*s + 602) + 3*Pk2*(390*r**2 + r*(444 - 807*s) - 1302*s**2 + 405*s - 92) + Pkd2*k2*(-2*C*(6*r*(87*s - 131) + 3159*s**2 - 3477*s + 1012) + 9*r*(357*s - 239) + 4554*s**2 - 4683*s + 1415) + 45*Pkdd2*k2**2*(3*s - 1)*(C*(6*s - 4) + s - 1)) + k1**2*k2**4*(Pk2*(-4*C*(9*r**2 + 12*r*(90*s - 11) + 522*s - 251) + 1440*r**2 + 3*r*(1365*s - 712) + 864*s**2 - 2157*s + 720) + 9*Pkd2*k2*(8*C*(3*r - 1)*(2*s - 1) + 99*r*s - 51*r + 138*s**2 - 133*s + 35)))) + Dd*f*(144*Pk2*k2**6*r*(1 - 4*r) + k1**6*(4*s - 1)*(Pk2*(516*s - 964) + k2*(-8*Pkd2*(33*s - 47) + 45*Pkdd2*k2*(s - 1))) + k1**4*k2**2*(4*C*Pk2*(r*(84*s - 827) + 2136*s**2 - 2136*s + 602) + 3*Pk2*(520*r**2 + r*(640 - 1076*s) - 1736*s**2 + 301*s - 92) + Pkd2*k2*(-2*C*(2*r*(348*s - 529) + 4212*s**2 - 4217*s + 1012) + 9*r*(476*s - 307) + 6072*s**2 - 5486*s + 1415) + 45*Pkdd2*k2**2*(4*s - 1)*(C*(6*s - 4) + s - 1)) + k1**2*k2**4*(Pk2*(-4*C*(12*r**2 + 1440*r*s - 61*r + 702*s - 251) + 1920*r**2 + 5460*r*s - 2216*r + 1152*s**2 - 2797*s + 720) + 9*Pkd2*k2*(8*C*(4*r - 1)*(2*s - 1) + 132*r*s - 63*r + 184*s**2 - 156*s + 35)))))/(315*d**2*k1**3*k2**3*k3**2) + D1**3*Pk1*ct**2*f*k2**2*st**6*(8*C - 8)*(-4*Pk2 + Pkd2*k2)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*D1*fd*(2*s - 1) + Dd*f*(8*s - 3))*(2*r + 2*s - 1) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 7*r + 24*s**2 - 21*s + 4)))/(63*d**2*k3**4) - D1**3*Pk1*ct**2*f*st**6*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + Dd*f*(12*s**2 - 7*s + 1)))/(63*d**2*k3**2) - 4*D1**3*Pk1*ct**2*st**4*(3*D1*bd1*f*(-14*b1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + f*(Pk2*k2**4*(48*r**2 + r*(48*s - 53) - 10*s + 5) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(5*s - 3) + 5*s**2 - 12*s + 3) - 7*r*(6*s - 3) - 42*s**2 + 70*s - 21) + k1**2*k2**2*(Pk2*(-4*C*(20*r**2 + 124*r*s - 43*r + 104*s**2 - 92*s + 24) + 140*r**2 + 252*r*s - 157*r + 112*s**2 - 66*s + 21) + Pkd2*k2*(2*C*(84*r*s - 20*r + 84*s**2 - 83*s + 21) - 16*r*s - 5*r - 16*s**2 + 3)))) - 42*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*D1*fd*s*(r + s) + Dd*f*(r*(8*s - 1) + s*(8*s - 3))) + 3*b1*f*(D1*fd*(48*Pk2*k2**4*r*(2*r + 2*s - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(2*s - 1)*(5*r + 5*s - 6) - 7*r*(12*s - 7) - 84*s**2 + 112*s - 35) + k1**2*k2**2*(Pk2*(-4*C*(40*r**2 + r*(248*s - 135) + 208*s**2 - 212*s + 54) + 280*r**2 + 6*r*(84*s - 47) + 224*s**2 - 212*s + 50) + Pkd2*k2*(8*C*(21*s - 11)*(2*r + 2*s - 1) + r*(17 - 32*s) - 32*s**2 + 26*s - 5))) + Dd*f*(Pk2*k2**4*(96*r - 5)*(2*r + 2*s - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(20*s - 11) + 20*s**2 - 35*s + 9) - 7*r*(24*s - 13) - 168*s**2 + 217*s - 56) + k1**2*k2**2*(Pk2*(-4*C*(80*r**2 + r*(496*s - 203) + 416*s**2 - 357*s + 78) + 560*r**2 + 16*r*(63*s - 29) + 448*s**2 - 324*s + 71) + Pkd2*k2*(2*C*(168*s - 65)*(2*r + 2*s - 1) + r*(11 - 64*s) - 64*s**2 + 29*s - 2)))) + f**2*(D1*fd*(Pk2*k2**4*(72*r**2 + r*(72*s - 57) - 30*s + 13) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(C*(3*s - 1)*(3*r + 3*s - 2) + r*(13 - 33*s) - 33*s**2 + 33*s - 8) + k1**2*k2**2*(Pk2*(-8*C*(54*r**2 + 21*r*(9*s - 5) + 135*s**2 - 159*s + 46) + 540*r**2 + 153*r*(4*s - 3) + 72*s**2 - 258*s + 103) + Pkd2*k2*(36*C + 6)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + Dd*f*(Pk2*k2**4*(96*r**2 + 12*r*(8*s - 5) - 40*s + 13) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*C*(3*s - 1)*(2*r + 2*s - 1) + r*(33 - 88*s) - 88*s**2 + 75*s - 16) + k1**2*k2**2*(Pk2*(-4*C*(144*r**2 + 504*r*s - 239*r + 360*s**2 - 381*s + 92) + 720*r**2 + 816*r*s - 482*r + 96*s**2 - 338*s + 103) + 3*Pkd2*k2*(12*C*(8*s - 3)*(2*r + 2*s - 1) + 32*r*s - 13*r + 32*s**2 - 27*s + 6)))))/(105*d**2*k1**2*k3**4) + D1**3*Pk1*ct**2*st**4*(66*b1**2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd*(15*f*(1 - 2*s)**2 - (7*K - 7)*(s - 1)**2) + Dd*f*(4*s - 1)*(-7*K*s + 7*K + 15*f*(2*s - 1) + 7*s - 7)) + 33*b1*(D1*(f**2*(60*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 5*s + 1) + k2**2*r*(Pk2*(14 - 15*s) + 5*Pkd2*k2*(9*s - 4)))) - 2*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(fd*(1 - 2*s)**2*(K - 1) - s*(s - 1)*(-14*K*bd1 + 14*bd1 + 14*gd2)) + 28*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + Dd*f*(f**2*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(Pk2*(-20*r*s + 32*r + 45*s - 18) + 5*Pkd2*k2*(6*r*(2*s - 1) - 5*s + 2))) - 2*f*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + 28*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*f**2*(33*bd1*(720*Pk2*k1**2*s*(2*s - 1) - 270*Pkd2*k1**2*k2*s*(2*s - 1) + 5*Pkd2*k2**3*(r*(3*s - 2) - 5*s + 2) + k2**2*(Pk2*(-5*r*s + 18*r + 45*s - 18) + 30*Pkdd2*k1**2*s*(2*s - 1))) + fd*(20*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(152*s**2 - 98*s + 15) + k2**2*(Pk2*(-1740*r*s + 2976*r + 2635*s - 1294) + 25*Pkd2*k2*(68*r*s - 50*r - 39*s + 18)))) + 66*D1*f*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(-K*bd1 + bd1 + 2*gd2) + 132*D1*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7*bd1*s*(s - 1) + fd*(1 - 2*s)**2) + Dd*f**3*(20*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(152*s**2 - 98*s + 15) + k2**2*(Pk2*(r*(2976 - 1740*s) + 2635*s - 1294) + 25*Pkd2*k2*(r*(68*s - 50) - 39*s + 18))) + 132*Dd*f*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1)))/(1155*d**2*k1**2*k2**2) + 2*D1**3*Pk1*ct**2*st**2*(1386*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(-42*D1*bd1*f*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + D1*fd*(k1**2*(4*Pk2*(14*K*(-16*s**2 + 34*s - 17) + f*(7*r*(3*s - 4) + 600*s**2 - 738*s + 174) + 84*r*(s - 1) + 56*s**2 - 140*s + 70) + k2*(-3*Pkd2*f*(14*r*(s - 1) + 248*s**2 - 363*s + 82) + 7*Pkd2*(K*(62*s**2 - 134*s + 67) - 12*r*(s - 1) - 2*s**2 + 14*s - 7) + 3*Pkdd2*f*k2*(16*s**2 - 39*s + 8) - 7*Pkdd2*k2*(K*(10*s**2 - 22*s + 11) + 2*s**2 - 2*s + 1))) + k2**2*r*(2*Pk2*(f*(96*s - 31) + r*(56*K - 56) + 70*s - 70) + Pkd2*k2*(-12*f*s + 3*f - 70*s + 70))) + Dd*f*k1**2*(2*Pk2*f*(28*r*(3*s - 7) + 2400*s**2 - 2097*s + 418) + 56*Pk2*(K*(-64*s**2 + 84*s - 17) + 3*r*(8*s - 5) + 16*s**2 - 27*s + 8) + Pkd2*k2*(7*K*(248*s**2 - 330*s + 67) - 3*f*(14*r*(2*s - 3) + 496*s**2 - 473*s + 96) - 336*r*s + 210*r - 56*s**2 + 252*s - 91) + Pkdd2*k2**2*(4*s - 1)*(K*(77 - 70*s) + 24*f*(s - 1) - 14*s + 7)) - 2*Dd*f*k2**2*(f*(Pk2*(-192*r*s + 62*r + 66*s - 20) + 3*Pkd2*k2*(r - 1)*(4*s - 1)) - 7*r*(Pk2*(32*K*r - 8*K - 32*r + 40*s - 2) + 5*Pkd2*k2*(1 - 4*s)))) - 33*b1*(-592*D1*K*Pk2*f*fd*k1**2*s**2 + 984*D1*K*Pk2*f*fd*k1**2*s - 344*D1*K*Pk2*f*fd*k1**2 - 32*D1*K*Pk2*f*fd*k2**2*r**2 + 88*D1*K*Pk2*f*fd*k2**2*r - 36*D1*K*Pk2*f*fd*k2**2 + 280*D1*K*Pkd2*f*fd*k1**2*k2*s**2 - 462*D1*K*Pkd2*f*fd*k1**2*k2*s + 161*D1*K*Pkd2*f*fd*k1**2*k2 - 44*D1*K*Pkdd2*f*fd*k1**2*k2**2*s**2 + 72*D1*K*Pkdd2*f*fd*k1**2*k2**2*s - 25*D1*K*Pkdd2*f*fd*k1**2*k2**2 - 336*D1*Pk2*bd2*f*k1**2*s**2 + 336*D1*Pk2*bd2*f*k1**2*s - 18*D1*Pk2*f**2*fd*k1**2*r*s - 444*D1*Pk2*f**2*fd*k1**2*r + 6480*D1*Pk2*f**2*fd*k1**2*s**2 - 5889*D1*Pk2*f**2*fd*k1**2*s + 1254*D1*Pk2*f**2*fd*k1**2 - 108*D1*Pk2*f**2*fd*k2**2*r**2 + 225*D1*Pk2*f**2*fd*k2**2*r*s - 234*D1*Pk2*f**2*fd*k2**2*r - 30*D1*Pk2*f**2*fd*k2**2*s + 66*D1*Pk2*f**2*fd*k2**2 + 84*D1*Pk2*f*fd*k1**2*r*s - 280*D1*Pk2*f*fd*k1**2*r + 112*D1*Pk2*f*fd*k1**2*s**2 - 70*D1*Pk2*f*fd*k1**2*s + 126*D1*Pk2*f*fd*k1**2 + 32*D1*Pk2*f*fd*k2**2*r**2 + 76*D1*Pk2*f*fd*k2**2*r*s - 238*D1*Pk2*f*fd*k2**2*r - 24*D1*Pk2*f*fd*k2**2*s + 104*D1*Pk2*f*fd*k2**2 + 1792*D1*Pk2*f*gd2*k1**2*s**2 - 1904*D1*Pk2*f*gd2*k1**2*s - 224*D1*Pk2*f*gd2*k2**2*r**2 + 1792*D1*Pk2*fd*g2*k1**2*s**2 - 3808*D1*Pk2*fd*g2*k1**2*s + 1904*D1*Pk2*fd*g2*k1**2 - 224*D1*Pk2*fd*g2*k2**2*r**2 + 210*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 210*D1*Pkd2*bd2*f*k1**2*k2*s - 36*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 138*D1*Pkd2*f**2*fd*k1**2*k2*r - 2268*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 2163*D1*Pkd2*f**2*fd*k1**2*k2*s - 450*D1*Pkd2*f**2*fd*k1**2*k2 + 81*D1*Pkd2*f**2*fd*k2**3*r*s + 12*D1*Pkd2*f**2*fd*k2**3*r - 12*D1*Pkd2*f**2*fd*k2**3*s - 10*D1*Pkd2*f**2*fd*k2**3 - 28*D1*Pkd2*f*fd*k1**2*k2*r*s + 77*D1*Pkd2*f*fd*k1**2*k2*r + 20*D1*Pkd2*f*fd*k1**2*k2*s**2 - 69*D1*Pkd2*f*fd*k1**2*k2*s - 2*D1*Pkd2*f*fd*k1**2*k2 - 24*D1*Pkd2*f*fd*k2**3*r*s + 61*D1*Pkd2*f*fd*k2**3*r + 5*D1*Pkd2*f*fd*k2**3*s - 27*D1*Pkd2*f*fd*k2**3 - 868*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 938*D1*Pkd2*f*gd2*k1**2*k2*s - 868*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 1876*D1*Pkd2*fd*g2*k1**2*k2*s - 938*D1*Pkd2*fd*g2*k1**2*k2 - 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 216*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 228*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 44*D1*Pkdd2*f**2*fd*k1**2*k2**2 - 16*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 + 30*D1*Pkdd2*f*fd*k1**2*k2**2*s - 11*D1*Pkdd2*f*fd*k1**2*k2**2 + 140*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 154*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 140*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 308*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 154*D1*Pkdd2*fd*g2*k1**2*k2**2 + D1*bd1*f*(k1**2*(2*Pk2*f*(14*r*(3*s - 10) + 1200*s**2 - 621*s + 70) + 56*Pk2*(6*r*(2*s - 1) + s**2*(8 - 32*K) + s*(33*K - 12) + 3) - Pkd2*k2*(6*f*(7*r*(s - 2) + 124*s**2 - 55*s + 7) + 84*r*(2*s - 1) + 7*s**2*(4 - 124*K) + 7*s*(129*K - 15) + 42) + Pkdd2*k2**2*s*(-7*K*(20*s - 21) + f*(48*s - 3) - 28*s + 21)) + k2**2*(2*Pk2*f*(r*(96*s - 31) - 66*s + 20) + 56*Pk2*r*(K*(4*r - 2) - 4*r + 5*s + 2) + 3*Pkd2*f*k2*(-4*r*s + r + 8*s - 2) - 140*Pkd2*k2*r*s)) - 1184*Dd*K*Pk2*f**2*k1**2*s**2 + 1672*Dd*K*Pk2*f**2*k1**2*s - 344*Dd*K*Pk2*f**2*k1**2 - 64*Dd*K*Pk2*f**2*k2**2*r**2 + 160*Dd*K*Pk2*f**2*k2**2*r - 36*Dd*K*Pk2*f**2*k2**2 + 560*Dd*K*Pkd2*f**2*k1**2*k2*s**2 - 784*Dd*K*Pkd2*f**2*k1**2*k2*s + 161*Dd*K*Pkd2*f**2*k1**2*k2 - 88*Dd*K*Pkdd2*f**2*k1**2*k2**2*s**2 + 122*Dd*K*Pkdd2*f**2*k1**2*k2**2*s - 25*Dd*K*Pkdd2*f**2*k1**2*k2**2 - 24*Dd*Pk2*f**3*k1**2*r*s - 680*Dd*Pk2*f**3*k1**2*r + 8640*Dd*Pk2*f**3*k1**2*s**2 - 6962*Dd*Pk2*f**3*k1**2*s + 1372*Dd*Pk2*f**3*k1**2 - 144*Dd*Pk2*f**3*k2**2*r**2 + 300*Dd*Pk2*f**3*k2**2*r*s - 266*Dd*Pk2*f**3*k2**2*r - 29*Dd*Pk2*f**3*k2**2*s + 64*Dd*Pk2*f**3*k2**2 + 168*Dd*Pk2*f**2*k1**2*r*s - 588*Dd*Pk2*f**2*k1**2*r + 224*Dd*Pk2*f**2*k1**2*s**2 - 14*Dd*Pk2*f**2*k1**2*s + 126*Dd*Pk2*f**2*k1**2 + 64*Dd*Pk2*f**2*k2**2*r**2 + 152*Dd*Pk2*f**2*k2**2*r*s - 434*Dd*Pk2*f**2*k2**2*r - 36*Dd*Pk2*f**2*k2**2*s + 104*Dd*Pk2*f**2*k2**2 + 7168*Dd*Pk2*f*g2*k1**2*s**2 - 9408*Dd*Pk2*f*g2*k1**2*s + 1904*Dd*Pk2*f*g2*k1**2 - 896*Dd*Pk2*f*g2*k2**2*r**2 + 224*Dd*Pk2*f*g2*k2**2*r - 48*Dd*Pkd2*f**3*k1**2*k2*r*s + 206*Dd*Pkd2*f**3*k1**2*k2*r - 3024*Dd*Pkd2*f**3*k1**2*k2*s**2 + 2498*Dd*Pkd2*f**3*k1**2*k2*s - 484*Dd*Pkd2*f**3*k1**2*k2 + 108*Dd*Pkd2*f**3*k2**3*r*s + 8*Dd*Pkd2*f**3*k2**3*r - 35*Dd*Pkd2*f**3*k2**3*s - 56*Dd*Pkd2*f**2*k1**2*k2*r*s + 161*Dd*Pkd2*f**2*k1**2*k2*r + 40*Dd*Pkd2*f**2*k1**2*k2*s**2 - 149*Dd*Pkd2*f**2*k1**2*k2*s - 2*Dd*Pkd2*f**2*k1**2*k2 - 48*Dd*Pkd2*f**2*k2**3*r*s + 109*Dd*Pkd2*f**2*k2**3*r + 11*Dd*Pkd2*f**2*k2**3*s - 27*Dd*Pkd2*f**2*k2**3 - 3472*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 4620*Dd*Pkd2*f*g2*k1**2*k2*s - 938*Dd*Pkd2*f*g2*k1**2*k2 + 288*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 248*Dd*Pkdd2*f**3*k1**2*k2**2*s + 44*Dd*Pkdd2*f**3*k1**2*k2**2 - 32*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 + 52*Dd*Pkdd2*f**2*k1**2*k2**2*s - 11*Dd*Pkdd2*f**2*k1**2*k2**2 + 560*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 756*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 154*Dd*Pkdd2*f*g2*k1**2*k2**2 - 42*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) - f*(-3960*D1*Pk2*bd2*f*k1**2*s**2 + 4752*D1*Pk2*bd2*f*k1**2*s + 3360*D1*Pk2*f**2*fd*k1**2*r*s - 8320*D1*Pk2*f**2*fd*k1**2*r + 139392*D1*Pk2*f**2*fd*k1**2*s**2 - 101160*D1*Pk2*f**2*fd*k1**2*s + 18448*D1*Pk2*f**2*fd*k1**2 + 1344*D1*Pk2*f**2*fd*k2**2*r**2 + 5940*D1*Pk2*f**2*fd*k2**2*r*s - 6414*D1*Pk2*f**2*fd*k2**2*r - 1815*D1*Pk2*f**2*fd*k2**2*s + 1602*D1*Pk2*f**2*fd*k2**2 + 19536*D1*Pk2*f*gd2*k1**2*s**2 - 22704*D1*Pk2*f*gd2*k1**2*s + 1056*D1*Pk2*f*gd2*k2**2*r**2 - 2376*D1*Pk2*f*gd2*k2**2*r + 39072*D1*Pk2*fd*g2*k1**2*s**2 - 64944*D1*Pk2*fd*g2*k1**2*s + 22704*D1*Pk2*fd*g2*k1**2 + 2112*D1*Pk2*fd*g2*k2**2*r**2 - 5808*D1*Pk2*fd*g2*k2**2*r + 2376*D1*Pk2*fd*g2*k2**2 + 2475*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 2970*D1*Pkd2*bd2*f*k1**2*k2*s - 1500*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 2520*D1*Pkd2*f**2*fd*k1**2*k2*r - 50688*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 37335*D1*Pkd2*f**2*fd*k1**2*k2*s - 6702*D1*Pkd2*f**2*fd*k1**2*k2 + 4620*D1*Pkd2*f**2*fd*k2**3*r*s - 1848*D1*Pkd2*f**2*fd*k2**3*r - 1155*D1*Pkd2*f**2*fd*k2**3*s + 462*D1*Pkd2*f**2*fd*k2**3 - 9240*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 10626*D1*Pkd2*f*gd2*k1**2*k2*s - 18480*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 30492*D1*Pkd2*fd*g2*k1**2*k2*s - 10626*D1*Pkd2*fd*g2*k1**2*k2 - 495*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 594*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 5280*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 3960*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 660*D1*Pkdd2*f**2*fd*k1**2*k2**2 + 1452*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 1650*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 2904*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 4752*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 1650*D1*Pkdd2*fd*g2*k1**2*k2**2 - 33*D1*bd1*(f**2*(k1**2*(Pk2*(r*(6*s + 236) - 2160*s**2 + 1073*s - 118) + k2*(Pkd2*(12*r*s - 68*r + 756*s**2 - 335*s + 34) + 4*Pkdd2*k2*s*(5 - 18*s))) + k2**2*(Pk2*(36*r**2 - 75*r*s + 32*r - s + 2) + Pkd2*k2*(-27*r*s + 4*r + 23*s - 10))) - f*(k1**2*(14*Pk2*r*(3*s - 11) + 4*Pk2*s*(K*(86 - 74*s) + 14*s + 7) + Pkd2*k2*(7*K*s*(20*s - 23) - 14*r*(s - 3) + s*(10*s - 40)) + Pkdd2*k2**2*s*(K*(25 - 22*s) - 8*s + 11)) + k2**2*(-2*Pk2*(r**2*(8*K - 8) + r*(-18*K - 19*s + 49) + 3*s) + 3*Pkd2*k2*(-4*r*(s - 2) + s))) + 28*g2*(-64*Pk2*k1**2*s*(s - 1) + 31*Pkd2*k1**2*k2*s*(s - 1) + k2**2*(8*Pk2*r*(r - 1) - 5*Pkdd2*k1**2*s*(s - 1)))) + 3360*Dd*Pk2*f**3*k1**2*r*s - 8320*Dd*Pk2*f**3*k1**2*r + 139392*Dd*Pk2*f**3*k1**2*s**2 - 101160*Dd*Pk2*f**3*k1**2*s + 18448*Dd*Pk2*f**3*k1**2 + 1344*Dd*Pk2*f**3*k2**2*r**2 + 5940*Dd*Pk2*f**3*k2**2*r*s - 6414*Dd*Pk2*f**3*k2**2*r - 1815*Dd*Pk2*f**3*k2**2*s + 1602*Dd*Pk2*f**3*k2**2 + 78144*Dd*Pk2*f*g2*k1**2*s**2 - 110352*Dd*Pk2*f*g2*k1**2*s + 22704*Dd*Pk2*f*g2*k1**2 + 4224*Dd*Pk2*f*g2*k2**2*r**2 - 10560*Dd*Pk2*f*g2*k2**2*r + 2376*Dd*Pk2*f*g2*k2**2 - 1500*Dd*Pkd2*f**3*k1**2*k2*r*s + 2520*Dd*Pkd2*f**3*k1**2*k2*r - 50688*Dd*Pkd2*f**3*k1**2*k2*s**2 + 37335*Dd*Pkd2*f**3*k1**2*k2*s - 6702*Dd*Pkd2*f**3*k1**2*k2 + 4620*Dd*Pkd2*f**3*k2**3*r*s - 1848*Dd*Pkd2*f**3*k2**3*r - 1155*Dd*Pkd2*f**3*k2**3*s + 462*Dd*Pkd2*f**3*k2**3 - 36960*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 51744*Dd*Pkd2*f*g2*k1**2*k2*s - 10626*Dd*Pkd2*f*g2*k1**2*k2 + 5280*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 3960*Dd*Pkdd2*f**3*k1**2*k2**2*s + 660*Dd*Pkdd2*f**3*k1**2*k2**2 + 5808*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 8052*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 1650*Dd*Pkdd2*f*g2*k1**2*k2**2 - 99*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(14*D1*bd1*s*(s - 1) + D1*fd*(10*s**2 - 17*s + 6) + Dd*f*(20*s**2 - 29*s + 6))))/(3465*d**2*k1**2*k2**2) + D1**3*Pk1*ct**2*(21*b1**3*(D1*fd*s*(k1**2*(5*Pk2*(r - 8*s) + k2*(-5*Pkd2*r + 34*Pkd2*s - 14*Pkdd2*k2*s)) + k2**2*r*(-15*Pk2 + Pkd2*k2)) + Dd*f*(k1**2*(5*Pk2*(4*r*(s - 1) + s*(11 - 32*s)) + k2*(Pkd2*r*(10 - 20*s) + Pkd2*s*(136*s - 39) + 14*Pkdd2*k2*s*(1 - 4*s))) + k2**2*(15*Pk2*s*(1 - 4*r) + Pkd2*k2*(4*r*s + 2*r - 3*s)))) + 3*b1**2*(7*D1*bd1*f*(k1**2*(5*Pk2*(r*(3*s - 4) + s*(11 - 24*s)) + k2*(-5*Pkd2*r*(3*s - 2) + 3*Pkd2*s*(34*s - 13) + 14*Pkdd2*k2*s*(1 - 3*s))) + k2**2*(15*Pk2*s*(1 - 3*r) + Pkd2*k2*(3*r*s + 2*r - 3*s))) + D1*fd*(k1**2*(Pk2*(28*K*(-21*s**2 + 26*s - 13) + f*(6*r*(103*s - 7) + 112*s**2 - 697*s + 28) + 868*r*s - 420*r + 28*s**2 - 56*s - 196) - k2*(Pkd2*f*(2*r*(291*s - 70) - 160*s**2 - 401*s + 14) - 14*Pkd2*(5*K*(9*s**2 - 14*s + 7) - 26*r*s + 10*r - 11*s**2 + 26*s - 5) + 6*Pkdd2*f*k2*(64*s**2 - 21*s + 7) + Pkdd2*k2*(14*K + 14)*(7*s**2 - 10*s + 5))) + k2**2*(Pk2*f*(32*r**2 + 2*r*(63*s - 25) + 63*s - 12) - 28*Pk2*(5*K*(2*r - 1) - 19*r*s + 9*r + 5) + Pkd2*f*k2*(r*(6*s - 28) + 81*s) - 112*Pkd2*k2*s*(r - 1))) + Dd*f*k1**2*(Pk2*(28*K*(-84*s**2 + 73*s - 13) + f*(6*r*(206*s - 101) + 224*s**2 - 855*s + 274) + 56*r*(62*s - 19) + 112*s**2 - 504*s + 168) - k2*(Pkd2*(-70*K*(36*s**2 - 37*s + 7) + f*(4*r*(291*s - 109) - 320*s**2 - 351*s + 144) + 1456*r*s - 462*r + 616*s**2 - 1064*s + 252) + 2*Pkdd2*k2*(4*s - 1)*(3*f*(32*s - 7) + (7*K + 7)*(7*s - 5)))) + Dd*f*k2**2*(Pk2*f*(64*r**2 + 36*r*(7*s - 3) + 21*s + 2) - 28*Pk2*(5*K*(4*r - 1) + r*(5 - 76*s) + 2*s + 3) + Pkd2*f*k2*(2*r*(6*s - 13) + 111*s - 22) + 14*Pkd2*k2*(-r*(32*s + 11) + 15*s + 1))) + b1*(-888*D1*K*Pk2*f*fd*k1**2*s**2 + 2820*D1*K*Pk2*f*fd*k1**2*s - 1188*D1*K*Pk2*f*fd*k1**2 - 144*D1*K*Pk2*f*fd*k2**2*r**2 + 144*D1*K*Pk2*f*fd*k2**2*r - 36*D1*K*Pk2*f*fd*k2**2 + 1428*D1*K*Pkd2*f*fd*k1**2*k2*s**2 - 2478*D1*K*Pkd2*f*fd*k1**2*k2*s + 882*D1*K*Pkd2*f*fd*k1**2*k2 - 252*D1*K*Pkdd2*f*fd*k1**2*k2**2*s**2 + 378*D1*K*Pkdd2*f*fd*k1**2*k2**2*s - 126*D1*K*Pkdd2*f*fd*k1**2*k2**2 - 840*D1*Pk2*bd2*f*k1**2*s**2 + 840*D1*Pk2*bd2*f*k1**2*s + 1089*D1*Pk2*f**2*fd*k1**2*r*s - 864*D1*Pk2*f**2*fd*k1**2*r + 7776*D1*Pk2*f**2*fd*k1**2*s**2 - 5970*D1*Pk2*f**2*fd*k1**2*s + 918*D1*Pk2*f**2*fd*k1**2 - 648*D1*Pk2*f**2*fd*k2**2*r**2 + 162*D1*Pk2*f**2*fd*k2**2*r*s + 864*D1*Pk2*f**2*fd*k2**2*r + 1782*D1*Pk2*f**2*fd*k2**2*s - 522*D1*Pk2*f**2*fd*k2**2 + 744*D1*Pk2*f*fd*k1**2*r*s - 792*D1*Pk2*f*fd*k1**2*r - 456*D1*Pk2*f*fd*k1**2*s**2 + 1848*D1*Pk2*f*fd*k1**2*s - 600*D1*Pk2*f*fd*k1**2 + 192*D1*Pk2*f*fd*k2**2*r**2 + 984*D1*Pk2*f*fd*k2**2*r*s - 516*D1*Pk2*f*fd*k2**2*r + 768*D1*Pk2*f*fd*k2**2*s - 420*D1*Pk2*f*fd*k2**2 + 3528*D1*Pk2*f*gd2*k1**2*s**2 - 2184*D1*Pk2*f*gd2*k1**2*s + 840*D1*Pk2*f*gd2*k2**2*r + 3528*D1*Pk2*fd*g2*k1**2*s**2 - 4368*D1*Pk2*fd*g2*k1**2*s + 2184*D1*Pk2*fd*g2*k1**2 + 1680*D1*Pk2*fd*g2*k2**2*r - 840*D1*Pk2*fd*g2*k2**2 + 714*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 630*D1*Pkd2*bd2*f*k1**2*k2*s - 2637*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 1188*D1*Pkd2*f**2*fd*k1**2*k2*r - 4050*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 4308*D1*Pkd2*f**2*fd*k1**2*k2*s - 828*D1*Pkd2*f**2*fd*k1**2*k2 - 162*D1*Pkd2*f**2*fd*k2**3*r*s + 54*D1*Pkd2*f**2*fd*k2**3*r + 54*D1*Pkd2*f**2*fd*k2**3*s - 18*D1*Pkd2*f**2*fd*k2**3 - 840*D1*Pkd2*f*fd*k1**2*k2*r*s + 714*D1*Pkd2*f*fd*k1**2*k2*r - 252*D1*Pkd2*f*fd*k1**2*k2*s**2 + 336*D1*Pkd2*f*fd*k1**2*k2*s - 252*D1*Pkd2*f*fd*k1**2*k2 - 336*D1*Pkd2*f*fd*k2**3*r*s + 210*D1*Pkd2*f*fd*k2**3*r + 42*D1*Pkd2*f*fd*k2**3*s - 42*D1*Pkd2*f*fd*k2**3 - 3780*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 2940*D1*Pkd2*f*gd2*k1**2*k2*s - 3780*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 5880*D1*Pkd2*fd*g2*k1**2*k2*s - 2940*D1*Pkd2*fd*g2*k1**2*k2 - 294*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 210*D1*Pkdd2*bd2*f*k1**2*k2**2*s - 810*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 + 360*D1*Pkdd2*f**2*fd*k1**2*k2**2*s - 90*D1*Pkdd2*f**2*fd*k1**2*k2**2 - 252*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 + 378*D1*Pkdd2*f*fd*k1**2*k2**2*s - 126*D1*Pkdd2*f*fd*k1**2*k2**2 + 588*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 420*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 588*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 840*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 420*D1*Pkdd2*fd*g2*k1**2*k2**2 + 6*D1*bd1*f*(k1**2*(Pk2*(f*(3*r*(103*s - 94) + 56*s**2 - 79*s + 123) + 28*r*(31*s - 9) + 14*s**2*(2 - 42*K) + 14*s*(34*K - 15) + 182) - k2*(Pkd2*(f*(r*(291*s - 148) - 80*s**2 + 25*s + 65) + 14*r*(26*s - 9) + 7*s**2*(22 - 90*K) + 7*s*(80*K - 37) + 91) + Pkdd2*k2*s*(3*f*(64*s - 39) + (14*K + 14)*(7*s - 6)))) + k2**2*(Pk2*(-70*K*r + f*(16*r**2 + 63*r*s - 29*r - 21*s + 7) + 532*r*s + 14*r - 28*s + 28) + Pkd2*k2*(f*(3*r*s + r + 15*s - 11) - 14*r*(8*s + 3) + 21*s + 7))) - 1776*Dd*K*Pk2*f**2*k1**2*s**2 + 5196*Dd*K*Pk2*f**2*k1**2*s - 1188*Dd*K*Pk2*f**2*k1**2 - 288*Dd*K*Pk2*f**2*k2**2*r**2 + 216*Dd*K*Pk2*f**2*k2**2*r - 36*Dd*K*Pk2*f**2*k2**2 + 2856*Dd*K*Pkd2*f**2*k1**2*k2*s**2 - 4242*Dd*K*Pkd2*f**2*k1**2*k2*s + 882*Dd*K*Pkd2*f**2*k1**2*k2 - 504*Dd*K*Pkdd2*f**2*k1**2*k2**2*s**2 + 630*Dd*K*Pkdd2*f**2*k1**2*k2**2*s - 126*Dd*K*Pkdd2*f**2*k1**2*k2**2 + 1452*Dd*Pk2*f**3*k1**2*r*s - 1968*Dd*Pk2*f**3*k1**2*r + 10368*Dd*Pk2*f**3*k1**2*s**2 - 6827*Dd*Pk2*f**3*k1**2*s + 1460*Dd*Pk2*f**3*k1**2 - 864*Dd*Pk2*f**3*k2**2*r**2 + 216*Dd*Pk2*f**3*k2**2*r*s + 1116*Dd*Pk2*f**3*k2**2*r + 2430*Dd*Pk2*f**3*k2**2*s - 846*Dd*Pk2*f**3*k2**2 + 1488*Dd*Pk2*f**2*k1**2*r*s - 1608*Dd*Pk2*f**2*k1**2*r - 912*Dd*Pk2*f**2*k1**2*s**2 + 3864*Dd*Pk2*f**2*k1**2*s - 600*Dd*Pk2*f**2*k1**2 + 384*Dd*Pk2*f**2*k2**2*r**2 + 1968*Dd*Pk2*f**2*k2**2*r*s - 564*Dd*Pk2*f**2*k2**2*r + 1656*Dd*Pk2*f**2*k2**2*s - 420*Dd*Pk2*f**2*k2**2 + 14112*Dd*Pk2*f*g2*k1**2*s**2 - 12264*Dd*Pk2*f*g2*k1**2*s + 2184*Dd*Pk2*f*g2*k1**2 + 3360*Dd*Pk2*f*g2*k2**2*r - 840*Dd*Pk2*f*g2*k2**2 - 3516*Dd*Pkd2*f**3*k1**2*k2*r*s + 1794*Dd*Pkd2*f**3*k1**2*k2*r - 5400*Dd*Pkd2*f**3*k1**2*k2*s**2 + 4939*Dd*Pkd2*f**3*k1**2*k2*s - 1126*Dd*Pkd2*f**3*k1**2*k2 - 216*Dd*Pkd2*f**3*k2**3*r*s + 72*Dd*Pkd2*f**3*k2**3*r + 54*Dd*Pkd2*f**3*k2**3*s - 18*Dd*Pkd2*f**3*k2**3 - 1680*Dd*Pkd2*f**2*k1**2*k2*r*s + 1302*Dd*Pkd2*f**2*k1**2*k2*r - 504*Dd*Pkd2*f**2*k1**2*k2*s**2 + 252*Dd*Pkd2*f**2*k1**2*k2*s - 252*Dd*Pkd2*f**2*k1**2*k2 - 672*Dd*Pkd2*f**2*k2**3*r*s + 294*Dd*Pkd2*f**2*k2**3*r + 42*Dd*Pkd2*f**2*k2**3*s - 42*Dd*Pkd2*f**2*k2**3 - 15120*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 15540*Dd*Pkd2*f*g2*k1**2*k2*s - 2940*Dd*Pkd2*f*g2*k1**2*k2 - 1080*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 + 630*Dd*Pkdd2*f**3*k1**2*k2**2*s - 90*Dd*Pkdd2*f**3*k1**2*k2**2 - 504*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 + 630*Dd*Pkdd2*f**2*k1**2*k2**2*s - 126*Dd*Pkdd2*f**2*k1**2*k2**2 + 2352*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 2268*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 420*Dd*Pkdd2*f*g2*k1**2*k2**2 - 42*b2*k1**2*(D1*fd*(20*Pk2*(s - 1)**2 + k2*(Pkd2*(-17*s**2 + 30*s - 15) + Pkdd2*k2*(7*s**2 - 10*s + 5))) + Dd*f*(4*s - 1)*(20*Pk2*(s - 1) + k2*(Pkd2*(15 - 17*s) + Pkdd2*k2*(7*s - 5))))) + f*(-336*D1*Pk2*bd2*f*k1**2*s**2 + 672*D1*Pk2*bd2*f*k1**2*s + 12*D1*Pk2*bd2*f*k2**2*r**2 + 36*D1*Pk2*bd2*f*k2**2*r - 300*D1*Pk2*f**2*fd*k1**2*r*s - 650*D1*Pk2*f**2*fd*k1**2*r + 6720*D1*Pk2*f**2*fd*k1**2*s**2 - 4275*D1*Pk2*f**2*fd*k1**2*s + 830*D1*Pk2*f**2*fd*k1**2 + 888*D1*Pk2*f*gd2*k1**2*s**2 - 2376*D1*Pk2*f*gd2*k1**2*s + 144*D1*Pk2*f*gd2*k2**2*r**2 - 72*D1*Pk2*f*gd2*k2**2*r + 1776*D1*Pk2*fd*g2*k1**2*s**2 - 5640*D1*Pk2*fd*g2*k1**2*s + 2376*D1*Pk2*fd*g2*k1**2 + 288*D1*Pk2*fd*g2*k2**2*r**2 - 288*D1*Pk2*fd*g2*k2**2*r + 72*D1*Pk2*fd*g2*k2**2 + 294*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 462*D1*Pkd2*bd2*f*k1**2*k2*s - 1020*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 680*D1*Pkd2*f**2*fd*k1**2*k2*r - 3840*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 3135*D1*Pkd2*f**2*fd*k1**2*k2*s - 650*D1*Pkd2*f**2*fd*k1**2*k2 - 1428*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 1764*D1*Pkd2*f*gd2*k1**2*k2*s - 2856*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 4956*D1*Pkd2*fd*g2*k1**2*k2*s - 1764*D1*Pkd2*fd*g2*k1**2*k2 - 126*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 126*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 252*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 252*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 504*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 756*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 252*D1*Pkdd2*fd*g2*k1**2*k2**2 + D1*bd1*(f**2*(k1**2*(Pk2*(3*r*(121*s - 368) + 2592*s**2 - 857*s + 542) + k2*(Pkd2*(-879*r*s + 606*r - 1350*s**2 + 631*s - 298) - 270*Pkdd2*k2*s*(s - 1))) - 18*k2**2*(Pk2*(12*r**2 - 3*r*s - 14*r - 36*s + 18) + Pkd2*k2*r*(3*s - 1))) + 6*f*(k1**2*(2*Pk2*(r*(31*s - 34) + s*(-37*K*s + 99*K - 19*s + 84)) - 7*k2*(Pkd2*r*(10*s - 7) + Pkd2*s*(K*(21 - 17*s) + 3*s + 1) + Pkdd2*k2*s*(3*K + 3)*(s - 1))) + k2**2*(Pk2*(r**2*(16 - 12*K) + r*(6*K + 82*s - 4) + 74*s) + 7*Pkd2*k2*r*(1 - 4*s))) + 84*g2*k1**2*s*(42*Pk2 + k2*(-45*Pkd2 + 7*Pkdd2*k2))*(s - 1)) - 300*Dd*Pk2*f**3*k1**2*r*s - 650*Dd*Pk2*f**3*k1**2*r + 6720*Dd*Pk2*f**3*k1**2*s**2 - 4275*Dd*Pk2*f**3*k1**2*s + 830*Dd*Pk2*f**3*k1**2 + 3552*Dd*Pk2*f*g2*k1**2*s**2 - 10392*Dd*Pk2*f*g2*k1**2*s + 2376*Dd*Pk2*f*g2*k1**2 + 576*Dd*Pk2*f*g2*k2**2*r**2 - 432*Dd*Pk2*f*g2*k2**2*r + 72*Dd*Pk2*f*g2*k2**2 - 1020*Dd*Pkd2*f**3*k1**2*k2*r*s + 680*Dd*Pkd2*f**3*k1**2*k2*r - 3840*Dd*Pkd2*f**3*k1**2*k2*s**2 + 3135*Dd*Pkd2*f**3*k1**2*k2*s - 650*Dd*Pkd2*f**3*k1**2*k2 - 5712*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 8484*Dd*Pkd2*f*g2*k1**2*k2*s - 1764*Dd*Pkd2*f*g2*k1**2*k2 + 1008*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 1260*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 252*Dd*Pkdd2*f*g2*k1**2*k2**2 - 6*b2*(7*D1*bd1*k1**2*s*(20*Pk2 + k2*(-17*Pkd2 + 7*Pkdd2*k2))*(s - 1) + D1*fd*(-2*Pk2*k2**2*(2*r**2 + 5*r - 3) + 7*k1**2*(2*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1)))) - 2*Dd*Pk2*f*k2**2*(4*r**2 + 11*r - 3) + 7*Dd*f*k1**2*(4*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1))))))/(315*d**2*k1**2*k2**2) - 2*D1**3*Pk1*ct**2*st**4*(42*b1**2*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1*f*(D1*(14*bd1*k1**2*k2**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + fd*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(C*(4*s - 2) - 17*s + 12) + k1**2*k2**2*(-4*Pk2*(C*r*(207*s - 142) + 16*C*(31*s**2 - 32*s + 8) + r*(202 - 327*s) - 204*s**2 + 206*s - 48) + k2*(Pkd2*(4*C*(57*r*s - 39*r + 250*s**2 - 260*s + 65) - 348*r*s + 216*r - 270*s**2 + 275*s - 60) + Pkdd2*k2*(-4*C*(42*s**2 - 44*s + 11) + 22*s**2 - 23*s + 4))) + 16*k2**4*r*(Pk2*(r*(13*C - 13) + 12*s - 6) + 3*Pkd2*k2*(1 - 2*s)))) + Dd*f*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(4*s - 2) - 17*s + 12) + k1**2*k2**2*(-2*Pk2*(C*(828*r*s - 496*r + 1984*s**2 - 1655*s + 362) - 1308*r*s + 676*r - 816*s**2 + 783*s - 232) + k2*(Pkd2*(2*C*(6*r*(38*s - 23) + 1000*s**2 - 809*s + 160) - 696*r*s + 366*r - 540*s**2 + 483*s - 135) - Pkdd2*k2*(4*s - 1)*(C*(84*s - 44) - 11*s + 4))) + k2**4*(2*Pk2*(r**2*(208*C - 208) - 2*r*(26*C - 96*s + 3) - 10*s + 5) + Pkd2*k2*(r*(58 - 192*s) + 10*s - 5)))) + f**2*(D1*(3*bd1*(k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(4*s - 2) - 17*s + 12) + k1**2*k2**2*(Pk2*(C*(-414*r*s + 212*r - 992*s**2 + 750*s - 212) + 654*r*s - 272*r + 408*s**2 - 550*s + 272) + k2*(Pkd2*(2*C*(57*r*s - 30*r + 250*s**2 - 159*s + 30) - 174*r*s + 75*r - 135*s**2 + 148*s - 75) + Pkdd2*k2*s*(C*(40 - 84*s) + 11*s))) + k2**4*(2*Pk2*(r**2*(52*C - 52) + r*(-52*C + 48*s + 47) - 10*s + 5) + Pkd2*k2*(r*(5 - 48*s) + 10*s - 5))) + fd*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(C*(6*s - 2) - 27*s + 12) - k1**2*k2**2*(2*C*Pk2*(9*r*(123*s - 50) + 1296*s**2 - 1473*s + 374) - 6*Pk2*(3*r*(165*s - 73) + 108*s**2 - 237*s + 85) + Pkd2*k2*(-2*C*(9*r*(33*s - 14) + 648*s**2 - 645*s + 152) + 9*r*(90*s - 41) + 81*s**2 - 315*s + 129) + Pkdd2*k2**2*(3*s - 1)*(36*C*(2*s - 1) + 9*s - 4)) + k2**4*(-4*Pk2*(C*(1 - 3*r)**2 - 9*r**2 - 117*r*s + 69*r + 42*s - 23) + Pkd2*k2*(r*(99 - 180*s) + 66*s - 35)))) + Dd*f*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(6*s - 2) - 27*s + 12) - k1**2*k2**2*(2*Pk2*(C*(12*r*(123*s - 46) + 1728*s**2 - 1745*s + 374) - 20*r*(99*s - 41) - 432*s**2 + 803*s - 255) + k2*(Pkd2*(-2*C*(12*r*(33*s - 13) + 864*s**2 - 767*s + 152) + 8*r*(135*s - 58) + 108*s**2 - 349*s + 129) + Pkdd2*k2*(4*s - 1)*(36*C*(2*s - 1) + 9*s - 4))) + k2**4*(-4*Pk2*(12*C*r**2 - 7*C*r + C - 12*r**2 - 156*r*s + 87*r + 47*s - 23) + Pkd2*k2*(-4*r*(60*s - 31) + 76*s - 35)))))/(105*d**2*k1**2*k2**2*k3**2) - 2*D1**3*Pk1*ct**2*st**2*(D1*bd1*f*(7*b1*(k1**4*s*(2*C - 3)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(-2*Pk2*(2*r*(7*C*s + 2*C - 19*s + 1) + s*(48*C*s - 35*C - 48*s + 41)) + k2*(Pkd2*r*(4*C*(s + 1) - 28*s + 2) + Pkd2*s*(C*(92*s - 52) - 66*s + 45) - Pkdd2*k2*s*(22*C - 9)*(2*s - 1))) + 2*k2**4*r*(Pk2*(16*C - 16)*(2*r - 1) + 5*Pkd2*k2*(1 - 2*s))) + f*(k1**4*(2*Pk2*(r*(25*s - 113) + s**2*(692 - 248*C) + s*(296*C - 679) + 113) + k2*(-2*Pkd2*(r*(8*s - 30) + s**2*(248 - 110*C) + s*(131*C - 215) + 30) + Pkdd2*k2*s*(C*(38 - 32*s) + 50*s - 29))) + k1**2*k2**2*(-2*Pk2*(C*(52*r**2 - 702*r*s + 250*r - 348*s**2 + 645*s - 326) - 73*r**2 + 786*r*s - 5*r - 342*s**2 + 36*s + 116) + k2*(Pkd2*(-2*C*(6*r*(48*s - 31) + 452*s**2 - 503*s + 198) + 632*r*s - 211*r + 28*s**2 - 335*s + 249) + Pkdd2*k2*s*(4*C*(31*s - 10) + 62*s - 41))) + k2**4*(-2*Pk2*(r**2*(16*C + 5) + r*(-36*C + 201*s + 12) - 6*s + 3) + Pkd2*k2*(72*r*s + 13*r + 3*s - 3)))) + 7*b1**2*(D1*fd*(Pk2*k1**4*s**2*(16*C - 24) - Pkd2*k1**4*k2*s**2*(10*C - 15) + Pkd2*k1**2*k2**3*s*(r*(2*C - 14) + s*(46*C - 33)) - 10*Pkd2*k2**5*r*s + k1**2*k2**2*s*(Pk2*r*(38 - 14*C) - Pk2*s*(48*C - 48) + Pkdd2*k1**2*s*(2*C - 3)) + k2**4*(Pk2*r**2*(32*C - 32) + Pkdd2*k1**2*s**2*(9 - 22*C))) + Dd*f*(k1**4*s*(2*C - 3)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(r*(28*C*s + 4*C - 76*s + 2) + s*(96*C*s - 35*C - 96*s + 41)) + k2*(Pkd2*r*(C*(8*s + 4) - 56*s + 2) + Pkd2*s*(4*C*(46*s - 13) - 132*s + 45) - Pkdd2*k2*s*(22*C - 9)*(4*s - 1))) + 2*k2**4*r*(Pk2*(16*C - 16)*(4*r - 1) + 5*Pkd2*k2*(1 - 4*s)))) + b1*f*(D1*fd*(k1**4*(-4*Pk2*(4*C*(62*s**2 - 123*s + 43) - 25*r*s + 86*r - 692*s**2 + 1108*s - 354) + k2*(Pkd2*(C*(440*s**2 - 924*s + 322) - 32*r*s + 93*r - 992*s**2 + 1675*s - 522) + Pkdd2*k2*(-2*C*(32*s**2 - 72*s + 25) + 100*s**2 - 189*s + 56))) + k1**2*k2**2*(-2*Pk2*(C*(104*r**2 - 1404*r*s + 1036*r - 696*s**2 + 657*s - 204) - 146*r**2 + 1572*r*s - 959*r - 684*s**2 + 863*s - 218) + k2*(Pkd2*(-2*C*(6*r*(96*s - 77) + 904*s**2 - 939*s + 252) + 1264*r*s - 847*r + 56*s**2 + 118*s - 44) + Pkdd2*k2*(4*C*(62*s**2 - 84*s + 21) + 124*s**2 - 147*s + 42))) + k2**4*(-2*Pk2*(4*C*(8*r**2 - 22*r + 9) + 10*r**2 + 134*r*(3*s - 1) + 21*s - 36) + Pkd2*k2*(12*r*(12*s - 7) + 5*s))) + Dd*f*(k1**4*(-2*Pk2*(8*C*(124*s**2 - 203*s + 43) - 100*r*s + 398*r - 2768*s**2 + 3603*s - 821) + k2*(Pkd2*(2*C*(440*s**2 - 754*s + 161) - 64*r*s + 213*r - 1984*s**2 + 2627*s - 582) - 2*Pkdd2*k2*(4*s - 1)*(C*(16*s - 25) - 25*s + 28))) + k1**2*k2**2*(Pk2*(-4*C*(104*r**2 - 1404*r*s + 818*r - 696*s**2 + 741*s - 265) + 584*r**2 - 6288*r*s + 2166*r + 2736*s**2 - 2240*s + 204) + k2*(Pkd2*(-4*C*(576*r*s - 429*r + 904*s**2 - 841*s + 225) + 2528*r*s - 1310*r + 112*s**2 - 170*s + 205) + Pkdd2*k2*(4*C + 2)*(124*s**2 - 115*s + 21))) + k2**4*(-2*Pk2*(4*C*(16*r**2 - 40*r + 9) + 20*r**2 + 804*r*s - 89*r + 15*s - 33) + Pkd2*k2*(r*(288*s - 71) + 11*s - 3)))) + f**2*(D1*fd*(k1**4*(-4*Pk2*(4*C*(81*s**2 - 96*s + 23) - 81*r*s + 87*r - 702*s**2 + 756*s - 194) + k2*(Pkd2*(2*C*(297*s**2 - 354*s + 85) - 90*r*s + 96*r - 999*s**2 + 1074*s - 269) - Pkdd2*k2*(3*s - 1)*(C*(30*s - 26) - 33*s + 24))) + k1**2*k2**2*(-6*Pk2*(C*(12*r**2 - 387*r*s + 294*r - 264*s**2 + 321*s - 134) - 75*r**2 + 375*r*s - 96*r - 120*s**2 + 66*s - 10) + k2*(-Pkd2*(2*C*(441*r*s - 354*r + 684*s**2 - 627*s + 202) - 1098*r*s + 516*r + 81*s**2 + 78*s - 85) + 9*Pkdd2*k2*(3*s - 1)*(C*(8*s - 4) + 3*s - 2))) + 2*k2**4*(Pk2*(-4*C*(27*r**2 + 12*r - 7) + 117*r**2 - 180*r*s - 57*r + 24*s + 18) + 6*Pkd2*k2*(3*r*(7*s - 3) - 4*s + 2))) + Dd*f*(k1**4*(4*Pk2*(C*(-432*s**2 + 476*s - 92) + 12*r*(9*s - 10) + 936*s**2 - 917*s + 194) + k2*(Pkd2*(2*C*(396*s**2 - 439*s + 85) - 120*r*s + 132*r - 1332*s**2 + 1307*s - 269) - Pkdd2*k2*(4*s - 1)*(C*(30*s - 26) - 33*s + 24))) + k1**2*k2**2*(C*Pk2*(-96*r**2 + 8*r*(387*s - 283) + 2112*s**2 - 2230*s + 804) + 6*Pk2*(100*r**2 + r*(101 - 500*s) + 160*s**2 - 81*s + 10) - Pkd2*k2*(2*C*(28*r*(21*s - 17) + 912*s**2 - 707*s + 202) - 8*r*(183*s - 80) + 108*s**2 + 39*s - 85) + 9*Pkdd2*k2**2*(4*s - 1)*(C*(8*s - 4) + 3*s - 2)) + 2*k2**4*(Pk2*(-4*C*(36*r**2 + 19*r - 7) + 156*r**2 - 240*r*s - 79*r + 28*s + 18) + 6*Pkd2*k2*(r*(28*s - 11) - 4*s + 2)))))/(105*d**2*k1**2*k2**2*k3**2) - 2*D1**3*Pk1*ct**2*(3*D1*bd1*f*(-7*b1*(k1**4*(Pk2*(24*r*(4*s - 1) + 2*s*(-32*C*s + 16*C + 38*s - 31)) + k2*(Pkd2*r*(12 - 48*s) + 2*Pkd2*s*(10*C*(2*s - 1) - 14*s + 13) - Pkdd2*k2*s*(4*C + 5)*(2*s - 1))) + k1**2*k2**2*(2*Pk2*(r**2*(68*C - 78) + r*(8*C*s - 46*C - 28*s + 46) + s*(68*C*s - 26*C - 68*s + 41)) + k2*(Pkd2*r*(s*(80*C - 152) + 33) + Pkd2*s*(10*C*(6*s - 7) - 116*s + 101) + Pkdd2*k2*s*(-10*C - 5)*(2*s - 1))) + k2**4*(Pk2*(r**2*(48 - 40*C) + 4*r*(5*C + 19*s - 12) - 14*s) + 5*Pkd2*k2*(r - s))) + f*(k1**4*(Pk2*(r*(284 - 302*s) + s**2*(340*C - 534) + s*(812 - 588*C) - 212) + k2*(Pkd2*(r*(256*s - 163) + s**2*(473 - 358*C) + s*(414*C - 523) + 127) + Pkdd2*k2*s*(66*C + 21)*(s - 1))) + k1**2*k2**2*(Pk2*(-2*C*(204*r**2 + 405*r*s - 224*r + 38*s**2 - 281*s + 194) + 854*r**2 + 1582*r*s - 880*r + 454*s**2 - 862*s + 504) + k2*(Pkd2*(2*C*(93*r*s - 106*r + 133*s**2 - 214*s + 130) + 446*r*s - 202*r + 461*s**2 - 457*s + 73) + Pkdd2*k2*s*(42*C + 21)*(s - 1))) + k2**4*(2*Pk2*(r**2*(12*C - 11) + r*(-6*C + 57*s + 5) - 37*s + 37) + 7*Pkd2*k2*r*(4*s - 3)))) - 21*b1**2*(-D1*fd*(2*Pk2*k2**4*r*(r*(10*C - 12) - 19*s) + k1**4*s*(Pk2*(32*C*s - 48*r - 38*s) + k2*(24*Pkd2*r + Pkd2*s*(14 - 20*C) + Pkdd2*k2*s*(4*C + 5))) + k1**2*k2**2*(Pk2*(r**2*(78 - 68*C) + r*s*(28 - 8*C) - s**2*(68*C - 68)) + k2*s*(Pkd2*(-40*C*r - 30*C*s + 76*r + 58*s) + Pkdd2*k2*s*(10*C + 5)))) + Dd*f*(k1**4*(2*Pk2*(12*r*(8*s - 1) + s*(-64*C*s + 16*C + 76*s - 31)) + k2*(Pkd2*r*(12 - 96*s) + 2*Pkd2*s*(10*C*(4*s - 1) - 28*s + 13) - Pkdd2*k2*s*(4*C + 5)*(4*s - 1))) + k1**2*k2**2*(2*Pk2*(r**2*(136*C - 156) + 2*r*(8*C*s - 23*C - 28*s + 23) + s*(136*C*s - 26*C - 136*s + 41)) + k2*(Pkd2*r*(s*(160*C - 304) + 33) + Pkd2*s*(10*C*(12*s - 7) - 232*s + 101) + Pkdd2*k2*s*(-10*C - 5)*(4*s - 1))) + k2**4*(-2*Pk2*(r**2*(40*C - 48) - 2*r*(5*C + 38*s - 12) + 7*s) + 5*Pkd2*k2*(r - s)))) + 3*b1*f*(D1*fd*(k1**4*(4*Pk2*(C*(170*s**2 - 235*s + 99) - 151*r*s + 42*r - 267*s**2 + 328*s - 92) + k2*(Pkd2*(C*(-716*s**2 + 826*s - 294) + 512*r*s - 203*r + 946*s**2 - 1103*s + 294) + 6*Pkdd2*k2*(C*(22*s**2 - 21*s + 7) + 7*s**2))) + k1**2*k2**2*(-4*Pk2*(C*(204*r**2 + 405*r*s - 344*r + 38*s**2 - 108*s + 30) - 427*r**2 - 791*r*s + 639*r - 227*s**2 + 404*s - 126) + k2*(Pkd2*(4*C*(93*r*s - 70*r + 133*s**2 - 204*s + 42) + 892*r*s - 119*r + 922*s**2 - 810*s + 154) + Pkdd2*k2*s**2*(84*C + 42))) + k2**4*(2*Pk2*(6*C*(1 - 2*r)**2 - 22*r**2 + 2*r*(57*s - 73) - 57*s + 26) + 7*Pkd2*k2*s*(8*r - 1))) + Dd*f*(k1**4*(4*Pk2*(C*(340*s**2 - 481*s + 99) - 302*r*s + 148*r - 534*s**2 + 641*s - 145) + k2*(Pkd2*(-2*C*(716*s**2 - 767*s + 147) + 1024*r*s - 457*r + 1892*s**2 - 1956*s + 421) + 3*Pkdd2*k2*(4*s - 1)*(2*C*(11*s - 7) + 7*s))) + k1**2*k2**2*(-2*Pk2*(C*(816*r**2 + 4*r*(405*s - 257) + 152*s**2 - 635*s + 254) - 1708*r**2 - 3164*r*s + 1915*r - 908*s**2 + 1546*s - 504) + k2*(Pkd2*(4*C*(2*r*(93*s - 79) + 266*s**2 - 383*s + 107) + 1784*r*s - 370*r + 1844*s**2 - 1445*s + 227) + Pkdd2*k2*s*(42*C + 21)*(4*s - 1))) + k2**4*(2*Pk2*(6*C*(8*r**2 - 6*r + 1) - 44*r**2 + 228*r*s - 167*r - 131*s + 63) + 7*Pkd2*k2*(r*(16*s - 3) - s)))) + f**2*(D1*fd*(-54*Pk2*k2**4*r*(3*r - 18*s + 5) + k1**4*(2*Pk2*(2*C*(207*s**2 - 768*s + 233) + 63*r*s + 339*r - 900*s**2 + 1344*s - 468) + 9*k2*(10*C*Pkdd2*k2*(3*s**2 - 4*s + 1) + Pkd2*(-2*C*(81*s**2 - 132*s + 35) + 84*r*s - 74*r + 249*s**2 - 304*s + 89))) + k1**2*k2**2*(2*Pk2*(C*(342*r**2 - 3*r*(405*s + 46) + 324*s**2 - 1809*s + 710) + 810*r**2 + 3501*r*s - 1419*r + 567*s**2 - 708*s + 167) + 9*Pkd2*k2*(2*C*(99*r*s - 66*r + 108*s**2 - 123*s + 40) + 54*r*s - 44*r + 153*s**2 - 166*s + 47))) + Dd*f*(-54*Pk2*k2**4*r*(4*r - 24*s + 5) + k1**4*(2*Pk2*(C*(552*s**2 - 2002*s + 466) + 84*r*s + 502*r - 1200*s**2 + 1649*s - 468) + 9*k2*(10*C*Pkdd2*k2*(4*s**2 - 5*s + 1) + Pkd2*(C*(-216*s**2 + 334*s - 70) + 112*r*s - 97*r + 332*s**2 - 370*s + 89))) + k1**2*k2**2*(2*Pk2*(C*(456*r**2 - 2*r*(810*s + 127) + 432*s**2 - 2403*s + 710) + 1080*r**2 + 4668*r*s - 1417*r + 756*s**2 - 877*s + 167) + 9*Pkd2*k2*(2*C*(44*r*(3*s - 2) + 144*s**2 - 141*s + 40) + 72*r*s - 57*r + 204*s**2 - 200*s + 47)))))/(315*d**2*k1**2*k2**2*k3**2) + 4*D1**3*Pk1*ct**2*st**2*(3*D1*bd1*f*(-7*b1*k2**2*(20*Pk2*k2**4*r*(r + s - 1) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*C*(s + 1) - 10*s - 5) + s*(4*C*(s - 2) - 10*s + 15)) + k1**2*k2**2*(6*Pk2*(4*C*r**2 + r*(-4*C*s + 4*C + 8*s - 7) + s*(-8*C*s + 8*s - 1)) + Pkd2*k2*(r*(88*C*s - 22*C - 34*s + 11) + s*(88*C*s - 66*C - 34*s + 23)))) + f*(Pk2*k2**6*(86*r**2 + 86*r*s - 93*r + 3*s - 3) + k1**6*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**4*k2**2*(Pk2*(-4*C*(11*r**2 - 39*r*s + 79*r - 50*s**2 + 186*s - 92) + 108*r**2 - 262*r*s + 137*r - 370*s**2 + 583*s - 279) + Pkd2*k2*(-4*C*(34*r*s - 39*r + 34*s**2 - 89*s + 40) + 176*r*s - 97*r + 176*s**2 - 257*s + 114)) + k1**2*k2**4*(-2*Pk2*(C*(264*r**2 + 654*r*s - 326*r + 390*s**2 - 312*s + 76) - 411*r**2 - 504*r*s + 502*r - 93*s**2 + 183*s - 91) + Pkd2*k2*(C*(8*r*(31*s - 5) + 248*s**2 - 254*s + 90) + 165*r*s - 72*r + 165*s**2 - 215*s + 71)))) - 21*b1**2*k2**2*(D1*fd*(r + s)*(2*C*k1**2*(2*Pk2*k1**2*s + 6*Pk2*k2**2*(r - 2*s) - Pkd2*k1**2*k2*s + 22*Pkd2*k2**3*s) - 10*Pk2*k1**4*s + 24*Pk2*k1**2*k2**2*s + 10*Pk2*k2**4*r + 5*Pkd2*k1**4*k2*s - 17*Pkd2*k1**2*k2**3*s) + Dd*f*(20*Pk2*k2**4*r*(2*r + 2*s - 1) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*C*s + 4*C - 20*s - 5) + s*(8*C*(s - 1) - 20*s + 15)) + k1**2*k2**2*(6*Pk2*(8*C*r**2 + r*(C*(4 - 8*s) + 16*s - 7) + s*(-s*(16*C - 16) - 1)) + Pkd2*k2*(r*(22*C*(8*s - 1) - 68*s + 11) + s*(22*C*(8*s - 3) - 68*s + 23))))) + 3*b1*f*(D1*fd*(Pk2*k2**6*(172*r**2 + 2*r*(86*s - 65) - 9*s + 22) + k1**6*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**4*k2**2*(Pk2*(-4*C*(22*r**2 - 78*r*s + 166*r - 100*s**2 + 325*s - 134) + 216*r**2 - 524*r*s + 783*r - 740*s**2 + 1604*s - 582) + Pkd2*k2*(-2*C*(136*r*s - 139*r + 136*s**2 - 263*s + 94) + 352*r*s - 279*r + 352*s**2 - 511*s + 150)) + k1**2*k2**4*(Pk2*(-4*C*(264*r**2 + r*(654*s - 376) + 390*s**2 - 397*s + 108) + 1644*r**2 + 7*r*(288*s - 173) + 372*s**2 - 281*s + 100) + Pkd2*k2*(8*C*(r*(62*s - 42) + 62*s**2 - 80*s + 21) + 3*r*(110*s - 63) + 330*s**2 - 382*s + 105))) + Dd*f*(Pk2*k2**6*(344*r**2 + r*(344*s - 245) - 3*s + 19) + 2*k1**6*(4*Pk2 - Pkd2*k2)*(r*(2*s - 13) + 2*s**2 - 28*s + 10) + k1**4*k2**2*(Pk2*(-8*C*(22*r**2 - 78*r*s + 166*r - 100*s**2 + 325*s - 113) + 432*r**2 - 1048*r*s + 1163*r - 1480*s**2 + 2805*s - 861) + 4*Pkd2*k2*(C*(-136*r*s + 146*r - 136*s**2 + 270*s - 87) + 176*r*s - 118*r + 176*s**2 - 234*s + 66)) + 2*k1**2*k2**4*(Pk2*(-4*C*(264*r**2 + r*(654*s - 299) + 390*s**2 - 320*s + 73) + 1644*r**2 + 3*r*(672*s - 417) + 372*s**2 - 321*s + 141) + Pkd2*k2*(C*(r*(496*s - 230) + 496*s**2 - 534*s + 129) + 6*r*(55*s - 27) + 330*s**2 - 355*s + 88)))) + f**2*(D1*fd*(18*Pk2*k2**6*(24*r**2 + r*(24*s - 17) - 2*s + 1) + 3*k1**6*(4*Pk2 - Pkd2*k2)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + k1**4*k2**2*(Pk2*(-4*C*(45*r**2 - 333*r*s + 387*r - 378*s**2 + 678*s - 281) + 666*r**2 - 1440*r*s + 891*r - 2106*s**2 + 2379*s - 770) + 3*Pkd2*k2*(-6*C*(51*r*s - 37*r + 51*s**2 - 75*s + 26) + (99*s - 53)*(3*r + 3*s - 2))) + 9*k1**2*k2**4*(Pk2*(-4*C*(27*r**2 + 123*r*s - 29*r + 96*s**2 - 56*s + 1) + 408*r**2 + 456*r*s - 331*r + 48*s**2 - 105*s + 44) + 12*Pkd2*k2*(C*r*(12*s - 5) + 3*C*(1 - 2*s)**2 + (2*s - 1)*(3*r + 3*s - 2)))) + Dd*f*(18*Pk2*k2**6*(16*r - 1)*(2*r + 2*s - 1) + 6*k1**6*(4*Pk2 - Pkd2*k2)*(r*(6*s - 7) + 6*s**2 - 12*s + 4) + k1**4*k2**2*(-2*Pk2*(2*C*(60*r**2 - 444*r*s + 519*r - 504*s**2 + 827*s - 281) - 444*r**2 + 960*r*s - 537*r + 1404*s**2 - 1483*s + 385) - 3*Pkd2*k2*(12*C*(34*r*s - 25*r + 34*s**2 - 44*s + 13) - 396*r*s + 199*r - 396*s**2 + 423*s - 106)) + 9*k1**2*k2**4*(-2*Pk2*(2*C*(36*r**2 + 164*r*s - 25*r + 128*s**2 - 61*s + 1) - 272*r**2 - 304*r*s + 185*r - 32*s**2 + 55*s - 22) + 3*Pkd2*k2*(4*C*(8*s - 3)*(2*r + 2*s - 1) + 32*r*s - 15*r + 32*s**2 - 33*s + 8)))))/(315*d**2*k1**2*k2**2*k3**4) + 4*D1**3*Pk1*ct**2*(-3*D1*bd1*f*(-7*b1*(5*Pk2*k2**6*(-r + s) - 2*k1**6*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**4*k2**2*(Pk2*(r**2*(174 - 80*C) + r*(-216*C*s + 104*C + 344*s - 183) + s*(-136*C*s + 112*C + 170*s - 161)) + Pkd2*k2*(r*(8*C*s - 12*C + 58*s - 7) + s*(8*C*s + 4*C + 58*s - 51))) + k1**2*k2**4*(-2*Pk2*(r**2*(40*C - 93) + 2*r*(5*C*(6*s - 5) - 90*s + 52) + s*(10*C*(2*s - 1) - 87*s + 76)) + 5*Pkd2*k2*(r*(8*C*s - 2*C + 6*s - 1) + s*(8*C*s - 6*C + 6*s - 5)))) + f*(-7*Pk2*k2**6*r*(2*r + 2*s - 3) + k1**6*(2*Pk2*(6*r*(2*s - 5) + 12*s**2 - 53*s + 24) - 3*Pkd2*k2*(15*r*s - 11*r + 15*s**2 - 24*s + 9)) - k1**4*k2**2*(Pk2*(-4*C*(39*r**2 + 2*r*(59*s - 41) + 79*s**2 - 154*s + 33) + 812*r**2 + 2*r*(857*s - 597) + 902*s**2 - 1244*s + 453) + 3*Pkd2*k2*(6*C*(15*r*s - 11*r + 15*s**2 - 24*s + 9) + 2*r*(25*s - 9) + 50*s**2 - 59*s + 9)) - k1**2*k2**4*(Pk2*(4*C*(54*r**2 + 131*r*s - 110*r + 77*s**2 - 136*s + 87) + 610*r**2 + 1200*r*s - 779*r + 590*s**2 - 694*s + 181) + 21*Pkd2*k2*(r*(4*C*s - 2*C + 3*s - 1) + s*(4*C + 3)*(s - 1))))) - 21*b1**2*(-D1*fd*k1**2*(r + s)*(k1**4*(-8*Pk2*s + 4*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(87 - 40*C) + Pk2*s*(85 - 68*C) + Pkd2*k2*s*(4*C + 29)) + k2**4*(Pk2*r*(93 - 40*C) + Pk2*s*(87 - 20*C) + Pkd2*k2*s*(20*C + 15))) + Dd*f*(5*Pk2*k2**6*(r - s) + 2*k1**6*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + s*(8*s - 3)) - k1**4*k2**2*(Pk2*(r**2*(348 - 160*C) + r*(-432*C*s + 104*C + 688*s - 183) + s*(-272*C*s + 112*C + 340*s - 161)) + Pkd2*k2*(r*(4*C*(4*s - 3) + 116*s - 7) + s*(4*C*(4*s + 1) + 116*s - 51))) + k1**2*k2**4*(4*Pk2*(r**2*(40*C - 93) + r*(60*C*s - 25*C - 180*s + 52) + s*(20*C*s - 5*C - 87*s + 38)) + 5*Pkd2*k2*(r*(-16*C*s + 2*C - 12*s + 1) + s*(-16*C*s + 6*C - 12*s + 5))))) - 3*b1*f*(D1*fd*(-7*Pk2*k2**6*(4*r**2 + r*(4*s - 2) + s) + k1**6*(2*Pk2*(24*r*s - 9*r + 24*s**2 - 28*s + 8) - 3*Pkd2*k2*(15*s - 7)*(2*r + 2*s - 1)) - k1**4*k2**2*(Pk2*(-4*C*(78*r**2 + r*(236*s - 78) + 158*s**2 - 216*s + 65) + 1624*r**2 + 2*r*(1714*s - 971) + 1804*s**2 - 2291*s + 628) + 3*Pkd2*k2*(2*C*(r*(90*s - 49) + 90*s**2 - 101*s + 28) + 2*r*(50*s - 7) + 100*s**2 - 57*s + 7)) - 2*k1**2*k2**4*(Pk2*(C*(216*r**2 + 524*r*s - 552*r + 308*s**2 - 626*s + 208) + 610*r**2 + 1200*r*s - 554*r + 590*s**2 - 586*s + 135) + 21*Pkd2*k2*s*(C*(4*r + 4*s - 1) + 3*r + 3*s - 1))) + Dd*f*(-7*Pk2*k2**6*(8*r**2 + r*(8*s - 5) + s) + 2*k1**6*(Pk2*(r*(48*s - 57) + 48*s**2 - 95*s + 32) - 3*Pkd2*k2*(15*s - 8)*(2*r + 2*s - 1)) - k1**4*k2**2*(Pk2*(-8*C*(78*r**2 + 236*r*s - 88*r + 158*s**2 - 226*s + 49) + 3248*r**2 + 6856*r*s - 3527*r + 3608*s**2 - 4225*s + 1081) + 3*Pkd2*k2*(2*C*(180*r*s - 103*r + 180*s**2 - 207*s + 55) + 200*r*s - 39*r + 200*s**2 - 125*s + 16)) - k1**2*k2**4*(Pk2*(4*C*(216*r**2 + 524*r*s - 476*r + 308*s**2 - 550*s + 191) + 2440*r**2 + 4800*r*s - 2038*r + 2360*s**2 - 2166*s + 451) + 21*Pkd2*k2*(r*(16*C*s - 2*C + 12*s - 1) + s*(16*C*s - 6*C + 12*s - 5))))) + f**2*k1**2*(D1*fd*(9*Pk2*k2**4*(4*C*(36*r**2 + 18*r*(5*s - 3) + 54*s**2 - 57*s + 17) + 87*r**2 + r*(240*s - 127) + 153*s**2 - 162*s + 43) + k1**4*(2*Pk2*(30*r*(3*s + 2) + 90*s**2 + 9*s - 43) + 45*Pkd2*k2*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(4*C*(225*r**2 + 333*r*s - 360*r + 108*s**2 - 120*s + 86) + 1593*r**2 + 4284*r*s - 2301*r + 2691*s**2 - 3132*s + 859) + 45*Pkd2*k2*(2*C*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7) + (s - 1)*(3*r + 3*s - 2)))) + Dd*f*(9*Pk2*k2**4*(4*C*(48*r**2 + 2*r*(60*s - 31) + 72*s**2 - 66*s + 17) + 116*r**2 + 8*r*(40*s - 17) + 204*s**2 - 196*s + 43) + 2*k1**4*(Pk2*(20*r*(6*s + 5) + 120*s**2 + 12*s - 43) + 45*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(8*C*(150*r**2 + 3*r*(74*s - 73) + 72*s**2 - 64*s + 43) + 2124*r**2 + 34*r*(168*s - 73) + 3588*s**2 - 3810*s + 859) + 90*Pkd2*k2*(C*(r*(20*s - 13) + 20*s**2 - 25*s + 7) + (s - 1)*(2*r + 2*s - 1))))))/(315*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*ct*f**2*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(11*b1*(33*s - 14)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s*(33*s - 14) + D1*fd*(540*s**2 - 303*s + 42) + 3*Dd*f*(180*s**2 - 101*s + 14)))/(693*d**2*k1*k2) - 4*D1**3*Pk1*ct*f*k2*st**6*(-9*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(2*Pk2*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 8*r**2 - 4*r*s + 9*r + 4*s**2 - 1) + Pkd2*k2*(-4*r*s + r - (1 - 2*s)**2))) - 9*b1*(2*D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(8*s - 3) + k2**2*(2*Pk2*(16*C*r - 2*C - 16*r + 8*s - 1) + Pkd2*k2*(3 - 8*s))))*(2*r + 2*s - 1) + f*(-2*D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s)))*(3*r + 3*s - 2) + Dd*f*(-k1**2*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + k2**2*(Pk2*(-4*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 96*r**2 + 48*r*s - 70*r - 48*s**2 + 14*s + 8) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 21*s + 4)))))/(63*d**2*k1*k3**4) + 2*D1**3*Pk1*ct*f*st**6*(9*b1*(D1*fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k2**2*(8*Pk2*(r*(8*C - 8) + 2*s - 1) + k2*(Pkd2*(-r*(16*C - 16) - 10*s + 5) + Pkdd2*k2*(2*s - 1)))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(8*Pk2*(2*C*(2*r*(8*s - 3) - 2*s + 1) - 4*r*(8*s - 3) + 8*s**2 - 2*s - 1) + k2*(Pkd2*(C*(-8*r*(8*s - 3) + 8*s - 4) + 8*r*(8*s - 3) - 40*s**2 + 22*s - 1) + Pkdd2*k2*(8*s**2 - 6*s + 1))))) + f*(-9*D1*bd1*(24*Pk2*k1**2*s*(1 - 2*s) + 9*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(4*C*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r + 10*s**2 + 3*s - 4) + Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 2*s**2 + 3*s - 2) + Pkdd2*k1**2*s*(1 - 2*s))) + D1*fd*(3*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1) + k2**2*(8*Pk2*(4*C*(3*r - 1) - 12*r + 3*s + 3) + k2*(Pkd2*(-24*C*r + 8*C + 24*r - 15*s - 3) + Pkdd2*k2*(3*s - 1)))) + Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + Dd*f*k2**2*(8*Pk2*(2*C*(24*r*s - 7*r - 7*s + 2) - 48*r*s + 14*r + 12*s**2 + 7*s - 3) + k2*(Pkd2*(-4*C*(24*r*s - 7*r - 7*s + 2) + 96*r*s - 28*r - 60*s**2 + 7*s + 3) + Pkdd2*k2*(12*s**2 - 7*s + 1)))))/(63*d**2*k1*k2*k3**2) + 4*D1**3*Pk1*ct*st**4*(3*D1*bd1*f*(7*b1*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k2**2*(Pk2*(4*C - 4)*(4*r**2 + r*(4*s - 3) - s) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)))) + f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(2*Pk2*(2*C*(5*r**2 + 42*r*s - 26*r + 37*s**2 - 50*s + 21) - 19*r**2 - 65*r*s + 36*r - 46*s**2 + 30*s - 18) + Pkd2*k2*(C*(-64*r*s + 30*r - 64*s**2 + 92*s - 30) + 19*r*s - 2*r + 19*s**2 - 11*s + 3)) + k2**4*(-2*Pk2*(2*C*(24*r**2 + 24*r*s - 31*r - 13*s + 6) - 44*r**2 - 27*r*s + 58*r + 17*s**2 + 21*s - 12) + Pkd2*k2*(r*(24*s - 5) + 24*s**2 - 23*s + 6)))) - 21*b1**2*k2**2*(2*D1*fd*(r + s)*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) - Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + s*(8*s - 3)) + k2**2*(Pk2*(4*C - 4)*(8*r**2 + r*(8*s - 3) - s) + Pkd2*k2*(-8*r*s + r + s*(3 - 8*s))))) + 3*b1*f*(D1*fd*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(Pk2*(4*C*(10*r**2 + 84*r*s - 63*r + 74*s**2 - 95*s + 29) - 76*r**2 - 260*r*s + 201*r - 184*s**2 + 206*s - 57) + Pkd2*k2*(-2*C*(64*r*s - 39*r + 64*s**2 - 78*s + 23) + 38*r*s - 23*r + 38*s**2 - 35*s + 8)) + k2**4*(Pk2*(-8*C*(12*r + 1)*(2*r + 2*s - 1) + 176*r**2 + 108*r*s - 31*r - 68*s**2 + 84*s - 25) + 2*Pkd2*k2*(12*s - 7)*(2*r + 2*s - 1))) + Dd*f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 35*s + 9) + k1**2*k2**2*(Pk2*(8*C*(10*r**2 + 84*r*s - 55*r + 74*s**2 - 87*s + 25) - 152*r**2 - 520*r*s + 311*r - 368*s**2 + 321*s - 93) + Pkd2*k2*(-2*C*(128*r*s - 69*r + 128*s**2 - 147*s + 38) + 76*r*s - 29*r + 76*s**2 - 53*s + 11)) + k2**4*(Pk2*(-16*C*(12*r - 1)*(2*r + 2*s - 1) + 352*r**2 + 216*r*s - 167*r - 136*s**2 + 63*s - 1) + 4*Pkd2*k2*(12*s - 5)*(2*r + 2*s - 1)))) + f**2*(D1*fd*(3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2**2*(Pk2*(12*C*(9*r**2 + 60*r*s - 34*r + 51*s**2 - 57*s + 17) - 198*r**2 - 342*r*s + 267*r - 144*s**2 + 246*s - 95) - 3*Pkd2*k2*(8*C*(r*(12*s - 5) + 3*(1 - 2*s)**2) - 3*r*s + 2*r - 3*s**2 + 3*s - 1)) + k2**4*(-Pk2*(C*(84*r + 48*s - 44) - 72*r**2 + 18*r*s + 3*r + 90*s**2 - 120*s + 35) + 3*Pkd2*k2*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + Dd*f*(6*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(Pk2*(12*C*(12*r**2 + 80*r*s - 41*r + 68*s**2 - 67*s + 17) - 264*r**2 - 456*r*s + 293*r - 192*s**2 + 315*s - 95) + 3*Pkd2*k2*(-2*C*(64*r*s - 25*r + 64*s**2 - 55*s + 12) + (2*s - 1)*(2*r + 2*s - 1))) + k2**4*(-Pk2*(4*C*(27*r + 17*s - 11) - 96*r**2 + 24*r*s + 7*r + 120*s**2 - 159*s + 35) + 3*Pkd2*k2*(8*s - 3)*(2*r + 2*s - 1)))))/(105*d**2*k1*k2*k3**4) - 4*D1**3*Pk1*ct*st**2*(3*D1*bd1*f*(-7*b1*(2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(s + 1) + s*(s - 2)) + k1**2*k2**2*(2*Pk2*(r**2*(4*C + 3) + 2*r*(4*C*s - 7*C - 6*s + 7) + s*(4*C*s + 6*C - 15*s - 2)) - Pkd2*k2*(r*(2*C*(6*s + 1) - 18*s + 7) + s*(2*C*(6*s - 7) - 18*s + 11))) + k2**4*(Pk2*(r**2*(98 - 80*C) + r*(-80*C*s + 60*C + 116*s - 68) + 2*s*(10*C + 9*s - 24)) + 5*Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3)))) + f*(k1**4*(Pk2*(4*C*(r*(s + 12) + s**2 + 27*s - 12) - 27*r**2 - 5*r*(4*s + 11) + 7*s**2 - 133*s + 86) + 2*Pkd2*k2*(C*(r*(s - 9) + s**2 - 22*s + 9) - 2*r*(5*s - 6) - 10*s**2 + 23*s - 13)) - k1**2*k2**2*(2*Pk2*(2*C*(36*r**2 - 26*r*s - 47*r - 62*s**2 + 44*s + 4) + 156*r**2 + 257*r*s - 159*r + 101*s**2 - 74*s + 17) + Pkd2*k2*(2*C*(137*r*s - 58*r + 137*s**2 - 187*s + 71) + 34*r*s - 31*r + 34*s**2 - 60*s + 26)) - k2**4*(Pk2*(4*C*(r**2 + r*(s - 22) - 9*s + 9) + 225*r**2 + 350*r*s - 207*r + 125*s**2 - 97*s + 14) + 7*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) - 21*b1**2*(D1*fd*(r + s)*(k1**4*s*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(4*C + 3) + Pk2*s*(4*C - 15) + Pkd2*k2*s*(9 - 6*C)) + k2**4*(Pk2*r*(49 - 40*C) + 9*Pk2*s + 10*Pkd2*k2*s)) + Dd*f*(2*k1**4*(2*Pk2 - Pkd2*k2)*(2*r*s + r + s*(2*s - 2)) + k1**2*k2**2*(4*Pk2*(r**2*(4*C + 3) + r*(8*C*s - 7*C - 12*s + 7) + s*(4*C*s + 3*C - 15*s - 1)) - Pkd2*k2*(r*(24*C*s + 2*C - 36*s + 7) + s*(24*C*s - 14*C - 36*s + 11))) + k2**4*(-4*Pk2*(r**2*(40*C - 49) + r*(5*C*(8*s - 3) - 58*s + 17) + s*(-5*C - 9*s + 12)) + 5*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) + 3*b1*f*(D1*fd*(k1**4*(Pk2*(4*C*(r*(2*s + 13) + 2*s**2 + 33*s - 17) - 54*r**2 - 10*r*(4*s + 15) + 14*s**2 - 303*s + 141) + Pkd2*k2*(2*C*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + r*(49 - 40*s) - 40*s**2 + 83*s - 28)) - k1**2*k2**2*(2*Pk2*(2*C*(72*r**2 - 52*r*s + 40*r - 124*s**2 + 180*s - 59) + 312*r**2 + 514*r*s - 278*r + 202*s**2 - 153*s + 33) + Pkd2*k2*(C*(548*r*s - 378*r + 548*s**2 - 736*s + 210) + 68*r*s - 49*r + 68*s**2 - 90*s + 28)) - k2**4*(Pk2*(4*C*(2*r**2 + 2*r*s - 37*r - 15*s + 18) + 450*r**2 + 700*r*s - 380*r + 250*s**2 - 259*s + 67) + 7*Pkd2*k2*s*(4*r + 4*s - 1))) + Dd*f*(k1**4*(Pk2*(4*C*(r*(4*s + 37) + 4*s**2 + 77*s - 29) - 108*r**2 - r*(80*s + 281) + 28*s**2 - 587*s + 227) + 2*Pkd2*k2*(C*r*(4*s - 26) + 4*C*(s**2 - 14*s + 5) + r*(47 - 40*s) - 40*s**2 + 81*s - 27)) - k1**2*k2**2*(4*Pk2*(C*(144*r**2 - 4*r*(26*s + 1) - 248*s**2 + 276*s - 55) + 312*r**2 + 514*r*s - 241*r + 202*s**2 - 116*s + 25) + Pkd2*k2*(4*C*(274*r*s - 155*r + 274*s**2 - 334*s + 88) + 136*r*s - 101*r + 136*s**2 - 183*s + 54)) - k2**4*(Pk2*(4*C*(4*r**2 + 4*r*s - 77*r - 33*s + 27) + 900*r**2 + 1400*r*s - 633*r + 500*s**2 - 391*s + 81) + 7*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3))))) - f**2*(D1*fd*(9*Pk2*k2**4*(4*C*(3*r - 1)*(2*r + 2*s - 1) + 72*r**2 + r*(114*s - 71) + 42*s**2 - 44*s + 13) + k1**4*(Pk2*(4*C*(9*r*s - 39*r + 9*s**2 - 72*s + 35) + 153*r**2 + 36*r*s + 201*r - 117*s**2 + 372*s - 199) - 3*Pkd2*k2*(2*C*(9*r*(s - 1) + 9*s**2 - 21*s + 8) - 45*r*s + 30*r - 45*s**2 + 63*s - 21)) + k1**2*k2**2*(Pk2*(36*C*(30*r**2 - 5*r*(3*s + 4) - 45*s**2 + 18*s + 4) + 1467*r**2 + 18*r*(125*s - 74) + 783*s**2 - 822*s + 218) + 9*Pkd2*k2*(24*C*(2*s - 1)*(3*r + 3*s - 2) + 5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + Dd*f*(9*Pk2*k2**4*(4*C*(4*r - 1)*(2*r + 2*s - 1) + 96*r**2 + r*(152*s - 77) + 56*s**2 - 51*s + 13) + k1**4*(Pk2*(4*C*(12*r*s - 59*r + 12*s**2 - 87*s + 35) + 204*r**2 + 48*r*s + 281*r - 156*s**2 + 491*s - 199) - 3*Pkd2*k2*(4*C*(6*r*s - 7*r + 6*s**2 - 12*s + 4) - 60*r*s + 39*r - 60*s**2 + 75*s - 21)) + k1**2*k2**2*(2*Pk2*(36*C*(20*r**2 - 10*r*s - 13*r - 30*s**2 + 10*s + 2) + 978*r**2 + 1500*r*s - 723*r + 522*s**2 - 463*s + 109) + 9*Pkd2*k2*(6*C*(32*r*s - 15*r + 32*s**2 - 33*s + 8) + 20*r*s - 13*r + 20*s**2 - 25*s + 7)))))/(315*d**2*k1*k2*k3**4) + 4*D1**3*Pk1*ct*(D1*bd1*f*(14*b1*(5*Pk2*k2**4*(3*r**2 + r*(6*s - 4) + s*(3*s - 2)) + k1**4*(2*Pk2*(12*r**2 + r*(C*(2 - 8*s) + 31*s - 15) + s*(C*(6 - 8*s) + 19*s - 16)) + Pkd2*k2*(C*r*(8*s - 2) + 2*C*s*(4*s - 3) + 5*s*(r + s - 1))) + k1**2*k2**2*(Pk2*(r**2*(60*C + 61) + r*(120*C*s - 50*C + 128*s - 75) + s*(60*C*s - 70*C + 67*s - 53)) + 5*Pkd2*k2*(C*r*(6*s - 1) + C*s*(6*s - 5) + s*(r + s - 1)))) + f*(7*Pk2*k2**4*(r**2*(4*C + 9) + r*(s*(4*C + 16) - 13) + s*(7*s - 7)) + k1**4*(Pk2*(-4*C*(3*r*(s - 4) + 3*s**2 - 23*s + 6) + 165*r**2 + 424*r*s - 291*r + 259*s**2 - 365*s + 106) + 3*Pkd2*k2*(2*C*(15*r*s - 11*r + 15*s**2 - 24*s + 9) + 7*s*(r + s - 1))) + k1**2*k2**2*(2*Pk2*(C*(290*r**2 + 584*r*s - 402*r + 294*s**2 - 440*s + 202) + 153*r**2 + 322*r*s - 227*r + 169*s**2 - 204*s + 35) + 21*Pkd2*k2*(C*r*(6*s - 2) + 6*C*s*(s - 1) + s*(r + s - 1))))) + 7*b1**2*(D1*fd*(r + s)*(15*Pk2*k2**4*(r + s) + k1**4*(24*Pk2*r + Pk2*s*(38 - 16*C) + Pkd2*k2*s*(8*C + 5)) + k1**2*k2**2*(Pk2*r*(60*C + 61) + Pk2*s*(60*C + 67) + Pkd2*k2*s*(30*C + 5))) + 2*Dd*f*(10*Pk2*k2**4*(3*r**2 + r*(6*s - 2) + s*(3*s - 1)) + k1**4*(2*Pk2*(24*r**2 + r*(-16*C*s + 2*C + 62*s - 15) + 2*s*(-8*C*s + 3*C + 19*s - 8)) + Pkd2*k2*(2*C*(r*(8*s - 1) + s*(8*s - 3)) + 5*s*(2*r + 2*s - 1))) + k1**2*k2**2*(Pk2*(r**2*(120*C + 122) + r*(240*C*s - 50*C + 256*s - 75) + s*(120*C*s - 70*C + 134*s - 53)) + 5*Pkd2*k2*(C*r*(12*s - 1) + C*s*(12*s - 5) + s*(2*r + 2*s - 1))))) + b1*f*(D1*fd*(7*Pk2*k2**4*(r**2*(8*C + 18) + r*(C*(8*s - 4) + 32*s - 9) + s*(-4*C + 14*s - 3)) + k1**4*(Pk2*(-4*C*(6*r*s + 21*r + 6*s**2 + 11*s - 7) + 330*r**2 + 848*r*s - 358*r + 518*s**2 - 515*s + 121) + 3*Pkd2*k2*(2*C*(15*s - 7) + 7*s)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(4*C*(290*r**2 + 584*r*s - 409*r + 294*s**2 - 453*s + 132) + 612*r**2 + 1288*r*s - 451*r + 676*s**2 - 476*s + 97) + 21*Pkd2*k2*s*(4*C*(3*r + 3*s - 1) + 2*r + 2*s - 1))) + Dd*f*(14*Pk2*k2**4*(r**2*(8*C + 18) + r*(C*(8*s - 2) + 32*s - 11) + s*(-2*C + 14*s - 5)) + k1**4*(Pk2*(-4*C*(12*r*s + 9*r + 12*s**2 - 11*s - 1) + 660*r**2 + 1696*r*s - 721*r + 1036*s**2 - 1035*s + 227) + 6*Pkd2*k2*(2*C*(15*s - 8) + 7*s)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(4*C*(580*r**2 + 1168*r*s - 714*r + 588*s**2 - 802*s + 233) + 1224*r**2 + 2576*r*s - 953*r + 1352*s**2 - 1003*s + 167) + 42*Pkd2*k2*(C*r*(12*s - 1) + C*s*(12*s - 5) + s*(2*r + 2*s - 1))))) + 3*f**2*k1**2*(D1*fd*(Pk2*k2**2*(4*C*(21*r**2 + 75*r*s - 46*r + 54*s**2 - 61*s + 19) + 15*r**2 + 48*r*s - 21*r + 33*s**2 - 44*s + 11) + k1**2*(10*C*Pkd2*k2*(s - 1)*(3*r + 3*s - 2) + Pk2*(4*C*(3*s - 1)*(5*r + 5*s - 3) + 15*r**2 + 48*r*s - 21*r + 33*s**2 - 44*s + 11))) + Dd*f*(Pk2*k2**2*(4*C*(28*r**2 + 100*r*s - 53*r + 72*s**2 - 73*s + 19) + 20*r**2 + 64*r*s - 21*r + 44*s**2 - 55*s + 11) + k1**2*(20*C*Pkd2*k2*(s - 1)*(2*r + 2*s - 1) + Pk2*(4*C*(4*s - 1)*(5*r + 5*s - 3) + 20*r**2 + 64*r*s - 21*r + 44*s**2 - 55*s + 11)))))/(105*d**2*k1*k2*k3**4) + D1**3*Pk1*ct*st**4*(33*b1**2*k1**2*(D1*fd*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + k2**2*(8*Pk2*(f*(52*s**2 - 33*s + 10) + (14*s - 14)*(r*(2*K - 2) + s - 1)) + k2*(-5*Pkd2*f*(52*s**2 - 33*s + 10) - 14*Pkd2*(s - 1)*(r*(4*K - 4) + 5*s - 5) + Pkdd2*f*k2*(52*s**2 - 33*s + 10) + 14*Pkdd2*k2*(s - 1)**2))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(f*(13*s - 10) + 14*s - 14) + 2*k2**2*(14*K*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) - s + 1) + 56*Pk2*(r*(5 - 8*s) + s*(4*s - 4)) + 7*Pkd2*k2*(2*r*(8*s - 5) - 20*s**2 + 23*s - 3) + 7*Pkdd2*k2**2*(4*s**2 - 5*s + 1) + f*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(52*s**2 - 33*s + 5)))) + 11*b1*(D1*(f**2*(3*bd1*k1**2*s*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(52*s - 33)) + fd*(360*Pk2*k2**4*r**2 + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(63*s**2 - 51*s + 10) + k1**2*k2**2*(-12*Pk2*(3*r*(6*s - 19) + 306*s**2 - 258*s + 53) + k2*(3*Pkd2*(72*r*s - 84*r + 405*s**2 - 378*s + 76) + Pkdd2*k2*(-99*s**2 + 114*s - 20))))) + 6*f*k1**2*(14*bd1*(24*Pk2*k1**2*s*(s - 1) - 9*Pkd2*k1**2*k2*s*(s - 1) + Pkd2*k2**3*(K*(r*(2 - 4*s) + s - 1) + r*(4*s - 2) - 5*s**2 + 4*s + 1) + Pkdd2*k2**4*s*(s - 1) + k2**2*(4*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 2*s**2 - s - 1) + Pkdd2*k1**2*s*(s - 1))) + fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k2**2*(8*Pk2*(K*(4*r - 2) - 4*r + 2*s + 1) + k2*(Pkd2*(-8*K*r + 4*K + 8*r - 10*s + 1) + Pkdd2*k2*(2*s - 1)))) + 28*gd2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(2*s - 1)) + 336*fd*g2*k1**2*k2**2*r*(-4*Pk2 + Pkd2*k2)*(s - 1)) + Dd*f*(f**2*(120*Pk2*k2**4*r*(4*r - 1) + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(84*s**2 - 61*s + 10) + k1**2*k2**2*(-4*Pk2*(24*r*(3*s - 11) + 1224*s**2 - 944*s + 221) + k2*(Pkd2*(288*r*s - 372*r + 1620*s**2 - 1337*s + 308) + Pkdd2*k2*(-132*s**2 + 113*s - 20)))) + 6*f*k1**2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(8*Pk2*(2*K*(r*(8*s - 3) - 3*s + 1) + r*(6 - 16*s) + 8*s**2 - 1) + k2*(Pkd2*(-4*K*(r*(8*s - 3) - 3*s + 1) + 4*r*(8*s - 3) - 40*s**2 + 18*s - 1) + Pkdd2*k2*(8*s**2 - 6*s + 1)))) + 168*g2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(r*(8*s - 5) - s + 1))) + f*(D1*f**2*(11*bd1*(120*Pk2*k2**4*r*(r - 1) + 2*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(21*s - 10) - k1**2*k2**2*(4*Pk2*(3*r*(6*s - 31) + 306*s**2 - 170*s + 62) + k2*(Pkd2*(-72*r*s + 120*r - 405*s**2 + 203*s - 80) + Pkdd2*k2*s*(33*s + 1)))) + fd*(60*Pk2*k2**4*(12*r**2 + 5*r - 2) + 5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(116*s**2 - 69*s + 10) + k1**2*k2**2*(-8*Pk2*(16*r*(51*s - 32) + 3740*s**2 - 2635*s + 502) + k2*(Pkd2*(16*r*(168*s - 97) + 10780*s**2 - 7679*s + 1466) - 55*Pkdd2*k2*(20*s**2 - 13*s + 2))))) + 66*D1*f*k1**2*(bd1*(24*Pk2*k1**2*s*(2*s - 1) + 9*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(-r*(2*K - 2)*(4*s - 1) + s*(2*K - 10*s + 3)) + Pkdd2*k2**4*s*(2*s - 1) + k2**2*(8*Pk2*(r*(K - 1)*(4*s - 1) + s*(-K + 2*s)) + Pkdd2*k1**2*s*(2*s - 1))) + 4*gd2*k2**2*(-4*Pk2 + Pkd2*k2)*(r*(4*s - 1) - s)) + 264*D1*g2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(7*bd1*(r*(2*s - 1) - s + 1) + 2*fd*(2*r - 1)*(2*s - 1)) + Dd*f**3*(60*Pk2*k2**4*(12*r**2 + 5*r - 2) + 5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(116*s**2 - 69*s + 10) + k1**2*k2**2*(-8*Pk2*(16*r*(51*s - 32) + 3740*s**2 - 2635*s + 502) + k2*(Pkd2*(16*r*(168*s - 97) + 10780*s**2 - 7679*s + 1466) - 55*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 528*Dd*f*g2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(r*(8*s - 3) - 3*s + 1)))/(1155*d**2*k1**3*k2**3) + D1**3*Pk1*ct*st**2*(231*b1**3*k1**2*s*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(D1*(-7*bd1*f*k1**2*s*(3*s - 1)*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2)) + fd*(Pk2*k2**4*r**2*(-480*f - 84) + k1**4*(8*Pk2*(f*(234*s**2 - 371*s + 112) + 133*s**2 - 294*s + 147) + k2*(-Pkd2*(f*(666*s**2 - 1183*s + 350) + 434*s**2 - 1008*s + 504) + Pkdd2*k2*(3*f*(22*s**2 - 49*s + 14) + 56*s**2 - 140*s + 70))) + k1**2*k2**2*(-4*Pk2*(-28*K*s + f*(8*r*(9*s + 5) - 336*s**2 + 201*s - 70) - 7*r*(K - 1)*(23*s - 27) - 77*s**2 + 182*s - 77) + k2*(Pkd2*f*(4*r*(64*s + 13) - 894*s**2 + 535*s - 182) - 14*Pkd2*(r*(4*K - 4)*(4*s - 5) + 15*s**2 + s*(4*K - 36) + 16) + 3*Pkdd2*f*k2*(74*s**2 - 49*s + 14) + 14*Pkdd2*k2*(4*s**2 - 10*s + 5))))) + Dd*f*(Pk2*k2**4*r*(-240*f - 84)*(4*r - 1) + k1**4*(4*s - 1)*(8*Pk2*(117*f*s - 112*f + 133*s - 147) + k2*(Pkd2*(-333*f*s + 350*f - 434*s + 504) + Pkdd2*k2*(33*f*s - 42*f + 56*s - 70))) + k1**2*k2**2*(-4*Pk2*f*(36*r*(4*s + 1) - 672*s**2 + 428*s - 83) + 28*Pk2*(K*(92*r*s - 43*r + 4*s + 4) + r*(43 - 92*s) + 44*s**2 - 59*s + 7) + Pkd2*k2*(-112*K*(8*r*s - 6*r + 1) + f*(16*r*(32*s + 1) - 1788*s**2 + 1079*s - 194) + 896*r*s - 672*r - 840*s**2 + 1106*s - 112) + Pkdd2*k2**2*(4*s - 1)*(3*f*(37*s - 14) + 56*s - 70)))) - 33*b1*(D1*(f**2*(2*bd1*(120*Pk2*k2**4*r*(1 - 2*r) + k1**4*s*(8*Pk2*(117*s - 97) + k2*(Pkd2*(275 - 333*s) + 3*Pkdd2*k2*(11*s - 9))) + k1**2*k2**2*(Pk2*(r*(8 - 144*s) + 672*s**2 - 454*s + 26) + k2*(Pkd2*(2*r*(64*s - 9) - 447*s**2 + 272*s - 6) + 3*Pkdd2*k2*s*(37*s - 22)))) + fd*(-24*Pk2*k2**4*(9*r**2 + 3*r - 2) + 3*k1**4*(8*Pk2*(147*s**2 - 150*s + 32) + k2*(Pkd2*(-411*s**2 + 462*s - 100) + 3*Pkdd2*k2*(13*s**2 - 18*s + 4))) + k1**2*k2**2*(12*Pk2*(42*r**2 + r*(72*s - 44) + 78*s**2 - 64*s + 25) + k2*(Pkd2*(72*r*(12*s - 5) - 90*s**2 - 219*s + 38) + 9*Pkdd2*k2*(18*s**2 - 9*s + 2))))) + 2*f*(14*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) + 7*bd1*(6*Pk2*k2**4*r*(1 - 2*r) + k1**4*s*(8*Pk2*(19*s - 20) + k2*(Pkd2*(67 - 62*s) + Pkdd2*k2*(8*s - 9))) + k1**2*k2**2*(4*Pk2*(K*(23*r*s - 5*r - s + 2) - 23*r*s + 5*r + 11*s**2 - 10*s - 2) + k2*(Pkd2*(K*(-32*r*s + 18*r + 6*s - 8) + 32*r*s - 18*r - 30*s**2 + 25*s + 8) + Pkdd2*k2*s*(8*s - 9)))) + fd*k1**4*(2*s - 1)*(4*Pk2*(43*s - 39) + k2*(Pkd2*(60 - 64*s) + 7*Pkdd2*k2*(s - 1))) + fd*k1**2*k2**2*(2*Pk2*(7*K*(8*r*s - 17*r - s + 7) + 52*r**2 - 92*r*s - 41*r + 58*s**2 - 26*s + 29) + k2*(-4*Pkd2*(K*(6*r*s - 17*r + 4*s + 5) - 22*r*s + 4*r + 18*s**2 - 14*s + 6) + 7*Pkdd2*k2*(2*s**2 - 3*s + 1))) + 28*gd2*k1**2*k2**2*(Pk2*(r*(6 - 23*s) - 2*s) + Pkd2*k2*(r*(8*s - 5) + s))) + 56*fd*g2*k1**2*k2**2*(Pk2*(r*(27 - 23*s) - 4*s) + 2*Pkd2*k2*(r*(4*s - 5) + s))) + Dd*f*(f**2*(-24*Pk2*k2**4*(12*r**2 + 5*r - 2) + 3*k1**4*(4*s - 1)*(8*Pk2*(49*s - 32) + k2*(Pkd2*(100 - 137*s) + Pkdd2*k2*(13*s - 12))) + 2*k1**2*k2**2*(Pk2*(336*r**2 + 4*r*(144*s - 61) + 624*s**2 - 468*s + 82) + k2*(Pkd2*(576*r*s - 260*r - 60*s**2 - 153*s + 71) + 9*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 2*f*(14*Pk2*k2**4*(4*r**2 - 5*r + 1) + k1**4*(4*s - 1)*(4*Pk2*(43*s - 39) + k2*(Pkd2*(60 - 64*s) + 7*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(7*K*(16*r*s - 31*r - s + 7) + 104*r**2 - 184*r*s - 121*r + 116*s**2 - 4*s + 29) + k2*(-4*Pkd2*(K*(12*r*(s - 3) + 13*s + 5) - 44*r*s - r + 36*s**2 - 21*s + 6) + 7*Pkdd2*k2*(4*s**2 - 5*s + 1)))) + 56*g2*k1**2*k2**2*(-Pk2*(92*r*s - 43*r + 4*s + 4) + 4*Pkd2*k2*(r*(8*s - 6) + 1)))) - f*(D1*(f**2*(33*bd1*(-24*Pk2*k2**4*r*(3*r + 2) + 3*k1**4*s*(8*Pk2*(49*s - 27) + k2*(Pkd2*(75 - 137*s) + Pkdd2*k2*(13*s - 7))) + k1**2*k2**2*(8*Pk2*(21*r**2 + r*(36*s + 5) + 39*s**2 - 21*s - 17) + k2*(Pkd2*(32*r*(9*s - 5) - 30*s**2 - 87*s + 104) + 9*Pkdd2*k2*s*(6*s - 5)))) + fd*k1**2*(55*k1**2*(4*s - 1)*(8*Pk2*(33*s - 16) + k2*(-93*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 24*k2**2*(Pk2*(380*r**2 + 528*r*s - 135*r - 660*s**2 + 473*s - 100) + 11*Pkd2*k2*(64*r*s - 32*r + 60*s**2 - 55*s + 14)))) + 66*f*(bd1*(14*Pk2*k2**4*r*(r - 1) + k1**4*s*(4*Pk2*(43*s - 39) + k2*(Pkd2*(60 - 64*s) + 7*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(52*r**2 + r*(56*K*s - 98*K - 92*s - 80) + 2*s*(29*s + 11)) + k2*(-2*Pkd2*(r*(6*K*s - 19*K - 22*s - 5) + s*(9*K + 18*s - 7)) + 7*Pkdd2*k2*s*(s - 1)))) + 2*k1**2*k2**2*(Pk2*bd2*(-r*(9*s + 31) + 18*s) - 14*Pk2*gd2*r*(4*s - 7) + Pkd2*bd2*k2*(4*r*(2*s + 3) - 9*s) + 2*Pkd2*gd2*k2*(r*(6*s - 19) + 9*s))) + 132*k1**2*k2**2*(b2*fd*(Pk2*(-2*r*(9*s + 20) + 23*s + 13) + Pkd2*k2*(16*r*s + 13*r - 15*s - 3)) + 2*g2*(-7*bd1*(Pk2*(23*r*s - 4*r - 4*s + 4) + 4*Pkd2*k2*(-2*r*s + r + s - 1)) + fd*(-7*Pk2*(8*r*s - 17*r - s + 7) + 2*Pkd2*k2*(6*r*s - 17*r + 4*s + 5))))) + Dd*f*k1**2*(f**2*(55*k1**2*(4*s - 1)*(8*Pk2*(33*s - 16) + k2*(-93*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 24*k2**2*(Pk2*(380*r**2 + 528*r*s - 135*r - 660*s**2 + 473*s - 100) + 11*Pkd2*k2*(64*r*s - 32*r + 60*s**2 - 55*s + 14))) + 132*k2**2*(Pk2*b2*(-6*r*(6*s + 17) + 59*s + 13) - 14*Pk2*g2*(r*(16*s - 31) - s + 7) + Pkd2*b2*k2*(r*(32*s + 37) - 33*s - 3) + 4*Pkd2*g2*k2*(12*r*(s - 3) + 13*s + 5)))))/(3465*d**2*k1**3*k2**3) - D1**3*Pk1*ct*(-21*b1**3*k2*(D1*fd*(5*Pkd2*k1**4*s**2 - 3*Pkd2*k1**2*k2**2*s*(8*r + 5*s) - 5*Pkdd2*k1**4*k2*s**2 + k2**3*(8*Pk2*r**2 - 5*Pkdd2*k1**2*s**2)) + Dd*f*(5*Pkd2*k1**4*s*(4*s - 1) - 3*Pkd2*k1**2*k2**2*(4*r*(8*s - 1) + s*(20*s - 9)) + 5*Pkdd2*k1**4*k2*s*(1 - 4*s) + k2**3*(8*Pk2*r*(4*r - 1) + 5*Pkdd2*k1**2*s*(1 - 4*s)))) - 3*b1**2*(D1*(7*bd1*f*k2*(5*Pkd2*k1**4*s*(3*s - 1) - 3*Pkd2*k1**2*k2**2*(4*r*(6*s - 1) + 3*s*(5*s - 3)) + 5*Pkdd2*k1**4*k2*s*(1 - 3*s) + k2**3*(8*Pk2*r*(3*r - 1) + 5*Pkdd2*k1**2*s*(1 - 3*s))) + 2*fd*(2*Pk2*k2**4*(f*(6*r**2 + r - 2) + 28*r**2 + 14*r - 7) + 7*k1**4*(2*Pk2*(3*f*(6*s**2 - 7*s + 2) + 9*s**2 - 10*s + 5) - k2*(Pkd2*(2*f*(9*s**2 - 14*s + 4) + 19*s**2 - 30*s + 15) + 6*Pkdd2*f*k2*s**2)) - k1**2*k2**2*(2*Pk2*(56*K*s + f*(108*r**2 + r*(168*s - 89) + 84*s**2 - 126*s + 38) + 63*r**2 + 7*r*(-23*K*s + 15*K + 23*s - 33) + 70*s**2 - 196*s + 133) + k2*(Pkd2*f*(8*r*(46*s - 7) + 399*s**2 - 296*s + 56) + 7*Pkd2*(19*s**2 + s*(12*K*(r - 1) + 12*r - 42) + 15) + 21*Pkdd2*f*k2*s**2)))) + Dd*f*(4*Pk2*k2**4*(4*r - 1)*(f*(3*r + 2) + 28*r + 7) + 14*k1**4*(4*s - 1)*(2*Pk2*(f*(9*s - 6) + 9*s - 5) + k2*(Pkd2*(-9*f*s + 8*f - 19*s + 15) - 3*Pkdd2*f*k2*s)) - k1**2*k2**2*(4*Pk2*(7*K*(-92*r*s + 19*r + 20*s - 4) + f*(216*r**2 + 6*r*(56*s - 39) + 168*s**2 - 238*s + 73) + 252*r**2 + 644*r*s - 448*r + 280*s**2 - 490*s + 161) + k2*(Pkd2*f*(8*r*(184*s - 37) + 1596*s**2 - 1287*s + 204) + 14*Pkd2*(6*K*(8*r*s - r - 5*s + 1) + 48*r*s - 6*r + 76*s**2 - 109*s + 21) + 21*Pkdd2*f*k2*s*(4*s - 1))))) - 3*b1*(D1*(f**2*(8*Pk2*bd1*k2**4*r*(3*r + 2) + 14*bd1*k1**4*s*(12*Pk2*(3*s - 2) + k2*(Pkd2*(13 - 18*s) + 3*Pkdd2*k2*(1 - 2*s))) - bd1*k1**2*k2**2*(4*Pk2*(108*r**2 + 168*r*s - 145*r + 84*s**2 - 112*s + 35) + k2*(Pkd2*(184*r*(4*s - 1) + 798*s**2 - 695*s + 92) + 21*Pkdd2*k2*s*(2*s - 1))) + 3*fd*k1**4*(40*Pk2*(9*s**2 - 9*s + 2) - 3*k2*(Pkd2*(67*s**2 - 72*s + 16) + 5*Pkdd2*k2*s**2)) - 4*fd*k1**2*k2**2*(Pk2*(90*r**2 + 6*r*(27*s - 14) + 54*s**2 - 171*s + 34) + 3*Pkd2*k2*(12*r*(3*s - 1) + 54*s**2 - 39*s + 10))) + 14*f*(-2*bd1*(Pk2*k2**4*r*(3 - 8*r) + k1**4*s*(-2*Pk2*(9*s - 7) + Pkd2*k2*(19*s - 17)) + k1**2*k2**2*(Pk2*(K*(-46*r*s + 4*r + 8*s - 4) + 18*r**2 + 46*r*s - 22*r + 20*s**2 - 28*s + 4) + Pkd2*k2*(3*K*(4*r*s - r - 2*s + 1) + 12*r*s - 3*r + 19*s**2 - 23*s + 3))) + fd*(4*Pk2*k2**4*r*(2*r - 1) + k1**4*(2*s - 1)*(2*Pk2*(3*s - 5) - 7*Pkd2*k2*(s - 1)) - k1**2*k2**2*(2*Pk2*(K*(-8*r*s + 5*r - 11*s + 5) + 2*r**2 + 20*r*s - 10*r + 8*s**2 - 19*s + 7) + Pkd2*k2*(s - 1)*(K*(8*r - 4) + 8*r + 14*s - 11))) - 2*k1**2*k2**2*s*(2*Pk2*gd2*(23*r - 4) + 3*Pkd2*bd2*k2*(2*r - 1) + 6*Pkd2*gd2*k2*(1 - 2*r))) + 56*fd*k1**2*k2**2*(Pk2*g2*(r*(15 - 23*s) + 8*s) - 3*Pkd2*b2*k2*s*(r - 1) + 6*Pkd2*g2*k2*s*(r - 1))) + Dd*f*(f**2*k1**2*(3*k1**2*(4*s - 1)*(40*Pk2*(3*s - 2) + k2*(-67*Pkd2*s + 48*Pkd2 - 5*Pkdd2*k2*s)) - 8*k2**2*(Pk2*(60*r**2 + 108*r*s - 71*r + 36*s**2 - 120*s + 35) + 3*Pkd2*k2*(3*s - 1)*(8*r + 12*s - 5))) + 14*f*(4*Pk2*k2**4*r*(4*r - 1) + k1**4*(4*s - 1)*(2*Pk2*(3*s - 5) - 7*Pkd2*k2*(s - 1)) - k1**2*k2**2*(2*Pk2*(K*(-16*r*s + 7*r - 23*s + 5) + 4*r**2 + 40*r*s - 8*r + 16*s**2 - 35*s + 7) + Pkd2*k2*(s - 1)*(4*K*(4*r - 1) + 16*r + 28*s - 11))) + 28*k1**2*k2**2*(Pk2*g2*(r*(38 - 184*s) + 40*s - 8) + 3*Pkd2*b2*k2*(-8*r*s + r + 5*s - 1) + 6*Pkd2*g2*k2*(r*(8*s - 1) - 5*s + 1)))) + f*(D1*(f**2*k1**2*(3*bd1*(120*Pk2*k1**2*s*(2 - 3*s) + 3*Pkd2*k1**2*k2*s*(67*s - 43) + 12*Pkd2*k2**3*(4*r*(3*s - 1) + 3*s*(6*s - 5)) + k2**2*(4*Pk2*(30*r**2 + 54*r*s - 58*r + 18*s**2 - 69*s + 36) + 15*Pkdd2*k1**2*s*(s - 1))) - 20*fd*k1**2*(7*Pk2 - 4*Pkd2*k2)*(12*s**2 - 11*s + 2)) + 42*f*(bd1*(-4*Pk2*k2**4*r**2 + k1**4*s*(Pk2*(10 - 6*s) + 7*Pkd2*k2*(s - 1)) + k1**2*k2**2*(2*Pk2*(r**2 + r*(-4*K*s + K + 10*s + 1) + 2*s*(-3*K + 2*s - 4)) + Pkd2*k2*(s - 1)*(r*(4*K + 4) + 7*s))) + 2*k1**2*k2**2*(Pk2*bd2*(3*r*s + r - 6*s) + 2*Pk2*gd2*(r*(4*s - 1) + 6*s) + 2*Pkd2*bd2*k2*r*(s - 1) - 4*Pkd2*gd2*k2*r*(s - 1))) + 84*k1**2*k2**2*(b2*(3*Pkd2*bd1*k2*(r*(2*s - 1) - s + 1) + fd*(Pk2*(6*r*s - 2*r - 11*s + 5) + 2*Pkd2*k2*(2*r - 1)*(s - 1))) + 2*g2*(Pk2*bd1*(r*(23*s - 4) - 4*s + 4) + Pk2*fd*(r*(8*s - 5) + 11*s - 5) + 3*Pkd2*bd1*k2*(-2*r*s + r + s - 1) + 2*Pkd2*fd*k2*(-2*r*(s - 1) + s - 1)))) - 20*Dd*f**3*k1**4*(7*Pk2 - 4*Pkd2*k2)*(12*s**2 - 11*s + 2) + 84*Dd*f*k1**2*k2**2*(Pk2*b2*(s*(12*r - 23) + 5) + 2*Pk2*g2*(r*(16*s - 7) + 23*s - 5) + 2*Pkd2*b2*k2*(4*r - 1)*(s - 1) + 4*Pkd2*g2*k2*(-4*r*(s - 1) + s - 1))))/(315*d**2*k1**3*k2**3) + 2*D1**3*Pk1*ct*st**4*(21*b1**2*k1**2*k2**2*(D1*fd*s*(8*Pk2*k1**2*s - 5*Pkd2*k1**2*k2*s - Pkd2*k2**3*(r*(8*C - 8) + s) + Pkdd2*k2**4*s + k2**2*(Pk2*r*(16*C - 16) + Pkdd2*k1**2*s)) + Dd*f*(8*Pk2*k1**2*s*(4*s - 1) + 5*Pkd2*k1**2*k2*s*(1 - 4*s) + Pkd2*k2**3*(-r*(4*C - 4)*(8*s - 1) + s*(4*C - 4*s - 3)) + Pkdd2*k2**4*s*(4*s - 1) + k2**2*(Pk2*(8*C - 8)*(8*r*s - r - s) + Pkdd2*k1**2*s*(4*s - 1)))) + 3*b1*f*(D1*(-7*bd1*k1**2*k2**2*(8*Pk2*k1**2*s*(1 - 2*s) + 5*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(r*(4*C - 4)*(4*s - 1) + s*(-4*C + 2*s + 3)) + Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(-Pk2*(8*C - 8)*(4*r*s - r - s) + Pkdd2*k1**2*s*(1 - 2*s))) + fd*(8*Pk2*k2**6*r**2 + k1**6*(1 - 2*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**4*k2**2*(2*Pk2*(16*C*(2*s - 1)*(2*r + 7*s - 7) - 175*r*s + 112*r - 232*s**2 + 304*s - 90) + k2*(Pkd2*(-2*C*(2*s - 1)*(8*r + 67*s - 58) + 98*r*s - 63*r + 176*s**2 - 224*s + 63) + 2*Pkdd2*k2*(C*(26*s**2 - 33*s + 10) - 10*s**2 + 12*s - 3))) + k1**2*k2**4*(2*Pk2*(-16*C*s + r**2*(12*C - 12) + r*(-296*C*s + 164*C + 213*s - 105) - 68*s**2 + 84*s - 17) + k2*(Pkd2*r*(16*C*(12*s - 7) - 130*s + 67) + 4*Pkd2*(23*s**2 + s*(4*C - 28) + 6) + Pkdd2*k2*(-24*s**2 + 28*s - 7))))) + Dd*f*(4*Pk2*k2**6*r*(4*r - 1) + k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k1**4*k2**2*(Pk2*(16*C*(2*r*(8*s - 3) + 56*s**2 - 72*s + 15) - 140*r*(5*s - 3) - 928*s**2 + 1099*s - 278) + k2*(Pkd2*(-2*C*(4*r*(8*s - 3) + 268*s**2 - 303*s + 60) + 7*r*(28*s - 17) + 352*s**2 - 382*s + 91) + 2*Pkdd2*k2*(4*s - 1)*(C*(13*s - 10) - 5*s + 3))) + k1**2*k2**4*(Pk2*(4*C*(12*r**2 - 296*r*s + 95*r + 8*s - 8) - 48*r**2 + 852*r*s - 154*r - 272*s**2 + 245*s - 56) + k2*(Pkd2*(8*C*(48*r*s - 20*r - 4*s + 3) - 260*r*s + 75*r + 184*s**2 - 136*s + 20) + Pkdd2*k2*(-48*s**2 + 40*s - 7))))) + f**2*(D1*(3*bd1*(4*Pk2*k2**6*r*(r - 1) + k1**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**4*k2**2*(Pk2*(16*C*(r*(4*s - 1) + 14*s**2 - 16*s + 1) + r*(98 - 175*s) - 232*s**2 + 311*s - 98) + k2*(Pkd2*(-2*C*(r*(8*s - 2) + 67*s**2 - 62*s + 2) + 7*r*(7*s - 4) + 88*s**2 - 95*s + 28) + 2*Pkdd2*k2*s*(C*(13*s - 10) - 5*s + 2))) + k1**2*k2**4*(Pk2*(4*C*(3*r**2 - 74*r*s + 3*r + 18*s - 8) - 12*r**2 + 213*r*s + 42*r - 68*s**2 + 35*s - 22) + k2*(Pkd2*(4*C*(24*r*s - 5*r - 13*s + 6) - 65*r*s + 46*s**2 + 4*s - 4) + Pkdd2*k2*s*(5 - 12*s)))) + fd*(2*Pk2*k2**6*(-45*r**2 + 12*r + 1) + k1**6*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**4*k2**2*(Pk2*(32*C*(3*s - 1)*(3*r + 12*s - 8) + r*(366 - 963*s) - 576*s**2 + 873*s - 242) + k2*(Pkd2*(-2*C*(3*s - 1)*(12*r + 111*s - 62) + 3*r*(87*s - 35) + 171*s**2 - 252*s + 71) + Pkdd2*k2*(3*s - 1)*(C*(42*s - 20) - 3*s + 2))) + k1**2*k2**4*(Pk2*(-12*C*(9*r**2 + 72*r*s - 62*r - 22*s + 19) - 18*r**2 + 81*r*s - 132*r - 180*s**2 + 105*s + 22) + k2*(Pkd2*(8*C*(9*r*(3*s - 2) - 3*s + 4) + 27*r*s - 15*r + 108*s**2 - 126*s + 32) - 3*Pkdd2*k2*(6*s**2 - 5*s + 1))))) + Dd*f*(2*Pk2*k2**6*(-60*r**2 + 11*r + 1) + k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + k1**4*k2**2*(Pk2*(16*C*(24*r*s - 7*r + 96*s**2 - 87*s + 16) - 1284*r*s + 460*r - 768*s**2 + 1021*s - 242) + k2*(Pkd2*(-2*C*(48*r*s - 14*r + 444*s**2 - 357*s + 62) + 348*r*s - 133*r + 228*s**2 - 295*s + 71) + Pkdd2*k2*(4*s - 1)*(C*(42*s - 20) - 3*s + 2))) + k1**2*k2**4*(Pk2*(-12*C*(4*r - 1)*(3*r + 24*s - 19) - 24*r**2 + 12*r*(9*s - 11) - 240*s**2 + 83*s + 22) + k2*(Pkd2*(4*C*(72*r*s - 49*r - s + 8) + 36*r*s - 23*r + 144*s**2 - 150*s + 32) - 3*Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(105*d**2*k1**3*k2**3*k3**2) + 2*D1**3*Pk1*ct*st**2*(21*b1**2*(D1*fd*(6*Pk2*k2**6*r**2 + k1**6*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**4*k2**2*s*(Pk2*r*(16*C - 15) - Pk2*s*(8*C + 14) + Pkd2*k2*(r*(5 - 8*C) + s*(2*C + 11)) + Pkdd2*k2**2*s*(2*C - 4)) - k1**2*k2**4*(Pk2*r*(r*(28 - 28*C) + s*(28*C - 13)) + k2*s*(Pkd2*r*(41 - 40*C) + 4*Pkd2*s + 5*Pkdd2*k2*s))) + Dd*f*(6*Pk2*k2**6*r*(4*r - 1) + k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**4*k2**2*(Pk2*(2*r*(32*C*s - 4*C - 30*s - 5) + s*(-s*(32*C + 56) + 39)) + k2*(Pkd2*r*(C*(4 - 32*s) + 20*s + 5) + Pkd2*s*(C*(8*s + 2) + 44*s - 21) + Pkdd2*k2*s*(2*C - 4)*(4*s - 1))) + k1**2*k2**4*(Pk2*(r**2*(112*C - 112) - 4*r*(28*C*s - 4*C - 13*s + 4) + s*(31 - 16*C)) + k2*(Pkd2*r*(20*C*(8*s - 1) - 164*s + 23) - 2*Pkd2*s*(10*C + 8*s - 11) + 5*Pkdd2*k2*s*(1 - 4*s))))) - 3*b1*f*(D1*(-7*bd1*(6*Pk2*k2**6*r*(2*r - 1) + k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**4*k2**2*(Pk2*(2*r*(16*C*s - 4*C - 15*s - 5) + s*(-s*(16*C + 28) + 39)) + k2*(Pkd2*r*(C*(4 - 16*s) + 10*s + 5) + Pkd2*s*(C*(4*s + 2) + 22*s - 21) + Pkdd2*k2*s*(2*C - 4)*(2*s - 1))) + k1**2*k2**4*(Pk2*(r**2*(56*C - 56) - 2*r*(28*C*s - 8*C - 13*s + 8) + s*(31 - 16*C)) + k2*(Pkd2*r*(20*C*(4*s - 1) - 82*s + 23) - 2*Pkd2*s*(10*C + 4*s - 11) + 5*Pkdd2*k2*s*(1 - 2*s)))) + fd*(-14*Pk2*k2**6*(10*r**2 + 3*r - 1) + k1**6*(4*Pk2*(62*s**2 - 121*s + 39) + k2*(-4*Pkd2*(17*s**2 - 46*s + 15) + Pkdd2*k2*(2*s**2 - 21*s + 7))) + k1**4*k2**2*(Pk2*(4*C*(4*r*s - 145*r + 312*s**2 - 538*s + 200) + 196*r**2 - 396*r*s + 706*r + 496*s**2 - 63*s - 148) + k2*(Pkd2*(2*C*(20*r*s + 84*r - 504*s**2 + 669*s - 210) + 388*r*s - 371*r + 264*s**2 - 262*s + 87) + Pkdd2*k2*(6*C*(32*s**2 - 49*s + 14) + 16*s**2 - 21*s + 7))) + k1**2*k2**4*(Pk2*(-4*C*(120*r**2 + 192*r*s - 99*r + 37*s - 12) + 688*r**2 + 972*r*s - 532*r + 672*s**2 - 671*s + 174) + k2*(Pkd2*(-32*C*s + r*(-48*C*s + 412*s - 231) + 236*s**2 - 234*s + 63) + 14*Pkdd2*k2*s**2)))) + Dd*f*(14*Pk2*k2**6*(-20*r**2 + r + 1) + k1**6*(4*s - 1)*(4*Pk2*(31*s - 39) + k2*(Pkd2*(60 - 34*s) + Pkdd2*k2*(s - 7))) + k1**4*k2**2*(2*Pk2*(2*C*(8*r*s - 279*r + 624*s**2 - 947*s + 267) + 196*r**2 - 396*r*s + 539*r + 496*s**2 + 167*s - 195) + k2*(Pkd2*(4*C*(20*r*s + 92*r - 504*s**2 + 549*s - 130) + 776*r*s - 636*r + 528*s**2 - 582*s + 223) + Pkdd2*k2*(12*C + 1)*(32*s**2 - 36*s + 7))) + k1**2*k2**4*(-2*Pk2*(2*C*(240*r**2 + 384*r*s - 109*r + 73*s - 30) - 688*r**2 - 972*r*s + 360*r - 672*s**2 + 415*s - 48) + k2*(Pkd2*(-4*C*(24*r*s + 4*r + 26*s - 9) + 824*r*s - 418*r + 472*s**2 - 462*s + 139) + 7*Pkdd2*k2*s*(4*s - 1))))) - f**2*(D1*(3*bd1*(-70*Pk2*k2**6*r*(r - 1) + k1**6*s*(4*Pk2*(31*s - 27) + k2*(Pkd2*(30 - 34*s) + Pkdd2*k2*(s - 1))) + k1**4*k2**2*(Pk2*(4*C*(2*r*s - 61*r + 156*s**2 - 215*s + 67) + 98*r**2 - 198*r*s + 122*r + 248*s**2 + 257*s - 242) + k2*(Pkd2*(2*C*(10*r*s + 44*r - 252*s**2 + 225*s - 50) + 194*r*s - 125*r + 132*s**2 - 237*s + 136) + 2*Pkdd2*k2*s*(48*C*s - 27*C + 4*s - 4))) + k1**2*k2**4*(Pk2*(-8*C*(30*r**2 + 48*r*s - 11*r + 9*s - 9) + 344*r**2 + 2*r*(243*s - 94) + 336*s**2 - 63*s - 78) + k2*(Pkd2*(-4*C*(6*r*s + 4*r + 9*s - 9) + 103*r*(2*s - 1) + 118*s**2 - 173*s + 76) + 7*Pkdd2*k2*s*(s - 1)))) + fd*(72*Pk2*k2**6*r*(1 - 3*r) + 3*k1**6*(3*s - 1)*(4*Pk2*(27*s - 19) + k2*(-4*Pkd2*(9*s - 7) + 3*Pkdd2*k2*(s - 1))) + k1**4*k2**2*(Pk2*(4*C*(3*r*(87*s - 137) + 918*s**2 - 1158*s + 392) + 450*r**2 + 3*r*(412 - 519*s) + 486*s**2 + 879*s - 636) + 3*k2*(Pkd2*(-2*C*(54*r*s - 78*r + 459*s**2 - 429*s + 112) + 369*r*s - 219*r + 162*s**2 - 225*s + 89) + 3*Pkdd2*k2*(3*s - 1)*(6*C*(3*s - 2) + s - 1))) + 3*k1**2*k2**4*(Pk2*(4*C*(45*r**2 - 18*r*(2*s + 5) - 90*s + 59) + 432*r**2 + 3*r*(147*s - 88) + 216*s**2 - 51*s - 16) + 3*Pkd2*k2*(16*C*(3*r - 1)*(2*s - 1) + 9*r*(9*s - 5) + 42*s**2 - 53*s + 19)))) + Dd*f*(72*Pk2*k2**6*r*(1 - 4*r) + 3*k1**6*(4*s - 1)*(4*Pk2*(27*s - 19) + k2*(-4*Pkd2*(9*s - 7) + 3*Pkdd2*k2*(s - 1))) + k1**4*k2**2*(Pk2*(4*C*(348*r*s - 547*r + 1224*s**2 - 1414*s + 392) + 600*r**2 - 2076*r*s + 1568*r + 648*s**2 + 1183*s - 636) + 3*k2*(Pkd2*(-2*C*(72*r*s - 110*r + 612*s**2 - 509*s + 112) + 492*r*s - 279*r + 216*s**2 - 254*s + 89) + 3*Pkdd2*k2*(4*s - 1)*(6*C*(3*s - 2) + s - 1))) + 3*k1**2*k2**4*(Pk2*(4*C*(60*r**2 - 48*r*s - 113*r - 126*s + 59) + 576*r**2 + 588*r*s - 256*r + 288*s**2 - 43*s - 16) + 3*Pkd2*k2*(16*C*(4*r - 1)*(2*s - 1) + 108*r*s - 57*r + 56*s**2 - 60*s + 19)))))/(315*d**2*k1**3*k2**3*k3**2) - 2*D1**3*Pk1*ct*(7*b1**2*(D1*fd*(-10*Pk2*k2**6*r**2 + 4*k1**6*s**2*(-2*Pk2 + Pkd2*k2) + k1**4*k2**2*(Pk2*(50*r**2 + r*s*(109 - 64*C) + s**2*(76 - 56*C)) + k2*s*(10*C*Pkdd2*k2*s + Pkd2*r*(40*C + 25) + Pkd2*s*(10*C + 39))) + k1**2*k2**4*(Pk2*(r**2*(38 - 20*C) + r*s*(89 - 60*C) + 50*s**2) + 15*Pkd2*k2*s*(r + s))) + Dd*f*(10*Pk2*k2**6*r*(1 - 4*r) - 4*k1**6*s*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**4*k2**2*(Pk2*(200*r**2 + r*(-256*C*s + 32*C + 436*s - 122) + s*(-224*C*s + 88*C + 304*s - 113)) + k2*(10*C*Pkdd2*k2*s*(4*s - 1) + 5*Pkd2*r*(4*C*(8*s - 1) + 20*s - 1) + Pkd2*s*(10*C*(4*s - 3) + 156*s - 59))) + k1**2*k2**4*(Pk2*(r**2*(152 - 80*C) - 4*r*(60*C*s - 20*C - 89*s + 30) + s*(200*s - 57)) + 5*Pkd2*k2*(r*(12*s - 1) + s*(12*s - 5))))) + b1*f*(D1*(7*bd1*(10*Pk2*k2**6*r*(1 - 2*r) - 4*k1**6*s*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**4*k2**2*(Pk2*(100*r**2 - 2*r*(64*C*s - 16*C - 109*s + 61) + s*(-112*C*s + 88*C + 152*s - 113)) + k2*(10*C*Pkdd2*k2*s*(2*s - 1) + 5*Pkd2*r*(4*C*(4*s - 1) + 10*s - 1) + Pkd2*s*(10*C*(2*s - 3) + 78*s - 59))) + k1**2*k2**4*(Pk2*(r**2*(76 - 40*C) - 2*r*(60*C*s - 40*C - 89*s + 60) + s*(100*s - 57)) + 5*Pkd2*k2*(r*(6*s - 1) + s*(6*s - 5)))) + fd*(28*Pk2*k2**6*r*(1 - 2*r) + k1**6*(-2*Pk2*(90*s**2 - 91*s + 35) + Pkd2*k2*(146*s**2 - 147*s + 49)) + k1**4*k2**2*(Pk2*(-4*C*(164*r*s + 7*r + 48*s**2 + 2*s - 28) + 712*r**2 + 2018*r*s - 964*r + 752*s**2 - 897*s + 178) + k2*(84*C*Pkdd2*k2*s**2 + Pkd2*(4*C*(190*r*s - 70*r + 189*s**2 - 256*s + 56) + 210*r*s + 412*s**2 - 231*s + 49))) + k1**2*k2**4*(Pk2*(4*C*(66*r**2 - 28*r*s - 129*r - 91*s + 48) + 440*r**2 + 1058*r*s - 482*r + 308*s**2 - 235*s + 54) + 14*Pkd2*k2*s*(C*(8*r - 4) + 9*r + 7*s - 3)))) + Dd*f*(28*Pk2*k2**6*r*(1 - 4*r) + k1**6*(4*s - 1)*(Pk2*(70 - 90*s) + Pkd2*k2*(73*s - 49)) + k1**4*k2**2*(Pk2*(-4*C*(328*r*s - 55*r + 96*s**2 - 63*s + 3) + 1424*r**2 + 4036*r*s - 1716*r + 1504*s**2 - 1809*s + 446) + k2*(42*C*Pkdd2*k2*s*(4*s - 1) + Pkd2*(2*C*(760*r*s - 340*r + 756*s**2 - 887*s + 212) + 420*r*s - 21*r + 824*s**2 - 486*s + 49))) + k1**2*k2**4*(Pk2*(4*C*(132*r**2 - 4*r*(14*s + 51) - 175*s + 90) + 880*r**2 + 2116*r*s - 914*r + 616*s**2 - 573*s + 146) + 7*Pkd2*k2*(r*(s*(32*C + 36) - 3) + s*(-8*C + 28*s - 13))))) + f**2*(D1*(bd1*(-28*Pk2*k2**6*r**2 + k1**6*s*(Pk2*(118 - 90*s) + 73*Pkd2*k2*(s - 1)) + k1**4*k2**2*(Pk2*(-4*C*(82*r*s - 55*r + 24*s**2 - 69*s + 31) + 356*r**2 + 1009*r*s - 602*r + 376*s**2 - 616*s + 268) + k2*(C*Pkd2*(20*r*(19*s - 13) + 378*s**2 - 466*s + 200) + 42*C*Pkdd2*k2*s*(s - 1) + 21*Pkd2*r*(5*s - 1) + 206*Pkd2*s*(s - 1))) + k1**2*k2**4*(Pk2*(4*C*(33*r**2 - 14*r*s - 27*r - 42*s + 42) + 220*r**2 + 529*r*s - 378*r + 154*s**2 - 246*s + 92) + 7*Pkd2*k2*(r*(8*C*s + 9*s - 3) + s*(7*s - 7)))) - 3*fd*k1**2*(-4*Pk2*k2**4*r*(3*r + 27*s - 10) + k1**4*(3*s - 1)*(2*Pk2*(5*s - 9) - 11*Pkd2*k2*(s - 1)) - k1**2*k2**2*(2*Pk2*(C*(30*r*s - 2*r + 36*s**2 - 92*s + 24) + 21*r**2 + r*(120*s - 47) + 2*(1 - 3*s)**2) + Pkd2*k2*(12*C*(9*r*(s - 1) + 18*s**2 - 21*s + 7) + 33*s**2 - 44*s + 11)))) - 3*Dd*f*k1**2*(-8*Pk2*k2**4*r*(2*r + 18*s - 5) + k1**4*(4*s - 1)*(2*Pk2*(5*s - 9) - 11*Pkd2*k2*(s - 1)) - k1**2*k2**2*(Pk2*(4*C*(20*r*s + r + 24*s**2 - 60*s + 12) + 56*r**2 + 320*r*s - 94*r + 48*s**2 - 28*s + 4) + Pkd2*k2*(12*C*(12*r*(s - 1) + 24*s**2 - 25*s + 7) + 44*s**2 - 55*s + 11)))))/(105*d**2*k1**3*k2**3*k3**2) - 4*D1**3*Pk1*f*k2**2*st**6*(-9*D1*bd1*f*(Pk2*k2**2*(-4*r**2 + r*(5 - 4*s) + 2*s - 1) + k1**2*(2*C*Pkd2*k2*(-4*r*s + r - (1 - 2*s)**2) + Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) + 9*b1*(4*D1*fd*(-C*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Pk2*r*(k1**2 + k2**2)) - Dd*f*(Pk2*k2**2*(1 - 8*r) + k1**2*(4*C*Pk2*(8*s - 3) + 2*C*Pkd2*k2*(3 - 8*s) - 8*Pk2*r + Pk2)))*(2*r + 2*s - 1) + f*(2*D1*fd*(Pk2*k2**2*(3*r - 1) - k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2))*(3*r + 3*s - 2) + Dd*f*(Pk2*k2**2*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + k1**2*(2*C*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + Pk2*(-4*C*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + 24*r**2 + 3*r*(8*s - 7) - 7*s + 4)))))/(63*d**2*k1**2*k3**4) + 2*D1**3*Pk1*f*st**6*(-9*D1*bd1*f*(k1**2*(2*C*Pkdd2*k2**2*s*(1 - 2*s) + 4*Pk2*r*(4*s - 1) - 4*Pk2*(2*s - 1)*(4*C*s + 1) + Pkd2*k2*(-4*r*s + r + (2*s - 1)*(10*C*s + 1))) + k2**2*(Pk2*(r**2*(8*C - 8) + r*(-8*C + 8*s + 6) - 4*s + 2) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 9*b1*(2*D1*fd*(-8*C*Pk2*k2**2*r**2 + C*k1**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) - 2*k1**2*r*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k2**2*r*(Pk2*(4*r - 4*s + 2) + Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*Pk2*(4*C*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 2*s - 1) + k2*(2*C*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-10*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r - 2*s + 1))) + k2**2*(Pk2*(-r**2*(32*C - 32) + 4*r*(2*C - 8*s + 1) + 4*s - 2) + Pkd2*k2*(2*r*(8*s - 3) - 2*s + 1)))) + f*(2*D1*fd*(k1**2*(3*s - 1)*(4*Pk2*(C*(6*s - 2) - 3*r + 1) + k2*(C*Pkdd2*k2*(3*s - 1) + Pkd2*(-15*C*s + 5*C + 3*r - 1))) + k2**2*(3*r - 1)*(C*Pk2*(2 - 6*r) + 6*Pk2*(r - s) + Pkd2*k2*(3*s - 1))) + Dd*f*(k1**2*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 7*s - 2) + k2*(2*C*Pkdd2*k2*(12*s**2 - 7*s + 1) + Pkd2*(-10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 7*s + 2))) + k2**2*(-4*C*Pk2*(12*r**2 - 7*r + 1) + 2*Pk2*(r - s)*(24*r - 7) + Pkd2*k2*(24*r*s - 7*r - 7*s + 2)))))/(63*d**2*k1**2*k3**2) + D1**3*Pk1*f*st**6*(198*b1**2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + 11*b1*f*(36*D1*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + 3*D1*fd*(2*k1**2*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k2**2*r*(Pk2*(22 - 39*s) + Pkd2*k2*(21*s - 10))) + 6*Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + Dd*f*k2**2*(Pk2*(-52*r*(3*s - 2) + 87*s - 38) + Pkd2*k2*(r*(84*s - 44) - 33*s + 14))) + f**2*(11*D1*bd1*(144*Pk2*k1**2*s*(3*s - 1) - 54*Pkd2*k1**2*k2*s*(3*s - 1) + Pkd2*k2**3*(7*r*(3*s - 2) - 33*s + 14) + k2**2*(Pk2*(-39*r*s + 38*r + 87*s - 38) + 6*Pkdd2*k1**2*s*(3*s - 1))) + D1*fd*(12*k1**2*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k2**2*(Pk2*(-12*r*(85*s - 24) + 695*s - 182) + Pkd2*k2*(6*r*(70*s - 23) - 215*s + 62))) + 12*Dd*f*k1**2*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + Dd*f*k2**2*(Pk2*(-12*r*(85*s - 24) + 695*s - 182) + Pkd2*k2*(6*r*(70*s - 23) - 215*s + 62))))/(693*d**2*k1**2*k2**2) + 4*D1**3*Pk1*(36*C*Pk2*f**2*k1**2*k2**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1))*(r + s - 1) + D1*bd1*f*(7*b1*(2*Pk2*k1**4*(r*(4*s - 1) + s*(4*s - 3)) + 5*Pk2*k2**4*(r**2*(8*C + 2) + r*(8*C*(2*s - 1) + 4*s - 3) + s*(8*C*(s - 1) + 2*s - 1)) + k1**2*k2**2*(20*C*Pkd2*k2*s*(r + s - 1) + Pk2*(r**2*(80*C + 10) + r*(80*C*(2*s - 1) + 28*s - 17) + s*(80*C*(s - 1) + 18*s - 11)))) + f*(6*Pk2*k1**4*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 7*Pk2*k2**4*(r**2*(12*C + 3) + r*(20*C*s - 8*C + 6*s - 6) + s*(8*C + 3)*(s - 1)) + k1**2*k2**2*(42*C*Pkd2*k2*s*(r + s - 1) + Pk2*(4*C*(60*r**2 + 116*r*s - 81*r + 56*s**2 - 85*s + 29) + 21*r**2 + 66*r*s - 54*r + 45*s**2 - 51*s + 6)))) + 7*b1**2*(D1*fd*(r + s)*(4*Pk2*k1**4*s + Pk2*k2**4*(20*C + 5)*(r + s) + k1**2*k2**2*(10*C*Pkd2*k2*s + Pk2*r*(40*C + 5) + Pk2*s*(40*C + 9))) + Dd*f*(2*Pk2*k1**4*(r*(8*s - 1) + s*(8*s - 3)) + 5*Pk2*k2**4*(r**2*(16*C + 4) + r*(8*C*(4*s - 1) + 8*s - 3) + s*(8*C*(2*s - 1) + 4*s - 1)) + k1**2*k2**2*(20*C*Pkd2*k2*s*(2*r + 2*s - 1) + Pk2*(r**2*(160*C + 20) + r*(80*C*(4*s - 1) + 56*s - 17) + s*(80*C*(2*s - 1) + 36*s - 11))))) + b1*f*(D1*fd*(2*C*k2**2*(14*Pk2*k2**2*(6*r**2 + r*(10*s - 3) + s*(4*s - 3)) + k1**2*(Pk2*(240*r**2 + 464*r*s - 268*r + 224*s**2 - 302*s + 88) + 21*Pkd2*k2*s*(2*r + 2*s - 1))) + Pk2*(3*k1**2 + 3*k2**2)*(8*k1**2*s*(2*r + 2*s - 1) + 7*k2**2*(2*r**2 + r*(4*s - 1) + 2*s**2))) + Dd*f*(6*Pk2*k1**4*(8*s - 1)*(2*r + 2*s - 1) + 7*Pk2*k2**4*(r**2*(48*C + 12) + r*(20*C*(4*s - 1) + 24*s - 9) + s*(4*C*(8*s - 5) + 12*s - 3)) + k1**2*k2**2*(4*C*Pk2*(240*r**2 + r*(464*s - 245) + 224*s**2 - 279*s + 73) + 84*C*Pkd2*k2*s*(2*r + 2*s - 1) + 3*Pk2*(28*r**2 + r*(88*s - 25) + 60*s**2 - 27*s + 2)))))/(105*d**2*k2**2*k3**4) - 4*D1**3*Pk1*st**4*(D1*bd1*f*(7*b1*k2**2*(Pk2*k2**2*(4*r**2 + r*(4*s - 3) - s) + k1**2*(2*C*Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3)) + Pk2*(4*r**2 + r*(4*s - 3) - s))) + f*(Pk2*k2**4*(-24*r**2 + r*(31 - 24*s) + 13*s - 6) + k1**4*(2*C*Pkd2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + Pk2*(-4*C*(5*r*s - 3*r + 5*s**2 - 12*s + 3) + 5*r**2 + 10*r*s - 11*r + 5*s**2 - 4*s + 6)) + k1**2*k2**2*(-2*C*(14*Pk2*(r**2 - r*(s + 1) - 2*s**2 + s) + Pkd2*k2*(r*(24*s - 5) + 24*s**2 - 23*s + 6)) + Pk2*(-19*r**2 + r*(20 - 14*s) + s*(5*s + 9))))) + 7*b1**2*k2**2*(2*D1*fd*(r + s)*(Pk2*k2**2*r + k1**2*(2*C*Pkd2*k2*s + Pk2*r)) + Dd*f*(Pk2*k2**2*(8*r**2 + r*(8*s - 3) - s) + k1**2*(2*C*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3)) + Pk2*(8*r**2 + r*(8*s - 3) - s)))) + b1*f*(-D1*fd*(2*Pk2*k2**4*(12*r + 1)*(2*r + 2*s - 1) + k1**4*(-2*C*Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6) + Pk2*(4*C*(2*s - 1)*(5*r + 5*s - 6) - 10*r**2 - 20*r*s + 24*r - 10*s**2 + 17*s - 6)) + k1**2*k2**2*(4*C*Pkd2*k2*(12*s - 7)*(2*r + 2*s - 1) + Pk2*(28*C*(2*r**2 - 2*r*s + r - 4*s**2 + 4*s - 1) + 38*r**2 + 28*r*s + 4*r - 10*s**2 + 21*s - 8))) + Dd*f*(-4*Pk2*k2**4*(12*r - 1)*(2*r + 2*s - 1) + k1**4*(2*C*Pkd2*k2*(r*(20*s - 11) + 20*s**2 - 35*s + 9) + Pk2*(-4*C*(20*r*s - 11*r + 20*s**2 - 35*s + 9) + 20*r**2 + 40*r*s - 41*r + 20*s**2 - 27*s + 12)) + k1**2*k2**2*(-8*C*Pkd2*k2*(12*s - 5)*(2*r + 2*s - 1) + Pk2*(-28*C*(4*r**2 - 4*r*s - 8*s**2 + 6*s - 1) - 76*r**2 - 56*r*s + 15*r + 20*s**2 - 19*s + 8)))) - f**2*(D1*fd*(Pk2*k2**4*(12*r**2 + 3*r*(4*s - 3) - 2*s + 1) + k1**4*(-2*C*Pkd2*k2*(3*s - 1)*(3*r + 3*s - 2) + Pk2*(4*C*(3*s - 1)*(3*r + 3*s - 2) - 9*r**2 - 12*r*s + 14*r - 3*s**2 + 9*s - 5)) + k1**2*k2**2*(2*C*Pkd2*k2*(r*(12*s - 5) + 3*(1 - 2*s)**2) + Pk2*(r**2*(36*C + 3) + r*(-4*C*(3*s + 8) + 5) - s**2*(48*C + 3) + s*(40*C + 7) - 4))) + Dd*f*(Pk2*k2**4*(8*r - 1)*(2*r + 2*s - 1) + k1**4*(4*C*Pkd2*k2*(1 - 3*s) + Pk2*(8*C*(3*s - 1) - 6*r - 2*s + 5))*(2*r + 2*s - 1) + 2*k1**2*k2**2*(C*Pkd2*k2*(8*s - 3)*(2*r + 2*s - 1) + Pk2*(r**2*(24*C + 2) + r*(-4*C*(2*s + 5) + 3) - s**2*(32*C + 2) + s*(24*C + 5) - 2)))))/(35*d**2*k1**2*k3**4) + D1**3*Pk1*st**4*(462*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(2*D1*(-7*bd1*f*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + fd*(k1**2*(Pk2*(f*(7*r*(s - 2) + 320*s**2 - 416*s + 104) + (56 - 56*s)*(K*(s - 1) - r + s - 1)) + k2*(Pkd2*f*(-7*r*s + 7*r - 116*s**2 + 176*s - 44) + 7*Pkd2*(s - 1)*(5*K*(s - 1) - 2*r + 5*s - 5) + 6*Pkdd2*f*k2*(2*s**2 - 4*s + 1) + Pkdd2*k2*(-7*K - 7)*(s - 1)**2)) - 2*k2**2*r*(Pk2*f*(13 - 31*s) + 7*Pk2*(-K*r + r - 2*s + 2) + Pkd2*k2*(5*f*s - 3*f + 7*s - 7)))) + Dd*f*(k1**2*(Pk2*f*(28*r*(s - 4) + 1280*s**2 - 1215*s + 250) - 56*Pk2*(2*K*(4*s**2 - 5*s + 1) + r*(5 - 8*s) + 8*s**2 - 9*s + 1) + Pkd2*k2*(70*K*(4*s**2 - 5*s + 1) + f*(r*(42 - 28*s) - 464*s**2 + 489*s - 102) - 112*r*s + 70*r + 280*s**2 - 336*s + 56) + Pkdd2*k2**2*(-14*K + 12*f - 14)*(4*s**2 - 5*s + 1)) - 2*k2**2*(Pk2*(f*(r*(52 - 124*s) + 47*s - 17) - 14*r**2*(4*K - 4) + 14*r*(K - 8*s + 4) + 14*s - 14) + Pkd2*k2*(f*(4*r*(5*s - 3) - 13*s + 5) + 7*r*(8*s - 5) - 7*s + 7)))) - 11*b1*(-192*D1*K*Pk2*f*fd*k1**2*s**2 + 192*D1*K*Pk2*f*fd*k1**2*s - 48*D1*K*Pk2*f*fd*k1**2 + 48*D1*K*Pk2*f*fd*k2**2*r**2 - 48*D1*K*Pk2*f*fd*k2**2*r + 12*D1*K*Pk2*f*fd*k2**2 + 120*D1*K*Pkd2*f*fd*k1**2*k2*s**2 - 120*D1*K*Pkd2*f*fd*k1**2*k2*s + 30*D1*K*Pkd2*f*fd*k1**2*k2 - 24*D1*K*Pkdd2*f*fd*k1**2*k2**2*s**2 + 24*D1*K*Pkdd2*f*fd*k1**2*k2**2*s - 6*D1*K*Pkdd2*f*fd*k1**2*k2**2 - 336*D1*Pk2*bd2*f*k1**2*s**2 + 336*D1*Pk2*bd2*f*k1**2*s + 342*D1*Pk2*f**2*fd*k1**2*r*s - 132*D1*Pk2*f**2*fd*k1**2*r + 2160*D1*Pk2*f**2*fd*k1**2*s**2 - 1689*D1*Pk2*f**2*fd*k1**2*s + 294*D1*Pk2*f**2*fd*k1**2 + 324*D1*Pk2*f**2*fd*k2**2*r**2 + 567*D1*Pk2*f**2*fd*k2**2*r*s - 258*D1*Pk2*f**2*fd*k2**2*r - 186*D1*Pk2*f**2*fd*k2**2*s + 66*D1*Pk2*f**2*fd*k2**2 + 192*D1*Pk2*f*fd*k1**2*r*s - 96*D1*Pk2*f*fd*k1**2*r - 192*D1*Pk2*f*fd*k1**2*s**2 + 96*D1*Pk2*f*fd*k1**2*s - 48*D1*Pk2*f*fd*k2**2*r**2 + 96*D1*Pk2*f*fd*k2**2*r*s - 48*D1*Pk2*f*fd*k2**2*s + 12*D1*Pk2*f*fd*k2**2 + 672*D1*Pk2*f*gd2*k1**2*s**2 - 672*D1*Pk2*f*gd2*k1**2*s - 168*D1*Pk2*f*gd2*k2**2*r**2 + 672*D1*Pk2*fd*g2*k1**2*s**2 - 1344*D1*Pk2*fd*g2*k1**2*s + 672*D1*Pk2*fd*g2*k1**2 - 168*D1*Pk2*fd*g2*k2**2*r**2 + 210*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 210*D1*Pkd2*bd2*f*k1**2*k2*s - 126*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 60*D1*Pkd2*f**2*fd*k1**2*k2*r - 702*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 663*D1*Pkd2*f**2*fd*k1**2*k2*s - 126*D1*Pkd2*f**2*fd*k1**2*k2 + 135*D1*Pkd2*f**2*fd*k2**3*r*s - 66*D1*Pkd2*f**2*fd*k2**3*r + 66*D1*Pkd2*f**2*fd*k2**3*s - 14*D1*Pkd2*f**2*fd*k2**3 - 48*D1*Pkd2*f*fd*k1**2*k2*r*s + 24*D1*Pkd2*f*fd*k1**2*k2*r + 120*D1*Pkd2*f*fd*k1**2*k2*s**2 - 96*D1*Pkd2*f*fd*k1**2*k2*s + 18*D1*Pkd2*f*fd*k1**2*k2 - 48*D1*Pkd2*f*fd*k2**3*r*s + 24*D1*Pkd2*f*fd*k2**3*r + 24*D1*Pkd2*f*fd*k2**3*s - 12*D1*Pkd2*f*fd*k2**3 - 420*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 420*D1*Pkd2*f*gd2*k1**2*k2*s - 420*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 840*D1*Pkd2*fd*g2*k1**2*k2*s - 420*D1*Pkd2*fd*g2*k1**2*k2 - 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 54*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 78*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 16*D1*Pkdd2*f**2*fd*k1**2*k2**2 - 24*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 + 24*D1*Pkdd2*f*fd*k1**2*k2**2*s - 6*D1*Pkdd2*f*fd*k1**2*k2**2 + 84*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 84*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 84*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 168*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 84*D1*Pkdd2*fd*g2*k1**2*k2**2 + 3*D1*bd1*f*(k1**2*(Pk2*f*(14*r*(s - 6) + 640*s**2 - 383*s + 42) + 56*Pk2*(r*(4*s - 2) - (s - 1)*(s*(4*K + 4) + 1)) - Pkd2*k2*(f*(14*r*(s - 2) + 232*s**2 - 137*s + 14) - 14*r*(2 - 4*s) - 14*(s - 1)*(s*(10*K + 10) + 1)) + 4*Pkdd2*k2**2*s*(f*(6*s - 3) + (-7*K - 7)*(s - 1))) - 2*k2**2*(Pk2*(f*(r*(26 - 62*s) + 47*s - 17) - 14*r**2*(2*K - 2) + 14*r*(K - 4*s + 1) + 14*s - 14) + Pkd2*k2*(f*(2*r*(5*s - 3) - 13*s + 5) + 7*r*(4*s - 2) - 7*s + 7))) - 384*Dd*K*Pk2*f**2*k1**2*s**2 + 288*Dd*K*Pk2*f**2*k1**2*s - 48*Dd*K*Pk2*f**2*k1**2 + 96*Dd*K*Pk2*f**2*k2**2*r**2 - 72*Dd*K*Pk2*f**2*k2**2*r + 12*Dd*K*Pk2*f**2*k2**2 + 240*Dd*K*Pkd2*f**2*k1**2*k2*s**2 - 180*Dd*K*Pkd2*f**2*k1**2*k2*s + 30*Dd*K*Pkd2*f**2*k1**2*k2 - 48*Dd*K*Pkdd2*f**2*k1**2*k2**2*s**2 + 36*Dd*K*Pkdd2*f**2*k1**2*k2**2*s - 6*Dd*K*Pkdd2*f**2*k1**2*k2**2 + 456*Dd*Pk2*f**3*k1**2*r*s - 208*Dd*Pk2*f**3*k1**2*r + 2880*Dd*Pk2*f**3*k1**2*s**2 - 1954*Dd*Pk2*f**3*k1**2*s + 332*Dd*Pk2*f**3*k1**2 + 432*Dd*Pk2*f**3*k2**2*r**2 + 756*Dd*Pk2*f**3*k2**2*r*s - 346*Dd*Pk2*f**3*k2**2*r - 127*Dd*Pk2*f**3*k2**2*s + 44*Dd*Pk2*f**3*k2**2 + 384*Dd*Pk2*f**2*k1**2*r*s - 144*Dd*Pk2*f**2*k1**2*r - 384*Dd*Pk2*f**2*k1**2*s**2 + 144*Dd*Pk2*f**2*k1**2*s - 96*Dd*Pk2*f**2*k2**2*r**2 + 192*Dd*Pk2*f**2*k2**2*r*s - 72*Dd*Pk2*f**2*k2**2*s + 12*Dd*Pk2*f**2*k2**2 + 2688*Dd*Pk2*f*g2*k1**2*s**2 - 3360*Dd*Pk2*f*g2*k1**2*s + 672*Dd*Pk2*f*g2*k1**2 - 672*Dd*Pk2*f*g2*k2**2*r**2 + 168*Dd*Pk2*f*g2*k2**2*r - 168*Dd*Pkd2*f**3*k1**2*k2*r*s + 88*Dd*Pkd2*f**3*k1**2*k2*r - 936*Dd*Pkd2*f**3*k1**2*k2*s**2 + 748*Dd*Pkd2*f**3*k1**2*k2*s - 140*Dd*Pkd2*f**3*k1**2*k2 + 180*Dd*Pkd2*f**3*k2**3*r*s - 92*Dd*Pkd2*f**3*k2**3*r - Dd*Pkd2*f**3*k2**3*s + 12*Dd*Pkd2*f**3*k2**3 - 96*Dd*Pkd2*f**2*k1**2*k2*r*s + 36*Dd*Pkd2*f**2*k1**2*k2*r + 240*Dd*Pkd2*f**2*k1**2*k2*s**2 - 144*Dd*Pkd2*f**2*k1**2*k2*s + 18*Dd*Pkd2*f**2*k1**2*k2 - 96*Dd*Pkd2*f**2*k2**3*r*s + 36*Dd*Pkd2*f**2*k2**3*r + 36*Dd*Pkd2*f**2*k2**3*s - 12*Dd*Pkd2*f**2*k2**3 - 1680*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 2100*Dd*Pkd2*f*g2*k1**2*k2*s - 420*Dd*Pkd2*f*g2*k1**2*k2 + 72*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 82*Dd*Pkdd2*f**3*k1**2*k2**2*s + 16*Dd*Pkdd2*f**3*k1**2*k2**2 - 48*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 + 36*Dd*Pkdd2*f**2*k1**2*k2**2*s - 6*Dd*Pkdd2*f**2*k1**2*k2**2 + 336*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 420*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 84*Dd*Pkdd2*f*g2*k1**2*k2**2 - 42*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) - f*(-1056*D1*Pk2*bd2*f*k1**2*s**2 + 528*D1*Pk2*bd2*f*k1**2*s + 2140*D1*Pk2*f**2*fd*k1**2*r*s - 480*D1*Pk2*f**2*fd*k1**2*r + 11264*D1*Pk2*f**2*fd*k1**2*s**2 - 6431*D1*Pk2*f**2*fd*k1**2*s + 890*D1*Pk2*f**2*fd*k1**2 + 1472*D1*Pk2*f**2*fd*k2**2*r**2 + 1100*D1*Pk2*f**2*fd*k2**2*r*s - 318*D1*Pk2*f**2*fd*k2**2*r + 1155*D1*Pk2*f**2*fd*k2**2*s - 370*D1*Pk2*f**2*fd*k2**2 + 2112*D1*Pk2*f*gd2*k1**2*s**2 - 1056*D1*Pk2*f*gd2*k1**2*s - 528*D1*Pk2*f*gd2*k2**2*r**2 + 264*D1*Pk2*f*gd2*k2**2*r + 4224*D1*Pk2*fd*g2*k1**2*s**2 - 4224*D1*Pk2*fd*g2*k1**2*s + 1056*D1*Pk2*fd*g2*k1**2 - 1056*D1*Pk2*fd*g2*k2**2*r**2 + 1056*D1*Pk2*fd*g2*k2**2*r - 264*D1*Pk2*fd*g2*k2**2 + 660*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 330*D1*Pkd2*bd2*f*k1**2*k2*s - 700*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 230*D1*Pkd2*f**2*fd*k1**2*k2*r - 3872*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 2441*D1*Pkd2*f**2*fd*k1**2*k2*s - 382*D1*Pkd2*f**2*fd*k1**2*k2 + 1100*D1*Pkd2*f**2*fd*k2**3*r*s - 440*D1*Pkd2*f**2*fd*k2**3*r - 275*D1*Pkd2*f**2*fd*k2**3*s + 110*D1*Pkd2*f**2*fd*k2**3 - 1320*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 660*D1*Pkd2*f*gd2*k1**2*k2*s - 2640*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 2640*D1*Pkd2*fd*g2*k1**2*k2*s - 660*D1*Pkd2*fd*g2*k1**2*k2 - 132*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 + 66*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 352*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 264*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 44*D1*Pkdd2*f**2*fd*k1**2*k2**2 + 264*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 - 132*D1*Pkdd2*f*gd2*k1**2*k2**2*s + 528*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 - 528*D1*Pkdd2*fd*g2*k1**2*k2**2*s + 132*D1*Pkdd2*fd*g2*k1**2*k2**2 + 11*D1*bd1*(f**2*(k1**2*(Pk2*(38*r*(3*s - 2) + 720*s**2 - 265*s + 38) + k2*(Pkd2*(-42*r*s + 28*r - 234*s**2 + 85*s - 14) + 2*Pkdd2*k2*s*(9*s - 2))) + k2**2*(Pk2*(108*r**2 + 189*r*s - 88*r + 59*s - 22) + Pkd2*k2*(45*r*s - 26*r - 67*s + 26))) + 6*f*(k1**2*(4*Pk2*(r*(4*s - 1) + s*(-4*K*s + 2*K - 4*s + 1)) + k2*(Pkd2*(-4*r*s + r + s*(10*K*s - 5*K + 10*s - 4)) - Pkdd2*k2*s*(K + 1)*(2*s - 1))) + k2**2*(2*K*Pk2*r*(2*r - 1) - 2*Pk2*(2*r**2 - 4*r*s + s) + Pkd2*k2*(-4*r*s + r + s))) + 84*g2*(8*Pk2*k1**2*s*(s - 1) - 5*Pkd2*k1**2*k2*s*(s - 1) + k2**2*(-2*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(s - 1)))) + 2140*Dd*Pk2*f**3*k1**2*r*s - 480*Dd*Pk2*f**3*k1**2*r + 11264*Dd*Pk2*f**3*k1**2*s**2 - 6431*Dd*Pk2*f**3*k1**2*s + 890*Dd*Pk2*f**3*k1**2 + 1472*Dd*Pk2*f**3*k2**2*r**2 + 1100*Dd*Pk2*f**3*k2**2*r*s - 318*Dd*Pk2*f**3*k2**2*r + 1155*Dd*Pk2*f**3*k2**2*s - 370*Dd*Pk2*f**3*k2**2 + 8448*Dd*Pk2*f*g2*k1**2*s**2 - 6336*Dd*Pk2*f*g2*k1**2*s + 1056*Dd*Pk2*f*g2*k1**2 - 2112*Dd*Pk2*f*g2*k2**2*r**2 + 1584*Dd*Pk2*f*g2*k2**2*r - 264*Dd*Pk2*f*g2*k2**2 - 700*Dd*Pkd2*f**3*k1**2*k2*r*s + 230*Dd*Pkd2*f**3*k1**2*k2*r - 3872*Dd*Pkd2*f**3*k1**2*k2*s**2 + 2441*Dd*Pkd2*f**3*k1**2*k2*s - 382*Dd*Pkd2*f**3*k1**2*k2 + 1100*Dd*Pkd2*f**3*k2**3*r*s - 440*Dd*Pkd2*f**3*k2**3*r - 275*Dd*Pkd2*f**3*k2**3*s + 110*Dd*Pkd2*f**3*k2**3 - 5280*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 3960*Dd*Pkd2*f*g2*k1**2*k2*s - 660*Dd*Pkd2*f*g2*k1**2*k2 + 352*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 264*Dd*Pkdd2*f**3*k1**2*k2**2*s + 44*Dd*Pkdd2*f**3*k1**2*k2**2 + 1056*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 - 792*Dd*Pkdd2*f*g2*k1**2*k2**2*s + 132*Dd*Pkdd2*f*g2*k1**2*k2**2 - 66*b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(7*D1*bd1*s*(s - 1) + D1*fd*(1 - 2*s)**2 + Dd*f*(8*s**2 - 6*s + 1))))/(1155*d**2*k1**2*k2**2) - D1**3*Pk1*st**2*(-21*b1**3*(-D1*fd*s*(k1**2*(-5*Pk2*(r - 8*s) + k2*(5*Pkd2*r - 28*Pkd2*s + 8*Pkdd2*k2*s)) + 3*k2**2*r*(5*Pk2 + Pkd2*k2)) + Dd*f*(k1**2*(5*Pk2*(4*r*(s - 1) + s*(11 - 32*s)) + k2*(Pkd2*r*(10 - 20*s) + Pkd2*s*(112*s - 33) + 8*Pkdd2*k2*s*(1 - 4*s))) - k2**2*(15*Pk2*s*(4*r - 1) + Pkd2*k2*(12*r*s - 4*r + s)))) + 3*b1**2*(7*D1*bd1*f*(k1**2*(5*Pk2*(r*(4 - 3*s) + s*(24*s - 11)) + k2*(5*Pkd2*r*(3*s - 2) + 3*Pkd2*s*(11 - 28*s) + 8*Pkdd2*k2*s*(3*s - 1))) + k2**2*(15*Pk2*s*(3*r - 1) + Pkd2*k2*(9*r*s - 4*r + s))) + D1*fd*(k1**2*(Pk2*f*(2*r*(165*s - 7) + 1232*s**2 - 611*s + 140) + 28*Pk2*(11*K*(s - 1)**2 - 13*r*s + 15*r + 9*s**2 - 20*s + 9) + Pkd2*k2*(-14*K*(14*s**2 - 30*s + 15) + f*(10*r*(15*s - 14) - 200*s**2 - 167*s + 42) + 112*r*s - 140*r - 196*s**2 + 448*s - 210) + 2*Pkdd2*k2**2*(f*(44*s**2 - 21*s + 7) + (7*K + 7)*(4*s**2 - 10*s + 5))) + k2**2*(Pk2*f*(352*r**2 + 2*r*(189*s - 79) - 63*s + 36) - 28*Pk2*(K*(4*r**2 + 2*r - 1) - 4*r**2 + 3*r*s - 5*r + 1) + 2*Pkd2*k2*r*(3*f*(39*s - 14) + 56*s - 70) + Pkd2*k2*s*(23*f + 28))) + Dd*f*k1**2*(Pk2*f*(r*(660*s + 278) + 2464*s**2 - 1131*s + 18) + 28*Pk2*(11*K*(4*s**2 - 5*s + 1) + r*(29 - 52*s) + 36*s**2 - 45*s + 5) + Pkd2*k2*(-14*K*(56*s**2 - 74*s + 15) + f*(4*r*(75*s - 82) - 400*s**2 - 143*s + 124) + 448*r*s - 336*r - 784*s**2 + 1036*s - 154) + 2*Pkdd2*k2**2*(4*s - 1)*(f*(22*s - 7) + (7*K + 7)*(4*s - 5))) + Dd*f*k2**2*(28*K*(-16*Pk2*r**2 + Pk2) + 28*Pk2*(16*r**2 - 12*r*s - s) + 56*Pkd2*k2*(8*r*s - 6*r + 1) + f*(Pk2*(704*r**2 + r*(756*s - 404) + 63*s - 6) + Pkd2*k2*(6*r*(78*s - 29) - 95*s + 38)))) + b1*(648*D1*K*Pk2*f*fd*k1**2*s**2 - 732*D1*K*Pk2*f*fd*k1**2*s + 204*D1*K*Pk2*f*fd*k1**2 + 96*D1*K*Pk2*f*fd*k2**2*r**2 - 264*D1*K*Pk2*f*fd*k2**2*r + 108*D1*K*Pk2*f*fd*k2**2 - 420*D1*K*Pkd2*f*fd*k1**2*k2*s**2 + 462*D1*K*Pkd2*f*fd*k1**2*k2*s - 126*D1*K*Pkd2*f*fd*k1**2*k2 + 84*D1*K*Pkdd2*f*fd*k1**2*k2**2*s**2 - 126*D1*K*Pkdd2*f*fd*k1**2*k2**2*s + 42*D1*K*Pkdd2*f*fd*k1**2*k2**2 + 840*D1*Pk2*bd2*f*k1**2*s**2 - 840*D1*Pk2*bd2*f*k1**2*s + 1071*D1*Pk2*f**2*fd*k1**2*r*s + 216*D1*Pk2*f**2*fd*k1**2*r + 1296*D1*Pk2*f**2*fd*k1**2*s**2 - 258*D1*Pk2*f**2*fd*k1**2*s - 54*D1*Pk2*f**2*fd*k1**2 + 648*D1*Pk2*f**2*fd*k2**2*r**2 + 486*D1*Pk2*f**2*fd*k2**2*r*s - 324*D1*Pk2*f**2*fd*k2**2*r + 378*D1*Pk2*f**2*fd*k2**2*s - 54*D1*Pk2*f**2*fd*k2**2 - 384*D1*Pk2*f*fd*k1**2*r*s + 444*D1*Pk2*f*fd*k1**2*r + 696*D1*Pk2*f*fd*k1**2*s**2 - 504*D1*Pk2*f*fd*k1**2*s - 48*D1*Pk2*f*fd*k1**2 + 432*D1*Pk2*f*fd*k2**2*r**2 - 96*D1*Pk2*f*fd*k2**2*r*s - 300*D1*Pk2*f*fd*k2**2*r + 132*D1*Pk2*f*fd*k2**2*s - 1848*D1*Pk2*f*gd2*k1**2*s**2 + 1848*D1*Pk2*f*gd2*k1**2*s + 672*D1*Pk2*f*gd2*k2**2*r**2 + 168*D1*Pk2*f*gd2*k2**2*r - 1848*D1*Pk2*fd*g2*k1**2*s**2 + 3696*D1*Pk2*fd*g2*k1**2*s - 1848*D1*Pk2*fd*g2*k1**2 + 672*D1*Pk2*fd*g2*k2**2*r**2 + 336*D1*Pk2*fd*g2*k2**2*r - 168*D1*Pk2*fd*g2*k2**2 - 588*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 630*D1*Pkd2*bd2*f*k1**2*k2*s + 585*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 540*D1*Pkd2*f**2*fd*k1**2*k2*r + 162*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 834*D1*Pkd2*f**2*fd*k1**2*k2*s + 252*D1*Pkd2*f**2*fd*k1**2*k2 + 486*D1*Pkd2*f**2*fd*k2**3*r*s - 162*D1*Pkd2*f**2*fd*k2**3*r - 162*D1*Pkd2*f**2*fd*k2**3*s + 54*D1*Pkd2*f**2*fd*k2**3 + 168*D1*Pkd2*f*fd*k1**2*k2*r*s - 126*D1*Pkd2*f*fd*k1**2*k2*r - 420*D1*Pkd2*f*fd*k1**2*k2*s**2 + 420*D1*Pkd2*f*fd*k1**2*k2*s - 84*D1*Pkd2*f*fd*k1**2*k2 + 168*D1*Pkd2*f*fd*k2**3*r*s - 126*D1*Pkd2*f*fd*k2**3*r - 42*D1*Pkd2*f*fd*k2**3*s + 42*D1*Pkd2*f*fd*k2**3 + 1176*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 1260*D1*Pkd2*f*gd2*k1**2*k2*s + 1176*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 2520*D1*Pkd2*fd*g2*k1**2*k2*s + 1260*D1*Pkd2*fd*g2*k1**2*k2 + 168*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 - 210*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 162*D1*Pkdd2*f**2*fd*k1**2*k2**2*s**2 - 72*D1*Pkdd2*f**2*fd*k1**2*k2**2*s + 18*D1*Pkdd2*f**2*fd*k1**2*k2**2 + 84*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 - 126*D1*Pkdd2*f*fd*k1**2*k2**2*s + 42*D1*Pkdd2*f*fd*k1**2*k2**2 - 336*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 + 420*D1*Pkdd2*f*gd2*k1**2*k2**2*s - 336*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 + 840*D1*Pkdd2*fd*g2*k1**2*k2**2*s - 420*D1*Pkdd2*fd*g2*k1**2*k2**2 + 6*D1*bd1*f*(k1**2*(Pk2*f*(r*(165*s + 146) + 616*s**2 - 260*s - 61) + 14*Pk2*(r*(9 - 26*s) + s**2*(22*K + 18) - s*(22*K + 15) - 4) + Pkd2*k2*(f*(r*(75*s - 94) - 100*s**2 + 12*s + 41) + 7*r*(16*s - 9) - 7*s**2*(28*K + 28) + 7*s*(29*K + 26) + 28) + Pkdd2*k2**2*s*(f*(44*s - 29) + (7*K + 7)*(8*s - 9))) + k2**2*(Pk2*f*(176*r**2 + 3*r*(63*s - 41) + 63*s - 21) - 14*Pk2*(r**2*(8*K - 8) + r*(-3*K + 6*s + 5) + s - 1) + Pkd2*f*k2*(9*r*(13*s - 5) - 59*s + 19) + 7*Pkd2*k2*(r*(16*s - 9) - 3*s + 4))) + 1296*Dd*K*Pk2*f**2*k1**2*s**2 - 1140*Dd*K*Pk2*f**2*k1**2*s + 204*Dd*K*Pk2*f**2*k1**2 + 192*Dd*K*Pk2*f**2*k2**2*r**2 - 480*Dd*K*Pk2*f**2*k2**2*r + 108*Dd*K*Pk2*f**2*k2**2 - 840*Dd*K*Pkd2*f**2*k1**2*k2*s**2 + 714*Dd*K*Pkd2*f**2*k1**2*k2*s - 126*Dd*K*Pkd2*f**2*k1**2*k2 + 168*Dd*K*Pkdd2*f**2*k1**2*k2**2*s**2 - 210*Dd*K*Pkdd2*f**2*k1**2*k2**2*s + 42*Dd*K*Pkdd2*f**2*k1**2*k2**2 + 1428*Dd*Pk2*f**3*k1**2*r*s + 528*Dd*Pk2*f**3*k1**2*r + 1728*Dd*Pk2*f**3*k1**2*s**2 - 565*Dd*Pk2*f**3*k1**2*s - 188*Dd*Pk2*f**3*k1**2 + 864*Dd*Pk2*f**3*k2**2*r**2 + 648*Dd*Pk2*f**3*k2**2*r*s - 468*Dd*Pk2*f**3*k2**2*r + 450*Dd*Pk2*f**3*k2**2*s - 90*Dd*Pk2*f**3*k2**2 - 768*Dd*Pk2*f**2*k1**2*r*s + 708*Dd*Pk2*f**2*k1**2*r + 1392*Dd*Pk2*f**2*k1**2*s**2 - 672*Dd*Pk2*f**2*k1**2*s - 48*Dd*Pk2*f**2*k1**2 + 864*Dd*Pk2*f**2*k2**2*r**2 - 192*Dd*Pk2*f**2*k2**2*r*s - 492*Dd*Pk2*f**2*k2**2*r + 324*Dd*Pk2*f**2*k2**2*s - 7392*Dd*Pk2*f*g2*k1**2*s**2 + 9240*Dd*Pk2*f*g2*k1**2*s - 1848*Dd*Pk2*f*g2*k1**2 + 2688*Dd*Pk2*f*g2*k2**2*r**2 - 168*Dd*Pk2*f*g2*k2**2 + 780*Dd*Pkd2*f**3*k1**2*k2*r*s - 750*Dd*Pkd2*f**3*k1**2*k2*r + 216*Dd*Pkd2*f**3*k1**2*k2*s**2 - 883*Dd*Pkd2*f**3*k1**2*k2*s + 346*Dd*Pkd2*f**3*k1**2*k2 + 648*Dd*Pkd2*f**3*k2**3*r*s - 216*Dd*Pkd2*f**3*k2**3*r - 162*Dd*Pkd2*f**3*k2**3*s + 54*Dd*Pkd2*f**3*k2**3 + 336*Dd*Pkd2*f**2*k1**2*k2*r*s - 210*Dd*Pkd2*f**2*k1**2*k2*r - 840*Dd*Pkd2*f**2*k1**2*k2*s**2 + 672*Dd*Pkd2*f**2*k1**2*k2*s - 84*Dd*Pkd2*f**2*k1**2*k2 + 336*Dd*Pkd2*f**2*k2**3*r*s - 210*Dd*Pkd2*f**2*k2**3*r - 42*Dd*Pkd2*f**2*k2**3*s + 42*Dd*Pkd2*f**2*k2**3 + 4704*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 6216*Dd*Pkd2*f*g2*k1**2*k2*s + 1260*Dd*Pkd2*f*g2*k1**2*k2 + 216*Dd*Pkdd2*f**3*k1**2*k2**2*s**2 - 126*Dd*Pkdd2*f**3*k1**2*k2**2*s + 18*Dd*Pkdd2*f**3*k1**2*k2**2 + 168*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 - 210*Dd*Pkdd2*f**2*k1**2*k2**2*s + 42*Dd*Pkdd2*f**2*k1**2*k2**2 - 1344*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 + 2016*Dd*Pkdd2*f*g2*k1**2*k2**2*s - 420*Dd*Pkdd2*f*g2*k1**2*k2**2 + 42*b2*k1**2*(D1*fd*(20*Pk2*(s - 1)**2 + k2*(Pkd2*(-14*s**2 + 30*s - 15) + Pkdd2*k2*(4*s**2 - 10*s + 5))) + Dd*f*(4*s - 1)*(20*Pk2*(s - 1) + k2*(Pkd2*(15 - 14*s) + Pkdd2*k2*(4*s - 5))))) + f*(336*D1*Pk2*bd2*f*k1**2*s**2 - 168*D1*Pk2*bd2*f*k1**2*s + 132*D1*Pk2*bd2*f*k2**2*r**2 - 108*D1*Pk2*bd2*f*k2**2*r + 180*D1*Pk2*f**2*fd*k1**2*r*s + 130*D1*Pk2*f**2*fd*k1**2*r - 576*D1*Pk2*f**2*fd*k1**2*s**2 + 489*D1*Pk2*f**2*fd*k1**2*s - 130*D1*Pk2*f**2*fd*k1**2 - 648*D1*Pk2*f*gd2*k1**2*s**2 + 408*D1*Pk2*f*gd2*k1**2*s - 96*D1*Pk2*f*gd2*k2**2*r**2 + 216*D1*Pk2*f*gd2*k2**2*r - 1296*D1*Pk2*fd*g2*k1**2*s**2 + 1464*D1*Pk2*fd*g2*k1**2*s - 408*D1*Pk2*fd*g2*k1**2 - 192*D1*Pk2*fd*g2*k2**2*r**2 + 528*D1*Pk2*fd*g2*k2**2*r - 216*D1*Pk2*fd*g2*k2**2 - 210*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 126*D1*Pkd2*bd2*f*k1**2*k2*s + 300*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 200*D1*Pkd2*f**2*fd*k1**2*k2*r + 576*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 507*D1*Pkd2*f**2*fd*k1**2*k2*s + 122*D1*Pkd2*f**2*fd*k1**2*k2 + 420*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 252*D1*Pkd2*f*gd2*k1**2*k2*s + 840*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 924*D1*Pkd2*fd*g2*k1**2*k2*s + 252*D1*Pkd2*fd*g2*k1**2*k2 + 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 - 42*D1*Pkdd2*bd2*f*k1**2*k2**2*s - 84*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 + 84*D1*Pkdd2*f*gd2*k1**2*k2**2*s - 168*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 + 252*D1*Pkdd2*fd*g2*k1**2*k2**2*s - 84*D1*Pkdd2*fd*g2*k1**2*k2**2 + D1*bd1*(f**2*(k1**2*(Pk2*(r*(357*s + 312) + 432*s**2 - 307*s - 134) + k2*(Pkd2*(195*r*s - 210*r + 54*s**2 - 49*s + 94) + 54*Pkdd2*k2*s*(s - 1))) + 18*k2**2*(Pk2*(12*r**2 + 9*r*s - 8*r + 4*s - 2) + 3*Pkd2*k2*r*(3*s - 1))) - 6*f*(k1**2*(2*Pk2*(r*(16*s - 11) + s*(-27*K*s + 17*K - 29*s + 7)) - 7*k2*(Pkd2*r*(2*s - 1) - Pkd2*s*(K + 1)*(5*s - 3) + Pkdd2*k2*s*(K + 1)*(s - 1))) + k2**2*(-2*Pk2*(r**2*(4*K + 18) - r*(9*K + 4*s + 8) + 8*s) + 7*Pkd2*k2*r*(1 - 2*s))) + 168*g2*(-11*Pk2*k1**2*s*(s - 1) + 7*Pkd2*k1**2*k2*s*(s - 1) + 2*k2**2*(2*Pk2*r*(r - 1) - Pkdd2*k1**2*s*(s - 1)))) + 180*Dd*Pk2*f**3*k1**2*r*s + 130*Dd*Pk2*f**3*k1**2*r - 576*Dd*Pk2*f**3*k1**2*s**2 + 489*Dd*Pk2*f**3*k1**2*s - 130*Dd*Pk2*f**3*k1**2 - 2592*Dd*Pk2*f*g2*k1**2*s**2 + 2280*Dd*Pk2*f*g2*k1**2*s - 408*Dd*Pk2*f*g2*k1**2 - 384*Dd*Pk2*f*g2*k2**2*r**2 + 960*Dd*Pk2*f*g2*k2**2*r - 216*Dd*Pk2*f*g2*k2**2 + 300*Dd*Pkd2*f**3*k1**2*k2*r*s - 200*Dd*Pkd2*f**3*k1**2*k2*r + 576*Dd*Pkd2*f**3*k1**2*k2*s**2 - 507*Dd*Pkd2*f**3*k1**2*k2*s + 122*Dd*Pkd2*f**3*k1**2*k2 + 1680*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 1428*Dd*Pkd2*f*g2*k1**2*k2*s + 252*Dd*Pkd2*f*g2*k1**2*k2 - 336*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 + 420*Dd*Pkdd2*f*g2*k1**2*k2**2*s - 84*Dd*Pkdd2*f*g2*k1**2*k2**2 + 6*b2*(14*D1*bd1*k1**2*s*(10*Pk2 + k2*(-7*Pkd2 + 2*Pkdd2*k2))*(s - 1) + D1*fd*(2*Pk2*k2**2*(22*r**2 - 29*r + 9) + 7*k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1)))) + 2*Dd*Pk2*f*k2**2*(44*r**2 - 47*r + 9) + 7*Dd*f*k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))))))/(315*d**2*k1**2*k2**2) - D1**3*Pk1*(7*b1**3*(D1*fd*(5*Pk2*k1**2*s*(5*r + 4*s) + Pk2*k2**2*r*(12*r + 5*s) + 5*Pkd2*k1**2*k2*s*(3*r + 4*s) + 5*Pkd2*k2**3*r*s) + Dd*f*(5*k1**2*(Pk2*r*(20*s - 6) + Pk2*s*(16*s - 3) + Pkd2*k2*s*(12*r + 16*s - 7)) + k2**2*(Pk2*(48*r**2 + 20*r*s - 22*r + 5*s) + 5*Pkd2*k2*s*(4*r - 1)))) + b1**2*(7*D1*bd1*f*(5*k1**2*(3*Pk2*(r*(5*s - 2) + s*(4*s - 1)) + Pkd2*k2*s*(9*r + 12*s - 7)) + k2**2*(Pk2*(36*r**2 + 15*r*s - 22*r + 5*s) + 5*Pkd2*k2*s*(3*r - 1))) + D1*fd*(7*k1**2*(Pk2*f*(32*s**2 + s*(60*r - 33) + 4) + 4*Pk2*(K*(3*s**2 - 10*s + 5) + r*(11*s - 5) + 7*s**2 - 16*s + 5) + Pkd2*f*k2*(64*s**2 + s*(36*r - 33) + 8) + Pkd2*k2*(20*K + 20)*(s - 1)**2) + k2**2*(Pk2*f*(144*r**2 + 6*r*(7*s - 24) - 35*s + 36) + 28*Pk2*(3*K*(r - 1)**2 + 3*r**2 + r*(7*s - 11) - 2*s + 3) + 21*Pkd2*f*k2*s*(2*r - 1))) + 14*Dd*f*k1**2*(Pk2*f*(6*r*(10*s - 3) + 32*s**2 - 37*s + 8) + 2*Pk2*(K*(12*s**2 - 23*s + 5) + r*(44*s - 8) + 28*s**2 - 42*s + 8) + Pkd2*f*k2*(64*s**2 + s*(36*r - 41) + 4) + Pkd2*k2*(10*K + 10)*(4*s**2 - 5*s + 1)) + Dd*f*k2**2*(Pk2*f*(288*r**2 + 6*r*(14*s - 43) - 91*s + 64) + 28*Pk2*(3*K*(4*r**2 - 5*r + 1) + 12*r**2 + 7*r*(4*s - 3) - 5*s + 4) + 21*Pkd2*f*k2*s*(4*r - 1))) + b1*(56*D1*K*Pk2*f*fd*k1**2*s**2 - 84*D1*K*Pk2*f*fd*k1**2*s + 28*D1*K*Pk2*f*fd*k1**2 + 112*D1*K*Pkd2*f*fd*k1**2*k2*s**2 - 168*D1*K*Pkd2*f*fd*k1**2*k2*s + 56*D1*K*Pkd2*f*fd*k1**2*k2 + 140*D1*Pk2*bd2*f*k1**2*s**2 - 140*D1*Pk2*bd2*f*k1**2*s + 84*D1*Pk2*bd2*f*k2**2*r**2 - 84*D1*Pk2*bd2*f*k2**2*r + 225*D1*Pk2*f**2*fd*k1**2*r*s + 108*D1*Pk2*f**2*fd*k1**2*s**2 - 141*D1*Pk2*f**2*fd*k1**2*s + 12*D1*Pk2*f**2*fd*k1**2 + 112*D1*Pk2*f*fd*k1**2*r*s - 56*D1*Pk2*f*fd*k1**2*r + 56*D1*Pk2*f*fd*k1**2*s**2 - 84*D1*Pk2*f*fd*k1**2*s + 28*D1*Pk2*f*fd*k1**2 + 112*D1*Pk2*f*fd*k2**2*r*s - 56*D1*Pk2*f*fd*k2**2*r - 168*D1*Pk2*f*gd2*k1**2*s**2 + 280*D1*Pk2*f*gd2*k1**2*s - 168*D1*Pk2*f*gd2*k2**2*r**2 + 168*D1*Pk2*f*gd2*k2**2*r - 168*D1*Pk2*fd*g2*k1**2*s**2 + 560*D1*Pk2*fd*g2*k1**2*s - 280*D1*Pk2*fd*g2*k1**2 - 168*D1*Pk2*fd*g2*k2**2*r**2 + 336*D1*Pk2*fd*g2*k2**2*r - 168*D1*Pk2*fd*g2*k2**2 + 140*D1*Pkd2*bd2*f*k1**2*k2*s**2 - 140*D1*Pkd2*bd2*f*k1**2*k2*s + 135*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 324*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 189*D1*Pkd2*f**2*fd*k1**2*k2*s + 36*D1*Pkd2*f**2*fd*k1**2*k2 + 112*D1*Pkd2*f*fd*k1**2*k2*s**2 - 168*D1*Pkd2*f*fd*k1**2*k2*s + 56*D1*Pkd2*f*fd*k1**2*k2 - 280*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 280*D1*Pkd2*f*gd2*k1**2*k2*s - 280*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 560*D1*Pkd2*fd*g2*k1**2*k2*s - 280*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*f*(7*k1**2*(Pk2*(f*(12*r*(5*s - 3) + 32*s**2 - 41*s + 12) + 4*r*(22*s - 3) + 4*s**2*(6*K + 14) - 4*s*(8*K + 18) + 12) + Pkd2*k2*s*(f*(36*r + 64*s - 49) + (40*K + 40)*(s - 1))) + 2*k2**2*(Pk2*f*(72*r**2 + 3*r*(7*s - 19) - 28*s + 14) + 14*Pk2*(r**2*(6*K + 6) + r*(-6*K + 14*s - 7) - 2*s + 1) + 21*Pkd2*f*k2*r*s)) + 112*Dd*K*Pk2*f**2*k1**2*s**2 - 140*Dd*K*Pk2*f**2*k1**2*s + 28*Dd*K*Pk2*f**2*k1**2 + 224*Dd*K*Pkd2*f**2*k1**2*k2*s**2 - 280*Dd*K*Pkd2*f**2*k1**2*k2*s + 56*Dd*K*Pkd2*f**2*k1**2*k2 + 300*Dd*Pk2*f**3*k1**2*r*s - 90*Dd*Pk2*f**3*k1**2*r + 144*Dd*Pk2*f**3*k1**2*s**2 - 213*Dd*Pk2*f**3*k1**2*s + 48*Dd*Pk2*f**3*k1**2 + 224*Dd*Pk2*f**2*k1**2*r*s - 56*Dd*Pk2*f**2*k1**2*r + 112*Dd*Pk2*f**2*k1**2*s**2 - 140*Dd*Pk2*f**2*k1**2*s + 28*Dd*Pk2*f**2*k1**2 + 224*Dd*Pk2*f**2*k2**2*r*s - 56*Dd*Pk2*f**2*k2**2*r - 672*Dd*Pk2*f*g2*k1**2*s**2 + 1288*Dd*Pk2*f*g2*k1**2*s - 280*Dd*Pk2*f*g2*k1**2 - 672*Dd*Pk2*f*g2*k2**2*r**2 + 840*Dd*Pk2*f*g2*k2**2*r - 168*Dd*Pk2*f*g2*k2**2 + 180*Dd*Pkd2*f**3*k1**2*k2*r*s + 432*Dd*Pkd2*f**3*k1**2*k2*s**2 - 297*Dd*Pkd2*f**3*k1**2*k2*s + 36*Dd*Pkd2*f**3*k1**2*k2 + 224*Dd*Pkd2*f**2*k1**2*k2*s**2 - 280*Dd*Pkd2*f**2*k1**2*k2*s + 56*Dd*Pkd2*f**2*k1**2*k2 - 1120*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 1400*Dd*Pkd2*f*g2*k1**2*k2*s - 280*Dd*Pkd2*f*g2*k1**2*k2 + 28*b2*(D1*fd*(3*Pk2*k2**2*(r - 1)**2 + 5*k1**2*(Pk2 + Pkd2*k2)*(s - 1)**2) + Dd*f*(3*Pk2*k2**2*(4*r**2 - 5*r + 1) + 5*k1**2*(Pk2 + Pkd2*k2)*(4*s**2 - 5*s + 1)))) + f*(D1*bd1*(3*f**2*k1**2*(Pk2*(5*r*(5*s - 6) + 12*(s - 1)**2) + 3*Pkd2*k2*s*(5*r + 12*s - 12)) + 28*f*s*(2*Pk2*k2**2*r + k1**2*(Pk2*(K*(s - 1) + 2*r + s - 1) + Pkd2*k2*(2*K + 2)*(s - 1))) - 56*g2*(3*Pk2*k1**2*s*(s - 1) + 3*Pk2*k2**2*r*(r - 1) + 5*Pkd2*k1**2*k2*s*(s - 1))) + 28*b2*(D1*bd1*(5*Pk2*k1**2*s*(s - 1) + 3*Pk2*k2**2*r*(r - 1) + 5*Pkd2*k1**2*k2*s*(s - 1)) + D1*fd*k1**2*(Pk2 + 2*Pkd2*k2)*(2*s**2 - 3*s + 1) + Dd*f*k1**2*(Pk2 + 2*Pkd2*k2)*(4*s**2 - 5*s + 1)) - 28*k1**2*(Pk2 + 2*Pkd2*k2)*(s - 1)*(-D1*f*s*(bd2 - 2*gd2) + 2*D1*fd*g2*(2*s - 1) + 2*Dd*f*g2*(4*s - 1))))/(105*d**2*k1**2*k2**2) + 2*D1**3*Pk1*st**4*(3*D1*bd1*f*(-7*b1*k1**2*k2**2*(2*C*Pkdd2*k2**2*s*(1 - 2*s) + Pk2*r*(8*s - 2) - 2*Pk2*s + Pkd2*k2*(C*s*(4*s - 2) - 4*r*s + r + s)) + 7*b1*k2**4*(Pk2*r*(4 - 4*C)*(2*r - 1) + Pkd2*k2*(r*(4*s - 1) - s)) + f*k1**4*(4*Pk2*(-4*r*s + r + s**2*(8*C - 1) + s*(6 - 4*C) - 1) + k2*(2*C*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-20*C*s**2 + 10*C*s + r*(4*s - 1) + s**2 - 6*s + 1))) + f*k1**2*k2**2*(-2*Pk2*(C*(4*r**2 + 37*r*s - 50*r + 60*s**2 - 87*s + 46) + 3*r**2 - 36*r*s + 5*r - 3*s**2 + 3*s - 9) + k2*(2*C*Pkdd2*k2*s*(5 - 12*s) + Pkd2*(2*C*(7*r*(s - 2) + 40*s**2 - 40*s + 14) - 20*r*s + 4*r + s**2 + 7*s - 5))) + f*k2**4*(Pk2*(r**2*(48*C - 64) + r*(-52*C + 20*s + 70) + 4*s - 2) + Pkd2*k2*(r*(5 - 24*s) + 13*s - 6))) + 21*b1**2*k2**2*(2*D1*fd*(-2*Pk2*k1**2*r*s + Pkd2*k1**2*k2*s*(-C*s + r) + Pkd2*k2**3*r*s + k2**2*(C*Pkdd2*k1**2*s**2 + Pk2*r**2*(2 - 2*C))) - Dd*f*(k1**2*(2*C*Pkdd2*k2**2*s*(1 - 4*s) + 2*Pk2*r*(8*s - 1) - 2*Pk2*s + Pkd2*k2*(C*s*(8*s - 2) - 8*r*s + r + s)) + k2**2*(Pk2*r*(4*C - 4)*(4*r - 1) + Pkd2*k2*(-8*r*s + r + s)))) + 3*b1*f*(D1*fd*(k1**4*(2*s - 1)*(-4*Pk2*(C*(4 - 8*s) + 4*r + s - 4) + k2*(2*C*Pkdd2*k2*(2*s - 1) + Pkd2*(-20*C*s + 10*C + 4*r + s - 4))) + k1**2*k2**2*(-2*Pk2*(2*C*(4*r**2 + r*(37*s - 36) + 15*(1 - 2*s)**2) + 6*r**2 - 72*r*s + 54*r - 6*s**2 - 5*s + 2) + k2*(-2*C*Pkdd2*k2*(24*s**2 - 28*s + 7) + Pkd2*(2*C*(14*r*(s - 1) + 80*s**2 - 84*s + 21) - 40*r*s + 24*r + 2*s**2 - 13*s + 4))) + 4*k2**4*(Pk2*(C*(24*r**2 + 4*r - 1) - 32*r**2 + 10*r*s - 9*r + 1) - Pkd2*k2*(r*(12*s - 7) + s))) + Dd*f*(k1**4*(4*Pk2*(4*C*(8*s**2 - 6*s + 1) - 16*r*s + 6*r - 4*s**2 + 19*s - 5) + k2*(2*C*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-10*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r + 4*s**2 - 19*s + 5))) - k1**2*k2**2*(2*Pk2*(C*(16*r**2 + 4*r*(37*s - 42) + 240*s**2 - 237*s + 76) + 12*r**2 - 144*r*s + 69*r - 12*s**2 - 5*s - 7) + k2*(2*C*Pkdd2*k2*(48*s**2 - 40*s + 7) + Pkd2*(C*(-56*r*s + 84*r - 320*s**2 + 290*s - 70) + 80*r*s - 34*r - 4*s**2 + 11*s + 1))) + 2*k2**4*(Pk2*(2*C*(48*r**2 - 8*r - 1) - 128*r**2 + 8*r*(5*s + 2) + 2*s + 1) + Pkd2*k2*(r*(20 - 48*s) + 4*s - 3)))) + f**2*(D1*fd*(k1**4*(3*s - 1)*(4*Pk2*(12*C*s - 4*C - 6*r - 3*s + 6) + k2*(2*C*Pkdd2*k2*(3*s - 1) + Pkd2*(-30*C*s + 10*C + 6*r + 3*s - 6))) + k1**2*k2**2*(-2*C*Pk2*(18*r**2 + 75*r*(3*s - 2) + 144*s**2 - 165*s + 62) - 6*C*Pkdd2*k2**2*(6*s**2 - 5*s + 1) + 18*Pk2*(r**2 + r*(6*s - 7) - s**2 - s + 2) + Pkd2*k2*(2*C*(r*(63*s - 30) + 90*s**2 - 78*s + 19) + r*(9 - 18*s) + 9*s**2 - 15*s + 3)) - k2**4*(4*Pk2*(C*(9*r**2 - 18*r + 5) + 27*r**2 - 9*r*s + 3*r + 9*s - 6) + 3*Pkd2*k2*(r*(12*s - 5) - 2*s + 1))) + Dd*f*(k1**4*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r - 12*s**2 + 26*s - 6) + k2*(2*C*Pkdd2*k2*(12*s**2 - 7*s + 1) + Pkd2*(-10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 12*s**2 - 26*s + 6))) + k1**2*k2**2*(-2*C*Pk2*(24*r**2 + r*(300*s - 202) + 192*s**2 - 175*s + 62) + 6*Pk2*(4*r**2 + r*(24*s - 25) - 4*s**2 - 5*s + 6) + k2*(-6*C*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(2*C*(84*r*s - 44*r + 120*s**2 - 83*s + 19) - 24*r*s + 11*r + 12*s**2 - 20*s + 3))) - k2**4*(2*Pk2*(2*C*(12*r**2 - 23*r + 5) + 72*r**2 - 24*r*s + 11*r + 25*s - 12) + 3*Pkd2*k2*(2*r*(8*s - 3) - 2*s + 1)))))/(105*d**2*k1**2*k2**2*k3**2) - 2*D1**3*Pk1*st**2*(3*D1*bd1*f*(7*b1*(k1**4*(-2*Pk2*(-4*r*s + r + 2*s**2) + k2*(2*C*Pkdd2*k2*s*(1 - 2*s) + Pkd2*(-4*r*s + r + 2*s*(2*C*s - C + s)))) + k1**2*k2**2*(2*Pk2*(r**2*(4*C + 6) + r*(26*C*s - 6*C - 6*s + 6) + s*(4*C*s - 11*C - 4*s - 4)) + k2*(10*C*Pkdd2*k2*s*(2*s - 1) + 4*Pkd2*r*(5*C*(s - 1) + 4*s - 1) + Pkd2*s*(s*(20*C + 2) - 5))) + k2**4*(Pk2*(r**2*(56 - 40*C) + r*(20*C + 28*s - 30) - 12*s) + 5*Pkd2*k2*(r*(4*s - 1) - s))) + f*(k1**4*(-2*Pk2*(2*r*(s - 4) - s**2*(54*C + 5) + s*(34*C - 28) + 11) + k2*(2*C*Pkdd2*k2*s*(s - 1) + Pkd2*(r*(2*s - 1) + s**2*(18 - 58*C) + s*(30*C - 15) + 4))) + k1**2*k2**2*(2*Pk2*(C*(68*r**2 + 174*r*s - 44*r + 250*s**2 - 73*s - 30) + 26*r**2 + 74*r*s + 9*r + 23*s**2 + 22*s - 20) + k2*(14*C*Pkdd2*k2*s*(s - 1) + Pkd2*(2*C*(90*r*s - 94*r + 77*s**2 - 152*s + 82) + 16*r*s - 8*r + 18*s**2 - 15*s + 4))) + k2**4*(4*Pk2*(r**2*(4*C + 10) + r*(-9*C + 26*s + 3) + 4*s - 4) + 7*Pkd2*k2*r*(2*s - 1)))) + 21*b1**2*(D1*fd*(k1**4*s*(Pk2*(4*r - 2*s) + k2*(-2*C*Pkdd2*k2*s + Pkd2*(2*C*s - 2*r + s))) + k1**2*k2**2*(Pk2*(r**2*(4*C + 6) + r*s*(26*C - 6) + s**2*(4*C - 4)) + k2*s*(10*C*Pkdd2*k2*s + Pkd2*(10*C*r + 10*C*s + 8*r + s))) + 2*k2**4*r*(Pk2*r*(14 - 10*C) + 7*Pk2*s + 5*Pkd2*k2*s)) + Dd*f*(k1**4*(-2*Pk2*(-8*r*s + r + 4*s**2) + k2*(2*C*Pkdd2*k2*s*(1 - 4*s) + Pkd2*(-8*r*s + r + 2*s*(4*C*s - C + 2*s)))) + k1**2*k2**2*(2*Pk2*(r**2*(8*C + 12) + 2*r*(26*C*s - 3*C - 6*s + 3) + s*(8*C*s - 11*C - 8*s - 4)) + k2*(10*C*Pkdd2*k2*s*(4*s - 1) + 4*Pkd2*r*(5*C*(2*s - 1) + 8*s - 1) + Pkd2*s*(s*(40*C + 4) - 5))) + k2**4*(-2*Pk2*(r**2*(40*C - 56) + r*(-10*C - 28*s + 15) + 6*s) + 5*Pkd2*k2*(r*(8*s - 1) - s)))) + 3*b1*f*(D1*fd*(k1**4*(4*Pk2*(C*(54*s**2 - 61*s + 17) - 2*r*s + 21*r + 5*s**2 + 27*s - 17) + k2*(2*C*Pkdd2*k2*(2*s**2 - 21*s + 7) + Pkd2*(-2*C*(58*s**2 - 77*s + 21) + 4*r*s - 21*r + 36*s**2 - 37*s + 14))) + k1**2*k2**2*(2*Pk2*(C*(136*r**2 + 12*r*(29*s - 9) + 500*s**2 - 573*s + 132) + 52*r**2 + 148*r*s - 43*r + 46*s**2 + 15*s - 22) + k2*(28*C*Pkdd2*k2*s**2 + Pkd2*(C*(40*r*(9*s - 7) + 308*s**2 - 306*s + 84) + 32*r*s - 21*r + 36*s**2 - 44*s + 14))) + k2**4*(4*Pk2*(C*(8*r**2 - 22*r + 9) + 20*r**2 + 52*r*s - 27*r + 2*s - 2) + 7*Pkd2*k2*s*(4*r - 1))) + Dd*f*(k1**4*(2*Pk2*(2*C*(108*s**2 - 95*s + 17) - 8*r*(s - 8) + 20*s**2 + 113*s - 45) + k2*(2*C*Pkdd2*k2*(4*s**2 - 29*s + 7) + Pkd2*(C*(-232*s**2 + 226*s - 42) + 8*r*s - 29*r + 72*s**2 - 63*s + 18))) + 2*k1**2*k2**2*(Pk2*(2*C*(136*r**2 + 58*r*(6*s - 1) + 500*s**2 - 392*s + 51) + 104*r**2 + 296*r*s - 22*r + 92*s**2 + 67*s - 42) + k2*(7*C*Pkdd2*k2*s*(4*s - 1) + Pkd2*(C*(8*r*(45*s - 38) + 308*s**2 - 359*s + 124) + 32*r*s - 18*r + 36*s**2 - 35*s + 9))) + k2**4*(4*Pk2*(C*(16*r**2 - 40*r + 9) + 40*r**2 + 2*r*(52*s - 11) + 10*s - 6) + 7*Pkd2*k2*(r*(8*s - 1) - s)))) + f**2*(D1*fd*(72*Pk2*k2**4*r*(3*s - 1) + k1**4*(2*Pk2*(C*(306*s**2 - 240*s + 46) - 45*r*s + 87*r + 18*s**2 + 138*s - 72) + 9*k2*(2*C*Pkdd2*k2*(3*s**2 - 4*s + 1) + Pkd2*(C*(-42*s**2 + 32*s - 6) + 6*r*s - 4*r + 9*s**2 - 10*s + 3))) + k1**2*k2**2*(2*Pk2*(C*(342*r**2 + 405*r*s - 318*r + 324*s**2 - 513*s + 158) + 135*r**2 + 261*r*s - 96*r + 81*s**2 + 39*s - 34) + 9*Pkd2*k2*(C*(90*r*s - 60*r + 48*s**2 - 70*s + 28) + 6*r*s - 4*r + 9*s**2 - 10*s + 3))) + Dd*f*(72*Pk2*k2**4*r*(4*s - 1) + k1**4*(2*Pk2*(C*(408*s**2 - 286*s + 46) - 60*r*s + 109*r + 24*s**2 + 188*s - 72) + 9*k2*(2*C*Pkdd2*k2*(4*s**2 - 5*s + 1) + Pkd2*(C*(-56*s**2 + 38*s - 6) + r*(8*s - 5) + 3*(1 - 2*s)**2))) + k1**2*k2**2*(2*Pk2*(C*(456*r**2 + r*(540*s - 314) + 432*s**2 - 675*s + 158) + 180*r**2 + 4*r*(87*s - 22) + 108*s**2 + 65*s - 34) + 9*Pkd2*k2*(2*C*(20*r*(3*s - 2) + 32*s**2 - 39*s + 14) + r*(8*s - 5) + 3*(1 - 2*s)**2)))))/(315*d**2*k1**2*k2**2*k3**2) + 2*D1**3*Pk1*(D1*bd1*f*(-7*b1*(10*Pk2*k2**4*r*(2*s - 1) + k1**4*(10*Pk2*r*(4*s - 1) + 4*Pk2*s*(C*(2 - 4*s) + 9*s - 7) + 5*Pkd2*k2*s*(2*s - 1)) + k1**2*k2**2*(2*Pk2*(r**2*(60*C + 10) + r*(70*C*s - 50*C + 42*s - 23) + s*(60*C*s - 45*C + 20*s - 13)) + 5*Pkd2*k2*s*(2*C*(6*r + 4*s - 5) + 2*s - 1))) + f*(-28*Pk2*k2**4*r*(s - 1) + k1**4*(-4*Pk2*r*(37*s - 15) + 10*Pk2*(s - 1)*(s*(2*C - 9) + 3) + Pkd2*k2*s*(-56*C - 21)*(s - 1)) - k1**2*k2**2*(2*Pk2*(C*(180*r**2 + 147*r*s - 174*r + 70*s**2 - 154*s + 84) + 21*r**2 + 106*r*s - 74*r + 42*s**2 - 51*s + 9) + 7*Pkd2*k2*s*(2*C*(9*r + 4*s - 4) + 3*s - 3)))) - 7*b1**2*(D1*fd*(10*Pk2*k2**4*r*s + k1**4*s*(20*Pk2*r + Pk2*s*(18 - 8*C) + 5*Pkd2*k2*s) + k1**2*k2**2*(2*Pk2*(r**2*(30*C + 5) + r*s*(35*C + 21) + s**2*(30*C + 10)) + 5*Pkd2*k2*s*(6*C*r + 4*C*s + s))) + Dd*f*(10*Pk2*k2**4*r*(4*s - 1) + k1**4*(10*Pk2*r*(8*s - 1) + 4*Pk2*s*(C*(2 - 8*s) + 18*s - 7) + 5*Pkd2*k2*s*(4*s - 1)) + k1**2*k2**2*(2*Pk2*(r**2*(120*C + 20) + r*(10*C*(14*s - 5) + 84*s - 23) + s*(15*C*(8*s - 3) + 40*s - 13)) + 5*Pkd2*k2*s*(2*C*(12*r + 8*s - 5) + 4*s - 1)))) + b1*f*(-2*D1*fd*(C*(k1**4*(-2*Pk2*(10*s**2 + 21*s - 7) + 28*Pkd2*k2*(2*s**2 - 3*s + 1)) + k1**2*k2**2*(Pk2*(360*r**2 + 6*r*(49*s - 60) + 140*s**2 - 231*s + 90) + 7*Pkd2*k2*s*(18*r + 8*s - 9))) + 28*Pk2*k2**4*r*s + k1**4*(2*Pk2*r*(74*s - 7) + 30*Pk2*s*(3*s - 2) + 21*Pkd2*k2*s**2) + k1**2*k2**2*(Pk2*(42*r**2 + r*(212*s - 35) + 12*s*(7*s - 3)) + 21*Pkd2*k2*s**2)) + Dd*f*(28*Pk2*k2**4*r*(1 - 4*s) + k1**4*(Pk2*(4*C*(20*s**2 + 23*s - 7) - 592*r*s + 88*r - 360*s**2 + 270*s - 30) - 7*Pkd2*k2*(4*s - 1)*(8*C*(s - 1) + 3*s)) - k1**2*k2**2*(2*Pk2*(C*(720*r**2 + 588*r*s - 624*r + 280*s**2 - 469*s + 174) + 84*r**2 + 424*r*s - 109*r + 168*s**2 - 96*s + 9) + 7*Pkd2*k2*s*(C*(72*r + 32*s - 26) + 12*s - 3)))) - 6*f**2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1))*(2*C*k1**2*(Pk2 + 3*Pkd2*k2)*(s - 1) + Pk2*r*(3*k1**2 + 3*k2**2)))/(105*d**2*k1**2*k2**2*k3**2) + 4*D1**3*Pk1*st**2*(3*D1*bd1*f*(-7*b1*k2**2*(5*Pk2*k2**4*(-4*r**2 + r*(3 - 4*s) + s) + k1**4*(4*C*Pkd2*k2*(r*(s + 1) + s*(s - 2)) + Pk2*(2*r**2 + r*(4*s - 7) + s*(2*s + 3))) - 2*k1**2*k2**2*(5*C*Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3)) + Pk2*(r + s)*(20*C*(r + s - 1) + 9*r - s - 4))) + f*(Pk2*k1**6*(r*(2*s + 3) + 2*s**2 + 5*s - 3) + 7*Pk2*k2**6*r*(2*r + 2*s - 1) + k1**4*k2**2*(4*C*Pkd2*k2*(2*r*(5*s - 6) + 10*s**2 - 23*s + 13) + Pk2*(28*C*(2*r**2 + 3*r*s - r + s**2 + 2*s - 1) + 20*r**2 + 42*r*s - 6*r + 22*s**2 - 4*s - 7)) + k1**2*k2**4*(14*C*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)) + Pk2*(4*C*(36*r**2 + 78*r*s - 57*r + 42*s**2 - 44*s + 16) + 34*r**2 + 54*r*s - 16*r + 20*s**2 - 9*s - 4)))) - 21*b1**2*k2**2*(D1*fd*(r + s)*(-10*Pk2*k2**4*r + k1**4*(2*C*Pkd2*k2*s + Pk2*(r + s)) - k1**2*k2**2*(20*C*Pkd2*k2*s + Pk2*r*(20*C + 9) + Pk2*s*(20*C - 1))) + Dd*f*(5*Pk2*k2**4*(-8*r**2 + r*(3 - 8*s) + s) + k1**4*(4*C*Pkd2*k2*(2*r*s + r + s*(2*s - 2)) + Pk2*(4*r**2 + r*(8*s - 7) + s*(4*s + 3))) - 2*k1**2*k2**2*(5*C*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3)) + 2*Pk2*(r + s)*(10*C*(2*r + 2*s - 1) + 9*r - s - 2)))) + 3*b1*f*(D1*fd*(Pk2*k1**6*(r*(4*s + 5) + 4*s**2 + 10*s - 6) + 7*Pk2*k2**6*(4*r**2 + r*(4*s - 2) - s) + k1**4*k2**2*(2*C*Pkd2*k2*(r*(40*s - 49) + 40*s**2 - 83*s + 28) + Pk2*(28*C*(4*r**2 + 6*r*s + 2*s**2 + 5*s - 3) + 40*r**2 + 84*r*s - 35*r + 44*s**2 - 30*s + 4)) + k1**2*k2**4*(14*C*Pkd2*k2*s*(4*r + 4*s - 1) + Pk2*(4*C*(72*r**2 + r*(156*s - 107) + 84*s**2 - 92*s + 32) + 68*r**2 + 54*r*(2*s - 1) + 40*s**2 - 47*s + 10))) + Dd*f*(Pk2*k1**6*(r*(8*s + 11) + 8*s**2 + 21*s - 9) + 7*Pk2*k2**6*(8*r**2 + r*(8*s - 3) - s) + k1**4*k2**2*(4*C*Pkd2*k2*(r*(40*s - 47) + 40*s**2 - 81*s + 27) + Pk2*(56*C*(4*r**2 + 6*r*s + 2*s**2 + 5*s - 2) + 80*r**2 + 168*r*s - 41*r + 88*s**2 - 31*s - 3)) + k1**2*k2**4*(14*C*Pkd2*k2*(r*(8*s - 1) + s*(8*s - 3)) + Pk2*(12*C*(48*r**2 + 104*r*s - 63*r + 56*s**2 - 53*s + 16) + 136*r**2 + 216*r*s - 73*r + 80*s**2 - 59*s + 6)))) + f**2*k1**2*(D1*fd*(Pk2*k1**4*(6*r*(3*s + 2) + 18*s**2 + 9*s - 11) + 9*Pk2*k2**4*(4*C*(9*r**2 + r*(21*s - 13) + 12*s**2 - 13*s + 4) + 15*r**2 + 3*r*(8*s - 5) + 9*s**2 - 10*s + 3) + k1**2*k2**2*(18*C*Pkd2*k2*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7) + Pk2*(4*C*(3*r - 1)*(30*r + 30*s - 11) + 135*r**2 + 3*r*(78*s - 41) + 99*s**2 - 81*s + 16))) + Dd*f*(Pk2*k1**4*(r*(24*s + 17) + 24*s**2 + 15*s - 11) + 9*Pk2*k2**4*(4*C*(12*r**2 + r*(28*s - 15) + 16*s**2 - 15*s + 4) + 20*r**2 + 16*r*(2*s - 1) + 3*(1 - 2*s)**2) + k1**2*k2**2*(18*C*Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 25*s + 7) + Pk2*(4*C*(120*r**2 + 120*r*s - 69*r - 35*s + 11) + 180*r**2 + 312*r*s - 127*r + 132*s**2 - 93*s + 16)))))/(315*d**2*k1**2*k2**2*k3**4) + D1**3*Pk2*Pkd1*ct**7*f*k2**3*(8*C - 8)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r + Dd*f*(12*r - 5))*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r - 1)*(6*r + 6*s - 1) + Dd*f*(24*r**2 + 24*r*s - 12*r - 4*s + 1)))/(315*d**2*k3**4) - 4*D1**3*Pk2*Pkd1*ct**6*f*k2**2*(9*D1*bd1*f*(k1**2*(2*C*(3*r**2 + 3*r*s + 5*r + 9*s - 8) - 21*r - 28*s + 21) + k2**2*(6*r**2 + r*(6*s - 11) - 10*s + 5)) + 9*b1*(2*D1*fd*r*(k1**2*(C*(6*r + 6*s + 4) - 7) + 3*k2**2*(2*r + 2*s - 1)) + Dd*f*(k1**2*(2*C*(12*r**2 + 12*r*s + 17*r + 9*s - 8) - 56*r - 28*s + 21) + k2**2*(12*r - 5)*(2*r + 2*s - 1))) + 5*f*(D1*fd*(3*r - 1)*(k1**2*(6*C*(3*r + 3*s - 2) - 12*r - 12*s + 11) + k2**2*(6*r + 6*s - 1)) + Dd*f*(k1**2*(6*C*(12*r**2 + 12*r*s - 9*r - 5*s + 2) - 48*r**2 - 48*r*s + 42*r + 26*s - 11) + k2**2*(24*r**2 + 12*r*(2*s - 1) - 4*s + 1))))/(315*d**2*k1*k3**4) + D1**3*Pk2*Pkd1*ct**5*f*k2**3*st**2*(16*C - 16)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r + Dd*f*(12*r - 5))*(2*r + 2*s - 1) + f*(D1*fd*(72*r**2 + 72*r*s - 9*r + 12*s - 17) + Dd*f*(96*r**2 + 96*r*s - 12*r + 32*s - 17)))/(315*d**2*k3**4) + 4*D1**3*Pk2*Pkd1*ct**5*k2*(-3*D1*bd1*f*(-14*b1*k2**2*(C - 1)*(2*r**2 + 2*r*s + r - 3*s) + 3*f*(k1**2*(2*C*(17*r**2 + 17*r*s - 16*r - 5*s - 1) - 37*r**2 - 37*r*s + 27*r + s + 10) + k2**2*(C*(42*r**2 + 42*r*s - 80*r - 52*s + 28) - 33*r**2 - 33*r*s + 53*r + 23*s - 10))) + 42*b1**2*k2**2*(C - 1)*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s + r - 3*s)) - 9*b1*f*(2*D1*fd*(k1**2*r*(2*C*(17*r + 17*s - 5) - 37*r - 37*s + 8) + k2**2*(C*(42*r**2 + 42*r*s - 29*r - s + 4) - 33*r**2 - 33*r*s + 21*r + s - 4)) + Dd*f*(k1**2*(2*C*(68*r**2 + 68*r*s - 25*r - 5*s - 1) - 148*r**2 - 148*r*s + 33*r + s + 10) + k2**2*(2*C*(84*r**2 + 84*r*s - 85*r - 29*s + 18) - 132*r**2 - 132*r*s + 109*r + 29*s - 18))) - 5*f**2*(D1*fd*(3*r - 1)*(k1**2*(6*C*(9*r + 9*s - 5) - 63*r - 63*s + 36) + k2**2*(4*C*(12*r + 12*s - 5) - 45*r - 45*s + 24)) + Dd*f*(3*k1**2*(2*C*(36*r**2 + 9*r*(4*s - 3) - 11*s + 5) - 84*r**2 - 21*r*(4*s - 3) + 27*s - 12) + k2**2*(4*C*(48*r**2 + 48*r*s - 33*r - 11*s + 5) - 180*r**2 - 180*r*s + 135*r + 51*s - 24))))/(315*d**2*k3**4) - 8*D1**3*Pk2*Pkd1*ct**4*f*k2**2*st**2*(-9*D1*bd1*f*(k1**2*(C*(2*r**2 + r*(2*s - 13) - 15*s + 11) - 8*r**2 - 8*r*(s - 3) + 25*s - 16) + k2**2*(-6*r**2 + r*(11 - 6*s) + 10*s - 5)) - 9*b1*(D1*fd*r*(k1**2*(C*(4*r + 4*s - 9) - 16*r - 16*s + 15) - 6*k2**2*(2*r + 2*s - 1)) + Dd*f*(k1**2*(C*(8*r**2 + 8*r*s - 33*r - 15*s + 11) - 32*r**2 - 32*r*s + 55*r + 25*s - 16) - k2**2*(12*r - 5)*(2*r + 2*s - 1))) + f*(D1*fd*(k1**2*(-9*C*(18*r + 15*s - 11) + 72*r**2 + 9*r*(8*s + 17) + 147*s - 116) + k2**2*(72*r**2 + 9*r*(8*s - 1) + 12*s - 17)) + Dd*f*(k1**2*(-9*C*(21*r + 23*s - 11) + 96*r**2 + 96*r*s + 177*r + 239*s - 116) + k2**2*(96*r**2 + 12*r*(8*s - 1) + 32*s - 17))))/(315*d**2*k1*k3**4) - 4*D1**3*Pk2*Pkd1*ct**4*(3*D1*bd1*f*(7*b1*k2**2*(k1**2*(r**2*(28*C - 26) + r*(28*C*s - 26*C - 26*s + 27) - s*(2*C + 1)) + k2**2*(2*r**2 + 2*r*s + r - 3*s)) + 3*f*(k1**4*(4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 33*r**2 - 33*r*s + 36*r + 13*s - 3) + k1**2*k2**2*(2*C*(35*r**2 + 35*r*s - 64*r - 36*s + 28) - 108*r**2 - 108*r*s + 163*r + 75*s - 48) + k2**4*(-15*r**2 + r*(29 - 15*s) + 16*s - 9))) + 21*b1**2*k2**2*(D1*fd*r*(r + s)*(k1**2*(14*C - 13) + k2**2) + Dd*f*(k1**2*(r**2*(56*C - 52) + r*(56*C*s - 26*C - 52*s + 27) - s*(2*C + 1)) + k2**2*(4*r**2 + 4*r*s + r - 3*s))) + 9*b1*f*(D1*fd*(2*k1**4*r*(8*C*(2*r + 2*s - 1) - 33*r - 33*s + 13) + k1**2*k2**2*(2*C*(70*r**2 + 70*r*s - 73*r - 17*s + 12) - 216*r**2 - 216*r*s + 171*r + 35*s - 28) + k2**4*(-30*r**2 + r*(23 - 30*s) + s - 4)) + Dd*f*(k1**4*(4*C*(8*r - 1)*(2*r + 2*s - 1) - 132*r**2 - 132*r*s + 65*r + 13*s - 3) + 2*k1**2*k2**2*(C*(140*r**2 + 140*r*s - 171*r - 59*s + 40) - 216*r**2 - 216*r*s + 198*r + 62*s - 38) + k2**4*(-60*r**2 + r*(63 - 60*s) + 19*s - 13))) + 5*f**2*(D1*fd*(3*r - 1)*(k1**4*(8*C*(3*r + 3*s - 2) - 51*r - 51*s + 31) + 3*k1**2*k2**2*(4*C*(3*r + 3*s - 2) - 33*r - 33*s + 20) - 9*k2**4*(2*r + 2*s - 1)) + Dd*f*(k1**4*(4*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) - 204*r**2 - 204*r*s + 165*r + 61*s - 31) + 3*k1**2*k2**2*(8*C*(6*r**2 + 6*r*(s - 1) - s + 1) - 132*r**2 - 132*r*s + 111*r + 35*s - 20) - 9*k2**4*(4*r - 1)*(2*r + 2*s - 1))))/(315*d**2*k1*k3**4) + D1**3*Pk2*Pkd1*ct**3*f*k2**3*st**4*(8*C - 8)*(3*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 3*b1*(6*D1*fd*r + Dd*f*(12*r - 5))*(2*r + 2*s - 1) + f*(D1*fd*(18*r**2 + 18*r*s + 9*r + 18*s - 13) + Dd*f*(24*r**2 + 24*r*s + 12*r + 28*s - 13)))/(105*d**2*k3**4) + 4*D1**3*Pk2*Pkd1*ct**3*k2*st**2*(-3*D1*bd1*f*(-14*b1*k2**2*(C - 1)*(2*r**2 + 2*r*s + r - 3*s) + f*k1**2*(2*C*(11*r**2 + r*(11*s + 2) + 5*s - 13) - 16*r**2 - r*(16*s + 43) - 55*s + 59) + f*k2**2*(2*C*(77*r**2 + r*(77*s - 149) - 114*s + 63) - 76*r**2 + r*(127 - 76*s) + 63*s - 33)) + 42*b1**2*k2**2*(C - 1)*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s + r - 3*s)) - 3*b1*f*(D1*fd*(k1**2*r*(4*C*(11*r + 11*s + 5) - 32*r - 32*s - 47) + k2**2*(2*C*(154*r**2 + 154*r*s - 97*r - 13*s + 10) - 152*r**2 - 152*r*s + 95*r + 26*s - 20)) + Dd*f*(k1**2*(2*C*(44*r**2 + 44*r*s + 25*r + 5*s - 13) - 64*r**2 - 64*r*s - 149*r - 55*s + 59) + k2**2*(2*C*(308*r**2 + 308*r*s - 307*r - 139*s + 73) - 304*r**2 - 304*r*s + 251*r + 113*s - 53))) + f**2*(D1*fd*(-9*k1**2*(2*C*(9*r**2 + 9*r*s - 16*r - 11*s + 7) - 18*r**2 - 18*r*s + 50*r + 37*s - 25) + k2**2*(C*(-612*r**2 - 612*r*s + 306*r + 60*s + 14) + 324*r**2 + 324*r*s - 432*r - 243*s + 153)) + Dd*f*(-9*k1**2*(2*C*(12*r**2 + 12*r*s - 19*r - 15*s + 7) - 24*r**2 - 24*r*s + 59*r + 53*s - 25) + k2**2*(-2*C*(408*r**2 + 6*r*(68*s - 31) + 10*s - 7) + 432*r**2 + 9*r*(48*s - 57) - 315*s + 153))))/(315*d**2*k3**4) + 4*D1**3*Pk2*Pkd1*ct**3*(3*D1*bd1*f*(-7*b1*k2**2*(k1**2*(r**2*(48*C - 62) + r*(48*C*s - 36*C - 62*s + 49) + s*(13 - 12*C)) + k2**2*(r**2*(24*C - 34) + r*(24*C*s - 8*C - 34*s + 23) + s*(11 - 16*C))) + 3*f*(2*k1**4*(4*r**2 + r*(4*s - 5) - 2*s + 1) + k1**2*k2**2*(-4*C*(7*r**2 + 7*r*s - 11*r - 4*s + 7) + 108*r**2 + 108*r*s - 145*r - 57*s + 48) + k2**4*(2*C*(8*r**2 + 8*r*s - 29*r - 16*s + 9) + 52*r**2 + 52*r*s - 59*r - 27*s + 20))) - 21*b1**2*k2**2*(D1*fd*r*(r + s)*(k1**2*(24*C - 31) + k2**2*(12*C - 17)) + Dd*f*(k1**2*(r**2*(96*C - 124) + r*(96*C*s - 36*C - 124*s + 49) + s*(13 - 12*C)) + k2**2*(r**2*(48*C - 68) + r*(48*C*s - 8*C - 68*s + 23) + s*(11 - 16*C)))) + 9*b1*f*(D1*fd*(8*k1**4*r*(2*r + 2*s - 1) + k1**2*k2**2*(-8*C*(7*r**2 + r*(7*s - 13) - 6*s + 3) + 216*r**2 + 3*r*(72*s - 67) - 65*s + 36) + k2**4*(4*C*(8*r**2 + 8*r*(s - 1) + 3*s + 2) + 104*r**2 + r*(104*s - 83) - 31*s + 12)) + 2*Dd*f*(k1**4*(8*r - 1)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(C*(-28*r**2 - 28*r*s + 47*r + 19*s - 13) + 108*r**2 + 108*r*s - 103*r - 35*s + 21) + k2**4*(C*(32*r**2 + 8*r*(4*s - 7) - 12*s + 13) + (52*r - 16)*(2*r + 2*s - 1)))) + 5*f**2*(D1*fd*(3*r - 1)*(4*k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(12*C*(3*r + 3*s - 1) + 57*r + 57*s - 44) + 9*k2**4*(C*(4*r + 4*s - 2) + 3*r + 3*s - 2)) + Dd*f*(2*k1**4*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + k1**2*k2**2*(12*C*(12*r**2 + 6*r*(2*s - 1) - 4*s + 1) + 228*r**2 + 3*r*(76*s - 77) - 59*s + 44) + 9*k2**4*(4*r - 1)*(C*(4*r + 4*s - 2) + 3*r + 3*s - 2))))/(315*d**2*k2*k3**4) - 4*D1**3*Pk2*Pkd1*ct**2*f*k2**2*st**4*(-3*D1*bd1*f*(k1**2*(2*C*(5*r**2 + 5*r*s - 8*r - 6*s + 3) - 16*r**2 - 16*r*s + 27*r + 22*s - 11) + k2**2*(-6*r**2 + r*(11 - 6*s) + 10*s - 5)) - 3*b1*(2*D1*fd*r*(k1**2*(5*C - 8) - 3*k2**2) + Dd*f*(k1**2*(20*C*r - 6*C - 32*r + 11) + k2**2*(5 - 12*r)))*(2*r + 2*s - 1) + f*(D1*fd*(k1**2*(-6*C*(3*r**2 + 3*r*(s + 1) + 4*s - 3) + 36*r**2 + 9*r*(4*s + 3) + 42*s - 31) + k2**2*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13)) + Dd*f*(k1**2*(-6*C*(2*r + 3)*(2*r + 2*s - 1) + 48*r**2 + 48*r*s + 36*r + 64*s - 31) + k2**2*(24*r**2 + 12*r*(2*s + 1) + 28*s - 13))))/(105*d**2*k1*k3**4) + 4*D1**3*Pk2*Pkd1*ct**2*st**2*(-3*D1*bd1*f*(7*b1*k2**2*(k1**2*(3 - 2*C) + k2**2)*(2*r**2 + 2*r*s + r - 3*s) + f*(k1**4*(2*C*(2*r**2 + 2*r*s + r - s - 3) - 15*r**2 - 15*r*s - 4*r - 3*s + 19) + k1**2*k2**2*(2*C*(26*r**2 + 26*r*s - 94*r - 78*s + 59) - 92*r**2 - 92*r*s + 191*r + 115*s - 72) + k2**4*(-41*r**2 + r*(83 - 41*s) + 54*s - 33))) - 21*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s + r - 3*s)) - 3*b1*f*(D1*fd*(2*k1**4*r*(C*(4*r + 4*s + 5) - 15*r - 15*s - 10) + k1**2*k2**2*(2*C*(52*r**2 + 52*r*s - 74*r - 13*s + 10) - 184*r**2 - 184*r*s + 145*r + 39*s - 30) + k2**4*(-82*r**2 + r*(61 - 82*s) + 13*s - 10)) + Dd*f*(k1**4*(2*C*(8*r**2 + 8*r*s + 9*r - s - 3) - 60*r**2 - 60*r*s - 43*r - 3*s + 19) + 2*k1**2*k2**2*(C*(104*r**2 + 104*r*s - 225*r - 103*s + 69) - 184*r**2 - 184*r*s + 201*r + 95*s - 51) + k2**4*(-164*r**2 + r*(175 - 164*s) + 79*s - 43))) - f**2*(D1*fd*(k1**4*(2*C*(18*r**2 + 18*r*(s - 1) - 15*s + 7) - 117*r**2 - 117*r*s + 180*r + 129*s - 77) + 9*k1**2*k2**2*(6*C*(3*r**2 + 3*r*(s + 1) + 4*s - 3) - 45*r**2 - 45*r*s + 49*r + 23*s - 14) - 27*k2**4*(3*r - 1)*(2*r + 2*s - 1)) + Dd*f*(k1**4*(2*C*(24*r**2 + 3*r*(8*s - 7) - 19*s + 7) - 156*r**2 - 156*r*s + 213*r + 173*s - 77) + 9*k1**2*k2**2*(2*C*(12*r**2 + 2*r*(6*s + 5) + 20*s - 9) - 60*r**2 - 60*r*s + 59*r + 27*s - 14) - 27*k2**4*(4*r - 1)*(2*r + 2*s - 1))))/(315*d**2*k1*k3**4) - 4*D1**3*Pk2*Pkd1*ct**2*(3*D1*bd1*f*(7*b1*(k1**4*(4*C - 10)*(4*r**2 + r*(4*s - 3) - s) - k1**2*k2**2*(r**2*(8*C + 54) + r*(8*C*(s - 2) + 54*s - 33) + s*(8*C - 21)) - 5*k2**4*(r + s)*(2*r - 1)) + 3*f*(k1**4*(4*C*s - 47*r**2 + r*(4*C - 47*s + 54) + 17*s - 17) - k1**2*k2**2*(2*C*(31*r**2 + 31*r*s - 59*r - 27*s + 20) + 52*r**2 + 52*r*s - 38*r - 13*s + 13) - 7*k2**4*r*(r + s))) + 21*b1**2*(D1*fd*r*(r + s)*(k1**4*(8*C - 20) - k1**2*k2**2*(4*C + 27) - 5*k2**4) + Dd*f*(k1**4*(4*C - 10)*(8*r**2 + r*(8*s - 3) - s) - k1**2*k2**2*(r**2*(16*C + 108) + r*(16*C*(s - 1) + 108*s - 33) + s*(8*C - 21)) - 5*k2**4*(r + s)*(4*r - 1))) - 9*b1*f*(D1*fd*(2*k1**4*(C*(8*r + 8*s - 4) + 47*r**2 + 47*r*(s - 1) - 20*s + 10) + k1**2*k2**2*(4*C*(31*r**2 + 31*r*(s - 1) - 5*s + 6) + 104*r**2 + r*(104*s - 83) - 45*s + 12) + 7*k2**4*(r + s)*(2*r - 1)) + Dd*f*(k1**4*(8*C*(2*r + 2*s - 1) + 188*r**2 + r*(188*s - 175) - 67*s + 37) + k1**2*k2**2*(C*(248*r**2 + r*(248*s - 294) - 86*s + 64) + 208*r**2 + 4*r*(52*s - 35) - 64*s + 25) + 7*k2**4*(r + s)*(4*r - 1))) - 5*f**2*k1**2*(D1*fd*(3*r - 1)*(k1**2*(8*C*(3*r + 3*s - 2) + 9*r + 9*s - 9) + 9*k2**2*(C*(6*r + 6*s - 4) + r + s - 1)) + Dd*f*(k1**2*(4*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + (36*r - 9)*(r + s - 1)) + 9*k2**2*(4*r - 1)*(C*(6*r + 6*s - 4) + r + s - 1))))/(315*d**2*k1*k3**4) - 4*D1**3*Pk2*Pkd1*ct*f*k2*st**4*(3*D1*bd1*f*(k1**2*(5*r**2 + r*(5*s - 8) - 6*s + 3) + k2**2*(2*C*(6*r**2 + 6*r*s - 11*r - 10*s + 5) + 5*r**2 + 5*r*s - 8*r - 6*s + 3)) + 3*b1*(D1*fd*r*(5*k1**2 + k2**2*(12*C + 5)) + Dd*f*(k1**2*(10*r - 3) + k2**2*(24*C*r - 10*C + 10*r - 3)))*(2*r + 2*s - 1) + f*(D1*fd*(3*k1**2*(3*r**2 + 3*r*(s + 1) + 4*s - 3) + k2**2*(2*C*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13) + 9*r**2 + 9*r*(s + 1) + 12*s - 9)) + Dd*f*(3*k1**2*(2*r + 3)*(2*r + 2*s - 1) + k2**2*(C*(48*r**2 + 48*r*s + 24*r + 56*s - 26) + (6*r + 9)*(2*r + 2*s - 1)))))/(105*d**2*k3**4) + 4*D1**3*Pk2*Pkd1*ct*st**2*(3*D1*bd1*f*(-7*b1*k2**2*(k1**2 + k2**2*(2*C + 1))*(2*r**2 + 2*r*s + r - 3*s) + f*(k1**4*(2*r**2 + 2*r*s + r - s - 3) + k1**2*k2**2*(2*C*(11*r**2 + 11*r*s + 2*r + 5*s - 13) + 22*r**2 + 22*r*s - 54*r - 34*s + 23) + k2**4*(2*C*(41*r**2 + 41*r*s - 83*r - 54*s + 33) + 20*r**2 + 20*r*s - 55*r - 33*s + 26))) - 21*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s + r - 3*s)) + 3*b1*f*(D1*fd*(k1**4*r*(4*r + 4*s + 5) + k1**2*k2**2*(r**2*(44*C + 44) + r*(44*C*s + 20*C + 44*s - 42) - 13*s + 10) + k2**4*(2*C*(82*r**2 + 82*r*s - 61*r - 13*s + 10) + 40*r**2 + 40*r*s - 47*r - 13*s + 10)) + Dd*f*(k1**4*(8*r**2 + r*(8*s + 9) - s - 3) + k1**2*k2**2*(2*C*(44*r**2 + 44*r*s + 25*r + 5*s - 13) + 88*r**2 + 88*r*s - 117*r - 59*s + 33) + 2*k2**4*(C*(164*r**2 + 164*r*s - 175*r - 79*s + 43) + 40*r**2 + 40*r*s - 63*r - 29*s + 18))) + f**2*(D1*fd*(k1**4*(18*r**2 + 18*r*(s - 1) - 15*s + 7) + k1**2*k2**2*(18*C*(9*r**2 + r*(9*s - 16) - 11*s + 7) + 99*r**2 + 99*r*(s - 1) - 42*s + 25) + 9*k2**4*(3*r - 1)*(6*C*(2*r + 2*s - 1) + 3*r + 3*s - 2)) + Dd*f*(k1**4*(24*r**2 + 3*r*(8*s - 7) - 19*s + 7) + k1**2*k2**2*(18*C*(12*r**2 + r*(12*s - 19) - 15*s + 7) + 132*r**2 + 12*r*(11*s - 10) - 46*s + 25) + 9*k2**4*(4*r - 1)*(6*C*(2*r + 2*s - 1) + 3*r + 3*s - 2))))/(315*d**2*k2*k3**4) + 4*D1**3*Pk2*Pkd1*ct*(30*C*f**2*k1**2*k2**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))*(r + s - 1) + D1*bd1*f*(7*b1*(k1**4*(8*r**2 + r*(8*s - 6) - 2*s) + k1**2*k2**2*(r**2*(48*C + 18) + r*(12*C*(4*s - 3) + 18*s - 11) - s*(12*C + 7)) + k2**4*(10*C + 5)*(r + s)*(2*r - 1)) + 3*f*(k1**4*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + k1**2*k2**2*(C*(62*r**2 + 62*r*s - 76*r - 26*s + 26) + 15*r**2 + 15*r*s - 8*r - 2*s + 2) + k2**4*r*(14*C + 7)*(r + s))) + 7*b1**2*(D1*fd*r*(r + s)*(4*k1**4 + k1**2*k2**2*(24*C + 9) + k2**4*(10*C + 5)) + Dd*f*(2*k1**4*(8*r**2 + r*(8*s - 3) - s) + k1**2*k2**2*(r**2*(96*C + 36) + r*(12*C*(8*s - 3) + 36*s - 11) - s*(12*C + 7)) + k2**4*(10*C + 5)*(r + s)*(4*r - 1))) + 3*b1*f*(D1*fd*(4*k1**4*(2*r - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(31*r**2 + 31*r*(s - 1) - 12*s + 6) + (2*r - 1)*(15*r + 15*s - 4)) + k2**4*(14*C + 7)*(r + s)*(2*r - 1)) + Dd*f*(2*k1**4*(8*r - 3)*(2*r + 2*s - 1) + k1**2*k2**2*(C*(248*r**2 + r*(248*s - 238) - 86*s + 50) + 60*r**2 + 5*r*(12*s - 7) - 19*s + 6) + k2**4*(14*C + 7)*(r + s)*(4*r - 1))))/(105*d**2*k2*k3**4) + D1**3*Pk2*Pkdd1*ct**6*f*k2**2*(8*C - 8)*(D1*(36*b1*fd*r**2 + 18*bd1*f*r*(r - 1) + 5*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(18*b1*r + 5*f*(3*r - 1)))/(315*d**2*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**5*f**2*k2*(D1*(99*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + 7*f*fd*(1 - 4*r)**2) + Dd*f*(4*r - 1)*(33*b1*r + 7*f*(4*r - 1)))/(693*d**2*k1) - 4*D1**3*Pk2*Pkdd1*ct**5*f*k2*(D1*(36*b1*fd*r**2 + 18*bd1*f*r*(r - 1) + 5*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(18*b1*r + 5*f*(3*r - 1)))*(k1**2*(5 - 4*C) + k2**2)/(315*d**2*k1*k3**2) + D1**3*Pk2*Pkdd1*ct**4*f*k2**2*st**2*(8*C - 8)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(9*r**2 - 15*r + 4)) + Dd*f*(4*r - 1)*(3*b1*r + f*(3*r - 4)))/(105*d**2*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**4*(33*b1**2*r*(D1*fd*r*(-7*K + 12*f + 7) + Dd*f*(4*r - 1)*(-7*K + 6*f + 7)) + 11*b1*(D1*(f**2*(18*bd1*r*(2*r - 1) + 5*fd*(27*r**2 - 6*r + 1)) + f*(-9*fd*(1 - 2*r)**2*(K - 1) - 21*r*(bd1*(K - 1)*(2*r - 1) - 2*gd2*r)) + 42*fd*g2*r**2) + Dd*f*(4*r - 1)*(5*f**2*(9*r - 1) - 9*f*(K - 1)*(2*r - 1) + 42*g2*r)) + f*(D1*(5*f**2*(11*bd1*r*(9*r - 7) + 14*fd*(1 - 4*r)**2) + 99*f*r*(2*r - 1)*(-K*bd1 + bd1 + 2*gd2) + 66*g2*(7*bd1*r*(r - 1) + 3*fd*(1 - 2*r)**2)) + 2*Dd*f*(4*r - 1)*(35*f**2*(4*r - 1) + 99*g2*(2*r - 1))))/(3465*d**2) + 8*D1**3*Pk2*Pkdd1*ct**4*(D1*(21*b1**2*fd*k2**2*r**2*(C - 1) - 3*b1*f*(7*bd1*k2**2*r*(-2*C*r + C + 2*r - 1) + 3*fd*(k1**2*r**2*(8 - 4*C) + k2**2*(4*C*r - C + 8*r**2 - 4*r + 1))) + f**2*(9*bd1*r*(k1**2*(2*C - 4)*(r - 1) + k2**2*(C - 4*r + 3)) + 5*fd*(1 - 3*r)**2*(k1**2*(C - 2) - k2**2*(C + 1)))) + Dd*f*(4*r - 1)*(21*b1**2*k2**2*r*(C - 1) - 9*b1*f*(k1**2*r*(4 - 2*C) + k2**2*(C + 4*r - 1)) + 5*f**2*(3*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1))))/(315*d**2*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**3*f**2*k2*st**2*(D1*(99*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + 5*f*fd*(20*r**2 - 21*r + 4)) + Dd*f*(4*r - 1)*(33*b1*r + 5*f*(5*r - 4)))/(693*d**2*k1) - 4*D1**3*Pk2*Pkdd1*ct**3*f*k2*st**2*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(9*r**2 - 15*r + 4)) + Dd*f*(4*r - 1)*(3*b1*r + f*(3*r - 4)))*(k1**2*(3 - 2*C) + k2**2)/(105*d**2*k1*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**3*(33*b1**2*r*(D1*fd*r*(k1**2*(12*f + 7) + k2**2*(24*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(6*f + 7) + k2**2*(12*f + 7))) + 11*b1*f*(D1*(3*bd1*r*(2*r - 1)*(k1**2*(6*f + 7) + k2**2*(12*f + 7)) + fd*(k1**2*(5*f*(18*r**2 - 6*r + 1) + 9*(1 - 2*r)**2) + k2**2*(10*f*(1 - 3*r)**2 + 9*(1 - 2*r)**2))) + Dd*f*(4*r - 1)*(k1**2*(5*f*(6*r - 1) + 18*r - 9) + k2**2*(10*f*(3*r - 1) + 18*r - 9))) + f**2*(99*D1*bd1*r*(k1**2 + k2**2)*(2*r - 1) + 5*D1*f*(22*bd1*r*(k1**2*(3*r - 2) + k2**2*(3*r - 1)) + 7*fd*k1**2*(1 - 4*r)**2) + 35*Dd*f**2*k1**2*(1 - 4*r)**2))/(3465*d**2*k1*k2) - 4*D1**3*Pk2*Pkdd1*ct**3*(D1*(21*b1**2*fd*k2**2*r**2*(k1**2*(5 - 4*C) + k2**2) + 3*b1*f*(7*bd1*k2**2*r*(2*r - 1)*(k1**2*(5 - 4*C) + k2**2) + 3*fd*(4*k1**4*r**2 + k1**2*k2**2*(4*C*(4*r - 1) + 24*r**2 - 20*r + 5) + k2**4*(1 - 2*r)**2)) + f**2*(-9*bd1*r*(-2*k1**4*(r - 1) + k1**2*k2**2*(4*C - 12*r + 7) + k2**4*(1 - 2*r)) + 5*fd*k1**2*(1 - 3*r)**2*(k1**2 + k2**2*(4*C + 1)))) + Dd*f*(4*r - 1)*(21*b1**2*k2**2*r*(k1**2*(5 - 4*C) + k2**2) + 9*b1*f*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**4*(2*r - 1)) + 5*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(3*r - 1)))/(315*d**2*k1*k2*k3**2) - D1**3*Pk2*Pkdd1*ct**2*f*k2**2*st**4*(8*C - 8)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k3**2) - 2*D1**3*Pk2*Pkdd1*ct**2*st**2*(11*b1**2*r*(D1*fd*r*(7*K + 12*f - 7) + Dd*f*(4*r - 1)*(7*K + 6*f - 7)) + 11*b1*(D1*(2*f**2*(3*bd1*r*(2*r - 1) + fd*(27*r**2 - 15*r + 4)) + f*(-fd*(K - 1)*(2*r**2 - 9*r + 4) + 7*r*(bd1*(K - 1)*(2*r - 1) - 2*gd2*r)) - 14*fd*g2*r**2) + Dd*f*(4*r - 1)*(2*f**2*(9*r - 4) - f*(K - 1)*(r - 4) - 14*g2*r)) + f*(D1*(2*f**2*(11*bd1*r*(9*r - 10) + 10*fd*(20*r**2 - 21*r + 4)) + 11*f*r*(r - 4)*(-K*bd1 + bd1 + 2*gd2) + 22*g2*(-7*bd1*r*(r - 1) + fd*(2*r**2 - 9*r + 4))) + 2*Dd*f*(4*r - 1)*(10*f**2*(5*r - 4) + 11*g2*(r - 4))))/(1155*d**2) - 4*D1**3*Pk2*Pkdd1*ct**2*(7*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(7*bd1*f*r*(3*r - 1) + 3*f*fd*(16*r**2 - 4*r + 1) + 7*fd*(K*(2*r - 1) + 2*r**2 - 2*r + 1)) + Dd*f*(4*r - 1)*(7*K + 3*f*(8*r - 1) + 14*r - 7)) + b1*(D1*(f**2*(24*bd1*r*(2*r - 1) + 5*fd*(1 - 3*r)**2) + f*(3*fd*(1 - 2*r)**2*(K + 1) + 7*r*(bd1*(K + 4*r - 3) + bd2*r - 2*gd2)) + 7*fd*(b2*r**2 + g2*(2 - 4*r))) + Dd*f*(4*r - 1)*(7*b2*r + 5*f**2*(3*r - 1) + 3*f*(K + 1)*(2*r - 1) - 14*g2)) + f*(D1*f*r*(5*bd1*f*(3*r - 1) + 3*bd1*(K + 1)*(2*r - 1) + (3*bd2 - 6*gd2)*(2*r - 1)) - 6*D1*fd*g2*(1 - 2*r)**2 - 6*Dd*f*g2*(8*r**2 - 6*r + 1) + b2*(7*D1*bd1*r*(r - 1) + 3*D1*fd*(1 - 2*r)**2 + 3*Dd*f*(8*r**2 - 6*r + 1))))/(105*d**2) - 4*D1**3*Pk2*Pkdd1*ct**2*st**2*(D1*(21*b1**2*fd*k2**2*r**2*(C - 1) + 3*b1*f*(7*bd1*k2**2*r*(C - 1)*(2*r - 1) + fd*k1**2*r**2*(8 - 2*C) + fd*k2**2*(C*(10*r**2 + 9*r - 4) + 8*r**2 - 9*r + 4)) + f**2*(-3*bd1*r*(k1**2*(C - 4)*(r - 1) + k2**2*(C*(2 - 5*r) - 4*r + 7)) - fd*(k1**2*(C - 4) - k2**2*(6*C + 3))*(9*r**2 - 15*r + 4))) - Dd*f*(4*r - 1)*(-21*b1**2*k2**2*r*(C - 1) - 3*b1*f*(-k1**2*r*(C - 4) + k2**2*(5*C*r + 4*C + 4*r - 4)) + f**2*(3*r - 4)*(k1**2*(C - 4) - k2**2*(6*C + 3))))/(315*d**2*k3**2) + 8*D1**3*Pk2*Pkdd1*ct**2*(21*b1**2*r*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1*f*(D1*(-7*bd1*r*(2*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)) + 3*fd*(k1**2*(C*(4*r - 1) + 2*(1 - 2*r)**2) + k2**2*(1 - 2*r)**2*(C + 1))) + 3*Dd*f*(4*r - 1)*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1))) + f**2*(C*(9*D1*bd1*r*(k1**2 + k2**2*(1 - 2*r)) - 5*D1*fd*k1**2*(1 - 3*r)**2 - 5*Dd*f*k1**2*(12*r**2 - 7*r + 1)) - 9*D1*bd1*r*(2*k1**2 + k2**2)*(2*r - 1)))/(315*d**2*k3**2) - 4*D1**3*Pk2*Pkdd1*ct*f**3*k2*st**4*(D1*fd + Dd*f)*(4*r**2 - 13*r + 3)/(231*d**2*k1) + 4*D1**3*Pk2*Pkdd1*ct*f*k2*st**4*(k1**2 + k2**2)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k1*k3**2) - 4*D1**3*Pk2*Pkdd1*ct*k1*(k1**2 + k2**2*(4*C + 1))*(3*D1*bd1*f**2*r*(2*r - 1) + 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(7*D1*bd1*r + D1*fd*(6*r - 3) + 3*Dd*f*(4*r - 1)))/(105*d**2*k2*k3**2) - 2*D1**3*Pk2*Pkdd1*ct*st**2*(D1*f**2*(11*bd1*f*r*(k1**2*(6*r - 7) + 2*k2**2*(3*r - 4)) + 11*bd1*r*(k1**2 + k2**2)*(r - 4) + 5*f*fd*k1**2*(20*r**2 - 21*r + 4)) + 5*Dd*f**4*k1**2*(20*r**2 - 21*r + 4) + 11*b1**2*r*(D1*fd*r*(k1**2*(6*f - 7) + k2**2*(12*f - 7)) + Dd*f*(4*r - 1)*(k1**2*(3*f - 7) + k2**2*(6*f - 7))) + 11*b1*f*(D1*(bd1*r*(2*r - 1)*(k1**2*(3*f - 7) + k2**2*(6*f - 7)) + fd*(k1**2*(f*(18*r**2 - 15*r + 4) + 2*r**2 - 9*r + 4) + k2**2*(2*f*(9*r**2 - 15*r + 4) + 2*r**2 - 9*r + 4))) + Dd*f*(4*r - 1)*(k1**2*(f*(6*r - 4) + r - 4) + k2**2*(f*(6*r - 8) + r - 4))))/(1155*d**2*k1*k2) - 4*D1**3*Pk2*Pkdd1*ct*(5*D1*bd1*f**3*k1**2*r*(3*r - 1) + 21*b1**3*r*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*(D1*(7*bd1*f*r*(k1**2 + k2**2)*(3*r - 1) + fd*k1**2*(3*f*(8*r**2 - 4*r + 1) + 7*(r - 1)**2) + fd*k2**2*(3*f*(1 - 2*r)**2 + 7*(r - 1)**2)) + Dd*f*(4*r - 1)*(k1**2*(12*f*r - 3*f + 7*r - 7) + k2**2*(6*f*r - 3*f + 7*r - 7))) + b1*(D1*f*(18*bd1*f*r*(2*k1**2 + k2**2)*(2*r - 1) + 42*bd1*r*(k1**2 + k2**2)*(r - 1) + 5*f*fd*k1**2*(1 - 3*r)**2) + 5*Dd*f**3*k1**2*(12*r**2 - 7*r + 1)))/(315*d**2*k1*k2) - 2*D1**3*Pk2*Pkdd1*ct*st**2*(D1*(-21*b1**2*fd*k2**2*r**2*(k1**2 + k2**2) + 3*b1*f*(-7*bd1*k2**2*r*(k1**2 + k2**2)*(2*r - 1) + fd*(2*k1**4*r**2 + k1**2*k2**2*(r**2*(24*C + 4) - 9*r + 4) + k2**4*(2*r**2 - 9*r + 4))) + f**2*(3*bd1*r*(k1**4*(r - 1) + k1**2*k2**2*(12*C*(r - 1) + 2*r - 5) + k2**4*(r - 4)) + fd*k1**2*(k1**2 + k2**2*(12*C + 1))*(9*r**2 - 15*r + 4))) + Dd*f*(4*r - 1)*(-21*b1**2*k2**2*r*(k1**2 + k2**2) + 3*b1*f*(k1**4*r + 2*k1**2*k2**2*(6*C*r + r - 2) + k2**4*(r - 4)) + f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(3*r - 4)))/(315*d**2*k1*k2*k3**2) + 4*D1**3*Pk2*Pkdd1*f*st**4*(33*b1**2*r*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(3*D1*bd1*r*(2*r - 1) + D1*fd*(3*r - 1) + Dd*f*(4*r - 1)) + f**2*(11*D1*bd1*r + D1*fd*(-8*r**2 + 26*r - 6) - 2*Dd*f*(4*r**2 - 13*r + 3)))/(1155*d**2) + 2*D1**3*Pk2*Pkdd1*st**2*(7*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(7*bd1*f*r*(3*r - 1) + f*fd*(-8*r**2 + 9*r - 4) + 7*fd*r**2*(K + 1)) - Dd*f*(4*r - 1)*(4*f*(r - 1) - r*(7*K + 7))) - b1*(D1*(f**2*(bd1*r*(8*r - 11) + fd*(9*r**2 - 15*r + 4)) + f*(fd*(K + 1)*(2*r**2 - 9*r + 4) - 7*r*(bd1*(K + 1)*(2*r - 1) + r*(bd2 - 2*gd2))) - 7*fd*r**2*(b2 - 2*g2)) + Dd*f*(4*r - 1)*(f**2*(3*r - 4) + f*(K + 1)*(r - 4) - r*(7*b2 - 14*g2))) - f*(D1*(bd1*r*(f**2*(3*r - 4) + f*(K + 1)*(r - 4) + 14*g2*(r - 1)) + f*r*(bd2 - 2*gd2)*(r - 4) - 2*fd*g2*(2*r**2 - 9*r + 4)) - 2*Dd*f*g2*(4*r**2 - 17*r + 4) + b2*(-7*D1*bd1*r*(r - 1) + D1*fd*(2*r**2 - 9*r + 4) + Dd*f*(4*r**2 - 17*r + 4))))/(105*d**2) - 4*D1**3*Pk2*Pkdd1*(7*D1*bd1*f*r*(b2 - 2*g2)*(r - 1) + 7*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(7*bd1*f*r*(3*r - 1) + 3*f*fd*(1 - 2*r)**2 + 7*fd*(K + 1)*(r - 1)**2) + Dd*f*(4*r - 1)*(f*(6*r - 3) + (7*K + 7)*(r - 1))) + b1*(D1*f*r*(2*bd1*(f*(6*r - 3) + (7*K + 7)*(r - 1)) + (7*bd2 - 14*gd2)*(r - 1)) - 14*D1*fd*g2*(r - 1)**2 - 14*Dd*f*g2*(4*r**2 - 5*r + 1) + 7*b2*(r - 1)*(D1*fd*(r - 1) + Dd*f*(4*r - 1))))/(105*d**2) + D1**3*Pkd1*ct**7*f*k2*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*s - 1) + Dd*f*(8*r*(3*s - 2) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(6*s - 5) + Dd*f*(24*r*s - 22*r - 4*s + 5)))/(315*d**2*k3**2) - D1**3*Pkd1*ct**6*f**2*(4*Pk2 - Pkd2*k2)*(11*D1*bd1*f*(7*r*(3*s - 2) - 33*s + 14) + 11*b1*(3*D1*fd*r*(21*s - 10) + Dd*f*(84*r*s - 44*r - 33*s + 14)) + 7*f*(4*r - 1)*(23*s - 14)*(D1*fd + Dd*f))/(693*d**2*k1) - 2*D1**3*Pkd1*ct**6*f*(18*D1*b1*fd*r*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(5*s - 6) - 16*s + 15) + k2**2*(2*Pk2*(r*(32*C - 32) + 6*s - 3) + 3*Pkd2*k2*(1 - 2*s))) - 9*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(5*r*(s - 2) - 13*s + 10) + r*(25 - 16*s) + 36*s - 25) + k2**2*(-2*Pk2*(r**2*(32*C - 32) + r*(-32*C + 6*s + 27) - 10*s + 5) + Pkd2*k2*(r*(6*s - 5) - 10*s + 5))) + D1*f*fd*(3*r - 1)*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(C*(6*s - 20) - 12*s + 25) + k2**2*(2*Pk2*(150*C*r + 58*C - 150*r + 30*s - 83) + 5*Pkd2*k2*(5 - 6*s))) - 9*Dd*b1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(8*r*(5*s - 8) - 26*s + 20) + r*(80 - 64*s) + 36*s - 25) + k2**2*(-2*Pk2*(r**2*(128*C - 128) - 8*r*(4*C - 3*s - 2) - 10*s + 5) + Pkd2*k2*(8*r*(3*s - 2) - 10*s + 5))) + Dd*f**2*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(4*r*(3*s - 11) + s + 10) + r*(110 - 48*s) + 2*s - 25) + k2**2*(2*Pk2*(C*(600*r**2 + 82*r - 58) - 600*r**2 + 24*r*(5*s - 8) - 20*s + 83) - 5*Pkd2*k2*(r*(24*s - 22) - 4*s + 5))))/(315*d**2*k1*k3**2) + D1**3*Pkd1*ct**5*f*k2*st**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*s - 1) + Dd*f*(8*r*(3*s - 2) - 10*s + 5)) + f*(D1*fd*(72*r*s - 51*r + 12*s + 5) + Dd*f*(96*r*s - 76*r + 32*s + 5)))/(315*d**2*k3**2) + 2*D1**3*Pkd1*ct**5*(-33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*r*(-7*K*s + 7*K + 18*f*(2*s - 1) + 7*s - 7) + Dd*f*(3*f*(8*r*(3*s - 2) - 10*s + 5) + (7 - 7*K)*(2*r*(2*s - 5) - 3*s + 3))) - 11*b1*(3*D1*bd1*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(2*r*(6*s - 5) - 10*s + 5) + (7 - 7*K)*(2*r*(s - 3) - 3*s + 3)) + D1*(5*f**2*fd*(-36*Pk2*k2**2*r**2 + k1**2*(4*Pk2 - Pkd2*k2)*(9*r - 1)*(6*s - 5)) + 3*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*fd*(K - 1)*(2*r - 1)*(s + 3) + 14*gd2*r*(s - 3)) + 42*fd*g2*k1**2*r*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(12*Pk2*k2**2*r*(1 - 4*r) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(72*s - 66) - 28*s + 19)) + 9*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) - 5*s - 3) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) - 3*s + 3))) + f*(-11*D1*bd1*(5*f**2*(-12*Pk2*k2**2*r*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(6*s - 7) - 22*s + 14)) + 9*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(s + 5) - 2*s) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 3) - 3*s + 3)) + 10*D1*f**2*fd*(4*r - 1)*(3*Pk2*k2**2*(7*r + 12) - 7*k1**2*(4*Pk2 - Pkd2*k2)*(6*s - 7)) + 198*D1*f*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s + 5) - 2*s) + 198*D1*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*r - 1)*(s + 3) + 10*Dd*f**3*(4*r - 1)*(3*Pk2*k2**2*(7*r + 12) - 7*k1**2*(4*Pk2 - Pkd2*k2)*(6*s - 7)) + 198*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) - 5*s - 3)))/(3465*d**2*k1**2*k2) - 2*D1**3*Pkd1*ct**5*(3*D1*bd1*f*(14*b1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*r*(s + 1) - 3*s) + 3*f*(-26*Pk2*k2**4*r*(r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(s + 5) + 3*s - 5) + r*(3*s - 20) - 19*s + 20) + k1**2*k2**2*(2*Pk2*(C*(22*r**2 - 2*r*(s + 25) - 44*s + 24) - 27*r**2 + 19*r*s + 35*r + 11*s - 4) + Pkd2*k2*(C*(-42*r*s + 32*r + 52*s - 28) + 25*r*s - 12*r - 19*s + 8)))) + 42*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*r*s + Dd*f*(r*(4*s + 2) - 3*s)) + 9*b1*f*(2*D1*fd*(-26*Pk2*k2**4*r**2 + k1**4*r*(4*Pk2 - Pkd2*k2)*(2*C*(s + 3) + 3*s - 12) + k1**2*k2**2*(2*Pk2*(-C*s + r**2*(22*C - 27) + r*(-2*C*s + 2*C + 19*s - 14) + s) + Pkd2*k2*(r*(-42*C*s + 20*C + 25*s - 8) + s*(C - 1)))) + Dd*f*(26*Pk2*k2**4*r*(1 - 4*r) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(4*r*(s + 4) + 3*s - 5) + 4*r*(3*s - 16) - 19*s + 20) + k1**2*k2**2*(2*Pk2*(C*(88*r**2 - 8*r*s - 66*r - 50*s + 24) - 108*r**2 + 76*r*s + 7*r + 17*s - 4) + Pkd2*k2*(C*(-168*r*s + 96*r + 58*s - 28) + (4*r - 1)*(25*s - 8))))) + f**2*(D1*fd*(2*Pk2*k2**4*(-180*r**2 + 3*r + 19) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*r - 1)*(2*C*(3*s + 5) - 3*s - 20) + k1**2*k2**2*(2*Pk2*(2*C*(45*r**2 - 90*r*s + 153*r + 48*s - 62) - 90*r**2 + 405*r*s - 723*r - 171*s + 263) - 5*Pkd2*k2*(3*r - 1)*(4*C*(12*s - 7) - 33*s + 8))) + Dd*f*(-2*Pk2*k2**4*(240*r**2 + 16*r - 19) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*C*r*(6*s + 11) - 10*C*(s + 1) - 4*r*(3*s + 22) + 11*s + 20) + k1**2*k2**2*(2*Pk2*(2*C*(60*r**2 - 120*r*s + 159*r + 104*s - 62) - 120*r**2 + 540*r*s - 914*r - 243*s + 263) - 5*Pkd2*k2*(4*C*(48*r*s - 29*r - 11*s + 7) - 132*r*s + 28*r + 37*s - 8)))))/(315*d**2*k1**2*k2*k3**2) - D1**3*Pkd1*ct**4*f**2*st**2*(4*Pk2 - Pkd2*k2)*(33*D1*bd1*f*(5*r*(3*s - 2) - 24*s + 10) + 33*b1*(3*D1*fd*r*(15*s - 7) + Dd*f*(60*r*s - 31*r - 24*s + 10)) + 5*f*(D1*fd + Dd*f)*(244*r*s - 127*r - 6*s + 18))/(693*d**2*k1) - 4*D1**3*Pkd1*ct**4*f*st**2*(-9*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(6*r*(s - 2) - 17*s + 12) + r*(17 - 12*s) + 27*s - 17) + k2**2*(-2*Pk2*(-17*C*r + r**2*(17*C - 17) + 6*r*(s + 2) - 10*s + 5) + Pkd2*k2*(r*(6*s - 5) - 10*s + 5))) - 9*b1*(D1*fd*r*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(12*s - 13) - 24*s + 19) + 2*k2**2*(Pk2*(-r*(34*C - 34) - 12*s + 6) + 3*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(24*s - 37) - 17*s + 12) + r*(53 - 48*s) + 27*s - 17) + k2**2*(-2*Pk2*(r**2*(68*C - 68) + r*(-17*C + 24*s + 1) - 10*s + 5) + Pkd2*k2*(8*r*(3*s - 2) - 10*s + 5)))) + f*(D1*fd*(-k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(r*(36*s - 39) + 15*s + 4) + r*(168 - 180*s) - 57*s - 17) + k2**2*(2*Pk2*(C*(63*r**2 + 57*r - 26) - 63*r**2 + 36*r*(2*s - 3) + 12*s + 31) - Pkd2*k2*(r*(72*s - 51) + 12*s + 5))) + Dd*f*(-k1**2*(4*Pk2 - Pkd2*k2)*(3*C*(r*(48*s - 59) + 31*s + 4) + r*(253 - 240*s) - 125*s - 17) + k2**2*(2*Pk2*(C*(84*r**2 + 83*r - 26) - 84*r**2 + 96*r*s - 159*r + 32*s + 31) - Pkd2*k2*(r*(96*s - 76) + 32*s + 5)))))/(315*d**2*k1*k3**2) + D1**3*Pkd1*ct**4*(-33*b1**2*(-2*D1*fd*r*(-k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(5*s - 6) + 7*s - 7) + k2**2*(2*Pk2*(6*f*(2*r - 5*s + 3) - 7*r*(6*K - 6) - 7*s + 7) + Pkd2*k2*(6*f*(5*s - 3) + 7*s - 7))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(12*r*(5*s - 8) - 39*s + 30) + 28*r*(2*s - 5) - 42*s + 42) - 2*k2**2*(6*Pk2*f*(8*r**2 + r*(10 - 20*s) + 13*s - 5) - 14*Pk2*(r**2*(24*K - 24) + r*(-6*K + 4*s - 4) - 3*s + 3) + 3*Pkd2*f*k2*(4*r*(5*s - 3) - 13*s + 5) + 7*Pkd2*k2*(2*r*(2*s - 5) - 3*s + 3)))) - 11*b1*(3*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(30*r*(s - 2) - 39*s + 30) + 28*r*(s - 3) - 42*s + 42) - 2*k2**2*(6*Pk2*f*(4*r**2 + r*(4 - 10*s) + 13*s - 5) - 14*Pk2*(6*K*r*(2*r - 1) - 12*r**2 + 2*r*s - 3*s + 3) + 3*Pkd2*f*k2*(2*r*(5*s - 3) - 13*s + 5) + 7*Pkd2*k2*(2*r*(s - 3) - 3*s + 3))) + D1*(-1008*Pk2*fd*g2*k2**2*r**2 + f**2*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(6*r - 1)*(3*s - 10) + k2**2*(6*Pk2*(90*r**2 + r*(30*s - 103) - 10*s + 36) + 5*Pkd2*k2*(3*r*(39*s - 8) + 6*s - 10))) - 6*f*(168*Pk2*gd2*k2**2*r**2 + fd*(2*r - 1)*(3*k1**2*(4*Pk2 - Pkd2*k2)*(s + 3) + k2**2*(Pk2*(-2*K*(9*r + 13) + 18*r + 6*s + 44) - 3*Pkd2*k2*(s + 3))))) + Dd*f*(1008*Pk2*g2*k2**2*r*(1 - 4*r) + f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(3*s - 11) - 7*s + 12) + k2**2*(Pk2*(720*r**2 + 240*r*s - 694*r + 470*s - 4) + 5*Pkd2*k2*(156*r*s - 40*r - 47*s + 12))) - 6*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) - 5*s - 3) + k2**2*(Pk2*(K*(-72*r**2 - 86*r + 26) + 72*r**2 + 24*r*s + 182*r - 30*s - 44) + 3*Pkd2*k2*(-4*r*(s + 4) + 5*s + 3))))) + f*(264*D1*Pk2*f*gd2*k2**2*r*(9*r + 13) + 264*D1*Pk2*fd*g2*k2**2*(18*r**2 + 17*r - 13) - 11*D1*bd1*(-1008*Pk2*g2*k2**2*r*(r - 1) + f**2*(5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(6*s - 28) - 11*s + 14) + k2**2*(2*Pk2*(90*r**2 + 30*r*s - 38*r + 265*s - 110) + 5*Pkd2*k2*(39*r*s - 16*r - 53*s + 22))) - 6*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s + 5) - 2*s) + k2**2*(-2*Pk2*(r**2*(9*K - 9) + r*(13*K - 3*s - 28) + 6*s) - 3*Pkd2*k2*(r*(s + 5) - 2*s)))) - 5*D1*f**2*fd*(7*k1**2*(4*Pk2 - Pkd2*k2)*(4*r - 1)*(s - 14) + k2**2*(2*Pk2*(896*r**2 - 745*r - 55*s + 144) + 77*Pkd2*k2*(4*r - 1)*(5*s - 2))) + 264*Dd*Pk2*f*g2*k2**2*(36*r**2 + 43*r - 13) - 5*Dd*f**3*(7*k1**2*(4*Pk2 - Pkd2*k2)*(4*r - 1)*(s - 14) + k2**2*(2*Pk2*(896*r**2 - 745*r - 55*s + 144) + 77*Pkd2*k2*(4*r - 1)*(5*s - 2)))))/(3465*d**2*k1*k2**2) + 2*D1**3*Pkd1*ct**4*(3*D1*bd1*f*(-7*b1*k1**2*k2**2*(2*Pk2 - Pkd2*k2)*(2*r*(C*(6*s - 4) - 5*s + 5) + s*(2*C - 5)) + 7*b1*k2**4*(Pk2*r*(24 - 24*C)*(2*r - 1) + Pkd2*k2*(2*r*(s + 1) - 3*s)) + 3*f*k1**4*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + 3*s - 5) + 3*f*k1**2*k2**2*(Pk2*(4*C*(5*r**2 + 2*r*s + 23*r + 30*s - 24) - 35*r**2 - 32*r*s - 47*r - 90*s + 62) + Pkd2*k2*(C*(70*r*s - 64*r - 76*s + 56) - 76*r*s + 50*r + 63*s - 40)) + f*k2**4*(Pk2*(r**2*(156*C - 81) + r*(-244*C - 108*s + 175) + 12*s - 6) + 3*Pkd2*k2*(r*(11 - 15*s) + 16*s - 9))) + 21*b1**2*k2**2*(D1*fd*r*(Pk2*k1**2*s*(10 - 12*C) + Pk2*k2**2*r*(24 - 24*C) + Pkd2*k1**2*k2*s*(6*C - 5) + Pkd2*k2**3*s) + Dd*f*(-k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(4*C*(3*s - 1) - 10*s + 5) + s*(2*C - 5)) + k2**2*(Pk2*r*(24 - 24*C)*(4*r - 1) + Pkd2*k2*(r*(4*s + 2) - 3*s)))) + 3*b1*f*(D1*fd*(24*Pk2*k1**4*r*(s + 3) + 6*Pk2*k1**2*k2**2*(r**2*(20*C - 35) + r*(8*C*s + 6*C - 32*s + 28) + s*(18*C - 19)) + 2*Pk2*k2**4*(2*C*(78*r**2 - 17*r + 13) - 81*r**2 - 108*r*s + 88*r - 26) - 6*Pkd2*k1**4*k2*r*(s + 3) + 3*Pkd2*k1**2*k2**3*(4*r*(5*C*(7*s - 4) - 38*s + 16) + s*(19 - 18*C)) + 3*Pkd2*k2**5*(r*(14 - 30*s) + s)) + Dd*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 3*s - 5) + 3*k1**2*k2**2*(Pk2*(4*C*(20*r**2 + 8*r*s + 46*r + 43*s - 24) - 140*r**2 - 128*r*s - 33*r - 148*s + 62) + 2*Pkd2*k2*(C*(140*r*s - 96*r - 51*s + 28) - 152*r*s + 72*r + 46*s - 20)) + k2**4*(Pk2*(52*C*(12*r**2 - 7*r + 1) - 324*r**2 - 432*r*s + 409*r + 12*s - 58) + 3*Pkd2*k2*(r*(32 - 60*s) + 19*s - 9)))) + f**2*(D1*fd*(5*k1**4*(4*Pk2 - Pkd2*k2)*(3*r - 1)*(3*s + 5) + k1**2*k2**2*(Pk2*(4*C*(180*r**2 + 9*r*(35*s - 4) - 132*s + 1) - 1395*r**2 - 45*r*(34*s - 37) + 654*s - 448) + 5*Pkd2*k2*(3*r - 1)*(C*(60*s - 56) - 75*s + 40)) + k2**4*(4*C*Pk2*(225*r**2 + 12*r - 29) - 3*Pk2*(345*r**2 + r*(240*s - 307) - 92*s + 68) - 45*Pkd2*k2*(3*r - 1)*(2*s - 1))) + Dd*f*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s + 11) - 5*s - 5) + k1**2*k2**2*(Pk2*(4*C*(240*r**2 + 420*r*s + 57*r - 226*s + 1) - 1860*r**2 - 2040*r*s + 1755*r + 1012*s - 448) + 5*Pkd2*k2*(4*C*(60*r*s - 58*r - 13*s + 14) - 300*r*s + 158*r + 77*s - 40)) + k2**4*(Pk2*(4*C*(300*r**2 + 41*r - 29) - 1380*r**2 - 960*r*s + 1043*r + 358*s - 204) - 45*Pkd2*k2*(4*r - 1)*(2*s - 1)))))/(315*d**2*k1*k2**2*k3**2) + D1**3*Pkd1*ct**3*f*k2*st**4*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(3*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 3*b1*(6*D1*fd*r*(2*s - 1) + Dd*f*(8*r*(3*s - 2) - 10*s + 5)) + f*(D1*fd*(18*r*s - 9*r + 18*s - 5) + Dd*f*(24*r*s - 14*r + 28*s - 5)))/(105*d**2*k3**2) - 2*D1**3*Pkd1*ct**3*st**2*(33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*r*(-7*K*s + 7*K + 36*f*(2*s - 1) + 7*s - 7) + Dd*f*(6*f*(8*r*(3*s - 2) - 10*s + 5) + (7 - 7*K)*(2*r*(2*s - 5) - 3*s + 3))) + 11*b1*(3*D1*bd1*f*k1**2*(4*Pk2 - Pkd2*k2)*(6*f*(2*r*(6*s - 5) - 10*s + 5) + (7 - 7*K)*(2*r*(s - 3) - 3*s + 3)) + D1*(2*f**2*fd*(45*Pk2*k2**2*r**2 + k1**2*(4*Pk2 - Pkd2*k2)*(9*r*(24*s - 17) + 12*s + 5)) - 3*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*r*(s - 4) + 13*s - 3) - 14*gd2*r*(s - 3)) + 42*fd*g2*k1**2*r*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(2*f**2*(15*Pk2*k2**2*r*(4*r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(24*s - 19) - 64*s + 55)) - 3*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 37*s - 3) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) - 3*s + 3))) + f*(11*D1*bd1*(2*f**2*(15*Pk2*k2**2*r*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(72*s - 75) - 76*s + 50)) - 3*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + 12*s) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 3) - 3*s + 3)) + 10*D1*f**2*fd*(3*Pk2*k2**2*(140*r**2 - 59*r + 6) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(8*r*(19*s - 13) + 6*s + 15)) + 66*D1*f*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + 12*s) + 66*D1*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 13*s - 3) + 10*Dd*f**3*(3*Pk2*k2**2*(140*r**2 - 59*r + 6) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(8*r*(19*s - 13) + 6*s + 15)) + 66*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 37*s - 3)))/(3465*d**2*k1**2*k2) + 2*D1**3*Pkd1*ct**3*(-231*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*r*s + Dd*f*(r*(4*s + 2) - 3*s)) - 33*b1**2*(7*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(r*(3*s + 2) - 3*s) + D1*fd*(-Pk2*k2**2*r**2*(72*f + 77) + k1**2*(Pk2*(-12*f*r*(4*s + 3) + r**2*(60*f - 21) + 14*r*(K*(s + 3) + s - 5) + s*(-56*K + 6*f + 56)) + Pkd2*k2*(12*f*r*(9*s - 2) - 3*f*s - 14*r*(K*(5*s - 3) - 4*s + 2) + s*(28*K - 28)))) - Dd*Pk2*f*k2**2*r*(36*f + 77)*(4*r - 1) + Dd*f*k1**2*(6*Pk2*f*(20*r**2 + r*(5 - 16*s) + 10*s - 4) + 7*Pk2*(2*K*(r*(4*s - 17) - 16*s + 8) - 12*r**2 + r*(8*s - 3) + 20*s - 4) + 6*Pkd2*f*k2*(12*r*(3*s - 1) - 5*s + 2) - 14*Pkd2*k2*(K*(4*r*(5*s - 4) - 9*s + 5) + r*(6 - 16*s) + 6*s - 2))) - 11*b1*(-324*D1*K*Pk2*f*fd*k1**2*r*s - 90*D1*K*Pk2*f*fd*k1**2*r + 204*D1*K*Pk2*f*fd*k1**2*s + 24*D1*K*Pk2*f*fd*k1**2 - 108*D1*K*Pkd2*f*fd*k1**2*k2*r*s + 180*D1*K*Pkd2*f*fd*k1**2*k2*r + 54*D1*K*Pkd2*f*fd*k1**2*k2*s - 90*D1*K*Pkd2*f*fd*k1**2*k2 + 42*D1*Pk2*bd2*f*k1**2*r*s - 126*D1*Pk2*bd2*f*k1**2*r + 720*D1*Pk2*f**2*fd*k1**2*r**2 - 270*D1*Pk2*f**2*fd*k1**2*r*s - 228*D1*Pk2*f**2*fd*k1**2*r + 54*D1*Pk2*f**2*fd*k1**2*s + 108*D1*Pk2*f**2*fd*k1**2 - 216*D1*Pk2*f**2*fd*k2**2*r + 72*D1*Pk2*f**2*fd*k2**2 + 162*D1*Pk2*f*fd*k1**2*r**2 + 252*D1*Pk2*f*fd*k1**2*r*s - 435*D1*Pk2*f*fd*k1**2*r - 168*D1*Pk2*f*fd*k1**2*s + 198*D1*Pk2*f*fd*k1**2 - 126*D1*Pk2*f*fd*k2**2*r**2 - 21*D1*Pk2*f*fd*k2**2*r + 42*D1*Pk2*f*fd*k2**2 - 84*D1*Pk2*f*gd2*k1**2*r*s + 504*D1*Pk2*f*gd2*k1**2*r + 168*D1*Pk2*f*gd2*k1**2*s - 84*D1*Pk2*fd*g2*k1**2*r*s - 252*D1*Pk2*fd*g2*k1**2*r + 336*D1*Pk2*fd*g2*k1**2*s - 21*D1*Pkd2*bd2*f*k1**2*k2*r*s + 63*D1*Pkd2*bd2*f*k1**2*k2*r + 945*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 330*D1*Pkd2*f**2*fd*k1**2*k2*r - 135*D1*Pkd2*f**2*fd*k1**2*k2*s + 20*D1*Pkd2*f**2*fd*k1**2*k2 + 144*D1*Pkd2*f*fd*k1**2*k2*r*s - 72*D1*Pkd2*f*fd*k1**2*k2*r - 72*D1*Pkd2*f*fd*k1**2*k2*s + 36*D1*Pkd2*f*fd*k1**2*k2 + 420*D1*Pkd2*f*gd2*k1**2*k2*r*s - 336*D1*Pkd2*f*gd2*k1**2*k2*r - 84*D1*Pkd2*f*gd2*k1**2*k2*s + 420*D1*Pkd2*fd*g2*k1**2*k2*r*s - 252*D1*Pkd2*fd*g2*k1**2*k2*r - 168*D1*Pkd2*fd*g2*k1**2*k2*s + 3*D1*bd1*f*(-Pk2*k2**2*r*(36*f + 77)*(2*r - 1) + k1**2*(6*Pk2*f*(10*r**2 + r*(11 - 8*s) + 9*s - 4) + 7*Pk2*(4*K*(r*(s - 7) - 5*s + 4) - 6*r**2 + 4*r*s + 7*r + 8*s - 4) + 3*Pkd2*f*k2*(4*r - 1)*(9*s - 4) - 14*Pkd2*k2*(K*(10*r*s - 9*r - 6*s + 5) - 8*r*s + 3*r + 3*s - 2))) - 648*Dd*K*Pk2*f**2*k1**2*r*s - 450*Dd*K*Pk2*f**2*k1**2*r + 516*Dd*K*Pk2*f**2*k1**2*s + 24*Dd*K*Pk2*f**2*k1**2 - 216*Dd*K*Pkd2*f**2*k1**2*k2*r*s + 396*Dd*K*Pkd2*f**2*k1**2*k2*r + 18*Dd*K*Pkd2*f**2*k1**2*k2*s - 90*Dd*K*Pkd2*f**2*k1**2*k2 + 960*Dd*Pk2*f**3*k1**2*r**2 - 360*Dd*Pk2*f**3*k1**2*r*s - 104*Dd*Pk2*f**3*k1**2*r + 402*Dd*Pk2*f**3*k1**2*s - 112*Dd*Pk2*f**3*k1**2 - 288*Dd*Pk2*f**3*k2**2*r + 72*Dd*Pk2*f**3*k2**2 + 324*Dd*Pk2*f**2*k1**2*r**2 + 504*Dd*Pk2*f**2*k1**2*r*s - 663*Dd*Pk2*f**2*k1**2*r - 336*Dd*Pk2*f**2*k1**2*s + 198*Dd*Pk2*f**2*k1**2 - 252*Dd*Pk2*f**2*k2**2*r**2 - 105*Dd*Pk2*f**2*k2**2*r + 42*Dd*Pk2*f**2*k2**2 - 336*Dd*Pk2*f*g2*k1**2*r*s + 1428*Dd*Pk2*f*g2*k1**2*r + 1344*Dd*Pk2*f*g2*k1**2*s - 672*Dd*Pk2*f*g2*k1**2 + 1260*Dd*Pkd2*f**3*k1**2*k2*r*s - 490*Dd*Pkd2*f**3*k1**2*k2*r - 345*Dd*Pkd2*f**3*k1**2*k2*s + 130*Dd*Pkd2*f**3*k1**2*k2 + 288*Dd*Pkd2*f**2*k1**2*k2*r*s - 108*Dd*Pkd2*f**2*k1**2*k2*r - 108*Dd*Pkd2*f**2*k1**2*k2*s + 36*Dd*Pkd2*f**2*k1**2*k2 + 1680*Dd*Pkd2*f*g2*k1**2*k2*r*s - 1344*Dd*Pkd2*f*g2*k1**2*k2*r - 756*Dd*Pkd2*f*g2*k1**2*k2*s + 420*Dd*Pkd2*f*g2*k1**2*k2 + 21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*r*(s - 1) + Dd*f*(4*r*s - 10*r - 3*s + 3))) + f*(-11*D1*bd1*(f**2*(-72*Pk2*k2**2*r + k1**2*(2*Pk2*(120*r**2 - 45*r*s + 62*r + 174*s - 110) + 5*Pkd2*k2*(63*r*s - 32*r - 42*s + 22))) + 3*f*(-7*Pk2*k2**2*r*(3*r + 2) + k1**2*(Pk2*(27*r**2 - 2*r*(3*K*(9*s + 10) - 21*s + 19) + s*(52*K - 28)) - 6*Pkd2*k2*(3*K*r*(s - 2) - 4*r*s + r + s*(K + 1)))) + 84*g2*k1**2*(Pk2*(-r*s + 8*r + 8*s - 8) + 5*Pkd2*k2*(r - 1)*(s - 1))) - 33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*(r*(s - 3) - 3*s + 3) - 3*D1*fd*(2*r - 1)*(s + 3) + 3*Dd*f*(-4*r*(s + 4) + 5*s + 3)) + k1**2*(D1*(-10*f**2*fd*(Pk2*(532*r**2 - 57*r - 44*s - 8) + 77*Pkd2*k2*(4*r - 1)*(2*s - 1)) + 33*f*(3*bd2*(2*Pk2 - Pkd2*k2)*(r*(s + 5) - 2*s) - 4*gd2*(Pk2*(3*r*(9*s + 10) - 26*s) + 3*Pkd2*k2*(3*r*(s - 2) + s))) - 132*fd*g2*(Pk2*(54*r*s + 15*r - 34*s - 4) + 3*Pkd2*k2*(2*r - 1)*(3*s - 5))) - 2*Dd*(5*f**3*(Pk2*(532*r**2 - 57*r - 44*s - 8) + 77*Pkd2*k2*(4*r - 1)*(2*s - 1)) + 66*f*g2*(Pk2*(108*r*s + 75*r - 86*s - 4) + 3*Pkd2*k2*(12*r*s - 22*r - s + 5))))))/(3465*d**2*k1**2*k2) - 2*D1**3*Pkd1*ct**3*st**2*(-3*D1*bd1*f*(-14*b1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*r*(s + 1) - 3*s) + f*(66*Pk2*k2**4*r*(r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(s - 9) - 11*s + 9) + r*(54 - 20*s) + 73*s - 54) + k1**2*k2**2*(2*Pk2*(2*C*(9*r**2 - 23*r*s + 49*r + 108*s - 60) + 3*r**2 - 44*r*s - 23*r - 45*s + 24) + Pkd2*k2*(2*C*(77*r*s - 61*r - 114*s + 63) - 64*r*s + 26*r + 57*s - 30)))) + 42*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*r*s + Dd*f*(r*(4*s + 2) - 3*s)) - 3*b1*f*(D1*fd*(132*Pk2*k2**4*r**2 + k1**4*r*(4*Pk2 - Pkd2*k2)*(4*C*(s - 4) - 40*s + 55) + k1**2*k2**2*(2*Pk2*(r**2*(36*C + 6) + r*(-92*C*s + 48*C - 88*s + 63) + s*(26*C - 26)) + Pkd2*k2*(r*(4*C*(77*s - 39) - 128*s + 45) + s*(26 - 26*C)))) + Dd*f*(66*Pk2*k2**4*r*(4*r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(4*s - 26) - 11*s + 9) + r*(163 - 80*s) + 73*s - 54) + k1**2*k2**2*(2*Pk2*(2*C*(36*r**2 - 92*r*s + 121*r + 133*s - 60) + 12*r**2 - 176*r*s + 40*r - 95*s + 24) + Pkd2*k2*(2*C*(308*r*s - 190*r - 139*s + 63) - 256*r*s + 77*r + 107*s - 30)))) + f**2*(D1*fd*(2*Pk2*k2**4*(9*r**2 - 15*r + 4) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(9*r*(s - 1) + 3*s + 1) - 3*r*(18*s - 19) - 21*s - 6) + k1**2*k2**2*(2*Pk2*(C*(-270*r**2 + 72*r*s + 210*r + 552*s - 232) + 387*r**2 + 324*r*s - 726*r - 459*s + 316) + Pkd2*k2*(C*(r*(366 - 612*s) + 60*s - 74) + 9*r*(24*s - 5) - 153*s + 42))) + Dd*f*(2*Pk2*k2**4*(12*r**2 - 19*r + 4) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(2*r*(6*s - 7) + 7*s + 1) + r*(87 - 72*s) - 45*s - 6) + k1**2*k2**2*(-2*Pk2*(2*C*(180*r**2 - 48*r*s - 85*r - 412*s + 116) - 516*r**2 - 432*r*s + 898*r + 603*s - 316) - Pkd2*k2*(C*(816*r*s - 520*r + 20*s + 74) - 288*r*s + 39*r + 201*s - 42)))))/(315*d**2*k1**2*k2*k3**2) + 2*D1**3*Pkd1*ct**3*(3*D1*bd1*f*(7*b1*(11*Pk2*k2**4*r*(2*r - 1) - k1**4*(2*Pk2 - Pkd2*k2)*(2*r*(C*(8*s - 2) - 11*s + 4) + s*(3 - 4*C)) + k1**2*k2**2*(Pk2*(r**2*(24*C - 18) + r*(8*C*(9*s - 5) - 72*s + 37) - s*(8*C - 8)) + Pkd2*k2*(r*(24*C*s + 4*C - 26*s + 4) + s*(9 - 16*C)))) + f*(7*Pk2*k2**4*r*(8 - 3*r) + 3*k1**4*(Pk2*(4*C*(r*(s + 14) + 8*s - 12) - 25*r**2 + 2*r*s - 51*r - 62*s + 60) + Pkd2*k2*(4*C*(7*r*s - 8*r - 6*s + 7) - 60*r*s + 44*r + 43*s - 36)) + k1**2*k2**2*(Pk2*(4*C*(78*r**2 + 3*r*s - 106*r - 20*s + 20) - 528*r**2 - 354*r*s + 663*r + 104*s - 92) + 3*Pkd2*k2*(-2*C*(8*r*s - 11*r - 16*s + 9) - 44*r*s + 22*r + 25*s - 18)))) - 21*b1**2*(D1*fd*r*(-11*Pk2*k2**4*r + k1**4*s*(8*C - 11)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(9 - 12*C) - Pk2*s*(36*C - 36) + Pkd2*k2*s*(13 - 12*C))) + Dd*f*(11*Pk2*k2**4*r*(1 - 4*r) + k1**4*(2*Pk2 - Pkd2*k2)*(4*r*(C*(8*s - 1) - 11*s + 2) + s*(3 - 4*C)) - k1**2*k2**2*(Pk2*(r**2*(48*C - 36) + r*(8*C*(18*s - 5) - 144*s + 37) - s*(8*C - 8)) + Pkd2*k2*(4*r*(12*C*s + C - 13*s + 1) + s*(9 - 16*C))))) + 3*b1*f*(D1*fd*(7*Pk2*k2**4*(-6*r**2 + r - 2) - 3*k1**4*(-2*Pk2*(-25*r**2 + r*(4*C*s + 10*C + 2*s + 3) + s*(16*C - 25)) + Pkd2*k2*(-8*r*(7*C*s - 5*C - 15*s + 7) + s*(16*C - 25))) + k1**2*k2**2*(Pk2*(4*C*(156*r**2 + 6*r*s - 83*r - 52*s + 40) - 1056*r**2 - 708*r*s + 777*r + 208*s - 198) + 3*Pkd2*k2*(-4*r*(8*C*s - 7*C + 22*s - 7) + s*(23 - 12*C)))) + Dd*f*(-7*Pk2*k2**4*(12*r**2 - 11*r + 2) + 3*k1**4*(Pk2*(4*C*(4*r*s + 29*r + 18*s - 12) - 100*r**2 + 8*r*s - 89*r - 128*s + 60) + 4*Pkd2*k2*(C*(4*r*(7*s - 6) - 11*s + 7) - 60*r*s + 32*r + 19*s - 9)) - 2*k1**2*k2**2*(Pk2*(-2*C*(312*r**2 + 12*r*s - 229*r - 92*s + 60) + 1056*r**2 + 708*r*s - 825*r - 196*s + 145) + 3*Pkd2*k2*(C*(32*r*(s - 1) - 12*s + 9) + 88*r*s - 32*r - 26*s + 9)))) + f**2*(D1*fd*(90*Pk2*k2**4*r*(1 - 3*r) + k1**4*(Pk2*(4*C*(225*r*s + 105*r - 84*s - 32) - 675*r**2 - 1080*r*s + 297*r + 450*s - 54) + 5*Pkd2*k2*(3*r - 1)*(4*C*(3*s - 7) - 45*s + 36)) + k1**2*k2**2*(Pk2*(4*C*(45*r**2 - 270*r*s + 303*r + 108*s - 112) - 2205*r**2 - 1170*r*s + 1347*r + 444*s - 222) - 45*Pkd2*k2*(3*r - 1)*(C*(4*s - 2) + 3*s - 2))) + Dd*f*(90*Pk2*k2**4*r*(1 - 4*r) + k1**4*(Pk2*(100*C*r*(12*s + 7) - 8*C*(61*s + 16) - 900*r**2 - 3*r*(480*s - 37) + 690*s - 54) + 5*Pkd2*k2*(4*C*(r*(12*s - 29) - 2*s + 7) + (9 - 36*r)*(5*s - 4))) + k1**2*k2**2*(Pk2*(4*C*(60*r**2 - 360*r*s + 379*r + 144*s - 112) - 2940*r**2 - 1560*r*s + 1441*r + 572*s - 222) - 45*Pkd2*k2*(4*r - 1)*(C*(4*s - 2) + 3*s - 2)))))/(315*d**2*k1**2*k2*k3**2) - D1**3*Pkd1*ct**2*f**2*st**4*(4*Pk2 - Pkd2*k2)*(33*D1*bd1*f*(r*(3*s - 2) - 5*s + 2) + 33*b1*(D1*fd*r*(9*s - 4) + Dd*f*(12*r*s - 6*r - 5*s + 2)) + f*(D1*fd + Dd*f)*(r*(212*s - 86) + 57*s - 6))/(231*d**2*k1) - 2*D1**3*Pkd1*ct**2*f*st**4*(6*D1*b1*fd*r*(-k1**2*(C - 4)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2*(r*(2*C - 2) + 6*s - 3) + 3*Pkd2*k2*(1 - 2*s))) - 3*D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(s - 2) - 4*s + 2) + r*(9 - 8*s) + 18*s - 9) + k2**2*(Pk2*(-r**2*(4*C - 4) + 2*r*(2*C - 6*s + 3) + 20*s - 10) + Pkd2*k2*(r*(6*s - 5) - 10*s + 5))) - 3*Dd*b1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(4*s - 5) - 4*s + 2) + r*(26 - 32*s) + 18*s - 9) + k2**2*(-2*Pk2*(r**2*(8*C - 8) - 2*r*(C - 12*s + 7) - 10*s + 5) + Pkd2*k2*(8*r*(3*s - 2) - 10*s + 5))) + f*(D1*fd*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(3*r + 2)*(3*s - 1) + r*(15 - 36*s) - 30*s + 9) + k2**2*(2*Pk2*(22*C*(3*r - 1) + 18*r*s - 75*r + 18*s + 17) + Pkd2*k2*(r*(9 - 18*s) - 18*s + 5))) + Dd*f*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(r*(12*s - 5) + 10*s - 2) + r*(24 - 48*s) - 48*s + 9) + k2**2*(2*Pk2*(22*C*(4*r - 1) + 6*r*(4*s - 17) + 28*s + 17) + Pkd2*k2*(r*(14 - 24*s) - 28*s + 5)))))/(105*d**2*k1*k3**2) - D1**3*Pkd1*ct**2*st**2*(11*b1**2*(D1*fd*r*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(36*s - 39) + 14*s - 14) + k2**2*(-2*Pk2*(3*f*(4*r - 24*s + 13) + 7*r*(3*K - 3) - 14*s + 14) + Pkd2*k2*(-72*f*s + 39*f - 14*s + 14))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(r*(24*s - 37) - 17*s + 12) + 28*r*(2*s - 5) - 42*s + 42) - 2*k2**2*(6*Pk2*f*(4*r**2 + r*(12 - 24*s) + 17*s - 6) + 7*Pk2*(r**2*(12*K - 12) + r*(-3*K - 8*s + 23) + 6*s - 6) + 3*Pkd2*f*k2*(r*(24*s - 13) - 17*s + 6) + 7*Pkd2*k2*(2*r*(2*s - 5) - 3*s + 3)))) + 11*b1*(D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(36*r*(s - 2) - 51*s + 36) + 28*r*(s - 3) - 42*s + 42) + k2**2*(-6*Pk2*f*(4*r**2 + r*(11 - 24*s) + 34*s - 12) - 14*Pk2*(r**2*(6*K - 6) + r*(-3*K - 4*s + 15) + 6*s - 6) + Pkd2*f*k2*(-72*r*s + 39*r + 102*s - 36) + 14*Pkd2*k2*(-2*r*s + 6*r + 3*s - 3))) + D1*(84*Pk2*fd*g2*k2**2*r**2 + f**2*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(72*s - 78) + 15*s + 4) + k2**2*(6*Pk2*(126*r**2 + 24*r*s - 41*r + 10*s + 8) + Pkd2*k2*(198*r*s - 69*r - 30*s - 4))) + 2*f*(42*Pk2*gd2*k2**2*r**2 + fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 13*s - 3) + fd*k2**2*(Pk2*(K*(-34*r**2 + 69*r - 26) + 34*r**2 + 4*r*s - 85*r + 26*s + 20) + Pkd2*k2*(-2*r*(s - 4) - 13*s + 3)))) + 2*Dd*f*(42*Pk2*g2*k2**2*r*(4*r - 1) + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(48*s - 59) - s + 12) + k2**2*(2*Pk2*(252*r**2 + 48*r*s - 95*r + 76*s - 14) + Pkd2*k2*(132*r*s - 53*r - 76*s + 24))) + f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 37*s - 3) + k2**2*(Pk2*(K*(-68*r**2 + 121*r - 26) + 68*r**2 + 8*r*s - 173*r + 74*s + 20) + Pkd2*k2*(r*(26 - 4*s) - 37*s + 3))))) + f*(44*D1*Pk2*f*gd2*k2**2*r*(17*r - 26) + 44*D1*Pk2*fd*g2*k2**2*(34*r**2 - 69*r + 26) + 11*D1*bd1*(84*Pk2*g2*k2**2*r*(r - 1) + f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(8*r*(3*s - 5) - 17*s + 20) + k2**2*(2*Pk2*(126*r**2 + 24*r*s - 67*r + 122*s - 52) + Pkd2*k2*(66*r*s - 37*r - 122*s + 52))) + 2*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + 12*s) + k2**2*(Pk2*(r**2*(17 - 17*K) + 2*r*(13*K + s - 22) + 24*s) - Pkd2*k2*(r*(s - 9) + 12*s)))) + D1*f**2*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 7*s + 12) + 2*k2**2*(2*Pk2*(1720*r**2 - 761*r - 605*s + 234) + 55*Pkd2*k2*(4*r - 1)*(5*s - 2))) + 44*Dd*Pk2*f*g2*k2**2*(68*r**2 - 121*r + 26) + Dd*f**3*(5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 7*s + 12) + 2*k2**2*(2*Pk2*(1720*r**2 - 761*r - 605*s + 234) + 55*Pkd2*k2*(4*r - 1)*(5*s - 2)))))/(1155*d**2*k1*k2**2) + D1**3*Pkd1*ct**2*(21*b1**3*(D1*fd*r*(6*Pk2*k1**2*s + 4*Pk2*k2**2*r - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(4*r*(3*s - 1) + s) - k2**2*(4*Pk2*r*(1 - 4*r) + Pkd2*k2*(12*r*s - 4*r + s)))) + 3*b1**2*(-7*D1*bd1*f*(-k1**2*(2*Pk2 - Pkd2*k2)*(r*(9*s - 4) + s) + k2**2*(4*Pk2*r*(1 - 3*r) + Pkd2*k2*(9*r*s - 4*r + s))) + D1*fd*(2*Pk2*k1**2*(3*f*r*(36*s - 7) + 28*r*(s + 1) - s*(27*f + 56)) - 2*Pk2*k2**2*(-14*K*(11*r**2 - 10*r + 5) + f*(192*r**2 + r*(252*s - 139) + 26) + 126*r**2 + 98*r*s - 238*r + 70) + Pkd2*k1**2*k2*(r*(-234*f*s + 84*f - 126*s + 70) + s*(27*f + 56)) + Pkd2*k2**3*(r*(-306*f*s + 84*f - 126*s + 70) + s*(27*f + 56))) + Dd*f*k1**2*(18*Pk2*f*(r*(24*s - 17) - 13*s + 6) + 56*Pk2*(r*(4*s - 6) - 7*s + 3) - 9*Pkd2*f*k2*(4*r - 1)*(13*s - 6) + 14*Pkd2*k2*(r*(22 - 36*s) + 15*s - 7)) - Dd*f*k2**2*(4*Pk2*(-7*K*(44*r**2 - 31*r + 5) + f*(192*r**2 + r*(252*s - 163) + 13) + 252*r**2 + 196*r*s - 273*r - 7*s + 42) + Pkd2*k2*(3*f*(204*r*s - 64*r - 59*s + 18) + 504*r*s - 308*r - 210*s + 98))) + b1*(6*D1*bd1*f*(k1**2*(6*Pk2*f*(2*r*(9*s - 11) - 15*s + 9) + 28*Pk2*(r*(2*s - 5) - 4*s + 3) + Pkd2*k2*(-3*f*(39*r*s - 22*r - 15*s + 9) - 126*r*s + 84*r + 63*s - 49)) - k2**2*(Pk2*(f*r*(252*s - 187) + r**2*(-308*K + 192*f + 252) + 28*r*(8*K + 7*s - 8) - 14*s + 14) + Pkd2*k2*(3*f*(3*r*(17*s - 6) - 25*s + 9) + 42*r*(3*s - 2) - 63*s + 49))) + 3*D1*(28*Pk2*fd*k2**2*(b2*r**2 - 2*g2*(11*r**2 - 10*r + 5)) + f**2*fd*(k1**2*(2*Pk2*(75*r*s - 90*r - 16*s + 12) + 5*Pkd2*k2*(-69*r*s + 36*r + 14*s - 6)) - 6*k2**2*(3*Pk2*(30*r**2 + 30*r*s - 33*r - 12*s + 8) + 5*Pkd2*k2*(3*r - 1)*(3*s - 1))) + 2*f*(14*Pk2*k2**2*r*(bd2*r + gd2*(10 - 22*r)) + fd*(k1**2*(Pk2*(-6*r*(8*s + 3) + 38*s + 2) - 21*Pkd2*k2*(2*r - 1)*(s - 1)) + k2**2*(2*Pk2*(K*(18*r**2 + 17*r - 13) - 66*r**2 - 66*r*s + 92*r + 40*s - 33) - 21*Pkd2*k2*(2*r - 1)*(s - 1))))) + Dd*f*(84*Pk2*k2**2*(4*r - 1)*(b2*r + g2*(10 - 22*r)) + f**2*(k1**2*(2*Pk2*(300*r*s - 510*r - 149*s + 146) + 5*Pkd2*k2*(-276*r*s + 156*r + 73*s - 40)) - 18*k2**2*(6*Pk2*(20*r**2 + 20*r*s - 22*r - 8*s + 5) + 5*Pkd2*k2*(4*r - 1)*(3*s - 1))) - 6*f*(k1**2*(2*Pk2*(r*(48*s + 45) - 53*s - 1) + 21*Pkd2*k2*(4*r - 1)*(s - 1)) + k2**2*(Pk2*(K*(-72*r**2 - 86*r + 26) + 264*r**2 + 8*r*(33*s - 31) - 148*s + 66) + 21*Pkd2*k2*(4*r - 1)*(s - 1))))) - f*(12*D1*Pk2*f*k2**2*r*(bd2*(12*r - 13) + 2*gd2*(9*r + 13)) + 12*D1*Pk2*fd*k2**2*(2*r - 1)*(b2*(12*r - 13) + 2*g2*(9*r + 13)) + D1*bd1*(Pk2*k2**2*r*(-84*b2 + 1848*g2)*(r - 1) + f**2*(k1**2*(Pk2*(-150*r*s + 480*r + 202*s - 220) + 5*Pkd2*k2*(69*r*s - 48*r - 31*s + 22)) + 18*k2**2*(3*Pk2*(10*r**2 + 10*r*s - 11*r - 4*s + 2) + 5*Pkd2*k2*r*(3*s - 1))) + 6*f*(k1**2*(12*Pk2*r*(2*s + 3) - 34*Pk2*s + 21*Pkd2*k2*r*(s - 1)) + k2**2*(-2*Pk2*(r**2*(9*K - 33) + r*(13*K - 33*s + 16) + 17*s) + 21*Pkd2*k2*r*(s - 1)))) + 5*D1*f**2*fd*k1**2*(2*Pk2*(35*r - 3*s - 8) + 7*Pkd2*k2*(4*r - 1)*(3*s - 2)) + 12*Dd*Pk2*f*k2**2*(4*r - 1)*(b2*(12*r - 13) + 2*g2*(9*r + 13)) + 5*Dd*f**3*k1**2*(2*Pk2*(35*r - 3*s - 8) + 7*Pkd2*k2*(4*r - 1)*(3*s - 2))))/(315*d**2*k1*k2**2) + 2*D1**3*Pkd1*ct**2*st**2*(D1*bd1*f*(7*b1*k2**2*(-k1**2*(2*Pk2 - Pkd2*k2)*(r*(C*(4*s - 6) - 2*s + 8) + s*(4*C - 7)) + k2**2*(Pk2*r*(6*C - 6)*(2*r - 1) + Pkd2*k2*(2*r*(s + 1) - 3*s))) - f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(s - 9) - 11*s + 9) + k1**2*k2**2*(Pk2*(-2*C*(21*r**2 - 6*r*s + 105*r + 148*s - 124) + 102*r**2 + 76*r*s + 47*r + 172*s - 149) + Pkd2*k2*(-2*C*(36*r*s - 59*r - 80*s + 58) + 76*r*s - 68*r - 101*s + 68)) + k2**4*(Pk2*(r**2*(238 - 214*C) + r*(232*C + 96*s - 259) - 6*s + 3) + Pkd2*k2*(r*(41*s - 31) - 54*s + 33)))) + 7*b1**2*k2**2*(D1*fd*r*(Pk2*k1**2*s*(2 - 4*C) + Pk2*k2**2*r*(6*C - 6) + Pkd2*k1**2*k2*s*(2*C - 1) + Pkd2*k2**3*s) + Dd*f*(-k1**2*(2*Pk2 - Pkd2*k2)*(r*(C*(8*s - 6) - 4*s + 8) + s*(4*C - 7)) + k2**2*(Pk2*r*(6*C - 6)*(4*r - 1) + Pkd2*k2*(r*(4*s + 2) - 3*s)))) - b1*f*(D1*fd*(8*Pk2*k1**4*r*(s - 4) + 2*Pk2*k1**2*k2**2*(r**2*(102 - 42*C) + 4*r*(3*C*(s - 8) + 19*s + 1) + s*(21 - 8*C)) + 2*Pk2*k2**4*(C*(-214*r**2 + 69*r - 26) + 238*r**2 + 96*r*s - 117*r + 26) - 2*Pkd2*k1**4*k2*r*(s - 4) + Pkd2*k1**2*k2**3*(-2*r*(72*C*s - 67*C - 76*s + 45) + s*(8*C - 21)) + Pkd2*k2**5*(r*(82*s - 42) - 13*s)) + Dd*f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) - 11*s + 9) + k1**2*k2**2*(Pk2*(-2*C*(84*r**2 - 24*r*s + 309*r + 172*s - 124) + 408*r**2 + 4*r*(76*s + 37) + 270*s - 149) - 2*Pkd2*k2*(2*C*(8*r*(9*s - 11) - 46*s + 29) + r*(99 - 152*s) + 75*s - 34)) + k2**4*(Pk2*(C*(-856*r**2 + 422*r - 52) + 952*r**2 + 384*r*s - 548*r - 6*s + 55) + Pkd2*k2*(2*r*(82*s - 47) - 79*s + 33)))) + f**2*(D1*fd*(-k1**4*(4*Pk2 - Pkd2*k2)*(9*r*(s - 1) + 3*s + 1) + k1**2*k2**2*(Pk2*(2*C*(27*r**2 + 69*r - 144*s + 22) - 252*r**2 - 198*r*s + 261*r + 360*s - 157) + Pkd2*k2*(2*C*(63*r*s - 57*r + 6*s + 10) - 99*r*s + 54*r + 39*s - 20)) - k2**4*(4*C*Pk2*(9*r**2 - 33*r + 10) + 3*Pk2*(114*r**2 + r*(48*s - 77) - 58*s + 27) + 9*Pkd2*k2*(3*r - 1)*(2*s - 1))) + Dd*f*(-k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 7) + 7*s + 1) + k1**2*k2**2*(Pk2*(C*(72*r**2 + 238*r - 432*s + 44) - 336*r**2 - 264*r*s + 290*r + 488*s - 157) + Pkd2*k2*(2*C*(84*r*s - 83*r + 22*s + 10) - 132*r*s + 70*r + 43*s - 20)) - k2**4*(Pk2*(4*C*(12*r**2 - 43*r + 10) + 456*r**2 + 64*r*(3*s - 4) - 230*s + 81) + 9*Pkd2*k2*(4*r - 1)*(2*s - 1)))))/(105*d**2*k1*k2**2*k3**2) + 2*D1**3*Pkd1*ct**2*(3*D1*bd1*f*(7*b1*(2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) - s) + k1**2*k2**2*(Pk2*(r**2*(72*C - 110) + r*(8*C*(13*s - 9) - 132*s + 103) + s*(18 - 16*C)) + Pkd2*k2*(r*(8*C*(s + 1) - 38*s + 2) + s*(17 - 12*C))) + k2**4*(Pk2*(r**2*(48*C - 46) + r*(-24*C - 48*s + 35) + 12*s) + 5*Pkd2*k2*s*(1 - 2*r))) + f*(3*k1**4*(2*Pk2*(4*r*s - 10*r - 7*s + 8) + Pkd2*k2*(-15*r*s + 11*r + 9*s - 9)) + k1**2*k2**2*(Pk2*(4*C*(39*r**2 + 6*r*s - 57*r - 26*s + 26) - 522*r**2 - 408*r*s + 599*r + 150*s - 144) - 3*Pkd2*k2*(C*(46*r*s - 44*r - 50*s + 36) + 36*r*s - 11*r - 9*s + 9)) + k2**4*(Pk2*(r**2*(36*C - 210) + r*(52*C - 108*s + 173) + 34*s - 34) - 21*Pkd2*k2*r*s))) + 21*b1**2*(D1*fd*r*(k1**4*(8*Pk2*s - 4*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(36*C*r + 52*C*s - 55*r - 66*s) + Pkd2*k2*s*(4*C - 19)) - k2**4*(Pk2*r*(23 - 24*C) + 24*Pk2*s + 5*Pkd2*k2*s)) + Dd*f*(2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) - s) + k1**2*k2**2*(Pk2*(r**2*(144*C - 220) + r*(8*C*(26*s - 9) - 264*s + 103) + s*(18 - 16*C)) + Pkd2*k2*(2*r*(8*C*s + 4*C - 38*s + 1) + s*(17 - 12*C))) + k2**4*(Pk2*(r**2*(96*C - 92) + r*(-24*C - 96*s + 35) + 12*s) + 5*Pkd2*k2*s*(1 - 4*r)))) + 3*b1*f*(D1*fd*(6*k1**4*(Pk2*r*(8*s - 3) - 8*Pk2*s + Pkd2*k2*r*(7 - 15*s) + 4*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(4*C*(78*r**2 + 12*r*s - 45*r - 76*s + 27) - 1044*r**2 - 816*r*s + 865*r + 384*s - 212) + 3*Pkd2*k2*(r*(-92*C*s + 56*C - 72*s + 14) + s*(4*C + 29))) + k2**4*(Pk2*(C*(72*r**2 + 68*r - 52) - 420*r**2 - 216*r*s + 259*r + 122*s - 56) + 21*Pkd2*k2*s*(1 - 2*r))) + Dd*f*(3*k1**4*(2*Pk2*(r*(16*s - 19) - 17*s + 8) + Pkd2*k2*(r*(32 - 60*s) + 19*s - 9)) + k1**2*k2**2*(2*Pk2*(2*C*(156*r**2 + 3*r*(8*s - 43) - 128*s + 53) - 1044*r**2 + r*(841 - 816*s) + 336*s - 178) - 3*Pkd2*k2*(2*C*(r*(92*s - 64) - 31*s + 18) + 16*r*(9*s - 2) - 40*s + 9)) + k2**4*(2*Pk2*(C*(72*r**2 + 86*r - 26) - 420*r**2 - 216*r*s + 244*r + 95*s - 45) + 21*Pkd2*k2*s*(1 - 4*r)))) - f**2*(D1*fd*(135*Pk2*k2**4*r*(3*r - 1) + k1**4*(2*Pk2*(30*r*(3*s + 2) - 39*s - 17) + 45*Pkd2*k2*(3*r - 1)*(s - 1)) + k1**2*k2**2*(Pk2*(4*C*(180*r**2 + 405*r*s - 336*r - 162*s + 101) + 945*r**2 + 450*r*s - 465*r - 168*s + 56) + 45*Pkd2*k2*(3*r - 1)*(C*(6*s - 4) + s - 1))) + Dd*f*(135*Pk2*k2**4*r*(4*r - 1) + k1**4*(2*Pk2*(20*r*(6*s + 5) - 62*s - 17) + 45*Pkd2*k2*(4*r - 1)*(s - 1)) + k1**2*k2**2*(Pk2*(4*C*(240*r**2 + 540*r*s - 383*r - 216*s + 101) + 1260*r**2 + 600*r*s - 475*r - 214*s + 56) + 45*Pkd2*k2*(4*r - 1)*(C*(6*s - 4) + s - 1)))))/(315*d**2*k1*k2**2*k3**2) - 2*D1**3*Pkd1*ct*f*st**4*(33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(6*D1*fd*r*(2*s - 1) + Dd*f*(8*r*(3*s - 2) - 10*s + 5)) + 11*b1*f*(3*D1*bd1*k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) - 10*s + 5) + D1*fd*(90*Pk2*k2**2*r**2 + k1**2*(4*Pk2 - Pkd2*k2)*(27*r*(2*s - 1) + 18*s - 5)) + Dd*f*(30*Pk2*k2**2*r*(4*r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(12*s - 7) + 4*s + 5))) + f**2*(11*D1*bd1*(30*Pk2*k2**2*r*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(6*s - 5) - 14*s + 10)) + (2*D1*fd + 2*Dd*f)*(30*Pk2*k2**2*(1 - 4*r)**2 + k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(46*s - 17) + 42*s - 5))))/(1155*d**2*k1**2*k2) - 2*D1**3*Pkd1*ct*f*st**4*(3*D1*bd1*f*(4*Pk2*k2**4*r*(r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(s - 2) - 4*s + 2) + k1**2*k2**2*(4*C*Pk2*(r**2 + r*(10*s - 7) - 12*s + 6) + 2*C*Pkd2*k2*(r*(5 - 6*s) + 10*s - 5) - 2*Pk2*r*(4*r + 7*s - 4) + Pkd2*k2*(-r*(s - 2) + 4*s - 2))) + 3*b1*(D1*fd*r*(8*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(4*C*(r + 10*s - 5) - 8*r - 14*s + 7) - Pkd2*k2*(12*C + 1)*(2*s - 1))) + Dd*f*(4*Pk2*k2**4*r*(4*r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 5) - 4*s + 2) + k1**2*k2**2*(4*C*Pk2*(4*r**2 + r*(40*s - 23) - 12*s + 6) + 2*C*Pkd2*k2*(-8*r*(3*s - 2) + 10*s - 5) - 2*Pk2*r*(16*r + 28*s - 11) + Pkd2*k2*(r*(5 - 4*s) + 4*s - 2)))) + f*(D1*fd*(2*Pk2*k2**4*(9*r**2 - 24*r + 7) + k1**4*(4*Pk2 - Pkd2*k2)*(3*r + 2)*(3*s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(9*r**2 + 18*r*s - 9*r + 24*s - 8) - 9*r**2 + 9*r*s - 39*r - 6*s + 15) + Pkd2*k2*(-2*C*(18*r*s - 9*r + 18*s - 5) - (3*r + 2)*(3*s - 1)))) + Dd*f*(2*Pk2*k2**4*(12*r**2 - 31*r + 7) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 10*s - 2) + k1**2*k2**2*(4*C*Pk2*(12*r**2 + r*(24*s - 13) + 36*s - 8) - 6*Pk2*(4*r**2 + r*(18 - 4*s) + 2*s - 5) + Pkd2*k2*(C*(-48*r*s + 28*r - 56*s + 10) - 12*r*s + 5*r - 10*s + 2)))))/(105*d**2*k1**2*k2*k3**2) - 2*D1**3*Pkd1*ct*st**2*(77*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*r*s + Dd*f*(r*(4*s + 2) - 3*s)) + 11*b1**2*(7*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(r*(3*s + 2) - 3*s) + D1*fd*(Pk2*k2**2*r**2*(108*f + 28) + k1**2*(2*Pk2*(39*f*r**2 + 13*f*s + r*(s - 1)*(21*K + 8*f - 7)) + Pkd2*k2*(f*r*(76*s - 34) - 13*f*s + r*(-7*K - 7)*(s - 1)))) + 2*Dd*Pk2*f*k2**2*r*(27*f + 14)*(4*r - 1) + Dd*f*k1**2*(Pk2*f*(156*r**2 + r*(32*s + 53) + 92*s - 48) + 14*Pk2*(K*(3*r*(4*s - 5) - 4*s + 4) - r*(4*s + 5) - 2*s + 2) + 2*Pkd2*f*k2*(r*(76*s - 44) - 23*s + 12) + Pkd2*k2*(-7*K - 7)*(2*r*(2*s - 5) - 3*s + 3))) + 11*b1*(-4*D1*K*Pk2*f*fd*k1**2*r*s - 26*D1*K*Pk2*f*fd*k1**2*r + 44*D1*K*Pk2*f*fd*k1**2*s - 8*D1*K*Pk2*f*fd*k1**2 - 2*D1*K*Pkd2*f*fd*k1**2*k2*r*s + 8*D1*K*Pkd2*f*fd*k1**2*k2*r - 13*D1*K*Pkd2*f*fd*k1**2*k2*s + 3*D1*K*Pkd2*f*fd*k1**2*k2 + 14*D1*Pk2*bd2*f*k1**2*r*s - 42*D1*Pk2*bd2*f*k1**2*r + 234*D1*Pk2*f**2*fd*k1**2*r**2 + 54*D1*Pk2*f**2*fd*k1**2*r*s - 69*D1*Pk2*f**2*fd*k1**2*r - 90*D1*Pk2*f**2*fd*k1**2*s + 54*D1*Pk2*f**2*fd*k1**2 + 162*D1*Pk2*f**2*fd*k2**2*r**2 - 90*D1*Pk2*f**2*fd*k2**2*r + 12*D1*Pk2*f**2*fd*k2**2 + 44*D1*Pk2*f*fd*k1**2*r**2 + 12*D1*Pk2*f*fd*k1**2*r*s - 92*D1*Pk2*f*fd*k1**2*r + 8*D1*Pk2*f*fd*k1**2*s + 28*D1*Pk2*f*fd*k1**2 + 36*D1*Pk2*f*fd*k2**2*r**2 - 50*D1*Pk2*f*fd*k2**2*r + 16*D1*Pk2*f*fd*k2**2 - 84*D1*Pk2*f*gd2*k1**2*r*s + 112*D1*Pk2*f*gd2*k1**2*r - 84*D1*Pk2*fd*g2*k1**2*r*s + 84*D1*Pk2*fd*g2*k1**2*r - 7*D1*Pkd2*bd2*f*k1**2*k2*r*s + 21*D1*Pkd2*bd2*f*k1**2*k2*r + 135*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 72*D1*Pkd2*f**2*fd*k1**2*k2*r - 27*D1*Pkd2*f**2*fd*k1**2*k2*s + 8*D1*Pkd2*f**2*fd*k1**2*k2 - 2*D1*Pkd2*f*fd*k1**2*k2*r*s + 8*D1*Pkd2*f*fd*k1**2*k2*r - 13*D1*Pkd2*f*fd*k1**2*k2*s + 3*D1*Pkd2*f*fd*k1**2*k2 + 14*D1*Pkd2*f*gd2*k1**2*k2*r*s - 42*D1*Pkd2*f*gd2*k1**2*k2*r + 14*D1*Pkd2*fd*g2*k1**2*k2*r*s - 14*D1*Pkd2*fd*g2*k1**2*k2*r + D1*bd1*f*(Pk2*k2**2*r*(54*f + 28)*(2*r - 1) + k1**2*(Pk2*f*(78*r**2 + r*(16*s + 69) + 66*s - 48) + 28*Pk2*(K*(r*(3*s - 4) - 2*s + 2) - r*(s + 2) - s + 1) + Pkd2*f*k2*(r*(76*s - 54) - 33*s + 24) + Pkd2*k2*(-7*K - 7)*(2*r*(s - 3) - 3*s + 3))) - 8*Dd*K*Pk2*f**2*k1**2*r*s - 74*Dd*K*Pk2*f**2*k1**2*r + 108*Dd*K*Pk2*f**2*k1**2*s - 8*Dd*K*Pk2*f**2*k1**2 - 4*Dd*K*Pkd2*f**2*k1**2*k2*r*s + 26*Dd*K*Pkd2*f**2*k1**2*k2*r - 37*Dd*K*Pkd2*f**2*k1**2*k2*s + 3*Dd*K*Pkd2*f**2*k1**2*k2 + 312*Dd*Pk2*f**3*k1**2*r**2 + 72*Dd*Pk2*f**3*k1**2*r*s - 62*Dd*Pk2*f**3*k1**2*r - 42*Dd*Pk2*f**3*k1**2*s + 2*Dd*Pk2*f**3*k1**2 + 216*Dd*Pk2*f**3*k2**2*r**2 - 102*Dd*Pk2*f**3*k2**2*r + 12*Dd*Pk2*f**3*k2**2 + 88*Dd*Pk2*f**2*k1**2*r**2 + 24*Dd*Pk2*f**2*k1**2*r*s - 180*Dd*Pk2*f**2*k1**2*r + 40*Dd*Pk2*f**2*k1**2*s + 28*Dd*Pk2*f**2*k1**2 + 72*Dd*Pk2*f**2*k2**2*r**2 - 82*Dd*Pk2*f**2*k2**2*r + 16*Dd*Pk2*f**2*k2**2 - 336*Dd*Pk2*f*g2*k1**2*r*s + 420*Dd*Pk2*f*g2*k1**2*r + 112*Dd*Pk2*f*g2*k1**2*s - 112*Dd*Pk2*f*g2*k1**2 + 180*Dd*Pkd2*f**3*k1**2*k2*r*s - 106*Dd*Pkd2*f**3*k1**2*k2*r - 75*Dd*Pkd2*f**3*k1**2*k2*s + 34*Dd*Pkd2*f**3*k1**2*k2 - 4*Dd*Pkd2*f**2*k1**2*k2*r*s + 26*Dd*Pkd2*f**2*k1**2*k2*r - 37*Dd*Pkd2*f**2*k1**2*k2*s + 3*Dd*Pkd2*f**2*k1**2*k2 + 56*Dd*Pkd2*f*g2*k1**2*k2*r*s - 140*Dd*Pkd2*f*g2*k1**2*k2*r - 42*Dd*Pkd2*f*g2*k1**2*k2*s + 42*Dd*Pkd2*f*g2*k1**2*k2 + 7*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*r*(s - 1) + Dd*f*(2*r*(2*s - 5) - 3*s + 3))) + f*(11*D1*bd1*(f**2*(6*Pk2*k2**2*r*(9*r - 2) + k1**2*(Pk2*(78*r**2 + 18*r*s + 7*r + 48*s - 52) + Pkd2*k2*(45*r*s - 34*r - 48*s + 26))) + f*(2*Pk2*k2**2*r*(9*r - 8) + k1**2*(2*Pk2*(16*K*s + 11*r**2 - r*(K*(s + 12) - 3*s + 22) + 8*s) - Pkd2*k2*(K + 1)*(r*(s - 9) + 12*s))) + 14*g2*k1**2*(Pk2*(-6*r*s + 8*r + 8*s - 8) + Pkd2*k2*(r*(s - 3) - 3*s + 3))) + 11*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*(r*(s - 3) - 3*s + 3) + D1*fd*(2*r*(s - 4) + 13*s - 3) + Dd*f*(r*(4*s - 26) + 37*s - 3)) + k1**2*(D1*f**2*fd*(Pk2*(1300*r**2 - 309*r - 968*s + 238) + 110*Pkd2*k2*(4*r - 1)*(2*s - 1)) + 11*D1*f*(bd2*(2*Pk2 - Pkd2*k2)*(r*(s - 9) + 12*s) + 2*gd2*(2*Pk2*r*(s + 12) - 32*Pk2*s + Pkd2*k2*r*(s - 9) + 12*Pkd2*k2*s)) + 22*D1*fd*g2*(Pk2*(r*(4*s + 26) - 44*s + 8) + Pkd2*k2*(2*r*(s - 4) + 13*s - 3)) + Dd*f**3*(Pk2*(1300*r**2 - 309*r - 968*s + 238) + 110*Pkd2*k2*(4*r - 1)*(2*s - 1)) + 22*Dd*f*g2*(2*Pk2*(r*(4*s + 37) - 54*s + 4) + Pkd2*k2*(r*(4*s - 26) + 37*s - 3)))))/(1155*d**2*k1**2*k2) - 2*D1**3*Pkd1*ct*(7*b1**3*k1**2*(D1*fd*r*(8*Pk2*r + 10*Pk2*s + 9*Pkd2*k2*s) + Dd*f*(2*Pk2*r*(16*r + 20*s - 9) + Pkd2*k2*(36*r*s - 2*r - 7*s))) + b1**2*(7*D1*bd1*f*k1**2*(6*Pk2*r*(4*r + 5*s - 3) + Pkd2*k2*(r*(27*s - 2) - 7*s)) + D1*fd*(Pk2*k2**2*(2*f*(18*r**2 - 25*r + 8) + 77*r**2 - 84*r + 42) + k1**2*(Pk2*(4*f*(66*r**2 + r*(84*s - 47) - 14*s + 10) + 133*r**2 + 14*r*(K*(s - 5) + 9*s - 19) + 7*s*(8*K - 8) + 98) + Pkd2*k2*(6*f*r*(36*s - 7) - 45*f*s + r*(7*K + 7)*(9*s - 5) - s*(28*K + 28)))) + Dd*Pk2*f*k2**2*(4*r - 1)*(2*f*(9*r - 8) + 77*r - 42) + Dd*f*k1**2*(4*Pk2*f*(132*r**2 + r*(168*s - 115) - 28*s + 17) + 7*Pk2*(K*(r*(8*s - 6) + 20*s - 4) + 76*r**2 + r*(72*s - 89) - 20*s + 18) + 3*Pkd2*f*k2*(16*r*(9*s - 2) - 40*s + 9) + Pkd2*k2*(7*K + 7)*(r*(36*s - 22) - 15*s + 7))) + b1*(D1*bd1*f*(Pk2*k2**2*r*(4*f*(9*r - 8) + 154*r - 119) + k1**2*(4*Pk2*f*(66*r**2 + r*(84*s - 68) - 14*s + 7) + 7*Pk2*(4*K*(r*s + r + 2*s - 1) + 38*r**2 + r*(36*s - 37) - 8*s + 4) + 3*Pkd2*f*k2*(18*r*(4*s - 1) - 25*s + 9) + Pkd2*k2*(7*K + 7)*(6*r*(3*s - 2) - 9*s + 7))) + D1*(3*f**2*fd*k1**2*(6*Pk2*(5*r - 2)*(2*r + 3*s - 1) + 5*Pkd2*k2*(3*r - 1)*(3*s - 1)) + 7*f*(fd*(3*Pk2*k2**2*r*(2*r - 1) + k1**2*(Pk2*(2*K*(3*r - 2)*(2*s - 1) + 6*r**2 + 12*r*s - 9*r - 8*s + 4) + Pkd2*k2*(3*K + 3)*(2*r - 1)*(s - 1))) + k1**2*(10*Pk2*bd2*r*s - 4*Pk2*gd2*s*(r + 2) + Pkd2*bd2*k2*(r*(9*s - 5) - 2*s) - 2*Pkd2*gd2*k2*(r*(9*s - 5) - 2*s))) + 7*fd*k1**2*(10*Pk2*b2*r*(s - 1) - 4*Pk2*g2*(r*(s - 5) + 4*s) + Pkd2*b2*k2*(r*(9*s - 5) - 4*s) + 2*Pkd2*g2*k2*(r*(5 - 9*s) + 4*s))) + Dd*f*(3*f**2*k1**2*(2*Pk2*(5*r - 2)*(8*r + 12*s - 5) + 5*Pkd2*k2*(4*r - 1)*(3*s - 1)) + 7*f*(3*Pk2*k2**2*r*(4*r - 1) + k1**2*(Pk2*(2*K*(3*r - 2)*(4*s - 1) + 12*r**2 + 24*r*s - 9*r - 16*s + 4) + Pkd2*k2*(3*K + 3)*(4*r - 1)*(s - 1))) + 7*k1**2*(b2*(10*Pk2*r*(4*s - 1) + Pkd2*k2*(36*r*s - 22*r - 15*s + 7)) - 2*g2*(Pk2*(8*r*s - 6*r + 20*s - 4) + Pkd2*k2*(36*r*s - 22*r - 15*s + 7))))) + f*(D1*bd1*(3*f**2*k1**2*(2*Pk2*(5*r - 2)*(2*r + 3*s - 2) + 5*Pkd2*k2*r*(3*s - 1)) + 7*f*(3*Pk2*k2**2*r**2 + k1**2*(Pk2*(3*r**2 + r*s*(6*K + 6) - s*(4*K + 4)) + Pkd2*k2*r*(3*K + 3)*(s - 1))) - 14*g2*k1**2*(2*Pk2*(r*(s + 2) + 2*s - 2) + Pkd2*k2*(r*(9*s - 7) - 7*s + 7))) + 7*b2*k1**2*(D1*(10*Pk2*bd1*r*s + 2*Pk2*fd*(3*r - 2)*(2*s - 1) + Pkd2*bd1*k2*(r*(9*s - 7) - 7*s + 7) + 3*Pkd2*fd*k2*(2*r - 1)*(s - 1)) + Dd*f*(2*Pk2*(3*r - 2)*(4*s - 1) + 3*Pkd2*k2*(4*r - 1)*(s - 1))) + 7*k1**2*(D1*f*(bd2 - 2*gd2)*(2*Pk2*s*(3*r - 2) + 3*Pkd2*k2*r*(s - 1)) - 2*D1*fd*g2*(2*Pk2*(3*r - 2)*(2*s - 1) + 3*Pkd2*k2*(2*r - 1)*(s - 1)) - 4*Dd*Pk2*f*g2*(3*r - 2)*(4*s - 1) + 6*Dd*Pkd2*f*g2*k2*(-4*r*(s - 1) + s - 1))))/(105*d**2*k1**2*k2) + 2*D1**3*Pkd1*ct*st**2*(3*D1*bd1*f*(7*b1*(4*Pk2*k2**4*r*(1 - 2*r) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*s - 3) + 2*s) + k1**2*k2**2*(Pk2*(4*C - 4)*(2*r**2 - 4*r*s + s) + Pkd2*k2*(-6*C*s + r*(4*C*(s + 1) - 2*s + 3) - 2*s))) + f*(2*Pk2*k2**4*r*(29 - 30*r) + k1**4*(Pk2*(4*C*r*(s + 12) + 8*C*(5*s - 6) - 26*r**2 - 26*r*s - 36*r - 48*s + 60) + Pkd2*k2*(2*C*(r*(s - 9) - 11*s + 9) + r*(23 - 18*s) + 29*s - 22)) - k1**2*k2**2*(2*Pk2*(C*(42*r**2 + 80*r*s - 30*r + 8*s - 8) + 79*r**2 + 31*r*s - 94*r - 11*s + 6) + Pkd2*k2*(2*C*(41*r*s - 31*r - 54*s + 33) + 18*r*s - 23*r - 29*s + 22)))) + 21*b1**2*(D1*fd*r*(-4*Pk2*k2**4*r + k1**4*s*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(4*C - 4)*(r - 2*s) + Pkd2*k2*s*(2*C - 1))) + Dd*f*(4*Pk2*k2**4*r*(1 - 4*r) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 3) + 2*s) + k1**2*k2**2*(Pk2*(4*C - 4)*(4*r**2 - 8*r*s + s) + Pkd2*k2*(-6*C*s + r*(8*C*s + 4*C - 4*s + 3) - 2*s)))) + 3*b1*f*(2*D1*fd*(Pk2*k2**4*(-60*r**2 + 25*r - 8) - 2*k1**4*(Pk2*(13*r**2 + r*(-2*C*s - 13*C + 13*s + 9) + 2*s) - Pkd2*k2*(r*(C*(s - 4) - 9*s + 7) + s)) + k1**2*k2**2*(-Pk2*(2*C*(42*r**2 + 80*r*s - 41*r + 9*s - 2) + 158*r**2 + 62*r*s - 65*r - 18*s + 20) + Pkd2*k2*(-2*r*(41*C*s - 21*C + 9*s - 7) + s*(13*C + 2)))) + Dd*f*(-4*Pk2*k2**4*(60*r**2 - 31*r + 4) + k1**4*(4*Pk2*(C*(4*r*s + 37*r + 10*s - 12) - 26*r**2 - 26*r*s - 29*r - 18*s + 15) + Pkd2*k2*(2*C*(4*r*s - 26*r - 11*s + 9) - 72*r*s + 65*r + 41*s - 22)) - k1**2*k2**2*(Pk2*(4*C*(84*r**2 + 160*r*s - 54*r + 17*s - 6) + 632*r**2 + 248*r*s - 354*r - 74*s + 52) + Pkd2*k2*(2*C*(164*r*s - 94*r - 79*s + 33) + 72*r*s - 65*r - 41*s + 22)))) - f**2*(D1*fd*(54*Pk2*k2**4*r*(3*r - 1) + k1**4*(-6*C*Pkd2*k2*(9*r*(s - 1) + 3*s + 1) + 4*Pk2*(C*(9*r*s - 39*r + 24*s + 4) + 36*r**2 + 45*r*s - 12*r - 78*s + 21) + 9*Pkd2*k2*(3*r - 1)*(3*s - 2)) + 3*k1**2*k2**2*(2*Pk2*(4*C*(45*r**2 + 27*r*s - 57*r - 36*s + 23) + 99*r**2 + 45*r*s - 51*r - 51*s + 18) + 3*Pkd2*k2*(3*r - 1)*(6*C*(2*s - 1) + 3*s - 2))) + Dd*f*(54*Pk2*k2**4*r*(4*r - 1) + k1**4*(-6*C*Pkd2*k2*(2*r*(6*s - 7) + 7*s + 1) + 4*Pk2*(C*(12*r*s - 59*r + 40*s + 4) + 48*r**2 + 60*r*s - 5*r - 106*s + 21) + 9*Pkd2*k2*(4*r - 1)*(3*s - 2)) + 3*k1**2*k2**2*(2*Pk2*(4*C*(60*r**2 + 36*r*s - 68*r - 48*s + 23) + 132*r**2 + 60*r*s - 53*r - 67*s + 18) + 3*Pkd2*k2*(4*r - 1)*(6*C*(2*s - 1) + 3*s - 2)))))/(315*d**2*k1**2*k2*k3**2) - 2*D1**3*Pkd1*ct*(D1*bd1*f*(7*b1*(5*Pk2*k2**4*r*(2*r - 1) + k1**4*(4*Pk2*(11*r**2 + r*(C*(2 - 8*s) + 17*s - 11) + s*(2*C - 3)) + Pkd2*k2*(4*C*r*(4*s - 1) - 4*C*s + s*(10*r - 5))) + k1**2*k2**2*(Pk2*(r**2*(24*C + 78) + r*(80*C*s - 32*C + 56*s - 53) - s*(20*C + 14)) + Pkd2*k2*s*(10*C + 5)*(2*r - 1))) + f*(21*Pk2*k2**4*r**2 + k1**4*(Pk2*(-12*C*(r*(s - 4) - 2*s + 2) + 153*r**2 + 186*r*s - 201*r - 64*s + 64) + 3*Pkd2*k2*(2*C*(15*r*s - 11*r - 9*s + 9) + 7*r*s)) + k1**2*k2**2*(Pk2*(4*C*(45*r**2 + 42*r*s - 61*r - 14*s + 14) + 210*r**2 + 132*r*s - 129*r - 40*s + 40) + Pkd2*k2*r*s*(42*C + 21)))) + 7*b1**2*(D1*fd*r*(5*Pk2*k2**4*r + k1**4*(22*Pk2*r + Pk2*s*(34 - 16*C) + Pkd2*k2*s*(8*C + 5)) + k1**2*k2**2*(Pk2*r*(12*C + 39) + Pk2*s*(40*C + 28) + Pkd2*k2*s*(10*C + 5))) + Dd*f*(5*Pk2*k2**4*r*(4*r - 1) + k1**4*(4*Pk2*(22*r**2 + r*(C*(2 - 16*s) + 34*s - 11) + s*(2*C - 3)) + Pkd2*k2*(4*C*r*(8*s - 1) - 4*C*s + s*(20*r - 5))) + k1**2*k2**2*(Pk2*(r**2*(48*C + 156) + r*(32*C*(5*s - 1) + 112*s - 53) - s*(20*C + 14)) + Pkd2*k2*s*(10*C + 5)*(4*r - 1)))) + b1*f*(D1*fd*(21*Pk2*k2**4*r*(2*r - 1) + k1**4*(Pk2*(96*C*s + 306*r**2 - 12*r*(2*C*s + 7*C - 31*s + 22) - 200*s + 66) + 3*Pkd2*k2*(4*C*(15*r*s - 7*r - 4*s) + s*(14*r - 7))) + k1**2*k2**2*(Pk2*(4*C*(90*r**2 + r*(84*s - 125) - 49*s + 40) + 420*r**2 + 3*r*(88*s - 91) - 146*s + 42) + Pkd2*k2*s*(42*C + 21)*(2*r - 1))) + Dd*f*(21*Pk2*k2**4*r*(4*r - 1) + k1**4*(Pk2*(-12*C*(4*r*s + 3*r - 12*s + 2) + 612*r**2 + 744*r*s - 531*r - 328*s + 130) + 3*Pkd2*k2*(2*C*(60*r*s - 32*r - 19*s + 9) + s*(28*r - 7))) + k1**2*k2**2*(Pk2*(4*C*(180*r**2 + 168*r*s - 226*r - 77*s + 54) + 840*r**2 + 528*r*s - 444*r - 226*s + 82) + Pkd2*k2*s*(42*C + 21)*(4*r - 1)))) + 3*f**2*k1**2*(2*C*k1**2*(D1*fd*(2*Pk2*(5*r - 2)*(3*s - 1) + 5*Pkd2*k2*(3*r - 1)*(s - 1)) + Dd*f*(2*Pk2*(5*r - 2)*(4*s - 1) + 5*Pkd2*k2*(4*r - 1)*(s - 1))) + Pk2*r*(5*k1**2 + 5*k2**2)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(105*d**2*k1**2*k2*k3**2) - D1**3*Pkd1*f**2*st**6*(4*Pk2 - Pkd2*k2)*(11*D1*bd1*f*(r*(3*s - 2) - 6*s + 2) + 11*b1*(3*D1*fd*r*(3*s - 1) + Dd*f*(12*r*s - 5*r - 6*s + 2)) + 5*f*(3*r + 2)*(4*s - 1)*(D1*fd + Dd*f))/(693*d**2*k1) + 2*D1**3*Pkd1*f*st**4*(6*D1*b1*fd*r*(Pk2*k2**2*(-4*C*r + r + 4*s - 2) + k1**2*(C*Pkd2*k2*(2*s - 1) + Pk2*(-4*C*s + 2*C + r + 4*s - 2))) - 3*D1*bd1*f*(Pk2*k2**2*(r**2*(4*C - 1) + r*(-4*C - 4*s + 2) + 2*s - 1) + k1**2*(-2*C*Pkd2*k2*(r*(s - 2) - 4*s + 2) + Pk2*(4*C*(r*(s - 2) - 4*s + 2) - r**2 - 4*r*s + 2*r + 2*s - 1))) - 3*Dd*b1*f*(Pk2*k2**2*(r**2*(16*C - 4) + r*(-4*C - 16*s + 7) + 2*s - 1) + k1**2*(2*C*Pkd2*k2*(r*(5 - 4*s) + 4*s - 2) + Pk2*(4*C*(4*r*s - 5*r - 4*s + 2) - 4*r**2 - 16*r*s + 7*r + 2*s - 1))) + f*(D1*fd*(Pk2*k2**2*(-4*C*(18*r**2 - 27*r + 7) + 9*r**2 + 6*s - 3) + k1**2*(2*C*Pkd2*k2*(3*r + 2)*(3*s - 1) + Pk2*(-4*C*(3*r + 2)*(3*s - 1) + 9*r**2 + 6*s - 3))) + Dd*f*(Pk2*k2**2*(-4*C*(24*r**2 - 34*r + 7) + 12*r**2 + r + 8*s - 3) + k1**2*(2*C*Pkd2*k2*(r*(12*s - 5) + 10*s - 2) + Pk2*(C*(-48*r*s + 20*r - 40*s + 8) + 12*r**2 + r + 8*s - 3)))))/(105*d**2*k1*k3**2) - D1**3*Pkd1*f*st**4*(33*b1**2*(D1*fd*r*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(8*r + 8*s - 2) + Pkd2*k2*(1 - 4*s))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 5) - 4*s + 2) + 2*k2**2*(Pk2*(8*r**2 + 8*r*s - 4*r - 8*s + 2) + Pkd2*k2*(-4*r*s + r + 4*s - 1)))) + 11*b1*f*(3*D1*bd1*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 2) - 2*s + 1) + k2**2*(2*Pk2*(4*r**2 + 4*r*s - 3*r - 8*s + 2) + Pkd2*k2*(-4*r*s + r + 8*s - 2))) + D1*fd*(2*k1**2*(4*Pk2 - Pkd2*k2)*(3*r + 1)*(3*s - 1) + k2**2*(12*Pk2*(18*r**2 + 3*r*(s - 3) + 2*s + 2) + Pkd2*k2*(3*r*(9*s - 5) - 12*s + 2))) + Dd*f*(8*Pk2*k1**2*(r*(12*s - 5) + 2*s) + 2*Pk2*k2**2*(144*r**2 + r*(24*s - 85) + 35*s + 2) - 2*Pkd2*k1**2*k2*(r*(12*s - 5) + 2*s) + Pkd2*k2**3*(r*(36*s - 22) - 35*s + 12))) + f**2*(11*D1*bd1*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(3*s - 2) - s + 1) + k2**2*(2*Pk2*(36*r**2 + 6*r*s - 31*r + 23*s - 10) + Pkd2*k2*(9*r*s - 7*r - 23*s + 10))) + (D1*fd + Dd*f)*(k1**2*(4*Pk2 - Pkd2*k2)*(25*r + 2)*(4*s - 1) + k2**2*(2*Pk2*(560*r**2 - 379*r - 385*s + 156) + 11*Pkd2*k2*(4*r - 1)*(5*s - 2)))))/(1155*d**2*k1*k2**2) + D1**3*Pkd1*st**2*(21*b1**3*(-D1*fd*r*(-2*Pk2*k1**2*s + 2*Pk2*k2**2*r + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 3) + 2*s) + k2**2*(2*Pk2*r*(1 - 4*r) + Pkd2*k2*(-4*r*s + 3*r - 2*s)))) - 3*b1**2*(14*D1*Pk2*fd*r*(-2*k1**2*(s - 1) + k2**2*(K*r + r - 2*s + 2)) + D1*f*(7*bd1*(-k1**2*(2*Pk2 - Pkd2*k2)*(3*r*(s - 1) + 2*s) + k2**2*(2*Pk2*r*(3*r - 1) + Pkd2*k2*(3*r*(s - 1) + 2*s))) + 2*fd*(Pk2*k1**2*(12*r*s + 7*r + 4*s) + 2*Pk2*k2**2*(92*r**2 + 42*r*s - 44*r + 11) + Pkd2*k1**2*k2*(15*r*s - 14*r - 2*s) + Pkd2*k2**3*(39*r*s - 14*r - 2*s))) + Dd*f*k1**2*(2*Pk2*(f*(24*r*s + 53*r + 29*s - 22) - 56*r*s + 35*r + 7*s - 7) + Pkd2*f*k2*(r*(60*s - 74) - 29*s + 22)) + Dd*f*k2**2*(2*Pk2*(2*f*(184*r**2 + 3*r*(28*s - 37) + 11) + 7*r**2*(4*K + 4) - 7*r*(K + 8*s - 4) + 7*s - 7) + Pkd2*f*k2*(13*r*(12*s - 5) - 62*s + 22))) - b1*(3*D1*bd1*f*(k1**2*(2*Pk2*(f*(12*r*s + 46*r + 25*s - 22) - 28*r*s + 14*r + 7*s - 7) + Pkd2*f*k2*(r*(30*s - 46) - 25*s + 22)) + k2**2*(2*Pk2*(2*f*r*(42*s - 67) + r**2*(14*K + 184*f + 14) - 7*r*(K + 4*s - 1) + 7*s - 7) + Pkd2*f*k2*(r*(78*s - 37) - 58*s + 22))) + 3*D1*(2*Pk2*f*(fd*k1**2*(r*(4*s + 5) - 9*s + 1) + fd*k2**2*(K*(46*r**2 - 67*r + 22) + 46*r**2 + r*(4*s - 62) - 9*s + 23) + k2**2*r**2*(7*bd2 - 14*gd2)) + 14*Pk2*fd*k2**2*r**2*(b2 - 2*g2) + f**2*fd*(k1**2*(2*Pk2*(3*r*(5*s + 6) - 29*s + 6) + Pkd2*k2*(r*(39*s - 36) - 7*s + 6)) + 6*k2**2*(Pk2*(45*r**2 + 18*r*(s - 2) - 24*s + 10) + Pkd2*k2*(3*r - 1)*(3*s - 1)))) + Dd*f*(6*Pk2*f*(k1**2*(r*(8*s + 11) - 17*s + 1) + k2**2*(K*(92*r**2 - 111*r + 22) + 92*r**2 + 8*r*s - 100*r - 17*s + 23)) + Pk2*k2**2*r*(42*b2 - 84*g2)*(4*r - 1) + f**2*(k1**2*(2*Pk2*(15*r*(4*s + 7) - 88*s - 8) + Pkd2*k2*(3*r*(52*s - 53) - 56*s + 44)) + 18*k2**2*(Pk2*(60*r**2 + 24*r*s - 45*r - 32*s + 14) + Pkd2*k2*(4*r - 1)*(3*s - 1))))) - f*(6*D1*Pk2*f*k2**2*r*(bd2 - 2*gd2)*(23*r - 22) + 6*D1*Pk2*fd*k2**2*(b2 - 2*g2)*(46*r**2 - 67*r + 22) + D1*bd1*(6*Pk2*f*(k1**2*(r*(2*s + 3) - 4*s) + k2**2*(r**2*(23*K + 23) + r*(-22*K + 2*s - 19) - 4*s)) + Pk2*k2**2*r*(42*b2 - 84*g2)*(r - 1) + f**2*(k1**2*(2*Pk2*(15*r*s + 51*r - s - 26) + Pkd2*k2*(39*r*s - 51*r - 35*s + 26)) + 18*k2**2*(Pk2*(15*r**2 + 6*r*s - 9*r - 8*s + 4) + Pkd2*k2*r*(3*s - 1)))) + D1*f**2*fd*k1**2*(Pk2*(50*r - 66*s + 4) + 5*Pkd2*k2*(4*r - 1)*(3*s - 2)) + 6*Dd*Pk2*f*k2**2*(b2 - 2*g2)*(92*r**2 - 111*r + 22) + Dd*f**3*k1**2*(Pk2*(50*r - 66*s + 4) + 5*Pkd2*k2*(4*r - 1)*(3*s - 2))))/(315*d**2*k1*k2**2) - D1**3*Pkd1*(D1*bd1*f*(Pk2*k2**2*r*(140*b2 - 280*g2)*(r - 1) + 3*f**2*k1**2*(2*Pk2*(5*r - 2)*(s - 1) + 5*Pkd2*k2*r*s)) + 35*b1**3*(D1*fd*r*(2*Pk2*k1**2*s + 4*Pk2*k2**2*(r + s) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + Dd*f*(k1**2*(2*Pk2*r*(4*s - 1) + Pkd2*k2*s*(4*r - 1)) + k2**2*(2*Pk2*(8*r**2 + 8*r*s - 3*r - s) + Pkd2*k2*s*(4*r - 1)))) + b1**2*(35*D1*bd1*f*(k1**2*(2*Pk2*r*(3*s - 1) + Pkd2*k2*s*(3*r - 1)) + k2**2*(2*Pk2*(6*r**2 + 6*r*s - 3*r - s) + Pkd2*k2*s*(3*r - 1))) + D1*fd*(56*Pk2*k1**2*s*(f*(3*r - 1) + r - 1) + 2*Pk2*k2**2*(f*(120*r**2 + 12*r*(7*s - 10) - 49*s + 30) + (14*r - 14)*(5*K*(r - 1) + 5*r + 2*s - 5)) + 21*Pkd2*f*k1**2*k2*s*(4*r - 1) + 21*Pkd2*f*k2**3*s*(2*r - 1)) + 14*Dd*f*k1**2*(2*Pk2*(f*(3*r - 1)*(4*s - 1) + 8*r*s - r - 5*s + 1) + 3*Pkd2*f*k2*s*(4*r - 1)) + Dd*f*k2**2*(2*Pk2*f*(240*r**2 + 3*r*(56*s - 67) - 77*s + 44) + 28*Pk2*(5*K*(4*r**2 - 5*r + 1) + 20*r**2 + r*(8*s - 26) - 5*s + 6) + 21*Pkd2*f*k2*s*(4*r - 1))) + b1*(D1*bd1*f*(7*k1**2*(4*Pk2*(f*(3*r - 1)*(2*s - 1) + 4*r*s - r - 2*s + 1) + 3*Pkd2*f*k2*s*(4*r - 1)) + 2*k2**2*(Pk2*f*(120*r**2 + r*(84*s - 81) - 28*s + 14) + 14*Pk2*(r**2*(10*K + 10) + r*(-10*K + 4*s - 11) - 2*s + 1) + 21*Pkd2*f*k2*r*s)) + D1*(140*Pk2*b2*fd*k2**2*(r - 1)**2 + 140*Pk2*f*k2**2*r*(bd2 - 2*gd2)*(r - 1) - 280*Pk2*fd*g2*k2**2*(r - 1)**2 + 3*f**2*fd*k1**2*s*(6*Pk2*(5*r - 2) + 5*Pkd2*k2*(3*r - 1))) + 140*Dd*Pk2*f*k2**2*(b2 - 2*g2)*(4*r**2 - 5*r + 1) + 3*Dd*f**3*k1**2*(2*Pk2*(5*r - 2)*(4*s - 1) + 5*Pkd2*k2*s*(4*r - 1))))/(105*d**2*k1*k2**2) - 2*D1**3*Pkd1*st**2*(3*D1*bd1*f*(7*b1*k2**2*(2*C*k2*(Pk2*k2*r*(2*r - 1) + Pkd2*k1**2*(2*r*s - 3*r + 2*s)) + Pk2*(k1**2 + k2**2)*(2*r**2 - 4*r*s + s)) + f*(Pk2*k1**4*(r*(2*s + 3) - s - 3) + 2*Pk2*k2**4*(r**2*(23*C + 9) + r*(-22*C + s - 12) - 2*s + 2) + k1**2*k2**2*(2*C*Pkd2*k2*(r*(18*s - 23) - 29*s + 22) + Pk2*(r**2*(54*C + 18) + r*(84*C*s - 54*C + 4*s - 21) - 5*s + 1)))) + 21*b1**2*k2**2*(2*C*k2*(D1*fd*r*(Pk2*k2*r + Pkd2*k1**2*s) + Dd*f*(Pk2*k2*r*(4*r - 1) + Pkd2*k1**2*(4*r*s - 3*r + 2*s))) + Pk2*(k1**2 + k2**2)*(D1*fd*r*(r - 2*s) + Dd*f*(4*r**2 - 8*r*s + s))) + 3*b1*f*(D1*fd*(Pk2*k1**4*r*(4*s + 5) + Pk2*k2**4*(2*C*(46*r**2 - 67*r + 22) + 36*r**2 + 4*r*s - r - 9*s + 2) + k1**2*k2**2*(8*C*Pkd2*k2*(r*(9*s - 7) - s) + Pk2*(r**2*(108*C + 36) + 4*r*(42*C*s - 21*C + 2*s + 1) - 9*s + 2))) + Dd*f*(Pk2*k1**4*(r*(8*s + 11) - s - 3) + Pk2*k2**4*(2*C*(92*r**2 - 111*r + 22) + 72*r**2 + 8*r*s - 27*r - 17*s + 6) + k1**2*k2**2*(2*C*Pkd2*k2*(r*(72*s - 65) - 41*s + 22) + Pk2*(r**2*(216*C + 72) + 2*r*(168*C*s - 69*C + 8*s - 8) - 18*s + 3)))) + f**2*(D1*fd*(Pk2*k1**4*(6*r*(3*s + 2) - 15*s - 1) + 27*Pk2*k2**4*r*(3*r - 1) + k1**2*k2**2*(18*C*Pkd2*k2*(3*r - 1)*(3*s - 2) + Pk2*(C*(342*r**2 + 6*r*(54*s - 71) - 432*s + 212) + 81*r**2 + 3*r*(6*s - 5) - 15*s - 1))) + Dd*f*(Pk2*k1**4*(r*(24*s + 17) - 19*s - 1) + 27*Pk2*k2**4*r*(4*r - 1) + k1**2*k2**2*(18*C*Pkd2*k2*(4*r - 1)*(3*s - 2) + Pk2*(C*(456*r**2 + 432*r*s - 494*r - 576*s + 212) + 108*r**2 + 24*r*s - 10*r - 19*s - 1)))))/(315*d**2*k1*k2**2*k3**2) - 2*D1**3*Pkd1*(D1*bd1*f*(7*b1*(2*Pk2*k1**4*(r*(4*s - 1) - s) + 5*Pk2*k2**4*r*(2*r - 1) + k1**2*k2**2*(10*C*Pkd2*k2*s*(2*r - 1) + Pk2*(-20*C*s + r**2*(72*C + 10) + r*(80*C*s - 56*C + 8*s - 7) - 2*s))) + f*(6*Pk2*k1**4*(r*(4*s - 2) - s + 1) + 21*Pk2*k2**4*r**2 + k1**2*k2**2*(8*C*Pk2*(27*r**2 + 3*r*(7*s - 8) - 7*s + 7) + 42*C*Pkd2*k2*r*s + 3*Pk2*(7*r**2 + r*(8*s - 4) - 2*s + 2)))) + b1*(D1*fd*(2*C*k1**2*k2**2*(2*Pk2*f*(108*r**2 + 12*r*(7*s - 9) - 49*s + 27) + 21*Pkd2*f*k2*s*(2*r - 1) + 7*b1*r*(18*Pk2*r + 20*Pk2*s + 5*Pkd2*k2*s)) + Pk2*(k1**2 + k2**2)*(7*b1*r*(4*k1**2*s + 5*k2**2*r) + 3*f*(2*r - 1)*(8*k1**2*s + 7*k2**2*r))) + Dd*f*(7*b1*(2*Pk2*k1**4*(r*(8*s - 1) - s) + 5*Pk2*k2**4*r*(4*r - 1) + k1**2*k2**2*(10*C*Pkd2*k2*s*(4*r - 1) + Pk2*(-20*C*s + r**2*(144*C + 20) + r*(8*C*(20*s - 7) + 16*s - 7) - 2*s))) + f*(6*Pk2*k1**4*(2*r*(8*s - 1) - 6*s + 1) + 21*Pk2*k2**4*r*(4*r - 1) + k1**2*k2**2*(42*C*Pkd2*k2*s*(4*r - 1) + Pk2*(4*C*(216*r**2 + 3*r*(56*s - 61) - 77*s + 41) + 84*r**2 + 96*r*s - 33*r - 36*s + 6))))))/(105*d**2*k1*k2**2*k3**2)
        perm13 = -D1**3*Pk1*Pk3*ct**8*f*k2**6*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(12*r + 12*s - 5))/(21*d**2*k3**8) - D1**3*Pk1*Pk3*ct**8*f*k2**4*(32*C - 32)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(72*r*s - 33*r + 72*s**2 - 72*s + 19) + Dd*f*(96*r*s - 52*r + 96*s**2 - 108*s + 31)))/(63*d**2*k3**6) - D1**3*Pk1*Pk3*ct**8*f*k2**2*(32*C - 32)*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(36*s**2 - 33*s + 7) + 2*Dd*f*(24*s**2 - 26*s + 7)))/(63*d**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**7*f*k2**5*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*k1**2*(2*r + 2*s - 1)*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(21*f*k2**2*(52*r**2 + r*(104*s - 67) + 52*s**2 - 67*s + 21) + 22*k1**2*(3*r + 3*s - 2)*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37)) + Dd*f*(21*f*k2**2*(13*r + 13*s - 7) + 22*k1**2*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37))*(4*r + 4*s - 3)))/(1155*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct**7*f*k2**3*(9*D1*bd1*f*(k1**2*(2*C*(72*r*s - 25*r + 72*s**2 - 86*s + 25) - 124*r*s + 45*r - 124*s**2 + 152*s - 45) - k2**2*(r + s - 1)*(r*(28*C - 38) - 10*s + 5)) + 9*b1*(D1*fd*(2*k1**2*(C*(144*r*s - 79*r + 144*s**2 - 158*s + 43) - 124*r*s + 69*r - 124*s**2 + 138*s - 38) - k2**2*(2*r + 2*s - 1)*(r*(28*C - 38) - 10*s + 5)) + Dd*f*(k1**2*(C*(576*r*s - 316*r + 576*s**2 - 718*s + 222) - 496*r*s + 276*r - 496*s**2 + 628*s - 197) - k2**2*(4*r + 4*s - 3)*(r*(28*C - 38) - 10*s + 5))) + f*(D1*fd*(5*k1**2*(4*C*(126*r*s - 69*r + 126*s**2 - 144*s + 43) - 432*r*s + 243*r - 432*s**2 + 504*s - 153) - k2**2*(3*r + 3*s - 2)*(4*C*(39*r + 17) - 216*r - 60*s - 43)) + Dd*f*(5*k1**2*(C*(r*(672*s - 412) + 672*s**2 - 846*s + 274) - 72*r*(8*s - 5) - 576*s**2 + 738*s - 243) + k2**2*(-2*C*(312*r**2 + 24*r*(13*s - 4) + 137*s - 103) + 864*r**2 + 8*r*(138*s - 59) + 240*s**2 - 6*s - 131))))/(315*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**7*f*k2*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(36*s**2 - 33*s + 7) + 2*Dd*f*(24*s**2 - 26*s + 7)))/(63*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct**7*f*k2*(9*b1*(2*s - 1)*(2*D1*fd*(k1**2*(66*C*s - 40*C - 56*s + 35) + k2**2*(-14*C*r + 24*r + 10*s - 5)) + Dd*f*(4*k1**2*(66*C*s - 40*C - 56*s + 35) + k2**2*(-56*C*r + 96*r + 40*s - 25))) + f*(D1*(18*bd1*k1**2*s*(C*(66*s - 40) - 56*s + 35) + 9*bd1*k2**2*(r*(-28*C*s + 48*s - 5) + 5*(1 - 2*s)**2) + 10*fd*k1**2*(3*s - 1)*(C*(78*s - 56) - 66*s + 49) + fd*k2**2*(C*(-522*r*s + 183*r - 186*s + 59) + 882*r*s - 348*r + 360*s**2 - 174*s + 36)) + Dd*f*(20*k1**2*(2*s - 1)*(C*(78*s - 56) - 66*s + 49) + k2**2*(C*(-696*r*s + 344*r - 256*s + 129) + 1176*r*s - 604*r + 480*s**2 - 284*s + 26))))/(315*d**2*k1*k3**4) - D1**3*Pk1*Pk3*ct**6*f*k2**6*st**2*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(9*r + 9*s - 4))/(7*d**2*k3**8) - D1**3*Pk1*Pk3*ct**6*f*k2**4*st**2*(32*C - 32)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) + Dd*f*(r*(72*s - 38) + 72*s**2 - 81*s + 23)))/(21*d**2*k3**6) - D1**3*Pk1*Pk3*ct**6*f*k2**2*st**2*(32*C - 32)*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(27*s**2 - 24*s + 5) + 2*Dd*f*(18*s**2 - 19*s + 5)))/(21*d**2*k3**4) + 8*D1**3*Pk1*Pk3*ct**6*k2**4*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + 3*K*r + 3*K*s + 2*K - 10*b1*(2*r + 2*s - 1) + 25*r + 25*s - 16)) + k2**2*(r + s)*(252*K*b1 - 252*b1 - 252*g2)) + 198*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) + 18*f*(fd*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 252*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16)) - 252*g2*k2**2*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(428*r**2 + r*(856*s - 565) + 428*s**2 - 565*s + 183) - 22*f*(5*fd*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(3*r**2 + r*(6*s - 1) + 3*s**2 - s - 2)) + 396*fd*g2*k2**2*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(107*r + 107*s - 61) + 110*f*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(3*r + 3*s + 2))))/(1155*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct**6*k2**2*(11*D1*bd1*f*(252*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(60*r**2 + r*(60*s - 101) - 75*s + 41) + 3*f*k1**2*(12*k1**2*(C*(95*r*s - 50*r + 95*s**2 - 144*s + 50) - 69*r*s + 40*r - 69*s**2 + 111*s - 40) + k2**2*(-4*C*(186*r**2 + 309*r*s - 224*r + 123*s**2 - 126*s + 38) + 738*r**2 + 1284*r*s - 923*r + 546*s**2 - 576*s + 185))) + 2772*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 11*b1*f*(3*D1*fd*(f*k2**4*r*(60*r + 60*s - 31) + 6*k1**4*(2*C*(190*r*s - 123*r + 190*s**2 - 239*s + 72) - 276*r*s + 187*r - 276*s**2 + 360*s - 111) - 2*k1**2*k2**2*(4*C*(186*r**2 + 309*r*s - 149*r + 123*s**2 - 114*s + 24) - 738*r**2 - 1284*r*s + 641*r - 546*s**2 + 531*s - 120)) + Dd*f*(f*k2**4*(240*r**2 + 2*r*(120*s - 97) - 75*s + 41) + 18*k1**4*(4*C*(190*r*s - 123*r + 190*s**2 - 275*s + 97) - 552*r*s + 374*r - 552*s**2 + 831*s - 302) - 3*k1**2*k2**2*(4*C*(744*r**2 + 1236*r*s - 800*r + 492*s**2 - 534*s + 143) - 2952*r**2 - 5136*r*s + 3374*r - 2184*s**2 + 2460*s - 701))) + f**2*(D1*fd*(5*f*k2**4*(496*r**2 + r*(496*s - 782) - 509*s + 357) + 110*k1**4*(14*C*(15*s - 11)*(3*r + 3*s - 2) - 450*r*s + 357*r - 450*s**2 + 666*s - 241) - 11*k1**2*k2**2*(4*C*(927*r**2 + 1683*r*s - 378*r + 756*s**2 - 120*s - 208) - 3690*r**2 - 6984*r*s + 1899*r - 3294*s**2 + 1014*s + 581)) + Dd*f*(5*f*k2**4*(496*r**2 + r*(496*s - 782) - 509*s + 357) + 110*k1**4*(28*C*(30*r*s - 23*r + 30*s**2 - 45*s + 17) - 600*r*s + 490*r - 600*s**2 + 945*s - 370) - 11*k1**2*k2**2*(4*C*(1236*r**2 + 2244*r*s - 699*r + 1008*s**2 - 290*s - 290) - 4920*r**2 - 9312*r*s + 3354*r - 4392*s**2 + 1924*s + 769))))/(3465*d**2*k1**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**6*(504*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 9*b1*f*(4*D1*(-28*bd1*k1**2*s*(C - 1)*(s - 1) + fd*(2*s - 1)*(k1**2*(s*(14*C - 17) + 5) + 2*k2**2*r)) + Dd*f*(2*s - 1)*(8*k1**2*(s*(14*C - 17) + 5) + k2**2*(16*r + 5))) - f**2*(D1*(9*bd1*(4*k1**2*s*(14*C*s - 17*s + 5) + k2**2*(8*r*s + 5*r + 10*s - 5)) + 20*fd*k1**2*(3*s - 1)*(2*C*(12*s - 7) - 27*s + 21) + 6*fd*k2**2*(3*r*(9*s - 1) + 36*s - 14)) + 4*Dd*f*(10*k1**2*(2*s - 1)*(24*C*s - 14*C - 27*s + 21) + 3*k2**2*(18*r*s - 7*r + 23*s - 12))))/(315*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**6*(-1008*b1**2*k1**2*k2**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 3*b1*f*(D1*(-336*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-48*k1**4*(2*s - 1)*(C*(78*s - 60) - 55*s + 45) + 8*k1**2*k2**2*(C*(681*r*s - 316*r + 576*s**2 - 498*s + 84) - 693*r*s + 343*r - 648*s**2 + 612*s - 123) + 3*k2**4*r*(288*C*r + 3*f*(5*s - 3) - 224*r + 64*s - 32))) + Dd*f*(-96*k1**4*(2*s - 1)*(C*(78*s - 60) - 55*s + 45) + 4*k1**2*k2**2*(C*(4*r*(681*s - 316) + 2304*s**2 - 2373*s + 586) - 28*r*(99*s - 49) - 2592*s**2 + 2877*s - 787) + 3*k2**4*(f*(4*r - 1)*(5*s - 3) + r**2*(576*C - 448) - 16*r*(9*C - 8*s - 3) + 40*s - 20))) + f**2*(D1*(-144*bd1*k1**4*s*(C*(78*s - 60) - 55*s + 45) + 12*bd1*k1**2*k2**2*(C*(r*(681*s - 130) + 576*s**2 - 573*s + 190) - 7*r*(99*s - 25) - 648*s**2 + 699*s - 235) + 9*bd1*k2**4*(f*(r - 1)*(5*s - 3) + 4*r**2*(36*C - 28) + 4*r*(-36*C + 8*s + 33) + 40*s - 20) - 240*fd*k1**4*(3*s - 1)*(30*C*s - 28*C - 21*s + 21) + 12*fd*k1**2*k2**2*(C*(r*(1389*s - 730) + 1248*s**2 - 815*s + 222) - 3*r*(465*s - 268) - 1368*s**2 + 1107*s - 330) + fd*k2**4*(8*C*(261*r**2 - 102*r + 5) + 15*f*(4*r - 1)*(5*s - 3) - 1656*r**2 + 432*r*s + 1284*r + 936*s - 604)) + Dd*f*(-480*k1**4*(2*s - 1)*(30*C*s - 28*C - 21*s + 21) + 4*k1**2*k2**2*(C*(4*r*(1389*s - 830) + 4992*s**2 - 3829*s + 802) + r*(3576 - 5580*s) - 5472*s**2 + 5055*s - 1356) + k2**4*(8*C*(348*r**2 - 107*r + 5) + 15*f*(4*r - 1)*(5*s - 3) - 2208*r**2 + 576*r*s + 1288*r + 1176*s - 844))))/(315*d**2*k1**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**5*f*k2**5*st**2*(33*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(r + s - 1) + 33*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(908*r**2 + r*(1816*s - 1197) + 908*s**2 - 1197*s + 387) + 22*k1**2*(3*r + 3*s - 2)*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368)) + Dd*f*(15*f*k2**2*(227*r + 227*s - 129) + 22*k1**2*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368))*(4*r + 4*s - 3)))/(1155*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct**5*f*k2**3*st**2*(9*D1*bd1*f*(k1**2*(8*C*(46*r*s - 15*r + 46*s**2 - 53*s + 15) - 308*r*s + 105*r - 308*s**2 + 364*s - 105) + k2**2*(-2*C*(48*r**2 + 48*r*s - 53*r - 10*s + 5) + 126*r**2 + 156*r*s - 151*r + 30*s**2 - 65*s + 25)) + 9*b1*(D1*fd*(2*k1**2*(2*C*(184*r*s - 99*r + 184*s**2 - 198*s + 53) - 308*r*s + 168*r - 308*s**2 + 336*s - 91) - 3*k2**2*(2*r + 2*s - 1)*(r*(32*C - 42) - 10*s + 5)) + Dd*f*(k1**2*(4*C*(368*r*s - 198*r + 368*s**2 - 449*s + 136) - 1232*r*s + 672*r - 1232*s**2 + 1526*s - 469) + k2**2*(-2*C*(192*r**2 + 48*r*(4*s - 3) - 10*s + 5) + 504*r**2 + 624*r*s - 438*r + 120*s**2 - 170*s + 55))) + f*(D1*fd*(6*k1**2*(4*C*(3*r*(72*s - 35) + 216*s**2 - 231*s + 64) - 729*r*s + 360*r - 729*s**2 + 789*s - 221) + k2**2*(-4*C*(261*r**2 + 9*r*(29*s - 14) + 21*s - 23) + 1449*r**2 + 1854*r*s - 954*r + 405*s**2 - 366*s + 28)) + Dd*f*(3*k1**2*(8*C*(32*r*(9*s - 5) + 288*s**2 - 342*s + 103) - 2*r*(972*s - 545) - 1944*s**2 + 2331*s - 709) + k2**2*(-2*C*(696*r**2 + 12*r*(58*s - 31) + 67*s - 71) + 1932*r**2 + 3*r*(824*s - 463) + 540*s**2 - 511*s + 38))))/(315*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**5*f*k2*st**2*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(27*s**2 - 24*s + 5) + 2*Dd*f*(18*s**2 - 19*s + 5)))/(21*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct**5*f*k2*st**2*(9*b1*(2*s - 1)*(2*D1*fd*(k1**2*(4*C*(43*s - 25) - 142*s + 85) + 3*k2**2*(r*(26 - 16*C) + 10*s - 5)) + Dd*f*(4*k1**2*(4*C*(43*s - 25) - 142*s + 85) + k2**2*(-2*C*(96*r - 5) + 312*r + 120*s - 85))) + f*(9*D1*bd1*(2*k1**2*s*(4*C*(43*s - 25) - 142*s + 85) + k2**2*(-2*C*(48*r*s - 5*r - 10*s + 5) + 156*r*s - 25*r + 60*s**2 - 80*s + 25)) + 2*D1*fd*(k1**2*(3*s - 1)*(C*(816*s - 500) - 681*s + 425) + k2**2*(-2*C*(315*r*s - 141*r + 3*s + 11) + 1035*r*s - 462*r + 405*s**2 - 399*s + 127)) + 4*Dd*f*k1**2*(2*s - 1)*(C*(816*s - 500) - 681*s + 425) + Dd*f*k2**2*(C*(-20*r*(84*s - 47) - 62*s + 6) + 10*r*(276*s - 151) + 1080*s**2 - 1153*s + 339)))/(315*d**2*k1*k3**4) + 8*D1**3*Pk1*Pk3*ct**5*k2**3*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*r + 4*K*s + 12*K + b1*(-51*r - 51*s + 29) + 111*r + 111*s - 73)) + k1**2*k2**2*(r + s)*(-84*b1*(5 - 8*K) - 672*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (70 - 112*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (70 - 112*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(3*fd*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73))*(2*r + 2*s - 1) - 112*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 672*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73)) - 672*g2*k1**2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(k1**2*(-71*r - 71*s + 45) + 11*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(5*fd*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 72*gd2*k2**2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3)) + 1584*fd*g2*k1**2*k2**2*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(71*r + 71*s - 45) - 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 1584*g2*k1**2*k2**2*(r + s + 3))))/(1155*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct**5*k2*(11*D1*bd1*f*(f**2*k2**4*(168*r**2 + r*(228*s - 211) + 60*s**2 - 241*s + 45) + 3*f*(6*k1**4*(2*C*(r*(53*s - 50) + 53*s**2 - 116*s + 50) - 7*r*(9*s - 10) - 63*s**2 + 154*s - 70) - 2*k1**2*k2**2*(2*C*(184*r**2 + r*(445*s - 266) + 261*s**2 - 266*s + 82) - 266*r**2 + r*(380 - 659*s) - 393*s**2 + 379*s - 114) + k2**4*(-2*K*(10*r**2 + 2*r*(5*s + 2) + 15*s - 15) + 3*b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 2*r**2*(107 - 84*C) + 8*r*(21*C*(s - 1) - 35*s + 37) - 66*s**2 + 150*s - 84)) + 42*k2**2*(r + s - 1)*(b1*k1**2*(14*C - 11)*(2*r + 2*s - 1) + 2*b1*k2**2*(r*(8 - 5*K) + 3*s) + 10*g2*k2**2*r)) + 33*b1**2*k2**2*(D1*fd*(k1**2*(196*C - 154)*(r + s - 1)**2 + k2**2*(3*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-14*r*(5*K - 8) + 42*s))) + 2*Dd*f*(k1**2*(98*C - 77)*(r + s - 1) + k2**2*(3*f*(13*r + 13*s - 8) + r*(56 - 35*K) + 21*s))*(4*r + 4*s - 3)) + 11*b1*(3*D1*(f**2*fd*k2**4*(168*r**2 + r*(228*s - 71) + 60*s**2 - 41*s + 9) + f*(fd*(6*k1**4*(2*C*(r*(106*s - 95) + 106*s**2 - 169*s + 58) - 126*r*(s - 1) - 126*s**2 + 217*s - 77) + k1**2*k2**2*(-4*C*(368*r**2 + 5*r*(178*s - 97) + 522*s**2 - 590*s + 157) + 1064*r**2 + r*(2636*s - 1521) + 1572*s**2 - 1922*s + 547) - 2*k2**4*(2*r + 2*s - 1)*(2*K*(5*r + 8) + r*(107 - 84*C) + 33*s - 43)) + 140*gd2*k2**4*r*(r + s - 1)) + 140*fd*g2*k2**4*r*(r + s)) + Dd*f*(4*f**2*k2**4*(168*r**2 + 2*r*(114*s - 53) + 60*s**2 - 91*s + 18) + 3*f*(6*k1**4*(4*C*(r*(106*s - 95) + 106*s**2 - 198*s + 83) - 252*r*(s - 1) - 252*s**2 + 511*s - 224) + k1**2*k2**2*(-4*C*(736*r**2 + 4*r*(445*s - 296) + 1044*s**2 - 1289*s + 411) + 2128*r**2 + r*(5272*s - 3658) + 3144*s**2 - 4055*s + 1364) - 2*k2**4*(K*(40*r**2 + 10*r*(4*s + 3) + 62*s - 46) + r**2*(428 - 336*C) + r*(-84*C*(4*s - 3) + 560*s - 489) + 132*s**2 - 269*s + 127)) + 420*g2*k2**4*r*(4*r + 4*s - 3))) + f*(D1*(10*f**2*fd*k2**4*(508*r**2 + r*(288*s - 1135) - 220*s**2 - 864*s + 703) + 11*f*(fd*(10*k1**4*(C*(6*r*(51*s - 65) + 306*s**2 - 630*s + 272) - 171*r*s + 264*r - 171*s**2 + 405*s - 185) + k1**2*k2**2*(-4*C*(396*r**2 + 9*r*(206*s + 29) + 1458*s**2 - 96*s - 467) + 738*r**2 + 4878*r*s + 1347*r + 4140*s**2 + 240*s - 1613) + 18*k2**4*(C*(72*r**2 + 72*r*s - 50*r - 4*s + 2) - 102*r**2 - 132*r*s + 85*r - 30*s**2 + 39*s - 12)) + 12*gd2*k2**4*(10*r**2 + 2*r*(5*s + 2) + 15*s - 15)) + 264*fd*g2*k2**4*(5*r + 8)*(2*r + 2*s - 1)) + Dd*f*(10*f**2*k2**4*(508*r**2 + r*(288*s - 1135) - 220*s**2 - 864*s + 703) + 11*f*(10*k1**4*(C*(r*(408*s - 500) + 408*s**2 - 864*s + 404) - 4*r*(57*s - 83) - 228*s**2 + 549*s - 272) + k1**2*k2**2*(-4*C*(528*r**2 + 6*r*(412*s + 3) + 1944*s**2 - 433*s - 616) + 984*r**2 + 8*r*(813*s + 86) + 5520*s**2 - 653*s - 2100) + 18*k2**4*(C*(96*r**2 + 24*r*(4*s - 3) - 4*s + 2) - 136*r**2 - 2*r*(88*s - 61) - 40*s**2 + 54*s - 17)) + 264*g2*k2**4*(20*r**2 + 5*r*(4*s + 3) + 31*s - 23))))/(3465*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**5*(D1*bd1*f**2*s*(3*s - 5) + 7*b1**2*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s*(s - 1) + D1*fd*(6*s**2 - 13*s + 5) + 2*Dd*f*(6*s**2 - 13*s + 5)))/(35*d**2*k1*k2) - 2*D1**3*Pk1*Pk3*ct**5*(168*b1**2*k1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(5 - 5*C)) - 3*b1*f*(2*D1*(-56*bd1*k1**2*s*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(5 - 5*C)) + fd*(k1**4*s*(168*C - 84)*(2*s - 1) + k1**2*k2**2*(2*C*(54*r*s - 34*r + 57*s - 25) + 9*r*s + 13*r + 372*s**2 - 486*s + 143) + 132*k2**4*r**2)) + Dd*f*(k1**4*s*(672*C - 336)*(2*s - 1) + k1**2*k2**2*(4*C*(108*r*s - 68*r + 117*s - 55) + 36*r*s + 52*r + 1488*s**2 - 1983*s + 602) + 132*k2**4*r*(4*r - 1))) - f**2*(D1*(3*bd1*(k1**4*s**2*(336*C - 168) + k1**2*k2**2*(120*C*s + r*(4*C*(27*s - 5) + 9*s + 10) + 372*s**2 - 333*s + 10) + 132*k2**4*r*(r - 1)) + fd*(40*k1**4*(3*s - 1)*(C*(30*s - 28) - 18*s + 21) + k1**2*k2**2*(4*C*(18*r*s + 3*r - 186*s + 59) + 423*r*s - 294*r + 2124*s**2 - 1017*s + 154) + 2*k2**4*(315*r**2 - 48*r - 19))) + Dd*f*(80*k1**4*(2*s - 1)*(C*(30*s - 28) - 18*s + 21) + k1**2*k2**2*(4*C*(8*r*(3*s - 2) - 256*s + 129) + 564*r*s - 412*r + 2832*s**2 - 1791*s + 220) + 2*k2**4*(420*r**2 - 29*r - 19))))/(315*d**2*k1**3*k2*k3**2) - 2*D1**3*Pk1*Pk3*ct**5*(924*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(13*C - 10)*(s - 1) + k2**2*r*(5 - 5*C))*(r + s - 1) + Dd*f*(k1**2*(2*C*(52*r*s - 44*r + 52*s**2 - 87*s + 35) - 80*r*s + 70*r - 80*s**2 + 135*s - 55) + k2**2*r*(10 - 10*C)*(4*r + 4*s - 3))) - 33*b1*f*(-2*D1*(14*bd1*k1**2*k2**2*(k1**2*(2*C*(26*r*s - 18*r + 26*s**2 - 35*s + 9) - 40*r*s + 30*r - 40*s**2 + 55*s - 15) + k2**2*r*(10 - 10*C)*(2*r + 2*s - 1)) + fd*(-30*f*k2**6*r**2 + 12*k1**6*(2*s - 1)*(C*(38*s - 40) - 22*s + 25) + k1**4*k2**2*(-4*C*(3*r*(120*s - 67) + 696*s**2 - 719*s + 154) + r*(1011*s - 635) + 2232*s**2 - 2444*s + 559) - k1**2*k2**4*(4*C*(23*r**2 + r*(171 - 298*s) + 32*s - 32) + 14*K*r*s - 7*K*s + 3*f*(12*r*s - 9*r + 2*s - 1) + 136*r**2 + 1778*r*s - 977*r + 372*s**2 - 493*s + 221))) + Dd*f*(20*f*k2**6*r*(4*r - 1) - 48*k1**6*(2*s - 1)*(C*(38*s - 40) - 22*s + 25) + k1**4*k2**2*(4*C*(12*r*(120*s - 67) + 2784*s**2 - 3332*s + 991) + r*(2540 - 4044*s) - 8928*s**2 + 11177*s - 3486) + 2*k1**2*k2**4*(2*C*(92*r**2 - 1192*r*s + 701*r + 136*s - 100) + 28*K*r*s - 7*K*s + 3*f*(4*r - 1)*(4*s - 3) + 272*r**2 + 3556*r*s - 2102*r + 744*s**2 - 1012*s + 384))) - f*(D1*(2*f**2*k2**4*(33*bd1*(3*k1**2*(4*r*s - 3*r - 6*s + 4) + 10*k2**2*r*(r - 1)) + 5*fd*(4*r - 1)*(44*k1**2*(3*s - 2) + 15*k2**2*(3*r + 2))) - 11*f*k1**2*(3*bd1*(24*k1**4*s*(C*(38*s - 40) - 22*s + 25) + k1**2*k2**2*(-4*C*(15*r*(24*s - 13) + 696*s**2 - 800*s + 285) + r*(1011*s - 650) + 2232*s**2 - 2639*s + 950) - 2*k2**4*(2*C*(23*r**2 + r*(37 - 298*s) + 42*s - 6) + 68*r**2 + r*(s*(7*K + 889) - 186) + 186*s**2 - 180*s + 10)) + fd*(40*k1**4*(3*s - 1)*(14*C*(3*s - 4) - 24*s + 35) + k1**2*k2**2*(-12*C*(r*(621*s - 669) + 1422*s**2 - 1401*s + 463) + r*(4869*s - 6474) + 13320*s**2 - 14355*s + 4922) - 2*k2**4*(6*C*(111*r**2 - 16*r*(30*s + 7) - 314*s + 183) - 171*r**2 + 9*r*(488*s + 27) + 1062*s**2 + 1482*s - 1162)) + 84*gd2*k2**4*r*s) + 924*fd*g2*k1**2*k2**4*s*(1 - 2*r)) + Dd*f*(10*f**2*k2**4*(4*r - 1)*(44*k1**2*(3*s - 2) + 15*k2**2*(3*r + 2)) - 11*f*k1**2*(80*k1**4*(2*s - 1)*(14*C*(3*s - 4) - 24*s + 35) + k1**2*k2**2*(-12*C*(828*r*s - 852*r + 1896*s**2 - 2095*s + 683) + 6492*r*s - 8132*r + 17760*s**2 - 21309*s + 7436) + 2*k2**4*(C*(-888*r**2 + 3840*r*s + 166*r + 2504*s - 1718) + 228*r**2 - 5856*r*s + 717*r - 1416*s**2 - 1717*s + 1751)) + 924*g2*k1**2*k2**4*s*(1 - 4*r))))/(3465*d**2*k1**3*k2*k3**4) - D1**3*Pk1*Pk3*ct**4*f*k2**6*st**4*(96*C - 96)*(2*r + 2*s - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d**2*k3**8) - D1**3*Pk1*Pk3*ct**4*f*k2**4*st**4*(32*C - 32)*(3*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(r*(12*s - 5) + 3*(1 - 2*s)**2) + Dd*f*(2*s - 1)*(8*r + 8*s - 5)))/(7*d**2*k3**6) - D1**3*Pk1*Pk3*ct**4*f*k2**2*st**4*(32*C - 32)*(2*s - 1)*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(7*d**2*k3**4) + 8*D1**3*Pk1*Pk3*ct**4*k2**4*st**2*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K - 30*b1*(2*r + 2*s - 1) + 51*r + 51*s - 29)) + k2**2*(r + s)*(168*K*b1 - 168*b1 - 168*g2)) + 198*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (14 - 14*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (14 - 14*K)*(r + s))*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) + 6*f*(fd*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29)) - 168*g2*k2**2*(r + s))) - f*(D1*(25*f**2*fd*k2**2*(1204*r**2 + r*(2408*s - 1619) + 1204*s**2 - 1619*s + 537) + 22*f*(fd*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1)) - 396*fd*g2*k2**2*(10*r**2 + r*(20*s - 3) + 10*s**2 - 3*s - 1)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(301*r + 301*s - 179) + 22*f*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(5*r + 5*s + 1))))/(1155*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct**4*k2**2*(33*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + k1**2*k2**2*(28*C*(8*r + 8*s - 5) + 6*K*(3*r + 3*s - 5) + b1*(25*r + 25*s - 23) - 194*r - 194*s + 132) - 7*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) - 140*k2**2*(r + s)*(b1*(k1**2 - k2**2*(K - 1)) + g2*k2**2)) - 33*b1**2*k2**2*(D1*fd*(-3*f*(k1**2*(25*r + 25*s - 23) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (70*k1**2 - 70*k2**2*(K - 1))*(r + s)**2) - Dd*f*(f*(k1**2*(75*r + 75*s - 69) - 42*k2**2*(2*r + 2*s - 1)) + (-70*k1**2 + 70*k2**2*(K - 1))*(r + s))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + 2*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 70*gd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1))) - 140*fd*g2*k2**4*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 140*g2*k2**4*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 22*f*(5*fd*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) - 18*gd2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(r + s - 1)) - 396*fd*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11)) + 110*f*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) - 396*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)))))/(1155*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct**4*k2**2*st**2*(33*D1*bd1*f*(168*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*f**2*k2**4*(r - 1)*(30*r + 30*s - 17) + f*k1**2*(6*k1**2*(6*C*(68*r*s - 31*r + 68*s**2 - 96*s + 31) - 284*r*s + 141*r - 284*s**2 + 424*s - 141) + k2**2*(-4*C*(420*r**2 + 657*r*s - 527*r + 237*s**2 - 297*s + 107) + 1548*r**2 + 2544*r*s - 1997*r + 996*s**2 - 1212*s + 449))) + 5544*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(2*D1*fd*(3*f*k2**4*r*(30*r + 30*s - 17) + 6*k1**4*(6*C*(68*r*s - 41*r + 68*s**2 - 82*s + 24) - 284*r*s + 177*r - 284*s**2 + 354*s - 106) + k1**2*k2**2*(-2*C*(840*r**2 + 1314*r*s - 655*r + 474*s**2 - 444*s + 96) + 1548*r**2 + 2544*r*s - 1310*r + 996*s**2 - 978*s + 225)) + Dd*f*(2*f*k2**4*(4*r - 1)*(30*r + 30*s - 17) + 6*k1**4*(6*C*(4*r*(68*s - 41) + 272*s**2 - 376*s + 127) - 1136*r*s + 708*r - 1136*s**2 + 1628*s - 565) + k1**2*k2**2*(-4*C*(1680*r**2 + 4*r*(657*s - 440) + 948*s**2 - 1089*s + 314) + 6192*r**2 + 10176*r*s - 6908*r + 3984*s**2 - 4674*s + 1409))) + f**2*(D1*fd*(f*k2**4*(6920*r**2 + 8*r*(865*s - 1008) - 3105*s + 2271) + 132*k1**4*(C*(1026*r*s - 561*r + 1026*s**2 - 1200*s + 359) - 729*r*s + 411*r - 729*s**2 + 873*s - 266) - 22*k1**2*k2**2*(2*C*(1494*r**2 + 3*r*(879*s - 340) + 1143*s**2 - 741*s + 1) - 2880*r**2 - 3*r*(1773*s - 748) - 2439*s**2 + 1797*s - 165)) + Dd*f*(f*k2**4*(6920*r**2 + 8*r*(865*s - 1008) - 3105*s + 2271) + 66*k1**4*(2*C*(1368*r*s - 812*r + 1368*s**2 - 1746*s + 563) - 1944*r*s + 1174*r - 1944*s**2 + 2529*s - 829) - 11*k1**2*k2**2*(4*C*(1992*r**2 + 3516*r*s - 1634*r + 1524*s**2 - 1169*s + 48) - 7680*r**2 - 14184*r*s + 7138*r - 6504*s**2 + 5591*s - 701))))/(3465*d**2*k1**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**4*st**2*(1008*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 9*b1*f*(4*D1*(-56*bd1*k1**2*s*(C - 1)*(s - 1) + fd*(2*s - 1)*(k1**2*(2*C*(25*s - 9) - 46*s + 23) + 9*k2**2*r)) + Dd*f*(2*s - 1)*(8*k1**2*(2*C*(25*s - 9) - 46*s + 23) + k2**2*(72*r + 5))) - f**2*(D1*(36*bd1*k1**2*s*(2*C*(25*s - 9) - 46*s + 23) + 9*bd1*k2**2*(r*(36*s + 5) + 10*s - 5) + 4*fd*k1**2*(3*s - 1)*(30*C*(9*s - 5) - 273*s + 175) + 2*fd*k2**2*(3*r*(75*s - 34) + 51*s - 8)) + Dd*f*(8*k1**2*(2*s - 1)*(30*C*(9*s - 5) - 273*s + 175) + k2**2*(10*r*(60*s - 37) + 137*s - 51))))/(315*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**4*st**2*(-2016*b1**2*k1**2*k2**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 3*b1*f*(D1*(-672*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-48*k1**4*(2*s - 1)*(2*C*(87*s - 61) - 118*s + 87) + 16*k1**2*k2**2*(C*(936*r*s - 482*r + 624*s**2 - 573*s + 120) - 858*r*s + 464*r - 636*s**2 + 627*s - 144) + 3*k2**4*r*(21*f*(5*s - 3) + 16*r*(2*C + 16) + 288*s - 144))) + Dd*f*(-96*k1**4*(2*s - 1)*(2*C*(87*s - 61) - 118*s + 87) + 4*k1**2*k2**2*(8*C*(936*r*s - 482*r + 624*s**2 - 705*s + 200) - 6864*r*s + 3712*r - 5088*s**2 + 6078*s - 1837) + 3*k2**4*(7*f*(4*r - 1)*(5*s - 3) + r**2*(64*C + 512) - 16*r*(C - 36*s + 26) + 40*s - 20))) + f**2*(D1*(-144*bd1*k1**4*s*(2*C*(87*s - 61) - 118*s + 87) + 12*bd1*k1**2*k2**2*(4*C*(4*r*(117*s - 31) + 312*s**2 - 387*s + 142) + r*(541 - 1716*s) - 1272*s**2 + 1650*s - 613) + 9*bd1*k2**4*(7*f*(r - 1)*(5*s - 3) + 4*r**2*(4*C + 32) + 4*r*(-4*C + 36*s - 27) + 40*s - 20) - 16*fd*k1**4*(3*s - 1)*(C*(894*s - 610) - 621*s + 435) + 8*fd*k1**2*k2**2*(C*(27*r*(163*s - 90) + 3096*s**2 - 2847*s + 926) - 6*r*(699*s - 401) - 3258*s**2 + 3264*s - 1062) + fd*k2**4*(-8*C*(99*r**2 + 294*r - 109) + 69*f*(4*r - 1)*(5*s - 3) + 1728*r**2 + 312*r*(3*s + 8) + 696*s - 1360)) + Dd*f*(-32*k1**4*(2*s - 1)*(C*(894*s - 610) - 621*s + 435) + 4*k1**2*k2**2*(2*C*(12*r*(489*s - 302) + 4128*s**2 - 4187*s + 1234) + r*(7090 - 11184*s) - 8688*s**2 + 9557*s - 2981) + k2**4*(-8*C*(132*r**2 + 403*r - 109) + 69*f*(4*r - 1)*(5*s - 3) + 2304*r**2 + 1248*r*s + 3128*r + 836*s - 1500))))/(315*d**2*k1**2*k3**4) + 8*D1**3*Pk1*Pk3*ct**4*(-11*D1*bd1*f*(f**2*k2**4*(k1**2*(240*r**2 + r*(882*s - 407) + 642*s**2 - 841*s + 103) - 18*k2**2*(r - 1)*(5*r + 5*s - 3)) + 3*f*k1**2*(12*k1**4*(C*(r*(9*s - 25) + 9*s**2 - 44*s + 25) + r*(15 - 4*s) - 4*s**2 + 25*s - 15) + k1**2*k2**2*(4*C*(88*r**2 + r*(8*s - 70) - 80*s**2 + 91*s - 18) - 321*r**2 + r*(370 - 310*s) + 11*s**2 - 33*s - 49) + k2**4*(28*C*(36*r**2 + 57*r*s - 46*r + 21*s**2 - 27*s + 10) + 56*K*r**2 + 100*K*r*s - 232*K*r + 44*K*s**2 - 258*K*s + 214*K + 2*b1*(66*r**2 + 4*r*(33*s - 23) + 66*s**2 - 78*s + 19) - 1132*r**2 - 1920*r*s + 1638*r - 788*s**2 + 1212*s - 557)) - 21*k1**2*k2**2*(6*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(4 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 4*K*(16*r**2 + 17*r*(s - 1) + (s - 1)**2) - 88*r**2 - 128*r*s + 115*r - 40*s**2 + 61*s - 24)) + 2*k2**2*(3*b2*(r + s) - 2*g2*(16*r + s))*(r + s - 1))) + 1386*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(84*C - 28)*(r + s - 1)**2 + k2**2*(-140*C*(r + s - 1)**2 - 14*K*(16*r**2 + r*(17*s - 4) + s**2 - 4*s + 2) + f*(132*r**2 + 4*r*(66*s - 37) + 132*s**2 - 141*s + 45) + 308*r**2 + 112*r*(4*s - 3) + 140*s**2 - 336*s + 168)) + Dd*f*(k1**2*(84*C - 28)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*K*(64*r**2 + 68*r*s - 56*r + 4*s**2 - 11*s + 6) + f*(264*r**2 + 4*r*(132*s - 83) + 264*s**2 - 297*s + 83) + 1232*r**2 + 1792*r*s - 1638*r + 560*s**2 - 1071*s + 504))) - 11*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(240*r**2 + r*(882*s - 205) + 642*s**2 - 464*s + 42) - 18*k2**2*r*(5*r + 5*s - 3)) + f*k1**2*(fd*(6*k1**4*(2*C*(r*(18*s - 37) + 18*s**2 - 53*s + 22) + r*(43 - 16*s) - 16*s**2 + 58*s - 25) + k1**2*k2**2*(4*C*(176*r**2 + 2*r*(8*s + 61) - 160*s**2 + 423*s - 176) - 642*r**2 - r*(620*s + 87) + 22*s**2 - 923*s + 480) + k2**4*(28*C*(72*r**2 + 114*r*s - 53*r + 42*s**2 - 36*s + 6) + 8*K*(14*r**2 + 25*r*s - 63*r + 11*s**2 - 65*s + 28) - 2264*r**2 - 3840*r*s + 2208*r - 1576*s**2 + 1857*s - 468)) + 14*k2**4*(-3*bd2*(r + s) + 2*gd2*(16*r + s - 2))*(r + s - 1)) + 14*fd*k1**2*k2**4*(-3*b2*(r + s)**2 + 2*g2*(16*r**2 + r*(17*s - 4) + s**2 - 4*s + 2))) + Dd*f*(f**2*k2**4*(k1**2*(960*r**2 + 14*r*(252*s - 73) + 2568*s**2 - 2233*s + 229) - 18*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 3*f*k1**2*(6*k1**4*(2*C*(r*(36*s - 74) + 36*s**2 - 128*s + 69) + r*(86 - 32*s) - 32*s**2 + 141*s - 80) + k1**2*k2**2*(4*C*(352*r**2 + 2*r*(16*s + 69) - 320*s**2 + 761*s - 361) - 1284*r**2 + r*(243 - 1240*s) + 44*s**2 - 1399*s + 863) + k2**4*(28*C*(144*r**2 + 4*r*(57*s - 37) + 84*s**2 - 93*s + 25) + 4*K*(56*r**2 + 100*r*s - 242*r + 44*s**2 - 259*s + 163) - 4528*r**2 - 7680*r*s + 5610*r - 3152*s**2 + 4407*s - 1575)) + 42*k1**2*k2**4*(-3*b2*(r + s) + 2*g2*(16*r + s - 2))*(4*r + 4*s - 3))) + f*(D1*(10*f**2*fd*k2**4*(-k1**2*(1752*r**2 + 10*r*(382*s - 393) + 2068*s**2 - 4519*s + 2138) + 11*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 11*f*k1**2*(fd*(10*k1**4*(2*C*(9*r*s - 84*r + 9*s**2 - 99*s + 59) + 99*r + 108*s - 69) + k1**2*k2**2*(4*C*(1683*r**2 + 9*r*(181*s - 258) - 54*s**2 - 1344*s + 860) - 5373*r**2 - 6876*r*s + 7683*r - 1503*s**2 + 5364*s - 2821) + 9*k2**4*(4*C*(213*r**2 + 327*r*s - 204*r + 114*s**2 - 131*s + 39) - 870*r**2 - 1416*r*s + 881*r - 546*s**2 + 630*s - 189)) - 6*k2**4*(3*bd2*(3*r**2 + 6*r*s - r + 3*s**2 - s - 2) + 2*gd2*(28*r**2 + 50*r*s - 116*r + 22*s**2 - 129*s + 107))) + 66*fd*k1**2*k2**4*(3*b2*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2) + 8*g2*(14*r**2 + r*(25*s - 63) + 11*s**2 - 65*s + 28))) + Dd*f*(10*f**2*k2**4*(-k1**2*(1752*r**2 + 10*r*(382*s - 393) + 2068*s**2 - 4519*s + 2138) + 11*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 11*f*k1**2*(10*k1**4*(2*C*(12*r*s - 98*r + 12*s**2 - 126*s + 83) + 114*r + 135*s - 96) + k1**2*k2**2*(4*C*(2244*r**2 + 2172*r*s - 3027*r - 72*s**2 - 1658*s + 1192) - 7164*r**2 - 9168*r*s + 10201*r - 2004*s**2 + 6999*s - 3955) + 9*k2**4*(4*C*(284*r**2 + 436*r*s - 297*r + 152*s**2 - 188*s + 58) - 1160*r**2 - 1888*r*s + 1286*r - 728*s**2 + 908*s - 285)) + 66*k1**2*k2**4*(3*b2*(12*r**2 + r*(24*s - 1) + 12*s**2 - s - 6) + 4*g2*(56*r**2 + 2*r*(50*s - 121) + 44*s**2 - 259*s + 163)))))/(3465*d**2*k1**2*k3**6) + 4*D1**3*Pk1*Pk3*ct**4*(D1*bd1*f**2*(k1**2*s*(24*C - 12)*(3*s - 5) + k2**2*(r*(9*s + 10) + 24*s)) + 7*b1**2*(4*D1*fd*(s - 1)*(k1**2*(6*C - 3)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(48*C - 24)*(2*s**2 - 3*s + 1) + k2**2*(16*r*s - 2*r + 3*s - 3))) + b1*f*(D1*(168*bd1*k1**2*s*(2*C - 1)*(s - 1) + 7*bd1*k2**2*(8*r*s + 6*r + 3*s - 3) + fd*k1**2*(24*C - 12)*(6*s**2 - 13*s + 5) + fd*k2**2*(r*(18*s + 5) + 54*s - 34)) + 2*Dd*f*(k1**2*(24*C - 12)*(6*s**2 - 13*s + 5) + k2**2*(r*(18*s + 5) + 51*s - 29))))/(105*d**2*k1**2*k2**2) - 2*D1**3*Pk1*Pk3*ct**4*(-21*b1**2*(2*D1*fd*(k1**4*(12 - 24*C)*(s - 1)**2 + 6*k1**2*k2**2*(s - 1)*(4*C*(r + s - 1) - 3*r - 4*s + 4) + k2**4*r*(f*(3*s - 2) + r*(14*C - 14))) + Dd*f*(k1**4*(48 - 96*C)*(2*s**2 - 3*s + 1) + 6*k1**2*k2**2*(4*C*(r*(8*s - 6) + 8*s**2 - 13*s + 5) - 6*r*(4*s - 3) - 32*s**2 + 51*s - 19) + k2**4*(4*r - 1)*(f*(3*s - 2) + r*(28*C - 28)))) - 3*b1*f*(-7*D1*bd1*(k1**4*s*(96*C - 48)*(s - 1) - 6*k1**2*k2**2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + r*(6 - 12*s) - 16*s**2 + 19*s - 3) - k2**4*(2*r - 1)*(f*(3*s - 2) + r*(28*C - 28))) + k2**2*(-D1*fd*(2*k1**2*(2*C*(r*(9*s + 34) + 292*s**2 - 286*s + 42) - r*(9*s + 34) - 614*s**2 + 675*s - 142) + k2**2*(-36*C*(1 - 2*r)**2 - 9*f*(3*r - 1)*(3*s - 2) + 36*r**2 + 740*r*s - 528*r + 14*s + 36)) + Dd*f*(k1**2*(-2*C*(4*r*(9*s + 34) + 1168*s**2 - 1297*s + 318) + 4*r*(9*s + 34) + 2456*s**2 - 2901*s + 798) + k2**2*(36*C*(8*r**2 - 6*r + 1) + 9*f*(4*r - 1)*(3*s - 2) - 72*r**2 - 1480*r*s + 930*r + 10*s - 48)))) + f**2*(D1*(3*bd1*k2**2*(k1**2*(2*C*(9*r*s + 10*r + 292*s**2 - 269*s + 70) - 9*r*s - 10*r - 614*s**2 + 533*s - 110) + k2**2*(r**2*(18 - 72*C) + r*(36*C - 27*f*s + 18*f + 370*s + 6) - 24*s + 12)) + fd*(-k1**4*(80*C - 40)*(9*s**2 - 24*s + 7) + k1**2*k2**2*(C*(-6*r*(87*s + 106) + 3888*s**2 - 2418*s + 644) + 477*r*s + 570*r - 3978*s**2 + 3789*s - 1064) + 2*k2**4*(2*C*(9*r**2 + 12*r - 5) - 234*r**2 + 846*r*s - 99*r + 510*s - 205))) + Dd*f*(k1**4*(80 - 160*C)*(6*s**2 - 17*s + 7) + k1**2*k2**2*(C*(-8*r*(87*s + 56) + 5184*s**2 - 3946*s + 876) + r*(636*s + 500) - 5304*s**2 + 5859*s - 1808) + 2*k2**4*(2*C*(12*r**2 + 17*r - 5) - 312*r**2 + 12*r*(94*s - 29) + 679*s - 374))))/(315*d**2*k1**2*k2**2*k3**2) - D1**3*Pk1*Pk3*ct**4*(33*b1**2*k2**2*(2*D1*fd*(k1**4*(448*C - 252)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(8*C*(11*r**2 + 17*r*(s - 1) + 6*(s - 1)**2) - 76*r**2 + r*(5*K*s - 9*f*s + 5*f - 129*s + 124) - 48*(s - 1)**2) + 2*k2**4*r*(f*(60*r + 60*s - 31) - 7*r*(7*K - 3) - 28*s)) + Dd*f*(112*k1**4*(C*(r*(32*s - 34) + 32*s**2 - 57*s + 25) - 3*r*(6*s - 7) - 18*s**2 + 33*s - 15) - 7*k1**2*k2**2*(16*C*(44*r**2 + r*(68*s - 47) + 24*s**2 - 37*s + 13) - f*(4*r - 1)*(9*s - 5) - 608*r**2 + 8*r*(s*(5*K - 129) + 82) - 384*s**2 - 2*s*(5*K - 295) - 196) + 4*k2**4*(2*f*(60*r**2 + r*(60*s - 49) - 18*s + 10) - 7*r**2*(28*K - 12) - 7*r*(-7*K + 16*s - 11) - 21*s))) + 11*b1*(3*D1*(f**2*k2**4*(7*bd1*k1**2*(2*r - 1)*(9*s - 5) + 4*bd1*k2**2*(60*r**2 + r*(60*s - 67) - 36*s + 20) + 9*fd*k1**2*(6*r - 9*s + 5) + fd*k2**2*(432*r**2 + 3*r*(347*s - 391) - 512*s + 396)) + 2*f*(fd*(k1**6*(48*C - 24)*(6*s**2 - 13*s + 5) - 2*k1**4*k2**2*(C*(306*r*s - 468*r + 2392*s**2 - 3128*s + 840) - 7*r*(21*s - 43) - 1606*s**2 + 2239*s - 634) + k1**2*k2**4*(C*(-80*r**2 + 4*r*(1043*s - 732) + 64*s**2 - 824*s + 820) + 49*K*s + 4*r**2 + r*(-98*K*s - 3470*s + 2456) + 308*s**2 + 549*s - 726) - 2*k2**6*(9*K*(1 - 2*r)**2 - r**2*(168*C - 136) + r*(4*s + 74) + 61*s - 29)) + 7*k2**2*(bd1*(8*k1**4*(C*(2*r*(8*s - 9) + 16*s**2 - 25*s + 9) - 3*r*(3*s - 4) - 9*s**2 + 15*s - 6) + k1**2*k2**2*(-8*C*(22*r**2 + r*(34*s - 13) + 12*s**2 - 13*s + 1) + 5*K*s + 152*r**2 - 2*r*(5*K*s - 129*s + 40) + 96*s**2 - 103*s + 2) + 2*k2**4*(r**2*(6 - 14*K) + r*(7*K - 8*s + 4) - 3*s)) + 2*gd2*k2**2*r*(5*k1**2*s + 14*k2**2*r))) + 28*fd*g2*k2**4*r*(5*k1**2*s + 14*k2**2*r)) + Dd*f*(f**2*k2**4*(54*k1**2*(4*r - 1) + k2**2*(1728*r**2 + 12*r*(347*s - 360) - 2251*s + 1577)) + 6*f*(k1**6*(96*C - 48)*(6*s**2 - 13*s + 5) + k1**4*k2**2*(-2*C*(36*r*(17*s - 26) + 4784*s**2 - 6937*s + 2430) + 28*r*(21*s - 43) + 6424*s**2 - 9769*s + 3506) + k1**2*k2**4*(-2*C*(80*r**2 + r*(2900 - 4172*s) - 64*s**2 + 787*s - 586) + 49*K*s + 8*r**2 - 2*r*(98*K*s + 3470*s - 2455) + 616*s**2 + 867*s - 948) - 2*k2**6*(9*K*(8*r**2 - 6*r + 1) + r**2*(272 - 336*C) + 2*r*(42*C + 4*s + 9) + 67*s - 56)) + 84*g2*k2**4*(4*r - 1)*(5*k1**2*s + 14*k2**2*r))) + f*(D1*(f**2*k2**4*(11*bd1*(27*k1**2*(2*r + 9*s - 7) + k2**2*(432*r**2 + 1041*r*s - 801*r - 715*s + 389)) - 5*fd*(55*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(1632*r**2 - 28*r*(55*s + 26) - 4125*s + 2335))) + 22*f*(3*bd1*(k1**6*s*(48*C - 24)*(3*s - 5) + k1**4*k2**2*(-2*C*(3*r*(51*s - 130) + 1196*s**2 - 1593*s + 570) + 49*r*(3*s - 10) + 1606*s**2 - 2177*s + 730) + k1**2*k2**4*(C*(-40*r**2 + r*(2086*s - 460) + 32*s**2 - 386*s + 20) + 2*r**2 + r*(-49*K*s - 1735*s + 346) + 154*s**2 + 172*s + 78) + 2*k2**6*(r**2*(84*C - 18*K - 68) + r*(-84*C + 9*K - 2*s + 91) + 18*s + 3)) + fd*(k1**6*(80*C - 40)*(9*s**2 - 24*s + 7) + k1**4*k2**2*(2*C*(333*r*s + 3102*r - 6696*s**2 + 9033*s - 3338) - 909*r*s - 3954*r + 8694*s**2 - 12837*s + 4732) + 2*k1**2*k2**4*(C*(-3204*r**2 + 3*r*(951*s + 1490) + 360*s**2 + 6603*s - 3692) + 2520*r**2 - 3*r*(729*s + 1253) + 315*s**2 - 6285*s + 3276) + 18*k2**6*(r**2*(36*C - 24) + r*(-12*C + 12*s + 7) + 6*s - 3)) + 6*gd2*k2**4*r*(49*k1**2*s + 18*k2**2*(2*r - 1))) + 132*g2*k2**4*(7*bd1*(r - 1)*(5*k1**2*s + 14*k2**2*r) + fd*(2*r - 1)*(49*k1**2*s + 18*k2**2*(2*r - 1)))) + Dd*f*(-5*f**2*k2**4*(55*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(1632*r**2 - 28*r*(55*s + 26) - 4125*s + 2335)) + 22*f*(k1**6*(160*C - 80)*(6*s**2 - 17*s + 7) + k1**4*k2**2*(2*C*(4*r*(111*s + 844) - 8928*s**2 + 13189*s - 5262) - 4*r*(303*s + 1073) + 11592*s**2 - 18659*s + 7656) - 2*k1**2*k2**4*(C*(4272*r**2 - 4*r*(951*s + 1189) - 480*s**2 - 8617*s + 5826) - 3360*r**2 + 4*r*(729*s + 976) - 420*s**2 + 8279*s - 5165) + 18*k2**6*(12*C*r*(4*r - 1) - 32*r**2 + 16*r*s + 6*s - 3)) + 132*g2*k2**4*(4*r - 1)*(49*k1**2*s + 18*k2**2*(2*r - 1)))))/(3465*d**2*k1**2*k2**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**3*f*k2**5*st**4*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(4*r + 4*s - 3)) + f*(D1*fd*(5*f*k2**2*(724*r**2 + r*(1448*s - 987) + 724*s**2 - 987*s + 333) + 22*k1**2*(3*r + 3*s - 2)*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71)) + Dd*f*(5*f*k2**2*(181*r + 181*s - 111) + 22*k1**2*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71))*(4*r + 4*s - 3)))/(385*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct**3*f*k2**3*st**4*(3*D1*bd1*f*(k1**2*(C*(304*r*s - 90*r + 304*s**2 - 332*s + 90) - 244*r*s + 75*r - 244*s**2 + 272*s - 75) + k2**2*(-4*C*(27*r**2 + 27*r*s - 32*r - 10*s + 5) + 138*r**2 + 168*r*s - 173*r + 30*s**2 - 85*s + 35)) + 3*b1*(D1*fd*(2*k1**2*(C*(304*r*s - 159*r + 304*s**2 - 318*s + 83) - 244*r*s + 129*r - 244*s**2 + 258*s - 68) - 3*k2**2*(2*r + 2*s - 1)*(r*(36*C - 46) - 10*s + 5)) + Dd*f*(k1**2*(2*C*(608*r*s - 318*r + 608*s**2 - 719*s + 211) - 976*r*s + 516*r - 976*s**2 + 1168*s - 347) + k2**2*(-4*C*(108*r**2 + 27*r*(4*s - 3) - 10*s + 5) + 552*r**2 + 672*r*s - 474*r + 120*s**2 - 190*s + 65))) + f*(D1*fd*(k1**2*(84*C - 69)*(r*(12*s - 5) + 3*(1 - 2*s)**2) + k2**2*(-4*C*(63*r**2 + 63*r*s - 48*r - 15*s + 7) + 342*r**2 + 432*r*s - 297*r + 90*s**2 - 165*s + 58)) + Dd*f*(3*k1**2*(2*C*(224*r*s - 110*r + 224*s**2 - 251*s + 69) - 368*r*s + 180*r - 368*s**2 + 412*s - 113) + k2**2*(C*(-336*r**2 - 336*r*s + 264*r + 70*s - 38) + 456*r**2 + 576*r*s - 414*r + 120*s**2 - 220*s + 83))))/(105*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**3*f*k2*st**4*(2*s - 1)*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(7*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct**3*f*k2*st**4*(3*b1*(2*s - 1)*(2*D1*fd*(k1**2*(146*C*s - 80*C - 116*s + 65) + 3*k2**2*(-18*C*r + 28*r + 10*s - 5)) + Dd*f*(4*k1**2*(146*C*s - 80*C - 116*s + 65) + k2**2*(-216*C*r + 20*C + 336*r + 120*s - 95))) + f*(D1*(6*bd1*k1**2*s*(2*C*(73*s - 40) - 116*s + 65) + 3*bd1*k2**2*(-4*C*(r*(27*s - 5) - 10*s + 5) + 7*r*(24*s - 5) + 60*s**2 - 100*s + 35) + 2*fd*k1**2*(3*s - 1)*(2*C*(81*s - 40) - 132*s + 65) + fd*k2**2*(C*(r*(147 - 306*s) + 78*s - 41) + 6*r*(81*s - 37) + 180*s**2 - 258*s + 86)) + Dd*f*(4*k1**2*(2*s - 1)*(2*C*(81*s - 40) - 132*s + 65) + k2**2*(C*(-8*r*(51*s - 29) + 88*s - 51) + 8*r*(81*s - 44) + 240*s**2 - 358*s + 126))))/(105*d**2*k1*k3**4) - 8*D1**3*Pk1*Pk3*ct**3*k1*k2*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + k1**2*k2**2*(28*C*(7*r + 7*s - 5) + 2*K*(26*r + 26*s - 20) + b1*(-31*r - 31*s + 5) - 166*r - 166*s + 118) - 7*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) + k2**2*(k1**2 + k2**2)*(r + s)*(420*b1*(3 - 4*K) + 1680*g2)) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (210 - 280*K)*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7)) + (210 - 280*K)*(k1**2 + k2**2)*(r + s))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) - 280*gd2*k2**2*(k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 1680*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) + 1680*g2*k2**2*(k1**2 + k2**2)*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 72*gd2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(r + s - 1)) + 1584*fd*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5)) + 110*f*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 1584*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s)))))/(1155*d**2*k3**8) + 16*D1**3*Pk1*Pk3*ct**3*k2**3*st**2*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 46*K*r + 46*K*s + 12*K - 6*b1*(51*r + 51*s - 29) + 431*r + 431*s - 261)) + k1**2*k2**2*(r + s)*(-84*b1*(4 - 7*K) - 588*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (56 - 98*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (56 - 98*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*k1**2*(fd*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261))*(2*r + 2*s - 1) - 196*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 588*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261)) - 588*g2*k1**2*k2**2*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(-523*r - 523*s + 329) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 6*gd2*k2**2*(23*r**2 + r*(46*s - 17) + 23*s**2 - 17*s - 6)) + 132*fd*g2*k1**2*k2**2*(46*r**2 + r*(92*s - 11) + 46*s**2 - 11*s - 6)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*(k1**2*k2**2*(523*r + 523*s - 329) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 132*g2*k1**2*k2**2*(23*r + 23*s + 6))))/(1155*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct**3*k2*st**2*(11*D1*bd1*f*(f**2*k2**4*(264*r**2 + r*(402*s - 377) + 138*s**2 - 383*s + 117) + 3*f*(2*k1**4*(C*(r*(289*s - 207) + 289*s**2 - 562*s + 207) + r*(135 - 169*s) - 169*s**2 + 358*s - 135) + k1**2*k2**2*(-2*C*(272*r**2 + r*(691*s - 434) + 419*s**2 - 434*s + 162) + 361*r**2 + r*(983*s - 590) + 622*s**2 - 595*s + 229) + k2**4*(42*C*(6*r**2 + 6*r*s - 7*r - 2*s + 1) - 14*K*r**2 - 14*K*r*s + 3*b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 307*r**2 - 376*r*s + 408*r - 69*s**2 + 198*s - 87)) + 21*k2**2*(b1*(k1**2*(26*C - 20)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(r**2*(34 - 22*K) + r*(K*(19 - 22*s) + 46*s - 31) + 3*s*(K + 4*s - 5))) + 2*g2*k2**2*(11*r**2 + 11*r*(s - 1) - 3*s))) + 33*b1**2*k2**2*(D1*fd*(k1**2*(182*C - 140)*(r + s - 1)**2 + k2**2*(3*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-7*r*(11*K - 17) + 42*s))) + Dd*f*(k1**2*(182*C - 140)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(6*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 24) - 7*r**2*(44*K - 68) - 7*r*(44*K*s - 27*K - 92*s + 45) + 21*s*(K + 8*s - 7)))) + 11*b1*(3*D1*(f**2*fd*k2**4*(264*r**2 + r*(402*s - 205) + 138*s**2 - 169*s + 57) + f*(fd*(2*k1**4*(C*(r*(578*s - 422) + 578*s**2 - 851*s + 281) + r*(260 - 338*s) - 338*s**2 + 527*s - 179) + k1**2*k2**2*(-2*C*(544*r**2 + r*(1382*s - 783) + 838*s**2 - 916*s + 233) + 722*r**2 + 2*r*(983*s - 595) + 1244*s**2 - 1451*s + 391) - k2**4*(14*K*(2*r**2 + 2*r*s + r - 1) + r**2*(614 - 504*C) + r*(-504*C*s + 252*C + 752*s - 425) + 138*s**2 - 159*s + 59)) + 14*gd2*k2**4*r*(11*r + 11*s - 8)) + 154*fd*g2*k2**4*r*(r + s)) + Dd*f*(2*f**2*k2**4*(528*r**2 + r*(804*s - 496) + 276*s**2 - 445*s + 144) + 3*f*(2*k1**4*(C*(4*r*(289*s - 211) + 1156*s**2 - 1983*s + 769) + r*(520 - 676*s) - 676*s**2 + 1233*s - 493) + k1**2*k2**2*(-2*C*(1088*r**2 + 4*r*(691*s - 475) + 1676*s**2 - 2033*s + 659) + 1444*r**2 + r*(3932*s - 2835) + 2488*s**2 - 3106*s + 1058) + k2**4*(42*C*(24*r**2 + 6*r*(4*s - 3) - 2*s + 1) - 14*K*(4*r**2 + 4*r*s + r - 1) - 1228*r**2 - 1504*r*s + 1157*r - 276*s**2 + 471*s - 191)) + 42*g2*k2**4*(44*r**2 + r*(44*s - 27) - 3*s))) + f*(D1*(2*f**2*fd*k2**4*(3748*r**2 + r*(2868*s - 4199) - 880*s**2 - 1256*s + 1305) + 11*f*(fd*(3*k1**4*(2*C*(9*r*(61*s - 39) + 549*s**2 - 729*s + 238) - 666*r*s + 441*r - 666*s**2 + 912*s - 303) + k1**2*k2**2*(-4*C*(360*r**2 + 9*r*(163*s - 36) + 1107*s**2 - 651*s - 1) + 963*r**2 + 4329*r*s - 1077*r + 3366*s**2 - 2058*s + 83) + 18*k2**4*(C*(60*r**2 + 60*r*s - 44*r - 8*s + 4) - 78*r**2 - 96*r*s + 65*r - 18*s**2 + 29*s - 10)) + 84*gd2*k2**4*r*(r + s)) + 924*fd*g2*k2**4*(2*r**2 + 2*r*s + r - 1)) + Dd*f*(2*f**2*k2**4*(3748*r**2 + r*(2868*s - 4199) - 880*s**2 - 1256*s + 1305) + 11*f*(3*k1**4*(2*C*(732*r*s - 472*r + 732*s**2 - 1035*s + 361) - 888*r*s + 582*r - 888*s**2 + 1287*s - 456) + k1**2*k2**2*(-2*C*(960*r**2 + 6*r*(652*s - 221) + 2952*s**2 - 2173*s + 131) + 1284*r**2 + 5772*r*s - 2233*r + 4488*s**2 - 3463*s + 366) + 18*k2**4*(C*(80*r**2 + 80*r*s - 60*r - 8*s + 4) - 104*r**2 - 128*r*s + 90*r - 24*s**2 + 38*s - 13)) + 924*g2*k2**4*(4*r**2 + 4*r*s + r - 1))))/(3465*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**3*st**2*(D1*bd1*f**2*s*(5*s - 6) + 14*b1**2*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(28*D1*bd1*s*(s - 1) + D1*fd*(10*s**2 - 17*s + 6) + 2*Dd*f*(10*s**2 - 17*s + 6)))/(35*d**2*k1*k2) - 2*D1**3*Pk1*Pk3*ct**3*(33*b1**2*(D1*fd*(k1**4*(56*C - 28)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(16*C*(r + s - 1)**2 - 10*r**2 + r*(10*K*s - 12*f*s + 8*f - 9*s + 4) + 6*(s - 1)**2) + 2*k2**4*(7*K*(13*r**2 + 31*r*s - 24*r - 12*s + 12) + 2*f*(32*r**2 + 2*r*(58*s - 15) + 84*s**2 - 101*s + 24) + 7*r**2*(20*C - 40) + 7*r*(20*C*(s - 1) - 49*s + 44) + 63*s**2 + 84*s - 84)) + Dd*f*(k1**4*(56*C - 28)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) - 7*k1**2*k2**2*(8*C*(8*r**2 + 4*r*(4*s - 1) + 8*s**2 - 9*s + 1) + 40*K*r*s - 10*K*s - 2*f*(4*r - 1)*(3*s - 2) - 40*r**2 - 36*r*s - 38*r + 24*s**2 - 59*s + 40) + 2*k2**4*(7*K*(52*r**2 + r*(124*s - 107) - 32*s + 24) + 2*f*(64*r**2 + 8*r*(29*s - 13) + 168*s**2 - 228*s + 65) + 7*r**2*(80*C - 160) + 28*r*(5*C*(4*s - 3) - 49*s + 48) + 252*s**2 + 21*s - 168))) + 11*b1*(3*D1*bd1*f*(k1**4*(56*C - 28)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) - 7*k1**2*k2**2*(8*C*(4*r**2 + r*(8*s + 4) + 4*s**2 - s - 3) + 20*K*r*s - 10*K*s - 2*f*(2*r - 1)*(3*s - 2) - 20*r**2 - 18*r*s - 46*r + 12*s**2 - 35*s + 28) + 4*k2**4*(7*K*(13*r**2 + r*(31*s - 24) - 7*s + 3) + f*(32*r**2 + 2*r*(58*s - 37) + 84*s**2 - 127*s + 41) + 7*r**2*(20*C - 40) + 7*r*(20*C*s - 10*C - 49*s + 42) + 63*s**2 - 21*s - 21)) + 3*D1*(2*f**2*fd*k2**2*(6*k1**2*(r*(6*s - 3) - 3*s + 2) + k2**2*(312*r**2 + r*(276*s - 638) - 414*s**2 - 80*s + 245)) + f*(fd*(2*k1**4*(4*C*(r*(27*s + 32) - 218*s**2 + 382*s - 126) - 2*r*(27*s + 32) + 486*s**2 - 919*s + 317) + k1**2*k2**2*(-4*C*(376*r**2 + 3*r*(106*s + 69) + 472*s**2 - 46*s - 232) + 56*K*s + 948*r**2 - 2*r*(56*K*s - 746*s - 99) + 2384*s**2 - 981*s - 492) + 2*k2**4*(28*C*(5*r**2 + r*(6 - 22*s) - s + 1) + K*(-198*r**2 - 68*r*s + 359*r + 223*s - 130) + 360*r**2 + 1544*r*s - 969*r + 538*s**2 - 856*s + 244)) + 28*gd2*k2**2*(5*k1**2*r*s + k2**2*(-13*r**2 - 31*r*s + 35*r + 6*s - 6))) + 28*fd*g2*k2**2*(5*k1**2*r*s + k2**2*(-13*r**2 + r*(24 - 31*s) + 12*s - 12))) + 2*Dd*f*(f**2*k2**2*(18*k1**2*(4*r - 1)*(2*s - 1) + k2**2*(1248*r**2 + 4*r*(276*s - 631) - 1656*s**2 - 436*s + 1047)) + 3*f*(k1**4*(2*C*(4*r*(27*s + 32) - 872*s**2 + 1603*s - 629) - 4*r*(27*s + 32) + 972*s**2 - 1913*s + 759) - k1**2*k2**2*(2*C*(752*r**2 + 2*r*(318*s + 7) + 944*s**2 - 314*s - 209) - 28*K*s - 948*r**2 + r*(s*(112*K - 1492) + 329) - 2384*s**2 + 1393*s + 63) + k2**4*(14*C*(20*r**2 + r*(35 - 88*s) - 2*s + 2) + K*(-396*r**2 - 136*r*s + 625*r + 415*s - 322) + 720*r**2 + 3088*r*s - 2110*r + 1076*s**2 - 1759*s + 707)) - 42*g2*k2**2*(5*k1**2*s*(1 - 4*r) + k2**2*(52*r**2 + r*(124*s - 107) - 32*s + 24)))) + f*(11*D1*bd1*(4*f**2*k2**2*(9*k1**2*(r*(2*s - 1) + s - 1) + k2**2*(156*r**2 + r*(138*s - 305) - 207*s**2 - 98*s + 156)) + 3*f*(2*k1**4*(2*C*(r*(27*s + 65) - 218*s**2 + 339*s - 95) - r*(27*s + 65) + 243*s**2 - 404*s + 95) + k1**2*k2**2*(-4*C*(188*r**2 + r*(159*s - 181) + 236*s**2 - 80*s + 71) + 474*r**2 + r*(-56*K*s + 746*s - 550) + 1192*s**2 - 569*s + 322) + 2*k2**4*(K*(-99*r**2 + r*(133 - 34*s) + 96*s - 96) + r**2*(70*C + 180) + r*(-308*C*s + 14*C + 772*s - 329) + 269*s**2 - 357*s + 186)) + 84*g2*k2**2*(5*k1**2*s*(r - 1) + k2**2*(-13*r**2 + r*(13 - 31*s) + 8*s))) + D1*(-30*f**2*fd*k2**2*(11*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(244*r**2 + r*(616*s - 573) + 660*s**2 - 1232*s + 502)) + 11*f*(-12*bd2*k2**4*(11*r**2 + 11*r*s - 25*r - 15*s + 15) + fd*(2*k1**4*(12*C*(r*(78*s + 76) - 186*s**2 + 359*s - 133) - 12*r*(39*s + 38) + 1233*s**2 - 2646*s + 949) + k1**2*k2**2*(-4*C*(3546*r**2 + 18*r*(227*s - 278) + 1584*s**2 - 5667*s + 2533) + 9072*r**2 + 27*r*(521*s - 530) + 8442*s**2 - 19425*s + 7736) - 18*k2**4*(2*C*(51*r**2 + 3*r*(50*s - 23) - 4*s + 2) - 186*r**2 + r*(249 - 528*s) - 138*s**2 + 128*s - 31)) + 12*gd2*k2**2*(28*k1**2*r*s + k2**2*(99*r**2 + 34*r*s - 133*r - 96*s + 96))) - 132*fd*k2**2*(b2*k2**2*(11*r - 16)*(2*r + 2*s - 1) + 28*g2*k1**2*s*(1 - 2*r) + g2*k2**2*(-198*r**2 + r*(359 - 68*s) + 223*s - 130))) + Dd*f*(-30*f**2*k2**2*(11*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(244*r**2 + r*(616*s - 573) + 660*s**2 - 1232*s + 502)) + 11*f*(4*k1**4*(4*C*(4*r*(39*s + 28) - 372*s**2 + 773*s - 341) - 8*r*(39*s + 28) + 822*s**2 - 1887*s + 833) + k1**2*k2**2*(-4*C*(4728*r**2 + 12*r*(454*s - 571) + 2112*s**2 - 7741*s + 4079) + 12096*r**2 + 12*r*(1563*s - 1666) + 11256*s**2 - 27173*s + 12670) - 18*k2**4*(2*C*(68*r**2 + r*(200*s - 117) - 4*s + 2) - 248*r**2 + r*(420 - 704*s) - 184*s**2 + 197*s - 54)) - 132*k2**2*(b2*k2**2*(44*r**2 + r*(44*s - 93) - 62*s + 46) + g2*(28*k1**2*s*(1 - 4*r) + k2**2*(-396*r**2 - 136*r*s + 625*r + 415*s - 322))))))/(3465*d**2*k1*k2*k3**4) + 8*D1**3*Pk1*Pk3*ct**3*(11*D1*bd1*f*(f**2*k2**4*(k1**2*(453*r**2 - 2*r*(21*s + 260) - 495*s**2 + 198*s + 181) + 9*k2**2*(22*r**2 - r*(8*s + 17) - 30*s**2 + 13*s - 3)) + 3*f*(k1**6*(12*C - 6)*(r*(s + 5) + s**2 + 6*s - 5) + k1**4*k2**2*(-4*C*(194*r**2 + r*(346*s - 252) + 152*s**2 - 119*s + 58) + 475*r**2 + r*(1018*s - 667) + 543*s**2 - 417*s + 192) + k1**2*k2**4*(-28*C*(64*r**2 + 121*r*s - 94*r + 57*s**2 - 75*s + 30) - 592*K*r**2 - 992*K*r*s + 1030*K*r - 400*K*s**2 + 956*K*s - 556*K + b1*(540*r**2 + r*(1248*s - 859) + 708*s**2 - 1027*s + 319) + 1951*r**2 + 3768*r*s - 2947*r + 1817*s**2 - 2591*s + 1096) + 7*k2**6*(3*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + r**2*(14 - 8*K) + r*(-8*K*s + 6*K + 20*s - 12) + s*(6*s - 6))) + 21*k2**2*(3*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*b1*(k1**4*(6*C - 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(30*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-22*r**2 - 74*r*s + 14*r - 52*s**2 + 44*s + 8) - 11*r**2 + 4*r*s + 43*r + 15*s**2 + 15*s - 31) - 10*k2**4*(r*(K - 2) - s)*(r + s - 1)) + 4*k2**2*(r + s - 1)*(b2*k1**2*(r + s) + g2*k1**2*(11*r + 26*s) + 5*g2*k2**2*r))) + 693*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**4*(84*C - 70)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 - 14*K*(11*r**2 + r*(37*s + 16) + 26*s**2 + 16*s - 8) + f*(540*r**2 + r*(1248*s - 631) + 708*s**2 - 715*s + 191) - 77*r**2 + 28*r*(s + 31) + 105*s**2 + 868*s - 434) + 7*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-10*r*(K - 2) + 10*s))) + Dd*f*(k1**4*(84*C - 70)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(420*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(88*r**2 + 296*r*s - 2*r + 208*s**2 - 92*s - 48) + 2*f*(540*r**2 + r*(1248*s - 745) + 708*s**2 - 871*s + 255) - 308*r**2 + 112*r*s + 1995*r + 420*s**2 + 1407*s - 1302) + 14*k2**4*(4*r + 4*s - 3)*(f*(9*r + 9*s - 6) + r*(10 - 5*K) + 5*s))) + 11*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(453*r**2 - r*(42*s + 401) - 495*s**2 + 117*s + 126) + 3*k2**2*(66*r**2 - r*(24*s + 1) - 90*s**2 + 89*s - 15)) + f*(fd*(k1**6*(12*C - 6)*(s + 3)*(2*r + 2*s - 1) + k1**4*k2**2*(-4*C*(388*r**2 + r*(692*s - 250) + 304*s**2 - 47*s - 66) + 950*r**2 + 4*r*(509*s - 198) + 1086*s**2 - 391*s - 115) - k1**2*k2**4*(28*C*(128*r**2 + 242*r*s - 117*r + 114*s**2 - 106*s + 20) + 2*K*(592*r**2 + 992*r*s - 872*r + 400*s**2 - 825*s + 288) - 3902*r**2 - 7536*r*s + 4070*r - 3634*s**2 + 3985*s - 923) - 14*k2**6*(r**2*(8*K - 14) + r*(K*(8*s - 4) - 20*s + 7) - s*(K + 6*s - 4))) + 28*k2**4*(r + s - 1)*(bd2*k1**2*(r + s) + gd2*k1**2*(11*r + 26*s + 8) + 5*gd2*k2**2*r)) + 28*fd*k2**4*(b2*k1**2*(r + s)**2 + g2*k1**2*(11*r**2 + r*(37*s + 16) + 26*s**2 + 16*s - 8) + 5*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(1812*r**2 - r*(168*s + 1723) - 1980*s**2 + 549*s + 559) + 18*k2**2*(44*r**2 - r*(16*s + 9) - 60*s**2 + 51*s - 9)) + 3*f*(k1**6*(12*C - 6)*(4*r*(s + 3) + 4*s**2 + 13*s - 11) + k1**4*k2**2*(-4*C*(776*r**2 + 4*r*(346*s - 187) + 608*s**2 - 279*s - 47) + 1900*r**2 + r*(4072*s - 2215) + 2172*s**2 - 1314*s + 40) - k1**2*k2**4*(28*C*(256*r**2 + 4*r*(121*s - 79) + 228*s**2 - 267*s + 79) + 2*K*(1184*r**2 + 2*r*(992*s - 951) + 800*s**2 - 1781*s + 844) - 7804*r**2 - 15072*r*s + 10335*r - 7268*s**2 + 9538*s - 3164) - 14*k2**6*(r**2*(16*K - 28) + r*(2*K*(8*s - 5) - 40*s + 19) - s*(K + 12*s - 10))) + 84*k2**4*(4*r + 4*s - 3)*(b2*k1**2*(r + s) + g2*k1**2*(11*r + 26*s + 8) + 5*g2*k2**2*r))) - f*(D1*(10*f**2*fd*k2**4*(k1**2*(2444*r**2 + r*(7328*s - 5909) + 4884*s**2 - 7805*s + 3090) + 44*k2**2*(12*r**2 + r*(52*s - 31) + 40*s**2 - 47*s + 14)) - 11*f*(fd*k1**2*(k1**4*(20*C - 10)*(3*s + 5)*(3*r + 3*s - 2) + k1**2*k2**2*(-4*C*(2016*r**2 + 9*r*(377*s - 296) + 1377*s**2 - 2112*s + 838) + 4977*r**2 + 9594*r*s - 7047*r + 4617*s**2 - 6312*s + 2321) - 9*k2**4*(4*C*(384*r**2 + 696*r*s - 439*r + 312*s**2 - 367*s + 114) - 1242*r**2 - 2322*r*s + 1463*r - 1080*s**2 + 1270*s - 395)) + 12*k2**4*(-3*bd2*k1**2*(r**2 + r*(2*s - 5) + s**2 - 5*s + 4) + gd2*(k1**2*(296*r**2 + 496*r*s - 515*r + 200*s**2 - 478*s + 278) + 7*k2**2*r*(4*r + 4*s - 3)))) + 132*fd*k2**4*(3*b2*k1**2*(2*r**2 + r*(4*s - 9) + 2*s**2 - 9*s + 4) - g2*(k1**2*(592*r**2 + 992*r*s - 872*r + 400*s**2 - 825*s + 288) + 7*k2**2*(8*r**2 + 8*r*s - 4*r - s)))) + Dd*f*(10*f**2*k2**4*(k1**2*(2444*r**2 + r*(7328*s - 5909) + 4884*s**2 - 7805*s + 3090) + 44*k2**2*(12*r**2 + r*(52*s - 31) + 40*s**2 - 47*s + 14)) - 11*f*k1**2*(k1**4*(20*C - 10)*(4*r*(3*s + 4) + 12*s**2 + 9*s - 13) + k1**2*k2**2*(-4*C*(2688*r**2 + 6*r*(754*s - 629) + 1836*s**2 - 2968*s + 1235) + 6636*r**2 + 3*r*(4264*s - 3373) + 6156*s**2 - 9014*s + 3484) - 9*k2**4*(4*C*(512*r**2 + r*(928*s - 642) + 416*s**2 - 531*s + 174) - 1656*r**2 - 4*r*(774*s - 539) - 1440*s**2 + 1847*s - 612)) + 132*k2**4*(3*b2*k1**2*(4*r**2 + r*(8*s - 19) + 4*s**2 - 19*s + 12) - g2*(k1**2*(1184*r**2 + 2*r*(992*s - 951) + 800*s**2 - 1781*s + 844) + 7*k2**2*(16*r**2 + 2*r*(8*s - 5) - s))))))/(3465*d**2*k1*k2*k3**6) + 4*D1**3*Pk1*Pk3*ct**3*(D1*bd1*f**2*(5*k1**2*(r*(2*C - 1)*(3*s + 1) + s*(-12*C + 5*s - 7)) + k2**2*r*(19*r + 1)) + 7*b1**2*(D1*fd*(11*k1**2*(s - 1)**2 + 9*k2**2*r**2) + Dd*f*(22*k1**2*(2*s**2 - 3*s + 1) + 9*k2**2*r*(4*r - 1))) + b1*f*(D1*(154*bd1*k1**2*s*(s - 1) + 63*bd1*k2**2*r*(2*r - 1) + 2*fd*k1**2*(C*(30*r*s - 8*r - 57*s + 25) - 15*r*s + 4*r + 25*s**2 - 49*s + 20) + fd*k2**2*(38*r**2 - 17*r - 1)) + Dd*f*(k1**2*(2*C*(60*r*s - 16*r - 117*s + 55) - 60*r*s + 16*r + 100*s**2 - 193*s + 75) + k2**2*(76*r**2 - 15*r - 1))))/(105*d**2*k1**3*k2) - 4*D1**3*Pk1*Pk3*ct**3*st**2*(84*b1**2*k1**2*(D1*fd*(s - 1)*(k1**2*(24*C - 18)*(s - 1) + k2**2*r*(11 - 11*C)) + Dd*f*(k1**2*(48*C - 36)*(2*s**2 - 3*s + 1) - k2**2*(C - 1)*(4*r*(11*s - 7) - 3*s + 3))) - 6*b1*f*(D1*(14*bd1*k1**2*(k1**2*s*(36 - 48*C)*(s - 1) + k2**2*(C - 1)*(r*(22*s - 6) - 3*s + 3)) + fd*(k1**4*(1 - 2*s)**2*(96*C - 48) + k1**2*k2**2*(7*C*(2*r*(5*s - 7) - s + 5) + r*(50*s + 24) + 288*s**2 - 281*s + 37) + 60*k2**4*r**2)) + Dd*f*(k1**4*(1 - 2*s)**2*(192*C - 96) + k1**2*k2**2*(7*C*(4*r*(5*s - 7) - s + 5) + 4*r*(25*s + 12) + 576*s**2 - 599*s + 131) + 30*k2**4*r*(4*r - 1))) - f**2*(D1*(6*bd1*(k1**4*s*(96*C - 48)*(2*s - 1) + k1**2*k2**2*(r*(35*C*(s - 1) + 25*s + 13) + 144*s**2 - 102*s + 22) + 30*k2**4*r*(r - 1)) + fd*(8*k1**4*(3*s - 1)*(2*C*(69*s - 50) - 87*s + 65) + k1**2*k2**2*(16*C*(r*(9*s + 6) - 30*s + 7) + 9*r*(45*s - 56) + 1332*s**2 - 987*s + 304) + 2*k2**4*(9*r**2 - 114*r + 37))) + Dd*f*(16*k1**4*(2*s - 1)*(2*C*(69*s - 50) - 87*s + 65) + k1**2*k2**2*(8*C*(r*(24*s + 2) - 85*s + 39) + 60*r*(9*s - 11) + 1776*s**2 - 1561*s + 434) + 2*k2**4*(12*r**2 - 151*r + 37))))/(315*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct**3*(3*b1**2*(D1*fd*(14*k1**4*(s - 1)*(4*C*(r + 11*s - 11) - 2*r - 33*s + 33) + 7*k1**2*k2**2*(2*f*(r*(4*s - 2) + s - 1) + r*(-116*C*(s - 1) + 121*s - 116)) + k2**4*r**2*(48*f + 126)) + Dd*f*(56*k1**4*(C*(4*r*(s - 2) + 44*s**2 - 69*s + 25) - 2*r*(s - 2) - 33*s**2 + 51*s - 18) - 7*k1**2*k2**2*(8*C*(r*(58*s - 31) - s + 1) - 2*f*(4*r - 1)*(2*s - 1) - 484*r*s + 248*r + 13*s - 8) + k2**4*r*(24*f + 126)*(4*r - 1))) + 3*b1*f*(D1*bd1*(28*k1**4*(2*C*(2*r*(s - 3) + 22*s**2 - 25*s + 3) - 2*r*(s - 3) - 33*s**2 + 36*s - 3) - 7*k1**2*k2**2*(8*C*(r*(29*s - 2) - s + 1) + f*(-8*r*s + 4*r + 6*s - 4) - 242*r*s + 16*r + 13*s - 8) + k2**4*r*(24*f + 126)*(2*r - 1)) - D1*fd*(k1**4*(4*C - 2)*(236*s**2 - 201*s + 17) + k1**2*k2**2*(-4*C*(40*r**2 - r*(88*s + 73) - 145*s + 121) + 28*K*r*s - 14*K*s - 12*f*(3*r - 1)*(3*s - 2) + 80*r**2 + 8*r*s - 376*r - 336*s**2 - 223*s + 362) + 2*k2**4*(-2*f*(9*r**2 + 3*r - 2) + 46*r**2 + 17*r + 1)) + 2*Dd*f*(-k1**4*(8*C - 4)*(118*s**2 - 111*s + 26) + k1**2*k2**2*(2*C*(80*r**2 - 2*r*(88*s + 63) - 277*s + 187) - 28*K*r*s + 7*K*s + 6*f*(4*r - 1)*(3*s - 2) - 80*r**2 - 8*r*s + 336*r + 336*s**2 + 200*s - 262) + k2**4*(4*r - 1)*(f*(6*r + 4) - 23*r + 1))) + f*(3*D1*bd1*f*(-k1**4*(4*C - 2)*(118*s**2 - 73*s + 35) + k1**2*k2**2*(r**2*(80*C - 40) - 2*r*(22*C*(4*s + 5) + 7*K*s - 18*f*s + 12*f + 2*s - 72) + 168*s**2 + 3*s*(55 - 88*C) + 18) + 2*k2**4*r*(f*(6*r + 4) - 23*r + 43)) + D1*(f*fd*(2*k1**4*(4*C*(6*r*(24*s + 13) - 486*s**2 + 555*s - 173) - 12*r*(24*s + 13) + 1089*s**2 - 1602*s + 497) + k1**2*k2**2*(-4*C*(234*r**2 + 3*r*(90*s - 139) - 558*s + 269) + 828*r**2 + 9*r*(17*s - 142) + 864*s**2 - 3435*s + 1366) + 144*k2**4*r*(1 - 3*r)) - 42*f*k1**2*k2**2*r*s*(bd2 - 2*gd2) - 42*fd*k1**2*k2**2*s*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(f*(4*k1**4*(8*C*(16*r*(3*s + 1) - 162*s**2 + 211*s - 75) - 64*r*(3*s + 1) + 726*s**2 - 1185*s + 451) + k1**2*k2**2*(-4*C*(312*r**2 + r*(360*s - 578) - 738*s + 449) + 1104*r**2 + 12*r*(17*s - 129) + 1152*s**2 - 4723*s + 2366) + 144*k2**4*r*(1 - 4*r)) + k1**2*k2**2*s*(-42*b2 + 84*g2)*(4*r - 1))))/(315*d**2*k1**3*k2*k3**2) - 4*D1**3*Pk1*Pk3*ct**3*st**2*(924*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(25*C - 19)*(s - 1) + k2**2*r*(11 - 11*C))*(r + s - 1) + Dd*f*(k1**2*(5*C*(4*r*(5*s - 4) + 20*s**2 - 33*s + 13) - 76*r*s + 62*r - 76*s**2 + 126*s - 50) - k2**2*(C - 1)*(44*r**2 + r*(44*s - 39) - 3*s + 3))) - 33*b1*f*(D1*(-28*bd1*k1**2*k2**2*(k1**2*(5*C*(10*r*s - 6*r + 10*s**2 - 13*s + 3) - 38*r*s + 24*r - 38*s**2 + 50*s - 12) - k2**2*(C - 1)*(22*r**2 + r*(22*s - 17) - 3*s + 3)) + fd*(-60*f*k2**6*r**2 - 12*k1**6*(2*s - 1)*(8*C*(9*s - 8) - 41*s + 38) + 2*k1**4*k2**2*(2*C*(683*r*s - 443*r + 1042*s**2 - 1114*s + 272) + r*(644 - 910*s) - 1568*s**2 + 1763*s - 451) + k1**2*k2**4*(-8*C*r*(184*s - 85) - 7*K*s + 12*f*(3*r*(4*s - 3) + 2*s - 1) + r**2*(404 - 128*C) + 14*r*(s*(K + 165) - 80) + 576*s**2 - 569*s + 144))) + Dd*f*(20*f*k2**6*r*(1 - 4*r) - 24*k1**6*(2*s - 1)*(8*C*(9*s - 8) - 41*s + 38) + 2*k1**4*k2**2*(C*(4*r*(683*s - 443) + 4168*s**2 - 5287*s + 1703) - 28*r*(65*s - 46) - 3136*s**2 + 4129*s - 1375) + k1**2*k2**4*(-4*C*(64*r**2 + 32*r*(23*s - 12) + 6*s - 3) + 28*K*r*s - 7*K*s + 12*f*(4*r - 1)*(4*s - 3) + 808*r**2 + 4620*r*s - 2554*r + 1152*s**2 - 1103*s + 274))) + f*(D1*(2*f**2*k2**4*(-66*bd1*(3*k1**2*(4*r*s - 3*r - 6*s + 4) - 5*k2**2*r*(r - 1)) + 7*fd*(4*r - 1)*(-44*k1**2*(3*s - 2) + 15*k2**2*(3*r + 2))) + 11*f*k1**2*(3*bd1*(12*k1**4*s*(8*C*(9*s - 8) - 41*s + 38) - 2*k1**2*k2**2*(C*(r*(683*s - 435) + 1042*s**2 - 1383*s + 525) - 7*r*(65*s - 47) - 784*s**2 + 1059*s - 401) + k2**4*(4*C*(16*r**2 + r*(184*s - 27) + 6*s - 3) - 202*r**2 + r*(-s*(7*K + 1155) + 244) - 288*s**2 + 102*s + 14)) + fd*(8*k1**4*(3*s - 1)*(10*C*(21*s - 16) - 123*s + 95) - 3*k1**2*k2**2*(4*C*(654*r*s - 503*r + 966*s**2 - 952*s + 305) - 1881*r*s + 1500*r - 2988*s**2 + 3081*s - 986) - 2*k2**4*(C*(486*r**2 - 3*r*(186*s + 463) - 498*s + 637) - 216*r**2 + 1449*r*s + 750*r + 666*s**2 - 81*s - 434)) + 42*gd2*k2**4*r*s) + 462*fd*g2*k1**2*k2**4*s*(2*r - 1)) + Dd*f*(14*f**2*k2**4*(4*r - 1)*(-44*k1**2*(3*s - 2) + 15*k2**2*(3*r + 2)) + 11*f*k1**2*(16*k1**4*(2*s - 1)*(10*C*(21*s - 16) - 123*s + 95) + k1**2*k2**2*(-4*C*(8*r*(327*s - 248) + 3864*s**2 - 4220*s + 1313) + 12*r*(627*s - 491) + 11952*s**2 - 13635*s + 4362) - 2*k2**4*(C*(648*r**2 - 2*r*(372*s + 787) - 614*s + 753) - 288*r**2 + 1932*r*s + 518*r + 888*s**2 - 324*s - 413)) + 462*g2*k1**2*k2**4*s*(4*r - 1))))/(3465*d**2*k1**3*k2*k3**4) - D1**3*Pk1*Pk3*ct**2*f*k2**6*st**6*(32*C - 32)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(21*d**2*k3**8) - D1**3*Pk1*Pk3*ct**2*f*k2**4*st**6*(32*C - 32)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(63*d**2*k3**6) - D1**3*Pk1*Pk3*ct**2*f*k2**2*st**6*(32*C - 32)*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + 2*Dd*f*(6*s**2 - 5*s + 1)))/(63*d**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**2*k1**2*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + 53*K*r + 53*K*s - 30*K + b1*(-33*r - 33*s + 13) - 69*r - 69*s + 52) - 21*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 420*k2**2*(r + s)*(b1*k1**2*(2 - 5*K) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + (r + s)**2*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3))) + Dd*f*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3)) + (r + s)*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) - 70*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 420*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) + 420*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) - 22*f*(5*fd*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 18*gd2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(r + s - 1)) + 396*fd*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9)) + 110*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 396*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s)))))/(1155*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct**2*k2**4*st**4*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(2*r + 2*s - 1)*(14*C - K + 30*b1 - 13) + k2**2*(r + s)*(28*K*b1 - 28*b1 - 28*g2)) + 66*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) + 2*f*(fd*(k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - k2**2*(14*C - K - 13)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 28*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(14*C - K - 13)*(2*r + 2*s - 1) - 28*g2*k2**2*(r + s))) + f*(D1*(-5*f**2*fd*k2**2*(1124*r**2 + r*(2248*s - 1543) + 1124*s**2 - 1543*s + 525) - 22*f*(fd*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 6*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 132*fd*g2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(281*r + 281*s - 175) + 22*f*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1)) - 132*g2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k3**8) + 16*D1**3*Pk1*Pk3*ct**2*k2**2*st**2*(33*D1*bd1*f*(r + s - 1)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + 55*K*r + 55*K*s + 18*K - 12*b1*(11*r + 11*s - 9) + 431*r + 431*s - 282) + 7*k2**4*(12*b1*(2*r + 2*s - 1) - (K - 1)*(r + s))) + 14*k2**2*(r + s)*(b1*k1**2*(3 - 11*K) + 5*b1*k2**2*(K - 1) + g2*(11*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5))) + Dd*f*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*gd2*k2**2*(11*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*fd*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s))) - f*(D1*(15*f**2*fd*k2**2*(8*k1**2*(4*r + 4*s - 3) - 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(k1**2*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 6*gd2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(r + s - 1)) + 66*fd*g2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*(8*k1**2*k2**2*(4*r + 4*s - 3) - 11*k2**4*(17*r + 17*s - 11)) + 11*f*(k1**4*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) - 66*g2*k2**2*(k1**2*(55*r + 55*s + 18) - 7*k2**2*(r + s)))))/(1155*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct**2*(231*b1**3*k2**2*(7*k1**2 + 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*(D1*(-7*bd1*f*k2**2*(7*k1**2 + 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(56*C - 28)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 - 14*K*(64*r**2 + 133*r*s + 24*r + 69*s**2 + 24*s - 12) + f*(768*r**2 + 3*r*(652*s - 315) + 1188*s**2 - 1127*s + 253) + 217*r**2 + 602*r*s + 728*r + 385*s**2 + 728*s - 364) + 7*k2**4*(f*(96*r**2 + 17*r*(12*s - 7) + 108*s**2 - 123*s + 39) + (-10*r - 10*s)*(r*(6*K - 6) + s*(3*K - 4))))) + Dd*f*(k1**4*(56*C - 28)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(420*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 7*K*(-512*r**2 - 1064*r*s + 288*r - 552*s**2 + 318*s + 72) + 2*f*(768*r**2 + 12*r*(163*s - 97) + 1188*s**2 - 1409*s + 406) + 868*r**2 + 2408*r*s + 707*r + 1540*s**2 + 350*s - 1092) + 7*k2**4*(4*f*(48*r**2 + r*(102*s - 67) + 54*s**2 - 69*s + 22) - 5*r**2*(48*K - 48) - 5*r*(36*K*(2*s - 1) - 80*s + 38) - 5*s*(6*K*(4*s - 3) - 32*s + 23)))) - 11*b1*(3*D1*bd1*f*(k1**4*(56*C - 28)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(420*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 28*K*(64*r**2 + 133*r*s - 58*r + 69*s**2 - 63*s - 6) + f*(768*r**2 + 3*r*(652*s - 461) + 1188*s**2 - 1691*s + 559) + 434*r**2 + 1204*r*s - 119*r + 770*s**2 - 357*s - 364) + 7*k2**4*(f*(96*r**2 + r*(204*s - 149) + 108*s**2 - 153*s + 49) - 5*r**2*(24*K - 24) - 5*r*(12*K*(3*s - 2) - 40*s + 25) - 5*s*(12*K*(s - 1) - 16*s + 15))) + 3*D1*(f**2*fd*k2**2*(k1**2*(975*r**2 + 2*r*(741*s - 557) + 507*s**2 - 877*s + 354) + 3*k2**2*(180*r**2 + r*(144*s - 97) - 36*s**2 + 41*s - 1)) - f*fd*(2*k1**4*(2*C*(132*r**2 + 2*r*(181*s - 82) + 230*s**2 - 143*s + 8) - 132*r**2 + r*(197 - 428*s) - 296*s**2 + 202*s - 21) + k1**2*k2**2*(28*C*(88*r**2 + 194*r*s - 101*r + 106*s**2 - 110*s + 24) + 2*K*(1128*r**2 + 4*r*(488*s - 317) + 824*s**2 - 1179*s + 352) - 2724*r**2 - 5896*r*s + 3088*r - 3172*s**2 + 3459*s - 814) + 7*k2**4*(r**2*(80*K - 76) + 2*r*(4*K*(14*s - 5) - 60*s + 19) + s*(K*(32*s - 22) - 44*s + 23))) + 14*f*k2**2*(r + s - 1)*(-bd2*(7*k1**2 + 5*k2**2)*(r + s) + 2*gd2*k1**2*(64*r + 69*s + 12) + 30*gd2*k2**2*(2*r + s)) + 14*fd*k2**2*(-b2*(7*k1**2 + 5*k2**2)*(r + s)**2 + 2*g2*k1**2*(64*r**2 + 133*r*s + 24*r + 69*s**2 + 24*s - 12) + 30*g2*k2**2*(2*r**2 + 3*r*s + s**2))) + Dd*f*(f**2*k2**2*(k1**2*(3900*r**2 + r*(5928*s - 4967) + 2028*s**2 - 3944*s + 1722) + 36*k2**2*(60*r**2 + r*(48*s - 41) - 12*s**2 + 5*s + 1)) - 3*f*(2*k1**4*(2*C*(264*r**2 + 724*r*s - 418*r + 460*s**2 - 355*s + 60) - 264*r**2 + r*(484 - 856*s) - 592*s**2 + 479*s - 89) + k1**2*k2**2*(28*C*(176*r**2 + 4*r*(97*s - 66) + 212*s**2 - 267*s + 87) + K*(4512*r**2 + 7808*r*s - 5868*r + 3296*s**2 - 5374*s + 2072) - 5448*r**2 - 11792*r*s + 7832*r - 6344*s**2 + 8259*s - 2687) + 7*k2**4*(r**2*(160*K - 152) + 4*r*(K*(56*s - 27) - 60*s + 28) + s*(K*(64*s - 54) - 88*s + 67))) + 42*k2**2*(4*r + 4*s - 3)*(-b2*(7*k1**2 + 5*k2**2)*(r + s) + 2*g2*k1**2*(64*r + 69*s + 12) + 30*g2*k2**2*(2*r + s)))) + f*(-11*D1*bd1*(f**2*k2**2*(k1**2*(975*r**2 + 13*r*(114*s - 125) + 507*s**2 - 1313*s + 660) + 9*k2**2*(60*r**2 + r*(48*s - 67) - 12*s**2 - 21*s + 5)) - 3*f*(2*k1**4*(2*C*(66*r**2 + r*(181*s - 98) + 115*s**2 - 77*s + 32) - 66*r**2 + r*(101 - 214*s) - 148*s**2 + 96*s - 35) + k1**2*k2**2*(28*C*(44*r**2 + r*(97*s - 74) + 53*s**2 - 71*s + 30) + 2*K*(564*r**2 + 976*r*s - 833*r + 412*s**2 - 754*s + 342) - 1362*r**2 - 2948*r*s + 2176*r - 1586*s**2 + 2204*s - 863) + 7*k2**4*(r**2*(40*K - 38) + r*(K*(56*s - 34) - 60*s + 37) + s*(16*K - 22)*(s - 1))) - 42*k2**2*(b2*(7*k1**2 + 5*k2**2)*(r + s) - 2*g2*(k1**2*(64*r + 69*s) + 15*k2**2*(2*r + s)))*(r + s - 1)) + D1*(5*f**2*fd*k2**2*(k1**2*(1904*r**2 + r*(8328*s - 6370) + 6424*s**2 - 9617*s + 3635) + 66*k2**2*(36*r**2 + r*(132*s - 85) + 96*s**2 - 121*s + 39)) + 11*f*(fd*k1**2*(2*k1**2*(4*C*(315*r**2 + 9*r*(83*s - 54) + 432*s**2 - 510*s + 166) - 630*r**2 - 1719*r*s + 1047*r - 1089*s**2 + 1236*s - 379) + 9*k2**2*(4*C*(273*r**2 + 564*r*s - 369*r + 291*s**2 - 361*s + 118) - 723*r**2 - 1536*r*s + 991*r - 813*s**2 + 1008*s - 325)) + 6*k2**2*(3*bd2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(r + s - 1) - 2*gd2*(k1**2*(564*r**2 + r*(976*s - 833) + 412*s**2 - 754*s + 342) + 7*k2**2*(20*r**2 + r*(28*s - 17) + s*(8*s - 8))))) + 66*fd*k2**2*(3*b2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 2*g2*(k1**2*(1128*r**2 + 4*r*(488*s - 317) + 824*s**2 - 1179*s + 352) + 7*k2**2*(40*r**2 + 4*r*(14*s - 5) + s*(16*s - 11))))) + Dd*f*(5*f**2*k2**2*(k1**2*(1904*r**2 + r*(8328*s - 6370) + 6424*s**2 - 9617*s + 3635) + 66*k2**2*(36*r**2 + r*(132*s - 85) + 96*s**2 - 121*s + 39)) + 11*f*k1**2*(2*k1**2*(4*C*(420*r**2 + 996*r*s - 729*r + 576*s**2 - 751*s + 263) - 840*r**2 - 2292*r*s + 1598*r - 1452*s**2 + 1835*s - 615) + 9*k2**2*(4*C*(364*r**2 + 752*r*s - 543*r + 388*s**2 - 524*s + 184) - 964*r**2 - 2048*r*s + 1475*r - 1084*s**2 + 1471*s - 517)) + 66*k2**2*(3*b2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(4*r + 4*s - 3) - 2*g2*(k1**2*(2256*r**2 + r*(3904*s - 2934) + 1648*s**2 - 2687*s + 1036) + 7*k2**2*(80*r**2 + 2*r*(56*s - 27) + s*(32*s - 27)))))))/(3465*d**2*k3**6) - 8*D1**3*Pk1*Pk3*ct**2*k2**2*st**4*(33*D1*bd1*f*(28*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(20*r**2 + r*(20*s - 29) - 15*s + 9) + f*k1**2*(4*k1**2*(C*(129*r*s - 48*r + 129*s**2 - 164*s + 48) - 83*r*s + 33*r - 83*s**2 + 111*s - 33) + k2**2*(-4*C*(108*r**2 + 3*r*(52*s - 47) + 48*s**2 - 82*s + 33) + 350*r**2 + 520*r*s - 463*r + 170*s**2 - 272*s + 113))) + 924*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(D1*fd*(f*k2**4*r*(60*r + 60*s - 37) + 2*k1**4*(2*C*(258*r*s - 143*r + 258*s**2 - 293*s + 82) - 332*r*s + 187*r - 332*s**2 + 388*s - 111) - 2*k1**2*k2**2*(2*C*(216*r**2 + 312*r*s - 159*r + 96*s**2 - 92*s + 21) - 350*r**2 - 520*r*s + 273*r - 170*s**2 + 169*s - 40)) + Dd*f*(f*k2**4*(80*r**2 + r*(80*s - 66) - 15*s + 9) + 2*k1**4*(4*C*(258*r*s - 143*r + 258*s**2 - 334*s + 106) - 664*r*s + 374*r - 664*s**2 + 887*s - 288) + k1**2*k2**2*(-4*C*(432*r**2 + 624*r*s - 430*r + 192*s**2 - 245*s + 77) + 1400*r**2 + 2080*r*s - 1458*r + 680*s**2 - 868*s + 281))) + f**2*(D1*fd*(f*k2**4*(1680*r**2 + 2*r*(840*s - 719) - 145*s + 117) + 66*k1**4*(2*C*(165*r*s - 68*r + 165*s**2 - 165*s + 41) - 222*r*s + 91*r - 222*s**2 + 222*s - 55) - 11*k1**2*k2**2*(4*C*(306*r**2 + 6*r*(75*s - 44) + 144*s**2 - 201*s + 55) - 1098*r**2 - 3*r*(552*s - 331) - 558*s**2 + 786*s - 225)) + Dd*f*(f*k2**4*(1680*r**2 + 2*r*(840*s - 719) - 145*s + 117) + 66*k1**4*(2*C*(4*r*(55*s - 26) + 220*s**2 - 245*s + 66) - 296*r*s + 138*r - 296*s**2 + 329*s - 88) - 11*k1**2*k2**2*(4*C*(408*r**2 + 600*r*s - 380*r + 192*s**2 - 281*s + 87) - 1464*r**2 - 2208*r*s + 1438*r - 744*s**2 + 1106*s - 359))))/(1155*d**2*k1**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**2*st**4*(168*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 3*b1*f*(4*D1*(-28*bd1*k1**2*s*(C - 1)*(s - 1) + fd*(2*s - 1)*(k1**2*(28*C*(2*s - 1) - 39*s + 23) + 12*k2**2*r)) + Dd*f*(2*s - 1)*(8*k1**2*(28*C*(2*s - 1) - 39*s + 23) + k2**2*(96*r - 5))) + f**2*(D1*(-3*bd1*(4*k1**2*s*(56*C*s - 28*C - 39*s + 23) + k2**2*(48*r*s - 5*r - 10*s + 5)) - 2*fd*(2*k1**2*(3*s - 1)*(30*C*(2*s - 1) - 51*s + 25) + k2**2*(9*r*(7*s - 4) - 24*s + 13))) - 2*Dd*f*(4*k1**2*(2*s - 1)*(60*C*s - 30*C - 51*s + 25) + k2**2*(84*r*s - 56*r - 29*s + 18))))/(105*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**2*st**4*(-336*b1**2*k1**2*k2**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 3*b1*f*(D1*(-112*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-16*k1**4*(2*s - 1)*(4*C*(29*s - 18) - 73*s + 47) + 8*k1**2*k2**2*(C*r*(557*s - 296) + 8*C*(38*s**2 - 37*s + 9) - 49*r*(9*s - 5) - 248*s**2 + 254*s - 65) + k2**4*r*(33*f*(5*s - 3) - 32*r*(13*C - 25) + 384*s - 192))) + Dd*f*(-32*k1**4*(2*s - 1)*(4*C*(29*s - 18) - 73*s + 47) + 4*k1**2*k2**2*(C*(4*r*(557*s - 296) + 1216*s**2 - 1489*s + 458) - 196*r*(9*s - 5) - 992*s**2 + 1277*s - 415) + k2**4*(11*f*(4*r - 1)*(5*s - 3) + 4*r**2*(400 - 208*C) + 16*r*(13*C + 48*s - 49) - 40*s + 20))) + f**2*(D1*(-3*bd1*(16*k1**4*s*(4*C*(29*s - 18) - 73*s + 47) - 4*k1**2*k2**2*(C*(557*r*s - 162*r + 304*s**2 - 445*s + 166) - 441*r*s + 147*r - 248*s**2 + 387*s - 151) + k2**4*(-11*f*(r - 1)*(5*s - 3) + 4*r**2*(52*C - 100) + 4*r*(-52*C - 48*s + 105) + 40*s - 20)) + fd*(-16*k1**4*(3*s - 1)*(6*C*(25*s - 12) - 99*s + 47) + 4*k1**2*k2**2*(C*(33*r*(57*s - 26) + 936*s**2 - 1131*s + 350) - 9*r*(183*s - 82) - 864*s**2 + 1047*s - 316) + k2**4*(8*C*(1 - 3*r)**2 + 23*f*(4*r - 1)*(5*s - 3) + 216*r**2 + 36*r*(8*s - 5) - 120*s + 44))) + Dd*f*(-32*k1**4*(2*s - 1)*(6*C*(25*s - 12) - 99*s + 47) + 4*k1**2*k2**2*(C*(4*r*(627*s - 326) + 1248*s**2 - 1587*s + 494) - 36*r*(61*s - 31) - 1152*s**2 + 1471*s - 452) + k2**4*(8*C*(12*r**2 - 7*r + 1) + 23*f*(4*r - 1)*(5*s - 3) + 288*r**2 + 384*r*s - 280*r - 160*s + 84))))/(105*d**2*k1**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**2*st**2*(33*D1*bd1*f*(2*f**2*k2**4*(k1**2*(96*r**2 + r*(246*s - 173) + 150*s**2 - 253*s + 67) - 3*k2**2*(r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**4*(4*C*(r*(25*s - 36) + 25*s**2 - 88*s + 36) + r*(81 - 51*s) - 51*s**2 + 198*s - 81) + k1**2*k2**2*(4*C*(79*r**2 + r*(28 - 130*s) - 209*s**2 + 230*s - 107) - 254*r**2 + r*(208*s - 17) + 462*s**2 - 533*s + 271) + k2**4*(28*C*(59*r**2 + 82*r*s - 77*r + 23*s**2 - 44*s + 18) - 60*K*r**2 - 92*K*r*s - 8*K*r - 32*K*s**2 + 20*K*s + 12*K + b1*(66*r**2 + r*(90*s - 43) + 24*s**2 + 27*s - 37) - 1464*r**2 - 2116*r*s + 1993*r - 652*s**2 + 1195*s - 501)) + 14*k1**2*k2**2*(-6*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(18*C - 11)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(-10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-28*r**2 - 30*r*s + 28*r - 2*s**2 + 1) + 28*r**2 + 42*r*s - 41*r + 14*s**2 - 19*s + 9)) + 2*k2**2*(-3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(14*r**2 + r*(15*s - 14) + s**2)))) - 2772*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(126*C - 77)*(r + s - 1)**2 - k2**2*(70*C*(r + s - 1)**2 + 7*K*(14*r**2 + 15*r*s + 2*r + s**2 + 2*s - 1) - f*(33*r**2 + r*(45*s - 23) + 12*s**2 - 9*s + 6) - 98*r**2 - 147*r*s + 126*r - 49*s**2 + 126*s - 63)) + Dd*f*(k1**2*(252*C - 154)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*K*(56*r**2 + 60*r*s - 40*r + 4*s**2 + 2*s - 3) + f*(132*r**2 + r*(180*s - 89) + 48*s**2 + 9*s - 25) + 784*r**2 + 1176*r*s - 1204*r + 392*s**2 - 742*s + 378))) + 33*b1*(D1*(6*f**2*fd*k2**4*(k1**2*(96*r**2 + 246*r*s - 107*r + 150*s**2 - 156*s + 40) - 3*k2**2*r*(5*r + 5*s - 3)) + f*k1**2*(fd*(2*k1**4*(4*C*(r*(50*s - 53) + 50*s**2 - 113*s + 44) - 3*r*(34*s - 38) - 102*s**2 + 249*s - 99) + k1**2*k2**2*(4*C*(158*r**2 - 4*r*(65*s - 84) - 418*s**2 + 701*s - 238) - 508*r**2 + r*(416*s - 893) + 924*s**2 - 1910*s + 708) + k2**4*(28*C*(118*r**2 + r*(164*s - 83) + 46*s**2 - 44*s + 10) - 4*K*(30*r**2 + 46*r*s + 33*r + 16*s**2 + 5*s - 24) - 2928*r**2 - 4232*r*s + 2340*r - 1304*s**2 + 1353*s - 382)) + 28*k2**4*(-3*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(14*r**2 + r*(15*s - 14) + s**2 - 1))) + 28*fd*k1**2*k2**4*(-3*b2*(r + s)**2 + g2*(14*r**2 + r*(15*s + 2) + s**2 + 2*s - 1))) + Dd*f*(2*f**2*k2**4*(k1**2*(384*r**2 + r*(984*s - 494) + 600*s**2 - 721*s + 187) - 3*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**4*(8*C*(r*(50*s - 53) + 50*s**2 - 135*s + 62) - 3*r*(68*s - 76) - 204*s**2 + 597*s - 279) + k1**2*k2**2*(4*C*(316*r**2 + r*(625 - 520*s) - 836*s**2 + 1394*s - 599) - 1016*r**2 + 832*r*s - 1596*r + 1848*s**2 - 3645*s + 1719) + k2**4*(28*C*(236*r**2 + r*(328*s - 227) + 92*s**2 - 122*s + 39) - 4*K*(60*r**2 + 92*r*s + 37*r + 32*s**2 - 5*s - 30) - 5856*r**2 - 8464*r*s + 6130*r - 2608*s**2 + 3547*s - 1230)) + 28*k1**2*k2**4*(-3*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(56*r**2 + 20*r*(3*s - 2) + 4*s**2 + 2*s - 3)))) + f*(D1*(f**2*fd*k2**4*(k1**2*(20700*r**2 + r*(29148*s - 28543) + 8448*s**2 - 22401*s + 11287) - 66*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(fd*(6*k1**4*(2*C*(9*r*(14*s - 11) + 126*s**2 - 204*s + 73) - 27*r*(5*s - 4) - 135*s**2 + 225*s - 81) + k1**2*k2**2*(4*C*(774*r**2 - 9*r*(61*s + 57) - 1323*s**2 + 507*s + 124) - 2178*r**2 + 45*r*(20*s + 27) + 3078*s**2 - 1227*s - 196) + 18*k2**4*(2*C*(192*r**2 + r*(258*s - 173) + 66*s**2 - 92*s + 31) - 351*r**2 + r*(329 - 492*s) - 141*s**2 + 191*s - 64)) - 6*k2**4*(3*bd2*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) - 4*gd2*(15*r**2 + r*(23*s + 2) + 8*s**2 - 5*s - 3))) - 66*fd*k1**2*k2**4*(b2*(30*r**2 + r*(60*s - 9) + 30*s**2 - 9*s - 3) - 4*g2*(30*r**2 + r*(46*s + 33) + 16*s**2 + 5*s - 24))) + Dd*f*(f**2*k2**4*(k1**2*(20700*r**2 + r*(29148*s - 28543) + 8448*s**2 - 22401*s + 11287) - 66*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(6*k1**4*(C*(4*r*(84*s - 59) + 336*s**2 - 558*s + 212) - 18*r*(10*s - 7) - 180*s**2 + 306*s - 117) + k1**2*k2**2*(4*C*(1032*r**2 - 6*r*(122*s + 67) - 1764*s**2 + 1007*s + 65) - 2904*r**2 + 30*r*(40*s + 27) + 4104*s**2 - 2504*s + 55) + 18*k2**4*(2*C*(256*r**2 + r*(344*s - 242) + 88*s**2 - 125*s + 42) - 468*r**2 + r*(463 - 656*s) - 188*s**2 + 263*s - 89)) - 66*k1**2*k2**4*(3*b2*(20*r**2 + r*(40*s - 11) + 20*s**2 - 11*s - 3) - 4*g2*(60*r**2 + r*(92*s + 37) + 32*s**2 - 5*s - 30)))))/(3465*d**2*k1**2*k3**6) + 4*D1**3*Pk1*Pk3*ct**2*st**2*(D1*bd1*f**2*(k1**2*s*(24*C - 12)*(5*s - 6) + k2**2*(r*(5*s - 17) - 3*s)) + 14*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))*(k1**2*(24*C - 12)*(s - 1) + 5*k2**2*r) + b1*f*(28*D1*bd1*s*(k1**2*(24*C - 12)*(s - 1) + 5*k2**2*r) + D1*fd*(k1**2*(24*C - 12)*(10*s**2 - 17*s + 6) + k2**2*(10*r*s - 47*r + 2*s + 20)) + Dd*f*k1**2*(48*C - 24)*(10*s**2 - 17*s + 6) + Dd*f*k2**2*(r*(20*s - 94) - 4*s + 23)))/(105*d**2*k1**2*k2**2) + D1**3*Pk1*Pk3*ct**2*(-4*D1*bd1*f**2*(k1**2*s*(56*C - 28)*(s - 2) + k2**2*(r**2*(1 - 2*C) + r*(-6*C + 27*s + 12) + 37*s)) + 35*b1**3*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 7*b1**2*(-D1*(s - 1)*(5*bd1*f*k2**2*(1 - 3*r) + fd*k1**2*(80*C - 40)*(s - 1) + fd*k2**2*(f*(3 - 6*r) + 76*r)) + Dd*f*(k1**2*(80 - 160*C)*(2*s**2 - 3*s + 1) + k2**2*(3*f*(4*r - 1)*(s - 1) - 304*r*s + 168*r + 8*s - 8))) - 2*b1*f*(D1*(280*bd1*k1**2*s*(2*C - 1)*(s - 1) + 7*bd1*k2**2*(r*(-3*f*(s - 1) + 76*s - 8) - 4*s + 4) + fd*k1**2*(112*C - 56)*(2*s**2 - 5*s + 2) + 2*fd*k2**2*(-2*C*(2*r**2 + 5*r - 3) + 2*r**2 + r*(54*s - 8) + 78*s - 49)) + 2*Dd*f*(k1**2*(112*C - 56)*(2*s**2 - 5*s + 2) + k2**2*(C*(-8*r**2 - 22*r + 6) + 4*r**2 + 3*r*(36*s - 5) + 152*s - 86))))/(105*d**2*k1**2*k2**2) - 4*D1**3*Pk1*Pk3*ct**2*st**2*(-14*b1**2*(-2*D1*fd*(k1**4*(12*C - 6)*(s - 1)**2 - 3*k1**2*k2**2*(s - 1)*(2*C*(2*r + s - 1) - 3*r - 2*s + 2) + k2**4*r*(f*(2 - 3*s) + r*(4*C - 4))) + Dd*f*(k1**4*(24 - 48*C)*(2*s**2 - 3*s + 1) + 3*k1**2*k2**2*(4*C*(4*s - 3)*(2*r + s - 1) - 6*r*(4*s - 3) - 16*s**2 + 27*s - 11) + k2**4*(4*r - 1)*(f*(3*s - 2) + r*(8 - 8*C)))) + b1*f*(14*D1*bd1*(k1**4*s*(48*C - 24)*(s - 1) - 3*k1**2*k2**2*(4*C*(2*s - 1)*(2*r + s - 1) + r*(6 - 12*s) - 8*s**2 + 11*s - 3) + k2**4*(2*r - 1)*(f*(2 - 3*s) + r*(8*C - 8))) + k2**2*(D1*fd*(-2*k1**2*(C*(14*r*(2*s - 7) - 444*s**2 + 458*s - 62) + 7*r*(7 - 2*s) + 378*s**2 - 455*s + 91) + k2**2*(-4*C*(8*r**2 - 22*r + 9) - 9*f*(3*r - 1)*(3*s - 2) + 74*r**2 + 430*r*s - 310*r + 7*s + 36)) + Dd*f*(-4*k1**2*(C*(14*r*(2*s - 7) - 444*s**2 + 514*s - 125) + 7*r*(7 - 2*s) + 378*s**2 - 490*s + 140) + k2**2*(-4*C*(16*r**2 - 40*r + 9) - 9*f*(4*r - 1)*(3*s - 2) + 148*r**2 + 860*r*s - 625*r + s + 39)))) - f**2*(D1*(bd1*k1**2*k2**2*(4*C*(7*r*(s - 1) - 111*s**2 + 108*s - 28) - 14*r*(s - 1) + 378*s**2 - 385*s + 91) + bd1*k2**4*(r**2*(16*C - 37) + r*(-36*C + 9*f*(3*s - 2) - 215*s + 60) + 6*s - 3) + fd*k1**4*(16*C - 8)*(18*s**2 - 21*s + 5) + fd*k1**2*k2**2*(2*C*(r*(45*s + 84) - 396*s**2 + 279*s - 82) + 9*r*(s - 16) + 756*s**2 - 660*s + 183) + fd*k2**4*(4*C*(9*r**2 + 18*r - 7) + 27*r**2 - 3*r*(24*s + 41) - 12*s + 50)) + Dd*f*(k1**4*(32*C - 16)*(12*s**2 - 16*s + 5) + k1**2*k2**2*(2*C*(r*(60*s + 68) - 528*s**2 + 443*s - 114) + 4*r*(3*s - 37) + 1008*s**2 - 1025*s + 296) + k2**4*(4*C*(12*r**2 + 25*r - 7) + 36*r**2 - 3*r*(32*s + 43) - 8*s + 46))))/(105*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*ct**2*(-3*D1*b1*bd1*f*(f*(21*k1**2*k2**2*(s - 1) + 2*k2**4*(8*r**2 + 3*r*(70*s - 41) - 63*s + 42)) - 14*k1**4*s*(80*C - 40)*(s - 1) - 14*k1**2*k2**2*s*(-8*C*(10*r - 17*s + 17) - 10*K*r + 5*K + 60*r - 136*s + 136) - 14*k2**4*(r**2*(-40*C + 20*K + 12) + 4*r*(5*C - 5*K - 19*s + 7) + 14*s)) - 105*b1**3*k1**2*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(D1*(35*bd1*f*k1**2*k2**2*(3*r - 1)*(s - 1) + fd*(k1**4*(280 - 560*C)*(s - 1)**2 + 7*k1**2*k2**2*(8*C*(s - 1)*(10*r - 17*s + 17) - 3*f*(s - 1) + 10*r*(s*(K - 6) + 6) + 136*(s - 1)**2) + 2*k2**4*(-70*K*(r - 1)**2 + f*(8*r**2 + r*(210*s - 157) + 6) + 14*r**2*(10*C - 3) + 14*r*(19*s - 10) + 70))) + 2*Dd*f*(k1**4*(280 - 560*C)*(2*s**2 - 3*s + 1) + 7*k1**2*k2**2*(8*C*(2*s - 1)*(10*r - 17*s + 17) - 5*K*s + 20*r*(s*(K - 6) + 3) + 272*s**2 - 408*s + 136) + k2**4*(-70*K*(4*r**2 - 5*r + 1) + f*(16*r**2 + 140*r*(3*s - 2) - 63*s + 48) - 14*r**2*(12 - 40*C) - 14*r*(10*C - 76*s + 41) - 98*s + 70))) + 3*b1*k2**2*(D1*(3*f**2*fd*(5*k1**2*(3*r - 1)*(s - 1) + 6*k2**2*(12*r**2 + r*(3*s - 19) - 35*s + 22)) - 2*f*(fd*(k1**2*(4*C*(r*(75*s + 92) - 38*s**2 + 347*s - 213) - 21*K*s + 2*r*(21*K*s - 75*s - 92) - 100*s**2 - 806*s + 540) - 2*k2**2*(K*(2*r**2 + 5*r - 3) + r**2*(34 - 28*C) + 2*r*(7*C + 71*s - 87) - 71*s + 26)) + 35*r*(bd2*k1**2*s - 2*gd2*k1**2*s + 4*gd2*k2**2*(r - 1))) - 70*fd*(b2*k1**2*r*s + g2*(-2*k1**2*r*s + 4*k2**2*(r - 1)**2))) + Dd*f*(3*f**2*(5*k1**2*(4*r - 1)*(s - 1) + 6*k2**2*(16*r**2 + 4*r*(s - 6) - 47*s + 28)) - 2*f*k1**2*(2*C*(12*r*(25*s + 19) - 152*s**2 + 1303*s - 708) - 21*K*s + 12*r*(7*K*s - 25*s - 19) - 200*s**2 - 1463*s + 876) + 4*f*k2**2*(K*(4*r**2 + 11*r - 3) + r**2*(68 - 56*C) + r*(14*C + 284*s - 269) - 145*s + 100) - (280*r - 70)*(b2*k1**2*s - 2*g2*k1**2*s + 4*g2*k2**2*(r - 1)))) + f*(D1*(9*bd1*f**2*k2**2*(5*k1**2*r*(s - 1) + 6*k2**2*(4*r**2 + r*(s - 5) - 12*s + 6)) - 2*f*(fd*(k1**4*(72*C - 36)*(9*s**2 - 24*s + 7) + k1**2*k2**2*(2*C*(828*r**2 + 3*r*(675*s - 514) + 324*s**2 - 1971*s + 818) - 828*r**2 - 3*r*(921*s - 632) - 1458*s**2 + 3459*s - 1224) + 54*k2**4*r*(3*r - 18*s + 5)) + 3*k2**2*(bd1*(k1**2*(2*C*(r*(75*s + 46) - 38*s**2 + 275*s + 14) + r*(21*K*s - 75*s - 46) - 50*s**2 - 327*s - 44) - 2*k2**2*(r**2*(-14*C + K + 17) + r*(3*K + 71*s + 5) - 37*s + 37)) - r*(bd2 - 2*gd2)*(-21*k1**2*s + 2*k2**2*(r + 3)))) + 6*k2**2*(-35*b2*bd1*k1**2*s*(r - 1) + b2*fd*(2*r - 1)*(-21*k1**2*s + 2*k2**2*(r + 3)) - 70*bd1*g2*(r - 1)*(-k1**2*s + 2*k2**2*r) - 2*fd*g2*(2*r - 1)*(-21*k1**2*s + 2*k2**2*(r + 3)))) - 2*Dd*f*(f*(k1**4*(144*C - 72)*(6*s**2 - 17*s + 7) + k1**2*k2**2*(C*(2208*r**2 + 5400*r*s - 4720*r + 864*s**2 - 5346*s + 2824) - 1104*r**2 - 3684*r*s + 2932*r - 1944*s**2 + 4877*s - 2156) + 54*k2**4*r*(4*r - 24*s + 11)) + k2**2*(-3*b2 + 6*g2)*(4*r - 1)*(-21*k1**2*s + 2*k2**2*(r + 3)))))/(315*d**2*k1**2*k2**2*k3**2) - 2*D1**3*Pk1*Pk3*ct**2*st**2*(33*b1**2*k2**2*(D1*fd*(k1**4*(784*C - 420)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(8*C*(11*r**2 + 17*r*(s - 1) + 6*(s - 1)**2) - 64*r**2 + r*(5*K*s - 36*f*s + 20*f - 117*s + 112) - 48*(s - 1)**2) + 2*k2**4*r*(f*(156*r + 156*s - 103) + r*(56*K - 126) - 70*s)) + Dd*f*(28*k1**4*(8*C*(14*r*s - 13*r + 14*s**2 - 24*s + 10) + (15 - 15*s)*(4*r + 4*s - 3)) - 7*k1**2*k2**2*(8*C*(44*r**2 + r*(68*s - 47) + 24*s**2 - 37*s + 13) + 20*K*r*s - 5*K*s - 2*f*(4*r - 1)*(9*s - 5) - 256*r**2 - 468*r*s + 280*r - 192*s**2 + 289*s - 92) + 4*k2**4*(f*(156*r**2 + r*(156*s - 133) - 30*s + 19) + 7*r*(4*K*(4*r - 1) - 36*r - 20*s + 19)))) + 33*b1*(D1*(f**2*k2**4*(14*bd1*k1**2*(2*r - 1)*(9*s - 5) + 2*bd1*k2**2*(156*r**2 + r*(156*s - 163) - 60*s + 38) + 9*fd*k1**2*(6*r - 9*s + 5) + 3*fd*k2**2*(156*r**2 + r*(117*s - 173) - 44*s + 48)) + f*(fd*(k1**6*(48*C - 24)*(10*s**2 - 17*s + 6) - 2*k1**4*k2**2*(4*C*(r*(86*s - 155) + 686*s**2 - 878*s + 250) + r*(389 - 190*s) - 1804*s**2 + 2410*s - 712) + k1**2*k2**4*(-4*C*(184*r**2 + r*(542 - 963*s) - 12*s**2 + 42*s - 48) + 49*K*s + 652*r**2 - 2*r*(49*K*s + 1315*s - 796) + 600*s**2 - 277*s - 114) + 2*k2**6*(-2*K*(8*r**2 - 22*r + 9) + 188*r**2 + 2*r*(86*s - 87) - 9*s + 40)) + 7*k2**2*(bd1*(4*k1**4*(8*C*(r*(7*s - 6) + 7*s**2 - 10*s + 3) + (15 - 15*s)*(2*r + 2*s - 1)) - k1**2*k2**2*(8*C*(22*r**2 + r*(34*s - 13) + 12*s**2 - 13*s + 1) - 5*K*s - 128*r**2 + 2*r*(5*K*s - 117*s + 28) - 96*s**2 + 97*s + 4) + 8*k2**4*r*(K*(4*r - 2) - 9*r - 5*s + 7)) + 2*gd2*k2**2*r*(5*k1**2*s - 16*k2**2*r))) + 14*fd*g2*k2**4*r*(5*k1**2*s - 16*k2**2*r)) + Dd*f*(f**2*k2**4*(18*k1**2*(4*r - 1) + k2**2*(624*r**2 + 12*r*(39*s - 59) - 163*s + 161)) + f*(k1**6*(96*C - 48)*(10*s**2 - 17*s + 6) - 2*k1**4*k2**2*(4*C*(172*r*s - 310*r + 1372*s**2 - 1988*s + 707) + r*(778 - 380*s) - 3608*s**2 + 5364*s - 1927) + k1**2*k2**4*(C*(-1472*r**2 + 8*r*(963*s - 478) + 96*s**2 + 18*s + 52) + 49*K*s + 1304*r**2 - 2*r*(98*K*s + 2630*s - 1357) + 1200*s**2 - 1161*s + 178) + 2*k2**6*(-2*K*(16*r**2 - 40*r + 9) + 376*r**2 + 4*r*(86*s - 99) - 3*s + 34)) - 14*g2*k2**4*(4*r - 1)*(-5*k1**2*s + 16*k2**2*r))) + f*(D1*(f**2*k2**4*(33*bd1*(9*k1**2*(2*r + 9*s - 7) + k2**2*(156*r**2 + 9*r*(13*s - 21) - 31*s + 17)) + fd*(-220*k1**2*(4*r - 1)*(9*s - 7) - 3*k2**2*(672*r**2 + 4180*r*s - 4912*r - 1155*s + 1241))) + 33*f*(bd1*(k1**6*s*(48*C - 24)*(5*s - 6) - 2*k1**4*k2**2*(4*C*(r*(43*s - 135) + 343*s**2 - 481*s + 171) + r*(323 - 95*s) - 902*s**2 + 1250*s - 413) + k1**2*k2**4*(C*(-368*r**2 + 2*r*(963*s + 194) + 24*s**2 + 210*s - 140) + 326*r**2 - r*(49*K*s + 1315*s + 476) + 300*s**2 - 534*s + 242) + 2*k2**6*(r**2*(94 - 8*K) + r*(18*K + 86*s - 111) + 3*s - 3)) + 2*fd*(k1**6*(16*C - 8)*(18*s**2 - 21*s + 5) + k1**4*k2**2*(C*(r*(960 - 774*s) - 2808*s**2 + 2814*s - 860) + 9*r*(53*s - 64) + 1854*s**2 - 1908*s + 569) + k1**2*k2**4*(C*(-1584*r**2 + 3*r*(27*s + 610) + 432*s**2 + 645*s - 706) + 1107*r**2 - 15*r*(9*s + 77) - 252*s**2 - 450*s + 455) - 6*k2**6*(r**2*(12*C - 36) + r*(-4*C - 24*s + 21) + 2*s - 1)) + 2*gd2*k2**4*r*(49*k1**2*s + 4*k2**2*(4*r - 9))) + 66*g2*k2**4*(-7*bd1*(r - 1)*(-5*k1**2*s + 16*k2**2*r) + fd*(2*r - 1)*(49*k1**2*s + 4*k2**2*(4*r - 9)))) + Dd*f*(f**2*k2**4*(-220*k1**2*(4*r - 1)*(9*s - 7) - 3*k2**2*(672*r**2 + r*(4180*s - 4912) - 1155*s + 1241)) + 66*f*(k1**6*(32*C - 16)*(12*s**2 - 16*s + 5) + k1**4*k2**2*(-2*C*(12*r*(43*s - 45) + 1872*s**2 - 2095*s + 650) + r*(636*s - 652) + 2472*s**2 - 2845*s + 888) + k1**2*k2**4*(C*(-2112*r**2 + 4*r*(27*s + 520) + 576*s**2 + 681*s - 886) + 1476*r**2 - 9*r*(20*s + 133) - 336*s**2 - 449*s + 538) - 6*k2**6*(r**2*(16*C - 48) - 4*r*(C + 8*s - 7) + 2*s - 1)) + 66*g2*k2**4*(4*r - 1)*(49*k1**2*s + 4*k2**2*(4*r - 9)))))/(3465*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*Pk3*ct**2*(4620*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + 2*s - 2) + 33*b1**2*k2**2*(2*D1*(70*bd1*f*k1**2*k2**2*(3*r**2 + r*(9*s - 8) + 6*s**2 - 10*s + 4) + fd*(-7*k1**4*(8*C*(4*r**2 + 13*r*(s - 1) + 9*(s - 1)**2) - 16*r**2 + r*(3*f*(s - 1) - s*(5*K + 80) + 80) - 64*(s - 1)**2) - k1**2*k2**2*(280*C*(3*r**2 + 5*r*(s - 1) + 2*(s - 1)**2) + 7*K*(14*r**2 - 25*r*s - 176*r - 78*s**2 - 104*s + 88) + f*(708*r**2 + r*(2941*s - 1286) + 2296*s**2 - 2488*s + 654) - 462*r**2 - 231*r*s + 2044*r + 504*s**2 + 1624*s - 952) + 14*k2**4*r*(4*f*(3*r + 3*s - 2) + r*(5 - 5*K)))) + Dd*f*(-7*k1**4*(32*C*(8*r**2 + r*(26*s - 19) + 18*s**2 - 29*s + 11) + 10*K*s + 3*f*(4*r - 1)*(s - 1) - 128*r**2 - 8*r*(s*(5*K + 80) - 54) - 512*s**2 + 808*s - 296) - k1**2*k2**2*(560*C*(12*r**2 + 5*r*(4*s - 3) + 8*s**2 - 13*s + 5) + 14*K*(56*r**2 - 100*r*s - 366*r - 312*s**2 - 27*s + 192) + f*(2832*r**2 + 4*r*(2941*s - 1459) + 9184*s**2 - 10671*s + 2851) - 3696*r**2 - 1848*r*s + 8372*r + 4032*s**2 + 3626*s - 4452) + 28*k2**4*(2*f*(4*r - 1)*(3*r + 3*s - 2) - r**2*(20*K - 20) + r*(5*K + 5) - 5*s))) - 11*b1*(3*D1*(f**2*k2**2*(bd1*(21*k1**4*(2*r - 1)*(s - 1) + k1**2*k2**2*(1416*r**2 + 34*r*(173*s - 96) + 4592*s**2 - 5695*s + 1543) - 56*k2**4*(2*r - 1)*(3*r + 3*s - 2)) + fd*(15*k1**4*(3*r - 1)*(s - 1) + k1**2*k2**2*(3204*r**2 + 5772*r*s - 5416*r + 648*s**2 - 3745*s + 2161) - 24*k2**4*(3*r - 1)*(3*r + 3*s - 2))) - 2*f*(fd*(k1**6*(112*C - 56)*(2*s**2 - 5*s + 2) + k1**4*k2**2*(4*C*(238*r**2 + r*(891*s - 281) + 614*s**2 - 293*s - 70) - 21*K*s - 476*r**2 + r*(s*(42*K - 2202) + 800) - 1892*s**2 + 1090*s + 54) + k1**2*k2**4*(28*C*(14*r**2 + r*(122*s - 33) + 28*s**2 - 8*s - 8) + K*(2036*r**2 + 2394*r*s - 2610*r + 748*s**2 - 2009*s + 796) - 2172*r**2 - 6494*r*s + 3096*r - 2436*s**2 + 2687*s - 508) - 14*k2**6*(r**2*(2*K + 2) - r*(K - 4*s + 1) + s)) - 7*k2**2*(bd1*k1**4*(16*C*(4*r**2 + r*(13*s - 6) + 9*s**2 - 11*s + 2) + 5*K*s - 32*r**2 - r*s*(10*K + 160) + 56*r - 128*s**2 + 148*s - 20) + bd1*k1**2*k2**2*(40*C*(6*r**2 + 5*r*(2*s - 1) + 4*s**2 - 5*s + 1) + K*(28*r**2 - 2*r*(25*s + 51) - 156*s**2 + 51*s + 52) - 132*r**2 - 66*r*s + 126*r + 144*s**2 - 17*s - 66) + 10*bd1*k2**4*(K*r*(2*r - 1) - 2*r**2 + s) - 20*bd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(-5*k1**4*r*s + k1**2*k2**2*(14*r**2 - r*(25*s + 88) - 78*s**2 + 26*s + 52) + 10*k2**4*r**2))) + 28*fd*k2**2*(-10*b2*k1**2*k2**2*(r + s)**2 + g2*(5*k1**4*r*s + k1**2*k2**2*(-14*r**2 + 25*r*s + 176*r + 78*s**2 + 104*s - 88) - 10*k2**4*r**2))) + Dd*f*(-840*b2*k1**2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**2*k2**2*(45*k1**4*(4*r - 1)*(s - 1) + 2*k1**2*k2**2*(6408*r**2 + 2*r*(5772*s - 5693) + 1296*s**2 - 8128*s + 4743) - 72*k2**4*(4*r - 1)*(3*r + 3*s - 2)) - 6*f*(k1**6*(224*C - 112)*(2*s**2 - 5*s + 2) + k1**4*k2**2*(2*C*(952*r**2 + 6*r*(594*s - 283) + 2456*s**2 - 1521*s + 66) - 21*K*s - 952*r**2 + r*(84*K*s - 4404*s + 2174) - 3784*s**2 + 2633*s - 304) + k1**2*k2**4*(28*C*(28*r**2 + r*(244*s - 117) + 56*s**2 - 38*s + 2) + K*(4072*r**2 + 4788*r*s - 5378*r + 1496*s**2 - 4157*s + 2196) - 4344*r**2 - 12988*r*s + 7982*r - 4872*s**2 + 6463*s - 2114) - 14*k2**6*(r**2*(4*K + 4) - r*(K - 8*s + 7) + s)) + 84*g2*k2**2*(5*k1**4*s*(4*r - 1) + k1**2*k2**2*(-56*r**2 + 100*r*s + 366*r + 312*s**2 + 27*s - 192) + 10*k2**4*r*(1 - 4*r)))) + f*(D1*(f**2*k2**2*(-11*bd1*(45*k1**4*r*(s - 1) + k1**2*k2**2*(3204*r**2 + 5772*r*s - 6524*r + 648*s**2 - 5021*s + 3003) - 72*k2**4*r*(3*r + 3*s - 2)) + 5*fd*k1**2*k2**2*(4944*r**2 + 4*r*(6237*s - 4765) + 28512*s**2 - 44055*s + 16237)) + 22*f*(3*bd1*(k1**6*s*(112*C - 56)*(s - 2) + k1**4*k2**2*(2*C*(238*r**2 + r*(891*s - 368) + 614*s**2 - 269*s + 154) - 238*r**2 + r*(s*(21*K - 1101) + 410) - 946*s**2 + 447*s - 208) + k1**2*k2**4*(28*C*(7*r**2 + 61*r*s - 27*r + 14*s**2 - 14*s + 8) + K*(1018*r**2 + 1197*r*s - 1384*r + 374*s**2 - 1074*s + 700) - 1086*r**2 - 3247*r*s + 1932*r - 1218*s**2 + 1748*s - 796) - 14*k2**6*r*(K*r + r + 2*s - 3)) + 12*bd2*k1**2*k2**4*(75*r**2 + r*(103*s - 117) + 28*s**2 - 87*s + 59) + fd*k1**6*(72*C - 36)*(9*s**2 - 24*s + 7) + fd*k1**4*k2**2*(2*C*(3708*r**2 + r*(9657*s - 6582) + 4662*s**2 - 8379*s + 2984) - 3708*r**2 + r*(7536 - 12195*s) - 7470*s**2 + 11547*s - 3764) + 18*fd*k1**2*k2**4*(C*(342*r**2 + 882*r*s - 456*r + 216*s**2 - 228*s + 68) - 321*r**2 + r*(445 - 888*s) - 261*s**2 + 276*s - 77) - 6*gd2*k2**2*(21*k1**4*r*s + k1**2*k2**2*(1018*r**2 + r*(1197*s - 1384) + 374*s**2 - 1074*s + 700) - 14*k2**4*r**2)) + 132*k2**2*(2*b2*k1**2*k2**2*(35*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(150*r**2 + r*(206*s - 199) + 56*s**2 - 166*s + 62)) - g2*(7*bd1*(5*k1**4*s*(r - 1) + k1**2*k2**2*(-14*r**2 + r*(25*s + 14) + s*(78*s - 25)) - 10*k2**4*r*(r - 1)) + fd*(21*k1**4*s*(2*r - 1) + k1**2*k2**2*(2036*r**2 + 2394*r*s - 2610*r + 748*s**2 - 2009*s + 796) + 14*k2**4*r*(1 - 2*r))))) + Dd*f*(5*f**2*k1**2*k2**4*(4944*r**2 + 4*r*(6237*s - 4765) + 28512*s**2 - 44055*s + 16237) + 22*f*k1**2*(k1**4*(144*C - 72)*(6*s**2 - 17*s + 7) + k1**2*k2**2*(2*C*(4944*r**2 + 4*r*(3219*s - 2522) + 6216*s**2 - 11997*s + 5048) - 4944*r**2 - 20*r*(813*s - 589) - 9960*s**2 + 16773*s - 6500) + 18*k2**4*(2*C*(228*r**2 + 588*r*s - 367*r + 144*s**2 - 168*s + 52) - 428*r**2 + r*(733 - 1184*s) - 348*s**2 + 415*s - 129)) + 132*k2**2*(2*b2*k1**2*k2**2*(300*r**2 + r*(412*s - 433) + 112*s**2 - 340*s + 180) - g2*(21*k1**4*s*(4*r - 1) + k1**2*k2**2*(4072*r**2 + 4788*r*s - 5378*r + 1496*s**2 - 4157*s + 2196) + 14*k2**4*r*(1 - 4*r))))))/(3465*d**2*k1**2*k2**2*k3**4) - 8*D1**3*Pk1*Pk3*ct*f*k2**5*st**6*(11*D1*bd1*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(r + s - 1) + 11*b1*(D1*fd*(f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + k1**2*(72*C - 54)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(180*r**2 + r*(360*s - 259) + 180*s**2 - 259*s + 93) + k1**2*(88*C - 66)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(45*r + 45*s - 31) + k1**2*(88*C - 66)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(231*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct*f*k2**3*st**6*(-9*D1*b1*fd*(-k1**2*(8*C - 6)*(2*s - 1) + k2**2*(r*(8*C - 10) - 2*s + 1))*(2*r + 2*s - 1) + 9*D1*bd1*f*(k1**2*(4*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(-2*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 10*r**2 + r*(12*s - 13) + 2*s**2 - 7*s + 3)) + D1*f*fd*(k1**2*(8*C - 6)*(3*s - 1) + k2**2*(C*(4 - 12*r) + 15*r + 3*s - 6))*(3*r + 3*s - 2) + 9*Dd*b1*f*(k1**2*(4*C - 3)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(C*(-32*r**2 - 8*r*(4*s - 3) + 4*s - 2) + 40*r**2 + r*(48*s - 34) + 8*s**2 - 14*s + 5)) + Dd*f**2*(k1**2*(4*C - 3)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(-2*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 60*r**2 + 72*r*s - 65*r + 12*s**2 - 31*s + 16)))/(63*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct*f*k2*st**6*(9*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + 2*Dd*f*(6*s**2 - 5*s + 1)))/(63*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct*f*k2*st**6*(9*b1*(2*s - 1)*(2*D1*fd*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + Dd*f*(k1**2*(16*C - 12)*(2*s - 1) + k2**2*(-16*C*r + 2*C + 24*r + 8*s - 7))) + f*(9*D1*bd1*(k1**2*s*(8*C - 6)*(2*s - 1) + k2**2*(C*(-8*r*s + 2*r + 4*s - 2) + 12*r*s - 3*r + 4*s**2 - 8*s + 3)) + 2*D1*fd*(3*s - 1)*(k1**2*(4*C - 3)*(3*s - 1) + k2**2*(C*(2 - 6*r) + 9*r + 3*s - 4)) + Dd*f*k1**2*(16*C - 12)*(6*s**2 - 5*s + 1) + Dd*f*k2**2*(C*(r*(20 - 48*s) + 14*s - 6) + 6*r*(12*s - 5) + 24*s**2 - 41*s + 13)))/(63*d**2*k1*k3**4) - 8*D1**3*Pk1*Pk3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*(k1**2*(-14*C*(r + s - 1) - 24*K*r - 24*K*s + 12*K + b1*(8*r + 8*s - 4) + 11*r + 11*s - 9) + 7*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(-168*b1*k1**2*(6*K - 1) - 420*b1*k2**2*(4*K - 1) + 336*g2*(3*k1**2 + 5*k2**2))) + 3*b1**2*(D1*fd*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5))) + Dd*f*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5)) + (r + s)*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 6*f*(3*fd*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s))*(2*r + 2*s - 1) - 56*gd2*(3*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 336*fd*g2*(3*k1**2 + 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - 18*f*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s)) + 336*g2*(3*k1**2 + 5*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 9*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 8*gd2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))*(r + s - 1) - 72*fd*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(r + s - 1) + f*k1**2*(90*C - 45)*(r + s - 1) - 72*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))))/(105*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct*k1*k2*st**2*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 32*K*r - 32*K*s - 12*K + 3*b1*(r + s - 11) - 181*r - 181*s + 129) - 7*k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) + 28*k2**2*(r + s)*(b1*k1**2*(1 - 4*K) + 5*b1*k2**2*(2*K - 1) + 2*g2*(2*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K))) + Dd*f*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7)) + (r + s)*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K)))*(4*r + 4*s - 3)) + 33*b1*(D1*(f**2*fd*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 2*f*(fd*(2*r + 2*s - 1)*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 28*gd2*k2**2*(2*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 56*fd*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 56*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 12*gd2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 264*fd*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5)) + 22*f*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 264*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(1155*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct*k1*(21*b1**3*k2**2*(4*k1**2 + 15*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(7*D1*bd1*f*(4*k1**2 + 15*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - D1*fd*(2*k1**2*(70*C*(r + s - 1)**2 - 56*K*(7*r**2 + 14*r*s + 2*r + 7*s**2 + 2*s - 1) + f*(126*r**2 + 420*r*s - 221*r + 294*s**2 - 291*s + 66) + 49*r**2 + 154*r*s + 98*r + 105*s**2 + 98*s - 49) + 7*k2**2*(f*(72*r**2 + r*(168*s - 89) + 96*s**2 - 97*s + 23) + (-5*r - 5*s)*(r*(18*K - 9) + s*(12*K - 7)))) - Dd*f*(2*k1**2*(70*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 56*K*(28*r**2 + 56*r*s - 17*r + 28*s**2 - 17*s - 3) + f*(252*r**2 + r*(840*s - 529) + 588*s**2 - 711*s + 220) + 196*r**2 + 616*r*s - 7*r + 420*s**2 - 91*s - 147) + 7*k2**2*(2*f*(72*r**2 + 2*r*(84*s - 55) + 96*s**2 - 118*s + 37) - 5*r**2*(72*K - 36) - 5*r*(6*K*(20*s - 9) - 64*s + 31) - 5*s*(12*K*(4*s - 3) - 28*s + 19)))) - b1*(3*D1*(f**2*k2**2*(28*bd1*k1**2*(9*r**2 + r*(30*s - 22) + 21*s**2 - 30*s + 11) + 7*bd1*k2**2*(72*r**2 + r*(168*s - 131) + 96*s**2 - 139*s + 51) + fd*k1**2*(390*r**2 + r*(900*s - 608) + 510*s**2 - 688*s + 234) + 3*fd*k2**2*(189*r**2 + r*(294*s - 185) + 105*s**2 - 107*s + 34)) + f*(-fd*(k1**4*(28*C - 14)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(28*C*(20*r**2 + r*(58*s - 33) + 38*s**2 - 46*s + 12) + 2*K*(804*r**2 + 1428*r*s - 818*r + 624*s**2 - 763*s + 208) - 658*r**2 - 1744*r*s + 868*r - 1086*s**2 + 1201*s - 301) + 7*k2**4*(r**2*(112*K - 54) + r*(8*K*(22*s - 7) - 92*s + 27) + s*(K*(64*s - 38) - 38*s + 15))) + 14*k2**2*(bd1*(k1**2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 8*K*(14*r**2 + 28*r*s - 13*r + 14*s**2 - 13*s - 1) + 14*r**2 + 44*r*s - 11*r + 30*s**2 - 19*s - 7) - 5*k2**2*(r**2*(18*K - 9) + 2*r*(3*K*(5*s - 3) - 8*s + 5) + s*(12*K*(s - 1) - 7*s + 6))) + (2*r + 2*s - 2)*(-bd2*(4*k1**2 + 5*k2**2)*(r + s) + 8*gd2*k1**2*(7*r + 7*s + 1) + 15*gd2*k2**2*(3*r + 2*s)))) + 28*fd*k2**2*(-b2*(4*k1**2 + 5*k2**2)*(r + s)**2 + 8*g2*k1**2*(7*r**2 + 2*r*(7*s + 1) + 7*s**2 + 2*s - 1) + 15*g2*k2**2*(3*r**2 + 5*r*s + 2*s**2))) + Dd*f*(f**2*k2**2*(2*k1**2*(780*r**2 + r*(1800*s - 1361) + 1020*s**2 - 1531*s + 577) + 9*k2**2*(252*r**2 + 392*r*s - 289*r + 140*s**2 - 185*s + 65)) - 3*f*(k1**4*(56*C - 28)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(28*C*(40*r**2 + 2*r*(58*s - 41) + 76*s**2 - 105*s + 37) + 2*K*(1608*r**2 + 4*r*(714*s - 487) + 1248*s**2 - 1793*s + 614) - 1316*r**2 - 3488*r*s + 2209*r - 2172*s**2 + 2842*s - 912) + 7*k2**4*(r**2*(224*K - 108) + r*(4*K*(88*s - 39) - 184*s + 89) + s*(2*K*(64*s - 51) - 76*s + 53))) + 84*k2**2*(4*r + 4*s - 3)*(-b2*(4*k1**2 + 5*k2**2)*(r + s) + 8*g2*k1**2*(7*r + 7*s + 1) + 15*g2*k2**2*(3*r + 2*s)))) + f*(D1*(f**2*k2**2*(-bd1*(k1**2*(390*r**2 + 900*r*s - 898*r + 510*s**2 - 998*s + 452) + 9*k2**2*(63*r**2 + 98*r*s - 104*r + 35*s**2 - 78*s + 31)) + 10*fd*(k1**2*(56*r*s - 42*r + 56*s**2 - 83*s + 31) + 2*k2**2*(20*r**2 + 92*r*s - 61*r + 72*s**2 - 97*s + 33))) + 3*f*(bd1*(k1**4*s*(28*C - 14)*(3*r + 3*s - 1) + k1**2*k2**2*(28*C*(10*r**2 + r*(29*s - 20) + 19*s**2 - 25*s + 10) + 2*K*(402*r**2 + 714*r*s - 565*r + 312*s**2 - 515*s + 203) - 329*r**2 - 872*r*s + 583*r - 543*s**2 + 733*s - 246) + 7*k2**4*(r**2*(56*K - 27) + r*(K*(88*s - 50) - 46*s + 31) + s*(32*K - 19)*(s - 1))) + 3*fd*(k1**4*(4*C - 2)*(3*s - 1)*(5*r + 5*s - 3) + k1**2*k2**2*(4*C*(66*r**2 + 56*r*(3*s - 2) + 102*s**2 - 135*s + 45) - 147*r**2 + r*(245 - 384*s) - 237*s**2 + 314*s - 101)) + 4*k2**2*(3*bd2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(r + s - 1) - gd2*(k1**2*(402*r**2 + r*(714*s - 565) + 312*s**2 - 515*s + 203) + 7*k2**2*(28*r**2 + r*(44*s - 25) + s*(16*s - 16))))) + 12*k2**2*(7*b2*bd1*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*b2*fd*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 7*bd1*g2*(56*k1**2*(r + s) + 15*k2**2*(3*r + 2*s))*(r + s - 1) - fd*g2*(k1**2*(804*r**2 + 2*r*(714*s - 409) + 624*s**2 - 763*s + 208) + 7*k2**2*(56*r**2 + 4*r*(22*s - 7) + s*(32*s - 19))))) + Dd*f*(10*f**2*k2**2*(k1**2*(14*r*(4*s - 3) + 56*s**2 - 83*s + 31) + 2*k2**2*(20*r**2 + r*(92*s - 61) + 72*s**2 - 97*s + 33)) + 9*f*k1**2*(k1**2*(8*C - 4)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(4*C*(88*r**2 + 56*r*(4*s - 3) + 136*s**2 - 197*s + 73) - 196*r**2 - 512*r*s + 373*r - 316*s**2 + 460*s - 168)) + 12*k2**2*(3*b2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(4*r + 4*s - 3) - g2*(k1**2*(1608*r**2 + 4*r*(714*s - 487) + 1248*s**2 - 1793*s + 614) + 7*k2**2*(112*r**2 + 2*r*(88*s - 39) + s*(64*s - 51)))))))/(315*d**2*k2*k3**6) + 8*D1**3*Pk1*Pk3*ct*k2**3*st**4*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(b1*(-51*r - 51*s + 29) - (28*C - 2*K - 20)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(168*K*b1 - 84*b1 - 168*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(102*r**2 + r*(204*s - 109) + 102*s**2 - 109*s + 29) + (14 - 28*K)*(r + s)**2) + Dd*f*(f*(51*r + 51*s - 29) + (14 - 28*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(fd*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1)) - 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-691*r - 691*s + 433) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k2**2*(9 - 12*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 12*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 264*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*(k1**2*k2**2*(691*r + 691*s - 433) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k1**2*k2**2*(9 - 12*C)*(2*r + 2*s - 1)) - 264*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct*k2*st**4*(11*D1*bd1*f*(f**2*k2**4*(120*r**2 + r*(192*s - 181) + 72*s**2 - 175*s + 63) + 3*f*(2*k1**4*(14*C*(r*(6*s - 3) + 6*s**2 - 10*s + 3) + r*(24 - 47*s) - 47*s**2 + 82*s - 24) - 2*k1**2*k2**2*(4*C*(22*r**2 + r*(49*s - 37) + 27*s**2 - 32*s + 15) - 61*r**2 - 2*r*(70*s - 53) - 79*s**2 + 88*s - 45) + k2**4*(28*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 2*K*(-4*r**2 - 4*r*s + 4*r + s - 1) + b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 128*r**2 - 152*r*s + 168*r - 24*s**2 + 90*s - 38)) + 42*k2**2*(b1*(k1**2*(4*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(r**2*(6 - 4*K) + r*(K*(3 - 4*s) + 8*s - 5) + s*(K + 2*s - 3))) + 2*g2*k2**2*(2*r**2 + 2*r*(s - 1) - s))) + 33*b1**2*k2**2*(D1*fd*(k1**2*(56*C - 42)*(r + s - 1)**2 + k2**2*(f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-14*r*(2*K - 3) + 14*s))) + 2*Dd*f*(k1**2*(28*C - 21)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 24) - 7*r**2*(8*K - 12) - 7*r*(8*K*s - 4*K - 16*s + 7) + 7*s*(K + 4*s - 4)))) + 11*b1*(3*D1*(f**2*fd*k2**4*(120*r**2 + r*(192*s - 113) + 72*s**2 - 99*s + 35) + f*(fd*(2*k1**4*(14*C*(r*(12*s - 7) + 12*s**2 - 16*s + 5) + r*(54 - 94*s) - 94*s**2 + 129*s - 41) + k1**2*k2**2*(-8*C*(44*r**2 + r*(98*s - 59) + 54*s**2 - 57*s + 14) + 244*r**2 + r*(560*s - 361) + 316*s**2 - 348*s + 89) + 4*k2**4*(2*r + 2*s - 1)*(-2*K*r + K + r*(28*C - 32) - 6*s + 2)) + 28*gd2*k2**4*r*(2*r + 2*s - 1)) + 56*fd*g2*k2**4*r*(r + s)) + Dd*f*(8*f**2*k2**4*(60*r**2 + r*(96*s - 65) + 36*s**2 - 59*s + 21) + 3*f*(2*k1**4*(14*C*(2*r*(12*s - 7) + 24*s**2 - 37*s + 13) - 4*r*(47*s - 27) - 188*s**2 + 299*s - 106) + k1**2*k2**2*(-8*C*(88*r**2 + 4*r*(49*s - 36) + 108*s**2 - 132*s + 45) + 488*r**2 + 28*r*(40*s - 31) + 632*s**2 - 783*s + 280) + 4*k2**4*(7*C*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + K*(-8*r**2 - 8*r*s + 8*r + 3*s - 2) - 128*r**2 - 152*r*s + 106*r - 24*s**2 + 41*s - 14)) + 84*g2*k2**4*(8*r**2 + r*(8*s - 4) - s))) + f*(D1*(2*f**2*fd*k2**4*(1076*r**2 + r*(856*s - 801) - 220*s**2 + 248*s - 43) + 11*f*(fd*(6*k1**4*(4*C*(33*r*s - 13*r + 33*s**2 - 33*s + 8) - 75*r*s + 29*r - 75*s**2 + 75*s - 18) + k1**2*k2**2*(-4*C*(180*r**2 + 360*r*s - 165*r + 180*s**2 - 204*s + 43) + 540*r**2 + 1044*r*s - 543*r + 504*s**2 - 624*s + 157) + 6*k2**4*(2*C*(12*r**2 + 12*r*s - 9*r - 2*s + 1) - 30*r**2 - 36*r*s + 25*r - 6*s**2 + 11*s - 4)) + 12*gd2*k2**4*(4*r**2 + 4*r*(s - 1) - s + 1)) + 264*fd*g2*k2**4*(2*r - 1)*(2*r + 2*s - 1)) + Dd*f*(2*f**2*k2**4*(1076*r**2 + r*(856*s - 801) - 220*s**2 + 248*s - 43) + 11*f*(12*k1**4*(C*(88*r*s - 38*r + 88*s**2 - 97*s + 25) - 50*r*s + 21*r - 50*s**2 + 55*s - 14) + k1**2*k2**2*(-4*C*(240*r**2 + 480*r*s - 252*r + 240*s**2 - 298*s + 77) + 720*r**2 + 1392*r*s - 830*r + 672*s**2 - 911*s + 276) + 6*k2**4*(C*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) - 40*r**2 - 48*r*s + 34*r - 8*s**2 + 14*s - 5)) + 264*g2*k2**4*(8*r**2 + 8*r*(s - 1) - 3*s + 2))))/(1155*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct*st**4*(D1*bd1*f**2*s*(2*s - 1) + 7*b1**2*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s*(s - 1) + D1*fd*(1 - 2*s)**2 + 2*Dd*f*(1 - 2*s)**2))/(35*d**2*k1*k2) - 2*D1**3*Pk1*Pk3*ct*st**2*(33*b1**2*(D1*fd*(k1**4*(56*C - 28)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(8*C*(2*r**2 + 15*r*(s - 1) + 13*(s - 1)**2) - 10*r**2 + r*(10*K*s - 12*f*s + 8*f - 97*s + 92) - 82*(s - 1)**2) + 2*k2**4*(7*K*(-11*r**2 - 17*r*s + 8*r + 4*s - 4) + 2*f*(120*r**2 + r*(204*s - 95) + 84*s**2 - 111*s + 34) + 7*r**2*(40*C - 20) + 7*r*(40*C*(s - 1) - 5*s + 32) + 63*s**2 - 28*s + 28)) + Dd*f*(k1**4*(56*C - 28)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) - 7*k1**2*k2**2*(16*C*(4*r**2 + 30*r*s - 16*r + 26*s**2 - 39*s + 13) + 40*K*r*s - 10*K*s - 2*f*(4*r - 1)*(3*s - 2) - 40*r**2 - 388*r*s + 186*r - 328*s**2 + 493*s - 160) + 2*k2**4*(140*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 7*K*(44*r**2 + r*(68*s - 29) - 24*s + 8) + 2*f*(240*r**2 + 24*r*(17*s - 11) + 168*s**2 - 274*s + 95) - 560*r**2 - 28*r*(5*s - 31) + 252*s**2 - 287*s - 84))) + 33*b1*(D1*bd1*f*(k1**4*(56*C - 28)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + 7*k1**2*k2**2*(-208*C*s**2 + 208*C*s + 10*K*s + 2*f*(2*r - 1)*(3*s - 2) - r**2*(32*C - 20) - 2*r*(120*C*s - 8*C + 10*K*s - 97*s + 1) + 164*s**2 - 165*s - 4) + 4*k2**4*(70*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 7*K*(11*r**2 + 17*r*s - 8*r - 9*s + 1) + f*(120*r**2 + r*(204*s - 169) + 84*s**2 - 163*s + 61) - 140*r**2 - 35*r*s + 196*r + 63*s**2 - 91*s - 63)) + D1*(6*f**2*fd*k2**2*(2*k1**2*(r*(6*s - 3) - 3*s + 2) + k2**2*(96*r**2 - 4*r*(15*s + 14) - 210*s**2 + 188*s - 23)) + f*(fd*(2*k1**4*(4*C*(r*(19*s + 22) - 226*s**2 + 316*s - 98) - 2*r*(19*s + 22) + 510*s**2 - 711*s + 221) + k1**2*k2**2*(-4*C*(440*r**2 + r*(552*s - 79) + 708*s**2 - 450*s + 4) + 56*K*s + 1076*r**2 - 2*r*(56*K*s - 852*s + 99) + 2480*s**2 - 1513*s + 36) - 2*k2**4*(28*C*(5*r**2 + 2*r*(7*s - 2) + s - 1) + K*(158*r**2 + 98*r*s - 235*r - 42*s + 78) - 524*r**2 - 1018*r*s + 489*r - 250*s**2 + 201*s - 54)) + 28*gd2*k2**2*(5*k1**2*r*s + k2**2*(11*r**2 + r*(17*s - 5) - 2*s + 2))) + 28*fd*g2*k2**2*(5*k1**2*r*s + k2**2*(11*r**2 + r*(17*s - 8) - 4*s + 4))) + 2*Dd*f*(f**2*k2**2*(6*k1**2*(4*r - 1)*(2*s - 1) + k2**2*(384*r**2 - 4*r*(60*s + 61) - 840*s**2 + 740*s - 93)) + f*(k1**4*(2*C*(r*(76*s + 88) - 904*s**2 + 1351*s - 481) - 76*r*s - 88*r + 1020*s**2 - 1509*s + 531) + k1**2*k2**2*(-2*C*(880*r**2 + 2*r*(552*s - 263) + 1416*s**2 - 1107*s + 138) + 28*K*s + 1076*r**2 + r*(-112*K*s + 1704*s - 661) + 2480*s**2 - 1856*s + 193) + k2**4*(-14*C*(20*r**2 + 56*r*s - 29*r + 2*s - 2) + K*(-316*r**2 - 196*r*s + 405*r + 42*s - 78) + 1048*r**2 + 2036*r*s - 1204*r + 500*s**2 - 422*s + 67)) + 14*g2*k2**2*(5*k1**2*s*(4*r - 1) + k2**2*(44*r**2 + r*(68*s - 29) - 24*s + 8)))) - f*(-33*D1*bd1*(4*f**2*k2**2*(3*k1**2*(r*(2*s - 1) + s - 1) + k2**2*(48*r**2 - 2*r*(15*s + 19) - 105*s**2 + 88*s - 12)) + f*(2*k1**4*(2*C*(r*(19*s + 53) - 226*s**2 + 279*s - 71) - r*(19*s + 53) + 255*s**2 - 304*s + 71) + k1**2*k2**2*(-4*C*(220*r**2 + 4*r*(69*s - 71) + 354*s**2 - 229*s + 60) + 538*r**2 + r*(-56*K*s + 852*s - 694) + 1240*s**2 - 747*s + 138) - 2*k2**4*(r**2*(70*C + 79*K - 262) + r*(98*C*(2*s - 1) + 49*K*s - 85*K - 509*s + 277) - 125*s**2 + 79*s + 4)) + 28*g2*k2**2*(5*k1**2*s*(r - 1) + k2**2*(11*r**2 + r*(17*s - 11) - 16*s))) + D1*(6*f**2*fd*k2**2*(55*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(1140*r**2 + 3432*r*s - 2605*r + 1980*s**2 - 2772*s + 1042)) + 11*f*(12*bd2*k2**4*(15*r**2 + r*(15*s - 29) - 9*s + 9) + 6*fd*k1**4*(12*C*(6*r*(s - 2) + 78*s**2 - 73*s + 19) - 36*r*(s - 2) - 531*s**2 + 498*s - 127) + fd*k1**2*k2**2*(12*C*(798*r**2 + 16*r*(39*s - 53) + 72*s**2 - 499*s + 283) - 5472*r**2 + r*(5394 - 4887*s) - 1674*s**2 + 3753*s - 1712) + 18*fd*k2**4*(2*C*(51*r**2 + r*(54*s - 37) - 4*s + 2) - 156*r**2 - 7*r*(30*s - 19) - 42*s**2 + 48*s - 15) - 12*gd2*k2**2*r*(28*k1**2*s + k2**2*(79*r + 49*s - 85))) + 132*fd*k2**2*(b2*k2**2*(30*r**2 + r*(30*s - 51) - 22*s + 18) + g2*(28*k1**2*s*(1 - 2*r) + k2**2*(-158*r**2 - 98*r*s + 235*r + 42*s - 78)))) + Dd*f*(132*b2*k2**4*(60*r**2 + r*(60*s - 109) - 40*s + 36) + 6*f**2*(55*k1**2*k2**2*(4*r - 1)*(s - 1) + 2*k2**4*(1140*r**2 + 3432*r*s - 2605*r + 1980*s**2 - 2772*s + 1042)) + 11*f*(12*k1**4*(4*C*(4*r*(3*s - 4) + 156*s**2 - 167*s + 47) - 24*r*s + 32*r - 354*s**2 + 381*s - 107) + k1**2*k2**2*(4*C*(3192*r**2 + 4*r*(624*s - 823) + 288*s**2 - 1919*s + 1199) - 7296*r**2 - 6516*r*s + 6872*r - 2232*s**2 + 4977*s - 2378) + 18*k2**4*(2*C*(68*r**2 + 72*r*s - 53*r - 4*s + 2) - 208*r**2 - 280*r*s + 198*r - 56*s**2 + 69*s - 22)) + 132*g2*k2**2*(28*k1**2*s*(1 - 4*r) + k2**2*(-316*r**2 - 196*r*s + 405*r + 42*s - 78)))))/(3465*d**2*k1*k2*k3**4) + 2*D1**3*Pk1*Pk3*ct*(420*b1**3*k1**2*k2**2*(D1*fd*(r**2 + 4*r*(s - 1) + 3*(s - 1)**2) + Dd*f*(4*r**2 + 16*r*s - 13*r + 12*s**2 - 20*s + 8)) - 3*b1**2*(D1*(-140*bd1*f*k1**2*k2**2*(3*r**2 + 3*r*(4*s - 3) + 9*s**2 - 14*s + 5) + fd*(k1**4*(280*C - 140)*(s - 1)*(r + s - 1) + k1**2*k2**2*(280*C*(2*r**2 + 5*r*(s - 1) + 3*(s - 1)**2) - 14*K*(58*r**2 + 13*r*(11*s + 8) + 98*s**2 + 68*s - 52) + 2*f*(210*r**2 + 2*r*(567*s - 251) + 966*s**2 - 895*s + 167) + 21*r*(9*s + 68) + 336*s**2 + 1652*s - 854) + 14*k2**4*(f*(8*r**2 + r*(56*s - 38) + 48*s**2 - 66*s + 26) - 5*r**2*(K - 4) - 5*r*s*(3*K - 9) + 15*s**2))) + Dd*f*(k1**4*(560*C - 280)*(2*s - 1)*(r + s - 1) + k1**2*k2**2*(280*C*(8*r**2 + 2*r*(10*s - 7) + 12*s**2 - 19*s + 7) - 14*K*(232*r**2 + r*(572*s + 2) + 392*s**2 - 129*s - 120) + 2*f*(420*r**2 + r*(2268*s - 1181) + 1932*s**2 - 2099*s + 552) + 84*r*(9*s + 23) + 1344*s**2 + 2205*s - 2016) + 14*k2**4*(2*f*(8*r**2 + r*(56*s - 30) + 48*s**2 - 58*s + 17) - 5*r**2*(4*K - 16) - 5*r*(12*K*s - 7*K - 36*s + 20) - 5*s*(7 - 12*s)))) - b1*(3*D1*(2*f**2*k2**2*(7*bd1*k1**2*(30*r**2 + r*(162*s - 97) + 138*s**2 - 172*s + 55) + 14*bd1*k2**2*(4*r**2 + r*(28*s - 11) + 24*s**2 - 25*s + 4) + fd*k1**2*(510*r**2 + 4*r*(363*s - 254) + 630*s**2 - 1027*s + 389) + 6*fd*k2**2*(18*r**2 + 9*r*(8*s - 5) + 54*s**2 - 69*s + 25)) + f*(7*bd1*(k1**4*s*(80*C - 40)*(r + s - 1) + k1**2*k2**2*(40*C*(4*r**2 + 2*r*(5*s - 2) + 6*s**2 - 7*s + 1) + K*(-232*r**2 - 572*r*s + 160*r - 392*s**2 + 266*s + 68) + 54*r*s - 14*r + 96*s**2 + 9*s - 48) - 20*k2**4*(r**2*(K - 4) + r*(K - 3)*(3*s - 2) + s*(2 - 3*s))) - 28*fd*k1**4*(2*C*(r*(17*s - 9) + 14*s**2 - 11*s + 2) - 17*r*s + 9*r - 18*s**2 + 15*s - 3) + fd*k1**2*k2**2*(-28*C*(4*r**2 + 7*r*(10*s - 3) + 20*s**2 - 6*s - 6) - 4*K*(786*r**2 + 1144*r*s - 835*r + 430*s**2 - 691*s + 221) + 1152*r**2 + 3846*r*s - 1502*r + 1644*s**2 - 1377*s + 162) - 14*fd*k2**4*(r**2*(14*K - 26) + r*(K*(18*s - 7) - 46*s + 13) + s*(-2*K - 14*s + 3)) + 28*k2**2*(-20*bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(k1**2*(58*r**2 + 143*r*s - 22*r + 98*s**2 - 64*s - 34) + 5*k2**2*r*(r + 3*s - 3)))) + 28*fd*k2**2*(-20*b2*k1**2*(r + s)**2 + g2*k1**2*(58*r**2 + 13*r*(11*s + 8) + 98*s**2 + 68*s - 52) + 5*g2*k2**2*r*(r + 3*s))) + Dd*f*(4*f**2*k2**2*(k1**2*(1020*r**2 + r*(2904*s - 2243) + 1260*s**2 - 2308*s + 973) + 18*k2**2*(12*r**2 + r*(48*s - 29) + 36*s**2 - 45*s + 14)) - 3*f*(14*k1**4*(2*C*(4*r*(17*s - 9) + 56*s**2 - 45*s + 9) + r*(36 - 68*s) - 72*s**2 + 61*s - 13) + k1**2*k2**2*(112*C*(2*r**2 + r*(35*s - 18) + 10*s**2 - 7*s + 1) + 4*K*(1572*r**2 + 2288*r*s - 1863*r + 860*s**2 - 1533*s + 633) - 2304*r**2 - 7692*r*s + 4260*r - 3288*s**2 + 3769*s - 1022) + 14*k2**4*(r**2*(28*K - 52) + r*(3*K*(12*s - 7) - 92*s + 53) + s*(-2*K - 28*s + 17))) + 84*k2**2*(-20*b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(232*r**2 + 572*r*s + 2*r + 392*s**2 - 129*s - 120) + 5*k2**2*r*(4*r + 12*s - 7))))) + f*(-D1*bd1*(2*f**2*k2**2*(k1**2*(510*r**2 + 2*r*(726*s - 719) + 630*s**2 - 1535*s + 779) + 18*k2**2*(6*r**2 + 24*r*s - 13*r + 18*s**2 - 21*s + 3)) - 3*f*(14*k1**4*(2*C*(r*(17*s - 1) + 14*s**2 - 5*s + 1) - 17*r*s + r - 18*s**2 + 7*s - 1) + k1**2*k2**2*(28*C*(2*r**2 + 35*r*s - 16*r + 10*s**2 - 10*s + 8) + 4*K*(393*r**2 + 572*r*s - 514*r + 215*s**2 - 421*s + 206) - 576*r**2 - 1923*r*s + 1162*r - 822*s**2 + 1182*s - 472) + 14*k2**4*(r**2*(7*K - 13) + r*(K*(9*s - 7) - 23*s + 20) - s*(7*s - 7))) + 84*k2**2*(-20*b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(k1**2*(58*r**2 + r*(143*s - 58) + s*(98*s - 69)) + 5*k2**2*r*(r + 3*s - 1)))) + 2*D1*(5*f**2*fd*k1**2*k2**2*(4*r*(49*s - 36) + 324*s**2 - 477*s + 169) + 9*f*fd*k1**2*(2*k1**2*(2*C*(60*r*s - 22*r + 42*s**2 - 57*s + 15) - 60*r*s + 22*r - 51*s**2 + 63*s - 16) + k2**2*(2*C*(84*r**2 + 291*r*s - 153*r + 108*s**2 - 122*s + 38) - 120*r**2 - 426*r*s + 210*r - 141*s**2 + 166*s - 49)) + 6*f*k2**2*(bd2*k1**2*(138*r**2 + r*(222*s - 187) + 84*s**2 - 157*s + 73) + 7*bd2*k2**2*r*(r + s) - 2*gd2*k1**2*(393*r**2 + r*(572*s - 514) + 215*s**2 - 421*s + 206) - 7*gd2*k2**2*r*(7*r + 9*s - 7)) + 6*fd*k2**2*(b2*k1**2*(276*r**2 + r*(444*s - 290) + 168*s**2 - 257*s + 76) + 7*b2*k2**2*(r + s)*(2*r - 1) - 2*g2*k1**2*(786*r**2 + r*(1144*s - 835) + 430*s**2 - 691*s + 221) - 7*g2*k2**2*(14*r**2 + r*(18*s - 7) - 2*s))) + 2*Dd*f*(5*f**2*k1**2*k2**2*(4*r*(49*s - 36) + 324*s**2 - 477*s + 169) + 18*f*(k1**4*(2*C*(80*r*s - 42*r + 56*s**2 - 85*s + 29) - 80*r*s + 42*r - 68*s**2 + 95*s - 31) + 2*k1**2*k2**2*(C*(56*r**2 + 194*r*s - 125*r + 72*s**2 - 91*s + 31) - 40*r**2 - 142*r*s + 88*r - 47*s**2 + 62*s - 21)) + 6*k2**2*(b2*k1**2*(552*r**2 + 8*r*(111*s - 83) + 336*s**2 - 571*s + 222) + 7*b2*k2**2*(r + s)*(4*r - 1) - 2*g2*k1**2*(1572*r**2 + r*(2288*s - 1863) + 860*s**2 - 1533*s + 633) - 7*g2*k2**2*(28*r**2 + 3*r*(12*s - 7) - 2*s)))))/(315*d**2*k1*k2*k3**4) + 8*D1**3*Pk1*Pk3*ct*st**2*(-33*D1*bd1*f*(f**2*k2**4*(k1**2*(9*r**2 + 2*r*(87*s - 40) + 165*s**2 - 222*s + 41) + 3*k2**2*(-10*r**2 + 3*r*(4*s + 1) + 22*s**2 - 15*s + 5)) + f*(k1**6*(4*C - 2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**4*k2**2*(4*C*(98*r**2 + r*(87*s - 45) - 11*s**2 + 77*s - 53) - 223*r**2 + r*(83 - 230*s) - 7*s**2 - 191*s + 140) - k1**2*k2**4*(-28*C*(54*r**2 + 88*r*s - 77*r + 34*s**2 - 55*s + 23) + 36*K*r**2 + 72*K*r*s + 30*K*r + 36*K*s**2 - 12*K*s - 24*K + b1*(436*r**2 + r*(1040*s - 731) + 604*s**2 - 899*s + 295) + 1031*r**2 + 1698*r*s - 1459*r + 667*s**2 - 1025*s + 428) - 7*k2**6*(3*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + 2*r**2*(3 - 2*K) + 2*r*(-2*K*s + K + 4*s - 2) + 2*s*(s - 1))) - 7*k2**2*(3*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*b1*(k1**4*(6*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(-20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*K*(5*r**2 + 13*r*s - 3*r + 8*s**2 - 12*s + 1) + 25*r**2 + 48*r*s - 46*r + 23*s**2 - 30*s + 14) + 5*k2**4*(r**2*(4*K - 6) + r*(K*(4*s - 3) - 8*s + 5) - s*(K + 2*s - 3))) + 4*k2**2*(b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(k1**2*(5*r**2 + r*(13*s - 5) + 2*s*(4*s - 7)) + 5*k2**2*(2*r**2 + 2*r*(s - 1) - s))))) + 693*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**4*(56 - 84*C)*(r + s - 1)**2 + k1**2*k2**2*(280*C*(r + s - 1)**2 - 14*K*(5*r**2 + r*(13*s - 4) + 8*s**2 - 4*s + 2) + f*(436*r**2 + 5*r*(208*s - 111) + 604*s**2 - 639*s + 179) - 175*r**2 - 56*r*(6*s - 7) - 161*s**2 + 392*s - 196) + 7*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-10*r*(2*K - 3) + 10*s))) + Dd*f*(k1**4*(56 - 84*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(280*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*K*(20*r**2 + 52*r*s - 11*r + 32*s**2 - 38*s + 6) + 2*f*(436*r**2 + r*(1040*s - 643) + 604*s**2 - 769*s + 237) - 700*r**2 - 1344*r*s + 1505*r - 644*s**2 + 1169*s - 588) + 14*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 5*r**2*(8*K - 12) - 5*r*(8*K*s - 4*K - 16*s + 7) + 5*s*(K + 4*s - 4)))) - 33*b1*(D1*(3*f**2*fd*k2**4*(k1**2*(9*r**2 + 29*r*(6*s - 1) + 165*s**2 - 131*s + 18) + k2**2*(-30*r**2 + r*(36*s - 13) + 66*s**2 - 67*s + 13)) + f*(fd*(k1**6*(4*C - 2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**4*k2**2*(4*C*(196*r**2 + 2*r*(87*s + 38) - 22*s**2 + 276*s - 133) - 446*r**2 - 4*r*(115*s + 53) - 14*s**2 - 687*s + 349) + k1**2*k2**4*(28*C*(108*r**2 + r*(176*s - 93) + 68*s**2 - 68*s + 16) - 18*K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 3*s - 6) - 2062*r**2 - 3396*r*s + 1880*r - 1334*s**2 + 1369*s - 351) + 14*k2**6*(r**2*(4*K - 6) + r*(K*(4*s - 2) - 8*s + 3) - s*(K + 2*s - 2))) - 28*k2**4*(bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(k1**2*(5*r**2 + 13*r*s - r + 8*s**2 - 10*s + 2) + 5*k2**2*r*(2*r + 2*s - 1)))) - 28*fd*k2**4*(b2*k1**2*(r + s)**2 + g2*k1**2*(5*r**2 + r*(13*s - 4) + 8*s**2 - 4*s + 2) + 10*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(36*r**2 + r*(696*s - 167) + 660*s**2 - 615*s + 95) - 6*k2**2*(20*r**2 + r*(5 - 24*s) - 44*s**2 + 41*s - 9)) + f*(k1**6*(4*C - 2)*(4*r*(s - 4) + 4*s**2 - 57*s + 31) + k1**4*k2**2*(8*C*(196*r**2 + 2*r*(87*s + 13) - 22*s**2 + 248*s - 159) - 892*r**2 - r*(920*s + 193) - 28*s**2 - 1216*s + 834) + k1**2*k2**4*(28*C*(216*r**2 + 4*r*(88*s - 61) + 136*s**2 - 175*s + 57) - 6*K*(24*r**2 + 8*r*(6*s + 5) + 24*s**2 + 5*s - 26) - 4124*r**2 - 6792*r*s + 4791*r - 2668*s**2 + 3412*s - 1130) + 14*k2**6*(r**2*(8*K - 12) + r*(K*(8*s - 4) - 16*s + 7) - s*(K + 4*s - 4))) - 28*k2**4*(b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(20*r**2 + 52*r*s - 11*r + 32*s**2 - 38*s + 6) + 5*k2**2*(8*r**2 + 8*r*s - 4*r - s))))) - f*(D1*(2*f**2*fd*k2**4*(k1**2*(5980*r**2 + r*(11920*s - 9973) + 5940*s**2 - 10823*s + 4556) + 132*k2**2*(12*r**2 + r*(42*s - 26) + 30*s**2 - 36*s + 11)) + 11*f*(fd*k1**2*(k1**4*(12*C - 6)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + k1**2*k2**2*(4*C*(666*r**2 + 468*r*s - 483*r - 198*s**2 - 69*s + 80) - 1503*r**2 - 1242*r*s + 975*r + 261*s**2 + 168*s - 105) + 9*k2**4*(4*C*(174*r**2 + 270*r*s - 181*r + 96*s**2 - 125*s + 42) - 492*r**2 - 768*r*s + 515*r - 276*s**2 + 354*s - 119)) - 12*k2**4*(bd2*k1**2*(8*r**2 + r*(16*s - 5) + 8*s**2 - 5*s - 3) + gd2*(-3*k1**2*(6*r**2 + 12*r*s + 5*r + 6*s**2 - 2*s - 4) + 7*k2**2*r*(2*r + 2*s - 1)))) - 132*fd*k2**4*(b2*k1**2*(16*r**2 + r*(32*s - 2) + 16*s**2 - 2*s - 3) - g2*(9*k1**2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 3*s - 6) + 7*k2**2*(-4*r**2 - 4*r*s + 2*r + s)))) + Dd*f*(2*f**2*k2**4*(k1**2*(5980*r**2 + r*(11920*s - 9973) + 5940*s**2 - 10823*s + 4556) + 132*k2**2*(12*r**2 + r*(42*s - 26) + 30*s**2 - 36*s + 11)) + 11*f*k1**2*(k1**4*(12*C - 6)*(4*r*(3*s - 2) + 12*s**2 - 27*s + 11) + k1**2*k2**2*(4*C*(888*r**2 + 624*r*s - 592*r - 264*s**2 - 7*s + 84) - 2004*r**2 - 1656*r*s + 1181*r + 348*s**2 + 52*s - 76) + 9*k2**4*(4*C*(232*r**2 + 8*r*(45*s - 32) + 128*s**2 - 175*s + 60) - 656*r**2 - 1024*r*s + 734*r - 368*s**2 + 499*s - 172)) - 132*k2**4*(b2*k1**2*(32*r**2 + 4*r*(16*s - 3) + 32*s**2 - 12*s - 9) - g2*(3*k1**2*(24*r**2 + 8*r*(6*s + 5) + 24*s**2 + 5*s - 26) + 7*k2**2*(-8*r**2 + r*(4 - 8*s) + s))))))/(3465*d**2*k1*k2*k3**6) + 4*D1**3*Pk1*Pk3*ct*st**2*(D1*bd1*f**2*(k1**2*(r*(2*C - 1)*(23*s + 17) + s*(-36*C + 29*s - 7)) + 7*k2**2*r*(r - 1)) + 7*b1**2*(D1*fd*(11*k1**2*(s - 1)**2 - 3*k2**2*r**2) + Dd*f*(22*k1**2*(2*s**2 - 3*s + 1) + 3*k2**2*r*(1 - 4*r))) + b1*f*(D1*(154*bd1*k1**2*s*(s - 1) + 21*bd1*k2**2*r*(1 - 2*r) + 2*fd*k1**2*(2*C*r*(23*s + 6) - 37*C*s + C - r*(23*s + 6) + 29*s**2 - 21*s + 12) + 7*fd*k2**2*(2*r**2 - 3*r + 1)) + Dd*f*(k1**2*(2*C*(4*r*(23*s + 6) - 73*s + 19) - 4*r*(23*s + 6) + 116*s**2 - 85*s + 31) + 7*k2**2*(4*r**2 - 5*r + 1))))/(105*d**2*k1**3*k2) - 4*D1**3*Pk1*Pk3*ct*(7*D1*bd1*f**2*(k1**2*(r*(2*C - 1)*(5*s - 1) - 4*s*(3*C + s - 2)) + 2*k2**2*r**2) + 14*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(14*bd1*f*k2**2*r*(3*r - 1) - 70*fd*k1**2*(s - 1)**2 + fd*k2**2*(f*(6*r**2 + r - 2) + 28*r**2 + 14*r - 7)) + Dd*f*(-140*k1**2*(2*s**2 - 3*s + 1) + k2**2*(4*r - 1)*(3*f*r + 2*f + 28*r + 7))) + b1*f*(D1*(-140*bd1*k1**2*s*(s - 1) + bd1*k2**2*r*(6*f*r + 4*f + 56*r - 21) + 7*fd*k1**2*(2*C*(10*r*s - 6*r - 13*s + 7) - 10*r*s + 6*r - 8*s**2 + 21*s - 9) + 14*fd*k2**2*r*(2*r - 1)) + 7*Dd*f*(k1**2*(C*(8*r*(5*s - 3) - 50*s + 26) - 20*r*s + 12*r - 16*s**2 + 41*s - 17) + 2*k2**2*r*(4*r - 1))))/(105*d**2*k1**3*k2) - 2*D1**3*Pk1*Pk3*ct*st**4*(168*b1**2*k1**2*(D1*fd*(s - 1)*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + Dd*f*(k1**2*(8*C - 6)*(2*s**2 - 3*s + 1) - k2**2*(C - 1)*(r*(8*s - 6) - s + 1))) - 3*b1*f*(2*D1*(28*bd1*k1**2*(k1**2*s*(6 - 8*C)*(s - 1) + k2**2*(C - 1)*(r*(4*s - 2) - s + 1)) + fd*(k1**4*(8*C - 4)*(18*s**2 - 25*s + 8) + k1**2*k2**2*(8*C*(2*r - 1)*(2*s - 1) + 3*r*(3*s - 5) + 68*s**2 - 52*s + 9) - 4*k2**4*r**2)) + Dd*f*(k1**4*(32*C - 16)*(18*s**2 - 25*s + 8) + k1**2*k2**2*(8*C*(8*r - 3)*(2*s - 1) + 12*r*(3*s - 5) + 272*s**2 - 255*s + 70) + 4*k2**4*r*(1 - 4*r))) - f**2*(D1*(3*bd1*(k1**4*s*(16*C - 8)*(9*s - 8) + k1**2*k2**2*(8*C*r*(4*s - 1) + 9*r*(s - 2) + 68*s**2 - s*(8*C + 57) + 26) - 4*k2**4*r*(r - 1)) + fd*(8*k1**4*(3*s - 1)*(C*(42*s - 20) - 24*s + 11) + k1**2*k2**2*(C*(72*r*s + 60*r - 72*s - 4) + 225*r*s - 126*r + 180*s**2 - 207*s + 66) + 2*k2**4*(45*r**2 - 12*r - 1))) + Dd*f*(16*k1**4*(2*s - 1)*(C*(42*s - 20) - 24*s + 11) + k1**2*k2**2*(4*C*(8*r*(3*s + 1) - 28*s + 9) + 4*r*(75*s - 41) + 240*s**2 - 289*s + 88) + 2*k2**4*(60*r**2 - 11*r - 1))))/(105*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct*st**2*(b1**2*(D1*fd*(14*k1**4*(s - 1)*(4*C*(r + 11*s - 11) - 2*r - 33*s + 33) + 7*k1**2*k2**2*(2*f*(r*(4*s - 2) + s - 1) + r*(-28*C*(s - 1) + 33*s - 28)) + k2**4*r**2*(-240*f - 42)) + Dd*f*(56*k1**4*(C*(4*r*(s - 2) + 44*s**2 - 69*s + 25) - 2*r*(s - 2) - 33*s**2 + 51*s - 18) - 7*k1**2*k2**2*(8*C*(14*r*s - 3*r + 2*s - 2) - 2*f*(4*r - 1)*(2*s - 1) - 132*r*s + 24*r - 11*s + 16) + k2**4*r*(-120*f - 42)*(4*r - 1))) + b1*f*(D1*bd1*(28*k1**4*(2*C*(2*r*(s - 3) + 22*s**2 - 25*s + 3) - 2*r*(s - 3) - 33*s**2 + 36*s - 3) - 7*k1**2*k2**2*(8*C*(7*r*s + 4*r + 2*s - 2) + f*(-8*r*s + 4*r + 6*s - 4) - 66*r*s - 32*r - 11*s + 16) + k2**4*r*(-120*f - 42)*(2*r - 1)) + D1*fd*(-k1**4*(4*C - 2)*(220*s**2 - 353*s + 97) + k1**2*k2**2*(4*C*(104*r**2 - 3*r*(6*s + 41) + 16*s + 32) - 28*K*r*s + 14*K*s + 12*f*(3*r - 1)*(3*s - 2) - 208*r**2 + 276*r*s + 188*r + 672*s**2 - 757*s + 94) - 2*k2**4*(6*f*(9*r**2 + 3*r - 2) + 70*r**2 + 21*r - 7)) + 2*Dd*f*(-k1**4*(88*C - 44)*(10*s**2 - 17*s + 6) + k1**2*k2**2*(4*C*(104*r**2 - r*(18*s + 97) + 26*s + 7) - 28*K*r*s + 7*K*s + 6*f*(4*r - 1)*(3*s - 2) - 208*r**2 + 276*r*s + 84*r + 672*s**2 - 833*s + 206) - k2**4*(4*r - 1)*(6*f*(3*r + 2) + 35*r + 7))) + f*(D1*bd1*f*(-k1**4*(4*C - 2)*(110*s**2 - 153*s + 35) + k1**2*k2**2*(r**2*(208*C - 104) - 2*r*(2*C*(9*s + 50) + 7*K*s - 18*f*s + 12*f - 69*s - 8) + 336*s**2 + s*(72*C - 333) + 78) - 2*k2**4*r*(6*f*(3*r + 2) + 35*r - 35)) + D1*(f*fd*(2*k1**4*(4*C*(18*r - 162*s**2 + 141*s - 35) - 36*r + 387*s**2 - 342*s + 83) + k1**2*k2**2*(-4*C*(126*r**2 + 3*r*(66*s - 71) - 126*s + 77) + 324*r**2 + 15*r*(33*s - 34) + 216*s**2 - 357*s + 174) + 24*k2**4*r*(1 - 3*r)) - 14*f*k1**2*k2**2*r*s*(bd2 - 2*gd2) - 14*fd*k1**2*k2**2*s*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(f*(4*k1**4*(8*C*(4*r - 54*s**2 + 55*s - 15) - 16*r + 258*s**2 - 267*s + 73) + k1**2*k2**2*(-4*C*(168*r**2 + 264*r*s - 302*r - 162*s + 113) + 432*r**2 + 660*r*s - 692*r + 288*s**2 - 493*s + 238) + 24*k2**4*r*(1 - 4*r)) + k1**2*k2**2*s*(-14*b2 + 28*g2)*(4*r - 1))))/(105*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct*(D1*b1**2*fd*(140*k1**4*(s - 1)*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(28*K*(r - 1)*(9*r + 4*s - 9) + 2*f*(r*(196*s - 51) + 420*s**2 - 490*s + 158) + 7*r*(60*C*(s - 1) - 37*s + 96) + 350*s**2 + 112*s - 126) - 70*k2**4*r**2) + D1*b1*(2*f**2*k1**2*k2**2*(7*bd1*(7*r*(4*s - 1) + 60*s**2 - 52*s + 5) + fd*(90*r**2 + 6*r*(63*s - 47) + 378*s**2 - 657*s + 271)) + f*(7*bd1*(40*k1**4*s*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(8*K*(9*r**2 + 2*r*(2*s - 5) - 2*s + 1) + 2*r*(60*C*s - 37*s + 2) + 100*s**2 - 51*s - 8) + 10*k2**4*r*(1 - 2*r)) + fd*k1**4*(28*C - 14)*(4*s**2 - 23*s + 11) + fd*k1**2*k2**2*(-2*K*(108*r**2 + 2*r*(49*s - 75) - 105*s + 48) + r**2*(112*C + 160) + 2*r*(14*C*(14*s - 9) + 179*s - 73) + 308*s**2 - 277*s + 54) + 28*fd*k2**4*r*(1 - 2*r) - 56*gd2*k1**2*k2**2*(9*r**2 + r*(4*s - 11) - 2*s + 2)) - 56*fd*g2*k1**2*k2**2*(r - 1)*(9*r + 4*s - 9)) + D1*bd1*f*(2*f**2*k1**2*k2**2*(30*r**2 + 2*r*(63*s - 50) + 126*s**2 - 201*s + 57) + f*(k1**4*(28*C - 14)*(2*s**2 - 9*s - 1) + k1**2*k2**2*(-2*K*(54*r**2 + 49*r*s - 76*r - 42*s + 42) + r**2*(56*C + 80) + r*(196*C*s + 179*s - 182) + 154*s**2 - 246*s + 92) - 28*k2**4*r**2) - 56*g2*k1**2*k2**2*(9*r**2 + r*(4*s - 9) - 2*s)) + Dd*b1**2*f*(280*k1**4*(2*s - 1)*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(28*K*(36*r**2 + r*(16*s - 49) - 10*s + 13) + 2*f*(4*r*(98*s - 25) + 840*s**2 - 854*s + 193) + 28*r*(60*C*s - 30*C - 37*s + 41) + 1400*s**2 - 539*s - 238) + 70*k2**4*r*(1 - 4*r)) + Dd*b1*f*(4*f**2*k1**2*k2**2*(60*r**2 + r*(252*s - 191) + 252*s**2 - 429*s + 164) + f*(k1**4*(112*C - 56)*(2*s**2 - 11*s + 5) + k1**2*k2**2*(K*(-432*r**2 - 392*r*s + 604*r + 378*s - 264) + r**2*(224*C + 320) + r*(112*C*(7*s - 4) + 716*s - 468) + 616*s**2 - 769*s + 238) + 28*k2**4*r*(1 - 4*r)) - 56*g2*k1**2*k2**2*(36*r**2 + r*(16*s - 49) - 10*s + 13)) - 2*f*k1**2*(D1*(f*(6*fd*(k1**2*(2*C*(6*r*(5*s - 2) + 9*s**2 - 25*s + 8) - 30*r*s + 12*r - 18*s**2 + 31*s - 9) + k2**2*r*(-3*r - 27*s + 10)) + k2**2*(bd2 - 2*gd2)*(54*r**2 + 49*r*s - 76*r - 42*s + 42)) + fd*k2**2*(b2 - 2*g2)*(108*r**2 + 2*r*(49*s - 75) - 105*s + 48)) + Dd*f*(6*f*(k1**2*(C*(80*r*s - 44*r + 24*s**2 - 70*s + 30) - 40*r*s + 22*r - 24*s**2 + 45*s - 17) + k2**2*r*(-4*r - 36*s + 19)) + k2**2*(b2 - 2*g2)*(216*r**2 + 2*r*(98*s - 151) - 189*s + 132))))/(105*d**2*k1**3*k2*k3**2) - 2*D1**3*Pk1*Pk3*ct*st**4*(924*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C))*(r + s - 1) + Dd*f*(k1**2*(4*C - 3)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(2 - 2*C)*(8*r**2 + 8*r*(s - 1) - s + 1))) - 33*b1*f*(-2*D1*(14*bd1*k1**2*k2**2*(k1**2*(4*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k2**2*(2 - 2*C)*(4*r**2 + 4*r*(s - 1) - s + 1)) + fd*(30*f*k2**6*r**2 + 4*k1**6*(2*s - 1)*(C*(34*s - 24) - 19*s + 13) + k1**4*k2**2*(-4*C*(r*(113*s - 74) + 118*s**2 - 131*s + 36) + r*(291*s - 191) + 312*s**2 - 358*s + 101) - k1**2*k2**4*(4*C*(11*r**2 - 18*r*s + r - 4*s + 4) + 3*f*(12*r*s - 9*r + 2*s - 1) - 28*r**2 + 156*r*s - 53*r + 68*s**2 - 52*s + 1))) + Dd*f*(20*f*k2**6*r*(1 - 4*r) - 16*k1**6*(2*s - 1)*(C*(34*s - 24) - 19*s + 13) + k1**4*k2**2*(4*C*(4*r*(113*s - 74) + 472*s**2 - 649*s + 224) + r*(764 - 1164*s) - 1248*s**2 + 1769*s - 618) + 2*k1**2*k2**4*(2*C*(44*r**2 + r*(9 - 72*s) - 20*s + 14) + 3*f*(4*r - 1)*(4*s - 3) - 56*r**2 + 312*r*s - 124*r + 136*s**2 - 89*s + 6))) - f**2*(D1*(-33*bd1*(20*f*k2**6*r*(r - 1) + 8*k1**6*s*(C*(34*s - 24) - 19*s + 13) + k1**4*k2**2*(-4*C*(r*(113*s - 72) + 118*s**2 - 193*s + 76) + r*(291*s - 190) + 312*s**2 - 527*s + 202) - 2*k1**2*k2**4*(C*(22*r**2 - 2*r*(18*s + 13) - 20*s + 8) + 3*f*(4*r*s - 3*r - 6*s + 4) - 14*r**2 + 78*r*s + 18*r + 34*s**2 + 10*s - 8)) + fd*(-30*f*k2**6*(12*r**2 + 5*r - 2) - 88*k1**6*(3*s - 1)*(6*C*(9*s - 4) - 30*s + 13) + 11*k1**4*k2**2*(4*C*(3*r*(213*s - 91) + 486*s**2 - 495*s + 131) - 3*r*(585*s - 238) - 1296*s**2 + 1401*s - 366) + 22*k1**2*k2**4*(C*(342*r**2 + 6*r*(6*s - 47) + 52) + 12*f*(4*r - 1)*(3*s - 2) - 135*r**2 + 198*r*s + 15*r + 90*s**2 - 180*s + 38))) + Dd*f*(-30*f*k2**6*(12*r**2 + 5*r - 2) - 176*k1**6*(2*s - 1)*(6*C*(9*s - 4) - 30*s + 13) + 11*k1**4*k2**2*(4*C*(4*r*(213*s - 95) + 648*s**2 - 705*s + 179) - 4*r*(585*s - 251) - 1728*s**2 + 1987*s - 520) + 22*k1**2*k2**4*(2*C*(228*r**2 + r*(24*s - 161) + 6*s + 20) + 12*f*(4*r - 1)*(3*s - 2) - 180*r**2 + 264*r*s - 61*r + 120*s**2 - 271*s + 99))))/(1155*d**2*k1**3*k2*k3**4) - 8*D1**3*Pk1*Pk3*f*k2**4*st**6*(11*D1*bd1*f*(k1**2*(36*C - 18)*(2*r + 2*s - 1) + k2**2*(-36*b1*(2*r + 2*s - 1) + f*(15*r + 15*s - 7)))*(r + s - 1) - 198*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 11*b1*(D1*fd*(f*k2**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + k1**2*(36*C - 18)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(15*r + 15*s - 7) + k1**2*(36*C - 18)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(116*r**2 + r*(232*s - 163) + 116*s**2 - 163*s + 57) + k1**2*(44*C - 22)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(29*r + 29*s - 19) + k1**2*(44*C - 22)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(231*d**2*k3**8) - 8*D1**3*Pk1*Pk3*f*k2**2*st**6*(11*D1*bd1*f*(2*f*k2**4*(6*r**2 + r*(6*s - 8) - 3*s + 2) + k1**4*(36*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2) - 9*k1**2*k2**2*(4*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 16*r**2 + r*(21 - 20*s) - 4*s**2 + 12*s - 5)) + 11*b1*(6*D1*fd*(2*f*k2**4*r*(3*r + 3*s - 2) + k1**4*(12*C - 6)*(2*s - 1)*(2*r + 2*s - 1) - 3*k1**2*k2**2*(2*r + 2*s - 1)*(2*C*(6*r + 2*s - 1) - 8*r - 2*s + 1)) + Dd*f*(2*f*k2**4*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**4*(36*C - 18)*(2*s - 1)*(8*r + 8*s - 5) - 9*k1**2*k2**2*(8*C*(12*r**2 + r*(16*s - 11) + 4*s**2 - 6*s + 2) - 64*r**2 + r*(56 - 80*s) - 16*s**2 + 26*s - 9))) + f*(D1*fd*(f*k2**4*(120*r**2 + 8*r*(15*s - 4) + 25*s - 27) + k1**4*(88*C - 44)*(3*s - 1)*(3*r + 3*s - 2) - 22*k1**2*k2**2*(3*r + 3*s - 2)*(2*C*(9*r + 3*s - 4) - 12*r - 3*s + 5)) + Dd*f*(f*k2**4*(120*r**2 + 8*r*(15*s - 4) + 25*s - 27) + k1**4*(44*C - 22)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 11*k1**2*k2**2*(4*C*(36*r**2 + r*(48*s - 41) + 12*s**2 - 24*s + 11) - 96*r**2 - 2*r*(60*s - 53) - 24*s**2 + 55*s - 27))))/(693*d**2*k1**2*k3**6) + 4*D1**3*Pk1*Pk3*f*st**6*(9*b1*(2*s - 1)*(4*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + Dd*f*(k1**2*(16*C - 8)*(2*s - 1) + k2**2*(8*r - 1))) + f*(9*D1*bd1*(k1**2*s*(8*C - 4)*(2*s - 1) + k2**2*(r*(4*s - 1) - 2*s + 1)) + 2*D1*fd*(3*s - 1)*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1)) + Dd*f*k1**2*(16*C - 8)*(6*s**2 - 5*s + 1) + Dd*f*k2**2*(2*r*(12*s - 5) - 7*s + 3)))/(63*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*f*st**6*(9*b1*(D1*fd*(k1**4*(1 - 2*s)**2*(16 - 32*C) + 16*k1**2*k2**2*(2*s - 1)*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1) + k2**4*r*(3*f*(5*s - 3) - r*(32*C - 64) + 32*s - 16)) + Dd*f*(k1**4*(1 - 2*s)**2*(32 - 64*C) + 4*k1**2*k2**2*(2*s - 1)*(8*C*(8*r + 4*s - 3) - 40*r - 16*s + 13) + k2**4*(f*(4*r - 1)*(5*s - 3) - r**2*(64*C - 128) + 16*r*(C + 4*s - 4) - 8*s + 4))) + f*(D1*(-9*bd1*(k1**4*s*(32*C - 16)*(2*s - 1) - 4*k1**2*k2**2*(8*C*(4*r*s - r + 2*s**2 - 3*s + 1) - 20*r*s + 5*r - 8*s**2 + 14*s - 5) + k2**4*(-f*(r - 1)*(5*s - 3) + r**2*(16*C - 32) - 4*r*(4*C + 4*s - 9) + 8*s - 4)) + fd*(k1**4*(1 - 3*s)**2*(16 - 32*C) + 8*k1**2*k2**2*(3*s - 1)*(12*C*(2*r + s - 1) - 15*r - 6*s + 7) + k2**4*(-8*C*(1 - 3*r)**2 + 3*f*(4*r - 1)*(5*s - 3) + (72*r - 24)*(2*r + s - 1)))) + Dd*f*(k1**4*(32 - 64*C)*(6*s**2 - 5*s + 1) + 4*k1**2*k2**2*(8*C*(12*s - 5)*(2*r + s - 1) + r*(50 - 120*s) - 48*s**2 + 75*s - 23) + k2**4*(-8*C*(12*r**2 - 7*r + 1) + 3*f*(4*r - 1)*(5*s - 3) + (96*r - 28)*(2*r + s - 1)))))/(63*d**2*k1**2*k3**4) - 8*D1**3*Pk1*Pk3*k1**4*(D1*(-14*b1*fd*(2*k1**2 + 5*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 15*bd1*f**3*k2**2*(r + s - 1)**2 + 3*f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(4*r + 4*s - 2) + 7*K*k2**2*(r + s) - 7*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))) + f*(3*fd*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(2*r + 2*s - 1) + (2*k1**2 + 5*k2**2)*(28*b1*gd2 + 28*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(15*b1*f**2*k2**2*(r + s - 1) - 14*b1*(2*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 3*f*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))))/(35*d**2*k3**8) + 8*D1**3*Pk1*Pk3*k1**2*(-336*C*D1*b1*f*fd*k1**2*r*s + 168*C*D1*b1*f*fd*k1**2*r - 336*C*D1*b1*f*fd*k1**2*s**2 + 504*C*D1*b1*f*fd*k1**2*s - 168*C*D1*b1*f*fd*k1**2 - 324*C*D1*f**2*fd*k1**2*r*s + 108*C*D1*f**2*fd*k1**2*r - 324*C*D1*f**2*fd*k1**2*s**2 + 432*C*D1*f**2*fd*k1**2*s - 108*C*D1*f**2*fd*k1**2 - 672*C*Dd*b1*f**2*k1**2*r*s + 336*C*Dd*b1*f**2*k1**2*r - 672*C*Dd*b1*f**2*k1**2*s**2 + 1008*C*Dd*b1*f**2*k1**2*s - 336*C*Dd*b1*f**2*k1**2 - 432*C*Dd*f**3*k1**2*r*s + 216*C*Dd*f**3*k1**2*r - 432*C*Dd*f**3*k1**2*s**2 + 648*C*Dd*f**3*k1**2*s - 216*C*Dd*f**3*k1**2 - 588*D1*K*b1**2*fd*k1**2*r**2 - 1176*D1*K*b1**2*fd*k1**2*r*s - 168*D1*K*b1**2*fd*k1**2*r - 588*D1*K*b1**2*fd*k1**2*s**2 - 168*D1*K*b1**2*fd*k1**2*s + 84*D1*K*b1**2*fd*k1**2 - 840*D1*K*b1**2*fd*k2**2*r**2 - 1470*D1*K*b1**2*fd*k2**2*r*s - 630*D1*K*b1**2*fd*k2**2*s**2 - 1152*D1*K*b1*f*fd*k1**2*r**2 - 2088*D1*K*b1*f*fd*k1**2*r*s + 1152*D1*K*b1*f*fd*k1**2*r - 936*D1*K*b1*f*fd*k1**2*s**2 + 1086*D1*K*b1*f*fd*k1**2*s - 288*D1*K*b1*f*fd*k1**2 - 1008*D1*K*b1*f*fd*k2**2*r**2 - 1680*D1*K*b1*f*fd*k2**2*r*s + 504*D1*K*b1*f*fd*k2**2*r - 672*D1*K*b1*f*fd*k2**2*s**2 + 378*D1*K*b1*f*fd*k2**2*s - 105*D1*b1**3*fd*k2**2*r**2 - 210*D1*b1**3*fd*k2**2*r*s + 210*D1*b1**3*fd*k2**2*r - 105*D1*b1**3*fd*k2**2*s**2 + 210*D1*b1**3*fd*k2**2*s - 105*D1*b1**3*fd*k2**2 + 252*D1*b1**2*f*fd*k1**2*r*s - 189*D1*b1**2*f*fd*k1**2*r + 252*D1*b1**2*f*fd*k1**2*s**2 - 294*D1*b1**2*f*fd*k1**2*s + 84*D1*b1**2*f*fd*k1**2 + 252*D1*b1**2*f*fd*k2**2*r**2 + 756*D1*b1**2*f*fd*k2**2*r*s - 441*D1*b1**2*f*fd*k2**2*r + 504*D1*b1**2*f*fd*k2**2*s**2 - 525*D1*b1**2*f*fd*k2**2*s + 105*D1*b1**2*f*fd*k2**2 + 84*D1*b1**2*fd*k1**2*r*s + 84*D1*b1**2*fd*k1**2*s**2 + 105*D1*b1**2*fd*k2**2*r**2 + 210*D1*b1**2*fd*k2**2*r*s + 105*D1*b1**2*fd*k2**2*s**2 - 84*D1*b1*b2*fd*k1**2*r**2 - 168*D1*b1*b2*fd*k1**2*r*s - 84*D1*b1*b2*fd*k1**2*s**2 - 210*D1*b1*b2*fd*k2**2*r**2 - 420*D1*b1*b2*fd*k2**2*r*s - 210*D1*b1*b2*fd*k2**2*s**2 + 270*D1*b1*f**2*fd*k1**2*r*s - 180*D1*b1*f**2*fd*k1**2*r + 270*D1*b1*f**2*fd*k1**2*s**2 - 351*D1*b1*f**2*fd*k1**2*s + 117*D1*b1*f**2*fd*k1**2 + 405*D1*b1*f**2*fd*k2**2*r**2 + 864*D1*b1*f**2*fd*k2**2*r*s - 639*D1*b1*f**2*fd*k2**2*r + 459*D1*b1*f**2*fd*k2**2*s**2 - 531*D1*b1*f**2*fd*k2**2*s + 180*D1*b1*f**2*fd*k2**2 + 312*D1*b1*f*fd*k1**2*r*s - 84*D1*b1*f*fd*k1**2*r + 312*D1*b1*f*fd*k1**2*s**2 - 324*D1*b1*f*fd*k1**2*s + 84*D1*b1*f*fd*k1**2 + 126*D1*b1*f*fd*k2**2*r**2 + 252*D1*b1*f*fd*k2**2*r*s - 63*D1*b1*f*fd*k2**2*r + 126*D1*b1*f*fd*k2**2*s**2 + 1176*D1*b1*f*gd2*k1**2*r**2 + 2352*D1*b1*f*gd2*k1**2*r*s - 1008*D1*b1*f*gd2*k1**2*r + 1176*D1*b1*f*gd2*k1**2*s**2 - 1008*D1*b1*f*gd2*k1**2*s - 168*D1*b1*f*gd2*k1**2 + 1680*D1*b1*f*gd2*k2**2*r**2 + 2940*D1*b1*f*gd2*k2**2*r*s - 1680*D1*b1*f*gd2*k2**2*r + 1260*D1*b1*f*gd2*k2**2*s**2 - 1260*D1*b1*f*gd2*k2**2*s + 1176*D1*b1*fd*g2*k1**2*r**2 + 2352*D1*b1*fd*g2*k1**2*r*s + 336*D1*b1*fd*g2*k1**2*r + 1176*D1*b1*fd*g2*k1**2*s**2 + 336*D1*b1*fd*g2*k1**2*s - 168*D1*b1*fd*g2*k1**2 + 1680*D1*b1*fd*g2*k2**2*r**2 + 2940*D1*b1*fd*g2*k2**2*r*s + 1260*D1*b1*fd*g2*k2**2*s**2 - 144*D1*b2*f*fd*k1**2*r**2 - 288*D1*b2*f*fd*k1**2*r*s + 144*D1*b2*f*fd*k1**2*r - 144*D1*b2*f*fd*k1**2*s**2 + 144*D1*b2*f*fd*k1**2*s - 36*D1*b2*f*fd*k1**2 - 252*D1*b2*f*fd*k2**2*r**2 - 504*D1*b2*f*fd*k2**2*r*s + 126*D1*b2*f*fd*k2**2*r - 252*D1*b2*f*fd*k2**2*s**2 + 126*D1*b2*f*fd*k2**2*s + 3*D1*bd1*f*(-35*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 7*b1*(4*K*(k1**2*(14*r + 14*s + 1) + 5*k2**2*(4*r + 3*s))*(r + s - 1) + k1**2*(r*(2 - 8*s) + s*(6 - 8*s)) - 5*k2**2*(2*r**2 + r*(4*s - 3) + s*(2*s - 1))) + 3*f**2*(2*k1**2*(s - 1)*(5*r + 5*s - 4) + k2**2*(15*r**2 + r*(32*s - 38) + 17*(s - 1)**2)) + f*(k1**2*(-2*K*(96*r**2 + 3*r*(58*s - 45) + 78*s**2 - 125*s + 47) + 7*b1*(3*r*(4*s - 3) + 12*s**2 - 17*s + 7) - 2*r*(28*C*s - 26*s + 6) - 2*(s - 1)*(28*C*s - 26*s + 3)) + 7*k2**2*(b1*(12*r**2 + r*(36*s - 33) + 24*s**2 - 37*s + 17) + r**2*(3 - 24*K) + r*(-40*K*s + 22*K + 6*s - 6) - s*(16*K - 3)*(s - 1))) - 7*(b2*(2*k1**2 + 5*k2**2)*(r + s) - 2*g2*(14*k1**2*(r + s) + 5*k2**2*(4*r + 3*s)))*(2*r + 2*s - 2)) - 6*D1*bd2*f*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(r + s - 1) - 160*D1*f**3*fd*k2**2*r*s + 80*D1*f**3*fd*k2**2*r - 160*D1*f**3*fd*k2**2*s**2 + 240*D1*f**3*fd*k2**2*s - 80*D1*f**3*fd*k2**2 + 162*D1*f**2*fd*k1**2*r*s - 54*D1*f**2*fd*k1**2*r + 162*D1*f**2*fd*k1**2*s**2 - 216*D1*f**2*fd*k1**2*s + 54*D1*f**2*fd*k1**2 + 1152*D1*f**2*gd2*k1**2*r**2 + 2088*D1*f**2*gd2*k1**2*r*s - 1620*D1*f**2*gd2*k1**2*r + 936*D1*f**2*gd2*k1**2*s**2 - 1500*D1*f**2*gd2*k1**2*s + 564*D1*f**2*gd2*k1**2 + 1008*D1*f**2*gd2*k2**2*r**2 + 1680*D1*f**2*gd2*k2**2*r*s - 924*D1*f**2*gd2*k2**2*r + 672*D1*f**2*gd2*k2**2*s**2 - 672*D1*f**2*gd2*k2**2*s + 2304*D1*f*fd*g2*k1**2*r**2 + 4176*D1*f*fd*g2*k1**2*r*s - 2304*D1*f*fd*g2*k1**2*r + 1872*D1*f*fd*g2*k1**2*s**2 - 2172*D1*f*fd*g2*k1**2*s + 576*D1*f*fd*g2*k1**2 + 2016*D1*f*fd*g2*k2**2*r**2 + 3360*D1*f*fd*g2*k2**2*r*s - 1008*D1*f*fd*g2*k2**2*r + 1344*D1*f*fd*g2*k2**2*s**2 - 756*D1*f*fd*g2*k2**2*s - 2352*Dd*K*b1**2*f*k1**2*r**2 - 4704*Dd*K*b1**2*f*k1**2*r*s + 1428*Dd*K*b1**2*f*k1**2*r - 2352*Dd*K*b1**2*f*k1**2*s**2 + 1428*Dd*K*b1**2*f*k1**2*s + 252*Dd*K*b1**2*f*k1**2 - 3360*Dd*K*b1**2*f*k2**2*r**2 - 5880*Dd*K*b1**2*f*k2**2*r*s + 2520*Dd*K*b1**2*f*k2**2*r - 2520*Dd*K*b1**2*f*k2**2*s**2 + 1890*Dd*K*b1**2*f*k2**2*s - 2304*Dd*K*b1*f**2*k1**2*r**2 - 4176*Dd*K*b1*f**2*k1**2*r*s + 2772*Dd*K*b1*f**2*k1**2*r - 1872*Dd*K*b1*f**2*k1**2*s**2 + 2586*Dd*K*b1*f**2*k1**2*s - 852*Dd*K*b1*f**2*k1**2 - 2016*Dd*K*b1*f**2*k2**2*r**2 - 3360*Dd*K*b1*f**2*k2**2*r*s + 1428*Dd*K*b1*f**2*k2**2*r - 1344*Dd*K*b1*f**2*k2**2*s**2 + 1050*Dd*K*b1*f**2*k2**2*s - 420*Dd*b1**3*f*k2**2*r**2 - 840*Dd*b1**3*f*k2**2*r*s + 735*Dd*b1**3*f*k2**2*r - 420*Dd*b1**3*f*k2**2*s**2 + 735*Dd*b1**3*f*k2**2*s - 315*Dd*b1**3*f*k2**2 + 504*Dd*b1**2*f**2*k1**2*r*s - 378*Dd*b1**2*f**2*k1**2*r + 504*Dd*b1**2*f**2*k1**2*s**2 - 651*Dd*b1**2*f**2*k1**2*s + 231*Dd*b1**2*f**2*k1**2 + 504*Dd*b1**2*f**2*k2**2*r**2 + 1512*Dd*b1**2*f**2*k2**2*r*s - 1134*Dd*b1**2*f**2*k2**2*r + 1008*Dd*b1**2*f**2*k2**2*s**2 - 1302*Dd*b1**2*f**2*k2**2*s + 462*Dd*b1**2*f**2*k2**2 + 336*Dd*b1**2*f*k1**2*r*s - 84*Dd*b1**2*f*k1**2*r + 336*Dd*b1**2*f*k1**2*s**2 - 210*Dd*b1**2*f*k1**2*s + 420*Dd*b1**2*f*k2**2*r**2 + 840*Dd*b1**2*f*k2**2*r*s - 525*Dd*b1**2*f*k2**2*r + 420*Dd*b1**2*f*k2**2*s**2 - 210*Dd*b1**2*f*k2**2*s - 336*Dd*b1*b2*f*k1**2*r**2 - 672*Dd*b1*b2*f*k1**2*r*s + 252*Dd*b1*b2*f*k1**2*r - 336*Dd*b1*b2*f*k1**2*s**2 + 252*Dd*b1*b2*f*k1**2*s - 840*Dd*b1*b2*f*k2**2*r**2 - 1680*Dd*b1*b2*f*k2**2*r*s + 630*Dd*b1*b2*f*k2**2*r - 840*Dd*b1*b2*f*k2**2*s**2 + 630*Dd*b1*b2*f*k2**2*s + 360*Dd*b1*f**3*k1**2*r*s - 270*Dd*b1*f**3*k1**2*r + 360*Dd*b1*f**3*k1**2*s**2 - 513*Dd*b1*f**3*k1**2*s + 189*Dd*b1*f**3*k1**2 + 540*Dd*b1*f**3*k2**2*r**2 + 1152*Dd*b1*f**3*k2**2*r*s - 981*Dd*b1*f**3*k2**2*r + 612*Dd*b1*f**3*k2**2*s**2 - 837*Dd*b1*f**3*k2**2*s + 333*Dd*b1*f**3*k2**2 + 624*Dd*b1*f**2*k1**2*r*s - 240*Dd*b1*f**2*k1**2*r + 624*Dd*b1*f**2*k1**2*s**2 - 756*Dd*b1*f**2*k1**2*s + 204*Dd*b1*f**2*k1**2 + 252*Dd*b1*f**2*k2**2*r**2 + 504*Dd*b1*f**2*k2**2*r*s - 315*Dd*b1*f**2*k2**2*r + 252*Dd*b1*f**2*k2**2*s**2 - 126*Dd*b1*f**2*k2**2*s + 4704*Dd*b1*f*g2*k1**2*r**2 + 9408*Dd*b1*f*g2*k1**2*r*s - 2856*Dd*b1*f*g2*k1**2*r + 4704*Dd*b1*f*g2*k1**2*s**2 - 2856*Dd*b1*f*g2*k1**2*s - 504*Dd*b1*f*g2*k1**2 + 6720*Dd*b1*f*g2*k2**2*r**2 + 11760*Dd*b1*f*g2*k2**2*r*s - 5040*Dd*b1*f*g2*k2**2*r + 5040*Dd*b1*f*g2*k2**2*s**2 - 3780*Dd*b1*f*g2*k2**2*s - 288*Dd*b2*f**2*k1**2*r**2 - 576*Dd*b2*f**2*k1**2*r*s + 360*Dd*b2*f**2*k1**2*r - 288*Dd*b2*f**2*k1**2*s**2 + 360*Dd*b2*f**2*k1**2*s - 108*Dd*b2*f**2*k1**2 - 504*Dd*b2*f**2*k2**2*r**2 - 1008*Dd*b2*f**2*k2**2*r*s + 378*Dd*b2*f**2*k2**2*r - 504*Dd*b2*f**2*k2**2*s**2 + 378*Dd*b2*f**2*k2**2*s - 160*Dd*f**4*k2**2*r*s + 80*Dd*f**4*k2**2*r - 160*Dd*f**4*k2**2*s**2 + 240*Dd*f**4*k2**2*s - 80*Dd*f**4*k2**2 + 216*Dd*f**3*k1**2*r*s - 108*Dd*f**3*k1**2*r + 216*Dd*f**3*k1**2*s**2 - 324*Dd*f**3*k1**2*s + 108*Dd*f**3*k1**2 + 4608*Dd*f**2*g2*k1**2*r**2 + 8352*Dd*f**2*g2*k1**2*r*s - 5544*Dd*f**2*g2*k1**2*r + 3744*Dd*f**2*g2*k1**2*s**2 - 5172*Dd*f**2*g2*k1**2*s + 1704*Dd*f**2*g2*k1**2 + 4032*Dd*f**2*g2*k2**2*r**2 + 6720*Dd*f**2*g2*k2**2*r*s - 2856*Dd*f**2*g2*k2**2*r + 2688*Dd*f**2*g2*k2**2*s**2 - 2100*Dd*f**2*g2*k2**2*s)/(315*d**2*k3**6) - 8*D1**3*Pk1*Pk3*k1**2*st**2*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(k1**4*(2*C - 1)*(r + s + 3) - k1**2*k2**2*(-14*C*(4*r + 4*s - 3) + 8*K*r + 8*K*s + 3*K + 3*b1*(r + s + 3) + 28*r + 28*s - 21) + 7*k2**4*(K*(r + s) - 3*b1*(5*r + 5*s - 3))) + k2**2*(-k1**2 + 5*k2**2)*(r + s)*(84*K*b1 - 84*g2)) + 33*b1**2*k2**2*(D1*fd*(14*K*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(14*K*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*(fd*(2*r + 2*s - 1)*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 84*g2*k2**2*(k1**2 - 5*k2**2)*(r + s))) - f*(D1*(5*f**2*fd*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 6*gd2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9)) + f*k1**2*(44*C - 22)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(1155*d**2*k3**8) + 8*D1**3*Pk1*Pk3*k2**2*st**4*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(14*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(5*r + 5*s - 6) - k1**2*k2**2*(b1*(19*r + 19*s - 13) + (14*C - K - 7)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*g2)) - 33*b1**2*k2**2*(D1*fd*(14*K*k1**2*(r + s)**2 - f*(k1**2*(19*r + 19*s - 13) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-14*K*k1**2*(r + s) + f*k1**2*(19*r + 19*s - 13) - 14*f*k2**2*(2*r + 2*s - 1))) + 33*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*k1**2*(fd*(k1**2*(2*C - 1)*(5*r + 5*s - 6) - k2**2*(14*C - K - 7)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*k1**4*(4*C - 2)*(5*r + 5*s - 6) + 2*f*k1**2*k2**2*(14*C - K - 7)*(2*r + 2*s - 1) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-103*r - 103*s + 69) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 66*f*k1**2*(fd*(2*C - 1)*(k1**2 - k2**2)*(3*r + 3*s - 2) - 2*gd2*k2**2*(r + s - 1))*(2*r + 2*s - 1) + 132*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(103*r + 103*s - 69) - 11*k2**2*(17*r + 17*s - 11)) + f*k1**2*(132*C - 66)*(k1**2 - k2**2)*(2*r + 2*s - 1) - 132*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k3**8) + 8*D1**3*Pk1*Pk3*st**4*(-11*D1*bd1*f*(f**2*k2**4*(48*r**2 + r*(102*s - 91) + 54*s**2 - 125*s + 47) + 3*f*(k1**4*(4*C - 2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(-4*C*(6*r**2 + 7*r*(4*s - 3) + 22*s**2 - 26*s + 15) + 17*r**2 + r*(66*s - 53) + 49*s**2 - 56*s + 36) - k2**4*(-28*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + 12*K*r**2 + 16*K*r*s - 14*K*r + 4*K*s**2 - 8*K*s + 4*K + b1*(22*r**2 + r*(58*s - 47) + 36*s**2 - 61*s + 25) + 108*r**2 + 136*r*s - 143*r + 28*s**2 - 83*s + 34)) - 21*k2**2*(2*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(2 - 4*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(K*s*(4*s - 6) + r**2*(12*K - 4) + r*(2*K*(8*s - 5) - 4*s + 3) + s)) + 2*k2**2*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(3*r**2 + r*(4*s - 3) + s*(s - 2))))) + 462*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**2*(14 - 28*C)*(r + s - 1)**2 + k2**2*(f*(22*r**2 + r*(58*s - 34) + 36*s**2 - 41*s + 11) + (14*r + 14*s)*(K*s + r*(3*K - 1)))) + Dd*f*(k1**2*(14 - 28*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(56*K*s*(s - 1) + f*(44*r**2 + 116*r*s - 81*r + 72*s**2 - 102*s + 36) + 7*r**2*(24*K - 8) + 14*r*(K*(16*s - 7) - 4*s + 2) + 7*s))) - 11*b1*(3*D1*(f**2*fd*k2**4*(48*r**2 + r*(102*s - 61) + 54*s**2 - 86*s + 32) + f*(fd*(k1**4*(4*C - 2)*(2*s - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(-4*C*(12*r**2 + r*(56*s - 45) + 44*s**2 - 54*s + 15) + 34*r**2 + 6*r*(22*s - 19) + 98*s**2 - 125*s + 36) + 2*k2**4*(2*r + 2*s - 1)*(14*C*(6*r + 2*s - 1) + K*(-6*r - 2*s + 3) - 54*r - 14*s + 6)) - 14*k2**4*(bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(3*r**2 + r*(4*s - 2) + s*(s - 1)))) - 14*fd*k2**4*(r + s)*(b2*(r + s) - 2*g2*(3*r + s))) + Dd*f*(f**2*k2**4*(192*r**2 + r*(408*s - 274) + 216*s**2 - 383*s + 143) + 3*f*(k1**4*(20*C - 10)*(2*s - 1)*(2*r + 2*s - 3) + k1**2*k2**2*(-4*C*(24*r**2 + 4*r*(28*s - 25) + 88*s**2 - 119*s + 47) + 68*r**2 + 264*r*s - 253*r + 196*s**2 - 270*s + 112) + k2**4*(56*C*(12*r**2 + r*(16*s - 11) + 4*s**2 - 6*s + 2) - 2*K*(24*r**2 + 32*r*s - 26*r + 8*s**2 - 16*s + 7) - 432*r**2 - 544*r*s + 376*r - 112*s**2 + 176*s - 59)) - 42*k2**4*(b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 2*g2*(12*r**2 + r*(16*s - 7) + s*(4*s - 4))))) + f*(D1*(f**2*fd*k2**4*(-804*r**2 + r*(793 - 716*s) + 88*s**2 + 113*s - 137) - 33*f*(fd*(k1**4*(4*C - 2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2**2*(-4*C*(9*r**2 + 10*r*(3*s - 1) + 21*s**2 - 22*s + 4) + 27*r**2 + r*(72*s - 34) + 45*s**2 - 53*s + 13) + k2**4*(4*C*(18*r**2 + 8*r*(3*s - 2) + 6*s**2 - 9*s + 3) - 48*r**2 + r*(41 - 60*s) - 12*s**2 + 20*s - 7)) - 2*k2**4*(bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*gd2*(6*r**2 + r*(8*s - 7) + 2*(s - 1)**2))) + 66*fd*k2**4*(b2*(2*r + 2*s - 1) - 2*g2*(6*r + 2*s - 3))*(2*r + 2*s - 1)) + Dd*f*(f**2*k2**4*(-804*r**2 + r*(793 - 716*s) + 88*s**2 + 113*s - 137) - 33*f*(k1**4*(4*C - 2)*(3*s - 1)*(4*r + 4*s - 3) + k1**2*k2**2*(-4*C*(12*r**2 + r*(40*s - 17) + 28*s**2 - 33*s + 8) + 36*r**2 + r*(96*s - 55) + 60*s**2 - 79*s + 24) + k2**4*(8*C*(12*r**2 + r*(16*s - 11) + 4*s**2 - 6*s + 2) - 64*r**2 + r*(56 - 80*s) - 16*s**2 + 26*s - 9)) + 66*k2**4*(b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*g2*(24*r**2 + r*(32*s - 26) + 8*s**2 - 16*s + 7)))))/(1155*d**2*k3**6) + 8*D1**3*Pk1*Pk3*st**2*(231*b1**3*k2**2*(k1**2 - 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(7*bd1*f*k2**2*(k1**2 - 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(14 - 28*C)*(r + s - 1)**2 + k1**2*k2**2*(140*C*(r + s - 1)**2 - 14*K*(3*r**2 + 7*r*s - 2*r + 4*s**2 - 2*s + 1) + f*(176*r**2 + r*(436*s - 203) + 260*s**2 - 245*s + 59) - 77*r**2 - 154*r*s + 140*r - 77*s**2 + 140*s - 70) + 7*k2**4*(f*(38*r**2 + r*(82*s - 47) + 44*s**2 - 49*s + 15) + (-10*r - 10*s)*(K*s + r*(3*K - 1))))) + Dd*f*(k1**4*(14 - 28*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*K*(12*r**2 + 28*r*s - 9*r + 16*s**2 - 18*s + 3) + 2*f*(176*r**2 + 4*r*(109*s - 61) + 260*s**2 - 307*s + 84) - 308*r**2 - 616*r*s + 581*r - 308*s**2 + 476*s - 210) + 7*k2**4*(-40*K*s*(s - 1) + f*(76*r**2 + r*(164*s - 107) + 88*s**2 - 111*s + 35) - 5*r**2*(24*K - 8) - 10*r*(K*(16*s - 7) - 4*s + 2) - 5*s))) + 11*b1*(3*D1*bd1*f*(k1**4*(14 - 28*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(140*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*K*(6*r**2 + 14*r*s - 5*r + 8*s**2 - 11*s + 1) + f*(176*r**2 + r*(436*s - 285) + 260*s**2 - 369*s + 109) - 154*r**2 - 308*r*s + 259*r - 154*s**2 + 189*s - 70) + 7*k2**4*(-5*K*s*(4*s - 6) + f*(38*r**2 + r*(82*s - 60) + 44*s**2 - 62*s + 20) - 5*r**2*(12*K - 4) - 5*r*(2*K*(8*s - 5) - 4*s + 3) - 5*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(93*r**2 + 2*r*(30*s - 53) - 33*s**2 - 46*s + 39) + 6*k2**2*(18*r**2 + 4*r*(3*s - 2) - 6*s**2 + 7*s - 1)) + f*(fd*(k1**4*(-4*C*(32*r**2 + r*(50*s + 19) + 18*s**2 + 54*s - 32) + 64*r**2 + r*(104*s + 43) + 40*s**2 + 118*s - 70) + 2*k1**2*k2**2*(-14*C*(28*r**2 + r*(52*s - 29) + 24*s**2 - 25*s + 6) + K*(18*r**2 + 36*r*s + 31*r + 18*s**2 + 10*s - 20) + 216*r**2 + 404*r*s - 223*r + 188*s**2 - 195*s + 47) - 7*k2**4*(4*K*s*(s - 1) + r**2*(12*K - 4) + 2*r*(K*(8*s - 3) - 2*s + 1) + s)) + 14*k2**2*(bd2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(3*r**2 + r*(7*s - 2) + 4*s**2 - 5*s + 1) + 5*k2**2*(3*r**2 + r*(4*s - 2) + s*(s - 1))))) + 14*fd*k2**2*(b2*(k1**2 - 5*k2**2)*(r + s)**2 + 2*g2*(k1**2*(3*r**2 + 7*r*s - 2*r + 4*s**2 - 2*s + 1) + 5*k2**2*(3*r**2 + 4*r*s + s**2)))) + Dd*f*(f**2*k2**2*(k1**2*(372*r**2 + r*(240*s - 419) - 132*s**2 - 161*s + 165) + 18*k2**2*(24*r**2 + 2*r*(8*s - 7) - 8*s**2 + 6*s - 1)) - 3*f*(k1**4*(4*C*(64*r**2 + 20*r*(5*s + 1) + 36*s**2 + 97*s - 79) - 128*r**2 - 2*r*(104*s + 25) - 80*s**2 - 213*s + 173) + k1**2*k2**2*(28*C*(56*r**2 + 2*r*(52*s - 37) + 48*s**2 - 62*s + 21) - 2*K*(36*r**2 + r*(72*s + 39) + 36*s**2 + 4*s - 32) - 864*r**2 - 1616*r*s + 1108*r - 752*s**2 + 940*s - 303) + 7*k2**4*(8*K*s*(s - 1) + r**2*(24*K - 8) + 2*r*(K*(16*s - 7) - 4*s + 2) + s)) + 42*k2**2*(b2*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(12*r**2 + r*(28*s - 9) + 16*s**2 - 18*s + 3) + 5*k2**2*(12*r**2 + r*(16*s - 7) + s*(4*s - 4)))))) - f*(-11*D1*bd1*(f**2*k2**2*(k1**2*(93*r**2 + r*(60*s - 101) - 33*s**2 - 23*s + 48) + 18*k2**2*(6*r**2 + r*(4*s - 6) - s*(2*s + 1))) - 3*f*(k1**4*(4*C*(16*r**2 + 25*r*s + 9*s**2 + 21*s - 16) - 32*r**2 - r*(52*s + 3) - 20*s**2 - 47*s + 35) + k1**2*k2**2*(56*C*(7*r**2 + r*(13*s - 11) + 6*s**2 - 9*s + 4) - 2*K*(9*r**2 + 18*r*s + 4*r + 9*s**2 - 3*s - 6) - 216*r**2 - 404*r*s + 317*r - 188*s**2 + 261*s - 108) + 7*k2**4*(2*K*s*(s - 1) + r**2*(6*K - 2) + r*(4*K - 1)*(2*s - 1))) + 42*k2**2*(b2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*g2*(k1**2*(3*r**2 + r*(7*s - 3) + 2*s*(2*s - 3)) + 5*k2**2*(3*r**2 + r*(4*s - 3) + s*(s - 2))))) + D1*(f**2*fd*k2**2*(k1**2*(1840*r**2 + 10*r*(492*s - 371) + 3080*s**2 - 4959*s + 1907) + 11*k2**2*(180*r**2 + r*(612*s - 401) + 432*s**2 - 549*s + 179)) + 11*f*(fd*k1**2*(k1**2*(4*C*(117*r**2 + 72*r*(2*s - 1) + 27*s**2 - 39*s + 5) - 234*r**2 - 306*r*s + 132*r - 72*s**2 + 69*s + 1) + 9*k2**2*(4*C*(45*r**2 + 78*r*s - 54*r + 33*s**2 - 43*s + 15) - 105*r**2 - 180*r*s + 123*r - 75*s**2 + 96*s - 33)) + 6*k2**2*(-bd2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1) + 2*gd2*(k1**2*(9*r**2 + 2*r*(9*s + 2) + 9*s**2 - 3*s - 6) - 7*k2**2*(3*r**2 + r*(4*s - 2) + s*(s - 1))))) + 66*fd*k2**2*(-b2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1) + 2*g2*(k1**2*(18*r**2 + 36*r*s + 31*r + 18*s**2 + 10*s - 20) - 7*k2**2*(6*r**2 + r*(8*s - 3) + s*(2*s - 2))))) + Dd*f*(f**2*k2**2*(k1**2*(1840*r**2 + 10*r*(492*s - 371) + 3080*s**2 - 4959*s + 1907) + 11*k2**2*(180*r**2 + r*(612*s - 401) + 432*s**2 - 549*s + 179)) + 11*f*k1**2*(k1**2*(4*C*(156*r**2 + 192*r*s - 99*r + 36*s**2 - 50*s + 7) - 312*r**2 - 408*r*s + 184*r - 96*s**2 + 91*s + 3) + 9*k2**2*(4*C*(60*r**2 + 104*r*s - 77*r + 44*s**2 - 61*s + 22) - 140*r**2 - 240*r*s + 177*r - 100*s**2 + 137*s - 49)) + 66*k2**2*(-b2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(4*r + 4*s - 3) + 2*g2*(k1**2*(36*r**2 + r*(72*s + 39) + 36*s**2 + 4*s - 32) - 7*k2**2*(12*r**2 + r*(16*s - 7) + s*(4*s - 4)))))))/(3465*d**2*k3**6) + D1**3*Pk1*Pk3*(140*b1**3*k2**2*(D1*fd*(2*k1**2*(s - 1) + k2**2*(r + 2*s - 2))*(r + s - 1) + Dd*f*(k1**2*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(4*r**2 + 3*r*(4*s - 3) + 8*s**2 - 13*s + 5))) + 7*b1**2*k2**2*(20*D1*bd1*f*(k1**2*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + 3*k2**2*(r**2 + r*(3*s - 2) + 2*s**2 - 3*s + 1)) - 2*D1*fd*(k1**2*(40*C*(s - 1)*(r + s - 1) - 70*K*r**2 - 159*K*r*s - 80*K*r - 98*K*s**2 - 56*K*s + 40*K + f*(57*r*s - 42*r + 60*s**2 - 56*s + 10) + 20*r + 4*s**2 + 48*s - 20) + 2*k2**2*(f*(r*(16*s - 9) + 16*s**2 - 17*s + 5) - 5*r**2*(4*K - 2) - 5*r*s*(7*K - 4) - 5*s**2*(2*K - 1))) - Dd*f*(k1**2*(160*C*(2*s - 1)*(r + s - 1) + 2*K*(-280*r**2 - 636*r*s + 74*r - 392*s**2 + 161*s + 96) + f*(12*r*(19*s - 14) + 240*s**2 - 275*s + 91) + 40*r + 32*s**2 + 156*s - 96) + 8*k2**2*(4*f*(2*s - 1)*(2*r + 2*s - 1) - 5*r**2*(8*K - 4) - 5*r*(14*K*s - 7*K - 8*s + 5) - 5*s*(4*K*s - 3*K - 2*s + 1)))) - b1*(D1*(f**2*k2**2*(7*bd1*(k1**2*(114*r*s - 84*r + 120*s**2 - 163*s + 71) + 4*k2**2*(16*r*s - 7*r + 16*s**2 - 15*s + 3)) + 3*fd*(k1**2*(5*r*(81*s - 53) + 288*s**2 - 373*s + 117) + 4*k2**2*(15*r**2 + r*(69*s - 44) + 54*s**2 - 65*s + 23))) - 2*f*(fd*(k1**4*(28*C - 14)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(1320*K*r**2 + 6*K*r*(349*s - 220) + 5*K*(172*s**2 - 229*s + 66) + 28*r*(C*(8*s - 4) - 18*s + 3) + s*(168 - 312*s)) + 28*k2**4*(r**2*(12*K - 6) + r*(17*K*s - 6*K - 11*s + 3) + s*(4*K*s - 3*K - 3*s))) + 7*k2**2*(bd1*(k1**2*(K*(140*r**2 + 2*r*(159*s - 56) + 196*s**2 - 147*s - 28) - 10*r*(8*C*s - 1) - 2*s**2*(40*C + 4) - 2*s*(5 - 40*C) + 4) + 10*k2**2*(r**2*(8*K - 4) + r*(K*(14*s - 9) - 8*s + 6) + s*(4*K*(s - 1) - 2*s + 1))) + 20*bd2*(2*k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(-70*r**2 + r*(42 - 159*s) - 98*s**2 + 70*s + 28) - 10*k2**2*(4*r**2 + r*(7*s - 5) + s*(2*s - 2))))) + 28*fd*k2**2*(-10*b2*(2*k1**2 + k2**2)*(r + s)**2 + g2*k1**2*(70*r**2 + r*(159*s + 80) + 98*s**2 + 56*s - 40) + 10*g2*k2**2*(4*r**2 + 7*r*s + 2*s**2))) + Dd*f*(3*f**2*k2**2*(k1**2*(20*r*(27*s - 20) + 384*s**2 - 577*s + 225) + 4*k2**2*(20*r**2 + r*(92*s - 61) + 72*s**2 - 89*s + 29)) - 2*f*(k1**4*(56*C - 28)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(K*(2640*r**2 + 12*r*(349*s - 254) + 1720*s**2 - 2637*s + 962) + 112*r*(4*C*s - 2*C - 9*s + 3) - 624*s**2 + 564*s - 84) + 28*k2**4*(r**2*(24*K - 12) + r*(34*K*s - 17*K - 22*s + 14) + s*(8*K*s - 7*K - 6*s + 3))) + 28*k2**2*(-10*b2*(2*k1**2 + k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(280*r**2 + r*(636*s - 74) + 392*s**2 - 161*s - 96) + 20*k2**2*(8*r**2 + 7*r*(2*s - 1) + s*(4*s - 3)))))) + f*(D1*(-3*f**2*k2**2*(3*bd1*k1**2*(s - 1)*(45*r + 32*s - 36) + 4*bd1*k2**2*(5*r**2 + 23*r*s - 17*r + 18*s**2 - 24*s + 6) - 40*fd*k1**2*(2*s**2 - 3*s + 1)) + 2*f*(bd1*(k1**4*s*(28*C - 14)*(s - 1) + k1**2*k2**2*(K*(660*r**2 + 3*r*(349*s - 288) + 430*s**2 - 746*s + 316) + 28*r*(4*C*s - 9*s + 3) - 156*s**2 + 198*s - 42) + 14*k2**4*(r**2*(12*K - 6) + r*(17*K*s - 11*K - 11*s + 11) + s*(4*K - 3)*(s - 1))) + 6*fd*k1**2*(3*s - 1)*(k1**2*(2*C - 1)*(s - 1) + 3*k2**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2)) + 2*k2**2*(2*bd2*(k1**2*(60*r**2 + 3*r*(34*s - 27) + 42*s**2 - 71*s + 29) + 7*k2**2*(3*r**2 + r*(5*s - 2) + s*(2*s - 2))) - gd2*(k1**2*(660*r**2 + 3*r*(349*s - 288) + 430*s**2 - 746*s + 316) + 14*k2**2*(12*r**2 + r*(17*s - 11) + s*(4*s - 4))))) + 4*k2**2*(2*b2*(35*bd1*(2*k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(120*r**2 + 12*r*(17*s - 10) + 84*s**2 - 109*s + 30) + 7*k2**2*(6*r**2 + r*(10*s - 3) + s*(4*s - 3)))) - g2*(7*bd1*k1**2*(70*r**2 + r*(159*s - 70) + 7*s*(14*s - 11)) + 70*bd1*k2**2*(4*r**2 + r*(7*s - 4) + s*(2*s - 2)) + fd*k1**2*(1320*r**2 + 6*r*(349*s - 220) + 860*s**2 - 1145*s + 330) + 28*fd*k2**2*(12*r**2 + r*(17*s - 6) + s*(4*s - 3))))) + 4*Dd*f*(30*f**2*k1**2*k2**2*(2*s**2 - 3*s + 1) + 6*f*k1**2*(2*s - 1)*(k1**2*(2*C - 1)*(s - 1) + 3*k2**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2)) + k2**2*(2*b2*(k1**2*(240*r**2 + 6*r*(68*s - 47) + 168*s**2 - 251*s + 88) + 7*k2**2*(12*r**2 + r*(20*s - 7) + s*(8*s - 7))) - g2*(k1**2*(2640*r**2 + 12*r*(349*s - 254) + 1720*s**2 - 2637*s + 962) + 28*k2**2*(24*r**2 + 17*r*(2*s - 1) + s*(8*s - 7)))))))/(105*d**2*k2**2*k3**4) + 4*D1**3*Pk1*Pk3*st**4*(D1*bd1*f**2*(k1**2*s*(8*C - 4)*(2*s - 1) + k2**2*(r*(4*s - 1) - s)) + 7*b1**2*(2*D1*fd*(s - 1)*(k1**2*(4*C - 2)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(16*C - 8)*(2*s**2 - 3*s + 1) + k2**2*(r*(8*s - 6) - s + 1))) + b1*f*(D1*(7*bd1*(k1**2*s*(16*C - 8)*(s - 1) + k2**2*(r*(4*s - 2) - s + 1)) + 2*fd*(2*s - 1)*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(2*r - 1))) + Dd*f*(2*s - 1)*(k1**2*(16*C - 8)*(2*s - 1) + k2**2*(8*r - 3))))/(35*d**2*k1**2*k2**2) + D1**3*Pk1*Pk3*st**2*(-4*D1*bd1*f**2*(k1**2*s*(28*C - 14)*(2*s - 1) + k2**2*(r**2*(22*C - 11) + r*(-18*C + 4*s + 8) - 8*s)) + 35*b1**3*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 7*b1**2*(-D1*(s - 1)*(5*bd1*f*k2**2*(1 - 3*r) + fd*k1**2*(80*C - 40)*(s - 1) + 3*fd*k2**2*(-2*f*r + f + 4*r)) + Dd*f*(k1**2*(80 - 160*C)*(2*s**2 - 3*s + 1) + k2**2*(3*f*(4*r - 1)*(s - 1) - 48*r*s + 16*r - 4*s + 4))) - 2*b1*f*(D1*(280*bd1*k1**2*s*(2*C - 1)*(s - 1) + 7*bd1*k2**2*(r*(-3*f*(s - 1) + 12*s + 4) + 2*s - 2) + fd*k1**2*(1 - 2*s)**2*(56*C - 28) + 2*fd*k2**2*(2*C*(22*r**2 - 29*r + 9) - 22*r**2 + 2*r*(4*s + 9) - 11*s)) + 2*Dd*f*(k1**2*(1 - 2*s)**2*(56*C - 28) + k2**2*(2*C*(44*r**2 - 47*r + 9) - 44*r**2 + 16*r*s + 25*r - 27*s + 8))))/(105*d**2*k1**2*k2**2) + D1**3*Pk1*Pk3*(-4*D1*bd1*f*(3*b2*k2**2*r*(r - 1) + f*s*(k1**2*(2*C - 1)*(s - 1) - 2*k2**2*r) - 6*g2*k2**2*r*(r - 1)) + 5*b1**3*k2**2*(3*D1*fd*r*(s - 1) + Dd*f*(4*r*(3*s - 2) - s + 1)) + b1**2*(-D1*(5*bd1*f*k2**2*(r*(5 - 9*s) + s - 1) + fd*(k1**2*(40*C - 20)*(s - 1)**2 + k2**2*(12*K*(r - 1)**2 + f*(-6*r*(3*s - 2) + 11*s - 7) - 28*r*s + 20*r + 8*s))) + Dd*f*(k1**2*(40 - 80*C)*(2*s**2 - 3*s + 1) + k2**2*(-12*K*(4*r**2 - 5*r + 1) + f*(12*r*(3*s - 2) - 19*s + 11) + 112*r*s - 48*r - 20*s + 8))) - 2*b1*(D1*(bd1*f**2*k2**2*(r*(6 - 9*s) + 4*s - 2) + 2*f*(10*bd1*k1**2*s*(2*C - 1)*(s - 1) + bd1*k2**2*(6*K*r**2 - 6*K*r - 14*r*s + r + 2*s - 1) + fd*(2*s - 1)*(k1**2*(2*C - 1)*(s - 1) - 2*k2**2*r) + k2**2*r*(3*bd2 - 6*gd2)*(r - 1)) + 6*fd*k2**2*(b2 - 2*g2)*(r - 1)**2) + 2*Dd*f*(2*f*(2*s - 1)*(k1**2*(2*C - 1)*(s - 1) - 2*k2**2*r) + k2**2*(3*b2 - 6*g2)*(4*r**2 - 5*r + 1))))/(15*d**2*k1**2*k2**2) - 2*D1**3*Pk1*Pk3*st**4*(-21*b1**2*(-2*D1*fd*(k1**4*(8*C - 4)*(s - 1)**2 - k1**2*k2**2*r*(8*C - 6)*(s - 1) + k2**4*r*(f*(2 - 3*s) + r*(2*C - 2))) + Dd*f*(k1**4*(16 - 32*C)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(8*C - 6)*(r*(8*s - 6) - s + 1) + k2**4*(4*r - 1)*(f*(3*s - 2) + r*(4 - 4*C)))) - 3*b1*f*(-7*D1*bd1*(k1**4*s*(32*C - 16)*(s - 1) - k1**2*k2**2*(8*C - 6)*(r*(4*s - 2) - s + 1) + k2**4*(2*r - 1)*(f*(2 - 3*s) + r*(4*C - 4))) + k2**2*(D1*fd*(2*k1**2*(2*C*(r*(23*s - 8) - 56*s**2 + 48*s - 10) + r*(8 - 23*s) + 58*s**2 - 53*s + 12) + k2**2*(-4*C*(1 - 2*r)**2 + 3*f*(3*r - 1)*(3*s - 2) + 48*r**2 - 40*r*s + 4*r + 4)) + Dd*f*(k1**2*(2*C*(4*r*(23*s - 8) - 224*s**2 + 221*s - 58) + r*(32 - 92*s) + 232*s**2 - 249*s + 70) + k2**2*(-4*C*(8*r**2 - 6*r + 1) + 3*f*(4*r - 1)*(3*s - 2) + 96*r**2 - 80*r*s - 4*s + 6)))) + f**2*(D1*(3*bd1*k2**2*(k1**2*(-2*C*(23*r*s + 10*r - 56*s**2 + 45*s - 14) + 23*r*s + 10*r - 58*s**2 + 55*s - 16) + k2**2*(r**2*(8*C - 24) + r*(-4*C - 9*f*s + 6*f + 20*s + 22) + 4*s - 2)) + fd*(k1**4*(1 - 3*s)**2*(8 - 16*C) + k1**2*k2**2*(2*C*(45*r*s - 6*r + 144*s**2 - 99*s + 14) - 81*r*s + 18*r - 162*s**2 + 141*s - 26) + 2*k2**4*(2*C*(27*r**2 - 24*r + 5) - 45*r**2 + 18*r*s + 6*r - 18*s + 7))) + Dd*f*(-k1**4*(32*C - 16)*(6*s**2 - 5*s + 1) + k1**2*k2**2*(2*C*(60*r*s + 8*r + 192*s**2 - 151*s + 18) - 108*r*s + 12*r - 216*s**2 + 209*s - 40) + 2*k2**4*(2*C*(36*r**2 - 29*r + 5) - 60*r**2 + 24*r*s - 3*r - 25*s + 14))))/(105*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*st**2*(-3*D1*b1*bd1*f*(f*(21*k1**2*k2**2*(s - 1) - 2*k2**4*(88*r**2 + 378*r*s - 177*r - 63*s + 42)) - 14*k1**4*s*(80*C - 40)*(s - 1) - 14*k1**2*k2**2*s*(-8*C*(10*r + s - 1) - 10*K*r + 5*K + 60*r + 8*s - 8) - 28*k2**4*(r**2*(20*C - 2*K - 10) + r*(-10*C + 2*K + 14*s + 3) - 6*s)) - 105*b1**3*k1**2*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*(D1*(-35*bd1*f*k1**2*k2**2*(3*r - 1)*(s - 1) + fd*(k1**4*(560*C - 280)*(s - 1)**2 - 7*k1**2*k2**2*(8*C*(s - 1)*(10*r + s - 1) + 10*K*r*s - 3*f*s + 3*f - 60*r*s + 60*r - 8*s**2 + 16*s - 8) + 2*k2**4*(-14*K*(r - 1)**2 + f*(88*r**2 + r*(378*s - 215) - 18) - 14*r**2*(5 - 10*C) - 14*r*(2 - 7*s) + 14))) + 2*Dd*f*(k1**4*(560*C - 280)*(2*s**2 - 3*s + 1) - 7*k1**2*k2**2*(8*C*(2*s - 1)*(10*r + s - 1) - 5*K*s + 20*r*(s*(K - 6) + 3) - 16*s**2 + 24*s - 8) + k2**4*(560*C*r**2 - 140*C*r - 56*K*r**2 + 70*K*r - 14*K + f*(176*r**2 + 28*r*(27*s - 14) - 63*s + 24) - 280*r**2 + 392*r*s - 14*r - 84*s + 14))) + 3*b1*k2**2*(D1*(-70*b2*fd*k1**2*r*s + 3*f**2*fd*(5*k1**2*(3*r - 1)*(s - 1) + 2*k2**2*(36*r**2 + 9*r*(9*s - 7) + 3*s + 2)) - 2*f*(35*bd2*k1**2*r*s + fd*k1**2*(4*C*(r*(281*s - 74) + 250*s**2 - 261*s + 47) - 21*K*s + 2*r*(21*K*s - 281*s + 74) - 580*s**2 + 522*s - 88) + 2*fd*k2**2*(K*(22*r**2 - 29*r + 9) - r**2*(28*C - 16) + 2*r*(7*C - 52*s + 13) - 4*s + 4) - 14*gd2*r*(5*k1**2*s + 2*k2**2*(r - 1))) + 28*fd*g2*(5*k1**2*r*s + 2*k2**2*(r - 1)**2)) + Dd*f*(3*f**2*(5*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(48*r**2 + 4*r*(27*s - 20) + 7*s)) - 2*f*(k1**2*(C*(8*r*(281*s - 109) + 2000*s**2 - 2262*s + 568) - 21*K*s + 4*r*(21*K*s - 281*s + 109) - 1160*s**2 + 1155*s - 256) + 2*k2**2*(K*(44*r**2 - 47*r + 9) + r**2*(32 - 56*C) + 2*r*(7*C - 104*s + 28) - 20*s + 20)) + (56*r - 14)*(-5*b2*k1**2*s + 10*g2*k1**2*s + 4*g2*k2**2*(r - 1)))) + f*(D1*(9*bd1*f**2*k2**2*(5*k1**2*r*(s - 1) + k2**2*(24*r**2 + r*(54*s - 34) + 8*s - 4)) - 2*f*fd*(k1**4*(1 - 3*s)**2*(72*C - 36) + k1**2*k2**2*(2*C*(396*r**2 + 1053*r*s - 714*r + 324*s**2 - 675*s + 266) - 396*r**2 - 1035*r*s + 636*r - 486*s**2 + 597*s - 198) + 72*k2**4*r*(1 - 3*s)) + 6*f*k2**2*(bd1*(k1**2*(-2*C*(r*(281*s - 58) + 250*s**2 - 211*s + 42) + r*(-21*K*s + 281*s - 58) + 290*s**2 - 209*s + 34) + 2*k2**2*(r**2*(14*C - 11*K - 8) + r*(9*K + 52*s + 6) + 8*s - 8)) - r*(bd2 - 2*gd2)*(21*k1**2*s + 2*k2**2*(11*r - 9))) - 6*k2**2*(b2*(35*bd1*k1**2*s*(r - 1) + fd*(2*r - 1)*(21*k1**2*s + 2*k2**2*(11*r - 9))) - 2*g2*(7*bd1*(r - 1)*(5*k1**2*s + 2*k2**2*r) + fd*(2*r - 1)*(21*k1**2*s + 2*k2**2*(11*r - 9))))) - 2*Dd*f*(f*(k1**4*(144*C - 72)*(6*s**2 - 5*s + 1) + k1**2*k2**2*(2*C*(528*r**2 + 4*r*(351*s - 272) + 432*s**2 - 945*s + 428) - 528*r**2 - 1380*r*s + 964*r - 648*s**2 + 869*s - 308) + 144*k2**4*r*(1 - 2*s)) + k2**2*(3*b2 - 6*g2)*(4*r - 1)*(21*k1**2*s + 2*k2**2*(11*r - 9)))))/(315*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*(-35*b1**3*k1**2*k2**2*(D1*fd*(s - 1)*(11*r + 12*s - 12) + Dd*f*(4*r*(11*s - 8) + 48*s**2 - 77*s + 29)) + 7*b1**2*(D1*(-5*bd1*f*k1**2*k2**2*(3*r*(11*s - 7) + 36*s**2 - 53*s + 17) + fd*(k1**4*(40*C - 20)*(s - 1)**2 + k1**2*k2**2*(-2*K*(r*(31*s + 60) + 26*s**2 + 24*s - 30) + f*(80*s**2 - 61*s + 13) + r*(80*C - 60)*(s - 1) + 8*s*(4*s + 3)) + 20*k2**4*r*s)) + 2*Dd*f*(k1**4*(40*C - 20)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(K*(-4*r*(31*s + 21) - 104*s**2 + 17*s + 54) + 8*f*(10*s**2 - 7*s + 1) + (8*s - 4)*(r*(20*C - 15) + 8*s + 3)) + 20*k2**4*r*(2*s - 1))) + b1*(7*D1*bd1*f*(k1**4*s*(80*C - 40)*(s - 1) + k1**2*k2**2*(-2*K*(2*r*(31*s + 6) + 52*s**2 - 27*s - 12) + f*(80*s**2 - 51*s + 3) + 64*s**2 - 2*s*(-80*C*r + 60*r + 10) - 12) + 20*k2**4*r*(2*s - 1)) + k2**2*(D1*(3*f**2*fd*k1**2*(15*r*(11*s - 7) + 252*s**2 - 341*s + 121) + 2*f*(-35*bd2*k1**2*(6*r**2 + r*(11*s - 6) + s*(6*s - 6)) + fd*(-K*k1**2*(360*r**2 + 6*r*(77*s - 60) + 140*s**2 - 273*s + 90) + 8*k1**2*(r*(28*C*s - 14*C + 4*s + 7) + 3*s*(7*s - 3)) + 56*k2**2*r*s) + 14*gd2*k1**2*(31*r*s + 12*r + 26*s**2 - 14*s - 12)) + 14*fd*k1**2*(-5*b2*(6*r**2 + 11*r*s + 6*s**2) + 2*g2*(r*(31*s + 60) + 26*s**2 + 24*s - 30))) + Dd*f*(3*f**2*k1**2*(20*r*(11*s - 8) + 336*s**2 - 465*s + 161) - 2*f*(k1**2*(K*(720*r**2 + 132*r*(7*s - 6) + 280*s**2 - 581*s + 258) - 8*r*(56*C*s - 28*C + 8*s + 5) - 336*s**2 + 276*s - 36) + 56*k2**2*r*(1 - 2*s)) + 14*k1**2*(-5*b2*(24*r**2 + 2*r*(22*s - 9) + s*(24*s - 17)) + 2*g2*(4*r*(31*s + 21) + 104*s**2 - 17*s - 54))))) + f*(D1*(3*bd1*f**2*k1**2*k2**2*(s - 1)*(55*r + 84*s - 40) - 2*f*(6*fd*k1**2*(3*s - 1)*(k1**2*(2*C - 1)*(s - 1) - 3*k2**2*r) + k2**2*(bd1*(k1**2*(K*(180*r**2 + 3*r*(77*s - 72) + 70*s**2 - 154*s + 84) - 4*r*(28*C*s + 4*s - 9) - 84*s**2 + 102*s - 18) - 28*k2**2*r*(s - 1)) + k1**2*(bd2 - 2*gd2)*(180*r**2 + 3*r*(77*s - 72) + 70*s**2 - 154*s + 84))) - 2*k1**2*k2**2*(b2*(35*bd1*(6*r**2 + r*(11*s - 6) + s*(6*s - 5)) + fd*(360*r**2 + 6*r*(77*s - 60) + 140*s**2 - 273*s + 90)) - 2*g2*(7*bd1*s*(31*r + 26*s - 13) + fd*(360*r**2 + 6*r*(77*s - 60) + 140*s**2 - 273*s + 90)))) - 2*Dd*f*k1**2*(12*f*(2*s - 1)*(k1**2*(2*C - 1)*(s - 1) - 3*k2**2*r) + k2**2*(b2 - 2*g2)*(720*r**2 + 132*r*(7*s - 6) + 280*s**2 - 581*s + 258))))/(105*d**2*k1**2*k2**2*k3**2) - D1**3*Pk1*Pk3*st**4*(33*b1**2*k2**2*(2*D1*fd*(k1**4*(112*C - 56)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*r*(16*C*(r + s - 1) + f*(5 - 9*s) - 12*r - 12*s + 12) + 2*k2**4*r*(8*f*(4*r + 4*s - 3) + r*(7*K - 21) - 14*s)) + Dd*f*(k1**4*(112*C - 56)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) - 7*k1**2*k2**2*(16*C*(8*r**2 + 8*r*(s - 1) - s + 1) - f*(4*r - 1)*(9*s - 5) - 96*r**2 - 96*r*(s - 1) + 12*s - 12) + 4*k2**4*(2*f*(8*r - 1)*(4*r + 4*s - 3) + 7*r**2*(4*K - 12) - 7*r*(K + 8*s - 5) + 7*s))) + 11*b1*(3*D1*(f**2*k2**4*(7*bd1*k1**2*(2*r - 1)*(9*s - 5) + 8*bd1*k2**2*(4*r - 1)*(4*r + 4*s - 3) + 3*fd*k1**2*(6*r - 9*s + 5) + fd*k2**2*(-24*r**2 + r*(93 - 177*s) + 8*s - 4)) + 4*f*(fd*(k1**6*(1 - 2*s)**2*(8*C - 4) + k1**4*k2**2*(-2*C*(r*(17*s - 12) + 64*s**2 - 84*s + 26) + r*(25*s - 16) + 66*s**2 - 93*s + 30) + k1**2*k2**4*(-2*C*(68*r**2 + r*(26 - 70*s) - 60*s**2 + 52*s - 7) + 76*r**2 + r*(60 - 112*s) - 74*s**2 + 69*s - 10) + k2**6*(K*(1 - 2*r)**2 + r**2*(100 - 56*C) + 16*r*(3*s - 1) + 4*s - 3)) + 7*k2**2*(bd1*(k1**4*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - k1**2*k2**2*(4*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + k2**4*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) - 2*gd2*k2**4*r**2)) - 56*fd*g2*k2**6*r**2) + Dd*f*(f**2*k2**4*(18*k1**2*(4*r - 1) + k2**2*(-96*r**2 + r*(408 - 708*s) + 115*s - 65)) + 6*f*(k1**6*(1 - 2*s)**2*(32*C - 16) + k1**4*k2**2*(-2*C*(r*(68*s - 48) + 256*s**2 - 413*s + 146) + 4*r*(25*s - 16) + 264*s**2 - 453*s + 164) + 2*k1**2*k2**4*(C*(-272*r**2 + 4*r*(70*s - 17) + 240*s**2 - 210*s + 44) + 152*r**2 + r*(106 - 224*s) - 148*s**2 + 136*s - 39) + 2*k2**6*(K*(8*r**2 - 6*r + 1) - r**2*(112*C - 200) + r*(28*C + 96*s - 90) - 8*s + 2)) + 168*g2*k2**6*r*(1 - 4*r))) + f*(D1*(f**2*k2**4*(99*bd1*k1**2*(2*r + 9*s - 7) - 11*bd1*k2**2*(24*r**2 + 3*r*(59*s - 43) - 91*s + 53) - 55*fd*k1**2*(4*r - 1)*(9*s - 7) + fd*k2**2*(-2208*r**2 - 4*r*(825*s - 518) - 605*s + 335)) + 22*f*(3*bd1*(k1**6*s*(16*C - 8)*(2*s - 1) + k1**4*k2**2*(-2*C*(17*r*(s - 2) + 64*s**2 - 125*s + 38) + 25*r*s - 36*r + 66*s**2 - 137*s + 40) - 2*k1**2*k2**4*(C*(68*r**2 - 10*r*(7*s + 6) - 60*s**2 + 20*s - 4) - 38*r**2 + 56*r*s + 25*r + 37*s**2 - 11*s + 10) + 2*k2**6*(r**2*(-28*C + 2*K + 50) + r*(28*C - K + 24*s - 58) - 13*s + 6)) + fd*(k1**6*(1 - 3*s)**2*(16*C - 8) - 3*k1**4*k2**2*(2*C*(87*r*s - 26*r + 96*s**2 - 89*s + 18) - 99*r*s + 30*r - 102*s**2 + 103*s - 22) - 6*k1**2*k2**4*(C*(84*r**2 - 42*r*s - 52*r - 48*s**2 + 60*s - 2) - 33*r**2 + 42*r*s + 27*s**2 - 45*s + 11) + 6*k2**6*(-r**2*(12*C - 24) + r*(4*C + 12*s - 13) - 2*s + 1)) + 12*gd2*k2**6*r*(1 - 2*r)) - 264*g2*k2**6*(7*bd1*r*(r - 1) + fd*(1 - 2*r)**2)) + Dd*f*(f**2*k2**4*(-55*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(-2208*r**2 - 4*r*(825*s - 518) - 605*s + 335)) + 22*f*(k1**6*(32*C - 16)*(6*s**2 - 5*s + 1) + k1**4*k2**2*(-2*C*(4*r*(87*s - 22) + 384*s**2 - 383*s + 74) + 36*r*(11*s - 3) + 408*s**2 - 441*s + 96) + 2*k1**2*k2**4*(C*(-336*r**2 + 28*r*(6*s + 5) + 192*s**2 - 278*s + 56) + 132*r**2 + 3*r*(17 - 56*s) - 108*s**2 + 204*s - 75) + 6*k2**6*(-r**2*(16*C - 32) + 4*r*(C + 4*s - 4) - 2*s + 1)) - 264*g2*k2**6*(8*r**2 - 6*r + 1))))/(1155*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*Pk3*st**2*(4620*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + 2*s - 2) + 33*b1**2*k2**2*(2*D1*(70*bd1*f*k1**2*k2**2*(3*r**2 + r*(9*s - 8) + 6*s**2 - 10*s + 4) + fd*(7*k1**4*(8*C*(2*r**2 + 9*r*(s - 1) + 7*(s - 1)**2) - 8*r**2 + r*(-3*f*(s - 1) + s*(5*K - 40) + 40) - 32*(s - 1)**2) + k1**2*k2**2*(14*K*(23*r**2 + r*(35*s - 8) + 9*s**2 - 4*s + 4) - f*(612*r**2 + 41*r*(39*s - 20) + 1176*s**2 - 1346*s + 380) + 14*r**2*(25 - 40*C) + 14*r*(-40*C*(s - 1) + 24*s - 26) + 28*s**2 + 28*s - 28) + 70*k2**4*r*(r*(K - 3) - 2*s))) + Dd*f*(7*k1**4*(64*C*(2*r**2 + r*(9*s - 6) + 7*s**2 - 11*s + 4) - 10*K*s - 3*f*(4*r - 1)*(s - 1) - 64*r**2 + 8*r*(s*(5*K - 40) + 27) - 256*s**2 + 404*s - 148) + k1**2*k2**2*(-560*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 28*K*(92*r**2 + 140*r*s - 59*r + 36*s**2 - 51*s + 8) - f*(2448*r**2 + 4*r*(1599*s - 989) + 4704*s**2 - 6001*s + 1861) + 2800*r**2 + 2688*r*s - 3388*r + 224*s**2 - 56*s + 308) + 140*k2**4*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s))) - 11*b1*(3*D1*(f**2*k1**2*k2**2*(21*bd1*k1**2*(2*r - 1)*(s - 1) + 3*bd1*k2**2*(408*r**2 + 2*r*(533*s - 386) + 784*s**2 - 1103*s + 367) + 15*fd*k1**2*(3*r - 1)*(s - 1) + fd*k2**2*(1044*r**2 + r*(732*s - 940) - 792*s**2 + 515*s + 37)) - 2*f*(fd*(k1**6*(1 - 2*s)**2*(56*C - 28) + k1**4*k2**2*(4*C*(126*r**2 + r*(433*s - 87) + 414*s**2 - 207*s - 14) - 21*K*s - 252*r**2 + 2*r*(21*K*s - 433*s + 66) - 916*s**2 + 372*s + 64) + 2*k1**2*k2**4*(14*C*(18*r**2 + r*(58*s - 25) + 24*s**2 - 22*s + 4) + K*(130*r**2 + 3*r*(34*s - 55) + 2*s**2 - 23*s + 50) - 188*r**2 - 602*r*s + 230*r - 210*s**2 + 189*s - 26) + 14*k2**6*(r**2*(2*K - 6) - r*(K + 4*s - 3) + s)) + 7*k2**2*(bd1*(k1**4*(16*C*(2*r**2 + r*(9*s - 3) + 7*s**2 - 8*s + 1) - 5*K*s - 16*r**2 + 2*r*(s*(5*K - 40) + 14) - 64*s**2 + 74*s - 10) - 2*k1**2*k2**2*(20*C*(4*r**2 + 4*r*(s - 1) - s + 1) - K*(46*r**2 + 70*r*s - 37*r + 18*s**2 - 36*s + 2) - 50*r**2 - 48*r*s + 60*r - 4*s**2 + 3*s - 14) + 10*k2**4*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) + 20*bd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(5*k1**4*r*s + 2*k1**2*k2**2*(23*r**2 + 7*r*(5*s - 2) + 9*s**2 - 11*s + 2) + 10*k2**4*r**2))) + 28*fd*k2**2*(-10*b2*k1**2*k2**2*(r + s)**2 + g2*(5*k1**4*r*s + 2*k1**2*k2**2*(23*r**2 + 35*r*s - 8*r + 9*s**2 - 4*s + 4) + 10*k2**4*r**2))) + Dd*f*(f**2*k1**2*k2**2*(45*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(2088*r**2 + 122*r*(12*s - 17) - 1584*s**2 + 860*s + 171)) - 6*f*(k1**6*(1 - 2*s)**2*(112*C - 56) + k1**4*k2**2*(2*C*(504*r**2 + 2*r*(866*s - 293) + 1656*s**2 - 979*s - 26) - 21*K*s - 504*r**2 + 2*r*(42*K*s - 866*s + 251) - 1832*s**2 + 913*s + 124) + 2*k1**2*k2**4*(14*C*(36*r**2 + r*(116*s - 67) + 48*s**2 - 52*s + 14) + K*(260*r**2 + 204*r*s - 281*r + 4*s**2 - 5*s + 30) - 376*r**2 - 1204*r*s + 590*r - 420*s**2 + 413*s - 75) + 14*k2**6*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s)) + 84*k2**2*(-10*b2*k1**2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(5*k1**4*s*(4*r - 1) + 2*k1**2*k2**2*(92*r**2 + 140*r*s - 59*r + 36*s**2 - 51*s + 8) + 10*k2**4*r*(4*r - 1))))) + f*(D1*(f**2*k1**2*k2**2*(-11*bd1*(45*k1**2*r*(s - 1) + k2**2*(1044*r**2 + 732*r*s - 1328*r - 792*s**2 + 175*s + 231)) + fd*k2**2*(7440*r**2 + 20*r*(1683*s - 1187) + 28512*s**2 - 38313*s + 13291)) + 22*f*(3*bd1*(k1**6*s*(56*C - 28)*(2*s - 1) + k1**4*k2**2*(C*(252*r**2 + r*(866*s - 248) + 828*s**2 - 270*s - 28) - 126*r**2 + r*(21*K*s - 433*s + 110) - 458*s**2 + 109*s + 34) + 2*k1**2*k2**4*(14*C*(9*r**2 + 29*r*s - 15*r + 12*s**2 - 12*s + 4) + K*(65*r**2 + 51*r*s - 58*r + s**2 + 9*s - 10) - 94*r**2 - 301*r*s + 117*r - 105*s**2 + 84*s - 14) + 14*k2**6*r*(r*(K - 3) - 2*s + 1)) + 12*bd2*k1**2*k2**4*(15*r**2 + r*(15*s - 22) - 2*s + 2) + fd*k1**6*(1 - 3*s)**2*(72*C - 36) + fd*k1**4*k2**2*(2*C*(1116*r**2 + 3*r*(591*s - 406) + 666*s**2 - 1107*s + 380) - 1116*r**2 - 21*r*(87*s - 52) - 882*s**2 + 1017*s - 278) + 18*fd*k1**2*k2**4*(2*C*(39*r**2 + r*(75*s - 44) + 24*s**2 - 26*s + 8) - 66*r**2 + r*(70 - 120*s) - 33*s**2 + 36*s - 11) - 6*gd2*k2**2*(21*k1**4*r*s + 2*k1**2*k2**2*(65*r**2 + r*(51*s - 58) + s**2 + 9*s - 10) + 14*k2**4*r**2)) - 132*k2**2*(-2*b2*k1**2*k2**2*(35*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(30*r**2 + r*(30*s - 37) - 8*s + 11)) + g2*(7*bd1*(5*k1**4*s*(r - 1) + 2*k1**2*k2**2*(23*r**2 + r*(35*s - 23) + s*(9*s - 25)) + 10*k2**4*r*(r - 1)) + fd*(21*k1**4*s*(2*r - 1) + 2*k1**2*k2**2*(130*r**2 + 3*r*(34*s - 55) + 2*s**2 - 23*s + 50) + 14*k2**4*r*(2*r - 1))))) + Dd*f*(f**2*k1**2*k2**4*(7440*r**2 + 20*r*(1683*s - 1187) + 28512*s**2 - 38313*s + 13291) + 22*f*k1**2*(k1**4*(144*C - 72)*(6*s**2 - 5*s + 1) + k1**2*k2**2*(2*C*(1488*r**2 + 4*r*(591*s - 440) + 888*s**2 - 1557*s + 608) - 1488*r**2 - 2436*r*s + 1580*r - 1176*s**2 + 1473*s - 440) + 18*k2**4*(2*C*(52*r**2 + 100*r*s - 67*r + 32*s**2 - 38*s + 12) - 88*r**2 - 160*r*s + 108*r - 44*s**2 + 53*s - 17)) - 132*k2**2*(-6*b2*k1**2*k2**2*(20*r**2 + r*(20*s - 27) - 4*s + 5) + g2*(21*k1**4*s*(4*r - 1) + 2*k1**2*k2**2*(260*r**2 + 204*r*s - 281*r + 4*s**2 - 5*s + 30) + 14*k2**4*r*(4*r - 1))))))/(3465*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*Pkd3*ct**8*f*k2**6*(4*C - 4)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(12*r + 12*s - 5))/(7*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**8*f*k2**4*(8*C - 8)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(72*r*s - 33*r + 72*s**2 - 72*s + 19) + Dd*f*(96*r*s - 52*r + 96*s**2 - 108*s + 31)))/(63*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**7*f*k2**5*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*k1**2*(2*r + 2*s - 1)*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(21*f*k2**2*(52*r**2 + r*(104*s - 67) + 52*s**2 - 67*s + 21) + 22*k1**2*(3*r + 3*s - 2)*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37)) + Dd*f*(21*f*k2**2*(13*r + 13*s - 7) + 22*k1**2*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37))*(4*r + 4*s - 3)))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**7*f*k2**3*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(72*r*s - 33*r + 72*s**2 - 72*s + 19) + Dd*f*(96*r*s - 52*r + 96*s**2 - 108*s + 31)))/(63*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**7*f*k2**3*(9*D1*bd1*f*(2*k1**2*(2*C*(72*r*s - 25*r + 72*s**2 - 86*s + 25) - 124*r*s + 45*r - 124*s**2 + 152*s - 45) - k2**2*(r + s - 1)*(r*(56*C - 106) - 50*s + 25)) + 9*b1*(D1*fd*(4*k1**2*(C*(144*r*s - 79*r + 144*s**2 - 158*s + 43) - 124*r*s + 69*r - 124*s**2 + 138*s - 38) - k2**2*(2*r + 2*s - 1)*(r*(56*C - 106) - 50*s + 25)) + Dd*f*(2*k1**2*(C*(576*r*s - 316*r + 576*s**2 - 718*s + 222) - 496*r*s + 276*r - 496*s**2 + 628*s - 197) - k2**2*(4*r + 4*s - 3)*(r*(56*C - 106) - 50*s + 25))) + f*(D1*fd*(10*k1**2*(4*C*(126*r*s - 69*r + 126*s**2 - 144*s + 43) - 432*r*s + 243*r - 432*s**2 + 504*s - 153) - k2**2*(3*r + 3*s - 2)*(8*C*(39*r + 17) - 612*r - 300*s - 11)) + Dd*f*(10*k1**2*(C*(r*(672*s - 412) + 672*s**2 - 846*s + 274) - 72*r*(8*s - 5) - 576*s**2 + 738*s - 243) + k2**2*(-4*C*(312*r**2 + 24*r*(13*s - 4) + 137*s - 103) + 2448*r**2 + 8*r*(456*s - 223) + 1200*s**2 - 852*s - 37))))/(315*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**6*f*k2**6*st**2*(12*C - 12)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(9*r + 9*s - 4))/(7*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**6*f*k2**4*st**2*(8*C - 8)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) + Dd*f*(r*(72*s - 38) + 72*s**2 - 81*s + 23)))/(21*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**6*k2**4*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + 3*K*r + 3*K*s + 2*K - 10*b1*(2*r + 2*s - 1) + 25*r + 25*s - 16)) + k2**2*(r + s)*(252*K*b1 - 252*b1 - 252*g2)) - 198*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) + 18*f*(fd*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 252*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16)) - 252*g2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(428*r**2 + r*(856*s - 565) + 428*s**2 - 565*s + 183) + 22*f*(5*fd*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(3*r**2 + r*(6*s - 1) + 3*s**2 - s - 2)) - 396*fd*g2*k2**2*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(107*r + 107*s - 61) + 110*f*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(3*r + 3*s + 2))))/(385*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**6*k2**2*(-252*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) - 9*b1*f*(28*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*D1*fd*(k1**2*(2*C*(28*r*s - 7*r + 28*s**2 - 15*s - 3) - 80*r*s + 33*r - 80*s**2 + 68*s - 7) + 4*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(-2*k1**2*(2*C*(56*r*s - 14*r + 56*s**2 - 43*s + 4) - 160*r*s + 66*r - 160*s**2 + 175*s - 44) + k2**2*(-32*r**2 - 8*r*(4*s - 3) - 10*s + 5))) + f**2*(9*D1*bd1*(4*k1**2*(C*(14*s**2 + s*(14*r - 12) + 5) - 5*r*(4*s - 1) - 20*s**2 + 25*s - 10) + k2**2*(8*r**2 + r*(8*s - 3) + 10*s - 5)) + D1*fd*(10*k1**2*(2*C*(72*r*s - 33*r + 72*s**2 - 72*s + 19) - 180*r*s + 105*r - 180*s**2 + 216*s - 67) + 3*k2**2*(36*r**2 + r*(36*s + 39) + 78*s - 47)) + Dd*f*(10*k1**2*(2*C*(96*r*s - 52*r + 96*s**2 - 108*s + 31) - 240*r*s + 154*r - 240*s**2 + 315*s - 106) + 3*k2**2*(48*r**2 + 12*r*(4*s + 3) + 98*s - 67))))/(315*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**6*k2**2*(11*D1*bd1*f*(630*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(60*r**2 + r*(60*s - 101) - 75*s + 41) + 3*f*k1**2*(12*k1**2*(C*(r*(95*s - 50) + 95*s**2 - 144*s + 50) + r*(40 - 69*s) - 69*s**2 + 111*s - 40) + k2**2*(-2*C*(435*r**2 + r*(744*s - 556) + 309*s**2 - 360*s + 121) + 945*r**2 + 2*r*(849*s - 646) + 753*s**2 - 945*s + 347))) + 6930*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 11*b1*f*(3*D1*fd*(f*k2**4*r*(60*r + 60*s - 31) + 6*k1**4*(2*C*(190*r*s - 123*r + 190*s**2 - 239*s + 72) - 276*r*s + 187*r - 276*s**2 + 360*s - 111) + k1**2*k2**2*(-2*C*(870*r**2 + 1488*r*s - 668*r + 618*s**2 - 528*s + 87) + 1890*r**2 + 3396*r*s - 1651*r + 1506*s**2 - 1431*s + 294)) + Dd*f*(f*k2**4*(240*r**2 + 2*r*(120*s - 97) - 75*s + 41) + 18*k1**4*(4*C*(190*r*s - 123*r + 190*s**2 - 275*s + 97) - 552*r*s + 374*r - 552*s**2 + 831*s - 302) - 3*k1**2*k2**2*(C*(3480*r**2 + 5952*r*s - 3722*r + 2472*s**2 - 2658*s + 680) - 3780*r**2 - 6792*r*s + 4427*r - 3012*s**2 + 3513*s - 1025))) + f**2*(D1*fd*(5*f*k2**4*(496*r**2 + r*(496*s - 782) - 509*s + 357) + 110*k1**4*(14*C*(15*s - 11)*(3*r + 3*s - 2) - 450*r*s + 357*r - 450*s**2 + 666*s - 241) - 11*k1**2*k2**2*(2*C*(2394*r**2 + 9*r*(494*s - 149) + 2052*s**2 - 825*s - 266) - 5175*r**2 - 9954*r*s + 3609*r - 4779*s**2 + 2724*s + 101)) + Dd*f*(5*f*k2**4*(496*r**2 + r*(496*s - 782) - 509*s + 357) + 110*k1**4*(28*C*(30*r*s - 23*r + 30*s**2 - 45*s + 17) - 600*r*s + 490*r - 600*s**2 + 945*s - 370) - 11*k1**2*k2**2*(2*C*(3192*r**2 + 6*r*(988*s - 373) + 2736*s**2 - 1420*s - 355) - 6900*r**2 - 13272*r*s + 5799*r - 6372*s**2 + 4369*s + 49))))/(3465*d**2*k1**2*k3**5) + D1**3*Pk1*Pkd3*ct**5*f*k2**5*st**2*(33*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(r + s - 1) + 33*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(908*r**2 + r*(1816*s - 1197) + 908*s**2 - 1197*s + 387) + 22*k1**2*(3*r + 3*s - 2)*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368)) + Dd*f*(15*f*k2**2*(227*r + 227*s - 129) + 22*k1**2*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368))*(4*r + 4*s - 3)))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**5*f*k2**3*st**2*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) + Dd*f*(r*(72*s - 38) + 72*s**2 - 81*s + 23)))/(21*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**5*f*k2**3*st**2*(9*D1*bd1*f*(k1**2*(16*C*(46*r*s - 15*r + 46*s**2 - 53*s + 15) - 616*r*s + 210*r - 616*s**2 + 728*s - 210) + k2**2*(-4*C*(48*r**2 + 48*r*s - 53*r - 10*s + 5) + 342*r**2 + 492*r*s - 437*r + 150*s**2 - 265*s + 95)) + 9*b1*(D1*fd*(4*k1**2*(2*C*(184*r*s - 99*r + 184*s**2 - 198*s + 53) - 308*r*s + 168*r - 308*s**2 + 336*s - 91) - 3*k2**2*(2*r + 2*s - 1)*(r*(64*C - 114) - 50*s + 25)) + Dd*f*(2*k1**2*(4*C*(2*r*(184*s - 99) + 368*s**2 - 449*s + 136) - 112*r*(11*s - 6) - 1232*s**2 + 1526*s - 469) + k2**2*(-4*C*(192*r**2 + 48*r*(4*s - 3) - 10*s + 5) + 1368*r**2 + 6*r*(328*s - 221) + 600*s**2 - 790*s + 245))) + f*(D1*fd*(12*k1**2*(4*C*(3*r*(72*s - 35) + 216*s**2 - 231*s + 64) - 729*r*s + 360*r - 729*s**2 + 789*s - 221) + k2**2*(-8*C*(261*r**2 + 9*r*(29*s - 14) + 21*s - 23) + 4113*r**2 + 6138*r*s - 3258*r + 2025*s**2 - 2082*s + 416)) + Dd*f*(6*k1**2*(8*C*(32*r*(9*s - 5) + 288*s**2 - 342*s + 103) - 1944*r*s + 1090*r - 1944*s**2 + 2331*s - 709) + k2**2*(-4*C*(696*r**2 + 696*r*s - 372*r + 67*s - 71) + 5484*r**2 + 8184*r*s - 4713*r + 2700*s**2 - 2957*s + 616))))/(315*d**2*k1*k3**5) - D1**3*Pk1*Pkd3*ct**5*k2**3*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*r + 4*K*s + 12*K + b1*(-51*r - 51*s + 29) + 111*r + 111*s - 73)) + k1**2*k2**2*(r + s)*(-84*b1*(5 - 8*K) - 672*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (70 - 112*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (70 - 112*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(3*fd*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73))*(2*r + 2*s - 1) - 112*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 672*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73)) - 672*g2*k1**2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(k1**2*(-71*r - 71*s + 45) + 11*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(5*fd*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 72*gd2*k2**2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3)) + 1584*fd*g2*k1**2*k2**2*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(71*r + 71*s - 45) - 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 1584*g2*k1**2*k2**2*(r + s + 3))))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**5*k2*(D1*bd1*f**2*(r*(6*s - 5) + 2*s*(3*s - 4)) + 7*b1**2*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1*f*(7*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*fd*(12*s - 13)*(r + s - 1) + Dd*f*(24*r*s - 26*r + 24*s**2 - 47*s + 21)))/(35*d**2*k1*k3) - 2*D1**3*Pk1*Pkd3*ct**5*k2*(-21*b1**2*(D1*fd*(k1**2*(52*C - 40)*(s - 1) + k2**2*(-20*C*r + 23*r + 3*s - 3))*(r + s - 1) + Dd*f*(2*k1**2*(2*C*(52*r*s - 44*r + 52*s**2 - 87*s + 35) - 80*r*s + 70*r - 80*s**2 + 135*s - 55) - k2**2*(4*r + 4*s - 3)*(r*(20*C - 23) - 3*s + 3))) + 3*b1*f*(-14*D1*bd1*k1**2*(2*C*(2*r*(13*s - 9) + 26*s**2 - 35*s + 9) - 5*r*(8*s - 6) - 40*s**2 + 55*s - 15) + 7*D1*bd1*k2**2*(2*r + 2*s - 1)*(r*(20*C - 23) - 3*s + 3) + 6*D1*fd*k1**2*(2*C*(7*r*(6*s - 1) + 42*s**2 - 24*s - 9) + r*(13 - 54*s) - 54*s**2 + 38*s + 12) + D1*fd*k2**2*(16*C*(5*r + 8)*(r + s - 1) + 130*r**2 + r*(484*s - 305) + 354*s**2 - 464*s + 203) + 6*Dd*f*k1**2*(4*C*(7*r*(6*s - 1) + 42*s**2 - 40*s + 6) + r*(26 - 108*s) - 108*s**2 + 130*s - 31) + Dd*f*k2**2*(4*C*(40*r**2 + r*(40*s + 34) + 62*s - 47) + 260*r**2 + r*(968*s - 773) + 708*s**2 - 932*s + 345)) + f**2*(3*D1*bd1*(6*k1**2*(C*(42*r*s + 42*s**2 - 58*s + 30) - 27*r*s + 5*r - 27*s**2 + 52*s - 30) + k2**2*(60*C*s + r**2*(40*C + 65) + r*(40*C*s + 68*C + 242*s - 171) + 177*s**2 - 147*s - 2)) + D1*fd*(30*k1**2*(8*C*(3*s - 2)*(3*r + 3*s - 2) + r*(42 - 45*s) - 45*s**2 + 75*s - 29) + k2**2*(8*C*(6*r - 17)*(3*r + 3*s - 2) + 306*r**2 + 3*r*(456*s + 59) + 1062*s**2 + 6*s - 365)) + Dd*f*(30*k1**2*(2*C*(r*(48*s - 34) + 48*s**2 - 69*s + 25) + r*(56 - 60*s) - 60*s**2 + 105*s - 44) + k2**2*(4*C*(48*r**2 + 6*r*(8*s - 29) - 137*s + 103) + 408*r**2 + 8*r*(228*s - 7) + 1416*s**2 - 239*s - 474))))/(315*d**2*k1*k3**3) + D1**3*Pk1*Pkd3*ct**5*k2*(11*D1*bd1*f*(f**2*k2**4*(786*r**2 + r*(1356*s - 887) + 570*s**2 - 947*s + 105) + 3*f*(12*k1**4*(2*C*(r*(53*s - 50) + 53*s**2 - 116*s + 50) - 7*r*(9*s - 10) - 63*s**2 + 154*s - 70) - 4*k1**2*k2**2*(C*(494*r**2 + r*(1142*s - 775) + 648*s**2 - 775*s + 281) - 338*r**2 + r*(551 - 803*s) - 465*s**2 + 550*s - 213) + k2**4*(-2*K*(20*r**2 + 4*r*(5*s + 2) + 30*s - 30) + 15*b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 2*r**2*(313 - 168*C) + 4*r*(84*C*(s - 1) - 239*s + 238) - 330*(s - 1)**2)) + 210*k2**2*(r + s - 1)*(b1*k1**2*(14*C - 11)*(2*r + 2*s - 1) + 2*b1*k2**2*(r*(5 - 2*K) + 3*s) + 4*g2*k2**2*r)) + 165*b1**2*k2**2*(D1*fd*(k1**2*(196*C - 154)*(r + s - 1)**2 + k2**2*(3*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-14*r*(2*K - 5) + 42*s))) + 2*Dd*f*(k1**2*(98*C - 77)*(r + s - 1) + k2**2*(3*f*(13*r + 13*s - 8) + r*(35 - 14*K) + 21*s))*(4*r + 4*s - 3)) + 11*b1*(3*D1*(f**2*fd*k2**4*(786*r**2 + r*(1356*s - 757) + 570*s**2 - 697*s + 253) + 2*f*(fd*(6*k1**4*(2*C*(r*(106*s - 95) + 106*s**2 - 169*s + 58) - 126*r*(s - 1) - 126*s**2 + 217*s - 77) + k1**2*k2**2*(-2*C*(988*r**2 + r*(2284*s - 1195) + 1296*s**2 - 1405*s + 341) + 1352*r**2 + 4*r*(803*s - 468) + 1860*s**2 - 2273*s + 619) - k2**4*(2*r + 2*s - 1)*(4*K*(5*r + 8) + r*(313 - 168*C) + 165*s - 167)) + 140*gd2*k2**4*r*(r + s - 1)) + 280*fd*g2*k2**4*r*(r + s)) + 2*Dd*f*(f**2*k2**4*(1572*r**2 + r*(2712*s - 1579) + 1140*s**2 - 1519*s + 432) + 3*f*(6*k1**4*(4*C*(r*(106*s - 95) + 106*s**2 - 198*s + 83) - 252*r*(s - 1) - 252*s**2 + 511*s - 224) + k1**2*k2**2*(-4*C*(988*r**2 + r*(2284*s - 1517) + 1296*s**2 - 1622*s + 519) + 2704*r**2 + r*(6424*s - 4630) + 3720*s**2 - 5027*s + 1769) - k2**4*(4*K*(20*r**2 + 5*r*(4*s + 3) + 31*s - 23) + r**2*(1252 - 672*C) + r*(-672*C*s + 504*C + 1912*s - 1599) + 660*s**2 - 1159*s + 497)) + 420*g2*k2**4*r*(4*r + 4*s - 3))) + 2*f*(D1*(10*f**2*fd*k2**4*(508*r**2 + r*(288*s - 1135) - 220*s**2 - 864*s + 703) + 11*f*(fd*(10*k1**4*(C*(6*r*(51*s - 65) + 306*s**2 - 630*s + 272) - 171*r*s + 264*r - 171*s**2 + 405*s - 185) + k1**2*k2**2*(-2*C*(1737*r**2 + 9*r*(622*s - 67) + 3861*s**2 - 1317*s - 604) + 1683*r**2 + 6768*r*s + 87*r + 5085*s**2 - 1020*s - 1193) + 9*k2**4*(4*C*(36*r**2 + 36*r*s - 25*r - 2*s + 1) - 294*r**2 - 444*r*s + 275*r - 150*s**2 + 183*s - 54)) + 12*gd2*k2**4*(10*r**2 + 2*r*(5*s + 2) + 15*s - 15)) + 264*fd*g2*k2**4*(5*r + 8)*(2*r + 2*s - 1)) + Dd*f*(10*f**2*k2**4*(508*r**2 + r*(288*s - 1135) - 220*s**2 - 864*s + 703) + 11*f*(10*k1**4*(C*(408*r*s - 500*r + 408*s**2 - 864*s + 404) - 228*r*s + 332*r - 228*s**2 + 549*s - 272) + k1**2*k2**2*(-2*C*(2316*r**2 + 7464*r*s - 1569*r + 5148*s**2 - 2471*s - 737) + 2244*r**2 + 9024*r*s - 1097*r + 6780*s**2 - 2438*s - 1470) + 9*k2**4*(4*C*(48*r**2 + 48*r*s - 36*r - 2*s + 1) - 392*r**2 - 592*r*s + 394*r - 200*s**2 + 258*s - 79)) + 264*g2*k2**4*(20*r**2 + 5*r*(4*s + 3) + 31*s - 23))))/(3465*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**4*f*k2**6*st**4*(36*C - 36)*(2*r + 2*s - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**4*(8*C - 8)*(3*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(r*(12*s - 5) + 3*(1 - 2*s)**2) + Dd*f*(2*s - 1)*(8*r + 8*s - 5)))/(7*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**4*k2**4*st**2*(33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K - 30*b1*(2*r + 2*s - 1) + 51*r + 51*s - 29)) + k2**2*(r + s)*(168*K*b1 - 168*b1 - 168*g2)) - 198*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (14 - 14*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (14 - 14*K)*(r + s))*(4*r + 4*s - 3)) + 33*b1*(D1*(5*f**2*fd*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) + 6*f*(fd*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29)) - 168*g2*k2**2*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(1204*r**2 + r*(2408*s - 1619) + 1204*s**2 - 1619*s + 537) + 22*f*(fd*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1)) - 396*fd*g2*k2**2*(10*r**2 + r*(20*s - 3) + 10*s**2 - 3*s - 1)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(301*r + 301*s - 179) + 22*f*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(5*r + 5*s + 1))))/(385*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**4*k2**2*(33*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + k1**2*k2**2*(28*C*(8*r + 8*s - 5) + 6*K*(3*r + 3*s - 5) + b1*(25*r + 25*s - 23) - 194*r - 194*s + 132) - 7*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) - 140*k2**2*(r + s)*(b1*(k1**2 - k2**2*(K - 1)) + g2*k2**2)) - 33*b1**2*k2**2*(D1*fd*(-3*f*(k1**2*(25*r + 25*s - 23) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (70*k1**2 - 70*k2**2*(K - 1))*(r + s)**2) - Dd*f*(f*(k1**2*(75*r + 75*s - 69) - 42*k2**2*(2*r + 2*s - 1)) + (-70*k1**2 + 70*k2**2*(K - 1))*(r + s))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + 2*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 70*gd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1))) - 140*fd*g2*k2**4*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 140*g2*k2**4*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 22*f*(5*fd*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) - 18*gd2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(r + s - 1)) - 396*fd*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11)) + 110*f*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) - 396*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)))))/(385*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**4*k2**2*st**2*(-504*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 9*b1*f*(-56*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 4*D1*fd*(k1**2*(C*(100*r*s - 43*r + 100*s**2 - 83*s + 13) - 104*r*s + 52*r - 104*s**2 + 101*s - 21) + 9*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(2*k1**2*(2*C*(200*r*s - 86*r + 200*s**2 - 201*s + 47) - (2*s - 1)*(208*r + 208*s - 141)) + k2**2*(144*r**2 + 36*r*(4*s - 3) + 10*s - 5))) + f**2*(9*D1*bd1*(2*k1**2*(2*C*(50*r*s - 9*r + 50*s**2 - 49*s + 15) - 104*r*s + 33*r - 104*s**2 + 130*s - 45) + k2**2*(36*r**2 + r*(36*s - 31) + 10*s - 5)) + 2*D1*fd*(6*k1**2*(10*C*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) - 3*r*(99*s - 50) - 297*s**2 + 327*s - 93) + k2**2*(117*r**2 + 9*r*(13*s + 2) + 87*s - 61)) + Dd*f*(6*k1**2*(10*C*(72*r*s - 38*r + 72*s**2 - 81*s + 23) - 792*r*s + 450*r - 792*s**2 + 963*s - 297) + k2**2*(312*r**2 + 24*r*(13*s - 1) + 209*s - 157))))/(315*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**4*k2**2*st**2*(33*D1*bd1*f*(420*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*f**2*k2**4*(r - 1)*(30*r + 30*s - 17) + f*k1**2*(6*k1**2*(6*C*(r*(68*s - 31) + 68*s**2 - 96*s + 31) + r*(141 - 284*s) - 284*s**2 + 424*s - 141) + k2**2*(-2*C*(1065*r**2 + 14*r*(126*s - 101) + 699*s**2 - 954*s + 349) + 2070*r**2 + 4*r*(897*s - 722) + 1518*s**2 - 2103*s + 818))) + 13860*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(D1*fd*(6*f*k2**4*r*(30*r + 30*s - 17) + 12*k1**4*(6*C*(68*r*s - 41*r + 68*s**2 - 82*s + 24) - 284*r*s + 177*r - 284*s**2 + 354*s - 106) + k1**2*k2**2*(-2*C*(2130*r**2 + 3528*r*s - 1670*r + 1398*s**2 - 1248*s + 237) + 4140*r**2 + 7176*r*s - 3610*r + 3036*s**2 - 2946*s + 639)) + 2*Dd*f*(f*k2**4*(4*r - 1)*(30*r + 30*s - 17) + 3*k1**4*(6*C*(4*r*(68*s - 41) + 272*s**2 - 376*s + 127) - 1136*r*s + 708*r - 1136*s**2 + 1628*s - 565) + k1**2*k2**2*(-C*(4260*r**2 + 7056*r*s - 4555*r + 2796*s**2 - 3213*s + 898) + 4140*r**2 + 7176*r*s - 4795*r + 3036*s**2 - 3678*s + 1123))) + f**2*(D1*fd*(f*k2**4*(6920*r**2 + 8*r*(865*s - 1008) - 3105*s + 2271) + 132*k1**4*(C*(1026*r*s - 561*r + 1026*s**2 - 1200*s + 359) - 729*r*s + 411*r - 729*s**2 + 873*s - 266) - 11*k1**2*k2**2*(2*C*(4203*r**2 + 6*r*(1284*s - 565) + 3501*s**2 - 2832*s + 362) - 8649*r**2 - 24*r*(684*s - 325) - 7767*s**2 + 6906*s - 1254)) + Dd*f*(f*k2**4*(6920*r**2 + 8*r*(865*s - 1008) - 3105*s + 2271) + 66*k1**4*(2*C*(1368*r*s - 812*r + 1368*s**2 - 1746*s + 563) - 1944*r*s + 1174*r - 1944*s**2 + 2529*s - 829) - 11*k1**2*k2**2*(2*C*(5604*r**2 + 10272*r*s - 5203*r + 4668*s**2 - 4273*s + 636) - 11532*r**2 - 21888*r*s + 11875*r - 10356*s**2 + 10328*s - 2087))))/(3465*d**2*k1**2*k3**5) - 2*D1**3*Pk1*Pkd3*ct**4*(D1*bd1*f**2*(6*k1**2*(r*(2*C*(6*s - 5) - 5*s + 10) + s*(4*C*(3*s - 4) - 5*s + 9)) + k2**2*(2*r**2 + r*(2*s + 37) + 24*s)) + 7*b1**2*(2*D1*fd*(k1**2*(12*C - 7)*(s - 1) + 2*k2**2*r)*(r + s - 1) + Dd*f*(4*k1**2*(3*C*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 14*r*s + 13*r - 14*s**2 + 24*s - 10) + k2**2*(16*r**2 + 16*r*s - 6*r + 3*s - 3))) + b1*f*(7*D1*bd1*(4*k1**2*(3*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 7*r*s + 6*r - 7*s**2 + 10*s - 3) + k2**2*(8*r**2 + 8*r*s + 2*r + 3*s - 3)) + D1*fd*(6*k1**2*(C*(24*s - 26) - 10*s + 19) + k2**2*(4*r + 61))*(r + s - 1) + Dd*f*(12*k1**2*(C*(24*r*s - 26*r + 24*s**2 - 47*s + 21) - 10*r*s + 19*r - 10*s**2 + 26*s - 14) + k2**2*(8*r**2 + 4*r*(2*s + 29) + 109*s - 85))))/(105*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*ct**4*(3*b1**2*(D1*fd*(k1**4*(224*C - 126)*(s - 1)*(r + s - 1) - 14*k1**2*k2**2*(r + s - 1)*(5*C*(5*r + 3*s - 3) - 21*r - 14*s + 14) + k2**4*r*(f*(60*r + 60*s - 31) - 28*r - 28*s)) + Dd*f*(28*k1**4*(C*(32*r*s - 34*r + 32*s**2 - 57*s + 25) - 18*r*s + 21*r - 18*s**2 + 33*s - 15) - 7*k1**2*k2**2*(10*C*(20*r**2 + 32*r*s - 23*r + 12*s**2 - 19*s + 7) - 168*r**2 - 280*r*s + 192*r - 112*s**2 + 173*s - 61) + k2**4*(2*f*(60*r**2 + r*(60*s - 49) - 18*s + 10) - 112*r**2 - 14*r*(8*s - 9) - 21*s))) + b1*f*(3*D1*bd1*(28*k1**4*(C*(2*r*(8*s - 9) + 16*s**2 - 25*s + 9) - 3*r*(3*s - 4) - 9*s**2 + 15*s - 6) - 7*k1**2*k2**2*(10*C*(10*r**2 + 16*r*s - 7*r + 6*s**2 - 7*s + 1) - 84*r**2 - 140*r*s + 52*r - 56*s**2 + 61*s - 5) + k2**4*(f*(60*r**2 + 60*r*s - 67*r - 36*s + 20) - 56*r**2 - 56*r*s + 77*r - 21*s)) - D1*fd*(18*k1**4*(2*C*(14*s**2 + s*(14*r - 10) - 9) - 14*r*s - 14*s**2 + 11*s + 12) + 3*k1**2*k2**2*(4*C*(7*r**2 - 130*r*s + 170*r - 137*s**2 + 223*s - 128) + 34*r**2 + 420*r*s - 576*r + 386*s**2 - 820*s + 489) + k2**4*(f*(-342*r**2 - 342*r*s + 615*r + 384*s - 302) + 12*r**2 + 12*r*s + 114*r + 183*s - 60)) + Dd*f*(-18*k1**4*(C*(56*r*s + 56*s**2 - 90*s + 24) - 28*r*s - 28*s**2 + 53*s - 16) - 3*k1**2*k2**2*(2*C*(28*r**2 - 520*r*s + 687*r - 548*s**2 + 911*s - 427) + 68*r**2 + 840*r*s - 1181*r + 772*s**2 - 1570*s + 778) + k2**4*(f*(456*r**2 + r*(456*s - 782) - 484*s + 352) - 24*r**2 - 24*r*(s + 6) - 201*s + 141))) + f**2*(D1*bd1*(-18*k1**4*(2*C*(7*s**2 + s*(7*r - 22) + 15) - 7*s**2 + s*(27 - 7*r) - 20) - 3*k1**2*k2**2*(2*C*(7*r**2 + r*(141 - 130*s) - 137*s**2 + 185*s - 28) + 17*r**2 + 3*r*(70*s - 79) + 193*s**2 - 275*s + 7) + k2**4*(f*(114*r**2 + r*(114*s - 167) - 100*s + 50) - 6*r**2 - 6*r*(s - 8) + 54*s + 9)) + D1*fd*(-10*k1**4*(6*C*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + r*(69 - 18*s) - 18*s**2 + 90*s - 49) - 3*k1**2*k2**2*(8*C*(36*r**2 - 45*r*(s + 1) - 81*s**2 + 9*s + 22) - 243*r**2 + 45*r*(4*s + 9) + 423*s**2 + 84*s - 203) + 9*k2**4*(12*r**2 + r*(12*s - 5) + 6*s - 3)) + Dd*f*(-10*k1**4*(6*C*(12*r*s - 22*r + 12*s**2 - 36*s + 19) - 24*r*s + 82*r - 24*s**2 + 117*s - 70) - 3*k1**2*k2**2*(8*C*(48*r**2 - 12*r*(5*s + 4) - 108*s**2 + 29*s + 29) - 324*r**2 + 240*r*s + 439*r + 564*s**2 + s - 261) + 9*k2**4*(16*r**2 + 4*r*(4*s - 3) + 6*s - 3))))/(315*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**4*(11*D1*bd1*f*(f**2*k2**4*(k1**2*(840*r**2 + r*(2484*s - 1099) + 1644*s**2 - 1967*s + 131) - 36*k2**2*(r - 1)*(5*r + 5*s - 3)) + 3*f*k1**2*(24*k1**4*(C*(9*r*s - 25*r + 9*s**2 - 44*s + 25) - 4*r*s + 15*r - 4*s**2 + 25*s - 15) + 2*k1**2*k2**2*(C*(226*r**2 - 220*r*s + 8*r - 446*s**2 + 652*s - 234) - 294*r**2 - 256*r*s + 271*r + 38*s**2 - 132*s + 23) + k2**4*(28*C*(81*r**2 + 22*r*(6*s - 5) + 51*s**2 - 72*s + 29) + 58*K*r**2 + 92*K*r*s - 446*K*r + 34*K*s**2 - 498*K*s + 464*K + b1*(660*r**2 + r*(1320*s - 899) + 660*s**2 - 843*s + 211) - 2930*r**2 - 5172*r*s + 4590*r - 2242*s**2 + 3738*s - 1762)) - 42*k1**2*k2**2*(15*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(10 - 30*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(50*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*K*(47*r**2 + 64*r*s - 52*r + 17*s**2 - 22*s + 5) - 172*r**2 - 296*r*s + 235*r - 124*s**2 + 181*s - 60)) + k2**2*(15*b2*(r + s) - 2*g2*(47*r + 17*s))*(r + s - 1))) - 6930*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(420*C - 140)*(r + s - 1)**2 + k2**2*(-700*C*(r + s - 1)**2 - 14*K*(47*r**2 + 4*r*(16*s - 5) + 17*s**2 - 20*s + 10) + f*(660*r**2 + 1320*r*s - 719*r + 660*s**2 - 705*s + 225) + 1204*r**2 + 28*r*(74*s - 60) + 868*s**2 - 1680*s + 840)) + 2*Dd*f*(k1**2*(210*C - 70)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-350*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(188*r**2 + 256*r*s - 181*r + 68*s**2 - 91*s + 30) + f*(660*r**2 + r*(1320*s - 809) + 660*s**2 - 774*s + 218) + 2408*r**2 + 4144*r*s - 3528*r + 1736*s**2 - 2961*s + 1260))) + 11*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(840*r**2 + r*(2484*s - 755) + 1644*s**2 - 1273*s + 169) - 36*k2**2*r*(5*r + 5*s - 3)) + 2*f*k1**2*(fd*(6*k1**4*(2*C*(r*(18*s - 37) + 18*s**2 - 53*s + 22) + r*(43 - 16*s) - 16*s**2 + 58*s - 25) + 2*k1**2*k2**2*(C*(226*r**2 - 110*r*(2*s - 5) - 446*s**2 + 1152*s - 487) - 294*r**2 - r*(256*s + 237) + 38*s**2 - 655*s + 348) + k2**4*(14*C*(162*r**2 + 2*r*(132*s - 53) + 102*s**2 - 72*s + 3) + K*(58*r**2 + 92*r*s - 513*r + 34*s**2 - 529*s + 242) - 2930*r**2 - 5172*r*s + 2811*r - 2242*s**2 + 2460*s - 540)) + 7*k2**4*(-15*bd2*(r + s) + gd2*(94*r + 34*s - 20))*(r + s - 1)) + 14*fd*k1**2*k2**4*(-15*b2*(r + s)**2 + 2*g2*(47*r**2 + 4*r*(16*s - 5) + 17*s**2 - 20*s + 10))) + 2*Dd*f*(f**2*k2**4*(k1**2*(1680*r**2 + 2*r*(2484*s - 841) + 3288*s**2 - 2893*s + 319) - 18*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 3*f*k1**2*(6*k1**4*(2*C*(r*(36*s - 74) + 36*s**2 - 128*s + 69) + r*(86 - 32*s) - 32*s**2 + 141*s - 80) + k1**2*k2**2*(2*C*(452*r**2 + r*(897 - 440*s) - 892*s**2 + 2143*s - 1046) - 1176*r**2 - 2*r*(512*s + 207) + 152*s**2 - 2056*s + 1295) + k2**4*(14*C*(324*r**2 + r*(528*s - 323) + 204*s**2 - 213*s + 50) + K*(116*r**2 + 184*r*s - 959*r + 68*s**2 - 1027*s + 706) - 5860*r**2 - 10344*r*s + 7401*r - 4484*s**2 + 6198*s - 2169)) + 21*k1**2*k2**4*(-15*b2*(r + s) + g2*(94*r + 34*s - 20))*(4*r + 4*s - 3))) - 2*f*(D1*(10*f**2*fd*k2**4*(-k1**2*(1752*r**2 + 10*r*(382*s - 393) + 2068*s**2 - 4519*s + 2138) + 11*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 11*f*k1**2*(fd*(10*k1**4*(2*C*(r*(9*s - 84) + 9*s**2 - 99*s + 59) + 99*r + 108*s - 69) + k1**2*k2**2*(C*(6732*r**2 + 18*r*(362*s - 501) - 216*s**2 - 5106*s + 3260) - 6048*r**2 + r*(8313 - 8226*s) - 2178*s**2 + 5994*s - 2941) + 9*k2**4*(2*C*(516*r**2 + r*(834*s - 513) + 318*s**2 - 367*s + 108) - 1185*r**2 - 31*r*(66*s - 41) - 861*s**2 + 1020*s - 309)) - 3*k2**4*(15*bd2*(3*r**2 + r*(6*s - 1) + 3*s**2 - s - 2) + 2*gd2*(29*r**2 + r*(46*s - 223) + 17*s**2 - 249*s + 232))) + 33*fd*k1**2*k2**4*(15*b2*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2) + 2*g2*(58*r**2 + r*(92*s - 513) + 34*s**2 - 529*s + 242))) + Dd*f*(10*f**2*k2**4*(-k1**2*(1752*r**2 + 10*r*(382*s - 393) + 2068*s**2 - 4519*s + 2138) + 11*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 11*f*k1**2*(10*k1**4*(2*C*(12*r*s - 98*r + 12*s**2 - 126*s + 83) + 114*r + 135*s - 96) + k1**2*k2**2*(2*C*(4488*r**2 + 6*r*(724*s - 979) - 144*s**2 - 3136*s + 2249) - 8064*r**2 - 10968*r*s + 11116*r - 2904*s**2 + 7914*s - 4135) + 9*k2**4*(2*C*(688*r**2 + 8*r*(139*s - 93) + 424*s**2 - 526*s + 161) - 1580*r**2 - 2728*r*s + 1841*r - 1148*s**2 + 1463*s - 465)) + 33*k1**2*k2**4*(15*b2*(12*r**2 + r*(24*s - 1) + 12*s**2 - s - 6) + 2*g2*(116*r**2 + r*(184*s - 959) + 68*s**2 - 1027*s + 706)))))/(3465*d**2*k1**2*k3**5) + 3*D1**3*Pk1*Pkd3*ct**3*f*k2**5*st**4*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(4*r + 4*s - 3)) + f*(D1*fd*(5*f*k2**2*(724*r**2 + r*(1448*s - 987) + 724*s**2 - 987*s + 333) + 22*k1**2*(3*r + 3*s - 2)*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71)) + Dd*f*(5*f*k2**2*(181*r + 181*s - 111) + 22*k1**2*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71))*(4*r + 4*s - 3)))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**3*f*k2**3*st**4*(3*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(r*(12*s - 5) + 3*(1 - 2*s)**2) + Dd*f*(2*s - 1)*(8*r + 8*s - 5)))/(7*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**3*f*k2**3*st**4*(3*D1*bd1*f*(2*k1**2*(C*(304*r*s - 90*r + 304*s**2 - 332*s + 90) - 244*r*s + 75*r - 244*s**2 + 272*s - 75) + k2**2*(-8*C*(27*r**2 + 27*r*s - 32*r - 10*s + 5) + 366*r**2 + 516*r*s - 481*r + 150*s**2 - 305*s + 115)) + 3*b1*(D1*fd*(4*k1**2*(C*(304*r*s - 159*r + 304*s**2 - 318*s + 83) - 244*r*s + 129*r - 244*s**2 + 258*s - 68) - 3*k2**2*(2*r + 2*s - 1)*(r*(72*C - 122) - 50*s + 25)) + Dd*f*(2*k1**2*(2*C*(r*(608*s - 318) + 608*s**2 - 719*s + 211) + r*(516 - 976*s) - 976*s**2 + 1168*s - 347) + k2**2*(-8*C*(108*r**2 + 27*r*(4*s - 3) - 10*s + 5) + 1464*r**2 + 6*r*(344*s - 233) + 600*s**2 - 830*s + 265))) + f*(D1*fd*(k1**2*(168*C - 138)*(r*(12*s - 5) + 3*(1 - 2*s)**2) + k2**2*(-8*C*(63*r**2 + r*(63*s - 48) - 15*s + 7) + 954*r**2 + 9*r*(156*s - 101) + 450*s**2 - 645*s + 206)) + Dd*f*(6*k1**2*(2*C*(2*r*(112*s - 55) + 224*s**2 - 251*s + 69) - 4*r*(92*s - 45) - 368*s**2 + 412*s - 113) + k2**2*(-4*C*(168*r**2 + 12*r*(14*s - 11) - 35*s + 19) + 1272*r**2 + 18*r*(104*s - 71) + 600*s**2 - 890*s + 301))))/(105*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**3*k1*k2*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + k1**2*k2**2*(28*C*(7*r + 7*s - 5) + 2*K*(26*r + 26*s - 20) + b1*(-31*r - 31*s + 5) - 166*r - 166*s + 118) - 7*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) + k2**2*(k1**2 + k2**2)*(r + s)*(420*b1*(3 - 4*K) + 1680*g2)) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (210 - 280*K)*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7)) + (210 - 280*K)*(k1**2 + k2**2)*(r + s))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) - 280*gd2*k2**2*(k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 1680*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) + 1680*g2*k2**2*(k1**2 + k2**2)*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 72*gd2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(r + s - 1)) + 1584*fd*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5)) + 110*f*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 1584*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s)))))/(385*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 46*K*r + 46*K*s + 12*K - 6*b1*(51*r + 51*s - 29) + 431*r + 431*s - 261)) + k1**2*k2**2*(r + s)*(-84*b1*(4 - 7*K) - 588*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (56 - 98*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (56 - 98*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*k1**2*(fd*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261))*(2*r + 2*s - 1) - 196*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 588*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261)) - 588*g2*k1**2*k2**2*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(-523*r - 523*s + 329) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 6*gd2*k2**2*(23*r**2 + r*(46*s - 17) + 23*s**2 - 17*s - 6)) + 132*fd*g2*k1**2*k2**2*(46*r**2 + r*(92*s - 11) + 46*s**2 - 11*s - 6)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*(k1**2*k2**2*(523*r + 523*s - 329) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 132*g2*k1**2*k2**2*(23*r + 23*s + 6))))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(D1*bd1*f**2*(2*r*(5*s - 3) + s*(10*s - 11)) + 14*b1**2*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1*f*(14*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*fd*(20*s - 17)*(r + s - 1) + Dd*f*(40*r*s - 34*r + 40*s**2 - 69*s + 28)))/(35*d**2*k1*k3) - 2*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(-42*b1**2*(D1*fd*(k1**2*(50*C - 38)*(s - 1) + k2**2*(-22*C*r + 25*r + 3*s - 3))*(r + s - 1) + Dd*f*(2*k1**2*(5*C*(4*r*(5*s - 4) + 20*s**2 - 33*s + 13) - 76*r*s + 62*r - 76*s**2 + 126*s - 50) + k2**2*(C*(-88*r**2 - 88*r*s + 78*r + 6*s - 6) + 100*r**2 + 112*r*s - 99*r + 12*s**2 - 27*s + 15))) + 3*b1*f*(-14*D1*bd1*(2*k1**2*(5*C*(10*r*s - 6*r + 10*s**2 - 13*s + 3) - 38*r*s + 24*r - 38*s**2 + 50*s - 12) + k2**2*(C*(-44*r**2 - 44*r*s + 34*r + 6*s - 6) + 50*r**2 + 56*r*s - 43*r + 6*s**2 - 15*s + 9)) + 2*D1*fd*(k1**2*(4*C*(131*r*s - 62*r + 131*s**2 - 118*s + 14) - 296*r*s + 155*r - 296*s**2 + 295*s - 35) + k2**2*(r**2*(56*C + 67) + 2*r*(28*C*(s - 1) + 170*s - 67) + 273*s**2 - 258*s + 57)) + Dd*f*(2*k1**2*(2*C*(524*r*s - 248*r + 524*s**2 - 651*s + 191) - 592*r*s + 310*r - 592*s**2 + 861*s - 286) + k2**2*(r**2*(224*C + 268) + r*(56*C*(4*s - 3) + 1360*s - 745) + 1092*s**2 - 1029*s + 241))) + f**2*(6*D1*bd1*k1**2*(2*C*(r*(131*s - 45) + 131*s**2 - 211*s + 90) + r*(72 - 148*s) - 148*s**2 + 311*s - 144) + 3*D1*bd1*k2**2*(r**2*(56*C + 67) + r*(s*(56*C + 340) - 121) + 273*s**2 - 111*s - 2) + 2*D1*fd*(3*k1**2*(8*C*(9*r*(9*s - 5) + 81*s**2 - 96*s + 29) - 432*r*s + 261*r - 432*s**2 + 546*s - 173) + k2**2*(4*C*(72*r**2 + 9*r*(8*s - 15) - 78*s + 55) - 63*r**2 + 603*r*s + 75*r + 666*s**2 - 267*s - 70)) + 2*Dd*f*(3*k1**2*(4*C*(216*r*s - 130*r + 216*s**2 - 279*s + 91) - 576*r*s + 362*r - 576*s**2 + 783*s - 266) + k2**2*(4*C*(96*r**2 + 96*r*s - 186*r - 103*s + 80) - 84*r**2 + 804*r*s - 85*r + 888*s**2 - 526*s - 33))))/(315*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(11*D1*bd1*f*(f**2*k2**4*(942*r**2 + r*(1632*s - 1225) + 690*s**2 - 1237*s + 291) + 3*f*(4*k1**4*(C*(r*(289*s - 207) + 289*s**2 - 562*s + 207) + r*(135 - 169*s) - 169*s**2 + 358*s - 135) + k1**2*k2**2*(-2*C*(793*r**2 + r*(1880*s - 1351) + 1087*s**2 - 1351*s + 558) + 1004*r**2 + r*(2530*s - 1831) + 1526*s**2 - 1841*s + 827) + k2**4*(84*C*(6*r**2 + 6*r*s - 7*r - 2*s + 1) - 28*K*r**2 - 28*K*r*s + 15*b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 821*r**2 - 1166*r*s + 1158*r - 345*s**2 + 738*s - 309)) + 42*k2**2*(b1*(k1**2*(65*C - 50)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(r**2*(52 - 22*K) + r*(K*(19 - 22*s) + 82*s - 49) + 3*s*(K + 10*s - 11))) + 2*g2*k2**2*(11*r**2 + 11*r*(s - 1) - 3*s))) + 33*b1**2*k2**2*(D1*fd*(k1**2*(910*C - 700)*(r + s - 1)**2 + k2**2*(15*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-14*r*(11*K - 26) + 210*s))) + 2*Dd*f*(k1**2*(455*C - 350)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(15*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 24) - 7*r**2*(44*K - 104) - 7*r*(44*K*s - 27*K - 164*s + 72) + 21*s*(K + 20*s - 16)))) + 11*b1*(3*D1*(f**2*fd*k2**4*(942*r**2 + r*(1632*s - 1019) + 690*s**2 - 947*s + 359) + f*(fd*(4*k1**4*(C*(r*(578*s - 422) + 578*s**2 - 851*s + 281) + r*(260 - 338*s) - 338*s**2 + 527*s - 179) + k1**2*k2**2*(-4*C*(793*r**2 + 2*r*(940*s - 501) + 1087*s**2 - 1135*s + 257) + 2008*r**2 + r*(5060*s - 2977) + 3052*s**2 - 3499*s + 869) - k2**4*(28*K*(2*r**2 + 2*r*s + r - 1) - r**2*(1008*C - 1642) + r*(-504*C*(2*s - 1) + 2332*s - 1327) + 690*s**2 - 795*s + 253)) + 28*gd2*k2**4*r*(11*r + 11*s - 8)) + 308*fd*g2*k2**4*r*(r + s)) + Dd*f*(2*f**2*k2**4*(1884*r**2 + r*(3264*s - 2141) + 1380*s**2 - 2039*s + 684) + 3*f*(4*k1**4*(C*(4*r*(289*s - 211) + 1156*s**2 - 1983*s + 769) + r*(520 - 676*s) - 676*s**2 + 1233*s - 493) - 2*k1**2*k2**2*(C*(3172*r**2 + r*(7520*s - 5111) + 4348*s**2 - 5377*s + 1741) - 2008*r**2 + r*(3714 - 5060*s) - 3052*s**2 + 3985*s - 1400) + k2**4*(84*C*(24*r**2 + 6*r*(4*s - 3) - 2*s + 1) - 28*K*(4*r**2 + 4*r*s + r - 1) - 3284*r**2 - 4664*r*s + 3475*r - 1380*s**2 + 2103*s - 787)) + 84*g2*k2**4*(44*r**2 + r*(44*s - 27) - 3*s))) + 2*f*(D1*(2*f**2*fd*k2**4*(3748*r**2 + r*(2868*s - 4199) - 880*s**2 - 1256*s + 1305) + 11*f*(fd*(3*k1**4*(2*C*(9*r*(61*s - 39) + 549*s**2 - 729*s + 238) - 666*r*s + 441*r - 666*s**2 + 912*s - 303) + k1**2*k2**2*(-2*C*(1557*r**2 + 9*r*(512*s - 181) + 3051*s**2 - 2283*s + 280) + 2043*r**2 + 6489*r*s - 2382*r + 4446*s**2 - 3363*s + 473) + 9*k2**4*(8*C*(15*r**2 + 15*r*s - 11*r - 2*s + 1) - 210*r**2 - 300*r*s + 193*r - 90*s**2 + 121*s - 38)) + 84*gd2*k2**4*r*(r + s)) + 924*fd*g2*k2**4*(2*r**2 + 2*r*s + r - 1)) + Dd*f*(2*f**2*k2**4*(3748*r**2 + r*(2868*s - 4199) - 880*s**2 - 1256*s + 1305) + 11*f*(3*k1**4*(2*C*(732*r*s - 472*r + 732*s**2 - 1035*s + 361) - 888*r*s + 582*r - 888*s**2 + 1287*s - 456) + k1**2*k2**2*(-2*C*(2076*r**2 + 6144*r*s - 2727*r + 4068*s**2 - 3574*s + 554) + 2724*r**2 + 8652*r*s - 4093*r + 5928*s**2 - 5323*s + 951) + 9*k2**4*(8*C*(20*r**2 + 5*r*(4*s - 3) - 2*s + 1) - 280*r**2 - 400*r*s + 270*r - 120*s**2 + 166*s - 53)) + 924*g2*k2**4*(4*r**2 + 4*r*s + r - 1))))/(3465*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct**3*(D1*bd1*f**2*(k1**2*(6 - 12*C)*(r*(s + 5) + s*(s + 1)) + k2**2*(r**2*(44*C - 13) + 2*r*(22*C*s - 34*C + 6*s + 35) + s*(-60*C + 25*s + 23))) + 7*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*(9*r + 11*s - 11))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) + k2**2*(36*r**2 + 80*r*s - 49*r + 44*s**2 - 66*s + 22))) + b1*f*(7*D1*bd1*(k1**2*(4*C - 2)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + k2**2*(18*r**2 + r*(40*s - 9) + s*(22*s - 22))) + D1*fd*(k1**2*(12 - 24*C)*(s + 3) + k2**2*(8*C*(11*r - 16) - 26*r + 50*s + 93))*(r + s - 1) + Dd*f*(k1**2*(6 - 12*C)*(4*r*(s + 3) + 4*s**2 + 5*s - 7) + k2**2*(4*C*(44*r**2 + 44*r*s - 97*r - 62*s + 47) - 52*r**2 + 48*r*s + 225*r + 100*s**2 + 64*s - 116))))/(105*d**2*k1*k2*k3) + D1**3*Pk1*Pkd3*ct**3*(21*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(7*bd1*f*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*fd*(k1**4*(28*C - 14)*(s - 1)*(r + s - 1) - 14*k1**2*k2**2*(r + s - 1)*(5*C*(r + s - 1) - 2*r + 2*s - 2) + k2**4*(84*K*(r - 1)*(r + s - 1) + f*(61*r**2 + r*(226*s - 54) + 165*s**2 - 196*s + 45) + 7*r**2*(20*C - 46) + 7*r*(20*C*(s - 1) - 44*s + 58) + 14*s**2 + 182*s - 133))) + Dd*f*(k1**4*(56*C - 28)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) - 14*k1**2*k2**2*(10*C*(4*r**2 + r*(8*s - 3) + 4*s**2 - 5*s + 1) - 16*r**2 - 26*r + 16*s**2 - 39*s + 23) + k2**4*(84*K*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + f*(244*r**2 + r*(904*s - 395) + 660*s**2 - 891*s + 251) + 14*r**2*(80*C - 184) + 28*r*(40*C*s - 30*C - 88*s + 103) + 112*s**2 + 700*s - 630))) + b1*(3*D1*bd1*f*(k1**4*(56*C - 28)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) - 14*k1**2*k2**2*(10*C*(2*r**2 + 4*r*s + r + 2*s**2 - s - 1) - 8*r**2 - 26*r + 8*s**2 - 23*s + 15) + k2**4*(84*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) + f*(122*r**2 + r*(452*s - 287) + 330*s**2 - 499*s + 161) + 14*r**2*(40*C - 92) + 14*r*(40*C*s - 20*C - 88*s + 87) + 56*s**2 + 182*s - 182)) + 6*D1*(4*f**2*fd*k2**4*(78*r**2 + 2*r*(66*s - 85) + 54*s**2 - 170*s + 97) + f*(fd*(k1**4*(12*C - 6)*(s + 3) - k1**2*k2**2*(4*C*(3*r**2 + r*(269 - 124*s) - 127*s**2 + 343*s - 209) + 18*r**2 + r*(128*s - 629) + 110*s**2 - 852*s + 594) + k2**4*(28*C*(8*r - 1)*(r + s - 1) - 2*K*(11*r - 16)*(2*r + 2*s - 1) + 100*r**2 + 596*r*s - 240*r + 496*s**2 - 613*s + 123)) - 84*gd2*k2**4*(2*r - 1)*(r + s - 1)) - 168*fd*g2*k2**4*(r - 1)*(r + s - 1)) + 2*Dd*f*(4*f**2*k2**4*(312*r**2 + 8*r*(66*s - 83) + 216*s**2 - 649*s + 351) + 3*f*(k1**4*(48*C - 24)*(2*s - 1) - k1**2*k2**2*(2*C*(12*r**2 + r*(855 - 496*s) - 508*s**2 + 1247*s - 649) + 36*r**2 + 256*r*s - 947*r + 220*s**2 - 1435*s + 865) + k2**4*(28*C*(16*r**2 + 2*r*(8*s - 7) - s + 1) - 2*K*(44*r**2 + 44*r*s - 93*r - 62*s + 46) + 200*r**2 + 1192*r*s - 728*r + 992*s**2 - 1321*s + 433)) - 252*g2*k2**4*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 2*f*(D1*bd1*(4*f**2*k2**4*(78*r**2 + 22*r*(6*s - 7) + 54*s**2 - 139*s + 60) + 3*f*(k1**4*(60*C - 30)*(s - 1) + k1**2*k2**2*(-r**2*(6*C + 9) + 2*r*(C*(124*s - 75) - 32*s + 46) + s**2*(254*C - 55) - s*(406*C - 217) + 40) + 2*k2**4*(K*(-11*r**2 + r*(25 - 11*s) + 15*s - 15) + r**2*(56*C + 25) + r*(56*C*s - 14*C + 149*s - 101) + 124*s**2 - 135*s + 60)) - 252*g2*k2**4*(2*r**2 + 2*r*(s - 1) - s)) + D1*(f*fd*(k1**4*(20*C - 10)*(3*s + 5)*(3*r + 3*s - 2) - 3*k1**2*k2**2*(4*C*(207*r**2 + 45*r*(3*s - 5) - 72*s**2 - 60*s + 65) - 549*r**2 + r*(753 - 756*s) - 207*s**2 + 492*s - 247) - 9*k2**4*(4*C*(3*r - 1)*(2*r + 2*s - 1) - 114*r**2 - 7*r*(36*s - 19) - 138*s**2 + 128*s - 31)) - 6*f*k2**4*(bd2 - 2*gd2)*(11*r**2 + 11*r*s - 25*r - 15*s + 15) - 6*fd*k2**4*(b2 - 2*g2)*(11*r - 16)*(2*r + 2*s - 1)) + Dd*f*(f*(k1**4*(20*C - 10)*(4*r*(3*s + 4) + 12*s**2 + 9*s - 13) - 3*k1**2*k2**2*(4*C*(276*r**2 + 3*r*(60*s - 97) - 96*s**2 - 56*s + 85) - 732*r**2 + r*(1039 - 1008*s) - 276*s**2 + 666*s - 352) - 9*k2**4*(4*C*(4*r - 1)*(2*r + 2*s - 1) - 152*r**2 - 4*r*(84*s - 53) - 184*s**2 + 197*s - 54)) + k2**4*(-6*b2 + 12*g2)*(44*r**2 + r*(44*s - 93) - 62*s + 46))))/(315*d**2*k1*k2*k3**3) - D1**3*Pk1*Pkd3*ct**3*(11*D1*bd1*f*(f**2*k2**4*(k1**2*(1581*r**2 + 2*r*(633*s - 1015) - 315*s**2 - 594*s + 677) + 9*k2**2*(134*r**2 + r*(164*s - 139) + 30*s**2 - 79*s + 9)) + 3*f*(k1**6*(24*C - 12)*(r*(s + 5) + s**2 + 6*s - 5) - 2*k1**4*k2**2*(2*C*(388*r**2 + r*(692*s - 513) + 304*s**2 - 247*s + 125) - 475*r**2 + r*(694 - 1018*s) - 543*s**2 + 444*s - 219) + k1**2*k2**4*(-28*C*(146*r**2 + 278*r*s - 233*r + 132*s**2 - 195*s + 87) - 4*K*(305*r**2 + 514*r*s - 560*r + 209*s**2 - 523*s + 314) + b1*(1440*r**2 + r*(3216*s - 2195) + 1776*s**2 - 2531*s + 755) + 4712*r**2 + 9156*r*s - 7676*r + 4444*s**2 - 6964*s + 3164) + 7*k2**6*(15*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + 2*r**2*(23 - 8*K) + 2*r*(-8*K*s + 6*K + 38*s - 21) + 2*s*(15*s - 15))) + 21*k2**2*(15*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*b1*(k1**4*(30*C - 25)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(150*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 4*K*(4*r**2 - 7*r*(s + 2) - 11*s**2 + s + 10) - 166*r**2 - 280*r*s + 323*r - 114*s**2 + 267*s - 155) - 10*k2**4*(r*(2*K - 7) - 5*s)*(r + s - 1)) + 4*k2**2*(5*b2*k1**2*(r + s) + 2*g2*(k1**2*(-4*r + 11*s) + 5*k2**2*r))*(r + s - 1))) + 3465*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**4*(420*C - 350)*(r + s - 1)**2 + k1**2*k2**2*(2100*C*(r + s - 1)**2 + 28*K*(4*r**2 - 7*r*s - 40*r - 11*s**2 - 40*s + 20) + f*(1440*r**2 + r*(3216*s - 1685) + 1776*s**2 - 1853*s + 535) - 1162*r**2 - 1960*r*s + 4340*r - 798*s**2 + 4340*s - 2170) + 35*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-2*r*(2*K - 7) + 10*s))) + 2*Dd*f*(k1**4*(210*C - 175)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(1050*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 14*K*(16*r**2 - 4*r*(7*s + 23) - 44*s**2 - 47*s + 60) + f*(1440*r**2 + 4*r*(804*s - 485) + 1776*s**2 - 2192*s + 645) - 2324*r**2 - 3920*r*s + 6111*r - 1596*s**2 + 5523*s - 3255) + 35*k2**4*(4*r + 4*s - 3)*(f*(9*r + 9*s - 6) + r*(7 - 2*K) + 5*s))) + 11*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(1581*r**2 + r*(1266*s - 1927) - 315*s**2 - 891*s + 732) + 3*k2**2*(402*r**2 + r*(492*s - 407) + 90*s**2 - 227*s + 135)) + 2*f*(fd*(k1**6*(12*C - 6)*(s + 3)*(2*r + 2*s - 1) - k1**4*k2**2*(2*C*(776*r**2 + r*(1384*s - 275) + 608*s**2 + 131*s - 285) - 950*r**2 + r*(495 - 2036*s) - 1086*s**2 + 94*s + 322) - k1**2*k2**4*(14*C*(292*r**2 + r*(556*s - 225) + 264*s**2 - 203*s + 13) + 2*K*(610*r**2 + 1028*r*s - 953*r + 418*s**2 - 906*s + 324) - 4712*r**2 - 9156*r*s + 4502*r - 4444*s**2 + 4417*s - 779) - 7*k2**6*(r**2*(16*K - 46) + r*(8*K*(2*s - 1) - 76*s + 23) + s*(-2*K - 30*s + 17))) + 14*k2**4*(r + s - 1)*(5*bd2*k1**2*(r + s) + gd2*k1**2*(-8*r + 22*s + 40) + 10*gd2*k2**2*r)) + 28*fd*k2**4*(5*b2*k1**2*(r + s)**2 + 2*g2*(k1**2*(-4*r**2 + 7*r*s + 40*r + 11*s**2 + 40*s - 20) + 5*k2**2*r*(r + s)))) + Dd*f*(f**2*k2**4*(k1**2*(6324*r**2 + r*(5064*s - 7811) - 1260*s**2 - 3267*s + 2873) + 18*k2**2*(268*r**2 + r*(328*s - 273) + 60*s**2 - 153*s + 72)) + 6*f*(k1**6*(12*C - 6)*(4*r*(s + 3) + 4*s**2 + 13*s - 11) + k1**4*k2**2*(-4*C*(776*r**2 + 4*r*(346*s - 151) + 608*s**2 - 135*s - 155) + 1900*r**2 + r*(4072*s - 1855) + 2172*s**2 - 954*s - 230) - k1**2*k2**4*(28*C*(292*r**2 + r*(556*s - 343) + 264*s**2 - 294*s + 79) + 2*K*(1220*r**2 + 2056*r*s - 2073*r + 836*s**2 - 1952*s + 952) - 9424*r**2 - 18312*r*s + 12234*r - 8888*s**2 + 11437*s - 3677) - 7*k2**6*(r**2*(32*K - 92) + r*(4*K*(8*s - 5) - 152*s + 65) + s*(-2*K - 60*s + 47))) + 84*k2**4*(4*r + 4*s - 3)*(5*b2*k1**2*(r + s) + g2*k1**2*(-8*r + 22*s + 40) + 10*g2*k2**2*r))) - 2*f*(D1*(10*f**2*fd*k2**4*(k1**2*(2444*r**2 + r*(7328*s - 5909) + 4884*s**2 - 7805*s + 3090) + 44*k2**2*(12*r**2 + r*(52*s - 31) + 40*s**2 - 47*s + 14)) - 11*f*(fd*k1**2*(k1**4*(20*C - 10)*(3*s + 5)*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(4707*r**2 + 9*r*(904*s - 677) + 3429*s**2 - 4989*s + 1886) + 5922*r**2 + 36*r*(319*s - 227) + 5562*s**2 - 7437*s + 2651) - 9*k2**4*(2*C*(993*r**2 + r*(1842*s - 1163) + 849*s**2 - 1019*s + 318) - 1647*r**2 - 3132*r*s + 2003*r - 1485*s**2 + 1810*s - 575)) + 6*k2**4*(-15*bd2*k1**2*(r**2 + r*(2*s - 5) + s**2 - 5*s + 4) + 2*gd2*(k1**2*(305*r**2 + 514*r*s - 560*r + 209*s**2 - 523*s + 314) + 7*k2**2*r*(4*r + 4*s - 3)))) + 66*fd*k2**4*(15*b2*k1**2*(2*r**2 + r*(4*s - 9) + 2*s**2 - 9*s + 4) - 2*g2*(k1**2*(610*r**2 + 1028*r*s - 953*r + 418*s**2 - 906*s + 324) + 7*k2**2*(8*r**2 + 8*r*s - 4*r - s)))) + Dd*f*(10*f**2*k2**4*(k1**2*(2444*r**2 + r*(7328*s - 5909) + 4884*s**2 - 7805*s + 3090) + 44*k2**2*(12*r**2 + r*(52*s - 31) + 40*s**2 - 47*s + 14)) - 11*f*k1**2*(k1**4*(20*C - 10)*(4*r*(3*s + 4) + 12*s**2 + 9*s - 13) + k1**2*k2**2*(-2*C*(6276*r**2 + 3*r*(3616*s - 2881) + 4572*s**2 - 7031*s + 2785) + 7896*r**2 + 12*r*(1276*s - 977) + 7416*s**2 - 10619*s + 3979) - 9*k2**4*(C*(2648*r**2 + r*(4912*s - 3378) + 2264*s**2 - 2934*s + 966) - 2196*r**2 + r*(2921 - 4176*s) - 1980*s**2 + 2612*s - 882)) + 66*k2**4*(15*b2*k1**2*(4*r**2 + r*(8*s - 19) + 4*s**2 - 19*s + 12) - 2*g2*(k1**2*(1220*r**2 + r*(2056*s - 2073) + 836*s**2 - 1952*s + 952) + 7*k2**2*(16*r**2 + 2*r*(8*s - 5) - s))))))/(3465*d**2*k1*k2*k3**5) + D1**3*Pk1*Pkd3*ct**2*f*k2**6*st**6*(4*C - 4)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(7*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**6*(8*C - 8)*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(63*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**2*k1**2*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + 53*K*r + 53*K*s - 30*K + b1*(-33*r - 33*s + 13) - 69*r - 69*s + 52) - 21*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 420*k2**2*(r + s)*(b1*k1**2*(2 - 5*K) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + (r + s)**2*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3))) + Dd*f*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3)) + (r + s)*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) - 70*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 420*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) + 420*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) - 22*f*(5*fd*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 18*gd2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(r + s - 1)) + 396*fd*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9)) + 110*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 396*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s)))))/(385*d**2*k3**7) - 3*D1**3*Pk1*Pkd3*ct**2*k2**4*st**4*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(2*r + 2*s - 1)*(14*C - K + 30*b1 - 13) + k2**2*(r + s)*(28*K*b1 - 28*b1 - 28*g2)) + 66*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) + 2*f*(fd*(k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - k2**2*(14*C - K - 13)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 28*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(14*C - K - 13)*(2*r + 2*s - 1) - 28*g2*k2**2*(r + s))) + f*(D1*(-5*f**2*fd*k2**2*(1124*r**2 + r*(2248*s - 1543) + 1124*s**2 - 1543*s + 525) - 22*f*(fd*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 6*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 132*fd*g2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(281*r + 281*s - 175) + 22*f*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1)) - 132*g2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(33*D1*bd1*f*(r + s - 1)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + 55*K*r + 55*K*s + 18*K - 12*b1*(11*r + 11*s - 9) + 431*r + 431*s - 282) + 7*k2**4*(12*b1*(2*r + 2*s - 1) - (K - 1)*(r + s))) + 14*k2**2*(r + s)*(b1*k1**2*(3 - 11*K) + 5*b1*k2**2*(K - 1) + g2*(11*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5))) + Dd*f*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*gd2*k2**2*(11*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*fd*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s))) - f*(D1*(15*f**2*fd*k2**2*(8*k1**2*(4*r + 4*s - 3) - 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(k1**2*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 6*gd2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(r + s - 1)) + 66*fd*g2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*(8*k1**2*k2**2*(4*r + 4*s - 3) - 11*k2**4*(17*r + 17*s - 11)) + 11*f*(k1**4*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) - 66*g2*k2**2*(k1**2*(55*r + 55*s + 18) - 7*k2**2*(r + s)))))/(385*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**2*(1155*b1**3*k2**2*(7*k1**2 + 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*(D1*(-35*bd1*f*k2**2*(7*k1**2 + 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(280*C - 140)*(r + s - 1)**2 + k1**2*k2**2*(2100*C*(r + s - 1)**2 - 14*K*(113*r**2 + 236*r*s + 120*r + 123*s**2 + 120*s - 60) + f*(1824*r**2 + 3*r*(1496*s - 651) + 2664*s**2 - 2317*s + 425) - 322*r**2 - 308*r*s + 3640*r + 14*s**2 + 3640*s - 1820) + 7*k2**4*(f*(372*r**2 + r*(768*s - 463) + 396*s**2 - 471*s + 159) + (-10*r - 10*s)*(r*(15*K - 18) + s*(9*K - 14))))) + 2*Dd*f*(k1**4*(140*C - 70)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(1050*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(452*r**2 + 944*r*s - 99*r + 492*s**2 - 129*s - 180) + 2*f*(912*r**2 + 12*r*(187*s - 106) + 1332*s**2 - 1517*s + 406) - 644*r**2 - 616*r*s + 4025*r + 28*s**2 + 3668*s - 2730) + 7*k2**4*(f*(372*r**2 + r*(768*s - 511) + 396*s**2 - 519*s + 169) - 5*r**2*(60*K - 72) - 5*r*(K*(96*s - 45) - 128*s + 56) - 5*s*(9*K*(4*s - 3) - 56*s + 41)))) - 11*b1*(3*D1*bd1*f*(k1**4*(280*C - 140)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(2100*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 28*K*(113*r**2 + 236*r*s - 83*r + 123*s**2 - 93*s - 30) + f*(1824*r**2 + 33*r*(136*s - 95) + 2664*s**2 - 3751*s + 1199) - 644*r**2 - 616*r*s + 2366*r + 28*s**2 + 1890*s - 1820) + 7*k2**4*(f*(372*r**2 + r*(768*s - 559) + 396*s**2 - 567*s + 179) - 10*r**2*(30*K - 36) - 10*r*(6*K*(8*s - 5) - 64*s + 37) - 10*s*(18*K*(s - 1) - 28*s + 27))) + 3*D1*(f**2*fd*k2**2*(k1**2*(2715*r**2 + r*(4494*s - 3323) + 1779*s**2 - 2849*s + 1118) + 3*k2**2*(900*r**2 + r*(1368*s - 989) + 468*s**2 - 713*s + 313)) - 2*f*(fd*(2*k1**4*(C*(264*r**2 + 4*r*(181*s - 64) + 460*s**2 - 214*s - 38) - 132*r**2 + r*(161 - 428*s) - 296*s**2 + 166*s + 6) + k1**2*k2**2*(14*C*(194*r**2 + 8*r*(53*s - 23) + 230*s**2 - 202*s + 21) + K*(2562*r**2 + 4516*r*s - 2905*r + 1954*s**2 - 2727*s + 812) - 3138*r**2 - 6724*r*s + 3187*r - 3586*s**2 + 3558*s - 634) + 7*k2**4*(r**2*(98*K - 112) + r*(K*(148*s - 49) - 192*s + 56) + s*(K*(50*s - 31) - 80*s + 41))) - 7*k2**2*(r + s - 1)*(-5*bd2*(7*k1**2 + 5*k2**2)*(r + s) + 2*gd2*k1**2*(113*r + 123*s + 60) + 30*gd2*k2**2*(5*r + 3*s))) + 14*fd*k2**2*(-5*b2*(7*k1**2 + 5*k2**2)*(r + s)**2 + 2*g2*k1**2*(113*r**2 + 4*r*(59*s + 30) + 123*s**2 + 120*s - 60) + 30*g2*k2**2*(5*r**2 + 8*r*s + 3*s**2))) + Dd*f*(f**2*k2**2*(k1**2*(10860*r**2 + 7*r*(2568*s - 2047) + 7116*s**2 - 12283*s + 5019) + 36*k2**2*(300*r**2 + r*(456*s - 337) + 156*s**2 - 245*s + 92)) - 6*f*(2*k1**4*(2*C*(264*r**2 + r*(724*s - 382) + 460*s**2 - 319*s + 33) - 264*r**2 + r*(448 - 856*s) - 592*s**2 + 443*s - 62) + k1**2*k2**2*(14*C*(388*r**2 + r*(848*s - 555) + 460*s**2 - 561*s + 174) + K*(5124*r**2 + 9032*r*s - 6759*r + 3908*s**2 - 6265*s + 2396) - 6276*r**2 - 13448*r*s + 8741*r - 7172*s**2 + 9168*s - 2903) + 7*k2**4*(r**2*(196*K - 224) + r*(K*(296*s - 135) - 384*s + 166) + s*(K*(100*s - 81) - 160*s + 121))) + 42*k2**2*(4*r + 4*s - 3)*(-5*b2*(7*k1**2 + 5*k2**2)*(r + s) + 2*g2*k1**2*(113*r + 123*s + 60) + 30*g2*k2**2*(5*r + 3*s)))) + f*(-11*D1*bd1*(f**2*k2**2*(k1**2*(2715*r**2 + r*(4494*s - 4360) + 1779*s**2 - 3736*s + 1665) + 9*k2**2*(300*r**2 + r*(456*s - 359) + 156*s**2 - 267*s + 55)) - 6*f*(2*k1**4*(2*C*(66*r**2 + r*(181*s - 107) + 115*s**2 - 86*s + 41) - 66*r**2 + r*(110 - 214*s) - 148*s**2 + 105*s - 44) + k1**2*k2**2*(14*C*(97*r**2 + 4*r*(53*s - 46) + 115*s**2 - 178*s + 87) + K*(1281*r**2 + 2258*r*s - 1927*r + 977*s**2 - 1769*s + 792) - 1569*r**2 - 3362*r*s + 2707*r - 1793*s**2 + 2735*s - 1187) + 7*k2**4*(r**2*(49*K - 56) + r*(K*(74*s - 43) - 96*s + 55) + s*(25*K - 40)*(s - 1))) - 42*k2**2*(5*b2*(7*k1**2 + 5*k2**2)*(r + s) - 2*g2*(k1**2*(113*r + 123*s) + 15*k2**2*(5*r + 3*s)))*(r + s - 1)) + 2*D1*(5*f**2*fd*k2**2*(k1**2*(1904*r**2 + r*(8328*s - 6370) + 6424*s**2 - 9617*s + 3635) + 66*k2**2*(36*r**2 + r*(132*s - 85) + 96*s**2 - 121*s + 39)) + 11*f*(45*bd2*k2**2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(r + s - 1) + 2*fd*k1**4*(2*C*(765*r**2 + 36*r*(49*s - 32) + 999*s**2 - 1200*s + 392) - 765*r**2 - 3*r*(663*s - 409) - 1224*s**2 + 1416*s - 439) + 9*fd*k1**2*k2**2*(2*C*(726*r**2 + 3*r*(496*s - 331) + 762*s**2 - 977*s + 326) - 948*r**2 + r*(1321 - 1986*s) - 1038*s**2 + 1338*s - 445) - 6*gd2*k2**2*(k1**2*(1281*r**2 + r*(2258*s - 1927) + 977*s**2 - 1769*s + 792) + 7*k2**2*(49*r**2 + r*(74*s - 43) + s*(25*s - 25)))) + 33*fd*k2**2*(15*b2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 2*g2*(k1**2*(2562*r**2 + r*(4516*s - 2905) + 1954*s**2 - 2727*s + 812) + 7*k2**2*(98*r**2 + r*(148*s - 49) + s*(50*s - 31))))) + 2*Dd*f*(5*f**2*k2**2*(k1**2*(1904*r**2 + r*(8328*s - 6370) + 6424*s**2 - 9617*s + 3635) + 66*k2**2*(36*r**2 + r*(132*s - 85) + 96*s**2 - 121*s + 39)) + 11*f*k1**2*(2*k1**2*(2*C*(1020*r**2 + 3*r*(784*s - 571) + 1332*s**2 - 1757*s + 616) - 1020*r**2 - 2652*r*s + 1853*r - 1632*s**2 + 2090*s - 705) + 9*k2**2*(2*C*(968*r**2 + 2*r*(992*s - 723) + 1016*s**2 - 1408*s + 503) - 1264*r**2 - 2648*r*s + 1940*r - 1384*s**2 + 1936*s - 697)) + 33*k2**2*(15*b2*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(4*r + 4*s - 3) - 2*g2*(k1**2*(5124*r**2 + r*(9032*s - 6759) + 3908*s**2 - 6265*s + 2396) + 7*k2**2*(196*r**2 + r*(296*s - 135) + s*(100*s - 81)))))))/(3465*d**2*k3**5) - 2*D1**3*Pk1*Pkd3*ct**2*k2**2*st**4*(-84*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 3*b1*f*(-28*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 2*D1*fd*(k1**2*(4*C*(2*s - 1)*(28*r + 28*s - 13) - 168*r*s + 91*r - 168*s**2 + 174*s - 45) + 24*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(k1**2*(16*C*(2*s - 1)*(28*r + 28*s - 17) - 672*r*s + 364*r - 672*s**2 + 810*s - 244) + k2**2*(192*r**2 + 48*r*(4*s - 3) - 10*s + 5))) + f**2*(3*D1*bd1*(4*k1**2*(C*(56*r*s - 14*r + 56*s**2 - 57*s + 15) - 42*r*s + 14*r - 42*s**2 + 50*s - 15) + k2**2*(48*r**2 + r*(48*s - 53) - 10*s + 5)) + D1*fd*(k1**2*(60*C - 54)*(r*(12*s - 5) + 3*(1 - 2*s)**2) + k2**2*(72*r**2 + r*(72*s - 57) - 30*s + 13)) + Dd*f*(6*k1**2*(10*C*(2*s - 1)*(8*r + 8*s - 5) - 144*r*s + 70*r - 144*s**2 + 161*s - 44) + k2**2*(96*r**2 + 12*r*(8*s - 7) - 40*s + 23))))/(105*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**2*k2**2*st**4*(33*D1*bd1*f*(70*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(20*r**2 + r*(20*s - 29) - 15*s + 9) + f*k1**2*(4*k1**2*(C*(129*r*s - 48*r + 129*s**2 - 164*s + 48) - 83*r*s + 33*r - 83*s**2 + 111*s - 33) + k2**2*(-2*C*(300*r**2 + 480*r*s - 411*r + 180*s**2 - 293*s + 111) + 485*r**2 + 790*r*s - 682*r + 305*s**2 - 491*s + 197))) + 2310*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(D1*fd*(f*k2**4*r*(60*r + 60*s - 37) + 2*k1**4*(2*C*(258*r*s - 143*r + 258*s**2 - 293*s + 82) - 332*r*s + 187*r - 332*s**2 + 388*s - 111) + k1**2*k2**2*(-2*C*(600*r**2 + 960*r*s - 474*r + 360*s**2 - 340*s + 75) + 970*r**2 + 1580*r*s - 813*r + 610*s**2 - 605*s + 140)) + Dd*f*(f*k2**4*(80*r**2 + r*(80*s - 66) - 15*s + 9) + 2*k1**4*(4*C*(258*r*s - 143*r + 258*s**2 - 334*s + 106) - 664*r*s + 374*r - 664*s**2 + 887*s - 288) + k1**2*k2**2*(-2*C*(1200*r**2 + 4*r*(480*s - 317) + 720*s**2 - 898*s + 271) + 1940*r**2 + 3160*r*s - 2151*r + 1220*s**2 - 1561*s + 497))) + f**2*(D1*fd*(f*k2**4*(1680*r**2 + 2*r*(840*s - 719) - 145*s + 117) + 66*k1**4*(2*C*(165*r*s - 68*r + 165*s**2 - 165*s + 41) - 222*r*s + 91*r - 222*s**2 + 222*s - 55) - 11*k1**2*k2**2*(2*C*(882*r**2 + 1440*r*s - 843*r + 558*s**2 - 717*s + 200) - 1611*r**2 - 2682*r*s + 1587*r - 1071*s**2 + 1380*s - 393)) + Dd*f*(f*k2**4*(1680*r**2 + 2*r*(840*s - 719) - 145*s + 117) + 66*k1**4*(2*C*(4*r*(55*s - 26) + 220*s**2 - 245*s + 66) - 296*r*s + 138*r - 296*s**2 + 329*s - 88) - 11*k1**2*k2**2*(2*C*(1176*r**2 + 1920*r*s - 1210*r + 744*s**2 - 1012*s + 309) - 2148*r**2 - 3576*r*s + 2287*r - 1428*s**2 + 1955*s - 611))))/(1155*d**2*k1**2*k3**5) - 2*D1**3*Pk1*Pkd3*ct**2*st**2*(D1*bd1*f**2*(2*k1**2*(r*(60*C*s - 36*C - 31*s + 27) + s*(60*C*s - 66*C - 31*s + 32)) - k2**2*(2*r**2 + 2*r*(s - 6) + 3*s)) + 14*b1**2*(D1*fd*(k1**2*(24*C - 13)*(s - 1) + 5*k2**2*r)*(r + s - 1) + Dd*f*(k1**2*(12*C*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 52*r*s + 44*r - 52*s**2 + 87*s - 35) + 5*k2**2*r*(4*r + 4*s - 3))) + b1*f*(14*D1*bd1*(k1**2*(12*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 26*r*s + 18*r - 26*s**2 + 35*s - 9) + 5*k2**2*r*(2*r + 2*s - 1)) + D1*fd*(2*k1**2*(6*C*(20*s - 17) - 62*s + 59) + k2**2*(9 - 4*r))*(r + s - 1) + Dd*f*(2*k1**2*(6*C*(40*r*s - 34*r + 40*s**2 - 69*s + 28) - 124*r*s + 118*r - 124*s**2 + 216*s - 91) + k2**2*(-8*r**2 - 8*r*(s - 3) + 3*s - 6))))/(105*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*ct**2*(D1*bd1*f**2*(k1**2*(r**2*(36 - 72*C) + r*(-16*C*(s - 6) + 74*s - 54) + 2*s*(C*(28*s + 2) + 19*s - 31)) + 7*k2**2*r*(2*r + 2*s + 1)) + 7*b1**3*k2**2*(2*D1*fd*r*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + b1**2*(7*D1*bd1*f*k2**2*(6*r**2 + 6*r*(s - 1) - s + 1) + D1*fd*(k1**2*(140*C + 28)*(s - 1) + k2**2*(f*(60*r - 51) + 56*r - 56))*(r + s - 1) + 14*Dd*f*k1**2*(20*C*(2*s - 1)*(r + s - 1) + r*(8*s - 6) + 8*s**2 - 13*s + 5) + Dd*f*k2**2*(3*f*(40*r**2 + 8*r*(5*s - 8) - 29*s + 23) + 224*r**2 + 7*r*(32*s - 38) - 105*s + 77)) + b1*f*(D1*bd1*(14*k1**2*(r*(20*C*s + 4*s - 2) + (s - 1)*(20*C*s + 4*s - 1)) + k2**2*(3*f*(20*r**2 + r*(20*s - 27) - 12*s + 6) + 112*r**2 + 14*r*(8*s - 5) - 21*s - 7)) - D1*fd*(4*k1**2*(C*(36*r - 28*s - 25) - 18*r - 19*s + 29) - 7*k2**2*(4*r + 1))*(r + s - 1) + Dd*f*(-2*k1**2*(2*C*(72*r**2 + 8*r*(2*s - 13) - 56*s**2 + 15*s + 26) - 72*r**2 - 148*r*s + 170*r - 76*s**2 + 177*s - 89) + 7*k2**2*(8*r**2 + r*(8*s - 4) + s - 1))))/(105*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*ct**2*st**2*(b1**2*(D1*fd*(k1**4*(392*C - 210)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(r + s - 1)*(4*C*(14*r + 9*s - 9) - 39*r - 31*s + 31) + k2**4*r*(f*(156*r + 156*s - 103) - 70*r - 70*s)) + Dd*f*(14*k1**4*(8*C*(14*r*s - 13*r + 14*s**2 - 24*s + 10) + (15 - 15*s)*(4*r + 4*s - 3)) - 7*k1**2*k2**2*(8*C*(28*r**2 + 46*r*s - 34*r + 18*s**2 - 29*s + 11) - 156*r**2 - 280*r*s + 189*r - 124*s**2 + 191*s - 67) + 2*k2**4*(f*(156*r**2 + 156*r*s - 133*r - 30*s + 19) - 35*r*(4*r + 4*s - 3)))) + b1*f*(D1*bd1*(14*k1**4*(8*C*(7*r*s - 6*r + 7*s**2 - 10*s + 3) + (15 - 15*s)*(2*r + 2*s - 1)) - 7*k1**2*k2**2*(8*C*(14*r**2 + 23*r*s - 11*r + 9*s**2 - 11*s + 2) - 78*r**2 - 140*r*s + 49*r - 62*s**2 + 67*s - 5) + k2**4*(f*(156*r**2 + 156*r*s - 163*r - 60*s + 38) - 140*r*(r + s - 1))) + D1*fd*(-2*k1**4*(C*(r*(64*s - 46) + 64*s**2 - 98*s - 2) + r*(23 - 32*s) - 32*s**2 + 62*s - 2) + k1**2*k2**2*(-4*C*(39*r**2 + r*(115 - 168*s) - 207*s**2 + 207*s - 63) + 128*r**2 + r*(354 - 404*s) - 532*s**2 + 679*s - 241) + k2**4*(2*f*(3*r - 1)*(33*r + 33*s - 29) + 172*r**2 + 2*r*(86*s - 65) - 9*s + 22)) + Dd*f*(-2*k1**4*(2*C*(r*(64*s - 46) + 64*s**2 - 201*s + 88) + r*(46 - 64*s) - 64*s**2 + 249*s - 112) + k1**2*k2**2*(-2*C*(156*r**2 + r*(415 - 672*s) - 828*s**2 + 849*s - 247) + 256*r**2 + r*(604 - 808*s) - 1064*s**2 + 1242*s - 421) + k2**4*(f*(264*r**2 + r*(264*s - 298) - 74*s + 62) + 344*r**2 + 4*r*(86*s - 79) - 3*s + 16))) + f**2*(D1*bd1*(k1**4*(-4*C*(2*r*(8*s - 9) + 16*s**2 - 101*s + 54) + 4*r*(8*s - 9) + 32*s**2 - 248*s + 126) - k1**2*k2**2*(C*(78*r**2 + r*(38 - 336*s) - 414*s**2 + 270*s - 56) - 64*r**2 + r*(202*s + 13) + 266*s**2 - 122*s + 5) + k2**4*(f*(66*r**2 + r*(66*s - 58) - 8*s + 4) + 86*r**2 + 86*r*s - 93*r + 3*s - 3)) + D1*fd*(-2*k1**4*(6*C*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) - 117*r*s + 90*r - 117*s**2 + 183*s - 65) - 3*k1**2*k2**2*(4*C*(45*r**2 - 21*r*s - 38*r - 66*s**2 + 22*s + 10) - 126*r**2 + 78*r*s + 75*r + 204*s**2 - 91*s - 12) + 6*k2**4*(24*r**2 + r*(24*s - 17) - 2*s + 1)) + Dd*f*(k1**4*(-12*C*(r*(48*s - 34) + 48*s**2 - 75*s + 28) + 4*r*(78*s - 55) + 312*s**2 - 504*s + 190) - 3*k1**2*k2**2*(4*C*(60*r**2 - r*(28*s + 41) - 88*s**2 + 44*s + 10) - 168*r**2 + 2*r*(52*s + 27) + 272*s**2 - 174*s + 3) + 6*k2**4*(32*r**2 + 8*r*(4*s - 3) - 2*s + 1))))/(105*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**2*(-21*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(13*r + 23*s - 23) + 3*b1**2*(D1*(-7*bd1*f*k1**2*k2**2*(39*r**2 + r*(108*s - 95) + 69*s**2 - 115*s + 46) + 2*fd*(-28*f*k2**4*r*(3*r + 3*s - 2) + 14*k1**4*(r + s - 1)*(10*C*(r + 2*s - 2) - 5*r - 17*s + 17) + k1**2*k2**2*(70*C*(7*r**2 + 12*r*(s - 1) + 5*(s - 1)**2) + 7*K*(36*r**2 + 36*r*s - 92*r - 56*s + 46) + f*(117*r**2 + r*(818*s - 274) + 701*s**2 - 770*s + 195) - 483*r**2 - 588*r*s + 1218*r - 105*s**2 + 1008*s - 574))) + Dd*f*(28*k1**4*(10*C*(4*r**2 + 3*r*(4*s - 3) + 8*s**2 - 13*s + 5) - 20*r**2 + r*(61 - 88*s) - 68*s**2 + 108*s - 40) + k1**2*k2**2*(140*C*(28*r**2 + r*(48*s - 37) + 20*s**2 - 33*s + 13) + 28*K*(72*r**2 + 8*r*(9*s - 16) - 65*s + 51) + f*(468*r**2 + r*(3272*s - 1259) + 2804*s**2 - 3183*s + 767) - 3864*r**2 - 4704*r*s + 6314*r - 840*s**2 + 4550*s - 2814) - 14*k2**4*(2*f*(4*r - 1)*(3*r + 3*s - 2) + 10*r - 5*s))) + b1*(3*D1*bd1*f*(28*k1**4*(10*C*(2*r**2 + r*(6*s - 3) + 4*s**2 - 5*s + 1) - 10*r**2 + r*(17 - 44*s) - 34*s**2 + 40*s - 6) + k1**2*k2**2*(140*C*(14*r**2 + r*(24*s - 13) + 10*s**2 - 13*s + 3) + 28*K*(36*r**2 + 36*r*s - 50*r - 23*s + 14) + f*(234*r**2 + r*(1636*s - 711) + 1402*s**2 - 1643*s + 377) - 1932*r**2 - 2352*r*s + 2002*r - 420*s**2 + 1316*s - 658) - 14*k2**4*(2*f*(2*r - 1)*(3*r + 3*s - 2) + 5*r - 5*s)) - 6*D1*(f**2*fd*k2**2*(-k1**2*(525*r**2 + r*(1443*s - 1195) + 918*s**2 - 1600*s + 690) + 6*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + f*(-fd*(2*k1**4*(C*(24*r**2 + 10*r*(6*s - 25) + 36*s**2 - 388*s + 254) - 12*r**2 - 5*r*(6*s - 25) - 18*s**2 + 234*s - 147) + k1**2*k2**2*(28*C*(13*r**2 + 2*r*(s - 9) - 11*s**2 - 2*s + 7) - 2*K*(150*r**2 + 206*r*s - 199*r + 56*s**2 - 166*s + 62) + 184*r**2 + 1056*r*s - 163*r + 872*s**2 - 696*s + 25) + 7*k2**4*(4*r**2 + r*(4*s - 2) + s)) + 14*k1**2*k2**2*(bd2*(4*r + 4*s + 1) + 4*gd2*(9*r - 7))*(r + s - 1)) + 14*fd*k1**2*k2**2*(b2*(4*r**2 + r*(8*s + 2) + 4*s**2 + 2*s - 1) + 2*g2*(18*r**2 + 2*r*(9*s - 23) - 28*s + 23))) + 2*Dd*f*(f**2*k2**2*(k1**2*(2100*r**2 + r*(5772*s - 4739) + 3672*s**2 - 6224*s + 2526) - 18*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 3*f*(8*k1**4*(C*(12*r**2 + 10*r*(3*s - 8) + 18*s**2 - 164*s + 93) - 6*r**2 - 5*r*(3*s - 8) - 9*s**2 + 99*s - 55) + 2*k1**2*k2**2*(7*C*(52*r**2 + r*(8*s - 35) - 44*s**2 + 17*s + 7) - K*(300*r**2 + 412*r*s - 433*r + 112*s**2 - 340*s + 180) + 184*r**2 + 1056*r*s - 500*r + 872*s**2 - 937*s + 232) + 7*k2**4*(8*r**2 + 8*r*(s - 1) + s)) - 42*k1**2*k2**2*(b2*(16*r**2 + 8*r*(4*s - 1) + 16*s**2 - 8*s - 3) + 2*g2*(72*r**2 + 8*r*(9*s - 16) - 65*s + 51)))) + 2*f*(D1*bd1*(f**2*k2**2*(k1**2*(525*r**2 + r*(1443*s - 1154) + 918*s**2 - 1424*s + 456) - 18*k2**2*r*(3*r + 3*s - 2)) + 3*f*(2*k1**4*(2*C*(6*r**2 + r*(15*s + 2) + 9*s**2 - 52*s - 14) - 6*r**2 - r*(15*s + 2) - 9*s**2 + 63*s + 17) + k1**2*k2**2*(14*C*(13*r**2 + r*(2*s + 7) - 11*s**2 + 11*s - 8) - 2*K*(75*r**2 + 103*r*s - 117*r + 28*s**2 - 87*s + 59) + 92*r**2 + 528*r*s - 443*r + 436*s**2 - 540*s + 237) + 7*k2**4*r*(2*r + 2*s - 3)) - 84*k1**2*k2**2*(2*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*g2*(2*r**2 + 2*r*(s - 1) - s))) + k1**2*(D1*(f*(fd*(-2*k1**2*(4*C*(180*r**2 + 9*r*(38*s - 29) + 162*s**2 - 204*s + 79) - 360*r**2 - 909*r*s + 597*r - 549*s**2 + 624*s - 205) - 9*k2**2*(4*C*(36*r**2 + 90*r*s - 54*r + 54*s**2 - 57*s + 17) - 159*r**2 - 420*r*s + 235*r - 261*s**2 + 276*s - 77)) + k2**2*(-6*bd2 + 12*gd2)*(75*r**2 + r*(103*s - 117) + 28*s**2 - 87*s + 59)) - 6*fd*k2**2*(b2 - 2*g2)*(150*r**2 + r*(206*s - 199) + 56*s**2 - 166*s + 62)) + Dd*f*(f*(-2*k1**2*(4*C*(240*r**2 + 456*r*s - 384*r + 216*s**2 - 298*s + 119) - 480*r**2 - 1212*r*s + 908*r - 732*s**2 + 929*s - 327) - 9*k2**2*(8*C*(24*r**2 + 60*r*s - 40*r + 36*s**2 - 42*s + 13) - 212*r**2 - 560*r*s + 367*r - 348*s**2 + 415*s - 129)) + k2**2*(-6*b2 + 12*g2)*(300*r**2 + r*(412*s - 433) + 112*s**2 - 340*s + 180)))))/(315*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**2*st**2*(33*D1*bd1*f*(2*f**2*k2**4*(k1**2*(168*r**2 + r*(390*s - 257) + 222*s**2 - 337*s + 79) - 3*k2**2*(r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**4*(4*C*(r*(25*s - 36) + 25*s**2 - 88*s + 36) + r*(81 - 51*s) - 51*s**2 + 198*s - 81) + k1**2*k2**2*(2*C*(125*r**2 + r*(224 - 326*s) - 451*s**2 + 628*s - 349) - 236*r**2 + r*(244*s - 215) + 480*s**2 - 731*s + 451) + k2**4*(14*C*(151*r**2 + 5*r*(46*s - 41) + 79*s**2 - 139*s + 54) - 105*K*r**2 - 182*K*r*s + 28*K*r - 77*K*s**2 + 56*K*s + 21*K + b1*(354*r**2 + r*(666*s - 412) + 312*s**2 - 342*s + 44) - 1941*r**2 - 3070*r*s + 2803*r - 1129*s**2 + 2005*s - 834)) - 7*k1**2*k2**2*(30*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(55 - 90*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(50*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(86*r**2 + 120*r*s - 83*r + 34*s**2 - 27*s - 5) - 122*r**2 - 216*r*s + 175*r - 94*s**2 + 131*s - 45)) + 2*k2**2*(15*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(-43*r**2 + r*(43 - 60*s) + s*(15 - 17*s))))) - 6930*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(630*C - 385)*(r + s - 1)**2 - k2**2*(350*C*(r + s - 1)**2 + 7*K*(43*r**2 + 60*r*s + 10*r + 17*s**2 + 10*s - 5) - f*(354*r**2 + r*(666*s - 325) + 312*s**2 - 297*s + 93) - 427*r**2 - 756*r*s + 630*r - 329*s**2 + 630*s - 315)) + Dd*f*(k1**2*(630*C - 385)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-350*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(172*r**2 + 240*r*s - 113*r + 68*s**2 - 29*s - 15) + f*(708*r**2 + r*(1332*s - 737) + 624*s**2 - 639*s + 137) + 1708*r**2 + 3024*r*s - 2653*r + 1316*s**2 - 2191*s + 945))) + 33*b1*(D1*(6*f**2*fd*k2**4*(k1**2*(168*r**2 + 390*r*s - 203*r + 222*s**2 - 252*s + 75) - 3*k2**2*r*(5*r + 5*s - 3)) + f*k1**2*(fd*(2*k1**4*(4*C*(r*(50*s - 53) + 50*s**2 - 113*s + 44) - 3*r*(34*s - 38) - 102*s**2 + 249*s - 99) + k1**2*k2**2*(2*C*(250*r**2 + r*(831 - 652*s) - 902*s**2 + 1561*s - 515) - 472*r**2 + 488*r*s - 1127*r + 960*s**2 - 2144*s + 792) + k2**4*(28*C*(151*r**2 + r*(230*s - 113) + 79*s**2 - 74*s + 16) - 7*K*(30*r**2 + 52*r*s + 15*r + 22*s**2 - s - 15) - 3882*r**2 - 6140*r*s + 3357*r - 2258*s**2 + 2370*s - 631)) + 14*k2**4*(-15*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(43*r**2 + 20*r*(3*s - 2) + 17*s**2 - 12*s - 5))) + 14*fd*k1**2*k2**4*(-15*b2*(r + s)**2 + g2*(43*r**2 + 10*r*(6*s + 1) + 17*s**2 + 10*s - 5))) + Dd*f*(2*f**2*k2**4*(k1**2*(672*r**2 + 2*r*(780*s - 433) + 888*s**2 - 1093*s + 304) - 3*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**4*(8*C*(r*(50*s - 53) + 50*s**2 - 135*s + 62) - 3*r*(68*s - 76) - 204*s**2 + 597*s - 279) + k1**2*k2**2*(2*C*(500*r**2 + r*(1697 - 1304*s) - 1804*s**2 + 3235*s - 1459) - 944*r**2 + 976*r*s - 2178*r + 1920*s**2 - 4227*s + 2115) + k2**4*(14*C*(604*r**2 + r*(920*s - 613) + 316*s**2 - 403*s + 123) - 7*K*(60*r**2 + 104*r*s + 7*r + 44*s**2 - 17*s - 21) - 7764*r**2 - 12280*r*s + 8725*r - 4516*s**2 + 6142*s - 2103)) + 14*k1**2*k2**4*(-15*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(172*r**2 + r*(240*s - 113) + 68*s**2 - 29*s - 15)))) + f*(D1*(f**2*fd*k2**4*(k1**2*(20700*r**2 + r*(29148*s - 28543) + 8448*s**2 - 22401*s + 11287) - 66*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(-45*bd2*k2**4*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) + 6*fd*k1**4*(2*C*(9*r*(14*s - 11) + 126*s**2 - 204*s + 73) - 27*r*(5*s - 4) - 135*s**2 + 225*s - 81) + fd*k1**2*k2**2*(4*C*(531*r**2 - 9*r*(115*s + 21) - 1566*s**2 + 831*s + 16) - 1773*r**2 + 18*r*(95*s + 33) + 3483*s**2 - 1848*s + 38) + 9*fd*k2**4*(4*C*(246*r**2 + r*(366*s - 236) + 120*s**2 - 155*s + 49) - 945*r**2 + r*(955 - 1470*s) - 525*s**2 + 679*s - 218) + 42*gd2*k2**4*(15*r**2 + r*(26*s - 4) + 11*s**2 - 8*s - 3)) - 33*fd*k1**2*k2**4*(15*b2*(10*r**2 + r*(20*s - 3) + 10*s**2 - 3*s - 1) - 14*g2*(30*r**2 + r*(52*s + 15) + 22*s**2 - s - 15))) + Dd*f*(f**2*k2**4*(k1**2*(20700*r**2 + r*(29148*s - 28543) + 8448*s**2 - 22401*s + 11287) - 66*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(6*k1**4*(C*(4*r*(84*s - 59) + 336*s**2 - 558*s + 212) - 18*r*(10*s - 7) - 180*s**2 + 306*s - 117) + k1**2*k2**2*(4*C*(708*r**2 - 1380*r*s + 57*r - 2088*s**2 + 1466*s - 97) - 2364*r**2 + 2280*r*s - 63*r + 4644*s**2 - 3377*s + 406) + 9*k2**4*(4*C*(328*r**2 + 488*r*s - 332*r + 160*s**2 - 215*s + 69) - 1260*r**2 - 1960*r*s + 1349*r - 700*s**2 + 949*s - 313)) - 33*k1**2*k2**4*(15*b2*(20*r**2 + r*(40*s - 11) + 20*s**2 - 11*s - 3) - 14*g2*(60*r**2 + r*(104*s + 7) + 44*s**2 - 17*s - 21)))))/(3465*d**2*k1**2*k3**5) + D1**3*Pk1*Pkd3*ct*f*k2**5*st**6*(11*D1*bd1*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(r + s - 1) + 11*b1*(D1*fd*(f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + k1**2*(72*C - 54)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(180*r**2 + r*(360*s - 259) + 180*s**2 - 259*s + 93) + k1**2*(88*C - 66)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(45*r + 45*s - 31) + k1**2*(88*C - 66)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(77*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct*f*k2**3*st**6*(9*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(63*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct*f*k2**3*st**6*(9*D1*bd1*f*(k1**2*(8*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(-4*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9)) + 9*b1*(D1*fd*(k1**2*(16*C - 12)*(2*s - 1) + k2**2*(r*(26 - 16*C) + 10*s - 5))*(2*r + 2*s - 1) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(C*(-64*r**2 + r*(48 - 64*s) + 8*s - 4) + 104*r**2 + 2*r*(72*s - 49) + 40*s**2 - 58*s + 19))) + f*(D1*fd*(k1**2*(16*C - 12)*(3*s - 1) + k2**2*(-24*C*r + 8*C + 39*r + 15*s - 18))*(3*r + 3*s - 2) + Dd*f*(k1**2*(8*C - 6)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(-4*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 156*r**2 + 216*r*s - 181*r + 60*s**2 - 113*s + 50))))/(63*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*(k1**2*(-14*C*(r + s - 1) - 24*K*r - 24*K*s + 12*K + b1*(8*r + 8*s - 4) + 11*r + 11*s - 9) + 7*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(-168*b1*k1**2*(6*K - 1) - 420*b1*k2**2*(4*K - 1) + 336*g2*(3*k1**2 + 5*k2**2))) + 3*b1**2*(D1*fd*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5))) + Dd*f*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5)) + (r + s)*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 6*f*(3*fd*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s))*(2*r + 2*s - 1) - 56*gd2*(3*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 336*fd*g2*(3*k1**2 + 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - 18*f*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s)) + 336*g2*(3*k1**2 + 5*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 9*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 8*gd2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))*(r + s - 1) - 72*fd*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(r + s - 1) + f*k1**2*(90*C - 45)*(r + s - 1) - 72*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))))/(35*d**2*k3**7) - D1**3*Pk1*Pkd3*ct*k1*k2*st**2*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 32*K*r - 32*K*s - 12*K + 3*b1*(r + s - 11) - 181*r - 181*s + 129) - 7*k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) + 28*k2**2*(r + s)*(b1*k1**2*(1 - 4*K) + 5*b1*k2**2*(2*K - 1) + 2*g2*(2*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K))) + Dd*f*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7)) + (r + s)*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K)))*(4*r + 4*s - 3)) + 33*b1*(D1*(f**2*fd*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 2*f*(fd*(2*r + 2*s - 1)*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 28*gd2*k2**2*(2*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 56*fd*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 56*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 12*gd2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 264*fd*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5)) + 22*f*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 264*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(385*d**2*k3**7) + D1**3*Pk1*Pkd3*ct*k1*(105*b1**3*k2**2*(4*k1**2 + 15*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(35*D1*bd1*f*(4*k1**2 + 15*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - D1*fd*(2*k1**2*(350*C*(r + s - 1)**2 - 56*K*(14*r**2 + 2*r*(14*s + 5) + 14*s**2 + 10*s - 5) + f*(252*r**2 + 840*r*s - 370*r + 588*s**2 - 510*s + 78) - 7*r**2 + 98*r*(s + 5) + 105*s**2 + 490*s - 245) + 7*k2**2*(f*(216*r**2 + r*(480*s - 241) + 264*s**2 - 257*s + 55) + (-20*r - 20*s)*(r*(12*K - 6) + s*(9*K - 5)))) - 2*Dd*f*(k1**2*(350*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 56*K*(56*r**2 + 112*r*s - 22*r + 56*s**2 - 22*s - 15) + 2*f*(252*r**2 + r*(840*s - 493) + 588*s**2 - 675*s + 193) - 28*r**2 + 392*r*s + 889*r + 420*s**2 + 721*s - 735) + 7*k2**2*(f*(216*r**2 + 10*r*(48*s - 31) + 264*s**2 - 326*s + 101) - 10*r**2*(48*K - 24) - 40*r*(3*K*(7*s - 3) - 11*s + 5) - 10*s*(9*K*(4*s - 3) - 20*s + 14)))) - b1*(3*D1*(f**2*k2**2*(56*bd1*k1**2*(9*r**2 + r*(30*s - 22) + 21*s**2 - 30*s + 11) + 7*bd1*k2**2*(216*r**2 + r*(480*s - 379) + 264*s**2 - 395*s + 147) + 4*fd*k1**2*(240*r**2 + 4*r*(135*s - 91) + 300*s**2 - 404*s + 137) + 3*fd*k2**2*(693*r**2 + r*(1218*s - 835) + 525*s**2 - 679*s + 248)) - 2*f*(fd*(k1**4*(28*C - 14)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(14*C*(40*r**2 + r*(116*s - 57) + 76*s**2 - 83*s + 15) + 2*K*(948*r**2 + 26*r*(66*s - 37) + 768*s**2 - 907*s + 244) - 730*r**2 - 1888*r*s + 877*r - 1158*s**2 + 1210*s - 256) + 14*k2**4*(r**2*(74*K - 36) + r*(K*(124*s - 37) - 64*s + 18) + 2*s*(K*(25*s - 14) - 14*s + 6))) - 7*k2**2*(bd1*(k1**2*(50*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 8*K*(28*r**2 + 56*r*s - 23*r + 28*s**2 - 23*s - 5) - 2*r**2 + 28*r*s + 29*r + 30*s**2 + 13*s - 35) - 10*k2**2*(r**2*(24*K - 12) + r*(6*K*(7*s - 4) - 22*s + 13) + s*(18*K*(s - 1) - 10*s + 9))) + (2*r + 2*s - 2)*(-5*bd2*(4*k1**2 + 5*k2**2)*(r + s) + 8*gd2*k1**2*(14*r + 14*s + 5) + 30*gd2*k2**2*(4*r + 3*s)))) + 28*fd*k2**2*(-5*b2*(4*k1**2 + 5*k2**2)*(r + s)**2 + 8*g2*k1**2*(14*r**2 + 2*r*(14*s + 5) + 14*s**2 + 10*s - 5) + 30*g2*k2**2*(4*r**2 + 7*r*s + 3*s**2))) + Dd*f*(f**2*k2**2*(4*k1**2*(960*r**2 + 16*r*(135*s - 101) + 1200*s**2 - 1786*s + 667) + 9*k2**2*(924*r**2 + r*(1624*s - 1193) + 700*s**2 - 985*s + 355)) - 6*f*(k1**4*(56*C - 28)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(28*C*(40*r**2 + 2*r*(58*s - 41) + 76*s**2 - 105*s + 37) + 2*K*(1896*r**2 + 4*r*(858*s - 577) + 1536*s**2 - 2153*s + 722) - 1460*r**2 - 3776*r*s + 2389*r - 2316*s**2 + 3022*s - 966) + 14*k2**4*(r**2*(148*K - 72) + r*(K*(248*s - 105) - 128*s + 58) + 2*s*(K*(50*s - 39) - 28*s + 20))) + 84*k2**2*(4*r + 4*s - 3)*(-5*b2*(4*k1**2 + 5*k2**2)*(r + s) + 8*g2*k1**2*(14*r + 14*s + 5) + 30*g2*k2**2*(4*r + 3*s)))) + f*(D1*(f**2*k2**2*(-8*bd1*k1**2*(120*r**2 + r*(270*s - 262) + 150*s**2 - 287*s + 128) - 9*bd1*k2**2*(231*r**2 + r*(406*s - 358) + 175*s**2 - 306*s + 107) + 20*fd*k1**2*(14*r*(4*s - 3) + 56*s**2 - 83*s + 31) + 40*fd*k2**2*(20*r**2 + r*(92*s - 61) + 72*s**2 - 97*s + 33)) + 6*f*(14*bd1*k1**4*s*(2*C - 1)*(3*r + 3*s - 1) + bd1*k1**2*k2**2*(14*C*(20*r**2 + r*(58*s - 49) + 38*s**2 - 59*s + 29) + 2*K*(474*r**2 + 858*r*s - 673*r + 384*s**2 - 623*s + 239) - 365*r**2 - 944*r*s + 700*r - 579*s**2 + 850*s - 327) + 14*bd1*k2**4*(r**2*(37*K - 18) + r*(K*(62*s - 34) - 32*s + 20) + s*(25*K - 14)*(s - 1)) + 30*bd2*k2**2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(r + s - 1) + fd*k1**4*(12*C - 6)*(3*s - 1)*(5*r + 5*s - 3) + 3*fd*k1**2*k2**2*(C*(354*r**2 + 852*r*s - 598*r + 498*s**2 - 690*s + 240) - 192*r**2 + r*(320 - 474*s) - 282*s**2 + 389*s - 131) - 4*gd2*k2**2*(k1**2*(474*r**2 + r*(858*s - 673) + 384*s**2 - 623*s + 239) + 7*k2**2*(37*r**2 + r*(62*s - 34) + s*(25*s - 25)))) + 12*k2**2*(5*b2*(7*bd1*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*fd*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) - 2*g2*(7*bd1*(56*k1**2*(r + s) + 15*k2**2*(4*r + 3*s))*(r + s - 1) + fd*(k1**2*(948*r**2 + 26*r*(66*s - 37) + 768*s**2 - 907*s + 244) + 7*k2**2*(74*r**2 + r*(124*s - 37) + 2*s*(25*s - 14)))))) + 2*Dd*f*(10*f**2*k2**2*(k1**2*(14*r*(4*s - 3) + 56*s**2 - 83*s + 31) + 2*k2**2*(20*r**2 + r*(92*s - 61) + 72*s**2 - 97*s + 33)) + 9*f*k1**2*(k1**2*(8*C - 4)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(2*C*(236*r**2 + 568*r*s - 441*r + 332*s**2 - 499*s + 191) - 256*r**2 - 632*r*s + 478*r - 376*s**2 + 565*s - 213)) + 6*k2**2*(15*b2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(4*r + 4*s - 3) - 2*g2*(k1**2*(1896*r**2 + 4*r*(858*s - 577) + 1536*s**2 - 2153*s + 722) + 7*k2**2*(148*r**2 + r*(248*s - 105) + 2*s*(50*s - 39)))))))/(315*d**2*k2*k3**5) - 3*D1**3*Pk1*Pkd3*ct*k2**3*st**4*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(b1*(-51*r - 51*s + 29) - (28*C - 2*K - 20)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(168*K*b1 - 84*b1 - 168*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(102*r**2 + r*(204*s - 109) + 102*s**2 - 109*s + 29) + (14 - 28*K)*(r + s)**2) + Dd*f*(f*(51*r + 51*s - 29) + (14 - 28*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(fd*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1)) - 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-691*r - 691*s + 433) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k2**2*(9 - 12*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 12*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 264*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*(k1**2*k2**2*(691*r + 691*s - 433) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k1**2*k2**2*(9 - 12*C)*(2*r + 2*s - 1)) - 264*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct*k2*st**4*(D1*bd1*f**2*(r*(4*s - 1) + s*(4*s - 3)) + 7*b1**2*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1*f*(7*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*s - 1)*(4*D1*fd*(r + s - 1) + Dd*f*(8*r + 8*s - 7))))/(35*d**2*k1*k3) - 2*D1**3*Pk1*Pkd3*ct*k2*st**4*(-21*b1**2*(D1*fd*(k1**2*(16*C - 12)*(s - 1) + k2**2*(r*(9 - 8*C) + s - 1))*(r + s - 1) + Dd*f*(k1**2*(8*C - 6)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(-4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 36*r**2 + r*(40*s - 39) + 4*s**2 - 11*s + 7))) - 3*b1*f*(7*D1*bd1*(k1**2*(8*C - 6)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k2**2*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*r**2 + r*(20*s - 19) + 2*s**2 - 7*s + 5)) + D1*fd*(-2*k1**2*(2*C*(48*r*s - 31*r + 48*s**2 - 54*s + 15) - 50*r*s + 32*r - 50*s**2 + 59*s - 17) + k2**2*(-16*C*(2*r - 1)*(r + s - 1) + 20*r**2 - 44*r*s - 7*r - 64*s**2 + 44*s + 3)) + Dd*f*(-2*k1**2*(2*C*(96*r*s - 62*r + 96*s**2 - 135*s + 47) - 100*r*s + 64*r - 100*s**2 + 153*s - 55) + k2**2*(-4*C*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 40*r**2 - 88*r*s + 12*r - 128*s**2 + 91*s - 8))) + f**2*(6*D1*bd1*(k1**2*(C*(48*r*s - 26*r + 48*s**2 - 80*s + 30) - 25*r*s + 15*r - 25*s**2 + 49*s - 18) + k2**2*(r**2*(8*C - 5) + r*(8*C*s - 6*C + 11*s + 3) - s*(2*C - 16*s + 2))) + D1*fd*(6*k1**2*(8*C*(r*(12*s - 5) + 3*(1 - 2*s)**2) - 57*r*s + 23*r - 57*s**2 + 57*s - 14) + k2**2*(8*C*(18*r**2 + 6*r*(3*s - 4) - 9*s + 7) + 90*r*s - 9*r + 90*s**2 - 108*s + 19)) + Dd*f*(12*k1**2*(C*(64*r*s - 30*r + 64*s**2 - 71*s + 19) - 38*r*s + 17*r - 38*s**2 + 42*s - 11) + k2**2*(4*C*(48*r**2 + 48*r*s - 66*r - 23*s + 19) + 120*r*s - 38*r + 120*s**2 - 167*s + 48))))/(105*d**2*k1*k3**3) + D1**3*Pk1*Pkd3*ct*k2*st**4*(11*D1*bd1*f*(f**2*k2**4*(366*r**2 + r*(636*s - 521) + 270*s**2 - 509*s + 159) + 3*f*(4*k1**4*(14*C*(r*(6*s - 3) + 6*s**2 - 10*s + 3) + r*(24 - 47*s) - 47*s**2 + 82*s - 24) + 2*k1**2*k2**2*(-2*C*(133*r**2 + r*(286*s - 232) + 153*s**2 - 212*s + 99) + 176*r**2 + r*(388*s - 323) + 212*s**2 - 287*s + 147) + k2**4*(56*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 4*K*(-4*r**2 - 4*r*s + 4*r + s - 1) + 5*b1*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 19) - 328*r**2 - 448*r*s + 444*r - 120*s**2 + 288*s - 112)) + 42*k2**2*(b1*(k1**2*(20*C - 15)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k2**2*(r**2*(9 - 4*K) + r*(K*(3 - 4*s) + 14*s - 8) + s*(K + 5*s - 6))) + 4*g2*k2**2*(2*r**2 + 2*r*(s - 1) - s))) + 33*b1**2*k2**2*(D1*fd*(k1**2*(280*C - 210)*(r + s - 1)**2 + k2**2*(5*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + (r + s)*(-14*r*(4*K - 9) + 70*s))) + 2*Dd*f*(k1**2*(140*C - 105)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(5*f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 24) - 7*r**2*(16*K - 36) - 7*r*(16*K*s - 8*K - 56*s + 23) - 7*s*(-2*K - 20*s + 17)))) + 11*b1*(3*D1*(f**2*fd*k2**4*(366*r**2 + r*(636*s - 427) + 270*s**2 - 399*s + 155) + 2*f*(fd*(2*k1**4*(14*C*(r*(12*s - 7) + 12*s**2 - 16*s + 5) + r*(54 - 94*s) - 94*s**2 + 129*s - 41) + k1**2*k2**2*(-2*C*(266*r**2 + r*(572*s - 323) + 306*s**2 - 315*s + 71) + 352*r**2 + r*(776*s - 475) + 424*s**2 - 462*s + 110) + 2*k2**4*(2*r + 2*s - 1)*(K*(2 - 4*r) + r*(56*C - 82) - 30*s + 13)) + 28*gd2*k2**4*r*(2*r + 2*s - 1)) + 112*fd*g2*k2**4*r*(r + s)) + 2*Dd*f*(f**2*k2**4*(732*r**2 + 53*r*(24*s - 17) + 540*s**2 - 853*s + 312) + 3*f*(2*k1**4*(14*C*(2*r*(12*s - 7) + 24*s**2 - 37*s + 13) - 4*r*(47*s - 27) - 188*s**2 + 299*s - 106) + k1**2*k2**2*(-2*C*(532*r**2 + 13*r*(88*s - 63) + 612*s**2 - 771*s + 261) + 704*r**2 + 2*r*(776*s - 593) + 848*s**2 - 1101*s + 397) + 2*k2**4*(14*C*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) - 2*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 328*r**2 - 448*r*s + 302*r - 120*s**2 + 172*s - 55)) + 84*g2*k2**4*(8*r**2 + r*(8*s - 4) - s))) + 2*f*(D1*(2*f**2*fd*k2**4*(1076*r**2 + r*(856*s - 801) - 220*s**2 + 248*s - 43) + 11*f*(fd*(6*k1**4*(4*C*(33*r*s - 13*r + 33*s**2 - 33*s + 8) - 75*r*s + 29*r - 75*s**2 + 75*s - 18) + k1**2*k2**2*(-2*C*(603*r**2 + 1206*r*s - 609*r + 603*s**2 - 687*s + 164) + 837*r**2 + 1638*r*s - 885*r + 801*s**2 - 966*s + 253) + 3*k2**4*(4*C*(12*r**2 + 12*r*s - 9*r - 2*s + 1) - 78*r**2 - 108*r*s + 71*r - 30*s**2 + 43*s - 14)) + 12*gd2*k2**4*(4*r**2 + 4*r*(s - 1) - s + 1)) + 264*fd*g2*k2**4*(2*r - 1)*(2*r + 2*s - 1)) + Dd*f*(2*f**2*k2**4*(1076*r**2 + r*(856*s - 801) - 220*s**2 + 248*s - 43) + 11*f*(12*k1**4*(C*(88*r*s - 38*r + 88*s**2 - 97*s + 25) - 50*r*s + 21*r - 50*s**2 + 55*s - 14) + k1**2*k2**2*(-2*C*(804*r**2 + 1608*r*s - 903*r + 804*s**2 - 995*s + 271) + 1116*r**2 + 2184*r*s - 1319*r + 1068*s**2 - 1400*s + 420) + 3*k2**4*(C*(64*r**2 + 64*r*s - 48*r - 8*s + 4) - 104*r**2 - 144*r*s + 98*r - 40*s**2 + 58*s - 19)) + 264*g2*k2**4*(8*r**2 + 8*r*(s - 1) - 3*s + 2))))/(1155*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct*st**2*(D1*bd1*f**2*(k1**2*(4*C - 2)*(r*(s - 9) + s*(s + 1)) + k2**2*(r**2*(60*C - 49) + 4*r*(15*C*s - 13*C - 5*s + 10) + s*(-36*C + 29*s - 27))) + 7*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*(-3*r + 11*s - 11))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) - k2**2*(12*r**2 - 32*r*s + r - 44*s**2 + 60*s - 16))) + b1*f*(7*D1*bd1*(k1**2*(4*C - 2)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + k2**2*(-6*r**2 + r*(16*s + 15) + 22*s**2 - 16*s - 6)) + D1*fd*(k1**2*(8*C - 4)*(s - 4) + k2**2*(8*C*(15*r - 11) - 98*r + 58*s + 13))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(4*r*(s - 4) + 4*s**2 - 9*s + 7) + k2**2*(4*C*(60*r**2 + 60*r*s - 89*r - 40*s + 31) - 196*r**2 - 80*r*s + 173*r + 116*s**2 - 128*s + 14))))/(105*d**2*k1*k2*k3) + 2*D1**3*Pk1*Pkd3*ct*(-7*D1*bd1*f*(6*b2*k2**2*(2*r**2 + 2*r*(s - 1) - s) + f*(k1**2*s*(12*C - 6)*(r + s - 1) + k2**2*(r**2*(4*C - 5) + 2*r*(2*C*(s - 1) - 6*s + 1) - s*(7*s - 7))) + 12*g2*k2**2*(-2*r**2 - 2*r*(s - 1) + s)) + 14*b1**3*k2**2*(D1*fd*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) + Dd*f*(4*r**2 + r*(24*s - 19) + 20*s**2 - 33*s + 13)) + b1**2*(14*D1*bd1*f*k2**2*(3*r**2 + r*(18*s - 13) + 15*s**2 - 23*s + 8) + D1*fd*(k1**2*(70 - 140*C)*(s - 1) + k2**2*(-84*K*(r - 1) + 6*f*(10*r + 14*s - 19) + 91*r + 133*s - 161))*(r + s - 1) + Dd*f*k1**2*(140 - 280*C)*(2*s - 1)*(r + s - 1) + Dd*f*k2**2*(-42*K*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 6*f*(20*r**2 + r*(48*s - 53) + 28*s**2 - 60*s + 29) + 364*r**2 + 896*r*s - 679*r + 532*s**2 - 896*s + 350)) + b1*(D1*(6*bd1*f**2*k2**2*(10*r**2 + 24*r*(s - 1) + 14*s**2 - 27*s + 10) - 7*f*(20*bd1*k1**2*s*(2*C - 1)*(r + s - 1) + bd1*k2**2*(6*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 26*r**2 + r*(27 - 64*s) - 38*s**2 + 46*s - 6) + fd*(k1**2*(12*C - 6)*(2*s - 1) + k2**2*(C*(8*r - 4) - 10*r - 14*s + 9))*(r + s - 1) + k2**2*(6*bd2 - 12*gd2)*(2*r - 1)*(r + s - 1)) - 84*fd*k2**2*(b2 - 2*g2)*(r - 1)*(r + s - 1)) - 7*Dd*f*(f*(k1**2*(24*C - 12)*(2*s - 1)*(r + s - 1) + k2**2*(4*C*(4*r - 1)*(r + s - 1) - 20*r**2 - 48*r*s + 33*r - 28*s**2 + 44*s - 16)) + k2**2*(6*b2 - 12*g2)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))))/(105*d**2*k1*k2*k3) + D1**3*Pk1*Pkd3*ct*st**2*(21*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(7*bd1*f*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*fd*(k1**4*(28*C - 14)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(r + s - 1)*(10*C*r + 54*C*(s - 1) - 7*r - 43*s + 43) + k2**4*(-28*K*(r - 1)*(r + s - 1) + f*(255*r**2 + r*(438*s - 220) + 183*s**2 - 252*s + 83) + 7*r**2*(40*C - 31) + 7*r*(40*C*(s - 1) - 26*s + 40) + 7*s*(5*s + 4)))) + Dd*f*(k1**4*(56*C - 28)*(4*r*(s - 2) + 4*s**2 - 9*s + 5) - 14*k1**2*k2**2*(2*C*(20*r**2 + r*(128*s - 71) + 108*s**2 - 163*s + 55) - 28*r**2 + r*(107 - 200*s) - 172*s**2 + 258*s - 86) + k2**4*(280*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 28*K*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + f*(1020*r**2 + 3*r*(584*s - 387) + 732*s**2 - 1201*s + 425) - 1736*r**2 - 1456*r*s + 2198*r + 280*s**2 + 14*s - 336))) + 3*b1*(D1*bd1*f*(k1**4*(56*C - 28)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) - 14*k1**2*k2**2*(2*C*(10*r**2 + r*(64*s - 7) + 54*s**2 - 55*s + 1) - 14*r**2 + r*(7 - 100*s) - s*(86*s - 86)) + k2**4*(280*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + f*(510*r**2 + r*(876*s - 721) + 366*s**2 - 697*s + 259) - 868*r**2 - 728*r*s + 1036*r + 140*s**2 - 308)) + 2*D1*(12*f**2*fd*k2**4*(24*r**2 + 4*r*(6*s - 7) - 8*s + 7) + f*(fd*(k1**4*(4*C - 2)*(13*s - 3) + k1**2*k2**2*(-4*C*(39*r**2 + r*(10*s + 89) - 29*s**2 + 101*s - 65) + 76*r**2 + 116*r*s + 227*r + 40*s**2 + 230*s - 170) + k2**4*(28*C*(4*r - 1)*(r + s - 1) - 2*K*(30*r**2 + 30*r*s - 51*r - 22*s + 18) + 212*r**2 + 448*r*s - 156*r + 236*s**2 - 175*s + 25)) + 28*gd2*k2**4*(2*r - 1)*(r + s - 1)) + 56*fd*g2*k2**4*(r - 1)*(r + s - 1)) + 2*Dd*f*(4*f**2*k2**4*(96*r**2 + 2*r*(48*s - 53) - 25*s + 21) + f*(k1**4*(96*C - 48)*(2*s - 1) + 2*k1**2*k2**2*(-C*(156*r**2 + r*(40*s + 171) - 116*s**2 + 325*s - 191) + 76*r**2 + 116*r*s + 111*r + 40*s**2 + 154*s - 134) + k2**4*(28*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*K*(60*r**2 + 60*r*s - 109*r - 40*s + 36) + 424*r**2 + 896*r*s - 472*r + 472*s**2 - 411*s + 67)) + 28*g2*k2**4*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 2*f*(3*D1*bd1*(4*f**2*k2**4*(24*r**2 + r*(24*s - 22) - s) + f*(k1**4*(4*C - 2)*(23*s - 9) + k1**2*k2**2*(r**2*(38 - 78*C) + r*(C*(86 - 20*s) + 58*s - 31) + 2*s**2*(29*C + 10) + 2*s*(8 - 33*C) - 16) + 2*k2**4*(K*(-15*r**2 - 15*r*s + 29*r + 9*s - 9) + r**2*(28*C + 53) + 2*r*(14*C*s - 7*C + 56*s - 36) + 59*s**2 - 45*s + 7)) + 28*g2*k2**4*(2*r**2 + 2*r*(s - 1) - s)) + D1*(f*(fd*(k1**4*(6 - 12*C)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + k1**2*k2**2*(-36*C*(45*r**2 + r*(9*s - 35) - 36*s**2 + 8*s + 7) + 927*r**2 + 9*r*(40*s - 69) - 567*s**2 + 132*s + 83) - 9*k2**4*(4*C*(3*r - 1)*(2*r + 2*s - 1) - 84*r**2 - 9*r*(14*s - 9) - 42*s**2 + 48*s - 15)) + k2**4*(-6*bd2 + 12*gd2)*(15*r**2 + r*(15*s - 29) - 9*s + 9)) - 6*fd*k2**4*(b2 - 2*g2)*(30*r**2 + r*(30*s - 51) - 22*s + 18)) + Dd*f*(f*(k1**4*(6 - 12*C)*(4*r*(3*s - 2) + 12*s**2 - 27*s + 11) + k1**2*k2**2*(-36*C*(60*r**2 + r*(12*s - 41) - 48*s**2 + 20*s + 7) + 1236*r**2 + 15*r*(32*s - 47) - 756*s**2 + 352*s + 52) - 9*k2**4*(4*C*(4*r - 1)*(2*r + 2*s - 1) - 112*r**2 - 2*r*(84*s - 59) - 56*s**2 + 69*s - 22)) + k2**4*(-6*b2 + 12*g2)*(60*r**2 + r*(60*s - 109) - 40*s + 36))))/(315*d**2*k1*k2*k3**3) + D1**3*Pk1*Pkd3*ct*(-21*b1**3*k2**2*(D1*fd*(8*k1**2*(3*r + 8*s - 8) + 5*k2**2*(r + s - 1))*(r + s - 1) + Dd*f*(4*k1**2*(24*r**2 + 8*r*(11*s - 9) + 64*s**2 - 107*s + 43) + 5*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) - 3*b1**2*(D1*(7*bd1*f*k2**2*(4*k1**2*(18*r**2 + r*(66*s - 50) + 48*s**2 - 75*s + 27) + 5*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2)) - 2*fd*(k1**4*(140*C - 70)*(s - 1)*(r + s - 1) + 2*k1**2*k2**2*(35*C*(5*r**2 + 12*r*(s - 1) + 7*(s - 1)**2) + 14*K*(4*r**2 - r*(s + 28) - 5*s**2 - 19*s + 14) + f*(-12*r**2 + 4*r*(36*s + 1) + 156*s**2 - 91*s - 16) - 112*r**2 - 224*r*s + 406*r - 112*s**2 + 462*s - 238) + 7*k2**4*(f*(5*r**2 + r*(50*s - 32) + 45*s**2 - 60*s + 23) + 15*(r + s)**2))) + Dd*f*(k1**4*(280 - 560*C)*(2*s - 1)*(r + s - 1) - 2*k1**2*k2**2*(70*C*(20*r**2 + r*(48*s - 35) + 28*s**2 - 45*s + 17) + 14*K*(32*r**2 - 2*r*(4*s + 59) - 40*s**2 - 55*s + 66) + f*(-48*r**2 + r*(576*s - 68) + 624*s**2 - 496*s + 40) - 896*r**2 - 1792*r*s + 1946*r - 896*s**2 + 2345*s - 1155) - 7*k2**4*(f*(20*r**2 + r*(200*s - 99) + 180*s**2 - 211*s + 59) + 120*r**2 + 10*r*(24*s - 13) + 10*s*(12*s - 7)))) + b1*(D1*(f**2*k2**2*(-12*bd1*k1**2*(12*r**2 + r*(38 - 144*s) - 156*s**2 + 157*s - 36) + 21*bd1*k2**2*(10*r**2 + 5*r*(20*s - 7) + 90*s**2 - 91*s + 13) + 4*fd*k1**2*(315*r**2 + 126*r*(10*s - 7) + 945*s**2 - 1392*s + 523) + 36*fd*k2**2*(18*r**2 + 9*r*(8*s - 5) + 54*s**2 - 69*s + 25)) - 6*f*(-7*bd1*(k1**4*s*(40*C - 20)*(r + s - 1) + k1**2*k2**2*(10*C*(10*r**2 + r*(24*s - 11) + 14*s**2 - 17*s + 3) + 2*K*(16*r**2 - 4*r*s - 35*r - 20*s**2 - 8*s + 19) - 64*r**2 - 128*r*s + 72*r - 64*s**2 + 105*s - 31) + 10*k2**4*(3*r**2 + r*(6*s - 4) + s*(3*s - 2))) + fd*(k1**4*(56*C - 28)*(2*s - 1) + k1**2*k2**2*(-28*C*(9*r**2 + r*(2*s - 11) - 7*s**2 - 3*s + 6) + 2*K*(276*r**2 + 444*r*s - 290*r + 168*s**2 - 257*s + 76) - 66*r**2 - 476*r*s + 17*r - 410*s**2 + 224*s + 36) + 7*k2**4*(r**2*(4*K - 18) + r*(K*(4*s - 2) - 32*s + 9) + s*(-2*K - 14*s + 3))) + 28*k1**2*k2**2*(bd2*(9*r + 9*s + 1) + gd2*(8*r - 10*s - 19))*(r + s - 1)) - 168*fd*k1**2*k2**2*(b2*(9*r**2 + 2*r*(9*s + 1) + 9*s**2 + 2*s - 1) + 2*g2*(4*r**2 - r*(s + 28) - 5*s**2 - 19*s + 14))) + 2*Dd*f*(2*f**2*k2**2*(k1**2*(420*r**2 + 3*r*(560*s - 407) + 1260*s**2 - 1876*s + 692) + 18*k2**2*(12*r**2 + r*(48*s - 29) + 36*s**2 - 45*s + 14)) - 3*f*(k1**4*(112*C - 56)*(2*s - 1) - k1**2*k2**2*(14*C*(36*r**2 + r*(8*s - 19) - 28*s**2 + 7*s + 5) - 2*K*(552*r**2 + 888*r*s - 664*r + 336*s**2 - 571*s + 222) + 132*r**2 + 952*r*s - 407*r + 820*s**2 - 767*s + 153) + 7*k2**4*(r**2*(8*K - 36) + r*(K*(8*s - 2) - 64*s + 35) + s*(-2*K - 28*s + 17))) - 84*k1**2*k2**2*(b2*(36*r**2 + r*(72*s - 23) + 36*s**2 - 23*s - 3) + g2*(32*r**2 - 2*r*(4*s + 59) - 40*s**2 - 55*s + 66)))) - 2*f*(D1*(-2*bd1*f**2*k2**2*(k1**2*(105*r**2 + r*(420*s - 339) + 315*s**2 - 484*s + 169) + 9*k2**2*(6*r**2 + 24*r*s - 13*r + 18*s**2 - 21*s + 3)) + 3*f*(bd1*(k1**4*s*(56*C - 28) - k1**2*k2**2*(14*C*(9*r**2 + r*(2*s + 5) - 7*s**2 + 7*s - 8) - 2*K*(138*r**2 + 222*r*s - 187*r + 84*s**2 - 157*s + 73) + 33*r**2 + 238*r*s - 230*r + 205*s**2 - 275*s + 126) + 7*k2**4*(r**2*(2*K - 9) + r*(s*(2*K - 16) + 13) - s*(7*s - 7))) + 3*fd*(k1**4*(4*C - 2)*(3*s - 1)*(5*r + 5*s - 3) + k1**2*k2**2*(4*C*(21*r**2 + r*(75*s - 46) + 54*s**2 - 61*s + 19) - 57*r**2 + r*(113 - 198*s) - 141*s**2 + 166*s - 49)) + k2**2*(2*bd2 - 4*gd2)*(k1**2*(138*r**2 + r*(222*s - 187) + 84*s**2 - 157*s + 73) + 7*k2**2*r*(r + s))) + 6*k2**2*(126*b2*bd1*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + b2*fd*(k1**2*(276*r**2 + r*(444*s - 290) + 168*s**2 - 257*s + 76) + 7*k2**2*(r + s)*(2*r - 1)) + 14*bd1*g2*k1**2*(8*r**2 - 2*r*(s + 4) - 10*s**2 + s) - 2*fd*g2*(k1**2*(276*r**2 + r*(444*s - 290) + 168*s**2 - 257*s + 76) + 7*k2**2*(r + s)*(2*r - 1)))) + 3*Dd*f*(3*f*k1**2*(k1**2*(8*C - 4)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(4*C*(28*r**2 + 100*r*s - 71*r + 72*s**2 - 91*s + 31) - 76*r**2 - 264*r*s + 179*r - 188*s**2 + 248*s - 84)) + k2**2*(2*b2 - 4*g2)*(k1**2*(552*r**2 + 8*r*(111*s - 83) + 336*s**2 - 571*s + 222) + 7*k2**2*(r + s)*(4*r - 1)))))/(315*d**2*k1*k2*k3**3) + D1**3*Pk1*Pkd3*ct*st**2*(33*D1*bd1*f*(f**2*k2**4*(k1**2*(81*r**2 + r*(474*s - 232) + 393*s**2 - 516*s + 91) + 3*k2**2*(-74*r**2 + r*(69 - 84*s) - 10*s**2 + 33*s + 1)) + f*(k1**6*(8*C - 4)*(r*(s - 9) + s**2 - 22*s + 9) + 2*k1**4*k2**2*(2*C*(208*r**2 + 3*r*(66*s - 19) - 10*s**2 + 187*s - 151) - 235*r**2 + r*(41 - 254*s) - 19*s**2 - 233*s + 194) - k1**2*k2**4*(-28*C*(147*r**2 + r*(254*s - 220) + 107*s**2 - 176*s + 73) + 84*K*(2*r**2 + 4*r*s + 2*s**2 - s - 1) + b1*(920*r**2 + r*(2176*s - 1555) + 1256*s**2 - 1891*s + 635) + 2686*r**2 + 4644*r*s - 4064*r + 1958*s**2 - 3196*s + 1378) - 7*k2**6*(15*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) - 2*r**2*(4*K - 9) - 2*r*(2*K - 7)*(2*s - 1) + 2*s*(5*s - 5))) - 7*k2**2*(15*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 4*b1*(k1**4*(15*C - 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(-50*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(10*r**2 + 26*r*s - 9*r + 16*s**2 - 27*s + 5) + 70*r**2 + 138*r*s - 112*r + 68*s**2 - 96*s + 35) + 5*k2**4*(r**2*(4*K - 9) + r*(K*(4*s - 3) - 14*s + 8) - s*(K + 5*s - 6))) + 4*k2**2*(5*b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*g2*(k1**2*(5*r**2 + r*(13*s - 5) + 2*s*(4*s - 7)) + 5*k2**2*(2*r**2 + 2*r*(s - 1) - s))))) - 3465*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*k2**2*(D1*fd*(k1**4*(280 - 420*C)*(r + s - 1)**2 + k1**2*k2**2*(1400*C*(r + s - 1)**2 - 28*K*(5*r**2 + 13*r*s - 10*r + 8*s**2 - 10*s + 5) + f*(920*r**2 + r*(2176*s - 1305) + 1256*s**2 - 1473*s + 475) - 980*r**2 - 1932*r*s + 1960*r - 952*s**2 + 1960*s - 980) + 35*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-2*r*(4*K - 9) + 10*s))) + 2*Dd*f*(k1**4*(140 - 210*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(700*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*K*(20*r**2 + 52*r*s - 23*r + 32*s**2 - 50*s + 15) + f*(920*r**2 + 2*r*(1088*s - 715) + 1256*s**2 - 1682*s + 555) - 1960*r**2 - 3864*r*s + 3626*r - 1904*s**2 + 3290*s - 1470) + 35*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + r**2*(36 - 16*K) + r*(-16*K*s + 8*K + 56*s - 23) + s*(2*K + 20*s - 17)))) + 33*b1*(D1*(3*f**2*fd*k2**4*(k1**2*(81*r**2 + r*(474*s - 109) + 393*s**2 - 313*s + 42) - k2**2*(222*r**2 + 7*r*(36*s - 31) + 30*s**2 - 109*s + 73)) + 2*f*(fd*(k1**6*(4*C - 2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**4*k2**2*(2*C*(416*r**2 + r*(396*s + 239) - 20*s**2 + 639*s - 317) - 470*r**2 - 2*r*(254*s + 163) - 38*s**2 - 801*s + 415) + k1**2*k2**4*(14*C*(294*r**2 + r*(508*s - 261) + 214*s**2 - 211*s + 47) - 42*K*(4*r**2 + 8*r*s + 4*r + 4*s**2 + s - 3) - 2686*r**2 - 4644*r*s + 2525*r - 1958*s**2 + 2014*s - 486) + 7*k2**6*(r**2*(8*K - 18) + r*(K*(8*s - 4) - 28*s + 9) + s*(-2*K - 10*s + 7))) - 14*k2**4*(5*bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(5*r**2 + 13*r*s - 4*r + 8*s**2 - 13*s + 5) + 5*k2**2*r*(2*r + 2*s - 1)))) - 28*fd*k2**4*(5*b2*k1**2*(r + s)**2 + 2*g2*k1**2*(5*r**2 + r*(13*s - 10) + 8*s**2 - 10*s + 5) + 20*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(324*r**2 + r*(1896*s - 559) + 1572*s**2 - 1455*s + 217) - 6*k2**2*(148*r**2 + r*(168*s - 143) + 20*s**2 - 71*s + 36)) + 2*f*(k1**6*(4*C - 2)*(4*r*(s - 4) + 4*s**2 - 57*s + 31) + k1**4*k2**2*(8*C*(208*r**2 + r*(198*s + 65) - 10*s**2 + 287*s - 195) - 940*r**2 - 1016*r*s - 397*r - 76*s**2 - 1420*s + 1014) + k1**2*k2**4*(14*C*(588*r**2 + r*(1016*s - 689) + 428*s**2 - 551*s + 177) - 42*K*(8*r**2 + 16*r*s + 4*r + 8*s**2 - s - 5) - 5372*r**2 - 9288*r*s + 6519*r - 3916*s**2 + 5140*s - 1724) + 7*k2**6*(r**2*(16*K - 36) + r*(8*K*(2*s - 1) - 56*s + 23) + s*(-2*K - 20*s + 17))) - 28*k2**4*(5*b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(20*r**2 + 52*r*s - 23*r + 32*s**2 - 50*s + 15) + 5*k2**2*(8*r**2 + 8*r*s - 4*r - s))))) + 2*f*(D1*(2*f**2*fd*k2**4*(k1**2*(5980*r**2 + r*(11920*s - 9973) + 5940*s**2 - 10823*s + 4556) + 132*k2**2*(12*r**2 + r*(42*s - 26) + 30*s**2 - 36*s + 11)) + 11*f*(fd*k1**2*(k1**4*(12*C - 6)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + k1**2*k2**2*(2*C*(1413*r**2 + 1098*r*s - 993*r - 315*s**2 - 165*s + 142) - 1611*r**2 - 1458*r*s + 1011*r + 153*s**2 + 204*s - 81) + 9*k2**4*(2*C*(483*r**2 + 810*r*s - 533*r + 327*s**2 - 421*s + 138) - 663*r**2 - 1110*r*s + 737*r - 447*s**2 + 576*s - 191)) - 6*k2**4*(5*bd2*k1**2*(8*r**2 + r*(16*s - 5) + 8*s**2 - 5*s - 3) - 14*gd2*(3*k1**2*(2*r**2 + 4*r*s + 2*s**2 - s - 1) + k2**2*r*(-2*r - 2*s + 1)))) - 66*fd*k2**4*(5*b2*k1**2*(16*r**2 + r*(32*s - 2) + 16*s**2 - 2*s - 3) - 14*g2*(3*k1**2*(4*r**2 + 8*r*s + 4*r + 4*s**2 + s - 3) + k2**2*(-4*r**2 - 4*r*s + 2*r + s)))) + Dd*f*(2*f**2*k2**4*(k1**2*(5980*r**2 + r*(11920*s - 9973) + 5940*s**2 - 10823*s + 4556) + 132*k2**2*(12*r**2 + r*(42*s - 26) + 30*s**2 - 36*s + 11)) + 11*f*k1**2*(k1**4*(12*C - 6)*(4*r*(3*s - 2) + 12*s**2 - 27*s + 11) + k1**2*k2**2*(2*C*(1884*r**2 + 1464*r*s - 1229*r - 420*s**2 - 59*s + 141) - 2148*r**2 - 1944*r*s + 1241*r + 204*s**2 + 112*s - 40) + 9*k2**4*(2*C*(644*r**2 + 1080*r*s - 755*r + 436*s**2 - 593*s + 201) - 884*r**2 - 1480*r*s + 1049*r - 596*s**2 + 814*s - 280)) - 66*k2**4*(5*b2*k1**2*(32*r**2 + 4*r*(16*s - 3) + 32*s**2 - 12*s - 9) - 14*g2*(3*k1**2*(8*r**2 + 16*r*s + 4*r + 8*s**2 - s - 5) + k2**2*(-8*r**2 - 8*r*s + 4*r + s))))))/(3465*d**2*k1*k2*k3**5) + D1**3*Pk1*Pkd3*f*k2**4*st**6*(11*D1*bd1*f*(k1**2*(36*C - 18)*(2*r + 2*s - 1) + k2**2*(-36*b1*(2*r + 2*s - 1) + f*(15*r + 15*s - 7)))*(r + s - 1) - 198*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 11*b1*(D1*fd*(f*k2**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + k1**2*(36*C - 18)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(15*r + 15*s - 7) + k1**2*(36*C - 18)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(116*r**2 + r*(232*s - 163) + 116*s**2 - 163*s + 57) + k1**2*(44*C - 22)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(29*r + 29*s - 19) + k1**2*(44*C - 22)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(77*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*f*k2**2*st**6*(9*D1*bd1*f*(k1**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 9*b1*(4*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r)*(2*r + 2*s - 1) + Dd*f*(k1**2*(4*C - 2)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) + f*(2*D1*fd*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1))*(3*r + 3*s - 2) + Dd*f*(k1**2*(4*C - 2)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(63*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*f*k2**2*st**6*(33*D1*b1*fd*(4*f*k2**4*r*(3*r + 3*s - 2) + k1**4*(24*C - 12)*(2*s - 1)*(2*r + 2*s - 1) - 3*k1**2*k2**2*(2*r + 2*s - 1)*(2*C*(18*r + 10*s - 5) - 22*r - 10*s + 5)) + 11*D1*bd1*f*(2*f*k2**4*(6*r**2 + r*(6*s - 8) - 3*s + 2) + k1**4*(36*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2) - 9*k1**2*k2**2*(2*C*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) - 22*r**2 + r*(30 - 32*s) - 10*s**2 + 21*s - 8)) + D1*f*fd*(f*k2**4*(120*r**2 + 8*r*(15*s - 4) + 25*s - 27) + k1**4*(88*C - 44)*(3*s - 1)*(3*r + 3*s - 2) - 11*k1**2*k2**2*(3*r + 3*s - 2)*(C*(54*r + 30*s - 28) - 33*r - 15*s + 16)) + 22*Dd*b1*f*(f*k2**4*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**4*(18*C - 9)*(2*s - 1)*(8*r + 8*s - 5) - 9*k1**2*k2**2*(C*(72*r**2 + 2*r*(56*s - 37) + 40*s**2 - 54*s + 17) - 44*r**2 + r*(43 - 64*s) - 20*s**2 + 28*s - 9)) + Dd*f**2*(f*k2**4*(120*r**2 + 8*r*(15*s - 4) + 25*s - 27) + k1**4*(44*C - 22)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 11*k1**2*k2**2*(2*C*(108*r**2 + 7*r*(24*s - 19) + 60*s**2 - 99*s + 40) - 132*r**2 + r*(157 - 192*s) - 60*s**2 + 106*s - 45)))/(693*d**2*k1**2*k3**5) + 3*D1**3*Pk1*Pkd3*k1**4*(D1*(-14*b1*fd*(2*k1**2 + 5*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 15*bd1*f**3*k2**2*(r + s - 1)**2 + 3*f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(4*r + 4*s - 2) + 7*K*k2**2*(r + s) - 7*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))) + f*(3*fd*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(2*r + 2*s - 1) + (2*k1**2 + 5*k2**2)*(28*b1*gd2 + 28*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(15*b1*f**2*k2**2*(r + s - 1) - 14*b1*(2*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 3*f*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))))/(35*d**2*k3**7) - D1**3*Pk1*Pkd3*k1**2*(-672*C*D1*b1*f*fd*k1**2*r*s + 336*C*D1*b1*f*fd*k1**2*r - 672*C*D1*b1*f*fd*k1**2*s**2 + 1008*C*D1*b1*f*fd*k1**2*s - 336*C*D1*b1*f*fd*k1**2 - 648*C*D1*f**2*fd*k1**2*r*s + 216*C*D1*f**2*fd*k1**2*r - 648*C*D1*f**2*fd*k1**2*s**2 + 864*C*D1*f**2*fd*k1**2*s - 216*C*D1*f**2*fd*k1**2 - 1344*C*Dd*b1*f**2*k1**2*r*s + 672*C*Dd*b1*f**2*k1**2*r - 1344*C*Dd*b1*f**2*k1**2*s**2 + 2016*C*Dd*b1*f**2*k1**2*s - 672*C*Dd*b1*f**2*k1**2 - 864*C*Dd*f**3*k1**2*r*s + 432*C*Dd*f**3*k1**2*r - 864*C*Dd*f**3*k1**2*s**2 + 1296*C*Dd*f**3*k1**2*s - 432*C*Dd*f**3*k1**2 - 1176*D1*K*b1**2*fd*k1**2*r**2 - 2352*D1*K*b1**2*fd*k1**2*r*s - 840*D1*K*b1**2*fd*k1**2*r - 1176*D1*K*b1**2*fd*k1**2*s**2 - 840*D1*K*b1**2*fd*k1**2*s + 420*D1*K*b1**2*fd*k1**2 - 2310*D1*K*b1**2*fd*k2**2*r**2 - 4200*D1*K*b1**2*fd*k2**2*r*s - 1890*D1*K*b1**2*fd*k2**2*s**2 - 2736*D1*K*b1*f*fd*k1**2*r**2 - 5040*D1*K*b1*f*fd*k1**2*r*s + 2736*D1*K*b1*f*fd*k1**2*r - 2304*D1*K*b1*f*fd*k1**2*s**2 + 2604*D1*K*b1*f*fd*k1**2*s - 684*D1*K*b1*f*fd*k1**2 - 2772*D1*K*b1*f*fd*k2**2*r**2 - 4872*D1*K*b1*f*fd*k2**2*r*s + 1386*D1*K*b1*f*fd*k2**2*r - 2100*D1*K*b1*f*fd*k2**2*s**2 + 1134*D1*K*b1*f*fd*k2**2*s - 525*D1*b1**3*fd*k2**2*r**2 - 1050*D1*b1**3*fd*k2**2*r*s + 1050*D1*b1**3*fd*k2**2*r - 525*D1*b1**3*fd*k2**2*s**2 + 1050*D1*b1**3*fd*k2**2*s - 525*D1*b1**3*fd*k2**2 + 504*D1*b1**2*f*fd*k1**2*r*s - 378*D1*b1**2*f*fd*k1**2*r + 504*D1*b1**2*f*fd*k1**2*s**2 - 588*D1*b1**2*f*fd*k1**2*s + 168*D1*b1**2*f*fd*k1**2 + 504*D1*b1**2*f*fd*k2**2*r**2 + 1512*D1*b1**2*f*fd*k2**2*r*s - 693*D1*b1**2*f*fd*k2**2*r + 1008*D1*b1**2*f*fd*k2**2*s**2 - 861*D1*b1**2*f*fd*k2**2*s + 21*D1*b1**2*f*fd*k2**2 + 168*D1*b1**2*fd*k1**2*r*s + 168*D1*b1**2*fd*k1**2*s**2 + 210*D1*b1**2*fd*k2**2*r**2 + 420*D1*b1**2*fd*k2**2*r*s + 210*D1*b1**2*fd*k2**2*s**2 - 420*D1*b1*b2*fd*k1**2*r**2 - 840*D1*b1*b2*fd*k1**2*r*s - 420*D1*b1*b2*fd*k1**2*s**2 - 1050*D1*b1*b2*fd*k2**2*r**2 - 2100*D1*b1*b2*fd*k2**2*r*s - 1050*D1*b1*b2*fd*k2**2*s**2 + 540*D1*b1*f**2*fd*k1**2*r*s - 360*D1*b1*f**2*fd*k1**2*r + 540*D1*b1*f**2*fd*k1**2*s**2 - 702*D1*b1*f**2*fd*k1**2*s + 234*D1*b1*f**2*fd*k1**2 + 1215*D1*b1*f**2*fd*k2**2*r**2 + 2538*D1*b1*f**2*fd*k2**2*r*s - 1953*D1*b1*f**2*fd*k2**2*r + 1323*D1*b1*f**2*fd*k2**2*s**2 - 1737*D1*b1*f**2*fd*k2**2*s + 630*D1*b1*f**2*fd*k2**2 + 624*D1*b1*f*fd*k1**2*r*s - 168*D1*b1*f*fd*k1**2*r + 624*D1*b1*f*fd*k1**2*s**2 - 648*D1*b1*f*fd*k1**2*s + 168*D1*b1*f*fd*k1**2 + 252*D1*b1*f*fd*k2**2*r**2 + 504*D1*b1*f*fd*k2**2*r*s - 126*D1*b1*f*fd*k2**2*r + 252*D1*b1*f*fd*k2**2*s**2 + 2352*D1*b1*f*gd2*k1**2*r**2 + 4704*D1*b1*f*gd2*k1**2*r*s - 1512*D1*b1*f*gd2*k1**2*r + 2352*D1*b1*f*gd2*k1**2*s**2 - 1512*D1*b1*f*gd2*k1**2*s - 840*D1*b1*f*gd2*k1**2 + 4620*D1*b1*f*gd2*k2**2*r**2 + 8400*D1*b1*f*gd2*k2**2*r*s - 4620*D1*b1*f*gd2*k2**2*r + 3780*D1*b1*f*gd2*k2**2*s**2 - 3780*D1*b1*f*gd2*k2**2*s + 2352*D1*b1*fd*g2*k1**2*r**2 + 4704*D1*b1*fd*g2*k1**2*r*s + 1680*D1*b1*fd*g2*k1**2*r + 2352*D1*b1*fd*g2*k1**2*s**2 + 1680*D1*b1*fd*g2*k1**2*s - 840*D1*b1*fd*g2*k1**2 + 4620*D1*b1*fd*g2*k2**2*r**2 + 8400*D1*b1*fd*g2*k2**2*r*s + 3780*D1*b1*fd*g2*k2**2*s**2 - 720*D1*b2*f*fd*k1**2*r**2 - 1440*D1*b2*f*fd*k1**2*r*s + 720*D1*b2*f*fd*k1**2*r - 720*D1*b2*f*fd*k1**2*s**2 + 720*D1*b2*f*fd*k1**2*s - 180*D1*b2*f*fd*k1**2 - 1260*D1*b2*f*fd*k2**2*r**2 - 2520*D1*b2*f*fd*k2**2*r*s + 630*D1*b2*f*fd*k2**2*r - 1260*D1*b2*f*fd*k2**2*s**2 + 630*D1*b2*f*fd*k2**2*s + 3*D1*bd1*f*(-175*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 14*b1*(2*K*(k1**2*(28*r + 28*s + 5) + 5*k2**2*(11*r + 9*s))*(r + s - 1) + k1**2*(r*(2 - 8*s) + s*(6 - 8*s)) - 5*k2**2*(2*r**2 + r*(4*s - 3) + s*(2*s - 1))) + 3*f**2*(4*k1**2*(s - 1)*(5*r + 5*s - 4) + k2**2*(45*r**2 + 2*r*(47*s - 53) + 49*(s - 1)**2)) + f*(2*k1**2*(-56*C*r*s - 56*C*s**2 + 56*C*s - 4*K*(57*r**2 + 3*r*(35*s - 27) + 48*s**2 - 76*s + 28) + 7*b1*(3*r*(4*s - 3) + 12*s**2 - 17*s + 7) + 52*r*s - 12*r + 52*s**2 - 58*s + 6) + 7*k2**2*(b1*(24*r**2 + r*(72*s - 75) + 48*s**2 - 83*s + 43) + 2*r**2*(3 - 33*K) + 2*r*(-58*K*s + 31*K + 6*s - 6) - 2*s*(25*K - 3)*(s - 1))) - 7*(5*b2*(2*k1**2 + 5*k2**2)*(r + s) - 2*g2*(28*k1**2*(r + s) + 5*k2**2*(11*r + 9*s)))*(2*r + 2*s - 2)) - 30*D1*bd2*f*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(r + s - 1) - 320*D1*f**3*fd*k2**2*r*s + 160*D1*f**3*fd*k2**2*r - 320*D1*f**3*fd*k2**2*s**2 + 480*D1*f**3*fd*k2**2*s - 160*D1*f**3*fd*k2**2 + 324*D1*f**2*fd*k1**2*r*s - 108*D1*f**2*fd*k1**2*r + 324*D1*f**2*fd*k1**2*s**2 - 432*D1*f**2*fd*k1**2*s + 108*D1*f**2*fd*k1**2 + 2736*D1*f**2*gd2*k1**2*r**2 + 5040*D1*f**2*gd2*k1**2*r*s - 3888*D1*f**2*gd2*k1**2*r + 2304*D1*f**2*gd2*k1**2*s**2 - 3648*D1*f**2*gd2*k1**2*s + 1344*D1*f**2*gd2*k1**2 + 2772*D1*f**2*gd2*k2**2*r**2 + 4872*D1*f**2*gd2*k2**2*r*s - 2604*D1*f**2*gd2*k2**2*r + 2100*D1*f**2*gd2*k2**2*s**2 - 2100*D1*f**2*gd2*k2**2*s + 5472*D1*f*fd*g2*k1**2*r**2 + 10080*D1*f*fd*g2*k1**2*r*s - 5472*D1*f*fd*g2*k1**2*r + 4608*D1*f*fd*g2*k1**2*s**2 - 5208*D1*f*fd*g2*k1**2*s + 1368*D1*f*fd*g2*k1**2 + 5544*D1*f*fd*g2*k2**2*r**2 + 9744*D1*f*fd*g2*k2**2*r*s - 2772*D1*f*fd*g2*k2**2*r + 4200*D1*f*fd*g2*k2**2*s**2 - 2268*D1*f*fd*g2*k2**2*s - 4704*Dd*K*b1**2*f*k1**2*r**2 - 9408*Dd*K*b1**2*f*k1**2*r*s + 1848*Dd*K*b1**2*f*k1**2*r - 4704*Dd*K*b1**2*f*k1**2*s**2 + 1848*Dd*K*b1**2*f*k1**2*s + 1260*Dd*K*b1**2*f*k1**2 - 9240*Dd*K*b1**2*f*k2**2*r**2 - 16800*Dd*K*b1**2*f*k2**2*r*s + 6930*Dd*K*b1**2*f*k2**2*r - 7560*Dd*K*b1**2*f*k2**2*s**2 + 5670*Dd*K*b1**2*f*k2**2*s - 5472*Dd*K*b1*f**2*k1**2*r**2 - 10080*Dd*K*b1*f**2*k1**2*r*s + 6624*Dd*K*b1*f**2*k1**2*r - 4608*Dd*K*b1*f**2*k1**2*s**2 + 6252*Dd*K*b1*f**2*k1**2*s - 2028*Dd*K*b1*f**2*k1**2 - 5544*Dd*K*b1*f**2*k2**2*r**2 - 9744*Dd*K*b1*f**2*k2**2*r*s + 3990*Dd*K*b1*f**2*k2**2*r - 4200*Dd*K*b1*f**2*k2**2*s**2 + 3234*Dd*K*b1*f**2*k2**2*s - 2100*Dd*b1**3*f*k2**2*r**2 - 4200*Dd*b1**3*f*k2**2*r*s + 3675*Dd*b1**3*f*k2**2*r - 2100*Dd*b1**3*f*k2**2*s**2 + 3675*Dd*b1**3*f*k2**2*s - 1575*Dd*b1**3*f*k2**2 + 1008*Dd*b1**2*f**2*k1**2*r*s - 756*Dd*b1**2*f**2*k1**2*r + 1008*Dd*b1**2*f**2*k1**2*s**2 - 1302*Dd*b1**2*f**2*k1**2*s + 462*Dd*b1**2*f**2*k1**2 + 1008*Dd*b1**2*f**2*k2**2*r**2 + 3024*Dd*b1**2*f**2*k2**2*r*s - 2268*Dd*b1**2*f**2*k2**2*r + 2016*Dd*b1**2*f**2*k2**2*s**2 - 2604*Dd*b1**2*f**2*k2**2*s + 924*Dd*b1**2*f**2*k2**2 + 672*Dd*b1**2*f*k1**2*r*s - 168*Dd*b1**2*f*k1**2*r + 672*Dd*b1**2*f*k1**2*s**2 - 420*Dd*b1**2*f*k1**2*s + 840*Dd*b1**2*f*k2**2*r**2 + 1680*Dd*b1**2*f*k2**2*r*s - 1050*Dd*b1**2*f*k2**2*r + 840*Dd*b1**2*f*k2**2*s**2 - 420*Dd*b1**2*f*k2**2*s - 1680*Dd*b1*b2*f*k1**2*r**2 - 3360*Dd*b1*b2*f*k1**2*r*s + 1260*Dd*b1*b2*f*k1**2*r - 1680*Dd*b1*b2*f*k1**2*s**2 + 1260*Dd*b1*b2*f*k1**2*s - 4200*Dd*b1*b2*f*k2**2*r**2 - 8400*Dd*b1*b2*f*k2**2*r*s + 3150*Dd*b1*b2*f*k2**2*r - 4200*Dd*b1*b2*f*k2**2*s**2 + 3150*Dd*b1*b2*f*k2**2*s + 720*Dd*b1*f**3*k1**2*r*s - 540*Dd*b1*f**3*k1**2*r + 720*Dd*b1*f**3*k1**2*s**2 - 1026*Dd*b1*f**3*k1**2*s + 378*Dd*b1*f**3*k1**2 + 1620*Dd*b1*f**3*k2**2*r**2 + 3384*Dd*b1*f**3*k2**2*r*s - 2907*Dd*b1*f**3*k2**2*r + 1764*Dd*b1*f**3*k2**2*s**2 - 2619*Dd*b1*f**3*k2**2*s + 1071*Dd*b1*f**3*k2**2 + 1248*Dd*b1*f**2*k1**2*r*s - 480*Dd*b1*f**2*k1**2*r + 1248*Dd*b1*f**2*k1**2*s**2 - 1512*Dd*b1*f**2*k1**2*s + 408*Dd*b1*f**2*k1**2 + 504*Dd*b1*f**2*k2**2*r**2 + 1008*Dd*b1*f**2*k2**2*r*s - 630*Dd*b1*f**2*k2**2*r + 504*Dd*b1*f**2*k2**2*s**2 - 252*Dd*b1*f**2*k2**2*s + 9408*Dd*b1*f*g2*k1**2*r**2 + 18816*Dd*b1*f*g2*k1**2*r*s - 3696*Dd*b1*f*g2*k1**2*r + 9408*Dd*b1*f*g2*k1**2*s**2 - 3696*Dd*b1*f*g2*k1**2*s - 2520*Dd*b1*f*g2*k1**2 + 18480*Dd*b1*f*g2*k2**2*r**2 + 33600*Dd*b1*f*g2*k2**2*r*s - 13860*Dd*b1*f*g2*k2**2*r + 15120*Dd*b1*f*g2*k2**2*s**2 - 11340*Dd*b1*f*g2*k2**2*s - 1440*Dd*b2*f**2*k1**2*r**2 - 2880*Dd*b2*f**2*k1**2*r*s + 1800*Dd*b2*f**2*k1**2*r - 1440*Dd*b2*f**2*k1**2*s**2 + 1800*Dd*b2*f**2*k1**2*s - 540*Dd*b2*f**2*k1**2 - 2520*Dd*b2*f**2*k2**2*r**2 - 5040*Dd*b2*f**2*k2**2*r*s + 1890*Dd*b2*f**2*k2**2*r - 2520*Dd*b2*f**2*k2**2*s**2 + 1890*Dd*b2*f**2*k2**2*s - 320*Dd*f**4*k2**2*r*s + 160*Dd*f**4*k2**2*r - 320*Dd*f**4*k2**2*s**2 + 480*Dd*f**4*k2**2*s - 160*Dd*f**4*k2**2 + 432*Dd*f**3*k1**2*r*s - 216*Dd*f**3*k1**2*r + 432*Dd*f**3*k1**2*s**2 - 648*Dd*f**3*k1**2*s + 216*Dd*f**3*k1**2 + 10944*Dd*f**2*g2*k1**2*r**2 + 20160*Dd*f**2*g2*k1**2*r*s - 13248*Dd*f**2*g2*k1**2*r + 9216*Dd*f**2*g2*k1**2*s**2 - 12504*Dd*f**2*g2*k1**2*s + 4056*Dd*f**2*g2*k1**2 + 11088*Dd*f**2*g2*k2**2*r**2 + 19488*Dd*f**2*g2*k2**2*r*s - 7980*Dd*f**2*g2*k2**2*r + 8400*Dd*f**2*g2*k2**2*s**2 - 6468*Dd*f**2*g2*k2**2*s)/(315*d**2*k3**5) + D1**3*Pk1*Pkd3*k1**2*st**2*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(k1**4*(2*C - 1)*(r + s + 3) - k1**2*k2**2*(-14*C*(4*r + 4*s - 3) + 8*K*r + 8*K*s + 3*K + 3*b1*(r + s + 3) + 28*r + 28*s - 21) + 7*k2**4*(K*(r + s) - 3*b1*(5*r + 5*s - 3))) + k2**2*(-k1**2 + 5*k2**2)*(r + s)*(84*K*b1 - 84*g2)) + 33*b1**2*k2**2*(D1*fd*(14*K*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(14*K*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*(fd*(2*r + 2*s - 1)*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 84*g2*k2**2*(k1**2 - 5*k2**2)*(r + s))) - f*(D1*(5*f**2*fd*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 6*gd2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9)) + f*k1**2*(44*C - 22)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(385*d**2*k3**7) - 3*D1**3*Pk1*Pkd3*k2**2*st**4*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(14*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(5*r + 5*s - 6) - k1**2*k2**2*(b1*(19*r + 19*s - 13) + (14*C - K - 7)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*g2)) - 33*b1**2*k2**2*(D1*fd*(14*K*k1**2*(r + s)**2 - f*(k1**2*(19*r + 19*s - 13) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-14*K*k1**2*(r + s) + f*k1**2*(19*r + 19*s - 13) - 14*f*k2**2*(2*r + 2*s - 1))) + 33*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*k1**2*(fd*(k1**2*(2*C - 1)*(5*r + 5*s - 6) - k2**2*(14*C - K - 7)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*k1**4*(4*C - 2)*(5*r + 5*s - 6) + 2*f*k1**2*k2**2*(14*C - K - 7)*(2*r + 2*s - 1) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-103*r - 103*s + 69) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 66*f*k1**2*(fd*(2*C - 1)*(k1**2 - k2**2)*(3*r + 3*s - 2) - 2*gd2*k2**2*(r + s - 1))*(2*r + 2*s - 1) + 132*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(103*r + 103*s - 69) - 11*k2**2*(17*r + 17*s - 11)) + f*k1**2*(132*C - 66)*(k1**2 - k2**2)*(2*r + 2*s - 1) - 132*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(385*d**2*k3**7) + 2*D1**3*Pk1*Pkd3*(-2*D1*bd1*f*(6*b2*r**2 + 6*b2*r*(s - 1) - 3*b2*s + f*s*(4*C - 2)*(r + s - 1) + 2*g2*(-6*r**2 - 6*r*(s - 1) + 3*s)) + 5*b1**3*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1**2*(5*D1*bd1*f*(r*(6*s - 4) + 6*s**2 - 9*s + 3) - D1*fd*(r + s - 1)*(20*C*(s - 1) + 12*K*(r - 1) + f*(9 - 12*s) - 14*s + 10) + Dd*f*(-40*C*(2*s - 1)*(r + s - 1) - 48*K*r**2 - 48*K*r*s + 72*K*r + 30*K*s - 24*K + 3*f*(8*r*s - 6*r + 8*s**2 - 13*s + 5) + 56*r*s - 24*r + 56*s**2 - 78*s + 24)) + b1*(-12*D1*b2*fd*(r - 1)*(r + s - 1) + D1*bd1*f*(-40*C*r*s - 40*C*s**2 + 40*C*s - 6*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 3*f*(r*(4*s - 3) + 4*s**2 - 6*s + 2) + 28*r*s - 2*r + 28*s**2 - 28*s + 2) - 6*D1*bd2*f*(2*r - 1)*(r + s - 1) - 4*D1*(f*(fd*(2*C - 1)*(2*s - 1) - 6*gd2*r + 3*gd2) - 6*fd*g2*(r - 1))*(r + s - 1) - 6*Dd*b2*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) - 4*Dd*f*(f*(4*C - 2)*(2*s - 1)*(r + s - 1) - 3*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))))/(15*d**2*k3) - D1**3*Pk1*Pkd3*(-7*D1*b1*bd1*f*(2*k1**2*(40*C*r*s + 40*C*s**2 - 40*C*s + 2*K*(2*r**2 - 2*r*(4*s + 5) - 10*s**2 - s + 8) + f*(s + 1) - 20*r*s - 20*s**2 + 22*s - 2) + k2**2*(f*(-6*r**2 + 5*r*(4*s - 1) + 26*s**2 - 21*s + 3) - 10*r**2*(4*K - 2) - 10*r*(K*(8*s - 4) - 4*s + 3) - 10*s*(4*K*(s - 1) - 2*s + 1))) - 2*D1*bd1*f*(-14*b2*(9*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*f**2*(2*k1**2*(s - 1)*(5*r + 5*s - 4) + k2**2*(5*r**2 + 23*r*s - 17*r + 18*s**2 - 24*s + 6)) + f*(-2*k1**2*(K*(60*r**2 + 102*r*s - 81*r + 42*s**2 - 71*s + 29) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) - 7*k2**2*(r**2*(6*K - 3) + 2*r*(5*K*s - 2*K - 3*s + 3) + s*(4*K - 3)*(s - 1))) - 28*g2*(k1**2*(r**2 - r*(4*s + 1) + s*(2 - 5*s)) - 5*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)))) + 35*b1**3*(D1*fd*(4*k1**2*(s - 1) + k2**2*(3*r + 5*s - 5))*(r + s - 1) + Dd*f*(2*k1**2*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(12*r**2 + r*(32*s - 25) + 20*s**2 - 33*s + 13))) + 7*b1**2*(5*D1*bd1*f*(2*k1**2*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + k2**2*(9*r**2 + r*(24*s - 17) + 15*s**2 - 23*s + 8)) + 2*D1*fd*(k1**2*(-20*C*(s - 1)*(r + s - 1) + 2*K*(-r**2 + r*(4*s + 22) + 5*s**2 + 16*s - 11) + f*(5 - 7*s) + 10*r*(s - 1) + 10*s**2 - 24*s + 10) + k2**2*(f*(3*r**2 + r*(3 - 10*s) - 13*s**2 + 11*s - 2) + (10*K - 5)*(r + s)**2)) + Dd*f*(-4*k1**2*(20*C*(2*s - 1)*(r + s - 1) + 4*K*r**2 - 16*K*r*s - 41*K*r - 20*K*s**2 - 20*K*s + 27*K + 4*f*s - 2*f - 20*r*s + 10*r - 20*s**2 + 34*s - 12) + k2**2*(f*(12*r**2 + r*(11 - 40*s) - 52*s**2 + 43*s - 7) + 10*r**2*(8*K - 4) + 10*r*(16*K*s - 6*K - 8*s + 5) + 20*s*(4*K*s - 3*K - 2*s + 1)))) + 2*b1*(240*D1*K*f*fd*k1**2*r**2 + 408*D1*K*f*fd*k1**2*r*s - 240*D1*K*f*fd*k1**2*r + 168*D1*K*f*fd*k1**2*s**2 - 218*D1*K*f*fd*k1**2*s + 60*D1*K*f*fd*k1**2 + 84*D1*K*f*fd*k2**2*r**2 + 140*D1*K*f*fd*k2**2*r*s - 42*D1*K*f*fd*k2**2*r + 56*D1*K*f*fd*k2**2*s**2 - 42*D1*K*f*fd*k2**2*s + 14*D1*bd2*f*(k1**2*(9*r + 9*s + 1) + 5*k2**2*(r + s))*(r + s - 1) - 90*D1*f**2*fd*k1**2*r*s + 60*D1*f**2*fd*k1**2*r - 90*D1*f**2*fd*k1**2*s**2 + 117*D1*f**2*fd*k1**2*s - 39*D1*f**2*fd*k1**2 - 45*D1*f**2*fd*k2**2*r**2 - 207*D1*f**2*fd*k2**2*r*s + 132*D1*f**2*fd*k2**2*r - 162*D1*f**2*fd*k2**2*s**2 + 195*D1*f**2*fd*k2**2*s - 69*D1*f**2*fd*k2**2 - 48*D1*f*fd*k1**2*r*s - 48*D1*f*fd*k1**2*s**2 + 24*D1*f*fd*k1**2*s - 42*D1*f*fd*k2**2*r**2 - 84*D1*f*fd*k2**2*r*s + 21*D1*f*fd*k2**2*r - 42*D1*f*fd*k2**2*s**2 + 28*D1*f*gd2*k1**2*r**2 - 112*D1*f*gd2*k1**2*r*s - 252*D1*f*gd2*k1**2*r - 140*D1*f*gd2*k1**2*s**2 - 84*D1*f*gd2*k1**2*s + 224*D1*f*gd2*k1**2 - 140*D1*f*gd2*k2**2*r**2 - 280*D1*f*gd2*k2**2*r*s + 140*D1*f*gd2*k2**2*r - 140*D1*f*gd2*k2**2*s**2 + 140*D1*f*gd2*k2**2*s + 28*D1*fd*g2*k1**2*r**2 - 112*D1*fd*g2*k1**2*r*s - 616*D1*fd*g2*k1**2*r - 140*D1*fd*g2*k1**2*s**2 - 448*D1*fd*g2*k1**2*s + 308*D1*fd*g2*k1**2 - 140*D1*fd*g2*k2**2*r**2 - 280*D1*fd*g2*k2**2*r*s - 140*D1*fd*g2*k2**2*s**2 + 480*Dd*K*f**2*k1**2*r**2 + 816*Dd*K*f**2*k1**2*r*s - 564*Dd*K*f**2*k1**2*r + 336*Dd*K*f**2*k1**2*s**2 - 502*Dd*K*f**2*k1**2*s + 176*Dd*K*f**2*k1**2 + 168*Dd*K*f**2*k2**2*r**2 + 280*Dd*K*f**2*k2**2*r*s - 98*Dd*K*f**2*k2**2*r + 112*Dd*K*f**2*k2**2*s**2 - 98*Dd*K*f**2*k2**2*s - 120*Dd*f**3*k1**2*r*s + 90*Dd*f**3*k1**2*r - 120*Dd*f**3*k1**2*s**2 + 171*Dd*f**3*k1**2*s - 63*Dd*f**3*k1**2 - 60*Dd*f**3*k2**2*r**2 - 276*Dd*f**3*k2**2*r*s + 183*Dd*f**3*k2**2*r - 216*Dd*f**3*k2**2*s**2 + 267*Dd*f**3*k2**2*s - 87*Dd*f**3*k2**2 - 96*Dd*f**2*k1**2*r*s + 24*Dd*f**2*k1**2*r - 96*Dd*f**2*k1**2*s**2 + 84*Dd*f**2*k1**2*s - 12*Dd*f**2*k1**2 - 84*Dd*f**2*k2**2*r**2 - 168*Dd*f**2*k2**2*r*s + 105*Dd*f**2*k2**2*r - 84*Dd*f**2*k2**2*s**2 + 42*Dd*f**2*k2**2*s + 112*Dd*f*g2*k1**2*r**2 - 448*Dd*f*g2*k1**2*r*s - 1148*Dd*f*g2*k1**2*r - 560*Dd*f*g2*k1**2*s**2 - 560*Dd*f*g2*k1**2*s + 756*Dd*f*g2*k1**2 - 560*Dd*f*g2*k2**2*r**2 - 1120*Dd*f*g2*k2**2*r*s + 420*Dd*f*g2*k2**2*r - 560*Dd*f*g2*k2**2*s**2 + 420*Dd*f*g2*k2**2*s + 14*b2*(D1*fd*(k1**2*(9*r**2 + 18*r*s + 2*r + 9*s**2 + 2*s - 1) + 5*k2**2*(r + s)**2) + Dd*f*(k1**2*(9*r + 9*s + 1) + 5*k2**2*(r + s))*(4*r + 4*s - 3))) + 4*f*(54*C*D1*f*fd*k1**2*r*s - 18*C*D1*f*fd*k1**2*r + 54*C*D1*f*fd*k1**2*s**2 - 72*C*D1*f*fd*k1**2*s + 18*C*D1*f*fd*k1**2 + 72*C*Dd*f**2*k1**2*r*s - 36*C*Dd*f**2*k1**2*r + 72*C*Dd*f**2*k1**2*s**2 - 108*C*Dd*f**2*k1**2*s + 36*C*Dd*f**2*k1**2 + D1*b2*fd*(k1**2*(120*r**2 + 12*r*(17*s - 10) + 84*s**2 - 109*s + 30) + 7*k2**2*(6*r**2 + r*(10*s - 3) + s*(4*s - 3))) + D1*bd2*f*(k1**2*(60*r**2 + 3*r*(34*s - 27) + 42*s**2 - 71*s + 29) + 7*k2**2*(3*r**2 + r*(5*s - 2) + s*(2*s - 2))) - 27*D1*f*fd*k1**2*r*s + 9*D1*f*fd*k1**2*r - 27*D1*f*fd*k1**2*s**2 + 36*D1*f*fd*k1**2*s - 9*D1*f*fd*k1**2 - 120*D1*f*gd2*k1**2*r**2 - 204*D1*f*gd2*k1**2*r*s + 162*D1*f*gd2*k1**2*r - 84*D1*f*gd2*k1**2*s**2 + 142*D1*f*gd2*k1**2*s - 58*D1*f*gd2*k1**2 - 42*D1*f*gd2*k2**2*r**2 - 70*D1*f*gd2*k2**2*r*s + 28*D1*f*gd2*k2**2*r - 28*D1*f*gd2*k2**2*s**2 + 28*D1*f*gd2*k2**2*s - 240*D1*fd*g2*k1**2*r**2 - 408*D1*fd*g2*k1**2*r*s + 240*D1*fd*g2*k1**2*r - 168*D1*fd*g2*k1**2*s**2 + 218*D1*fd*g2*k1**2*s - 60*D1*fd*g2*k1**2 - 84*D1*fd*g2*k2**2*r**2 - 140*D1*fd*g2*k2**2*r*s + 42*D1*fd*g2*k2**2*r - 56*D1*fd*g2*k2**2*s**2 + 42*D1*fd*g2*k2**2*s + Dd*b2*f*(k1**2*(240*r**2 + 6*r*(68*s - 47) + 168*s**2 - 251*s + 88) + 7*k2**2*(12*r**2 + r*(20*s - 7) + s*(8*s - 7))) - 36*Dd*f**2*k1**2*r*s + 18*Dd*f**2*k1**2*r - 36*Dd*f**2*k1**2*s**2 + 54*Dd*f**2*k1**2*s - 18*Dd*f**2*k1**2 - 480*Dd*f*g2*k1**2*r**2 - 816*Dd*f*g2*k1**2*r*s + 564*Dd*f*g2*k1**2*r - 336*Dd*f*g2*k1**2*s**2 + 502*Dd*f*g2*k1**2*s - 176*Dd*f*g2*k1**2 - 168*Dd*f*g2*k2**2*r**2 - 280*Dd*f*g2*k2**2*r*s + 98*Dd*f*g2*k2**2*r - 112*Dd*f*g2*k2**2*s**2 + 98*Dd*f*g2*k2**2*s))/(105*d**2*k3**3) + D1**3*Pk1*Pkd3*st**4*(11*D1*bd1*f*(f**2*k2**4*(168*r**2 + r*(348*s - 275) + 180*s**2 - 343*s + 115) + 3*f*(k1**4*(8*C - 4)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) - 2*k1**2*k2**2*(2*C*(21*r**2 + r*(74*s - 69) + 53*s**2 - 79*s + 48) - 26*r**2 + r*(80 - 84*s) - 58*s**2 + 83*s - 54) + k2**4*(28*C*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) - 2*K*(18*r**2 + 28*r*s - 23*r + 10*s**2 - 17*s + 7) + b1*(16*r**2 + r*(4*s + 25) - 12*s**2 + 53*s - 41) - 300*r**2 - 440*r*s + 412*r - 140*s**2 + 292*s - 110)) - 42*k2**2*(5*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(5 - 10*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(2*K*s*(5*s - 6) + r**2*(18*K - 4) + r*(4*K*(7*s - 4) - 4*s + 3) + s)) + k2**2*(5*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(9*r**2 + r*(14*s - 9) + s*(5*s - 7))))) - 2310*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**2*(140*C - 70)*(r + s - 1)**2 + k2**2*(f*(16*r**2 + r*(4*s + 23) - 12*s**2 + 37*s - 13) + (-14*r - 14*s)*(5*K*s + r*(9*K - 2)))) + 2*Dd*f*(k1**2*(70*C - 35)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-7*K*s*(20*s - 17) + f*(16*r**2 + 4*r*(s + 6) - 12*s**2 + 45*s - 27) - 7*r**2*(36*K - 8) - 7*r*(K*(56*s - 23) - 8*s + 4) - 7*s))) + 11*b1*(3*D1*(f**2*fd*k2**4*(168*r**2 + r*(348*s - 227) + 180*s**2 - 277*s + 105) + 2*f*(fd*(k1**4*(4*C - 2)*(2*s - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(-2*C*(42*r**2 + r*(148*s - 117) + 106*s**2 - 135*s + 36) + 52*r**2 + 3*r*(56*s - 47) + 116*s**2 - 152*s + 42) + k2**4*(2*r + 2*s - 1)*(14*C*(18*r + 10*s - 5) + K*(-18*r - 10*s + 9) - 150*r - 70*s + 33)) - 7*k2**4*(5*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(9*r**2 + 7*r*(2*s - 1) + s*(5*s - 5)))) - 14*fd*k2**4*(r + s)*(5*b2*(r + s) - 2*g2*(9*r + 5*s))) + 2*Dd*f*(f**2*k2**4*(336*r**2 + r*(696*s - 478) + 360*s**2 - 587*s + 215) + 3*f*(k1**4*(20*C - 10)*(2*s - 1)*(2*r + 2*s - 3) + k1**2*k2**2*(-2*C*(84*r**2 + r*(296*s - 275) + 212*s**2 - 313*s + 130) + 104*r**2 + 8*r*(42*s - 41) + 232*s**2 - 345*s + 148) + k2**4*(14*C*(72*r**2 + 2*r*(56*s - 37) + 40*s**2 - 54*s + 17) - K*(72*r**2 + 112*r*s - 82*r + 40*s**2 - 62*s + 23) - 600*r**2 - 880*r*s + 586*r - 280*s**2 + 386*s - 122)) - 21*k2**4*(5*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 2*g2*(36*r**2 + r*(56*s - 23) + s*(20*s - 17))))) + 2*f*(D1*(f**2*fd*k2**4*(804*r**2 + r*(716*s - 793) - 88*s**2 - 113*s + 137) + 33*f*(fd*(k1**4*(4*C - 2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(36*r**2 + 96*r*s - 41*r + 60*s**2 - 65*s + 14) + 45*r**2 + 108*r*s - 55*r + 63*s**2 - 74*s + 19) + k2**4*(2*C*(54*r**2 + 84*r*s - 53*r + 30*s**2 - 39*s + 12) - 66*r**2 - 96*r*s + 62*r - 30*s**2 + 41*s - 13)) + k2**4*(-5*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*gd2*(18*r**2 + r*(28*s - 23) + 10*s**2 - 17*s + 7))) - 33*fd*k2**4*(5*b2*(2*r + 2*s - 1) - 2*g2*(18*r + 10*s - 9))*(2*r + 2*s - 1)) + Dd*f*(f**2*k2**4*(804*r**2 + r*(716*s - 793) - 88*s**2 - 113*s + 137) + 33*f*(k1**4*(4*C - 2)*(3*s - 1)*(4*r + 4*s - 3) + k1**2*k2**2*(-2*C*(48*r**2 + 64*r*(2*s - 1) + 80*s**2 - 96*s + 25) + 60*r**2 + 144*r*s - 85*r + 84*s**2 - 109*s + 33) + 2*k2**4*(C*(72*r**2 + 112*r*s - 74*r + 40*s**2 - 54*s + 17) - 44*r**2 - 64*r*s + 43*r - 20*s**2 + 28*s - 9)) - 33*k2**4*(5*b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*g2*(72*r**2 + 2*r*(56*s - 41) + 40*s**2 - 62*s + 23)))))/(1155*d**2*k3**5) - D1**3*Pk1*Pkd3*st**2*(11*D1*bd1*f*(f**2*k2**2*(k1**2*(195*r**2 + 2*r*(69*s - 107) - 57*s**2 - 58*s + 99) + 9*k2**2*(60*r**2 + r*(88*s - 69) + 28*s**2 - 49*s + 9)) - 6*f*(2*k1**4*(C*(32*r**2 + r*(50*s + 9) + 18*s**2 + 51*s - 41) - 16*r**2 - 2*r*(13*s + 3) - 10*s**2 - 28*s + 22) + k1**2*k2**2*(14*C*(37*r**2 + r*(70*s - 62) + 33*s**2 - 54*s + 25) - 7*K*(6*r**2 + 12*r*s - r + 6*s**2 - 3*s - 3) - 279*r**2 - 530*r*s + 443*r - 251*s**2 + 387*s - 171) + 7*k2**4*(5*K*s*(s - 1) + r**2*(9*K - 2) + r*(7*K - 1)*(2*s - 1))) + 42*k2**2*(5*b2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*g2*(2*k1**2*(3*r**2 + r*(7*s - 3) + 2*s*(2*s - 3)) + 5*k2**2*(9*r**2 + r*(14*s - 9) + s*(5*s - 7))))) + 1155*b1**3*k2**2*(k1**2 - 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(35*bd1*f*k2**2*(k1**2 - 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(70 - 140*C)*(r + s - 1)**2 + k1**2*k2**2*(700*C*(r + s - 1)**2 - 14*K*(6*r**2 + 2*r*(7*s - 5) + 8*s**2 - 10*s + 5) + f*(376*r**2 + r*(920*s - 427) + 544*s**2 - 511*s + 127) - 364*r**2 - 728*r*s + 700*r - 364*s**2 + 700*s - 350) + 7*k2**4*(f*(136*r**2 + r*(284*s - 169) + 148*s**2 - 173*s + 57) + (-10*r - 10*s)*(5*K*s + r*(9*K - 2))))) + 2*Dd*f*(k1**4*(35 - 70*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(350*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(24*r**2 + r*(56*s - 30) + 32*s**2 - 48*s + 15) + 2*f*(188*r**2 + 460*r*s - 253*r + 272*s**2 - 316*s + 84) - 728*r**2 - 28*r*(52*s - 47) - 728*s**2 + 1211*s - 525) + 7*k2**4*(-5*K*s*(20*s - 17) + 2*f*(68*r**2 + 2*r*(71*s - 47) + 74*s**2 - 96*s + 31) - 5*r**2*(36*K - 8) - 5*r*(K*(56*s - 23) - 8*s + 4) - 5*s))) + 11*b1*(3*D1*bd1*f*(k1**4*(70 - 140*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(700*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*K*(12*r**2 + 28*r*s - 13*r + 16*s**2 - 25*s + 5) + f*(376*r**2 + r*(920*s - 585) + 544*s**2 - 753*s + 209) - 728*r**2 - 1456*r*s + 1148*r - 728*s**2 + 1008*s - 350) + 7*k2**4*(-20*K*s*(5*s - 6) + f*(136*r**2 + r*(284*s - 207) + 148*s**2 - 211*s + 67) - 10*r**2*(18*K - 4) - 10*r*(4*K*(7*s - 4) - 4*s + 3) - 10*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(195*r**2 + r*(138*s - 245) - 57*s**2 - 125*s + 98) + 3*k2**2*(180*r**2 + r*(264*s - 191) + 84*s**2 - 131*s + 59)) - 2*f*(fd*(k1**4*(2*C*(64*r**2 + 5*r*(20*s + 13) + 36*s**2 + 135*s - 79) - 64*r**2 - 2*r*(52*s + 35) - 40*s**2 - 145*s + 85) + k1**2*k2**2*(14*C*(74*r**2 + 4*r*(35*s - 19) + 66*s**2 - 68*s + 15) - 7*K*(12*r**2 + 24*r*s + 8*r + 12*s**2 + 2*s - 7) - 558*r**2 - 1060*r*s + 572*r - 502*s**2 + 516*s - 115) + 7*k2**4*(K*s*(10*s - 7) + r**2*(18*K - 4) + r*(K*(28*s - 9) - 4*s + 2) + s)) - 7*k2**2*(5*bd2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(6*r**2 + 7*r*(2*s - 1) + 8*s**2 - 13*s + 5) + 5*k2**2*(9*r**2 + 7*r*(2*s - 1) + s*(5*s - 5))))) + 14*fd*k2**2*(5*b2*(k1**2 - 5*k2**2)*(r + s)**2 + 2*g2*(k1**2*(6*r**2 + 2*r*(7*s - 5) + 8*s**2 - 10*s + 5) + 5*k2**2*(9*r**2 + 14*r*s + 5*s**2)))) + Dd*f*(f**2*k2**2*(k1**2*(780*r**2 + r*(552*s - 949) - 228*s**2 - 433*s + 393) + 36*k2**2*(60*r**2 + r*(88*s - 65) + 28*s**2 - 45*s + 17)) - 6*f*(k1**4*(4*C*(64*r**2 + 4*r*(25*s + 11) + 36*s**2 + 121*s - 97) - 128*r**2 - 2*r*(104*s + 49) - 80*s**2 - 261*s + 209) + k1**2*k2**2*(14*C*(148*r**2 + r*(280*s - 199) + 132*s**2 - 175*s + 60) - 7*K*(24*r**2 + 48*r*s + 6*r + 24*s**2 - 4*s - 13) - 1116*r**2 - 2120*r*s + 1465*r - 1004*s**2 + 1297*s - 429) + 7*k2**4*(K*s*(20*s - 17) + r**2*(36*K - 8) + r*(K*(56*s - 23) - 8*s + 4) + s)) + 42*k2**2*(5*b2*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(24*r**2 + r*(56*s - 30) + 32*s**2 - 48*s + 15) + 5*k2**2*(36*r**2 + r*(56*s - 23) + s*(20*s - 17)))))) - 2*f*(D1*(f**2*fd*k2**2*(k1**2*(1840*r**2 + 10*r*(492*s - 371) + 3080*s**2 - 4959*s + 1907) + 11*k2**2*(180*r**2 + r*(612*s - 401) + 432*s**2 - 549*s + 179)) + 11*f*(fd*k1**2*(k1**2*(2*C*(261*r**2 + 9*r*(38*s - 17) + 81*s**2 - 87*s + 4) - 261*r**2 - 360*r*s + 141*r - 99*s**2 + 78*s + 7) + 9*k2**2*(C*(252*r**2 + 6*r*(76*s - 53) + 204*s**2 - 274*s + 96) - 141*r**2 - 3*r*(84*s - 58) - 111*s**2 + 147*s - 51)) + 3*k2**2*(-5*bd2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1) + 14*gd2*(k1**2*(6*r**2 + r*(12*s - 1) + 6*s**2 - 3*s - 3) + k2**2*(-9*r**2 + r*(7 - 14*s) - s*(5*s - 5))))) + 33*fd*k2**2*(-5*b2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1) + 14*g2*(k1**2*(12*r**2 + 8*r*(3*s + 1) + 12*s**2 + 2*s - 7) + k2**2*(-18*r**2 + r*(9 - 28*s) + s*(7 - 10*s))))) + Dd*f*(f**2*k2**2*(k1**2*(1840*r**2 + 10*r*(492*s - 371) + 3080*s**2 - 4959*s + 1907) + 11*k2**2*(180*r**2 + r*(612*s - 401) + 432*s**2 - 549*s + 179)) + 11*f*k1**2*(k1**2*(2*C*(348*r**2 + 456*r*s - 213*r + 108*s**2 - 115*s + 5) - 348*r**2 - 480*r*s + 199*r - 132*s**2 + 106*s + 12) + 9*k2**2*(2*C*(168*r**2 + 304*r*s - 226*r + 136*s**2 - 194*s + 71) - 188*r**2 - 336*r*s + 249*r - 148*s**2 + 209*s - 76)) + 33*k2**2*(-5*b2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(4*r + 4*s - 3) + 14*g2*(k1**2*(24*r**2 + 6*r*(8*s + 1) + 24*s**2 - 4*s - 13) + k2**2*(-36*r**2 + r*(23 - 56*s) + s*(17 - 20*s)))))))/(3465*d**2*k3**5) - 2*D1**3*Pk1*Pkd3*st**4*(D1*bd1*f**2*(k1**2*(4*C - 2)*(r*(4*s - 1) + s*(4*s - 3)) + k2**2*(4*r**2 + r*(4*s - 3) - s)) + 7*b1**2*(2*D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*r)*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(8*r**2 + 8*r*(s - 1) - s + 1))) + b1*f*(7*D1*bd1*(k1**2*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k2**2*(4*r**2 + 4*r*(s - 1) - s + 1)) + 4*D1*fd*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(2*r - 1))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(2*s - 1)*(8*r + 8*s - 7) + k2**2*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5))))/(35*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*st**2*(D1*bd1*f**2*(k1**2*(r**2*(24 - 48*C) + r*(8*C*s + 36*C - 2*s - 15) + 2*s*(28*C*s - 22*C - 13*s + 12)) + 7*k2**2*r*(2*r + 2*s - 1)) + 14*b1**3*k2**2*(2*D1*fd*r*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + b1**2*(14*D1*bd1*f*k2**2*(6*r**2 + 6*r*(s - 1) - s + 1) + D1*fd*(k1**2*(140*C - 84)*(s - 1) + k2**2*(12*f*r + f + 56*r + 14))*(r + s - 1) + 7*Dd*f*k1**2*(40*C*(2*s - 1)*(r + s - 1) + r*(26 - 48*s) - 48*s**2 + 73*s - 25) + Dd*f*k2**2*(f*(24*r**2 + 8*r*(3*s - 2) + 5*s - 3) + 224*r**2 + 28*r*(8*s - 7) + 7)) + b1*f*(D1*bd1*(7*k1**2*(r*(s*(40*C - 24) + 2) + (s - 1)*(s*(40*C - 24) + 1)) + k2**2*(f*(12*r**2 + 12*r*s - 5*r + 4*s - 2) + 112*r**2 + 112*r*s - 105*r - 21*s + 28)) - D1*fd*(k1**2*(8*C*(12*r - 14*s + 1) - 48*r + 52*s - 9) + 7*k2**2*(1 - 4*r))*(r + s - 1) + Dd*f*(k1**2*(-4*C*(48*r**2 - 8*r*(s + 4) - 56*s**2 + 66*s - 13) + 96*r**2 - 8*r*s - 54*r - 104*s**2 + 135*s - 33) + 7*k2**2*(8*r**2 + 8*r*(s - 1) - s + 1))))/(105*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*st**4*(3*b1**2*(D1*fd*(k1**4*(56*C - 28)*(s - 1)*(r + s - 1) - 7*k1**2*k2**2*(r + s - 1)*(2*C*(5*r + s - 1) - 7*r - s + 1) + 2*k2**4*r*(4*f*(4*r + 4*s - 3) - 7*r - 7*s)) + Dd*f*(k1**4*(28*C - 14)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) - 7*k1**2*k2**2*(2*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) - 28*r**2 + r*(31 - 32*s) - 4*s**2 + 10*s - 6) + k2**4*(2*f*(8*r - 1)*(4*r + 4*s - 3) - 56*r**2 + 7*r*(4 - 8*s) + 7*s))) + b1*f*(3*D1*bd1*(k1**4*(28*C - 14)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 7*k1**2*k2**2*(2*C*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3) - 14*r**2 - 16*r*s + 15*r - 2*s**2 + 6*s - 4) + k2**4*(2*f*(4*r - 1)*(4*r + 4*s - 3) - 28*r**2 + 7*r*(3 - 4*s) + 7*s)) + D1*fd*(k1**4*(6 - 12*C)*(2*s - 1)*(r + s - 2) - 3*k1**2*k2**2*(4*C*(24*r**2 - r*(2*s + 9) - 26*s**2 + 20*s - 1) - 46*r**2 + 2*r*(8*s + 3) + 62*s**2 - 53*s + 4) + k2**4*(f*(36*r**2 + 3*r*(12*s - 5) + 6*s - 8) + (72*r + 6)*(2*r + 2*s - 1))) + Dd*f*(k1**4*(12 - 24*C)*(2*s - 1)*(r + s - 4) - 3*k1**2*k2**2*(4*C*(48*r**2 - 4*r*(s + 5) - 52*s**2 + 43*s - 6) - 92*r**2 + r*(32*s + 7) + 124*s**2 - 112*s + 25) + k2**4*(2*f*(24*r**2 + 24*r*s - 8*r + 5*s - 5) + 288*r**2 + 3*r*(96*s - 68) - 24*s + 9))) + f**2*(D1*bd1*(k1**4*(6 - 12*C)*(r*(s - 2) + s**2 - 9*s + 3) - 3*k1**2*k2**2*(r**2*(48*C - 23) + r*(-4*C*(s + 11) + 8*s + 14) + s**2*(31 - 52*C) + s*(20*C - 13) + 6) + k2**4*(f*(12*r**2 + r*(12*s - 1) + 4*s - 2) + 72*r**2 + r*(72*s - 93) - 39*s + 18)) - 3*D1*fd*(k1**4*(4*C - 2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2**2*(-4*C*r*(3*s + 8) + r**2*(36*C - 9) + 18*r*s + 2*r + s**2*(27 - 48*C) + s*(40*C - 29) + 5) + k2**4*(-12*r**2 + r*(9 - 12*s) + 2*s - 1)) - 3*Dd*f*(k1**4*(4*C - 2)*(3*s - 1)*(4*r + 4*s - 3) + k1**2*k2**2*(4*C*(12*r**2 - 4*r*s - 9*r - 16*s**2 + 16*s - 2) - 12*r**2 + 24*r*s - 3*r + 36*s**2 - 45*s + 12) + k2**4*(-16*r**2 - 4*r*(4*s - 3) + 2*s - 1))))/(105*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*st**2*(-21*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(11*r + 21*s - 21) + 3*b1**2*(D1*(-7*bd1*f*k1**2*k2**2*(33*r**2 + r*(96*s - 85) + 63*s**2 - 105*s + 42) - 2*fd*(7*k1**4*(r + s - 1)*(10*C*(r + 3*s - 3) - 5*r - 17*s + 17) + k1**2*k2**2*(-70*C*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 7*K*(15*r**2 + 26*r*s - 10*r + 11*s**2 - 6*s + 5) - f*(99*r**2 + 2*r*(135*s - 68) + 171*s**2 - 259*s + 88) + 238*r**2 + 280*r*s - 252*r + 42*s**2 - 56*s + 21) - 70*k2**4*r*(r + s))) + Dd*f*(-14*k1**4*(10*C*(4*r**2 + r*(16*s - 11) + 12*s**2 - 19*s + 7) - 20*r**2 + r*(61 - 88*s) - 68*s**2 + 108*s - 40) + k1**2*k2**2*(140*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) - 14*K*(60*r**2 + r*(104*s - 61) + 44*s**2 - 47*s + 11) + f*(396*r**2 + 3*r*(360*s - 223) + 684*s**2 - 1121*s + 397) - 1904*r**2 - 56*r*(40*s - 39) - 336*s**2 + 602*s - 364) + 70*k2**4*(8*r**2 + r*(8*s - 4) - s))) + b1*(3*D1*bd1*f*(-14*k1**4*(10*C*(2*r**2 + r*(8*s - 3) + 6*s**2 - 7*s + 1) - 10*r**2 + r*(17 - 44*s) - 34*s**2 + 40*s - 6) + k1**2*k2**2*(140*C*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3) - 14*K*(30*r**2 + 52*r*s - 33*r + 22*s**2 - 27*s + 3) + f*(198*r**2 + r*(540*s - 397) + 342*s**2 - 603*s + 221) - 952*r**2 - 1120*r*s + 1078*r - 168*s**2 + 350*s - 266) + 70*k2**4*(4*r**2 + r*(4*s - 3) - s)) + 6*D1*(f**2*fd*k1**2*k2**2*(129*r**2 + r*(183*s - 193) + 54*s**2 - 142*s + 78) + f*(fd*(k1**4*(4*C*(r**2 - 4*r*(9*s + 8) - 37*s**2 - 15*s + 24) - 2*r**2 + 8*r*(9*s + 8) + 74*s**2 + 39*s - 49) + k1**2*k2**2*(-28*C*(r**2 + 3*r*(4*s - 1) + 11*s**2 - 9*s + 1) - 2*K*(30*r**2 + 30*r*s - 37*r - 8*s + 11) + 26*r**2 + 220*r*s - 47*r + 194*s**2 - 159*s + 17) + 7*k2**4*(4*r**2 + r*(4*s - 2) - s)) - 7*k1**2*k2**2*(bd2*(11*r + 11*s - 1) - 2*gd2*(15*r + 11*s - 3))*(r + s - 1)) - 7*fd*k1**2*k2**2*(b2*(11*r**2 + r*(22*s - 2) + 11*s**2 - 2*s + 1) - 2*g2*(15*r**2 + 2*r*(13*s - 5) + 11*s**2 - 6*s + 5))) + 2*Dd*f*(f**2*k1**2*k2**2*(516*r**2 + r*(732*s - 731) + 216*s**2 - 506*s + 258) + 3*f*(k1**4*(2*C*(4*r**2 - r*(144*s + 71) - 148*s**2 - 29*s + 87) - 4*r**2 + r*(144*s + 71) + 148*s**2 + 45*s - 95) + k1**2*k2**2*(-14*C*(4*r**2 + r*(48*s - 23) + 44*s**2 - 45*s + 11) - 6*K*(20*r**2 + 20*r*s - 27*r - 4*s + 5) + 52*r**2 + 440*r*s - 177*r + 388*s**2 - 380*s + 79) + 7*k2**4*(8*r**2 + r*(8*s - 4) - s)) - 21*k1**2*k2**2*(b2*(44*r**2 + r*(88*s - 37) + 44*s**2 - 37*s + 3) - 2*g2*(60*r**2 + r*(104*s - 61) + 44*s**2 - 47*s + 11)))) + 2*f*(D1*bd1*(f**2*k1**2*k2**2*(129*r**2 + r*(183*s - 152) + 54*s**2 - 80*s + 24) + 3*f*(k1**4*(2*C*(r**2 - 9*r*(4*s + 1) - 37*s**2 - 11*s + 14) - r**2 + 9*r*(4*s + 1) + 37*s**2 + 14*s - 17) + k1**2*k2**2*(-14*C*(r**2 + r*(12*s - 7) + 11*s**2 - 11*s + 4) + K*(-30*r**2 - 30*r*s + 44*r + 4*s - 4) + 13*r**2 + 110*r*s - 51*r + 97*s**2 - 86*s + 24) + 7*k2**4*r*(2*r + 2*s - 1)) - 21*k1**2*k2**2*(11*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(15*r**2 + r*(26*s - 15) + s*(11*s - 13)))) + k1**2*(D1*(f*(fd*(k1**2*(-4*C*(3*r - 1)*(30*r + 30*s - 11) + 180*r**2 + 6*r*(33*s - 19) + 18*s**2 - 51*s + 11) - 9*k2**2*(4*C*(9*r**2 + r*(21*s - 13) + 12*s**2 - 13*s + 4) - 33*r**2 + r*(41 - 66*s) - 33*s**2 + 36*s - 11)) + k2**2*(-6*bd2 + 12*gd2)*(15*r**2 + r*(15*s - 22) - 2*s + 2)) - 6*fd*k2**2*(b2 - 2*g2)*(30*r**2 + r*(30*s - 37) - 8*s + 11)) + Dd*f*(f*(k1**2*(-4*C*(120*r**2 + 12*r*(10*s - 7) - 35*s + 16) + 240*r**2 + 22*r*(12*s - 7) + 24*s**2 - 61*s + 15) - 9*k2**2*(4*C*(12*r**2 + r*(28*s - 19) + 16*s**2 - 19*s + 6) - 44*r**2 + r*(61 - 88*s) - 44*s**2 + 53*s - 17)) + k2**2*(-18*b2 + 36*g2)*(20*r**2 + r*(20*s - 27) - 4*s + 5)))))/(315*d**2*k1**2*k3**3) - D1**3*Pk1*Pkdd3*ct**8*f*k2**6*(4*C - 4)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(12*r + 12*s - 5))/(63*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**7*f*k2**5*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(12*r + 12*s - 5))/(63*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**7*f*k2**5*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*k1**2*(2*r + 2*s - 1)*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 18*k1**2*(C*(78*r + 78*s - 46) - 68*r - 68*s + 41))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(21*f*k2**2*(52*r**2 + r*(104*s - 67) + 52*s**2 - 67*s + 21) + 22*k1**2*(3*r + 3*s - 2)*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37)) + Dd*f*(21*f*k2**2*(13*r + 13*s - 7) + 22*k1**2*(6*C*(15*r + 15*s - 7) - 78*r - 78*s + 37))*(4*r + 4*s - 3)))/(3465*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**6*f*k2**6*st**2*(4*C - 4)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(9*r + 9*s - 4))/(21*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**6*k2**4*(126*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 9*b1*f*(14*D1*bd1*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*fd*(-2*C*(14*r**2 + 4*r*(7*s - 2) + 14*s**2 - 8*s - 1) + 46*r**2 + r*(92*s - 41) + 46*s**2 - 41*s + 6) - Dd*f*(4*r + 4*s - 3)*(2*C*(7*r + 7*s - 2) - 23*r - 23*s + 12)) + f**2*(-9*D1*bd1*(r + s - 1)*(2*C*(7*r + 7*s - 5) - 23*r - 23*s + 18) - (5*D1*fd*(3*r + 3*s - 2) + 5*Dd*f*(4*r + 4*s - 3))*(2*C*(12*r + 12*s - 5) - 33*r - 33*s + 16)))/(315*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct**6*k2**4*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + 3*K*r + 3*K*s + 2*K - 10*b1*(2*r + 2*s - 1) + 25*r + 25*s - 16)) + k2**2*(r + s)*(252*K*b1 - 252*b1 - 252*g2)) + 198*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) + 18*f*(fd*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 252*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(69*r + 69*s - 49) + 18*f*(k1**2*(8*C*(13*r + 13*s - 10) - 75*r - 75*s + 62) + k2**2*(-14*C*(2*r + 2*s - 1) + K*(3*r + 3*s + 2) + 25*r + 25*s - 16)) - 252*g2*k2**2*(r + s))) + f*(D1*(-35*f**2*fd*k2**2*(428*r**2 + r*(856*s - 565) + 428*s**2 - 565*s + 183) - 22*f*(5*fd*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(3*r**2 + r*(6*s - 1) + 3*s**2 - s - 2)) + 396*fd*g2*k2**2*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(107*r + 107*s - 61) + 110*f*(k1**2*(12*C*(9*r + 9*s - 5) - 75*r - 75*s + 44) + k2**2*(18 - 18*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(3*r + 3*s + 2))))/(3465*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**5*f*k2**5*st**2*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(9*r + 9*s - 4))/(21*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**5*f*k2**5*st**2*(33*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(r + s - 1) + 33*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(28*C*(7*r + 7*s - 4) - 166*r - 166*s + 97))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(908*r**2 + r*(1816*s - 1197) + 908*s**2 - 1197*s + 387) + 22*k1**2*(3*r + 3*s - 2)*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368)) + Dd*f*(15*f*k2**2*(227*r + 227*s - 129) + 22*k1**2*(C*(912*r + 912*s - 428) - 777*r - 777*s + 368))*(4*r + 4*s - 3)))/(3465*d**2*k1*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**5*k2**3*(r + s - 1)*(3*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k1*k3**2) - D1**3*Pk1*Pkdd3*ct**5*k2**3*(3*b1**2*(D1*fd*(k1**2*(196*C - 154)*(r + s - 1)**2 + 3*k2**2*(f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + 14*(r + s)**2)) + 2*Dd*f*(k1**2*(98*C - 77)*(r + s - 1) + 3*k2**2*(f*(13*r + 13*s - 8) + 7*r + 7*s))*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(k1**2*(196*C - 154)*(2*r + 2*s - 1) + 3*k2**2*(f*(52*r + 52*s - 19) + 28*r + 28*s))*(r + s - 1) + D1*fd*(-18*k1**2*(2*C*(28*r**2 + 56*r*s - 25*r + 28*s**2 - 25*s + 3) - 32*r**2 - 64*r*s + 39*r - 32*s**2 + 39*s - 8) + k2**2*(5*f*(90*r**2 + 3*r*(60*s - 41) + 90*s**2 - 123*s + 47) - 396*r**2 - 18*r*(44*s - 29) - 396*s**2 + 522*s - 162)) + 2*Dd*f*(-9*k1**2*(4*C*(7*r + 7*s - 4) - 16*r - 16*s + 15) + k2**2*(5*f*(15*r + 15*s - 8) - 99*r - 99*s + 81))*(4*r + 4*s - 3)) + f**2*(-D1*bd1*(36*k1**2*(C*(14*r + 14*s - 13) - 8*r - 8*s + 11) + k2**2*(-5*f*(30*r + 30*s - 1) + 198*r + 198*s - 162))*(r + s - 1) - (k1**2*(C*(42*r + 42*s - 22) - 21*r - 21*s + 14) + 9*k2**2*(2*r + 2*s - 1))*(10*D1*fd*(3*r + 3*s - 2) + 10*Dd*f*(4*r + 4*s - 3))))/(315*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*ct**5*k2**3*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*r + 4*K*s + 12*K + b1*(-51*r - 51*s + 29) + 111*r + 111*s - 73)) + k1**2*k2**2*(r + s)*(-84*b1*(5 - 8*K) - 672*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (70 - 112*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (70 - 112*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(3*fd*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73))*(2*r + 2*s - 1) - 112*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 672*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(12*C*(3*r + 3*s - 5) - 13*r - 13*s + 38) + k2**2*(-14*C*(9*r + 9*s - 5) + 4*K*(r + s + 3) + 111*r + 111*s - 73)) - 672*g2*k1**2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(k1**2*(-71*r - 71*s + 45) + 11*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(5*fd*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 72*gd2*k2**2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3)) + 1584*fd*g2*k1**2*k2**2*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(71*r + 71*s - 45) - 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(4*C*(3*r + 3*s - 5) + 9*r + 9*s + 6) - 9*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 1584*g2*k1**2*k2**2*(r + s + 3))))/(3465*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**4*f*k2**6*st**4*(4*C - 4)*(2*r + 2*s - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**4*k2**4*st**2*(252*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 9*b1*f*(28*D1*bd1*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*fd*(-10*C*(10*r**2 + 4*r*(5*s - 2) + 10*s**2 - 8*s + 1) + 116*r**2 + 2*r*(116*s - 55) + 116*s**2 - 110*s + 21) - Dd*f*(4*r + 4*s - 3)*(10*C*(5*r + 5*s - 2) - 58*r - 58*s + 31)) + f**2*(-9*D1*bd1*(r + s - 1)*(10*C*(5*r + 5*s - 3) - 58*r - 58*s + 41) - (D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(30*C*(9*r + 9*s - 4) - 321*r - 321*s + 154)))/(315*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct**4*k2**4*st**2*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K - 30*b1*(2*r + 2*s - 1) + 51*r + 51*s - 29)) + k2**2*(r + s)*(168*K*b1 - 168*b1 - 168*g2)) + 198*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (14 - 14*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (14 - 14*K)*(r + s))*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) + 6*f*(fd*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(51*r + 51*s - 35) + 6*f*(k1**2*(2*C*(115*r + 115*s - 82) - 162*r - 162*s + 123) + k2**2*(-28*C*(2*r + 2*s - 1) + 5*K*r + 5*K*s + K + 51*r + 51*s - 29)) - 168*g2*k2**2*(r + s))) - f*(D1*(25*f**2*fd*k2**2*(1204*r**2 + r*(2408*s - 1619) + 1204*s**2 - 1619*s + 537) + 22*f*(fd*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 18*gd2*k2**2*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1)) - 396*fd*g2*k2**2*(10*r**2 + r*(20*s - 3) + 10*s**2 - 3*s - 1)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(301*r + 301*s - 179) + 22*f*(k1**2*(2*C*(561*r + 561*s - 284) - 801*r - 801*s + 414) + k2**2*(108 - 108*C)*(2*r + 2*s - 1)) - 396*g2*k2**2*(5*r + 5*s + 1))))/(3465*d**2*k3**6) + 4*D1**3*Pk1*Pkdd3*ct**4*k2**2*(r + s - 1)*(3*D1*bd1*f**2*(3*C - 1)*(r + s) + 7*b1**2*(3*C - 2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(3*C - 2)*(2*r + 2*s - 1) + (9*C - 3)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k3**2) + D1**3*Pk1*Pkdd3*ct**4*k2**2*(126*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*(D1*(-42*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(84*C - 28)*(r + s - 1)**2 + k2**2*(-140*C*(r + s - 1)**2 - 14*K*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s + 2) + 3*f*(44*r**2 + r*(88*s - 47) + 44*s**2 - 47*s + 15) + 196*r**2 + 56*r*(7*s - 6) + 196*s**2 - 336*s + 168))) + 2*Dd*f*(k1**2*(42*C - 14)*(r + s - 1) + k2**2*(-70*C*(r + s - 1) - 7*K*(5*r + 5*s - 2) + 3*f*(11*r + 11*s - 5) + 98*r + 98*s - 84))*(4*r + 4*s - 3)) + b1*(-3*D1*bd1*f*(k1**2*(84*C - 28)*(2*r + 2*s - 1) + k2**2*(-140*C*(2*r + 2*s - 1) - 28*K*(5*r + 5*s - 1) + 3*f*(44*r + 44*s - 15) + 392*r + 392*s - 168))*(r + s - 1) + D1*(-5*f**2*fd*k2**2*(72*r**2 + 3*r*(48*s - 23) + 72*s**2 - 69*s + 17) + 6*f*(3*fd*(k1**2*(C*(28*r**2 + r*(56*s - 68) + 28*s**2 - 68*s + 30) - 6*r**2 + r*(43 - 12*s) - 6*s**2 + 43*s - 24) + k2**2*(-14*C*(2*r**2 + 4*r*s + 2*s**2 - 1) + K*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2) + 74*r**2 + 148*r*s - 67*r + 74*s**2 - 67*s + 8)) - 7*k2**2*(-3*bd2*(r + s) + 2*gd2*(5*r + 5*s - 2))*(r + s - 1)) + 42*fd*k2**2*(3*b2*(r + s)**2 - 2*g2*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s + 2))) - 2*Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2*(6*r + 6*s - 1) - 9*f*(k1**2*(2*C*(7*r + 7*s - 12) - 3*r - 3*s + 16) + k2**2*(-14*C*r - 14*C*s + K*(3*r + 3*s + 2) + 37*r + 37*s - 22)) + 21*k2**2*(-3*b2*(r + s) + 2*g2*(5*r + 5*s - 2)))) + f*(-D1*bd1*(r + s - 1)*(5*f**2*k2**2*(24*r + 24*s + 5) - 18*f*(k1**2*(2*C*(7*r + 7*s - 9) - 3*r - 3*s + 8) + k2**2*(-14*C*(r + s - 1) + K*(3*r + 3*s + 2) + 37*r + 37*s - 36)) + k2**2*(-126*b2 + 420*g2)*(r + s)) + 2*D1*(5*f*fd*(k1**2*(-6*C + 15*r + 15*s - 4) - 9*k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 4))*(3*r + 3*s - 2) + 9*f*k2**2*(bd2 - 2*gd2)*(3*r**2 + r*(6*s - 1) + 3*s**2 - s - 2) + 9*fd*k2**2*(b2 - 2*g2)*(6*r**2 + 12*r*s + r + 6*s**2 + s - 2)) + 2*Dd*f*(-5*f*(k1**2*(6*C - 15*r - 15*s + 4) + 9*k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 4)) + k2**2*(9*b2 - 18*g2)*(3*r + 3*s + 2))*(4*r + 4*s - 3)))/(315*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct**4*k2**2*(33*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + k1**2*k2**2*(28*C*(8*r + 8*s - 5) + 6*K*(3*r + 3*s - 5) + b1*(25*r + 25*s - 23) - 194*r - 194*s + 132) - 7*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) - 140*k2**2*(r + s)*(b1*(k1**2 - k2**2*(K - 1)) + g2*k2**2)) - 33*b1**2*k2**2*(D1*fd*(-3*f*(k1**2*(25*r + 25*s - 23) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (70*k1**2 - 70*k2**2*(K - 1))*(r + s)**2) - Dd*f*(f*(k1**2*(75*r + 75*s - 69) - 42*k2**2*(2*r + 2*s - 1)) + (-70*k1**2 + 70*k2**2*(K - 1))*(r + s))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + 2*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 70*gd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1))) - 140*fd*g2*k2**4*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + 6*f*(k1**4*(2*C*(18*r + 18*s + 5) - 31*r - 31*s - 2) + 2*k1**2*k2**2*(14*C*(8*r + 8*s - 5) + 3*K*(3*r + 3*s - 5) - 97*r - 97*s + 66) + k2**4*(7*K - 7)*(r + s)) - 140*g2*k2**4*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 22*f*(5*fd*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) - 18*gd2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(r + s - 1)) - 396*fd*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(3*k1**2*(13*r + 13*s - 7) + 11*k2**2*(17*r + 17*s - 11)) + 110*f*k1**2*(k1**2*(6*C*(12*r + 12*s - 5) - 57*r - 57*s + 26) + 9*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) - 396*g2*k2**2*(6*k1**2*(3*r + 3*s - 5) + 7*k2**2*(r + s)))))/(3465*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**3*f*k2**5*st**4*(2*r + 2*s - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**3*f*k2**5*st**4*(11*D1*bd1*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(r + s - 1) + 11*b1*(D1*fd*(5*f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 6*k1**2*(2*r + 2*s - 1)*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71)) + Dd*f*(5*f*k2**2*(33*r + 33*s - 19) + 6*k1**2*(2*C*(79*r + 79*s - 43) - 128*r - 128*s + 71))*(4*r + 4*s - 3)) + f*(D1*fd*(5*f*k2**2*(724*r**2 + r*(1448*s - 987) + 724*s**2 - 987*s + 333) + 22*k1**2*(3*r + 3*s - 2)*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71)) + Dd*f*(5*f*k2**2*(181*r + 181*s - 111) + 22*k1**2*(2*C*(87*r + 87*s - 43) - 144*r - 144*s + 71))*(4*r + 4*s - 3)))/(1155*d**2*k1*k3**6) + D1**3*Pk1*Pkdd3*ct**3*k1*k2*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + k1**2*k2**2*(28*C*(7*r + 7*s - 5) + 2*K*(26*r + 26*s - 20) + b1*(-31*r - 31*s + 5) - 166*r - 166*s + 118) - 7*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) + k2**2*(k1**2 + k2**2)*(r + s)*(420*b1*(3 - 4*K) + 1680*g2)) - 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (210 - 280*K)*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(3*f*(k1**2*(31*r + 31*s - 5) + 7*k2**2*(13*r + 13*s - 7)) + (210 - 280*K)*(k1**2 + k2**2)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) - 280*gd2*k2**2*(k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 1680*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1)) - 18*f*(k1**4*(2*C*(17*r + 17*s - 5) - 21*r - 21*s + 7) + 2*k1**2*k2**2*(14*C*(7*r + 7*s - 5) + K*(26*r + 26*s - 20) - 83*r - 83*s + 59) + k2**4*(28*K - 21)*(r + s)) + 1680*g2*k2**2*(k1**2 + k2**2)*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 22*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 72*gd2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(r + s - 1)) - 1584*fd*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(58*r + 58*s - 38) + 33*k2**2*(7*r + 7*s - 5)) + 110*f*k1**2*(k1**2*(6*C*(9*r + 9*s - 5) - 33*r - 33*s + 19) + 9*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 1584*g2*k2**2*(k1**2*(13*r + 13*s - 10) + 7*k2**2*(r + s)))))/(3465*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(r + s - 1)*(5*D1*bd1*f**2*(r + s) + 14*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(14*D1*bd1*(2*r + 2*s - 1) + 10*D1*fd*(r + s - 1) + 5*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k1*k3**2) - 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(3*b1**2*(D1*fd*(k1**2*(182*C - 140)*(r + s - 1)**2 + 3*k2**2*(f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + 14*(r + s)**2)) + 2*Dd*f*(k1**2*(91*C - 70)*(r + s - 1) + 3*k2**2*(f*(13*r + 13*s - 8) + 7*r + 7*s))*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(k1**2*(182*C - 140)*(2*r + 2*s - 1) + 3*k2**2*(f*(52*r + 52*s - 19) + 28*r + 28*s))*(r + s - 1) + D1*fd*(-3*k1**2*(4*C*(83*r**2 + 166*r*s - 73*r + 83*s**2 - 73*s + 8) - 188*r**2 - 376*r*s + 199*r - 188*s**2 + 199*s - 29) + k2**2*(f*(414*r**2 + 828*r*s - 609*r + 414*s**2 - 609*s + 245) - 414*r**2 - 828*r*s + 477*r - 414*s**2 + 477*s - 135)) + Dd*f*(-6*k1**2*(C*(83*r + 83*s - 47) - 47*r - 47*s + 38) + k2**2*(2*f*(69*r + 69*s - 44) - 207*r - 207*s + 135))*(4*r + 4*s - 3)) + f**2*(-D1*bd1*(3*k1**2*(2*C*(83*r + 83*s - 78) - 94*r - 94*s + 123) + k2**2*(f*(-138*r - 138*s + 19) + 207*r + 207*s - 135))*(r + s - 1) - (k1**2*(2*C*(93*r + 93*s - 47) - 120*r - 120*s + 65) + 27*k2**2*(2*r + 2*s - 1))*(2*D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(4*r + 4*s - 3))))/(315*d**2*k1*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 46*K*r + 46*K*s + 12*K - 6*b1*(51*r + 51*s - 29) + 431*r + 431*s - 261)) + k1**2*k2**2*(r + s)*(-84*b1*(4 - 7*K) - 588*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(306*r**2 + r*(612*s - 327) + 306*s**2 - 327*s + 87) + (56 - 98*K)*(r + s)**2) + Dd*f*(3*f*(51*r + 51*s - 29) + (56 - 98*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*k1**2*(fd*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261))*(2*r + 2*s - 1) - 196*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 588*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3)) + 3*f*k1**2*(k1**2*(C*(326*r + 326*s - 366) - 185*r - 185*s + 243) + k2**2*(-42*C*(13*r + 13*s - 7) + 2*K*(23*r + 23*s + 6) + 431*r + 431*s - 261)) - 588*g2*k1**2*k2**2*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(-523*r - 523*s + 329) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 6*gd2*k2**2*(23*r**2 + r*(46*s - 17) + 23*s**2 - 17*s - 6)) + 132*fd*g2*k1**2*k2**2*(46*r**2 + r*(92*s - 11) + 46*s**2 - 11*s - 6)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*(k1**2*k2**2*(523*r + 523*s - 329) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(285*r + 285*s - 169) - 165*r - 165*s + 104) - 27*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 132*g2*k1**2*k2**2*(23*r + 23*s + 6))))/(3465*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**3*k2*(r + s - 1)*(6*D1*bd1*f**2*(r + s)*(k1**2*(2*C - 5) - 7*k2**2) + 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - b1**2*(D1*(-7*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(14*C + 7) + k2**2*(3*f + 49))*(r + s - 1)) + Dd*f*(k1**2*(28*C + 14) + k2**2*(3*f + 98))*(4*r + 4*s - 3)) - b1*f*(D1*bd1*(k1**2*(28*C + 14) + k2**2*(3*f + 98))*(2*r + 2*s - 1) - (6*k1**2*(2*C - 5) - 42*k2**2)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k1*k3**2) + D1**3*Pk1*Pkdd3*ct**3*k2*(63*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(21*bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(84*C - 70)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 + 28*K*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) + 3*f*(40*r**2 + r*(80*s - 47) + 40*s**2 - 47*s + 17) - 336*r**2 - 672*r*s + 868*r - 336*s**2 + 868*s - 434) + 7*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + 10*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(42*C - 35)*(r + s - 1) + k1**2*k2**2*(210*C*(r + s - 1) + 14*K*(5*r + 5*s - 4) + 15*f*(2*r + 2*s - 1) - 168*r - 168*s + 217) + 7*k2**4*(f*(9*r + 9*s - 6) + 5*r + 5*s))) + 3*b1*(D1*bd1*f*(r + s - 1)*(k1**4*(84*C - 70)*(2*r + 2*s - 1) + k1**2*k2**2*(420*C*(2*r + 2*s - 1) + 56*K*(5*r + 5*s - 2) + 3*f*(40*r + 40*s - 13) - 672*r - 672*s + 434) + 7*k2**4*(3*f*(12*r + 12*s - 5) + 20*r + 20*s)) + D1*(5*f**2*fd*k2**2*(k1**2*(45*r**2 + 15*r*(6*s - 5) + 45*s**2 - 75*s + 32) + 3*k2**2*(18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 11)) - 2*f*(3*fd*(k1**4*(C*(50*r + 50*s - 34) - 33*r - 33*s + 23) + 2*k1**2*k2**2*(7*C*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + K*(2*r**2 + 4*r*s - 9*r + 2*s**2 - 9*s + 4) - 45*r**2 - 90*r*s + 24*r - 45*s**2 + 24*s + 8) - 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 14*k1**2*k2**2*(-bd2*(r + s) + 2*gd2*(5*r + 5*s - 4))*(r + s - 1)) + 28*fd*k1**2*k2**2*(b2*(r + s)**2 - 2*g2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4))) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 13) + 6*k2**2*(3*r + 3*s - 2)) - 6*f*(k1**4*(16*C - 10) + k1**2*k2**2*(28*C*r + 28*C*s + 2*K*(r + s - 4) - 45*r - 45*s + 19) - 7*k2**4*(r + s)) + 28*k1**2*k2**2*(b2*(r + s) - 2*g2*(5*r + 5*s - 4)))) + f*(3*D1*bd1*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s - 7) + 3*k2**2*(6*r + 6*s - 1)) + 6*f*(k1**4*(2*C - 3) + k1**2*k2**2*(-14*C*(2*r + 2*s - 3) - 2*K*(r + s - 4) + 45*r + 45*s - 54) + 7*k2**4*(r + s)) + k1**2*k2**2*(28*b2 - 280*g2)*(r + s)) - 2*k1**2*(D1*(f*(5*fd*(k1**2*(2*C*(15*r + 15*s - 7) - 21*r - 21*s + 11) + 9*k2**2*(2*C*(5*r + 5*s - 3) - 9*r - 9*s + 6))*(3*r + 3*s - 2) + k2**2*(18*bd2 - 36*gd2)*(r**2 + r*(2*s - 5) + s**2 - 5*s + 4)) + 18*fd*k2**2*(b2 - 2*g2)*(2*r**2 + r*(4*s - 9) + 2*s**2 - 9*s + 4)) + Dd*f*(5*f*(k1**2*(2*C*(15*r + 15*s - 7) - 21*r - 21*s + 11) + 9*k2**2*(2*C*(5*r + 5*s - 3) - 9*r - 9*s + 6)) + k2**2*(18*b2 - 36*g2)*(r + s - 4))*(4*r + 4*s - 3))))/(315*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**2*f*k2**6*st**6*(4*C - 4)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(63*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**2*k1**2*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + 53*K*r + 53*K*s - 30*K + b1*(-33*r - 33*s + 13) - 69*r - 69*s + 52) - 21*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 420*k2**2*(r + s)*(b1*k1**2*(2 - 5*K) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) - 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + (r + s)**2*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3))) + Dd*f*(3*f*(k1**2*(33*r + 33*s - 13) + 21*k2**2*(5*r + 5*s - 3)) + (r + s)*(-70*k1**2*(5*K - 2) - 70*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) - 6*f*(3*fd*(2*r + 2*s - 1)*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) - 70*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 420*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s)) - 18*f*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(6*r + 6*s - 5) + K*(53*r + 53*s - 30) - 69*r - 69*s + 52) + k2**4*(42*K - 21)*(r + s)) + 420*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s))) + f*(D1*(35*f**2*fd*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 22*f*(5*fd*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 18*gd2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(r + s - 1)) - 396*fd*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(11*r + 11*s - 9)) + 110*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 396*g2*k2**2*(k1**2*(53*r + 53*s - 30) + 42*k2**2*(r + s)))))/(3465*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**2*k2**4*st**4*(42*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1*f*(14*D1*bd1*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*fd*(-2*C*(56*r**2 + 4*r*(28*s - 13) + 56*s**2 - 52*s + 11) + 90*r**2 + r*(180*s - 89) + 90*s**2 - 89*s + 20) - Dd*f*(4*r + 4*s - 3)*(C*(56*r + 56*s - 26) - 45*r - 45*s + 24)) + f**2*(-3*D1*bd1*(r + s - 1)*(C*(56*r + 56*s - 30) - 45*r - 45*s + 28) - (D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(30*C*(2*r + 2*s - 1) - 57*r - 57*s + 28)))/(105*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct**2*k2**4*st**4*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(2*r + 2*s - 1)*(14*C - K + 30*b1 - 13) + k2**2*(r + s)*(28*K*b1 - 28*b1 - 28*g2)) + 66*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1)**2 + (7 - 7*K)*(r + s)**2) + Dd*f*(15*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s))*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) + 2*f*(fd*(k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - k2**2*(14*C - K - 13)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 28*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(11*r + 11*s - 7) + 2*f*k1**2*(2*C*(73*r + 73*s - 47) - 97*r - 97*s + 66) - 2*f*k2**2*(14*C - K - 13)*(2*r + 2*s - 1) - 28*g2*k2**2*(r + s))) + f*(D1*(-5*f**2*fd*k2**2*(1124*r**2 + r*(2248*s - 1543) + 1124*s**2 - 1543*s + 525) - 22*f*(fd*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 6*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 132*fd*g2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(281*r + 281*s - 175) + 22*f*(k1**2*(4*C*(45*r + 45*s - 22) - 123*r - 123*s + 60) + k2**2*(6 - 6*C)*(2*r + 2*s - 1)) - 132*g2*k2**2*(2*r + 2*s - 1))))/(1155*d**2*k3**6) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(r + s - 1)*(2*D1*bd1*f**2*(15*C - 8)*(r + s) + 7*b1**2*(12*C - 7)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(12*C - 7)*(2*r + 2*s - 1) + (30*C - 16)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k3**2) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(42*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*(42*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(77 - 126*C)*(r + s - 1)**2 + k2**2*(70*C*(r + s - 1)**2 + 7*K*(5*r**2 + 10*r*s + 2*r + 5*s**2 + 2*s - 1) - 3*f*(32*r**2 + r*(64*s - 31) + 32*s**2 - 31*s + 9) - 77*r**2 - 154*r*s + 126*r - 77*s**2 + 126*s - 63))) - Dd*f*(k1**2*(126*C - 77)*(r + s - 1) - k2**2*(70*C*(r + s - 1) + 35*K*r + 35*K*s + 7*K - 6*f*(8*r + 8*s - 3) - 77*r - 77*s + 63))*(4*r + 4*s - 3)) - b1*(D1*bd1*f*(k1**2*(126*C - 77)*(2*r + 2*s - 1) - k2**2*(70*C*(2*r + 2*s - 1) + 70*K*r + 70*K*s + 7*K - 3*f*(32*r + 32*s - 9) - 154*r - 154*s + 63))*(r + s - 1) + D1*(2*f**2*fd*k2**2*(72*r**2 + 48*r*(3*s - 2) + 72*s**2 - 96*s + 35) + f*(fd*(-2*k1**2*(C*(22*r**2 + r*(44*s - 53) + 22*s**2 - 53*s + 13) - 6*r**2 + r*(39 - 12*s) - 6*s**2 + 39*s - 14) + k2**2*(28*C*(11*r**2 + 2*r*(11*s - 5) + 11*s**2 - 10*s + 2) + K*(-30*r**2 - 60*r*s + 9*r - 30*s**2 + 9*s + 3) - 318*r**2 - 636*r*s + 339*r - 318*s**2 + 339*s - 83)) + 14*k2**2*(-3*bd2*(r + s) + gd2*(5*r + 5*s + 1))*(r + s - 1)) + 14*fd*k2**2*(-3*b2*(r + s)**2 + g2*(5*r**2 + 2*r*(5*s + 1) + 5*s**2 + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(2*f**2*k2**2*(24*r + 24*s - 13) - f*(k1**2*(C*(22*r + 22*s - 58) - 6*r - 6*s + 44) + k2**2*(-14*C*(11*r + 11*s - 5) + 3*K*(5*r + 5*s + 1) + 159*r + 159*s - 97)) + 14*k2**2*(-3*b2*(r + s) + g2*(5*r + 5*s + 1)))) - f*(D1*bd1*(r + s - 1)*(8*f**2*k2**2*(6*r + 6*s - 1) - f*(k1**2*(C*(22*r + 22*s - 90) - 6*r - 6*s + 60) + k2**2*(-14*C*(11*r + 11*s - 6) + 15*K*r + 15*K*s + 3*K + 159*r + 159*s - 111)) + k2**2*(-42*b2 + 70*g2)*(r + s)) + D1*(f*(-fd*(k1**2*(12*C*(3*r + 3*s - 2) - 15*r - 15*s + 13) - 9*k2**2*(C*(8*r + 8*s - 4) - 9*r - 9*s + 5))*(3*r + 3*s - 2) + k2**2*(-3*bd2 + 6*gd2)*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1)) - 3*fd*k2**2*(b2 - 2*g2)*(10*r**2 + r*(20*s - 3) + 10*s**2 - 3*s - 1)) - Dd*f*(4*r + 4*s - 3)*(f*k1**2*(12*C*(3*r + 3*s - 2) - 15*r - 15*s + 13) - 9*f*k2**2*(C*(8*r + 8*s - 4) - 9*r - 9*s + 5) + k2**2*(3*b2 - 6*g2)*(5*r + 5*s + 1))))/(105*d**2*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(33*D1*bd1*f*(r + s - 1)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + 55*K*r + 55*K*s + 18*K - 12*b1*(11*r + 11*s - 9) + 431*r + 431*s - 282) + 7*k2**4*(12*b1*(2*r + 2*s - 1) - (K - 1)*(r + s))) + 14*k2**2*(r + s)*(b1*k1**2*(3 - 11*K) + 5*b1*k2**2*(K - 1) + g2*(11*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5))) + Dd*f*(6*f*(k1**2*(11*r + 11*s - 9) - 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(11*K - 3) + 7*k2**2*(5*K - 5)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*gd2*k2**2*(11*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*fd*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(9*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*(2*k1**4*(2*C*(8*r + 8*s - 39) - 5*r - 5*s + 48) + k1**2*k2**2*(-14*C*(46*r + 46*s - 27) + K*(55*r + 55*s + 18) + 431*r + 431*s - 282) + k2**4*(7 - 7*K)*(r + s)) + 14*g2*k2**2*(11*k1**2 - 5*k2**2)*(r + s))) - f*(D1*(15*f**2*fd*k2**2*(8*k1**2*(4*r + 4*s - 3) - 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(k1**2*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 6*gd2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(r + s - 1)) + 66*fd*g2*k2**2*(-k1**2*(55*r + 55*s + 18) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*(8*k1**2*k2**2*(4*r + 4*s - 3) - 11*k2**4*(17*r + 17*s - 11)) + 11*f*(k1**4*(C*(66*r + 66*s - 86) - 21*r - 21*s + 47) - 9*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) - 66*g2*k2**2*(k1**2*(55*r + 55*s + 18) - 7*k2**2*(r + s)))))/(3465*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**2*(r + s - 1)*(-4*D1*bd1*f*(r + s)*(3*f*(k1**2*(4*C - 2) + k2**2*(7*C - 7)) + k2**2*(7*b2 - 14*g2)) + 21*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(21*bd1*f*k2**2*(3*r + 3*s - 2) - 2*fd*(k1**2*(28*C - 14) + k2**2*(70*C + 14*K - 27*f - 98))*(r + s - 1)) + Dd*f*(k1**2*(28 - 56*C) + k2**2*(-140*C - 28*K + 27*f + 196))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(k1**2*(28 - 56*C) + k2**2*(-140*C - 28*K + 27*f + 196))*(2*r + 2*s - 1) - 4*D1*(r + s - 1)*(6*f*fd*(k1**2*(4*C - 2) + k2**2*(7*C - 7)) + 7*f*k2**2*(bd2 - 2*gd2) + 7*fd*k2**2*(b2 - 2*g2)) - 4*Dd*f*(3*f*(k1**2*(4*C - 2) + k2**2*(7*C - 7)) + k2**2*(7*b2 - 14*g2))*(4*r + 4*s - 3)))/(105*d**2*k3**2) - D1**3*Pk1*Pkdd3*ct**2*(21*b1**3*k2**2*(7*k1**2 + 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*(D1*(-7*bd1*f*k2**2*(7*k1**2 + 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(56*C - 28)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 + 14*K*(5*r**2 + 10*r*s - 24*r + 5*s**2 - 24*s + 12) + 3*f*(32*r**2 + r*(64*s - 7) + 32*s**2 - 7*s - 9) - 252*r**2 - 504*r*s + 728*r - 252*s**2 + 728*s - 364) + 7*k2**4*(3*f*(20*r**2 + 5*r*(8*s - 5) + 20*s**2 - 25*s + 9) + (20 - 10*K)*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(28*C - 14)*(r + s - 1) + k1**2*k2**2*(210*C*(r + s - 1) + 7*K*(5*r + 5*s - 12) + r*(24*f - 126) + s*(24*f - 126) + 182) + 7*k2**4*(3*f*(5*r + 5*s - 3) + (10 - 5*K)*(r + s)))) + b1*(-3*D1*bd1*f*(r + s - 1)*(k1**4*(56*C - 28)*(2*r + 2*s - 1) + k1**2*k2**2*(420*C*(2*r + 2*s - 1) + 28*K*(5*r + 5*s - 6) + 3*f*(32*r + 32*s - 9) - 504*r - 504*s + 364) + 7*k2**4*(3*f*(20*r + 20*s - 9) + (40 - 20*K)*(r + s))) + D1*(-5*f**2*fd*k2**2*(k1**2*(153*r**2 + 3*r*(102*s - 73) + 153*s**2 - 219*s + 82) + 9*k2**2*(36*r**2 + r*(72*s - 53) + 36*s**2 - 53*s + 21)) + 6*f*(3*fd*(k1**4*(4*C - 2)*(4*r + 4*s - 3) + k1**2*k2**2*(14*C*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 3) + K*(34*r**2 + 68*r*s - 41*r + 34*s**2 - 41*s + 12) - 46*r**2 - 92*r*s + 11*r - 46*s**2 + 11*s + 20) + k2**4*(7*K - 14)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 7*k2**2*(bd2*(7*k1**2 + 5*k2**2)*(r + s) + 2*gd2*(k1**2*(5*r + 5*s - 12) - 5*k2**2*(r + s)))*(r + s - 1)) + 42*fd*k2**2*(b2*(7*k1**2 + 5*k2**2)*(r + s)**2 + 2*g2*(k1**2*(5*r**2 + 2*r*(5*s - 12) + 5*s**2 - 24*s + 12) - 5*k2**2*(r + s)**2))) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(51*r + 51*s - 35) + 36*k2**2*(3*r + 3*s - 2)) - 18*f*(k1**4*(4*C - 2) + k1**2*k2**2*(14*C*r + 14*C*s + K*(17*r + 17*s - 12) - 23*r - 23*s + 8) + k2**4*(7*K - 14)*(r + s)) - 42*k2**2*(b2*(7*k1**2 + 5*k2**2)*(r + s) + 2*g2*(k1**2*(5*r + 5*s - 12) - 5*k2**2*(r + s))))) + f*(-D1*bd1*(r + s - 1)*(5*f**2*k2**2*(k1**2*(51*r + 51*s - 23) + 27*k2**2*(4*r + 4*s - 1)) + 18*f*(k1**4*(4*C - 2) + k1**2*k2**2*(-14*C*(r + s - 3) + K*(-17*r - 17*s + 12) + 23*r + 23*s - 36) - k2**4*(7*K - 14)*(r + s)) - 42*k2**2*(r + s)*(b2*(7*k1**2 + 5*k2**2) + 10*g2*(k1**2 - k2**2))) + 2*D1*(f*(5*fd*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(C*(8*r + 8*s - 6) - 5*r - 5*s + 4))*(3*r + 3*s - 2) + k2**2*(9*bd2 - 18*gd2)*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(r + s - 1)) + 9*fd*k2**2*(b2 - 2*g2)*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + 2*Dd*f*(5*f*k1**2*(k1**2*(4*C - 2)*(3*r + 3*s - 2) + 9*k2**2*(C*(8*r + 8*s - 6) - 5*r - 5*s + 4)) + k2**2*(9*b2 - 18*g2)*(k1**2*(17*r + 17*s - 12) + 7*k2**2*(r + s)))*(4*r + 4*s - 3)))/(315*d**2*k3**4) - 2*D1**3*Pk1*Pkdd3*ct*f*k2**5*st**6*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(63*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct*f*k2**5*st**6*(11*D1*bd1*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(r + s - 1) + 11*b1*(D1*fd*(f*k2**2*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + k1**2*(72*C - 54)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(33*r + 33*s - 19) + k1**2*(72*C - 54)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(180*r**2 + r*(360*s - 259) + 180*s**2 - 259*s + 93) + k1**2*(88*C - 66)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(45*r + 45*s - 31) + k1**2*(88*C - 66)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(693*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*(k1**2*(-14*C*(r + s - 1) - 24*K*r - 24*K*s + 12*K + b1*(8*r + 8*s - 4) + 11*r + 11*s - 9) + 7*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(-168*b1*k1**2*(6*K - 1) - 420*b1*k2**2*(4*K - 1) + 336*g2*(3*k1**2 + 5*k2**2))) + 3*b1**2*(D1*fd*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5))) + Dd*f*(3*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(7*r + 7*s - 5)) + (r + s)*(-14*k1**2*(12*K - 2) - 14*k2**2*(20*K - 5)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 6*f*(3*fd*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s))*(2*r + 2*s - 1) - 56*gd2*(3*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 336*fd*g2*(3*k1**2 + 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - 18*f*(k1**2*(14*C*(r + s - 1) + 12*K*(2*r + 2*s - 1) - 11*r - 11*s + 9) + k2**2*(28*K - 7)*(r + s)) + 336*g2*(3*k1**2 + 5*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 9*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 8*gd2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))*(r + s - 1) - 72*fd*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(r + s - 1) + f*k1**2*(90*C - 45)*(r + s - 1) - 72*g2*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)))))/(315*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct*k1*k2*(-21*b1**3*(4*k1**2 + 15*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*(7*D1*bd1*f*(4*k1**2 + 15*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - D1*fd*(2*k1**2*(70*C*(r + s - 1)**2 - 56*K*(2*r + 2*s - 1) + 6*f*(4*r + 4*s - 3) - 35*r**2 - 14*r*(5*s - 7) - 35*s**2 + 98*s - 49) + 7*k2**2*(3*f*(8*r**2 + r*(16*s - 7) + 8*s**2 - 7*s + 1) + (10 - 20*K)*(r + s)**2)) - 2*Dd*f*(k1**2*(70*C*(r + s - 1) - 56*K + 6*f - 35*r - 35*s + 49) + 7*k2**2*(f*(6*r + 6*s - 3) + (5 - 10*K)*(r + s)))*(4*r + 4*s - 3)) + b1*(21*D1*bd1*f*(2*k1**2*(10*C*(2*r + 2*s - 1) - 8*K - 10*r - 10*s + 7) + k2**2*(3*f*(8*r + 8*s - 5) + (20 - 40*K)*(r + s)))*(r + s - 1) + D1*(5*f**2*fd*(4*k1**2*(3*r + 3*s - 2)**2 + 9*k2**2*(21*r**2 + r*(42*s - 31) + 21*s**2 - 31*s + 12)) - 18*f*fd*(k1**2*(14*C*(r + s - 1) + 8*K*(2*r + 2*s - 1)**2 - 8*r**2 - 16*r*s + r - 8*s**2 + s + 5) + k2**2*(14*K - 7)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 84*f*(r + s - 1)*(-bd2*(4*k1**2 + 5*k2**2)*(r + s) + 8*gd2*k1**2 + 10*gd2*k2**2*(r + s)) - 84*fd*(b2*(4*k1**2 + 5*k2**2)*(r + s)**2 - 2*g2*(k1**2*(8*r + 8*s - 4) + 5*k2**2*(r + s)**2))) + Dd*f*(4*r + 4*s - 3)*(-84*b2*(4*k1**2 + 5*k2**2)*(r + s) + 5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(7*r + 7*s - 5)) - 18*f*(k1**2*(8*K - 2)*(2*r + 2*s - 1) + k2**2*(14*K - 7)*(r + s)) + 168*g2*(4*k1**2 + 5*k2**2*(r + s)))) + f*(-540*C*D1*f*fd*k1**2*r**2 - 1080*C*D1*f*fd*k1**2*r*s + 900*C*D1*f*fd*k1**2*r - 540*C*D1*f*fd*k1**2*s**2 + 900*C*D1*f*fd*k1**2*s - 360*C*D1*f*fd*k1**2 - 720*C*Dd*f**2*k1**2*r**2 - 1440*C*Dd*f**2*k1**2*r*s + 1260*C*Dd*f**2*k1**2*r - 720*C*Dd*f**2*k1**2*s**2 + 1260*C*Dd*f**2*k1**2*s - 540*C*Dd*f**2*k1**2 + D1*bd1*(r + s - 1)*(5*f**2*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(7*r + 7*s - 3)) + 18*f*(k1**2*(14*C - 8*K*(2*r + 2*s - 1) + 4*r + 4*s - 9) + k2**2*(7 - 14*K)*(r + s)) + (r + s)*(-336*b2*k1**2 - 420*b2*k2**2 + 840*g2*k2**2)) - 36*D1*bd2*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(r + s - 1) + 270*D1*f*fd*k1**2*r**2 + 540*D1*f*fd*k1**2*r*s - 450*D1*f*fd*k1**2*r + 270*D1*f*fd*k1**2*s**2 - 450*D1*f*fd*k1**2*s + 180*D1*f*fd*k1**2 + 576*D1*f*gd2*k1**2*r**2 + 1152*D1*f*gd2*k1**2*r*s - 864*D1*f*gd2*k1**2*r + 576*D1*f*gd2*k1**2*s**2 - 864*D1*f*gd2*k1**2*s + 288*D1*f*gd2*k1**2 + 504*D1*f*gd2*k2**2*r**2 + 1008*D1*f*gd2*k2**2*r*s - 504*D1*f*gd2*k2**2*r + 504*D1*f*gd2*k2**2*s**2 - 504*D1*f*gd2*k2**2*s + 1152*D1*fd*g2*k1**2*r**2 + 2304*D1*fd*g2*k1**2*r*s - 1152*D1*fd*g2*k1**2*r + 1152*D1*fd*g2*k1**2*s**2 - 1152*D1*fd*g2*k1**2*s + 288*D1*fd*g2*k1**2 + 1008*D1*fd*g2*k2**2*r**2 + 2016*D1*fd*g2*k2**2*r*s - 504*D1*fd*g2*k2**2*r + 1008*D1*fd*g2*k2**2*s**2 - 504*D1*fd*g2*k2**2*s + 360*Dd*f**2*k1**2*r**2 + 720*Dd*f**2*k1**2*r*s - 630*Dd*f**2*k1**2*r + 360*Dd*f**2*k1**2*s**2 - 630*Dd*f**2*k1**2*s + 270*Dd*f**2*k1**2 + 2304*Dd*f*g2*k1**2*r**2 + 4608*Dd*f*g2*k1**2*r*s - 2880*Dd*f*g2*k1**2*r + 2304*Dd*f*g2*k1**2*s**2 - 2880*Dd*f*g2*k1**2*s + 864*Dd*f*g2*k1**2 + 2016*Dd*f*g2*k2**2*r**2 + 4032*Dd*f*g2*k2**2*r*s - 1512*Dd*f*g2*k2**2*r + 2016*Dd*f*g2*k2**2*s**2 - 1512*Dd*f*g2*k2**2*s - 36*b2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct*k1*k2*st**2*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 32*K*r - 32*K*s - 12*K + 3*b1*(r + s - 11) - 181*r - 181*s + 129) - 7*k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) + 28*k2**2*(r + s)*(b1*k1**2*(1 - 4*K) + 5*b1*k2**2*(2*K - 1) + 2*g2*(2*k1**2 - 5*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K))) + Dd*f*(3*f*(k1**2*(r + s - 11) - 7*k2**2*(13*r + 13*s - 7)) + (r + s)*(-14*k1**2*(4*K - 1) - 14*k2**2*(5 - 10*K)))*(4*r + 4*s - 3)) + 33*b1*(D1*(f**2*fd*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 2*f*(fd*(2*r + 2*s - 1)*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 28*gd2*k2**2*(2*k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 56*fd*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1)) + 2*f*(k1**4*(14*C - 8)*(r + s + 3) + k1**2*k2**2*(14*C*(23*r + 23*s - 15) - 4*K*(8*r + 8*s + 3) - 181*r - 181*s + 129) + k2**4*(14*K - 7)*(r + s)) + 56*g2*k2**2*(2*k1**2 - 5*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 12*gd2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 264*fd*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(8*k1**2*(5*r + 5*s - 1) + 99*k2**2*(7*r + 7*s - 5)) + 22*f*k1**2*(k1**2*(10*C - 6)*(3*r + 3*s + 1) + 9*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 264*g2*k2**2*(2*k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(3465*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct*k2**3*st**4*(r + s - 1)*(2*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k1*k3**2) - D1**3*Pk1*Pkdd3*ct*k2**3*st**4*(3*b1**2*(D1*fd*(k1**2*(56*C - 42)*(r + s - 1)**2 + k2**2*(f*(52*r**2 + r*(104*s - 71) + 52*s**2 - 71*s + 29) + 14*(r + s)**2)) + 2*Dd*f*(k1**2*(28*C - 21)*(r + s - 1) + k2**2*(f*(13*r + 13*s - 8) + 7*r + 7*s))*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(k1**2*(56*C - 42)*(2*r + 2*s - 1) + k2**2*(f*(52*r + 52*s - 19) + 28*r + 28*s))*(r + s - 1) + D1*fd*(-6*k1**2*(2*C*(30*r**2 + 60*r*s - 29*r + 30*s**2 - 29*s + 5) - 36*r**2 - 72*r*s + 38*r - 36*s**2 + 38*s - 7) + k2**2*(f*(126*r**2 + 3*r*(84*s - 67) + 126*s**2 - 201*s + 85) - 36*(2*r + 2*s - 1)**2)) + 2*Dd*f*(k1**2*(-18*C*(5*r + 5*s - 3) + 54*r + 54*s - 39) + k2**2*(f*(21*r + 21*s - 16) - 36*r - 36*s + 18))*(4*r + 4*s - 3)) + f**2*(-D1*bd1*(6*k1**2*(C*(30*r + 30*s - 26) - 18*r - 18*s + 19) + k2**2*(f*(-42*r - 42*s + 11) + 72*r + 72*s - 36))*(r + s - 1) - (k1**2*(C*(54*r + 54*s - 26) - 33*r - 33*s + 16) + 3*k2**2*(2*r + 2*s - 1))*(2*D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(4*r + 4*s - 3))))/(105*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*ct*k2**3*st**4*(-11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(b1*(-51*r - 51*s + 29) - (28*C - 2*K - 20)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(168*K*b1 - 84*b1 - 168*g2)) + 33*b1**2*k1**2*k2**2*(D1*fd*(f*(102*r**2 + r*(204*s - 109) + 102*s**2 - 109*s + 29) + (14 - 28*K)*(r + s)**2) + Dd*f*(f*(51*r + 51*s - 29) + (14 - 28*K)*(r + s))*(4*r + 4*s - 3)) - 11*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k1**2*(fd*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 28*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3)) + 6*f*k1**2*(k1**2*(C*(58*r + 58*s - 50) - 34*r - 34*s + 31) + k2**2*(-28*C + 2*K + 20)*(2*r + 2*s - 1)) - 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-691*r - 691*s + 433) + 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 22*f*k1**2*(fd*(k1**2*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k2**2*(9 - 12*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 12*gd2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 264*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*(k1**2*k2**2*(691*r + 691*s - 433) - 55*k2**4*(5*r + 5*s - 3)) + 22*f*(k1**4*(C*(78*r + 78*s - 38) - 45*r - 45*s + 22) + k1**2*k2**2*(9 - 12*C)*(2*r + 2*s - 1)) - 264*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(1155*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct*k2*st**2*(r + s - 1)*(-2*D1*bd1*f**2*(r + s)*(2*C*k1**2 + 7*k2**2) + 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(7*bd1*f*k2**2*(3*r + 3*s - 2) - 2*fd*(k1**2*(14*C - 14) + k2**2*(28 - 15*f))*(r + s - 1)) + Dd*f*(k1**2*(28 - 28*C) + k2**2*(15*f - 56))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(k1**2*(28*C - 28) + k2**2*(56 - 15*f))*(2*r + 2*s - 1) - (4*C*k1**2 + 14*k2**2)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k1*k3**2) + D1**3*Pk1*Pkdd3*ct*k2*(r + s - 1)*(-14*D1*bd1*f*k1**2*(r + s)*(4*b2 + f*(6*C - 3) - 8*g2) + 7*b1**3*(4*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(7*D1*bd1*f*(4*k1**2 + 5*k2**2)*(3*r + 3*s - 2) - 2*D1*fd*(-21*f*k2**2 + k1**2*(70*C + 28*K - 24*f - 49))*(r + s - 1) + Dd*f*(21*f*k2**2 + k1**2*(-140*C - 56*K + 24*f + 98))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(21*f*k2**2 + k1**2*(-140*C - 56*K + 24*f + 98))*(2*r + 2*s - 1) - 14*k1**2*(12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 4*D1*bd2*f*(r + s - 1) - 6*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd - 8*D1*f*gd2*r - 8*D1*f*gd2*s + 8*D1*f*gd2 - 8*D1*fd*g2*r - 8*D1*fd*g2*s + 8*D1*fd*g2 - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 32*Dd*f*g2*r - 32*Dd*f*g2*s + 24*Dd*f*g2 + 4*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(105*d**2*k1*k3**2) + D1**3*Pk1*Pkdd3*ct*k2*st**2*(63*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(21*bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(56 - 84*C)*(r + s - 1)**2 + k1**2*k2**2*(280*C*(r + s - 1)**2 + 14*K*(4*r + 4*s - 2) + f*(16*r**2 + r*(32*s - 65) + 16*s**2 - 65*s + 39) - 210*r**2 - 420*r*s + 392*r - 210*s**2 + 392*s - 196) + 7*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + 10*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(28 - 42*C)*(r + s - 1) + k1**2*k2**2*(140*C*(r + s - 1) + 14*K + f*(4*r + 4*s - 9) - 105*r - 105*s + 98) + 7*k2**4*(f*(9*r + 9*s - 6) + 5*r + 5*s))) + 3*b1*(-D1*bd1*f*(r + s - 1)*(k1**4*(84*C - 56)*(2*r + 2*s - 1) - k1**2*k2**2*(280*C*(2*r + 2*s - 1) + 28*K + f*(16*r + 16*s - 15) - 420*r - 420*s + 196) - 7*k2**4*(3*f*(12*r + 12*s - 5) + 20*r + 20*s)) + D1*(3*f**2*fd*k2**2*(-k1**2*(21*r**2 + r*(42*s - 17) + 21*s**2 - 17*s + 2) + 3*k2**2*(18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 11)) - 2*f*fd*(2*k1**4*(C*(8*r**2 + r*(16*s + 29) + 8*s**2 + 29*s - 17) - 4*r**2 - r*(8*s + 19) - 4*s**2 - 19*s + 11) + k1**2*k2**2*(14*C*(26*r**2 + r*(52*s - 25) + 26*s**2 - 25*s + 5) + K*(-32*r**2 - 64*r*s + 4*r - 32*s**2 + 4*s + 6) - 208*r**2 - 416*r*s + 215*r - 208*s**2 + 215*s - 45) - 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 28*f*k1**2*k2**2*(bd2*(r + s) - 2*gd2)*(r + s - 1) + 28*fd*k1**2*k2**2*(b2*(r + s)**2 + g2*(-4*r - 4*s + 2))) - Dd*f*(4*r + 4*s - 3)*(-3*f**2*k2**2*(k1**2*(-7*r - 7*s + 1) + 6*k2**2*(3*r + 3*s - 2)) + 2*f*(4*k1**4*(2*C*(r + s + 4) - r - s - 5) - 2*k1**2*k2**2*(-7*C*(13*r + 13*s - 7) + K*(8*r + 8*s + 3) + 52*r + 52*s - 33) - 7*k2**4*(r + s)) - 28*k1**2*k2**2*(b2*(r + s) - 2*g2))) + f*(-3*D1*bd1*(r + s - 1)*(-28*b2*k1**2*k2**2*(r + s) - 3*f**2*k2**2*(k1**2*(-7*r - 7*s + 1) + 3*k2**2*(6*r + 6*s - 1)) + 2*f*(2*k1**4*(C*(4*r + 4*s + 15) - 2*r - 2*s - 9) + k1**2*k2**2*(14*C*(13*r + 13*s - 9) - 2*K*(8*r + 8*s + 3) - 104*r - 104*s + 87) - 7*k2**4*(r + s))) + 2*k1**2*(D1*(f*(-fd*(k1**2*(6*C - 4)*(3*r + 3*s + 1) + 9*k2**2*(6*C*(5*r + 5*s - 3) - 19*r - 19*s + 12))*(3*r + 3*s - 2) + k2**2*(6*bd2 - 12*gd2)*(8*r**2 + r*(16*s - 5) + 8*s**2 - 5*s - 3)) + 6*fd*k2**2*(b2 - 2*g2)*(16*r**2 + r*(32*s - 2) + 16*s**2 - 2*s - 3)) - Dd*f*(4*r + 4*s - 3)*(f*k1**2*(6*C - 4)*(3*r + 3*s + 1) + 9*f*k2**2*(6*C*(5*r + 5*s - 3) - 19*r - 19*s + 12) - k2**2*(6*b2 - 12*g2)*(8*r + 8*s + 3)))))/(315*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*f*k2**4*st**6*(4*C - 2)*(9*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(63*d**2*k3**4) - D1**3*Pk1*Pkdd3*f*k2**4*st**6*(11*D1*bd1*f*(k1**2*(36*C - 18)*(2*r + 2*s - 1) + k2**2*(-36*b1*(2*r + 2*s - 1) + f*(15*r + 15*s - 7)))*(r + s - 1) - 198*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 11*b1*(D1*fd*(f*k2**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + k1**2*(36*C - 18)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(15*r + 15*s - 7) + k1**2*(36*C - 18)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(116*r**2 + r*(232*s - 163) + 116*s**2 - 163*s + 57) + k1**2*(44*C - 22)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(29*r + 29*s - 19) + k1**2*(44*C - 22)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(693*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**4*(D1*(-14*b1*fd*(2*k1**2 + 5*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 15*bd1*f**3*k2**2*(r + s - 1)**2 + 3*f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(4*r + 4*s - 2) + 7*K*k2**2*(r + s) - 7*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))) + f*(3*fd*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(2*r + 2*s - 1) + (2*k1**2 + 5*k2**2)*(28*b1*gd2 + 28*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(15*b1*f**2*k2**2*(r + s - 1) - 14*b1*(2*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 3*f*(b1*(-2*K*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + 7*b1*k2**2*(r + s - 1)) + 4*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))))/(105*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**2*(56*D1*K*b1**2*fd*k1**2*r + 56*D1*K*b1**2*fd*k1**2*s - 28*D1*K*b1**2*fd*k1**2 + 70*D1*K*b1**2*fd*k2**2*r**2 + 140*D1*K*b1**2*fd*k2**2*r*s + 70*D1*K*b1**2*fd*k2**2*s**2 + 28*D1*K*b1*bd1*f*k1**2*r + 28*D1*K*b1*bd1*f*k1**2*s - 28*D1*K*b1*bd1*f*k1**2 + 140*D1*K*b1*bd1*f*k2**2*r**2 + 280*D1*K*b1*bd1*f*k2**2*r*s - 140*D1*K*b1*bd1*f*k2**2*r + 140*D1*K*b1*bd1*f*k2**2*s**2 - 140*D1*K*b1*bd1*f*k2**2*s + 48*D1*K*b1*f*fd*k1**2*r**2 + 96*D1*K*b1*f*fd*k1**2*r*s - 48*D1*K*b1*f*fd*k1**2*r + 48*D1*K*b1*f*fd*k1**2*s**2 - 48*D1*K*b1*f*fd*k1**2*s + 12*D1*K*b1*f*fd*k1**2 + 84*D1*K*b1*f*fd*k2**2*r**2 + 168*D1*K*b1*f*fd*k2**2*r*s - 42*D1*K*b1*f*fd*k2**2*r + 84*D1*K*b1*f*fd*k2**2*s**2 - 42*D1*K*b1*f*fd*k2**2*s + 24*D1*K*bd1*f**2*k1**2*r**2 + 48*D1*K*bd1*f**2*k1**2*r*s - 36*D1*K*bd1*f**2*k1**2*r + 24*D1*K*bd1*f**2*k1**2*s**2 - 36*D1*K*bd1*f**2*k1**2*s + 12*D1*K*bd1*f**2*k1**2 + 42*D1*K*bd1*f**2*k2**2*r**2 + 84*D1*K*bd1*f**2*k2**2*r*s - 42*D1*K*bd1*f**2*k2**2*r + 42*D1*K*bd1*f**2*k2**2*s**2 - 42*D1*K*bd1*f**2*k2**2*s + 35*D1*b1**3*fd*k2**2*r**2 + 70*D1*b1**3*fd*k2**2*r*s - 70*D1*b1**3*fd*k2**2*r + 35*D1*b1**3*fd*k2**2*s**2 - 70*D1*b1**3*fd*k2**2*s + 35*D1*b1**3*fd*k2**2 + 105*D1*b1**2*bd1*f*k2**2*r**2 + 210*D1*b1**2*bd1*f*k2**2*r*s - 175*D1*b1**2*bd1*f*k2**2*r + 105*D1*b1**2*bd1*f*k2**2*s**2 - 175*D1*b1**2*bd1*f*k2**2*s + 70*D1*b1**2*bd1*f*k2**2 - 21*D1*b1**2*f*fd*k2**2*r - 21*D1*b1**2*f*fd*k2**2*s + 21*D1*b1**2*f*fd*k2**2 + 21*D1*b1*bd1*f**2*k2**2*r + 21*D1*b1*bd1*f**2*k2**2*s - 21*D1*b1*bd1*f**2*k2**2 - 45*D1*b1*f**2*fd*k2**2*r**2 - 90*D1*b1*f**2*fd*k2**2*r*s + 75*D1*b1*f**2*fd*k2**2*r - 45*D1*b1*f**2*fd*k2**2*s**2 + 75*D1*b1*f**2*fd*k2**2*s - 30*D1*b1*f**2*fd*k2**2 - 56*D1*b1*f*gd2*k1**2*r - 56*D1*b1*f*gd2*k1**2*s + 56*D1*b1*f*gd2*k1**2 - 140*D1*b1*f*gd2*k2**2*r**2 - 280*D1*b1*f*gd2*k2**2*r*s + 140*D1*b1*f*gd2*k2**2*r - 140*D1*b1*f*gd2*k2**2*s**2 + 140*D1*b1*f*gd2*k2**2*s - 112*D1*b1*fd*g2*k1**2*r - 112*D1*b1*fd*g2*k1**2*s + 56*D1*b1*fd*g2*k1**2 - 140*D1*b1*fd*g2*k2**2*r**2 - 280*D1*b1*fd*g2*k2**2*r*s - 140*D1*b1*fd*g2*k2**2*s**2 - 15*D1*bd1*f**3*k2**2*r**2 - 30*D1*bd1*f**3*k2**2*r*s + 30*D1*bd1*f**3*k2**2*r - 15*D1*bd1*f**3*k2**2*s**2 + 30*D1*bd1*f**3*k2**2*s - 15*D1*bd1*f**3*k2**2 - 140*D1*bd1*f*g2*k2**2*r**2 - 280*D1*bd1*f*g2*k2**2*r*s + 140*D1*bd1*f*g2*k2**2*r - 140*D1*bd1*f*g2*k2**2*s**2 + 140*D1*bd1*f*g2*k2**2*s + 2*D1*bd2*f*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(r + s - 1) - 48*D1*f**2*gd2*k1**2*r**2 - 96*D1*f**2*gd2*k1**2*r*s + 72*D1*f**2*gd2*k1**2*r - 48*D1*f**2*gd2*k1**2*s**2 + 72*D1*f**2*gd2*k1**2*s - 24*D1*f**2*gd2*k1**2 - 84*D1*f**2*gd2*k2**2*r**2 - 168*D1*f**2*gd2*k2**2*r*s + 84*D1*f**2*gd2*k2**2*r - 84*D1*f**2*gd2*k2**2*s**2 + 84*D1*f**2*gd2*k2**2*s - 96*D1*f*fd*g2*k1**2*r**2 - 192*D1*f*fd*g2*k1**2*r*s + 96*D1*f*fd*g2*k1**2*r - 96*D1*f*fd*g2*k1**2*s**2 + 96*D1*f*fd*g2*k1**2*s - 24*D1*f*fd*g2*k1**2 - 168*D1*f*fd*g2*k2**2*r**2 - 336*D1*f*fd*g2*k2**2*r*s + 84*D1*f*fd*g2*k2**2*r - 168*D1*f*fd*g2*k2**2*s**2 + 84*D1*f*fd*g2*k2**2*s + 112*Dd*K*b1**2*f*k1**2*r + 112*Dd*K*b1**2*f*k1**2*s - 84*Dd*K*b1**2*f*k1**2 + 280*Dd*K*b1**2*f*k2**2*r**2 + 560*Dd*K*b1**2*f*k2**2*r*s - 210*Dd*K*b1**2*f*k2**2*r + 280*Dd*K*b1**2*f*k2**2*s**2 - 210*Dd*K*b1**2*f*k2**2*s + 96*Dd*K*b1*f**2*k1**2*r**2 + 192*Dd*K*b1*f**2*k1**2*r*s - 120*Dd*K*b1*f**2*k1**2*r + 96*Dd*K*b1*f**2*k1**2*s**2 - 120*Dd*K*b1*f**2*k1**2*s + 36*Dd*K*b1*f**2*k1**2 + 168*Dd*K*b1*f**2*k2**2*r**2 + 336*Dd*K*b1*f**2*k2**2*r*s - 126*Dd*K*b1*f**2*k2**2*r + 168*Dd*K*b1*f**2*k2**2*s**2 - 126*Dd*K*b1*f**2*k2**2*s + 140*Dd*b1**3*f*k2**2*r**2 + 280*Dd*b1**3*f*k2**2*r*s - 245*Dd*b1**3*f*k2**2*r + 140*Dd*b1**3*f*k2**2*s**2 - 245*Dd*b1**3*f*k2**2*s + 105*Dd*b1**3*f*k2**2 - 60*Dd*b1*f**3*k2**2*r**2 - 120*Dd*b1*f**3*k2**2*r*s + 105*Dd*b1*f**3*k2**2*r - 60*Dd*b1*f**3*k2**2*s**2 + 105*Dd*b1*f**3*k2**2*s - 45*Dd*b1*f**3*k2**2 - 224*Dd*b1*f*g2*k1**2*r - 224*Dd*b1*f*g2*k1**2*s + 168*Dd*b1*f*g2*k1**2 - 560*Dd*b1*f*g2*k2**2*r**2 - 1120*Dd*b1*f*g2*k2**2*r*s + 420*Dd*b1*f*g2*k2**2*r - 560*Dd*b1*f*g2*k2**2*s**2 + 420*Dd*b1*f*g2*k2**2*s - 192*Dd*f**2*g2*k1**2*r**2 - 384*Dd*f**2*g2*k1**2*r*s + 240*Dd*f**2*g2*k1**2*r - 192*Dd*f**2*g2*k1**2*s**2 + 240*Dd*f**2*g2*k1**2*s - 72*Dd*f**2*g2*k1**2 - 336*Dd*f**2*g2*k2**2*r**2 - 672*Dd*f**2*g2*k2**2*r*s + 252*Dd*f**2*g2*k2**2*r - 336*Dd*f**2*g2*k2**2*s**2 + 252*Dd*f**2*g2*k2**2*s + 2*b2*(D1*(7*b1*fd*(2*k1**2 + 5*k2**2)*(r + s)**2 + 7*bd1*f*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*f*fd*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(7*b1*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)))*(4*r + 4*s - 3)))/(105*d**2*k3**4) + D1**3*Pk1*Pkdd3*k1**2*st**2*(11*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(k1**4*(2*C - 1)*(r + s + 3) - k1**2*k2**2*(-14*C*(4*r + 4*s - 3) + 8*K*r + 8*K*s + 3*K + 3*b1*(r + s + 3) + 28*r + 28*s - 21) + 7*k2**4*(K*(r + s) - 3*b1*(5*r + 5*s - 3))) + k2**2*(-k1**2 + 5*k2**2)*(r + s)*(84*K*b1 - 84*g2)) - 33*b1**2*k2**2*(D1*fd*(14*K*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(14*K*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**2*(r + s + 3) + 7*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(f**2*fd*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*(fd*(2*r + 2*s - 1)*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s)) + 6*f*(7*K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s + 3) + k1**2*k2**2*(14*C*(4*r + 4*s - 3) - K*(8*r + 8*s + 3) - 28*r - 28*s + 21)) + 84*g2*k2**2*(k1**2 - 5*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 22*f*(fd*k1**2*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 6*gd2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(11*r + 11*s - 9)) + f*k1**2*(44*C - 22)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s)))))/(3465*d**2*k3**6) + D1**3*Pk1*Pkdd3*k2**2*st**4*(4*C - 2)*(r + s - 1)*(2*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k3**2) + D1**3*Pk1*Pkdd3*k2**2*st**4*(42*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*(D1*(-14*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(28*C - 14)*(r + s - 1)**2 + k2**2*(-14*K*(r + s)**2 + f*(20*r**2 + 5*r*(8*s - 3) + 20*s**2 - 15*s + 3)))) + 2*Dd*f*(k1**2*(14*C - 7)*(r + s - 1) + k2**2*(-7*K*(r + s) + f*(5*r + 5*s - 1)))*(4*r + 4*s - 3)) + b1*(-3*D1*bd1*f*(k1**2*(28*C - 14)*(2*r + 2*s - 1) + k2**2*(-28*K*(r + s) + f*(20*r + 20*s - 3)))*(r + s - 1) + D1*(-f**2*fd*k2**2*(72*r**2 + 3*r*(48*s - 35) + 72*s**2 - 105*s + 41) + 6*f*(fd*(k1**2*(2*C - 1)*(6*r**2 + 3*r*(4*s - 3) + 6*s**2 - 9*s + 2) - k2**2*(14*C - K - 7)*(2*r + 2*s - 1)**2) + k2**2*(7*bd2 - 14*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 42*fd*k2**2*(b2 - 2*g2)*(r + s)**2) - 2*Dd*f*(4*r + 4*s - 3)*(4*f**2*k2**2*(3*r + 3*s - 2) - f*k1**2*(6*C - 3)*(3*r + 3*s - 4) + 3*f*k2**2*(14*C - K - 7)*(2*r + 2*s - 1) + k2**2*(-21*b2 + 42*g2)*(r + s))) + f*(-D1*bd1*(r + s - 1)*(f**2*k2**2*(24*r + 24*s - 7) + 6*f*(k1**2*(3 - 6*C)*(r + s - 2) + k2**2*(14*C - K - 7)*(2*r + 2*s - 1)) + k2**2*(-42*b2 + 84*g2)*(r + s)) + (D1*(f*fd*(2*C - 1)*(k1**2 - k2**2)*(3*r + 3*s - 2) + f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*(2*C - 1)*(k1**2 - k2**2) + k2**2*(b2 - 2*g2))*(4*r + 4*s - 3))*(12*r + 12*s - 6)))/(105*d**2*k3**4) + D1**3*Pk1*Pkdd3*k2**2*st**4*(33*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(14*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(5*r + 5*s - 6) - k1**2*k2**2*(b1*(19*r + 19*s - 13) + (14*C - K - 7)*(2*r + 2*s - 1))) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*g2)) - 33*b1**2*k2**2*(D1*fd*(14*K*k1**2*(r + s)**2 - f*(k1**2*(19*r + 19*s - 13) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-14*K*k1**2*(r + s) + f*k1**2*(19*r + 19*s - 13) - 14*f*k2**2*(2*r + 2*s - 1))) + 33*b1*(D1*(f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*k1**2*(fd*(k1**2*(2*C - 1)*(5*r + 5*s - 6) - k2**2*(14*C - K - 7)*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - f*k1**4*(4*C - 2)*(5*r + 5*s - 6) + 2*f*k1**2*k2**2*(14*C - K - 7)*(2*r + 2*s - 1) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(f**2*fd*k2**2*(k1**2*(-103*r - 103*s + 69) + 11*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 66*f*k1**2*(fd*(2*C - 1)*(k1**2 - k2**2)*(3*r + 3*s - 2) - 2*gd2*k2**2*(r + s - 1))*(2*r + 2*s - 1) + 132*fd*g2*k1**2*k2**2*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(103*r + 103*s - 69) - 11*k2**2*(17*r + 17*s - 11)) + f*k1**2*(132*C - 66)*(k1**2 - k2**2)*(2*r + 2*s - 1) - 132*g2*k1**2*k2**2*(2*r + 2*s - 1))))/(1155*d**2*k3**6) + D1**3*Pk1*Pkdd3*st**2*(r + s - 1)*(-2*D1*bd1*f*(r + s)*(f*(2*C - 1)*(k1**2 + 7*k2**2) + k2**2*(-7*b2 + 14*g2)) + 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(7*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(14*C - 7) + k2**2*(-70*C + 7*K - 3*f + 35))*(r + s - 1)) + Dd*f*(k1**2*(28*C - 14) + k2**2*(-140*C + 14*K - 3*f + 70))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(k1**2*(28*C - 14) + k2**2*(-140*C + 14*K - 3*f + 70))*(2*r + 2*s - 1) - 2*D1*(r + s - 1)*(f*fd*(4*C - 2)*(k1**2 + 7*k2**2) - 7*f*k2**2*(bd2 - 2*gd2) - 7*fd*k2**2*(b2 - 2*g2)) - 2*Dd*f*(f*(2*C - 1)*(k1**2 + 7*k2**2) + k2**2*(-7*b2 + 14*g2))*(4*r + 4*s - 3)))/(105*d**2*k3**2) + D1**3*Pk1*Pkdd3*(r + s - 1)*(-4*D1*bd1*f*k1**2*(b2 - 2*g2)*(r + s) + 5*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(5*D1*bd1*f*k2**2*(3*r + 3*s - 2) - 2*D1*fd*(2*K*k1**2 - 3*f*k2**2)*(r + s - 1) + Dd*f*(-4*K*k1**2 + 3*f*k2**2)*(4*r + 4*s - 3)) + b1*(-8*D1*K*bd1*f*k1**2*r - 8*D1*K*bd1*f*k1**2*s + 4*D1*K*bd1*f*k1**2 + 6*D1*bd1*f**2*k2**2*r + 6*D1*bd1*f**2*k2**2*s - 3*D1*bd1*f**2*k2**2 - 4*D1*bd2*f*k1**2*(r + s - 1) + 8*D1*f*gd2*k1**2*r + 8*D1*f*gd2*k1**2*s - 8*D1*f*gd2*k1**2 + 8*D1*fd*g2*k1**2*r + 8*D1*fd*g2*k1**2*s - 8*D1*fd*g2*k1**2 + 32*Dd*f*g2*k1**2*r + 32*Dd*f*g2*k1**2*s - 24*Dd*f*g2*k1**2 - 4*b2*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(15*d**2*k3**2) + D1**3*Pk1*Pkdd3*st**2*(21*b1**3*k2**2*(k1**2 - 10*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(7*bd1*f*k2**2*(k1**2 - 10*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(14 - 28*C)*(r + s - 1)**2 + k1**2*k2**2*(140*C*(r + s - 1)**2 + 14*K*(2*r + 2*s - 1) + f*(8*r**2 + r*(16*s - 7) + 8*s**2 - 7*s + 3) - 70*(r + s - 1)**2) + 7*k2**4*(-10*K*(r + s)**2 + f*(20*r**2 + 5*r*(8*s - 5) + 20*s**2 - 25*s + 9)))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(7 - 14*C)*(r + s - 1) + k1**2*k2**2*(70*C*(r + s - 1) + 7*K + 2*f*r + 2*f*s - 35*r - 35*s + 35) + 7*k2**4*(-5*K*(r + s) + f*(5*r + 5*s - 3)))) + b1*(-3*D1*bd1*f*(r + s - 1)*(k1**4*(28*C - 14)*(2*r + 2*s - 1) - k1**2*k2**2*(140*C*(2*r + 2*s - 1) + 14*K + f*(8*r + 8*s + 3) - 140*r - 140*s + 70) - 7*k2**4*(-20*K*(r + s) + f*(20*r + 20*s - 9))) + D1*(f**2*fd*k2**2*(k1**2*(9*r**2 + 3*r*(6*s - 11) + 9*s**2 - 33*s + 20) + 9*k2**2*(36*r**2 + r*(72*s - 53) + 36*s**2 - 53*s + 21)) - 6*f*(fd*(7*K*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + k1**4*(2*C - 1)*(9*r + 9*s - 5) + k1**2*k2**2*(14*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + K*(-16*r**2 - 32*r*s + 2*r - 16*s**2 + 2*s + 3) - 42*r**2 - 84*r*s + 42*r - 42*s**2 + 42*s - 7)) - 7*k2**2*(bd2*(k1**2 - 5*k2**2)*(r + s) - 2*gd2*(k1**2 - 5*k2**2*(r + s)))*(r + s - 1)) + 42*fd*k2**2*(b2*(k1**2 - 5*k2**2)*(r + s)**2 + 2*g2*(k1**2*(-2*r - 2*s + 1) + 5*k2**2*(r + s)**2))) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(3*r + 3*s - 7) + 36*k2**2*(3*r + 3*s - 2)) - 6*f*(7*K*k2**4*(r + s) + k1**4*(8*C - 4) + k1**2*k2**2*(14*C*(3*r + 3*s - 2) - K*(8*r + 8*s + 3) - 21*r - 21*s + 14)) + 42*k2**2*(b2*(k1**2 - 5*k2**2)*(r + s) - 2*g2*(k1**2 - 5*k2**2*(r + s))))) + f*(D1*bd1*(r + s - 1)*(f**2*k2**2*(k1**2*(3*r + 3*s - 1) + 27*k2**2*(4*r + 4*s - 1)) - 6*f*(7*K*k2**4*(r + s) + k1**4*(6*C - 3) + k1**2*k2**2*(42*C*(r + s - 1) - K*(8*r + 8*s + 3) - 21*r - 21*s + 21)) + 42*k2**2*(r + s)*(b2*(k1**2 - 5*k2**2) + 10*g2*k2**2)) + 2*D1*(f*(-fd*k1**2*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + k2**2*(3*bd2 - 6*gd2)*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(r + s - 1)) + 3*fd*k2**2*(b2 - 2*g2)*(k1**2*(8*r + 8*s + 3) - 7*k2**2*(r + s))*(2*r + 2*s - 1)) - 2*Dd*f*(f*k1**2*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) + k2**2*(3*b2 - 6*g2)*(-k1**2*(8*r + 8*s + 3) + 7*k2**2*(r + s)))*(4*r + 4*s - 3)))/(315*d**2*k3**4) + D1**3*Pk3*Pkd1*ct**7*f*k2**5*(16*C - 16)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(6*r + 6*s - 1) + Dd*f*(24*r**2 + 24*r*s - 6*r - 4*s - 1)))/(315*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**7*f*k2**3*(8*C - 8)*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + 5*f*(D1*fd*(3*r - 1)*(6*s - 5) + Dd*f*(8*r*(3*s - 2) - 4*s + 3)))/(315*d**2*k3**4) + 4*D1**3*Pk3*Pkd1*ct**6*f*k2**4*(11*D1*bd1*f*(5*f*k2**2*(21*r**2 + r*(21*s - 40) - 33*s + 19) + 18*k1**2*(2*C*(9*r**2 + 9*r*(s - 3) - 29*s + 18) - 12*r**2 - 12*r*s + 43*r + 48*s - 31)) + 11*b1*(3*D1*fd*r*(5*f*k2**2*(21*r + 21*s - 11) + 12*k1**2*(2*C*(9*r + 9*s - 8) - 12*r - 12*s + 13)) + Dd*f*(5*f*k2**2*(84*r**2 + r*(84*s - 73) - 33*s + 19) + 18*k1**2*(C*(72*r**2 + 72*r*s - 82*r - 58*s + 36) - 48*r**2 - 48*r*s + 64*r + 48*s - 31))) + 5*f*(D1*fd*(7*f*k2**2*(4*r - 1)*(23*r + 23*s - 9) + 22*k1**2*(3*r - 1)*(C*(6*r + 6*s + 8) - 9)) + Dd*f*(7*f*k2**2*(4*r - 1)*(23*r + 23*s - 9) + 22*k1**2*(2*C*(12*r**2 + 12*r*s + 33*r + 7*s - 14) - 72*r - 18*s + 27))))/(3465*d**2*k1*k3**6) + 4*D1**3*Pk3*Pkd1*ct**6*f*k2**2*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + 5*f*(D1*fd*(3*r - 1)*(6*s - 5) + Dd*f*(8*r*(3*s - 2) - 4*s + 3)))/(315*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkd1*ct**6*f*k2**2*(9*D1*bd1*f*(k1**2*(C*(34*r*s - 40*r - 66*s + 40) - 28*r*s + 35*r + 56*s - 35) + k2**2*(r**2*(38 - 32*C) + r*(32*C + 6*s - 43) - 10*s + 5)) + 9*b1*(2*D1*fd*r*(k1**2*(34*C*s - 24*C - 28*s + 21) + k2**2*(-32*C*r + 38*r + 6*s - 3)) + Dd*f*(k1**2*(2*C*(68*r*s - 48*r - 33*s + 20) - 112*r*s + 84*r + 56*s - 35) + k2**2*(-r**2*(128*C - 152) + r*(32*C + 24*s - 50) - 10*s + 5))) + f*(D1*fd*(3*r - 1)*(5*k1**2*(10*C*(3*s - 4) - 24*s + 35) + k2**2*(-2*C*(75*r + 29) + 180*r + 30*s + 53)) + Dd*f*(5*k1**2*(2*C*(60*r*s - 64*r - 7*s + 12) - 96*r*s + 112*r + 10*s - 21) + k2**2*(C*(-600*r**2 - 82*r + 58) + 720*r**2 + 120*r*s + 52*r - 20*s - 63))))/(315*d**2*k1*k3**4) + D1**3*Pk3*Pkd1*ct**5*f*k2**5*st**2*(32*C - 32)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(72*r**2 + 72*r*s - 9*r + 12*s - 17) + Dd*f*(96*r**2 + 96*r*s + 12*r + 32*s - 37)))/(315*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**5*f*k2**3*st**2*(16*C - 16)*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + f*(D1*fd*(72*r*s - 51*r + 12*s + 5) + Dd*f*(96*r*s - 52*r + 32*s - 15)))/(315*d**2*k3**4) - 8*D1**3*Pk3*Pkd1*ct**5*k2**3*(11*D1*bd1*f*(5*f**2*k2**2*(29*r + 32*s - 22) + 9*f*(k1**2*(2*C*(17*r**2 + r*(17*s + 5) + 23*s - 22) - 37*r**2 + r*(6 - 37*s) - 27*s + 31) + k2**2*(14*C*(r - 1)*(2*r + 2*s - 1) + K*r**2 + K*r*s - 8*K*r - 2*K*s + 2*K + b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) - 29*r**2 - 29*r*s + 50*r + 30*s - 16)) - 21*k2**2*(b1*(K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) + 33*b1**2*k2**2*(D1*fd*r*(18*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(3*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5) - (7*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 11*b1*(D1*(5*f**2*fd*k2**2*(3*r - 6*s + 1) + 3*f*(6*fd*k1**2*r*(C*(34*r + 34*s + 4) - 37*r - 37*s + 1) + 3*fd*k2**2*(K*(2*r - 1)*(r + s - 4) + r**2*(56*C - 58) + r*(56*C*s - 28*C - 58*s + 37) + s - 4) + 14*gd2*k2**2*r*(r + s + 2)) + 42*fd*g2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(32*r + 26*s - 21) + 9*f*(k1**2*(2*C*(68*r**2 + r*(68*s - 9) + 23*s - 22) - 148*r**2 + r*(41 - 148*s) - 27*s + 31) + k2**2*(14*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s - 25*r - 5*s + 8) - 116*r**2 - 116*r*s + 109*r + 33*s - 22)) + 42*g2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) - f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(r + s + 2) - 55*f*fd*(3*r - 1)*(k1**2*(26*C*(3*r + 3*s - 2) - 75*r - 75*s + 47) + k2**2*(18*C - 18)*(2*r + 2*s - 1)) + 198*f*gd2*k2**2*(r**2 + r*(s - 8) - 2*s + 2) + 198*fd*g2*k2**2*(2*r - 1)*(r + s - 4)) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(r + s + 2) - 55*f*(k1**2*(2*C*(156*r**2 + 3*r*(52*s - 61) - 59*s + 46) - 300*r**2 + r*(327 - 300*s) + 107*s - 79) + k2**2*(18*C - 18)*(4*r - 1)*(2*r + 2*s - 1)) + 198*g2*k2**2*(4*r**2 + r*(4*s - 25) - 5*s + 8))))/(3465*d**2*k3**6) - 4*D1**3*Pk3*Pkd1*ct**5*k2*(-42*b1**2*k1**2*(C - 1)*(D1*fd*r*(s - 1) + Dd*f*(4*r*(s - 2) - 3*s + 3)) + 3*b1*f*(-14*D1*bd1*k1**2*(C - 1)*(2*r*(s - 3) - 3*s + 3) + 6*D1*fd*(k1**2*(C*(14*r*s - s - 3) - 13*r*s + 3*r + s + 3) + 13*k2**2*r**2) + 3*Dd*f*(k1**2*(C*(56*r*s - 30*s + 8) - 52*r*s + 12*r + 33*s - 13) + 13*k2**2*r*(4*r - 1))) + f**2*(9*D1*bd1*(k1**2*(2*C*(7*r*s - 12*s + 5) - 13*r*s + 5*r + 27*s - 15) + 13*k2**2*r*(r - 1)) + D1*fd*(3*r - 1)*(5*k1**2*(2*C*(6*s - 5) - 9*s + 15) + k2**2*(60*r + 19)) + Dd*f*(5*k1**2*(C*(48*r*s - 32*r - 8*s + 6) - 36*r*s + 48*r + 3*s - 9) + k2**2*(240*r**2 + 16*r - 19))))/(315*d**2*k1**2*k3**2) - 4*D1**3*Pk3*Pkd1*ct**5*k2*(33*D1*bd1*f*(-14*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(2*s - 7) - 3*s + 3) + 10*f**2*k2**4*r*(r - 1) - 3*f*k1**2*(k1**2*(6*C*(5*r*(s - 2) - 13*s + 10) - 19*r*s + 45*r + 55*s - 45) + k2**2*(C*(-56*r**2 + 30*r*s + 58*r + 16*s - 6) + 42*r**2 - 39*r*s - 47*r - 15*s + 9))) - 462*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 33*b1*f*(-6*D1*fd*(-5*f*k2**4*r**2 + k1**4*r*(6*C*(5*s - 6) - 19*s + 27) - k1**2*k2**2*(C*(56*r**2 - 30*r*s + 13*r - s + 1) - 42*r**2 + 39*r*s - 14*r + s - 1)) + Dd*f*(10*f*k2**4*r*(4*r - 1) - 3*k1**4*(6*C*(4*r*(5*s - 6) - 13*s + 10) - 76*r*s + 108*r + 55*s - 45) + 3*k1**2*k2**2*(2*C*(112*r**2 - 60*r*s - 11*s + 6) - 168*r**2 + 156*r*s - 18*r + 21*s - 15))) + f**2*(D1*fd*(15*f*k2**4*(28*r**2 + 41*r - 12) - 165*k1**4*(3*r - 1)*(6*C*s - 20*C - 3*s + 15) + 11*k1**2*k2**2*(2*C*(135*r**2 - 360*r*s + 552*r + 138*s - 205) - 45*r**2 + 945*r*s - 1167*r - 351*s + 406)) + Dd*f*(15*f*k2**4*(28*r**2 + 41*r - 12) - 165*k1**4*(2*C*(4*r*(3*s - 8) + s + 6) - 12*r*(s - 4) - 3*s - 9) + 11*k1**2*k2**2*(2*C*(180*r**2 - 480*r*s + 851*r + 194*s - 261) - 60*r**2 + 1260*r*s - 1801*r - 483*s + 538))))/(3465*d**2*k1**2*k3**4) + 4*D1**3*Pk3*Pkd1*ct**4*f*k2**4*st**2*(33*D1*bd1*f*(5*f*k2**2*(15*r**2 + r*(15*s - 29) - 24*s + 14) + 12*k1**2*(C*(26*r**2 + 26*r*s - 57*r - 55*s + 31) - 20*r**2 - 20*r*s + 46*r + 45*s - 26)) + 33*b1*(3*D1*fd*r*(5*f*k2**2*(15*r + 15*s - 8) + 4*k1**2*(C*(52*r + 52*s - 33) - 40*r - 40*s + 27)) + Dd*f*(5*f*k2**2*(60*r**2 + r*(60*s - 53) - 24*s + 14) + 12*k1**2*(C*(104*r**2 + 104*r*s - 92*r - 55*s + 31) - 80*r**2 - 80*r*s + 74*r + 45*s - 26))) + f*(D1*fd*(25*f*k2**2*(244*r**2 + r*(244*s - 123) - 6*s - 12) + 44*k1**2*(C*(288*r**2 + 18*r*(16*s + 7) + 183*s - 167) - 216*r**2 - 27*r*(8*s + 5) - 171*s + 150)) + Dd*f*(25*f*k2**2*(244*r**2 + r*(244*s - 123) - 6*s - 12) + 44*k1**2*(C*(384*r**2 + 6*r*(64*s + 53) + 335*s - 319) - 288*r**2 - 18*r*(16*s + 17) - 303*s + 282))))/(3465*d**2*k1*k3**6) + 8*D1**3*Pk3*Pkd1*ct**4*f*k2**2*st**2*(9*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 9*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + f*(D1*fd*(72*r*s - 51*r + 12*s + 5) + Dd*f*(96*r*s - 52*r + 32*s - 15)))/(315*d**2*k1*k3**2) + 8*D1**3*Pk3*Pkd1*ct**4*f*k2**2*st**2*(9*D1*bd1*f*(k1**2*(C*(30*r*s - 32*r - 57*s + 32) - 24*r*s + 27*r + 47*s - 27) + k2**2*(r**2*(23 - 17*C) + r*(17*C + 6*s - 28) - 10*s + 5)) + 9*b1*(D1*fd*r*(k1**2*(60*C*s - 37*C - 48*s + 31) + 2*k2**2*(-17*C*r + 23*r + 6*s - 3)) + Dd*f*(k1**2*(C*(120*r*s - 74*r - 57*s + 32) - 96*r*s + 62*r + 47*s - 27) + k2**2*(r**2*(92 - 68*C) + r*(17*C + 24*s - 35) - 10*s + 5))) + f*(D1*fd*(k1**2*(C*(r*(396*s - 321) + 93*s + 32) - 54*r*(6*s - 5) - 81*s - 27) + k2**2*(C*(-63*r**2 - 57*r + 26) + 135*r**2 + 72*r*s + 48*r + 12*s - 43)) + Dd*f*(k1**2*(C*(r*(528*s - 322) + 221*s - 96) - 54*r*(8*s - 5) - 189*s + 81) + k2**2*(C*(-84*r**2 - 83*r + 26) + 180*r**2 + 96*r*s + 95*r + 32*s - 63))))/(315*d**2*k1*k3**4) + 4*D1**3*Pk3*Pkd1*ct**4*k2**2*(-11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(48*r**2 + r*(48*s + 3) + 25*s - 31) + 9*k2**2*(r - 1)*(5*r + 5*s - 3)) + 9*f*k1**2*(2*k1**2*(2*C*(45*r**2 + r*(45*s - 37) - 5*s - 8) - 70*r**2 + r*(63 - 70*s) + 14*s + 7) - k2**2*(-28*C*(r - 1)*(7*r + 7*s - 4) - 2*K*(19*r**2 + 19*r*s - 40*r - 10*s + 10) + b1*(2*r**2 + r*(2*s + 5) + 31*s - 19) + 204*r**2 + 204*r*s - 330*r - 184*s + 114)) + 42*k1**2*k2**2*(b1*(r**2*(10*K - 12) + r*(5*K*(2*s - 3) - 12*s + 14) + s*(5*K - 2)) - 10*g2*(r**2 + r*(s - 1) + s))) + 33*b1**2*k1**2*k2**2*(2*D1*fd*r*(3*f*(r + s + 3) + (42 - 35*K)*(r + s)) + Dd*f*(3*f*(4*r**2 + r*(4*s + 11) + 31*s - 19) - 14*r**2*(20*K - 24) - 14*r*(5*K*(4*s - 5) - 24*s + 22) - 14*s*(5*K - 2))) - 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(144*r**2 + 9*r*(16*s - 3) + 15*s - 19) + 27*k2**2*r*(5*r + 5*s - 3)) + 6*f*k1**2*(6*fd*k1**2*r*(6*C*(15*r + 15*s - 4) - 70*r - 70*s + 21) + 3*fd*k2**2*(K*(2*r - 1)*(19*r + 19*s - 20) + r**2*(196*C - 204) + 4*r*(7*C*(7*s - 4) - 51*s + 37) + 18*s - 16) - 70*gd2*k2**2*r*(r + s - 2)) - 420*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(2*k1**2*(96*r**2 + 96*r*s - 12*r + 20*s - 25) + 9*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(2*C*(180*r**2 + 3*r*(60*s - 31) - 5*s - 8) - 280*r**2 + 7*r*(22 - 40*s) + 14*s + 7) + k2**2*(14*C*(4*r - 1)*(7*r + 7*s - 4) + K*(76*r**2 + 76*r*s - 139*r - 39*s + 40) - 408*r**2 - 408*r*s + 394*r + 118*s - 81)) - 420*g2*k1**2*k2**2*(4*r**2 + r*(4*s - 5) + s))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(k1**2*(93*r + 93*s - 67) + 11*k2**2*(5*r + 5*s - 3)) - 22*f*k1**2*(5*fd*(3*r - 1)*(k1**2*(2*C*(75*r + 75*s - 44) - 114*r - 114*s + 67) + 9*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 18*gd2*k2**2*(19*r**2 + 19*r*s - 40*r - 10*s + 10)) + 396*fd*g2*k1**2*k2**2*(2*r - 1)*(19*r + 19*s - 20)) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(k1**2*(93*r + 93*s - 67) + 11*k2**2*(5*r + 5*s - 3)) - 110*f*k1**2*(k1**2*(2*C*(300*r**2 + 300*r*s - 291*r - 95*s + 64) - 456*r**2 - 456*r*s + 438*r + 142*s - 95) + 9*k2**2*(4*r - 1)*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) + 396*g2*k1**2*k2**2*(76*r**2 + r*(76*s - 139) - 39*s + 40))))/(3465*d**2*k1*k3**6) + 4*D1**3*Pk3*Pkd1*ct**4*(-3*D1*bd1*f**2*(r*(s + 5) - 2*s) + 7*b1**2*(D1*fd*r*(s - 1) + Dd*f*(4*r*(s - 2) - 3*s + 3)) + b1*f*(7*D1*bd1*(2*r*(s - 3) - 3*s + 3) - 3*D1*fd*(2*r - 1)*(s + 3) + 3*Dd*f*(-4*r*(s + 3) + 5*s + 1)))/(105*d**2*k1) + 2*D1**3*Pk3*Pkd1*ct**4*(42*b1**2*(D1*fd*r*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(12 - 12*C)) + Dd*f*(k1**2*(4*C - 3)*(4*r*(s - 2) - 3*s + 3) + k2**2*r*(12 - 12*C)*(4*r - 1))) - 3*b1*f*(-14*D1*bd1*(k1**2*(4*C - 3)*(2*r*(s - 3) - 3*s + 3) + k2**2*r*(12 - 12*C)*(2*r - 1)) + 2*D1*fd*(3*k1**2*(4*C*(7*r*s - s - 3) - 14*r*s + 3*s + 9) + k2**2*(2*C*(6*r**2 + 17*r - 13) + 27*r**2 - 108*r*s + 20*r + 26)) + Dd*f*(6*k1**2*(2*C*(28*r*s - 23*s + 8) - 28*r*s + 31*s - 12) + k2**2*(4*C*(12*r**2 + 49*r - 13) + 108*r**2 - 432*r*s - 19*r + 12*s + 46))) - f**2*(3*D1*bd1*(6*k1**2*(2*C*(7*r*s - 17*s + 10) - 7*r*s + 22*s - 15) + k2**2*(r**2*(12*C + 27) + r*(76*C - 108*s - 109) + 12*s - 6)) + D1*fd*(10*k1**2*(3*r - 1)*(C*(6*s - 20) + 15) + k2**2*(4*C*(45*r**2 - 102*r + 29) - 45*r**2 - 720*r*s + 765*r + 276*s - 262)) + Dd*f*(10*k1**2*(2*C*(4*r*(3*s - 8) + s + 6) + 48*r - 6*s - 9) + k2**2*(4*C*(60*r**2 - 131*r + 29) - 60*r**2 - 960*r*s + 1155*r + 358*s - 344))))/(315*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**4*(11*D1*bd1*f*(f**2*k2**4*(90*r**2 + 3*r*(160*s - 49) - 185*s + 115) + 3*f*(6*k1**4*(C*(r*(6*s - 40) - 38*s + 40) + r*(25 - 2*s) + 22*s - 25) + 3*k1**2*k2**2*(4*C*(19*r**2 + r*(66*s - 23) + 3*s - 2) - 79*r**2 + r*(103 - 258*s) + 16*s - 4) + 2*k2**4*(3*b1*(14*r**2 + r*(10*s - 19) - 13*s + 8) + r**2*(84*C - 9*K - 120) - r*(84*C + 13*K + 45*s - 184) + 48*s - 27)) - 42*k2**2*(b1*k1**2*(4*C*(2*r**2 + 2*r*s + 3*r + 2*s - 2) - 10*r**2 - 10*r*s - 5*r - 5*s + 5) + b1*k2**2*(r**2*(12*K - 14) + r*(-6*K - 2*s + 5) + 3*s) - 12*g2*k2**2*r*(r - 1))) + 66*b1**2*k2**2*(D1*fd*r*(k1**2*(35 - 28*C)*(r + s - 1) + k2**2*(-42*K*r + 6*f*(7*r + 5*s - 2) + 49*r + 7*s)) + Dd*f*(-7*k1**2*(4*C*(4*r**2 + 4*r*s + r + 2*s - 2) - 20*r**2 - 20*r*s + 5*r - 5*s + 5) + k2**2*(3*f*(28*r**2 + r*(20*s - 23) - 13*s + 8) - 7*r**2*(24*K - 28) - 7*r*(-6*K - 4*s + 3) - 21*s))) + 11*b1*(3*D1*(f**2*fd*k2**4*(90*r**2 + 480*r*s - 207*r - 10*s - 26) + 2*f*(fd*(6*k1**4*r*(6*C*(s - 4) - 2*s + 15) + 3*k1**2*k2**2*(C*(76*r**2 + 6*r*(44*s - 13) + 20*s - 20) - 79*r**2 - 258*r*s + 77*r - 19*s + 19) + k2**4*(K*(-18*r**2 - 17*r + 13) + r**2*(168*C - 240) + r*(86 - 90*s) + 3*s - 25)) + 84*gd2*k2**4*r**2) + 168*fd*g2*k2**4*r**2) + Dd*f*(f**2*k2**4*(360*r**2 + 384*r*(5*s - 2) - 215*s + 37) + 3*f*(6*k1**4*(C*(24*r*(s - 4) - 38*s + 40) + r*(60 - 8*s) + 22*s - 25) + 3*k1**2*k2**2*(4*C*(76*r**2 + 3*r*(88*s - 39) + 19*s - 18) - 316*r**2 + r*(463 - 1032*s) - 42*s + 54) - 2*k2**4*(K*(36*r**2 + 43*r - 13) - r**2*(336*C - 480) + 4*r*(21*C + 45*s - 82) - 57*s + 58)) + 504*g2*k2**4*r*(4*r - 1))) + f*(D1*(5*f**2*fd*k2**4*(1344*r**2 + r*(3080*s - 3158) - 825*s + 733) - 11*f*(fd*(10*k1**4*(3*r - 1)*(C*(6*s + 40) - 6*s - 25) + k1**2*k2**2*(-36*C*(135*r**2 + 2*r*(90*s - 103) - 67*s + 56) + 4275*r**2 + 9*r*(700*s - 709) - 2316*s + 1724) - 90*k2**4*(3*r - 1)*(r*(4*C - 6) - 2*s + 1)) - 12*gd2*k2**4*r*(9*r + 13)) + 132*fd*g2*k2**4*(18*r**2 + 17*r - 13)) + Dd*f*(5*f**2*k2**4*(1344*r**2 + r*(3080*s - 3158) - 825*s + 733) - 11*f*(10*k1**4*(2*C*(4*r*(3*s + 16) - 11*s - 12) - 8*r*(3*s + 10) + 16*s + 15) + k1**2*k2**2*(-12*C*(540*r**2 + r*(720*s - 889) - 263*s + 230) + 5700*r**2 + r*(8400*s - 9213) - 2978*s + 2386) - 90*k2**4*(4*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 132*g2*k2**4*(36*r**2 + 43*r - 13))))/(3465*d**2*k1*k3**4) + D1**3*Pk3*Pkd1*ct**3*f*k2**5*st**4*(16*C - 16)*(3*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 3*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13) + Dd*f*(24*r**2 + 6*r*(4*s + 3) + 28*s - 23)))/(105*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**4*(8*C - 8)*(3*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 3*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + f*(D1*fd*(18*r*s - 9*r + 18*s - 5) + Dd*f*(24*r*s - 8*r + 28*s - 15)))/(105*d**2*k3**4) + 8*D1**3*Pk3*Pkd1*ct**3*k2**3*st**2*(11*D1*bd1*f*(2*f**2*k2**2*(18*r**2 + 2*r*(9*s - 73) - 149*s + 103) + 3*f*(k1**2*(C*(74*r**2 + r*(74*s - 292) - 310*s + 218) - 32*r**2 - 32*r*s + 187*r + 205*s - 155) + k2**2*(-42*C*(r - 1)*(2*r + 2*s - 1) + K*r**2 + K*r*s + 20*K*r + 12*K*s - 12*K - 6*b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) + 83*r**2 + 83*r*s - 146*r - 96*s + 54)) + 21*k2**2*(b1*(K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) - 33*b1**2*k2**2*(D1*fd*r*(36*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(6*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5) - (7*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 11*b1*(D1*(2*f**2*fd*k2**2*(54*r**2 + 6*r*(9*s - 11) - 12*s + 17) + 3*f*(fd*k1**2*r*(4*C*(37*r + 37*s - 50) - 64*r - 64*s + 137) + fd*k2**2*(K*(2*r**2 + r*(2*s + 19) + 13*s - 10) - r**2*(168*C - 166) + r*(-168*C*s + 84*C + 166*s - 103) - 13*s + 10) - 14*gd2*k2**2*r*(r + s + 2)) - 42*fd*g2*k2**2*r*(r + s)) + Dd*f*(2*f**2*k2**2*(72*r**2 + 4*r*(18*s - 53) - 161*s + 120) + 3*f*(k1**2*(C*(296*r**2 + r*(296*s - 474) - 310*s + 218) - 128*r**2 - 128*r*s + 306*r + 205*s - 155) + k2**2*(-42*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + 332*r**2 + 332*r*s - 311*r - 121*s + 76)) - 42*g2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(10*f**2*fd*k2**2*(256*r**2 + 256*r*s + 30*r + 123*s - 117) + 11*f*(fd*(k1**2*(2*C*(63*r**2 + 9*r*(7*s + 50) + 393*s - 295) + 18*r**2 + 18*r*(s - 42) - 627*s + 457) + k2**2*(54 - 54*C)*(3*r - 1)*(2*r + 2*s - 1)) - 6*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) - 66*fd*g2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(10*f**2*k2**2*(256*r**2 + 256*r*s + 30*r + 123*s - 117) + 11*f*(k1**2*(2*C*(84*r**2 + r*(84*s + 771) + 613*s - 515) + 24*r**2 + 24*r*(s - 52) - 955*s + 785) + k2**2*(54 - 54*C)*(4*r - 1)*(2*r + 2*s - 1)) - 66*g2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**6) + 8*D1**3*Pk3*Pkd1*ct**3*k2*(11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(6*r**2 + r*(6*s - 8) + 3*s + 5) - 9*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 9*f*(k1**4*(C*(66*r**2 + r*(66*s - 72) - 26*s + 6) - 41*r**2 + r*(46 - 41*s) + 17*s - 5) + k1**2*k2**2*(42*C*(r - 1)*(3*r + 3*s - 2) + 59*K*r**2 + 59*K*r*s - 80*K*r - 20*K*s + 20*K + b1*(-54*r**2 + r*(47 - 54*s) + 3*s + 2) - 132*r**2 - 132*r*s + 202*r + 103*s - 75) - 7*k2**4*(b1*(2*r - 1)*(2*r + 2*s - 1) - r*(K - 1)*(r + s))) - 21*k2**2*(b1*(k1**2*(r**2*(50*K - 38) + r*(5*K*(10*s - 9) - 38*s + 31) + s*(7 - 5*K)) + k2**2*(5*K - 5)*(r + s)*(2*r - 1)) - 10*g2*(k1**2*(5*r**2 + 5*r*(s - 1) - s) + k2**2*(r - 1)*(r + s)))) + 33*b1**2*k2**2*(D1*fd*r*(6*f*(k1**2*(27*r + 27*s - 10) + 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(25*K - 19) - 7*k2**2*(5*K - 5))) + Dd*f*(3*f*(k1**2*(108*r**2 + 108*r*s - 67*r - 3*s - 2) + 7*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 7*k1**2*(r**2*(100*K - 76) + r*(100*K*s - 65*K - 76*s + 43) + s*(7 - 5*K)) - 7*k2**2*(5*K - 5)*(r + s)*(4*r - 1))) + 11*b1*(3*D1*(5*f**2*fd*k2**2*(k1**2*(6*r**2 + r*(6*s - 22) - 15*s + 10) - 3*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) + f*(-3*fd*(2*k1**4*r*(C*(66*r + 66*s - 26) - 41*r - 41*s + 17) + k1**2*k2**2*(K*(2*r - 1)*(59*r + 59*s - 40) + r**2*(252*C - 264) + r*(84*C*(3*s - 2) - 264*s + 215) + 41*s - 24) + k2**4*(7*K - 7)*(r + s)*(2*r - 1)) + 70*gd2*k2**2*r*(k1**2*(5*r + 5*s - 4) + k2**2*(r + s))) + 70*fd*g2*k2**2*r*(5*k1**2 + k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(k1**2*(24*r**2 + r*(24*s - 74) - 42*s + 35) - 9*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 9*f*(k1**4*(2*C*(132*r**2 + r*(132*s - 85) - 13*s + 3) - 164*r**2 + r*(109 - 164*s) + 17*s - 5) + k1**2*k2**2*(42*C*(4*r - 1)*(3*r + 3*s - 2) + K*(236*r**2 + r*(236*s - 299) - 99*s + 80) - 528*r**2 - 528*r*(s - 1) + 156*s - 111) + k2**4*(7*K - 7)*(r + s)*(4*r - 1)) + 210*g2*k2**2*(k1**2*(20*r**2 + r*(20*s - 13) - s) + k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(k1**2*(53*r + 53*s - 37) + 22*k2**2*(3*r + 3*s - 2)) - 55*f*fd*k1**2*(3*r - 1)*(k1**2*(2*C*(51*r + 51*s - 31) - 63*r - 63*s + 39) + 9*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*f*gd2*k2**2*(k1**2*(59*r**2 + 59*r*s - 80*r - 20*s + 20) + 7*k2**2*r*(r + s)) + 198*fd*g2*k2**2*(2*r - 1)*(k1**2*(59*r + 59*s - 40) + 7*k2**2*(r + s))) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(k1**2*(53*r + 53*s - 37) + 22*k2**2*(3*r + 3*s - 2)) - 55*f*k1**2*(k1**2*(2*C*(204*r**2 + 3*r*(68*s - 65) - 61*s + 41) - 252*r**2 - 3*r*(84*s - 81) + 75*s - 51) + 9*k2**2*(4*r - 1)*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*g2*k2**2*(k1**2*(236*r**2 + r*(236*s - 299) - 99*s + 80) + 7*k2**2*(r + s)*(4*r - 1)))))/(3465*d**2*k3**6) - 2*D1**3*Pk3*Pkd1*ct**3*(11*D1*bd1*f*(2*f**2*k2**4*(165*r**2 - 195*r*s - 59*r + 184*s - 114) + 3*f*(k1**4*(12*C - 6)*(r*(s + 5) + 3*s - 5) - 3*k1**2*k2**2*(4*C*(51*r**2 + r*(87*s - 62) - 11*s + 5) - 127*r**2 + r*(165 - 262*s) + 42*s - 22) + k2**4*(-84*C*(6*r**2 + r*(s - 7) - 2*s + 1) - 150*K*r**2 - 138*K*r*s + 270*K*r + 52*K*s - 52*K + 6*b1*(66*r**2 + r*(92*s - 72) - 9*s + 5) + 723*r**2 + 360*r*s - 958*r - 286*s + 202)) + 21*k2**2*(2*b1**2*k2**2*(3*r**2 + r*(3*s - 8) - 3*s + 3) + b1*(k1**2*(4*C*(14*r**2 + r*(14*s - 9) - s + 1) - 44*r**2 - 44*r*s + 34*r + 6*s - 6) + k2**2*(20*C*(2*r - 1)*(r + s - 1) + 4*K*(5*r**2 - 9*r*s - r + 1) - 22*r**2 + 28*r*s + 37*r + 12*s - 24)) + 2*k2**2*(b2*(r**2 + r*(s - 1) - 3*s) + 2*g2*(-5*r**2 + r*(9*s + 5) - 2*s)))) + 462*b1**3*k2**4*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 33*b1**2*k2**2*(D1*fd*(k1**2*r*(196*C - 154)*(r + s - 1) + k2**2*(14*K*(5*r**2 - r*(9*s + 8) - 4*s + 4) + 6*f*(66*r**2 + r*(92*s - 53) + s - 1) + 7*r**2*(20*C - 11) + 14*r*(10*C*(s - 1) + 7*s + 18) + 56*s - 56)) + Dd*f*(14*k1**2*(C*(56*r**2 + r*(56*s - 46) - 2*s + 2) - 44*r**2 - 44*r*s + 39*r + 3*s - 3) + k2**2*(140*C*(4*r - 1)*(r + s - 1) + 14*K*(20*r**2 - 36*r*s - 7*r - 6*s + 8) + 6*f*(132*r**2 + r*(184*s - 125) - 8*s + 4) - 308*r**2 + 392*r*s + 553*r + 168*s - 252))) + 11*b1*(3*D1*(2*f**2*fd*k2**4*(165*r**2 - r*(195*s + 94) - 121*s + 115) + f*(fd*(k1**4*r*(24*C - 12)*(s + 3) - 6*k1**2*k2**2*(C*(204*r**2 + 4*r*(87*s - 23) + 34*s - 34) - 127*r**2 - 262*r*s + 74*r - 25*s + 25) - k2**4*(84*C*(12*r**2 + 2*r*s + r + s - 1) + 2*K*(150*r**2 + 3*r*(46*s - 85) - 76*s + 90) - 1446*r**2 - 720*r*s + 599*r + 164*s - 106)) + 14*k2**4*(bd2*r*(r + s + 2) - 2*gd2*(5*r**2 + r*(3 - 9*s) - 2*s + 2))) + 14*fd*k2**4*(b2*r*(r + s) - 2*g2*(5*r**2 - r*(9*s + 8) - 4*s + 4))) + Dd*f*(2*f**2*k2**4*(660*r**2 - r*(780*s + 341) - 179*s + 231) + 3*f*(k1**4*(12*C - 6)*(4*r*(s + 3) + 3*s - 5) - 3*k1**2*k2**2*(12*C*(68*r**2 + r*(116*s - 59) + 4*s - 6) - 508*r**2 + r*(523 - 1048*s) - 24*s + 44) + k2**4*(84*C*s - 2*K*(300*r**2 + 3*r*(92*s - 175) - 128*s + 142) + r**2*(2892 - 2016*C) + r*(-336*C*s + 504*C + 1440*s - 1927) - 526*s + 384)) + 42*k2**4*(b2*(4*r**2 + r*(4*s + 3) - 3*s) - 2*g2*(20*r**2 - r*(36*s + 7) - 6*s + 8)))) - f*(D1*(10*f**2*fd*k2**4*(1596*r**2 + r*(3696*s - 3251) - 990*s + 746) - 11*f*(fd*(k1**4*(20*C - 10)*(3*r - 1)*(3*s + 5) + k1**2*k2**2*(-4*C*(1800*r**2 + 60*r*(36*s - 35) - 801*s + 527) + 4635*r**2 + r*(6480*s - 5727) - 2394*s + 1472) - 90*k2**4*(3*r - 1)*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) - 6*k2**4*(3*bd2*(r**2 + r*(s - 8) - 2*s + 2) - 2*gd2*(75*r**2 + 69*r*s - 135*r - 26*s + 26))) + 66*fd*k2**4*(3*b2*(2*r - 1)*(r + s - 4) - 2*g2*(150*r**2 + 3*r*(46*s - 85) - 76*s + 90))) + Dd*f*(10*f**2*k2**4*(1596*r**2 + r*(3696*s - 3251) - 990*s + 746) - 11*f*(k1**4*(20*C - 10)*(4*r*(3*s + 4) - 5*s - 3) + k1**2*k2**2*(-4*C*(2400*r**2 + 10*r*(288*s - 299) - 1023*s + 749) + 6180*r**2 + r*(8640*s - 8261) - 3042*s + 2120) - 90*k2**4*(4*r - 1)*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) + 66*k2**4*(3*b2*(4*r**2 + r*(4*s - 25) - 5*s + 8) - 2*g2*(300*r**2 + 3*r*(92*s - 175) - 128*s + 142)))))/(3465*d**2*k2*k3**4) + 4*D1**3*Pk3*Pkd1*ct**3*k2*st**2*(42*b1**2*k1**2*(C - 1)*(D1*fd*r*(s - 1) + Dd*f*(4*r*(s - 2) - 3*s + 3)) + 3*b1*f*(14*D1*bd1*k1**2*(C - 1)*(2*r*(s - 3) - 3*s + 3) + D1*fd*(k1**2*(C*(-140*r*s + 56*r + 26*s - 6) + 104*r*s - 59*r - 26*s + 6) - 66*k2**2*r**2) + Dd*f*(k1**2*(-2*C*(28*r*(5*s - 2) - 97*s + 45) + 208*r*s - 118*r - 185*s + 96) + 33*k2**2*r*(1 - 4*r))) + f**2*(-3*D1*bd1*(k1**2*(2*C*(7*r*(5*s - 3) - 72*s + 30) - 52*r*s + 48*r + 135*s - 66) + 33*k2**2*r*(r - 1)) + D1*fd*(k1**2*(-4*C*(r*(72*s - 51) + 12*s + 5) + 3*r*(84*s - 73) + 69*s + 22) + k2**2*(9*r**2 - 15*r + 4)) + Dd*f*(k1**2*(-4*C*(96*r*s - 52*r + 32*s - 15) + 336*r*s - 218*r + 157*s - 66) + k2**2*(12*r**2 - 19*r + 4))))/(315*d**2*k1**2*k3**2) + 4*D1**3*Pk3*Pkd1*ct**3*k2*st**2*(33*D1*bd1*f*(14*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(2*s - 7) - 3*s + 3) + 5*f**2*k2**4*r*(r - 1) + f*k1**2*(k1**2*(2*C*(r*(73*s - 111) - 173*s + 111) + r*(156 - 92*s) + 235*s - 156) + k2**2*(-2*C*(68*r**2 - r*(19*s + 97) - 66*s + 27) + 85*r**2 - 2*r*(34*s + 73) - 117*s + 57))) + 462*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 33*b1*f*(D1*fd*(15*f*k2**4*r**2 + k1**4*r*(4*C*(73*s - 61) - 184*s + 169) + k1**2*k2**2*(-2*C*(136*r**2 - 38*r*s + 7*r - 13*s + 13) + 170*r**2 - 136*r*s + 23*r - 26*s + 26)) + Dd*f*(5*f*k2**4*r*(4*r - 1) + k1**4*(C*(8*r*(73*s - 61) - 346*s + 222) - 368*r*s + 338*r + 235*s - 156) + k1**2*k2**2*(-2*C*(272*r**2 - 76*r*s - 56*r - 91*s + 52) + 340*r**2 - 272*r*s - 43*r - 167*s + 107))) + f**2*(D1*fd*(15*f*k2**4*(140*r**2 - 59*r + 6) + 11*k1**4*(C*(774*r*s - 726*r + 246*s + 74) - 522*r*s + 507*r - 177*s - 52) + 11*k1**2*k2**2*(6*C*(75*r**2 + 42*r*s - 220*r - 110*s + 97) - 477*r**2 - 396*r*s + 1305*r + 771*s - 595)) + Dd*f*(15*f*k2**4*(140*r**2 - 59*r + 6) + 11*k1**4*(2*C*(516*r*s - 356*r + 271*s - 111) - 696*r*s + 494*r - 385*s + 156) + 11*k1**2*k2**2*(2*C*(300*r**2 + 168*r*s - 935*r - 466*s + 427) - 636*r**2 - 528*r*s + 1869*r + 1075*s - 899))))/(3465*d**2*k1**2*k3**4) - 2*D1**3*Pk3*Pkd1*ct**3*(D1*bd1*f**2*(-k1**2*(12*C - 6)*(r*(s + 5) - 2*s) + 7*k2**2*r*(3*r + 2)) + 7*b1**2*(D1*fd*r*(k1**2*(4*C - 2)*(s - 1) + 11*k2**2*r) + Dd*f*(k1**2*(4*C - 2)*(4*r*(s - 2) - 3*s + 3) + 11*k2**2*r*(4*r - 1))) + b1*f*(7*D1*bd1*(k1**2*(4*C - 2)*(2*r*(s - 3) - 3*s + 3) + 11*k2**2*r*(2*r - 1)) + D1*fd*(2*r - 1)*(-k1**2*(12*C - 6)*(s + 3) + 7*k2**2*(3*r + 2)) + Dd*f*(-k1**2*(12*C - 6)*(4*r*(s + 3) - 5*s - 1) + 7*k2**2*(12*r**2 + 5*r - 2))))/(105*d**2*k1**2*k2) + 2*D1**3*Pk3*Pkd1*ct**3*(-3*b1**2*(D1*fd*r*(-k1**4*(28*C - 14)*(s - 1) + 21*k1**2*k2**2*(4*C*(r - 3*s + 3) - 3*r + 12*s - 12) + k2**4*r*(72*f + 77)) + Dd*f*(-k1**4*(28*C - 14)*(4*r*(s - 2) - 3*s + 3) + 7*k1**2*k2**2*(4*C*(12*r**2 - 36*r*s + 19*r + 2*s - 2) - 36*r**2 + r*(144*s - 79) - 8*s + 8) + k2**4*r*(36*f + 77)*(4*r - 1))) - 3*b1*f*(D1*bd1*(-k1**4*(28*C - 14)*(2*r*(s - 3) - 3*s + 3) + 7*k1**2*k2**2*(4*C*(6*r**2 - 18*r*s + r + 2*s - 2) - 18*r**2 + r*(72*s - 7) - 8*s + 8) + k2**4*r*(36*f + 77)*(2*r - 1)) - D1*fd*(k1**4*(12*C - 6)*(s + 3) + k1**2*k2**2*(-8*C*(3*r**2 + r*(53 - 3*s) + 26*s - 32) + 12*r**2 + 3*r*(52*s + 77) + 208*s - 218) + k2**4*(-72*f*r + 24*f + 42*r**2 - 7*r + 14)) + Dd*f*(-k1**4*(48*C - 24)*(2*s - 1) + 2*k1**2*k2**2*(2*C*(12*r**2 + r*(155 - 12*s) + 92*s - 84) - 12*r**2 - 3*r*(52*s + 49) - 172*s + 143) + k2**4*(4*r - 1)*(24*f - 21*r + 14))) + f**2*(3*D1*bd1*(k1**4*(60*C - 30)*(s - 1) + k1**2*k2**2*(-80*C*s + r**2*(6 - 12*C) + r*(12*C*s - 56*C + 78*s + 39) + 56*s + 12) + k2**4*r*(-24*f + 21*r - 56)) + D1*fd*(k1**4*(20*C - 10)*(3*r - 1)*(3*s + 5) + k1**2*k2**2*(-8*C*(180*r**2 + 3*r*(45*s - 73) - 54*s + 56) + 1035*r**2 + 9*r*(190*s - 177) - 660*s + 446) + 90*k2**4*r*(3*r - 1)) + Dd*f*(k1**4*(20*C - 10)*(4*r*(3*s + 4) - 5*s - 3) + k1**2*k2**2*(-16*C*(120*r**2 + r*(90*s - 151) - 36*s + 37) + 1380*r**2 + 3*r*(760*s - 783) - 860*s + 646) + 90*k2**4*r*(4*r - 1))))/(315*d**2*k1**2*k2*k3**2) + 4*D1**3*Pk3*Pkd1*ct**2*f*k2**4*st**4*(33*D1*bd1*f*(5*f*k2**2*(3*r**2 + 3*r*(s - 2) - 5*s + 3) + 2*k1**2*(C*(34*r**2 + 34*r*s - 60*r - 52*s + 26) - 28*r**2 - 28*r*s + 49*r + 42*s - 21)) + 33*b1*(D1*fd*r*(5*f*k2**2*(9*r + 9*s - 5) + k1**2*(68*C - 56)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2*(12*r**2 + r*(12*s - 11) - 5*s + 3) + 2*k1**2*(2*C*(68*r**2 + 17*r*(4*s - 3) - 26*s + 13) - 112*r**2 - 28*r*(4*s - 3) + 42*s - 21))) + f*(D1*fd*(5*f*k2**2*(212*r**2 + r*(212*s - 69) + 57*s - 51) + 22*k1**2*(C*(90*r**2 + 18*r*(5*s + 3) + 96*s - 70) - 72*r**2 - 9*r*(8*s + 5) - 78*s + 57)) + Dd*f*(5*f*k2**2*(212*r**2 + r*(212*s - 69) + 57*s - 51) + 22*k1**2*(2*C*(60*r**2 + r*(60*s + 51) + 74*s - 61) - 96*r**2 - 12*r*(8*s + 7) - 120*s + 99))))/(1155*d**2*k1*k3**6) + 4*D1**3*Pk3*Pkd1*ct**2*f*k2**2*st**4*(3*D1*bd1*f*(r*(6*s - 5) - 10*s + 5) + 3*b1*(2*s - 1)*(6*D1*fd*r + Dd*f*(12*r - 5)) + f*(D1*fd*(18*r*s - 9*r + 18*s - 5) + Dd*f*(24*r*s - 8*r + 28*s - 15)))/(105*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkd1*ct**2*f*k2**2*st**4*(6*D1*b1*fd*r*(k1**2*(13*C - 10)*(2*s - 1) + k2**2*(-r*(2*C - 8) + 6*s - 3)) + 3*D1*bd1*f*(k1**2*(C*(26*r*s - 24*r - 48*s + 24) - 20*r*s + 19*r + 38*s - 19) + k2**2*(-r**2*(2*C - 8) + r*(2*C + 6*s - 13) - 10*s + 5)) + D1*f*fd*(k1**2*(6*C*(15*r*s - 7*r + 14*s - 4) - 72*r*s + 33*r - 66*s + 19) + k2**2*(C*(22 - 66*r) + 18*r**2 + 18*r*s + 75*r + 18*s - 35)) + 3*Dd*b1*f*(k1**2*(2*s - 1)*(4*C*(13*r - 6) - 40*r + 19) + k2**2*(-r**2*(8*C - 32) + 2*r*(C + 12*s - 10) - 10*s + 5)) + Dd*f**2*(k1**2*(12*C*(10*r*s - 3*r + 11*s - 6) - 96*r*s + 28*r - 104*s + 57) + k2**2*(C*(22 - 88*r) + 24*r**2 + 24*r*s + 106*r + 28*s - 45)))/(105*d**2*k1*k3**4) + 4*D1**3*Pk3*Pkd1*ct**2*k1*(11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(63*r**2 + r*(63*s - 55) - 4*s + 8) + 9*k2**2*(11*r + 9*s - 7)) - 9*f*(k1**4*(8*C - 4)*(4*r**2 + r*(4*s - 5) - 2*s + 1) + k1**2*k2**2*(28*C*(r - 1)*(5*r + 5*s - 4) + 2*K*(73*r**2 + 73*r*s - 80*r - 20*s + 20) + b1*(-114*r**2 + r*(107 - 114*s) + 25*s - 9) - 148*r**2 - 148*r*s + 218*r + 100*s - 86) - 7*k2**4*(b1*(2*r - 1)*(9*r + 9*s - 5) + r*(4 - 6*K)*(r + s))) - 42*k2**2*(b1*(k1**2*(r**2*(70*K - 32) + r*(K*(70*s - 55) - 32*s + 24) + s*(8 - 15*K)) + k2**2*(15*K - 10)*(r + s)*(2*r - 1)) - 10*g2*(k1**2*(7*r**2 + 7*r*(s - 1) - 3*s) + 3*k2**2*(r - 1)*(r + s)))) + 33*b1**2*k2**2*(2*D1*fd*r*(3*f*(k1**2*(57*r + 57*s - 25) + 7*k2**2*(9*r + 9*s - 5)) + (r + s)*(-7*k1**2*(35*K - 16) - 7*k2**2*(15*K - 10))) + Dd*f*(3*f*(k1**2*(228*r**2 + 228*r*s - 157*r - 25*s + 9) + 7*k2**2*(4*r - 1)*(9*r + 9*s - 5)) - 14*k1**2*(r**2*(140*K - 64) + r*(140*K*s - 75*K - 64*s + 32) + s*(8 - 15*K)) - 14*k2**2*(15*K - 10)*(r + s)*(4*r - 1))) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(189*r**2 + 3*r*(63*s - 68) - 87*s + 55) - 9*k2**2*(3*r + 9*s - 5)) - 6*f*(3*fd*(k1**4*r*(16*C - 8)*(2*r + 2*s - 1) + k1**2*k2**2*(K*(2*r - 1)*(73*r + 73*s - 40) + 2*r**2*(70*C - 74) + 2*r*(70*C*s - 56*C - 74*s + 67) + 32*s - 16) + k2**4*(21*K - 14)*(r + s)*(2*r - 1)) - 70*gd2*k2**2*r*(k1**2*(7*r + 7*s - 4) + 3*k2**2*(r + s))) + 420*fd*g2*k2**2*r*(7*k1**2 + 3*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(7*k1**2*(36*r**2 + r*(36*s - 37) - 13*s + 9) + 18*k2**2*(4*r - 1)) - 18*f*(k1**4*(4*C - 2)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + k1**2*k2**2*(14*C*(4*r - 1)*(5*r + 5*s - 4) + K*(292*r**2 + 292*r*s - 313*r - 113*s + 80) - 296*r**2 - 296*r*s + 310*r + 90*s - 67) + k2**4*(21*K - 14)*(r + s)*(4*r - 1)) + 420*g2*k2**2*(k1**2*(28*r**2 + r*(28*s - 15) - 3*s) + 3*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(8*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) - 22*f*(5*fd*k1**2*(3*r - 1)*(k1**2*(8*C - 4)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 18*gd2*k2**2*(k1**2*(73*r**2 + 73*r*s - 80*r - 20*s + 20) + 21*k2**2*r*(r + s))) + 396*fd*g2*k2**2*(2*r - 1)*(k1**2*(73*r + 73*s - 40) + 21*k2**2*(r + s))) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(8*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) - 110*f*k1**2*(k1**2*(4*C - 2)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) + 396*g2*k2**2*(k1**2*(292*r**2 + r*(292*s - 313) - 113*s + 80) + 21*k2**2*(r + s)*(4*r - 1)))))/(3465*d**2*k3**6) - 4*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(33*D1*bd1*f*(f**2*k2**2*(k1**2*(48*r**2 + 3*r*(16*s + 37) + 127*s - 115) + 18*k2**2*(r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**2*(4*C*(9*r**2 + r*(9*s + 22) + 27*s - 31) - 31*r**2 - r*(31*s + 47) - 58*s + 78) + k2**2*(28*C*(r - 1)*(15*r + 15*s - 8) - 6*K*(r**2 + r*(s + 20) + 12*s - 12) + 3*b1*(20*r**2 + r*(20*s - 27) - 47*s + 27) - 332*r**2 - 332*r*s + 598*r + 384*s - 230)) - 14*k1**2*k2**2*(b1*(3*K - 2)*(2*r**2 + 2*r*s + r - 3*s) - 6*g2*(r**2 + r*(s - 1) - 3*s))) + 33*b1**2*k1**2*k2**2*(D1*fd*r*(f*(60*r + 60*s - 51) + (28 - 42*K)*(r + s)) + Dd*f*(3*f*(40*r**2 + 40*r*s - 44*r - 47*s + 27) + (28 - 42*K)*(4*r**2 + 4*r*s + 3*r - 3*s))) + 33*b1*(D1*(f**2*fd*k2**2*(k1**2*(144*r**2 + 9*r*(16*s + 9) + 105*s - 85) + 54*k2**2*r*(5*r + 5*s - 3)) + 2*f*k1**2*(-fd*(k1**2*r*(-8*C*(9*r + 9*s + 13) + 62*r + 62*s + 67) + k2**2*(K*(6*r**2 + r*(6*s + 57) + 39*s - 30) + r**2*(332 - 420*C) - 4*r*(7*C*(15*s - 8) - 83*s + 55) - 26*s + 20)) + 42*gd2*k2**2*r*(r + s + 2)) + 84*fd*g2*k1**2*k2**2*r*(r + s)) + 2*Dd*f*(f**2*k2**2*(4*k1**2*(24*r**2 + 24*r*(s + 1) + 29*s - 25) + 9*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + f*k1**2*(k1**2*(4*C*(36*r**2 + r*(36*s + 43) + 27*s - 31) - 124*r**2 - r*(124*s + 103) - 58*s + 78) + k2**2*(14*C*(4*r - 1)*(15*r + 15*s - 8) - 3*K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) - 664*r**2 - 664*r*s + 650*r + 242*s - 159)) + 42*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(15*f**2*fd*k2**2*(3*k1**2*(56*r**2 + 8*r*(7*s - 18) - 91*s + 71) + 22*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*(k1**2*(8*C*(15*r - 29)*(3*r + 3*s - 2) - 279*r**2 - 9*r*(31*s - 70) + 462*s - 302) + 9*k2**2*(3*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 18*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 396*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(15*f**2*k2**2*(3*k1**2*(56*r**2 + 8*r*(7*s - 18) - 91*s + 71) + 22*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 22*f*k1**2*(k1**2*(8*C*(60*r**2 + 60*r*s - 177*r - 124*s + 95) - 372*r**2 - 372*r*s + 939*r + 650*s - 490) + 9*k2**2*(4*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 396*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k1*k3**6) + 4*D1**3*Pk3*Pkd1*ct**2*st**2*(D1*bd1*f**2*(r*(s - 9) + 12*s) + 7*b1**2*(D1*fd*r*(s - 1) + Dd*f*(4*r*(s - 2) - 3*s + 3)) + b1*f*(7*D1*bd1*(2*r*(s - 3) - 3*s + 3) + D1*fd*(2*r*(s - 4) + 13*s - 3) + Dd*f*(4*r*(s - 4) + 37*s - 15)))/(105*d**2*k1) + 4*D1**3*Pk3*Pkd1*ct**2*(D1*bd1*f**2*(r**2*(12 - 24*C) + r*(26*C + 33*s - 16) - 17*s) + 7*b1**2*(D1*fd*r*(2*C*r - r + 7*s - 7) + Dd*f*(r**2*(8*C - 4) + r*(-2*C + 28*s - 15) - s + 1)) + b1*f*(7*D1*bd1*(r**2*(4*C - 2) + r*(-2*C + 14*s - 1) - s + 1) + D1*fd*(C*(-48*r**2 + 76*r - 26) + 24*r**2 + 66*r*s - 71*r - 40*s + 33) - 2*Dd*f*(C*(48*r**2 - 64*r + 13) - 24*r**2 - 66*r*s + 65*r + 37*s - 25)))/(105*d**2*k1) + 2*D1**3*Pk3*Pkd1*ct**2*st**2*(14*b1**2*(D1*fd*r*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(3*C - 3)) + Dd*f*(k1**2*(4*C - 3)*(4*r*(s - 2) - 3*s + 3) + k2**2*r*(3*C - 3)*(4*r - 1))) + b1*f*(14*D1*bd1*(k1**2*(4*C - 3)*(2*r*(s - 3) - 3*s + 3) + k2**2*r*(3*C - 3)*(2*r - 1)) - 2*D1*fd*(k1**2*(2*C*(r*(32*s - 23) - 26*s + 6) + r*(23 - 32*s) + 39*s - 9) + k2**2*(C*(-46*r**2 + 69*r - 26) + 4*r**2 - 3*r*(32*s + 7) + 26)) + Dd*f*(-2*k1**2*(2*C*(r*(64*s - 46) - 125*s + 66) + r*(46 - 64*s) + 173*s - 90) + k2**2*(2*C*(92*r**2 - 127*r + 26) - 16*r**2 + 4*r*(96*s + 5) - 6*s - 49))) + f**2*(D1*bd1*(-2*k1**2*(2*C*(2*r*(8*s - 9) - 75*s + 36) - 16*r*s + 18*r + 98*s - 45) + k2**2*(r**2*(46*C - 4) + r*(-64*C + 96*s + 19) - 6*s + 3)) + D1*fd*(-2*k1**2*(C*(r*(72*s - 78) + 30*s + 8) + r*(48 - 45*s) - 18*s - 5) + k2**2*(-4*C*(63*r**2 - 51*r + 10) + 252*r**2 + 9*r*(16*s - 29) - 174*s + 101)) + Dd*f*(-2*k1**2*(C*(96*r*s - 76*r + 62*s - 24) - 60*r*s + 46*r - 38*s + 15) + k2**2*(-4*C*(84*r**2 - 61*r + 10) + 336*r**2 + 192*r*s - 348*r - 230*s + 157))))/(105*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**2*(42*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*(D1*(14*bd1*f*k2**2*r*(3*r - 1) + 14*fd*k1**2*r*(6*C*r + 28*C*(s - 1) - 3*r - 21*s + 21) + fd*k2**2*(14*K*(6*r**2 - 10*r + 5) + f*(96*r**2 + r*(504*s - 281) - 26) + 7*r**2*(20*C - 27) + 28*r*(6*s + 5) - 70)) + Dd*f*(14*k1**2*(2*C*(12*r**2 + 7*r*(8*s - 5) - 2*s + 2) - 12*r**2 + 3*r*(17 - 28*s) + 3*s - 3) + k2**2*(14*K*(24*r**2 - 26*r + 5) + 2*f*(96*r**2 + 14*r*(36*s - 19) - 63*s + 29) + 7*r**2*(80*C - 108) + 7*r*(-20*C + 96*s + 43) - 84*s - 70))) + 3*b1*(D1*bd1*f*(14*k1**2*(2*C*(6*r**2 + 28*r*s - 7*r - 2*s + 2) - 6*r**2 - 42*r*s + 9*r + 3*s - 3) + k2**2*(f*(96*r**2 + r*(504*s - 251) - 126*s + 84) + 7*r**2*(40*C + 24*K - 54) + 7*r*(-20*C - 22*K + 48*s + 25) - 84*s)) + D1*(3*f**2*fd*k2**2*(90*r**2 + 9*r*(20*s - 21) - 66*s + 56) + f*(fd*(2*k1**2*(2*C*(r*(6*s - 89) - 80*s + 65) + r*(89 - 6*s) + 120*s - 85) + k2**2*(K*(-48*r**2 + 76*r - 26) + r**2*(168*C + 84) + r*(-84*C + 216*s - 91) - 122*s + 56)) + 14*k2**2*r*(bd2*r - 2*gd2*(6*r - 5))) + 14*fd*k2**2*(b2*r**2 - 2*g2*(6*r**2 - 10*r + 5))) + 2*Dd*f*(3*f**2*k2**2*(60*r**2 + r*(120*s - 121) - 39*s + 31) + f*(k1**2*(2*C*(2*r*(6*s - 53) - 148*s + 99) - 2*r*(6*s - 53) + 216*s - 133) + k2**2*(K*(-48*r**2 + 64*r - 13) + r**2*(168*C + 84) + r*(-42*C + 216*s - 187) - 95*s + 62)) + 7*k2**2*(4*r - 1)*(b2*r - 2*g2*(6*r - 5)))) + f*(3*D1*bd1*(3*f**2*k2**2*(30*r**2 + r*(60*s - 53) - 12*s + 6) + f*(2*k1**2*(-68*C*s + r*(2*C - 1)*(3*s + 5) + 45*s + 3) + k2**2*(r**2*(84*C - 24*K + 42) + r*(26*K + 108*s - 173) - 34*s + 34)) + k2**2*r*(14*b2 - 168*g2)*(r - 1)) + D1*(f*(-2*fd*k1**2*(C*(630*r**2 + 810*r*s - 762*r - 324*s + 202) - 315*r**2 - 630*r*s + 456*r + 246*s - 129) + 135*fd*k2**2*r*(3*r - 1) - k2**2*r*(6*bd2 - 12*gd2)*(12*r - 13)) - 6*fd*k2**2*(b2 - 2*g2)*(24*r**2 - 38*r + 13)) + Dd*f*(-2*f*k1**2*(2*C*(420*r**2 + r*(540*s - 563) - 216*s + 155) - 420*r**2 + r*(703 - 840*s) + 323*s - 206) + 135*f*k2**2*r*(4*r - 1) - k2**2*(6*b2 - 12*g2)*(48*r**2 - 64*r + 13))))/(315*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**2*st**2*(11*D1*bd1*f*(f**2*k2**4*(108*r**2 + 51*r*(4*s - 3) - 58*s + 38) + f*(2*k1**4*(2*C*(r*(20*s - 54) - 73*s + 54) - 21*r*(s - 3) + 84*s - 63) + k1**2*k2**2*(2*C*(147*r**2 + r*(246*s - 65) + 122*s - 68) - 248*r**2 + r*(125 - 428*s) - 146*s + 99) + k2**4*(3*b1*(28*r**2 + r*(24*s - 47) - 34*s + 22) + r**2*(168*C + 17*K - 267) - 2*r*(84*C + 13*K + 41*s - 180) + 108*s - 66)) + 7*k2**2*(b1*k1**2*(4*C*(8*r**2 + 2*r*(4*s - 9) - 7*s + 7) - 28*r**2 + r*(58 - 28*s) + 22*s - 22) + b1*k2**2*(r**2*(6*K - 2) + r*(-3*K + 4*s + 5) - 6*s) - 6*g2*k2**2*r*(r - 1))) + 11*b1**2*k2**2*(D1*fd*r*(k1**2*(112*C - 98)*(r + s - 1) + k2**2*(f*(84*r + 72*s - 33) + r*(21*K - 7) + 14*s)) + Dd*f*(14*k1**2*(2*C*(16*r**2 + 16*r*s - 26*r - 7*s + 7) - 28*r**2 - 28*r*s + 43*r + 11*s - 11) + k2**2*(6*f*(28*r**2 + r*(24*s - 29) - 17*s + 11) + 7*r**2*(12*K - 4) + 7*r*(-3*K + 8*s + 9) - 42*s))) + 11*b1*(D1*(3*f**2*fd*k2**4*(108*r**2 + 204*r*s - 81*r + 10*s - 18) + f*fd*(2*k1**4*r*(10*C*(8*s - 11) - 42*s + 63) + 2*k1**2*k2**2*(2*C*(147*r**2 + r*(246*s - 53) + 35*s - 35) - 248*r**2 - 428*r*s + 86*r - 57*s + 57) + k2**4*(K*(34*r**2 - 69*r + 26) + r**2*(336*C - 534) + r*(191 - 164*s) + 26*s - 46)) - 42*f*gd2*k2**4*r**2 - 42*fd*g2*k2**4*r**2) + Dd*f*(4*f**2*k2**4*(108*r**2 + 3*r*(68*s - 33) - 7*s - 4) + f*(2*k1**4*(2*C*(10*r*(8*s - 11) - 73*s + 54) - 21*r*(4*s - 6) + 84*s - 63) + k1**2*k2**2*(2*C*(588*r**2 + r*(984*s - 359) + 248*s - 194) - 992*r**2 + r*(596 - 1712*s) - 348*s + 301) + k2**4*(K*(68*r**2 - 121*r + 26) + r**2*(672*C - 1068) + r*(-168*C - 328*s + 659) + 158*s - 136)) + 42*g2*k2**4*r*(1 - 4*r))) + f*(D1*(2*f**2*fd*k2**4*(2580*r**2 + r*(2200*s - 2599) - 1155*s + 791) + 11*f*(fd*(2*k1**4*(6*C*(18*r*s - 19*r + 7*s + 2) - 63*r*s + 66*r - 24*s - 7) + k1**2*k2**2*(2*C*(621*r**2 + 414*r*s - 933*r - 570*s + 386) - 900*r**2 - 738*r*s + 1353*r + 942*s - 583) + 18*k2**4*(3*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 2*gd2*k2**4*r*(26 - 17*r)) - 22*fd*g2*k2**4*(34*r**2 - 69*r + 26)) + Dd*f*(2*f**2*k2**4*(2580*r**2 + r*(2200*s - 2599) - 1155*s + 791) + 11*f*(2*k1**4*(18*C*(8*r*s - 6*r + 5*s - 2) - 84*r*s + 62*r - 52*s + 21) + k1**2*k2**2*(2*C*(828*r**2 + 552*r*s - 1287*r - 770*s + 586) - 1200*r**2 - 984*r*s + 1880*r + 1262*s - 903) + 18*k2**4*(4*r - 1)*(r*(4*C - 6) - 2*s + 1)) - 22*g2*k2**4*(68*r**2 - 121*r + 26))))/(1155*d**2*k1*k3**4) + 2*D1**3*Pk3*Pkd1*ct**2*(231*b1**3*k1**2*k2**2*(11*D1*fd*r*(r + s - 1) + Dd*f*(44*r**2 + r*(44*s - 39) - 3*s + 3)) - 33*b1**2*(D1*(-7*bd1*f*k1**2*k2**2*(33*r**2 + r*(33*s - 28) - 3*s + 3) + fd*(k1**4*r*(112*C - 56)*(r + s - 1) + k1**2*k2**2*(-14*K*(26*r**2 + r*(37*s + 24) + 12*s - 12) + f*(624*r**2 + 12*r*(79*s - 31) + 75*s - 75) + 7*r**2*(40*C + 15) + 7*r*(40*C*(s - 1) + 38*s + 62) + 112*s - 112) + 14*k2**4*r*(6*f*(3*r + 3*s - 2) + r*(10 - 5*K) + 5*s))) + Dd*f*(k1**4*(56*C - 28)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(280*C*(4*r - 1)*(r + s - 1) - 56*K*(26*r**2 + 37*r*s - 5*r + 2*s - 6) + 3*f*(416*r**2 + r*(632*s - 386) - 47*s + 15) + 420*r**2 + 1064*r*s + 707*r + 196*s - 434) + 14*k2**4*(4*r - 1)*(f*(9*r + 9*s - 6) + r*(10 - 5*K) + 5*s))) - 11*b1*(3*D1*bd1*f*(k1**4*(56*C - 28)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(280*C*(2*r - 1)*(r + s - 1) - 14*K*(52*r**2 + 74*r*s - 35*r - 10*s - 6) + 6*f*(104*r**2 + r*(158*s - 131) - 36*s + 20) + 210*r**2 + 532*r*s + 189*r + 28*s - 266) + 14*k2**4*(2*r - 1)*(f*(9*r + 9*s - 6) + r*(10 - 5*K) + 5*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(855*r**2 + r*(435*s - 727) - 442*s + 328) + 30*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - f*fd*(12*k1**4*(C*(40*r**2 + 86*r*s - 27*r + 8*s - 8) - 20*r**2 + r*(19 - 54*s) - 4*s + 4) + k1**2*k2**2*(168*C*(5*r**2 + r*s + r + s - 1) + 12*K*(100*r**2 + 83*r*s - 114*r - 45*s + 32) - 1452*r**2 - 948*r*s + 745*r + 334*s - 104) + 42*k2**4*(2*r - 1)*(r*(K - 2) - s)) + 14*f*k2**2*(bd2*k1**2*r*(-7*r - 7*s + 6) + 2*gd2*(k1**2*(26*r**2 + 37*r*s - 9*r + 6*s - 6) + 5*k2**2*r**2)) + 14*fd*k2**2*(-7*b2*k1**2*r*(r + s) + 2*g2*(k1**2*(26*r**2 + 37*r*s + 24*r + 12*s - 12) + 5*k2**2*r**2))) + Dd*f*(f**2*k2**2*(k1**2*(3420*r**2 + r*(1740*s - 2963) - 1163*s + 891) + 90*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 6*f*(3*k1**4*(4*C*(40*r**2 + r*(86*s - 45) + 2*s - 3) - 80*r**2 - 8*r*(27*s - 14) - 2*s + 5) + k1**2*k2**2*(-42*C*s + 6*K*(200*r**2 + r*(166*s - 223) - 71*s + 58) + r**2*(840*C - 1452) + r*(42*C*(4*s - 5) - 948*s + 1039) + 373*s - 237) + 21*k2**4*(4*r - 1)*(r*(K - 2) - s)) + 42*k2**2*(b2*k1**2*(-28*r**2 + r*(19 - 28*s) + s) + 2*g2*(4*k1**2*(26*r**2 + 37*r*s - 5*r + 2*s - 6) + 5*k2**2*r*(4*r - 1))))) + f*(-11*D1*bd1*(f**2*k2**2*(k1**2*(855*r**2 + r*(435*s - 782) + 163*s - 93) + 90*k2**2*r*(3*r + 3*s - 2)) - 3*f*(6*k1**4*(2*C*(20*r**2 + r*(43*s - 26) - 6*s + 4) - 20*r**2 + r*(27 - 54*s) + 8*s - 5) + k1**2*k2**2*(84*C*(5*r**2 + r*(s - 7) - 3*s + 2) + 6*K*(100*r**2 + 83*r*s - 109*r - 26*s + 26) - 726*r**2 - 474*r*s + 887*r + 290*s - 248) + 42*k2**4*r*(r*(K - 2) - s)) + 42*k2**2*(b2*k1**2*(-7*r**2 - 7*r*(s - 1) + s) + 2*g2*(k1**2*(26*r**2 + 37*r*s - 26*r - 16*s) + 5*k2**2*r*(r - 1)))) + D1*(5*f**2*fd*k1**2*k2**2*(1680*r**2 + r*(5544*s - 4514) - 1485*s + 1073) + 11*f*(fd*k1**2*(2*k1**2*(2*C*(675*r**2 + 1035*r*s - 831*r - 390*s + 217) - 675*r**2 - 1260*r*s + 906*r + 474*s - 245) + 45*k2**2*(3*r - 1)*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) - 18*k2**2*(bd2*k1**2*(-17*r**2 - 17*r*s + 24*r + 6*s - 6) + 2*gd2*(k1**2*(100*r**2 + 83*r*s - 109*r - 26*s + 26) + 7*k2**2*r**2))) + 198*fd*k2**2*(b2*k1**2*(2*r - 1)*(17*r + 17*s - 12) - 2*g2*(2*k1**2*(100*r**2 + 83*r*s - 114*r - 45*s + 32) + 7*k2**2*r*(2*r - 1)))) + Dd*f*(5*f**2*k1**2*k2**2*(1680*r**2 + r*(5544*s - 4514) - 1485*s + 1073) + 11*f*k1**2*(2*k1**2*(2*C*(900*r**2 + 1380*r*s - 1223*r - 500*s + 327) - 900*r**2 - 1680*r*s + 1363*r + 607*s - 378) + 45*k2**2*(4*r - 1)*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) + 198*k2**2*(b2*k1**2*(68*r**2 + r*(68*s - 89) - 29*s + 24) - 2*g2*(2*k1**2*(200*r**2 + 166*r*s - 223*r - 71*s + 58) + 7*k2**2*r*(4*r - 1))))))/(3465*d**2*k1*k3**4) + 8*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(11*D1*bd1*f*(3*k1**2*(C*(32*r**2 + 32*r*s - 54*r - 44*s + 22) - 21*r**2 - 21*r*s + 35*r + 28*s - 14) + k2**2*(-3*b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) + f*(12*r**2 + r*(12*s - 49) - 46*s + 32))) - 33*b1**2*k2**2*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + 11*b1*(D1*fd*(f*k2**2*(36*r**2 + r*(36*s - 39) - 18*s + 13) + k1**2*r*(96*C - 63)*(2*r + 2*s - 1)) + Dd*f*(f*k2**2*(48*r**2 + 8*r*(6*s - 11) - 64*s + 45) + 3*k1**2*(2*C*(64*r**2 + 64*r*s - 48*r - 22*s + 11) - 84*r**2 - 84*r*s + 63*r + 28*s - 14))) + f*(D1*fd*(2*f*k2**2*(236*r**2 + r*(236*s - 5) + 128*s - 107) + 11*k1**2*(C*(72*r**2 + 18*r*(4*s + 3) + 84*s - 62) - 45*r**2 - 9*r*(5*s + 4) - 54*s + 40)) + Dd*f*(2*f*k2**2*(236*r**2 + r*(236*s - 5) + 128*s - 107) + 11*k1**2*(2*C*(48*r**2 + 48*r*(s + 1) + 64*s - 53) - 60*r**2 - 60*r*s - 63*r - 82*s + 68))))/(1155*d**2*k3**6) + 4*D1**3*Pk3*Pkd1*ct*f*k2*st**4*(-3*D1*bd1*f*(k1**2*(2*C*(6*r*s - 5*r - 10*s + 5) - 7*r*s + 7*r + 14*s - 7) - 2*k2**2*r*(r - 1)) - 3*b1*(D1*fd*r*(k1**2*(12*C - 7)*(2*s - 1) - 4*k2**2*r) + Dd*f*(k1**2*(2*s - 1)*(2*C*(12*r - 5) - 14*r + 7) + 2*k2**2*r*(1 - 4*r))) + f*(D1*fd*(k1**2*(-2*C*(9*r*(2*s - 1) + 18*s - 5) + 3*r*(9*s - 4) + 24*s - 7) + k2**2*(9*r**2 - 24*r + 7)) + Dd*f*(k1**2*(C*(-48*r*s + 16*r - 56*s + 30) + 36*r*s - 10*r + 38*s - 21) + k2**2*(12*r**2 - 31*r + 7))))/(105*d**2*k1**2*k3**2) + 4*D1**3*Pk3*Pkd1*ct*f*k2*st**4*(33*D1*bd1*f*(5*f*k2**4*r*(r - 1) + k1**4*(2*C*(8*r*s - 9*r - 18*s + 9) - 9*r*s + 11*r + 22*s - 11) + k1**2*k2**2*(-2*C*(11*r**2 + 10*r*s - 17*r - 12*s + 6) + 19*r**2 + 19*r*s - 29*r - 20*s + 10)) + 33*b1*(D1*fd*r*(15*f*k2**4*r + k1**4*(16*C - 9)*(2*s - 1) + k1**2*k2**2*(-4*C*(11*r + 10*s - 5) + 38*r + 38*s - 19)) + Dd*f*(5*f*k2**4*r*(4*r - 1) + k1**4*(2*s - 1)*(2*C*(16*r - 9) - 18*r + 11) + k1**2*k2**2*(-2*C*(44*r**2 + 40*r*s - 31*r - 12*s + 6) + 76*r**2 + 76*r*s - 57*r - 20*s + 10))) + f*(D1*fd*(30*f*k2**4*(1 - 4*r)**2 + 11*k1**4*(6*C*(r*(12*s - 5) + 10*s - 3) - 9*r*(5*s - 2) - 36*s + 11) - 11*k1**2*k2**2*(2*C*(9*r**2 + 9*r*(2*s + 9) + 24*s - 38) - 18*r**2 - 9*r*(3*s + 14) - 42*s + 61)) + Dd*f*(30*f*k2**4*(1 - 4*r)**2 + 11*k1**4*(6*C*(4*r*(4*s - 1) + 16*s - 9) + r*(14 - 60*s) - 58*s + 33) - 11*k1**2*k2**2*(2*C*(12*r**2 + r*(24*s + 113) + 36*s - 50) - 24*r**2 - 4*r*(9*s + 44) - 62*s + 81))))/(1155*d**2*k1**2*k3**4) + 8*D1**3*Pk3*Pkd1*ct*k1**2*k2*(D1*bd1*f*(-21*b1*(k1**2*(10*K - 2)*(4*r**2 + r*(4*s - 3) - s) + k2**2*(15*K - 5)*(r + s)*(2*r - 1)) + 5*f**2*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 9*k2**2*(2*r**2 + 2*r*s + s - 1)) + 9*f*(k1**2*(-14*C*(r - 1)*(r + s - 1) - 40*K*r**2 - 40*K*r*s + 40*K*r + 10*K*s - 10*K + 2*b1*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 15*r**2 + 15*r*s - 22*r - 9*s + 9) + 7*k2**2*(b1*(2*r - 1)*(3*r + 3*s - 2) - r*(3*K - 1)*(r + s))) + 210*g2*(k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 3*k2**2*(r - 1)*(r + s))) + 3*b1**2*(D1*fd*r*(6*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(3*r + 3*s - 2)) + (r + s)*(-7*k1**2*(20*K - 4) - 7*k2**2*(15*K - 5))) + Dd*f*(3*f*(k1**2*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) + 7*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 7*k1**2*(10*K - 2)*(8*r**2 + r*(8*s - 4) - s) - 7*k2**2*(15*K - 5)*(r + s)*(4*r - 1))) + b1*(D1*(5*f**2*fd*(4*k1**2*(3*r - 1)*(3*r + 3*s - 2) + 9*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2)) - 9*f*fd*(k1**2*(20*K*(2*r - 1)*(2*r + 2*s - 1) + r**2*(28*C - 30) + r*(28*C - 30)*(s - 1) + 8*s - 4) + k2**2*(21*K - 7)*(r + s)*(2*r - 1)) + 210*f*gd2*r*(k1**2*(4*r + 4*s - 2) + 3*k2**2*(r + s)) + 210*fd*g2*r*(4*k1**2 + 3*k2**2)*(r + s)) + Dd*f*(5*f**2*(2*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 9*f*(k1**2*(14*C*(4*r - 1)*(r + s - 1) + 20*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 60*r**2 - 60*r*s + 67*r + 19*s - 15) + k2**2*(21*K - 7)*(r + s)*(4*r - 1)) + 210*g2*(2*k1**2*(8*r**2 + r*(8*s - 4) - s) + 3*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(r + s - 1) - 9*f*(fd*k1**2*(10*C - 5)*(3*r - 1)*(r + s - 1) - 20*gd2*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 42*gd2*k2**2*r*(r + s)) + 18*fd*g2*(2*r - 1)*(20*k1**2*(2*r + 2*s - 1) + 21*k2**2*(r + s))) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(r + s - 1) - f*k1**2*(90*C - 45)*(4*r - 1)*(r + s - 1) + 360*g2*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 378*g2*k2**2*(r + s)*(4*r - 1))))/(315*d**2*k3**6) - 8*D1**3*Pk3*Pkd1*ct*k2*st**2*(33*D1*bd1*f*(f**2*k2**2*(k1**2*(6*r**2 + 6*r*s + 31*r + 24*s - 28) + 9*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) + f*(-21*b1*k2**4*(2*r - 1)*(2*r + 2*s - 1) + k1**4*(C*(30*r**2 + r*(30*s + 8) + 6*s - 38) - 17*r**2 - r*(17*s + 5) - 2*s + 22) - k1**2*k2**2*(-14*C*(r - 1)*(12*r + 12*s - 7) + 3*K*r**2 + 3*K*r*s + 60*K*r + 36*K*s - 36*K + b1*(30*r**2 + 2*r*(15*s - 8) + 24*s - 19) + 104*r**2 + 104*r*s - 188*r - 117*s + 75)) - 7*k1**2*k2**2*(b1*(3*K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 6*g2*(r**2 + r*(s - 1) - 3*s))) - 33*b1**2*k2**2*(D1*fd*r*(f*k1**2*(30*r + 30*s - 1) + 42*f*k2**2*(2*r + 2*s - 1) + k1**2*(21*K - 7)*(r + s)) + Dd*f*(f*(k1**2*(60*r**2 + 60*r*s - 17*r + 24*s - 19) + 21*k2**2*(4*r - 1)*(2*r + 2*s - 1)) + k1**2*(21*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 33*b1*(D1*(3*f**2*fd*k2**2*(k1**2*(6*r**2 + 3*r*(2*s + 7) + 18*s - 13) + 3*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) + f*k1**2*(-fd*(k1**2*r*(-20*C*(3*r + 3*s + 2) + 34*r + 34*s + 25) + k2**2*(K*(6*r**2 + r*(6*s + 57) + 39*s - 30) + r**2*(208 - 336*C) + r*(-336*C*s + 196*C + 208*s - 145) - 13*s + 10)) + 42*gd2*k2**2*r*(r + s + 2)) + 42*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(24*r**2 + r*(24*s + 94) + 78*s - 67) + 9*k2**2*(4*r - 1)*(4*r + 4*s - 3)) + f*k1**2*(k1**2*(2*C*(60*r**2 + 5*r*(12*s + 5) + 3*s - 19) - 68*r**2 - r*(68*s + 33) - 2*s + 22) + k2**2*(14*C*(4*r - 1)*(12*r + 12*s - 7) - 3*K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) - 416*r**2 - 416*r*s + 416*r + 142*s - 97)) + 42*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(260*r**2 + r*(260*s - 359) - 186*s + 134) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 11*f*k1**2*(fd*(k1**2*(2*C*(117*r**2 + 9*r*(13*s - 20) - 129*s + 77) - 135*r**2 - 3*r*(45*s - 66) + 144*s - 84) + 9*k2**2*(3*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 18*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 198*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(5*f**2*k2**2*(k1**2*(260*r**2 + r*(260*s - 359) - 186*s + 134) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 11*f*k1**2*(k1**2*(C*(312*r**2 + 6*r*(52*s - 85) - 346*s + 242) - 180*r**2 - 3*r*(60*s - 93) + 192*s - 132) + 9*k2**2*(4*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 198*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**6) - 2*D1**3*Pk3*Pkd1*ct*st**2*(33*D1*bd1*f*(f**2*k2**4*(6*r**2 - 23*r*(6*s - 1) + 20*s) + f*(k1**4*(2 - 4*C)*(r*(s - 9) - 11*s + 9) - 2*k1**2*k2**2*(2*C*(85*r**2 + r*(106*s - 57) + 18*s - 20) - 98*r**2 + r*(59 - 135*s) - 17*s + 28) + k2**4*(-84*C*(r - 1)*(5*r + 2*s - 1) - 2*K*(18*r**2 + r*s - 55*r - 16*s + 16) + b1*(274*r**2 + 376*r*s - 269*r + 18*s - 10) + 350*r**2 + 128*r*s - 484*r - 158*s + 102)) + 14*k2**2*(b1**2*k2**2*(3*r**2 + r*(3*s - 8) - 3*s + 3) + b1*(k1**2*(-10*C*(2*r - 1)*(r + s - 1) + 14*r**2 + 14*r*s - 19*r - 6*s + 6) + k2**2*(K - 1)*(6*r*s + r - 4*s)) + k2**2*(b2*(r**2 + r*(s - 1) - 3*s) + 2*g2*s*(4 - 3*r)))) + 462*b1**3*k2**4*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 33*b1**2*k2**2*(2*D1*fd*(f*k2**2*(137*r**2 + 94*r*(2*s - 1) + 13*s - 13) - 7*r*(k1**2*(10*C - 7)*(r + s - 1) + k2**2*s*(3 - 3*K))) + Dd*f*(-14*k1**2*(10*C*(4*r - 1)*(r + s - 1) - 28*r**2 - 28*r*s + 33*r + 6*s - 6) + k2**2*(f*(548*r**2 + 752*r*s - 457*r + 44*s - 36) + (28*K - 28)*(6*r*s + r - 2*s)))) + 33*b1*(D1*(3*f**2*fd*k2**4*(6*r**2 - r*(138*s + 31) - 86*s + 68) - 2*f*(fd*(k1**4*r*(4*C - 2)*(s - 4) + k1**2*k2**2*(C*(340*r**2 + r*(424*s - 60) + 62*s - 62) - 196*r**2 - 270*r*s + 27*r - 40*s + 40) + k2**4*(2*K*(18*r**2 + r*(s - 53) - 11*s + 22) + r**2*(420*C - 350) + r*(84*C*(2*s - 1) - 128*s + 133) + 22*s - 28)) - 7*k2**4*r*(bd2*(r + s + 2) - 6*gd2*s - 2*gd2)) + 14*fd*k2**4*r*(b2*(r + s) - 6*g2*s)) + 2*Dd*f*(f**2*k2**4*(12*r**2 - r*(276*s + 35) - 119*s + 102) + f*(-k1**4*(2*C - 1)*(4*r*(s - 4) - 11*s + 9) + k1**2*k2**2*(-2*C*(340*r**2 + r*(424*s - 151) + 69*s - 71) + 392*r**2 + 54*r*(10*s - 3) + 81*s - 92) + k2**4*(-42*C*(4*r - 1)*(5*r + 2*s - 1) + K*(-72*r**2 - 4*r*(s - 54) + 54*s - 76) + 700*r**2 + 256*r*s - 449*r - 117*s + 95)) + 7*k2**4*(b2*(4*r**2 + r*(4*s + 3) - 3*s) - 4*g2*(6*r*s + r - 2*s)))) + f*(D1*(-3*f**2*fd*k2**4*(3900*r**2 + r*(5280*s - 5327) - 2772*s + 1814) - 22*f*(fd*(k1**4*(6*C - 3)*(9*r*(s - 1) + 3*s + 1) + k1**2*k2**2*(6*C*(228*r**2 + 59*r*(3*s - 5) - 212*s + 124) - 774*r**2 + r*(993 - 702*s) + 819*s - 440) + 9*k2**4*(3*r - 1)*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) - 3*k2**4*(bd2*(r**2 + r*(s + 20) + 12*s - 12) + 2*gd2*(18*r**2 + r*(s - 55) - 16*s + 16))) + 66*fd*k2**4*(b2*(2*r**2 + r*(2*s + 19) + 13*s - 10) + 4*g2*(18*r**2 + r*(s - 53) - 11*s + 22))) + Dd*f*(-3*f**2*k2**4*(3900*r**2 + r*(5280*s - 5327) - 2772*s + 1814) - 22*f*(k1**4*(6*C - 3)*(4*r*(3*s - 2) + 7*s - 3) + k1**2*k2**2*(4*C*(456*r**2 + r*(354*s - 607) - 422*s + 290) - 1032*r**2 + r*(1376 - 936*s) + 1083*s - 704) + 9*k2**4*(4*r - 1)*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) + 66*k2**4*(b2*(4*r**2 + r*(4*s + 59) + 37*s - 34) + 4*g2*(36*r**2 + 2*r*(s - 54) - 27*s + 38)))))/(3465*d**2*k2*k3**4) + 2*D1**3*Pk3*Pkd1*ct*(D1*(21*b1*fd*k2**2*(2*b1**2*r*(4*k1**2 + 5*k2**2)*(r + s - 1) + 2*b1*k1**2*(-10*C*r*(s - 1) + 2*K*(19*r**2 + 3*r*(7*s + 4) + 6*s - 6) - r**2*(10*C + 6) - 13*r*(s + 1) - 4*s + 4) + 5*b1*k2**2*r*(r*(6*K - 5) + s*(2*K - 2)) + 2*b2*r*(12*k1**2 + 5*k2**2)*(r + s) - 8*g2*k1**2*(19*r**2 + 3*r*(7*s + 4) + 6*s - 6) - 20*g2*k2**2*r*(3*r + s)) - 2*f**3*k2**2*(bd1*(k1**2*(210*r**2 + 240*r*s - 296*r - 19*s + 19) + 45*k2**2*r*(3*r + 3*s - 2)) + 5*fd*k1**2*(r*(42 - 56*s) + 15*s - 11)) + 3*f**2*(bd1*(k1**4*r*s*(84*C - 42) + k1**2*k2**2*(84*C*(r**2 - 2*r - s + 1) + 636*K*r**2 + 540*K*r*s - 602*K*r - 156*K*s + 156*K - 6*b1*(38*r**2 + r*(84*s - 68) - 21*s + 14) - 243*r**2 - 228*r*s + 309*r + 106*s - 106) - 21*k2**4*(2*b1*(4*r**2 + r*(4*s - 5) - 3*s + 2) + r*(r*(5 - 6*K) - s*(2*K - 2)))) + fd*(-30*b1*k2**4*(3*r - 1)*(3*r + 3*s - 2) + k1**4*(12*C - 6)*(5*r - 2)*(3*s - 1) + k1**2*k2**2*(-2*b1*(210*r**2 + r*(240*s - 226) - 119*s + 80) + (45*r - 15)*(4*C*(2*r + s - 1) - 5*r - 2*s + 2))) + 2*k2**2*(3*bd2*(6*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 7*k2**2*r*(r + s)) - 2*gd2*(k1**2*(318*r**2 + 270*r*s - 301*r - 78*s + 78) + 21*k2**2*r*(3*r + s)))) + 3*f*(2*b1**2*k2**2*(7*bd1*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 5*k2**2*(3*r - 1)*(r + s - 1)) - 3*fd*(k1**2*(38*r**2 + 84*r*s - 33*r + 8*s - 8) + 7*k2**2*(4*r**2 + 4*r*s - r + s - 1))) + b1*(-7*bd1*(2*k1**2*k2**2*(10*C*(2*r - 1)*(r + s - 1) + K*(-76*r**2 - 84*r*s + 47*r + 15*s + 6) + 12*r**2 + 26*r*s - r - 2*s - 7) - 5*k2**4*(2*r - 1)*(r*(6*K - 5) + s*(2*K - 2))) + fd*(k1**4*r*(84*C - 42)*(2*s - 1) + 2*k1**2*k2**2*(42*C*(2*r**2 + r + s - 1) + K*(636*r**2 + 540*r*s - 650*r - 291*s + 166) - 243*r**2 - 228*r*s + 159*r + 100*s - 24) + 21*k2**4*(2*r - 1)*(r*(6*K - 5) + s*(2*K - 2))) + 14*k2**2*(bd2*r*(6*k1**2*(2*r + 2*s - 1) + 5*k2**2*(r + s)) - 2*gd2*(k1**2*(38*r**2 + 42*r*s - 9*r + 6*s - 6) + 5*k2**2*r*(3*r + s)))) + 2*k2**2*(b2*(7*bd1*(6*k1**2*(2*r**2 + 2*r*(s - 1) - s) + 5*k2**2*(r - 1)*(r + s)) + 3*fd*(2*r - 1)*(12*k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s))) - 2*g2*(7*bd1*k1**2*(38*r**2 + r*(42*s - 38) - 21*s) + 35*bd1*k2**2*(r - 1)*(3*r + s) + fd*k1**2*(636*r**2 + 10*r*(54*s - 65) - 291*s + 166) + 21*fd*k2**2*(2*r - 1)*(3*r + s))))) + Dd*f*(21*b1*k2**2*(2*b1**2*(2*k1**2*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*k2**2*(4*r - 1)*(r + s - 1)) - 2*b1*k1**2*(10*C*(4*r - 1)*(r + s - 1) + K*(-152*r**2 - 168*r*s + 32*r - 3*s + 24) + 24*r**2 + 52*r*s + 12*r + 4*s - 13) + 5*b1*k2**2*(4*r - 1)*(r*(6*K - 5) + s*(2*K - 2)) + 2*b2*(6*k1**2*(8*r**2 + r*(8*s - 4) - s) + 5*k2**2*(r + s)*(4*r - 1)) - 4*g2*(k1**2*(152*r**2 + 8*r*(21*s - 4) + 3*s - 24) + 5*k2**2*(3*r + s)*(4*r - 1))) + 10*f**3*k1**2*k2**2*(14*r*(4*s - 3) - 15*s + 11) + f**2*(-90*b1*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(72*C - 36)*(5*r - 2)*(2*s - 1) + k1**2*k2**2*(-2*b1*(840*r**2 + r*(960*s - 974) - 376*s + 259) + (180*r - 45)*(4*C*(2*r + s - 1) - 5*r - 2*s + 2))) - 3*f*(6*b1**2*k2**2*(k1**2*(76*r**2 + r*(168*s - 101) - 13*s + 6) + 7*k2**2*(4*r - 1)*(2*r + 2*s - 1)) + b1*(k1**4*r*(84 - 168*C)*(2*s - 1) + k1**2*k2**2*(K*(-2544*r**2 - 8*r*(270*s - 313) + 894*s - 644) + r**2*(972 - 336*C) + r*(84*C + 912*s - 831) - 370*s + 218) - 21*k2**4*(4*r - 1)*(r*(6*K - 5) + s*(2*K - 2))) - 2*k2**2*(36*b2*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 21*b2*k2**2*(r + s)*(4*r - 1) - 2*g2*k1**2*(1272*r**2 + 4*r*(270*s - 313) - 447*s + 322) - 42*g2*k2**2*(3*r + s)*(4*r - 1)))))/(315*d**2*k2*k3**4) - 4*D1**3*Pk3*Pkd1*ct*st**2*(D1*bd1*f**2*(k1**2*(2*C - 1)*(r*(s - 9) + 12*s) + k2**2*r*(8 - 9*r)) + 7*b1**2*(D1*fd*r*(k1**2*(2*C - 1)*(s - 1) - 2*k2**2*r) + Dd*f*(k1**2*(2*C - 1)*(4*r*(s - 2) - 3*s + 3) + 2*k2**2*r*(1 - 4*r))) + b1*f*(7*D1*bd1*(k1**2*(2*C - 1)*(2*r*(s - 3) - 3*s + 3) + 2*k2**2*r*(1 - 2*r)) + D1*fd*(k1**2*(2*C - 1)*(2*r*(s - 4) + 13*s - 3) + k2**2*(-18*r**2 + 25*r - 8)) + Dd*f*(k1**2*(2*C - 1)*(4*r*(s - 4) + 37*s - 15) + k2**2*(-36*r**2 + 41*r - 8))))/(105*d**2*k1**2*k2) + 2*D1**3*Pk3*Pkd1*ct*(7*D1*bd1*f**2*(2*k1**2*s*(C*(4 - 6*r) + 3*r - 2) + 3*k2**2*r**2) + b1**2*(D1*fd*(-k1**2*r*(140*C - 70)*(s - 1) + k2**2*(2*f*(18*r**2 - 25*r + 8) + 77*r**2 - 84*r + 42)) + Dd*f*(-k1**2*r*(280*C - 140)*(2*s - 1) + k2**2*(4*r - 1)*(2*f*(9*r - 8) + 77*r - 42))) + b1*f*(D1*(bd1*r*(k1**2*s*(140 - 280*C) + k2**2*(36*f*r - 32*f + 154*r - 119)) - 7*fd*(k1**2*(4*C - 2)*(3*r - 2)*(2*s - 1) + 3*k2**2*r*(1 - 2*r))) - 7*Dd*f*(k1**2*(8*C - 4)*(3*r - 2)*(2*s - 1) + 3*k2**2*r*(1 - 4*r))))/(105*d**2*k1**2*k2) + 4*D1**3*Pk3*Pkd1*ct*st**2*(b1**2*(D1*fd*r*(k1**4*(14*C - 7)*(s - 1) - k1**2*k2**2*(28*C - 28)*(s - 1) + k2**4*r*(54*f + 14)) + Dd*f*(k1**4*(14*C - 7)*(4*r*(s - 2) - 3*s + 3) - k1**2*k2**2*(14*C - 14)*(r*(8*s - 6) - s + 1) + k2**4*r*(27*f + 14)*(4*r - 1))) + b1*f*(D1*bd1*(k1**4*(14*C - 7)*(2*r*(s - 3) - 3*s + 3) - k1**2*k2**2*(14*C - 14)*(r*(4*s - 2) - s + 1) + k2**4*r*(27*f + 14)*(2*r - 1)) + D1*fd*(k1**4*(2*C - 1)*(13*s - 3) + k1**2*k2**2*(-2*C*(34*r**2 + 80*r*s + 39*r + 9*s - 33) + 34*r**2 + 130*r*s + 57*r + 18*s - 50) + k2**4*(f*(81*r**2 - 45*r + 6) + 60*r**2 - 25*r + 8)) + Dd*f*(k1**4*(48*C - 24)*(2*s - 1) + k1**2*k2**2*(-2*C*(68*r**2 + 160*r*s + 17*r + 17*s - 37) + 68*r**2 + 260*r*s + 31*r + 31*s - 60) + k2**4*(4*r - 1)*(3*f*(9*r - 2) + 30*r - 8))) + f**2*(D1*bd1*(k1**4*(2*C - 1)*(23*s - 9) + k1**2*k2**2*(-8*C*s + r**2*(17 - 34*C) + r*(-80*C*s + 20*C + 65*s - 6) + 5*s - 2) + k2**4*r*(3*f*(9*r - 2) + 30*r - 29)) + D1*fd*(-k1**4*(2*C - 1)*(9*r*(s - 1) + 3*s + 1) + k1**2*k2**2*(-2*C*(117*r**2 + 54*r*s - 123*r - 72*s + 46) + 135*r**2 + 99*r*s - 147*r - 123*s + 64) + 9*k2**4*r*(3*r - 1)) + Dd*f*(-k1**4*(2*C - 1)*(4*r*(3*s - 2) + 7*s - 3) + k1**2*k2**2*(-2*C*(156*r**2 + r*(72*s - 163) - 96*s + 70) + 180*r**2 + 3*r*(44*s - 67) - 163*s + 104) + 9*k2**4*r*(4*r - 1))))/(105*d**2*k1**2*k2*k3**2) - 2*D1**3*Pk3*Pkd1*ct*(14*b1**3*k1**2*k2**2*(2*D1*fd*r*(2*r + 5*s - 5) + Dd*f*(16*r**2 + r*(40*s - 34) - 5*s + 5)) + b1**2*(14*D1*bd1*f*k1**2*k2**2*(12*r**2 + 6*r*(5*s - 4) - 5*s + 5) - D1*fd*(k1**4*r*(140*C - 70)*(s - 1) + k1**2*k2**2*(28*K*(3*r**2 - r*(3*s + 14) - 2*s + 7) + 2*f*(8*r*(21*s - 4) + 49*s - 55) + 7*r**2*(20*C - 15) + 28*r*(5*s + 7) + 56*s - 98) + 35*k2**4*r**2) + Dd*f*(-k1**4*r*(280*C - 140)*(2*s - 1) + k1**2*k2**2*(-14*K*(24*r**2 - 8*r*(3*s + 7) - 5*s + 18) + f*(r*(176 - 672*s) - 28*s + 54) - 7*r**2*(80*C - 60) - 7*r*(-20*C + 80*s + 51) - 42*s + 154) + 35*k2**4*r*(1 - 4*r))) - b1*(D1*(2*f**2*k1**2*k2**2*(7*bd1*(8*r*(3*s - 1) - 5*s + 4) + 3*fd*(30*r**2 + 18*r*(5*s - 4) - 33*s + 22)) + f*(7*bd1*(k1**4*r*s*(40*C - 20) + k1**2*k2**2*(2*K*(12*r**2 - r*(12*s + 17) + s + 2) + r**2*(40*C - 30) + r*(-20*C + 40*s + 19) - 6*s - 4) + 5*k2**4*r*(2*r - 1)) - fd*k1**4*(56*C - 28)*(2*s - 1) + fd*k1**2*k2**2*(-2*K*(132*r**2 + 2*r*(42*s - 73) - 49*s + 40) + r**2*(168*C + 84) - 3*r*(28*C - 88*s + 35) - 146*s + 42) + 21*fd*k2**4*r*(2*r - 1) + 14*k1**2*k2**2*(bd2*r*(-8*r - 10*s + 5) + gd2*(-12*r**2 + 12*r*s + 22*r + 4*s - 4))) - 28*fd*k1**2*k2**2*(b2*r*(4*r + 5*s) + 2*g2*(3*r**2 - r*(3*s + 14) - 2*s + 7))) + Dd*f*(6*f**2*k1**2*k2**2*(40*r**2 + 24*r*(5*s - 4) - 39*s + 26) + f*(-k1**4*(112*C - 56)*(2*s - 1) - 2*k1**2*k2**2*(K*(264*r**2 + 4*r*(42*s - 67) - 77*s + 68) - r**2*(168*C + 84) + 3*r*(14*C - 88*s + 57) + 113*s - 61) + 21*k2**4*r*(4*r - 1)) - 14*k1**2*k2**2*(b2*(32*r**2 + 2*r*(20*s - 9) - 5*s) + 2*g2*(24*r**2 - 8*r*(3*s + 7) - 5*s + 18)))) + f*(-D1*(12*bd1*f**2*k1**2*k2**2*(5*r**2 + 3*r*(5*s - 4) - 3*s + 2) + f*(bd1*(k1**4*s*(28 - 56*C) + k1**2*k2**2*(-2*K*(66*r**2 + 42*r*s - 61*r - 14*s + 14) + r**2*(84*C + 42) + 3*r*(44*s - 43) - 40*s + 40) + 21*k2**4*r**2) - 3*fd*(k1**4*(4*C - 2)*(5*r - 2)*(3*s - 1) + 5*k1**2*k2**2*r*(1 - 3*r)) + k1**2*k2**2*(-2*bd2 + 4*gd2)*(66*r**2 + 42*r*s - 61*r - 14*s + 14)) - 2*k1**2*k2**2*(b2*(7*bd1*(8*r**2 + 10*r*s - 8*r - 5*s) + fd*(132*r**2 + 84*r*s - 146*r - 49*s + 40)) + 42*bd1*g2*(2*r**2 - 2*r*(s + 1) + s) - 2*fd*g2*(132*r**2 + 2*r*(42*s - 73) - 49*s + 40))) + Dd*f*k1**2*(3*f*(k1**2*(8*C - 4)*(5*r - 2)*(2*s - 1) + 5*k2**2*r*(1 - 4*r)) + k2**2*(2*b2 - 4*g2)*(264*r**2 + 4*r*(42*s - 67) - 77*s + 68))))/(105*d**2*k1**2*k2*k3**2) + 4*D1**3*Pk3*Pkd1*f**2*k2**6*st**6*(11*D1*bd1*f*(3*r**2 + r*(3*s - 7) - 6*s + 4) + 11*b1*(3*D1*fd*r*(3*r + 3*s - 2) + Dd*f*(12*r**2 + 12*r*s - 13*r - 6*s + 4)) + 5*f*(3*r + 2)*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(693*d**2*k1*k3**6) - 4*D1**3*Pk3*Pkd1*f*k2**2*st**4*(11*D1*bd1*f*(3*f*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(12*C - 6)*(5*r**2 + r*(5*s - 8) - 6*s + 3) + 2*k1**2*k2**2*(3*b1*(11*r**2 + 11*r*(s - 1) - 8*s + 4) + f*(18*r + 17*s - 14))) + 33*b1**2*k1**2*k2**2*(11*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(44*r**2 + 11*r*(4*s - 3) - 16*s + 8)) + 11*b1*(D1*fd*(f*k1**2*k2**2*(36*r + 30*s - 22) + 9*f*k2**4*r*(5*r + 5*s - 3) + k1**4*r*(30 - 60*C)*(2*r + 2*s - 1)) + Dd*f*(2*f*k1**2*k2**2*(36*r + 32*s - 25) + 3*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) - k1**4*(12*C - 6)*(20*r**2 + 5*r*(4*s - 3) - 6*s + 3))) - f*(D1*fd*(f*k1**2*k2**2*(204*r**2 + 204*r*s + 71*r + 180*s - 146) - 11*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(3*r**2 + 3*r*(s + 1) + 4*s - 3)) + Dd*f*(f*k1**2*k2**2*(204*r**2 + 204*r*s + 71*r + 180*s - 146) - 11*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(4*r**2 + r*(4*s + 5) + 6*s - 5))))/(1155*d**2*k1*k3**6) - 2*D1**3*Pk3*Pkd1*f*st**4*(6*D1*b1*fd*r*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*(r*(4*C - 1) + 4*s - 2)) + 3*D1*bd1*f*(k1**2*(4*C - 2)*(r*(s - 2) - 4*s + 2) + k2**2*(4*C*r*(r - 1) - r**2 + 4*r*s - 2*s + 1)) + D1*f*fd*(k1**2*(4*C - 2)*(3*r + 2)*(3*s - 1) + k2**2*(4*C*(18*r**2 - 27*r + 7) - 27*r**2 + 54*r + 6*s - 17)) + 3*Dd*b1*f*(k1**2*(8*C - 4)*(r - 1)*(2*s - 1) + k2**2*(r**2*(16*C - 4) + r*(-4*C + 16*s - 7) - 2*s + 1)) + Dd*f**2*(k1**2*(8*C - 4)*(r*(6*s - 1) + 5*s - 3) + k2**2*(4*C*(24*r**2 - 34*r + 7) - 36*r**2 + 69*r + 8*s - 19)))/(105*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*f*st**4*(11*D1*bd1*f*(k1**4*(12*C - 6)*(r*(s - 2) - 4*s + 2) - 3*k1**2*k2**2*(4*C*(9*r**2 + r*(9*s - 13) - 8*s + 4) - 19*r**2 + r*(28 - 22*s) + 18*s - 9) + k2**4*(3*b1*(r*(4*s - 9) - 8*s + 6) + f*(30*r**2 + 6*r*(6*s - 5) - 7*s + 5))) + 33*b1**2*k2**4*(D1*fd*r*(4*s - 3) + 2*Dd*f*(r*(4*s - 6) - 4*s + 3)) + 11*b1*(6*D1*fd*(f*k2**4*(15*r**2 + 18*r*s - r + 2*s - 4) + k1**4*r*(2*C - 1)*(2*s - 1) + k1**2*k2**2*r*(-18*C*(2*r + 2*s - 1) + 19*r + 22*s - 11)) + Dd*f*(f*k2**4*(120*r**2 + 36*r*(4*s - 1) + 5*s - 19) + k1**4*(24*C - 12)*(r - 1)*(2*s - 1) - 3*k1**2*k2**2*(4*C*(36*r**2 + 9*r*(4*s - 3) - 8*s + 4) - 76*r**2 + r*(63 - 88*s) + 18*s - 9))) + f*(D1*fd*(5*f*k2**4*(168*r**2 + 4*r*(22*s - 43) - 99*s + 71) + k1**4*(44*C - 22)*(3*r + 2)*(3*s - 1) - 11*k1**2*k2**2*(4*C*(r*(9*s + 48) + 18*s - 23) - 9*r**2 - 6*r*(3*s + 16) - 42*s + 49)) + Dd*f*(5*f*k2**4*(168*r**2 + 4*r*(22*s - 43) - 99*s + 71) + k1**4*(88*C - 44)*(r*(6*s - 1) + 5*s - 3) - 11*k1**2*k2**2*(4*C*(6*r*(2*s + 11) + 26*s - 31) - 12*r**2 - r*(24*s + 133) - 60*s + 67))))/(1155*d**2*k1*k3**4) + 4*D1**3*Pk3*Pkd1*k1**3*(D1*(-14*b1*fd*r*(4*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 15*bd1*f**3*k2**2*r*(r + s - 1) + 3*f**2*(-2*K*bd1*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s)) + 7*b1*bd1*k2**2*(2*r - 1)*(r + s - 1) + 5*b1*fd*k2**2*(3*r - 1)*(r + s - 1) + 4*gd2*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s))) + 2*f*(3*b1*fd*(-K*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s)) + 7*b1*k2**2*r*(r + s - 1)) + 14*b1*gd2*r*(k1**2*(4*r + 4*s - 2) + 5*k2**2*(r + s)) + 7*bd1*(K*b1*(k1**2*(-8*r**2 - 8*r*s + 6*r + 2*s) - 5*k2**2*(r + s)*(2*r - 1)) + 2*g2*(k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 5*k2**2*(r - 1)*(r + s))) + 6*fd*g2*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s)))) + Dd*f*(15*b1*f**2*k2**2*(4*r - 1)*(r + s - 1) - 14*b1*(K*b1 - 2*g2)*(2*k1**2*(8*r**2 + r*(8*s - 4) - s) + 5*k2**2*(r + s)*(4*r - 1)) + 3*f*(b1*(-2*K*(4*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)) + 7*b1*k2**2*(4*r - 1)*(r + s - 1)) + 4*g2*(4*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)))))/(105*d**2*k3**6) + 2*D1**3*Pk3*Pkd1*k1*(182*D1*K*b1**2*fd*k1**2*r**2 + 196*D1*K*b1**2*fd*k1**2*r*s + 112*D1*K*b1**2*fd*k1**2*r + 56*D1*K*b1**2*fd*k1**2*s - 56*D1*K*b1**2*fd*k1**2 + 140*D1*K*b1**2*fd*k2**2*r**2 + 70*D1*K*b1**2*fd*k2**2*r*s + 408*D1*K*b1*f*fd*k1**2*r**2 + 360*D1*K*b1*f*fd*k1**2*r*s - 408*D1*K*b1*f*fd*k1**2*r - 194*D1*K*b1*f*fd*k1**2*s + 102*D1*K*b1*f*fd*k1**2 + 168*D1*K*b1*f*fd*k2**2*r**2 + 84*D1*K*b1*f*fd*k2**2*r*s - 84*D1*K*b1*f*fd*k2**2*r - 42*D1*K*b1*f*fd*k2**2*s + 35*D1*b1**3*fd*k2**2*r**2 + 35*D1*b1**3*fd*k2**2*r*s - 35*D1*b1**3*fd*k2**2*r - 84*D1*b1**2*f*fd*k1**2*r*s + 63*D1*b1**2*f*fd*k1**2*r - 21*D1*b1**2*f*fd*k2**2*r - 21*D1*b1**2*f*fd*k2**2*s + 21*D1*b1**2*f*fd*k2**2 - 28*D1*b1**2*fd*k1**2*r*s - 35*D1*b1**2*fd*k2**2*r**2 + 56*D1*b1*b2*fd*k1**2*r**2 + 56*D1*b1*b2*fd*k1**2*r*s + 70*D1*b1*b2*fd*k2**2*r**2 + 70*D1*b1*b2*fd*k2**2*r*s - 90*D1*b1*f**2*fd*k1**2*r*s + 60*D1*b1*f**2*fd*k1**2*r + 33*D1*b1*f**2*fd*k1**2*s - 21*D1*b1*f**2*fd*k1**2 - 45*D1*b1*f**2*fd*k2**2*r**2 - 45*D1*b1*f**2*fd*k2**2*r*s + 60*D1*b1*f**2*fd*k2**2*r + 15*D1*b1*f**2*fd*k2**2*s - 15*D1*b1*f**2*fd*k2**2 - 48*D1*b1*f*fd*k1**2*r*s + 24*D1*b1*f*fd*k1**2*s - 42*D1*b1*f*fd*k2**2*r**2 + 21*D1*b1*f*fd*k2**2*r - 364*D1*b1*f*gd2*k1**2*r**2 - 392*D1*b1*f*gd2*k1**2*r*s + 84*D1*b1*f*gd2*k1**2*r - 56*D1*b1*f*gd2*k1**2*s + 56*D1*b1*f*gd2*k1**2 - 280*D1*b1*f*gd2*k2**2*r**2 - 140*D1*b1*f*gd2*k2**2*r*s - 364*D1*b1*fd*g2*k1**2*r**2 - 392*D1*b1*fd*g2*k1**2*r*s - 224*D1*b1*fd*g2*k1**2*r - 112*D1*b1*fd*g2*k1**2*s + 112*D1*b1*fd*g2*k1**2 - 280*D1*b1*fd*g2*k2**2*r**2 - 140*D1*b1*fd*g2*k2**2*r*s + 96*D1*b2*f*fd*k1**2*r**2 + 96*D1*b2*f*fd*k1**2*r*s - 96*D1*b2*f*fd*k1**2*r - 48*D1*b2*f*fd*k1**2*s + 24*D1*b2*f*fd*k1**2 + 84*D1*b2*f*fd*k2**2*r**2 + 84*D1*b2*f*fd*k2**2*r*s - 42*D1*b2*f*fd*k2**2*r - 42*D1*b2*f*fd*k2**2*s + D1*bd1*f*(14*K*b1*(k1**2*(26*r**2 + 4*r*(7*s - 4) - 5*s - 2) + 5*k2**2*(2*r - 1)*(2*r + s)) + 35*b1**2*k2**2*(3*r - 1)*(r + s - 1) + 14*b1*k1**2*(-4*r*s + r + s) + 35*b1*k2**2*r*(1 - 2*r) + 14*b2*k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 70*b2*k2**2*(r - 1)*(r + s) - 3*f**2*(2*k1**2*(5*r - 1)*(s - 1) + 5*k2**2*r*(r + s - 1)) + f*(k1**2*(4*K*(51*r**2 + 45*r*s - 48*r - 13*s + 13) - 21*b1*(r*(4*s - 3) - s + 1) + 6*r*(2 - 4*s) + 6*s - 6) + 21*k2**2*(b1*(r + s - 1) + r*(4*K*r + 2*K*s - r))) + 28*g2*k1**2*(-13*r**2 + r*(13 - 14*s) + 7*s) - 140*g2*k2**2*(r - 1)*(2*r + s)) + 2*D1*bd2*f*(7*b1*r*(k1**2*(4*r + 4*s - 2) + 5*k2**2*(r + s)) + 3*f*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s))) - 408*D1*f**2*gd2*k1**2*r**2 - 360*D1*f**2*gd2*k1**2*r*s + 384*D1*f**2*gd2*k1**2*r + 104*D1*f**2*gd2*k1**2*s - 104*D1*f**2*gd2*k1**2 - 168*D1*f**2*gd2*k2**2*r**2 - 84*D1*f**2*gd2*k2**2*r*s - 816*D1*f*fd*g2*k1**2*r**2 - 720*D1*f*fd*g2*k1**2*r*s + 816*D1*f*fd*g2*k1**2*r + 388*D1*f*fd*g2*k1**2*s - 204*D1*f*fd*g2*k1**2 - 336*D1*f*fd*g2*k2**2*r**2 - 168*D1*f*fd*g2*k2**2*r*s + 168*D1*f*fd*g2*k2**2*r + 84*D1*f*fd*g2*k2**2*s + 728*Dd*K*b1**2*f*k1**2*r**2 + 784*Dd*K*b1**2*f*k1**2*r*s - 154*Dd*K*b1**2*f*k1**2*r + 14*Dd*K*b1**2*f*k1**2*s - 112*Dd*K*b1**2*f*k1**2 + 560*Dd*K*b1**2*f*k2**2*r**2 + 280*Dd*K*b1**2*f*k2**2*r*s - 140*Dd*K*b1**2*f*k2**2*r - 70*Dd*K*b1**2*f*k2**2*s + 816*Dd*K*b1*f**2*k1**2*r**2 + 720*Dd*K*b1*f**2*k1**2*r*s - 792*Dd*K*b1*f**2*k1**2*r - 298*Dd*K*b1*f**2*k1**2*s + 206*Dd*K*b1*f**2*k1**2 + 336*Dd*K*b1*f**2*k2**2*r**2 + 168*Dd*K*b1*f**2*k2**2*r*s - 84*Dd*K*b1*f**2*k2**2*r - 42*Dd*K*b1*f**2*k2**2*s + 140*Dd*b1**3*f*k2**2*r**2 + 140*Dd*b1**3*f*k2**2*r*s - 175*Dd*b1**3*f*k2**2*r - 35*Dd*b1**3*f*k2**2*s + 35*Dd*b1**3*f*k2**2 - 168*Dd*b1**2*f**2*k1**2*r*s + 126*Dd*b1**2*f**2*k1**2*r + 21*Dd*b1**2*f**2*k1**2*s - 21*Dd*b1**2*f**2*k1**2 - 112*Dd*b1**2*f*k1**2*r*s + 28*Dd*b1**2*f*k1**2*r + 14*Dd*b1**2*f*k1**2*s - 140*Dd*b1**2*f*k2**2*r**2 + 35*Dd*b1**2*f*k2**2*r + 224*Dd*b1*b2*f*k1**2*r**2 + 224*Dd*b1*b2*f*k1**2*r*s - 112*Dd*b1*b2*f*k1**2*r - 28*Dd*b1*b2*f*k1**2*s + 280*Dd*b1*b2*f*k2**2*r**2 + 280*Dd*b1*b2*f*k2**2*r*s - 70*Dd*b1*b2*f*k2**2*r - 70*Dd*b1*b2*f*k2**2*s - 120*Dd*b1*f**3*k1**2*r*s + 90*Dd*b1*f**3*k1**2*r + 39*Dd*b1*f**3*k1**2*s - 27*Dd*b1*f**3*k1**2 - 60*Dd*b1*f**3*k2**2*r**2 - 60*Dd*b1*f**3*k2**2*r*s + 75*Dd*b1*f**3*k2**2*r + 15*Dd*b1*f**3*k2**2*s - 15*Dd*b1*f**3*k2**2 - 96*Dd*b1*f**2*k1**2*r*s + 24*Dd*b1*f**2*k1**2*r + 36*Dd*b1*f**2*k1**2*s - 12*Dd*b1*f**2*k1**2 - 84*Dd*b1*f**2*k2**2*r**2 + 21*Dd*b1*f**2*k2**2*r - 1456*Dd*b1*f*g2*k1**2*r**2 - 1568*Dd*b1*f*g2*k1**2*r*s + 308*Dd*b1*f*g2*k1**2*r - 28*Dd*b1*f*g2*k1**2*s + 224*Dd*b1*f*g2*k1**2 - 1120*Dd*b1*f*g2*k2**2*r**2 - 560*Dd*b1*f*g2*k2**2*r*s + 280*Dd*b1*f*g2*k2**2*r + 140*Dd*b1*f*g2*k2**2*s + 192*Dd*b2*f**2*k1**2*r**2 + 192*Dd*b2*f**2*k1**2*r*s - 192*Dd*b2*f**2*k1**2*r - 72*Dd*b2*f**2*k1**2*s + 48*Dd*b2*f**2*k1**2 + 168*Dd*b2*f**2*k2**2*r**2 + 168*Dd*b2*f**2*k2**2*r*s - 42*Dd*b2*f**2*k2**2*r - 42*Dd*b2*f**2*k2**2*s - 1632*Dd*f**2*g2*k1**2*r**2 - 1440*Dd*f**2*g2*k1**2*r*s + 1584*Dd*f**2*g2*k1**2*r + 596*Dd*f**2*g2*k1**2*s - 412*Dd*f**2*g2*k1**2 - 672*Dd*f**2*g2*k2**2*r**2 - 336*Dd*f**2*g2*k2**2*r*s + 168*Dd*f**2*g2*k2**2*r + 84*Dd*f**2*g2*k2**2*s)/(105*d**2*k3**4) + 4*D1**3*Pk3*Pkd1*k1*st**2*(11*D1*bd1*f*(f**2*k2**2*(k1**2*(9*r**2 + r*(9*s - 47) - 26*s + 34) + 9*k2**2*(11*r + 9*s - 7)) + 3*f*(7*b1*k2**4*(2*r - 1)*(9*r + 9*s - 5) - k1**4*(4*C - 2)*(2*r**2 + 2*r*s + r - s - 3) + 2*k1**2*k2**2*(-14*C*(r - 1)*(3*r + 3*s - 2) + K*r**2 + K*r*s + 20*K*r + 12*K*s - 12*K + b1*(9*r**2 + r*(9*s - 2) + 3*s - 5) + 21*r**2 + 21*r*s - 35*r - 21*s + 14)) + 42*k1**2*k2**2*(K*b1*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) + 33*b1**2*k2**2*(D1*fd*r*(14*K*k1**2*(r + s) + f*k1**2*(18*r + 18*s + 5) + 14*f*k2**2*(9*r + 9*s - 5)) + Dd*f*(14*K*k1**2*(4*r**2 + r*(4*s + 3) - 3*s) + f*(k1**2*(36*r**2 + 36*r*s + r + 6*s - 10) + 7*k2**2*(4*r - 1)*(9*r + 9*s - 5)))) + 11*b1*(D1*(f**2*fd*k2**2*(k1**2*(27*r**2 + 3*r*(9*s - 40) - 84*s + 56) - 9*k2**2*(3*r + 9*s - 5)) + 6*f*k1**2*(K*fd*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10) - fd*r*(2*C - 1)*(k1**2*(4*r + 4*s + 5) + 14*k2**2*(3*r + 3*s - 2)) - 14*gd2*k2**2*r*(r + s + 2)) - 84*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(36*r**2 + r*(36*s - 167) - 110*s + 90) + 18*k2**2*(4*r - 1)) - 6*f*k1**2*(k1**2*(2*C - 1)*(8*r**2 + 8*r*(s + 1) - s - 3) + k2**2*(14*C*(4*r - 1)*(3*r + 3*s - 2) - K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + (7 - 28*r)*(3*r + 3*s - 2))) - 84*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) - f*(D1*(5*f**2*fd*k2**2*(k1**2*(80*r**2 + 80*r*(s - 1) - 42*s + 26) + 11*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + 22*f*k1**2*(fd*(2*C - 1)*(k1**2*(18*r**2 + 18*r*(s - 1) - 15*s + 7) + 9*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + 6*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 132*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(5*f**2*k2**2*(k1**2*(80*r**2 + 80*r*(s - 1) - 42*s + 26) + 11*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + f*k1**2*(44*C - 22)*(k1**2*(24*r**2 + 24*r*(s - 1) - 19*s + 11) + 9*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 132*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**6) - 2*D1**3*Pk3*Pkd1*st**2*(D1*bd1*f**2*(r**2*(46*C - 23) + r*(-44*C - 2*s + 19) + 4*s) + 7*b1**2*(D1*fd*r*(2*C*r - r + 2*s - 2) + Dd*f*(r**2*(8*C - 4) + r*(-2*C + 8*s - 5) - s + 1)) + b1*f*(7*D1*bd1*(r**2*(4*C - 2) + r*(-2*C + 4*s - 1) - s + 1) + D1*fd*(2*C*(46*r**2 - 67*r + 22) - 46*r**2 - 4*r*s + 62*r + 9*s - 23) + Dd*f*(2*C*(92*r**2 - 111*r + 22) - 92*r**2 - 8*r*s + 101*r + 17*s - 27)))/(105*d**2*k1) + 2*D1**3*Pk3*Pkd1*(-10*D1*bd1*f*r*(b2 - 2*g2)*(r - 1) + 5*b1**3*(2*D1*fd*r*(s - 1) + Dd*f*(r*(8*s - 6) - s + 1)) + b1**2*(5*D1*bd1*f*(r*(6*s - 4) - s + 1) + D1*fd*(f*(3*r*(4*s - 3) - 7*s + 5) + (2 - 2*r)*(5*K*(r - 1) - 2*s)) + Dd*f*(-10*K*(4*r**2 - 5*r + 1) + f*(6*r*(4*s - 3) - 11*s + 7) + 16*r*s - 4*r - 10*s + 4)) + b1*(D1*bd1*f*(-20*K*r**2 + f*(3*r*(4*s - 3) - 4*s + 2) + r*(20*K + 8*s - 2) - 4*s + 2) + (10 - 10*r)*(D1*b2*fd*(r - 1) + D1*f*r*(bd2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + Dd*b2*f*(4*r - 1) + 2*Dd*f*g2*(1 - 4*r))))/(15*d**2*k1) - 2*D1**3*Pk3*Pkd1*st**2*(21*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(D1*f*k2**2*(7*bd1*r*(1 - 3*r) + 2*fd*(46*r**2 + r*(84*s - 26) - 11)) - 7*D1*fd*r*(k1**2*(C*(6*r + 8*s - 8) - 3*r - 6*s + 6) + k2**2*(r*(K - 1) + 2*s)) - 7*Dd*f*k1**2*(C*(24*r**2 + r*(32*s - 30) - 4*s + 4) - 12*r**2 - 3*r*(8*s - 7) + 3*s - 3) + Dd*f*k2**2*(2*f*(92*r**2 + 7*r*(24*s - 11) - 21*s + 3) + 7*r**2*(4 - 4*K) + 7*r*(K - 8*s + 1) + 7*s)) - 3*b1*(D1*bd1*f*(-7*k1**2*(2*C*(6*r**2 + 8*r*s - 7*r - 2*s + 2) - 6*r**2 - 12*r*s + 9*r + 3*s - 3) + k2**2*(-14*K*r**2 + 7*K*r + 2*f*(46*r**2 + 84*r*s - 51*r - 21*s + 14) + 14*r**2 - 28*r*s + 7*s)) + D1*(3*f**2*fd*k2**2*(45*r**2 + 18*r*(2*s - 3) - 30*s + 22) + f*(fd*k1**2*(-2*C*(76*r*s + 51*r + 18*s - 40) + 76*r*s + 51*r + 27*s - 41) - fd*k2**2*(K*(46*r**2 - 67*r + 22) - 36*r**2 - 4*r*s + r + 9*s - 2) + k2**2*r**2*(-7*bd2 + 14*gd2)) - 7*fd*k2**2*r**2*(b2 - 2*g2)) + Dd*f*(3*f**2*k2**2*(60*r**2 + r*(48*s - 67) - 38*s + 26) + f*(k1**2*(-4*C*(4*r*(19*s + 6) + 17*s - 24) + 8*r*(19*s + 6) + 50*s - 56) + k2**2*(K*(-92*r**2 + 111*r - 22) + 72*r**2 + 4*r*(2*s - 7) - 17*s + 10)) + k2**2*r*(-7*b2 + 14*g2)*(4*r - 1))) + f*(-3*D1*bd1*(3*f**2*k2**2*(15*r**2 + r*(12*s - 13) - 8*s + 4) + f*(k1**2*(-16*C*s - r*(2*C - 1)*(38*s + 5) + 11*s - 3) + k2**2*(r**2*(18 - 23*K) + 2*r*(11*K + s - 12) - 4*s + 4)) + k2**2*r*(-7*b2 + 14*g2)*(r - 1)) + D1*(f*(fd*k1**2*(C*(342*r**2 + 6*r*(54*s - 71) - 432*s + 212) - 171*r**2 - 3*r*(60*s - 67) + 231*s - 105) + 27*fd*k2**2*r*(1 - 3*r) + k2**2*r*(3*bd2 - 6*gd2)*(23*r - 22)) + 3*fd*k2**2*(b2 - 2*g2)*(46*r**2 - 67*r + 22)) + Dd*f*(f*k1**2*(C*(456*r**2 + r*(432*s - 602) - 576*s + 356) - 228*r**2 + r*(287 - 240*s) + 307*s - 181) + 27*f*k2**2*r*(1 - 4*r) + k2**2*(3*b2 - 6*g2)*(92*r**2 - 111*r + 22))))/(315*d**2*k1*k3**2) - 2*D1**3*Pk3*Pkd1*(35*b1**3*k1**2*(2*D1*fd*r*(s - 1) + Dd*f*(r*(8*s - 6) - s + 1)) + 7*b1**2*(5*D1*bd1*f*k1**2*(r*(6*s - 4) - s + 1) + D1*fd*(2*K*k1**2*(6*r*(s + 3) + 4*s - 9) + f*k1**2*(5 - 7*s) - 4*k1**2*s - 5*k2**2*r**2) + Dd*f*(k1**2*(2*K*(6*r*(4*s + 5) + 5*s - 13) + f*(4 - 8*s) - 8*s + 4) + 5*k2**2*r*(1 - 4*r))) - b1*(7*D1*bd1*f*(k1**2*(2*K*(-6*r*(2*s + 1) + s + 2) + f*(s + 1) + 2*s - 2) + 5*k2**2*r*(2*r - 1)) + D1*(3*f**2*fd*k1**2*(10*r*(3*s - 2) - 11*s + 7) + f*(-2*K*fd*k1**2*(108*r**2 + 12*r*(7*s - 9) - 49*s + 27) - 14*bd2*k1**2*r*(9*r + 10*s - 5) + 3*fd*(2*r - 1)*(8*k1**2*s + 7*k2**2*r) + 56*gd2*k1**2*(3*r*(s + 1) + s - 1)) + 14*fd*k1**2*(-b2*r*(9*r + 10*s) + 2*g2*(6*r*(s + 3) + 4*s - 9))) + Dd*f*(3*f**2*k1**2*(10*r*(4*s - 3) - 13*s + 9) + f*(-2*k1**2*(K*(216*r**2 + 168*r*s - 204*r - 77*s + 55) - 48*r*s + 12*r + 18*s - 6) + 21*k2**2*r*(4*r - 1)) + 14*k1**2*(b2*(-36*r**2 + r*(19 - 40*s) + 5*s) + 2*g2*(6*r*(4*s + 5) + 5*s - 13)))) + f*(D1*bd1*(-6*f**2*k1**2*(5*r - 1)*(s - 1) + f*(2*k1**2*(2*K*(27*r**2 + 3*r*(7*s - 8) - 7*s + 7) + 3*r*(2 - 4*s) + 3*s - 3) - 21*k2**2*r**2) + 14*k1**2*(b2*(9*r**2 + 10*r*s - 9*r - 5*s) + 6*g2*s*(1 - 2*r))) + 2*k1**2*(D1*b2*fd*(108*r**2 + 12*r*(7*s - 9) - 49*s + 27) + 2*D1*bd2*f*(27*r**2 + 3*r*(7*s - 8) - 7*s + 7) - 2*D1*(2*f*gd2*(27*r**2 + 3*r*(7*s - 8) - 7*s + 7) + fd*g2*(108*r**2 + 12*r*(7*s - 9) - 49*s + 27)) + Dd*b2*f*(216*r**2 + 12*r*(14*s - 17) - 77*s + 55) - 2*Dd*f*g2*(216*r**2 + 12*r*(14*s - 17) - 77*s + 55))))/(105*d**2*k1*k3**2) - 2*D1**3*Pk3*Pkd1*st**2*(231*b1**3*k1**2*k2**2*(3*D1*fd*r*(r + s - 1) + Dd*f*(12*r**2 + r*(12*s - 17) - 4*s + 4)) + 33*b1**2*(D1*(7*bd1*f*k1**2*k2**2*(9*r**2 + r*(9*s - 14) - 4*s + 4) + fd*(2*f*k1**2*k2**2*(89*r**2 + r*(134*s - 61) + 11*s - 11) + 28*f*k2**4*r*(3*r + 3*s - 2) + k1**4*r*(28 - 56*C)*(r + s - 1) + 7*k1**2*k2**2*r*(3*K*r + 6*K*s + r - 2*s))) + Dd*f*(14*f*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(14 - 28*C)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(-56*K*s + f*(356*r**2 + r*(536*s - 331) - 3*s - 5) + 7*r**2*(12*K + 4) + 7*r*(24*K*s + K - 8*s + 1) + 7*s))) + 11*b1*(3*D1*bd1*f*(14*f*k2**4*(2*r - 1)*(3*r + 3*s - 2) + k1**4*(14 - 28*C)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(7*K*(6*r**2 + 12*r*s - r - 8*s) + f*(178*r**2 + r*(268*s - 209) - 25*s + 17) + 14*r**2 - 28*r*s + 7*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(135*r**2 + r*(21*s - 166) - 163*s + 109) + 6*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + f*k1**2*(fd*(k1**2*(-4*C*(31*r**2 + 46*r*s + 2*r + 9*s - 9) + 62*r**2 + r*(96*s + 9) + 18*s - 18) + k2**2*(K*(-38*r**2 + r*(143 - 4*s) + 44*s - 62) + r**2*(204 - 336*C) + r*(-56*C*(3*s - 2) + 88*s - 57) - 9*s + 2)) + 14*k2**2*r*(bd2*(r + s + 2) - gd2*(3*r + 6*s + 2))) + 14*fd*k1**2*k2**2*r*(b2*(r + s) - 3*g2*(r + 2*s))) + Dd*f*(f**2*k2**2*(k1**2*(540*r**2 + 7*r*(12*s - 95) - 548*s + 396) + 18*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 3*f*k1**2*(k1**2*(C*(248*r**2 + r*(368*s - 62) + 60*s - 76) - 124*r**2 - 3*r*(64*s - 7) - 29*s + 41) + k2**2*(28*C*(4*r - 1)*(6*r + 3*s - 2) + K*(76*r**2 + 8*r*s - 311*r - 108*s + 126) - 408*r**2 - 176*r*s + 224*r + 59*s - 38)) + 42*k1**2*k2**2*(b2*(4*r**2 + r*(4*s + 3) - 3*s) - g2*(12*r**2 + 24*r*s + r - 8*s)))) + f*(11*D1*bd1*(f**2*k2**2*(k1**2*(135*r**2 + r*(21*s - 167) - 59*s + 69) + 18*k2**2*r*(3*r + 3*s - 2)) - 3*f*k1**2*(k1**2*(C*(62*r**2 + r*(92*s - 26) + 8*s - 24) - 31*r**2 - 48*r*s + 10*r - 3*s + 15) + k2**2*(28*C*(r - 1)*(6*r + 3*s - 2) + K*(19*r**2 + 2*r*s - 84*r - 32*s + 32) - 102*r**2 - 44*r*s + 136*r + 46*s - 32)) + 42*k1**2*k2**2*(b2*(r**2 + r*(s - 1) - 3*s) + g2*(-3*r**2 + r*(3 - 6*s) + 8*s))) + k1**2*(D1*(f**2*fd*k2**2*(-1740*r**2 - 5*r*(792*s - 713) + 2079*s - 1327) - 11*f*(fd*(k1**2*(C*(486*r**2 + 6*r*(78*s - 95) - 552*s + 268) - 243*r**2 - 252*r*s + 273*r + 291*s - 133) + 9*k2**2*(3*r - 1)*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) - 6*k2**2*(bd2*(r**2 + r*(s + 20) + 12*s - 12) + gd2*(19*r**2 + 2*r*(s - 42) - 32*s + 32))) + 66*fd*k2**2*(b2*(2*r**2 + r*(2*s + 19) + 13*s - 10) + g2*(38*r**2 + r*(4*s - 143) - 44*s + 62))) + Dd*f*(f**2*k2**2*(-1740*r**2 - 5*r*(792*s - 713) + 2079*s - 1327) - 11*f*(k1**2*(C*(648*r**2 + 624*r*s - 794*r - 728*s + 444) - 324*r**2 - 336*r*s + 383*r + 383*s - 225) + 9*k2**2*(4*r - 1)*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) + 66*k2**2*(b2*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + g2*(76*r**2 + 8*r*s - 311*r - 108*s + 126))))))/(3465*d**2*k1*k3**4) + 4*D1**3*Pk3*Pkdd1*b1*ct*k2*(2*D1*bd1*f*r*(6*f*r - 3*f + 7*r - 7) + 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*(7*D1*bd1*f*r*(3*r - 1) + D1*fd*(3*f*(1 - 2*r)**2 + 7*(r - 1)**2) + Dd*f*(4*r - 1)*(6*f*r - 3*f + 7*r - 7)))/(105*d**2*k1) + D1**3*Pk3*Pkdd1*ct**6*f*k2**4*(8*C - 8)*(D1*(36*b1*fd*r**2 + 18*bd1*f*r*(r - 1) + 5*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(18*b1*r + 5*f*(3*r - 1)))/(315*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**5*f*k2**3*(D1*(36*b1*fd*r**2 + 18*bd1*f*r*(r - 1) + 5*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(18*b1*r + 5*f*(3*r - 1)))/(315*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkdd1*ct**5*f*k2**3*(D1*(396*b1*fd*k1**2*r**2*(8*C - 7) + 5*f**2*k2**2*(33*bd1*r*(r - 1) + 7*fd*(1 - 4*r)**2) + 11*f*(18*bd1*k1**2*r*(8*C - 7)*(r - 1) + 5*fd*(9*b1*k2**2*r**2 + k1**2*(1 - 3*r)**2*(8*C - 7)))) + Dd*f*(4*r - 1)*(198*b1*k1**2*r*(8*C - 7) + 35*f**2*k2**2*(4*r - 1) + 55*f*(3*b1*k2**2*r + k1**2*(8*C - 7)*(3*r - 1))))/(3465*d**2*k1*k3**4) + D1**3*Pk3*Pkdd1*ct**4*f*k2**4*st**2*(8*C - 8)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(9*r**2 - 15*r + 4)) + Dd*f*(4*r - 1)*(3*b1*r + f*(3*r - 4)))/(105*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**4*k2**2*(42*b1**2*r*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) - 6*b1*f*(7*D1*bd1*r*(-2*C*r + C + 2*r - 1) - 3*D1*fd*(-4*C*r + C + 2*r**2 + 4*r - 1) + 3*Dd*f*(4*r - 1)*(C - r - 1)) + f**2*(18*D1*bd1*r*(C + r - 2) + D1*fd*(1 - 3*r)**2*(15 - 10*C) - Dd*f*(10*C - 15)*(12*r**2 - 7*r + 1)))/(315*d**2*k3**2) - 4*D1**3*Pk3*Pkdd1*ct**4*k2**2*(D1*(-231*b1*fd*k2**2*r**2*(b1*(K - 1) - 2*g2) - 5*f**3*k2**2*(22*bd1*r*(3*r - 4) + 21*fd*(1 - 4*r)**2) - 11*f**2*(5*fd*(b1*k2**2*(18*r**2 + 6*r - 1) + k1**2*(1 - 3*r)**2*(12*C - 9)) + 9*r*(6*bd1*k1**2*(4*C - 3)*(r - 1) - bd1*k2**2*(2*r - 1)*(-K + 2*b1 + 1) + 2*gd2*k2**2*(1 - 2*r))) + 33*f*(12*b1**2*fd*k2**2*r**2 + b1*(-3*fd*(k1**2*r**2*(48*C - 36) + k2**2*(1 - 2*r)**2*(K - 1)) + 7*k2**2*r*(bd1*(-2*K*r + K + 2*r - 1) + 2*gd2*r)) + 2*g2*k2**2*(7*bd1*r*(r - 1) + 3*fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(231*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 105*f**3*k2**2*(4*r - 1) + 55*f**2*(b1*k2**2*(6*r + 1) + k1**2*(12*C - 9)*(3*r - 1)) - 99*f*(2*b1**2*k2**2*r + 6*b1*k1**2*r*(3 - 4*C) + b1*k2**2*(-2*K*r + K + 2*r - 1) + 2*g2*k2**2*(2*r - 1))))/(3465*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**3*f*k2**3*st**2*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(9*r**2 - 15*r + 4)) + Dd*f*(4*r - 1)*(3*b1*r + f*(3*r - 4)))/(105*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkdd1*ct**3*f*k2**3*st**2*(D1*(198*b1*fd*k1**2*r**2*(6*C - 5) + 5*f**2*k2**2*(33*bd1*r*(r - 1) + 5*fd*(20*r**2 - 21*r + 4)) + 33*f*(15*b1*fd*k2**2*r**2 + 3*bd1*k1**2*r*(6*C - 5)*(r - 1) + fd*k1**2*(6*C - 5)*(9*r**2 - 15*r + 4))) + Dd*f*(4*r - 1)*(99*b1*k1**2*r*(6*C - 5) + 25*f**2*k2**2*(5*r - 4) + 33*f*(5*b1*k2**2*r + k1**2*(6*C - 5)*(3*r - 4))))/(3465*d**2*k1*k3**4) - 4*D1**3*Pk3*Pkdd1*ct**3*k1*k2*(D1*(-231*b1*fd*k2**2*r**2*(b1*(4*K - 3) - 8*g2) - 15*f**3*k2**2*(-22*bd1*r + 7*fd*(1 - 4*r)**2) - 11*f**2*(5*fd*(3*b1*k2**2*(6*r - 1) + k1**2*(1 - 3*r)**2*(8*C - 5)) + 9*r*(2*bd1*k1**2*(8*C - 5)*(r - 1) - bd1*k2**2*(2*r - 1)*(-4*K + 6*b1 + 3) + 8*gd2*k2**2*(1 - 2*r))) + 33*f*(36*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(60 - 96*C) + k2**2*(1 - 2*r)**2*(9 - 12*K)) - 7*k2**2*r*(bd1*(4*K - 3)*(2*r - 1) - 8*gd2*r)) + 8*g2*k2**2*(7*bd1*r*(r - 1) + 3*fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(231*b1*k2**2*r*(b1*(4*K - 3) - 8*g2) + 105*f**3*k2**2*(4*r - 1) + 55*f**2*(3*b1*k2**2 + k1**2*(8*C - 5)*(3*r - 1)) - 99*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(5 - 8*C) + b1*k2**2*(K*(4 - 8*r) + 6*r - 3) + 8*g2*k2**2*(2*r - 1))))/(3465*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**3*k2*(3*D1*bd1*f**2*r*(2*r - 1) + 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(7*D1*bd1*r + D1*fd*(6*r - 3) + 3*Dd*f*(4*r - 1)))/(105*d**2*k1) + 4*D1**3*Pk3*Pkdd1*ct**3*k2*(3*b1**2*r*(D1*fd*r*(k1**2*(28*C - 21) + k2**2*(24*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(28*C - 21) + k2**2*(12*f + 7))) + b1*f*(D1*(3*bd1*r*(2*r - 1)*(k1**2*(28*C - 21) + k2**2*(12*f + 7)) + fd*(-k1**2*(36*C - 27)*(4*r - 1) + k2**2*(10*f*(1 - 3*r)**2 + 9*(1 - 2*r)**2))) + Dd*f*(4*r - 1)*(k1**2*(27 - 36*C) + k2**2*(10*f*(3*r - 1) + 18*r - 9))) + f**2*(D1*bd1*r*(k1**2*(36*C - 27) + k2**2*(10*f*(3*r - 1) + 18*r - 9)) + D1*fd*k1**2*(1 - 3*r)**2*(15 - 20*C) - Dd*f*k1**2*(20*C - 15)*(12*r**2 - 7*r + 1)))/(315*d**2*k1*k3**2) - D1**3*Pk3*Pkdd1*ct**2*f*k2**4*st**4*(8*C - 8)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*ct**2*k1**2*(D1*(-693*b1*fd*k2**2*r**2*(b1*(2*K - 1) - 4*g2) - 5*f**3*k2**2*(-66*bd1*r**2 + 7*fd*(1 - 4*r)**2) - 11*f**2*(5*fd*(-3*b1*k2**2*(6*r**2 - 6*r + 1) + k1**2*(1 - 3*r)**2*(2*C - 1)) + 9*r*(2*bd1*k1**2*(2*C - 1)*(r - 1) - 3*bd1*k2**2*(2*r - 1)*(-2*K + 2*b1 + 1) + 12*gd2*k2**2*(1 - 2*r))) + 99*f*(12*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(4 - 8*C) + k2**2*(1 - 2*r)**2*(3 - 6*K)) - 7*k2**2*r*(bd1*(2*K - 1)*(2*r - 1) - 4*gd2*r)) + 4*g2*k2**2*(7*bd1*r*(r - 1) + 3*fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(693*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 35*f**3*k2**2*(4*r - 1) + 55*f**2*(3*b1*k2**2*(1 - 2*r) + k1**2*(2*C - 1)*(3*r - 1)) - 99*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(1 - 2*C) - 3*b1*k2**2*(2*K - 1)*(2*r - 1) + 12*g2*k2**2*(2*r - 1))))/(3465*d**2*k3**4) - D1**3*Pk3*Pkdd1*ct**2*k2**2*st**2*(4*C - 4)*(7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*r*(2*r - 1) + D1*fd*(10*r**2 + 9*r - 4) + Dd*f*(20*r**2 + 11*r - 4)) + f**2*(D1*bd1*r*(5*r - 2) + 2*D1*fd*(9*r**2 - 15*r + 4) + 2*Dd*f*(12*r**2 - 19*r + 4)))/(105*d**2*k3**2) + 2*D1**3*Pk3*Pkdd1*ct**2*k2**2*st**2*(D1*(-231*b1*fd*k2**2*r**2*(b1*(K - 1) - 2*g2) + 6*f**3*k2**2*(11*bd1*r*(6*r - 5) + 15*fd*(20*r**2 - 21*r + 4)) + 11*f**2*(6*b1*fd*k2**2*(18*r**2 + 15*r - 4) + 6*bd1*k1**2*r*(19*C - 13)*(r - 1) + 3*bd1*k2**2*r*(b1*(6 - 12*r) + (K - 1)*(r - 4)) + fd*k1**2*(38*C - 26)*(9*r**2 - 15*r + 4) - 6*gd2*k2**2*r*(r - 4)) - 33*f*(12*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(52 - 76*C) - k2**2*(K - 1)*(2*r**2 - 9*r + 4)) + 7*k2**2*r*(bd1*(K - 1)*(2*r - 1) - 2*gd2*r)) + 2*g2*k2**2*(-7*bd1*r*(r - 1) + fd*(2*r**2 - 9*r + 4)))) + Dd*f*(4*r - 1)*(-231*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 90*f**3*k2**2*(5*r - 4) + 22*f**2*(6*b1*k2**2*(3*r + 2) + k1**2*(19*C - 13)*(3*r - 4)) - 33*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(13 - 19*C) - b1*k2**2*(K - 1)*(r - 4) + 2*g2*k2**2*(r - 4))))/(3465*d**2*k3**4) - D1**3*Pk3*Pkdd1*ct**2*(8*C - 4)*(3*D1*bd1*f**2*r*(2*r - 1) + 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(7*D1*bd1*r + D1*fd*(6*r - 3) + 3*Dd*f*(4*r - 1)))/(105*d**2) - 4*D1**3*Pk3*Pkdd1*ct**2*(21*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(D1*(7*bd1*f*k2**2*r*(1 - 3*r) + fd*k1**2*r**2*(14*C - 7) + fd*k2**2*(-14*K*r + 7*K + 3*f*(8*r**2 + 4*r - 1) + 7*r**2 + 14*r - 7)) + Dd*f*(4*r - 1)*(k1**2*r*(14*C - 7) + k2**2*(-7*K + 3*f*(4*r + 1) + 7*r + 7))) - 3*b1*(D1*(f**2*k2**2*(12*bd1*r*(2*r - 1) + 5*fd*(1 - 3*r)**2) + f*(-3*fd*(k1**2*(2*C - 1)*(4*r - 1) + k2**2*(1 - 2*r)**2*(K - 2)) + 7*r*(bd1*k1**2*(2*C - 1)*(2*r - 1) - bd1*k2**2*(K - 2*r) + k2**2*(-bd2*r + 2*gd2))) - 7*fd*k2**2*(b2*r**2 + g2*(2 - 4*r))) + Dd*f*(4*r - 1)*(5*f**2*k2**2*(3*r - 1) + 3*f*(k1**2*(1 - 2*C) + k2**2*(-2*K*r + K + 4*r - 2)) + 7*k2**2*(-b2*r + 2*g2))) + f*(D1*(15*bd1*f**2*k2**2*r*(1 - 3*r) + f*(fd*k1**2*(1 - 3*r)**2*(10*C - 5) + 9*r*(bd1*k1**2*(1 - 2*C) + bd1*k2**2*(K - 2)*(2*r - 1) + k2**2*(bd2 - 2*gd2)*(2*r - 1))) + 3*k2**2*(7*b2*bd1*r*(r - 1) + 3*b2*fd*(1 - 2*r)**2 - 6*fd*g2*(1 - 2*r)**2)) + Dd*f*(4*r - 1)*(f*k1**2*(10*C - 5)*(3*r - 1) + k2**2*(9*b2 - 18*g2)*(2*r - 1))))/(315*d**2*k3**2) - 4*D1**3*Pk3*Pkdd1*ct*f*k2**3*st**4*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkdd1*ct*f*k2**3*st**4*(D1*(66*b1*fd*k1**2*r**2*(3 - 4*C) + 5*f**2*fd*k2**2*(4*r**2 - 13*r + 3) - f*k1**2*(44*C - 33)*(3*bd1*r*(r - 1) + fd*(3*r - 1))) + Dd*f*(4*r - 1)*(33*b1*k1**2*r*(3 - 4*C) + 5*f**2*k2**2*(r - 3) + f*k1**2*(33 - 44*C)))/(1155*d**2*k1*k3**4) - 4*D1**3*Pk3*Pkdd1*ct*k1**3*k2*(3*b1**2*r*(D1*fd*r*(-28*K + 12*f + 7) + Dd*f*(4*r - 1)*(-28*K + 6*f + 7)) + b1*(D1*(f**2*(18*bd1*r*(2*r - 1) + 5*fd*(1 - 3*r)**2) - 3*f*(3*fd*(1 - 2*r)**2*(4*K - 1) + 7*r*(bd1*(4*K - 1)*(2*r - 1) - 8*gd2*r)) + 168*fd*g2*r**2) + Dd*f*(4*r - 1)*(5*f**2*(3*r - 1) - 9*f*(4*K - 1)*(2*r - 1) + 168*g2*r)) + f*(D1*(bd1*r*(5*f**2*(3*r - 1) - 9*f*(4*K - 1)*(2*r - 1) + 168*g2*(r - 1)) + 72*f*gd2*r*(2*r - 1) + 72*fd*g2*(1 - 2*r)**2) + 72*Dd*f*g2*(8*r**2 - 6*r + 1)))/(315*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*ct*k1*k2*(21*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(7*D1*bd1*f*r*(1 - 3*r) + D1*fd*(7*K*(2 - 4*r) + 3*f*(4*r - 1) + 14*r - 7) + Dd*f*(4*r - 1)*(-14*K + 3*f + 7)) + b1*(D1*(-5*f**2*fd*(1 - 3*r)**2 + 3*f*(3*fd*(1 - 2*r)**2*(2*K - 1) + 7*r*(2*K*bd1 - bd1 + 2*bd2*r - 4*gd2)) + 42*fd*(b2*r**2 + g2*(2 - 4*r))) - Dd*f*(4*r - 1)*(-42*b2*r + 5*f**2*(3*r - 1) - 9*f*(2*K - 1)*(2*r - 1) + 84*g2)) + f*(D1*f*r*(bd1*f*(5 - 15*r) + 9*bd1*(2*K - 1)*(2*r - 1) + (18*bd2 - 36*gd2)*(2*r - 1)) - 36*D1*fd*g2*(1 - 2*r)**2 - 36*Dd*f*g2*(8*r**2 - 6*r + 1) + 6*b2*(7*D1*bd1*r*(r - 1) + 3*D1*fd*(1 - 2*r)**2 + 3*Dd*f*(8*r**2 - 6*r + 1))))/(315*d**2*k3**2) + 2*D1**3*Pk3*Pkdd1*ct*k1*k2*st**2*(D1*(231*b1*fd*k2**2*r**2*(-2*K*b1 + b1 + 4*g2) + 9*f**3*k2**2*(11*bd1*r + 5*fd*(20*r**2 - 21*r + 4)) + 11*f**2*(fd*(9*b1*k2**2*(15*r - 4) + k1**2*(16*C - 9)*(9*r**2 - 15*r + 4)) + r*(3*bd1*k1**2*(16*C - 9)*(r - 1) + 3*bd1*k2**2*(b1*(9 - 18*r) + (2*K - 1)*(r - 4)) - 12*gd2*k2**2*(r - 4))) - 33*f*(18*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(18 - 32*C) - k2**2*(2*K - 1)*(2*r**2 - 9*r + 4)) + 7*k2**2*r*(bd1*(2*K - 1)*(2*r - 1) - 4*gd2*r)) + 4*g2*k2**2*(-7*bd1*r*(r - 1) + fd*(2*r**2 - 9*r + 4)))) + Dd*f*(4*r - 1)*(231*b1*k2**2*r*(-2*K*b1 + b1 + 4*g2) + 45*f**3*k2**2*(5*r - 4) + 11*f**2*(36*b1*k2**2 + k1**2*(16*C - 9)*(3*r - 4)) - 33*f*(9*b1**2*k2**2*r + b1*k1**2*r*(9 - 16*C) + b1*k2**2*(-2*K*(r - 4) + r - 4) + 4*g2*k2**2*(r - 4))))/(3465*d**2*k3**4) + 2*D1**3*Pk3*Pkdd1*ct*k2*st**2*(D1*bd1*f**2*r*(r - 4) - 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(D1*(2*r - 1)*(-7*bd1*r + fd*(r - 4)) + Dd*f*(4*r**2 - 17*r + 4)))/(105*d**2*k1) + 2*D1**3*Pk3*Pkdd1*ct*k2*st**2*(3*b1**2*r*(D1*fd*r*(k1**2*(21 - 28*C) + k2**2*(12*f - 7)) + Dd*f*(4*r - 1)*(k1**2*(21 - 28*C) + k2**2*(6*f - 7))) + 3*b1*f*(D1*(-bd1*r*(2*r - 1)*(k1**2*(28*C - 21) + k2**2*(7 - 6*f)) + fd*(k1**2*(-4*C*(4*r**2 + 9*r - 4) + 8*r**2 + 27*r - 12) + k2**2*(2*f*(9*r**2 - 15*r + 4) + 2*r**2 - 9*r + 4))) + Dd*f*(4*r - 1)*(-4*k1**2*(2*C*(r + 2) - r - 3) + k2**2*(f*(6*r - 8) + r - 4))) + f**2*(D1*(-3*bd1*k1**2*r*(C*(8*r + 4) - 4*r - 5) + 3*bd1*k2**2*r*(f*(6*r - 8) + r - 4) - fd*k1**2*(12*C - 7)*(9*r**2 - 15*r + 4)) - Dd*f*k1**2*(12*C - 7)*(12*r**2 - 19*r + 4)))/(315*d**2*k1*k3**2) + D1**3*Pk3*Pkdd1*f*k2**2*st**4*(8*C - 4)*(D1*(6*b1*fd*r**2 + 3*bd1*f*r*(r - 1) + f*fd*(3*r - 1)) + Dd*f*(4*r - 1)*(3*b1*r + f))/(105*d**2*k3**2) + 4*D1**3*Pk3*Pkdd1*f*k2**2*st**4*(D1*(66*b1*fd*r**2*(b1*k2**2 + k1**2*(1 - 2*C)) + f**2*k2**2*(11*bd1*r + 3*fd*(4*r**2 - 13*r + 3)) - 11*f*(3*bd1*r*(b1*k2**2*(1 - 2*r) + k1**2*(2*C - 1)*(r - 1)) + fd*(3*r - 1)*(-b1*k2**2 + k1**2*(2*C - 1)))) + Dd*f*(4*r - 1)*(33*b1*r*(b1*k2**2 + k1**2*(1 - 2*C)) + 3*f**2*k2**2*(r - 3) + 11*f*(b1*k2**2 + k1**2*(1 - 2*C))))/(1155*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*k1**4*(D1*(7*b1*fd*r**2*(K*b1 - 2*g2) - 3*f**2*r*(2*r - 1)*(-K*bd1 + 2*gd2) - 3*f*fd*(1 - 2*r)**2*(-K*b1 + 2*g2) - 7*f*r*(K*b1*bd1*(1 - 2*r) + 2*b1*gd2*r + 2*bd1*g2*(r - 1))) - Dd*f*(4*r - 1)*(-K*b1 + 2*g2)*(7*b1*r + f*(6*r - 3)))/(105*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*k1**2*(7*K*b1**2*(D1*fd*(2*r - 1) + Dd*f*(4*r - 1)) + b1*(D1*(7*f*r*(K*bd1 + bd2*r - 2*gd2) + fd*(2*r - 1)*(6*K*f*r - 3*K*f - 14*g2)) + Dd*f*(4*r - 1)*(3*K*f*(2*r - 1) - 14*g2)) + b2*(D1*(7*b1*fd*r**2 + 7*bd1*f*r*(r - 1) + 3*f*fd*(1 - 2*r)**2) + Dd*f*(4*r - 1)*(7*b1*r + f*(6*r - 3))) - 3*f*(2*r - 1)*(-D1*f*r*(K*bd1 + bd2 - 2*gd2) + 2*D1*fd*g2*(2*r - 1) + 2*Dd*f*g2*(4*r - 1)))/(105*d**2*k3**2) - 2*D1**3*Pk3*Pkdd1*k1**2*st**2*(D1*(231*b1*fd*k2**2*r**2*(K*b1 - 2*g2) + f**3*k2**2*(33*bd1*r*(2*r - 3) - 5*fd*(20*r**2 - 21*r + 4)) - 11*f**2*(3*bd1*r*(k1**2*(2*C - 1)*(r - 1) + k2**2*(K*(r - 4) + b1*(3 - 6*r))) + fd*(-3*b1*k2**2*(6*r**2 - 15*r + 4) + k1**2*(2*C - 1)*(9*r**2 - 15*r + 4)) - 6*gd2*k2**2*r*(r - 4)) + 33*f*(fd*(K*b1*k2**2*(-2*r**2 + 9*r - 4) + 2*b1*r**2*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(2*r**2 - 9*r + 4)) - 7*k2**2*r*(K*b1*bd1*(1 - 2*r) + 2*b1*gd2*r + 2*bd1*g2*(r - 1)))) - Dd*f*(4*r - 1)*(-231*b1*k2**2*r*(K*b1 - 2*g2) + 5*f**3*k2**2*(5*r - 4) + 11*f**2*(-6*b1*k2**2*(r - 2) + k1**2*(2*C - 1)*(3*r - 4)) - 33*f*(-K*b1*k2**2*(r - 4) + b1*r*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(r - 4))))/(3465*d**2*k3**4) - D1**3*Pk3*Pkdd1*st**2*(4*C - 2)*(D1*bd1*f**2*r*(r - 4) - 7*b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(D1*(2*r - 1)*(-7*bd1*r + fd*(r - 4)) + Dd*f*(4*r**2 - 17*r + 4)))/(105*d**2) - 4*D1**3*Pk3*Pkdd1*(r - 1)*(D1*bd1*f*r*(b2 - 2*g2) + K*b1**2*(D1*fd*(r - 1) + Dd*f*(4*r - 1)) + b1*(D1*b2*fd*(r - 1) + D1*f*r*(2*K*bd1 + bd2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + Dd*b2*f*(4*r - 1) + 2*Dd*f*g2*(1 - 4*r)))/(15*d**2) + 2*D1**3*Pk3*Pkdd1*st**2*(21*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*(D1*(f*k2**2*(7*bd1*r*(3*r - 1) + fd*(4*r**2 + 9*r - 4)) + 7*fd*r**2*(K*k2**2 + k1**2*(1 - 2*C))) + Dd*f*(4*r - 1)*(2*f*k2**2*(r + 2) + r*(-14*C*k1**2 + 7*K*k2**2 + 7*k1**2))) + 3*b1*(D1*(f**2*k2**2*(bd1*r*(4*r + 5) + fd*(9*r**2 - 15*r + 4)) + f*(K*fd*k2**2*(-2*r**2 + 9*r - 4) - 7*bd1*r*(2*r - 1)*(-K*k2**2 + k1**2*(2*C - 1)) - fd*k1**2*(2*C - 1)*(9*r - 4) + k2**2*r**2*(7*bd2 - 14*gd2)) + 7*fd*k2**2*r**2*(b2 - 2*g2)) + Dd*f*(4*r - 1)*(-K*f*k2**2*(r - 4) + f**2*k2**2*(3*r - 4) + f*k1**2*(4 - 8*C) + k2**2*r*(7*b2 - 14*g2))) + f*(D1*(3*bd1*f**2*k2**2*r*(3*r - 4) + f*(-fd*k1**2*(2*C - 1)*(9*r**2 - 15*r + 4) + r*(-3*K*bd1*k2**2*(r - 4) - 3*bd1*k1**2*(6*C - 3) - 3*k2**2*(bd2 - 2*gd2)*(r - 4))) - k2**2*(3*b2 - 6*g2)*(-7*bd1*r*(r - 1) + fd*(2*r**2 - 9*r + 4))) - Dd*f*(4*r - 1)*(f*k1**2*(2*C - 1)*(3*r - 4) + k2**2*(3*b2 - 6*g2)*(r - 4))))/(315*d**2*k3**2) - D1**3*Pkd1*Pkd3*ct**7*f*k2**5*(4*C - 4)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(6*r + 6*s - 1) + Dd*f*(24*r**2 + 24*r*s - 6*r - 4*s - 1)))/(315*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**6*f*k2**4*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(6*r + 6*s - 1) + Dd*f*(24*r**2 + 24*r*s - 6*r - 4*s - 1)))/(315*d**2*k1*k3**3) - D1**3*Pkd1*Pkd3*ct**6*f*k2**4*(11*D1*bd1*f*(5*f*k2**2*(21*r**2 + r*(21*s - 40) - 33*s + 19) + 18*k1**2*(2*C*(9*r**2 + 9*r*(s - 3) - 29*s + 18) - 12*r**2 - 12*r*s + 43*r + 48*s - 31)) + 11*b1*(3*D1*fd*r*(5*f*k2**2*(21*r + 21*s - 11) + 12*k1**2*(2*C*(9*r + 9*s - 8) - 12*r - 12*s + 13)) + Dd*f*(5*f*k2**2*(84*r**2 + r*(84*s - 73) - 33*s + 19) + 18*k1**2*(C*(72*r**2 + 72*r*s - 82*r - 58*s + 36) - 48*r**2 - 48*r*s + 64*r + 48*s - 31))) + 5*f*(D1*fd*(7*f*k2**2*(4*r - 1)*(23*r + 23*s - 9) + 22*k1**2*(3*r - 1)*(C*(6*r + 6*s + 8) - 9)) + Dd*f*(7*f*k2**2*(4*r - 1)*(23*r + 23*s - 9) + 22*k1**2*(2*C*(12*r**2 + 12*r*s + 33*r + 7*s - 14) - 72*r - 18*s + 27))))/(3465*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*ct**5*f*k2**5*st**2*(8*C - 8)*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(72*r**2 + 72*r*s - 9*r + 12*s - 17) + Dd*f*(96*r**2 + 96*r*s + 12*r + 32*s - 37)))/(315*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**5*k2**3*(42*b1**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 3*b1*f*(14*D1*bd1*(C - 1)*(2*r**2 + r*(2*s - 7) - 3*s + 3) - 6*D1*fd*(C*(14*r**2 + 14*r*s - 9*r - s + 1) - 5*r**2 - 5*r*s + 8*r + s - 1) + 3*Dd*f*(-2*C*(28*r**2 + 28*r*s - 23*r - 15*s + 8) + 20*r**2 + 20*r*s - 33*r - 29*s + 19)) - f**2*(9*D1*bd1*(2*C*(7*r**2 + 7*r*s - 10*r - 12*s + 5) - 5*r**2 - 5*r*s + 14*r + 23*s - 13) + 5*D1*fd*(3*r - 1)*(2*C*(6*r + 6*s - 1) + 3*r + 3*s - 5) + 5*Dd*f*(2*C*(24*r**2 + 24*r*s - 6*r - 4*s - 1) + 12*r**2 + 12*r*s - 39*r - 11*s + 13)))/(315*d**2*k3**3) + 2*D1**3*Pkd1*Pkd3*ct**5*k2**3*(11*D1*bd1*f*(5*f**2*k2**2*(29*r + 32*s - 22) + 9*f*(k1**2*(2*C*(17*r**2 + r*(17*s + 5) + 23*s - 22) - 37*r**2 + r*(6 - 37*s) - 27*s + 31) + k2**2*(14*C*(r - 1)*(2*r + 2*s - 1) + K*r**2 + K*r*s - 8*K*r - 2*K*s + 2*K + b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) - 29*r**2 - 29*r*s + 50*r + 30*s - 16)) - 21*k2**2*(b1*(K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) + 33*b1**2*k2**2*(D1*fd*r*(18*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(3*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5) - (7*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 11*b1*(D1*(5*f**2*fd*k2**2*(3*r - 6*s + 1) + 3*f*(6*fd*k1**2*r*(C*(34*r + 34*s + 4) - 37*r - 37*s + 1) + 3*fd*k2**2*(K*(2*r - 1)*(r + s - 4) + r**2*(56*C - 58) + r*(56*C*s - 28*C - 58*s + 37) + s - 4) + 14*gd2*k2**2*r*(r + s + 2)) + 42*fd*g2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(32*r + 26*s - 21) + 9*f*(k1**2*(2*C*(68*r**2 + r*(68*s - 9) + 23*s - 22) - 148*r**2 + r*(41 - 148*s) - 27*s + 31) + k2**2*(14*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s - 25*r - 5*s + 8) - 116*r**2 - 116*r*s + 109*r + 33*s - 22)) + 42*g2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) - f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(r + s + 2) - 55*f*fd*(3*r - 1)*(k1**2*(26*C*(3*r + 3*s - 2) - 75*r - 75*s + 47) + k2**2*(18*C - 18)*(2*r + 2*s - 1)) + 198*f*gd2*k2**2*(r**2 + r*(s - 8) - 2*s + 2) + 198*fd*g2*k2**2*(2*r - 1)*(r + s - 4)) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(r + s + 2) - 55*f*(k1**2*(2*C*(156*r**2 + 3*r*(52*s - 61) - 59*s + 46) - 300*r**2 + r*(327 - 300*s) + 107*s - 79) + k2**2*(18*C - 18)*(4*r - 1)*(2*r + 2*s - 1)) + 198*g2*k2**2*(4*r**2 + r*(4*s - 25) - 5*s + 8))))/(3465*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**4*f*k2**4*st**2*(9*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 9*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(72*r**2 + 72*r*s - 9*r + 12*s - 17) + Dd*f*(96*r**2 + 96*r*s + 12*r + 32*s - 37)))/(315*d**2*k1*k3**3) + D1**3*Pkd1*Pkd3*ct**4*f*k2**4*st**2*(-33*D1*bd1*f*(5*f*k2**2*(15*r**2 + r*(15*s - 29) - 24*s + 14) + 12*k1**2*(C*(26*r**2 + 26*r*s - 57*r - 55*s + 31) - 20*r**2 - 20*r*s + 46*r + 45*s - 26)) - 33*b1*(3*D1*fd*r*(5*f*k2**2*(15*r + 15*s - 8) + 4*k1**2*(C*(52*r + 52*s - 33) - 40*r - 40*s + 27)) + Dd*f*(5*f*k2**2*(60*r**2 + r*(60*s - 53) - 24*s + 14) + 12*k1**2*(C*(104*r**2 + 104*r*s - 92*r - 55*s + 31) - 80*r**2 - 80*r*s + 74*r + 45*s - 26))) + f*(D1*fd*(-25*f*k2**2*(244*r**2 + r*(244*s - 123) - 6*s - 12) - 44*k1**2*(C*(288*r**2 + 18*r*(16*s + 7) + 183*s - 167) - 216*r**2 - 27*r*(8*s + 5) - 171*s + 150)) + Dd*f*(-25*f*k2**2*(244*r**2 + r*(244*s - 123) - 6*s - 12) - 44*k1**2*(C*(384*r**2 + 6*r*(64*s + 53) + 335*s - 319) - 288*r**2 - 18*r*(16*s + 17) - 303*s + 282))))/(3465*d**2*k1*k3**5) + 2*D1**3*Pkd1*Pkd3*ct**4*k2**2*(3*D1*bd1*f**2*(r**2 + r*s + r - 2*s) - 7*b1**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s - 9*r - 3*s + 3)) + b1*f*(-7*D1*bd1*(2*r**2 + r*(2*s - 7) - 3*s + 3) + 3*D1*fd*(2*r - 1)*(r + s - 1) + 3*Dd*f*(4*r**2 + 4*r*s - 5*r - 5*s + 3)))/(105*d**2*k1*k3) + 2*D1**3*Pkd1*Pkd3*ct**4*k2**2*(-3*b1**2*(D1*fd*r*(k1**2*(35 - 28*C)*(r + s - 1) + k2**2*(6*f*(5*r + 5*s - 2) + 7*r + 7*s)) + Dd*f*(-7*k1**2*(4*C*(4*r**2 + 4*r*s + r + 2*s - 2) - 20*r**2 - 20*r*s + 5*r - 5*s + 5) + k2**2*(3*f*(20*r**2 + 20*r*s - 21*r - 13*s + 8) + 28*r**2 + 28*r*s + 21*r - 21*s))) + b1*f*(3*D1*bd1*(7*k1**2*(4*C*(2*r**2 + 2*r*s + 3*r + 2*s - 2) - 10*r**2 - 10*r*s - 5*r - 5*s + 5) - k2**2*(3*f*(10*r**2 + 10*r*s - 17*r - 13*s + 8) + 14*r**2 + 14*r*s + 7*r - 21*s)) + D1*fd*(9*k1**2*(4*C*(7*r**2 + 7*r*s - 17*r - 5*s + 5) + 2*r**2 + 2*r*s + 51*r + 19*s - 19) + k2**2*(-5*f*(3*r - 1)*(3*r + 3*s + 2) + 270*r**2 + 270*r*s - 207*r - 9*s + 36)) + Dd*f*(9*k1**2*(2*C*(28*r**2 + 28*r*s - 55*r - 31*s + 24) + 4*r**2 + 4*r*s + 63*r + 43*s - 38) - k2**2*(5*f*(12*r**2 + 12*r*s + 5*r + s - 4) - 540*r**2 - 540*r*s + 603*r + 171*s - 135))) + f**2*(D1*bd1*(9*k1**2*(2*C*(7*r**2 + r*(7*s - 9) - 15*s + 8) + r**2 + r*(s - 2) + 14*s - 9) - k2**2*(5*f*(3*r**2 + r*(3*s + 2) + 4*s - 2) - 135*r**2 - 9*r*(15*s - 29) + 144*s - 81)) - 15*D1*fd*(3*r - 1)*(k1**2*(C*(6*r + 6*s - 4) - 12*r - 12*s + 7) - 3*k2**2*(2*r + 2*s - 1)) - 15*Dd*f*(k1**2*(2*C*(12*r**2 + 3*r*(4*s - 5) - 5*s + 4) - 48*r**2 - 48*r*(s - 1) + 16*s - 11) - 3*k2**2*(4*r - 1)*(2*r + 2*s - 1))))/(315*d**2*k1*k3**3) + D1**3*Pkd1*Pkd3*ct**4*k2**2*(11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(48*r**2 + r*(48*s + 3) + 25*s - 31) + 9*k2**2*(r - 1)*(5*r + 5*s - 3)) + 9*f*k1**2*(2*k1**2*(2*C*(45*r**2 + r*(45*s - 37) - 5*s - 8) - 70*r**2 + r*(63 - 70*s) + 14*s + 7) - k2**2*(-28*C*(r - 1)*(7*r + 7*s - 4) - 2*K*(19*r**2 + 19*r*s - 40*r - 10*s + 10) + b1*(2*r**2 + r*(2*s + 5) + 31*s - 19) + 204*r**2 + 204*r*s - 330*r - 184*s + 114)) + 42*k1**2*k2**2*(b1*(r**2*(10*K - 12) + r*(5*K*(2*s - 3) - 12*s + 14) + s*(5*K - 2)) - 10*g2*(r**2 + r*(s - 1) + s))) - 33*b1**2*k1**2*k2**2*(2*D1*fd*r*(3*f*(r + s + 3) + (42 - 35*K)*(r + s)) + Dd*f*(3*f*(4*r**2 + r*(4*s + 11) + 31*s - 19) - 14*r**2*(20*K - 24) - 14*r*(5*K*(4*s - 5) - 24*s + 22) - 14*s*(5*K - 2))) + 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(144*r**2 + 9*r*(16*s - 3) + 15*s - 19) + 27*k2**2*r*(5*r + 5*s - 3)) + 6*f*k1**2*(6*fd*k1**2*r*(6*C*(15*r + 15*s - 4) - 70*r - 70*s + 21) + 3*fd*k2**2*(K*(2*r - 1)*(19*r + 19*s - 20) + r**2*(196*C - 204) + 4*r*(7*C*(7*s - 4) - 51*s + 37) + 18*s - 16) - 70*gd2*k2**2*r*(r + s - 2)) - 420*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(2*k1**2*(96*r**2 + 96*r*s - 12*r + 20*s - 25) + 9*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 18*f*k1**2*(k1**2*(2*C*(180*r**2 + 3*r*(60*s - 31) - 5*s - 8) - 280*r**2 + 7*r*(22 - 40*s) + 14*s + 7) + k2**2*(14*C*(4*r - 1)*(7*r + 7*s - 4) + K*(76*r**2 + 76*r*s - 139*r - 39*s + 40) - 408*r**2 - 408*r*s + 394*r + 118*s - 81)) - 420*g2*k1**2*k2**2*(4*r**2 + r*(4*s - 5) + s))) + f*(D1*(35*f**2*fd*k2**2*(4*r - 1)*(k1**2*(93*r + 93*s - 67) + 11*k2**2*(5*r + 5*s - 3)) + 22*f*k1**2*(5*fd*(3*r - 1)*(k1**2*(2*C*(75*r + 75*s - 44) - 114*r - 114*s + 67) + 9*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 18*gd2*k2**2*(19*r**2 + 19*r*s - 40*r - 10*s + 10)) - 396*fd*g2*k1**2*k2**2*(2*r - 1)*(19*r + 19*s - 20)) + Dd*f*(35*f**2*k2**2*(4*r - 1)*(k1**2*(93*r + 93*s - 67) + 11*k2**2*(5*r + 5*s - 3)) + 110*f*k1**2*(k1**2*(2*C*(300*r**2 + 300*r*s - 291*r - 95*s + 64) - 456*r**2 - 456*r*s + 438*r + 142*s - 95) + 9*k2**2*(4*r - 1)*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 396*g2*k1**2*k2**2*(76*r**2 + r*(76*s - 139) - 39*s + 40))))/(3465*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*ct**3*f*k2**5*st**4*(4*C - 4)*(3*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 3*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13) + Dd*f*(24*r**2 + 6*r*(4*s + 3) + 28*s - 23)))/(105*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**3*k2**3*st**2*(42*b1**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 3*b1*f*(14*D1*bd1*(C - 1)*(2*r**2 + r*(2*s - 7) - 3*s + 3) + D1*fd*(-2*C*(70*r**2 + 70*r*s - 47*r - 13*s + 13) + 80*r**2 + 80*r*s - 85*r - 26*s + 26) + Dd*f*(-2*C*(140*r**2 + 140*r*s - 131*r - 97*s + 55) + 160*r**2 + 160*r*s - 214*r - 179*s + 113)) + f**2*(-3*D1*bd1*(2*C*(35*r**2 + r*(35*s - 67) - 72*s + 30) - 40*r**2 + r*(107 - 40*s) + 129*s - 63) + D1*fd*(-4*C*(72*r**2 + 9*r*(8*s - 1) + 12*s - 17) + 144*r**2 + 144*r*(s + 1) + 159*s - 133) + Dd*f*(-4*C*(96*r**2 + 12*r*(8*s + 1) + 32*s - 37) + 192*r**2 + 6*r*(32*s + 49) + 271*s - 245)))/(315*d**2*k3**3) - 2*D1**3*Pkd1*Pkd3*ct**3*k2**3*st**2*(11*D1*bd1*f*(2*f**2*k2**2*(18*r**2 + 2*r*(9*s - 73) - 149*s + 103) + 3*f*(k1**2*(C*(74*r**2 + r*(74*s - 292) - 310*s + 218) - 32*r**2 - 32*r*s + 187*r + 205*s - 155) + k2**2*(-42*C*(r - 1)*(2*r + 2*s - 1) + K*r**2 + K*r*s + 20*K*r + 12*K*s - 12*K - 6*b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) + 83*r**2 + 83*r*s - 146*r - 96*s + 54)) + 21*k2**2*(b1*(K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) - 33*b1**2*k2**2*(D1*fd*r*(36*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(6*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5) - (7*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 11*b1*(D1*(2*f**2*fd*k2**2*(54*r**2 + 6*r*(9*s - 11) - 12*s + 17) + 3*f*(fd*k1**2*r*(4*C*(37*r + 37*s - 50) - 64*r - 64*s + 137) + fd*k2**2*(K*(2*r**2 + r*(2*s + 19) + 13*s - 10) - r**2*(168*C - 166) + r*(-168*C*s + 84*C + 166*s - 103) - 13*s + 10) - 14*gd2*k2**2*r*(r + s + 2)) - 42*fd*g2*k2**2*r*(r + s)) + Dd*f*(2*f**2*k2**2*(72*r**2 + 4*r*(18*s - 53) - 161*s + 120) + 3*f*(k1**2*(C*(296*r**2 + r*(296*s - 474) - 310*s + 218) - 128*r**2 - 128*r*s + 306*r + 205*s - 155) + k2**2*(-42*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + 332*r**2 + 332*r*s - 311*r - 121*s + 76)) - 42*g2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(10*f**2*fd*k2**2*(256*r**2 + 256*r*s + 30*r + 123*s - 117) + 11*f*(fd*(k1**2*(2*C*(63*r**2 + 9*r*(7*s + 50) + 393*s - 295) + 18*r**2 + 18*r*(s - 42) - 627*s + 457) + k2**2*(54 - 54*C)*(3*r - 1)*(2*r + 2*s - 1)) - 6*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) - 66*fd*g2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(10*f**2*k2**2*(256*r**2 + 256*r*s + 30*r + 123*s - 117) + 11*f*(k1**2*(2*C*(84*r**2 + r*(84*s + 771) + 613*s - 515) + 24*r**2 + 24*r*(s - 52) - 955*s + 785) + k2**2*(54 - 54*C)*(4*r - 1)*(2*r + 2*s - 1)) - 66*g2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**5) + 2*D1**3*Pkd1*Pkd3*ct**3*k2*(-3*D1*bd1*f**2*(r**2*(2*C - 9) + r*(2*C*(s + 1) - 9*s + 5) - s*(4*C - 4)) + 7*b1**2*(D1*fd*r*(2*C + 3)*(r + s - 1) + Dd*f*(2*C*(4*r**2 + 4*r*s - 9*r - 3*s + 3) + 12*r**2 + 12*r*s - 7*r + s - 1)) + b1*f*(7*D1*bd1*(2*C*(2*r**2 + 2*r*s - 7*r - 3*s + 3) + 6*r**2 + 6*r*s - r + s - 1) - 3*D1*fd*(2*C - 9)*(2*r - 1)*(r + s - 1) - 3*Dd*f*(2*C*(4*r**2 + 4*r*s - 5*r - 5*s + 3) - 36*r**2 - 36*r*s + 45*r + 17*s - 13)))/(105*d**2*k3) + 2*D1**3*Pkd1*Pkd3*ct**3*k2*(21*b1**3*k2**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 3*b1**2*(7*D1*bd1*f*k2**2*(3*r**2 + r*(3*s - 8) - 3*s + 3) + D1*fd*(k1**2*r*(98*C - 77)*(r + s - 1) + k2**2*(7*K*(5*r**2 + r*(5*s - 8) - 4*s + 4) + 3*f*(36*r**2 + r*(36*s - 25) + s - 1) + 7*r**2*(10*C - 7) + 7*r*(10*C*(s - 1) - 7*s + 18) + 28*s - 28)) + 7*Dd*f*k1**2*(C*(56*r**2 + r*(56*s - 46) - 2*s + 2) - 44*r**2 - 44*r*s + 39*r + 3*s - 3) + Dd*f*k2**2*(70*C*(4*r - 1)*(r + s - 1) + 7*K*(20*r**2 + 20*r*s - 21*r - 13*s + 8) + 9*f*(24*r**2 + 6*r*(4*s - 3) + 2*s - 1) - 196*r**2 - 196*r*s + 385*r + 133*s - 126)) + b1*(3*D1*bd1*f*(7*k1**2*(2*C*(14*r**2 + r*(14*s - 9) - s + 1) - 22*r**2 - 22*r*s + 17*r + 3*s - 3) + k2**2*(70*C*(2*r - 1)*(r + s - 1) + 7*K*(10*r**2 + 10*r*s - 9*r - 7*s + 2) + 3*f*(36*r**2 + r*(36*s - 29) + 5*s - 2) - 98*r**2 - 98*r*s + 189*r + 91*s - 84)) + 3*D1*(5*f**2*fd*k2**2*(3*r - 1)*(11*r + 11*s - 10) - 3*f*fd*(k1**2*(82*C*r + 34*C*(s - 1) - 57*r - 25*s + 25) + k2**2*(14*C*(2*r**2 + 2*r*s + r + s - 1) + K*(2*r - 1)*(r + s - 4) - 76*r**2 - 76*r*s + 41*r + 3*s + 2)) + 7*f*k2**2*(bd2*r*(r + s + 2) - 2*gd2*(5*r**2 + r*(5*s - 4) - 2*s + 2)) + 7*fd*k2**2*(b2*r*(r + s) - 2*g2*(5*r**2 + r*(5*s - 8) - 4*s + 4))) + Dd*f*(5*f**2*k2**2*(132*r**2 + r*(132*s - 157) - 43*s + 36) - 9*f*(k1**2*(48*C - 32)*(2*r + s - 1) + k2**2*(-14*C*s + K*(4*r**2 + r*(4*s - 25) - 5*s + 8) + r**2*(56*C - 152) + 2*r*(28*C*s - 7*C - 76*s + 69) + 50*s - 31)) + 21*k2**2*(b2*(4*r**2 + r*(4*s + 3) - 3*s) - 2*g2*(20*r**2 + r*(20*s - 21) - 13*s + 8)))) + f*(D1*bd1*(5*f**2*k2**2*(33*r**2 + r*(33*s - 34) - 10*s + 6) + 9*f*(k1**2*(2*C*(5*r - s + 1) - 9*r - s + 1) - k2**2*(14*C*(r**2 + r*(s - 2) - 2*s + 1) + K*(r**2 + r*(s - 8) - 2*s + 2) - 38*r**2 - 38*r*s + 66*r + 41*s - 27)) + 21*k2**2*(b2*(r**2 + r*(s - 1) - 3*s) - 10*g2*(r - 1)*(r + s))) + D1*(-5*f*fd*(3*r - 1)*(k1**2*(6*C*(9*r + 9*s - 5) - 39*r - 39*s + 23) + 9*k2**2*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3)) - 9*f*k2**2*(bd2 - 2*gd2)*(r**2 + r*(s - 8) - 2*s + 2) - 9*fd*k2**2*(b2 - 2*g2)*(2*r - 1)*(r + s - 4)) + Dd*f*(-5*f*(k1**2*(6*C*(36*r**2 + 36*r*s - 33*r - 11*s + 7) - 156*r**2 - 156*r*s + 147*r + 47*s - 31) + 9*k2**2*(4*r - 1)*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3)) + k2**2*(-9*b2 + 18*g2)*(4*r**2 + r*(4*s - 25) - 5*s + 8))))/(315*d**2*k3**3) - 2*D1**3*Pkd1*Pkd3*ct**3*k2*(11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(6*r**2 + r*(6*s - 8) + 3*s + 5) - 9*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 9*f*(k1**4*(C*(66*r**2 + r*(66*s - 72) - 26*s + 6) - 41*r**2 + r*(46 - 41*s) + 17*s - 5) + k1**2*k2**2*(42*C*(r - 1)*(3*r + 3*s - 2) + 59*K*r**2 + 59*K*r*s - 80*K*r - 20*K*s + 20*K + b1*(-54*r**2 + r*(47 - 54*s) + 3*s + 2) - 132*r**2 - 132*r*s + 202*r + 103*s - 75) - 7*k2**4*(b1*(2*r - 1)*(2*r + 2*s - 1) - r*(K - 1)*(r + s))) - 21*k2**2*(b1*(k1**2*(r**2*(50*K - 38) + r*(5*K*(10*s - 9) - 38*s + 31) + s*(7 - 5*K)) + k2**2*(5*K - 5)*(r + s)*(2*r - 1)) - 10*g2*(k1**2*(5*r**2 + 5*r*(s - 1) - s) + k2**2*(r - 1)*(r + s)))) + 33*b1**2*k2**2*(D1*fd*r*(6*f*(k1**2*(27*r + 27*s - 10) + 7*k2**2*(2*r + 2*s - 1)) + (r + s)*(-7*k1**2*(25*K - 19) - 7*k2**2*(5*K - 5))) + Dd*f*(3*f*(k1**2*(108*r**2 + 108*r*s - 67*r - 3*s - 2) + 7*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 7*k1**2*(r**2*(100*K - 76) + r*(100*K*s - 65*K - 76*s + 43) + s*(7 - 5*K)) - 7*k2**2*(5*K - 5)*(r + s)*(4*r - 1))) + 11*b1*(3*D1*(5*f**2*fd*k2**2*(k1**2*(6*r**2 + r*(6*s - 22) - 15*s + 10) - 3*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) + f*(-3*fd*(2*k1**4*r*(C*(66*r + 66*s - 26) - 41*r - 41*s + 17) + k1**2*k2**2*(K*(2*r - 1)*(59*r + 59*s - 40) + r**2*(252*C - 264) + r*(84*C*(3*s - 2) - 264*s + 215) + 41*s - 24) + k2**4*(7*K - 7)*(r + s)*(2*r - 1)) + 70*gd2*k2**2*r*(k1**2*(5*r + 5*s - 4) + k2**2*(r + s))) + 70*fd*g2*k2**2*r*(5*k1**2 + k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(k1**2*(24*r**2 + r*(24*s - 74) - 42*s + 35) - 9*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 9*f*(k1**4*(2*C*(132*r**2 + r*(132*s - 85) - 13*s + 3) - 164*r**2 + r*(109 - 164*s) + 17*s - 5) + k1**2*k2**2*(42*C*(4*r - 1)*(3*r + 3*s - 2) + K*(236*r**2 + r*(236*s - 299) - 99*s + 80) - 528*r**2 - 528*r*(s - 1) + 156*s - 111) + k2**4*(7*K - 7)*(r + s)*(4*r - 1)) + 210*g2*k2**2*(k1**2*(20*r**2 + r*(20*s - 13) - s) + k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(k1**2*(53*r + 53*s - 37) + 22*k2**2*(3*r + 3*s - 2)) - 55*f*fd*k1**2*(3*r - 1)*(k1**2*(2*C*(51*r + 51*s - 31) - 63*r - 63*s + 39) + 9*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*f*gd2*k2**2*(k1**2*(59*r**2 + 59*r*s - 80*r - 20*s + 20) + 7*k2**2*r*(r + s)) + 198*fd*g2*k2**2*(2*r - 1)*(k1**2*(59*r + 59*s - 40) + 7*k2**2*(r + s))) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(k1**2*(53*r + 53*s - 37) + 22*k2**2*(3*r + 3*s - 2)) - 55*f*k1**2*(k1**2*(2*C*(204*r**2 + 3*r*(68*s - 65) - 61*s + 41) - 252*r**2 - 3*r*(84*s - 81) + 75*s - 51) + 9*k2**2*(4*r - 1)*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 198*g2*k2**2*(k1**2*(236*r**2 + r*(236*s - 299) - 99*s + 80) + 7*k2**2*(r + s)*(4*r - 1)))))/(3465*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**2*f*k2**4*st**4*(3*D1*bd1*f*(6*r**2 + r*(6*s - 11) - 10*s + 5) + 3*b1*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + f*(D1*fd*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13) + Dd*f*(24*r**2 + 6*r*(4*s + 3) + 28*s - 23)))/(105*d**2*k1*k3**3) - D1**3*Pkd1*Pkd3*ct**2*f*k2**4*st**4*(33*D1*bd1*f*(5*f*k2**2*(3*r**2 + 3*r*(s - 2) - 5*s + 3) + 2*k1**2*(C*(34*r**2 + 34*r*s - 60*r - 52*s + 26) - 28*r**2 - 28*r*s + 49*r + 42*s - 21)) + 33*b1*(D1*fd*r*(5*f*k2**2*(9*r + 9*s - 5) + k1**2*(68*C - 56)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2*(12*r**2 + r*(12*s - 11) - 5*s + 3) + 2*k1**2*(2*C*(68*r**2 + 17*r*(4*s - 3) - 26*s + 13) - 112*r**2 - 28*r*(4*s - 3) + 42*s - 21))) + f*(D1*fd*(5*f*k2**2*(212*r**2 + r*(212*s - 69) + 57*s - 51) + 22*k1**2*(C*(90*r**2 + 18*r*(5*s + 3) + 96*s - 70) - 72*r**2 - 9*r*(8*s + 5) - 78*s + 57)) + Dd*f*(5*f*k2**2*(212*r**2 + r*(212*s - 69) + 57*s - 51) + 22*k1**2*(2*C*(60*r**2 + r*(60*s + 51) + 74*s - 61) - 96*r**2 - 12*r*(8*s + 7) - 120*s + 99))))/(1155*d**2*k1*k3**5) + D1**3*Pkd1*Pkd3*ct**2*k1*(-11*D1*bd1*f*(5*f**2*k2**2*(k1**2*(63*r**2 + r*(63*s - 55) - 4*s + 8) + 9*k2**2*(11*r + 9*s - 7)) - 9*f*(k1**4*(8*C - 4)*(4*r**2 + r*(4*s - 5) - 2*s + 1) + k1**2*k2**2*(28*C*(r - 1)*(5*r + 5*s - 4) + 2*K*(73*r**2 + 73*r*s - 80*r - 20*s + 20) + b1*(-114*r**2 + r*(107 - 114*s) + 25*s - 9) - 148*r**2 - 148*r*s + 218*r + 100*s - 86) - 7*k2**4*(b1*(2*r - 1)*(9*r + 9*s - 5) + r*(4 - 6*K)*(r + s))) - 42*k2**2*(b1*(k1**2*(r**2*(70*K - 32) + r*(K*(70*s - 55) - 32*s + 24) + s*(8 - 15*K)) + k2**2*(15*K - 10)*(r + s)*(2*r - 1)) - 10*g2*(k1**2*(7*r**2 + 7*r*(s - 1) - 3*s) + 3*k2**2*(r - 1)*(r + s)))) - 33*b1**2*k2**2*(2*D1*fd*r*(3*f*(k1**2*(57*r + 57*s - 25) + 7*k2**2*(9*r + 9*s - 5)) + (r + s)*(-7*k1**2*(35*K - 16) - 7*k2**2*(15*K - 10))) + Dd*f*(3*f*(k1**2*(228*r**2 + 228*r*s - 157*r - 25*s + 9) + 7*k2**2*(4*r - 1)*(9*r + 9*s - 5)) - 14*k1**2*(r**2*(140*K - 64) + r*(140*K*s - 75*K - 64*s + 32) + s*(8 - 15*K)) - 14*k2**2*(15*K - 10)*(r + s)*(4*r - 1))) - 11*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(189*r**2 + 3*r*(63*s - 68) - 87*s + 55) - 9*k2**2*(3*r + 9*s - 5)) - 6*f*(3*fd*(k1**4*r*(16*C - 8)*(2*r + 2*s - 1) + k1**2*k2**2*(K*(2*r - 1)*(73*r + 73*s - 40) + 2*r**2*(70*C - 74) + 2*r*(70*C*s - 56*C - 74*s + 67) + 32*s - 16) + k2**4*(21*K - 14)*(r + s)*(2*r - 1)) - 70*gd2*k2**2*r*(k1**2*(7*r + 7*s - 4) + 3*k2**2*(r + s))) + 420*fd*g2*k2**2*r*(7*k1**2 + 3*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(7*k1**2*(36*r**2 + r*(36*s - 37) - 13*s + 9) + 18*k2**2*(4*r - 1)) - 18*f*(k1**4*(4*C - 2)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + k1**2*k2**2*(14*C*(4*r - 1)*(5*r + 5*s - 4) + K*(292*r**2 + 292*r*s - 313*r - 113*s + 80) - 296*r**2 - 296*r*s + 310*r + 90*s - 67) + k2**4*(21*K - 14)*(r + s)*(4*r - 1)) + 420*g2*k2**2*(k1**2*(28*r**2 + r*(28*s - 15) - 3*s) + 3*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(35*f**2*fd*k2**2*(4*r - 1)*(8*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) + 22*f*(5*fd*k1**2*(3*r - 1)*(k1**2*(8*C - 4)*(3*r + 3*s - 2) + 9*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 18*gd2*k2**2*(k1**2*(73*r**2 + 73*r*s - 80*r - 20*s + 20) + 21*k2**2*r*(r + s))) - 396*fd*g2*k2**2*(2*r - 1)*(k1**2*(73*r + 73*s - 40) + 21*k2**2*(r + s))) + Dd*f*(35*f**2*k2**2*(4*r - 1)*(8*k1**2*(4*r + 4*s - 3) + 11*k2**2*(9*r + 9*s - 7)) + 110*f*k1**2*(k1**2*(4*C - 2)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 396*g2*k2**2*(k1**2*(292*r**2 + r*(292*s - 313) - 113*s + 80) + 21*k2**2*(r + s)*(4*r - 1)))))/(3465*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(D1*bd1*f**2*(r**2 + r*s + r + 12*s) + 7*b1**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + b1*f*(7*D1*bd1*(2*r**2 + r*(2*s - 7) - 3*s + 3) + D1*fd*(2*r + 13)*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s + 23*r + 37*s - 25)))/(105*d**2*k1*k3) + D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(-b1**2*(D1*fd*r*(k1**2*(112*C - 98)*(r + s - 1) + k2**2*(f*(72*r + 72*s - 33) + 14*r + 14*s)) + 2*Dd*f*(7*k1**2*(2*C*(16*r**2 + 16*r*s - 26*r - 7*s + 7) - 28*r**2 - 28*r*s + 43*r + 11*s - 11) + k2**2*(f*(72*r**2 + 72*r*s - 84*r - 51*s + 33) + 28*r**2 + 28*r*s + 21*r - 21*s))) + b1*f*(-D1*bd1*(14*k1**2*(2*C*(8*r**2 + 8*r*s - 18*r - 7*s + 7) - 14*r**2 - 14*r*s + 29*r + 11*s - 11) + k2**2*(3*f*(24*r**2 + 24*r*s - 45*r - 34*s + 22) + 28*r**2 + 28*r*s + 14*r - 42*s)) + D1*fd*(2*k1**2*(2*C*(12*r**2 + 12*r*s - 62*r - 35*s + 35) + 8*r**2 + 8*r*(s + 12) + 57*s - 57) + k2**2*(f*(-72*r**2 + r*(3 - 72*s) - 30*s + 34) + 164*r**2 + 2*r*(82*s - 61) - 26*s + 20)) + 2*Dd*f*(k1**2*(4*C*(12*r**2 + 12*r*s - 65*r - 68*s + 48) + 16*r**2 + 16*r*s + 186*r + 195*s - 147) - k2**2*(f*(48*r**2 + 48*r*s + 2*r + 31*s - 25) - 164*r**2 - 164*r*s + 185*r + 79*s - 55))) + f**2*(4*D1*bd1*k1**2*(C*(6*r**2 + r*(6*s - 46) - 73*s + 33) + 2*r**2 + r*(2*s + 27) + 47*s - 23) - D1*bd1*k2**2*(f*(24*r**2 + r*(24*s + 7) + 32*s - 16) - 82*r**2 - 2*r*(41*s - 83) + 108*s - 66) + 6*D1*fd*(k1**2*(C*(36*r + 30*s - 22) + 9*r**2 + 9*r*s - 34*r - 26*s + 18) + 3*k2**2*(3*r - 1)*(2*r + 2*s - 1)) + 6*Dd*f*(k1**2*(C*(60*r + 46*s - 38) + 12*r**2 + 12*r*s - 53*r - 38*s + 30) + 3*k2**2*(4*r - 1)*(2*r + 2*s - 1))))/(105*d**2*k1*k3**3) + D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(33*D1*bd1*f*(f**2*k2**2*(k1**2*(48*r**2 + 3*r*(16*s + 37) + 127*s - 115) + 18*k2**2*(r - 1)*(5*r + 5*s - 3)) + f*k1**2*(2*k1**2*(4*C*(9*r**2 + r*(9*s + 22) + 27*s - 31) - 31*r**2 - r*(31*s + 47) - 58*s + 78) + k2**2*(28*C*(r - 1)*(15*r + 15*s - 8) - 6*K*(r**2 + r*(s + 20) + 12*s - 12) + 3*b1*(20*r**2 + r*(20*s - 27) - 47*s + 27) - 332*r**2 - 332*r*s + 598*r + 384*s - 230)) - 14*k1**2*k2**2*(b1*(3*K - 2)*(2*r**2 + 2*r*s + r - 3*s) - 6*g2*(r**2 + r*(s - 1) - 3*s))) + 33*b1**2*k1**2*k2**2*(D1*fd*r*(f*(60*r + 60*s - 51) + (28 - 42*K)*(r + s)) + Dd*f*(3*f*(40*r**2 + 40*r*s - 44*r - 47*s + 27) + (28 - 42*K)*(4*r**2 + 4*r*s + 3*r - 3*s))) + 33*b1*(D1*(f**2*fd*k2**2*(k1**2*(144*r**2 + 9*r*(16*s + 9) + 105*s - 85) + 54*k2**2*r*(5*r + 5*s - 3)) + 2*f*k1**2*(-fd*(k1**2*r*(-8*C*(9*r + 9*s + 13) + 62*r + 62*s + 67) + k2**2*(K*(6*r**2 + r*(6*s + 57) + 39*s - 30) + r**2*(332 - 420*C) - 4*r*(7*C*(15*s - 8) - 83*s + 55) - 26*s + 20)) + 42*gd2*k2**2*r*(r + s + 2)) + 84*fd*g2*k1**2*k2**2*r*(r + s)) + 2*Dd*f*(f**2*k2**2*(4*k1**2*(24*r**2 + 24*r*(s + 1) + 29*s - 25) + 9*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + f*k1**2*(k1**2*(4*C*(36*r**2 + r*(36*s + 43) + 27*s - 31) - 124*r**2 - r*(124*s + 103) - 58*s + 78) + k2**2*(14*C*(4*r - 1)*(15*r + 15*s - 8) - 3*K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) - 664*r**2 - 664*r*s + 650*r + 242*s - 159)) + 42*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(15*f**2*fd*k2**2*(3*k1**2*(56*r**2 + 8*r*(7*s - 18) - 91*s + 71) + 22*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*(k1**2*(8*C*(15*r - 29)*(3*r + 3*s - 2) - 279*r**2 - 9*r*(31*s - 70) + 462*s - 302) + 9*k2**2*(3*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 18*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 396*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(15*f**2*k2**2*(3*k1**2*(56*r**2 + 8*r*(7*s - 18) - 91*s + 71) + 22*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 22*f*k1**2*(k1**2*(8*C*(60*r**2 + 60*r*s - 177*r - 124*s + 95) - 372*r**2 - 372*r*s + 939*r + 650*s - 490) + 9*k2**2*(4*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 396*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k1*k3**5) + D1**3*Pkd1*Pkd3*ct**2*(-6*D1*bd1*f**2*(k1**2*(4*C - 2)*(4*r**2 + r*(4*s - 3) - s) - 7*k2**2*r*(r + s - 1)) + 7*b1**3*k2**2*(3*D1*fd*r*(r + s - 1) + Dd*f*(12*r**2 + r*(12*s - 7) + s - 1)) + b1**2*(7*D1*bd1*f*k2**2*(9*r**2 + r*(9*s - 4) + s - 1) + D1*fd*(k1**2*r*(56 - 112*C) + k2**2*(54*f*r - 27*f + 126*r - 56))*(r + s - 1) + Dd*f*k1**2*(28 - 56*C)*(8*r**2 + 8*r*(s - 1) - s + 1) + Dd*f*k2**2*(3*f*(36*r**2 + 9*r*(4*s - 5) - 17*s + 13) + 504*r**2 + 14*r*(36*s - 49) - 210*s + 182)) + 2*b1*f*(D1*bd1*(k1**2*(14 - 28*C)*(4*r**2 + 4*r*(s - 1) - s + 1) + k2**2*(3*f*(9*r**2 + 9*r*(s - 1) - 4*s + 2) + 126*r**2 + 7*r*(18*s - 25) - 63*s + 49)) - 3*D1*fd*(2*r - 1)*(k1**2*(16*C - 8) - 7*k2**2)*(r + s - 1) - 3*Dd*f*(k1**2*(4*C - 2)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 7*k2**2*(4*r - 1)*(r + s - 1))))/(105*d**2*k1*k3) + D1**3*Pkd1*Pkd3*ct**2*(-21*b1**3*k1**2*k2**2*(11*D1*fd*r*(r + s - 1) + Dd*f*(44*r**2 + r*(44*s - 39) - 3*s + 3)) + 3*b1**2*(D1*(-7*bd1*f*k1**2*k2**2*(33*r**2 + r*(33*s - 28) - 3*s + 3) + fd*(k1**4*r*(112*C - 56)*(r + s - 1) + k1**2*k2**2*(14*K*(5*r**2 + 5*r*s - 24*r - 12*s + 12) + 3*f*(64*r**2 + r*(64*s + 9) + 25*s - 25) + 14*r**2*(20*C - 11) + 14*r*(20*C*(s - 1) - 11*s + 31) + 112*s - 112) + 14*k2**4*r*(6*f*(3*r + 3*s - 2) + 5*r + 5*s))) + 2*Dd*f*(k1**4*(28*C - 14)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(140*C*(4*r - 1)*(r + s - 1) + 7*K*(20*r**2 + 20*r*s - 53*r - 29*s + 24) + 6*f*(32*r**2 + 4*r*(8*s - 3) + 4*s - 5) - 308*r**2 - 308*r*s + 693*r + 203*s - 217) + 7*k2**4*(4*r - 1)*(f*(9*r + 9*s - 6) + 5*r + 5*s))) + b1*(3*D1*bd1*f*(k1**4*(56*C - 28)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(280*C*(2*r - 1)*(r + s - 1) + 14*K*(10*r**2 + 10*r*s - 17*r - 11*s + 6) + 3*f*(64*r**2 + r*(64*s - 57) - 9*s + 5) - 308*r**2 - 308*r*s + 658*r + 238*s - 266) + 14*k2**4*(2*r - 1)*(f*(9*r + 9*s - 6) + 5*r + 5*s)) - 3*D1*(-5*f**2*fd*k2**2*(3*r - 1)*(k1**2*(29*r + 29*s - 21) + 6*k2**2*(3*r + 3*s - 2)) + 2*f*(3*fd*(k1**4*(16*C - 8)*(2*r + s - 1) + k1**2*k2**2*(28*C*(r**2 + r*s + r + s - 1) + K*(2*r - 1)*(17*r + 17*s - 12) - 62*r**2 - 62*r*s + 27*r + 3*s + 9) - 7*k2**4*(r + s)*(2*r - 1)) + 7*k1**2*k2**2*(bd2*r*(7*r + 7*s - 6) + 2*gd2*(5*r**2 + r*(5*s - 12) - 6*s + 6))) + 14*fd*k1**2*k2**2*(7*b2*r*(r + s) + 2*g2*(5*r**2 + 5*r*s - 24*r - 12*s + 12))) + Dd*f*(5*f**2*k2**2*(k1**2*(348*r**2 + r*(348*s - 355) - 103*s + 75) + 18*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 18*f*(k1**4*(16*C - 8)*(2*r + s - 1) + k1**2*k2**2*(-14*C*s + K*(68*r**2 + r*(68*s - 89) - 29*s + 24) + r**2*(56*C - 124) + r*(56*C*s - 14*C - 124*s + 103) + 43*s - 24) - 7*k2**4*(r + s)*(4*r - 1)) - 42*k1**2*k2**2*(b2*(28*r**2 + r*(28*s - 19) - s) + 2*g2*(20*r**2 + r*(20*s - 53) - 29*s + 24)))) + f*(D1*bd1*(5*f**2*k2**2*(k1**2*(87*r**2 + r*(87*s - 79) - 16*s + 12) + 18*k2**2*r*(3*r + 3*s - 2)) + 18*f*(k1**4*(4*C - 2)*(2*r + s - 1) + k1**2*k2**2*(-14*C*(r**2 + r*(s - 3) - 3*s + 2) + K*(-17*r**2 - 17*r*s + 24*r + 6*s - 6) + 31*r**2 + 31*r*s - 52*r - 34*s + 27) + 7*k2**4*r*(r + s)) - 42*k1**2*k2**2*(b2*(7*r**2 + 7*r*(s - 1) - s) + 10*g2*(r - 1)*(r + s))) - 2*k1**2*(D1*(5*f*fd*(3*r - 1)*(k1**2*(8*C - 4)*(3*r + 3*s - 2) + 9*k2**2*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + 9*f*k2**2*(bd2 - 2*gd2)*(17*r**2 + r*(17*s - 24) - 6*s + 6) + 9*fd*k2**2*(b2 - 2*g2)*(2*r - 1)*(17*r + 17*s - 12)) + Dd*f*(5*f*(k1**2*(4*C - 2)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + k2**2*(9*b2 - 18*g2)*(68*r**2 + r*(68*s - 89) - 29*s + 24)))))/(315*d**2*k1*k3**3) + 2*D1**3*Pkd1*Pkd3*ct*f*k2**3*st**4*(3*D1*bd1*f*(2*C*(6*r**2 + r*(6*s - 11) - 10*s + 5) - 11*r**2 + r*(19 - 11*s) + 16*s - 8) + 3*b1*(D1*fd*r*(12*C - 11)*(2*r + 2*s - 1) + Dd*f*(2*C*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5) - 44*r**2 - 44*r*s + 33*r + 16*s - 8)) + f*(D1*fd*(2*C*(18*r**2 + 9*r*(2*s + 1) + 18*s - 13) - 27*r**2 - 9*r*(3*s + 2) - 30*s + 22) + Dd*f*(C*(48*r**2 + 12*r*(4*s + 3) + 56*s - 46) - 36*r**2 - 3*r*(12*s + 11) - 46*s + 38)))/(105*d**2*k3**3) - 2*D1**3*Pkd1*Pkd3*ct*f*k2**3*st**4*(11*D1*bd1*f*(3*k1**2*(C*(32*r**2 + 32*r*s - 54*r - 44*s + 22) - 21*r**2 - 21*r*s + 35*r + 28*s - 14) + k2**2*(-3*b1*(12*r**2 + 12*r*(s - 1) - 10*s + 5) + f*(12*r**2 + r*(12*s - 49) - 46*s + 32))) - 33*b1**2*k2**2*(6*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(24*r**2 + 6*r*(4*s - 3) - 10*s + 5)) + 11*b1*(D1*fd*(f*k2**2*(36*r**2 + r*(36*s - 39) - 18*s + 13) + k1**2*r*(96*C - 63)*(2*r + 2*s - 1)) + Dd*f*(f*k2**2*(48*r**2 + 8*r*(6*s - 11) - 64*s + 45) + 3*k1**2*(2*C*(64*r**2 + 64*r*s - 48*r - 22*s + 11) - 84*r**2 - 84*r*s + 63*r + 28*s - 14))) + f*(D1*fd*(2*f*k2**2*(236*r**2 + r*(236*s - 5) + 128*s - 107) + 11*k1**2*(C*(72*r**2 + 18*r*(4*s + 3) + 84*s - 62) - 45*r**2 - 9*r*(5*s + 4) - 54*s + 40)) + Dd*f*(2*f*k2**2*(236*r**2 + r*(236*s - 5) + 128*s - 107) + 11*k1**2*(2*C*(48*r**2 + 48*r*(s + 1) + 64*s - 53) - 60*r**2 - 60*r*s - 63*r - 82*s + 68))))/(1155*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct*k1**2*k2*(D1*bd1*f*(-21*b1*(k1**2*(10*K - 2)*(4*r**2 + r*(4*s - 3) - s) + k2**2*(15*K - 5)*(r + s)*(2*r - 1)) + 5*f**2*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 9*k2**2*(2*r**2 + 2*r*s + s - 1)) + 9*f*(k1**2*(-14*C*(r - 1)*(r + s - 1) - 40*K*r**2 - 40*K*r*s + 40*K*r + 10*K*s - 10*K + 2*b1*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 15*r**2 + 15*r*s - 22*r - 9*s + 9) + 7*k2**2*(b1*(2*r - 1)*(3*r + 3*s - 2) - r*(3*K - 1)*(r + s))) + 210*g2*(k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 3*k2**2*(r - 1)*(r + s))) + 3*b1**2*(D1*fd*r*(6*f*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(3*r + 3*s - 2)) + (r + s)*(-7*k1**2*(20*K - 4) - 7*k2**2*(15*K - 5))) + Dd*f*(3*f*(k1**2*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) + 7*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 7*k1**2*(10*K - 2)*(8*r**2 + r*(8*s - 4) - s) - 7*k2**2*(15*K - 5)*(r + s)*(4*r - 1))) + b1*(D1*(5*f**2*fd*(4*k1**2*(3*r - 1)*(3*r + 3*s - 2) + 9*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2)) - 9*f*fd*(k1**2*(20*K*(2*r - 1)*(2*r + 2*s - 1) + r**2*(28*C - 30) + r*(28*C - 30)*(s - 1) + 8*s - 4) + k2**2*(21*K - 7)*(r + s)*(2*r - 1)) + 210*f*gd2*r*(k1**2*(4*r + 4*s - 2) + 3*k2**2*(r + s)) + 210*fd*g2*r*(4*k1**2 + 3*k2**2)*(r + s)) + Dd*f*(5*f**2*(2*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 9*f*(k1**2*(14*C*(4*r - 1)*(r + s - 1) + 20*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 60*r**2 - 60*r*s + 67*r + 19*s - 15) + k2**2*(21*K - 7)*(r + s)*(4*r - 1)) + 210*g2*(2*k1**2*(8*r**2 + r*(8*s - 4) - s) + 3*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1)*(r + s - 1) - 9*f*(fd*k1**2*(10*C - 5)*(3*r - 1)*(r + s - 1) - 20*gd2*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 42*gd2*k2**2*r*(r + s)) + 18*fd*g2*(2*r - 1)*(20*k1**2*(2*r + 2*s - 1) + 21*k2**2*(r + s))) + Dd*f*(-35*f**2*k2**2*(4*r - 1)*(r + s - 1) - f*k1**2*(90*C - 45)*(4*r - 1)*(r + s - 1) + 360*g2*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 378*g2*k2**2*(r + s)*(4*r - 1))))/(315*d**2*k3**5) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(D1*bd1*f**2*(r**2*(2*C + 1) + r*(2*C*(s + 1) + s - 6) + s*(24*C - 16)) + 7*b1**2*(D1*fd*r*(2*C - 3)*(r + s - 1) + Dd*f*(2*C*(4*r**2 + 4*r*s - 9*r - 3*s + 3) - 12*r**2 - 12*r*s + 17*r + 4*s - 4)) + b1*f*(7*D1*bd1*(2*C*(2*r**2 + 2*r*s - 7*r - 3*s + 3) - 6*r**2 - 6*r*s + 11*r + 4*s - 4) + 2*D1*fd*(r + s - 1)*(C*(2*r + 13) + r - 11) + Dd*f*(C*(8*r**2 + 8*r*s + 46*r + 74*s - 50) + 4*r**2 + 4*r*s - 47*r - 54*s + 38)))/(105*d**2*k3) + 2*D1**3*Pkd1*Pkd3*ct*k2*(-7*D1*bd1*f*(b2*(4*r**2 + 4*r*(s - 1) - 2*s) + f*r*(6*C - 3)*(r + s - 1) + 4*g2*(-2*r**2 - 2*r*s + 2*r + s)) + 14*b1**3*(2*D1*fd*r*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + b1**2*(14*D1*bd1*f*(6*r**2 + 6*r*(s - 1) - s + 1) + D1*fd*(r + s - 1)*(-70*C*r - 28*K*(r - 1) + 24*f*(2*r - 1) + 63*r - 28) + Dd*f*(-70*C*(4*r - 1)*(r + s - 1) - 14*K*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 6*f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 252*r**2 + 252*r*s - 343*r - 105*s + 91)) + b1*(-84*C*D1*f*fd*r**2 - 84*C*D1*f*fd*r*s + 126*C*D1*f*fd*r + 42*C*D1*f*fd*s - 42*C*D1*f*fd - 168*C*Dd*f**2*r**2 - 168*C*Dd*f**2*r*s + 210*C*Dd*f**2*r + 42*C*Dd*f**2*s - 42*C*Dd*f**2 - 28*D1*b2*fd*(r - 1)*(r + s - 1) + D1*bd1*f*(-70*C*(2*r - 1)*(r + s - 1) - 14*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 6*f*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 126*r**2 + 126*r*s - 175*r - 63*s + 49) - 14*D1*bd2*f*(2*r - 1)*(r + s - 1) + 42*D1*f*fd*r**2 + 42*D1*f*fd*r*s - 63*D1*f*fd*r - 21*D1*f*fd*s + 21*D1*f*fd + 56*D1*f*gd2*r**2 + 56*D1*f*gd2*r*s - 84*D1*f*gd2*r - 28*D1*f*gd2*s + 28*D1*f*gd2 + 56*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 112*D1*fd*g2*r - 56*D1*fd*g2*s + 56*D1*fd*g2 - 14*Dd*b2*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + 84*Dd*f**2*r**2 + 84*Dd*f**2*r*s - 105*Dd*f**2*r - 21*Dd*f**2*s + 21*Dd*f**2 + 224*Dd*f*g2*r**2 + 224*Dd*f*g2*r*s - 336*Dd*f*g2*r - 140*Dd*f*g2*s + 112*Dd*f*g2))/(105*d**2*k3) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(21*b1**3*k2**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + r*(4*s - 9) - 3*s + 3)) + 3*b1**2*(7*D1*bd1*f*k2**2*(3*r**2 + r*(3*s - 8) - 3*s + 3) + D1*fd*(f*k2**2*(20*r**2 + 10*r*(2*s - 1) + 13*s - 13) + k1**2*r*(49 - 70*C)*(r + s - 1) + k2**2*r*(7*K - 7)*(r + s)) - 7*Dd*f*k1**2*(10*C*(4*r - 1)*(r + s - 1) - 28*r**2 - 28*r*s + 33*r + 6*s - 6) + Dd*f*k2**2*(f*(40*r**2 + r*(40*s - 2) + 64*s - 39) + (7*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 3*b1*(D1*bd1*f*(-7*k1**2*(10*C*(2*r - 1)*(r + s - 1) - 14*r**2 - 14*r*s + 19*r + 6*s - 6) + k2**2*(f*(20*r**2 + 4*r*(5*s + 2) + 51*s - 26) + (7*K - 7)*(2*r**2 + 2*r*s + r - 3*s))) + D1*(3*f**2*fd*k2**2*(3*r**2 + r*(3*s - 20) - 13*s + 12) + f*(fd*k1**2*(-2*C*(16*r**2 + r*(16*s + 47) + 31*s - 31) + 16*r**2 + r*(16*s + 65) + 40*s - 40) + fd*k2**2*(K*(2*r**2 + r*(2*s + 19) + 13*s - 10) - r**2*(168*C - 124) + r*(-168*C*s + 84*C + 124*s - 89) - 13*s + 10) + k2**2*r*(7*bd2 - 14*gd2)*(r + s + 2)) + 7*fd*k2**2*r*(b2 - 2*g2)*(r + s)) + Dd*f*(f**2*k2**2*(12*r**2 + r*(12*s - 83) - 59*s + 48) + f*(-4*k1**2*(2*C*(8*r**2 + 4*r*(2*s + 5) + 19*s - 16) - 8*r**2 - 4*r*(2*s + 7) - 23*s + 20) + k2**2*(-42*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + 248*r**2 + 248*r*s - 262*r - 100*s + 69)) + k2**2*(7*b2 - 14*g2)*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(3*D1*bd1*(f**2*k2**2*(3*r**2 + r*(3*s - 23) - 20*s + 12) + f*(k1**2*(-2*C*(8*r**2 + r*(8*s + 13) + 25*s - 13) + 8*r**2 + 8*r*s + 19*r + 28*s - 16) + k2**2*(-42*C*(r - 1)*(2*r + 2*s - 1) + K*(r**2 + r*(s + 20) + 12*s - 12) + 62*r**2 + 62*r*s - 118*r - 75*s + 47)) + k2**2*(7*b2 - 14*g2)*(r**2 + r*(s - 1) - 3*s)) + D1*(f*(fd*(k1**2*(-18*C*(9*r**2 + r*(9*s - 16) - 11*s + 7) + 99*r**2 + 9*r*(11*s - 18) - 114*s + 70) - 9*k2**2*(3*r - 1)*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5)) + k2**2*(3*bd2 - 6*gd2)*(r**2 + r*(s + 20) + 12*s - 12)) + 3*fd*k2**2*(b2 - 2*g2)*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(f*(k1**2*(-18*C*(12*r**2 + r*(12*s - 23) - 15*s + 11) + 132*r**2 + 33*r*(4*s - 7) - 154*s + 110) - 9*k2**2*(4*r - 1)*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5)) + k2**2*(3*b2 - 6*g2)*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(315*d**2*k3**3) - 2*D1**3*Pkd1*Pkd3*ct*k2*(-D1*bd1*f*(-126*b2*k1**2*(2*r**2 + 2*r*(s - 1) - s) - 105*b2*k2**2*(r - 1)*(r + s) + 5*f**2*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 9*k2**2*r*(3*r + 3*s - 2)) + 9*f*(k1**2*(14*C*(r + s - 1) - 6*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 8*r**2 + 8*r*s - 15*r - 9*s + 9) + k2**2*r*(7 - 7*K)*(r + s)) + 210*g2*k2**2*(r - 1)*(r + s)) + 21*b1**3*(D1*fd*r*(4*k1**2 + 5*k2**2)*(r + s - 1) + Dd*f*(2*k1**2*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*k2**2*(4*r - 1)*(r + s - 1))) + 3*b1**2*(7*D1*bd1*f*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 5*k2**2*(3*r - 1)*(r + s - 1)) + D1*fd*(k1**2*(84*K*(2*r + s - 1) - 24*f*(2*r + s - 1) + 7*r**2*(5 - 10*C) + 7*r*(-10*C*(s - 1) + 5*s - 13) - 28*s + 28) - 7*k2**2*(3*f*(4*r**2 + r*(4*s - 1) + s - 1) + r*(5 - 5*K)*(r + s))) + Dd*f*(k1**2*(-70*C*(4*r - 1)*(r + s - 1) + 168*K*(2*r + s - 1) - 24*f*(2*r + s - 1) + 140*r**2 + 140*r*s - 287*r - 91*s + 91) - 7*k2**2*(4*r - 1)*(f*(6*r + 6*s - 3) + (5 - 5*K)*(r + s)))) + b1*(-21*D1*bd1*f*(k1**2*(10*C*(2*r - 1)*(r + s - 1) - 6*K*(2*r + s - 1) - 10*r**2 - 10*r*s + 19*r + 7*s - 7) + k2**2*(3*f*(4*r**2 + r*(4*s - 5) - 3*s + 2) + (5 - 5*K)*(r + s)*(2*r - 1))) + D1*(-5*f**2*fd*(4*k1**2 + 9*k2**2)*(3*r - 1)*(3*r + 3*s - 2) + 3*f*(7*bd2*r*(6*k1**2*(2*r + 2*s - 1) + 5*k2**2*(r + s)) + 3*fd*k1**2*(14*C*(r + s - 1) + 12*K*(2*r - 1)*(2*r + 2*s - 1) - 16*r**2 - 16*r*s + 9*r + s + 3) + 21*fd*k2**2*(K - 1)*(r + s)*(2*r - 1) - 14*gd2*(6*k1**2*(2*r + s - 1) + 5*k2**2*r*(r + s))) + 21*fd*(b2*r*(12*k1**2 + 5*k2**2)*(r + s) - 2*g2*(12*k1**2*(2*r + s - 1) + 5*k2**2*r*(r + s)))) - Dd*f*(-126*b2*k1**2*(8*r**2 + r*(8*s - 4) - s) - 105*b2*k2**2*(r + s)*(4*r - 1) + 5*f**2*(2*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 9*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 9*f*(k1**2*(12*K - 4)*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + k2**2*(7*K - 7)*(r + s)*(4*r - 1)) + 1008*g2*k1**2*(2*r + s - 1) + 210*g2*k2**2*(r + s)*(4*r - 1))) + 9*f*(30*C*D1*f*fd*k1**2*r**2 + 30*C*D1*f*fd*k1**2*r*s - 40*C*D1*f*fd*k1**2*r - 10*C*D1*f*fd*k1**2*s + 10*C*D1*f*fd*k1**2 + 40*C*Dd*f**2*k1**2*r**2 + 40*C*Dd*f**2*k1**2*r*s - 50*C*Dd*f**2*k1**2*r - 10*C*Dd*f**2*k1**2*s + 10*C*Dd*f**2*k1**2 + D1*b2*fd*(2*r - 1)*(12*k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s)) + D1*bd2*f*(6*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 7*k2**2*r*(r + s)) - 15*D1*f*fd*k1**2*r**2 - 15*D1*f*fd*k1**2*r*s + 20*D1*f*fd*k1**2*r + 5*D1*f*fd*k1**2*s - 5*D1*f*fd*k1**2 - 48*D1*f*gd2*k1**2*r**2 - 48*D1*f*gd2*k1**2*r*s + 48*D1*f*gd2*k1**2*r + 12*D1*f*gd2*k1**2*s - 12*D1*f*gd2*k1**2 - 14*D1*f*gd2*k2**2*r**2 - 14*D1*f*gd2*k2**2*r*s - 96*D1*fd*g2*k1**2*r**2 - 96*D1*fd*g2*k1**2*r*s + 96*D1*fd*g2*k1**2*r + 48*D1*fd*g2*k1**2*s - 24*D1*fd*g2*k1**2 - 28*D1*fd*g2*k2**2*r**2 - 28*D1*fd*g2*k2**2*r*s + 14*D1*fd*g2*k2**2*r + 14*D1*fd*g2*k2**2*s + Dd*b2*f*(12*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)) - 20*Dd*f**2*k1**2*r**2 - 20*Dd*f**2*k1**2*r*s + 25*Dd*f**2*k1**2*r + 5*Dd*f**2*k1**2*s - 5*Dd*f**2*k1**2 - 192*Dd*f*g2*k1**2*r**2 - 192*Dd*f*g2*k1**2*r*s + 192*Dd*f*g2*k1**2*r + 72*Dd*f*g2*k1**2*s - 48*Dd*f*g2*k1**2 - 56*Dd*f*g2*k2**2*r**2 - 56*Dd*f*g2*k2**2*r*s + 14*Dd*f*g2*k2**2*r + 14*Dd*f*g2*k2**2*s))/(315*d**2*k3**3) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(33*D1*bd1*f*(f**2*k2**2*(k1**2*(6*r**2 + 6*r*s + 31*r + 24*s - 28) + 9*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) + f*(-21*b1*k2**4*(2*r - 1)*(2*r + 2*s - 1) + k1**4*(C*(30*r**2 + r*(30*s + 8) + 6*s - 38) - 17*r**2 - r*(17*s + 5) - 2*s + 22) - k1**2*k2**2*(-14*C*(r - 1)*(12*r + 12*s - 7) + 3*K*r**2 + 3*K*r*s + 60*K*r + 36*K*s - 36*K + b1*(30*r**2 + 2*r*(15*s - 8) + 24*s - 19) + 104*r**2 + 104*r*s - 188*r - 117*s + 75)) - 7*k1**2*k2**2*(b1*(3*K - 1)*(2*r**2 + 2*r*s + r - 3*s) - 6*g2*(r**2 + r*(s - 1) - 3*s))) - 33*b1**2*k2**2*(D1*fd*r*(f*k1**2*(30*r + 30*s - 1) + 42*f*k2**2*(2*r + 2*s - 1) + k1**2*(21*K - 7)*(r + s)) + Dd*f*(f*(k1**2*(60*r**2 + 60*r*s - 17*r + 24*s - 19) + 21*k2**2*(4*r - 1)*(2*r + 2*s - 1)) + k1**2*(21*K - 7)*(4*r**2 + r*(4*s + 3) - 3*s))) + 33*b1*(D1*(3*f**2*fd*k2**2*(k1**2*(6*r**2 + 3*r*(2*s + 7) + 18*s - 13) + 3*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) + f*k1**2*(-fd*(k1**2*r*(-20*C*(3*r + 3*s + 2) + 34*r + 34*s + 25) + k2**2*(K*(6*r**2 + r*(6*s + 57) + 39*s - 30) + r**2*(208 - 336*C) + r*(-336*C*s + 196*C + 208*s - 145) - 13*s + 10)) + 42*gd2*k2**2*r*(r + s + 2)) + 42*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(24*r**2 + r*(24*s + 94) + 78*s - 67) + 9*k2**2*(4*r - 1)*(4*r + 4*s - 3)) + f*k1**2*(k1**2*(2*C*(60*r**2 + 5*r*(12*s + 5) + 3*s - 19) - 68*r**2 - r*(68*s + 33) - 2*s + 22) + k2**2*(14*C*(4*r - 1)*(12*r + 12*s - 7) - 3*K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) - 416*r**2 - 416*r*s + 416*r + 142*s - 97)) + 42*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(260*r**2 + r*(260*s - 359) - 186*s + 134) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 11*f*k1**2*(fd*(k1**2*(2*C*(117*r**2 + 9*r*(13*s - 20) - 129*s + 77) - 135*r**2 - 3*r*(45*s - 66) + 144*s - 84) + 9*k2**2*(3*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 18*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 198*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(5*f**2*k2**2*(k1**2*(260*r**2 + r*(260*s - 359) - 186*s + 134) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 11*f*k1**2*(k1**2*(C*(312*r**2 + 6*r*(52*s - 85) - 346*s + 242) - 180*r**2 - 3*r*(60*s - 93) + 192*s - 132) + 9*k2**2*(4*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 198*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**5) - D1**3*Pkd1*Pkd3*f**2*k2**6*st**6*(11*D1*bd1*f*(3*r**2 + r*(3*s - 7) - 6*s + 4) + 11*b1*(3*D1*fd*r*(3*r + 3*s - 2) + Dd*f*(12*r**2 + 12*r*s - 13*r - 6*s + 4)) + 5*f*(3*r + 2)*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(693*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*f*k2**2*st**4*(D1*bd1*f*(k1**2*(6 - 12*C)*(5*r**2 + r*(5*s - 8) - 6*s + 3) + k2**2*(3*b1*(r - 2)*(4*r + 4*s - 3) + f*(6*r**2 + 6*r*s + r + 8*s - 4))) + 3*b1**2*k2**2*(D1*fd*r + 2*Dd*f*(r - 1))*(4*r + 4*s - 3) + b1*(D1*fd*(f*k2**2*(3*r + 2)*(6*r + 6*s - 5) + k1**2*r*(30 - 60*C)*(2*r + 2*s - 1)) + 2*Dd*f*(f*k2**2*(12*r**2 + r*(12*s - 1) + 10*s - 7) + k1**2*(3 - 6*C)*(20*r**2 + 5*r*(4*s - 3) - 6*s + 3))) - f*k1**2*(12*C - 6)*(D1*fd*(3*r**2 + 3*r*(s + 1) + 4*s - 3) + Dd*f*(4*r**2 + r*(4*s + 5) + 6*s - 5)))/(105*d**2*k1*k3**3) + D1**3*Pkd1*Pkd3*f*k2**2*st**4*(11*D1*bd1*f*(3*f*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(12*C - 6)*(5*r**2 + r*(5*s - 8) - 6*s + 3) + 2*k1**2*k2**2*(3*b1*(11*r**2 + 11*r*(s - 1) - 8*s + 4) + f*(18*r + 17*s - 14))) + 33*b1**2*k1**2*k2**2*(11*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(44*r**2 + 11*r*(4*s - 3) - 16*s + 8)) + 11*b1*(D1*fd*(f*k1**2*k2**2*(36*r + 30*s - 22) + 9*f*k2**4*r*(5*r + 5*s - 3) + k1**4*r*(30 - 60*C)*(2*r + 2*s - 1)) + Dd*f*(2*f*k1**2*k2**2*(36*r + 32*s - 25) + 3*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) - k1**4*(12*C - 6)*(20*r**2 + 5*r*(4*s - 3) - 6*s + 3))) - f*(D1*fd*(f*k1**2*k2**2*(204*r**2 + 204*r*s + 71*r + 180*s - 146) - 11*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(3*r**2 + 3*r*(s + 1) + 4*s - 3)) + Dd*f*(f*k1**2*k2**2*(204*r**2 + 204*r*s + 71*r + 180*s - 146) - 11*f*k2**4*(4*r - 1)*(5*r + 5*s - 3) + k1**4*(132*C - 66)*(4*r**2 + r*(4*s + 5) + 6*s - 5))))/(1155*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*k1**3*(D1*(-14*b1*fd*r*(4*k1**2 + 5*k2**2)*(r + s)*(K*b1 - 2*g2) + 15*bd1*f**3*k2**2*r*(r + s - 1) + 3*f**2*(-2*K*bd1*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s)) + 7*b1*bd1*k2**2*(2*r - 1)*(r + s - 1) + 5*b1*fd*k2**2*(3*r - 1)*(r + s - 1) + 4*gd2*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s))) + 2*f*(3*b1*fd*(-K*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s)) + 7*b1*k2**2*r*(r + s - 1)) + 14*b1*gd2*r*(k1**2*(4*r + 4*s - 2) + 5*k2**2*(r + s)) + 7*bd1*(K*b1*(k1**2*(-8*r**2 - 8*r*s + 6*r + 2*s) - 5*k2**2*(r + s)*(2*r - 1)) + 2*g2*(k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 5*k2**2*(r - 1)*(r + s))) + 6*fd*g2*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s)))) + Dd*f*(15*b1*f**2*k2**2*(4*r - 1)*(r + s - 1) - 14*b1*(K*b1 - 2*g2)*(2*k1**2*(8*r**2 + r*(8*s - 4) - s) + 5*k2**2*(r + s)*(4*r - 1)) + 3*f*(b1*(-2*K*(4*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)) + 7*b1*k2**2*(4*r - 1)*(r + s - 1)) + 4*g2*(4*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)))))/(105*d**2*k3**5) - D1**3*Pkd1*Pkd3*k1*(112*D1*K*b1**2*fd*k1**2*r + 56*D1*K*b1**2*fd*k1**2*s - 56*D1*K*b1**2*fd*k1**2 + 70*D1*K*b1**2*fd*k2**2*r**2 + 70*D1*K*b1**2*fd*k2**2*r*s + 56*D1*K*b1*bd1*f*k1**2*r + 28*D1*K*b1*bd1*f*k1**2*s - 28*D1*K*b1*bd1*f*k1**2 + 140*D1*K*b1*bd1*f*k2**2*r**2 + 140*D1*K*b1*bd1*f*k2**2*r*s - 70*D1*K*b1*bd1*f*k2**2*r - 70*D1*K*b1*bd1*f*k2**2*s + 96*D1*K*b1*f*fd*k1**2*r**2 + 96*D1*K*b1*f*fd*k1**2*r*s - 96*D1*K*b1*f*fd*k1**2*r - 48*D1*K*b1*f*fd*k1**2*s + 24*D1*K*b1*f*fd*k1**2 + 84*D1*K*b1*f*fd*k2**2*r**2 + 84*D1*K*b1*f*fd*k2**2*r*s - 42*D1*K*b1*f*fd*k2**2*r - 42*D1*K*b1*f*fd*k2**2*s + 48*D1*K*bd1*f**2*k1**2*r**2 + 48*D1*K*bd1*f**2*k1**2*r*s - 48*D1*K*bd1*f**2*k1**2*r - 12*D1*K*bd1*f**2*k1**2*s + 12*D1*K*bd1*f**2*k1**2 + 42*D1*K*bd1*f**2*k2**2*r**2 + 42*D1*K*bd1*f**2*k2**2*r*s + 35*D1*b1**3*fd*k2**2*r**2 + 35*D1*b1**3*fd*k2**2*r*s - 35*D1*b1**3*fd*k2**2*r + 105*D1*b1**2*bd1*f*k2**2*r**2 + 105*D1*b1**2*bd1*f*k2**2*r*s - 140*D1*b1**2*bd1*f*k2**2*r - 35*D1*b1**2*bd1*f*k2**2*s + 35*D1*b1**2*bd1*f*k2**2 - 21*D1*b1**2*f*fd*k2**2*r - 21*D1*b1**2*f*fd*k2**2*s + 21*D1*b1**2*f*fd*k2**2 + 21*D1*b1*bd1*f**2*k2**2*r + 21*D1*b1*bd1*f**2*k2**2*s - 21*D1*b1*bd1*f**2*k2**2 - 45*D1*b1*f**2*fd*k2**2*r**2 - 45*D1*b1*f**2*fd*k2**2*r*s + 60*D1*b1*f**2*fd*k2**2*r + 15*D1*b1*f**2*fd*k2**2*s - 15*D1*b1*f**2*fd*k2**2 - 112*D1*b1*f*gd2*k1**2*r - 56*D1*b1*f*gd2*k1**2*s + 56*D1*b1*f*gd2*k1**2 - 140*D1*b1*f*gd2*k2**2*r**2 - 140*D1*b1*f*gd2*k2**2*r*s - 224*D1*b1*fd*g2*k1**2*r - 112*D1*b1*fd*g2*k1**2*s + 112*D1*b1*fd*g2*k1**2 - 140*D1*b1*fd*g2*k2**2*r**2 - 140*D1*b1*fd*g2*k2**2*r*s - 15*D1*bd1*f**3*k2**2*r**2 - 15*D1*bd1*f**3*k2**2*r*s + 15*D1*bd1*f**3*k2**2*r - 140*D1*bd1*f*g2*k2**2*r**2 - 140*D1*bd1*f*g2*k2**2*r*s + 140*D1*bd1*f*g2*k2**2*r + 140*D1*bd1*f*g2*k2**2*s + 2*D1*bd2*f*(7*b1*r*(k1**2*(4*r + 4*s - 2) + 5*k2**2*(r + s)) + 3*f*(k1**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 7*k2**2*r*(r + s))) - 96*D1*f**2*gd2*k1**2*r**2 - 96*D1*f**2*gd2*k1**2*r*s + 96*D1*f**2*gd2*k1**2*r + 24*D1*f**2*gd2*k1**2*s - 24*D1*f**2*gd2*k1**2 - 84*D1*f**2*gd2*k2**2*r**2 - 84*D1*f**2*gd2*k2**2*r*s - 192*D1*f*fd*g2*k1**2*r**2 - 192*D1*f*fd*g2*k1**2*r*s + 192*D1*f*fd*g2*k1**2*r + 96*D1*f*fd*g2*k1**2*s - 48*D1*f*fd*g2*k1**2 - 168*D1*f*fd*g2*k2**2*r**2 - 168*D1*f*fd*g2*k2**2*r*s + 84*D1*f*fd*g2*k2**2*r + 84*D1*f*fd*g2*k2**2*s + 224*Dd*K*b1**2*f*k1**2*r + 112*Dd*K*b1**2*f*k1**2*s - 112*Dd*K*b1**2*f*k1**2 + 280*Dd*K*b1**2*f*k2**2*r**2 + 280*Dd*K*b1**2*f*k2**2*r*s - 70*Dd*K*b1**2*f*k2**2*r - 70*Dd*K*b1**2*f*k2**2*s + 192*Dd*K*b1*f**2*k1**2*r**2 + 192*Dd*K*b1*f**2*k1**2*r*s - 192*Dd*K*b1*f**2*k1**2*r - 72*Dd*K*b1*f**2*k1**2*s + 48*Dd*K*b1*f**2*k1**2 + 168*Dd*K*b1*f**2*k2**2*r**2 + 168*Dd*K*b1*f**2*k2**2*r*s - 42*Dd*K*b1*f**2*k2**2*r - 42*Dd*K*b1*f**2*k2**2*s + 140*Dd*b1**3*f*k2**2*r**2 + 140*Dd*b1**3*f*k2**2*r*s - 175*Dd*b1**3*f*k2**2*r - 35*Dd*b1**3*f*k2**2*s + 35*Dd*b1**3*f*k2**2 - 60*Dd*b1*f**3*k2**2*r**2 - 60*Dd*b1*f**3*k2**2*r*s + 75*Dd*b1*f**3*k2**2*r + 15*Dd*b1*f**3*k2**2*s - 15*Dd*b1*f**3*k2**2 - 448*Dd*b1*f*g2*k1**2*r - 224*Dd*b1*f*g2*k1**2*s + 224*Dd*b1*f*g2*k1**2 - 560*Dd*b1*f*g2*k2**2*r**2 - 560*Dd*b1*f*g2*k2**2*r*s + 140*Dd*b1*f*g2*k2**2*r + 140*Dd*b1*f*g2*k2**2*s - 384*Dd*f**2*g2*k1**2*r**2 - 384*Dd*f**2*g2*k1**2*r*s + 384*Dd*f**2*g2*k1**2*r + 144*Dd*f**2*g2*k1**2*s - 96*Dd*f**2*g2*k1**2 - 336*Dd*f**2*g2*k2**2*r**2 - 336*Dd*f**2*g2*k2**2*r*s + 84*Dd*f**2*g2*k2**2*r + 84*Dd*f**2*g2*k2**2*s + 2*b2*(D1*(7*b1*fd*r*(4*k1**2 + 5*k2**2)*(r + s) + 7*bd1*f*(k1**2*(4*r**2 + 4*r*(s - 1) - 2*s) + 5*k2**2*(r - 1)*(r + s)) + 3*f*fd*(2*r - 1)*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(r + s))) + Dd*f*(7*b1*(2*k1**2*(8*r**2 + 8*r*s - 4*r - s) + 5*k2**2*(r + s)*(4*r - 1)) + 3*f*(4*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 7*k2**2*(r + s)*(4*r - 1)))))/(105*d**2*k3**3) + D1**3*Pkd1*Pkd3*k1*st**2*(-11*D1*bd1*f*(f**2*k2**2*(k1**2*(9*r**2 + r*(9*s - 47) - 26*s + 34) + 9*k2**2*(11*r + 9*s - 7)) + 3*f*(7*b1*k2**4*(2*r - 1)*(9*r + 9*s - 5) - k1**4*(4*C - 2)*(2*r**2 + 2*r*s + r - s - 3) + 2*k1**2*k2**2*(-14*C*(r - 1)*(3*r + 3*s - 2) + K*r**2 + K*r*s + 20*K*r + 12*K*s - 12*K + b1*(9*r**2 + r*(9*s - 2) + 3*s - 5) + 21*r**2 + 21*r*s - 35*r - 21*s + 14)) + 42*k1**2*k2**2*(K*b1*(2*r**2 + 2*r*s + r - 3*s) - 2*g2*(r**2 + r*(s - 1) - 3*s))) - 33*b1**2*k2**2*(D1*fd*r*(14*K*k1**2*(r + s) + f*k1**2*(18*r + 18*s + 5) + 14*f*k2**2*(9*r + 9*s - 5)) + Dd*f*(14*K*k1**2*(4*r**2 + r*(4*s + 3) - 3*s) + f*(k1**2*(36*r**2 + 36*r*s + r + 6*s - 10) + 7*k2**2*(4*r - 1)*(9*r + 9*s - 5)))) - 11*b1*(D1*(f**2*fd*k2**2*(k1**2*(27*r**2 + 3*r*(9*s - 40) - 84*s + 56) - 9*k2**2*(3*r + 9*s - 5)) + 6*f*k1**2*(K*fd*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10) - fd*r*(2*C - 1)*(k1**2*(4*r + 4*s + 5) + 14*k2**2*(3*r + 3*s - 2)) - 14*gd2*k2**2*r*(r + s + 2)) - 84*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(36*r**2 + r*(36*s - 167) - 110*s + 90) + 18*k2**2*(4*r - 1)) - 6*f*k1**2*(k1**2*(2*C - 1)*(8*r**2 + 8*r*(s + 1) - s - 3) + k2**2*(14*C*(4*r - 1)*(3*r + 3*s - 2) - K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + (7 - 28*r)*(3*r + 3*s - 2))) - 84*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(80*r**2 + 80*r*(s - 1) - 42*s + 26) + 11*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + 22*f*k1**2*(fd*(2*C - 1)*(k1**2*(18*r**2 + 18*r*(s - 1) - 15*s + 7) + 9*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + 6*gd2*k2**2*(r**2 + r*(s + 20) + 12*s - 12)) + 132*fd*g2*k1**2*k2**2*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(5*f**2*k2**2*(k1**2*(80*r**2 + 80*r*(s - 1) - 42*s + 26) + 11*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + f*k1**2*(44*C - 22)*(k1**2*(24*r**2 + 24*r*(s - 1) - 19*s + 11) + 9*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 132*g2*k1**2*k2**2*(4*r**2 + r*(4*s + 59) + 37*s - 34))))/(3465*d**2*k3**5) + D1**3*Pkd1*Pkd3*st**2*(-2*D1*bd1*f**2*k1**2*(2*C - 1)*(2*r**2 + r*(2*s - 5) - 4*s) + 7*b1**3*k2**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s + r + 2*s - 2)) + b1**2*(D1*(7*bd1*f*k2**2*(3*r**2 + 3*r*s + 2*r + 2*s - 2) - 2*fd*(f*k2**2*(3*r + 2) + k1**2*r*(14 - 28*C))*(r + s - 1)) + Dd*f*(f*k2**2*(-12*r**2 - 12*r*s + r - 20*s + 12) + k1**2*(28*C - 14)*(8*r**2 + 8*r*(s - 1) - s + 1))) - b1*f*(D1*bd1*(f*k2**2*(6*r**2 + 6*r*s + r + 16*s - 8) + k1**2*(14 - 28*C)*(4*r**2 + 4*r*(s - 1) - s + 1)) + k1**2*(4*C - 2)*(D1*fd*(4*r - 9)*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 3) - 17*s + 13))))/(105*d**2*k1*k3) + D1**3*Pkd1*Pkd3*(-4*D1*bd1*f*k1**2*(b2 - 2*g2)*(2*r**2 + 2*r*(s - 1) - s) + 5*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1))*(r + s - 1) + b1**2*(-D1*(r + s - 1)*(8*K*fd*k1**2*(r - 1) + 5*bd1*f*k2**2*(1 - 3*r) + 3*f*fd*k2**2*(1 - 2*r)) + Dd*f*(-4*K*k1**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + 3*f*k2**2*(4*r - 1)*(r + s - 1))) - 2*b1*(8*D1*K*bd1*f*k1**2*r**2 + 8*D1*K*bd1*f*k1**2*r*s - 10*D1*K*bd1*f*k1**2*r - 4*D1*K*bd1*f*k1**2*s + 2*D1*K*bd1*f*k1**2 - 3*D1*bd1*f**2*k2**2*r**2 - 3*D1*bd1*f**2*k2**2*r*s + 3*D1*bd1*f**2*k2**2*r + 2*D1*bd2*f*k1**2*(2*r - 1)*(r + s - 1) - 8*D1*f*gd2*k1**2*r**2 - 8*D1*f*gd2*k1**2*r*s + 12*D1*f*gd2*k1**2*r + 4*D1*f*gd2*k1**2*s - 4*D1*f*gd2*k1**2 - 8*D1*fd*g2*k1**2*r**2 - 8*D1*fd*g2*k1**2*r*s + 16*D1*fd*g2*k1**2*r + 8*D1*fd*g2*k1**2*s - 8*D1*fd*g2*k1**2 - 32*Dd*f*g2*k1**2*r**2 - 32*Dd*f*g2*k1**2*r*s + 48*Dd*f*g2*k1**2*r + 20*Dd*f*g2*k1**2*s - 16*Dd*f*g2*k1**2 + 2*b2*k1**2*(2*D1*fd*(r - 1)*(r + s - 1) + Dd*f*(8*r**2 + 8*r*s - 12*r - 5*s + 4))))/(15*d**2*k1*k3) + D1**3*Pkd1*Pkd3*st**2*(21*b1**3*k1**2*k2**2*(3*D1*fd*r*(r + s - 1) + Dd*f*(12*r**2 + r*(12*s - 17) - 4*s + 4)) + 3*b1**2*(D1*(7*bd1*f*k1**2*k2**2*(9*r**2 + r*(9*s - 14) - 4*s + 4) + fd*(14*K*k1**2*k2**2*r*(r + s) + f*k1**2*k2**2*(16*r**2 + r*(16*s + 11) + 22*s - 22) + 28*f*k2**4*r*(3*r + 3*s - 2) + k1**4*r*(28 - 56*C)*(r + s - 1))) + 2*Dd*f*(7*f*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(7 - 14*C)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(7*K*(4*r**2 + r*(4*s + 3) - 3*s) + 2*f*(8*r**2 + 8*r*s + 4*r + 15*s - 10)))) + b1*(3*D1*bd1*f*(14*f*k2**4*(2*r - 1)*(3*r + 3*s - 2) + k1**4*(14 - 28*C)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(14*K*(2*r**2 + 2*r*s + r - 3*s) + f*(16*r**2 + r*(16*s + 5) + 38*s - 18))) + 3*D1*(f**2*fd*k2**2*(k1**2*(21*r**2 + r*(21*s - 52) - 28*s + 24) + 6*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 2*f*k1**2*(fd*k1**2*(18*C - 9)*(2*r + s - 1) - fd*k2**2*(K*(2*r**2 + r*(2*s + 19) + 13*s - 10) + r*(14 - 28*C)*(3*r + 3*s - 2)) + k2**2*r*(-7*bd2 + 14*gd2)*(r + s + 2)) + 14*fd*k1**2*k2**2*r*(b2 - 2*g2)*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(84*r**2 + r*(84*s - 215) - 116*s + 96) + 18*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 6*f*k1**2*(k1**2*(32*C - 16)*(2*r + s - 1) + k2**2*(14*C*(4*r - 1)*(3*r + 3*s - 2) - K*(4*r**2 + 4*r*s + 59*r + 37*s - 34) + (7 - 28*r)*(3*r + 3*s - 2))) + k1**2*k2**2*(42*b2 - 84*g2)*(4*r**2 + r*(4*s + 3) - 3*s))) + f*(D1*bd1*(f**2*k2**2*(k1**2*(21*r**2 + r*(21*s - 59) - 32*s + 24) + 18*k2**2*r*(3*r + 3*s - 2)) - 6*f*k1**2*(k1**2*(6*C - 3)*(2*r + s - 1) + k2**2*(14*C*(r - 1)*(3*r + 3*s - 2) - K*(r**2 + r*(s + 20) + 12*s - 12) + (7 - 7*r)*(3*r + 3*s - 2))) + k1**2*k2**2*(42*b2 - 84*g2)*(r**2 + r*(s - 1) - 3*s)) + 2*k1**2*(D1*(f*(-fd*(2*C - 1)*(k1**2*(18*r**2 + 18*r*(s - 1) - 15*s + 7) + 9*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + k2**2*(3*bd2 - 6*gd2)*(r**2 + r*(s + 20) + 12*s - 12)) + 3*fd*k2**2*(b2 - 2*g2)*(2*r**2 + r*(2*s + 19) + 13*s - 10)) + Dd*f*(-f*(2*C - 1)*(k1**2*(24*r**2 + 24*r*(s - 1) - 19*s + 11) + 9*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + k2**2*(3*b2 - 6*g2)*(4*r**2 + r*(4*s + 59) + 37*s - 34)))))/(315*d**2*k1*k3**3)
        perm23 = -16*D1**3*Pk2*Pk3*ct**8*f*k1**2*k2**4*(792*C*D1*f*fd*r**2 + 1584*C*D1*f*fd*r*s - 858*C*D1*f*fd*r + 792*C*D1*f*fd*s**2 - 858*C*D1*f*fd*s + 220*C*D1*f*fd + 1056*C*Dd*f**2*r**2 + 2112*C*Dd*f**2*r*s - 1232*C*Dd*f**2*r + 1056*C*Dd*f**2*s**2 - 1232*C*Dd*f**2*s + 330*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 700*D1*f**2*fd*r**2 + 1400*D1*f**2*fd*r*s - 973*D1*f**2*fd*r + 700*D1*f**2*fd*s**2 - 973*D1*f**2*fd*s + 336*D1*f**2*fd - 792*D1*f*fd*r**2 - 1584*D1*f*fd*r*s + 858*D1*f*fd*r - 792*D1*f*fd*s**2 + 858*D1*f*fd*s - 220*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 700*Dd*f**3*r**2 + 1400*Dd*f**3*r*s - 973*Dd*f**3*r + 700*Dd*f**3*s**2 - 973*Dd*f**3*s + 336*Dd*f**3 - 1056*Dd*f**2*r**2 - 2112*Dd*f**2*r*s + 1232*Dd*f**2*r - 1056*Dd*f**2*s**2 + 1232*Dd*f**2*s - 330*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(231*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct**7*f*k1*k2**3*(-13860*C*D1*f*fd*k1**2*r**2 - 27720*C*D1*f*fd*k1**2*r*s + 16500*C*D1*f*fd*k1**2*r - 13860*C*D1*f*fd*k1**2*s**2 + 16500*C*D1*f*fd*k1**2*s - 4840*C*D1*f*fd*k1**2 - 15840*C*D1*f*fd*k2**2*r**2 - 55440*C*D1*f*fd*k2**2*r*s + 21120*C*D1*f*fd*k2**2*r - 15840*C*D1*f*fd*k2**2*s**2 + 33000*C*D1*f*fd*k2**2*s - 8360*C*D1*f*fd*k2**2 - 18480*C*Dd*f**2*k1**2*r**2 - 36960*C*Dd*f**2*k1**2*r*s + 23540*C*Dd*f**2*k1**2*r - 18480*C*Dd*f**2*k1**2*s**2 + 23540*C*Dd*f**2*k1**2*s - 7260*C*Dd*f**2*k1**2 - 21120*C*Dd*f**2*k2**2*r**2 - 73920*C*Dd*f**2*k2**2*r*s + 28600*C*Dd*f**2*k2**2*r - 21120*C*Dd*f**2*k2**2*s**2 + 48400*C*Dd*f**2*k2**2*s - 10560*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(18*K - 18)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 21140*D1*f**2*fd*k1**2*r**2 - 42280*D1*f**2*fd*k1**2*r*s + 30555*D1*f**2*fd*k1**2*r - 21140*D1*f**2*fd*k1**2*s**2 + 30555*D1*f**2*fd*k1**2*s - 11025*D1*f**2*fd*k1**2 + 13860*D1*f*fd*k1**2*r**2 + 27720*D1*f*fd*k1**2*r*s - 16500*D1*f*fd*k1**2*r + 13860*D1*f*fd*k1**2*s**2 - 16500*D1*f*fd*k1**2*s + 4840*D1*f*fd*k1**2 + 11880*D1*f*fd*k2**2*r**2 + 35640*D1*f*fd*k2**2*r*s - 14850*D1*f*fd*k2**2*r + 11880*D1*f*fd*k2**2*s**2 - 20790*D1*f*fd*k2**2*s + 5280*D1*f*fd*k2**2 + 7524*D1*f*gd2*k1**2*r**2 + 15048*D1*f*gd2*k1**2*r*s - 12672*D1*f*gd2*k1**2*r + 7524*D1*f*gd2*k1**2*s**2 - 12672*D1*f*gd2*k1**2*s + 5148*D1*f*gd2*k1**2 + 7920*D1*f*gd2*k2**2*r**2 + 15840*D1*f*gd2*k2**2*r*s - 11880*D1*f*gd2*k2**2*r + 7920*D1*f*gd2*k2**2*s**2 - 11880*D1*f*gd2*k2**2*s + 3960*D1*f*gd2*k2**2 + 15048*D1*fd*g2*k1**2*r**2 + 30096*D1*fd*g2*k1**2*r*s - 17820*D1*fd*g2*k1**2*r + 15048*D1*fd*g2*k1**2*s**2 - 17820*D1*fd*g2*k1**2*s + 5148*D1*fd*g2*k1**2 + 15840*D1*fd*g2*k2**2*r**2 + 31680*D1*fd*g2*k2**2*r*s - 15840*D1*fd*g2*k2**2*r + 15840*D1*fd*g2*k2**2*s**2 - 15840*D1*fd*g2*k2**2*s + 3960*D1*fd*g2*k2**2 - 21140*Dd*f**3*k1**2*r**2 - 42280*Dd*f**3*k1**2*r*s + 30555*Dd*f**3*k1**2*r - 21140*Dd*f**3*k1**2*s**2 + 30555*Dd*f**3*k1**2*s - 11025*Dd*f**3*k1**2 + 18480*Dd*f**2*k1**2*r**2 + 36960*Dd*f**2*k1**2*r*s - 23540*Dd*f**2*k1**2*r + 18480*Dd*f**2*k1**2*s**2 - 23540*Dd*f**2*k1**2*s + 7260*Dd*f**2*k1**2 + 15840*Dd*f**2*k2**2*r**2 + 47520*Dd*f**2*k2**2*r*s - 20460*Dd*f**2*k2**2*r + 15840*Dd*f**2*k2**2*s**2 - 30360*Dd*f**2*k2**2*s + 6930*Dd*f**2*k2**2 + 30096*Dd*f*g2*k1**2*r**2 + 60192*Dd*f*g2*k1**2*r*s - 43164*Dd*f*g2*k1**2*r + 30096*Dd*f*g2*k1**2*s**2 - 43164*Dd*f*g2*k1**2*s + 15444*Dd*f*g2*k1**2 + 31680*Dd*f*g2*k2**2*r**2 + 63360*Dd*f*g2*k2**2*r*s - 39600*Dd*f*g2*k2**2*r + 31680*Dd*f*g2*k2**2*s**2 - 39600*Dd*f*g2*k2**2*s + 11880*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(18 - 18*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(18 - 18*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(1155*d**2*k3**8) - 16*D1**3*Pk2*Pk3*ct**6*f*k1**2*k2**4*st**2*(1782*C*D1*f*fd*r**2 + 3564*C*D1*f*fd*r*s - 1980*C*D1*f*fd*r + 1782*C*D1*f*fd*s**2 - 1980*C*D1*f*fd*s + 528*C*D1*f*fd + 2376*C*Dd*f**2*r**2 + 4752*C*Dd*f**2*r*s - 2838*C*Dd*f**2*r + 2376*C*Dd*f**2*s**2 - 2838*C*Dd*f**2*s + 792*C*Dd*f**2 + 297*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2212*D1*f**2*fd*r**2 + 4424*D1*f**2*fd*r*s - 3087*D1*f**2*fd*r + 2212*D1*f**2*fd*s**2 - 3087*D1*f**2*fd*s + 1071*D1*f**2*fd - 1782*D1*f*fd*r**2 - 3564*D1*f*fd*r*s + 1980*D1*f*fd*r - 1782*D1*f*fd*s**2 + 1980*D1*f*fd*s - 528*D1*f*fd - 1188*D1*f*gd2*r**2 - 2376*D1*f*gd2*r*s + 1782*D1*f*gd2*r - 1188*D1*f*gd2*s**2 + 1782*D1*f*gd2*s - 594*D1*f*gd2 - 2376*D1*fd*g2*r**2 - 4752*D1*fd*g2*r*s + 2376*D1*fd*g2*r - 2376*D1*fd*g2*s**2 + 2376*D1*fd*g2*s - 594*D1*fd*g2 + 2212*Dd*f**3*r**2 + 4424*Dd*f**3*r*s - 3087*Dd*f**3*r + 2212*Dd*f**3*s**2 - 3087*Dd*f**3*s + 1071*Dd*f**3 - 2376*Dd*f**2*r**2 - 4752*Dd*f**2*r*s + 2838*Dd*f**2*r - 2376*Dd*f**2*s**2 + 2838*Dd*f**2*s - 792*Dd*f**2 - 4752*Dd*f*g2*r**2 - 9504*Dd*f*g2*r*s + 5940*Dd*f*g2*r - 4752*Dd*f*g2*s**2 + 5940*Dd*f*g2*s - 1782*Dd*f*g2 + 297*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(231*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**6*k2**2*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + k1**2*k2**2*(r + s)*(-252*K*b1 + 252*b1 + 252*g2)) + 1386*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k1**2*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) - 18*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) - 14*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 252*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + 252*g2*k1**2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**4*(6*C - 6)*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(72*r**2 + 6*r*(69*s - 22) + 72*s**2 - 267*s + 71) + 81*r**2 + 144*r*(3*s - 1) + 81*s**2 - 279*s + 75) - k2**4*(2*C - 1)*(36*r**2 + 6*r*(21*s - 8) + 36*s**2 - 75*s + 19)) + 18*gd2*(k1**4*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 396*fd*g2*(k1**4*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 9) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(35*f**2*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 110*f*(k1**4*(6*C - 6)*(4*r + 4*s - 3) + k1**2*k2**2*(-2*C*(96*r**2 + r*(552*s - 169) + 96*s**2 - 394*s + 84) + 108*r**2 + 6*r*(96*s - 31) + 108*s**2 - 411*s + 90) - k2**4*(2*C - 1)*(48*r**2 + r*(168*s - 65) + 48*s**2 - 110*s + 24)) - 396*g2*(k1**4*(16*r**2 + 16*r*(2*s - 3) + 16*s**2 - 48*s + 27) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1155*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct**5*f*k1*k2**3*st**2*(-24552*C*D1*f*fd*k1**2*r**2 - 49104*C*D1*f*fd*k1**2*r*s + 28776*C*D1*f*fd*k1**2*r - 24552*C*D1*f*fd*k1**2*s**2 + 28776*C*D1*f*fd*k1**2*s - 8272*C*D1*f*fd*k1**2 - 35640*C*D1*f*fd*k2**2*r**2 - 118800*C*D1*f*fd*k2**2*r*s + 47520*C*D1*f*fd*k2**2*r - 35640*C*D1*f*fd*k2**2*s**2 + 71280*C*D1*f*fd*k2**2*s - 18480*C*D1*f*fd*k2**2 - 32736*C*Dd*f**2*k1**2*r**2 - 65472*C*Dd*f**2*k1**2*r*s + 41096*C*Dd*f**2*k1**2*r - 32736*C*Dd*f**2*k1**2*s**2 + 41096*C*Dd*f**2*k1**2*s - 12408*C*Dd*f**2*k1**2 - 47520*C*Dd*f**2*k2**2*r**2 - 158400*C*Dd*f**2*k2**2*r*s + 64680*C*Dd*f**2*k2**2*r - 47520*C*Dd*f**2*k2**2*s**2 + 104280*C*Dd*f**2*k2**2*s - 23760*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(12*K - 12)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 52260*D1*f**2*fd*k1**2*r**2 - 104520*D1*f**2*fd*k1**2*r*s + 75255*D1*f**2*fd*k1**2*r - 52260*D1*f**2*fd*k1**2*s**2 + 75255*D1*f**2*fd*k1**2*s - 27045*D1*f**2*fd*k1**2 + 24552*D1*f*fd*k1**2*r**2 + 49104*D1*f*fd*k1**2*r*s - 28776*D1*f*fd*k1**2*r + 24552*D1*f*fd*k1**2*s**2 - 28776*D1*f*fd*k1**2*s + 8272*D1*f*fd*k1**2 + 26730*D1*f*fd*k2**2*r**2 + 77220*D1*f*fd*k2**2*r*s - 33660*D1*f*fd*k2**2*r + 26730*D1*f*fd*k2**2*s**2 - 45540*D1*f*fd*k2**2*s + 11880*D1*f*fd*k2**2 + 15048*D1*f*gd2*k1**2*r**2 + 30096*D1*f*gd2*k1**2*r*s - 25344*D1*f*gd2*k1**2*r + 15048*D1*f*gd2*k1**2*s**2 - 25344*D1*f*gd2*k1**2*s + 10296*D1*f*gd2*k1**2 + 23760*D1*f*gd2*k2**2*r**2 + 47520*D1*f*gd2*k2**2*r*s - 35640*D1*f*gd2*k2**2*r + 23760*D1*f*gd2*k2**2*s**2 - 35640*D1*f*gd2*k2**2*s + 11880*D1*f*gd2*k2**2 + 30096*D1*fd*g2*k1**2*r**2 + 60192*D1*fd*g2*k1**2*r*s - 35640*D1*fd*g2*k1**2*r + 30096*D1*fd*g2*k1**2*s**2 - 35640*D1*fd*g2*k1**2*s + 10296*D1*fd*g2*k1**2 + 47520*D1*fd*g2*k2**2*r**2 + 95040*D1*fd*g2*k2**2*r*s - 47520*D1*fd*g2*k2**2*r + 47520*D1*fd*g2*k2**2*s**2 - 47520*D1*fd*g2*k2**2*s + 11880*D1*fd*g2*k2**2 - 52260*Dd*f**3*k1**2*r**2 - 104520*Dd*f**3*k1**2*r*s + 75255*Dd*f**3*k1**2*r - 52260*Dd*f**3*k1**2*s**2 + 75255*Dd*f**3*k1**2*s - 27045*Dd*f**3*k1**2 + 32736*Dd*f**2*k1**2*r**2 + 65472*Dd*f**2*k1**2*r*s - 41096*Dd*f**2*k1**2*r + 32736*Dd*f**2*k1**2*s**2 - 41096*Dd*f**2*k1**2*s + 12408*Dd*f**2*k1**2 + 35640*Dd*f**2*k2**2*r**2 + 102960*Dd*f**2*k2**2*r*s - 46530*Dd*f**2*k2**2*r + 35640*Dd*f**2*k2**2*s**2 - 66330*Dd*f**2*k2**2*s + 15840*Dd*f**2*k2**2 + 60192*Dd*f*g2*k1**2*r**2 + 120384*Dd*f*g2*k1**2*r*s - 86328*Dd*f*g2*k1**2*r + 60192*Dd*f*g2*k1**2*s**2 - 86328*Dd*f*g2*k1**2*s + 30888*Dd*f*g2*k1**2 + 95040*Dd*f*g2*k2**2*r**2 + 190080*Dd*f*g2*k2**2*r*s - 118800*Dd*f*g2*k2**2*r + 95040*Dd*f*g2*k2**2*s**2 - 118800*Dd*f*g2*k2**2*s + 35640*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(12 - 12*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(12 - 12*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(1155*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct**5*k1*k2*(11*D1*bd1*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 18*f*(k1**4*(K - 1)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) + k1**2*k2**2*(r + s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5) + 9*K*r**2 + 18*K*r*s - 10*K*r + 9*K*s**2 - 10*K*s + K + b1*(13*r**2 + 2*r*(13*s - 8) + 13*s**2 - 16*s + 3) - 5*r**2 + 18*r*s + 4*r - 5*s**2 + 4*s + 1)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + 3*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*(3*fd*(k1**4*(K - 1)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) - 10*r**2 + 36*r*s + 31*r - 10*s**2 - 11*s - 13)) + 28*gd2*k2**2*(k1**2 + 3*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k2**2*(k1**2 + 3*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 18*f*(k1**4*(K - 1)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) - k2**4*(4*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) - K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 20*r**2 - 72*r*s - 53*r + 20*s**2 + 17*s + 25)) + 168*g2*k2**2*(k1**2 + 3*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(35*f**2*fd*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**4*(2*C - 2)*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + 3*k1**2*k2**2*(C*(90*r**2 + 6*r*(6*s - 13) + 90*s**2 - 6*s + 4) - 90*r**2 - 3*r*(36*s - 31) - 90*s**2 + 57*s - 18) + k2**4*(C*(90*r**2 - 6*r*(6*s + 11) + 90*s**2 + 42*s - 8) - 99*r**2 + r*(96 - 90*s) - 99*s**2 + 42*s - 14)) - 18*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1)) + 396*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1)) + Dd*f*(35*f**2*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 110*f*(k1**4*(2*C - 2)*(60*r**2 + r*(120*s - 73) + 60*s**2 - 73*s + 21) + 3*k1**2*k2**2*(2*C*(60*r**2 + r*(24*s - 61) + 60*s**2 - s + 9) - 120*r**2 - 3*r*(48*s - 46) - 120*s**2 + 78*s - 33) + k2**4*(2*C*(60*r**2 - r*(24*s + 55) + 60*s**2 + 35*s + 3) - 132*r**2 - 5*r*(24*s - 29) - 132*s**2 + 55*s - 30)) + 396*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3))))/(1155*d**2*k3**8) - 16*D1**3*Pk2*Pk3*ct**4*f*k1**2*k2**4*st**4*(396*C*D1*f*fd*r**2 + 792*C*D1*f*fd*r*s - 462*C*D1*f*fd*r + 396*C*D1*f*fd*s**2 - 462*C*D1*f*fd*s + 132*C*D1*f*fd + 528*C*Dd*f**2*r**2 + 1056*C*Dd*f**2*r*s - 660*C*Dd*f**2*r + 528*C*Dd*f**2*s**2 - 660*C*Dd*f**2*s + 198*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 812*D1*f**2*fd*r**2 + 1624*D1*f**2*fd*r*s - 1141*D1*f**2*fd*r + 812*D1*f**2*fd*s**2 - 1141*D1*f**2*fd*s + 399*D1*f**2*fd - 396*D1*f*fd*r**2 - 792*D1*f*fd*r*s + 462*D1*f*fd*r - 396*D1*f*fd*s**2 + 462*D1*f*fd*s - 132*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 812*Dd*f**3*r**2 + 1624*Dd*f**3*r*s - 1141*Dd*f**3*r + 812*Dd*f**3*s**2 - 1141*Dd*f**3*s + 399*Dd*f**3 - 528*Dd*f**2*r**2 - 1056*Dd*f**2*r*s + 660*Dd*f**2*r - 528*Dd*f**2*s**2 + 660*Dd*f**2*s - 198*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(77*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**4*k2**2*st**2*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + k1**2*k2**2*(r + s)*(-168*K*b1 + 168*b1 + 168*g2)) + 2772*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) - 6*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) - 28*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(75*f**2*fd*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(fd*(k1**4*(36*C - 36)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(396*r**2 + 6*r*(321*s - 109) + 396*s**2 - 1221*s + 323) - 513*r**2 - 72*r*(30*s - 11) - 513*s**2 + 1359*s - 363) + k2**4*(30*C - 15)*(27*r**2 + 18*r*(5*s - 2) + 27*s**2 - 54*s + 14)) - 18*gd2*(3*k1**4*(3*r**2 + r*(6*s - 8) + 3*s**2 - 8*s + 5) + 2*k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 396*fd*g2*(3*k1**4*(6*r**2 + r*(12*s - 13) + 6*s**2 - 13*s + 5) + 2*k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(75*f**2*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(k1**4*(36*C - 36)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(528*r**2 + r*(2568*s - 853) + 528*s**2 - 1798*s + 390) - 684*r**2 - 30*r*(96*s - 35) - 684*s**2 + 1995*s - 450) + k2**4*(30*C - 15)*(36*r**2 + r*(120*s - 49) + 36*s**2 - 79*s + 18)) - 396*g2*(k1**4*(36*r**2 + r*(72*s - 87) + 36*s**2 - 87*s + 45) + 2*k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1155*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**4*(33*D1*bd1*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 6*f*(k1**6*(2*K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(r + s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(11*r**2 - 48*r*s + 8*r + 11*s**2 + 8*s - 19) + 66*K*r**2 + 132*K*r*s - 99*K*r + 66*K*s**2 - 99*K*s + 33*K + b1*(23*r**2 + r*(46*s - 24) + 23*s**2 - 24*s + 1) - 55*r**2 - 40*r*s + 65*r - 55*s**2 + 65*s - 10) + k2**6*(-2*C*(3*r**2 + 4*r*(5*s - 2) + 3*s**2 - 8*s + 5) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5)) + 28*k2**2*(b1*(3*K*k2**4 + k1**4*(7 - 7*K) - k1**2*k2**2*(K - 3)) + g2*(7*k1**4 + k1**2*k2**2 - 3*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-3*f*k1**2*k2**2*(46*r**2 + r*(92*s - 25) + 46*s**2 - 25*s + 1) + (r + s)**2*(42*K*k2**4 - 14*k1**4*(7*K - 7) - 14*k1**2*k2**2*(K - 3))) - Dd*f*(3*f*k1**2*k2**2*(23*r + 23*s - 1) + (r + s)*(-42*K*k2**4 + 14*k1**4*(7*K - 7) + 14*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 6*f*fd*(k1**6*(2*K - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*r + 2*s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(22*r**2 - r*(96*s + 43) + 22*s**2 + 62*s + 16) + 33*K*(2*r + 2*s - 1)**2 - 110*r**2 - 80*r*s + 145*r - 110*s**2 + 40*s - 45) + k2**6*(-2*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + 7*K*(2*r + 2*s - 1)**2 + 6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2)) + 28*f*gd2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k2**2*(r + s)**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)) + Dd*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 6*f*(k1**6*(2*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(44*r**2 - 2*r*(96*s + 31) + 44*s**2 + 113*s + 13) + 33*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 220*r**2 - 5*r*(32*s - 62) - 220*s**2 + 135*s - 100) + k2**6*(-2*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 12*r**2 + 80*r*s - 8*r + 12*s**2 - 43*s + 1)) + 28*g2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-35*f**2*fd*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**6*(4*C - 4)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(198*r**2 + 6*r*(57*s - 41) + 198*s**2 - 219*s + 73) - 351*r**2 - 18*r*(36*s - 25) - 351*s**2 + 423*s - 141) + 3*k1**2*k2**4*(2*C*(90*r**2 + 54*r*(3*s - 2) + 90*s**2 - 99*s + 31) - 135*r**2 - 3*r*(84*s - 55) - 135*s**2 + 156*s - 49) + k2**6*(18*C - 9)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 18*gd2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 396*fd*g2*(2*r + 2*s - 1)**2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)) + Dd*f*(-35*f**2*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 110*f*(k1**6*(4*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(C*(528*r**2 + r*(912*s - 706) + 528*s**2 - 616*s + 228) - 468*r**2 - 3*r*(288*s - 214) - 468*s**2 + 597*s - 216) + 3*k1**2*k2**4*(C*(240*r**2 + 432*r*s - 310*r + 240*s**2 - 280*s + 96) - 180*r**2 - 4*r*(84*s - 59) - 180*s**2 + 221*s - 75) + k2**6*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 396*g2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(1155*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct**3*f*k1*k2**3*st**4*(-3564*C*D1*f*fd*k1**2*r**2 - 7128*C*D1*f*fd*k1**2*r*s + 4092*C*D1*f*fd*k1**2*r - 3564*C*D1*f*fd*k1**2*s**2 + 4092*C*D1*f*fd*k1**2*s - 1144*C*D1*f*fd*k1**2 - 7920*C*D1*f*fd*k2**2*r**2 - 23760*C*D1*f*fd*k2**2*r*s + 10560*C*D1*f*fd*k2**2*r - 7920*C*D1*f*fd*k2**2*s**2 + 14520*C*D1*f*fd*k2**2*s - 3960*C*D1*f*fd*k2**2 - 4752*C*Dd*f**2*k1**2*r**2 - 9504*C*Dd*f**2*k1**2*r*s + 5852*C*Dd*f**2*k1**2*r - 4752*C*Dd*f**2*k1**2*s**2 + 5852*C*Dd*f**2*k1**2*s - 1716*C*Dd*f**2*k1**2 - 10560*C*Dd*f**2*k2**2*r**2 - 31680*C*Dd*f**2*k2**2*r*s + 14520*C*Dd*f**2*k2**2*r - 10560*C*Dd*f**2*k2**2*s**2 + 21120*C*Dd*f**2*k2**2*s - 5280*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(6*K - 6)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 13700*D1*f**2*fd*k1**2*r**2 - 27400*D1*f**2*fd*k1**2*r*s + 19615*D1*f**2*fd*k1**2*r - 13700*D1*f**2*fd*k1**2*s**2 + 19615*D1*f**2*fd*k1**2*s - 7005*D1*f**2*fd*k1**2 + 3564*D1*f*fd*k1**2*r**2 + 7128*D1*f*fd*k1**2*r*s - 4092*D1*f*fd*k1**2*r + 3564*D1*f*fd*k1**2*s**2 - 4092*D1*f*fd*k1**2*s + 1144*D1*f*fd*k1**2 + 5940*D1*f*fd*k2**2*r**2 + 15840*D1*f*fd*k2**2*r*s - 7590*D1*f*fd*k2**2*r + 5940*D1*f*fd*k2**2*s**2 - 9570*D1*f*fd*k2**2*s + 2640*D1*f*fd*k2**2 + 2508*D1*f*gd2*k1**2*r**2 + 5016*D1*f*gd2*k1**2*r*s - 4224*D1*f*gd2*k1**2*r + 2508*D1*f*gd2*k1**2*s**2 - 4224*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 7920*D1*f*gd2*k2**2*r**2 + 15840*D1*f*gd2*k2**2*r*s - 11880*D1*f*gd2*k2**2*r + 7920*D1*f*gd2*k2**2*s**2 - 11880*D1*f*gd2*k2**2*s + 3960*D1*f*gd2*k2**2 + 5016*D1*fd*g2*k1**2*r**2 + 10032*D1*fd*g2*k1**2*r*s - 5940*D1*fd*g2*k1**2*r + 5016*D1*fd*g2*k1**2*s**2 - 5940*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 + 15840*D1*fd*g2*k2**2*r**2 + 31680*D1*fd*g2*k2**2*r*s - 15840*D1*fd*g2*k2**2*r + 15840*D1*fd*g2*k2**2*s**2 - 15840*D1*fd*g2*k2**2*s + 3960*D1*fd*g2*k2**2 - 13700*Dd*f**3*k1**2*r**2 - 27400*Dd*f**3*k1**2*r*s + 19615*Dd*f**3*k1**2*r - 13700*Dd*f**3*k1**2*s**2 + 19615*Dd*f**3*k1**2*s - 7005*Dd*f**3*k1**2 + 4752*Dd*f**2*k1**2*r**2 + 9504*Dd*f**2*k1**2*r*s - 5852*Dd*f**2*k1**2*r + 4752*Dd*f**2*k1**2*s**2 - 5852*Dd*f**2*k1**2*s + 1716*Dd*f**2*k1**2 + 7920*Dd*f**2*k2**2*r**2 + 21120*Dd*f**2*k2**2*r*s - 10560*Dd*f**2*k2**2*r + 7920*Dd*f**2*k2**2*s**2 - 13860*Dd*f**2*k2**2*s + 3630*Dd*f**2*k2**2 + 10032*Dd*f*g2*k1**2*r**2 + 20064*Dd*f*g2*k1**2*r*s - 14388*Dd*f*g2*k1**2*r + 10032*Dd*f*g2*k1**2*s**2 - 14388*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 31680*Dd*f*g2*k2**2*r**2 + 63360*Dd*f*g2*k2**2*r*s - 39600*Dd*f*g2*k2**2*r + 31680*Dd*f*g2*k2**2*s**2 - 39600*Dd*f*g2*k2**2*s + 11880*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(6 - 6*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(6 - 6*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(385*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**3*k1*k2*st**2*(11*D1*bd1*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 3*f*(k1**4*(5*K - 5)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) + 3*k2**4*(-4*C*(5*r**2 + 24*r*s - 11*r + 5*s**2 - 11*s + 6) + 18*K*r**2 + 36*K*r*s - 20*K*r + 18*K*s**2 - 20*K*s + 2*K + b1*(26*r**2 + 4*r*(13*s - 8) + 26*s**2 - 32*s + 6) - 13*r**2 + 2*r*s + 16*r - 13*s**2 + 16*s - 3)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - g2*(k1**2 + 6*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*(fd*(k1**4*(5*K - 5)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(10*r**2 + r*(48*s - 3) + 10*s**2 - 24*s - 1) - 2*K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) + 26*r**2 - 4*r*s - 47*r + 26*s**2 - 5*s + 17)) + 28*gd2*k2**2*(k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 3*f*(k1**4*(5*K - 5)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 2*K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 52*r**2 - 8*r*s - 93*r + 52*s**2 - 23*s + 37)) + 84*g2*k2**2*(k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(5*f**2*fd*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(fd*(k1**4*(3*C - 3)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 9*k1**2*k2**2*(C*(9*r**2 + r*(19 - 150*s) + 9*s**2 + 103*s - 26) - 18*r**2 + r*(48*s + 7) - 18*s**2 - 35*s + 8) + k2**4*(2*C*(45*r**2 + r*(21 - 342*s) + 45*s**2 + 237*s - 58) - 207*r**2 + 6*r*(3*s + 28) - 207*s**2 - 48*s + 4)) - 3*gd2*(5*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + 3*k1**2*k2**2*(17*r**2 + r*(34*s - 8) + 17*s**2 - 8*s - 9) + 6*k2**4*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1))) + 66*fd*g2*(5*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + 3*k1**2*k2**2*(34*r**2 + 68*r*s + r + 34*s**2 + s - 9) + 6*k2**4*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1))) + Dd*f*(5*f**2*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(k1**4*(3*C - 3)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 9*k1**2*k2**2*(C*(12*r**2 - 200*r*s + 15*r + 12*s**2 + 155*s - 25) - 24*r**2 + 64*r*s + 16*r - 24*s**2 - 54*s + 5) + k2**4*(2*C*(60*r**2 - 456*r*s - r + 60*s**2 + 359*s - 51) - 276*r**2 + 24*r*s + 271*r - 276*s**2 - 89*s - 30)) + 66*g2*(5*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + 3*k1**2*k2**2*(68*r**2 + r*(136*s - 15) + 68*s**2 - 15*s - 27) + 6*k2**4*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3)))))/(1155*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**3*k1*(D1*(-462*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) - 5*f**3*k1**2*(11*bd1*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(r + s - 1) + 7*fd*k1**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 11*f**2*k2**2*(18*bd1*(k1**4*(r + s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) - k1**2*k2**2*(C*(-96*r**2 - 80*r*s + 88*r - 96*s**2 + 88*s + 8) - 65*K*r**2 - 130*K*r*s + 108*K*r - 65*K*s**2 + 108*K*s - 43*K + b1*(17*r**2 + r*(34*s - 36) + 17*s**2 - 36*s + 19) + 107*r**2 + 158*r*s - 136*r + 107*s**2 - 136*s + 29) + k2**4*(4*C*(8*r**2 + 2*r*s - 5*r + 8*s**2 - 5*s - 3) + 35*K*r**2 + 70*K*r*s - 56*K*r + 35*K*s**2 - 56*K*s + 21*K - 7*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 23*r**2 - 18*r*s + 17*r - 23*s**2 + 17*s + 6)) + 5*fd*(3*r + 3*s - 2)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) - 36*gd2*(k1**4*(15*r**2 + r*(30*s - 26) + 15*s**2 - 26*s + 11) + k1**2*k2**2*(65*r**2 + 2*r*(65*s - 54) + 65*s**2 - 108*s + 43) + 7*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) + 33*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(3*fd*(k1**4*(2*r + 2*s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(24*r**2 + 4*r*(5*s - 6) + 24*s**2 - 3*s + 6) + K*(130*r**2 + 260*r*s - 151*r + 130*s**2 - 151*s + 43) - 214*r**2 - 316*r*s + 221*r - 214*s**2 + 137*s - 57) + k2**4*(4*C*(16*r**2 + 4*r*(s - 4) + 16*s**2 + 5*s + 4) + 7*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 46*r**2 - 36*r*s + 39*r - 46*s**2 - 3*s - 8)) + (14*bd1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 112*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(56*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*fd*(k1**4*(30*r**2 + r*(60*s - 37) + 30*s**2 - 37*s + 11) + k1**2*k2**2*(130*r**2 + r*(260*s - 151) + 130*s**2 - 151*s + 43) + 7*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(-462*b1*k2**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 35*f**3*k1**4*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 55*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) + 99*f*k2**2*(b1**2*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(4*r + 4*s - 3)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(48*r**2 + r*(40*s - 53) + 48*s**2 - 18*s + 11) + K*(260*r**2 + 520*r*s - 367*r + 260*s**2 - 367*s + 129) - 428*r**2 - 632*r*s + 521*r - 428*s**2 + 381*s - 143) + k2**4*(4*C*(32*r**2 + r*(8*s - 33) + 32*s**2 + 2*s + 5) + 7*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 92*r**2 - 72*r*s + 87*r - 92*s**2 + 17*s - 10)) + 4*g2*(k1**4*(60*r**2 + r*(120*s - 89) + 60*s**2 - 89*s + 33) + k1**2*k2**2*(260*r**2 + r*(520*s - 367) + 260*s**2 - 367*s + 129) + 7*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(1155*d**2*k2*k3**8) - 16*D1**3*Pk2*Pk3*ct**2*f*k1**2*k2**4*st**6*(198*C*D1*f*fd*r**2 + 396*C*D1*f*fd*r*s - 264*C*D1*f*fd*r + 198*C*D1*f*fd*s**2 - 264*C*D1*f*fd*s + 88*C*D1*f*fd + 264*C*Dd*f**2*r**2 + 528*C*Dd*f**2*r*s - 374*C*Dd*f**2*r + 264*C*Dd*f**2*s**2 - 374*C*Dd*f**2*s + 132*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1036*D1*f**2*fd*r**2 + 2072*D1*f**2*fd*r*s - 1477*D1*f**2*fd*r + 1036*D1*f**2*fd*s**2 - 1477*D1*f**2*fd*s + 525*D1*f**2*fd - 198*D1*f*fd*r**2 - 396*D1*f*fd*r*s + 264*D1*f*fd*r - 198*D1*f*fd*s**2 + 264*D1*f*fd*s - 88*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 1036*Dd*f**3*r**2 + 2072*Dd*f**3*r*s - 1477*Dd*f**3*r + 1036*Dd*f**3*s**2 - 1477*Dd*f**3*s + 525*Dd*f**3 - 264*Dd*f**2*r**2 - 528*Dd*f**2*r*s + 374*Dd*f**2*r - 264*Dd*f**2*s**2 + 374*Dd*f**2*s - 132*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(231*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**2*k2**2*st**4*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*b1 + 28*g2)) + 462*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) - 2*f*fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*f*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(15*f**2*fd*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(fd*(k1**4*(6*C - 6)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2) + k1**2*k2**2*(2*C*(144*r**2 + 54*r*(11*s - 4) + 144*s**2 - 369*s + 97) - 207*r**2 - 144*r*(5*s - 2) - 207*s**2 + 441*s - 117) + k2**4*(30*C - 15)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) - 6*gd2*(k1**4*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 132*fd*g2*(k1**4*(10*r**2 + r*(20*s - 17) + 10*s**2 - 17*s + 6) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(15*f**2*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(k1**4*(6*C - 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(2*C*(192*r**2 + 792*r*s - 287*r + 192*s**2 - 542*s + 120) - 276*r**2 - 30*r*(32*s - 13) - 276*s**2 + 645*s - 150) + k2**4*(30*C - 15)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) - 132*g2*(k1**4*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(385*d**2*k3**8) - 16*D1**3*Pk2*Pk3*ct**2*st**2*(33*D1*bd1*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - f*(k1**6*(K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(25*r**2 + 204*r*s - 90*r + 25*s**2 - 90*s + 65) + 183*K*r**2 + 366*K*r*s - 264*K*r + 183*K*s**2 - 264*K*s + 81*K + 12*b1*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) - 71*r**2 + 12*r*s + 75*r - 71*s**2 + 75*s - 4) - 3*k2**6*(2*C*(5*r**2 + r*(24*s - 11) + 5*s**2 - 11*s + 6) - 14*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 5*r**2 - 24*r*s + 11*r - 5*s**2 + 11*s - 6)) + 14*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) - k1**2*k2**2*(K - 3)) - g2*(k1**4 - k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-6*f*k1**2*k2**2*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + (r + s)**2*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3))) + Dd*f*(-6*f*k1**2*k2**2*(9*r + 9*s - 1) + (r + s)*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(50*r**2 + r*(408*s - 1) + 50*s**2 - 232*s - 12) + K*(366*r**2 + 732*r*s - 345*r + 366*s**2 - 345*s + 81) - 142*r**2 + 24*r*s + 233*r - 142*s**2 + 2*s - 81) - 3*k2**6*(C*(20*r**2 + r*(96*s - 6) + 20*s**2 - 48*s - 2) - 14*K*(2*r + 2*s - 1)**2 - 10*r**2 - 48*r*s + 3*r - 10*s**2 + 24*s + 1)) + 14*gd2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 14*fd*g2*k2**2*(r + s)**2*(k1**4 - k1**2*k2**2 + 6*k2**4)) + Dd*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(-k1**6*(K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(2*C*(100*r**2 + 8*r*(102*s - 13) + 100*s**2 - 489*s + 41) - 3*K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 284*r**2 - 48*r*s - 460*r + 284*s**2 - 75*s + 166) + 3*k2**6*(2*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 14*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 20*r**2 - 96*r*s + 18*r - 20*s**2 + 53*s - 4)) - 14*g2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-15*f**2*fd*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(fd*(k1**6*(2*C - 2)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 3*k1**4*k2**2*(2*C*(54*r**2 - 39*r + 54*s**2 + 15*s - 4) - 99*r**2 - 3*r*(30*s - 31) - 99*s**2 + 39*s - 12) + 9*k1**2*k2**4*(4*C*(36*r**2 + 6*r*(9*s - 7) + 36*s**2 - 33*s + 11) - 117*r**2 - 3*r*(66*s - 47) - 117*s**2 + 123*s - 40) + k2**6*(108*C - 54)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 6*gd2*(k1**6*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**4*k2**2*(38*r**2 + r*(76*s - 29) + 38*s**2 - 29*s - 9) + 3*k1**2*k2**4*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 42*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 66*fd*g2*(k1**6*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**4*k2**2*(76*r**2 + 4*r*(38*s - 5) + 76*s**2 - 20*s - 9) + 3*k1**2*k2**4*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 42*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-15*f**2*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(k1**6*(2*C - 2)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 3*k1**4*k2**2*(2*C*(72*r**2 - 64*r + 72*s**2 + 26*s + 3) - 132*r**2 - 3*r*(40*s - 47) - 132*s**2 + 51*s - 27) + 9*k1**2*k2**4*(4*C*(48*r**2 + r*(72*s - 61) + 48*s**2 - 46*s + 18) - 156*r**2 + r*(203 - 264*s) - 156*s**2 + 173*s - 63) + k2**6*(108*C - 54)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 66*g2*(k1**6*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(152*r**2 + r*(304*s - 78) + 152*s**2 - 78*s - 27) + 3*k1**2*k2**4*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 42*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1155*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**2*(D1*bd1*f*(-5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(r + s - 1) - 18*f*(k1**6*(4*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*C*(39*r**2 + 64*r*s - 48*r + 39*s**2 - 48*s + 9) + 18*K*r**2 + 36*K*r*s - 34*K*r + 18*K*s**2 - 34*K*s + 16*K - b1*(59*r**2 + 2*r*(59*s - 46) + 59*s**2 - 92*s + 33) - 69*r**2 - 124*r*s + 93*r - 69*s**2 + 93*s - 24) + k1**2*k2**4*(2*C*(45*r**2 + 76*r*s - 50*r + 45*s**2 - 50*s + 5) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 59*r**2 - 104*r*s + 64*r - 59*s**2 + 64*s - 5) + k2**6*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (-84*b1*(5*K*k2**6 + k1**6*(2*K - 2) + k1**4*k2**2*(21*K - 13) + k1**2*k2**4*(27*K - 10)) + 84*g2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*b1**2*(D1*fd*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10))) + Dd*f*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1)) + (r + s)*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) - 18*f*fd*(k1**6*(4*C - 4)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*C*(78*r**2 + r*(128*s - 71) + 78*s**2 - 50*s + 16) + 2*K*(18*r**2 + 36*r*s - 25*r + 18*s**2 - 25*s + 8) - 138*r**2 - 248*r*s + 131*r - 138*s**2 + 110*s - 31) + k1**2*k2**4*(2*C*(90*r**2 + 152*r*s - 69*r + 90*s**2 - 48*s + 12) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 118*r**2 - 208*r*s + 83*r - 118*s**2 + 62*s - 12) + k2**6*(14*C - 7)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 84*f*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6) + 84*fd*g2*(r + s)**2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6)) - Dd*f*(5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(4*r + 4*s - 3) + 18*f*(k1**6*(4*C - 4)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(C*(312*r**2 + 4*r*(128*s - 87) + 312*s**2 - 278*s + 82) + 2*K*(36*r**2 + 72*r*s - 59*r + 36*s**2 - 59*s + 24) - 276*r**2 - 496*r*s + 324*r - 276*s**2 + 289*s - 86) + k1**2*k2**4*(C*(360*r**2 + 32*r*(19*s - 11) + 360*s**2 - 282*s + 58) + 7*K*(4*r + 4*s - 3)**2 - 236*r**2 - 416*r*s + 218*r - 236*s**2 + 183*s - 29) + k2**6*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 84*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))) + f*k1**2*(D1*(-105*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*f*k2**2*(5*fd*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) + 36*fd*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(105*f**2*k1**4*(r + s - 1) + 10*f*k2**2*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3)) - 36*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3)))))/(105*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct*f*k1*k2**3*st**6*(D1*(f**2*(11*bd1*k2**2*(33*r**2 + r*(66*s - 52) + 33*s**2 - 52*s + 19) - fd*k1**2*(1996*r**2 + r*(3992*s - 2829) + 1996*s**2 - 2829*s + 999)) - 11*f*k2**2*(18*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 72*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 198*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) - Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(499*r + 499*s - 333) - 11*f*k2**2*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(396*K*b1 - 198*b1 - 792*g2)))/(231*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct*k1*k2*st**4*(D1*(-462*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*(11*bd1*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(r + s - 1) - fd*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 11*f**2*k2**2*(-6*bd1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + b1*(-13*r - 13*s + 3) + 8*r + 8*s - 4))*(r + s - 1) + fd*(2*k1**2*(-12*C*(6*r**2 + 36*r*s - 11*r + 6*s**2 - 23*s + 6) + b1*(36*r**2 + r*(72*s - 66) + 36*s**2 - 66*s + 28) + 54*r**2 + 252*r*s - 87*r + 54*s**2 - 159*s + 42) - k2**2*(4*C*(45*r**2 + 3*r*(66*s - 23) + 45*s**2 - 123*s + 32) + 15*b1*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6) - 54*r**2 - 324*r*s + 96*r - 54*s**2 + 204*s - 52)) + 12*gd2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(r + s - 1)) + 33*f*k2**2*(b1**2*fd*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4))*(2*r + 2*s - 1) + 28*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-2*K*bd1 + bd1 + 2*gd2) + 4*g2*(14*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(2*r + 2*s - 1)))) + Dd*f*(-462*b1*k2**4*(b1*(2*K - 1) - 4*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - f**3*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 11*f**2*k2**2*(2*k1**2*(-12*C*(8*r**2 + 48*r*s - 14*r + 8*s**2 - 34*s + 7) + b1*(48*r**2 + r*(96*s - 92) + 48*s**2 - 92*s + 42) + 72*r**2 + 336*r*s - 114*r + 72*s**2 - 234*s + 51) - k2**2*(4*C*(60*r**2 + r*(264*s - 91) + 60*s**2 - 181*s + 39) + 15*b1*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 72*r**2 - 432*r*s + 122*r - 72*s**2 + 302*s - 60)) + 33*f*k2**2*(4*r + 4*s - 3)*(b1**2*k2**2*(13*r + 13*s - 3) - 2*b1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4)) + 4*g2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1)))))/(385*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct*k1*st**2*(D1*(462*b1*fd*k2**4*(r + s)**2*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) + 3*f**3*k1**2*(-11*bd1*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 11*f**2*k2**2*(-6*bd1*(k1**4*(2*K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(-8*C*(4*r**2 + 29*r*s - 13*r + 4*s**2 - 13*s + 9) + 61*K*r**2 + 122*K*r*s - 88*K*r + 61*K*s**2 - 88*K*s + 27*K + 9*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) - 4*r**2 + 76*r*s - 8*r - 4*s**2 - 8*s + 12) - k2**4*(4*C*(r**2 + 6*r*(5*s - 2) + s**2 - 12*s + 11) - 105*K*r**2 - 210*K*r*s + 168*K*r - 105*K*s**2 + 168*K*s - 63*K + 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*r**2 - 46*r*s + 17*r + 5*s**2 + 17*s - 22)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) + 12*gd2*(2*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 21*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 33*f*k2**2*(-3*b1**2*fd*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(-4*C*(16*r**2 + 2*r*(58*s - 1) + 16*s**2 - 65*s - 3) + K*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) - 8*r**2 + 8*r*(19*s + 8) - 8*s**2 - 62*s - 30) - k2**4*(4*C*(2*r**2 + r*(60*s + 5) + 2*s**2 - 37*s - 3) - 21*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) + 10*r**2 - 92*r*s - 17*r + 10*s**2 + 67*s + 6)) + 14*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(1 - 2*K) + bd1*k2**2*(8*K - 5) + 2*gd2*(k1**2 - 4*k2**2))) + 4*g2*(-14*bd1*k2**2*(k1**2 - 4*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 21*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(462*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) + 15*f**3*k1**4*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 11*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) - 33*f*k2**2*(-3*b1**2*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*C*(32*r**2 + 232*r*s - 33*r + 32*s**2 - 138*s + 12) - K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 16*r**2 - 304*r*s - 90*r + 16*s**2 + 120*s + 48) + k2**4*(-4*C*(4*r**2 + 5*r*(24*s - 1) + 4*s**2 - 75*s + 5) + 21*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 20*r**2 + 184*r*s + 11*r - 20*s**2 - 129*s + 10)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**2*k2**2*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 21*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(1155*d**2*k2*k3**8) - 8*D1**3*Pk2*Pk3*ct*k1*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(-k1**4*(-8*C + 20*b1 + 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*r + 7*K*s - 7*K - 21*b1*(3*r + 3*s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) + 84*k2**2*(r + s)*(b1*(10*K*k2**4 + k1**4*(4*K - 2) + k1**2*k2**2*(18*K - 5)) - 2*g2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) + 3*b1**2*k2**2*(D1*fd*(3*f*k1**2*(20*k1**2*(2*r + 2*s - 1) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5))) + Dd*f*(4*r + 4*s - 3)*(60*f*k1**4*(2*r + 2*s - 1) + 63*f*k1**2*k2**2*(3*r + 3*s - 1) + (r + s)*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5)))) + b1*(D1*(-5*f**2*fd*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 6*f*k2**2*(3*fd*(2*r + 2*s - 1)*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 28*gd2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k2**2*(r + s)**2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 168*g2*k2**2*(r + s)*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) - 18*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 14*f*gd2*(r + s - 1) - 14*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1))/(105*d**2*k2*k3**8) - 16*D1**3*Pk2*Pk3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(33*d**2*k3**8) + 8*D1**3*Pk2*Pk3*f*k2**2*st**6*(D1*(f**2*k1**2*(11*bd1*k2**2*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 7) - fd*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) + 11*f*k2**2*(b1*fd*k1**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) - 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-9*K*bd1 + 18*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 198*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2)) + 11*f*k2**2*(b1*k1**2*(-15*r - 15*s + 7) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(198*K*b1 - 396*g2)*(2*r + 2*s - 1)))/(231*d**2*k3**8) - 8*D1**3*Pk2*Pk3*k1**2*(-D1*bd1*f*(r + s - 1)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)) + b1**2*(D1*fd*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(2*D1*bd1*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(r + s - 1) + D1*(-15*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 14*gd2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s))))/(35*d**2*k3**8) - 8*D1**3*Pk2*Pk3*st**4*(D1*(462*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) + f**3*k1**2*(33*bd1*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + fd*k1**2*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3)) + 33*f**2*k2**2*(fd*(2*k1**4*(2*C*(r*(6*s - 1) - 4*s + 1) + 6*b1*r**2 + 6*b1*s**2 - 4*b1*s + r*(12*b1*s - 4*b1 - 6*s + 1) + 4*s - 1) + k1**2*k2**2*(b1*(39*r**2 + r*(78*s - 53) + 39*s**2 - 53*s + 18) + (4*C - 2)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) + k2**4*(2 - 4*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 2*k2**2*(r + s - 1)*(b1*bd1*k1**2*(13*r + 13*s - 3) - bd1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 2*gd2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))) - 33*f*k2**4*(b1**2*fd*k1**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(2*r + 2*s - 1)*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 28*b1*k2**2*(-K*bd1 + gd2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 4*g2*(7*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(462*b1*k2**6*(K*b1 - 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**3*k1**4*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 33*f**2*k2**2*(2*k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + 8*b1*r**2 + 8*b1*s**2 - 6*b1*s + r*(16*b1*s - 6*b1 - 8*s + 1) + 6*s - 1) + k1**2*k2**2*(b1*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + (4*C - 2)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) + k2**4*(2 - 4*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 33*f*k2**4*(4*r + 4*s - 3)*(b1**2*k1**2*(13*r + 13*s - 3) - 2*b1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 4*g2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))))/(385*d**2*k3**8) + 8*D1**3*Pk2*Pk3*st**2*(D1*bd1*f*(-f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(r + s - 1) + 6*f*k2**2*(k1**4*(-14*C*(2*r*s - r - s + 1) + K*r**2 + 2*K*r*s + 2*K*r + K*s**2 + 2*K*s - 3*K + 3*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) + 14*r*s - 7*r - 7*s + 7) + k1**2*k2**2*(-4*C*(4*r**2 + 15*r*s - 6*r + 4*s**2 - 6*s + 2) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 30*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(-k1**2 + 5*k2**2)*(84*K*b1 - 84*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*b1**2*k2**2*(D1*fd*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**4*(5*r + 5*s + 1) - 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(D1*(-f**2*fd*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*k2**2*(fd*(K*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) - (2*C - 1)*(7*k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + r*(60*s - 2) + 16*s**2 - 23*s - 3) - 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)))) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**4*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(-f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(4*r + 4*s - 3) + 6*f*k2**2*(k1**4*(-14*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s + 9*r + 4*s**2 + 9*s - 9) + 56*r*s - 7*r - 42*s + 7) + k1**2*k2**2*(C*(-64*r**2 + r*(38 - 240*s) - 64*s**2 + 108*s + 4) + 7*K*(4*r + 4*s - 3)**2 + 32*r**2 + 120*r*s - 19*r + 32*s**2 - 54*s - 2) + k2**4*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 84*g2*k2**4*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*k1**2*(D1*(15*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(fd*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 6*gd2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 12*fd*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) - 12*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3)))))/(105*d**2*k3**8) + 2*D1**3*Pk2*Pkd3*ct**8*f*k1**2*k2**4*(792*C*D1*f*fd*r**2 + 1584*C*D1*f*fd*r*s - 858*C*D1*f*fd*r + 792*C*D1*f*fd*s**2 - 858*C*D1*f*fd*s + 220*C*D1*f*fd + 1056*C*Dd*f**2*r**2 + 2112*C*Dd*f**2*r*s - 1232*C*Dd*f**2*r + 1056*C*Dd*f**2*s**2 - 1232*C*Dd*f**2*s + 330*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 700*D1*f**2*fd*r**2 + 1400*D1*f**2*fd*r*s - 973*D1*f**2*fd*r + 700*D1*f**2*fd*s**2 - 973*D1*f**2*fd*s + 336*D1*f**2*fd - 792*D1*f*fd*r**2 - 1584*D1*f*fd*r*s + 858*D1*f*fd*r - 792*D1*f*fd*s**2 + 858*D1*f*fd*s - 220*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 700*Dd*f**3*r**2 + 1400*Dd*f**3*r*s - 973*Dd*f**3*r + 700*Dd*f**3*s**2 - 973*Dd*f**3*s + 336*Dd*f**3 - 1056*Dd*f**2*r**2 - 2112*Dd*f**2*r*s + 1232*Dd*f**2*r - 1056*Dd*f**2*s**2 + 1232*Dd*f**2*s - 330*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(77*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**7*f*k1*k2**3*(13860*C*D1*f*fd*k1**2*r**2 + 27720*C*D1*f*fd*k1**2*r*s - 16500*C*D1*f*fd*k1**2*r + 13860*C*D1*f*fd*k1**2*s**2 - 16500*C*D1*f*fd*k1**2*s + 4840*C*D1*f*fd*k1**2 + 15840*C*D1*f*fd*k2**2*r**2 + 55440*C*D1*f*fd*k2**2*r*s - 21120*C*D1*f*fd*k2**2*r + 15840*C*D1*f*fd*k2**2*s**2 - 33000*C*D1*f*fd*k2**2*s + 8360*C*D1*f*fd*k2**2 + 18480*C*Dd*f**2*k1**2*r**2 + 36960*C*Dd*f**2*k1**2*r*s - 23540*C*Dd*f**2*k1**2*r + 18480*C*Dd*f**2*k1**2*s**2 - 23540*C*Dd*f**2*k1**2*s + 7260*C*Dd*f**2*k1**2 + 21120*C*Dd*f**2*k2**2*r**2 + 73920*C*Dd*f**2*k2**2*r*s - 28600*C*Dd*f**2*k2**2*r + 21120*C*Dd*f**2*k2**2*s**2 - 48400*C*Dd*f**2*k2**2*s + 10560*C*Dd*f**2*k2**2 + 11*D1*bd1*f*(k1**2*(18*K - 18)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) + 21140*D1*f**2*fd*k1**2*r**2 + 42280*D1*f**2*fd*k1**2*r*s - 30555*D1*f**2*fd*k1**2*r + 21140*D1*f**2*fd*k1**2*s**2 - 30555*D1*f**2*fd*k1**2*s + 11025*D1*f**2*fd*k1**2 - 13860*D1*f*fd*k1**2*r**2 - 27720*D1*f*fd*k1**2*r*s + 16500*D1*f*fd*k1**2*r - 13860*D1*f*fd*k1**2*s**2 + 16500*D1*f*fd*k1**2*s - 4840*D1*f*fd*k1**2 - 11880*D1*f*fd*k2**2*r**2 - 35640*D1*f*fd*k2**2*r*s + 14850*D1*f*fd*k2**2*r - 11880*D1*f*fd*k2**2*s**2 + 20790*D1*f*fd*k2**2*s - 5280*D1*f*fd*k2**2 - 7524*D1*f*gd2*k1**2*r**2 - 15048*D1*f*gd2*k1**2*r*s + 12672*D1*f*gd2*k1**2*r - 7524*D1*f*gd2*k1**2*s**2 + 12672*D1*f*gd2*k1**2*s - 5148*D1*f*gd2*k1**2 - 7920*D1*f*gd2*k2**2*r**2 - 15840*D1*f*gd2*k2**2*r*s + 11880*D1*f*gd2*k2**2*r - 7920*D1*f*gd2*k2**2*s**2 + 11880*D1*f*gd2*k2**2*s - 3960*D1*f*gd2*k2**2 - 15048*D1*fd*g2*k1**2*r**2 - 30096*D1*fd*g2*k1**2*r*s + 17820*D1*fd*g2*k1**2*r - 15048*D1*fd*g2*k1**2*s**2 + 17820*D1*fd*g2*k1**2*s - 5148*D1*fd*g2*k1**2 - 15840*D1*fd*g2*k2**2*r**2 - 31680*D1*fd*g2*k2**2*r*s + 15840*D1*fd*g2*k2**2*r - 15840*D1*fd*g2*k2**2*s**2 + 15840*D1*fd*g2*k2**2*s - 3960*D1*fd*g2*k2**2 + 21140*Dd*f**3*k1**2*r**2 + 42280*Dd*f**3*k1**2*r*s - 30555*Dd*f**3*k1**2*r + 21140*Dd*f**3*k1**2*s**2 - 30555*Dd*f**3*k1**2*s + 11025*Dd*f**3*k1**2 - 18480*Dd*f**2*k1**2*r**2 - 36960*Dd*f**2*k1**2*r*s + 23540*Dd*f**2*k1**2*r - 18480*Dd*f**2*k1**2*s**2 + 23540*Dd*f**2*k1**2*s - 7260*Dd*f**2*k1**2 - 15840*Dd*f**2*k2**2*r**2 - 47520*Dd*f**2*k2**2*r*s + 20460*Dd*f**2*k2**2*r - 15840*Dd*f**2*k2**2*s**2 + 30360*Dd*f**2*k2**2*s - 6930*Dd*f**2*k2**2 - 30096*Dd*f*g2*k1**2*r**2 - 60192*Dd*f*g2*k1**2*r*s + 43164*Dd*f*g2*k1**2*r - 30096*Dd*f*g2*k1**2*s**2 + 43164*Dd*f*g2*k1**2*s - 15444*Dd*f*g2*k1**2 - 31680*Dd*f*g2*k2**2*r**2 - 63360*Dd*f*g2*k2**2*r*s + 39600*Dd*f*g2*k2**2*r - 31680*Dd*f*g2*k2**2*s**2 + 39600*Dd*f*g2*k2**2*s - 11880*Dd*f*g2*k2**2 - 11*b1*(D1*fd*(k1**2*(18 - 18*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(18 - 18*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(385*d**2*k3**7) + 2*D1**3*Pk2*Pkd3*ct**6*f*k1**2*k2**4*st**2*(1782*C*D1*f*fd*r**2 + 3564*C*D1*f*fd*r*s - 1980*C*D1*f*fd*r + 1782*C*D1*f*fd*s**2 - 1980*C*D1*f*fd*s + 528*C*D1*f*fd + 2376*C*Dd*f**2*r**2 + 4752*C*Dd*f**2*r*s - 2838*C*Dd*f**2*r + 2376*C*Dd*f**2*s**2 - 2838*C*Dd*f**2*s + 792*C*Dd*f**2 + 297*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2212*D1*f**2*fd*r**2 + 4424*D1*f**2*fd*r*s - 3087*D1*f**2*fd*r + 2212*D1*f**2*fd*s**2 - 3087*D1*f**2*fd*s + 1071*D1*f**2*fd - 1782*D1*f*fd*r**2 - 3564*D1*f*fd*r*s + 1980*D1*f*fd*r - 1782*D1*f*fd*s**2 + 1980*D1*f*fd*s - 528*D1*f*fd - 1188*D1*f*gd2*r**2 - 2376*D1*f*gd2*r*s + 1782*D1*f*gd2*r - 1188*D1*f*gd2*s**2 + 1782*D1*f*gd2*s - 594*D1*f*gd2 - 2376*D1*fd*g2*r**2 - 4752*D1*fd*g2*r*s + 2376*D1*fd*g2*r - 2376*D1*fd*g2*s**2 + 2376*D1*fd*g2*s - 594*D1*fd*g2 + 2212*Dd*f**3*r**2 + 4424*Dd*f**3*r*s - 3087*Dd*f**3*r + 2212*Dd*f**3*s**2 - 3087*Dd*f**3*s + 1071*Dd*f**3 - 2376*Dd*f**2*r**2 - 4752*Dd*f**2*r*s + 2838*Dd*f**2*r - 2376*Dd*f**2*s**2 + 2838*Dd*f**2*s - 792*Dd*f**2 - 4752*Dd*f*g2*r**2 - 9504*Dd*f*g2*r*s + 5940*Dd*f*g2*r - 4752*Dd*f*g2*s**2 + 5940*Dd*f*g2*s - 1782*Dd*f*g2 + 297*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(77*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**6*k2**2*(-11*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + k1**2*k2**2*(r + s)*(-252*K*b1 + 252*b1 + 252*g2)) + 1386*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 11*b1*(D1*(5*f**2*fd*k1**2*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) - 18*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) - 14*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 252*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + 252*g2*k1**2*k2**2*(r + s))) + f*(D1*(35*f**2*fd*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**4*(6*C - 6)*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(72*r**2 + 6*r*(69*s - 22) + 72*s**2 - 267*s + 71) + 81*r**2 + 144*r*(3*s - 1) + 81*s**2 - 279*s + 75) - k2**4*(2*C - 1)*(36*r**2 + 6*r*(21*s - 8) + 36*s**2 - 75*s + 19)) + 18*gd2*(k1**4*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 396*fd*g2*(k1**4*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 9) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(35*f**2*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 110*f*(k1**4*(6*C - 6)*(4*r + 4*s - 3) + k1**2*k2**2*(-2*C*(96*r**2 + r*(552*s - 169) + 96*s**2 - 394*s + 84) + 108*r**2 + 6*r*(96*s - 31) + 108*s**2 - 411*s + 90) - k2**4*(2*C - 1)*(48*r**2 + r*(168*s - 65) + 48*s**2 - 110*s + 24)) - 396*g2*(k1**4*(16*r**2 + 16*r*(2*s - 3) + 16*s**2 - 48*s + 27) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**5*f*k1*k2**3*st**2*(24552*C*D1*f*fd*k1**2*r**2 + 49104*C*D1*f*fd*k1**2*r*s - 28776*C*D1*f*fd*k1**2*r + 24552*C*D1*f*fd*k1**2*s**2 - 28776*C*D1*f*fd*k1**2*s + 8272*C*D1*f*fd*k1**2 + 35640*C*D1*f*fd*k2**2*r**2 + 118800*C*D1*f*fd*k2**2*r*s - 47520*C*D1*f*fd*k2**2*r + 35640*C*D1*f*fd*k2**2*s**2 - 71280*C*D1*f*fd*k2**2*s + 18480*C*D1*f*fd*k2**2 + 32736*C*Dd*f**2*k1**2*r**2 + 65472*C*Dd*f**2*k1**2*r*s - 41096*C*Dd*f**2*k1**2*r + 32736*C*Dd*f**2*k1**2*s**2 - 41096*C*Dd*f**2*k1**2*s + 12408*C*Dd*f**2*k1**2 + 47520*C*Dd*f**2*k2**2*r**2 + 158400*C*Dd*f**2*k2**2*r*s - 64680*C*Dd*f**2*k2**2*r + 47520*C*Dd*f**2*k2**2*s**2 - 104280*C*Dd*f**2*k2**2*s + 23760*C*Dd*f**2*k2**2 + 33*D1*bd1*f*(k1**2*(12*K - 12)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) + 52260*D1*f**2*fd*k1**2*r**2 + 104520*D1*f**2*fd*k1**2*r*s - 75255*D1*f**2*fd*k1**2*r + 52260*D1*f**2*fd*k1**2*s**2 - 75255*D1*f**2*fd*k1**2*s + 27045*D1*f**2*fd*k1**2 - 24552*D1*f*fd*k1**2*r**2 - 49104*D1*f*fd*k1**2*r*s + 28776*D1*f*fd*k1**2*r - 24552*D1*f*fd*k1**2*s**2 + 28776*D1*f*fd*k1**2*s - 8272*D1*f*fd*k1**2 - 26730*D1*f*fd*k2**2*r**2 - 77220*D1*f*fd*k2**2*r*s + 33660*D1*f*fd*k2**2*r - 26730*D1*f*fd*k2**2*s**2 + 45540*D1*f*fd*k2**2*s - 11880*D1*f*fd*k2**2 - 15048*D1*f*gd2*k1**2*r**2 - 30096*D1*f*gd2*k1**2*r*s + 25344*D1*f*gd2*k1**2*r - 15048*D1*f*gd2*k1**2*s**2 + 25344*D1*f*gd2*k1**2*s - 10296*D1*f*gd2*k1**2 - 23760*D1*f*gd2*k2**2*r**2 - 47520*D1*f*gd2*k2**2*r*s + 35640*D1*f*gd2*k2**2*r - 23760*D1*f*gd2*k2**2*s**2 + 35640*D1*f*gd2*k2**2*s - 11880*D1*f*gd2*k2**2 - 30096*D1*fd*g2*k1**2*r**2 - 60192*D1*fd*g2*k1**2*r*s + 35640*D1*fd*g2*k1**2*r - 30096*D1*fd*g2*k1**2*s**2 + 35640*D1*fd*g2*k1**2*s - 10296*D1*fd*g2*k1**2 - 47520*D1*fd*g2*k2**2*r**2 - 95040*D1*fd*g2*k2**2*r*s + 47520*D1*fd*g2*k2**2*r - 47520*D1*fd*g2*k2**2*s**2 + 47520*D1*fd*g2*k2**2*s - 11880*D1*fd*g2*k2**2 + 52260*Dd*f**3*k1**2*r**2 + 104520*Dd*f**3*k1**2*r*s - 75255*Dd*f**3*k1**2*r + 52260*Dd*f**3*k1**2*s**2 - 75255*Dd*f**3*k1**2*s + 27045*Dd*f**3*k1**2 - 32736*Dd*f**2*k1**2*r**2 - 65472*Dd*f**2*k1**2*r*s + 41096*Dd*f**2*k1**2*r - 32736*Dd*f**2*k1**2*s**2 + 41096*Dd*f**2*k1**2*s - 12408*Dd*f**2*k1**2 - 35640*Dd*f**2*k2**2*r**2 - 102960*Dd*f**2*k2**2*r*s + 46530*Dd*f**2*k2**2*r - 35640*Dd*f**2*k2**2*s**2 + 66330*Dd*f**2*k2**2*s - 15840*Dd*f**2*k2**2 - 60192*Dd*f*g2*k1**2*r**2 - 120384*Dd*f*g2*k1**2*r*s + 86328*Dd*f*g2*k1**2*r - 60192*Dd*f*g2*k1**2*s**2 + 86328*Dd*f*g2*k1**2*s - 30888*Dd*f*g2*k1**2 - 95040*Dd*f*g2*k2**2*r**2 - 190080*Dd*f*g2*k2**2*r*s + 118800*Dd*f*g2*k2**2*r - 95040*Dd*f*g2*k2**2*s**2 + 118800*Dd*f*g2*k2**2*s - 35640*Dd*f*g2*k2**2 - 33*b1*(D1*fd*(k1**2*(12 - 12*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(12 - 12*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(385*d**2*k3**7) - D1**3*Pk2*Pkd3*ct**5*k1*k2*(11*D1*bd1*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 18*f*(k1**4*(K - 1)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) + k1**2*k2**2*(r + s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5) + 9*K*r**2 + 18*K*r*s - 10*K*r + 9*K*s**2 - 10*K*s + K + b1*(13*r**2 + 2*r*(13*s - 8) + 13*s**2 - 16*s + 3) - 5*r**2 + 18*r*s + 4*r - 5*s**2 + 4*s + 1)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + 3*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*(3*fd*(k1**4*(K - 1)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) - 10*r**2 + 36*r*s + 31*r - 10*s**2 - 11*s - 13)) + 28*gd2*k2**2*(k1**2 + 3*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k2**2*(k1**2 + 3*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 18*f*(k1**4*(K - 1)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) - k2**4*(4*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) - K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 20*r**2 - 72*r*s - 53*r + 20*s**2 + 17*s + 25)) + 168*g2*k2**2*(k1**2 + 3*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(35*f**2*fd*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**4*(2*C - 2)*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + 3*k1**2*k2**2*(C*(90*r**2 + 6*r*(6*s - 13) + 90*s**2 - 6*s + 4) - 90*r**2 - 3*r*(36*s - 31) - 90*s**2 + 57*s - 18) + k2**4*(C*(90*r**2 - 6*r*(6*s + 11) + 90*s**2 + 42*s - 8) - 99*r**2 + r*(96 - 90*s) - 99*s**2 + 42*s - 14)) - 18*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1)) + 396*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1)) + Dd*f*(35*f**2*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 110*f*(k1**4*(2*C - 2)*(60*r**2 + r*(120*s - 73) + 60*s**2 - 73*s + 21) + 3*k1**2*k2**2*(2*C*(60*r**2 + r*(24*s - 61) + 60*s**2 - s + 9) - 120*r**2 - 3*r*(48*s - 46) - 120*s**2 + 78*s - 33) + k2**4*(2*C*(60*r**2 - r*(24*s + 55) + 60*s**2 + 35*s + 3) - 132*r**2 - 5*r*(24*s - 29) - 132*s**2 + 55*s - 30)) + 396*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3))))/(385*d**2*k3**7) + 6*D1**3*Pk2*Pkd3*ct**4*f*k1**2*k2**4*st**4*(396*C*D1*f*fd*r**2 + 792*C*D1*f*fd*r*s - 462*C*D1*f*fd*r + 396*C*D1*f*fd*s**2 - 462*C*D1*f*fd*s + 132*C*D1*f*fd + 528*C*Dd*f**2*r**2 + 1056*C*Dd*f**2*r*s - 660*C*Dd*f**2*r + 528*C*Dd*f**2*s**2 - 660*C*Dd*f**2*s + 198*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 812*D1*f**2*fd*r**2 + 1624*D1*f**2*fd*r*s - 1141*D1*f**2*fd*r + 812*D1*f**2*fd*s**2 - 1141*D1*f**2*fd*s + 399*D1*f**2*fd - 396*D1*f*fd*r**2 - 792*D1*f*fd*r*s + 462*D1*f*fd*r - 396*D1*f*fd*s**2 + 462*D1*f*fd*s - 132*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 812*Dd*f**3*r**2 + 1624*Dd*f**3*r*s - 1141*Dd*f**3*r + 812*Dd*f**3*s**2 - 1141*Dd*f**3*s + 399*Dd*f**3 - 528*Dd*f**2*r**2 - 1056*Dd*f**2*r*s + 660*Dd*f**2*r - 528*Dd*f**2*s**2 + 660*Dd*f**2*s - 198*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(77*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**4*k2**2*st**2*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + k1**2*k2**2*(r + s)*(-168*K*b1 + 168*b1 + 168*g2)) + 2772*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) - 6*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) - 28*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(75*f**2*fd*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(fd*(k1**4*(36*C - 36)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(396*r**2 + 6*r*(321*s - 109) + 396*s**2 - 1221*s + 323) - 513*r**2 - 72*r*(30*s - 11) - 513*s**2 + 1359*s - 363) + k2**4*(30*C - 15)*(27*r**2 + 18*r*(5*s - 2) + 27*s**2 - 54*s + 14)) - 18*gd2*(3*k1**4*(3*r**2 + r*(6*s - 8) + 3*s**2 - 8*s + 5) + 2*k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 396*fd*g2*(3*k1**4*(6*r**2 + r*(12*s - 13) + 6*s**2 - 13*s + 5) + 2*k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(75*f**2*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(k1**4*(36*C - 36)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(528*r**2 + r*(2568*s - 853) + 528*s**2 - 1798*s + 390) - 684*r**2 - 30*r*(96*s - 35) - 684*s**2 + 1995*s - 450) + k2**4*(30*C - 15)*(36*r**2 + r*(120*s - 49) + 36*s**2 - 79*s + 18)) - 396*g2*(k1**4*(36*r**2 + r*(72*s - 87) + 36*s**2 - 87*s + 45) + 2*k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**4*(33*D1*bd1*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 6*f*(k1**6*(2*K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(r + s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(11*r**2 - 48*r*s + 8*r + 11*s**2 + 8*s - 19) + 66*K*r**2 + 132*K*r*s - 99*K*r + 66*K*s**2 - 99*K*s + 33*K + b1*(23*r**2 + r*(46*s - 24) + 23*s**2 - 24*s + 1) - 55*r**2 - 40*r*s + 65*r - 55*s**2 + 65*s - 10) + k2**6*(-2*C*(3*r**2 + 4*r*(5*s - 2) + 3*s**2 - 8*s + 5) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5)) + 28*k2**2*(b1*(3*K*k2**4 + k1**4*(7 - 7*K) - k1**2*k2**2*(K - 3)) + g2*(7*k1**4 + k1**2*k2**2 - 3*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-3*f*k1**2*k2**2*(46*r**2 + r*(92*s - 25) + 46*s**2 - 25*s + 1) + (r + s)**2*(42*K*k2**4 - 14*k1**4*(7*K - 7) - 14*k1**2*k2**2*(K - 3))) - Dd*f*(3*f*k1**2*k2**2*(23*r + 23*s - 1) + (r + s)*(-42*K*k2**4 + 14*k1**4*(7*K - 7) + 14*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 6*f*fd*(k1**6*(2*K - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*r + 2*s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(22*r**2 - r*(96*s + 43) + 22*s**2 + 62*s + 16) + 33*K*(2*r + 2*s - 1)**2 - 110*r**2 - 80*r*s + 145*r - 110*s**2 + 40*s - 45) + k2**6*(-2*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + 7*K*(2*r + 2*s - 1)**2 + 6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2)) + 28*f*gd2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k2**2*(r + s)**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)) + Dd*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 6*f*(k1**6*(2*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(44*r**2 - 2*r*(96*s + 31) + 44*s**2 + 113*s + 13) + 33*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 220*r**2 - 5*r*(32*s - 62) - 220*s**2 + 135*s - 100) + k2**6*(-2*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 12*r**2 + 80*r*s - 8*r + 12*s**2 - 43*s + 1)) + 28*g2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-35*f**2*fd*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**6*(4*C - 4)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(198*r**2 + 6*r*(57*s - 41) + 198*s**2 - 219*s + 73) - 351*r**2 - 18*r*(36*s - 25) - 351*s**2 + 423*s - 141) + 3*k1**2*k2**4*(2*C*(90*r**2 + 54*r*(3*s - 2) + 90*s**2 - 99*s + 31) - 135*r**2 - 3*r*(84*s - 55) - 135*s**2 + 156*s - 49) + k2**6*(18*C - 9)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 18*gd2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 396*fd*g2*(2*r + 2*s - 1)**2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)) + Dd*f*(-35*f**2*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 110*f*(k1**6*(4*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(C*(528*r**2 + r*(912*s - 706) + 528*s**2 - 616*s + 228) - 468*r**2 - 3*r*(288*s - 214) - 468*s**2 + 597*s - 216) + 3*k1**2*k2**4*(C*(240*r**2 + 432*r*s - 310*r + 240*s**2 - 280*s + 96) - 180*r**2 - 4*r*(84*s - 59) - 180*s**2 + 221*s - 75) + k2**6*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 396*g2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(385*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**3*st**4*(-3564*C*D1*f*fd*k1**2*r**2 - 7128*C*D1*f*fd*k1**2*r*s + 4092*C*D1*f*fd*k1**2*r - 3564*C*D1*f*fd*k1**2*s**2 + 4092*C*D1*f*fd*k1**2*s - 1144*C*D1*f*fd*k1**2 - 7920*C*D1*f*fd*k2**2*r**2 - 23760*C*D1*f*fd*k2**2*r*s + 10560*C*D1*f*fd*k2**2*r - 7920*C*D1*f*fd*k2**2*s**2 + 14520*C*D1*f*fd*k2**2*s - 3960*C*D1*f*fd*k2**2 - 4752*C*Dd*f**2*k1**2*r**2 - 9504*C*Dd*f**2*k1**2*r*s + 5852*C*Dd*f**2*k1**2*r - 4752*C*Dd*f**2*k1**2*s**2 + 5852*C*Dd*f**2*k1**2*s - 1716*C*Dd*f**2*k1**2 - 10560*C*Dd*f**2*k2**2*r**2 - 31680*C*Dd*f**2*k2**2*r*s + 14520*C*Dd*f**2*k2**2*r - 10560*C*Dd*f**2*k2**2*s**2 + 21120*C*Dd*f**2*k2**2*s - 5280*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(6*K - 6)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 13700*D1*f**2*fd*k1**2*r**2 - 27400*D1*f**2*fd*k1**2*r*s + 19615*D1*f**2*fd*k1**2*r - 13700*D1*f**2*fd*k1**2*s**2 + 19615*D1*f**2*fd*k1**2*s - 7005*D1*f**2*fd*k1**2 + 3564*D1*f*fd*k1**2*r**2 + 7128*D1*f*fd*k1**2*r*s - 4092*D1*f*fd*k1**2*r + 3564*D1*f*fd*k1**2*s**2 - 4092*D1*f*fd*k1**2*s + 1144*D1*f*fd*k1**2 + 5940*D1*f*fd*k2**2*r**2 + 15840*D1*f*fd*k2**2*r*s - 7590*D1*f*fd*k2**2*r + 5940*D1*f*fd*k2**2*s**2 - 9570*D1*f*fd*k2**2*s + 2640*D1*f*fd*k2**2 + 2508*D1*f*gd2*k1**2*r**2 + 5016*D1*f*gd2*k1**2*r*s - 4224*D1*f*gd2*k1**2*r + 2508*D1*f*gd2*k1**2*s**2 - 4224*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 7920*D1*f*gd2*k2**2*r**2 + 15840*D1*f*gd2*k2**2*r*s - 11880*D1*f*gd2*k2**2*r + 7920*D1*f*gd2*k2**2*s**2 - 11880*D1*f*gd2*k2**2*s + 3960*D1*f*gd2*k2**2 + 5016*D1*fd*g2*k1**2*r**2 + 10032*D1*fd*g2*k1**2*r*s - 5940*D1*fd*g2*k1**2*r + 5016*D1*fd*g2*k1**2*s**2 - 5940*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 + 15840*D1*fd*g2*k2**2*r**2 + 31680*D1*fd*g2*k2**2*r*s - 15840*D1*fd*g2*k2**2*r + 15840*D1*fd*g2*k2**2*s**2 - 15840*D1*fd*g2*k2**2*s + 3960*D1*fd*g2*k2**2 - 13700*Dd*f**3*k1**2*r**2 - 27400*Dd*f**3*k1**2*r*s + 19615*Dd*f**3*k1**2*r - 13700*Dd*f**3*k1**2*s**2 + 19615*Dd*f**3*k1**2*s - 7005*Dd*f**3*k1**2 + 4752*Dd*f**2*k1**2*r**2 + 9504*Dd*f**2*k1**2*r*s - 5852*Dd*f**2*k1**2*r + 4752*Dd*f**2*k1**2*s**2 - 5852*Dd*f**2*k1**2*s + 1716*Dd*f**2*k1**2 + 7920*Dd*f**2*k2**2*r**2 + 21120*Dd*f**2*k2**2*r*s - 10560*Dd*f**2*k2**2*r + 7920*Dd*f**2*k2**2*s**2 - 13860*Dd*f**2*k2**2*s + 3630*Dd*f**2*k2**2 + 10032*Dd*f*g2*k1**2*r**2 + 20064*Dd*f*g2*k1**2*r*s - 14388*Dd*f*g2*k1**2*r + 10032*Dd*f*g2*k1**2*s**2 - 14388*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 31680*Dd*f*g2*k2**2*r**2 + 63360*Dd*f*g2*k2**2*r*s - 39600*Dd*f*g2*k2**2*r + 31680*Dd*f*g2*k2**2*s**2 - 39600*Dd*f*g2*k2**2*s + 11880*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(6 - 6*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(6 - 6*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(385*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**3*k1*k2*st**2*(11*D1*bd1*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 3*f*(k1**4*(5*K - 5)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) + 3*k2**4*(-4*C*(5*r**2 + 24*r*s - 11*r + 5*s**2 - 11*s + 6) + 18*K*r**2 + 36*K*r*s - 20*K*r + 18*K*s**2 - 20*K*s + 2*K + b1*(26*r**2 + 4*r*(13*s - 8) + 26*s**2 - 32*s + 6) - 13*r**2 + 2*r*s + 16*r - 13*s**2 + 16*s - 3)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - g2*(k1**2 + 6*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*(fd*(k1**4*(5*K - 5)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(10*r**2 + r*(48*s - 3) + 10*s**2 - 24*s - 1) - 2*K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) + 26*r**2 - 4*r*s - 47*r + 26*s**2 - 5*s + 17)) + 28*gd2*k2**2*(k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 3*f*(k1**4*(5*K - 5)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 2*K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 52*r**2 - 8*r*s - 93*r + 52*s**2 - 23*s + 37)) + 84*g2*k2**2*(k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(5*f**2*fd*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(fd*(k1**4*(3*C - 3)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 9*k1**2*k2**2*(C*(9*r**2 + r*(19 - 150*s) + 9*s**2 + 103*s - 26) - 18*r**2 + r*(48*s + 7) - 18*s**2 - 35*s + 8) + k2**4*(2*C*(45*r**2 + r*(21 - 342*s) + 45*s**2 + 237*s - 58) - 207*r**2 + 6*r*(3*s + 28) - 207*s**2 - 48*s + 4)) - 3*gd2*(5*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + 3*k1**2*k2**2*(17*r**2 + r*(34*s - 8) + 17*s**2 - 8*s - 9) + 6*k2**4*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1))) + 66*fd*g2*(5*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + 3*k1**2*k2**2*(34*r**2 + 68*r*s + r + 34*s**2 + s - 9) + 6*k2**4*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1))) + Dd*f*(5*f**2*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(k1**4*(3*C - 3)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 9*k1**2*k2**2*(C*(12*r**2 - 200*r*s + 15*r + 12*s**2 + 155*s - 25) - 24*r**2 + 64*r*s + 16*r - 24*s**2 - 54*s + 5) + k2**4*(2*C*(60*r**2 - 456*r*s - r + 60*s**2 + 359*s - 51) - 276*r**2 + 24*r*s + 271*r - 276*s**2 - 89*s - 30)) + 66*g2*(5*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + 3*k1**2*k2**2*(68*r**2 + r*(136*s - 15) + 68*s**2 - 15*s - 27) + 6*k2**4*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**3*k1*(D1*(-462*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) - 5*f**3*k1**2*(11*bd1*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(r + s - 1) + 7*fd*k1**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 11*f**2*k2**2*(18*bd1*(k1**4*(r + s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) - k1**2*k2**2*(C*(-96*r**2 - 80*r*s + 88*r - 96*s**2 + 88*s + 8) - 65*K*r**2 - 130*K*r*s + 108*K*r - 65*K*s**2 + 108*K*s - 43*K + b1*(17*r**2 + r*(34*s - 36) + 17*s**2 - 36*s + 19) + 107*r**2 + 158*r*s - 136*r + 107*s**2 - 136*s + 29) + k2**4*(4*C*(8*r**2 + 2*r*s - 5*r + 8*s**2 - 5*s - 3) + 35*K*r**2 + 70*K*r*s - 56*K*r + 35*K*s**2 - 56*K*s + 21*K - 7*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 23*r**2 - 18*r*s + 17*r - 23*s**2 + 17*s + 6)) + 5*fd*(3*r + 3*s - 2)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) - 36*gd2*(k1**4*(15*r**2 + r*(30*s - 26) + 15*s**2 - 26*s + 11) + k1**2*k2**2*(65*r**2 + 2*r*(65*s - 54) + 65*s**2 - 108*s + 43) + 7*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) + 33*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(3*fd*(k1**4*(2*r + 2*s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(24*r**2 + 4*r*(5*s - 6) + 24*s**2 - 3*s + 6) + K*(130*r**2 + 260*r*s - 151*r + 130*s**2 - 151*s + 43) - 214*r**2 - 316*r*s + 221*r - 214*s**2 + 137*s - 57) + k2**4*(4*C*(16*r**2 + 4*r*(s - 4) + 16*s**2 + 5*s + 4) + 7*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 46*r**2 - 36*r*s + 39*r - 46*s**2 - 3*s - 8)) + (14*bd1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 112*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(56*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*fd*(k1**4*(30*r**2 + r*(60*s - 37) + 30*s**2 - 37*s + 11) + k1**2*k2**2*(130*r**2 + r*(260*s - 151) + 130*s**2 - 151*s + 43) + 7*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(-462*b1*k2**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 35*f**3*k1**4*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 55*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) + 99*f*k2**2*(b1**2*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(4*r + 4*s - 3)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(48*r**2 + r*(40*s - 53) + 48*s**2 - 18*s + 11) + K*(260*r**2 + 520*r*s - 367*r + 260*s**2 - 367*s + 129) - 428*r**2 - 632*r*s + 521*r - 428*s**2 + 381*s - 143) + k2**4*(4*C*(32*r**2 + r*(8*s - 33) + 32*s**2 + 2*s + 5) + 7*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 92*r**2 - 72*r*s + 87*r - 92*s**2 + 17*s - 10)) + 4*g2*(k1**4*(60*r**2 + r*(120*s - 89) + 60*s**2 - 89*s + 33) + k1**2*k2**2*(260*r**2 + r*(520*s - 367) + 260*s**2 - 367*s + 129) + 7*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(385*d**2*k2*k3**7) + 2*D1**3*Pk2*Pkd3*ct**2*f*k1**2*k2**4*st**6*(198*C*D1*f*fd*r**2 + 396*C*D1*f*fd*r*s - 264*C*D1*f*fd*r + 198*C*D1*f*fd*s**2 - 264*C*D1*f*fd*s + 88*C*D1*f*fd + 264*C*Dd*f**2*r**2 + 528*C*Dd*f**2*r*s - 374*C*Dd*f**2*r + 264*C*Dd*f**2*s**2 - 374*C*Dd*f**2*s + 132*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1036*D1*f**2*fd*r**2 + 2072*D1*f**2*fd*r*s - 1477*D1*f**2*fd*r + 1036*D1*f**2*fd*s**2 - 1477*D1*f**2*fd*s + 525*D1*f**2*fd - 198*D1*f*fd*r**2 - 396*D1*f*fd*r*s + 264*D1*f*fd*r - 198*D1*f*fd*s**2 + 264*D1*f*fd*s - 88*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 1036*Dd*f**3*r**2 + 2072*Dd*f**3*r*s - 1477*Dd*f**3*r + 1036*Dd*f**3*s**2 - 1477*Dd*f**3*s + 525*Dd*f**3 - 264*Dd*f**2*r**2 - 528*Dd*f**2*r*s + 374*Dd*f**2*r - 264*Dd*f**2*s**2 + 374*Dd*f**2*s - 132*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(77*d**2*k3**7) + 3*D1**3*Pk2*Pkd3*ct**2*k2**2*st**4*(-33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*b1 + 28*g2)) + 462*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) - 2*f*fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*f*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(15*f**2*fd*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(fd*(k1**4*(6*C - 6)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2) + k1**2*k2**2*(2*C*(144*r**2 + 54*r*(11*s - 4) + 144*s**2 - 369*s + 97) - 207*r**2 - 144*r*(5*s - 2) - 207*s**2 + 441*s - 117) + k2**4*(30*C - 15)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) - 6*gd2*(k1**4*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 132*fd*g2*(k1**4*(10*r**2 + r*(20*s - 17) + 10*s**2 - 17*s + 6) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(15*f**2*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(k1**4*(6*C - 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(2*C*(192*r**2 + 792*r*s - 287*r + 192*s**2 - 542*s + 120) - 276*r**2 - 30*r*(32*s - 13) - 276*s**2 + 645*s - 150) + k2**4*(30*C - 15)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) - 132*g2*(k1**4*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(385*d**2*k3**7) + 2*D1**3*Pk2*Pkd3*ct**2*st**2*(33*D1*bd1*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - f*(k1**6*(K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(25*r**2 + 204*r*s - 90*r + 25*s**2 - 90*s + 65) + 183*K*r**2 + 366*K*r*s - 264*K*r + 183*K*s**2 - 264*K*s + 81*K + 12*b1*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) - 71*r**2 + 12*r*s + 75*r - 71*s**2 + 75*s - 4) - 3*k2**6*(2*C*(5*r**2 + r*(24*s - 11) + 5*s**2 - 11*s + 6) - 14*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 5*r**2 - 24*r*s + 11*r - 5*s**2 + 11*s - 6)) + 14*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) - k1**2*k2**2*(K - 3)) - g2*(k1**4 - k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-6*f*k1**2*k2**2*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + (r + s)**2*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3))) + Dd*f*(-6*f*k1**2*k2**2*(9*r + 9*s - 1) + (r + s)*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(50*r**2 + r*(408*s - 1) + 50*s**2 - 232*s - 12) + K*(366*r**2 + 732*r*s - 345*r + 366*s**2 - 345*s + 81) - 142*r**2 + 24*r*s + 233*r - 142*s**2 + 2*s - 81) - 3*k2**6*(C*(20*r**2 + r*(96*s - 6) + 20*s**2 - 48*s - 2) - 14*K*(2*r + 2*s - 1)**2 - 10*r**2 - 48*r*s + 3*r - 10*s**2 + 24*s + 1)) + 14*gd2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 14*fd*g2*k2**2*(r + s)**2*(k1**4 - k1**2*k2**2 + 6*k2**4)) + Dd*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(-k1**6*(K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(2*C*(100*r**2 + 8*r*(102*s - 13) + 100*s**2 - 489*s + 41) - 3*K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 284*r**2 - 48*r*s - 460*r + 284*s**2 - 75*s + 166) + 3*k2**6*(2*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 14*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 20*r**2 - 96*r*s + 18*r - 20*s**2 + 53*s - 4)) - 14*g2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-15*f**2*fd*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(fd*(k1**6*(2*C - 2)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 3*k1**4*k2**2*(2*C*(54*r**2 - 39*r + 54*s**2 + 15*s - 4) - 99*r**2 - 3*r*(30*s - 31) - 99*s**2 + 39*s - 12) + 9*k1**2*k2**4*(4*C*(36*r**2 + 6*r*(9*s - 7) + 36*s**2 - 33*s + 11) - 117*r**2 - 3*r*(66*s - 47) - 117*s**2 + 123*s - 40) + k2**6*(108*C - 54)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 6*gd2*(k1**6*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**4*k2**2*(38*r**2 + r*(76*s - 29) + 38*s**2 - 29*s - 9) + 3*k1**2*k2**4*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 42*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 66*fd*g2*(k1**6*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**4*k2**2*(76*r**2 + 4*r*(38*s - 5) + 76*s**2 - 20*s - 9) + 3*k1**2*k2**4*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 42*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-15*f**2*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(k1**6*(2*C - 2)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 3*k1**4*k2**2*(2*C*(72*r**2 - 64*r + 72*s**2 + 26*s + 3) - 132*r**2 - 3*r*(40*s - 47) - 132*s**2 + 51*s - 27) + 9*k1**2*k2**4*(4*C*(48*r**2 + r*(72*s - 61) + 48*s**2 - 46*s + 18) - 156*r**2 + r*(203 - 264*s) - 156*s**2 + 173*s - 63) + k2**6*(108*C - 54)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 66*g2*(k1**6*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(152*r**2 + r*(304*s - 78) + 152*s**2 - 78*s - 27) + 3*k1**2*k2**4*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 42*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**2*(D1*bd1*f*(-5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(r + s - 1) - 18*f*(k1**6*(4*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*C*(39*r**2 + 64*r*s - 48*r + 39*s**2 - 48*s + 9) + 18*K*r**2 + 36*K*r*s - 34*K*r + 18*K*s**2 - 34*K*s + 16*K - b1*(59*r**2 + 2*r*(59*s - 46) + 59*s**2 - 92*s + 33) - 69*r**2 - 124*r*s + 93*r - 69*s**2 + 93*s - 24) + k1**2*k2**4*(2*C*(45*r**2 + 76*r*s - 50*r + 45*s**2 - 50*s + 5) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 59*r**2 - 104*r*s + 64*r - 59*s**2 + 64*s - 5) + k2**6*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (-84*b1*(5*K*k2**6 + k1**6*(2*K - 2) + k1**4*k2**2*(21*K - 13) + k1**2*k2**4*(27*K - 10)) + 84*g2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*b1**2*(D1*fd*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10))) + Dd*f*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1)) + (r + s)*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) - 18*f*fd*(k1**6*(4*C - 4)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*C*(78*r**2 + r*(128*s - 71) + 78*s**2 - 50*s + 16) + 2*K*(18*r**2 + 36*r*s - 25*r + 18*s**2 - 25*s + 8) - 138*r**2 - 248*r*s + 131*r - 138*s**2 + 110*s - 31) + k1**2*k2**4*(2*C*(90*r**2 + 152*r*s - 69*r + 90*s**2 - 48*s + 12) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 118*r**2 - 208*r*s + 83*r - 118*s**2 + 62*s - 12) + k2**6*(14*C - 7)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 84*f*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6) + 84*fd*g2*(r + s)**2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6)) - Dd*f*(5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(4*r + 4*s - 3) + 18*f*(k1**6*(4*C - 4)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(C*(312*r**2 + 4*r*(128*s - 87) + 312*s**2 - 278*s + 82) + 2*K*(36*r**2 + 72*r*s - 59*r + 36*s**2 - 59*s + 24) - 276*r**2 - 496*r*s + 324*r - 276*s**2 + 289*s - 86) + k1**2*k2**4*(C*(360*r**2 + 32*r*(19*s - 11) + 360*s**2 - 282*s + 58) + 7*K*(4*r + 4*s - 3)**2 - 236*r**2 - 416*r*s + 218*r - 236*s**2 + 183*s - 29) + k2**6*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 84*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))) + f*k1**2*(D1*(-105*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*f*k2**2*(5*fd*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) + 36*fd*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(105*f**2*k1**4*(r + s - 1) + 10*f*k2**2*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3)) - 36*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3)))))/(35*d**2*k3**7) + D1**3*Pk2*Pkd3*ct*f*k1*k2**3*st**6*(D1*(f**2*(-11*bd1*k2**2*(33*r**2 + r*(66*s - 52) + 33*s**2 - 52*s + 19) + fd*k1**2*(1996*r**2 + r*(3992*s - 2829) + 1996*s**2 - 2829*s + 999)) + 11*f*k2**2*(18*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 72*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 198*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(499*r + 499*s - 333) - 11*f*k2**2*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(396*K*b1 - 198*b1 - 792*g2)))/(77*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*ct*k1*k2*st**4*(D1*(-462*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*(11*bd1*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(r + s - 1) - fd*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 11*f**2*k2**2*(-6*bd1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + b1*(-13*r - 13*s + 3) + 8*r + 8*s - 4))*(r + s - 1) + fd*(2*k1**2*(-12*C*(6*r**2 + 36*r*s - 11*r + 6*s**2 - 23*s + 6) + b1*(36*r**2 + r*(72*s - 66) + 36*s**2 - 66*s + 28) + 54*r**2 + 252*r*s - 87*r + 54*s**2 - 159*s + 42) - k2**2*(4*C*(45*r**2 + 3*r*(66*s - 23) + 45*s**2 - 123*s + 32) + 15*b1*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6) - 54*r**2 - 324*r*s + 96*r - 54*s**2 + 204*s - 52)) + 12*gd2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(r + s - 1)) + 33*f*k2**2*(b1**2*fd*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4))*(2*r + 2*s - 1) + 28*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-2*K*bd1 + bd1 + 2*gd2) + 4*g2*(14*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(2*r + 2*s - 1)))) + Dd*f*(-462*b1*k2**4*(b1*(2*K - 1) - 4*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - f**3*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 11*f**2*k2**2*(2*k1**2*(-12*C*(8*r**2 + 48*r*s - 14*r + 8*s**2 - 34*s + 7) + b1*(48*r**2 + r*(96*s - 92) + 48*s**2 - 92*s + 42) + 72*r**2 + 336*r*s - 114*r + 72*s**2 - 234*s + 51) - k2**2*(4*C*(60*r**2 + r*(264*s - 91) + 60*s**2 - 181*s + 39) + 15*b1*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 72*r**2 - 432*r*s + 122*r - 72*s**2 + 302*s - 60)) + 33*f*k2**2*(4*r + 4*s - 3)*(b1**2*k2**2*(13*r + 13*s - 3) - 2*b1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4)) + 4*g2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*ct*k1*st**2*(D1*(-462*b1*fd*k2**4*(r + s)**2*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) - 3*f**3*k1**2*(-11*bd1*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 11*f**2*k2**2*(-6*bd1*(k1**4*(2*K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(-8*C*(4*r**2 + 29*r*s - 13*r + 4*s**2 - 13*s + 9) + 61*K*r**2 + 122*K*r*s - 88*K*r + 61*K*s**2 - 88*K*s + 27*K + 9*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) - 4*r**2 + 76*r*s - 8*r - 4*s**2 - 8*s + 12) - k2**4*(4*C*(r**2 + 6*r*(5*s - 2) + s**2 - 12*s + 11) - 105*K*r**2 - 210*K*r*s + 168*K*r - 105*K*s**2 + 168*K*s - 63*K + 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*r**2 - 46*r*s + 17*r + 5*s**2 + 17*s - 22)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) + 12*gd2*(2*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 21*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) + 33*f*k2**2*(-3*b1**2*fd*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(-4*C*(16*r**2 + 2*r*(58*s - 1) + 16*s**2 - 65*s - 3) + K*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) - 8*r**2 + 8*r*(19*s + 8) - 8*s**2 - 62*s - 30) - k2**4*(4*C*(2*r**2 + r*(60*s + 5) + 2*s**2 - 37*s - 3) - 21*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) + 10*r**2 - 92*r*s - 17*r + 10*s**2 + 67*s + 6)) + 14*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(1 - 2*K) + bd1*k2**2*(8*K - 5) + 2*gd2*(k1**2 - 4*k2**2))) + 4*g2*(-14*bd1*k2**2*(k1**2 - 4*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 21*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(-462*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) - 15*f**3*k1**4*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) + 11*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) + 33*f*k2**2*(-3*b1**2*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*C*(32*r**2 + 232*r*s - 33*r + 32*s**2 - 138*s + 12) - K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 16*r**2 - 304*r*s - 90*r + 16*s**2 + 120*s + 48) + k2**4*(-4*C*(4*r**2 + 5*r*(24*s - 1) + 4*s**2 - 75*s + 5) + 21*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 20*r**2 + 184*r*s + 11*r - 20*s**2 - 129*s + 10)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**2*k2**2*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 21*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(385*d**2*k2*k3**7) + D1**3*Pk2*Pkd3*ct*k1*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(-k1**4*(-8*C + 20*b1 + 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*r + 7*K*s - 7*K - 21*b1*(3*r + 3*s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) + 84*k2**2*(r + s)*(b1*(10*K*k2**4 + k1**4*(4*K - 2) + k1**2*k2**2*(18*K - 5)) - 2*g2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) + 3*b1**2*k2**2*(D1*fd*(3*f*k1**2*(20*k1**2*(2*r + 2*s - 1) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5))) + Dd*f*(4*r + 4*s - 3)*(60*f*k1**4*(2*r + 2*s - 1) + 63*f*k1**2*k2**2*(3*r + 3*s - 1) + (r + s)*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5)))) + b1*(D1*(-5*f**2*fd*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 6*f*k2**2*(3*fd*(2*r + 2*s - 1)*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 28*gd2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k2**2*(r + s)**2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 168*g2*k2**2*(r + s)*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) - 18*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 14*f*gd2*(r + s - 1) - 14*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1))/(35*d**2*k2*k3**7) + 2*D1**3*Pk2*Pkd3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(11*d**2*k3**7) - D1**3*Pk2*Pkd3*f*k2**2*st**6*(D1*(f**2*k1**2*(11*bd1*k2**2*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 7) - fd*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) + 11*f*k2**2*(b1*fd*k1**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) - 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-9*K*bd1 + 18*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 198*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2)) + 11*f*k2**2*(b1*k1**2*(-15*r - 15*s + 7) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(198*K*b1 - 396*g2)*(2*r + 2*s - 1)))/(77*d**2*k3**7) + 3*D1**3*Pk2*Pkd3*k1**2*(-D1*bd1*f*(r + s - 1)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)) + b1**2*(D1*fd*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(2*D1*bd1*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(r + s - 1) + D1*(-15*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 14*gd2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s))))/(35*d**2*k3**7) + 3*D1**3*Pk2*Pkd3*st**4*(D1*(462*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) + f**3*k1**2*(33*bd1*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + fd*k1**2*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3)) + 33*f**2*k2**2*(fd*(2*k1**4*(2*C*(r*(6*s - 1) - 4*s + 1) + 6*b1*r**2 + 6*b1*s**2 - 4*b1*s + r*(12*b1*s - 4*b1 - 6*s + 1) + 4*s - 1) + k1**2*k2**2*(b1*(39*r**2 + r*(78*s - 53) + 39*s**2 - 53*s + 18) + (4*C - 2)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) + k2**4*(2 - 4*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 2*k2**2*(r + s - 1)*(b1*bd1*k1**2*(13*r + 13*s - 3) - bd1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 2*gd2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))) - 33*f*k2**4*(b1**2*fd*k1**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(2*r + 2*s - 1)*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 28*b1*k2**2*(-K*bd1 + gd2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 4*g2*(7*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(462*b1*k2**6*(K*b1 - 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**3*k1**4*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 33*f**2*k2**2*(2*k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + 8*b1*r**2 + 8*b1*s**2 - 6*b1*s + r*(16*b1*s - 6*b1 - 8*s + 1) + 6*s - 1) + k1**2*k2**2*(b1*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + (4*C - 2)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) + k2**4*(2 - 4*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 33*f*k2**4*(4*r + 4*s - 3)*(b1**2*k1**2*(13*r + 13*s - 3) - 2*b1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 4*g2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))))/(385*d**2*k3**7) + D1**3*Pk2*Pkd3*st**2*(D1*bd1*f*(f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(r + s - 1) - 6*f*k2**2*(k1**4*(-14*C*(2*r*s - r - s + 1) + K*r**2 + 2*K*r*s + 2*K*r + K*s**2 + 2*K*s - 3*K + 3*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) + 14*r*s - 7*r - 7*s + 7) + k1**2*k2**2*(-4*C*(4*r**2 + 15*r*s - 6*r + 4*s**2 - 6*s + 2) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 30*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(-k1**2 + 5*k2**2)*(-84*K*b1 + 84*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 3*b1**2*k2**2*(D1*fd*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**4*(5*r + 5*s + 1) - 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(D1*(f**2*fd*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) - 6*f*k2**2*(fd*(K*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) - (2*C - 1)*(7*k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + r*(60*s - 2) + 16*s**2 - 23*s - 3) - 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)))) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 84*fd*g2*k2**4*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(4*r + 4*s - 3) - 6*f*k2**2*(k1**4*(-14*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s + 9*r + 4*s**2 + 9*s - 9) + 56*r*s - 7*r - 42*s + 7) + k1**2*k2**2*(C*(-64*r**2 + r*(38 - 240*s) - 64*s**2 + 108*s + 4) + 7*K*(4*r + 4*s - 3)**2 + 32*r**2 + 120*r*s - 19*r + 32*s**2 - 54*s - 2) + k2**4*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 84*g2*k2**4*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*k1**2*(D1*(-15*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(-fd*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 6*gd2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) + 12*fd*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) - 12*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3)))))/(35*d**2*k3**7) + D1**3*Pk2*Pkdd3*b1*k1**2*(D1*bd1*f*(5*b1*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - (4*C - 2)*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3)) + b1*(D1*fd*(5*b1*(r + s - 1)**2 - (8*C - 4)*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1)) + Dd*f*(5*b1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - (4*C - 2)*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1))))/(15*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**8*f*k1**2*k2**4*(792*C*D1*f*fd*r**2 + 1584*C*D1*f*fd*r*s - 858*C*D1*f*fd*r + 792*C*D1*f*fd*s**2 - 858*C*D1*f*fd*s + 220*C*D1*f*fd + 1056*C*Dd*f**2*r**2 + 2112*C*Dd*f**2*r*s - 1232*C*Dd*f**2*r + 1056*C*Dd*f**2*s**2 - 1232*C*Dd*f**2*s + 330*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 700*D1*f**2*fd*r**2 + 1400*D1*f**2*fd*r*s - 973*D1*f**2*fd*r + 700*D1*f**2*fd*s**2 - 973*D1*f**2*fd*s + 336*D1*f**2*fd - 792*D1*f*fd*r**2 - 1584*D1*f*fd*r*s + 858*D1*f*fd*r - 792*D1*f*fd*s**2 + 858*D1*f*fd*s - 220*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 700*Dd*f**3*r**2 + 1400*Dd*f**3*r*s - 973*Dd*f**3*r + 700*Dd*f**3*s**2 - 973*Dd*f**3*s + 336*Dd*f**3 - 1056*Dd*f**2*r**2 - 2112*Dd*f**2*r*s + 1232*Dd*f**2*r - 1056*Dd*f**2*s**2 + 1232*Dd*f**2*s - 330*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(693*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct**7*f*k1*k2**3*(D1*bd1*f*(r + s - 1)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18) + b1*(D1*fd*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(12*r + 12*s - 5))/(63*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**7*f*k1*k2**3*(-13860*C*D1*f*fd*k1**2*r**2 - 27720*C*D1*f*fd*k1**2*r*s + 16500*C*D1*f*fd*k1**2*r - 13860*C*D1*f*fd*k1**2*s**2 + 16500*C*D1*f*fd*k1**2*s - 4840*C*D1*f*fd*k1**2 - 15840*C*D1*f*fd*k2**2*r**2 - 55440*C*D1*f*fd*k2**2*r*s + 21120*C*D1*f*fd*k2**2*r - 15840*C*D1*f*fd*k2**2*s**2 + 33000*C*D1*f*fd*k2**2*s - 8360*C*D1*f*fd*k2**2 - 18480*C*Dd*f**2*k1**2*r**2 - 36960*C*Dd*f**2*k1**2*r*s + 23540*C*Dd*f**2*k1**2*r - 18480*C*Dd*f**2*k1**2*s**2 + 23540*C*Dd*f**2*k1**2*s - 7260*C*Dd*f**2*k1**2 - 21120*C*Dd*f**2*k2**2*r**2 - 73920*C*Dd*f**2*k2**2*r*s + 28600*C*Dd*f**2*k2**2*r - 21120*C*Dd*f**2*k2**2*s**2 + 48400*C*Dd*f**2*k2**2*s - 10560*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(18*K - 18)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 21140*D1*f**2*fd*k1**2*r**2 - 42280*D1*f**2*fd*k1**2*r*s + 30555*D1*f**2*fd*k1**2*r - 21140*D1*f**2*fd*k1**2*s**2 + 30555*D1*f**2*fd*k1**2*s - 11025*D1*f**2*fd*k1**2 + 13860*D1*f*fd*k1**2*r**2 + 27720*D1*f*fd*k1**2*r*s - 16500*D1*f*fd*k1**2*r + 13860*D1*f*fd*k1**2*s**2 - 16500*D1*f*fd*k1**2*s + 4840*D1*f*fd*k1**2 + 11880*D1*f*fd*k2**2*r**2 + 35640*D1*f*fd*k2**2*r*s - 14850*D1*f*fd*k2**2*r + 11880*D1*f*fd*k2**2*s**2 - 20790*D1*f*fd*k2**2*s + 5280*D1*f*fd*k2**2 + 7524*D1*f*gd2*k1**2*r**2 + 15048*D1*f*gd2*k1**2*r*s - 12672*D1*f*gd2*k1**2*r + 7524*D1*f*gd2*k1**2*s**2 - 12672*D1*f*gd2*k1**2*s + 5148*D1*f*gd2*k1**2 + 7920*D1*f*gd2*k2**2*r**2 + 15840*D1*f*gd2*k2**2*r*s - 11880*D1*f*gd2*k2**2*r + 7920*D1*f*gd2*k2**2*s**2 - 11880*D1*f*gd2*k2**2*s + 3960*D1*f*gd2*k2**2 + 15048*D1*fd*g2*k1**2*r**2 + 30096*D1*fd*g2*k1**2*r*s - 17820*D1*fd*g2*k1**2*r + 15048*D1*fd*g2*k1**2*s**2 - 17820*D1*fd*g2*k1**2*s + 5148*D1*fd*g2*k1**2 + 15840*D1*fd*g2*k2**2*r**2 + 31680*D1*fd*g2*k2**2*r*s - 15840*D1*fd*g2*k2**2*r + 15840*D1*fd*g2*k2**2*s**2 - 15840*D1*fd*g2*k2**2*s + 3960*D1*fd*g2*k2**2 - 21140*Dd*f**3*k1**2*r**2 - 42280*Dd*f**3*k1**2*r*s + 30555*Dd*f**3*k1**2*r - 21140*Dd*f**3*k1**2*s**2 + 30555*Dd*f**3*k1**2*s - 11025*Dd*f**3*k1**2 + 18480*Dd*f**2*k1**2*r**2 + 36960*Dd*f**2*k1**2*r*s - 23540*Dd*f**2*k1**2*r + 18480*Dd*f**2*k1**2*s**2 - 23540*Dd*f**2*k1**2*s + 7260*Dd*f**2*k1**2 + 15840*Dd*f**2*k2**2*r**2 + 47520*Dd*f**2*k2**2*r*s - 20460*Dd*f**2*k2**2*r + 15840*Dd*f**2*k2**2*s**2 - 30360*Dd*f**2*k2**2*s + 6930*Dd*f**2*k2**2 + 30096*Dd*f*g2*k1**2*r**2 + 60192*Dd*f*g2*k1**2*r*s - 43164*Dd*f*g2*k1**2*r + 30096*Dd*f*g2*k1**2*s**2 - 43164*Dd*f*g2*k1**2*s + 15444*Dd*f*g2*k1**2 + 31680*Dd*f*g2*k2**2*r**2 + 63360*Dd*f*g2*k2**2*r*s - 39600*Dd*f*g2*k2**2*r + 31680*Dd*f*g2*k2**2*s**2 - 39600*Dd*f*g2*k2**2*s + 11880*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(18 - 18*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(18 - 18*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(3465*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**6*f*k1**2*k2**4*st**2*(1782*C*D1*f*fd*r**2 + 3564*C*D1*f*fd*r*s - 1980*C*D1*f*fd*r + 1782*C*D1*f*fd*s**2 - 1980*C*D1*f*fd*s + 528*C*D1*f*fd + 2376*C*Dd*f**2*r**2 + 4752*C*Dd*f**2*r*s - 2838*C*Dd*f**2*r + 2376*C*Dd*f**2*s**2 - 2838*C*Dd*f**2*s + 792*C*Dd*f**2 + 297*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2212*D1*f**2*fd*r**2 + 4424*D1*f**2*fd*r*s - 3087*D1*f**2*fd*r + 2212*D1*f**2*fd*s**2 - 3087*D1*f**2*fd*s + 1071*D1*f**2*fd - 1782*D1*f*fd*r**2 - 3564*D1*f*fd*r*s + 1980*D1*f*fd*r - 1782*D1*f*fd*s**2 + 1980*D1*f*fd*s - 528*D1*f*fd - 1188*D1*f*gd2*r**2 - 2376*D1*f*gd2*r*s + 1782*D1*f*gd2*r - 1188*D1*f*gd2*s**2 + 1782*D1*f*gd2*s - 594*D1*f*gd2 - 2376*D1*fd*g2*r**2 - 4752*D1*fd*g2*r*s + 2376*D1*fd*g2*r - 2376*D1*fd*g2*s**2 + 2376*D1*fd*g2*s - 594*D1*fd*g2 + 2212*Dd*f**3*r**2 + 4424*Dd*f**3*r*s - 3087*Dd*f**3*r + 2212*Dd*f**3*s**2 - 3087*Dd*f**3*s + 1071*Dd*f**3 - 2376*Dd*f**2*r**2 - 4752*Dd*f**2*r*s + 2838*Dd*f**2*r - 2376*Dd*f**2*s**2 + 2838*Dd*f**2*s - 792*Dd*f**2 - 4752*Dd*f*g2*r**2 - 9504*Dd*f*g2*r*s + 5940*Dd*f*g2*r - 4752*Dd*f*g2*s**2 + 5940*Dd*f*g2*s - 1782*Dd*f*g2 + 297*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(693*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**6*k2**2*(-126*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - b1*(126*D1*bd1*f*k1**2*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(5*f**2*fd*k1**2*(279*r**2 + r*(558*s - 429) + 279*s**2 - 429*s + 170) + 18*f*(-5*K*fd*k2**2*(2*r + 2*s - 1)**2 + fd*k1**2*(12*C*(r + s - 1)**2 + 26*r**2 + r*(52*s - 21) + 26*s**2 - 21*s + 1) - 14*gd2*k1**2*(r + s - 1)**2) - 252*fd*g2*k1**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*(93*r + 93*s - 73) + 18*f*(-5*K*k2**2*(2*r + 2*s - 1) + k1**2*(6*C*(r + s - 1) + 13*r + 13*s - 7)) - 252*g2*k1**2*(r + s - 1))) - f*(D1*bd1*(r + s - 1)*(5*f**2*k1**2*(93*r + 93*s - 49) + 18*f*(-5*K*k2**2*(2*r + 2*s - 1) + k1**2*(6*C*r + 6*C*s + 13*r + 13*s - 13)) - 252*g2*k1**2*(r + s)) + 10*D1*(f*fd*(k1**2*(63*r**2 + 3*r*(42*s - 25) + 63*s**2 - 75*s + 22) - k2**2*(2*C - 1)*(36*r**2 + 6*r*(21*s - 8) + 36*s**2 - 75*s + 19)) - 9*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)**2) + 10*Dd*f*(f*(k1**2*(84*r**2 + r*(168*s - 107) + 84*s**2 - 107*s + 33) - k2**2*(2*C - 1)*(48*r**2 + r*(168*s - 65) + 48*s**2 - 110*s + 24)) + k2**2*(-9*b2 + 18*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(315*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**6*k2**2*(11*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + k1**2*k2**2*(r + s)*(-252*K*b1 + 252*b1 + 252*g2)) - 1386*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k1**2*k2**2*(207*r**2 + 3*r*(138*s - 95) + 207*s**2 - 285*s + 98) - 18*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) - 14*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 252*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(69*r + 69*s - 49) - 18*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(4*r + 4*s - 9) + k1**2*k2**2*(C*(6*r + 6*s + 4) + K*(24*r + 24*s - 19) - 11*r - 11*s + 2)) + 252*g2*k1**2*k2**2*(r + s))) + f*(D1*(-35*f**2*fd*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 22*f*(5*fd*(k1**4*(6*C - 6)*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(72*r**2 + 6*r*(69*s - 22) + 72*s**2 - 267*s + 71) + 81*r**2 + 144*r*(3*s - 1) + 81*s**2 - 279*s + 75) - k2**4*(2*C - 1)*(36*r**2 + 6*r*(21*s - 8) + 36*s**2 - 75*s + 19)) + 18*gd2*(k1**4*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 396*fd*g2*(k1**4*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 9) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(-35*f**2*k1**2*(k1**2*(137*r + 137*s - 111) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 110*f*(k1**4*(6*C - 6)*(4*r + 4*s - 3) + k1**2*k2**2*(-2*C*(96*r**2 + r*(552*s - 169) + 96*s**2 - 394*s + 84) + 108*r**2 + 6*r*(96*s - 31) + 108*s**2 - 411*s + 90) - k2**4*(2*C - 1)*(48*r**2 + r*(168*s - 65) + 48*s**2 - 110*s + 24)) + 396*g2*(k1**4*(16*r**2 + 16*r*(2*s - 3) + 16*s**2 - 48*s + 27) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3465*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct**5*f*k1*k2**3*st**2*(D1*bd1*f*(r + s - 1)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18) + b1*(D1*fd*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(9*r + 9*s - 4))/(21*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**5*f*k1*k2**3*st**2*(-24552*C*D1*f*fd*k1**2*r**2 - 49104*C*D1*f*fd*k1**2*r*s + 28776*C*D1*f*fd*k1**2*r - 24552*C*D1*f*fd*k1**2*s**2 + 28776*C*D1*f*fd*k1**2*s - 8272*C*D1*f*fd*k1**2 - 35640*C*D1*f*fd*k2**2*r**2 - 118800*C*D1*f*fd*k2**2*r*s + 47520*C*D1*f*fd*k2**2*r - 35640*C*D1*f*fd*k2**2*s**2 + 71280*C*D1*f*fd*k2**2*s - 18480*C*D1*f*fd*k2**2 - 32736*C*Dd*f**2*k1**2*r**2 - 65472*C*Dd*f**2*k1**2*r*s + 41096*C*Dd*f**2*k1**2*r - 32736*C*Dd*f**2*k1**2*s**2 + 41096*C*Dd*f**2*k1**2*s - 12408*C*Dd*f**2*k1**2 - 47520*C*Dd*f**2*k2**2*r**2 - 158400*C*Dd*f**2*k2**2*r*s + 64680*C*Dd*f**2*k2**2*r - 47520*C*Dd*f**2*k2**2*s**2 + 104280*C*Dd*f**2*k2**2*s - 23760*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(12*K - 12)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 52260*D1*f**2*fd*k1**2*r**2 - 104520*D1*f**2*fd*k1**2*r*s + 75255*D1*f**2*fd*k1**2*r - 52260*D1*f**2*fd*k1**2*s**2 + 75255*D1*f**2*fd*k1**2*s - 27045*D1*f**2*fd*k1**2 + 24552*D1*f*fd*k1**2*r**2 + 49104*D1*f*fd*k1**2*r*s - 28776*D1*f*fd*k1**2*r + 24552*D1*f*fd*k1**2*s**2 - 28776*D1*f*fd*k1**2*s + 8272*D1*f*fd*k1**2 + 26730*D1*f*fd*k2**2*r**2 + 77220*D1*f*fd*k2**2*r*s - 33660*D1*f*fd*k2**2*r + 26730*D1*f*fd*k2**2*s**2 - 45540*D1*f*fd*k2**2*s + 11880*D1*f*fd*k2**2 + 15048*D1*f*gd2*k1**2*r**2 + 30096*D1*f*gd2*k1**2*r*s - 25344*D1*f*gd2*k1**2*r + 15048*D1*f*gd2*k1**2*s**2 - 25344*D1*f*gd2*k1**2*s + 10296*D1*f*gd2*k1**2 + 23760*D1*f*gd2*k2**2*r**2 + 47520*D1*f*gd2*k2**2*r*s - 35640*D1*f*gd2*k2**2*r + 23760*D1*f*gd2*k2**2*s**2 - 35640*D1*f*gd2*k2**2*s + 11880*D1*f*gd2*k2**2 + 30096*D1*fd*g2*k1**2*r**2 + 60192*D1*fd*g2*k1**2*r*s - 35640*D1*fd*g2*k1**2*r + 30096*D1*fd*g2*k1**2*s**2 - 35640*D1*fd*g2*k1**2*s + 10296*D1*fd*g2*k1**2 + 47520*D1*fd*g2*k2**2*r**2 + 95040*D1*fd*g2*k2**2*r*s - 47520*D1*fd*g2*k2**2*r + 47520*D1*fd*g2*k2**2*s**2 - 47520*D1*fd*g2*k2**2*s + 11880*D1*fd*g2*k2**2 - 52260*Dd*f**3*k1**2*r**2 - 104520*Dd*f**3*k1**2*r*s + 75255*Dd*f**3*k1**2*r - 52260*Dd*f**3*k1**2*s**2 + 75255*Dd*f**3*k1**2*s - 27045*Dd*f**3*k1**2 + 32736*Dd*f**2*k1**2*r**2 + 65472*Dd*f**2*k1**2*r*s - 41096*Dd*f**2*k1**2*r + 32736*Dd*f**2*k1**2*s**2 - 41096*Dd*f**2*k1**2*s + 12408*Dd*f**2*k1**2 + 35640*Dd*f**2*k2**2*r**2 + 102960*Dd*f**2*k2**2*r*s - 46530*Dd*f**2*k2**2*r + 35640*Dd*f**2*k2**2*s**2 - 66330*Dd*f**2*k2**2*s + 15840*Dd*f**2*k2**2 + 60192*Dd*f*g2*k1**2*r**2 + 120384*Dd*f*g2*k1**2*r*s - 86328*Dd*f*g2*k1**2*r + 60192*Dd*f*g2*k1**2*s**2 - 86328*Dd*f*g2*k1**2*s + 30888*Dd*f*g2*k1**2 + 95040*Dd*f*g2*k2**2*r**2 + 190080*Dd*f*g2*k2**2*r*s - 118800*Dd*f*g2*k2**2*r + 95040*Dd*f*g2*k2**2*s**2 - 118800*Dd*f*g2*k2**2*s + 35640*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(12 - 12*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(12 - 12*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(3465*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct**5*k1*k2*(r + s - 1)*(6*D1*bd1*f**2*(r + s) + b1**2*(2*D1*fd*(13*f + 7)*(r + s - 1) + Dd*f*(13*f + 14)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(13*f + 14)*(2*r + 2*s - 1) + 12*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k3**2) + D1**3*Pk2*Pkdd3*ct**5*k1*k2*(-3*b1**2*(D1*fd*(k1**2*(14*K - 14)*(r + s - 1)**2 + 3*k2**2*(28*K*(r + s - 1)**2 + f*(33*r + 33*s - 23) + 28*r + 28*s - 14)) + 2*Dd*f*(k1**2*(7*K - 7)*(r + s - 1) + 3*k2**2*(14*K*(r + s - 1) + 5*f + 7))*(4*r + 4*s - 3)) - 3*b1*(7*D1*bd1*f*(k1**2*(2*K - 2)*(2*r + 2*s - 1) + 3*k2**2*(K*(8*r + 8*s - 4) + f + 2))*(r + s - 1) + D1*(5*f**2*fd*(k1**2*(54*r**2 + 3*r*(36*s - 35) + 54*s**2 - 105*s + 49) - 3*k2**2*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6)) - 2*f*(3*fd*(k1**2*(4*C*(r + s - 1)**2 - 12*r**2 - 6*r*(4*s - 5) - 12*s**2 + 30*s - 13) + k2**2*(-4*C*(6*r**2 + r*(40*s - 19) + 6*s**2 - 33*s + 13) + K*(38*r**2 + 76*r*s - 45*r + 38*s**2 - 45*s + 13) + 40*r**2 + 136*r*s - 79*r + 40*s**2 - 107*s + 41)) + 14*gd2*(k1**2 + 6*k2**2)*(r + s - 1)**2) - 28*fd*g2*(k1**2 + 6*k2**2)*(r + s - 1)**2) + Dd*f*(5*f**2*(2*k1**2*(9*r + 9*s - 10) - 3*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 6*f*(k1**2*(4*r + 4*s - 3)*(2*C*(r + s - 1) - 6*r - 6*s + 11) + k2**2*(-4*C*(12*r**2 + 4*r*(20*s - 7) + 12*s**2 - 63*s + 16) + K*(76*r**2 + 152*r*s - 109*r + 76*s**2 - 109*s + 39) + 80*r**2 + 272*r*s - 146*r + 80*s**2 - 216*s + 68)) - 28*g2*(k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + f*(-3*D1*bd1*(5*f**2*(k1**2*(18*r + 18*s - 11) - 3*k2**2*(5*r + 5*s - 3))*(r + s - 1) - 6*f*(k1**2*(r + s - 1)*(r*(2*C - 6) + s*(2*C - 6) + 9) + k2**2*(-12*C*s**2 + 40*C*s + K*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) - r**2*(12*C - 20) + r*(-80*C*s + 12*C + 68*s - 29) + 20*s**2 - 43*s + 9)) - 28*g2*(k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*(f*(5*fd*(k1**2*(9*r + 9*s - 6) + k2**2*(2*C*(63*r**2 + 234*r*s - 93*r + 63*s**2 - 147*s + 40) - 9*r**2 - 126*r*s + 30*r - 9*s**2 + 84*s - 22)) + k2**2*(9*bd2 - 18*gd2)*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13)) + 9*fd*k2**2*(b2 - 2*g2)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13)) + 2*Dd*f*(5*f*(3*k1**2*(4*r + 4*s - 3) + k2**2*(2*C*(84*r**2 + 312*r*s - 125*r + 84*s**2 - 215*s + 51) - 12*r**2 - 168*r*s + 35*r - 12*s**2 + 125*s - 24)) + k2**2*(9*b2 - 18*g2)*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39))))/(315*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**5*k1*k2*(11*D1*bd1*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 18*f*(k1**4*(K - 1)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) + k1**2*k2**2*(r + s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5) + 9*K*r**2 + 18*K*r*s - 10*K*r + 9*K*s**2 - 10*K*s + K + b1*(13*r**2 + 2*r*(13*s - 8) + 13*s**2 - 16*s + 3) - 5*r**2 + 18*r*s + 4*r - 5*s**2 + 4*s + 1)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + 3*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(2*K - 2) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*(3*fd*(k1**4*(K - 1)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) + k2**4*(-4*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) - 10*r**2 + 36*r*s + 31*r - 10*s**2 - 11*s - 13)) + 28*gd2*k2**2*(k1**2 + 3*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k2**2*(k1**2 + 3*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(4*k1**2*(3*r + 3*s - 8) - 9*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 18*f*(k1**4*(K - 1)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s - 4) + 3*K*(9*r + 9*s - 1) - 35*r - 35*s + 28) - k2**4*(4*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) - K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 20*r**2 - 72*r*s - 53*r + 20*s**2 + 17*s + 25)) + 168*g2*k2**2*(k1**2 + 3*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(35*f**2*fd*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**4*(2*C - 2)*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + 3*k1**2*k2**2*(C*(90*r**2 + 6*r*(6*s - 13) + 90*s**2 - 6*s + 4) - 90*r**2 - 3*r*(36*s - 31) - 90*s**2 + 57*s - 18) + k2**4*(C*(90*r**2 - 6*r*(6*s + 11) + 90*s**2 + 42*s - 8) - 99*r**2 + r*(96 - 90*s) - 99*s**2 + 42*s - 14)) - 18*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1)) + 396*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1)) + Dd*f*(35*f**2*k1**2*(k1**2*(5*r + 5*s - 23) - 33*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 110*f*(k1**4*(2*C - 2)*(60*r**2 + r*(120*s - 73) + 60*s**2 - 73*s + 21) + 3*k1**2*k2**2*(2*C*(60*r**2 + r*(24*s - 61) + 60*s**2 - s + 9) - 120*r**2 - 3*r*(48*s - 46) - 120*s**2 + 78*s - 33) + k2**4*(2*C*(60*r**2 - r*(24*s + 55) + 60*s**2 + 35*s + 3) - 132*r**2 - 5*r*(24*s - 29) - 132*s**2 + 55*s - 30)) + 396*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3))))/(3465*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**4*f*k1**2*k2**4*st**4*(396*C*D1*f*fd*r**2 + 792*C*D1*f*fd*r*s - 462*C*D1*f*fd*r + 396*C*D1*f*fd*s**2 - 462*C*D1*f*fd*s + 132*C*D1*f*fd + 528*C*Dd*f**2*r**2 + 1056*C*Dd*f**2*r*s - 660*C*Dd*f**2*r + 528*C*Dd*f**2*s**2 - 660*C*Dd*f**2*s + 198*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 812*D1*f**2*fd*r**2 + 1624*D1*f**2*fd*r*s - 1141*D1*f**2*fd*r + 812*D1*f**2*fd*s**2 - 1141*D1*f**2*fd*s + 399*D1*f**2*fd - 396*D1*f*fd*r**2 - 792*D1*f*fd*r*s + 462*D1*f*fd*r - 396*D1*f*fd*s**2 + 462*D1*f*fd*s - 132*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 812*Dd*f**3*r**2 + 1624*Dd*f**3*r*s - 1141*Dd*f**3*r + 812*Dd*f**3*s**2 - 1141*Dd*f**3*s + 399*Dd*f**3 - 528*Dd*f**2*r**2 - 1056*Dd*f**2*r*s + 660*Dd*f**2*r - 528*Dd*f**2*s**2 + 660*Dd*f**2*s - 198*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(231*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**4*k2**2*st**2*(-252*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1*(84*D1*bd1*f*k1**2*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(5*f**2*fd*k1**2*(207*r**2 + 9*r*(46*s - 35) + 207*s**2 - 315*s + 124) + 6*f*(-15*K*fd*k2**2*(2*r + 2*s - 1)**2 + 2*fd*k1**2*(10*C*(r + s - 1)**2 + 28*r**2 + r*(56*s - 25) + 28*s**2 - 25*s + 3) - 28*gd2*k1**2*(r + s - 1)**2) - 168*fd*g2*k1**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(-90*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(69*r + 69*s - 53) + 12*f*k1**2*(5*C*(r + s - 1) + 14*r + 14*s - 8) - 168*g2*k1**2*(r + s - 1))) - f*(3*D1*bd1*(r + s - 1)*(-90*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(69*r + 69*s - 35) + 12*f*k1**2*(r*(5*C + 14) + s*(5*C + 14) - 13) - 168*g2*k1**2*(r + s)) + 2*D1*(f*fd*(2*k1**2*(279*r**2 + r*(558*s - 327) + 279*s**2 - 327*s + 94) + k2**2*(15 - 30*C)*(27*r**2 + 18*r*(5*s - 2) + 27*s**2 - 54*s + 14)) - 135*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 135*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)**2) + 2*Dd*f*(f*(2*k1**2*(372*r**2 + r*(744*s - 467) + 372*s**2 - 467*s + 141) + k2**2*(15 - 30*C)*(36*r**2 + r*(120*s - 49) + 36*s**2 - 79*s + 18)) + k2**2*(-135*b2 + 270*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(315*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**4*k2**2*st**2*(33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + k1**2*k2**2*(r + s)*(-168*K*b1 + 168*b1 + 168*g2)) - 2772*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(153*r**2 + 9*r*(34*s - 23) + 153*s**2 - 207*s + 70) - 6*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) - 28*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 168*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(51*r + 51*s - 35) - 6*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(3*K - 3)*(3*r + 3*s - 5) + 2*k1**2*k2**2*(5*C*r + 5*C*s + C + 24*K*r + 24*K*s - 19*K - 10*r - 10*s + 5)) + 168*g2*k1**2*k2**2*(r + s))) + f*(D1*(-75*f**2*fd*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(fd*(k1**4*(36*C - 36)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(396*r**2 + 6*r*(321*s - 109) + 396*s**2 - 1221*s + 323) - 513*r**2 - 72*r*(30*s - 11) - 513*s**2 + 1359*s - 363) + k2**4*(30*C - 15)*(27*r**2 + 18*r*(5*s - 2) + 27*s**2 - 54*s + 14)) - 18*gd2*(3*k1**4*(3*r**2 + r*(6*s - 8) + 3*s**2 - 8*s + 5) + 2*k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 396*fd*g2*(3*k1**4*(6*r**2 + r*(12*s - 13) + 6*s**2 - 13*s + 5) + 2*k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(-75*f**2*k1**2*(k1**2*(131*r + 131*s - 101) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(k1**4*(36*C - 36)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(528*r**2 + r*(2568*s - 853) + 528*s**2 - 1798*s + 390) - 684*r**2 - 30*r*(96*s - 35) - 684*s**2 + 1995*s - 450) + k2**4*(30*C - 15)*(36*r**2 + r*(120*s - 49) + 36*s**2 - 79*s + 18)) + 396*g2*(k1**4*(36*r**2 + r*(72*s - 87) + 36*s**2 - 87*s + 45) + 2*k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3465*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**4*(6*D1*bd1*f*(f*(k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + k2**2*(2*C - 1)*(3*r**2 + r*(20*s - 3) + s*(3*s - 10))) + k2**2*(7*b2 - 14*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - b1**2*(2*D1*fd*(-21*K*k2**2 + k1**2*(15*f + 7))*(r + s - 1) + Dd*f*(-42*K*k2**2 + k1**2*(15*f + 14))*(4*r + 4*s - 3))*(r + s - 1) + b1*(-D1*bd1*f*(-42*K*k2**2 + k1**2*(15*f + 14))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 6*D1*(f*(2*fd*k1**2*(r + s - 1)**2 + fd*k2**2*(2*C - 1)*(6*r**2 + r*(40*s - 19) + 6*s**2 - 33*s + 13) + k2**2*(7*bd2 - 14*gd2)*(r + s - 1)**2) + 7*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + 6*Dd*f*(f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(2*C - 1)*(12*r**2 + 4*r*(20*s - 7) + 12*s**2 - 63*s + 16)) + k2**2*(7*b2 - 14*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(105*d**2*k3**2) + D1**3*Pk2*Pkdd3*ct**4*(3*D1*b1**2*fd*(42*K*k2**4*(2*r + 2*s - 1) + k1**4*(28*K - 28)*(r + s - 1)**2 + k1**2*k2**2*(56*C*(r + s - 1)**2 + 42*K*(r + s - 1)**2 - 3*f*(24*r**2 + r*(48*s - 7) + 24*s**2 - 7*s - 5) - 140*r**2 - 56*r*(5*s - 4) - 140*s**2 + 224*s - 112)) + 3*D1*b1*bd1*f*(r + s - 1)*(42*K*k2**4 + k1**4*(28*K - 28)*(2*r + 2*s - 1) + k1**2*k2**2*(56*C*(2*r + 2*s - 1) + 84*K*r + 84*K*s - 42*K - 3*f*(24*r + 24*s - 5) - 280*r - 280*s + 112)) + D1*b1*(5*f**2*fd*k1**2*(k1**2*(90*r**2 + 3*r*(60*s - 37) + 90*s**2 - 111*s + 37) + 9*k2**2*(51*r**2 + r*(102*s - 77) + 51*s**2 - 77*s + 30)) + 6*f*(3*fd*(k1**4*(16*C*(r + s - 1)**2 + 2*r**2 + r*(4*s + 21) + 2*s**2 + 21*s - 15) + k1**2*k2**2*(2*C*(18*r**2 - r*(104*s + 1) + 18*s**2 + 69*s - 17) + K*(8*r**2 + 16*r*s - 22*r + 8*s**2 - 22*s + 9) + 40*r**2 + 220*r*s - 62*r + 40*s**2 - 132*s + 30) + k2**4*(C*(40*r + 26*s - 30) - 7*K*(2*r + 2*s - 1)**2 - 20*r - 13*s + 15)) + (-3*bd2*k2**4*(r + s) + gd2*(4*k1**4*(r + s - 1) + 6*k1**2*k2**2*(r + s - 1) + 6*k2**4))*(-7*r - 7*s + 7)) - 42*fd*(-3*b2*k2**4*(r + s)**2 + 4*g2*k1**4*(r + s - 1)**2 + 6*g2*k1**2*k2**2*(r + s - 1)**2 + 6*g2*k2**4*(2*r + 2*s - 1))) + D1*bd1*f*(5*f**2*k1**2*(5*k1**2*(6*r + 6*s - 1) + 9*k2**2*(17*r + 17*s - 9))*(r + s - 1) + 18*f*(k1**4*(r + s - 1)*(8*C*r + 8*C*s + r + s - 1) + k1**2*k2**2*(18*C*s**2 + 52*C*s + K*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) + r**2*(18*C + 20) - r*(2*C*(52*s + 9) - 110*s + 49) + 20*s**2 - 84*s + 29) - k2**4*(2*C*(5*r - 2*s - 5) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 5*r + 2*s + 5)) + (r**2 + r*(2*s - 1) + s*(s - 1))*(126*b2*k2**4 - 168*g2*k1**4 - 252*g2*k1**2*k2**2)) - 6*Dd*b1**2*f*(4*r + 4*s - 3)*(-21*K*k2**4 - k1**4*(14*K - 14)*(r + s - 1) + k1**2*k2**2*(-28*C*(r + s - 1) - 21*K*(r + s - 1) + 18*f*r + 18*f*s + 70*r + 70*s - 56)) + Dd*b1*f*(5*f**2*k1**2*(2*k1**2*(15*r + 15*s - 7) + 9*k2**2*(17*r + 17*s - 13))*(4*r + 4*s - 3) + 18*f*(k1**4*(4*r + 4*s - 3)*(8*C*(r + s - 1) + r + s + 7) + k1**2*k2**2*(2*C*(36*r**2 - 4*r*(52*s + 7) + 36*s**2 + 147*s - 8) + K*(16*r**2 + 32*r*s - 48*r + 16*s**2 - 48*s + 27) + 80*r**2 + 440*r*s - 143*r + 80*s**2 - 318*s + 71) + k2**4*(10*C - 7*K*(2*r + 2*s - 1) - 5)*(4*r + 4*s - 3)) - (-3*b2*k2**4*(r + s) + g2*(4*k1**4*(r + s - 1) + 6*k1**2*k2**2*(r + s - 1) + 6*k2**4))*(168*r + 168*s - 126)) + 2*f*(D1*(f*(5*fd*(k1**4*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) + 3*k1**2*k2**2*(2*C*(6*r - 5)*(3*s - 1) + 45*r**2 + r*(72*s - 51) + 45*s**2 - 42*s + 13) + k2**4*(9 - 18*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + k2**2*(9*bd2 - 18*gd2)*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 9*fd*k2**2*(b2 - 2*g2)*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + Dd*f*(5*f*(k1**4*(60*r**2 + r*(120*s - 73) + 60*s**2 - 73*s + 21) + 3*k1**2*k2**2*(2*C*(r*(24*s - 7) - 22*s + 6) + 60*r**2 + r*(96*s - 74) + 60*s**2 - 59*s + 21) + k2**4*(9 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + k2**2*(9*b2 - 18*g2)*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3))))/(315*d**2*k3**4) - D1**3*Pk2*Pkdd3*ct**4*(33*D1*bd1*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 6*f*(k1**6*(2*K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(r + s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(11*r**2 - 48*r*s + 8*r + 11*s**2 + 8*s - 19) + 66*K*r**2 + 132*K*r*s - 99*K*r + 66*K*s**2 - 99*K*s + 33*K + b1*(23*r**2 + r*(46*s - 24) + 23*s**2 - 24*s + 1) - 55*r**2 - 40*r*s + 65*r - 55*s**2 + 65*s - 10) + k2**6*(-2*C*(3*r**2 + 4*r*(5*s - 2) + 3*s**2 - 8*s + 5) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 3*r**2 + 20*r*s - 8*r + 3*s**2 - 8*s + 5)) + 28*k2**2*(b1*(3*K*k2**4 + k1**4*(7 - 7*K) - k1**2*k2**2*(K - 3)) + g2*(7*k1**4 + k1**2*k2**2 - 3*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-3*f*k1**2*k2**2*(46*r**2 + r*(92*s - 25) + 46*s**2 - 25*s + 1) + (r + s)**2*(42*K*k2**4 - 14*k1**4*(7*K - 7) - 14*k1**2*k2**2*(K - 3))) - Dd*f*(3*f*k1**2*k2**2*(23*r + 23*s - 1) + (r + s)*(-42*K*k2**4 + 14*k1**4*(7*K - 7) + 14*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(15*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 6*f*fd*(k1**6*(2*K - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*r + 2*s - 1)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(22*r**2 - r*(96*s + 43) + 22*s**2 + 62*s + 16) + 33*K*(2*r + 2*s - 1)**2 - 110*r**2 - 80*r*s + 145*r - 110*s**2 + 40*s - 45) + k2**6*(-2*C*(6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2) + 7*K*(2*r + 2*s - 1)**2 + 6*r**2 + 40*r*s + r + 6*s**2 - 20*s - 2)) + 28*f*gd2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k2**2*(r + s)**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)) + Dd*f*(15*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 6*f*(k1**6*(2*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(C*(34*r + 34*s - 24) + 23*K*(2*r + 2*s - 1) - 71*r - 71*s + 46) + k1**2*k2**4*(2*C*(44*r**2 - 2*r*(96*s + 31) + 44*s**2 + 113*s + 13) + 33*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 220*r**2 - 5*r*(32*s - 62) - 220*s**2 + 135*s - 100) + k2**6*(-2*C*(12*r**2 + r*(80*s - 8) + 12*s**2 - 43*s + 1) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 12*r**2 + 80*r*s - 8*r + 12*s**2 - 43*s + 1)) + 28*g2*k2**2*(7*k1**4 + k1**2*k2**2 - 3*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-35*f**2*fd*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 22*f*(5*fd*(k1**6*(4*C - 4)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(198*r**2 + 6*r*(57*s - 41) + 198*s**2 - 219*s + 73) - 351*r**2 - 18*r*(36*s - 25) - 351*s**2 + 423*s - 141) + 3*k1**2*k2**4*(2*C*(90*r**2 + 54*r*(3*s - 2) + 90*s**2 - 99*s + 31) - 135*r**2 - 3*r*(84*s - 55) - 135*s**2 + 156*s - 49) + k2**6*(18*C - 9)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 18*gd2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 396*fd*g2*(2*r + 2*s - 1)**2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)) + Dd*f*(-35*f**2*k1**4*(k1**2*(47*r + 47*s - 27) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 110*f*(k1**6*(4*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(C*(528*r**2 + r*(912*s - 706) + 528*s**2 - 616*s + 228) - 468*r**2 - 3*r*(288*s - 214) - 468*s**2 + 597*s - 216) + 3*k1**2*k2**4*(C*(240*r**2 + 432*r*s - 310*r + 240*s**2 - 280*s + 96) - 180*r**2 - 4*r*(84*s - 59) - 180*s**2 + 221*s - 75) + k2**6*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 396*g2*(2*k1**6 + 23*k1**4*k2**2 + 33*k1**2*k2**4 + 7*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(3465*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct**3*f*k1*k2**3*st**4*(D1*bd1*f*(r + s - 1)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18) + b1*(D1*fd*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18)) + 6*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(21*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**3*f*k1*k2**3*st**4*(-3564*C*D1*f*fd*k1**2*r**2 - 7128*C*D1*f*fd*k1**2*r*s + 4092*C*D1*f*fd*k1**2*r - 3564*C*D1*f*fd*k1**2*s**2 + 4092*C*D1*f*fd*k1**2*s - 1144*C*D1*f*fd*k1**2 - 7920*C*D1*f*fd*k2**2*r**2 - 23760*C*D1*f*fd*k2**2*r*s + 10560*C*D1*f*fd*k2**2*r - 7920*C*D1*f*fd*k2**2*s**2 + 14520*C*D1*f*fd*k2**2*s - 3960*C*D1*f*fd*k2**2 - 4752*C*Dd*f**2*k1**2*r**2 - 9504*C*Dd*f**2*k1**2*r*s + 5852*C*Dd*f**2*k1**2*r - 4752*C*Dd*f**2*k1**2*s**2 + 5852*C*Dd*f**2*k1**2*s - 1716*C*Dd*f**2*k1**2 - 10560*C*Dd*f**2*k2**2*r**2 - 31680*C*Dd*f**2*k2**2*r*s + 14520*C*Dd*f**2*k2**2*r - 10560*C*Dd*f**2*k2**2*s**2 + 21120*C*Dd*f**2*k2**2*s - 5280*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(6*K - 6)*(19*r + 19*s - 13) - 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(r + s - 1) - 13700*D1*f**2*fd*k1**2*r**2 - 27400*D1*f**2*fd*k1**2*r*s + 19615*D1*f**2*fd*k1**2*r - 13700*D1*f**2*fd*k1**2*s**2 + 19615*D1*f**2*fd*k1**2*s - 7005*D1*f**2*fd*k1**2 + 3564*D1*f*fd*k1**2*r**2 + 7128*D1*f*fd*k1**2*r*s - 4092*D1*f*fd*k1**2*r + 3564*D1*f*fd*k1**2*s**2 - 4092*D1*f*fd*k1**2*s + 1144*D1*f*fd*k1**2 + 5940*D1*f*fd*k2**2*r**2 + 15840*D1*f*fd*k2**2*r*s - 7590*D1*f*fd*k2**2*r + 5940*D1*f*fd*k2**2*s**2 - 9570*D1*f*fd*k2**2*s + 2640*D1*f*fd*k2**2 + 2508*D1*f*gd2*k1**2*r**2 + 5016*D1*f*gd2*k1**2*r*s - 4224*D1*f*gd2*k1**2*r + 2508*D1*f*gd2*k1**2*s**2 - 4224*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 7920*D1*f*gd2*k2**2*r**2 + 15840*D1*f*gd2*k2**2*r*s - 11880*D1*f*gd2*k2**2*r + 7920*D1*f*gd2*k2**2*s**2 - 11880*D1*f*gd2*k2**2*s + 3960*D1*f*gd2*k2**2 + 5016*D1*fd*g2*k1**2*r**2 + 10032*D1*fd*g2*k1**2*r*s - 5940*D1*fd*g2*k1**2*r + 5016*D1*fd*g2*k1**2*s**2 - 5940*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 + 15840*D1*fd*g2*k2**2*r**2 + 31680*D1*fd*g2*k2**2*r*s - 15840*D1*fd*g2*k2**2*r + 15840*D1*fd*g2*k2**2*s**2 - 15840*D1*fd*g2*k2**2*s + 3960*D1*fd*g2*k2**2 - 13700*Dd*f**3*k1**2*r**2 - 27400*Dd*f**3*k1**2*r*s + 19615*Dd*f**3*k1**2*r - 13700*Dd*f**3*k1**2*s**2 + 19615*Dd*f**3*k1**2*s - 7005*Dd*f**3*k1**2 + 4752*Dd*f**2*k1**2*r**2 + 9504*Dd*f**2*k1**2*r*s - 5852*Dd*f**2*k1**2*r + 4752*Dd*f**2*k1**2*s**2 - 5852*Dd*f**2*k1**2*s + 1716*Dd*f**2*k1**2 + 7920*Dd*f**2*k2**2*r**2 + 21120*Dd*f**2*k2**2*r*s - 10560*Dd*f**2*k2**2*r + 7920*Dd*f**2*k2**2*s**2 - 13860*Dd*f**2*k2**2*s + 3630*Dd*f**2*k2**2 + 10032*Dd*f*g2*k1**2*r**2 + 20064*Dd*f*g2*k1**2*r*s - 14388*Dd*f*g2*k1**2*r + 10032*Dd*f*g2*k1**2*s**2 - 14388*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 31680*Dd*f*g2*k2**2*r**2 + 63360*Dd*f*g2*k2**2*r*s - 39600*Dd*f*g2*k2**2*r + 31680*Dd*f*g2*k2**2*s**2 - 39600*Dd*f*g2*k2**2*s + 11880*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(6 - 6*K)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + 5*k2**2*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + (18 - 36*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(6 - 6*K)*(19*r + 19*s - 13) + 5*k2**2*(f*(33*r + 33*s - 19) + (18 - 36*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(1155*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(r + s - 1)*(5*D1*bd1*f**2*(r + s) + b1**2*(2*D1*fd*(13*f + 7)*(r + s - 1) + Dd*f*(13*f + 14)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(13*f + 14)*(2*r + 2*s - 1) + 10*D1*fd*(r + s - 1) + 5*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(3*b1**2*(D1*fd*(k1**2*(7*K - 7)*(r + s - 1)**2 + 3*k2**2*(28*K*(r + s - 1)**2 + f*(33*r + 33*s - 23) + 28*r + 28*s - 14)) + Dd*f*(k1**2*(7*K - 7)*(r + s - 1) + 6*k2**2*(14*K*(r + s - 1) + 5*f + 7))*(4*r + 4*s - 3)) + 3*b1*(7*D1*bd1*f*(k1**2*(K - 1)*(2*r + 2*s - 1) + 3*k2**2*(K*(8*r + 8*s - 4) + f + 2))*(r + s - 1) + D1*(f**2*fd*(k1**2*(252*r**2 + r*(504*s - 465) + 252*s**2 - 465*s + 211) - 15*k2**2*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6)) + f*(fd*k1**2*(4*C*(r + s - 1)**2 + 50*r**2 + r*(100*s - 109) + 50*s**2 - 109*s + 41) + 3*fd*k2**2*(4*C*(10*r**2 + 3*r*(16*s - 9) + 10*s**2 - 41*s + 17) - 2*K*(38*r**2 + 76*r*s - 45*r + 38*s**2 - 45*s + 13) - 76*r**2 - 208*r*s + 127*r - 76*s**2 + 155*s - 59) - 14*gd2*(k1**2 + 12*k2**2)*(r + s - 1)**2) - 14*fd*g2*(k1**2 + 12*k2**2)*(r + s - 1)**2) + Dd*f*(f**2*(k1**2*(84*r + 84*s - 86) - 15*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + f*(k1**2*(4*r + 4*s - 3)*(2*C*(r + s - 1) + 25*r + 25*s - 43) + 6*k2**2*(2*C*(20*r**2 + 6*r*(16*s - 7) + 20*s**2 - 77*s + 22) - K*(76*r**2 + 152*r*s - 109*r + 76*s**2 - 109*s + 39) - 76*r**2 - 208*r*s + 124*r - 76*s**2 + 159*s - 52)) - 14*g2*(k1**2 + 12*k2**2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + f*(3*D1*bd1*(f**2*(k1**2*(84*r + 84*s - 47) - 15*k2**2*(5*r + 5*s - 3))*(r + s - 1) + f*(k1**2*(r + s - 1)*(r*(2*C + 25) + s*(2*C + 25) - 45) - 3*k2**2*(-20*C*s**2 + 48*C*s + K*(38*r**2 + r*(76*s - 64) + 38*s**2 - 64*s + 26) + r**2*(38 - 20*C) + r*(-96*C*s + 20*C + 104*s - 53) + 38*s**2 - 67*s + 15)) - 14*g2*(k1**2 + 12*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*(f*(fd*(9*k1**2*(3*r + 3*s - 2)**2 + k2**2*(-2*C*(279*r**2 + 990*r*s - 399*r + 279*s**2 - 615*s + 166) + 117*r**2 + 666*r*s - 210*r + 117*s**2 - 426*s + 112)) + k2**2*(-9*bd2 + 18*gd2)*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13)) - 9*fd*k2**2*(b2 - 2*g2)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13)) + 2*Dd*f*(f*(9*k1**2*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k2**2*(-2*C*(372*r**2 + 1320*r*s - 539*r + 372*s**2 - 899*s + 213) + 156*r**2 + 888*r*s - 269*r + 156*s**2 - 629*s + 132)) + k2**2*(-9*b2 + 18*g2)*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39))))/(315*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(11*D1*bd1*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 3*f*(k1**4*(5*K - 5)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) + 3*k2**4*(-4*C*(5*r**2 + 24*r*s - 11*r + 5*s**2 - 11*s + 6) + 18*K*r**2 + 36*K*r*s - 20*K*r + 18*K*s**2 - 20*K*s + 2*K + b1*(26*r**2 + 4*r*(13*s - 8) + 26*s**2 - 32*s + 6) - 13*r**2 + 2*r*s + 16*r - 13*s**2 + 16*s - 3)) - 84*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(b1*k1**2*(K - 1) + 3*b1*k2**2*(2*K - 1) - g2*(k1**2 + 6*k2**2))) + 33*b1**2*k2**2*(D1*fd*(3*f*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) + (r + s)**2*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3))) + Dd*f*(3*f*k2**2*(13*r + 13*s - 3) + (r + s)*(-14*k1**2*(K - 1) - 14*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 11*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 3*f*(fd*(k1**4*(5*K - 5)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(10*r**2 + r*(48*s - 3) + 10*s**2 - 24*s - 1) - 2*K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) + 26*r**2 - 4*r*s - 47*r + 26*s**2 - 5*s + 17)) + 28*gd2*k2**2*(k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**2*(k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(33*r + 33*s - 61) - 45*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 3*f*(k1**4*(5*K - 5)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s + 3) - 3*K*(17*r + 17*s + 9) + 46*r + 46*s - 30) - 3*k2**4*(4*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 2*K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 52*r**2 - 8*r*s - 93*r + 52*s**2 - 23*s + 37)) + 84*g2*k2**2*(k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*(D1*(5*f**2*fd*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(fd*(k1**4*(3*C - 3)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 9*k1**2*k2**2*(C*(9*r**2 + r*(19 - 150*s) + 9*s**2 + 103*s - 26) - 18*r**2 + r*(48*s + 7) - 18*s**2 - 35*s + 8) + k2**4*(2*C*(45*r**2 + r*(21 - 342*s) + 45*s**2 + 237*s - 58) - 207*r**2 + 6*r*(3*s + 28) - 207*s**2 - 48*s + 4)) - 3*gd2*(5*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + 3*k1**2*k2**2*(17*r**2 + r*(34*s - 8) + 17*s**2 - 8*s - 9) + 6*k2**4*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1))) + 66*fd*g2*(5*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + 3*k1**2*k2**2*(34*r**2 + 68*r*s + r + 34*s**2 + s - 9) + 6*k2**4*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1))) + Dd*f*(5*f**2*k1**2*(k1**2*(193*r + 193*s - 219) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 22*f*(k1**4*(3*C - 3)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 9*k1**2*k2**2*(C*(12*r**2 - 200*r*s + 15*r + 12*s**2 + 155*s - 25) - 24*r**2 + 64*r*s + 16*r - 24*s**2 - 54*s + 5) + k2**4*(2*C*(60*r**2 - 456*r*s - r + 60*s**2 + 359*s - 51) - 276*r**2 + 24*r*s + 271*r - 276*s**2 - 89*s - 30)) + 66*g2*(5*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + 3*k1**2*k2**2*(68*r**2 + r*(136*s - 15) + 68*s**2 - 15*s - 27) + 6*k2**4*(36*r**2 + r*(72*s - 31) + 36*s**2 - 31*s + 3)))))/(3465*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**3*k1*(2*D1*bd1*f*(6*f*(2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + k2**2*(-r**2*(C - 4) + r*(26*C*s + C - 6*s - 4) + s*(-C*(s + 13) + 4*s + 3))) + k2**2*(7*b2 - 14*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*(-7*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(24*f + 14) + k2**2*(7*K + 63*f + 49))*(r + s - 1)) + Dd*f*(k1**2*(24*f + 28) + k2**2*(14*K + 63*f + 98))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(k1**2*(24*f + 28) + k2**2*(14*K + 63*f + 98))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*D1*(6*f*fd*(4*k1**2*(r + s - 1)**2 + k2**2*(-2*C*(r**2 + r*(5 - 26*s) + s**2 + 19*s - 6) + 8*r**2 - 3*r*(4*s + 3) + 8*s**2 + 5*s + 1)) + 7*f*k2**2*(bd2 - 2*gd2)*(r + s - 1)**2 + 7*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + 2*Dd*f*(6*f*(2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-C*(4*r**2 + r*(7 - 104*s) + 4*s**2 + 77*s - 11) + 16*r**2 - 3*r*(8*s + 7) + 16*s**2 + 14*s + 5)) + k2**2*(7*b2 - 14*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(105*d**2*k2*k3**2) + D1**3*Pk2*Pkdd3*ct**3*k1*(D1*bd1*f*(5*f**2*k1**2*(8*k1**2*(3*r + 3*s - 1) + 81*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 9*f*(4*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(60*C*s**2 + 52*C*s - 2*K*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) + b1*(12*r**2 + r*(24*s - 11) + 12*s**2 - 11*s - 1) + 2*r**2*(30*C + 19) - 4*r*(26*C*s + 15*C - 47*s + 26) + 38*s**2 - 160*s + 66) + k2**4*(4*C*(13*r**2 + r*(26*s - 19) + 13*s**2 - 5*s + 6) - 14*K*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3) + 7*b1*(r + s - 1) - 26*r**2 - 52*r*s + 38*r - 26*s**2 + 10*s - 12)) + 21*k2**2*(b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*b1*(k1**2*(r + s - 1)*(8*C*(2*r + 2*s - 1) + 9*K*(2*r + 2*s - 1) - 16*r - 16*s + 15) + k2**2*(4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) + K*(22*r**2 + 44*r*s - 31*r + 22*s**2 - 31*s + 9) - 12*r**2 + 16*r*s + 13*r - 12*s**2 + 3*s - 1)) + (r**2 + r*(2*s - 1) + s*(s - 1))*(4*b2*k2**2 - 36*g2*k1**2 - 44*g2*k2**2))) + 21*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(D1*fd*(k1**2*(112*C*(r + s - 1)**2 + 126*K*(r + s - 1)**2 + 3*f*(12*r**2 + 3*r*(8*s + 3) + 12*s**2 + 9*s - 11) - 112*r**2 - 224*r*s + 420*r - 112*s**2 + 420*s - 210) + 7*k2**2*(16*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 2*K*(11*r**2 + 22*r*s - 18*r + 11*s**2 - 18*s + 9) + 3*f*(7*r + 7*s - 5) - 12*r**2 + 16*r*s + 44*r - 12*s**2 + 4*s - 22)) + 2*Dd*f*(k1**2*(4*r + 4*s - 3)*(56*C*(r + s - 1) + 63*K*(r + s - 1) + f*(9*r + 9*s + 6) - 56*r - 56*s + 105) + 7*k2**2*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + 44*K*r**2 + 88*K*r*s - 69*K*r + 44*K*s**2 - 69*K*s + 27*K + 3*f*(4*r + 4*s - 3) - 24*r**2 + 32*r*s + 52*r - 24*s**2 + 2*s - 23))) + b1*(D1*(5*f**2*fd*k1**2*(4*k1**2*(18*r**2 + 6*r*(6*s - 5) + 18*s**2 - 30*s + 13) + 9*k2**2*(54*r**2 + r*(108*s - 91) + 54*s**2 - 91*s + 39)) + 6*f*(3*fd*(2*k1**4*(2*r + 2*s - 1)**2 + k1**2*k2**2*(4*C*(15*r**2 - 2*r*(13*s + 8) + 15*s**2 + 12*s + 1) - K*(18*r**2 + 36*r*s - 11*r + 18*s**2 - 11*s + 1) + 38*r**2 + 188*r*s - 35*r + 38*s**2 - 91*s + 9) + k2**4*(4*C*(13*r**2 + 2*r*(13*s - 7) + 13*s**2 - 21*s + 4) - 7*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 26*r**2 - 52*r*s + 49*r - 26*s**2 + 63*s - 22)) - 14*k2**2*(r + s - 1)*(-bd2*k2**2*(r + s) + 9*gd2*k1**2*(r + s - 1) + gd2*k2**2*(11*r + 11*s - 9))) + 84*fd*k2**2*(b2*k2**2*(r + s)**2 - g2*(9*k1**2*(r + s - 1)**2 + k2**2*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 9)))) + 2*Dd*f*(5*f**2*k1**2*(2*k1**2*(6*r + 6*s - 5) + 9*k2**2*(9*r + 9*s - 8))*(4*r + 4*s - 3) + 9*f*(2*k1**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(2*C*(60*r**2 - r*(104*s + 77) + 60*s**2 + 63*s + 17) - K*(36*r**2 + 72*r*s - 31*r + 36*s**2 - 31*s + 3) + 76*r**2 + 376*r*s - 113*r + 76*s**2 - 253*s + 49) + k2**4*(4*r + 4*s - 3)*(2*C*(13*r + 13*s - 7) - 7*K*(5*r + 5*s - 3) - 13*r - 13*s + 14)) - 42*k2**2*(4*r + 4*s - 3)*(-b2*k2**2*(r + s) + 9*g2*k1**2*(r + s - 1) + g2*k2**2*(11*r + 11*s - 9)))) + 2*f*(D1*(f*(5*fd*(3*r + 3*s - 2)*(k1**4*(6*r + 6*s - 4) + k1**2*k2**2*(-2*C*(15*r + 15*s - 7) + 51*r + 51*s - 34) + k2**4*(9 - 18*C)*(5*r + 5*s - 3)) + k2**2*(-9*bd2 + 18*gd2)*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(r + s - 1)) - 9*fd*k2**2*(b2 - 2*g2)*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(5*f*(k1**4*(6*r + 6*s - 4) + k1**2*k2**2*(-2*C*(15*r + 15*s - 7) + 51*r + 51*s - 34) + k2**4*(9 - 18*C)*(5*r + 5*s - 3)) + k2**2*(-9*b2 + 18*g2)*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)))/(315*d**2*k2*k3**4) + D1**3*Pk2*Pkdd3*ct**3*k1*(D1*(462*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) + 5*f**3*k1**2*(11*bd1*k2**2*(k1**2*(15*r + 15*s - 13) - 72*k2**2*(r + s - 1))*(r + s - 1) + 7*fd*k1**2*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 11*f**2*k2**2*(18*bd1*(k1**4*(r + s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) - k1**2*k2**2*(C*(-96*r**2 - 80*r*s + 88*r - 96*s**2 + 88*s + 8) - 65*K*r**2 - 130*K*r*s + 108*K*r - 65*K*s**2 + 108*K*s - 43*K + b1*(17*r**2 + r*(34*s - 36) + 17*s**2 - 36*s + 19) + 107*r**2 + 158*r*s - 136*r + 107*s**2 - 136*s + 29) + k2**4*(4*C*(8*r**2 + 2*r*s - 5*r + 8*s**2 - 5*s - 3) + 35*K*r**2 + 70*K*r*s - 56*K*r + 35*K*s**2 - 56*K*s + 21*K - 7*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 23*r**2 - 18*r*s + 17*r - 23*s**2 + 17*s + 6)) + 5*fd*(3*r + 3*s - 2)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) - 36*gd2*(k1**4*(15*r**2 + r*(30*s - 26) + 15*s**2 - 26*s + 11) + k1**2*k2**2*(65*r**2 + 2*r*(65*s - 54) + 65*s**2 - 108*s + 43) + 7*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 33*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(3*fd*(k1**4*(2*r + 2*s - 1)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(24*r**2 + 4*r*(5*s - 6) + 24*s**2 - 3*s + 6) + K*(130*r**2 + 260*r*s - 151*r + 130*s**2 - 151*s + 43) - 214*r**2 - 316*r*s + 221*r - 214*s**2 + 137*s - 57) + k2**4*(4*C*(16*r**2 + 4*r*(s - 4) + 16*s**2 + 5*s + 4) + 7*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 46*r**2 - 36*r*s + 39*r - 46*s**2 - 3*s - 8)) + (14*bd1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 112*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(56*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*fd*(k1**4*(30*r**2 + r*(60*s - 37) + 30*s**2 - 37*s + 11) + k1**2*k2**2*(130*r**2 + r*(260*s - 151) + 130*s**2 - 151*s + 43) + 7*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(462*b1*k2**2*(b1*(k1**4*(8*K - 8) + k1**2*k2**2*(24*K - 17) + k2**4*(8*K - 5)) - 16*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 35*f**3*k1**4*(4*k1**2*(4*r + 4*s - 3) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) + 55*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(C*(84*r + 84*s - 68) + b1*(15*r + 15*s - 13) - 72*r - 72*s + 60) - 2*k1**2*k2**2*(-2*C*(87*r + 87*s - 61) + 36*b1*(r + s - 1) + 123*r + 123*s - 88) + k2**4*(36*C - 18)*(5*r + 5*s - 3)) - 99*f*k2**2*(b1**2*k2**2*(k1**2*(17*r + 17*s - 19) + 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(4*r + 4*s - 3)*(16*C*(2*r + 2*s - 1) + K*(15*r + 15*s - 11) - 43*r - 43*s + 25) + k1**2*k2**2*(8*C*(48*r**2 + r*(40*s - 53) + 48*s**2 - 18*s + 11) + K*(260*r**2 + 520*r*s - 367*r + 260*s**2 - 367*s + 129) - 428*r**2 - 632*r*s + 521*r - 428*s**2 + 381*s - 143) + k2**4*(4*C*(32*r**2 + r*(8*s - 33) + 32*s**2 + 2*s + 5) + 7*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 92*r**2 - 72*r*s + 87*r - 92*s**2 + 17*s - 10)) + 4*g2*(k1**4*(60*r**2 + r*(120*s - 89) + 60*s**2 - 89*s + 33) + k1**2*k2**2*(260*r**2 + r*(520*s - 367) + 260*s**2 - 367*s + 129) + 7*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(3465*d**2*k2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**2*f*k1**2*k2**4*st**6*(198*C*D1*f*fd*r**2 + 396*C*D1*f*fd*r*s - 264*C*D1*f*fd*r + 198*C*D1*f*fd*s**2 - 264*C*D1*f*fd*s + 88*C*D1*f*fd + 264*C*Dd*f**2*r**2 + 528*C*Dd*f**2*r*s - 374*C*Dd*f**2*r + 264*C*Dd*f**2*s**2 - 374*C*Dd*f**2*s + 132*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1036*D1*f**2*fd*r**2 + 2072*D1*f**2*fd*r*s - 1477*D1*f**2*fd*r + 1036*D1*f**2*fd*s**2 - 1477*D1*f**2*fd*s + 525*D1*f**2*fd - 198*D1*f*fd*r**2 - 396*D1*f*fd*r*s + 264*D1*f*fd*r - 198*D1*f*fd*s**2 + 264*D1*f*fd*s - 88*D1*f*fd - 396*D1*f*gd2*r**2 - 792*D1*f*gd2*r*s + 594*D1*f*gd2*r - 396*D1*f*gd2*s**2 + 594*D1*f*gd2*s - 198*D1*f*gd2 - 792*D1*fd*g2*r**2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 792*D1*fd*g2*s**2 + 792*D1*fd*g2*s - 198*D1*fd*g2 + 1036*Dd*f**3*r**2 + 2072*Dd*f**3*r*s - 1477*Dd*f**3*r + 1036*Dd*f**3*s**2 - 1477*Dd*f**3*s + 525*Dd*f**3 - 264*Dd*f**2*r**2 - 528*Dd*f**2*r*s + 374*Dd*f**2*r - 264*Dd*f**2*s**2 + 374*Dd*f**2*s - 132*Dd*f**2 - 1584*Dd*f*g2*r**2 - 3168*Dd*f*g2*r*s + 1980*Dd*f*g2*r - 1584*Dd*f*g2*s**2 + 1980*Dd*f*g2*s - 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(693*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**2*k2**2*st**4*(-42*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1*(14*D1*bd1*f*k1**2*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(5*f**2*fd*k1**2*(45*r**2 + r*(90*s - 67) + 45*s**2 - 67*s + 26) + 2*f*(-15*K*fd*k2**2*(2*r + 2*s - 1)**2 + fd*k1**2*(8*C*(r + s - 1)**2 + 30*r**2 + r*(60*s - 29) + 30*s**2 - 29*s + 5) - 14*gd2*k1**2*(r + s - 1)**2) - 28*fd*g2*k1**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(-30*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(15*r + 15*s - 11) + 2*f*k1**2*(4*C*(r + s - 1) + 15*r + 15*s - 9) - 28*g2*k1**2*(r + s - 1))) - f*(3*D1*bd1*(r + s - 1)*(-30*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(15*r + 15*s - 7) + f*k1**2*(r*(8*C + 30) + s*(8*C + 30) - 26) - 28*g2*k1**2*(r + s)) + 2*D1*(f*fd*(k1**2*(81*r**2 + 3*r*(54*s - 31) + 81*s**2 - 93*s + 26) + k2**2*(15 - 30*C)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) - 45*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 45*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)**2) + 2*Dd*f*(f*(k1**2*(108*r**2 + r*(216*s - 133) + 108*s**2 - 133*s + 39) + k2**2*(15 - 30*C)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) + k2**2*(-45*b2 + 90*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(105*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**2*k2**2*st**4*(33*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + k1**2*k2**2*(r + s)*(-28*K*b1 + 28*b1 + 28*g2)) - 462*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(5*f**2*fd*k1**2*k2**2*(33*r**2 + r*(66*s - 43) + 33*s**2 - 43*s + 14) - 2*f*fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*f*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 28*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(11*r + 11*s - 7) - 2*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(C*(4*r + 4*s - 2) + K*(24*r + 24*s - 19) - 9*r - 9*s + 8)) + 28*g2*k1**2*k2**2*(r + s))) + f*(D1*(-15*f**2*fd*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(fd*(k1**4*(6*C - 6)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2) + k1**2*k2**2*(2*C*(144*r**2 + 54*r*(11*s - 4) + 144*s**2 - 369*s + 97) - 207*r**2 - 144*r*(5*s - 2) - 207*s**2 + 441*s - 117) + k2**4*(30*C - 15)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) - 6*gd2*(k1**4*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6) + k1**2*k2**2*(24*r**2 + r*(48*s - 43) + 24*s**2 - 43*s + 19) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 132*fd*g2*(k1**4*(10*r**2 + r*(20*s - 17) + 10*s**2 - 17*s + 6) + k1**2*k2**2*(48*r**2 + r*(96*s - 62) + 48*s**2 - 62*s + 19) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(-15*f**2*k1**2*(k1**2*(125*r + 125*s - 91) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 22*f*(k1**4*(6*C - 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(2*C*(192*r**2 + 792*r*s - 287*r + 192*s**2 - 542*s + 120) - 276*r**2 - 30*r*(32*s - 13) - 276*s**2 + 645*s - 150) + k2**4*(30*C - 15)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) + 132*g2*(k1**4*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18) + k1**2*k2**2*(96*r**2 + 4*r*(48*s - 37) + 96*s**2 - 148*s + 57) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1155*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(D1*bd1*f*(f*(k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - k2**2*(6*C - 3)*(5*r**2 + r*(24*s - 5) + s*(5*s - 12))) + k2**2*(-42*b2 + 84*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + b1**2*(D1*fd*(-42*K*k2**2 + k1**2*(18*f + 7))*(r + s - 1) + Dd*f*(-42*K*k2**2 + k1**2*(9*f + 7))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(-42*K*k2**2 + k1**2*(9*f + 7))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(2*fd*k1**2*(r + s - 1)**2 - fd*k2**2*(6*C - 3)*(10*r**2 + 3*r*(16*s - 9) + 10*s**2 - 41*s + 17) - k2**2*(42*bd2 - 84*gd2)*(r + s - 1)**2) - 42*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + Dd*f*(f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - k2**2*(6*C - 3)*(20*r**2 + 6*r*(16*s - 7) + 20*s**2 - 77*s + 22)) + k2**2*(-42*b2 + 84*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(105*d**2*k3**2) + D1**3*Pk2*Pkdd3*ct**2*(-2*D1*bd1*f*(7*b2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*f*(k1**2*(r**2*(8*C - 11) - r*(4*C*(3*s + 2) + 8*s - 11) + s*(C*(8*s + 6) - 11*s + 4)) + k2**2*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 14*g2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 21*b1**3*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 7*b1**2*(3*D1*bd1*f*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*D1*fd*(k1**2*(-2*K + 9*f + 9)*(r + s - 1)**2 - k2**2*(4*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 5*K*(r + s - 1)**2 - 2*r**2 + 6*r*s + 4*r - 2*s**2 - 6*s - 2)) + Dd*f*(k1**2*(-4*K + 9*f + 18)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*k2**2*(2*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + 5*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 8*r**2 + 24*r*s + 9*r - 8*s**2 - 16*s - 1))) + b1*(-96*C*D1*f*fd*k1**2*r**2 + 144*C*D1*f*fd*k1**2*r*s + 108*C*D1*f*fd*k1**2*r - 96*C*D1*f*fd*k1**2*s**2 - 60*C*D1*f*fd*k1**2*s - 12*C*D1*f*fd*k1**2 - 168*C*D1*f*fd*k2**2*r**2 - 336*C*D1*f*fd*k2**2*r*s + 336*C*D1*f*fd*k2**2*r - 168*C*D1*f*fd*k2**2*s**2 + 336*C*D1*f*fd*k2**2*s - 168*C*D1*f*fd*k2**2 - 192*C*Dd*f**2*k1**2*r**2 + 288*C*Dd*f**2*k1**2*r*s + 252*C*Dd*f**2*k1**2*r - 192*C*Dd*f**2*k1**2*s**2 - 168*C*Dd*f**2*k1**2*s - 60*C*Dd*f**2*k1**2 - 336*C*Dd*f**2*k2**2*r**2 - 672*C*Dd*f**2*k2**2*r*s + 588*C*Dd*f**2*k2**2*r - 336*C*Dd*f**2*k2**2*s**2 + 588*C*Dd*f**2*k2**2*s - 252*C*Dd*f**2*k2**2 + 7*D1*bd1*f*(k1**2*(-4*K + 9*f + 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*k2**2*(C*(8*r**2 - 2*r*(12*s + 1) + 8*s**2 + 8*s - 6) + 5*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 4*r**2 + 12*r*s + r - 4*s**2 - 4*s + 3)) - 14*D1*bd2*f*(2*k1**2 + 5*k2**2)*(r + s - 1)**2 + 132*D1*f*fd*k1**2*r**2 + 96*D1*f*fd*k1**2*r*s - 222*D1*f*fd*k1**2*r + 132*D1*f*fd*k1**2*s**2 - 138*D1*f*fd*k1**2*s + 90*D1*f*fd*k1**2 + 84*D1*f*fd*k2**2*r**2 + 168*D1*f*fd*k2**2*r*s - 168*D1*f*fd*k2**2*r + 84*D1*f*fd*k2**2*s**2 - 168*D1*f*fd*k2**2*s + 84*D1*f*fd*k2**2 + 56*D1*f*gd2*k1**2*r**2 + 112*D1*f*gd2*k1**2*r*s - 112*D1*f*gd2*k1**2*r + 56*D1*f*gd2*k1**2*s**2 - 112*D1*f*gd2*k1**2*s + 56*D1*f*gd2*k1**2 + 140*D1*f*gd2*k2**2*r**2 + 280*D1*f*gd2*k2**2*r*s - 280*D1*f*gd2*k2**2*r + 140*D1*f*gd2*k2**2*s**2 - 280*D1*f*gd2*k2**2*s + 140*D1*f*gd2*k2**2 + 56*D1*fd*g2*k1**2*r**2 + 112*D1*fd*g2*k1**2*r*s - 112*D1*fd*g2*k1**2*r + 56*D1*fd*g2*k1**2*s**2 - 112*D1*fd*g2*k1**2*s + 56*D1*fd*g2*k1**2 + 140*D1*fd*g2*k2**2*r**2 + 280*D1*fd*g2*k2**2*r*s - 280*D1*fd*g2*k2**2*r + 140*D1*fd*g2*k2**2*s**2 - 280*D1*fd*g2*k2**2*s + 140*D1*fd*g2*k2**2 + 264*Dd*f**2*k1**2*r**2 + 192*Dd*f**2*k1**2*r*s - 420*Dd*f**2*k1**2*r + 264*Dd*f**2*k1**2*s**2 - 210*Dd*f**2*k1**2*s + 156*Dd*f**2*k1**2 + 168*Dd*f**2*k2**2*r**2 + 336*Dd*f**2*k2**2*r*s - 294*Dd*f**2*k2**2*r + 168*Dd*f**2*k2**2*s**2 - 294*Dd*f**2*k2**2*s + 126*Dd*f**2*k2**2 + 224*Dd*f*g2*k1**2*r**2 + 448*Dd*f*g2*k1**2*r*s - 392*Dd*f*g2*k1**2*r + 224*Dd*f*g2*k1**2*s**2 - 392*Dd*f*g2*k1**2*s + 168*Dd*f*g2*k1**2 + 560*Dd*f*g2*k2**2*r**2 + 1120*Dd*f*g2*k2**2*r*s - 980*Dd*f*g2*k2**2*r + 560*Dd*f*g2*k2**2*s**2 - 980*Dd*f*g2*k2**2*s + 420*Dd*f*g2*k2**2 - 14*b2*(2*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1)))/(105*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(b1**2*(D1*fd*(-42*K*k2**4*(2*r + 2*s - 1) + k1**4*(7*K - 7)*(r + s - 1)**2 + k1**2*k2**2*(14*C*(r + s - 1)**2 - 21*K*(r + s - 1)**2 + 3*f*(20*r**2 + r*(40*s - 7) + 20*s**2 - 7*s - 3) + 28*r**2 + 56*r*s - 28*r + 28*s**2 - 28*s + 14)) + Dd*f*(4*r + 4*s - 3)*(-42*K*k2**4 + k1**4*(7*K - 7)*(r + s - 1) + k1**2*k2**2*(14*C*(r + s - 1) - 21*K*(r + s - 1) + 30*f*r + 30*f*s + 28*r + 28*s - 14))) + b1*(D1*bd1*f*(r + s - 1)*(-42*K*k2**4 + k1**4*(7*K - 7)*(2*r + 2*s - 1) + k1**2*k2**2*(14*C*(2*r + 2*s - 1) - 7*K*(6*r + 6*s - 3) + f*(60*r + 60*s - 9) + 56*r + 56*s - 14)) - D1*(f**2*fd*k1**2*(2*k1**2*(9*r**2 + 6*r*(3*s + 1) + 9*s**2 + 6*s - 8) + 9*k2**2*(51*r**2 + r*(102*s - 77) + 51*s**2 - 77*s + 30)) + f*(fd*(k1**4*(4*C*(r + s - 1)**2 + 6*r**2 + 3*r*(4*s + 11) + 6*s**2 + 33*s - 19) + k1**2*k2**2*(2*C*(10*r**2 + r*(57 - 288*s) + 10*s**2 + 211*s - 67) + 9*K*(6*r**2 + 12*r*s - 13*r + 6*s**2 - 13*s + 5) + 156*r**2 + 620*r*s - 260*r + 156*s**2 - 414*s + 124) - 3*k2**4*(C*(-48*r - 34*s + 36) + 14*K*(2*r + 2*s - 1)**2 + 24*r + 17*s - 18)) + (3*bd2*k2**4*(r + s) + gd2*(k1**4*(r + s - 1) - 3*k1**2*k2**2*(r + s - 1) - 6*k2**4))*(14*r + 14*s - 14)) + 14*fd*(3*b2*k2**4*(r + s)**2 + g2*(k1**4*(r + s - 1)**2 - 3*k1**2*k2**2*(r + s - 1)**2 - 6*k2**4*(2*r + 2*s - 1)))) - Dd*f*(f**2*k1**2*(k1**2*(6*r + 6*s + 8) + 9*k2**2*(17*r + 17*s - 13))*(4*r + 4*s - 3) + f*(k1**4*(4*r + 4*s - 3)*(2*C*(r + s - 1) + 3*r + 3*s + 17) + k1**2*k2**2*(2*C*(20*r**2 - 6*r*(96*s - 7) + 20*s**2 + 427*s - 62) + 9*K*(12*r**2 + 24*r*s - 29*r + 12*s**2 - 29*s + 15) + 312*r**2 + 1240*r*s - 543*r + 312*s**2 - 928*s + 251) - 6*k2**4*(-6*C + 7*K*(2*r + 2*s - 1) + 3)*(4*r + 4*s - 3)) + (3*b2*k2**4*(r + s) + g2*(k1**4*(r + s - 1) - 3*k1**2*k2**2*(r + s - 1) - 6*k2**4))*(56*r + 56*s - 42))) - f*(D1*bd1*(f**2*k1**2*(k1**2*(6*r + 6*s + 8) + 9*k2**2*(17*r + 17*s - 9))*(r + s - 1) + f*(k1**4*(r + s - 1)*(r*(2*C + 3) + s*(2*C + 3) + 15) + k1**2*k2**2*(10*C*s**2 + 144*C*s + 9*K*(3*r**2 + r*(6*s - 8) + 3*s**2 - 8*s + 5) + r**2*(10*C + 78) - r*(288*C*s + 10*C - 310*s + 147) + 78*s**2 - 224*s + 69) - 3*k2**4*(2*C*(6*r - s - 6) + 14*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 6*r + s + 6)) + (42*b2*k2**4 + 14*g2*(k1**4 - 3*k1**2*k2**2))*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*(f*(fd*(k1**4*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 3*k1**2*k2**2*(4*C*(9*r**2 + 3*r*(12*s - 5) + 9*s**2 - 24*s + 7) + 27*r**2 + 9*r*(2*s - 3) + 27*s**2 - 9*s + 4) - k2**4*(36*C - 18)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + k2**2*(3*bd2 - 6*gd2)*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 3*fd*k2**2*(b2 - 2*g2)*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + Dd*f*(f*(k1**4*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 3*k1**2*k2**2*(4*C*(12*r**2 + 4*r*(12*s - 5) + 12*s**2 - 35*s + 9) + 36*r**2 + r*(24*s - 41) + 36*s**2 - 11*s + 9) + k2**4*(18 - 36*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + k2**2*(3*b2 - 6*g2)*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3))))/(105*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**2*(-147*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*(D1*(-49*bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(56*C*(r + s - 1)**2 + 3*f*(68*r**2 + r*(136*s - 79) + 68*s**2 - 79*s + 27) + 56*r**2 + 112*r*(s + 1) + 56*s**2 + 112*s - 56) + 7*k1**2*k2**2*(8*C*(4*r**2 - r*(17*s + 8) + 4*s**2 + 17*s + 4) + 2*K*(5*r**2 + 10*r*s - 24*r + 5*s**2 - 24*s + 12) + 3*f*(8*r**2 + r*(16*s - 1) + 8*s**2 - s - 3) - 14*r**2 + 72*r*s + 68*r - 14*s**2 - 32*s - 34) + 14*k2**4*(4*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) - 5*K*(2*r + 2*s - 1) - 2*r**2 + 6*r*s + 4*r - 2*s**2 - 6*s - 2))) + 2*Dd*f*(k1**4*(4*r + 4*s - 3)*(28*C*(r + s - 1) + 3*f*(17*r + 17*s - 9) + 28*r + 28*s + 28) + 7*k1**2*k2**2*(2*C*(32*r**2 - r*(136*s + 31) + 32*s**2 + 94*s - 1) + K*(20*r**2 + 40*r*s - 63*r + 20*s**2 - 63*s + 36) + 24*f*r**2 + 48*f*r*s - 18*f*r + 24*f*s**2 - 18*f*s - 28*r**2 + 144*r*s + 64*r - 28*s**2 - 61*s - 26) + 7*k2**4*(2*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 5*K*(4*r + 4*s - 3) - 8*r**2 + 24*r*s + 9*r - 8*s**2 - 16*s - 1))) + 3*b1*(D1*bd1*f*(k1**4*(r + s - 1)*(56*C*(2*r + 2*s - 1) + 3*f*(68*r + 68*s - 27) + 112*r + 112*s + 56) + 7*k1**2*k2**2*(4*C*(16*r**2 - 68*r*s + r + 16*s**2 + 26*s - 17) + 4*K*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 11*s + 6) + 3*f*(8*r**2 + r*(16*s - 11) + 8*s**2 - 11*s + 3) - 28*r**2 + 144*r*s + 12*r - 28*s**2 - 38*s + 16) + 14*k2**4*(C*(8*r**2 - 2*r*(12*s + 1) + 8*s**2 + 8*s - 6) - 5*K*(r + s - 1) - 4*r**2 + 12*r*s + r - 4*s**2 - 4*s + 3)) + D1*(45*f**2*fd*k1**4*(6*r**2 + r*(12*s - 11) + 6*s**2 - 11*s + 5) - 2*f*(3*fd*(2*k1**4*(7*C*(r*(4*s - 1) - 3*s + 1) + K*(2*r + 2*s - 1)**2 - 23*r**2 - 60*r*s + 30*r - 23*s**2 + 37*s - 11) - k1**2*k2**2*(C*(4*r**2 + 8*r*(s - 6) + 4*s**2 - 62*s + 34) - 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 12*r**2 + 24*r*s + 38*r + 12*s**2 + 45*s - 31) + k2**4*(14*C - 7)*(3*r + 3*s - 2)) + 7*k2**2*(bd2*(7*k1**2 + 5*k2**2)*(r + s) + 2*gd2*(k1**2*(5*r + 5*s - 12) - 5*k2**2))*(r + s - 1)) - 14*fd*k2**2*(b2*(7*k1**2 + 5*k2**2)*(r + s)**2 + 2*g2*(k1**2*(5*r**2 + 10*r*s - 24*r + 5*s**2 - 24*s + 12) - 5*k2**2*(2*r + 2*s - 1)))) + 2*Dd*f*(45*f**2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 3*f*(k1**4*(14*C*(r*(8*s - 1) - 6*s + 1) + 2*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 92*r**2 - 240*r*s + 136*r - 92*s**2 + 171*s - 52) - k1**2*k2**2*(4*r + 4*s - 3)*(2*C*(r + s - 6) - 7*K*(4*r + 4*s - 3) + 6*r + 6*s + 13) + k2**4*(14*C - 7)*(4*r + 4*s - 3)) - 7*k2**2*(b2*(7*k1**2 + 5*k2**2)*(r + s) + 2*g2*(k1**2*(5*r + 5*s - 12) - 5*k2**2))*(4*r + 4*s - 3))) + f*(3*D1*bd1*(45*f**2*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 6*f*k1**4*(-14*C*s + K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - 23*r**2 + r*(28*C*s - 60*s + 38) - 23*s**2 + 45*s - 15) + 6*f*k1**2*k2**2*(2*C*(r**2 + 2*r*(s + 2) + s**2 + 11*s - 5) - 7*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 6*r**2 + 12*r*s - 11*r + 6*s**2 - 18*s + 5) - 14*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(7*b2*k1**2 + 5*b2*k2**2 + 10*g2*k1**2)) - 2*k1**2*(180*C*D1*f*fd*k1**2*r**2 + 360*C*D1*f*fd*k1**2*r*s - 240*C*D1*f*fd*k1**2*r + 180*C*D1*f*fd*k1**2*s**2 - 240*C*D1*f*fd*k1**2*s + 80*C*D1*f*fd*k1**2 + 1080*C*D1*f*fd*k2**2*r**2 + 2160*C*D1*f*fd*k2**2*r*s - 1530*C*D1*f*fd*k2**2*r + 1080*C*D1*f*fd*k2**2*s**2 - 1530*C*D1*f*fd*k2**2*s + 540*C*D1*f*fd*k2**2 + 240*C*Dd*f**2*k1**2*r**2 + 480*C*Dd*f**2*k1**2*r*s - 340*C*Dd*f**2*k1**2*r + 240*C*Dd*f**2*k1**2*s**2 - 340*C*Dd*f**2*k1**2*s + 120*C*Dd*f**2*k1**2 + 1440*C*Dd*f**2*k2**2*r**2 + 2880*C*Dd*f**2*k2**2*r*s - 2160*C*Dd*f**2*k2**2*r + 1440*C*Dd*f**2*k2**2*s**2 - 2160*C*Dd*f**2*k2**2*s + 810*C*Dd*f**2*k2**2 + 9*D1*bd2*f*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) - 225*D1*f*fd*k1**2*r**2 - 450*D1*f*fd*k1**2*r*s + 345*D1*f*fd*k1**2*r - 225*D1*f*fd*k1**2*s**2 + 345*D1*f*fd*k1**2*s - 130*D1*f*fd*k1**2 - 540*D1*f*fd*k2**2*r**2 - 1080*D1*f*fd*k2**2*r*s + 765*D1*f*fd*k2**2*r - 540*D1*f*fd*k2**2*s**2 + 765*D1*f*fd*k2**2*s - 270*D1*f*fd*k2**2 - 72*D1*f*gd2*k1**2*r**2 - 144*D1*f*gd2*k1**2*r*s + 108*D1*f*gd2*k1**2*r - 72*D1*f*gd2*k1**2*s**2 + 108*D1*f*gd2*k1**2*s - 36*D1*f*gd2*k1**2 - 504*D1*f*gd2*k2**2*r**2 - 1008*D1*f*gd2*k2**2*r*s + 882*D1*f*gd2*k2**2*r - 504*D1*f*gd2*k2**2*s**2 + 882*D1*f*gd2*k2**2*s - 378*D1*f*gd2*k2**2 - 144*D1*fd*g2*k1**2*r**2 - 288*D1*fd*g2*k1**2*r*s + 144*D1*fd*g2*k1**2*r - 144*D1*fd*g2*k1**2*s**2 + 144*D1*fd*g2*k1**2*s - 36*D1*fd*g2*k1**2 - 1008*D1*fd*g2*k2**2*r**2 - 2016*D1*fd*g2*k2**2*r*s + 1260*D1*fd*g2*k2**2*r - 1008*D1*fd*g2*k2**2*s**2 + 1260*D1*fd*g2*k2**2*s - 378*D1*fd*g2*k2**2 - 300*Dd*f**2*k1**2*r**2 - 600*Dd*f**2*k1**2*r*s + 485*Dd*f**2*k1**2*r - 300*Dd*f**2*k1**2*s**2 + 485*Dd*f**2*k1**2*s - 195*Dd*f**2*k1**2 - 720*Dd*f**2*k2**2*r**2 - 1440*Dd*f**2*k2**2*r*s + 1080*Dd*f**2*k2**2*r - 720*Dd*f**2*k2**2*s**2 + 1080*Dd*f**2*k2**2*s - 405*Dd*f**2*k2**2 - 288*Dd*f*g2*k1**2*r**2 - 576*Dd*f*g2*k1**2*r*s + 360*Dd*f*g2*k1**2*r - 288*Dd*f*g2*k1**2*s**2 + 360*Dd*f*g2*k1**2*s - 108*Dd*f*g2*k1**2 - 2016*Dd*f*g2*k2**2*r**2 - 4032*Dd*f*g2*k2**2*r*s + 3024*Dd*f*g2*k2**2*r - 2016*Dd*f*g2*k2**2*s**2 + 3024*Dd*f*g2*k2**2*s - 1134*Dd*f*g2*k2**2 + 9*b2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(315*d**2*k3**4) - 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(33*D1*bd1*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - f*(k1**6*(K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(25*r**2 + 204*r*s - 90*r + 25*s**2 - 90*s + 65) + 183*K*r**2 + 366*K*r*s - 264*K*r + 183*K*s**2 - 264*K*s + 81*K + 12*b1*(9*r**2 + 2*r*(9*s - 5) + 9*s**2 - 10*s + 1) - 71*r**2 + 12*r*s + 75*r - 71*s**2 + 75*s - 4) - 3*k2**6*(2*C*(5*r**2 + r*(24*s - 11) + 5*s**2 - 11*s + 6) - 14*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 5*r**2 - 24*r*s + 11*r - 5*s**2 + 11*s - 6)) + 14*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) - k1**2*k2**2*(K - 3)) - g2*(k1**4 - k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(-6*f*k1**2*k2**2*(18*r**2 + r*(36*s - 11) + 18*s**2 - 11*s + 1) + (r + s)**2*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3))) + Dd*f*(-6*f*k1**2*k2**2*(9*r + 9*s - 1) + (r + s)*(42*K*k2**4 + 7*k1**4*(K - 1) - 7*k1**2*k2**2*(K - 3)))*(4*r + 4*s - 3)) + 33*b1*(D1*(9*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) - k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(-2*C*(50*r**2 + r*(408*s - 1) + 50*s**2 - 232*s - 12) + K*(366*r**2 + 732*r*s - 345*r + 366*s**2 - 345*s + 81) - 142*r**2 + 24*r*s + 233*r - 142*s**2 + 2*s - 81) - 3*k2**6*(C*(20*r**2 + r*(96*s - 6) + 20*s**2 - 48*s - 2) - 14*K*(2*r + 2*s - 1)**2 - 10*r**2 - 48*r*s + 3*r - 10*s**2 + 24*s + 1)) + 14*gd2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 14*fd*g2*k2**2*(r + s)**2*(k1**4 - k1**2*k2**2 + 6*k2**4)) + Dd*f*(9*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(-k1**6*(K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s + 3) - K*(38*r + 38*s + 9) + 17*r + 17*s - 12) + k1**2*k2**4*(2*C*(100*r**2 + 8*r*(102*s - 13) + 100*s**2 - 489*s + 41) - 3*K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 284*r**2 - 48*r*s - 460*r + 284*s**2 - 75*s + 166) + 3*k2**6*(2*C*(20*r**2 + 6*r*(16*s - 3) + 20*s**2 - 53*s + 4) - 14*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 20*r**2 - 96*r*s + 18*r - 20*s**2 + 53*s - 4)) - 14*g2*k2**2*(k1**4 - k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-15*f**2*fd*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(fd*(k1**6*(2*C - 2)*(9*r**2 + 3*r*(6*s - 1) + 9*s**2 - 3*s - 2) + 3*k1**4*k2**2*(2*C*(54*r**2 - 39*r + 54*s**2 + 15*s - 4) - 99*r**2 - 3*r*(30*s - 31) - 99*s**2 + 39*s - 12) + 9*k1**2*k2**4*(4*C*(36*r**2 + 6*r*(9*s - 7) + 36*s**2 - 33*s + 11) - 117*r**2 - 3*r*(66*s - 47) - 117*s**2 + 123*s - 40) + k2**6*(108*C - 54)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 6*gd2*(k1**6*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**4*k2**2*(38*r**2 + r*(76*s - 29) + 38*s**2 - 29*s - 9) + 3*k1**2*k2**4*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 42*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 66*fd*g2*(k1**6*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**4*k2**2*(76*r**2 + 4*r*(38*s - 5) + 76*s**2 - 20*s - 9) + 3*k1**2*k2**4*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 42*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-15*f**2*k1**4*(k1**2*(17*r + 17*s + 1) + 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 11*f*(k1**6*(2*C - 2)*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + 3*k1**4*k2**2*(2*C*(72*r**2 - 64*r + 72*s**2 + 26*s + 3) - 132*r**2 - 3*r*(40*s - 47) - 132*s**2 + 51*s - 27) + 9*k1**2*k2**4*(4*C*(48*r**2 + r*(72*s - 61) + 48*s**2 - 46*s + 18) - 156*r**2 + r*(203 - 264*s) - 156*s**2 + 173*s - 63) + k2**6*(108*C - 54)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 66*g2*(k1**6*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**4*k2**2*(152*r**2 + r*(304*s - 78) + 152*s**2 - 78*s - 27) + 3*k1**2*k2**4*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 42*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3465*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**2*(D1*bd1*f*(5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(r + s - 1) + 18*f*(k1**6*(4*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*C*(39*r**2 + 64*r*s - 48*r + 39*s**2 - 48*s + 9) + 18*K*r**2 + 36*K*r*s - 34*K*r + 18*K*s**2 - 34*K*s + 16*K - b1*(59*r**2 + 2*r*(59*s - 46) + 59*s**2 - 92*s + 33) - 69*r**2 - 124*r*s + 93*r - 69*s**2 + 93*s - 24) + k1**2*k2**4*(2*C*(45*r**2 + 76*r*s - 50*r + 45*s**2 - 50*s + 5) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 59*r**2 - 104*r*s + 64*r - 59*s**2 + 64*s - 5) + k2**6*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (84*b1*(5*K*k2**6 + k1**6*(2*K - 2) + k1**4*k2**2*(21*K - 13) + k1**2*k2**4*(27*K - 10)) - 84*g2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) - 3*b1**2*(D1*fd*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10))) + Dd*f*(3*f*k1**2*k2**2*(k1**2*(59*r + 59*s - 33) + 21*k2**2*(3*r + 3*s - 1)) + (r + s)*(-70*K*k2**6 - 14*k1**6*(2*K - 2) - 14*k1**4*k2**2*(21*K - 13) - 14*k1**2*k2**4*(27*K - 10)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*(3*fd*(k1**6*(4*C - 4)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(2*C*(78*r**2 + r*(128*s - 71) + 78*s**2 - 50*s + 16) + 2*K*(18*r**2 + 36*r*s - 25*r + 18*s**2 - 25*s + 8) - 138*r**2 - 248*r*s + 131*r - 138*s**2 + 110*s - 31) + k1**2*k2**4*(2*C*(90*r**2 + 152*r*s - 69*r + 90*s**2 - 48*s + 12) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 118*r**2 - 208*r*s + 83*r - 118*s**2 + 62*s - 12) + k2**6*(14*C - 7)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 14*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6)) - 84*fd*g2*(r + s)**2*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6)) + Dd*f*(5*f**2*k1**4*(k1**2*(39*r + 39*s - 23) + 36*k2**2*(r + s))*(4*r + 4*s - 3) + 18*f*(k1**6*(4*C - 4)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(C*(312*r**2 + 4*r*(128*s - 87) + 312*s**2 - 278*s + 82) + 2*K*(36*r**2 + 72*r*s - 59*r + 36*s**2 - 59*s + 24) - 276*r**2 - 496*r*s + 324*r - 276*s**2 + 289*s - 86) + k1**2*k2**4*(C*(360*r**2 + 32*r*(19*s - 11) + 360*s**2 - 282*s + 58) + 7*K*(4*r + 4*s - 3)**2 - 236*r**2 - 416*r*s + 218*r - 236*s**2 + 183*s - 29) + k2**6*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 84*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(2*k1**6 + 21*k1**4*k2**2 + 27*k1**2*k2**4 + 5*k2**6))) + f*k1**2*(D1*(105*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(5*fd*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 36*fd*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(105*f**2*k1**4*(r + s - 1) + 10*f*k2**2*(k1**2*(C*(48*r + 48*s - 44) - 33*r - 33*s + 31) + k2**2*(18*C - 9)*(4*r + 4*s - 3)) - 36*g2*k2**2*(2*k1**2*(9*r + 9*s - 8) + 7*k2**2*(4*r + 4*s - 3)))))/(315*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct*f*k1*k2**3*st**6*(D1*bd1*f*(r + s - 1)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18) + b1*(D1*fd*(f*(99*r**2 + 3*r*(66*s - 41) + 99*s**2 - 123*s + 38) + 18*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(33*r + 33*s - 19) + 36*r + 36*s - 18)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(63*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct*f*k1*k2**3*st**6*(D1*(f**2*(11*bd1*k2**2*(33*r**2 + r*(66*s - 52) + 33*s**2 - 52*s + 19) - fd*k1**2*(1996*r**2 + r*(3992*s - 2829) + 1996*s**2 - 2829*s + 999)) - 11*f*k2**2*(18*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 72*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 198*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) - Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(499*r + 499*s - 333) - 11*f*k2**2*(b1*(33*r + 33*s - 19) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(396*K*b1 - 198*b1 - 792*g2)))/(693*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct*k1*k2*st**4*(r + s - 1)*(4*D1*bd1*f**2*(r + s) + b1**2*(2*D1*fd*(13*f + 7)*(r + s - 1) + Dd*f*(13*f + 14)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(13*f + 14)*(2*r + 2*s - 1) + 8*D1*fd*(r + s - 1) + 4*Dd*f*(4*r + 4*s - 3)))/(35*d**2*k3**2) - D1**3*Pk2*Pkdd3*ct*k1*k2*st**4*(3*D1*bd1*f*(r + s - 1)*(f**2*(13*k1**2*(2*r + 2*s - 1) - 5*k2**2*(5*r + 5*s - 3)) + f*(2*k1**2*(5*r + 5*s - 6) + k2**2*(16*C*r + 16*C*s + K*(-38*r - 38*s + 26) + 7*b1 - 36*r - 36*s + 12)) + 14*k2**2*(K*b1*(4*r + 4*s - 2) + b1 - 4*g2*(r + s))) + 3*b1**2*k2**2*(D1*fd*(28*K*(r + s - 1)**2 + f*(33*r + 33*s - 23) + 28*r + 28*s - 14) + 2*Dd*f*(4*r + 4*s - 3)*(14*K*(r + s - 1) + 5*f + 7)) + 3*b1*(D1*(f**2*fd*(k1**2*(78*r**2 + 3*r*(52*s - 45) + 78*s**2 - 135*s + 59) - 5*k2**2*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6)) + 2*f*(fd*k1**2*(10*r**2 + r*(20*s - 17) + 10*s**2 - 17*s + 6) + fd*k2**2*(16*C*(r + s - 1)**2 - K*(38*r**2 + 76*r*s - 45*r + 38*s**2 - 45*s + 13) - 36*r**2 - 72*r*s + 48*r - 36*s**2 + 48*s - 18) - 28*gd2*k2**2*(r + s - 1)**2) - 56*fd*g2*k2**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*(k1**2*(26*r + 26*s - 24) - 5*k2**2*(5*r + 5*s - 3)) + 2*f*(k1**2*(5*r + 5*s - 6) + k2**2*(8*C*(r + s - 1) + K*(-19*r - 19*s + 13) - 18*r - 18*s + 12)) - 56*g2*k2**2*(r + s - 1))) + 2*f*(D1*(f*(fd*(3*k1**2*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2) + k2**2*(-2*C*(81*r**2 + 3*r*(90*s - 37) + 81*s**2 - 165*s + 44) + 63*r**2 + 234*r*s - 90*r + 63*s**2 - 144*s + 38)) + k2**2*(-3*bd2 + 6*gd2)*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13)) - 3*fd*k2**2*(b2 - 2*g2)*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13)) + Dd*f*(f*(3*k1**2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k2**2*(-2*C*(108*r**2 + 360*r*s - 151*r + 108*s**2 - 241*s + 57) + 84*r**2 + 312*r*s - 121*r + 84*s**2 - 211*s + 48)) + k2**2*(-3*b2 + 6*g2)*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39))))/(105*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct*k1*k2*st**4*(D1*(-462*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*(11*bd1*k2**2*(4*k1**2*(6*r + 6*s - 7) - 15*k2**2*(5*r + 5*s - 3))*(r + s - 1) - fd*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 11*f**2*k2**2*(-6*bd1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + b1*(-13*r - 13*s + 3) + 8*r + 8*s - 4))*(r + s - 1) + fd*(2*k1**2*(-12*C*(6*r**2 + 36*r*s - 11*r + 6*s**2 - 23*s + 6) + b1*(36*r**2 + r*(72*s - 66) + 36*s**2 - 66*s + 28) + 54*r**2 + 252*r*s - 87*r + 54*s**2 - 159*s + 42) - k2**2*(4*C*(45*r**2 + 3*r*(66*s - 23) + 45*s**2 - 123*s + 32) + 15*b1*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6) - 54*r**2 - 324*r*s + 96*r - 54*s**2 + 204*s - 52)) + 12*gd2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(r + s - 1)) + 33*f*k2**2*(b1**2*fd*k2**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4))*(2*r + 2*s - 1) + 28*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-2*K*bd1 + bd1 + 2*gd2) + 4*g2*(14*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1))*(2*r + 2*s - 1)))) + Dd*f*(-462*b1*k2**4*(b1*(2*K - 1) - 4*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - f**3*k1**2*(19*k1**2*(19*r + 19*s - 17) - 165*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 11*f**2*k2**2*(2*k1**2*(-12*C*(8*r**2 + 48*r*s - 14*r + 8*s**2 - 34*s + 7) + b1*(48*r**2 + r*(96*s - 92) + 48*s**2 - 92*s + 42) + 72*r**2 + 336*r*s - 114*r + 72*s**2 - 234*s + 51) - k2**2*(4*C*(60*r**2 + r*(264*s - 91) + 60*s**2 - 181*s + 39) + 15*b1*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 72*r**2 - 432*r*s + 122*r - 72*s**2 + 302*s - 60)) + 33*f*k2**2*(4*r + 4*s - 3)*(b1**2*k2**2*(13*r + 13*s - 3) - 2*b1*(k1**2*(2*K - 1)*(5*r + 5*s - 6) + k2**2*(C*(8*r + 8*s - 4) - 9*K*r - 9*K*s + K + 8*r + 8*s - 4)) + 4*g2*(2*k1**2*(5*r + 5*s - 6) + k2**2*(-9*r - 9*s + 1)))))/(1155*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct*k1*st**2*(2*D1*bd1*f*(f*(k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*k2**2*(r**2*(C + 3) + r*(C*(58*s - 1) - 22*s - 3) + s*(C*(s - 29) + 3*s + 11))) + k2**2*(7*b2 - 14*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*(-7*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(6*f - 7) + k2**2*(7*K + 63*f + 28))*(r + s - 1)) + Dd*f*(k1**2*(6*f - 14) + k2**2*(14*K + 63*f + 56))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(k1**2*(6*f - 14) + k2**2*(14*K + 63*f + 56))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*D1*(f*(2*fd*k1**2*(r + s - 1)**2 + 4*fd*k2**2*(C*(r**2 + 2*r*(29*s - 8) + s**2 - 44*s + 15) + 3*r**2 - 22*r*s + r + 3*s**2 + 15*s - 4) + k2**2*(7*bd2 - 14*gd2)*(r + s - 1)**2) + 7*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + 2*Dd*f*(f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k2**2*(C*(4*r**2 + 232*r*s - 35*r + 4*s**2 - 175*s + 31) + 12*r**2 - 88*r*s - 7*r + 12*s**2 + 63*s - 5)) + k2**2*(7*b2 - 14*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(105*d**2*k2*k3**2) + D1**3*Pk2*Pkdd3*ct*k1*(-2*D1*bd1*f*k2**2*(5*b2 + f*(6*C - 3) - 10*g2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1**3*(4*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*bd1*f*(4*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*D1*fd*(2*k1**2*(r + s - 1)**2 - k2**2*(8*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 5*K*(r + s - 1)**2 - 4*r**2 + 12*r*s + 8*r - 4*s**2 - 12*s - 4)) + 2*Dd*f*(2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - k2**2*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + 5*K*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 16*r**2 + 6*r*(8*s + 3) - 16*s**2 - 32*s - 2))) + 2*b1*(D1*bd1*f*(k1**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - k2**2*(4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) + 5*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 8*r**2 + 24*r*s + 2*r - 8*s**2 - 8*s + 6)) - k2**2*(r + s - 1)*(12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 5*D1*bd2*f*(r + s - 1) - 6*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd - 10*D1*f*gd2*r - 10*D1*f*gd2*s + 10*D1*f*gd2 - 10*D1*fd*g2*r - 10*D1*fd*g2*s + 10*D1*fd*g2 - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 40*Dd*f*g2*r - 40*Dd*f*g2*s + 30*Dd*f*g2 + 5*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(15*d**2*k2*k3**2) + D1**3*Pk2*Pkdd3*ct*k1*st**2*(3*D1*bd1*f*(f**2*k1**2*(2*k1**2*(6*r + 6*s + 1) + 81*k2**2*(2*r + 2*s - 1))*(r + s - 1) + f*(2*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) - k1**2*k2**2*(-8*C*s**2 - 160*C*s + 10*K*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + b1*(68*r**2 + r*(136*s - 95) + 68*s**2 - 95*s + 27) - 2*r**2*(4*C + 17) + 2*r*(160*C*s + 4*C - 118*s + 41) - 34*s**2 + 166*s - 48) + k2**4*(4*C*(29*r**2 + r*(58*s - 51) + 29*s**2 - 23*s + 22) - 42*K*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 21*b1*(r + s - 1) - 58*r**2 - 116*r*s + 102*r - 58*s**2 + 46*s - 44)) + 7*k2**2*(r + s - 1)*(b1**2*k2**2*(3*r + 3*s - 2) - 2*b1*k1**2*(K*(4*r + 4*s - 2) + 1) + 2*b1*k2**2*(C*(-8*r - 8*s + 4) + K*(22*r + 22*s - 9) + 6*r + 6*s + 2) + (r + s)*(4*b2*k2**2 + 8*g2*k1**2 - 44*g2*k2**2))) + 21*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*k2**2*(D1*fd*(k1**2*(28*K*(r + s - 1)**2 + f*(68*r**2 + r*(136*s - 103) + 68*s**2 - 103*s + 45) + 28*r + 28*s - 14) + 7*k2**2*(8*C*(r + s - 1)**2 - 2*K*(11*r**2 + 22*r*s - 18*r + 11*s**2 - 18*s + 9) - 3*f*(7*r + 7*s - 5) - 6*r**2 - 12*r*s - 8*r - 6*s**2 - 8*s + 4)) + 2*Dd*f*(k1**2*(14*K*(r + s - 1) + f*(17*r + 17*s - 12) + 7) + 7*k2**2*(4*C*(r + s - 1) - 11*K*r - 11*K*s + 9*K - 3*f - 3*r - 3*s - 2))*(4*r + 4*s - 3)) + 3*b1*(D1*(f**2*fd*k1**2*(2*k1**2*(18*r**2 + 3*r*(12*s - 7) + 18*s**2 - 21*s + 7) + 9*k2**2*(54*r**2 + r*(108*s - 91) + 54*s**2 - 91*s + 39)) + 2*f*(fd*(k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(4*C*(2*r**2 + r*(17 - 80*s) + 2*s**2 + 59*s - 19) - 5*K*(2*r**2 + 4*r*s + 5*r + 2*s**2 + 5*s - 3) + 34*r**2 + 236*r*s - 98*r + 34*s**2 - 182*s + 60) + k2**4*(4*C*(29*r**2 + 2*r*(29*s - 7) + 29*s**2 - 28*s - 4) - 21*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 58*r**2 - 116*r*s + 49*r - 58*s**2 + 77*s - 6)) + 14*k2**2*(r + s - 1)*(bd2*k2**2*(r + s) + 2*gd2*k1**2*(r + s - 1) + gd2*k2**2*(-11*r - 11*s + 9))) + 28*fd*k2**2*(b2*k2**2*(r + s)**2 + 2*g2*k1**2*(r + s - 1)**2 - g2*k2**2*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 9))) + 2*Dd*f*(f**2*k1**2*(k1**2*(6*r + 6*s - 2) + 9*k2**2*(9*r + 9*s - 8))*(4*r + 4*s - 3) + f*(k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**2*k2**2*(4*C*(4*r**2 - 2*r*(80*s - 7) + 4*s**2 + 119*s - 18) - 5*K*(4*r**2 + 8*r*s + 9*r + 4*s**2 + 9*s - 9) + 68*r**2 + 472*r*s - 177*r + 68*s**2 - 387*s + 105) + k2**4*(4*r + 4*s - 3)*(2*C*(29*r + 29*s - 7) - 21*K*(5*r + 5*s - 3) - 29*r - 29*s + 14)) + 14*k2**2*(4*r + 4*s - 3)*(b2*k2**2*(r + s) + 2*g2*k1**2*(r + s - 1) + g2*k2**2*(-11*r - 11*s + 9)))) + 2*f*(D1*(f*(fd*(3*r + 3*s - 2)*(k1**4*(3*r + 3*s + 1) - 3*k1**2*k2**2*(C*(6*r + 6*s + 2) - 15*r - 15*s + 8) - k2**4*(54*C - 27)*(5*r + 5*s - 3)) + k2**2*(-3*bd2 + 6*gd2)*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(r + s - 1)) - 3*fd*k2**2*(b2 - 2*g2)*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(f*(k1**4*(3*r + 3*s + 1) - 3*k1**2*k2**2*(C*(6*r + 6*s + 2) - 15*r - 15*s + 8) - k2**4*(54*C - 27)*(5*r + 5*s - 3)) + k2**2*(-3*b2 + 6*g2)*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)))/(315*d**2*k2*k3**4) + D1**3*Pk2*Pkdd3*ct*k1*(D1*bd1*f*(-7*b1**2*k2**2*(12*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 14*b1*(4*k1**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*k1**2*k2**2*(4*C*(2*r**2 + r*(2 - 16*s) + 2*s**2 + 7*s - 4) - 8*K*s**2 + 8*K*s - r**2*(8*K + 1) + r*(-16*K*s + 8*K + 38*s - 6) - s**2 - 16*s + 7) + k2**4*(4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) - 5*K*(2*r**2 + 4*r*s - r + 2*s**2 - s - 1) - 8*r**2 + 24*r*s + 2*r - 8*s**2 - 8*s + 6)) + 3*f*(r + s - 1)*(k1**4*(16*b1 + 4)*(2*r + 2*s - 1) + k1**2*k2**2*(-32*C*(2*r + 2*s - 1) - 14*K*(r + s - 1) + 7*b1*(12*r + 12*s - 7) + 46*r + 46*s - 16) + k2**4*(14 - 28*C)*(r + s)) - 28*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(4*b2*k1**2 + 5*b2*k2**2 - 8*g2*k1**2 - 5*g2*k2**2)) - 7*b1**3*k2**2*(12*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*fd*(3*f*k1**2*(4*k1**2*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 7*k2**2*(12*r**2 + 3*r*(8*s - 5) + 12*s**2 - 15*s + 5)) + 28*k1**4*(r + s)**2 + 14*k1**2*k2**2*(8*C*(r**2 - 2*r*(4*s + 1) + s**2 + 8*s + 1) - 8*K*s**2 - r**2*(8*K + 1) + r*(-16*K*s + 38*s + 12) - s**2 - 28*s - 6) + 14*k2**4*(8*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) - 5*K*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) - 4*r**2 + 4*r*(3*s + 2) - 4*s**2 - 12*s - 4)) + 2*Dd*f*(3*f*k1**2*(k1**2*(8*r + 8*s - 6) + 7*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 14*k1**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 7*k1**2*k2**2*(8*C*(4*r**2 - 2*r*(16*s + 1) + 4*s**2 + 23*s - 2) - 32*K*s**2 + 24*K*s - r**2*(32*K + 4) + r*(-64*K*s + 24*K + 152*s + 7) - 4*s**2 - 93*s + 2) + 7*k2**4*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 5*K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 16*r**2 + 6*r*(8*s + 3) - 16*s**2 - 32*s - 2))) + 2*b1*(D1*(f*(3*fd*(2*k1**4*(2*r + 2*s - 1)**2 - k1**2*k2**2*(2*r + 2*s - 1)*(16*C*(2*r + 2*s - 1) + 7*K*(r + s - 1) - 23*r - 23*s + 8) - k2**4*(28*C - 14)*(r**2 + 2*r*s + r + s**2 + s - 1)) + 14*k2**2*(r + s - 1)*(-bd2*(4*k1**2 + 5*k2**2)*(r + s) + 8*gd2*k1**2*(r + s) + 5*gd2*k2**2*(r + s + 1))) + 14*fd*k2**2*(-b2*(4*k1**2 + 5*k2**2)*(r + s)**2 + 8*g2*k1**2*(r + s)**2 + 5*g2*k2**2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1))) + Dd*f*(3*f*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(-16*C*(2*r + 2*s - 1) - 7*K*(r + s - 1) + 23*r + 23*s - 8) + k2**4*(7 - 14*C)*(r + s + 1)) + 14*k2**2*(-b2*(4*k1**2 + 5*k2**2)*(r + s) + 8*g2*k1**2*(r + s) + 5*g2*k2**2*(r + s + 1)))*(4*r + 4*s - 3)) - 6*f*k1**2*k2**2*(r + s - 1)*(30*C*D1*f*fd*r + 30*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1) - 15*D1*f*fd*r - 15*D1*f*fd*s + 10*D1*f*fd - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 28*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k2*k3**4) + D1**3*Pk2*Pkdd3*ct*k1*st**2*(D1*(462*b1*fd*k2**4*(r + s)**2*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) + 3*f**3*k1**2*(-11*bd1*k2**2*(k1**2*(27*r + 27*s - 1) + 72*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 11*f**2*k2**2*(-6*bd1*(k1**4*(2*K - 1)*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(-8*C*(4*r**2 + 29*r*s - 13*r + 4*s**2 - 13*s + 9) + 61*K*r**2 + 122*K*r*s - 88*K*r + 61*K*s**2 - 88*K*s + 27*K + 9*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) - 4*r**2 + 76*r*s - 8*r - 4*s**2 - 8*s + 12) - k2**4*(4*C*(r**2 + 6*r*(5*s - 2) + s**2 - 12*s + 11) - 105*K*r**2 - 210*K*r*s + 168*K*r - 105*K*s**2 + 168*K*s - 63*K + 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*r**2 - 46*r*s + 17*r + 5*s**2 + 17*s - 22)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) + 12*gd2*(2*k1**4*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 3) + k1**2*k2**2*(61*r**2 + 2*r*(61*s - 44) + 61*s**2 - 88*s + 27) + 21*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 33*f*k2**2*(-3*b1**2*fd*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - 2*b1*(fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(-4*C*(16*r**2 + 2*r*(58*s - 1) + 16*s**2 - 65*s - 3) + K*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) - 8*r**2 + 8*r*(19*s + 8) - 8*s**2 - 62*s - 30) - k2**4*(4*C*(2*r**2 + r*(60*s + 5) + 2*s**2 - 37*s - 3) - 21*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) + 10*r**2 - 92*r*s - 17*r + 10*s**2 + 67*s + 6)) + 14*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(1 - 2*K) + bd1*k2**2*(8*K - 5) + 2*gd2*(k1**2 - 4*k2**2))) + 4*g2*(-14*bd1*k2**2*(k1**2 - 4*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**4*(2*r**2 + r*(4*s + 5) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(122*r**2 + r*(244*s - 115) + 122*s**2 - 115*s + 27) + 21*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(462*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(b1*k1**2*(1 - 2*K) + b1*k2**2*(8*K - 5) + 4*g2*(k1**2 - 4*k2**2)) + 15*f**3*k1**4*(2*k1**2*(5*r + 5*s - 1) + 11*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 11*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(81*r + 81*s - 3) + (6 - 8*C)*(3*r + 3*s + 1)) + 6*k1**2*k2**2*(C*(-54*r - 54*s + 34) + 36*b1*(r + s - 1) + 39*r + 39*s - 26) + k2**4*(54 - 108*C)*(5*r + 5*s - 3)) - 33*f*k2**2*(-3*b1**2*k2**2*(3*k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) - k1**2*k2**2*(4*C*(32*r**2 + 232*r*s - 33*r + 32*s**2 - 138*s + 12) - K*(244*r**2 + 488*r*s - 291*r + 244*s**2 - 291*s + 81) + 16*r**2 - 304*r*s - 90*r + 16*s**2 + 120*s + 48) + k2**4*(-4*C*(4*r**2 + 5*r*(24*s - 1) + 4*s**2 - 75*s + 5) + 21*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 20*r**2 + 184*r*s + 11*r - 20*s**2 - 129*s + 10)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s + 9) + 4*s**2 + 9*s - 9) + k1**2*k2**2*(244*r**2 + r*(488*s - 291) + 244*s**2 - 291*s + 81) + 21*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(3465*d**2*k2*k3**6) + D1**3*Pk2*Pkdd3*ct*k1*(D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(-k1**4*(-8*C + 20*b1 + 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*r + 7*K*s - 7*K - 21*b1*(3*r + 3*s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) + 84*k2**2*(r + s)*(b1*(10*K*k2**4 + k1**4*(4*K - 2) + k1**2*k2**2*(18*K - 5)) - 2*g2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) - 3*b1**2*k2**2*(D1*fd*(3*f*k1**2*(20*k1**2*(2*r + 2*s - 1) + 21*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) + (r + s)**2*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5))) + Dd*f*(4*r + 4*s - 3)*(60*f*k1**4*(2*r + 2*s - 1) + 63*f*k1**2*k2**2*(3*r + 3*s - 1) + (r + s)*(-140*K*k2**4 - 14*k1**4*(4*K - 2) - 14*k1**2*k2**2*(18*K - 5)))) + b1*(D1*(5*f**2*fd*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 6*f*k2**2*(3*fd*(2*r + 2*s - 1)*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 28*gd2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 168*fd*g2*k2**2*(r + s)**2*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(4*k1**2*(3*r + 3*s - 2) + 9*k2**2*(5*r + 5*s - 3)) + 18*f*k2**2*(k1**4*(8*C - 6)*(2*r + 2*s - 1) + k1**2*k2**2*(4*C*(15*r + 15*s - 4) + 7*K*(r + s - 1) - 37*r - 37*s + 8) + k2**4*(28*C - 14)*(r + s)) - 168*g2*k2**2*(r + s)*(2*k1**4 + 9*k1**2*k2**2 + 5*k2**4))) + 18*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 14*f*gd2*(r + s - 1) - 14*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1))/(315*d**2*k2*k3**6) - 2*D1**3*Pk2*Pkdd3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(99*d**2*k3**6) - D1**3*Pk2*Pkdd3*f*k2**2*st**6*(D1*bd1*f*(-18*K*k2**2*(2*r + 2*s - 1) + 7*f*k1**2*(3*r + 3*s - 1))*(r + s - 1) + b1*(D1*fd*(-18*K*k2**2*(2*r + 2*s - 1)**2 + f*k1**2*(63*r**2 + 3*r*(42*s - 29) + 63*s**2 - 87*s + 32)) + Dd*f*(-18*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(21*r + 21*s - 13))*(4*r + 4*s - 3)) - 2*k2**2*(18*C*D1*f*fd*r**2 + 36*C*D1*f*fd*r*s - 24*C*D1*f*fd*r + 18*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 8*C*D1*f*fd + 24*C*Dd*f**2*r**2 + 48*C*Dd*f**2*r*s - 34*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 34*C*Dd*f**2*s + 12*C*Dd*f**2 + 9*D1*bd2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 9*D1*f*fd*r**2 - 18*D1*f*fd*r*s + 12*D1*f*fd*r - 9*D1*f*fd*s**2 + 12*D1*f*fd*s - 4*D1*f*fd - 36*D1*f*gd2*r**2 - 72*D1*f*gd2*r*s + 54*D1*f*gd2*r - 36*D1*f*gd2*s**2 + 54*D1*f*gd2*s - 18*D1*f*gd2 - 72*D1*fd*g2*r**2 - 144*D1*fd*g2*r*s + 72*D1*fd*g2*r - 72*D1*fd*g2*s**2 + 72*D1*fd*g2*s - 18*D1*fd*g2 - 12*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 17*Dd*f**2*r - 12*Dd*f**2*s**2 + 17*Dd*f**2*s - 6*Dd*f**2 - 144*Dd*f*g2*r**2 - 288*Dd*f*g2*r*s + 180*Dd*f*g2*r - 144*Dd*f*g2*s**2 + 180*Dd*f*g2*s - 54*Dd*f*g2 + 9*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1)))/(63*d**2*k3**4) + D1**3*Pk2*Pkdd3*f*k2**2*st**6*(D1*(f**2*k1**2*(11*bd1*k2**2*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 7) - fd*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) + 11*f*k2**2*(b1*fd*k1**2*(45*r**2 + r*(90*s - 51) + 45*s**2 - 51*s + 14) - 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-9*K*bd1 + 18*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 198*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(119*r + 119*s - 81) - 22*k2**2*(3*r + 3*s - 2)) + 11*f*k2**2*(b1*k1**2*(-15*r - 15*s + 7) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(198*K*b1 - 396*g2)*(2*r + 2*s - 1)))/(693*d**2*k3**6) - D1**3*Pk2*Pkdd3*k1**2*(2*D1*bd1*f*(f*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + (7*b2 - 14*g2)*(2*k1**2 + 5*k2**2)*(r + s))*(r + s - 1) + 7*b1**3*(4*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 7*b1**2*(D1*bd1*f*(4*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + D1*fd*(-3*f*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 4*k1**2*(K*(r + s)**2 + s*(10*C - 5)*(r - 1)) + 2*k2**2*(-4*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 5*K*s**2 + r**2*(5*K + 2) + 2*r*(5*K*s - 3*s - 2) + 2*s**2 + 6*s + 2)) - 2*Dd*f*(k1**2*(-10*C*(r*(8*s - 1) - 6*s + 1) - 8*K*r**2 - 16*K*r*s + 6*K*r - 8*K*s**2 + 6*K*s + 3*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 40*r*s - 5*r - 30*s + 5) + k2**2*(2*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 20*K*s**2 + 15*K*s - r**2*(20*K + 8) + r*(-40*K*s + 15*K + 24*s + 9) - 8*s**2 - 16*s - 1))) + b1*(-7*D1*bd1*f*(k1**2*(-20*C*(r*(4*s - 1) - 2*s + 1) - 8*K*r**2 - 8*K*s**2 + 8*K*s + 3*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*r*(8*K*s - 4*K - 20*s + 5) - 20*s + 10) + 2*k2**2*(C*(8*r**2 - 2*r*(12*s + 1) + 8*s**2 + 8*s - 6) - 10*K*s**2 + 10*K*s - r**2*(10*K + 4) + r*(-20*K*s + 10*K + 12*s + 1) - 4*s**2 - 4*s + 3)) + 2*D1*(f*fd*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1) + 7*f*(bd2 - 2*gd2)*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 7*fd*(b2 - 2*g2)*(2*k1**2 + 5*k2**2)*(r + s)**2) + 2*Dd*f*(f*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) + (7*b2 - 14*g2)*(2*k1**2 + 5*k2**2)*(r + s))*(4*r + 4*s - 3)))/(105*d**2*k3**4) - D1**3*Pk2*Pkdd3*k1**2*(-D1*bd1*f*(r + s - 1)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)) + b1**2*(D1*fd*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(8*r + 8*s - 4) + 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(2*D1*bd1*f*(-14*K*k2**2*(2*k1**2 + 5*k2**2)*(r + s) + 3*f*(k1**4*(8*r + 8*s - 4) + 7*k1**2*k2**2*(3*r + 3*s - 1)))*(r + s - 1) + D1*(-15*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(6*C - 3)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s))*(2*r + 2*s - 1) - 14*gd2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*fd*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(12*C - 6)*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)) - 28*g2*k2**2*(2*k1**2 + 5*k2**2)*(r + s))))/(105*d**2*k3**6) - D1**3*Pk2*Pkdd3*st**4*(r + s - 1)*(-2*D1*bd1*f*k2**2*(r + s)*(7*b2 + f*(4*C - 2) - 14*g2) + b1**2*(2*D1*fd*(-7*K*k2**2 + f*k1**2)*(r + s - 1) + Dd*f*(-14*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-14*K*k2**2 + f*k1**2)*(2*r + 2*s - 1) - 2*k2**2*(7*D1*bd2*f*(r + s - 1) - 2*D1*(r + s - 1)*(f*fd*(2 - 4*C) + 7*f*gd2 + 7*fd*g2) + 2*Dd*f*(f*(2*C - 1) - 7*g2)*(4*r + 4*s - 3) + 7*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(35*d**2*k3**2) + D1**3*Pk2*Pkdd3*st**2*(2*D1*bd1*f*(7*b2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - f*(2*C - 1)*(k1**2*(r**2 - r*(12*s + 1) + s*(s + 6)) + 7*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 14*g2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*b1**3*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 7*b1**2*(r + s - 1)*(D1*bd1*f*k1**2*(3*r + 3*s - 2) + 2*D1*fd*(r + s - 1)*(K*(k1**2 - 5*k2**2) + 3*f*k1**2 + k2**2*(2*C - 1)) + Dd*f*(4*r + 4*s - 3)*(2*K*(k1**2 - 5*k2**2) + 3*f*k1**2 + k2**2*(4*C - 2))) + b1*(56*C*D1*bd1*f*k2**2*r**2 + 112*C*D1*bd1*f*k2**2*r*s - 84*C*D1*bd1*f*k2**2*r + 56*C*D1*bd1*f*k2**2*s**2 - 84*C*D1*bd1*f*k2**2*s + 28*C*D1*bd1*f*k2**2 - 8*C*D1*f*fd*k1**2*r**2 + 96*C*D1*f*fd*k1**2*r*s - 12*C*D1*f*fd*k1**2*r - 8*C*D1*f*fd*k1**2*s**2 - 68*C*D1*f*fd*k1**2*s + 20*C*D1*f*fd*k1**2 - 56*C*D1*f*fd*k2**2*r**2 - 112*C*D1*f*fd*k2**2*r*s + 112*C*D1*f*fd*k2**2*r - 56*C*D1*f*fd*k2**2*s**2 + 112*C*D1*f*fd*k2**2*s - 56*C*D1*f*fd*k2**2 - 16*C*Dd*f**2*k1**2*r**2 + 192*C*Dd*f**2*k1**2*r*s - 16*C*Dd*f**2*k1**2*s**2 - 140*C*Dd*f**2*k1**2*s + 16*C*Dd*f**2*k1**2 - 112*C*Dd*f**2*k2**2*r**2 - 224*C*Dd*f**2*k2**2*r*s + 196*C*Dd*f**2*k2**2*r - 112*C*Dd*f**2*k2**2*s**2 + 196*C*Dd*f**2*k2**2*s - 84*C*Dd*f**2*k2**2 + 28*D1*K*bd1*f*k1**2*r**2 + 56*D1*K*bd1*f*k1**2*r*s - 42*D1*K*bd1*f*k1**2*r + 28*D1*K*bd1*f*k1**2*s**2 - 42*D1*K*bd1*f*k1**2*s + 14*D1*K*bd1*f*k1**2 - 140*D1*K*bd1*f*k2**2*r**2 - 280*D1*K*bd1*f*k2**2*r*s + 210*D1*K*bd1*f*k2**2*r - 140*D1*K*bd1*f*k2**2*s**2 + 210*D1*K*bd1*f*k2**2*s - 70*D1*K*bd1*f*k2**2 + 42*D1*bd1*f**2*k1**2*r**2 + 84*D1*bd1*f**2*k1**2*r*s - 63*D1*bd1*f**2*k1**2*r + 42*D1*bd1*f**2*k1**2*s**2 - 63*D1*bd1*f**2*k1**2*s + 21*D1*bd1*f**2*k1**2 - 28*D1*bd1*f*k2**2*r**2 - 56*D1*bd1*f*k2**2*r*s + 42*D1*bd1*f*k2**2*r - 28*D1*bd1*f*k2**2*s**2 + 42*D1*bd1*f*k2**2*s - 14*D1*bd1*f*k2**2 + 14*D1*bd2*f*(k1**2 - 5*k2**2)*(r + s - 1)**2 + 4*D1*f*fd*k1**2*r**2 - 48*D1*f*fd*k1**2*r*s + 6*D1*f*fd*k1**2*r + 4*D1*f*fd*k1**2*s**2 + 34*D1*f*fd*k1**2*s - 10*D1*f*fd*k1**2 + 28*D1*f*fd*k2**2*r**2 + 56*D1*f*fd*k2**2*r*s - 56*D1*f*fd*k2**2*r + 28*D1*f*fd*k2**2*s**2 - 56*D1*f*fd*k2**2*s + 28*D1*f*fd*k2**2 - 28*D1*f*gd2*k1**2*r**2 - 56*D1*f*gd2*k1**2*r*s + 56*D1*f*gd2*k1**2*r - 28*D1*f*gd2*k1**2*s**2 + 56*D1*f*gd2*k1**2*s - 28*D1*f*gd2*k1**2 + 140*D1*f*gd2*k2**2*r**2 + 280*D1*f*gd2*k2**2*r*s - 280*D1*f*gd2*k2**2*r + 140*D1*f*gd2*k2**2*s**2 - 280*D1*f*gd2*k2**2*s + 140*D1*f*gd2*k2**2 - 28*D1*fd*g2*k1**2*r**2 - 56*D1*fd*g2*k1**2*r*s + 56*D1*fd*g2*k1**2*r - 28*D1*fd*g2*k1**2*s**2 + 56*D1*fd*g2*k1**2*s - 28*D1*fd*g2*k1**2 + 140*D1*fd*g2*k2**2*r**2 + 280*D1*fd*g2*k2**2*r*s - 280*D1*fd*g2*k2**2*r + 140*D1*fd*g2*k2**2*s**2 - 280*D1*fd*g2*k2**2*s + 140*D1*fd*g2*k2**2 + 8*Dd*f**2*k1**2*r**2 - 96*Dd*f**2*k1**2*r*s + 8*Dd*f**2*k1**2*s**2 + 70*Dd*f**2*k1**2*s - 8*Dd*f**2*k1**2 + 56*Dd*f**2*k2**2*r**2 + 112*Dd*f**2*k2**2*r*s - 98*Dd*f**2*k2**2*r + 56*Dd*f**2*k2**2*s**2 - 98*Dd*f**2*k2**2*s + 42*Dd*f**2*k2**2 - 112*Dd*f*g2*k1**2*r**2 - 224*Dd*f*g2*k1**2*r*s + 196*Dd*f*g2*k1**2*r - 112*Dd*f*g2*k1**2*s**2 + 196*Dd*f*g2*k1**2*s - 84*Dd*f*g2*k1**2 + 560*Dd*f*g2*k2**2*r**2 + 1120*Dd*f*g2*k2**2*r*s - 980*Dd*f*g2*k2**2*r + 560*Dd*f*g2*k2**2*s**2 - 980*Dd*f*g2*k2**2*s + 420*Dd*f*g2*k2**2 + 14*b2*(k1**2 - 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1)))/(105*d**2*k3**2) + D1**3*Pk2*Pkdd3*st**4*(-D1*bd1*f*(r + s - 1)*(f**2*k1**2*(k1**2*(6*r + 6*s - 7) - 3*k2**2*(17*r + 17*s - 9)) + 3*f*k2**2*(2*K*k1**2*(-5*r - 5*s + 6) + 14*K*k2**2*(2*r + 2*s - 1) + b1*k1**2*(16*r + 16*s - 1) + 2*k2**2*(2*C - 1)) - 42*k2**4*(K*b1 + b2*(r + s))) + 3*b1**2*k2**2*(D1*fd*(14*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(-16*r**2 + r*(7 - 32*s) - 16*s**2 + 7*s + 1)) - 2*Dd*f*(-7*K*k2**2 + 4*f*k1**2*(r + s))*(4*r + 4*s - 3)) + b1*(D1*(f**2*fd*k1**2*(-k1**2*(18*r**2 + 9*r*(4*s - 5) + 18*s**2 - 45*s + 23) + 3*k2**2*(51*r**2 + r*(102*s - 77) + 51*s**2 - 77*s + 30)) + 6*f*k2**2*(fd*(K*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 3)) + 7*k2**2*(bd2*(r + s) - 2*gd2)*(r + s - 1)) + 42*fd*k2**4*(b2*(r + s)**2 + g2*(-4*r - 4*s + 2))) - Dd*f*(4*r + 4*s - 3)*(f**2*(2*k1**4*(3*r + 3*s - 5) - 3*k1**2*k2**2*(17*r + 17*s - 13)) + 6*f*k2**2*(K*k1**2*(-5*r - 5*s + 6) + 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(1 - 2*C)) - 42*k2**4*(b2*(r + s) - 2*g2))) + 6*f*k2**2*(12*C*D1*f*fd*k1**2*r**2 + 36*C*D1*f*fd*k1**2*r*s - 16*C*D1*f*fd*k1**2*r + 12*C*D1*f*fd*k1**2*s**2 - 22*C*D1*f*fd*k1**2*s + 6*C*D1*f*fd*k1**2 - 12*C*D1*f*fd*k2**2*r**2 - 24*C*D1*f*fd*k2**2*r*s + 14*C*D1*f*fd*k2**2*r - 12*C*D1*f*fd*k2**2*s**2 + 14*C*D1*f*fd*k2**2*s - 4*C*D1*f*fd*k2**2 + 16*C*Dd*f**2*k1**2*r**2 + 48*C*Dd*f**2*k1**2*r*s - 22*C*Dd*f**2*k1**2*r + 16*C*Dd*f**2*k1**2*s**2 - 32*C*Dd*f**2*k1**2*s + 8*C*Dd*f**2*k1**2 - 16*C*Dd*f**2*k2**2*r**2 - 32*C*Dd*f**2*k2**2*r*s + 20*C*Dd*f**2*k2**2*r - 16*C*Dd*f**2*k2**2*s**2 + 20*C*Dd*f**2*k2**2*s - 6*C*Dd*f**2*k2**2 + D1*bd2*f*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 6*D1*f*fd*k1**2*r**2 - 18*D1*f*fd*k1**2*r*s + 8*D1*f*fd*k1**2*r - 6*D1*f*fd*k1**2*s**2 + 11*D1*f*fd*k1**2*s - 3*D1*f*fd*k1**2 + 6*D1*f*fd*k2**2*r**2 + 12*D1*f*fd*k2**2*r*s - 7*D1*f*fd*k2**2*r + 6*D1*f*fd*k2**2*s**2 - 7*D1*f*fd*k2**2*s + 2*D1*f*fd*k2**2 - 10*D1*f*gd2*k1**2*r**2 - 20*D1*f*gd2*k1**2*r*s + 22*D1*f*gd2*k1**2*r - 10*D1*f*gd2*k1**2*s**2 + 22*D1*f*gd2*k1**2*s - 12*D1*f*gd2*k1**2 + 28*D1*f*gd2*k2**2*r**2 + 56*D1*f*gd2*k2**2*r*s - 42*D1*f*gd2*k2**2*r + 28*D1*f*gd2*k2**2*s**2 - 42*D1*f*gd2*k2**2*s + 14*D1*f*gd2*k2**2 - 20*D1*fd*g2*k1**2*r**2 - 40*D1*fd*g2*k1**2*r*s + 34*D1*fd*g2*k1**2*r - 20*D1*fd*g2*k1**2*s**2 + 34*D1*fd*g2*k1**2*s - 12*D1*fd*g2*k1**2 + 56*D1*fd*g2*k2**2*r**2 + 112*D1*fd*g2*k2**2*r*s - 56*D1*fd*g2*k2**2*r + 56*D1*fd*g2*k2**2*s**2 - 56*D1*fd*g2*k2**2*s + 14*D1*fd*g2*k2**2 - 8*Dd*f**2*k1**2*r**2 - 24*Dd*f**2*k1**2*r*s + 11*Dd*f**2*k1**2*r - 8*Dd*f**2*k1**2*s**2 + 16*Dd*f**2*k1**2*s - 4*Dd*f**2*k1**2 + 8*Dd*f**2*k2**2*r**2 + 16*Dd*f**2*k2**2*r*s - 10*Dd*f**2*k2**2*r + 8*Dd*f**2*k2**2*s**2 - 10*Dd*f**2*k2**2*s + 3*Dd*f**2*k2**2 - 40*Dd*f*g2*k1**2*r**2 - 80*Dd*f*g2*k1**2*r*s + 78*Dd*f*g2*k1**2*r - 40*Dd*f*g2*k1**2*s**2 + 78*Dd*f*g2*k1**2*s - 36*Dd*f*g2*k1**2 + 112*Dd*f*g2*k2**2*r**2 + 224*Dd*f*g2*k2**2*r*s - 140*Dd*f*g2*k2**2*r + 112*Dd*f*g2*k2**2*s**2 - 140*Dd*f*g2*k2**2*s + 42*Dd*f*g2*k2**2 + b2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d**2*k3**4) + D1**3*Pk2*Pkdd3*st**2*(21*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*(D1*(f*k1**2*(-7*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(4*r**2 + 8*r*s - 17*r + 4*s**2 - 17*s + 9) - 7*k2**2*(8*r**2 + 16*r*s - r + 8*s**2 - s - 3))) + 14*fd*k2**2*(-K*(k1**2 - 5*k2**2)*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(r + s - 1)**2)) + 2*Dd*f*(4*r + 4*s - 3)*(-7*K*k2**2*(k1**2 - 5*k2**2) + f*k1**4*(r + s - 3) - 14*f*k1**2*k2**2*(r + s) + k2**4*(14*C - 7)*(r + s - 1))) - 3*b1*(D1*bd1*f*(r + s - 1)*(-14*K*k2**2*(k1**2 - 5*k2**2) + f*k1**4*(4*r + 4*s - 9) - 7*f*k1**2*k2**2*(8*r + 8*s - 3) + k2**4*(28*C - 14)*(2*r + 2*s - 1)) + D1*(-9*f**2*fd*k1**4*(6*r**2 + r*(12*s - 11) + 6*s**2 - 11*s + 5) + 2*f*(fd*(k1**4*(14*C*(r*(4*s - 1) - 3*s + 1) + K*(2*r**2 + 4*r*s + 5*r + 2*s**2 + 5*s - 3) - 28*r*s + 7*r + 21*s - 7) + k1**2*k2**2*(-2*C*(18*r**2 + 36*r*s + r + 18*s**2 - 6*s - 8) + 7*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 18*r**2 + 36*r*s + r + 18*s**2 - 6*s - 8) + k2**4*(14*C - 7)*(3*r + 3*s - 2)) - 7*k2**2*(k1**2 - 5*k2**2)*(bd2*(r + s) - 2*gd2)*(r + s - 1)) - 14*fd*k2**2*(-k1**2 + 5*k2**2)*(-b2*(r + s)**2 + g2*(4*r + 4*s - 2))) - 2*Dd*f*(9*f**2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - f*(k1**4*(14*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s + 9*r + 4*s**2 + 9*s - 9) - 56*r*s + 7*r + 42*s - 7) + k1**2*k2**2*(4*r + 4*s - 3)*(-2*C*(9*r + 9*s + 2) + 7*K*(4*r + 4*s - 3) + 9*r + 9*s + 2) + k2**4*(14*C - 7)*(4*r + 4*s - 3)) + 7*k2**2*(k1**2 - 5*k2**2)*(b2*(r + s) - 2*g2)*(4*r + 4*s - 3))) + f*(-6*D1*bd2*f*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) - 6*b2*(D1*(-7*bd1*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3)) + k1**2*(3*D1*bd1*f*(-2*K*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) + 9*f*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + (4*C - 2)*(7*k1**2*s*(1 - 2*r) + k2**2*(9*r**2 + r*(18*s - 13) + 9*s**2 - 6*s + 4))) + 2*D1*(f*(-fd*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 6*gd2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) + 6*fd*g2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) - 2*Dd*f*(f*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) - 6*g2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3)))*(4*r + 4*s - 3))))/(315*d**2*k3**4) - D1**3*Pk2*Pkdd3*st**4*(D1*(462*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) + f**3*k1**2*(33*bd1*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + fd*k1**2*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3)) + 33*f**2*k2**2*(fd*(2*k1**4*(2*C*(r*(6*s - 1) - 4*s + 1) + 6*b1*r**2 + 6*b1*s**2 - 4*b1*s + r*(12*b1*s - 4*b1 - 6*s + 1) + 4*s - 1) + k1**2*k2**2*(b1*(39*r**2 + r*(78*s - 53) + 39*s**2 - 53*s + 18) + (4*C - 2)*(6*r**2 + 2*r*(9*s - 4) + 6*s**2 - 11*s + 3)) + k2**4*(2 - 4*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 2*k2**2*(r + s - 1)*(b1*bd1*k1**2*(13*r + 13*s - 3) - bd1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 2*gd2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))) - 33*f*k2**4*(b1**2*fd*k1**2*(26*r**2 + r*(52*s - 19) + 26*s**2 - 19*s + 3) - 2*b1*fd*(2*r + 2*s - 1)*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 28*b1*k2**2*(-K*bd1 + gd2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 4*g2*(7*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(462*b1*k2**6*(K*b1 - 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**3*k1**4*(k1**2*(13*r + 13*s - 29) - 33*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 33*f**2*k2**2*(2*k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + 8*b1*r**2 + 8*b1*s**2 - 6*b1*s + r*(16*b1*s - 6*b1 - 8*s + 1) + 6*s - 1) + k1**2*k2**2*(b1*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + (4*C - 2)*(8*r**2 + r*(24*s - 11) + 8*s**2 - 16*s + 4)) + k2**4*(2 - 4*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 33*f*k2**4*(4*r + 4*s - 3)*(b1**2*k1**2*(13*r + 13*s - 3) - 2*b1*(K*k1**2*(5*r + 5*s - 6) - 7*K*k2**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 1)) + 4*g2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1)))))/(1155*d**2*k3**6) + D1**3*Pk2*Pkdd3*st**2*(D1*bd1*f*(-f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(r + s - 1) + 6*f*k2**2*(k1**4*(-14*C*(2*r*s - r - s + 1) + K*r**2 + 2*K*r*s + 2*K*r + K*s**2 + 2*K*s - 3*K + 3*b1*(5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s - 1) + 14*r*s - 7*r - 7*s + 7) + k1**2*k2**2*(-4*C*(4*r**2 + 15*r*s - 6*r + 4*s**2 - 6*s + 2) + 28*K*r**2 + 56*K*r*s - 49*K*r + 28*K*s**2 - 49*K*s + 21*K - 21*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 30*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(14*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(-k1**2 + 5*k2**2)*(84*K*b1 - 84*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*b1**2*k2**2*(D1*fd*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s)**2 + 3*f*k1**2*(k1**2*(5*r + 5*s + 1) - 7*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(-14*K*k2**2*(k1**2 - 5*k2**2)*(r + s) + 3*f*(k1**4*(5*r + 5*s + 1) - 7*k1**2*k2**2*(3*r + 3*s - 1)))*(4*r + 4*s - 3)) + b1*(D1*(-f**2*fd*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(3*r + 3*s - 2) + 6*f*k2**2*(fd*(K*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) - (2*C - 1)*(7*k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + r*(60*s - 2) + 16*s**2 - 23*s - 3) - 7*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)))) + 14*gd2*k2**2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 84*fd*g2*k2**4*(k1**2 - 5*k2**2)*(r + s)**2) + Dd*f*(-f**2*k1**4*(k1**2*(3*r + 3*s + 1) - 36*k2**2*(r + s))*(4*r + 4*s - 3) + 6*f*k2**2*(k1**4*(-14*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s + 9*r + 4*s**2 + 9*s - 9) + 56*r*s - 7*r - 42*s + 7) + k1**2*k2**2*(C*(-64*r**2 + r*(38 - 240*s) - 64*s**2 + 108*s + 4) + 7*K*(4*r + 4*s - 3)**2 + 32*r**2 + 120*r*s - 19*r + 32*s**2 - 54*s - 2) + k2**4*(14*C - 7)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 84*g2*k2**4*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*k1**2*(D1*(15*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(fd*(2*C - 1)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 6*gd2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 12*fd*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(3*r + 3*s + 1) + 9*k2**2*(4*r + 4*s - 3)) - 12*g2*k2**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3)))))/(315*d**2*k3**6) + 8*D1**3*Pk3*ct**8*f*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(1584*C*D1*f*fd*r*s - 726*C*D1*f*fd*r + 1584*C*D1*f*fd*s**2 - 1584*C*D1*f*fd*s + 418*C*D1*f*fd + 2112*C*Dd*f**2*r*s - 880*C*Dd*f**2*r + 2112*C*Dd*f**2*s**2 - 2112*C*Dd*f**2*s + 572*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 1400*D1*f**2*fd*r*s - 427*D1*f**2*fd*r + 1400*D1*f**2*fd*s**2 - 1400*D1*f**2*fd*s + 301*D1*f**2*fd - 1584*D1*f*fd*r*s + 726*D1*f*fd*r - 1584*D1*f*fd*s**2 + 1584*D1*f*fd*s - 418*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 1400*Dd*f**3*r*s - 427*Dd*f**3*r + 1400*Dd*f**3*s**2 - 1400*Dd*f**3*s + 301*Dd*f**3 - 2112*Dd*f**2*r*s + 880*Dd*f**2*r - 2112*Dd*f**2*s**2 + 2112*Dd*f**2*s - 572*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**6) - 2*D1**3*Pk3*ct**8*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(100*s**2 - 61*s + 9) + f*fd*(22*C - 22)*(36*s**2 - 33*s + 7) - 99*f*s*(2*s - 1)*(-K*bd1 + bd1 + 2*gd2) - 198*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(25*s - 9) + f*(22*C - 22)*(12*s - 7) + 198*g2*(1 - 2*s)) + 99*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(693*d**2*k3**4) + 4*D1**3*Pk3*ct**7*f*k1*k2*(-95040*C*D1*Pk2*f*fd*k1**2*r*s + 63360*C*D1*Pk2*f*fd*k1**2*r - 95040*C*D1*Pk2*f*fd*k1**2*s**2 + 126720*C*D1*Pk2*f*fd*k1**2*s - 42240*C*D1*Pk2*f*fd*k1**2 + 28512*C*D1*Pk2*f*fd*k2**2*r**2 - 82368*C*D1*Pk2*f*fd*k2**2*r*s + 28248*C*D1*Pk2*f*fd*k2**2*r - 63360*C*D1*Pk2*f*fd*k2**2*s**2 + 101376*C*D1*Pk2*f*fd*k2**2*s - 30184*C*D1*Pk2*f*fd*k2**2 + 23760*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 15840*C*D1*Pkd2*f*fd*k1**2*k2*r + 23760*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 31680*C*D1*Pkd2*f*fd*k1**2*k2*s + 10560*C*D1*Pkd2*f*fd*k1**2*k2 + 55440*C*D1*Pkd2*f*fd*k2**3*r*s - 18480*C*D1*Pkd2*f*fd*k2**3*r + 31680*C*D1*Pkd2*f*fd*k2**3*s**2 - 47520*C*D1*Pkd2*f*fd*k2**3*s + 12320*C*D1*Pkd2*f*fd*k2**3 - 126720*C*Dd*Pk2*f**2*k1**2*r*s + 81840*C*Dd*Pk2*f**2*k1**2*r - 126720*C*Dd*Pk2*f**2*k1**2*s**2 + 174240*C*Dd*Pk2*f**2*k1**2*s - 60720*C*Dd*Pk2*f**2*k1**2 + 38016*C*Dd*Pk2*f**2*k2**2*r**2 - 109824*C*Dd*Pk2*f**2*k2**2*r*s + 26488*C*Dd*Pk2*f**2*k2**2*r - 84480*C*Dd*Pk2*f**2*k2**2*s**2 + 136752*C*Dd*Pk2*f**2*k2**2*s - 37928*C*Dd*Pk2*f**2*k2**2 + 31680*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 20460*C*Dd*Pkd2*f**2*k1**2*k2*r + 31680*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 43560*C*Dd*Pkd2*f**2*k1**2*k2*s + 15180*C*Dd*Pkd2*f**2*k1**2*k2 + 73920*C*Dd*Pkd2*f**2*k2**3*r*s - 21560*C*Dd*Pkd2*f**2*k2**3*r + 42240*C*Dd*Pkd2*f**2*k2**3*s**2 - 66000*C*Dd*Pkd2*f**2*k2**3*s + 15400*C*Dd*Pkd2*f**2*k2**3 - 150080*D1*Pk2*f**2*fd*k1**2*r*s + 54460*D1*Pk2*f**2*fd*k1**2*r - 150080*D1*Pk2*f**2*fd*k1**2*s**2 + 165480*D1*Pk2*f**2*fd*k1**2*s - 40460*D1*Pk2*f**2*fd*k1**2 + 8800*D1*Pk2*f**2*fd*k2**2*r**2 + 8800*D1*Pk2*f**2*fd*k2**2*r*s - 6380*D1*Pk2*f**2*fd*k2**2*r - 1320*D1*Pk2*f**2*fd*k2**2*s + 220*D1*Pk2*f**2*fd*k2**2 + 95040*D1*Pk2*f*fd*k1**2*r*s - 63360*D1*Pk2*f*fd*k1**2*r + 95040*D1*Pk2*f*fd*k1**2*s**2 - 126720*D1*Pk2*f*fd*k1**2*s + 42240*D1*Pk2*f*fd*k1**2 - 36432*D1*Pk2*f*fd*k2**2*r**2 + 26928*D1*Pk2*f*fd*k2**2*r*s - 8448*D1*Pk2*f*fd*k2**2*r + 39600*D1*Pk2*f*fd*k2**2*s**2 - 61116*D1*Pk2*f*fd*k2**2*s + 19844*D1*Pk2*f*fd*k2**2 + 50688*D1*Pk2*f*gd2*k1**2*r*s - 23760*D1*Pk2*f*gd2*k1**2*r + 50688*D1*Pk2*f*gd2*k1**2*s**2 - 72864*D1*Pk2*f*gd2*k1**2*s + 23760*D1*Pk2*f*gd2*k1**2 - 15840*D1*Pk2*f*gd2*k2**2*r**2 + 15840*D1*Pk2*f*gd2*k2**2*r*s + 11880*D1*Pk2*f*gd2*k2**2*r + 31680*D1*Pk2*f*gd2*k2**2*s**2 - 23760*D1*Pk2*f*gd2*k2**2*s + 3960*D1*Pk2*f*gd2*k2**2 + 101376*D1*Pk2*fd*g2*k1**2*r*s - 61776*D1*Pk2*fd*g2*k1**2*r + 101376*D1*Pk2*fd*g2*k1**2*s**2 - 123552*D1*Pk2*fd*g2*k1**2*s + 36432*D1*Pk2*fd*g2*k1**2 - 31680*D1*Pk2*fd*g2*k2**2*r**2 + 31680*D1*Pk2*fd*g2*k2**2*r*s - 15840*D1*Pk2*fd*g2*k2**2*r + 63360*D1*Pk2*fd*g2*k2**2*s**2 - 63360*D1*Pk2*fd*g2*k2**2*s + 15840*D1*Pk2*fd*g2*k2**2 + 37520*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 13615*D1*Pkd2*f**2*fd*k1**2*k2*r + 37520*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 41370*D1*Pkd2*f**2*fd*k1**2*k2*s + 10115*D1*Pkd2*f**2*fd*k1**2*k2 - 23760*D1*Pkd2*f*fd*k1**2*k2*r*s + 15840*D1*Pkd2*f*fd*k1**2*k2*r - 23760*D1*Pkd2*f*fd*k1**2*k2*s**2 + 31680*D1*Pkd2*f*fd*k1**2*k2*s - 10560*D1*Pkd2*f*fd*k1**2*k2 - 35640*D1*Pkd2*f*fd*k2**3*r*s + 12870*D1*Pkd2*f*fd*k2**3*r - 23760*D1*Pkd2*f*fd*k2**3*s**2 + 31680*D1*Pkd2*f*fd*k2**3*s - 8250*D1*Pkd2*f*fd*k2**3 - 12672*D1*Pkd2*f*gd2*k1**2*k2*r*s + 5940*D1*Pkd2*f*gd2*k1**2*k2*r - 12672*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 18216*D1*Pkd2*f*gd2*k1**2*k2*s - 5940*D1*Pkd2*f*gd2*k1**2*k2 - 15840*D1*Pkd2*f*gd2*k2**3*r*s + 3960*D1*Pkd2*f*gd2*k2**3*r - 15840*D1*Pkd2*f*gd2*k2**3*s**2 + 15840*D1*Pkd2*f*gd2*k2**3*s - 3960*D1*Pkd2*f*gd2*k2**3 - 25344*D1*Pkd2*fd*g2*k1**2*k2*r*s + 15444*D1*Pkd2*fd*g2*k1**2*k2*r - 25344*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 30888*D1*Pkd2*fd*g2*k1**2*k2*s - 9108*D1*Pkd2*fd*g2*k1**2*k2 - 31680*D1*Pkd2*fd*g2*k2**3*r*s + 15840*D1*Pkd2*fd*g2*k2**3*r - 31680*D1*Pkd2*fd*g2*k2**3*s**2 + 31680*D1*Pkd2*fd*g2*k2**3*s - 7920*D1*Pkd2*fd*g2*k2**3 - 22*D1*bd1*f*(k1**2*(9*K - 9)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*f*(33*r**2 - 38*r - 33*s**2 + 14*s + 5) - 18*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*f*k2*(r*(33*s - 7) + 33*s**2 - 33*s + 7) - Pkd2*k2*(18*K - 9)*(r*(4*s - 1) + (1 - 2*s)**2))) - 150080*Dd*Pk2*f**3*k1**2*r*s + 54460*Dd*Pk2*f**3*k1**2*r - 150080*Dd*Pk2*f**3*k1**2*s**2 + 165480*Dd*Pk2*f**3*k1**2*s - 40460*Dd*Pk2*f**3*k1**2 + 8800*Dd*Pk2*f**3*k2**2*r**2 + 8800*Dd*Pk2*f**3*k2**2*r*s - 6380*Dd*Pk2*f**3*k2**2*r - 1320*Dd*Pk2*f**3*k2**2*s + 220*Dd*Pk2*f**3*k2**2 + 126720*Dd*Pk2*f**2*k1**2*r*s - 81840*Dd*Pk2*f**2*k1**2*r + 126720*Dd*Pk2*f**2*k1**2*s**2 - 174240*Dd*Pk2*f**2*k1**2*s + 60720*Dd*Pk2*f**2*k1**2 - 48576*Dd*Pk2*f**2*k2**2*r**2 + 35904*Dd*Pk2*f**2*k2**2*r*s - 1408*Dd*Pk2*f**2*k2**2*r + 52800*Dd*Pk2*f**2*k2**2*s**2 - 79552*Dd*Pk2*f**2*k2**2*s + 24948*Dd*Pk2*f**2*k2**2 + 202752*Dd*Pk2*f*g2*k1**2*r*s - 109296*Dd*Pk2*f*g2*k1**2*r + 202752*Dd*Pk2*f*g2*k1**2*s**2 - 269280*Dd*Pk2*f*g2*k1**2*s + 83952*Dd*Pk2*f*g2*k1**2 - 63360*Dd*Pk2*f*g2*k2**2*r**2 + 63360*Dd*Pk2*f*g2*k2**2*r*s + 7920*Dd*Pk2*f*g2*k2**2*r + 126720*Dd*Pk2*f*g2*k2**2*s**2 - 110880*Dd*Pk2*f*g2*k2**2*s + 23760*Dd*Pk2*f*g2*k2**2 + 37520*Dd*Pkd2*f**3*k1**2*k2*r*s - 13615*Dd*Pkd2*f**3*k1**2*k2*r + 37520*Dd*Pkd2*f**3*k1**2*k2*s**2 - 41370*Dd*Pkd2*f**3*k1**2*k2*s + 10115*Dd*Pkd2*f**3*k1**2*k2 - 31680*Dd*Pkd2*f**2*k1**2*k2*r*s + 20460*Dd*Pkd2*f**2*k1**2*k2*r - 31680*Dd*Pkd2*f**2*k1**2*k2*s**2 + 43560*Dd*Pkd2*f**2*k1**2*k2*s - 15180*Dd*Pkd2*f**2*k1**2*k2 - 47520*Dd*Pkd2*f**2*k2**3*r*s + 15180*Dd*Pkd2*f**2*k2**3*r - 31680*Dd*Pkd2*f**2*k2**3*s**2 + 43560*Dd*Pkd2*f**2*k2**3*s - 10560*Dd*Pkd2*f**2*k2**3 - 50688*Dd*Pkd2*f*g2*k1**2*k2*r*s + 27324*Dd*Pkd2*f*g2*k1**2*k2*r - 50688*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 67320*Dd*Pkd2*f*g2*k1**2*k2*s - 20988*Dd*Pkd2*f*g2*k1**2*k2 - 63360*Dd*Pkd2*f*g2*k2**3*r*s + 23760*Dd*Pkd2*f*g2*k2**3*r - 63360*Dd*Pkd2*f*g2*k2**3*s**2 + 63360*Dd*Pkd2*f*g2*k2**3*s - 15840*Dd*Pkd2*f*g2*k2**3 - 11*b1*(D1*fd*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(6*Pk2*(f*(33*r**2 - 16*r - 33*s**2 + 25*s - 3) + (-12*r - 12*s + 6)*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(2*Pk2*f*(132*r**2 - 86*r - 132*s**2 + 89*s - 4) - 36*Pk2*(2*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 24*r**2 - 16*r*s + 18*r + 8*s**2 - 2*s - 1) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) - Pkd2*k2*(72*K - 36)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**6) - D1**3*Pk3*ct**7*f*k1*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(99*s**2 - 75*s + 14) + 18*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(f*(33*s - 14) + 36*s - 18)) + f*(D1*bd1*s*(f*(33*s - 14) + 36*s - 18) + 2*D1*fd*(36*s**2 - 33*s + 7) + 2*Dd*f*(48*s**2 - 40*s + 7)))/(63*d**2*k2*k3**2) - D1**3*Pk3*ct**7*f*k1*(D1*(5*f**2*(-11*bd1*k2**2*(-8*Pk2*(2*r*(33*s - 7) + 33*s**2 - 52*s + 14) + k2*(Pkd2*(4*r*(33*s - 7) - 33*s**2 - 62*s + 28) + Pkdd2*k2*s*(33*s - 14))) + fd*(63*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 37*s + 6) + 44*k2**2*(Pk2*(r*(80 - 196*s) + 42*s - 26) + Pkd2*k2*(r*(52*s - 21) - 12*s + 7)))) + 22*f*(9*bd1*(Pk2*k1**2*s*(24*K - 24)*(13*s - 10) - Pkd2*k1**2*k2*s*(9*K - 9)*(13*s - 10) + 5*Pkd2*k2**3*(K*(r*(8*s - 2) - 20*s**2 + 6*s + 2) + r*(4 - 16*s) + 2*s**2 + 7*s - 4) + Pkdd2*k2**4*s*(10*K - 5)*(2*s - 1) + k2**2*(-40*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + Pkdd2*k1**2*s*(K - 1)*(13*s - 10))) + fd*k1**2*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(45*s**2 - 57*s + 14) + fd*k2**2*(-4*Pk2*(C*(9*r*(162*s - 77) - 1440*s**2 + 1554*s - 289) - 33*r*(66*s - 31) + 360*s**2 - 504*s + 29) + k2*(Pkd2*(4*C*(378*r*s - 180*r - 900*s**2 + 879*s - 175) - 2232*r*s + 1050*r + 1980*s**2 - 1971*s + 335) + Pkdd2*k2*(20*C - 15)*(36*s**2 - 33*s + 7))) - 18*gd2*(24*Pk2*k1**2*s*(13*s - 10) + 9*Pkd2*k1**2*k2*s*(10 - 13*s) + 10*Pkd2*k2**3*(r*(4*s - 1) - 10*s**2 + 3*s + 1) + 10*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(40*Pk2*(-4*r*s + r + 4*s**2 - 1) + Pkdd2*k1**2*s*(13*s - 10)))) - 396*fd*g2*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + 10*k2**2*(-8*Pk2*(2*r - 2*s + 1) + k2*(Pkd2*(4*r - 10*s + 5) + Pkdd2*k2*(2*s - 1))))) + Dd*f*(5*f**2*(63*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 37*s + 6) + 44*k2**2*(Pk2*(r*(80 - 196*s) + 42*s - 26) + Pkd2*k2*(r*(52*s - 21) - 12*s + 7))) + 22*f*(k1**2*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(60*s**2 - 71*s + 14) + k2**2*(8*C*Pk2*(-108*r*(9*s - 4) + 960*s**2 - 854*s + 59) + 16*Pk2*(r*(726*s - 316) - 120*s**2 + 87*s + 53) + Pkd2*k2*(36*C*r*(56*s - 25) - 8*C*(600*s**2 - 509*s + 65) - 2976*r*s + 1300*r + 2640*s**2 - 2112*s + 85) + Pkdd2*k2**2*(20*C - 15)*(48*s**2 - 40*s + 7))) - 396*g2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) + 10*k2**2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))) + 11*b1*(D1*fd*(k1**2*(18*K - 18)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 5*k2**2*(-24*Pk2*(f*(r*(66*s - 25) + 33*s**2 - 41*s + 11) + (12*s - 6)*(K*(-4*r + 4*s - 2) + 8*r + 2*s - 1)) + k2*(3*Pkd2*(f*(2*r*(66*s - 25) - 33*s**2 - 7*s + 8) + (2*s - 1)*(-12*K*(4*r - 10*s + 5) + 96*r - 12*s + 6)) + Pkdd2*k2*(f*(99*s**2 - 75*s + 14) + (1 - 2*s)**2*(18 - 36*K))))) + Dd*f*(k1**2*(18*K - 18)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) - 5*k2**2*(-8*Pk2*(f*(r*(264*s - 89) + 132*s**2 - 175*s + 47) + r*(72 - 36*K)*(8*s - 3) + (36*s - 18)*(s*(8*K + 4) - 5)) + k2*(Pkd2*(-36*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) + f*(2*r*(264*s - 89) - 132*s**2 - 83*s + 52) + 1152*r*s - 432*r - 144*s**2 - 180*s + 126) + Pkdd2*k2*(4*s - 1)*(-72*K*s + 36*K + f*(33*s - 14) + 36*s - 18))))))/(3465*d**2*k2*k3**4) + 8*D1**3*Pk3*ct**6*f*k1**2*k2**2*st**2*(-4*Pk2 + Pkd2*k2)*(3564*C*D1*f*fd*r*s - 1584*C*D1*f*fd*r + 3564*C*D1*f*fd*s**2 - 3564*C*D1*f*fd*s + 924*C*D1*f*fd + 4752*C*Dd*f**2*r*s - 1914*C*Dd*f**2*r + 4752*C*Dd*f**2*s**2 - 4752*C*Dd*f**2*s + 1254*C*Dd*f**2 + 297*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 4424*D1*f**2*fd*r*s - 1337*D1*f**2*fd*r + 4424*D1*f**2*fd*s**2 - 4424*D1*f**2*fd*s + 945*D1*f**2*fd - 3564*D1*f*fd*r*s + 1584*D1*f*fd*r - 3564*D1*f*fd*s**2 + 3564*D1*f*fd*s - 924*D1*f*fd - 2376*D1*f*gd2*r*s + 594*D1*f*gd2*r - 2376*D1*f*gd2*s**2 + 2376*D1*f*gd2*s - 594*D1*f*gd2 - 4752*D1*fd*g2*r*s + 2376*D1*fd*g2*r - 4752*D1*fd*g2*s**2 + 4752*D1*fd*g2*s - 1188*D1*fd*g2 + 4424*Dd*f**3*r*s - 1337*Dd*f**3*r + 4424*Dd*f**3*s**2 - 4424*Dd*f**3*s + 945*Dd*f**3 - 4752*Dd*f**2*r*s + 1914*Dd*f**2*r - 4752*Dd*f**2*s**2 + 4752*Dd*f**2*s - 1254*Dd*f**2 - 9504*Dd*f*g2*r*s + 3564*Dd*f*g2*r - 9504*Dd*f*g2*s**2 + 9504*Dd*f*g2*s - 2376*Dd*f*g2 + 594*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**6) - 2*D1**3*Pk3*ct**6*f*k1**2*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(316*s**2 - 191*s + 28) + 33*f*(fd*(2*C - 2)*(27*s**2 - 24*s + 5) + s*(2*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) - 594*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(79*s - 28) + f*(66*C - 66)*(9*s - 5) + 594*g2*(1 - 2*s)) + 297*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(693*d**2*k3**4) - 4*D1**3*Pk3*ct**6*(11*D1*bd1*f*(f**2*k2**2*(18*Pk2*k2**2*(r - 1)*(5*r + 5*s - 1) + 5*k1**2*(2*Pk2*(93*r**2 + 69*r*s - 110*r - 24*s**2 + s + 3) + Pkd2*k2*(117*r*s - 32*r + 117*s**2 - 143*s + 46))) + 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + k1**2*k2**2*(2*Pk2*(6*C*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 7*s - 2) + K*(-96*r**2 - 90*r*s + 59*r + 6*s**2 - 105*s + 37) + 135*r**2 + 228*r*s - 164*r + 93*s**2 - 87*s + 59) - 3*Pkd2*k2*(2*C*(r*(6*s - 3) + 6*s**2 - 4*s - 2) + K*(36*r*s - 23*r + 36*s**2 - 64*s + 23) - 16*r*s + 14*r - 16*s**2 + 26*s - 4)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 126*k1**2*k2**2*(-b1*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 1386*b1**2*k1**2*k2**2*(K - 1)*(2*D1*fd*(Pk2*(r**2 + 4*r*s - 2*r + 3*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + Dd*f*(2*Pk2*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 11*b1*(D1*(f**2*fd*k2**2*(18*Pk2*k2**2*(15*r**2 + 3*r*(5*s - 1) + 5*s - 4) + 5*k1**2*(6*Pk2*(93*r**2 + 69*r*s - 67*r - 24*s**2 + 17*s + 6) + Pkd2*k2*(351*r*s - 228*r + 351*s**2 - 480*s + 152))) + 6*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) + k1**2*k2**2*(2*Pk2*(6*C*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 11*s + 6) + K*(-192*r**2 - 180*r*s + 76*r + 12*s**2 - 96*s + 45) + 270*r**2 + 456*r*s - 256*r + 186*s**2 - 207*s + 27) - 3*Pkd2*k2*(24*C*s**2 + 2*C*s + 2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(s*(24*C - 32) + 11) - 32*s**2 + 20*s - 9)) - 30*k2**4*(2*r + 2*s - 1)*(K*Pk2*(6*r + 2*s - 1) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 42*gd2*k1**2*k2**2*(-2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 504*fd*g2*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(18*Pk2*k2**2*(20*r**2 + r*(20*s - 9) - 3) + 5*k1**2*(2*Pk2*(372*r**2 + r*(276*s - 311) - 96*s**2 + 52*s + 21) + Pkd2*k2*(52*r*(9*s - 5) + 468*s**2 - 623*s + 198))) + 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) + k1**2*k2**2*(2*Pk2*(6*C*(12*r**2 + 24*r*(2*s - 1) + 36*s**2 - 25*s + 7) + K*(-384*r**2 - 360*r*s + 194*r + 24*s**2 - 306*s + 119) + 540*r**2 + 912*r*s - 584*r + 372*s**2 - 381*s + 115) - 3*Pkd2*k2*(C*(6*r*(8*s - 1) + 48*s**2 - 8*s - 4) + 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) - 64*r*s + 33*r - 64*s**2 + 66*s - 21)) - 30*k2**4*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1))) + 252*g2*k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(5*f**2*fd*k1**2*(7*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(79*s - 39) + 948*s**2 - 1223*s + 362) + 22*k2**2*(-Pk2*(104*r**2 + r*(920*s - 241) + 816*s**2 - 714*s + 107) + 7*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(-90*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + fd*k1**2*k2**2*(-4*C*Pk2*(324*r**2 + r*(555 - 450*s) + 36*s**2 + 1386*s - 637) + 6*Pk2*(321*r**2 + 40*r*(9*s + 2) + 309*s**2 + 379*s - 263) - 15*Pkd2*k2*(4*C*(45*r*s - 21*r + 18*s**2 - 48*s + 16) - 90*r*s + 51*r - 36*s**2 + 108*s - 39)) + fd*k2**4*(Pk2*(-12*C*(156*r**2 + 504*r*s - 116*r + 60*s**2 - 223*s + 33) + 1224*r**2 + 3312*r*s - 669*r + 360*s**2 - 1164*s + 67) + Pkd2*k2*(10 - 20*C)*(3*s - 1)*(21*r + 12*s - 14)) - 6*gd2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + k1**2*k2**2*(-2*Pk2*(96*r**2 + r*(90*s - 59) - 6*s**2 + 105*s - 37) - 3*Pkd2*k2*(r*(36*s - 23) + 36*s**2 - 64*s + 23)) - 15*k2**4*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 132*fd*(15*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) - 2*k1**2*k2**2*(Pk2*(192*r**2 + 4*r*(45*s - 19) - 12*s**2 + 96*s - 45) + 3*Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 30*k2**4*(Pk2*(6*r + 2*s - 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-1980*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*f**2*k1**2*(7*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(79*s - 39) + 948*s**2 - 1223*s + 362) + 22*k2**2*(-Pk2*(104*r**2 + r*(920*s - 241) + 816*s**2 - 714*s + 107) + 7*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 25) + 12*s**2 - 39*s + 20) - 2*k1**2*k2**2*(Pk2*(4*C*(216*r**2 - 300*r*s + 356*r + 24*s**2 + 1020*s - 451) - 1284*r**2 - 1440*r*s - 289*r - 1236*s**2 - 1745*s + 1159) + 15*Pkd2*k2*(C*(120*r*s - 53*r + 48*s**2 - 138*s + 43) - 60*r*s + 33*r - 24*s**2 + 78*s - 27)) - k2**4*(2*Pk2*(2*C*(624*r**2 + 2016*r*s - 478*r + 240*s**2 - 1028*s + 73) - 816*r**2 - 2208*r*s + 487*r - 240*s**2 + 934*s + 18) + Pkd2*k2*(10*C - 5)*(7*r*(24*s - 7) + 96*s**2 - 150*s + 35))) - 132*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) - 2*k1**2*k2**2*(Pk2*(384*r**2 + 2*r*(180*s - 97) - 24*s**2 + 306*s - 119) + 9*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 30*k2**4*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**6) - D1**3*Pk3*ct**6*(126*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 3*b1*(12*C*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 5)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + D1*(f**2*fd*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 33*s + 7) + 3*k2**2*(Pk2*(r*(74 - 165*s) - 25*s + 2) + 5*Pkd2*k2*(r*(9*s - 4) + s))) - 6*f*(fd*(2*s - 1)*(5*K*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) - 168*Pk2*k1**2*s + 63*Pkd2*k1**2*k2*s - 20*Pkd2*k2**3*r + k2**2*(80*Pk2*r - 7*Pkdd2*k1**2*s)) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(-14*K*bd1 + 14*bd1 + 14*gd2)) - 84*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f**2*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(48*s**2 - 40*s + 7) + 3*k2**2*(Pk2*(-110*r*s + 56*r + 15*s - 18) + 5*Pkd2*k2*(r*(6*s - 3) - s + 1))) - 3*f*(5*K*Pkdd2*k2**4*(8*s**2 - 6*s + 1) + 168*Pk2*k1**2*s*(1 - 4*s) + 63*Pkd2*k1**2*k2*s*(4*s - 1) - 5*Pkd2*k2**3*(5*K*(8*s**2 - 6*s + 1) + 16*r*s - 6*r - 4*s + 2) + k2**2*(40*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + 7*Pkdd2*k1**2*s*(1 - 4*s))) - 42*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*(-90*b2*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 3*bd1*f**2*(240*Pk2*k1**2*s*(12*s - 7) - 90*Pkd2*k1**2*k2*s*(12*s - 7) + 15*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(-3*Pk2*(r - 1)*(55*s - 38) + 10*Pkdd2*k1**2*s*(12*s - 7))) + 2*f*(9*bd1*(5*K*Pkdd2*k2**4*s*(1 - 2*s) + 24*Pk2*k1**2*s*(2*C*(3*s - 5) + 7*s) - 9*Pkd2*k1**2*k2*s*(2*C*(3*s - 5) + 7*s) + 5*Pkd2*k2**3*(r*(4*s - 1) + (2*s - 1)*(5*K*s - 1)) + k2**2*(-20*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*s*(2*C*(3*s - 5) + 7*s))) + 5*fd*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(45*s**2 - 57*s + 14) + fd*k2**2*(-2*Pk2*(40*C*(36*s**2 - 33*s + 7) + 738*r*s - 363*r - 720*s**2 + 954*s - 199) + k2*(Pkd2*(50*C*(36*s**2 - 33*s + 7) + 396*r*s - 195*r - 900*s**2 + 963*s - 200) + Pkdd2*k2*(5 - 10*C)*(36*s**2 - 33*s + 7))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-45*bd2 + 90*gd2)*(2*s - 1)) + 36*g2*(-7*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 5*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)))) + 2*Dd*f*(f*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(60*s**2 - 71*s + 14) + k2**2*(-4*Pk2*(20*C*(48*s**2 - 40*s + 7) + 492*r*s - 232*r - 480*s**2 + 534*s - 49) + k2*(Pkd2*(50*C*(48*s**2 - 40*s + 7) + 528*r*s - 250*r - 1200*s**2 + 1116*s - 145) + Pkdd2*k2*(5 - 10*C)*(48*s**2 - 40*s + 7)))) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-45*b2 + 90*g2)*(8*s**2 - 6*s + 1))))/(315*d**2*k2**2*k3**2) + D1**3*Pk3*ct**6*(-1386*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2)) + Dd*f*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 11*b1*(3*D1*(-f**2*fd*k2**2*(-10*k1**2*(4*Pk2*(r*(165*s - 76) + 117*s**2 - 142*s + 46) - k2*(Pkd2*(165*r*s - 76*r + 45*s**2 - 43*s + 25) + Pkdd2*k2*(24*s**2 - 33*s + 7))) + 3*k2**2*(Pk2*(3*r - 1)*(20*r - 15*s + 18) + 5*Pkd2*k2*(9*r*s - 4*r + s))) + 2*f*(fd*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + k1**2*k2**2*(2*Pk2*(24*C*(r*(12*s - 13) + 18*s**2 - 25*s + 13) + K*(-687*r*s + 466*r - 528*s**2 + 360*s - 48) + 1167*r*s - 622*r + 1176*s**2 - 1092*s + 132) + 3*k2*(Pkd2*(-4*C*(r*(12*s - 13) + 27*s**2 - 25*s + 13) + K*(118*r*s - 80*r + 16*s**2 + 54*s - 31) - 198*r*s + 106*r - 166*s**2 + 167*s - 13) + Pkdd2*k2*(K*(24*s**2 - 38*s + 13) + s**2*(12*C - 10) + 5*s - 3))) + 15*k2**4*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2)))) + 21*k1**2*k2**2*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2)))) - 84*fd*g2*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + 2*Dd*f*(-f**2*k2**2*(-5*k1**2*(4*Pk2*(4*r*(165*s - 71) + 468*s**2 - 599*s + 180) - k2*(Pkd2*(660*r*s - 284*r + 180*s**2 - 275*s + 117) + 3*Pkdd2*k2*(32*s**2 - 36*s + 7))) + 9*k2**2*(Pk2*(2*r - 1)*(20*r - 15*s + 18) + 5*Pkd2*k2*(6*r*s - 3*r - s + 1))) + 3*f*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + k1**2*k2**2*(2*Pk2*(24*C*(r*(24*s - 23) + 36*s**2 - 47*s + 18) + K*(-1374*r*s + 860*r - 1056*s**2 + 999*s - 442) + 2334*r*s - 1136*r + 2352*s**2 - 2547*s + 766) + 3*k2*(Pkd2*(C*(r*(92 - 96*s) - 216*s**2 + 206*s - 72) + K*(4*r*(59*s - 37) + 32*s**2 + 22*s + 37) - 396*r*s + 194*r - 332*s**2 + 377*s - 121) + Pkdd2*k2*(4*s - 1)*(K*(12*s - 13) + s*(6*C - 5) + 3))) + 15*k2**4*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1))) - 126*g2*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1))))) + f*(D1*(2772*bd1*g2*k1**2*k2**2*(8*Pk2*(r*(2*s - 1) + s*(3*s - 3)) + k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + f**2*(3960*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 110*bd1*k1**2*k2**2*(4*Pk2*(r*(165*s - 56) + 117*s**2 - 173*s + 42) + k2*(Pkd2*(-165*r*s + 56*r - 45*s**2 + 146*s - 42) + 3*Pkdd2*k2*s*(3 - 8*s))) + 99*bd1*k2**4*(r - 1)*(Pk2*(20*r - 15*s + 18) + 5*Pkd2*k2*(3*s - 2)) - 210*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(56*s**2 - 50*s + 9) + 110*fd*k1**2*k2**2*(9*Pk2*(2*r*(63*s - 40) + 288*s**2 - 207*s + 58) + k2*(-3*Pkd2*(102*r*s - 63*r + 300*s**2 - 208*s + 52) + 7*Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 22*f*(3*bd1*(k1**4*s*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 5) + k1**2*k2**2*(Pk2*(432*C*s**2 - 528*C*s + K*(r*(394 - 687*s) - 528*s**2 + 639*s - 394) + r*(48*C*(6*s - 5) + 1167*s - 514) + 1176*s**2 - 1455*s + 754) + 3*k2*(Pkd2*(-54*C*s**2 + 62*C*s + K*(r*(59*s - 34) + 8*s**2 - 16*s + 34) + r*(-24*C*s + 20*C - 99*s + 44) - 83*s**2 + 96*s - 64) + Pkdd2*k2*s*(6*C*(s - 1) + K*(12*s - 13) - 5*s + 9))) + 15*k2**4*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 90*bd2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(k1**4*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*s**2 - 24*s + 7) + k1**2*k2**2*(-2*Pk2*(C*(81*r*(41*s - 38) + 3168*s**2 - 699*s + 538) - 5481*r*s + 4518*r - 6228*s**2 + 4719*s - 1778) + k2*(Pkd2*(2*C*(891*r*s - 810*r + 252*s**2 + 840*s - 137) - 2862*r*s + 2340*r - 2709*s**2 + 1185*s - 556) + 5*Pkdd2*k2*(3*s - 1)*(C*(24*s - 38) - 9*s + 24))) + k2**4*(2*Pk2*(6*C*(33*r**2 + r*(440 - 1116*s) - 240*s**2 + 592*s - 197) - 486*r**2 + 1755*r*(2*s - 1) + 720*s**2 - 1830*s + 779) + k2*(Pkd2*(30*C*(3*s - 1)*(72*r + 12*s - 31) - 3636*r*s + 1275*r - 540*s**2 + 1437*s - 440) + Pkdd2*k2*(10*C - 5)*(36*s**2 - 33*s + 7)))) + 6*gd2*(-3*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 5) + k1**2*k2**2*(Pk2*(r*(687*s - 394) + 528*s**2 - 639*s + 394) - 3*k2*(Pkd2*(59*r*s - 34*r + 8*s**2 - 16*s + 34) + Pkdd2*k2*s*(12*s - 13))) - 15*k2**4*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 132*fd*(-30*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + k1**2*k2**2*(-2*Pk2*(687*r*s - 466*r + 528*s**2 - 360*s + 48) + 3*k2*(Pkd2*(118*r*s - 80*r + 16*s**2 + 54*s - 31) + Pkdd2*k2*(24*s**2 - 38*s + 13))) + 15*k2**4*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1)))))) - 2*Dd*f*(1980*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 5*f**2*(-396*Pk2*k2**4*(2*r**2 - 3*r + 1) + 21*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(56*s**2 - 50*s + 9) - 11*k1**2*k2**2*(9*Pk2*(2*r*(63*s - 40) + 288*s**2 - 207*s + 58) + k2*(-3*Pkd2*(102*r*s - 63*r + 300*s**2 - 208*s + 52) + 7*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 11*f*(k1**4*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 31*s + 7) + k1**2*k2**2*(-4*Pk2*(C*(54*r*(41*s - 38) + 2112*s**2 - 659*s + 782) - 42*r*(87*s - 71) - 4152*s**2 + 3349*s - 1612) + k2*(Pkd2*(2*C*(108*r*(11*s - 10) + 336*s**2 + 950*s + 133) - 3816*r*s + 3090*r - 3612*s**2 + 1855*s - 1306) + 5*Pkdd2*k2*(4*s - 1)*(C*(24*s - 38) - 9*s + 24))) + k2**4*(4*Pk2*(2*C*(66*r**2 + r*(779 - 2232*s) - 480*s**2 + 1336*s - 431) - 324*r**2 + 18*r*(130*s - 57) + 480*s**2 - 1390*s + 619) + k2*(Pkd2*(30*C*(288*r*s - 84*r + 48*s**2 - 160*s + 43) - 4848*r*s + 1510*r - 720*s**2 + 2284*s - 675) + Pkdd2*k2*(10*C - 5)*(48*s**2 - 40*s + 7)))) - 66*g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + k1**2*k2**2*(-2*Pk2*(2*r*(687*s - 430) + 1056*s**2 - 999*s + 442) + 3*k2*(Pkd2*(4*r*(59*s - 37) + 32*s**2 + 22*s + 37) + Pkdd2*k2*(48*s**2 - 64*s + 13))) + 15*k2**4*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(3465*d**2*k2**2*k3**4) + 4*D1**3*Pk3*ct**5*f*k1*k2*st**2*(-171072*C*D1*Pk2*f*fd*k1**2*r*s + 95040*C*D1*Pk2*f*fd*k1**2*r - 171072*C*D1*Pk2*f*fd*k1**2*s**2 + 202752*C*D1*Pk2*f*fd*k1**2*s - 61248*C*D1*Pk2*f*fd*k1**2 + 58608*C*D1*Pk2*f*fd*k2**2*r**2 - 178992*C*D1*Pk2*f*fd*k2**2*r*s + 55440*C*D1*Pk2*f*fd*k2**2*r - 142560*C*D1*Pk2*f*fd*k2**2*s**2 + 211728*C*D1*Pk2*f*fd*k2**2*s - 59840*C*D1*Pk2*f*fd*k2**2 + 42768*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 23760*C*D1*Pkd2*f*fd*k1**2*k2*r + 42768*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 50688*C*D1*Pkd2*f*fd*k1**2*k2*s + 15312*C*D1*Pkd2*f*fd*k1**2*k2 + 118800*C*D1*Pkd2*f*fd*k2**3*r*s - 39600*C*D1*Pkd2*f*fd*k2**3*r + 71280*C*D1*Pkd2*f*fd*k2**3*s**2 - 102960*C*D1*Pkd2*f*fd*k2**3*s + 26400*C*D1*Pkd2*f*fd*k2**3 - 228096*C*Dd*Pk2*f**2*k1**2*r*s + 121440*C*Dd*Pk2*f**2*k1**2*r - 228096*C*Dd*Pk2*f**2*k1**2*s**2 + 278784*C*Dd*Pk2*f**2*k1**2*s - 87648*C*Dd*Pk2*f**2*k1**2 + 78144*C*Dd*Pk2*f**2*k2**2*r**2 - 238656*C*Dd*Pk2*f**2*k2**2*r*s + 50424*C*Dd*Pk2*f**2*k2**2*r - 190080*C*Dd*Pk2*f**2*k2**2*s**2 + 285296*C*Dd*Pk2*f**2*k2**2*s - 74360*C*Dd*Pk2*f**2*k2**2 + 57024*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 30360*C*Dd*Pkd2*f**2*k1**2*k2*r + 57024*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 69696*C*Dd*Pkd2*f**2*k1**2*k2*s + 21912*C*Dd*Pkd2*f**2*k1**2*k2 + 158400*C*Dd*Pkd2*f**2*k2**3*r*s - 46200*C*Dd*Pkd2*f**2*k2**3*r + 95040*C*Dd*Pkd2*f**2*k2**3*s**2 - 142560*C*Dd*Pkd2*f**2*k2**3*s + 33000*C*Dd*Pkd2*f**2*k2**3 - 372480*D1*Pk2*f**2*fd*k1**2*r*s + 129420*D1*Pk2*f**2*fd*k1**2*r - 372480*D1*Pk2*f**2*fd*k1**2*s**2 + 402840*D1*Pk2*f**2*fd*k1**2*s - 95580*D1*Pk2*f**2*fd*k1**2 + 15840*D1*Pk2*f**2*fd*k2**2*r**2 + 15840*D1*Pk2*f**2*fd*k2**2*r*s - 6820*D1*Pk2*f**2*fd*k2**2*r + 1320*D1*Pk2*f**2*fd*k2**2*s - 2860*D1*Pk2*f**2*fd*k2**2 + 171072*D1*Pk2*f*fd*k1**2*r*s - 95040*D1*Pk2*f*fd*k1**2*r + 171072*D1*Pk2*f*fd*k1**2*s**2 - 202752*D1*Pk2*f*fd*k1**2*s + 61248*D1*Pk2*f*fd*k1**2 - 76428*D1*Pk2*f*fd*k2**2*r**2 + 60192*D1*Pk2*f*fd*k2**2*r*s - 11880*D1*Pk2*f*fd*k2**2*r + 89100*D1*Pk2*f*fd*k2**2*s**2 - 124608*D1*Pk2*f*fd*k2**2*s + 37400*D1*Pk2*f*fd*k2**2 + 101376*D1*Pk2*f*gd2*k1**2*r*s - 47520*D1*Pk2*f*gd2*k1**2*r + 101376*D1*Pk2*f*gd2*k1**2*s**2 - 145728*D1*Pk2*f*gd2*k1**2*s + 47520*D1*Pk2*f*gd2*k1**2 - 47520*D1*Pk2*f*gd2*k2**2*r**2 + 47520*D1*Pk2*f*gd2*k2**2*r*s + 35640*D1*Pk2*f*gd2*k2**2*r + 95040*D1*Pk2*f*gd2*k2**2*s**2 - 71280*D1*Pk2*f*gd2*k2**2*s + 11880*D1*Pk2*f*gd2*k2**2 + 202752*D1*Pk2*fd*g2*k1**2*r*s - 123552*D1*Pk2*fd*g2*k1**2*r + 202752*D1*Pk2*fd*g2*k1**2*s**2 - 247104*D1*Pk2*fd*g2*k1**2*s + 72864*D1*Pk2*fd*g2*k1**2 - 95040*D1*Pk2*fd*g2*k2**2*r**2 + 95040*D1*Pk2*fd*g2*k2**2*r*s - 47520*D1*Pk2*fd*g2*k2**2*r + 190080*D1*Pk2*fd*g2*k2**2*s**2 - 190080*D1*Pk2*fd*g2*k2**2*s + 47520*D1*Pk2*fd*g2*k2**2 + 93120*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 32355*D1*Pkd2*f**2*fd*k1**2*k2*r + 93120*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 100710*D1*Pkd2*f**2*fd*k1**2*k2*s + 23895*D1*Pkd2*f**2*fd*k1**2*k2 - 42768*D1*Pkd2*f*fd*k1**2*k2*r*s + 23760*D1*Pkd2*f*fd*k1**2*k2*r - 42768*D1*Pkd2*f*fd*k1**2*k2*s**2 + 50688*D1*Pkd2*f*fd*k1**2*k2*s - 15312*D1*Pkd2*f*fd*k1**2*k2 - 77220*D1*Pkd2*f*fd*k2**3*r*s + 27720*D1*Pkd2*f*fd*k2**3*r - 53460*D1*Pkd2*f*fd*k2**3*s**2 + 69300*D1*Pkd2*f*fd*k2**3*s - 17820*D1*Pkd2*f*fd*k2**3 - 25344*D1*Pkd2*f*gd2*k1**2*k2*r*s + 11880*D1*Pkd2*f*gd2*k1**2*k2*r - 25344*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 36432*D1*Pkd2*f*gd2*k1**2*k2*s - 11880*D1*Pkd2*f*gd2*k1**2*k2 - 47520*D1*Pkd2*f*gd2*k2**3*r*s + 11880*D1*Pkd2*f*gd2*k2**3*r - 47520*D1*Pkd2*f*gd2*k2**3*s**2 + 47520*D1*Pkd2*f*gd2*k2**3*s - 11880*D1*Pkd2*f*gd2*k2**3 - 50688*D1*Pkd2*fd*g2*k1**2*k2*r*s + 30888*D1*Pkd2*fd*g2*k1**2*k2*r - 50688*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 61776*D1*Pkd2*fd*g2*k1**2*k2*s - 18216*D1*Pkd2*fd*g2*k1**2*k2 - 95040*D1*Pkd2*fd*g2*k2**3*r*s + 47520*D1*Pkd2*fd*g2*k2**3*r - 95040*D1*Pkd2*fd*g2*k2**3*s**2 + 95040*D1*Pkd2*fd*g2*k2**3*s - 23760*D1*Pkd2*fd*g2*k2**3 - 66*D1*bd1*f*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*f*(33*r**2 - 38*r - 33*s**2 + 14*s + 5) - 18*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*f*k2*(r*(33*s - 7) + 33*s**2 - 33*s + 7) - Pkd2*k2*(18*K - 9)*(r*(4*s - 1) + (1 - 2*s)**2))) - 372480*Dd*Pk2*f**3*k1**2*r*s + 129420*Dd*Pk2*f**3*k1**2*r - 372480*Dd*Pk2*f**3*k1**2*s**2 + 402840*Dd*Pk2*f**3*k1**2*s - 95580*Dd*Pk2*f**3*k1**2 + 15840*Dd*Pk2*f**3*k2**2*r**2 + 15840*Dd*Pk2*f**3*k2**2*r*s - 6820*Dd*Pk2*f**3*k2**2*r + 1320*Dd*Pk2*f**3*k2**2*s - 2860*Dd*Pk2*f**3*k2**2 + 228096*Dd*Pk2*f**2*k1**2*r*s - 121440*Dd*Pk2*f**2*k1**2*r + 228096*Dd*Pk2*f**2*k1**2*s**2 - 278784*Dd*Pk2*f**2*k1**2*s + 87648*Dd*Pk2*f**2*k1**2 - 101904*Dd*Pk2*f**2*k2**2*r**2 + 80256*Dd*Pk2*f**2*k2**2*r*s + 5016*Dd*Pk2*f**2*k2**2*r + 118800*Dd*Pk2*f**2*k2**2*s**2 - 161876*Dd*Pk2*f**2*k2**2*s + 45980*Dd*Pk2*f**2*k2**2 + 405504*Dd*Pk2*f*g2*k1**2*r*s - 218592*Dd*Pk2*f*g2*k1**2*r + 405504*Dd*Pk2*f*g2*k1**2*s**2 - 538560*Dd*Pk2*f*g2*k1**2*s + 167904*Dd*Pk2*f*g2*k1**2 - 190080*Dd*Pk2*f*g2*k2**2*r**2 + 190080*Dd*Pk2*f*g2*k2**2*r*s + 23760*Dd*Pk2*f*g2*k2**2*r + 380160*Dd*Pk2*f*g2*k2**2*s**2 - 332640*Dd*Pk2*f*g2*k2**2*s + 71280*Dd*Pk2*f*g2*k2**2 + 93120*Dd*Pkd2*f**3*k1**2*k2*r*s - 32355*Dd*Pkd2*f**3*k1**2*k2*r + 93120*Dd*Pkd2*f**3*k1**2*k2*s**2 - 100710*Dd*Pkd2*f**3*k1**2*k2*s + 23895*Dd*Pkd2*f**3*k1**2*k2 - 57024*Dd*Pkd2*f**2*k1**2*k2*r*s + 30360*Dd*Pkd2*f**2*k1**2*k2*r - 57024*Dd*Pkd2*f**2*k1**2*k2*s**2 + 69696*Dd*Pkd2*f**2*k1**2*k2*s - 21912*Dd*Pkd2*f**2*k1**2*k2 - 102960*Dd*Pkd2*f**2*k2**3*r*s + 32670*Dd*Pkd2*f**2*k2**3*r - 71280*Dd*Pkd2*f**2*k2**3*s**2 + 95040*Dd*Pkd2*f**2*k2**3*s - 22770*Dd*Pkd2*f**2*k2**3 - 101376*Dd*Pkd2*f*g2*k1**2*k2*r*s + 54648*Dd*Pkd2*f*g2*k1**2*k2*r - 101376*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 134640*Dd*Pkd2*f*g2*k1**2*k2*s - 41976*Dd*Pkd2*f*g2*k1**2*k2 - 190080*Dd*Pkd2*f*g2*k2**3*r*s + 71280*Dd*Pkd2*f*g2*k2**3*r - 190080*Dd*Pkd2*f*g2*k2**3*s**2 + 190080*Dd*Pkd2*f*g2*k2**3*s - 47520*Dd*Pkd2*f*g2*k2**3 - 33*b1*(D1*fd*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(6*Pk2*(f*(33*r**2 - 16*r - 33*s**2 + 25*s - 3) + (-12*r - 12*s + 6)*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(2*Pk2*f*(132*r**2 - 86*r - 132*s**2 + 89*s - 4) - 36*Pk2*(2*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 24*r**2 - 16*r*s + 18*r + 8*s**2 - 2*s - 1) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) - Pkd2*k2*(72*K - 36)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**6) - D1**3*Pk3*ct**5*f*k1*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(99*s**2 - 75*s + 14) + 18*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(f*(33*s - 14) + 36*s - 18)) + f*(D1*bd1*s*(f*(33*s - 14) + 36*s - 18) + 2*D1*fd*(27*s**2 - 24*s + 5) + 2*Dd*f*(36*s**2 - 29*s + 5)))/(21*d**2*k2*k3**2) - D1**3*Pk3*ct**5*f*k1*st**2*(D1*(5*f**2*(-33*bd1*k2**2*(-8*Pk2*(2*r*(33*s - 7) + 33*s**2 - 52*s + 14) + k2*(Pkd2*(4*r*(33*s - 7) - 33*s**2 - 62*s + 28) + Pkdd2*k2*s*(33*s - 14))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(908*s**2 - 619*s + 98) + 44*k2**2*(Pk2*(r*(224 - 540*s) + 102*s - 70) + 3*Pkd2*k2*(r*(52*s - 21) - 12*s + 7)))) + 22*f*(9*bd1*(Pk2*k1**2*s*(48*K - 48)*(13*s - 10) - Pkd2*k1**2*k2*s*(18*K - 18)*(13*s - 10) + 15*Pkd2*k2**3*(K*(r*(8*s - 2) - 20*s**2 + 6*s + 2) + r*(4 - 16*s) + 2*s**2 + 7*s - 4) + Pkdd2*k2**4*s*(30*K - 15)*(2*s - 1) + 2*k2**2*(-60*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + Pkdd2*k1**2*s*(K - 1)*(13*s - 10))) + fd*k1**2*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 219*s + 50) + fd*k2**2*(-8*Pk2*(2*C*(828*r*s - 411*r - 810*s**2 + 732*s - 109) - 2466*r*s + 1182*r + 405*s**2 - 294*s - 67) + k2*(Pkd2*(4*C*(882*r*s - 438*r - 2025*s**2 + 1794*s - 325) - 5148*r*s + 2472*r + 4455*s**2 - 3756*s + 505) + Pkdd2*k2*(60*C - 45)*(27*s**2 - 24*s + 5))) - 36*gd2*(24*Pk2*k1**2*s*(13*s - 10) + 9*Pkd2*k1**2*k2*s*(10 - 13*s) - 15*Pkd2*k2**3*(-4*r*s + r + 10*s**2 - 3*s - 1) + 15*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(60*Pk2*(-4*r*s + r + 4*s**2 - 1) + Pkdd2*k1**2*s*(13*s - 10)))) - 792*fd*g2*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + 15*k2**2*(-8*Pk2*(2*r - 2*s + 1) + k2*(Pkd2*(4*r - 10*s + 5) + Pkdd2*k2*(2*s - 1))))) + Dd*f*(5*f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(908*s**2 - 619*s + 98) + 44*k2**2*(Pk2*(r*(224 - 540*s) + 102*s - 70) + 3*Pkd2*k2*(r*(52*s - 21) - 12*s + 7))) + 22*f*(k1**2*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 269*s + 50) + k2**2*(-8*Pk2*(2*C*(1104*r*s - 517*r - 1080*s**2 + 764*s - 3) - 3288*r*s + 1469*r + 540*s**2 - 13*s - 354) + k2*(Pkd2*(4*C*(7*r*(168*s - 79) - 2700*s**2 + 2033*s - 210) - 6864*r*s + 3082*r + 5940*s**2 - 3797*s - 105) + Pkdd2*k2*(60*C - 45)*(36*s**2 - 29*s + 5)))) - 792*g2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) + 15*k2**2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))) + 33*b1*(D1*fd*(k1**2*(12*K - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 5*k2**2*(-24*Pk2*(f*(r*(66*s - 25) + 33*s**2 - 41*s + 11) + (12*s - 6)*(K*(-4*r + 4*s - 2) + 8*r + 2*s - 1)) + k2*(3*Pkd2*(f*(2*r*(66*s - 25) - 33*s**2 - 7*s + 8) + (2*s - 1)*(-12*K*(4*r - 10*s + 5) + 96*r - 12*s + 6)) + Pkdd2*k2*(f*(99*s**2 - 75*s + 14) + (1 - 2*s)**2*(18 - 36*K))))) + Dd*f*(k1**2*(12*K - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) - 5*k2**2*(-8*Pk2*(f*(r*(264*s - 89) + 132*s**2 - 175*s + 47) + r*(72 - 36*K)*(8*s - 3) + (36*s - 18)*(s*(8*K + 4) - 5)) + k2*(Pkd2*(-36*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) + f*(2*r*(264*s - 89) - 132*s**2 - 83*s + 52) + 1152*r*s - 432*r - 144*s**2 - 180*s + 126) + Pkdd2*k2*(4*s - 1)*(-72*K*s + 36*K + f*(33*s - 14) + 36*s - 18))))))/(3465*d**2*k2*k3**4) - D1**3*Pk3*ct**5*k1*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*D1*bd1*f**2*s*(3*s - 5) + b1**2*(D1*fd*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + Dd*f*(4*s - 1)*(f*(13*s - 10) + 14*s - 14)) + 2*b1*f*(D1*bd1*s*(f*(13*s - 10) + 14*s - 14) + D1*fd*(6*s**2 - 13*s + 5) + Dd*f*(12*s**2 - 23*s + 5)))/(35*d**2*k2**3) - 4*D1**3*Pk3*ct**5*(11*D1*bd1*f*k1**2*(f**2*k2**2*(5*k1**2*(4*Pk2*(27*r**2 + 6*r*(7*s - 3) + 15*s**2 + 7*s - 19) + Pkd2*k2*(3*r*(8*s - 17) + 24*s**2 - 101*s + 71)) - 18*k2**2*(Pk2*(27*r**2 - 8*r*(s + 3) - 35*s**2 + 16*s + 5) + 5*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) + 3*f*(k1**4*(6 - 6*K)*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) + 2*k1**2*k2**2*(-2*Pk2*(6*C*(r**2 + r*(5*s - 6) + 4*s**2 - 10*s + 6) + K*(-23*r**2 + 112*r*s + 65*r + 135*s**2 - 8*s - 42) + 5*r**2 - 199*r*s + 55*r - 204*s**2 + 203*s - 66) + 3*Pkd2*k2*(2*C*(3*r*s - 5*r + 3*s**2 - 9*s + 6) + K*(34*r*s + 9*r + 34*s**2 - 6*s - 9) - 51*r*s + 16*r - 51*s**2 + 56*s - 18)) + k2**4*(42*Pk2*b1*(r + s - 1) + 4*Pk2*(2*C*(11*r**2 + 113*r*s - 46*r + 18*s**2 - 81*s + 21) - K*(69*r**2 + 312*r*s - 133*r + 243*s**2 - 204*s + 64) - 82*r**2 - 133*r*s + 177*r + 33*s**2 + 138*s - 67) + 3*Pkd2*k2*(-8*C*(20*r*s - 10*r + 6*s**2 - 11*s + 5) + 48*K*r*s + 2*K*r + 48*K*s**2 - 20*K*s - 2*K + b1*(13*r*(4*s - 1) + 52*s**2 - 45*s + 3) + 36*r*s - 32*r - 20*s**2 + 4*s + 2))) - 42*k2**2*(b1*(-k1**2*(K - 1)*(2*Pk2*(2*r**2 + 2*r*(5*s - 1) + 8*s**2 - 10*s + 1) - Pkd2*k2*(6*r*s + r + s*(6*s - 7))) + 3*k2**2*(-2*Pk2*(K*(4*r*s - 3*r + 4*s**2 - 5*s + 2) + 4*r**2 + 4*r*s - 2*r - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3)))) - 2*g2*(-2*Pk2*k1**2*(r**2 + 5*r*s + s*(4*s - 4)) - 6*Pk2*k2**2*(r*(2*s - 1) + s*(2*s - 2)) + Pkd2*k1**2*k2*(3*r*s + r + s*(3*s - 3)) + 6*Pkd2*k2**3*(r*(2*s - 1) + s*(2*s - 2))))) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(14*K - 14)*(2*Pk2*(r**2 + r*(5*s - 2) + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + 3*k2**2*(2*Pk2*(28*K*(r*(s - 2) + (s - 1)**2) + f*(33*r + 33*s - 23) + 28*r**2 + 28*r*(s + 1) + 28*s - 14) + Pkd2*k2*s*(f*(52*r + 52*s - 19) + (28 - 56*K)*(r + s)))) + Dd*f*(k1**2*(14*K - 14)*(2*Pk2*(4*r**2 + r*(20*s - 6) + 16*s**2 - 18*s + 3) - Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 3*k2**2*(4*Pk2*(7*K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 5*f*(4*r + 4*s - 3) + 56*r**2 + 56*r*s - 7*r + 14*s - 21) + Pkd2*k2*(f*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3) + (14 - 28*K)*(r*(8*s - 1) + 4*s*(2*s - 1)))))) + 11*b1*k1**2*(3*D1*(f**2*fd*k2**2*(5*k1**2*(4*Pk2*(27*r**2 + 42*r*s - 9*r + 15*s**2 + 8*s - 6) + Pkd2*k2*(24*r*s - 87*r + 24*s**2 - 121*s + 61)) - 3*k2**2*(2*Pk2*(81*r**2 - 8*r*(3*s + 8) - 105*s**2 + 31*s + 13) + 5*Pkd2*k2*(r*(30*s - 11) + 30*s**2 - 30*s + 7))) - 2*f*fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(12*C*(r**2 + r*(5*s - 2) + 4*s**2 - 7*s + 1) + K*(-46*r**2 + 28*r*(8*s - 3) + 270*s**2 - 263*s + 64) + 10*r**2 - 398*r*s + 249*r - 408*s**2 + 542*s - 151) - 3*Pkd2*k2*(12*C*s**2 - 20*C*s + K*(r*(68*s - 13) + 68*s**2 - 40*s + 3) + 2*r*(6*C*s - 51*s + 19) - 102*s**2 + 103*s - 19)) + k2**4*(Pk2*(-4*C*(22*r**2 + r*(226*s - 163) + 36*s**2 - 233*s + 106) + 2*K*(138*r**2 + 624*r*s - 368*r + 486*s**2 - 507*s + 132) + 328*r**2 + 532*r*s - 521*r - 132*s**2 - 410*s + 265) - 3*Pkd2*k2*(-48*C*s**2 + 80*C*s + K*(r*(48*s - 17) + 48*s**2 - 34*s + 5) - 4*r*(40*C*s - 9*s - 7) - 20*s**2 + 17*s - 14))) + 28*f*gd2*k2**2*(k1**2*(-2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 6*s + 1) + Pkd2*k2*s*(3*r + 3*s - 4)) + 6*k2**2*(Pk2*(-2*r*s + 2*r - 2*s**2 + 3*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1))) + 28*fd*g2*k2**2*(k1**2*(-2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1) + 3*Pkd2*k2*s*(r + s)) + 12*k2**2*(-Pk2*(r*(s - 2) + (s - 1)**2) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(10*k1**2*(2*Pk2*(108*r**2 + 168*r*s - 45*r + 60*s**2 + 31*s - 37) + Pkd2*k2*(48*r*s - 156*r + 48*s**2 - 232*s + 127)) - 9*k2**2*(2*Pk2*(108*r**2 - 8*r*(4*s + 11) - 140*s**2 + 47*s + 18) + 5*Pkd2*k2*(r*(40*s - 13) + 40*s**2 - 40*s + 9))) - 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + k1**2*k2**2*(2*Pk2*(6*C*(4*r**2 + 4*r*(5*s - 3) + 16*s**2 - 30*s + 9) + K*(-92*r**2 + 448*r*s + 46*r + 540*s**2 - 279*s - 20) + 20*r**2 - 796*r*s + 335*r - 816*s**2 + 924*s - 253) - 3*Pkd2*k2*(2*C*(r*(12*s - 5) + 12*s**2 - 23*s + 6) + K*(136*r*s + 5*r + 136*s**2 - 52*s - 15) - 204*r*s + 60*r - 204*s**2 + 205*s - 43)) + k2**4*(Pk2*(-4*C*(44*r**2 + r*(452*s - 266) + 72*s**2 - 448*s + 173) + 2*K*(276*r**2 + 1248*r*s - 634*r + 972*s**2 - 915*s + 260) + 656*r**2 + 1064*r*s - 1255*r - 264*s**2 - 1072*s + 615) + 3*Pkd2*k2*(4*C*(10*r*(8*s - 1) + 24*s**2 - 46*s + 5) - 3*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) - 72*r*s - 19*r + 40*s**2 - 16*s + 20))) + 84*g2*k2**2*(k1**2*(-2*Pk2*(4*r**2 + r*(20*s - 6) + 16*s**2 - 18*s + 3) + Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 6*k2**2*(Pk2*(-8*r*s + 9*r - 8*s**2 + 12*s - 6) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(5*f**2*fd*k1**2*(704*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(r*(280*s - 257) + 280*s**2 - 500*s + 201) + 11*k1**2*k2**2*(4*Pk2*(204*r**2 - 24*r*(29*s + 1) - 900*s**2 + 757*s - 85) + 7*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) - 22*f*(fd*(Pk2*k2**6*(2 - 4*C)*(3*r - 1)*(12*r - 42*s - 23) + k1**6*(10*C - 10)*(4*Pk2 - Pkd2*k2)*(3*s + 5)*(3*r + 3*s - 2) - 3*k1**4*k2**2*(2*Pk2*(2*C*(162*r**2 - 15*r*(3*s + 17) - 297*s**2 - 60*s + 125) - 324*r**2 + 225*r*s + 390*r + 639*s**2 - 90*s - 160) + 5*Pkd2*k2*(2*C*(36*r*s + 3*r + 54*s**2 - 18*s - 5) - 99*r*s + 15*r - 117*s**2 + 75*s - 6)) + k1**2*k2**4*(-Pk2*(4*C*(171*r**2 - 4608*r*s + 387*r - 1377*s**2 + 2823*s - 424) - 1962*r**2 + 8118*r*s + 951*r + 3276*s**2 - 4908*s + 271) - 30*Pkd2*k2*(C*(18*r*s - 3*r + 36*s**2 - 12*s - 1) - (3*s - 1)*(9*r + 12*s - 4)))) + 6*k1**2*(3*Pk2*bd2*k2**4*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) + gd2*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) + k1**2*k2**2*(2*Pk2*(23*r**2 - r*(112*s + 65) - 135*s**2 + 8*s + 42) + 3*Pkd2*k2*(r*(34*s + 9) + 34*s**2 - 6*s - 9)) + k2**4*(-2*Pk2*(69*r**2 + r*(312*s - 133) + 243*s**2 - 204*s + 64) + 3*Pkd2*k2*(24*r*s + r + 24*s**2 - 10*s - 1))))) - 132*fd*k1**2*(3*Pk2*b2*k2**4*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + g2*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(46*r**2 - 224*r*s + 84*r - 270*s**2 + 263*s - 64) + 3*Pkd2*k2*(68*r*s - 13*r + 68*s**2 - 40*s + 3)) + k2**4*(-2*Pk2*(138*r**2 + 624*r*s - 368*r + 486*s**2 - 507*s + 132) + 3*Pkd2*k2*(48*r*s - 17*r + 48*s**2 - 34*s + 5))))) + Dd*f*(5*f**2*k1**2*(704*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(r*(280*s - 257) + 280*s**2 - 500*s + 201) + 11*k1**2*k2**2*(4*Pk2*(204*r**2 - 24*r*(29*s + 1) - 900*s**2 + 757*s - 85) + 7*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) - 22*f*(-Pk2*k2**6*(8*C - 4)*(24*r**2 - 21*r*(4*s + 3) + 32*s + 28) + k1**6*(10*C - 10)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s + 11) + 12*s**2 + 15*s - 17) - 3*k1**4*k2**2*(2*Pk2*(2*C*(216*r**2 - 60*r*s - 404*r - 396*s**2 - 159*s + 220) - 432*r**2 + 300*r*s + 648*r + 852*s**2 + 13*s - 310) + 5*Pkd2*k2*(4*C*(24*r*s + 4*r + 36*s**2 - 9*s - 5) - 132*r*s + 12*r - 156*s**2 + 93*s - 3)) + k1**2*k2**4*(Pk2*(-4*C*(228*r**2 - 6144*r*s + 141*r - 1836*s**2 + 3961*s - 235) + 2616*r**2 - 10824*r*s - 2371*r - 4368*s**2 + 6650*s + 495) - 30*Pkd2*k2*(2*C*(12*r*s - r + 24*s**2 - 6*s - 1) - 36*r*s + 10*r - 48*s**2 + 30*s - 5))) - 132*k1**2*(3*Pk2*b2*k2**4*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) + g2*(-3*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + k1**2*k2**2*(2*Pk2*(92*r**2 - 448*r*s - 46*r - 540*s**2 + 279*s + 20) + 3*Pkd2*k2*(136*r*s + 5*r + 136*s**2 - 52*s - 15)) + k2**4*(-2*Pk2*(276*r**2 + 1248*r*s - 634*r + 972*s**2 - 915*s + 260) + 9*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1)))))))/(3465*d**2*k1*k2*k3**6) + D1**3*Pk3*ct**5*(-9*b1**2*k1**2*k2**2*(D1*fd*(8*Pk2*(-28*K*(s - 1)*(r - s + 1) + f*(33*s - 10) + 28*r*s - 28*r + 28*s - 14) + k2*(Pkd2*f*(50 - 165*s) + 14*Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*f*k2*(33*s - 10) + 14*Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) + 2*Dd*f*(8*Pk2*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7) + k2*(-25*Pkd2*f*(4*s - 1) + 7*Pkd2*(2*K*(r*(8*s - 5) - 20*s**2 + 23*s - 3) - 2*r*(8*s - 5) - 16*s + 1) + Pkdd2*k2*(4*s - 1)*(14*K*(s - 1) + 5*f + 7)))) + b1*k1**2*(D1*(f**2*(-63*bd1*k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + fd*(-10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(45*s**2 - 57*s + 14) + 9*k2**2*(12*Pk2*(42*r*s - 37*r + 170*s**2 - 134*s + 36) + k2*(Pkd2*(-24*r*(6*s - 5) - 735*s**2 + 575*s - 142) + 5*Pkdd2*k2*(15*s**2 - 11*s + 2))))) - 6*f*(fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + k2**2*(-2*Pk2*(2*C*(14*r*(7*s - 11) - 144*s**2 + 431*s - 127) + 12*K*(26*s**2 - 33*s + 10) + 179*r*s + 40*r + 1224*s**2 - 1786*s + 464) + k2*(Pkd2*(4*C*(14*r*(2*s - 3) - 90*s**2 + 223*s - 75) + 15*K*(26*s**2 - 33*s + 10) + 86*r*s + 27*r + 972*s**2 - 1489*s + 423) + 3*Pkdd2*k2*(4*C*(6*s**2 - 13*s + 5) + K*(-26*s**2 + 33*s - 10) - 40*s**2 + 67*s - 22)))) + 21*k2**2*(-8*Pk2*bd1*(K*(r*(4*s - 2) - 4*s**2 + 3*s + 1) + r*(2 - 4*s) - 1) + 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*k2*(Pkd2*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2) + Pkdd2*k2*s*(4*K*(s - 1) + 1)) - 4*gd2*k2*(Pkd2*(r*(2*s - 1) - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1)))) + 504*fd*g2*k2**2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + Dd*f*(f**2*(-10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(60*s**2 - 71*s + 14) + 9*k2**2*(8*Pk2*(84*r*(s - 1) + 340*s**2 - 251*s + 73) + k2*(Pkd2*(-192*r*s + 180*r - 980*s**2 + 709*s - 182) + 5*Pkdd2*k2*(20*s**2 - 13*s + 2)))) - 6*f*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + k2**2*(-2*Pk2*(4*C*(14*r*(7*s - 11) - 144*s**2 + 395*s - 25) + 12*K*(52*s**2 - 53*s + 10) + 358*r*s + 74*r + 2448*s**2 - 3275*s + 584) + k2*(Pkd2*(4*C*(28*r*(2*s - 3) - 180*s**2 + 401*s - 54) + 15*K*(52*s**2 - 53*s + 10) + 172*r*s + 51*r + 1944*s**2 - 2606*s + 483) + 3*Pkdd2*k2*(4*s - 1)*(4*C*(3*s - 5) + K*(10 - 13*s) - 20*s + 22)))) + 504*g2*k2**2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1)))) + f*(D1*(bd1*f**2*k1**2*(240*Pk2*k1**2*s*(14 - 15*s) + 90*Pkd2*k1**2*k2*s*(15*s - 14) - 9*Pkd2*k2**3*(12*r*(4*s - 5) + 245*s**2 - 134*s + 40) + 45*Pkdd2*k2**4*s*(5*s - 2) + 2*k2**2*(18*Pk2*(42*r*s - 57*r + 170*s**2 - 100*s + 38) + 5*Pkdd2*k1**2*s*(14 - 15*s))) - 2*f*(fd*(5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(9*s**2 - 24*s + 7) - k1**2*k2**2*(80*C*Pk2*(45*s**2 - 57*s + 14) + 3*Pk2*(r*(507*s - 646) + 1536*s**2 - 833*s + 266) - Pkd2*k2*(50*C*(45*s**2 - 57*s + 14) + 21*r*(21*s - 25) + 1287*s**2 - 465*s + 138) + 5*Pkdd2*k2**2*(3*s - 1)*(C*(30*s - 28) + 3*s + 5)) - 2*k2**4*(3*r - 1)*(Pk2*(-276*C*s + 98*C + 15*r + 138*s - 78) + Pkd2*k2*(40*C - 20)*(3*s - 1))) + 3*k1**2*(bd1*(72*Pk2*k1**2*s*(3*s - 5) - 27*Pkd2*k1**2*k2*s*(3*s - 5) + Pkd2*k2**3*(r*(28*C*(2*s - 3) + 43*s + 12) + s**2*(-180*C + 195*K + 486) + s*(384*C - 150*K - 564) + 72) + 3*Pkdd2*k2**4*s*(4*C*(3*s - 5) + K*(10 - 13*s) - 20*s + 19) - k2**2*(Pk2*(r*(28*C*(7*s - 11) + 179*s + 34) - s**2*(288*C - 312*K - 1224) + s*(816*C - 240*K - 1551) + 274) + 3*Pkdd2*k1**2*s*(5 - 3*s))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-3*bd2 + 6*gd2)*(13*s - 10))) + 18*k1**2*k2**2*(b2*fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 2*g2*(14*bd1*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) + fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10)))) - 2*Dd*f*(f*(5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 31*s + 7) - k1**2*k2**2*(2*Pk2*(40*C*(60*s**2 - 71*s + 14) + 2*r*(507*s - 671) + 3072*s**2 - 1679*s + 772) + k2*(-Pkd2*(50*C*(60*s**2 - 71*s + 14) + 588*r*s - 725*r + 1716*s**2 - 625*s + 338) + 5*Pkdd2*k2*(4*s - 1)*(C*(30*s - 28) + 3*s + 5))) - 4*k2**4*(Pk2*(C*(-8*r*(69*s - 22) + 236*s - 78) + 30*r**2 + 23*r*(12*s - 7) - 118*s + 68) + Pkd2*k2*(10*C - 5)*(r*(24*s - 7) - 10*s + 3))) + k1**2*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-9*b2 + 18*g2)*(52*s**2 - 53*s + 10))))/(315*d**2*k1*k2**3*k3**2) + D1**3*Pk3*ct**5*(D1*(-462*b1*fd*k1**2*k2**2*(b1*(k1**2*(K - 1)*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) + 3*k2**2*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1)))) - 2*g2*(k1**2*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) + 6*k2**2*(-4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(-2*r*s + 4*r - 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2)))) + f**3*k1**2*(11*bd1*k2**2*(-80*Pk2*k1**2*(r*(48*s - 35) + 48*s**2 - 71*s + 21) + 36*Pk2*k2**2*(2*r**2 + r*(92*s + 27) + 50*s**2 - 6*s - 29) + 5*k1**2*k2*(Pkd2*(4*r*(48*s - 35) + 192*s**2 - 293*s + 84) + 3*Pkdd2*k2*s) - 9*k2**3*(Pkd2*(r*(68*s + 60) - 45*s**2 + 50*s - 60) + 5*Pkdd2*k2*s*(5*s - 2))) - 5*fd*(7*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 89*s + 18) - 11*k1**2*k2**2*(8*Pk2*(24*r*(7*s - 10) + 1380*s**2 - 997*s + 262) + k2*(Pkd2*(-384*r*s + 504*r - 4020*s**2 + 2837*s - 662) + 21*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 88*k2**4*(Pk2*(162*r**2 + r*(6*s - 200) - 57*s + 73) + 9*Pkd2*k2*(2*r - 1)*(3*s - 1)))) + 11*f**2*k2**2*(3*bd1*(2*k1**4*(2*Pk2*(48*C*s**2 + K*(r*(37*s - 137) + 576*s**2 - 485*s + 137) + r*(24*C*(s + 5) - 193*s + 197) - 792*s**2 + 929*s - 317) + k2*(-Pkd2*(K*(r*(22*s - 72) + 423*s**2 - 282*s + 72) + 2*r*(6*C*(s + 5) - 50*s + 51) + 3*s**2*(14*C - 192) + 3*s*(189 - 6*C) - 162) + 3*Pkdd2*k2*s*(2*C*(s - 1) + K*(15*s - 4) - 20*s + 11))) + k1**2*k2**2*(-2*Pk2*(-4*C*(14*r**2 - 191*r*s + 88*r - 72*s**2 + 264*s - 42) + 78*K*r**2 - 114*K*r*s + 346*K*r - 1128*K*s**2 + 1230*K*s - 424*K + 42*b1*(r + 2*s - 1) - 214*r**2 - 1673*r*s + 616*r - 480*s**2 + 1113*s - 282) + k2*(3*Pkd2*b1*(14*r - 26*s**2 + 41*s - 14) + 2*Pkd2*(4*C*(106*r*s - 30*r + 45*s**2 - 120*s + 21) - 3*K*(74*r*s - 64*r + 203*s**2 - 198*s + 64) - 421*r*s + 84*r - 39*s**2 + 351*s - 108) + 3*Pkdd2*k2*s*(-24*C*(s - 1) + 30*K*s - 8*K + 13*b1*(2*s - 1) - 10*s - 4)))) + fd*(k1**4*(-16*Pk2*(C*(9*r*(9*s + 47) - 1692*s**2 + 1749*s - 545) + 15*b1*(r*(48*s - 34) + 48*s**2 - 49*s + 22) + 54*r*s - 693*r + 1872*s**2 - 2274*s + 775) + k2*(15*Pkd2*b1*(8*r*(24*s - 17) + 192*s**2 - 25*s + 46) + 2*Pkd2*(2*C*(18*r*(3*s + 25) - 2637*s**2 + 2253*s - 614) + 18*r*(9*s - 80) + 5769*s**2 - 5916*s + 1793) - 15*Pkdd2*b1*k2*(57*s - 14) + 10*Pkdd2*k2*(3*s - 1)*(C*(42*s - 8) - 45*s + 15))) + k1**2*k2**2*(2*Pk2*(4*C*(261*r**2 + 3*r*(567*s - 790) + 3204*s**2 - 4881*s + 1843) + 18*b1*(6*r**2 + r*(276*s - 41) + 150*s**2 - 160*s + 17) - 828*r**2 + 3789*r*s + 5778*r - 4248*s**2 + 10641*s - 5330) - k2*(Pkd2*(12*C*(r*(690*s - 494) + 1173*s**2 - 1297*s + 390) + 9*b1*(2*r*(102*s + 5) - 135*s**2 + 7*s - 12) - 54*r*(5*s - 37) - 7542*s**2 + 7098*s - 2164) + 5*Pkdd2*k2*(3*s - 1)*(C*(16 - 84*s) + 9*b1*(5*s - 2) + 78*s - 26))) - 4*k2**4*(3*r - 1)*(Pk2*(C*(-108*r + 60*s + 262) + 69*r - 30*s - 160) + Pkd2*k2*(40*C - 20)*(3*s - 1))) - 12*k1**2*(3*bd2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + gd2*(k1**2*(2*Pk2*(r*(37*s - 137) + 576*s**2 - 485*s + 137) + k2*(Pkd2*(-22*r*s + 72*r - 423*s**2 + 282*s - 72) + 3*Pkdd2*k2*s*(15*s - 4))) + k2**2*(-2*Pk2*(39*r**2 + r*(173 - 57*s) - 564*s**2 + 615*s - 212) + 3*k2*(Pkd2*(-74*r*s + 64*r - 203*s**2 + 198*s - 64) + Pkdd2*k2*s*(15*s - 4)))))) + 66*f*k1**2*k2**2*(3*b1**2*fd*k2**2*(-66*Pk2*(r + 2*s - 1) + k2*(Pkd2*(33*r - 13*s**2 + 66*s - 33) + 13*Pkdd2*k2*s**2)) + b1*(-7*bd1*(k1**2*(K - 1)*(8*Pk2*(2*r*(s - 3) + 4*s**2 - 6*s + 3) + k2*(Pkd2*(-4*r*(s - 3) - 14*s**2 + 15*s - 6) + Pkdd2*k2*s*(2*s - 1))) + 3*k2**2*(-2*K*(2*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s))) + 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-8*r*s + 2*s**2 - 3*s + 2) + Pkdd2*k2**2*s*(1 - 2*s))) + fd*k1**2*(4*Pk2*(24*C*(r*(s + 3) + 2*s**2 + 2*s - 3) + K*(37*r*s - 113*r + 576*s**2 - 688*s + 200) - 193*r*s + 191*r - 792*s**2 + 976*s - 254) + k2*(-Pkd2*(12*C*(2*r*(s + 3) + 7*s**2 + 4*s - 6) + K*(44*r*s - 120*r + 846*s**2 - 895*s + 236) - 200*r*s + 198*r - 1152*s**2 + 1300*s - 335) + 3*Pkdd2*k2*(K*(30*s**2 - 23*s + 4) + s**2*(4*C - 40) + 36*s - 9))) + fd*k2**2*(2*Pk2*(2*C*(28*r**2 + r*(282 - 382*s) - 144*s**2 + 671*s - 310) - 2*K*(39*r**2 - 57*r*s + 95*r - 564*s**2 + 606*s - 162) + 214*r**2 + 1673*r*s - 1086*r + 480*s**2 - 1282*s + 542) - k2*(Pkd2*(-8*C*(2*r*(53*s - 30) + 45*s**2 - 152*s + 60) + 3*K*(4*r*(37*s - 29) + 406*s**2 - 427*s + 112) + 842*r*s - 513*r + 78*s**2 - 700*s + 288) + 3*Pkdd2*k2*(K*(-30*s**2 + 23*s - 4) + s**2*(24*C + 10) - 28*s + 7))) + 14*gd2*k1**2*(8*Pk2*(r*(s - 3) + 2*s**2 - 4*s + 3) + k2*(Pkd2*(-2*r*s + 6*r - 7*s**2 + 8*s - 6) + Pkdd2*k2*s**2)) + 84*gd2*k2**2*(2*Pk2*(-2*r**2 + r + (1 - 2*s)**2) + k2*(Pkd2*(-2*r*s + 2*r - 5*s**2 + 5*s - 2) + Pkdd2*k2*s**2))) + 14*bd1*g2*(k1**2*(8*Pk2*(r*(s - 3) + s*(2*s - 2)) + k2*(-2*Pkd2*r*(s - 3) - 7*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + 6*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))) - 2*fd*(3*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + g2*(k1**2*(4*Pk2*(r*(37*s - 113) + 576*s**2 - 688*s + 200) + k2*(Pkd2*(-44*r*s + 120*r - 846*s**2 + 895*s - 236) + 3*Pkdd2*k2*(30*s**2 - 23*s + 4))) + k2**2*(-4*Pk2*(39*r**2 - 57*r*s + 95*r - 564*s**2 + 606*s - 162) + 3*k2*(-4*Pkd2*r*(37*s - 29) - 7*Pkd2*(58*s**2 - 61*s + 16) + Pkdd2*k2*(30*s**2 - 23*s + 4))))))) + Dd*f*(-462*b1*k1**2*k2**2*(b1*(k1**2*(K - 1)*(8*Pk2*(2*r*(2*s - 5) + 8*s**2 - 12*s + 7) + k2*(Pkd2*(-8*r*s + 20*r - 28*s**2 + 27*s - 14) + Pkdd2*k2*s*(4*s - 1))) + 3*k2**2*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1)))) - 2*g2*(k1**2*(8*Pk2*(2*r*(2*s - 5) + 8*s**2 - 12*s + 7) + k2*(Pkd2*(-8*r*s + 20*r - 28*s**2 + 27*s - 14) + Pkdd2*k2*s*(4*s - 1))) + 6*k2**2*(-4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(-8*r*s + 9*r - 20*s**2 + 23*s - 8) + Pkdd2*k2*s*(4*s - 1))))) - 5*f**3*k1**2*(7*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 89*s + 18) - 11*k1**2*k2**2*(8*Pk2*(24*r*(7*s - 10) + 1380*s**2 - 997*s + 262) + k2*(Pkd2*(-384*r*s + 504*r - 4020*s**2 + 2837*s - 662) + 21*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 88*k2**4*(Pk2*(162*r**2 + r*(6*s - 200) - 57*s + 73) + 9*Pkd2*k2*(2*r - 1)*(3*s - 1))) - 11*f**2*k2**2*(2*k1**4*(8*Pk2*(2*C*(54*r*s + 297*r - 1128*s**2 + 1093*s - 358) + 5*b1*(r*(192*s - 137) + 192*s**2 - 218*s + 87) + 72*r*s - 969*r + 2496*s**2 - 2926*s + 1051) + k2*(-Pkd2*(2*C*(72*r*s + 630*r - 3516*s**2 + 2759*s - 794) + 5*b1*(r*(384*s - 274) + 384*s**2 - 184*s + 111) + 216*r*s - 2010*r + 7692*s**2 - 7463*s + 2363) + 5*Pkdd2*k2*(4*s - 1)*(C*(8 - 42*s) + 21*b1 + 45*s - 15))) + k1**2*k2**2*(-4*Pk2*(4*C*(174*r**2 + 1134*r*s - 1651*r + 2136*s**2 - 3349*s + 1344) + 18*b1*(4*r**2 + r*(184*s - 7) + 100*s**2 - 83*s - 6) - 552*r**2 + 2526*r*s + 4380*r - 2832*s**2 + 7309*s - 4018) + k2*(Pkd2*(4*C*(2*r*(1380*s - 983) + 4692*s**2 - 5237*s + 1654) + 9*b1*(r*(272*s + 70) - 180*s**2 + 57*s - 72) - 360*r*s + 2934*r - 10056*s**2 + 9226*s - 3100) + 5*Pkdd2*k2*(4*s - 1)*(-84*C*s + 16*C + 9*b1*(5*s - 2) + 78*s - 26))) + 8*k2**4*(Pk2*(-2*C*(108*r**2 - 60*r*s - 326*r + 10*s + 141) + 138*r**2 - 60*r*s - 399*r + 10*s + 170) + Pkd2*k2*(10*C - 5)*(r*(24*s - 7) - 10*s + 3))) + 33*f*k1**2*k2**2*(3*b1**2*k2**2*(-160*Pk2*(r + 2*s - 1) + k2*(Pkd2*(80*r - 52*s**2 + 173*s - 80) + 13*Pkdd2*k2*s*(4*s - 1))) + 2*b1*(k1**2*(4*Pk2*(12*C*(4*r*(s + 4) + 8*s**2 + 8*s - 11) + K*(74*r*s - 250*r + 1152*s**2 - 1173*s + 337) - 386*r*s + 388*r - 1584*s**2 + 1857*s - 511) + k2*(-Pkd2*(6*C*(8*r*(s + 4) + 28*s**2 + 13*s - 22) + K*(88*r*(s - 3) + 1692*s**2 - 1459*s + 380) - 400*r*s + 402*r - 2304*s**2 + 2368*s - 599) + 3*Pkdd2*k2*(4*s - 1)*(K*(15*s - 4) + s*(2*C - 20) + 9))) + k2**2*(2*Pk2*(4*C*(28*r**2 + r*(222 - 382*s) - 144*s**2 + 635*s - 220) + K*(-156*r**2 + 228*r*s - 536*r + 2256*s**2 - 2442*s + 748) + 428*r**2 + 3346*r*s - 1692*r + 960*s**2 - 2453*s + 874) + k2*(Pkd2*(4*C*(4*r*(106*s - 45) + 180*s**2 - 581*s + 171) - 3*K*(4*r*(74*s - 61) + 812*s**2 - 823*s + 240) - 1684*r*s + 699*r - 156*s**2 + 1475*s - 498) - 3*Pkdd2*k2*(4*s - 1)*(K*(4 - 15*s) + s*(12*C + 5) - 7)))) - 12*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) - 4*g2*(k1**2*(4*Pk2*(r*(74*s - 250) + 1152*s**2 - 1173*s + 337) + k2*(Pkd2*(-88*r*(s - 3) - 1692*s**2 + 1459*s - 380) + 3*Pkdd2*k2*(60*s**2 - 31*s + 4))) + k2**2*(-4*Pk2*(78*r**2 + r*(268 - 114*s) - 1128*s**2 + 1221*s - 374) + 3*k2*(Pkd2*(-296*r*s + 244*r - 812*s**2 + 823*s - 240) + Pkdd2*k2*(60*s**2 - 31*s + 4)))))))/(3465*d**2*k1*k2**3*k3**4) + 8*D1**3*Pk3*ct**4*f*k1**2*k2**2*st**4*(-4*Pk2 + Pkd2*k2)*(792*C*D1*f*fd*r*s - 330*C*D1*f*fd*r + 792*C*D1*f*fd*s**2 - 792*C*D1*f*fd*s + 198*C*D1*f*fd + 1056*C*Dd*f**2*r*s - 396*C*Dd*f**2*r + 1056*C*Dd*f**2*s**2 - 1056*C*Dd*f**2*s + 264*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 1624*D1*f**2*fd*r*s - 483*D1*f**2*fd*r + 1624*D1*f**2*fd*s**2 - 1624*D1*f**2*fd*s + 343*D1*f**2*fd - 792*D1*f*fd*r*s + 330*D1*f*fd*r - 792*D1*f*fd*s**2 + 792*D1*f*fd*s - 198*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 1624*Dd*f**3*r*s - 483*Dd*f**3*r + 1624*Dd*f**3*s**2 - 1624*Dd*f**3*s + 343*Dd*f**3 - 1056*Dd*f**2*r*s + 396*Dd*f**2*r - 1056*Dd*f**2*s**2 + 1056*Dd*f**2*s - 264*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(231*d**2*k3**6) - 2*D1**3*Pk3*ct**4*f*k1**2*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(116*s**2 - 69*s + 10) + 33*f*(2*s - 1)*(fd*(2*C - 2)*(3*s - 1) + s*(3*K*bd1 - 3*bd1 - 6*gd2)) - 198*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(29*s - 10) + f*(66*C - 66)*(2*s - 1) + 198*g2*(1 - 2*s)) + 99*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(231*d**2*k3**4) - 4*D1**3*Pk3*ct**4*st**2*(33*D1*bd1*f*(f**2*k2**2*(6*Pk2*k2**2*(r - 1)*(5*r + 5*s + 3) + 5*k1**2*(2*Pk2*(69*r**2 + 51*r*s - 82*r - 18*s**2 - s + 3) + Pkd2*k2*(87*r*s - 22*r + 87*s**2 - 103*s + 32))) + 2*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 2*k1**2*k2**2*(-Pk2*(6*C*(5*r**2 + 10*r*(2*s - 1) + 15*s**2 - 14*s - 1) + K*(-171*r**2 - 117*r*s + 83*r + 54*s**2 - 252*s + 88) + 255*r**2 + 417*r*s - 305*r + 162*s**2 - 132*s + 86) + 3*Pkd2*k2*(C*(5*r*(2*s - 1) + 10*s**2 - 9*s - 1) + K*(36*r*s - 23*r + 36*s**2 - 64*s + 23) - 14*r*s + 13*r - 14*s**2 + 27*s - 7)) - 45*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 84*k1**2*k2**2*(-b1*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 2772*b1**2*k1**2*k2**2*(K - 1)*(2*D1*fd*(Pk2*(r**2 + 4*r*s - 2*r + 3*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + Dd*f*(2*Pk2*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 33*b1*(D1*(f**2*fd*k2**2*(6*Pk2*k2**2*(15*r**2 + r*(15*s + 19) + 25*s - 18) + 5*k1**2*(6*Pk2*(69*r**2 + r*(51*s - 50) - 18*s**2 + 11*s + 5) + Pkd2*k2*(3*r*(87*s - 55) + 261*s**2 - 348*s + 109))) + 4*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) + k1**2*k2**2*(Pk2*(6*C*(10*r**2 + 20*r*(2*s - 1) + 30*s**2 - 23*s + 10) + K*(-342*r**2 - 234*r*s + 82*r + 108*s**2 - 276*s + 111) + 510*r**2 + 834*r*s - 466*r + 324*s**2 - 324*s + 45) - 3*Pkd2*k2*(20*C*s**2 - 3*C*s + 2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(s*(20*C - 28) + 11) - 28*s**2 + 25*s - 9)) - 45*k2**4*(2*r + 2*s - 1)*(K*Pk2*(6*r + 2*s - 1) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 42*gd2*k1**2*k2**2*(-2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 336*fd*g2*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(6*Pk2*k2**2*(20*r**2 + r*(20*s + 17) + 20*s - 21) + 5*k1**2*(4*Pk2*(138*r**2 + 2*r*(51*s - 58) - 36*s**2 + 16*s + 9) + Pkd2*k2*(r*(348*s - 187) + 348*s**2 - 451*s + 141))) + 4*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) + k1**2*k2**2*(Pk2*(6*C*(20*r**2 + 40*r*(2*s - 1) + 60*s**2 - 51*s + 14) + K*(-684*r**2 - 468*r*s + 248*r + 216*s**2 - 780*s + 287) + 1020*r**2 + 1668*r*s - 1076*r + 648*s**2 - 588*s + 181) - 3*Pkd2*k2*(C*(5*r*(8*s - 1) + 40*s**2 - 16*s - 1) + 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) + (7*s - 4)*(-8*r - 8*s + 6))) - 45*k2**4*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1))) + 168*g2*k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(884*s - 375) + 2652*s**2 - 3191*s + 863) + 22*k2**2*(-Pk2*(240*r**2 + 3*r*(2800*s - 439) + 8160*s**2 - 6730*s + 721) + 75*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 44*f*(-135*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(9*C - 9)*(4*Pk2 - Pkd2*k2)*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) + k1**2*k2**2*(-2*C*Pk2*(567*r**2 + r*(672 - 1395*s) - 558*s**2 + 2286*s - 832) + 6*Pk2*(282*r**2 + r*(117*s - 20) + 69*s**2 + 293*s - 143) - 3*Pkd2*k2*(4*C*(45*r*(5*s - 2) + 108*s**2 - 222*s + 67) - 9*r*(56*s - 25) - 270*s**2 + 528*s - 165)) + k2**4*(-2*C*Pk2*(927*r**2 + 18*r*(182*s - 45) + 405*s**2 - 1596*s + 290) + 3*Pk2*(396*r**2 + 9*r*(131*s - 30) + 135*s**2 - 495*s + 65) + Pkd2*k2*(15 - 30*C)*(3*s - 1)*(15*r + 9*s - 10))) - 3*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 2*k1**2*k2**2*(Pk2*(171*r**2 + r*(117*s - 83) - 54*s**2 + 252*s - 88) + 3*Pkd2*k2*(r*(36*s - 23) + 36*s**2 - 64*s + 23)) - 45*k2**4*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 132*fd*(45*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + 2*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) + k1**2*k2**2*(Pk2*(-342*r**2 + r*(82 - 234*s) + 108*s**2 - 276*s + 111) - 6*Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 45*k2**4*(Pk2*(6*r + 2*s - 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-5940*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(884*s - 375) + 2652*s**2 - 3191*s + 863) + 22*k2**2*(-Pk2*(240*r**2 + 3*r*(2800*s - 439) + 8160*s**2 - 6730*s + 721) + 75*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(r*(48*s - 37) + 48*s**2 - 78*s + 29) - 4*k1**2*k2**2*(Pk2*(C*(756*r**2 - 1860*r*s + 787*r - 744*s**2 + 3330*s - 1136) - 1128*r**2 - 468*r*s + 160*r - 276*s**2 - 1333*s + 611) + 3*Pkd2*k2*(C*(600*r*s - 221*r + 288*s**2 - 630*s + 175) - 336*r*s + 141*r - 180*s**2 + 375*s - 111)) + k2**4*(Pk2*(-4*C*(1236*r**2 + 48*r*(91*s - 23) + 540*s**2 - 2447*s + 275) + 3168*r**2 + 9432*r*s - 2307*r + 1080*s**2 - 4680*s + 285) + Pkd2*k2*(15 - 30*C)*(5*r*(24*s - 7) + 72*s**2 - 108*s + 25))) - 264*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) + k1**2*k2**2*(Pk2*(-684*r**2 + r*(248 - 468*s) + 216*s**2 - 780*s + 287) - 18*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 45*k2**4*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**6) + D1**3*Pk3*ct**4*(2*D1*bd1*f*(f*(2*Pk2*(r*(13*s - 47) + 12*s*(6*C*s - 10*C - 3*s + 11)) + k2*(Pkd2*r*(27 - 10*s) + 3*Pkd2*s*(C*(50 - 30*s) + 15*s - 37) + Pkdd2*k2*s*(6*C - 3)*(3*s - 5))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(21*b2 - 42*g2)*(s - 1)) + 7*b1**2*(D1*fd*(f*(Pk2*(2*r*(9*s - 10) + 15*s - 2) - 3*Pkd2*k2*(2*r*(s - 1) + s)) + (s - 1)*(6*K*(s - 1)*(8*Pk2 - 5*Pkd2*k2 + Pkdd2*k2**2) + 48*Pk2*r - 12*Pkd2*k2*r)) + 2*Dd*f*(Pk2*(24*K*(4*s**2 - 5*s + 1) + f*(18*r*s - 32*r + 15*s + 10) + 96*r*s - 60*r - 24*s + 24) - 3*k2*(K*Pkdd2*k2*(-4*s**2 + 5*s - 1) + Pkd2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2)))) + b1*(7*D1*bd1*f*(12*K*Pkdd2*k2**2*s*(s - 1) + Pk2*f*(2*r*(9*s - 22) + 15*s + 22) + 24*Pk2*(r*(4*s - 2) + (s - 1)*(4*K*s - 1)) - 3*Pkd2*k2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1))) + 2*D1*(f*(fd*(2*Pk2*(24*C*(6*s**2 - 13*s + 5) + 26*r*s - 76*r - 72*s**2 + 269*s - 85) + k2*(Pkd2*(-30*C*(6*s**2 - 13*s + 5) - 20*r*s + 45*r + 90*s**2 - 248*s + 84) + Pkdd2*k2*(6*C - 3)*(6*s**2 - 13*s + 5))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(21*bd2 - 42*gd2)*(s - 1)) - 42*fd*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f*(4*Pk2*(12*C*(12*s**2 - 23*s + 5) + 26*r*s - 85*r - 72*s**2 + 251*s - 19) + k2*(Pkd2*(-30*C*(12*s**2 - 23*s + 5) - 40*r*s + 99*r + 180*s**2 - 451*s + 57) + Pkdd2*k2*(6*C - 3)*(12*s**2 - 23*s + 5))) - 42*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 42*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d**2*k2**2) - D1**3*Pk3*ct**4*st**2*(252*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 9*b1*(D1*(f**2*fd*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(27*s**2 - 24*s + 5) + k2**2*(Pk2*(r*(198 - 435*s) - 95*s + 14) + 15*Pkd2*k2*(r*(9*s - 4) + s))) + 2*f*(fd*(2*s - 1)*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(5*s - 6) + 8*s - 4) - 15*k2**2*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + r*(16*Pk2 - 4*Pkd2*k2))) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(28*K*bd1 - 28*bd1 - 28*gd2)) - 56*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f**2*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 29*s + 5) + k2**2*(Pk2*(r*(152 - 290*s) + 25*s - 46) + 15*Pkd2*k2*(r*(6*s - 3) - s + 1))) + f*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(5*s - 6) + 8*s - 4) - 15*k2**2*(8*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-5*K*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 4*s - 2)))) - 28*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*(-270*b2*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 9*bd1*f**2*(240*Pk2*k1**2*s*(9*s - 5) - 90*Pkd2*k1**2*k2*s*(9*s - 5) + 15*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(-Pk2*(r - 1)*(145*s - 106) + 10*Pkdd2*k1**2*s*(9*s - 5))) - 504*bd1*g2*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 2*f*(9*bd1*(15*K*Pkdd2*k2**4*s*(1 - 2*s) + 48*Pk2*k1**2*s*(C*(5*s - 6) + 8*s - 4) - 18*Pkd2*k1**2*k2*s*(C*(5*s - 6) + 8*s - 4) + 15*Pkd2*k2**3*(r*(4*s - 1) + (2*s - 1)*(5*K*s - 1)) - 2*k2**2*(30*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*s*(C*(6 - 5*s) - 8*s + 4))) + 2*fd*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 219*s + 50) + fd*k2**2*(-8*Pk2*(30*C*(27*s**2 - 24*s + 5) + 423*r*s - 231*r - 405*s**2 + 417*s - 64) + k2*(Pkd2*(150*C*(27*s**2 - 24*s + 5) + 954*r*s - 516*r - 2025*s**2 + 1878*s - 335) + Pkdd2*k2*(15 - 30*C)*(27*s**2 - 24*s + 5))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-135*bd2 + 270*gd2)*(2*s - 1)) + 540*fd*g2*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))) + 2*Dd*f*(f*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 269*s + 50) - k2**2*(4*Pk2*(60*C*(36*s**2 - 29*s + 5) + 1128*r*s - 599*r - 1080*s**2 + 868*s + 9) + k2*(Pkd2*(-150*C*(36*s**2 - 29*s + 5) - 1272*r*s + 671*r + 2700*s**2 - 2101*s + 180) + Pkdd2*k2*(30*C - 15)*(36*s**2 - 29*s + 5)))) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-135*b2 + 270*g2)*(8*s**2 - 6*s + 1))))/(315*d**2*k2**2*k3**2) + D1**3*Pk3*ct**4*st**2*(-2772*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2)) + Dd*f*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 33*b1*(D1*(-3*f**2*fd*k2**2*(-10*k1**2*(4*Pk2*(r*(123*s - 55) + 87*s**2 - 104*s + 33) - k2*(Pkd2*(123*r*s - 55*r + 33*s**2 - 32*s + 18) + Pkdd2*k2*(18*s**2 - 24*s + 5))) + k2**2*(Pk2*(3*r - 1)*(20*r - 105*s + 86) + 15*Pkd2*k2*(9*r*s - 4*r + s))) + 2*f*(fd*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) + 2*k1**2*k2**2*(4*Pk2*(6*C*(r*(20*s - 17) + 30*s**2 - 37*s + 17) + K*(-333*r*s + 226*r - 180*s**2 + 96*s - 3) + 597*r*s - 358*r + 540*s**2 - 540*s + 99) + 3*k2*(-Pkd2*(C*(r*(40*s - 34) + 90*s**2 - 74*s + 34) + K*(-118*r*s + 80*r + 12*s**2 - 82*s + 38) + 206*r*s - 124*r + 156*s**2 - 165*s + 24) + Pkdd2*k2*(K*(24*s**2 - 38*s + 13) + s**2*(10*C - 8) + 5*s - 3))) + 45*k2**4*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2)))) + 42*k1**2*k2**2*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2)))) - 168*fd*g2*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + 2*Dd*f*(-f**2*k2**2*(-5*k1**2*(4*Pk2*(41*r*(12*s - 5) + 348*s**2 - 439*s + 129) - k2*(Pkd2*(41*r*(12*s - 5) + 132*s**2 - 205*s + 84) + 3*Pkdd2*k2*(24*s**2 - 26*s + 5))) + 3*k2**2*(Pk2*(2*r - 1)*(20*r - 105*s + 86) + 15*Pkd2*k2*(6*r*s - 3*r - s + 1))) + f*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + 2*k1**2*k2**2*(4*Pk2*(6*C*(r*(40*s - 29) + 60*s**2 - 69*s + 23) + K*(-666*r*s + 416*r - 360*s**2 + 363*s - 193) + 1194*r*s - 656*r + 1080*s**2 - 1287*s + 433) + 3*k2*(Pkd2*(C*(r*(58 - 80*s) - 180*s**2 + 153*s - 46) + 2*K*(2*r*(59*s - 37) - 12*s**2 + 32*s + 15) - 4*r*(103*s - 57) - 312*s**2 + 388*s - 140) + Pkdd2*k2*(4*s - 1)*(5*C*s + K*(12*s - 13) - 4*s + 3))) + 45*k2**4*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1))) - 84*g2*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1))))) + f*(D1*(5544*bd1*g2*k1**2*k2**2*(8*Pk2*(r*(2*s - 1) + s*(3*s - 3)) + k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + f**2*(11880*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 330*bd1*k1**2*k2**2*(4*Pk2*(r*(123*s - 40) + 87*s**2 - 127*s + 30) + k2*(Pkd2*(-123*r*s + 40*r - 33*s**2 + 109*s - 30) + 6*Pkdd2*k2*s*(1 - 3*s))) + 99*bd1*k2**4*(r - 1)*(Pk2*(20*r - 105*s + 86) + 15*Pkd2*k2*(3*s - 2)) - 150*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(160*s**2 - 124*s + 21) + 22*fd*k1**2*k2**2*(Pk2*(18*r*(665*s - 404) + 25440*s**2 - 18305*s + 5126) + 5*k2*(Pkd2*(-702*r*s + 405*r - 1812*s**2 + 1282*s - 322) + 15*Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 22*f*(3*bd1*(k1**4*s*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(5*s - 6) + 2*k1**2*k2**2*(-2*Pk2*(-180*C*s**2 + 192*C*s + K*(r*(333*s - 190) + 180*s**2 - 267*s + 190) + r*(-120*C*s + 72*C - 597*s + 298) - 540*s**2 + 747*s - 370) + 3*k2*(Pkd2*(-45*C*s**2 + 47*C*s + K*(r*(59*s - 34) - 6*s**2 - 9*s + 34) + r*(-20*C*s + 12*C - 103*s + 52) - 78*s**2 + 104*s - 64) + Pkdd2*k2*s*(5*C*(s - 1) + K*(12*s - 13) - 4*s + 8))) + 45*k2**4*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 270*bd2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*k1**4*(12*C - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(18*s**2 - 21*s + 5) + 2*fd*k1**2*k2**2*(-2*Pk2*(C*(3285*r*s - 2418*r + 936*s**2 - 531*s + 514) - 5229*r*s + 3498*r - 3708*s**2 + 3711*s - 1410) + k2*(Pkd2*(2*C*(r*(882*s - 645) - 522*s**2 + 756*s - 77) - 2736*r*s + 1830*r - 963*s**2 + 735*s - 444) + Pkdd2*k2*(3*s - 1)*(2*C*(84*s - 73) - 99*s + 96))) + fd*k2**4*(4*Pk2*(C*(171*r**2 + r*(3186 - 7848*s) - 1620*s**2 + 4344*s - 1477) - 432*r**2 + 6*r*(708*s - 359) + 810*s**2 - 2280*s + 964) + k2*(2*C*Pkd2*(3*s - 1)*(2472*r + 405*s - 1145) - 3*Pkd2*(6*r*(465*s - 166) + 405*s**2 - 1254*s + 395) + Pkdd2*k2*(30*C - 15)*(27*s**2 - 24*s + 5))) + 6*gd2*(-3*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(5*s - 6) + 2*k1**2*k2**2*(Pk2*(r*(666*s - 380) + 360*s**2 - 534*s + 380) - 3*k2*(Pkd2*(59*r*s - 34*r - 6*s**2 - 9*s + 34) + Pkdd2*k2*s*(12*s - 13))) - 45*k2**4*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 132*fd*(-90*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) + 2*k1**2*k2**2*(-4*Pk2*(r*(333*s - 226) + 180*s**2 - 96*s + 3) + 3*k2*(2*Pkd2*(59*r*s - 40*r - 6*s**2 + 41*s - 19) + Pkdd2*k2*(24*s**2 - 38*s + 13))) + 45*k2**4*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1)))))) - 2*Dd*f*(5940*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + f**2*(-5940*Pk2*k2**4*(2*r**2 - 3*r + 1) + 75*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(160*s**2 - 124*s + 21) - 11*k1**2*k2**2*(Pk2*(18*r*(665*s - 404) + 25440*s**2 - 18305*s + 5126) + 5*k2*(Pkd2*(-702*r*s + 405*r - 1812*s**2 + 1282*s - 322) + 15*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 11*f*(k1**4*(12*C - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(24*s**2 - 26*s + 5) + 2*k1**2*k2**2*(-4*Pk2*(C*(2190*r*s - 1586*r + 624*s**2 - 615*s + 634) - 3486*r*s + 2276*r - 2472*s**2 + 2737*s - 1232) + k2*(Pkd2*(2*C*(1176*r*s - 847*r - 696*s**2 + 780*s + 125) - 3648*r*s + 2384*r - 1284*s**2 + 1369*s - 998) + Pkdd2*k2*(4*s - 1)*(2*C*(84*s - 73) - 99*s + 96))) + k2**4*(8*Pk2*(C*(114*r**2 - 5232*r*s + 1923*r - 1080*s**2 + 3314*s - 1097) - 288*r**2 + 2832*r*s - 1297*r + 540*s**2 - 1765*s + 774) + k2*(2*C*Pkd2*(9888*r*s - 2932*r + 1620*s**2 - 5905*s + 1605) - 3*Pkd2*(r*(3720*s - 1201) + 540*s**2 - 1993*s + 600) + Pkdd2*k2*(30*C - 15)*(36*s**2 - 29*s + 5)))) - 66*g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + 2*k1**2*k2**2*(-4*Pk2*(r*(666*s - 416) + 360*s**2 - 363*s + 193) + 3*k2*(2*Pkd2*(118*r*s - 74*r - 12*s**2 + 32*s + 15) + Pkdd2*k2*(48*s**2 - 64*s + 13))) + 45*k2**4*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(3465*d**2*k2**2*k3**4) + 4*D1**3*Pk3*ct**4*(D1*(462*b1*fd*k2**2*(6*Pk2*b2*k2**4*(r + s)**2 + b1*(k1**4*(K - 1)*(2*Pk2*(2*r**2 + r*(11*s - 4) + 9*s**2 - 4*s + 2) - 7*Pkd2*k2*s*(r + s)) + k1**2*k2**2*(2*Pk2*(4*C*(r + s - 1)**2 + K*(r**2 + 10*r*s - 6*r + 9*s**2 - 6*s + 3) - 8*r**2 - 24*r*s + 16*r - 16*s**2 + 16*s - 8) - Pkd2*k2*s*(4*K - 7)*(r + s)) + 6*k2**4*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s))) - 2*g2*(k1**4*(2*Pk2*(2*r**2 + 11*r*s - 4*r + 9*s**2 - 4*s + 2) - 7*Pkd2*k2*s*(r + s)) - 2*k1**2*k2**2*(-Pk2*(r**2 + 10*r*s - 6*r + 9*s**2 - 6*s + 3) + 2*Pkd2*k2*s*(r + s)) + 6*k2**4*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + f**3*(11*bd1*k2**2*(54*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 10*k1**4*(Pk2*(30*r**2 + 36*r*s - 109*r + 6*s**2 - 95*s + 73) + Pkd2*k2*(12*r*s + 37*r + 12*s**2 + 30*s - 34)) + 9*k1**2*k2**2*(Pk2*(250*r**2 + 326*r*s - 356*r + 76*s**2 - 238*s + 94) + 5*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) - 5*fd*k1**2*(176*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(s - 14)*(4*r + 4*s - 3) + 11*k1**2*k2**2*(4*Pk2*(356*r**2 - 4*r*(67*s + 56) - 624*s**2 + 538*s - 39) + 7*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) + 11*f**2*k2**2*(36*Pk2*bd2*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 6*bd1*(k1**4*(2*Pk2*(6*C*(4*r**2 + 25*r*s - 16*r + 21*s**2 - 27*s + 6) - K*(45*r**2 + 34*r*s - 50*r - 11*s**2 + 48*s + 5) + 48*r**2 - 59*r*s + 31*r - 107*s**2 + 198*s - 43) - 3*Pkd2*k2*(2*C*(r*(17*s - 12) + 17*s**2 - 23*s + 6) + K*(37*r*s - 11*r + 37*s**2 - 44*s + 11) - 70*r*s + 40*r - 70*s**2 + 96*s - 28)) + k1**2*k2**2*(-Pk2*(4*C*(57*r**2 + 229*r*s - 90*r - 38*s**2 - 150*s + 83) + 554*K*r**2 + 632*K*r*s - 670*K*r + 78*K*s**2 - 208*K*s + 116*K + 3*b1*(24*r**2 + r*(48*s - 29) + 24*s**2 - 29*s + 5) - 955*r**2 - 1628*r*s + 1416*r - 253*s**2 + 1103*s - 661) + 3*Pkd2*k2*(2*C*(22*r*s - 4*r - 20*s**2 + 11*s + 9) - 101*K*r*s + 27*K*r - 101*K*s**2 + 108*K*s - 27*K + b1*(r*(5 - 41*s) - 41*s**2 + 34*s + 1) + 51*r*s - 29*r + 93*s**2 - 104*s + 18)) + k2**4*(-Pk2*(4*C*(4*r**2 - 154*r*s + 55*r - 18*s**2 + 54*s - 57) + 252*K*r**2 + 336*K*r*s - 350*K*r + 84*K*s**2 - 252*K*s + 98*K + 7*b1*(7*r + 3*s - 5) - 96*r**2 + 220*r*s + 48*r + 36*s**2 - 30*s + 57) + 3*Pkd2*k2*(2*C*(10*r*(2*s - 1) + 6*s**2 - 11*s + 5) - 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 10*r - 6*s**2 + 11*s - 5))) + 2*fd*k1**4*(Pk2*(-4*C*(405*r**2 + 369*r*s - 447*r - 36*s**2 + 27*s + 58) + 15*b1*(30*r**2 + r*(36*s - 83) + 6*s**2 - 73*s + 45) + 2070*r**2 + 2466*r*s - 2148*r + 396*s**2 - 312*s + 272) + 5*Pkd2*k2*(-2*C*(153*r*s - 60*r + 153*s**2 - 171*s + 43) + b1*(r*(36*s + 69) + 36*s**2 + 54*s - 49) + 297*r*s - 135*r + 297*s**2 - 351*s + 96)) + 3*fd*k1**2*k2**2*(2*Pk2*(-2*C*(1674*r**2 - 9*r*(6*s + 163) + 306*s**2 + 480*s + 115) + 3*b1*(375*r**2 + r*(489*s - 382) + 114*s**2 - 225*s + 103) + 3429*r**2 + 2556*r*s - 3456*r + 1161*s**2 - 882*s + 652) + 5*Pkd2*k2*(-4*C*(27*r*(5*s - 2) + 135*s**2 - 141*s + 35) + 3*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 414*r*s - 180*r + 414*s**2 - 450*s + 118)) + 6*fd*k2**4*(Pk2*(-2*C*(756*r**2 + 57*r*(6*s - 13) + 216*s**2 - 150*s + 151) + 9*b1*(3*r - 1)*(5*r + 5*s - 3) + 972*r**2 + 558*r*s - 906*r + 216*s**2 - 192*s + 172) + Pkd2*k2*(15 - 30*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2)) + 12*gd2*(k1**4*(2*Pk2*(45*r**2 + 34*r*s - 50*r - 11*s**2 + 48*s + 5) + 3*Pkd2*k2*(37*r*s - 11*r + 37*s**2 - 44*s + 11)) + k1**2*k2**2*(2*Pk2*(277*r**2 + 316*r*s - 335*r + 39*s**2 - 104*s + 58) + 3*Pkd2*k2*(101*r*s - 27*r + 101*s**2 - 108*s + 27)) + 7*k2**4*(2*Pk2*(18*r**2 + r*(24*s - 25) + 6*s**2 - 18*s + 7) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 33*f*k2**2*(84*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 12*Pk2*b2*fd*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - b1**2*fd*k2**2*(14*Pk2*k2**2*(4*r + 3*s - 2) + 3*k1**2*(2*Pk2*(24*r**2 + 48*r*s - 7*r + 24*s**2 - 7*s - 5) + Pkd2*k2*s*(82*r + 82*s - 27))) + 2*b1*(42*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 7*bd1*(k1**4*(2*K - 2)*(2*Pk2*(2*r**2 + r*(11*s - 6) + 9*s**2 - 7*s + 1) + Pkd2*k2*(r*(3 - 7*s) + s*(4 - 7*s))) + k1**2*k2**2*(2*Pk2*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(2*r**2 + 20*r*s - 14*r + 18*s**2 - 12*s + 3) - 16*r**2 - 48*r*s + 33*r - 32*s**2 + 31*s - 8) + Pkd2*k2*(r*(K*(7 - 8*s) + 14*s - 6) + s*(-8*K*s + K + 14*s - 8))) + 3*k2**4*(K*(2*Pk2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(2*Pk2*(6*C*(8*r**2 + 2*r*(25*s - 8) + 42*s**2 - 33*s + 8) + K*(-90*r**2 - 68*r*s + 41*r + 22*s**2 - 113*s + 51) + 96*r**2 - 118*r*s + 40*r - 214*s**2 + 293*s - 105) - 3*Pkd2*k2*(K*(2*s - 1)*(37*r + 37*s - 22) + r*(68*C*s - 140*s + 43) + (2*s - 1)*(34*C*s - 70*s + 25))) + k1**2*k2**2*(Pk2*(-4*C*(114*r**2 + r*(458*s - 277) - 76*s**2 - 427*s + 149) - 2*K*(554*r**2 + 632*r*s - 260*r + 78*s**2 + 97*s - 68) + 1910*r**2 + 3256*r*s - 2189*r + 506*s**2 - 1893*s + 594) - 3*Pkd2*k2*(80*C*s**2 + 72*C*s + K*(2*s - 1)*(101*r + 101*s - 54) + r*(-s*(88*C + 102) + 63) - 186*s**2 + 107*s - 35)) + k2**4*(-Pk2*(4*C*(8*r**2 - 4*r*(77*s + 38) - 36*s**2 + 115*s + 89) + 14*K*(36*r**2 + r*(48*s - 23) + 3*(1 - 2*s)**2) - 192*r**2 + 440*r*s + 480*r + 72*s**2 - 163*s - 222) - 6*Pkd2*k2*(7*K*(2*s - 1)*(2*r + 2*s - 1) - s*(4*C - 2)*(10*r + 3*s - 5)))) - 14*gd2*(k1**4*(2*Pk2*(2*r**2 + 11*r*s - 4*r + 9*s**2 - 5*s + 2) + Pkd2*k2*s*(-7*r - 7*s + 1)) + k1**2*k2**2*(2*Pk2*(r**2 + 10*r*s - 4*r + 9*s**2 - 3*s + 3) - Pkd2*k2*s*(4*r + 4*s + 3)) + 3*k2**4*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) - 28*bd1*g2*(k1**4*(2*Pk2*(2*r**2 + r*(11*s - 8) + s*(9*s - 9)) + Pkd2*k2*(r*(6 - 7*s) - s*(7*s - 7))) + k1**2*k2**2*(2*Pk2*(r**2 + 10*r*(s - 1) + s*(9*s - 9)) + Pkd2*k2*(r*(7 - 4*s) - s*(4*s - 4))) + 3*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + 4*fd*g2*(k1**4*(2*Pk2*(90*r**2 + 68*r*s - 41*r - 22*s**2 + 113*s - 51) + 3*Pkd2*k2*(2*s - 1)*(37*r + 37*s - 22)) + k1**2*k2**2*(2*Pk2*(554*r**2 + 632*r*s - 260*r + 78*s**2 + 97*s - 68) + 3*Pkd2*k2*(2*s - 1)*(101*r + 101*s - 54)) + 14*k2**4*(Pk2*(36*r**2 + r*(48*s - 23) + 3*(1 - 2*s)**2) + 3*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(462*b1*k2**2*(6*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(K - 1)*(2*Pk2*(8*r**2 + 4*r*(11*s - 5) + 36*s**2 - 23*s + 6) + Pkd2*k2*(r*(6 - 28*s) + s*(9 - 28*s))) + k1**2*k2**2*(2*Pk2*(4*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(4*r**2 + 8*r*(5*s - 3) + 36*s**2 - 21*s + 9) - 32*r**2 - 96*r*s + 65*r - 64*s**2 + 62*s - 24) - Pkd2*k2*(r*(K*(16*s - 7) - 28*s + 6) + s*(2*K*(8*s + 1) - 28*s + 9))) + 3*k2**4*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(k1**4*(2*Pk2*(8*r**2 + 4*r*(11*s - 5) + 36*s**2 - 23*s + 6) + Pkd2*k2*(r*(6 - 28*s) + s*(9 - 28*s))) + k1**2*k2**2*(2*Pk2*(4*r**2 + 8*r*(5*s - 3) + 36*s**2 - 21*s + 9) - Pkd2*k2*(r*(16*s - 7) + 2*s*(8*s + 1))) + 3*k2**4*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) - 5*f**3*k1**2*(176*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(s - 14)*(4*r + 4*s - 3) + 11*k1**2*k2**2*(4*Pk2*(356*r**2 - 4*r*(67*s + 56) - 624*s**2 + 538*s - 39) + 7*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) + 11*f**2*k2**2*(2*k1**4*(2*Pk2*(-2*C*(540*r**2 + 492*r*s - 655*r - 48*s**2 + 12*s + 131) + 5*b1*(60*r**2 + r*(72*s - 179) + 12*s**2 - 157*s + 104) + 1380*r**2 + 1644*r*s - 1565*r + 264*s**2 - 266*s + 282) + 5*Pkd2*k2*(-2*C*(204*r*s - 73*r + 204*s**2 - 231*s + 56) + b1*(2*r*(24*s + 53) + 48*s**2 + 84*s - 83) + 396*r*s - 168*r + 396*s**2 - 477*s + 129)) + 3*k1**2*k2**2*(2*Pk2*(-2*C*(2232*r**2 - 72*r*s - 2353*r + 408*s**2 + 636*s + 443) + 6*b1*(250*r**2 + r*(326*s - 280) + 76*s**2 - 172*s + 75) + 4572*r**2 + 3408*r*s - 5240*r + 1548*s**2 - 1355*s + 1293) + 5*Pkd2*k2*(-4*C*(180*r*s - 65*r + 180*s**2 - 189*s + 46) + 3*b1*(21*s - 10)*(4*r + 4*s - 3) + 552*r*s - 220*r + 552*s**2 - 606*s + 158)) + 6*k2**4*(Pk2*(-2*C*(1008*r**2 + 456*r*s - 1155*r + 288*s**2 - 250*s + 313) + 18*b1*(2*r - 1)*(5*r + 5*s - 3) + 1296*r**2 + 744*r*s - 1413*r + 288*s**2 - 334*s + 355) + Pkd2*k2*(30 - 60*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 33*f*k2**2*(12*Pk2*b2*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(-72*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 14*Pk2*k2**2*(11*r + 6*s - 7) + 3*Pkd2*k1**2*k2*(-2*r*(82*s - 5) - 164*s**2 + 95*s + 2)) + 2*b1*(k1**4*(2*Pk2*(6*C*(16*r**2 + 20*r*(5*s - 2) + 84*s**2 - 79*s + 18) + K*(-180*r**2 - 136*r*s + 141*r + 44*s**2 - 209*s + 41) + 192*r**2 - 236*r*s + 54*r - 428*s**2 + 641*s - 179) - 3*Pkd2*k2*(2*C*(4*r*(17*s - 3) + 68*s**2 - 51*s + 6) + K*(148*r*s - 59*r + 148*s**2 - 169*s + 44) - 280*r*s + 99*r - 280*s**2 + 288*s - 69)) + k1**2*k2**2*(Pk2*(-4*C*(228*r**2 + r*(916*s - 495) - 152*s**2 - 870*s + 303) - 2*K*(1108*r**2 + 1264*r*s - 930*r + 156*s**2 - 111*s + 48) + 3820*r**2 + 6512*r*s - 5179*r + 1012*s**2 - 4467*s + 1874) + 3*Pkd2*k2*(2*C*(r*(88*s - 4) - 80*s**2 - 52*s + 9) + K*(-404*r*s + 155*r - 404*s**2 + 425*s - 108) + 204*r*s - 113*r + 372*s**2 - 265*s + 74)) + k2**4*(-Pk2*(4*C*(16*r**2 - 8*r*(77*s + 20) - 72*s**2 + 266*s + 91) + 14*K*(72*r**2 + 96*r*s - 73*r + 24*s**2 - 48*s + 17) - 384*r**2 + 880*r*s + 807*r + 144*s**2 - 314*s - 348) + 3*Pkd2*k2*(2*C*(10*r*(8*s - 1) + 24*s**2 - 46*s + 5) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 80*r*s + 10*r - 24*s**2 + 46*s - 5))) + 4*g2*(k1**4*(Pk2*(360*r**2 + 272*r*s - 282*r - 88*s**2 + 418*s - 82) + 3*Pkd2*k2*(148*r*s - 59*r + 148*s**2 - 169*s + 44)) + k1**2*k2**2*(2*Pk2*(1108*r**2 + 1264*r*s - 930*r + 156*s**2 - 111*s + 48) + 3*Pkd2*k2*(404*r*s - 155*r + 404*s**2 - 425*s + 108)) + 14*k2**4*(Pk2*(72*r**2 + 96*r*s - 73*r + 24*s**2 - 48*s + 17) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(3465*d**2*k2**2*k3**6) + D1**3*Pk3*ct**4*(-6*b1**2*k1**2*(D1*fd*(k1**2*(8*Pk2*(-77*K*(s - 1)**2 + 3*f*(12*s**2 + 13*s - 5) - 7*s**2*(4*C - 16) - 154*s + 77) + k2*(-15*Pkd2*f*(12*s**2 + 13*s - 5) + 7*Pkd2*(37*K*(s - 1)**2 + s**2*(20*C - 62) + 74*s - 37) + 3*Pkdd2*f*k2*(12*s**2 + 13*s - 5) - 7*Pkdd2*k2*(5*K*(s - 1)**2 + s**2*(4*C - 10) + 10*s - 5))) + 7*k2**2*(6*K*Pk2*r*(r - 4*s + 4) + 3*K*Pkd2*k2*(4*r*(s - 1) + 2*s - 1) - 3*K*Pkdd2*k2**2*(2*s - 1) - 6*Pk2*r*(r + 2) + 6*Pkd2*k2*r + f*(-8*Pk2*r + Pk2 + 3*Pkd2*k2*r))) + Dd*f*(k1**2*(4*s - 1)*(8*Pk2*(-77*K*(s - 1) + 3*f*(6*s + 5) - 7*s*(4*C - 16) - 77) + k2*(-15*Pkd2*f*(6*s + 5) + 7*Pkd2*(37*K*(s - 1) + s*(20*C - 62) + 37) + 3*Pkdd2*f*k2*(6*s + 5) - 7*Pkdd2*k2*(5*K*(s - 1) + s*(4*C - 10) + 5))) + 7*k2**2*(-2*Pk2*(-12*K*(r**2 - 4*r*s + 2*r + s - 1) + 7*f*(2*r - 1) + 12*r**2 + 6*r - 6) + 3*k2*(K*Pkdd2*k2*(1 - 4*s) + Pkd2*(K*(2*r*(8*s - 5) + 3) + f*(4*r - 2) + 4*r - 2))))) + 3*b1*k1**2*(D1*(f**2*(-2*bd1*(24*Pk2*k1**2*s*(12*s + 1) - 15*Pkd2*k1**2*k2*s*(12*s + 1) + 21*Pkd2*k2**3*(3*r - 2) + k2**2*(Pk2*(91 - 140*r) + 3*Pkdd2*k1**2*s*(12*s + 1))) + 3*fd*(k1**2*(Pk2*(6*r*(3*s - 74) + 4032*s**2 - 3537*s + 950) + k2*(Pkd2*(-18*r*s + 120*r - 1548*s**2 + 1341*s - 332) + 30*Pkdd2*k2*(6*s**2 - 5*s + 1))) + k2**2*(Pk2*(252*r**2 + 15*r*s - 272*r - 145*s + 128) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2)))) + 2*f*(7*bd1*(3*K*Pkdd2*k2**4*s + 8*Pk2*k1**2*s*(C*(8*s - 4) + 22*K*(s - 1) - 32*s + 27) + Pkd2*k1**2*k2*s*(C*(20 - 40*s) - 74*K*(s - 1) + 124*s - 99) - 3*Pkd2*k2**3*(K*(r*(8*s - 4) - s + 2) + r - 1) + k2**2*(-6*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + Pkdd2*k1**2*s*(C*(8*s - 4) + 10*K*(s - 1) - 20*s + 15))) + 21*bd2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) + fd*k1**2*(4*Pk2*(8*C*(32*s**2 - 74*s + 29) + 6*K*(6*s**2 - 13*s + 5) + r*s - 74*r + 374*s**2 - 201*s + 10) + k2*(-Pkd2*(C*(508*s**2 - 970*s + 358) + 15*K*(6*s**2 - 13*s + 5) + 8*r*s - 81*r + 518*s**2 - 264*s + 10) + 3*Pkdd2*k2*(14*C*(2*s**2 - 3*s + 1) + K*(6*s**2 - 13*s + 5) + s*(16*s - 7)))) + fd*k2**2*(2*Pk2*(2*C*(2*r - 1)*(12*r + 230*s - 163) - 7*K*(r*(9*s - 8) + 12*(1 - 2*s)**2) - 48*r**2 - 796*r*s + 659*r + 230*s - 202) + 3*k2*(Pkd2*(-2*C*(72*r*(2*s - 1) - 59*s + 31) + 7*K*(2*r*(s - 1) + 5*(1 - 2*s)**2) + 200*r*s - 115*r - 59*s + 28) + Pkdd2*k2*(2*C*(13*s - 5) - 7*K*(1 - 2*s)**2 - 13*s + 5))) - 14*gd2*(88*Pk2*k1**2*s*(s - 1) - 37*Pkd2*k1**2*k2*s*(s - 1) + 3*Pkd2*k2**3*(r*(2 - 4*s) + s - 2) + 3*Pkdd2*k2**4*s + k2**2*(-6*Pk2*(r**2 - 4*r*s + r + 2*s - 2) + 5*Pkdd2*k1**2*s*(s - 1)))) + 14*fd*(3*b2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) - 2*g2*(k1**2*(88*Pk2 + k2*(-37*Pkd2 + 5*Pkdd2*k2))*(s - 1)**2 + 3*k2**2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + Pkdd2*k2**2*(2*s - 1))))) + 2*Dd*f*(21*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 3*f**2*(k1**2*(2*Pk2*(6*r*(s - 28) + 1344*s**2 - 1067*s + 266) + k2*(Pkd2*(-12*r*s + 90*r - 1032*s**2 + 808*s - 181) + 15*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(168*r**2 + 10*r*s - 179*r - 75*s + 65) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) + f*(k1**2*(4*Pk2*(8*C*(64*s**2 - 132*s + 29) + 6*K*(12*s**2 - 23*s + 5) + 2*r*s - 181*r + 748*s**2 - 294*s + 117) + k2*(-Pkd2*(2*C*(508*s**2 - 843*s + 179) + 15*K*(12*s**2 - 23*s + 5) + 16*r*s - 195*r + 1036*s**2 - 373*s + 124) + 3*Pkdd2*k2*(4*s - 1)*(14*C*(s - 1) + K*(3*s - 5) + 8*s))) + k2**2*(2*Pk2*(8*C*(2*r - 1)*(6*r + 115*s - 68) - 7*K*(18*r*s - 22*r + 96*s**2 - 93*s + 26) - 96*r**2 - 1592*r*s + 1102*r + 544*s - 464) + 3*k2*(Pkd2*(C*(-72*r*(8*s - 3) + 248*s - 98) + 7*K*(4*r*s - 6*r + 40*s**2 - 36*s + 9) + 400*r*s - 186*r - 152*s + 81) + Pkdd2*k2*(4*s - 1)*(10*C + K*(7 - 14*s) - 5)))) - 14*g2*(k1**2*(88*Pk2 + k2*(-37*Pkd2 + 5*Pkdd2*k2))*(4*s**2 - 5*s + 1) + 3*k2**2*(-8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(-16*r*s + 10*r - 3) + Pkdd2*k2*(4*s - 1)))))) + f*(3*D1*bd1*k1**2*(42*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + 3*f**2*(k1**2*(Pk2*(6*r*(s - 38) + 1344*s**2 - 731*s + 114) + k2*(Pkd2*(-6*r*s + 60*r - 516*s**2 + 275*s - 30) + 30*Pkdd2*k2*s*(2*s - 1))) + k2**2*(r - 1)*(Pk2*(84*r + 5*s - 2) + 7*Pkd2*k2*(5*s - 2))) + 2*f*(k1**2*(2*Pk2*(r*(s - 107) + s**2*(256*C + 36*K + 374) - s*(464*C + 60*K + 99) + 107) + k2*(Pkd2*(r*(57 - 4*s) - s**2*(254*C + 45*K + 259) + s*(358*C + 75*K + 62) - 57) + 3*Pkdd2*k2*s*(14*C*(s - 1) + K*(3*s - 5) + 8*s - 1))) + k2**2*(-Pk2*(7*K*(r*(9*s - 14) + 48*s**2 - 45*s + 14) + r**2*(48 - 48*C) + r*(C*(436 - 920*s) + 796*s - 428) + 6*s*(36*C - 32) + 114) + 3*k2*(Pkd2*(32*C*s + 7*K*(r*(s - 2) + 10*s**2 - 8*s + 2) + r*(-144*C*s + 36*C + 100*s - 37) - 30*s + 19) + Pkdd2*k2*s*(4*C + K*(7 - 14*s) - 2)))) + 28*g2*(-88*Pk2*k1**2*s*(s - 1) + 37*Pkd2*k1**2*k2*s*(s - 1) + 6*Pkd2*k2**3*r*(2*s - 1) + k2**2*(6*Pk2*r*(r - 4*s + 2) - 5*Pkdd2*k1**2*s*(s - 1)))) + 2*D1*(f*fd*(Pk2*k2**4*(2 - 4*C)*(9*r**2 + 12*r - 5) + k1**4*(80*C*Pk2*(9*s**2 - 24*s + 7) + 12*Pk2*(-r*(57*s + 101) + 579*s**2 - 613*s + 180) + Pkd2*k2*(-50*C*(9*s**2 - 24*s + 7) + 6*r*(24*s + 55) - 2817*s**2 + 2703*s - 714) + 5*Pkdd2*k2**2*(3*s - 1)*(2*C*(3*s - 7) + 24*s - 11)) - k1**2*k2**2*(Pk2*(2*C*(3*r*(75*s - 214) + 1944*s**2 - 1371*s + 430) - 720*r**2 + 3*r*(513*s + 388) - 1944*s**2 + 2619*s - 1136) + k2*(Pkd2*(2*C*(9*r*s + 240*r - 1242*s**2 + 870*s - 233) - 765*r*s + 93*r + 1242*s**2 - 708*s + 152) + Pkdd2*k2*(90*C - 45)*(6*s**2 - 5*s + 1)))) + 3*f*k1**2*(bd2 - 2*gd2)*(24*Pk2*k1**2*s*(3*s - 5) + 15*Pkd2*k1**2*k2*s*(5 - 3*s) + 21*Pkd2*k2**3*(r*(s - 2) + 10*s**2 - 8*s + 2) + 21*Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(-7*Pk2*(9*r*s - 14*r + 48*s**2 - 45*s + 14) + 3*Pkdd2*k1**2*s*(3*s - 5))) - 18*fd*g2*k1**4*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) + 42*fd*g2*k1**2*k2**2*(2*Pk2*(r*(9*s - 8) + 12*(1 - 2*s)**2) + 3*k2*(-2*Pkd2*r*(s - 1) - 5*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))) + 2*Dd*f*(Pk2*f*k2**4*(4 - 8*C)*(6*r**2 + 7*r - 5) + f*k1**4*(4*Pk2*(20*C*(12*s**2 - 31*s + 7) - 228*r*s - 439*r + 2316*s**2 - 2291*s + 676) + k2*(Pkd2*(-50*C*(12*s**2 - 31*s + 7) + 192*r*s + 475*r - 3756*s**2 + 3329*s - 859) + 5*Pkdd2*k2*(4*s - 1)*(2*C*(3*s - 7) + 24*s - 11))) - f*k1**2*k2**2*(2*Pk2*(2*C*(150*r*s - 478*r + 1296*s**2 - 931*s + 372) - 480*r**2 + 1026*r*s + 961*r - 1296*s**2 + 1677*s - 827) + k2*(Pkd2*(C*(24*r*s + 740*r - 3312*s**2 + 2240*s - 726) - 1020*r*s + 44*r + 1656*s**2 - 796*s + 201) + Pkdd2*k2*(90*C - 45)*(8*s**2 - 6*s + 1))) - 18*g2*k1**4*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) + 42*g2*k1**2*k2**2*(2*Pk2*(2*r*(9*s - 11) + 96*s**2 - 93*s + 26) + 3*k2*(Pkd2*(-4*r*s + 6*r - 40*s**2 + 36*s - 9) + Pkdd2*k2*(8*s**2 - 6*s + 1)))) + 6*b2*k1**2*(D1*fd*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*s**2 - 13*s + 5) - 7*k2**2*(2*Pk2*(r*(9*s - 8) + 12*(1 - 2*s)**2) + 3*k2*(-2*Pkd2*r*(s - 1) - 5*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))) + Dd*f*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(12*s**2 - 23*s + 5) - 7*k2**2*(2*Pk2*(2*r*(9*s - 11) + 96*s**2 - 93*s + 26) + 3*k2*(Pkd2*(-4*r*s + 6*r - 40*s**2 + 36*s - 9) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(315*d**2*k1**2*k2**2*k3**2) - D1**3*Pk3*ct**4*(D1*bd1*f*k1**2*(252*Pkd2*b2*k2**5*(r*(2*s - 1) + s*(2*s - 2)) + 42*b1*(k1**4*s*(2 - 2*K)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(Pk2*(-16*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(8*r**2 + 126*r*s + 52*r + 160*s**2 - 135*s - 20) + 8*r**2 + 222*r*s + 16*r + 256*s**2 - 247*s + 8) + k2*(Pkd2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(15*r*s + 6*r + 31*s**2 - 26*s - 1) - 78*r*s + 6*r - 112*s**2 + 109*s - 12) + Pkdd2*k2*s*(K*(3 - 6*s) + 8*s - 4))) + 3*k2**4*(-2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s)))) + f**2*(10*k1**4*(4*Pk2*(r*(6*s - 28) + 18*s**2 - 27*s + 14) + k2*(Pkd2*(-6*r*s + 28*r - 36*s**2 + 33*s - 14) + 2*Pkdd2*k2*s*(3*s - 1))) + 9*k1**2*k2**2*(3*Pk2*(88*r**2 - 2*r*(108*s + 89) - 208*s**2 + 117*s + 90) + k2*(Pkd2*(290*r*s + 100*r + 106*s**2 - 121*s - 100) + 10*Pkdd2*k2*s*(4*s - 1))) + 9*k2**4*(r - 1)*(Pk2*(116*r + 125*s - 90) + 7*Pkd2*k2*(5*s - 2))) - 3*f*(2*k1**4*(8*Pk2*(3*r*(s + 5) + s**2*(24*C + 32*K - 53) - s*(24*C + 58*K - 100) - 15) + k2*(Pkd2*(-6*r*(s + 5) + s**2*(-120*C - 127*K + 241) + s*(120*C + 179*K - 335) + 30) + Pkdd2*k2*s*(s - 1)*(24*C + 21*K - 45))) + 2*k1**2*k2**2*(Pk2*(-2*C*(84*r**2 + 541*r*s - 396*r - 280*s**2 - 248*s + 168) + 108*K*r**2 - 505*K*r*s - 330*K*r + 636*K*s**2 - 769*K*s + 222*K - 18*b1*(2*r*(8*s + 5) + 16*s**2 - 9*s - 4) - 98*r**2 + 1949*r*s - 834*r + 172*s**2 - 1249*s + 716) + k2*(Pkd2*(2*C*(3*r*(87*s - 34) - 145*s**2 - 89*s + 84) + 283*K*r*s + 50*K*r - 297*K*s**2 + 294*K*s - 50*K + 18*b1*(r*(8*s + 5) + 5*s**2 - 3*s - 2) - 983*r*s + 427*r - 79*s**2 + 643*s - 427) + 3*Pkdd2*k2*s*(18*C*(s - 1) + 39*K*s - 23*K + 9*b1*(2*s - 1) - 38*s + 31))) + k2**4*(Pk2*(-432*C*s + 14*K*(12*r**2 - r*(87*s + 10) - 48*s**2 + 27*s - 2) - 7*b1*(2*r*(9*s - 14) - 9*s + 20) + 4*r**2*(8*C - 142) + 4*r*(460*C*s + 42*C - 251*s + 189) + 384*s - 228) + k2*(Pkd2*(-12*C*(72*r*s - 46*r + 9*s**2 - 19*s + 28) + 630*K*r*s - 84*K*r + 252*K*s**2 - 336*K*s + 84*K + 21*b1*(2*r*(s + 1) + s - 2) + 284*r*s - 216*r + 54*s**2 + 42*s + 54) + 6*Pkdd2*k2*s*(-6*C*(s - 1) + 14*K*s - 7*K + 3*s - 3)))) + 84*g2*(2*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + k1**2*k2**2*(Pk2*(4*r**2 + 9*r*(7*s + 4) + s*(80*s - 80)) + k2*(-5*Pkd2*r*(3*s + 2) - 31*Pkd2*s*(s - 1) + 3*Pkdd2*k2*s*(s - 1))) - 3*k2**4*(-2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(4*s - 2) + 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))))) - 3*b1**2*k1**2*(D1*fd*(k1**4*s**2*(28*K - 28)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 2*k1**2*k2**2*(-6*Pk2*f*(r*(48*s + 38) + 48*s**2 + 19*s - 38) + 7*Pk2*(K*(4*r**2 + 63*r*s - 60*r + 80*s**2 - 112*s + 56) - 4*r**2 + r*s*(32*C - 111) + 64*r + s**2*(32*C - 128) + s*(152 - 32*C) - 60) + k2*(3*Pkd2*f*(r*(48*s + 38) + 30*s**2 + 19*s - 38) - 7*Pkd2*(K*(r*(15*s - 16) + 31*s**2 - 32*s + 16) + r*s*(16*C - 39) + 18*r + s**2*(16*C - 56) + s*(52 - 16*C) - 18) + Pkdd2*k2*s**2*(21*K + 54*f - 28))) + 7*k2**4*(-6*K*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) + f*(Pk2*(-18*r*s + 4*r + 9*s + 4) + 3*Pkd2*k2*s*(2*r + 1)) + 12*r*(Pk2*(r + 2) + Pkd2*k2*s))) + 2*Dd*f*(k1**4*s*(14*K - 14)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(56*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*K*(8*r**2 + 126*r*s + 4*r + 160*s**2 - 151*s + 8) - 6*f*(r*(48*s + 34) + 48*s**2 - 4*s - 25) - 56*r**2 - 1554*r*s + 154*r - 1792*s**2 + 1813*s - 210) + k2*(Pkd2*(-56*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 7*K*(60*r*s - 2*r + 124*s**2 - 105*s + 12) + 3*f*(r*(96*s + 68) + 60*s**2 + s - 50) + 1092*r*s - 196*r + 1568*s**2 - 1498*s + 238) + Pkdd2*k2*s*(4*s - 1)*(21*K + 27*f - 28))) + 7*k2**4*(Pk2*(12*K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) - f*(2*r - 1)*(9*s - 8) + 24*r**2 + 12*r - 12) - 3*k2*(K*Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + K*Pkdd2*k2*s*(4*s - 1) - Pkd2*f*(2*r*s + r + s - 1) + Pkd2*(-8*r*s + r + 2*s))))) + b1*k1**2*(D1*(f**2*fd*(10*k1**4*(12*Pk2*(6*r*s - 20*r + 18*s**2 - 9*s + 12) + k2*(-3*Pkd2*(6*r*s - 20*r + 36*s**2 + 15*s + 5) + Pkdd2*k2*(18*s**2 + 24*s - 7))) + 9*k1**2*k2**2*(Pk2*(792*r**2 - 6*r*(324*s + 65) - 1872*s**2 + 1721*s - 110) + k2*(Pkd2*(30*r*(29*s - 6) + 318*s**2 - 317*s + 78) + 30*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 9*k2**4*(Pk2*(348*r**2 + 375*r*s - 344*r - 265*s + 104) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2))) - 6*f*fd*(k1**4*(8*Pk2*(48*C*s**2 + 2*K*(32*s**2 - 74*s + 29) + 6*r*(s + 3) - 106*s**2 + 163*s - 67) + k2*(-Pkd2*(240*C*s**2 + K*(254*s**2 - 485*s + 179) + 12*r*(s + 3) - 482*s**2 + 515*s - 197) + 3*Pkdd2*k2*(7*K*(2*s**2 - 3*s + 1) + s**2*(16*C - 30) + 21*s - 7))) + k1**2*k2**2*(-2*Pk2*(C*(168*r**2 + 2*r*(541*s - 260) - 560*s**2 - 741*s + 352) - K*(108*r**2 - 505*r*s + 60*r + 636*s**2 - 1028*s + 355) + 98*r**2 - 1949*r*s + 1086*r - 172*s**2 + 1167*s - 403) + k2*(Pkd2*(2*C*(18*r*(29*s - 4) - 290*s**2 - 321*s + 72) + K*(566*r*s - 122*r - 594*s**2 + 1007*s - 355) - 1966*r*s + 713*r - 158*s**2 + 914*s - 118) + 3*Pkdd2*k2*(K*(78*s**2 - 85*s + 23) + s**2*(36*C - 76) + 49*s - 14))) + k2**4*(2*Pk2*(2*C*(2*r - 1)*(4*r + 230*s - 33) + 7*K*(12*r**2 + r*(44 - 87*s) - 12*(1 - 2*s)**2) - 284*r**2 - 502*r*s + 181*r + 251*s - 51) + k2*(Pkd2*(-12*C*(4*r*(18*s + 5) + 9*s**2 - 10*s - 20) + 42*K*r*(15*s - 7) + 63*K*(1 - 2*s)**2 + 284*r*s + 204*r + 54*s**2 - 7*s - 120) + 3*Pkdd2*k2*(7*K*(1 - 2*s)**2 + s**2*(6 - 12*C))))) + 84*f*(3*Pkd2*bd2*k2**5*s*(2*r + 2*s - 1) + gd2*(2*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*(4*r**2 + r*(63*s + 16) + 80*s**2 - 55*s - 20) + k2*(Pkd2*(-15*r*s - 2*r - 31*s**2 + 21*s + 2) + 3*Pkdd2*k2*s**2)) - 3*k2**4*(-2*Pk2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + k2*(Pkd2*(4*r*s + 2*r + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2)))) + 84*fd*(6*Pkd2*b2*k2**5*s*(r + s) + g2*(2*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*(4*r**2 + 63*r*s - 60*r + 80*s**2 - 112*s + 56) + k2*(Pkd2*(-15*r*s + 16*r - 31*s**2 + 32*s - 16) + 3*Pkdd2*k2*s**2)) - 3*k2**4*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2)))) + 2*Dd*f*(126*Pkd2*b2*k2**5*(r*(8*s - 1) + 4*s*(2*s - 1)) + f**2*(5*k1**4*(8*Pk2*(4*r*(3*s - 11) + 36*s**2 - 27*s + 25) + k2*(-Pkd2*(24*r*s - 88*r + 144*s**2 + 12*s + 29) + Pkdd2*k2*(24*s**2 + 22*s - 7))) + 9*k1**2*k2**2*(2*Pk2*(264*r**2 - 3*r*(216*s + 77) - 624*s**2 + 518*s + 40) + k2*(Pkd2*(580*r*s - 40*r + 212*s**2 - 219*s - 11) + 5*Pkdd2*k2*(16*s**2 - 16*s + 3))) + 9*k2**4*(Pk2*(232*r**2 + 250*r*s - 275*r - 195*s + 97) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) - 3*f*(k1**4*(8*Pk2*(96*C*s**2 - 24*C*s + 2*K*(64*s**2 - 132*s + 29) + 12*r*(s + 4) - 212*s**2 + 339*s - 97) + k2*(-Pkd2*(480*C*s**2 - 120*C*s + K*(508*s**2 - 843*s + 179) + 24*r*(s + 4) - 964*s**2 + 1065*s - 257) + 3*Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(8*C - 15) + 7))) + k1**2*k2**2*(-2*Pk2*(2*C*(168*r**2 + 2*r*(541*s - 307) - 560*s**2 - 837*s + 374) + K*(-216*r**2 + 1010*r*s + 270*r - 1272*s**2 + 1797*s - 577) + 196*r**2 - 3898*r*s + 1806*r - 344*s**2 + 2679*s - 1113) + k2*(Pkd2*(2*C*(12*r*(87*s - 16) - 580*s**2 - 689*s + 174) + K*(1132*r*s - 22*r - 1188*s**2 + 1595*s - 455) - 3932*r*s + 1369*r - 316*s**2 + 2403*s - 774) + 3*Pkdd2*k2*(4*s - 1)*(18*C*s + 39*K*s - 23*K - 38*s + 14))) + k2**4*(2*Pk2*(8*C*(2*r - 1)*(2*r + 115*s - 3) + 7*K*(24*r**2 - 174*r*s + 34*r - 96*s**2 + 75*s - 14) - 568*r**2 - 1004*r*s + 566*r + 586*s - 162) + k2*(Pkd2*(-6*C*(4*r*(72*s + 1) + 36*s**2 - 73*s - 22) + 21*K*(60*r*s - 18*r + 24*s**2 - 28*s + 7) + 568*r*s + 147*r + 108*s**2 - 29*s - 144) + 3*Pkdd2*k2*(4*s - 1)*(7*K*(2*s - 1) + s*(3 - 6*C))))) + 42*g2*(2*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(8*r**2 + 2*r*(63*s + 2) + 160*s**2 - 151*s + 8) + k2*(Pkd2*(-60*r*s + 2*r - 124*s**2 + 105*s - 12) + 3*Pkdd2*k2*s*(4*s - 1))) - 3*k2**4*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) + 2*f*(D1*(5*f**2*fd*k1**4*(k1**2*(Pk2*(10*r*(7*s + 40) - 3648*s**2 + 3029*s - 738) - k2*(Pkd2*(5*r*(2*s + 21) - 1416*s**2 + 1139*s - 250) + 21*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(-1296*r**2 - 90*r*s + 1305*r + 840*s**2 + 5*s - 371) + Pkd2*k2*(-810*r*s + 324*r - 480*s**2 + 685*s - 202))) + f*(fd*(Pk2*k2**6*(2 - 4*C)*(9*r**2 + 12*r - 5) - 2*k1**6*(4*Pk2*(38*C*(9*s**2 - 24*s + 7) + 45*r*s + 75*r - 297*s**2 + 957*s - 316) + k2*(-Pkd2*(C*(747*s**2 - 1452*s + 401) + 45*r*s + 75*r - 702*s**2 + 1497*s - 451) + Pkdd2*k2*(45*C - 45)*(3*s**2 - 4*s + 1))) + k1**4*k2**2*(-2*Pk2*(3*C*(474*r**2 - r*(1017*s + 754) + 1056*s**2 - 2651*s + 1078) - 2529*r**2 + 4581*r*s + 1653*r + 576*s**2 + 3957*s - 2162) + k2*(Pkd2*(6*C*(r*(68 - 843*s) + 519*s**2 - 743*s + 261) + 7344*r*s - 2358*r + 693*s**2 - 435*s + 38) - 5*Pkdd2*k2*(3*s - 1)*(2*C*(51*s - 29) - 78*s + 47))) + k1**2*k2**4*(C*Pk2*(-6120*r**2 + 18*r*(1415*s + 158) + 3888*s**2 - 11802*s + 404) + 9*Pk2*(648*r**2 - r*(1323*s + 416) - 216*s**2 + 461*s + 84) + Pkd2*k2*(-2*C*(3*r*(867*s - 292) + 918*s**2 - 1434*s + 379) + 3*r*(1119*s - 403) + 918*s**2 - 1596*s + 460) + Pkdd2*k2**2*(45 - 90*C)*(6*s**2 - 5*s + 1))) + 6*k1**2*(3*bd2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) - 7*bd2*k2**4*(-2*Pk2*(2*r*(6*s - 1) + 12*s**2 - 9*s + 2) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + gd2*k1**4*s*(16*Pk2*(16*s - 29) + k2*(Pkd2*(179 - 127*s) + 21*Pkdd2*k2*(s - 1))) + gd2*k1**2*k2**2*(Pk2*(108*r**2 - 5*r*(101*s + 66) + 636*s**2 - 769*s + 222) + k2*(Pkd2*(283*r*s + 50*r - 297*s**2 + 294*s - 50) + 3*Pkdd2*k2*s*(39*s - 23))) + 7*gd2*k2**4*(Pk2*(12*r**2 - r*(87*s + 10) - 48*s**2 + 27*s - 2) + 3*k2*(Pkd2*(15*r*s - 2*r + 6*s**2 - 8*s + 2) + Pkdd2*k2*s*(2*s - 1))))) + 6*fd*k1**2*(3*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) - 14*b2*k2**4*(Pk2*r*(13 - 24*s) - 6*Pk2*(1 - 2*s)**2 + 3*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)) + g2*k1**4*(2*s - 1)*(16*Pk2*(16*s - 29) + k2*(Pkd2*(179 - 127*s) + 21*Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(2*Pk2*(108*r**2 + r*(60 - 505*s) + 636*s**2 - 1028*s + 355) + k2*(Pkd2*(566*r*s - 122*r - 594*s**2 + 1007*s - 355) + 3*Pkdd2*k2*(78*s**2 - 85*s + 23))) + 7*g2*k2**4*(2*Pk2*(12*r**2 + r*(44 - 87*s) - 12*(1 - 2*s)**2) + 3*k2*(2*Pkd2*r*(15*s - 7) + 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2)))) + Dd*f*(5*f**2*k1**4*(k1**2*(Pk2*(10*r*(7*s + 40) - 3648*s**2 + 3029*s - 738) - k2*(Pkd2*(5*r*(2*s + 21) - 1416*s**2 + 1139*s - 250) + 21*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(-1296*r**2 - 90*r*s + 1305*r + 840*s**2 + 5*s - 371) + Pkd2*k2*(-810*r*s + 324*r - 480*s**2 + 685*s - 202))) + f*(Pk2*k2**6*(4 - 8*C)*(6*r**2 + 7*r - 5) - 2*k1**6*(4*Pk2*(38*C*(12*s**2 - 31*s + 7) + 10*r*(6*s + 11) - 396*s**2 + 1253*s - 351) + k2*(-Pkd2*(C*(996*s**2 - 1853*s + 401) + 10*r*(6*s + 11) - 936*s**2 + 1928*s - 486) + Pkdd2*k2*(45*C - 45)*(4*s**2 - 5*s + 1))) + k1**4*k2**2*(-4*Pk2*(C*(948*r**2 - 2*r*(1017*s + 920) + 2112*s**2 - 5135*s + 2089) - 1686*r**2 + 3054*r*s + 1571*r + 384*s**2 + 2537*s - 1404) + k2*(Pkd2*(C*(-6744*r*s + 164*r + 4152*s**2 - 5234*s + 1810) + 9792*r*s - 2739*r + 924*s**2 - 1325*s + 419) - 5*Pkdd2*k2*(4*s - 1)*(2*C*(51*s - 29) - 78*s + 47))) + k1**2*k2**4*(-4*C*Pk2*(2040*r**2 - 6*r*(1415*s + 302) - 1296*s**2 + 4193*s + 490) + 18*Pk2*(432*r**2 - r*(882*s + 407) - 144*s**2 + 327*s + 133) + k2*(Pkd2*(-2*C*(3468*r*s - 998*r + 1224*s**2 - 2048*s + 501) + 4476*r*s - 1412*r + 1224*s**2 - 2372*s + 663) + Pkdd2*k2*(45 - 90*C)*(8*s**2 - 6*s + 1)))) + 6*k1**2*(3*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) - 14*b2*k2**4*(Pk2*(r*(17 - 48*s) - 48*s**2 + 42*s - 10) + 3*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + g2*k1**4*(4*s - 1)*(16*Pk2*(16*s - 29) + k2*(Pkd2*(179 - 127*s) + 21*Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(2*Pk2*(216*r**2 - 10*r*(101*s + 27) + 1272*s**2 - 1797*s + 577) + k2*(Pkd2*(1132*r*s - 22*r - 1188*s**2 + 1595*s - 455) + 3*Pkdd2*k2*(156*s**2 - 131*s + 23))) + 7*g2*k2**4*(2*Pk2*(24*r**2 + r*(34 - 174*s) - 96*s**2 + 75*s - 14) + 3*k2*(Pkd2*(60*r*s - 18*r + 24*s**2 - 28*s + 7) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(315*d**2*k1**2*k2**2*k3**4) + 4*D1**3*Pk3*ct**3*f*k1*k2*st**4*(-76032*C*D1*Pk2*f*fd*k1**2*r*s + 31680*C*D1*Pk2*f*fd*k1**2*r - 76032*C*D1*Pk2*f*fd*k1**2*s**2 + 76032*C*D1*Pk2*f*fd*k1**2*s - 19008*C*D1*Pk2*f*fd*k1**2 + 38016*C*D1*Pk2*f*fd*k2**2*r**2 - 104544*C*D1*Pk2*f*fd*k2**2*r*s + 24552*C*D1*Pk2*f*fd*k2**2*r - 95040*C*D1*Pk2*f*fd*k2**2*s**2 + 123552*C*D1*Pk2*f*fd*k2**2*s - 31416*C*D1*Pk2*f*fd*k2**2 + 19008*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 7920*C*D1*Pkd2*f*fd*k1**2*k2*r + 19008*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 19008*C*D1*Pkd2*f*fd*k1**2*k2*s + 4752*C*D1*Pkd2*f*fd*k1**2*k2 + 71280*C*D1*Pkd2*f*fd*k2**3*r*s - 23760*C*D1*Pkd2*f*fd*k2**3*r + 47520*C*D1*Pkd2*f*fd*k2**3*s**2 - 63360*C*D1*Pkd2*f*fd*k2**3*s + 15840*C*D1*Pkd2*f*fd*k2**3 - 101376*C*Dd*Pk2*f**2*k1**2*r*s + 39600*C*Dd*Pk2*f**2*k1**2*r - 101376*C*Dd*Pk2*f**2*k1**2*s**2 + 104544*C*Dd*Pk2*f**2*k1**2*s - 26928*C*Dd*Pk2*f**2*k1**2 + 50688*C*Dd*Pk2*f**2*k2**2*r**2 - 139392*C*Dd*Pk2*f**2*k2**2*r*s + 18216*C*Dd*Pk2*f**2*k2**2*r - 126720*C*Dd*Pk2*f**2*k2**2*s**2 + 165264*C*Dd*Pk2*f**2*k2**2*s - 37752*C*Dd*Pk2*f**2*k2**2 + 25344*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 9900*C*Dd*Pkd2*f**2*k1**2*k2*r + 25344*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 26136*C*Dd*Pkd2*f**2*k1**2*k2*s + 6732*C*Dd*Pkd2*f**2*k1**2*k2 + 95040*C*Dd*Pkd2*f**2*k2**3*r*s - 27720*C*Dd*Pkd2*f**2*k2**3*r + 63360*C*Dd*Pkd2*f**2*k2**3*s**2 - 87120*C*Dd*Pkd2*f**2*k2**3*s + 19800*C*Dd*Pkd2*f**2*k2**3 - 294720*D1*Pk2*f**2*fd*k1**2*r*s + 95460*D1*Pk2*f**2*fd*k1**2*r - 294720*D1*Pk2*f**2*fd*k1**2*s**2 + 309240*D1*Pk2*f**2*fd*k1**2*s - 69780*D1*Pk2*f**2*fd*k1**2 + 5280*D1*Pk2*f**2*fd*k2**2*r**2 + 5280*D1*Pk2*f**2*fd*k2**2*r*s + 5500*D1*Pk2*f**2*fd*k2**2*r + 6600*D1*Pk2*f**2*fd*k2**2*s - 6380*D1*Pk2*f**2*fd*k2**2 + 76032*D1*Pk2*f*fd*k1**2*r*s - 31680*D1*Pk2*f*fd*k1**2*r + 76032*D1*Pk2*f*fd*k1**2*s**2 - 76032*D1*Pk2*f*fd*k1**2*s + 19008*D1*Pk2*f*fd*k1**2 - 49896*D1*Pk2*f*fd*k2**2*r**2 + 33264*D1*Pk2*f*fd*k2**2*r*s + 3168*D1*Pk2*f*fd*k2**2*r + 59400*D1*Pk2*f*fd*k2**2*s**2 - 70092*D1*Pk2*f*fd*k2**2*s + 17556*D1*Pk2*f*fd*k2**2 + 50688*D1*Pk2*f*gd2*k1**2*r*s - 23760*D1*Pk2*f*gd2*k1**2*r + 50688*D1*Pk2*f*gd2*k1**2*s**2 - 72864*D1*Pk2*f*gd2*k1**2*s + 23760*D1*Pk2*f*gd2*k1**2 - 47520*D1*Pk2*f*gd2*k2**2*r**2 + 47520*D1*Pk2*f*gd2*k2**2*r*s + 35640*D1*Pk2*f*gd2*k2**2*r + 95040*D1*Pk2*f*gd2*k2**2*s**2 - 71280*D1*Pk2*f*gd2*k2**2*s + 11880*D1*Pk2*f*gd2*k2**2 + 101376*D1*Pk2*fd*g2*k1**2*r*s - 61776*D1*Pk2*fd*g2*k1**2*r + 101376*D1*Pk2*fd*g2*k1**2*s**2 - 123552*D1*Pk2*fd*g2*k1**2*s + 36432*D1*Pk2*fd*g2*k1**2 - 95040*D1*Pk2*fd*g2*k2**2*r**2 + 95040*D1*Pk2*fd*g2*k2**2*r*s - 47520*D1*Pk2*fd*g2*k2**2*r + 190080*D1*Pk2*fd*g2*k2**2*s**2 - 190080*D1*Pk2*fd*g2*k2**2*s + 47520*D1*Pk2*fd*g2*k2**2 + 73680*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 23865*D1*Pkd2*f**2*fd*k1**2*k2*r + 73680*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 77310*D1*Pkd2*f**2*fd*k1**2*k2*s + 17445*D1*Pkd2*f**2*fd*k1**2*k2 - 19008*D1*Pkd2*f*fd*k1**2*k2*r*s + 7920*D1*Pkd2*f*fd*k1**2*k2*r - 19008*D1*Pkd2*f*fd*k1**2*k2*s**2 + 19008*D1*Pkd2*f*fd*k1**2*k2*s - 4752*D1*Pkd2*f*fd*k1**2*k2 - 47520*D1*Pkd2*f*fd*k2**3*r*s + 16830*D1*Pkd2*f*fd*k2**3*r - 35640*D1*Pkd2*f*fd*k2**3*s**2 + 43560*D1*Pkd2*f*fd*k2**3*s - 10890*D1*Pkd2*f*fd*k2**3 - 12672*D1*Pkd2*f*gd2*k1**2*k2*r*s + 5940*D1*Pkd2*f*gd2*k1**2*k2*r - 12672*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 18216*D1*Pkd2*f*gd2*k1**2*k2*s - 5940*D1*Pkd2*f*gd2*k1**2*k2 - 47520*D1*Pkd2*f*gd2*k2**3*r*s + 11880*D1*Pkd2*f*gd2*k2**3*r - 47520*D1*Pkd2*f*gd2*k2**3*s**2 + 47520*D1*Pkd2*f*gd2*k2**3*s - 11880*D1*Pkd2*f*gd2*k2**3 - 25344*D1*Pkd2*fd*g2*k1**2*k2*r*s + 15444*D1*Pkd2*fd*g2*k1**2*k2*r - 25344*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 30888*D1*Pkd2*fd*g2*k1**2*k2*s - 9108*D1*Pkd2*fd*g2*k1**2*k2 - 95040*D1*Pkd2*fd*g2*k2**3*r*s + 47520*D1*Pkd2*fd*g2*k2**3*r - 95040*D1*Pkd2*fd*g2*k2**3*s**2 + 95040*D1*Pkd2*fd*g2*k2**3*s - 23760*D1*Pkd2*fd*g2*k2**3 - 66*D1*bd1*f*(k1**2*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*f*(33*r**2 - 38*r - 33*s**2 + 14*s + 5) - 18*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*f*k2*(r*(33*s - 7) + 33*s**2 - 33*s + 7) - Pkd2*k2*(18*K - 9)*(r*(4*s - 1) + (1 - 2*s)**2))) - 294720*Dd*Pk2*f**3*k1**2*r*s + 95460*Dd*Pk2*f**3*k1**2*r - 294720*Dd*Pk2*f**3*k1**2*s**2 + 309240*Dd*Pk2*f**3*k1**2*s - 69780*Dd*Pk2*f**3*k1**2 + 5280*Dd*Pk2*f**3*k2**2*r**2 + 5280*Dd*Pk2*f**3*k2**2*r*s + 5500*Dd*Pk2*f**3*k2**2*r + 6600*Dd*Pk2*f**3*k2**2*s - 6380*Dd*Pk2*f**3*k2**2 + 101376*Dd*Pk2*f**2*k1**2*r*s - 39600*Dd*Pk2*f**2*k1**2*r + 101376*Dd*Pk2*f**2*k1**2*s**2 - 104544*Dd*Pk2*f**2*k1**2*s + 26928*Dd*Pk2*f**2*k1**2 - 66528*Dd*Pk2*f**2*k2**2*r**2 + 44352*Dd*Pk2*f**2*k2**2*r*s + 17424*Dd*Pk2*f**2*k2**2*r + 79200*Dd*Pk2*f**2*k2**2*s**2 - 90024*Dd*Pk2*f**2*k2**2*s + 19932*Dd*Pk2*f**2*k2**2 + 202752*Dd*Pk2*f*g2*k1**2*r*s - 109296*Dd*Pk2*f*g2*k1**2*r + 202752*Dd*Pk2*f*g2*k1**2*s**2 - 269280*Dd*Pk2*f*g2*k1**2*s + 83952*Dd*Pk2*f*g2*k1**2 - 190080*Dd*Pk2*f*g2*k2**2*r**2 + 190080*Dd*Pk2*f*g2*k2**2*r*s + 23760*Dd*Pk2*f*g2*k2**2*r + 380160*Dd*Pk2*f*g2*k2**2*s**2 - 332640*Dd*Pk2*f*g2*k2**2*s + 71280*Dd*Pk2*f*g2*k2**2 + 73680*Dd*Pkd2*f**3*k1**2*k2*r*s - 23865*Dd*Pkd2*f**3*k1**2*k2*r + 73680*Dd*Pkd2*f**3*k1**2*k2*s**2 - 77310*Dd*Pkd2*f**3*k1**2*k2*s + 17445*Dd*Pkd2*f**3*k1**2*k2 - 25344*Dd*Pkd2*f**2*k1**2*k2*r*s + 9900*Dd*Pkd2*f**2*k1**2*k2*r - 25344*Dd*Pkd2*f**2*k1**2*k2*s**2 + 26136*Dd*Pkd2*f**2*k1**2*k2*s - 6732*Dd*Pkd2*f**2*k1**2*k2 - 63360*Dd*Pkd2*f**2*k2**3*r*s + 19800*Dd*Pkd2*f**2*k2**3*r - 47520*Dd*Pkd2*f**2*k2**3*s**2 + 59400*Dd*Pkd2*f**2*k2**3*s - 13860*Dd*Pkd2*f**2*k2**3 - 50688*Dd*Pkd2*f*g2*k1**2*k2*r*s + 27324*Dd*Pkd2*f*g2*k1**2*k2*r - 50688*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 67320*Dd*Pkd2*f*g2*k1**2*k2*s - 20988*Dd*Pkd2*f*g2*k1**2*k2 - 190080*Dd*Pkd2*f*g2*k2**3*r*s + 71280*Dd*Pkd2*f*g2*k2**3*r - 190080*Dd*Pkd2*f*g2*k2**3*s**2 + 190080*Dd*Pkd2*f*g2*k2**3*s - 47520*Dd*Pkd2*f*g2*k2**3 - 33*b1*(D1*fd*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(6*Pk2*(f*(33*r**2 - 16*r - 33*s**2 + 25*s - 3) + (-12*r - 12*s + 6)*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(2*Pk2*f*(132*r**2 - 86*r - 132*s**2 + 89*s - 4) - 36*Pk2*(2*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 24*r**2 - 16*r*s + 18*r + 8*s**2 - 2*s - 1) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) - Pkd2*k2*(72*K - 36)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**6) - D1**3*Pk3*ct**3*f*k1*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(99*s**2 - 75*s + 14) + 18*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(f*(33*s - 14) + 36*s - 18)) + f*(D1*bd1*s*(f*(33*s - 14) + 36*s - 18) + 6*D1*fd*(6*s**2 - 5*s + 1) + 6*Dd*f*(8*s**2 - 6*s + 1)))/(21*d**2*k2*k3**2) - D1**3*Pk3*ct**3*f*k1*st**4*(D1*(5*f**2*(-33*bd1*k2**2*(-8*Pk2*(2*r*(33*s - 7) + 33*s**2 - 52*s + 14) + k2*(Pkd2*(4*r*(33*s - 7) - 33*s**2 - 62*s + 28) + Pkdd2*k2*s*(33*s - 14))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(724*s**2 - 461*s + 70) + 44*k2**2*(Pk2*(r*(208 - 492*s) + 78*s - 62) + 3*Pkd2*k2*(r*(52*s - 21) - 12*s + 7)))) + 66*f*(3*bd1*(Pk2*k1**2*s*(24*K - 24)*(13*s - 10) - Pkd2*k1**2*k2*s*(9*K - 9)*(13*s - 10) + 15*Pkd2*k2**3*(K*(r*(8*s - 2) - 20*s**2 + 6*s + 2) + r*(4 - 16*s) + 2*s**2 + 7*s - 4) + Pkdd2*k2**4*s*(30*K - 15)*(2*s - 1) + k2**2*(-120*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + Pkdd2*k1**2*s*(K - 1)*(13*s - 10))) + fd*(k1**2*(2*C - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(63*s**2 - 51*s + 10) + k2**2*(-4*Pk2*(C*(738*r*s - 357*r - 720*s**2 + 498*s - 49) - 1098*r*s + 507*r + 180*s**2 + 12*s - 71) + k2*(Pkd2*(4*C*(198*r*s - 96*r - 450*s**2 + 345*s - 55) - 1152*r*s + 534*r + 990*s**2 - 645*s + 55) + Pkdd2*k2*(60*C - 45)*(6*s**2 - 5*s + 1)))) - 6*gd2*(24*Pk2*k1**2*s*(13*s - 10) + 9*Pkd2*k1**2*k2*s*(10 - 13*s) - 30*Pkd2*k2**3*(-4*r*s + r + 10*s**2 - 3*s - 1) + 30*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(120*Pk2*(-4*r*s + r + 4*s**2 - 1) + Pkdd2*k1**2*s*(13*s - 10)))) - 396*fd*g2*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*s - 10) + 30*k2**2*(-8*Pk2*(2*r - 2*s + 1) + k2*(Pkd2*(4*r - 10*s + 5) + Pkdd2*k2*(2*s - 1))))) + Dd*f*(5*f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(724*s**2 - 461*s + 70) + 44*k2**2*(Pk2*(r*(208 - 492*s) + 78*s - 62) + 3*Pkd2*k2*(r*(52*s - 21) - 12*s + 7))) + 66*f*(k1**2*(2*C - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(84*s**2 - 61*s + 10) + k2**2*(-8*Pk2*(C*(492*r*s - 224*r - 480*s**2 + 238*s + 21) - 732*r*s + 314*r + 120*s**2 + 92*s - 96) + k2*(Pkd2*(4*C*(264*r*s - 121*r - 600*s**2 + 380*s - 30) - 1536*r*s + 664*r + 1320*s**2 - 590*s - 75) + Pkdd2*k2*(60*C - 45)*(8*s**2 - 6*s + 1)))) - 396*g2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) + 30*k2**2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))) + 33*b1*(D1*fd*(k1**2*(6*K - 6)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 5*k2**2*(-24*Pk2*(f*(r*(66*s - 25) + 33*s**2 - 41*s + 11) + (12*s - 6)*(K*(-4*r + 4*s - 2) + 8*r + 2*s - 1)) + k2*(3*Pkd2*(f*(2*r*(66*s - 25) - 33*s**2 - 7*s + 8) + (2*s - 1)*(-12*K*(4*r - 10*s + 5) + 96*r - 12*s + 6)) + Pkdd2*k2*(f*(99*s**2 - 75*s + 14) + (1 - 2*s)**2*(18 - 36*K))))) + Dd*f*(k1**2*(6*K - 6)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(52*s**2 - 53*s + 10) - 5*k2**2*(-8*Pk2*(f*(r*(264*s - 89) + 132*s**2 - 175*s + 47) + r*(72 - 36*K)*(8*s - 3) + (36*s - 18)*(s*(8*K + 4) - 5)) + k2*(Pkd2*(-36*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) + f*(2*r*(264*s - 89) - 132*s**2 - 83*s + 52) + 1152*r*s - 432*r - 144*s**2 - 180*s + 126) + Pkdd2*k2*(4*s - 1)*(-72*K*s + 36*K + f*(33*s - 14) + 36*s - 18))))))/(3465*d**2*k2*k3**4) - 2*D1**3*Pk3*ct**3*k1*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*bd1*f**2*s*(5*s - 6) + b1**2*(D1*fd*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + Dd*f*(4*s - 1)*(f*(13*s - 10) + 14*s - 14)) + b1*f*(2*D1*bd1*s*(f*(13*s - 10) + 14*s - 14) + D1*fd*(10*s**2 - 17*s + 6) + Dd*f*(20*s**2 - 29*s + 6)))/(35*d**2*k2**3) - 8*D1**3*Pk3*ct**3*st**2*(11*D1*bd1*f*k1**2*(f**2*k2**2*(k1**2*(4*Pk2*(126*r**2 + 6*r*(34*s - 21) + 78*s**2 - 29*s - 46) + Pkd2*k2*(3*r*(32*s - 47) + 96*s**2 - 335*s + 233)) - 18*k2**2*(Pk2*(35*r**2 + 10*r*s - 42*r - 25*s**2 - 2*s + 13) + 5*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**2*k2**2*(2*Pk2*(2*C*(r**2 + 33*r*s - 6*r + 32*s**2 - 24*s - 8) + 2*K*(4*r**2 - 56*r*s - 25*r - 60*s**2 - 26*s + 21) + 17*r**2 + 148*r*s - 64*r + 131*s**2 - 104*s + 73) + Pkd2*k2*(C*(r*(10 - 62*s) - 62*s**2 + 46*s + 16) + 9*K*(8*r*s + 5*r + 8*s**2 + 6*s - 5) - 58*r*s - r - 58*s**2 + 32*s - 25)) + k2**4*(2*Pk2*(2*C*(15*r**2 + 129*r*s - 50*r + 30*s**2 - 84*s + 12) - 96*K*r**2 - 498*K*r*s + 196*K*r - 402*K*s**2 + 324*K*s - 100*K + 21*b1*(r + s - 1) - 177*r**2 - 231*r*s + 302*r + 30*s**2 + 201*s - 79) + 3*Pkd2*k2*(-8*C*(12*r*s - 6*r + 5*s**2 - 8*s + 3) + 48*K*r*s + 2*K*r + 48*K*s**2 - 20*K*s - 2*K + b1*(13*r*(4*s - 1) + 52*s**2 - 45*s + 3) + 2*r*s - 15*r - 26*s**2 + 15*s - 3))) - 21*k2**2*(4*Pk2*g2*k1**2*(r**2 + 5*r*s + s*(4*s - 4)) + 24*Pk2*g2*k2**2*(r*(2*s - 1) + s*(2*s - 2)) - 2*Pkd2*g2*k1**2*k2*(3*r*s + r + s*(3*s - 3)) - 24*Pkd2*g2*k2**3*(r*(2*s - 1) + s*(2*s - 2)) - b1*k1**2*(K - 1)*(2*Pk2*(2*r**2 + 2*r*(5*s - 1) + 8*s**2 - 10*s + 1) - Pkd2*k2*(6*r*s + r + s*(6*s - 7))) + 6*b1*k2**2*(-2*Pk2*(K*(4*r*s - 3*r + 4*s**2 - 5*s + 2) + 4*r**2 + 4*r*s - 2*r - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))))) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(7*K - 7)*(2*Pk2*(r**2 + r*(5*s - 2) + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + 3*k2**2*(2*Pk2*(28*K*(r*(s - 2) + (s - 1)**2) + f*(33*r + 33*s - 23) + 28*r**2 + 28*r*(s + 1) + 28*s - 14) + Pkd2*k2*s*(f*(52*r + 52*s - 19) + (28 - 56*K)*(r + s)))) + Dd*f*(k1**2*(7*K - 7)*(2*Pk2*(4*r**2 + r*(20*s - 6) + 16*s**2 - 18*s + 3) - Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 3*k2**2*(4*Pk2*(7*K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 5*f*(4*r + 4*s - 3) + 56*r**2 + 56*r*s - 7*r + 14*s - 21) + Pkd2*k2*(f*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3) + (14 - 28*K)*(r*(8*s - 1) + 4*s*(2*s - 1)))))) + 11*b1*k1**2*(3*D1*(f**2*fd*k2**2*(k1**2*(4*Pk2*(126*r**2 + 204*r*s - 72*r + 78*s**2 - 7*s - 6) + Pkd2*k2*(96*r*s - 321*r + 96*s**2 - 451*s + 223)) - 3*k2**2*(2*Pk2*(105*r**2 + 30*r*s - 96*r - 75*s**2 - s + 23) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) + f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**2*k2**2*(2*Pk2*(4*C*(r**2 + r*(33*s - 2) + 32*s**2 - 7*s + 1) + 2*K*(8*r**2 - 112*r*s + 63*r - 120*s**2 + 106*s - 23) + 34*r**2 + 296*r*s - 325*r + 262*s**2 - 481*s + 153) + Pkd2*k2*(-124*C*s**2 + 20*C*s + 9*K*(r*(16*s - 1) + 16*s**2 - 2*s - 3) + r*(-s*(124*C + 116) + 99) - 116*s**2 + 178*s - 39)) + k2**4*(2*Pk2*(2*C*(30*r**2 + 3*r*(86*s - 65) + 60*s**2 - 259*s + 126) - 2*K*(96*r**2 + 498*r*s - 298*r + 402*s**2 - 423*s + 111) - 354*r**2 - 462*r*s + 368*r + 60*s**2 + 203*s - 153) + 3*Pkd2*k2*(-80*C*s**2 + 96*C*s + 2*K*(r*(48*s - 17) + 48*s**2 - 34*s + 5) + 4*r*(-48*C*s + s + 14) - 52*s**2 + 61*s - 28))) + 14*gd2*k2**2*(k1**2*(-2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 6*s + 1) + Pkd2*k2*s*(3*r + 3*s - 4)) + 12*k2**2*(Pk2*(-2*r*s + 2*r - 2*s**2 + 3*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 14*fd*g2*k2**2*(k1**2*(-2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1) + 3*Pkd2*k2*s*(r + s)) + 24*k2**2*(-Pk2*(r*(s - 2) + (s - 1)**2) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(2*k1**2*(4*Pk2*(252*r**2 + 3*r*(136*s - 57) + 156*s**2 - 25*s - 32) + Pkd2*k2*(24*r*(8*s - 23) + 192*s**2 - 844*s + 451)) - 9*k2**2*(Pk2*(280*r**2 + 80*r*s - 276*r - 200*s**2 - 6*s + 72) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + k1**2*k2**2*(2*Pk2*(2*C*(4*r**2 + 12*r*(11*s - 1) + 128*s**2 - 58*s - 5) + 2*K*(16*r**2 - 224*r*s + 13*r - 240*s**2 + 54*s + 19) + 68*r**2 + 592*r*s - 461*r + 524*s**2 - 697*s + 281) + Pkd2*k2*(-2*C*(r*(124*s - 5) + 124*s**2 - 51*s - 8) + 9*K*(32*r*s + 9*r + 32*s**2 + 10*s - 13) - 232*r*s + 107*r - 232*s**2 + 252*s - 73)) + k2**4*(2*Pk2*(4*C*(30*r**2 + r*(258*s - 157) + 60*s**2 - 244*s + 96) - 2*K*(192*r**2 + 996*r*s - 494*r + 804*s**2 - 747*s + 211) - 708*r**2 - 924*r*s + 995*r + 120*s**2 + 670*s - 380) - 3*Pkd2*k2*(8*C*(6*r*(8*s - 1) + 20*s**2 - 29*s + 3) - 6*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) - 8*r*s - 55*r + 104*s**2 - 92*s + 45))) + 42*g2*k2**2*(k1**2*(-2*Pk2*(4*r**2 + r*(20*s - 6) + 16*s**2 - 18*s + 3) + Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 12*k2**2*(Pk2*(-8*r*s + 9*r - 8*s**2 + 12*s - 6) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(f**2*fd*k1**2*(2640*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1832*s - 1019) + 1832*s**2 - 2580*s + 811) + 11*k1**2*k2**2*(4*Pk2*(708*r**2 - 3*r*(844*s + 31) - 3240*s**2 + 2698*s - 286) + 25*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 11*f*(fd*(Pk2*k2**6*(16*C - 8)*(36*r**2 - 9*r*(8*s + 5) + 42*s + 5) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) - 9*k1**4*k2**2*(-2*Pk2*(2*C*(9*r**2 + 3*r*(7*s - 8) - 36*s**2 - 43*s + 23) + 78*r*s - 13*r + 126*s**2 - 28*s - 9) + Pkd2*k2*(8*C*(12*r*s - 7*r - 15*s + 6) - 12*r*s + 19*r + 36*s**2 + 30*s - 19)) - 2*k1**2*k2**4*(Pk2*(2*C*(18*r**2 + 9*r*(752*s - 115) + 1890*s**2 - 4416*s + 853) + 927*r**2 - 6165*r*s + 159*r - 2232*s**2 + 4200*s - 623) + 6*Pkd2*k2*(C*(3*r*(6*s - 5) - 54*s**2 - 30*s + 19) + (3*s - 1)*(15*r + 27*s - 4)))) - 6*k1**2*(6*Pk2*bd2*k2**4*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**2*k2**2*(4*Pk2*(4*r**2 - r*(56*s + 25) - 60*s**2 - 26*s + 21) + 9*Pkd2*k2*(r*(8*s + 5) + 8*s**2 + 6*s - 5)) + 2*k2**4*(-2*Pk2*(48*r**2 + r*(249*s - 98) + 201*s**2 - 162*s + 50) + 3*Pkd2*k2*(24*r*s + r + 24*s**2 - 10*s - 1))))) - 66*fd*k1**2*(6*Pk2*b2*k2**4*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**2*k2**2*(4*Pk2*(8*r**2 - 112*r*s + 63*r - 120*s**2 + 106*s - 23) + 9*Pkd2*k2*(16*r*s - r + 16*s**2 - 2*s - 3)) + 2*k2**4*(-2*Pk2*(96*r**2 + 498*r*s - 298*r + 402*s**2 - 423*s + 111) + 3*Pkd2*k2*(48*r*s - 17*r + 48*s**2 - 34*s + 5))))) + Dd*f*(f**2*k1**2*(2640*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1832*s - 1019) + 1832*s**2 - 2580*s + 811) + 11*k1**2*k2**2*(4*Pk2*(708*r**2 - 3*r*(844*s + 31) - 3240*s**2 + 2698*s - 286) + 25*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 11*f*(Pk2*k2**6*(64*C - 32)*(12*r**2 - 6*r*(4*s + 3) + 16*s + 5) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 7) + 12*s**2 - 33*s + 13) - 9*k1**4*k2**2*(-2*Pk2*(4*C*(6*r**2 + 14*r*s - 22*r - 24*s**2 - 43*s + 20) + 104*r*s + 7*r + 168*s**2 + 8*s - 29) + Pkd2*k2*(2*C*(64*r*s - 39*r - 94*s + 35) - 16*r*s + 31*r + 48*s**2 + 58*s - 31)) - 2*k1**2*k2**4*(Pk2*(4*C*(12*r**2 + 6*r*(752*s - 77) + 1260*s**2 - 3131*s + 368) + 1236*r**2 - 8220*r*s - 458*r - 2976*s**2 + 5794*s - 315) + 6*Pkd2*k2*(C*(24*r*s - 22*r - 72*s**2 - 54*s + 26) + 60*r*s - 16*r + 108*s**2 - 45*s + 5))) - 66*k1**2*(6*Pk2*b2*k2**4*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + k1**2*k2**2*(4*Pk2*(16*r**2 - 224*r*s + 13*r - 240*s**2 + 54*s + 19) + 9*Pkd2*k2*(32*r*s + 9*r + 32*s**2 + 10*s - 13)) + 2*k2**4*(-2*Pk2*(192*r**2 + 996*r*s - 494*r + 804*s**2 - 747*s + 211) + 9*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1)))))))/(3465*d**2*k1*k2*k3**6) + 4*D1**3*Pk3*ct**3*(D1*bd1*f*(f**2*k1**2*(216*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + 5*k1**4*(2*Pk2*(24*r**2 + 66*r*s - 85*r + 42*s**2 - 91*s + 45) + Pkd2*k2*(-18*r*s + 53*r - 18*s**2 + 59*s - 37)) + 9*k1**2*k2**2*(4*Pk2*(29*r**2 + 94*r*s - 65*r + 65*s**2 - 86*s + 18) + 5*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + 3*f*(Pk2*k2**6*(4 - 8*C)*(11*r**2 - 17*r*s - 4*r + 6*s - 6) + 2*k1**6*(2*Pk2*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - K*(3*r*(8*s + 5) + 24*s**2 + 11*s - 15) + 12*r**2 + 21*r - 12*s**2 + 53*s - 21) - 3*Pkd2*k2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 7*K*(s - 1)*(r + s - 1) - 23*r*s + 15*r - 23*s**2 + 34*s - 11)) + k1**4*k2**2*(2*Pk2*(-4*C*(144*r**2 + 339*r*s - 187*r + 27*s**2 - 220*s + 109) - 494*K*r**2 - 1140*K*r*s + 702*K*r - 646*K*s**2 + 564*K*s - 208*K + b1*(36*r**2 + r*(72*s - 33) + 36*s**2 - 33*s - 3) + 1223*r**2 + 2404*r*s - 1743*r + 845*s**2 - 1603*s + 784) + 3*Pkd2*k2*(-4*C*(r*(41*s - 24) + 55*s**2 - 60*s + 5) - 2*K*(r*(71*s - 37) + 71*s**2 - 106*s + 37) + b1*(3*r*(8*s - 9) + 24*s**2 - 31*s + 17) + 228*r*s - 128*r + 256*s**2 - 320*s + 64)) + k1**2*k2**4*(2*Pk2*(-4*C*(169*r**2 - 208*r*s + 4*r + 29*s**2 + 25*s - 96) - 826*K*r**2 - 1708*K*r*s + 1274*K*r - 882*K*s**2 + 1190*K*s - 448*K + 7*b1*(36*r**2 + r*(48*s - 65) + 12*s**2 - 41*s + 29) + 847*r**2 + 362*r*s - 639*r + 327*s**2 - 403*s + 48) + 3*Pkd2*k2*(-2*C*(r*(34*s - 24) + 62*s**2 - 60*s - 2) - 14*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 7*b1*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) + 62*r*s - 38*r + 90*s**2 - 88*s - 2))) + 42*k1**2*(Pk2*b1**2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 4*Pk2*b2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - b1*(k1**4*(2 - 2*K)*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(-2*Pk2*(8*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-36*r**2 - 42*r*s + 17*r - 6*s**2 + 7*s + 9) + 38*r**2 + 46*r*s - 13*r + 8*s**2 - 3*s - 15) + Pkd2*k2*(r*(K*(58*s - 17) - 44*s + 11) + s*(K*(58*s - 41) - 44*s + 33))) + k2**4*(2*Pk2*(-4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) + K*(12*r**2 + 2*r*s + 5*r - 10*s**2 + 11*s - 9) - 15*r**2 - 52*r*s + 7*r + 3*s**2 + 13*s + 1) + Pkd2*k2*(r*(K*(34*s - 11) - 20*s + 5) + s*(K*(34*s - 23) - 20*s + 15)))) + 2*g2*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + k1**2*k2**2*(2*Pk2*(18*r**2 + r*(21*s - 8) + s*(3*s - 3)) + Pkd2*k2*(r*(29*s - 17) + s*(29*s - 29))) + k2**4*(2*Pk2*(6*r**2 + r*(s + 2) - s*(5*s - 5)) + Pkd2*k2*(r*(17*s - 11) + s*(17*s - 17)))))) + 42*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k1**2*(D1*fd*(k1**4*s*(56*K - 56)*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(2*Pk2*(112*C*(r + s - 1)**2 - 42*K*(6*r**2 + 7*r*s + 6*r + s**2 + 6*s - 3) + 3*f*(12*r**2 + 3*r*(8*s + 3) + 12*s**2 + 9*s - 11) + 266*r**2 + 322*r*s + 420*r + 56*s**2 + 420*s - 210) + Pkd2*k2*s*(f*(72*r + 72*s - 57) + (308 - 406*K)*(r + s))) + 7*k2**4*(2*Pk2*(16*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) - 12*K*r**2 - 2*K*r*s - 36*K*r + 10*K*s**2 - 36*K*s + 18*K + f*(36*r**2 + 48*r*s - 29*r + 12*s**2 - 17*s + 1) + 15*r**2 + 52*r*s + 44*r - 3*s**2 + 4*s - 22) + Pkd2*k2*s*(3*f*(12*r + 12*s - 5) + (20 - 34*K)*(r + s)))) + Dd*f*(k1**4*(28*K - 28)*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(4*Pk2*(56*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(72*r**2 + 84*r*s - 8*r + 12*s**2 + 7*s - 27) + 3*f*(12*r**2 + r*(24*s - 1) + 12*s**2 - s - 6) + 532*r**2 + 644*r*s + 91*r + 112*s**2 + 196*s - 315) + Pkd2*k2*(3*f*(3*r*(16*s - 9) + 48*s**2 - 50*s + 17) - 14*r*(116*K*s - 17*K - 88*s + 11) - 14*s*(116*K*s - 53*K - 88*s + 44))) + 7*k2**4*(2*Pk2*(8*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 48*K*r**2 - 8*K*r*s - 52*K*r + 40*K*s**2 - 70*K*s + 54*K + f*(72*r**2 + 96*r*s - 94*r + 24*s**2 - 58*s + 30) + 60*r**2 + 208*r*s + 37*r - 12*s**2 - 51*s - 46) + Pkd2*k2*(f*(9*r*(8*s - 1) + 72*s**2 - 48*s + 3) + 2*r*(-68*K*s + 11*K + 40*s - 5) + 2*s*(-68*K*s + 29*K + 40*s - 20))))) + b1*(D1*(f**2*fd*k1**2*(216*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + 5*k1**4*(6*Pk2*(24*r**2 + 66*r*s - 50*r + 42*s**2 - 59*s + 24) + Pkd2*k2*(-54*r*s + 30*r - 54*s**2 + 57*s - 20)) + 9*k1**2*k2**2*(4*Pk2*(87*r**2 + 282*r*s - 118*r + 195*s**2 - 161*s + 43) + 5*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) - 6*f*fd*(Pk2*k2**6*(4*C - 2)*(2*r - 1)*(11*r - 17*s - 16) + k1**6*(2*Pk2*(K*(r*(48*s - 3) + 48*s**2 - 20*s - 2) - 24*r**2 + r*(-96*C*s + 27) - (8*s - 4)*(12*C*s - 3*s - 1)) + 3*Pkd2*k2*(2*r + 2*s - 1)*(7*K*(s - 1) + s*(16*C - 23) + 7)) + k1**4*k2**2*(Pk2*(4*C*(288*r**2 + r*(678*s - 317) + 54*s**2 - 431*s + 106) + 2*K*(494*r**2 + 12*r*(95*s - 51) + 646*s**2 - 555*s + 116) - 2446*r**2 - 4808*r*s + 2770*r - 1690*s**2 + 2847*s - 713) + 3*Pkd2*k2*(220*C*s**2 - 54*C*s + K*(2*r*(71*s - 46) + 142*s**2 - 177*s + 53) + r*(s*(164*C - 228) + 49) - 256*s**2 + 149*s - 28)) + k1**2*k2**4*(Pk2*(4*C*(338*r**2 - 4*r*(104*s + 111) + 58*s**2 + 305*s + 136) + 14*K*(118*r**2 + 244*r*s - 133*r + 126*s**2 - 127*s + 32) - 1694*r**2 - 724*r*s + 1850*r - 654*s**2 + 147*s - 453) + 3*Pkd2*k2*(7*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(C*(34*r + 62*s - 3) - 31*r - 45*s + 5)))) + 84*f*k1**2*(2*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-2*k1**4*s*(2*Pk2 - Pkd2*k2)*(2*r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(18*r**2 + 21*r*s - 9*r + 3*s**2 - 4*s - 9) + Pkd2*k2*s*(29*r + 29*s - 12)) + k2**4*(2*Pk2*(6*r**2 + r*(s + 3) - 5*s**2 + 6*s - 9) + Pkd2*k2*s*(17*r + 17*s - 6)))) + 84*fd*k1**2*(2*Pk2*b2*k2**4*(r + s)**2 + g2*(-4*k1**4*s*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(6*Pk2*(6*r**2 + r*(7*s + 6) + s**2 + 6*s - 3) + 29*Pkd2*k2*s*(r + s)) + k2**4*(2*Pk2*(6*r**2 + r*(s + 18) - 5*s**2 + 18*s - 9) + 17*Pkd2*k2*s*(r + s))))) + Dd*f*(f**2*k1**2*(216*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + 5*k1**4*(2*Pk2*(96*r**2 + 264*r*s - 235*r + 168*s**2 - 268*s + 117) + Pkd2*k2*(-72*r*s + 83*r - 72*s**2 + 116*s - 57)) + 18*k1**2*k2**2*(2*Pk2*(116*r**2 + r*(376*s - 183) + 260*s**2 - 247*s + 61) + 5*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) + 6*f*(Pk2*k2**6*(4 - 8*C)*(2*r - 1)*(11*r - 17*s - 13) + k1**6*(2*Pk2*(12*C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - K*(96*r*s + 27*r + 96*s**2 + 2*s - 32) + 48*r**2 - 9*r - 48*s**2 + 86*s - 26) - 3*Pkd2*k2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + 7*K*(s - 1)*(4*r + 4*s - 3) - 92*r*s + 36*r - 92*s**2 + 97*s - 25)) - k1**4*k2**2*(Pk2*(4*C*(576*r**2 + r*(1356*s - 715) + 108*s**2 - 979*s + 282) + 2*K*(988*r**2 + 6*r*(380*s - 219) + 1292*s**2 - 1119*s + 324) - 4892*r**2 - 9616*r*s + 6376*r - 3380*s**2 + 6341*s - 2137) + 3*Pkd2*k2*(2*C*(4*r*(41*s - 6) + 220*s**2 - 109*s + 5) + K*(284*r*s - 166*r + 284*s**2 - 389*s + 127) - 456*r*s + 134*r - 512*s**2 + 412*s - 81)) - k1**2*k2**4*(Pk2*(4*C*(676*r**2 - 4*r*(208*s + 187) + 116*s**2 + 491*s + 179) + 14*K*(236*r**2 + 488*r*s - 315*r + 252*s**2 - 297*s + 96) - 3388*r**2 - 1448*r*s + 3830*r - 1308*s**2 + 759*s - 995) + 3*Pkd2*k2*(2*C*(4*r*(17*s - 3) + 124*s**2 - 37*s - 1) + 7*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 124*r*s + 19*r - 180*s**2 + 65*s + 1))) + 84*k1**2*(2*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(2*Pk2*(72*r**2 + r*(84*s - 8) + 12*s**2 + 7*s - 27) + Pkd2*k2*(r*(116*s - 17) + s*(116*s - 53))) + k2**4*(Pk2*(48*r**2 + r*(8*s + 52) - 40*s**2 + 70*s - 54) + Pkd2*k2*(r*(68*s - 11) + s*(68*s - 29))))))) + f*(D1*(-5*f**2*fd*k1**4*(32*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(140*r**2 + 8*r*s - 91*r - 132*s**2 + 151*s - 20) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(fd*(Pk2*k2**6*(36*C - 18)*(3*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(2*C*Pk2*(30*r*(6*s + 1) + 180*s**2 - 81*s - 23) + 6*Pk2*(-15*r**2 + r*(10 - 90*s) - 75*s**2 + 47*s + 1) + Pkd2*k2*(45*C - 45)*(s - 1)*(3*r + 3*s - 2)) + k1**4*k2**2*(Pk2*(12*C*(618*r**2 + 1125*r*s - 829*r + 723*s**2 - 674*s + 227) - 7281*r**2 - 14238*r*s + 9951*r - 8253*s**2 + 8808*s - 2945) + 5*Pkd2*k2*(C*(6*r*(93*s - 55) + 558*s**2 - 738*s + 232) - 414*r*s + 255*r - 414*s**2 + 558*s - 179)) + 3*k1**2*k2**4*(Pk2*(4*C*(1008*r**2 + 9*r*(191*s - 143) + 927*s**2 - 1071*s + 380) - 2592*r**2 - 4428*r*s + 3213*r - 2268*s**2 + 2604*s - 907) + Pkd2*k2*(120*C - 60)*(2*s - 1)*(3*r + 3*s - 2))) - 6*k1**2*(-3*Pk2*bd2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(r + s - 1) + gd2*(k1**4*(Pk2*(6*r*(8*s + 5) + 48*s**2 + 22*s - 30) + 21*Pkd2*k2*(s - 1)*(r + s - 1)) + k1**2*k2**2*(2*Pk2*(247*r**2 + 570*r*s - 351*r + 323*s**2 - 282*s + 104) + 3*Pkd2*k2*(71*r*s - 37*r + 71*s**2 - 106*s + 37)) + 7*k2**4*(2*Pk2*(59*r**2 + 122*r*s - 91*r + 63*s**2 - 85*s + 32) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3))))) + 12*fd*k1**2*(-3*Pk2*b2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + g2*(k1**4*(Pk2*(96*r*s - 6*r + 96*s**2 - 40*s - 4) + 21*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k1**2*k2**2*(2*Pk2*(494*r**2 + 12*r*(95*s - 51) + 646*s**2 - 555*s + 116) + 3*Pkd2*k2*(2*r*(71*s - 46) + 142*s**2 - 177*s + 53)) + 7*k2**4*(Pk2*(236*r**2 + 488*r*s - 266*r + 252*s**2 - 254*s + 64) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-5*f**2*k1**4*(32*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(140*r**2 + 8*r*s - 91*r - 132*s**2 + 151*s - 20) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(Pk2*k2**6*(72*C - 36)*(2*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(2*Pk2*(C*(240*r*s + 65*r + 240*s**2 - 78*s - 58) - 60*r**2 - 360*r*s + 20*r - 300*s**2 + 163*s + 28) + Pkd2*k2*(45*C - 45)*(s - 1)*(4*r + 4*s - 3)) + k1**4*k2**2*(Pk2*(4*C*(2472*r**2 + 4500*r*s - 3464*r + 2892*s**2 - 2677*s + 1040) - 9708*r**2 - 18984*r*s + 13798*r - 11004*s**2 + 11815*s - 4365) + 5*Pkd2*k2*(2*C*(4*r*(93*s - 53) + 372*s**2 - 507*s + 163) - 552*r*s + 329*r - 552*s**2 + 768*s - 253)) + 3*k1**2*k2**4*(Pk2*(4*C*(1344*r**2 + 2292*r*s - 1836*r + 1236*s**2 - 1499*s + 593) - 3456*r**2 - 5904*r*s + 4581*r - 3024*s**2 + 3646*s - 1411) + Pkd2*k2*(30*C - 15)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 12*k1**2*(-3*Pk2*b2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + g2*(k1**4*(2*Pk2*(96*r*s + 27*r + 96*s**2 + 2*s - 32) + 21*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(2*Pk2*(988*r**2 + 6*r*(380*s - 219) + 1292*s**2 - 1119*s + 324) + 3*Pkd2*k2*(2*r*(142*s - 83) + 284*s**2 - 389*s + 127)) + 7*k2**4*(2*Pk2*(236*r**2 + 488*r*s - 315*r + 252*s**2 - 297*s + 96) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(315*d**2*k1*k2*k3**6) + D1**3*Pk3*ct**3*(2*D1*bd1*f**2*(4*Pk2*k1**2*s*(67*s - 107) + 10*Pkd2*k1**2*k2*s*(17 - 13*s) + Pkd2*k2**3*(24*C - 12)*(r*(4*s - 1) - s) + k2**2*(2*Pk2*(10*r**2 + r*(-110*C*s + 38*C + 55*s - 38) + s*(24*C - 12)) + 21*Pkdd2*k1**2*s*(s - 1))) - 7*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + 7*b1**2*k1**2*(D1*(-bd1*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + fd*(8*Pk2*(f*(42*s**2 - 53*s + 16) + 25*s**2 - 42*s + 21) + k2*(-Pkd2*(f*(138*s**2 - 169*s + 50) + 92*s**2 - 144*s + 72) + Pkdd2*k2*(3*f*(6*s**2 - 7*s + 2) + 14*s**2 - 20*s + 10)))) + Dd*f*(4*s - 1)*(8*Pk2*(f*(21*s - 16) + 25*s - 21) + k2*(Pkd2*(-69*f*s + 50*f - 92*s + 72) + Pkdd2*k2*(9*f*s - 6*f + 14*s - 10)))) + 2*b1*f*(7*D1*bd1*k1**2*s*(8*Pk2*(f*(21*s - 16) + 25*s - 23) + k2*(Pkd2*(-69*f*s + 50*f - 92*s + 82) + Pkdd2*k2*(9*f*s - 6*f + 14*s - 12))) + D1*fd*(k1**2*(2*s - 1)*(4*Pk2*(67*s - 107) + k2*(Pkd2*(170 - 130*s) + 21*Pkdd2*k2*(s - 1))) + 2*k2**2*(2*r - 1)*(Pk2*(C*(62 - 110*s) + 10*r + 55*s - 50) + Pkd2*k2*(24*C - 12)*(2*s - 1))) + Dd*f*k1**2*(4*s - 1)*(4*Pk2*(67*s - 107) + k2*(Pkd2*(170 - 130*s) + 21*Pkdd2*k2*(s - 1))) + 4*Dd*f*k2**2*(2*r - 1)*(Pk2*(C*(50 - 110*s) + 10*r + 55*s - 44) + Pkd2*k2*(6*C - 3)*(8*s - 3))))/(105*d**2*k1*k2**3) - 2*D1**3*Pk3*ct**3*st**2*(9*b1**2*k1**2*k2**2*(D1*fd*(8*Pk2*(-28*K*(s - 1)*(r - s + 1) + f*(33*s - 10) + 28*r*s - 28*r + 28*s - 14) + k2*(Pkd2*f*(50 - 165*s) + 14*Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*f*k2*(33*s - 10) + 14*Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) + 2*Dd*f*(8*Pk2*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7) + k2*(-25*Pkd2*f*(4*s - 1) + 7*Pkd2*(2*K*(r*(8*s - 5) - 20*s**2 + 23*s - 3) - 2*r*(8*s - 5) - 16*s + 1) + Pkdd2*k2*(4*s - 1)*(14*K*(s - 1) + 5*f + 7)))) + b1*k1**2*(D1*(f**2*(63*bd1*k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + fd*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 219*s + 50) - 9*k2**2*(8*Pk2*(r*(54*s - 51) + 225*s**2 - 175*s + 48) + k2*(Pkd2*(-24*r*(6*s - 5) - 675*s**2 + 531*s - 134) + 5*Pkdd2*k2*(15*s**2 - 11*s + 2))))) + 3*f*(fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) + k2**2*(-4*Pk2*(C*(2*r*(81*s - 121) - 240*s**2 + 439*s - 79) + 12*K*(26*s**2 - 33*s + 10) + 192*r*s - 12*r + 1032*s**2 - 1249*s + 271) + k2*(Pkd2*(4*C*(44*r*s - 64*r - 150*s**2 + 261*s - 72) + 30*K*(26*s**2 - 33*s + 10) + 220*r*s - 26*r + 1716*s**2 - 2205*s + 552) + 3*Pkdd2*k2*(4*C*(10*s**2 - 17*s + 6) + K*(-52*s**2 + 66*s - 20) - 76*s**2 + 107*s - 32)))) + 42*k2**2*(-8*Pk2*bd1*(K*(r*(4*s - 2) - 4*s**2 + 3*s + 1) + r*(2 - 4*s) - 1) + 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*k2*(Pkd2*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2) + Pkdd2*k2*s*(4*K*(s - 1) + 1)) - 4*gd2*k2*(Pkd2*(r*(2*s - 1) - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1)))) - 504*fd*g2*k2**2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + Dd*f*(f**2*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 269*s + 50) - 9*k2**2*(24*Pk2*(r*(24*s - 26) + 100*s**2 - 73*s + 22) + k2*(-3*Pkd2*(64*r*s - 60*r + 300*s**2 - 219*s + 58) + 5*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 9*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) + 6*f*k2**2*(-4*Pk2*(C*(18*r*(9*s - 13) - 240*s**2 + 379*s + 17) + 6*K*(52*s**2 - 53*s + 10) + 192*r*s - 23*r + 1032*s**2 - 1144*s + 209) + k2*(Pkd2*(2*C*(4*r*(22*s - 31) - 300*s**2 + 447*s - 42) + 15*K*(52*s**2 - 53*s + 10) + 220*r*s - 37*r + 1716*s**2 - 1905*s + 360) + 3*Pkdd2*k2*(4*s - 1)*(2*C*(5*s - 6) + K*(10 - 13*s) - 19*s + 16))) - 504*g2*k2**2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1)))) + f*(D1*(bd1*f**2*k1**2*(48*Pk2*k1**2*s*(69*s - 50) - 18*Pkd2*k1**2*k2*s*(69*s - 50) + 9*Pkd2*k2**3*(12*r*(4*s - 5) + 225*s**2 - 126*s + 40) - 45*Pkdd2*k2**4*s*(5*s - 2) - 2*k2**2*(36*Pk2*(9*r*(2*s - 3) + 75*s**2 - 44*s + 18) + Pkdd2*k1**2*s*(50 - 69*s))) + f*(2*fd*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(18*s**2 - 21*s + 5) + k1**2*k2**2*(-Pk2*(16*C*(207*s**2 - 219*s + 50) + 3*r*(543*s - 514) + 2304*s**2 - 1683*s + 638) + k2*(Pkd2*(10*C*(207*s**2 - 219*s + 50) + 6*r*(78*s - 71) + 441*s**2 - 189*s + 104) - Pkdd2*k2*(3*s - 1)*(2*C*(69*s - 50) - 15*s + 23))) - 2*k2**4*(Pk2*(-4*C*(306*r*s - 111*r - 138*s + 49) + 45*r**2 + 612*r*s - 396*r - 276*s + 151) + Pkd2*k2*(8*C - 4)*(21*r - 10)*(3*s - 1))) + 3*k1**2*(bd1*(72*Pk2*k1**2*s*(5*s - 6) - 27*Pkd2*k1**2*k2*s*(5*s - 6) + Pkd2*k2**3*(2*r*(C*(44*s - 60) + 55*s - 12) + s**2*(-300*C + 390*K + 858) + s*(408*C - 300*K - 801) + 144) + 3*Pkdd2*k2**4*s*(4*C*(5*s - 6) + K*(20 - 26*s) - 38*s + 27) + k2**2*(-4*Pk2*(r*(C*(81*s - 113) + 96*s - 17) + s**2*(-120*C + 156*K + 516) + s*(192*C - 120*K - 537) + 130) + 3*Pkdd2*k1**2*s*(5*s - 6))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-6*bd2 + 12*gd2)*(13*s - 10))) - 18*k1**2*k2**2*(b2*fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 2*g2*(14*bd1*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) + fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10)))) + 2*Dd*f*(f*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(24*s**2 - 26*s + 5) + k1**2*k2**2*(-2*Pk2*(8*C*(276*s**2 - 269*s + 50) + 2*r*(543*s - 524) + 1536*s**2 - 1215*s + 596) + k2*(Pkd2*(10*C*(276*s**2 - 269*s + 50) + 624*r*s - 578*r + 588*s**2 - 327*s + 256) - Pkdd2*k2*(4*s - 1)*(2*C*(69*s - 50) - 15*s + 23))) - 4*k2**4*(Pk2*(-4*C*(204*r*s - 70*r - 118*s + 39) + 30*r**2 + 408*r*s - 261*r - 236*s + 131) + Pkd2*k2*(4*C - 2)*(r*(84*s - 26) - 50*s + 15))) + k1**2*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-9*b2 + 18*g2)*(52*s**2 - 53*s + 10))))/(315*d**2*k1*k2**3*k3**2) + D1**3*Pk3*ct**3*(21*b1**3*k1**2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1**2*k1**2*(D1*(7*bd1*f*k2**3*s*(-Pkd2 + Pkdd2*k2)*(3*s - 1) + fd*(Pk2*k1**2*s**2*(96*f + 224) - Pkd2*k1**2*k2*s**2*(60*f + 140) + 7*Pkd2*k2**3*(-16*C*s**2 - 80*C*s + 2*K*(20*r*(s - 1) - 33*s**2 + 64*s - 32) + f*(4*r*(4*s - 3) - 85*s + 26) + 2*r*(40*C*s - 57*s + 20) + 12*s**2 + 16*s + 32) + 7*Pkdd2*k2**4*(2*K*(11*s**2 - 20*s + 10) + 3*f*(7*s - 2) + 2*s**2*(8*C - 6) + 20*s - 10) - 2*k2**2*(7*Pk2*(80*C*r*s - 80*C*s + 2*K*(s - 1)*(31*r - 22*s + 22) + 2*f*(4*r*(s - 2) - 29*s + 11) - 141*r*s + 62*r + 36*s + 22) + Pkdd2*k1**2*s**2*(-6*f - 14)))) + 2*Dd*f*(Pk2*k1**2*s*(24*f + 112)*(4*s - 1) - Pkd2*k1**2*k2*s*(15*f + 70)*(4*s - 1) + 7*Pkd2*k2**3*(4*C*(5*r*(8*s - 1) - 8*s**2 - 28*s + 5) + 80*K*r*s - 50*K*r - 132*K*s**2 + 141*K*s - 12*K + f*(4*r*(4*s - 9) - 60*s + 31) - 228*r*s + 61*r + 24*s**2 + 82*s - 24) + 7*Pkdd2*k2**4*(4*s - 1)*(8*C*s + K*(11*s - 10) + 3*f - 6*s + 5) + k2**2*(-14*Pk2*(20*C*(r*(8*s - 1) - 6*s + 1) + 124*K*r*s - 55*K*r - 88*K*s**2 + 94*K*s - 6*K + f*(8*r*(s - 5) - 44*s + 30) - 282*r*s + 66*r + 109*s - 25) + Pkdd2*k1**2*s*(3*f + 14)*(4*s - 1)))) + 3*b1*(D1*(f**2*k1**2*(bd1*(48*Pk2*k1**2*s*(2*s - 1) + 30*Pkd2*k1**2*k2*s*(1 - 2*s) + 7*Pkd2*k2**3*(4*r*(4*s - 15) - 35*s + 36) + 21*Pkdd2*k2**4*s - 2*k2**2*(14*Pk2*(4*r*(s - 8) - 15*s + 19) + 3*Pkdd2*k1**2*s*(1 - 2*s))) + 6*fd*(k1**2*(3*s - 1)*(8*Pk2*(33*s - 28) + k2*(Pkd2*(86 - 111*s) + 5*Pkdd2*k2*(3*s - 2))) + 2*k2**2*(Pk2*(126*r**2 + 6*r*(3*s - 19) - 150*s**2 + 46*s + 33) + Pkd2*k2*(63*r*(2*s - 1) + 90*s**2 - 122*s + 40)))) + 2*f*(fd*(k1**4*(4*Pk2*(182*s**2 - 281*s + 107) + k2*(-10*Pkd2*(38*s**2 - 47*s + 17) + 3*Pkdd2*k2*(22*s**2 - 21*s + 7))) + k1**2*k2**2*(Pk2*(4*C*(r*(148*s + 31) + 100*s**2 - 713*s + 279) + 28*K*(r*(s + 4) - 24*s**2 + 32*s - 10) + 196*r**2 - 1016*r*s + 114*r - 704*s**2 + 2901*s - 944) + k2*(-Pkd2*(4*C*(7*r*(4*s + 7) + 89*s**2 - 295*s + 93) + 7*K*(4*r*s + 6*r - 66*s**2 + 85*s - 26) - 492*r*s + 7*r - 598*s**2 + 1320*s - 307) + 3*Pkdd2*k2*(4*C*(13*s**2 - 21*s + 7) - 7*K*(6*s**2 - 7*s + 2) - 26*s**2 + 63*s - 21))) + k2**4*(4*C - 2)*(2*r - 1)*(Pk2*(20*r - 59) + 12*Pkd2*k2)) + 7*k1**2*(bd1*(16*Pk2*k1**2*s*(2*s - 1) + 10*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(4*C*(5*r*(4*s - 1) - 4*s**2 - 8*s + 5) + K*(40*r*s - 20*r - 66*s**2 + 55*s + 10) - 114*r*s + 31*r + 12*s**2 + 34*s - 30) + Pkdd2*k2**4*s*(8*C*(2*s - 1) + K*(22*s - 21) - 12*s + 11) + k2**2*(Pk2*(-40*C*(r*(4*s - 1) - 2*s + 1) - 4*K*(31*r*s - 8*r - 22*s**2 + 18*s + 4) + 282*r*s - 54*r - 91*s + 56) + 2*Pkdd2*k1**2*s*(2*s - 1))) + k2**2*(4*Pk2*gd2*(r*(31*s - 8) - 22*s**2 + 14*s + 8) + bd2*k2*s**2*(-Pkd2 + Pkdd2*k2) + 2*gd2*k2*(Pkd2*(r*(10 - 20*s) + 33*s**2 - 22*s - 10) + Pkdd2*k2*s*(10 - 11*s))))) - 14*fd*k1**2*k2**2*(b2*k2*s**2*(Pkd2 - Pkdd2*k2) - 2*g2*(2*Pk2*(s - 1)*(31*r - 22*s + 22) + k2*(Pkd2*(-20*r*(s - 1) + 33*s**2 - 64*s + 32) + Pkdd2*k2*(-11*s**2 + 20*s - 10))))) + 2*Dd*f*(3*f**2*k1**2*(k1**2*(4*s - 1)*(8*Pk2*(33*s - 28) + k2*(Pkd2*(86 - 111*s) + 5*Pkdd2*k2*(3*s - 2))) + 4*k2**2*(Pk2*(84*r**2 + 12*r*s - 62*r - 100*s**2 + 31*s + 7) + 3*Pkd2*k2*(28*r*s - 14*r + 20*s**2 - 27*s + 9))) + f*(k1**4*(4*s - 1)*(4*Pk2*(91*s - 107) + k2*(Pkd2*(170 - 190*s) + 3*Pkdd2*k2*(11*s - 7))) + k1**2*k2**2*(4*Pk2*(C*(r*(296*s + 113) + 200*s**2 - 1376*s + 238) + 7*K*(2*r*s + 11*r - 48*s**2 + 57*s - 17) + 98*r**2 - 508*r*s + 29*r - 352*s**2 + 1474*s - 322) + k2*(-Pkd2*(C*(28*r*(8*s + 17) + 712*s**2 - 2170*s + 232) + 7*K*(8*r*s + 18*r - 132*s**2 + 145*s - 38) - 984*r*s + 32*r - 1196*s**2 + 2579*s - 463) + 3*Pkdd2*k2*(4*s - 1)*(C*(26*s - 28) - 7*K*(3*s - 2) - 13*s + 21))) + k2**4*(8*C - 4)*(2*r - 1)*(Pk2*(20*r - 59) + 6*Pkd2*k2)) - 7*k1**2*k2**2*(b2*k2*s*(Pkd2 - Pkdd2*k2)*(4*s - 1) - 2*g2*(2*Pk2*(r*(124*s - 55) - 88*s**2 + 94*s - 6) + k2*(Pkd2*r*(50 - 80*s) + 3*Pkd2*(44*s**2 - 47*s + 4) + Pkdd2*k2*(-44*s**2 + 51*s - 10)))))) + 2*f*(D1*(9*bd1*f**2*k1**2*(8*Pk2*k1**2*s*(33*s - 28) + Pkd2*k1**2*k2*s*(86 - 111*s) + 2*Pkd2*k2**3*(21*r*(2*s - 1) + 30*s**2 - 40*s + 14) + k2**2*(2*Pk2*(42*r**2 + 6*r*s - 10*r - 50*s**2 + 16*s - 19) + 5*Pkdd2*k1**2*s*(3*s - 2))) + f*(3*bd1*(k1**4*s*(4*Pk2*(91*s - 131) + k2*(Pkd2*(230 - 190*s) + 33*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(200*C*s**2 - 1280*C*s + 14*K*(r*(s + 7) - 24*s**2 + 25*s - 7) + 98*r**2 + 2*r*(148*C*s + 82*C - 254*s + 41) - 352*s**2 + 1475*s - 326) - k2*(Pkd2*(178*C*s**2 - 506*C*s + 7*K*(2*r*(s + 3) - 33*s**2 + 30*s - 6) + r*(28*C*(2*s + 5) - 246*s + 53) - 299*s**2 + 638*s - 184) + 3*Pkdd2*k2*s*(-26*C*(s - 1) + 7*K*(3*s - 2) + 13*s - 13))) + k2**4*(2 - 4*C)*(Pk2*r*(59 - 20*r) + 6*Pkd2*k2*(r - 1))) + fd*k1**4*(3*s - 1)*(Pk2*(516*s - 964) + k2*(-8*Pkd2*(33*s - 47) + 45*Pkdd2*k2*(s - 1))) + fd*k1**2*k2**2*(Pk2*(8*C*(6*r*(15*s + 22) - 486*s**2 + 573*s - 191) + 1170*r**2 - 3*r*(603*s + 176) + 324*s**2 - 2565*s + 1066) + k2*(Pkd2*(C*(-12*r*(39*s + 35) + 2754*s**2 - 3066*s + 908) + 1935*r*s - 789*r - 135*s**2 + 66*s + 41) + Pkdd2*k2*(45 - 90*C)*(9*s**2 - 9*s + 2))) - 2*fd*k2**4*(Pk2*(2*C*(234*r**2 - 3*r*(270*s + 37) + 306*s - 1) - 288*r**2 + 810*r*s + 129*r - 306*s + 1) + Pkd2*k2*(36*C - 18)*(3*r - 1)*(2*s - 1)) - k1**2*k2**2*(21*bd2 - 42*gd2)*(-2*Pk2*(r*(s + 7) - 24*s**2 + 25*s - 7) + k2*(Pkd2*(2*r*(s + 3) - 33*s**2 + 30*s - 6) + 3*Pkdd2*k2*s*(3*s - 2)))) + 21*k1**2*k2**2*(b2*(4*Pk2*fd*(r*(s + 4) - 24*s**2 + 32*s - 10) + bd1*k2*s*(-Pkd2 + Pkdd2*k2)*(s - 1) - fd*k2*(Pkd2*(4*r*s + 6*r - 66*s**2 + 85*s - 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) - 2*g2*(Pk2*bd1*(r*(16 - 62*s) + s*(44*s - 44)) + 4*Pk2*fd*(r*(s + 4) - 24*s**2 + 32*s - 10) + bd1*k2*(10*Pkd2*r*(2*s - 1) - 33*Pkd2*s*(s - 1) + 11*Pkdd2*k2*s*(s - 1)) - fd*k2*(Pkd2*(4*r*s + 6*r - 66*s**2 + 85*s - 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))) + Dd*f*(f*(k1**4*(4*s - 1)*(Pk2*(516*s - 964) + k2*(-8*Pkd2*(33*s - 47) + 45*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(4*C*(4*r*(30*s + 49) - 648*s**2 + 730*s - 255) + 780*r**2 - 1206*r*s - 497*r + 216*s**2 - 1521*s + 571) - k2*(Pkd2*(2*C*(8*r*(39*s + 40) - 1836*s**2 + 1919*s - 564) - 2580*r*s + 967*r + 180*s**2 + 187*s - 219) + Pkdd2*k2*(90*C - 45)*(12*s**2 - 11*s + 2))) - 4*k2**4*(Pk2*(2*C*(156*r**2 - 10*r*(54*s + 13) + 234*s + 35) - 192*r**2 + 540*r*s + 148*r - 234*s - 35) + Pkd2*k2*(36*C - 18)*(2*r - 1)*(2*s - 1))) + k1**2*k2**2*(-21*b2 + 42*g2)*(4*Pk2*(-r*(2*s + 11) + 48*s**2 - 57*s + 17) + k2*(Pkd2*(8*r*s + 18*r - 132*s**2 + 145*s - 38) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))))))/(315*d**2*k1*k2**3*k3**2) - 2*D1**3*Pk3*ct**3*st**2*(D1*(231*b1*fd*k1**2*k2**2*(b1*k1**2*(K - 1)*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) + 6*b1*k2**2*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1))) - 2*g2*k1**2*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) - 24*g2*k2**2*(-4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(-2*r*s + 4*r - 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + f**3*k1**2*(-11*bd1*k1**2*k2**2*(-80*Pk2*(r*(42*s - 25) + 42*s**2 - 61*s + 15) + k2*(Pkd2*(840*r*s - 500*r + 840*s**2 - 1391*s + 300) + 57*Pkdd2*k2*s)) + 99*bd1*k2**4*(8*Pk2*(5*r**2 - 3*r*(11*s + 8) - 25*s**2 - 5*s + 19) + k2*(Pkd2*(68*r*s + 60*r - 25*s**2 + 42*s - 60) + 5*Pkdd2*k2*s*(5*s - 2))) + 25*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(92*s**2 - 79*s + 14) - 11*fd*k1**2*k2**2*(8*Pk2*(24*r*(37*s - 34) + 4980*s**2 - 3553*s + 874) + k2*(Pkd2*(-24*r*(88*s - 75) - 14460*s**2 + 10199*s - 2282) + 75*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 1320*fd*k2**4*(Pk2*(54*r**2 + r*(6*s - 68) - 21*s + 25) + 3*Pkd2*k2*(2*r - 1)*(3*s - 1))) + 11*f**2*k2**2*(-3*bd1*(k1**4*(2*Pk2*(-128*C*s**2 + 112*C*s + K*(r*(85*s - 149) + 540*s**2 - 533*s + 149) + r*(-8*C*(s - 9) - 269*s + 293) - 664*s**2 + 1021*s - 365) + k2*(Pkd2*(K*(r*(78 - 46*s) - 369*s**2 + 288*s - 78) + 2*r*(2*C*(s - 9) + 69*s - 75) + 2*s**2*(77*C + 193) - 2*s*(73*C + 248) + 186) - 3*Pkdd2*k2*s*(10*C*(s - 1) + K*(2 - 11*s) + 6*s + 2))) + k1**2*k2**2*(-4*Pk2*(-3*C*(10*r**2 - 69*r*s + 22*r - 40*s**2 + 88*s - 8) + 18*K*r**2 - 120*K*r*s + 208*K*r - 480*K*s**2 + 594*K*s - 226*K + 21*b1*(r + 2*s - 1) - 63*r**2 - 642*r*s + 150*r - 228*s**2 + 315*s - 51) + k2*(Pkd2*(4*C*(122*r*s - 32*r + 75*s**2 - 135*s + 12) - 444*K*r*s + 384*K*r - 1050*K*s**2 + 1104*K*s - 384*K + 3*b1*(14*r - 26*s**2 + 41*s - 14) - 674*r*s + 86*r - 129*s**2 + 435*s - 78) - 3*Pkdd2*k2*s*(20*C*(s - 1) - 30*K*s + 8*K + b1*(13 - 26*s) + 13*s + 1)))) + fd*(3*k1**4*(8*Pk2*(-3*C*(51*r*s - 43*r + 138*s**2 - 155*s + 45) + 2*b1*(2*r*(105*s - 62) + 210*s**2 - 205*s + 82) + 261*r*s - 210*r + 558*s**2 - 669*s + 202) + k2*(Pkd2*b1*(r*(496 - 840*s) - 840*s**2 + 163*s - 178) + 2*Pkd2*(3*C*(r*(54*s - 46) + 147*s**2 - 153*s + 44) - 3*r*(90*s - 73) - 639*s**2 + 726*s - 214) + Pkdd2*b1*k2*(219*s - 50) - 2*Pkdd2*k2*(3*s - 1)*(C*(3*s + 2) - 9*s + 3))) + k1**2*k2**2*(2*Pk2*(-2*C*(342*r**2 + 4860*r*s - 3711*r + 4608*s**2 - 7284*s + 2575) + 36*b1*(15*r**2 - 3*r*(33*s + 4) - 75*s**2 + 68*s + 1) + 522*r**2 + 1215*r*s - 4182*r + 3312*s**2 - 7149*s + 3216) + k2*(Pkd2*(4*C*(2340*r*s - 1284*r + 2421*s**2 - 3213*s + 970) - 9*b1*(-2*r*(102*s + 5) + 75*s**2 + 37*s + 4) - 2592*r*s + 2124*r - 5202*s**2 + 6258*s - 1928) + Pkdd2*k2*(3*s - 1)*(2*C*(8 - 78*s) + 45*b1*(5*s - 2) + 186*s - 62))) + 4*k2**4*(Pk2*(-12*C*(39*r**2 + r*(6*s - 115) + 10*s + 30) + 279*r**2 + 36*r*(s - 24) + 60*s + 233) + Pkd2*k2*(8*C - 4)*(21*r - 10)*(3*s - 1))) + 6*k1**2*(6*bd2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + gd2*(k1**2*(2*Pk2*(r*(85*s - 149) + 540*s**2 - 533*s + 149) + k2*(Pkd2*(-46*r*s + 78*r - 369*s**2 + 288*s - 78) + 3*Pkdd2*k2*s*(11*s - 2))) + 2*k2**2*(-4*Pk2*(9*r**2 + r*(104 - 60*s) - 240*s**2 + 297*s - 113) + 3*k2*(Pkd2*(-74*r*s + 64*r - 175*s**2 + 184*s - 64) + Pkdd2*k2*s*(15*s - 4)))))) + 33*f*k1**2*k2**2*(-6*b1**2*fd*k2**2*(-66*Pk2*(r + 2*s - 1) + k2*(Pkd2*(33*r - 13*s**2 + 66*s - 33) + 13*Pkdd2*k2*s**2)) + b1*(7*bd1*(k1**2*(K - 1)*(8*Pk2*(2*r*(s - 3) + 4*s**2 - 6*s + 3) + k2*(Pkd2*(-4*r*(s - 3) - 14*s**2 + 15*s - 6) + Pkdd2*k2*s*(2*s - 1))) + 6*k2**2*(-2*K*(2*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s))) + 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-8*r*s + 2*s**2 - 3*s + 2) + Pkdd2*k2**2*s*(1 - 2*s))) + fd*(k1**2*(4*Pk2*(8*C*(r*(s - 4) + 16*s**2 - 5*s + 4) + K*(-85*r*s + 137*r - 540*s**2 + 694*s - 212) + 269*r*s - 285*r + 664*s**2 - 1116*s + 348) + k2*(Pkd2*(-4*C*(2*r*(s - 4) + 77*s**2 - 10*s + 8) + K*(92*r*s - 144*r + 738*s**2 - 829*s + 230) - 276*r*s + 292*r - 772*s**2 + 1404*s - 420) + 3*Pkdd2*k2*(K*(-22*s**2 + 15*s - 2) + s**2*(20*C + 12) - 32*s + 8))) + 2*k2**2*(-2*Pk2*(C*(60*r**2 + r*(254 - 414*s) - 240*s**2 + 727*s - 314) + K*(-36*r**2 + 240*r*s - 260*r + 960*s**2 - 1044*s + 282) + 126*r**2 + 1284*r*s - 719*r + 456*s**2 - 817*s + 305) + k2*(Pkd2*(-4*C*(2*r*(61*s - 36) + 75*s**2 - 177*s + 72) + 3*K*(148*r*s - 116*r + 350*s**2 - 371*s + 98) + 674*r*s - 390*r + 129*s**2 - 426*s + 186) + 3*Pkdd2*k2*(K*(-30*s**2 + 23*s - 4) + s**2*(20*C + 13) - 28*s + 7)))) - 14*gd2*(k1**2*(8*Pk2*(r*(s - 3) + 2*s**2 - 4*s + 3) + k2*(Pkd2*(-2*r*s + 6*r - 7*s**2 + 8*s - 6) + Pkdd2*k2*s**2)) + 12*k2**2*(2*Pk2*(-2*r**2 + r + (1 - 2*s)**2) + k2*(Pkd2*(-2*r*s + 2*r - 5*s**2 + 5*s - 2) + Pkdd2*k2*s**2)))) - 14*bd1*g2*(k1**2*(8*Pk2*(r*(s - 3) + s*(2*s - 2)) + k2*(-2*Pkd2*r*(s - 3) - 7*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + 12*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))) + 2*fd*(6*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + g2*(k1**2*(4*Pk2*(r*(85*s - 137) + 540*s**2 - 694*s + 212) + k2*(Pkd2*(-92*r*s + 144*r - 738*s**2 + 829*s - 230) + 3*Pkdd2*k2*(22*s**2 - 15*s + 2))) + 2*k2**2*(-4*Pk2*(18*r**2 + r*(130 - 120*s) - 480*s**2 + 522*s - 141) + 3*k2*(Pkd2*(-148*r*s + 116*r - 350*s**2 + 371*s - 98) + Pkdd2*k2*(30*s**2 - 23*s + 4))))))) + Dd*f*(231*b1*k1**2*k2**2*(b1*k1**2*(K - 1)*(8*Pk2*(2*r*(2*s - 5) + 8*s**2 - 12*s + 7) + k2*(Pkd2*(-8*r*s + 20*r - 28*s**2 + 27*s - 14) + Pkdd2*k2*s*(4*s - 1))) + 6*b1*k2**2*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) - 2*g2*k1**2*(8*Pk2*(2*r*(2*s - 5) + 8*s**2 - 12*s + 7) + k2*(Pkd2*(-8*r*s + 20*r - 28*s**2 + 27*s - 14) + Pkdd2*k2*s*(4*s - 1))) - 24*g2*k2**2*(-4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(-8*r*s + 9*r - 20*s**2 + 23*s - 8) + Pkdd2*k2*s*(4*s - 1)))) + f**3*k1**2*(25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(92*s**2 - 79*s + 14) - 11*k1**2*k2**2*(8*Pk2*(24*r*(37*s - 34) + 4980*s**2 - 3553*s + 874) + k2*(Pkd2*(-24*r*(88*s - 75) - 14460*s**2 + 10199*s - 2282) + 75*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 1320*k2**4*(Pk2*(54*r**2 + r*(6*s - 68) - 21*s + 25) + 3*Pkd2*k2*(2*r - 1)*(3*s - 1))) + 11*f**2*k2**2*(2*k1**4*(4*Pk2*(-6*C*(102*r*s - 86*r + 276*s**2 - 304*s + 89) + 2*b1*(7*r*(120*s - 71) + 840*s**2 - 920*s + 321) + 1044*r*s - 849*r + 2232*s**2 - 2682*s + 825) + k2*(Pkd2*b1*(r*(994 - 1680*s) - 1680*s**2 + 940*s - 417) + 3*Pkd2*(C*(8*r*(27*s - 23) + 588*s**2 - 599*s + 178) - 360*r*s + 295*r - 852*s**2 + 963*s - 290) - 3*Pkdd2*k2*(4*s - 1)*(3*C*s + 2*C - 25*b1 - 9*s + 3))) + k1**2*k2**2*(4*Pk2*(-2*C*(228*r**2 + 3240*r*s - 2494*r + 3072*s**2 - 5104*s + 1869) + 18*b1*(20*r**2 - 12*r*(11*s + 3) - 100*s**2 + 63*s + 20) + 348*r**2 + 810*r*s - 3032*r + 2208*s**2 - 5089*s + 2462) + k2*(Pkd2*(4*C*(3120*r*s - 1648*r + 3228*s**2 - 4407*s + 1334) + 9*b1*(r*(272*s + 70) - 100*s**2 + 5*s - 64) - 3456*r*s + 2868*r - 6936*s**2 + 8414*s - 2672) + Pkdd2*k2*(4*s - 1)*(2*C*(8 - 78*s) + 45*b1*(5*s - 2) + 186*s - 62))) + 8*k2**4*(Pk2*(-4*C*(78*r**2 + 12*r*s - 247*r + 10*s + 100) + 186*r**2 + 24*r*s - 615*r + 20*s + 253) + Pkd2*k2*(4*C - 2)*(r*(84*s - 26) - 50*s + 15))) + 33*f*k1**2*k2**2*(-3*b1**2*k2**2*(-160*Pk2*(r + 2*s - 1) + k2*(Pkd2*(80*r - 52*s**2 + 173*s - 80) + 13*Pkdd2*k2*s*(4*s - 1))) + b1*(k1**2*(4*Pk2*(4*C*(r*(4*s - 26) + 64*s**2 - 34*s + 17) + K*(-170*r*s + 286*r - 1080*s**2 + 1227*s - 361) + 538*r*s - 578*r + 1328*s**2 - 2153*s + 677) + k2*(Pkd2*(-2*C*(r*(8*s - 52) + 308*s**2 - 113*s + 34) + K*(4*r*(46*s - 75) + 1476*s**2 - 1405*s + 386) - 552*r*s + 592*r - 1544*s**2 + 2502*s - 756) + 3*Pkdd2*k2*(4*s - 1)*(K*(2 - 11*s) + s*(10*C + 6) - 8))) + k2**2*(-8*Pk2*(C*(60*r**2 + r*(182 - 414*s) - 240*s**2 + 667*s - 206) + K*(-36*r**2 + 240*r*s - 338*r + 960*s**2 - 1116*s + 367) + 126*r**2 + 1284*r*s - 506*r + 456*s**2 - 742*s + 218) + k2*(Pkd2*(-4*C*(4*r*(122*s - 53) + 300*s**2 - 663*s + 192) + 6*K*(4*r*(74*s - 61) + 700*s**2 - 739*s + 226) + 2696*r*s - 998*r + 516*s**2 - 1809*s + 582) + 3*Pkdd2*k2*(4*s - 1)*(K*(8 - 30*s) + s*(20*C + 13) - 14)))) + 12*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 2*g2*(k1**2*(4*Pk2*(2*r*(85*s - 143) + 1080*s**2 - 1227*s + 361) + k2*(Pkd2*(-184*r*s + 300*r - 1476*s**2 + 1405*s - 386) + 3*Pkdd2*k2*(44*s**2 - 19*s + 2))) + 2*k2**2*(-4*Pk2*(36*r**2 + r*(338 - 240*s) - 960*s**2 + 1116*s - 367) + 3*k2*(Pkd2*(-296*r*s + 244*r - 700*s**2 + 739*s - 226) + Pkdd2*k2*(60*s**2 - 31*s + 4)))))))/(3465*d**2*k1*k2**3*k3**4) + D1**3*Pk3*ct**3*(D1*(-42*b1*fd*k1**2*k2**2*(2*Pkd2*b1**2*k2**3*s*(r + s - 1) + 6*Pkd2*b2*k2**3*s*(r + s) + b1*k1**2*(4*Pk2*(-8*C*s**2 + 8*C*s + K*(2*r*(9*s - 2) + 7*s**2 - 8*s + 4) + r*(-8*C*s - 17*s + 4) - 6*s**2 - 4) + k2*(Pkd2*(16*C*s**2 - 16*C*s + K*(-2*r*(9*s + 5) + 13*s**2 - 20*s + 10) + 2*r*(s*(8*C + 8) + 5) - 13*s**2 + 36*s - 10) + Pkdd2*k2*s**2*(7 - 9*K))) + b1*k2**2*(Pk2*(80*C*(r - 1)*(r + s - 1) + 2*K*(9*r**2 + r*(4 - 8*s) - 22*(s - 1)**2) - 86*r**2 - 111*r*s + 176*r + 36*s - 58) + k2*(Pkd2*(K*(2*r*(9*s - 19) + 39*s**2 - 76*s + 38) + r*(s*(39 - 48*C) + 20) + 4*s**2*(8*C - 5) + 4*s*(12*C + 6) - 20) + Pkdd2*k2*s**2*(5 - 9*K))) + 2*g2*k1**2*(-4*Pk2*(2*r*(9*s - 2) + 7*s**2 - 8*s + 4) + k2*(Pkd2*(2*r*(9*s + 5) - 13*s**2 + 20*s - 10) + 9*Pkdd2*k2*s**2)) + 2*g2*k2**2*(-2*Pk2*(9*r**2 + r*(4 - 8*s) - 22*(s - 1)**2) + k2*(Pkd2*(-18*r*s + 38*r - 39*s**2 + 76*s - 38) + 9*Pkdd2*k2*s**2))) + f**3*k1**2*(3*bd1*(5*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) - 3*k1**2*k2**2*(16*Pk2*(15*r**2 - r*(4*s + 27) - 24*s**2 + 14*s + 12) + k2*(Pkd2*(192*r*s + 60*r + 240*s**2 - 209*s - 60) + 15*Pkdd2*k2*s)) - 12*k2**4*(2*Pk2*(36*r**2 + 92*r*s - 63*r + 35*s**2 - 55*s + 20) + Pkd2*k2*(7*r*(4*s - 3) + 30*s**2 - 54*s + 21))) + 5*fd*k1**2*(k1**2*(4*s - 1)*(40*Pk2*(9*s - 8) + k2*(Pkd2*(122 - 153*s) + 7*Pkdd2*k2*(3*s - 2))) + 24*k2**2*(Pk2*(60*r**2 + 8*r*s - 34*r - 140*s**2 + 63*s - 6) + 2*Pkd2*k2*(36*r*s - 18*r + 40*s**2 - 44*s + 13)))) - f**2*(-216*C*Pk2*fd*k1**4*k2**2*r*s - 1944*C*Pk2*fd*k1**4*k2**2*r + 3888*C*Pk2*fd*k1**4*k2**2*s**2 + 4752*C*Pk2*fd*k1**4*k2**2*s - 1344*C*Pk2*fd*k1**4*k2**2 - 27720*C*Pk2*fd*k1**2*k2**4*r**2 - 936*C*Pk2*fd*k1**2*k2**4*r*s + 25560*C*Pk2*fd*k1**2*k2**4*r - 3456*C*Pk2*fd*k1**2*k2**4*s**2 + 6072*C*Pk2*fd*k1**2*k2**4*s - 6976*C*Pk2*fd*k1**2*k2**4 - 3600*C*Pk2*fd*k2**6*r**2 + 4752*C*Pk2*fd*k2**6*r*s + 2328*C*Pk2*fd*k2**6*r - 1872*C*Pk2*fd*k2**6*s - 280*C*Pk2*fd*k2**6 - 4464*C*Pkd2*fd*k1**4*k2**3*r*s + 2784*C*Pkd2*fd*k1**4*k2**3*r - 5472*C*Pkd2*fd*k1**4*k2**3*s**2 + 2400*C*Pkd2*fd*k1**4*k2**3*s - 624*C*Pkd2*fd*k1**4*k2**3 - 23184*C*Pkd2*fd*k1**2*k2**5*r*s + 11472*C*Pkd2*fd*k1**2*k2**5*r - 19548*C*Pkd2*fd*k1**2*k2**5*s**2 + 22164*C*Pkd2*fd*k1**2*k2**5*s - 6464*C*Pkd2*fd*k1**2*k2**5 - 864*C*Pkd2*fd*k2**7*r*s + 432*C*Pkd2*fd*k2**7*r + 288*C*Pkd2*fd*k2**7*s - 144*C*Pkd2*fd*k2**7 - 1080*C*Pkdd2*fd*k1**4*k2**4*s**2 + 1440*C*Pkdd2*fd*k1**4*k2**4*s - 360*C*Pkdd2*fd*k1**4*k2**4 - 1620*C*Pkdd2*fd*k1**2*k2**6*s**2 + 1620*C*Pkdd2*fd*k1**2*k2**6*s - 360*C*Pkdd2*fd*k1**2*k2**6 - 360*Pk2*b1*fd*k1**6*s**2 + 6480*Pk2*b1*fd*k1**4*k2**2*r**2 - 1728*Pk2*b1*fd*k1**4*k2**2*r*s - 5328*Pk2*b1*fd*k1**4*k2**2*r - 10368*Pk2*b1*fd*k1**4*k2**2*s**2 + 3168*Pk2*b1*fd*k1**4*k2**2*s + 576*Pk2*b1*fd*k1**4*k2**2 + 7776*Pk2*b1*fd*k1**2*k2**4*r**2 + 19872*Pk2*b1*fd*k1**2*k2**4*r*s - 11016*Pk2*b1*fd*k1**2*k2**4*r + 7560*Pk2*b1*fd*k1**2*k2**4*s**2 - 13248*Pk2*b1*fd*k1**2*k2**4*s + 4104*Pk2*b1*fd*k1**2*k2**4 + 3060*Pk2*fd*k1**4*k2**2*r**2 + 2448*Pk2*fd*k1**4*k2**2*r*s + 1068*Pk2*fd*k1**4*k2**2*r - 5184*Pk2*fd*k1**4*k2**2*s**2 + 192*Pk2*fd*k1**4*k2**2*s - 456*Pk2*fd*k1**4*k2**2 + 27324*Pk2*fd*k1**2*k2**4*r**2 + 20250*Pk2*fd*k1**2*k2**4*r*s - 26856*Pk2*fd*k1**2*k2**4*r + 8424*Pk2*fd*k1**2*k2**4*s**2 - 14670*Pk2*fd*k1**2*k2**4*s + 7620*Pk2*fd*k1**2*k2**4 + 2016*Pk2*fd*k2**6*r**2 - 2376*Pk2*fd*k2**6*r*s - 1236*Pk2*fd*k2**6*r + 936*Pk2*fd*k2**6*s + 140*Pk2*fd*k2**6 - 576*Pk2*gd2*k1**4*k2**2*r*s + 984*Pk2*gd2*k1**4*k2**2*r - 1392*Pk2*gd2*k1**4*k2**2*s**2 - 360*Pk2*gd2*k1**4*k2**2*s - 984*Pk2*gd2*k1**4*k2**2 + 8568*Pk2*gd2*k1**2*k2**4*r**2 + 8736*Pk2*gd2*k1**2*k2**4*r*s - 9408*Pk2*gd2*k1**2*k2**4*r + 2016*Pk2*gd2*k1**2*k2**4*s**2 - 1344*Pk2*gd2*k1**2*k2**4*s + 840*Pk2*gd2*k1**2*k2**4 + 225*Pkd2*b1*fd*k1**6*k2*s**2 + 5184*Pkd2*b1*fd*k1**4*k2**3*r*s - 2520*Pkd2*b1*fd*k1**4*k2**3*r + 6480*Pkd2*b1*fd*k1**4*k2**3*s**2 - 2727*Pkd2*b1*fd*k1**4*k2**3*s + 1278*Pkd2*b1*fd*k1**4*k2**3 + 3024*Pkd2*b1*fd*k1**2*k2**5*r*s - 2268*Pkd2*b1*fd*k1**2*k2**5*r + 3240*Pkd2*b1*fd*k1**2*k2**5*s**2 - 2880*Pkd2*b1*fd*k1**2*k2**5*s + 1188*Pkd2*b1*fd*k1**2*k2**5 + 6984*Pkd2*fd*k1**4*k2**3*r*s - 4884*Pkd2*fd*k1**4*k2**3*r + 8496*Pkd2*fd*k1**4*k2**3*s**2 - 7704*Pkd2*fd*k1**4*k2**3*s + 2476*Pkd2*fd*k1**4*k2**3 + 14994*Pkd2*fd*k1**2*k2**5*r*s - 7734*Pkd2*fd*k1**2*k2**5*r + 12258*Pkd2*fd*k1**2*k2**5*s**2 - 14016*Pkd2*fd*k1**2*k2**5*s + 4222*Pkd2*fd*k1**2*k2**5 + 432*Pkd2*fd*k2**7*r*s - 216*Pkd2*fd*k2**7*r - 144*Pkd2*fd*k2**7*s + 72*Pkd2*fd*k2**7 + 1920*Pkd2*gd2*k1**4*k2**3*r*s - 984*Pkd2*gd2*k1**4*k2**3*r + 2496*Pkd2*gd2*k1**4*k2**3*s**2 - 1200*Pkd2*gd2*k1**4*k2**3*s + 984*Pkd2*gd2*k1**4*k2**3 + 9744*Pkd2*gd2*k1**2*k2**5*r*s - 3696*Pkd2*gd2*k1**2*k2**5*r + 9324*Pkd2*gd2*k1**2*k2**5*s**2 - 11088*Pkd2*gd2*k1**2*k2**5*s + 3696*Pkd2*gd2*k1**2*k2**5 - 45*Pkdd2*b1*fd*k1**6*k2**2*s**2 - 1215*Pkdd2*b1*fd*k1**4*k2**4*s + 270*Pkdd2*b1*fd*k1**4*k2**4 + 810*Pkdd2*fd*k1**4*k2**4*s**2 - 1080*Pkdd2*fd*k1**4*k2**4*s + 270*Pkdd2*fd*k1**4*k2**4 + 810*Pkdd2*fd*k1**2*k2**6*s**2 - 810*Pkdd2*fd*k1**2*k2**6*s + 180*Pkdd2*fd*k1**2*k2**6 + 504*Pkdd2*gd2*k1**4*k2**4*s**2 - 504*Pkdd2*gd2*k1**4*k2**4*s + 756*Pkdd2*gd2*k1**2*k2**6*s**2 - 504*Pkdd2*gd2*k1**2*k2**6*s + 3*bd1*(k1**4*k2**2*(4*Pk2*(12*C*(50*r*s - 9*r + 17*s**2 - 29*s + 7) + 24*K*r*s - 41*K*r + 58*K*s**2 + 15*K*s + 41*K - 3*b1*(2*r*(8*s - 23) + 16*s**2 - 37*s + 24) + 87*r**2 - 610*r*s + 238*r - 444*s**2 + 761*s - 265) + k2*(Pkd2*(-12*C*(14*r*(5*s - 1) - 11*s**2 - 17*s + 14) - 4*K*(80*r*s - 41*r + 104*s**2 - 50*s + 41) + 3*b1*(4*r*(8*s - 23) + 26*s**2 - 71*s + 48) + 1604*r*s - 788*r + 1012*s**2 - 1536*s + 716) + 3*Pkdd2*k2*s*(b1*(6*s - 3) + (s - 1)*(-60*C - 28*K + 66)))) + k1**2*k2**4*(2*Pk2*(4*C*(5*r**2 - 697*r*s - 39*r - 50*s**2 + 530*s - 106) - 714*K*r**2 - 728*K*r*s + 784*K*r - 168*K*s**2 + 112*K*s - 70*K + 14*b1*(16*r**2 + 17*r*(2*s - 1) - 27*s + 11) + 1272*r**2 + 3014*r*s - 1520*r + 688*s**2 - 2105*s + 918) + k2*(Pkd2*(4*C*(r*(54 - 14*s) + 71*s**2 + 37*s - 54) - 14*K*(4*r*(29*s - 11) + 111*s**2 - 132*s + 44) + 21*b1*(2*r*(4*s - 5) + 2*s**2 - 5*s + 6) + 912*r*s - 578*r + 354*s**2 - 840*s + 476) + 3*Pkdd2*k2*s*(-60*C*(s - 1) - 42*K*s + 28*K + 21*b1*(2*s - 1) + 44*s - 44))) + 4*k2**6*(-Pk2*(C*(40*r**2 - 26*r*s + 24*r + 24*s - 48) - 30*r**2 + 13*r*s + 7*r - 12*s + 24) + Pkd2*k2*(12*C - 6)*(r*(4*s - 2) - s + 1))) + 36*bd2*k1**4*k2**2*(2*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) - 84*bd2*k1**2*k2**4*(2*Pk2*(8*r**2 + 2*r*(s - 4) + s*(5 - 6*s)) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))) - 6*f*k2**2*(b1**2*k1**2*(7*Pkd2*bd1*k2**3*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + fd*(k1**2*(Pk2*(r*(72 - 96*s) - 96*s**2 + 90*s - 72) + 3*k2*(Pkd2*(4*r*(4*s - 3) + 13*s**2 - 15*s + 12) + 3*Pkdd2*k2*s**2)) + 7*k2**2*(2*Pk2*(16*r**2 + r*(34*s - 19) - 47*s + 9) + 3*k2*(Pkd2*(4*r*s + 7*r + s**2 + 10*s - 7) + 3*Pkdd2*k2*s**2)))) + b1*(-7*bd1*(k1**4*(4*Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-36*r*s + r - 14*s**2 + 15*s + 3) + 34*r*s - 3*r + 12*s**2 - 7*s - 7) + k2*(Pkd2*(-8*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(36*r*s + 6*r - 26*s**2 + 19*s - 10) - 32*r*s - 2*r + 26*s**2 - 33*s + 18) + Pkdd2*k2*s*(9*K - 7)*(2*s - 1))) + k1**2*k2**2*(Pk2*(-40*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + K*(-36*r**2 + 4*r*(8*s + 29) + 88*s**2 - 86*s - 36) + 172*r**2 + 222*r*s - 302*r - 61*s + 68) + k2*(Pkd2*(8*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) - K*(36*r*s + 2*r + 78*s**2 - 101*s + 14) - 78*r*s + 17*r + 40*s**2 - 20*s + 2) + Pkdd2*k2*s*(9*K - 5)*(2*s - 1)))) + fd*(k1**4*(2*Pk2*(24*C*(r*(50*s - 4) + 17*s**2 - 33*s + 4) + K*(48*r*s - 73*r + 116*s**2 + 38*s - 48) + 174*r**2 - 1220*r*s + 207*r - 888*s**2 + 1282*s - 242) + k2*(-2*Pkd2*(-6*C*(-7*r*(10*s + 1) + 11*s**2 + 21*s + 7) + K*(5*r*(32*s - 23) + 208*s**2 - 110*s + 3) - 802*r*s + 217*r - 506*s**2 + 621*s - 76) - 3*Pkdd2*k2*(14*K*(2*s**2 - 3*s + 1) + s**2*(60*C - 66) + 21*s - 7))) + k1**2*k2**2*(Pk2*(4*C*(10*r**2 - 1394*r*s + 347*r - 100*s**2 + 1350*s - 376) - 28*K*(51*r**2 + 52*r*s - 26*r + 12*s**2 - 4*s - 1) + 2544*r**2 + 6028*r*s - 3342*r + 1376*s**2 - 4973*s + 1404) - k2*(Pkd2*(4*C*(r*(14*s + 87) - 71*s**2 + 167*s - 87) + 7*K*(232*r*s - 130*r + 222*s**2 - 227*s + 58) - 912*r*s - 13*r - 354*s**2 + 66*s + 195) + 3*Pkdd2*k2*(7*K*(6*s**2 - 7*s + 2) + s**2*(60*C - 44)))) + 2*k2**4*(2*r - 1)*(Pk2*(C*(-40*r + 26*s + 96) + 30*r - 13*s - 67) + Pkd2*k2*s*(48*C - 24))) + 14*k1**2*(Pkd2*bd2*k2**3*s*(3*r + 3*s - 4) + gd2*k1**2*(-4*Pk2*(3*r*(6*s + 1) + 7*s**2 - 8*s - 3) + k2*(Pkd2*(2*r*(9*s + 5) - 13*s**2 + 6*s - 10) + 9*Pkdd2*k2*s**2)) + gd2*k2**2*(-2*Pk2*(9*r**2 - r*(8*s + 27) - 22*s**2 + 21*s + 18) + k2*(Pkd2*(-18*r*s + 14*r - 39*s**2 + 62*s - 14) + 9*Pkdd2*k2*s**2)))) + 2*k1**2*(7*Pkd2*b2*bd1*k2**3*(3*r*s + r + s*(3*s - 3)) + b2*fd*(3*k1**2*(2*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) - 7*k2**2*(2*Pk2*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 3*Pkd2*k2*(r*(16*s - 9) + 16*s**2 - 18*s + 5))) - 7*bd1*g2*(k1**2*(4*Pk2*(2*r*(9*s - 2) + s*(7*s - 7)) + k2*(Pkd2*r*(4 - 18*s) + 13*Pkd2*s*(s - 1) - 9*Pkdd2*k2*s*(s - 1))) + k2**2*(2*Pk2*(9*r**2 - r*(8*s + 31) - s*(22*s - 22)) + k2*(2*Pkd2*r*(9*s + 8) + 39*Pkd2*s*(s - 1) - 9*Pkdd2*k2*s*(s - 1)))) + fd*g2*(2*k1**2*(Pk2*(r*(73 - 48*s) - 116*s**2 - 38*s + 48) + k2*(Pkd2*(5*r*(32*s - 23) + 208*s**2 - 110*s + 3) + 21*Pkdd2*k2*(2*s**2 - 3*s + 1))) + 7*k2**2*(4*Pk2*(51*r**2 + 26*r*(2*s - 1) + 12*s**2 - 4*s - 1) + k2*(Pkd2*(232*r*s - 130*r + 222*s**2 - 227*s + 58) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))))) + Dd*f*(-42*b1*k1**2*k2**2*(Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 2*Pkd2*b2*k2**3*(12*r*s + r + s*(12*s - 11)) + b1*(k1**2*(-4*Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + K*(-72*r*s + 2*r - 28*s**2 + 31*s + 2) + 68*r*s - 4*r + 24*s**2 - 8*s - 6) + k2*(Pkd2*(8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + K*(-72*r*s - 26*r + 52*s**2 - 45*s + 30) + 64*r*s + 22*r - 52*s**2 + 89*s - 38) - Pkdd2*k2*s*(9*K - 7)*(4*s - 1))) + k2**2*(2*Pk2*(20*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) + K*(36*r**2 - 32*r*s - 81*r - 88*s**2 + 108*s + 14) - 172*r**2 - 222*r*s + 336*r + 79*s - 117) + k2*(Pkd2*(8*C*(r*(3 - 24*s) + 16*s**2 + 14*s - 3) + K*(72*r*s - 50*r + 156*s**2 - 239*s + 66) + 156*r*s + 13*r - 80*s**2 + 44*s - 32) - Pkdd2*k2*s*(9*K - 5)*(4*s - 1)))) + 2*g2*(k1**2*(-4*Pk2*(r*(72*s - 2) + 28*s**2 - 31*s - 2) + k2*(Pkd2*(72*r*s + 26*r - 52*s**2 + 45*s - 30) + 9*Pkdd2*k2*s*(4*s - 1))) + k2**2*(-2*Pk2*(36*r**2 - r*(32*s + 81) - 88*s**2 + 108*s + 14) + k2*(Pkd2*(-72*r*s + 50*r - 156*s**2 + 239*s - 66) + 9*Pkdd2*k2*s*(4*s - 1))))) + 5*f**3*k1**4*(k1**2*(4*s - 1)*(40*Pk2*(9*s - 8) + k2*(Pkd2*(122 - 153*s) + 7*Pkdd2*k2*(3*s - 2))) + 24*k2**2*(Pk2*(60*r**2 + 8*r*s - 34*r - 140*s**2 + 63*s - 6) + 2*Pkd2*k2*(36*r*s - 18*r + 40*s**2 - 44*s + 13))) + f**2*(15*b1*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + 2*k1**4*k2**2*(-4*Pk2*(C*(-36*r*s - 345*r + 648*s**2 + 810*s - 66) + 72*b1*(15*r**2 - 4*r*(s + 4) - 24*s**2 + 9*s + 4) + 510*r**2 + 408*r*s + 170*r - 864*s**2 + 46*s - 221) + k2*(Pkd2*(4*C*(r*(744*s - 439) + 912*s**2 - 398*s + 169) - 9*b1*(2*r*(192*s - 55) + 480*s**2 - 256*s + 41) - 4656*r*s + 3146*r - 5664*s**2 + 5220*s - 1942) + 45*Pkdd2*k2*(3*b1 + (4*C - 3)*(s - 1))*(4*s - 1))) + 2*k1**2*k2**4*(8*C*Pk2*(2310*r**2 + 3*r*(26*s - 827) + 288*s**2 - 427*s + 742) - 36*Pk2*b1*(144*r**2 + 8*r*(46*s - 27) + 140*s**2 - 239*s + 77) - 6*Pk2*(3036*r**2 + 3*r*(750*s - 1109) + 936*s**2 - 1601*s + 965) + Pkd2*k2*(2*C*(7728*r*s - 3604*r + 6516*s**2 - 7693*s + 2352) - 36*b1*(14*r*(4*s - 3) + 60*s**2 - 67*s + 27) - 9996*r*s + 4891*r - 8172*s**2 + 9799*s - 3135) + Pkdd2*k2**2*(90*C - 45)*(12*s**2 - 11*s + 2)) + 8*k2**6*(Pk2*(2*C*(300*r**2 - 2*r*(198*s + 137) + 162*s + 71) - 336*r**2 + 4*r*(99*s + 73) - 162*s - 71) + Pkd2*k2*(36*C - 18)*(2*r - 1)*(2*s - 1))) - 3*f*k2**2*(b1**2*k1**2*(-3*k1**2*(8*Pk2*(16*r*s - 29*r + 16*s**2 - 26*s + 18) + k2*(Pkd2*(-64*r*s + 116*r - 52*s**2 + 101*s - 72) + 3*Pkdd2*k2*s*(1 - 4*s))) + 7*k2**2*(8*Pk2*(16*r**2 + 2*r*(17*s - 9) - 37*s + 10) + 3*k2*(Pkd2*(16*r*s + 4*r + 4*s**2 + 15*s - 8) + 3*Pkdd2*k2*s*(4*s - 1)))) + 2*b1*(k1**4*(2*Pk2*(12*C*(4*r*(50*s - 3) + 68*s**2 - 133*s + 10) + K*(96*r*s - 155*r + 232*s**2 + 68*s + 34) + 348*r**2 - 2440*r*s + 443*r - 1776*s**2 + 2798*s - 592) + k2*(Pkd2*(C*(-84*r*(20*s + 1) + 264*s**2 + 606*s + 84) - 2*K*(320*r*s - 197*r + 416*s**2 - 210*s + 85) + 3208*r*s - 982*r + 2024*s**2 - 2802*s + 664) - 3*Pkdd2*k2*(4*s - 1)*(14*K*(s - 1) + s*(30*C - 33) + 7))) - k1**2*k2**2*(-4*Pk2*(C*(20*r**2 + r*(255 - 2788*s) - 200*s**2 + 2650*s - 434) - 14*K*(51*r**2 + 52*r*s - 41*r + 12*s**2 - 6*s + 2) + 1272*r**2 + 3014*r*s - 1654*r + 688*s**2 - 2447*s + 701) + k2*(Pkd2*(2*C*(2*r*(28*s + 87) - 284*s**2 + 391*s - 174) + 7*K*(464*r*s - 218*r + 444*s**2 - 491*s + 146) - 1824*r*s + 292*r - 708*s**2 + 741*s - 59) + 3*Pkdd2*k2*(4*s - 1)*(7*K*(3*s - 2) + s*(30*C - 22)))) + 4*k2**4*(2*r - 1)*(Pk2*(C*(-40*r + 26*s + 60) + 30*r - 13*s - 49) + Pkd2*k2*(6*C - 3)*(8*s - 1))) + 4*k1**2*(3*b2*k1**2*(2*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) - 7*b2*k2**2*(2*Pk2*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 3*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) - 2*g2*k1**2*(Pk2*(r*(96*s - 155) + 232*s**2 + 68*s + 34) - k2*(Pkd2*(320*r*s - 197*r + 416*s**2 - 210*s + 85) + 21*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 7*g2*k2**2*(8*Pk2*(51*r**2 + r*(52*s - 41) + 12*s**2 - 6*s + 2) + k2*(Pkd2*(464*r*s - 218*r + 444*s**2 - 491*s + 146) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2)))))))/(315*d**2*k1*k2**3*k3**4) + 8*D1**3*Pk3*ct**2*f*k1**2*k2**2*st**6*(-4*Pk2 + Pkd2*k2)*(396*C*D1*f*fd*r*s - 132*C*D1*f*fd*r + 396*C*D1*f*fd*s**2 - 396*C*D1*f*fd*s + 88*C*D1*f*fd + 528*C*Dd*f**2*r*s - 154*C*Dd*f**2*r + 528*C*Dd*f**2*s**2 - 528*C*Dd*f**2*s + 110*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 2072*D1*f**2*fd*r*s - 595*D1*f**2*fd*r + 2072*D1*f**2*fd*s**2 - 2072*D1*f**2*fd*s + 427*D1*f**2*fd - 396*D1*f*fd*r*s + 132*D1*f*fd*r - 396*D1*f*fd*s**2 + 396*D1*f*fd*s - 88*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 2072*Dd*f**3*r*s - 595*Dd*f**3*r + 2072*Dd*f**3*s**2 - 2072*Dd*f**3*s + 427*Dd*f**3 - 528*Dd*f**2*r*s + 154*Dd*f**2*r - 528*Dd*f**2*s**2 + 528*Dd*f**2*s - 110*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**6) - 2*D1**3*Pk3*ct**2*f*k1**2*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(148*s**2 - 85*s + 12) + f*fd*(1 - 3*s)**2*(22*C - 22) - 99*f*s*(2*s - 1)*(-K*bd1 + bd1 + 2*gd2) - 198*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(37*s - 12) + f*(22*C - 22)*(3*s - 1) + 198*g2*(1 - 2*s)) + 99*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(693*d**2*k3**4) - 4*D1**3*Pk3*ct**2*st**4*(99*D1*bd1*f*(f**2*k2**2*(-2*Pk2*k2**2*(r - 1)*(5*r + 5*s - 9) + 5*k1**2*(Pk2*(30*r**2 + 22*r*s - 36*r - 8*s**2 - 2*s + 2) + Pkd2*k2*(19*r*s - 4*r + 19*s**2 - 21*s + 6))) + 2*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(2*Pk2*(2*C*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) + K*(-25*r**2 - 9*r*s + 8*r + 16*s**2 - 49*s + 17) + 40*r**2 + 63*r*s - 47*r + 23*s**2 - 15*s + 9) + Pkd2*k2*(-2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(23 - 36*s) - 36*s**2 + 64*s - 23) + 12*r*(s - 1) + 12*s**2 - 28*s + 10)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 14*k1**2*k2**2*(-b1*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 1386*b1**2*k1**2*k2**2*(K - 1)*(2*D1*fd*(Pk2*(r**2 + 4*r*s - 2*r + 3*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + Dd*f*(2*Pk2*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 99*b1*(D1*(f**2*fd*k2**2*(-2*Pk2*k2**2*(15*r**2 + r*(15*s - 47) - 35*s + 24) + 5*k1**2*(2*Pk2*(45*r**2 + 33*r*(s - 1) - 12*s**2 + 5*s + 4) + Pkd2*k2*(r*(57*s - 34) + 57*s**2 - 72*s + 22))) + 2*f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(2*Pk2*(8*C*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + 2*K*(-25*r**2 - 9*r*s + r + 16*s**2 - 30*s + 11) + 80*r**2 + 126*r*s - 70*r + 46*s**2 - 39*s + 6) + Pkd2*k2*(-2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(-16*C*s + 24*s - 11) - (2*s - 1)*(8*C*s - 12*s + 9))) - 30*k2**4*(2*r + 2*s - 1)*(K*Pk2*(6*r + 2*s - 1) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 14*gd2*k1**2*k2**2*(-2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 56*fd*g2*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(-2*Pk2*k2**2*(20*r**2 + r*(20*s - 61) - 40*s + 33) + 5*k1**2*(2*Pk2*(60*r**2 + 44*r*s - 51*r - 16*s**2 + 4*s + 5) + Pkd2*k2*(76*r*s - 38*r + 76*s**2 - 93*s + 28))) + 2*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + k1**2*k2**2*(2*Pk2*(2*C*(8*r**2 + 16*r*(2*s - 1) + 24*s**2 - 26*s + 7) - 2*K*(50*r**2 + 18*r*s - 9*r - 32*s**2 + 79*s - 28) + 160*r**2 + 252*r*s - 164*r + 92*s**2 - 69*s + 22) + Pkd2*k2*(C*(r*(4 - 32*s) - 32*s**2 + 24*s - 2) - 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) + 48*r*s - 31*r + 48*s**2 - 82*s + 27)) - 30*k2**4*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1))) + 28*g2*k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(410*s - 141) + 2460*s**2 - 2713*s + 640) + 22*k2**2*(Pk2*(360*r**2 + r*(27 - 4200*s) - 4560*s**2 + 3550*s - 181) + 45*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 66*f*(-90*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) - fd*k1**2*k2**2*(4*C*Pk2*(117*r**2 + r*(39 - 279*s) - 198*s**2 + 318*s - 79) + 6*Pk2*(-105*r**2 + 2*r*(9*s + 20) + 57*s**2 - 81*s + 17) + 3*Pkd2*k2*(4*C*(3*s - 1)*(25*r + 14*s - 18) - 186*r*s + 65*r - 120*s**2 + 172*s - 45)) + fd*k2**4*(-4*C*Pk2*(198*r**2 + 12*r*(54*s - 17) + 90*s**2 - 339*s + 77) + 3*Pk2*(168*r**2 + r*(468*s - 149) + 60*s**2 - 224*s + 47) + Pkd2*k2*(30 - 60*C)*(3*s - 1)*(3*r + 2*s - 2)) - 6*gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(-2*Pk2*(25*r**2 + r*(9*s - 8) - 16*s**2 + 49*s - 17) + Pkd2*k2*(r*(23 - 36*s) - 36*s**2 + 64*s - 23)) - 15*k2**4*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 396*fd*(15*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) - 2*k1**2*k2**2*(2*Pk2*(25*r**2 + r*(9*s - 1) - 16*s**2 + 30*s - 11) + Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 30*k2**4*(Pk2*(6*r + 2*s - 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-5940*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(410*s - 141) + 2460*s**2 - 2713*s + 640) + 22*k2**2*(Pk2*(360*r**2 + r*(27 - 4200*s) - 4560*s**2 + 3550*s - 181) + 45*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 66*f*(k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(4*r + 4*s - 3) - 2*k1**2*k2**2*(Pk2*(2*C*(156*r**2 - 372*r*s + 19*r - 264*s**2 + 450*s - 98) - 420*r**2 + 72*r*s + 215*r + 228*s**2 - 347*s + 61) + 3*Pkd2*k2*(C*(200*r*s - 59*r + 112*s**2 - 190*s + 45) - 124*r*s + 39*r - 80*s**2 + 120*s - 29)) + k2**4*(-4*C*Pk2*(264*r**2 + 6*r*(144*s - 47) + 120*s**2 - 518*s + 89) + 6*Pk2*(112*r**2 + 2*r*(156*s - 53) + 40*s**2 - 174*s + 27) + Pkd2*k2*(15 - 30*C)*(r*(24*s - 7) + 16*s**2 - 22*s + 5))) - 396*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) - 2*k1**2*k2**2*(2*Pk2*(50*r**2 + 9*r*(2*s - 1) - 32*s**2 + 79*s - 28) + 3*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 30*k2**4*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**6) + 2*D1**3*Pk3*ct**2*st**2*(D1*bd1*f*(f*(2*Pk2*(7*r*(3*s - 11) + 6*s*(4*C*(5*s - 6) - 10*s + 19)) + k2*(-14*Pkd2*r*(s - 3) + 3*Pkd2*s*(C*(60 - 50*s) + 25*s - 37) + Pkdd2*k2*s*(6*C - 3)*(5*s - 6))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(42*b2 - 84*g2)*(s - 1)) + 7*b1**2*(D1*f*fd*(2*Pk2*(r*(6*s - 8) + 9*s - 2) - 3*Pkd2*k2*(2*r*(s - 1) + s)) + 6*D1*fd*(s - 1)*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + 8*Pk2*r - 2*Pkd2*k2*r) + 4*Dd*Pk2*f*(12*K*(4*s**2 - 5*s + 1) + f*(2*r*(3*s - 7) + 9*s + 4) + 48*r*s - 30*r - 12*s + 12) - 6*Dd*f*k2*(K*Pkdd2*k2*(-4*s**2 + 5*s - 1) + Pkd2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2))) + b1*(480*C*D1*Pk2*f*fd*s**2 - 816*C*D1*Pk2*f*fd*s + 288*C*D1*Pk2*f*fd - 300*C*D1*Pkd2*f*fd*k2*s**2 + 510*C*D1*Pkd2*f*fd*k2*s - 180*C*D1*Pkd2*f*fd*k2 + 60*C*D1*Pkdd2*f*fd*k2**2*s**2 - 102*C*D1*Pkdd2*f*fd*k2**2*s + 36*C*D1*Pkdd2*f*fd*k2**2 + 960*C*Dd*Pk2*f**2*s**2 - 1392*C*Dd*Pk2*f**2*s + 288*C*Dd*Pk2*f**2 - 600*C*Dd*Pkd2*f**2*k2*s**2 + 870*C*Dd*Pkd2*f**2*k2*s - 180*C*Dd*Pkd2*f**2*k2 + 120*C*Dd*Pkdd2*f**2*k2**2*s**2 - 174*C*Dd*Pkdd2*f**2*k2**2*s + 36*C*Dd*Pkdd2*f**2*k2**2 + 336*D1*Pk2*bd2*f*s**2 - 336*D1*Pk2*bd2*f*s + 84*D1*Pk2*f*fd*r*s - 280*D1*Pk2*f*fd*r - 240*D1*Pk2*f*fd*s**2 + 506*D1*Pk2*f*fd*s - 74*D1*Pk2*f*fd - 672*D1*Pk2*f*gd2*s**2 + 672*D1*Pk2*f*gd2*s - 672*D1*Pk2*fd*g2*s**2 + 1344*D1*Pk2*fd*g2*s - 672*D1*Pk2*fd*g2 - 210*D1*Pkd2*bd2*f*k2*s**2 + 210*D1*Pkd2*bd2*f*k2*s - 28*D1*Pkd2*f*fd*k2*r*s + 77*D1*Pkd2*f*fd*k2*r + 150*D1*Pkd2*f*fd*k2*s**2 - 276*D1*Pkd2*f*fd*k2*s + 69*D1*Pkd2*f*fd*k2 + 420*D1*Pkd2*f*gd2*k2*s**2 - 420*D1*Pkd2*f*gd2*k2*s + 420*D1*Pkd2*fd*g2*k2*s**2 - 840*D1*Pkd2*fd*g2*k2*s + 420*D1*Pkd2*fd*g2*k2 + 42*D1*Pkdd2*bd2*f*k2**2*s**2 - 42*D1*Pkdd2*bd2*f*k2**2*s - 30*D1*Pkdd2*f*fd*k2**2*s**2 + 51*D1*Pkdd2*f*fd*k2**2*s - 18*D1*Pkdd2*f*fd*k2**2 - 84*D1*Pkdd2*f*gd2*k2**2*s**2 + 84*D1*Pkdd2*f*gd2*k2**2*s - 84*D1*Pkdd2*fd*g2*k2**2*s**2 + 168*D1*Pkdd2*fd*g2*k2**2*s - 84*D1*Pkdd2*fd*g2*k2**2 + 7*D1*bd1*f*(12*K*Pkdd2*k2**2*s*(s - 1) + 2*Pk2*f*(r*(6*s - 20) + 9*s + 10) + 24*Pk2*(r*(4*s - 2) + (s - 1)*(4*K*s - 1)) - 3*Pkd2*k2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1))) + 168*Dd*Pk2*f**2*r*s - 588*Dd*Pk2*f**2*r - 480*Dd*Pk2*f**2*s**2 + 892*Dd*Pk2*f**2*s + 80*Dd*Pk2*f**2 - 2688*Dd*Pk2*f*g2*s**2 + 3360*Dd*Pk2*f*g2*s - 672*Dd*Pk2*f*g2 - 56*Dd*Pkd2*f**2*k2*r*s + 161*Dd*Pkd2*f**2*k2*r + 300*Dd*Pkd2*f**2*k2*s**2 - 477*Dd*Pkd2*f**2*k2*s + 27*Dd*Pkd2*f**2*k2 + 1680*Dd*Pkd2*f*g2*k2*s**2 - 2100*Dd*Pkd2*f*g2*k2*s + 420*Dd*Pkd2*f*g2*k2 - 60*Dd*Pkdd2*f**2*k2**2*s**2 + 87*Dd*Pkdd2*f**2*k2**2*s - 18*Dd*Pkdd2*f**2*k2**2 - 336*Dd*Pkdd2*f*g2*k2**2*s**2 + 420*Dd*Pkdd2*f*g2*k2**2*s - 84*Dd*Pkdd2*f*g2*k2**2 + 42*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d**2*k2**2) - D1**3*Pk3*ct**2*st**4*(42*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 3*b1*(D1*(f**2*fd*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 5*s + 1) + k2**2*(Pk2*(r*(174 - 375*s) - 115*s + 22) + 15*Pkd2*k2*(r*(9*s - 4) + s))) + 2*f*(fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(4*s - 2) + 9*s - 8) - 15*k2**2*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + r*(16*Pk2 - 4*Pkd2*k2))) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 28*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f**2*(15*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(Pk2*(r*(136 - 250*s) + 5*s - 38) + 15*Pkd2*k2*(r*(6*s - 3) - s + 1))) + f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(4*s - 2) + 9*s - 8) - 15*k2**2*(8*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-5*K*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 4*s - 2)))) - 14*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*(-90*b2*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 3*bd1*f**2*(720*Pk2*k1**2*s*(2*s - 1) - 270*Pkd2*k1**2*k2*s*(2*s - 1) + 15*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(-Pk2*(r - 1)*(125*s - 98) + 30*Pkdd2*k1**2*s*(2*s - 1))) - 84*bd1*g2*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 2*f*(3*bd1*(15*K*Pkdd2*k2**4*s*(1 - 2*s) + 24*Pk2*k1**2*s*(C*(4*s - 2) + 9*s - 8) - 9*Pkd2*k1**2*k2*s*(C*(4*s - 2) + 9*s - 8) + 15*Pkd2*k2**3*(r*(4*s - 1) + (2*s - 1)*(5*K*s - 1)) + k2**2*(-60*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*s*(C*(4*s - 2) + 9*s - 8))) + fd*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(63*s**2 - 51*s + 10) + k2**2*(-2*Pk2*(120*C*(6*s**2 - 5*s + 1) + 9*r*(42*s - 23) - 360*s**2 + 258*s - 19) + k2*(Pkd2*(150*C*(6*s**2 - 5*s + 1) + 216*r*s - 117*r - 450*s**2 + 345*s - 50) + Pkdd2*k2*(15 - 30*C)*(6*s**2 - 5*s + 1)))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-45*bd2 + 90*gd2)*(2*s - 1)) + 180*fd*g2*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))) + 2*Dd*f*(f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(84*s**2 - 61*s + 10) - k2**2*(4*Pk2*(60*C*(8*s**2 - 6*s + 1) + 252*r*s - 134*r - 240*s**2 + 118*s + 21) + k2*(Pkd2*(-150*C*(8*s**2 - 6*s + 1) - 288*r*s + 152*r + 600*s**2 - 370*s + 15) + Pkdd2*k2*(30*C - 15)*(8*s**2 - 6*s + 1)))) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-45*b2 + 90*g2)*(8*s**2 - 6*s + 1))))/(105*d**2*k2**2*k3**2) + D1**3*Pk3*ct**2*(-21*b1**3*k2*(D1*fd*s*(15*Pk2*k2*(r - 1) - 4*Pkd2*k1**2*s + 5*Pkd2*k2**2*(r - 1) + 4*Pkdd2*k1**2*k2*s) + 2*Dd*f*(2*Pkd2*k1**2*s*(1 - 4*s) + 5*Pkd2*k2**2*(r*(2*s - 1) - 3*s + 1) + k2*s*(15*Pk2*(2*r - 1) + 2*Pkdd2*k1**2*(4*s - 1)))) - 21*b1**2*(D1*bd1*f*k2*(4*Pkd2*k1**2*s*(1 - 3*s) + 5*Pkd2*k2**2*(r*(3*s - 2) - 5*s + 2) + k2*s*(15*Pk2*(3*r - 1) + 4*Pkdd2*k1**2*(3*s - 1))) + D1*fd*(k1**2*(Pk2*(12*K*(s - 1)**2 + f*(-64*s**2 + s*(156*r - 185) + 32) + 4*s**2*(16*C - 16) + 4*s*(24*r + 6) - 12) - k2*(Pkd2*(32*C*s**2 + K*(44*s**2 - 80*s + 40) + f*(-56*s**2 + s*(84*r - 115) + 22) + 48*r*s - 76*s**2 + 80*s - 40) + 2*Pkdd2*k2*(3*f*(4*s**2 + 3*s - 1) + s**2*(5 - 2*K)))) - 2*k2**2*(Pk2*(68*C*(r - 1)**2 + 10*K*r**2 - 35*K*r*s + 20*K*r + f*(40*r**2 - 37*r + 6) - 68*r**2 + 126*r - 68) + k2*(5*K*(Pkd2*r*(3*s - 4) - 2*Pkd2*s + Pkd2 + Pkdd2*k2*(1 - 2*s)) + 5*Pkd2*f*(2*r - 1) + 2*Pkd2*r*(s*(6 - 28*C) + 5) + 2*Pkd2*s*(C*(6*s + 28) - 3*s - 6) + 2*Pkdd2*k2*s**2*(2*C - 1)))) + 2*Dd*f*k1**2*(2*Pk2*(64*C*s**2 - 16*C*s + 3*K*(4*s**2 - 5*s + 1) + f*(6*r*(13*s - 3) - 32*s**2 - 75*s + 20) + 96*r*s - 12*r - 64*s**2 + 4*s - 3) + k2*(Pkd2*(-64*C*s**2 + 16*C*s - 2*K*(44*s**2 - 51*s + 10) + f*(r*(18 - 84*s) + 56*s**2 + 84*s - 23) - 96*r*s + 12*r + 152*s**2 - 94*s + 20) + Pkdd2*k2*(4*s - 1)*(-3*f*(2*s + 1) + s*(2*K - 5)))) - 2*Dd*f*k2**2*(2*Pk2*(68*C*(2*r**2 - 3*r + 1) + 20*K*r**2 - 70*K*r*s + 15*K*s + f*(40*r**2 - 42*r + 11) - 136*r**2 + 204*r - 68) + k2*(Pkd2*(4*C*(r*(7 - 56*s) + 12*s**2 + 39*s - 7) + 60*K*r*s - 40*K*r - 50*K*s + 25*K + 20*f*r - 10*f + 48*r*s + 14*r - 24*s**2 - 30*s - 4) + Pkdd2*k2*(4*s - 1)*(4*C*s - 5*K - 2*s)))) - 3*b1*(7*D1*bd1*f*(-4*Pk2*k1**2*(r*(12 - 48*s) + s*(C*(16 - 32*s) - 6*K*s + 6*K + 32*s - 7)) - 4*Pkd2*k1**2*k2*(6*r*(4*s - 1) + s*(8*C*(2*s - 1) + 22*K*s - 21*K - 38*s + 23)) + 2*Pkd2*k2**3*(4*C*(7*r*(4*s - 1) - 6*s**2 - 11*s + 7) - 10*K*(3*r*s - r - 2*s + 1) - 24*r*s + r + 12*s**2 + 6*s - 1) - 2*Pkdd2*k2**4*s*(C*(8*s - 4) - 5*K - 4*s + 2) + f*(k1**2*(Pk2*(12*r*(13*s - 6) - 64*s**2 - 115*s + 48) + k2*(Pkd2*(-84*r*s + 36*r + 56*s**2 + 53*s - 24) + 6*Pkdd2*k2*s*(1 - 4*s))) - 2*k2**2*(Pk2*(40*r**2 - 47*r + 16) + 5*Pkd2*k2*(2*r - 1))) - 2*k2**2*(Pk2*(15*K*s + r**2*(136*C + 20*K - 136) - 2*r*(68*C + 35*K*s + 5*K - 73)) - Pkdd2*k1**2*s*(2*K - 5)*(2*s - 1))) + D1*(-9*f**2*fd*k1**2*(Pk2*(18*r*(s + 4) - 360*s**2 + 249*s - 82) + 3*Pkd2*k2*(14*r*(3*s - 2) + 72*s**2 - 81*s + 26)) + 2*f*(7*bd2*k2*s*(15*Pk2*k2*(r - 1) - 2*Pkd2*k1**2*s + 5*Pkd2*k2**2*(r + s + 1) + 2*Pkdd2*k1**2*k2*s + 5*Pkdd2*k2**3*s) + fd*k1**2*(4*Pk2*(C*(18*s**2 - 95*s + 43) + 14*K*(2*s**2 - 5*s + 2) + 151*r*s - 42*r + 135*s**2 - 138*s + 6) + k2*(-Pkd2*(4*C*(82*s**2 - 105*s + 35) + 7*K*(14*s**2 - 29*s + 11) + 512*r*s - 203*r + 170*s**2 - 263*s + 14) + 3*Pkdd2*k2*(7*K*(2*s**2 - 3*s + 1) + s**2*(16*C - 22)))) + fd*k2**2*(Pk2*(-2*C*(140*r**2 + r*(376 - 1550*s) + 845*s - 258) + 14*K*(10*r**2 + r*(27*s - 13) + 3*(1 - 2*s)**2) - 332*r**2 - 1886*r*s + 1022*r + 845*s - 302) + k2*(Pkd2*(C*(-188*r*s + 476*r + 24*s - 210) + 70*K*r*(3*s - 2) + 84*K*(1 - 2*s)**2 + 94*r*s - 357*r - 12*s + 154) + Pkdd2*k2*(42*C - 21)*(3*s - 1))) - 14*gd2*(6*Pk2*k1**2*s*(s - 1) + 2*Pkd2*k1**2*k2*s*(10 - 11*s) - 5*Pkd2*k2**3*(r*(3*s - 2) - 4*s + 2) + 5*Pkdd2*k2**4*s + k2**2*(-5*Pk2*(2*r**2 - 7*r*s - 2*r + 3*s) + 2*Pkdd2*k1**2*s**2))) + 14*fd*(b2*k2*s*(-2*Pkd2*k1**2*s + 5*Pkd2*k2**2*(r + s) + 5*Pkdd2*k2**3*s + k2*(15*Pk2*r + 2*Pkdd2*k1**2*s)) - 2*g2*(2*k1**2*(3*Pk2*(s - 1)**2 + k2*(Pkd2*(-11*s**2 + 20*s - 10) + Pkdd2*k2*s**2)) + 5*k2**2*(Pk2*r*(-2*r + 7*s - 4) - Pkd2*k2*(3*r*s - 4*r - 2*s + 1) + Pkdd2*k2**2*(2*s - 1))))) - 2*Dd*f*(-7*b2*k2*(2*Pkd2*k1**2*s*(1 - 4*s) + 5*Pkd2*k2**2*(4*r*s - 2*r + 4*s**2 + s) + 5*Pkdd2*k2**3*s*(4*s - 1) + 2*k2*s*(15*Pk2*(2*r - 1) + Pkdd2*k1**2*(4*s - 1))) + 18*f**2*k1**2*(Pk2*(r*(6*s + 31) - 120*s**2 + 73*s - 27) + Pkd2*k2*(14*r*(3*s - 2) + 72*s**2 - 75*s + 23)) - f*(k1**2*(2*Pk2*(C*(72*s**2 - 362*s + 86) + 28*K*(4*s**2 - 9*s + 2) + 604*r*s - 296*r + 540*s**2 - 597*s + 188) + k2*(-Pkd2*(4*C*(164*s**2 - 181*s + 35) + 7*K*(28*s**2 - 51*s + 11) + 1024*r*s - 457*r + 340*s**2 - 611*s + 232) + 3*Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(8*C - 11)))) + k2**2*(-2*Pk2*(2*C*(140*r**2 + r*(149 - 1550*s) + 845*s - 127) - 7*K*(20*r**2 + 54*r*s - 21*r + 24*s**2 - 15*s + 1) + 332*r**2 + 1886*r*s - 841*r - 845*s + 313) + k2*(Pkd2*(-2*C*(4*r*(47*s - 89) + 46*s + 143) + 14*K*(30*r*s - 20*r + 48*s**2 - 51*s + 16) + 188*r*s - 552*r + 46*s + 241) + Pkdd2*k2*(42*C - 21)*(4*s - 1)))) + 14*g2*(2*k1**2*(4*s - 1)*(3*Pk2*(s - 1) + k2*(-11*Pkd2*s + 10*Pkd2 + Pkdd2*k2*s)) + 5*k2**2*(-2*Pk2*(4*r**2 - 14*r*s + 3*s) + Pkd2*k2*(-12*r*s + 8*r + 10*s - 5) + Pkdd2*k2**2*(4*s - 1))))) + f*(3*D1*bd1*(-14*b2*k2*(-2*Pkd2*k1**2*s*(s - 1) + 5*Pkd2*k2**2*(r*(s - 2) + s*(s - 1)) + 5*Pkdd2*k2**3*s*(s - 1) + k2*s*(15*Pk2*r + 2*Pkdd2*k1**2*(s - 1))) + 9*f**2*k1**2*(Pk2*(r*(6*s + 52) - 120*s**2 + 43*s - 26) + Pkd2*k2*(14*r*(3*s - 2) + 72*s**2 - 57*s + 14)) - 2*f*(k1**2*(2*Pk2*(r*(151*s - 142) + s**2*(18*C + 28*K + 135) - s*(86*C + 56*K + 138) + 106) + k2*(Pkd2*(r*(163 - 256*s) - s**2*(164*C + 49*K + 85) + s*(164*C + 77*K + 135) - 127) + Pkdd2*k2*s*(s - 1)*(24*C + 21*K - 33))) + k2**2*(Pk2*(-524*C*s + 7*K*(10*r**2 + r*(27*s - 8) + 12*s**2 - 3*s - 2) - r**2*(140*C + 166) + r*(1550*C*s + 8*C - 943*s + 312) + 262*s - 142) + Pkd2*k2*(-2*C*(r*(47*s - 20) + 88*s - 60) + 7*K*(5*r*(3*s - 2) + 24*s**2 - 27*s + 10) + 47*r*s - 48*r + 88*s - 60))) - 28*g2*(-6*Pk2*k1**2*s*(s - 1) + 22*Pkd2*k1**2*k2*s*(s - 1) + 15*Pkd2*k2**3*r*s + k2**2*(5*Pk2*r*(2*r - 7*s) - 2*Pkdd2*k1**2*s*(s - 1)))) - 2*D1*(f*(fd*(k1**2*(2*Pk2*(36*C*(9*s**2 - 24*s + 7) - 63*r*s - 339*r + 648*s**2 - 240*s + 128) + 9*k2*(-2*Pkd2*(C*(33*s**2 - 68*s + 19) + 42*r*s - 37*r + 60*s**2 - 54*s + 19) + Pkdd2*k2*(10*C - 5)*(3*s**2 - 4*s + 1))) + k2**2*(Pk2*(2*C*(828*r**2 + 3*r*(513*s - 406) + 324*s**2 - 1809*s + 710) - 1476*r**2 - 2511*r*s + 1758*r - 324*s**2 + 1809*s - 710) + Pkd2*k2*(18*C - 9)*(33*r*(3*s - 2) + 108*s**2 - 123*s + 40))) + (21*bd2 - 42*gd2)*(8*Pk2*k1**2*s*(s - 2) + Pkd2*k1**2*k2*s*(11 - 7*s) + Pkd2*k2**3*(5*r*(3*s - 2) + 24*s**2 - 27*s + 10) + k2**2*(Pk2*(10*r**2 + 27*r*s - 8*r + 12*s**2 - 3*s - 2) + 3*Pkdd2*k1**2*s*(s - 1)))) - 42*fd*g2*(k1**2*(2*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(10*r**2 + r*(27*s - 13) + 3*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 6*(1 - 2*s)**2)))) - 2*Dd*f*(f*(k1**2*(2*Pk2*(36*C*(12*s**2 - 31*s + 7) - 84*r*s - 502*r + 864*s**2 - 334*s + 291) + 9*k2*(-Pkd2*(2*C*(44*s**2 - 87*s + 19) + 112*r*s - 97*r + 160*s**2 - 146*s + 61) + Pkdd2*k2*(10*C - 5)*(4*s**2 - 5*s + 1))) + 2*k2**2*(Pk2*(2*C*(552*r**2 + 1026*r*s - 805*r + 216*s**2 - 1161*s + 413) - 984*r**2 - 1674*r*s + 1183*r - 216*s**2 + 1161*s - 413) + Pkd2*k2*(18*C - 9)*(22*r*(3*s - 2) + 72*s**2 - 87*s + 31))) - 42*g2*(k1**2*(4*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(20*r**2 + 54*r*s - 21*r + 24*s**2 - 15*s + 1) + Pkd2*k2*(30*r*s - 20*r + 48*s**2 - 51*s + 16)))) - 42*b2*(D1*fd*(k1**2*(2*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(10*r**2 + r*(27*s - 13) + 3*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 6*(1 - 2*s)**2))) + Dd*f*(k1**2*(4*s - 1)*(8*Pk2*(s - 2) + k2*(Pkd2*(11 - 7*s) + 3*Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(20*r**2 + 54*r*s - 21*r + 24*s**2 - 15*s + 1) + Pkd2*k2*(30*r*s - 20*r + 48*s**2 - 51*s + 16))))))/(315*d**2*k2**2*k3**2) + D1**3*Pk3*ct**2*st**4*(-1386*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2)) + Dd*f*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 99*b1*(D1*(f**2*fd*k2**2*(10*k1**2*(4*Pk2*(r*(81*s - 34) + 57*s**2 - 66*s + 20) - k2*(Pkd2*(81*r*s - 34*r + 21*s**2 - 21*s + 11) + 3*Pkdd2*k2*(4*s**2 - 5*s + 1))) + k2**2*(Pk2*(3*r - 1)*(20*r + 165*s - 118) - 15*Pkd2*k2*(9*r*s - 4*r + s))) + 2*f*(fd*(k1**4*(1 - 2*s)**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(2*Pk2*(32*C*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + K*(-215*r*s + 146*r - 64*s**2 + 8*s + 12) + 407*r*s - 270*r + 328*s**2 - 356*s + 88) + k2*(-Pkd2*(8*C*(r*(4*s - 2) + 9*s**2 - 6*s + 2) + K*(-118*r*s + 80*r + 40*s**2 - 110*s + 45) + 214*r*s - 142*r + 146*s**2 - 163*s + 35) + Pkdd2*k2*(K*(24*s**2 - 38*s + 13) + s**2*(8*C - 6) + 5*s - 3))) + 15*k2**4*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2)))) + 7*k1**2*k2**2*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2)))) - 28*fd*g2*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + 2*Dd*f*(f**2*k2**2*(5*k1**2*(4*Pk2*(6*r*(18*s - 7) + 76*s**2 - 93*s + 26) - k2*(Pkd2*(6*r*(18*s - 7) + 28*s**2 - 45*s + 17) + Pkdd2*k2*(16*s**2 - 16*s + 3))) + k2**2*(Pk2*(2*r - 1)*(20*r + 165*s - 118) - 15*Pkd2*k2*(6*r*s - 3*r - s + 1))) + f*(k1**4*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k1**2*k2**2*(2*Pk2*(8*C*(2*r*(8*s - 3) + 24*s**2 - 22*s + 5) + K*(-430*r*s + 268*r - 128*s**2 + 151*s - 110) + 814*r*s - 496*r + 656*s**2 - 867*s + 322) + k2*(Pkd2*(-4*C*(2*r*(8*s - 3) + 36*s**2 - 25*s + 5) + K*(4*r*(59*s - 37) - 80*s**2 + 106*s + 23) - 428*r*s + 262*r - 292*s**2 + 399*s - 159) + Pkdd2*k2*(4*s - 1)*(K*(12*s - 13) + s*(4*C - 3) + 3))) + 15*k2**4*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1))) - 14*g2*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1))))) + f*(D1*(2772*bd1*g2*k1**2*k2**2*(8*Pk2*(r*(2*s - 1) + s*(3*s - 3)) + k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + f**2*(99*bd1*k2**2*(-10*k1**2*(4*Pk2*(r*(27*s - 8) + 19*s**2 - 27*s + 6) + k2*(Pkd2*(-27*r*s + 8*r - 7*s**2 + 24*s - 6) + Pkdd2*k2*s*(1 - 4*s))) + k2**2*(r - 1)*(Pk2*(-20*r - 165*s + 118) + 15*Pkd2*k2*(3*s - 2))) + 2*fd*(5940*Pk2*k2**4*(2*r**2 - 3*r + 1) - 45*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(152*s**2 - 98*s + 15) + 11*k1**2*k2**2*(Pk2*(18*r*(425*s - 224) + 13920*s**2 - 10145*s + 2726) + 5*k2*(Pkd2*(-486*r*s + 243*r - 1020*s**2 + 748*s - 184) + 9*Pkdd2*k2*(12*s**2 - 7*s + 1))))) - 66*f*(3*bd1*(k1**4*s*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(Pk2*(96*C*s**2 - 80*C*s + K*(r*(122 - 215*s) - 64*s**2 + 143*s - 122) + r*(64*C*s - 16*C + 407*s - 226) + 328*s**2 - 511*s + 242) + k2*(Pkd2*(-36*C*s**2 + 32*C*s + K*(59*r*s - 34*r - 20*s**2 - 2*s + 34) + r*(-16*C*s + 4*C - 107*s + 60) - 73*s**2 + 112*s - 64) + Pkdd2*k2*s*(4*C*(s - 1) + K*(12*s - 13) - 3*s + 7))) + 15*k2**4*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 90*bd2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(k1**4*(1 - 3*s)**2*(2*C - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(-2*Pk2*(3*C*(393*r*s - 158*r - 144*s**2 - 3*s + 26) - 1755*r*s + 714*r - 396*s**2 + 789*s - 262) + k2*(Pkd2*(6*C*(105*r*s - 44*r - 144*s**2 + 84*s - 9) - 918*r*s + 384*r + 261*s**2 + 39*s - 68) + Pkdd2*k2*(3*s - 1)*(C*(72*s - 34) - 51*s + 24))) + k2**4*(-6*Pk2*(2*C*(3*r**2 + 540*r*s - 212*r + 120*s**2 - 312*s + 101) + 30*r**2 - 594*r*s + 273*r - 120*s**2 + 330*s - 125) + k2*(2*C*Pkd2*(3*s - 1)*(504*r + 90*s - 245) - 9*Pkd2*(192*r*s - 69*r + 30*s**2 - 95*s + 30) + Pkdd2*k2*(30*C - 15)*(6*s**2 - 5*s + 1)))) + 6*gd2*(-k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(Pk2*(r*(215*s - 122) + 64*s**2 - 143*s + 122) + k2*(Pkd2*(-59*r*s + 34*r + 20*s**2 + 2*s - 34) + Pkdd2*k2*s*(13 - 12*s))) - 15*k2**4*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 396*fd*(-30*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + g2*(k1**4*(1 - 2*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*r*(292 - 430*s) + 8*Pk2*(-16*s**2 + 2*s + 3) + Pkd2*k2*(2*r*(59*s - 40) - 40*s**2 + 110*s - 45) + Pkdd2*k2**2*(24*s**2 - 38*s + 13)) + 15*k2**4*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1)))))) - 2*Dd*f*(5940*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + f**2*(-5940*Pk2*k2**4*(2*r**2 - 3*r + 1) + 45*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(152*s**2 - 98*s + 15) - 11*k1**2*k2**2*(Pk2*(18*r*(425*s - 224) + 13920*s**2 - 10145*s + 2726) + 5*k2*(Pkd2*(-486*r*s + 243*r - 1020*s**2 + 748*s - 184) + 9*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 33*f*(k1**4*(2*C - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + k1**2*k2**2*(-4*Pk2*(C*(786*r*s - 296*r - 288*s**2 - 121*s + 98) - 1170*r*s + 446*r - 264*s**2 + 639*s - 220) + k2*(Pkd2*(2*C*(420*r*s - 166*r - 576*s**2 + 238*s + 7) - 1224*r*s + 482*r + 348*s**2 + 225*s - 166) + Pkdd2*k2*(4*s - 1)*(C*(72*s - 34) - 51*s + 24))) + k2**4*(-4*Pk2*(2*C*(6*r**2 + 1080*r*s - 391*r + 240*s**2 - 716*s + 223) + 60*r**2 - 1188*r*s + 502*r - 240*s**2 + 770*s - 295) + k2*(2*C*Pkd2*(4*r*(504*s - 151) + 360*s**2 - 1270*s + 345) - 9*Pkd2*(4*r*(64*s - 21) + 40*s**2 - 150*s + 45) + Pkdd2*k2*(30*C - 15)*(8*s**2 - 6*s + 1)))) - 198*g2*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k1**2*k2**2*(Pk2*(r*(536 - 860*s) - 256*s**2 + 302*s - 220) + k2*(Pkd2*(4*r*(59*s - 37) - 80*s**2 + 106*s + 23) + Pkdd2*k2*(48*s**2 - 64*s + 13))) + 15*k2**4*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(3465*d**2*k2**2*k3**4) - 4*D1**3*Pk3*ct**2*st**2*(D1*(462*b1*fd*k2**2*(-12*Pk2*b2*k2**4*(r + s)**2 + b1*k1**4*(K - 1)*(2*Pk2*(r**2 + r*(3*s - 2) + 2*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + b1*k1**2*k2**2*(4*C*Pk2*(r + s - 1)**2 - 2*K*Pk2*(r**2 + 2*r*(5*s - 3) + 9*s**2 - 6*s + 3) + 4*Pk2*(r**2 + r*(6*s - 2) + 5*s**2 - 2*s + 1) + Pkd2*k2*s*(4*K - 7)*(r + s)) - 12*b1*k2**4*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s)) + 2*g2*(k1**4*(-2*Pk2*(r**2 + 3*r*s - 2*r + 2*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s)) - 2*k1**2*k2**2*(-Pk2*(r**2 + 10*r*s - 6*r + 9*s**2 - 6*s + 3) + 2*Pkd2*k2*s*(r + s)) + 12*k2**4*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + 3*f**3*(-11*bd1*k2**2*(24*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + k1**4*(2*Pk2*(12*r**2 - 72*r*s - 67*r - 84*s**2 - 11*s + 67) + Pkd2*k2*(96*r*s + 71*r + 96*s**2 + 15*s - 83)) + 6*k1**2*k2**2*(Pk2*(150*r**2 + 194*r*s - 215*r + 44*s**2 - 149*s + 61) + 3*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + fd*k1**2*(264*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 104*s**2 - 192*s + 69) + 22*k1**2*k2**2*(2*Pk2*(450*r**2 - r*(582*s + 197) - 1032*s**2 + 909*s - 104) + 5*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 11*f**2*k2**2*(36*Pk2*bd2*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 3*bd1*(2*k1**4*(2*Pk2*(2*C*(r**2 - r*(13*s + 4) - 14*s**2 + 9*s + 5) + K*(-13*r**2 + 2*r*s - 5*r + 15*s**2 - 19*s + 18) + 16*r**2 + 33*r*s + 32*r + 17*s**2 + 33*s - 52) + Pkd2*k2*(2*C*(15*r*s + 3*r + 15*s**2 - 10*s - 5) - 3*K*(11*r*s - r + 11*s**2 - 4*s + 1) + 4*r*s - 18*r + 4*s**2 - 14*s + 22)) + k1**2*k2**2*(-2*Pk2*(-4*C*(21*r**2 - 113*r*s - 25*r + 20*s**2 + 51*s + 6) + 452*K*r**2 + 386*K*r*s - 468*K*r - 66*K*s**2 - 34*K*s + 16*K + 6*b1*(20*r**2 + r*(40*s - 23) + 20*s**2 - 23*s + 3) - 534*r**2 - 1016*r*s + 765*r - 174*s**2 + 579*s - 223) + Pkd2*k2*(4*C*(2*r*(73*s - 33) + 48*s**2 - 95*s + 47) - 144*K*(r*(4*s - 1) + (1 - 2*s)**2) + b1*(r*(57 - 396*s) - 396*s**2 + 333*s + 3) + 10*r*s + 2*r + 206*s**2 - 212*s + 48)) + 2*k2**4*(Pk2*(4*C*(198*r*s - 68*r + 30*s**2 - 87*s + 78) - 546*K*r**2 - 798*K*r*s + 770*K*r - 252*K*s**2 + 588*K*s - 224*K + 7*b1*(6*r**2 + r*(6*s - 19) - 9*s + 11) + 168*r**2 - 228*r*s - 123*r - 60*s**2 + 69*s - 93) + 6*Pkd2*k2*(2*C*(6*r*(2*s - 1) + 5*s**2 - 8*s + 3) - 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 5*s**2 + 8*s - 3))) + fd*k1**4*(2*Pk2*(-4*C*(63*r**2 + 9*r*(7*s + 8) + 51*s - 55) + 9*b1*(12*r**2 - r*(72*s + 59) - 84*s**2 - 19*s + 39) + 306*r**2 + 306*r*s + 324*r + 312*s - 280) + 3*Pkd2*k2*(-4*C*(3*r*(9*s - 4) + 27*s**2 - 21*s + 5) + b1*(3*r*(96*s + 67) + 288*s**2 + 81*s - 149) + 126*r*s - 66*r + 126*s**2 - 126*s + 36)) + 18*fd*k1**2*k2**2*(Pk2*(-4*C*(117*r**2 - 297*r*s - 14*r - 60*s**2 + 268*s - 58) + b1*(450*r**2 + r*(582*s - 465) + 132*s**2 - 291*s + 131) + 540*r**2 - 210*r*s - 325*r - 42*s**2 + 373*s - 48) + Pkd2*k2*(C*(-216*r*s + 90*r - 216*s**2 + 228*s - 58) + 3*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 180*r*s - 81*r + 180*s**2 - 198*s + 53)) + 36*fd*k2**4*(Pk2*(-2*C*(165*r**2 + 81*r*s - 151*r + 42*s**2 - 20*s + 25) + 2*b1*(3*r - 1)*(5*r + 5*s - 3) + 207*r**2 + 123*r*s - 183*r + 42*s**2 - 28*s + 29) + Pkd2*k2*(3 - 6*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2)) + 12*gd2*(k1**4*(2*Pk2*(13*r**2 - 2*r*s + 5*r - 15*s**2 + 19*s - 18) + 3*Pkd2*k2*(11*r*s - r + 11*s**2 - 4*s + 1)) + 2*k1**2*k2**2*(Pk2*(226*r**2 + r*(193*s - 234) - 33*s**2 - 17*s + 8) + 36*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*k2**4*(Pk2*(39*r**2 + 57*r*s - 55*r + 18*s**2 - 42*s + 16) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 33*f*k2**2*(168*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 12*Pk2*b2*fd*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*k2**2*(14*Pk2*k2**2*(6*r**2 + r*(6*s - 13) - 9*s + 5) - 3*k1**2*(4*Pk2*(20*r**2 + 40*r*s - 7*r + 20*s**2 - 7*s - 3) + 3*Pkd2*k2*s*(44*r + 44*s - 15))) + 2*b1*(84*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*bd1*(k1**4*(2*K - 2)*(Pk2*(2*r**2 + r*(6*s - 1) + 4*s**2 - 7*s + 1) - Pkd2*k2*(r*(s + 1) + s*(s - 2))) + k1**2*k2**2*(2*Pk2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - K*(2*r**2 + 20*r*s - 14*r + 18*s**2 - 12*s + 3) + 4*r**2 + 24*r*s - 15*r + 20*s**2 - 13*s + 2) + Pkd2*k2*(r*(K*(8*s - 7) - 14*s + 6) + s*(K*(8*s - 1) - 14*s + 8))) - 6*k2**4*(K*(2*Pk2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(2*Pk2*(4*C*(r**2 - r*(13*s + 2) - 14*s**2 + 2*s + 1) + K*(-26*r**2 + 4*r*s - 65*r + 30*s**2 - 107*s + 46) + 32*r**2 + 66*r*s + 106*r + 34*s**2 + 147*s - 76) + Pkd2*k2*(60*C*s**2 - 16*C*s - 3*K*(2*s - 1)*(11*r + 11*s - 2) + r*(60*C*s + 8*s - 41) + 8*s**2 - 52*s + 17)) + k1**2*k2**2*(Pk2*(4*C*(42*r**2 + r*(67 - 226*s) + 40*s**2 + 201*s - 80) - 2*K*(452*r**2 + 386*r*s - 67*r - 66*s**2 + 283*s - 125) + 1068*r**2 + 2032*r*s - 1045*r + 348*s**2 - 790*s + 262) + Pkd2*k2*(192*C*s**2 - 348*C*s - 144*K*(2*s - 1)*(2*r + 2*s - 1) + r*(584*C*s + 10*s - 189) + 206*s**2 - 201*s + 105)) + k2**4*(4*C*Pk2*(12*r*(33*s + 13) + 60*s**2 - 175*s - 96) - 14*K*Pk2*(78*r**2 + 2*r*(57*s - 28) + 9*(1 - 2*s)**2) - 84*K*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1) + 3*Pk2*(112*r**2 - 4*r*(38*s + 47) - 40*s**2 + 105*s + 78) + Pkd2*k2*s*(24*C - 12)*(12*r + 5*s - 6))) + 14*gd2*(k1**4*(2*Pk2*(r**2 + 3*r*s - 2*r + 2*s**2 - 5*s + 1) - Pkd2*k2*s*(r + s - 3)) + k1**2*k2**2*(-2*Pk2*(r**2 + 10*r*s - 4*r + 9*s**2 - 3*s + 3) + Pkd2*k2*s*(4*r + 4*s + 3)) - 6*k2**4*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 28*bd1*g2*(k1**4*(2*Pk2*(r**2 + 3*r*s + r + s*(2*s - 2)) - Pkd2*k2*(r*(s + 2) + s*(s - 1))) + k1**2*k2**2*(-2*Pk2*(r**2 + 10*r*(s - 1) + s*(9*s - 9)) + Pkd2*k2*(r*(4*s - 7) + s*(4*s - 4))) - 6*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + 4*fd*g2*(k1**4*(2*Pk2*(26*r**2 - 4*r*s + 65*r - 30*s**2 + 107*s - 46) + 3*Pkd2*k2*(2*s - 1)*(11*r + 11*s - 2)) + 2*k1**2*k2**2*(Pk2*(452*r**2 + 386*r*s - 67*r - 66*s**2 + 283*s - 125) + 72*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)) + 14*k2**4*(Pk2*(78*r**2 + 2*r*(57*s - 28) + 9*(1 - 2*s)**2) + 6*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(462*b1*k2**2*(-12*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(K - 1)*(2*Pk2*(4*r**2 + r*(12*s - 5) + 8*s**2 - 14*s + 3) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + k1**2*k2**2*(2*Pk2*(2*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - K*(4*r**2 + 8*r*(5*s - 3) + 36*s**2 - 21*s + 9) + 8*r**2 + 48*r*s - 23*r + 40*s**2 - 20*s + 6) + Pkd2*k2*(r*(K*(16*s - 7) - 28*s + 6) + s*(2*K*(8*s + 1) - 28*s + 9))) - 6*k2**4*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(k1**4*(2*Pk2*(4*r**2 + r*(12*s - 5) + 8*s**2 - 14*s + 3) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(5*s - 3) + 36*s**2 - 21*s + 9) + Pkd2*k2*(r*(16*s - 7) + 2*s*(8*s + 1))) - 6*k2**4*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 3*f**3*k1**2*(264*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 104*s**2 - 192*s + 69) + 22*k1**2*k2**2*(2*Pk2*(450*r**2 - r*(582*s + 197) - 1032*s**2 + 909*s - 104) + 5*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 22*f**2*k2**2*(k1**4*(2*Pk2*(-4*C*(42*r**2 + 6*r*(7*s + 5) + 5*s - 32) + 6*b1*(12*r**2 - r*(72*s + 61) - 84*s**2 - 17*s + 46) + 204*r**2 + 204*r*s + 147*r + 104*s - 176) + 3*Pkd2*k2*(C*(-72*r*s + 22*r - 72*s**2 + 42*s - 8) + 4*b1*(r*(48*s + 34) + 48*s**2 + 12*s - 29) + 84*r*s - 36*r + 84*s**2 - 75*s + 21)) + 9*k1**2*k2**2*(Pk2*(-4*C*(156*r**2 - 396*r*s - 70*r - 80*s**2 + 366*s - 41) + 8*b1*(75*r**2 + r*(97*s - 85) + 22*s**2 - 55*s + 24) + 720*r**2 - 280*r*s - 586*r - 56*s**2 + 474*s + 33) + Pkd2*k2*(-2*C*(144*r*s - 53*r + 144*s**2 - 150*s + 37) + 3*b1*(21*s - 10)*(4*r + 4*s - 3) + 240*r*s - 98*r + 240*s**2 - 264*s + 70)) + 18*k2**4*(Pk2*(-2*C*(220*r**2 + 4*r*(27*s - 59) + 56*s**2 - 36*s + 55) + 4*b1*(2*r - 1)*(5*r + 5*s - 3) + 276*r**2 + 164*r*s - 286*r + 56*s**2 - 52*s + 63) + Pkd2*k2*(6 - 12*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 33*f*k2**2*(12*Pk2*b2*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(-120*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 28*Pk2*k2**2*(6*r**2 + 2*r*(3*s - 8) - 9*s + 8) + 3*Pkd2*k1**2*k2*(r*(19 - 264*s) - 264*s**2 + 156*s + 1)) + 2*b1*(k1**4*(2*Pk2*(4*C*(2*r**2 - r*(26*s + 5) - 28*s**2 + 12*s + 4) + K*(-52*r**2 + 8*r*s - 75*r + 60*s**2 - 145*s + 82) + 64*r**2 + 132*r*s + 166*r + 68*s**2 + 209*s - 172) + Pkd2*k2*(2*C*(r*(60*s + 3) + 60*s**2 - 31*s - 5) - 3*K*(44*r*s - 13*r + 44*s**2 - 23*s + 4) + 16*r*s - 71*r + 16*s**2 - 74*s + 51)) + k1**2*k2**2*(Pk2*(4*C*(84*r**2 + r*(29 - 452*s) + 80*s**2 + 392*s - 82) - 2*K*(904*r**2 + 772*r*s - 535*r - 132*s**2 + 249*s - 109) + 2136*r**2 + 4064*r*s - 2621*r + 696*s**2 - 2148*s + 762) + Pkd2*k2*(2*C*(r*(584*s - 66) + 192*s**2 - 396*s + 47) - 144*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 20*r*s - 251*r + 412*s**2 - 379*s + 192)) + k2**4*(Pk2*(8*C*(r*(396*s + 74) + 60*s**2 - 205*s - 39) - 14*K*(156*r**2 + 2*r*(114*s - 83) + 72*s**2 - 120*s + 41) + 672*r**2 - 3*r*(304*s + 353) - 240*s**2 + 582*s + 345) + 6*Pkd2*k2*(2*C*(6*r*(8*s - 1) + 20*s**2 - 29*s + 3) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 48*r*s + 6*r - 20*s**2 + 29*s - 3))) + 4*g2*(k1**4*(2*Pk2*(52*r**2 - 8*r*s + 75*r - 60*s**2 + 145*s - 82) + 3*Pkd2*k2*(44*r*s - 13*r + 44*s**2 - 23*s + 4)) + 2*k1**2*k2**2*(Pk2*(904*r**2 + 772*r*s - 535*r - 132*s**2 + 249*s - 109) + 72*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) + 14*k2**4*(Pk2*(156*r**2 + 228*r*s - 166*r + 72*s**2 - 120*s + 41) + 6*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(3465*d**2*k2**2*k3**6) + 4*D1**3*Pk3*ct**2*(D1*bd1*f*(f**2*k1**2*(162*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(3*r*(5*s - 4) + 15*s**2 - 23*s + 8) - 18*k1**2*k2**2*(Pk2*(85*r**2 + r*(43*s - 100) - 42*s**2 - 7*s + 35) + 5*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) - 6*f*k2**2*(k1**4*(Pk2*(4*C*(84*r**2 + 3*r*(73*s - 47) + 93*s**2 - 167*s + 53) + 2*K*(33*r**2 + 146*r*s - 45*r + 113*s**2 - 91*s + 12) - 3*b1*(68*r**2 + r*(136*s - 95) + 68*s**2 - 95*s + 27) - 516*r**2 - 1246*r*s + 840*r - 646*s**2 + 962*s - 308) - 3*Pkd2*k2*(-2*C*(23*r*s - 8*r + 23*s**2 - 27*s + 4) - 14*K*r*s + 14*K*r - 14*K*s**2 + 28*K*s - 14*K + b1*(r*(43*s - 16) + 43*s**2 - 43*s + 8) + 45*r*s - 19*r + 45*s**2 - 58*s + 13)) + k1**2*k2**2*(Pk2*(2*C*(816*r**2 + 818*r*s - 773*r + 604*s**2 - 719*s + 73) + 574*K*r**2 + 1512*K*r*s - 1008*K*r + 938*K*s**2 - 1134*K*s + 434*K - 7*b1*(168*r**2 + 3*r*(92*s - 83) + 108*s**2 - 205*s + 89) - 1514*r**2 - 2078*r*s + 1647*r - 1166*s**2 + 1463*s - 332) - 3*Pkd2*k2*(-2*C*(59*r*s - 26*r + 59*s**2 - 65*s + 6) - 35*K*r*s + 21*K*r - 35*K*s**2 + 56*K*s - 21*K + 7*b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) + 80*r*s - 33*r + 80*s**2 - 86*s + 6)) + k2**4*(Pk2*(C*(524*r**2 + 384*r*s - 370*r + 280*s**2 - 250*s - 30) + 84*K*r**2 + 252*K*r*s - 140*K*r + 168*K*s**2 - 168*K*s + 56*K - 14*b1*(2*r - 1)*(3*r + 3*s - 1) - 318*r**2 - 248*r*s + 206*r - 140*s**2 + 125*s + 15) + Pkd2*k2*(42*C - 21)*(r*(2*s - 1) + s*(2*s - 2)))) - 42*k2**2*(7*Pk2*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*b2*k2**2*(7*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - b1*(2*k1**4*(2*Pk2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - 17*K*s**2 + 15*K*s - r**2*(14*K - 18) + r*(-31*K*s + 16*K + 39*s - 18) + 21*s**2 - 17*s - 2) - Pkd2*k2*(r*(K*(13*s - 2) - 9*s + 1) + s*(K*(13*s - 11) - 9*s + 8))) + k1**2*k2**2*(Pk2*(4*C*(16*r**2 - 68*r*s + r + 16*s**2 + 26*s - 17) + K*(-248*r**2 - 484*r*s + 226*r - 236*s**2 + 210*s + 24) + 146*r**2 + 452*r*s - 157*r + 106*s**2 - 177*s + 16) + Pkd2*k2*(r*(K*(16 - 74*s) + 30*s - 5) + s*(-74*K*s + 58*K + 30*s - 25))) + k2**4*(5*K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + Pk2*(4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) - 10*K*(6*r**2 + 12*r*s - 5*r + 6*s**2 - 5*s - 1) + 12*r**2 + 44*r*s - 13*r - 8*s**2 - 13*s + 6))) - 2*g2*(k1**4*(Pk2*(28*r**2 + r*(62*s - 36) + s*(34*s - 34)) + Pkd2*k2*(r*(13*s - 4) + s*(13*s - 13))) + k1**2*k2**2*(2*Pk2*(62*r**2 + r*(121*s - 63) + s*(59*s - 59)) + Pkd2*k2*(r*(37*s - 16) + s*(37*s - 37))) + 5*k2**4*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) - 294*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(D1*fd*(k1**4*(2*Pk2*(56*C*(r + s - 1)**2 + 3*f*(68*r**2 + r*(136*s - 79) + 68*s**2 - 79*s + 27) - 14*r**2*(14*K - 18) - 14*r*(s*(31*K - 39) - 8) - 14*s**2*(17*K - 21) + 112*s - 56) + Pkd2*k2*s*(129*f*(2*r + 2*s - 1) + (126 - 182*K)*(r + s))) + 7*k1**2*k2**2*(2*Pk2*(8*C*(4*r**2 - r*(17*s + 8) + 4*s**2 + 17*s + 4) - 124*K*r**2 - 242*K*r*s - 48*K*r - 118*K*s**2 - 48*K*s + 24*K + f*(168*r**2 + 3*r*(92*s - 53) + 108*s**2 - 133*s + 33) + 73*r**2 + 226*r*s + 68*r + 53*s**2 - 32*s - 34) + Pkd2*k2*s*(f*(90*r + 90*s - 39) + (30 - 74*K)*(r + s))) - 28*k2**4*(5*K*Pkd2*k2*s*(r + s) + Pk2*(-4*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 15*K*r**2 + 30*K*r*s + 10*K*r + 15*K*s**2 + 10*K*s - 5*K - f*(2*r - 1)*(3*r + 3*s - 1) - 3*r**2 - 11*r*s - 4*r + 2*s**2 + 6*s + 2))) + Dd*f*(k1**4*(4*Pk2*(28*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 3*f*(68*r**2 + r*(136*s - 87) + 68*s**2 - 87*s + 27) - 7*r**2*(56*K - 72) - 14*r*(K*(62*s - 23) - 78*s + 21) - 7*s**2*(68*K - 84) - 7*s*(39 - 43*K) - 84) + Pkd2*k2*(f*(12*r*(43*s - 8) + 516*s**2 - 387*s + 48) - 14*r*(52*K*s - 4*K - 36*s + 2) - 14*s*(52*K*s - 31*K - 36*s + 23))) + 7*k1**2*k2**2*(2*Pk2*(4*C*(32*r**2 - r*(136*s + 31) + 32*s**2 + 94*s - 1) - 496*K*r**2 - 968*K*r*s + 278*K*r - 472*K*s**2 + 254*K*s + 72*K + 2*f*(168*r**2 + 276*r*s - 204*r + 108*s**2 - 169*s + 61) + 292*r**2 + 904*r*s - 128*r + 212*s**2 - 333*s - 52) + Pkd2*k2*(3*f*(r*(60*s - 6) + 60*s**2 - 41*s + 2) - 2*r*(4*K*(37*s - 4) - 60*s + 5) - 2*s*(K*(148*s - 79) - 60*s + 35))) + 14*k2**4*(5*K*Pkd2*k2*(-8*r*s + r + s*(4 - 8*s)) + Pk2*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 120*K*r**2 - 240*K*r*s + 50*K*r - 120*K*s**2 + 50*K*s + 30*K + 4*f*(2*r - 1)*(3*r + 3*s - 1) + 24*r**2 + 88*r*s - 7*r - 16*s**2 - 42*s - 2)))) + b1*(-3*D1*(f**2*fd*k1**2*(-54*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - 25*k1**4*s*(2*Pk2 - Pkd2*k2)*(3*r + 3*s - 2) + 6*k1**2*k2**2*(Pk2*(255*r**2 + r*(129*s - 265) - 126*s**2 - 51*s + 66) + 5*Pkd2*k2*(r*(12*s + 13) + 12*s**2 + 6*s - 9))) + 2*f*k2**2*(14*Pk2*bd2*k2**2*(7*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(2*Pk2*(2*C*(168*r**2 + 3*r*(146*s - 63) + 186*s**2 - 247*s + 63) + K*(66*r**2 + 146*r*(2*s - 1) + 226*s**2 - 247*s + 67) - 516*r**2 - 1246*r*s + 605*r - 646*s**2 + 754*s - 198) + 3*Pkd2*k2*(2*r + 2*s - 1)*(14*K*(s - 1) + s*(46*C - 45) + 7)) + k1**2*k2**2*(2*Pk2*(C*(1632*r**2 + 2*r*(818*s - 715) + 1208*s**2 - 357*s + 274) + 7*K*(82*r**2 + 216*r*s - 132*r + 134*s**2 - 153*s + 43) - 1514*r**2 - 2078*r*s + 1343*r - 1166*s**2 + 777*s - 266) + 3*Pkd2*k2*(7*K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(C*(236*r + 236*s - 90) - 160*r - 160*s + 59))) + k2**4*(2*Pk2*(C*(524*r**2 + 384*r*(s - 1) + 280*s**2 + 25*s + 40) + 14*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 318*r**2 - 248*r*s + 220*r - 140*s**2 + 5*s - 20) + Pkd2*k2*s*(42*C - 21)*(4*r + 4*s - 1))) - 14*gd2*(k1**4*(Pk2*(28*r**2 + 62*r*s - 28*r + 34*s**2 - 26*s) + Pkd2*k2*s*(13*r + 13*s - 9)) + k1**2*k2**2*(2*Pk2*(62*r**2 + 121*r*s - 50*r + 59*s**2 - 46*s - 12) + Pkd2*k2*s*(37*r + 37*s - 21)) + 5*k2**4*(2*Pk2*(3*r**2 + 6*r*s - 2*r + 3*s**2 - 2*s - 1) + Pkd2*k2*s*(2*r + 2*s - 1)))) - 28*fd*k2**2*(-Pk2*b2*k2**2*(7*k1**2 + 5*k2**2)*(r + s)**2 + g2*(k1**4*(r + s)*(28*Pk2*r + 34*Pk2*s + 13*Pkd2*k2*s) + k1**2*k2**2*(2*Pk2*(62*r**2 + 121*r*s + 24*r + 59*s**2 + 24*s - 12) + 37*Pkd2*k2*s*(r + s)) + 10*k2**4*(Pk2*(3*r**2 + 6*r*s + 2*r + 3*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s))))) + Dd*f*(f**2*k1**2*(324*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(12*r*(5*s - 1) + 60*s**2 - 53*s + 8) - 18*k1**2*k2**2*(Pk2*(340*r**2 + r*(172*s - 365) - 168*s**2 - 58*s + 101) + 5*Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) - 6*f*k2**2*(k1**4*(2*Pk2*(2*C*(336*r**2 + 12*r*(73*s - 38) + 372*s**2 - 587*s + 158) + K*(132*r**2 + 584*r*s - 236*r + 452*s**2 - 429*s + 91) - 1032*r**2 - 2492*r*s + 1415*r - 1292*s**2 + 1707*s - 484) + 3*Pkd2*k2*(2*C*(r*(92*s - 8) + 92*s**2 - 69*s + 4) + 14*K*(s - 1)*(4*r + 4*s - 3) - 180*r*s + 40*r - 180*s**2 + 163*s - 27)) + k1**2*k2**2*(Pk2*(2*C*(3264*r**2 + r*(3272*s - 3359) + 2416*s**2 - 1534*s + 687) + 14*K*(164*r**2 + 432*r*s - 276*r + 268*s**2 - 315*s + 105) - 6056*r**2 - 8312*r*s + 6410*r - 4664*s**2 + 4266*s - 1427) + 3*Pkd2*k2*(2*C*(r*(236*s - 26) + 236*s**2 - 149*s + 6) + 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) - 320*r*s + 33*r - 320*s**2 + 198*s - 6)) + k2**4*(Pk2*(2*C*(1048*r**2 + r*(768*s - 913) + 560*s**2 - 174*s + 107) + 28*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 1272*r**2 - 992*r*s + 1046*r - 560*s**2 + 244*s - 107) + Pkd2*k2*(42*C - 21)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 84*k2**2*(-Pk2*b2*k2**2*(7*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**4*(2*Pk2*(56*r**2 + 2*r*(62*s - 23) + s*(68*s - 43)) + Pkd2*k2*(r*(52*s - 4) + s*(52*s - 31))) + k1**2*k2**2*(Pk2*(496*r**2 + r*(968*s - 278) + 472*s**2 - 254*s - 72) + Pkd2*k2*(4*r*(37*s - 4) + s*(148*s - 79))) + 5*k2**4*(2*Pk2*(12*r**2 + 24*r*s - 5*r + 12*s**2 - 5*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + f*(D1*(-5*f**2*fd*k1**4*(48*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(70*r + 76*s - 54) + 7*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) - 2*f*k2**2*(18*Pk2*bd2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k2**4*(36*C - 18)*(36*r**2 + 18*r*(5*s - 3) + 54*s**2 - 57*s + 17) + k1**4*(2*Pk2*(2*C*(225*r**2 + 981*r*s - 432*r + 756*s**2 - 840*s + 206) - 495*r**2 - 1827*r*s + 894*r - 1332*s**2 + 1569*s - 415) + Pkd2*k2*(180*C - 135)*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(4*C*(1953*r**2 + 9*r*(541*s - 360) + 2916*s**2 - 3666*s + 1220) - 4959*r**2 - 12168*r*s + 7983*r - 7209*s**2 + 8880*s - 2917) + Pkd2*k2*(90*C - 45)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) - 6*gd2*(28*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + 2*k1**4*(Pk2*(33*r**2 + r*(146*s - 45) + 113*s**2 - 91*s + 12) + 21*Pkd2*k2*(s - 1)*(r + s - 1)) + 7*k1**2*k2**2*(2*Pk2*(41*r**2 + 36*r*(3*s - 2) + 67*s**2 - 81*s + 31) + 3*Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 12*fd*k2**2*(-3*Pk2*b2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + g2*(28*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 2*k1**4*(Pk2*(66*r**2 + 146*r*(2*s - 1) + 226*s**2 - 247*s + 67) + 21*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + 7*k1**2*k2**2*(2*Pk2*(82*r**2 + 216*r*s - 132*r + 134*s**2 - 153*s + 43) + 3*Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))))) + Dd*f*(-5*f**2*k1**4*(48*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(70*r + 76*s - 54) + 7*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) - 2*f*k2**2*(Pk2*k2**4*(36*C - 18)*(48*r**2 + 2*r*(60*s - 37) + 72*s**2 - 78*s + 25) + k1**4*(2*Pk2*(600*C*r**2 + 6*C*r*(436*s - 179) + 8*C*(252*s**2 - 269*s + 59) - 660*r**2 + r*(1139 - 2436*s) - 1776*s**2 + 2024*s - 495) + Pkd2*k2*(180*C - 135)*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(4*C*(2604*r**2 + 6492*r*s - 4410*r + 3888*s**2 - 4958*s + 1739) - 6612*r**2 - 16224*r*s + 10845*r - 9612*s**2 + 11941*s - 4126) + Pkd2*k2*(90*C - 45)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 12*k2**2*(-3*Pk2*b2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + g2*(28*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 2*k1**4*(Pk2*(132*r**2 + 584*r*s - 236*r + 452*s**2 - 429*s + 91) + 21*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + 7*k1**2*k2**2*(Pk2*(328*r**2 + 864*r*s - 552*r + 536*s**2 - 630*s + 210) + 3*Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10)))))))/(315*d**2*k2**2*k3**6) + D1**3*Pk3*ct**2*(-2*D1*bd1*f*(f*(Pk2*k2**2*r*(2 - 4*C)*(r + 3) + k1**2*(2*Pk2*(r*(31*s - 34) + s*(56*C*(s - 2) - 28*s + 127)) + 7*k2*(Pkd2*r*(7 - 10*s) - Pkd2*s*(2*C - 1)*(7*s - 11) + Pkdd2*k2*s*(6*C - 3)*(s - 1)))) + k1**2*s*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(35*b2 - 70*g2)*(s - 1)) - 35*b1**3*k1**2*(D1*fd*s*(Pk2 - Pkd2*k2)*(r - 1) + 2*Dd*f*(Pk2*(2*r*(s - 1) - 5*s + 2) + Pkd2*k2*(-2*r*s + r + 3*s - 1))) - 7*b1**2*k1**2*(5*D1*bd1*f*(Pk2*(r*(3*s - 4) - 9*s + 4) + Pkd2*k2*(r*(2 - 3*s) + 5*s - 2)) + D1*fd*(10*K*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)**2 + 4*Pk2*(r*(31*s - 15) - 16*s) - f*(3*Pk2*(2*r*(s + 1) - 11*s + 4) + 5*Pkd2*k2*(2*r - 1)*(3*s - 2)) + 4*k2*(Pkd2*r*(5 - 13*s) + Pkd2*s*(-2*C*s + s + 8) + Pkdd2*k2*s**2*(2*C - 1))) - 2*Dd*f*(3*Pk2*f*(r*(2*s + 7) - 11*s - 1) - 4*Pk2*(5*K*(4*s**2 - 5*s + 1) + r*(62*s - 19) - 29*s + 9) + Pkd2*k2*(16*C*s**2 - 4*C*s + 15*K*(4*s**2 - 5*s + 1) + 5*f*(2*r - 1)*(3*s - 2) + 104*r*s - 33*r - 8*s**2 - 56*s + 18) - Pkdd2*k2**2*(4*s - 1)*(5*K*(s - 1) + s*(4*C - 2)))) + b1*(7*D1*bd1*f*k1**2*(Pk2*(-80*K*s**2 + 80*K*s + 3*f*(2*r*(s + 6) - 11*s - 6) - 8*r*(31*s - 9) + 84*s - 52) + k2*(Pkd2*(16*C*s**2 - 8*C*s + 60*K*s**2 - 60*K*s + 5*f*(2*r - 1)*(3*s - 2) + 4*r*(26*s - 9) - 8*s**2 - 38*s + 26) - 4*Pkdd2*k2*s*(C*(4*s - 2) + 5*K*(s - 1) - 2*s + 1))) - 2*D1*(f*(fd*(Pk2*k2**2*(2 - 4*C)*(2*r**2 + 5*r - 3) + k1**2*(2*Pk2*(56*C*(2*s**2 - 5*s + 2) + 62*r*s - 66*r - 56*s**2 + 249*s - 93) + 7*k2*(Pkd2*(C*(-28*s**2 + 58*s - 22) - 20*r*s + 17*r + 14*s**2 - 22*s + 4) + Pkdd2*k2*(6*C - 3)*(2*s**2 - 3*s + 1)))) + k1**2*s*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(35*bd2 - 70*gd2)*(s - 1)) - 70*fd*g2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)**2) - 2*Dd*f*(f*(Pk2*k2**2*(4 - 8*C)*(2*r**2 + 5*r - 3) + k1**2*(2*Pk2*(56*C*(4*s**2 - 9*s + 2) + 2*r*(62*s - 67) - 112*s**2 + 470*s - 59) + 7*k2*(-Pkd2*(2*C*(28*s**2 - 51*s + 11) + 40*r*s - 31*r - 28*s**2 + 37*s + 3) + Pkdd2*k2*(6*C - 3)*(4*s**2 - 5*s + 1)))) - 70*g2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) - 70*b2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d**2*k1**2*k2**2) - 2*D1**3*Pk3*ct**2*st**2*(b1**2*k1**2*(D1*fd*(k1**2*(8*Pk2*(-77*K*(s - 1)**2 + 3*f*(20*s**2 + 17*s - 6) + s**2*(14*C + 70) - 154*s + 77) + k2*(-15*Pkd2*f*(20*s**2 + 17*s - 6) - 7*Pkd2*(-37*K*(s - 1)**2 + s**2*(10*C + 32) - 74*s + 37) + 3*Pkdd2*f*k2*(20*s**2 + 17*s - 6) + 7*Pkdd2*k2*(-5*K*(s - 1)**2 + s**2*(2*C + 4) - 10*s + 5))) + 14*k2**2*(6*K*Pk2*r*(r - 4*s + 4) + 3*K*Pkd2*k2*(4*r*(s - 1) + 2*s - 1) - 3*K*Pkdd2*k2**2*(2*s - 1) + Pk2*f*(2 - 10*r) - 6*Pk2*r*(r + 2) + 3*Pkd2*f*k2*r + 6*Pkd2*k2*r)) + Dd*f*(k1**2*(4*s - 1)*(8*Pk2*(14*C*s - 77*K*(s - 1) + 6*f*(5*s + 3) + 70*s - 77) + k2*(-30*Pkd2*f*(5*s + 3) - 7*Pkd2*(-37*K*(s - 1) + s*(10*C + 32) - 37) + 6*Pkdd2*f*k2*(5*s + 3) + 7*Pkdd2*k2*(-5*K*(s - 1) + s*(2*C + 4) - 5))) + 14*k2**2*(-4*Pk2*(-6*K*(r**2 + r*(2 - 4*s) + s - 1) + f*(8*r - 4) + 6*r**2 + 3*r - 3) + 3*k2*(K*Pkdd2*k2*(1 - 4*s) + Pkd2*(K*(2*r*(8*s - 5) + 3) + f*(4*r - 2) + 4*r - 2))))) - b1*k1**2*(D1*(f**2*(bd1*(24*Pk2*k1**2*s*(3 - 20*s) + 15*Pkd2*k1**2*k2*s*(20*s - 3) - 42*Pkd2*k2**3*(3*r - 2) + k2**2*(28*Pk2*(11*r - 7) + 3*Pkdd2*k1**2*s*(3 - 20*s))) + 3*fd*(3*k1**2*(Pk2*(6*r*(5*s - 14) + 816*s**2 - 695*s + 178) + 2*k2*(Pkd2*(-6*r*(s - 2) - 156*s**2 + 133*s - 32) + 3*Pkdd2*k2*(6*s**2 - 5*s + 1))) + k2**2*(Pk2*(252*r**2 + 45*r*s - 284*r - 155*s + 132) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2)))) + f*(7*bd1*(6*K*Pkdd2*k2**4*s + 8*Pk2*k1**2*s*(C*(2 - 4*s) + 22*K*(s - 1) - 20*s + 21) + Pkd2*k1**2*k2*s*(10*C*(2*s - 1) - 74*K*(s - 1) + 64*s - 69) - 6*Pkd2*k2**3*(K*(r*(8*s - 4) - s + 2) + r - 1) + k2**2*(-12*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + Pkdd2*k1**2*s*(C*(2 - 4*s) + 10*K*(s - 1) - 8*s + 9))) + 42*bd2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) + fd*k1**2*(4*Pk2*(4*C*(44*s**2 - 72*s + 25) + 6*K*(10*s**2 - 17*s + 6) + 25*r*s - 86*r + 388*s**2 - 532*s + 154) + k2*(-Pkd2*(2*C*(130*s**2 - 207*s + 71) + 15*K*(10*s**2 - 17*s + 6) + 32*r*s - 93*r + 592*s**2 - 847*s + 238) + Pkdd2*k2*(14*C*(2*s**2 - 3*s + 1) + 3*K*(10*s**2 - 17*s + 6) + 68*s**2 - 105*s + 28))) + fd*k2**2*(2*Pk2*(4*C*(26*r**2 + r*(294*s - 215) - 175*s + 115) - 14*K*(2*r*(6*s - 5) + 9*(1 - 2*s)**2) - 62*r**2 - 1176*r*s + 937*r + 350*s - 306) + k2*(Pkd2*(-10*C*(56*r*(2*s - 1) - 57*s + 30) + 84*K*(r*(s - 1) + 2*(1 - 2*s)**2) + 896*r*s - 525*r - 285*s + 171) - 3*Pkdd2*k2*(C*(12 - 34*s) + 14*K*(1 - 2*s)**2 + 17*s - 6))) + 14*gd2*(-88*Pk2*k1**2*s*(s - 1) + 37*Pkd2*k1**2*k2*s*(s - 1) + 6*Pkd2*k2**3*(r*(4*s - 2) - s + 2) - 6*Pkdd2*k2**4*s + k2**2*(12*Pk2*(r**2 - 4*r*s + r + 2*s - 2) - 5*Pkdd2*k1**2*s*(s - 1)))) + 14*fd*(3*b2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) - g2*k1**2*(88*Pk2 + k2*(-37*Pkd2 + 5*Pkdd2*k2))*(s - 1)**2 - 6*g2*k2**2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + Pkdd2*k2**2*(2*s - 1)))) + Dd*f*(42*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 6*f**2*(3*k1**2*(2*Pk2*(2*r*(5*s - 16) + 272*s**2 - 209*s + 50) + k2*(Pkd2*(-8*r*s + 18*r - 208*s**2 + 160*s - 35) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(168*r**2 + 30*r*s - 187*r - 85*s + 69) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) + f*(k1**2*(4*Pk2*(4*C*(88*s**2 - 122*s + 25) + 6*K*(20*s**2 - 29*s + 6) + 50*r*s - 199*r + 776*s**2 - 889*s + 267) + k2*(-Pkd2*(2*C*(260*s**2 - 349*s + 71) + 15*K*(20*s**2 - 29*s + 6) + 64*r*s - 213*r + 1184*s**2 - 1334*s + 358) + Pkdd2*k2*(4*s - 1)*(14*C*(s - 1) + 3*K*(5*s - 6) + 34*s - 28))) + 2*k2**2*(2*Pk2*(4*C*(26*r**2 + r*(294*s - 187) - 175*s + 94) - 7*K*(24*r*s - 26*r + 72*s**2 - 78*s + 25) - 62*r**2 - 1176*r*s + 762*r + 434*s - 327) + k2*(Pkd2*(C*(-224*r*(5*s - 2) + 600*s - 234) + 42*K*(2*r*s - 3*r + 16*s**2 - 15*s + 4) + 896*r*s - 434*r - 384*s + 201) + 3*Pkdd2*k2*(4*s - 1)*(6*C + K*(7 - 14*s) - 3)))) - 14*g2*k1**2*(88*Pk2 + k2*(-37*Pkd2 + 5*Pkdd2*k2))*(4*s**2 - 5*s + 1) - 84*g2*k2**2*(-8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(-16*r*s + 10*r - 3) + Pkdd2*k2*(4*s - 1))))) - f*(576*C*D1*Pk2*f*fd*k1**4*s**2 - 672*C*D1*Pk2*f*fd*k1**4*s + 160*C*D1*Pk2*f*fd*k1**4 - 468*C*D1*Pk2*f*fd*k1**2*k2**2*r*s + 768*C*D1*Pk2*f*fd*k1**2*k2**2*r - 1584*C*D1*Pk2*f*fd*k1**2*k2**2*s**2 + 1332*C*D1*Pk2*f*fd*k1**2*k2**2*s - 472*C*D1*Pk2*f*fd*k1**2*k2**2 + 72*C*D1*Pk2*f*fd*k2**4*r**2 + 144*C*D1*Pk2*f*fd*k2**4*r - 56*C*D1*Pk2*f*fd*k2**4 - 360*C*D1*Pkd2*f*fd*k1**4*k2*s**2 + 420*C*D1*Pkd2*f*fd*k1**4*k2*s - 100*C*D1*Pkd2*f*fd*k1**4*k2 + 72*C*D1*Pkd2*f*fd*k1**2*k2**3*r*s - 276*C*D1*Pkd2*f*fd*k1**2*k2**3*r + 1008*C*D1*Pkd2*f*fd*k1**2*k2**3*s**2 - 792*C*D1*Pkd2*f*fd*k1**2*k2**3*s + 236*C*D1*Pkd2*f*fd*k1**2*k2**3 + 72*C*D1*Pkdd2*f*fd*k1**4*k2**2*s**2 - 84*C*D1*Pkdd2*f*fd*k1**4*k2**2*s + 20*C*D1*Pkdd2*f*fd*k1**4*k2**2 - 216*C*D1*Pkdd2*f*fd*k1**2*k2**4*s**2 + 180*C*D1*Pkdd2*f*fd*k1**2*k2**4*s - 36*C*D1*Pkdd2*f*fd*k1**2*k2**4 + 768*C*Dd*Pk2*f**2*k1**4*s**2 - 832*C*Dd*Pk2*f**2*k1**4*s + 160*C*Dd*Pk2*f**2*k1**4 - 624*C*Dd*Pk2*f**2*k1**2*k2**2*r*s + 1112*C*Dd*Pk2*f**2*k1**2*k2**2*r - 2112*C*Dd*Pk2*f**2*k1**2*k2**2*s**2 + 1880*C*Dd*Pk2*f**2*k1**2*k2**2*s - 816*C*Dd*Pk2*f**2*k1**2*k2**2 + 96*C*Dd*Pk2*f**2*k2**4*r**2 + 176*C*Dd*Pk2*f**2*k2**4*r - 112*C*Dd*Pk2*f**2*k2**4 - 480*C*Dd*Pkd2*f**2*k1**4*k2*s**2 + 520*C*Dd*Pkd2*f**2*k1**4*k2*s - 100*C*Dd*Pkd2*f**2*k1**4*k2 + 96*C*Dd*Pkd2*f**2*k1**2*k2**3*r*s - 412*C*Dd*Pkd2*f**2*k1**2*k2**3*r + 1344*C*Dd*Pkd2*f**2*k1**2*k2**3*s**2 - 1048*C*Dd*Pkd2*f**2*k1**2*k2**3*s + 372*C*Dd*Pkd2*f**2*k1**2*k2**3 + 96*C*Dd*Pkdd2*f**2*k1**4*k2**2*s**2 - 104*C*Dd*Pkdd2*f**2*k1**4*k2**2*s + 20*C*Dd*Pkdd2*f**2*k1**4*k2**2 - 288*C*Dd*Pkdd2*f**2*k1**2*k2**4*s**2 + 216*C*Dd*Pkdd2*f**2*k1**2*k2**4*s - 36*C*Dd*Pkdd2*f**2*k1**2*k2**4 + 120*D1*Pk2*bd2*f*k1**4*s**2 - 144*D1*Pk2*bd2*f*k1**4*s - 168*D1*Pk2*bd2*f*k1**2*k2**2*r*s + 224*D1*Pk2*bd2*f*k1**2*k2**2*r - 504*D1*Pk2*bd2*f*k1**2*k2**2*s**2 + 588*D1*Pk2*bd2*f*k1**2*k2**2*s - 224*D1*Pk2*bd2*f*k1**2*k2**2 + 324*D1*Pk2*f*fd*k1**4*r*s - 348*D1*Pk2*f*fd*k1**4*r + 1800*D1*Pk2*f*fd*k1**4*s**2 - 1824*D1*Pk2*f*fd*k1**4*s + 488*D1*Pk2*f*fd*k1**4 + 378*D1*Pk2*f*fd*k1**2*k2**2*r**2 - 342*D1*Pk2*f*fd*k1**2*k2**2*r*s - 612*D1*Pk2*f*fd*k1**2*k2**2*r + 792*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 870*D1*Pk2*f*fd*k1**2*k2**2*s + 402*D1*Pk2*f*fd*k1**2*k2**2 - 36*D1*Pk2*f*fd*k2**4*r**2 - 72*D1*Pk2*f*fd*k2**4*r + 28*D1*Pk2*f*fd*k2**4 - 240*D1*Pk2*f*gd2*k1**4*s**2 + 288*D1*Pk2*f*gd2*k1**4*s + 336*D1*Pk2*f*gd2*k1**2*k2**2*r*s - 448*D1*Pk2*f*gd2*k1**2*k2**2*r + 1008*D1*Pk2*f*gd2*k1**2*k2**2*s**2 - 1176*D1*Pk2*f*gd2*k1**2*k2**2*s + 448*D1*Pk2*f*gd2*k1**2*k2**2 - 480*D1*Pk2*fd*g2*k1**4*s**2 + 816*D1*Pk2*fd*g2*k1**4*s - 288*D1*Pk2*fd*g2*k1**4 + 672*D1*Pk2*fd*g2*k1**2*k2**2*r*s - 560*D1*Pk2*fd*g2*k1**2*k2**2*r + 2016*D1*Pk2*fd*g2*k1**2*k2**2*s**2 - 2016*D1*Pk2*fd*g2*k1**2*k2**2*s + 504*D1*Pk2*fd*g2*k1**2*k2**2 - 75*D1*Pkd2*bd2*f*k1**4*k2*s**2 + 90*D1*Pkd2*bd2*f*k1**4*k2*s + 42*D1*Pkd2*bd2*f*k1**2*k2**3*r*s - 84*D1*Pkd2*bd2*f*k1**2*k2**3*r + 336*D1*Pkd2*bd2*f*k1**2*k2**3*s**2 - 294*D1*Pkd2*bd2*f*k1**2*k2**3*s + 84*D1*Pkd2*bd2*f*k1**2*k2**3 - 90*D1*Pkd2*f*fd*k1**4*k2*r*s + 96*D1*Pkd2*f*fd*k1**4*k2*r - 585*D1*Pkd2*f*fd*k1**4*k2*s**2 + 576*D1*Pkd2*f*fd*k1**4*k2*s - 149*D1*Pkd2*f*fd*k1**4*k2 + 324*D1*Pkd2*f*fd*k1**2*k2**3*r*s - 24*D1*Pkd2*f*fd*k1**2*k2**3*r - 504*D1*Pkd2*f*fd*k1**2*k2**3*s**2 + 312*D1*Pkd2*f*fd*k1**2*k2**3*s - 76*D1*Pkd2*f*fd*k1**2*k2**3 + 150*D1*Pkd2*f*gd2*k1**4*k2*s**2 - 180*D1*Pkd2*f*gd2*k1**4*k2*s - 84*D1*Pkd2*f*gd2*k1**2*k2**3*r*s + 168*D1*Pkd2*f*gd2*k1**2*k2**3*r - 672*D1*Pkd2*f*gd2*k1**2*k2**3*s**2 + 588*D1*Pkd2*f*gd2*k1**2*k2**3*s - 168*D1*Pkd2*f*gd2*k1**2*k2**3 + 300*D1*Pkd2*fd*g2*k1**4*k2*s**2 - 510*D1*Pkd2*fd*g2*k1**4*k2*s + 180*D1*Pkd2*fd*g2*k1**4*k2 - 168*D1*Pkd2*fd*g2*k1**2*k2**3*r*s + 168*D1*Pkd2*fd*g2*k1**2*k2**3*r - 1344*D1*Pkd2*fd*g2*k1**2*k2**3*s**2 + 1344*D1*Pkd2*fd*g2*k1**2*k2**3*s - 336*D1*Pkd2*fd*g2*k1**2*k2**3 + 15*D1*Pkdd2*bd2*f*k1**4*k2**2*s**2 - 18*D1*Pkdd2*bd2*f*k1**4*k2**2*s - 84*D1*Pkdd2*bd2*f*k1**2*k2**4*s**2 + 42*D1*Pkdd2*bd2*f*k1**2*k2**4*s + 45*D1*Pkdd2*f*fd*k1**4*k2**2*s**2 - 39*D1*Pkdd2*f*fd*k1**4*k2**2*s + 8*D1*Pkdd2*f*fd*k1**4*k2**2 + 108*D1*Pkdd2*f*fd*k1**2*k2**4*s**2 - 90*D1*Pkdd2*f*fd*k1**2*k2**4*s + 18*D1*Pkdd2*f*fd*k1**2*k2**4 - 30*D1*Pkdd2*f*gd2*k1**4*k2**2*s**2 + 36*D1*Pkdd2*f*gd2*k1**4*k2**2*s + 168*D1*Pkdd2*f*gd2*k1**2*k2**4*s**2 - 84*D1*Pkdd2*f*gd2*k1**2*k2**4*s - 60*D1*Pkdd2*fd*g2*k1**4*k2**2*s**2 + 102*D1*Pkdd2*fd*g2*k1**4*k2**2*s - 36*D1*Pkdd2*fd*g2*k1**4*k2**2 + 336*D1*Pkdd2*fd*g2*k1**2*k2**4*s**2 - 336*D1*Pkdd2*fd*g2*k1**2*k2**4*s + 84*D1*Pkdd2*fd*g2*k1**2*k2**4 + D1*bd1*k1**2*(42*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + 9*f**2*k1**2*(Pk2*(2*r*(5*s - 22) + 272*s**2 - 141*s + 22) + 2*k2*(Pkd2*(-2*r*s + 6*r - 52*s**2 + 27*s - 3) + 3*Pkdd2*k2*s*(2*s - 1))) + 3*f**2*k2**2*(r - 1)*(3*Pk2*(28*r + 5*s - 2) + 7*Pkd2*k2*(5*s - 2)) + f*k1**2*(2*Pk2*(r*(25*s - 113) + s**2*(176*C + 60*K + 388) - s*(200*C + 72*K + 327) + 113) + k2*(Pkd2*(r*(60 - 16*s) - s**2*(130*C + 75*K + 296) + s*(142*C + 90*K + 206) - 60) + Pkdd2*k2*s*(14*C*(s - 1) + 3*K*(5*s - 6) + 34*s - 13))) + f*k2**2*(-2*Pk2*(14*K*(r*(6*s - 8) + 18*s**2 - 21*s + 8) + r**2*(31 - 52*C) + r*(C*(292 - 588*s) + 588*s - 271) + 21*s*(8*C - 8) + 63) + k2*(Pkd2*(42*K*(r*(s - 2) + 8*s**2 - 7*s + 2) - 7*r*(8*C*(10*s - 3) - 64*s + 25) + s*(162*C - 165) + 63) + 3*Pkdd2*k2*s*(2*C + K*(14 - 28*s) - 1))) + 14*g2*(-88*Pk2*k1**2*s*(s - 1) + 37*Pkd2*k1**2*k2*s*(s - 1) + 12*Pkd2*k2**3*r*(2*s - 1) + k2**2*(12*Pk2*r*(r - 4*s + 2) - 5*Pkdd2*k1**2*s*(s - 1)))) + 432*Dd*Pk2*f**2*k1**4*r*s - 480*Dd*Pk2*f**2*k1**4*r + 2400*Dd*Pk2*f**2*k1**4*s**2 - 2336*Dd*Pk2*f**2*k1**4*s + 620*Dd*Pk2*f**2*k1**4 + 504*Dd*Pk2*f**2*k1**2*k2**2*r**2 - 456*Dd*Pk2*f**2*k1**2*k2**2*r*s - 972*Dd*Pk2*f**2*k1**2*k2**2*r + 1056*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 1140*Dd*Pk2*f**2*k1**2*k2**2*s + 636*Dd*Pk2*f**2*k1**2*k2**2 - 48*Dd*Pk2*f**2*k2**4*r**2 - 88*Dd*Pk2*f**2*k2**4*r + 56*Dd*Pk2*f**2*k2**4 - 960*Dd*Pk2*f*g2*k1**4*s**2 + 1392*Dd*Pk2*f*g2*k1**4*s - 288*Dd*Pk2*f*g2*k1**4 + 1344*Dd*Pk2*f*g2*k1**2*k2**2*r*s - 1456*Dd*Pk2*f*g2*k1**2*k2**2*r + 4032*Dd*Pk2*f*g2*k1**2*k2**2*s**2 - 4368*Dd*Pk2*f*g2*k1**2*k2**2*s + 1400*Dd*Pk2*f*g2*k1**2*k2**2 - 120*Dd*Pkd2*f**2*k1**4*k2*r*s + 132*Dd*Pkd2*f**2*k1**4*k2*r - 780*Dd*Pkd2*f**2*k1**4*k2*s**2 + 731*Dd*Pkd2*f**2*k1**4*k2*s - 185*Dd*Pkd2*f**2*k1**4*k2 + 432*Dd*Pkd2*f**2*k1**2*k2**3*r*s + 2*Dd*Pkd2*f**2*k1**2*k2**3*r - 672*Dd*Pkd2*f**2*k1**2*k2**3*s**2 + 356*Dd*Pkd2*f**2*k1**2*k2**3*s - 102*Dd*Pkd2*f**2*k1**2*k2**3 + 600*Dd*Pkd2*f*g2*k1**4*k2*s**2 - 870*Dd*Pkd2*f*g2*k1**4*k2*s + 180*Dd*Pkd2*f*g2*k1**4*k2 - 336*Dd*Pkd2*f*g2*k1**2*k2**3*r*s + 504*Dd*Pkd2*f*g2*k1**2*k2**3*r - 2688*Dd*Pkd2*f*g2*k1**2*k2**3*s**2 + 2520*Dd*Pkd2*f*g2*k1**2*k2**3*s - 672*Dd*Pkd2*f*g2*k1**2*k2**3 + 60*Dd*Pkdd2*f**2*k1**4*k2**2*s**2 - 47*Dd*Pkdd2*f**2*k1**4*k2**2*s + 8*Dd*Pkdd2*f**2*k1**4*k2**2 + 144*Dd*Pkdd2*f**2*k1**2*k2**4*s**2 - 108*Dd*Pkdd2*f**2*k1**2*k2**4*s + 18*Dd*Pkdd2*f**2*k1**2*k2**4 - 120*Dd*Pkdd2*f*g2*k1**4*k2**2*s**2 + 174*Dd*Pkdd2*f*g2*k1**4*k2**2*s - 36*Dd*Pkdd2*f*g2*k1**4*k2**2 + 672*Dd*Pkdd2*f*g2*k1**2*k2**4*s**2 - 504*Dd*Pkdd2*f*g2*k1**2*k2**4*s + 84*Dd*Pkdd2*f*g2*k1**2*k2**4 + b2*k1**2*(D1*fd*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(10*s**2 - 17*s + 6) - 14*k2**2*(4*Pk2*r*(6*s - 5) + 18*Pk2*(1 - 2*s)**2 - 6*Pkd2*k2*(r*(s - 1) + 2*(1 - 2*s)**2) + 3*Pkdd2*k2**2*(1 - 2*s)**2)) + Dd*f*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(20*s**2 - 29*s + 6) - 14*k2**2*(2*Pk2*(r*(24*s - 26) + 72*s**2 - 78*s + 25) + 3*k2*(Pkd2*(-4*r*s + 6*r - 32*s**2 + 30*s - 8) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(105*d**2*k1**2*k2**2*k3**2) - 2*D1**3*Pk3*ct**2*st**2*(3*D1*bd1*f*k1**2*(84*Pkd2*b2*k2**5*(r*(2*s - 1) + s*(2*s - 2)) + 7*b1*k1**4*s*(K - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + 7*b1*k1**2*k2**2*(Pk2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(8*r**2 + 126*r*s + 52*r + 160*s**2 - 135*s - 20) + 8*r**2 + 126*r*s + 40*r + 160*s**2 - 151*s - 16) - k2*(4*C*Pkd2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*K*Pkd2*(3*r*(5*s + 2) + 31*s**2 - 26*s - 1) + 3*K*Pkdd2*k2*s*(2*s - 1) + 30*Pkd2*r*s + 6*Pkd2*r + 64*Pkd2*s**2 - 61*Pkd2*s - 8*Pkdd2*k2*s**2 + 4*Pkdd2*k2*s)) + 42*b1*k2**4*(-2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s))) + f**2*(k1**4*(4*Pk2*(8*r*(3*s - 5) + 72*s**2 - 99*s + 20) + k2*(Pkd2*(-24*r*s + 40*r - 144*s**2 + 177*s - 20) + 2*Pkdd2*k2*s*(12*s - 13))) + 3*k1**2*k2**2*(Pk2*(156*r**2 - 36*r*(11*s + 9) - 376*s**2 + 179*s + 168) + 2*k2*(Pkd2*(87*r*s + 30*r + 31*s**2 - 34*s - 30) + 3*Pkdd2*k2*s*(4*s - 1))) + 3*k2**4*(r - 1)*(Pk2*(96*r + 95*s - 74) + 7*Pkd2*k2*(5*s - 2))) + f*(k1**4*(8*Pk2*(r*(s - 9) + s**2*(12*C - 22*K + 11) + s*(-12*C + 25*K - 35) + 9) + k2*(Pkd2*(-2*r*(s - 9) + s**2*(-60*C + 65*K - 7) + s*(60*C - 71*K + 55) - 18) + Pkdd2*k2*s*(s - 1)*(12*C - 7*K - 5))) + k1**2*k2**2*(Pk2*(2*C*(44*r**2 + 157*r*s - 92*r - 168*s**2 - 32*s + 8) - 96*K*r**2 + 361*K*r*s + 382*K*r - 1032*K*s**2 + 1207*K*s - 286*K + 6*b1*(r*(80*s + 29) + 80*s**2 - 52*s - 13) + 136*r**2 - 1117*r*s + 226*r + 80*s**2 + 399*s - 370) + k2*(Pkd2*(C*(-194*r*s + 32*r + 62*s**2 + 182*s - 8) - 229*K*r*s - 74*K*r + 411*K*s**2 - 441*K*s + 74*K - 3*b1*(r*(80*s + 29) + 50*s**2 - 37*s - 13) + 611*r*s - 224*r + 114*s**2 - 477*s + 244) + Pkdd2*k2*s*(46*C*(s - 1) - 111*K*s + 66*K + b1*(45 - 90*s) + 32*s - 11))) - k2**4*(-2*Pk2*(-52*C*r**2 - 588*C*r*s + 40*C*r + 168*C*s - 14*K*(12*r**2 - 8*r*(3*s + 2) - 18*s**2 + 3*s + 4) + 7*b1*(2*r*(9*s - 5) - 9*s + 8) + 325*r**2 + 357*r*s - 418*r - 168*s + 63) + k2*(Pkd2*(C*(-560*r*s + 296*r - 90*s**2 + 234*s - 240) + 42*K*(r*(15*s - 2) + 8*s**2 - 9*s + 2) + 21*b1*(2*r*(s + 1) + s - 2) + 126*r*s - 99*r + 45*s**2 - 12*s + 57) + 3*Pkdd2*k2*s*(-10*C*(s - 1) + 28*K*s - 14*K + 5*s - 5)))) + 14*g2*(-k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + k1**2*k2**2*(Pk2*(4*r**2 + 9*r*(7*s + 4) + s*(80*s - 80)) + k2*(-5*Pkd2*r*(3*s + 2) - 31*Pkd2*s*(s - 1) + 3*Pkdd2*k2*s*(s - 1))) - 6*k2**4*(-2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(4*s - 2) + 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))))) - 3*b1**2*k1**2*(D1*fd*(k1**4*s**2*(7 - 7*K)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(-Pk2*(-7*K*(4*r**2 + 63*r*s - 60*r + 80*s**2 - 112*s + 56) + 6*f*(r*(80*s + 47) + 80*s**2 + 20*s - 47) + 28*r**2 + 7*r*(s*(16*C + 63) - 64) + 7*s**2*(16*C + 80) - 7*s*(16*C + 104) + 420) + k2*(3*Pkd2*f*(r*(80*s + 47) + 50*s**2 + 20*s - 47) + 7*Pkd2*(8*C*s**2 - 8*C*s + K*(r*(16 - 15*s) - 31*s**2 + 32*s - 16) + r*(8*C*s + 15*s - 18) + 32*s**2 - 28*s + 18) + Pkdd2*k2*s**2*(21*K + 90*f - 28))) + 7*k2**4*(-6*K*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) + f*(Pk2*(-4*r*(9*s + 1) + 18*s + 8) + 3*Pkd2*k2*s*(2*r + 1)) + 12*r*(Pk2*(r + 2) + Pkd2*k2*s))) + Dd*f*(k1**4*s*(7 - 7*K)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 7*K*(8*r**2 + 126*r*s + 4*r + 160*s**2 - 151*s + 8) + 12*f*(r*(40*s + 19) + 40*s**2 - 8*s - 15) + 56*r**2 + 882*r*s - 70*r + 1120*s**2 - 1141*s + 126) + k2*(Pkd2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 7*K*(r*(60*s - 2) + 124*s**2 - 105*s + 12) + 3*f*(4*r*(40*s + 19) + 100*s**2 - 17*s - 60) + 14*r*(30*s - 8) + 896*s**2 - 826*s + 154) + Pkdd2*k2*s*(4*s - 1)*(21*K + 45*f - 28))) + 14*k2**4*(2*Pk2*(6*K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) - f*(2*r - 1)*(9*s - 2) + 12*r**2 + 6*r - 6) - 3*k2*(K*Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + K*Pkdd2*k2*s*(4*s - 1) - Pkd2*f*(2*r*s + r + s - 1) + Pkd2*(-8*r*s + r + 2*s))))) + 3*b1*k1**2*(D1*(f**2*fd*(k1**4*(12*Pk2*(r*(24*s - 26) + 72*s**2 - 27*s + 18) + k2*(-3*Pkd2*(24*r*s - 26*r + 144*s**2 + 15*s + 8) + 2*Pkdd2*k2*(36*s**2 + 21*s - 5))) + 3*k1**2*k2**2*(Pk2*(468*r**2 - 12*r*(99*s + 20) - 1128*s**2 + 1077*s - 64) + 6*k2*(Pkd2*(87*r*s - 18*r + 31*s**2 - 37*s + 9) + 3*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 3*k2**4*(Pk2*(288*r**2 + 3*r*(95*s - 92) - 235*s + 88) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2))) + f*(84*Pkd2*bd2*k2**5*s*(2*r + 2*s - 1) + fd*(k1**4*(8*Pk2*(24*C*s**2 + K*(-44*s**2 + 72*s - 25) + 2*r*(s - 4) + 22*s**2 - 95*s + 36) - k2*(Pkd2*(120*C*s**2 + K*(-130*s**2 + 207*s - 71) + 4*r*(s - 4) + 14*s**2 - 253*s + 93) + Pkdd2*k2*(7*K*(2*s**2 - 3*s + 1) + s**2*(10 - 24*C) + 21*s - 7))) + k1**2*k2**2*(2*Pk2*(C*(88*r**2 + r*(314*s - 276) - 336*s**2 - 221*s + 188) - K*(96*r**2 - 361*r*s + 2*r + 1032*s**2 - 1508*s + 496) + 136*r**2 - 1117*r*s + 918*r + 80*s**2 + 327*s - 184) + k2*(Pkd2*(2*C*(-2*r*(97*s - 58) + 62*s**2 + 203*s - 116) + K*(-458*r*s + 68*r + 822*s**2 - 1319*s + 454) + 1222*r*s - 809*r + 228*s**2 - 463*s + 172) + Pkdd2*k2*(-3*K*(74*s**2 - 81*s + 22) + s**2*(92*C + 64) - 147*s + 42))) + k2**4*(-2*Pk2*(4*C*(26*r**2 + r*(294*s - 89) - 175*s + 52) + 14*K*(24*r**2 + r*(22 - 48*s) - 9*(1 - 2*s)**2) - 650*r**2 - 714*r*s + 391*r + 371*s - 159) + k2*(Pkd2*(4*C*(8*r*(35*s + 9) + 45*s**2 - 66*s - 72) - 84*K*(15*r*s - 7*r + 8*s**2 - 8*s + 2) - 252*r*s - 312*r - 90*s**2 + 111*s + 144) + 6*Pkdd2*k2*(-7*K*(1 - 2*s)**2 + s**2*(10*C - 5))))) - 14*gd2*(k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) - k1**2*k2**2*(Pk2*(4*r**2 + r*(63*s + 16) + 80*s**2 - 55*s - 20) + k2*(Pkd2*(-15*r*s - 2*r - 31*s**2 + 21*s + 2) + 3*Pkdd2*k2*s**2)) + 6*k2**4*(-2*Pk2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + k2*(Pkd2*(4*r*s + 2*r + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2)))) - 14*fd*(-12*Pkd2*b2*k2**5*s*(r + s) + g2*(k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) - k1**2*k2**2*(Pk2*(4*r**2 + 63*r*s - 60*r + 80*s**2 - 112*s + 56) + k2*(Pkd2*(-15*r*s + 16*r - 31*s**2 + 32*s - 16) + 3*Pkdd2*k2*s**2)) + 6*k2**4*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2)))) + Dd*f*(84*Pkd2*b2*k2**5*(r*(8*s - 1) + 4*s*(2*s - 1)) + 2*f**2*(k1**4*(4*Pk2*(r*(48*s - 59) + 144*s**2 - 90*s + 37) + k2*(Pkd2*(-48*r*s + 59*r - 288*s**2 + 66*s - 22) + Pkdd2*k2*(48*s**2 + 8*s - 5))) + 3*k1**2*k2**2*(Pk2*(312*r**2 - 6*r*(132*s + 47) - 752*s**2 + 628*s + 52) + k2*(Pkd2*(348*r*s - 24*r + 124*s**2 - 145*s - 3) + 3*Pkdd2*k2*(16*s**2 - 16*s + 3))) + 3*k2**4*(Pk2*(192*r**2 + 190*r*s - 223*r - 165*s + 81) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) + f*(-k1**4*(8*Pk2*(-48*C*s**2 + 12*C*s + K*(88*s**2 - 122*s + 25) - 4*r*s + 26*r - 44*s**2 + 177*s - 54) + k2*(Pkd2*(240*C*s**2 - 60*C*s + K*(-260*s**2 + 349*s - 71) + 8*r*s - 52*r + 28*s**2 - 423*s + 129) + Pkdd2*k2*(4*s - 1)*(-12*C*s + 7*K*(s - 1) + 5*s + 7))) + k1**2*k2**2*(2*Pk2*(2*C*(88*r**2 + r*(314*s - 258) - 336*s**2 - 245*s + 150) + K*(-192*r**2 + 722*r*s + 380*r - 2064*s**2 + 2715*s - 782) + 272*r**2 - 2234*r*s + 1210*r + 160*s**2 + 849*s - 616) + k2*(Pkd2*(C*(r*(308 - 776*s) + 248*s**2 + 846*s - 284) + K*(-916*r*s - 80*r + 1644*s**2 - 2201*s + 602) + 2444*r*s - 1279*r + 456*s**2 - 1426*s + 662) + Pkdd2*k2*(4*s - 1)*(K*(66 - 111*s) + s*(46*C + 32) - 42))) + k2**4*(-4*Pk2*(4*C*(26*r**2 + r*(294*s - 61) - 175*s + 31) + 7*K*(48*r**2 - 2*r*(48*s + 5) - 72*s**2 + 42*s - 1) - 650*r**2 - 714*r*s + 636*r + 455*s - 180) + k2*(Pkd2*(2*C*(32*r*(35*s + 1) + 180*s**2 - 429*s - 60) - 84*K*(30*r*s - 9*r + 16*s**2 - 17*s + 4) - 504*r*s - 291*r - 180*s**2 + 219*s + 165) + 3*Pkdd2*k2*(4*s - 1)*(K*(14 - 28*s) + s*(10*C - 5))))) + 14*g2*(-k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(8*r**2 + 2*r*(63*s + 2) + 160*s**2 - 151*s + 8) + k2*(Pkd2*(-60*r*s + 2*r - 124*s**2 + 105*s - 12) + 3*Pkdd2*k2*s*(4*s - 1))) - 6*k2**4*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) + f*(D1*(-2*f**2*fd*k1**4*(k1**2*(4*Pk2*(5*r*(36*s - 41) + 2376*s**2 - 1770*s + 374) + 3*k2*(Pkd2*(-70*r*s + 75*r - 1152*s**2 + 865*s - 173) + 15*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 9*k2**2*(Pk2*(432*r**2 + 9*r*(10*s - 51) - 120*s**2 - 125*s + 149) + Pkd2*k2*(54*r*(5*s - 2) + 120*s**2 - 205*s + 64))) + f*(fd*(Pk2*k2**6*(24*C - 12)*(9*r**2 + 18*r - 7) - 6*k1**6*(4*Pk2*(2*C*(45*s**2 - 54*s + 13) - 9*r*(s - 1) - 99*s**2 + 129*s - 34) + k2*(Pkd2*(C*(-117*s**2 + 144*s - 35) + 9*r*(s - 1) + 126*s**2 - 165*s + 43) + Pkdd2*k2*(3*C - 3)*(3*s**2 - 4*s + 1))) - k1**4*k2**2*(2*Pk2*(C*(288*r**2 + 3*r*(81*s - 310) + 5616*s**2 - 6381*s + 1754) - 774*r**2 + 3*r*(729*s - 89) - 1944*s**2 + 2511*s - 689) + 3*k2*(Pkd2*(2*C*(63*r*s + 102*r - 882*s**2 + 957*s - 262) - 864*r*s + 270*r + 711*s**2 - 666*s + 149) + Pkdd2*k2*(3*s - 1)*(C*(84*s - 52) - 69*s + 44))) - 6*k1**2*k2**4*(2*C*Pk2*(792*r**2 - 3*r*(753*s + 146) - 396*s**2 + 1407*s - 116) - 3*Pk2*(459*r**2 - 3*r*(227*s + 100) - 132*s**2 + 403*s + 5) + 2*Pkd2*k2*(C*(3*r*(186*s - 61) + 180*s**2 - 282*s + 73) + r*(132 - 369*s) - 90*s**2 + 162*s - 47) + Pkdd2*k2**2*(18*C - 9)*(6*s**2 - 5*s + 1))) + 6*k1**2*(6*bd2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 14*bd2*k2**4*(Pk2*(3*r**2 - r*(15*s + 1) - 2*(1 - 3*s)**2) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + gd2*k1**4*s*(8*Pk2*(22*s - 25) + k2*(Pkd2*(71 - 65*s) + 7*Pkdd2*k2*(s - 1))) + gd2*k1**2*k2**2*(Pk2*(96*r**2 - r*(361*s + 382) + 1032*s**2 - 1207*s + 286) + k2*(Pkd2*(229*r*s + 74*r - 411*s**2 + 441*s - 74) + 3*Pkdd2*k2*s*(37*s - 22))) + 14*gd2*k2**4*(Pk2*(24*r**2 - 16*r*(3*s + 2) - 36*s**2 + 6*s + 8) + 3*k2*(Pkd2*(15*r*s - 2*r + 8*s**2 - 9*s + 2) + Pkdd2*k2*s*(2*s - 1))))) + 6*fd*k1**2*(-2*b2*k2**2*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) + 7*k2**2*(Pk2*(6*r**2 + r*(16 - 30*s) - 9*(1 - 2*s)**2) + 6*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))) + g2*(k1**4*(2*s - 1)*(8*Pk2*(22*s - 25) + k2*(Pkd2*(71 - 65*s) + 7*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(96*r**2 - 361*r*s + 2*r + 1032*s**2 - 1508*s + 496) + k2*(Pkd2*(458*r*s - 68*r - 822*s**2 + 1319*s - 454) + 3*Pkdd2*k2*(74*s**2 - 81*s + 22))) + 14*k2**4*(2*Pk2*(24*r**2 + r*(22 - 48*s) - 9*(1 - 2*s)**2) + 3*k2*(2*Pkd2*r*(15*s - 7) + 4*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))))) - Dd*f*(2*f**2*k1**4*(k1**2*(4*Pk2*(5*r*(36*s - 41) + 2376*s**2 - 1770*s + 374) + 3*k2*(Pkd2*(-70*r*s + 75*r - 1152*s**2 + 865*s - 173) + 15*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 9*k2**2*(Pk2*(432*r**2 + 9*r*(10*s - 51) - 120*s**2 - 125*s + 149) + Pkd2*k2*(54*r*(5*s - 2) + 120*s**2 - 205*s + 64))) + f*(Pk2*k2**6*(24 - 48*C)*(6*r**2 + 11*r - 7) + 6*k1**6*(4*Pk2*(2*C*(60*s**2 - 67*s + 13) - 12*r*s + 14*r - 132*s**2 + 167*s - 39) + k2*(C*Pkd2*(-156*s**2 + 179*s - 35) + 2*Pkd2*(r*(6*s - 7) + 84*s**2 - 106*s + 24) + Pkdd2*k2*(3*C - 3)*(4*s**2 - 5*s + 1))) + k1**4*k2**2*(4*Pk2*(C*(192*r**2 + 162*r*s - 802*r + 3744*s**2 - 4269*s + 1166) - 516*r**2 + 1458*r*s + 109*r - 1296*s**2 + 1725*s - 458) + 3*k2*(Pkd2*(8*C*(21*r*(s + 2) - 294*s**2 + 307*s - 82) - (4*s - 1)*(288*r - 237*s + 131)) + Pkdd2*k2*(4*s - 1)*(C*(84*s - 52) - 69*s + 44))) + 6*k1**2*k2**4*(4*C*Pk2*(528*r**2 - r*(1506*s + 463) - 264*s**2 + 1001*s + 54) + 6*Pk2*(-306*r**2 + r*(454*s + 277) + 88*s**2 - 285*s - 53) + k2*(Pkd2*(2*C*(744*r*s - 209*r + 240*s**2 - 410*s + 99) - 984*r*s + 311*r - 240*s**2 + 494*s - 141) + Pkdd2*k2*(18*C - 9)*(8*s**2 - 6*s + 1)))) - 6*k1**2*(-2*b2*k2**2*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) + 7*k2**2*(Pk2*(12*r**2 + r*(14 - 60*s) - 72*s**2 + 60*s - 13) + 6*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + g2*(k1**4*(4*s - 1)*(8*Pk2*(22*s - 25) + k2*(Pkd2*(71 - 65*s) + 7*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(192*r**2 - 38*r*(19*s + 10) + 2064*s**2 - 2715*s + 782) + k2*(Pkd2*(916*r*s + 80*r - 1644*s**2 + 2201*s - 602) + 3*Pkdd2*k2*(148*s**2 - 125*s + 22))) + 14*k2**4*(2*Pk2*(48*r**2 - 2*r*(48*s + 5) - 72*s**2 + 42*s - 1) + 3*k2*(2*Pkd2*(30*r*s - 9*r + 16*s**2 - 17*s + 4) + Pkdd2*k2*(8*s**2 - 6*s + 1))))))))/(315*d**2*k1**2*k2**2*k3**4) + D1**3*Pk3*ct**2*(-3*D1*bd1*f*(3*f**2*k1**4*(k1**2*(Pk2*(5*r*(25*s - 4) - 48*s**2 + 20) + k2*(-5*Pkd2*r*(s - 2) + 2*Pkd2*(52*s**2 - 34*s - 5) - 20*Pkdd2*k2*s*(s - 1))) - 3*k2**2*(Pk2*(40*r**2 - 4*r*(54*s + 13) - 160*s**2 + 123*s + 40) + 3*Pkd2*k2*(14*r - 16*s**2 + 25*s - 14))) + f*(Pk2*k2**6*r*(8*C - 4)*(r + 3) - 2*k1**6*(2*Pk2*(-96*C*s**2 + 96*C*s - 9*K*s**2 + 43*K*s + 3*b1*(9*s - 4)*(4*r + 4*s - 3) + 12*r*(2*s - 5) + 129*s**2 - 245*s + 48) - k2*(Pkd2*(3*b1*(4*r*(9*s - 4) + 28*s**2 - 39*s + 12) + r*(90*s - 66) - (2*s - 2)*(s*(48*C + 35*K - 128) + 27)) + 12*Pkdd2*b1*k2*s*(2*s - 1))) + k1**4*k2**2*(7*Pk2*b1*(384*r**2 + r*(374*s - 436) - 64*s**2 - 131*s + 92) - 4*Pk2*(C*(360*r**2 + r*(1187*s - 486) - 282*s**2 - 740*s + 284) + 7*K*(23*r**2 + 85*r*s - 29*r + 44*s**2 - 26*s + 6) - 925*r**2 - 1785*r*s + 1212*r - 213*s**2 + 1019*s - 550) + Pkd2*k2*(-2*C*(906*r*s - 348*r + 608*s**2 - 824*s + 216) - 14*K*(62*r*s - 44*r + 101*s**2 - 119*s + 44) + 21*b1*(2*r*(37*s - 7) + 52*s**2 - 59*s + 10) + 1880*r*s - 758*r + 1558*s**2 - 1874*s + 470) + 6*Pkdd2*k2**2*s*(21*b1*(2*s - 1) - (s - 1)*(36*C + 7*K - 25))) + k1**2*k2**4*(21*Pk2*b1*(40*r**2 + r*(34*s - 46) - 27*s + 18) - 2*Pk2*(2*C*(518*r**2 - r*(193*s + 44) + 112*s**2 - 146*s - 172) + 7*K*(58*r**2 + 171*r*s - 88*r + 108*s**2 - 99*s + 30) - 894*r**2 - 137*r*s + 376*r - 112*s**2 + 288*s + 30) + Pkd2*k2*(-4*C*(r*(233*s - 120) + 119*s**2 - 179*s + 60) - 14*K*(5*r*(3*s - 2) + 24*s**2 - 27*s + 10) + 210*b1*r*s - 105*b1*s + 606*r*s - 282*r + 238*s**2 - 358*s + 120) + Pkdd2*k2**2*s*(42 - 84*C)*(s - 1))) - 14*k1**2*(b1**2*k2**3*(10*Pk2*k2*(r - 1)*(3*r + 3*s - 2) + Pkd2*k1**2*(r*(33*s - 8) + 33*s**2 - 38*s + 8)) + b1*(4*k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(K*(2 - 4*s) + 8*s - 5)) + k1**2*k2**2*(-Pk2*(8*C*(20*r**2 + r*(28*s - 27) + 8*s**2 - 18*s + 7) + K*(-108*r**2 + 90*r*s + 86*r + 124*s**2 - 143*s + 8) + 136*r**2 - 2*r*s - 36*r - 64*s**2 + 129*s - 60) + k2*(Pkd2*(4*C*(11*r*(4*s - 1) - 16*s**2 - 14*s + 11) + K*(154*r*s - 6*r + 112*s**2 - 67*s - 20) - 230*r*s + 30*r - 68*s**2 + 107*s - 8) + Pkdd2*k2*s*(12*K - 5)*(2*s - 1))) + k2**4*(Pk2*(-16*C*(16*r**2 - r*(20*s + 11) + 4*s**2 + 8*s - 5) + 5*K*(4*r**2 + 14*r*s + 6*r + 8*s**2 - 3*s - 8) + 152*r**2 - 116*r*s - 158*r + 32*s**2 + 42*s - 14) + k2*(5*K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(4*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) + 10*K*(5*r*s - r + 5*s**2 - s - 1) - 44*r*s + 11*r + 16*s**2 + 9*s - 6)))) + 2*b2*k2**3*(10*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*(r*(7*s - 6) + s*(7*s - 7)) + 5*Pkd2*k2**2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*(8*k1**4*s*(2*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(Pk2*(-54*r**2 + 5*r*(9*s + 8) + s*(62*s - 62)) + k2*(Pkd2*r*(26 - 77*s) - 56*Pkd2*s*(s - 1) - 12*Pkdd2*k2*s*(s - 1))) - 5*k2**4*(Pk2*(2*r**2 + 7*r*s + s*(4*s - 4)) + Pkd2*k2*(r*(5*s - 4) + s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))))) + 42*b1**3*k1**2*k2**3*(D1*fd*(10*Pk2*k2*(r - 1) + 11*Pkd2*k1**2*s)*(r + s - 1) + Dd*f*(10*Pk2*k2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*(r*(44*s - 8) + 44*s**2 - 49*s + 8))) + 3*b1**2*k1**2*(D1*fd*(2*k1**4*s*(54*Pk2*f*(4*r + 4*s - 3) - 3*f*k2*(Pkd2*(36*r + 28*s - 27) + 8*Pkdd2*k2*s) + (112*Pk2 - 56*Pkd2*k2)*(r - s*(K - 2))) - 7*k1**2*k2**2*(Pk2*(32*C*(5*r**2 + r*(7*s - 10) + 2*s**2 - 7*s + 5) - 2*K*(54*r**2 + r*(116 - 45*s) - 62*s**2 + 192*s - 96) + f*(384*r**2 + r*(374*s - 452) - 64*s**2 - 195*s + 156) + 136*r**2 - 2*r*(s - 248) - 64*s**2 + 496*s - 296) + k2*(Pkd2*(-176*C*r*s + 64*C*s**2 + 176*C*s - 2*K*(r*(77*s + 20) + 56*s**2 + 40*s - 20) + 3*f*(r*(74*s + 20) + 52*s**2 - 13*s - 20) + 230*r*s + 20*r + 68*s**2 - 32*s - 20) + Pkdd2*k2*s**2*(-24*K + 36*f + 10))) + 7*k2**4*(-64*C*Pk2*(4*r**2 - r*(5*s + 8) + s**2 + 5*s + 4) + 10*K*k2*(Pkd2*(r*(5*s + 4) + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2) - 3*Pk2*f*(40*r**2 + r*(34*s - 36) - 27*s + 8) + 2*Pk2*(5*K*(2*r**2 + 7*r*s + 12*r + 4*s**2 + 8*s - 4) + 76*r**2 - 2*r*(29*s + 106) + 16*s**2 + 48*s + 96) + Pkd2*k2*s*(16*C*(3*r - 2*s - 3) + f*(15 - 30*r) - 44*r + 16*s + 24))) + 2*Dd*f*(f*(6*k1**4*(2*Pk2*(9*s - 2)*(4*r + 4*s - 3) + k2*(Pkd2*(-36*r*s + 8*r - 28*s**2 + 33*s - 6) + 2*Pkdd2*k2*s*(1 - 4*s))) - 7*k1**2*k2**2*(Pk2*(384*r**2 + r*(374*s - 444) - 64*s**2 - 163*s + 124) + 3*k2*(Pkd2*(74*r*s + 3*r + 52*s**2 - 36*s - 5) + 3*Pkdd2*k2*s*(4*s - 1))) - 21*k2**4*(Pk2*(40*r**2 + 34*r*s - 41*r - 27*s + 13) + 5*Pkd2*k2*s*(2*r - 1))) + 28*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 2*s*(-4*K*s + K + 8*s - 3)) + 7*k1**2*k2**2*(-2*Pk2*(4*C*(40*r**2 + r*(56*s - 67) + 16*s**2 - 46*s + 27) + K*(-108*r**2 + 90*r*s + 8*r + 124*s**2 - 208*s + 56) + 136*r**2 - 2*r*s + 114*r - 64*s**2 + 237*s - 146) + k2*(2*Pkd2*(2*C*(11*r*(8*s - 1) - 32*s**2 - 58*s + 11) + K*(154*r*s + 17*r + 112*s**2 - 19*s - 30) - 230*r*s + 5*r - 68*s**2 + 98*s + 6) + Pkdd2*k2*s*(12*K - 5)*(4*s - 1))) + 7*k2**4*(-16*C*Pk2*(32*r**2 - r*(40*s + 43) + 8*s**2 + 28*s + 11) + 10*K*Pk2*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) + 5*K*Pkdd2*k2**2*s*(4*s - 1) + 4*Pk2*(76*r**2 - 2*r*(29*s + 69) + 16*s**2 + 37*s + 47) + Pkd2*k2*(4*C*(3*r*(8*s - 1) - 16*s**2 - 14*s + 3) + 5*K*(20*r*s + 4*r + 20*s**2 + 9*s - 8) - 88*r*s + 11*r + 32*s**2 + 38*s - 6)))) - 3*b1*(D1*(3*f**2*fd*k1**4*(k1**2*(Pk2*(15*r*(25*s + 8) - 144*s**2 - 290*s - 48) - k2*(Pkd2*(15*r*(s + 8) - 312*s**2 + 14*s - 62) + 10*Pkdd2*k2*(6*s**2 + 4*s - 1))) - 3*k2**2*(Pk2*(120*r**2 - 648*r*s + 44*r - 480*s**2 + 597*s - 108) + 3*Pkd2*k2*(42*r - 48*s**2 + 39*s - 26))) + 2*f*(fd*(Pk2*k2**6*(4*C - 2)*(2*r**2 + 5*r - 3) + 2*k1**6*(Pk2*(192*C*s**2 + K*(18*s**2 - 95*s + 43) - 6*r*(8*s - 3) - 258*s**2 + 151*s - 59) + Pkd2*k2*(-35*K*(2*s**2 - 3*s + 1) + 6*r*(15*s - 7) - 8*s**2*(12*C - 32) - 192*s + 56)) - k1**4*k2**2*(2*Pk2*(C*(720*r**2 + 2*r*(1187*s - 515) - 564*s**2 - 1457*s + 532) + 7*K*(46*r**2 + 170*r*s - 87*r + 88*s**2 - 76*s + 16) - 1850*r**2 - 3570*r*s + 2233*r - 426*s**2 + 2026*s - 639) + k2*(Pkd2*(2*C*(6*r*(151*s + 28) + 608*s**2 - 159*s - 168) + 7*K*(4*r*(31*s - 25) + 202*s**2 - 239*s + 69) - 1880*r*s - 49*r - 1558*s**2 + 863*s + 98) + 3*Pkdd2*k2*(7*K*(2*s**2 - 3*s + 1) + s**2*(72*C - 50)))) - k1**2*k2**4*(Pk2*(C*(2072*r**2 - 4*r*(193*s + 622) + 448*s**2 + 638*s + 796) + 14*K*(58*r**2 + 3*r*(57*s - 31) + 27*(1 - 2*s)**2) - 1788*r**2 - 274*r*s + 1898*r - 224*s**2 + 39*s - 516) + 2*k2*(Pkd2*(C*(2*r*(233*s + 63) + 238*s**2 + 19*s - 126) + 7*K*(5*r*(3*s - 2) + 6*(1 - 2*s)**2) - 303*r*s - 63*r - 119*s**2 + 15*s + 63) + Pkdd2*k2*s**2*(42*C - 21)))) + 14*k1**2*(-bd2*k2**3*(10*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*s*(7*r + 7*s - 1) + 5*Pkd2*k2**2*s*(2*r + 2*s - 1)) + gd2*(8*k1**4*s**2*(-2*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(54*r**2 - r*(45*s + 46) - 62*s**2 + 81*s - 8) + k2*(Pkd2*(77*r*s + 20*r + 56*s**2 - 11*s - 20) + 12*Pkdd2*k2*s**2)) + 5*k2**4*(Pk2*(2*r**2 + r*(7*s + 6) + 4*s**2 + s - 8) + k2*(Pkd2*(5*r*s + 2*r + 5*s**2 + 3*s - 2) + Pkdd2*k2*s**2))))) + 28*fd*k1**2*(-b2*k2**3*(r + s)*(10*Pk2*k2*(r + s) + 7*Pkd2*k1**2*s + 10*Pkd2*k2**2*s) + g2*(8*k1**4*s**2*(-2*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(54*r**2 + r*(116 - 45*s) - 62*s**2 + 192*s - 96) + k2*(Pkd2*(77*r*s + 20*r + 56*s**2 + 40*s - 20) + 12*Pkdd2*k2*s**2)) + 5*k2**4*(Pk2*(2*r**2 + 7*r*s + 12*r + 4*s**2 + 8*s - 4) + k2*(Pkd2*(5*r*s + 4*r + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))))) + 2*Dd*f*(3*f**2*k1**4*(k1**2*(Pk2*(50*r*(5*s + 1) - 96*s**2 - 145*s - 14) - k2*(Pkd2*(10*r*s + 55*r - 208*s**2 + 41*s - 26) + 5*Pkdd2*k2*(8*s**2 + 2*s - 1))) - 6*k2**2*(Pk2*(40*r**2 - 216*r*s - 2*r - 160*s**2 + 180*s - 17) + 6*Pkd2*k2*(7*r - 8*s**2 + 8*s - 5))) + f*(Pk2*k2**6*(8*C - 4)*(2*r**2 + 5*r - 3) + 2*k1**6*(Pk2*(384*C*s**2 - 96*C*s + K*(36*s**2 - 181*s + 43) + r*(114 - 96*s) - 516*s**2 + 521*s - 143) + Pkd2*k2*(-35*K*(4*s**2 - 5*s + 1) + 12*r*(15*s - 8) - 2*s**2*(96*C - 256) + 2*s*(24*C - 221) + 104)) - k1**4*k2**2*(2*Pk2*(2*C*(720*r**2 + r*(2374*s - 1037) - 564*s**2 - 1720*s + 507) + 7*K*(92*r**2 + 5*r*(68*s - 29) + 176*s**2 - 128*s + 28) - 3700*r**2 - 7140*r*s + 4846*r - 852*s**2 + 4451*s - 1665) + k2*(Pkd2*(4*C*(r*(906*s + 39) + 608*s**2 - 395*s - 72) + 7*K*(4*r*(62*s - 47) + 404*s**2 - 477*s + 157) - 3760*r*s + 295*r - 3116*s**2 + 2477*s - 102) + 3*Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(36*C - 25)))) - k1**2*k2**4*(2*Pk2*(C*(2072*r**2 - 2*r*(386*s + 1055) + 448*s**2 + 302*s + 530) + 7*K*(116*r**2 + 342*r*s - 181*r + 216*s**2 - 207*s + 57) - 1788*r**2 - 274*r*s + 1795*r - 224*s**2 + 207*s - 454) + k2*(Pkd2*(2*C*(r*(932*s + 48) + 476*s**2 - 249*s - 108) + 14*K*(30*r*s - 20*r + 48*s**2 - 51*s + 16) - 1212*r*s - 27*r - 476*s**2 + 347*s + 108) + Pkdd2*k2*s*(42*C - 21)*(4*s - 1)))) + 14*k1**2*(b2*k2**3*(-10*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pkd2*k1**2*(r*(6 - 28*s) + s*(9 - 28*s)) - 5*Pkd2*k2**2*(r*(8*s - 1) + 4*s*(2*s - 1))) + g2*(-8*k1**4*s*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(2*Pk2*(54*r**2 - r*(45*s + 4) - 62*s**2 + 104*s - 28) + k2*(Pkd2*(154*r*s + 17*r + 112*s**2 - 19*s - 30) + 6*Pkdd2*k2*s*(4*s - 1))) + 5*k2**4*(2*Pk2*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) + k2*(Pkd2*(20*r*s + 4*r + 20*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1))))))) + 2*f*k1**2*(D1*(5*f**2*fd*k1**4*(Pk2*(5*r*(6*s + 41) - 1008*s**2 + 687*s - 215) + 9*Pkd2*k2*(10*r*(3*s - 2) + 64*s**2 - 63*s + 18)) - f*(-42*bd2*k2**2*(4*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(6*r**2 + 13*r*s - 8*r + 7*s**2 - 3*s + 2) + 3*Pkd2*k2*(5*s - 3)*(r + s - 1))) + fd*(2*k1**4*(2*Pk2*(C*(45*s**2 - 336*s + 107) + 90*r*s + 60*r + 45*s**2 + 345*s - 150) - 9*Pkd2*k2*(s - 1)*(16*C*(3*s - 1) - 15*r - 63*s + 26)) + k1**2*k2**2*(-2*Pk2*(6*C*(411*r**2 + 1389*r*s - 704*r + 594*s**2 - 856*s + 254) - 2799*r**2 - 8685*r*s + 4464*r - 3726*s**2 + 4992*s - 1462) - 9*k2*(2*Pkd2*(C*(318*r*s - 248*r + 483*s**2 - 574*s + 185) - 201*r*s + 161*r - 318*s**2 + 375*s - 121) + Pkdd2*k2*(10*C - 5)*(3*s**2 - 4*s + 1))) + k2**4*(Pk2*(-2*C*(3420*r**2 + 8019*r*s - 5106*r + 4212*s**2 - 5913*s + 1934) + 4068*r**2 + 8991*r*s - 5646*r + 4212*s**2 - 5913*s + 1934) + Pkd2*k2*(9 - 18*C)*(33*r*(3*s - 2) + 108*s**2 - 123*s + 40))) + 6*gd2*(2*k1**4*s*(Pk2*(43 - 9*s) + 35*Pkd2*k2*(s - 1)) + 7*k1**2*k2**2*(2*Pk2*(23*r**2 + r*(85*s - 29) + 44*s**2 - 26*s + 6) + k2*(Pkd2*(62*r*s - 44*r + 101*s**2 - 119*s + 44) + 3*Pkdd2*k2*s*(s - 1))) + 7*k2**4*(Pk2*(58*r**2 + r*(171*s - 88) + 108*s**2 - 99*s + 30) + Pkd2*k2*(5*r*(3*s - 2) + 24*s**2 - 27*s + 10)))) + 6*fd*(7*b2*k2**2*(2*Pk2*k1**2*(12*r**2 + 2*r*(13*s - 7) + 7*s*(2*s - 1)) + 4*Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 3*Pkd2*k1**2*k2*(r*(10*s - 7) + 10*s**2 - 13*s + 4)) + g2*(2*k1**4*(2*s - 1)*(Pk2*(9*s - 43) - 35*Pkd2*k2*(s - 1)) - 7*k1**2*k2**2*(2*Pk2*(46*r**2 + r*(170*s - 87) + 88*s**2 - 76*s + 16) + k2*(Pkd2*(4*r*(31*s - 25) + 202*s**2 - 239*s + 69) + 3*Pkdd2*k2*(2*s**2 - 3*s + 1))) - 14*k2**4*(Pk2*(58*r**2 + 3*r*(57*s - 31) + 27*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 6*(1 - 2*s)**2))))) + Dd*f*(42*b2*k2**2*(4*Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(24*r**2 + 52*r*s - 30*r + 28*s**2 - 13*s + 4) + 3*Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10))) + 5*f**2*k1**4*(Pk2*(5*r*(6*s + 41) - 1008*s**2 + 687*s - 215) + 9*Pkd2*k2*(10*r*(3*s - 2) + 64*s**2 - 63*s + 18)) - f*(2*k1**4*(2*Pk2*(C*(60*s**2 - 443*s + 107) + 20*r*(6*s + 5) + 60*s**2 + 485*s - 190) - 9*Pkd2*k2*(s - 1)*(16*C*(4*s - 1) - 20*r - 84*s + 31)) + k1**2*k2**2*(-2*Pk2*(2*C*(1644*r**2 + 5556*r*s - 2695*r + 2376*s**2 - 3362*s + 934) - 3732*r**2 - 11580*r*s + 5748*r - 4968*s**2 + 6520*s - 1813) - 9*k2*(Pkd2*(2*C*(424*r*s - 324*r + 644*s**2 - 769*s + 261) - 536*r*s + 421*r - 848*s**2 + 1002*s - 341) + Pkdd2*k2*(10*C - 5)*(4*s**2 - 5*s + 1))) - 2*k2**4*(Pk2*(2*C*(2280*r**2 + 5346*r*s - 3469*r + 2808*s**2 - 3969*s + 1313) - 2712*r**2 - 5994*r*s + 3847*r - 2808*s**2 + 3969*s - 1313) + Pkd2*k2*(18*C - 9)*(22*r*(3*s - 2) + 72*s**2 - 87*s + 31))) + 6*g2*(2*k1**4*(4*s - 1)*(Pk2*(9*s - 43) - 35*Pkd2*k2*(s - 1)) - 7*k1**2*k2**2*(2*Pk2*(92*r**2 + 5*r*(68*s - 29) + 176*s**2 - 128*s + 28) + k2*(Pkd2*(4*r*(62*s - 47) + 404*s**2 - 477*s + 157) + 3*Pkdd2*k2*(4*s**2 - 5*s + 1))) - 14*k2**4*(Pk2*(116*r**2 + 342*r*s - 181*r + 216*s**2 - 207*s + 57) + Pkd2*k2*(30*r*s - 20*r + 48*s**2 - 51*s + 16))))))/(315*d**2*k1**2*k2**2*k3**4) - 4*D1**3*Pk3*ct*f*k1*k2*st**6*(D1*(f**2*(22*bd1*k2**2*(Pk2*(33*r**2 - 38*r - 33*s**2 + 14*s + 5) + Pkd2*k2*(r*(33*s - 7) + 33*s**2 - 33*s + 7)) + fd*(44*Pk2*k2**2*(8*r**2 + r*(8*s - 27) - 18*s + 15) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(3616*s - 1025) + 3616*s**2 - 3594*s + 733))) - 11*f*k2**2*(16*C*fd*(Pk2*(3*r - 6*s + 1) + Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) - 6*Pk2*b1*fd*(33*r**2 - 16*r - 33*s**2 + 25*s - 3) + Pkd2*b1*fd*k2*(r*(75 - 198*s) - 198*s**2 + 198*s - 47) + 18*bd1*(2*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 12*fd*(5*Pk2*(r - s) + Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) - 72*gd2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) - 396*fd*k2**2*(2*r + 2*s - 1)*(Pk2*b1*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1) - 8*Pk2*g2*(r - 2*s + 1) + Pkd2*b1*k2*(2*K - 1)*(2*s - 1) + 4*Pkd2*g2*k2*(1 - 2*s))) + Dd*f*(f**2*(44*Pk2*k2**2*(8*r**2 + r*(8*s - 27) - 18*s + 15) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(3616*s - 1025) + 3616*s**2 - 3594*s + 733)) + 11*f*k2**2*(2*Pk2*b1*(132*r**2 - 86*r - 132*s**2 + 89*s - 4) - 4*Pk2*(C*(48*r**2 - 2*r*(24*s + 13) - 96*s**2 + 76*s - 6) - 60*r**2 + 50*r + 60*s**2 - 35*s - 5) + Pkd2*b1*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) - Pkd2*k2*(8*C - 6)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 396*k2**2*(b1*(Pk2*(2*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 24*r**2 - 16*r*s + 18*r + 8*s**2 - 2*s - 1) + Pkd2*k2*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 4*g2*(Pk2*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(693*d**2*k3**6) - D1**3*Pk3*ct*f*k1*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(99*s**2 - 75*s + 14) + 18*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(f*(33*s - 14) + 36*s - 18)) + f*(D1*bd1*s*(f*(33*s - 14) + 36*s - 18) + 2*D1*fd*(1 - 3*s)**2 + 2*Dd*f*(12*s**2 - 7*s + 1)))/(63*d**2*k2*k3**2) - D1**3*Pk3*ct*f*k1*st**6*(D1*(f**2*(-11*bd1*k2**2*(-8*Pk2*(2*r*(33*s - 7) + 33*s**2 - 52*s + 14) + k2*(Pkd2*(4*r*(33*s - 7) - 33*s**2 - 62*s + 28) + Pkdd2*k2*s*(33*s - 14))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(180*s**2 - 101*s + 14) + 44*k2**2*(-2*Pk2*(r*(74*s - 32) - 9*s + 9) + Pkd2*k2*(r*(52*s - 21) - 12*s + 7)))) + 11*f*k2**2*(-144*Pk2*bd1*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + 8*Pk2*fd*(3*b1*(r*(66*s - 25) + 33*s**2 - 41*s + 11) + (2 - 6*s)*(-12*C*s + r*(12*C - 18) + 3*s + 5)) - 288*Pk2*gd2*(-4*r*s + r + 4*s**2 - 1) + 18*bd1*k2*(Pkd2*(K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) - 16*r*s + 4*r + 2*s**2 + 7*s - 4) + Pkdd2*k2*s*(2*K - 1)*(2*s - 1)) - fd*k2*(Pkd2*(3*b1*(2*r*(66*s - 25) - 33*s**2 - 7*s + 8) + (3*s - 1)*(-24*C*(2*r - 5*s + 1) + 72*r - 66*s - 2)) + Pkdd2*k2*(3*s - 1)*(b1*(33*s - 14) + (6 - 8*C)*(3*s - 1))) + 72*gd2*k2*(Pkd2*(-4*r*s + r + 10*s**2 - 3*s - 1) + Pkdd2*k2*s*(1 - 2*s))) + 198*fd*k2**2*(2*s - 1)*(-8*Pk2*b1*(K*(4*r - 4*s + 2) - 8*r - 2*s + 1) + 32*Pk2*g2*(2*r - 2*s + 1) + b1*k2*(Pkd2*(2*K*(4*r - 10*s + 5) - 16*r + 2*s - 1) + Pkdd2*k2*(2*K - 1)*(2*s - 1)) + 4*g2*k2*(Pkd2*(-4*r + 10*s - 5) + Pkdd2*k2*(1 - 2*s)))) + Dd*f*(f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(180*s**2 - 101*s + 14) + 44*k2**2*(-2*Pk2*(r*(74*s - 32) - 9*s + 9) + Pkd2*k2*(r*(52*s - 21) - 12*s + 7))) - 11*f*k2**2*(-8*Pk2*b1*(r*(264*s - 89) + 132*s**2 - 175*s + 47) + 16*Pk2*(2*C*(r*(24*s - 7) - 24*s**2 + 4*s + 1) + r*(21 - 72*s) + 12*s**2 + 23*s - 8) + Pkd2*k2*(8*C*(r*(7 - 24*s) + 60*s**2 - 25*s + 2) + b1*(2*r*(264*s - 89) - 132*s**2 - 83*s + 52) + 288*r*s - 84*r - 264*s**2 + 34*s + 14) + Pkdd2*k2**2*(4*s - 1)*(b1*(33*s - 14) + (6 - 8*C)*(3*s - 1))) + 198*k2**2*(b1*(8*Pk2*(r*(4 - 2*K)*(8*s - 3) + (2*s - 1)*(8*K*s + 4*s - 5)) + k2*(Pkd2*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7) + Pkdd2*k2*(2*K - 1)*(8*s**2 - 6*s + 1))) - 4*g2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))))/(693*d**2*k2*k3**4) - D1**3*Pk3*ct*k1*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*D1*bd1*f**2*s*(2*s - 1) + b1**2*(D1*fd*(f*(26*s**2 - 33*s + 10) + 14*(s - 1)**2) + Dd*f*(4*s - 1)*(f*(13*s - 10) + 14*s - 14)) + 2*b1*f*(D1*bd1*s*(f*(13*s - 10) + 14*s - 14) + D1*fd*(1 - 2*s)**2 + Dd*f*(8*s**2 - 6*s + 1)))/(35*d**2*k2**3) - 4*D1**3*Pk3*ct*st**4*(D1*(-2772*b1*fd*k1**2*k2**4*(-Pk2*b1*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) + Pkd2*b1*k2*s*(2*K - 1)*(r + s) + 4*g2*(Pk2*(r*(s - 2) + (s - 1)**2) - Pkd2*k2*s*(r + s))) + f**3*k1**2*(33*bd1*k2**2*(k1**2*(4*Pk2*(39*r**2 + 66*r*s - 54*r + 27*s**2 - 31*s + 1) + Pkd2*k2*(24*r*s - 9*r + 24*s**2 - 55*s + 37)) - 6*k2**2*(Pk2*(43*r**2 + 28*r*s - 60*r - 15*s**2 - 20*s + 21) + 5*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + fd*(1760*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(2264*s - 753) + 2264*s**2 - 2660*s + 617) + 33*k1**2*k2**2*(4*Pk2*(132*r**2 - 22*r*(24*s + 1) - 660*s**2 + 537*s - 49) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35)))) + 33*f**2*k2**2*(-3*bd1*(2*k1**4*(2*Pk2*(r**2*(5*K - 10) + r*(-5*K - 15*s + 19) - s**2*(5*K + 5) + s*(20*K + 3) - 9) + Pkd2*k2*(2*K - 1)*(r*(5*s - 3) + 5*s**2 - 12*s + 3)) + k1**2*k2**2*(-14*Pk2*b1*(r + s - 1) + 4*Pk2*(C*(-8*s**2 + s*(6 - 8*r) + 2) + K*(9*r**2 + 62*r*s - 21*r + 53*s**2 - 40*s + 12) + 29*r**2 + 30*r*s - 39*r + s**2 - 25*s + 8) + Pkd2*k2*(8*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*K*(24*r*s + r + 24*s**2 - 10*s - 1) + b1*(r*(13 - 52*s) - 52*s**2 + 45*s - 3) + 32*r*s - 2*r + 32*s**2 - 26*s + 8))) + fd*(Pk2*k2**4*(8*C - 4)*(36*r**2 - 3*r*(18*s + 11) + 42*s - 1) + 3*k1**4*(4*Pk2*(C*(-18*r**2 + 48*r*s + 6*r + 30*s**2 - 50*s + 8) + 3*b1*(13*r**2 + 11*r*(2*s - 1) + 9*s**2 - 6*s + 2) + 24*r**2 - 9*r*s - 21*r - 15*s**2 + 18*s + 1) + Pkd2*k2*(-4*C*(36*r*s - 11*r + 18*s**2 - 34*s + 9) + b1*(3*r*(8*s - 23) + 24*s**2 - 99*s + 47) + 90*r*s - 28*r + 54*s**2 - 86*s + 22)) + k1**2*k2**2*(-2*Pk2*(4*C*(135*r**2 + 72*r*(11*s - 3) + 171*s**2 - 495*s + 115) + 3*b1*(129*r**2 + 4*r*(21*s - 32) - 45*s**2 - 33*s + 33) - 252*r**2 - 1620*r*s + 423*r - 396*s**2 + 1056*s - 241) - 3*Pkd2*k2*(4*C*(42*r*s - 15*r + 24*s**2 - 40*s + 11) + 5*b1*(r*(30*s - 11) + 30*s**2 - 30*s + 7) + (3*s - 1)*(-20*r - 8*s + 16)))) + 12*k1**2*(-Pk2*bd2*k2**2*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) + gd2*(10*Pk2*k1**2*(r**2 - r - s*(s - 4)) + 2*Pk2*k2**2*(9*r**2 + r*(62*s - 21) + 53*s**2 - 40*s + 12) + 2*Pkd2*k1**2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) - Pkd2*k2**3*(24*r*s + r + 24*s**2 - 10*s - 1)))) + 99*f*k1**2*k2**2*(b1**2*fd*k2**2*(Pk2*(66*r + 66*s - 46) + Pkd2*k2*s*(52*r + 52*s - 19)) - 2*b1*(fd*(k1**2*(2*Pk2*(K*(10*r**2 - 14*r - 10*s**2 + 17*s - 6) - 20*r**2 - 30*r*s + 36*r - 10*s**2 + 17*s - 6) + Pkd2*k2*(2*K - 1)*(2*s - 1)*(5*r + 5*s - 6)) + k2**2*(Pk2*(-8*C*(4*r*(s - 1) + 4*s**2 - 6*s + 3) + 2*K*(18*r**2 + 124*r*s - 76*r + 106*s**2 - 113*s + 30) + 116*r**2 + 120*r*s - 61*r + 4*s**2 - 12*s + 11) + Pkd2*k2*(K*(r*(17 - 48*s) - 48*s**2 + 34*s - 5) + (s*(8*C + 8) - 7)*(4*r + 4*s - 2)))) + 7*k2**2*(-2*Pk2*bd1*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1) + 4*Pk2*gd2*(2*r*(s - 1) + 2*s**2 - 3*s + 2) + Pkd2*bd1*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3)) - 4*Pkd2*gd2*k2*s*(2*r + 2*s - 1))) + 56*bd1*g2*k2**2*(-Pk2 + Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) - 4*fd*(Pk2*b2*k2**2*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + g2*(-2*k1**2*(Pk2*(10*r**2 - 14*r - 10*s**2 + 17*s - 6) + Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6)) + k2**2*(-2*Pk2*(18*r**2 + 124*r*s - 76*r + 106*s**2 - 113*s + 30) + Pkd2*k2*(48*r*s - 17*r + 48*s**2 - 34*s + 5)))))) + Dd*f*(-1386*b1*k1**2*k2**4*(-2*Pk2*b1*(K*(r*(8*s - 9) + 8*s**2 - 12*s + 6) + 8*r**2 + r*(8*s - 1) + 2*s - 3) + 4*Pk2*g2*(r*(8*s - 9) + 8*s**2 - 12*s + 6) + Pkd2*b1*k2*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 4*Pkd2*g2*k2*(-8*r*s + r + s*(4 - 8*s))) + f**3*k1**2*(1760*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(2264*s - 753) + 2264*s**2 - 2660*s + 617) + 33*k1**2*k2**2*(4*Pk2*(132*r**2 - 22*r*(24*s + 1) - 660*s**2 + 537*s - 49) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 33*f**2*k2**2*(Pk2*k2**4*(16*C - 8)*(24*r**2 - 9*r*(4*s + 3) + 32*s + 4) + 2*k1**4*(2*Pk2*(3*C*(-24*r**2 + 4*r*(16*s + 3) + 40*s**2 - 74*s + 8) + b1*(156*r**2 + 3*r*(88*s - 51) + 108*s**2 - 85*s + 19) + 96*r**2 - 36*r*s - 93*r - 60*s**2 + 87*s + 9) + Pkd2*k2*(-3*C*(96*r*s - 26*r + 48*s**2 - 96*s + 22) + b1*(12*r*(4*s - 9) + 48*s**2 - 176*s + 89) + 180*r*s - 51*r + 108*s**2 - 183*s + 42)) + k1**2*k2**2*(-2*Pk2*(4*C*(180*r**2 + 3*r*(352*s - 91) + 228*s**2 - 727*s + 127) + 3*b1*(172*r**2 + 4*r*(28*s - 47) - 60*s**2 - 53*s + 54) - 336*r**2 - 2160*r*s + 521*r - 528*s**2 + 1526*s - 255) - 3*Pkd2*k2*(8*C*(28*r*s - 9*r + 16*s**2 - 28*s + 7) + 5*b1*(r*(40*s - 13) + 40*s**2 - 40*s + 9) - 80*r*s + 24*r - 32*s**2 + 80*s - 20))) + 99*f*k1**2*k2**2*(-4*Pk2*b2*k2**2*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) + b1**2*k2**2*(20*Pk2*(4*r + 4*s - 3) + Pkd2*k2*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3)) - 2*b1*(k1**2*(2*Pk2*(K*(20*r**2 - 24*r - 20*s**2 + 57*s - 6) - 40*r**2 - 60*r*s + 74*r - 20*s**2 + 23*s - 24) + Pkd2*k2*(2*K - 1)*(r*(20*s - 11) + 20*s**2 - 41*s + 12)) + k2**2*(Pk2*(-4*C*(2*r*(8*s - 5) + 16*s**2 - 20*s + 7) + 2*K*(36*r**2 + 248*r*s - 118*r + 212*s**2 - 193*s + 54) + 232*r**2 + 240*r*s - 221*r + 8*s**2 - 116*s + 51) + Pkd2*k2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) - 3*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) + 64*r*s - 36*r + 64*s**2 - 76*s + 25))) - 4*g2*(-2*k1**2*(Pk2*(20*r**2 - 24*r - 20*s**2 + 57*s - 6) + Pkd2*k2*(20*r*s - 11*r + 20*s**2 - 41*s + 12)) + k2**2*(-2*Pk2*(36*r**2 + 248*r*s - 118*r + 212*s**2 - 193*s + 54) + 3*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1))))))/(3465*d**2*k1*k2*k3**6) + 4*D1**3*Pk3*ct*st**2*(3*D1*bd1*f*(f**2*k1**2*(48*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + k1**4*(2*Pk2*(12*r**2 - 18*r*s - 41*r - 30*s**2 + s + 21) + Pkd2*k2*(42*r*s + 31*r + 42*s**2 - 11*s - 23)) + 3*k1**2*k2**2*(4*Pk2*(27*r**2 + 66*r*s - 47*r + 39*s**2 - 58*s + 12) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + f*(4*Pk2*k1**6*(-K*(r*(2*s + 3) + 2*s**2 + 5*s - 3) + r**2 + r*(4*s + 5) + 3*s**2 + 7*s - 6) + Pk2*k2**6*(4 - 8*C)*(15*r**2 - r*(27*s + 8) + 12*s - 12) - k1**4*k2**2*(2*Pk2*(-4*C*(17*r**2 - 64*r*s - 35*r + 3*s**2 + 28*s + 11) + 134*K*r**2 + 236*K*r*s - 74*K*r + 102*K*s**2 + 20*K*s - 60*K + b1*(68*r**2 + r*(136*s - 95) + 68*s**2 - 95*s + 27) - 71*r**2 - 336*r*s + 39*r - 97*s**2 + 139*s + 4) + Pkd2*k2*(-4*C*(r*(58*s - 15) + 30*s**2 - 41*s + 11) + 2*K*(69*r*s - 33*r + 69*s**2 - 90*s + 33) + b1*(3*r*(64*s + 5) + 192*s**2 - 157*s - 25) + 76*r*s + 18*r + 20*s**2 + 10*s - 30)) + k1**2*k2**4*(2*Pk2*(4*C*(16*r**2 + 301*r*s - 138*r + 61*s**2 - 149*s + 116) - 742*K*r**2 - 1456*K*r*s + 1134*K*r - 714*K*s**2 + 1022*K*s - 392*K + 7*b1*(36*r**2 + r*(48*s - 65) + 12*s**2 - 41*s + 29) + 205*r**2 - 240*r*s - 27*r + 3*s**2 + 135*s - 166) + Pkd2*k2*(2*C*(r*(62*s - 24) + 6*s**2 - 32*s + 26) - 42*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 21*b1*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) - 34*r*s + 10*r + 22*s**2 + 4*s - 26))) + 14*k1**2*k2**2*(Pk2*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 4*Pk2*b2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - b1*(2*k1**2*(Pk2*(K*(2*r**2 + 4*r*s + r + 2*s**2 - 9*s + 2) + 2*r**2 + 4*r*s - 6*r + 2*s**2 + 4*s - 1) - Pkd2*k2*(2*K - 1)*(r*(s + 1) + s*(s - 2))) + k2**2*(2*Pk2*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(12*r**2 + 2*r*s + 5*r - 10*s**2 + 11*s - 9) - 33*r**2 - 48*r*s + 24*r - 15*s**2 + 20*s + 2) + Pkd2*k2*(r*(K*(34*s - 11) - 20*s + 5) + s*(K*(34*s - 23) - 20*s + 15)))) + 2*g2*(2*k1**2*(Pk2*(r**2 + 2*r*(s + 2) + s*(s - 1)) - Pkd2*k2*(r*(s + 2) + s*(s - 1))) + k2**2*(2*Pk2*(6*r**2 + r*(s + 2) - s*(5*s - 5)) + Pkd2*k2*(r*(17*s - 11) + s*(17*s - 17)))))) + 42*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(2*Pk2*(14*K*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) + f*(68*r**2 + r*(136*s - 103) + 68*s**2 - 103*s + 45) + 14*r**2 + 28*r*(s + 1) + 14*s**2 + 28*s - 14) + Pkd2*k2*s*(f*(192*r + 192*s - 61) + (14 - 28*K)*(r + s))) - 7*k2**2*(-2*Pk2*(8*C*(r + s - 1)**2 + 12*K*r**2 + 2*K*r*s + 36*K*r - 10*K*s**2 + 36*K*s - 18*K - f*(36*r**2 + 48*r*s - 29*r + 12*s**2 - 17*s + 1) - 33*r**2 - 48*r*s - 8*r - 15*s**2 - 8*s + 4) + Pkd2*k2*s*(3*f*(12*r + 12*s - 5) + (20 - 34*K)*(r + s)))) + Dd*f*(k1**2*(4*Pk2*(7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 21*s + 6) + f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 36) + 28*r**2 + 56*r*s - 28*r + 28*s**2 + 77*s - 21) + Pkd2*k2*(f*(3*r*(128*s + 5) + 384*s**2 - 218*s - 25) + (14 - 28*K)*(r*(4*s + 2) + s*(4*s - 7)))) + 7*k2**2*(2*Pk2*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 48*K*r**2 + 8*K*r*s + 52*K*r - 40*K*s**2 + 70*K*s - 54*K - 2*f*(36*r**2 + 48*r*s - 47*r + 12*s**2 - 29*s + 15) - 132*r**2 - 192*r*s + 69*r - 60*s**2 + 57*s + 12) + Pkd2*k2*(f*(r*(9 - 72*s) - 72*s**2 + 48*s - 3) + 2*r*(68*K*s - 11*K - 40*s + 5) + 2*s*(68*K*s - 29*K - 40*s + 20))))) + 3*b1*(D1*(f**2*fd*k1**2*(48*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + k1**4*(6*Pk2*(12*r**2 - 2*r*(9*s + 10) - 30*s**2 + 5*s + 10) + Pkd2*k2*(18*r*(7*s + 1) + 126*s**2 - 57*s - 16)) + 3*k1**2*k2**2*(4*Pk2*(81*r**2 + 198*r*s - 90*r + 117*s**2 - 111*s + 29) + 3*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) - 2*f*fd*(2*Pk2*k1**6*(K*(r*(4*s + 5) + 4*s**2 + 10*s - 6) - 2*r**2 - 2*r*(4*s + 5) - 6*s**2 - 15*s + 9) + Pk2*k2**6*(4*C - 2)*(30*r**2 - 3*r*(18*s + 17) + 41*s + 18) + k1**4*k2**2*(-Pk2*(4*C*(34*r**2 + r*(11 - 128*s) + 6*s**2 + 109*s - 34) - 2*K*(134*r**2 + 236*r*s - 6*r + 102*s**2 + 73*s - 62) + 142*r**2 + 672*r*s - 198*r + 194*s**2 - 329*s + 71) + Pkd2*k2*(3*K*(23*s - 15)*(2*r + 2*s - 1) + r*s*(76 - 232*C) + 49*r - s**2*(120*C - 20) + s*(130*C + 18) - 28)) - k1**2*k2**4*(Pk2*(4*C*(32*r**2 + r*(602*s + 33) + 122*s**2 - 376*s - 32) - 14*K*(106*r**2 + 208*r*s - 113*r + 102*s**2 - 103*s + 26) + 410*r**2 - 480*r*s - 470*r + 6*s**2 + 523*s + 123) + Pkd2*k2*(-21*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(C*(62*r + 6*s - 45) - 17*r + 11*s + 19)))) + 28*f*k1**2*k2**2*(2*Pk2*bd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(2*k1**2*(Pk2*(r**2 + 2*r*s - 3*r + s**2 - 8*s + 2) - Pkd2*k2*s*(r + s - 3)) + k2**2*(2*Pk2*(6*r**2 + r*(s + 3) - 5*s**2 + 6*s - 9) + Pkd2*k2*s*(17*r + 17*s - 6)))) + 28*fd*k1**2*k2**2*(2*Pk2*b2*k2**2*(r + s)**2 + 2*g2*k1**2*(Pk2*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - Pkd2*k2*s*(r + s)) + g2*k2**2*(2*Pk2*(6*r**2 + r*(s + 18) - 5*s**2 + 18*s - 9) + 17*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(48*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + k1**4*(2*Pk2*(48*r**2 - r*(72*s + 101) - 120*s**2 + 16*s + 51) + Pkd2*k2*(7*r*(24*s + 7) + 168*s**2 - 68*s - 39)) + 6*k1**2*k2**2*(Pk2*(216*r**2 + r*(528*s - 274) + 312*s**2 - 338*s + 82) + 3*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) - 2*f*(2*Pk2*k1**6*(K*(8*r*s + 11*r + 8*s**2 + 20*s - 12) - 4*r**2 - 4*r*(4*s + 5) - 12*s**2 - 29*s + 21) + Pk2*k2**6*(8*C - 4)*(30*r**2 - 2*r*(27*s + 23) + 41*s + 12) + k1**4*k2**2*(Pk2*(-4*C*(68*r**2 - r*(256*s + 47) + 12*s**2 + 219*s - 17) + 2*K*(268*r**2 + 472*r*s - 80*r + 204*s**2 + 93*s - 122) - 284*r**2 - 1344*r*s + 326*r - 388*s**2 + 741*s - 85) + Pkd2*k2*(C*(r*(30 - 464*s) - 240*s**2 + 320*s - 22) + 3*K*(92*r*s - 52*r + 92*s**2 - 113*s + 37) + 152*r*s + 79*r + 40*s**2 + 12*s - 64)) - k1**2*k2**4*(Pk2*(4*C*(64*r**2 + 4*r*(301*s - 26) + 244*s**2 - 787*s + 67) - 14*K*(212*r**2 + 416*r*s - 275*r + 204*s**2 - 249*s + 82) + 820*r**2 - 960*r*s - 816*r + 12*s**2 + 1005*s + 71) + Pkd2*k2*(2*C*(4*r*(31*s - 3) + 12*s**2 - 93*s + 13) - 21*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 68*r*s + 5*r + 44*s**2 + 65*s - 13))) + 28*k1**2*k2**2*(2*Pk2*b2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*k1**2*(Pk2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 21*s + 6) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + k2**2*(Pk2*(48*r**2 + r*(8*s + 52) - 40*s**2 + 70*s - 54) + Pkd2*k2*(r*(68*s - 11) + s*(68*s - 29))))))) + f*(D1*(-3*f**2*fd*k1**4*(24*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(100*r**2 - 40*r*s - 33*r - 140*s**2 + 165*s - 36) + 5*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(fd*(2*Pk2*k1**6*(2*C*(6*r*(3*s + 2) + 18*s**2 + 9*s - 11) - 9*r**2 - 3*r*(18*s + 7) - 45*s**2 - 15*s + 24) + Pk2*k2**6*(36*C - 18)*(3*r - 1)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(4*C*(315*r**2 - 9*r*(4*s + 5) + 189*s**2 + 291*s - 134) - 1269*r**2 - 9*r*(114*s - 77) - 837*s**2 - 54*s + 135) + 3*Pkd2*k2*(2*C*(27*s - 17)*(3*r + 3*s - 2) - 126*r*s + 81*r - 126*s**2 + 168*s - 55)) + 9*k1**2*k2**4*(Pk2*(4*C*(180*r**2 + 243*r*s - 203*r + 123*s**2 - 135*s + 52) - 450*r**2 - 618*r*s + 495*r - 288*s**2 + 320*s - 121) + Pkd2*k2*(24*C - 12)*(2*s - 1)*(3*r + 3*s - 2))) - 6*k1**2*(-Pk2*bd2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(r + s - 1) + gd2*(2*Pk2*k1**4*(r*(2*s + 3) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(2*Pk2*(67*r**2 + 118*r*s - 37*r + 51*s**2 + 10*s - 30) + 3*Pkd2*k2*(23*r*s - 11*r + 23*s**2 - 30*s + 11)) + 7*k2**4*(2*Pk2*(53*r**2 + 104*r*s - 81*r + 51*s**2 - 73*s + 28) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3))))) + 12*fd*k1**2*(-Pk2*b2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(r*(4*s + 5) + 4*s**2 + 10*s - 6) + k1**2*k2**2*(2*Pk2*(134*r**2 + 236*r*s - 6*r + 102*s**2 + 73*s - 62) + 3*Pkd2*k2*(23*s - 15)*(2*r + 2*s - 1)) + 7*k2**4*(Pk2*(212*r**2 + 416*r*s - 226*r + 204*s**2 - 206*s + 52) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-3*f**2*k1**4*(24*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(100*r**2 - 40*r*s - 33*r - 140*s**2 + 165*s - 36) + 5*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(2*Pk2*k1**6*(C*r*(48*s + 34) + 8*C*(6*s**2 + 3*s - 4) - 12*r**2 - r*(72*s + 29) - 60*s**2 - 19*s + 35) + Pk2*k2**6*(72*C - 36)*(2*r - 1)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(4*C*(420*r**2 - 6*r*(8*s + 25) + 252*s**2 + 377*s - 134) - 1692*r**2 - 3*r*(456*s - 394) - 1116*s**2 + 15*s + 69) + 3*Pkd2*k2*(2*C*(108*r*s - 64*r + 108*s**2 - 141*s + 47) - 168*r*s + 103*r - 168*s**2 + 228*s - 77)) + 9*k1**2*k2**4*(Pk2*(4*C*(240*r**2 + 324*r*s - 298*r + 164*s**2 - 195*s + 87) - 600*r**2 - 824*r*s + 725*r - 384*s**2 + 462*s - 201) + Pkd2*k2*(6*C - 3)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 12*k1**2*(-Pk2*b2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + g2*(2*Pk2*k1**4*(8*r*s + 11*r + 8*s**2 + 20*s - 12) + k1**2*k2**2*(2*Pk2*(268*r**2 + 472*r*s - 80*r + 204*s**2 + 93*s - 122) + 3*Pkd2*k2*(92*r*s - 52*r + 92*s**2 - 113*s + 37)) + 7*k2**4*(2*Pk2*(212*r**2 + 416*r*s - 275*r + 204*s**2 - 249*s + 82) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(315*d**2*k1*k2*k3**6) - 4*D1**3*Pk3*ct*(D1*bd1*f*(3*f**2*k1**4*(12*Pk2*k2**2*(8*r**2 + r*(8*s - 9) - 3*s + 1) + k1**2*(2*Pk2*(50*r**2 + 70*r*s - 87*r + 20*s**2 - 57*s + 33) + 5*Pkd2*k2*(6*s + 1)*(r + s - 1))) - f*(Pk2*k2**6*r*(28 - 56*C)*(r + s) + 12*k1**6*(2*Pk2*(-2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 4*b1*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) + Pkd2*b1*k2*(r*(8*s - 2) + 8*s**2 - 8*s + 1)) + k1**4*k2**2*(2*Pk2*(-4*C*(213*r**2 + 406*r*s - 313*r + 249*s**2 - 326*s + 77) - 84*K*r**2 - 308*K*r*s + 168*K*r - 224*K*s**2 + 280*K*s - 84*K + 7*b1*(192*r**2 + r*(336*s - 281) + 144*s**2 - 249*s + 97) + 675*r**2 + 1350*r*s - 995*r + 787*s**2 - 1023*s + 236) + 3*Pkd2*k2*(-2*C*(r*(44*s - 8) + 44*s**2 - 48*s + 4) - 14*K*(s - 1)*(r + s - 1) + 7*b1*(3*r*(8*s - 1) + 24*s**2 - 23*s + 1) + 58*r*s - 8*r + 58*s**2 - 62*s + 4)) - 2*k1**2*k2**4*(Pk2*(4*C*(264*r**2 + 5*r*(85*s - 57) + 217*s**2 - 255*s + 38) + 56*K*r**2 + 224*K*r*s - 112*K*r + 168*K*s**2 - 168*K*s + 56*K - 28*b1*(12*r**2 + r*(18*s - 13) + 6*s**2 - 11*s + 3) - 633*r**2 - 1004*r*s + 661*r - 483*s**2 + 559*s - 76) + Pkd2*k2*(42*C - 21)*(r*(3*s - 1) + s*(3*s - 3)))) + 14*k1**2*(Pk2*b1**2*k2**2*(12*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 4*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(-4*Pk2*k1**4*(2*r**2 + r*(-4*K*s + K + 8*s - 3) + s*(K*(3 - 4*s) + 6*s - 5)) + 2*k1**2*k2**2*(-Pk2*(8*C*(2*r**2 + r*(2 - 16*s) + 2*s**2 + 7*s - 4) - 98*K*s**2 + 87*K*s + r**2*(32 - 74*K) + r*(-172*K*s + 85*K + 152*s - 53) + 40*s**2 - 67*s + 14) + Pkd2*k2*(K*r*(14*s - 1) + K*s*(14*s - 13) - 5*s*(r + s - 1))) + k2**4*(5*K*Pkd2*k2*(r*(6*s - 1) + s*(6*s - 5)) - 2*Pk2*(4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) - 5*K*(20*r**2 + 42*r*s - 20*r + 22*s**2 - 20*s - 1) + 17*r**2 + 64*r*s - 23*r + 7*s**2 - 23*s + 6))) - 2*g2*(4*Pk2*k1**4*(r*(2*s - 1) + s*(2*s - 2)) + 2*k1**2*k2**2*(Pk2*(37*r**2 + r*(86*s - 48) + s*(49*s - 49)) + Pkd2*k2*(r*(7*s - 1) + s*(7*s - 7))) + 5*k2**4*(Pk2*(20*r**2 + r*(42*s - 22) + s*(22*s - 22)) + Pkd2*k2*(r*(3*s - 1) + s*(3*s - 3)))))) + 14*Pk2*b1**3*k1**2*k2**2*(12*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - b1**2*k1**2*(D1*fd*(56*Pk2*k1**4*(r + s)*(r + s*(3 - 2*K)) + f*(112*Pk2*k2**4*(6*r**2 + r*(9*s - 5) + 3*s**2 - 4*s + 1) + 24*k1**4*(Pk2*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 2*Pkd2*k2*s*(2*r + 2*s - 1)) + 7*k1**2*k2**2*(2*Pk2*(192*r**2 + 7*r*(48*s - 29) + 144*s**2 - 183*s + 55) + 3*Pkd2*k2*s*(24*r + 24*s - 11))) + 14*k1**2*k2**2*(2*Pk2*(8*C*(r**2 - 2*r*(4*s + 1) + s**2 + 8*s + 1) - 49*K*s**2 + r**2*(16 - 37*K) + r*(-86*K*s + 76*s + 12) + 20*s**2 - 28*s - 6) - Pkd2*k2*s*(14*K - 5)*(r + s)) - 14*k2**4*(15*K*Pkd2*k2*s*(r + s) + Pk2*(-16*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 10*K*(10*r**2 + 21*r*s + 2*r + 11*s**2 + 2*s - 1) - 17*r**2 - 64*r*s - 16*r - 7*s**2 + 24*s + 8))) + Dd*f*(56*Pk2*k1**4*(4*r**2 + r*(-8*K*s + K + 16*s - 4) + s*(K*(4 - 8*s) + 12*s - 7)) + f*(56*Pk2*k2**4*(24*r**2 + r*(36*s - 23) + 12*s**2 - 19*s + 5) + 12*k1**4*(2*Pk2*(4*r + 4*s - 3)**2 + Pkd2*k2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 7*k1**2*k2**2*(8*Pk2*(96*r**2 + r*(168*s - 121) + 72*s**2 - 108*s + 38) + 3*Pkd2*k2*(r*(48*s - 3) + 48*s**2 - 34*s + 1))) + 14*k1**2*k2**2*(2*Pk2*(8*C*(4*r**2 - 2*r*(16*s + 1) + 4*s**2 + 23*s - 2) - 196*K*s**2 + 125*K*s + r**2*(64 - 148*K) + r*(-344*K*s + 122*K + 304*s - 51) + 80*s**2 - 142*s + 2) + Pkd2*k2*(K*r*(2 - 56*s) + 2*K*s*(19 - 28*s) + 5*s*(4*r + 4*s - 3))) + 14*k2**4*(5*K*Pkd2*k2*(-12*r*s + r + s*(7 - 12*s)) + Pk2*(8*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 10*K*(40*r**2 + 84*r*s - 27*r + 44*s**2 - 27*s - 3) + 68*r**2 + 256*r*s - 39*r + 28*s**2 - 109*s - 4)))) + b1*(D1*(3*f**2*fd*k1**4*(12*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 5*s + 5) + k1**2*(2*Pk2*(150*r**2 + 6*r*(35*s - 31) + 60*s**2 - 121*s + 58) + 5*Pkd2*k2*(6*r*(3*s + 1) + 18*s**2 - 7*s - 4))) + 2*f*(fd*(-12*Pk2*k1**6*(2*r + 2*s - 1)*(2*r + s*(10 - 8*C) - 1) + Pk2*k2**6*(28*C - 14)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(4*C*(426*r**2 + r*(812*s - 405) + 498*s**2 - 343*s + 96) + 28*K*(6*r**2 + 22*r*s - 14*r + 16*s**2 - 22*s + 7) - 1350*r**2 - 2700*r*s + 1252*r - 1574*s**2 + 1189*s - 313) + 3*Pkd2*k2*(7*K*(s - 1) + s*(44*C - 29))*(2*r + 2*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(528*r**2 + r*(850*s - 353) + 434*s**2 - 229*s + 34) + 56*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 1266*r**2 - 2008*r*s + 811*r - 966*s**2 + 521*s - 68) + Pkd2*k2*s*(84*C - 42)*(3*r + 3*s - 1))) - 14*k1**2*(-2*Pk2*bd2*k2**2*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(4*Pk2*k1**4*s*(2*r + 2*s - 1) + 2*Pk2*k1**2*k2**2*(37*r**2 + r*(86*s - 37) + s*(49*s - 38)) + 10*Pk2*k2**4*(10*r**2 + 3*r*(7*s - 3) + 11*s**2 - 9*s - 1) + 2*Pkd2*k1**2*k2**3*s*(7*r + 7*s - 6) + 5*Pkd2*k2**5*s*(3*r + 3*s - 2)))) - 28*fd*k1**2*(-2*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(r + s)**2 + g2*(8*Pk2*k1**4*s*(r + s) + 2*Pk2*k1**2*k2**2*(37*r**2 + 86*r*s + 49*s**2) + 10*Pk2*k2**4*(10*r**2 + r*(21*s + 2) + 11*s**2 + 2*s - 1) + 14*Pkd2*k1**2*k2**3*s*(r + s) + 15*Pkd2*k2**5*s*(r + s)))) + Dd*f*(3*f**2*k1**4*(24*Pk2*k2**2*(4*r - 1)*(4*r + 4*s - 3) + k1**2*(2*Pk2*(200*r**2 + 7*r*(40*s - 39) + 80*s**2 - 178*s + 91) + 5*Pkd2*k2*(r*(24*s + 7) + 24*s**2 - 12*s - 5))) + 2*f*(12*Pk2*k1**6*(C*(4*r*(8*s - 1) + 32*s**2 - 24*s + 2) - 8*r**2 + r*(14 - 48*s) - 40*s**2 + 34*s - 5) + Pk2*k2**6*(56*C - 28)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(4*C*(852*r**2 + r*(1624*s - 1027) + 996*s**2 - 935*s + 269) + 28*K*(12*r**2 + 44*r*s - 26*r + 32*s**2 - 42*s + 13) - 2700*r**2 - 5400*r*s + 3186*r - 3148*s**2 + 3067*s - 813) + 3*Pkd2*k2*(4*C*(r*(44*s - 2) + 44*s**2 - 33*s + 1) + 7*K*(s - 1)*(4*r + 4*s - 3) - 116*r*s + 4*r - 116*s**2 + 87*s - 2)) + k1**2*k2**4*(Pk2*(4*C*(1056*r**2 + r*(1700*s - 957) + 868*s**2 - 717*s + 127) + 56*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) - 2532*r**2 - 4016*r*s + 2215*r - 1932*s**2 + 1609*s - 254) + Pkd2*k2*(42*C - 21)*(r*(12*s - 1) + s*(12*s - 7)))) + 28*k1**2*(2*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(4*Pk2*k1**4*(-8*r*s + r + s*(4 - 8*s)) - 2*Pk2*k1**2*k2**2*(148*r**2 + 2*r*(172*s - 61) + s*(196*s - 125)) - 10*Pk2*k2**4*(40*r**2 + 3*r*(28*s - 9) + 44*s**2 - 27*s - 3) + 2*Pkd2*k1**2*k2**3*(-28*r*s + r + s*(19 - 28*s)) + 5*Pkd2*k2**5*(-12*r*s + r + s*(7 - 12*s)))))) + 2*f*k1**2*(D1*(40*Pk2*f**2*fd*k1**4*(4*s - 1)*(r + s - 1) + f*k2**2*(42*Pk2*bd2*k1**2*(r + s - 1)**2 + 3*fd*(Pk2*k2**2*(4*C - 2)*(21*r**2 + r*(75*s - 46) + 54*s**2 - 61*s + 19) + k1**2*(Pk2*(8*C*(15*r**2 + 54*r*s - 33*r + 39*s**2 - 54*s + 17) - 75*r**2 - 264*r*s + 153*r - 189*s**2 + 260*s - 79) + Pkd2*k2*(10*C - 5)*(s - 1)*(3*r + 3*s - 2))) - 14*gd2*(8*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + k1**2*(4*Pk2*(3*r**2 + 11*r*s - 6*r + 8*s**2 - 10*s + 3) + 3*Pkd2*k2*(s - 1)*(r + s - 1)))) - 14*fd*k2**2*(-3*Pk2*b2*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + g2*(8*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(4*Pk2*(6*r**2 + 22*r*s - 14*r + 16*s**2 - 22*s + 7) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))))) + Dd*f*(40*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + 3*f*k2**2*(Pk2*k2**2*(8*C - 4)*(14*r**2 + 10*r*(5*s - 3) + 36*s**2 - 40*s + 13) + k1**2*(Pk2*(8*C*(20*r**2 + 72*r*s - 43*r + 52*s**2 - 71*s + 22) - 100*r**2 - 352*r*s + 198*r - 252*s**2 + 339*s - 99) + Pkd2*k2*(10*C - 5)*(s - 1)*(4*r + 4*s - 3))) - 14*k2**2*(-3*Pk2*b2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + g2*(8*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(4*Pk2*(12*r**2 + 44*r*s - 26*r + 32*s**2 - 42*s + 13) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(105*d**2*k1*k2*k3**6) + D1**3*Pk3*ct*st**2*(2*D1*bd1*f**2*(4*Pk2*k1**2*s*(43*s - 39) + 4*Pkd2*k1**2*k2*s*(15 - 16*s) + Pkd2*k2**3*(8*C - 4)*(r*(17*s - 6) - 6*s) + k2**2*(2*Pk2*(26*r**2 + r*(-150*C*s + 62*C + 75*s - 58) + s*(48*C - 24)) + 7*Pkdd2*k1**2*s*(s - 1))) - 7*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + 7*b1**2*k1**2*(D1*(-bd1*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + fd*(8*Pk2*(f*(42*s**2 - 53*s + 16) + 19*s**2 - 42*s + 21) + k2*(-Pkd2*(f*(138*s**2 - 169*s + 50) + 62*s**2 - 144*s + 72) + Pkdd2*k2*(3*f*(6*s**2 - 7*s + 2) + 8*s**2 - 20*s + 10)))) + Dd*f*(4*s - 1)*(8*Pk2*(f*(21*s - 16) + 19*s - 21) + k2*(Pkd2*(-69*f*s + 50*f - 62*s + 72) + Pkdd2*k2*(9*f*s - 6*f + 8*s - 10)))) + 2*b1*f*(7*D1*bd1*k1**2*s*(8*Pk2*(f*(21*s - 16) + 19*s - 20) + k2*(Pkd2*(-69*f*s + 50*f - 62*s + 67) + Pkdd2*k2*(9*f*s - 6*f + 8*s - 9))) + D1*fd*(k1**2*(2*s - 1)*(4*Pk2*(43*s - 39) + k2*(Pkd2*(60 - 64*s) + 7*Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(-2*C*(2*r*(75*s - 41) - 103*s + 55) + 52*r**2 + 6*r*(25*s - 27) - 103*s + 82) + Pkd2*k2*(4*C - 2)*(17*r - 12)*(2*s - 1))) + Dd*f*k1**2*(4*s - 1)*(4*Pk2*(43*s - 39) + k2*(Pkd2*(60 - 64*s) + 7*Pkdd2*k2*(s - 1))) + 4*Dd*f*k2**2*(Pk2*(C*(r*(144 - 300*s) + 206*s - 86) + 52*r**2 + 2*r*(75*s - 76) - 103*s + 70) + Pkd2*k2*(2*C - 1)*(r*(68*s - 29) - 48*s + 18))))/(105*d**2*k1*k2**3) + D1**3*Pk3*ct*(-2*D1*bd1*f**2*(2*Pk2*k1**2*s*(3*s - 5) - 2*Pk2*k2**2*(-8*C*s + r**2 + r*(2*C - 1)*(11*s - 1) + 4*s) - 7*Pkd2*k1**2*k2*s*(s - 1) + Pkd2*k2**3*r*(8*C - 4)*(s - 1)) + 5*b1**3*k1**2*k2*s*(-Pkd2 + Pkdd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + b1**2*(5*D1*bd1*f*k1**2*k2*s*(-Pkd2 + Pkdd2*k2)*(3*s - 1) - 2*D1*fd*k1**2*(2*Pk2*(3*f*(6*s**2 - 7*s + 2) + 9*s**2 - 10*s + 5) - Pkd2*k2*(4*f*(6*s**2 - 7*s + 2) + 19*s**2 - 30*s + 15)) + 4*D1*fd*k2**2*(r - 1)*(9*Pk2*(r - 1) + Pkd2*k2*s*(8*C - 4)) - 2*Dd*f*k1**2*(4*s - 1)*(2*Pk2*(f*(9*s - 6) + 9*s - 5) + Pkd2*k2*(f*(8 - 12*s) - 19*s + 15)) + 8*Dd*f*k2**2*(9*Pk2*(2*r**2 - 3*r + 1) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) - 6*s + 1))) - 2*b1*f*(2*D1*bd1*(2*Pk2*k1**2*s*(f*(9*s - 6) + 9*s - 7) - 18*Pk2*k2**2*r*(r - 1) + Pkd2*k1**2*k2*s*(f*(8 - 12*s) - 19*s + 17) - Pkd2*k2**3*(4*C - 2)*(r*(4*s - 1) - 2*s + 1)) + D1*fd*(k1**2*(2*s - 1)*(2*Pk2*(3*s - 5) - 7*Pkd2*k2*(s - 1)) + 2*k2**2*(Pk2*(-2*C*(22*r*s - 8*r - 13*s + 5) - 2*r**2 + 22*r*s - 7*r - 13*s + 5) + Pkd2*k2*(4*C - 2)*(2*r - 1)*(s - 1))) + Dd*f*k1**2*(4*s - 1)*(2*Pk2*(3*s - 5) - 7*Pkd2*k2*(s - 1)) + 4*Dd*f*k2**2*(Pk2*(C*(-44*r*s + 10*r + 26*s - 6) - 2*r**2 + 22*r*s - 4*r - 13*s + 3) + Pkd2*k2*(4*C - 2)*(2*r - 1)*(s - 1))))/(15*d**2*k1*k2**3) - D1**3*Pk3*ct*st**4*(3*b1**2*k1**2*k2**2*(D1*fd*(8*Pk2*(-28*K*(s - 1)*(r - s + 1) + f*(33*s - 10) + 28*r*s - 28*r + 28*s - 14) + k2*(Pkd2*f*(50 - 165*s) + 14*Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*f*k2*(33*s - 10) + 14*Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) + 2*Dd*f*(8*Pk2*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7) + k2*(-25*Pkd2*f*(4*s - 1) + 7*Pkd2*(2*K*(r*(8*s - 5) - 20*s**2 + 23*s - 3) - 2*r*(8*s - 5) - 16*s + 1) + Pkdd2*k2*(4*s - 1)*(14*K*(s - 1) + 5*f + 7)))) + b1*k1**2*(D1*(f**2*(21*bd1*k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + fd*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(63*s**2 - 51*s + 10) - 3*k2**2*(4*Pk2*(r*(90*s - 93) + 390*s**2 - 298*s + 84) + k2*(Pkd2*(-24*r*(6*s - 5) - 615*s**2 + 487*s - 126) + 5*Pkdd2*k2*(15*s**2 - 11*s + 2))))) + 6*f*(fd*(k1**2*(1 - 2*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) - k2**2*(2*Pk2*(-64*C*s**2 + 32*C*s + 4*K*(26*s**2 - 33*s + 10) + r*(64*C*s - 32*C + 47*s - 48) + 280*s**2 - 264*s + 58) + k2*(Pkd2*(-4*C*(2*s - 1)*(4*r - 10*s + 3) - 5*K*(26*s**2 - 33*s + 10) - 34*r*s + 31*r - 248*s**2 + 252*s - 59) + Pkdd2*k2*(-4*C*(1 - 2*s)**2 + K*(26*s**2 - 33*s + 10) + 36*s**2 - 40*s + 10)))) + 7*k2**2*(-8*Pk2*bd1*(K*(r*(4*s - 2) - 4*s**2 + 3*s + 1) + r*(2 - 4*s) - 1) + 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*k2*(Pkd2*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2) + Pkdd2*k2*s*(4*K*(s - 1) + 1)) - 4*gd2*k2*(Pkd2*(r*(2*s - 1) - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1)))) - 168*fd*g2*k2**2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + Dd*f*(f**2*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(84*s**2 - 61*s + 10) - 3*k2**2*(8*Pk2*(12*r*(5*s - 6) + 260*s**2 - 187*s + 59) + k2*(Pkd2*(-192*r*s + 180*r - 820*s**2 + 605*s - 166) + 5*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 6*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(-2*Pk2*(8*C*(2*r*(8*s - 3) - 16*s**2 + 4*s + 1) + 4*K*(52*s**2 - 53*s + 10) + 94*r*s - 114*r + 560*s**2 - 487*s + 132) + k2*(Pkd2*(8*C*(r*(8*s - 3) - 20*s**2 + 11*s - 1) + 5*K*(52*s**2 - 53*s + 10) + 68*r*s - 71*r + 496*s**2 - 428*s + 103) + Pkdd2*k2*(4*s - 1)*(C*(8*s - 4) + K*(10 - 13*s) - 18*s + 10)))) - 168*g2*k2**2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1)))) + f*(D1*(bd1*f**2*k1**2*(48*Pk2*k1**2*s*(21*s - 10) + 18*Pkd2*k1**2*k2*s*(10 - 21*s) + 3*Pkd2*k2**3*(12*r*(4*s - 5) + 205*s**2 - 118*s + 40) + 15*Pkdd2*k2**4*s*(2 - 5*s) - 2*k2**2*(6*Pk2*(30*r*s - 51*r + 130*s**2 - 76*s + 34) + Pkdd2*k1**2*s*(10 - 21*s))) + 2*f*(fd*(k1**4*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*(-16*C*(63*s**2 - 51*s + 10) - 135*r*(5*s - 2) + 177*s - 74) + k2*(Pkd2*(10*C*(63*s**2 - 51*s + 10) + 27*r*(7*s - 3) - 135*s**2 + 57*s + 2) - Pkdd2*k2*(3*s - 1)*(C*(42*s - 20) - 15*s + 7))) - 2*k2**4*(Pk2*(C*(-540*r*s + 198*r + 276*s - 98) + 63*r**2 + 270*r*s - 165*r - 138*s + 64) + Pkd2*k2*(8*C - 4)*(9*r - 5)*(3*s - 1))) + 3*k1**2*(bd1*(24*Pk2*k1**2*s*(2*s - 1) + 9*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(r*(4*C*(4*s - 1) + 17*s - 20) + s**2*(-40*C + 65*K + 124) + s*(16*C - 50*K - 87) + 24) + Pkdd2*k2**4*s*(C*(8*s - 4) + K*(10 - 13*s) - 18*s + 8) - k2**2*(Pk2*(r*(16*C*(4*s - 1) + 47*s - 66) - s**2*(64*C - 104*K - 280) + s*(16*C - 80*K - 231) + 82) + Pkdd2*k1**2*s*(1 - 2*s))) - k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(bd2 - 2*gd2)*(13*s - 10))) - 6*k1**2*k2**2*(b2*fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10) - 2*g2*(14*bd1*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) + fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(26*s**2 - 33*s + 10)))) + 2*Dd*f*(f*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + k1**2*k2**2*(-2*Pk2*(8*C*(84*s**2 - 61*s + 10) + 6*r*(75*s - 29) - 181*s + 76) + k2*(Pkd2*(10*C*(84*s**2 - 61*s + 10) + 21*r*(12*s - 5) - 180*s**2 + 25*s + 26) - Pkdd2*k2*(4*s - 1)*(C*(42*s - 20) - 15*s + 7))) - 4*k2**4*(Pk2*(C*(-8*r*(45*s - 16) + 236*s - 78) + 42*r**2 + 5*r*(36*s - 23) - 118*s + 54) + Pkd2*k2*(2*C - 1)*(r*(72*s - 23) - 50*s + 15))) + k1**2*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-3*b2 + 6*g2)*(52*s**2 - 53*s + 10))))/(105*d**2*k1*k2**3*k3**2) + D1**3*Pk3*ct*st**2*(21*b1**3*k1**2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 3*b1**2*k1**2*(D1*(7*bd1*f*k2**3*s*(Pkd2 - Pkdd2*k2)*(3*s - 1) + fd*(Pk2*k1**2*s**2*(480*f + 112) - Pkd2*k1**2*k2*s**2*(300*f + 70) - 7*Pkd2*k2**3*(8*C*s**2 + 16*C*s - 2*K*(-20*r*(s - 1) + 33*s**2 - 64*s + 32) + f*(4*r*(4*s - 3) - 85*s + 26) - 2*r*(8*C*s + 9*s - 20) - 6*s**2 - 80*s + 32) - 7*Pkdd2*k2**4*(-8*C*s**2 + K*(22*s**2 - 40*s + 20) + 3*f*(7*s - 2) + 6*s**2 + 20*s - 10) + 2*k2**2*(7*Pk2*(-16*C*r*s + 16*C*s + 2*K*(s - 1)*(31*r - 22*s + 22) + 2*f*(4*r*(s - 2) - 29*s + 11) - 45*r*s + 62*r - 60*s + 22) + Pkdd2*k1**2*s**2*(30*f + 7)))) - 2*Dd*f*(Pk2*k1**2*s*(-120*f - 56)*(4*s - 1) + Pkd2*k1**2*k2*s*(75*f + 35)*(4*s - 1) - 7*Pkd2*k2**3*(-4*C*(-8*r*s + r + 4*s**2 + 5*s - 1) - 80*K*r*s + 50*K*r + 132*K*s**2 - 141*K*s + 12*K + f*(-16*r*s + 36*r + 60*s - 31) + 36*r*s - 37*r + 12*s**2 + 53*s) + 7*Pkdd2*k2**4*(4*s - 1)*(-4*C*s + K*(11*s - 10) + 3*f + 3*s + 5) + k2**2*(14*Pk2*(4*C*(r*(8*s - 1) - 6*s + 1) - 124*K*r*s + 55*K*r + 88*K*s**2 - 94*K*s + 6*K + f*(-8*r*(s - 5) + 44*s - 30) + 90*r*s - 42*r + 35*s + 1) - Pkdd2*k1**2*s*(15*f + 7)*(4*s - 1)))) + 3*b1*(D1*(f**2*k1**2*(bd1*(240*Pk2*k1**2*s*(1 - 2*s) + 150*Pkd2*k1**2*k2*s*(2*s - 1) + 7*Pkd2*k2**3*(4*r*(4*s - 15) - 35*s + 36) + 21*Pkdd2*k2**4*s + k2**2*(-28*Pk2*(4*r*(s - 8) - 15*s + 19) + 30*Pkdd2*k1**2*s*(1 - 2*s))) + 6*fd*(k1**2*(3*s - 1)*(8*Pk2*(27*s - 16) + k2*(-81*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 2*k2**2*(Pk2*(126*r**2 + 6*r*(9*s - 22) - 30*s**2 - 58*s + 57) + Pkd2*k2*(63*r*(2*s - 1) + 60*s**2 - 100*s + 36)))) + 2*f*(fd*(k1**4*(4*Pk2*(62*s**2 - 121*s + 39) + k2*(-4*Pkd2*(17*s**2 - 46*s + 15) + Pkdd2*k2*(2*s**2 - 21*s + 7))) + k1**2*k2**2*(Pk2*(4*C*(214*r*s + 5*r + 116*s**2 - 370*s + 100) + 28*K*(r*(s + 4) - 24*s**2 + 32*s - 10) + 196*r**2 - 620*r*s + 162*r - 64*s**2 + 609*s - 140) + k2*(Pkd2*(-4*C*(7*r*(16*s - 3) + 87*s**2 - 205*s + 67) - 7*K*(4*r*s + 6*r - 66*s**2 + 85*s - 26) + 540*r*s - 287*r + 426*s**2 - 710*s + 215) + Pkdd2*k2*(4*C*(29*s**2 - 21*s + 7) - 21*K*(6*s**2 - 7*s + 2) - 58*s**2 + 63*s - 21))) + k2**4*(4*C - 2)*(Pk2*(104*r**2 - 202*r + 75) + 2*Pkd2*k2*(17*r - 12))) - 7*k1**2*(bd1*(8*Pk2*k1**2*s*(2*s - 1) + 5*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(-4*C*(-4*r*s + r + 2*s**2 + s - 1) + K*(-40*r*s + 20*r + 66*s**2 - 55*s - 10) + 18*r*s - 7*r + 6*s**2 + 5*s + 6) - Pkdd2*k2**4*s*(C*(4 - 8*s) + K*(22*s - 21) + 6*s + 2) - k2**2*(Pk2*(8*C*(r*(4*s - 1) - 2*s + 1) - 4*K*(31*r*s - 8*r - 22*s**2 + 18*s + 4) + 90*r*s - 6*r + 5*s + 8) + Pkdd2*k1**2*s*(1 - 2*s))) + k2**2*(-4*Pk2*gd2*(r*(31*s - 8) - 22*s**2 + 14*s + 8) + bd2*k2*s**2*(Pkd2 - Pkdd2*k2) + 2*gd2*k2*(Pkd2*(10*r*(2*s - 1) - 33*s**2 + 22*s + 10) + Pkdd2*k2*s*(11*s - 10))))) - 14*fd*k1**2*k2**2*(b2*k2*s**2*(Pkd2 - Pkdd2*k2) - 2*g2*(2*Pk2*(s - 1)*(31*r - 22*s + 22) + k2*(Pkd2*(-20*r*(s - 1) + 33*s**2 - 64*s + 32) + Pkdd2*k2*(-11*s**2 + 20*s - 10))))) + 2*Dd*f*(3*f**2*k1**2*(k1**2*(4*s - 1)*(8*Pk2*(27*s - 16) + k2*(-81*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 4*k2**2*(Pk2*(84*r**2 + 36*r*s - 74*r - 20*s**2 - 33*s + 21) + Pkd2*k2*(84*r*s - 42*r + 40*s**2 - 68*s + 25))) + f*(k1**4*(4*s - 1)*(4*Pk2*(31*s - 39) + k2*(Pkd2*(60 - 34*s) + Pkdd2*k2*(s - 7))) + k1**2*k2**2*(4*Pk2*(C*(r*(428*s + 53) + 232*s**2 - 682*s + 76) + 7*K*(2*r*s + 11*r - 48*s**2 + 57*s - 17) + 98*r**2 - 310*r*s + 25*r - 32*s**2 + 383*s - 92) + k2*(Pkd2*(-2*C*(14*r*(32*s - 1) + 348*s**2 - 763*s + 120) + 7*K*(-2*r*(4*s + 9) + 132*s**2 - 145*s + 38) + 1080*r*s - 464*r + 852*s**2 - 1501*s + 419) + Pkdd2*k2*(4*s - 1)*(C*(58*s - 28) + K*(42 - 63*s) - 29*s + 21))) + k2**4*(8*C - 4)*(2*r - 1)*(Pk2*(52*r - 75) + 12*Pkd2*k2)) - 7*k1**2*k2**2*(b2*k2*s*(Pkd2 - Pkdd2*k2)*(4*s - 1) - 2*g2*(2*Pk2*(r*(124*s - 55) - 88*s**2 + 94*s - 6) + k2*(Pkd2*r*(50 - 80*s) + 3*Pkd2*(44*s**2 - 47*s + 4) + Pkdd2*k2*(-44*s**2 + 51*s - 10)))))) + 2*f*(D1*(9*bd1*f**2*k1**2*(8*Pk2*k1**2*s*(27*s - 16) + Pkd2*k1**2*k2*s*(50 - 81*s) + 2*Pkd2*k2**3*(21*r*(2*s - 1) + 20*s**2 - 36*s + 14) + k2**2*(2*Pk2*(42*r**2 + 2*r*(9*s - 8) - 10*s**2 - 8*s - 15) + 3*Pkdd2*k1**2*s*(3*s - 2))) + f*(3*bd1*(k1**4*s*(4*Pk2*(31*s - 27) + k2*(Pkd2*(30 - 34*s) + Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(232*C*s**2 - 496*C*s + 14*K*(r*(s + 7) - 24*s**2 + 25*s - 7) + 98*r**2 + r*(428*C*s + 96*C - 310*s - 22) - 32*s**2 + 425*s - 170) - k2*(Pkd2*(174*C*s**2 - 326*C*s + 7*K*(2*r*(s + 3) - 33*s**2 + 30*s - 6) + r*(28*C*(8*s + 1) - 270*s + 93) - 213*s**2 + 398*s - 120) + Pkdd2*k2*s*(-58*C*(s - 1) + 21*K*(3*s - 2) + 29*s - 29))) + k2**4*(4*C - 2)*(Pk2*r*(52*r - 75) + 2*Pkd2*k2*(r + 6))) + 3*fd*k1**4*(3*s - 1)*(4*Pk2*(27*s - 19) + k2*(-4*Pkd2*(9*s - 7) + 3*Pkdd2*k2*(s - 1))) + fd*k1**2*k2**2*(Pk2*(-24*C*(18*r*(s - 2) + 162*s**2 - 147*s + 41) + 450*r**2 - 729*r*s + 24*r + 1836*s**2 - 1629*s + 362) - 3*k2*(Pkd2*(-2*C*(18*r*(s - 3) + 405*s**2 - 369*s + 94) - 279*r*s + 117*r + 279*s**2 - 192*s + 25) + Pkdd2*k2*(18*C - 9)*(9*s**2 - 9*s + 2))) - 6*fd*k2**4*(Pk2*(2*C*(126*r**2 - 306*r*s - 75*r + 210*s - 25) - 144*r**2 + 9*r*(34*s + 9) - 210*s + 25) + Pkd2*k2*(24*C - 12)*(3*r - 1)*(2*s - 1)) - k1**2*k2**2*(21*bd2 - 42*gd2)*(-2*Pk2*(r*(s + 7) - 24*s**2 + 25*s - 7) + k2*(Pkd2*(2*r*(s + 3) - 33*s**2 + 30*s - 6) + 3*Pkdd2*k2*s*(3*s - 2)))) + 21*k1**2*k2**2*(b2*(4*Pk2*fd*(r*(s + 4) - 24*s**2 + 32*s - 10) + bd1*k2*s*(-Pkd2 + Pkdd2*k2)*(s - 1) - fd*k2*(Pkd2*(4*r*s + 6*r - 66*s**2 + 85*s - 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) - 2*g2*(Pk2*bd1*(r*(16 - 62*s) + s*(44*s - 44)) + 4*Pk2*fd*(r*(s + 4) - 24*s**2 + 32*s - 10) + bd1*k2*(10*Pkd2*r*(2*s - 1) - 33*Pkd2*s*(s - 1) + 11*Pkdd2*k2*s*(s - 1)) - fd*k2*(Pkd2*(4*r*s + 6*r - 66*s**2 + 85*s - 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))) + Dd*f*(f*(3*k1**4*(4*s - 1)*(4*Pk2*(27*s - 19) + k2*(-4*Pkd2*(9*s - 7) + 3*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(-2*Pk2*(12*C*(24*r*s - 52*r + 216*s**2 - 190*s + 57) - 300*r**2 + 486*r*s + 73*r - 1224*s**2 + 981*s - 191) - 3*k2*(Pkd2*(-2*C*(24*r*s - 80*r + 540*s**2 - 467*s + 120) - 372*r*s + 139*r + 372*s**2 - 197*s + 3) + Pkdd2*k2*(18*C - 9)*(12*s**2 - 11*s + 2))) - 12*k2**4*(Pk2*(2*C*(84*r**2 - 204*r*s - 70*r + 162*s - 1) - 96*r**2 + 204*r*s + 76*r - 162*s + 1) + Pkd2*k2*(24*C - 12)*(2*r - 1)*(2*s - 1))) + k1**2*k2**2*(-21*b2 + 42*g2)*(4*Pk2*(-r*(2*s + 11) + 48*s**2 - 57*s + 17) + k2*(Pkd2*(8*r*s + 18*r - 132*s**2 + 145*s - 38) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))))))/(315*d**2*k1*k2**3*k3**2) - D1**3*Pk3*ct*(35*b1**3*k1**2*k2**3*(D1*fd*s*(Pkd2*(8*r + 3*s - 8) + Pkdd2*k2*s) + Dd*f*(Pkd2*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + Pkdd2*k2*s*(4*s - 1))) - 7*b1**2*(D1*(-5*bd1*f*k1**2*k2**3*(Pkd2*(4*r*(6*s - 1) + 9*s**2 - 19*s + 4) + Pkdd2*k2*s*(3*s - 1)) + 2*fd*(2*k1**4*s**2*(-4*Pk2 + k2*(Pkd2*(2 - 3*f) + 3*Pkdd2*f*k2)) + k1**2*k2**2*(Pk2*(64*C*r*s - 64*C*s + 10*K*(s - 1)*(3*r + 4*s - 4) + 2*f*(60*r**2 + r*(36*s - 77) - 10*s + 24) + 50*r**2 - 49*r*s + 30*r + 104*s - 20) - k2*(5*K*Pkdd2*k2*s**2 + Pkd2*(80*C*r*s - 16*C*s**2 - 80*C*s - 5*K*(3*s**2 - s*(4*r + 12) + 6) + 2*f*(-10*r*(2*s + 1) + s + 9) - 65*r*s + 12*s**2 + 10*s + 15))) - 2*k2**4*(r - 1)*(Pk2*(-4*C*(9*r - 4*s - 9) + 27*r - 8*s - 27) + Pkd2*k2*s*(8*C - 4)))) + 2*Dd*f*(-k1**4*s*(8*Pk2 + k2*(Pkd2*(3*f - 4) - 3*Pkdd2*f*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(16*C*(r*(8*s - 1) - 6*s + 1) + 60*K*r*s - 15*K*r + 80*K*s**2 - 100*K*s + 20*K + 2*f*(60*r**2 + 36*r*s - 82*r - 14*s + 25) + 100*r**2 - 98*r*s - 39*r + 131*s - 26) + k2*(5*K*Pkdd2*k2*s*(1 - 4*s) + Pkd2*(8*C*(r*(5 - 40*s) + 8*s**2 + 28*s - 5) - 80*K*r*s + 10*K*r + 60*K*s**2 - 115*K*s + 30*K + 4*f*(20*r*s + 10*r - 2*s - 7) + 260*r*s - 25*r - 48*s**2 - 88*s + 5))) - 4*k2**4*(Pk2*(-8*C*(9*r**2 - 4*r*s - 13*r + 3*s + 4) + 54*r**2 - 16*r*s - 79*r + 12*s + 25) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) - 6*s + 1)))) + 2*b1*(D1*(f**2*k1**2*(-7*bd1*k2*(3*Pkd2*k1**2*s*(1 - 2*s) + 2*Pkd2*k2**2*(10*r*(2*s + 1) - 3*s - 5) + k2*(2*Pk2*(60*r**2 + 36*r*s - 87*r - 18*s + 26) + 3*Pkdd2*k1**2*s*(2*s - 1))) + 12*fd*k1**2*(5*Pk2 - 3*Pkd2*k2)*(9*s**2 - 9*s + 2)) + f*(7*bd1*(4*k1**4*s*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(-32*C*(r*(4*s - 1) - 2*s + 1) - 80*K*s**2 + 80*K*s - 100*r**2 + r*(-60*K*s + 98*s + 58) - 79*s + 32) + k2*(5*K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(8*C*(5*r*(4*s - 1) - 4*s**2 - 8*s + 5) - 30*K*s**2 + 35*K*s + 5*r*(8*K*s - 2*K - 26*s + 5) + 24*s**2 + 33*s - 20))) + 4*k2**4*(Pk2*(-4*C*(9*r**2 - 4*r*(s + 2) + 2*s - 1) + 27*r**2 - 8*r*s - 25*r + 4*s - 2) + Pkd2*k2*(2*C - 1)*(r*(4*s - 1) - 2*s + 1))) + fd*k1**4*(2*Pk2*(90*s**2 - 91*s + 35) + Pkd2*k2*(-146*s**2 + 147*s - 49)) + fd*k1**2*k2**2*(Pk2*(28*C*(46*r*s - 13*r - 16*s**2 - 34*s + 16) + 28*K*(9*r*s - 4*r + 6*s**2 - 7*s + 2) - 712*r**2 - 1306*r*s + 852*r + 224*s**2 + 765*s - 346) + k2*(Pkd2*(4*C*(-35*s**2 + s*(120*r + 87) - 49) + 28*K*(5*r*s - 5*r + 12*s**2 - 14*s + 4) - 450*r*s + 70*s**2 - 237*s + 147) + Pkdd2*k2*s**2*(84*C - 42))) + fd*k2**4*(4*C - 2)*(Pk2*(80*r**2 - 164*r + 69) + 14*Pkd2*k2*(2*r - 1)) + 35*k1**2*k2**2*s*(bd2*k2*(Pkd2*(4*r + 3*s - 2) + Pkdd2*k2*s) + 2*gd2*(Pk2*(6*r + 8*s - 8) - k2*(Pkd2*(4*r - 3*s + 4) + Pkdd2*k2*s)))) + 35*fd*k1**2*k2**2*(4*Pk2*g2*(s - 1)*(3*r + 4*s - 4) + b2*k2*s*(4*Pkd2*r + 3*Pkd2*s + Pkdd2*k2*s) - 2*g2*k2*(Pkd2*(-3*s**2 + s*(4*r + 12) - 6) + Pkdd2*k2*s**2))) + Dd*f*(12*f**2*k1**4*(5*Pk2 - 3*Pkd2*k2)*(12*s**2 - 11*s + 2) + f*(k1**4*(4*s - 1)*(10*Pk2*(9*s - 7) + Pkd2*k2*(49 - 73*s)) + k1**2*k2**2*(2*Pk2*(14*C*(92*r*s - 13*r - 32*s**2 - 76*s + 16) + 14*K*(18*r*s - 3*r + 12*s**2 - 10*s + 1) - 712*r**2 - 1306*r*s + 884*r + 224*s**2 + 877*s - 334) + k2*(Pkd2*(2*C*(60*r*(8*s - 1) - 140*s**2 + 187*s - 68) + 280*K*r*(s - 1) + 84*K*(8*s**2 - 9*s + 3) - 900*r*s + 81*r + 140*s**2 - 215*s + 117) + Pkdd2*k2*s*(42*C - 21)*(4*s - 1))) + k2**4*(8*C - 4)*(2*r - 1)*(Pk2*(40*r - 41) + 14*Pkd2*k2)) + 35*k1**2*k2**2*(b2*k2*(2*Pkd2*r*(8*s - 1) + Pkd2*s*(12*s - 7) + Pkdd2*k2*s*(4*s - 1)) + 2*g2*(2*Pk2*(4*s - 1)*(3*r + 4*s - 4) + k2*(Pkd2*(-16*r*s + 2*r + 12*s**2 - 23*s + 6) + Pkdd2*k2*s*(1 - 4*s)))))) + 2*f*(D1*(12*bd1*f**2*k1**4*s*(5*Pk2 - 3*Pkd2*k2)*(3*s - 2) + f*(bd1*(k1**4*s*(2*Pk2*(45*s - 59) - 73*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(14*K*(9*r*s + r + 6*s**2 - 3*s - 1) - 356*r**2 + r*(s*(644*C - 653) + 410) - 4*s**2*(56*C - 28) - 4*s*(112*C - 106) - 172) + k2*(Pkd2*(10*C*(12*r*(2*s - 1) - 7*s**2 + s + 6) + 14*K*(5*r*(s - 1) + 12*s**2 - 13*s + 5) - 225*r*s + 81*r + 35*s**2 - 5*s - 30) + Pkdd2*k2*s*(42*C - 21)*(s - 1))) + k2**4*(4*C - 2)*(Pk2*(40*r**2 + r - 28) + 14*Pkd2*k2*r)) + 3*fd*(k1**4*(3*s - 1)*(2*Pk2*(5*s - 9) - 11*Pkd2*k2*(s - 1)) + 2*k1**2*k2**2*(Pk2*(4*C*(24*r*s - 6*r + 9*s**2 - 23*s + 6) - 21*r**2 - 102*r*s + 37*r - 18*s**2 + 46*s - 12) + Pkd2*k2*(6*C - 3)*(9*r*(s - 1) + 18*s**2 - 21*s + 7))) + k1**2*k2**2*(14*bd2 - 28*gd2)*(Pk2*(9*r*s + r + 6*s**2 - 3*s - 1) + Pkd2*k2*(5*r*(s - 1) + 12*s**2 - 13*s + 5))) + 7*k1**2*k2**2*(5*b2*bd1*k2*(Pkd2*r*(4*s - 2) + 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1)) + 4*b2*fd*(Pk2*(r*(9*s - 4) + 6*s**2 - 7*s + 2) + Pkd2*k2*(5*r*(s - 1) + 12*s**2 - 14*s + 4)) - 10*bd1*g2*(-2*Pk2*s*(3*r + 4*s - 4) + Pkd2*k2*(r*(4*s - 2) + s*(3 - 3*s)) + Pkdd2*k2**2*s*(s - 1)) - 8*fd*g2*(Pk2*(r*(9*s - 4) + 6*s**2 - 7*s + 2) + Pkd2*k2*(5*r*(s - 1) + 12*s**2 - 14*s + 4)))) + Dd*f*k1**2*(3*f*(k1**2*(4*s - 1)*(2*Pk2*(5*s - 9) - 11*Pkd2*k2*(s - 1)) + 4*k2**2*(Pk2*(2*C*(32*r*s - 5*r + 12*s**2 - 29*s + 5) - 14*r**2 - 68*r*s + 21*r - 12*s**2 + 29*s - 5) + Pkd2*k2*(6*C - 3)*(6*r*(s - 1) + 12*s**2 - 14*s + 5))) + k2**2*(28*b2 - 56*g2)*(Pk2*(3*r*(6*s - 1) + 12*s**2 - 10*s + 1) + Pkd2*k2*(10*r*(s - 1) + 24*s**2 - 27*s + 9)))))/(105*d**2*k1*k2**3*k3**2) - D1**3*Pk3*ct*st**4*(D1*(1386*b1*fd*k1**2*k2**4*(b1*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1))) + 4*g2*(4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - Pkdd2*k2*s**2))) + f**3*k1**2*(-33*bd1*k1**2*k2**2*(-80*Pk2*(r*(12*s - 5) + 12*s**2 - 17*s + 3) + k2*(Pkd2*(20*r*(12*s - 5) + 240*s**2 - 439*s + 60) + 33*Pkdd2*k2*s)) + 99*bd1*k2**4*(4*Pk2*(22*r**2 - r*(40*s + 69) - 50*s**2 - 26*s + 47) + k2*(Pkd2*(68*r*s + 60*r - 5*s**2 + 34*s - 60) + 5*Pkdd2*k2*s*(5*s - 2))) + 15*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(116*s**2 - 69*s + 10) - 33*fd*k1**2*k2**2*(8*Pk2*(24*r*(13*s - 6) + 1020*s**2 - 707*s + 146) + k2*(Pkd2*(-768*r*s + 360*r - 2940*s**2 + 2071*s - 418) + 15*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 440*fd*k2**4*(Pk2*(162*r**2 + r*(30*s - 208) - 69*s + 77) + 9*Pkd2*k2*(2*r - 1)*(3*s - 1))) + 33*f**2*k2**2*(-3*bd1*(2*k1**4*(8*Pk2*(-K*(-4*r*s + r + 3*s**2 + 4*s - 1) - 9*r*s + 4*r - 4*s**2 + 17*s - 4) + k2*(Pkd2*(2*K*(-4*r*s + r + 9*s**2 + s - 1) + 18*r*s - 8*r + 2*s**2 - 31*s + 8) + Pkdd2*k2*s*(K*(2 - 4*s) + 2*s - 1))) + k1**2*k2**2*(2*Pk2*(8*C*(4*r**2 - 3*r - 8*s**2 + 4*s + 1) + 2*K*r**2 + 122*K*r*s - 162*K*r + 264*K*s**2 - 382*K*s + 160*K - 14*b1*(r + 2*s - 1) + 2*r**2 + 277*r*s + 144*s**2 - 81*s - 10) + k2*(Pkd2*(8*C*(10*s**2 + s*(4*r - 7) - 1) - 2*K*(r*(74*s - 64) + 147*s**2 - 170*s + 64) + b1*(14*r - 26*s**2 + 41*s - 14) - 158*r*s - 4*r - 60*s**2 + 72*s + 4) + Pkdd2*k2*s*(-16*C*(s - 1) + 30*K*s - 8*K + 13*b1*(2*s - 1) - 16*s + 2)))) + fd*(k1**4*(16*Pk2*(3*b1*(60*r*s - 26*r + 60*s**2 - 55*s + 18) + (3*s - 1)*(-12*C*r + 6*C*s + 8*C + 21*r + 6*s - 15)) + k2*(-3*Pkd2*b1*(8*r*(30*s - 13) + 240*s**2 - 67*s + 42) + 2*Pkd2*(3*s - 1)*(4*C*(6*r - 12*s - 1) - 42*r + 15*s + 21) + 3*Pkdd2*b1*k2*(51*s - 10) + Pkdd2*k2*(1 - 3*s)**2*(8*C - 6))) + k1**2*k2**2*(6*Pk2*(4*C*(15*r**2 - 339*r*s + 103*r - 156*s**2 + 279*s - 74) + 2*b1*(66*r**2 - r*(120*s + 89) - 150*s**2 + 112*s + 21) - 120*r**2 + 579*r*s - 122*r + 264*s**2 - 497*s + 126) + k2*(Pkd2*(4*C*(990*r*s - 342*r + 441*s**2 - 813*s + 226) + 3*b1*(2*r*(102*s + 5) - 15*s**2 - 81*s + 4) - 2070*r*s + 726*r - 954*s**2 + 1734*s - 484) + Pkdd2*k2*(3*s - 1)*(4*C*(9*s - 4) + 15*b1*(5*s - 2) - 6*s + 2))) + 4*k2**4*(Pk2*(-2*C*(198*r**2 + 9*r*(6*s - 31) + 30*s + 55) + 261*r**2 + 54*r*s - 345*r + 30*s + 70) + Pkd2*k2*(8*C - 4)*(9*r - 5)*(3*s - 1))) + 12*k1**2*(bd2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + gd2*(2*k1**2*(-4*Pk2*(-4*r*s + r + 3*s**2 + 4*s - 1) + k2*(Pkd2*(-4*r*s + r + 9*s**2 + s - 1) + Pkdd2*k2*s*(1 - 2*s))) + k2**2*(2*Pk2*(r**2 + r*(61*s - 81) + 132*s**2 - 191*s + 80) + k2*(Pkd2*(-74*r*s + 64*r - 147*s**2 + 170*s - 64) + Pkdd2*k2*s*(15*s - 4)))))) + 198*f*k1**2*k2**2*(b1**2*fd*k2**2*(66*Pk2*(r + 2*s - 1) + k2*(Pkd2*(-33*r + 13*s**2 - 66*s + 33) - 13*Pkdd2*k2*s**2)) - b1*(fd*(-k1**2*(2*s - 1)*(-8*Pk2*(K*(4*r - 3*s - 2) - 9*r - 4*s + 9) + k2*(Pkd2*(2*K*(4*r - 9*s + 1) - 18*r - 2*s + 15) + Pkdd2*k2*(2*K - 1)*(2*s - 1))) + k2**2*(2*Pk2*(16*C*(2*r**2 - r - (1 - 2*s)**2) + 2*K*(r**2 + 61*r*s - 55*r + 132*s**2 - 146*s + 40) + 2*r**2 + 277*r*s - 120*r + 144*s**2 - 144*s + 36) - k2*(Pkd2*(-16*C*(2*r*(s - 1) + 5*s**2 - 5*s + 2) + K*(148*r*s - 116*r + 294*s**2 - 315*s + 84) + 158*r*s - 89*r + 60*s**2 - 64*s + 28) + Pkdd2*k2*(K*(-30*s**2 + 23*s - 4) + s**2*(16*C + 16) - 28*s + 7)))) + 7*k2**2*(bd1*(4*K*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + 2*K*k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s)) - 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-2*s**2 + s*(8*r + 3) - 2) + Pkdd2*k2**2*s*(2*s - 1)) - 4*gd2*(Pk2*(4*r**2 - 2*r - 2*(1 - 2*s)**2) + k2*(Pkd2*(2*r*(s - 1) + 5*s**2 - 5*s + 2) - Pkdd2*k2*s**2)))) - 28*bd1*g2*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1)) + 2*fd*(b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + g2*(-2*k1**2*(2*s - 1)*(Pk2*(-16*r + 12*s + 8) + k2*(4*Pkd2*r - 9*Pkd2*s + Pkd2 + 2*Pkdd2*k2*s - Pkdd2*k2)) + k2**2*(4*Pk2*(r**2 + 61*r*s - 55*r + 132*s**2 - 146*s + 40) + k2*(Pkd2*(-148*r*s + 116*r - 294*s**2 + 315*s - 84) + Pkdd2*k2*(30*s**2 - 23*s + 4))))))) + Dd*f*(1386*b1*k1**2*k2**4*(b1*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) + 4*g2*(4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + Pkdd2*k2*s*(1 - 4*s)))) + f**3*k1**2*(15*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(116*s**2 - 69*s + 10) - 33*k1**2*k2**2*(8*Pk2*(24*r*(13*s - 6) + 1020*s**2 - 707*s + 146) + k2*(Pkd2*(-768*r*s + 360*r - 2940*s**2 + 2071*s - 418) + 15*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 440*k2**4*(Pk2*(162*r**2 + r*(30*s - 208) - 69*s + 77) + 9*Pkd2*k2*(2*r - 1)*(3*s - 1))) + 33*f**2*k2**2*(2*k1**4*(8*Pk2*(C*(-48*r*s + 14*r + 24*s**2 + 30*s - 10) + b1*(r*(240*s - 103) + 240*s**2 - 250*s + 69) + 84*r*s - 26*r + 24*s**2 - 76*s + 20) + k2*(Pkd2*(4*C*(24*r*s - 7*r - 48*s**2 + 6*s + 2) + b1*(r*(206 - 480*s) - 480*s**2 + 320*s - 93) - 168*r*s + 52*r + 60*s**2 + 89*s - 31) + Pkdd2*k2*(15*b1 + (4*C - 3)*(3*s - 1))*(4*s - 1))) + k1**2*k2**2*(4*Pk2*(4*C*(30*r**2 - 678*r*s + 185*r - 312*s**2 + 613*s - 149) + 6*b1*(44*r**2 - r*(80*s + 79) - 100*s**2 + 43*s + 34) - 240*r**2 + 1158*r*s - 204*r + 528*s**2 - 1143*s + 270) + k2*(Pkd2*(4*C*(6*r*(220*s - 69) + 588*s**2 - 1171*s + 298) - 3*b1*(-2*r*(136*s + 35) + 20*s**2 + 47*s + 56) - 2760*r*s + 894*r - 1272*s**2 + 2518*s - 652) + Pkdd2*k2*(4*s - 1)*(4*C*(9*s - 4) + 15*b1*(5*s - 2) - 6*s + 2))) + 8*k2**4*(Pk2*(-2*C*(132*r**2 + 6*r*(6*s - 35) + 10*s + 65) + 174*r**2 + 9*r*(4*s - 29) + 10*s + 80) + Pkd2*k2*(2*C - 1)*(r*(72*s - 23) - 50*s + 15))) + 99*f*k1**2*k2**2*(b1**2*k2**2*(160*Pk2*(r + 2*s - 1) + k2*(Pkd2*(-80*r + 52*s**2 - 173*s + 80) + 13*Pkdd2*k2*s*(1 - 4*s))) - 2*b1*(k1**2*(8*Pk2*(K*(16*r*s - 6*r - 12*s**2 - 9*s + 4) - 36*r*s + 17*r - 16*s**2 + 56*s - 17) + k2*(Pkd2*(-2*K*(16*r*s - 6*r - 36*s**2 + 9*s + 1) + 72*r*s - 34*r + 8*s**2 - 94*s + 31) - Pkdd2*k2*(2*K - 1)*(8*s**2 - 6*s + 1))) + k2**2*(2*Pk2*(8*C*(8*r**2 - 6*r - 16*s**2 + 12*s - 1) + K*(4*r**2 + 4*r*(61*s - 68) + 528*s**2 - 674*s + 240) + 4*r**2 + 554*r*s - 116*r + 288*s**2 - 225*s + 26) + k2*(Pkd2*(4*C*(2*r*(8*s - 5) + 40*s**2 - 34*s + 9) + K*(-296*r*s + 244*r - 588*s**2 + 655*s - 212) - 316*r*s + 97*r - 120*s**2 + 138*s - 36) + Pkdd2*k2*(4*s - 1)*(K*(15*s - 4) - s*(8*C + 8) + 7)))) + 4*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 4*g2*(2*k1**2*(4*Pk2*(2*r*(8*s - 3) - 12*s**2 - 9*s + 4) - k2*(Pkd2*(16*r*s - 6*r - 36*s**2 + 9*s + 1) + Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(4*Pk2*(2*r**2 + 2*r*(61*s - 68) + 264*s**2 - 337*s + 120) + k2*(Pkd2*(-296*r*s + 244*r - 588*s**2 + 655*s - 212) + Pkdd2*k2*(60*s**2 - 31*s + 4)))))))/(3465*d**2*k1*k2**3*k3**4) + D1**3*Pk3*ct*st**2*(D1*(-42*b1*fd*k1**2*k2**2*(2*Pkd2*b1**2*k2**3*s*(r + s - 1) + 6*Pkd2*b2*k2**3*s*(r + s) + b1*(k1**2*(-4*Pk2*(K*(r*(4*s - 2) + s**2 - 4*s + 2) + r*(2 - 5*s) - 2*(s - 1)**2) + k2*s*(Pkd2*(-4*K*s + r*(4*K - 6) + s) + Pkdd2*k2*s*(2*K - 1))) + k2**2*(-Pk2*(16*C*(r - 1)*(r + s - 1) - 2*K*(9*r**2 + r*(4 - 8*s) - 22*(s - 1)**2) - 10*r**2 + 15*r*s + 16*r + 60*s - 38) + k2*(Pkd2*(K*(2*r*(9*s - 19) + 39*s**2 - 76*s + 38) + r*s*(35 - 16*C) + 20*r - s**2*(16*C - 16) + s*(16*C + 28) - 20) + Pkdd2*k2*s**2*(5 - 9*K)))) + 4*g2*k1**2*(2*Pk2*(r*(4*s - 2) + s**2 - 4*s + 2) - k2*s*(2*Pkd2*(r - s) + Pkdd2*k2*s)) + 2*g2*k2**2*(-2*Pk2*(9*r**2 + r*(4 - 8*s) - 22*(s - 1)**2) + k2*(Pkd2*(-18*r*s + 38*r - 39*s**2 + 76*s - 38) + 9*Pkdd2*k2*s**2))) + f**3*k1**2*(-9*bd1*(5*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + k1**2*k2**2*(48*Pk2*(3*r**2 - r*(4*s + 5) - 6*s**2 + 5*s + 2) + k2*(Pkd2*(4*r*(40*s + 9) + 144*s**2 - 151*s - 36) + 9*Pkdd2*k2*s)) + 4*k2**4*(2*Pk2*(24*r**2 + 6*r*(11*s - 7) + 35*s**2 - 39*s + 11) + Pkd2*k2*(7*r*(4*s - 3) + 20*s**2 - 50*s + 21))) + fd*k1**2*(5*k1**2*(4*s - 1)*(8*Pk2*(33*s - 16) + k2*(Pkd2*(50 - 93*s) + 3*Pkdd2*k2*(3*s - 2))) + 216*k2**2*(Pk2*(20*r**2 + 2*r*(4*s - 7) - 20*s**2 + s + 2) + Pkd2*k2*(12*r*(2*s - 1) + 20*s**2 - 25*s + 8)))) + f**2*(-504*C*Pk2*fd*k1**4*k2**2*r*s + 1320*C*Pk2*fd*k1**4*k2**2*r + 3888*C*Pk2*fd*k1**4*k2**2*s**2 - 1920*C*Pk2*fd*k1**4*k2**2*s - 176*C*Pk2*fd*k1**4*k2**2 + 13320*C*Pk2*fd*k1**2*k2**4*r**2 - 18360*C*Pk2*fd*k1**2*k2**4*r*s - 4344*C*Pk2*fd*k1**2*k2**4*r + 15624*C*Pk2*fd*k1**2*k2**4*s - 3200*C*Pk2*fd*k1**2*k2**4 + 4752*C*Pk2*fd*k2**6*r**2 - 5616*C*Pk2*fd*k2**6*r*s - 3240*C*Pk2*fd*k2**6*r + 4464*C*Pk2*fd*k2**6*s - 312*C*Pk2*fd*k2**6 + 216*C*Pkd2*fd*k1**4*k2**3*r*s - 72*C*Pkd2*fd*k1**4*k2**3*r - 1296*C*Pkd2*fd*k1**4*k2**3*s**2 + 1512*C*Pkd2*fd*k1**4*k2**3*s - 360*C*Pkd2*fd*k1**4*k2**3 + 12096*C*Pkd2*fd*k1**2*k2**5*r*s - 6048*C*Pkd2*fd*k1**2*k2**5*r + 7236*C*Pkd2*fd*k1**2*k2**5*s**2 - 9756*C*Pkd2*fd*k1**2*k2**5*s + 3120*C*Pkd2*fd*k1**2*k2**5 + 1728*C*Pkd2*fd*k2**7*r*s - 864*C*Pkd2*fd*k2**7*r - 576*C*Pkd2*fd*k2**7*s + 288*C*Pkd2*fd*k2**7 + 216*C*Pkdd2*fd*k1**4*k2**4*s**2 - 288*C*Pkdd2*fd*k1**4*k2**4*s + 72*C*Pkdd2*fd*k1**4*k2**4 + 972*C*Pkdd2*fd*k1**2*k2**6*s**2 - 972*C*Pkdd2*fd*k1**2*k2**6*s + 216*C*Pkdd2*fd*k1**2*k2**6 - 1080*Pk2*b1*fd*k1**6*s**2 - 3888*Pk2*b1*fd*k1**4*k2**2*r**2 + 5184*Pk2*b1*fd*k1**4*k2**2*r*s + 2160*Pk2*b1*fd*k1**4*k2**2*r + 7776*Pk2*b1*fd*k1**4*k2**2*s**2 - 5616*Pk2*b1*fd*k1**4*k2**2*s + 432*Pk2*b1*fd*k1**4*k2**2 - 5184*Pk2*b1*fd*k1**2*k2**4*r**2 - 14256*Pk2*b1*fd*k1**2*k2**4*r*s + 6336*Pk2*b1*fd*k1**2*k2**4*r - 7560*Pk2*b1*fd*k1**2*k2**4*s**2 + 11520*Pk2*b1*fd*k1**2*k2**4*s - 2736*Pk2*b1*fd*k1**2*k2**4 - 612*Pk2*fd*k1**4*k2**2*r**2 + 864*Pk2*fd*k1**4*k2**2*r*s - 2148*Pk2*fd*k1**4*k2**2*r - 2160*Pk2*fd*k1**4*k2**2*s**2 - 648*Pk2*fd*k1**4*k2**2*s + 1144*Pk2*fd*k1**4*k2**2 - 12420*Pk2*fd*k1**2*k2**4*r**2 + 2214*Pk2*fd*k1**2*k2**4*r*s + 6912*Pk2*fd*k1**2*k2**4*r - 2808*Pk2*fd*k1**2*k2**4*s**2 - 4482*Pk2*fd*k1**2*k2**4*s + 636*Pk2*fd*k1**2*k2**4 - 2592*Pk2*fd*k2**6*r**2 + 2808*Pk2*fd*k2**6*r*s + 1692*Pk2*fd*k2**6*r - 2232*Pk2*fd*k2**6*s + 156*Pk2*fd*k2**6 + 648*Pk2*gd2*k1**4*k2**2*r*s - 288*Pk2*gd2*k1**4*k2**2*r - 1584*Pk2*gd2*k1**4*k2**2*s**2 + 1056*Pk2*gd2*k1**4*k2**2*s + 288*Pk2*gd2*k1**4*k2**2 - 7560*Pk2*gd2*k1**2*k2**4*r**2 - 5712*Pk2*gd2*k1**2*k2**4*r*s + 7728*Pk2*gd2*k1**2*k2**4*r - 6048*Pk2*gd2*k1**2*k2**4*s**2 + 2352*Pk2*gd2*k1**2*k2**4*s - 168*Pk2*gd2*k1**2*k2**4 + 675*Pkd2*b1*fd*k1**6*k2*s**2 - 4320*Pkd2*b1*fd*k1**4*k2**3*r*s + 1512*Pkd2*b1*fd*k1**4*k2**3*r - 3888*Pkd2*b1*fd*k1**4*k2**3*s**2 + 2385*Pkd2*b1*fd*k1**4*k2**3*s - 810*Pkd2*b1*fd*k1**4*k2**3 - 3024*Pkd2*b1*fd*k1**2*k2**5*r*s + 2268*Pkd2*b1*fd*k1**2*k2**5*r - 2160*Pkd2*b1*fd*k1**2*k2**5*s**2 + 2088*Pkd2*b1*fd*k1**2*k2**5*s - 1044*Pkd2*b1*fd*k1**2*k2**5 - 864*Pkd2*fd*k1**4*k2**3*r*s + 540*Pkd2*fd*k1**4*k2**3*r + 216*Pkd2*fd*k1**4*k2**3*s**2 - 72*Pkd2*fd*k1**4*k2**3*s - 84*Pkd2*fd*k1**4*k2**3 - 7830*Pkd2*fd*k1**2*k2**5*r*s + 4050*Pkd2*fd*k1**2*k2**5*r - 4374*Pkd2*fd*k1**2*k2**5*s**2 + 5940*Pkd2*fd*k1**2*k2**5*s - 1974*Pkd2*fd*k1**2*k2**5 - 864*Pkd2*fd*k2**7*r*s + 432*Pkd2*fd*k2**7*r + 288*Pkd2*fd*k2**7*s - 144*Pkd2*fd*k2**7 - 312*Pkd2*gd2*k1**4*k2**3*r*s - 48*Pkd2*gd2*k1**4*k2**3*r + 384*Pkd2*gd2*k1**4*k2**3*s**2 - 792*Pkd2*gd2*k1**4*k2**3*s + 48*Pkd2*gd2*k1**4*k2**3 - 9744*Pkd2*gd2*k1**2*k2**5*r*s + 3696*Pkd2*gd2*k1**2*k2**5*r - 7308*Pkd2*gd2*k1**2*k2**5*s**2 + 10080*Pkd2*gd2*k1**2*k2**5*s - 3696*Pkd2*gd2*k1**2*k2**5 - 135*Pkdd2*b1*fd*k1**6*k2**2*s**2 + 729*Pkdd2*b1*fd*k1**4*k2**4*s - 162*Pkdd2*b1*fd*k1**4*k2**4 - 162*Pkdd2*fd*k1**4*k2**4*s**2 + 216*Pkdd2*fd*k1**4*k2**4*s - 54*Pkdd2*fd*k1**4*k2**4 - 486*Pkdd2*fd*k1**2*k2**6*s**2 + 486*Pkdd2*fd*k1**2*k2**6*s - 108*Pkdd2*fd*k1**2*k2**6 - 168*Pkdd2*gd2*k1**4*k2**4*s**2 + 168*Pkdd2*gd2*k1**4*k2**4*s - 756*Pkdd2*gd2*k1**2*k2**6*s**2 + 504*Pkdd2*gd2*k1**2*k2**6*s - 3*bd1*k2**2*(k1**4*(4*Pk2*(-4*C*(-9*r*(2*s + 1) + s**2 + 13*s + 3) + 27*K*r*s - 12*K*r - 66*K*s**2 + 44*K*s + 12*K + b1*(2*r*(64*s + 33) + 128*s**2 - 79*s - 32) + 27*r**2 - 33*r*s + 37*r + 24*s**2 + 148*s - 92) - k2*(Pkd2*(16*C*r*(8*s + 3) + 24*C*(s**2 - 7*s - 1) + 4*K*(13*r*s + 2*r - 16*s**2 + 33*s - 2) + b1*(4*r*(64*s + 33) + 166*s**2 - 113*s - 64) - 152*r*s + 76*r - 104*s**2 + 276*s - 108) + Pkdd2*k2*s*(45*b1*(2*s - 1) + (s - 1)*(-48*C + 28*K + 22)))) + k1**2*k2**2*(2*Pk2*(4*C*(83*r**2 - 434*r*s - 97*r - 58*s**2 + 218*s + 10) - 630*K*r**2 - 476*K*r*s + 644*K*r - 504*K*s**2 + 196*K*s - 14*K + 14*b1*(16*r**2 + 17*r*(2*s - 1) - 27*s + 11) + 440*r**2 + 1804*r*s - 504*r + 704*s**2 - 907*s + 78) + k2*(Pkd2*(4*C*(6*r*(53*s - 19) + 177*s**2 - 233*s + 94) - 14*K*(116*r*s - 44*r + 87*s**2 - 120*s + 44) + 21*b1*(2*r*(4*s - 5) + 2*s**2 - 5*s + 6) - 208*r*s - 42*r - 118*s**2 + 4*s + 52) + Pkdd2*k2*s*(4*C*(s - 1) - 126*K*s + 84*K + 63*b1*(2*s - 1) + 12*s - 12))) + 4*k2**4*(Pk2*(C*(-104*r**2 + 66*r*s + 48*r - 48*s + 96) + 78*r**2 - 33*r*s - 51*r + 24*s - 48) + Pkd2*k2*(4*C - 2)*(r*(17*s - 5) - 6*s + 6))) + 12*bd2*k1**2*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + 7*k2**2*(2*Pk2*(8*r**2 + 2*r*(s - 4) + s*(5 - 6*s)) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)))) - 6*f*k2**2*(b1**2*k1**2*(7*Pkd2*bd1*k2**3*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + fd*(k1**2*(2*Pk2*(16*r*(8*s + 1) + 128*s**2 - 85*s - 16) - k2*(Pkd2*(16*r*(8*s + 1) + 83*s**2 - 85*s - 16) + 45*Pkdd2*k2*s**2)) + 7*k2**2*(2*Pk2*(16*r**2 + r*(34*s - 19) - 47*s + 9) + 3*k2*(Pkd2*(4*r*s + 7*r + s**2 + 10*s - 7) + 3*Pkdd2*k2*s**2)))) - b1*(7*bd1*(k1**4*(4*Pk2*(K*(8*r*s - 3*r + 2*s**2 - 5*s + 1) - 10*r*s + r - 4*s**2 + 9*s - 1) + k2*(Pkd2*(2*r*(-4*K*s + K + 6*s + 1) + s*(8*K*s - 2*K - 2*s - 7)) + Pkdd2*k2*s*(K*(2 - 4*s) + 2*s - 1))) + k1**2*k2**2*(Pk2*(8*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + K*(-36*r**2 + 4*r*(8*s + 29) + 88*s**2 - 86*s - 36) - 20*r**2 + 30*r*s - 62*r + 35*s + 20) + k2*(Pkd2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(36*r*s + 2*r + 78*s**2 - 101*s + 14) - 70*r*s + 15*r - 32*s**2 + 12*s + 4) + Pkdd2*k2*s*(9*K - 5)*(2*s - 1)))) + fd*(k1**4*(-2*Pk2*(-8*C*(r*(8 - 18*s) + s**2 + 18*s - 8) + K*(54*r*s - 83*r - 132*s**2 + 90*s - 12) + 54*r**2 - 66*r*s + 251*r + 48*s**2 + 344*s - 174) + k2*(2*Pkd2*(2*C*(r*(32*s - 21) + 6*s**2 - 37*s + 21) + K*(2*s - 1)*(13*r - 16*s + 29) - 76*r*s + 91*r - 52*s**2 + 107*s - 47) + Pkdd2*k2*(14*K*(2*s**2 - 3*s + 1) + s**2*(22 - 48*C) + 21*s - 7))) + k1**2*k2**2*(Pk2*(4*C*(-166*r**2 + r*(868*s + 7) + 116*s**2 - 739*s + 158) + 28*K*(45*r**2 + 34*r*s - 16*r + 36*s**2 - 28*s + 5) - 880*r**2 - 3608*r*s + 874*r - 1408*s**2 + 2817*s - 640) + k2*(Pkd2*(-4*C*(r*(318*s - 13) + 177*s**2 - 241*s + 13) + 7*K*(232*r*s - 130*r + 174*s**2 - 179*s + 46) + 208*r*s + 219*r + 118*s**2 - 338*s + 5) + Pkdd2*k2*(21*K*(6*s**2 - 7*s + 2) + s**2*(-4*C - 12)))) - 2*k2**4*(Pk2*(-2*C*(104*r**2 - 66*r*s - 200*r + 61*s + 88) + 156*r**2 - 66*r*s - 280*r + 61*s + 115) + Pkd2*k2*s*(8*C - 4)*(17*r - 12))) - 14*k1**2*(Pkd2*bd2*k2**3*s*(3*r + 3*s - 4) + 2*gd2*k1**2*(2*Pk2*(r*(4*s - 1) + s**2 - 4*s + 1) + k2*s*(-2*Pkd2*r + 2*Pkd2*s + Pkd2 - Pkdd2*k2*s)) + gd2*k2**2*(-2*Pk2*(9*r**2 - r*(8*s + 27) - 22*s**2 + 21*s + 18) + k2*(Pkd2*(-18*r*s + 14*r - 39*s**2 + 62*s - 14) + 9*Pkdd2*k2*s**2)))) + 2*k1**2*(b2*(7*Pkd2*bd1*k2**3*(3*r*s + r + s*(3*s - 3)) - fd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + 7*k2**2*(2*Pk2*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 3*Pkd2*k2*(r*(16*s - 9) + 16*s**2 - 18*s + 5)))) + g2*(14*bd1*k1**2*(2*Pk2*(r*(4*s - 2) + s*(s - 1)) + k2*(Pkd2*(-2*r*s + r + s*(2*s - 2)) - Pkdd2*k2*s*(s - 1))) + 7*bd1*k2**2*(Pk2*(-18*r**2 + 2*r*(8*s + 31) + s*(44*s - 44)) + k2*(-2*Pkd2*r*(9*s + 8) - 39*Pkd2*s*(s - 1) + 9*Pkdd2*k2*s*(s - 1))) - 2*fd*k1**2*(Pk2*(54*r*s - 83*r - 132*s**2 + 90*s - 12) + k2*(2*s - 1)*(Pkd2*(-13*r + 16*s - 29) - 7*Pkdd2*k2*(s - 1))) + 7*fd*k2**2*(4*Pk2*(45*r**2 + 2*r*(17*s - 8) + 36*s**2 - 28*s + 5) + k2*(Pkd2*(232*r*s - 130*r + 174*s**2 - 179*s + 46) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))))) + Dd*f*(-42*b1*k1**2*k2**2*(Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 2*Pkd2*b2*k2**3*(12*r*s + r + s*(12*s - 11)) + b1*(k1**2*(-4*Pk2*(K*(16*r*s - 6*r + 4*s**2 - 13*s + 4) - 20*r*s + 4*r - 8*s**2 + 20*s - 4) + k2*(2*Pkd2*r*(K*(8*s - 1) - 12*s - 1) + Pkd2*s*(s*(4 - 16*K) + 15) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) + k2**2*(-2*Pk2*(4*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) + K*(-36*r**2 + 32*r*s + 81*r + 88*s**2 - 108*s - 14) - 20*r**2 + 30*r*s - 24*r + 65*s - 3) + k2*(Pkd2*(-8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + K*(72*r*s - 50*r + 156*s**2 - 239*s + 66) + 140*r*s + 15*r + 64*s**2 + 20*s - 34) - Pkdd2*k2*s*(9*K - 5)*(4*s - 1)))) + 2*g2*(2*k1**2*(2*Pk2*(2*r*(8*s - 3) + 4*s**2 - 13*s + 4) + k2*(Pkd2*(-8*r*s + r + 8*s**2) + Pkdd2*k2*s*(1 - 4*s))) + k2**2*(-2*Pk2*(36*r**2 - r*(32*s + 81) - 88*s**2 + 108*s + 14) + k2*(Pkd2*(-72*r*s + 50*r - 156*s**2 + 239*s - 66) + 9*Pkdd2*k2*s*(4*s - 1))))) + f**3*k1**4*(5*k1**2*(4*s - 1)*(8*Pk2*(33*s - 16) + k2*(Pkd2*(50 - 93*s) + 3*Pkdd2*k2*(3*s - 2))) + 216*k2**2*(Pk2*(20*r**2 + 2*r*(4*s - 7) - 20*s**2 + s + 2) + Pkd2*k2*(12*r*(2*s - 1) + 20*s**2 - 25*s + 8))) - f**2*(45*b1*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) - 2*k1**4*k2**2*(-4*Pk2*(C*(84*r*s - 185*r - 648*s**2 + 322*s + 42) + 54*b1*(12*r**2 - 2*r*(8*s + 5) - 24*s**2 + 18*s + 1) + 102*r**2 - 144*r*s + 308*r + 360*s**2 + 96*s - 208) + 3*k2*(-Pkd2*(4*C*(-12*r*s + r + 72*s**2 - 82*s + 17) + 3*b1*(r*(320*s - 66) + 288*s**2 - 208*s + 27) + 2*r*(96*s - 55) - 48*s**2 + 34) + 3*Pkdd2*k2*(9*b1 + (4*C - 3)*(s - 1))*(4*s - 1))) - 2*k1**2*k2**4*(-2*Pk2*(C*(-4440*r**2 + 6120*r*s + 2572*r - 5460*s + 424) + 18*b1*(96*r**2 + 2*r*(132*s - 65) + 140*s**2 - 199*s + 49) + 4140*r**2 - 738*r*s - 3045*r + 936*s**2 + 1593*s + 123) + 3*k2*(Pkd2*(2*C*(1344*r*s - 628*r + 804*s**2 - 1153*s + 384) - 12*b1*(14*r*(4*s - 3) + 40*s**2 - 54*s + 25) - 1740*r*s + 847*r - 972*s**2 + 1423*s - 501) + Pkdd2*k2*(18*C - 9)*(12*s**2 - 11*s + 2))) - 24*k2**6*(Pk2*(C*(264*r**2 - 4*r*(78*s + 59) + 276*s + 22) - 144*r**2 + 4*r*(39*s + 31) - 138*s - 11) + Pkd2*k2*(24*C - 12)*(2*r - 1)*(2*s - 1))) - 3*f*k2**2*(b1**2*k1**2*(k1**2*(8*Pk2*(r*(128*s + 41) + 128*s**2 - 82*s - 24) + k2*(Pkd2*(-4*r*(128*s + 41) - 332*s**2 + 283*s + 96) + 45*Pkdd2*k2*s*(1 - 4*s))) + 7*k2**2*(8*Pk2*(16*r**2 + 2*r*(17*s - 9) - 37*s + 10) + 3*k2*(Pkd2*(16*r*s + 4*r + 4*s**2 + 15*s - 8) + 3*Pkdd2*k2*s*(4*s - 1)))) + 2*b1*(k1**4*(2*Pk2*(4*C*(r*(72*s - 4) - 4*s**2 - 67*s + 10) + K*(108*r*s - 107*r - 264*s**2 + 178*s + 12) + 108*r**2 - 132*r*s + 343*r + 96*s**2 + 640*s - 348) + k2*(-2*Pkd2*(2*C*(r*(64*s - 15) + 12*s**2 - 77*s + 18) + K*(52*r*s - 9*r - 64*s**2 + 140*s - 33) - 152*r*s + 138*r - 104*s**2 + 234*s - 102) - Pkdd2*k2*(4*s - 1)*(14*K*(s - 1) + s*(11 - 24*C) + 7))) + k1**2*k2**2*(4*Pk2*(C*(332*r**2 - r*(1736*s + 257) - 232*s**2 + 1420*s - 78) - 14*K*(45*r**2 + 34*r*s - 31*r + 36*s**2 - 21*s + 3) + 440*r**2 + 1804*r*s - 440*r + 704*s**2 - 1298*s + 165) + k2*(Pkd2*(2*C*(6*r*(212*s - 25) + 708*s**2 - 1033*s + 130) - 7*K*(464*r*s - 218*r + 348*s**2 - 419*s + 134) - 416*r*s - 328*r - 236*s**2 + 487*s + 109) + Pkdd2*k2*(4*s - 1)*(K*(42 - 63*s) + s*(2*C + 6)))) + 4*k2**4*(Pk2*(-2*C*(104*r**2 - 2*r*(33*s + 85) + 61*s + 52) + 156*r**2 - 66*r*s - 250*r + 61*s + 79) + Pkd2*k2*(2*C - 1)*(r*(68*s - 5) - 48*s + 6))) + 4*k1**2*(-b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) - 7*b2*k2**2*(2*Pk2*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 3*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) - 2*g2*k1**2*(Pk2*(r*(108*s - 107) - 264*s**2 + 178*s + 12) + k2*(Pkd2*(-52*r*s + 9*r + 64*s**2 - 140*s + 33) - 7*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 7*g2*k2**2*(8*Pk2*(45*r**2 + r*(34*s - 31) + 36*s**2 - 21*s + 3) + k2*(Pkd2*(464*r*s - 218*r + 348*s**2 - 419*s + 134) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2)))))))/(315*d**2*k1*k2**3*k3**4) - D1**3*Pk3*ct*(D1*(-42*b1*fd*k2**2*(2*b1**2*k1**2*k2*(r + s - 1)*(10*Pk2*k2*(3*r + s - 3) + 4*Pkd2*k1**2*s + 5*Pkd2*k2**2*s) + b1*(Pk2*k2**4*(8 - 16*C)*(r - 1)*(3*r - 2*s - 3) - 2*k1**4*(2*Pk2*(12*r**2 + r*s*(8*C - 12*K + 27) + s*(8*C*(s - 1) - 7*K*s + 10*s + 8)) + Pkd2*k2*s*(-20*C*(r - 1) - 4*K*r - 13*K*s + 15*r + 12*s - 10)) + k1**2*k2**2*(Pk2*(-64*C*(2*r**2 - r*(7*s + 4) + s**2 + 7*s + 2) + 10*K*(19*r**2 + 28*r*s + 12*r + 12*s**2 + 20*s - 10) - 24*r**2 - 339*r*s - 232*r - 10*s**2 + 124*s + 126) + k2*(5*K*(Pkd2*(18*r*s + 2*r + 17*s**2 + 4*s - 2) + Pkdd2*k2*s**2) - Pkd2*s*(-8*C*(3*r - 2*s - 3) + 37*r + 7*s - 12)))) - 2*k1**2*(-b2*k2*(r + s)*(40*Pk2*k2*(r + s) + 4*Pkd2*k1**2*s + 15*Pkd2*k2**2*s) + g2*(4*Pk2*k1**2*s*(12*r + 7*s) + 10*Pk2*k2**2*(19*r**2 + 28*r*s + 12*r + 12*s**2 + 20*s - 10) + 2*Pkd2*k1**2*k2*s*(4*r + 13*s) + 5*Pkd2*k2**3*(18*r*s + 2*r + 17*s**2 + 4*s - 2) + 5*Pkdd2*k2**4*s**2))) + f**3*k1**4*(-9*bd1*k2*(-5*Pkd2*k1**2*s*(s - 1) + 4*Pkd2*k2**2*(14*r*(2*s + 1) + 5*s - 14) + k2*(4*Pk2*(70*r**2 + 16*r*(s - 8) - 36*s**2 - 11*s + 58) + 5*Pkdd2*k1**2*s*(s - 1))) + 20*fd*k1**2*(7*Pk2 - 4*Pkd2*k2)*(12*s**2 - 11*s + 2)) + 3*f**2*k2*(bd1*k2*(k1**4*(4*Pk2*(-4*C*(4*r*(32*s - 9) + 33*s**2 - 86*s + 18) - 91*K*r*s - 98*K*s**2 + 42*K*s + 7*b1*(72*r**2 + 2*r*(48*s - 53) + 24*s**2 - 59*s + 30) + 165*r**2 + 777*r*s - 387*r + 323*s**2 - 533*s + 154) + k2*(Pkd2*(-24*C*(r*(8*s - 4) + 23*s**2 - 25*s + 2) - 84*K*r*s + 84*K*r - 280*K*s**2 + 364*K*s - 84*K + 21*b1*(r*(64*s - 4) + 50*s**2 - 51*s + 4) + 180*r*s - 48*r + 590*s**2 - 614*s + 24) + 63*Pkdd2*b1*k2*s*(2*s - 1))) - 2*k1**2*k2**2*(Pk2*(4*C*(597*r**2 + 608*r*s - 627*r + 224*s**2 - 432*s + 138) + 224*K*r**2 + 1022*K*r*s - 434*K*r + 756*K*s**2 - 714*K*s + 210*K - 14*b1*(122*r**2 + r*(134*s - 161) + 30*s**2 - 80*s + 49) - 1844*r**2 - 2079*r*s + 1986*r - 602*s**2 + 1190*s - 448) + k2*(Pkd2*(C*(12*r*(69*s - 17) + 658*s**2 - 718*s + 60) + 14*K*(5*r*(s - 1) + 12*s**2 - 13*s + 5) - 3*r*s*(140*b1 + 173) + 123*r - 3*s**2*(56*b1 + 126) + 3*s*(98*b1 + 136) - 30) + Pkdd2*k2*s*(42*C - 21)*(s - 1))) - 4*k2**4*(Pk2*(2*C*(68*r**2 - 49*r*s + 8*r + 28*s - 28) - 75*r**2 + 49*r*s - 8*r - 28*s + 28) + Pkd2*k2*r*s*(28*C - 14))) - k1**2*(3*fd*(-15*b1*k1**4*s**2*(Pkd2 - Pkdd2*k2) + 2*k1**2*k2*(2*Pk2*(2*C*(3*s - 1)*(21*r + 22*s - 10) + b1*(210*r**2 + 16*r*(3*s - 13) - 108*s**2 + 55*s + 30) - 15*r**2 - 144*r*s + 53*r - 117*s**2 + 108*s - 23) + Pkd2*k2*(2*b1*(42*r*(2*s + 1) + 11*s - 32) + (s - 1)*(12*C*(5*r + 16*s - 7) - 30*r - 129*s + 53))) + 4*k2**3*(Pk2*(4*C*(42*r**2 + 174*r*s - 98*r + 117*s**2 - 145*s + 44) - 105*r**2 - 402*r*s + 221*r - 234*s**2 + 290*s - 88) + Pkd2*k2*(6*C - 3)*(9*r*(s - 1) + 18*s**2 - 21*s + 7))) + 28*k2*(bd2*(2*Pk2*k1**2*s*(3*r + 3*s - 1) + 8*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + 3*Pkd2*k1**2*k2*(s - 1)*(r + s - 1)) - 2*gd2*(Pk2*k1**2*s*(13*r + 14*s - 6) + Pk2*k2**2*(16*r**2 + r*(73*s - 31) + 54*s**2 - 51*s + 15) + Pkd2*k1**2*k2*(s - 1)*(3*r + 10*s - 3) + Pkd2*k2**3*(5*r*(s - 1) + 12*s**2 - 13*s + 5))))) - 6*f*k2**2*(-7*b1**2*k1**2*(-bd1*k2*(20*Pk2*k2*(9*r**2 + 2*r*(6*s - 7) + 3*s**2 - 9*s + 5) + 4*Pkd2*k1**2*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 5*Pkd2*k2**2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + fd*(k1**2*(2*Pk2*(72*r**2 + 4*r*(24*s - 25) + 24*s**2 - 53*s + 38) + 3*k2*(Pkd2*(32*r*s + 4*r + 25*s**2 - 15*s - 4) + 3*Pkdd2*k2*s**2)) + 2*k2**2*(Pk2*(122*r**2 + 134*r*s - 123*r + 30*s**2 - 57*s + 29) + 3*Pkd2*k2*s*(10*r + 4*s - 5)))) + b1*(-7*bd1*(Pk2*k2**4*(16*C - 8)*(6*r**2 - r*(4*s + 5) + 2*s - 1) + 2*k1**4*(2*Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 14*K*s**2 + 13*K*s + 24*r**2 + r*(-24*K*s + 6*K + 54*s - 28) + 20*s**2 - 17*s - 4) + Pkd2*k2*(-10*C*(r*(4*s - 1) - 2*s + 1) - 26*K*s**2 + 15*K*s + r*(-8*K*s + 2*K + 30*s - 5) + 24*s**2 - 27*s + 5)) + k1**2*k2**2*(Pk2*(32*C*(8*r**2 - r*(28*s + 1) + 4*s**2 + 12*s - 7) - 10*K*(38*r**2 + 56*r*s - 38*r + 24*s**2 - 17*s - 2) + 48*r**2 + 678*r*s - 150*r + 20*s**2 - 229*s + 92) + k2*(5*K*Pkdd2*k2*s*(1 - 2*s) + Pkd2*(4*C*(r*(3 - 12*s) + 8*s**2 + 2*s - 3) - 5*K*(36*r*s - 2*r + 34*s**2 - 27*s - 2) + 74*r*s - 11*r + 14*s**2 - 39*s + 6)))) + fd*(k1**4*(2*Pk2*(4*C*(r*(256*s - 35) + 66*s**2 - 163*s + 35) + 7*K*(2*s - 1)*(13*r + 14*s - 6) - 330*r**2 - 1554*r*s + 477*r - 646*s**2 + 945*s - 205) + Pkd2*k2*(28*K*(s - 1)*(3*r + 10*s - 5) + s**2*(552*C - 590) + s*(192*C*r - 96*C - 180*r + 237) - 49)) + k1**2*k2**2*(Pk2*(4*C*(1194*r**2 + r*(1216*s - 1005) + 448*s**2 - 223*s + 148) + 28*K*(16*r**2 + 73*r*s - 44*r + 54*s**2 - 63*s + 18) - 3688*r**2 - 4158*r*s + 2932*r - 1204*s**2 + 805*s - 348) + 2*k2*(Pkd2*(C*(12*r*(69*s + 7) + 658*s**2 - 204*s - 84) + 14*K*(5*r*s - 5*r + 12*s**2 - 14*s + 4) - 519*r*s - 42*r - 378*s**2 + 144*s + 42) + Pkdd2*k2*s**2*(42*C - 21))) + 2*k2**4*(Pk2*(2*C*(136*r**2 - 2*r*(49*s + 68) + 63*s + 34) - 150*r**2 + 98*r*s + 143*r - 63*s - 34) + Pkd2*k2*s*(28*C - 14)*(2*r - 1))) - 14*k1**2*(-bd2*k2*(40*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k1**2*s*(2*r + 2*s - 1) + 5*Pkd2*k2**2*s*(3*r + 3*s - 2)) + gd2*(4*Pk2*k1**2*s*(12*r + 7*s - 6) + 10*Pk2*k2**2*(19*r**2 + 28*r*s - 17*r + 12*s**2 - 5*s - 2) + 2*Pkd2*k1**2*k2*s*(4*r + 13*s - 2) + 5*Pkd2*k2**3*(18*r*s + 2*r + 17*s**2 - 10*s - 2) + 5*Pkdd2*k2**4*s**2))) + 14*k1**2*(b2*(bd1*k2*(40*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + 5*Pkd2*k2**2*(r*(3*s - 1) + s*(3*s - 3))) + fd*(8*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(2*Pk2*(2*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)))) - g2*(bd1*k1**2*(4*Pk2*(6*r*(2*s - 1) + s*(7*s - 7)) + 2*Pkd2*k2*(r*(4*s - 2) + s*(13*s - 13))) + 5*bd1*k2**2*(Pk2*(38*r**2 + 14*r*(4*s - 3) + s*(24*s - 24)) + k2*(2*Pkd2*r*(9*s - 2) + 17*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + 2*fd*k1**2*(Pk2*(2*s - 1)*(13*r + 14*s - 6) + 2*Pkd2*k2*(s - 1)*(3*r + 10*s - 5)) + 4*fd*k2**2*(Pk2*(16*r**2 + r*(73*s - 44) + 54*s**2 - 63*s + 18) + Pkd2*k2*(5*r*(s - 1) + 12*s**2 - 14*s + 4)))))) + Dd*f*(-42*b1*k2**2*(b1**2*k1**2*k2*(20*Pk2*k2*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + 4*Pkd2*k1**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 5*Pkd2*k2**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - b1*(Pk2*k2**4*(16*C - 8)*(12*r**2 - r*(8*s + 17) + 6*s + 5) + 2*k1**4*(2*Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*K*s**2 + 19*K*s + 48*r**2 + r*(-48*K*s + 6*K + 108*s - 40) + 40*s**2 - 16*s - 4) + Pkd2*k2*(-10*C*(r*(8*s - 1) - 6*s + 1) - 52*K*s**2 + 17*K*s + r*(-16*K*s + 2*K + 60*s - 5) + 48*s**2 - 52*s + 5)) + k1**2*k2**2*(2*Pk2*(16*C*(16*r**2 - r*(56*s + 17) + 8*s**2 + 40*s + 1) - 5*K*(76*r**2 + 112*r*s - 43*r + 48*s**2 - 2*s - 14) + 48*r**2 + 678*r*s + 77*r + 20*s**2 - 286*s - 65) + k2*(5*K*Pkdd2*k2*s*(1 - 4*s) + Pkd2*(C*(r*(12 - 96*s) + 64*s**2 + 56*s - 12) - 5*K*(72*r*s + 2*r + 68*s**2 - 33*s - 6) + 148*r*s - 11*r + 28*s**2 - 83*s + 6)))) + 2*k1**2*(b2*k2*(40*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*Pkd2*k1**2*(r*(8*s - 1) + 4*s*(2*s - 1)) + 5*Pkd2*k2**2*(r*(12*s - 1) + s*(12*s - 7))) + g2*(4*Pk2*k1**2*(r*(6 - 48*s) + s*(19 - 28*s)) - 10*Pk2*k2**2*(76*r**2 + r*(112*s - 43) + 48*s**2 - 2*s - 14) + 2*Pkd2*k1**2*k2*(r*(2 - 16*s) + s*(17 - 52*s)) - 5*Pkd2*k2**3*(r*(72*s + 2) + 68*s**2 - 33*s - 6) + 5*Pkdd2*k2**4*s*(1 - 4*s)))) + 20*f**3*k1**6*(7*Pk2 - 4*Pkd2*k2)*(12*s**2 - 11*s + 2) - 9*f**2*k1**2*k2*(-5*b1*k1**4*s*(Pkd2 - Pkdd2*k2)*(4*s - 1) + 2*k1**2*k2*(2*Pk2*(2*C*(4*s - 1)*(21*r + 22*s - 10) + 4*b1*(70*r**2 + 4*r*(4*s - 21) - 36*s**2 + 11*s + 22) - 20*r**2 - 192*r*s + 58*r - 156*s**2 + 131*s - 23) + Pkd2*k2*(4*b1*(28*r*(2*s + 1) + 8*s - 23) + (s - 1)*(8*C*(10*r + 32*s - 13) - 40*r - 172*s + 63))) + 8*k2**3*(Pk2*(2*C*(56*r**2 + 232*r*s - 125*r + 156*s**2 - 189*s + 57) - 70*r**2 - 268*r*s + 141*r - 156*s**2 + 189*s - 57) + Pkd2*k2*(6*C - 3)*(6*r*(s - 1) + 12*s**2 - 14*s + 5))) + 3*f*k2**2*(7*b1**2*k1**2*(k1**2*(8*Pk2*(72*r**2 + r*(96*s - 103) + 24*s**2 - 56*s + 34) + 3*k2*(Pkd2*(128*r*s + 4*r + 100*s**2 - 81*s - 4) + 3*Pkdd2*k2*s*(4*s - 1))) + 4*k2**2*(Pk2*(244*r**2 + 4*r*(67*s - 71) + 60*s**2 - 137*s + 78) + 12*Pkd2*k2*s*(5*r + 2*s - 3))) - 2*b1*(k1**4*(2*Pk2*(4*C*(r*(512*s - 71) + 132*s**2 - 359*s + 53) + 7*K*(4*s - 1)*(13*r + 14*s - 6) - 660*r**2 - 3108*r*s + 1101*r - 1292*s**2 + 2059*s - 431) + Pkd2*k2*(12*C*(4*r*(8*s - 1) + 92*s**2 - 39*s + 2) + 56*K*(s - 1)*(3*r + 10*s - 4) - 360*r*s + 24*r - 1180*s**2 + 671*s - 61)) + k1**2*k2**2*(2*Pk2*(2*C*(2388*r**2 + 19*r*(128*s - 131) + 896*s**2 - 1034*s + 546) + 14*K*(32*r**2 + 146*r*s - 75*r + 108*s**2 - 114*s + 33) - 3688*r**2 - 4158*r*s + 3716*r - 1204*s**2 + 1568*s - 733) + k2*(Pkd2*(2*C*(24*r*(69*s + 1) + 1316*s**2 - 821*s - 96) + 280*K*r*(s - 1) + 84*K*(8*s**2 - 9*s + 3) - 2076*r*s - 3*r - 1512*s**2 + 1038*s + 96) + Pkdd2*k2*s*(42*C - 21)*(4*s - 1))) + 4*k2**4*(Pk2*(2*C*(136*r**2 - 98*r*s - 115*r + 63*s + 20) - 150*r**2 + 98*r*s + 122*r - 63*s - 20) + Pkd2*k2*s*(28*C - 14)*(2*r - 1))) - 28*k1**2*(8*Pk2*b2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + b2*k1**2*(2*Pk2*(4*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) - 2*g2*k1**2*(Pk2*(4*s - 1)*(13*r + 14*s - 6) + 4*Pkd2*k2*(s - 1)*(3*r + 10*s - 4)) - 4*g2*k2**2*(Pk2*(32*r**2 + 146*r*s - 75*r + 108*s**2 - 114*s + 33) + Pkd2*k2*(10*r*(s - 1) + 24*s**2 - 27*s + 9))))))/(315*d**2*k1*k2**3*k3**4) + 16*D1**3*Pk3*f**3*k1**2*k2**2*st**8*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(99*d**2*k3**6) - 2*D1**3*Pk3*f**3*k1**2*st**8*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd + Dd*f)/(99*d**2*k3**4) - 4*D1**3*Pk3*f*st**6*(D1*(f**2*(-198*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) + 11*bd1*k1**2*k2**2*(2*Pk2*(21*r**2 + r*(15*s - 26) - 6*s**2 - 5*s + 3) + Pkd2*k2*(r*(27*s - 2) + 27*s**2 - 23*s + 4)) + fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(189*r + 189*s - 139) + 22*fd*k1**2*k2**2*(Pk2*(16*r**2 - r*(80*s + 17) - 96*s**2 + 78*s + 1) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 11*f*k2**2*(b1*fd*(18*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(-6*Pk2*(21*r**2 + 15*r*s - 16*r - 6*s**2 - s + 3) + Pkd2*k2*(-81*r*s + 39*r - 81*s**2 + 84*s - 23))) + 2*k2**2*(18*Pk2*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 9*bd1*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + 2*fd*(Pk2*(2*C*(9*r + 3*s - 4) - 12*r - 3*s + 5) + Pkd2*k2*(2*C - 1)*(3*s - 1))*(3*r + 3*s - 2) - 18*gd2*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 396*fd*k2**4*(2*r + 2*s - 1)*(K*b1*(-6*Pk2*r - 2*Pk2*s + Pk2 - 2*Pkd2*k2*s + Pkd2*k2) + 2*Pk2*b1*r + Pk2*b2*(-2*r - 2*s + 1) + 2*Pk2*g2*(6*r + 2*s - 1) + 2*Pkd2*g2*k2*(2*s - 1))) + Dd*f*(f**2*k1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(189*r + 189*s - 139) + 22*k2**2*(Pk2*(16*r**2 - r*(80*s + 17) - 96*s**2 + 78*s + 1) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 11*f*k2**2*(b1*(-18*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(4*Pk2*(42*r**2 + 30*r*s - 37*r - 12*s**2 - 4*s + 6) + Pkd2*k2*(108*r*s - 41*r + 108*s**2 - 107*s + 27))) - 2*k2**2*(Pk2*(4*C*(36*r**2 + 48*r*s - 44*r + 12*s**2 - 27*s + 13) - 96*r**2 - 120*r*s + 115*r - 24*s**2 + 64*s - 33) + Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 396*k2**4*(Pk2*b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + b1*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1)) - 2*g2*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(693*d**2*k3**6) + D1**3*Pk3*f*st**6*(-3*D1*bd1*f*(6*K*Pkdd2*k2**4*s*(1 - 2*s) + 48*Pk2*f*k1**2*s*(3*s - 1) + 18*Pkd2*f*k1**2*k2*s*(1 - 3*s) + 3*Pkd2*k2**3*(f*(r - 1)*(3*s - 2) + r*(8*s - 2) + (4*s - 2)*(5*K*s - 1)) + k2**2*(-3*Pk2*(f*(r - 1)*(7*s - 6) + 8*r*(4*s - 1) + (16*s - 8)*(2*K*s - 1)) + 2*Pkdd2*f*k1**2*s*(3*s - 1))) - 3*b1*(D1*fd*(f*(2*k1**2*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + 3*k2**2*(Pk2*(r*(10 - 21*s) - 9*s + 2) + Pkd2*k2*(r*(9*s - 4) + s))) - 6*k2**2*(2*s - 1)*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + r*(16*Pk2 - 4*Pkd2*k2))) + 2*Dd*f*(f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + 3*k2**2*(-Pk2*(2*r*(7*s - 4) + s + 2) + Pkd2*k2*(r*(6*s - 3) - s + 1))) - 3*k2**2*(8*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-5*K*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 4*s - 2))))) + 2*k2**2*(D1*(2*C*f*fd*(1 - 3*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 9*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(bd2 - 2*gd2)*(2*s - 1) - fd*(f*(3*s - 1)*(24*Pk2*(-r + s) + 3*Pkd2*k2*(2*r - 5*s + 1) + Pkdd2*k2**2*(3*s - 1)) + 18*g2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)))) + Dd*f*(f*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 24*s**2 + 4*s + 1) + k2*(Pkd2*(-10*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 60*s**2 - 25*s + 2) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) - 18*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1)) + 9*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(63*d**2*k2**2*k3**2) + D1**3*Pk3*f*st**6*(D1*(f**2*(792*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 22*bd1*k1**2*k2**2*(4*Pk2*(r*(39*s - 8) + 27*s**2 - 35*s + 6) - k2*(Pkd2*(39*r*s - 8*r + 9*s**2 - 35*s + 6) + 6*Pkdd2*k2*s**2)) + 99*bd1*k2**4*(r - 1)*(Pk2*(-4*r - 15*s + 10) + Pkd2*k2*(3*s - 2)) - 18*fd*k1**4*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + 22*fd*k1**2*k2**2*(3*Pk2*(6*r*(15*s - 4) + 96*s**2 - 77*s + 14) + k2*(-9*Pkd2*(10*r*s - 3*r + 12*s**2 - 10*s + 2) + Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 11*f*k2**2*(-3*b1*fd*(8*Pk2*k1**2*(13*r*(3*s - 1) + 27*s**2 - 28*s + 7) + 3*Pk2*k2**2*(3*r - 1)*(4*r + 15*s - 10) - 3*Pkd2*k2**3*(r*(9*s - 4) + s) - 2*k1**2*k2*(Pkd2*(13*r*(3*s - 1) + 9*s**2 - 10*s + 4) + Pkdd2*k2*(6*s**2 - 6*s + 1))) - 2*k2**2*(4*Pk2*fd*(C*(9*r**2 + r*(18 - 72*s) - 36*s**2 + 48*s - 11) - 18*r**2 + 36*r*s + 18*s**2 - 24*s + 4) + 9*bd1*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1)) - 18*bd2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*k2*(3*s - 1)*(Pkd2*(2*C*(24*r + 9*s - 11) - 30*r - 9*s + 13) + Pkdd2*k2*(2*C - 1)*(3*s - 1)) - 18*gd2*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 198*fd*k2**4*(-b1*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2))) + 4*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + 2*g2*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))))) - 2*Dd*f*(f**2*(-396*Pk2*k2**4*(2*r**2 - 3*r + 1) + 9*k1**4*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) - 11*k1**2*k2**2*(3*Pk2*(6*r*(15*s - 4) + 96*s**2 - 77*s + 14) + k2*(-9*Pkd2*(10*r*s - 3*r + 12*s**2 - 10*s + 2) + Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 11*f*k2**2*(8*Pk2*k2**2*(C*(6*r**2 + r*(9 - 48*s) - 24*s**2 + 34*s - 7) - 12*r**2 + 3*r*(8*s + 1) + 12*s**2 - 17*s + 2) + b1*k1**2*(4*Pk2*(r*(156*s - 47) + 108*s**2 - 119*s + 27) - k2*(Pkd2*(156*r*s - 47*r + 36*s**2 - 65*s + 18) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) - 9*b1*k2**2*(-Pk2*(2*r - 1)*(4*r + 15*s - 10) + Pkd2*k2*(r*(6*s - 3) - s + 1)) + k2**3*(Pkd2*(2*C*(96*r*s - 28*r + 36*s**2 - 61*s + 15) - 120*r*s + 35*r - 36*s**2 + 71*s - 18) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) + 99*k2**4*(b1*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1)) - 4*b2*(2*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 2*g2*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(693*d**2*k2**2*k3**4) + D1**3*Pk3*st**4*(2*D1*bd1*f*(f*(4*Pk2*(r*(4*s - 1) + s*(8*C*s - 4*C - 4*s + 1)) + k2*(Pkd2*(-4*r*s + r + 2*s*(-10*C*s + 5*C + 5*s - 2)) + Pkdd2*k2*s*(2*C - 1)*(2*s - 1))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(7*b2 - 14*g2)*(s - 1)) + 7*b1**2*(D1*fd*(f*(Pk2*(2*r*(s - 2) + 7*s - 2) - Pkd2*k2*(2*r*(s - 1) + s)) + (s - 1)*(2*K*(s - 1)*(8*Pk2 - 5*Pkd2*k2 + Pkdd2*k2**2) + 16*Pk2*r - 4*Pkd2*k2*r)) + 2*Dd*f*(K*Pkdd2*k2**2*(4*s**2 - 5*s + 1) + Pk2*f*(2*r*(s - 4) + 7*s + 2) + 4*Pk2*(2*K*(4*s**2 - 5*s + 1) + r*(8*s - 5) - 2*s + 2) - Pkd2*k2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2))) + b1*(7*D1*bd1*f*(4*K*Pkdd2*k2**2*s*(s - 1) + Pk2*f*(2*r*(s - 6) + 7*s + 6) + 8*Pk2*(r*(4*s - 2) + (s - 1)*(4*K*s - 1)) - Pkd2*k2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1))) + 2*D1*(2*C*f*fd*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 7*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(bd2 - 2*gd2)*(s - 1) - fd*(f*(2*s - 1)*(16*Pk2*(-r + s) + Pkd2*k2*(4*r - 10*s + 3) + Pkdd2*k2**2*(2*s - 1)) + 14*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2)) + 2*Dd*f*(f*(4*Pk2*(4*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r - 16*s**2 + 4*s + 1) + k2*(-2*Pkd2*(5*C*(8*s**2 - 6*s + 1) + 8*r*s - 3*r - 20*s**2 + 11*s - 1) + Pkdd2*k2*(2*C - 1)*(8*s**2 - 6*s + 1))) - 14*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 14*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(35*d**2*k2**2) + D1**3*Pk3*st**2*(-21*b1**3*k2*(D1*fd*s*(15*Pk2*k2*(r - 1) + 2*Pkd2*k1**2*s + 5*Pkd2*k2**2*(r - 1) - 2*Pkdd2*k1**2*k2*s) + 2*Dd*f*(Pkd2*k1**2*s*(4*s - 1) + 5*Pkd2*k2**2*(r*(2*s - 1) - 3*s + 1) + k2*s*(15*Pk2*(2*r - 1) + Pkdd2*k1**2*(1 - 4*s)))) + 21*b1**2*(D1*(bd1*f*k2*(2*Pkd2*k1**2*s*(1 - 3*s) - 5*Pkd2*k2**2*(r*(3*s - 2) - 5*s + 2) + k2*s*(Pk2*(15 - 45*r) + 2*Pkdd2*k1**2*(3*s - 1))) + fd*(k1**2*(Pk2*f*(36*r*s + 64*s**2 + s - 8) - 4*Pk2*(K*(s - 1)**2 - s*(2*r - 2) - 1) + f*k2*(-Pkd2*(40*s**2 + s*(12*r + 11) - 6) + 2*Pkdd2*k2*(4*s**2 + 3*s - 1)) + 2*k2*s*(K*Pkdd2*k2*s + Pkd2*(-K*s - 2*r + s))) - 2*k2**2*(Pk2*(4*C*(r - 1)**2 - 10*K*r**2 + 35*K*r*s - 20*K*r + f*(-40*r**2 + 41*r - 8) - 4*r**2 + 18*r - 4) + k2*(8*C*Pkd2*r*s + 6*C*Pkd2*s**2 - 8*C*Pkd2*s + 2*C*Pkdd2*k2*s**2 - 5*K*(Pkd2*r*(3*s - 4) - 2*Pkd2*s + Pkd2 + Pkdd2*k2*(1 - 2*s)) + 5*Pkd2*f*(1 - 2*r) - 6*Pkd2*r*s - 10*Pkd2*r - 3*Pkd2*s**2 + 6*Pkd2*s - Pkdd2*k2*s**2)))) + 2*Dd*f*(k1**2*(-2*Pk2*(4*K*s**2 - 5*K*s + K + f*(-6*r*(3*s + 1) - 32*s**2 + 5*s + 6) - 8*r*s + r + 6*s - 1) + k2*(K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(-8*r*s + r + s*(-4*K*s + K + 4*s + 1)) - f*(Pkd2*(12*r*s + 6*r + 40*s**2 - 7) + Pkdd2*k2*(-8*s**2 - 2*s + 1)))) + k2**2*(2*Pk2*(-4*C*(2*r**2 - 3*r + 1) + 20*K*r**2 - 70*K*r*s + 15*K*s + f*(40*r**2 - 46*r + 13) + 8*r**2 - 12*r + 4) + k2*(Pkd2*(C*(-32*r*s + 4*r - 24*s**2 + 30*s - 4) + 60*K*r*s - 40*K*r - 50*K*s + 25*K + 20*f*r - 10*f + 24*r*s + 17*r + 12*s**2 - 21*s - 7) - Pkdd2*k2*(5*K + s*(2*C - 1))*(4*s - 1))))) + 3*b1*(7*D1*bd1*f*(-4*Pk2*k1**2*(2*K*s*(s - 1) - 4*r*s + r + 2*s) - 2*Pkd2*k1**2*k2*(r*(4*s - 1) + s*(K*(2*s - 1) - 2*s)) - 2*Pkd2*k2**3*(2*C*(r*(8*s - 2) + 6*s**2 - 7*s + 2) - 10*K*(3*r*s - r - 2*s + 1) - 12*r*s - 2*r - 6*s**2 + 9*s + 2) - 2*Pkdd2*k2**4*s*(C*(4*s - 2) + 5*K - 2*s + 1) + f*(k1**2*(Pk2*(12*r*(3*s + 2) + 64*s**2 - 21*s - 16) + k2*(Pkd2*(-12*r*(s + 1) - 40*s**2 + 11*s + 8) + 2*Pkdd2*k2*s*(4*s - 1))) + 2*k2**2*(Pk2*(40*r**2 - 51*r + 18) + 5*Pkd2*k2*(2*r - 1))) - 2*k2**2*(K*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(-15*K*s + r**2*(8*C - 20*K - 8) + r*(-8*C + 70*K*s + 10*K - 2)))) + D1*(3*f**2*fd*k1**2*(Pk2*(6*r*(9*s + 8) - 72*s**2 - 9*s - 22) + 3*Pkd2*k2*(14*r*(3*s - 2) + 48*s**2 - 61*s + 22)) + 2*f*(-7*bd2*k2*s*(15*Pk2*k2*(r - 1) + Pkd2*k1**2*s + 5*Pkd2*k2**2*(r + s + 1) - Pkdd2*k1**2*k2*s + 5*Pkdd2*k2**3*s) + fd*(k1**2*(4*Pk2*(C*(2*s**2 + 5*s - 3) - 7*K*(1 - 2*s)**2 - 2*r*s + 21*r + s**2 + 17*s - 11) + k2*(Pkd2*(-24*C*s**2 + 7*K*(10*s**2 - 11*s + 3) + 4*r*s - 21*r + 48*s**2 - 37*s + 14) + Pkdd2*k2*(-7*K*(2*s**2 - 3*s + 1) + s**2*(24*C - 12)))) + k2**2*(Pk2*(2*C*(28*r**2 + r*(92 - 422*s) + 253*s - 74) - 14*K*(10*r**2 + 3*r*(7*s - 3) + 9*(1 - 2*s)**2) + 40*r**2 + 590*r*s - 192*r - 253*s + 86) + k2*(Pkd2*(2*C*(r*(86*s - 42) - 36*s + 21) - 14*K*(5*r*(3*s - 2) + 3*(1 - 2*s)**2) - 86*r*s + 63*r + 36*s - 28) + Pkdd2*k2*(7 - 14*C)*(3*s - 1)))) + 14*gd2*(2*Pk2*k1**2*s*(s - 1) + Pkd2*k1**2*k2*s**2 - 5*Pkd2*k2**3*(r*(3*s - 2) - 4*s + 2) + 5*Pkdd2*k2**4*s - k2**2*(5*Pk2*(2*r**2 - 7*r*s - 2*r + 3*s) + Pkdd2*k1**2*s**2))) + 14*fd*(-b2*k2*s*(Pkd2*k1**2*s + 5*Pkd2*k2**2*(r + s) + 5*Pkdd2*k2**3*s + k2*(15*Pk2*r - Pkdd2*k1**2*s)) + 2*g2*(k1**2*(2*Pk2*(s - 1)**2 + k2*s**2*(Pkd2 - Pkdd2*k2)) + 5*k2**2*(Pk2*r*(-2*r + 7*s - 4) - Pkd2*k2*(3*r*s - 4*r - 2*s + 1) + Pkdd2*k2**2*(2*s - 1))))) + 2*Dd*f*(-7*b2*k2*(Pkd2*k1**2*s*(4*s - 1) + 5*Pkd2*k2**2*(4*r*s - 2*r + 4*s**2 + s) + 5*Pkdd2*k2**3*s*(4*s - 1) + k2*s*(30*Pk2*(2*r - 1) + Pkdd2*k1**2*(1 - 4*s))) + 6*f**2*k1**2*(Pk2*(r*(18*s + 23) - 24*s**2 - 5*s - 11) + Pkd2*k2*(14*r*(3*s - 2) + 48*s**2 - 57*s + 20)) + f*(k1**2*(2*Pk2*(C*(8*s**2 + 22*s - 6) - 14*K*(8*s**2 - 6*s + 1) - 8*r*s + 64*r + 4*s**2 + 63*s - 47) + k2*(Pkd2*(-48*C*s**2 + 12*C*s + 7*K*(20*s**2 - 17*s + 3) + 8*r*s - 29*r + 96*s**2 - 70*s + 25) - Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(6 - 12*C)))) + k2**2*(2*Pk2*(2*C*(28*r**2 + r*(55 - 422*s) + 253*s - 45) - 7*K*(20*r**2 + 42*r*s - 13*r + 72*s**2 - 45*s + 3) + 40*r**2 + 590*r*s - 139*r - 253*s + 49) + k2*(Pkd2*(2*C*(2*r - 1)*(86*s - 23) - 14*K*(30*r*s - 20*r + 24*s**2 - 33*s + 13) - (2*r - 1)*(86*s - 37)) + Pkdd2*k2*(7 - 14*C)*(4*s - 1)))) + 14*g2*(k1**2*(4*s - 1)*(2*Pk2*(s - 1) + k2*s*(Pkd2 - Pkdd2*k2)) + 5*k2**2*(-2*Pk2*(4*r**2 - 14*r*s + 3*s) + Pkd2*k2*(-12*r*s + 8*r + 10*s - 5) + Pkdd2*k2**2*(4*s - 1))))) + f*(3*D1*bd1*(-14*b2*k2*(Pkd2*k1**2*s*(s - 1) + 5*Pkd2*k2**2*(r*(s - 2) + s*(s - 1)) + 5*Pkdd2*k2**3*s*(s - 1) + k2*s*(15*Pk2*r + k1**2*(-Pkdd2*s + Pkdd2))) + 3*f**2*k1**2*(Pk2*(2*r*(9*s + 22) - 24*s**2 - 11*s - 22) + Pkd2*k2*(14*r*(3*s - 2) + 48*s**2 - 45*s + 14)) - 2*f*(k1**2*(2*Pk2*(2*r*(s - 4) + s**2*(-2*C + 28*K - 1) - s*(6*C + 14*K + 16) + 11) + k2*(Pkd2*(-2*r*s + r + s**2*(12*C - 35*K - 24) - s*(12*C - 21*K - 21) - 4) - Pkdd2*k2*s*(s - 1)*(12*C - 7*K - 6))) + k2**2*(Pk2*(-116*C*s + 7*K*(10*r**2 + r*(21*s - 4) + 36*s**2 - 9*s - 6) - r**2*(28*C + 20) + r*(422*C*s - 32*C - 295*s + 46) + 58*s + 8) + Pkd2*k2*(C*(-2*r*(43*s + 10) + 4*s + 24) + 7*K*(5*r*(3*s - 2) + 12*s**2 - 21*s + 10) + 43*r*s + 10*r - 2*s - 12))) - 28*g2*(-2*Pk2*k1**2*s*(s - 1) - Pkd2*k1**2*k2*s*(s - 1) + 15*Pkd2*k2**3*r*s + k2**2*(5*Pk2*r*(2*r - 7*s) + Pkdd2*k1**2*s*(s - 1)))) - 2*D1*(f*(fd*(k1**2*(2*Pk2*(36*C*(1 - 3*s)**2 + r*(45*s - 87) - 162*s**2 - 6*s + 44) + 9*k2*(2*C*(3*s - 1)*(Pkd2*(3 - 7*s) + Pkdd2*k2*(s - 1)) + 2*Pkd2*(-3*r*s + 2*r + 6*s**2 - 3*s) - Pkdd2*k2*(3*s**2 - 4*s + 1))) + k2**2*(Pk2*(2*C*(396*r**2 + 567*r*s - 390*r + 324*s**2 - 513*s + 158) - 558*r**2 - 783*r*s + 516*r - 324*s**2 + 513*s - 158) + Pkd2*k2*(18*C - 9)*(15*r*(3*s - 2) + 24*s**2 - 35*s + 14))) + (21*bd2 - 42*gd2)*(4*Pk2*k1**2*s*(2*s - 1) + Pkd2*k1**2*k2*s*(3 - 5*s) + Pkd2*k2**3*(5*r*(3*s - 2) + 12*s**2 - 21*s + 10) + k2**2*(Pk2*(10*r**2 + 21*r*s - 4*r + 36*s**2 - 9*s - 6) + Pkdd2*k1**2*s*(s - 1)))) - 42*fd*g2*(k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(10*r**2 + 3*r*(7*s - 3) + 9*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 3*(1 - 2*s)**2)))) - 2*Dd*f*(f*(k1**2*(2*Pk2*(36*C*(12*s**2 - 7*s + 1) + 60*r*s - 109*r - 216*s**2 - 22*s + 66) + 9*k2*(-Pkd2*(C*(56*s**2 - 38*s + 6) + 8*r*s - 5*r - 16*s**2 + 6*s + 1) + Pkdd2*k2*(2*C - 1)*(4*s**2 - 5*s + 1))) + 2*k2**2*(Pk2*(2*C*(264*r**2 + 7*r*(54*s - 37) + 216*s**2 - 297*s + 77) - 372*r**2 - 522*r*s + 349*r - 216*s**2 + 297*s - 77) + Pkd2*k2*(18*C - 9)*(10*r*(3*s - 2) + 16*s**2 - 27*s + 12))) - 42*g2*(k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(20*r**2 + 42*r*s - 13*r + 72*s**2 - 45*s + 3) + Pkd2*k2*(30*r*s - 20*r + 24*s**2 - 33*s + 13)))) - 42*b2*(D1*fd*(k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(10*r**2 + 3*r*(7*s - 3) + 9*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 3*(1 - 2*s)**2))) + Dd*f*(k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 2*k2**2*(Pk2*(20*r**2 + 42*r*s - 13*r + 72*s**2 - 45*s + 3) + Pkd2*k2*(30*r*s - 20*r + 24*s**2 - 33*s + 13))))))/(315*d**2*k2**2*k3**2) + D1**3*Pk3*(D1*bd1*f*(70*b1**2*k2**2*(2*Pk2*k2**2*(3*r - 1)*(r + s - 1) + k1**2*(2*Pk2*(12*r**2 + 18*r*s - 19*r + 6*s**2 - 14*s + 7) + Pkd2*k2*s*(3*r + 3*s - 2))) + 14*b1*(-4*Pk2*k1**4*(r*(4*s - 1) + s*(-2*K*s + K + 6*s - 4)) + k1**2*k2**2*(2*Pk2*(2*C*(31*r*(4*s - 1) - 16*s**2 - 54*s + 31) + 80*K*s**2 - 70*K*s + r**2*(40*K - 10) + r*(130*K*s - 55*K - 166*s + 54) - 6*s**2 + 66*s - 29) + 5*Pkd2*k2*s*(K*(4*r + 8*s - 6) - 2*s + 1)) + k2**4*(5*K*Pkd2*k2*s*(6*r + 4*s - 5) + Pk2*(-12*C*(8*r**2 - r*(12*s + 5) + 6*s - 3) + 100*K*s**2 - 85*K*s + r**2*(140*K + 28) + 2*r*(35*K*(3*s - 2) - 46*s - 5) + 36*s - 18))) + 140*b2*k2**2*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))*(r + s - 1) + 3*f**2*k1**4*(Pk2*(r*(65*s - 70) + 8*s**2 - 50*s + 42) + Pkd2*k2*s*(35*r + 24*s - 24)) - f*(2*k1**4*(4*Pk2*(7*b1*(2*s - 1)*(3*r + 3*s - 2) + 6*r*(2*s - 1) - (3*s - 3)*(s*(4*C - 8) + 1)) + 21*Pkd2*b1*k2*s*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(-8*C*(120*r**2 + 345*r*s - 243*r + 168*s**2 - 256*s + 88) + 7*b1*(336*r**2 + r*(466*s - 498) + 184*s**2 - 327*s + 166) + 564*r**2 - 4*r*(56*K*s - 482*s + 336) - 4*(s - 1)*(63*K*s - 231*s + 103)) + 7*Pkd2*k2*s*(-24*C*(r + 2*s - 2) - 8*K*s + 8*K + b1*(90*r + 48*s - 69) + 12*r + 30*s - 30)) - 2*k2**4*(Pk2*(2*C*(348*r**2 + r*(413*s - 328) + 126*s**2 - 210*s + 84) - 390*r**2 + r*(356 - 441*s) - 126*s**2 + 210*s - 84) + Pkd2*k2*s*(14*C - 7)*(9*r + 4*s - 4))) - 28*g2*(4*Pk2*k1**4*s*(s - 1) + 10*k1**2*k2**2*(Pk2*(4*r**2 + r*(13*s - 7) + s*(8*s - 8)) + Pkd2*k2*s*(r + 2*s - 2)) + 5*k2**4*(Pk2*(14*r**2 + 7*r*(3*s - 2) + s*(10*s - 10)) + Pkd2*k2*s*(3*r + 2*s - 2)))) + 70*b1**3*k2**2*(D1*fd*(2*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*s))*(r + s - 1) + Dd*f*(4*Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(2*Pk2*(16*r**2 + 3*r*(8*s - 9) + 8*s**2 - 20*s + 11) + Pkd2*k2*s*(4*r + 4*s - 3)))) - 7*b1**2*(D1*fd*(-10*K*Pkd2*k2**5*s*(3*r + 2*s) - 8*Pk2*k1**4*s*(-2*r + s*(K - 3)) - 4*Pk2*k1**2*k2**2*(r**2*(20*K - 5) + r*s*(124*C + 65*K - 83) + s*(-4*C*(4*s + 31) + 40*K*s - 3*s + 58)) - 2*Pk2*k2**4*(-24*C*(r - 1)*(2*r - 3*s - 2) + 5*K*(14*r**2 + 21*r*s + 4*r + 10*s**2 + 8*s - 4) + 14*r**2 - 46*r*s - 48*r + 36*s + 24) - 10*Pkd2*k1**2*k2**3*s*(2*K*(r + 2*s) - s) + f*k1**2*(16*Pk2*k1**2*s*(3*r + 3*s - 2) + Pk2*k2**2*(336*r**2 + r*(466*s - 392) + 184*s**2 - 251*s + 116) + 6*Pkd2*k1**2*k2*s*(4*r + 4*s - 3) + 3*Pkd2*k2**3*s*(30*r + 16*s - 15))) + 2*Dd*f*(4*Pk2*k1**4*(r*(8*s - 1) + s*(-4*K*s + K + 12*s - 5)) + f*(2*k1**4*(2*Pk2*(4*s - 1)*(3*r + 3*s - 2) + 3*Pkd2*k2*s*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(336*r**2 + 466*r*s - 445*r + 184*s**2 - 289*s + 141) + 3*Pkd2*k2*s*(30*r + 16*s - 19))) + k1**2*k2**2*(-2*Pk2*(C*(62*r*(8*s - 1) - 64*s**2 - 356*s + 62) + 160*K*s**2 - 100*K*s + r**2*(80*K - 20) + r*(260*K*s - 75*K - 332*s + 59) - 12*s**2 + 187*s - 29) - 5*Pkd2*k2*s*(8*K*(r + 2*s - 1) - 4*s + 1)) - 2*k2**4*(10*K*Pkd2*k2*s*(3*r + 2*s - 2) + Pk2*(-6*C*(16*r**2 - 3*r*(8*s + 7) + 18*s + 5) + 5*K*(28*r**2 + 42*r*s - 19*r + 20*s**2 - 8*s - 2) + 28*r**2 - 92*r*s - 48*r + 54*s + 15)))) + b1*(D1*(3*f**2*fd*k1**4*(Pk2*(24*s**2 + s*(195*r - 100) - 4) + Pkd2*k2*(72*s**2 + s*(105*r - 22) - 12)) + 2*f*(70*bd2*k2**2*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))*(r + s - 1) + fd*(48*Pk2*k1**4*s*(-2*r + s*(2*C - 4) + 1) + 2*k1**2*k2**2*(Pk2*(4*C*(120*r**2 + 15*r*(23*s - 8) + 168*s**2 - 169*s + 30) + 7*K*(2*s - 1)*(8*r + 9*s - 9) - 282*r**2 - 964*r*s + 275*r - 462*s**2 + 398*s - 60) + 7*Pkd2*k2*(K*(4*s**2 - 6*s + 2) + 3*s*(C*(4*r + 8*s - 2) - 2*r - 5*s + 1))) + k2**4*(Pk2*(2*C*(696*r**2 + 118*r*(7*s - 4) + 252*s**2 - 231*s + 34) - 780*r**2 - 882*r*s + 514*r - 252*s**2 + 231*s - 34) + Pkd2*k2*s*(14*C - 7)*(18*r + 8*s - 9))) - 14*gd2*(4*Pk2*k1**4*s**2 + 10*k1**2*k2**2*(Pk2*(4*r**2 + 13*r*s - 4*r + 8*s**2 - 6*s) + Pkd2*k2*s*(r + 2*s - 1)) + 5*k2**4*(Pk2*(14*r**2 + 7*r*(3*s - 2) + s*(10*s - 7)) + Pkd2*k2*s*(3*r + 2*s - 3)))) - 28*fd*(-5*b2*k2**2*(r + s)*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s)) + g2*(4*Pk2*k1**4*s**2 + 10*Pk2*k1**2*k2**2*(4*r**2 + 13*r*s + 8*s**2) + 5*Pk2*k2**4*(14*r**2 + 21*r*s + 4*r + 10*s**2 + 8*s - 4) + 10*Pkd2*k1**2*k2**3*s*(r + 2*s) + 5*Pkd2*k2**5*s*(3*r + 2*s)))) + 2*Dd*f*(70*b2*k2**2*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))*(4*r + 4*s - 3) + 3*f**2*k1**4*(Pk2*(5*r*(26*s - 7) + 16*s**2 - 75*s + 19) + Pkd2*k2*(48*s**2 + s*(70*r - 23) - 6)) + f*(12*Pk2*k1**4*(r*(2 - 16*s) + s**2*(16*C - 32) - s*(4*C - 16) - 1) + k1**2*k2**2*(2*Pk2*(2*C*(480*r**2 + 3*r*(460*s - 221) + 672*s**2 - 844*s + 208) + 7*K*(4*s - 1)*(8*r + 9*s - 9) - 564*r**2 - 1928*r*s + 812*r - 924*s**2 + 1027*s - 223) + 7*Pkd2*k2*(4*K*(4*s**2 - 5*s + 1) + 3*s*(16*C*(r + 2*s - 1) - 8*r - 20*s + 9))) + 2*k2**4*(Pk2*(2*C*(696*r**2 + 826*r*s - 619*r + 252*s**2 - 350*s + 104) - 780*r**2 - 882*r*s + 675*r - 252*s**2 + 350*s - 104) + Pkd2*k2*s*(14*C - 7)*(18*r + 8*s - 11))) - 28*g2*(2*Pk2*k1**4*s*(4*s - 1) + 5*Pk2*k1**2*k2**2*(16*r**2 + r*(52*s - 15) + 4*s*(8*s - 5)) + 5*Pk2*k2**4*(28*r**2 + r*(42*s - 19) + 20*s**2 - 8*s - 2) + 20*Pkd2*k1**2*k2**3*s*(r + 2*s - 1) + 10*Pkd2*k2**5*s*(3*r + 2*s - 2)))) + 4*f*k1**2*k2**2*(D1*(f*(3*fd*(3*s - 1)*(Pk2*(24*C*r + 26*C*(s - 1) - 15*r - 13*s + 13) + Pkd2*k2*(6*C - 3)*(s - 1)) + 14*s*(2*Pk2*bd2*(r + s - 1) + Pk2*gd2*(-8*r - 9*s + 9) - 2*Pkd2*gd2*k2*(s - 1))) - 14*fd*g2*(2*s - 1)*(Pk2*(8*r + 9*s - 9) + 2*Pkd2*k2*(s - 1))) + Dd*f*(4*s - 1)*(3*f*(Pk2*(24*C*r + 26*C*(s - 1) - 15*r - 13*s + 13) + Pkd2*k2*(6*C - 3)*(s - 1)) - 14*g2*(Pk2*(8*r + 9*s - 9) + 2*Pkd2*k2*(s - 1))) + 28*Pk2*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(r + s - 1)))/(105*d**2*k2**2*k3**4) - 4*D1**3*Pk3*st**4*(D1*(-2772*b1*fd*k2**6*(Pk2*b2*(r + s)**2 + b1*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s)) - 2*g2*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s))) + f**3*(-33*bd1*k2**2*(6*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(4*Pk2*(3*r**2 + 18*r*s - 7*r + 15*s**2 - 14*s + 1) + Pkd2*k2*(-24*r*s + r - 24*s**2 + 15*s + 5)) + 3*k1**2*k2**2*(2*Pk2*(25*r**2 + 31*r*s - 37*r + 6*s**2 - 30*s + 14) + Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + fd*k1**2*(88*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(25*r + 25*s - 27) + 33*k1**2*k2**2*(4*Pk2*(38*r**2 - r*(82*s + 5) - 120*s**2 + 103*s - 15) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 33*f**2*k2**2*(b1*(84*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) - 3*bd1*k1**2*k2**2*(Pk2*(32*r**2 + r*(64*s - 34) + 32*s**2 - 34*s + 2) + Pkd2*k2*(r*(50*s - 9) + 50*s**2 - 43*s + 1)) + fd*(6*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + k1**4*(-12*Pk2*(3*r**2 + 18*r*s - 4*r + 15*s**2 - 9*s + 1) + Pkd2*k2*(72*r*s + 21*r + 72*s**2 - 9*s - 17)) + 3*k1**2*k2**2*(2*Pk2*(75*r**2 + r*(93*s - 83) + 18*s**2 - 66*s + 28) + Pkd2*k2*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24)))) + 6*k2**2*(60*C*Pk2*fd*k1**2*r**2 + 252*C*Pk2*fd*k1**2*r*s - 102*C*Pk2*fd*k1**2*r + 36*C*Pk2*fd*k1**2*s**2 - 152*C*Pk2*fd*k1**2*s + 46*C*Pk2*fd*k1**2 - 108*C*Pk2*fd*k2**2*r**2 - 48*C*Pk2*fd*k2**2*r*s + 110*C*Pk2*fd*k2**2*r - 24*C*Pk2*fd*k2**2*s**2 + 4*C*Pk2*fd*k2**2*s - 18*C*Pk2*fd*k2**2 + 18*C*Pkd2*fd*k1**2*k2*r*s - 6*C*Pkd2*fd*k1**2*k2*r + 18*C*Pkd2*fd*k1**2*k2*s**2 - 18*C*Pkd2*fd*k1**2*k2*s + 4*C*Pkd2*fd*k1**2*k2 - 24*C*Pkd2*fd*k2**3*r*s + 10*C*Pkd2*fd*k2**3*r - 24*C*Pkd2*fd*k2**3*s**2 + 24*C*Pkd2*fd*k2**3*s - 6*C*Pkd2*fd*k2**3 + 2*Pk2*bd2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 39*Pk2*fd*k1**2*r**2 - 138*Pk2*fd*k1**2*r*s + 65*Pk2*fd*k1**2*r - 21*Pk2*fd*k1**2*s**2 + 85*Pk2*fd*k1**2*s - 28*Pk2*fd*k1**2 + 66*Pk2*fd*k2**2*r**2 + 36*Pk2*fd*k2**2*r*s - 64*Pk2*fd*k2**2*r + 12*Pk2*fd*k2**2*s**2 - 4*Pk2*fd*k2**2*s + 10*Pk2*fd*k2**2 - 40*Pk2*gd2*k1**2*r**2 - 80*Pk2*gd2*k1**2*r*s + 88*Pk2*gd2*k1**2*r - 40*Pk2*gd2*k1**2*s**2 + 60*Pk2*gd2*k1**2*s - 48*Pk2*gd2*k1**2 + 196*Pk2*gd2*k2**2*r**2 + 308*Pk2*gd2*k2**2*r*s - 280*Pk2*gd2*k2**2*r + 112*Pk2*gd2*k2**2*s**2 - 224*Pk2*gd2*k2**2*s + 84*Pk2*gd2*k2**2 - 9*Pkd2*fd*k1**2*k2*r*s + 3*Pkd2*fd*k1**2*k2*r - 9*Pkd2*fd*k1**2*k2*s**2 + 9*Pkd2*fd*k1**2*k2*s - 2*Pkd2*fd*k1**2*k2 + 12*Pkd2*fd*k2**3*r*s - 5*Pkd2*fd*k2**3*r + 12*Pkd2*fd*k2**3*s**2 - 12*Pkd2*fd*k2**3*s + 3*Pkd2*fd*k2**3 - 10*Pkd2*gd2*k1**2*k2*r*s + 6*Pkd2*gd2*k1**2*k2*r - 10*Pkd2*gd2*k1**2*k2*s**2 + 24*Pkd2*gd2*k1**2*k2*s - 6*Pkd2*gd2*k1**2*k2 + 56*Pkd2*gd2*k2**3*r*s - 14*Pkd2*gd2*k2**3*r + 56*Pkd2*gd2*k2**3*s**2 - 56*Pkd2*gd2*k2**3*s + 14*Pkd2*gd2*k2**3 + bd1*(k1**2*(K*Pkd2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + Pk2*(K*(20*r**2 + 40*r*s - 44*r + 20*s**2 - 30*s + 24) - 5*r**2 - 10*r*s + 11*r - 5*s**2 + 4*s - 6)) + k2**2*(2*C*(2*Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 7*K*(2*Pk2*(7*r**2 + r*(11*s - 10) + 4*s**2 - 8*s + 3) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + 16*Pk2*r**2 + 8*Pk2*r*s - 17*Pk2*r - 8*Pk2*s**2 + Pk2*s - 4*Pkd2*k2*r*s + 2*Pkd2*k2*r - 4*Pkd2*k2*s**2 + 5*Pkd2*k2*s - Pkd2*k2)))) + 198*f*k2**4*(-14*Pk2*b2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*Pk2*b2*fd*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*(-7*Pk2*k2**2*(r - 1)*(2*r + 2*s - 1) + k1**2*(Pk2*(16*r**2 + 32*r*s - 7*r + 16*s**2 - 7*s - 1) + Pkd2*k2*s*(25*r + 25*s - 9))) + b1*(fd*(k1**2*(-K*Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6) + Pk2*(-2*K*(20*r**2 + r*(40*s - 41) + 20*s**2 - 34*s + 12) + 10*r**2 + 4*r*(5*s - 6) + 10*s**2 - 17*s + 6)) - 2*k2**2*(2*C*(Pk2*(8*r**2 + 16*r*s - 4*r + 8*s**2 - 4*s - 1) + 2*Pkd2*k2*s*(2*r + 2*s - 1)) - 7*K*(Pk2*(7*r + 4*s - 2) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1) + 2*Pk2*(8*r**2 + r*(4*s - 3) + s*(3 - 4*s)) + 2*Pkd2*k2*s*(-2*r - 2*s + 1))) + 7*k2**2*(-2*Pk2*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + bd1*(K*Pk2*(-8*r**2 + r*(6 - 16*s) - 8*s**2 + 6*s + 2) + K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + 4*Pk2*r**2 + Pk2*r*(4*s - 3) - Pk2*s) + 2*gd2*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 14*bd1*g2*k2**2*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) - 2*fd*g2*(-k1**2*(Pk2*(40*r**2 + r*(80*s - 82) + 40*s**2 - 68*s + 24) + Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6)) + 14*k2**2*(Pk2*(7*r + 4*s - 2) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-1386*b1*k2**6*(2*Pk2*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))) + f**3*k1**2*(88*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(25*r + 25*s - 27) + 33*k1**2*k2**2*(4*Pk2*(38*r**2 - r*(82*s + 5) - 120*s**2 + 103*s - 15) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 33*f**2*k2**2*(12*Pk2*b1*k2**4*(2*r - 1)*(5*r + 5*s - 3) - 2*b1*k1**4*(2*Pk2*(12*r**2 + r*(72*s - 19) + 60*s**2 - 41*s + 4) + Pkd2*k2*(-2*r*(24*s + 5) - 48*s**2 + 12*s + 11)) + 3*b1*k1**2*k2**2*(4*Pk2*(50*r**2 + 62*r*s - 60*r + 12*s**2 - 48*s + 21) + Pkd2*k2*(21*s - 10)*(4*r + 4*s - 3)) + 6*k1**2*k2**2*(Pk2*(2*C*(40*r**2 + 168*r*s - 67*r + 24*s**2 - 112*s + 29) - 52*r**2 - 184*r*s + 86*r - 28*s**2 + 123*s - 36) + Pkd2*k2*(2*C - 1)*(3*s - 1)*(4*r + 4*s - 3)) + 6*k2**4*(Pk2*(-2*C*(72*r**2 + 32*r*s - 83*r + 16*s**2 - 2*s + 19) + 88*r**2 + 48*r*s - 97*r + 16*s**2 - 6*s + 21) + Pkd2*k2*(2 - 4*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 99*f*k2**4*(-4*Pk2*b2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*(16*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 14*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*k2*(r*(100*s - 9) + 100*s**2 - 61*s + 1)) - 2*b1*(k1**2*(K*Pkd2*k2*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + Pk2*(2*K*(40*r**2 + 80*r*s - 85*r + 40*s**2 - 64*s + 36) - 20*r**2 - 40*r*s + 46*r - 20*s**2 + 25*s - 18)) + k2**2*(Pk2*(4*C*(16*r**2 + 16*r*(2*s - 1) + 16*s**2 - 16*s + 3) - 14*K*(28*r**2 + 44*r*s - 31*r + 16*s**2 - 24*s + 8) + 64*r**2 + 32*r*s - 48*r - 32*s**2 + 12*s + 3) + Pkd2*k2*(C*(4*r*(8*s - 1) + 32*s**2 - 24*s + 2) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 16*r*s + 2*r - 16*s**2 + 12*s - 1))) - 4*g2*(-k1**2*(2*Pk2*(40*r**2 + 80*r*s - 85*r + 40*s**2 - 64*s + 36) + Pkd2*k2*(20*r*s - 11*r + 20*s**2 - 41*s + 12)) + 14*k2**2*(Pk2*(28*r**2 + 44*r*s - 31*r + 16*s**2 - 24*s + 8) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(3465*d**2*k2**2*k3**6) - 4*D1**3*Pk3*st**2*(D1*bd1*f*(f**2*k1**2*(-36*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(s + 1) + 15*s**2 - 8*s - 7) + 18*k1**2*k2**2*(Pk2*(5*r**2 - r*(13*s + 2) - 18*s**2 + 15*s + 3) + Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) + 3*f*k2**2*(k1**4*(2*Pk2*(56*C*r*s - 28*C*s + 2*K*(r**2 + 4*r*s + 5*r + 3*s**2 + 7*s - 6) + b1*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) - 30*r*s - 3*r - 2*s**2 + 9*s + 3) + Pkd2*b1*k2*(3*r*(22*s + 5) + 66*s**2 - 59*s - 11)) - 2*k1**2*k2**2*(Pk2*(2*C*(48*r**2 + 224*r*s - 135*r + 50*s**2 - 105*s + 69) - 154*K*r**2 - 336*K*r*s + 238*K*r - 182*K*s**2 + 224*K*s - 84*K + 7*b1*(32*r**2 + r*(52*s - 55) + 20*s**2 - 43*s + 23) - 28*r**2 - 184*r*s + 126*r - 30*s**2 + 96*s - 73) + Pkd2*k2*(2*C*(15*r*s + 3*r + 15*s**2 - 10*s - 5) - 35*K*r*s + 21*K*r - 35*K*s**2 + 56*K*s - 21*K + 7*b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) - 15*r*s - 3*r - 15*s**2 + 10*s + 5)) + 2*k2**4*(Pk2*(2*C*(58*r**2 + 16*r*s - 51*r + 28*s**2 - 11*s - 17) + 42*K*r**2 + 126*K*r*s - 70*K*r + 84*K*s**2 - 84*K*s + 28*K - 7*b1*(2*r - 1)*(3*r + 3*s - 1) - 72*r**2 - 30*r*s + 58*r - 28*s**2 + 11*s + 17) + Pkd2*k2*(14*C - 7)*(r*(2*s - 1) + s*(2*s - 2)))) + 42*k2**4*(-Pk2*b1**2*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*Pk2*b2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(-2*K*k1**2*(Pk2*(2*r**2 + 6*r*s - 4*r + 4*s**2 - 1) + Pkd2*k2*(r*s + r + s**2 - 2*s)) + 5*K*k2**2*(2*Pk2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(k1**2*(2*r**2 + r*(4*s - 7) + s*(2*s + 3)) + k2**2*(4*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 24*r**2 - 28*r*s + 21*r - 4*s**2 + 11*s - 2))) + 2*g2*k1**2*(2*Pk2*(r**2 + r*(3*s - 4) + s*(2*s - 2)) + Pkd2*k2*(r*(s + 2) + s*(s - 1))) - 10*g2*k2**2*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) - 42*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(D1*fd*(f*(-14*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + 2*k1**4*(Pk2*(4*r**2 + 8*r*s - 17*r + 4*s**2 - 17*s + 9) + Pkd2*k2*s*(33*r + 33*s - 13)) - 7*k1**2*k2**2*(2*Pk2*(32*r**2 + 52*r*s - 33*r + 20*s**2 - 27*s + 7) + Pkd2*k2*s*(30*r + 30*s - 13))) + 14*k2**2*(-K*k1**2*(2*Pk2*(r**2 + r*(3*s + 2) + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)) + 10*K*k2**2*(Pk2*(3*r**2 + r*(6*s + 2) + 3*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)) + Pk2*(k1**2*(r + s)**2 + 2*k2**2*(2*C*(r + s - 1)**2 - 6*r**2 + r*(2 - 7*s) - (s - 1)**2)))) + Dd*f*(f*(-28*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(4*Pk2*(4*r**2 + r*(8*s - 15) + 4*s**2 - 15*s + 9) + Pkd2*k2*(3*r*(44*s + 5) + 132*s**2 - 85*s - 11)) - 7*k1**2*k2**2*(4*Pk2*(32*r**2 + 52*r*s - 44*r + 20*s**2 - 35*s + 15) + Pkd2*k2*(60*r*s - 6*r + 60*s**2 - 41*s + 2))) + 14*k2**2*(-K*k1**2*(2*Pk2*(4*r**2 + 2*r*(6*s - 1) + 8*s**2 + 4*s - 3) + Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + 5*K*k2**2*(2*Pk2*(12*r**2 + 24*r*s - 5*r + 12*s**2 - 5*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + Pk2*(k1**2*(4*r**2 + 8*r*(s - 1) + s*(4*s + 7)) + k2**2*(4*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 48*r**2 - 56*r*s + 39*r - 8*s**2 + 24*s - 6))))) + b1*(-3*D1*(f**2*fd*k1**2*(12*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - k1**4*s*(2*Pk2 - Pkd2*k2)*(15*r + 15*s - 13) - 6*k1**2*k2**2*(Pk2*(15*r**2 - 39*r*s - 23*r - 54*s**2 + 15*s + 8) + Pkd2*k2*(12*r*s + 13*r + 12*s**2 + 6*s - 9))) - 2*f*fd*k2**2*(Pk2*k1**4*(28*C*(r*(4*s - 1) - 3*s + 1) + 2*K*(2*r**2 + 8*r*s + 10*r + 6*s**2 + 15*s - 9) - 60*r*s + 9*r - 4*s**2 + 32*s - 8) + k1**2*k2**2*(Pk2*(-2*C*(96*r**2 + r*(448*s - 44) + 100*s**2 - 221*s - 8) + 14*K*(22*r**2 + 48*r*s - 26*r + 26*s**2 - 25*s + 6) + 56*r**2 + 368*r*s - 4*r + 60*s**2 - 181*s - 18) + Pkd2*k2*(7*K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2 - 4*C)*(15*r + 15*s - 4))) + k2**4*(2*Pk2*(C*(116*r**2 + 4*r*(8*s - 15) + 56*s**2 + 89*s - 6) + 7*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 72*r**2 - 30*r*s + 37*r - 28*s**2 - 41*s + 3) + Pkd2*k2*s*(14*C - 7)*(4*r + 4*s - 1))) + 28*f*k2**4*(Pk2*bd2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - gd2*k1**2*(2*Pk2*(r**2 + 3*r*s + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s - 3)) + 5*gd2*k2**2*(2*Pk2*(3*r**2 + r*(6*s - 2) + 3*s**2 - 2*s - 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 28*fd*k2**4*(Pk2*b2*(k1**2 - 5*k2**2)*(r + s)**2 - g2*k1**2*(2*Pk2*(r**2 + r*(3*s + 2) + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)) + 10*g2*k2**2*(Pk2*(3*r**2 + r*(6*s + 2) + 3*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-72*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(4*s + 1) + 60*s**2 - 47*s - 7) + 18*k1**2*k2**2*(Pk2*(20*r**2 - r*(52*s + 25) - 72*s**2 + 30*s + 11) + Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) + 6*f*k2**2*(Pk2*k1**4*(28*C*(r*(8*s - 1) - 6*s + 1) + K*(8*r**2 + 8*r*(4*s + 5) + 24*s**2 + 58*s - 42) - 120*r*s + 3*r - 8*s**2 + 64*s - 2) + k1**2*k2**2*(Pk2*(-2*C*(192*r**2 + 7*r*(128*s - 33) + 200*s**2 - 488*s + 65) + 14*K*(44*r**2 + 96*r*s - 60*r + 52*s**2 - 57*s + 18) + 112*r**2 + 736*r*s - 159*r + 120*s**2 - 416*s + 56) + Pkd2*k2*(-2*C*(r*(60*s + 3) + 60*s**2 - 31*s - 5) + 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) + 60*r*s + 3*r + 60*s**2 - 31*s - 5)) + k2**4*(Pk2*(2*C*(232*r**2 + r*(64*s - 177) + 112*s**2 + 122*s - 15) + 14*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 288*r**2 - 120*r*s + 212*r - 112*s**2 - 108*s + 15) + Pkd2*k2*(14*C - 7)*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 84*k2**4*(Pk2*b2*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - g2*k1**2*(2*Pk2*(4*r**2 + 2*r*(6*s - 1) + 8*s**2 + 4*s - 3) + Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + 5*g2*k2**2*(2*Pk2*(12*r**2 + r*(24*s - 5) + 12*s**2 - 5*s - 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)))))) + f*(D1*(f**2*fd*k1**4*(36*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(2*Pk2*(25*r + 58*s - 27) + 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(6*Pk2*bd2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k1**4*(4*C*(9*r**2 + 9*r*(4*s + 1) + 27*s**2 + 6*s - 13) - 18*r**2 - 30*r*(3*s + 1) - 72*s**2 - 21*s + 37) + Pk2*k2**4*(36*C - 18)*(9*r**2 + r*(21*s - 13) + 12*s**2 - 13*s + 4) + k1**2*k2**2*(Pk2*(4*C*(333*r**2 + 9*r*(73*s - 49) + 324*s**2 - 462*s + 155) - 801*r**2 - 1530*r*s + 1017*r - 729*s**2 + 1014*s - 337) + Pkd2*k2*(18*C - 9)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) - 6*gd2*(2*Pk2*k1**4*(r**2 + r*(4*s + 5) + 3*s**2 + 7*s - 6) + 14*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + 7*k1**2*k2**2*(2*Pk2*(11*r**2 + r*(24*s - 17) + 13*s**2 - 16*s + 6) + Pkd2*k2*(5*s - 3)*(r + s - 1)))) - 12*fd*k2**2*(-Pk2*b2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(2*r**2 + 2*r*(4*s + 5) + 6*s**2 + 15*s - 9) + 14*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 7*k1**2*k2**2*(2*Pk2*(22*r**2 + 48*r*s - 26*r + 26*s**2 - 25*s + 6) + Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))))) + Dd*f*(f**2*k1**4*(36*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(2*Pk2*(25*r + 58*s - 27) + 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(Pk2*k1**4*(4*C*(12*r**2 + 12*r*(4*s + 1) + 36*s**2 + 7*s - 19) - 24*r**2 - r*(120*s + 41) - 96*s**2 - 26*s + 54) + Pk2*k2**4*(72*C - 36)*(6*r**2 + r*(14*s - 9) + 8*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(4*C*(444*r**2 + 876*r*s - 621*r + 432*s**2 - 644*s + 224) - 1068*r**2 - 2040*r*s + 1431*r - 972*s**2 + 1405*s - 484) + Pkd2*k2*(18*C - 9)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) - 12*k2**2*(-Pk2*b2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + g2*(2*Pk2*k1**4*(4*r**2 + 4*r*(4*s + 5) + 12*s**2 + 29*s - 21) + 14*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 7*k1**2*k2**2*(2*Pk2*(44*r**2 + 96*r*s - 60*r + 52*s**2 - 57*s + 18) + Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10)))))))/(315*d**2*k2**2*k3**6) - 4*D1**3*Pk3*(D1*bd1*f*(3*f**2*k1**4*(6*Pk2*k2**2*(5*r**2 + r*(9*s - 11) + 4*(s - 1)**2) + k1**2*(2*Pk2*(s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(r + s - 1))) - 2*f*k2**2*(Pk2*k2**4*(14 - 28*C)*(3*r**2 + r*(5*s - 2) + s*(2*s - 2)) + k1**4*(14*Pk2*b1*(30*r**2 + 9*r*(6*s - 5) + 24*s**2 - 41*s + 16) + 6*Pk2*(-4*C*(2*r**2 + r*(8*s - 5) + 6*s**2 - 8*s + 2) + 4*r**2 + 4*r*(5*s - 3) + 16*s**2 - 21*s + 5) + 63*Pkd2*b1*k2*s*(r + s - 1)) + k1**2*k2**2*(Pk2*(-4*C*(102*r**2 + 9*r*(23*s - 16) + 105*s**2 - 134*s + 29) - 28*K*r*s - 28*K*s**2 + 28*K*s + 14*b1*(18*r**2 + 3*r*(10*s - 7) + 12*s**2 - 19*s + 5) + 225*r**2 + 456*r*s - 330*r + 231*s**2 - 289*s + 58) + Pkd2*k2*s*(21 - 42*C)*(r + s - 1))) + 14*k2**2*(Pk2*b1**2*k1**2*(4*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(20*K*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pk2*k1**4*(10*C*(r*(4*s - 1) - 2*s + 1) + 4*K*r**2 + 12*K*s**2 - 10*K*s + 2*r*(8*K*s - 3*K - 12*s + 3) - 4*s**2 + 13*s - 5) + k1**2*k2**2*(10*K*Pkd2*k2*s*(r + s - 1) + Pk2*(-4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) + 100*K*s**2 - 90*K*s + r**2*(80*K - 2) + r*(90*K*(2*s - 1) - 44*s + 13) - 2*s**2 + 13*s - 6))) - 2*g2*(4*Pk2*k1**4*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + 10*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 5*k1**2*k2**2*(2*Pk2*(4*r**2 + r*(9*s - 5) + s*(5*s - 5)) + Pkd2*k2*s*(r + s - 1))))) + 14*Pk2*b1**3*k1**2*k2**2*(4*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 4*Pk2*f*k1**2*k2**4*(D1*(f*fd*(18*C - 9)*(3*s - 1) - 28*f*gd2*s + 28*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(18*C - 9) - 28*g2))*(r + s - 1) - 7*b1**2*k2**2*(D1*fd*(-20*K*Pk2*k2**4*(r + s)**2 + 4*Pk2*f*k1**2*k2**2*(18*r**2 + 15*r*(2*s - 1) + 12*s**2 - 13*s + 3) - 8*Pk2*k1**4*(K*(r**2 + 4*r*s + 3*s**2) + s*(10*C*(r - 1) - 6*r - s + 5)) + f*k1**4*(2*Pk2*(60*r**2 + 3*r*(36*s - 23) + 48*s**2 - 64*s + 21) + 9*Pkd2*k2*s*(2*r + 2*s - 1)) - 2*k1**2*k2**2*(5*K*Pkd2*k2*s*(r + s) - Pk2*(8*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) - 50*K*s**2 + r**2*(1 - 40*K) + r*(-90*K*s + 22*s + 8) + s**2 - 12*s - 4))) + Dd*f*(-20*K*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + k1**4*(-40*C*Pk2*(r*(8*s - 1) - 6*s + 1) + 2*Pk2*f*(120*r**2 + 3*r*(72*s - 53) + 96*s**2 - 146*s + 53) - 4*Pk2*(8*K*r**2 + r*(8*K*(4*s - 1) - 48*s + 6) + s**2*(24*K - 8) + s*(34 - 14*K) - 5) + 9*Pkd2*f*k2*s*(4*r + 4*s - 3)) - 2*k1**2*k2**2*(5*K*Pkd2*k2*s*(4*r + 4*s - 3) - Pk2*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 160*K*r**2 - 360*K*r*s + 130*K*r - 200*K*s**2 + 130*K*s + 8*f*(9*r**2 + 15*r*s - 9*r + 6*s**2 - 8*s + 2) + 4*r**2 + 88*r*s - 2*r + 4*s**2 - 37*s - 2)))) + b1*(D1*(3*f**2*fd*k1**4*(6*Pk2*k1**2*s*(5*r + 5*s - 3) + 6*Pk2*k2**2*(15*r**2 + 27*r*s - 23*r + 12*s**2 - 14*s + 8) + 5*Pkd2*k1**2*k2*s*(3*r + 3*s - 2)) + 2*f*k2**2*(14*Pk2*bd2*k1**2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 12*Pk2*fd*k1**4*(2*r + 2*s - 1)*(2*C*(2*r + 6*s - 1) - 2*r - 8*s + 1) + Pk2*fd*k2**4*(28*C - 14)*(6*r**2 + r*(10*s - 3) + s*(4*s - 3)) + fd*k1**2*k2**2*(Pk2*(4*C*(204*r**2 + 18*r*(23*s - 9) + 210*s**2 - 151*s + 30) + 28*K*(2*s - 1)*(r + s - 1) - 450*r**2 - 912*r*s + 345*r - 462*s**2 + 302*s - 60) + Pkd2*k2*s*(42*C - 21)*(2*r + 2*s - 1)) - 14*gd2*(4*Pk2*k1**4*(r**2 + r*(4*s - 1) + s*(3*s - 2)) + 10*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 5*k1**2*k2**2*(2*Pk2*(4*r**2 + r*(9*s - 4) + s*(5*s - 4)) + Pkd2*k2*s*(r + s - 1)))) - 28*fd*k2**2*(r + s)*(-Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(r + s) + g2*(4*Pk2*k1**4*(r + 3*s) + 10*Pk2*k2**4*(r + s) + 5*k1**2*k2**2*(8*Pk2*r + 10*Pk2*s + Pkd2*k2*s)))) + Dd*f*(3*f**2*k1**4*(12*Pk2*k2**2*(10*r**2 + r*(18*s - 17) + 8*s**2 - 11*s + 6) + k1**2*(2*Pk2*(4*s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(4*r + 4*s - 3))) + 2*f*k2**2*(6*Pk2*k1**4*(8*C*(4*r**2 + 2*r*(8*s - 3) + 12*s**2 - 11*s + 2) - 16*r**2 + r*(26 - 80*s) - 64*s**2 + 56*s - 9) + Pk2*k2**4*(112*C - 56)*(3*r**2 + r*(5*s - 2) + s*(2*s - 2)) + k1**2*k2**2*(Pk2*(4*C*(408*r**2 + 6*r*(138*s - 73) + 420*s**2 - 407*s + 89) + 28*K*(4*s - 1)*(r + s - 1) - 900*r**2 - 1824*r*s + 960*r - 924*s**2 + 835*s - 178) + Pkd2*k2*s*(42*C - 21)*(4*r + 4*s - 3))) - 28*k2**2*(-Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(4*Pk2*k1**4*(4*r**2 + 4*r*(4*s - 1) + s*(12*s - 7)) + 10*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 5*k1**2*k2**2*(Pk2*(32*r**2 + 72*r*s - 26*r + 40*s**2 - 26*s) + Pkd2*k2*s*(4*r + 4*s - 3)))))))/(105*d**2*k2**2*k3**6) - D1**3*Pk3*st**2*(2*D1*bd1*f*(f*(Pk2*k2**2*r*(4*C - 2)*(11*r - 9) + k1**2*(2*Pk2*(r*(16*s - 11) + 2*s*(28*C*s - 14*C - 14*s + 5)) + 7*k2*(Pkd2*(-2*r*s + r - s*(2*C - 1)*(5*s - 3)) + Pkdd2*k2*s*(2*C - 1)*(s - 1)))) + k1**2*s*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(35*b2 - 70*g2)*(s - 1)) + 35*b1**3*k1**2*(D1*fd*s*(Pk2 - Pkd2*k2)*(r - 1) + 2*Dd*f*(Pk2*(2*r*(s - 1) - 5*s + 2) + Pkd2*k2*(-2*r*s + r + 3*s - 1))) + 7*b1**2*k1**2*(5*D1*bd1*f*(Pk2*(r*(3*s - 4) - 9*s + 4) + Pkd2*k2*(r*(2 - 3*s) + 5*s - 2)) + D1*fd*(4*C*Pkd2*k2*s**2 - 4*C*Pkdd2*k2**2*s**2 + 10*K*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)**2 + Pk2*f*(r*(2 - 18*s) + 39*s - 16) + 52*Pk2*r*s - 60*Pk2*r + 8*Pk2*s - 5*Pkd2*f*k2*(2*r - 1)*(3*s - 2) - 16*Pkd2*k2*r*s + 20*Pkd2*k2*r - 2*Pkd2*k2*s**2 - 4*Pkd2*k2*s + 2*Pkdd2*k2**2*s**2) - 2*Dd*f*(Pk2*f*(r*(18*s + 13) - 39*s + 1) - 2*Pk2*(10*K*(4*s**2 - 5*s + 1) + r*(52*s - 29) - 4*s + 9) + Pkd2*k2*(-8*C*s**2 + 2*C*s + 15*K*(4*s**2 - 5*s + 1) + 5*f*(2*r - 1)*(3*s - 2) + 32*r*s - 24*r + 4*s**2 - 5*s + 9) - Pkdd2*k2**2*(4*s - 1)*(-2*C*s + 5*K*(s - 1) + s))) + b1*(-7*D1*bd1*f*k1**2*(Pk2*f*(2*r*(9*s + 14) - 39*s - 14) - 4*Pk2*(20*K*s**2 + r*(26*s - 9) - s*(20*K + 3) + 4) + Pkd2*k2*(5*f*(2*r - 1)*(3*s - 2) + 2*r*(16*s - 9) + s**2*(-8*C + 60*K + 4) + s*(4*C - 60*K - 8) + 8) + 2*Pkdd2*k2**2*s*(C*(4*s - 2) - 10*K*(s - 1) - 2*s + 1)) + 2*D1*(f*(fd*(Pk2*k2**2*(4*C - 2)*(22*r**2 - 29*r + 9) + k1**2*(2*Pk2*(28*C*(1 - 2*s)**2 + 32*r*s - 37*r - 56*s**2 + 47*s + 1) + 7*k2*(Pkd2*(C*(-20*s**2 + 22*s - 6) - 4*r*s + 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*(2*C - 1)*(2*s**2 - 3*s + 1)))) + k1**2*s*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(35*bd2 - 70*gd2)*(s - 1)) - 70*fd*g2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f*(Pk2*k2**2*(8*C - 4)*(22*r**2 - 29*r + 9) + k1**2*(2*Pk2*(28*C*(8*s**2 - 6*s + 1) + 64*r*s - 59*r - 112*s**2 + 66*s + 12) + 7*k2*(Pkd2*(C*(-40*s**2 + 34*s - 6) - 8*r*s + 5*r + 20*s**2 - 15*s + 1) + Pkdd2*k2*(2*C - 1)*(4*s**2 - 5*s + 1)))) - 70*g2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 70*b2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d**2*k1**2*k2**2) + D1**3*Pk3*(-4*D1*bd1*f*k1**2*s*(-Pk2*f*(-2*C*(s - 1) + 2*r + s - 1) + Pkd2*f*k2*(4*C - 2)*(s - 1) + 5*b2*(Pk2 + Pkd2*k2)*(s - 1) - 10*g2*(Pk2 + Pkd2*k2)*(s - 1)) + 5*b1**3*k1**2*(D1*fd*s*(5*Pk2 + 3*Pkd2*k2)*(r - 1) + 2*Dd*f*(Pk2*(10*r*s - 3*r - 11*s + 3) + 3*Pkd2*k2*s*(2*r - 1))) + b1**2*(5*D1*bd1*f*k1**2*(Pk2*(3*r*(5*s - 2) - 17*s + 6) + 3*Pkd2*k2*s*(3*r - 1)) - 4*D1*fd*(5*K*k1**2*(Pk2 + Pkd2*k2)*(s - 1)**2 + Pk2*k1**2*(r*(5 - 11*s) + 6*s) + Pk2*k2**2*(6*C - 3)*(r - 1)**2) - 4*Dd*f*(Pk2*k2**2*(12*C - 6)*(2*r**2 - 3*r + 1) + k1**2*(5*K*Pkd2*k2*(4*s**2 - 5*s + 1) + Pk2*(5*K*(4*s**2 - 5*s + 1) - 44*r*s + 8*r + 18*s - 3)))) + 4*b1*(D1*bd1*f*(6*Pk2*k2**2*r*(-2*C*(r - 1) + r - 1) + k1**2*(-10*K*Pkd2*k2*s*(s - 1) + Pk2*(-10*K*s**2 + 10*K*s + 22*r*s - 3*r - 6*s + 3))) + k1**2*(D1*(-f*fd*(2*s - 1)*(-Pk2*(-2*C*(s - 1) + 2*r + s - 1) + Pkd2*k2*(4*C - 2)*(s - 1)) - 5*f*s*(Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(s - 1) + 10*fd*g2*(Pk2 + Pkd2*k2)*(s - 1)**2) - Dd*f*(4*s - 1)*(-Pk2*f*(-2*C*(s - 1) + 2*r + s - 1) + Pkd2*f*k2*(4*C - 2)*(s - 1) - 10*g2*(Pk2 + Pkd2*k2)*(s - 1)) - 5*b2*(Pk2 + Pkd2*k2)*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)))))/(15*d**2*k1**2*k2**2) + D1**3*Pk3*st**4*(3*D1*bd1*f*k1**2*(f**2*(k1**2*(Pk2*(18*r*(3*s - 2) + 288*s**2 - 115*s + 18) + k2*(Pkd2*(-18*r*s + 12*r - 108*s**2 + 49*s - 6) + 6*Pkdd2*k2*s*(2*s - 1))) + k2**2*(r - 1)*(Pk2*(84*r + 25*s - 10) + 7*Pkd2*k2*(5*s - 2))) - 2*f*(k1**2*(4*Pk2*(-4*r*s + r + s**2*(-4*K + 16*b1 - 1) + s*(2*K - 8*b1 + 6) - 1) + k2*(Pkd2*(r*(4*s - 1) + s**2*(10*K - 40*b1 + 1) + s*(-5*K + 20*b1 - 6) + 1) + Pkdd2*k2*s*(-K + 4*b1)*(2*s - 1))) + k2**2*(Pk2*(2*C*r*(2 - 16*s) + 7*K*(r*(5*s - 6) + 8*s**2 - 13*s + 6) - 7*b1*(8*r - 5) + 2*r**2*(4*C - 11) + 100*r*s + 2*r + 2*s*(4*C - 16) + 12) + k2*(Pkd2*(16*C*r*s - 4*C*r - 6*C*s - 7*K*(r*(s - 2) + 6*s**2 - 6*s + 2) + 7*b1*(3*r - 2) - 36*r*s + 8*r + 17*s - 6) + Pkdd2*k2*s*(2*C + 7*K*(2*s - 1) - 1)))) + 14*k2**2*(b1*(-2*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + k2*(K*Pkd2*(r*(4 - 8*s) + s - 2) + K*Pkdd2*k2*s - Pkd2*r + Pkd2)) + b2*k2*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + 4*g2*r*(Pk2*(r - 4*s + 2) + Pkd2*k2*(2*s - 1)))) - 6*b1**2*k1**2*(D1*fd*(f*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 + 4*s - 1) + 7*k2**2*(-4*Pk2*r + Pk2 + Pkd2*k2*r)) - 7*k2**2*(-2*K*Pk2*r*(r - 4*s + 4) + K*Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + K*Pkdd2*k2**2*(2*s - 1) + 2*Pk2*r*(r + 2) - 2*Pkd2*k2*r)) + Dd*f*(28*Pk2*k2**2*(2*K*(r**2 + r*(2 - 4*s) + s - 1) - 2*r**2 - r + 1) + f*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(16*s**2 - 1) + 14*f*k2**2*(-3*Pk2 + Pkd2*k2)*(2*r - 1) - 7*k2**3*(K*Pkdd2*k2*(4*s - 1) + Pkd2*(K*(-16*r*s + 10*r - 3) - 4*r + 2)))) + 3*b1*k1**2*(D1*(f**2*fd*(k1**2*(Pk2*(6*r*(27*s - 10) + 864*s**2 - 633*s + 118) + k2*(Pkd2*(-54*r*s + 24*r - 324*s**2 + 255*s - 52) + 6*Pkdd2*k2*(6*s**2 - 5*s + 1))) + k2**2*(Pk2*(252*r**2 + 75*r*s - 296*r - 165*s + 136) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2))) + 2*f*(fd*(k1**2*(2*s - 1)*(4*Pk2*(K*(4*s - 2) + 4*r + s - 4) + k2*(K*Pkdd2*k2*(2*s - 1) - Pkd2*(10*K*s - 5*K + 4*r + s - 4))) + k2**2*(-2*Pk2*(2*C*(2*r - 1)*(2*r - 8*s + 3) + 7*K*(5*r*s - 4*r + 8*s**2 - 8*s + 2) - 22*r**2 + 100*r*s - 46*r - 8*s + 4) + k2*(Pkd2*(C*(r*(16 - 32*s) + 8*s - 6) + 7*K*(2*r*(s - 1) + 3*(1 - 2*s)**2) + 72*r*s - 40*r - 4*s + 5) + Pkdd2*k2*(C*(8*s - 2) - 7*K*(1 - 2*s)**2 - 4*s + 1)))) + 7*k2**2*(4*Pk2*gd2*(r**2 - 4*r*s + r + 2*s - 2) + bd2*k2*s**2*(-Pkd2 + Pkdd2*k2) - 2*gd2*k2*(Pkd2*(-4*r*s + 2*r + s - 2) + Pkdd2*k2*s))) + 14*fd*k2**2*(b2*k2*s**2*(-Pkd2 + Pkdd2*k2) - 2*g2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*s + 4*r - 2*s + 1) + Pkdd2*k2**2*(2*s - 1)))) + 2*Dd*f*(f**2*(k1**2*(2*Pk2*(6*r*(9*s - 4) + 288*s**2 - 187*s + 34) + k2*(Pkd2*(-36*r*s + 18*r - 216*s**2 + 152*s - 29) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(168*r**2 + 50*r*s - 195*r - 95*s + 73) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) + f*(k1**2*(4*Pk2*(2*K*(8*s**2 - 6*s + 1) + 16*r*s - 6*r + 4*s**2 - 21*s + 6) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) - Pkd2*(5*K*(8*s**2 - 6*s + 1) + 16*r*s - 6*r + 4*s**2 - 21*s + 6))) + k2**2*(-2*Pk2*(8*C*(2*r - 1)*(r - 4*s + 1) + 7*K*(10*r*(s - 1) + 16*s**2 - 21*s + 8) - 44*r**2 + 200*r*s - 42*r - 44*s + 18) + k2*(Pkd2*(C*(-8*r*(8*s - 3) + 24*s - 10) + 7*K*(4*r*s - 6*r + 24*s**2 - 24*s + 7) + 144*r*s - 58*r - 40*s + 21) + Pkdd2*k2*(4*s - 1)*(2*C + K*(7 - 14*s) - 1)))) + 7*k2**2*(b2*k2*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 2*g2*(8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(2*r*(8*s - 5) + 3) + Pkdd2*k2*(1 - 4*s)))))) + 2*f*(D1*(f*fd*(Pk2*k2**4*(2 - 4*C)*(27*r**2 - 24*r + 5) + k1**4*(3*s - 1)*(4*Pk2*(4*C*(3*s - 1) + 6*r - 3*s - 4) + k2*(Pkd2*(-30*C*s + 10*C - 6*r + 12*s + 1) + Pkdd2*k2*(2*C - 1)*(3*s - 1))) + k1**2*k2**2*(Pk2*(-2*C*(3*r*(69*s - 38) + 144*s**2 - 153*s + 50) + 18*r**2 + 99*r*s - 48*r + 144*s**2 - 117*s + 26) + k2*(Pkd2*(2*C*(63*r*s - 30*r + 90*s**2 - 78*s + 19) - 27*r*s + 15*r - 90*s**2 + 72*s - 16) + Pkdd2*k2*(3 - 6*C)*(6*s**2 - 5*s + 1)))) + 3*f*k1**2*(bd2 - 2*gd2)*(8*Pk2*k1**2*s*(2*s - 1) + 5*Pkd2*k1**2*k2*s*(1 - 2*s) + 7*Pkd2*k2**3*(r*(s - 2) + 6*s**2 - 6*s + 2) + 7*Pkdd2*k2**4*s*(1 - 2*s) - k2**2*(7*Pk2*(5*r*s - 6*r + 8*s**2 - 13*s + 6) + Pkdd2*k1**2*s*(1 - 2*s))) - 6*fd*g2*k1**4*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 42*fd*g2*k1**2*k2**2*(2*Pk2*(r*(5*s - 4) + 2*(1 - 2*s)**2) + k2*(-2*Pkd2*r*(s - 1) - 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))) + Dd*f*(Pk2*f*k2**4*(4 - 8*C)*(18*r**2 - 19*r + 5) + f*k1**4*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 12*s**2 - 15*s + 5) + k2*(-Pkd2*(10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 48*s**2 + 6*s + 2) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) + f*k1**2*k2**2*(-2*Pk2*(2*C*(138*r*s - 80*r + 96*s**2 - 125*s + 48) - 12*r**2 - 66*r*s + 43*r - 96*s**2 + 99*s - 29) + k2*(Pkd2*(2*C*(84*r*s - 44*r + 120*s**2 - 116*s + 33) - 36*r*s + 26*r - 120*s**2 + 104*s - 27) + Pkdd2*k2*(3 - 6*C)*(8*s**2 - 6*s + 1))) - 6*g2*k1**4*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + 42*g2*k1**2*k2**2*(2*Pk2*(10*r*(s - 1) + 16*s**2 - 21*s + 8) + k2*(Pkd2*(-4*r*s + 6*r - 24*s**2 + 24*s - 7) + Pkdd2*k2*(8*s**2 - 6*s + 1)))) + 3*b2*k1**2*(D1*fd*(k1**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) - 7*k2**2*(2*Pk2*(r*(5*s - 4) + 2*(1 - 2*s)**2) + k2*(-2*Pkd2*r*(s - 1) - 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))) + Dd*f*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) - 7*k2**2*(2*Pk2*(10*r*(s - 1) + 16*s**2 - 21*s + 8) + k2*(Pkd2*(-4*r*s + 6*r - 24*s**2 + 24*s - 7) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(105*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*(D1*bd1*f*(-105*b1**2*k1**2*k2**2*(Pk2*(12*r**2 + 9*r*(s - 2) - 7*s + 6) + Pkd2*k2*s*(3*r - 1)) + 14*b1*(Pk2*k2**4*r*(24*C - 12)*(r - 1) + k1**4*(10*Pk2*r*(4*s - 1) + 4*Pk2*s*(C*(4*s - 2) + s - 3) + 5*Pkd2*k2*s*(2*s - 1)) + k1**2*k2**2*(5*K*Pkd2*k2*s*(1 - 6*r) + Pk2*(-36*C*(r*(4*s - 1) - 2*s + 1) + r**2*(20 - 60*K) + r*(K*(60 - 50*s) + 48*s - 32) - s*(15*K + 24) + 12))) + f*k1**4*(Pk2*(7*b1*(12*r*(9*s - 5) + 16*s**2 - 81*s + 40) + 8*r*(37*s - 15) - (4*s - 4)*(s*(7*K - 21) + 15)) + 7*Pkd2*k2*s*(b1*(60*r + 32*s - 23) + (6 - 8*K)*(s - 1))) + 2*f*k1**2*k2**2*(Pk2*(-2*C*(180*r**2 + 133*r*s - 216*r - 84*s + 84) + 222*r**2 + 133*r*s - 244*r - 84*s + 84) + Pkd2*k2*r*s*(63 - 126*C)) - 70*k1**2*k2**2*(b2*(Pk2*(6*r**2 + r*(9*s - 6) + s*(6*s - 6)) + Pkd2*k2*s*(3*r + 2*s - 2)) - 2*g2*r*(Pk2*(6*r + 5*s - 6) + 3*Pkd2*k2*s))) - 105*b1**3*k1**2*k2**2*(D1*fd*(r - 1)*(Pk2*(4*r + 3*s - 4) + Pkd2*k2*s) + 2*Dd*f*(Pk2*(8*r**2 + 6*r*s - 13*r - 5*s + 5) + Pkd2*k2*s*(2*r - 1))) + 7*b1**2*(D1*fd*(-10*K*k1**2*k2**2*(Pk2*(6*r**2 + r*(5*s + 4) + 12*s - 6) + Pkd2*k2*(s*(3*r + 4) - 2)) + 4*Pk2*k1**4*s*(4*C*s + 10*r + s) + 4*Pk2*k1**2*k2**2*(5*r**2 + r*(s*(12 - 36*C) + 5) + s*(36*C - 12)) + 2*Pk2*k2**4*(12*C - 6)*(r - 1)**2 + 10*Pkd2*k1**4*k2*s**2 + f*k1**4*(Pk2*(16*s**2 + s*(108*r - 59) - 4) + Pkd2*k2*(32*s**2 + s*(60*r - 21) - 8))) + 2*Dd*f*(Pk2*k2**4*(24*C - 12)*(2*r**2 - 3*r + 1) + 2*f*k1**4*(Pk2*(3*r*(18*s - 5) + 8*s**2 - 35*s + 9) + Pkd2*k2*(16*s**2 + s*(30*r - 11) - 2)) + k1**4*(2*Pk2*(5*r*(8*s - 1) + s*(16*C*s - 4*C + 4*s - 11)) + 5*Pkd2*k2*s*(4*s - 1)) - 2*k1**2*k2**2*(5*K*Pkd2*k2*(6*r*s + s - 1) + Pk2*(18*C*(r*(8*s - 1) - 6*s + 1) + 5*K*(12*r**2 + 10*r*s - 7*r + 9*s - 3) - 20*r**2 - 48*r*s + 16*r + 36*s - 6)))) - 2*b1*k1**2*(D1*(f*(fd*(14*K*k1**2*(Pk2 + 2*Pkd2*k2)*(2*s**2 - 3*s + 1) + 4*Pk2*k1**2*(r*(7 - 74*s) + s*(30 - 21*s)) + Pk2*k2**2*(C*(720*r**2 + 76*r*(7*s - 8) - 42*s + 40) - 444*r**2 - 266*r*s + 318*r + 21*s - 20) - 42*Pkd2*k1**2*k2*s**2 + Pkd2*k2**3*(14*C - 7)*(s*(18*r + 3) - 4)) + 35*k2**2*(bd2*(Pk2*(6*r**2 + 9*r*s - 6*r + 6*s**2 - 3*s) + Pkd2*k2*s*(3*r + 2*s - 3)) - 2*gd2*(Pk2*(6*r**2 + 5*r*s - 6*r + 3*s) + Pkd2*k2*s*(3*r - 1)))) + 35*fd*k2**2*(b2*(Pk2*(6*r**2 + 9*r*s + 6*s**2) + Pkd2*k2*s*(3*r + 2*s)) - 2*g2*(Pk2*(6*r**2 + 5*r*s + 4*r + 12*s - 6) + Pkd2*k2*(3*r*s + 4*s - 2)))) + Dd*f*(f*(k1**2*(2*Pk2*(7*K*(4*s**2 - 5*s + 1) - 296*r*s + 44*r - 84*s**2 + 141*s - 15) + 7*Pkd2*k2*(4*s - 1)*(4*K*(s - 1) - 3*s)) + 2*k2**2*(Pk2*(2*C*(360*r**2 + 266*r*s - 395*r - 91*s + 97) - 444*r**2 - 266*r*s + 437*r + 91*s - 97) + Pkd2*k2*(14*C - 7)*(s*(18*r - 1) - 2))) + 70*k2**2*(b2*(3*Pk2*(4*r**2 + 6*r*s - 3*r + 4*s**2 - 2*s) + 2*Pkd2*k2*s*(3*r + 2*s - 2)) - 2*g2*(Pk2*(12*r**2 + 10*r*s - 7*r + 9*s - 3) + Pkd2*k2*(6*r*s + s - 1))))) - 4*f*k1**4*(D1*(3*f*fd*(3*s - 1)*(-Pk2*(-2*C*(s - 1) + 3*r + s - 1) + Pkd2*k2*(6*C - 3)*(s - 1)) + 7*f*s*(Pk2 + 2*Pkd2*k2)*(bd2 - 2*gd2)*(s - 1) - 14*fd*g2*(Pk2 + 2*Pkd2*k2)*(2*s**2 - 3*s + 1)) + Dd*f*(4*s - 1)*(-3*Pk2*f*(-2*C*(s - 1) + 3*r + s - 1) + Pkd2*f*k2*(18*C - 9)*(s - 1) - 14*g2*(Pk2 + 2*Pkd2*k2)*(s - 1)) + 7*b2*(Pk2 + 2*Pkd2*k2)*(s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(105*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*st**4*(-3*D1*bd1*f*k1**2*(f**2*(4*k1**4*(4*Pk2*(r*(3*s - 2) + 9*s**2 - 12*s + 1) + k2*(Pkd2*(-3*r*s + 2*r - 18*s**2 + 24*s - 1) + Pkdd2*k2*s*(3*s - 4))) + 3*k1**2*k2**2*(Pk2*(48*r**2 - 6*r*(24*s + 19) - 128*s**2 + 7*s + 66) + k2*(Pkd2*(58*r*s + 20*r + 18*s**2 - 15*s - 20) + 2*Pkdd2*k2*s*(4*s - 1))) + 3*k2**4*(r - 1)*(Pk2*(76*r + 65*s - 58) + 7*Pkd2*k2*(5*s - 2))) + 6*f*k1**2*k2**2*(2*Pk2*(K*(2*r**2 - 17*r*s + 4*r - 10*s**2 + 38*s - 6) + b1*(r*(32*s - 1) + 32*s**2 - 25*s - 1) - 7*r**2 - 7*r*s + 14*r - 6*s**2 - 4*s - 7) + k2*(Pkd2*(K*(18*r*s - 8*r + 10*s**2 - 35*s + 8) + b1*(-32*r*s + r - 20*s**2 + 19*s + 1) - 4*r*s + r - s**2 + 6*s - 1) - Pkdd2*k2*s*(-K + 6*b1)*(2*s - 1))) - 3*f*k2**4*(14*K*Pk2*(12*r**2 - 3*r*(s + 6) - 8*s**2 - 5*s + 6) - 7*Pk2*b1*(2*r*(9*s - 2) - 9*s + 4) - 4*Pk2*(r**2*(53 - 12*C) + r*(-2*C*(8*s - 5) + 22*s - 59) + s*(4*C - 16) + 6) + Pkd2*k2*(-8*C*(r*(4*s - 3) + 3*s**2 - 6*s + 2) + 14*K*(15*r*s - 2*r + 10*s**2 - 10*s + 2) + 7*b1*(2*r*(s + 1) + s - 2) - 32*r*s - 2*r + 12*s**2 + 2*s - 4) + 2*Pkdd2*k2**2*s*(-4*C*(s - 1) + 14*K*s - 7*K + 2*s - 2)) + 42*k2**4*(-2*Pk2*b1*(K*(6*r**2 + r*(8*s - 7) - 2*s + 2) + 2*r**2 - 1) + 2*Pkd2*b2*k2*(r*(2*s - 1) + s*(2*s - 2)) + b1*k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s)) + 2*g2*(2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(2 - 4*s) - 3*Pkd2*s*(s - 1) - Pkdd2*k2*s*(s - 1))))) + 9*b1**2*k1**2*k2**2*(D1*fd*(f*(-2*k1**2*(2*Pk2*(r*(32*s + 9) + 32*s**2 + s - 9) - k2*(Pkd2*(32*r*s + 9*r + 20*s**2 + s - 9) + 12*Pkdd2*k2*s**2)) + 7*k2**2*(Pk2*(-2*r*(9*s + 2) + 9*s + 4) + Pkd2*k2*s*(2*r + 1))) - 14*k2**2*(K*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) - 2*r*(Pk2*(r + 2) + Pkd2*k2*s))) - 2*Dd*f*(f*(2*k1**2*(2*Pk2*(4*r*(8*s + 1) + 32*s**2 - 12*s - 5) + k2*(Pkd2*(-4*r*(8*s + 1) - 20*s**2 + 9*s + 5) + 3*Pkdd2*k2*s*(1 - 4*s))) - 7*k2**2*(9*Pk2*s*(1 - 2*r) + Pkd2*k2*(2*r*s + r + s - 1))) + 7*k2**2*(-4*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + k2*(K*Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(-8*r*s + r + 2*s))))) - 3*b1*k1**2*(D1*(f**2*fd*(2*k1**4*(24*Pk2*(r*(3*s - 1) + 9*s**2 - 3*s + 1) + k2*(-3*Pkd2*(6*r*s - 2*r + 36*s**2 + 1) + Pkdd2*k2*(18*s**2 + 6*s - 1))) + 3*k1**2*k2**2*(Pk2*(144*r**2 - 18*r*(24*s + 5) - 384*s**2 + 433*s - 18) + k2*(Pkd2*(6*r*(29*s - 6) + 54*s**2 - 127*s + 30) + 6*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 3*k2**4*(Pk2*(228*r**2 + 195*r*s - 208*r - 205*s + 72) + 7*Pkd2*k2*(3*r - 1)*(5*s - 2))) - 6*f*k2**2*(fd*(k1**2*(Pk2*(K*(-8*r**2 + 4*r*(17*s - 5) + 40*s**2 - 96*s + 38) + 28*r**2 + 28*r*(s - 2) + 6*(1 - 2*s)**2) - k2*(2*s - 1)*(K*Pkdd2*k2*(2*s - 1) + Pkd2*(K*(18*r + 10*s - 19) - 4*r - s + 4))) + k2**2*(2*Pk2*(2*C*(2*r - 1)*(6*r + 8*s - 7) + 7*K*(12*r**2 - 3*r*s - 8*s**2 + 8*s - 2) - 106*r**2 - 44*r*s + 34*r + 8*s - 8) + k2*(Pkd2*(-8*C*(r*(4*s + 2) + 3*s**2 + 2*s - 2) + 7*K*(2*r*(15*s - 7) + 5*(1 - 2*s)**2) + 4*r*(9 - 8*s) + 12*s**2 + 4*s - 8) + Pkdd2*k2*(7*K*(1 - 2*s)**2 + s**2*(4 - 8*C))))) + 14*k2**2*(-2*Pk2*gd2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + Pkd2*bd2*k2*s*(-2*r - 2*s + 1) + gd2*k2*(Pkd2*(r*(4*s + 2) + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2))) - 84*fd*k2**4*(-2*Pkd2*b2*k2*s*(r + s) + g2*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2))) + 2*Dd*f*(f**2*(k1**4*(8*Pk2*(r*(12*s - 5) + 36*s**2 - 21*s + 4) + k2*(Pkd2*(-24*r*s + 10*r - 144*s**2 + 48*s - 5) + Pkdd2*k2*(24*s**2 - 2*s - 1))) + 3*k1**2*k2**2*(96*Pk2*r**2 - 6*Pk2*r*(48*s + 17) + 4*Pk2*(-64*s**2 + 55*s + 6) + Pkd2*k2*(4*r*(29*s - 2) + 36*s**2 - 71*s + 5) + Pkdd2*k2**2*(16*s**2 - 16*s + 3)) + 3*k2**4*(Pk2*(152*r**2 + 130*r*s - 171*r - 135*s + 65) + 7*Pkd2*k2*(2*r - 1)*(5*s - 2))) - 3*f*k2**2*(k1**2*(2*Pk2*(K*(-8*r**2 + 2*r*(34*s - 9) + 40*s**2 - 124*s + 31) + 28*r**2 + 28*r*(s - 2) + 24*s**2 - 4*s + 17) - k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(K*(72*r*s - 34*r + 40*s**2 - 118*s + 35) - 16*r*s + 6*r - 4*s**2 + 21*s - 6))) + k2**2*(2*Pk2*(8*C*(2*r - 1)*(3*r + 4*s - 3) + 7*K*(24*r**2 - 6*r*(s + 3) - 16*s**2 + 3*s + 4) - (4*r - 2)*(53*r + 22*s - 13)) + k2*(Pkd2*(-4*C*(2*r*(8*s + 1) + 12*s**2 - 3*s - 3) + 7*K*(60*r*s - 18*r + 40*s**2 - 40*s + 9) - 64*r*s + 44*r + 24*s**2 + 14*s - 19) + Pkdd2*k2*(4*s - 1)*(7*K*(2*s - 1) + s*(2 - 4*C))))) - 42*k2**4*(Pkd2*b2*k2*(-8*r*s + r + s*(4 - 8*s)) + g2*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) + 2*f*(D1*(f**2*fd*k1**4*(3*k1**2*(Pk2*(10*r*(17*s - 4) + 768*s**2 - 461*s + 66) + k2*(Pkd2*(-50*r*s + 15*r - 264*s**2 + 173*s - 28) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(1296*r**2 + 9*r*(50*s - 161) + 120*s**2 - 745*s + 523) + Pkd2*k2*(162*r*(5*s - 2) + 240*s**2 - 545*s + 182))) + 3*f*k2**2*(6*bd2*(k1**4*(2*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + 7*k1**2*k2**2*(2*Pk2*(r**2 - r*(s + 1) - 2*s**2 + s) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + fd*(Pk2*k2**4*(4*C - 2)*(27*r**2 - 24*r + 5) + k1**4*(-6*Pk2*(2*C*(3*r**2 - 27*r*s + 4*r - 24*s**2 + 30*s - 6) - 15*r**2 + 2*r*(9*s + 7) + 24*s**2 - 26*s + 1) - k2*(3*s - 1)*(Pkd2*(C*(60*r + 42*s - 46) - 36*r - 24*s + 29) + Pkdd2*k2*(2*C - 1)*(3*s - 1))) + k1**2*k2**2*(3*Pk2*(2*C*(60*r**2 - 3*r*(41*s + 18) - 48*s**2 + 109*s - 6) - 102*r**2 + 111*r*s + 64*r + 48*s**2 - 113*s + 10) + k2*(Pkd2*(2*C*(81*r*s - 30*r + 54*s**2 - 66*s + 17) - 117*r*s + 45*r - 54*s**2 + 72*s - 20) + Pkdd2*k2*(6*C - 3)*(6*s**2 - 5*s + 1)))) + 6*gd2*k1**2*(k1**2*(2*Pk2*(2*r**2 + r*(4 - 17*s) - 10*s**2 + 38*s - 6) + k2*(Pkd2*(18*r*s - 8*r + 10*s**2 - 35*s + 8) + Pkdd2*k2*s*(2*s - 1))) - 7*k2**2*(Pk2*(12*r**2 - 3*r*(s + 6) - 8*s**2 - 5*s + 6) + k2*(Pkd2*(15*r*s - 2*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(2*s - 1))))) + 18*fd*k1**2*k2**2*(b2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + 14*b2*k2**2*(Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1) + g2*k1**2*(Pk2*(8*r**2 + r*(20 - 68*s) - 40*s**2 + 96*s - 38) + k2*(2*s - 1)*(Pkd2*(18*r + 10*s - 19) + Pkdd2*k2*(2*s - 1))) - 7*g2*k2**2*(2*Pk2*(12*r**2 - 3*r*s - 2*(1 - 2*s)**2) + k2*(2*Pkd2*r*(15*s - 7) + 5*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2)))) + Dd*f*(f**2*k1**4*(3*k1**2*(Pk2*(10*r*(17*s - 4) + 768*s**2 - 461*s + 66) + k2*(Pkd2*(-50*r*s + 15*r - 264*s**2 + 173*s - 28) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(1296*r**2 + 9*r*(50*s - 161) + 120*s**2 - 745*s + 523) + Pkd2*k2*(162*r*(5*s - 2) + 240*s**2 - 545*s + 182))) + 3*f*k2**2*(2*C*(4*Pk2*k2**4*(18*r**2 - 19*r + 5) - k1**4*(2*Pk2*(12*r**2 - 2*r*(54*s - 7) - 96*s**2 + 130*s - 23) + k2*(Pkd2*(120*r*s - 38*r + 84*s**2 - 129*s + 31) + Pkdd2*k2*(12*s**2 - 7*s + 1))) + k1**2*k2**2*(2*Pk2*(120*r**2 - 2*r*(123*s + 71) - 96*s**2 + 223*s + 22) + k2*(Pkd2*(4*r*(27*s - 7) + 72*s**2 - 76*s + 15) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1)))) - 4*Pk2*k2**4*(18*r**2 - 19*r + 5) + k1**4*(24*Pk2*(5*r**2 - r*(6*s + 5) + s*(10 - 8*s)) + Pkd2*k2*(9*r*(16*s - 5) + 96*s**2 - 158*s + 38) + Pkdd2*k2**2*(12*s**2 - 7*s + 1)) - k1**2*k2**2*(6*Pk2*(68*r**2 - r*(74*s + 59) - 32*s**2 + 75*s + 5) + k2*(Pkd2*(156*r*s - 46*r + 72*s**2 - 88*s + 21) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1)))) + 18*k1**2*k2**2*(b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + 14*b2*k2**2*(Pk2*(4*r**2 - r*(4*s + 1) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + g2*k1**2*(2*Pk2*(8*r**2 + r*(18 - 68*s) - 40*s**2 + 124*s - 31) + k2*(Pkd2*(72*r*s - 34*r + 40*s**2 - 118*s + 35) + Pkdd2*k2*(8*s**2 - 6*s + 1))) - 7*g2*k2**2*(2*Pk2*(24*r**2 - 6*r*(s + 3) - 16*s**2 + 3*s + 4) + k2*(Pkd2*(60*r*s - 18*r + 40*s**2 - 40*s + 9) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(315*d**2*k1**2*k2**2*k3**4) + D1**3*Pk3*st**2*(3*D1*bd1*f*(3*f**2*k1**4*(k1**2*(Pk2*(r*(35*s + 4) + 48*s**2 - 72*s - 4) + k2*(Pkd2*(-27*r*s - 2*r - 40*s**2 + 44*s + 2) + 4*Pkdd2*k2*s*(s - 1))) + k2**2*(Pk2*(64*r**2 - 4*r*(36*s + 25) - 144*s**2 + 61*s + 64) + Pkd2*k2*(42*r - 32*s**2 + 71*s - 42))) - f*(Pk2*k2**6*r*(4 - 8*C)*(11*r - 9) + 4*k1**6*(Pk2*(2*b1*(r*(6*s + 9) + 6*s**2 + s - 5) + r*(2*s + 3) - (s + 3)*(s*(K - 3) + 1)) - b1*k2*(Pkd2*(r*(6*s + 9) + 4*s - 5) + 3*Pkdd2*k2*s*(2*s - 1))) + k1**4*k2**2*(7*Pk2*b1*(64*r**2 + 6*r*(9*s - 10) - 64*s**2 - 19*s + 20) + 4*Pk2*(2*C*(6*r**2 - 119*r*s - 9*r + 3*s**2 + 48*s + 6) - 7*K*(5*r**2 + 9*r*s - r + 8*s**2 + 6*s - 4) + 15*r**2 + 175*r*s + 12*r + 37*s**2 - 47*s - 23) + Pkd2*k2*(8*C*(3*r*(9*s - 1) + 27*s**2 - 25*s - 2) - 14*K*(14*r*s - 8*r + 15*s**2 - 23*s + 8) + 7*b1*(14*r*(s - 1) + 20*s**2 - 13*s + 10) - 104*r*s + 10*r - 72*s**2 + 70*s + 16) + 2*Pkdd2*k2**2*s*(21*b1*(2*s - 1) + (s - 1)*(12*C - 7*K - 6))) + k1**2*k2**4*(7*Pk2*b1*(120*r**2 + 22*r*(3*s - 7) - 63*s + 62) + 2*Pk2*(2*C*(18*r**2 + r*(61*s - 52) - 38*s + 68) - 7*K*(34*r**2 + 93*r*s - 44*r + 84*s**2 - 57*s + 10) + 44*r**2 + 47*r*s + 16*r + 46*s - 76) + Pkd2*k2*(-4*C*(13*r*s - 38*r + 21*s**2 - 33*s + 12) - 14*K*(5*r*(3*s - 2) + 12*s**2 - 21*s + 10) + 6*r*(s*(35*b1 + 9) - 15) + 42*s**2 - s*(105*b1 + 66) + 24) + Pkdd2*k2**2*s*(14 - 28*C)*(s - 1))) - 14*k1**2*k2**2*(b1**2*k2*(-10*Pk2*k2*(r - 1)*(3*r + 3*s - 2) + Pkd2*k1**2*(9*r*s + r + 9*s**2 - 4*s - 1)) + b1*(k1**2*(2*Pk2*(K*(2*r**2 - 10*r*s + r - 6*s**2 + 12*s - 2) - 4*r**2 + 2*r*(s + 4) - 10*s + 1) + k2*(K*Pkdd2*k2*s*(2*s - 1) + Pkd2*r*(2*K*(6*s + 1) - 4*s + 1) + Pkd2*s*(K*(6*s - 11) + 2*s))) - k2**2*(4*C*(4*Pk2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*K*(Pk2*(4*r**2 + 2*r*(7*s + 3) + 8*s**2 - 3*s - 8) + k2*(2*Pkd2*(5*r*s - r + 5*s**2 - s - 1) + Pkdd2*k2*s*(2*s - 1))) - 64*Pk2*r**2 - 60*Pk2*r*s + 44*Pk2*r - 16*Pk2*s**2 + 38*Pk2*s - 28*Pkd2*k2*r*s + 7*Pkd2*k2*r - 8*Pkd2*k2*s**2 + 13*Pkd2*k2*s - 2*Pkd2*k2)) + 2*b2*k2*(-10*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*(r*(s + 2) + s*(s - 1)) - 5*Pkd2*k2**2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*(-k1**2*(2*Pk2*(r**2 - 5*r*s - s*(3*s - 3)) + Pkd2*k2*(r*(6*s + 2) + s*(3*s - 3)) + Pkdd2*k2**2*s*(s - 1)) + 5*k2**2*(Pk2*(2*r**2 + 7*r*s + s*(4*s - 4)) + Pkd2*k2*(r*(5*s - 4) + s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))))) - 42*b1**3*k1**2*k2**3*(-D1*fd*(10*Pk2*k2*(r - 1) - 3*Pkd2*k1**2*s)*(r + s - 1) + Dd*f*(-10*Pk2*k2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*(12*r*s + r + 12*s**2 - 7*s - 1))) - 3*b1**2*k1**2*(D1*fd*(8*f*k1**4*s*(Pk2*(6*r + 6*s - 8) + k2*(Pkd2*(4 - 3*r) - 3*Pkdd2*k2*s)) + 7*k1**2*k2**2*(Pk2*f*(64*r**2 + r*(54*s - 76) - 64*s**2 - 51*s + 28) + 4*Pk2*(K*(r**2 + r*(4 - 5*s) - 3*s**2 + 8*s - 4) - 2*r**2 + r*(s - 2) - 4*s + 2) + f*k2*(Pkd2*(2*r*(7*s + 10) + 20*s**2 + 17*s - 20) + 12*Pkdd2*k2*s**2) + 2*k2*s*(K*Pkdd2*k2*s + Pkd2*(3*K*s + r*(6*K - 2) + s))) - 7*k2**4*(10*K*k2*(Pkd2*(r*(5*s + 4) + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2) + Pk2*(32*C*(r + s - 1)**2 + 10*K*(2*r**2 + 7*r*s + 12*r + 4*s**2 + 8*s - 4) + f*(-120*r**2 + r*(124 - 66*s) + 63*s - 32) - 64*r**2 - 4*r*(15*s - 2) - 16*s**2 + 40*s - 24) + Pkd2*k2*s*(16*C*(r + s - 1) + f*(15 - 30*r) - 28*r - 8*s + 8))) + 2*Dd*f*(f*(2*k1**4*(2*Pk2*(3*r*(4*s + 3) + 12*s**2 - 7*s - 5) + k2*(Pkd2*(-3*r*(4*s + 3) + 4*s + 5) + 3*Pkdd2*k2*s*(1 - 4*s))) + 7*k1**2*k2**2*(Pk2*(64*r**2 + r*(54*s - 68) - 64*s**2 - 35*s + 24) + k2*(Pkd2*(14*r*s + 3*r + 20*s**2 + 2*s - 5) + 3*Pkdd2*k2*s*(4*s - 1))) + 7*k2**4*(Pk2*(120*r**2 + 66*r*s - 139*r - 63*s + 47) + 15*Pkd2*k2*s*(2*r - 1))) + 7*k1**2*k2**2*(2*Pk2*(K*(4*r**2 - 20*r*s + 6*r - 12*s**2 + 29*s - 8) - 8*r**2 + 4*r*s + 7*r - 24*s + 4) + k2*(K*Pkdd2*k2*s*(4*s - 1) + Pkd2*r*(K*(24*s + 2) - 8*s + 1) + Pkd2*s*(K*(12*s - 19) + 4*s + 1))) - 7*k2**4*(2*Pk2*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 5*K*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) - 64*r**2 - 60*r*s + 41*r - 16*s**2 + 44*s - 7) + k2*(5*K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 5*K*(20*r*s + 4*r + 20*s**2 + 9*s - 8) - 56*r*s + 7*r - 16*s**2 + 26*s - 2))))) + 3*b1*(D1*(3*f**2*fd*k1**4*(k1**2*(Pk2*(3*r*(35*s - 8) + 144*s**2 - 86*s + 24) + k2*(Pkd2*(-81*r*s + 24*r - 120*s**2 + 54*s - 14) + 2*Pkdd2*k2*(6*s**2 + 4*s - 1))) + k2**2*(Pk2*(192*r**2 - 4*r*(108*s + 37) - 432*s**2 + 531*s - 44) + 3*Pkd2*k2*(42*r - 32*s**2 + 19*s - 22))) + 2*f*(fd*(-2*Pk2*k1**6*(K*(-2*s**2 - 5*s + 3) + r*(4*s + 5) + 6*s**2 + 15*s - 9) + Pk2*k2**6*(4*C - 2)*(22*r**2 - 29*r + 9) + k1**4*k2**2*(-2*Pk2*(2*C*(12*r**2 + r*(47 - 238*s) + 6*s**2 + 174*s - 56) - 7*K*(10*r**2 + 18*r*s + 3*r + 16*s**2 + 12*s - 10) + 30*r**2 + 350*r*s - 80*r + 74*s**2 - 205*s + 54) + k2*(Pkd2*(-216*C*s**2 + 80*C*s + 7*K*(4*r*(7*s - 5) + 30*s**2 - 41*s + 13) + r*(-216*C*s + 104*s + 21) + 72*s**2 - 3*s - 14) + Pkdd2*k2*(7*K*(2*s**2 - 3*s + 1) + s**2*(12 - 24*C)))) + k1**2*k2**4*(-Pk2*(C*(72*r**2 + 4*r*(61*s - 56) - 318*s + 52) - 14*K*(34*r**2 + r*(93*s - 49) + 21*(1 - 2*s)**2) + 88*r**2 + 94*r*s + 58*r + 149*s - 44) + 2*k2*(Pkd2*(C*(r*(26*s + 42) + 42*s**2 + 85*s - 42) + 7*K*(5*r*(3*s - 2) + 3*(1 - 2*s)**2) - 3*r*(9*s + 7) - 21*s**2 - 39*s + 21) + Pkdd2*k2*s**2*(14*C - 7)))) - 14*k1**2*k2**2*(bd2*k2*(-10*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*s*(r + s - 3) - 5*Pkd2*k2**2*s*(2*r + 2*s - 1)) + gd2*(-k1**2*(2*Pk2*(r**2 - 5*r*s + r - 3*s**2 + 9*s - 2) + k2*s*(Pkd2*(6*r + 3*s - 8) + Pkdd2*k2*s)) + 5*k2**2*(Pk2*(2*r**2 + r*(7*s + 6) + 4*s**2 + s - 8) + k2*(Pkd2*(5*r*s + 2*r + 5*s**2 + 3*s - 2) + Pkdd2*k2*s**2))))) - 28*fd*k1**2*k2**2*(-b2*k2*(r + s)*(10*Pk2*k2*(r + s) - Pkd2*k1**2*s + 10*Pkd2*k2**2*s) + g2*(-k1**2*(2*Pk2*(r**2 - 5*r*s + 4*r - 3*s**2 + 8*s - 4) + k2*s*(6*Pkd2*r + 3*Pkd2*s + Pkdd2*k2*s)) + 5*k2**2*(Pk2*(2*r**2 + 7*r*s + 12*r + 4*s**2 + 8*s - 4) + k2*(Pkd2*(5*r*s + 4*r + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))))) + 2*Dd*f*(3*f**2*k1**4*(k1**2*(Pk2*(10*r*(7*s - 1) + 96*s**2 - 79*s + 10) + k2*(Pkd2*(-54*r*s + 11*r - 80*s**2 + 49*s - 6) + Pkdd2*k2*(8*s**2 + 2*s - 1))) + 2*k2**2*(Pk2*(64*r**2 - 2*r*(72*s + 31) - 144*s**2 + 148*s + 5) + Pkd2*k2*(42*r - 32*s**2 + 32*s - 27))) + f*(-2*Pk2*k1**6*(K*(-4*s**2 - 11*s + 3) + r*(8*s + 11) + 12*s**2 + 31*s - 15) + Pk2*k2**6*(8*C - 4)*(22*r**2 - 29*r + 9) + k1**4*k2**2*(-2*Pk2*(2*C*(24*r**2 - 7*r*(68*s - 5) + 12*s**2 + 353*s - 53) - 7*K*(20*r**2 + 36*r*s + r + 32*s**2 + 24*s - 18) + 60*r**2 + 700*r*s - 82*r + 148*s**2 - 403*s + 30) + k2*(Pkd2*(C*(r*(12 - 432*s) - 432*s**2 + 268*s + 8) + 7*K*(56*r*s - 36*r + 60*s**2 - 87*s + 29) + 208*r*s + 23*r + 144*s**2 - 70*s - 29) + Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(6 - 12*C)))) + k1**2*k2**4*(-2*Pk2*(2*C*(36*r**2 + r*(122*s - 119) - 159*s + 75) - 7*K*(68*r**2 + 93*r*(2*s - 1) + 168*s**2 - 141*s + 31) + 88*r**2 + 94*r*s + 52*r + 149*s - 97) + k2*(Pkd2*(2*C*(2*r*(26*s + 9) + 84*s**2 + 93*s - 44) + 14*K*(30*r*s - 20*r + 24*s**2 - 33*s + 13) - 108*r*s - 11*r - 84*s**2 - 79*s + 44) + Pkdd2*k2*s*(14*C - 7)*(4*s - 1)))) - 14*k1**2*k2**2*(b2*k2*(-10*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pkd2*k1**2*(r*(4*s + 2) + s*(4*s - 7)) - 5*Pkd2*k2**2*(r*(8*s - 1) + 4*s*(2*s - 1))) + g2*(k1**2*(-2*Pk2*(4*r**2 + r*(6 - 20*s) - 12*s**2 + 29*s - 8) + k2*(-Pkd2*(r*(24*s + 2) + s*(12*s - 19)) + Pkdd2*k2*s*(1 - 4*s))) + 5*k2**2*(2*Pk2*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) + k2*(Pkd2*(20*r*s + 4*r + 20*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1))))))) + 2*f*k1**2*(D1*(3*f**2*fd*k1**4*(Pk2*(5*r*(6*s + 11) - 144*s**2 + 75*s - 41) + 3*Pkd2*k2*(10*r*(3*s - 2) + 48*s**2 - 51*s + 16)) + f*(42*bd2*k2**2*(2*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(2*r**2 + 3*r*s - r + s**2 + 2*s - 1) + Pkd2*k2*(5*s - 3)*(r + s - 1))) + fd*(2*Pk2*k1**4*(2*C*(9*s**2 + 12*s - 5) - 3*r*(6*s + 4) - 36*s**2 - 33*s + 21) + k1**2*k2**2*(2*Pk2*(6*C*(69*r**2 + 93*r*s - 20*r + 54*s**2 - 4*s - 16) - 369*r**2 - 585*r*s + 180*r - 324*s**2 + 78*s + 56) + 9*k2*(2*C*Pkd2*(14*r*(3*s - 2) + 39*s**2 - 62*s + 21) - 8*Pkd2*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + Pkdd2*k2*(2*C - 1)*(3*s**2 - 4*s + 1))) + k2**4*(Pk2*(C*(2088*r**2 + 6*r*(693*s - 442) + 2376*s**2 - 2898*s + 892) - 1206*r**2 - 2295*r*s + 1452*r - 1188*s**2 + 1449*s - 446) + Pkd2*k2*(18*C - 9)*(15*r*(3*s - 2) + 24*s**2 - 35*s + 14))) - 6*gd2*(2*Pk2*k1**4*s*(s + 3) + 7*k1**2*k2**2*(2*Pk2*(5*r**2 + r*(9*s - 1) + 8*s**2 + 6*s - 4) + k2*(Pkd2*(14*r*s - 8*r + 15*s**2 - 23*s + 8) + Pkdd2*k2*s*(s - 1))) + 7*k2**4*(Pk2*(34*r**2 + r*(93*s - 44) + 84*s**2 - 57*s + 10) + Pkd2*k2*(5*r*(3*s - 2) + 12*s**2 - 21*s + 10)))) - 6*fd*(-7*b2*k2**2*(2*Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*(2*Pk2*(4*r**2 + 6*r*s + 2*s**2 + 5*s - 3) + Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))) + g2*(2*Pk2*k1**4*(2*s**2 + 5*s - 3) + 7*k1**2*k2**2*(Pk2*(20*r**2 + 6*r*(6*s + 1) + 32*s**2 + 24*s - 20) + k2*(Pkd2*(4*r*(7*s - 5) + 30*s**2 - 41*s + 13) + Pkdd2*k2*(2*s**2 - 3*s + 1))) + 14*k2**4*(Pk2*(34*r**2 + r*(93*s - 49) + 21*(1 - 2*s)**2) + Pkd2*k2*(5*r*(3*s - 2) + 3*(1 - 2*s)**2))))) + Dd*f*(42*b2*k2**2*(2*Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(8*r**2 + 12*r*s - 2*r + 4*s**2 + 9*s - 5) + Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10))) + 3*f**2*k1**4*(Pk2*(5*r*(6*s + 11) - 144*s**2 + 75*s - 41) + 3*Pkd2*k2*(10*r*(3*s - 2) + 48*s**2 - 51*s + 16)) + f*(-2*Pk2*k1**4*(-2*C*(12*s**2 + 17*s - 5) + r*(24*s + 17) + 48*s**2 + 46*s - 26) + k1**2*k2**2*(2*Pk2*(2*C*(276*r**2 + 372*r*s - 115*r + 216*s**2 - 38*s - 62) - 492*r**2 - 780*r*s + 285*r - 432*s**2 + 124*s + 74) + 9*k2*(Pkd2*(2*C*(56*r*s - 36*r + 52*s**2 - 85*s + 29) - 64*r*s + 41*r - 64*s**2 + 98*s - 33) + Pkdd2*k2*(2*C - 1)*(4*s**2 - 5*s + 1))) + 2*k2**4*(Pk2*(2*C*(696*r**2 + 1386*r*s - 907*r + 792*s**2 - 945*s + 293) - 804*r**2 - 1530*r*s + 997*r - 792*s**2 + 945*s - 293) + Pkd2*k2*(18*C - 9)*(10*r*(3*s - 2) + 16*s**2 - 27*s + 12))) - 6*g2*(2*Pk2*k1**4*(4*s**2 + 11*s - 3) + 7*k1**2*k2**2*(2*Pk2*(20*r**2 + 36*r*s + r + 32*s**2 + 24*s - 18) + k2*(Pkd2*(56*r*s - 36*r + 60*s**2 - 87*s + 29) + Pkdd2*k2*(4*s**2 - 5*s + 1))) + 14*k2**4*(Pk2*(68*r**2 + 93*r*(2*s - 1) + 168*s**2 - 141*s + 31) + Pkd2*k2*(10*r*(3*s - 2) + 24*s**2 - 33*s + 13))))))/(315*d**2*k1**2*k2**2*k3**4) + 2*D1**3*Pkd3*ct**8*f*k1**2*k2**2*(4*Pk2 - Pkd2*k2)*(1584*C*D1*f*fd*r*s - 726*C*D1*f*fd*r + 1584*C*D1*f*fd*s**2 - 1584*C*D1*f*fd*s + 418*C*D1*f*fd + 2112*C*Dd*f**2*r*s - 880*C*Dd*f**2*r + 2112*C*Dd*f**2*s**2 - 2112*C*Dd*f**2*s + 572*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 1400*D1*f**2*fd*r*s - 427*D1*f**2*fd*r + 1400*D1*f**2*fd*s**2 - 1400*D1*f**2*fd*s + 301*D1*f**2*fd - 1584*D1*f*fd*r*s + 726*D1*f*fd*r - 1584*D1*f*fd*s**2 + 1584*D1*f*fd*s - 418*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 1400*Dd*f**3*r*s - 427*Dd*f**3*r + 1400*Dd*f**3*s**2 - 1400*Dd*f**3*s + 301*Dd*f**3 - 2112*Dd*f**2*r*s + 880*Dd*f**2*r - 2112*Dd*f**2*s**2 + 2112*Dd*f**2*s - 572*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**5) + D1**3*Pkd3*ct**7*f*k1*k2*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (72*s - 36)*(2*r + 2*s - 1)) + 2*D1*bd1*f*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2) + 2*D1*f*fd*(r*(72*s - 33) + 72*s**2 - 72*s + 19) + Dd*b1*f*(f*(264*r*s - 89*r + 264*s**2 - 264*s + 61) + 288*r*s - 108*r + 288*s**2 - 288*s + 72) + 4*Dd*f**2*(4*r*(12*s - 5) + 48*s**2 - 48*s + 13))/(63*d**2*k3**3) - D1**3*Pkd3*ct**7*f*k1*k2*(-95040*C*D1*Pk2*f*fd*k1**2*r*s + 63360*C*D1*Pk2*f*fd*k1**2*r - 95040*C*D1*Pk2*f*fd*k1**2*s**2 + 126720*C*D1*Pk2*f*fd*k1**2*s - 42240*C*D1*Pk2*f*fd*k1**2 + 28512*C*D1*Pk2*f*fd*k2**2*r**2 - 82368*C*D1*Pk2*f*fd*k2**2*r*s + 28248*C*D1*Pk2*f*fd*k2**2*r - 63360*C*D1*Pk2*f*fd*k2**2*s**2 + 101376*C*D1*Pk2*f*fd*k2**2*s - 30184*C*D1*Pk2*f*fd*k2**2 + 23760*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 15840*C*D1*Pkd2*f*fd*k1**2*k2*r + 23760*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 31680*C*D1*Pkd2*f*fd*k1**2*k2*s + 10560*C*D1*Pkd2*f*fd*k1**2*k2 + 55440*C*D1*Pkd2*f*fd*k2**3*r*s - 18480*C*D1*Pkd2*f*fd*k2**3*r + 31680*C*D1*Pkd2*f*fd*k2**3*s**2 - 47520*C*D1*Pkd2*f*fd*k2**3*s + 12320*C*D1*Pkd2*f*fd*k2**3 - 126720*C*Dd*Pk2*f**2*k1**2*r*s + 81840*C*Dd*Pk2*f**2*k1**2*r - 126720*C*Dd*Pk2*f**2*k1**2*s**2 + 174240*C*Dd*Pk2*f**2*k1**2*s - 60720*C*Dd*Pk2*f**2*k1**2 + 38016*C*Dd*Pk2*f**2*k2**2*r**2 - 109824*C*Dd*Pk2*f**2*k2**2*r*s + 26488*C*Dd*Pk2*f**2*k2**2*r - 84480*C*Dd*Pk2*f**2*k2**2*s**2 + 136752*C*Dd*Pk2*f**2*k2**2*s - 37928*C*Dd*Pk2*f**2*k2**2 + 31680*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 20460*C*Dd*Pkd2*f**2*k1**2*k2*r + 31680*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 43560*C*Dd*Pkd2*f**2*k1**2*k2*s + 15180*C*Dd*Pkd2*f**2*k1**2*k2 + 73920*C*Dd*Pkd2*f**2*k2**3*r*s - 21560*C*Dd*Pkd2*f**2*k2**3*r + 42240*C*Dd*Pkd2*f**2*k2**3*s**2 - 66000*C*Dd*Pkd2*f**2*k2**3*s + 15400*C*Dd*Pkd2*f**2*k2**3 - 150080*D1*Pk2*f**2*fd*k1**2*r*s + 54460*D1*Pk2*f**2*fd*k1**2*r - 150080*D1*Pk2*f**2*fd*k1**2*s**2 + 165480*D1*Pk2*f**2*fd*k1**2*s - 40460*D1*Pk2*f**2*fd*k1**2 + 8800*D1*Pk2*f**2*fd*k2**2*r**2 + 8800*D1*Pk2*f**2*fd*k2**2*r*s - 6380*D1*Pk2*f**2*fd*k2**2*r - 1320*D1*Pk2*f**2*fd*k2**2*s + 220*D1*Pk2*f**2*fd*k2**2 + 95040*D1*Pk2*f*fd*k1**2*r*s - 63360*D1*Pk2*f*fd*k1**2*r + 95040*D1*Pk2*f*fd*k1**2*s**2 - 126720*D1*Pk2*f*fd*k1**2*s + 42240*D1*Pk2*f*fd*k1**2 - 48312*D1*Pk2*f*fd*k2**2*r**2 + 3168*D1*Pk2*f*fd*k2**2*r*s + 4422*D1*Pk2*f*fd*k2**2*r + 27720*D1*Pk2*f*fd*k2**2*s**2 - 48246*D1*Pk2*f*fd*k2**2*s + 16544*D1*Pk2*f*fd*k2**2 + 50688*D1*Pk2*f*gd2*k1**2*r*s - 23760*D1*Pk2*f*gd2*k1**2*r + 50688*D1*Pk2*f*gd2*k1**2*s**2 - 72864*D1*Pk2*f*gd2*k1**2*s + 23760*D1*Pk2*f*gd2*k1**2 - 15840*D1*Pk2*f*gd2*k2**2*r**2 + 15840*D1*Pk2*f*gd2*k2**2*r*s + 11880*D1*Pk2*f*gd2*k2**2*r + 31680*D1*Pk2*f*gd2*k2**2*s**2 - 23760*D1*Pk2*f*gd2*k2**2*s + 3960*D1*Pk2*f*gd2*k2**2 + 101376*D1*Pk2*fd*g2*k1**2*r*s - 61776*D1*Pk2*fd*g2*k1**2*r + 101376*D1*Pk2*fd*g2*k1**2*s**2 - 123552*D1*Pk2*fd*g2*k1**2*s + 36432*D1*Pk2*fd*g2*k1**2 - 31680*D1*Pk2*fd*g2*k2**2*r**2 + 31680*D1*Pk2*fd*g2*k2**2*r*s - 15840*D1*Pk2*fd*g2*k2**2*r + 63360*D1*Pk2*fd*g2*k2**2*s**2 - 63360*D1*Pk2*fd*g2*k2**2*s + 15840*D1*Pk2*fd*g2*k2**2 + 37520*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 13615*D1*Pkd2*f**2*fd*k1**2*k2*r + 37520*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 41370*D1*Pkd2*f**2*fd*k1**2*k2*s + 10115*D1*Pkd2*f**2*fd*k1**2*k2 - 23760*D1*Pkd2*f*fd*k1**2*k2*r*s + 15840*D1*Pkd2*f*fd*k1**2*k2*r - 23760*D1*Pkd2*f*fd*k1**2*k2*s**2 + 31680*D1*Pkd2*f*fd*k1**2*k2*s - 10560*D1*Pkd2*f*fd*k1**2*k2 - 35640*D1*Pkd2*f*fd*k2**3*r*s + 12870*D1*Pkd2*f*fd*k2**3*r - 23760*D1*Pkd2*f*fd*k2**3*s**2 + 31680*D1*Pkd2*f*fd*k2**3*s - 8250*D1*Pkd2*f*fd*k2**3 - 12672*D1*Pkd2*f*gd2*k1**2*k2*r*s + 5940*D1*Pkd2*f*gd2*k1**2*k2*r - 12672*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 18216*D1*Pkd2*f*gd2*k1**2*k2*s - 5940*D1*Pkd2*f*gd2*k1**2*k2 - 15840*D1*Pkd2*f*gd2*k2**3*r*s + 3960*D1*Pkd2*f*gd2*k2**3*r - 15840*D1*Pkd2*f*gd2*k2**3*s**2 + 15840*D1*Pkd2*f*gd2*k2**3*s - 3960*D1*Pkd2*f*gd2*k2**3 - 25344*D1*Pkd2*fd*g2*k1**2*k2*r*s + 15444*D1*Pkd2*fd*g2*k1**2*k2*r - 25344*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 30888*D1*Pkd2*fd*g2*k1**2*k2*s - 9108*D1*Pkd2*fd*g2*k1**2*k2 - 31680*D1*Pkd2*fd*g2*k2**3*r*s + 15840*D1*Pkd2*fd*g2*k2**3*r - 31680*D1*Pkd2*fd*g2*k2**3*s**2 + 31680*D1*Pkd2*fd*g2*k2**3*s - 7920*D1*Pkd2*fd*g2*k2**3 - 11*D1*bd1*f*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*(-36*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) + f*(165*r**2 + 2*r*(99*s - 116) + 33*s**2 - 128*s + 67) + 324*r**2 + 360*r*s - 414*r + 36*s**2 - 198*s + 90) + 2*Pkd2*k2*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + (9 - 18*K)*(r*(4*s - 1) + (1 - 2*s)**2)))) - 150080*Dd*Pk2*f**3*k1**2*r*s + 54460*Dd*Pk2*f**3*k1**2*r - 150080*Dd*Pk2*f**3*k1**2*s**2 + 165480*Dd*Pk2*f**3*k1**2*s - 40460*Dd*Pk2*f**3*k1**2 + 8800*Dd*Pk2*f**3*k2**2*r**2 + 8800*Dd*Pk2*f**3*k2**2*r*s - 6380*Dd*Pk2*f**3*k2**2*r - 1320*Dd*Pk2*f**3*k2**2*s + 220*Dd*Pk2*f**3*k2**2 + 126720*Dd*Pk2*f**2*k1**2*r*s - 81840*Dd*Pk2*f**2*k1**2*r + 126720*Dd*Pk2*f**2*k1**2*s**2 - 174240*Dd*Pk2*f**2*k1**2*s + 60720*Dd*Pk2*f**2*k1**2 - 64416*Dd*Pk2*f**2*k2**2*r**2 + 4224*Dd*Pk2*f**2*k2**2*r*s + 17072*Dd*Pk2*f**2*k2**2*r + 36960*Dd*Pk2*f**2*k2**2*s**2 - 61072*Dd*Pk2*f**2*k2**2*s + 19998*Dd*Pk2*f**2*k2**2 + 202752*Dd*Pk2*f*g2*k1**2*r*s - 109296*Dd*Pk2*f*g2*k1**2*r + 202752*Dd*Pk2*f*g2*k1**2*s**2 - 269280*Dd*Pk2*f*g2*k1**2*s + 83952*Dd*Pk2*f*g2*k1**2 - 63360*Dd*Pk2*f*g2*k2**2*r**2 + 63360*Dd*Pk2*f*g2*k2**2*r*s + 7920*Dd*Pk2*f*g2*k2**2*r + 126720*Dd*Pk2*f*g2*k2**2*s**2 - 110880*Dd*Pk2*f*g2*k2**2*s + 23760*Dd*Pk2*f*g2*k2**2 + 37520*Dd*Pkd2*f**3*k1**2*k2*r*s - 13615*Dd*Pkd2*f**3*k1**2*k2*r + 37520*Dd*Pkd2*f**3*k1**2*k2*s**2 - 41370*Dd*Pkd2*f**3*k1**2*k2*s + 10115*Dd*Pkd2*f**3*k1**2*k2 - 31680*Dd*Pkd2*f**2*k1**2*k2*r*s + 20460*Dd*Pkd2*f**2*k1**2*k2*r - 31680*Dd*Pkd2*f**2*k1**2*k2*s**2 + 43560*Dd*Pkd2*f**2*k1**2*k2*s - 15180*Dd*Pkd2*f**2*k1**2*k2 - 47520*Dd*Pkd2*f**2*k2**3*r*s + 15180*Dd*Pkd2*f**2*k2**3*r - 31680*Dd*Pkd2*f**2*k2**3*s**2 + 43560*Dd*Pkd2*f**2*k2**3*s - 10560*Dd*Pkd2*f**2*k2**3 - 50688*Dd*Pkd2*f*g2*k1**2*k2*r*s + 27324*Dd*Pkd2*f*g2*k1**2*k2*r - 50688*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 67320*Dd*Pkd2*f*g2*k1**2*k2*s - 20988*Dd*Pkd2*f*g2*k1**2*k2 - 63360*Dd*Pkd2*f*g2*k2**3*r*s + 23760*Dd*Pkd2*f*g2*k2**3*r - 63360*Dd*Pkd2*f*g2*k2**3*s**2 + 63360*Dd*Pkd2*f*g2*k2**3*s - 15840*Dd*Pkd2*f*g2*k2**3 - 11*b1*(D1*fd*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(3*Pk2*(f*(165*r**2 + r*(198*s - 155) + 33*s**2 - 73*s + 32) + (2*r + 2*s - 1)*(-48*K*(r - 2*s + 1) + 108*r + 12*s - 6)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(Pk2*f*(660*r**2 + r*(792*s - 697) + 132*s**2 - 347*s + 163) - 18*Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) + Pkd2*k2*(36 - 72*K)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**5) + 2*D1**3*Pkd3*ct**6*f*k1**2*k2**2*st**2*(4*Pk2 - Pkd2*k2)*(3564*C*D1*f*fd*r*s - 1584*C*D1*f*fd*r + 3564*C*D1*f*fd*s**2 - 3564*C*D1*f*fd*s + 924*C*D1*f*fd + 4752*C*Dd*f**2*r*s - 1914*C*Dd*f**2*r + 4752*C*Dd*f**2*s**2 - 4752*C*Dd*f**2*s + 1254*C*Dd*f**2 + 297*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 4424*D1*f**2*fd*r*s - 1337*D1*f**2*fd*r + 4424*D1*f**2*fd*s**2 - 4424*D1*f**2*fd*s + 945*D1*f**2*fd - 3564*D1*f*fd*r*s + 1584*D1*f*fd*r - 3564*D1*f*fd*s**2 + 3564*D1*f*fd*s - 924*D1*f*fd - 2376*D1*f*gd2*r*s + 594*D1*f*gd2*r - 2376*D1*f*gd2*s**2 + 2376*D1*f*gd2*s - 594*D1*f*gd2 - 4752*D1*fd*g2*r*s + 2376*D1*fd*g2*r - 4752*D1*fd*g2*s**2 + 4752*D1*fd*g2*s - 1188*D1*fd*g2 + 4424*Dd*f**3*r*s - 1337*Dd*f**3*r + 4424*Dd*f**3*s**2 - 4424*Dd*f**3*s + 945*Dd*f**3 - 4752*Dd*f**2*r*s + 1914*Dd*f**2*r - 4752*Dd*f**2*s**2 + 4752*Dd*f**2*s - 1254*Dd*f**2 - 9504*Dd*f*g2*r*s + 3564*Dd*f*g2*r - 9504*Dd*f*g2*s**2 + 9504*Dd*f*g2*s - 2376*Dd*f*g2 + 594*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**5) + D1**3*Pkd3*ct**6*(126*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(126*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 3*D1*(f**2*fd*(6*Pk2*k2**2*(15*r**2 + 3*r*(5*s - 1) + 5*s - 4) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(165*s - 76) + 165*s**2 - 208*s + 60)) - 6*f*(fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(12*s - 13)*(r + s - 1) + r*(40*s - 13) + 40*s**2 - 28*s - 3) + 10*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1) - 14*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1)) + 168*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) + Dd*f*(f**2*(-18*Pk2*k2**2*(20*r**2 + r*(20*s - 9) - 3) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(165*s - 71) + 660*s**2 - 815*s + 222)) + 18*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(48*s - 46) + 48*s**2 - 88*s + 36) + r*(80*s - 23) + 80*s**2 - 82*s + 17) + 10*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1))) - 252*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(D1*bd1*(f**2*(-18*Pk2*k2**2*(r - 1)*(5*r + 5*s - 1) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(165*s - 56) + 165*s**2 - 191*s + 42)) + 18*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*C*(6*s - 5) + 20*s - 5) + s**2*(12*C + 20) - s*(16*C + 30) + 15) + 5*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) - 252*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*(f*fd*(60*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 2)*(3*r + 3*s - 2) + k2**2*(Pk2*(-40*C*(3*s - 1)*(21*r + 12*s - 14) - 288*r**2 + 972*r*s - 447*r + 720*s**2 - 1254*s + 411) + Pkd2*k2*(20*C - 10)*(3*s - 1)*(21*r + 12*s - 14))) + 45*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(4*s - 1) + (1 - 2*s)**2) + 90*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(f*(15*k1**2*(4*Pk2 - Pkd2*k2)*(r*(48*s - 31) + 48*s**2 - 66*s + 23) + k2**2*(-4*Pk2*(5*C*(7*r*(24*s - 7) + 96*s**2 - 150*s + 35) + 96*r**2 - 324*r*s + 118*r - 240*s**2 + 422*s - 133) + Pkd2*k2*(10*C - 5)*(7*r*(24*s - 7) + 96*s**2 - 150*s + 35))) + k2**2*(-2*Pk2 + Pkd2*k2)*(90*b2 - 180*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))))/(315*d**2*k3**3) + D1**3*Pkd3*ct**6*(11*D1*bd1*f*(f**2*k2**2*(18*Pk2*k2**2*(r - 1)*(5*r + 5*s - 1) + 5*k1**2*(Pk2*(465*r**2 + 696*r*s - 646*r + 231*s**2 - 424*s + 153) + Pkd2*k2*(117*r*s - 32*r + 117*s**2 - 143*s + 46))) + 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + k1**2*k2**2*(Pk2*(6*C*(15*r**2 + 21*r*(2*s - 1) + 27*s**2 - 23*s - 4) - 2*K*(96*r**2 + 90*r*s - 59*r - 6*s**2 + 105*s - 37) + 387*r**2 + 690*r*s - 562*r + 303*s**2 - 408*s + 235) - 3*Pkd2*k2*(2*C*(r*(6*s - 3) + 6*s**2 - 4*s - 2) + K*(36*r*s - 23*r + 36*s**2 - 64*s + 23) - 16*r*s + 14*r - 16*s**2 + 26*s - 4)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 126*k1**2*k2**2*(-b1*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 1386*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) - 2*Pkd2*k2*s*(r + s)) + Dd*f*(Pk2*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 11*b1*(D1*(f**2*fd*k2**2*(18*Pk2*k2**2*(15*r**2 + 3*r*(5*s - 1) + 5*s - 4) + 5*k1**2*(3*Pk2*(465*r**2 + 696*r*s - 563*r + 231*s**2 - 395*s + 182) + Pkd2*k2*(351*r*s - 228*r + 351*s**2 - 480*s + 152))) + 6*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) + k1**2*k2**2*(Pk2*(12*C*(15*r**2 + 6*r*(7*s - 5) + 27*s**2 - 29*s + 15) - 2*K*(192*r**2 + 180*r*s - 76*r - 12*s**2 + 96*s - 45) + 774*r**2 + 1380*r*s - 701*r + 606*s**2 - 603*s + 63) - 3*Pkd2*k2*(24*C*s**2 + 2*C*s + 2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(s*(24*C - 32) + 11) - 32*s**2 + 20*s - 9)) - 15*k2**4*(2*r + 2*s - 1)*(K*Pk2*(18*r + 10*s - 5) + 2*K*Pkd2*k2*(2*s - 1) - 4*Pk2*r)) + 42*gd2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 252*fd*g2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(18*Pk2*k2**2*(20*r**2 + r*(20*s - 9) - 3) + 5*k1**2*(Pk2*(1860*r**2 + r*(2784*s - 2335) + 924*s**2 - 1609*s + 699) + Pkd2*k2*(52*r*(9*s - 5) + 468*s**2 - 623*s + 198))) + 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) + k1**2*k2**2*(Pk2*(6*C*(60*r**2 + 3*r*(56*s - 37) + 108*s**2 - 113*s + 41) + K*(-768*r**2 - 720*r*s + 388*r + 48*s**2 - 612*s + 238) + 1548*r**2 + 2760*r*s - 1771*r + 1212*s**2 - 1365*s + 419) - 3*Pkd2*k2*(C*(6*r*(8*s - 1) + 48*s**2 - 8*s - 4) + 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) - 64*r*s + 33*r - 64*s**2 + 66*s - 21)) - 15*k2**4*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2))) + 252*g2*k1**2*k2**2*(-Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(5*f**2*fd*k1**2*(7*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(79*s - 39) + 948*s**2 - 1223*s + 362) + 22*k2**2*(-Pk2*(104*r**2 + r*(920*s - 241) + 816*s**2 - 714*s + 107) + 7*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(-225*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + fd*k1**2*k2**2*(Pk2*(-4*C*(324*r**2 + r*(555 - 450*s) + 36*s**2 + 1386*s - 637) + 2871*r**2 + 15*r*(270*s - 43) + 2799*s**2 + 1149*s - 1248) - 15*Pkd2*k2*(4*C*(45*r*s - 21*r + 18*s**2 - 48*s + 16) - 90*r*s + 51*r - 36*s**2 + 108*s - 39)) + fd*k2**4*(Pk2*(-6*C*(492*r**2 + 1638*r*s - 472*r + 300*s**2 - 821*s + 161) + 1764*r**2 + 5202*r*s - 1389*r + 900*s**2 - 2289*s + 352) + Pkd2*k2*(10 - 20*C)*(3*s - 1)*(21*r + 12*s - 14)) - 6*gd2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + k1**2*k2**2*(-2*Pk2*(96*r**2 + r*(90*s - 59) - 6*s**2 + 105*s - 37) - 3*Pkd2*k2*(r*(36*s - 23) + 36*s**2 - 64*s + 23)) - 15*k2**4*(Pk2*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 66*fd*(75*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + 6*g2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) - 4*g2*k1**2*k2**2*(Pk2*(192*r**2 + 4*r*(45*s - 19) - 12*s**2 + 96*s - 45) + 3*Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 30*g2*k2**4*(Pk2*(18*r + 10*s - 5) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1))) + Dd*f*(-4950*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*f**2*k1**2*(7*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(79*s - 39) + 948*s**2 - 1223*s + 362) + 22*k2**2*(-Pk2*(104*r**2 + r*(920*s - 241) + 816*s**2 - 714*s + 107) + 7*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 25) + 12*s**2 - 39*s + 20) + k1**2*k2**2*(Pk2*(-8*C*(216*r**2 - 300*r*s + 356*r + 24*s**2 + 1020*s - 451) + 3828*r**2 + 5400*r*s - 1027*r + 3732*s**2 + 1885*s - 1823) - 30*Pkd2*k2*(C*(120*r*s - 53*r + 48*s**2 - 138*s + 43) - 60*r*s + 33*r - 24*s**2 + 78*s - 27)) + k2**4*(Pk2*(-2*C*(1968*r**2 + 6552*r*s - 1931*r + 1200*s**2 - 3706*s + 506) + 2352*r**2 + 6936*r*s - 1949*r + 1200*s**2 - 3518*s + 324) + Pkd2*k2*(5 - 10*C)*(7*r*(24*s - 7) + 96*s**2 - 150*s + 35))) - 132*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) - 2*k1**2*k2**2*(Pk2*(384*r**2 + 2*r*(180*s - 97) - 24*s**2 + 306*s - 119) + 9*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 15*k2**4*(Pk2*(72*r**2 + 2*r*(56*s - 39) + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**5) + D1**3*Pkd3*ct**5*f*k1*k2*st**2*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (72*s - 36)*(2*r + 2*s - 1)) + 2*D1*bd1*f*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2) + 4*D1*f*fd*(3*r*(9*s - 4) + 27*s**2 - 27*s + 7) + Dd*b1*f*(f*(264*r*s - 89*r + 264*s**2 - 264*s + 61) + 288*r*s - 108*r + 288*s**2 - 288*s + 72) + 2*Dd*f**2*(r*(72*s - 29) + 72*s**2 - 72*s + 19))/(21*d**2*k3**3) - D1**3*Pkd3*ct**5*f*k1*k2*st**2*(-171072*C*D1*Pk2*f*fd*k1**2*r*s + 95040*C*D1*Pk2*f*fd*k1**2*r - 171072*C*D1*Pk2*f*fd*k1**2*s**2 + 202752*C*D1*Pk2*f*fd*k1**2*s - 61248*C*D1*Pk2*f*fd*k1**2 + 58608*C*D1*Pk2*f*fd*k2**2*r**2 - 178992*C*D1*Pk2*f*fd*k2**2*r*s + 55440*C*D1*Pk2*f*fd*k2**2*r - 142560*C*D1*Pk2*f*fd*k2**2*s**2 + 211728*C*D1*Pk2*f*fd*k2**2*s - 59840*C*D1*Pk2*f*fd*k2**2 + 42768*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 23760*C*D1*Pkd2*f*fd*k1**2*k2*r + 42768*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 50688*C*D1*Pkd2*f*fd*k1**2*k2*s + 15312*C*D1*Pkd2*f*fd*k1**2*k2 + 118800*C*D1*Pkd2*f*fd*k2**3*r*s - 39600*C*D1*Pkd2*f*fd*k2**3*r + 71280*C*D1*Pkd2*f*fd*k2**3*s**2 - 102960*C*D1*Pkd2*f*fd*k2**3*s + 26400*C*D1*Pkd2*f*fd*k2**3 - 228096*C*Dd*Pk2*f**2*k1**2*r*s + 121440*C*Dd*Pk2*f**2*k1**2*r - 228096*C*Dd*Pk2*f**2*k1**2*s**2 + 278784*C*Dd*Pk2*f**2*k1**2*s - 87648*C*Dd*Pk2*f**2*k1**2 + 78144*C*Dd*Pk2*f**2*k2**2*r**2 - 238656*C*Dd*Pk2*f**2*k2**2*r*s + 50424*C*Dd*Pk2*f**2*k2**2*r - 190080*C*Dd*Pk2*f**2*k2**2*s**2 + 285296*C*Dd*Pk2*f**2*k2**2*s - 74360*C*Dd*Pk2*f**2*k2**2 + 57024*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 30360*C*Dd*Pkd2*f**2*k1**2*k2*r + 57024*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 69696*C*Dd*Pkd2*f**2*k1**2*k2*s + 21912*C*Dd*Pkd2*f**2*k1**2*k2 + 158400*C*Dd*Pkd2*f**2*k2**3*r*s - 46200*C*Dd*Pkd2*f**2*k2**3*r + 95040*C*Dd*Pkd2*f**2*k2**3*s**2 - 142560*C*Dd*Pkd2*f**2*k2**3*s + 33000*C*Dd*Pkd2*f**2*k2**3 - 372480*D1*Pk2*f**2*fd*k1**2*r*s + 129420*D1*Pk2*f**2*fd*k1**2*r - 372480*D1*Pk2*f**2*fd*k1**2*s**2 + 402840*D1*Pk2*f**2*fd*k1**2*s - 95580*D1*Pk2*f**2*fd*k1**2 + 15840*D1*Pk2*f**2*fd*k2**2*r**2 + 15840*D1*Pk2*f**2*fd*k2**2*r*s - 6820*D1*Pk2*f**2*fd*k2**2*r + 1320*D1*Pk2*f**2*fd*k2**2*s - 2860*D1*Pk2*f**2*fd*k2**2 + 171072*D1*Pk2*f*fd*k1**2*r*s - 95040*D1*Pk2*f*fd*k1**2*r + 171072*D1*Pk2*f*fd*k1**2*s**2 - 202752*D1*Pk2*f*fd*k1**2*s + 61248*D1*Pk2*f*fd*k1**2 - 103158*D1*Pk2*f*fd*k2**2*r**2 + 6732*D1*Pk2*f*fd*k2**2*r*s + 17820*D1*Pk2*f*fd*k2**2*r + 62370*D1*Pk2*f*fd*k2**2*s**2 - 94908*D1*Pk2*f*fd*k2**2*s + 29480*D1*Pk2*f*fd*k2**2 + 101376*D1*Pk2*f*gd2*k1**2*r*s - 47520*D1*Pk2*f*gd2*k1**2*r + 101376*D1*Pk2*f*gd2*k1**2*s**2 - 145728*D1*Pk2*f*gd2*k1**2*s + 47520*D1*Pk2*f*gd2*k1**2 - 47520*D1*Pk2*f*gd2*k2**2*r**2 + 47520*D1*Pk2*f*gd2*k2**2*r*s + 35640*D1*Pk2*f*gd2*k2**2*r + 95040*D1*Pk2*f*gd2*k2**2*s**2 - 71280*D1*Pk2*f*gd2*k2**2*s + 11880*D1*Pk2*f*gd2*k2**2 + 202752*D1*Pk2*fd*g2*k1**2*r*s - 123552*D1*Pk2*fd*g2*k1**2*r + 202752*D1*Pk2*fd*g2*k1**2*s**2 - 247104*D1*Pk2*fd*g2*k1**2*s + 72864*D1*Pk2*fd*g2*k1**2 - 95040*D1*Pk2*fd*g2*k2**2*r**2 + 95040*D1*Pk2*fd*g2*k2**2*r*s - 47520*D1*Pk2*fd*g2*k2**2*r + 190080*D1*Pk2*fd*g2*k2**2*s**2 - 190080*D1*Pk2*fd*g2*k2**2*s + 47520*D1*Pk2*fd*g2*k2**2 + 93120*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 32355*D1*Pkd2*f**2*fd*k1**2*k2*r + 93120*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 100710*D1*Pkd2*f**2*fd*k1**2*k2*s + 23895*D1*Pkd2*f**2*fd*k1**2*k2 - 42768*D1*Pkd2*f*fd*k1**2*k2*r*s + 23760*D1*Pkd2*f*fd*k1**2*k2*r - 42768*D1*Pkd2*f*fd*k1**2*k2*s**2 + 50688*D1*Pkd2*f*fd*k1**2*k2*s - 15312*D1*Pkd2*f*fd*k1**2*k2 - 77220*D1*Pkd2*f*fd*k2**3*r*s + 27720*D1*Pkd2*f*fd*k2**3*r - 53460*D1*Pkd2*f*fd*k2**3*s**2 + 69300*D1*Pkd2*f*fd*k2**3*s - 17820*D1*Pkd2*f*fd*k2**3 - 25344*D1*Pkd2*f*gd2*k1**2*k2*r*s + 11880*D1*Pkd2*f*gd2*k1**2*k2*r - 25344*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 36432*D1*Pkd2*f*gd2*k1**2*k2*s - 11880*D1*Pkd2*f*gd2*k1**2*k2 - 47520*D1*Pkd2*f*gd2*k2**3*r*s + 11880*D1*Pkd2*f*gd2*k2**3*r - 47520*D1*Pkd2*f*gd2*k2**3*s**2 + 47520*D1*Pkd2*f*gd2*k2**3*s - 11880*D1*Pkd2*f*gd2*k2**3 - 50688*D1*Pkd2*fd*g2*k1**2*k2*r*s + 30888*D1*Pkd2*fd*g2*k1**2*k2*r - 50688*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 61776*D1*Pkd2*fd*g2*k1**2*k2*s - 18216*D1*Pkd2*fd*g2*k1**2*k2 - 95040*D1*Pkd2*fd*g2*k2**3*r*s + 47520*D1*Pkd2*fd*g2*k2**3*r - 95040*D1*Pkd2*fd*g2*k2**3*s**2 + 95040*D1*Pkd2*fd*g2*k2**3*s - 23760*D1*Pkd2*fd*g2*k2**3 - 33*D1*bd1*f*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*(-36*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) + f*(165*r**2 + 2*r*(99*s - 116) + 33*s**2 - 128*s + 67) + 324*r**2 + 360*r*s - 414*r + 36*s**2 - 198*s + 90) + 2*Pkd2*k2*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + (9 - 18*K)*(r*(4*s - 1) + (1 - 2*s)**2)))) - 372480*Dd*Pk2*f**3*k1**2*r*s + 129420*Dd*Pk2*f**3*k1**2*r - 372480*Dd*Pk2*f**3*k1**2*s**2 + 402840*Dd*Pk2*f**3*k1**2*s - 95580*Dd*Pk2*f**3*k1**2 + 15840*Dd*Pk2*f**3*k2**2*r**2 + 15840*Dd*Pk2*f**3*k2**2*r*s - 6820*Dd*Pk2*f**3*k2**2*r + 1320*Dd*Pk2*f**3*k2**2*s - 2860*Dd*Pk2*f**3*k2**2 + 228096*Dd*Pk2*f**2*k1**2*r*s - 121440*Dd*Pk2*f**2*k1**2*r + 228096*Dd*Pk2*f**2*k1**2*s**2 - 278784*Dd*Pk2*f**2*k1**2*s + 87648*Dd*Pk2*f**2*k1**2 - 137544*Dd*Pk2*f**2*k2**2*r**2 + 8976*Dd*Pk2*f**2*k2**2*r*s + 47586*Dd*Pk2*f**2*k2**2*r + 83160*Dd*Pk2*f**2*k2**2*s**2 - 119306*Dd*Pk2*f**2*k2**2*s + 34100*Dd*Pk2*f**2*k2**2 + 405504*Dd*Pk2*f*g2*k1**2*r*s - 218592*Dd*Pk2*f*g2*k1**2*r + 405504*Dd*Pk2*f*g2*k1**2*s**2 - 538560*Dd*Pk2*f*g2*k1**2*s + 167904*Dd*Pk2*f*g2*k1**2 - 190080*Dd*Pk2*f*g2*k2**2*r**2 + 190080*Dd*Pk2*f*g2*k2**2*r*s + 23760*Dd*Pk2*f*g2*k2**2*r + 380160*Dd*Pk2*f*g2*k2**2*s**2 - 332640*Dd*Pk2*f*g2*k2**2*s + 71280*Dd*Pk2*f*g2*k2**2 + 93120*Dd*Pkd2*f**3*k1**2*k2*r*s - 32355*Dd*Pkd2*f**3*k1**2*k2*r + 93120*Dd*Pkd2*f**3*k1**2*k2*s**2 - 100710*Dd*Pkd2*f**3*k1**2*k2*s + 23895*Dd*Pkd2*f**3*k1**2*k2 - 57024*Dd*Pkd2*f**2*k1**2*k2*r*s + 30360*Dd*Pkd2*f**2*k1**2*k2*r - 57024*Dd*Pkd2*f**2*k1**2*k2*s**2 + 69696*Dd*Pkd2*f**2*k1**2*k2*s - 21912*Dd*Pkd2*f**2*k1**2*k2 - 102960*Dd*Pkd2*f**2*k2**3*r*s + 32670*Dd*Pkd2*f**2*k2**3*r - 71280*Dd*Pkd2*f**2*k2**3*s**2 + 95040*Dd*Pkd2*f**2*k2**3*s - 22770*Dd*Pkd2*f**2*k2**3 - 101376*Dd*Pkd2*f*g2*k1**2*k2*r*s + 54648*Dd*Pkd2*f*g2*k1**2*k2*r - 101376*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 134640*Dd*Pkd2*f*g2*k1**2*k2*s - 41976*Dd*Pkd2*f*g2*k1**2*k2 - 190080*Dd*Pkd2*f*g2*k2**3*r*s + 71280*Dd*Pkd2*f*g2*k2**3*r - 190080*Dd*Pkd2*f*g2*k2**3*s**2 + 190080*Dd*Pkd2*f*g2*k2**3*s - 47520*Dd*Pkd2*f*g2*k2**3 - 33*b1*(D1*fd*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(3*Pk2*(f*(165*r**2 + r*(198*s - 155) + 33*s**2 - 73*s + 32) + (2*r + 2*s - 1)*(-48*K*(r - 2*s + 1) + 108*r + 12*s - 6)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(Pk2*f*(660*r**2 + r*(792*s - 697) + 132*s**2 - 347*s + 163) - 18*Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) + Pkd2*k2*(36 - 72*K)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**5) + D1**3*Pkd3*ct**5*k1*(4*Pk2 - Pkd2*k2)*(2*D1*bd1*f**2*(r*(6*s - 5) + 2*s*(3*s - 4)) + b1**2*(D1*fd*(r + s - 1)*(f*(52*s - 33) + 28*s - 28) + Dd*f*(f*(104*r*s - 53*r + 104*s**2 - 144*s + 43) + 112*r*s - 70*r + 112*s**2 - 168*s + 56)) + b1*f*(D1*bd1*(f*(52*r*s - 20*r + 52*s**2 - 59*s + 10) + 56*r*s - 28*r + 56*s**2 - 70*s + 14) + 2*D1*fd*(12*s - 13)*(r + s - 1) + 2*Dd*f*(24*r*s - 23*r + 24*s**2 - 44*s + 18)))/(35*d**2*k2*k3) + D1**3*Pkd3*ct**5*(3*b1**2*k1**2*(D1*fd*(k1**2*(14*K - 14)*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1) - 3*k2**2*(-2*Pk2*f*(13*r**2 + r*(26*s + 7) + 13*s**2 + 40*s - 20) + 14*Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 + r*(2 - 6*s) - s**2 - 6*s + 3) + 33*Pkd2*f*k2*(r + 2*s - 1) + 28*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1))) + Dd*f*(k1**2*(14*K - 14)*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) + 4*s**2 - 11*s + 7) - 3*k2**2*(-Pk2*f*(52*r**2 + r*(104*s - 11) + 52*s**2 + 69*s - 41) + 14*Pk2*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 - 24*r*s + 17*r - 4*s**2 - 5*s + 1) + 4*Pkd2*k2*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)))) + b1*k1**2*(3*D1*bd1*f*(k1**2*(14*K - 14)*(4*Pk2 - Pkd2*k2)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) - 3*k2**2*(Pk2*(28*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) + f*(-26*r**2 + r*(25 - 52*s) - 26*s**2 + 11*s + 1) - 140*r**2 - 168*r*s + 126*r - 28*s**2 + 14*s - 14) + 7*Pkd2*k2*(4*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(r + 2*s - 1) + 2*r + 4*s - 2))) + 3*D1*(f**2*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(96*s - 68) + 96*s**2 - 155*s + 58) + 3*k2**2*(-4*Pk2*(3*r**2 + r*(168*s - 55) + 165*s**2 - 144*s + 28) + 5*Pkd2*k2*(r*(30*s - 11) + 30*s**2 - 30*s + 7))) - 2*f*fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(s + 3)*(r + s - 1) + r*(13 - 26*s) - 26*s**2 + 35*s - 4) + k2**2*(Pk2*(4*C*(14*r**2 + r*(141 - 226*s) - 72*s**2 + 311*s - 155) + 6*K*(64*r*s - 39*r + 64*s**2 - 78*s + 23) + 118*r**2 + 1288*r*s - 851*r + 834*s**2 - 1520*s + 617) + 3*Pkd2*k2*(8*C*(2*s - 1)*(10*r + 3*s - 10) + K*(-64*r*s + 39*r - 64*s**2 + 78*s - 23) - 136*r*s + 81*r - 80*s**2 + 174*s - 67))) + 28*f*gd2*(-k1**2*(4*Pk2 - Pkd2*k2)*(s - 3) + 6*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1)))*(r + s - 1) + 28*fd*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + 12*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1)))*(r + s - 1)) + Dd*f*(f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(192*r*s - 137*r + 192*s**2 - 302*s + 108) + 9*k2**2*(-4*Pk2*(4*r**2 + 7*r*(32*s - 9) + 220*s**2 - 185*s + 35) + 5*Pkd2*k2*(r*(40*s - 13) + 40*s**2 - 40*s + 9))) - 6*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(4*r*(s + 4) + 4*s**2 + 9*s - 11) + r*(23 - 52*s) - 52*s**2 + 89*s - 24) + k2**2*(Pk2*(4*C*(28*r**2 + r*(222 - 452*s) - 144*s**2 + 586*s - 199) + 6*K*(128*r*s - 69*r + 128*s**2 - 170*s + 53) + 236*r**2 + 2576*r*s - 1438*r + 1668*s**2 - 2833*s + 942) + 3*Pkd2*k2*(4*C*(10*r*(8*s - 3) + 24*s**2 - 86*s + 25) + K*(-128*r*s + 69*r - 128*s**2 + 170*s - 53) - 272*r*s + 122*r - 160*s**2 + 324*s - 98))) + 84*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) + 4*s**2 - 11*s + 7) + 6*k2**2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))) + f*(D1*bd1*k1**2*(f**2*(5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(96*s - 70) + 96*s**2 - 139*s + 42) + 18*k2**2*(-2*Pk2*(r**2 + 8*r*(7*s - 1) + 55*s**2 - 41*s + 7) + 5*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) - 6*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*C*(s + 5) - 13*s + 5) + s**2*(2*C - 13) + s*(2*C + 30) - 15) + k2**2*(Pk2*(-144*C*s**2 + 444*C*s + 6*K*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + r**2*(28*C + 59) + r*(-452*C*s + 176*C + 644*s - 303) + 417*s**2 - 597*s + 100) - 3*Pkd2*k2*(-24*C*s**2 + 60*C*s + K*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + r*(-80*C*s + 20*C + 68*s - 19) + 40*s**2 - 62*s + 9))) + 84*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1)) + 6*k2**2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) + 2*D1*(f*(fd*(Pk2*k2**4*(2 - 4*C)*(3*r - 1)*(12*r - 42*s - 23) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + k1**2*k2**2*(-Pk2*(60*C*(54*r*s - 27*r + 36*s**2 - 60*s + 19) + 108*r**2 + 630*r*s + 555*r + 1062*s**2 + 612*s - 589) + 30*Pkd2*k2*(C*(54*r*s - 27*r + 36*s**2 - 60*s + 19) - 9*r*s + 6*r + 12*s - 5))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(9*bd2 - 18*gd2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15)) + 9*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23)) + 2*Dd*f*(f*(Pk2*k2**4*(4 - 8*C)*(24*r**2 - 21*r*(4*s + 3) + 32*s + 28) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(r*(12*s - 25) + 12*s**2 - 39*s + 20) + k1**2*k2**2*(-Pk2*(120*C*(36*r*s - 17*r + 24*s**2 - 42*s + 13) + 144*r**2 + 840*r*s + 829*r + 1416*s**2 + 1020*s - 899) + 30*Pkd2*k2*(C*(72*r*s - 34*r + 48*s**2 - 84*s + 26) - 12*r*s + 8*r + 18*s - 7))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(9*b2 - 18*g2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53))))/(315*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct**5*(11*D1*bd1*f*k1**2*(f**2*k2**2*(5*k1**2*(Pk2*(270*r**2 + 492*r*s - 333*r + 222*s**2 - 233*s + 23) + Pkd2*k2*(24*r*s - 51*r + 24*s**2 - 101*s + 71)) - 9*k2**2*(Pk2*(129*r**2 + 2*r*(67*s - 84) + 5*s**2 - 88*s + 55) + 10*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) - 3*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) - 2*k1**2*k2**2*(Pk2*(-6*C*(5*r**2 + r*(16*s - 15) + 11*s**2 - 23*s + 12) + 2*K*(23*r**2 - 112*r*s - 65*r - 135*s**2 + 8*s + 42) + 44*r**2 + 506*r*s - 245*r + 462*s**2 - 541*s + 213) + 3*Pkd2*k2*(2*C*(3*r*s - 5*r + 3*s**2 - 9*s + 6) + K*(34*r*s + 9*r + 34*s**2 - 6*s - 9) - 51*r*s + 16*r - 51*s**2 + 56*s - 18)) + k2**4*(Pk2*(-8*C*(38*r**2 + 293*r*s - 73*r + 45*s**2 - 171*s + 21) + 2*K*(309*r**2 + 966*r*s - 554*r + 657*s**2 - 696*s + 245) - 105*b1*(r + s - 1) + 688*r**2 + 1756*r*s - 1230*r + 228*s**2 - 1326*s + 430) - 3*Pkd2*k2*(-8*C*(20*r*s - 10*r + 6*s**2 - 11*s + 5) + 48*K*r*s + 2*K*r + 48*K*s**2 - 20*K*s - 2*K + b1*(13*r*(4*s - 1) + 52*s**2 - 45*s + 3) + 36*r*s - 32*r - 20*s**2 + 4*s + 2))) - 42*k2**2*(-b1*k1**2*(K - 1)*(Pk2*(10*r**2 + r*(32*s - 13) + 22*s**2 - 29*s + 5) - Pkd2*k2*(6*r*s + r + s*(6*s - 7))) + 3*b1*k2**2*(Pk2*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 2*g2*(k1**2*(Pk2*(5*r**2 + r*(16*s - 3) + s*(11*s - 11)) - Pkd2*k2*(3*r*s + r + s*(3*s - 3))) - 6*k2**2*(Pk2*(-3*r**2 + r*(4 - 8*s) - s*(5*s - 5)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(14*K - 14)*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + 3*k2**2*(Pk2*(28*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 5*f*(33*r + 33*s - 23) + 56*r**2 + 56*r*s + 140*r + 140*s - 70) + Pkd2*k2*s*(f*(52*r + 52*s - 19) + (28 - 56*K)*(r + s)))) + Dd*f*(k1**2*(14*K - 14)*(Pk2*(20*r**2 + r*(64*s - 33) + 44*s**2 - 57*s + 15) - Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 3*k2**2*(50*Pk2*f*(4*r + 4*s - 3) + 14*Pk2*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15) + Pkd2*f*k2*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3) - Pkd2*k2*(28*K - 14)*(r*(8*s - 1) + 4*s*(2*s - 1))))) - 11*b1*k1**2*(-3*D1*(f**2*fd*k2**2*(5*k1**2*(Pk2*(270*r**2 + 492*r*s - 351*r + 222*s**2 - 283*s + 123) + Pkd2*k2*(24*r*s - 87*r + 24*s**2 - 121*s + 61)) - 3*k2**2*(Pk2*(387*r**2 + 402*r*s - 413*r + 15*s**2 - 223*s + 116) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) - 2*f*fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**2*k2**2*(Pk2*(12*C*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 20*s + 5) - 2*K*(46*r**2 - 224*r*s + 84*r - 270*s**2 + 263*s - 64) - 88*r**2 - 1012*r*s + 768*r - 924*s**2 + 1354*s - 419) - 3*Pkd2*k2*(12*C*s**2 - 20*C*s + K*(r*(68*s - 13) + 68*s**2 - 40*s + 3) + 2*r*(6*C*s - 51*s + 19) - 102*s**2 + 103*s - 19)) + k2**4*(Pk2*(-4*C*(76*r**2 + r*(586*s - 334) + 90*s**2 - 530*s + 223) + K*(618*r**2 + 1932*r*s - 1141*r + 1314*s**2 - 1419*s + 381) + 688*r**2 + 1756*r*s - 1232*r + 228*s**2 - 1373*s + 634) - 3*Pkd2*k2*(-48*C*s**2 + 80*C*s + K*(r*(48*s - 17) + 48*s**2 - 34*s + 5) - 4*r*(40*C*s - 9*s - 7) - 20*s**2 + 17*s - 14))) + 28*f*gd2*k2**2*(k1**2*(-Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 18*s + 5) + Pkd2*k2*s*(3*r + 3*s - 4)) + 6*k2**2*(-Pk2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 28*fd*g2*k2**2*(k1**2*(-Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) + 3*Pkd2*k2*s*(r + s)) + 6*k2**2*(-Pk2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(-10*k1**2*(Pk2*(540*r**2 + 984*r*s - 693*r + 444*s**2 - 541*s + 196) + Pkd2*k2*(48*r*s - 156*r + 48*s**2 - 232*s + 127)) + 9*k2**2*(Pk2*(516*r**2 + 536*r*s - 581*r + 20*s**2 - 311*s + 171) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 6*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + k1**2*k2**2*(Pk2*(6*C*(20*r**2 + r*(64*s - 45) + 44*s**2 - 81*s + 27) - 2*K*(92*r**2 - 448*r*s - 46*r - 540*s**2 + 279*s + 20) - 176*r**2 - 2024*r*s + 1228*r - 1848*s**2 + 2406*s - 803) - 3*Pkd2*k2*(2*C*(r*(12*s - 5) + 12*s**2 - 23*s + 6) + K*(136*r*s + 5*r + 136*s**2 - 52*s - 15) - 204*r*s + 60*r - 204*s**2 + 205*s - 43)) + k2**4*(Pk2*(-4*C*(152*r**2 + 2*r*(586*s - 259) + 180*s**2 - 1015*s + 317) + K*(1236*r**2 + 3864*r*s - 2249*r + 2628*s**2 - 2811*s + 871) + 1376*r**2 + 3512*r*s - 2569*r + 456*s**2 - 3016*s + 1227) + 3*Pkd2*k2*(4*C*(10*r*(8*s - 1) + 24*s**2 - 46*s + 5) - 3*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) - 72*r*s - 19*r + 40*s**2 - 16*s + 20))) - 84*g2*k2**2*(k1**2*(-Pk2*(20*r**2 + r*(64*s - 33) + 44*s**2 - 57*s + 15) + Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 6*k2**2*(-Pk2*(12*r**2 + 32*r*s - 30*r + 20*s**2 - 33*s + 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(5*f**2*fd*k1**2*(704*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(r*(280*s - 257) + 280*s**2 - 500*s + 201) + 11*k1**2*k2**2*(4*Pk2*(204*r**2 - 24*r*(29*s + 1) - 900*s**2 + 757*s - 85) + 7*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) - 22*f*(fd*(Pk2*k2**6*(2 - 4*C)*(3*r - 1)*(12*r - 42*s - 23) + k1**6*(10*C - 10)*(4*Pk2 - Pkd2*k2)*(3*s + 5)*(3*r + 3*s - 2) - 3*k1**4*k2**2*(Pk2*(4*C*(162*r**2 - 15*r*(3*s + 17) - 297*s**2 - 60*s + 125) - 648*r**2 + 450*r*s + 735*r + 1278*s**2 - 225*s - 290) + 5*Pkd2*k2*(2*C*(36*r*s + 3*r + 54*s**2 - 18*s - 5) - 99*r*s + 15*r - 117*s**2 + 75*s - 6)) + k1**2*k2**4*(Pk2*(2*C*(603*r**2 + 9*r*(1414*s - 241) + 3699*s**2 - 7851*s + 1448) + 1827*r**2 - 3*r*(3336*s + 167) - 3411*s**2 + 6168*s - 601) - 30*Pkd2*k2*(C*(3*r*(6*s - 1) + 36*s**2 - 12*s - 1) - (3*s - 1)*(9*r + 12*s - 4)))) + 3*k1**2*(15*Pk2*bd2*k2**4*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) - 2*gd2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) + k1**2*k2**2*(-2*Pk2*(23*r**2 - 112*r*s - 65*r - 135*s**2 + 8*s + 42) - 3*Pkd2*k2*(34*r*s + 9*r + 34*s**2 - 6*s - 9)) + k2**4*(Pk2*(309*r**2 + 966*r*s - 554*r + 657*s**2 - 696*s + 245) - 3*Pkd2*k2*(24*r*s + r + 24*s**2 - 10*s - 1))))) - 66*fd*k1**2*(15*Pk2*b2*k2**4*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) - 2*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**2*k2**2*(-2*Pk2*(46*r**2 - 224*r*s + 84*r - 270*s**2 + 263*s - 64) - 3*Pkd2*k2*(68*r*s - 13*r + 68*s**2 - 40*s + 3)) + k2**4*(Pk2*(618*r**2 + 1932*r*s - 1141*r + 1314*s**2 - 1419*s + 381) - 3*Pkd2*k2*(48*r*s - 17*r + 48*s**2 - 34*s + 5))))) + Dd*f*(5*f**2*k1**2*(704*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(r*(280*s - 257) + 280*s**2 - 500*s + 201) + 11*k1**2*k2**2*(4*Pk2*(204*r**2 - 24*r*(29*s + 1) - 900*s**2 + 757*s - 85) + 7*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) - 22*f*(-Pk2*k2**6*(8*C - 4)*(24*r**2 - 21*r*(4*s + 3) + 32*s + 28) + k1**6*(10*C - 10)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s + 11) + 12*s**2 + 15*s - 17) - 3*k1**4*k2**2*(Pk2*(4*C*(216*r**2 - 60*r*s - 404*r - 396*s**2 - 159*s + 220) - 864*r**2 + 600*r*s + 1236*r + 1704*s**2 - 34*s - 575) + 5*Pkd2*k2*(4*C*(24*r*s + 4*r + 36*s**2 - 9*s - 5) - 132*r*s + 12*r - 156*s**2 + 93*s - 3)) + k1**2*k2**4*(Pk2*(2*C*(804*r**2 + 3*r*(5656*s - 719) + 4932*s**2 - 11147*s + 1235) + 2436*r**2 - 2*r*(6672*s + 923) - 4548*s**2 + 8525*s + 135) - 30*Pkd2*k2*(2*C*(r*(12*s - 1) + 24*s**2 - 6*s - 1) + r*(10 - 36*s) - 48*s**2 + 30*s - 5))) - 66*k1**2*(15*Pk2*b2*k2**4*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) - 2*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + k1**2*k2**2*(-2*Pk2*(92*r**2 - 448*r*s - 46*r - 540*s**2 + 279*s + 20) - 3*Pkd2*k2*(136*r*s + 5*r + 136*s**2 - 52*s - 15)) + k2**4*(Pk2*(1236*r**2 + 3864*r*s - 2249*r + 2628*s**2 - 2811*s + 871) - 9*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1)))))))/(3465*d**2*k1*k2*k3**5) + 2*D1**3*Pkd3*ct**4*f*k1**2*k2**2*st**4*(4*Pk2 - Pkd2*k2)*(792*C*D1*f*fd*r*s - 330*C*D1*f*fd*r + 792*C*D1*f*fd*s**2 - 792*C*D1*f*fd*s + 198*C*D1*f*fd + 1056*C*Dd*f**2*r*s - 396*C*Dd*f**2*r + 1056*C*Dd*f**2*s**2 - 1056*C*Dd*f**2*s + 264*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 1624*D1*f**2*fd*r*s - 483*D1*f**2*fd*r + 1624*D1*f**2*fd*s**2 - 1624*D1*f**2*fd*s + 343*D1*f**2*fd - 792*D1*f*fd*r*s + 330*D1*f*fd*r - 792*D1*f*fd*s**2 + 792*D1*f*fd*s - 198*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 1624*Dd*f**3*r*s - 483*Dd*f**3*r + 1624*Dd*f**3*s**2 - 1624*Dd*f**3*s + 343*Dd*f**3 - 1056*Dd*f**2*r*s + 396*Dd*f**2*r - 1056*Dd*f**2*s**2 + 1056*Dd*f**2*s - 264*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(231*d**2*k3**5) + D1**3*Pkd3*ct**4*st**2*(252*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*b1*(84*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 3*D1*(f**2*fd*(2*Pk2*k2**2*(15*r**2 + r*(15*s + 19) + 25*s - 18) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(123*s - 55) + 123*s**2 - 152*s + 43)) - 4*f*(fd*k1**2*(4*Pk2 - Pkd2*k2)*(C*(20*s - 17)*(r + s - 1) + 22*r*(2*s - 1) + 44*s**2 - 41*s + 6) + 15*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1) - 14*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1)) + 112*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) + Dd*f*(f**2*(-6*Pk2*k2**2*(20*r**2 + r*(20*s + 17) + 20*s - 21) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(41*r*(12*s - 5) + 492*s**2 - 595*s + 159)) + 12*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(40*s - 29) + 40*s**2 - 64*s + 23) + (11*s - 5)*(8*r + 8*s - 6)) + 15*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1))) - 168*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(3*D1*bd1*(f**2*(-6*Pk2*k2**2*(r - 1)*(5*r + 5*s + 3) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(123*s - 40) + 123*s**2 - 139*s + 30)) + 6*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*C*(5*s - 3) + 22*s - 9) + s**2*(10*C + 22) - s*(11*C + 35) + 15) + 15*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) - 168*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*(2*f*fd*(6*k1**2*(4*Pk2 - Pkd2*k2)*(9*r*(9*s - 5) + 81*s**2 - 96*s + 29) + k2**2*(Pk2*(-60*C*(3*s - 1)*(15*r + 9*s - 10) - 261*r**2 + 9*r*(121*s - 50) + 810*s**2 - 1281*s + 395) + Pkd2*k2*(30*C - 15)*(3*s - 1)*(15*r + 9*s - 10))) + 135*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(4*s - 1) + (1 - 2*s)**2) + 270*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(f*(6*k1**2*(4*Pk2 - Pkd2*k2)*(r*(216*s - 115) + 216*s**2 - 264*s + 83) + k2**2*(Pk2*(-60*C*(5*r*(24*s - 7) + 72*s**2 - 108*s + 25) - 696*r**2 + 2904*r*s - 951*r + 2160*s**2 - 3454*s + 1015) + Pkd2*k2*(30*C - 15)*(5*r*(24*s - 7) + 72*s**2 - 108*s + 25))) + k2**2*(-2*Pk2 + Pkd2*k2)*(270*b2 - 540*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))))/(315*d**2*k3**3) + D1**3*Pkd3*ct**4*st**2*(33*D1*bd1*f*(f**2*k2**2*(6*Pk2*k2**2*(r - 1)*(5*r + 5*s + 3) + 5*k1**2*(Pk2*(345*r**2 + 516*r*s - 476*r + 171*s**2 - 314*s + 111) + Pkd2*k2*(87*r*s - 22*r + 87*s**2 - 103*s + 32))) + 2*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 2*k1**2*k2**2*(-Pk2*(3*C*(25*r**2 + 35*r*(2*s - 1) + 45*s**2 - 43*s - 2) + K*(-171*r**2 - 117*r*s + 83*r + 54*s**2 - 252*s + 88) + 381*r**2 + 669*r*s - 548*r + 288*s**2 - 375*s + 203) + 3*Pkd2*k2*(C*(5*r*(2*s - 1) + 10*s**2 - 9*s - 1) + K*(36*r*s - 23*r + 36*s**2 - 64*s + 23) - 14*r*s + 13*r - 14*s**2 + 27*s - 7)) - 45*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 84*k1**2*k2**2*(-b1*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 2772*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) - 2*Pkd2*k2*s*(r + s)) + Dd*f*(Pk2*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 33*b1*(D1*(f**2*fd*k2**2*(6*Pk2*k2**2*(15*r**2 + r*(15*s + 19) + 25*s - 18) + 5*k1**2*(3*Pk2*(345*r**2 + r*(516*s - 415) + 171*s**2 - 293*s + 134) + Pkd2*k2*(3*r*(87*s - 55) + 261*s**2 - 348*s + 109))) + 2*f*(fd*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) - 2*k1**2*k2**2*(-Pk2*(6*C*(25*r**2 + 10*r*(7*s - 5) + 45*s**2 - 53*s + 25) + K*(-342*r**2 - 234*r*s + 82*r + 108*s**2 - 276*s + 111) + 762*r**2 + 1338*r*s - 691*r + 576*s**2 - 549*s + 72) + 3*Pkd2*k2*(20*C*s**2 - 3*C*s + 2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(s*(20*C - 28) + 11) - 28*s**2 + 25*s - 9)) - 45*k2**4*(2*r + 2*s - 1)*(K*Pk2*(18*r + 10*s - 5) + 2*K*Pkd2*k2*(2*s - 1) - 4*Pk2*r)) + 84*gd2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 168*fd*g2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(6*Pk2*k2**2*(20*r**2 + r*(20*s + 17) + 20*s - 21) + 5*k1**2*(Pk2*(1380*r**2 + 2064*r*s - 1721*r + 684*s**2 - 1193*s + 513) + Pkd2*k2*(348*r*s - 187*r + 348*s**2 - 451*s + 141))) + 2*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) - 2*k1**2*k2**2*(-Pk2*(3*C*(100*r**2 + 5*r*(56*s - 37) + 180*s**2 - 207*s + 73) + K*(-684*r**2 - 468*r*s + 248*r + 216*s**2 - 780*s + 287) + 1524*r**2 + 2676*r*s - 1742*r + 1152*s**2 - 1254*s + 397) + 3*Pkd2*k2*(C*(5*r*(8*s - 1) + 40*s**2 - 16*s - 1) + 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) + (7*s - 4)*(-8*r - 8*s + 6))) - 45*k2**4*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2))) + 168*g2*k1**2*k2**2*(-Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(884*s - 375) + 2652*s**2 - 3191*s + 863) + 22*k2**2*(-Pk2*(240*r**2 + 3*r*(2800*s - 439) + 8160*s**2 - 6730*s + 721) + 75*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(-675*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) - 2*k1**2*k2**2*(2*C*Pk2*(567*r**2 + r*(672 - 1395*s) - 558*s**2 + 2286*s - 832) + 12*C*Pkd2*k2*(45*r*(5*s - 2) + 108*s**2 - 222*s + 67) - 3*Pk2*(843*r**2 + r*(792*s - 367) + 417*s**2 + 259*s - 192) - 9*Pkd2*k2*(3*r*(56*s - 25) + 90*s**2 - 176*s + 55)) + k2**4*(-2*C*Pk2*(3069*r**2 + 18*r*(589*s - 180) + 2025*s**2 - 5622*s + 1210) + 3*Pk2*(1197*r**2 + 36*r*(103*s - 30) + 675*s**2 - 1800*s + 340) + Pkd2*k2*(30 - 60*C)*(3*s - 1)*(15*r + 9*s - 10))) - 6*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 2*k1**2*k2**2*(Pk2*(171*r**2 + r*(117*s - 83) - 54*s**2 + 252*s - 88) + 3*Pkd2*k2*(r*(36*s - 23) + 36*s**2 - 64*s + 23)) - 45*k2**4*(Pk2*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 66*fd*(225*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + 2*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) - 2*k1**2*k2**2*(Pk2*(342*r**2 + r*(234*s - 82) - 108*s**2 + 276*s - 111) + 6*Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 45*k2**4*(Pk2*(18*r + 10*s - 5) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-14850*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(884*s - 375) + 2652*s**2 - 3191*s + 863) + 22*k2**2*(-Pk2*(240*r**2 + 3*r*(2800*s - 439) + 8160*s**2 - 6730*s + 721) + 75*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 22*f*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(r*(48*s - 37) + 48*s**2 - 78*s + 29) - 2*k1**2*k2**2*(Pk2*(2*C*(756*r**2 - 1860*r*s + 787*r - 744*s**2 + 3330*s - 1136) - 3372*r**2 - 3168*r*s + 1721*r - 1668*s**2 - 1265*s + 799) + 6*Pkd2*k2*(C*(600*r*s - 221*r + 288*s**2 - 630*s + 175) - 336*r*s + 141*r - 180*s**2 + 375*s - 111)) + k2**4*(Pk2*(-2*C*(4092*r**2 + 3*r*(4712*s - 1471) + 2700*s**2 - 8449*s + 1360) + 4788*r**2 + 48*r*(309*s - 94) + 2700*s**2 - 8235*s + 1095) + Pkd2*k2*(15 - 30*C)*(5*r*(24*s - 7) + 72*s**2 - 108*s + 25))) - 132*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) - 2*k1**2*k2**2*(Pk2*(684*r**2 + 4*r*(117*s - 62) - 216*s**2 + 780*s - 287) + 18*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 45*k2**4*(Pk2*(72*r**2 + 2*r*(56*s - 39) + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**5) + D1**3*Pkd3*ct**4*(2*D1*bd1*f*(f*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s*(s + 1)) + k2**2*(Pk2*(4*r**2 + r*(-240*C*s + 60*C + 124*s - 61) - 18*s*(4*C*s - 10*C - 2*s + 7)) + Pkd2*k2*(6*C - 3)*(5*r*(4*s - 1) + 3*s*(2*s - 5)))) + k2**2*(-2*Pk2 + Pkd2*k2)*(21*b2 - 42*g2)*(r*(2*s - 1) + s*(2*s - 2))) + b1**2*(-2*D1*fd*(-k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(5*s - 6) + 7*s - 7) + 21*k2**2*(2*K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f + 2*Pk2*r))*(r + s - 1) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(4*r*(5*s - 8) + 20*s**2 - 39*s + 22) + 28*r*(2*s - 5) + 56*s**2 - 154*s + 98) - 42*k2**2*(K*Pkd2*k2*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Pk2*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + f*(r + 2*s - 1) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)))) + b1*(D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(30*r*(s - 2) + 30*s**2 - 51*s + 30) + 28*r*(s - 3) + 28*s**2 - 70*s + 42) - 42*k2**2*(K*Pkd2*k2*(r*(2 - 4*s) - 4*s**2 + 5*s - 1) + Pk2*(2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*s + 4*r**2 + 4*r*(s - 1) - s + 1))) + 2*D1*(f*(-6*fd*k1**2*(4*Pk2 - Pkd2*k2)*(s + 3)*(r + s - 1) + fd*k2**2*(Pk2*(-24*C*(2*s - 1)*(10*r + 3*s - 10) + 8*r**2 + 248*r*s - 195*r + 72*s**2 - 343*s + 187) + Pkd2*k2*(12*C - 6)*(2*s - 1)*(10*r + 3*s - 10)) + k2**2*(-2*Pk2 + Pkd2*k2)*(21*bd2 - 42*gd2)*(2*s - 1)*(r + s - 1)) + 42*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 9*s - 11) + k2**2*(Pk2*(-12*C*(80*r*s - 30*r + 24*s**2 - 86*s + 25) + 16*r**2 + 496*r*s - 321*r + 144*s**2 - 650*s + 248) + Pkd2*k2*(6*C - 3)*(10*r*(8*s - 3) + 24*s**2 - 86*s + 25))) + k2**2*(-2*Pk2 + Pkd2*k2)*(21*b2 - 42*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))/(105*d**2*k2**2*k3) + D1**3*Pkd3*ct**4*(D1*bd1*f*(f**2*(54*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 28) + 6*s**2 - 23*s + 14) + 9*k1**2*k2**2*(2*Pk2*(66*r**2 - 3*r*(54*s + 13) - 228*s**2 + 184*s - 17) + 5*Pkd2*k2*(r*(29*s - 8) + 29*s**2 - 31*s + 6))) - 3*f*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) + k1**2*k2**2*(-3*Pk2*b1*(10*r**2 + r*(116*s + 45) + 106*s**2 - 69*s - 19) + 2*Pk2*(236*C*s**2 + 124*C*s + 6*K*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + r**2*(8 - 84*C) + r*(-352*C*s + 228*C + 462*s - 263) + 202*s**2 - 494*s + 147) + 9*Pkd2*b1*k2*(2*r*(8*s + 5) + 16*s**2 - 9*s - 4) - 6*Pkd2*k2*(32*C*s**2 + 18*C*s + K*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + r*(-52*C*s + 6*C + 70*s - 27) + 28*s**2 - 75*s + 27)) + 2*k2**4*(Pk2*(2*C*r**2 + 496*C*r*s + 106*C*r + 18*C*s**2 - 168*C*s - 14*K*(12*r*s - 2*r + 12*s**2 - 9*s + 2) + 7*b1*(7*r - 5) - 85*r**2 - 332*r*s + 74*r - 9*s**2 + 126*s - 57) + 3*Pkd2*k2*(2*C*(5*r - 4*s - 5) + 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 5*r + 4*s + 5))) + 42*k2**2*(-b1*(k1**2*(Pk2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(2*r**2 + 30*r*s + 9*r + 28*s**2 - 23*s - 5) - 6*r**2 - 112*r*s + 3*r - 106*s**2 + 105*s - 5) + Pkd2*k2*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-2*r*(8*s + 1) - 16*s**2 + 15*s + 1) + 40*r*s - 7*r + 40*s**2 - 43*s + 6)) + 3*k2**2*(-K*Pkd2*k2*(r + 2*s - 1) + Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1))) + 3*b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*(3*Pk2*k2**2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + k1**2*(2*Pk2*(r**2 + 5*r*(3*s + 1) + s*(14*s - 14)) - Pkd2*k2*(8*r*s + r + s*(8*s - 8)))))) - 3*b1**2*k2**2*(D1*fd*(k1**2*(-6*Pk2*f*(5*r**2 + r*(58*s + 28) + 53*s**2 + 9*s - 33) + 14*Pk2*(16*C*s**2 - 16*C*s + 2*K*(r**2 + 15*r*(s - 1) + 14*(s - 1)**2) - 3*r**2 + 2*r*(8*C*s - 28*s + 17) - 53*s**2 + 78*s - 31) + Pkd2*k2*(-112*C*s**2 + 112*C*s - 112*K*(s - 1)*(r + s - 1) + 3*f*(r*(48*s + 38) + 48*s**2 + 19*s - 38) - 14*r*(8*C*s - 20*s + 9) + 280*s**2 - 364*s + 126)) + 14*k2**2*(3*K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 6*K*Pkd2*k2*(r + 2*s - 1) + Pk2*f*(r + 1) + 6*Pk2*r)) + Dd*f*(k1**2*(Pk2*(112*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 56*K*(2*r**2 + 30*r*s - r + 28*s**2 - 30*s + 2) - 3*f*(20*r**2 + r*(232*s + 101) + 212*s**2 - 51*s - 85) - 168*r**2 - 3136*r*s + 518*r - 2968*s**2 + 3290*s - 462) - 2*Pkd2*k2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*K*(32*r*s - 5*r + 32*s**2 - 38*s + 6) - 3*f*(r*(48*s + 34) + 48*s**2 - 4*s - 25) - 560*r*s + 126*r - 560*s**2 + 644*s - 119)) + 14*k2**2*(-12*K*Pkd2*k2*(r + 2*s - 1) + Pk2*(3*K*(20*r**2 + r*(24*s - 25) + 4*s**2 - 11*s + 7) + f*(8*r - 4) + 12*r - 6)))) + b1*(D1*(f**2*fd*(54*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 10)*(6*r + 6*s - 5) + 9*k1**2*k2**2*(4*Pk2*(99*r**2 + r*(3 - 243*s) - 342*s**2 + 355*s - 59) + 5*Pkd2*k2*(r*(87*s - 36) + 87*s**2 - 104*s + 28))) - 6*f*(fd*(3*k1**4*(4*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(21*r**2 + r*(88*s - 65) - 59*s**2 - 48*s + 44) + 6*K*(22*r*s - 25*r + 22*s**2 - 43*s + 16) + 16*r**2 + 924*r*s - 793*r + 404*s**2 - 1093*s + 510) + 3*Pkd2*k2*(4*C*(r*(26*s - 6) - 16*s**2 - 11*s + 6) + K*(-22*r*s + 25*r - 22*s**2 + 43*s - 16) - 140*r*s + 60*r - 56*s**2 + 113*s - 32)) + k2**4*(Pk2*(C*(4*r**2 + r*(992*s - 66) + 36*s**2 - 574*s + 62) - 14*K*(r*(24*s - 13) + 6*(1 - 2*s)**2) - 170*r**2 - 664*r*s + 134*r - 18*s**2 + 287*s - 8) + 6*Pkd2*k2*(C*(-20*r - 26*s + 20) + 7*K*(2*s - 1)*(2*r + 2*s - 1) + 10*r + 13*s - 10))) + 7*k2**2*(3*bd2*k2**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(-2*r - 2*s + 1)) - 2*gd2*k1**2*(2*Pk2*(r + 14*s + 5) - Pkd2*k2*(8*s + 1))*(r + s - 1) + 6*gd2*k2**2*(-Pk2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) + Pkd2*k2*(r + 2*s - 1)))) + 42*fd*k2**2*(3*b2*k2**2*(-Pk2*(r + s - 1)**2 + 2*Pkd2*k2*s*(r + s)) + 4*g2*k1**2*(Pk2*(r + 14*s - 14) - 4*Pkd2*k2*(s - 1))*(r + s - 1) + 6*g2*k2**2*(Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 2*Pkd2*k2*(r + 2*s - 1)))) + Dd*f*(f**2*(108*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + 10*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(3*s - 11) + 12*s**2 - 49*s + 32) + 9*k1**2*k2**2*(6*Pk2*(88*r**2 - r*(216*s + 11) - 304*s**2 + 298*s - 45) + 5*Pkd2*k2*(4*r*(29*s - 11) + 116*s**2 - 135*s + 34))) - 6*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + k1**2*k2**2*(Pk2*(-4*C*(84*r**2 + r*(352*s - 265) - 236*s**2 - 251*s + 145) + 6*K*(44*r*s - 55*r + 44*s**2 - 107*s + 46) + 32*r**2 + 1848*r*s - 1376*r + 808*s**2 - 2282*s + 969) + 3*Pkd2*k2*(2*C*(2*r*(52*s - 9) - 64*s**2 - 60*s + 15) + K*(-44*r*s + 55*r - 44*s**2 + 107*s - 46) - 280*r*s + 109*r - 112*s**2 + 274*s - 81)) + k2**4*(Pk2*(2*C*(4*r**2 + 8*r*(124*s + 9) + 36*s**2 - 565*s - 22) - 14*K*(48*r*s - 17*r + 48*s**2 - 42*s + 10) - 340*r**2 - 1328*r*s + 274*r - 36*s**2 + 649*s - 46) - 6*Pkd2*k2*(20*C*(r + 2*s - 1) - 7*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 10*r - 20*s + 10))) + 42*k2**2*(3*b2*k2**2*(-Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + 2*g2*(k1**2*(4*Pk2*(2*r**2 + 30*r*s - r + 28*s**2 - 30*s + 2) + Pkd2*k2*(-32*r*s + 5*r - 32*s**2 + 38*s - 6)) - 3*k2**2*(-Pk2*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + 4*Pkd2*k2*(r + 2*s - 1)))))) + 2*f*(D1*(f*(fd*(-5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s + 5)*(3*r + 3*s - 2) + 3*k1**2*k2**2*(Pk2*(-20*C*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + 369*r**2 - 15*r*(24*s + 19) - 729*s**2 + 360*s + 55) + 5*Pkd2*k2*(2*C*(9*r*(s - 2) + 9*s**2 - 27*s + 13) + 9*r*(7*s - 2) + 63*s**2 - 57*s + 11)) - 3*k2**4*(2*Pk2*(C*(144*r**2 - 3*r*(270*s + 17) - 324*s**2 + 504*s - 41) - 180*r**2 + 27*r*(11*s + 4) + 162*s**2 - 231*s + 10) + Pkd2*k2*(30*C - 15)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + k2**2*(-3*bd2 + 6*gd2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(11*s - 15) + 11*s**2 - 32*s + 15) + 7*k2**2*(-2*Pk2*(2*r*(6*s - 1) + 12*s**2 - 9*s + 2) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 3*fd*k2**2*(b2 - 2*g2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(22*s - 25) + 22*s**2 - 43*s + 16) + 14*k2**2*(Pk2*r*(13 - 24*s) - 6*Pk2*(1 - 2*s)**2 + 3*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(f*(-5*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s + 11) + 12*s**2 + 15*s - 17) + 3*k1**2*k2**2*(Pk2*(-20*C*(12*r*s - 25*r + 12*s**2 - 39*s + 20) + 492*r**2 - 480*r*s - 503*r - 972*s**2 + 397*s + 150) + 5*Pkd2*k2*(C*(24*r*s - 50*r + 24*s**2 - 78*s + 40) + 84*r*s - 20*r + 84*s**2 - 75*s + 13)) - 3*k2**4*(Pk2*(2*C*(192*r**2 - 3*r*(360*s + 53) - 432*s**2 + 698*s + 19) - 480*r**2 + 792*r*s + 417*r + 432*s**2 - 614*s - 61) + Pkd2*k2*(60*C - 30)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + k2**2*(-3*b2 + 6*g2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(11*r*(4*s - 5) + 44*s**2 - 107*s + 46) + 14*k2**2*(Pk2*(r*(17 - 48*s) - 48*s**2 + 42*s - 10) + 3*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(315*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**4*(D1*(-462*b1*fd*k2**2*(15*Pk2*b2*k2**4*(r + s)**2 + b1*(k1**4*(K - 1)*(2*Pk2*(5*r**2 + r*(17*s - 10) + 12*s**2 - 10*s + 5) - 7*Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(20*C*(r + s - 1)**2 + K*(11*r**2 + 38*r*s - 30*r + 27*s**2 - 30*s + 15) - 46*r**2 - 108*r*s + 80*r - 62*s**2 + 80*s - 40) - Pkd2*k2*s*(4*K - 7)*(r + s)) + 3*k2**4*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s))) - 2*g2*(k1**4*(2*Pk2*(5*r**2 + 17*r*s - 10*r + 12*s**2 - 10*s + 5) - 7*Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(11*r**2 + 38*r*s - 30*r + 27*s**2 - 30*s + 15) - 4*Pkd2*k2*s*(r + s)) + 3*k2**4*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + f**3*(-11*bd1*k2**2*(54*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 5*k1**4*(Pk2*(150*r**2 + 252*r*s - 323*r + 102*s**2 - 295*s + 161) + 2*Pkd2*k2*(12*r*s + 37*r + 12*s**2 + 30*s - 34)) + 9*k1**2*k2**2*(Pk2*(505*r**2 + 836*r*s - 746*r + 331*s**2 - 628*s + 229) + 5*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + 5*fd*k1**2*(176*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(s - 14)*(4*r + 4*s - 3) + 11*k1**2*k2**2*(4*Pk2*(356*r**2 - 4*r*(67*s + 56) - 624*s**2 + 538*s - 39) + 7*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 11*f**2*k2**2*(90*Pk2*bd2*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 3*bd1*(2*k1**4*(Pk2*(12*C*(10*r**2 + r*(37*s - 22) + 27*s**2 - 33*s + 6) - 2*K*(45*r**2 + 34*r*s - 50*r - 11*s**2 + 48*s + 5) + 105*r**2 - 100*r*s + 44*r - 205*s**2 + 378*s - 77) - 3*Pkd2*k2*(2*C*(r*(17*s - 12) + 17*s**2 - 23*s + 6) + K*(37*r*s - 11*r + 37*s**2 - 44*s + 11) - 70*r*s + 40*r - 70*s**2 + 96*s - 28)) + k1**2*k2**2*(-Pk2*(4*C*(33*r**2 + r*(926*s - 99) - 157*s**2 - 534*s + 166) + 14*K*(74*r**2 + 80*r*s - 79*r + 6*s**2 - 13*s + 5) + 15*b1*(24*r**2 + r*(48*s - 29) + 24*s**2 - 29*s + 5) - 2270*r**2 - 5236*r*s + 3714*r - 866*s**2 + 3718*s - 1844) + 6*Pkd2*k2*(2*C*(22*r*s - 4*r - 20*s**2 + 11*s + 9) - 101*K*r*s + 27*K*r - 101*K*s**2 + 108*K*s - 27*K + b1*(r*(5 - 41*s) - 41*s**2 + 34*s + 1) + 51*r*s - 29*r + 93*s**2 - 104*s + 18)) - 2*k2**4*(Pk2*(2*C*(8*r**2 - 308*r*s + 155*r - 36*s**2 + 90*s - 159) + 378*K*r**2 + 588*K*r*s - 539*K*r + 210*K*s**2 - 441*K*s + 161*K + 7*b1*(7*r + 3*s - 5) - 96*r**2 + 220*r*s + 3*r + 36*s**2 - 12*s + 102) - 3*Pkd2*k2*(2*C*(10*r*(2*s - 1) + 6*s**2 - 11*s + 5) - 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 10*r - 6*s**2 + 11*s - 5))) + fd*(k1**4*(Pk2*(-8*C*(405*r**2 + 369*r*s - 447*r - 36*s**2 + 27*s + 58) + 15*b1*(150*r**2 + r*(252*s - 277) + 102*s**2 - 257*s + 127) + 5490*r**2 + 7632*r*s - 5826*r + 2142*s**2 - 2154*s + 964) + 10*Pkd2*k2*(-2*C*(153*r*s - 60*r + 153*s**2 - 171*s + 43) + b1*(r*(36*s + 69) + 36*s**2 + 54*s - 49) + 297*r*s - 135*r + 297*s**2 - 351*s + 96)) + 3*k1**2*k2**2*(Pk2*(-4*C*(1674*r**2 - 81*r*(4*s + 17) + 306*s**2 + 705*s + 40) + 3*b1*(1515*r**2 + 19*r*(132*s - 101) + 993*s**2 - 1605*s + 656) + 8208*r**2 + 7272*r*s - 8442*r + 3672*s**2 - 3024*s + 1694) + 5*Pkd2*k2*(-4*C*(27*r*(5*s - 2) + 135*s**2 - 141*s + 35) + 3*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 414*r*s - 180*r + 414*s**2 - 450*s + 118)) + 6*k2**4*(Pk2*(-2*C*(1026*r**2 + 882*r*s - 1056*r + 486*s**2 - 465*s + 241) + 9*b1*(3*r - 1)*(5*r + 5*s - 3) + 1242*r**2 + 1098*r*s - 1221*r + 486*s**2 - 507*s + 262) + Pkd2*k2*(15 - 30*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + 12*gd2*(k1**4*(2*Pk2*(45*r**2 + 34*r*s - 50*r - 11*s**2 + 48*s + 5) + 3*Pkd2*k2*(37*r*s - 11*r + 37*s**2 - 44*s + 11)) + k1**2*k2**2*(7*Pk2*(74*r**2 + 80*r*s - 79*r + 6*s**2 - 13*s + 5) + 3*Pkd2*k2*(101*r*s - 27*r + 101*s**2 - 108*s + 27)) + 7*k2**4*(Pk2*(54*r**2 + r*(84*s - 77) + 30*s**2 - 63*s + 23) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 33*f*k2**2*(-210*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - 30*Pk2*b2*fd*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*k2**2*(14*Pk2*k2**2*(4*r + 3*s - 2) + 3*k1**2*(5*Pk2*(24*r**2 + 48*r*s - 7*r + 24*s**2 - 7*s - 5) + Pkd2*k2*s*(82*r + 82*s - 27))) - 2*b1*(105*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 7*bd1*(k1**4*(2*K - 2)*(Pk2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 23*s + 5) + Pkd2*k2*(r*(3 - 7*s) + s*(4 - 7*s))) + k1**2*k2**2*(Pk2*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(22*r**2 + 76*r*s - 55*r + 54*s**2 - 51*s + 15) - 92*r**2 - 216*r*s + 150*r - 124*s**2 + 146*s - 40) + Pkd2*k2*(r*(K*(7 - 8*s) + 14*s - 6) + s*(-8*K*s + K + 14*s - 8))) + 3*k2**4*(K*(Pk2*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(Pk2*(12*C*(20*r**2 + r*(74*s - 40) + 54*s**2 - 57*s + 20) - 2*K*(90*r**2 + 68*r*s - 41*r - 22*s**2 + 113*s - 51) + 210*r**2 - 200*r*s + 269*r - 410*s**2 + 775*s - 345) - 3*Pkd2*k2*(K*(2*s - 1)*(37*r + 37*s - 22) + r*(68*C*s - 140*s + 43) + (2*s - 1)*(34*C*s - 70*s + 25))) + k1**2*k2**2*(Pk2*(-2*C*(66*r**2 + r*(1852*s - 545) - 314*s**2 - 1475*s + 451) - 7*K*(148*r**2 + 160*r*s - 46*r + 12*s**2 + 56*s - 31) + 2270*r**2 + 5236*r*s - 2747*r + 866*s**2 - 3081*s + 864) - 3*Pkd2*k2*(80*C*s**2 + 72*C*s + K*(2*s - 1)*(101*r + 101*s - 54) + r*(-s*(88*C + 102) + 63) - 186*s**2 + 107*s - 35)) + k2**4*(-Pk2*(2*C*(16*r**2 - 44*r*(14*s + 11) - 72*s**2 + 113*s + 313) + 7*K*(108*r**2 + 2*r*(84*s - 41) + 15*(1 - 2*s)**2) - 192*r**2 + 440*r*s + 660*r + 72*s**2 - 46*s - 357) - 6*Pkd2*k2*(7*K*(2*s - 1)*(2*r + 2*s - 1) - s*(4*C - 2)*(10*r + 3*s - 5)))) - 14*gd2*(k1**4*(2*Pk2*(5*r**2 + 17*r*s - 10*r + 12*s**2 - 11*s + 5) + Pkd2*k2*s*(-7*r - 7*s + 1)) + k1**2*k2**2*(Pk2*(11*r**2 + 38*r*s - 26*r + 27*s**2 - 24*s + 15) - Pkd2*k2*s*(4*r + 4*s + 3)) + 3*k2**4*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 28*bd1*g2*(k1**4*(2*Pk2*(5*r**2 + r*(17*s - 11) + s*(12*s - 12)) + Pkd2*k2*(r*(6 - 7*s) - s*(7*s - 7))) + k1**2*k2**2*(Pk2*(11*r**2 + r*(38*s - 29) + s*(27*s - 27)) + Pkd2*k2*(r*(7 - 4*s) - s*(4*s - 4))) + 3*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 4*fd*g2*(k1**4*(2*Pk2*(90*r**2 + 68*r*s - 41*r - 22*s**2 + 113*s - 51) + 3*Pkd2*k2*(2*s - 1)*(37*r + 37*s - 22)) + k1**2*k2**2*(7*Pk2*(148*r**2 + 160*r*s - 46*r + 12*s**2 + 56*s - 31) + 3*Pkd2*k2*(2*s - 1)*(101*r + 101*s - 54)) + 7*k2**4*(Pk2*(108*r**2 + 2*r*(84*s - 41) + 15*(1 - 2*s)**2) + 6*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(-462*b1*k2**2*(15*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(K - 1)*(2*Pk2*(20*r**2 + r*(68*s - 41) + 48*s**2 - 44*s + 15) + Pkd2*k2*(r*(6 - 28*s) + s*(9 - 28*s))) + k1**2*k2**2*(Pk2*(20*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(44*r**2 + 152*r*s - 111*r + 108*s**2 - 105*s + 45) - 184*r**2 - 432*r*s + 316*r - 248*s**2 + 310*s - 120) - Pkd2*k2*(r*(K*(16*s - 7) - 28*s + 6) + s*(2*K*(8*s + 1) - 28*s + 9))) + 3*k2**4*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(k1**4*(2*Pk2*(20*r**2 + r*(68*s - 41) + 48*s**2 - 44*s + 15) + Pkd2*k2*(r*(6 - 28*s) + s*(9 - 28*s))) + k1**2*k2**2*(Pk2*(44*r**2 + 152*r*s - 111*r + 108*s**2 - 105*s + 45) - Pkd2*k2*(r*(16*s - 7) + 2*s*(8*s + 1))) + 3*k2**4*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 5*f**3*k1**2*(176*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(s - 14)*(4*r + 4*s - 3) + 11*k1**2*k2**2*(4*Pk2*(356*r**2 - 4*r*(67*s + 56) - 624*s**2 + 538*s - 39) + 7*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 11*f**2*k2**2*(2*k1**4*(Pk2*(-4*C*(540*r**2 + 492*r*s - 655*r - 48*s**2 + 12*s + 131) + 5*b1*(300*r**2 + r*(504*s - 577) + 204*s**2 - 533*s + 271) + 3660*r**2 + 5088*r*s - 4225*r + 1428*s**2 - 1627*s + 879) + 5*Pkd2*k2*(-2*C*(204*r*s - 73*r + 204*s**2 - 231*s + 56) + b1*(2*r*(24*s + 53) + 48*s**2 + 84*s - 83) + 396*r*s - 168*r + 396*s**2 - 477*s + 129)) + 3*k1**2*k2**2*(Pk2*(-4*C*(2232*r**2 - 8*r*(54*s + 281) + 408*s**2 + 966*s + 353) + 3*b1*(2020*r**2 + r*(3344*s - 2665) + 1324*s**2 - 2233*s + 885) + 10944*r**2 + 9696*r*s - 12700*r + 4896*s**2 - 4480*s + 3216) + 5*Pkd2*k2*(-4*C*(180*r*s - 65*r + 180*s**2 - 189*s + 46) + 3*b1*(21*s - 10)*(4*r + 4*s - 3) + 552*r*s - 220*r + 552*s**2 - 606*s + 158)) + 6*k2**4*(Pk2*(-2*C*(1368*r**2 + 3*r*(392*s - 535) + 648*s**2 - 700*s + 448) + 18*b1*(2*r - 1)*(5*r + 5*s - 3) + 1656*r**2 + 1464*r*s - 1863*r + 648*s**2 - 784*s + 490) + Pkd2*k2*(30 - 60*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 33*f*k2**2*(30*Pk2*b2*k2**2*(k1**2*(4*r + 4*s - 9) - 7*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(-180*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 14*Pk2*k2**2*(11*r + 6*s - 7) + 3*Pkd2*k1**2*k2*(-2*r*(82*s - 5) - 164*s**2 + 95*s + 2)) + 2*b1*(k1**4*(Pk2*(12*C*(40*r**2 + 2*r*(74*s - 41) + 108*s**2 - 121*s + 36) + K*(-360*r**2 - 272*r*s + 282*r + 88*s**2 - 418*s + 82) + 420*r**2 - 400*r*s + 333*r - 820*s**2 + 1507*s - 547) - 3*Pkd2*k2*(2*C*(4*r*(17*s - 3) + 68*s**2 - 51*s + 6) + K*(148*r*s - 59*r + 148*s**2 - 169*s + 44) - 280*r*s + 99*r - 280*s**2 + 288*s - 69)) + k1**2*k2**2*(Pk2*(-2*C*(132*r**2 + r*(3704*s - 738) - 628*s**2 - 3063*s + 678) - 7*K*(296*r**2 + 320*r*s - 204*r + 24*s**2 + 30*s - 21) + 4540*r**2 + 10472*r*s - 6466*r + 1732*s**2 - 7329*s + 2513) + 3*Pkd2*k2*(2*C*(r*(88*s - 4) - 80*s**2 - 52*s + 9) + K*(-404*r*s + 155*r - 404*s**2 + 425*s - 108) + 204*r*s - 113*r + 372*s**2 - 265*s + 74)) + k2**4*(-Pk2*(2*C*(32*r**2 - 4*r*(308*s + 125) - 144*s**2 + 352*s + 317) + 7*K*(216*r**2 + 4*r*(84*s - 59) + 120*s**2 - 186*s + 61) - 384*r**2 + 880*r*s + 987*r + 144*s**2 - 134*s - 483) + 3*Pkd2*k2*(2*C*(10*r*(8*s - 1) + 24*s**2 - 46*s + 5) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 80*r*s + 10*r - 24*s**2 + 46*s - 5))) + 4*g2*(k1**4*(Pk2*(360*r**2 + 272*r*s - 282*r - 88*s**2 + 418*s - 82) + 3*Pkd2*k2*(148*r*s - 59*r + 148*s**2 - 169*s + 44)) + k1**2*k2**2*(7*Pk2*(296*r**2 + 320*r*s - 204*r + 24*s**2 + 30*s - 21) + 3*Pkd2*k2*(404*r*s - 155*r + 404*s**2 - 425*s + 108)) + 7*k2**4*(Pk2*(216*r**2 + 4*r*(84*s - 59) + 120*s**2 - 186*s + 61) + 6*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k2**2*k3**5) + D1**3*Pkd3*ct**3*f*k1*k2*st**4*(4*Pk2 - Pkd2*k2)*(2*D1*bd1*f*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2) + b1*(D1*fd*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (72*s - 36)*(2*r + 2*s - 1)) + Dd*f*(f*(264*r*s - 89*r + 264*s**2 - 264*s + 61) + 288*r*s - 108*r + 288*s**2 - 288*s + 72)) + 6*f*(D1*fd*(r*(12*s - 5) + 3*(1 - 2*s)**2) + 2*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2)))/(21*d**2*k3**3) - D1**3*Pkd3*ct**3*f*k1*k2*st**4*(-76032*C*D1*Pk2*f*fd*k1**2*r*s + 31680*C*D1*Pk2*f*fd*k1**2*r - 76032*C*D1*Pk2*f*fd*k1**2*s**2 + 76032*C*D1*Pk2*f*fd*k1**2*s - 19008*C*D1*Pk2*f*fd*k1**2 + 38016*C*D1*Pk2*f*fd*k2**2*r**2 - 104544*C*D1*Pk2*f*fd*k2**2*r*s + 24552*C*D1*Pk2*f*fd*k2**2*r - 95040*C*D1*Pk2*f*fd*k2**2*s**2 + 123552*C*D1*Pk2*f*fd*k2**2*s - 31416*C*D1*Pk2*f*fd*k2**2 + 19008*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 7920*C*D1*Pkd2*f*fd*k1**2*k2*r + 19008*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 19008*C*D1*Pkd2*f*fd*k1**2*k2*s + 4752*C*D1*Pkd2*f*fd*k1**2*k2 + 71280*C*D1*Pkd2*f*fd*k2**3*r*s - 23760*C*D1*Pkd2*f*fd*k2**3*r + 47520*C*D1*Pkd2*f*fd*k2**3*s**2 - 63360*C*D1*Pkd2*f*fd*k2**3*s + 15840*C*D1*Pkd2*f*fd*k2**3 - 101376*C*Dd*Pk2*f**2*k1**2*r*s + 39600*C*Dd*Pk2*f**2*k1**2*r - 101376*C*Dd*Pk2*f**2*k1**2*s**2 + 104544*C*Dd*Pk2*f**2*k1**2*s - 26928*C*Dd*Pk2*f**2*k1**2 + 50688*C*Dd*Pk2*f**2*k2**2*r**2 - 139392*C*Dd*Pk2*f**2*k2**2*r*s + 18216*C*Dd*Pk2*f**2*k2**2*r - 126720*C*Dd*Pk2*f**2*k2**2*s**2 + 165264*C*Dd*Pk2*f**2*k2**2*s - 37752*C*Dd*Pk2*f**2*k2**2 + 25344*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 9900*C*Dd*Pkd2*f**2*k1**2*k2*r + 25344*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 26136*C*Dd*Pkd2*f**2*k1**2*k2*s + 6732*C*Dd*Pkd2*f**2*k1**2*k2 + 95040*C*Dd*Pkd2*f**2*k2**3*r*s - 27720*C*Dd*Pkd2*f**2*k2**3*r + 63360*C*Dd*Pkd2*f**2*k2**3*s**2 - 87120*C*Dd*Pkd2*f**2*k2**3*s + 19800*C*Dd*Pkd2*f**2*k2**3 - 294720*D1*Pk2*f**2*fd*k1**2*r*s + 95460*D1*Pk2*f**2*fd*k1**2*r - 294720*D1*Pk2*f**2*fd*k1**2*s**2 + 309240*D1*Pk2*f**2*fd*k1**2*s - 69780*D1*Pk2*f**2*fd*k1**2 + 5280*D1*Pk2*f**2*fd*k2**2*r**2 + 5280*D1*Pk2*f**2*fd*k2**2*r*s + 5500*D1*Pk2*f**2*fd*k2**2*r + 6600*D1*Pk2*f**2*fd*k2**2*s - 6380*D1*Pk2*f**2*fd*k2**2 + 76032*D1*Pk2*f*fd*k1**2*r*s - 31680*D1*Pk2*f*fd*k1**2*r + 76032*D1*Pk2*f*fd*k1**2*s**2 - 76032*D1*Pk2*f*fd*k1**2*s + 19008*D1*Pk2*f*fd*k1**2 - 67716*D1*Pk2*f*fd*k2**2*r**2 - 2376*D1*Pk2*f*fd*k2**2*r*s + 23958*D1*Pk2*f*fd*k2**2*r + 41580*D1*Pk2*f*fd*k2**2*s**2 - 49302*D1*Pk2*f*fd*k2**2*s + 11616*D1*Pk2*f*fd*k2**2 + 50688*D1*Pk2*f*gd2*k1**2*r*s - 23760*D1*Pk2*f*gd2*k1**2*r + 50688*D1*Pk2*f*gd2*k1**2*s**2 - 72864*D1*Pk2*f*gd2*k1**2*s + 23760*D1*Pk2*f*gd2*k1**2 - 47520*D1*Pk2*f*gd2*k2**2*r**2 + 47520*D1*Pk2*f*gd2*k2**2*r*s + 35640*D1*Pk2*f*gd2*k2**2*r + 95040*D1*Pk2*f*gd2*k2**2*s**2 - 71280*D1*Pk2*f*gd2*k2**2*s + 11880*D1*Pk2*f*gd2*k2**2 + 101376*D1*Pk2*fd*g2*k1**2*r*s - 61776*D1*Pk2*fd*g2*k1**2*r + 101376*D1*Pk2*fd*g2*k1**2*s**2 - 123552*D1*Pk2*fd*g2*k1**2*s + 36432*D1*Pk2*fd*g2*k1**2 - 95040*D1*Pk2*fd*g2*k2**2*r**2 + 95040*D1*Pk2*fd*g2*k2**2*r*s - 47520*D1*Pk2*fd*g2*k2**2*r + 190080*D1*Pk2*fd*g2*k2**2*s**2 - 190080*D1*Pk2*fd*g2*k2**2*s + 47520*D1*Pk2*fd*g2*k2**2 + 73680*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 23865*D1*Pkd2*f**2*fd*k1**2*k2*r + 73680*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 77310*D1*Pkd2*f**2*fd*k1**2*k2*s + 17445*D1*Pkd2*f**2*fd*k1**2*k2 - 19008*D1*Pkd2*f*fd*k1**2*k2*r*s + 7920*D1*Pkd2*f*fd*k1**2*k2*r - 19008*D1*Pkd2*f*fd*k1**2*k2*s**2 + 19008*D1*Pkd2*f*fd*k1**2*k2*s - 4752*D1*Pkd2*f*fd*k1**2*k2 - 47520*D1*Pkd2*f*fd*k2**3*r*s + 16830*D1*Pkd2*f*fd*k2**3*r - 35640*D1*Pkd2*f*fd*k2**3*s**2 + 43560*D1*Pkd2*f*fd*k2**3*s - 10890*D1*Pkd2*f*fd*k2**3 - 12672*D1*Pkd2*f*gd2*k1**2*k2*r*s + 5940*D1*Pkd2*f*gd2*k1**2*k2*r - 12672*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 18216*D1*Pkd2*f*gd2*k1**2*k2*s - 5940*D1*Pkd2*f*gd2*k1**2*k2 - 47520*D1*Pkd2*f*gd2*k2**3*r*s + 11880*D1*Pkd2*f*gd2*k2**3*r - 47520*D1*Pkd2*f*gd2*k2**3*s**2 + 47520*D1*Pkd2*f*gd2*k2**3*s - 11880*D1*Pkd2*f*gd2*k2**3 - 25344*D1*Pkd2*fd*g2*k1**2*k2*r*s + 15444*D1*Pkd2*fd*g2*k1**2*k2*r - 25344*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 30888*D1*Pkd2*fd*g2*k1**2*k2*s - 9108*D1*Pkd2*fd*g2*k1**2*k2 - 95040*D1*Pkd2*fd*g2*k2**3*r*s + 47520*D1*Pkd2*fd*g2*k2**3*r - 95040*D1*Pkd2*fd*g2*k2**3*s**2 + 95040*D1*Pkd2*fd*g2*k2**3*s - 23760*D1*Pkd2*fd*g2*k2**3 - 33*D1*bd1*f*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + 5*k2**2*(Pk2*(-36*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) + f*(165*r**2 + 2*r*(99*s - 116) + 33*s**2 - 128*s + 67) + 324*r**2 + 360*r*s - 414*r + 36*s**2 - 198*s + 90) + 2*Pkd2*k2*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + (9 - 18*K)*(r*(4*s - 1) + (1 - 2*s)**2)))) - 294720*Dd*Pk2*f**3*k1**2*r*s + 95460*Dd*Pk2*f**3*k1**2*r - 294720*Dd*Pk2*f**3*k1**2*s**2 + 309240*Dd*Pk2*f**3*k1**2*s - 69780*Dd*Pk2*f**3*k1**2 + 5280*Dd*Pk2*f**3*k2**2*r**2 + 5280*Dd*Pk2*f**3*k2**2*r*s + 5500*Dd*Pk2*f**3*k2**2*r + 6600*Dd*Pk2*f**3*k2**2*s - 6380*Dd*Pk2*f**3*k2**2 + 101376*Dd*Pk2*f**2*k1**2*r*s - 39600*Dd*Pk2*f**2*k1**2*r + 101376*Dd*Pk2*f**2*k1**2*s**2 - 104544*Dd*Pk2*f**2*k1**2*s + 26928*Dd*Pk2*f**2*k1**2 - 90288*Dd*Pk2*f**2*k2**2*r**2 - 3168*Dd*Pk2*f**2*k2**2*r*s + 47124*Dd*Pk2*f**2*k2**2*r + 55440*Dd*Pk2*f**2*k2**2*s**2 - 60324*Dd*Pk2*f**2*k2**2*s + 11022*Dd*Pk2*f**2*k2**2 + 202752*Dd*Pk2*f*g2*k1**2*r*s - 109296*Dd*Pk2*f*g2*k1**2*r + 202752*Dd*Pk2*f*g2*k1**2*s**2 - 269280*Dd*Pk2*f*g2*k1**2*s + 83952*Dd*Pk2*f*g2*k1**2 - 190080*Dd*Pk2*f*g2*k2**2*r**2 + 190080*Dd*Pk2*f*g2*k2**2*r*s + 23760*Dd*Pk2*f*g2*k2**2*r + 380160*Dd*Pk2*f*g2*k2**2*s**2 - 332640*Dd*Pk2*f*g2*k2**2*s + 71280*Dd*Pk2*f*g2*k2**2 + 73680*Dd*Pkd2*f**3*k1**2*k2*r*s - 23865*Dd*Pkd2*f**3*k1**2*k2*r + 73680*Dd*Pkd2*f**3*k1**2*k2*s**2 - 77310*Dd*Pkd2*f**3*k1**2*k2*s + 17445*Dd*Pkd2*f**3*k1**2*k2 - 25344*Dd*Pkd2*f**2*k1**2*k2*r*s + 9900*Dd*Pkd2*f**2*k1**2*k2*r - 25344*Dd*Pkd2*f**2*k1**2*k2*s**2 + 26136*Dd*Pkd2*f**2*k1**2*k2*s - 6732*Dd*Pkd2*f**2*k1**2*k2 - 63360*Dd*Pkd2*f**2*k2**3*r*s + 19800*Dd*Pkd2*f**2*k2**3*r - 47520*Dd*Pkd2*f**2*k2**3*s**2 + 59400*Dd*Pkd2*f**2*k2**3*s - 13860*Dd*Pkd2*f**2*k2**3 - 50688*Dd*Pkd2*f*g2*k1**2*k2*r*s + 27324*Dd*Pkd2*f*g2*k1**2*k2*r - 50688*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 67320*Dd*Pkd2*f*g2*k1**2*k2*s - 20988*Dd*Pkd2*f*g2*k1**2*k2 - 190080*Dd*Pkd2*f*g2*k2**3*r*s + 71280*Dd*Pkd2*f*g2*k2**3*r - 190080*Dd*Pkd2*f*g2*k2**3*s**2 + 190080*Dd*Pkd2*f*g2*k2**3*s - 47520*Dd*Pkd2*f*g2*k2**3 - 33*b1*(D1*fd*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23) + 5*k2**2*(3*Pk2*(f*(165*r**2 + r*(198*s - 155) + 33*s**2 - 73*s + 32) + (2*r + 2*s - 1)*(-48*K*(r - 2*s + 1) + 108*r + 12*s - 6)) + Pkd2*k2*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (36 - 72*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53) + 5*k2**2*(Pk2*f*(660*r**2 + r*(792*s - 697) + 132*s**2 - 347*s + 163) - 18*Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*f*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) + Pkd2*k2*(36 - 72*K)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(3465*d**2*k3**5) + 2*D1**3*Pkd3*ct**3*k1*st**2*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*(2*r*(5*s - 3) + s*(10*s - 11)) + b1**2*(D1*fd*(r + s - 1)*(f*(52*s - 33) + 28*s - 28) + Dd*f*(f*(104*r*s - 53*r + 104*s**2 - 144*s + 43) + 112*r*s - 70*r + 112*s**2 - 168*s + 56)) + b1*f*(D1*bd1*(f*(52*r*s - 20*r + 52*s**2 - 59*s + 10) + 56*r*s - 28*r + 56*s**2 - 70*s + 14) + D1*fd*(20*s - 17)*(r + s - 1) + Dd*f*(40*r*s - 29*r + 40*s**2 - 64*s + 23)))/(35*d**2*k2*k3) + D1**3*Pkd3*ct**3*(2*D1*bd1*f*(-7*b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1)) + f*(Pk2*k2**2*(2 - 4*C)*(11*r**2 - 17*r*(s + 1) + 6*s) + k1**2*(Pk2*(39*r**2 + r*(C*(60 - 156*s) + 8*s - 60) + s*(12*C*(s + 8) - 115*s + 31)) + 3*Pkd2*k2*(r*(2*C*(13*s - 5) + s - 2) - s*(2*C*(s + 8) - 15*s + 6)))) + 14*g2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1))) + 7*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*s*(r + s - 1) + Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 7*b1**2*k1**2*(D1*bd1*f*(2*Pk2 - Pkd2*k2)*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + D1*fd*(2*Pk2*(-2*K*s + 2*K + 12*f*(r - 5*s + 2) - r - 39*s + 31) + Pkd2*k2*(2*K*s - 2*K + 3*f*(12*s - 7) + 28*s - 20))*(r + s - 1) + Dd*f*(2*Pk2*(-2*K*(4*r*s - 10*r + 4*s**2 - 11*s + 7) + 6*f*(4*r**2 - 16*r*s + r - 20*s**2 + 23*s - 4) - 4*r**2 - 160*r*s + 56*r - 156*s**2 + 199*s - 47) + Pkd2*k2*(2*K*(4*r*s - 10*r + 4*s**2 - 11*s + 7) + 3*f*(r*(24*s - 11) + 24*s**2 - 32*s + 9) + 112*r*s - 54*r + 112*s**2 - 152*s + 44))) + b1*(-624*C*D1*Pk2*f*fd*k1**2*r*s + 312*C*D1*Pk2*f*fd*k1**2*r + 48*C*D1*Pk2*f*fd*k1**2*s**2 + 600*C*D1*Pk2*f*fd*k1**2*s - 312*C*D1*Pk2*f*fd*k1**2 - 176*C*D1*Pk2*f*fd*k2**2*r**2 + 272*C*D1*Pk2*f*fd*k2**2*r*s + 264*C*D1*Pk2*f*fd*k2**2*r - 136*C*D1*Pk2*f*fd*k2**2*s - 88*C*D1*Pk2*f*fd*k2**2 + 312*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 156*C*D1*Pkd2*f*fd*k1**2*k2*r - 24*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 300*C*D1*Pkd2*f*fd*k1**2*k2*s + 156*C*D1*Pkd2*f*fd*k1**2*k2 - 1248*C*Dd*Pk2*f**2*k1**2*r*s + 552*C*Dd*Pk2*f**2*k1**2*r + 96*C*Dd*Pk2*f**2*k1**2*s**2 + 1224*C*Dd*Pk2*f**2*k1**2*s - 432*C*Dd*Pk2*f**2*k1**2 - 352*C*Dd*Pk2*f**2*k2**2*r**2 + 544*C*Dd*Pk2*f**2*k2**2*r*s + 624*C*Dd*Pk2*f**2*k2**2*r - 272*C*Dd*Pk2*f**2*k2**2*s - 224*C*Dd*Pk2*f**2*k2**2 + 624*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 276*C*Dd*Pkd2*f**2*k1**2*k2*r - 48*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 612*C*Dd*Pkd2*f**2*k1**2*k2*s + 216*C*Dd*Pkd2*f**2*k1**2*k2 + 156*D1*Pk2*f*fd*k1**2*r**2 + 32*D1*Pk2*f*fd*k1**2*r*s - 214*D1*Pk2*f*fd*k1**2*r - 460*D1*Pk2*f*fd*k1**2*s**2 + 234*D1*Pk2*f*fd*k1**2*s + 58*D1*Pk2*f*fd*k1**2 + 88*D1*Pk2*f*fd*k2**2*r**2 - 136*D1*Pk2*f*fd*k2**2*r*s - 132*D1*Pk2*f*fd*k2**2*r + 68*D1*Pk2*f*fd*k2**2*s + 44*D1*Pk2*f*fd*k2**2 + 56*D1*Pk2*f*gd2*k1**2*r*s - 168*D1*Pk2*f*gd2*k1**2*r + 56*D1*Pk2*f*gd2*k1**2*s**2 - 224*D1*Pk2*f*gd2*k1**2*s + 168*D1*Pk2*f*gd2*k1**2 + 56*D1*Pk2*fd*g2*k1**2*r*s - 56*D1*Pk2*fd*g2*k1**2*r + 56*D1*Pk2*fd*g2*k1**2*s**2 - 112*D1*Pk2*fd*g2*k1**2*s + 56*D1*Pk2*fd*g2*k1**2 + 12*D1*Pkd2*f*fd*k1**2*k2*r*s - 48*D1*Pkd2*f*fd*k1**2*k2*r + 180*D1*Pkd2*f*fd*k1**2*k2*s**2 - 144*D1*Pkd2*f*fd*k1**2*k2*s + 48*D1*Pkd2*f*fd*k1**2*k2 - 28*D1*Pkd2*f*gd2*k1**2*k2*r*s + 84*D1*Pkd2*f*gd2*k1**2*k2*r - 28*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 112*D1*Pkd2*f*gd2*k1**2*k2*s - 84*D1*Pkd2*f*gd2*k1**2*k2 - 28*D1*Pkd2*fd*g2*k1**2*k2*r*s + 28*D1*Pkd2*fd*g2*k1**2*k2*r - 28*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 56*D1*Pkd2*fd*g2*k1**2*k2*s - 28*D1*Pkd2*fd*g2*k1**2*k2 + 7*D1*bd1*f*k1**2*(-2*Pk2*(2*K*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + 60*f*s**2 - 54*f*s + r**2*(2 - 12*f) + r*(48*f*s + 6*f + 80*s - 17) + 78*s**2 - 84*s + 10) + Pkd2*k2*(2*K*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + 3*f*(4*r*(3*s - 1) + 12*s**2 - 13*s + 2) + 8*r*(7*s - 3) + 56*s**2 - 66*s + 14)) - 14*D1*bd2*f*k1**2*(2*Pk2 - Pkd2*k2)*(s - 3)*(r + s - 1) + 312*Dd*Pk2*f**2*k1**2*r**2 + 64*Dd*Pk2*f**2*k1**2*r*s - 532*Dd*Pk2*f**2*k1**2*r - 920*Dd*Pk2*f**2*k1**2*s**2 + 238*Dd*Pk2*f**2*k1**2*s + 178*Dd*Pk2*f**2*k1**2 + 176*Dd*Pk2*f**2*k2**2*r**2 - 272*Dd*Pk2*f**2*k2**2*r*s - 312*Dd*Pk2*f**2*k2**2*r + 136*Dd*Pk2*f**2*k2**2*s + 112*Dd*Pk2*f**2*k2**2 + 224*Dd*Pk2*f*g2*k1**2*r*s - 560*Dd*Pk2*f*g2*k1**2*r + 224*Dd*Pk2*f*g2*k1**2*s**2 - 616*Dd*Pk2*f*g2*k1**2*s + 392*Dd*Pk2*f*g2*k1**2 + 24*Dd*Pkd2*f**2*k1**2*k2*r*s - 72*Dd*Pkd2*f**2*k1**2*k2*r + 360*Dd*Pkd2*f**2*k1**2*k2*s**2 - 198*Dd*Pkd2*f**2*k1**2*k2*s + 60*Dd*Pkd2*f**2*k1**2*k2 - 112*Dd*Pkd2*f*g2*k1**2*k2*r*s + 280*Dd*Pkd2*f*g2*k1**2*k2*r - 112*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 308*Dd*Pkd2*f*g2*k1**2*k2*s - 196*Dd*Pkd2*f*g2*k1**2*k2 - 14*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1)*(r + s - 1) + Dd*f*(4*r*s - 10*r + 4*s**2 - 11*s + 7))))/(105*d**2*k1*k2*k3) - 2*D1**3*Pkd3*ct**3*st**2*(-3*b1**2*k1**2*(D1*fd*(k1**2*(7*K - 7)*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1) - 3*k2**2*(-2*Pk2*f*(13*r**2 + r*(26*s + 7) + 13*s**2 + 40*s - 20) + 14*Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 + r*(2 - 6*s) - s**2 - 6*s + 3) + 33*Pkd2*f*k2*(r + 2*s - 1) + 28*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1))) + Dd*f*(k1**2*(7*K - 7)*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) + 4*s**2 - 11*s + 7) - 3*k2**2*(-Pk2*f*(52*r**2 + r*(104*s - 11) + 52*s**2 + 69*s - 41) + 14*Pk2*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 - 24*r*s + 17*r - 4*s**2 - 5*s + 1) + 4*Pkd2*k2*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)))) + b1*k1**2*(-3*D1*bd1*f*(k1**2*(7*K - 7)*(4*Pk2 - Pkd2*k2)*(2*r*(s - 3) + 2*s**2 - 5*s + 3) - 3*k2**2*(Pk2*(28*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) + f*(-26*r**2 + r*(25 - 52*s) - 26*s**2 + 11*s + 1) - 140*r**2 - 168*r*s + 126*r - 28*s**2 + 14*s - 14) + 7*Pkd2*k2*(4*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(r + 2*s - 1) + 2*r + 4*s - 2))) + 3*D1*(f**2*fd*(-k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(105*s - 62) + 420*s**2 - 629*s + 214) - 3*k2**2*(4*Pk2*(15*r**2 - 135*r*s + 27*r - 150*s**2 + 122*s - 18) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) + f*(fd*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(s - 4)*(r + s - 1) + r*(46*s - 37) + 46*s**2 - 80*s + 25) + k2**2*(2*Pk2*(C*(60*r**2 + r*(254 - 516*s) - 240*s**2 + 722*s - 314) + 6*K*(64*r*s - 39*r + 64*s**2 - 78*s + 23) + 75*r**2 + 972*r*s - 546*r + 729*s**2 - 1070*s + 362) + 3*Pkd2*k2*(8*C*(2*s - 1)*(12*r + 5*s - 12) - 2*K*(64*r*s - 39*r + 64*s**2 - 78*s + 23) - 208*r*s + 121*r - 152*s**2 + 262*s - 93))) - 14*gd2*(-k1**2*(4*Pk2 - Pkd2*k2)*(s - 3) + 12*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1)))*(r + s - 1)) - 14*fd*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + 24*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1)))*(r + s - 1)) + Dd*f*(f**2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(840*r*s - 497*r + 840*s**2 - 1220*s + 396) - 9*k2**2*(8*Pk2*(10*r**2 - 90*r*s + 13*r - 100*s**2 + 78*s - 11) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) - 6*f*k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(4*s - 26) + 4*s**2 - 19*s + 17) + r*(92*s - 73) + 92*s**2 - 203*s + 70) + 3*f*k2**2*(Pk2*(8*C*(30*r**2 + r*(93 - 258*s) - 120*s**2 + 331*s - 97) + 12*K*(128*r*s - 69*r + 128*s**2 - 170*s + 53) + 300*r**2 + 3888*r*s - 1777*r + 2916*s**2 - 3911*s + 1123) + 6*Pkd2*k2*(4*C*(6*r*(8*s - 3) + 20*s**2 - 53*s + 15) + K*(-128*r*s + 69*r - 128*s**2 + 170*s - 53) - 208*r*s + 90*r - 152*s**2 + 242*s - 70)) + 42*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(2*s - 5) + 4*s**2 - 11*s + 7) - 12*k2**2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))) + f*(D1*bd1*k1**2*(f**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(10*r*(42*s - 25) + 420*s**2 - 553*s + 150) - 18*k2**2*(2*Pk2*(5*r**2 - r*(45*s + 1) - 50*s**2 + 34*s - 4) + 5*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) - 3*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(C*(s - 9) + 23*s - 18) + s**2*(C + 23) + s*(C - 67) + 27) + k2**2*(-Pk2*(-240*C*s**2 + 480*C*s + 12*K*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + r**2*(60*C + 75) + r*(-516*C*s + 148*C + 972*s - 365) + 729*s**2 - 813*s + 154) + 3*Pkd2*k2*(-40*C*s**2 + 72*C*s + K*(r*(64*s - 30) + 64*s**2 - 92*s + 30) + r*(-96*C*s + 24*C + 104*s - 27) + 76*s**2 - 94*s + 15))) + 42*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1)) - 12*k2**2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) + D1*(f*(fd*(Pk2*k2**4*(16*C - 8)*(36*r**2 - 9*r*(8*s + 5) + 42*s + 5) - 9*k1**4*(4*Pk2 - Pkd2*k2)*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) - 2*k1**2*k2**2*(-Pk2*(12*C*(3*r*(78*s - 35) + 162*s**2 - 246*s + 73) + 81*r**2 - 9*r*s + 327*r + 342*s**2 + 540*s - 335) + 6*Pkd2*k2*(C*(3*r*(78*s - 35) + 162*s**2 - 246*s + 73) - 63*r*s + 30*r - 27*s**2 + 69*s - 23))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-18*bd2 + 36*gd2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15)) - 18*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23)) + Dd*f*(f*(Pk2*k2**4*(64*C - 32)*(12*r**2 - 6*r*(4*s + 3) + 16*s + 5) - 9*k1**4*(4*Pk2 - Pkd2*k2)*(r*(48*s - 37) + 48*s**2 - 78*s + 29) - 2*k1**2*k2**2*(-Pk2*(24*C*(156*r*s - 65*r + 108*s**2 - 171*s + 49) + 108*r**2 - 12*r*s + 470*r + 456*s**2 + 864*s - 505) + 6*Pkd2*k2*(2*C*(156*r*s - 65*r + 108*s**2 - 171*s + 49) - 84*r*s + 38*r - 36*s**2 + 99*s - 31))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-18*b2 + 36*g2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53))))/(315*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct**3*(21*b1**3*k1**2*k2**2*(D1*fd*(Pk2*(r + s - 1) + 2*Pkd2*k2*s)*(r + s - 1) + Dd*f*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) - 3*b1**2*k1**2*(-7*D1*bd1*f*k2**2*(Pk2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + D1*fd*(k1**2*(6*Pk2*f*(8*r**2 + 4*r*(8*s - 7) + 24*s**2 - 31*s + 20) + 28*Pk2*(8*C*s**2 - 8*C*s - 4*K*(s - 1)*(r + s - 1) + r**2 + r*(8*C*s + 5*s - 6) + 4*s**2 - 2*s + 5) - Pkd2*k2*(112*C*s**2 - 112*C*s + 70*K*(s - 1)*(r + s - 1) + f*(12*r*(4*s - 3) + 48*s**2 - 45*s + 36) + 14*r*(8*C*s - 6*s + 5) - 84*s**2 + 252*s - 70)) + 7*k2**2*(-2*Pk2*(40*C*(r - 1)*(r + s - 1) + K*(17*r**2 - 6*r*(s - 1) - 23*(s - 1)**2) + 7*f*r**2 - 2*f*r*s - f*r - 9*f*s**2 - 20*f*s - 59*r**2 - 66*r*s + 102*r - 7*s**2 + 32*s - 36) - Pkd2*k2*(K*(r*(44*s - 38) + 44*s**2 - 76*s + 38) + 21*f*(r + 2*s - 1) + 4*r*(s*(4 - 12*C) + 5) + 4*s**2*(8*C - 6) + 4*s*(12*C + 6) - 20))) + 2*Dd*f*k1**2*(2*Pk2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 7*K*(16*r*s + 5*r + 16*s**2 - 14*s - 2) + 3*f*(8*r**2 + r*(32*s - 43) + 24*s**2 - 40*s + 24) + 28*r**2 + 140*r*s - 28*r + 112*s**2 + 14*s - 21) - Pkd2*k2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 35*K*(s - 1)*(4*r + 4*s - 3) + f*(48*r*s - 87*r + 48*s**2 - 78*s + 54) - 168*r*s + 126*r - 168*s**2 + 406*s - 133)) + 7*Dd*f*k2**2*(Pk2*(-40*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 2*K*(-68*r**2 + r*(24*s + 79) + 92*s**2 - 81*s - 11) + f*(-28*r**2 + r*(8*s + 9) + 36*s**2 + 49*s - 13) + 472*r**2 + 528*r*s - 780*r + 56*s**2 - 294*s + 276) + 2*Pkd2*k2*(4*C*(3*r*(8*s - 1) - 16*s**2 - 14*s + 3) - 88*K*r*s + 39*K*r - 88*K*s**2 + 120*K*s - 33*K - 12*f*(r + 2*s - 1) - 32*r*s - 16*r + 48*s**2 - 28*s + 16))) - 3*b1*(D1*bd1*f*k1**2*(k1**2*(2*Pk2*(56*C*(r*(4*s - 1) + (1 - 2*s)**2) + 14*K*(-8*r*s - 6*r - 8*s**2 + 5*s + 3) + 3*f*(8*r**2 + r*(32*s - 58) + 24*s**2 - 49*s + 28) + 28*r**2 + 140*r*s + 14*r + 112*s**2 - 84) - Pkd2*k2*(56*C*(r*(4*s - 1) + (1 - 2*s)**2) + 70*K*(s - 1)*(2*r + 2*s - 1) + 3*f*(2*r*(8*s - 23) + 16*s**2 - 37*s + 24) - 168*r*s + 112*r - 168*s**2 + 322*s - 126)) + 7*k2**2*(Pk2*(-40*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 68*K*r**2 + 24*K*r*s + 102*K*r + 92*K*s**2 - 58*K*s - 34*K + f*(-14*r**2 + 4*r*s + 7*r + 18*s**2 + 9*s - 13) + 236*r**2 + 264*r*s - 336*r + 28*s**2 - 122*s + 82) + Pkd2*k2*(8*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) - 2*K*(44*r*s - 13*r + 44*s**2 - 52*s + 7) - 3*f*(r + 2*s - 1) - 32*r*s - 2*r + 48*s**2 - 28*s + 2))) + D1*(-3*f**2*fd*k1**2*(24*Pk2*k2**2*(18*r**2 + r*(33*s - 28) + 15*s**2 - 22*s + 10) + k1**2*(4*Pk2*(90*r**2 - 54*r*s - 51*r - 144*s**2 + 172*s - 25) + 5*Pkd2*k2*(72*r*s - 36*r + 72*s**2 - 97*s + 30))) - 2*f*(fd*(Pk2*k2**4*(20*C - 10)*(2*r - 1) + k1**4*(Pk2*(24*C*(r*(22*s - 4) + 8*s**2 - 19*s + 4) + 6*K*(s + 3)*(2*r + 2*s - 1) + 150*r**2 - 560*r*s + 146*r - 542*s**2 + 847*s - 231) - 3*Pkd2*k2*(14*C*(2*r*s + r - 2*s**2 + s - 1) + K*(s + 3)*(2*r + 2*s - 1) - 104*r*s + 28*r - 76*s**2 + 73*s - 7)) + k1**2*k2**2*(Pk2*(4*C*(179*r**2 - r*(680*s + 49) - 47*s**2 + 583*s - 130) - 14*K*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 148*r**2 + 2244*r*s - 401*r + 472*s**2 - 1784*s + 350) + 3*Pkd2*k2*(2*C*(r*(52*s - 29) + 52*s**2 - 84*s + 29) - 7*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) - 52*r*s + 50*r - 52*s**2 + 126*s - 50))) - 7*k1**2*(bd2*k2**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(-3*r - 3*s + 4)) + 2*gd2*(k1**2*(Pk2*(8*s + 6) + 5*Pkd2*k2*(s - 1))*(r + s - 1) + k2**2*(Pk2*(17*r**2 - 2*r*(3*s + 17) - 23*s**2 + 6*s + 17) + Pkd2*k2*(r*(22*s - 7) + 22*s**2 - 30*s + 7))))) + 14*fd*k1**2*(b2*k2**2*(Pk2*(r + s - 1)**2 - 3*Pkd2*k2*s*(r + s)) + 2*g2*(k1**2*(8*Pk2 + 5*Pkd2*k2)*(s - 1)*(r + s - 1) + k2**2*(Pk2*(17*r**2 - 6*r*(s - 1) - 23*(s - 1)**2) + Pkd2*k2*(r*(22*s - 19) + 22*s**2 - 38*s + 19))))) - 2*Dd*f*(3*f**2*k1**2*(12*Pk2*k2**2*(24*r**2 + r*(44*s - 37) + 20*s**2 - 29*s + 13) + k1**2*(8*Pk2*(30*r**2 - 2*r*(9*s + 8) - 48*s**2 + 55*s - 8) + 5*Pkd2*k2*(r*(48*s - 23) + 48*s**2 - 62*s + 18))) + f*(4*Pk2*k2**4*(C*(2 - 4*r) + 2*r - 1) + k1**4*(Pk2*(12*C*(r*(88*s + 2) + 32*s**2 - 68*s + 3) + 6*K*(4*r*(s + 4) + 4*s**2 + 17*s - 13) + 300*r**2 - 1120*r*s + 108*r - 1084*s**2 + 1783*s - 367) - 3*Pkd2*k2*(14*C*(r*(4*s + 3) - 4*s**2 + s - 2) + K*(4*r*(s + 4) + 4*s**2 + 17*s - 13) - 208*r*s + 54*r - 152*s**2 + 198*s - 41)) + k1**2*k2**2*(2*Pk2*(C*(716*r**2 - r*(2720*s + 683) - 188*s**2 + 2285*s - 57) - 7*K*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 148*r**2 + 4*r*(561*s - 74) + 472*s**2 - 1788*s + 248) + 3*Pkd2*k2*(C*(r*(208*s - 98) + 208*s**2 - 272*s + 78) - 7*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 104*r*s + 77*r - 104*s**2 + 192*s - 67))) - 7*k1**2*(b2*k2**2*(Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 2*g2*(k1**2*(2*Pk2*(16*r*s + 5*r + 16*s**2 - 14*s - 2) + 5*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k2**2*(Pk2*(68*r**2 - 24*r*s - 79*r - 92*s**2 + 81*s + 11) + Pkd2*k2*(88*r*s - 39*r + 88*s**2 - 120*s + 33)))))) + f*(360*C*D1*Pk2*f*fd*k1**4*r*s + 600*C*D1*Pk2*f*fd*k1**4*r + 360*C*D1*Pk2*f*fd*k1**4*s**2 + 360*C*D1*Pk2*f*fd*k1**4*s - 400*C*D1*Pk2*f*fd*k1**4 - 4968*C*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 1944*C*D1*Pk2*f*fd*k1**2*k2**2*r*s + 4392*C*D1*Pk2*f*fd*k1**2*k2**2*r + 1728*C*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 2304*C*D1*Pk2*f*fd*k1**2*k2**2*s - 552*C*D1*Pk2*f*fd*k1**2*k2**2 - 432*C*D1*Pk2*f*fd*k2**4*r**2 - 432*C*D1*Pk2*f*fd*k2**4*r*s + 360*C*D1*Pk2*f*fd*k2**4*r + 144*C*D1*Pk2*f*fd*k2**4*s - 72*C*D1*Pk2*f*fd*k2**4 - 180*C*D1*Pkd2*f*fd*k1**4*k2*r*s - 300*C*D1*Pkd2*f*fd*k1**4*k2*r - 180*C*D1*Pkd2*f*fd*k1**4*k2*s**2 - 180*C*D1*Pkd2*f*fd*k1**4*k2*s + 200*C*D1*Pkd2*f*fd*k1**4*k2 - 4320*C*D1*Pkd2*f*fd*k1**2*k2**3*r*s + 2160*C*D1*Pkd2*f*fd*k1**2*k2**3*r - 4320*C*D1*Pkd2*f*fd*k1**2*k2**3*s**2 + 5040*C*D1*Pkd2*f*fd*k1**2*k2**3*s - 1440*C*D1*Pkd2*f*fd*k1**2*k2**3 + 480*C*Dd*Pk2*f**2*k1**4*r*s + 880*C*Dd*Pk2*f**2*k1**4*r + 480*C*Dd*Pk2*f**2*k1**4*s**2 + 600*C*Dd*Pk2*f**2*k1**4*s - 680*C*Dd*Pk2*f**2*k1**4 - 6624*C*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 2592*C*Dd*Pk2*f**2*k1**2*k2**2*r*s + 7128*C*Dd*Pk2*f**2*k1**2*k2**2*r + 2304*C*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 2976*C*Dd*Pk2*f**2*k1**2*k2**2*s - 1632*C*Dd*Pk2*f**2*k1**2*k2**2 - 576*C*Dd*Pk2*f**2*k2**4*r**2 - 576*C*Dd*Pk2*f**2*k2**4*r*s + 576*C*Dd*Pk2*f**2*k2**4*r + 288*C*Dd*Pk2*f**2*k2**4*s - 144*C*Dd*Pk2*f**2*k2**4 - 240*C*Dd*Pkd2*f**2*k1**4*k2*r*s - 440*C*Dd*Pkd2*f**2*k1**4*k2*r - 240*C*Dd*Pkd2*f**2*k1**4*k2*s**2 - 300*C*Dd*Pkd2*f**2*k1**4*k2*s + 340*C*Dd*Pkd2*f**2*k1**4*k2 - 5760*C*Dd*Pkd2*f**2*k1**2*k2**3*r*s + 2700*C*Dd*Pkd2*f**2*k1**2*k2**3*r - 5760*C*Dd*Pkd2*f**2*k1**2*k2**3*s**2 + 6840*C*Dd*Pkd2*f**2*k1**2*k2**3*s - 1980*C*Dd*Pkd2*f**2*k1**2*k2**3 + 1530*D1*Pk2*f*fd*k1**4*r**2 + 756*D1*Pk2*f*fd*k1**4*r*s - 1038*D1*Pk2*f*fd*k1**4*r - 774*D1*Pk2*f*fd*k1**4*s**2 + 1128*D1*Pk2*f*fd*k1**4*s - 198*D1*Pk2*f*fd*k1**4 + 5940*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 4968*D1*Pk2*f*fd*k1**2*k2**2*r*s - 6030*D1*Pk2*f*fd*k1**2*k2**2*r + 1620*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 1620*D1*Pk2*f*fd*k1**2*k2**2*s + 1158*D1*Pk2*f*fd*k1**2*k2**2 + 216*D1*Pk2*f*fd*k2**4*r**2 + 216*D1*Pk2*f*fd*k2**4*r*s - 180*D1*Pk2*f*fd*k2**4*r - 72*D1*Pk2*f*fd*k2**4*s + 36*D1*Pk2*f*fd*k2**4 - 72*D1*Pk2*f*gd2*k1**4*r*s - 360*D1*Pk2*f*gd2*k1**4*r - 72*D1*Pk2*f*gd2*k1**4*s**2 - 432*D1*Pk2*f*gd2*k1**4*s + 360*D1*Pk2*f*gd2*k1**4 + 1344*D1*Pk2*f*gd2*k1**2*k2**2*r**2 + 336*D1*Pk2*f*gd2*k1**2*k2**2*r*s - 1344*D1*Pk2*f*gd2*k1**2*k2**2*r - 1008*D1*Pk2*f*gd2*k1**2*k2**2*s**2 + 840*D1*Pk2*f*gd2*k1**2*k2**2*s - 144*D1*Pk2*fd*g2*k1**4*r*s - 432*D1*Pk2*fd*g2*k1**4*r - 144*D1*Pk2*fd*g2*k1**4*s**2 - 360*D1*Pk2*fd*g2*k1**4*s + 216*D1*Pk2*fd*g2*k1**4 + 2688*D1*Pk2*fd*g2*k1**2*k2**2*r**2 + 672*D1*Pk2*fd*g2*k1**2*k2**2*r*s - 2016*D1*Pk2*fd*g2*k1**2*k2**2*s**2 + 3360*D1*Pk2*fd*g2*k1**2*k2**2*s - 1176*D1*Pk2*fd*g2*k1**2*k2**2 + 1440*D1*Pkd2*f*fd*k1**4*k2*r*s - 750*D1*Pkd2*f*fd*k1**4*k2*r + 1440*D1*Pkd2*f*fd*k1**4*k2*s**2 - 1800*D1*Pkd2*f*fd*k1**4*k2*s + 530*D1*Pkd2*f*fd*k1**4*k2 + 2160*D1*Pkd2*f*fd*k1**2*k2**3*r*s - 1080*D1*Pkd2*f*fd*k1**2*k2**3*r + 2160*D1*Pkd2*f*fd*k1**2*k2**3*s**2 - 2520*D1*Pkd2*f*fd*k1**2*k2**3*s + 720*D1*Pkd2*f*fd*k1**2*k2**3 + 36*D1*Pkd2*f*gd2*k1**4*k2*r*s + 180*D1*Pkd2*f*gd2*k1**4*k2*r + 36*D1*Pkd2*f*gd2*k1**4*k2*s**2 + 216*D1*Pkd2*f*gd2*k1**4*k2*s - 180*D1*Pkd2*f*gd2*k1**4*k2 + 2016*D1*Pkd2*f*gd2*k1**2*k2**3*r*s - 756*D1*Pkd2*f*gd2*k1**2*k2**3*r + 2016*D1*Pkd2*f*gd2*k1**2*k2**3*s**2 - 2520*D1*Pkd2*f*gd2*k1**2*k2**3*s + 756*D1*Pkd2*f*gd2*k1**2*k2**3 + 72*D1*Pkd2*fd*g2*k1**4*k2*r*s + 216*D1*Pkd2*fd*g2*k1**4*k2*r + 72*D1*Pkd2*fd*g2*k1**4*k2*s**2 + 180*D1*Pkd2*fd*g2*k1**4*k2*s - 108*D1*Pkd2*fd*g2*k1**4*k2 + 4032*D1*Pkd2*fd*g2*k1**2*k2**3*r*s - 2268*D1*Pkd2*fd*g2*k1**2*k2**3*r + 4032*D1*Pkd2*fd*g2*k1**2*k2**3*s**2 - 4536*D1*Pkd2*fd*g2*k1**2*k2**3*s + 1260*D1*Pkd2*fd*g2*k1**2*k2**3 + 3*D1*bd1*(3*f**2*k1**2*(24*Pk2*k2**2*(6*r**2 + r*(11*s - 9) + 5*s**2 - 7*s + 3) + k1**2*(4*Pk2*(30*r**2 - 18*r*s - 13*r - 48*s**2 + 48*s - 7) + 5*Pkd2*k2*(24*r*s - 10*r + 24*s**2 - 27*s + 6))) + 2*f*(Pk2*k2**4*(2 - 4*C)*(13*r - 6) + k1**4*(Pk2*(96*C*s**2 - 156*C*s + 6*K*(r*(s + 5) + s**2 + 6*s - 5) + 75*r**2 + r*(264*C*s + 60*C - 280*s + 11) - 271*s**2 + 495*s - 110) - 3*Pkd2*k2*(-14*C*s**2 + K*(r*(s + 5) + s**2 + 6*s - 5) + r*(14*C*(s + 1) - 52*s + 19) - 38*s**2 + 72*s - 27)) + k1**2*k2**2*(Pk2*(r**2*(358*C - 112*K + 74) - r*(2*C*(680*s + 203) + 28*K*(s - 4) - 1122*s + 211) + s**2*(-94*C + 84*K + 236) + s*(926*C - 70*K - 806) + 240) + 3*Pkd2*k2*(C*(r*(52*s - 22) + 52*s**2 - 36*s + 2) - 7*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) - 26*r*s + 11*r - 26*s**2 + 18*s - 1))) + 14*k1**2*(b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(3*r*s + r + s*(3*s - 3))) - 2*g2*(k1**2*(Pk2*r*(8*s + 6) + 8*Pk2*s*(s - 1) + 5*Pkd2*k2*(r + s)*(s - 1)) + k2**2*(Pk2*(17*r**2 - r*(6*s + 17) - s*(23*s - 23)) + 2*Pkd2*k2*(r*(11*s - 3) + s*(11*s - 11)))))) + 6*D1*bd2*f*k1**2*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(s + 5) + s**2 + 6*s - 5) - 7*k2**2*(2*Pk2*(8*r**2 + 2*r*(s - 4) + s*(5 - 6*s)) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))) + 2040*Dd*Pk2*f**2*k1**4*r**2 + 1008*Dd*Pk2*f**2*k1**4*r*s - 1580*Dd*Pk2*f**2*k1**4*r - 1032*Dd*Pk2*f**2*k1**4*s**2 + 1538*Dd*Pk2*f**2*k1**4*s - 166*Dd*Pk2*f**2*k1**4 + 7920*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 6624*Dd*Pk2*f**2*k1**2*k2**2*r*s - 9018*Dd*Pk2*f**2*k1**2*k2**2*r + 2160*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 2400*Dd*Pk2*f**2*k1**2*k2**2*s + 2166*Dd*Pk2*f**2*k1**2*k2**2 + 288*Dd*Pk2*f**2*k2**4*r**2 + 288*Dd*Pk2*f**2*k2**4*r*s - 288*Dd*Pk2*f**2*k2**4*r - 144*Dd*Pk2*f**2*k2**4*s + 72*Dd*Pk2*f**2*k2**4 - 288*Dd*Pk2*f*g2*k1**4*r*s - 1152*Dd*Pk2*f*g2*k1**4*r - 288*Dd*Pk2*f*g2*k1**4*s**2 - 1224*Dd*Pk2*f*g2*k1**4*s + 936*Dd*Pk2*f*g2*k1**4 + 5376*Dd*Pk2*f*g2*k1**2*k2**2*r**2 + 1344*Dd*Pk2*f*g2*k1**2*k2**2*r*s - 2688*Dd*Pk2*f*g2*k1**2*k2**2*r - 4032*Dd*Pk2*f*g2*k1**2*k2**2*s**2 + 5040*Dd*Pk2*f*g2*k1**2*k2**2*s - 1176*Dd*Pk2*f*g2*k1**2*k2**2 + 1920*Dd*Pkd2*f**2*k1**4*k2*r*s - 950*Dd*Pkd2*f**2*k1**4*k2*r + 1920*Dd*Pkd2*f**2*k1**4*k2*s**2 - 2460*Dd*Pkd2*f**2*k1**4*k2*s + 730*Dd*Pkd2*f**2*k1**4*k2 + 2880*Dd*Pkd2*f**2*k1**2*k2**3*r*s - 1350*Dd*Pkd2*f**2*k1**2*k2**3*r + 2880*Dd*Pkd2*f**2*k1**2*k2**3*s**2 - 3420*Dd*Pkd2*f**2*k1**2*k2**3*s + 990*Dd*Pkd2*f**2*k1**2*k2**3 + 144*Dd*Pkd2*f*g2*k1**4*k2*r*s + 576*Dd*Pkd2*f*g2*k1**4*k2*r + 144*Dd*Pkd2*f*g2*k1**4*k2*s**2 + 612*Dd*Pkd2*f*g2*k1**4*k2*s - 468*Dd*Pkd2*f*g2*k1**4*k2 + 8064*Dd*Pkd2*f*g2*k1**2*k2**3*r*s - 3780*Dd*Pkd2*f*g2*k1**2*k2**3*r + 8064*Dd*Pkd2*f*g2*k1**2*k2**3*s**2 - 9576*Dd*Pkd2*f*g2*k1**2*k2**3*s + 2772*Dd*Pkd2*f*g2*k1**2*k2**3 + 6*b2*k1**2*(D1*fd*(3*k1**2*(2*Pk2 - Pkd2*k2)*(s + 3)*(2*r + 2*s - 1) - 7*k2**2*(2*Pk2*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))) + Dd*f*(3*k1**2*(2*Pk2 - Pkd2*k2)*(4*r*(s + 4) + 4*s**2 + 17*s - 13) - 7*k2**2*(2*Pk2*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 3*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11))))))/(315*d**2*k1*k2*k3**3) + 2*D1**3*Pkd3*ct**3*st**2*(11*D1*bd1*f*k1**2*(f**2*k2**2*(k1**2*(Pk2*(1260*r**2 + 3*r*(776*s - 561) + 1068*s**2 - 1295*s + 239) + Pkd2*k2*(3*r*(32*s - 47) + 96*s**2 - 335*s + 233)) - 9*k2**2*(Pk2*(145*r**2 + 34*r*(5*s - 6) + 25*s**2 - 124*s + 71) + 10*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**2*k2**2*(Pk2*(2*C*(5*r**2 + 3*r*(24*s - 5) + 67*s**2 - 51*s - 16) + 4*K*(4*r**2 - 56*r*s - 25*r - 60*s**2 - 26*s + 21) + 109*r**2 + 446*r*s - 338*r + 337*s**2 - 418*s + 281) + Pkd2*k2*(C*(r*(10 - 62*s) - 62*s**2 + 46*s + 16) + 9*K*(8*r*s + 5*r + 8*s**2 + 6*s - 5) - 58*r*s - r - 58*s**2 + 32*s - 25)) + k2**4*(Pk2*(4*C*(60*r**2 + 345*r*s - 95*r + 75*s**2 - 192*s + 12) - 534*K*r**2 - 1680*K*r*s + 968*K*r - 1146*K*s**2 + 1224*K*s - 434*K + 105*b1*(r + s - 1) - 696*r**2 - 1398*r*s + 1081*r - 282*s**2 + 1005*s - 293) + 3*Pkd2*k2*(-8*C*(12*r*s - 6*r + 5*s**2 - 8*s + 3) + 48*K*r*s + 2*K*r + 48*K*s**2 - 20*K*s - 2*K + b1*(13*r*(4*s - 1) + 52*s**2 - 45*s + 3) + 2*r*s - 15*r - 26*s**2 + 15*s - 3))) - 21*k2**2*(-b1*k1**2*(K - 1)*(Pk2*(10*r**2 + r*(32*s - 13) + 22*s**2 - 29*s + 5) - Pkd2*k2*(6*r*s + r + s*(6*s - 7))) + 6*b1*k2**2*(Pk2*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 2*g2*(k1**2*(Pk2*(5*r**2 + r*(16*s - 3) + s*(11*s - 11)) - Pkd2*k2*(3*r*s + r + s*(3*s - 3))) - 12*k2**2*(Pk2*(-3*r**2 + r*(4 - 8*s) - s*(5*s - 5)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(7*K - 7)*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + 3*k2**2*(Pk2*(28*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 5*f*(33*r + 33*s - 23) + 56*r**2 + 56*r*s + 140*r + 140*s - 70) + Pkd2*k2*s*(f*(52*r + 52*s - 19) + (28 - 56*K)*(r + s)))) + Dd*f*(k1**2*(7*K - 7)*(Pk2*(20*r**2 + r*(64*s - 33) + 44*s**2 - 57*s + 15) - Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 3*k2**2*(50*Pk2*f*(4*r + 4*s - 3) + 14*Pk2*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15) + Pkd2*f*k2*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3) - Pkd2*k2*(28*K - 14)*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 11*b1*k1**2*(-3*D1*(f**2*fd*k2**2*(-k1**2*(Pk2*(1260*r**2 + 3*r*(776*s - 561) + 1068*s**2 - 1423*s + 609) + Pkd2*k2*(r*(96*s - 321) + 96*s**2 - 451*s + 223)) + 3*k2**2*(Pk2*(435*r**2 + 510*r*s - 477*r + 75*s**2 - 287*s + 136) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) + f*(fd*(-k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**2*k2**2*(-Pk2*(4*C*(5*r**2 + 2*r*(36*s - 5) + 67*s**2 - 20*s + 5) + 4*K*(8*r**2 - 112*r*s + 63*r - 120*s**2 + 106*s - 23) + 218*r**2 + 892*r*s - 977*r + 674*s**2 - 1289*s + 429) + Pkd2*k2*(124*C*s**2 - 20*C*s - 9*K*(r*(16*s - 1) + 16*s**2 - 2*s - 3) + r*(s*(124*C + 116) - 99) + 116*s**2 - 178*s + 39)) + k2**4*(Pk2*(-4*C*(120*r**2 + 6*r*(115*s - 73) + 150*s**2 - 628*s + 279) + 2*K*(534*r**2 + 1680*r*s - 1001*r + 1146*s**2 - 1251*s + 339) + 1392*r**2 + 2796*r*s - 1879*r + 564*s**2 - 1801*s + 837) - 3*Pkd2*k2*(-80*C*s**2 + 96*C*s + 2*K*(r*(48*s - 17) + 48*s**2 - 34*s + 5) + 4*r*(-48*C*s + s + 14) - 52*s**2 + 61*s - 28))) - 14*gd2*k2**2*(k1**2*(-Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 18*s + 5) + Pkd2*k2*s*(3*r + 3*s - 4)) + 12*k2**2*(-Pk2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) - 14*fd*g2*k2**2*(k1**2*(-Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) + 3*Pkd2*k2*s*(r + s)) + 12*k2**2*(-Pk2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(2*k1**2*(Pk2*(2520*r**2 + 6*r*(776*s - 561) + 2136*s**2 - 2782*s + 1033) + Pkd2*k2*(24*r*(8*s - 23) + 192*s**2 - 844*s + 451)) - 9*k2**2*(Pk2*(580*r**2 + 680*r*s - 681*r + 100*s**2 - 411*s + 207) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + k1**2*k2**2*(Pk2*(C*(40*r**2 + 18*r*(32*s - 5) + 536*s**2 - 274*s - 2) + 4*K*(16*r**2 - 224*r*s + 13*r - 240*s**2 + 54*s + 19) + 436*r**2 + 1784*r*s - 1663*r + 1348*s**2 - 2135*s + 949) + Pkd2*k2*(-2*C*(r*(124*s - 5) + 124*s**2 - 51*s - 8) + 9*K*(32*r*s + 9*r + 32*s**2 + 10*s - 13) - 232*r*s + 107*r - 232*s**2 + 252*s - 73)) + k2**4*(2*Pk2*(2*C*(240*r**2 + 4*r*(345*s - 173) + 300*s**2 - 1181*s + 390) - K*(1068*r**2 + 3360*r*s - 1969*r + 2292*s**2 - 2475*s + 773) - 1392*r**2 - 2796*r*s + 2111*r - 564*s**2 + 2101*s - 848) - 3*Pkd2*k2*(8*C*(6*r*(8*s - 1) + 20*s**2 - 29*s + 3) - 6*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) - 8*r*s - 55*r + 104*s**2 - 92*s + 45))) + 42*g2*k2**2*(k1**2*(-Pk2*(20*r**2 + r*(64*s - 33) + 44*s**2 - 57*s + 15) + Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 12*k2**2*(-Pk2*(12*r**2 + 32*r*s - 30*r + 20*s**2 - 33*s + 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(f**2*fd*k1**2*(2640*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1832*s - 1019) + 1832*s**2 - 2580*s + 811) + 11*k1**2*k2**2*(4*Pk2*(708*r**2 - 3*r*(844*s + 31) - 3240*s**2 + 2698*s - 286) + 25*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 11*f*(fd*(Pk2*k2**6*(16*C - 8)*(36*r**2 - 9*r*(8*s + 5) + 42*s + 5) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) - 9*k1**4*k2**2*(-2*Pk2*(2*C*(9*r**2 + 3*r*(7*s - 8) - 36*s**2 - 43*s + 23) + 27*r**2 + 132*r*s - 49*r + 153*s**2 - 64*s + 3) + Pkd2*k2*(8*C*(12*r*s - 7*r - 15*s + 6) - 12*r*s + 19*r + 36*s**2 + 30*s - 19)) - 2*k1**2*k2**4*(Pk2*(2*C*(855*r**2 + 9738*r*s - 2232*r + 2727*s**2 - 6261*s + 1351) + 576*r**2 - 8163*r*s + 789*r - 2583*s**2 + 5478*s - 959) + 6*Pkd2*k2*(C*(3*r*(6*s - 5) - 54*s**2 - 30*s + 19) + (3*s - 1)*(15*r + 27*s - 4)))) - 6*k1**2*(15*Pk2*bd2*k2**4*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**2*k2**2*(4*Pk2*(4*r**2 - r*(56*s + 25) - 60*s**2 - 26*s + 21) + 9*Pkd2*k2*(r*(8*s + 5) + 8*s**2 + 6*s - 5)) + 2*k2**4*(-Pk2*(267*r**2 + r*(840*s - 484) + 573*s**2 - 612*s + 217) + 3*Pkd2*k2*(24*r*s + r + 24*s**2 - 10*s - 1))))) - 66*fd*k1**2*(15*Pk2*b2*k2**4*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + k1**2*k2**2*(4*Pk2*(8*r**2 - 112*r*s + 63*r - 120*s**2 + 106*s - 23) + 9*Pkd2*k2*(16*r*s - r + 16*s**2 - 2*s - 3)) + 2*k2**4*(-Pk2*(534*r**2 + 1680*r*s - 1001*r + 1146*s**2 - 1251*s + 339) + 3*Pkd2*k2*(48*r*s - 17*r + 48*s**2 - 34*s + 5))))) + Dd*f*(f**2*k1**2*(2640*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1832*s - 1019) + 1832*s**2 - 2580*s + 811) + 11*k1**2*k2**2*(4*Pk2*(708*r**2 - 3*r*(844*s + 31) - 3240*s**2 + 2698*s - 286) + 25*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 11*f*(Pk2*k2**6*(64*C - 32)*(12*r**2 - 6*r*(4*s + 3) + 16*s + 5) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 7) + 12*s**2 - 33*s + 13) - 9*k1**4*k2**2*(-2*Pk2*(4*C*(6*r**2 + 2*r*(7*s - 11) - 24*s**2 - 43*s + 20) + 36*r**2 + 44*r*(4*s - 1) + 204*s**2 - 43*s - 11) + Pkd2*k2*(2*C*(r*(64*s - 39) - 94*s + 35) + r*(31 - 16*s) + 48*s**2 + 58*s - 31)) - 2*k1**2*k2**4*(Pk2*(2*C*(1140*r**2 + 3*r*(4328*s - 847) + 3636*s**2 - 8959*s + 1375) + 768*r**2 - 10884*r*s + 349*r - 3444*s**2 + 7681*s - 711) + 6*Pkd2*k2*(C*(24*r*s - 22*r - 72*s**2 - 54*s + 26) + 60*r*s - 16*r + 108*s**2 - 45*s + 5))) - 66*k1**2*(15*Pk2*b2*k2**4*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + k1**2*k2**2*(4*Pk2*(16*r**2 - 224*r*s + 13*r - 240*s**2 + 54*s + 19) + 9*Pkd2*k2*(32*r*s + 9*r + 32*s**2 + 10*s - 13)) + 2*k2**4*(-Pk2*(1068*r**2 + 3360*r*s - 1969*r + 2292*s**2 - 2475*s + 773) + 9*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1)))))))/(3465*d**2*k1*k2*k3**5) - D1**3*Pkd3*ct**3*(D1*bd1*f*(f**2*k1**2*(216*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + 5*k1**4*(2*Pk2*(60*r**2 + 138*r*s - 133*r + 78*s**2 - 139*s + 57) + Pkd2*k2*(-18*r*s + 53*r - 18*s**2 + 59*s - 37)) + 9*k1**2*k2**2*(Pk2*(386*r**2 + 916*r*s - 665*r + 530*s**2 - 749*s + 207) + 5*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + 3*f*(Pk2*k2**6*(4 - 8*C)*(11*r**2 - 17*r*s - 4*r + 6*s - 6) + 2*k1**6*(2*Pk2*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - K*(3*r*(8*s + 5) + 24*s**2 + 11*s - 15) + 30*r**2 + 36*r*s - 6*r + 6*s**2 + 26*s - 12) - 3*Pkd2*k2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 7*K*(s - 1)*(r + s - 1) - 23*r*s + 15*r - 23*s**2 + 34*s - 11)) + k1**4*k2**2*(15*Pk2*b1*(12*r**2 + r*(24*s - 11) + 12*s**2 - 11*s - 1) - 2*Pk2*(2*C*(153*r**2 + r*(912*s - 239) - 81*s**2 - 557*s + 218) + K*(575*r**2 + 1302*r*s - 792*r + 727*s**2 - 654*s + 217) - 1394*r**2 - 3250*r*s + 2211*r - 1016*s**2 + 2323*s - 1081) + 3*Pkd2*b1*k2*(3*r*(8*s - 9) + 24*s**2 - 31*s + 17) - 6*Pkd2*k2*(2*C*(r*(41*s - 24) + 55*s**2 - 60*s + 5) + K*(71*r*s - 37*r + 71*s**2 - 106*s + 37) - 114*r*s + 64*r - 128*s**2 + 160*s - 32)) + k1**2*k2**4*(7*Pk2*b1*(72*r**2 + r*(96*s - 121) + 24*s**2 - 73*s + 49) - 2*Pk2*(2*C*(221*r**2 + r*(179 - 650*s) - 59*s**2 + 95*s - 246) + 7*K*(163*r**2 + 334*r*s - 254*r + 171*s**2 - 242*s + 91) - 730*r**2 - 128*r*s + 468*r - 210*s**2 + 358*s + 6) + 21*Pkd2*b1*k2*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) - 6*Pkd2*k2*(C*(r*(34*s - 24) + 62*s**2 - 60*s - 2) + 7*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) - 31*r*s + 19*r - 45*s**2 + 44*s + 1))) + 21*k1**2*(5*Pk2*b1**2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 20*Pk2*b2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*b1*(k1**4*(2 - 2*K)*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(-Pk2*(40*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-18*r**2 + 24*r*s - 47*r + 42*s**2 - 67*s + 45) + 28*r**2 - 4*r*s + 67*r - 32*s**2 + 87*s - 75) + Pkd2*k2*(r*(K*(58*s - 17) - 44*s + 11) + s*(K*(58*s - 41) - 44*s + 33))) + k2**4*(Pk2*(-20*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) - K*(42*r**2 + 128*r*s - 103*r + 86*s**2 - 115*s + 45) + 6*r**2 - 152*r*s - 25*r + 42*s**2 + 17*s + 5) + Pkd2*k2*(r*(K*(34*s - 11) - 20*s + 5) + s*(K*(34*s - 23) - 20*s + 15)))) + 4*g2*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + k1**2*k2**2*(Pk2*(9*r**2 + r*(11 - 12*s) - s*(21*s - 21)) + Pkd2*k2*(r*(29*s - 17) + s*(29*s - 29))) + k2**4*(Pk2*(-21*r**2 + r*(37 - 64*s) - s*(43*s - 43)) + Pkd2*k2*(r*(17*s - 11) + s*(17*s - 17)))))) + 105*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k1**2*(D1*fd*(k1**4*s*(56*K - 56)*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(Pk2*(560*C*(r + s - 1)**2 - 42*K*(3*r**2 + r*(30 - 4*s) - 7*s**2 + 30*s - 15) + 15*f*(12*r**2 + 3*r*(8*s + 3) + 12*s**2 + 9*s - 11) + 196*r**2 - 28*r*(s - 75) - 224*s**2 + 2100*s - 1050) + Pkd2*k2*s*(f*(72*r + 72*s - 57) + (308 - 406*K)*(r + s))) + 7*k2**4*(Pk2*(80*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 2*K*(21*r**2 + 64*r*s - 90*r + 43*s**2 - 90*s + 45) + f*(72*r**2 + r*(96*s + 5) + 24*s**2 + 29*s - 43) - 6*r**2 + 152*r*s + 220*r - 42*s**2 + 20*s - 110) + Pkd2*k2*s*(3*f*(12*r + 12*s - 5) + (20 - 34*K)*(r + s)))) + Dd*f*(k1**4*(28*K - 28)*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(2*Pk2*(280*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(36*r**2 - 48*r*s + 173*r - 84*s**2 + 203*s - 135) + 15*f*(12*r**2 + r*(24*s - 1) + 12*s**2 - s - 6) + 392*r**2 - 56*r*s + 1946*r - 448*s**2 + 2156*s - 1575) + Pkd2*k2*(3*f*(3*r*(16*s - 9) + 48*s**2 - 50*s + 17) - 14*r*(116*K*s - 17*K - 88*s + 11) - 14*s*(116*K*s - 53*K - 88*s + 44))) + 7*k2**4*(2*Pk2*(20*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + 84*K*r**2 + 256*K*r*s - 259*K*r + 172*K*s**2 - 277*K*s + 135*K + f*(72*r**2 + 96*r*s - 58*r + 24*s**2 - 22*s + 3) - 12*r**2 + 304*r*s + 193*r - 84*s**2 - 45*s - 115) + Pkd2*k2*(f*(9*r*(8*s - 1) + 72*s**2 - 48*s + 3) + 2*r*(-68*K*s + 11*K + 40*s - 5) + 2*s*(-68*K*s + 29*K + 40*s - 20))))) + b1*(D1*(f**2*fd*k1**2*(216*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + 5*k1**4*(6*Pk2*(60*r**2 + 2*r*(69*s - 55) + 78*s**2 - 119*s + 50) + Pkd2*k2*(-6*r*(9*s - 5) - 54*s**2 + 57*s - 20)) + 9*k1**2*k2**2*(Pk2*(1158*r**2 + 2748*r*s - 1837*r + 1590*s**2 - 2009*s + 757) + 5*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) - 6*f*fd*(Pk2*k2**6*(4*C - 2)*(2*r - 1)*(11*r - 17*s - 16) + k1**6*(-2*Pk2*(K*(r*(3 - 48*s) - 48*s**2 + 20*s + 2) + 60*r**2 + r*(96*C*s + 72*s - 63) + (2*s - 1)*(48*C*s + 6*s - 13)) + 3*Pkd2*k2*(2*r + 2*s - 1)*(7*K*(s - 1) + s*(16*C - 23) + 7)) + k1**4*k2**2*(Pk2*(4*C*(153*r**2 + r*(912*s - 173) - 81*s**2 - 539*s + 97) + K*(1150*r**2 + 21*r*(124*s - 63) + 1454*s**2 - 1209*s + 241) - 2788*r**2 - 6500*r*s + 3085*r - 2032*s**2 + 3666*s - 794) + 3*Pkd2*k2*(220*C*s**2 - 54*C*s + K*(2*r*(71*s - 46) + 142*s**2 - 177*s + 53) + r*(s*(164*C - 228) + 49) - 256*s**2 + 149*s - 28)) + k1**2*k2**4*(Pk2*(4*C*(221*r**2 - 2*r*(325*s + 159) - 59*s**2 + 494*s + 100) + 7*K*(326*r**2 + 668*r*s - 365*r + 342*s**2 - 353*s + 91) - 1460*r**2 - 256*r*s + 1409*r - 420*s**2 - 420*s - 255) + 3*Pkd2*k2*(7*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(C*(34*r + 62*s - 3) - 31*r - 45*s + 5)))) + 84*f*k1**2*(5*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-2*k1**4*s*(2*Pk2 - Pkd2*k2)*(2*r + 2*s - 1) + k1**2*k2**2*(Pk2*(9*r**2 - 12*r*(s - 3) - 21*s**2 + 46*s - 45) + Pkd2*k2*s*(29*r + 29*s - 12)) + k2**4*(-Pk2*(21*r**2 + 64*r*s - 66*r + 43*s**2 - 72*s + 45) + Pkd2*k2*s*(17*r + 17*s - 6)))) + 84*fd*k1**2*(5*Pk2*b2*k2**4*(r + s)**2 + g2*(-4*k1**4*s*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(3*Pk2*(3*r**2 - 4*r*s + 30*r - 7*s**2 + 30*s - 15) + 29*Pkd2*k2*s*(r + s)) + k2**4*(-Pk2*(21*r**2 + 64*r*s - 90*r + 43*s**2 - 90*s + 45) + 17*Pkd2*k2*s*(r + s))))) + Dd*f*(f**2*k1**2*(216*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + 5*k1**4*(2*Pk2*(240*r**2 + 552*r*s - 463*r + 312*s**2 - 496*s + 207) + Pkd2*k2*(-72*r*s + 83*r - 72*s**2 + 116*s - 57)) + 18*k1**2*k2**2*(Pk2*(772*r**2 + r*(1832*s - 1251) + 1060*s**2 - 1379*s + 482) + 5*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) + 6*f*(Pk2*k2**6*(4 - 8*C)*(2*r - 1)*(11*r - 17*s - 13) + k1**6*(2*Pk2*(12*C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - K*(96*r*s + 27*r + 96*s**2 + 2*s - 32) + 120*r**2 + 144*r*s - 99*r + 24*s**2 - 4*s + 1) - 3*Pkd2*k2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + 7*K*(s - 1)*(4*r + 4*s - 3) - 92*r*s + 36*r - 92*s**2 + 97*s - 25)) + k1**4*k2**2*(Pk2*(-2*C*(612*r**2 + r*(3648*s - 737) - 324*s**2 - 2525*s + 411) - K*(2300*r**2 + 5208*r*s - 2907*r + 2908*s**2 - 2517*s + 675) + 5576*r**2 + 13000*r*s - 7393*r + 4064*s**2 - 8618*s + 2578) - 3*Pkd2*k2*(2*C*(4*r*(41*s - 6) + 220*s**2 - 109*s + 5) + K*(284*r*s - 166*r + 284*s**2 - 389*s + 127) - 456*r*s + 134*r - 512*s**2 + 412*s - 81)) + k1**2*k2**4*(Pk2*(-2*C*(884*r**2 - r*(2600*s + 893) - 236*s**2 + 1585*s + 169) - 7*K*(652*r**2 + 1336*r*s - 873*r + 684*s**2 - 837*s + 273) + 2920*r**2 + 512*r*s - 2975*r + 840*s**2 + 96*s + 617) - 3*Pkd2*k2*(2*C*(4*r*(17*s - 3) + 124*s**2 - 37*s - 1) + 7*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 124*r*s + 19*r - 180*s**2 + 65*s + 1))) + 84*k1**2*(5*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(Pk2*(36*r**2 + r*(173 - 48*s) - 84*s**2 + 203*s - 135) + Pkd2*k2*(r*(116*s - 17) + s*(116*s - 53))) + k2**4*(-Pk2*(84*r**2 + r*(256*s - 259) + 172*s**2 - 277*s + 135) + Pkd2*k2*(r*(68*s - 11) + s*(68*s - 29))))))) + f*(D1*(-5*f**2*fd*k1**4*(32*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(140*r**2 + 8*r*s - 91*r - 132*s**2 + 151*s - 20) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*fd*(Pk2*k2**6*(36*C - 18)*(3*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(2*C*Pk2*(30*r*(6*s + 1) + 180*s**2 - 81*s - 23) - 3*Pk2*(75*r**2 + 10*r*(27*s - 8) + 195*s**2 - 154*s + 18) + Pkd2*k2*(45*C - 45)*(s - 1)*(3*r + 3*s - 2)) + k1**4*k2**2*(Pk2*(6*C*(1461*r**2 + 2700*r*s - 1913*r + 1671*s**2 - 1603*s + 524) - 9576*r**2 - 18828*r*s + 13011*r - 10548*s**2 + 11868*s - 3965) + 5*Pkd2*k2*(C*(6*r*(93*s - 55) + 558*s**2 - 738*s + 232) - 414*r*s + 255*r - 414*s**2 + 558*s - 179)) + 3*k1**2*k2**4*(Pk2*(C*(5382*r**2 + 9576*r*s - 6858*r + 5058*s**2 - 5994*s + 2060) - 3267*r**2 - 5778*r*s + 4068*r - 2943*s**2 + 3459*s - 1177) + Pkd2*k2*(120*C - 60)*(2*s - 1)*(3*r + 3*s - 2))) + 6*f*k1**2*(-15*Pk2*bd2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 2*gd2*(k1**4*(Pk2*(6*r*(8*s + 5) + 48*s**2 + 22*s - 30) + 21*Pkd2*k2*(s - 1)*(r + s - 1)) + k1**2*k2**2*(Pk2*(575*r**2 + 1302*r*s - 792*r + 727*s**2 - 654*s + 217) + 3*Pkd2*k2*(71*r*s - 37*r + 71*s**2 - 106*s + 37)) + 7*k2**4*(Pk2*(163*r**2 + 334*r*s - 254*r + 171*s**2 - 242*s + 91) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3)))) + 6*fd*k1**2*(-15*Pk2*b2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + 2*g2*(k1**4*(Pk2*(96*r*s - 6*r + 96*s**2 - 40*s - 4) + 21*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(1150*r**2 + 21*r*(124*s - 63) + 1454*s**2 - 1209*s + 241) + 3*Pkd2*k2*(2*r*(71*s - 46) + 142*s**2 - 177*s + 53)) + 7*k2**4*(Pk2*(326*r**2 + 668*r*s - 365*r + 342*s**2 - 353*s + 91) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-5*f**2*k1**4*(32*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(140*r**2 + 8*r*s - 91*r - 132*s**2 + 151*s - 20) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(Pk2*k2**6*(72*C - 36)*(2*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(Pk2*(2*C*(240*r*s + 65*r + 240*s**2 - 78*s - 58) - 300*r**2 - 1080*r*s + 295*r - 780*s**2 + 581*s - 34) + Pkd2*k2*(45*C - 45)*(s - 1)*(4*r + 4*s - 3)) + k1**4*k2**2*(Pk2*(2*C*(5844*r**2 + 10800*r*s - 8023*r + 6684*s**2 - 6449*s + 2395) - 12768*r**2 - 25104*r*s + 18133*r - 14064*s**2 + 16150*s - 5895) + 5*Pkd2*k2*(2*C*(4*r*(93*s - 53) + 372*s**2 - 507*s + 163) - 552*r*s + 329*r - 552*s**2 + 768*s - 253)) + 3*k1**2*k2**4*(Pk2*(2*C*(3588*r**2 + 6384*r*s - 4887*r + 3372*s**2 - 4213*s + 1591) - 4356*r**2 - 7704*r*s + 5796*r - 3924*s**2 + 4861*s - 1816) + Pkd2*k2*(30*C - 15)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 6*k1**2*(-15*Pk2*b2*k2**2*(k1**2*(9*r + 9*s - 1) + 7*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 2*g2*(k1**4*(2*Pk2*(96*r*s + 27*r + 96*s**2 + 2*s - 32) + 21*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(2300*r**2 + 5208*r*s - 2907*r + 2908*s**2 - 2517*s + 675) + 3*Pkd2*k2*(284*r*s - 166*r + 284*s**2 - 389*s + 127)) + 7*k2**4*(Pk2*(652*r**2 + 1336*r*s - 873*r + 684*s**2 - 837*s + 273) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(315*d**2*k1*k2*k3**5) + 2*D1**3*Pkd3*ct**2*f*k1**2*k2**2*st**6*(4*Pk2 - Pkd2*k2)*(396*C*D1*f*fd*r*s - 132*C*D1*f*fd*r + 396*C*D1*f*fd*s**2 - 396*C*D1*f*fd*s + 88*C*D1*f*fd + 528*C*Dd*f**2*r*s - 154*C*Dd*f**2*r + 528*C*Dd*f**2*s**2 - 528*C*Dd*f**2*s + 110*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 2072*D1*f**2*fd*r*s - 595*D1*f**2*fd*r + 2072*D1*f**2*fd*s**2 - 2072*D1*f**2*fd*s + 427*D1*f**2*fd - 396*D1*f*fd*r*s + 132*D1*f*fd*r - 396*D1*f*fd*s**2 + 396*D1*f*fd*s - 88*D1*f*fd - 792*D1*f*gd2*r*s + 198*D1*f*gd2*r - 792*D1*f*gd2*s**2 + 792*D1*f*gd2*s - 198*D1*f*gd2 - 1584*D1*fd*g2*r*s + 792*D1*fd*g2*r - 1584*D1*fd*g2*s**2 + 1584*D1*fd*g2*s - 396*D1*fd*g2 + 2072*Dd*f**3*r*s - 595*Dd*f**3*r + 2072*Dd*f**3*s**2 - 2072*Dd*f**3*s + 427*Dd*f**3 - 528*Dd*f**2*r*s + 154*Dd*f**2*r - 528*Dd*f**2*s**2 + 528*Dd*f**2*s - 110*Dd*f**2 - 3168*Dd*f*g2*r*s + 1188*Dd*f*g2*r - 3168*Dd*f*g2*s**2 + 3168*Dd*f*g2*s - 792*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(693*d**2*k3**5) + D1**3*Pkd3*ct**2*st**4*(42*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*b1*(14*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*(f**2*fd*(2*Pk2*k2**2*(15*r**2 + r*(15*s - 47) - 35*s + 24) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(81*s - 34) + 81*s**2 - 96*s + 26)) + 2*f*(fd*k1**2*(4*Pk2 - Pkd2*k2)*(8*C*(2*s - 1)*(r + s - 1) + r*(48*s - 31) + 48*s**2 - 54*s + 15) + 30*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1) - 14*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1)) - 56*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) + Dd*f*(f**2*(2*Pk2*k2**2*(20*r**2 + r*(20*s - 61) - 40*s + 33) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(18*s - 7) + 108*s**2 - 125*s + 32)) + 2*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + r*(96*s - 57) + 96*s**2 - 130*s + 43) + 30*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1))) - 28*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(3*D1*bd1*(f**2*(2*Pk2*k2**2*(r - 1)*(5*r + 5*s - 9) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(27*s - 8) + 27*s**2 - 29*s + 6)) + 2*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(C*(8*s - 2) + 24*s - 13) + s**2*(8*C + 24) - s*(6*C + 40) + 15) + 15*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) - 28*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*(f*fd*(12*k1**2*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 3*(1 - 2*s)**2) + k2**2*(Pk2*(-120*C*(3*s - 1)*(3*r + 2*s - 2) - 108*r**2 + 432*r*s - 141*r + 360*s**2 - 486*s + 133) + Pkd2*k2*(60*C - 30)*(3*s - 1)*(3*r + 2*s - 2))) + 45*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(4*s - 1) + (1 - 2*s)**2) + 90*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(64*s - 25) + 64*s**2 - 66*s + 17) + k2**2*(-2*Pk2*(30*C*(24*r*s - 7*r + 16*s**2 - 22*s + 5) + 72*r**2 - 288*r*s + 69*r - 240*s**2 + 326*s - 83) + Pkd2*k2*(30*C - 15)*(r*(24*s - 7) + 16*s**2 - 22*s + 5))) + k2**2*(-2*Pk2 + Pkd2*k2)*(90*b2 - 180*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))))/(105*d**2*k3**3) + D1**3*Pkd3*ct**2*st**4*(99*D1*bd1*f*(f**2*k2**2*(-2*Pk2*k2**2*(r - 1)*(5*r + 5*s - 9) + 5*k1**2*(Pk2*(75*r**2 + 2*r*(56*s - 51) + 37*s**2 - 68*s + 23) + Pkd2*k2*(r*(19*s - 4) + 19*s**2 - 21*s + 6))) + 2*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(Pk2*(4*C*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) - 2*K*(25*r**2 + 9*r*s - 8*r - 16*s**2 + 49*s - 17) + 125*r**2 + 216*r*s - 178*r + 91*s**2 - 114*s + 57) + Pkd2*k2*(-2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(23 - 36*s) - 36*s**2 + 64*s - 23) + 12*r*(s - 1) + 12*s**2 - 28*s + 10)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 14*k1**2*k2**2*(-b1*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 1386*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) - 2*Pkd2*k2*s*(r + s)) + Dd*f*(Pk2*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 99*b1*(D1*(f**2*fd*k2**2*(-2*Pk2*k2**2*(15*r**2 + r*(15*s - 47) - 35*s + 24) + 5*k1**2*(Pk2*(225*r**2 + 336*r*s - 267*r + 111*s**2 - 191*s + 86) + Pkd2*k2*(57*r*s - 34*r + 57*s**2 - 72*s + 22))) + 2*f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + k1**2*k2**2*(Pk2*(8*C*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) - 4*K*(25*r**2 + 9*r*s - r - 16*s**2 + 30*s - 11) + 250*r**2 + 432*r*s - 227*r + 182*s**2 - 165*s + 27) + Pkd2*k2*(-2*K*(r*(36*s - 25) + 36*s**2 - 50*s + 16) + r*(-16*C*s + 24*s - 11) - (2*s - 1)*(8*C*s - 12*s + 9))) - 15*k2**4*(2*r + 2*s - 1)*(K*Pk2*(18*r + 10*s - 5) + 2*K*Pkd2*k2*(2*s - 1) - 4*Pk2*r)) + 14*gd2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 28*fd*g2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(-2*Pk2*k2**2*(20*r**2 + r*(20*s - 61) - 40*s + 33) + 5*k1**2*(Pk2*(300*r**2 + 448*r*s - 369*r + 148*s**2 - 259*s + 109) + Pkd2*k2*(76*r*s - 38*r + 76*s**2 - 93*s + 28))) + 2*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + k1**2*k2**2*(Pk2*(4*C*(20*r**2 + r*(56*s - 37) + 36*s**2 - 47*s + 16) - 4*K*(50*r**2 + 18*r*s - 9*r - 32*s**2 + 79*s - 28) + 500*r**2 + 864*r*s - 571*r + 364*s**2 - 381*s + 125) + Pkd2*k2*(C*(r*(4 - 32*s) - 32*s**2 + 24*s - 2) - 6*K*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13) + 48*r*s - 31*r + 48*s**2 - 82*s + 27)) - 15*k2**4*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2))) + 28*g2*k1**2*k2**2*(-Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(410*s - 141) + 2460*s**2 - 2713*s + 640) + 22*k2**2*(Pk2*(360*r**2 + r*(27 - 4200*s) - 4560*s**2 + 3550*s - 181) + 45*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 66*f*(-225*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + fd*k1**2*k2**2*(Pk2*(-4*C*(117*r**2 - 279*r*s + 39*r - 198*s**2 + 318*s - 79) + 873*r**2 + 378*r*s - 519*r - 99*s**2 + 207*s - 24) + 3*Pkd2*k2*(-4*C*(3*s - 1)*(25*r + 14*s - 18) + 186*r*s - 65*r + 120*s**2 - 172*s + 45)) + fd*k2**4*(-2*C*Pk2*(666*r**2 + 6*r*(351*s - 128) + 450*s**2 - 1173*s + 289) + 3*Pk2*(258*r**2 + r*(738*s - 269) + 150*s**2 - 389*s + 92) + Pkd2*k2*(30 - 60*C)*(3*s - 1)*(3*r + 2*s - 2)) - 6*gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k1**2*k2**2*(-2*Pk2*(25*r**2 + r*(9*s - 8) - 16*s**2 + 49*s - 17) + Pkd2*k2*(r*(23 - 36*s) - 36*s**2 + 64*s - 23)) - 15*k2**4*(Pk2*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 198*fd*(75*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + 2*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) - 2*k1**2*k2**2*(2*Pk2*(25*r**2 + r*(9*s - 1) - 16*s**2 + 30*s - 11) + Pkd2*k2*(r*(36*s - 25) + 36*s**2 - 50*s + 16)) - 15*k2**4*(Pk2*(18*r + 10*s - 5) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-14850*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(410*s - 141) + 2460*s**2 - 2713*s + 640) + 22*k2**2*(Pk2*(360*r**2 + r*(27 - 4200*s) - 4560*s**2 + 3550*s - 181) + 45*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 66*f*(k1**4*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(4*r + 4*s - 3) + k1**2*k2**2*(Pk2*(-4*C*(156*r**2 - 372*r*s + 19*r - 264*s**2 + 450*s - 98) + 1164*r**2 + 504*r*s - 829*r - 132*s**2 + 295*s - 5) - 6*Pkd2*k2*(C*(200*r*s - 59*r + 112*s**2 - 190*s + 45) - 124*r*s + 39*r - 80*s**2 + 120*s - 29)) + k2**4*(Pk2*(-2*C*(888*r**2 + 3*r*(936*s - 353) + 600*s**2 - 1756*s + 358) + 1032*r**2 + 3*r*(984*s - 377) + 600*s**2 - 1764*s + 342) + Pkd2*k2*(15 - 30*C)*(r*(24*s - 7) + 16*s**2 - 22*s + 5))) - 396*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) - 2*k1**2*k2**2*(2*Pk2*(50*r**2 + 9*r*(2*s - 1) - 32*s**2 + 79*s - 28) + 3*Pkd2*k2*(8*r*(3*s - 2) + 24*s**2 - 38*s + 13)) - 15*k2**4*(Pk2*(72*r**2 + 2*r*(56*s - 39) + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k3**5) + D1**3*Pkd3*ct**2*st**2*(2*D1*bd1*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s*(s + 1)) + k2**2*(Pk2*(r*(-288*C*s + 72*C + 144*s - 50) + 3*s*(-40*C*s + 72*C + 20*s - 43)) + Pkd2*k2*(12*C - 6)*(3*r*(4*s - 1) + s*(5*s - 9)))) + k2**2*(-2*Pk2 + Pkd2*k2)*(42*b2 - 84*g2)*(r*(2*s - 1) + s*(2*s - 2))) + b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(36*s - 39) + 14*s - 14) + 42*k2**2*(-4*K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 3) - 4*Pk2*r))*(r + s - 1) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(r*(24*s - 37) + 24*s**2 - 44*s + 25) + 28*r*(2*s - 5) + 56*s**2 - 154*s + 98) + 84*k2**2*(K*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + Pk2*(-2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + f*(2*r**2 + 2*r*(s - 2) - 3*s + 2) - 8*r**2 - 8*r*s + 9*r + 2*s - 2)))) + b1*(D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(36*r*(s - 2) + 36*s**2 - 57*s + 36) + 28*r*(s - 3) + 28*s**2 - 70*s + 42) + 42*k2**2*(2*K*Pkd2*k2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pk2*(-4*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(2*r**2 + r*(2*s - 3) - 3*s + 1) - 8*r**2 - 8*r*s + 8*r + 2*s - 2))) + 2*D1*(f*(2*fd*k1**2*(4*Pk2 - Pkd2*k2)*(s - 4)*(r + s - 1) + fd*k2**2*(Pk2*(-24*C*(2*s - 1)*(12*r + 5*s - 12) + 288*r*s - 179*r + 120*s**2 - 383*s + 179) + Pkd2*k2*(12*C - 6)*(2*s - 1)*(12*r + 5*s - 12)) + k2**2*(-2*Pk2 + Pkd2*k2)*(42*bd2 - 84*gd2)*(2*s - 1)*(r + s - 1)) + 84*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 19*s + 17) + k2**2*(Pk2*(-24*C*(6*r*(8*s - 3) + 20*s**2 - 53*s + 15) + 9*r*(64*s - 31) + 240*s**2 - 706*s + 229) + Pkd2*k2*(12*C - 6)*(6*r*(8*s - 3) + 20*s**2 - 53*s + 15))) + k2**2*(-2*Pk2 + Pkd2*k2)*(42*b2 - 84*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))/(105*d**2*k2**2*k3) + D1**3*Pkd3*ct**2*(2*D1*bd1*f*(f*(3*k1**2*(2*Pk2*(r*(4*s + 6) + s*(4*s - 3)) + 7*Pkd2*k2*(r + s)*(s - 1)) + k2**2*(Pk2*(r**2*(92 - 72*C) + r*(404*C*s + 96*C - 146*s - 83) + s*(2*C - 1)*(28*s - 131)) + Pkd2*k2*(21 - 42*C)*(r*(2*s - 1) + s*(2*s - 2)))) + k2**2*(-35*b2 + 70*g2)*(-2*Pk2*s*(r + s - 1) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 7*b1**3*(-D1*fd*(r + s - 1)*(-6*Pk2*k1**2*s + 10*Pk2*k2**2*(r - 1) + 3*Pkd2*k1**2*k2*s) + Dd*f*(-10*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(2*Pk2 - Pkd2*k2)*(4*r*(3*s - 1) + 12*s**2 - 17*s + 4))) - 7*b1**2*(D1*bd1*f*(-10*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(2*Pk2 - Pkd2*k2)*(r*(9*s - 4) + 9*s**2 - 14*s + 4)) - 2*D1*fd*(k1**2*(Pk2*(3*f - 4*s - 4) + Pkd2*k2*(f*(9*s - 6) + 9*s - 5))*(r + s - 1) + 2*k2**2*(Pk2*(r + s - 1)*(5*K*(s - 1) + f*(6*r - 3) + 13*r - 8) + Pkd2*k2*(-5*K*(s - 1)*(r + s - 1) + s*(2*C - 1)*(3*r - 2*s - 3)))) - Dd*f*(k1**2*(6*Pk2*f*(5*r + 2*s - 3) - 8*Pk2*(r*(4*s - 6) + 4*s**2 - 7*s + 4) + Pkd2*k2*(3*f*(3*s - 2)*(4*r + 4*s - 3) + 72*r*s - 44*r + 72*s**2 - 102*s + 34)) + 2*k2**2*(Pk2*(10*K*(4*s - 1)*(r + s - 1) + 12*f*(2*r - 1)*(r + s - 1) + 104*r**2 + 104*r*s - 149*r - 58*s + 50) + Pkd2*k2*(C*(6*r*(8*s - 1) - 32*s**2 - 28*s + 6) - 5*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 24*r*s + 3*r + 16*s**2 + 14*s - 3)))) + b1*(7*D1*bd1*f*(k1**2*(6*Pk2*f*(4*r + s - 2) - 8*Pk2*(r*(2*s - 5) + 2*s**2 - 4*s + 3) + Pkd2*k2*(3*f*(3*s - 2)*(2*r + 2*s - 1) + 36*r*s - 24*r + 36*s**2 - 46*s + 14)) + 2*k2**2*(Pk2*(20*K*s**2 - 20*K*s + 6*f*(2*r - 1)*(r + s - 1) + 52*r**2 + 4*r*(5*K*s + 13*s - 15) - 21*s + 13) + Pkd2*k2*(2*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) - 5*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 12*r*s + 3*r + 8*s**2 + 2*s - 3))) + 2*D1*(f*fd*(6*k1**2*(Pk2*(8*s + 3) + 7*Pkd2*k2*(s - 1))*(r + s - 1) - k2**2*(2*Pk2*(C*(72*r**2 - 404*r*s + 11*r - 56*s**2 + 349*s - 83) - 92*r**2 + 146*r*s + 68*r + 28*s**2 - 157*s + 24) + Pkd2*k2*(42*C - 21)*(4*s - 3)*(r + s - 1))) - 35*f*k2**2*(bd2 - 2*gd2)*(-2*Pk2*s + Pkd2*k2*(2*s - 1))*(r + s - 1) - 70*fd*k2**2*(-Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(3*k1**2*(2*Pk2*(16*r*s + 15*r + 16*s**2 - 6*s - 9) + 7*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k2**2*(Pk2*(C*(-288*r**2 + 1616*r*s + 242*r + 224*s**2 - 1340*s + 70) + 368*r**2 - 584*r*s - 394*r - 112*s**2 + 600*s + 35) + Pkd2*k2*(21 - 42*C)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + k2**2*(-35*b2 + 70*g2)*(-2*Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))))/(105*d**2*k2**2*k3) + D1**3*Pkd3*ct**2*st**2*(D1*bd1*f*(f**2*(24*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(8*r*(3*s - 5) + 24*s**2 - 47*s + 20) + 6*k1**2*k2**2*(Pk2*(78*r**2 - 9*r*(22*s + 5) - 276*s**2 + 215*s - 21) + 3*Pkd2*k2*(r*(29*s - 8) + 29*s**2 - 31*s + 6))) + f*(2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + k1**2*k2**2*(2*Pk2*(44*C*r**2 + 328*C*r*s - 104*C*r - 108*C*s**2 - 84*C*s - 12*K*(8*r*s - 9*r + 8*s**2 - 22*s + 9) + 3*b1*(6*r**2 + 4*r*(23*s + 5) + 86*s**2 - 61*s - 10) + 21*r**2 - 428*r*s + 140*r - 253*s**2 + 370*s - 145) + Pkd2*k2*(48*C*s**2 + 188*C*s + 12*K*(r*(8*s - 9) + 8*s**2 - 22*s + 9) - 3*b1*(r*(80*s + 29) + 80*s**2 - 52*s - 13) + 2*r*(-172*C*s + 22*C + 210*s - 71) + 224*s**2 - 438*s + 142)) - 2*k2**4*(Pk2*(30*C*r**2 + 648*C*r*s + 26*C*r + 30*C*s**2 - 240*C*s + 14*K*(3*r**2 - r*(15*s + 1) - 2*(1 - 3*s)**2) + 14*b1*(5*r - 4) - 183*r**2 - 492*r*s + 232*r - 15*s**2 + 204*s - 63) + 6*Pkd2*k2*(C*(6*r - 2*s - 6) + 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r + s + 3))) + 14*k2**2*(b1*(k1**2*(Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 2*K*(2*r**2 + 30*r*s + 9*r + 28*s**2 - 23*s - 5) + 6*r**2 + 64*r*s + 9*r + 58*s**2 - 57*s - 7) + Pkd2*k2*(C*r*(2 - 8*s) - 2*C*(1 - 2*s)**2 + K*(2*r*(8*s + 1) + 16*s**2 - 15*s - 1) - 16*r*s + r - 16*s**2 + 19*s)) + 6*k2**2*(K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1))) + 6*b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*(6*Pk2*k2**2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + k1**2*(2*Pk2*(r**2 + 5*r*(3*s + 1) + s*(14*s - 14)) - Pkd2*k2*(8*r*s + r + s*(8*s - 8)))))) + b1**2*k2**2*(D1*fd*(k1**2*(6*Pk2*f*(6*r**2 + r*(92*s + 35) + 86*s**2 + 8*s - 41) + 14*Pk2*(8*C*s**2 - 8*C*s - 2*K*(r**2 + 15*r*(s - 1) + 14*(s - 1)**2) + 3*r**2 + r*(s*(8*C + 32) - 34) + 29*s**2 - 54*s + 31) - 3*Pkd2*f*k2*(r*(80*s + 47) + 80*s**2 + 20*s - 47) - 14*Pkd2*k2*(4*C*s**2 - 4*C*s - 8*K*(s - 1)*(r + s - 1) + r*(s*(4*C + 8) - 9) + 8*s**2 - 14*s + 9)) + 28*k2**2*(-3*K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 6*K*Pkd2*k2*(r + 2*s - 1) + Pk2*f*(r - 2) - 6*Pk2*r)) + 2*Dd*f*(k1**2*(Pk2*(28*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*K*(2*r**2 + 30*r*s - r + 28*s**2 - 30*s + 2) + 3*f*(12*r**2 + r*(184*s + 55) + 172*s**2 - 53*s - 51) + 84*r**2 + 896*r*s - 175*r + 812*s**2 - 973*s + 147) - Pkd2*k2*(14*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 7*K*(32*r*s - 5*r + 32*s**2 - 38*s + 6) + 6*f*(r*(40*s + 19) + 40*s**2 - 8*s - 15) + 224*r*s - 84*r + 224*s**2 - 308*s + 77)) + 14*k2**2*(12*K*Pkd2*k2*(r + 2*s - 1) - Pk2*(3*K*(20*r**2 + r*(24*s - 25) + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 12*r - 6)))) + b1*(D1*(f**2*fd*(24*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(72*s - 78) + 72*s**2 - 165*s + 74) + 6*k1**2*k2**2*(Pk2*(234*r**2 + r*(15 - 594*s) - 828*s**2 + 837*s - 137) + 3*Pkd2*k2*(r*(87*s - 36) + 87*s**2 - 104*s + 28))) + 2*f*(42*bd2*k2**4*(-Pk2*(r + s - 1)**2 + Pkd2*k2*s*(2*r + 2*s - 1)) + fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + fd*k1**2*k2**2*(Pk2*(4*C*(22*r**2 + r*(164*s - 69) - 54*s**2 - 91*s + 47) - 12*K*(16*r*s - 15*r + 16*s**2 - 30*s + 11) + 42*r**2 - 856*r*s + 625*r - 506*s**2 + 1088*s - 376) + Pkd2*k2*(4*C*(r*(29 - 86*s) + 12*s**2 + 66*s - 29) + 6*K*(16*r*s - 15*r + 16*s**2 - 30*s + 11) + 420*r*s - 234*r + 224*s**2 - 461*s + 150)) + fd*k2**4*(Pk2*(-2*C*(30*r**2 + r*(648*s - 137) + 30*s**2 - 431*s + 107) - 14*K*(6*r**2 + r*(16 - 30*s) - 9*(1 - 2*s)**2) + 366*r**2 + 984*r*s - 354*r + 30*s**2 - 431*s + 114) + 6*Pkd2*k2*(C*(24*r + 34*s - 24) - 14*K*(2*s - 1)*(2*r + 2*s - 1) - 12*r - 17*s + 12)) + 14*gd2*k2**2*(k1**2*(2*Pk2*(r + 14*s + 5) - Pkd2*k2*(8*s + 1))*(r + s - 1) - 6*k2**2*(-Pk2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) + Pkd2*k2*(r + 2*s - 1)))) + 28*fd*k2**2*(-3*Pk2*b2*k2**2*(r + s - 1)**2 + 6*Pkd2*b2*k2**3*s*(r + s) + 2*g2*k1**2*(Pk2*(r + 14*s - 14) - 4*Pkd2*k2*(s - 1))*(r + s - 1) + 6*g2*k2**2*(Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 2*Pkd2*k2*(r + 2*s - 1)))) + 2*Dd*f*(f**2*(24*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(48*s - 59) + 48*s**2 - 106*s + 47) + 3*k1**2*k2**2*(2*Pk2*(156*r**2 - 3*r*(132*s + 5) - 552*s**2 + 526*s - 79) + 3*Pkd2*k2*(4*r*(29*s - 11) + 116*s**2 - 135*s + 34))) + f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + k1**2*k2**2*(Pk2*(4*C*(44*r**2 + 4*r*(82*s - 33) - 108*s**2 - 209*s + 73) - 12*K*(32*r*s - 33*r + 32*s**2 - 74*s + 29) + 84*r**2 - 1712*r*s + 958*r - 1012*s**2 + 2049*s - 735) + Pkd2*k2*(C*(-688*r*s + 160*r + 96*s**2 + 552*s - 138) + 6*K*(32*r*s - 33*r + 32*s**2 - 74*s + 29) + 840*r*s - 381*r + 448*s**2 - 958*s + 297)) + k2**4*(Pk2*(-2*C*(60*r**2 + 18*r*(72*s - 7) + 60*s**2 - 847*s + 94) - 14*K*(12*r**2 - 60*r*s + 14*r - 72*s**2 + 60*s - 13) + 732*r**2 + 1968*r*s - 826*r + 60*s**2 - 1015*s + 234) + 12*Pkd2*k2*(12*C*(r + 2*s - 1) - 7*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 6*r - 12*s + 6))) + 14*k2**2*(3*b2*k2**2*(-Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + g2*(k1**2*(4*Pk2*(2*r**2 + 30*r*s - r + 28*s**2 - 30*s + 2) + Pkd2*k2*(-32*r*s + 5*r - 32*s**2 + 38*s - 6)) - 6*k2**2*(-Pk2*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + 4*Pkd2*k2*(r + 2*s - 1)))))) + 2*f*(D1*(f*(fd*(k1**4*(4*Pk2 - Pkd2*k2)*(9*r*(s - 1) + 9*s**2 - 21*s + 8) + 3*k1**2*k2**2*(-Pk2*(4*C*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) - 54*r**2 + 90*r*s + 13*r + 144*s**2 - 85*s + 4) + Pkd2*k2*(2*C*(9*r*(4*s - 3) + 36*s**2 - 54*s + 19) + 36*r*s - 9*r + 36*s**2 - 30*s + 5)) - 6*k2**4*(Pk2*(2*C*(45*r**2 - 3*r*(49*s + 5) - 66*s**2 + 110*s - 13) - 87*r**2 + 105*r*s + 47*r + 66*s**2 - 102*s + 9) + Pkd2*k2*(6*C - 3)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + k2**2*(-2*bd2 + 4*gd2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(8*s - 9) + 8*s**2 - 22*s + 9) + 7*k2**2*(Pk2*(3*r**2 - r*(15*s + 1) - 2*(1 - 3*s)**2) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 2*fd*k2**2*(b2 - 2*g2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(16*s - 15) + 16*s**2 - 30*s + 11) + 7*k2**2*(Pk2*(6*r**2 + r*(16 - 30*s) - 9*(1 - 2*s)**2) + 6*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(f*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 7) + 12*s**2 - 33*s + 13) + 3*k1**2*k2**2*(Pk2*(-4*C*(r*(48*s - 37) + 48*s**2 - 78*s + 29) + 72*r**2 - 2*r*(60*s + 23) - 192*s**2 + 84*s + 11) + 2*Pkd2*k2*(C*(r*(48*s - 37) + 48*s**2 - 78*s + 29) + 4*r*(6*s - 1) + 24*s**2 - 18*s + 2)) - 6*k2**4*(Pk2*(2*C*(60*r**2 - 4*r*(49*s + 10) - 88*s**2 + 152*s - 3) - 116*r**2 + 140*r*s + 90*r + 88*s**2 - 136*s - 5) + Pkd2*k2*(12*C - 6)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + k2**2*(-2*b2 + 4*g2)*(3*k1**2*(2*Pk2 - Pkd2*k2)*(r*(32*s - 33) + 32*s**2 - 74*s + 29) + 7*k2**2*(Pk2*(12*r**2 + r*(14 - 60*s) - 72*s**2 + 60*s - 13) + 6*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(105*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**2*(3*D1*bd1*f*(-7*b1**2*k2**2*(10*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(3*Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + Pkd2*k2*(33*r*s - 8*r + 33*s**2 - 38*s + 8))) + 14*b1*(-2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(Pk2*(4*C*(20*r**2 + r*(28*s - 27) + 8*s**2 - 18*s + 7) + 2*K*(12*r**2 + 62*r*s - 12*r + 50*s**2 - 53*s + 3) - 24*r**2 - 108*r*s + 70*r - 84*s**2 + 120*s - 39) + 2*Pkd2*k2*(C*(r*(11 - 44*s) + 16*s**2 + 14*s - 11) + K*(3*r*s - 7*r + 3*s**2 - 11*s + 5) + 28*r*s - 2*r - 2*s**2 - 8*s + 2)) + k2**4*(Pk2*(2*C*(68*r**2 - r*(92*s + 45) + 20*s**2 + 36*s - 23) + 5*K*(6*r**2 + r*(8*s - 11) + 2*s**2 - 7*s + 5) - 100*r**2 + 30*r*(2*s + 3) - 20*s**2 - 20*s + 10) + Pkd2*k2*(C*(r*(6 - 24*s) + 16*s**2 + 4*s - 6) - 5*K*(r + 2*s - 1) + 12*r*s - 3*r - 8*s**2 - 2*s + 3))) + 3*f**2*k1**2*(18*Pk2*k2**2*(6*r**2 + 9*r*(2*s - 1) + 12*s**2 - 13*s + 3) + k1**2*(Pk2*(40*r + 22*s - 20) + 5*Pkd2*k2*(3*s - 2)*(2*r + 2*s - 1))) - f*(-2*Pk2*k2**4*(2*C*(19*r**2 + 40*r*(s - 2) + 21*s**2 + 67*s + 15) - 84*K*r**2 - 252*K*r*s + 140*K*r - 168*K*s**2 + 168*K*s - 56*K + 28*b1*(2*r - 1) - 19*r**2 - 40*r*s + 94*r - 21*s**2 - 67*s - 15) + k1**4*(2*Pk2*(3*b1*(9*s - 4)*(4*r + 4*s - 3) + 24*r*s - 60*r + 24*s**2 - 106*s + 48) - 3*Pkd2*k2*(b1*(9*s - 4)*(4*r + 4*s - 3) + 30*r*s - 22*r + 30*s**2 - 48*s + 18)) + k1**2*k2**2*(Pk2*(-856*C*s**2 - 704*C*s + 28*K*(6*r**2 + r*(13*s - 8) + 7*s**2 - 3*s + 2) - 7*b1*(174*r**2 + r*(124*s - 191) - 50*s**2 - 25*s + 37) - 2*r**2*(108*C + 371) + 2*r*(752*C*s + 48*C - 968*s + 585) + 94*s**2 + 1062*s - 518) + 3*Pkd2*k2*(4*C*(3*r*s + 2*r + 3*s**2 - 9*s + 6) + 14*K*(5*s - 3)*(r + s - 1) - 112*b1*r*s - 14*b1*r - 112*b1*s**2 + 91*b1*s - 34*r*s - 4*r - 34*s**2 + 46*s - 12))) - 14*k2**2*(10*Pk2*g2*k2**2*(3*r**2 + r*(4*s - 3) + s*(s - 1)) + b2*k1**2*(-2*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(7*s - 6) + s*(7*s - 7))) + 5*b2*k2**2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*k1**2*(2*Pk2*(6*r**2 + r*(31*s - 3) + s*(25*s - 25)) + Pkd2*k2*(r*(3*s - 4) + s*(3*s - 3))))) - 21*b1**3*k2**2*(D1*fd*(10*Pk2*k2**2*(r - 1) + k1**2*(3*Pk2*(r + s - 1) + 11*Pkd2*k2*s))*(r + s - 1) + Dd*f*(10*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(3*Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(44*r*s - 8*r + 44*s**2 - 49*s + 8)))) - 3*b1**2*(D1*fd*(k1**4*s*(2*Pk2 - Pkd2*k2)*(27*f*(4*r + 4*s - 3) + 56*r + 56*s) + 7*k1**2*k2**2*(-2*Pk2*(8*C*(5*r**2 + r*(7*s - 10) + 2*s**2 - 7*s + 5) + 12*K*r**2 + 62*K*r*s - 62*K*r + 50*K*s**2 - 100*K*s + 50*K + f*(87*r**2 + 62*r*s - 95*r - 25*s**2 - 24*s + 30) - 12*r**2 - 54*r*s + 142*r - 42*s**2 + 142*s - 83) - Pkd2*k2*(32*C*s**2 + 88*C*s + 2*K*(r*(3*s - 10) + 3*s**2 - 20*s + 10) + 3*f*(2*r*(8*s + 5) + 16*s**2 + 5*s - 10) + 2*r*(-44*C*s + 28*s + 5) - 4*s**2 - 16*s - 10)) + 14*k2**4*(-Pk2*(4*C*(17*r**2 - r*(23*s + 34) + 5*s**2 + 23*s + 17) + 5*K*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 3) + f*(8*r - 4) - 50*r**2 + 10*r*(3*s + 11) - 10*s**2 - 30*s - 50) + 2*Pkd2*k2*(5*K*(r + 2*s - 1) + s*(2*C - 1)*(3*r - 2*s - 3)))) + Dd*f*(f*(112*Pk2*k2**4*(1 - 2*r) + 6*k1**4*(2*Pk2 - Pkd2*k2)*(9*s - 2)*(4*r + 4*s - 3) - 7*k1**2*k2**2*(Pk2*(348*r**2 + r*(248*s - 381) - 100*s**2 - 73*s + 97) + 6*Pkd2*k2*(2*r*(8*s + 3) + 16*s**2 - 4*s - 5))) + 28*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) - 14*k1**2*k2**2*(Pk2*(4*C*(40*r**2 + r*(56*s - 67) + 16*s**2 - 46*s + 27) + 2*K*(24*r**2 + 124*r*s - 52*r + 100*s**2 - 131*s + 31) - 48*r**2 - 216*r*s + 275*r - 168*s**2 + 340*s - 173) + Pkd2*k2*(2*C*(r*(11 - 88*s) + 32*s**2 + 58*s - 11) + K*(12*r*s - 34*r + 12*s**2 - 61*s + 30) + 112*r*s + 6*r - 8*s**2 - 42*s - 6)) - 14*k2**4*(Pk2*(C*(272*r**2 - 2*r*(184*s + 181) + 80*s**2 + 256*s + 90) + 5*K*(12*r**2 + 16*r*s - 27*r + 4*s**2 - 19*s + 13) - 200*r**2 + 120*r*s + 305*r - 40*s**2 - 80*s - 95) + Pkd2*k2*(C*(r*(6 - 48*s) + 32*s**2 + 28*s - 6) - 20*K*(r + 2*s - 1) + 24*r*s - 3*r - 16*s**2 - 14*s + 3)))) + 3*b1*(D1*(3*f**2*fd*k1**2*(18*Pk2*k2**2*(18*r**2 + r*(54*s - 39) + 36*s**2 - 51*s + 19) + k1**2*(Pk2*(60*r + 66*s - 52) + 5*Pkd2*k2*(3*s - 2)*(6*r + 6*s - 5))) - 2*f*(fd*(k1**4*(2*Pk2*(24*r*s - 9*r + 24*s**2 - 28*s + 8) - 3*Pkd2*k2*(15*s - 7)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(-8*C*(27*r**2 + r*(11 - 188*s) + 107*s**2 + 92*s - 38) + 196*K*s**2 - 98*K*s + r**2*(168*K - 742) + 4*r*(91*K*s - 49*K - 484*s + 228) + 94*s**2 + 989*s - 316) + 3*Pkd2*k2*(2*C*(r*(6*s + 28) + 6*s**2 + 39*s - 28) + 7*K*(10*r*s - 7*r + 10*s**2 - 13*s + 4) - 34*r*s - 42*r - 34*s**2 - 53*s + 42)) + k2**4*(-2*Pk2*(C*(38*r**2 + r*(80*s - 95) + 42*s**2 - 110*s + 31) - 14*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 19*r**2 - 40*r*s + 93*r - 21*s**2 + 55*s - 33) + Pkd2*k2*(126*C - 63)*(r + 2*s - 1))) + 7*k2**2*(-bd2*k1**2*(2*Pk2*(r + s - 1)**2 + Pkd2*k2*s*(-7*r - 7*s + 1)) + 5*bd2*k2**2*(Pk2*(r**2 + 2*r*s + s**2 - 1) + Pkd2*k2*s*(2*r + 2*s - 1)) + 2*gd2*k1**2*(2*Pk2*(6*r**2 + r*(31*s - 9) + 25*s**2 - 28*s + 3) + Pkd2*k2*(r*(3*s - 10) + 3*s**2 - 19*s + 10)) - 10*gd2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 5) + Pkd2*k2*(r + 2*s - 1)))) - 14*fd*k2**2*(b2*k1**2*(-2*Pk2*(r + s - 1)**2 + 7*Pkd2*k2*s*(r + s)) + 5*b2*k2**2*(Pk2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) + 2*Pkd2*k2*s*(r + s)) + 2*g2*k1**2*(2*Pk2*(6*r**2 + 31*r*(s - 1) + 25*(s - 1)**2) + Pkd2*k2*(r*(3*s - 10) + 3*s**2 - 20*s + 10)) - 10*g2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 3) + 2*Pkd2*k2*(r + 2*s - 1)))) + 2*Dd*f*(3*f**2*k1**2*(18*Pk2*k2**2*(12*r**2 + 12*r*(3*s - 2) + 24*s**2 - 32*s + 11) + k1**2*(Pk2*(50*r + 44*s - 36) + 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) - f*(k1**4*(2*Pk2*(r*(48*s - 57) + 48*s**2 - 122*s + 50) - 3*Pkd2*k2*(4*r*(15*s - 8) + 60*s**2 - 73*s + 23)) + k1**2*k2**2*(Pk2*(-4*C*(108*r**2 - r*(752*s + 29) + 428*s**2 + 475*s - 64) + 14*K*(24*r**2 + 52*r*s - 30*r + 28*s**2 - 13*s + 4) - 1484*r**2 - 3872*r*s + 2082*r + 188*s**2 + 2365*s - 789) + 3*Pkd2*k2*(C*(8*r*(3*s + 11) + 24*s**2 + 94*s - 72) + 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) - 68*r*s - 65*r - 68*s**2 - 47*s + 57)) + k2**4*(Pk2*(-2*C*(76*r**2 + r*(160*s - 251) + 84*s**2 - 87*s + 103) + 28*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 76*r**2 + 160*r*s - 391*r + 84*s**2 - 87*s + 173) + Pkd2*k2*(168*C - 84)*(r + 2*s - 1))) - 7*k2**2*(-b2*k1**2*(2*Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(r*(6 - 28*s) + s*(9 - 28*s))) + 5*b2*k2**2*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 2*g2*k1**2*(2*Pk2*(24*r**2 + 4*r*(31*s - 13) + 100*s**2 - 131*s + 31) + Pkd2*k2*(2*r*(6*s - 17) + 12*s**2 - 61*s + 30)) - 10*g2*k2**2*(-Pk2*(12*r**2 + r*(16*s - 27) + 4*s**2 - 19*s + 13) + 4*Pkd2*k2*(r + 2*s - 1))))) + 2*f*(D1*(f*(fd*(Pk2*k2**4*(18 - 36*C)*(36*r**2 + 18*r*(5*s - 3) + 54*s**2 - 57*s + 17) + k1**4*(2*Pk2*(30*r*(3*s + 2) + 90*s**2 + 9*s - 43) + 45*Pkd2*k2*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(-8*C*(180*r**2 + 9*r*(38*s - 29) + 162*s**2 - 204*s + 79) + 1773*r**2 + 9*r*(422*s - 283) + 2025*s**2 - 2364*s + 793) + Pkd2*k2*(45 - 90*C)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + k2**2*(-21*bd2 + 42*gd2)*(4*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(6*r**2 + 13*r*s - 8*r + 7*s**2 - 3*s + 2) + 3*Pkd2*k2*(5*s - 3)*(r + s - 1)))) - 21*fd*k2**2*(b2 - 2*g2)*(2*Pk2*k1**2*(12*r**2 + 2*r*(13*s - 7) + 7*s*(2*s - 1)) + 4*Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 3*Pkd2*k1**2*k2*(r*(10*s - 7) + 10*s**2 - 13*s + 4))) + Dd*f*(f*(Pk2*k2**4*(18 - 36*C)*(48*r**2 + 2*r*(60*s - 37) + 72*s**2 - 78*s + 25) + k1**4*(2*Pk2*(20*r*(6*s + 5) + 120*s**2 + 42*s - 83) + 45*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(-16*C*(120*r**2 + 228*r*s - 180*r + 108*s**2 - 137*s + 59) + 2364*r**2 + 5064*r*s - 3465*r + 2700*s**2 - 3121*s + 1120) + Pkd2*k2*(45 - 90*C)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + k2**2*(-21*b2 + 42*g2)*(4*Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(24*r**2 + 52*r*s - 30*r + 28*s**2 - 13*s + 4) + 3*Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10))))))/(315*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**2*st**2*(D1*(462*b1*fd*k2**2*(-30*Pk2*b2*k2**4*(r + s)**2 + b1*(k1**4*(K - 1)*(Pk2*(5*r**2 + 2*r*(6*s - 5) + 7*s**2 - 10*s + 5) - Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(10*C*(r + s - 1)**2 - K*(11*r**2 + 38*r*s - 30*r + 27*s**2 - 30*s + 15) + 16*r**2 + 48*r*s - 20*r + 32*s**2 - 20*s + 10) + Pkd2*k2*s*(4*K - 7)*(r + s)) - 6*k2**4*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s))) + 2*g2*(k1**4*(-Pk2*(5*r**2 + 2*r*(6*s - 5) + 7*s**2 - 10*s + 5) + Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(11*r**2 + 38*r*s - 30*r + 27*s**2 - 30*s + 15) - 4*Pkd2*k2*s*(r + s)) + 6*k2**4*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + 3*f**3*(-11*bd1*k2**2*(24*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + k1**4*(2*Pk2*(30*r**2 - 36*r*s - 61*r - 66*s**2 - 5*s + 43) + Pkd2*k2*(96*r*s + 71*r + 96*s**2 + 15*s - 83)) + 6*k1**2*k2**2*(Pk2*(303*r**2 + 500*r*s - 449*r + 197*s**2 - 383*s + 142) + 3*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + fd*k1**2*(264*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 104*s**2 - 192*s + 69) + 22*k1**2*k2**2*(2*Pk2*(450*r**2 - r*(582*s + 197) - 1032*s**2 + 909*s - 104) + 5*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 11*f**2*k2**2*(90*Pk2*bd2*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 3*bd1*(2*k1**4*(Pk2*(2*C*(5*r**2 - r*(20*s + 11) - 25*s**2 + 15*s + 10) + K*(-26*r**2 + 4*r*s - 10*r + 30*s**2 - 38*s + 36) + 41*r**2 + 84*r*s + 100*r + 43*s**2 + 102*s - 149) + Pkd2*k2*(2*C*(15*r*s + 3*r + 15*s**2 - 10*s - 5) - 3*K*(11*r*s - r + 11*s**2 - 4*s + 1) + 4*r*s - 18*r + 4*s**2 - 14*s + 22)) + k1**2*k2**2*(2*Pk2*(2*C*(57*r**2 - 658*r*s - 65*r + 55*s**2 + 318*s + 12) - 371*K*r**2 - 224*K*r*s + 252*K*r + 147*K*s**2 - 182*K*s + 119*K - 15*b1*(20*r**2 + r*(40*s - 23) + 20*s**2 - 23*s + 3) + 768*r**2 + 1946*r*s - 1206*r + 408*s**2 - 1251*s + 430) + Pkd2*k2*(4*C*(2*r*(73*s - 33) + 48*s**2 - 95*s + 47) - 144*K*(r*(4*s - 1) + (1 - 2*s)**2) + b1*(r*(57 - 396*s) - 396*s**2 + 333*s + 3) + 10*r*s + 2*r + 206*s**2 - 212*s + 48)) + 2*k2**4*(Pk2*(2*C*(396*r*s - 190*r + 60*s**2 - 165*s + 210) - 798*K*r**2 - 1302*K*r*s + 1148*K*r - 504*K*s**2 + 966*K*s - 350*K + 7*b1*(6*r**2 + r*(6*s - 19) - 9*s + 11) + 168*r**2 - 228*r*s - 69*r - 60*s**2 + 60*s - 147) + 6*Pkd2*k2*(2*C*(6*r*(2*s - 1) + 5*s**2 - 8*s + 3) - 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 5*s**2 + 8*s - 3))) + fd*(k1**4*(2*Pk2*(-4*C*(63*r**2 + 9*r*(7*s + 8) + 51*s - 55) + 9*b1*(30*r**2 - r*(36*s + 47) - 66*s**2 - 7*s + 23) + 387*r**2 + 468*r*s + 297*r + 81*s**2 + 285*s - 298) + 3*Pkd2*k2*(-4*C*(3*r*(9*s - 4) + 27*s**2 - 21*s + 5) + b1*(3*r*(96*s + 67) + 288*s**2 + 81*s - 149) + 126*r*s - 66*r + 126*s**2 - 126*s + 36)) + 18*k1**2*k2**2*(Pk2*(-4*C*(90*r**2 - 405*r*s + 31*r - 87*s**2 + 340*s - 79) + b1*(909*r**2 + 6*r*(250*s - 193) + 591*s**2 - 984*s + 401) + 621*r**2 - 156*r*s - 406*r + 39*s**2 + 346*s - 36) + Pkd2*k2*(C*(-216*r*s + 90*r - 216*s**2 + 228*s - 58) + 3*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 180*r*s - 81*r + 180*s**2 - 198*s + 53)) + 36*k2**4*(Pk2*(-2*C*(219*r**2 + 189*r*s - 214*r + 96*s**2 - 83*s + 43) + 2*b1*(3*r - 1)*(5*r + 5*s - 3) + 261*r**2 + 231*r*s - 246*r + 96*s**2 - 91*s + 47) + Pkd2*k2*(3 - 6*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + 12*gd2*(k1**4*(2*Pk2*(13*r**2 - 2*r*s + 5*r - 15*s**2 + 19*s - 18) + 3*Pkd2*k2*(11*r*s - r + 11*s**2 - 4*s + 1)) + k1**2*k2**2*(7*Pk2*(53*r**2 + 4*r*(8*s - 9) - 21*s**2 + 26*s - 17) + 72*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*k2**4*(Pk2*(57*r**2 + r*(93*s - 82) + 36*s**2 - 69*s + 25) + 3*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 33*f*k2**2*(420*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 30*Pk2*b2*fd*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*k2**2*(14*Pk2*k2**2*(6*r**2 + r*(6*s - 13) - 9*s + 5) - 3*k1**2*(10*Pk2*(20*r**2 + 40*r*s - 7*r + 20*s**2 - 7*s - 3) + 3*Pkd2*k2*s*(44*r + 44*s - 15))) + 2*b1*(210*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*bd1*(k1**4*(K - 1)*(Pk2*(10*r**2 + r*(24*s - 11) + 14*s**2 - 23*s + 5) - 2*Pkd2*k2*(r*(s + 1) + s*(s - 2))) + k1**2*k2**2*(Pk2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - K*(22*r**2 + 76*r*s - 55*r + 54*s**2 - 51*s + 15) + 32*r**2 + 96*r*s - 60*r + 64*s**2 - 56*s + 10) + Pkd2*k2*(r*(K*(8*s - 7) - 14*s + 6) + s*(K*(8*s - 1) - 14*s + 8))) - 6*k2**4*(K*(Pk2*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(Pk2*(4*C*(5*r**2 - 10*r*(2*s + 1) - 25*s**2 - 2*s + 5) + K*(-52*r**2 + 8*r*s - 130*r + 60*s**2 - 214*s + 92) + 82*r**2 + 168*r*s + 311*r + 86*s**2 + 393*s - 209) + Pkd2*k2*(60*C*s**2 - 16*C*s - 3*K*(2*s - 1)*(11*r + 11*s - 2) + r*(60*C*s + 8*s - 41) + 8*s**2 - 52*s + 17)) + k1**2*k2**2*(Pk2*(C*(228*r**2 + r*(610 - 2632*s) + 220*s**2 + 2070*s - 722) - 7*K*(106*r**2 + 64*r*s + 31*r - 42*s**2 + 131*s - 55) + 1536*r**2 + 3892*r*s - 1825*r + 816*s**2 - 2032*s + 634) + Pkd2*k2*(192*C*s**2 - 348*C*s - 144*K*(2*s - 1)*(2*r + 2*s - 1) + r*(584*C*s + 10*s - 189) + 206*s**2 - 201*s + 105)) + 2*k2**4*(C*Pk2*(264*r*(3*s + 2) + 120*s**2 - 197*s - 354) - 14*K*Pk2*(57*r**2 + r*(93*s - 46) + 9*(1 - 2*s)**2) - 42*K*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1) + 3*Pk2*(56*r**2 - 2*r*(38*s + 65) - 20*s**2 + 27*s + 66) + Pkd2*k2*s*(12*C - 6)*(12*r + 5*s - 6))) + 14*gd2*(k1**4*(Pk2*(5*r**2 + 2*r*(6*s - 5) + 7*s**2 - 16*s + 5) - Pkd2*k2*s*(r + s - 3)) + k1**2*k2**2*(-Pk2*(11*r**2 + 38*r*s - 26*r + 27*s**2 - 24*s + 15) + Pkd2*k2*s*(4*r + 4*s + 3)) - 6*k2**4*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 28*bd1*g2*(k1**4*(Pk2*(5*r**2 + r*(12*s - 1) + s*(7*s - 7)) - Pkd2*k2*(r*(s + 2) + s*(s - 1))) + k1**2*k2**2*(Pk2*(-11*r**2 + r*(29 - 38*s) - s*(27*s - 27)) + Pkd2*k2*(r*(4*s - 7) + s*(4*s - 4))) - 6*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + 4*fd*g2*(k1**4*(2*Pk2*(26*r**2 - 4*r*s + 65*r - 30*s**2 + 107*s - 46) + 3*Pkd2*k2*(2*s - 1)*(11*r + 11*s - 2)) + k1**2*k2**2*(7*Pk2*(106*r**2 + 64*r*s + 31*r - 42*s**2 + 131*s - 55) + 144*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)) + 28*k2**4*(Pk2*(57*r**2 + r*(93*s - 46) + 9*(1 - 2*s)**2) + 3*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(462*b1*k2**2*(-30*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*k1**4*(K - 1)*(Pk2*(20*r**2 + r*(48*s - 31) + 28*s**2 - 49*s + 15) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + b1*k1**2*k2**2*(Pk2*(10*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - K*(44*r**2 + 152*r*s - 111*r + 108*s**2 - 105*s + 45) + 64*r**2 + 192*r*s - 106*r + 128*s**2 - 100*s + 30) + Pkd2*k2*(r*(K*(16*s - 7) - 28*s + 6) + s*(2*K*(8*s + 1) - 28*s + 9))) - 6*b1*k2**4*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(k1**4*(Pk2*(20*r**2 + r*(48*s - 31) + 28*s**2 - 49*s + 15) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + k1**2*k2**2*(-Pk2*(44*r**2 + 152*r*s - 111*r + 108*s**2 - 105*s + 45) + Pkd2*k2*(r*(16*s - 7) + 2*s*(8*s + 1))) - 6*k2**4*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 3*f**3*k1**2*(264*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(104*s - 81) + 104*s**2 - 192*s + 69) + 22*k1**2*k2**2*(2*Pk2*(450*r**2 - r*(582*s + 197) - 1032*s**2 + 909*s - 104) + 5*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 22*f**2*k2**2*(k1**4*(Pk2*(-8*C*(42*r**2 + 6*r*(7*s + 5) + 5*s - 32) + 6*b1*(60*r**2 - r*(72*s + 101) - 132*s**2 - 13*s + 56) + 516*r**2 + 624*r*s + 249*r + 108*s**2 + 163*s - 379) + 3*Pkd2*k2*(C*(-72*r*s + 22*r - 72*s**2 + 42*s - 8) + 4*b1*(r*(48*s + 34) + 48*s**2 + 12*s - 29) + 84*r*s - 36*r + 84*s**2 - 75*s + 21)) + 9*k1**2*k2**2*(Pk2*(4*C*(-120*r**2 + 540*r*s + 10*r + 116*s**2 - 471*s + 68) + b1*(1212*r**2 + r*(2000*s - 1607) + 788*s**2 - 1367*s + 543) + 828*r**2 - 208*r*s - 709*r + 52*s**2 + 441*s + 60) + Pkd2*k2*(-2*C*(144*r*s - 53*r + 144*s**2 - 150*s + 37) + 3*b1*(21*s - 10)*(4*r + 4*s - 3) + 240*r*s - 98*r + 240*s**2 - 264*s + 70)) + 36*k2**4*(Pk2*(-2*C*(146*r**2 + 126*r*s - 163*r + 64*s**2 - 63*s + 41) + 2*b1*(2*r - 1)*(5*r + 5*s - 3) + 174*r**2 + 154*r*s - 188*r + 64*s**2 - 71*s + 45) + Pkd2*k2*(3 - 6*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 33*f*k2**2*(30*Pk2*b2*k2**2*(3*k1**2*(3*r + 3*s - 5) - 14*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(-300*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 28*Pk2*k2**2*(6*r**2 + 2*r*(3*s - 8) - 9*s + 8) + 3*Pkd2*k1**2*k2*(r*(19 - 264*s) - 264*s**2 + 156*s + 1)) + 2*b1*(k1**4*(Pk2*(2*C*(20*r**2 - r*(80*s + 41) - 100*s**2 + 27*s + 25) - 2*K*(52*r**2 - 8*r*s + 75*r - 60*s**2 + 145*s - 82) + 164*r**2 + 336*r*s + 509*r + 172*s**2 + 595*s - 497) + Pkd2*k2*(2*C*(r*(60*s + 3) + 60*s**2 - 31*s - 5) - 3*K*(44*r*s - 13*r + 44*s**2 - 23*s + 4) + 16*r*s - 71*r + 16*s**2 - 74*s + 51)) + k1**2*k2**2*(Pk2*(C*(456*r**2 - 5264*r*s + 368*r + 440*s**2 + 4130*s - 700) - 7*K*(212*r**2 + 128*r*s - 41*r - 84*s**2 + 183*s - 89) + 3072*r**2 + 7784*r*s - 4250*r + 1632*s**2 - 4932*s + 1515) + Pkd2*k2*(2*C*(r*(584*s - 66) + 192*s**2 - 396*s + 47) - 144*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 20*r*s - 251*r + 412*s**2 - 379*s + 192)) + k2**4*(Pk2*(4*C*(8*r*(99*s + 32) + 120*s**2 - 302*s - 159) - 28*K*(114*r**2 + 2*r*(93*s - 64) + 72*s**2 - 105*s + 34) + 672*r**2 - 3*r*(304*s + 425) - 240*s**2 + 366*s + 507) + 6*Pkd2*k2*(2*C*(6*r*(8*s - 1) + 20*s**2 - 29*s + 3) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 48*r*s + 6*r - 20*s**2 + 29*s - 3))) + 4*g2*(k1**4*(2*Pk2*(52*r**2 - 8*r*s + 75*r - 60*s**2 + 145*s - 82) + 3*Pkd2*k2*(44*r*s - 13*r + 44*s**2 - 23*s + 4)) + k1**2*k2**2*(7*Pk2*(212*r**2 + 128*r*s - 41*r - 84*s**2 + 183*s - 89) + 144*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) + 28*k2**4*(Pk2*(114*r**2 + 2*r*(93*s - 64) + 72*s**2 - 105*s + 34) + 3*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(3465*d**2*k2**2*k3**5) - D1**3*Pkd3*ct**2*(D1*bd1*f*(f**2*k1**2*(162*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(3*r*(5*s - 4) + 15*s**2 - 23*s + 8) - 9*k1**2*k2**2*(Pk2*(80*r**2 - r*(94*s + 65) - 174*s**2 + 121*s + 25) + 10*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) - 3*f*k2**2*(k1**4*(Pk2*(4*C*(168*r**2 + 282*r*(2*s - 1) + 186*s**2 - 397*s + 106) + 4*K*(51*r**2 + 182*r*s - 72*r + 131*s**2 - 118*s + 21) - 15*b1*(68*r**2 + r*(136*s - 95) + 68*s**2 - 95*s + 27) - 1446*r**2 - 3572*r*s + 2364*r - 1706*s**2 + 2734*s - 886) - 6*Pkd2*k2*(-2*C*(23*r*s - 8*r + 23*s**2 - 27*s + 4) - 14*K*r*s + 14*K*r - 14*K*s**2 + 28*K*s - 14*K + b1*(r*(43*s - 16) + 43*s**2 - 43*s + 8) + 45*r*s - 19*r + 45*s**2 - 58*s + 13)) + k1**2*k2**2*(Pk2*(4*C*(807*r**2 + r*(800*s - 809) + 595*s**2 - 818*s + 118) + 14*K*(118*r**2 + 9*r*(32*s - 23) + 170*s**2 - 225*s + 89) - 7*b1*(408*r**2 + r*(696*s - 597) + 288*s**2 - 509*s + 205) - 3136*r**2 - 4372*r*s + 3492*r - 2440*s**2 + 3250*s - 754) - 6*Pkd2*k2*(-2*C*(59*r*s - 26*r + 59*s**2 - 65*s + 6) - 35*K*r*s + 21*K*r - 35*K*s**2 + 56*K*s - 21*K + 7*b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) + 80*r*s - 33*r + 80*s**2 - 86*s + 6)) + 2*k2**4*(Pk2*(C*(524*r**2 + 384*r*s - 370*r + 280*s**2 - 250*s - 30) + 84*K*r**2 + 252*K*r*s - 140*K*r + 168*K*s**2 - 168*K*s + 56*K - 14*b1*(2*r - 1)*(3*r + 3*s - 1) - 318*r**2 - 248*r*s + 206*r - 140*s**2 + 125*s + 15) + Pkd2*k2*(42*C - 21)*(r*(2*s - 1) + s*(2*s - 2)))) - 21*k2**2*(35*Pk2*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 10*Pk2*b2*k2**2*(7*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*b1*(2*k1**4*(2*Pk2*(5*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 17*K*s**2 + 15*K*s + r**2*(24 - 14*K) + r*(-31*K*s + 16*K + 51*s - 21) + 27*s**2 - 20*s - 5) - Pkd2*k2*(r*(K*(13*s - 2) - 9*s + 1) + s*(K*(13*s - 11) - 9*s + 8))) + k1**2*k2**2*(Pk2*(10*C*(16*r**2 - 68*r*s + r + 16*s**2 + 26*s - 17) - 2*K*(109*r**2 + 212*r*s - 80*r + 103*s**2 - 72*s - 30) + 104*r**2 + 668*r*s - 139*r + 64*s**2 - 234*s + 40) + Pkd2*k2*(r*(K*(16 - 74*s) + 30*s - 5) + s*(-74*K*s + 58*K + 30*s - 25))) + 5*k2**4*(K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + Pk2*(C*(8*r**2 - 2*r*(12*s + 1) + 8*s**2 + 8*s - 6) + K*(-12*r**2 - 24*r*s + 7*r - 12*s**2 + 7*s + 5) + 16*r*s - 2*r - 4*s**2 - 5*s + 3))) - 4*g2*(k1**4*(Pk2*(28*r**2 + r*(62*s - 36) + s*(34*s - 34)) + Pkd2*k2*(r*(13*s - 4) + s*(13*s - 13))) + k1**2*k2**2*(Pk2*(109*r**2 + r*(212*s - 111) + s*(103*s - 103)) + Pkd2*k2*(r*(37*s - 16) + s*(37*s - 37))) + 5*k2**4*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) - 735*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(D1*fd*(k1**4*(Pk2*(280*C*(r + s - 1)**2 + 15*f*(68*r**2 + r*(136*s - 79) + 68*s**2 - 79*s + 27) - 28*r**2*(14*K - 24) - 28*r*(s*(31*K - 51) - 20) - 28*s**2*(17*K - 27) + 560*s - 280) + Pkd2*k2*s*(129*f*(2*r + 2*s - 1) + (126 - 182*K)*(r + s))) + 7*k1**2*k2**2*(Pk2*(40*C*(4*r**2 - r*(17*s + 8) + 4*s**2 + 17*s + 4) - 2*K*(109*r**2 + 4*r*(53*s + 30) + 103*s**2 + 120*s - 60) + f*(408*r**2 + r*(696*s - 327) + 288*s**2 - 275*s + 39) + 104*r**2 + 4*r*(167*s + 85) + 64*s**2 - 160*s - 170) + Pkd2*k2*s*(f*(90*r + 90*s - 39) + (30 - 74*K)*(r + s))) - 14*k2**4*(10*K*Pkd2*k2*s*(r + s) + Pk2*(-20*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 5*K*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) - 2*f*(2*r - 1)*(3*r + 3*s - 1) - 40*r*s - 20*r + 10*s**2 + 30*s + 10))) + Dd*f*(k1**4*(280*C*Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 30*Pk2*f*(68*r**2 + r*(136*s - 87) + 68*s**2 - 87*s + 27) - 28*Pk2*(r**2*(56*K - 96) + 2*r*(K*(62*s - 23) - 102*s + 18) + s**2*(68*K - 108) + s*(33 - 43*K) + 30) + Pkd2*f*k2*(12*r*(43*s - 8) + 516*s**2 - 387*s + 48) - 14*Pkd2*k2*(r*(K*(52*s - 4) - 36*s + 2) + s*(K*(52*s - 31) - 36*s + 23))) + 7*k1**2*k2**2*(2*Pk2*(10*C*(32*r**2 - r*(136*s + 31) + 32*s**2 + 94*s - 1) - 436*K*r**2 - 848*K*r*s + 89*K*r - 412*K*s**2 + 65*K*s + 180*K + 2*f*(204*r**2 + 348*r*s - 231*r + 144*s**2 - 196*s + 61) + 208*r**2 + 1336*r*s + 64*r + 128*s**2 - 516*s - 130) + Pkd2*k2*(3*f*(r*(60*s - 6) + 60*s**2 - 41*s + 2) - 2*r*(4*K*(37*s - 4) - 60*s + 5) - 2*s*(K*(148*s - 79) - 60*s + 35))) - 14*k2**4*(5*K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) + Pk2*(-10*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + 5*K*(24*r**2 + r*(48*s + 2) + 24*s**2 + 2*s - 15) - 4*f*(2*r - 1)*(3*r + 3*s - 1) - 20*r*(8*s + 1) + 40*s**2 + 90*s + 5)))) + b1*(-3*D1*(70*Pk2*b2*fd*k2**4*(7*k1**2 + 5*k2**2)*(r + s)**2 + f**2*fd*k1**2*(-54*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - 25*k1**4*s*(2*Pk2 - Pkd2*k2)*(3*r + 3*s - 2) + 3*k1**2*k2**2*(Pk2*(240*r**2 - r*(282*s + 35) - 522*s**2 + 393*s - 93) + 10*Pkd2*k2*(r*(12*s + 13) + 12*s**2 + 6*s - 9))) + 2*f*k2**2*(35*Pk2*bd2*k2**2*(7*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(2*Pk2*(C*(336*r**2 + 3*r*(376*s - 147) + 372*s**2 - 683*s + 189) + K*(102*r**2 + 182*r*(2*s - 1) + 262*s**2 - 283*s + 76) - 723*r**2 - 1786*r*s + 875*r - 853*s**2 + 1087*s - 297) + 3*Pkd2*k2*(2*r + 2*s - 1)*(14*K*(s - 1) + s*(46*C - 45) + 7)) + k1**2*k2**2*(Pk2*(2*C*(1614*r**2 + 2*r*(800*s - 607) + 1190*s**2 - 78*s + 121) + 7*K*(236*r**2 + 6*r*(96*s - 59) + 340*s**2 - 396*s + 113) - 3136*r**2 - 4372*r*s + 2344*r - 2440*s**2 + 1149*s - 253) + 3*Pkd2*k2*(7*K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(C*(236*r + 236*s - 90) - 160*r - 160*s + 59))) + k2**4*(Pk2*(2*C*(524*r**2 + 3*r*(128*s - 65) + 280*s**2 + 214*s - 86) + 28*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 636*r**2 - 496*r*s + 251*r - 280*s**2 - 179*s + 86) + Pkd2*k2*s*(42*C - 21)*(4*r + 4*s - 1))) - 14*gd2*(k1**4*(Pk2*(28*r**2 + 62*r*s - 28*r + 34*s**2 - 26*s) + Pkd2*k2*s*(13*r + 13*s - 9)) + k1**2*k2**2*(Pk2*(109*r**2 + 212*r*s - 49*r + 103*s**2 - 41*s - 60) + Pkd2*k2*s*(37*r + 37*s - 21)) + 5*k2**4*(Pk2*(6*r**2 + 12*r*s - r + 6*s**2 - s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) - 28*fd*g2*k2**2*(k1**4*(r + s)*(28*Pk2*r + 34*Pk2*s + 13*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(109*r**2 + 4*r*(53*s + 30) + 103*s**2 + 120*s - 60) + 37*Pkd2*k2*s*(r + s)) + 5*k2**4*(Pk2*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(324*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(12*r*(5*s - 1) + 60*s**2 - 53*s + 8) - 18*k1**2*k2**2*(Pk2*(160*r**2 - 2*r*(94*s + 25) - 348*s**2 + 257*s - 34) + 5*Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) - 6*f*k2**2*(k1**4*(Pk2*(2*C*(672*r**2 + 3*r*(752*s - 325) + 744*s**2 - 1552*s + 379) + 2*K*(204*r**2 + 728*r*s - 326*r + 524*s**2 - 519*s + 118) - 2892*r**2 - 7144*r*s + 4054*r - 3412*s**2 + 4953*s - 1436) + 3*Pkd2*k2*(2*C*(r*(92*s - 8) + 92*s**2 - 69*s + 4) + 14*K*(s - 1)*(4*r + 4*s - 3) - 180*r*s + 40*r - 180*s**2 + 163*s - 27)) + k1**2*k2**2*(Pk2*(2*C*(3228*r**2 + 4*r*(800*s - 779) + 2380*s**2 - 1291*s + 525) + 7*K*(472*r**2 + 384*r*(3*s - 2) + 680*s**2 - 846*s + 291) - 6272*r**2 - 8*r*(1093*s - 763) - 4880*s**2 + 3960*s - 1076) + 3*Pkd2*k2*(2*C*(r*(236*s - 26) + 236*s**2 - 149*s + 6) + 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) - 320*r*s + 33*r - 320*s**2 + 198*s - 6)) + k2**4*(2*Pk2*(C*(1048*r**2 + r*(768*s - 661) + 560*s**2 + 78*s - 82) + 14*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 636*r**2 - 496*r*s + 397*r - 280*s**2 - 4*s + 41) + Pkd2*k2*(42*C - 21)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 42*k2**2*(-5*Pk2*b2*k2**2*(7*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**4*(2*Pk2*(56*r**2 + 2*r*(62*s - 23) + s*(68*s - 43)) + Pkd2*k2*(r*(52*s - 4) + s*(52*s - 31))) + k1**2*k2**2*(Pk2*(436*r**2 + r*(848*s - 89) + 412*s**2 - 65*s - 180) + Pkd2*k2*(4*r*(37*s - 4) + s*(148*s - 79))) + 5*k2**4*(Pk2*(24*r**2 + 48*r*s + 2*r + 24*s**2 + 2*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + f*(D1*(-5*f**2*fd*k1**4*(48*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(70*r + 76*s - 54) + 7*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) - 2*f*k2**2*(45*Pk2*bd2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k2**4*(36*C - 18)*(36*r**2 + 18*r*(5*s - 3) + 54*s**2 - 57*s + 17) + k1**4*(Pk2*(4*C*(360*r**2 + 9*r*(139*s - 68) + 891*s**2 - 1020*s + 266) - 1665*r**2 - 5004*r*s + 2823*r - 3339*s**2 + 4173*s - 1220) + Pkd2*k2*(180*C - 135)*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(2*C*(5526*r**2 + 9*r*(1442*s - 975) + 7452*s**2 - 9627*s + 3250) - 6579*r**2 - 18*r*(856*s - 571) - 8829*s**2 + 11175*s - 3727) + Pkd2*k2*(90*C - 45)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) - 6*gd2*(28*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + 2*k1**4*(Pk2*(51*r**2 + 2*r*(91*s - 36) + 131*s**2 - 118*s + 21) + 21*Pkd2*k2*(s - 1)*(r + s - 1)) + 7*k1**2*k2**2*(Pk2*(118*r**2 + 9*r*(32*s - 23) + 170*s**2 - 225*s + 89) + 3*Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 6*fd*k2**2*(-15*Pk2*b2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 2*g2*(28*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 2*k1**4*(Pk2*(102*r**2 + 182*r*(2*s - 1) + 262*s**2 - 283*s + 76) + 21*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + 7*k1**2*k2**2*(Pk2*(236*r**2 + 6*r*(96*s - 59) + 340*s**2 - 396*s + 113) + 3*Pkd2*k2*(r*(10*s - 7) + 10*s**2 - 13*s + 4))))) + Dd*f*(-5*f**2*k1**4*(48*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(70*r + 76*s - 54) + 7*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) - 2*f*k2**2*(Pk2*k2**4*(36*C - 18)*(48*r**2 + 2*r*(60*s - 37) + 72*s**2 - 78*s + 25) + k1**4*(Pk2*(4*C*(480*r**2 + 1668*r*s - 792*r + 1188*s**2 - 1331*s + 326) - 2220*r**2 - 6672*r*s + 3733*r - 4452*s**2 + 5503*s - 1575) + Pkd2*k2*(180*C - 135)*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(2*C*(7368*r**2 + 17304*r*s - 12060*r + 9936*s**2 - 13156*s + 4693) - 8772*r**2 - 20544*r*s + 14085*r - 11772*s**2 + 15181*s - 5341) + Pkd2*k2*(90*C - 45)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 6*k2**2*(-15*Pk2*b2*k1**2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + 2*g2*(28*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 2*k1**4*(Pk2*(204*r**2 + 728*r*s - 326*r + 524*s**2 - 519*s + 118) + 21*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + 7*k1**2*k2**2*(Pk2*(472*r**2 + 384*r*(3*s - 2) + 680*s**2 - 846*s + 291) + 3*Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 29*s + 10)))))))/(315*d**2*k2**2*k3**5) + D1**3*Pkd3*ct*f*k1*k2*st**6*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(f*(198*r*s - 75*r + 198*s**2 - 198*s + 47) + (72*s - 36)*(2*r + 2*s - 1)) + 2*D1*bd1*f*(f*(r*(33*s - 7) + 33*s**2 - 33*s + 7) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2) + 4*D1*f*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*b1*f*(f*(264*r*s - 89*r + 264*s**2 - 264*s + 61) + 288*r*s - 108*r + 288*s**2 - 288*s + 72) + 2*Dd*f**2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))/(63*d**2*k3**3) + D1**3*Pkd3*ct*f*k1*k2*st**6*(D1*(f**2*(11*bd1*k2**2*(Pk2*(165*r**2 + 2*r*(99*s - 116) + 33*s**2 - 128*s + 67) + 2*Pkd2*k2*(r*(33*s - 7) + 33*s**2 - 33*s + 7)) + fd*(44*Pk2*k2**2*(8*r**2 + r*(8*s - 27) - 18*s + 15) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(3616*s - 1025) + 3616*s**2 - 3594*s + 733))) - 11*f*k2**2*(18*bd1*(Pk2*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - fd*(3*Pk2*b1*(165*r**2 + r*(198*s - 155) + 33*s**2 - 73*s + 32) - 2*Pk2*(3*r + 3*s - 2)*(8*C*(3*r - 6*s + 1) - 39*r + 21*s + 6) + Pkd2*b1*k2*(3*r*(66*s - 25) + 198*s**2 - 198*s + 47) + Pkd2*k2*(12 - 16*C)*(3*s - 1)*(3*r + 3*s - 2)) - 72*gd2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) - 198*fd*k2**2*(b1*(Pk2*(8*K*(r - 2*s + 1) - 18*r - 2*s + 1) + Pkd2*k2*(4*K - 2)*(2*s - 1)) - 8*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))*(2*r + 2*s - 1)) + Dd*f*(f**2*(44*Pk2*k2**2*(8*r**2 + r*(8*s - 27) - 18*s + 15) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(3616*s - 1025) + 3616*s**2 - 3594*s + 733)) + 11*f*k2**2*(Pk2*b1*(660*r**2 + r*(792*s - 697) + 132*s**2 - 347*s + 163) + 2*Pk2*(4*C*(-24*r**2 + r*(24*s + 13) + 48*s**2 - 38*s + 3) + 156*r**2 + r*(72*s - 151) - 84*s**2 + 19*s + 28) + Pkd2*b1*k2*(r*(264*s - 89) + 264*s**2 - 264*s + 61) + Pkd2*k2*(6 - 8*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 198*k2**2*(b1*(Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*k2*(4*K - 2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 8*g2*(Pk2*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(693*d**2*k3**5) + D1**3*Pkd3*ct*k1*st**4*(4*Pk2 - Pkd2*k2)*(2*D1*bd1*f**2*(r*(4*s - 1) + s*(4*s - 3)) + b1**2*(D1*fd*(r + s - 1)*(f*(52*s - 33) + 28*s - 28) + Dd*f*(f*(104*r*s - 53*r + 104*s**2 - 144*s + 43) + 112*r*s - 70*r + 112*s**2 - 168*s + 56)) + b1*f*(D1*bd1*(f*(52*r*s - 20*r + 52*s**2 - 59*s + 10) + 56*r*s - 28*r + 56*s**2 - 70*s + 14) + 8*D1*fd*(2*s - 1)*(r + s - 1) + 2*Dd*f*(16*r*s - 6*r + 16*s**2 - 20*s + 5)))/(35*d**2*k2*k3) + D1**3*Pkd3*ct*st**2*(2*D1*bd1*f*(-7*b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1)) + f*(Pk2*k2**2*(2 - 4*C)*(15*r**2 - r*(27*s + 13) + 12*s) + k1**2*(Pk2*(23*r**2 - 4*r*(29*C*s - 9*C - 6*s + 7) + s*(-4*C*s + 80*C - 55*s + 25)) + Pkd2*k2*(r*(2*C*(29*s - 9) - 15*s + 2) + s*(2*C*(s - 20) + 13*s + 6)))) + 14*g2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 3) + s*(s - 1))) + 7*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*s*(r + s - 1) + Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 7*b1**2*k1**2*(D1*bd1*f*(2*Pk2 - Pkd2*k2)*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + D1*fd*(2*Pk2*(-2*K*(s - 1) + 12*f*(r - 5*s + 2) - r - 27*s + 31) + Pkd2*k2*(2*K*(s - 1) + 3*f*(12*s - 7) + 16*s - 20))*(r + s - 1) + Dd*f*(2*Pk2*(-2*K*(4*r*s - 10*r + 4*s**2 - 11*s + 7) + 6*f*(4*r**2 - 16*r*s + r - 20*s**2 + 23*s - 4) - 4*r**2 - 112*r*s + 50*r - 108*s**2 + 151*s - 41) + Pkd2*k2*(2*K*(2*r*(2*s - 5) + 4*s**2 - 11*s + 7) + 3*f*(r*(24*s - 11) + 24*s**2 - 32*s + 9) + 16*r*(4*s - 3) + 64*s**2 - 104*s + 38))) + b1*(-464*C*D1*Pk2*f*fd*k1**2*r*s + 232*C*D1*Pk2*f*fd*k1**2*r - 16*C*D1*Pk2*f*fd*k1**2*s**2 + 472*C*D1*Pk2*f*fd*k1**2*s - 232*C*D1*Pk2*f*fd*k1**2 - 240*C*D1*Pk2*f*fd*k2**2*r**2 + 432*C*D1*Pk2*f*fd*k2**2*r*s + 248*C*D1*Pk2*f*fd*k2**2*r - 328*C*D1*Pk2*f*fd*k2**2*s - 8*C*D1*Pk2*f*fd*k2**2 + 232*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 116*C*D1*Pkd2*f*fd*k1**2*k2*r + 8*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 236*C*D1*Pkd2*f*fd*k1**2*k2*s + 116*C*D1*Pkd2*f*fd*k1**2*k2 - 928*C*Dd*Pk2*f**2*k1**2*r*s + 376*C*Dd*Pk2*f**2*k1**2*r - 32*C*Dd*Pk2*f**2*k1**2*s**2 + 936*C*Dd*Pk2*f**2*k1**2*s - 304*C*Dd*Pk2*f**2*k1**2 - 480*C*Dd*Pk2*f**2*k2**2*r**2 + 864*C*Dd*Pk2*f**2*k2**2*r*s + 576*C*Dd*Pk2*f**2*k2**2*r - 656*C*Dd*Pk2*f**2*k2**2*s - 112*C*Dd*Pk2*f**2*k2**2 + 464*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 188*C*Dd*Pkd2*f**2*k1**2*k2*r + 16*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 468*C*Dd*Pkd2*f**2*k1**2*k2*s + 152*C*Dd*Pkd2*f**2*k1**2*k2 + 92*D1*Pk2*f*fd*k1**2*r**2 + 96*D1*Pk2*f*fd*k1**2*r*s - 98*D1*Pk2*f*fd*k1**2*r - 220*D1*Pk2*f*fd*k1**2*s**2 + 102*D1*Pk2*f*fd*k1**2*s + 6*D1*Pk2*f*fd*k1**2 + 120*D1*Pk2*f*fd*k2**2*r**2 - 216*D1*Pk2*f*fd*k2**2*r*s - 124*D1*Pk2*f*fd*k2**2*r + 164*D1*Pk2*f*fd*k2**2*s + 4*D1*Pk2*f*fd*k2**2 + 56*D1*Pk2*f*gd2*k1**2*r*s - 168*D1*Pk2*f*gd2*k1**2*r + 56*D1*Pk2*f*gd2*k1**2*s**2 - 224*D1*Pk2*f*gd2*k1**2*s + 168*D1*Pk2*f*gd2*k1**2 + 56*D1*Pk2*fd*g2*k1**2*r*s - 56*D1*Pk2*fd*g2*k1**2*r + 56*D1*Pk2*fd*g2*k1**2*s**2 - 112*D1*Pk2*fd*g2*k1**2*s + 56*D1*Pk2*fd*g2*k1**2 - 60*D1*Pkd2*f*fd*k1**2*k2*r*s + 16*D1*Pkd2*f*fd*k1**2*k2*r + 52*D1*Pkd2*f*fd*k1**2*k2*s**2 + 20*D1*Pkd2*f*fd*k1**2*k2*s - 16*D1*Pkd2*f*fd*k1**2*k2 - 28*D1*Pkd2*f*gd2*k1**2*k2*r*s + 84*D1*Pkd2*f*gd2*k1**2*k2*r - 28*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 112*D1*Pkd2*f*gd2*k1**2*k2*s - 84*D1*Pkd2*f*gd2*k1**2*k2 - 28*D1*Pkd2*fd*g2*k1**2*k2*r*s + 28*D1*Pkd2*fd*g2*k1**2*k2*r - 28*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 56*D1*Pkd2*fd*g2*k1**2*k2*s - 28*D1*Pkd2*fd*g2*k1**2*k2 + 7*D1*bd1*f*k1**2*(-2*Pk2*(2*K*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + 60*f*s**2 - 54*f*s + r**2*(2 - 12*f) + r*(48*f*s + 6*f + 56*s - 11) + 54*s**2 - 60*s + 4) + Pkd2*k2*(2*K*(2*r*(s - 3) + 2*s**2 - 5*s + 3) + 3*f*(4*r*(3*s - 1) + 12*s**2 - 13*s + 2) + 32*r*s - 18*r + 32*s**2 - 42*s + 8)) - 14*D1*bd2*f*k1**2*(2*Pk2 - Pkd2*k2)*(s - 3)*(r + s - 1) + 184*Dd*Pk2*f**2*k1**2*r**2 + 192*Dd*Pk2*f**2*k1**2*r*s - 256*Dd*Pk2*f**2*k1**2*r - 440*Dd*Pk2*f**2*k1**2*s**2 + 94*Dd*Pk2*f**2*k1**2*s + 62*Dd*Pk2*f**2*k1**2 + 240*Dd*Pk2*f**2*k2**2*r**2 - 432*Dd*Pk2*f**2*k2**2*r*s - 288*Dd*Pk2*f**2*k2**2*r + 328*Dd*Pk2*f**2*k2**2*s + 56*Dd*Pk2*f**2*k2**2 + 224*Dd*Pk2*f*g2*k1**2*r*s - 560*Dd*Pk2*f*g2*k1**2*r + 224*Dd*Pk2*f*g2*k1**2*s**2 - 616*Dd*Pk2*f*g2*k1**2*s + 392*Dd*Pk2*f*g2*k1**2 - 120*Dd*Pkd2*f**2*k1**2*k2*r*s + 24*Dd*Pkd2*f**2*k1**2*k2*r + 104*Dd*Pkd2*f**2*k1**2*k2*s**2 + 66*Dd*Pkd2*f**2*k1**2*k2*s - 20*Dd*Pkd2*f**2*k1**2*k2 - 112*Dd*Pkd2*f*g2*k1**2*k2*r*s + 280*Dd*Pkd2*f*g2*k1**2*k2*r - 112*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 308*Dd*Pkd2*f*g2*k1**2*k2*s - 196*Dd*Pkd2*f*g2*k1**2*k2 - 14*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1)*(r + s - 1) + Dd*f*(4*r*s - 10*r + 4*s**2 - 11*s + 7))))/(105*d**2*k1*k2*k3) + D1**3*Pkd3*ct*(-2*D1*bd1*f*(f*(Pk2*k1**2*(-20*C*r*s - 3*r**2 + s*(4*C*(3*s + 2) - 13*s + 3)) + Pk2*k2**2*r*(4*C - 2)*(r + s - 1) + Pkd2*k1**2*k2*(6*C - 3)*(r + s)*(s - 1)) + k1**2*(5*b2 - 10*g2)*(2*Pk2*s*(r + s - 1) + Pkd2*k2*(r + s)*(s - 1))) + 5*b1**3*k1**2*(2*D1*fd*(2*Pk2*(r - 1) + Pkd2*k2*s)*(r + s - 1) + Dd*f*(2*Pk2*(8*r**2 + 8*r*s - 13*r - 6*s + 5) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) + b1**2*(5*D1*bd1*f*k1**2*(2*Pk2*(6*r**2 + r*(6*s - 9) - 4*s + 3) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + 2*D1*fd*(Pk2*k2**2*(4 - 8*C)*(r - 1)*(3*r - 2*s - 3) + k1**2*(Pk2*(r + s - 1)*(-10*K*(s - 1) + 12*f*(2*s - 1) + 21*r + 19*s - 31) + Pkd2*k2*(-5*K*(s - 1)*(r + s - 1) + s*(4*C - 2)*(3*r - 2*s - 3)))) + 2*Dd*f*(Pk2*k2**2*(4 - 8*C)*(12*r**2 - r*(8*s + 17) + 6*s + 5) + k1**2*(Pk2*(-10*K*(4*s - 1)*(r + s - 1) + 12*f*(4*s - 1)*(r + s - 1) + 84*r**2 + 160*r*s - 136*r + 76*s**2 - 139*s + 57) + Pkd2*k2*(C*(6*r*(8*s - 1) - 32*s**2 - 28*s + 6) - 5*K*(s - 1)*(4*r + 4*s - 3) - 24*r*s + 3*r + 16*s**2 + 14*s - 3)))) + 2*b1*(40*C*D1*Pk2*f*fd*k1**2*r*s - 8*C*D1*Pk2*f*fd*k1**2*r - 24*C*D1*Pk2*f*fd*k1**2*s**2 - 16*C*D1*Pk2*f*fd*k1**2*s + 8*C*D1*Pk2*f*fd*k1**2 - 8*C*D1*Pk2*f*fd*k2**2*r**2 - 8*C*D1*Pk2*f*fd*k2**2*r*s + 12*C*D1*Pk2*f*fd*k2**2*r + 4*C*D1*Pk2*f*fd*k2**2*s - 4*C*D1*Pk2*f*fd*k2**2 - 12*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 12*C*D1*Pkd2*f*fd*k1**2*k2*r - 12*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 24*C*D1*Pkd2*f*fd*k1**2*k2*s - 12*C*D1*Pkd2*f*fd*k1**2*k2 + 80*C*Dd*Pk2*f**2*k1**2*r*s - 8*C*Dd*Pk2*f**2*k1**2*r - 48*C*Dd*Pk2*f**2*k1**2*s**2 - 44*C*Dd*Pk2*f**2*k1**2*s + 8*C*Dd*Pk2*f**2*k1**2 - 16*C*Dd*Pk2*f**2*k2**2*r**2 - 16*C*Dd*Pk2*f**2*k2**2*r*s + 24*C*Dd*Pk2*f**2*k2**2*r + 8*C*Dd*Pk2*f**2*k2**2*s - 8*C*Dd*Pk2*f**2*k2**2 - 24*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 24*C*Dd*Pkd2*f**2*k1**2*k2*r - 24*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 42*C*Dd*Pkd2*f**2*k1**2*k2*s - 18*C*Dd*Pkd2*f**2*k1**2*k2 - 10*D1*Pk2*bd2*f*k1**2*r*s - 10*D1*Pk2*bd2*f*k1**2*s**2 + 10*D1*Pk2*bd2*f*k1**2*s + 6*D1*Pk2*f*fd*k1**2*r**2 - 9*D1*Pk2*f*fd*k1**2*r + 26*D1*Pk2*f*fd*k1**2*s**2 - 13*D1*Pk2*f*fd*k1**2*s + 3*D1*Pk2*f*fd*k1**2 + 4*D1*Pk2*f*fd*k2**2*r**2 + 4*D1*Pk2*f*fd*k2**2*r*s - 6*D1*Pk2*f*fd*k2**2*r - 2*D1*Pk2*f*fd*k2**2*s + 2*D1*Pk2*f*fd*k2**2 + 20*D1*Pk2*f*gd2*k1**2*r*s + 20*D1*Pk2*f*gd2*k1**2*s**2 - 20*D1*Pk2*f*gd2*k1**2*s + 20*D1*Pk2*fd*g2*k1**2*r*s - 20*D1*Pk2*fd*g2*k1**2*r + 20*D1*Pk2*fd*g2*k1**2*s**2 - 40*D1*Pk2*fd*g2*k1**2*s + 20*D1*Pk2*fd*g2*k1**2 - 5*D1*Pkd2*bd2*f*k1**2*k2*r*s + 5*D1*Pkd2*bd2*f*k1**2*k2*r - 5*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 10*D1*Pkd2*bd2*f*k1**2*k2*s - 5*D1*Pkd2*bd2*f*k1**2*k2 + 6*D1*Pkd2*f*fd*k1**2*k2*r*s - 6*D1*Pkd2*f*fd*k1**2*k2*r + 6*D1*Pkd2*f*fd*k1**2*k2*s**2 - 12*D1*Pkd2*f*fd*k1**2*k2*s + 6*D1*Pkd2*f*fd*k1**2*k2 + 10*D1*Pkd2*f*gd2*k1**2*k2*r*s - 10*D1*Pkd2*f*gd2*k1**2*k2*r + 10*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 20*D1*Pkd2*f*gd2*k1**2*k2*s + 10*D1*Pkd2*f*gd2*k1**2*k2 + 10*D1*Pkd2*fd*g2*k1**2*k2*r*s - 10*D1*Pkd2*fd*g2*k1**2*k2*r + 10*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 20*D1*Pkd2*fd*g2*k1**2*k2*s + 10*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*f*(Pk2*k2**2*(4 - 8*C)*(6*r**2 - r*(4*s + 5) + 2*s - 1) + k1**2*(Pk2*(42*r**2 + r*(s*(-20*K + 24*f + 80) - 47) + s**2*(-20*K + 24*f + 38) + s*(20*K - 24*f - 54) + 10) + Pkd2*k2*(2*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) - 5*K*(s - 1)*(2*r + 2*s - 1) - 12*r*s + 3*r + 8*s**2 + 2*s - 3))) + 12*Dd*Pk2*f**2*k1**2*r**2 - 12*Dd*Pk2*f**2*k1**2*r + 52*Dd*Pk2*f**2*k1**2*s**2 - 13*Dd*Pk2*f**2*k1**2*s + 3*Dd*Pk2*f**2*k1**2 + 8*Dd*Pk2*f**2*k2**2*r**2 + 8*Dd*Pk2*f**2*k2**2*r*s - 12*Dd*Pk2*f**2*k2**2*r - 4*Dd*Pk2*f**2*k2**2*s + 4*Dd*Pk2*f**2*k2**2 + 80*Dd*Pk2*f*g2*k1**2*r*s - 20*Dd*Pk2*f*g2*k1**2*r + 80*Dd*Pk2*f*g2*k1**2*s**2 - 100*Dd*Pk2*f*g2*k1**2*s + 20*Dd*Pk2*f*g2*k1**2 + 12*Dd*Pkd2*f**2*k1**2*k2*r*s - 12*Dd*Pkd2*f**2*k1**2*k2*r + 12*Dd*Pkd2*f**2*k1**2*k2*s**2 - 21*Dd*Pkd2*f**2*k1**2*k2*s + 9*Dd*Pkd2*f**2*k1**2*k2 + 40*Dd*Pkd2*f*g2*k1**2*k2*r*s - 40*Dd*Pkd2*f*g2*k1**2*k2*r + 40*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 70*Dd*Pkd2*f*g2*k1**2*k2*s + 30*Dd*Pkd2*f*g2*k1**2*k2 - 5*b2*k1**2*(D1*fd*(2*Pk2 + Pkd2*k2)*(s - 1)*(r + s - 1) + Dd*f*(2*Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))/(15*d**2*k1*k2*k3) + D1**3*Pkd3*ct*st**4*(D1*bd1*f*k1**2*(f**2*(k1**2*(4*Pk2 - Pkd2*k2)*(10*r*(12*s - 5) + 120*s**2 - 137*s + 30) + 6*k2**2*(Pk2*(22*r**2 - 4*r*(17*s + 5) - 90*s**2 + 54*s - 2) + 5*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) + 3*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + k2**2*(Pk2*(-32*C*r**2 + 64*C*s**2 - 40*C*s - 4*K*(r*(32*s - 15) + 32*s**2 - 46*s + 15) + b1*(26*r**2 + r*(52*s - 25) + 26*s**2 - 11*s - 1) + 4*r*(8*C*s + 2*C - 52*s + 13) - 208*s**2 + 160*s - 36) + Pkd2*k2*(2*K*(r*(32*s - 15) + 32*s**2 - 46*s + 15) - 7*b1*(r + 2*s - 1) + 8*r*(-4*C*s + C + 9*s - 2) + 4*s**2*(18 - 8*C) + 4*s*(6*C - 16) + 12))) - 42*k2**2*(b1*(Pk2*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 - 12*r*s + 9*r - 2*s**2 + s - 1) + Pkd2*k2*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 4*g2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) - 3*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*f*(13*r**2 + r*(26*s + 7) + 13*s**2 + 40*s - 20) + 14*Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 - 6*r*s + 2*r - s**2 - 6*s + 3) + 33*Pkd2*f*k2*(r + 2*s - 1) + 28*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1)) + Dd*f*(-Pk2*f*(52*r**2 + r*(104*s - 11) + 52*s**2 + 69*s - 41) + 14*Pk2*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 - 24*r*s + 17*r - 4*s**2 - 5*s + 1) + 4*Pkd2*k2*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14))) + b1*k1**2*(3*D1*(f**2*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(30*s - 13) + 120*s**2 - 161*s + 46) + k2**2*(4*Pk2*(33*r**2 - 102*r*s - r - 135*s**2 + 100*s - 8) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) + 2*f*(fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + k2**2*(Pk2*(-16*C*(2*r**2 - r*(2*s + 1) - 4*s**2 + 5*s - 1) - 2*K*(64*r*s - 39*r + 64*s**2 - 78*s + 23) - 208*r*s + 83*r - 208*s**2 + 220*s - 49) + Pkd2*k2*(-16*C*(2*s - 1)*(r + s - 1) + K*(64*r*s - 39*r + 64*s**2 - 78*s + 23) + 72*r*s - 40*r + 72*s**2 - 88*s + 26))) + 28*gd2*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1))*(r + s - 1)) + 112*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))*(r + s - 1)) + Dd*f*(f**2*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(240*s - 103) + 240*s**2 - 310*s + 84) + 3*k2**2*(4*Pk2*(44*r**2 - 136*r*s - 11*r - 180*s**2 + 127*s - 9) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 6*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + k2**2*(Pk2*(4*C*(-16*r**2 + 2*r*(8*s + 5) + 32*s**2 - 32*s + 3) - 2*K*(128*r*s - 69*r + 128*s**2 - 170*s + 53) - 416*r*s + 121*r - 416*s**2 + 386*s - 79) + Pkd2*k2*(-4*C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + K*(128*r*s - 69*r + 128*s**2 - 170*s + 53) + 144*r*s - 58*r + 144*s**2 - 160*s + 42))) + 168*g2*k2**2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))) + 2*f*(D1*(f*(fd*(-Pk2*k2**4*(4*C - 2)*(36*r**2 - 3*r*(18*s + 11) + 42*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2**2*(Pk2*(-12*C*(66*r*s - 25*r + 48*s**2 - 64*s + 17) - 90*r**2 + 144*r*s - 33*r + 126*s**2 - 192*s + 55) + 6*Pkd2*k2*(C*(66*r*s - 25*r + 48*s**2 - 64*s + 17) - 27*r*s + 10*r - 18*s**2 + 26*s - 7))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(3*bd2 - 6*gd2)*(r*(32*s - 15) + 32*s**2 - 46*s + 15)) + 3*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(64*s - 39) + 64*s**2 - 78*s + 23)) + Dd*f*(f*(-Pk2*k2**4*(8*C - 4)*(24*r**2 - 9*r*(4*s + 3) + 32*s + 4) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(4*r + 4*s - 3) + k1**2*k2**2*(Pk2*(-24*C*(44*r*s - 15*r + 32*s**2 - 44*s + 11) - 120*r**2 + 192*r*s - 25*r + 168*s**2 - 276*s + 77) + 6*Pkd2*k2*(C*(88*r*s - 30*r + 64*s**2 - 88*s + 22) - 36*r*s + 12*r - 24*s**2 + 36*s - 9))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(3*b2 - 6*g2)*(r*(128*s - 69) + 128*s**2 - 170*s + 53))))/(105*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct*st**2*(21*b1**3*k1**2*k2**2*(D1*fd*(Pk2*(r + s - 1) + 2*Pkd2*k2*s)*(r + s - 1) + Dd*f*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) - 3*b1**2*k1**2*(-7*D1*bd1*f*k2**2*(Pk2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + D1*fd*(k1**2*(2*Pk2*(28*K*(s - 1)*(r + s - 1) + f*(6*r**2 - 4*r*(29*s + 7) - 122*s**2 + 73*s + 22) - 7*r**2 - 56*r*s + 42*r - 49*s**2 + 70*s - 35) + Pkd2*k2*(f*(16*r*(8*s + 1) + 128*s**2 - 85*s - 16) + 14*s*(r + s))) + 7*k2**2*(2*Pk2*(8*C*(r - 1)*(r + s - 1) + K*(-17*r**2 + 6*r*(s - 1) + 23*(s - 1)**2) - 7*f*r**2 + 2*f*r*s + f*r + 9*f*s**2 + 20*f*s + 8*r**2 + 12*r*s + 4*s**2 + 22*s - 15) - Pkd2*k2*(2*K*(r*(22*s - 19) + 22*s**2 - 38*s + 19) + 21*f*(r + 2*s - 1) + 4*r*(s*(3 - 4*C) + 5) + 4*s**2*(3 - 4*C) + 4*s*(4*C + 7) - 20))) + 2*Dd*f*k1**2*(Pk2*f*(12*r**2 - r*(232*s + 103) - 244*s**2 + 143*s + 57) + 7*Pk2*(2*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 4*r**2 + r*(13 - 32*s) - 28*s**2 + 45*s - 11) + Pkd2*f*k2*(r*(128*s + 41) + 128*s**2 - 82*s - 24) + 7*Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + 7*Dd*f*k2**2*(Pk2*(8*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 2*K*(-68*r**2 + 24*r*s + 79*r + 92*s**2 - 81*s - 11) + f*(-28*r**2 + r*(8*s + 9) + 36*s**2 + 49*s - 13) + 64*r**2 + 96*r*s - 114*r + 32*s**2 + 36*s + 18) + 2*Pkd2*k2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 88*K*r*s + 39*K*r - 88*K*s**2 + 120*K*s - 33*K - 12*f*(r + 2*s - 1) - 24*r*s - 17*r - 24*s**2 - 16*s + 17))) + 3*b1*(-D1*bd1*f*k1**2*(k1**2*(2*Pk2*(14*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + f*(6*r**2 - r*(116*s + 75) - 122*s**2 + 70*s + 35) - 14*r**2 - 112*r*s + 21*r - 98*s**2 + 147*s - 21) + Pkd2*k2*(f*(128*r*s + 66*r + 128*s**2 - 79*s - 32) + 28*r*s + 28*r + 28*s**2 - 56*s)) + 7*k2**2*(Pk2*(8*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 68*K*r**2 + 24*K*r*s + 102*K*r + 92*K*s**2 - 58*K*s - 34*K + f*(-14*r**2 + 4*r*s + 7*r + 18*s**2 + 9*s - 13) + 32*r**2 + 48*r*s - 78*r + 16*s**2 - 8*s + 28) + Pkd2*k2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - 2*K*(r*(44*s - 13) + 44*s**2 - 52*s + 7) - 3*f*(r + 2*s - 1) - 24*r*s - 4*r - 24*s**2 + 4*s + 4))) + D1*(3*f**2*fd*k1**2*(16*Pk2*k2**2*(18*r**2 + r*(33*s - 28) + 15*s**2 - 22*s + 10) + k1**2*(4*Pk2*(54*r**2 - 3*r*(18*s + 5) - 108*s**2 + 132*s - 25) + 3*Pkd2*k2*(36*r*(2*s - 1) + 72*s**2 - 97*s + 30))) + 2*f*(fd*(Pk2*k2**4*(4*C - 2)*(20*r - 17) + k1**4*(Pk2*(16*C*(r*(15*s - 4) + s**2 - 12*s + 4) - 2*K*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + 52*r**2 - 108*r*s + 156*r - 48*s**2 + 361*s - 141) + Pkd2*k2*(-14*C*(r*(8*s - 3) - 7*s + 3) + K*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + 96*r*s - 70*r + 40*s**2 - 132*s + 49)) + k1**2*k2**2*(Pk2*(4*C*(73*r**2 + r*(25 - 434*s) - 59*s**2 + 381*s - 98) - 14*K*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 156*r**2 + 1408*r*s - 337*r + 356*s**2 - 1034*s + 268) + Pkd2*k2*(2*C*(r*(116*s - 13) + 116*s**2 - 98*s + 13) - 21*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) - 116*r*s + 34*r - 116*s**2 + 140*s - 34))) + 7*k1**2*(bd2*k2**2*(-Pk2*(r + s - 1)**2 + Pkd2*k2*s*(3*r + 3*s - 4)) + 2*gd2*(2*Pk2*k1**2*(2*s - 1)*(r + s - 1) + k2**2*(Pk2*(-17*r**2 + 6*r*s + 34*r + 23*s**2 - 6*s - 17) + Pkd2*k2*(-22*r*s + 7*r - 22*s**2 + 30*s - 7))))) + 14*fd*k1**2*(b2*k2**2*(-Pk2*(r + s - 1)**2 + 3*Pkd2*k2*s*(r + s)) + 2*g2*(4*Pk2*k1**2*(s - 1)*(r + s - 1) + k2**2*(Pk2*(-17*r**2 + 6*r*(s - 1) + 23*(s - 1)**2) + Pkd2*k2*(r*(19 - 22*s) - 22*s**2 + 38*s - 19))))) + 2*Dd*f*(3*f**2*k1**2*(8*Pk2*k2**2*(24*r**2 + r*(44*s - 37) + 20*s**2 - 29*s + 13) + k1**2*(8*Pk2*(18*r**2 - 18*r*s - 5*r - 36*s**2 + 42*s - 8) + 3*Pkd2*k2*(48*r*s - 23*r + 48*s**2 - 62*s + 18))) + f*(Pk2*k2**4*(40*C - 20)*(2*r - 1) + k1**4*(Pk2*(4*C*(10*r*(12*s - 1) + 8*s**2 - 94*s + 13) - 2*K*(4*r*s - 26*r + 4*s**2 - 67*s + 29) + 104*r**2 - 216*r*s + 215*r - 96*s**2 + 670*s - 268) + Pkd2*k2*(-14*C*(r*(16*s - 3) - 14*s + 3) + K*(4*r*s - 26*r + 4*s**2 - 67*s + 29) + 192*r*s - 115*r + 80*s**2 - 270*s + 96)) + k1**2*k2**2*(2*Pk2*(C*(292*r**2 - r*(1736*s + 145) - 236*s**2 + 1465*s - 135) - 7*K*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 156*r**2 + 1408*r*s - 286*r + 356*s**2 - 1021*s + 161) + Pkd2*k2*(C*(r*(464*s - 98) + 464*s**2 - 400*s + 62) - 21*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 232*r*s + 77*r - 232*s**2 + 256*s - 59))) + 7*k1**2*(b2*k2**2*(-Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(12*r*s + r + s*(12*s - 11))) + 2*g2*(2*Pk2*k1**2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k2**2*(Pk2*(-68*r**2 + 24*r*s + 79*r + 92*s**2 - 81*s - 11) + Pkd2*k2*(-88*r*s + 39*r - 88*s**2 + 120*s - 33)))))) + f*(-216*C*D1*Pk2*f*fd*k1**4*r*s + 216*C*D1*Pk2*f*fd*k1**4*r - 216*C*D1*Pk2*f*fd*k1**4*s**2 + 504*C*D1*Pk2*f*fd*k1**4*s - 192*C*D1*Pk2*f*fd*k1**4 - 3240*C*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 3672*C*D1*Pk2*f*fd*k1**2*k2**2*r*s + 1512*C*D1*Pk2*f*fd*k1**2*k2**2*r + 2592*C*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 4032*C*D1*Pk2*f*fd*k1**2*k2**2*s + 504*C*D1*Pk2*f*fd*k1**2*k2**2 - 432*C*D1*Pk2*f*fd*k2**4*r**2 - 432*C*D1*Pk2*f*fd*k2**4*r*s + 360*C*D1*Pk2*f*fd*k2**4*r + 144*C*D1*Pk2*f*fd*k2**4*s - 72*C*D1*Pk2*f*fd*k2**4 + 108*C*D1*Pkd2*f*fd*k1**4*k2*r*s - 108*C*D1*Pkd2*f*fd*k1**4*k2*r + 108*C*D1*Pkd2*f*fd*k1**4*k2*s**2 - 252*C*D1*Pkd2*f*fd*k1**4*k2*s + 96*C*D1*Pkd2*f*fd*k1**4*k2 - 2592*C*D1*Pkd2*f*fd*k1**2*k2**3*r*s + 1296*C*D1*Pkd2*f*fd*k1**2*k2**3*r - 2592*C*D1*Pkd2*f*fd*k1**2*k2**3*s**2 + 3024*C*D1*Pkd2*f*fd*k1**2*k2**3*s - 864*C*D1*Pkd2*f*fd*k1**2*k2**3 - 288*C*Dd*Pk2*f**2*k1**4*r*s + 336*C*Dd*Pk2*f**2*k1**4*r - 288*C*Dd*Pk2*f**2*k1**4*s**2 + 792*C*Dd*Pk2*f**2*k1**4*s - 312*C*Dd*Pk2*f**2*k1**4 - 4320*C*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 4896*C*Dd*Pk2*f**2*k1**2*k2**2*r*s + 3096*C*Dd*Pk2*f**2*k1**2*k2**2*r + 3456*C*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 5184*C*Dd*Pk2*f**2*k1**2*k2**2*s - 576*C*Dd*Pk2*f**2*k2**4*r**2 - 576*C*Dd*Pk2*f**2*k2**4*r*s + 576*C*Dd*Pk2*f**2*k2**4*r + 288*C*Dd*Pk2*f**2*k2**4*s - 144*C*Dd*Pk2*f**2*k2**4 + 144*C*Dd*Pkd2*f**2*k1**4*k2*r*s - 168*C*Dd*Pkd2*f**2*k1**4*k2*r + 144*C*Dd*Pkd2*f**2*k1**4*k2*s**2 - 396*C*Dd*Pkd2*f**2*k1**4*k2*s + 156*C*Dd*Pkd2*f**2*k1**4*k2 - 3456*C*Dd*Pkd2*f**2*k1**2*k2**3*r*s + 1620*C*Dd*Pkd2*f**2*k1**2*k2**3*r - 3456*C*Dd*Pkd2*f**2*k1**2*k2**3*s**2 + 4104*C*Dd*Pkd2*f**2*k1**2*k2**3*s - 1188*C*Dd*Pkd2*f**2*k1**2*k2**3 + 306*D1*Pk2*f*fd*k1**4*r**2 + 36*D1*Pk2*f*fd*k1**4*r*s + 198*D1*Pk2*f*fd*k1**4*r - 270*D1*Pk2*f*fd*k1**4*s**2 + 420*D1*Pk2*f*fd*k1**4*s - 214*D1*Pk2*f*fd*k1**4 + 3240*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 540*D1*Pk2*f*fd*k1**2*k2**2*r*s - 2358*D1*Pk2*f*fd*k1**2*k2**2*r - 540*D1*Pk2*f*fd*k1**2*k2**2*s**2 + 1116*D1*Pk2*f*fd*k1**2*k2**2*s + 54*D1*Pk2*f*fd*k1**2*k2**2 + 216*D1*Pk2*f*fd*k2**4*r**2 + 216*D1*Pk2*f*fd*k2**4*r*s - 180*D1*Pk2*f*fd*k2**4*r - 72*D1*Pk2*f*fd*k2**4*s + 36*D1*Pk2*f*fd*k2**4 + 24*D1*Pk2*f*gd2*k1**4*r*s - 216*D1*Pk2*f*gd2*k1**4*r + 24*D1*Pk2*f*gd2*k1**4*s**2 - 528*D1*Pk2*f*gd2*k1**4*s + 216*D1*Pk2*f*gd2*k1**4 + 1344*D1*Pk2*f*gd2*k1**2*k2**2*r**2 + 336*D1*Pk2*f*gd2*k1**2*k2**2*r*s - 1344*D1*Pk2*f*gd2*k1**2*k2**2*r - 1008*D1*Pk2*f*gd2*k1**2*k2**2*s**2 + 840*D1*Pk2*f*gd2*k1**2*k2**2*s + 48*D1*Pk2*fd*g2*k1**4*r*s - 192*D1*Pk2*fd*g2*k1**4*r + 48*D1*Pk2*fd*g2*k1**4*s**2 - 552*D1*Pk2*fd*g2*k1**4*s + 264*D1*Pk2*fd*g2*k1**4 + 2688*D1*Pk2*fd*g2*k1**2*k2**2*r**2 + 672*D1*Pk2*fd*g2*k1**2*k2**2*r*s - 2016*D1*Pk2*fd*g2*k1**2*k2**2*s**2 + 3360*D1*Pk2*fd*g2*k1**2*k2**2*s - 1176*D1*Pk2*fd*g2*k1**2*k2**2 + 216*D1*Pkd2*f*fd*k1**4*k2*r*s - 126*D1*Pkd2*f*fd*k1**4*k2*r + 216*D1*Pkd2*f*fd*k1**4*k2*s**2 - 252*D1*Pkd2*f*fd*k1**4*k2*s + 78*D1*Pkd2*f*fd*k1**4*k2 + 1296*D1*Pkd2*f*fd*k1**2*k2**3*r*s - 648*D1*Pkd2*f*fd*k1**2*k2**3*r + 1296*D1*Pkd2*f*fd*k1**2*k2**3*s**2 - 1512*D1*Pkd2*f*fd*k1**2*k2**3*s + 432*D1*Pkd2*f*fd*k1**2*k2**3 - 12*D1*Pkd2*f*gd2*k1**4*k2*r*s + 108*D1*Pkd2*f*gd2*k1**4*k2*r - 12*D1*Pkd2*f*gd2*k1**4*k2*s**2 + 264*D1*Pkd2*f*gd2*k1**4*k2*s - 108*D1*Pkd2*f*gd2*k1**4*k2 + 2016*D1*Pkd2*f*gd2*k1**2*k2**3*r*s - 756*D1*Pkd2*f*gd2*k1**2*k2**3*r + 2016*D1*Pkd2*f*gd2*k1**2*k2**3*s**2 - 2520*D1*Pkd2*f*gd2*k1**2*k2**3*s + 756*D1*Pkd2*f*gd2*k1**2*k2**3 - 24*D1*Pkd2*fd*g2*k1**4*k2*r*s + 96*D1*Pkd2*fd*g2*k1**4*k2*r - 24*D1*Pkd2*fd*g2*k1**4*k2*s**2 + 276*D1*Pkd2*fd*g2*k1**4*k2*s - 132*D1*Pkd2*fd*g2*k1**4*k2 + 4032*D1*Pkd2*fd*g2*k1**2*k2**3*r*s - 2268*D1*Pkd2*fd*g2*k1**2*k2**3*r + 4032*D1*Pkd2*fd*g2*k1**2*k2**3*s**2 - 4536*D1*Pkd2*fd*g2*k1**2*k2**3*s + 1260*D1*Pkd2*fd*g2*k1**2*k2**3 + 3*D1*bd1*(3*f**2*k1**2*(16*Pk2*k2**2*(6*r**2 + r*(11*s - 9) + 5*s**2 - 7*s + 3) + k1**2*(4*Pk2*(18*r**2 - 18*r*s - 5*r - 36*s**2 + 36*s - 7) + 3*Pkd2*k2*(24*r*s - 10*r + 24*s**2 - 27*s + 6))) - 2*f*(Pk2*k2**4*(4*C - 2)*(5*r - 12) + k1**4*(2*Pk2*(-4*C*s**2 + 38*C*s + K*(r*(s - 9) + s**2 - 22*s + 9) - 13*r**2 - r*(60*C*s + 6*C - 27*s + 16) + 12*s**2 - 74*s + 37) - Pkd2*k2*(42*C*s + K*(r*(s - 9) + s**2 - 22*s + 9) - 8*r*(7*C*s - 6*s + 3) + 20*s**2 - 67*s + 26)) + k1**2*k2**2*(Pk2*(r**2*(-146*C + 112*K - 78) + r*(2*C*(434*s + 61) + 28*K*(s - 4) - 704*s + 169) + 2*s**2*(59*C - 42*K - 89) + 2*s*(-257*C + 35*K + 211) - 66) + Pkd2*k2*(-2*C*(r*(58*s - 31) + 58*s**2 - 52*s + 13) + 21*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 58*r*s - 31*r + 58*s**2 - 52*s + 13))) + 14*k1**2*(b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(3*r*s + r + s*(3*s - 3))) + 2*g2*(2*Pk2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + k2**2*(Pk2*(-17*r**2 + r*(6*s + 17) + s*(23*s - 23)) + 2*Pkd2*k2*(r*(3 - 11*s) - s*(11*s - 11)))))) - 6*D1*bd2*f*k1**2*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(s - 9) + s**2 - 22*s + 9) + 7*k2**2*(2*Pk2*(8*r**2 + 2*r*(s - 4) + s*(5 - 6*s)) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))) + 408*Dd*Pk2*f**2*k1**4*r**2 + 48*Dd*Pk2*f**2*k1**4*r*s + 156*Dd*Pk2*f**2*k1**4*r - 360*Dd*Pk2*f**2*k1**4*s**2 + 442*Dd*Pk2*f**2*k1**4*s - 274*Dd*Pk2*f**2*k1**4 + 4320*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 720*Dd*Pk2*f**2*k1**2*k2**2*r*s - 3870*Dd*Pk2*f**2*k1**2*k2**2*r - 720*Dd*Pk2*f**2*k1**2*k2**2*s**2 + 1296*Dd*Pk2*f**2*k1**2*k2**2*s + 486*Dd*Pk2*f**2*k1**2*k2**2 + 288*Dd*Pk2*f**2*k2**4*r**2 + 288*Dd*Pk2*f**2*k2**4*r*s - 288*Dd*Pk2*f**2*k2**4*r - 144*Dd*Pk2*f**2*k2**4*s + 72*Dd*Pk2*f**2*k2**4 + 96*Dd*Pk2*f*g2*k1**4*r*s - 624*Dd*Pk2*f*g2*k1**4*r + 96*Dd*Pk2*f*g2*k1**4*s**2 - 1608*Dd*Pk2*f*g2*k1**4*s + 696*Dd*Pk2*f*g2*k1**4 + 5376*Dd*Pk2*f*g2*k1**2*k2**2*r**2 + 1344*Dd*Pk2*f*g2*k1**2*k2**2*r*s - 2688*Dd*Pk2*f*g2*k1**2*k2**2*r - 4032*Dd*Pk2*f*g2*k1**2*k2**2*s**2 + 5040*Dd*Pk2*f*g2*k1**2*k2**2*s - 1176*Dd*Pk2*f*g2*k1**2*k2**2 + 288*Dd*Pkd2*f**2*k1**4*k2*r*s - 150*Dd*Pkd2*f**2*k1**4*k2*r + 288*Dd*Pkd2*f**2*k1**4*k2*s**2 - 324*Dd*Pkd2*f**2*k1**4*k2*s + 102*Dd*Pkd2*f**2*k1**4*k2 + 1728*Dd*Pkd2*f**2*k1**2*k2**3*r*s - 810*Dd*Pkd2*f**2*k1**2*k2**3*r + 1728*Dd*Pkd2*f**2*k1**2*k2**3*s**2 - 2052*Dd*Pkd2*f**2*k1**2*k2**3*s + 594*Dd*Pkd2*f**2*k1**2*k2**3 - 48*Dd*Pkd2*f*g2*k1**4*k2*r*s + 312*Dd*Pkd2*f*g2*k1**4*k2*r - 48*Dd*Pkd2*f*g2*k1**4*k2*s**2 + 804*Dd*Pkd2*f*g2*k1**4*k2*s - 348*Dd*Pkd2*f*g2*k1**4*k2 + 8064*Dd*Pkd2*f*g2*k1**2*k2**3*r*s - 3780*Dd*Pkd2*f*g2*k1**2*k2**3*r + 8064*Dd*Pkd2*f*g2*k1**2*k2**3*s**2 - 9576*Dd*Pkd2*f*g2*k1**2*k2**3*s + 2772*Dd*Pkd2*f*g2*k1**2*k2**3 - 6*b2*k1**2*(D1*fd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(s - 4) + 2*s**2 - 23*s + 11) + 7*k2**2*(2*Pk2*(16*r**2 + 4*r*s - 12*s**2 + 20*s - 7) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 26) + 4*s**2 - 67*s + 29) + 7*k2**2*(2*Pk2*(32*r**2 + 8*r*(s - 2) - 24*s**2 + 30*s - 7) + 3*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11))))))/(315*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct*(-7*b1**3*k1**2*(D1*fd*(4*k1**2*(Pk2*(r + s - 1) + 2*Pkd2*k2*s) + 5*k2**2*(Pk2*(13*r + 5*s - 13) + 2*Pkd2*k2*s))*(r + s - 1) + Dd*f*(4*k1**2*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1)) + 5*k2**2*(Pk2*(52*r**2 + 72*r*s - 87*r + 20*s**2 - 59*s + 35) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1)))) - 7*b1**2*(D1*bd1*f*k1**2*(4*k1**2*(Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + Pkd2*k2*(6*r*s - r + 6*s**2 - 6*s + 1)) + 5*k2**2*(Pk2*(39*r**2 + 54*r*s - 61*r + 15*s**2 - 41*s + 22) + Pkd2*k2*(6*r*s - r + 6*s**2 - 6*s + 1))) - D1*fd*(Pk2*k2**4*(16*C - 8)*(r - 1)*(3*r - 2*s - 3) + k1**4*(2*Pk2*f*(72*r**2 + 4*r*(24*s - 25) + 24*s**2 - 53*s + 38) + 4*Pk2*(11*r**2 + r*(s*(8*C + 13) + 2) + s**2*(8*C + 2) + s*(10 - 8*C) - 1) + 3*Pkd2*f*k2*(4*r*(4*s + 1) + 16*s**2 - 7*s - 4) - 2*Pkd2*k2*s*(20*C*(r - 1) + 4*K*s + r*(4*K - 15) - 5*s + 10)) - 2*k1**2*k2**2*(Pk2*(-8*C*(9*r**2 - r*(31*s + 18) + 5*s**2 + 31*s + 9) + 25*K*r**2 + 10*K*r*s + 70*K*r - 15*K*s**2 + 110*K*s - 55*K - 4*f*(8*r**2 + 8*r*s - 7*r + s + 1) + 32*r**2 - 124*r*s - 124*r + 24*s**2 + 74*s + 67) + Pkd2*k2*(5*K*(2*r*s + r + 2*s**2 + 2*s - 1) + s*(4*C - 2)*(3*r - 2*s - 3)))) - 2*Dd*f*(Pk2*k2**4*(8*C - 4)*(12*r**2 - r*(8*s + 17) + 6*s + 5) + k1**4*(2*Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + f*(72*r**2 + 96*r*s - 103*r + 24*s**2 - 56*s + 34) + 44*r**2 + 52*r*s - 27*r + 8*s**2 + 10*s - 7) + Pkd2*k2*(-10*C*(r*(8*s - 1) - 6*s + 1) - 16*K*r*s + 2*K*r - 16*K*s**2 + 8*K*s + f*(48*r*s + 9*r + 48*s**2 - 30*s - 6) + 60*r*s - 5*r + 20*s**2 - 45*s + 5)) - k1**2*k2**2*(Pk2*(-4*C*(72*r**2 - r*(248*s + 77) + 40*s**2 + 176*s + 5) + 100*K*r**2 + 40*K*r*s + 25*K*r - 60*K*s**2 + 185*K*s - 85*K - 8*f*(8*r**2 + 8*r*(s - 1) + 1) + 128*r**2 - 496*r*s - 215*r + 96*s**2 + 258*s + 67) + Pkd2*k2*(C*(6*r*(8*s - 1) - 32*s**2 - 28*s + 6) + 5*K*(8*r*s + 3*r + 8*s**2 - 3) - 24*r*s + 3*r + 16*s**2 + 14*s - 3)))) + b1*(7*D1*bd1*f*(Pk2*k2**4*(16*C - 8)*(6*r**2 - r*(4*s + 5) + 2*s - 1) + k1**4*(2*Pk2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + f*(72*r**2 + 96*r*s - 106*r + 24*s**2 - 59*s + 30) + 44*r**2 + 52*r*s - 38*r + 8*s**2 - 2*s - 10) + Pkd2*k2*(-20*C*(r*(4*s - 1) - 2*s + 1) - 16*K*s**2 + 12*K*s + 48*f*s**2 - 39*f*s + 2*r*(-8*K*s + 2*K + 24*f*s + 3*f + 30*s - 5) + 20*s**2 - 40*s + 10)) - 2*k1**2*k2**2*(Pk2*(-4*C*(36*r**2 - r*(124*s + 5) + 20*s**2 + 52*s - 31) + 50*K*r**2 + 20*K*r*s - 35*K*r - 30*K*s**2 + 45*K*s - 15*K - 4*f*(8*r - 1)*(r + s - 1) + 64*r**2 - 248*r*s - 7*r + 48*s**2 + 80*s - 52) + Pkd2*k2*(2*C*(3*r*(4*s - 1) - 8*s**2 - 2*s + 3) + 5*K*(4*r*s + r + 4*s**2 - 2*s - 1) - 12*r*s + 3*r + 8*s**2 + 2*s - 3))) + 2*D1*(108*Pk2*f**2*fd*k1**4*(3*s - 1)*(r + s - 1) + f*(-fd*(Pk2*k2**4*(28*C - 14)*(2*r - 1) + k1**4*(Pk2*(28*C*(r*(16*s - 5) - 13*s + 5) + 14*K*(2*s - 1)*(3*r + 3*s - 1) - 330*r**2 - 880*r*s + 428*r - 326*s**2 + 601*s - 191) + 3*Pkd2*k2*(7*K*(s - 1) + s*(16*C - 15))*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(4*C*(213*r**2 + r*(178*s - 129) - 35*s**2 + 79*s - 22) + 56*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 594*r**2 - 524*r*s + 272*r + 70*s**2 - 242*s + 93) + Pkd2*k2*(84*C - 42)*(2*r*s + r + 2*s**2 + s - 1))) - 7*k1**2*k2*(bd2*(5*Pk2*k2*(7*r**2 + 14*r*s - 6*r + 7*s**2 - 6*s - 1) + 2*Pkd2*k1**2*s*(2*r + 2*s - 1) + 5*Pkd2*k2**2*s*(3*r + 3*s - 2)) - 2*gd2*(5*Pk2*k2*(5*r**2 + 2*r*(s - 1) - 3*(s - 1)**2) + 2*Pkd2*k1**2*s*(2*r + 2*s - 1) + 5*Pkd2*k2**2*(2*r*s + r + 2*s**2 - 1)))) - 7*fd*k1**2*k2*(b2*(5*Pk2*k2*(7*r**2 + 14*r*s + 2*r + 7*s**2 + 2*s - 1) + 4*Pkd2*k1**2*s*(r + s) + 15*Pkd2*k2**2*s*(r + s)) - 2*g2*(5*Pk2*k2*(5*r**2 + 2*r*(s + 7) - 3*s**2 + 22*s - 11) + 4*Pkd2*k1**2*s*(r + s) + 5*Pkd2*k2**2*(2*r*s + r + 2*s**2 + 2*s - 1)))) + 2*Dd*f*(108*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + f*(Pk2*k2**4*(28 - 56*C)*(2*r - 1) + k1**4*(Pk2*(-28*C*(r*(32*s - 5) - 26*s + 5) - 14*K*(4*s - 1)*(3*r + 3*s - 1) + 660*r**2 + 1760*r*s - 908*r + 652*s**2 - 1267*s + 345) - 3*Pkd2*k2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + 7*K*(s - 1)*(4*r + 4*s - 3) - 60*r*s + 4*r - 60*s**2 + 45*s - 2)) + k1**2*k2**2*(Pk2*(-2*C*(852*r**2 + 89*r*(8*s - 9) - 140*s**2 - 55*s + 121) - 56*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) + 1188*r**2 + 1048*r*s - 990*r - 140*s**2 + 15*s + 72) + Pkd2*k2*(21 - 42*C)*(r*(8*s + 3) + 8*s**2 - 3))) - 7*k1**2*k2*(b2*(5*Pk2*k2*(28*r**2 + r*(56*s - 17) + 28*s**2 - 17*s - 3) + 2*Pkd2*k1**2*(r*(8*s - 1) + 4*s*(2*s - 1)) + 5*Pkd2*k2**2*(r*(12*s - 1) + s*(12*s - 7))) - 2*g2*(5*Pk2*k2*(20*r**2 + 8*r*s + 5*r - 12*s**2 + 37*s - 17) + 2*Pkd2*k1**2*(8*r*s - r + 8*s**2 - 4*s) + 5*Pkd2*k2**2*(8*r*s + 3*r + 8*s**2 - 3))))) + 2*f*(D1*bd1*(108*Pk2*f**2*k1**4*s*(r + s - 1) - f*(Pk2*k2**4*r*(28*C - 14) + k1**4*(Pk2*(-165*r**2 + r*(s*(224*C + 42*K - 440) + 243) + s**2*(42*K - 163) - s*(140*C + 14*K - 315) - 82) + 3*Pkd2*k2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 7*K*(s - 1)*(r + s - 1) - 15*r*s + 4*r - 15*s**2 + 17*s - 2)) + k1**2*k2**2*(Pk2*(2*C*(213*r**2 + r*(178*s - 241) - 35*s**2 - 111*s + 76) + 56*K*(r**2 + 4*r*s - 2*r + 3*s**2 - 3*s + 1) - 297*r**2 - 262*r*s + 332*r + 35*s**2 + 111*s - 76) + Pkd2*k2*s*(84*C - 42)*(r + s - 1))) - 7*k1**2*k2*(b2*(35*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + 5*Pkd2*k2**2*(r*(3*s - 1) + s*(3*s - 3))) - 2*g2*(5*Pk2*k2*(5*r**2 + r*(2*s - 5) - s*(3*s - 3)) + 2*Pkd2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + 10*Pkd2*k2**2*s*(r + s - 1)))) + k1**2*(D1*(f*(-3*fd*(Pk2*k2**2*(4*C - 2)*(21*r**2 + r*(75*s - 46) + 54*s**2 - 61*s + 19) + k1**2*(Pk2*(4*C*(3*s - 1)*(5*r + 5*s - 3) - 15*r**2 - 78*r*s + 31*r - 63*s**2 + 72*s - 17) + Pkd2*k2*(10*C - 5)*(s - 1)*(3*r + 3*s - 2))) + (-7*bd2 + 14*gd2)*(2*Pk2*k1**2*s*(3*r + 3*s - 1) + 8*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + 3*Pkd2*k1**2*k2*(s - 1)*(r + s - 1))) + 14*fd*g2*(8*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(2*Pk2*(2*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)))) + Dd*f*(-3*f*(Pk2*k2**2*(8*C - 4)*(14*r**2 + 10*r*(5*s - 3) + 36*s**2 - 40*s + 13) + k1**2*(Pk2*(4*C*(4*s - 1)*(5*r + 5*s - 3) - 20*r**2 - 104*r*s + 36*r - 84*s**2 + 89*s - 17) + Pkd2*k2*(10*C - 5)*(s - 1)*(4*r + 4*s - 3))) + 14*g2*(8*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(2*Pk2*(4*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))) - 7*b2*(D1*fd*(8*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(2*Pk2*(2*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))) + Dd*f*(8*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(2*Pk2*(4*s - 1)*(3*r + 3*s - 1) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(105*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct*st**4*(D1*(-1386*b1*fd*k1**2*k2**4*(-Pk2*b1*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 4*r*s + 10*r + 10*s - 5) + 4*Pk2*g2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*b1*k2*s*(2*K - 1)*(r + s) - 8*Pkd2*g2*k2*s*(r + s)) + f**3*k1**2*(33*bd1*k2**2*(k1**2*(Pk2*(390*r**2 + 732*r*s - 567*r + 342*s**2 - 475*s + 121) + Pkd2*k2*(24*r*s - 9*r + 24*s**2 - 55*s + 37)) - 3*k2**2*(Pk2*(161*r**2 + 206*r*s - 240*r + 45*s**2 - 160*s + 87) + 10*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + fd*(1760*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(2264*s - 753) + 2264*s**2 - 2660*s + 617) + 33*k1**2*k2**2*(4*Pk2*(132*r**2 - 22*r*(24*s + 1) - 660*s**2 + 537*s - 49) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35)))) + 33*f**2*k2**2*(-3*bd1*(2*k1**4*(Pk2*(r**2*(10*K - 35) + r*(-10*K - 60*s + 71) - s**2*(10*K + 25) + s*(40*K + 39) - 36) + Pkd2*k2*(2*K - 1)*(r*(5*s - 3) + 5*s**2 - 12*s + 3)) + k1**2*k2**2*(-35*Pk2*b1*(r + s - 1) + 2*Pk2*(-4*C*(6*r**2 + 2*r*(8*s - 3) + 10*s**2 - 9*s - 1) + K*(75*r**2 + 238*r*s - 138*r + 163*s**2 - 176*s + 63) + 112*r**2 + 168*r*s - 150*r + 56*s**2 - 122*s + 34) + Pkd2*b1*k2*(r*(13 - 52*s) - 52*s**2 + 45*s - 3) + 2*Pkd2*k2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - K*(24*r*s + r + 24*s**2 - 10*s - 1) + 16*r*s - r + 16*s**2 - 13*s + 4))) + fd*(Pk2*k2**4*(8*C - 4)*(36*r**2 - 3*r*(18*s + 11) + 42*s - 1) + 3*k1**4*(Pk2*(-8*C*(9*r**2 - 3*r*(8*s + 1) - 15*s**2 + 25*s - 4) + 3*b1*(130*r**2 + r*(244*s - 179) + 114*s**2 - 159*s + 67) + 132*r**2 + 18*r*(2*s - 7) - 24*s**2 + 30*s + 16) + Pkd2*k2*(-4*C*(36*r*s - 11*r + 18*s**2 - 34*s + 9) + b1*(3*r*(8*s - 23) + 24*s**2 - 99*s + 47) + 90*r*s - 28*r + 54*s**2 - 86*s + 22)) - k1**2*k2**2*(Pk2*(4*C*(513*r**2 + 9*r*(266*s - 85) + 585*s**2 - 1485*s + 362) + 3*b1*(483*r**2 + 618*r*s - 541*r + 135*s**2 - 351*s + 156) - 882*r**2 - 4644*r*s + 1386*r - 1170*s**2 + 2976*s - 710) + 3*Pkd2*k2*(4*C*(3*r*(14*s - 5) + 24*s**2 - 40*s + 11) + 5*b1*(r*(30*s - 11) + 30*s**2 - 30*s + 7) + (3*s - 1)*(-20*r - 8*s + 16)))) + 6*k1**2*(-5*Pk2*bd2*k2**2*(19*r**2 + r*(38*s - 32) + 19*s**2 - 32*s + 13) + 2*gd2*(10*Pk2*k1**2*(r**2 - r - s*(s - 4)) + Pk2*k2**2*(75*r**2 + 2*r*(119*s - 69) + 163*s**2 - 176*s + 63) + 2*Pkd2*k1**2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) - Pkd2*k2**3*(24*r*s + r + 24*s**2 - 10*s - 1)))) + 99*f*k1**2*k2**2*(-10*Pk2*b2*fd*k2**2*(38*r**2 + r*(76*s - 45) + 38*s**2 - 45*s + 13) + b1**2*fd*k2**2*(5*Pk2*(33*r + 33*s - 23) + Pkd2*k2*s*(52*r + 52*s - 19)) - 2*b1*(fd*(k1**2*(Pk2*(2*K*(10*r**2 - 14*r - 10*s**2 + 17*s - 6) - 70*r**2 - 120*r*s + 123*r - 50*s**2 + 85*s - 30) + Pkd2*k2*(2*K - 1)*(2*s - 1)*(5*r + 5*s - 6)) + k2**2*(Pk2*(-8*C*(6*r**2 + 16*r*(s - 1) + 10*s**2 - 18*s + 9) + K*(150*r**2 + 7*r*(68*s - 41) + 326*s**2 - 361*s + 99) + 224*r**2 + 336*r*s - 205*r + 112*s**2 - 156*s + 65) + Pkd2*k2*(K*(r*(17 - 48*s) - 48*s**2 + 34*s - 5) + (s*(8*C + 8) - 7)*(4*r + 4*s - 2)))) + 7*k2**2*(Pk2*bd1*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + 4*Pk2*gd2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*bd1*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3)) - 4*Pkd2*gd2*k2*s*(2*r + 2*s - 1))) + 56*bd1*g2*k2**2*(Pk2*(-3*r**2 + r*(4 - 8*s) - s*(5*s - 5)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 4*fd*g2*(2*k1**2*(Pk2*(10*r**2 - 14*r - 10*s**2 + 17*s - 6) + Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6)) + k2**2*(Pk2*(150*r**2 + 7*r*(68*s - 41) + 326*s**2 - 361*s + 99) + Pkd2*k2*(r*(17 - 48*s) - 48*s**2 + 34*s - 5))))) + Dd*f*(-1386*b1*k1**2*k2**4*(-Pk2*b1*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15) + Pkd2*b1*k2*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 4*g2*(Pk2*(12*r**2 + r*(32*s - 30) + 20*s**2 - 33*s + 15) + Pkd2*k2*(-8*r*s + r + s*(4 - 8*s)))) + f**3*k1**2*(1760*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(2264*s - 753) + 2264*s**2 - 2660*s + 617) + 33*k1**2*k2**2*(4*Pk2*(132*r**2 - 22*r*(24*s + 1) - 660*s**2 + 537*s - 49) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 33*f**2*k2**2*(Pk2*k2**4*(16*C - 8)*(24*r**2 - 9*r*(4*s + 3) + 32*s + 4) + 2*k1**4*(Pk2*b1*(780*r**2 + 3*r*(488*s - 363) + 684*s**2 - 953*s + 362) + 3*Pk2*(-4*C*(12*r**2 - 2*r*(16*s + 3) - 20*s**2 + 37*s - 4) + 88*r**2 + 4*r*(6*s - 23) - 16*s**2 + 28*s + 15) + Pkd2*b1*k2*(12*r*(4*s - 9) + 48*s**2 - 176*s + 89) - 3*Pkd2*k2*(C*(r*(96*s - 26) + 48*s**2 - 96*s + 22) + r*(17 - 60*s) - 36*s**2 + 61*s - 14)) - k1**2*k2**2*(Pk2*(4*C*(684*r**2 + 3192*r*s - 999*r + 780*s**2 - 2177*s + 425) + 3*b1*(644*r**2 + r*(824*s - 781) + 180*s**2 - 511*s + 243) - 1176*r**2 - 6192*r*s + 1768*r - 1560*s**2 + 4318*s - 798) + 3*Pkd2*k2*(8*C*(28*r*s - 9*r + 16*s**2 - 28*s + 7) + 5*b1*(r*(40*s - 13) + 40*s**2 - 40*s + 9) - 80*r*s + 24*r - 32*s**2 + 80*s - 20))) + 99*f*k1**2*k2**2*(-10*Pk2*b2*k2**2*(76*r**2 + r*(152*s - 109) + 76*s**2 - 109*s + 39) + b1**2*k2**2*(50*Pk2*(4*r + 4*s - 3) + Pkd2*k2*(13*r*(8*s - 1) + 104*s**2 - 64*s + 3)) - 2*b1*(k1**2*(Pk2*(2*K*(20*r**2 - 24*r - 20*s**2 + 57*s - 6) - 140*r**2 - 240*r*s + 265*r - 100*s**2 + 163*s - 102) + Pkd2*k2*(2*K - 1)*(r*(20*s - 11) + 20*s**2 - 41*s + 12)) + k2**2*(Pk2*(-4*C*(24*r**2 + r*(64*s - 52) + 40*s**2 - 62*s + 25) + K*(300*r**2 + 952*r*s - 563*r + 652*s**2 - 713*s + 225) + 448*r**2 + 672*r*s - 527*r + 224*s**2 - 422*s + 159) + Pkd2*k2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) - 3*K*(32*r*s - 5*r + 32*s**2 - 18*s + 1) + 64*r*s - 36*r + 64*s**2 - 76*s + 25))) + 4*g2*(2*k1**2*(Pk2*(20*r**2 - 24*r - 20*s**2 + 57*s - 6) + Pkd2*k2*(20*r*s - 11*r + 20*s**2 - 41*s + 12)) + k2**2*(Pk2*(300*r**2 + 952*r*s - 563*r + 652*s**2 - 713*s + 225) - 3*Pkd2*k2*(32*r*s - 5*r + 32*s**2 - 18*s + 1))))))/(3465*d**2*k1*k2*k3**5) - D1**3*Pkd3*ct*st**2*(3*D1*bd1*f*(f**2*k1**2*(48*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + k1**4*(4*Pk2*(15*r**2 + 9*r*s - 28*r - 6*s**2 - 7*s + 9) + Pkd2*k2*(42*r*s + 31*r + 42*s**2 - 11*s - 23)) + 3*k1**2*k2**2*(Pk2*(270*r**2 + 588*r*s - 431*r + 318*s**2 - 475*s + 129) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + f*(-2*Pk2*k1**6*(2*K*(r*(2*s + 3) + 2*s**2 + 5*s - 3) - 5*r**2 - 2*r*(7*s + 8) - 9*s**2 - 20*s + 21) + Pk2*k2**6*(4 - 8*C)*(15*r**2 - r*(27*s + 8) + 12*s - 12) - k1**4*k2**2*(5*Pk2*b1*(68*r**2 + r*(136*s - 95) + 68*s**2 - 95*s + 27) - 2*Pk2*(4*C*(20*r**2 - 2*r*(92*s + 19) + 6*s**2 + 88*s + 11) - K*(149*r**2 + 266*r*s - 44*r + 117*s**2 + 50*s - 105) + 122*r**2 + 690*r*s - 162*r + 148*s**2 - 388*s + 68) + Pkd2*b1*k2*(3*r*(64*s + 5) + 192*s**2 - 157*s - 25) + 2*Pkd2*k2*(-2*C*(r*(58*s - 15) + 30*s**2 - 41*s + 11) + K*(69*r*s - 33*r + 69*s**2 - 90*s + 33) + 38*r*s + 9*r + 10*s**2 + 5*s - 15)) + k1**2*k2**4*(7*Pk2*b1*(72*r**2 + r*(96*s - 121) + 24*s**2 - 73*s + 49) + 2*Pk2*(2*C*(119*r**2 + r*(776*s - 429) + 209*s**2 - 367*s + 298) - 7*K*(151*r**2 + 298*r*s - 234*r + 147*s**2 - 218*s + 83) + 118*r**2 - 414*r*s + 126*r - 84*s**2 + 204*s - 232) + 21*Pkd2*b1*k2*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) + 2*Pkd2*k2*(C*(r*(62*s - 24) + 6*s**2 - 32*s + 26) - 21*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) - 17*r*s + 5*r + 11*s**2 + 2*s - 13))) + 7*k1**2*k2**2*(5*Pk2*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 20*Pk2*b2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*b1*(k1**2*(Pk2*(2*K*(8*r**2 + 16*r*s - 8*r + 8*s**2 - 18*s + 5) + 4*r**2 + 8*r*s - 9*r + 4*s**2 + 11*s - 5) + Pkd2*k2*(2 - 4*K)*(r*(s + 1) + s*(s - 2))) + k2**2*(Pk2*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - K*(42*r**2 + 128*r*s - 103*r + 86*s**2 - 115*s + 45) - 84*r**2 - 132*r*s + 60*r - 48*s**2 + 52*s + 10) + Pkd2*k2*(r*(K*(34*s - 11) - 20*s + 5) + s*(K*(34*s - 23) - 20*s + 15)))) + 4*g2*(2*k1**2*(Pk2*(4*r**2 + 8*r*s + r + s*(4*s - 4)) - Pkd2*k2*(r*(s + 2) + s*(s - 1))) + k2**2*(Pk2*(-21*r**2 + r*(37 - 64*s) - s*(43*s - 43)) + Pkd2*k2*(r*(17*s - 11) + s*(17*s - 17)))))) + 105*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(Pk2*(28*K*(4*r**2 + 8*r*s - 10*r + 4*s**2 - 10*s + 5) + 5*f*(68*r**2 + r*(136*s - 103) + 68*s**2 - 103*s + 45) + 28*r**2 + 56*r*s + 140*r + 28*s**2 + 140*s - 70) + Pkd2*k2*s*(f*(192*r + 192*s - 61) + (14 - 28*K)*(r + s))) - 7*k2**2*(Pk2*(-40*C*(r + s - 1)**2 + 2*K*(21*r**2 + 64*r*s - 90*r + 43*s**2 - 90*s + 45) + f*(72*r**2 + r*(96*s + 5) + 24*s**2 + 29*s - 43) + 84*r**2 + 132*r*s + 40*r + 48*s**2 + 40*s - 20) + Pkd2*k2*s*(3*f*(12*r + 12*s - 5) + (20 - 34*K)*(r + s)))) + Dd*f*(k1**2*(2*Pk2*(7*K*(32*r**2 + 64*r*s - 54*r + 32*s**2 - 84*s + 30) + 5*f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 36) + 56*r**2 + 112*r*s + 28*r + 56*s**2 + 238*s - 105) + Pkd2*k2*(f*(3*r*(128*s + 5) + 384*s**2 - 218*s - 25) + (14 - 28*K)*(r*(4*s + 2) + s*(4*s - 7)))) - 7*k2**2*(-2*Pk2*(20*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 84*K*r**2 - 256*K*r*s + 259*K*r - 172*K*s**2 + 277*K*s - 135*K - f*(72*r**2 + 96*r*s - 58*r + 24*s**2 - 22*s + 3) - 168*r**2 - 264*r*s + 72*r - 96*s**2 + 60*s + 30) + Pkd2*k2*(f*(9*r*(8*s - 1) + 72*s**2 - 48*s + 3) + 2*r*(-68*K*s + 11*K + 40*s - 5) + 2*s*(-68*K*s + 29*K + 40*s - 20))))) + 3*b1*(D1*(f**2*fd*k1**2*(48*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + k1**4*(6*Pk2*(30*r**2 + r*(18*s - 41) - 12*s**2 - 16*s + 17) + Pkd2*k2*(18*r*(7*s + 1) + 126*s**2 - 57*s - 16)) + 3*k1**2*k2**2*(Pk2*(810*r**2 + 9*r*(196*s - 131) + 954*s**2 - 1263*s + 467) + 3*Pkd2*k2*(3*r*(8*s - 15) + 24*s**2 - 67*s + 31))) - 2*f*(fd*(Pk2*k1**6*(2*K*(r*(4*s + 5) + 4*s**2 + 10*s - 6) - 10*r**2 - 7*r*(4*s + 5) - 18*s**2 - 45*s + 27) + Pk2*k2**6*(4*C - 2)*(30*r**2 - 3*r*(18*s + 17) + 41*s + 18) + k1**4*k2**2*(Pk2*(-4*C*(40*r**2 + r*(62 - 368*s) + 12*s**2 + 286*s - 91) + K*(298*r**2 + 532*r*s + 63*r + 234*s**2 + 221*s - 169) - 244*r**2 - 1380*r*s + 492*r - 296*s**2 + 875*s - 251) + Pkd2*k2*(3*K*(23*s - 15)*(2*r + 2*s - 1) + r*s*(76 - 232*C) + 49*r - s**2*(120*C - 20) + s*(130*C + 18) - 28)) + k1**2*k2**4*(Pk2*(-4*C*(119*r**2 + r*(776*s - 9) + 209*s**2 - 460*s - 44) + 7*K*(302*r**2 + 596*r*s - 325*r + 294*s**2 - 305*s + 79) - 236*r**2 + 828*r*s + 323*r + 168*s**2 - 754*s - 105) + Pkd2*k2*(21*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) - 2*s*(C*(62*r + 6*s - 45) - 17*r + 11*s + 19)))) + 14*k1**2*k2**2*(-5*Pk2*bd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-2*k1**2*(Pk2*(4*r**2 + 8*r*s - 9*r + 4*s**2 - 14*s + 5) - Pkd2*k2*s*(r + s - 3)) + k2**2*(Pk2*(21*r**2 + 64*r*s - 66*r + 43*s**2 - 72*s + 45) + Pkd2*k2*s*(-17*r - 17*s + 6))))) + 28*fd*k1**2*k2**2*(5*Pk2*b2*k2**2*(r + s)**2 + 2*g2*k1**2*(Pk2*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) - Pkd2*k2*s*(r + s)) + g2*k2**2*(-Pk2*(21*r**2 + r*(64*s - 90) + 43*s**2 - 90*s + 45) + 17*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(48*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + k1**4*(2*Pk2*(120*r**2 + r*(72*s - 179) - 48*s**2 - 62*s + 69) + Pkd2*k2*(7*r*(24*s + 7) + 168*s**2 - 68*s - 39)) + 6*k1**2*k2**2*(Pk2*(540*r**2 + 7*r*(168*s - 115) + 636*s**2 - 869*s + 298) + 3*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) - 2*f*(Pk2*k1**6*(2*K*(8*r*s + 11*r + 8*s**2 + 20*s - 12) - 20*r**2 - r*(56*s + 67) - 36*s**2 - 85*s + 69) + Pk2*k2**6*(8*C - 4)*(30*r**2 - 2*r*(27*s + 23) + 41*s + 12) + k1**4*k2**2*(Pk2*(-4*C*(80*r**2 - r*(736*s + 5) + 24*s**2 + 576*s - 71) + K*(596*r**2 + 1064*r*s - 25*r + 468*s**2 + 321*s - 379) - 488*r**2 - 2760*r*s + 857*r - 592*s**2 + 1902*s - 400) + Pkd2*k2*(C*(r*(30 - 464*s) - 240*s**2 + 320*s - 22) + 3*K*(92*r*s - 52*r + 92*s**2 - 113*s + 37) + 152*r*s + 79*r + 40*s**2 + 12*s - 64)) + k1**2*k2**4*(Pk2*(-2*C*(476*r**2 + r*(3104*s - 553) + 836*s**2 - 1919*s + 197) + 7*K*(604*r**2 + 1192*r*s - 793*r + 588*s**2 - 741*s + 245) - 472*r**2 + 1656*r*s + 387*r + 336*s**2 - 1434*s + 55) + Pkd2*k2*(-2*C*(4*r*(31*s - 3) + 12*s**2 - 93*s + 13) + 21*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) + 68*r*s - 5*r - 44*s**2 - 65*s + 13))) - 28*k1**2*k2**2*(-5*Pk2*b2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(-2*Pk2*(16*r**2 + r*(32*s - 27) + 16*s**2 - 42*s + 15) + 2*Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + k2**2*(Pk2*(84*r**2 + r*(256*s - 259) + 172*s**2 - 277*s + 135) + Pkd2*k2*(r*(11 - 68*s) + s*(29 - 68*s))))))) + f*(D1*(-3*f**2*fd*k1**4*(24*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(100*r**2 - 40*r*s - 33*r - 140*s**2 + 165*s - 36) + 5*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*fd*(Pk2*k1**6*(4*C*(6*r*(3*s + 2) + 18*s**2 + 9*s - 11) - 45*r**2 - 3*r*(54*s + 11) - 117*s**2 - 21*s + 54) + Pk2*k2**6*(36*C - 18)*(3*r - 1)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(2*C*(711*r**2 + 90*r*s - 117*r + 459*s**2 + 555*s - 286) - 1674*r**2 - 1836*r*s + 1179*r - 1242*s**2 + 432*s - 9) + 3*Pkd2*k2*(2*C*(27*s - 17)*(3*r + 3*s - 2) - 126*r*s + 81*r - 126*s**2 + 168*s - 55)) + 9*k1**2*k2**4*(Pk2*(2*C*(495*r**2 + 756*r*s - 577*r + 381*s**2 - 441*s + 158) - 585*r**2 - 888*r*s + 666*r - 423*s**2 + 491*s - 175) + Pkd2*k2*(24*C - 12)*(2*s - 1)*(3*r + 3*s - 2))) + 6*f*k1**2*(-5*Pk2*bd2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 2*gd2*(2*Pk2*k1**4*(r*(2*s + 3) + 2*s**2 + 5*s - 3) + k1**2*k2**2*(Pk2*(149*r**2 + 266*r*s - 44*r + 117*s**2 + 50*s - 105) + 3*Pkd2*k2*(23*r*s - 11*r + 23*s**2 - 30*s + 11)) + 7*k2**4*(Pk2*(151*r**2 + 298*r*s - 234*r + 147*s**2 - 218*s + 83) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3)))) + 6*fd*k1**2*(-5*Pk2*b2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + 2*g2*(2*Pk2*k1**4*(r*(4*s + 5) + 4*s**2 + 10*s - 6) + k1**2*k2**2*(Pk2*(298*r**2 + 532*r*s + 63*r + 234*s**2 + 221*s - 169) + 3*Pkd2*k2*(23*s - 15)*(2*r + 2*s - 1)) + 7*k2**4*(Pk2*(302*r**2 + 596*r*s - 325*r + 294*s**2 - 305*s + 79) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-3*f**2*k1**4*(24*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(100*r**2 - 40*r*s - 33*r - 140*s**2 + 165*s - 36) + 5*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(Pk2*k1**6*(C*(96*r*s + 68*r + 96*s**2 + 48*s - 64) - 60*r**2 - r*(216*s + 43) - 156*s**2 - 23*s + 79) + Pk2*k2**6*(72*C - 36)*(2*r - 1)*(2*r + 2*s - 1) + k1**4*k2**2*(Pk2*(2*C*(948*r**2 + 15*r*(8*s - 23) + 612*s**2 + 709*s - 295) - 2232*r**2 - 3*r*(816*s - 625) - 1656*s**2 + 708*s - 147) + 3*Pkd2*k2*(2*C*(108*r*s - 64*r + 108*s**2 - 141*s + 47) - 168*r*s + 103*r - 168*s**2 + 228*s - 77)) + 9*k1**2*k2**4*(Pk2*(2*C*(660*r**2 + r*(1008*s - 839) + 508*s**2 - 633*s + 255) - 780*r**2 + r*(968 - 1184*s) - 564*s**2 + 705*s - 282) + Pkd2*k2*(6*C - 3)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 6*k1**2*(-5*Pk2*b2*k2**2*(5*k1**2*(r + s + 3) + 21*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 2*g2*(2*Pk2*k1**4*(8*r*s + 11*r + 8*s**2 + 20*s - 12) + k1**2*k2**2*(Pk2*(596*r**2 + 1064*r*s - 25*r + 468*s**2 + 321*s - 379) + 3*Pkd2*k2*(92*r*s - 52*r + 92*s**2 - 113*s + 37)) + 7*k2**4*(Pk2*(604*r**2 + 1192*r*s - 793*r + 588*s**2 - 741*s + 245) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(315*d**2*k1*k2*k3**5) + D1**3*Pkd3*ct*(D1*bd1*f*(3*f**2*k1**4*(12*Pk2*k2**2*(8*r**2 + r*(8*s - 9) - 3*s + 1) + k1**2*(2*Pk2*(50*r**2 + 70*r*s - 87*r + 20*s**2 - 57*s + 33) + 5*Pkd2*k2*(6*s + 1)*(r + s - 1))) - f*(Pk2*k2**6*r*(28 - 56*C)*(r + s) + 12*k1**6*(Pk2*(-4*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 20*b1*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 10*r**2 + 36*r*s - 23*r + 26*s**2 - 35*s + 9) + Pkd2*b1*k2*(r*(8*s - 2) + 8*s**2 - 8*s + 1)) + k1**4*k2**2*(7*Pk2*b1*(492*r**2 + r*(888*s - 733) + 396*s**2 - 669*s + 257) - 2*Pk2*(4*C*(285*r**2 + r*(550*s - 421) + 321*s**2 - 434*s + 113) + 7*K*(21*r**2 + 62*r*s - 42*r + 41*s**2 - 58*s + 21) - 882*r**2 - 1764*r*s + 1274*r - 994*s**2 + 1302*s - 308) + 21*Pkd2*b1*k2*(3*r*(8*s - 1) + 24*s**2 - 23*s + 1) - 6*Pkd2*k2*(C*(r*(44*s - 8) + 44*s**2 - 48*s + 4) + 7*K*(s - 1)*(r + s - 1) - 29*r*s + 4*r - 29*s**2 + 31*s - 2)) - 2*k1**2*k2**4*(-2*Pk2*(-C*(591*r**2 + 976*r*s - 633*r + 497*s**2 - 573*s + 76) - 28*K*r**2 - 112*K*r*s + 56*K*r - 84*K*s**2 + 84*K*s - 28*K + 14*b1*(12*r**2 + r*(18*s - 13) + 6*s**2 - 11*s + 3) + 348*r**2 + 565*r*s - 362*r + 273*s**2 - 311*s + 38) + Pkd2*k2*(42*C - 21)*(r*(3*s - 1) + s*(3*s - 3)))) + 7*k1**2*(5*Pk2*b1**2*k2**2*(12*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 20*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(-4*Pk2*k1**4*(5*r**2 + r*(-4*K*s + K + 14*s - 6) + s*(K*(3 - 4*s) + 9*s - 8)) + 2*k1**2*k2**2*(-Pk2*(20*C*(2*r**2 + r*(2 - 16*s) + 2*s**2 + 7*s - 4) - 122*K*s**2 + 111*K*s + r**2*(29 - 98*K) + r*(-220*K*s + 109*K + 266*s - 71) + 37*s**2 - 115*s + 35) + Pkd2*k2*(K*r*(14*s - 1) + K*s*(14*s - 13) - 5*s*(r + s - 1))) + 5*k2**4*(K*Pkd2*k2*(r*(6*s - 1) + s*(6*s - 5)) + Pk2*(-4*C*(4*r**2 - r*(12*s + 1) + 4*s**2 + 4*s - 3) + K*(46*r**2 + 96*r*s - 43*r + 50*s**2 - 43*s - 5) - 2*r**2 - 40*r*s + 8*r + 2*s**2 + 14*s - 6))) - 4*g2*(4*Pk2*k1**4*(r*(2*s - 1) + s*(2*s - 2)) + 2*k1**2*k2**2*(Pk2*(49*r**2 + 10*r*(11*s - 6) + s*(61*s - 61)) + Pkd2*k2*(r*(7*s - 1) + s*(7*s - 7))) + 5*k2**4*(Pk2*(23*r**2 + r*(48*s - 25) + s*(25*s - 25)) + Pkd2*k2*(r*(3*s - 1) + s*(3*s - 3)))))) + 35*Pk2*b1**3*k1**2*k2**2*(12*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - b1**2*k1**2*(D1*fd*(28*Pk2*k1**4*(r + s)*(5*r + s*(9 - 4*K)) + f*(112*Pk2*k2**4*(6*r**2 + r*(9*s - 5) + 3*s**2 - 4*s + 1) + 12*k1**4*(5*Pk2*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 4*Pkd2*k2*s*(2*r + 2*s - 1)) + 7*k1**2*k2**2*(Pk2*(492*r**2 + 888*r*s - 541*r + 396*s**2 - 501*s + 155) + 3*Pkd2*k2*s*(24*r + 24*s - 11))) - 14*k1**2*k2**2*(Pk2*(-40*C*(r**2 - 2*r*(4*s + 1) + s**2 + 8*s + 1) + 122*K*s**2 + r**2*(98*K - 29) + r*(220*K*s - 266*s - 60) - 37*s**2 + 140*s + 30) + Pkd2*k2*s*(14*K - 5)*(r + s)) - 70*k2**4*(3*K*Pkd2*k2*s*(r + s) + Pk2*(-8*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + K*(23*r**2 + 48*r*s + 10*r + 25*s**2 + 10*s - 5) - r**2 - 20*r*s - 8*r + s**2 + 12*s + 4))) + Dd*f*(28*Pk2*k1**4*(20*r**2 + r*(K*(2 - 16*s) + 56*s - 17) + s*(K*(8 - 16*s) + 36*s - 23)) + f*(56*Pk2*k2**4*(24*r**2 + r*(36*s - 23) + 12*s**2 - 19*s + 5) + 12*k1**4*(5*Pk2*(4*r + 4*s - 3)**2 + Pkd2*k2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 7*k1**2*k2**2*(2*Pk2*(492*r**2 + r*(888*s - 637) + 396*s**2 - 585*s + 206) + 3*Pkd2*k2*(r*(48*s - 3) + 48*s**2 - 34*s + 1))) + 14*k1**2*k2**2*(Pk2*(40*C*(4*r**2 - 2*r*(16*s + 1) + 4*s**2 + 23*s - 2) - 488*K*s**2 + 322*K*s - r**2*(392*K - 116) + r*(-880*K*s + 316*K + 1064*s - 81) + 148*s**2 - 563*s + 10) + Pkd2*k2*(K*r*(2 - 56*s) + 2*K*s*(19 - 28*s) + 5*s*(4*r + 4*s - 3))) + 70*k2**4*(K*Pkd2*k2*(-12*r*s + r + s*(7 - 12*s)) + Pk2*(4*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) + K*(-92*r**2 - 192*r*s + 51*r - 100*s**2 + 51*s + 15) + 4*r**2 + 80*r*s + 3*r - 4*s**2 - 41*s - 2)))) + b1*(D1*(3*f**2*fd*k1**4*(12*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 5*s + 5) + k1**2*(2*Pk2*(150*r**2 + 6*r*(35*s - 31) + 60*s**2 - 121*s + 58) + 5*Pkd2*k2*(6*r*(3*s + 1) + 18*s**2 - 7*s - 4))) + 2*f*(fd*(-6*Pk2*k1**6*(2*r + 2*s - 1)*(10*r + s*(26 - 16*C) - 5) + Pk2*k2**6*(28*C - 14)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(4*C*(570*r**2 + r*(1100*s - 549) + 642*s**2 - 487*s + 132) + 7*K*(42*r**2 + 124*r*s - 83*r + 82*s**2 - 115*s + 37) - 1764*r**2 - 3528*r*s + 1603*r - 1988*s**2 + 1540*s - 385) + 3*Pkd2*k2*(7*K*(s - 1) + s*(44*C - 29))*(2*r + 2*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(591*r**2 + r*(976*s - 290) + 497*s**2 - 166*s - 29) + 56*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 1392*r**2 - 2260*r*s + 685*r - 1092*s**2 + 395*s + 58) + Pkd2*k2*s*(84*C - 42)*(3*r + 3*s - 1))) - 14*k1**2*(-5*Pk2*bd2*k2**2*(4*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(4*Pk2*k1**4*s*(2*r + 2*s - 1) + 2*Pk2*k1**2*k2**2*(49*r**2 + r*(110*s - 49) + s*(61*s - 50)) + 5*Pk2*k2**4*(23*r**2 + 6*r*(8*s - 3) + 25*s**2 - 18*s - 5) + 2*Pkd2*k1**2*k2**3*s*(7*r + 7*s - 6) + 5*Pkd2*k2**5*s*(3*r + 3*s - 2)))) - 28*fd*k1**2*(-5*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(r + s)**2 + g2*(8*Pk2*k1**4*s*(r + s) + 2*Pk2*k1**2*k2**2*(49*r**2 + 110*r*s + 61*s**2) + 5*Pk2*k2**4*(23*r**2 + 48*r*s + 10*r + 25*s**2 + 10*s - 5) + 14*Pkd2*k1**2*k2**3*s*(r + s) + 15*Pkd2*k2**5*s*(r + s)))) + Dd*f*(3*f**2*k1**4*(24*Pk2*k2**2*(4*r - 1)*(4*r + 4*s - 3) + k1**2*(2*Pk2*(200*r**2 + 7*r*(40*s - 39) + 80*s**2 - 178*s + 91) + 5*Pkd2*k2*(r*(24*s + 7) + 24*s**2 - 12*s - 5))) + 2*f*(6*Pk2*k1**6*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) - 40*r**2 + r*(58 - 144*s) - 104*s**2 + 98*s - 19) + Pk2*k2**6*(56*C - 28)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(4*C*(1140*r**2 + r*(2200*s - 1387) + 1284*s**2 - 1295*s + 377) + 7*K*(84*r**2 + 248*r*s - 167*r + 164*s**2 - 231*s + 79) - 3528*r**2 - 7056*r*s + 4095*r - 3976*s**2 + 3976*s - 1029) + 3*Pkd2*k2*(4*C*(r*(44*s - 2) + 44*s**2 - 33*s + 1) + 7*K*(s - 1)*(4*r + 4*s - 3) - 116*r*s + 4*r - 116*s**2 + 87*s - 2)) + k1**2*k2**4*(Pk2*(2*C*(2364*r**2 + r*(3904*s - 1851) + 1988*s**2 - 1371*s + 65) + 56*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) - 2784*r**2 - 4520*r*s + 2152*r - 2184*s**2 + 1546*s - 65) + Pkd2*k2*(42*C - 21)*(r*(12*s - 1) + s*(12*s - 7)))) + 28*k1**2*(5*Pk2*b2*k2**2*(4*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(4*Pk2*k1**4*(-8*r*s + r + s*(4 - 8*s)) - 2*Pk2*k1**2*k2**2*(196*r**2 + 2*r*(220*s - 79) + s*(244*s - 161)) - 5*Pk2*k2**4*(92*r**2 + 3*r*(64*s - 17) + 100*s**2 - 51*s - 15) + 2*Pkd2*k1**2*k2**3*(-28*r*s + r + s*(19 - 28*s)) + 5*Pkd2*k2**5*(-12*r*s + r + s*(7 - 12*s)))))) + 2*f*k1**2*(D1*(40*Pk2*f**2*fd*k1**4*(4*s - 1)*(r + s - 1) + f*k2**2*(105*Pk2*bd2*k1**2*(r + s - 1)**2 + 3*fd*(Pk2*k2**2*(4*C - 2)*(21*r**2 + r*(75*s - 46) + 54*s**2 - 61*s + 19) + k1**2*(Pk2*(2*C*(105*r**2 + 9*r*(34*s - 23) + 201*s**2 - 291*s + 98) - 120*r**2 - 354*r*s + 228*r - 234*s**2 + 335*s - 109) + Pkd2*k2*(10*C - 5)*(s - 1)*(3*r + 3*s - 2))) - 14*gd2*(8*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + k1**2*(Pk2*(21*r**2 + 62*r*s - 42*r + 41*s**2 - 58*s + 21) + 3*Pkd2*k2*(s - 1)*(r + s - 1)))) - 7*fd*k2**2*(-15*Pk2*b2*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*g2*(8*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(Pk2*(42*r**2 + 124*r*s - 83*r + 82*s**2 - 115*s + 37) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))))) + Dd*f*(40*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + 3*f*k2**2*(Pk2*k2**2*(8*C - 4)*(14*r**2 + 10*r*(5*s - 3) + 36*s**2 - 40*s + 13) + k1**2*(Pk2*(C*(280*r**2 + 816*r*s - 554*r + 536*s**2 - 778*s + 266) - 160*r**2 - 472*r*s + 303*r - 312*s**2 + 444*s - 144) + Pkd2*k2*(10*C - 5)*(s - 1)*(4*r + 4*s - 3))) - 7*k2**2*(-15*Pk2*b2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*g2*(8*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(Pk2*(84*r**2 + 248*r*s - 167*r + 164*s**2 - 231*s + 79) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(105*d**2*k1*k2*k3**5) - 4*D1**3*Pkd3*f**3*k1**2*k2**2*st**8*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(99*d**2*k3**5) + D1**3*Pkd3*f*st**6*(D1*bd1*f*(f*(18*Pk2*k2**2*(r - 1)*(r + s - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(39*s - 8) + 39*s**2 - 35*s + 6)) + 18*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) + b1*(3*D1*fd*(f*(6*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(13*r + 13*s - 9)) + 12*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1)) + Dd*f*(f*(18*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(156*s - 47) + 156*s**2 - 155*s + 33)) + 36*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1)))) + 2*k2**2*(-72*C*D1*Pk2*f*fd*r*s + 24*C*D1*Pk2*f*fd*r - 72*C*D1*Pk2*f*fd*s**2 + 72*C*D1*Pk2*f*fd*s - 16*C*D1*Pk2*f*fd + 36*C*D1*Pkd2*f*fd*k2*r*s - 12*C*D1*Pkd2*f*fd*k2*r + 36*C*D1*Pkd2*f*fd*k2*s**2 - 36*C*D1*Pkd2*f*fd*k2*s + 8*C*D1*Pkd2*f*fd*k2 - 96*C*Dd*Pk2*f**2*r*s + 28*C*Dd*Pk2*f**2*r - 96*C*Dd*Pk2*f**2*s**2 + 96*C*Dd*Pk2*f**2*s - 20*C*Dd*Pk2*f**2 + 48*C*Dd*Pkd2*f**2*k2*r*s - 14*C*Dd*Pkd2*f**2*k2*r + 48*C*Dd*Pkd2*f**2*k2*s**2 - 48*C*Dd*Pkd2*f**2*k2*s + 10*C*Dd*Pkd2*f**2*k2 - 18*D1*Pk2*f*fd*r**2 + 18*D1*Pk2*f*fd*r*s + 6*D1*Pk2*f*fd*r + 36*D1*Pk2*f*fd*s**2 - 30*D1*Pk2*f*fd*s + 4*D1*Pk2*f*fd + 144*D1*Pk2*f*gd2*r*s - 36*D1*Pk2*f*gd2*r + 144*D1*Pk2*f*gd2*s**2 - 144*D1*Pk2*f*gd2*s + 36*D1*Pk2*f*gd2 + 288*D1*Pk2*fd*g2*r*s - 144*D1*Pk2*fd*g2*r + 288*D1*Pk2*fd*g2*s**2 - 288*D1*Pk2*fd*g2*s + 72*D1*Pk2*fd*g2 - 18*D1*Pkd2*f*fd*k2*r*s + 6*D1*Pkd2*f*fd*k2*r - 18*D1*Pkd2*f*fd*k2*s**2 + 18*D1*Pkd2*f*fd*k2*s - 4*D1*Pkd2*f*fd*k2 - 72*D1*Pkd2*f*gd2*k2*r*s + 18*D1*Pkd2*f*gd2*k2*r - 72*D1*Pkd2*f*gd2*k2*s**2 + 72*D1*Pkd2*f*gd2*k2*s - 18*D1*Pkd2*f*gd2*k2 - 144*D1*Pkd2*fd*g2*k2*r*s + 72*D1*Pkd2*fd*g2*k2*r - 144*D1*Pkd2*fd*g2*k2*s**2 + 144*D1*Pkd2*fd*g2*k2*s - 36*D1*Pkd2*fd*g2*k2 - 9*D1*bd2*f*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) - 24*Dd*Pk2*f**2*r**2 + 24*Dd*Pk2*f**2*r*s + 13*Dd*Pk2*f**2*r + 48*Dd*Pk2*f**2*s**2 - 38*Dd*Pk2*f**2*s + 3*Dd*Pk2*f**2 + 576*Dd*Pk2*f*g2*r*s - 216*Dd*Pk2*f*g2*r + 576*Dd*Pk2*f*g2*s**2 - 576*Dd*Pk2*f*g2*s + 144*Dd*Pk2*f*g2 - 24*Dd*Pkd2*f**2*k2*r*s + 7*Dd*Pkd2*f**2*k2*r - 24*Dd*Pkd2*f**2*k2*s**2 + 24*Dd*Pkd2*f**2*k2*s - 5*Dd*Pkd2*f**2*k2 - 288*Dd*Pkd2*f*g2*k2*r*s + 108*Dd*Pkd2*f*g2*k2*r - 288*Dd*Pkd2*f*g2*k2*s**2 + 288*Dd*Pkd2*f*g2*k2*s - 72*Dd*Pkd2*f*g2*k2 - 18*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))/(63*d**2*k3**3) + D1**3*Pkd3*f*st**6*(D1*(f**2*(-198*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) + 11*bd1*k1**2*k2**2*(Pk2*(105*r**2 + 4*r*(39*s - 34) + 51*s**2 - 94*s + 27) + Pkd2*k2*(r*(27*s - 2) + 27*s**2 - 23*s + 4)) + fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(189*r + 189*s - 139) + 22*fd*k1**2*k2**2*(Pk2*(16*r**2 - r*(80*s + 17) - 96*s**2 + 78*s + 1) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 11*f*k2**2*(b1*fd*(-18*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(3*Pk2*(105*r**2 + 156*r*s - 119*r + 51*s**2 - 89*s + 38) + Pkd2*k2*(81*r*s - 39*r + 81*s**2 - 84*s + 23))) - 2*k2**2*(162*C*Pk2*fd*r**2 + 252*C*Pk2*fd*r*s - 192*C*Pk2*fd*r + 90*C*Pk2*fd*s**2 - 144*C*Pk2*fd*s + 56*C*Pk2*fd + 36*C*Pkd2*fd*k2*r*s - 12*C*Pkd2*fd*k2*r + 36*C*Pkd2*fd*k2*s**2 - 36*C*Pkd2*fd*k2*s + 8*C*Pkd2*fd*k2 + 45*Pk2*bd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 99*Pk2*fd*r**2 - 144*Pk2*fd*r*s + 114*Pk2*fd*r - 45*Pk2*fd*s**2 + 78*Pk2*fd*s - 32*Pk2*fd - 324*Pk2*gd2*r**2 - 504*Pk2*gd2*r*s + 450*Pk2*gd2*r - 180*Pk2*gd2*s**2 + 342*Pk2*gd2*s - 126*Pk2*gd2 - 18*Pkd2*fd*k2*r*s + 6*Pkd2*fd*k2*r - 18*Pkd2*fd*k2*s**2 + 18*Pkd2*fd*k2*s - 4*Pkd2*fd*k2 - 72*Pkd2*gd2*k2*r*s + 18*Pkd2*gd2*k2*r - 72*Pkd2*gd2*k2*s**2 + 72*Pkd2*gd2*k2*s - 18*Pkd2*gd2*k2 + 9*bd1*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)))) + 198*fd*k2**4*(2*r + 2*s - 1)*(K*Pk2*b1*(-18*r - 10*s + 5) + 2*K*Pkd2*b1*k2*(1 - 2*s) + 4*Pk2*b1*r - 5*Pk2*b2*(2*r + 2*s - 1) + 2*Pk2*g2*(18*r + 10*s - 5) + 4*Pkd2*g2*k2*(2*s - 1))) + Dd*f*(f**2*k1**2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(189*r + 189*s - 139) + 22*k2**2*(Pk2*(16*r**2 - r*(80*s + 17) - 96*s**2 + 78*s + 1) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 11*f*k2**2*(b1*(-18*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(Pk2*(420*r**2 + 624*r*s - 493*r + 204*s**2 - 361*s + 141) + Pkd2*k2*(108*r*s - 41*r + 108*s**2 - 107*s + 27))) - 2*k2**2*(Pk2*(2*C*(108*r**2 + 168*r*s - 139*r + 60*s**2 - 105*s + 44) - 132*r**2 - 192*r*s + 166*r - 60*s**2 + 115*s - 51) + Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 198*k2**4*(5*Pk2*b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + b1*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2)) - 2*g2*(Pk2*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(693*d**2*k3**5) + D1**3*Pkd3*st**4*(2*D1*bd1*f*k2**2*(-7*b2*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + f*(Pk2*(-4*r**2 + r*(-16*C*s + 4*C + 4*s + 1) + s*(-16*C*s + 12*C + 8*s - 5)) + Pkd2*k2*(2*C - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 14*g2*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + b1**2*(D1*fd*(f*(28*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)) + 28*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(s - 1) - Pk2*r))*(r + s - 1) + Dd*f*(f*(14*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 5) + 4*s**2 - 5*s + 3)) + 14*k2**2*(K*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - Pk2*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)))) + 2*b1*(D1*bd1*f*(f*(7*Pk2*k2**2*(r - 1)*(2*r + 2*s - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(s - 2) + s**2 - s + 1)) + 7*k2**2*(K*Pkd2*k2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pk2*(-2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*s + 4*r + s - 1))) + k2**2*(-32*C*D1*Pk2*f*fd*r*s + 16*C*D1*Pk2*f*fd*r - 32*C*D1*Pk2*f*fd*s**2 + 48*C*D1*Pk2*f*fd*s - 16*C*D1*Pk2*f*fd + 16*C*D1*Pkd2*f*fd*k2*r*s - 8*C*D1*Pkd2*f*fd*k2*r + 16*C*D1*Pkd2*f*fd*k2*s**2 - 24*C*D1*Pkd2*f*fd*k2*s + 8*C*D1*Pkd2*f*fd*k2 - 64*C*Dd*Pk2*f**2*r*s + 24*C*Dd*Pk2*f**2*r - 64*C*Dd*Pk2*f**2*s**2 + 80*C*Dd*Pk2*f**2*s - 20*C*Dd*Pk2*f**2 + 32*C*Dd*Pkd2*f**2*k2*r*s - 12*C*Dd*Pkd2*f**2*k2*r + 32*C*Dd*Pkd2*f**2*k2*s**2 - 40*C*Dd*Pkd2*f**2*k2*s + 10*C*Dd*Pkd2*f**2*k2 - 8*D1*Pk2*f*fd*r**2 + 8*D1*Pk2*f*fd*r*s + 4*D1*Pk2*f*fd*r + 16*D1*Pk2*f*fd*s**2 - 20*D1*Pk2*f*fd*s + 4*D1*Pk2*f*fd + 56*D1*Pk2*f*gd2*r*s - 28*D1*Pk2*f*gd2*r + 56*D1*Pk2*f*gd2*s**2 - 84*D1*Pk2*f*gd2*s + 28*D1*Pk2*f*gd2 + 56*D1*Pk2*fd*g2*r*s - 56*D1*Pk2*fd*g2*r + 56*D1*Pk2*fd*g2*s**2 - 112*D1*Pk2*fd*g2*s + 56*D1*Pk2*fd*g2 - 8*D1*Pkd2*f*fd*k2*r*s + 4*D1*Pkd2*f*fd*k2*r - 8*D1*Pkd2*f*fd*k2*s**2 + 12*D1*Pkd2*f*fd*k2*s - 4*D1*Pkd2*f*fd*k2 - 28*D1*Pkd2*f*gd2*k2*r*s + 14*D1*Pkd2*f*gd2*k2*r - 28*D1*Pkd2*f*gd2*k2*s**2 + 42*D1*Pkd2*f*gd2*k2*s - 14*D1*Pkd2*f*gd2*k2 - 28*D1*Pkd2*fd*g2*k2*r*s + 28*D1*Pkd2*fd*g2*k2*r - 28*D1*Pkd2*fd*g2*k2*s**2 + 56*D1*Pkd2*fd*g2*k2*s - 28*D1*Pkd2*fd*g2*k2 - 7*D1*bd2*f*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1) - 16*Dd*Pk2*f**2*r**2 + 16*Dd*Pk2*f**2*r*s + 10*Dd*Pk2*f**2*r + 32*Dd*Pk2*f**2*s**2 - 32*Dd*Pk2*f**2*s + 3*Dd*Pk2*f**2 + 224*Dd*Pk2*f*g2*r*s - 140*Dd*Pk2*f*g2*r + 224*Dd*Pk2*f*g2*s**2 - 336*Dd*Pk2*f*g2*s + 112*Dd*Pk2*f*g2 - 16*Dd*Pkd2*f**2*k2*r*s + 6*Dd*Pkd2*f**2*k2*r - 16*Dd*Pkd2*f**2*k2*s**2 + 20*Dd*Pkd2*f**2*k2*s - 5*Dd*Pkd2*f**2*k2 - 112*Dd*Pkd2*f*g2*k2*r*s + 70*Dd*Pkd2*f*g2*k2*r - 112*Dd*Pkd2*f*g2*k2*s**2 + 168*Dd*Pkd2*f*g2*k2*s - 56*Dd*Pkd2*f*g2*k2 - 7*b2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(8*r*s - 5*r + 8*s**2 - 12*s + 4)))))/(35*d**2*k2**2*k3) + D1**3*Pkd3*st**2*(2*D1*bd1*f*(f*(Pk2*k1**2*(r*(2*s + 3) + 2*s*(s + 1)) + k2**2*(Pk2*(4*C*r*(37*s + 9) + r**2*(38 - 48*C) - 5*r*(12*s + 5) + s*(2*C - 1)*(28*s - 43)) + Pkd2*k2*(7 - 14*C)*(r*(2*s - 1) + s*(2*s - 2)))) + k2**2*(-35*b2 + 70*g2)*(-2*Pk2*s*(r + s - 1) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 7*b1**3*(-D1*fd*(r + s - 1)*(-2*Pk2*k1**2*s + 10*Pk2*k2**2*(r - 1) + Pkd2*k1**2*k2*s) + Dd*f*(-10*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 3) + 4*s**2 - 9*s + 3))) - 7*b1**2*(D1*bd1*f*(-10*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(2*Pk2 - Pkd2*k2)*(3*r*(s - 1) + 3*s**2 - 8*s + 3)) - 2*D1*fd*(k1**2*(Pk2*(f - 2*s + 2) + Pkd2*f*k2*(3*s - 2)) + k2**2*(Pk2*(10*K*(s - 1) + f*(6*r - 3) + 8*r + 2) - 2*Pkd2*k2*(-2*C*s + 5*K*(s - 1) + s)))*(r + s - 1) - Dd*f*(k1**2*(2*Pk2*(f*(5*r + 2*s - 3) - 8*r*s + 5*r - 8*s**2 + 12*s - 4) + Pkd2*f*k2*(3*s - 2)*(4*r + 4*s - 3)) + 2*k2**2*(Pk2*(10*K*(4*s - 1)*(r + s - 1) + 6*f*(2*r - 1)*(r + s - 1) + 32*r**2 + 32*r*s - 32*r - 4*s + 5) + Pkd2*k2*(2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 5*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 8*r*s + r - 8*s**2 + 8*s - 1)))) + b1*(7*D1*bd1*f*(k1**2*(2*Pk2*(f*(4*r + s - 2) - 4*r*s + 2*r - 4*s**2 + 5*s - 1) + Pkd2*f*k2*(3*s - 2)*(2*r + 2*s - 1)) + 2*k2**2*(Pk2*(20*K*s**2 - 20*K*s + 3*f*(2*r - 1)*(r + s - 1) + 16*r**2 + r*(s*(20*K + 16) - 15) - 3*s + 4) + Pkd2*k2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 - 5*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - 4*s**2 + 4*s - 1))) + 2*D1*(f*fd*(Pk2*k1**2*(4*s + 5)*(r + s - 1) + k2**2*(-2*Pk2*(C*(48*r**2 - 148*r*s - 23*r - 56*s**2 + 151*s - 25) - 38*r**2 + 60*r*s + 29*r + 28*s**2 - 72*s + 9) + Pkd2*k2*(7 - 14*C)*(4*s - 3)*(r + s - 1))) - 35*f*k2**2*(bd2 - 2*gd2)*(-2*Pk2*s + Pkd2*k2*(2*s - 1))*(r + s - 1) - 70*fd*k2**2*(-Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(Pk2*k1**2*(8*r*s + 11*r + 8*s**2 + 4*s - 8) + k2**2*(Pk2*(2*C*(-96*r**2 + r*(296*s + 83) + 112*s**2 - 274*s + 7) + 152*r**2 - 2*r*(120*s + 73) - 112*s**2 + 260*s + 7) + Pkd2*k2*(7 - 14*C)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + k2**2*(-35*b2 + 70*g2)*(-2*Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))))/(105*d**2*k2**2*k3) + D1**3*Pkd3*(-4*D1*Pk2*bd1*f*k2**2*s*(5*b2 + f*(4*C - 2) - 10*g2)*(r + s - 1) + 2*Pk2*b1*(D1*bd1*f*(k1**2*(r*(8*s - 2) + 2*(1 - 2*s)**2) + k2**2*(-6*C*(8*r**2 - r*(12*s + 5) + 6*s - 3) - 20*K*s**2 + 20*K*s + 24*r**2 - r*(s*(20*K + 36) + 15) + 18*s - 9)) - 2*k2**2*(r + s - 1)*(D1*(f*fd*(4*C - 2)*(2*s - 1) + 5*f*s*(bd2 - 2*gd2) - 10*fd*g2*(s - 1)) + 2*Dd*f*(4*s - 1)*(f*(2*C - 1) - 5*g2) + 5*b2*(D1*fd*(s - 1) + Dd*f*(4*s - 1)))) + 5*b1**3*(D1*fd*(r + s - 1)*(2*Pk2*k1**2*s + 2*Pk2*k2**2*(r - 1) + Pkd2*k1**2*k2*s) + Dd*f*(4*Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(2*Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*s*(4*r + 4*s - 3)))) + b1**2*(5*D1*bd1*f*(2*Pk2*k2**2*(3*r - 1)*(r + s - 1) + k1**2*(2*Pk2*(3*s - 1)*(r + s - 1) + Pkd2*k2*s*(3*r + 3*s - 2))) + 2*Pk2*(4*D1*fd*k1**2*s*(r + s - 1) - 2*D1*fd*k2**2*(6*C*(r - 1)*(2*r - 3*s - 2) + 5*K*(s - 1)*(r + s - 1) + (3 - 3*r)*(2*r - 3*s - 2)) + 2*Dd*f*k1**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + Dd*f*k2**2*(-6*C*(16*r**2 - 3*r*(8*s + 7) + 18*s + 5) - 10*K*(4*s - 1)*(r + s - 1) + 48*r**2 - 72*r*s - 63*r + 54*s + 15))))/(15*d**2*k2**2*k3) + D1**3*Pkd3*st**4*(D1*bd1*f*(f**2*(6*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(3*s - 2) + 3*s**2 - 4*s + 1) + 3*k1**2*k2**2*(2*Pk2*(12*r**2 - 6*r*(6*s + 1) - 48*s**2 + 31*s - 4) + Pkd2*k2*(r*(29*s - 8) + 29*s**2 - 31*s + 6))) - 3*f*k2**2*(k1**2*(-2*K*Pkd2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + Pk2*b1*(-2*r**2 + r*(5 - 68*s) - 66*s**2 + 53*s + 1) + 2*Pk2*(2*K*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + 5*r**2 + r*(10*s - 11) + 5*s**2 - 4*s + 6) + Pkd2*b1*k2*(r*(32*s - 1) + 32*s**2 - 25*s - 1)) + 2*k2**2*(Pk2*(7*b1*(r - 1) + 2*r**2*(10*C + 7*K - 19) - 2*r*(C*(8 - 12*s) + 7*K*(s + 1) + 20*s - 21) + 2*s**2*(2*C - 14*K - 1) + 2*s*(-4*C + 7*K + 9) - 6) + Pkd2*k2*(2*C*(r + 2*s - 1) + 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - r - 2*s + 1))) + 42*k2**4*(2*Pk2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + b1*(K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) - b2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) - 3*b1**2*k2**2*(D1*fd*(f*(-14*Pk2*k2**2*(r - 1) + k1**2*(-2*Pk2*(r**2 + 34*r*s + 7*r + 33*s**2 - s - 8) + Pkd2*k2*(32*r*s + 9*r + 32*s**2 + s - 9))) - 14*k2**2*(-K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 2*K*Pkd2*k2*(r + 2*s - 1) - 2*Pk2*r)) + Dd*f*(f*k1**2*(-Pk2*(4*r**2 + 136*r*s + 9*r + 132*s**2 - 55*s - 17) + 2*Pkd2*k2*(32*r*s + 4*r + 32*s**2 - 12*s - 5)) - 14*k2**2*(4*K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + 4*r - 2)))) + b1*(D1*(f**2*fd*(6*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 4) + 3*k1**2*k2**2*(2*Pk2*(36*r**2 + r*(9 - 108*s) - 144*s**2 + 127*s - 19) + Pkd2*k2*(r*(87*s - 36) + 87*s**2 - 104*s + 28))) - 6*f*k2**2*(7*bd2*k2**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(-2*r - 2*s + 1)) + fd*k1**2*(-K*Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6) + Pk2*(2*K*(2*s - 1)*(5*r + 5*s - 6) + 10*r**2 + 4*r*(5*s - 6) + 10*s**2 - 17*s + 6)) - 2*fd*k2**2*(Pk2*(-4*C*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) - 7*K*(2*r**2 - 2*r*s + r - 4*s**2 + 4*s - 1) + 38*r**2 + 40*r*s - 32*r + 2*s**2 - 8*s + 7) + Pkd2*k2*(4*C*(r + 2*s - 1) - 7*K*(2*s - 1)*(2*r + 2*s - 1) - 2*r - 4*s + 2)) - 14*gd2*k2**2*(Pk2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) - Pkd2*k2*(r + 2*s - 1))) + 42*fd*k2**4*(-Pk2*b2*(r + s - 1)**2 + 2*Pk2*g2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 2*Pkd2*b2*k2*s*(r + s) - 4*Pkd2*g2*k2*(r + 2*s - 1))) + Dd*f*(f**2*(12*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 19*s + 5) + 3*k1**2*k2**2*(Pk2*(96*r**2 + r*(6 - 288*s) - 384*s**2 + 316*s - 46) + Pkd2*k2*(4*r*(29*s - 11) + 116*s**2 - 135*s + 34))) - 6*f*k2**2*(k1**2*(K*Pkd2*k2*(r*(11 - 20*s) - 20*s**2 + 41*s - 12) + Pk2*(K*(40*r*s - 22*r + 40*s**2 - 82*s + 24) + 20*r**2 + 40*r*s - 46*r + 20*s**2 - 25*s + 18)) - 2*k2**2*(Pk2*(-2*C*(20*r**2 + r*(24*s - 29) + 4*s**2 - 15*s + 10) - 7*K*(4*r**2 - 4*r*s - r - 8*s**2 + 6*s - 1) + 76*r**2 + 80*r*s - 80*r + 4*s**2 - 29*s + 18) + Pkd2*k2*(4*C*(r + 2*s - 1) - 7*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 2*r - 4*s + 2))) + 42*k2**4*(-b2*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s)) + 2*g2*(Pk2*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) - 4*Pkd2*k2*(r + 2*s - 1))))) - 6*f*k2**2*(36*C*D1*Pk2*f*fd*k1**2*r*s - 12*C*D1*Pk2*f*fd*k1**2*r + 36*C*D1*Pk2*f*fd*k1**2*s**2 - 36*C*D1*Pk2*f*fd*k1**2*s + 8*C*D1*Pk2*f*fd*k1**2 + 36*C*D1*Pk2*f*fd*k2**2*r**2 - 96*C*D1*Pk2*f*fd*k2**2*r*s - 26*C*D1*Pk2*f*fd*k2**2*r - 48*C*D1*Pk2*f*fd*k2**2*s**2 + 80*C*D1*Pk2*f*fd*k2**2*s - 6*C*D1*Pk2*f*fd*k2**2 - 18*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 6*C*D1*Pkd2*f*fd*k1**2*k2*r - 18*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 18*C*D1*Pkd2*f*fd*k1**2*k2*s - 4*C*D1*Pkd2*f*fd*k1**2*k2 + 24*C*D1*Pkd2*f*fd*k2**3*r*s - 10*C*D1*Pkd2*f*fd*k2**3*r + 24*C*D1*Pkd2*f*fd*k2**3*s**2 - 24*C*D1*Pkd2*f*fd*k2**3*s + 6*C*D1*Pkd2*f*fd*k2**3 + 48*C*Dd*Pk2*f**2*k1**2*r*s - 16*C*Dd*Pk2*f**2*k1**2*r + 48*C*Dd*Pk2*f**2*k1**2*s**2 - 52*C*Dd*Pk2*f**2*k1**2*s + 12*C*Dd*Pk2*f**2*k1**2 + 48*C*Dd*Pk2*f**2*k2**2*r**2 - 128*C*Dd*Pk2*f**2*k2**2*r*s - 46*C*Dd*Pk2*f**2*k2**2*r - 64*C*Dd*Pk2*f**2*k2**2*s**2 + 116*C*Dd*Pk2*f**2*k2**2*s + 2*C*Dd*Pk2*f**2*k2**2 - 24*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 8*C*Dd*Pkd2*f**2*k1**2*k2*r - 24*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 26*C*Dd*Pkd2*f**2*k1**2*k2*s - 6*C*Dd*Pkd2*f**2*k1**2*k2 + 32*C*Dd*Pkd2*f**2*k2**3*r*s - 12*C*Dd*Pkd2*f**2*k2**3*r + 32*C*Dd*Pkd2*f**2*k2**3*s**2 - 32*C*Dd*Pkd2*f**2*k2**3*s + 8*C*Dd*Pkd2*f**2*k2**3 + 9*D1*Pk2*f*fd*k1**2*r**2 - 6*D1*Pk2*f*fd*k1**2*r*s - 8*D1*Pk2*f*fd*k1**2*r - 15*D1*Pk2*f*fd*k1**2*s**2 + 9*D1*Pk2*f*fd*k1**2*s + D1*Pk2*f*fd*k1**2 - 30*D1*Pk2*f*fd*k2**2*r**2 + 36*D1*Pk2*f*fd*k2**2*r*s + 22*D1*Pk2*f*fd*k2**2*r + 24*D1*Pk2*f*fd*k2**2*s**2 - 38*D1*Pk2*f*fd*k2**2*s + 2*D1*Pk2*f*fd*k2**2 - 20*D1*Pk2*f*gd2*k1**2*r*s + 12*D1*Pk2*f*gd2*k1**2*r - 20*D1*Pk2*f*gd2*k1**2*s**2 + 48*D1*Pk2*f*gd2*k1**2*s - 12*D1*Pk2*f*gd2*k1**2 - 28*D1*Pk2*f*gd2*k2**2*r**2 + 28*D1*Pk2*f*gd2*k2**2*r*s + 28*D1*Pk2*f*gd2*k2**2*r + 56*D1*Pk2*f*gd2*k2**2*s**2 - 28*D1*Pk2*f*gd2*k2**2*s - 40*D1*Pk2*fd*g2*k1**2*r*s + 20*D1*Pk2*fd*g2*k1**2*r - 40*D1*Pk2*fd*g2*k1**2*s**2 + 68*D1*Pk2*fd*g2*k1**2*s - 24*D1*Pk2*fd*g2*k1**2 - 56*D1*Pk2*fd*g2*k2**2*r**2 + 56*D1*Pk2*fd*g2*k2**2*r*s - 28*D1*Pk2*fd*g2*k2**2*r + 112*D1*Pk2*fd*g2*k2**2*s**2 - 112*D1*Pk2*fd*g2*k2**2*s + 28*D1*Pk2*fd*g2*k2**2 + 9*D1*Pkd2*f*fd*k1**2*k2*r*s - 3*D1*Pkd2*f*fd*k1**2*k2*r + 9*D1*Pkd2*f*fd*k1**2*k2*s**2 - 9*D1*Pkd2*f*fd*k1**2*k2*s + 2*D1*Pkd2*f*fd*k1**2*k2 - 12*D1*Pkd2*f*fd*k2**3*r*s + 5*D1*Pkd2*f*fd*k2**3*r - 12*D1*Pkd2*f*fd*k2**3*s**2 + 12*D1*Pkd2*f*fd*k2**3*s - 3*D1*Pkd2*f*fd*k2**3 + 10*D1*Pkd2*f*gd2*k1**2*k2*r*s - 6*D1*Pkd2*f*gd2*k1**2*k2*r + 10*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 24*D1*Pkd2*f*gd2*k1**2*k2*s + 6*D1*Pkd2*f*gd2*k1**2*k2 - 56*D1*Pkd2*f*gd2*k2**3*r*s + 14*D1*Pkd2*f*gd2*k2**3*r - 56*D1*Pkd2*f*gd2*k2**3*s**2 + 56*D1*Pkd2*f*gd2*k2**3*s - 14*D1*Pkd2*f*gd2*k2**3 + 20*D1*Pkd2*fd*g2*k1**2*k2*r*s - 10*D1*Pkd2*fd*g2*k1**2*k2*r + 20*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 34*D1*Pkd2*fd*g2*k1**2*k2*s + 12*D1*Pkd2*fd*g2*k1**2*k2 - 112*D1*Pkd2*fd*g2*k2**3*r*s + 56*D1*Pkd2*fd*g2*k2**3*r - 112*D1*Pkd2*fd*g2*k2**3*s**2 + 112*D1*Pkd2*fd*g2*k2**3*s - 28*D1*Pkd2*fd*g2*k2**3 + D1*b2*fd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(5*r + 5*s - 6) + 14*k2**2*(Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)) + D1*bd2*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + 7*k2**2*(2*Pk2*(r**2 - r*(s + 1) - 2*s**2 + s) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + 12*Dd*Pk2*f**2*k1**2*r**2 - 8*Dd*Pk2*f**2*k1**2*r*s - 11*Dd*Pk2*f**2*k1**2*r - 20*Dd*Pk2*f**2*k1**2*s**2 + 15*Dd*Pk2*f**2*k1**2*s + Dd*Pk2*f**2*k1**2 - 40*Dd*Pk2*f**2*k2**2*r**2 + 48*Dd*Pk2*f**2*k2**2*r*s + 37*Dd*Pk2*f**2*k2**2*r + 32*Dd*Pk2*f**2*k2**2*s**2 - 54*Dd*Pk2*f**2*k2**2*s - 3*Dd*Pk2*f**2*k2**2 - 80*Dd*Pk2*f*g2*k1**2*r*s + 44*Dd*Pk2*f*g2*k1**2*r - 80*Dd*Pk2*f*g2*k1**2*s**2 + 164*Dd*Pk2*f*g2*k1**2*s - 48*Dd*Pk2*f*g2*k1**2 - 112*Dd*Pk2*f*g2*k2**2*r**2 + 112*Dd*Pk2*f*g2*k2**2*r*s + 28*Dd*Pk2*f*g2*k2**2*r + 224*Dd*Pk2*f*g2*k2**2*s**2 - 168*Dd*Pk2*f*g2*k2**2*s + 28*Dd*Pk2*f*g2*k2**2 + 12*Dd*Pkd2*f**2*k1**2*k2*r*s - 4*Dd*Pkd2*f**2*k1**2*k2*r + 12*Dd*Pkd2*f**2*k1**2*k2*s**2 - 13*Dd*Pkd2*f**2*k1**2*k2*s + 3*Dd*Pkd2*f**2*k1**2*k2 - 16*Dd*Pkd2*f**2*k2**3*r*s + 6*Dd*Pkd2*f**2*k2**3*r - 16*Dd*Pkd2*f**2*k2**3*s**2 + 16*Dd*Pkd2*f**2*k2**3*s - 4*Dd*Pkd2*f**2*k2**3 + 40*Dd*Pkd2*f*g2*k1**2*k2*r*s - 22*Dd*Pkd2*f*g2*k1**2*k2*r + 40*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 82*Dd*Pkd2*f*g2*k1**2*k2*s + 24*Dd*Pkd2*f*g2*k1**2*k2 - 224*Dd*Pkd2*f*g2*k2**3*r*s + 84*Dd*Pkd2*f*g2*k2**3*r - 224*Dd*Pkd2*f*g2*k2**3*s**2 + 224*Dd*Pkd2*f*g2*k2**3*s - 56*Dd*Pkd2*f*g2*k2**3 + Dd*b2*f*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + 14*k2**2*(Pk2*(4*r**2 - 4*r*s - r - 8*s**2 + 6*s - 1) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(105*d**2*k2**2*k3**3) + D1**3*Pkd3*st**2*(3*D1*bd1*f*(3*f**2*k1**2*(4*Pk2*k2**2*(6*r**2 + 9*r*(2*s - 1) + 12*s**2 - 13*s + 3) + k1**2*(2*Pk2*(4*r + 5*s - 2) + Pkd2*k2*(3*s - 2)*(2*r + 2*s - 1))) + f*(2*Pk2*k2**4*(2*C*(29*r**2 + 6*r*(6*s - 5) + 7*s**2 - 9*s + 17) - 42*K*r**2 - 126*K*r*s + 70*K*r - 84*K*s**2 + 84*K*s - 28*K + 14*b1*(2*r - 1) - 29*r**2 - 36*r*s + 30*r - 7*s**2 + 9*s - 17) + 2*k1**4*(Pk2*(2*b1*(6*r*s + 9*r + 6*s**2 + s - 5) + 2*r*s + 3*r + 2*s**2 + 5*s - 3) - Pkd2*b1*k2*(r*(6*s + 9) + 6*s**2 + s - 5)) + k1**2*k2**2*(Pk2*(4*C*r**2 - 536*C*r*s + 20*C*r + 20*C*s**2 + 236*C*s - 28*K*(2*r**2 + 3*r*s - r + s**2 + 2*s - 1) + 7*b1*(26*r**2 - 3*r*(4*s + 7) - 38*s**2 + 13*s + 7) + 38*r**2 + 344*r*s - 34*r + 26*s**2 - 140*s - 8) + Pkd2*k2*(4*C*(15*r*s + 3*r + 15*s**2 - 10*s - 5) - 14*K*(5*s - 3)*(r + s - 1) + 112*b1*r*s + 14*b1*r + 112*b1*s**2 - 91*b1*s - 30*r*s - 6*r - 30*s**2 + 20*s + 10))) - 7*k2**2*(20*Pk2*g2*k2**2*(3*r**2 + r*(4*s - 3) + s*(s - 1)) + b1**2*(10*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - Pkd2*k2*(9*r*s + r + 9*s**2 - 4*s - 1))) + 2*b1*(k1**2*(-2*K*Pkd2*k2*(r*(s + 1) + s*(s - 2)) + Pk2*(K*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) + 2*r**2 - 5*r - 2*s**2 + 8*s - 1)) + k2**2*(Pk2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 5*K*(6*r**2 + 8*r*s - 11*r + 2*s**2 - 7*s + 5) - 14*r**2 - 24*r*s + 15*r - 10*s**2 + 17*s - 1) + Pkd2*k2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + 5*K*(r + 2*s - 1) - 4*r*s + r - 4*s**2 + 4*s - 1))) + 2*b2*k1**2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) - Pkd2*k2*(r*(s + 2) + s*(s - 1))) + 10*b2*k2**2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 4*g2*k1**2*(-Pk2*(r**2 + r*(6*s - 3) + s*(5*s - 5)) + Pkd2*k2*(r*(s + 2) + s*(s - 1))))) - 21*b1**3*k2**2*(D1*fd*(10*Pk2*k2**2*(r - 1) + k1**2*(Pk2*(r + s - 1) - 3*Pkd2*k2*s))*(r + s - 1) + Dd*f*(10*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - Pkd2*k2*(12*r*s + r + 12*s**2 - 7*s - 1)))) + 3*b1**2*(D1*fd*(4*f*k1**4*s*(2*Pk2 - Pkd2*k2)*(3*r + 3*s - 4) + 7*k1**2*k2**2*(-2*Pk2*(K*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) + f*(-13*r**2 + r*(6*s + 13) + 19*s**2 - 4) + r**2 + 2*r - s**2 + 4*s - 2) + Pkd2*k2*(2*K*s*(r + s) + f*(2*r*(8*s + 5) + 16*s**2 + 5*s - 10))) - 14*k2**4*(Pk2*(10*C*(r + s - 1)**2 - 15*K*r**2 - 20*K*r*s + 40*K*r - 5*K*s**2 + 30*K*s - 15*K - 4*f*r + 2*f - 7*r**2 - 12*r*s + 4*r - 5*s**2 + 12*s - 7) + 2*Pkd2*k2*(5*K*(r + 2*s - 1) + s*(2*C - 1)*(r + s - 1)))) + Dd*f*(f*(56*Pk2*k2**4*(2*r - 1) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(3*r*(4*s + 3) + 12*s**2 - 7*s - 5) + 7*k1**2*k2**2*(Pk2*(52*r**2 - r*(24*s + 47) - 76*s**2 + 13*s + 15) + 2*Pkd2*k2*(2*r*(8*s + 3) + 16*s**2 - 4*s - 5))) - 14*k2**2*(k1**2*(-K*Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7)) + Pk2*(K*(4*r**2 + 24*r*s - 17*r + 20*s**2 - 31*s + 11) + 4*r**2 - 3*r - 4*s**2 + 19*s - 4)) + k2**2*(Pk2*(10*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 5*K*(12*r**2 + 16*r*s - 27*r + 4*s**2 - 19*s + 13) - 28*r**2 - 48*r*s + 28*r - 20*s**2 + 41*s - 10) + Pkd2*k2*(2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 20*K*(r + 2*s - 1) - 8*r*s + r - 8*s**2 + 8*s - 1))))) + 3*b1*(D1*(3*f**2*fd*k1**2*(4*Pk2*k2**2*(18*r**2 + r*(54*s - 39) + 36*s**2 - 51*s + 19) + k1**2*(2*Pk2*(6*r + 15*s - 8) + Pkd2*k2*(3*s - 2)*(6*r + 6*s - 5))) + 2*f*(fd*(Pk2*k1**4*(r*(4*s + 5) + 4*s**2 + 10*s - 6) + k1**2*k2**2*(Pk2*(4*C*(r**2 + r*(31 - 134*s) + 5*s**2 + 97*s - 32) - 14*K*(4*r**2 + 6*r*s + 2*s**2 + 5*s - 3) + 38*r**2 + 344*r*s - 107*r + 26*s**2 - 235*s + 79) + Pkd2*k2*(-7*K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(4*C - 2)*(15*r + 15*s - 4))) + k2**4*(2*Pk2*(C*(58*r**2 + r*(72*s - 89) + 14*s**2 - 64*s + 23) - 7*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 29*r**2 - 36*r*s + 55*r - 7*s**2 + 32*s - 15) + Pkd2*k2*(21 - 42*C)*(r + 2*s - 1))) - 7*k2**2*(bd2*k1**2*(Pk2*(r + s - 1)**2 - Pkd2*k2*s*(r + s - 3)) + 5*bd2*k2**2*(Pk2*(r**2 + 2*r*s + s**2 - 1) + Pkd2*k2*s*(2*r + 2*s - 1)) + 2*gd2*k1**2*(-Pk2*(r**2 + r*(6*s - 4) + 5*s**2 - 8*s + 3) + Pkd2*k2*s*(r + s - 3)) - 10*gd2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 5) + Pkd2*k2*(r + 2*s - 1)))) - 14*fd*k2**2*(b2*k1**2*(Pk2*(r + s - 1)**2 - Pkd2*k2*s*(r + s)) + 5*b2*k2**2*(Pk2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) + 2*Pkd2*k2*s*(r + s)) + 2*g2*k1**2*(-Pk2*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) + Pkd2*k2*s*(r + s)) - 10*g2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 3) + 2*Pkd2*k2*(r + 2*s - 1)))) + 2*Dd*f*(3*f**2*k1**2*(4*Pk2*k2**2*(12*r**2 + 12*r*(3*s - 2) + 24*s**2 - 32*s + 11) + k1**2*(10*Pk2*(r + 2*s - 1) + Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*(Pk2*k1**4*(8*r*s + 11*r + 8*s**2 + 20*s - 12) + k1**2*k2**2*(Pk2*(2*C*(4*r**2 + r*(71 - 536*s) + 20*s**2 + 393*s - 69) - 14*K*(8*r**2 + 12*r*s - 2*r + 4*s**2 + 9*s - 5) + 76*r**2 + 688*r*s - 154*r + 52*s**2 - 469*s + 86) + Pkd2*k2*(2*C*(r*(60*s + 3) + 60*s**2 - 31*s - 5) - 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) - 60*r*s - 3*r - 60*s**2 + 31*s + 5)) - k2**4*(Pk2*(-2*C*(116*r**2 + r*(144*s - 179) + 28*s**2 - 121*s + 71) + 14*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 116*r**2 + 144*r*s - 207*r + 28*s**2 - 121*s + 85) + Pkd2*k2*(56*C - 28)*(r + 2*s - 1))) - 7*k2**2*(b2*k1**2*(Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + 5*b2*k2**2*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 2*g2*k1**2*(-Pk2*(4*r**2 + r*(24*s - 17) + 20*s**2 - 31*s + 11) + Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) - 10*g2*k2**2*(-Pk2*(12*r**2 + r*(16*s - 27) + 4*s**2 - 19*s + 13) + 4*Pkd2*k2*(r + 2*s - 1))))) + 2*f*(D1*(f*(fd*(Pk2*k1**4*(6*r*(3*s + 2) + 18*s**2 + 9*s - 11) - Pk2*k2**4*(36*C - 18)*(9*r**2 + r*(21*s - 13) + 12*s**2 - 13*s + 4) + k1**2*k2**2*(Pk2*(-4*C*(3*r - 1)*(30*r + 30*s - 11) + 315*r**2 + 9*r*(44*s - 29) + 81*s**2 - 150*s + 49) + Pkd2*k2*(9 - 18*C)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + k2**2*(-21*bd2 + 42*gd2)*(2*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(2*r**2 + 3*r*s - r + s**2 + 2*s - 1) + Pkd2*k2*(5*s - 3)*(r + s - 1)))) - 21*fd*k2**2*(b2 - 2*g2)*(2*Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*(2*Pk2*(4*r**2 + 6*r*s + 2*s**2 + 5*s - 3) + Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4)))) + Dd*f*(f*(Pk2*k1**4*(r*(24*s + 17) + 24*s**2 + 12*s - 16) + Pk2*k2**4*(36 - 72*C)*(6*r**2 + r*(14*s - 9) + 8*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(-4*C*(120*r**2 + 120*r*s - 99*r - 50*s + 17) + 420*r**2 + 528*r*s - 387*r + 108*s**2 - 217*s + 70) + Pkd2*k2*(9 - 18*C)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + k2**2*(-21*b2 + 42*g2)*(2*Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(8*r**2 + 12*r*s - 2*r + 4*s**2 + 9*s - 5) + Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10))))))/(315*d**2*k2**2*k3**3) + D1**3*Pkd3*(D1*bd1*f*(Pk2*f*k2**4*r*(28 - 56*C)*(3*r + 3*s - 2) - 35*b1**2*k2**2*(2*Pk2*k2**2*(3*r - 1)*(r + s - 1) + k1**2*(Pk2*(27*r**2 + 42*r*s - 43*r + 15*s**2 - 33*s + 16) + Pkd2*k2*s*(3*r + 3*s - 2))) + 14*b1*(2*Pk2*k1**4*(r*(4*s - 1) + s*(4*s - 3)) + Pk2*k2**4*(6*C*(8*r**2 - r*(12*s + 5) + 6*s - 3) - r**2*(20*K + 24) + r*(-20*K*(s - 1) + 36*s + 15) - 18*s + 9) + k1**2*k2**2*(-10*K*Pkd2*k2*s*(r + s - 1) + Pk2*(4*C*(2*r**2 + r*(15 - 68*s) + 10*s**2 + 29*s - 17) - 40*K*s**2 + 40*K*s + r**2*(6 - 40*K) + r*(-80*K*s + 40*K + 148*s - 43) - 18*s**2 - 55*s + 32))) + f*k1**4*(4*Pk2*(7*b1*(2*s - 1)*(3*r + 3*s - 2) + 12*r*s - 6*r + 12*s**2 - 15*s + 3) + 21*Pkd2*b1*k2*s*(4*r + 4*s - 3)) + 2*f*k1**2*k2**2*(Pk2*(-4*C*(60*r**2 + 102*r*s - 81*r + 42*s**2 - 71*s + 29) - 28*K*r*s - 28*K*s**2 + 28*K*s + 14*b1*(12*r**2 + r*(20*s - 21) + 8*s**2 - 13*s + 7) + 141*r**2 + 246*r*s - 204*r + 105*s**2 - 163*s + 58) + Pkd2*k2*s*(21 - 42*C)*(r + s - 1)) - 70*k2**2*(r + s - 1)*(2*Pk2*b2*k2**2*(r + s) - 4*Pk2*g2*k2**2*r + b2*k1**2*(4*Pk2*(r + s) + Pkd2*k2*s) - 2*g2*k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))) - 4*Pk2*f*k1**2*k2**2*(r + s - 1)*(D1*(f*fd*(18*C - 9)*(3*s - 1) + 14*f*s*(bd2 - 2*gd2) + 28*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(18*C - 9) - 28*g2) + 14*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))) - 35*b1**3*k2**2*(D1*fd*(2*Pk2*k2**2*(r - 1) + k1**2*(Pk2*(9*r + 5*s - 9) + Pkd2*k2*s))*(r + s - 1) + Dd*f*(4*Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(Pk2*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + Pkd2*k2*s*(4*r + 4*s - 3)))) + 7*b1**2*(D1*fd*(4*Pk2*k2**4*(6*C*(r - 1)*(2*r - 3*s - 2) - 5*K*(r**2 + r*s + r + 2*s - 1) + (3 - 3*r)*(2*r - 3*s - 2)) + k1**4*s*(8*Pk2*f*(3*r + 3*s - 2) + 8*Pk2*(r + s) + 3*Pkd2*f*k2*(4*r + 4*s - 3)) - 2*k1**2*k2**2*(5*K*Pkd2*k2*s*(r + s) + Pk2*(-4*C*(r**2 - 2*r*(17*s + 1) + 5*s**2 + 34*s + 1) + 20*K*r**2 + 40*K*r*s + 20*K*s**2 - 2*f*(12*r**2 + 20*r*s - 19*r + 8*s**2 - 11*s + 7) - 3*r**2 - 74*r*s - 4*r + 9*s**2 + 64*s + 2))) + 2*Dd*f*(2*Pk2*k1**4*(r*(8*s - 1) + 4*s*(2*s - 1)) + Pk2*k2**4*(6*C*(16*r**2 - 3*r*(8*s + 7) + 18*s + 5) - 10*K*(4*r**2 + 4*r*s - 2*r + 2*s - 1) - 48*r**2 + 72*r*s + 63*r - 54*s - 15) + f*(4*Pk2*k1**2*k2**2*(12*r**2 + 20*r*(s - 1) + 8*s**2 - 12*s + 7) + k1**4*(2*Pk2*(4*s - 1)*(3*r + 3*s - 2) + 3*Pkd2*k2*s*(4*r + 4*s - 3))) + k1**2*k2**2*(-5*K*Pkd2*k2*s*(4*r + 4*s - 3) + Pk2*(4*C*(4*r**2 + r*(11 - 136*s) + 20*s**2 + 97*s - 15) - 80*K*s**2 + 60*K*s + r**2*(12 - 80*K) - 4*r*(5*K*(8*s - 3) - 74*s + 10) - 36*s**2 - 183*s + 28)))) + 2*b1*(D1*(f*(fd*(24*Pk2*k1**4*s*(2*r + 2*s - 1) - Pk2*k2**4*(28*C - 14)*(2*r + 1)*(3*r + 3*s - 2) + k1**2*k2**2*(Pk2*(-4*C*(120*r**2 + 12*r*(17*s - 10) + 84*s**2 - 109*s + 30) - 28*K*(2*s - 1)*(r + s - 1) + 282*r**2 + 492*r*s - 261*r + 210*s**2 - 218*s + 60) + Pkd2*k2*s*(21 - 42*C)*(2*r + 2*s - 1))) - 35*k2**2*(r + s - 1)*(2*Pk2*bd2*k2**2*(r + s) - 4*Pk2*gd2*k2**2*r + bd2*k1**2*(4*Pk2*(r + s) + Pkd2*k2*s) - 2*gd2*k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))) - 35*fd*k2**2*(b2*(r + s)*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s)) - 2*g2*(4*Pk2*k1**2*(r + s)**2 + 2*Pk2*k2**2*(r**2 + r*s + r + 2*s - 1) + Pkd2*k1**2*k2*s*(r + s)))) + Dd*f*(f*(6*Pk2*k1**4*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + Pk2*k2**4*(28 - 56*C)*(6*r**2 + r*(6*s - 3) + s - 1) + k1**2*k2**2*(Pk2*(-4*C*(240*r**2 + 3*r*(136*s - 97) + 168*s**2 - 260*s + 89) - 28*K*(4*s - 1)*(r + s - 1) + 564*r**2 + 984*r*s - 666*r + 420*s**2 - 541*s + 178) + Pkd2*k2*s*(21 - 42*C)*(4*r + 4*s - 3))) + 35*k2**2*(-b2*(2*Pk2*k2**2*(r + s) + k1**2*(4*Pk2*(r + s) + Pkd2*k2*s))*(4*r + 4*s - 3) + 2*g2*(4*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*Pk2*k2**2*(4*r**2 + r*(4*s - 2) + 2*s - 1) + Pkd2*k1**2*k2*s*(4*r + 4*s - 3))))))/(105*d**2*k2**2*k3**3) + D1**3*Pkd3*st**4*(D1*(-1386*b1*fd*k2**6*(5*Pk2*b2*(r + s)**2 + b1*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s)) - 2*g2*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s))) + f**3*(-33*bd1*k2**2*(6*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(Pk2*(30*r**2 + 108*r*s - 67*r + 78*s**2 - 95*s + 25) + Pkd2*k2*(-24*r*s + r - 24*s**2 + 15*s + 5)) + 3*k1**2*k2**2*(Pk2*(101*r**2 + 4*r*(41*s - 38) + 63*s**2 - 138*s + 55) + Pkd2*k2*(r*(21*s - 4) + 21*s**2 - 23*s + 6))) + fd*k1**2*(88*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(25*r + 25*s - 27) + 33*k1**2*k2**2*(4*Pk2*(38*r**2 - r*(82*s + 5) - 120*s**2 + 103*s - 15) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) + 33*f**2*k2**2*(b1*(-84*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) - 6*Pk2*fd*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 3*bd1*k1**2*k2**2*(5*Pk2*(16*r**2 + r*(32*s - 17) + 16*s**2 - 17*s + 1) + Pkd2*k2*(r*(50*s - 9) + 50*s**2 - 43*s + 1)) + fd*k1**4*(3*Pk2*(30*r**2 + r*(108*s - 61) + 78*s**2 - 81*s + 27) + Pkd2*k2*(-3*r*(24*s + 7) - 72*s**2 + 9*s + 17)) - 3*fd*k1**2*k2**2*(Pk2*(303*r**2 + r*(492*s - 397) + 189*s**2 - 363*s + 146) + Pkd2*k2*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24))) - 6*k2**2*(96*C*Pk2*fd*k1**2*r**2 + 360*C*Pk2*fd*k1**2*r*s - 150*C*Pk2*fd*k1**2*r + 72*C*Pk2*fd*k1**2*s**2 - 218*C*Pk2*fd*k1**2*s + 64*C*Pk2*fd*k1**2 - 144*C*Pk2*fd*k2**2*r**2 - 120*C*Pk2*fd*k2**2*r*s + 152*C*Pk2*fd*k2**2*r - 60*C*Pk2*fd*k2**2*s**2 + 46*C*Pk2*fd*k2**2*s - 30*C*Pk2*fd*k2**2 + 18*C*Pkd2*fd*k1**2*k2*r*s - 6*C*Pkd2*fd*k1**2*k2*r + 18*C*Pkd2*fd*k1**2*k2*s**2 - 18*C*Pkd2*fd*k1**2*k2*s + 4*C*Pkd2*fd*k1**2*k2 - 24*C*Pkd2*fd*k2**3*r*s + 10*C*Pkd2*fd*k2**3*r - 24*C*Pkd2*fd*k2**3*s**2 + 24*C*Pkd2*fd*k2**3*s - 6*C*Pkd2*fd*k2**3 + 5*Pk2*bd2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 57*Pk2*fd*k1**2*r**2 - 192*Pk2*fd*k1**2*r*s + 89*Pk2*fd*k1**2*r - 39*Pk2*fd*k1**2*s**2 + 118*Pk2*fd*k1**2*s - 37*Pk2*fd*k1**2 + 84*Pk2*fd*k2**2*r**2 + 72*Pk2*fd*k2**2*r*s - 85*Pk2*fd*k2**2*r + 30*Pk2*fd*k2**2*s**2 - 25*Pk2*fd*k2**2*s + 16*Pk2*fd*k2**2 - 70*Pk2*gd2*k1**2*r**2 - 140*Pk2*gd2*k1**2*r*s + 154*Pk2*gd2*k1**2*r - 70*Pk2*gd2*k1**2*s**2 + 126*Pk2*gd2*k1**2*s - 84*Pk2*gd2*k1**2 + 280*Pk2*gd2*k2**2*r**2 + 476*Pk2*gd2*k2**2*r*s - 406*Pk2*gd2*k2**2*r + 196*Pk2*gd2*k2**2*s**2 - 350*Pk2*gd2*k2**2*s + 126*Pk2*gd2*k2**2 - 9*Pkd2*fd*k1**2*k2*r*s + 3*Pkd2*fd*k1**2*k2*r - 9*Pkd2*fd*k1**2*k2*s**2 + 9*Pkd2*fd*k1**2*k2*s - 2*Pkd2*fd*k1**2*k2 + 12*Pkd2*fd*k2**3*r*s - 5*Pkd2*fd*k2**3*r + 12*Pkd2*fd*k2**3*s**2 - 12*Pkd2*fd*k2**3*s + 3*Pkd2*fd*k2**3 - 10*Pkd2*gd2*k1**2*k2*r*s + 6*Pkd2*gd2*k1**2*k2*r - 10*Pkd2*gd2*k1**2*k2*s**2 + 24*Pkd2*gd2*k1**2*k2*s - 6*Pkd2*gd2*k1**2*k2 + 56*Pkd2*gd2*k2**3*r*s - 14*Pkd2*gd2*k2**3*r + 56*Pkd2*gd2*k2**3*s**2 - 56*Pkd2*gd2*k2**3*s + 14*Pkd2*gd2*k2**3 + bd1*(k1**2*(K*Pkd2*k2*(r*(5*s - 3) + 5*s**2 - 12*s + 3) + Pk2*(7*K*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 9*s + 6) - 5*r**2 - 10*r*s + 11*r - 5*s**2 + 4*s - 6)) + k2**2*(Pk2*(2*C*(8*r**2 + r*(16*s - 17) + 8*s**2 - 17*s + 9) - 7*K*(20*r**2 + 34*r*s - 29*r + 14*s**2 - 25*s + 9) + 16*r**2 + 8*r*s - 14*r - 8*s**2 + 4*s - 3) + Pkd2*k2*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 7*K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r*s + 2*r - 4*s**2 + 5*s - 1))))) + 99*f*k2**4*(-10*Pk2*b2*(7*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + b1**2*fd*(-14*Pk2*k2**2*(r - 1)*(2*r + 2*s - 1) + k1**2*(5*Pk2*(16*r**2 + 32*r*s - 7*r + 16*s**2 - 7*s - 1) + 2*Pkd2*k2*s*(25*r + 25*s - 9))) - 2*b1*(fd*(k1**2*(K*Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6) + Pk2*(7*K*(10*r**2 + 20*r*s - 19*r + 10*s**2 - 17*s + 6) - 10*r**2 - 20*r*s + 24*r - 10*s**2 + 17*s - 6)) + k2**2*(Pk2*(C*(32*r**2 + 8*r*(8*s + 1) + 32*s**2 + 8*s - 22) - 7*K*(40*r**2 + 34*r*(2*s - 1) + 7*(1 - 2*s)**2) + 32*r**2 + 16*r*s - 24*r - 16*s**2 + 9) + 2*Pkd2*k2*(2*r + 2*s - 1)*(4*C*s - 14*K*s + 7*K - 2*s))) - 7*k2**2*(-5*Pk2*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + bd1*(K*Pk2*(-8*r**2 + r*(3 - 16*s) - 8*s**2 + 3*s + 5) + K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + 4*Pk2*r**2 + Pk2*r*(4*s - 3) - Pk2*s) + 2*gd2*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 4*g2*(7*bd1*k2**2*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + fd*(k1**2*(7*Pk2*(10*r**2 + r*(20*s - 19) + 10*s**2 - 17*s + 6) + Pkd2*k2*(2*s - 1)*(5*r + 5*s - 6)) - 7*k2**2*(Pk2*(20*r + 14*s - 7) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1))))) + Dd*f*(-1386*b1*k2**6*(5*Pk2*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))) + f**3*k1**2*(88*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(25*r + 25*s - 27) + 33*k1**2*k2**2*(4*Pk2*(38*r**2 - r*(82*s + 5) - 120*s**2 + 103*s - 15) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 33*f**2*k2**2*(12*Pk2*b1*k2**4*(2*r - 1)*(5*r + 5*s - 3) - 2*b1*k1**4*(Pk2*(60*r**2 + r*(216*s - 125) + 156*s**2 - 169*s + 53) + Pkd2*k2*(-2*r*(24*s + 5) - 48*s**2 + 12*s + 11)) + 3*b1*k1**2*k2**2*(Pk2*(404*r**2 + 656*r*s - 549*r + 252*s**2 - 501*s + 201) + Pkd2*k2*(21*s - 10)*(4*r + 4*s - 3)) + 6*k1**2*k2**2*(Pk2*(2*C*(64*r**2 + 20*r*(12*s - 5) + 48*s**2 - 160*s + 41) - 76*r**2 - 256*r*s + 119*r - 52*s**2 + 171*s - 48) + Pkd2*k2*(2*C - 1)*(3*s - 1)*(4*r + 4*s - 3)) + 6*k2**4*(Pk2*(-2*C*(96*r**2 + 80*r*s - 113*r + 40*s**2 - 32*s + 28) + 112*r**2 + 96*r*s - 127*r + 40*s**2 - 36*s + 30) + Pkd2*k2*(2 - 4*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 99*f*k2**4*(-10*Pk2*b2*(k1**2*(5*r + 5*s - 6) - 7*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*(40*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 14*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*k2*(r*(100*s - 9) + 100*s**2 - 61*s + 1)) - 2*b1*(k1**2*(K*Pkd2*k2*(r*(20*s - 11) + 20*s**2 - 41*s + 12) + Pk2*(7*K*(20*r**2 + 40*r*s - 41*r + 20*s**2 - 35*s + 18) - 20*r**2 - 40*r*s + 46*r - 20*s**2 + 25*s - 18)) + k2**2*(Pk2*(2*C*(32*r**2 + 4*r*(16*s - 5) + 32*s**2 - 20*s - 3) - 7*K*(80*r**2 + 136*r*s - 92*r + 56*s**2 - 78*s + 25) + 64*r**2 + 32*r*s - 60*r - 32*s**2 + 12) + Pkd2*k2*(C*(4*r*(8*s - 1) + 32*s**2 - 24*s + 2) - 14*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 16*r*s + 2*r - 16*s**2 + 12*s - 1))) + 4*g2*(k1**2*(7*Pk2*(20*r**2 + 40*r*s - 41*r + 20*s**2 - 35*s + 18) + Pkd2*k2*(20*r*s - 11*r + 20*s**2 - 41*s + 12)) - 7*k2**2*(Pk2*(80*r**2 + 136*r*s - 92*r + 56*s**2 - 78*s + 25) + 2*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(3465*d**2*k2**2*k3**5) + D1**3*Pkd3*st**2*(D1*bd1*f*(f**2*k1**2*(-36*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(s + 1) + 15*s**2 - 8*s - 7) + 9*k1**2*k2**2*(-Pk2*(8*r**2 + r*(62*s - 23) + 54*s**2 - 57*s + 3) + 2*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) + 3*f*k2**2*(k1**4*(Pk2*(-140*C*s + 2*K*(5*r**2 + 2*r*(7*s + 8) + 9*s**2 + 20*s - 21) + 5*b1*(4*r**2 + r*(8*s - 13) + 4*s**2 - 13*s + 9) + 2*r*(140*C*s - 72*s - 3) - 4*s**2 + 60*s + 6) + Pkd2*b1*k2*(3*r*(22*s + 5) + 66*s**2 - 59*s - 11)) + k1**2*k2**2*(Pk2*(-4*C*(75*r**2 + 2*r*(139*s - 87) + 77*s**2 - 123*s + 81) + 14*K*(34*r**2 + 72*r*s - 55*r + 38*s**2 - 53*s + 21) - 7*b1*(88*r**2 + r*(152*s - 143) + 64*s**2 - 119*s + 55) + 110*r**2 + 476*r*s - 330*r + 114*s**2 - 228*s + 170) - 2*Pkd2*k2*(2*C*(15*r*s + 3*r + 15*s**2 - 10*s - 5) - 35*K*r*s + 21*K*r - 35*K*s**2 + 56*K*s - 21*K + 7*b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) - 15*r*s - 3*r - 15*s**2 + 10*s + 5)) + 2*k2**4*(Pk2*(2*C*(58*r**2 + 16*r*s - 51*r + 28*s**2 - 11*s - 17) + 42*K*r**2 + 126*K*r*s - 70*K*r + 84*K*s**2 - 84*K*s + 28*K - 7*b1*(2*r - 1)*(3*r + 3*s - 1) - 72*r**2 - 30*r*s + 58*r - 28*s**2 + 11*s + 17) + Pkd2*k2*(14*C - 7)*(r*(2*s - 1) + s*(2*s - 2)))) + 21*k2**4*(-5*Pk2*b1**2*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 10*Pk2*b2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*b1*(K*k1**2*(Pk2*(4*r**2 + r*(12*s - 5) + 8*s**2 + 3*s - 5) + 2*Pkd2*k2*(r*(s + 1) + s*(s - 2))) - 5*K*k2**2*(Pk2*(12*r**2 + r*(24*s - 7) + 12*s**2 - 7*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) - Pk2*k1**2*(2*r**2 + r*(4*s - 7) + s*(2*s + 3)) - 5*Pk2*k2**2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - 6*r**2 + r*(6 - 8*s) - 2*s**2 + 4*s - 1)) + 4*g2*(k1**2*(2*Pk2*(r**2 + r*(3*s - 4) + s*(2*s - 2)) + Pkd2*k2*(r*(s + 2) + s*(s - 1))) - 5*k2**2*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) - 105*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1**2*k2**2*(D1*fd*(f*(-14*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(5*Pk2*(4*r**2 + 8*r*s - 17*r + 4*s**2 - 17*s + 9) + 2*Pkd2*k2*s*(33*r + 33*s - 13)) - 7*k1**2*k2**2*(Pk2*(88*r**2 + 152*r*s - 69*r + 64*s**2 - 57*s + 5) + Pkd2*k2*s*(30*r + 30*s - 13))) + 14*k2**2*(-K*k1**2*(Pk2*(2*r**2 + 2*r*(3*s + 5) + 4*s**2 + 10*s - 5) + Pkd2*k2*s*(r + s)) + 5*K*k2**2*(Pk2*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)) + Pk2*(k1**2*(r + s)**2 + 5*k2**2*(2*C*(r + s - 1)**2 - 3*r**2 + r*(2 - 4*s) - (s - 1)**2)))) + Dd*f*(f*(-28*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(10*Pk2*(4*r**2 + r*(8*s - 15) + 4*s**2 - 15*s + 9) + Pkd2*k2*(3*r*(44*s + 5) + 132*s**2 - 85*s - 11)) - 7*k1**2*k2**2*(4*Pk2*(44*r**2 + 76*r*s - 53*r + 32*s**2 - 44*s + 15) + Pkd2*k2*(60*r*s - 6*r + 60*s**2 - 41*s + 2))) + 14*k2**2*(-K*k1**2*(Pk2*(8*r**2 + 8*r*(3*s + 1) + 16*s**2 + 20*s - 15) + Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) + 5*K*k2**2*(Pk2*(24*r**2 + 48*r*s + 2*r + 24*s**2 + 2*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + Pk2*(k1**2*(4*r**2 + 8*r*(s - 1) + s*(4*s + 7)) + 5*k2**2*(2*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 12*r**2 - 16*r*s + 12*r - 4*s**2 + 9*s - 3))))) + b1*(-3*D1*(f**2*fd*k1**2*(12*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - k1**4*s*(2*Pk2 - Pkd2*k2)*(15*r + 15*s - 13) - 3*k1**2*k2**2*(-Pk2*(24*r**2 + 186*r*s - 53*r + 162*s**2 - 129*s + 29) + 2*Pkd2*k2*(12*r*s + 13*r + 12*s**2 + 6*s - 9))) - 2*f*k2**2*(fd*(Pk2*k1**4*(70*C*(r*(4*s - 1) - 3*s + 1) + K*(10*r**2 + 7*r*(4*s + 5) + 18*s**2 + 45*s - 27) - 144*r*s + 30*r - 4*s**2 + 95*s - 29) + k1**2*k2**2*(Pk2*(C*(-300*r**2 + r*(82 - 1112*s) - 308*s**2 + 478*s + 64) + 7*K*(68*r**2 + 144*r*s - 82*r + 76*s**2 - 80*s + 21) + 110*r**2 + 476*r*s - r + 114*s**2 - 199*s - 42) + Pkd2*k2*(7*K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2 - 4*C)*(15*r + 15*s - 4))) + k2**4*(Pk2*(2*C*(116*r**2 + r*(32*s + 3) + 56*s**2 + 152*s - 48) + 14*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 144*r**2 - 60*r*s + 11*r - 56*s**2 - 145*s + 48) + Pkd2*k2*s*(14*C - 7)*(4*r + 4*s - 1))) - 7*k2**2*(5*Pk2*bd2*(k1**2 - 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(k1**2*(Pk2*(2*r**2 + 6*r*s + 3*r + 4*s**2 + 7*s - 5) + Pkd2*k2*s*(r + s - 3)) - 5*k2**2*(Pk2*(6*r**2 + 12*r*s - r + 6*s**2 - s - 5) + Pkd2*k2*s*(2*r + 2*s - 1))))) + 14*fd*k2**4*(5*Pk2*b2*(k1**2 - 5*k2**2)*(r + s)**2 - 2*g2*k1**2*(Pk2*(2*r**2 + 2*r*(3*s + 5) + 4*s**2 + 10*s - 5) + Pkd2*k2*s*(r + s)) + 10*g2*k2**2*(Pk2*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-72*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(4*s + 1) + 60*s**2 - 47*s - 7) + 18*k1**2*k2**2*(-Pk2*(16*r**2 + 2*r*(62*s - 19) + 108*s**2 - 93*s + 16) + Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) + 6*f*k2**2*(Pk2*k1**4*(70*C*(r*(8*s - 1) - 6*s + 1) + K*(20*r**2 + 56*r*s + 67*r + 36*s**2 + 85*s - 69) - 288*r*s + 24*r - 8*s**2 + 190*s - 23) + k1**2*k2**2*(Pk2*(-2*C*(300*r**2 + 8*r*(139*s - 36) + 308*s**2 - 545*s + 47) + 7*K*(136*r**2 + 96*r*(3*s - 2) + 152*s**2 - 186*s + 63) + 220*r**2 + 952*r*s - 216*r + 228*s**2 - 473*s + 38) + Pkd2*k2*(-2*C*(r*(60*s + 3) + 60*s**2 - 31*s - 5) + 7*K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) + 60*r*s + 3*r + 60*s**2 - 31*s - 5)) + k2**4*(2*Pk2*(C*(232*r**2 + r*(64*s - 93) + 112*s**2 + 206*s - 78) + 7*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 144*r**2 - 60*r*s + 64*r - 56*s**2 - 96*s + 39) + Pkd2*k2*(14*C - 7)*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 42*k2**4*(5*Pk2*b2*(k1**2 - 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 2*g2*(k1**2*(Pk2*(8*r**2 + 8*r*(3*s + 1) + 16*s**2 + 20*s - 15) + Pkd2*k2*(r*(4*s + 2) + s*(4*s - 7))) - 5*k2**2*(Pk2*(24*r**2 + 48*r*s + 2*r + 24*s**2 + 2*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + f*(D1*(f**2*fd*k1**4*(36*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(2*Pk2*(25*r + 58*s - 27) + 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(15*Pk2*bd2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k1**4*(2*C*(45*r**2 + 9*r*(14*s + 1) + 81*s**2 + 3*s - 32) - 45*r**2 - 3*r*(48*s + 7) - 99*s**2 - 12*s + 43) + Pk2*k2**4*(36*C - 18)*(9*r**2 + r*(21*s - 13) + 12*s**2 - 13*s + 4) + k1**2*k2**2*(Pk2*(2*C*(990*r**2 + 9*r*(218*s - 149) + 972*s**2 - 1383*s + 472) - 1125*r**2 - 2178*r*s + 1476*r - 1053*s**2 + 1473*s - 499) + Pkd2*k2*(18*C - 9)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) - 6*gd2*(Pk2*k1**4*(5*r**2 + 2*r*(7*s + 8) + 9*s**2 + 20*s - 21) + 14*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + 7*k1**2*k2**2*(Pk2*(34*r**2 + r*(72*s - 55) + 38*s**2 - 53*s + 21) + Pkd2*k2*(5*s - 3)*(r + s - 1)))) - 6*fd*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 2*g2*(Pk2*k1**4*(10*r**2 + 7*r*(4*s + 5) + 18*s**2 + 45*s - 27) + 14*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 7*k1**2*k2**2*(Pk2*(68*r**2 + 144*r*s - 82*r + 76*s**2 - 80*s + 21) + Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))))) + Dd*f*(f**2*k1**4*(36*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(2*Pk2*(25*r + 58*s - 27) + 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(Pk2*k1**4*(2*C*(60*r**2 + 3*r*(56*s + 3) + 108*s**2 - s - 47) - 60*r**2 - 2*r*(96*s + 13) - 132*s**2 - 11*s + 63) + Pk2*k2**4*(72*C - 36)*(6*r**2 + r*(14*s - 9) + 8*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(2*C*(1320*r**2 + 6*r*(436*s - 315) + 1296*s**2 - 1936*s + 691) - 1500*r**2 - 33*r*(88*s - 63) - 1404*s**2 + 2053*s - 727) + Pkd2*k2*(18*C - 9)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) - 6*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(r + s + 3) + 7*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + 2*g2*(Pk2*k1**4*(20*r**2 + r*(56*s + 67) + 36*s**2 + 85*s - 69) + 14*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 7*k1**2*k2**2*(Pk2*(136*r**2 + 96*r*(3*s - 2) + 152*s**2 - 186*s + 63) + Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 29*s + 10)))))))/(315*d**2*k2**2*k3**5) + D1**3*Pkd3*(D1*bd1*f*(3*f**2*k1**4*(6*Pk2*k2**2*(5*r**2 + r*(9*s - 11) + 4*(s - 1)**2) + k1**2*(2*Pk2*(s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(r + s - 1))) + f*k2**2*(Pk2*k2**4*(56*C - 28)*(3*r**2 + r*(5*s - 2) + s*(2*s - 2)) - k1**4*(7*Pk2*b1*(156*r**2 + 9*r*(32*s - 27) + 132*s**2 - 227*s + 91) - 12*Pk2*(2*C*(10*r**2 + r*(28*s - 19) + 18*s**2 - 25*s + 7) - 10*r**2 + r*(21 - 32*s) - 22*s**2 + 30*s - 8) + 126*Pkd2*b1*k2*s*(r + s - 1)) + 2*k1**2*k2**2*(Pk2*(2*C*(267*r**2 + 540*r*s - 351*r + 273*s**2 - 331*s + 58) + 28*K*r*s + 28*K*s**2 - 28*K*s - 14*b1*(18*r**2 + 3*r*(10*s - 7) + 12*s**2 - 19*s + 5) - 288*r**2 - 582*r*s + 393*r - 294*s**2 + 352*s - 58) + Pkd2*k2*s*(42*C - 21)*(r + s - 1))) + 7*k2**2*(5*Pk2*b1**2*k1**2*(4*k1**2 + 5*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 10*Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(20*K*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pk2*k1**4*(50*C*(r*(4*s - 1) - 2*s + 1) + 20*K*r**2 + 36*K*s**2 - 32*K*s + r*(8*K*(7*s - 3) - 108*s + 27) - 8*s**2 + 56*s - 25) + 5*k1**2*k2**2*(2*K*Pkd2*k2*s*(r + s - 1) + Pk2*(C*(-8*r**2 + r*(24*s + 2) - 8*s**2 - 8*s + 6) + 26*K*s**2 - 24*K*s + r**2*(22*K + 2) + 2*r*(24*K*s - 12*K - 8*s + 1) + 2*s**2 + 5*s - 3))) - 4*g2*(2*Pk2*k1**4*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + 10*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 5*k1**2*k2**2*(Pk2*(11*r**2 + r*(24*s - 13) + s*(13*s - 13)) + Pkd2*k2*s*(r + s - 1))))) + 35*Pk2*b1**3*k1**2*k2**2*(4*k1**2 + 5*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 4*Pk2*f*k1**2*k2**4*(D1*(f*fd*(18*C - 9)*(3*s - 1) - 28*f*gd2*s + 28*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(18*C - 9) - 28*g2))*(r + s - 1) + 7*b1**2*k2**2*(D1*fd*(20*K*Pk2*k2**4*(r + s)**2 + 4*Pk2*k1**4*(K*(5*r**2 + 14*r*s + 9*s**2) + s*(50*C*(r - 1) - 27*r - 2*s + 25)) - f*k1**2*(4*Pk2*k2**2*(18*r**2 + 15*r*(2*s - 1) + 12*s**2 - 13*s + 3) + k1**2*(Pk2*(156*r**2 + 3*r*(96*s - 67) + 132*s**2 - 191*s + 69) + 9*Pkd2*k2*s*(2*r + 2*s - 1))) + 10*k1**2*k2**2*(K*Pkd2*k2*s*(r + s) + Pk2*(-4*C*(r**2 - r*(3*s + 2) + s**2 + 3*s + 1) + 13*K*s**2 + r**2*(11*K + 1) + 4*r*(6*K*s - 2*s - 1) + s**2 + 6*s + 2))) - Dd*f*(-20*K*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + k1**4*(-2*Pk2*(50*C*(r*(8*s - 1) - 6*s + 1) + 40*K*r**2 + 112*K*r*s - 34*K*r + 72*K*s**2 - 46*K*s - f*(156*r**2 + 6*r*(48*s - 37) + 132*s**2 - 209*s + 80) - 216*r*s + 27*r - 16*s**2 + 158*s - 25) + 9*Pkd2*f*k2*s*(4*r + 4*s - 3)) - 2*k1**2*k2**2*(5*K*Pkd2*k2*s*(4*r + 4*s - 3) + Pk2*(-10*C*(8*r**2 - 3*r*(8*s + 3) + 8*s**2 + 16*s + 1) - 8*f*(9*r**2 + 3*r*(5*s - 3) + 6*s**2 - 8*s + 2) + 5*r**2*(44*K + 4) + 5*r*(K*(96*s - 35) - 32*s - 5) + 5*s**2*(52*K + 4) + 5*s*(17 - 35*K) + 5)))) + b1*(D1*(3*f**2*fd*k1**4*(6*Pk2*k1**2*s*(5*r + 5*s - 3) + 6*Pk2*k2**2*(15*r**2 + 27*r*s - 23*r + 12*s**2 - 14*s + 8) + 5*Pkd2*k1**2*k2*s*(3*r + 3*s - 2)) + 2*f*k2**2*(35*Pk2*bd2*k1**2*(2*k1**2 + 5*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 6*Pk2*fd*k1**4*(2*r + 2*s - 1)*(2*C*(10*r + 18*s - 5) - 10*r - 22*s + 5) + Pk2*fd*k2**4*(28*C - 14)*(6*r**2 + r*(10*s - 3) + s*(4*s - 3)) + fd*k1**2*k2**2*(Pk2*(2*C*(534*r**2 + 9*r*(120*s - 43) + 546*s**2 - 365*s + 60) + 28*K*(2*s - 1)*(r + s - 1) - 576*r**2 - 1164*r*s + 408*r - 588*s**2 + 365*s - 60) + Pkd2*k2*s*(42*C - 21)*(2*r + 2*s - 1)) - 14*gd2*(2*Pk2*k1**4*(5*r**2 + r*(14*s - 5) + s*(9*s - 7)) + 10*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 5*k1**2*k2**2*(Pk2*(11*r**2 + r*(24*s - 11) + s*(13*s - 11)) + Pkd2*k2*s*(r + s - 1)))) - 14*fd*k2**2*(r + s)*(-5*Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(r + s) + 2*g2*(2*Pk2*k1**4*(5*r + 9*s) + 10*Pk2*k2**4*(r + s) + 5*k1**2*k2**2*(11*Pk2*r + 13*Pk2*s + Pkd2*k2*s)))) + Dd*f*(3*f**2*k1**4*(12*Pk2*k2**2*(10*r**2 + r*(18*s - 17) + 8*s**2 - 11*s + 6) + k1**2*(2*Pk2*(4*s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(4*r + 4*s - 3))) + 2*f*k2**2*(12*Pk2*k1**4*(C*(40*r**2 + 2*r*(56*s - 27) + 72*s**2 - 74*s + 17) - 20*r**2 + r*(28 - 64*s) - 44*s**2 + 43*s - 9) + Pk2*k2**4*(112*C - 56)*(3*r**2 + r*(5*s - 2) + s*(2*s - 2)) + k1**2*k2**2*(Pk2*(C*(2136*r**2 + 30*r*(144*s - 71) + 2184*s**2 - 2006*s + 356) + 28*K*(4*s - 1)*(r + s - 1) - 1152*r**2 - 2328*r*s + 1149*r - 1176*s**2 + 1024*s - 178) + Pkd2*k2*s*(42*C - 21)*(4*r + 4*s - 3))) - 14*k2**2*(-5*Pk2*b2*k1**2*(2*k1**2 + 5*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(2*Pk2*k1**4*(20*r**2 + r*(56*s - 17) + s*(36*s - 23)) + 10*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 5*k1**2*k2**2*(Pk2*(44*r**2 + r*(96*s - 35) + s*(52*s - 35)) + Pkd2*k2*s*(4*r + 4*s - 3)))))))/(105*d**2*k2**2*k3**5)
        
        return np.sqrt((4*np.pi))*(perm12+perm13+perm23)
    
    def l2(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        #get derivs for RR
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)
        
        perm12 = -160*C*D1**3*Pk1*Pk2*f*k2**4*st**6*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(693*d**2*k3**6) - 64*C*D1**3*Pk1*Pk2*k1**2*(D1*bd1*f*(r + s - 1)*(2*b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s)) + b1*(D1*fd*(b1*(k1**2 + 7*k2**2)*(r + s)**2 + f*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1)) + 2*Dd*f*(2*r + 2*s - 1)*(b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s))))/(21*d**2*k3**6) + 64*C*D1**3*Pk1*Pk2*k2**2*st**4*(D1*(-11*b1**2*fd*k2**2*(r + s)**2 + 11*b1*f*(-2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + f**2*(11*bd1*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1) + 2*fd*k1**2*(3*r + 3*s - 2)**2)) + 2*Dd*f*(2*r + 2*s - 1)*(-11*b1**2*k2**2*(r + s) + 11*b1*f*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + 2*f**2*k1**2*(3*r + 3*s - 2)))/(77*d**2*k3**6) + 32*C*D1**3*Pk1*Pk2*st**2*(33*D1*bd1*f*(2*b1*k2**2*(13*k1**2 + 7*k2**2)*(r + s) + f*(k1**4*(r + s - 1) + 4*k1**2*k2**2*(r + s) - k2**4*(r + s)))*(r + s - 1) + 33*b1**2*k2**2*(13*k1**2 + 7*k2**2)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 33*b1*f*(D1*fd + 2*Dd*f)*(k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 4*k1**2*k2**2*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + k2**4*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) + f**2*k1**2*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d**2*k3**6) - 16*C*D1**3*Pk2*Pkd1*f*k1*k2**2*st**4*(D1*(11*b1*fd*r*(2*r + 2*s - 1) + 11*bd1*f*r*(r + s - 1) + 2*f*fd*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(22*b1*r*(2*r + 2*s - 1) + f*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)))/(77*d**2*k3**4) - 8*C*D1**3*Pk2*Pkd1*st**2*(33*D1*bd1*f*(b1*k1*k2**2*(26*r**2 + r*(26*s - 23) - 3*s) + f*(k1*k2**2*(4*r**2 + 4*r*s + r + 3*s - 2) + (2*r - 1)*(r + s - 1)*(k1**2)**(3/2))) + 33*b1**2*k1*k2**2*(13*D1*fd*r*(r + s) + Dd*f*(52*r**2 + r*(52*s - 23) - 3*s)) + 33*b1*f*(D1*fd*(k1*k2**2*(8*r**2 + r*(8*s - 7) - 5*s + 2) + r*(4*r + 4*s - 3)*(k1**2)**(3/2)) + Dd*f*(2*k1*k2**2*r*(8*s - 3) + r**2*(16*k1*k2**2 + 8*(k1**2)**(3/2)) + r*(8*s - 7)*(k1**2)**(3/2) - s*(2*k1*k2**2 + (k1**2)**(3/2)) + (k1**2)**(3/2))) + f**2*(D1*fd*(-33*k1*k2**2*(3*r - 1)*(3*r + 3*s - 2) + (54*r**2 + 54*r*(s - 1) + 15*s + 1)*(k1**2)**(3/2)) + Dd*f*(-33*k1*k2**2*(4*r - 1)*(3*r + 3*s - 2) + (72*r**2 + 9*r*(8*s - 7) + 23*s + 1)*(k1**2)**(3/2))))/(693*d**2*k3**4) + 16*C*D1**3*Pk2*Pkd1*(D1*bd1*f*(b1*(7*k1*k2**2*r*(2*s - 1) + r**2*(14*k1*k2**2 + 4*(k1**2)**(3/2)) + r*(4*s - 3)*(k1**2)**(3/2) - s*(7*k1*k2**2 + (k1**2)**(3/2))) + f*(r**2*(6*k1*k2**2 + 4*(k1**2)**(3/2)) + r*(6*k1*k2**2*s + 4*s*(k1**2)**(3/2) - 4*(k1**2)**(3/2)) - (s - 1)*(k1**2)**(3/2))) + b1*(D1*fd*(b1*r*(r + s)*(7*k1*k2**2 + 2*(k1**2)**(3/2)) + 2*f*(2*r - 1)*(3*k1*k2**2*r + 3*k1*k2**2*s + 2*r*(k1**2)**(3/2) + 2*s*(k1**2)**(3/2) - (k1**2)**(3/2))) + Dd*f*(b1*(7*k1*k2**2*r*(4*s - 1) + r**2*(28*k1*k2**2 + 8*(k1**2)**(3/2)) + r*(8*s - 3)*(k1**2)**(3/2) - s*(7*k1*k2**2 + (k1**2)**(3/2))) + f*(6*k1*k2**2*r*(4*s - 1) + r**2*(24*k1*k2**2 + 16*(k1**2)**(3/2)) + 2*r*(8*s - 7)*(k1**2)**(3/2) - s*(6*k1*k2**2 + 6*(k1**2)**(3/2)) + 3*(k1**2)**(3/2)))))/(21*d**2*k3**4) + 8*C*D1**3*Pk2*Pkdd1*f**2*k2**2*st**4*(3*r - 1)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k3**2) - 8*C*D1**3*Pk2*Pkdd1*k1**2*(D1*bd1*f**2*r*(2*r - 1) + b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(D1*bd1*r + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2*k3**2) + 4*C*D1**3*Pk2*Pkdd1*st**2*(D1*(33*b1**2*fd*k2**2*r**2 + 33*b1*f*r*(bd1*k2**2*(2*r - 1) + 2*fd*k1**2*r + fd*k2**2*(2*r - 1)) + f**2*(33*bd1*r*(k1**2*(r - 1) + k2**2*r) + fd*k1**2*(27*r**2 + 15*r - 8))) + Dd*f*(4*r - 1)*(33*b1**2*k2**2*r + 33*b1*f*r*(k1**2 + k2**2) + f**2*k1**2*(9*r + 8)))/(693*d**2*k3**2) - D1**3*Pk1*Pk2*ct**8*f*k2**4*(320*C - 320)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(51*r + 51*s - 23))/(693*d**2*k3**6) - 32*D1**3*Pk1*Pk2*ct**7*f*(33*D1*bd1*f*(k1**2*(k2**3*(4*C*(11*r**2 - 4*r*(3*s + 2) + 11*s**2 - s - 3) - 54*r**2 + 6*r*(8*s + 7) - 54*s**2 + 9*s + 12) + (4*C*(2*r*(17*s - 5) - 17*s + 10) + r*(45 - 156*s) + 78*s - 45)*(k2**2)**(3/2)) - 5*k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(D1*fd*(k1**2*(k2**3*(4*C*(22*r**2 - 24*r*s + 12*r + 22*s**2 - 25*s + 7) - 108*r**2 + 96*r*s - 48*r - 108*s**2 + 120*s - 33) + 4*r*(C*(68*s - 37) - 78*s + 42)*(k2**2)**(3/2)) - 5*k2**5*(2*r + 2*s - 1)**2) + Dd*f*(k1**2*(k2**3*(4*C*(44*r**2 - 48*r*s + 7*r + 44*s**2 - 33*s + 4) - 216*r**2 + 192*r*s - 18*r - 216*s**2 + 162*s - 21) + (4*C*(136*r*s - 57*r - 17*s + 10) - 624*r*s + 258*r + 78*s - 45)*(k2**2)**(3/2)) - 10*k2**5*(2*r + 2*s - 1)**2)) + 5*f*(D1*fd*(k1**2*(k2**3*(C*(630*r**2 - 792*r*s + 240*r + 630*s**2 - 552*s + 52) - 783*r**2 + 792*r*s - 204*r - 783*s**2 + 687*s - 75) + (2*C*(1026*r*s - 507*r - 111*s + 92) - 2358*r*s + 1149*r + 258*s - 207)*(k2**2)**(3/2)) - k2**5*(153*r**2 + 9*r*(34*s - 19) + 153*s**2 - 171*s + 46)) + Dd*f*(k1**2*(k2**3*(2*C*(420*r**2 - 528*r*s + 173*r + 420*s**2 - 355*s + 26) - 1044*r**2 + 1056*r*s - 315*r - 1044*s**2 + 873*s - 75) + (2*C*(1368*r*s - 619*r - 91*s + 92) - 3144*r*s + 1401*r + 213*s - 207)*(k2**2)**(3/2)) - 2*k2**5*(102*r**2 + r*(204*s - 97) + 102*s**2 - 97*s + 23))))/(693*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**6*f*k2**4*st**2*(160*C - 160)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(53*r + 53*s - 28))/(231*d**2*k3**6) + 32*D1**3*Pk1*Pk2*ct**6*k2**2*(-66*D1*bd1*f*(r + s - 1)*(12*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(12*C*(r + s - 1) - 23*r - 23*s + 19) - 3*f*k2**2*(C*(6*r + 6*s - 4) + r + s)) - 396*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 66*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(12*C*(r + s - 1) - 23*r - 23*s + 19) - 3*k2**2*(C*(6*r + 6*s - 4) + r + s))*(2*r + 2*s - 1) - 5*f**2*(k1**2*(C*(84*r + 84*s - 78) - 189*r - 189*s + 137) + k2**2*(-2*C*(117*r + 117*s - 56) + 27*r + 27*s - 7))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d**2*k3**6) - 16*D1**3*Pk1*Pk2*ct**5*f*st**2*(33*D1*bd1*f*(k1**2*(k2**3*(4*C*(31*r**2 - 4*r*(3*s + 7) + 31*s**2 - 11*s - 3) - 154*r**2 + 48*r*s + 142*r - 154*s**2 + 59*s + 12) + (4*C*(74*r*s - 20*r - 37*s + 20) - 356*r*s + 95*r + 178*s - 95)*(k2**2)**(3/2)) - 15*k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(D1*fd*(k1**2*(k2**3*(4*C*(62*r**2 - 24*r*s + 12*r + 62*s**2 - 65*s + 17) - 308*r**2 + 96*r*s - 48*r - 308*s**2 + 320*s - 83) + 4*r*(C*(148*s - 77) - 178*s + 92)*(k2**2)**(3/2)) - 15*k2**5*(2*r + 2*s - 1)**2) + Dd*f*(k1**2*(k2**3*(4*C*(124*r**2 - 48*r*s - 13*r + 124*s**2 - 93*s + 14) - 616*r**2 + 192*r*s + 82*r - 616*s**2 + 462*s - 71) + (4*C*(296*r*s - 117*r - 37*s + 20) - 1424*r*s + 558*r + 178*s - 95)*(k2**2)**(3/2)) - 30*k2**5*(2*r + 2*s - 1)**2)) + f*(D1*fd*(k1**2*(k2**3*(4*C*(2223*r**2 - 36*r*(33*s + 10) + 2223*s**2 - 1746*s + 340) - 11277*r**2 + 6*r*(792*s + 395) - 11277*s**2 + 8904*s - 1780) + 2*(2*C*(9*r*(626*s - 271) - 1053*s + 538) + r*(5838 - 13653*s) + 2571*s - 1286)*(k2**2)**(3/2)) - 15*k2**5*(159*r**2 + 2*r*(159*s - 95) + 159*s**2 - 190*s + 56)) + Dd*f*(k1**2*(k2**3*(4*C*(2964*r**2 - 1584*r*s - 299*r + 2964*s**2 - 2147*s + 340) - 15036*r**2 + 6336*r*s + 2171*r - 15036*s**2 + 10883*s - 1780) + (4*C*(7512*r*s - 2939*r - 1091*s + 538) - 36408*r*s + 14051*r + 5339*s - 2572)*(k2**2)**(3/2)) - 30*k2**5*(106*r**2 + r*(212*s - 109) + 106*s**2 - 109*s + 28))))/(693*d**2*k1*k3**6) + 32*D1**3*Pk1*Pk2*ct**5*(33*D1*bd1*f*(-2*b1*k1**2*(k2**3*(r**2*(20*C - 26) + r*(-28*C*s - 3*C + 28*s + 6) + s*(20*C*s - 3*C - 26*s + 6)) + (17*C - 20)*(r*(4*s - 1) - s)*(k2**2)**(3/2)) + 12*b1*k2**5*(r**2 + r*(2*s - 1) + s*(s - 1)) + 4*f*k1**4*k2*(r + s - 1)*(C*(r + s + 1) + 2*r + 2*s - 4) + f*k1**2*(k2**3*(4*C*(24*r**2 + 32*r*s - 39*r + 24*s**2 - 27*s + 8) - 60*r**2 - 120*r*s + 117*r - 60*s**2 + 78*s - 24) + (4*C*(16*r*s - 3*r - 15*s + 10) + 12*r**2 + 24*r*s - 30*r + 12*s**2 + 9*s - 15)*(k2**2)**(3/2)) - f*k2**5*(8*r**2 + r*(16*s - 15) + 8*s**2 - 15*s + 7)) - 66*b1**2*(D1*fd*(k1**2*(k2**3*(r**2*(10*C - 13) - r*s*(14*C - 14) + s**2*(10*C - 13)) + r*s*(34*C - 40)*(k2**2)**(3/2)) - 3*k2**5*(r + s)**2) + Dd*f*(k1**2*(k2**3*(r**2*(40*C - 52) + r*(-56*C*s - 3*C + 56*s + 6) + s*(40*C*s - 3*C - 52*s + 6)) + (17*C - 20)*(r*(8*s - 1) - s)*(k2**2)**(3/2)) - 6*k2**5*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)))) + 33*b1*f*(D1*fd*(4*k1**4*k2*(2*r + 2*s - 1)*(C*(r + s + 1) + 2*r + 2*s - 4) + k1**2*(k2**3*(4*C*(48*r**2 + 64*r*s - 31*r + 48*s**2 - 61*s + 18) - 120*r**2 - 240*r*s + 102*r - 120*s**2 + 168*s - 51) + 2*(2*C*s + 12*r**2 + 2*r*(32*C*s - 29*C + 12*s + 6) + 12*s**2 - 21*s + 6)*(k2**2)**(3/2)) - k2**5*(16*r**2 + r*(32*s - 22) + 16*s**2 - 22*s + 7)) + Dd*f*(8*k1**4*k2*(2*r + 2*s - 1)*(C*(r + s + 1) + 2*r + 2*s - 4) + k1**2*(k2**3*(8*C*(48*r**2 + 8*r*(8*s - 5) + 48*s**2 - 52*s + 13) - 240*r**2 - 12*r*(40*s - 21) - 240*s**2 + 288*s - 75) + (8*C*(4*r - 1)*(8*s - 5) + 48*r**2 + 96*r*s + 48*s**2 - 36*s - 3)*(k2**2)**(3/2)) - 2*k2**5*(16*r**2 + r*(32*s - 22) + 16*s**2 - 22*s + 7))) + 5*f**2*(D1*fd*(k1**4*k2*(3*r + 3*s - 2)*(2*C*(27*r + 27*s - 7) - 12*r - 12*s - 25) + k1**2*(3*k2**3*(2*C*(270*r**2 + 6*r*(45*s - 34) + 270*s**2 - 303*s + 79) - 396*r**2 - 176*r*(3*s - 2) - 396*s**2 + 451*s - 121) + (2*C*(810*r*s - 402*r - 105*s + 79) + 126*r**2 - 540*r*s + 228*r + 126*s**2 - 69*s - 21)*(k2**2)**(3/2)) - 33*k2**5*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Dd*f*(2*k1**4*k2*(2*r + 2*s - 1)*(2*C*(27*r + 27*s - 7) - 12*r - 12*s - 25) + k1**2*(3*k2**3*(2*C*(360*r**2 + 360*r*s - 227*r + 360*s**2 - 359*s + 79) - 528*r**2 - 704*r*s + 396*r - 528*s**2 + 528*s - 121) + (2*C*(1080*r*s - 491*r - 95*s + 79) + 168*r**2 - 720*r*s + 288*r + 168*s**2 - 108*s - 21)*(k2**2)**(3/2)) - 66*k2**5*(2*r + 2*s - 1)**2)))/(693*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**4*f**2*k2**4*st**4*(320*C - 320)*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2)/(77*d**2*k3**6) + 32*D1**3*Pk1*Pk2*ct**4*k2**2*st**2*(-33*D1*bd1*f*(r + s - 1)*(12*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(9*C*(5*r + 5*s - 3) - 76*r - 76*s + 44) - f*k2**2*(3*C*(11*r + 11*s - 6) + 28*r + 28*s - 14)) - 198*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 33*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C*(5*r + 5*s - 3) - 76*r - 76*s + 44) - k2**2*(3*C*(11*r + 11*s - 6) + 28*r + 28*s - 14))*(2*r + 2*s - 1) - f**2*(k1**2*(306*C*(3*r + 3*s - 2) - 1659*r - 1659*s + 1051) - k2**2*(3*C*(397*r + 397*s - 206) + 345*r + 345*s - 241))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d**2*k3**6) - 32*D1**3*Pk1*Pk2*ct**4*(-66*D1*bd1*f*(r + s - 1)*(C*(-2*b1*k2**2*(k1**2 - 13*k2**2)*(r + s) + f*(k1**4*(2*r + 2*s - 1) + 6*k1**2*k2**2*(7*r + 7*s - 6) + k2**4*(-2*r - 2*s + 7))) - 4*b1*k2**2*(-3*k1**2 + k2**2)*(r + s) - f*(3*k1**4*(r + s) + 2*k1**2*k2**2*(22*r + 22*s - 17) + k2**4*(19*r + 19*s - 11))) + 66*b1**2*k2**2*(r + s)*(k1**2*(C - 6) + k2**2*(2 - 13*C))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 66*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(C*(k1**4*(2*r + 2*s - 1) + 6*k1**2*k2**2*(7*r + 7*s - 6) + k2**4*(-2*r - 2*s + 7)) - 3*k1**4*(r + s) - 2*k1**2*k2**2*(22*r + 22*s - 17) + k2**4*(-19*r - 19*s + 11)) - 5*f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(10*C*(3*r + 3*s - 2) - 57*r - 57*s + 27) + 4*k1**2*k2**2*(C*(87*r + 87*s - 69) - 114*r - 114*s + 76) - 33*k2**4*(C*(4*r + 4*s - 2) + 5*r + 5*s - 3)))/(693*d**2*k3**6) - 32*D1**3*Pk1*Pk2*ct**3*f*st**4*(66*D1*bd1*f*k1**2*(C - 1)*(k2**3*(3*r**2 + 4*r*(s - 1) + 3*s**2 - 3*s + 1) + s*(2*r - 1)*(k2**2)**(3/2)) + 66*b1*k1**2*(C - 1)*(D1*fd*(k2**3*(6*r**2 + 8*r*s - 4*r + 6*s**2 - 5*s + 1) + r*(4*s - 1)*(k2**2)**(3/2)) + Dd*f*(k2**3*(12*r**2 + 16*r*s - 9*r + 12*s**2 - 9*s + 2) + (8*r*s - r - s)*(k2**2)**(3/2))) + 5*f*(D1*fd*(k1**2*(8*C - 11)*(k2**3*(9*r**2 - 6*r + 9*s**2 - 6*s + 2) + 2*(3*r - 1)*(3*s - 1)*(k2**2)**(3/2)) - 3*k2**5*(3*r + 3*s - 2)**2) + Dd*f*(k1**2*(8*C - 11)*(k2**3*(12*r**2 - 7*r + 12*s**2 - 7*s + 2) + (r*(24*s - 7) - 7*s + 2)*(k2**2)**(3/2)) - 6*k2**5*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2))))/(231*d**2*k1*k3**6) + 16*D1**3*Pk1*Pk2*ct**3*st**2*(33*D1*bd1*f*(-2*b1*k1**2*(k2**3*(r**2*(52*C - 58) + r*(28*C*s - 33*C - 28*s + 36) + s*(52*C*s - 33*C - 58*s + 36)) + (19*C - 22)*(r*(4*s - 1) - s)*(k2**2)**(3/2)) + 12*b1*k2**5*(r**2 + r*(2*s - 1) + s*(s - 1)) - f*k1**4*k2*(r + s - 1)*(2*C*(13*r + 13*s - 9) - 71*r - 71*s + 45) + f*k1**2*(k2**3*(2*C*(61*r**2 + r*(82*s - 95) + 61*s**2 - 67*s + 23) - r**2 + r*(44 - 64*s) - s**2 + 13*s - 15) + (C*(r*(80*s - 6) - 62*s + 28) + 45*r**2 + 2*r*(76*s - 53) + 45*s**2 - 75*s + 33)*(k2**2)**(3/2)) - 3*f*k2**5*(r + s - 1)**2) - 66*b1**2*(D1*fd*(k1**2*(k2**3*(r**2*(26*C - 29) + r*s*(14*C - 14) + s**2*(26*C - 29)) + r*s*(38*C - 44)*(k2**2)**(3/2)) - 3*k2**5*(r + s)**2) + Dd*f*(k1**2*(k2**3*(r**2*(104*C - 116) + r*(56*C*s - 33*C - 56*s + 36) + s*(104*C*s - 33*C - 116*s + 36)) + (19*C - 22)*(r*(8*s - 1) - s)*(k2**2)**(3/2)) - 6*k2**5*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)))) + 33*b1*f*(D1*fd*(-k1**4*k2*(2*r + 2*s - 1)*(2*C*(13*r + 13*s - 9) - 71*r - 71*s + 45) + k1**2*(k2**3*(2*C*(122*r**2 + 164*r*s - 58*r + 122*s**2 - 164*s + 37) - 2*r**2 - 128*r*s - 11*r - 2*s**2 + 92*s - 9) + (58*C*s + 90*r**2 + r*(2*C*(80*s - 77) + 304*s - 69) + 90*s**2 - 172*s + 27)*(k2**2)**(3/2)) - 3*k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(-2*k1**4*k2*(2*r + 2*s - 1)*(2*C*(13*r + 13*s - 9) - 71*r - 71*s + 45) + k1**2*(k2**3*(4*C*(122*r**2 + 164*r*s - 85*r + 122*s**2 - 137*s + 30) - 4*r**2 - 256*r*s + 33*r - 4*s**2 + 129*s - 24) + (4*C*(80*r*s - 50*r + 2*s + 7) + 180*r**2 + 608*r*s - 193*r + 180*s**2 - 289*s + 60)*(k2**2)**(3/2)) - 6*k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + f**2*(D1*fd*(-18*k1**4*k2*(3*r + 3*s - 2)*(C*(23*r + 23*s - 19) - 74*r - 74*s + 53) + k1**2*(3*k2**3*(2*C*(1977*r**2 + 46*r*(48*s - 37) + 1977*s**2 - 2230*s + 626) - 1386*r**2 - 33*r*(60*s - 39) - 1386*s**2 + 1584*s - 429) + (2*C*(5238*r*s - 2373*r - 789*s + 472) + 2754*r**2 + 3132*r*s - 2385*r + 2754*s**2 - 3276*s + 927)*(k2**2)**(3/2)) - 198*k2**5*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Dd*f*(-36*k1**4*k2*(2*r + 2*s - 1)*(C*(23*r + 23*s - 19) - 74*r - 74*s + 53) + k1**2*(3*k2**3*(2*C*(2636*r**2 + 2944*r*s - 1927*r + 2636*s**2 - 2631*s + 626) - 1848*r**2 - 2640*r*s + 1452*r - 1848*s**2 + 1848*s - 429) + (2*C*(6984*r*s - 2873*r - 761*s + 472) + 3672*r**2 + 4176*r*s - 2700*r + 3672*s**2 - 3888*s + 927)*(k2**2)**(3/2)) - 396*k2**5*(2*r + 2*s - 1)**2)))/(693*d**2*k1*k3**6) - 32*D1**3*Pk1*Pk2*ct**3*(33*D1*bd1*f*(b1*(-k1**4*(16*C - 14)*(r**2 + r*(2*s - 1) + s*(s - 1))*(k2**2)**(3/2) - k1**2*k2**4*(k2*(2*r**2 + r*(96*C*s - 24*C - 24*s + 5) + s*(-24*C + 2*s + 5)) + (r**2*(96*C - 70) + r*(96*C*s - 72*C - 112*s + 63) + s*(96*C*s - 72*C - 70*s + 63))*np.sqrt(k2**2)) + 14*k2**6*(r**2 + r*(2*s - 1) + s*(s - 1))*np.sqrt(k2**2)) + f*(k1**6*(k2*(r*(5 - 8*s) + 4*s - 5) + (2*r**2 + 4*r*(3*s - 2) + 2*s**2 - 7*s + 6)*np.sqrt(k2**2)) - 3*k1**4*(r + s - 1)*(8*C*(r + s - 1) - 20*r - 20*s + 15)*(k2**2)**(3/2) + 2*k1**2*k2**4*(k2*(2*C*(22*r*s - 5*r - 16*s + 10) + 15*r**2 + 30*r*s - 27*r + 15*s**2 - 24*s + 9) + (2*C*(7*r**2 - 8*r*s - 13*r + 7*s**2 - 2*s + 1) + 15*r**2 + 30*r*s - 15*r + 15*s**2 - 18*s + 3)*np.sqrt(k2**2)) + 6*k2**6*(r**2 + r*(2*s - 1) + s*(s - 1))*np.sqrt(k2**2))) + 33*b1**2*(D1*fd*(-k1**4*(8*C - 7)*(r + s)**2*(k2**2)**(3/2) - k1**2*k2**4*(k2*(r**2 + r*s*(48*C - 12) + s**2) + (r**2*(48*C - 35) + r*s*(48*C - 56) + s**2*(48*C - 35))*np.sqrt(k2**2)) + 7*k2**6*(r + s)**2*np.sqrt(k2**2)) + Dd*f*(-k1**4*(16*C - 14)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*(k2**2)**(3/2) - k1**2*k2**4*(k2*(4*r**2 + r*(24*C*(8*s - 1) - 48*s + 5) + s*(-24*C + 4*s + 5)) + (r**2*(192*C - 140) + r*(24*C*(8*s - 3) - 224*s + 63) + s*(24*C*(8*s - 3) - 140*s + 63))*np.sqrt(k2**2)) + 14*k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2))) + 33*b1*f*(D1*fd*(k1**6*(-2*k2*r*(8*s - 7) + (4*r**2 + 6*r*(4*s - 3) + (1 - 2*s)**2)*np.sqrt(k2**2)) - 3*k1**4*(2*r + 2*s - 1)*(8*C*(r + s - 1) - 20*r - 20*s + 15)*(k2**2)**(3/2) + 4*k1**2*k2**4*(k2*(2*C*s + 15*r**2 + r*(44*C*s - 33*C + 30*s - 15) + 15*s**2 - 21*s + 6) + (C*(14*r**2 + r*(4 - 16*s) + 14*s**2 - 31*s + 11) + 15*r**2 + 6*r*(5*s - 2) + 3*s*(5*s - 2))*np.sqrt(k2**2)) + 6*k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2)) + Dd*f*(k1**6*(k2*(-8*r*(4*s - 3) + 4*s - 5) + (8*r**2 + 16*r*(3*s - 2) + 8*s**2 - 12*s + 7)*np.sqrt(k2**2)) - 6*k1**4*(2*r + 2*s - 1)*(8*C*(r + s - 1) - 20*r - 20*s + 15)*(k2**2)**(3/2) + 2*k1**2*k2**4*(k2*(2*C*(r*(88*s - 47) - 15*s + 10) + 60*r**2 + 3*r*(40*s - 22) + 60*s**2 - 78*s + 21) + (C*(56*r**2 - 2*r*(32*s + 11) + 56*s**2 - 86*s + 24) + 60*r**2 + 6*r*(20*s - 7) + 60*s**2 - 30*s + 3)*np.sqrt(k2**2)) + 12*k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2))) + 5*f**2*k1**2*(D1*fd*(k1**4*(k2*(-6*r*(18*s - 17) + 3*s - 23) + (45*r**2 + 18*r*(11*s - 9) + 45*s**2 - 63*s + 43)*np.sqrt(k2**2)) - k1**2*(3*r + 3*s - 2)*(4*C*(3*r + 3*s - 13) - 213*r - 213*s + 175)*(k2**2)**(3/2) + 33*k2**4*(k2*(2*C*(30*r*s - 14*r - 5*s + 3) + 12*r**2 + 18*r*s - 13*r + 12*s**2 - 16*s + 5) + (2*C*(15*r**2 - 5*r + 15*s**2 - 14*s + 3) + 6*r*s - 4*r - s + 1)*np.sqrt(k2**2))) + Dd*f*(k1**4*(-k2*(2*r*(72*s - 65) + 2*s + 23) + (60*r**2 + 8*r*(33*s - 25) + 60*s**2 - 68*s + 43)*np.sqrt(k2**2)) - 2*k1**2*(2*r + 2*s - 1)*(4*C*(3*r + 3*s - 13) - 213*r - 213*s + 175)*(k2**2)**(3/2) + 33*k2**4*(k2*(2*C*(r*(40*s - 17) - 5*s + 3) + 16*r**2 + 3*r*(8*s - 5) + 16*s**2 - 19*s + 5) + (2*C*(20*r**2 - 5*r + 20*s**2 - 17*s + 3) + r*(8*s - 5) - s + 1)*np.sqrt(k2**2)))))/(693*d**2*k1*k2*k3**6*np.sqrt(k2**2)) + D1**3*Pk1*Pk2*ct**2*f*k2**4*st**6*(160*C - 160)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)**2 + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(693*d**2*k3**6) + 32*D1**3*Pk1*Pk2*ct**2*k2**2*st**4*(-33*D1*bd1*f*(r + s - 1)*(-4*b1*k2**2*(C - 1)*(r + s) + f*k1**2*(r*(2*C - 5) + s*(2*C - 5) + 1) + f*k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 3)) + 66*b1**2*k2**2*(C - 1)*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 33*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(2*C*s + r*(2*C - 5) - 5*s + 1) + k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 3))*(2*r + 2*s - 1) - 2*f**2*(k1**2*(6*C - 16) - k2**2*(15*C + 10))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(3*r + 3*s - 2))/(231*d**2*k3**6) - 16*D1**3*Pk1*Pk2*ct**2*st**2*(33*D1*bd1*f*(4*b1*k2**2*(r + s)*(k1**2*(13*C - 26) + k2**2*(C - 20)) + f*(k1**4*(2*C*(r + s - 1) - 15*r - 15*s + 11) - 2*k1**2*k2**2*(C*(41*r + 41*s - 27) + 11*r + 11*s - 3) + k2**4*(C*(4*r + 4*s - 6) + r + s - 3)))*(r + s - 1) + 66*b1**2*k2**2*(r + s)*(k1**2*(13*C - 26) + k2**2*(C - 20))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 33*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C*(r + s - 1) - 15*r - 15*s + 11) - 2*k1**2*k2**2*(C*(41*r + 41*s - 27) + 11*r + 11*s - 3) + k2**4*(C*(4*r + 4*s - 6) + r + s - 3)) + f**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(2*C*(9*r + 9*s - 17) - 225*r - 225*s + 205) - 6*k1**2*k2**2*(C*(350*r + 350*s - 237) - 92*r - 92*s + 54) + 99*k2**4*(C*(8*r + 8*s - 4) + 5*r + 5*s - 3)))/(693*d**2*k3**6) - 32*D1**3*Pk1*Pk2*ct**2*(66*D1*bd1*f*(-2*b1*(r + s)*(k1**4*(C - 3) + k1**2*k2**2*(8*C - 16) - k2**4*(7*C + 7)) + f*(k1**4*(9*r + 9*s - 6) + k1**2*k2**2*(24*C*(r + s - 1) + 19*r + 19*s - 5) + k2**4*(6*C + 6)*(r + s)))*(r + s - 1) - 66*b1**2*(r + s)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1))*(k1**4*(C - 3) + k1**2*k2**2*(8*C - 16) - k2**4*(7*C + 7)) + 66*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(9*r + 9*s - 6) + k1**2*k2**2*(24*C*(r + s - 1) + 19*r + 19*s - 5) + k2**4*(6*C + 6)*(r + s)) + 5*f**2*k1**2*(k1**2*(10*C*(3*r + 3*s - 2) + 33*r + 33*s - 33) + 33*k2**2*(C*(8*r + 8*s - 6) + r + s - 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d**2*k3**6) - 80*D1**3*Pk1*Pk2*ct*f*st**6*(33*b1*(D1*fd*(k1**2*(k2**3*(4*r**2 + (1 - 2*s)**2) + 4*r*(2*s - 1)*(k2**2)**(3/2)) + k2**5*(2*r + 2*s - 1)**2) + Dd*f*(k1**2*(k2**3*(8*r**2 - 2*r + 8*s**2 - 6*s + 1) + (2*r*(8*s - 3) - 2*s + 1)*(k2**2)**(3/2)) + 2*k2**5*(2*r + 2*s - 1)**2)) + f*(33*D1*bd1*(k1**2*k2**3*(2*r**2 - 2*r + s*(2*s - 1)) + k1**2*(r*(4*s - 1) - 2*s + 1)*(k2**2)**(3/2) + k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*fd*(k1**2*(k2**3*(9*r**2 - 6*r + 9*s**2 - 6*s + 2) + 2*(3*r - 1)*(3*s - 1)*(k2**2)**(3/2)) + k2**5*(3*r + 3*s - 2)**2) + Dd*f*k1**2*(k2**3*(12*r**2 - 7*r + 12*s**2 - 7*s + 2) + (r*(24*s - 7) - 7*s + 2)*(k2**2)**(3/2)) + 2*Dd*f*k2**5*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)))/(693*d**2*k1*k3**6) - 32*D1**3*Pk1*Pk2*ct*k1*(10*C*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1)*(k2**2)**(3/2) + D1*bd1*f*(b1*(k1**4*(k2*(r*(4*s - 1) - s) + (2*r**2 - r + s*(2*s - 1))*np.sqrt(k2**2)) + k1**2*(16*C + 16)*(r**2 + r*(2*s - 1) + s*(s - 1))*(k2**2)**(3/2) + 14*k2**4*(2*C*(2*r**2 - r + s*(2*s - 1))*np.sqrt(k2**2) + k2*(r**2 + r*(8*C*s - 2*C + 2*s - 1) + s*(-2*C + s - 1)))) + f*(k1**4*(k2*(r*(4*s - 2) - s + 1) + (2*r**2 - r + s*(2*s - 2))*np.sqrt(k2**2)) + k1**2*(r + s - 1)*(4*C*(7*r + 7*s - 5) + 8*r + 8*s - 1)*(k2**2)**(3/2) + 6*k2**4*(4*C*(r**2 + s*(s - 1))*np.sqrt(k2**2) + k2*(r**2 + r*(4*C + 1)*(2*s - 1) + s*(s - 1))))) + b1**2*(D1*fd*(28*C*k2**4*(r**2 + s**2)*np.sqrt(k2**2) + 2*k1**4*k2*r*s + k1**2*(k1**2*(r**2 + s**2) + k2**2*(8*C + 8)*(r + s)**2)*np.sqrt(k2**2) + 7*k2**5*(r**2 + 2*r*(4*C*s + s) + s**2)) + Dd*f*(k1**4*(k2*(r*(8*s - 1) - s) + (4*r**2 - r + s*(4*s - 1))*np.sqrt(k2**2)) + k1**2*(16*C + 16)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*(k2**2)**(3/2) + 14*k2**4*(2*C*(4*r**2 - r + s*(4*s - 1))*np.sqrt(k2**2) + k2*(2*r**2 + r*(16*C*s - 2*C + 4*s - 1) + s*(-2*C + 2*s - 1))))) + b1*f*(D1*fd*(k1**4*(-4*k2*s + 4*r**2*np.sqrt(k2**2) - 4*r*(-2*k2*s + np.sqrt(k2**2)) + (4*s**2 + 1)*np.sqrt(k2**2)) + k1**2*(2*r + 2*s - 1)*(4*C*(7*r + 7*s - 5) + 8*r + 8*s - 1)*(k2**2)**(3/2) + 6*k2**4*(4*C*(2*r**2 - r + 2*s**2)*np.sqrt(k2**2) + k2*(2*r**2 + r*(16*C*s + 4*s - 1) + s*(-4*C + 2*s - 1)))) + Dd*f*(k1**4*(2*k2*r*(8*s - 1) - 6*k2*s + k2 + (8*r**2 - 6*r + 8*s**2 - 2*s + 1)*np.sqrt(k2**2)) + 2*k1**2*(2*r + 2*s - 1)*(4*C*(7*r + 7*s - 5) + 8*r + 8*s - 1)*(k2**2)**(3/2) + 12*k2**4*(2*C*(4*r**2 - r + s*(4*s - 1))*np.sqrt(k2**2) + k2*(2*r**2 + r*(16*C*s - 2*C + 4*s - 1) + s*(-2*C + 2*s - 1))))))/(21*d**2*k2*k3**6*np.sqrt(k2**2)) + 32*D1**3*Pk1*Pk2*ct*st**4*(D1*(-33*b1**2*fd*(k1**2*(k2**3*(r**2 + s**2) + 2*r*s*(k2**2)**(3/2)) + k2**5*(r + s)**2) + 33*b1*f*(bd1*k1**2*(k2**3*(-2*r**2 + r - 2*s**2 + s) + (-4*r*s + r + s)*(k2**2)**(3/2)) - 2*bd1*k2**5*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*k1**4*k2*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + fd*k1**2*(k2**3*(2*C*(6*r**2 + r*(4*s - 1) + 6*s**2 - 5*s + 1) + (2*r + 2*s - 1)**2) + (2*r**2 + r*(8*C*(2*s - 1) + 4*s - 1) + s*(2*s - 1))*(k2**2)**(3/2)) + fd*k2**5*(2*r + 2*s - 1)**2) + f**2*(33*bd1*(k1**4*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + k1**2*(k2**3*(r**2*(6*C + 2) + r*(C*(4*s - 6) + 4*s - 3) + s**2*(6*C + 2) - s*(4*C + 3) + 1) + (C*(r*(8*s - 2) - 4*s + 2) + r**2 + r*(2*s - 1) + s*(s - 1))*(k2**2)**(3/2)) + k2**5*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*fd*k1**2*(20*C*(k2**3*(9*r**2 + 9*r*(s - 1) + 9*s**2 - 9*s + 3) + (3*r - 1)*(3*s - 1)*(k2**2)**(3/2)) + 3*k1**2*k2*(3*r + 3*s - 2)**2 + 3*(3*r + 3*s - 2)**2*(k2**2)**(3/2)))) + Dd*f*(-33*b1**2*(k1**2*(k2**3*(4*r**2 - r + s*(4*s - 1)) + (r*(8*s - 1) - s)*(k2**2)**(3/2)) + 2*k2**5*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 66*b1*f*(k1**4*k2*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + k1**2*(k2**3*(C*(12*r**2 + r*(8*s - 4) + 12*s**2 - 8*s + 1) + (2*r + 2*s - 1)**2) + (2*C*r*(8*s - 3) - 2*C*s + C + 2*r**2 + r*(4*s - 1) + s*(2*s - 1))*(k2**2)**(3/2)) + k2**5*(2*r + 2*s - 1)**2) + 4*f**2*k1**2*(5*C*(3*k2**3*(8*r**2 + 8*r*s - 7*r + 8*s**2 - 7*s + 2) + (24*r*s - 7*r - 7*s + 2)*(k2**2)**(3/2)) + 3*k1**2*k2*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2) + 3*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)*(k2**2)**(3/2))))/(231*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk2*ct*st**2*(33*D1*bd1*f*(-2*b1*(13*k1**4*(r**2 + r*(2*s - 1) + s*(s - 1))*(k2**2)**(3/2) + k1**2*k2**4*(13*k2*(r**2 + r*(4*C*s - C + 2*s - 1) + s*(-C + s - 1)) + (r**2*(52*C + 7) + r*(52*C*s - 39*C + 14*s - 7) + s*(52*C*s - 39*C + 7*s - 7))*np.sqrt(k2**2)) + 7*k2**6*(r**2 + r*(2*s - 1) + s*(s - 1))*np.sqrt(k2**2)) + f*(k1**6*(k2*(-2*r*s + r + s - 1) + (-r**2 + r - s**2 + s)*np.sqrt(k2**2)) - k1**4*(r + s - 1)*(2*C*(13*r + 13*s - 9) + 5*r + 5*s - 1)*(k2**2)**(3/2) + k1**2*k2**4*(k2*(2*C*(2*r*(8*s - 1) - 13*s + 7) - 4*r**2 + r*(5 - 10*s) - 4*s**2 + 5*s - 1) + (-2*C*(r**2 + 18*r*s + s**2 - 11*s + 4) + r**2 + r*(4*s - 2) + (s - 1)**2)*np.sqrt(k2**2)) + k2**6*(r**2 + r*(2*s - 1) + s*(s - 1))*np.sqrt(k2**2))) - 33*b1**2*(D1*fd*(13*k1**4*(r + s)**2*(k2**2)**(3/2) + k1**2*k2**4*(13*k2*(r**2 + 2*r*(2*C*s + s) + s**2) + (r**2*(52*C + 7) + r*s*(52*C + 14) + s**2*(52*C + 7))*np.sqrt(k2**2)) + 7*k2**6*(r + s)**2*np.sqrt(k2**2)) + 2*Dd*f*(13*k1**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*(k2**2)**(3/2) + k1**2*k2**4*(13*k2*(2*r**2 + r*(8*C*s - C + 4*s - 1) + s*(-C + 2*s - 1)) + (r**2*(104*C + 14) + r*(13*C*(8*s - 3) + 28*s - 7) + s*(13*C*(8*s - 3) + 14*s - 7))*np.sqrt(k2**2)) + 7*k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2))) + 33*b1*f*(D1*fd*(-k1**6*(k2*r*(4*s - 3) + (2*r**2 + 2*s**2 - 3*s + 1)*np.sqrt(k2**2)) - k1**4*(2*r + 2*s - 1)*(2*C*(13*r + 13*s - 9) + 5*r + 5*s - 1)*(k2**2)**(3/2) + k1**2*k2**4*(C*(k2*(r*(64*s - 66) + 22*s) - 2*(2*r**2 + 4*r*(9*s - 7) + 2*s**2 + 16*s - 3)*np.sqrt(k2**2)) + k2*(-8*r**2 + r*(7 - 20*s) + s*(4 - 8*s)) + (2*r**2 + r*(8*s - 4) + s*(2*s - 1))*np.sqrt(k2**2)) + k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2)) + Dd*f*(-k1**6*(k2*r*(8*s - 5) - k2*s + k2 + (4*r**2 - r + 4*s**2 - 5*s + 1)*np.sqrt(k2**2)) - 2*k1**4*(2*r + 2*s - 1)*(2*C*(13*r + 13*s - 9) + 5*r + 5*s - 1)*(k2**2)**(3/2) - k1**2*k2**4*(k2*(-2*C*(64*r*s - 44*r + 7) + 16*r**2 + 40*r*s - 13*r + 16*s**2 - 9*s + 1) + (2*C*(4*r**2 + 72*r*s - 34*r + 4*s**2 + 10*s + 1) - 4*r**2 - 16*r*s + 7*r - 4*s**2 + 3*s - 1)*np.sqrt(k2**2)) + 2*k2**6*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))*np.sqrt(k2**2))) - f**2*k1**2*(D1*fd*(k1**4*(k2*(6*r*(9*s - 14) + 15*s + 17) + (27*r**2 + 15*r + 27*s**2 - 84*s + 17)*np.sqrt(k2**2)) + k1**2*(3*r + 3*s - 2)*(18*C*(23*r + 23*s - 19) - 123*r - 123*s + 82)*(k2**2)**(3/2) - 33*k2**4*(k2*(6*C*(30*r*s - 14*r - 5*s + 3) + 12*r**2 + 18*r*s - 13*r + 12*s**2 - 16*s + 5) + (6*C*(15*r**2 - 5*r + 15*s**2 - 14*s + 3) + 6*r*s - 4*r - s + 1)*np.sqrt(k2**2))) + Dd*f*(k1**4*(k2*(r*(72*s - 109) + 23*s + 17) + (36*r**2 + 23*r + 36*s**2 - 109*s + 17)*np.sqrt(k2**2)) + 2*k1**2*(2*r + 2*s - 1)*(18*C*(23*r + 23*s - 19) - 123*r - 123*s + 82)*(k2**2)**(3/2) - 33*k2**4*(k2*(6*C*(r*(40*s - 17) - 5*s + 3) + 16*r**2 + 3*r*(8*s - 5) + 16*s**2 - 19*s + 5) + (6*C*(20*r**2 - 5*r + 20*s**2 - 17*s + 3) + r*(8*s - 5) - s + 1)*np.sqrt(k2**2)))))/(693*d**2*k1*k2*k3**6*np.sqrt(k2**2)) - D1**3*Pk1*ct**8*f*(40*C - 40)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(33*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(153*s**2 - 135*s + 28) + Dd*f*(204*s**2 - 163*s + 28)))/(693*d**2*k3**2) + D1**3*Pk1*ct**8*f*(80*C - 80)*(33*D1*bd1*f*(-4*Pk2*k2**2*(r*(4*s - 1) + (1 - 2*s)**2) + Pkd2*k2**3*(r*(4*s - 1) - 2*s + 1) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + 33*b1*(-2*D1*fd*(2*s - 1)*(4*Pk2*k2**2*(2*r + 2*s - 1) - 2*Pkd2*k2**3*r + Pkd2*(1 - 2*s)*(k2**2)**(3/2)) + Dd*f*(-4*Pk2*k2**2*(8*s - 3)*(2*r + 2*s - 1) + Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 2*Pkd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2))) + f*(D1*fd*(-4*Pk2*k2**2*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) + Pkd2*k2**3*(9*r*(34*s - 15) - 36*s + 23) + 2*Pkd2*(153*s**2 - 135*s + 28)*(k2**2)**(3/2)) + Dd*f*(-4*Pk2*k2**2*(408*r*s - 163*r + 408*s**2 - 357*s + 79) + Pkd2*k2**3*(408*r*s - 163*r - 31*s + 23) + 2*Pkd2*(204*s**2 - 163*s + 28)*(k2**2)**(3/2))))/(693*d**2*k3**4) + 10*D1**3*Pk1*ct**7*f**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*b1*(135*s - 56)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s*(135*s - 56) + 42*D1*fd*(136*s**2 - 94*s + 15) + 42*Dd*f*(136*s**2 - 94*s + 15)))/(9009*d**2*k1*k2) + 8*D1**3*Pk1*ct**7*f*(33*D1*bd1*f*(Pk2*k2**3*(r**2*(48*C - 48) + r*(48*C*(s - 1) - 68*s + 53) - 5*(1 - 2*s)**2) + 15*Pk2*(r*(4*s - 1) + (1 - 2*s)**2)*(k2**2)**(3/2) - 5*Pkd2*k2**4*(r*(4*s - 1) + (1 - 2*s)**2) - k1**2*k2*(4*Pk2 - Pkd2*k2)*(6*C*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + r*(35 - 92*s) - 92*s**2 + 116*s - 35)) + 33*b1*(2*D1*fd*(k1**2*k2*(-4*Pk2 + Pkd2*k2)*(6*C*(12*r*s - 7*r + 12*s**2 - 14*s + 4) + r*(52 - 92*s) - 92*s**2 + 104*s - 29) + (2*r + 2*s - 1)*(Pk2*k2**3*(r*(24*C - 24) - 10*s + 5) + 15*Pk2*(2*s - 1)*(k2**2)**(3/2) + 5*Pkd2*k2**4*(1 - 2*s))) + Dd*f*(k1**2*k2*(-4*Pk2 + Pkd2*k2)*(6*C*(24*r*(2*s - 1) + 48*s**2 - 52*s + 13) + r*(174 - 368*s) - 368*s**2 + 382*s - 93) + (2*r + 2*s - 1)*(Pk2*k2**3*(r*(96*C - 96) - 40*s + 15) + 15*Pk2*(8*s - 3)*(k2**2)**(3/2) - 5*Pkd2*k2**4*(8*s - 3)))) + f*(D1*fd*(Pk2*k2**3*(2*C*(1593*r**2 + 3*r*(594*s - 101) + 66*s - 296) - 3186*r**2 + r*(1281 - 5094*s) - 1530*s**2 + 1398*s + 197) + Pk2*(C*(r*(60 - 378*s) + 1446*s - 460) + 3*r*(1656*s - 695) + 4590*s**2 - 6036*s + 1645)*(k2**2)**(3/2) - 5*Pkd2*k2**4*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) - 5*k1**2*k2*(4*Pk2 - Pkd2*k2)*(12*C*(29*s - 17)*(3*r + 3*s - 2) - 9*r*(150*s - 83) - 1350*s**2 + 1614*s - 487)) + Dd*f*(Pk2*k2**3*(2*C*(2124*r**2 + r*(2376*s - 7) + 66*s - 296) - 4248*r**2 + r*(829 - 6792*s) - 2040*s**2 + 1653*s + 197) + Pk2*(-2*C*(4*r*(63*s + 5) - 1003*s + 230) + r*(6624*s - 2405) + 6120*s**2 - 7361*s + 1645)*(k2**2)**(3/2) - 5*Pkd2*k2**4*(r*(408*s - 163) + 408*s**2 - 357*s + 79) - 5*k1**2*k2*(4*Pk2 - Pkd2*k2)*(12*C*(r*(116*s - 65) + 116*s**2 - 129*s + 34) + r*(943 - 1800*s) - 1800*s**2 + 1905*s - 487))))/(693*d**2*k1*k3**4) - 4*D1**3*Pk1*ct**7*f*(33*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*C*(7*s - 5) - 38*s + 25) + k2**2*(-8*Pk2*(r*(24*C - 24) + 10*s - 5) + k2*(Pkd2*(r*(48*C - 48) + 50*s - 25) + 5*Pkdd2*(1 - 2*s)*np.sqrt(k2**2)))) + f*(33*D1*bd1*s*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*C*(7*s - 5) - 38*s + 25) + k2**2*(-8*Pk2*(r*(24*C - 24) + 10*s - 5) + k2*(Pkd2*(r*(48*C - 48) + 50*s - 25) + 5*Pkdd2*(1 - 2*s)*np.sqrt(k2**2)))) + D1*fd*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(2*C*(69*s - 56) - 189*s + 140) + k2**2*(-2*Pk2*(C*(9*r*(774*s - 269) + 2958*s - 953) - 6966*r*s + 2421*r + 3060*s**2 - 5658*s + 1513) + k2*(Pkd2*(2*C*(9*r*(199*s - 70) + 723*s - 230) - 3582*r*s + 1260*r + 3825*s**2 - 4821*s + 1160) - 5*Pkdd2*(153*s**2 - 135*s + 28)*np.sqrt(k2**2)))) + 5*Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(2*C*(69*s - 56) - 189*s + 140) + Dd*f*k2**2*(-2*Pk2*(C*(9288*r*s - 2588*r + 4078*s - 953) - 9288*r*s + 2588*r + 4080*s**2 - 7338*s + 1513) + k2*(Pkd2*(2*C*(2388*r*s - 680*r + 1003*s - 230) - 4776*r*s + 1360*r + 5100*s**2 - 6081*s + 1160) - 5*Pkdd2*(204*s**2 - 163*s + 28)*np.sqrt(k2**2)))))/(693*d**2*k1*k2*k3**2) - D1**3*Pk1*ct**6*f*st**2*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(33*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(159*s**2 - 128*s + 25) + Dd*f*(212*s**2 - 153*s + 25)))/(231*d**2*k3**2) + D1**3*Pk1*ct**6*f*st**2*(40*C - 40)*(33*D1*bd1*f*(-4*Pk2*k2**2*(r*(4*s - 1) + (1 - 2*s)**2) + Pkd2*k2**3*(r*(4*s - 1) - 2*s + 1) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + 33*b1*(-2*D1*fd*(2*s - 1)*(4*Pk2*k2**2*(2*r + 2*s - 1) - 2*Pkd2*k2**3*r + Pkd2*(1 - 2*s)*(k2**2)**(3/2)) + Dd*f*(-4*Pk2*k2**2*(8*s - 3)*(2*r + 2*s - 1) + Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 2*Pkd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2))) + f*(2*D1*fd*(-4*Pk2*k2**2*(159*r*s - 64*r + 159*s**2 - 159*s + 39) + Pkd2*k2**3*(159*r*s - 64*r - 31*s + 14) + Pkd2*(159*s**2 - 128*s + 25)*(k2**2)**(3/2)) + Dd*f*(-4*Pk2*k2**2*(424*r*s - 153*r + 424*s**2 - 371*s + 78) + Pkd2*k2**3*(424*r*s - 153*r - 65*s + 28) + 2*Pkd2*(212*s**2 - 153*s + 25)*(k2**2)**(3/2))))/(231*d**2*k3**4) + D1**3*Pk1*ct**6*(1716*b1**2*k1**2*(D1*fd*(5*f*(1 - 2*s)**2 - (6*K - 6)*(s - 1)**2) + Dd*f*(4*s - 1)*(-6*K*s + 6*K + 5*f*(2*s - 1) + 6*s - 6))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 13*b1*(3*D1*(f**2*(-440*bd1*k1**2*s*(2*s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 20*fd*k1**2*(153*s**2 - 135*s + 28)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 3*fd*r*(Pk2*(662 - 1535*s) + 10*Pkd2*k2*(37*s - 16))*(k2**2)**(3/2)) + 44*f*k1**2*(fd*(K - 1)*(8*s**2 - 14*s + 5) + s*(s - 1)*(12*K*bd1 - 12*bd1 - 12*gd2))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 528*fd*g2*k1**2*(s - 1)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + Dd*f*(f**2*(-60*k1**2*(204*s**2 - 163*s + 28)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(7864 - 18420*s) + 4365*s - 1906) + 10*Pkd2*k2*(2*r*(222*s - 95) - 105*s + 46))*(k2**2)**(3/2)) + 132*f*k1**2*(K - 1)*(16*s**2 - 24*s + 5)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 1584*g2*k1**2*(4*s**2 - 5*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)))) + f*(D1*f**2*(-13*bd1*(Pk2*(1440*k1**2*s*(28 - 51*s) + k2**2*(-4605*r*s + 1906*r + 4365*s - 1906))*np.sqrt(k2**2) + 540*Pkd2*k1**2*k2**2*s*(51*s - 28) + 10*Pkd2*k2**3*(111*r*s - 46*r - 105*s + 46)*np.sqrt(k2**2) + 60*Pkdd2*k1**2*s*(28 - 51*s)*(k2**2)**(3/2)) - 5*fd*(-56*k1**2*(304*s**2 - 256*s + 45)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(17240 - 44156*s) + 40159*s - 11590) + 4*Pkd2*k2*(4*r*(629*s - 245) - 2449*s + 700))*(k2**2)**(3/2))) + 1716*D1*f*k1**2*s*(4*s - 5)*(-K*bd1 + bd1 + 2*gd2)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 3432*D1*g2*k1**2*(6*bd1*s*(s - 1) + fd*(8*s**2 - 14*s + 5))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 5*Dd*f**3*(-56*k1**2*(304*s**2 - 256*s + 45)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(17240 - 44156*s) + 40159*s - 11590) + 4*Pkd2*k2*(4*r*(629*s - 245) - 2449*s + 700))*(k2**2)**(3/2)) + 3432*Dd*f*g2*k1**2*(16*s**2 - 24*s + 5)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))))/(9009*d**2*k1**2*(k2**2)**(3/2)) - 4*D1**3*Pk1*ct**6*(396*b1**2*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1))*(k2**2)**(3/2) + 33*b1*f*(D1*(12*bd1*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*(k2**2)**(3/2) + fd*(2*k1**4*(2*s - 1)*(C*(4*s - 5) - 11*s + 10)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(-2*Pk2*(C*(333*r*s - 190*r + 872*s**2 - 936*s + 234) - 413*r*s + 230*r - 600*s**2 + 640*s - 154) + k2*(Pkd2*(C*(24*r*(7*s - 4) + 652*s**2 - 732*s + 183) - 208*r*s + 116*r - 312*s**2 + 362*s - 83) + 2*Pkdd2*k2*(C*(-36*s**2 + 44*s - 11) + 2*s**2 - 7*s + 1)))*(k2**2)**(3/2) + 4*k2**4*r*(-2*Pk2*(r*(14*C - 14) - 2*s + 1)*np.sqrt(k2**2) + Pkd2*k2*(-6*k2 + 5*np.sqrt(k2**2))*(2*s - 1)))) + Dd*f*(2*k1**4*(4*s - 1)*(C*(4*s - 5) - 11*s + 10)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(Pk2*(C*(-1332*r*s + 568*r - 3488*s**2 + 2885*s - 562) + 1652*r*s - 688*r + 2400*s**2 - 2013*s + 422) + k2*(Pkd2*(C*(48*r*(7*s - 3) + 1304*s**2 - 1094*s + 207) - 2*r*(208*s - 87) - 624*s**2 + 534*s - 112) - 2*Pkdd2*k2*(4*s - 1)*(C*(18*s - 11) - s + 1)))*(k2**2)**(3/2) + k2**4*(2*Pk2*(-r**2*(112*C - 112) + 2*r*(14*C + 8*s - 11) + 10*s - 5)*np.sqrt(k2**2) + Pkd2*k2*(24*k2*r*(1 - 4*s) + 5*(2*r*(8*s - 3) - 2*s + 1)*np.sqrt(k2**2))))) + f**2*(D1*(33*bd1*(-18*Pkd2*k1**4*k2**2*s*(C*(4*s - 5) - 11*s + 10) + Pkd2*k1**2*k2**3*(C*(12*r*(7*s - 2) + 326*s**2 - 179*s + 24) + r*(29 - 104*s) - 156*s**2 + 89*s - 29)*np.sqrt(k2**2) - 24*Pkd2*k2**6*r*s + 5*Pkd2*k2**5*(r*(4*s - 1) - 2*s + 1)*np.sqrt(k2**2) + k1**2*(48*Pk2*k1**2*s*(C*(4*s - 5) - 11*s + 10) + k2**2*(Pk2*(C*(-333*r*s + 94*r - 872*s**2 + 545*s - 94) + 413*r*s - 114*r + 600*s**2 - 425*s + 114) + 2*Pkdd2*k1**2*s*(C*(4*s - 5) - 11*s + 10)))*np.sqrt(k2**2) + 2*k2**4*(Pk2*(-r**2*(28*C - 28) + r*(28*C + 4*s - 23) + 10*s - 5) + Pkdd2*k1**2*s*(C*(7 - 18*s) + s + 3))*np.sqrt(k2**2)) + fd*(5*k1**4*(3*s - 1)*(4*C*(9*s - 14) - 105*s + 112)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(Pk2*(C*(-3*r*(6879*s - 4042) - 70776*s**2 + 53403*s - 11686) + 9*r*(2867*s - 1623) + 50256*s**2 - 30885*s + 6713) + k2*(Pkd2*(C*(6*r*(897*s - 530) + 28224*s**2 - 22425*s + 4801) - 6723*r*s + 3825*r - 15399*s**2 + 9207*s - 1886) - 5*Pkdd2*k2*(3*s - 1)*(2*C*(117*s - 61) - 63*s + 10)))*(k2**2)**(3/2) + k2**4*(Pk2*(C*(-4104*r**2 + 888*r + 160) + 4104*r**2 + 720*r*s - 897*r + 1740*s - 817)*np.sqrt(k2**2) + 3*Pkd2*k2*(-220*k2*r*(3*s - 1) + (573*r*s - 235*r - 301*s + 115)*np.sqrt(k2**2))))) + Dd*f*(5*k1**4*(4*s - 1)*(4*C*(9*s - 14) - 105*s + 112)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(Pk2*(C*(-27516*r*s + 15368*r - 94368*s**2 + 61847*s - 11686) + 34404*r*s - 18576*r + 67008*s**2 - 33629*s + 6713) + k2*(Pkd2*(C*(8*r*(897*s - 505) + 37632*s**2 - 26366*s + 4801) - 8964*r*s + 4875*r - 20532*s**2 + 10043*s - 1886) - 5*Pkdd2*k2*(4*s - 1)*(2*C*(117*s - 61) - 63*s + 10)))*(k2**2)**(3/2) + k2**4*(Pk2*(-8*C*(684*r**2 - 91*r - 20) + 5472*r**2 + 960*r*s - 590*r + 2250*s - 817)*np.sqrt(k2**2) + 3*Pkd2*k2*(-220*k2*r*(4*s - 1) + (764*r*s - 265*r - 386*s + 115)*np.sqrt(k2**2))))))/(693*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 8*D1**3*Pk1*ct**6*(33*D1*bd1*f*(-12*b1*k1**2*(C - 1)*(2*Pk2*k2**2*(-4*r*s + r + s*(3 - 4*s)) + Pkd2*k2**3*(r*(4*s - 1) - s) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + f*(Pk2*k2**4*(4*r**2 + 4*r*s + r + 10*s - 5) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(6*s - 5) + 6*s**2 - 12*s + 5) - 3*r*(8*s - 5) - 24*s**2 + 40*s - 15) + k1**2*(Pk2*k2**2*(-C*(129*r**2 + 419*r*s - 175*r + 290*s**2 - 246*s + 66) + 149*r**2 + 287*r*s - 150*r + 138*s**2 - 80*s + 21) + Pkd2*k2**3*(2*C*(12*r*s - r - 11*s + 6) + 64*r*s - 23*r + 36*s**2 - 46*s + 13) + 4*Pkd2*(C*(12*r*s - 3*r + 18*s**2 - 13*s + 3) - 15*r*s + 3*r - 8*s**2 + 8*s - 3)*(k2**2)**(3/2)))) - 396*b1**2*k1**2*(C - 1)*(2*D1*fd*s*(-2*Pk2*k2**2*(r + s) + Pkd2*k2**3*r + Pkd2*s*(k2**2)**(3/2)) + Dd*f*(-2*Pk2*k2**2*(r*(8*s - 1) + s*(8*s - 3)) + Pkd2*k2**3*(r*(8*s - 1) - s) + 2*Pkd2*s*(4*s - 1)*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(4*Pk2*k2**4*r*(2*r + 2*s - 1) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + r*(17 - 24*s) - 24*s**2 + 32*s - 10) + k1**2*(Pk2*k2**2*(-C*(258*r**2 + 838*r*s - 462*r + 580*s**2 - 636*s + 161) + 298*r**2 + 574*r*s - 318*r + 276*s**2 - 308*s + 73) + 2*Pkd2*k2**3*(r*(4*C*(6*s - 5) + 64*s - 27) + 36*s**2 + 2*s*(C - 22) + 12) + 4*Pkd2*(C*(24*r*s - 12*r + 36*s**2 - 44*s + 11) - 30*r*s + 15*r - 16*s**2 + 24*s - 6)*(k2**2)**(3/2))) + Dd*f*(Pk2*k2**4*(8*r + 5)*(2*r + 2*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(C*(8*r*(6*s - 5) + 48*s**2 - 72*s + 22) + r*(64 - 96*s) - 96*s**2 + 124*s - 35) + k1**2*(Pk2*k2**2*(-C*(516*r**2 + 1676*r*s - 699*r + 1160*s**2 - 1047*s + 227) + 596*r**2 + 1148*r*s - 485*r + 552*s**2 - 465*s + 94) + Pkd2*k2**3*(4*C*(24*r*s - 13*r - 5*s + 3) + 256*r*s - 92*r + 144*s**2 - 156*s + 37) + 4*Pkd2*(2*C*(24*r*s - 9*r + 36*s**2 - 34*s + 7) - 60*r*s + 21*r - 32*s**2 + 38*s - 9)*(k2**2)**(3/2)))) + f**2*(D1*fd*(3*Pk2*k2**4*(21*r**2 + r*(21*s + 254) + 323*s - 197) + 30*k1**4*(4*Pk2 - Pkd2*k2)*(C*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + r*(131 - 162*s) - 162*s**2 + 250*s - 91) + k1**2*(-Pk2*k2**2*(C*(7281*r**2 + 45*r*(711*s - 229) + 24714*s**2 - 18066*s + 2347) - 8424*r**2 + 3*r*(1511 - 7266*s) - 13374*s**2 + 4797*s + 1734) + 10*Pkd2*k2**3*(C*(9*r*(34*s - 15) - 36*s + 23) + 6*r*(60*s - 31) + 261*s**2 - 327*s + 102) + 10*Pkd2*(C*(33*r*(12*s - 5) + 702*s**2 - 666*s + 155) - 99*r*(5*s - 2) - 99*(1 - 2*s)**2)*(k2**2)**(3/2))) + Dd*f*(3*Pk2*k2**4*(28*r**2 + r*(28*s + 366) + 408*s - 197) + 30*k1**4*(4*Pk2 - Pkd2*k2)*(C*(4*r*(25*s - 27) + 100*s**2 - 170*s + 57) + r*(173 - 216*s) - 216*s**2 + 299*s - 91) + k1**2*(-Pk2*k2**2*(C*(9708*r**2 + 5*r*(8532*s - 2069) + 32952*s**2 - 20373*s + 2347) - 11232*r**2 - 29064*r*s + 3017*r - 17832*s**2 + 4579*s + 1734) + 10*Pkd2*k2**3*(C*(408*r*s - 163*r - 31*s + 23) + 480*r*s - 228*r + 348*s**2 - 387*s + 102) + 10*Pkd2*(C*(66*r*(8*s - 3) + 936*s**2 - 788*s + 155) - 33*r*(20*s - 7) - 528*s**2 + 462*s - 99)*(k2**2)**(3/2)))))/(693*d**2*k1**2*k3**4) + 5*D1**3*Pk1*ct**5*f**2*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(13*b1*(177*s - 70)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s*(177*s - 70) + D1*fd*(7076*s**2 - 4513*s + 686) + Dd*f*(7076*s**2 - 4513*s + 686)))/(3003*d**2*k1*k2) + 4*D1**3*Pk1*ct**5*f*st**2*(33*D1*bd1*f*(Pk2*k2**3*(r**2*(128*C - 128) + r*(16*C*(3*s - 8) - 108*s + 143) - 15*(1 - 2*s)**2) + 5*Pk2*(4*C*(r*(4*s - 1) - 2*s + 1) + 5*r*(4*s - 1) + 36*s**2 - 28*s + 5)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(r*(4*s - 1) + (1 - 2*s)**2) - 3*k1**2*k2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + r*(25 - 84*s) - 84*s**2 + 92*s - 25)) + 33*b1*(2*D1*fd*(Pk2*k2**3*(r**2*(128*C - 128) + r*(24*C - 54)*(2*s - 1) - 15*(1 - 2*s)**2) + 5*Pk2*(2*s - 1)*(r*(8*C + 10) + 18*s - 9)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(2*s - 1)*(2*r + 2*s - 1) + 3*k1**2*k2*(-4*Pk2 + Pkd2*k2)*(2*C*(r*(32*s - 17) + 32*s**2 - 34*s + 9) + r*(44 - 84*s) - 84*s**2 + 88*s - 23)) + Dd*f*(Pk2*k2**3*(r**2*(512*C - 512) + 2*r*(C*(96*s - 88) - 216*s + 133) - 240*s**2 + 210*s - 45) + 5*Pk2*(4*C*(2*r*(8*s - 3) - 2*s + 1) + 10*r*(8*s - 3) + 144*s**2 - 118*s + 23)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(8*s - 3)*(2*r + 2*s - 1) - 3*k1**2*k2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(64*s - 27) + 64*s**2 - 61*s + 14) - 6*r*(56*s - 23) - 336*s**2 + 314*s - 71))) + f*(2*D1*fd*(Pk2*k2**3*(2*C*(2304*r**2 + 3*r*(66*s - 149) + 66*s - 151) - 4608*r**2 - 927*r*(3*s - 2) - 2385*s**2 + 2253*s - 283) + Pk2*(4*C*(9*r*(117*s - 50) - 21*s + 40) + 27*r*(109*s - 40) + 7155*s**2 - 7071*s + 1595)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(159*r*s - 64*r + 159*s**2 - 159*s + 39) - 3*k1**2*k2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(597*s - 265) + 597*s**2 - 652*s + 173) + r*(1380 - 3183*s) - 3183*s**2 + 3403*s - 887)) + Dd*f*(Pk2*k2**3*(4*C*(3072*r**2 + 8*r*(33*s - 37) + 66*s - 151) - 12288*r**2 + r*(3479 - 7416*s) - 6360*s**2 + 5301*s - 566) + Pk2*(4*C*(13*r*(216*s - 85) + 83*s + 80) + r*(7848*s - 2465) + 19080*s**2 - 17027*s + 3190)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(r*(424*s - 153) + 424*s**2 - 371*s + 78) - 3*k1**2*k2*(4*Pk2 - Pkd2*k2)*(4*C*(r*(1592*s - 655) + 1592*s**2 - 1525*s + 346) + r*(3385 - 8488*s) - 8488*s**2 + 7955*s - 1774))))/(693*d**2*k1*k3**4) - 2*D1**3*Pk1*ct**5*f*st**2*(33*b1*(D1*fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(68*s - 40) - 98*s + 55) + k2**2*(-8*Pk2*(r*(64*C - 64) + 30*s - 15) + k2*(Pkd2*r*(128*C - 128) + 75*Pkd2*(2*s - 1) + 15*Pkdd2*(1 - 2*s)*np.sqrt(k2**2)))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(68*s - 40) - 98*s + 55) + k2**2*(-8*Pk2*(2*C*(128*r*s - 42*r - 10*s + 5) - 256*r*s + 84*r + 120*s**2 - 70*s + 5) + k2*(Pkd2*(4*C*(128*r*s - 42*r - 10*s + 5) - 512*r*s + 168*r + 600*s**2 - 410*s + 55) - 15*Pkdd2*(8*s**2 - 6*s + 1)*np.sqrt(k2**2))))) + f*(33*D1*bd1*(24*Pk2*k1**2*s*(C*(68*s - 40) - 98*s + 55) - 9*Pkd2*k1**2*k2*s*(C*(68*s - 40) - 98*s + 55) + k2**3*(Pkd2*(4*C*(32*r*s - 5*r - 10*s + 5) - 128*r*s + 20*r + 150*s**2 - 35*s - 20) + 15*Pkdd2*s*(1 - 2*s)*np.sqrt(k2**2)) + k2**2*(-8*Pk2*(2*C*(r*(32*s - 5) - 10*s + 5) + r*(10 - 64*s) + 30*s**2 + 5*s - 10) + Pkdd2*k1**2*s*(C*(68*s - 40) - 98*s + 55))) + D1*fd*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(4*C*(453*s - 250) - 2607*s + 1375) + k2**2*(-4*Pk2*(C*(9810*r*s - 4029*r - 102*s + 287) - 9810*r*s + 4029*r + 4770*s**2 - 3738*s + 463) + k2*(Pkd2*(8*C*(1251*r*s - 516*r - 21*s + 40) - 10008*r*s + 4128*r + 11925*s**2 - 9432*s + 1555) - 15*Pkdd2*(159*s**2 - 128*s + 25)*np.sqrt(k2**2)))) + Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(4*C*(453*s - 250) - 2607*s + 1375) + Dd*f*k2**2*(-4*Pk2*(C*(8*r*(1635*s - 602) + 398*s + 287) - 13080*r*s + 4816*r + 6360*s**2 - 4988*s + 463) + k2*(Pkd2*(4*C*(3336*r*s - 1237*r + 83*s + 80) - 13344*r*s + 4948*r + 15900*s**2 - 11807*s + 1555) - 15*Pkdd2*(212*s**2 - 153*s + 25)*np.sqrt(k2**2)))))/(693*d**2*k1*k2*k3**2) + 4*D1**3*Pk1*ct**5*(33*D1*bd1*f*(-4*b1*(2*Pk2*k1**2*(r*(C*(30*s - 4) - 42*s + 7) + s*(C*(30*s - 26) - 42*s + 35))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(28 - 28*C) + r*(-28*C*(s - 1) + 40*s - 31) + 3*s*(4*s - 3))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(C*(4 - 30*s) + 42*s - 7) + s*(-30*C*s + 26*C + 42*s - 35))*np.sqrt(k2**2) - 3*k2**5*(Pk2 - Pkd2*np.sqrt(k2**2))*(r*(4*s - 1) + s*(4*s - 3))) + f*(2*k1**4*(Pk2*(2*C*(r*(32*s - 5) - 8*s**2 + 12*s + 5) + r*(25 - 82*s) + 88*s**2 - 78*s - 25)*np.sqrt(k2**2) + k2*(-5*Pk2*(2*C*(8*r*s - 5*r - 4*s + 5) - 34*r*s + 25*r + 26*s - 25) + Pkd2*(2*C*(2*r*s - 5*r + 2*s**2 - 8*s + 5) - 22*r*s + 25*r - 22*s**2 + 52*s - 25)*np.sqrt(k2**2))) + k1**2*(Pk2*(4*C*(31*r**2 + 259*r*s - 100*r + 228*s**2 - 260*s + 75) - 205*r**2 - 951*r*s + 347*r - 746*s**2 + 698*s - 186) - 2*Pkd2*k2*(6*C*(26*r*s - 11*r + 26*s**2 - 35*s + 12) - 82*r*s + 23*r - 82*s**2 + 95*s - 34))*(k2**2)**(3/2) + k2**4*(2*Pk2*(-r**2*(36*C - 36) + r*(-26*C*s + 42*C + 57*s - 68) + 16*s**2 - 65*s + 31)*np.sqrt(k2**2) + k2*(-Pk2*(4*C*(5*r*s - 8*r - 10*s + 10) + 57*r**2 + 229*r*s - 79*r + 162*s**2 - 160*s + 24) + 2*Pkd2*(2*r*(8*s - 1) + 16*s**2 - 17*s + 7)*np.sqrt(k2**2))))) - 132*b1**2*(D1*fd*(r + s)*(Pk2*k1**2*s*(30*C - 42)*(k2**2)**(3/2) + 2*Pk2*k2**4*(r*(7 - 7*C) + 3*s)*np.sqrt(k2**2) - Pkd2*k1**2*k2**3*s*(15*C - 21)*np.sqrt(k2**2) - 6*k2**5*s*(Pk2 - Pkd2*np.sqrt(k2**2))) + Dd*f*(2*Pk2*k1**2*(r*(C*(60*s - 4) - 84*s + 7) + s*(C*(60*s - 26) - 84*s + 35))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(56 - 56*C) + r*(C*(28 - 56*s) + 80*s - 31) + 3*s*(8*s - 3))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(C*(4 - 60*s) + 84*s - 7) + s*(C*(26 - 60*s) + 84*s - 35))*np.sqrt(k2**2) - 3*k2**5*(Pk2 - Pkd2*np.sqrt(k2**2))*(r*(8*s - 1) + s*(8*s - 3)))) + 33*b1*f*(D1*fd*(Pk2*k1**2*(4*k1**2*(2*C*(32*r*s - 19*r - 8*s**2 + 20*s - 8) - 82*r*s + 53*r + 88*s**2 - 148*s + 52) + k2**2*(4*C*(62*r**2 + 518*r*s - 306*r + 456*s**2 - 566*s + 163) - 410*r**2 - 1902*r*s + 1098*r - 1492*s**2 + 1820*s - 501))*np.sqrt(k2**2) - 2*Pk2*k2**4*(2*C*(36*r**2 + r*(26*s - 36) - s + 9) - 72*r**2 - 3*r*(38*s - 37) - 32*s**2 + 48*s - 30)*np.sqrt(k2**2) - 4*Pkd2*k1**2*k2**3*(6*C*(2*r*(13*s - 8) + 26*s**2 - 32*s + 9) + r*(51 - 82*s) - 82*s**2 + 104*s - 27)*np.sqrt(k2**2) + 4*k1**4*k2*(5*Pk2*r*(-2*C*(8*s - 7) + 34*s - 29) + Pkd2*(2*C*(s - 2)*(2*r + 2*s - 1) + r*(23 - 22*s) - 22*s**2 + 37*s - 13)*np.sqrt(k2**2)) + k2**5*(-Pk2*(114*r**2 + r*(s*(40*C + 458) - 264) + 324*s**2 - s*(68*C + 284) + 89) + 4*Pkd2*(4*r*(4*s - 3) + 16*s**2 - 23*s + 6)*np.sqrt(k2**2))) + Dd*f*(2*k1**4*(Pk2*(2*C*(16*r*(8*s - 3) - 32*s**2 + 68*s - 11) - 4*r*(82*s - 39) + 352*s**2 - 478*s + 79)*np.sqrt(k2**2) + k2*(-5*Pk2*(2*C*(8*r*(4*s - 3) - 4*s + 5) - 136*r*s + 108*r + 26*s - 25) + Pkd2*(2*C*(4*s - 9)*(2*r + 2*s - 1) - 88*r*s + 96*r - 88*s**2 + 152*s - 51)*np.sqrt(k2**2))) + k1**2*(Pk2*(4*C*(124*r**2 + 1036*r*s - 475*r + 912*s**2 - 995*s + 238) - 820*r**2 - 3804*r*s + 1603*r - 2984*s**2 + 3047*s - 687) - 8*Pkd2*k2*(3*C*(52*r*s - 27*r + 52*s**2 - 59*s + 15) - 82*r*s + 38*r - 82*s**2 + 91*s - 22))*(k2**2)**(3/2) + k2**4*(2*Pk2*(-2*C*(72*r**2 + 52*r*s - 66*r - s + 9) + 144*r**2 + 228*r*s - 227*r + 64*s**2 - 126*s + 61)*np.sqrt(k2**2) + k2*(-Pk2*(4*C*(20*r*s - 8*r - 37*s + 10) + 228*r**2 + 916*r*s - 405*r + 648*s**2 - 495*s + 113) + 2*Pkd2*(32*r*(2*s - 1) + 64*s**2 - 76*s + 19)*np.sqrt(k2**2))))) + f**2*(D1*fd*(10*k1**4*(3*Pk2*(2*C*(6*r*(28*s - 13) - 12*s**2 + 95*s - 23) + r*(236 - 411*s) + 324*s**2 - 684*s + 159)*np.sqrt(k2**2) + k2*(-5*Pk2*(C*(216*r*s - 204*r - 6*s + 46) - 441*r*s + 444*r + 48*s - 115) + Pkd2*(2*C*(3*s - 23)*(3*r + 3*s - 2) - 243*r*s + 378*r - 243*s**2 + 573*s - 263)*np.sqrt(k2**2))) + k1**2*(Pk2*(12*C*(141*r**2 + 5865*r*s - 2170*r + 5724*s**2 - 5760*s + 1340) - 4293*r**2 - 65115*r*s + 13215*r - 60822*s**2 + 45786*s - 5197) - 30*Pkd2*k2*(4*C*(73*s - 39)*(3*r + 3*s - 2) - 585*r*s + 239*r - 585*s**2 + 607*s - 152))*(k2**2)**(3/2) + k2**4*(2*Pk2*(C*(-3582*r**2 - 4356*r*s + 1134*r + 132*s + 460) + 4356*r**2 + 8019*r*s - 5082*r + 1980*s**2 - 3564*s + 1287)*np.sqrt(k2**2) + k2*(Pk2*(4*C*(129*r - 263)*(3*s - 1) - 2061*r**2 - 18981*r*s + 4599*r - 13554*s**2 + 10050*s - 1039) + 330*Pkd2*(r*(12*s - 5) + 3*(1 - 2*s)**2)*np.sqrt(k2**2)))) + Dd*f*(10*k1**4*(Pk2*(2*C*(r*(672*s - 262) - 48*s**2 + 382*s - 69) + r*(848 - 1644*s) + 1296*s**2 - 2669*s + 477)*np.sqrt(k2**2) - k2*(5*Pk2*(C*(4*r*(72*s - 65) + 4*s + 46) + r*(584 - 588*s) + 23*s - 115) + Pkd2*(-2*C*(r*(12*s - 97) + 12*s**2 - 93*s + 46) + r*(324*s - 518) + 324*s**2 - 696*s + 263)*np.sqrt(k2**2))) + k1**2*(Pk2*(12*C*(188*r**2 + 7820*r*s - 2495*r + 7632*s**2 - 6775*s + 1340) - 5724*r**2 - 86820*r*s + 11815*r - 81096*s**2 + 52383*s - 5197) - 60*Pkd2*k2*(C*(584*r*s - 295*r + 584*s**2 - 621*s + 156) - 390*r*s + 144*r - 390*s**2 + 355*s - 76))*(k2**2)**(3/2) + k2**4*(2*Pk2*(C*(-4776*r**2 - 5808*r*s + 674*r + 132*s + 460) + 5808*r**2 + 10692*r*s - 6039*r + 2640*s**2 - 3894*s + 1287)*np.sqrt(k2**2) + k2*(Pk2*(4*C*(516*r*s - 112*r - 1069*s + 263) - 2748*r**2 - 25308*r*s + 5041*r - 18072*s**2 + 10647*s - 1039) + 330*Pkd2*(8*s - 3)*(2*r + 2*s - 1)*np.sqrt(k2**2))))))/(693*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct**5*(858*b1**2*k1**2*(D1*fd*(-9*Pkd2*k1**2*k2*(f*(14*s**2 - 17*s + 5) + 6*(s - 1)**2)*np.sqrt(k2**2) + Pkdd2*k2**4*(f*(28*s**2 - 17*s + 5) + 6*(s - 1)**2)*np.sqrt(k2**2) + k2**3*(90*Pk2*(s - 1)**2 - Pkd2*(5*f*(28*s**2 - 17*s + 5) + (s - 1)*(2*r*(7*K - 7) + 30*s - 30))*np.sqrt(k2**2)) + (2*Pk2*k2**2*(4*f*(28*s**2 - 17*s + 5) + (s - 1)*(7*r*(4*K - 4) - 21*s + 21)) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(f*(14*s**2 - 17*s + 5) + 6*(s - 1)**2))*np.sqrt(k2**2)) + Dd*f*(4*s - 1)*(-9*Pkd2*k1**2*k2*(7*f*s - 5*f + 6*s - 6)*np.sqrt(k2**2) + Pkdd2*k2**4*(14*f*s - 5*f + 6*s - 6)*np.sqrt(k2**2) + k2**3*(90*Pk2*(s - 1) + Pkd2*(-14*K*r + f*(25 - 70*s) + 14*r - 30*s + 30)*np.sqrt(k2**2)) + (2*Pk2*k2**2*(4*f*(14*s - 5) + 7*r*(4*K - 4) - 21*s + 21) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(7*f*s - 5*f + 6*s - 6))*np.sqrt(k2**2))) - 13*b1*(D1*(f**2*(-66*bd1*k1**2*s*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7*s - 5) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(28*s - 17))*np.sqrt(k2**2) + fd*(630*Pk2*k2**4*r**2*np.sqrt(k2**2) - 10*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 237*s + 56)*np.sqrt(k2**2) + k1**2*(2*Pk2*(387*r*(3*s - 1) + 28350*s**2 - 23307*s + 4159)*(k2**2)**(3/2) + 5*Pkdd2*k2**4*(81*s**2 - 126*s + 10)*np.sqrt(k2**2) + k2**3*(Pk2*(-8046*r*s + 2088*r + 7494*s - 2432) + 3*Pkd2*(378*r*s - 60*r - 5130*s**2 + 3901*s - 546)*np.sqrt(k2**2))))) - 66*f*k1**2*(fd*(-9*Pkd2*k1**2*k2*(8*s**2 - 14*s + 5)*np.sqrt(k2**2) + Pkdd2*k2**4*(8*s**2 - 14*s + 5)*np.sqrt(k2**2) + k2**3*(-5*Pk2*(K*(10*r*s - 4*r - 17*s + 8) - 10*r*s + 4*r - 24*s**2 + 59*s - 23) + Pkd2*(K*(-14*r*s + 8*r - 17*s + 8) + 14*r*s - 8*r - 40*s**2 + 87*s - 33)*np.sqrt(k2**2)) + (Pk2*k2**2*(K*(104*r*s - 50*r - 16*s + 7) - 104*r*s + 50*r - 56*s**2 + 114*s - 42) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(8*s**2 - 14*s + 5))*np.sqrt(k2**2)) + s*(4*bd1*(-27*Pkd2*k1**2*k2*(s - 1)*np.sqrt(k2**2) + 3*Pkdd2*k2**4*(s - 1)*np.sqrt(k2**2) + k2**3*(45*Pk2*(s - 1) + Pkd2*(-7*K*r + 7*r - 15*s + 15)*np.sqrt(k2**2)) + (7*Pk2*k2**2*(r*(4*K - 4) - 3*s + 3) + 3*k1**2*(24*Pk2 + Pkdd2*k2**2)*(s - 1))*np.sqrt(k2**2)) + 28*gd2*r*(-4*Pk2 + Pkd2*k2)*(k2**2)**(3/2))) - 1848*fd*g2*k1**2*r*(-4*Pk2 + Pkd2*k2)*(s - 1)*(k2**2)**(3/2)) + Dd*f*(f**2*(210*Pk2*k2**4*r*(4*r - 1)*np.sqrt(k2**2) - 10*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 293*s + 56)*np.sqrt(k2**2) + k1**2*(6*Pk2*(4*r*(129*s - 28) + 12600*s**2 - 8667*s + 1375)*(k2**2)**(3/2) + 5*Pkdd2*k2**4*(108*s**2 - 67*s + 10)*np.sqrt(k2**2) - 2*k2**3*(Pk2*(12*r*(447*s - 41) - 4241*s + 848) + Pkd2*(-12*r*(63*s + 5) + 10260*s**2 - 5992*s + 919)*np.sqrt(k2**2)))) - 66*f*k1**2*(-9*Pkd2*k1**2*k2*(16*s**2 - 24*s + 5)*np.sqrt(k2**2) + Pkdd2*k2**4*(16*s**2 - 24*s + 5)*np.sqrt(k2**2) + k2**3*(5*Pk2*(K*(s*(37 - 20*r) - 8) + 48*s**2 + s*(20*r - 109) + 23) + Pkd2*(K*(-4*r*(7*s - 3) - 37*s + 8) + 4*r*(7*s - 3) - 80*s**2 + 157*s - 33)*np.sqrt(k2**2)) + (Pk2*k2**2*(K*(208*r*s - 44*r - 36*s + 7) - 208*r*s + 44*r - 112*s**2 + 204*s - 42) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(16*s**2 - 24*s + 5))*np.sqrt(k2**2)) - 1848*g2*k1**2*r*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(k2**2)**(3/2))) - f*(13*D1*bd1*(f**2*(210*Pk2*k2**4*r*(r - 1)*np.sqrt(k2**2) - 10*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(69*s - 56)*np.sqrt(k2**2) + k1**2*(2*Pk2*(r*(387*s + 51) + 9450*s**2 - 2694*s - 34)*(k2**2)**(3/2) + 5*Pkdd2*k2**4*s*(27*s + 59)*np.sqrt(k2**2) + k2**3*(Pk2*(-6*r*(447*s + 184) + 988*s + 736) + Pkd2*(6*r*(63*s + 50) - 5130*s**2 + 281*s - 200)*np.sqrt(k2**2)))) - 66*f*k1**2*(-9*Pkd2*k1**2*k2*s*(4*s - 5)*np.sqrt(k2**2) + Pkdd2*k2**4*s*(4*s - 5)*np.sqrt(k2**2) + k2**3*(-5*Pk2*(r*(K - 1)*(5*s + 2) + s*(-10*K - 12*s + 25)) + Pkd2*(-r*(K - 1)*(7*s - 2) - 5*s*(2*K + 4*s - 7))*np.sqrt(k2**2)) + (24*Pk2*k1**2*s*(4*s - 5) + k2**2*(Pk2*r*(K - 1)*(52*s + 3) + Pk2*s*(-10*K - 28*s + 45) + Pkdd2*k1**2*s*(4*s - 5)))*np.sqrt(k2**2)) - 1848*g2*k1**2*r*s*(-4*Pk2 + Pkd2*k2)*(k2**2)**(3/2)) + 5*D1*f**2*fd*(360*Pk2*k2**4*(4*r**2 + 11*r - 3)*np.sqrt(k2**2) - 70*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(40*s**2 - 46*s + 9)*np.sqrt(k2**2) + k1**2*(4*Pk2*(8*r*(269*s - 51) + 51740*s**2 - 37185*s + 6030)*(k2**2)**(3/2) + 364*Pkdd2*k2**4*(20*s**2 - 13*s + 2)*np.sqrt(k2**2) + k2**3*(-40*Pk2*(764*r*s - 48*r - 919*s + 194) + Pkd2*(4448*r*s + 448*r - 73580*s**2 + 42451*s - 6404)*np.sqrt(k2**2)))) - 1716*D1*f*gd2*k1**2*(Pk2*(-r*(52*s + 3) + 10*s)*(k2**2)**(3/2) + k2**3*(5*Pk2*(5*r*s + 2*r - 10*s) + Pkd2*(7*r*s - 2*r + 10*s)*np.sqrt(k2**2))) - 1716*D1*fd*g2*k1**2*(Pk2*(r*(50 - 104*s) + 16*s - 7)*(k2**2)**(3/2) + k2**3*(5*Pk2*(10*r*s - 4*r - 17*s + 8) + Pkd2*(14*r*s - 8*r + 17*s - 8)*np.sqrt(k2**2))) + 5*Dd*f**3*(360*Pk2*k2**4*(4*r**2 + 11*r - 3)*np.sqrt(k2**2) - 70*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(40*s**2 - 46*s + 9)*np.sqrt(k2**2) + k1**2*(4*Pk2*(8*r*(269*s - 51) + 51740*s**2 - 37185*s + 6030)*(k2**2)**(3/2) + 364*Pkdd2*k2**4*(20*s**2 - 13*s + 2)*np.sqrt(k2**2) + k2**3*(-40*Pk2*(764*r*s - 48*r - 919*s + 194) + Pkd2*(4448*r*s + 448*r - 73580*s**2 + 42451*s - 6404)*np.sqrt(k2**2)))) - 1716*Dd*f*g2*k1**2*(Pk2*(r*(44 - 208*s) + 36*s - 7)*(k2**2)**(3/2) + k2**3*(5*Pk2*(s*(20*r - 37) + 8) + Pkd2*(4*r*(7*s - 3) + 37*s - 8)*np.sqrt(k2**2)))))/(9009*d**2*k1**3*k2**3*np.sqrt(k2**2)) - 2*D1**3*Pk1*ct**5*(33*D1*bd1*f*(4*b1*k1**2*(2*s - 1)*(Pk2*k1**2*s*(40*C - 64)*(k2**2)**(3/2) - Pkd2*k1**2*k2**3*s*(25*C - 40)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(14*C - 14) + 3*s)*np.sqrt(k2**2) - 3*Pkdd2*k2**7*s + k2**4*(Pk2*r*(28 - 28*C) + Pkdd2*k1**2*s*(5*C - 8))*np.sqrt(k2**2)) + f*(8*Pk2*k2**6*r*(7*k2 + np.sqrt(k2**2))*(r - 1) - 2*k1**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 5)*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(r*(12*s - 13) - 584*s**2 + 396*s + 13) + r*(94 - 113*s) + 2592*s**2 - 1565*s - 94)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*s*(C*(40 - 60*s) + 36*s - 17)*np.sqrt(k2**2) + k2**3*(-2*Pk2*(10*C*(r - 1)*(11*s - 12) - 277*r*s + 228*r + 60*s**2 + 192*s - 228) + Pkd2*(C*(44*r*s - 48*r + 944*s**2 - 692*s + 48) - 112*r*s + 92*r - 834*s**2 + 591*s - 92)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(C*(-20*r**2 + r*(764*s + 44) - 96*s + 88) + 20*r**2 - 3*r*(235*s + 18) + 260*s**2 - 53*s - 78)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(17*r*s + 4*r - 10*s + 10) + 20*r*(2*s + 1) - 146*s**2 + 37*s + 36)*np.sqrt(k2**2) + 4*Pkdd2*k2**3*s*(4*s - 1)))) + 132*b1**2*k1**2*(D1*fd*s + Dd*f*(4*s - 1))*(Pk2*k1**2*s*(40*C - 64)*(k2**2)**(3/2) - Pkd2*k1**2*k2**3*s*(25*C - 40)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(14*C - 14) + 3*s)*np.sqrt(k2**2) - 3*Pkdd2*k2**7*s + k2**4*(Pk2*r*(28 - 28*C) + Pkdd2*k1**2*s*(5*C - 8))*np.sqrt(k2**2)) + 33*b1*f*(D1*fd*(16*Pk2*k2**6*r**2*(7*k2 + np.sqrt(k2**2)) - 2*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5)*np.sqrt(k2**2) + k1**4*(2*Pk2*(4*C*(r*(12*s - 13) - 584*s**2 + 724*s - 212) + r*(96 - 113*s) + 2592*s**2 - 3162*s + 901)*(k2**2)**(3/2) - 2*Pkdd2*k2**4*(4*C*(30*s**2 - 38*s + 11) - 72*s**2 + 94*s - 25)*np.sqrt(k2**2) + k2**3*(-2*Pk2*(r*(220*C*s - 240*C - 554*s + 466) + 120*s**2 - 210*s + 75) + Pkd2*(8*C*(11*r*s - 12*r + 236*s**2 - 295*s + 86) - 224*r*s + 188*r - 1668*s**2 + 2040*s - 563)*np.sqrt(k2**2))) + k1**2*k2**4*(-2*Pk2*(r**2*(20*C - 20) + r*(C*(412 - 764*s) + 705*s - 382) - 260*s**2 + s*(66*C + 194) - 65)*np.sqrt(k2**2) + Pkd2*k2*(r*(C*(96 - 136*s) + 80*s - 68) - 292*s**2 + s*(68*C + 240) - 77)*np.sqrt(k2**2) + 4*Pkdd2*k2**3*(8*s**2 - 12*s + 3))) + Dd*f*(8*Pk2*k2**6*r*(7*k2 + np.sqrt(k2**2))*(4*r - 1) - 2*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5)*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(r*(48*s - 52) - 2336*s**2 + 2268*s - 411) + r*(380 - 452*s) + 10368*s**2 - 9691*s + 1708)*(k2**2)**(3/2) - 2*Pkdd2*k2**4*(4*s - 1)*(C*(60*s - 44) - 36*s + 25)*np.sqrt(k2**2) + k2**3*(2*Pk2*(-10*C*(4*r - 1)*(11*s - 12) + 1108*r*s - 922*r - 240*s**2 + 93*s + 153) + Pkd2*(4*C*(44*r*s - 48*r + 944*s**2 - 935*s + 184) - 448*r*s + 372*r - 3336*s**2 + 3194*s - 655)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(-4*C*(20*r**2 + r*(197 - 764*s) + 77*s - 22) + 80*r**2 + r*(708 - 2820*s) + 1040*s**2 - 491*s + 52)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(4*r*(17*s - 5) - 37*s + 10) + 4*r*(40*s - 11) - 584*s**2 + 314*s - 41)*np.sqrt(k2**2) + 4*Pkdd2*k2**3*(16*s**2 - 16*s + 3)))) + f**2*(D1*fd*(2*Pk2*k2**6*(3*r - 1)*(k2*(555*r + 343) + 50*(3*r - 1)*np.sqrt(k2**2)) - 20*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(27*s**2 - 51*s + 14)*np.sqrt(k2**2) - k1**4*(Pk2*(8*C*(r*(579 - 252*s) + 21924*s**2 - 25158*s + 5785) + r*(4707*s - 7608) - 200268*s**2 + 219921*s - 49042)*(k2**2)**(3/2) + 10*Pkdd2*k2**4*(3*s - 1)*(4*C*(84*s - 61) - 246*s + 137)*np.sqrt(k2**2) + k2**3*(40*C*Pk2*(3*r*(51*s - 160) + 279*s + 50) + 6*Pk2*(r*(5977 - 3708*s) + 1350*s**2 - 5989*s + 266) + Pkd2*(-8*C*(153*r*s - 480*r + 9261*s**2 - 9954*s + 2432) + 4806*r*s - 7410*r + 70182*s**2 - 65847*s + 16087)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(-12*C*(609*r**2 - 4602*r*s + 875*r - 2184*s + 880) + 8118*r**2 - 52569*r*s + 7062*r + 19188*s**2 - 32955*s + 11438)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(9*r*(243*s - 92) + 591*s - 164) + 8262*r*s - 2622*r - 11574*s**2 + 7107*s - 1127)*np.sqrt(k2**2) + 330*Pkdd2*k2**3*(6*s**2 - 5*s + 1))) + Dd*f*(2*Pk2*k2**6*(4*r - 1)*(k2*(555*r + 343) + 50*(3*r - 1)*np.sqrt(k2**2)) - 20*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 65*s + 14)*np.sqrt(k2**2) - k1**4*(Pk2*(8*C*(r*(802 - 336*s) + 29232*s**2 - 31166*s + 5785) + 6*r*(1046*s - 1769) - 267024*s**2 + 271969*s - 49042)*(k2**2)**(3/2) + 10*Pkdd2*k2**4*(4*s - 1)*(4*C*(84*s - 61) - 246*s + 137)*np.sqrt(k2**2) + k2**3*(40*C*Pk2*(r*(204*s - 670) + 419*s + 50) + 6*Pk2*(r*(8361 - 4944*s) + 1800*s**2 - 8639*s + 266) + Pkd2*(-16*C*(r*(102*s - 335) + 6174*s**2 - 6098*s + 1216) + 18*r*(356*s - 575) + 93576*s**2 - 78994*s + 16087)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(-4*C*(2436*r**2 + r*(2375 - 18408*s) - 8942*s + 2640) + 10824*r**2 + r*(4466 - 70092*s) + 25584*s**2 - 41797*s + 11438)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(4*r*(729*s - 236) + 871*s - 164) + 6*r*(1836*s - 431) - 15432*s**2 + 8198*s - 1127)*np.sqrt(k2**2) + 330*Pkdd2*k2**3*(8*s**2 - 6*s + 1)))))/(693*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) - D1**3*Pk1*ct**4*f**2*st**4*(40*C - 40)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1))/(77*d**2*k3**2) + D1**3*Pk1*ct**4*f**2*st**4*(80*C - 80)*(-2*D1*fd*(3*s - 1)*(4*Pk2*k2**2*(3*r + 3*s - 2) + Pkd2*(1 - 3*s)*(k2**2)**(3/2) + k2**3*(-3*Pkd2*r + Pkd2)) + Dd*f*(-4*Pk2*k2**2*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + Pkd2*k2**3*(r*(24*s - 7) - 7*s + 2) + 2*Pkd2*(12*s**2 - 7*s + 1)*(k2**2)**(3/2)))/(77*d**2*k3**4) + D1**3*Pk1*ct**4*st**2*(2574*b1**2*k1**2*(D1*fd*(5*f*(1 - 2*s)**2 - (2*K - 2)*(s - 1)**2) + Dd*f*(4*s - 1)*(-2*K*s + 2*K + 5*f*(2*s - 1) + 2*s - 2))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 39*b1*(D1*(f**2*(-660*bd1*k1**2*s*(2*s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 30*fd*k1**2*(159*s**2 - 128*s + 25)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + fd*r*(Pk2*(3706 - 10425*s) + 5*Pkd2*k2*(513*s - 182))*(k2**2)**(3/2)) + 66*f*k1**2*(fd*(K - 1)*(6*s**2 - 7*s + 2) + s*(s - 1)*(4*K*bd1 - 4*bd1 - 4*gd2))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 264*fd*g2*k1**2*(s - 1)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + Dd*f*(f**2*(-30*k1**2*(212*s**2 - 153*s + 25)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(4408 - 13900*s) + 1875*s - 702) + 5*Pkd2*k2*(36*r*(19*s - 6) - 91*s + 34))*(k2**2)**(3/2)) + 66*f*k1**2*(K - 1)*(12*s**2 - 11*s + 2)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 264*g2*k1**2*(4*s**2 - 5*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)))) + f*(D1*f**2*(-39*bd1*(Pk2*(-720*k1**2*s*(53*s - 25) + k2**2*(-3475*r*s + 702*r + 1875*s - 702))*np.sqrt(k2**2) + 270*Pkd2*k1**2*k2**2*s*(53*s - 25) + 5*Pkd2*k2**3*(171*r*s - 34*r - 91*s + 34)*np.sqrt(k2**2) + 30*Pkdd2*k1**2*s*(25 - 53*s)*(k2**2)**(3/2)) + fd*(100*k1**2*(1312*s**2 - 916*s + 147)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(4*r*(113155*s - 28708) - 178155*s + 44958) - 5*Pkd2*k2*(r*(20252*s - 4790) - 8313*s + 2010))*(k2**2)**(3/2))) + 2574*D1*f*k1**2*s*(3*s - 2)*(-K*bd1 + bd1 + 2*gd2)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 5148*D1*g2*k1**2*(2*bd1*s*(s - 1) + fd*(6*s**2 - 7*s + 2))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + Dd*f**3*(100*k1**2*(1312*s**2 - 916*s + 147)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(4*r*(113155*s - 28708) - 178155*s + 44958) - 5*Pkd2*k2*(r*(20252*s - 4790) - 8313*s + 2010))*(k2**2)**(3/2)) + 5148*Dd*f*g2*k1**2*(12*s**2 - 11*s + 2)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))))/(9009*d**2*k1**2*(k2**2)**(3/2)) - D1**3*Pk1*ct**4*(-10296*b1**3*k1**2*s*(D1*fd*s + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 429*b1**2*(2*D1*(-12*bd1*f*k1**2*s*(3*s - 1)*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + fd*k1**2*(Pk2*(K*(-500*s**2 + 968*s - 484) + f*(45*r*s - 46*r + 784*s**2 - 1072*s + 244) + 96*r*(s - 1) + 308*s**2 - 584*s + 292)*np.sqrt(k2**2) + Pkd2*k2**2*(K*(209*s**2 - 398*s + 199) + f*(-6*r*(8*s - 5) - 148*s**2 + 328*s - 67) - 89*s**2 + 158*s - 79) + 6*Pkd2*k2*r*(f*(6*s - 3) - 4*s + 4)*np.sqrt(k2**2) + 2*Pkdd2*(K*(-14*s**2 + 26*s - 13) + f*(-8*s**2 - 10*s + 1) + 2*s**2 - 2*s + 1)*(k2**2)**(3/2)) + 2*fd*r*(Pk2*(-16*K*r + f*(19 - 53*s) + 16*r + 4*s - 4) + 2*Pkd2*k2*(f*(14*s - 5) - s + 1))*(k2**2)**(3/2)) + Dd*f*(k1**2*(Pk2*(8*K*(-500*s**2 + 609*s - 121) + f*(20*r*(9*s - 14) + 3136*s**2 - 2877*s + 582) + 768*r*s - 480*r + 2464*s**2 - 3048*s + 680)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(f*(6*r*(16*s - 9) + 296*s**2 - 360*s + 79) - (4*s - 1)*(K*(209*s - 199) - 89*s + 79)) + 12*Pkd2*k2*(r*(3*f*(4*s - 1) - 16*s + 10) + 2*s - 2)*np.sqrt(k2**2) - 4*Pkdd2*(4*s - 1)*(K*(14*s - 13) + 4*f*s + f - 2*s + 1)*(k2**2)**(3/2)) + 2*(Pk2*(f*(r*(76 - 212*s) + 37*s - 15) - 8*r**2*(16*K - 16) + 32*r*(K + s + 1) + 24*s - 24) + 4*Pkd2*k2*(f*(2*r*(14*s - 5) - 5*s + 2) - 4*r*(s + 2) - 3*s + 3))*(k2**2)**(3/2))) + 13*b1*(-41712*D1*K*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 71016*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 25080*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 3696*D1*K*Pk2*f*fd*r**2*(k2**2)**(3/2) + 1320*D1*K*Pk2*f*fd*r*(k2**2)**(3/2) + 264*D1*K*Pk2*f*fd*(k2**2)**(3/2) + 18348*D1*K*Pkd2*f*fd*k1**2*k2**2*s**2 - 30426*D1*K*Pkd2*f*fd*k1**2*k2**2*s + 10626*D1*K*Pkd2*f*fd*k1**2*k2**2 - 2640*D1*K*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) + 4224*D1*K*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) - 1452*D1*K*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) - 6336*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) + 6336*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 6246*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 8412*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 273456*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) - 233703*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 47346*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 216*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 585*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) + 36*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) + 11190*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) - 2682*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 2904*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 5016*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 24816*D1*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) - 33396*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 12276*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 3696*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) - 264*D1*Pk2*f*fd*r*s*(k2**2)**(3/2) + 4884*D1*Pk2*f*fd*s*(k2**2)**(3/2) - 3300*D1*Pk2*f*fd*(k2**2)**(3/2) + 66000*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) - 63888*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 4224*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 66000*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) - 127776*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 63888*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 4224*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 3960*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 - 3960*D1*Pkd2*bd2*f*k1**2*k2**2*s - 4824*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 4380*D1*Pkd2*f**2*fd*k1**2*k2**2*r - 94284*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 82080*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 16146*D1*Pkd2*f**2*fd*k1**2*k2**2 + 5940*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 1980*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 1836*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) + 24*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) - 5892*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) + 1180*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) - 7788*D1*Pkd2*f*fd*k1**2*k2**2*s**2 + 11946*D1*Pkd2*f*fd*k1**2*k2**2*s - 4026*D1*Pkd2*f*fd*k1**2*k2**2 - 792*D1*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 1320*D1*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) - 1980*D1*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) + 528*D1*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) + 264*D1*Pkd2*f*fd*k2**3*r*s*np.sqrt(k2**2) - 792*D1*Pkd2*f*fd*k2**3*r*np.sqrt(k2**2) - 2508*D1*Pkd2*f*fd*k2**3*s*np.sqrt(k2**2) + 1584*D1*Pkd2*f*fd*k2**3*np.sqrt(k2**2) - 27588*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 + 26268*D1*Pkd2*f*gd2*k1**2*k2**2*s - 27588*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 + 52536*D1*Pkd2*fd*g2*k1**2*k2**2*s - 26268*D1*Pkd2*fd*g2*k1**2*k2**2 - 792*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) + 792*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 8640*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 7860*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 1420*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) + 528*D1*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) - 528*D1*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) + 132*D1*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) + 3696*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) - 3432*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) + 3696*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) - 6864*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) + 3432*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 33*D1*bd1*f*(k1**2*(Pk2*(f*(2*r*(45*s - 94) + 1568*s**2 - 733*s + 94) + 192*r*(2*s - 1) + 16*s**2*(77 - 125*K) + 16*s*(123*K - 81) + 96)*np.sqrt(k2**2) - 4*Pkd2*k2**2*s*(-209*K*s + 204*K + 89*s - 84) - 24*Pkd2*k2*(4*r*s - 2*r - s + 1)*np.sqrt(k2**2) - 4*Pkdd2*s*(28*K*s - 27*K - 4*s + 3)*(k2**2)**(3/2) - 8*f*(Pkd2*k2**2*(12*r*s - 6*r + 37*s**2 - 8*s + 3) - 9*Pkd2*k2*r*s*np.sqrt(k2**2) + Pkdd2*s*(4*s - 5)*(k2**2)**(3/2))) + 2*(Pk2*(f*(r*(38 - 106*s) + 37*s - 15) - 8*r**2*(8*K - 8) + 16*r*(2*K + s + 1) + 24*s - 24) + 4*Pkd2*k2*(f*(r*(14*s - 5) - 5*s + 2) - 2*r*(s + 3) - 3*s + 3))*(k2**2)**(3/2)) - 83424*Dd*K*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 121176*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 25080*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) - 7392*Dd*K*Pk2*f**2*r**2*(k2**2)**(3/2) + 792*Dd*K*Pk2*f**2*r*(k2**2)**(3/2) + 264*Dd*K*Pk2*f**2*(k2**2)**(3/2) + 36696*Dd*K*Pkd2*f**2*k1**2*k2**2*s**2 - 51678*Dd*K*Pkd2*f**2*k1**2*k2**2*s + 10626*Dd*K*Pkd2*f**2*k1**2*k2**2 - 5280*Dd*K*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) + 7128*Dd*K*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) - 1452*Dd*K*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 8328*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 14896*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 364608*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) - 276526*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 50588*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 288*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 780*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) + 1268*Dd*Pk2*f**3*r*(k2**2)**(3/2) + 12065*Dd*Pk2*f**3*s*(k2**2)**(3/2) - 3400*Dd*Pk2*f**3*(k2**2)**(3/2) + 5808*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 12144*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 49632*Dd*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) - 50820*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 12276*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) + 7392*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) - 528*Dd*Pk2*f**2*r*s*(k2**2)**(3/2) + 1848*Dd*Pk2*f**2*r*(k2**2)**(3/2) + 9636*Dd*Pk2*f**2*s*(k2**2)**(3/2) - 3300*Dd*Pk2*f**2*(k2**2)**(3/2) + 264000*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) - 321552*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 63888*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 16896*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 4224*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 6432*Dd*Pkd2*f**3*k1**2*k2**2*r*s + 6100*Dd*Pkd2*f**3*k1**2*k2**2*r - 125712*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 94960*Dd*Pkd2*f**3*k1**2*k2**2*s - 17006*Dd*Pkd2*f**3*k1**2*k2**2 + 7920*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 1980*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) + 2448*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) - 488*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) - 6412*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) + 1572*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) - 15576*Dd*Pkd2*f**2*k1**2*k2**2*s**2 + 19998*Dd*Pkd2*f**2*k1**2*k2**2*s - 4026*Dd*Pkd2*f**2*k1**2*k2**2 - 1584*Dd*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) + 3168*Dd*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) - 4884*Dd*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) + 528*Dd*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) + 528*Dd*Pkd2*f**2*k2**3*r*s*np.sqrt(k2**2) - 1584*Dd*Pkd2*f**2*k2**3*r*np.sqrt(k2**2) - 4884*Dd*Pkd2*f**2*k2**3*s*np.sqrt(k2**2) + 1584*Dd*Pkd2*f**2*k2**3*np.sqrt(k2**2) - 110352*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 + 132660*Dd*Pkd2*f*g2*k1**2*k2**2*s - 26268*Dd*Pkd2*f*g2*k1**2*k2**2 + 11520*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) - 8560*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) + 1420*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) + 1056*Dd*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) - 792*Dd*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) + 132*Dd*Pkdd2*f**2*k1**2*(k2**2)**(3/2) + 14784*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) - 17424*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) + 3432*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) - 792*b2*k1**2*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + f*(-54912*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) + 68640*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 133420*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 83320*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 2803840*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) - 2148565*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 391070*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 62080*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 237900*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) - 97340*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) - 260975*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) + 70830*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 542256*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) - 652080*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 48048*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 6864*D1*Pk2*f*gd2*r*(k2**2)**(3/2) + 1084512*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) - 1846416*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 652080*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 96096*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) - 34320*D1*Pk2*fd*g2*r*(k2**2)**(3/2) - 6864*D1*Pk2*fd*g2*(k2**2)**(3/2) + 34320*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 - 42900*D1*Pkd2*bd2*f*k1**2*k2**2*s - 15200*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 35000*D1*Pkd2*f**2*fd*k1**2*k2**2*r - 1050400*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 800440*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 142260*D1*Pkd2*f**2*fd*k1**2*k2**2 + 43680*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 10920*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) - 33800*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) + 13520*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) + 8450*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) - 3380*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) - 238524*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 + 276276*D1*Pkd2*f*gd2*k1**2*k2**2*s - 477048*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 + 791076*D1*Pkd2*fd*g2*k1**2*k2**2*s - 276276*D1*Pkd2*fd*g2*k1**2*k2**2 - 6864*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) + 8580*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 116480*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 87360*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 14560*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) + 34320*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) - 37752*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) + 68640*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) - 109824*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) + 37752*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 13*D1*bd1*(f**2*(k1**2*(Pk2*(-2*r*(1041*s + 3242) + 91152*s**2 - 42823*s + 3242)*np.sqrt(k2**2) - 4*Pkd2*k2**2*(402*r*s - 430*r + 7857*s**2 - 3220*s + 215) + 1980*Pkd2*k2*r*s*np.sqrt(k2**2) - 20*Pkdd2*s*(35 - 144*s)*(k2**2)**(3/2)) + (Pk2*(72*r**2 + 195*r*s + 1232*r + 875*s - 718) + 4*Pkd2*k2*(153*r*s - 128*r - 130*s + 98))*(k2**2)**(3/2)) + 66*f*(k1**2*(2*Pk2*(r*(11*s - 27) + 2*s*(-79*K*s + 95*K + 47*s - 33))*np.sqrt(k2**2) + Pkd2*k2**2*s*(139*K*s - 161*K - 59*s + 61) - 2*Pkd2*k2*(3*r*s - 7*r + 11*s)*np.sqrt(k2**2) + 2*Pkdd2*s*(-10*K*s + 11*K + 2*s - 1)*(k2**2)**(3/2)) + 2*(Pk2*(r**2*(14 - 14*K) - r*(2*K + s - 7) + 18*s) + Pkd2*k2*(r*(s - 3) - 9*s))*(k2**2)**(3/2)) + 132*g2*(4*Pk2*(125*k1**2*s*(s - 1) + 8*k2**2*r*(r - 1))*np.sqrt(k2**2) - k1**2*s*(s - 1)*(209*Pkd2*k2**2 - 28*Pkdd2*(k2**2)**(3/2)))) - 133420*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 83320*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 2803840*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) - 2148565*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 391070*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 62080*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 237900*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) - 97340*Dd*Pk2*f**3*r*(k2**2)**(3/2) - 260975*Dd*Pk2*f**3*s*(k2**2)**(3/2) + 70830*Dd*Pk2*f**3*(k2**2)**(3/2) + 2169024*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) - 3150576*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 652080*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 192192*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 20592*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 6864*Dd*Pk2*f*g2*(k2**2)**(3/2) - 15200*Dd*Pkd2*f**3*k1**2*k2**2*r*s + 35000*Dd*Pkd2*f**3*k1**2*k2**2*r - 1050400*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 800440*Dd*Pkd2*f**3*k1**2*k2**2*s - 142260*Dd*Pkd2*f**3*k1**2*k2**2 + 43680*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 10920*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 33800*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) + 13520*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) + 8450*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) - 3380*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) - 954096*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 + 1343628*Dd*Pkd2*f*g2*k1**2*k2**2*s - 276276*Dd*Pkd2*f*g2*k1**2*k2**2 + 116480*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) - 87360*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) + 14560*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) + 137280*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) - 185328*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) + 37752*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) - 1716*b2*k1**2*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))*(6*D1*bd1*s*(s - 1) + D1*fd*(8*s**2 - 14*s + 5) + Dd*f*(16*s**2 - 24*s + 5))))/(9009*d**2*k1**2*(k2**2)**(3/2)) - 2*D1**3*Pk1*ct**4*st**2*(396*b1**2*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1))*(k2**2)**(3/2) + 33*b1*f*(2*D1*(6*bd1*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*(k2**2)**(3/2) + fd*(k1**4*(2*s - 1)*(C*(9*s - 6) - 26*s + 16)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - k1**2*(2*Pk2*(C*(r*(343*s - 198) + 848*s**2 - 920*s + 230) + r*(258 - 463*s) - 472*s**2 + 532*s - 130) + k2*(Pkd2*(-2*C*(r*(82*s - 47) + 311*s**2 - 356*s + 89) + 4*r*(56*s - 31) + 152*s**2 - 227*s + 53) + Pkdd2*k2*(3*C*(22*s**2 - 28*s + 7) + 28*s**2 - 13*s + 4)))*(k2**2)**(3/2) + 2*k2**4*r*(-2*Pk2*(r*(2*C - 2) - 2*s + 1)*np.sqrt(k2**2) + Pkd2*k2*(-6*k2 + 5*np.sqrt(k2**2))*(2*s - 1)))) + Dd*f*(2*k1**4*(4*s - 1)*(C*(9*s - 6) - 26*s + 16)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - k1**2*(2*Pk2*(C*(1372*r*s - 640*r + 3392*s**2 - 2879*s + 582) - 1852*r*s + 820*r - 1888*s**2 + 1763*s - 412) + k2*(Pkd2*(C*(-656*r*s + 300*r - 2488*s**2 + 2134*s - 412) + 896*r*s - 390*r + 608*s**2 - 694*s + 177) + 2*Pkdd2*k2*(4*s - 1)*(3*C*(11*s - 7) + 14*s - 4)))*(k2**2)**(3/2) + k2**4*(2*Pk2*(-r**2*(16*C - 16) + 2*r*(2*C + 8*s + 1) + 10*s - 5)*np.sqrt(k2**2) + Pkd2*k2*(24*k2*r*(1 - 4*s) + 5*(2*r*(8*s - 3) - 2*s + 1)*np.sqrt(k2**2))))) + f**2*(D1*(33*bd1*(-18*Pkd2*k1**4*k2**2*s*(C*(9*s - 6) - 26*s + 16) + Pkd2*k1**2*k2**3*(2*C*(r*(82*s - 28) + 311*s**2 - 177*s + 28) + r*(71 - 224*s) - 152*s**2 + 134*s - 71)*np.sqrt(k2**2) - 24*Pkd2*k2**6*r*s + 5*Pkd2*k2**5*(r*(4*s - 1) - 2*s + 1)*np.sqrt(k2**2) + 2*k1**2*(24*Pk2*k1**2*s*(C*(9*s - 6) - 26*s + 16) + k2**2*(Pk2*(C*(-343*r*s + 122*r - 848*s**2 + 579*s - 122) + 463*r*s - 152*r + 472*s**2 - 439*s + 152) + Pkdd2*k1**2*s*(C*(9*s - 6) - 26*s + 16)))*np.sqrt(k2**2) + 2*k2**4*(Pk2*(-r**2*(4*C - 4) + r*(4*C + 4*s + 1) + 10*s - 5) + Pkdd2*k1**2*s*(C*(12 - 33*s) - 14*s + 13))*np.sqrt(k2**2)) + 2*fd*(k1**4*(3*s - 1)*(6*C*(42*s - 25) - 705*s + 400)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - k1**2*(Pk2*(3*C*(9159*r*s - 4538*r + 22848*s**2 - 19649*s + 4506) - 34659*r*s + 16899*r - 38592*s**2 + 33453*s - 8645) + k2*(Pkd2*(-3*C*(4*r*(591*s - 296) + 9285*s**2 - 7847*s + 1716) + 8937*r*s - 4398*r + 9135*s**2 - 7815*s + 2063) + Pkdd2*k2*(3*s - 1)*(3*C*(397*s - 191) + 57*s - 52)))*(k2**2)**(3/2) + k2**4*(Pk2*(C*(-2394*r**2 + 2916*r - 706) + 2394*r**2 + 432*r*s - 3159*r + 780*s + 479)*np.sqrt(k2**2) + Pkd2*k2*(-132*k2*r*(3*s - 1) + (279*r*s - 60*r - 423*s + 130)*np.sqrt(k2**2))))) + Dd*f*(2*k1**4*(4*s - 1)*(6*C*(42*s - 25) - 705*s + 400)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - k1**2*(2*Pk2*(C*(4*r*(9159*s - 4342) + 91392*s**2 - 68711*s + 13518) - 6*r*(7702*s - 3615) - 51456*s**2 + 37307*s - 8645) + k2*(Pkd2*(-2*C*(r*(9456*s - 4540) + 37140*s**2 - 27701*s + 5148) + 3*r*(7944*s - 3769) + 24360*s**2 - 17245*s + 4126) + 2*Pkdd2*k2*(4*s - 1)*(3*C*(397*s - 191) + 57*s - 52)))*(k2**2)**(3/2) + k2**4*(2*Pk2*(C*(-3192*r**2 + 3622*r - 706) + 3192*r**2 + 9*r*(64*s - 437) + 1075*s + 479)*np.sqrt(k2**2) + Pkd2*k2*(-264*k2*r*(4*s - 1) + (r*(744*s - 85) - 1141*s + 260)*np.sqrt(k2**2))))))/(693*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 2*D1**3*Pk1*ct**4*(33*D1*bd1*f*(2*b1*(Pkd2*k1**4*k2**2*s*(10*C + 15)*(2*s - 1) + Pkd2*k1**2*k2**3*(r*(s*(28*C - 52) + 6) + s*(C*(190*s - 109) - 156*s + 98))*np.sqrt(k2**2) + 14*Pkd2*k2**6*r*(1 - 2*s) + 6*Pkd2*k2**5*(r*(4*s - 1) - s)*np.sqrt(k2**2) + k1**2*(Pk2*k1**2*s*(-16*C - 24)*(2*s - 1) + k2**2*(-3*Pk2*(2*r*(7*C*s - 15*s + 2) + s*(92*C*s - 53*C - 92*s + 57)) - Pkdd2*k1**2*s*(2*C + 3)*(2*s - 1)))*np.sqrt(k2**2) + k2**4*(Pk2*r*(32 - 32*C)*(2*r - 1) - Pkdd2*k1**2*s*(26*C - 9)*(2*s - 1))*np.sqrt(k2**2)) + f*(-2*k1**4*(Pk2*(r*(67 - 27*s) + s**2*(348*C - 716) + s*(687 - 412*C) - 67)*np.sqrt(k2**2) + Pkd2*k2**2*s*(C*(181 - 159*s) - 12*r + 275*s - 235) + Pkd2*k2*(r*(19*s - 17) - 15*s + 17)*np.sqrt(k2**2) + 2*Pkdd2*s*(C*(12*s - 13) - 16*s + 13)*(k2**2)**(3/2)) + k1**2*(Pk2*(-2*C*(8*r**2 - 541*r*s + 160*r - 358*s**2 + 380*s - 184) + 7*r**2 - 1210*r*s + 239*r + 44*s**2 + 228*s - 306) + 2*k2*(-Pkd2*(C*(142*r*s - 84*r + 205*s**2 - 191*s + 92) - 148*r*s + 63*r + 17*s**2 + 46*s - 78) + 2*Pkdd2*k2*s*(2*C*(s + 2) + 14*s - 11)))*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(40*C - 5) + r*(-104*C - 148*s + 73) + 8*s - 4)*np.sqrt(k2**2) + 2*Pkd2*k2*(-6*k2*(2*r*s - 3*r - 2*s + 1) + (13*r*s - 12*r - 9*s + 9)*np.sqrt(k2**2))))) + 66*b1**2*(D1*fd*(Pkd2*k1**4*k2**2*s**2*(10*C + 15) + Pkd2*k1**2*k2**3*s*(r*(14*C - 26) + s*(95*C - 78))*np.sqrt(k2**2) - 14*Pkd2*k2**6*r*s + 12*Pkd2*k2**5*r*s*np.sqrt(k2**2) - k1**2*s*(Pk2*k1**2*s*(16*C + 24) + k2**2*(3*Pk2*(r*(7*C - 15) + s*(46*C - 46)) + Pkdd2*k1**2*s*(2*C + 3)))*np.sqrt(k2**2) + k2**4*(Pk2*r**2*(32 - 32*C) + Pkdd2*k1**2*s**2*(9 - 26*C))*np.sqrt(k2**2)) + Dd*f*(Pkd2*k1**4*k2**2*s*(10*C + 15)*(4*s - 1) + Pkd2*k1**2*k2**3*(2*r*(s*(28*C - 52) + 3) + s*(C*(380*s - 109) - 312*s + 98))*np.sqrt(k2**2) + 14*Pkd2*k2**6*r*(1 - 4*s) + 6*Pkd2*k2**5*(r*(8*s - 1) - s)*np.sqrt(k2**2) + k1**2*(Pk2*k1**2*s*(-16*C - 24)*(4*s - 1) + k2**2*(-3*Pk2*(4*r*(7*C*s - 15*s + 1) + s*(184*C*s - 53*C - 184*s + 57)) - Pkdd2*k1**2*s*(2*C + 3)*(4*s - 1)))*np.sqrt(k2**2) + k2**4*(Pk2*r*(32 - 32*C)*(4*r - 1) - Pkdd2*k1**2*s*(26*C - 9)*(4*s - 1))*np.sqrt(k2**2))) + 33*b1*f*(2*D1*fd*(k1**4*(2*Pk2*(-2*C*(174*s**2 - 269*s + 95) + 27*r*s - 51*r + 716*s**2 - 962*s + 306)*np.sqrt(k2**2) + Pkd2*k2**2*(C*(318*s**2 - 461*s + 161) + 24*r*s - 12*r - 550*s**2 + 715*s - 225) - 38*Pkd2*k2*r*(s - 1)*np.sqrt(k2**2) + 2*Pkdd2*(C*(-24*s**2 + 32*s - 11) + 32*s**2 - 39*s + 12)*(k2**2)**(3/2)) + k1**2*(Pk2*(C*(-16*r**2 + 1082*r*s - 560*r + 716*s**2 - 997*s + 218) + 7*r**2 - 1210*r*s + 591*r + 44*s**2 + 202*s + 4) + k2*(-Pkd2*(2*C*(142*r*s - 76*r + 205*s**2 - 296*s + 66) - 296*r*s + 142*r + 34*s**2 + 105*s + 3) + 2*Pkdd2*k2*(C*(4*s**2 - 24*s + 6) + 28*s**2 - 21*s + 6)))*(k2**2)**(3/2) + k2**4*(Pk2*(4*C*(10*r**2 + 5*r + 1) - 5*r**2 - 148*r*s + 57*r - 3*s - 4)*np.sqrt(k2**2) + Pkd2*k2*s*(-24*k2*r + (26*r - 19)*np.sqrt(k2**2)))) + Dd*f*(-2*k1**4*(Pk2*(4*C*(348*s**2 - 467*s + 95) - 4*r*(27*s - 59) - 2864*s**2 + 3223*s - 679)*np.sqrt(k2**2) - Pkd2*k2**2*(4*s - 1)*(C*(159*s - 161) + 12*r - 275*s + 225) + Pkd2*k2*(r*(76*s - 72) - 15*s + 17)*np.sqrt(k2**2) + 2*Pkdd2*(4*s - 1)*(C*(12*s - 11) - 16*s + 12)*(k2**2)**(3/2)) + k1**2*(Pk2*(C*(-64*r**2 + 8*r*(541*s - 206) + 2864*s**2 - 3350*s + 804) + 28*r**2 - 4840*r*s + 1523*r + 176*s**2 + 828*s - 298) + 2*k2*(-Pkd2*(C*(8*r*(71*s - 36) + 820*s**2 - 955*s + 224) - 592*r*s + 232*r + 68*s**2 + 199*s - 75) + 4*Pkdd2*k2*(4*s - 1)*(C*(s - 3) + 7*s - 3)))*(k2**2)**(3/2) + k2**4*(Pk2*(8*C*(20*r**2 - 9*r + 1) - 20*r**2 + r*(199 - 592*s) + 2*s - 12)*np.sqrt(k2**2) + 2*Pkd2*k2*(-6*k2*(4*r - 1)*(2*s - 1) + (4*r*(13*s - 3) - 37*s + 9)*np.sqrt(k2**2))))) + f**2*(D1*fd*(Pk2*k2**4*(8*C*(801*r**2 - 72*r - 65) - 2331*r**2 - 3*r*(2652*s - 1127) - 8106*s + 2718)*np.sqrt(k2**2) + 66*Pkd2*k2**6*(r*(12*s - 1) + 6*s - 3) - 2*k1**4*(2*Pk2*(18*C*(591*s**2 - 1076*s + 293) + 3*r*(129*s + 727) - 25092*s**2 + 32571*s - 8839)*np.sqrt(k2**2) - 3*Pkd2*k2**2*(3*s - 1)*(C*(1101*s - 1489) + 110*r - 2219*s + 2067) + Pkd2*k2*(6*r*(141*s - 245) + 543*s + 215)*np.sqrt(k2**2) + 5*Pkdd2*(3*s - 1)*(2*C*(51*s - 61) - 165*s + 132)*(k2**2)**(3/2)) + k1**2*(Pk2*(-4*C*(2052*r**2 - 14346*r*s + 5130*r - 15984*s**2 + 4515*s - 73) + 13293*r**2 - 69282*r*s + 9117*r - 8532*s**2 - 35304*s + 15898) + 2*k2*(Pkd2*(-2*C*(5067*r*s - 3174*r + 10494*s**2 - 8652*s + 2213) + 13302*r*s - 5721*r + 3672*s**2 - 3648*s + 1237) + 165*Pkdd2*k2*(3*s - 1)*(C*(4*s - 2) + 3*s - 2)))*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(8*C*(1068*r**2 - 7*r - 65) - 3108*r**2 + r*(3499 - 10608*s) - 10942*s + 2718)*np.sqrt(k2**2) + 66*Pkd2*k2**6*(2*r*(8*s + 1) + 6*s - 3) - 2*k1**4*(2*Pk2*(18*C*(788*s**2 - 1369*s + 293) + 4*r*(129*s + 797) - 33456*s**2 + 40403*s - 8839)*np.sqrt(k2**2) - 3*Pkd2*k2**2*(4*s - 1)*(C*(1101*s - 1489) + 110*r - 2219*s + 2067) + Pkd2*k2*(2*r*(564*s - 995) + 848*s + 215)*np.sqrt(k2**2) + 5*Pkdd2*(4*s - 1)*(2*C*(51*s - 61) - 165*s + 132)*(k2**2)**(3/2)) + k1**2*(Pk2*(-4*C*(2736*r**2 + r*(6370 - 19128*s) - 21312*s**2 + 3348*s - 73) + 17724*r**2 - 92376*r*s + 7991*r - 11376*s**2 - 50076*s + 15898) + 2*k2*(Pkd2*(-2*C*(r*(6756*s - 4132) + 13992*s**2 - 9907*s + 2213) + 24*r*(739*s - 282) + 4896*s**2 - 3838*s + 1237) + 165*Pkdd2*k2*(4*s - 1)*(C*(4*s - 2) + 3*s - 2)))*(k2**2)**(3/2))))/(693*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 4*D1**3*Pk1*ct**4*st**2*(33*D1*bd1*f*(-12*b1*k1**2*(C - 1)*(2*Pk2*k2**2*(-4*r*s + r + s*(3 - 4*s)) + Pkd2*k2**3*(r*(4*s - 1) - s) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + f*(Pk2*k2**4*(4*r**2 + 4*r*s + r + 10*s - 5) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + r*(11 - 32*s) - 32*s**2 + 38*s - 11) + k1**2*(Pk2*k2**2*(-2*C*(129*r**2 + 407*r*s - 201*r + 278*s**2 - 278*s + 84) + 318*r**2 + 442*r*s - 357*r + 124*s**2 - 130*s + 63) + 6*Pkd2*k2**3*(C*(14*r*s - 2*r - 9*s + 4) + 24*r*s - 8*r + 16*s**2 - 19*s + 6) + 12*Pkd2*(C*(4*r*s - r + 11*s**2 - 6*s + 1) - 5*r*s + r - s**2 + s - 1)*(k2**2)**(3/2)))) - 396*b1**2*k1**2*(C - 1)*(2*D1*fd*s*(-2*Pk2*k2**2*(r + s) + Pkd2*k2**3*r + Pkd2*s*(k2**2)**(3/2)) + Dd*f*(-2*Pk2*k2**2*(r*(8*s - 1) + s*(8*s - 3)) + Pkd2*k2**3*(r*(8*s - 1) - s) + 2*Pkd2*s*(4*s - 1)*(k2**2)**(3/2))) + 33*b1*f*(2*D1*fd*(2*Pk2*k2**4*r*(2*r + 2*s - 1) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + r*(35 - 64*s) - 64*s**2 + 70*s - 19) + k1**2*(Pk2*k2**2*(-C*(258*r**2 + 814*r*s - 460*r + 556*s**2 - 598*s + 157) + 318*r**2 + 442*r*s - 268*r + 124*s**2 - 154*s + 43) + 3*Pkd2*k2**3*(5*C*s + r*(4*C*(7*s - 5) + 48*s - 19) + 32*s**2 - 39*s + 9) + 6*Pkd2*(C*(8*r*s - 4*r + 22*s**2 - 28*s + 7) - 10*r*s + 5*r - 2*s**2 + 8*s - 2)*(k2**2)**(3/2))) + Dd*f*(Pk2*k2**4*(8*r + 5)*(2*r + 2*s - 1) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(2*C*(r*(32*s - 15) + 32*s**2 - 33*s + 8) + r*(57 - 128*s) - 128*s**2 + 127*s - 30) + k1**2*(Pk2*k2**2*(-2*C*(516*r**2 + 1628*r*s - 751*r + 1112*s**2 - 1027*s + 241) + 1272*r**2 + 1768*r*s - 968*r + 496*s**2 - 512*s + 149) + 6*Pkd2*k2**3*(C*(56*r*s - 27*r - 3*s + 4) + 96*r*s - 32*r + 64*s**2 - 68*s + 15) + 12*Pkd2*(C*(16*r*s - 6*r + 44*s**2 - 41*s + 8) - 20*r*s + 7*r - 4*s**2 + 11*s - 3)*(k2**2)**(3/2)))) + f**2*(2*D1*fd*(-Pk2*k2**4*(27*r - 163)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*C*(r*(372*s - 179) + 372*s**2 - 438*s + 123) - 11*r*(210*s - 97) - 2310*s**2 + 2618*s - 715) + k1**2*(Pk2*k2**2*(-C*(8361*r**2 + 3*r*(10881*s - 5243) + 24282*s**2 - 24462*s + 6143) + 10008*r**2 + 18*r*(977*s - 524) + 7578*s**2 - 6921*s + 1543) + 6*Pkd2*k2**3*(5*C*(r*(159*s - 64) - 31*s + 14) + r*(696*s - 298) + 597*s**2 - 652*s + 173) + 6*Pkd2*(C*(33*r*(12*s - 5) + 1191*s**2 - 1036*s + 224) - 99*r*(5*s - 2) - 99*(1 - 2*s)**2)*(k2**2)**(3/2))) + Dd*f*(Pk2*k2**4*(-216*r**2 - 3*r*(72*s - 481) + 1273*s - 652) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(3*C*(r*(496*s - 229) + 496*s**2 - 511*s + 123) - 22*r*(140*s - 61) - 3080*s**2 + 3058*s - 715) + k1**2*(Pk2*k2**2*(-2*C*(11148*r**2 + 43524*r*s - 17795*r + 32376*s**2 - 28539*s + 6143) + 26688*r**2 + 46896*r*s - 20083*r + 20208*s**2 - 15709*s + 3086) + 6*Pkd2*k2**3*(5*C*(424*r*s - 153*r - 65*s + 28) + 1856*r*s - 721*r + 1592*s**2 - 1525*s + 346) + 12*Pkd2*(C*(66*r*(8*s - 3) + 1588*s**2 - 1227*s + 224) - 33*r*(20*s - 7) - 528*s**2 + 462*s - 99)*(k2**2)**(3/2)))))/(693*d**2*k1**2*k3**4) + 8*D1**3*Pk1*ct**4*(33*D1*bd1*f*(b1*(-2*Pk2*k2**6*(2*r**2 + r*(2*s - 5) + 3*s)*np.sqrt(k2**2) + 2*k1**4*(-2*Pk2 + Pkd2*k2)*(r*(C*(2*s + 3) - 17*s - 1) + s*(C*(2*s - 5) - 17*s + 18))*(k2**2)**(3/2) + k1**2*k2**4*(2*Pk2*(r**2*(49*C - 61) + r*(C*(118*s - 75) - 130*s + 84) + s*(C*(69*s - 43) - 69*s + 46))*np.sqrt(k2**2) + Pkd2*k2*(k2*(-7*r*(8*C*s - 2*C - 10*s + 3) + 2*s*(-52*C*s + 33*C + 28*s - 21)) + (-r*(12*C + 11)*(4*s - 1) + s*(12*C - 30*s + 26))*np.sqrt(k2**2)))) + f*(Pk2*k2**6*(2*r**2 + 2*r*s - r + 3*s + 3)*np.sqrt(k2**2) + k1**6*(4*Pk2*(r*(2*s - 5) + 2*s**2 - 8*s + 5)*np.sqrt(k2**2) + Pkd2*k2*(6*k2*r*s - 2*k2*s*(s - 2) + r*(5 - 8*s)*np.sqrt(k2**2) + (4*s - 5)*np.sqrt(k2**2))) + k1**4*(Pk2*(C*(-6*r**2 + 199*r*s - 134*r + 205*s**2 - 369*s + 128) + 5*r**2 - 274*r*s + 110*r - 279*s**2 + 373*s - 109) + Pkd2*k2*(-6*C*(18*r*s - 13*r + 18*s**2 - 31*s + 12) + 112*r*s - 61*r + 112*s**2 - 163*s + 58))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(-C*(177*r**2 + r*(378*s - 251) + 201*s**2 - 221*s + 116) + 177*r**2 + 3*r*(66*s - 83) + 21*s**2 - 104*s + 108)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-6*r*(C*(4*s - 2) - 7*s + 4) + s**2*(8*C + 24) + s*(16*C - 36) + 6) + (2*C*(2*r*(8*s - 1) - 13*s + 7) + 3*r*(8*s - 2) + 42*s**2 - 45*s + 15)*np.sqrt(k2**2))))) - 33*b1**2*(D1*fd*(2*Pk2*k2**6*r*(r + s)*np.sqrt(k2**2) + k1**4*s*(2*C - 17)*(2*Pk2 - Pkd2*k2)*(r + s)*(k2**2)**(3/2) + k1**2*k2**4*(-Pk2*(r + s)*(r*(49*C - 61) + s*(69*C - 69))*np.sqrt(k2**2) + Pkd2*k2*s*(k2*(r*(28*C - 35) + s*(52*C - 28)) + (r*(24*C + 22) + 15*s)*np.sqrt(k2**2)))) + Dd*f*(2*Pk2*k2**6*(4*r**2 + r*(4*s - 5) + 3*s)*np.sqrt(k2**2) - 2*k1**4*(-2*Pk2 + Pkd2*k2)*(r*(C*(4*s + 3) - 34*s - 1) + s*(C*(4*s - 5) - 34*s + 18))*(k2**2)**(3/2) + k1**2*k2**4*(-2*Pk2*(r**2*(98*C - 122) + r*(C*(236*s - 75) - 260*s + 84) + s*(C*(138*s - 43) - 138*s + 46))*np.sqrt(k2**2) + Pkd2*k2*(k2*(7*r*(16*C*s - 2*C - 20*s + 3) + 2*s*(104*C*s - 33*C - 56*s + 21)) + (r*(12*C + 11)*(8*s - 1) + 2*s*(-6*C + 30*s - 13))*np.sqrt(k2**2))))) + 33*b1*f*(D1*fd*(Pk2*k2**6*(4*r**2 + 4*r*(s - 4) - 20*s + 7)*np.sqrt(k2**2) - 2*k1**6*(-4*Pk2*(s - 2)*(2*r + 2*s - 1)*np.sqrt(k2**2) + Pkd2*k2*(-k2*(2*s - 1)*(3*r - s + 2) + r*(8*s - 7)*np.sqrt(k2**2))) + k1**4*(Pk2*(C*(-12*r**2 + 398*r*s - 269*r + 410*s**2 - 595*s + 195) + 10*r**2 - 548*r*s + 325*r - 558*s**2 + 739*s - 224) + 2*Pkd2*k2*(-6*C*(6*r*(3*s - 2) + 18*s**2 - 23*s + 7) + 112*r*s - 65*r + 112*s**2 - 133*s + 37))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(-C*(354*r**2 + r*(756*s - 557) + 402*s**2 - 609*s + 178) + 354*r**2 + r*(396*s - 383) + 42*s**2 - 233*s + 83)*np.sqrt(k2**2) + 2*Pkd2*k2*(C*(2*k2*(4*s**2 - s*(12*r + 21) + 6) + 2*(4*r*(4*s - 3) + s)*np.sqrt(k2**2)) + 6*k2*(r*(7*s - 1) + s*(4*s - 1)) + 3*(r*(8*s - 7) + 14*s**2 - 18*s + 5)*np.sqrt(k2**2)))) + Dd*f*(2*Pk2*k2**6*(4*r**2 + r*(4*s - 9) - 13*s + 5)*np.sqrt(k2**2) + k1**6*(4*Pk2*(4*s - 9)*(2*r + 2*s - 1)*np.sqrt(k2**2) + Pkd2*k2*(2*k2*(4*s - 1)*(3*r - s + 2) + (-8*r*(4*s - 3) + 4*s - 5)*np.sqrt(k2**2))) + k1**4*(Pk2*(C*(-24*r**2 + 796*r*s - 519*r + 820*s**2 - 1171*s + 323) + 20*r**2 - 1096*r*s + 526*r - 1116*s**2 + 1354*s - 333) - 4*Pkd2*k2*(3*C*(36*r*s - 24*r + 36*s**2 - 46*s + 13) - 112*r*s + 60*r - 112*s**2 + 128*s - 33))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(-2*C*(354*r**2 + r*(756*s - 457) + 402*s**2 - 509*s + 147) + 708*r**2 + r*(792*s - 730) + 84*s**2 - 430*s + 191)*np.sqrt(k2**2) + Pkd2*k2*(k2*(4*C*(r*(3 - 24*s) + 8*s**2 - 23*s + 6) + (24*s - 6)*(7*r + 4*s - 1)) + (2*C*(32*r*(2*s - 1) - 12*s + 7) + 12*r*(8*s - 5) + 168*s**2 - 186*s + 45)*np.sqrt(k2**2))))) + f**2*(D1*fd*(66*Pk2*k2**6*(3*r**2 + 3*r*s + 4*s - 2)*np.sqrt(k2**2) - 5*k1**6*(-4*Pk2*(3*s - 23)*(3*r + 3*s - 2)*np.sqrt(k2**2) + Pkd2*k2*(-k2*(3*s - 1)*(33*r - 3*s + 23) + (6*r*(18*s - 17) - 3*s + 23)*np.sqrt(k2**2))) + k1**4*(Pk2*(C*(-2160*r**2 + 9*r*(881*s - 713) + 10089*s**2 - 17718*s + 6283) + 4572*r**2 - 54*r*(236*s - 43) - 17316*s**2 + 18828*s - 4218) - 5*Pkd2*k2*(12*C*(120*r*s - 95*r + 120*s**2 - 186*s + 67) - 1773*r*s + 987*r - 1773*s**2 + 2235*s - 680))*(k2**2)**(3/2) + 3*k1**2*k2**4*(Pk2*(-2*C*(1857*r**2 + 3*r*(1675*s - 608) + 3168*s**2 - 2093*s + 189) + 5547*r**2 + 6*r*(1291*s - 933) + 2199*s**2 - 2926*s + 1120)*np.sqrt(k2**2) + 55*Pkd2*k2*(k2*(2*s - 1)*(4*C*(3*s - 1) + 3*r - 1) + (2*C*(r*(12*s - 5) - 2*s + 1) + (2*s - 1)*(9*r + 12*s - 7))*np.sqrt(k2**2)))) + Dd*f*(132*Pk2*k2**6*(r + 1)*(2*r + 2*s - 1)*np.sqrt(k2**2) - 5*k1**6*(-4*Pk2*(r*(12*s - 97) + 12*s**2 - 93*s + 46)*np.sqrt(k2**2) + Pkd2*k2*(-k2*(4*s - 1)*(33*r - 3*s + 23) + (2*r*(72*s - 65) + 2*s + 23)*np.sqrt(k2**2))) + k1**4*(Pk2*(C*(-2880*r**2 + 10572*r*s - 8955*r + 13452*s**2 - 21463*s + 6283) + 6096*r**2 - 16992*r*s + 3050*r - 23088*s**2 + 22318*s - 4218) - 10*Pkd2*k2*(3*C*(320*r*s - 251*r + 320*s**2 - 445*s + 134) - 1182*r*s + 628*r - 1182*s**2 + 1323*s - 340))*(k2**2)**(3/2) + 3*k1**2*k2**4*(-2*Pk2*(C*(2476*r**2 + 6700*r*s - 1787*r + 4224*s**2 - 2319*s + 189) - 3698*r**2 + r*(3095 - 5164*s) - 1466*s**2 + 1727*s - 560)*np.sqrt(k2**2) + 55*Pkd2*k2*(k2*(2*s - 1)*(4*C*(4*s - 1) + 4*r - 1) + (2*C*(16*r*s - 6*r - 2*s + 1) + 24*r*s - 11*r + 32*s**2 - 31*s + 7)*np.sqrt(k2**2))))))/(693*d**2*k1**2*k3**4*(k2**2)**(3/2)) + 10*D1**3*Pk1*ct**3*f**2*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(182*b1*(3*s - 1)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(182*D1*bd1*s*(3*s - 1) + D1*fd*(1772*s**2 - 1003*s + 140) + Dd*f*(1772*s**2 - 1003*s + 140)))/(3003*d**2*k1*k2) + 8*D1**3*Pk1*ct**3*f*st**4*(-66*b1*k2*(C - 1)*(D1*fd*(4*Pk2*k2**2*r*(2*r + 2*s - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1)) + Dd*f*(8*Pk2*k2**2*r*(2*r + 2*s - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 9*s + 1))) + f*(2*D1*(-66*bd1*k2*(C - 1)*(4*Pk2*k1**2*s*(2*r + 2*s - 1) + 2*Pk2*k2**2*r*(r + s - 1) + Pkd2*k1**2*k2*s*(-2*r - 2*s + 1)) + fd*(Pk2*k2**3*(C*(279*r**2 - 252*r + 53) - 279*r**2 - 27*r*(5*s - 11) - 135*s**2 + 135*s - 83) + Pk2*(C*(3*r - 1)*(93*s - 20) + 3*r*(42*s - 25) + 405*s**2 - 312*s + 70)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2*(30*C - 45)*(-4*Pk2 + Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2))) + Dd*f*(Pk2*k2**3*(2*C*(372*r**2 - 305*r + 53) - 744*r**2 + r*(715 - 360*s) - 360*s**2 + 315*s - 166) + Pk2*(2*C*(r*(372*s - 70) - 103*s + 20) + 7*r*(48*s - 25) + 1080*s**2 - 739*s + 140)*(k2**2)**(3/2) - 15*Pkd2*k2**4*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + k1**2*k2*(30*C - 45)*(-4*Pk2 + Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 21*s + 4))))/(231*d**2*k1*k3**4) - 4*D1**3*Pk1*ct**3*f*st**4*(D1*(66*b1*fd*(C - 1)*(2*s - 1)*(24*Pk2*k1**2*s - 9*Pkd2*k1**2*k2*s - 4*Pkd2*k2**3*r + k2**2*(16*Pk2*r + Pkdd2*k1**2*s)) + f*(66*bd1*s*(C - 1)*(24*Pk2*k1**2*s - 9*Pkd2*k1**2*k2*s - 4*Pkd2*k2**3*r + k2**2*(16*Pk2*r + Pkdd2*k1**2*s)) + fd*(k1**2*(1 - 3*s)**2*(20*C - 35)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k2**2*(-8*Pk2*(C*(3*r - 1)*(93*s - 20) - 279*r*s + 60*r + 135*s**2 + 3*s - 5) + k2*(Pkd2*(2*C*(3*r - 1)*(93*s - 20) - 558*r*s + 120*r + 675*s**2 - 264*s + 35) - 15*Pkdd2*(1 - 3*s)**2*np.sqrt(k2**2)))))) + Dd*f*(66*b1*(C - 1)*(4*s - 1)*(24*Pk2*k1**2*s - 9*Pkd2*k1**2*k2*s - 4*Pkd2*k2**3*r + k2**2*(16*Pk2*r + Pkdd2*k1**2*s)) + f*(k1**2*(20*C - 35)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + k2**2*(-8*Pk2*(C*(372*r*s - 70*r - 103*s + 20) - 372*r*s + 70*r + 180*s**2 - 2*s - 5) + k2*(Pkd2*(2*C*(372*r*s - 70*r - 103*s + 20) - 744*r*s + 140*r + 900*s**2 - 319*s + 35) - 15*Pkdd2*(12*s**2 - 7*s + 1)*np.sqrt(k2**2))))))/(231*d**2*k1*k2*k3**2) + 4*D1**3*Pk1*ct**3*st**2*(33*D1*bd1*f*(-2*b1*(2*Pk2*k1**2*(r*(C*(78*s - 23) - 90*s + 26) + s*(C*(78*s - 55) - 90*s + 64))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(4*C - 4) + r*(4*C*(7*s - 4) - 16*s + 13) + 3*s*(4*s - 3))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(C*(23 - 78*s) + 90*s - 26) + s*(C*(55 - 78*s) + 90*s - 64))*np.sqrt(k2**2) - 3*k2**5*(Pk2*(r*(2*C - 1)*(4*s - 1) + s*(-2*C + 4*s - 1)) + Pkd2*(-4*r*s + r + s*(3 - 4*s))*np.sqrt(k2**2))) + f*(2*k1**4*(Pk2*(C*(3*r*(4*s - 1) - 28*s**2 + 15*s + 3) - 4*r*(9*s - 3) + 124*s**2 - 60*s - 12)*np.sqrt(k2**2) + k2*(-Pk2*(5*C - 20)*(r*(8*s - 3) - 5*s + 3) + Pkd2*(C*(7*s - 3)*(r + s - 1) + r*(12 - 31*s) - 31*s**2 + 40*s - 12)*np.sqrt(k2**2))) - k1**2*(Pk2*(-4*C*(45*r**2 + 242*r*s - 99*r + 197*s**2 - 202*s + 61) + 297*r**2 + 735*r*s - 401*r + 438*s**2 - 404*s + 144) + Pkd2*k2*(2*C*(95*r*s - 28*r + 95*s**2 - 109*s + 35) + 44*r*s - 25*r + 44*s**2 - 55*s + 5))*(k2**2)**(3/2) + k2**4*(Pk2*(-4*C*(10*r**2 + 20*r*s - 18*r - 6*s + 3) + 40*r**2 + 92*r*s - 99*r + 6*s**2 - 87*s + 45)*np.sqrt(k2**2) + k2*(-Pk2*(33*r**2 + r*(-40*C*s + 12*C + 203*s - 92) + 124*s**2 - 151*s + 53) + 3*Pkd2*(2*r*s + r + 2*s**2 - s + 1)*np.sqrt(k2**2))))) - 66*b1**2*(D1*fd*(Pk2*k1**2*s*(78*C - 90)*(r + s)*(k2**2)**(3/2) + 2*Pk2*k2**4*(r**2*(C - 1) + r*s*(7*C - 4) + 3*s**2)*np.sqrt(k2**2) - Pkd2*k1**2*k2**3*s*(39*C - 45)*(r + s)*np.sqrt(k2**2) + 6*k2**5*s*(Pk2*(-2*C*r + r - s) + Pkd2*(r + s)*np.sqrt(k2**2))) + Dd*f*(2*Pk2*k1**2*(r*(C*(156*s - 23) - 180*s + 26) + s*(C*(156*s - 55) - 180*s + 64))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(8*C - 8) + r*(8*C*(7*s - 2) - 32*s + 13) + 3*s*(8*s - 3))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(C*(23 - 156*s) + 180*s - 26) + s*(C*(55 - 156*s) + 180*s - 64))*np.sqrt(k2**2) - 3*k2**5*(Pk2*(r*(2*C - 1)*(8*s - 1) + s*(-2*C + 8*s - 1)) + Pkd2*(-8*r*s + r + s*(3 - 8*s))*np.sqrt(k2**2)))) + 33*b1*f*(D1*fd*(Pk2*k1**2*(2*k1**2*(C*(24*r*s - 13*r - 56*s**2 + 68*s - 20) - 72*r*s + 40*r + 248*s**2 - 284*s + 80) + k2**2*(8*C*(45*r**2 + 242*r*s - 142*r + 197*s**2 - 218*s + 59) - 594*r**2 - 1470*r*s + 920*r - 876*s**2 + 1014*s - 279))*np.sqrt(k2**2) + Pk2*k2**4*(4*C*(-20*r**2 + r*(2 - 40*s) + s + 4) + 80*r**2 + 2*r*(92*s - 19) + 12*s**2 - 37*s - 4)*np.sqrt(k2**2) - Pkd2*k1**2*k2**3*(2*C*(r*(190*s - 129) + 190*s**2 - 236*s + 69) + 8*r*(11*s + 3) + 88*s**2 - 11*s - 12)*np.sqrt(k2**2) + 2*k1**4*k2*(Pk2*r*(20 - 5*C)*(16*s - 9) + Pkd2*(C*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + r*(35 - 62*s) - 62*s**2 + 71*s - 20)*np.sqrt(k2**2)) + k2**5*(-Pk2*(28*C*s + 66*r**2 - 2*r*(40*C*s - 203*s + 96) + 248*s**2 - 297*s + 71) + 3*Pkd2*(4*r*(s - 2) + 4*s**2 - 11*s + 4)*np.sqrt(k2**2))) + Dd*f*(2*k1**4*(Pk2*(C*(r*(48*s - 19) - 112*s**2 + 103*s - 17) - 16*r*(9*s - 4) + 496*s**2 - 424*s + 68)*np.sqrt(k2**2) + k2*(Pk2*(20 - 5*C)*(r*(32*s - 15) - 5*s + 3) + Pkd2*(2*C*(14*r*s - 7*r + 14*s**2 - 16*s + 4) + r*(59 - 124*s) - 124*s**2 + 131*s - 32)*np.sqrt(k2**2))) - k1**2*(Pk2*(-4*C*(180*r**2 + 968*r*s - 448*r + 788*s**2 - 752*s + 179) + 1188*r**2 + 2940*r*s - 1487*r + 1752*s**2 - 1675*s + 423) + Pkd2*k2*(4*C*(190*r*s - 98*r + 190*s**2 - 205*s + 52) + 176*r*s + 5*r + 176*s**2 - 65*s - 7))*(k2**2)**(3/2) + k2**4*(-4*Pk2*k2*(7*C*s + 33*r**2 + r*(-40*C*s + 3*C + 203*s - 85) + 124*s**2 - 129*s + 31) + Pk2*(-4*C*(40*r**2 + 80*r*s - 19*r - 7*s - 1) + 160*r**2 + 368*r*s - 169*r + 24*s**2 - 133*s + 41)*np.sqrt(k2**2) + 3*Pkd2*k2*(r*(8*s - 9) + 8*s**2 - 15*s + 5)*np.sqrt(k2**2)))) + f**2*(D1*fd*(3*k1**4*(Pk2*(2*C*(318*r*s - 128*r - 612*s**2 + 643*s - 139) - 1752*r*s + 793*r + 5688*s**2 - 5342*s + 1079)*np.sqrt(k2**2) + k2*(-5*Pk2*(2*C*(186*r*s - 84*r - 29*s + 17) - 1488*r*s + 705*r + 298*s - 169) + Pkd2*(2*C*(153*r*s - 73*r + 153*s**2 - 197*s + 56) - 1422*r*s + 683*r - 1422*s**2 + 1708*s - 481)*np.sqrt(k2**2))) + k1**2*(Pk2*(24*C*(363*r**2 + 2808*r*s - 1409*r + 2445*s**2 - 2731*s + 756) - 14229*r**2 - 50571*r*s + 26145*r - 36342*s**2 + 38676*s - 10369) - 3*Pkd2*k2*(8*C*(795*r*s - 364*r + 795*s**2 - 883*s + 239) - 1260*r*s + 585*r - 1260*s**2 + 1326*s - 357))*(k2**2)**(3/2) + k2**4*(2*Pk2*(C*(-2088*r**2 - 3564*r*s + 666*r + 396*s + 274) + 3564*r**2 + 7425*r*s - 4455*r + 1188*s**2 - 2574*s + 990)*np.sqrt(k2**2) + k2*(Pk2*(4*C*(738*r*s - 213*r - 642*s + 203) - 1197*r**2 - 17181*r*s + 6921*r - 10638*s**2 + 11466*s - 2905) + 198*Pkd2*(r*(12*s - 5) + 3*(1 - 2*s)**2)*np.sqrt(k2**2)))) + Dd*f*(3*k1**4*(Pk2*(2*C*(424*r*s - 153*r - 816*s**2 + 807*s - 139) - 2336*r*s + 993*r + 7584*s**2 - 6621*s + 1079)*np.sqrt(k2**2) + k2*(-5*Pk2*(C*(496*r*s - 218*r - 42*s + 34) - 1984*r*s + 905*r + 267*s - 169) + Pkd2*(4*C*(102*r*s - 49*r + 102*s**2 - 114*s + 28) - 1896*r*s + 883*r - 1896*s**2 + 1989*s - 481)*np.sqrt(k2**2))) + k1**2*(-6*C*Pkd2*k2*(5*r*(848*s - 361) + 4240*s**2 - 4139*s + 956) + Pk2*(96*C*(121*r**2 + 104*r*(9*s - 4) + 815*s**2 - 808*s + 189) - 18972*r**2 - 67428*r*s + 29419*r - 48456*s**2 + 45771*s - 10369) + 9*Pkd2*k2*(r*(560*s - 233) + 560*s**2 - 523*s + 119))*(k2**2)**(3/2) + k2**4*(2*Pk2*(C*(-2784*r**2 - 4752*r*s + 392*r + 396*s + 274) + 4752*r**2 + 9900*r*s - 5247*r + 1584*s**2 - 2772*s + 990)*np.sqrt(k2**2) + k2*(Pk2*(4*C*(984*r*s - 166*r - 892*s + 203) - 1596*r**2 - 22908*r*s + 8245*r - 14184*s**2 + 13047*s - 2905) + 198*Pkd2*(8*s - 3)*(2*r + 2*s - 1)*np.sqrt(k2**2))))))/(693*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 4*D1**3*Pk1*ct**3*(33*D1*bd1*f*(b1*(-2*k1**4*(Pk2*(r*(C*(8*s - 2) - 6*s + 5) + 2*s*(C*(3 - 8*s) + 6*s - 4))*np.sqrt(k2**2) + k2*(Pk2*(3*r*(C*(2 - 8*s) + 6*s - 5) + s*(6*C + 6)) + Pkd2*(r*(8*C*s - 2*C - 6*s + 5) + s*(8*C*s - 6*C - 6*s + 1))*np.sqrt(k2**2))) - 2*k1**2*(Pk2*(23*r**2 + r*(-120*C*s + 44*C + 202*s - 83) + s*(-120*C*s + 76*C + 179*s - 119)) + 2*Pkd2*k2*(r*(72*C*s - 11*C - 55*s + 12) + s*(72*C*s - 61*C - 55*s + 43)))*(k2**2)**(3/2) + k2**4*(-7*Pk2*(r**2*(16*C - 16) + r*(16*C*(s - 1) - 34*s + 15) + s*(14 - 8*s))*np.sqrt(k2**2) + k2*(Pk2*(-38*r**2 + r*(51 - 170*s) + s*(84 - 62*s)) + 14*Pkd2*(r*(4*s - 1) + s*(4*s - 3))*np.sqrt(k2**2)))) + f*(k1**4*(Pk2*(-4*C*(r*(43*s - 19) - 13*s**2 + 6*s + 18) + 26*r**2 + r*(277*s - 182) - 181*s**2 + 49*s + 146)*np.sqrt(k2**2) + 2*k2*(Pk2*(2*C*(56*r*s - 43*r - 35*s + 40) - 216*r*s + 148*r + 142*s - 133) + Pkd2*(C*(-24*r*s + 26*r - 24*s**2 + 50*s - 24) + 56*r*s - 40*r + 56*s**2 - 91*s + 35)*np.sqrt(k2**2))) + 2*k1**2*(Pk2*(-2*C*(83*r**2 + 224*r*s - 127*r + 141*s**2 - 159*s + 62) + 295*r**2 + 490*r*s - 417*r + 195*s**2 - 293*s + 171) + 3*Pkd2*k2*(2*C*(8*r*s - 4*r + 8*s**2 - 13*s + 7) + 28*r*s - 14*r + 28*s**2 - 35*s + 7))*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(52 - 28*C) + r*(-52*C*s + 12*C + 239*s - 49) + s*(24*s - 24))*np.sqrt(k2**2) + k2*(Pk2*(8*C*(3*r*s - 4*r - 5*s + 5) + 84*r**2 + 12*r*s - 131*r + 91*s**2 - 103*s + 62) + 12*Pkd2*(r*(2*s - 1) + s*(2*s - 2))*np.sqrt(k2**2))))) + 33*b1**2*(D1*fd*(Pk2*k1**2*(k1**2*s*(6 - 8*C)*(r - 2*s) - k2**2*(r + s)*(23*r + s*(179 - 120*C)))*np.sqrt(k2**2) - 7*Pk2*k2**4*(r**2*(8*C - 8) + r*s*(8*C - 17) - 4*s**2)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*s*(110 - 144*C)*(r + s)*np.sqrt(k2**2) - k1**4*k2*s*(8*C - 6)*(-3*Pk2*r + Pkd2*(r + s)*np.sqrt(k2**2)) + k2**5*(-Pk2*(19*r**2 + 85*r*s + 31*s**2) + 28*Pkd2*s*(r + s)*np.sqrt(k2**2))) + Dd*f*(-2*k1**4*(Pk2*(r*(2*C*(8*s - 1) - 12*s + 5) + 2*s*(C*(3 - 16*s) + 12*s - 4))*np.sqrt(k2**2) + k2*(Pk2*(r*(-48*C*s + 6*C + 36*s - 15) + s*(6*C + 6)) + Pkd2*(r*(16*C*s - 2*C - 12*s + 5) + s*(16*C*s - 6*C - 12*s + 1))*np.sqrt(k2**2))) - 2*k1**2*(Pk2*(46*r**2 + r*(-240*C*s + 44*C + 404*s - 83) + s*(-240*C*s + 76*C + 358*s - 119)) + 2*Pkd2*k2*(r*(144*C*s - 11*C - 110*s + 12) + s*(144*C*s - 61*C - 110*s + 43)))*(k2**2)**(3/2) + k2**4*(-7*Pk2*(r**2*(32*C - 32) + r*(32*C*s - 16*C - 68*s + 15) + s*(14 - 16*s))*np.sqrt(k2**2) + k2*(Pk2*(-76*r**2 + r*(51 - 340*s) + s*(84 - 124*s)) + 14*Pkd2*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2))))) + 33*b1*f*(D1*fd*(Pk2*k1**2*(k1**2*(4*C*(r*(57 - 86*s) + 26*s**2 - 31*s + 15) + 52*r**2 + 554*r*s - 373*r - 362*s**2 + 399*s - 151) - 2*k2**2*(4*C*(83*r**2 + 8*r*(28*s - 19) + 141*s**2 - 208*s + 62) - 590*r**2 - 980*r*s + 729*r - 390*s**2 + 681*s - 209))*np.sqrt(k2**2) - 2*Pk2*k2**4*(2*C*(14*r**2 + r*(26*s + 11) - s - 9) - 52*r**2 + r*(87 - 239*s) + s*(34 - 24*s))*np.sqrt(k2**2) + 12*Pkd2*k1**2*k2**3*(2*C*(r*(8*s - 9) + 8*s**2 - 16*s + 5) + 7*r*(4*s - 1) + 28*s**2 - 19*s + 4)*np.sqrt(k2**2) - 2*k1**4*k2*(Pk2*(r*(-224*C*s + 172*C + 432*s - 283) + s*(24*C - 42)) + 2*Pkd2*(2*C*(6*s - 5)*(2*r + 2*s - 1) - 56*r*s + 33*r - 56*s**2 + 64*s - 18)*np.sqrt(k2**2)) + k2**5*(Pk2*(168*r**2 + r*(s*(48*C + 24) - 157) + 182*s**2 - s*(72*C + 273) + 97) + 12*Pkd2*s*(4*r + 4*s - 1)*np.sqrt(k2**2))) + Dd*f*(k1**4*(Pk2*(-4*C*(r*(172*s - 93) - 52*s**2 + 51*s + 3) + 104*r**2 + r*(1108*s - 691) - 724*s**2 + 589*s - 5)*np.sqrt(k2**2) + 2*k2*(Pk2*(4*C*(r*(112*s - 83) - 25*s + 20) - 9*r*(96*s - 61) + 199*s - 133) + Pkd2*(-4*C*(12*s - 11)*(2*r + 2*s - 1) + 8*r*(28*s - 17) + 224*s**2 - 260*s + 71)*np.sqrt(k2**2))) + 2*k1**2*(-2*Pk2*(2*C*(166*r**2 + 448*r*s - 242*r + 282*s**2 - 354*s + 93) - 590*r**2 - 980*r*s + 649*r - 390*s**2 + 601*s - 190) + 3*Pkd2*k2*(2*C*(4*r*(8*s - 7) + 32*s**2 - 56*s + 17) + 112*r*s - 34*r + 112*s**2 - 82*s + 15))*(k2**2)**(3/2) + k2**4*(Pk2*(-4*C*(28*r**2 + r*(52*s + 17) - s - 9) + 208*r**2 + r*(956*s - 223) + 4*s*(24*s - 23))*np.sqrt(k2**2) + k2*(Pk2*(8*C*(4*r*(3*s - 1) - 19*s + 5) + 336*r**2 + 48*r*(s - 7) + 364*s**2 - 487*s + 159) + 12*Pkd2*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2))))) + f**2*(D1*fd*(33*Pk2*k2**4*(k2*(4*C*(3*r - 1)*(2*s - 1) + 177*r**2 + 3*r*(43*s - 37) + 258*s**2 - 224*s + 49) + 2*r*(12*C*r - 4*C + 153*s - 51)*np.sqrt(k2**2)) + k1**4*(-3*Pk2*(4*C*(2*r*(519*s - 338) + 105*s**2 + 277*s + 6) - 1350*r**2 + r*(6037 - 7029*s) + 1893*s**2 - 3374*s - 167)*np.sqrt(k2**2) + 2*k2*(Pk2*(2*C*(2799*r*s - 3243*r - 207*s + 839) - 11358*r*s + 10419*r + 684*s - 2439) - 5*Pkd2*(8*C*(9*s - 14)*(3*r + 3*s - 2) - 693*r*s + 528*r - 693*s**2 + 1023*s - 363)*np.sqrt(k2**2))) + 3*k1**2*(Pk2*(-4*C*(537*r**2 + r*(3870*s - 1021) + 3333*s**2 - 2621*s + 354) + 11541*r**2 + 6*r*(3927*s - 2353) + 12021*s**2 - 12942*s + 3784) + 110*Pkd2*k2*(8*C*(2*s - 1)*(3*r + 3*s - 2) + 5*r*(3*s - 2) + 15*s**2 - 21*s + 7))*(k2**2)**(3/2)) + Dd*f*(33*Pk2*k2**4*(k2*(4*C*(4*r - 1)*(2*s - 1) + 236*r**2 + 172*r*s - 117*r + 344*s**2 - 267*s + 49) + 2*r*(16*C*r - 4*C + 204*s - 51)*np.sqrt(k2**2)) - k1**4*(Pk2*(4*C*(4152*r*s - 2498*r + 420*s**2 + 1283*s + 18) - 5400*r**2 - 28116*r*s + 22763*r + 7572*s**2 - 14273*s - 501)*np.sqrt(k2**2) + 2*k2*(Pk2*(C*(-7464*r*s + 8546*r + 32*s - 1678) + 15144*r*s - 13734*r + 192*s + 2439) + 5*Pkd2*(C*(r*(288*s - 458) + 288*s**2 - 582*s + 224) - 231*r*(4*s - 3) - 924*s**2 + 1221*s - 363)*np.sqrt(k2**2))) + 6*k1**2*(Pk2*(-4*C*(358*r**2 + 2580*r*s - 459*r + 2222*s**2 - 1539*s + 177) + 7694*r**2 + 15708*r*s - 7713*r + 8014*s**2 - 7709*s + 1892) + 55*Pkd2*k2*(2*C*(32*r*s - 15*r + 32*s**2 - 33*s + 8) + 20*r*s - 13*r + 20*s**2 - 25*s + 7))*(k2**2)**(3/2))))/(693*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct**3*st**2*(429*b1**2*k1**2*(D1*fd*(-9*Pkd2*k1**2*k2*(f*(34*s**2 - 37*s + 10) + 6*(s - 1)**2)*np.sqrt(k2**2) + Pkdd2*k2**4*(f*(68*s**2 - 37*s + 10) + 6*(s - 1)**2)*np.sqrt(k2**2) + k2**3*(30*Pk2*(s - 1)*(r*(2*K - 2) + 3*s - 3) - Pkd2*(5*f*(68*s**2 - 37*s + 10) + (s - 1)*(-2*r*(K - 1) + 30*s - 30))*np.sqrt(k2**2)) + (2*Pk2*k2**2*(4*f*(68*s**2 - 37*s + 10) - (s - 1)*(r*(34*K - 34) + 21*s - 21)) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(f*(34*s**2 - 37*s + 10) + 6*(s - 1)**2))*np.sqrt(k2**2)) + Dd*f*(-9*Pkd2*k1**2*k2*(4*s - 1)*(17*f*s - 10*f + 6*s - 6)*np.sqrt(k2**2) + 2*Pkdd2*k2**4*(4*s - 1)*(17*f*s - 5*f + 3*s - 3)*np.sqrt(k2**2) + 2*k2**3*(15*Pk2*(K*r*(8*s - 5) - K*s + K - 8*r*s + 5*r + 12*s**2 - 14*s + 2) - Pkd2*(-K*(4*r*s + 8*r + 3*s - 3) + 5*f*(68*s**2 - 37*s + 5) + 4*r*s + 8*r + 60*s**2 - 72*s + 12)*np.sqrt(k2**2)) + (2*Pk2*k2**2*(K*(-136*r*s + 43*r + 3*s - 3) + 8*f*(68*s**2 - 37*s + 5) + 136*r*s - 43*r - 84*s**2 + 102*s - 18) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(4*s - 1)*(17*f*s - 10*f + 6*s - 6))*np.sqrt(k2**2))) + 13*b1*(33*D1*bd1*f*k1**2*(-18*Pkd2*k1**2*k2*s*(17*f*s - 10*f + 6*s - 6)*np.sqrt(k2**2) + Pkdd2*k2**4*s*(f*(68*s - 37) + 12*s - 12)*np.sqrt(k2**2) + k2**3*(30*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 6*s**2 - 5*s - 1) + Pkd2*(4*K*r*(s + 3) + 6*K*(s - 1) - 340*f*s**2 + 185*f*s - 4*r*(s + 3) - 60*s**2 + 54*s + 6)*np.sqrt(k2**2)) - 2*(-24*Pk2*k1**2*s*(17*f*s - 10*f + 6*s - 6) + k2**2*(Pk2*(K*(68*r*s - 6*r - 3*s + 3) - 272*f*s**2 + 148*f*s - 68*r*s + 6*r + 42*s**2 - 39*s - 3) + Pkdd2*k1**2*s*(f*(10 - 17*s) - 6*s + 6)))*np.sqrt(k2**2)) + D1*(f**2*fd*(2160*Pk2*k2**4*r**2*np.sqrt(k2**2) + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1359*s**2 - 1203*s + 250)*np.sqrt(k2**2) + k1**2*(-2*Pk2*(9*r*(246*s - 71) + 28728*s**2 - 24078*s + 4219)*(k2**2)**(3/2) + Pkdd2*k2**4*(243*s**2 + 612*s - 80)*np.sqrt(k2**2) + k2**3*(8*Pk2*(18*r*(129*s - 32) - 753*s + 229) + 9*Pkd2*(r*(76 - 360*s) + 1515*s**2 - 1378*s + 212)*np.sqrt(k2**2)))) + 33*f*k1**2*(fd*(-27*Pkd2*k1**2*k2*(6*s**2 - 7*s + 2)*np.sqrt(k2**2) + 3*Pkdd2*k2**4*(6*s**2 - 7*s + 2)*np.sqrt(k2**2) + k2**3*(5*Pk2*(2*K*(r*(20*s - 9) - 7*s + 3) + r*(18 - 40*s) + 54*s**2 - 49*s + 12) + Pkd2*(-2*K*(2*r*(9*s - 4) - 7*s + 3) + 4*r*(9*s - 4) - 90*s**2 + 91*s - 24)*np.sqrt(k2**2)) + (2*s - 1)*(Pk2*k2**2*(K*(8 - 30*r) + 30*r - 63*s + 34) + 3*k1**2*(24*Pk2 + Pkdd2*k2**2)*(3*s - 2))*np.sqrt(k2**2)) - 4*gd2*r*(Pk2*(3 - 34*s)*(k2**2)**(3/2) + k2**3*(15*Pk2*(2*s - 1) + Pkd2*(s + 3)*np.sqrt(k2**2)))) - 132*fd*g2*k1**2*r*(s - 1)*(-34*Pk2*(k2**2)**(3/2) + k2**3*(30*Pk2 + Pkd2*np.sqrt(k2**2)))) + Dd*f*(f**2*(720*Pk2*k2**4*r*(4*r - 1)*np.sqrt(k2**2) + 2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1812*s**2 - 1453*s + 250)*np.sqrt(k2**2) + k1**2*(-6*Pk2*(2*r*(492*s - 83) + 12768*s**2 - 8772*s + 1375)*(k2**2)**(3/2) + Pkdd2*k2**4*(324*s**2 + 239*s - 80)*np.sqrt(k2**2) + k2**3*(4*Pk2*(6192*r*s - 651*r - 1393*s + 124) + Pkd2*(-4320*r*s + 204*r + 18180*s**2 - 12581*s + 2228)*np.sqrt(k2**2)))) + 33*f*k1**2*(-27*Pkd2*k1**2*k2*(12*s**2 - 11*s + 2)*np.sqrt(k2**2) + 3*Pkdd2*k2**4*(12*s**2 - 11*s + 2)*np.sqrt(k2**2) + k2**3*(5*Pk2*(2*K*(5*r*(8*s - 3) - 7*s + 3) - 80*r*s + 30*r + 108*s**2 - 85*s + 12) + Pkd2*(K*(-72*r*s + 28*r + 14*s - 6) + 72*r*s - 28*r - 180*s**2 + 151*s - 24)*np.sqrt(k2**2)) + (Pk2*k2**2*(-2*K*(60*r*s - 23*r - 8*s + 4) + 120*r*s - 46*r - 252*s**2 + 215*s - 34) + 3*k1**2*(24*Pk2 + Pkdd2*k2**2)*(12*s**2 - 11*s + 2))*np.sqrt(k2**2)) - 132*g2*k1**2*(Pk2*(-136*r*s + 43*r + 3*s - 3)*(k2**2)**(3/2) + k2**3*(15*Pk2*(8*r*s - 5*r - s + 1) + Pkd2*(4*r*s + 8*r + 3*s - 3)*np.sqrt(k2**2))))) - f*(-13*D1*bd1*(f**2*(720*Pk2*k2**4*r*(r - 1)*np.sqrt(k2**2) + 2*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(453*s - 250)*np.sqrt(k2**2) + k1**2*(-2*Pk2*(3*r*(246*s + 47) + 9576*s**2 - 2238*s - 94)*(k2**2)**(3/2) + Pkdd2*k2**4*s*(81*s - 373)*np.sqrt(k2**2) + k2**3*(4*Pk2*(3*r*(516*s + 167) + 113*s - 334) + Pkd2*(-120*r*(9*s + 4) + 4545*s**2 - 179*s + 320)*np.sqrt(k2**2)))) + 33*f*k1**2*(27*Pkd2*k1**2*k2*s*(2 - 3*s)*np.sqrt(k2**2) + 3*Pkdd2*k2**4*s*(3*s - 2)*np.sqrt(k2**2) + k2**3*(5*Pk2*(r*(2*K - 2)*(10*s - 3) + 9*s*(3*s - 2)) + 3*Pkd2*(-r*(2*K - 2)*(3*s - 1) + s*(10 - 15*s))*np.sqrt(k2**2)) + (72*Pk2*k1**2*s*(3*s - 2) + k2**2*(-Pk2*r*(2*K - 2)*(15*s - 4) + 21*Pk2*s*(2 - 3*s) + 3*Pkdd2*k1**2*s*(3*s - 2)))*np.sqrt(k2**2)) - 132*g2*k1**2*(Pk2*(-34*r*s + 3*r + 3*s - 3)*(k2**2)**(3/2) + k2**3*(15*Pk2*(2*r*s - r - s + 1) + Pkd2*(r*s + 3*r + 3*s - 3)*np.sqrt(k2**2)))) + D1*f**2*fd*(-60*Pk2*k2**4*(444*r**2 + 25*r - 34)*np.sqrt(k2**2) - 25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(788*s**2 - 589*s + 98)*np.sqrt(k2**2) + k1**2*(16*Pk2*(r*(4308*s - 843) + 64480*s**2 - 41286*s + 6233)*(k2**2)**(3/2) + 1625*Pkdd2*k2**4*(20*s**2 - 13*s + 2)*np.sqrt(k2**2) + k2**3*(-8*Pk2*(6*r*(4944*s - 287) - 10666*s + 1243) + Pkd2*(16*r*(2072*s + 275) - 355420*s**2 + 209423*s - 33314)*np.sqrt(k2**2)))) - 1716*D1*f*gd2*k1**2*r*(Pk2*(15*s - 4)*(k2**2)**(3/2) + k2**3*(Pk2*(15 - 50*s) + 3*Pkd2*(3*s - 1)*np.sqrt(k2**2))) - 1716*D1*fd*g2*k1**2*(Pk2*(15*r - 4)*(2*s - 1)*(k2**2)**(3/2) + k2**3*(-5*Pk2*(r*(20*s - 9) - 7*s + 3) + Pkd2*(2*r*(9*s - 4) - 7*s + 3)*np.sqrt(k2**2))) + Dd*f**3*(-60*Pk2*k2**4*(444*r**2 + 25*r - 34)*np.sqrt(k2**2) - 25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(788*s**2 - 589*s + 98)*np.sqrt(k2**2) + k1**2*(16*Pk2*(r*(4308*s - 843) + 64480*s**2 - 41286*s + 6233)*(k2**2)**(3/2) + 1625*Pkdd2*k2**4*(20*s**2 - 13*s + 2)*np.sqrt(k2**2) + k2**3*(-8*Pk2*(6*r*(4944*s - 287) - 10666*s + 1243) + Pkd2*(16*r*(2072*s + 275) - 355420*s**2 + 209423*s - 33314)*np.sqrt(k2**2)))) - 1716*Dd*f*g2*k1**2*(Pk2*(r*(60*s - 23) - 8*s + 4)*(k2**2)**(3/2) + k2**3*(-5*Pk2*(5*r*(8*s - 3) - 7*s + 3) + Pkd2*(2*r*(18*s - 7) - 7*s + 3)*np.sqrt(k2**2)))))/(9009*d**2*k1**3*k2**3*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct**3*(2145*b1**3*k1**2*s*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1))*np.sqrt(k2**2) - 429*b1**2*(D1*(-5*bd1*f*k1**2*s*(3*s - 1)*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*np.sqrt(k2**2) + fd*(Pk2*k2**4*r**2*(8*f + 36)*np.sqrt(k2**2) + k1**4*(4*Pk2*(2*f*(94*s**2 - 121*s + 35) + 91*s**2 - 174*s + 87) + k2*(-Pkd2*(2*f*(136*s**2 - 184*s + 53) + 139*s**2 - 258*s + 129) + 2*Pkdd2*k2*(f*(14*s**2 - 21*s + 6) + 8*s**2 - 14*s + 7)))*np.sqrt(k2**2) + k1**2*(Pk2*(6*K*s + 4*f*(3*r*(8*s - 1) + 132*s**2 - 88*s + 23) + r*(2*K - 2)*(74*s - 77) - 107*s**2 + 196*s - 101)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*(f*(34*s**2 - 21*s + 6) + 8*s**2 - 14*s + 7)*np.sqrt(k2**2) + k2**3*(Pk2*(f*r*(24 - 240*s) + r*(2*K - 2)*(13*s - 4) + 225*s**2 + s*(-18*K + 102*f - 420) + 219) + Pkd2*(6*K*s + 2*f*(r*(40*s - 4) - 166*s**2 + 83*s - 29) - r*(2*K - 2)*(17*s - 14) - 75*s**2 + 140*s - 73)*np.sqrt(k2**2))))) + Dd*f*(Pk2*k2**4*r*(4*f + 36)*(4*r - 1)*np.sqrt(k2**2) + k1**4*(4*s - 1)*(4*Pk2*(f*(94*s - 70) + 91*s - 87) + k2*(Pkd2*(-136*f*s + 106*f - 139*s + 129) + 2*Pkdd2*k2*(7*f*s - 6*f + 8*s - 7)))*np.sqrt(k2**2) + k1**2*(Pk2*(2*K*(296*r*s - 65*r + 39*s - 12) + 2*f*(4*r*(24*s - 7) + 528*s**2 - 348*s + 55) - 592*r*s + 130*r - 428*s**2 + 433*s - 77)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*(4*s - 1)*(f*(17*s - 6) + 8*s - 7)*np.sqrt(k2**2) + k2**3*(Pk2*(2*K*(52*r*s - 46*r - 119*s + 38) - 24*f*(r*(20*s - 6) - 7*s + 2) - 104*r*s + 92*r + 900*s**2 - 863*s + 143) + Pkd2*(K*(-136*r*s + 52*r + 78*s - 24) + 2*f*(8*r*(10*s - 3) - 332*s**2 + 171*s - 21) + 136*r*s - 52*r - 300*s**2 + 289*s - 49)*np.sqrt(k2**2))))) - 13*b1*(66*D1*bd1*f*(Pk2*k2**4*r*(2*f + 18)*(2*r - 1)*np.sqrt(k2**2) + k1**4*s*(4*Pk2*(f*(94*s - 66) + 91*s - 89) + k2*(Pkd2*(f*(96 - 136*s) - 139*s + 134) + Pkdd2*k2*(2*f*(7*s - 5) + 16*s - 15)))*np.sqrt(k2**2) + k1**2*(Pk2*(4*K*(37*r*s + 3*r + 6*s - 3) + f*(r*(48*s - 22) + 264*s**2 - 172*s + 9) - 148*r*s - 12*r - 107*s**2 + 80*s + 12)*(k2**2)**(3/2) + Pkdd2*k2**4*s*(f*(34*s - 20) + 16*s - 15)*np.sqrt(k2**2) + k2**3*(Pk2*(K*(26*r*s - 40*r - 74*s + 38) - 3*f*(20*r*(2*s - 1) - 11*s + 8) - 26*r*s + 40*r + 225*s**2 - 148*s - 38) + Pkd2*(-2*K*(17*r*s - 6*r - 12*s + 6) + 2*f*(10*r*(2*s - 1) - 83*s**2 + 44*s + 4) + 34*r*s - 12*r - 75*s**2 + 50*s + 12)*np.sqrt(k2**2)))) + D1*(f**2*fd*(24*Pk2*k2**4*(9*r**2 + 93*r - 32)*np.sqrt(k2**2) + 3*k1**4*(8*Pk2*(2559*s**2 - 2772*s + 638) + k2*(Pkd2*(-8043*s**2 + 8514*s - 1936) + 5*Pkdd2*k2*(195*s**2 - 198*s + 44)))*np.sqrt(k2**2) + k1**2*(6*Pk2*(606*r**2 + 18*r*(65*s - 27) - 132*s**2 - 38*s + 121)*(k2**2)**(3/2) + 165*Pkdd2*k2**4*(18*s**2 - 9*s + 2)*np.sqrt(k2**2) + k2**3*(-12*Pk2*(9*r*(19*s + 26) - 266*s - 133) + Pkd2*(12*r*(585*s - 109) - 1584*s**2 - 4947*s + 260)*np.sqrt(k2**2)))) + 33*f*(fd*(6*Pk2*k2**4*(8*r**2 + 2*r - 3)*np.sqrt(k2**2) + k1**4*(2*s - 1)*(4*Pk2*(59*s - 67) + k2*(Pkd2*(103 - 95*s) + 12*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(Pk2*(2*K*(r*(144*s - 67) - 13*s + 4) + 24*r**2 + r*(78 - 240*s) - 142*s**2 + 183*s - 41)*(k2**2)**(3/2) + 12*Pkdd2*k2**4*(2*s**2 - 3*s + 1)*np.sqrt(k2**2) + k2**3*(Pk2*(-2*K*(66*r*s - 24*r - 121*s + 56) + 12*r*s + 282*s**2 - 509*s + 181) + Pkd2*(-6*K*(6*r*s - 4*r + 5*s - 2) + 76*r*s - 40*r - 94*s**2 + 119*s - 35)*np.sqrt(k2**2)))) - 4*gd2*k1**2*(2*Pk2*s*(37*r + 6)*(k2**2)**(3/2) + k2**3*(Pk2*r*(13*s - 2) - 36*Pk2*s + Pkd2*s*(12 - 17*r)*np.sqrt(k2**2)))) + 132*fd*g2*k1**2*(Pk2*(r*(77 - 74*s) - 3*s)*(k2**2)**(3/2) + k2**3*(Pk2*(-13*r*s + 4*r + 9*s) + Pkd2*(17*r*s - 14*r - 3*s)*np.sqrt(k2**2)))) + Dd*f*(f**2*(24*Pk2*k2**4*(12*r**2 + 125*r - 32)*np.sqrt(k2**2) + 3*k1**4*(4*s - 1)*(8*Pk2*(853*s - 638) + k2*(Pkd2*(1936 - 2681*s) + 5*Pkdd2*k2*(65*s - 44)))*np.sqrt(k2**2) + 2*k1**2*(Pk2*(2424*r**2 + r*(4680*s - 2746) - 528*s**2 - 2454*s + 889)*(k2**2)**(3/2) + 165*Pkdd2*k2**4*(12*s**2 - 7*s + 1)*np.sqrt(k2**2) - 2*k2**3*(3*Pk2*(228*r*s - 142*r - 479*s + 141) + Pkd2*(-2340*r*s + 736*r + 528*s**2 + 1161*s - 361)*np.sqrt(k2**2)))) + 33*f*(6*Pk2*k2**4*(16*r**2 + 8*r - 3)*np.sqrt(k2**2) + k1**4*(4*s - 1)*(4*Pk2*(59*s - 67) + k2*(Pkd2*(103 - 95*s) + 12*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(Pk2*(2*K*(r*(288*s - 55) - 33*s + 4) + 48*r**2 - 6*r*(80*s - 7) - 284*s**2 + 301*s - 41)*(k2**2)**(3/2) + 12*Pkdd2*k2**4*(4*s**2 - 5*s + 1)*np.sqrt(k2**2) + k2**3*(Pk2*(-2*K*(4*r*(33*s + 2) - 265*s + 56) + 8*r*(3*s + 2) + 564*s**2 - 887*s + 181) + Pkd2*(K*(-8*r*(9*s - 5) - 70*s + 12) + 8*r*(19*s - 5) - 188*s**2 + 189*s - 35)*np.sqrt(k2**2)))) + 132*g2*k1**2*(Pk2*(r*(65 - 296*s) - 39*s + 12)*(k2**2)**(3/2) + k2**3*(Pk2*(-52*r*s + 46*r + 119*s - 38) + Pkd2*(68*r*s - 26*r - 39*s + 12)*np.sqrt(k2**2))))) - f*(13*D1*bd1*(f**2*(24*Pk2*k2**4*r*(3*r + 32)*np.sqrt(k2**2) + 3*k1**4*s*(8*Pk2*(853*s - 633) + k2*(-7*Pkd2*(383*s - 273) + 5*Pkdd2*k2*(65*s - 43)))*np.sqrt(k2**2) + k1**2*(4*Pk2*(303*r**2 + r*(585*s - 644) - 66*s**2 - 1170*s + 263)*(k2**2)**(3/2) + 165*Pkdd2*k2**4*s*(6*s - 5)*np.sqrt(k2**2) + k2**3*(-12*Pk2*(r*(57*s - 376) - 213*s + 274) + Pkd2*(4*r*(585*s - 409) - 528*s**2 + 303*s + 1184)*np.sqrt(k2**2)))) + 33*f*(6*Pk2*k2**4*r*(4*r + 3)*np.sqrt(k2**2) + k1**4*s*(4*Pk2*(59*s - 67) + k2*(Pkd2*(103 - 95*s) + 12*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(Pk2*(12*r**2 + 6*r*(K*(24*s + 2) - 20*s - 3) + s*(-20*K - 71*s + 59))*(k2**2)**(3/2) + 12*Pkdd2*k2**4*s*(s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(r*(-66*K*s - 32*K + 6*s + 8) + 3*s*(48*K + 47*s - 63)) + Pkd2*(-2*K*(9*r*s - 4*r + 10*s) + s*(38*r - 47*s + 35))*np.sqrt(k2**2)))) + 132*g2*k1**2*(-2*Pk2*(37*r*s + 6*r + 6*s - 6)*(k2**2)**(3/2) + k2**3*(Pk2*r*(38 - 13*s) + 38*Pk2*(s - 1) + Pkd2*(17*r*s - 12*r - 12*s + 12)*np.sqrt(k2**2)))) + 858*b2*k1**2*(D1*fd*(3*Pk2*(2*r - 3)*(2*s - 1)*(k2**2)**(3/2) - k2**3*(3*Pk2 - Pkd2*np.sqrt(k2**2))*(2*r*(5*s - 2) - 17*s + 8)) + Dd*f*(Pk2*(4*r*(6*s - 1) - 38*s + 9)*(k2**2)**(3/2) - k2**3*(3*Pk2 - Pkd2*np.sqrt(k2**2))*(s*(20*r - 37) + 8))) + 2*k1**2*(5*D1*f**2*fd*(-13*Pkd2*k1**2*k2*(1332*s**2 - 1321*s + 247)*np.sqrt(k2**2) + 13*k2**3*(16*Pk2*(r*(84*s - 11) - 82*s + 18) + Pkd2*(160*r*(2*s - 1) + 1220*s**2 - 873*s + 162)*np.sqrt(k2**2)) + 2*(Pk2*k2**2*(2908*r**2 + r*(1040*s - 2559) - 14560*s**2 + 9204*s - 998) + 13*k1**2*(4*s - 1)*(Pk2*(414*s - 326) + 7*Pkdd2*k2**2*(3*s - 2)))*np.sqrt(k2**2)) + 429*D1*f*(Pk2*bd2*(6*r*s + r - 10*s)*(k2**2)**(3/2) - 4*Pk2*gd2*(r*(36*s + 3) - 5*s)*(k2**2)**(3/2) - bd2*k2**3*(3*Pk2 - Pkd2*np.sqrt(k2**2))*(r*(5*s + 2) - 10*s) + 2*gd2*k2**3*(Pk2*(r*(33*s + 16) - 72*s) + Pkd2*(r*(9*s - 4) + 10*s)*np.sqrt(k2**2))) + 858*D1*fd*g2*(Pk2*(r*(67 - 144*s) + 13*s - 4)*(k2**2)**(3/2) + k2**3*(Pk2*(66*r*s - 24*r - 121*s + 56) + 3*Pkd2*(6*r*s - 4*r + 5*s - 2)*np.sqrt(k2**2))) + 5*Dd*f**3*(-13*Pkd2*k1**2*k2*(1332*s**2 - 1321*s + 247)*np.sqrt(k2**2) + 13*k2**3*(16*Pk2*(r*(84*s - 11) - 82*s + 18) + Pkd2*(160*r*(2*s - 1) + 1220*s**2 - 873*s + 162)*np.sqrt(k2**2)) + 2*(Pk2*k2**2*(2908*r**2 + r*(1040*s - 2559) - 14560*s**2 + 9204*s - 998) + 13*k1**2*(4*s - 1)*(Pk2*(414*s - 326) + 7*Pkdd2*k2**2*(3*s - 2)))*np.sqrt(k2**2)) + 858*Dd*f*g2*(Pk2*(r*(55 - 288*s) + 33*s - 4)*(k2**2)**(3/2) + k2**3*(Pk2*(4*r*(33*s + 2) - 265*s + 56) + Pkd2*(4*r*(9*s - 5) + 35*s - 6)*np.sqrt(k2**2))))))/(9009*d**2*k1**3*k2**3*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct**3*st**2*(33*D1*bd1*f*(-2*b1*k1**2*(Pk2*k1**2*s*(104*C - 128)*(2*s - 1)*(k2**2)**(3/2) - Pkd2*k1**2*k2**3*s*(65*C - 80)*(2*s - 1)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(4 - 4*C)*(s - 2) + 3*s*(-2*C + 2*s + 1))*np.sqrt(k2**2) + 3*Pkdd2*k2**7*s*(1 - 2*s) + k2**4*(Pk2*(4*C - 4)*(2*r*(s - 2) + 3*s) + Pkdd2*k1**2*s*(13*C - 16)*(2*s - 1))*np.sqrt(k2**2)) + f*(4*Pk2*k2**6*r*(-5*k2 + 3*np.sqrt(k2**2))*(r - 1) + 3*k1**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 2)*np.sqrt(k2**2) + k1**4*(Pk2*(-4*C*(r*(27*s - 7) - 376*s**2 + 167*s + 7) + r*(197*s - 70) - 1519*s**2 + 535*s + 70)*(k2**2)**(3/2) + Pkdd2*k2**4*s*(34*C*(2*s - 1) + 6*s - 15)*np.sqrt(k2**2) + k2**3*(5*Pk2*(24*C*(3*r*s - r - 2*s + 1) - 152*r*s + 60*r + 27*s**2 + 88*s - 60) + 2*Pkd2*(C*(-32*r*s + 12*r - 290*s**2 + 165*s - 12) + 69*r*s - 28*r + 164*s**2 - 98*s + 28)*np.sqrt(k2**2))) - k1**2*k2**4*(Pk2*(-4*C*(5*r**2 - r*(51*s + 5) + 8*s - 4) + 20*r**2 - r*(191*s + 26) + 236*s**2 - 91*s - 10)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(r*(9*s - 1) - 6*s + 3) + r*(22*s + 4) - 121*s**2 + 42*s + 4)*np.sqrt(k2**2) + 3*Pkdd2*k2**3*s*(s + 1)))) - 66*b1**2*k1**2*(D1*fd*s*(Pk2*k1**2*s*(104*C - 128)*(k2**2)**(3/2) + Pkd2*k1**2*k2**3*s*(80 - 65*C)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(2 - 2*C) + 3*s)*np.sqrt(k2**2) - 3*Pkdd2*k2**7*s + k2**4*(Pk2*r*(4*C - 4) + Pkdd2*k1**2*s*(13*C - 16))*np.sqrt(k2**2)) + Dd*f*(Pk2*k1**2*s*(104*C - 128)*(4*s - 1)*(k2**2)**(3/2) - Pkd2*k1**2*k2**3*s*(65*C - 80)*(4*s - 1)*np.sqrt(k2**2) + Pkd2*k2**5*(8*r*(-C*s + C + s - 1) + 3*s*(-2*C + 4*s + 1))*np.sqrt(k2**2) + 3*Pkdd2*k2**7*s*(1 - 4*s) + k2**4*(Pk2*(4*C - 4)*(4*r*(s - 1) + 3*s) + Pkdd2*k1**2*s*(13*C - 16)*(4*s - 1))*np.sqrt(k2**2))) + 33*b1*f*(D1*fd*(8*Pk2*k2**6*r**2*(-5*k2 + 3*np.sqrt(k2**2)) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2)*np.sqrt(k2**2) + k1**4*(Pk2*(8*C*(r*(14 - 27*s) + 376*s**2 - 422*s + 108) + r*(394*s - 218) - 3038*s**2 + 3475*s - 870)*(k2**2)**(3/2) + Pkdd2*k2**4*(2*C*(68*s**2 - 95*s + 26) + 12*s**2 + 45*s - 12)*np.sqrt(k2**2) + k2**3*(5*Pk2*(2*r*(36*C*(2*s - 1) - 152*s + 83) + 54*s**2 - 63*s + 18) + Pkd2*(-2*C*(32*r*(2*s - 1) + 580*s**2 - 707*s + 186) + 6*r*(46*s - 25) + 656*s**2 - 925*s + 231)*np.sqrt(k2**2))) + k1**2*k2**4*(2*Pk2*(r**2*(20*C - 20) + r*(-4*C*(51*s - 35) + 191*s - 130) - 236*s**2 + s*(266 - 30*C) - 59)*np.sqrt(k2**2) + Pkd2*k2*(r*(72*C*(s - 1) - 44*s + 52) + 242*s**2 + s*(28*C - 288) + 65)*np.sqrt(k2**2) - 6*Pkdd2*k2**3*(s**2 - 4*s + 1))) + Dd*f*(4*Pk2*k2**6*r*(-5*k2 + 3*np.sqrt(k2**2))*(4*r - 1) + 3*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2)*np.sqrt(k2**2) + k1**4*(2*Pk2*(C*(r*(84 - 216*s) + 3008*s**2 - 2454*s + 418) + r*(394*s - 179) - 3038*s**2 + 2440*s - 400)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*(4*s - 1)*(34*C*s - 26*C + 3*s + 6)*np.sqrt(k2**2) + k2**3*(5*Pk2*(24*C*(12*r*s - 5*r - 2*s + 1) - 608*r*s + 286*r + 108*s**2 + 7*s - 42) + Pkd2*(-4*C*(64*r*s - 28*r + 580*s**2 - 529*s + 99) + 552*r*s - 262*r + 1312*s**2 - 1352*s + 287)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(20*r**2 + r*(69 - 204*s) - 7*s - 4) - 80*r**2 + 4*r*(191*s - 61) - 944*s**2 + 741*s - 108)*np.sqrt(k2**2) + Pkd2*k2*(4*C*(r*(36*s - 22) + s + 3) + r*(52 - 88*s) + 484*s**2 - 395*s + 61)*np.sqrt(k2**2) - 3*Pkdd2*k2**3*(4*s**2 - 9*s + 2)))) + f**2*(D1*fd*(4*Pk2*k2**6*(3*r - 1)*(-71*k2*(3*r - 1) + 3*(9*r + 8)*np.sqrt(k2**2)) + 6*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(126*s**2 - 117*s + 25)*np.sqrt(k2**2) + k1**4*(Pk2*(-88*C*(153*r*s - 69*r - 1422*s**2 + 1236*s - 248) + 9*r*(1989*s - 938) - 129492*s**2 + 108147*s - 20836)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*(3*s - 1)*(C*(1203*s - 698) - 369*s + 222)*np.sqrt(k2**2) + k2**3*(2*Pk2*(660*C*(12*r*(2*s - 1) - 5*s + 3) - 3*r*(9423*s - 4912) + 5670*s**2 - 792*s - 2137) + Pkd2*(-2*C*(264*r*(9*s - 5) + 26469*s**2 - 24345*s + 5350) + 12*r*(840*s - 467) + 36180*s**2 - 32991*s + 7725)*np.sqrt(k2**2))) + k1**2*k2**4*(3*Pk2*(4*C*(597*r**2 - 2028*r*s + 80*r - 314*s + 237) - 2844*r**2 + 7887*r*s + 1082*r - 5508*s**2 + 4101*s - 1676)*np.sqrt(k2**2) + Pkd2*k2*(4*C*(1242*r*s - 579*r + 378*s - 71) - 5472*r*s + 1626*r + 9450*s**2 - 6489*s + 1179)*np.sqrt(k2**2) - 198*Pkdd2*k2**3*(6*s**2 - 5*s + 1))) + Dd*f*(4*Pk2*k2**6*(4*r - 1)*(-71*k2*(3*r - 1) + 3*(9*r + 8)*np.sqrt(k2**2)) + 6*k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(168*s**2 - 142*s + 25)*np.sqrt(k2**2) + k1**4*(Pk2*(-88*C*(3*r*(68*s - 27) - 1896*s**2 + 1496*s - 248) + 4*r*(5967*s - 2597) - 172656*s**2 + 130929*s - 20836)*(k2**2)**(3/2) + 2*Pkdd2*k2**4*(4*s - 1)*(C*(1203*s - 698) - 369*s + 222)*np.sqrt(k2**2) + k2**3*(2*Pk2*(660*C*(32*r*s - 15*r - 5*s + 3) - 37692*r*s + 19238*r + 7560*s**2 - 3157*s - 2137) + Pkd2*(-2*C*(132*r*(24*s - 13) + 35292*s**2 - 29299*s + 5350) + 13440*r*s - 7484*r + 48240*s**2 - 38836*s + 7725)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(2388*r**2 - 8112*r*s + 181*r - 1594*s + 711) - 11376*r**2 + 31548*r*s + 5888*r - 22032*s**2 + 14689*s - 5028)*np.sqrt(k2**2) + Pkd2*k2*(4*C*(1656*r*s - 758*r + 628*s - 71) - 7296*r*s + 1534*r + 12600*s**2 - 7576*s + 1179)*np.sqrt(k2**2) - 198*Pkdd2*k2**3*(8*s**2 - 6*s + 1)))))/(693*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) - 2*D1**3*Pk1*ct**3*(33*D1*bd1*f*(b1*(4*Pk2*k2**6*r*(8*k2 + np.sqrt(k2**2))*(2*r - 1) + 2*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(-56*C*(s - 1) + 30*s - 74) + s*(C*(188 - 432*s) + 656*s - 269))*(k2**2)**(3/2) + Pkdd2*k2**4*s*(44 - 48*C)*(2*s - 1)*np.sqrt(k2**2) + k2**3*(6*Pk2*(r*(28*C*(s - 1) - 22*s + 37) + s*(14*C + 2*s - 27)) + Pkd2*(r*(-56*C*(s - 1) + 44*s - 74) + s*(8*C*(39*s - 23) - 422*s + 263))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(r**2*(88 - 88*C) + 2*r*(212*C*s - 80*C - 233*s + 80) + s*(29 - 8*C))*np.sqrt(k2**2) + Pkd2*k2*(-2*r*(56*C*s - 28*C - 62*s + 33) + s*(21 - 34*s))*np.sqrt(k2**2) + 14*Pkdd2*k2**3*s*(2*s - 1))) + f*(2*Pk2*k2**6*r*(k2*(35 - 16*r) + 2*(2*r - 1)*np.sqrt(k2**2)) + k1**6*s*(4*Pk2*(67*s - 75) + k2*(Pkd2*(123 - 115*s) + 16*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(-4*C*(4*r*(7*s - 15) - 240*s**2 + 117*s + 50) + 32*r**2 + r*(266*s - 330) - 625*s**2 + 132*s + 250)*(k2**2)**(3/2) + 4*Pkdd2*k2**4*s*(2*C*(5*s - 2) + 13*s - 13)*np.sqrt(k2**2) + k2**3*(Pk2*(C*(484*r*s - 600*r - 468*s + 480) - 946*r*s + 760*r + 153*s**2 + 513*s - 616) + Pkd2*(-4*C*(47*r*s - 46*r + 146*s**2 - 130*s + 36) + 338*r*s - 240*r + 260*s**2 - 319*s + 192)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(-4*C*(34*r**2 + 77*r*s - 8*r - 42*s + 42) + 160*r**2 + 48*r*(5*s - 1) + 24*s**2 - 167*s + 162)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(r*(9*s - 4) + 10*s - 10) + 2*r*(61*s - 44) + 103*s**2 - 94*s + 40)*np.sqrt(k2**2) + 12*Pkdd2*k2**3*s*(s - 1)))) + 33*b1**2*(D1*fd*(4*Pk2*k2**6*r**2*np.sqrt(k2**2) - 10*Pkd2*k1**6*k2*s**2*np.sqrt(k2**2) + Pkd2*k1**2*k2**5*s*(r*(62 - 56*C) - 17*s)*np.sqrt(k2**2) + k1**4*k2**3*s*(6*Pk2*(14*C*r - 11*r + s) + Pkd2*(-28*C*r + 156*C*s + 22*r - 211*s)*np.sqrt(k2**2)) + k1**4*s*(16*Pk2*k1**2*s + k2**2*(Pk2*r*(15 - 28*C) + Pk2*s*(328 - 216*C) + 2*Pkdd2*k1**2*s))*np.sqrt(k2**2) + k1**2*k2**4*(Pk2*r*(r*(44 - 44*C) + s*(212*C - 233)) + Pkdd2*k1**2*s**2*(44 - 48*C))*np.sqrt(k2**2) + 2*k2**7*(16*Pk2*r**2 + 7*Pkdd2*k1**2*s**2)) + Dd*f*(4*Pk2*k2**6*r*(8*k2 + np.sqrt(k2**2))*(4*r - 1) + 2*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(-56*C*(2*s - 1) + 60*s - 74) + s*(C*(188 - 864*s) + 1312*s - 269))*(k2**2)**(3/2) + Pkdd2*k2**4*s*(44 - 48*C)*(4*s - 1)*np.sqrt(k2**2) + k2**3*(6*Pk2*(r*(56*C*s - 28*C - 44*s + 37) + s*(14*C + 4*s - 27)) + Pkd2*(r*(-56*C*(2*s - 1) + 88*s - 74) + s*(8*C*(78*s - 23) - 844*s + 263))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(r**2*(176 - 176*C) + 4*r*(212*C*s - 40*C - 233*s + 40) + s*(29 - 8*C))*np.sqrt(k2**2) + Pkd2*k2*(r*(-224*C*s + 56*C + 248*s - 66) + s*(21 - 68*s))*np.sqrt(k2**2) + 14*Pkdd2*k2**3*s*(4*s - 1)))) + 33*b1*f*(D1*fd*(2*Pk2*k2**6*(k2*(-32*r**2 + 14*r - 11) + 2*(1 - 2*r)**2*np.sqrt(k2**2)) + k1**6*(4*Pk2*(134*s**2 - 193*s + 67) + k2*(Pkd2*(-230*s**2 + 301*s - 103) + 4*Pkdd2*k2*(8*s**2 - 9*s + 3)))*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(r*(47 - 56*s) + 480*s**2 - 580*s + 176) + 64*r**2 + 4*r*(133*s - 71) - 1250*s**2 + 1574*s - 505)*(k2**2)**(3/2) + 4*Pkdd2*k2**4*(2*C*(10*s**2 - 21*s + 6) + 26*s**2 - 9*s + 3)*np.sqrt(k2**2) + k2**3*(Pk2*(-264*C*s + 4*r*(242*C*s - 148*C - 473*s + 219) + 306*s**2 - 3*s + 165) + Pkd2*(-4*C*(94*r*s - 52*r + 292*s**2 - 397*s + 108) + 676*r*s - 300*r + 520*s**2 - 903*s + 196)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(-4*C*(68*r**2 + r*(154*s - 173) - 74*s + 20) + 320*r**2 + 12*r*(40*s - 53) + 48*s**2 - 365*s + 102)*np.sqrt(k2**2) + Pkd2*k2*(-4*r*(s*(18*C - 61) + 11) + 206*s**2 - s*(60*C + 272) + 51)*np.sqrt(k2**2) + 24*Pkdd2*k2**3*s**2)) + Dd*f*(2*Pk2*k2**6*(4*r - 1)*(k2*(11 - 16*r) + 2*(2*r - 1)*np.sqrt(k2**2)) + k1**6*(4*s - 1)*(268*Pk2*(s - 1) + k2*(Pkd2*(103 - 115*s) + 4*Pkdd2*k2*(4*s - 3)))*np.sqrt(k2**2) + k1**4*(Pk2*(C*(-448*r*s + 588*r + 3840*s**2 - 3452*s + 504) + 128*r**2 + 4*r*(266*s - 195) - 2500*s**2 + 2127*s - 255)*(k2**2)**(3/2) + 4*Pkdd2*k2**4*(4*s - 1)*(2*C*(5*s - 6) + 13*s - 3)*np.sqrt(k2**2) + k2**3*(Pk2*(4*C*(484*r*s - 388*r - 213*s + 120) - 3784*r*s + 2000*r + 612*s**2 + 597*s - 451) + 2*Pkd2*(-2*C*(4*r*(47*s - 31) + 584*s**2 - 645*s + 144) + 676*r*s - 324*r + 520*s**2 - 751*s + 194)*np.sqrt(k2**2))) + k1**2*k2**4*(-4*Pk2*(C*(136*r**2 + r*(308*s - 201) - 158*s + 62) - 160*r**2 - 48*r*(5*s - 4) - 24*s**2 + 178*s - 66)*np.sqrt(k2**2) + Pkd2*k2*(-4*C*(36*r*s - 4*r + 35*s - 10) + 8*r*(61*s - 17) + 412*s**2 - 453*s + 91)*np.sqrt(k2**2) + 12*Pkdd2*k2**3*s*(4*s - 1)))) + f**2*(D1*fd*(1188*Pk2*k2**7*r*(1 - 3*r) + k1**6*(3*s - 1)*(Pk2*(5532*s - 7388) + k2*(Pkd2*(2837 - 2373*s) + 330*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(-36*C*r*(67*s - 323) + 8*C*(8757*s**2 - 9912*s + 1880) + 7740*r**2 + 3*r*(5247*s - 7726) - 51039*s**2 + 51945*s - 6527)*(k2**2)**(3/2) + 330*Pkdd2*k2**4*(3*s - 1)*(C*(6*s - 4) + s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(24*C*(r*(174*s - 1081) + 591*s + 144) + r*(31662 - 31428*s) + 9477*s**2 - 33990*s + 3215) + Pkd2*(-8*C*(3*r*(282*s - 391) + 6237*s**2 - 6486*s + 1766) + 66*r*(306*s - 197) + 30303*s**2 - 30861*s + 9010)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(927*r**2 + r*(504 - 5940*s) - 3894*s + 1687) + 7200*r**2 + 9*r*(3875*s - 1748) + 3168*s**2 - 15189*s + 5280) + 33*Pkd2*k2*(8*C*(3*r - 1)*(2*s - 1) + 144*r*s - 66*r + 258*s**2 - 233*s + 55))*np.sqrt(k2**2)) + Dd*f*(1188*Pk2*k2**7*r*(1 - 4*r) + k1**6*(4*s - 1)*(Pk2*(5532*s - 7388) + k2*(Pkd2*(2837 - 2373*s) + 330*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(-4*C*r*(804*s - 4211) + 32*C*(2919*s**2 - 3111*s + 470) + 10320*r**2 + r*(20988*s - 30374) - 68052*s**2 + 65668*s - 6527)*(k2**2)**(3/2) + 330*Pkdd2*k2**4*(4*s - 1)*(C*(6*s - 4) + s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(48*C*(4*r*(29*s - 195) + 463*s + 72) + r*(43154 - 41904*s) + 12636*s**2 - 48697*s + 3215) + Pkd2*(-8*C*(2*r*(564*s - 797) + 8316*s**2 - 7831*s + 1766) + 66*r*(408*s - 251) + 40404*s**2 - 36307*s + 9010)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(1236*r**2 - 7920*r*s + 137*r - 5214*s + 1687) + 9600*r**2 + 46500*r*s - 16132*r + 4224*s**2 - 20069*s + 5280) + 33*Pkd2*k2*(8*C*(4*r - 1)*(2*s - 1) + 192*r*s - 78*r + 344*s**2 - 276*s + 55))*np.sqrt(k2**2))))/(693*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) + D1**3*Pk1*ct**2*f*st**6*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(33*b1*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + Dd*f*(12*s**2 - 7*s + 1)))/(693*d**2*k3**2) - D1**3*Pk1*ct**2*f*st**6*(40*C - 40)*(33*D1*bd1*f*(-4*Pk2*k2**2*(r*(4*s - 1) + (1 - 2*s)**2) + Pkd2*k2**3*(r*(4*s - 1) - 2*s + 1) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + 33*b1*(-2*D1*fd*(2*s - 1)*(4*Pk2*k2**2*(2*r + 2*s - 1) - 2*Pkd2*k2**3*r + Pkd2*(1 - 2*s)*(k2**2)**(3/2)) + Dd*f*(-4*Pk2*k2**2*(8*s - 3)*(2*r + 2*s - 1) + Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 2*Pkd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2))) + f*(-2*D1*fd*(3*s - 1)*(4*Pk2*k2**2*(3*r + 3*s - 2) + Pkd2*(1 - 3*s)*(k2**2)**(3/2) + k2**3*(-3*Pkd2*r + Pkd2)) + Dd*f*(-4*Pk2*k2**2*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + Pkd2*k2**3*(r*(24*s - 7) - 7*s + 2) + 2*Pkd2*(12*s**2 - 7*s + 1)*(k2**2)**(3/2))))/(693*d**2*k3**4) + D1**3*Pk1*ct**2*st**4*(D1*f*(-3432*bd1*g2*k1**2*s*(s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + f**2*(-65*bd1*(Pk2*(864*k1**2*s*(1 - 3*s) + k2**2*(-521*r*s + 74*r + 233*s - 74))*np.sqrt(k2**2) + 324*Pkd2*k1**2*k2**2*s*(3*s - 1) + 24*Pkd2*k2**3*(6*r*s - r - 3*s + 1)*np.sqrt(k2**2) + 36*Pkdd2*k1**2*s*(1 - 3*s)*(k2**2)**(3/2)) + fd*(80*k1**2*(188*s**2 - 107*s + 15)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(12*r*(6685*s - 1902) - 14855*s + 4406) + 10*Pkd2*k2*(r*(490 - 1804*s) + 321*s - 90))*(k2**2)**(3/2)))) + Dd*f**4*(80*k1**2*(188*s**2 - 107*s + 15)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(12*r*(6685*s - 1902) - 14855*s + 4406) + 10*Pkd2*k2*(r*(490 - 1804*s) + 321*s - 90))*(k2**2)**(3/2)) + 1716*b1**2*k1**2*(K - 1)*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) - 13*b1*(3*D1*(5*f**2*fd*(-12*k1**2*(1 - 3*s)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + r*(Pk2*(170 - 521*s) + 48*Pkd2*k2*(3*s - 1))*(k2**2)**(3/2)) + 88*f*k1**2*s*(s - 1)*(-K*bd1 + bd1 + gd2)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 88*fd*g2*k1**2*(s - 1)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + Dd*f*(5*f**2*(-36*k1**2*(12*s**2 - 7*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(584 - 2084*s) + 233*s - 74) + 24*Pkd2*k2*(r*(24*s - 7) - 3*s + 1))*(k2**2)**(3/2)) + 264*g2*k1**2*(4*s**2 - 5*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)))))/(3003*d**2*k1**2*(k2**2)**(3/2)) - D1**3*Pk1*ct**2*st**2*(-5148*b1**3*k1**2*s*(D1*fd*s + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 429*b1**2*(2*D1*(-6*bd1*f*k1**2*s*(3*s - 1)*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + fd*k1**2*(Pk2*(-8*K*(4*s**2 - 10*s + 5) + f*(39*r*s - 34*r + 336*s**2 - 744*s + 180) + 48*r*s - 48*r - 64*s**2 + 112*s - 56)*np.sqrt(k2**2) + Pkd2*k2**2*(K*(2*s**2 - 14*s + 7) - 3*f*(8*r*s - 5*r - 20*s**2 - 65*s + 15) + 58*s**2 - 106*s + 53) + 3*Pkd2*k2*r*(f*(6*s - 3) - 4*s + 4)*np.sqrt(k2**2) + Pkdd2*(K*(2*s**2 - 2*s + 1) - s**2*(48*f + 14) + s*(26 - 3*f) - 13)*(k2**2)**(3/2)) + fd*r*(Pk2*f*(64 - 246*s) - 4*Pk2*(r*(8*K - 8) + 7*s - 7) + 27*Pkd2*f*k2*(4*s - 1) + 14*Pkd2*k2*(s - 1))*(k2**2)**(3/2)) + Dd*f*(k1**2*(Pk2*(-16*K*(16*s**2 - 24*s + 5) + f*(4*r*(39*s - 46) + 1344*s**2 - 1863*s + 418) + 384*r*s - 240*r - 512*s**2 + 528*s - 64)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(3*f*(r*(16*s - 9) - 40*s**2 - 53*s + 17) - (4*s - 1)*(K*(2*s - 7) + 58*s - 53)) - 6*Pkd2*k2*(r*(-12*f*s + 3*f + 16*s - 10) - 2*s + 2)*np.sqrt(k2**2) - 2*Pkdd2*(4*s - 1)*(-2*K*s + K + s*(24*f + 14) - 13)*(k2**2)**(3/2)) + 2*(Pk2*f*(r*(128 - 492*s) + 63*s - 17) - 4*Pk2*r*(8*K*(4*r - 1) - 32*r + 28*s + 1) + 6*Pkd2*f*k2*(9*r - 1)*(4*s - 1) + 14*Pkd2*k2*r*(4*s - 1))*(k2**2)**(3/2))) + 39*b1*(-6688*D1*K*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 7920*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 2288*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 704*D1*K*Pk2*f*fd*r**2*(k2**2)**(3/2) + 880*D1*K*Pk2*f*fd*r*(k2**2)**(3/2) - 264*D1*K*Pk2*f*fd*(k2**2)**(3/2) + 2992*D1*K*Pkd2*f*fd*k1**2*k2**2*s**2 - 3564*D1*K*Pkd2*f*fd*k1**2*k2**2*s + 1034*D1*K*Pkd2*f*fd*k1**2*k2**2 - 440*D1*K*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) + 528*D1*K*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) - 154*D1*K*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) - 1056*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) + 1056*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 882*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 1092*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 59184*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) - 49965*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 9414*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 216*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 3474*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) - 2082*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) + 1482*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) - 222*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 2376*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 880*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 352*D1*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) - 1276*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 396*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 704*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) + 88*D1*Pk2*f*fd*r*s*(k2**2)**(3/2) - 748*D1*Pk2*f*fd*r*(k2**2)**(3/2) + 176*D1*Pk2*f*fd*(k2**2)**(3/2) + 1408*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) - 1760*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 1408*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 1408*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) - 3520*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 1760*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 1408*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 660*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 - 660*D1*Pkd2*bd2*f*k1**2*k2**2*s - 2304*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 1164*D1*Pkd2*f**2*fd*k1**2*k2**2*r - 17388*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 17052*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 3258*D1*Pkd2*f**2*fd*k1**2*k2**2 + 2376*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 792*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 1530*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) - 24*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) - 840*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) + 140*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) + 176*D1*Pkd2*f*fd*k1**2*k2**2*r*s - 88*D1*Pkd2*f*fd*k1**2*k2**2*r + 968*D1*Pkd2*f*fd*k1**2*k2**2*s**2 - 1056*D1*Pkd2*f*fd*k1**2*k2**2*s + 286*D1*Pkd2*f*fd*k1**2*k2**2 - 792*D1*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 330*D1*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) + 198*D1*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) - 66*D1*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) - 110*D1*Pkd2*f*fd*k2**3*r*np.sqrt(k2**2) - 22*D1*Pkd2*f*fd*k2**3*s*np.sqrt(k2**2) + 66*D1*Pkd2*f*fd*k2**3*np.sqrt(k2**2) - 88*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 + 308*D1*Pkd2*f*gd2*k1**2*k2**2*s - 88*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 + 616*D1*Pkd2*fd*g2*k1**2*k2**2*s - 308*D1*Pkd2*fd*g2*k1**2*k2**2 - 132*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) + 132*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 864*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 1512*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 296*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) - 352*D1*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) + 396*D1*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) - 110*D1*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) - 88*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) + 44*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) - 88*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) + 88*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) - 44*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 11*D1*bd1*f*(k1**2*(Pk2*(f*(2*r*(39*s - 58) + 672*s**2 - 375*s + 58) + 96*r*(2*s - 1) - 16*s**2*(8*K + 16) + 16*s*(9*K + 12) + 48)*np.sqrt(k2**2) - 2*Pkd2*k2**2*s*(-4*K*s + 9*K - 116*s + 111) - 12*Pkd2*k2*(4*r*s - 2*r - s + 1)*np.sqrt(k2**2) - 2*Pkdd2*s*(-4*K*s + 3*K + 28*s - 27)*(k2**2)**(3/2) - 6*f*(2*Pkd2*k2**2*(4*r*s - 2*r - 10*s**2 + 6*s + 1) - 6*Pkd2*k2*r*s*np.sqrt(k2**2) + Pkdd2*s*(16*s - 9)*(k2**2)**(3/2))) + 2*(Pk2*f*(r*(64 - 246*s) + 63*s - 17) - 8*Pk2*r*(K*(8*r - 4) - 8*r + 7*s + 4) + 3*Pkd2*f*k2*(9*r - 2)*(4*s - 1) + 28*Pkd2*k2*r*s)*(k2**2)**(3/2)) - 13376*Dd*K*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 12496*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 2288*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) - 1408*Dd*K*Pk2*f**2*r**2*(k2**2)**(3/2) + 1408*Dd*K*Pk2*f**2*r*(k2**2)**(3/2) - 264*Dd*K*Pk2*f**2*(k2**2)**(3/2) + 5984*Dd*K*Pkd2*f**2*k1**2*k2**2*s**2 - 5632*Dd*K*Pkd2*f**2*k1**2*k2**2*s + 1034*Dd*K*Pkd2*f**2*k1**2*k2**2 - 880*Dd*K*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) + 836*Dd*K*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) - 154*Dd*K*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 1176*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 2528*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 78912*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) - 57434*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 10132*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 288*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 4632*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) - 1532*Dd*Pk2*f**3*r*(k2**2)**(3/2) + 1366*Dd*Pk2*f**3*s*(k2**2)**(3/2) - 230*Dd*Pk2*f**3*(k2**2)**(3/2) + 4752*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 1848*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 704*Dd*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) - 1100*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 396*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) + 1408*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) + 176*Dd*Pk2*f**2*r*s*(k2**2)**(3/2) - 1364*Dd*Pk2*f**2*r*(k2**2)**(3/2) + 264*Dd*Pk2*f**2*s*(k2**2)**(3/2) + 176*Dd*Pk2*f**2*(k2**2)**(3/2) + 5632*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) - 8448*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 1760*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 5632*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 1408*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 3072*Dd*Pkd2*f**3*k1**2*k2**2*r*s + 1556*Dd*Pkd2*f**3*k1**2*k2**2*r - 23184*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 18824*Dd*Pkd2*f**3*k1**2*k2**2*s - 3454*Dd*Pkd2*f**3*k1**2*k2**2 + 3168*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 792*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) + 2040*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) - 304*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) - 782*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) + 144*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) + 352*Dd*Pkd2*f**2*k1**2*k2**2*r*s - 88*Dd*Pkd2*f**2*k1**2*k2**2*r + 1936*Dd*Pkd2*f**2*k1**2*k2**2*s**2 - 1628*Dd*Pkd2*f**2*k1**2*k2**2*s + 286*Dd*Pkd2*f**2*k1**2*k2**2 - 1584*Dd*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) + 594*Dd*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) + 66*Dd*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) - 66*Dd*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) - 110*Dd*Pkd2*f**2*k2**3*r*np.sqrt(k2**2) - 154*Dd*Pkd2*f**2*k2**3*s*np.sqrt(k2**2) + 66*Dd*Pkd2*f**2*k2**3*np.sqrt(k2**2) - 352*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 + 1320*Dd*Pkd2*f*g2*k1**2*k2**2*s - 308*Dd*Pkd2*f*g2*k1**2*k2**2 + 1152*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) - 1472*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) + 296*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) - 704*Dd*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) + 616*Dd*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) - 110*Dd*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 352*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) + 264*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) - 44*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) - 132*b2*k1**2*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + f*(-61776*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) + 41184*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 38100*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 44360*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 1931904*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) - 1269675*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 210146*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 83328*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 402480*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) - 188148*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) - 113880*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) + 45144*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 260832*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) - 178464*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 27456*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) - 20592*D1*Pk2*f*gd2*r*(k2**2)**(3/2) + 521664*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) - 617760*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 178464*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 54912*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) - 68640*D1*Pk2*fd*g2*r*(k2**2)**(3/2) + 20592*D1*Pk2*fd*g2*(k2**2)**(3/2) + 38610*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 - 25740*D1*Pkd2*bd2*f*k1**2*k2**2*s - 66720*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 32670*D1*Pkd2*f**2*fd*k1**2*k2**2*r - 670176*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 459330*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 76944*D1*Pkd2*f**2*fd*k1**2*k2**2 + 70200*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 17550*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) - 1560*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) + 624*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) + 390*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) - 156*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) - 116688*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 + 80652*D1*Pkd2*f*gd2*k1**2*k2**2*s - 233376*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 + 277992*D1*Pkd2*fd*g2*k1**2*k2**2*s - 80652*D1*Pkd2*fd*g2*k1**2*k2**2 - 7722*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) + 5148*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 62400*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 46800*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 7800*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) + 17160*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) - 12012*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) + 34320*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) - 41184*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) + 12012*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 39*D1*bd1*(f**2*(k1**2*(Pk2*(-2*r*(147*s + 718) + 19728*s**2 - 7469*s + 718)*np.sqrt(k2**2) - 4*Pkd2*k2**2*(2*r*(96*s - 49) + 1449*s**2 - 443*s + 49) + 792*Pkd2*k2*r*s*np.sqrt(k2**2) + 8*Pkdd2*s*(36*s + 5)*(k2**2)**(3/2)) + 2*(Pk2*(-36*r**2 + r*(579*s + 275) - 58*s - 4) + Pkd2*k2*(5*r*(51*s - 28) + 29*s + 2))*(k2**2)**(3/2)) - 22*f*(k1**2*(-2*Pk2*(r*(27*s - 11) + 2*s*(-38*K*s + 26*K + 2*s + 1))*np.sqrt(k2**2) + Pkd2*k2**2*s*(-68*K*s + 47*K - 4*r - 22*s + 13) + 3*Pkd2*k2*(6*r*s - 2*r + s)*np.sqrt(k2**2) + Pkdd2*s*(10*K*s - 7*K + 8*s - 5)*(k2**2)**(3/2)) + (2*Pk2*(r**2*(8*K - 8) - r*(6*K + s - 7) - 3*s) + 3*Pkd2*k2*s)*(k2**2)**(3/2)) + 88*g2*(16*Pk2*(k1**2*s*(s - 1) + k2**2*r*(r - 1))*np.sqrt(k2**2) - k1**2*s*(s - 1)*(Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)))) - 38100*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 44360*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 1931904*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) - 1269675*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 210146*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 83328*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 402480*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) - 188148*Dd*Pk2*f**3*r*(k2**2)**(3/2) - 113880*Dd*Pk2*f**3*s*(k2**2)**(3/2) + 45144*Dd*Pk2*f**3*(k2**2)**(3/2) + 1043328*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) - 974688*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 178464*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 109824*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 109824*Dd*Pk2*f*g2*r*(k2**2)**(3/2) + 20592*Dd*Pk2*f*g2*(k2**2)**(3/2) - 66720*Dd*Pkd2*f**3*k1**2*k2**2*r*s + 32670*Dd*Pkd2*f**3*k1**2*k2**2*r - 670176*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 459330*Dd*Pkd2*f**3*k1**2*k2**2*s - 76944*Dd*Pkd2*f**3*k1**2*k2**2 + 70200*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 17550*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 1560*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) + 624*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) + 390*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) - 156*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) - 466752*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 + 439296*Dd*Pkd2*f*g2*k1**2*k2**2*s - 80652*Dd*Pkd2*f*g2*k1**2*k2**2 + 62400*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) - 46800*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) + 7800*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) + 68640*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) - 65208*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) + 12012*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) - 2574*b2*k1**2*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))*(2*D1*bd1*s*(s - 1) + D1*fd*(6*s**2 - 7*s + 2) + Dd*f*(12*s**2 - 11*s + 2))))/(9009*d**2*k1**2*(k2**2)**(3/2)) - D1**3*Pk1*ct**2*(33*b1**3*(D1*fd*s*(k1**2*(-7*Pk2*(5*r - 28*s)*np.sqrt(k2**2) - 130*Pkd2*k2**2*s + 14*Pkd2*k2*r*np.sqrt(k2**2) + 32*Pkdd2*s*(k2**2)**(3/2)) + r*(-21*Pk2 + 26*Pkd2*k2)*(k2**2)**(3/2)) + Dd*f*(k1**2*(7*Pk2*(r*(8 - 20*s) + s*(112*s - 31))*np.sqrt(k2**2) + 2*Pkd2*k2**2*(-7*r + s*(72 - 260*s)) + 14*Pkd2*k2*r*(4*s - 1)*np.sqrt(k2**2) + 32*Pkdd2*s*(4*s - 1)*(k2**2)**(3/2)) + (21*Pk2*s*(1 - 4*r) + 4*Pkd2*k2*r*(26*s - 5) - 6*Pkd2*k2*s)*(k2**2)**(3/2))) - 33*b1**2*(D1*(bd1*f*k1**2*(7*Pk2*(r*(15*s - 8) + s*(31 - 84*s))*np.sqrt(k2**2) + 2*Pkd2*k2**2*(7*r + 3*s*(65*s - 24)) + 14*Pkd2*k2*r*(1 - 3*s)*np.sqrt(k2**2) + 32*Pkdd2*s*(1 - 3*s)*(k2**2)**(3/2)) + bd1*f*(21*Pk2*s*(3*r - 1) + Pkd2*k2*(r*(20 - 78*s) + 6*s))*(k2**2)**(3/2) + fd*k1**2*(Pk2*(K*(-444*s**2 + 824*s - 412) + f*(r*(302*s - 24) - 416*s**2 - 297*s + 4) + 250*r*s - 210*r + 52*s**2 - 80*s + 20)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(-2*K*(54*s**2 - 98*s + 49) + f*(-196*s**2 + s*(56*r - 51) - 8) + 28*r*(s - 1) - 22*s**2 + 56*s - 28) - 4*Pkd2*k2*(f*r*(33*s - 14) + s*(5*r - 5))*np.sqrt(k2**2) - 4*Pkdd2*(2*f*(26*s**2 - 9*s + 3) + (K + 1)*(8*s**2 - 14*s + 7))*(k2**2)**(3/2)) + fd*(Pk2*(-8*K*(9*r**2 - 4*r + 2) + f*(-6*r*(33*s - 2) + 9*s + 16) + 72*r**2 + 58*r*s - 90*r + 16) + 4*Pkd2*k2*(2*f*(r*(7*s - 5) + 7*s) - r*s + s))*(k2**2)**(3/2)) + Dd*f*(-k1**2*(Pk2*(4*K*(444*s**2 - 523*s + 103) + f*(r*(356 - 604*s) + 832*s**2 + 139*s - 138) - 1000*r*s + 482*r - 208*s**2 + 540*s - 180)*np.sqrt(k2**2) + 4*Pkd2*k2**2*(K*(-216*s**2 + 250*s - 49) + f*(r*(56*s - 22) - 196*s**2 + 33*s + 6) + 56*r*s - 35*r - 44*s**2 + 60*s - 7) + 2*Pkd2*k2*(f*(4*r*(33*s - 17) - 21*s + 14) + r*(40*s - 26) - 88*s + 26)*np.sqrt(k2**2) + 4*Pkdd2*(4*s - 1)*(f*(26*s - 6) + (K + 1)*(8*s - 7))*(k2**2)**(3/2)) + (Pk2*(-8*K*(36*r**2 - 17*r + 2) + 3*f*(r*(8 - 132*s) + s + 6) + 288*r**2 + 232*r*s - 218*r - 8*s + 24) + 4*Pkd2*k2*(f*(2*r*(14*s - 5) + 15*s - 3) - 2*r*(2*s + 5) + 27*s - 4))*(k2**2)**(3/2))) + b1*(15048*D1*K*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) - 25212*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 8844*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 2640*D1*K*Pk2*f*fd*r**2*(k2**2)**(3/2) - 264*D1*K*Pk2*f*fd*r*(k2**2)**(3/2) - 528*D1*K*Pk2*f*fd*(k2**2)**(3/2) - 10560*D1*K*Pkd2*f*fd*k1**2*k2**2*s**2 + 16368*D1*K*Pkd2*f*fd*k1**2*k2**2*s - 5544*D1*K*Pkd2*f*fd*k1**2*k2**2 + 1584*D1*K*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) - 2376*D1*K*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) + 792*D1*K*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) + 6468*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) - 6468*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) + 2817*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 1188*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) - 46332*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) + 41070*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) - 6006*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 7776*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 17226*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) - 7758*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) - 18414*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) + 3834*D1*Pk2*f**2*fd*(k2**2)**(3/2) - 3564*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) + 3630*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 1320*D1*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) - 8844*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 3168*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 2640*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) - 396*D1*Pk2*f*fd*r*s*(k2**2)**(3/2) + 2574*D1*Pk2*f*fd*r*(k2**2)**(3/2) - 7128*D1*Pk2*f*fd*s*(k2**2)**(3/2) + 3036*D1*Pk2*f*fd*(k2**2)**(3/2) - 29304*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) + 27192*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) - 4752*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 1056*D1*Pk2*f*gd2*r*(k2**2)**(3/2) - 29304*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) + 54384*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) - 27192*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) - 4752*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 2112*D1*Pk2*fd*g2*r*(k2**2)**(3/2) - 1056*D1*Pk2*fd*g2*(k2**2)**(3/2) - 4290*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 + 4158*D1*Pkd2*bd2*f*k1**2*k2**2*s + 4680*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 20790*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 - 25452*D1*Pkd2*f**2*fd*k1**2*k2**2*s + 3960*D1*Pkd2*f**2*fd*k1**2*k2**2 + 10494*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 6336*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) - 1584*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) + 1056*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) - 2376*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) + 792*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) + 792*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) - 264*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) + 3696*D1*Pkd2*f*fd*k1**2*k2**2*r*s - 2904*D1*Pkd2*f*fd*k1**2*k2**2*r - 792*D1*Pkd2*f*fd*k1**2*k2**2*s**2 + 660*D1*Pkd2*f*fd*k1**2*k2**2*s + 396*D1*Pkd2*f*fd*k1**2*k2**2 + 528*D1*Pkd2*f*fd*k2**3*r*s*np.sqrt(k2**2) + 264*D1*Pkd2*f*fd*k2**3*r*np.sqrt(k2**2) + 528*D1*Pkd2*f*fd*k2**3*s*np.sqrt(k2**2) - 528*D1*Pkd2*f*fd*k2**3*np.sqrt(k2**2) + 14256*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 - 12936*D1*Pkd2*f*gd2*k1**2*k2**2*s + 14256*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 - 25872*D1*Pkd2*fd*g2*k1**2*k2**2*s + 12936*D1*Pkd2*fd*g2*k1**2*k2**2 + 1056*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) - 924*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 5940*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 2640*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 660*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) + 1584*D1*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) - 2376*D1*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) + 792*D1*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) - 2112*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) + 1848*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) - 2112*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) + 3696*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) - 1848*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) - 66*D1*bd1*f*(k1**2*(Pk2*(f*(r*(151*s - 166) - 208*s**2 + 79*s + 67) + 2*r*(125*s - 54) + 2*s**2*(26 - 222*K) + 2*s*(214*K - 84) + 80)*np.sqrt(k2**2) - Pkd2*k2**2*(-216*K*s**2 + 206*K*s + f*(r*(56*s - 44) - 196*s**2 + 117*s + 20) + 28*r*(2*s - 1) - 44*s**2 + 36*s + 14) + Pkd2*k2*(f*(-66*r*s + 40*r + 21*s - 14) + r*(26 - 20*s) + 52*s - 26)*np.sqrt(k2**2) + 2*Pkdd2*s*(f*(32 - 52*s) - (K + 1)*(16*s - 15))*(k2**2)**(3/2)) + (Pk2*(f*r*(6 - 99*s) - 3*f*s + f - r**2*(72*K - 72) + r*(44*K + 58*s - 52) - 4*s + 4) + 2*Pkd2*k2*(f*(14*r*s + s - 3) - r*(2*s + 3) + 15*s - 4))*(k2**2)**(3/2)) + 30096*Dd*K*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) - 42900*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 8844*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) + 5280*Dd*K*Pk2*f**2*r**2*(k2**2)**(3/2) + 792*Dd*K*Pk2*f**2*r*(k2**2)**(3/2) - 528*Dd*K*Pk2*f**2*(k2**2)**(3/2) - 21120*Dd*K*Pkd2*f**2*k1**2*k2**2*s**2 + 27456*Dd*K*Pkd2*f**2*k1**2*k2**2*s - 5544*Dd*K*Pkd2*f**2*k1**2*k2**2 + 3168*Dd*K*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) - 3960*Dd*K*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) + 792*Dd*K*Pkdd2*f**2*k1**2*(k2**2)**(3/2) + 3756*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 9216*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 61776*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) + 44329*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) - 9760*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 10368*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 22968*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) - 11592*Dd*Pk2*f**3*r*(k2**2)**(3/2) - 24750*Dd*Pk2*f**3*s*(k2**2)**(3/2) + 7002*Dd*Pk2*f**3*(k2**2)**(3/2) - 7128*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) + 7590*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 2640*Dd*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) - 19140*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 3168*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) - 5280*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) - 792*Dd*Pk2*f**2*r*s*(k2**2)**(3/2) + 4422*Dd*Pk2*f**2*r*(k2**2)**(3/2) - 15048*Dd*Pk2*f**2*s*(k2**2)**(3/2) + 3036*Dd*Pk2*f**2*(k2**2)**(3/2) - 117216*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) + 138072*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 27192*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) - 19008*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) + 8976*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 1056*Dd*Pk2*f*g2*(k2**2)**(3/2) + 6240*Dd*Pkd2*f**3*k1**2*k2**2*r*s - 1770*Dd*Pkd2*f**3*k1**2*k2**2*r + 27720*Dd*Pkd2*f**3*k1**2*k2**2*s**2 - 26240*Dd*Pkd2*f**3*k1**2*k2**2*s + 4880*Dd*Pkd2*f**3*k1**2*k2**2 + 13992*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 8778*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 3168*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) + 2112*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) - 3168*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) + 1056*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) + 792*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) - 264*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) + 7392*Dd*Pkd2*f**2*k1**2*k2**2*r*s - 5016*Dd*Pkd2*f**2*k1**2*k2**2*r - 1584*Dd*Pkd2*f**2*k1**2*k2**2*s**2 + 1980*Dd*Pkd2*f**2*k1**2*k2**2*s + 396*Dd*Pkd2*f**2*k1**2*k2**2 + 1056*Dd*Pkd2*f**2*k2**3*r*s*np.sqrt(k2**2) + 1320*Dd*Pkd2*f**2*k2**3*r*np.sqrt(k2**2) + 528*Dd*Pkd2*f**2*k2**3*s*np.sqrt(k2**2) - 528*Dd*Pkd2*f**2*k2**3*np.sqrt(k2**2) + 57024*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 - 66000*Dd*Pkd2*f*g2*k1**2*k2**2*s + 12936*Dd*Pkd2*f*g2*k1**2*k2**2 + 7920*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) - 4620*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) + 660*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) + 3168*Dd*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) - 3960*Dd*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) + 792*Dd*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 8448*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) + 9504*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) - 1848*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) + 66*b2*k1**2*(D1*fd*(98*Pk2*(s - 1)**2*np.sqrt(k2**2) + Pkd2*k2**2*(-65*s**2 + 126*s - 63) + 2*Pkdd2*(8*s**2 - 14*s + 7)*(k2**2)**(3/2)) + Dd*f*(4*s - 1)*(98*Pk2*(s - 1)*np.sqrt(k2**2) + Pkd2*k2**2*(63 - 65*s) + 2*Pkdd2*(8*s - 7)*(k2**2)**(3/2)))) + f*(4092*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) - 4620*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) + 528*D1*Pk2*bd2*f*r*(k2**2)**(3/2) + 11580*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 1780*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) - 53760*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) + 32085*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) - 5830*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 15048*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) + 17688*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) - 2640*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) - 1056*D1*Pk2*f*gd2*r*(k2**2)**(3/2) - 30096*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) + 50424*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) - 17688*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) - 5280*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 528*D1*Pk2*fd*g2*r*(k2**2)**(3/2) + 1056*D1*Pk2*fd*g2*(k2**2)**(3/2) - 2838*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 + 3102*D1*Pkd2*bd2*f*k1**2*k2**2*s + 29280*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 - 21960*D1*Pkd2*f**2*fd*k1**2*k2**2*s + 3660*D1*Pkd2*f**2*fd*k1**2*k2**2 + 6360*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 4240*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) - 1590*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) + 1060*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) + 10560*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 - 11088*D1*Pkd2*f*gd2*k1**2*k2**2*s + 21120*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 - 32736*D1*Pkd2*fd*g2*k1**2*k2**2*s + 11088*D1*Pkd2*fd*g2*k1**2*k2**2 + 792*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) - 792*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) - 1584*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) + 1584*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) - 3168*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) + 4752*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) - 1584*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + D1*bd1*(f**2*(k1**2*(Pk2*(r*(939*s + 8028) - 15444*s**2 + 3259*s - 3754)*np.sqrt(k2**2) + 2*Pkd2*k2**2*(780*r*s - 885*r + 3465*s**2 - 394*s + 460) + 66*Pkd2*k2*(53*r*s - 37*r - 24*s + 16)*np.sqrt(k2**2) + 1980*Pkdd2*s*(s - 1)*(k2**2)**(3/2)) - 6*(-3*Pk2*(144*r**2 + 319*r*s - 213*r - 352*s + 176) + 44*Pkd2*k2*r*(3*s - 1))*(k2**2)**(3/2)) + 66*f*(k1**2*(Pk2*(r*(30 - 27*s) + 2*s*(K*(57*s - 67) + 5*s - 39))*np.sqrt(k2**2) + 2*Pkd2*k2**2*(2*r*(7*s - 4) + s*(K*(42 - 40*s) - 3*s + 5)) + 2*Pkdd2*s*(6*K + 6)*(s - 1)*(k2**2)**(3/2)) + (Pk2*(r**2*(20*K - 20) + r*(8*K - 3*s + 14) - 60*s) + 4*Pkd2*k2*r*(s + 2))*(k2**2)**(3/2)) - 264*g2*(3*Pk2*(37*k1**2*s*(s - 1) + 6*k2**2*r*(r - 1))*np.sqrt(k2**2) - 2*k1**2*s*(s - 1)*(27*Pkd2*k2**2 - 4*Pkdd2*(k2**2)**(3/2)))) + 11580*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 1780*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 53760*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) + 32085*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) - 5830*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 60192*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) + 85800*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 17688*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) - 10560*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 1584*Dd*Pk2*f*g2*r*(k2**2)**(3/2) + 1056*Dd*Pk2*f*g2*(k2**2)**(3/2) + 29280*Dd*Pkd2*f**3*k1**2*k2**2*s**2 - 21960*Dd*Pkd2*f**3*k1**2*k2**2*s + 3660*Dd*Pkd2*f**3*k1**2*k2**2 + 6360*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 4240*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 1590*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) + 1060*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) + 42240*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 - 54912*Dd*Pkd2*f*g2*k1**2*k2**2*s + 11088*Dd*Pkd2*f*g2*k1**2*k2**2 - 6336*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) + 7920*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) - 1584*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) + 66*b2*(D1*(8*Pk2*fd*(2*r - 1)*(k2**2)**(3/2) + bd1*k1**2*s*(s - 1)*(98*Pk2*np.sqrt(k2**2) - 65*Pkd2*k2**2 + 16*Pkdd2*(k2**2)**(3/2)) + fd*k1**2*(2*s - 1)*(2*Pk2*(31*s - 35)*np.sqrt(k2**2) + Pkd2*k2**2*(47 - 43*s) + 12*Pkdd2*(s - 1)*(k2**2)**(3/2))) + Dd*f*(8*Pk2*(4*r - 1)*(k2**2)**(3/2) + k1**2*(4*s - 1)*(2*Pk2*(31*s - 35)*np.sqrt(k2**2) + Pkd2*k2**2*(47 - 43*s) + 12*Pkdd2*(s - 1)*(k2**2)**(3/2))))))/(693*d**2*k1**2*(k2**2)**(3/2)) + 4*D1**3*Pk1*ct**2*st**4*(D1*(66*b1**2*fd*k1**2*s**2*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(k2**2)**(3/2) - 33*b1*f*(-2*bd1*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*(k2**2)**(3/2) + fd*(-k1**4*s*(2*s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(-4*Pk2*(C*r*(7*s + 2) - 4*C*(1 - 2*s)**2 - 7*r*s - 2*r + 20*s**2 - 18*s + 4) + k2*(Pkd2*(4*C*r*(s + 1) - 10*C*(1 - 2*s)**2 - 4*r*(s + 1) + 50*s**2 - 45*s + 10) + Pkdd2*k2*(2*s - 1)*(C*(4*s - 2) - 5*s + 2)))*(k2**2)**(3/2) + 4*k2**4*r*(2*Pk2*(-r*(4*C - 4) - 2*s + 1)*np.sqrt(k2**2) + Pkd2*k2**2*(2*s - 1)))) + f**2*(-33*bd1*(-k1**4*s**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(-2*Pk2*(C*(r*(7*s + 6) - 16*s**2 + 9*s - 6) - r*(7*s + 6) + 20*s**2 - 9*s + 6) + k2*(Pkd2*(2*C*(r*(s + 2) - 10*s**2 + 6*s - 2) - 2*r*(s + 2) + 25*s**2 - 12*s + 4) + Pkdd2*k2*s*(C*(4*s - 2) - 5*s + 2)))*(k2**2)**(3/2) + 4*k2**4*r*(-2*Pk2*(2*C*(r - 1) - 2*r + s + 2)*np.sqrt(k2**2) + Pkd2*k2**2*s)) + fd*(k1**4*(1 - 3*s)**2*(12 - 2*C)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(4*Pk2*(4*C*(3*s - 1)*(36*r + 75*s - 37) - 621*r*s + 174*r - 180*s**2 + 327*s - 78) + k2*(-Pkd2*(2*C*(3*s - 1)*(72*r + 285*s - 119) - 621*r*s + 174*r + 90*s**2 + 147*s - 48) + Pkdd2*k2*(1 - 3*s)**2*(30*C + 10)))*(k2**2)**(3/2) + k2**4*(3*r - 1)*(2*Pk2*(26*C*(3*r - 1) - 78*r - 3*s + 16) + Pkd2*k2*(3*s + 10))*np.sqrt(k2**2)))) + Dd*f*(66*b1**2*k1**2*s*(C - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1)*(k2**2)**(3/2) - 33*b1*f*(-k1**4*s*(4*s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(-2*Pk2*(C*(4*r*(7*s + 4) - 64*s**2 + 49*s - 14) - 4*r*(7*s + 4) + 80*s**2 - 53*s + 14) + k2*(Pkd2*(2*C*(r*(4*s + 6) - 40*s**2 + 31*s - 7) - 4*r*(2*s + 3) + 100*s**2 - 67*s + 14) + Pkdd2*k2*(4*s - 1)*(C*(4*s - 2) - 5*s + 2)))*(k2**2)**(3/2) - 4*k2**4*r*(2*Pk2*(C*(8*r - 2) - 8*r + 4*s + 1)*np.sqrt(k2**2) + Pkd2*k2**2*(1 - 4*s))) + f**2*(k1**4*(12 - 2*C)*(12*s**2 - 7*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + k1**2*(4*Pk2*(4*C*(6*r*(24*s - 7) + 300*s**2 - 217*s + 37) - 828*r*s + 203*r - 240*s**2 + 376*s - 78) + k2*(-Pkd2*(2*C*(288*r*s - 84*r + 1140*s**2 - 749*s + 119) - 828*r*s + 203*r + 120*s**2 + 166*s - 48) + Pkdd2*k2*(30*C + 10)*(12*s**2 - 7*s + 1)))*(k2**2)**(3/2) + k2**4*(Pk2*(52*C*(12*r**2 - 7*r + 1) - 624*r**2 - 6*r*(4*s - 49) - 4*s - 32) + Pkd2*k2*(r*(12*s + 35) + 2*s - 10))*np.sqrt(k2**2))))/(231*d**2*k1**2*k3**2*(k2**2)**(3/2)) + 2*D1**3*Pk1*ct**2*st**2*(11*D1*bd1*f*(b1*(Pkd2*k1**4*k2**2*s*(10*C - 75)*(2*s - 1) - Pkd2*k1**2*k2**3*(2*r*(C*(74*s - 22) - 86*s + 25) + s*(C*(44*s - 52) + 6*s + 33))*np.sqrt(k2**2) + 14*Pkd2*k2**6*r*(1 - 2*s) + k1**2*(Pk2*k1**2*s*(120 - 16*C)*(2*s - 1) + k2**2*(4*Pk2*r*(C*(67*s - 22) - 79*s + 25) + 2*Pk2*s*(C*(48*s - 47) - 48*s + 53) - Pkdd2*k1**2*s*(2*C - 15)*(2*s - 1)))*np.sqrt(k2**2) + k2**4*(Pk2*r*(64*C - 64)*(2*r - 1) - Pkdd2*k1**2*s*(2*C - 27)*(2*s - 1))*np.sqrt(k2**2)) + f*(k1**4*(-2*Pk2*(r*(55*s - 23) - s**2*(136*C - 244) + s*(88*C - 153) + 23)*np.sqrt(k2**2) + Pkd2*k2**2*s*(C*(74 - 116*s) - 6*r + 116*s - 37) + Pkd2*k2*(2*r*(17*s - 6) - 25*s + 12)*np.sqrt(k2**2) + Pkdd2*s*(2*C*(8*s - 5) + 2*s - 5)*(k2**2)**(3/2)) - k1**2*(Pk2*(C*(24*r**2 + 308*r*s - 92*r + 720*s**2 - 458*s + 84) - 45*r**2 - 392*r*s + 85*r - 180*s**2 + 158*s - 60) + k2*(Pkd2*(2*C*(4*r*s - 2*r - 80*s**2 + 31*s - 2) - 24*r*s + 27*r - 116*s**2 + 93*s - 17) + Pkdd2*k2*s*(4*C*(s + 2) + 2*s + 1)))*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(32*C - 71) - 3*r*(8*C + 20*s - 23) + 12*s - 6)*np.sqrt(k2**2) + Pkd2*k2*(2*k2*r*(1 - 7*s) + (2*r*s + 3*r + 3*s - 3)*np.sqrt(k2**2))))) + 11*b1**2*(D1*fd*(Pkd2*k1**4*k2**2*s**2*(10*C - 75) - Pkd2*k1**2*k2**3*s*(r*(74*C - 86) + s*(22*C + 3))*np.sqrt(k2**2) - 14*Pkd2*k2**6*r*s + k1**2*s*(Pk2*k1**2*s*(120 - 16*C) + k2**2*(Pk2*r*(134*C - 158) + Pk2*s*(48*C - 48) + Pkdd2*k1**2*s*(15 - 2*C)))*np.sqrt(k2**2) + k2**4*(Pk2*r**2*(64*C - 64) + Pkdd2*k1**2*s**2*(27 - 2*C))*np.sqrt(k2**2)) + Dd*f*(Pkd2*k1**4*k2**2*s*(10*C - 75)*(4*s - 1) - Pkd2*k1**2*k2**3*(r*(4*C*(74*s - 11) - 344*s + 50) + s*(C*(88*s - 52) + 12*s + 33))*np.sqrt(k2**2) + 14*Pkd2*k2**6*r*(1 - 4*s) + k1**2*(Pk2*k1**2*s*(120 - 16*C)*(4*s - 1) + k2**2*(2*Pk2*(r*(268*C*s - 44*C - 316*s + 50) + s*(96*C*s - 47*C - 96*s + 53)) - Pkdd2*k1**2*s*(2*C - 15)*(4*s - 1)))*np.sqrt(k2**2) + k2**4*(Pk2*r*(64*C - 64)*(4*r - 1) - Pkdd2*k1**2*s*(2*C - 27)*(4*s - 1))*np.sqrt(k2**2))) + 11*b1*f*(D1*fd*(k1**4*(4*Pk2*(4*C*(34*s**2 - 45*s + 13) - 55*r*s + 26*r - 244*s**2 + 304*s - 78)*np.sqrt(k2**2) + Pkd2*k2**2*(C*(-232*s**2 + 324*s - 94) - 12*r*s + 6*r + 232*s**2 - 385*s + 102) + Pkd2*k2*r*(68*s - 33)*np.sqrt(k2**2) + Pkdd2*(2*C*(16*s**2 - 24*s + 7) + 4*s**2 + 27*s - 8)*(k2**2)**(3/2)) + k1**2*(-2*Pk2*(C*(24*r**2 + 44*r*(7*s - 5) + 720*s**2 - 751*s + 198) - 45*r**2 - 392*r*s + 272*r - 180*s**2 + 215*s - 70) + k2*(Pkd2*(2*C*(-2*r*(4*s + 9) + 160*s**2 - 197*s + 54) + 48*r*s + 25*r + 232*s**2 - 210*s + 38) - Pkdd2*k2*(4*C*(2*s**2 - 12*s + 3) + 4*s**2 - 21*s + 6)))*(k2**2)**(3/2) + k2**4*(2*Pk2*(4*C*(8*r**2 - 10*r + 3) - 71*r**2 - 60*r*s + 67*r + 3*s - 12)*np.sqrt(k2**2) + Pkd2*k2*(-4*k2*r*(7*s - 3) + s*(4*r + 1)*np.sqrt(k2**2)))) + Dd*f*(k1**4*(2*Pk2*(8*C*(68*s**2 - 69*s + 13) + r*(98 - 220*s) - 976*s**2 + 917*s - 179)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(4*s - 1)*(C*(58*s - 47) + 3*r - 58*s + 51) + Pkd2*k2*(r*(136*s - 57) - 25*s + 12)*np.sqrt(k2**2) + 2*Pkdd2*(4*s - 1)*(C*(8*s - 7) + s + 4)*(k2**2)**(3/2)) - k1**2*(Pk2*(96*C*r**2 + 8*C*r*(154*s - 79) + 60*C*(48*s**2 - 39*s + 8) - 180*r**2 + r*(699 - 1568*s) - 720*s**2 + 718*s - 200) + k2*(Pkd2*(4*C*(8*r*s + 11*r - 160*s**2 + 139*s - 28) - 96*r*s + 14*r - 464*s**2 + 346*s - 55) + Pkdd2*k2*(4*C + 2)*(4*s**2 - 13*s + 3)))*(k2**2)**(3/2) + k2**4*(Pk2*(8*C*(16*r**2 - 16*r + 3) - 284*r**2 - 240*r*s + 233*r + 18*s - 30)*np.sqrt(k2**2) + Pkd2*k2*(14*k2*r*(1 - 4*s) + (8*r*s + 3*r + 7*s - 3)*np.sqrt(k2**2))))) - f**2*(D1*fd*(Pk2*k2**4*(-8*C*(1 - 3*r)**2 + 1449*r**2 + 9*r*(70*s - 171) - 540*s + 462)*np.sqrt(k2**2) + 132*Pkd2*k2**6*r*(3*s - 1) + k1**4*(-4*Pk2*(4*C*(537*s**2 - 512*s + 111) + r*(319 - 561*s) - 3930*s**2 + 3632*s - 818)*np.sqrt(k2**2) + Pkd2*k2**2*(3*s - 1)*(2*C*(643*s - 405) + 110*r - 1673*s + 994) - 11*Pkd2*k2*(42*r*(2*s - 1) - 13*s + 9)*np.sqrt(k2**2) - Pkdd2*(3*s - 1)*(2*C*(95*s - 61) - 121*s + 88)*(k2**2)**(3/2)) + k1**2*(Pk2*(-2*C*(372*r**2 - 4545*r*s + 2114*r - 6444*s**2 + 5481*s - 1352) + 1833*r**2 - 9894*r*s + 2175*r + 216*s**2 + 998*s - 186) + k2*(-Pkd2*(2*C*(1053*r*s - 714*r + 3168*s**2 - 2397*s + 568) - 2682*r*s + 1180*r + 1305*s**2 - 724*s + 1) + 33*Pkdd2*k2*(3*s - 1)*(C*(8*s - 4) + 3*s - 2)))*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(-8*C*(12*r**2 - 7*r + 1) + 1932*r**2 + r*(840*s - 1801) - 740*s + 462)*np.sqrt(k2**2) + 132*Pkd2*k2**6*r*(4*s - 1) + k1**4*(-4*Pk2*(4*C*(716*s**2 - 623*s + 111) + r*(440 - 748*s) - 5240*s**2 + 4329*s - 818)*np.sqrt(k2**2) + Pkd2*k2**2*(4*s - 1)*(2*C*(643*s - 405) + 110*r - 1673*s + 994) - 11*Pkd2*k2*(2*r*(56*s - 27) - 10*s + 9)*np.sqrt(k2**2) - Pkdd2*(4*s - 1)*(2*C*(95*s - 61) - 121*s + 88)*(k2**2)**(3/2)) + k1**2*(Pk2*(-2*C*(496*r**2 - 6060*r*s + 2844*r - 8592*s**2 + 6103*s - 1352) + 2444*r**2 - 13192*r*s + 2411*r + 288*s**2 + 948*s - 186) + k2*(-Pkd2*(2*C*(12*r*(117*s - 85) + 4224*s**2 - 2659*s + 568) - 3576*r*s + 1384*r + 1740*s**2 - 929*s + 1) + 33*Pkdd2*k2*(4*s - 1)*(C*(8*s - 4) + 3*s - 2)))*(k2**2)**(3/2))))/(231*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 2*D1**3*Pk1*ct**2*(33*D1*bd1*f*(2*b1*(Pk2*k2**4*(r**2*(56*C - 33) + r*(-28*C - 29*s + 15) + 16*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*(-r + s) + k1**4*(2*Pk2*(-3*r*(6*s - 5) + 2*s*(C*(8*s - 4) + 16*s - 11))*np.sqrt(k2**2) - Pkd2*k2**2*s*(10*C + 23)*(2*s - 1) + 3*Pkd2*k2*(r*(6*s - 5) + 2*s)*np.sqrt(k2**2) + Pkdd2*s*(2*C + 7)*(2*s - 1)*(k2**2)**(3/2)) + k1**2*(Pk2*(r**2*(15 - 8*C) + r*(88*C*s - 32*C - 179*s + 53) + s*(76*C*s - 46*C - 76*s + 67)) + k2*(Pkd2*r*(s*(94 - 28*C) - 48) + Pkd2*s*(C*(56 - 84*s) + 64*s - 31) + Pkdd2*k2*s*(14*C + 7)*(2*s - 1)))*(k2**2)**(3/2)) + f*(Pk2*k2**4*(r**2*(40*C - 38) + r*(16*C + 79*s - 8) - 60*s + 60)*np.sqrt(k2**2) + 4*Pkd2*k2**6*r*(s - 3) + k1**4*(Pk2*(r*(162 - 151*s) + s**2*(292*C - 338) + s*(416 - 332*C) - 118)*np.sqrt(k2**2) + 2*Pkd2*k2**2*(r*(26*s - 20) + s**2*(97 - 100*C) + s*(104*C - 98) + 20) + 2*Pkd2*k2*(26*r*s - 22*r - 11*s + 11)*np.sqrt(k2**2) + 2*Pkdd2*s*(16*C + 6)*(s - 1)*(k2**2)**(3/2)) + 2*k1**2*(Pk2*(-C*(88*r**2 + 219*r*s - 142*r + 10*s**2 - 139*s + 122) + 183*r**2 + 373*r*s - 237*r + 37*s**2 - 184*s + 155) + k2*(Pkd2*(C*(40*r*s - 60*r + 46*s**2 - 89*s + 68) + 88*r*s - 56*r + 105*s**2 - 103*s + 17) + Pkdd2*k2*s*(12*C + 6)*(s - 1)))*(k2**2)**(3/2))) + 33*b1**2*(D1*fd*(-Pkd2*k1**4*k2**2*s**2*(20*C + 46) + 18*Pkd2*k1**4*k2*r*s*np.sqrt(k2**2) + 2*Pkd2*k1**2*k2**3*s*(r*(47 - 14*C) + s*(32 - 42*C))*np.sqrt(k2**2) + k1**2*(4*Pk2*k1**2*s*(-9*r + s*(8*C + 16)) + k2**2*(Pk2*(r**2*(15 - 8*C) + r*s*(88*C - 179) + s**2*(76*C - 76)) + Pkdd2*k1**2*s**2*(4*C + 14)))*np.sqrt(k2**2) + k2**4*(Pk2*r*(r*(56*C - 33) - 29*s) + Pkdd2*k1**2*s**2*(28*C + 14))*np.sqrt(k2**2)) + 2*Dd*f*(Pk2*k2**4*(r**2*(112*C - 66) + r*(-28*C - 58*s + 15) + 16*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*(-r + s) + k1**4*(-2*Pk2*(3*r*(12*s - 5) + 2*s*(-16*C*s + 4*C - 32*s + 11))*np.sqrt(k2**2) - Pkd2*k2**2*s*(10*C + 23)*(4*s - 1) + 3*Pkd2*k2*(12*r*s - 5*r + 2*s)*np.sqrt(k2**2) + Pkdd2*s*(2*C + 7)*(4*s - 1)*(k2**2)**(3/2)) + k1**2*(Pk2*(r**2*(30 - 16*C) + r*(176*C*s - 32*C - 358*s + 53) + s*(152*C*s - 46*C - 152*s + 67)) + k2*(-4*Pkd2*r*(s*(14*C - 47) + 12) + Pkd2*s*(-56*C*(3*s - 1) + 128*s - 31) + Pkdd2*k2*s*(14*C + 7)*(4*s - 1)))*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(Pk2*k2**4*(8*C*(10*r**2 - r - 2) - 76*r**2 + r*(158*s - 89) - 88*s + 8)*np.sqrt(k2**2) + 8*Pkd2*k2**6*s*(r + 1) + k1**4*(Pk2*(4*C*(146*s**2 - 191*s + 67) - 302*r*s + 123*r - 676*s**2 + 934*s - 264)*np.sqrt(k2**2) + 2*Pkd2*k2**2*(-4*C*(50*s**2 - 62*s + 21) + 52*r*s - 46*r + 194*s**2 - 244*s + 75) + 52*Pkd2*k2*s*(2*r - 1)*np.sqrt(k2**2) + 8*Pkdd2*(C*(8*s**2 - 9*s + 3) + 3*s**2)*(k2**2)**(3/2)) + 2*k1**2*(Pk2*(-2*C*(88*r**2 + 3*r*(73*s - 54) + 10*s**2 - 96*s + 19) + 366*r**2 + r*(746*s - 575) + 74*s**2 - 326*s + 88) + k2*(Pkd2*(C*(8*r*(10*s - 7) + 92*s**2 - 202*s + 39) + 22*r*(8*s - 1) + 210*s**2 - 177*s + 38) + Pkdd2*k2*s**2*(24*C + 12)))*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(8*C*(20*r**2 + 3*r - 2) - 152*r**2 + r*(316*s - 105) - 208*s + 68)*np.sqrt(k2**2) + 4*Pkd2*k2**6*(r*(4*s - 3) + 2*s) + k1**4*(Pk2*(4*C*(292*s**2 - 341*s + 67) - 604*r*s + 359*r - 1352*s**2 + 1658*s - 382)*np.sqrt(k2**2) + 2*Pkd2*k2**2*(C*(-400*s**2 + 436*s - 84) + 104*r*s - 86*r + 388*s**2 - 417*s + 95) + 2*Pkd2*k2*(2*r*(52*s - 11) - 48*s + 11)*np.sqrt(k2**2) + 4*Pkdd2*(4*s - 1)*(C*(8*s - 6) + 3*s)*(k2**2)**(3/2)) + 2*k1**2*(Pk2*(-C*(352*r**2 + 876*r*s - 512*r + 40*s**2 - 445*s + 160) + 732*r**2 + 1492*r*s - 891*r + 148*s**2 - 674*s + 243) + k2*(Pkd2*(C*(16*r*(10*s - 9) + 184*s**2 - 370*s + 107) + 352*r*s - 86*r + 420*s**2 - 327*s + 55) + Pkdd2*k2*s*(12*C + 6)*(4*s - 1)))*(k2**2)**(3/2))) + f**2*(D1*fd*(-297*Pk2*k2**4*r*(7*r - 22*s + 5)*np.sqrt(k2**2) + k1**4*(660*C*Pkdd2*(3*s**2 - 4*s + 1)*(k2**2)**(3/2) + Pk2*(4*C*(3609*s**2 - 6696*s + 1831) + 477*r*s + 4461*r - 20970*s**2 + 24546*s - 7392)*np.sqrt(k2**2) + 66*Pkd2*k2**2*(-2*C*(93*s**2 - 136*s + 35) + 72*r*s - 62*r + 237*s**2 - 287*s + 82)) + k1**2*(Pk2*(2*C*(3204*r**2 - 9*r*(495*s + 274) + 1188*s**2 - 12573*s + 5020) + 9405*r**2 + 819*r*(61*s - 24) + 4158*s**2 - 7842*s + 2108) + 66*Pkd2*k2*(C*(48*r*(3*s - 2) + 198*s**2 - 213*s + 65) + r*(42*s - 32) + 144*s**2 - 153*s + 41))*(k2**2)**(3/2)) + Dd*f*(-99*Pk2*k2**4*r*(28*r - 88*s + 15)*np.sqrt(k2**2) + k1**4*(660*C*Pkdd2*(4*s**2 - 5*s + 1)*(k2**2)**(3/2) + Pk2*(4*C*(4812*s**2 - 8527*s + 1831) + 636*r*s + 6673*r - 27960*s**2 + 29726*s - 7392)*np.sqrt(k2**2) + 66*Pkd2*k2**2*(C*(-248*s**2 + 342*s - 70) + 96*r*s - 81*r + 316*s**2 - 350*s + 82)) + 2*k1**2*(Pk2*(C*(4272*r**2 - 4*r*(1485*s + 832) + 1584*s**2 - 16731*s + 5020) + 6270*r**2 + 33306*r*s - 9794*r + 2772*s**2 - 5009*s + 1054) + 33*Pkd2*k2*(C*(64*r*(3*s - 2) + 264*s**2 - 246*s + 65) + 56*r*s - 41*r + 192*s**2 - 185*s + 41))*(k2**2)**(3/2))))/(693*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 8*D1**3*Pk1*ct**2*st**4*(66*b1**2*k1**2*(C - 1)*(2*D1*fd*s*(-2*Pk2*k2**2*(r + s) + Pkd2*k2**3*r + Pkd2*s*(k2**2)**(3/2)) + Dd*f*(-2*Pk2*k2**2*(r*(8*s - 1) + s*(8*s - 3)) + Pkd2*k2**3*(r*(8*s - 1) - s) + 2*Pkd2*s*(4*s - 1)*(k2**2)**(3/2))) + 33*b1*f*(D1*(2*bd1*k1**2*(C - 1)*(2*Pk2*k2**2*(-4*r*s + r + s*(3 - 4*s)) + Pkd2*k2**3*(r*(4*s - 1) - s) + 2*Pkd2*s*(2*s - 1)*(k2**2)**(3/2)) + fd*(-4*Pk2*k2**4*r*(2*r + 2*s - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(C*(4*s - 2) - 12*s + 5) + (2*s - 1)*(s*(2*C - 6) + 1)) + k1**2*(-2*Pk2*k2**2*(2*C*(8*r**2 + r - 2*(1 - 2*s)**2) - 16*r**2 + r*(8*s - 5) + 24*s**2 - 22*s + 5) + Pkd2*k2**3*(4*s - 1)*(r + 2*s - 1) - 2*Pkd2*(2*s - 1)*(C*(4*r + 4*s - 2) - 5*r - 4*s + 2)*(k2**2)**(3/2)))) + Dd*f*(-8*Pk2*k2**4*r*(2*r + 2*s - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(C*(8*s - 2) - 24*s + 5) + s**2*(8*C - 24) + s*(11 - 2*C) - 1) + k1**2*(-2*Pk2*k2**2*(2*C*(16*r**2 - 5*r - 16*s**2 + 9*s - 1) - 32*r**2 + 16*r*s + 7*r + 48*s**2 - 27*s + 3) + Pkd2*k2**3*(r*(8*s - 1) + 16*s**2 - 9*s + 1) + 2*Pkd2*(-C*(8*s - 3)*(2*r + 2*s - 1) + 20*r*s - 7*r + 16*s**2 - 14*s + 3)*(k2**2)**(3/2)))) + f**2*(D1*(-66*bd1*(2*Pk2*k2**4*r*(r + s - 1) - k1**4*s*(4*Pk2 - Pkd2*k2)*(r*(C - 3) + s*(C - 3) + 1) + k1**2*(2*Pk2*k2**2*(C*(4*r**2 - 5*r - 4*s**2 - s + 1) - 4*r**2 + r*(2*s + 5) + 6*s**2 - 1) - Pkd2*k2**3*s*(r + 2*s - 1) + Pkd2*(C*(r*(4*s - 1) + (1 - 2*s)**2) - 5*r*s + r - (1 - 2*s)**2)*(k2**2)**(3/2))) + fd*(Pk2*k2**4*(3*r - 1)*(3*r + 3*s - 13) + k1**4*(12*C - 42)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + k1**2*(60*C*Pkd2*(1 - 3*s)**2*(k2**2)**(3/2) - Pk2*k2**2*(2*C*(423*r**2 + 1143*r*s - 696*r + 720*s**2 - 861*s + 265) - 1035*r**2 - 855*r*s + 1074*r + 180*s**2 + 165*s - 223) + 30*Pkd2*k2**3*(3*s - 1)*(C*(6*r - 2) + 3*r + 3*s - 2)))) + Dd*f*(Pk2*k2**4*(12*r**2 + 12*r*(s - 5) + 2*s + 13) + k1**4*(6*C - 21)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + k1**2*(60*C*Pkd2*(12*s**2 - 7*s + 1)*(k2**2)**(3/2) - Pk2*k2**2*(2*C*(564*r**2 + 1524*r*s - 823*r + 960*s**2 - 999*s + 265) - 1380*r**2 - 1140*r*s + 1286*r + 240*s**2 + 176*s - 223) + 15*Pkd2*k2**3*(2*C*(24*r*s - 7*r - 7*s + 2) + 24*r*s - 7*r + 24*s**2 - 21*s + 4)))))/(231*d**2*k1**2*k3**4) + 4*D1**3*Pk1*ct**2*st**2*(33*D1*bd1*f*(b1*(28*Pk2*k2**6*r*(r + s - 1)*np.sqrt(k2**2) + k1**4*(-2*Pk2 + Pkd2*k2)*(r*(4*C*(13*s - 5) - 130*s + 43) + s*(4*C*(13*s - 8) - 130*s + 87))*(k2**2)**(3/2) + k1**2*k2**4*(6*Pk2*(r**2*(44*C - 48) + r*(4*C*(13*s - 7) - 56*s + 31) + s*(8*C*(s - 3) - 8*s + 25))*np.sqrt(k2**2) + Pkd2*k2*(k2*(7*r*(8*C*s - 2*C - 10*s + 3) + 2*s*(4*C*s - 9*C - 28*s + 21)) + (-r*(12*C + 16)*(4*s - 1) + s*(12*C - 78*s + 55))*np.sqrt(k2**2)))) + f*(Pk2*k2**6*(14*r**2 + r*(14*s - 15) - 3*s + 3)*np.sqrt(k2**2) + k1**6*(4*Pk2*(7*s - 3)*(r + s - 1)*np.sqrt(k2**2) + Pkd2*k2*(k2*r*s + k2*s*(5 - 7*s) + r*(3 - 8*s)*np.sqrt(k2**2) + (5*s - 3)*np.sqrt(k2**2))) + k1**4*(Pk2*(4*C*(9*r**2 + 89*r*s - 35*r + 80*s**2 - 88*s + 28) - 116*r**2 - 390*r*s + 183*r - 274*s**2 + 245*s - 89) + Pkd2*k2*(-4*C*(22*r*s - 9*r + 22*s**2 - 29*s + 10) - 16*r*s + 5*r - 16*s**2 + 13*s + 6))*(k2**2)**(3/2) + k1**2*k2**4*(-2*Pk2*(2*C*(15*r**2 + r*(54*s - 22) + 39*s**2 - 30*s + 8) + 6*r**2 + r*(99*s - 23) + 93*s**2 - 75*s + 17)*np.sqrt(k2**2) + Pkd2*k2*(k2*(r*(C*(2 - 4*s) + 11*s - 6) + s**2*(8*C + 4) + s*(16*C - 10) + 3) + (6*C*(2*r*s + r - 3*s + 1) + r*(6 - 8*s) - s**2 + 5*s + 2)*np.sqrt(k2**2))))) + 33*b1**2*(D1*fd*(14*Pk2*k2**6*r*(r + s)*np.sqrt(k2**2) + k1**4*s*(26*C - 65)*(-2*Pk2 + Pkd2*k2)*(r + s)*(k2**2)**(3/2) - k1**2*k2**4*(-12*Pk2*(r + s)*(r*(11*C - 12) + s*(2*C - 2))*np.sqrt(k2**2) + Pkd2*k2*s*(k2*(r*(35 - 28*C) - s*(4*C - 28)) + (r*(24*C + 32) + 39*s)*np.sqrt(k2**2)))) + Dd*f*(28*Pk2*k2**6*r*(2*r + 2*s - 1)*np.sqrt(k2**2) + k1**4*(-2*Pk2 + Pkd2*k2)*(r*(4*C*(26*s - 5) - 260*s + 43) + s*(8*C*(13*s - 4) - 260*s + 87))*(k2**2)**(3/2) + k1**2*k2**4*(6*Pk2*(r**2*(88*C - 96) + r*(4*C*(26*s - 7) - 112*s + 31) + s*(8*C*(2*s - 3) - 16*s + 25))*np.sqrt(k2**2) + Pkd2*k2*(k2*(7*r*(16*C*s - 2*C - 20*s + 3) + 2*s*(8*C*s - 9*C - 56*s + 21)) + (-r*(12*C + 16)*(8*s - 1) + s*(12*C - 156*s + 55))*np.sqrt(k2**2))))) + 33*b1*f*(D1*fd*(Pk2*k2**6*(28*r**2 + 2*r*(14*s - 5) - 3*s - 2)*np.sqrt(k2**2) + k1**6*(4*Pk2*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5)*np.sqrt(k2**2) + Pkd2*k2*(k2*(2*s - 1)*(r - 7*s + 5) + r*(9 - 16*s)*np.sqrt(k2**2))) - k1**4*(Pk2*(-4*C*(18*r**2 + 2*r*(89*s - 54) + 160*s**2 - 181*s + 50) + 232*r**2 + 780*r*s - 509*r + 548*s**2 - 632*s + 174) + Pkd2*k2*(2*C*(88*r*s - 61*r + 88*s**2 - 113*s + 34) + 32*r*s + 33*r + 32*s**2 + 25*s - 18))*(k2**2)**(3/2) - k1**2*k2**4*(Pk2*(4*C*(30*r**2 + 4*r*(27*s - 13) + 78*s**2 - 73*s + 15) + 24*r**2 + r*(396*s - 247) + 372*s**2 - 385*s + 110)*np.sqrt(k2**2) + Pkd2*k2*(2*C*k2*(-8*s**2 + s*(4*r + 47) - 12) - 6*C*(4*r*(s - 2) + 5*s)*np.sqrt(k2**2) + k2*(r*(6 - 22*s) + s*(2 - 8*s)) + (r*(16*s + 21) + 2*s**2 + 32*s - 15)*np.sqrt(k2**2)))) + Dd*f*(Pk2*k2**6*(56*r**2 + r*(56*s - 23) - 9*s + 1)*np.sqrt(k2**2) + k1**6*(8*Pk2*(14*r*s - 7*r + 14*s**2 - 16*s + 4)*np.sqrt(k2**2) + Pkd2*k2*(k2*(4*s - 1)*(r - 7*s + 5) + (r*(15 - 32*s) + 5*s - 3)*np.sqrt(k2**2))) - k1**4*(Pk2*(-8*C*(18*r**2 + 178*r*s - 86*r + 160*s**2 - 159*s + 39) + 464*r**2 + 1560*r*s - 793*r + 1096*s**2 - 1039*s + 263) + 4*Pkd2*k2*(C*(88*r*s - 50*r + 88*s**2 - 102*s + 27) + 16*r*s + 10*r + 16*s**2 + 6*s - 6))*(k2**2)**(3/2) - k1**2*k2**4*(4*Pk2*(C*(60*r**2 + r*(216*s - 79) + 156*s**2 - 121*s + 23) + 12*r**2 + 3*r*(66*s - 29) + 186*s**2 - 156*s + 36)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-2*C*(-8*r*s + r + 16*s**2 - 51*s + 12) - 44*r*s + 15*r - 16*s**2 + 12*s - 3) + (-6*C*(8*r*s - 9*r + 3*s + 1) + 32*r*s + 21*r + 4*s**2 + 38*s - 17)*np.sqrt(k2**2))))) + f**2*(D1*fd*(396*Pk2*k2**6*r*(3*r + 3*s - 2)*np.sqrt(k2**2) - 3*k1**6*(-4*Pk2*(r*(153*s - 73) + 153*s**2 - 197*s + 56)*np.sqrt(k2**2) + Pkd2*k2*(-k2*(3*s - 1)*(11*r - 51*s + 39) + (186*r*s - 84*r - 29*s + 17)*np.sqrt(k2**2))) + k1**4*(Pk2*(4*C*(351*r**2 + 5571*r*s - 3147*r + 5220*s**2 - 6492*s + 1975) - 3978*r**2 - 23400*r*s + 13191*r - 19422*s**2 + 22959*s - 6850) + 3*Pkd2*k2*(-2*C*(1281*r*s - 647*r + 1281*s**2 - 1545*s + 446) + (323*s - 181)*(3*r + 3*s - 2)))*(k2**2)**(3/2) + 3*k1**2*k2**4*(-Pk2*(8*C*(234*r**2 + r*(927*s - 300) + 693*s**2 - 540*s + 74) - 3426*r**2 - 3*r*(638*s - 655) + 1512*s**2 - 1349*s + 220)*np.sqrt(k2**2) + 33*Pkd2*k2*(k2*(2*s - 1)*(8*C*(3*s - 1) + 3*r - 1) + (4*C*(r*(12*s - 5) - 2*s + 1) + (2*s - 1)*(9*r + 12*s - 7))*np.sqrt(k2**2)))) + Dd*f*(792*Pk2*k2**6*r*(2*r + 2*s - 1)*np.sqrt(k2**2) - 3*k1**6*(-8*Pk2*(102*r*s - 49*r + 102*s**2 - 114*s + 28)*np.sqrt(k2**2) + Pkd2*k2*(-k2*(4*s - 1)*(11*r - 51*s + 39) + (248*r*s - 109*r - 21*s + 17)*np.sqrt(k2**2))) + k1**4*(2*Pk2*(2*C*(468*r**2 + 7428*r*s - 3897*r + 6960*s**2 - 7717*s + 1975) - 2652*r**2 - 15600*r*s + 7725*r - 12948*s**2 + 13775*s - 3425) - 3*Pkd2*k2*(4*C*(854*r*s - 415*r + 854*s**2 - 904*s + 223) - 1292*r*s + 683*r - 1292*s**2 + 1411*s - 362))*(k2**2)**(3/2) + 3*k1**2*k2**4*(-4*Pk2*(2*C*(312*r**2 + r*(1236*s - 317) + 924*s**2 - 597*s + 74) - 1142*r**2 + r*(525 - 638*s) + 504*s**2 - 426*s + 55)*np.sqrt(k2**2) + 33*Pkd2*k2*(k2*(2*s - 1)*(8*C*(4*s - 1) + 4*r - 1) + (4*C*(16*r*s - 6*r - 2*s + 1) + 24*r*s - 11*r + 32*s**2 - 31*s + 7)*np.sqrt(k2**2))))))/(693*d**2*k1**2*k3**4*(k2**2)**(3/2)) + 8*D1**3*Pk1*ct**2*(33*D1*bd1*f*(-b1*(7*Pk2*k2**6*(r - s)*np.sqrt(k2**2) + k1**6*(2*Pk2*(r*(4*s - 1) + s*(4*s - 3))*np.sqrt(k2**2) + Pkd2*k2*(r*(1 - 4*s)*np.sqrt(k2**2) + s*(-4*k2*s + 2*k2 + np.sqrt(k2**2)))) + k1**4*(Pk2*(r**2*(28*C - 54) + r*(8*C*(6*s - 5) - 16*s + 45) + s*(4*C*(5*s - 2) + 38*s - 29)) + 2*Pkd2*k2*(r*(16*C*s + 3*C - 37*s + 4) + s*(16*C*s - 19*C - 37*s + 33)))*(k2**2)**(3/2) + k1**2*k2**4*(4*Pk2*(r**2*(28*C - 39) + r*(7*C*(6*s - 5) - 63*s + 44) + s*(7*C*(2*s - 1) - 24*s + 19))*np.sqrt(k2**2) - 7*Pkd2*k2*(2*C*r*(4*s - 1)*np.sqrt(k2**2) + 2*k2*r*s + k2*s*(C*(8*s - 4) - 1) + r*(4*s - 1)*np.sqrt(k2**2) - 2*s*(C - 3*s + 2)*np.sqrt(k2**2)))) + f*(Pk2*k2**6*r*(r + s - 6)*np.sqrt(k2**2) + k1**6*(Pk2*(r*(15 - 13*s) - 13*s**2 + 29*s - 13)*np.sqrt(k2**2) + Pkd2*k2*(2*k2*(s - 1)*(3*r + 5*s - 3) + (r*(4*s - 2) - s + 1)*np.sqrt(k2**2))) + k1**4*(Pk2*(-2*C*(19*r**2 + 71*r*s - 41*r + 52*s**2 - 74*s + 16) + 168*r**2 + 323*r*s - 258*r + 155*s**2 - 229*s + 96) + Pkd2*k2*(6*C*(10*r*s - 8*r + 10*s**2 - 17*s + 7) + 40*r*s - 14*r + 40*s**2 - 47*s + 7))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(C*(33*r**2 + r*(91*s - 103) + 58*s**2 - 122*s + 90) + 140*r**2 + 2*r*(135*s - 98) + 130*s**2 - 152*s + 41)*np.sqrt(k2**2) + 6*Pkd2*k2*(r*(2*C*(2*s - 1)*np.sqrt(k2**2) + k2*s + (2*s - 1)*np.sqrt(k2**2)) + s*(s - 1)*(4*C*k2 + 3*np.sqrt(k2**2)))))) - 33*b1**2*(-D1*fd*k1**2*(-Pk2*k1**2*(r + s)*(4*k1**2*s + k2**2*(r*(14*C - 27) + s*(10*C + 19)))*np.sqrt(k2**2) - 2*Pk2*k2**4*(r + s)*(r*(28*C - 39) + s*(14*C - 24))*np.sqrt(k2**2) + 2*Pkd2*k1**4*k2**2*s**2 + 2*Pkd2*k1**4*k2*r*s*np.sqrt(k2**2) - Pkd2*k1**2*k2**3*s*(16*C - 37)*(r + s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*s*(4*C*s + r) + 7*Pkd2*k2**5*s*(r*(4*C + 2) + 3*s)*np.sqrt(k2**2)) + Dd*f*(7*Pk2*k2**6*(r - s)*np.sqrt(k2**2) + k1**6*(2*Pk2*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2) + Pkd2*k2*(r*(1 - 8*s)*np.sqrt(k2**2) + s*(-8*k2*s + 2*k2 + np.sqrt(k2**2)))) + k1**4*(Pk2*(r**2*(56*C - 108) + r*(96*C*s - 40*C - 32*s + 45) + s*(40*C*s - 8*C + 76*s - 29)) + 2*Pkd2*k2*(r*(32*C*s + 3*C - 74*s + 4) + s*(32*C*s - 19*C - 74*s + 33)))*(k2**2)**(3/2) + k1**2*k2**4*(4*Pk2*(r**2*(56*C - 78) + r*(7*C*(12*s - 5) - 126*s + 44) + s*(7*C*(4*s - 1) - 48*s + 19))*np.sqrt(k2**2) - 7*Pkd2*k2*(2*C*r*(8*s - 1)*np.sqrt(k2**2) + 4*k2*r*s + k2*s*(4*C*(4*s - 1) - 1) + r*(8*s - 1)*np.sqrt(k2**2) - 2*s*(C - 6*s + 2)*np.sqrt(k2**2))))) + 33*b1*f*(D1*fd*(Pk2*k2**6*(2*r**2 + r*(2*s - 1) + 5*s)*np.sqrt(k2**2) + k1**6*(Pk2*(r*(17 - 26*s) - 26*s**2 + 31*s - 9)*np.sqrt(k2**2) + 2*Pkd2*k2*(k2*(6*r*(s - 1) + 10*s**2 - 9*s + 3) + 2*s*(2*r - 1)*np.sqrt(k2**2))) + k1**4*(Pk2*(-2*C*(38*r**2 + 142*r*s - 65*r + 104*s**2 - 139*s + 43) + 336*r**2 + 646*r*s - 406*r + 310*s**2 - 452*s + 137) + 2*Pkd2*k2*(6*C*(10*r*s - 7*r + 10*s**2 - 13*s + 4) + 40*r*s - 6*r + 40*s**2 - 23*s + 3))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(C*(66*r**2 + 2*r*(91*s - 120) + 116*s**2 - 278*s + 97) + 280*r**2 + r*(540*s - 254) + 260*s**2 - 250*s + 63)*np.sqrt(k2**2) + 6*Pkd2*k2*s*(k2*(8*C*s + 2*r - 1) + (C*(8*r - 2) + 4*r + 6*s - 1)*np.sqrt(k2**2)))) + Dd*f*(Pk2*k2**6*(4*r**2 + r*(4*s - 7) + 5*s)*np.sqrt(k2**2) + k1**6*(Pk2*(r*(43 - 52*s) - 52*s**2 + 71*s - 22)*np.sqrt(k2**2) + Pkd2*k2*(4*k2*(6*r*(s - 1) + 10*s**2 - 10*s + 3) + (2*r*(8*s - 1) - 6*s + 1)*np.sqrt(k2**2))) + k1**4*(Pk2*(-2*C*(76*r**2 + r*(284*s - 115) + 208*s**2 - 263*s + 59) + 672*r**2 + r*(1292*s - 743) + 620*s**2 - 835*s + 233) + Pkd2*k2*(6*C*(4*r*(10*s - 7) + 40*s**2 - 52*s + 15) + 32*r*(5*s - 1) + 160*s**2 - 100*s + 13))*(k2**2)**(3/2) + k1**2*k2**4*(Pk2*(C*(132*r**2 + 7*r*(52*s - 61) + 232*s**2 - 503*s + 187) + 560*r**2 + 2*r*(540*s - 241) + 520*s**2 - 474*s + 104)*np.sqrt(k2**2) + 6*Pkd2*k2*(2*C*r*(8*s - 1)*np.sqrt(k2**2) + 4*k2*r*s + k2*s*(4*C*(4*s - 1) - 1) + r*(8*s - 1)*np.sqrt(k2**2) - 2*s*(C - 6*s + 2)*np.sqrt(k2**2))))) + f**2*k1**2*(D1*fd*(33*Pk2*k2**4*(C*(117*r**2 + 3*r*(105*s - 61) + 198*s**2 - 204*s + 59) + 81*r**2 + r*(225*s - 116) + 144*s**2 - 151*s + 39)*np.sqrt(k2**2) + k1**4*(Pk2*(-45*r*(s - 15) - 45*s**2 + 738*s - 461)*np.sqrt(k2**2) + 165*Pkd2*k2**2*(s - 1)*(3*r + 3*s - 2)) + k1**2*(Pk2*(2*C*(1080*r**2 - 3*r*(3*s + 470) - 1089*s**2 + 1125*s + 97) + 5643*r**2 + 14409*r*s - 7806*r + 8766*s**2 - 10317*s + 2839) + 165*Pkd2*k2*(2*C*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7) + (s - 1)*(3*r + 3*s - 2)))*(k2**2)**(3/2)) + Dd*f*(33*Pk2*k2**4*(C*(156*r**2 + r*(420*s - 209) + 264*s**2 - 237*s + 59) + 108*r**2 + 3*r*(100*s - 41) + 192*s**2 - 183*s + 39)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(980 - 60*s) - 60*s**2 + 894*s - 461)*np.sqrt(k2**2) + 330*Pkd2*k2**2*(s - 1)*(2*r + 2*s - 1)) + k1**2*(Pk2*(2*C*(1440*r**2 - 3*r*(4*s + 607) - 1452*s**2 + 1439*s + 97) + 7524*r**2 + 19212*r*s - 8392*r + 11688*s**2 - 12570*s + 2839) + 330*Pkd2*k2*(C*(20*r*s - 13*r + 20*s**2 - 25*s + 7) + (s - 1)*(2*r + 2*s - 1)))*(k2**2)**(3/2))))/(693*d**2*k1**2*k3**4*(k2**2)**(3/2)) + 5*D1**3*Pk1*ct*f**2*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(-13*b1*(9*s - 14)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s*(14 - 9*s) + D1*fd*(828*s**2 - 375*s + 42) + 3*Dd*f*(276*s**2 - 125*s + 14)))/(9009*d**2*k1*k2) + 20*D1**3*Pk1*ct*f*st**6*(-33*D1*bd1*f*(Pk2*k2**3*(r**2*(16*C - 16) + r*(-16*C - 4*s + 17) - (1 - 2*s)**2) + Pk2*(4*C*(r*(4*s - 1) - 2*s + 1) - 4*r*s + r + 12*s**2 - 4*s - 1)*(k2**2)**(3/2) - Pkd2*k2**4*(r*(4*s - 1) + (1 - 2*s)**2) + k1**2*k2*(4*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 33*b1*(2*D1*fd*(Pk2*k2**3*(r**2*(16*C - 16) + r*(2 - 4*s) - (1 - 2*s)**2) + Pk2*(2*s - 1)*(r*(8*C - 2) + 6*s - 3)*(k2**2)**(3/2) - Pkd2*k2**4*(2*s - 1)*(2*r + 2*s - 1) + k1**2*k2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1)) + Dd*f*(Pk2*k2**3*(r**2*(64*C - 64) - 2*r*(8*C + 8*s - 11) - 16*s**2 + 14*s - 3) + Pk2*(4*C*(2*r*(8*s - 3) - 2*s + 1) + r*(6 - 16*s) + 48*s**2 - 34*s + 5)*(k2**2)**(3/2) - Pkd2*k2**4*(8*s - 3)*(2*r + 2*s - 1) + k1**2*k2*(4*Pk2 - Pkd2*k2)*(8*s - 3)*(2*r + 2*s - 1))) + f*(-2*D1*fd*(Pk2*k2**3*(4*C*(1 - 3*r)**2 - 36*r**2 - 9*r*(s - 3) - 9*s**2 + 9*s - 6) + Pk2*(3*s - 1)*(4*C*(3*r - 1) - 3*r + 9*s - 2)*(k2**2)**(3/2) - Pkd2*k2**4*(3*s - 1)*(3*r + 3*s - 2) + k1**2*k2*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2)) + Dd*f*(Pk2*k2**3*(-8*C*(12*r**2 - 7*r + 1) + 96*r**2 + 3*r*(8*s - 21) + 24*s**2 - 21*s + 12) + Pk2*(-4*C*(r*(24*s - 7) - 7*s + 2) + r*(24*s - 7) - 72*s**2 + 35*s - 4)*(k2**2)**(3/2) + Pkd2*k2**4*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + k1**2*k2*(-4*Pk2 + Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 21*s + 4))))/(693*d**2*k1*k3**4) - 10*D1**3*Pk1*ct*f*st**6*(33*b1*(D1*fd*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1) + k2**2*(8*Pk2*(r*(8*C - 8) + 2*s - 1) + k2*(Pkd2*(-r*(16*C - 16) - 10*s + 5) + Pkdd2*(2*s - 1)*np.sqrt(k2**2)))) + Dd*f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1) + k2**2*(8*Pk2*(2*C*(2*r*(8*s - 3) - 2*s + 1) - 4*r*(8*s - 3) + 8*s**2 - 2*s - 1) + k2*(Pkd2*(C*(-8*r*(8*s - 3) + 8*s - 4) + 8*r*(8*s - 3) - 40*s**2 + 22*s - 1) + Pkdd2*(8*s**2 - 6*s + 1)*np.sqrt(k2**2))))) + f*(-33*D1*bd1*(24*Pk2*k1**2*s*(1 - 2*s) + 9*Pkd2*k1**2*k2*s*(2*s - 1) + k2**3*(Pkd2*(4*C*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r + 10*s**2 + 3*s - 4) + Pkdd2*s*(1 - 2*s)*np.sqrt(k2**2)) + k2**2*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 2*s**2 + 3*s - 2) + Pkdd2*k1**2*s*(1 - 2*s))) + D1*fd*(3*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1) + k2**2*(8*Pk2*(4*C*(3*r - 1) - 12*r + 3*s + 3) - k2*(Pkd2*(24*C*r - 8*C - 24*r + 15*s + 3) + Pkdd2*(1 - 3*s)*np.sqrt(k2**2)))) + Dd*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + Dd*f*k2**2*(8*Pk2*(2*C*(24*r*s - 7*r - 7*s + 2) - 48*r*s + 14*r + 12*s**2 + 7*s - 3) + k2*(Pkd2*(-4*C*(24*r*s - 7*r - 7*s + 2) + 96*r*s - 28*r - 60*s**2 + 7*s + 3) + Pkdd2*(12*s**2 - 7*s + 1)*np.sqrt(k2**2)))))/(693*d**2*k1*k2*k3**2) - 8*D1**3*Pk1*ct*st**4*(D1*(-66*b1**2*fd*(-2*Pk2*k1**2*s*(r + s)*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(4 - 4*C) + r*s + s**2)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*s*(r + s)*np.sqrt(k2**2) + k2**5*s*(-Pk2*(4*C*r - 3*r + s) + Pkd2*(r + s)*np.sqrt(k2**2))) + 33*b1*f*(bd1*(2*Pk2*k1**2*(r*(4*s - 1) + s*(4*s - 3))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(16*C - 16) + r*(-8*C - 4*s + 9) + s*(3 - 4*s))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(-4*r*s + r + s*(3 - 4*s))*np.sqrt(k2**2) + k2**5*(Pk2*(r*(4*C - 3)*(4*s - 1) + s*(-4*C + 4*s + 1)) + Pkd2*(-4*r*s + r + s*(3 - 4*s))*np.sqrt(k2**2))) + fd*(Pk2*k1**2*(k1**2*(r - 4*s)*(2*s - 1) + k2**2*(-4*C*(2*r**2 + 12*r*s - 3*r + 10*s**2 - 7*s + 1) + 20*r**2 + 4*r*s + 7*r - 16*s**2 + 18*s - 5))*np.sqrt(k2**2) + 2*Pk2*k2**4*(r**2*(16 - 16*C) - r*(8*C - 18)*(2*s - 1) + (1 - 2*s)**2)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(2*C*(r*(8*s - 3) + 8*s**2 - 6*s + 1) + (2*s - 1)*(5*r + 5*s - 2))*np.sqrt(k2**2) + k1**4*k2*(2*s - 1)*(-5*Pk2*r + Pkd2*(r + s)*np.sqrt(k2**2)) + k2**5*(Pk2*(8*r**2 + r*(19 - 36*s) - 3*(1 - 2*s)**2) + 2*Pkd2*(2*s - 1)*(2*r + 2*s - 1)*np.sqrt(k2**2)))) + f**2*(33*bd1*(Pk2*k1**2*(k1**2*s*(r - 4*s) - 2*k2**2*(r**2*(2*C - 5) + r*(12*C*s - 2*C - s + 5) + 2*s*(5*C*s - 4*C + 2*s + 1)))*np.sqrt(k2**2) + Pk2*k2**4*(-4*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 16*r**2 + 9*r*(4*s - 3) + 4*s**2 - 24*s + 11)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(s*(8*C + 5) - 1) + s**2*(8*C + 5) - s*(4*C + 4) + 1)*np.sqrt(k2**2) + k1**4*k2*s*(-5*Pk2*r + Pkd2*(r + s)*np.sqrt(k2**2)) + k2**5*(Pk2*(4*r**2 - 18*r*s + r - 6*s**2 + 12*s - 5) + Pkd2*(r*(4*s - 1) + (1 - 2*s)**2)*np.sqrt(k2**2))) + fd*(Pk2*k2**4*(-2*C*(81*r**2 + 12*r - 13)*np.sqrt(k2**2) + k2*(-2*C*(3*r - 1)*(27*s - 20) + 153*r**2 + 27*r*(9*s - 8) + 90*s**2 - 141*s + 65)) + 6*k1**4*(3*s - 1)*(Pk2*k2*(5 - 15*r) + 3*Pk2*(r - 4*s + 1)*np.sqrt(k2**2) + Pkd2*k2*(3*r + 3*s - 2)*np.sqrt(k2**2)) + k1**2*(Pk2*(-24*C*(9*r**2 + 9*r*(7*s - 3) + 54*s**2 - 57*s + 14) + 477*r**2 + 9*r*(75*s - 64) + 198*s**2 - 357*s + 161) + Pkd2*k2*(60*C + 6)*(3*s - 1)*(3*r + 3*s - 2))*(k2**2)**(3/2)))) + Dd*f*(-33*b1**2*(2*Pk2*k1**2*(-8*r*s + r + s*(3 - 8*s))*(k2**2)**(3/2) + Pk2*k2**4*(r**2*(32 - 32*C) + r*(8*C + 8*s - 9) + s*(8*s - 3))*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2) - k2**5*(Pk2*(r*(4*C - 3)*(8*s - 1) + s*(-4*C + 8*s + 1)) + Pkd2*(-8*r*s + r + s*(3 - 8*s))*np.sqrt(k2**2))) + 33*b1*f*(-Pk2*k1**2*(-k1**2*(r - 4*s)*(4*s - 1) + k2**2*(4*C*(4*r**2 + 24*r*s - 4*r + 20*s**2 - 12*s + 1) - 40*r**2 - 8*r*s + 3*r + 32*s**2 - 19*s + 5))*np.sqrt(k2**2) + Pk2*k2**4*(-4*C*(8*r - 1)*(2*r + 2*s - 1) + 64*r**2 + 2*r*(72*s - 37) + 16*s**2 - 34*s + 13)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*(2*C*(r*(16*s - 3) + 16*s**2 - 9*s + 1) + r*(20*s - 7) + 20*s**2 - 15*s + 3)*np.sqrt(k2**2) + k1**4*k2*(4*s - 1)*(-5*Pk2*r + Pkd2*(r + s)*np.sqrt(k2**2)) + k2**5*(Pk2*(16*r**2 + r*(25 - 72*s) - 24*s**2 + 27*s - 8) + Pkd2*(8*s - 3)*(2*r + 2*s - 1)*np.sqrt(k2**2))) + f**2*(Pk2*k2**4*(-2*C*(108*r**2 + 25*r - 13)*np.sqrt(k2**2) + k2*(C*(-216*r*s + 140*r + 74*s - 40) + 204*r**2 + 324*r*s - 263*r + 120*s**2 - 159*s + 65)) + 3*k1**4*(Pk2*(r*(24*s - 7) - 96*s**2 + 49*s - 6)*np.sqrt(k2**2) + k2*(-5*Pk2*(24*r*s - 7*r - 7*s + 2) + Pkd2*(24*r*s - 7*r + 24*s**2 - 21*s + 4)*np.sqrt(k2**2))) + k1**2*(Pk2*(-12*C*(24*r**2 + 21*r*(8*s - 3) + 144*s**2 - 133*s + 28) + 636*r**2 + 900*r*s - 683*r + 264*s**2 - 411*s + 161) + Pkd2*k2*(30*C + 3)*(r*(24*s - 7) + 24*s**2 - 21*s + 4))*(k2**2)**(3/2))))/(231*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 4*D1**3*Pk1*ct*st**2*(33*D1*bd1*f*(b1*(k1**4*(Pk2*(r*(10 - 26*s) + s*(52*s - 23))*np.sqrt(k2**2) + k2*(Pk2*(6*r*(13*s - 5) - 9*s) + 2*Pkd2*(r*(5 - 13*s) + s*(8 - 13*s))*np.sqrt(k2**2))) + k1**2*(2*Pk2*(r**2*(52*C - 105) + 2*r*(52*C*s - 19*C - 78*s + 37) + s*(52*C*s - 66*C - 51*s + 82)) + Pkd2*k2*(r*(-156*C*s + 46*C - 54*s + 17) + s*(-156*C*s + 110*C - 54*s + 37)))*(k2**2)**(3/2) + k2**4*(7*Pk2*(r**2*(16*C - 16) + r*(4*C*(4*s - 3) - 36*s + 15) + s*(-4*C - 4*s + 13))*np.sqrt(k2**2) + k2*(Pk2*(-54*r**2 + r*(32*s + 19) + s*(5 - 26*s)) + 7*Pkd2*(-4*r*s + r + s*(3 - 4*s))*np.sqrt(k2**2)))) + f*(-k1**4*(Pk2*(2*C*(r*(7*s - 3) - 18*s**2 + 9*s + 3) + 15*r**2 + r*(2*s - 13) + 53*s**2 - 12*s - 4)*np.sqrt(k2**2) + k2*(Pk2*(C*(r*(22 - 50*s) + 34*s - 22) + 2*r*(33*s - 8) - 35*s + 22) + 2*Pkd2*(C*(7*s - 3)*(r + s - 1) + 2*s**2 + s*(2*r - 1) - 1)*np.sqrt(k2**2))) - k1**2*(Pk2*(4*C*(12*r**2 + 68*r*s - 19*r + 56*s**2 - 38*s + 8) + 25*r**2 + 105*r*s - 53*r + 80*s**2 - 82*s + 24) + Pkd2*k2*(2*C*(r*(s - 2) + s**2 + s - 5) + 2*r*s + r + 2*s**2 - 2))*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(4*C + 8) + r*(-8*C*s + 4*C + 34*s - 9) + s*(2*s - 2))*np.sqrt(k2**2) + k2*(Pk2*(4*C*(3*r*s - 5*r - 3*s + 3) + 10*r**2 - 23*r*s + 3*r - 9*s**2 + 13*s - 4) + Pkd2*(r*(2*s - 1) + s*(2*s - 2))*np.sqrt(k2**2))))) - 33*b1**2*(D1*fd*(Pk2*k1**2*(13*k1**2*s*(r - 2*s) - k2**2*(r + s)*(r*(52*C - 105) + s*(52*C - 51)))*np.sqrt(k2**2) - 14*Pk2*k2**4*(r**2*(4*C - 4) + r*s*(4*C - 9) - s**2)*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*s*(78*C + 27)*(r + s)*np.sqrt(k2**2) + 13*k1**4*k2*s*(-3*Pk2*r + Pkd2*(r + s)*np.sqrt(k2**2)) + k2**5*(Pk2*(27*r**2 - 16*r*s + 13*s**2) + 14*Pkd2*s*(r + s)*np.sqrt(k2**2))) + Dd*f*(k1**4*(Pk2*(2*r*(26*s - 5) + s*(23 - 104*s))*np.sqrt(k2**2) + k2*(Pk2*(-156*r*s + 30*r + 9*s) + 2*Pkd2*(26*r*s - 5*r + 26*s**2 - 8*s)*np.sqrt(k2**2))) + k1**2*(-4*Pk2*(r**2*(52*C - 105) + r*(104*C*s - 19*C - 156*s + 37) + s*(52*C*s - 33*C - 51*s + 41)) + Pkd2*k2*(r*(312*C*s - 46*C + 108*s - 17) + s*(312*C*s - 110*C + 108*s - 37)))*(k2**2)**(3/2) + k2**4*(-7*Pk2*(r**2*(32*C - 32) + r*(4*C*(8*s - 3) - 72*s + 15) + s*(-4*C - 8*s + 13))*np.sqrt(k2**2) + k2*(Pk2*(108*r**2 - r*(64*s + 19) + s*(52*s - 5)) + 7*Pkd2*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2))))) + 33*b1*f*(D1*fd*(-Pk2*k1**2*(k1**2*(4*C*(r*(7*s - 4) - 18*s**2 + 23*s - 7) + 30*r**2 + r*(4*s + 11) + 106*s**2 - 149*s + 35) + k2**2*(4*C*(24*r**2 + 2*r*(68*s - 35) + 112*s**2 - 102*s + 23) + 50*r**2 + 6*r*(35*s - 19) + 160*s**2 - 150*s + 39))*np.sqrt(k2**2) + Pk2*k2**4*(r**2*(8*C + 16) - 2*r*(C*(8*s + 2) - 34*s + 11) + s*(4*C + 4*s - 11))*np.sqrt(k2**2) - Pkd2*k1**2*k2**3*(C*(r*(4*s + 54) + 4*s**2 + 64*s - 30) + r*(4*s + 7) + 4*s**2 + 6*s - 4)*np.sqrt(k2**2) - k1**4*k2*(Pk2*(r*(-100*C*s + 60*C + 132*s - 105) + 24*s) + Pkd2*(2*C*(14*r*s - 8*r + 14*s**2 - 17*s + 5) + 8*r*s + 7*r + 8*s**2 + 5*s - 4)*np.sqrt(k2**2)) + k2**5*(2*Pk2*(-8*C*s + 10*r**2 + r*(12*C*s - 23*s + 10) - 9*s**2 + 11*s - 4) + Pkd2*s*(4*r + 4*s - 1)*np.sqrt(k2**2))) + Dd*f*(-k1**4*(-2*Pk2*k2*(C*(4*r*(25*s - 13) - 17*s + 11) + r*(73 - 132*s) + 4*s - 11) + Pk2*(2*C*(14*r*(2*s - 1) - 72*s**2 + 69*s - 11) + 60*r**2 + r*(8*s + 3) + 212*s**2 - 197*s + 31)*np.sqrt(k2**2) + 2*Pkd2*k2*(2*C*(14*r*s - 7*r + 14*s**2 - 16*s + 4) + r*(8*s + 5) + 8*s**2 + 3*s - 3)*np.sqrt(k2**2)) - k1**2*(Pk2*(4*C*(48*r**2 + r*(272*s - 98) + 224*s**2 - 162*s + 31) + 100*r**2 + 15*r*(28*s - 13) + 320*s**2 - 267*s + 63) + Pkd2*k2*(C*r*(8*s + 68) + 8*C*(s**2 + 11*s - 5) + r*(8*s + 11) + 8*s**2 + 9*s - 6))*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(16*C + 32) + r*(-32*C*s + 136*s - 31) + s*(4*C + 8*s - 13))*np.sqrt(k2**2) + k2*(Pk2*(4*C*(12*r*s - 5*r - 10*s + 3) + 40*r**2 - 92*r*s + 31*r - 36*s**2 + 39*s - 12) + Pkd2*(r*(8*s - 1) + s*(8*s - 3))*np.sqrt(k2**2))))) + f**2*(D1*fd*(33*Pk2*k2**4*(k2*(63*r**2 + r*(45*s - 42) + 36*s**2 - 36*s + 10) + 18*r*(3*s - 1)*np.sqrt(k2**2)) + k1**4*(Pk2*(C*(-918*r*s + 438*r + 2052*s**2 - 2514*s + 566) - 351*r**2 + 891*r*s - 525*r - 3177*s**2 + 3702*s - 766)*np.sqrt(k2**2) + k2*(Pk2*(22*C*(15*r*(9*s - 5) - 21*s + 17) - 4419*r*s + 2958*r + 714*s - 733) + 3*Pkd2*(-2*C*(r*(153*s - 73) + 153*s**2 - 197*s + 56) + 55*r*(3*s - 2) + 165*s**2 - 231*s + 77)*np.sqrt(k2**2))) + k1**2*(Pk2*(-12*C*(36*r**2 + r*(1125*s - 322) + 1089*s**2 - 980*s + 184) + 4410*r**2 + 15*r*(321*s - 215) + 405*s**2 - 258*s + 91) + 33*Pkd2*k2*(24*C*(2*s - 1)*(3*r + 3*s - 2) + 5*r*(3*s - 2) + 15*s**2 - 21*s + 7))*(k2**2)**(3/2)) + Dd*f*(66*Pk2*k2**4*(k2*(42*r**2 + r*(30*s - 23) + 24*s**2 - 21*s + 5) + 9*r*(4*s - 1)*np.sqrt(k2**2)) + k1**4*(Pk2*(C*(-1224*r*s + 588*r + 2736*s**2 - 3230*s + 566) - 468*r**2 + 1188*r*s - 706*r - 4236*s**2 + 4649*s - 766)*np.sqrt(k2**2) + k2*(Pk2*(22*C*(20*r*(9*s - 5) - 13*s + 17) - 5892*r*s + 3671*r + 734*s - 733) - 3*Pkd2*(4*C*(102*r*s - 49*r + 102*s**2 - 114*s + 28) - 220*r*s + 143*r - 220*s**2 + 275*s - 77)*np.sqrt(k2**2))) + k1**2*(Pk2*(-24*C*(24*r**2 + 25*r*(30*s - 7) + 726*s**2 - 568*s + 92) + 5880*r**2 + 6420*r*s - 3405*r + 540*s**2 - 169*s + 91) + 33*Pkd2*k2*(6*C*(32*r*s - 15*r + 32*s**2 - 33*s + 8) + 20*r*s - 13*r + 20*s**2 - 25*s + 7))*(k2**2)**(3/2))))/(693*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 4*D1**3*Pk1*ct*(D1*bd1*f*(b1*(7*Pk2*k2**4*(k2*(6*r**2 + r*(2*s - 5) + 2*s*(3*s - 1)) + 5*r*(2*s - 1)*np.sqrt(k2**2)) + 2*k1**4*(Pk2*(18*r**2 + r*(C*(8*s - 2) + 14*s - 9) + 2*s*(-8*C*s + 3*C + 7*s - 7))*np.sqrt(k2**2) + k2*(Pk2*(3*r*(C*(2 - 8*s) + 6*s - 5) + s*(6*C + 6)) + 2*Pkd2*(C*r*(4*s - 1) + C*s*(4*s - 3) + 7*s*(r + s - 1))*np.sqrt(k2**2))) + 2*k1**2*(Pk2*(115*r**2 + r*(28*C + 218*s - 147) + s*(-28*C + 103*s - 71)) + 14*Pkd2*k2*(C*r*(6*s - 1) + C*s*(6*s - 5) + s*(r + s - 1)))*(k2**2)**(3/2)) + f*(Pk2*k2**4*(k2*(27*r**2 + r*(4*C*s + 15*s - 12) + s*(25*s - 25)) + r*(4*C*r + 37*s - 37)*np.sqrt(k2**2)) + k1**4*(-2*Pk2*k2*(6*C*(r*(5*s - 4) - 3*s + 3) + r*(39 - 51*s) + 20*s - 20) + Pk2*(4*C*(2*r*(5*s - 4) - 5*s**2 + 7) + 64*r**2 + r*(49*s - 38) + s*(87*s - 87))*np.sqrt(k2**2) + 4*Pkd2*k2*(C*(2*r*(5*s - 4) + 10*s**2 - 17*s + 7) + 3*s*(r + s - 1))*np.sqrt(k2**2)) + k1**2*(Pk2*(4*C*(52*r**2 + 109*r*s - 87*r + 57*s**2 - 91*s + 47) + 147*r**2 + 299*r*s - 229*r + 152*s**2 - 180*s + 28) + 12*Pkd2*k2*(C*r*(6*s - 2) + 6*C*s*(s - 1) + s*(r + s - 1)))*(k2**2)**(3/2))) + b1**2*(D1*fd*(Pk2*k1**2*(2*k1**2*(9*r**2 + r*s*(4*C + 7) + s**2*(7 - 8*C)) + k2**2*(115*r**2 + 218*r*s + 103*s**2))*np.sqrt(k2**2) + 7*Pk2*k2**5*(3*r**2 + r*s + 3*s**2) + 35*Pk2*k2**4*r*s*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*s*(84*C + 14)*(r + s)*np.sqrt(k2**2) + 2*k1**4*k2*s*(Pk2*r*(9 - 12*C) + Pkd2*(4*C + 7)*(r + s)*np.sqrt(k2**2))) + Dd*f*(7*Pk2*k2**4*(k2*(12*r**2 + r*(4*s - 5) + 2*s*(6*s - 1)) + 5*r*(4*s - 1)*np.sqrt(k2**2)) + 2*k1**4*(Pk2*(36*r**2 + r*(2*C*(8*s - 1) + 28*s - 9) + 2*s*(C*(3 - 16*s) + 14*s - 7))*np.sqrt(k2**2) + k2*(Pk2*(r*(-48*C*s + 6*C + 36*s - 15) + s*(6*C + 6)) + 2*Pkd2*(C*r*(8*s - 1) + C*s*(8*s - 3) + 7*s*(2*r + 2*s - 1))*np.sqrt(k2**2))) + 2*k1**2*(Pk2*(230*r**2 + r*(28*C + 436*s - 147) + s*(-28*C + 206*s - 71)) + 14*Pkd2*k2*(C*r*(12*s - 1) + C*s*(12*s - 5) + s*(2*r + 2*s - 1)))*(k2**2)**(3/2))) + b1*f*(D1*fd*(Pk2*k2**4*(k2*(54*r**2 + r*(8*C*s + 30*s - 27) + s*(-4*C + 50*s - 3)) + 2*r*(C*(4*r - 2) + 37*s)*np.sqrt(k2**2)) + k1**4*(Pk2*(4*C*k2*(r*(9 - 30*s) + 12*s) + 4*C*(4*r*(5*s - 3) - 10*s**2 - 9*s + 1)*np.sqrt(k2**2) + 204*k2*r*s - 104*k2*s + 128*r**2*np.sqrt(k2**2) + r*(98*s - 141)*np.sqrt(k2**2) + 174*s**2*np.sqrt(k2**2) - 87*s*np.sqrt(k2**2) + 51*np.sqrt(k2**2)) + 4*Pkd2*k2*(2*C*(5*s - 3) + 3*s)*(2*r + 2*s - 1)*np.sqrt(k2**2)) + k1**2*(Pk2*(4*C*(104*r**2 + 218*r*s - 166*r + 114*s**2 - 186*s + 57) + 294*r**2 + 26*r*(23*s - 8) + 304*s**2 - 194*s + 43) + 12*Pkd2*k2*s*(4*C*(3*r + 3*s - 1) + 2*r + 2*s - 1))*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(k2*(108*r**2 + r*(16*C*s + 60*s - 39) - s*(4*C - 100*s + 28)) + r*(16*C*r - 4*C + 148*s - 37)*np.sqrt(k2**2)) + k1**4*(-2*Pk2*k2*(6*C*(r*(20*s - 9) - 8*s + 3) + r*(39 - 204*s) + 92*s - 20) + Pk2*(4*C*(r*(40*s - 26) - 20*s**2 - 11*s + 8) + 256*r**2 + r*(196*s - 205) + 348*s**2 - 199*s + 51)*np.sqrt(k2**2) + 4*Pkd2*k2*(C*(20*s - 13) + 6*s)*(2*r + 2*s - 1)*np.sqrt(k2**2)) + k1**2*(Pk2*(4*C*(208*r**2 + r*(436*s - 297) + 228*s**2 - 337*s + 104) + 588*r**2 + 13*r*(92*s - 35) + 608*s**2 - 427*s + 71) + 24*Pkd2*k2*(C*r*(12*s - 1) + C*s*(12*s - 5) + s*(2*r + 2*s - 1)))*(k2**2)**(3/2))) + f**2*k1**2*(4*C*(D1*fd*(Pk2*(36*r**2 + 27*r*(5*s - 3) + 99*s**2 - 111*s + 34)*(k2**2)**(3/2) + k1**2*(Pk2*(15*r*(s - 1) + 15*s**2 - 13*s + 6)*np.sqrt(k2**2) + k2*(Pk2*(10*r - s - 3) + 5*Pkd2*(s - 1)*(3*r + 3*s - 2)*np.sqrt(k2**2)))) + Dd*f*(Pk2*(48*r**2 + 3*r*(60*s - 31) + 132*s**2 - 133*s + 34)*(k2**2)**(3/2) + k1**2*(2*Pk2*(10*r*(s - 1) + 10*s**2 - 7*s + 3)*np.sqrt(k2**2) + k2*(3*Pk2*(5*r - s - 1) + 10*Pkd2*(s - 1)*(2*r + 2*s - 1)*np.sqrt(k2**2))))) + Pk2*(k1**2 + k2**2)*(D1*fd*(30*r**2 + 93*r*s - 41*r + 63*s**2 - 84*s + 21) + Dd*f*(40*r**2 + r*(124*s - 41) + 84*s**2 - 105*s + 21))*np.sqrt(k2**2)))/(21*d**2*k1*k2*k3**4*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct*st**4*(13*D1*bd1*f*(f**2*(-90*Pk2*k2**4*r*(r - 1)*np.sqrt(k2**2) + 20*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*np.sqrt(k2**2) + k1**2*(-2*Pk2*(r*(81*s - 30) + 90*s**2 + 156*s + 20)*(k2**2)**(3/2) + 20*Pkdd2*k2**4*s*(3*s - 2)*np.sqrt(k2**2) + k2**3*(10*Pk2*(81*r*s - 30*r - 4*s + 20) + Pkd2*(-162*r*s + 60*r - 135*s**2 + 208*s - 40)*np.sqrt(k2**2)))) - 264*g2*k1**2*(Pk2*(k2**2)**(3/2) + k2**3*(-5*Pk2 + Pkd2*np.sqrt(k2**2)))*(r*(2*s - 1) - s + 1)) + 429*b1**2*k1**2*(D1*fd*(-9*Pkd2*k1**2*k2*(s**2*(2*f - 2) - s*(f - 4) - 2)*np.sqrt(k2**2) + Pkdd2*k2**4*(s**2*(4*f - 2) - s*(f - 4) - 2)*np.sqrt(k2**2) + k2**3*(-10*Pk2*(s - 1)*(r*(4*K - 4) + 3*s - 3) + Pkd2*(r*(8*K - 8)*(s - 1) + 5*s**2*(2 - 4*f) + 5*s*(f - 4) + 10)*np.sqrt(k2**2)) + (2*Pk2*k2**2*(r*(4*K - 4)*(s - 1) + s**2*(16*f + 7) - s*(4*f + 14) + 7) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(s**2*(2*f - 2) - s*(f - 4) - 2))*np.sqrt(k2**2)) + Dd*f*(-9*Pkd2*k1**2*k2*(4*s - 1)*(s*(f - 2) + 2)*np.sqrt(k2**2) + 2*Pkdd2*k2**4*(4*s - 1)*(s*(f - 1) + 1)*np.sqrt(k2**2) - 2*k2**3*(5*Pk2*(2*K*(r*(8*s - 5) - s + 1) - 2*r*(8*s - 5) + 12*s**2 - 13*s + 1) + Pkd2*(-2*K*(r*(8*s - 5) - s + 1) + 20*f*s**2 - 5*f*s + 2*r*(8*s - 5) - 20*s**2 + 23*s - 3)*np.sqrt(k2**2)) + (2*Pk2*k2**2*(2*K*(r*(8*s - 5) - s + 1) + 32*f*s**2 - 8*f*s - 2*r*(8*s - 5) + 28*s**2 - 33*s + 5) + k1**2*(24*Pk2 + Pkdd2*k2**2)*(4*s - 1)*(s*(f - 2) + 2))*np.sqrt(k2**2))) + 13*b1*(33*D1*bd1*f*k1**2*(-18*Pkd2*k1**2*k2*s*(s*(f - 2) + 2)*np.sqrt(k2**2) + Pkdd2*k2**4*s*(f*(4*s - 1) - 4*s + 4)*np.sqrt(k2**2) + k2**3*(-20*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 3*s**2 - 2*s - 1) + Pkd2*(4*K*(r*(4*s - 2) - s + 1) - 20*f*s**2 + 5*f*s + r*(8 - 16*s) + 20*s**2 - 16*s - 4)*np.sqrt(k2**2)) + 2*(24*Pk2*k1**2*s*(s*(f - 2) + 2) + k2**2*(2*Pk2*(K*r*(4*s - 2) - K*s + K + 8*f*s**2 - 2*f*s + r*(2 - 4*s) + 7*s**2 - 6*s - 1) + Pkdd2*k1**2*s*(s*(f - 2) + 2)))*np.sqrt(k2**2)) + D1*f**2*fd*(-270*Pk2*k2**4*r**2*np.sqrt(k2**2) + 20*k1**4*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*np.sqrt(k2**2) + k1**2*(2*Pk2*(-9*r*(27*s - 20) - 270*s**2 + 117*s + 20)*(k2**2)**(3/2) + 10*Pkdd2*k2**4*(18*s**2 - 6*s + 1)*np.sqrt(k2**2) + k2**3*(10*Pk2*(9*r - 1)*(27*s - 20) - 9*Pkd2*(54*r*s - 40*r + 45*s**2 - 21*s + 10)*np.sqrt(k2**2)))) - 264*D1*f*gd2*k1**2*r*(2*s - 1)*(Pk2*(k2**2)**(3/2) + k2**3*(-5*Pk2 + Pkd2*np.sqrt(k2**2))) - 528*D1*fd*g2*k1**2*r*(s - 1)*(Pk2*(k2**2)**(3/2) + k2**3*(-5*Pk2 + Pkd2*np.sqrt(k2**2))) + Dd*f**3*(90*Pk2*k2**4*r*(1 - 4*r)*np.sqrt(k2**2) + 20*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1)*np.sqrt(k2**2) + k1**2*(-6*Pk2*(2*r*(54*s - 35) + s*(120*s + 13))*(k2**2)**(3/2) + 10*Pkdd2*k2**4*(24*s**2 - 10*s + 1)*np.sqrt(k2**2) + k2**3*(10*Pk2*(6*r*(54*s - 35) - 31*s + 40) + Pkd2*(r*(420 - 648*s) - 540*s**2 + 397*s - 130)*np.sqrt(k2**2)))) - 264*Dd*f*g2*k1**2*(Pk2*(k2**2)**(3/2) + k2**3*(-5*Pk2 + Pkd2*np.sqrt(k2**2)))*(r*(8*s - 5) - s + 1)) - f**3*(D1*fd + Dd*f)*(180*Pk2*k2**4*(12*r**2 - 19*r + 4)*np.sqrt(k2**2) - 5*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(268*s**2 - 147*s + 20)*np.sqrt(k2**2) + k1**2*(4*Pk2*(4*r*(534*s - 205) + 11180*s**2 - 6085*s + 894)*(k2**2)**(3/2) + 65*Pkdd2*k2**4*(20*s**2 - 13*s + 2)*np.sqrt(k2**2) - 2*k2**3*(4*Pk2*(3468*r*s - 1114*r - 477*s + 181) + Pkd2*(-1776*r*s + 392*r + 7540*s**2 - 3989*s + 539)*np.sqrt(k2**2)))))/(3003*d**2*k1**3*k2**3*np.sqrt(k2**2)) + D1**3*Pk1*ct*st**2*(5577*b1**3*k1**2*s*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1))*np.sqrt(k2**2) - 429*b1**2*(D1*(-13*bd1*f*k1**2*s*(3*s - 1)*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2))*np.sqrt(k2**2) + fd*(36*Pk2*k2**4*r**2*np.sqrt(k2**2) - k1**4*(-8*Pk2*(f*(42*s**2 - 71*s + 16) - 17*s**2 + 30*s - 15) + k2*(Pkd2*(5*f*(6*s**2 - 41*s + 10) - 82*s**2 + 144*s - 72) + Pkdd2*k2*(3*f*(6*s**2 + 7*s - 2) + 16*s**2 - 28*s + 14)))*np.sqrt(k2**2) + k1**2*(2*Pk2*(-4*K*s + 2*f*(24*r*s - 7*r + 120*s**2 - 54*s + 10) + r*(2*K - 2)*(9*s - 7) + 25*s**2 - 40*s + 22)*(k2**2)**(3/2) + Pkdd2*k2**4*(3*f*(6*s**2 - 7*s + 2) - 16*s**2 + 28*s - 14)*np.sqrt(k2**2) + k2**3*(-2*Pk2*(6*f*r*(16*s - 5) + r*(4*K - 4)*(23*s - 20) + 27*s**2 - s*(12*K + 18*f + 36) + 24) + Pkd2*(f*(4*r*(16*s - 5) - 258*s**2 + 109*s - 26) + 2*r*(4*K - 4)*(8*s - 7) + 18*s**2 - 2*s*(4*K + 12) + 16)*np.sqrt(k2**2))))) + Dd*f*(36*Pk2*k2**4*r*(4*r - 1)*np.sqrt(k2**2) - k1**4*(4*s - 1)*(-8*Pk2*(f*(21*s - 16) - 17*s + 15) + k2*(Pkd2*(15*f*s - 50*f - 82*s + 72) + Pkdd2*k2*(9*f*s + 6*f + 16*s - 14)))*np.sqrt(k2**2) + k1**2*(2*Pk2*(2*K*(36*r*s - 50*r - 19*s + 15) + 4*f*(12*r*(2*s - 1) + 120*s**2 - 52*s + 7) - 72*r*s + 100*r + 100*s**2 - 75*s - 8)*(k2**2)**(3/2) + Pkdd2*k2**4*(4*s - 1)*(f*(9*s - 6) - 16*s + 14)*np.sqrt(k2**2) - k2**3*(2*Pk2*(K*(368*r*s - 206*r - 70*s + 46) + 6*f*(4*r*(8*s - 5) + 3) - 368*r*s + 206*r + 108*s**2 - 53*s - 22) + Pkd2*(-16*K*(r*(16*s - 9) - 3*s + 2) + f*(-16*r*(8*s - 5) + 516*s**2 - 233*s + 14) + 16*r*(16*s - 9) - 72*s**2 + 34*s + 16)*np.sqrt(k2**2))))) - 39*b1*(22*D1*bd1*f*(18*Pk2*k2**4*r*(2*r - 1)*np.sqrt(k2**2) + k1**4*s*(8*Pk2*(7*f*(3*s - 1) - 17*s + 16) + k2*(Pkd2*(-15*f*s + 5*f + 82*s - 77) + Pkdd2*k2*(-9*f*s + 3*f - 16*s + 15)))*np.sqrt(k2**2) + k1**2*(Pk2*(K*(36*r*s - 58*r - 32*s + 30) + 2*f*(r*(24*s - 17) + 120*s**2 - 50*s + 4) - 36*r*s + 58*r + 50*s**2 - 15*s - 30)*(k2**2)**(3/2) + Pkdd2*k2**4*s*(f*(9*s - 6) - 16*s + 15)*np.sqrt(k2**2) + k2**3*(-Pk2*(2*K*(92*r*s - 43*r - 26*s + 23) + 6*f*(16*r*s - 15*r + 3*s + 3) - 184*r*s + 86*r + 54*s**2 + s - 46) + Pkd2*(2*K*(32*r*s - 15*r - 9*s + 8) + f*(r*(32*s - 30) - 129*s**2 + 62*s + 6) - 64*r*s + 30*r + 18*s**2 + s - 16)*np.sqrt(k2**2)))) + D1*(f**2*fd*(-24*Pk2*k2**4*(9*r**2 + 27*r - 10)*np.sqrt(k2**2) + k1**4*(8*Pk2*(1893*s**2 - 1782*s + 352) + k2*(Pkd2*(-4713*s**2 + 5346*s - 1100) + 3*Pkdd2*k2*(103*s**2 - 198*s + 44)))*np.sqrt(k2**2) + k1**2*(4*Pk2*(378*r**2 + r*(522*s - 239) + 594*s**2 - 9*s + 33)*(k2**2)**(3/2) + 33*Pkdd2*k2**4*(18*s**2 - 9*s + 2)*np.sqrt(k2**2) + k2**3*(12*Pk2*(r*(468*s - 250) - 57*s + 43) + Pkd2*(8*r*(162*s - 7) - 1782*s**2 - 267*s - 18)*np.sqrt(k2**2)))) + 22*f*(fd*(14*Pk2*k2**4*(2*r**2 - 3*r + 1)*np.sqrt(k2**2) + k1**4*(2*s - 1)*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(-2*Pk2*(2*K*(r + s - 1) - 2*r*(6*s - 5) + s*(14*s - 11))*(k2**2)**(3/2) + Pkdd2*k2**4*(2*s**2 - 3*s + 1)*np.sqrt(k2**2) + 2*k2**3*(Pk2*(K*(24*r*s + r - 7*s - 3) + r*(29 - 48*s) + 36*s**2 - 17*s - 3) - 2*Pkd2*(K*(r + s - 1) - 4*r*(s - 1) + s*(6*s - 5))*np.sqrt(k2**2)))) + 4*gd2*k1**2*(Pk2*(r*(14 - 9*s) + s)*(k2**2)**(3/2) + k2**3*(Pk2*(46*r*s - 20*r - 3*s) + Pkd2*(-16*r*s + 7*r + s)*np.sqrt(k2**2)))) - 88*fd*g2*k1**2*(Pk2*(r*(9*s - 7) - 2*s)*(k2**2)**(3/2) - 2*k2**3*(Pk2*(23*r*s - 20*r - 3*s) + Pkd2*(-8*r*s + 7*r + s)*np.sqrt(k2**2)))) + Dd*f*(f**2*(-24*Pk2*k2**4*(12*r**2 + 37*r - 10)*np.sqrt(k2**2) + k1**4*(4*s - 1)*(8*Pk2*(631*s - 352) + k2*(Pkd2*(1100 - 1571*s) + Pkdd2*k2*(103*s - 132)))*np.sqrt(k2**2) + 2*k1**2*(2*Pk2*(504*r**2 + 232*r*(3*s - 2) + 792*s**2 - 302*s + 67)*(k2**2)**(3/2) + 33*Pkdd2*k2**4*(12*s**2 - 7*s + 1)*np.sqrt(k2**2) + k2**3*(6*Pk2*(624*r*s - 142*r - 50*s + 9) + Pkd2*(864*r*s - 244*r - 1188*s**2 + 89*s + 59)*np.sqrt(k2**2)))) + 22*f*(14*Pk2*k2**4*(4*r**2 - 5*r + 1)*np.sqrt(k2**2) + k1**4*(4*s - 1)*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(2*Pk2*(K*(2 - 8*s) + 2*r*(12*s - 7) + s*(15 - 28*s))*(k2**2)**(3/2) + Pkdd2*k2**4*(4*s**2 - 5*s + 1)*np.sqrt(k2**2) + 2*k2**3*(Pk2*(K*(r*(48*s - 7) + 7*s - 3) + r*(37 - 96*s) + 72*s**2 - 19*s - 3) + 2*Pkd2*(-4*K*s + K + r*(8*s - 5) + s*(6 - 12*s))*np.sqrt(k2**2)))) - 88*g2*k1**2*(Pk2*(r*(36*s - 50) - 19*s + 15)*(k2**2)**(3/2) + k2**3*(Pk2*(-184*r*s + 103*r + 35*s - 23) + 4*Pkd2*(16*r*s - 9*r - 3*s + 2)*np.sqrt(k2**2))))) - f*(39*D1*bd1*(f**2*(-24*Pk2*k2**4*r*(3*r + 10)*np.sqrt(k2**2) + k1**4*s*(8*Pk2*(631*s - 257) + k2*(Pkd2*(625 - 1571*s) + Pkdd2*k2*(103*s - 37)))*np.sqrt(k2**2) + k1**2*(4*Pk2*(126*r**2 + 3*r*(58*s - 75) + 198*s**2 - 293*s + 34)*(k2**2)**(3/2) + 33*Pkdd2*k2**4*s*(6*s - 5)*np.sqrt(k2**2) + k2**3*(12*Pk2*(12*r*(13*s + 9) + 7*s - 34) + Pkd2*(432*r*(s - 1) - 594*s**2 + 445*s + 136)*np.sqrt(k2**2)))) + 22*f*(14*Pk2*k2**4*r*(r - 1)*np.sqrt(k2**2) + k1**4*s*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**2*(2*Pk2*(r*(K + 6*s - 2) + s*(-3*K - 7*s + 2))*(k2**2)**(3/2) + Pkdd2*k2**4*s*(s - 1)*np.sqrt(k2**2) + 2*k2**3*(Pk2*(4*r*(3*K*s - K - 6*s + 1) + s*(7*K + 18*s - 1)) + Pkd2*(r*(K + 4*s - 1) + s*(-3*K - 6*s + 1))*np.sqrt(k2**2)))) - 88*g2*k1**2*(3*Pk2*(r*(3*s - 5) - 5*s + 5)*(k2**2)**(3/2) - k2**3*(23*Pk2 - 8*Pkd2*np.sqrt(k2**2))*(r*(2*s - 1) - s + 1))) + 1716*b2*k1**2*(D1*fd*(Pk2*(r*(6*s - 7) - 4*s + 4)*(k2**2)**(3/2) - k2**3*(3*Pk2 - Pkd2*np.sqrt(k2**2))*(r*(4*s - 5) - 3*s + 3)) + Dd*f*(Pk2*(3*r*(4*s - 3) - 10*s + 4)*(k2**2)**(3/2) - k2**3*(3*Pk2 - Pkd2*np.sqrt(k2**2))*(r*(8*s - 5) - 9*s + 3))) + k1**2*(D1*f**2*fd*(-65*Pkd2*k1**2*k2*(2004*s**2 - 1501*s + 250)*np.sqrt(k2**2) + 156*k2**3*(8*Pk2*(4*r*(64*s - 13) - 56*s + 11) + Pkd2*(128*r*(2*s - 1) + 540*s**2 - 415*s + 86)*np.sqrt(k2**2)) + (24*Pk2*k2**2*(3260*r**2 + r*(416*s - 2111) - 5460*s**2 + 3445*s - 222) + 65*k1**2*(4*s - 1)*(8*Pk2*(183*s - 80) + 15*Pkdd2*k2**2*(3*s - 2)))*np.sqrt(k2**2)) - 1716*D1*f*(Pk2*bd2*(6*k2**3*r*s + r*(1 - 3*s)*(k2**2)**(3/2) + s*(-9*k2**3 + 3*(k2**2)**(3/2))) + 2*Pk2*gd2*(r - 3*s)*(k2**2)**(3/2) + Pkd2*bd2*k2**3*s*(3 - 2*r)*np.sqrt(k2**2) + 2*gd2*k2**3*(4*Pk2*r*(3*s - 1) + 7*Pk2*s + Pkd2*(r - 3*s)*np.sqrt(k2**2))) + 3432*D1*fd*g2*(2*Pk2*(r + s - 1)*(k2**2)**(3/2) + k2**3*(-Pk2*(24*r*s + r - 7*s - 3) + 2*Pkd2*(r + s - 1)*np.sqrt(k2**2))) + Dd*f**3*(-65*Pkd2*k1**2*k2*(2004*s**2 - 1501*s + 250)*np.sqrt(k2**2) + 156*k2**3*(8*Pk2*(4*r*(64*s - 13) - 56*s + 11) + Pkd2*(128*r*(2*s - 1) + 540*s**2 - 415*s + 86)*np.sqrt(k2**2)) + (24*Pk2*k2**2*(3260*r**2 + r*(416*s - 2111) - 5460*s**2 + 3445*s - 222) + 65*k1**2*(4*s - 1)*(8*Pk2*(183*s - 80) + 15*Pkdd2*k2**2*(3*s - 2)))*np.sqrt(k2**2)) + 3432*Dd*f*g2*(2*Pk2*(4*s - 1)*(k2**2)**(3/2) + k2**3*(Pk2*(-48*r*s + 7*r - 7*s + 3) + 2*Pkd2*(4*s - 1)*np.sqrt(k2**2))))))/(9009*d**2*k1**3*k2**3*np.sqrt(k2**2)) - 2*D1**3*Pk1*ct*(33*b1**3*(D1*fd*(-28*Pkd2*k1**4*k2*s**2*np.sqrt(k2**2) - 6*k1**2*k2**3*r*s*(Pk2 - Pkd2*np.sqrt(k2**2)) + k1**2*s*(42*Pk2*k1**2*s + k2**2*(6*Pk2*r + 7*Pkdd2*k1**2*s))*np.sqrt(k2**2) + k2**4*(2*Pk2*r**2 + 7*Pkdd2*k1**2*s**2)*np.sqrt(k2**2)) + Dd*f*(2*Pk2*k2**4*r*(4*r - 1)*np.sqrt(k2**2) + 7*k1**4*s*(6*Pk2 + k2*(-4*Pkd2 + Pkdd2*k2))*(4*s - 1)*np.sqrt(k2**2) + k1**2*(6*Pk2*(4*r*(s - 1) + 3*s)*(k2**2)**(3/2) + 7*Pkdd2*k2**4*s*(4*s - 1)*np.sqrt(k2**2) - 6*k2**3*(Pk2 - Pkd2*np.sqrt(k2**2))*(4*r*(s - 1) + 3*s)))) + 33*b1**2*(D1*(bd1*f*(2*Pk2*k2**4*r*(3*r - 1)*np.sqrt(k2**2) + 7*k1**4*s*(6*Pk2 + k2*(-4*Pkd2 + Pkdd2*k2))*(3*s - 1)*np.sqrt(k2**2) + k1**2*(6*Pk2*(r*(3*s - 4) + 3*s)*(k2**2)**(3/2) + 7*Pkdd2*k2**4*s*(3*s - 1)*np.sqrt(k2**2) - 6*k2**3*(Pk2 - Pkd2*np.sqrt(k2**2))*(r*(3*s - 4) + 3*s))) + fd*(2*Pk2*k2**4*(f*(8*r - 4) - 19*r**2 + 10*r - 5)*np.sqrt(k2**2) + k1**4*(-2*Pk2*(12*f*(3*s**2 - 7*s + 2) + 39*s**2 - 70*s + 35) + k2*(Pkd2*(f*(18*s**2 - 91*s + 26) + 25*s**2 - 42*s + 21) + 24*Pkdd2*f*k2*s**2))*np.sqrt(k2**2) + k1**2*(Pk2*(-6*K*s + 2*f*(52*r**2 + 36*r*s - 31*r + 12*s**2 - 22*s + 10) - 6*r**2 - 6*r*(6*K*s - 7*K - 8*s + 5) + 25*s**2 - 48*s + 15)*(k2**2)**(3/2) + 12*Pkdd2*f*k2**4*s**2*np.sqrt(k2**2) + k2**3*(-Pk2*(f*(r*(36 - 264*s) + 64*s) + 53*s**2 + s*(10*K*(r - 1) + 2*r - 100) + 49) + Pkd2*(f*(r*(88*s - 8) + 174*s**2 - 123*s + 26) + 25*s**2 + s*(6*K*(r - 1) + 6*r - 48) + 21)*np.sqrt(k2**2))))) + Dd*f*(2*Pk2*k2**4*(4*r - 1)*(4*f - 19*r + 5)*np.sqrt(k2**2) + k1**4*(4*s - 1)*(Pk2*(f*(48 - 36*s) - 78*s + 70) + k2*(Pkd2*(9*f*s - 26*f + 25*s - 21) + 12*Pkdd2*f*k2*s))*np.sqrt(k2**2) + k1**2*(Pk2*(-6*K*(24*r*s - 3*r + 13*s - 4) + 2*f*(104*r**2 + r*(72*s - 78) + 24*s**2 - 48*s + 19) - 24*r**2 + 192*r*s - 36*r + 100*s**2 - 187*s + 39)*(k2**2)**(3/2) + 6*Pkdd2*f*k2**4*s*(4*s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(K*(-40*r*s + 68*r + 214*s - 68) + 4*f*(4*r*(33*s - 8) - 29*s + 7) - 8*r*s - 20*r - 212*s**2 + 191*s - 29) + Pkd2*(6*K*(4*r*(s - 1) - 13*s + 4) + f*(16*r*(11*s - 3) + 348*s**2 - 267*s + 46) + 24*r*s - 24*r + 100*s**2 - 187*s + 45)*np.sqrt(k2**2))))) + 3*b1*(880*D1*K*Pk2*f*fd*k1**2*k2**3*r*s - 396*D1*K*Pk2*f*fd*k1**2*k2**3*r - 1012*D1*K*Pk2*f*fd*k1**2*k2**3*s + 484*D1*K*Pk2*f*fd*k1**2*k2**3 - 1056*D1*K*Pk2*f*fd*k1**2*r*s*(k2**2)**(3/2) + 506*D1*K*Pk2*f*fd*k1**2*r*(k2**2)**(3/2) - 22*D1*K*Pk2*f*fd*k1**2*s*(k2**2)**(3/2) + 22*D1*K*Pk2*f*fd*k1**2*(k2**2)**(3/2) + 88*D1*K*Pkd2*f*fd*k1**2*k2**3*r*s*np.sqrt(k2**2) - 88*D1*K*Pkd2*f*fd*k1**2*k2**3*r*np.sqrt(k2**2) - 44*D1*K*Pkd2*f*fd*k1**2*k2**3*s*np.sqrt(k2**2) + 44*D1*K*Pkd2*f*fd*k1**2*k2**3*np.sqrt(k2**2) - 66*D1*Pk2*bd2*f*k1**2*k2**3*r*s + 264*D1*Pk2*bd2*f*k1**2*k2**3*s + 66*D1*Pk2*bd2*f*k1**2*r*s*(k2**2)**(3/2) - 264*D1*Pk2*bd2*f*k1**2*s*(k2**2)**(3/2) - 3630*D1*Pk2*f**2*fd*k1**4*s**2*np.sqrt(k2**2) + 3960*D1*Pk2*f**2*fd*k1**4*s*np.sqrt(k2**2) - 880*D1*Pk2*f**2*fd*k1**4*np.sqrt(k2**2) + 4752*D1*Pk2*f**2*fd*k1**2*k2**3*r*s - 352*D1*Pk2*f**2*fd*k1**2*k2**3*r - 2904*D1*Pk2*f**2*fd*k1**2*k2**3*s + 264*D1*Pk2*f**2*fd*k1**2*k2**3 + 1620*D1*Pk2*f**2*fd*k1**2*r**2*(k2**2)**(3/2) + 396*D1*Pk2*f**2*fd*k1**2*r*s*(k2**2)**(3/2) - 1344*D1*Pk2*f**2*fd*k1**2*r*(k2**2)**(3/2) + 396*D1*Pk2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) - 330*D1*Pk2*f**2*fd*k1**2*s*(k2**2)**(3/2) + 312*D1*Pk2*f**2*fd*k1**2*(k2**2)**(3/2) - 924*D1*Pk2*f*fd*k1**4*s**2*np.sqrt(k2**2) + 1474*D1*Pk2*f*fd*k1**4*s*np.sqrt(k2**2) - 506*D1*Pk2*f*fd*k1**4*np.sqrt(k2**2) + 880*D1*Pk2*f*fd*k1**2*k2**3*r*s - 396*D1*Pk2*f*fd*k1**2*k2**3*r - 374*D1*Pk2*f*fd*k1**2*k2**3*s**2 - 363*D1*Pk2*f*fd*k1**2*k2**3*s + 253*D1*Pk2*f*fd*k1**2*k2**3 + 44*D1*Pk2*f*fd*k1**2*r**2*(k2**2)**(3/2) + 1144*D1*Pk2*f*fd*k1**2*r*s*(k2**2)**(3/2) - 616*D1*Pk2*f*fd*k1**2*r*(k2**2)**(3/2) + 550*D1*Pk2*f*fd*k1**2*s**2*(k2**2)**(3/2) - 847*D1*Pk2*f*fd*k1**2*s*(k2**2)**(3/2) + 297*D1*Pk2*f*fd*k1**2*(k2**2)**(3/2) - 484*D1*Pk2*f*fd*k2**4*r**2*np.sqrt(k2**2) + 242*D1*Pk2*f*fd*k2**4*r*np.sqrt(k2**2) + 220*D1*Pk2*f*gd2*k1**2*k2**3*r*s - 1496*D1*Pk2*f*gd2*k1**2*k2**3*s + 792*D1*Pk2*f*gd2*k1**2*r*s*(k2**2)**(3/2) + 528*D1*Pk2*f*gd2*k1**2*s*(k2**2)**(3/2) + 220*D1*Pk2*fd*g2*k1**2*k2**3*r*s - 220*D1*Pk2*fd*g2*k1**2*k2**3*s + 792*D1*Pk2*fd*g2*k1**2*r*s*(k2**2)**(3/2) - 924*D1*Pk2*fd*g2*k1**2*r*(k2**2)**(3/2) + 132*D1*Pk2*fd*g2*k1**2*s*(k2**2)**(3/2) + 66*D1*Pkd2*bd2*f*k1**2*k2**3*r*s*np.sqrt(k2**2) - 264*D1*Pkd2*bd2*f*k1**2*k2**3*s*np.sqrt(k2**2) + 1848*D1*Pkd2*f**2*fd*k1**4*k2*s**2*np.sqrt(k2**2) - 2178*D1*Pkd2*f**2*fd*k1**4*k2*s*np.sqrt(k2**2) + 484*D1*Pkd2*f**2*fd*k1**4*k2*np.sqrt(k2**2) + 792*D1*Pkd2*f**2*fd*k1**2*k2**3*r*s*np.sqrt(k2**2) - 264*D1*Pkd2*f**2*fd*k1**2*k2**3*r*np.sqrt(k2**2) + 2178*D1*Pkd2*f**2*fd*k1**2*k2**3*s**2*np.sqrt(k2**2) - 1353*D1*Pkd2*f**2*fd*k1**2*k2**3*s*np.sqrt(k2**2) + 330*D1*Pkd2*f**2*fd*k1**2*k2**3*np.sqrt(k2**2) + 550*D1*Pkd2*f*fd*k1**4*k2*s**2*np.sqrt(k2**2) - 825*D1*Pkd2*f*fd*k1**4*k2*s*np.sqrt(k2**2) + 275*D1*Pkd2*f*fd*k1**4*k2*np.sqrt(k2**2) + 88*D1*Pkd2*f*fd*k1**2*k2**3*r*s*np.sqrt(k2**2) - 88*D1*Pkd2*f*fd*k1**2*k2**3*r*np.sqrt(k2**2) + 550*D1*Pkd2*f*fd*k1**2*k2**3*s**2*np.sqrt(k2**2) - 869*D1*Pkd2*f*fd*k1**2*k2**3*s*np.sqrt(k2**2) + 319*D1*Pkd2*f*fd*k1**2*k2**3*np.sqrt(k2**2) - 132*D1*Pkd2*f*gd2*k1**2*k2**3*r*s*np.sqrt(k2**2) + 528*D1*Pkd2*f*gd2*k1**2*k2**3*s*np.sqrt(k2**2) - 132*D1*Pkd2*fd*g2*k1**2*k2**3*r*s*np.sqrt(k2**2) + 132*D1*Pkd2*fd*g2*k1**2*k2**3*s*np.sqrt(k2**2) + 165*D1*Pkdd2*f**2*fd*k1**4*s**2*(k2**2)**(3/2) + 22*D1*bd1*f*(2*Pk2*k2**4*r*(4*f - 19*r + 12)*np.sqrt(k2**2) + k1**4*s*(Pk2*(-6*f*(6*s - 5) - 78*s + 74) + k2*(Pkd2*(9*f*s - 11*f + 25*s - 23) + 6*Pkdd2*f*k2*(2*s - 1)))*np.sqrt(k2**2) + k1**2*(Pk2*(-12*K*(3*r*s + r + 2*s - 1) + f*(52*r**2 + r*(36*s - 47) + 12*s**2 - 26*s + 9) - 6*r**2 + 48*r*s - 6*r + 25*s**2 - 47*s + 12)*(k2**2)**(3/2) + 3*Pkdd2*f*k2**4*s*(2*s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(K*(-10*r*s + 34*r + 68*s - 34) + 2*f*(r*(66*s - 23) - 13*s + 7) - 2*r*s - 10*r - 53*s**2 + 31*s + 10) + Pkd2*(6*K*(r*(s - 2) - 4*s + 2) + f*(4*r*(11*s - 5) + 87*s**2 - 72*s + 10) + 6*r*s - 12*r + 25*s**2 - 47*s + 12)*np.sqrt(k2**2)))) + 1760*Dd*K*Pk2*f**2*k1**2*k2**3*r*s - 308*Dd*K*Pk2*f**2*k1**2*k2**3*r - 2068*Dd*K*Pk2*f**2*k1**2*k2**3*s + 484*Dd*K*Pk2*f**2*k1**2*k2**3 - 2112*Dd*K*Pk2*f**2*k1**2*r*s*(k2**2)**(3/2) + 462*Dd*K*Pk2*f**2*k1**2*r*(k2**2)**(3/2) - 22*Dd*K*Pk2*f**2*k1**2*s*(k2**2)**(3/2) + 22*Dd*K*Pk2*f**2*k1**2*(k2**2)**(3/2) + 176*Dd*K*Pkd2*f**2*k1**2*k2**3*r*s*np.sqrt(k2**2) - 176*Dd*K*Pkd2*f**2*k1**2*k2**3*r*np.sqrt(k2**2) - 44*Dd*K*Pkd2*f**2*k1**2*k2**3*s*np.sqrt(k2**2) + 44*Dd*K*Pkd2*f**2*k1**2*k2**3*np.sqrt(k2**2) - 4840*Dd*Pk2*f**3*k1**4*s**2*np.sqrt(k2**2) + 4730*Dd*Pk2*f**3*k1**4*s*np.sqrt(k2**2) - 880*Dd*Pk2*f**3*k1**4*np.sqrt(k2**2) + 6336*Dd*Pk2*f**3*k1**2*k2**3*r*s - 1496*Dd*Pk2*f**3*k1**2*k2**3*r - 3960*Dd*Pk2*f**3*k1**2*k2**3*s + 968*Dd*Pk2*f**3*k1**2*k2**3 + 2160*Dd*Pk2*f**3*k1**2*r**2*(k2**2)**(3/2) + 528*Dd*Pk2*f**3*k1**2*r*s*(k2**2)**(3/2) - 1612*Dd*Pk2*f**3*k1**2*r*(k2**2)**(3/2) + 528*Dd*Pk2*f**3*k1**2*s**2*(k2**2)**(3/2) - 440*Dd*Pk2*f**3*k1**2*s*(k2**2)**(3/2) + 312*Dd*Pk2*f**3*k1**2*(k2**2)**(3/2) - 1848*Dd*Pk2*f**2*k1**4*s**2*np.sqrt(k2**2) + 2486*Dd*Pk2*f**2*k1**4*s*np.sqrt(k2**2) - 506*Dd*Pk2*f**2*k1**4*np.sqrt(k2**2) + 1760*Dd*Pk2*f**2*k1**2*k2**3*r*s - 308*Dd*Pk2*f**2*k1**2*k2**3*r - 748*Dd*Pk2*f**2*k1**2*k2**3*s**2 - 957*Dd*Pk2*f**2*k1**2*k2**3*s + 253*Dd*Pk2*f**2*k1**2*k2**3 + 88*Dd*Pk2*f**2*k1**2*r**2*(k2**2)**(3/2) + 2288*Dd*Pk2*f**2*k1**2*r*s*(k2**2)**(3/2) - 660*Dd*Pk2*f**2*k1**2*r*(k2**2)**(3/2) + 1100*Dd*Pk2*f**2*k1**2*s**2*(k2**2)**(3/2) - 1397*Dd*Pk2*f**2*k1**2*s*(k2**2)**(3/2) + 297*Dd*Pk2*f**2*k1**2*(k2**2)**(3/2) - 968*Dd*Pk2*f**2*k2**4*r**2*np.sqrt(k2**2) + 242*Dd*Pk2*f**2*k2**4*r*np.sqrt(k2**2) + 880*Dd*Pk2*f*g2*k1**2*k2**3*r*s - 1496*Dd*Pk2*f*g2*k1**2*k2**3*r - 4708*Dd*Pk2*f*g2*k1**2*k2**3*s + 1496*Dd*Pk2*f*g2*k1**2*k2**3 + 3168*Dd*Pk2*f*g2*k1**2*r*s*(k2**2)**(3/2) - 396*Dd*Pk2*f*g2*k1**2*r*(k2**2)**(3/2) + 1716*Dd*Pk2*f*g2*k1**2*s*(k2**2)**(3/2) - 528*Dd*Pk2*f*g2*k1**2*(k2**2)**(3/2) + 2464*Dd*Pkd2*f**3*k1**4*k2*s**2*np.sqrt(k2**2) - 2552*Dd*Pkd2*f**3*k1**4*k2*s*np.sqrt(k2**2) + 484*Dd*Pkd2*f**3*k1**4*k2*np.sqrt(k2**2) + 1056*Dd*Pkd2*f**3*k1**2*k2**3*r*s*np.sqrt(k2**2) - 352*Dd*Pkd2*f**3*k1**2*k2**3*r*np.sqrt(k2**2) + 2904*Dd*Pkd2*f**3*k1**2*k2**3*s**2*np.sqrt(k2**2) - 1958*Dd*Pkd2*f**3*k1**2*k2**3*s*np.sqrt(k2**2) + 330*Dd*Pkd2*f**3*k1**2*k2**3*np.sqrt(k2**2) + 1100*Dd*Pkd2*f**2*k1**4*k2*s**2*np.sqrt(k2**2) - 1375*Dd*Pkd2*f**2*k1**4*k2*s*np.sqrt(k2**2) + 275*Dd*Pkd2*f**2*k1**4*k2*np.sqrt(k2**2) + 176*Dd*Pkd2*f**2*k1**2*k2**3*r*s*np.sqrt(k2**2) - 176*Dd*Pkd2*f**2*k1**2*k2**3*r*np.sqrt(k2**2) + 1100*Dd*Pkd2*f**2*k1**2*k2**3*s**2*np.sqrt(k2**2) - 1419*Dd*Pkd2*f**2*k1**2*k2**3*s*np.sqrt(k2**2) + 319*Dd*Pkd2*f**2*k1**2*k2**3*np.sqrt(k2**2) - 528*Dd*Pkd2*f*g2*k1**2*k2**3*r*s*np.sqrt(k2**2) + 528*Dd*Pkd2*f*g2*k1**2*k2**3*r*np.sqrt(k2**2) + 1716*Dd*Pkd2*f*g2*k1**2*k2**3*s*np.sqrt(k2**2) - 528*Dd*Pkd2*f*g2*k1**2*k2**3*np.sqrt(k2**2) + 220*Dd*Pkdd2*f**3*k1**4*s**2*(k2**2)**(3/2) - 55*Dd*Pkdd2*f**3*k1**4*s*(k2**2)**(3/2) + 66*b2*k1**2*(Pk2*(k2**2)**(3/2) + k2**3*(-Pk2 + Pkd2*np.sqrt(k2**2)))*(D1*fd*s*(r - 1) + Dd*f*(4*r*(s - 1) - 13*s + 4))) + f*(3*D1*bd1*(f**2*k1**2*(22*Pkd2*k1**2*k2*s*(28*s - 17)*np.sqrt(k2**2) + 11*k2**3*(8*Pk2*(r*(18*s - 13) - 12*s + 8) + Pkd2*(8*r*(3*s - 1) + 11*s*(6*s - 5))*np.sqrt(k2**2)) + (110*Pk2*k1**2*s*(7 - 11*s) + k2**2*(540*Pk2*r**2 + 4*Pk2*r*(33*s - 67) + 22*Pk2*s*(6*s - 5) + 55*Pkdd2*k1**2*s*(s - 1)))*np.sqrt(k2**2)) - 11*f*(22*Pk2*k2**4*r**2*np.sqrt(k2**2) + k1**4*s*(Pk2*(42*s - 46) - 25*Pkd2*k2*(s - 1))*np.sqrt(k2**2) + k1**2*(Pk2*(-2*r**2 + 2*r*(24*K*s + K - 26*s + 1) - s*(25*s - 25))*(k2**2)**(3/2) + k2**3*(Pk2*(r*(-4*K - 4)*(10*s + 1) + s*(48*K + 17*s + 27)) - Pkd2*(s - 1)*(r*(4*K + 4) + 25*s)*np.sqrt(k2**2)))) - 44*g2*k1**2*(-6*Pk2*(3*r*s + 2*r + 2*s - 2)*(k2**2)**(3/2) + k2**3*(Pk2*(r*(34 - 5*s) + 34*s - 34) + 3*Pkd2*(r*(s - 4) - 4*s + 4)*np.sqrt(k2**2)))) + 66*b2*k1**2*(3*D1*bd1*(Pk2*(k2**2)**(3/2) + k2**3*(-Pk2 + Pkd2*np.sqrt(k2**2)))*(r*(s - 4) - 4*s + 4) + D1*fd*(Pk2*(2*r - 1)*(s - 1)*(k2**2)**(3/2) + 2*k2**3*(Pk2*(r*(20*s - 9) - 23*s + 11) + Pkd2*(2*r - 1)*(s - 1)*np.sqrt(k2**2))) + Dd*f*(Pk2*(4*r - 1)*(s - 1)*(k2**2)**(3/2) + 2*k2**3*(Pk2*(r*(40*s - 7) - 47*s + 11) + Pkd2*(4*r - 1)*(s - 1)*np.sqrt(k2**2)))) + k1**2*(D1*(66*f*(Pk2*bd2*r*(s - 1)*(k2**2)**(3/2) + 2*Pk2*gd2*r*(24*s + 1)*(k2**2)**(3/2) + 2*bd2*k2**3*(Pk2*(10*r*s + r - 12*s) + Pkd2*r*(s - 1)*np.sqrt(k2**2)) - 4*gd2*k2**3*(Pk2*(10*r*s + r - 12*s) + Pkd2*r*(s - 1)*np.sqrt(k2**2))) + fd*(132*Pk2*g2*(r*(48*s - 23) + s - 1)*(k2**2)**(3/2) + 5*f**2*k1**2*(-112*Pk2 + 61*Pkd2*k2)*(12*s**2 - 11*s + 2)*np.sqrt(k2**2) - 264*g2*k2**3*(Pk2*(r*(20*s - 9) - 23*s + 11) + Pkd2*(2*r - 1)*(s - 1)*np.sqrt(k2**2)))) + Dd*f*(132*Pk2*g2*(3*r*(32*s - 7) + s - 1)*(k2**2)**(3/2) + 5*f**2*k1**2*(-112*Pk2 + 61*Pkd2*k2)*(12*s**2 - 11*s + 2)*np.sqrt(k2**2) - 264*g2*k2**3*(Pk2*(r*(40*s - 7) - 47*s + 11) + Pkd2*(4*r - 1)*(s - 1)*np.sqrt(k2**2))))))/(693*d**2*k1**3*k2**3*np.sqrt(k2**2)) + 4*D1**3*Pk1*ct*st**4*(33*D1*bd1*f*(b1*k1**2*(8*Pk2*k1**2*s*(1 - 2*s)*(k2**2)**(3/2) + 5*Pkd2*k1**2*k2**3*s*(2*s - 1)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(4*C - 4)*(4*s - 1) + s*(-4*C + 2*s + 3))*np.sqrt(k2**2) + Pkdd2*k2**7*s*(1 - 2*s) + k2**4*(-Pk2*(8*C - 8)*(r*(4*s - 1) - s) + Pkdd2*k1**2*s*(1 - 2*s))*np.sqrt(k2**2)) + f*(-4*Pk2*k2**7*r*(r - 1) + k1**4*(Pk2*s*(4*r + s*(32*C + 8) - 13)*(k2**2)**(3/2) + Pkdd2*k2**4*s*(s*(2*C + 2) - 1)*np.sqrt(k2**2) + k2**3*(-Pk2*(r*(11*s + 6) + 4*s - 6) + Pkd2*(r*(s + 2) - s**2*(14*C + 8) + 8*s - 2)*np.sqrt(k2**2))) - k1**2*k2**4*(Pk2*(4*C*(r**2 - 10*r*s + 2*s - 1) - 4*r**2 + r*(35*s + 6) - 4*s**2 + s - 2)*np.sqrt(k2**2) + Pkd2*k2*(4*C*(r*(4*s - 1) - 2*s + 1) + r*(2 - 15*s) + 4*s**2 + 4*s - 2)*np.sqrt(k2**2) + Pkdd2*k2**3*s*(1 - 2*s)))) + 33*b1**2*k1**2*(D1*fd*s*(-8*Pk2*k1**2*s*(k2**2)**(3/2) + 5*Pkd2*k1**2*k2**3*s*np.sqrt(k2**2) + Pkd2*k2**5*(r*(8*C - 8) + s)*np.sqrt(k2**2) - Pkdd2*k2**7*s - k2**4*(Pk2*r*(16*C - 16) + Pkdd2*k1**2*s)*np.sqrt(k2**2)) + Dd*f*(8*Pk2*k1**2*s*(1 - 4*s)*(k2**2)**(3/2) + 5*Pkd2*k1**2*k2**3*s*(4*s - 1)*np.sqrt(k2**2) + Pkd2*k2**5*(r*(4*C - 4)*(8*s - 1) + s*(-4*C + 4*s + 3))*np.sqrt(k2**2) + Pkdd2*k2**7*s*(1 - 4*s) + k2**4*(-Pk2*(8*C - 8)*(r*(8*s - 1) - s) + Pkdd2*k1**2*s*(1 - 4*s))*np.sqrt(k2**2))) - 33*b1*f*(D1*fd*(8*Pk2*k2**7*r**2 - k1**4*(Pk2*(k2**3*r*(3 - 22*s) + (r*(8*s - 3) + (8*s - 4)*(s*(8*C + 2) - 3))*(k2**2)**(3/2)) + k2**3*(Pkd2*(2*r*s + r - (4*s - 2)*(7*C*s + 4*s - 3)) + Pkdd2*k2*(2*s - 1)*(s*(2*C + 2) - 1))*np.sqrt(k2**2)) - k1**2*k2**4*(2*Pk2*(r**2*(4 - 4*C) + 5*r*(C*(8*s - 4) - 7*s + 3) + (1 - 2*s)**2)*np.sqrt(k2**2) + Pkd2*k2*(r*(C*(16 - 32*s) + 30*s - 13) - 2*(1 - 2*s)**2)*np.sqrt(k2**2) + Pkdd2*k2**3*(1 - 2*s)**2)) + Dd*f*(4*Pk2*k2**7*r*(4*r - 1) - k1**4*(Pk2*(r*(16*s - 3) + s**2*(128*C + 32) - s*(32*C + 57) + 12)*(k2**2)**(3/2) + Pkdd2*k2**4*(4*s - 1)*(s*(2*C + 2) - 1)*np.sqrt(k2**2) + k2**3*(-Pk2*(r*(44*s + 9) + 4*s - 6) + Pkd2*(r*(4*s + 5) - s**2*(56*C + 32) + s*(14*C + 34) - 8)*np.sqrt(k2**2))) - k1**2*k2**4*(Pk2*(-4*C*(4*r**2 + r*(11 - 40*s) + 2*s - 1) + 16*r**2 + r*(22 - 140*s) + 16*s**2 - 11*s + 4)*np.sqrt(k2**2) + k2*(-4*C*Pkd2*(2*r*(8*s - 3) - 2*s + 1)*np.sqrt(k2**2) + Pkd2*(r*(60*s - 17) + s*(6 - 16*s))*np.sqrt(k2**2) + Pkdd2*k2**2*(8*s**2 - 6*s + 1))))) + f**2*(D1*fd*(Pk2*k2**6*(3*r - 1)*(k2*(51 - 87*r) + 2*(3*r - 1)*np.sqrt(k2**2)) + k1**6*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*np.sqrt(k2**2) + k1**4*(3*s - 1)*(Pk2*(-24*C*(r - 28*s + 9) + 60*r - 333*s + 91)*(k2**2)**(3/2) + Pkdd2*k2**4*(20*C + 1)*(3*s - 1)*np.sqrt(k2**2) + k2**3*(5*Pk2*(8*C*(3*r - 1) - 60*r + 9*s + 17) + Pkd2*(-4*C*(6*r + 87*s - 31) + 60*r + 63*s - 41)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(24*C*(3*r - 1)*(3*r - 2*s - 4) - 225*r**2 + 396*r*s + 84*r - 180*s**2 - 12*s - 23) + 2*Pkd2*k2*(-C*(3*r - 1)*(27*s - 20) + (3*s - 1)*(6*r + 15*s - 7)))*np.sqrt(k2**2)) + Dd*f*(Pk2*k2**6*(4*r - 1)*(k2*(51 - 87*r) + 2*(3*r - 1)*np.sqrt(k2**2)) + k1**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1)*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(r*(7 - 24*s) + 672*s**2 - 385*s + 54) + 10*r*(24*s - 7) - 1332*s**2 + 707*s - 91)*(k2**2)**(3/2) + Pkdd2*k2**4*(20*C + 1)*(12*s**2 - 7*s + 1)*np.sqrt(k2**2) + k2**3*(5*Pk2*(4*C*(24*r*s - 7*r - 7*s + 2) - 240*r*s + 70*r + 36*s**2 + 49*s - 17) + Pkd2*(-4*C*(24*r*s - 7*r + 348*s**2 - 210*s + 31) + 240*r*s - 70*r + 252*s**2 - 217*s + 41)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(12*C*(24*r**2 - 16*r*s - 35*r + s + 8) - 300*r**2 + 528*r*s + 87*r - 240*s**2 + 8*s - 23) + 2*Pkd2*k2*(C*(-108*r*s + 70*r + 37*s - 20) + 24*r*s - 7*r + 60*s**2 - 42*s + 7))*np.sqrt(k2**2))))/(231*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) + 2*D1**3*Pk1*ct*st**2*(33*D1*bd1*f*(b1*(2*Pk2*k2**6*r*(-10*k2 + np.sqrt(k2**2))*(2*r - 1) + k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(C*(4 - 16*s) + 96*s - 31) + 2*s*(C*(88*s - 42) - 89*s + 36))*(k2**2)**(3/2) + Pkdd2*k2**4*s*(26*C + 8)*(2*s - 1)*np.sqrt(k2**2) + k2**3*(3*Pk2*(r*(16*C*s - 4*C - 82*s + 31) + s*(-4*C + 2*s + 9)) + Pkd2*(r*(-16*C*s + 4*C + 82*s - 31) + s*(-140*C*s + 74*C + 70*s - 45))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(r**2*(40 - 40*C) + 2*r*(4*C*(5*s - 4) + s + 16) + s*(32*C - 53))*np.sqrt(k2**2) + Pkd2*k2*(r*(-28*C*(4*s - 1) + 134*s - 37) + 2*s*(14*C + 20*s - 25))*np.sqrt(k2**2) + 7*Pkdd2*k2**3*s*(2*s - 1))) + f*(2*Pk2*k2**6*r*(-2*k2*r + k2 + r*np.sqrt(k2**2)) + k1**6*s*(-4*Pk2*(9*s - 5) + k2*(Pkd2*(6*s - 2) + Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(-6*C*Pkdd2*k2**4*s*np.sqrt(k2**2) + Pk2*(4*C*(r*(3*s - 2) - 92*s**2 + 14*s + 3) + 22*r**2 - r*(3*s + 19) + 246*s**2 - 46*s - 8)*(k2**2)**(3/2) + k2**3*(Pk2*(-4*C*(25*r*s - 9*r - 35*s + 12) + 160*r*s - 17*r - 30*s**2 - 56*s + 32) + Pkd2*(2*C*(6*r*s - 4*r + 56*s**2 - 27*s + 6) + 22*r*s - 13*r + 30*s**2 - 42*s + 8)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(C*(44*r**2 - 56*r*s - 4*r + 8*s - 8) - 44*r**2 + r*(59*s + 2) + 132*s**2 - 74*s + 8)*np.sqrt(k2**2) + Pkd2*k2*(4*C*(4*r + 3*s - 3) + r*(2*s - 7) + 8*s**2 - 26*s + 12)*np.sqrt(k2**2) - Pkdd2*k2**3*s*(s - 1)))) + 33*b1**2*(D1*fd*(2*Pk2*k2**6*r**2*np.sqrt(k2**2) - 5*Pkd2*k1**6*k2*s**2*np.sqrt(k2**2) + Pkd2*k1**2*k2**5*s*(r*(67 - 56*C) + 20*s)*np.sqrt(k2**2) + k1**4*k2**3*s*(3*Pk2*(8*C*r - 41*r + s) + Pkd2*(-8*C*r - 70*C*s + 41*r + 35*s)*np.sqrt(k2**2)) + k1**4*s*(8*Pk2*k1**2*s + k2**2*(Pk2*r*(48 - 8*C) + Pk2*s*(88*C - 89) + Pkdd2*k1**2*s))*np.sqrt(k2**2) + k1**2*k2**4*(Pk2*r*(20*C*s + r*(20 - 20*C) + s) + Pkdd2*k1**2*s**2*(26*C + 8))*np.sqrt(k2**2) + k2**7*(-20*Pk2*r**2 + 7*Pkdd2*k1**2*s**2)) + Dd*f*(2*Pk2*k2**6*r*(-10*k2 + np.sqrt(k2**2))*(4*r - 1) + k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(C*(4 - 32*s) + 192*s - 31) + 4*s*(C*(88*s - 21) - 89*s + 18))*(k2**2)**(3/2) + Pkdd2*k2**4*s*(26*C + 8)*(4*s - 1)*np.sqrt(k2**2) + k2**3*(3*Pk2*(r*(32*C*s - 4*C - 164*s + 31) + s*(-4*C + 4*s + 9)) + Pkd2*(r*(-32*C*s + 4*C + 164*s - 31) + s*(-280*C*s + 74*C + 140*s - 45))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(r**2*(80 - 80*C) + 4*r*(4*C*(5*s - 2) + s + 8) + s*(32*C - 53))*np.sqrt(k2**2) + Pkd2*k2*(r*(-28*C*(8*s - 1) + 268*s - 37) + 2*s*(14*C + 40*s - 25))*np.sqrt(k2**2) + 7*Pkdd2*k2**3*s*(4*s - 1)))) + 33*b1*f*(D1*fd*(-2*Pk2*k2**6*(k2*(4*r**2 - 22*r + 7) + r*(1 - 2*r)*np.sqrt(k2**2)) + k1**6*(-4*Pk2*(18*s**2 - 31*s + 9) + k2*(4*Pkd2*(3*s**2 - 10*s + 3) + Pkdd2*k2*(2*s**2 + 3*s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(8*C*(3*r*(s - 1) - 92*s**2 + 85*s - 16) + 44*r**2 + r*(37 - 6*s) + 492*s**2 - 585*s + 124)*(k2**2)**(3/2) + Pkdd2*k2**4*(6*C*(7*s - 2) + 3*s - 1)*np.sqrt(k2**2) + k2**3*(-Pk2*(r*(4*C*(50*s - 29) - 320*s + 243) + 60*s**2 + 6*s*(8*C - 27) + 24) + Pkd2*(C*(24*r*(s - 1) + 224*s**2 - 254*s + 60) + 44*r*s + 5*r + 60*s**2 - 26*s)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(22*r**2 - r*(28*s + 19) + 15*s + 4) - 88*r**2 + 2*r*(59*s + 24) + 264*s**2 - 303*s + 52)*np.sqrt(k2**2) + Pkd2*k2*(r*(4*s - 15) + 2*s*(4*C + 8*s + 1))*np.sqrt(k2**2) - 2*Pkdd2*k2**3*s**2)) + Dd*f*(-2*Pk2*k2**6*(4*r - 1)*(k2*(2*r - 7) - r*np.sqrt(k2**2)) + k1**6*(4*s - 1)*(-36*Pk2*(s - 1) + k2*(6*Pkd2*(s - 2) + Pkdd2*k2*(s + 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(12*r*(s - 1) - 368*s**2 + 217*s - 29) + 88*r**2 - 6*r*(2*s - 5) + 984*s**2 - 759*s + 116)*(k2**2)**(3/2) + Pkdd2*k2**4*(12*C + 1)*(4*s - 1)*np.sqrt(k2**2) + 2*k2**3*(Pk2*(C*(-200*r*s + 106*r + 40*s - 24) + 8*r*(40*s - 19) - 60*s**2 + 71*s + 4) + 2*Pkd2*(C*(12*r*(s - 1) + 112*s**2 - 91*s + 18) + r*(22*s - 3) + 30*s**2 - 18*s + 2)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(44*r**2 - 8*r*(7*s + 3) + 19*s + 2) - 176*r**2 + 4*r*(59*s + 16) + 528*s**2 - 451*s + 60)*np.sqrt(k2**2) + 2*Pkd2*k2*(2*C*(4*r + 8*s - 3) + 4*r*s - 17*r + 16*s**2 - 12*s + 6)*np.sqrt(k2**2) + Pkdd2*k2**3*s*(1 - 4*s)))) - f**2*(D1*fd*(396*Pk2*k2**7*r*(1 - 3*r) + 3*k1**6*(3*s - 1)*(4*Pk2*(139*s - 83) + k2*(-4*Pkd2*(43*s - 29) + 11*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(24*C*(r*(46 - 72*s) + 1017*s**2 - 841*s + 160) + 1098*r**2 + 9*r*(451*s - 349) - 10314*s**2 + 9582*s - 1574)*(k2**2)**(3/2) + 33*Pkdd2*k2**4*(3*s - 1)*(6*C*(3*s - 2) + s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(4*C*(9*r*(237*s - 167) - 480*s + 424) - 14283*r*s + 7731*r + 3456*s**2 - 546*s - 1192) - 3*Pkd2*(C*(444*r*s - 412*r + 4158*s**2 - 3426*s + 768) - 957*r*s + 539*r - 408*s**2 + 558*s - 214)*np.sqrt(k2**2))) + 3*k1**2*k2**4*(2*Pk2*(8*C*(45*r**2 + 99*r*s - 96*r - 99*s + 49) + 660*r**2 + 909*r*s - 655*r - 198*s**2 + 126*s + 24) + 11*Pkd2*k2*(3*r*(15*s - 7) + 36*s**2 - 36*s + 10))*np.sqrt(k2**2)) + Dd*f*(396*Pk2*k2**7*r*(1 - 4*r) + 3*k1**6*(4*s - 1)*(4*Pk2*(139*s - 83) + k2*(-4*Pkd2*(43*s - 29) + 11*Pkdd2*k2*(s - 1)))*np.sqrt(k2**2) + k1**4*(Pk2*(12*C*(r*(133 - 192*s) + 2712*s**2 - 2043*s + 320) + 1464*r**2 + r*(5412*s - 3835) - 13752*s**2 + 11850*s - 1574)*(k2**2)**(3/2) + 33*Pkdd2*k2**4*(4*s - 1)*(6*C*(3*s - 2) + s - 1)*np.sqrt(k2**2) + k2**3*(Pk2*(4*C*(2844*r*s - 2078*r - 329*s + 424) - 19044*r*s + 9575*r + 4608*s**2 - 1198*s - 1192) - 3*Pkd2*(C*(592*r*s - 620*r + 5544*s**2 - 3986*s + 768) - 1276*r*s + 671*r - 544*s**2 + 640*s - 214)*np.sqrt(k2**2))) + 3*k1**2*k2**4*(2*Pk2*(8*C*(60*r**2 + 4*r*(33*s - 28) - 132*s + 49) + 880*r**2 + 1212*r*s - 678*r - 264*s**2 + 125*s + 24) + 11*Pkd2*k2*(5*r*(12*s - 5) + 48*s**2 - 42*s + 10))*np.sqrt(k2**2))))/(693*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) - 2*D1**3*Pk1*ct*(33*D1*bd1*f*(b1*(28*Pk2*k2**7*r*(1 - 2*r) + 4*k1**6*s*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*np.sqrt(k2**2) + k1**4*(28*C*Pkdd2*k2**4*s*(2*s - 1)*np.sqrt(k2**2) + Pk2*(28*r**2 + 14*r*(4*C*(s - 1) + 5*s - 2) + s*(4*C*(20*s - 3) - 128*s + 43))*(k2**2)**(3/2) - k2**3*(4*Pk2*(r*(34*C*s - 40*C + 8*s + 19) + s*(23*C + 2*s - 24)) + Pkd2*(-14*r*(4*C*(s - 1) + 4*s - 1) + s*(28*C*(4*s - 3) - 162*s + 95))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(r**2*(56*C - 68) - 2*r*(84*C*s - 28*C - 89*s + 42) + s*(28*s + 15)) - 7*Pkd2*k2*(2*r - 6*s**2 + s))*np.sqrt(k2**2)) + f*(-22*Pk2*k2**7*r**2 + k1**6*s*(Pk2*(62 - 58*s) + 33*Pkd2*k2*(s - 1))*np.sqrt(k2**2) + k1**4*(24*C*Pkdd2*k2**4*s*(s - 1)*np.sqrt(k2**2) + Pk2*(4*C*(r*(10*s - 33) - 8*s**2 - 13*s + 23) + 150*r**2 + r*(139*s - 100) + s*(97*s - 97))*(k2**2)**(3/2) + k2**3*(Pk2*(-8*C*(22*r*s - 35*r - 21*s + 21) + r*(292*s - 242) - 25*s**2 - 135*s + 164) + 2*Pkd2*(C*(r*(72*s - 68) + 72*s**2 - 94*s + 48) + 3*r*(7*s - 2) + s*(53*s - 53))*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(C*(92*r**2 - 8*r*s - 52*r - 96*s + 96) + 68*r**2 + 39*r*(7*s - 6) + 58*s**2 - 134*s + 76) + Pkd2*k2*(2*r*(s*(4*C + 9) - 6) + s*(25*s - 25)))*np.sqrt(k2**2))) - 33*b1**2*(D1*fd*(-Pk2*k1**4*(-8*k1**2*s**2 + k2**2*(14*r**2 + r*s*(28*C + 35) + s**2*(40*C - 64)))*np.sqrt(k2**2) + 28*Pk2*k2**7*r**2 - 4*Pkd2*k1**6*k2*s**2*np.sqrt(k2**2) - 21*Pkd2*k1**2*k2**5*s**2*np.sqrt(k2**2) + k1**4*k2**3*s*(4*Pk2*(r*(17*C + 4) + s) - Pkd2*(r*(28*C + 28) + s*(81 - 56*C))*np.sqrt(k2**2)) - k1**2*k2**4*(28*C*Pkdd2*k1**2*s**2 + Pk2*(r**2*(28*C - 34) + r*s*(89 - 84*C) + 14*s**2))*np.sqrt(k2**2)) + Dd*f*(28*Pk2*k2**7*r*(4*r - 1) - 4*k1**6*s*(-2*Pk2 + Pkd2*k2)*(4*s - 1)*np.sqrt(k2**2) + k1**4*(-28*C*Pkdd2*k2**4*s*(4*s - 1)*np.sqrt(k2**2) + Pk2*(-56*r**2 - 28*r*(C*(4*s - 2) + 5*s - 1) + s*(-4*C*(40*s - 3) + 256*s - 43))*(k2**2)**(3/2) + k2**3*(4*Pk2*(r*(68*C*s - 40*C + 16*s + 19) + s*(23*C + 4*s - 24)) + Pkd2*(-14*r*(C*(8*s - 4) + 8*s - 1) + s*(28*C*(8*s - 3) - 324*s + 95))*np.sqrt(k2**2))) + k1**2*k2**4*(-Pk2*(r**2*(112*C - 136) - 4*r*(84*C*s - 14*C - 89*s + 21) + s*(56*s + 15)) + 7*Pkd2*k2*(2*r - 12*s**2 + s))*np.sqrt(k2**2))) + 33*b1*f*(D1*fd*(22*Pk2*k2**7*r*(1 - 2*r) + k1**6*(-2*Pk2*(58*s**2 - 67*s + 23) + Pkd2*k2*(66*s**2 - 75*s + 25))*np.sqrt(k2**2) + k1**4*(48*C*Pkdd2*k2**4*s**2*np.sqrt(k2**2) + Pk2*(4*C*(20*r*s - r - 16*s**2 - 36*s + 4) + 300*r**2 + r*(278*s - 348) + 194*s**2 - 102*s + 87)*(k2**2)**(3/2) + k2**3*(-Pk2*(r*(s*(352*C - 584) + 78) + 50*s**2 + s*(241 - 232*C) + 21) + Pkd2*(4*C*(4*r*(18*s - 7) + 72*s**2 - 113*s + 26) + 212*s**2 + s*(84*r - 105) + 25)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(46*r**2 - 4*r*s - 55*r - 49*s + 16) + 136*r**2 + 546*r*s - 196*r + 116*s**2 - 141*s + 26) + 2*Pkd2*k2*s*(C*(8*r - 4) + 18*r + 25*s - 3))*np.sqrt(k2**2)) + Dd*f*(22*Pk2*k2**7*r*(1 - 4*r) + k1**6*(4*s - 1)*(Pk2*(46 - 58*s) + Pkd2*k2*(33*s - 25))*np.sqrt(k2**2) + k1**4*(24*C*Pkdd2*k2**4*s*(4*s - 1)*np.sqrt(k2**2) + Pk2*(4*C*(r*(40*s - 47) - 32*s**2 - 63*s + 27) + 600*r**2 + r*(556*s - 510) + 388*s**2 - 224*s + 87)*(k2**2)**(3/2) + k2**3*(Pk2*(-8*C*(r*(88*s - 42) - 64*s + 21) + 16*r*(73*s - 20) - 100*s**2 - 519*s + 143) + Pkd2*(8*C*(r*(72*s - 38) + 72*s**2 - 98*s + 25) + 12*r*(14*s - 1) + 424*s**2 - 236*s + 25)*np.sqrt(k2**2))) + k1**2*k2**4*(Pk2*(4*C*(92*r**2 - 4*r*(2*s + 21) - 97*s + 40) + 272*r**2 + 12*r*(91*s - 38) + 232*s**2 - 351*s + 102) + Pkd2*k2*(4*r*(s*(8*C + 18) - 3) + s*(-8*C + 100*s - 31)))*np.sqrt(k2**2))) + f**2*k1**2*(D1*fd*(66*Pk2*k2**4*r*(6*r + 99*s - 35)*np.sqrt(k2**2) + 33*k1**4*(3*s - 1)*(Pk2*(38 - 30*s) + 21*Pkd2*k2*(s - 1))*np.sqrt(k2**2) + k1**2*(Pk2*(4*C*(-3*r*(393*s + 133) + 594*s**2 - 894*s + 496) + 2376*r**2 + 8316*r*s - 3564*r + 2079*s**2 - 2772*s + 693)*(k2**2)**(3/2) + k2**3*(Pk2*(8*C*(18*r*(74*s + 1) - 807*s + 115) + (3*s - 1)*(2178*r - 297*s + 561)) + 33*Pkd2*(4*C*(42*r*(s - 1) + 99*s**2 - 113*s + 36) + 63*s**2 - 84*s + 21)*np.sqrt(k2**2)))) + Dd*f*(66*Pk2*k2**4*r*(8*r + 132*s - 35)*np.sqrt(k2**2) + 33*k1**4*(4*s - 1)*(Pk2*(38 - 30*s) + 21*Pkd2*k2*(s - 1))*np.sqrt(k2**2) + k1**2*(Pk2*(4*C*(-r*(1572*s + 779) + 792*s**2 - 1010*s + 496) + 3168*r**2 + 396*r*(28*s - 9) + 2772*s**2 - 3465*s + 693)*(k2**2)**(3/2) + k2**3*(Pk2*(8*C*(1776*r*s + 241*r - 1145*s + 115) + (4*s - 1)*(2178*r - 297*s + 561)) + 33*Pkd2*(4*C*(56*r*(s - 1) + 132*s**2 - 135*s + 36) + 84*s**2 - 105*s + 21)*np.sqrt(k2**2))))))/(693*d**2*k1**3*k2**3*k3**2*np.sqrt(k2**2)) - 5*D1**3*Pk1*f*st**6*(858*b1**2*k1**2*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 13*b1*f*(3*D1*(44*bd1*k1**2*s*(2*s - 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 2*fd*k1**2*(1 - 3*s)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + fd*r*(Pk2*(166 - 399*s) + Pkd2*k2*(141*s - 58))*(k2**2)**(3/2)) + Dd*f*(6*k1**2*(12*s**2 - 7*s + 1)*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(680 - 1596*s) + 447*s - 182) + Pkd2*k2*(4*r*(141*s - 59) - 153*s + 62))*(k2**2)**(3/2))) + f**2*(13*D1*bd1*(Pk2*(144*k1**2*s*(3*s - 1) + k2**2*(-399*r*s + 182*r + 447*s - 182))*np.sqrt(k2**2) - 54*Pkd2*k1**2*k2**2*s*(3*s - 1) + Pkd2*k2**3*(141*r*s - 62*r - 153*s + 62)*np.sqrt(k2**2) + 6*Pkdd2*k1**2*s*(3*s - 1)*(k2**2)**(3/2)) + D1*fd*(-12*k1**2*(1 - 4*s)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + (Pk2*(r*(2016 - 7908*s) + 2497*s - 634) + Pkd2*k2*(6*r*(362*s - 97) - 673*s + 178))*(k2**2)**(3/2)) - 12*Dd*f*k1**2*(1 - 4*s)**2*(24*Pk2*np.sqrt(k2**2) - 9*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + Dd*f*(Pk2*(r*(2016 - 7908*s) + 2497*s - 634) + Pkd2*k2*(6*r*(362*s - 97) - 673*s + 178))*(k2**2)**(3/2)))/(9009*d**2*k1**2*(k2**2)**(3/2)) - 10*D1**3*Pk1*f*st**6*(-33*D1*bd1*f*(k1**2*(2*C*Pkdd2*k2**2*s*(1 - 2*s) + 4*Pk2*r*(4*s - 1) - 4*Pk2*(2*s - 1)*(4*C*s + 1) + Pkd2*k2*(-4*r*s + r + (2*s - 1)*(10*C*s + 1))) + k2**2*(Pk2*(r**2*(8*C - 8) + r*(-8*C + 8*s + 6) - 4*s + 2) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 33*b1*(2*D1*fd*(-8*C*Pk2*k2**2*r**2 + C*k1**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) - 2*k1**2*r*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k2**2*r*(Pk2*(4*r - 4*s + 2) + Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*Pk2*(4*C*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 2*s - 1) + k2*(2*C*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-10*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r - 2*s + 1))) + k2**2*(Pk2*(-r**2*(32*C - 32) + 4*r*(2*C - 8*s + 1) + 4*s - 2) + Pkd2*k2*(2*r*(8*s - 3) - 2*s + 1)))) + f*(2*D1*fd*(k1**2*(3*s - 1)*(4*Pk2*(C*(6*s - 2) - 3*r + 1) + k2*(C*Pkdd2*k2*(3*s - 1) + Pkd2*(-15*C*s + 5*C + 3*r - 1))) + k2**2*(3*r - 1)*(C*Pk2*(2 - 6*r) + 6*Pk2*(r - s) + Pkd2*k2*(3*s - 1))) + Dd*f*(k1**2*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 7*s - 2) + k2*(2*C*Pkdd2*k2*(12*s**2 - 7*s + 1) + Pkd2*(-10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 7*s + 2))) + k2**2*(-4*C*Pk2*(12*r**2 - 7*r + 1) + 2*Pk2*(r - s)*(24*r - 7) + Pkd2*k2*(24*r*s - 7*r - 7*s + 2)))))/(693*d**2*k1**2*k3**2) + 20*D1**3*Pk1*f*st**6*(33*D1*bd1*f*(Pk2*k2**4*(4*r**2 + r*(4*s - 5) - 2*s + 1) + k1**2*(2*C*Pkd2*k2**3*(r*(4*s - 1) - 2*s + 1) + 4*C*Pkd2*s*(2*s - 1)*(k2**2)**(3/2) + Pk2*k2**2*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 1))) + 33*b1*(4*D1*fd*(C*k1**2*(2*s - 1)*(-2*Pk2*k2**2*(2*r + 2*s - 1) + 2*Pkd2*k2**3*r + Pkd2*(2*s - 1)*(k2**2)**(3/2)) + Pk2*k2**2*r*(k1**2 + k2**2)*(2*r + 2*s - 1)) + Dd*f*(Pk2*k2**4*(8*r - 1)*(2*r + 2*s - 1) + k1**2*(2*C*Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 4*C*Pkd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2) + Pk2*k2**2*(2*r + 2*s - 1)*(-4*C*(8*s - 3) + 8*r - 1)))) + f*(2*D1*fd*(Pk2*k2**4*(3*r - 1)*(3*r + 3*s - 2) + k1**2*(2*C*Pkd2*k2**3*(3*r - 1)*(3*s - 1) + 2*C*Pkd2*(1 - 3*s)**2*(k2**2)**(3/2) + Pk2*k2**2*(3*r + 3*s - 2)*(C*(4 - 12*s) + 3*r - 1))) + Dd*f*(Pk2*k2**4*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + k1**2*(2*C*Pkd2*k2**3*(r*(24*s - 7) - 7*s + 2) + 4*C*Pkd2*(12*s**2 - 7*s + 1)*(k2**2)**(3/2) + Pk2*k2**2*(-4*C*(r*(24*s - 7) + 24*s**2 - 21*s + 4) + 24*r**2 + 3*r*(8*s - 7) - 7*s + 4)))))/(693*d**2*k1**2*k3**4) + 8*D1**3*Pk1*(11*C*Pk2*f**2*k1**2*k2**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1))*(r + s - 1) + D1*bd1*f*(b1*(Pk2*k1**4*(r*(4*s - 1) + s*(4*s - 3)) + 7*Pk2*k2**4*(r**2*(2*C + 2) + r*(C*(4*s - 2) + 4*s - 3) + s*(2*C*(s - 1) + 2*s - 1)) + 2*k1**2*k2**2*(14*C*Pkd2*k2*s*(r + s - 1) + Pk2*(r**2*(14*C + 7) + r*(14*C*(2*s - 1) + 16*s - 11) + s*(14*C*(s - 1) + 9*s - 5)))) + f*(Pk2*k1**4*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pk2*k2**4*(C*r*(28*s - 13) + r**2*(15*C + 6) + 12*r*(s - 1) + s*(13*C + 6)*(s - 1)) + k1**2*k2**2*(12*C*Pkd2*k2*s*(r + s - 1) + Pk2*(C*(44*r**2 + r*(87*s - 68) + 43*s**2 - 67*s + 24) + 6*r**2 + 2*r*(8*s - 7) + 10*s**2 - 11*s + 1)))) + b1**2*(D1*fd*(r + s)*(2*Pk2*k1**4*s + Pk2*k2**4*(7*C + 7)*(r + s) + k1**2*k2**2*(14*C*Pkd2*k2*s + Pk2*r*(14*C + 7) + Pk2*s*(14*C + 9))) + Dd*f*(Pk2*k1**4*(r*(8*s - 1) + s*(8*s - 3)) + 7*Pk2*k2**4*(r**2*(4*C + 4) + r*(C*(8*s - 2) + 8*s - 3) + s*(C*(4*s - 2) + 4*s - 1)) + 2*k1**2*k2**2*(14*C*Pkd2*k2*s*(2*r + 2*s - 1) + Pk2*(r**2*(28*C + 14) + r*(56*C*s - 14*C + 32*s - 11) + s*(28*C*s - 14*C + 18*s - 5))))) + b1*f*(D1*fd*(C*k2**2*(Pk2*k2**2*(30*r**2 + r*(56*s - 15) + s*(26*s - 15)) + k1**2*(Pk2*(88*r**2 + 174*r*s - 101*r + 86*s**2 - 115*s + 35) + 12*Pkd2*k2*s*(2*r + 2*s - 1))) + Pk2*(2*k1**2 + 2*k2**2)*(2*k1**2*s*(2*r + 2*s - 1) + 3*k2**2*(2*r**2 + r*(4*s - 1) + 2*s**2))) + Dd*f*(Pk2*k1**4*(8*s - 1)*(2*r + 2*s - 1) + 2*Pk2*k2**4*(r**2*(30*C + 12) + r*(56*C*s - 14*C + 24*s - 9) + s*(26*C*s - 14*C + 12*s - 3)) + k1**2*k2**2*(24*C*Pkd2*k2*s*(2*r + 2*s - 1) + Pk2*(C*(176*r**2 + 348*r*s - 191*r + 172*s**2 - 219*s + 59) + 24*r**2 + 64*r*s - 20*r + 40*s**2 - 16*s + 1)))))/(21*d**2*k2**2*k3**4) - D1**3*Pk1*st**4*(-13*D1*bd1*f*(-528*Pk2*g2*(-4*k1**2*s*(s - 1) + k2**2*r*(r - 1))*np.sqrt(k2**2) - 132*b2*k1**2*s*(s - 1)*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + f**2*(4*k1**2*(8*Pk2*(2*r*(6*s - 1) + 9*s**2 - 11*s + 1)*np.sqrt(k2**2) + Pkd2*k2**2*(-24*r*s + 4*r - 45*s**2 + 43*s - 2) + Pkdd2*s*(9*s - 7)*(k2**2)**(3/2)) + (Pk2*(288*r**2 - r*(s + 198) + 321*s - 122) + 2*Pkd2*k2*(r*(69*s - 34) - 149*s + 58))*(k2**2)**(3/2)) - 264*g2*k1**2*s*(s - 1)*(5*Pkd2*k2**2 - Pkdd2*(k2**2)**(3/2))) + 1716*b1**3*k1**2*s*(D1*fd*s + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + 858*b1**2*(D1*(2*bd1*f*k1**2*s*(3*s - 1)*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2)) + fd*k1**2*(-2*Pk2*(f*(r*(s - 2) + 16*(1 - 2*s)**2) - (8*s - 8)*(K*(s - 1) - r + s - 1))*np.sqrt(k2**2) + Pkd2*k2**2*(f*r*(8*s - 5) + 14*f*(1 - 2*s)**2 - (10*K + 10)*(s - 1)**2) + Pkd2*k2*r*(-6*f*s + 3*f + 4*s - 4)*np.sqrt(k2**2) + 2*Pkdd2*(-f*(1 - 2*s)**2 + (K + 1)*(s - 1)**2)*(k2**2)**(3/2)) + 4*fd*r*(Pk2*(-K*r + f*(3 - 9*s) + r - 2*s + 2) + Pkd2*k2*(f*(3*s - 1) + s - 1))*(k2**2)**(3/2)) + Dd*f*(k1**2*(Pk2*(16*K*(4*s**2 - 5*s + 1) + f*(-4*r*(s - 4) - 256*s**2 + 201*s - 38) - 64*r*s + 40*r + 64*s**2 - 72*s + 8)*np.sqrt(k2**2) + Pkd2*k2**2*(f*(r*(16*s - 9) + 112*s**2 - 87*s + 16) + (-10*K - 10)*(4*s**2 - 5*s + 1)) + Pkd2*k2*(r*(-12*f*s + 3*f + 16*s - 10) - 2*s + 2)*np.sqrt(k2**2) + 2*Pkdd2*(4*s - 1)*(-2*f*s + f + (K + 1)*(s - 1))*(k2**2)**(3/2)) + 2*(Pk2*(-3*f*(4*r - 1)*(3*s - 1) - 2*r**2*(4*K - 4) + 2*r*(K - 8*s + 4) + 2*s - 2) + Pkd2*k2*(f*(4*r - 1)*(3*s - 1) + 8*r*s - 5*r - s + 1))*(k2**2)**(3/2))) + 13*b1*(1056*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) - 1056*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 1152*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 384*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) - 864*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) + 384*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) - 96*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 864*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 3*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) - 78*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) + 384*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) - 96*D1*Pk2*f**2*fd*(k2**2)**(3/2) - 2112*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) + 2112*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 528*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) - 2112*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) + 4224*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) - 2112*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 528*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) - 660*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 + 660*D1*Pkd2*bd2*f*k1**2*k2**2*s + 288*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s - 96*D1*Pkd2*f**2*fd*k1**2*k2**2*r + 540*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 - 168*D1*Pkd2*f**2*fd*k1**2*k2**2*s + 36*D1*Pkd2*f**2*fd*k1**2*k2**2 - 414*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) + 300*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) - 192*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) + 32*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) + 1320*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 - 1320*D1*Pkd2*f*gd2*k1**2*k2**2*s + 1320*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 - 2640*D1*Pkd2*fd*g2*k1**2*k2**2*s + 1320*D1*Pkd2*fd*g2*k1**2*k2**2 + 132*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) - 132*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) - 108*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) + 24*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) - 4*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) - 264*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) + 264*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) - 264*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) + 528*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) - 264*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 66*D1*bd1*f*(-k1**2*(20*K*Pkd2*k2**2*s**2 - 20*K*Pkd2*k2**2*s - 4*K*Pkdd2*s**2*(k2**2)**(3/2) + 4*K*Pkdd2*s*(k2**2)**(3/2) + Pk2*(f*(2*r*(s - 6) + 128*s**2 - 73*s + 6) + 8*r*(4*s - 2) - (8*s - 8)*(s*(4*K + 4) + 1))*np.sqrt(k2**2) + 20*Pkd2*k2**2*s**2 - 20*Pkd2*k2**2*s - 8*Pkd2*k2*r*s*np.sqrt(k2**2) + 4*Pkd2*k2*r*np.sqrt(k2**2) + 2*Pkd2*k2*s*np.sqrt(k2**2) - 2*Pkd2*k2*np.sqrt(k2**2) - 4*Pkdd2*s**2*(k2**2)**(3/2) + 4*Pkdd2*s*(k2**2)**(3/2) + f*(Pkd2*k2**2*(-8*r*s + 4*r - 56*s**2 + 31*s - 2) + 6*Pkd2*k2*r*s*np.sqrt(k2**2) + 4*Pkdd2*s*(2*s - 1)*(k2**2)**(3/2))) + 2*(Pk2*(-3*f*(2*r - 1)*(3*s - 1) - 2*r**2*(2*K - 2) + 2*r*(K - 4*s + 1) + 2*s - 2) + Pkd2*k2*(f*(2*r - 1)*(3*s - 1) + 4*r*s - 2*r - s + 1))*(k2**2)**(3/2)) - 1536*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 448*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 1152*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) + 736*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) - 128*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 1152*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 4*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) + 120*Dd*Pk2*f**3*r*(k2**2)**(3/2) + 63*Dd*Pk2*f**3*s*(k2**2)**(3/2) + 26*Dd*Pk2*f**3*(k2**2)**(3/2) - 8448*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) + 10560*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 2112*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 2112*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 528*Dd*Pk2*f*g2*r*(k2**2)**(3/2) + 384*Dd*Pkd2*f**3*k1**2*k2**2*r*s - 112*Dd*Pkd2*f**3*k1**2*k2**2*r + 720*Dd*Pkd2*f**3*k1**2*k2**2*s**2 - 340*Dd*Pkd2*f**3*k1**2*k2**2*s + 44*Dd*Pkd2*f**3*k1**2*k2**2 - 552*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) + 368*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) + 106*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) - 84*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) + 5280*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 - 6600*Dd*Pkd2*f*g2*k1**2*k2**2*s + 1320*Dd*Pkd2*f*g2*k1**2*k2**2 - 144*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) + 52*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) - 4*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) - 1056*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) + 1320*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) - 264*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) + 132*b2*k1**2*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))*(8*Pk2*np.sqrt(k2**2) - 5*Pkd2*k2**2 + Pkdd2*(k2**2)**(3/2))) + f**3*(D1*fd + Dd*f)*(2*k1**2*(Pk2*(-20*r*(83*s - 24) + 13312*s**2 - 6553*s + 790)*np.sqrt(k2**2) + Pkd2*k2**2*(-560*r*s + 205*r - 4576*s**2 + 2623*s - 386) + 195*Pkd2*k2*r*(4*s - 1)*np.sqrt(k2**2) + 52*Pkdd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2)) + (Pk2*(5888*r**2 + 4*r*(4355*s - 2556) - 4875*s + 2318) - 104*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2)))/(3003*d**2*k1**2*(k2**2)**(3/2)) + D1**3*Pk1*st**2*(-33*b1**3*(D1*fd*s*(k1**2*(7*Pk2*(r - 8*s)*np.sqrt(k2**2) + 44*Pkd2*k2**2*s - 7*Pkd2*k2*r*np.sqrt(k2**2) - 16*Pkdd2*s*(k2**2)**(3/2)) + 3*r*(-7*Pk2 + 5*Pkd2*k2)*(k2**2)**(3/2)) + Dd*f*(k1**2*(7*Pk2*(4*r*(s - 1) + s*(11 - 32*s))*np.sqrt(k2**2) + Pkd2*k2**2*(7*r + s*(176*s - 51)) + 7*Pkd2*k2*r*(1 - 4*s)*np.sqrt(k2**2) + 16*Pkdd2*s*(1 - 4*s)*(k2**2)**(3/2)) + (21*Pk2*s*(1 - 4*r) + Pkd2*k2*(r*(60*s - 4) - 11*s))*(k2**2)**(3/2))) + 33*b1**2*(D1*(bd1*f*k1**2*(7*Pk2*(r*(4 - 3*s) + s*(24*s - 11))*np.sqrt(k2**2) + Pkd2*k2**2*(-7*r + s*(51 - 132*s)) + 7*Pkd2*k2*r*(3*s - 1)*np.sqrt(k2**2) + 16*Pkdd2*s*(3*s - 1)*(k2**2)**(3/2)) + bd1*f*(21*Pk2*s*(3*r - 1) + Pkd2*k2*(r*(4 - 45*s) + 11*s))*(k2**2)**(3/2) + fd*k1**2*(Pk2*(52*K*(s - 1)**2 + f*(10*r*(8*s - 1) + 112*s**2 - 219*s + 52) - 92*r*s + 84*r + 60*s**2 - 112*s + 60)*np.sqrt(k2**2) - Pkd2*k2**2*(K*(44*s**2 - 84*s + 42) + f*(-96*s**2 + s*(16*r + 39) - 12) - 28*r*s + 28*r + 44*s**2 - 84*s + 42) + 2*Pkd2*k2*(f*r*(15*s - 14) + s*(2*r - 2))*np.sqrt(k2**2) - 2*Pkdd2*(f*(4*s**2 - 3*s + 1) - (K + 1)*(8*s**2 - 14*s + 7))*(k2**2)**(3/2)) + fd*(Pk2*f*(96*r**2 + r*(22 - 162*s) + 9*s + 4) - 4*Pk2*(8*K*r**2 - 2*K*r + K - 8*r**2 + 9*r*s - 7*r - 1) + Pkd2*k2*r*(74*f*s - 36*f + 32*s - 28) + Pkd2*k2*s*(15*f - 4))*(k2**2)**(3/2)) + Dd*f*(k1**2*(2*Pk2*(26*K*(4*s**2 - 5*s + 1) + f*(r*(80*s - 5) + 112*s**2 - 131*s + 22) - 184*r*s + 86*r + 120*s**2 - 126*s + 14)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(K*(88*s**2 - 106*s + 21) + f*(r*(16*s - 5) - 96*s**2 + 41*s - 4) - 56*r*s + 35*r + 88*s**2 - 99*s + 14) + Pkd2*k2*(f*(10*r*(6*s - 5) - 21*s + 14) + 2*r*(8*s - 1) - 10*s + 2)*np.sqrt(k2**2) - 2*Pkdd2*(4*s - 1)*(f*(2*s - 1) - (K + 1)*(8*s - 7))*(k2**2)**(3/2)) + (-4*K*Pk2*(32*r**2 - 12*r + 1) + Pk2*f*(192*r**2 - 4*r*(81*s - 5) + 45*s - 8) + 4*Pk2*(32*r**2 - 36*r*s + s) + Pkd2*f*k2*(2*r*(74*s - 31) - 31*s + 14) + 8*Pkd2*k2*(r*(16*s - 9) - 3*s + 2))*(k2**2)**(3/2))) + b1*(-1320*D1*K*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 1452*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 396*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 1056*D1*K*Pk2*f*fd*r**2*(k2**2)**(3/2) - 792*D1*K*Pk2*f*fd*r*(k2**2)**(3/2) + 132*D1*K*Pk2*f*fd*(k2**2)**(3/2) + 660*D1*K*Pkd2*f*fd*k1**2*k2**2*s**2 - 726*D1*K*Pkd2*f*fd*k1**2*k2**2*s + 198*D1*K*Pkd2*f*fd*k1**2*k2**2 - 132*D1*K*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) + 198*D1*K*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) - 66*D1*K*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) + 1848*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) - 1848*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) - 4977*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 1188*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) - 3159*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 660*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 3240*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) - 8316*D1*Pk2*f**2*fd*r*s*(k2**2)**(3/2) + 4734*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) + 2376*D1*Pk2*f**2*fd*s*(k2**2)**(3/2) - 1152*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 1584*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 396*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) - 792*D1*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 528*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) + 528*D1*Pk2*f*fd*r*s*(k2**2)**(3/2) - 132*D1*Pk2*f*fd*r*(k2**2)**(3/2) - 396*D1*Pk2*f*fd*s*(k2**2)**(3/2) - 3432*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) + 3432*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 2112*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) - 264*D1*Pk2*f*gd2*r*(k2**2)**(3/2) - 3432*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) + 6864*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) - 3432*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) + 2112*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) - 528*D1*Pk2*fd*g2*r*(k2**2)**(3/2) + 264*D1*Pk2*fd*g2*(k2**2)**(3/2) - 1452*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 + 1386*D1*Pkd2*bd2*f*k1**2*k2**2*s + 360*D1*Pkd2*f**2*fd*k1**2*k2**2*r*s + 594*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 1893*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 396*D1*Pkd2*f**2*fd*k1**2*k2**2 - 1089*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 396*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 99*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) - 66*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) + 594*D1*Pkd2*f**2*fd*k2**3*r*s*np.sqrt(k2**2) - 198*D1*Pkd2*f**2*fd*k2**3*r*np.sqrt(k2**2) - 198*D1*Pkd2*f**2*fd*k2**3*s*np.sqrt(k2**2) + 66*D1*Pkd2*f**2*fd*k2**3*np.sqrt(k2**2) - 264*D1*Pkd2*f*fd*k1**2*k2**2*r*s + 198*D1*Pkd2*f*fd*k1**2*k2**2*r + 660*D1*Pkd2*f*fd*k1**2*k2**2*s**2 - 660*D1*Pkd2*f*fd*k1**2*k2**2*s + 132*D1*Pkd2*f*fd*k1**2*k2**2 - 264*D1*Pkd2*f*fd*k2**3*r*s*np.sqrt(k2**2) + 198*D1*Pkd2*f*fd*k2**3*r*np.sqrt(k2**2) + 66*D1*Pkd2*f*fd*k2**3*s*np.sqrt(k2**2) - 66*D1*Pkd2*f*fd*k2**3*np.sqrt(k2**2) + 2904*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 - 2772*D1*Pkd2*f*gd2*k1**2*k2**2*s + 2904*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 - 5544*D1*Pkd2*fd*g2*k1**2*k2**2*s + 2772*D1*Pkd2*fd*g2*k1**2*k2**2 + 528*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) - 462*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) - 594*D1*Pkdd2*f**2*fd*k1**2*s**2*(k2**2)**(3/2) + 264*D1*Pkdd2*f**2*fd*k1**2*s*(k2**2)**(3/2) - 66*D1*Pkdd2*f**2*fd*k1**2*(k2**2)**(3/2) - 132*D1*Pkdd2*f*fd*k1**2*s**2*(k2**2)**(3/2) + 198*D1*Pkdd2*f*fd*k1**2*s*(k2**2)**(3/2) - 66*D1*Pkdd2*f*fd*k1**2*(k2**2)**(3/2) - 1056*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) + 924*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) - 1056*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) + 1848*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) - 924*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + 33*D1*bd1*f*(k1**2*(Pk2*(f*(112*s**2 + s*(80*r - 43) - 8) + 4*r*(15 - 46*s) + 4*s**2*(26*K + 30) - 4*s*(26*K + 21) - 32)*np.sqrt(k2**2) + Pkd2*k2**2*(-88*K*s**2 + 86*K*s + f*(-2*r*(8*s - 5) + 96*s**2 - 43*s - 4) + 28*r*(2*s - 1) - 88*s**2 + 72*s + 14) + Pkd2*k2*(f*(r*(30*s - 22) - 21*s + 14) + r*(8*s - 2) - 4*s + 2)*np.sqrt(k2**2) + 2*Pkdd2*s*(f*(3 - 4*s) + (K + 1)*(16*s - 15))*(k2**2)**(3/2)) + 2*(Pk2*(f*(48*r**2 - r*(81*s + 1) + 18*s - 6) - 2*r**2*(16*K - 16) + 2*r*(9*K - 18*s - 7) + 2*s - 2) + Pkd2*k2*(f*(37*r*s - 13*r - 23*s + 7) + 32*r*s - 15*r - 9*s + 8))*(k2**2)**(3/2)) - 2640*Dd*K*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 2244*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 396*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) + 2112*Dd*K*Pk2*f**2*r**2*(k2**2)**(3/2) - 1056*Dd*K*Pk2*f**2*r*(k2**2)**(3/2) + 132*Dd*K*Pk2*f**2*(k2**2)**(3/2) + 1320*Dd*K*Pkd2*f**2*k1**2*k2**2*s**2 - 1122*Dd*K*Pkd2*f**2*k1**2*k2**2*s + 198*Dd*K*Pkd2*f**2*k1**2*k2**2 - 264*Dd*K*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) + 330*Dd*K*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) - 66*Dd*K*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 6636*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 384*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 2437*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 928*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 4320*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) - 11088*Dd*Pk2*f**3*r*s*(k2**2)**(3/2) + 6876*Dd*Pk2*f**3*r*(k2**2)**(3/2) + 3168*Dd*Pk2*f**3*s*(k2**2)**(3/2) - 1548*Dd*Pk2*f**3*(k2**2)**(3/2) + 3168*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 660*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) - 1584*Dd*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 264*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 1056*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) + 1056*Dd*Pk2*f**2*r*s*(k2**2)**(3/2) - 132*Dd*Pk2*f**2*r*(k2**2)**(3/2) - 396*Dd*Pk2*f**2*s*(k2**2)**(3/2) - 13728*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) + 17160*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 3432*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 8448*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) - 3168*Dd*Pk2*f*g2*r*(k2**2)**(3/2) + 264*Dd*Pk2*f*g2*(k2**2)**(3/2) + 480*Dd*Pkd2*f**3*k1**2*k2**2*r*s + 105*Dd*Pkd2*f**3*k1**2*k2**2*r + 792*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 1433*Dd*Pkd2*f**3*k1**2*k2**2*s - 464*Dd*Pkd2*f**3*k1**2*k2**2 - 1452*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) + 693*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) + 198*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) - 132*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) + 792*Dd*Pkd2*f**3*k2**3*r*s*np.sqrt(k2**2) - 264*Dd*Pkd2*f**3*k2**3*r*np.sqrt(k2**2) - 198*Dd*Pkd2*f**3*k2**3*s*np.sqrt(k2**2) + 66*Dd*Pkd2*f**3*k2**3*np.sqrt(k2**2) - 528*Dd*Pkd2*f**2*k1**2*k2**2*r*s + 330*Dd*Pkd2*f**2*k1**2*k2**2*r + 1320*Dd*Pkd2*f**2*k1**2*k2**2*s**2 - 1056*Dd*Pkd2*f**2*k1**2*k2**2*s + 132*Dd*Pkd2*f**2*k1**2*k2**2 - 528*Dd*Pkd2*f**2*k2**3*r*s*np.sqrt(k2**2) + 330*Dd*Pkd2*f**2*k2**3*r*np.sqrt(k2**2) + 66*Dd*Pkd2*f**2*k2**3*s*np.sqrt(k2**2) - 66*Dd*Pkd2*f**2*k2**3*np.sqrt(k2**2) + 11616*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 - 13992*Dd*Pkd2*f*g2*k1**2*k2**2*s + 2772*Dd*Pkd2*f*g2*k1**2*k2**2 - 792*Dd*Pkdd2*f**3*k1**2*s**2*(k2**2)**(3/2) + 462*Dd*Pkdd2*f**3*k1**2*s*(k2**2)**(3/2) - 66*Dd*Pkdd2*f**3*k1**2*(k2**2)**(3/2) - 264*Dd*Pkdd2*f**2*k1**2*s**2*(k2**2)**(3/2) + 330*Dd*Pkdd2*f**2*k1**2*s*(k2**2)**(3/2) - 66*Dd*Pkdd2*f**2*k1**2*(k2**2)**(3/2) - 4224*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) + 4752*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) - 924*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) + 66*b2*k1**2*(D1*fd*(28*Pk2*(s - 1)**2*np.sqrt(k2**2) + Pkd2*k2**2*(-22*s**2 + 42*s - 21) + Pkdd2*(8*s**2 - 14*s + 7)*(k2**2)**(3/2)) + Dd*f*(4*s - 1)*(28*Pk2*(s - 1)*np.sqrt(k2**2) + Pkd2*k2**2*(21 - 22*s) + Pkdd2*(8*s - 7)*(k2**2)**(3/2)))) + f*(-528*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) + 264*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) + 396*D1*Pk2*bd2*f*r**2*(k2**2)**(3/2) - 132*D1*Pk2*bd2*f*r*(k2**2)**(3/2) - 3240*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 310*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 4032*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) - 2508*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 500*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 1320*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) - 792*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) - 1056*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 264*D1*Pk2*f*gd2*r*(k2**2)**(3/2) + 2640*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) - 2904*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 792*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) - 2112*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 1584*D1*Pk2*fd*g2*r*(k2**2)**(3/2) - 264*D1*Pk2*fd*g2*(k2**2)**(3/2) + 330*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 - 198*D1*Pkd2*bd2*f*k1**2*k2**2*s - 2592*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 1944*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 324*D1*Pkd2*f**2*fd*k1**2*k2**2 - 780*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 520*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 195*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) - 130*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) - 660*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 + 396*D1*Pkd2*f*gd2*k1**2*k2**2*s - 1320*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 + 1452*D1*Pkd2*fd*g2*k1**2*k2**2*s - 396*D1*Pkd2*fd*g2*k1**2*k2**2 - 66*D1*Pkdd2*bd2*f*k1**2*s**2*(k2**2)**(3/2) + 66*D1*Pkdd2*bd2*f*k1**2*s*(k2**2)**(3/2) + 132*D1*Pkdd2*f*gd2*k1**2*s**2*(k2**2)**(3/2) - 132*D1*Pkdd2*f*gd2*k1**2*s*(k2**2)**(3/2) + 264*D1*Pkdd2*fd*g2*k1**2*s**2*(k2**2)**(3/2) - 396*D1*Pkdd2*fd*g2*k1**2*s*(k2**2)**(3/2) + 132*D1*Pkdd2*fd*g2*k1**2*(k2**2)**(3/2) + D1*bd1*(f**2*(k1**2*(Pk2*(-3*r*(553*s + 268) + 722*s + 268)*np.sqrt(k2**2) + Pkd2*k2**2*(15*r*(8*s + 7) + 198*s**2 - 460*s - 68) - 33*Pkd2*k2*(r*(11*s - 9) - 3*s + 2)*np.sqrt(k2**2) - 198*Pkdd2*s*(s - 1)*(k2**2)**(3/2)) + 6*(-3*Pk2*(60*r**2 + 7*r*(22*s - 17) - 44*s + 22) + 11*Pkd2*k2*r*(3*s - 1))*(k2**2)**(3/2)) - 66*f*(k1**2*(-2*Pk2*(r*(6*s - 1) + s*(K*(3 - 5*s) - 3*s + 1))*np.sqrt(k2**2) + Pkd2*k2**2*(r*(2*s - 1) - s*(K + 1)*(5*s - 3)) + Pkdd2*s*(K + 1)*(s - 1)*(k2**2)**(3/2)) + r*(K*Pk2*(2 - 8*r) - 4*Pk2*(r + s) + Pkd2*k2*(2*s - 1))*(k2**2)**(3/2)) + 264*g2*(Pk2*(-13*k1**2*s*(s - 1) + 8*k2**2*r*(r - 1))*np.sqrt(k2**2) + k1**2*s*(s - 1)*(11*Pkd2*k2**2 - 4*Pkdd2*(k2**2)**(3/2)))) - 3240*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 310*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 4032*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) - 2508*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 500*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 5280*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) - 4488*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 792*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) - 4224*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) + 2112*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 264*Dd*Pk2*f*g2*(k2**2)**(3/2) - 2592*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 1944*Dd*Pkd2*f**3*k1**2*k2**2*s - 324*Dd*Pkd2*f**3*k1**2*k2**2 - 780*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) + 520*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) + 195*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) - 130*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) - 2640*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 + 2244*Dd*Pkd2*f*g2*k1**2*k2**2*s - 396*Dd*Pkd2*f*g2*k1**2*k2**2 + 528*Dd*Pkdd2*f*g2*k1**2*s**2*(k2**2)**(3/2) - 660*Dd*Pkdd2*f*g2*k1**2*s*(k2**2)**(3/2) + 132*Dd*Pkdd2*f*g2*k1**2*(k2**2)**(3/2) + 66*b2*(D1*(2*Pk2*fd*(6*r**2 - 5*r + 1)*(k2**2)**(3/2) + 2*bd1*k1**2*s*(s - 1)*(14*Pk2*np.sqrt(k2**2) - 11*Pkd2*k2**2 + 4*Pkdd2*(k2**2)**(3/2)) - fd*k1**2*(2*s - 1)*(4*Pk2*(2*s - 1)*np.sqrt(k2**2) + Pkd2*k2**2*(3 - 5*s) + Pkdd2*(s - 1)*(k2**2)**(3/2))) + Dd*f*(2*Pk2*(12*r**2 - 7*r + 1)*(k2**2)**(3/2) - k1**2*(4*s - 1)*(4*Pk2*(2*s - 1)*np.sqrt(k2**2) + Pkd2*k2**2*(3 - 5*s) + Pkdd2*(s - 1)*(k2**2)**(3/2))))))/(693*d**2*k1**2*(k2**2)**(3/2)) + D1**3*Pk1*(b1**3*(D1*fd*(Pk2*(7*k1**2*s*(-r + 4*s) + k2**2*r*(24*r + 7*s))*np.sqrt(k2**2) + 14*Pkd2*k2**2*s*(-k1**2*s + 2*k2*r*np.sqrt(k2**2))) + Dd*f*(Pk2*(-7*k1**2*s*(4*r - 16*s + 3) + k2**2*(96*r**2 + 28*r*s + 4*r - 35*s))*np.sqrt(k2**2) + 14*Pkd2*k2**2*s*(k1**2*(1 - 4*s) + 2*k2*(4*r - 1)*np.sqrt(k2**2)))) + b1**2*(D1*(Pk2*bd1*f*(-21*k1**2*s*(r - 4*s + 1) + k2**2*(72*r**2 + r*(21*s + 4) - 35*s))*np.sqrt(k2**2) + 14*Pkd2*bd1*f*k2**2*s*(k1**2*(1 - 3*s) + 2*k2*(3*r - 1)*np.sqrt(k2**2)) - fd*k1**2*(Pk2*(-4*K*(9*s**2 - 14*s + 7) + f*(32*s**2 + s*(276*r - 105) + 4) + 26*r*s - 14*r - 20*s**2 + 44*s - 28)*np.sqrt(k2**2) + 2*Pkd2*k2*(13*f*k2*(8*s**2 - 3*s + 1) + 9*f*s*(4*r - 1)*np.sqrt(k2**2) + k2*(7*K + 7)*(s - 1)**2)) + fd*(Pk2*(24*K*(r - 1)**2 + f*(-96*r**2 + r*(96 - 78*s) + 59*s - 24) + 24*r**2 - 10*r*s - 34*r - 4*s + 24) + 6*Pkd2*f*k2*s*(2*r - 1))*(k2**2)**(3/2)) + Dd*f*(-2*k1**2*(Pk2*(-2*K*(36*s**2 - 37*s + 7) + f*(12*r*(23*s - 6) + 32*s**2 - 109*s + 26) + 52*r*s - 31*r - 40*s**2 - 12*s + 10)*np.sqrt(k2**2) + Pkd2*k2*(18*f*s*(4*r - 1)*np.sqrt(k2**2) + k2*(4*s - 1)*(13*f*(4*s - 1) + (7*K + 7)*(s - 1)))) + (Pk2*f*(-192*r**2 + r*(204 - 156*s) + 139*s - 64) + 2*Pk2*(12*K*(4*r**2 - 5*r + 1) + 48*r**2 - r*(20*s + 33) + 58*s - 8) + 6*Pkd2*f*k2*s*(4*r - 1))*(k2**2)**(3/2))) + b1*(-8*D1*K*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 12*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 4*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 52*D1*K*Pkd2*f*fd*k1**2*k2**2*s**2 + 78*D1*K*Pkd2*f*fd*k1**2*k2**2*s - 26*D1*K*Pkd2*f*fd*k1**2*k2**2 + 28*D1*Pk2*bd2*f*k1**2*s**2*np.sqrt(k2**2) - 28*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) + 24*D1*Pk2*bd2*f*r**2*(k2**2)**(3/2) - 24*D1*Pk2*bd2*f*r*(k2**2)**(3/2) - 225*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 36*D1*Pk2*f**2*fd*k1**2*s**2*np.sqrt(k2**2) + 107*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) - 4*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 52*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) + 26*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) - 8*D1*Pk2*f*fd*k1**2*s**2*np.sqrt(k2**2) + 12*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 4*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 52*D1*Pk2*f*fd*r*s*(k2**2)**(3/2) + 26*D1*Pk2*f*fd*r*(k2**2)**(3/2) - 72*D1*Pk2*f*gd2*k1**2*s**2*np.sqrt(k2**2) + 56*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) - 48*D1*Pk2*f*gd2*r**2*(k2**2)**(3/2) + 48*D1*Pk2*f*gd2*r*(k2**2)**(3/2) - 72*D1*Pk2*fd*g2*k1**2*s**2*np.sqrt(k2**2) + 112*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) - 56*D1*Pk2*fd*g2*k1**2*np.sqrt(k2**2) - 48*D1*Pk2*fd*g2*r**2*(k2**2)**(3/2) + 96*D1*Pk2*fd*g2*r*(k2**2)**(3/2) - 48*D1*Pk2*fd*g2*(k2**2)**(3/2) - 14*D1*Pkd2*bd2*f*k1**2*k2**2*s**2 + 14*D1*Pkd2*bd2*f*k1**2*k2**2*s - 198*D1*Pkd2*f**2*fd*k1**2*k2**2*s**2 + 88*D1*Pkd2*f**2*fd*k1**2*k2**2*s - 22*D1*Pkd2*f**2*fd*k1**2*k2**2 - 60*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 20*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) - 52*D1*Pkd2*f*fd*k1**2*k2**2*s**2 + 78*D1*Pkd2*f*fd*k1**2*k2**2*s - 26*D1*Pkd2*f*fd*k1**2*k2**2 + 28*D1*Pkd2*f*gd2*k1**2*k2**2*s**2 - 28*D1*Pkd2*f*gd2*k1**2*k2**2*s + 28*D1*Pkd2*fd*g2*k1**2*k2**2*s**2 - 56*D1*Pkd2*fd*g2*k1**2*k2**2*s + 28*D1*Pkd2*fd*g2*k1**2*k2**2 + D1*bd1*f*(k1**2*(Pk2*(f*(r*(144 - 276*s) - 32*s**2 + 113*s - 48) + r*(48 - 52*s) + 8*s**2*(9*K + 5) + 8*s*(6 - 8*K) - 48)*np.sqrt(k2**2) + 2*Pkd2*k2*s*(-13*f*k2*(8*s - 5) + 9*f*(1 - 4*r)*np.sqrt(k2**2) - k2*(14*K + 14)*(s - 1))) + 2*(-Pk2*(f*(48*r**2 + r*(39*s - 54) - 40*s + 20) - r**2*(24*K + 24) + 2*r*(12*K + 5*s + 2) - 40*s + 20) + 6*Pkd2*f*k2*r*s)*(k2**2)**(3/2)) - 16*Dd*K*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 20*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 4*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) - 104*Dd*K*Pkd2*f**2*k1**2*k2**2*s**2 + 130*Dd*K*Pkd2*f**2*k1**2*k2**2*s - 26*Dd*K*Pkd2*f**2*k1**2*k2**2 - 300*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 80*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 48*Dd*Pk2*f**3*k1**2*s**2*np.sqrt(k2**2) + 151*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) - 36*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 104*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) + 26*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) - 16*Dd*Pk2*f**2*k1**2*s**2*np.sqrt(k2**2) + 20*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 4*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) - 104*Dd*Pk2*f**2*r*s*(k2**2)**(3/2) + 26*Dd*Pk2*f**2*r*(k2**2)**(3/2) - 288*Dd*Pk2*f*g2*k1**2*s**2*np.sqrt(k2**2) + 296*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 56*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) - 192*Dd*Pk2*f*g2*r**2*(k2**2)**(3/2) + 240*Dd*Pk2*f*g2*r*(k2**2)**(3/2) - 48*Dd*Pk2*f*g2*(k2**2)**(3/2) - 264*Dd*Pkd2*f**3*k1**2*k2**2*s**2 + 154*Dd*Pkd2*f**3*k1**2*k2**2*s - 22*Dd*Pkd2*f**3*k1**2*k2**2 - 80*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) + 20*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) - 104*Dd*Pkd2*f**2*k1**2*k2**2*s**2 + 130*Dd*Pkd2*f**2*k1**2*k2**2*s - 26*Dd*Pkd2*f**2*k1**2*k2**2 + 112*Dd*Pkd2*f*g2*k1**2*k2**2*s**2 - 140*Dd*Pkd2*f*g2*k1**2*k2**2*s + 28*Dd*Pkd2*f*g2*k1**2*k2**2 + 2*b2*(D1*fd*(12*Pk2*(r - 1)**2*(k2**2)**(3/2) + 7*k1**2*(s - 1)**2*(2*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)) + Dd*f*(12*Pk2*(4*r**2 - 5*r + 1)*(k2**2)**(3/2) + 7*k1**2*(2*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*(4*s**2 - 5*s + 1)))) - f*(-2*D1*b2*(2*Pk2*bd1*(7*k1**2*s*(s - 1) + 6*k2**2*r*(r - 1))*np.sqrt(k2**2) - 7*Pkd2*bd1*k1**2*k2**2*s*(s - 1) - fd*k1**2*(2*Pk2*np.sqrt(k2**2) + 13*Pkd2*k2**2)*(2*s**2 - 3*s + 1)) + D1*bd1*(f**2*k1**2*(Pk2*(75*r*s - 80*r + 12*s**2 - 44*s + 32)*np.sqrt(k2**2) + 2*Pkd2*k2*s*(33*k2*(s - 1) + 10*r*np.sqrt(k2**2))) + 2*f*s*(13*Pk2*r*(k2**2)**(3/2) + k1**2*(Pk2*(2*K*(s - 1) + 13*r + 2*s - 2)*np.sqrt(k2**2) + Pkd2*k2**2*(13*K + 13)*(s - 1))) + 4*g2*(6*Pk2*(3*k1**2*s*(s - 1) + 2*k2**2*r*(r - 1))*np.sqrt(k2**2) - 7*Pkd2*k1**2*k2**2*s*(s - 1))) + 2*Dd*b2*f*k1**2*(2*Pk2*np.sqrt(k2**2) + 13*Pkd2*k2**2)*(4*s**2 - 5*s + 1) - 2*k1**2*(s - 1)*(2*Pk2*np.sqrt(k2**2) + 13*Pkd2*k2**2)*(-D1*f*s*(bd2 - 2*gd2) + 2*D1*fd*g2*(2*s - 1) + 2*Dd*f*g2*(4*s - 1))))/(21*d**2*k1**2*(k2**2)**(3/2)) - 4*D1**3*Pk1*st**4*(D1*(66*b1**2*fd*(-2*Pk2*k1**2*r*s + Pkd2*k1**2*k2*s*(-C*s + r) + Pkd2*k2**3*r*s + k2**2*(C*Pkdd2*k1**2*s**2 + Pk2*r**2*(2 - 2*C)))*(k2**2)**(3/2) + 33*b1*f*(-2*C*(bd1*k2*(2*Pk2*k2*r*(2*r - 1) + Pkd2*k1**2*s*(2*s - 1) + Pkdd2*k1**2*k2*s*(1 - 2*s)) + fd*(-8*Pk2*k2**2*r**2 + k1**2*(2*Pk2*(r*(3*s - 4) + 2*(1 - 2*s)**2) + k2*(-2*Pkd2*r*(s - 1) - 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2))))*(k2**2)**(3/2) + bd1*(-k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) - s) + k2**2*(4*Pk2*r*(2*r - 1) + Pkd2*k2*(4*r*s - r - s)))*(k2**2)**(3/2) + fd*(-2*Pk2*k1**2*(2*k1**2*s*(1 - 2*s) + k2**2*(2*r**2 + r*(6 - 8*s) - 2*s**2 + s))*np.sqrt(k2**2) - 4*Pk2*k2**4*r*(4*r - 2*s + 1)*np.sqrt(k2**2) + Pkd2*k1**4*k2**2*s*(1 - 2*s) - Pkd2*k1**2*k2**3*(4*r + s)*(2*s - 1)*np.sqrt(k2**2) + 4*Pkd2*k2**6*r*(1 - 2*s))) + f**2*(-33*bd1*(-4*Pk2*k2**4*r*(2*C*(r - 1) - 2*r + s + 2)*np.sqrt(k2**2) + Pkd2*k2**6*(r*(4*s - 1) - 2*s + 1) + k1**4*s**2*(-4*Pk2*np.sqrt(k2**2) + Pkd2*k2**2) + k1**2*(2*Pk2*(C*(3*r*(s - 2) + 8*s**2 - 11*s + 6) + r**2 - 4*r*s - s**2 - 1) + k2*(2*C*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-2*C*(r*(s - 2) + 6*s**2 - 6*s + 2) + r*(4*s - 1) + (s - 1)**2)))*(k2**2)**(3/2)) + fd*(-Pk2*k2**4*(3*r - 1)*(16*C*(3*r - 1) - 48*r + 9*s + 24)*np.sqrt(k2**2) - 2*k1**4*(3*s - 1)*(C*Pkdd2*(3*s - 1)*(k2**2)**(3/2) + 4*Pk2*(6*C*s - 2*C - 3*r - 6*s + 3)*np.sqrt(k2**2) - Pkd2*k2**2*(5*C - 2)*(3*s - 1) + Pkd2*k2*(3*r - 1)*np.sqrt(k2**2)) + k1**2*(4*C*(Pk2*(9*r**2 - 36*r*s + 6*r + 9*s**2 + 6*s - 2) + 4*Pkd2*k2*(3*r - 1)*(3*s - 1)) + 3*Pk2*(12*r**2 - 57*r*s + s*(12*s + 11)) - 6*Pkd2*k2*(3*s - 1)*(r + 2*s - 1))*(k2**2)**(3/2)))) + Dd*f*(33*b1**2*(-k1**2*(2*C*Pkdd2*k2**2*s*(1 - 4*s) + 2*Pk2*r*(8*s - 1) - 2*Pk2*s + Pkd2*k2*(C*s*(8*s - 2) - 8*r*s + r + s)) + k2**2*(Pk2*r*(4 - 4*C)*(4*r - 1) + Pkd2*k2*(r*(8*s - 1) - s)))*(k2**2)**(3/2) - 33*b1*f*(-4*Pk2*k2**4*r*(C*(8*r - 2) - 8*r + 4*s + 1)*np.sqrt(k2**2) + Pkd2*k2**6*(2*r*(8*s - 3) - 2*s + 1) - k1**4*s*(4*s - 1)*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2) + k1**2*(2*Pk2*(C*(4*r*(3*s - 5) + 32*s**2 - 31*s + 10) + 4*r**2 - 16*r*s + 7*r - 4*s**2 + s - 1) + k2*(2*C*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-2*C*(4*r*s - 6*r + 24*s**2 - 21*s + 5) + 16*r*s - 6*r + 4*s**2 - 3*s + 1)))*(k2**2)**(3/2)) + f**2*(Pk2*k2**4*(-16*C*(12*r**2 - 7*r + 1) + 192*r**2 - 4*r*(9*s + 35) + 5*s + 24)*np.sqrt(k2**2) + k1**4*(-2*C*Pkdd2*(12*s**2 - 7*s + 1)*(k2**2)**(3/2) + 4*Pk2*(-4*C*(12*s**2 - 7*s + 1) + r*(24*s - 7) + 48*s**2 - 35*s + 6)*np.sqrt(k2**2) + Pkd2*k2**2*(10*C - 4)*(12*s**2 - 7*s + 1) + Pkd2*k2*(r*(7 - 24*s) + 7*s - 2)*np.sqrt(k2**2)) + k1**2*(4*C*(Pk2*(12*r**2 - 48*r*s + 7*r + 12*s**2 + 7*s - 2) + 2*Pkd2*k2*(24*r*s - 7*r - 7*s + 2)) + 3*Pk2*(16*r**2 - 76*r*s + s*(16*s + 11)) + Pkd2*k2*(r*(7 - 24*s) - 48*s**2 + 35*s - 6))*(k2**2)**(3/2))))/(231*d**2*k1**2*k3**2*(k2**2)**(3/2)) - 2*D1**3*Pk1*st**2*(33*D1*bd1*f*(b1*(2*Pk2*k2**4*(r**2*(28*C - 20) + r*(-14*C - 10*s + 9) + 6*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*(-4*r*s + r + s) + k1**4*(2*C*Pkdd2*s*(1 - 2*s)*(k2**2)**(3/2) + 2*Pk2*(r*(4*s - 1) + 2*s*(11*s - 6))*np.sqrt(k2**2) + Pkd2*k2**2*s*(2*C - 11)*(2*s - 1) + Pkd2*k2*(-4*r*s + r + s)*np.sqrt(k2**2)) + k1**2*(2*Pk2*(r**2*(4*C - 18) + 2*r*(C*(s - 3) - 15*s + 3) + s*(4*C*s + C - 4*s + 20)) + k2*(14*C*Pkdd2*k2*s*(1 - 2*s) - 4*Pkd2*r*(7*C*(s - 1) + 8*s - 2) + Pkd2*s*(-s*(28*C + 22) + 19)))*(k2**2)**(3/2)) + f*(k1**4*(-2*C*Pkdd2*s*(s - 1)*(k2**2)**(3/2) + 2*Pk2*(s**2*(10*C - 15) + s*(-6*C - 4*r + 6) - 1)*np.sqrt(k2**2) + Pkd2*k2**2*(r*(2*s - 1) - s**2*(6*C + 2) + s*(2*C + 2) + 1) + Pkd2*k2*(r*(2 - 4*s) + s - 1)*np.sqrt(k2**2)) + k1**2*(-Pk2*(2*C*(12*r**2 + 11*r*s + 6*r + 70*s**2 - 12*s - 16) - 3*r**2 + 30*r*s - 15*r + 34*s**2 - 24*s + 8) + k2*(-2*C*Pkd2*(2*r*(7*s - 3) + 7*s**2 - 21*s + 10) + 2*C*Pkdd2*k2*s*(s - 1) + Pkd2*s*(3 - 2*s)))*(k2**2)**(3/2) + k2**4*r*(Pk2*(C*(4 - 16*r) + 15*r - 6*s - 3)*np.sqrt(k2**2) + Pkd2*k2**2*(2*s - 1)))) - 33*b1**2*(D1*fd*(Pkd2*k1**4*k2**2*s**2*(11 - 2*C) + 2*Pkd2*k1**4*k2*r*s*np.sqrt(k2**2) + Pkd2*k1**2*k2**3*s*(r*(14*C + 16) + s*(14*C + 11))*np.sqrt(k2**2) + 14*Pkd2*k2**6*r*s + 2*k1**2*(-Pk2*k1**2*s*(2*r + 11*s) + k2**2*(C*Pkdd2*k1**2*s**2 + Pk2*(r**2*(9 - 2*C) - r*s*(C - 15) - s**2*(2*C - 2))))*np.sqrt(k2**2) + 2*k2**4*(7*C*Pkdd2*k1**2*s**2 + Pk2*r*(-14*C*r + 10*r + 5*s))*np.sqrt(k2**2)) + Dd*f*(-2*Pk2*k2**4*(r**2*(56*C - 40) + r*(-14*C - 20*s + 9) + 6*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*(r*(8*s - 1) - s) + k1**4*(2*C*Pkdd2*s*(4*s - 1)*(k2**2)**(3/2) + 2*Pk2*(-8*r*s + r + s*(12 - 44*s))*np.sqrt(k2**2) - Pkd2*k2**2*s*(2*C - 11)*(4*s - 1) + Pkd2*k2*(8*r*s - r - s)*np.sqrt(k2**2)) + k1**2*(-2*Pk2*(r**2*(8*C - 36) + r*(4*C*s - 6*C - 60*s + 6) + s*(8*C*s + C - 8*s + 20)) + k2*(14*C*Pkdd2*k2*s*(4*s - 1) + 4*Pkd2*r*(7*C*(2*s - 1) + 16*s - 2) + Pkd2*s*(s*(56*C + 44) - 19)))*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(2*Pk2*k2**4*(-2*C*(8*r**2 - 6*r + 1) + (3*r - 1)*(5*r - 2*s - 4))*np.sqrt(k2**2) + Pkd2*k2**6*s*(4*r - 1) - k1**4*(2*C*Pkdd2*(2*s**2 + 3*s - 1)*(k2**2)**(3/2) + 4*Pk2*(C*(-10*s**2 + 11*s - 3) + 4*r*s - 3*r + 15*s**2 - 14*s + 3)*np.sqrt(k2**2) + Pkd2*k2**2*(2*C*(6*s**2 - 11*s + 3) - 4*r*s + 3*r + 4*s**2 + 7*s - 2) + 4*Pkd2*k2*s*(2*r - 1)*np.sqrt(k2**2)) + k1**2*(-2*Pk2*(C*(24*r**2 + 22*r*s - 16*r + 140*s**2 - 125*s + 34) - 3*r**2 + 30*r*s + 4*r + 34*s**2 - 33*s + 2) + k2*(4*C*Pkdd2*k2*s**2 - Pkd2*(2*C*(28*r*(s - 1) + 14*s**2 - 5*s + 3) + 3*r + 4*s**2 + 4*s - 2)))*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(-4*C*(1 - 4*r)**2 + 60*r**2 - 3*r*(8*s + 15) + 4*s + 8)*np.sqrt(k2**2) + Pkd2*k2**6*(r*(8*s - 1) - s) - k1**4*(2*C*Pkdd2*(4*s**2 + 3*s - 1)*(k2**2)**(3/2) + 2*Pk2*(C*(-40*s**2 + 34*s - 6) + 16*r*s - 8*r + 60*s**2 - 39*s + 7)*np.sqrt(k2**2) + Pkd2*k2**2*(6*C*(4*s**2 - 5*s + 1) - 8*r*s + 5*r + 8*s**2 + 7*s - 3) + Pkd2*k2*(2*r*(8*s - 1) - 6*s + 1)*np.sqrt(k2**2)) + k1**2*(-Pk2*(C*(96*r**2 + 88*r*s + 8*r + 560*s**2 - 338*s + 36) - 12*r**2 + 120*r*s - 7*r + 136*s**2 - 102*s + 12) + 2*k2*(C*Pkdd2*k2*s*(4*s - 1) - Pkd2*(C*(8*r*(7*s - 6) + 28*s**2 - 25*s + 13) + 2*r + 4*s**2 + s - 1)))*(k2**2)**(3/2))) + f**2*(D1*fd*(-99*Pk2*k2**4*r*(3*r - 6*s + 1)*np.sqrt(k2**2) + k1**4*(66*C*Pkdd2*(3*s**2 - 4*s + 1)*(k2**2)**(3/2) + 2*Pk2*(2*C*(621*s**2 - 480*s + 91) - 441*r*s + 279*r - 648*s**2 + 876*s - 264)*np.sqrt(k2**2) + 33*Pkd2*k2**2*(C*(-42*s**2 + 32*s - 6) + 6*r*s - 4*r + 9*s**2 - 10*s + 3)) + k1**2*(Pk2*(4*C*(387*r**2 + 36*r*(33*s - 20) - 594*s + 263) + 693*r**2 + 1404*r*s - 699*r - 594*s**2 + 786*s - 196) + 33*Pkd2*k2*(2*C*(9*r*s - 6*r + 18*s**2 - 18*s + 5) + 6*r*s - 4*r + 9*s**2 - 10*s + 3))*(k2**2)**(3/2)) + Dd*f*(-99*Pk2*k2**4*r*(4*r - 8*s + 1)*np.sqrt(k2**2) + k1**4*(66*C*Pkdd2*(4*s**2 - 5*s + 1)*(k2**2)**(3/2) + 2*Pk2*(2*C*(828*s**2 - 571*s + 91) + r*(353 - 588*s) - 864*s**2 + 1066*s - 264)*np.sqrt(k2**2) + 33*Pkd2*k2**2*(C*(-56*s**2 + 38*s - 6) + r*(8*s - 5) + 3*(1 - 2*s)**2)) + k1**2*(Pk2*(4*C*(516*r**2 + r*(1584*s - 785) - 792*s + 263) + 924*r**2 + r*(1872*s - 667) - 792*s**2 + 950*s - 196) + 33*Pkd2*k2*(2*C*(4*r*(3*s - 2) + 24*s**2 - 21*s + 5) + r*(8*s - 5) + 3*(1 - 2*s)**2))*(k2**2)**(3/2))))/(693*d**2*k1**2*k3**2*(k2**2)**(3/2)) + 2*D1**3*Pk1*(D1*bd1*f*(2*b1*(7*Pk2*k2**4*r*(3*r - s - 1)*np.sqrt(k2**2) + k1**4*(-2*Pk2*(7*r*(s - 1) + s*(-4*C*s + 2*C - 3*s + 5))*np.sqrt(k2**2) + 7*Pkd2*k2**2*s*(1 - 2*s)) - k1**2*(Pk2*(7*r**2 + r*(-14*C*(s - 2) + 69*s - 47) + s*(-21*C + 14*s + 2)) + Pkd2*k2*s*(7*C + 7)*(2*s - 1))*(k2**2)**(3/2)) + f*(Pk2*k2**4*r*(9*r - 13*s + 13)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(40 - 57*s) + (2*s - 2)*(s*(6*C - 11) + 10))*np.sqrt(k2**2) + Pkd2*k2**2*s*(-26*C - 12)*(s - 1)) - k1**2*(Pk2*(2*C*(80*r**2 + r*(75*s - 88) + 28*s**2 - 76*s + 48) + 15*r**2 + 3*r*(34*s - 31) + 30*s**2 - 46*s + 16) + 2*Pkd2*k2*s*(18*C*r + 13*C*(s - 1) + 6*s - 6))*(k2**2)**(3/2))) + b1**2*(D1*fd*(Pk2*k1**2*(2*k1**2*s*(-7*r + s*(4*C + 3)) - k2**2*(7*r**2 + r*s*(69 - 14*C) + 14*s**2))*np.sqrt(k2**2) + 7*Pk2*k2**4*r*(3*r - s)*np.sqrt(k2**2) - 14*Pkd2*k1**4*k2**2*s**2 - Pkd2*k1**2*k2**3*s**2*(14*C + 14)*np.sqrt(k2**2)) + 2*Dd*f*(7*Pk2*k2**4*r*(6*r - 2*s - 1)*np.sqrt(k2**2) + k1**4*(-2*Pk2*(7*r*(2*s - 1) + s*(-8*C*s + 2*C - 6*s + 5))*np.sqrt(k2**2) + 7*Pkd2*k2**2*s*(1 - 4*s)) - k1**2*(Pk2*(14*r**2 + r*(-28*C*(s - 1) + 138*s - 47) + s*(-21*C + 28*s + 2)) + Pkd2*k2*s*(7*C + 7)*(4*s - 1))*(k2**2)**(3/2))) + b1*f*(D1*fd*(-2*C*(k1**4*(-2*Pk2*(6*s**2 + 3*s - 1)*np.sqrt(k2**2) + 13*Pkd2*k2**2*(2*s**2 - 3*s + 1)) + k1**2*(Pk2*(160*r**2 + 10*r*(15*s - 16) + 56*s**2 - 123*s + 40) + 2*Pkd2*k2*s*(18*r + 13*s - 9))*(k2**2)**(3/2)) + Pk2*k2**4*r*(18*r - 26*s - 9)*np.sqrt(k2**2) + k1**4*(Pk2*(r*(13 - 114*s) - s*(44*s - 44))*np.sqrt(k2**2) - 24*Pkd2*k2**2*s**2) - 2*k1**2*(Pk2*(15*r**2 + 2*r*(51*s - 7) + 2*s*(15*s - 7)) + 12*Pkd2*k2*s**2)*(k2**2)**(3/2)) + Dd*f*(4*Pk2*k2**4*r*(9*r - 13*s + 1)*np.sqrt(k2**2) + k1**4*(Pk2*(4*C*(12*s**2 + s - 1) + r*(53 - 228*s) - 88*s**2 + 106*s - 20)*np.sqrt(k2**2) - 2*Pkd2*k2**2*(4*s - 1)*(13*C*(s - 1) + 6*s)) - k1**2*(Pk2*(2*C*(320*r**2 + 300*r*s - 288*r + 112*s**2 - 247*s + 88) + 60*r**2 + 408*r*s - 121*r + 120*s**2 - 90*s + 16) + 2*Pkd2*k2*s*(C*(72*r + 52*s - 31) + 24*s - 6))*(k2**2)**(3/2))) - f**2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1))*(2*C*k1**2*(s - 1)*(2*Pk2*np.sqrt(k2**2) + 11*Pkd2*k2**2) + 11*Pk2*r*(k1**2 + k2**2)*np.sqrt(k2**2)))/(21*d**2*k1**2*k3**2*(k2**2)**(3/2)) + 8*D1**3*Pk1*st**4*(D1*(22*b1**2*fd*(Pk2*k2**4*r*(r + s) + k1**2*(2*C*Pkd2*k2**3*r*s + 2*C*Pkd2*s**2*(k2**2)**(3/2) + Pk2*k2**2*r*(r + s))) - 11*b1*f*(2*C*k1**2*(Pkd2*bd1*(k2**3*(-4*r*s + r + s) + 2*s*(1 - 2*s)*(k2**2)**(3/2)) + fd*(2*Pk2*k2**2*(2*r**2 - 2*r*s + r - (1 - 2*s)**2) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 4*Pkd2*k2**3*r*(2*s - 1) + (4*s - 2)*(-Pk2*k1**2*(r + s) + Pkd2*(2*s - 1)*(k2**2)**(3/2)))) + Pk2*(k1**2 + k2**2)*(bd1*k2**2*(-4*r**2 + r*(3 - 4*s) + s) + fd*(k1**2*(2*r**2 + 4*r*s + s*(2*s - 1)) + 4*k2**2*r*(2*r + 2*s - 1)))) + f**2*(-11*bd1*(Pk2*k2**4*(4*r**2 + r*(4*s - 5) - 2*s + 1) + k1**4*(2*C*Pkd2*k2*s*(r + s) + Pk2*(r**2 + r*(-4*C*s + 2*s - 1) + s*(-4*C*s + s - 2))) + k1**2*(2*C*Pkd2*k2**3*(r*(4*s - 1) - 2*s + 1) + 4*C*Pkd2*s*(2*s - 1)*(k2**2)**(3/2) + Pk2*k2**2*(r**2*(4*C + 5) - 2*r*(2*C*(s + 1) - 3*s + 3) + s**2*(1 - 8*C) + s*(4*C - 4) + 1))) + 2*fd*k1**2*(Pk2*k2**2*(C*(3*r - 1)*(r + s + 3) - (3*r + 3*s - 2)**2) + k1**2*(2*C*Pkd2*k2*(1 - 3*s) + Pk2*(4*C*(3*s - 1) - 3*r - 3*s + 2))*(3*r + 3*s - 2)))) + Dd*f*(11*b1**2*(Pk2*k2**4*(8*r**2 + r*(8*s - 3) - s) + k1**2*(2*C*Pkd2*k2**3*(8*r*s - r - s) + 4*C*Pkd2*s*(4*s - 1)*(k2**2)**(3/2) + Pk2*k2**2*(8*r**2 + 8*r*s - 3*r - s))) - 11*b1*f*(Pk2*k2**4*(8*r - 1)*(2*r + 2*s - 1) + k1**4*(2*C*Pkd2*k2*(r + s)*(4*s - 1) + Pk2*(4*r**2 + r*(-16*C*s + 4*C + 8*s - 1) + s*(-16*C*s + 4*C + 4*s - 3))) + k1**2*(2*C*Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 4*C*Pkd2*(8*s**2 - 6*s + 1)*(k2**2)**(3/2) + Pk2*k2**2*(4*C*(4*r**2 - 4*r*s - 8*s**2 + 6*s - 1) + 20*r**2 + 24*r*s - 11*r + 4*s**2 - 5*s + 1))) + 2*f**2*k1**2*(Pk2*k2**2*(C*(4*r**2 + 4*r*s + 13*r - 3*s - 3) - 12*r**2 - 24*r*s + 14*r - 12*s**2 + 14*s - 4) + k1**2*(C*Pkd2*k2*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + 2*Pk2*(C*(24*r*s - 7*r + 24*s**2 - 21*s + 4) - 6*r**2 - 12*r*s + 7*r - 6*s**2 + 7*s - 2)))))/(77*d**2*k1**2*k3**4) - 4*D1**3*Pk1*st**2*(33*D1*bd1*f*(b1*k2**2*(7*Pk2*k2**4*(4*r**2 + r*(4*s - 3) - s) + k1**4*(4*C*Pkd2*k2*(r*(13*s - 5) + s*(13*s - 8)) + Pk2*(26*r**2 + r*(52*s - 19) + s*(26*s - 33))) + 2*k1**2*(7*C*Pkd2*k2**3*(r*(4*s - 1) - s) + 14*C*Pkd2*s*(2*s - 1)*(k2**2)**(3/2) + Pk2*k2**2*(r + s)*(28*C*(r + s - 1) + 27*r + 13*s - 20))) + f*(Pk2*k1**6*(2*s - 1)*(r + s - 1) + Pk2*k2**6*r*(-2*r - 2*s + 1) + k1**4*k2**2*(4*C*Pkd2*k2*(2*s**2 + s*(2*r - 1) - 1) + Pk2*(4*C*(4*r**2 + r*(21*s - 5) + 17*s**2 - 8*s + 1) + 4*r**2 + 10*r*(s - 1) + 6*s**2 - 12*s + 5)) + k1**2*k2**4*(2*C*Pkd2*(k2*(-2*r*s + r) - 2*s*(s - 1)*np.sqrt(k2**2)) + Pk2*(C*(-6*r**2 + 6*r*(s + 1) + 12*s**2 - 4*s - 4) + 2*r**2 + 6*r*s - 8*r + 4*s**2 - 9*s + 4)))) + 33*b1**2*k2**2*(D1*fd*(14*Pk2*k2**4*r*(r + s) + 13*k1**4*(r + s)*(2*C*Pkd2*k2*s + Pk2*(r + s)) + k1**2*(28*C*Pkd2*k2**3*r*s + 28*C*Pkd2*s**2*(k2**2)**(3/2) + Pk2*k2**2*(r + s)*(r*(28*C + 27) + s*(28*C + 13)))) + Dd*f*(7*Pk2*k2**4*(8*r**2 + r*(8*s - 3) - s) + k1**4*(4*C*Pkd2*k2*(r*(26*s - 5) + 2*s*(13*s - 4)) + Pk2*(52*r**2 + r*(104*s - 19) + s*(52*s - 33))) + 2*k1**2*(7*C*Pkd2*k2**3*(r*(8*s - 1) - s) + 14*C*Pkd2*s*(4*s - 1)*(k2**2)**(3/2) + 2*Pk2*k2**2*(r + s)*(14*C*(2*r + 2*s - 1) + 27*r + 13*s - 10)))) + 33*b1*f*(D1*fd*(Pk2*k1**6*(r*(4*s - 3) + 4*s**2 - 6*s + 2) + Pk2*k2**6*(-4*r**2 + r*(2 - 4*s) + s) + k1**4*k2**2*(2*C*Pkd2*k2*(r*(8*s + 7) + 8*s**2 + 5*s - 4) + Pk2*(4*C*(8*r**2 + 6*r*(7*s - 3) + 34*s**2 - 23*s + 3) + 8*r**2 + 20*r*s - 11*r + 12*s**2 - 14*s + 4)) + k1**2*k2**4*(2*C*Pkd2*s*(-4*k2*r + k2 - 4*s*np.sqrt(k2**2)) + Pk2*(-2*C*(6*r**2 - 6*r*s + 8*r - 12*s**2 + 8*s - 5) + 4*r**2 + 12*r*s - 6*r + 8*s**2 - 7*s + 2))) + Dd*f*(Pk2*k1**6*(r*(8*s - 5) + 8*s**2 - 11*s + 3) + Pk2*k2**6*(-8*r**2 + r*(3 - 8*s) + s) + k1**4*k2**2*(4*C*Pkd2*k2*(r*(8*s + 5) + 8*s**2 + 3*s - 3) + Pk2*(8*C*(8*r**2 + 6*r*(7*s - 2) + 34*s**2 - 17*s + 2) + 16*r**2 + 5*r*(8*s - 5) + 24*s**2 - 31*s + 9)) + k1**2*k2**4*(2*C*Pkd2*(k2*(-8*r*s + r + s) + 2*s*(1 - 4*s)*np.sqrt(k2**2)) + Pk2*(-6*C*(4*r**2 - 4*r*s + 3*r - 8*s**2 + 3*s - 1) + 8*r**2 + 24*r*s - 17*r + 16*s**2 - 19*s + 6)))) + f**2*k1**2*(D1*fd*(Pk2*k1**4*(6*r*(9*s - 14) + 54*s**2 - 153*s + 67) - 33*Pk2*k2**4*(2*C*(9*r**2 + 3*r*(9*s - 5) + 18*s**2 - 18*s + 5) + 15*r**2 + 3*r*(8*s - 5) + 9*s**2 - 10*s + 3) - k1**2*k2**2*(66*C*Pkd2*k2*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7) + Pk2*(4*C*(54*r**2 - 540*r*s + 177*r - 594*s**2 + 576*s - 131) + 495*r**2 + 738*r*s - 411*r + 243*s**2 - 177*s + 32))) + Dd*f*(Pk2*k1**4*(r*(72*s - 109) + 72*s**2 - 195*s + 67) - 33*Pk2*k2**4*(2*C*(12*r**2 + r*(36*s - 17) + 24*s**2 - 21*s + 5) + 20*r**2 + 16*r*(2*s - 1) + 3*(1 - 2*s)**2) - k1**2*k2**2*(66*C*Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 25*s + 7) + Pk2*(4*C*(72*r**2 - 720*r*s + 201*r - 792*s**2 + 683*s - 131) + 660*r**2 + 984*r*s - 419*r + 324*s**2 - 201*s + 32)))))/(693*d**2*k1**2*k2**2*k3**4) + D1**3*Pk2*Pkd1*ct**7*f*(16*C - 16)*(D1*(132*b1*fd*r*(k2**3*(4*r - 6*s + 3) + 5*(2*s - 1)*(k2**2)**(3/2)) + f*(33*bd1*(4*k2**3*r*(2*r - 3*s - 2) + 5*(4*r*s - r - 2*s + 1)*(k2**2)**(3/2)) + 5*fd*(2*k2**3*(54*r**2 + r*(30 - 99*s) - 5) + (9*r*(34*s - 15) - 36*s + 23)*(k2**2)**(3/2)))) + Dd*f*(33*b1*(4*k2**3*r*(8*r - 12*s + 1) + 5*(16*r*s - 6*r - 2*s + 1)*(k2**2)**(3/2)) + 5*f*(2*k2**3*(72*r**2 - 132*r*s + 35*r - 5) + (408*r*s - 163*r - 31*s + 23)*(k2**2)**(3/2))))/(693*d**2*k3**4) - 8*D1**3*Pk2*Pkd1*ct**6*f*k2**2*(-33*D1*bd1*f*(k1*(6*C*(2*r**2 + r*(2*s - 5) - 4*s + 3) - 20*r**2 + r*(43 - 20*s) + 34*s - 23)*np.sqrt(k1**2) + k2**2*(-8*r**2 + r*(13 - 8*s) + 10*s - 5)) - 33*b1*(8*D1*fd*r*(k1*(3*C*(r + s - 1) - 5*r - 5*s + 4)*np.sqrt(k1**2) + k2**2*(-2*r - 2*s + 1)) + Dd*f*(k1*(6*C*(8*r**2 + 4*r*(2*s - 3) - 4*s + 3) - 80*r**2 + r*(98 - 80*s) + 34*s - 23)*np.sqrt(k1**2) - k2**2*(16*r - 5)*(2*r + 2*s - 1))) - 5*f*(D1*fd*(3*r - 1)*(k1*(6*C*(3*r + 3*s - 2) - 54*r - 54*s + 25)*np.sqrt(k1**2) + k2**2*(-36*r - 36*s + 13)) + Dd*f*(k1*(12*C*(6*r**2 + r*(6*s - 8) + s + 1) - 216*r**2 - 27*r*(8*s - 7) + 19*s - 25)*np.sqrt(k1**2) + k2**2*(-144*r**2 + r*(93 - 144*s) + 31*s - 13))))/(693*d**2*k3**4*np.sqrt(k1**2)) + D1**3*Pk2*Pkd1*ct**5*f*st**2*(16*C - 16)*(D1*(66*b1*fd*r*(k2**3*(14*r - 6*s + 3) + 10*(2*s - 1)*(k2**2)**(3/2)) + f*(66*bd1*k2**3*r*(7*r - 3*s - 7) + 165*bd1*(r*(4*s - 1) - 2*s + 1)*(k2**2)**(3/2) + 2*fd*k2**3*(432*r**2 - 3*r*(99*s + 8) - 7) + fd*(9*r*(162*s - 65) - 156*s + 85)*(k2**2)**(3/2))) + Dd*f*(33*b1*(8*k2**3*r*(7*r - 3*s - 1) + 5*(16*r*s - 6*r - 2*s + 1)*(k2**2)**(3/2)) + f*(2*k2**3*(576*r**2 - 396*r*s - 17*r - 7) + (1944*r*s - 710*r - 116*s + 85)*(k2**2)**(3/2))))/(693*d**2*k3**4) + 8*D1**3*Pk2*Pkd1*ct**5*(33*D1*bd1*f*(4*b1*(C - 1)*(k2**3*r*(5*r - 7*s + 1) + 3*(r*(4*s - 1) - s)*(k2**2)**(3/2)) + f*(3*k1**2*k2*(C*(-4*r**2 - 4*r*s + 2*r + 2) + 2*r**2 + 2*r*s + 3*r + 4*s - 5) - 2*k2**3*(2*C*(9*r**2 + 9*r*s - 17*r - 6*s + 3) - 10*r**2 - 30*r*s + 29*r + 18*s - 9) + (2*C*(r + 11*s - 6) - 6*r**2 - 46*r*s + 29*r + 22*s - 13)*(k2**2)**(3/2))) + 66*b1**2*(C - 1)*(D1*fd*r*(k2**3*(5*r - 7*s) + 12*s*(k2**2)**(3/2)) + 2*Dd*f*(k2**3*r*(10*r - 14*s + 1) + 3*(8*r*s - r - s)*(k2**2)**(3/2))) + 33*b1*f*(-4*D1*fd*(3*k1**2*k2*r*(r*(2*C - 1) + s*(2*C - 1) - 1) + k2**3*(18*C*r**2 + C*r*(18*s - 7) + C - 10*r**2 + r*(13 - 30*s) - 1) + (3*r**2 + r*(-4*C + 23*s - 9) + s*(C - 1))*(k2**2)**(3/2)) + Dd*f*(-3*k1**2*k2*(2*C*(8*r**2 + 8*r*s - 1) - 8*r**2 - 4*r*(2*s + 3) - 4*s + 5) - 2*k2**3*(4*C*(18*r**2 + 2*r*(9*s - 7) - 3*s + 2) - 40*r**2 + r*(66 - 120*s) + 18*s - 11) + (4*C*(7*r + 5*s - 3) - 24*r**2 + r*(80 - 184*s) + 24*s - 13)*(k2**2)**(3/2))) - 5*f**2*(D1*fd*(3*k1**2*k2*(3*r - 1)*(2*C*(19*r + 19*s - 9) - 35*r - 35*s + 16) + k2**3*(2*C*(3*r - 1)*(102*r + 66*s - 23) + (99 - 396*r)*(r + 2*s - 1)) + (2*C*(3*r - 1)*(36*s - 23) + 27*r**2 + 3*r*(141*s - 64) - 75*s + 39)*(k2**2)**(3/2)) + Dd*f*(6*k1**2*k2*(C*(76*r**2 + r*(76*s - 50) - 24*s + 9) - 70*r**2 + r*(42 - 70*s) + 25*s - 8) + k2**3*(2*C*(4*r - 1)*(102*r + 66*s - 23) - 528*r**2 - 66*r*(16*s - 9) + 198*s - 99) + (2*C*(r*(144*s - 97) - 31*s + 23) + 36*r**2 + 6*r*(94*s - 41) - 60*s + 39)*(k2**2)**(3/2))))/(693*d**2*k3**4) - 8*D1**3*Pk2*Pkd1*ct**4*f*k2**2*st**2*(-33*D1*bd1*f*(k1*(3*C*(14*r**2 + 14*r*s - 19*r - 9*s + 5) - 56*r**2 - 56*r*s + 76*r + 37*s - 20)*np.sqrt(k1**2) + k2**2*(-14*r**2 + r*(19 - 14*s) + 10*s - 5)) - 33*b1*(D1*fd*r*(k1*(C*(84*r + 84*s - 45) - 112*r - 112*s + 59)*np.sqrt(k1**2) - 14*k2**2*(2*r + 2*s - 1)) + Dd*f*(k1*(3*C*(56*r**2 + r*(56*s - 39) - 9*s + 5) - 224*r**2 + r*(155 - 224*s) + 37*s - 20)*np.sqrt(k1**2) - k2**2*(28*r - 5)*(2*r + 2*s - 1))) + f*(D1*fd*(k1*(-9*C*(240*r**2 + 6*r*(40*s - 29) - 25*s + 13) + 3024*r**2 + 3024*r*s - 2199*r - 381*s + 188)*np.sqrt(k1**2) + k2**2*(864*r**2 + r*(864*s - 633) - 156*s + 71)) + Dd*f*(k1*(-9*C*(320*r**2 + 320*r*s - 203*r - 9*s + 13) + 4032*r**2 + 4032*r*s - 2571*r - 197*s + 188)*np.sqrt(k1**2) + k2**2*(1152*r**2 + 24*r*(48*s - 31) - 116*s + 71))))/(693*d**2*k3**4*np.sqrt(k1**2)) - 8*D1**3*Pk2*Pkd1*ct**4*(33*D1*bd1*f*(2*b1*k2**2*(-2*C*k1*(r**2 + r*s + r - 2*s)*np.sqrt(k1**2) + 7*k1*(r**2 + r*s - s)*np.sqrt(k1**2) + k2**2*(5*r**2 + 5*r*s - 2*r - 3*s)) + f*(k1**4*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 14*r**2 - 14*r*s + 13*r + 4*s + 1) + k1*k2**2*(6*C*(10*r**2 + 10*r*s - 19*r - 11*s + 8) - 64*r**2 - 64*r*s + 109*r + 55*s - 34)*np.sqrt(k1**2) + k2**4*(-10*r**2 + r*(22 - 10*s) + 13*s - 7))) + 33*b1**2*k2**2*(-2*C*k1*(D1*fd*r*(r + s) + 2*Dd*f*(2*r**2 + 2*r*s + r - 2*s))*np.sqrt(k1**2) + D1*fd*r*(r + s)*(7*k1*np.sqrt(k1**2) + 5*k2**2) + 2*Dd*f*(7*k1*(2*r**2 + 2*r*s - s)*np.sqrt(k1**2) + k2**2*(10*r**2 + 10*r*s - 2*r - 3*s))) + 33*b1*f*(2*D1*fd*(2*k1**4*r*(C*(4*r + 4*s - 2) - 7*r - 7*s + 2) + k1*k2**2*(6*C*(10*r**2 + r*(10*s - 9) - s + 1) - 64*r**2 + r*(49 - 64*s) + 5*s - 7)*np.sqrt(k1**2) - k2**4*(10*r**2 + r*(10*s - 7) + s + 1)) + Dd*f*(k1**4*(2*C*(8*r - 1)*(2*r + 2*s - 1) - 56*r**2 + r*(20 - 56*s) + 4*s + 1) + 4*k1*k2**2*(3*C*(20*r**2 + r*(20*s - 23) - 7*s + 5) - 64*r**2 - 2*r*(32*s - 31) + 18*s - 12)*np.sqrt(k1**2) + k2**4*(-40*r**2 + r*(44 - 40*s) + 12*s - 9))) + 5*f**2*(D1*fd*(3*r - 1)*(k1**4*(20*C*(3*r + 3*s - 2) - 117*r - 117*s + 67) + 3*k1*k2**2*(24*C*(3*r + 3*s - 2) - 107*r - 107*s + 64)*np.sqrt(k1**2) - 33*k2**4*(2*r + 2*s - 1)) + Dd*f*(k1**4*(10*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) - 468*r**2 + r*(360 - 468*s) + 142*s - 67) + 6*k1*k2**2*(C*(144*r**2 + r*(144*s - 137) - 31*s + 24) - 214*r**2 - 214*r*s + 179*r + 56*s - 32)*np.sqrt(k1**2) - 33*k2**4*(4*r - 1)*(2*r + 2*s - 1))))/(693*d**2*k3**4*np.sqrt(k1**2)) + D1**3*Pk2*Pkd1*ct**3*f*st**4*(16*C - 16)*(2*D1*(33*b1*fd*k2**3*r*(2*r + 2*s - 1) + 33*bd1*f*k2**3*r*(r + s - 1) + 5*f*fd*(3*r - 1)*(k2**3*(3*r - 1) + (3*s - 1)*(k2**2)**(3/2))) + Dd*f*(132*b1*k2**3*r*(2*r + 2*s - 1) + 5*f*(2*k2**3*(12*r**2 - 7*r + 1) + (24*r*s - 7*r - 7*s + 2)*(k2**2)**(3/2))))/(231*d**2*k3**4) - 4*D1**3*Pk2*Pkd1*ct**3*st**2*(33*D1*bd1*f*(-2*b1*(C - 1)*(2*k2**3*r*(13*r + 7*s - 10) + 3*(r*(4*s - 1) - s)*(k2**2)**(3/2)) + f*(k1**2*k2*(-2*C*(19*r**2 + 19*r*s - 26*r - 11*s + 7) + 80*r**2 + 80*r*s - 109*r - 49*s + 29) + k2**3*(2*C*(27*r**2 + 7*r*s - 36*r - 6*s + 3) + 2*r**2 - 26*r*s + 19*r + 18*s - 9) + (2*C*(20*r*s - 7*r - 20*s + 10) + 42*r**2 + 70*r*s - 66*r - 33*s + 18)*(k2**2)**(3/2))) - 66*b1**2*(C - 1)*(D1*fd*r*(k2**3*(13*r + 7*s) + 6*s*(k2**2)**(3/2)) + Dd*f*(4*k2**3*r*(13*r + 7*s - 5) + 3*(8*r*s - r - s)*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(k1**2*k2*r*(C*(-76*r - 76*s + 44) + 160*r + 160*s - 89) + 2*k2**3*(C*(54*r**2 + 14*r*s + 5*r - 2) + 2*r**2 - 26*r*s + r + 2) + (84*r**2 + r*(80*C*s - 56*C + 140*s - 57) + s*(10*C - 10))*(k2**2)**(3/2)) + Dd*f*(k1**2*k2*(-2*C*(76*r**2 + 76*r*s - 55*r - 11*s + 7) + 320*r**2 + 320*r*s - 227*r - 49*s + 29) + k2**3*(2*C*(108*r**2 + 4*r*(7*s - 8) - 6*s + 1) + 8*r**2 - 104*r*s + 26*r + 18*s - 5) + (10*C*(16*r*s - 9*r - 3*s + 2) + 168*r**2 + 280*r*s - 141*r - 43*s + 18)*(k2**2)**(3/2))) + f**2*(D1*fd*(-3*k1**2*k2*(2*C*(261*r**2 + 261*r*s - 184*r + s + 3) - 1242*r**2 - 1242*r*s + 890*r + 73*s - 45) + k2**3*(2*C*(3*r - 1)*(774*r + 198*s - 71) + (297 - 1188*r)*(r + 2*s - 1)) + (4*C*(9*r*(96*s - 43) - 156*s + 85) + 2160*r**2 + 9*r*(372*s - 229) - 423*s + 216)*(k2**2)**(3/2)) + Dd*f*(-3*k1**2*k2*(C*(696*r**2 + 696*r*s - 422*r + 50*s + 6) - 1656*r**2 - 1656*r*s + 1031*r - 23*s - 45) + k2**3*(2*C*(4*r - 1)*(774*r + 198*s - 71) - 1584*r**2 - 3168*r*s + 1782*r + 594*s - 297) + (4*C*(128*r*(9*s - 4) - 116*s + 85) + 2880*r**2 + 9*r*(496*s - 269) - 279*s + 216)*(k2**2)**(3/2))))/(693*d**2*k3**4) + 8*D1**3*Pk2*Pkd1*ct**3*(33*D1*bd1*f*(b1*(-2*k1**2*(-3*C*s + r**2*(12*C - 11) + r*(3*C*(4*s - 3) - 11*s + 10) + s)*(k2**2)**(3/2) + k2**5*(-2*r**2 - r*(C*(20*s + 2) + 30*s - 5) + s*(12*C + 11)) + k2**4*(r**2*(28 - 48*C) + r*(-28*C*s + 24*C + 56*s - 21) + s*(14*C - 21))*np.sqrt(k2**2)) + f*(k1**4*(k2*(r*(5 - 8*s) + 4*s - 5) + 2*(2*r**2 + r*(6*s - 5) - 3*s + 3)*np.sqrt(k2**2)) + k1**2*(-6*C*(4*r**2 + r*(4*s - 7) - 3*s + 4) + 64*r**2 + r*(64*s - 95) - 41*s + 34)*(k2**2)**(3/2) + k2**4*(k2*(2*C*(2*r*(5*s - 4) - 13*s + 7) + 24*r**2 + 12*r*(s - 3) - 21*s + 15) + 2*r*(2*C*(2*r - 3*s - 7) + 6*r + 12*s - 3)*np.sqrt(k2**2)))) - 33*b1**2*(D1*fd*r*(k1**2*(12*C - 11)*(r + s)*(k2**2)**(3/2) + k2**5*(r + s*(10*C + 15)) + 2*k2**4*(r*(12*C - 7) + s*(7*C - 14))*np.sqrt(k2**2)) + Dd*f*(2*k1**2*(-3*C*s + r**2*(24*C - 22) + r*(3*C*(8*s - 3) - 22*s + 10) + s)*(k2**2)**(3/2) + k2**5*(4*r**2 + r*(C*(40*s + 2) + 60*s - 5) - s*(12*C + 11)) + k2**4*(r**2*(96*C - 56) + r*(8*C*(7*s - 3) - 112*s + 21) + s*(21 - 14*C))*np.sqrt(k2**2))) + 33*b1*f*(2*D1*fd*(k1**4*k2*r*(7 - 8*s) + k1**2*(k1**2*r*(4*r + 12*s - 9) + k2**2*(-6*C*(4*r**2 + 4*r*s - 6*r - 2*s + 1) + 64*r**2 + 64*r*s - 59*r - 15*s + 9))*np.sqrt(k2**2) + k2**5*(4*C*r*(5*s - 3) + 2*C*s + 24*r**2 + 3*r*(4*s - 7) + 3) + k2**4*(2*C*(4*r**2 + r*(2 - 6*s) + 3*s + 1) + 12*r**2 + 3*r*(8*s - 2) - 9*s)*np.sqrt(k2**2)) + Dd*f*(k1**4*(k2*(-8*r*(4*s - 3) + 4*s - 5) + 2*(8*r**2 + r*(24*s - 17) - 3*s + 3)*np.sqrt(k2**2)) - 4*k1**2*(3*C*(8*r**2 + 4*r*(2*s - 3) - 4*s + 3) - 64*r**2 - 64*r*(s - 1) + 20*s - 13)*(k2**2)**(3/2) + k2**4*(k2*(2*C*(r*(40*s - 26) - 12*s + 7) + 96*r**2 + 48*r*(s - 2) - 24*s + 21) + 2*(2*C*(4*r - 1)*(2*r - 3*s - 1) + 24*r**2 + 48*r*s - 9*r - 9*s)*np.sqrt(k2**2)))) + 5*f**2*(D1*fd*(k1**4*(k2*(-6*r*(18*s - 17) + 3*s - 23) + (90*r**2 + 6*r*(33*s - 32) - 33*s + 43)*np.sqrt(k2**2)) + k1**2*(3*r - 1)*(12*C*(4*r + 4*s + 1) + 195*r + 195*s - 152)*(k2**2)**(3/2) + 33*k2**4*(3*r - 1)*(4*C*r*np.sqrt(k2**2) + k2*(C*(4*s - 2) + 3*r + 3*s - 2))) + Dd*f*(k1**4*(-k2*(2*r*(72*s - 65) + 2*s + 23) + (120*r**2 + r*(264*s - 235) - 33*s + 43)*np.sqrt(k2**2)) + 2*k1**2*(3*C*(32*r**2 + r*(32*s + 5) - 13*s - 2) + 390*r**2 + r*(390*s - 399) - 100*s + 76)*(k2**2)**(3/2) + 33*k2**4*(4*r - 1)*(4*C*r*np.sqrt(k2**2) + k2*(C*(4*s - 2) + 3*r + 3*s - 2)))))/(693*d**2*k2*k3**4*np.sqrt(k2**2)) - 8*D1**3*Pk2*Pkd1*ct**2*f*k2**2*st**4*(-2*D1*(33*b1*fd*r*(k1*(C - 2)*np.sqrt(k1**2) - k2**2)*(2*r + 2*s - 1) + f*(33*bd1*r*(k1*(C - 2)*np.sqrt(k1**2) - k2**2)*(r + s - 1) + fd*(3*r - 1)*(k1*(6*C - 11)*np.sqrt(k1**2) - 5*k2**2)*(3*r + 3*s - 2))) + Dd*f*(-132*b1*r*(k1*(C - 2)*np.sqrt(k1**2) - k2**2)*(2*r + 2*s - 1) - f*(k1*(6*C - 11)*np.sqrt(k1**2) - 5*k2**2)*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)))/(231*d**2*k3**4*np.sqrt(k1**2)) - 4*D1**3*Pk2*Pkd1*ct**2*st**2*(-33*D1*bd1*f*(-b1*k2**2*(k1*(3 - 2*C)*np.sqrt(k1**2) + k2**2)*(26*r**2 + r*(26*s - 23) - 3*s) + f*(k1**4*(2*C*(2*r - 1)*(r + s - 1) - 23*r**2 + r*(32 - 23*s) + 13*s - 9) - k1*k2**2*(2*C*(38*r**2 + r*(38*s - 58) - 30*s + 17) + 28*r**2 + r*(28*s - 19) + s)*np.sqrt(k1**2) - k2**4*(r**2 + r*(s + 5) + 6*s - 3))) + 33*b1**2*k2**2*(k1*(3 - 2*C)*np.sqrt(k1**2) + k2**2)*(13*D1*fd*r*(r + s) + Dd*f*(52*r**2 + r*(52*s - 23) - 3*s)) - 33*b1*f*(-D1*fd*(2*k1**4*r*(C*(-4*r - 4*s + 3) + 23*r + 23*s - 14) + k1*k2**2*(2*C*(76*r**2 + 38*r*(2*s - 1) + 5*s - 2) + 56*r**2 + r*(56*s - 41) - 15*s + 6)*np.sqrt(k1**2) + k2**4*(2*r**2 + r*(2*s - 5) - 5*s + 2)) + Dd*f*(k1**4*(2*C*(8*r**2 + r*(8*s - 7) - s + 1) - 92*r**2 + r*(69 - 92*s) + 13*s - 9) - 2*k1*k2**2*(C*(152*r**2 + r*(152*s - 111) - 25*s + 15) + 56*r**2 + r*(56*s - 33) - 7*s + 3)*np.sqrt(k1**2) - k2**4*(4*r**2 + 4*r*s + r + s - 1))) - f**2*(D1*fd*(k1**4*(2*C*(54*r**2 + 54*r*(s - 1) + 15*s + 1) - 891*r**2 - 11*r*(81*s - 60) - 33*s - 11) + 3*k1*k2**2*(-2*C*(819*r**2 + 9*r*(91*s - 69) - 108*s + 61) + 135*r**2 + r*(135*s - 179) - 133*s + 74)*np.sqrt(k1**2) + 99*k2**4*(3*r - 1)*(2*r + 2*s - 1)) + Dd*f*(k1**4*(2*C*(72*r**2 + 9*r*(8*s - 7) + 23*s + 1) - 1188*r**2 - 33*r*(36*s - 23) - 121*s - 11) + 3*k1*k2**2*(-2*C*(1092*r**2 + 2*r*(546*s - 365) - 60*s + 61) + 180*r**2 + r*(180*s - 229) - 157*s + 74)*np.sqrt(k1**2) + 99*k2**4*(4*r - 1)*(2*r + 2*s - 1))))/(693*d**2*k3**4*np.sqrt(k1**2)) + 8*D1**3*Pk2*Pkd1*ct**2*(-33*D1*bd1*f*(b1*(k1**4*(2*C - 5)*(4*r**2 + r*(4*s - 3) - s) + 2*k1*k2**2*(r**2*(16*C - 27) + r*(C*(16*s - 5) - 27*s + 15) + s*(12 - 11*C))*np.sqrt(k1**2) - 7*k2**4*(r + s)*(2*r - 1)) + f*(k1**4*(-26*r**2 + 2*r*(C - 13*s + 16) + s*(2*C + 11) - 11) - 3*k1*k2**2*(2*C*(6*r**2 + 2*r*(3*s - 7) - 7*s + 5) + 12*r**2 + 4*r*(3*s - 2) - 3*s + 3)*np.sqrt(k1**2) - 6*k2**4*r*(r + s))) - 33*b1**2*(D1*fd*r*(r + s)*(k1**4*(4*C - 10) + k1*k2**2*(16*C - 27)*np.sqrt(k1**2) - 7*k2**4) + Dd*f*(k1**4*(2*C - 5)*(8*r**2 + r*(8*s - 3) - s) + 2*k1*k2**2*(r**2*(32*C - 54) + r*(C*(32*s - 5) - 54*s + 15) + s*(12 - 11*C))*np.sqrt(k1**2) - 7*k2**4*(r + s)*(4*r - 1))) + 33*b1*f*(2*D1*fd*(k1**4*(C*(4*r + 4*s - 2) + 26*r**2 + 26*r*(s - 1) - 10*s + 5) + 3*k1*k2**2*(2*C*(6*r**2 + 6*r*(s - 1) + 1) + 12*r**2 + 3*r*(4*s - 3) - 5*s + 1)*np.sqrt(k1**2) + 3*k2**4*(r + s)*(2*r - 1)) + Dd*f*(k1**4*(C*(8*r + 8*s - 4) + 104*r**2 + 4*r*(26*s - 25) - 36*s + 21) + 3*k1*k2**2*(2*C*(24*r**2 + 8*r*(3*s - 4) - 8*s + 7) + 48*r**2 + 6*r*(8*s - 5) - 14*s + 5)*np.sqrt(k1**2) + 6*k2**4*(r + s)*(4*r - 1))) + 5*f**2*k1*(D1*fd*(3*r - 1)*(k1**3*(20*C*(3*r + 3*s - 2) + 33*r + 33*s - 33) + 33*k2**2*(C*(6*r + 6*s - 4) + r + s - 1)*np.sqrt(k1**2)) + Dd*f*(k1**3*(10*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + (132*r - 33)*(r + s - 1)) + 33*k2**2*(4*r - 1)*(C*(6*r + 6*s - 4) + r + s - 1)*np.sqrt(k1**2))))/(693*d**2*k3**4*np.sqrt(k1**2)) - 8*D1**3*Pk2*Pkd1*ct*f*st**4*(D1*(33*b1*fd*r*(8*C*k2**3*r + 4*C*(2*s - 1)*(k2**2)**(3/2) + k1**2*k2*(2*r + 2*s - 1) + (2*r + 2*s - 1)*(k2**2)**(3/2)) + f*(33*bd1*r*(4*C*(k2**3*(r - 1) + s*(k2**2)**(3/2)) + k1**2*k2*(r + s - 1) + (r + s - 1)*(k2**2)**(3/2)) + 2*fd*(3*r - 1)*(10*C*(k2**3*(3*r - 1) + (3*s - 1)*(k2**2)**(3/2)) + 3*k1**2*k2*(3*r + 3*s - 2) + 3*(3*r + 3*s - 2)*(k2**2)**(3/2)))) + Dd*f*(66*b1*r*(C*k2**3*(8*r - 2) + 2*C*(4*s - 1)*(k2**2)**(3/2) + k1**2*k2*(2*r + 2*s - 1) + (2*r + 2*s - 1)*(k2**2)**(3/2)) + f*(10*C*(2*k2**3*(12*r**2 - 7*r + 1) + (24*r*s - 7*r - 7*s + 2)*(k2**2)**(3/2)) + 3*k1**2*k2*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 3*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)*(k2**2)**(3/2))))/(231*d**2*k3**4) - 4*D1**3*Pk2*Pkd1*ct*st**2*(33*D1*bd1*f*(b1*(26*C*k2**4*r*(2*r - 1)*np.sqrt(k2**2) + k1**2*(26*r**2 + r*(26*s - 23) - 3*s)*(k2**2)**(3/2) + k2**5*(-6*C*s + 26*r**2 + r*(52*C*s - 20*C + 26*s - 23) - 3*s)) + f*(k1**4*(k2*r*(2*s - 1) - k2*s + k2 + 2*r*(r - 1)*np.sqrt(k2**2)) + k1**2*(2*C*(19*r**2 + r*(19*s - 26) - 11*s + 7) + 6*r**2 + r*(6*s - 2) + 2*s - 1)*(k2**2)**(3/2) + k2**4*(2*C*r*(r + 4)*np.sqrt(k2**2) + k2*(2*C*(r*s + r + 6*s - 3) + 4*r**2 + 4*r*s + r + 3*s - 2)))) + 33*b1**2*(13*D1*fd*r*(2*C*k2**4*r*np.sqrt(k2**2) + k1**2*(r + s)*(k2**2)**(3/2) + k2**5*(2*C*s + r + s)) + Dd*f*(26*C*k2**4*r*(4*r - 1)*np.sqrt(k2**2) + k1**2*(52*r**2 + r*(52*s - 23) - 3*s)*(k2**2)**(3/2) + k2**5*(-6*C*s + 52*r**2 + r*(4*C*(26*s - 5) + 52*s - 23) - 3*s))) + 33*b1*f*(D1*fd*(2*C*k2**4*(2*r**2 - 11*r + 2)*np.sqrt(k2**2) + k1**4*k2*r*(4*s - 3) + k1**2*(4*k1**2*r**2 + k2**2*(r**2*(76*C + 12) + 2*r*(38*C*s - 22*C + 6*s - 5) - 5*s + 2))*np.sqrt(k2**2) + k2**5*(8*r**2 + r*(4*C*(s + 3) + 8*s - 7) - s*(10*C + 5) + 2)) + Dd*f*(k1**4*(k2*r*(8*s - 5) - k2*s + k2 + 2*r*(4*r - 1)*np.sqrt(k2**2)) + k1**2*(2*C*(76*r**2 + r*(76*s - 55) - 11*s + 7) + 24*r**2 + r*(24*s - 13) - 3*s + 1)*(k2**2)**(3/2) + 2*k2**4*(C*k2*(2*r*(2*s + 5) + s - 3) + C*(4*r**2 - 9*r + 2)*np.sqrt(k2**2) + 8*k2*r**2 + k2*r*(8*s - 3) - k2*s))) + f**2*(D1*fd*(k1**4*(k2*(6*r*(9*s - 14) + 15*s + 17) + 2*(27*r**2 + 15*r - 8)*np.sqrt(k2**2)) + k1**2*(6*C*(261*r**2 + r*(261*s - 184) + s + 3) - 243*r**2 - 243*r*(s - 1) + 114*s - 65)*(k2**2)**(3/2) - 33*k2**4*(3*r - 1)*(12*C*r*np.sqrt(k2**2) + k2*(6*C*(2*s - 1) + 3*r + 3*s - 2))) + Dd*f*(k1**4*(k2*(r*(72*s - 109) + 23*s + 17) + 2*(36*r**2 + 23*r - 8)*np.sqrt(k2**2)) + k1**2*(6*C*(348*r**2 + r*(348*s - 211) + 25*s + 3) - 324*r**2 + r*(300 - 324*s) + 122*s - 65)*(k2**2)**(3/2) - 33*k2**4*(4*r - 1)*(12*C*r*np.sqrt(k2**2) + k2*(6*C*(2*s - 1) + 3*r + 3*s - 2)))))/(693*d**2*k2*k3**4*np.sqrt(k2**2)) + 8*D1**3*Pk2*Pkd1*ct*(10*C*f**2*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))*(r + s - 1)*(k2**2)**(3/2) + D1*bd1*f*(b1*(k1**4*(k2*r*(4*s - 1) - k2*s + 2*r*(2*r - 1)*np.sqrt(k2**2)) + 2*k1**2*(r**2*(12*C + 9) + r*(3*C*(4*s - 3) + 9*s - 5) - s*(3*C + 4))*(k2**2)**(3/2) + 7*k2**4*(2*r - 1)*(2*C*r*np.sqrt(k2**2) + k2*(2*C*s + r + s))) + f*(k1**4*(k2*r*(4*s - 2) - k2*s + k2 + 2*r*(2*r - 1)*np.sqrt(k2**2)) + k1**2*(6*C*(6*r**2 + r*(6*s - 8) - 3*s + 3) + 10*r**2 + 2*r*(5*s - 2) - s + 1)*(k2**2)**(3/2) + 6*k2**4*r*(2*C*r*np.sqrt(k2**2) + k2*(2*C*s + r + s)))) + b1**2*(D1*fd*r*(14*C*k2**4*r*np.sqrt(k2**2) + 2*k1**4*k2*s + k1**2*(2*k1**2*r + k2**2*(12*C + 9)*(r + s))*np.sqrt(k2**2) + 7*k2**5*(2*C*s + r + s)) + Dd*f*(k1**4*(k2*r*(8*s - 1) - k2*s + 2*r*(4*r - 1)*np.sqrt(k2**2)) + 2*k1**2*(r**2*(24*C + 18) + r*(3*C*(8*s - 3) + 18*s - 5) - s*(3*C + 4))*(k2**2)**(3/2) + 7*k2**4*(4*r - 1)*(2*C*r*np.sqrt(k2**2) + k2*(2*C*s + r + s)))) + b1*f*(2*D1*fd*(k1**4*(2*r - 1)*(2*k2*s + 2*r*np.sqrt(k2**2) - np.sqrt(k2**2)) + k1**2*(6*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + (2*r - 1)*(5*r + 5*s - 1))*(k2**2)**(3/2) + 3*k2**4*(2*r - 1)*(2*C*r*np.sqrt(k2**2) + k2*(2*C*s + r + s))) + Dd*f*(k1**4*(2*k2*r*(8*s - 1) - 6*k2*s + k2 + 2*(8*r**2 - 6*r + 1)*np.sqrt(k2**2)) + k1**2*(6*C*(24*r**2 + 24*r*(s - 1) - 8*s + 5) + 40*r**2 + 20*r*(2*s - 1) - 12*s + 3)*(k2**2)**(3/2) + 6*k2**4*(4*r - 1)*(2*C*r*np.sqrt(k2**2) + k2*(2*C*s + r + s)))))/(21*d**2*k2*k3**4*np.sqrt(k2**2)) + D1**3*Pk2*Pkdd1*ct**6*f*k2**2*(8*C - 8)*(D1*(132*b1*fd*r**2 + 66*bd1*f*r*(r - 1) + 25*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(66*b1*r + 25*f*(3*r - 1)))/(693*d**2*k3**2) - 20*D1**3*Pk2*Pkdd1*ct**5*f**2*k2*(D1*(585*b1*fd*r**2 + 195*bd1*f*r*(r - 1) + 49*f*fd*(1 - 4*r)**2) + Dd*f*(4*r - 1)*(195*b1*r + 49*f*(4*r - 1)))/(9009*d**2*k1) - 4*D1**3*Pk2*Pkdd1*ct**5*f*(D1*(132*b1*fd*r**2 + 66*bd1*f*r*(r - 1) + 25*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(66*b1*r + 25*f*(3*r - 1)))*(k1**2*k2*(5 - 4*C) + (k2**2)**(3/2))/(693*d**2*k1*k3**2) - D1**3*Pk2*Pkdd1*ct**4*f*k2**2*st**2*(8*C - 8)*(D1*(66*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + f*fd*(27*r**2 + 15*r - 8)) + Dd*f*(4*r - 1)*(33*b1*r + f*(9*r + 8)))/(231*d**2*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**4*(429*b1**2*r*(D1*fd*r*(-K + 4*f + 1) + Dd*f*(4*r - 1)*(-K + 2*f + 1)) + 13*b1*(D1*(f**2*(66*bd1*r*(2*r - 1) + 25*fd*(27*r**2 - 6*r + 1)) - 33*f*(fd*(1 - 2*r)**2*(K - 1) + r*(bd1*(K - 1)*(2*r - 1) - 2*gd2*r)) + 66*fd*g2*r**2) + Dd*f*(4*r - 1)*(25*f**2*(9*r - 1) - 33*f*(K - 1)*(2*r - 1) + 66*g2*r)) + f*(D1*(5*f**2*(65*bd1*r*(9*r - 7) + 98*fd*(1 - 4*r)**2) + 429*f*r*(2*r - 1)*(-K*bd1 + bd1 + 2*gd2) + 858*g2*(bd1*r*(r - 1) + fd*(1 - 2*r)**2)) + 2*Dd*f*(4*r - 1)*(245*f**2*(4*r - 1) + 429*g2*(2*r - 1))))/(9009*d**2) + 8*D1**3*Pk2*Pkdd1*ct**4*(D1*(33*b1**2*fd*k2**2*r**2*(C - 1) - 33*b1*f*(bd1*k2**2*r*(-2*C*r + C + 2*r - 1) + fd*k1**2*r**2*(8 - 4*C) + fd*k2**2*(C*(4*r - 1) + 8*r**2 - 4*r + 1)) + f**2*(33*bd1*r*(k1**2*(2*C - 4)*(r - 1) + k2**2*(C - 4*r + 3)) + 25*fd*(1 - 3*r)**2*(k1**2*(C - 2) - k2**2*(C + 1)))) + Dd*f*(4*r - 1)*(33*b1**2*k2**2*r*(C - 1) - 33*b1*f*(k1**2*r*(4 - 2*C) + k2**2*(C + 4*r - 1)) + 25*f**2*(3*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1))))/(693*d**2*k3**2) + 20*D1**3*Pk2*Pkdd1*ct**3*f**2*k2*st**2*(D1*(351*b1*fd*r**2 + 117*bd1*f*r*(r - 1) + 5*f*fd*(4*r**2 + 63*r - 16)) + Dd*f*(4*r - 1)*(117*b1*r + 5*f*(r + 16)))/(9009*d**2*k1) + 4*D1**3*Pk2*Pkdd1*ct**3*f*st**2*(D1*(66*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + f*fd*(27*r**2 + 15*r - 8)) + Dd*f*(4*r - 1)*(33*b1*r + f*(9*r + 8)))*(k1**2*k2*(3 - 2*C) + (k2**2)**(3/2))/(231*d**2*k1*k3**2) - 4*D1**3*Pk2*Pkdd1*ct**3*(D1*f**2*(650*bd1*f*r*(k1**2*(3*r - 2) + k2**2*(3*r - 1)) + 429*bd1*r*(k1**2 + k2**2)*(2*r - 1) + 245*f*fd*k1**2*(1 - 4*r)**2) + 245*Dd*f**4*k1**2*(1 - 4*r)**2 + 429*b1**2*r*(D1*fd*r*(k1**2*(4*f + 1) + k2**2*(8*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(2*f + 1) + k2**2*(4*f + 1))) + 13*b1*f*(D1*(33*bd1*r*(2*r - 1)*(k1**2*(2*f + 1) + k2**2*(4*f + 1)) + fd*(k1**2*(25*f*(18*r**2 - 6*r + 1) + 33*(1 - 2*r)**2) + k2**2*(50*f*(1 - 3*r)**2 + 33*(1 - 2*r)**2))) + Dd*f*(4*r - 1)*(k1**2*(25*f*(6*r - 1) + 66*r - 33) + k2**2*(50*f*(3*r - 1) + 66*r - 33))))/(9009*d**2*k1*k2) - 4*D1**3*Pk2*Pkdd1*ct**3*(D1*(33*b1**2*fd*k2**2*r**2*(k1**2*(5 - 4*C) + k2*np.sqrt(k2**2)) + 33*b1*f*(bd1*k2**2*r*(2*r - 1)*(k1**2*(5 - 4*C) + k2*np.sqrt(k2**2)) + fd*(4*k1**4*r**2 + k1**2*k2**2*(4*C*(4*r - 1) + 24*r**2 - 20*r + 5) + k2**3*(1 - 2*r)**2*np.sqrt(k2**2))) + f**2*(33*bd1*r*(2*k1**4*(r - 1) + k1**2*k2**2*(-4*C + 12*r - 7) + k2**3*(2*r - 1)*np.sqrt(k2**2)) + 25*fd*k1**2*(1 - 3*r)**2*(k1**2 + k2**2*(4*C + 1)))) + Dd*f*(4*r - 1)*(33*b1**2*k2**2*r*(k1**2*(5 - 4*C) + k2*np.sqrt(k2**2)) + 33*b1*f*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**3*(2*r - 1)*np.sqrt(k2**2)) + 25*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(3*r - 1)))/(693*d**2*k1*k2*k3**2) - D1**3*Pk2*Pkdd1*ct**2*f**2*k2**2*st**4*(8*C - 8)*(3*r - 1)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k3**2) + 2*D1**3*Pk2*Pkdd1*ct**2*st**2*(143*b1**2*r*(D1*fd*r*(-K + 12*f + 1) + Dd*f*(4*r - 1)*(-K + 6*f + 1)) + 13*b1*(D1*(2*f**2*(33*bd1*r*(2*r - 1) + fd*(81*r**2 + 15*r - 8)) - 11*f*r*(bd1*(K - 1)*(2*r - 1) + fd*(K - 1)*(2*r - 1) - 2*gd2*r) + 22*fd*g2*r**2) + Dd*f*(4*r - 1)*(2*f**2*(27*r + 8) - 11*f*r*(K - 1) + 22*g2*r)) + f*(D1*(2*f**2*(13*bd1*r*(27*r - 10) + 10*fd*(4*r**2 + 63*r - 16)) + 143*f*r**2*(-K*bd1 + bd1 + 2*gd2) + 286*g2*r*(bd1*(r - 1) + fd*(2*r - 1))) + 2*Dd*f*(4*r - 1)*(10*f**2*(r + 16) + 143*g2*r)))/(3003*d**2) - 4*D1**3*Pk2*Pkdd1*ct**2*(11*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(D1*(bd1*f*r*(3*r - 1) + fd*(2*K*r - K + 16*f*r**2 - 4*f*r + f + 2*r**2 - 2*r + 1)) + Dd*f*(4*r - 1)*(K + f*(8*r - 1) + 2*r - 1)) + b1*(D1*(f**2*(88*bd1*r*(2*r - 1) + 25*fd*(1 - 3*r)**2) + 11*f*(fd*(1 - 2*r)**2*(K + 1) + r*(bd1*(K + 4*r - 3) + bd2*r - 2*gd2)) + 11*fd*(b2*r**2 + g2*(2 - 4*r))) + Dd*f*(4*r - 1)*(11*b2*r + 25*f**2*(3*r - 1) + 11*f*(K + 1)*(2*r - 1) - 22*g2)) + f*(D1*f*r*(25*bd1*f*(3*r - 1) + 11*bd1*(K + 1)*(2*r - 1) + (11*bd2 - 22*gd2)*(2*r - 1)) - 22*D1*fd*g2*(1 - 2*r)**2 - 22*Dd*f*g2*(8*r**2 - 6*r + 1) + 11*b2*(D1*bd1*r*(r - 1) + D1*fd*(1 - 2*r)**2 + Dd*f*(8*r**2 - 6*r + 1))))/(231*d**2) - 4*D1**3*Pk2*Pkdd1*ct**2*st**2*(D1*(33*b1**2*fd*k2**2*r**2*(C - 1) + 33*b1*f*r*(bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*r*(2*C - 8) - fd*k2**2*(10*C*r + C + 8*r - 1)) + f**2*(33*bd1*r*(k1**2*(C - 4)*(r - 1) + k2**2*(C*(6 - 5*r) - 4*r + 3)) + fd*(k1**2*(C - 4) - k2**2*(6*C + 3))*(27*r**2 + 15*r - 8))) + Dd*f*(4*r - 1)*(33*b1**2*k2**2*r*(C - 1) + 33*b1*f*r*(k1**2*(C - 4) - k2**2*(5*C + 4)) + f**2*(9*r + 8)*(k1**2*(C - 4) - k2**2*(6*C + 3))))/(693*d**2*k3**2) + 8*D1**3*Pk2*Pkdd1*ct**2*(33*b1**2*r*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) - 33*b1*f*(D1*(-bd1*r*(2*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)) + fd*(k1**2*(C*(4*r - 1) + 2*(1 - 2*r)**2) + k2**2*(1 - 2*r)**2*(C + 1))) + Dd*f*(4*r - 1)*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1))) + f**2*(C*(33*D1*bd1*r*(k1**2 + k2**2*(1 - 2*r)) - 25*D1*fd*k1**2*(1 - 3*r)**2 - 25*Dd*f*k1**2*(12*r**2 - 7*r + 1)) - 33*D1*bd1*r*(2*k1**2 + k2**2)*(2*r - 1)))/(693*d**2*k3**2) + 20*D1**3*Pk2*Pkdd1*ct*f**2*k2*st**4*(D1*(117*b1*fd*r**2 + 39*bd1*f*r*(r - 1) + f*fd*(56*r**2 - 2*r - 3)) + Dd*f*(4*r - 1)*(39*b1*r + f*(14*r + 3)))/(3003*d**2*k1) + 4*D1**3*Pk2*Pkdd1*ct*f**2*st**4*(3*r - 1)*(k1**2*k2 + (k2**2)**(3/2))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k1*k3**2) - 4*D1**3*Pk2*Pkdd1*ct*k1*(k1**2 + k2**2*(4*C + 1))*(D1*bd1*f**2*r*(2*r - 1) + b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(D1*bd1*r + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2*k2*k3**2) + 2*D1**3*Pk2*Pkdd1*ct*st**2*(D1*f**2*(13*bd1*f*r*(k1**2*(18*r - 1) + 2*k2**2*(9*r + 8)) + 143*bd1*r**2*(k1**2 + k2**2) + 5*f*fd*k1**2*(4*r**2 + 63*r - 16)) + 5*Dd*f**4*k1**2*(4*r**2 + 63*r - 16) + 143*b1**2*r*(D1*fd*r*(k1**2*(6*f + 1) + k2**2*(12*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(3*f + 1) + k2**2*(6*f + 1))) + 13*b1*f*(D1*(f*(33*bd1*r*(k1**2 + 2*k2**2)*(2*r - 1) + fd*k1**2*(54*r**2 + 15*r - 8) + 2*fd*k2**2*(27*r**2 + 15*r - 8)) + r*(11*bd1 + 11*fd)*(k1**2 + k2**2)*(2*r - 1)) + Dd*f*(4*r - 1)*(2*f*(k1**2*(9*r + 4) + k2**2*(9*r + 8)) + r*(11*k1**2 + 11*k2**2))))/(3003*d**2*k1*k2) - 4*D1**3*Pk2*Pkdd1*ct*(25*D1*bd1*f**3*k1**2*r*(3*r - 1) + 33*b1**3*r*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 33*b1**2*(D1*(bd1*f*r*(k1**2 + k2**2)*(3*r - 1) + fd*k1**2*(f*(8*r**2 - 4*r + 1) + (r - 1)**2) + fd*k2**2*(f*(1 - 2*r)**2 + (r - 1)**2)) + Dd*f*(4*r - 1)*(k1**2*(f*(4*r - 1) + r - 1) + k2**2*(f*(2*r - 1) + r - 1))) + b1*(D1*f*(66*bd1*f*r*(2*k1**2 + k2**2)*(2*r - 1) + 66*bd1*r*(k1**2 + k2**2)*(r - 1) + 25*f*fd*k1**2*(1 - 3*r)**2) + 25*Dd*f**3*k1**2*(12*r**2 - 7*r + 1)))/(693*d**2*k1*k2) + 2*D1**3*Pk2*Pkdd1*ct*st**2*(D1*(33*b1**2*fd*k2**2*r**2*(k1**2 + k2*np.sqrt(k2**2)) + 33*b1*f*r*(bd1*k2**2*(k1**2 + k2*np.sqrt(k2**2))*(2*r - 1) + fd*(2*k1**4*r + k1**2*k2**2*(24*C*r + 4*r - 1) + k2**3*(2*r - 1)*np.sqrt(k2**2))) + f**2*(33*bd1*r*(k1**4*(r - 1) + k1**2*k2**2*(12*C*(r - 1) + 2*r - 1) + k2**3*r*np.sqrt(k2**2)) + fd*k1**2*(k1**2 + k2**2*(12*C + 1))*(27*r**2 + 15*r - 8))) + Dd*f*(4*r - 1)*(33*b1**2*k2**2*r*(k1**2 + k2*np.sqrt(k2**2)) + 33*b1*f*r*(k1**4 + k1**2*k2**2*(12*C + 2) + k2**3*np.sqrt(k2**2)) + f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(9*r + 8)))/(693*d**2*k1*k2*k3**2) + 4*D1**3*Pk2*Pkdd1*f**2*st**4*(13*b1*(D1*fd*(27*r**2 - 6*r + 1) + Dd*f*(36*r**2 - 13*r + 1)) + f*(13*D1*bd1*r*(9*r - 7) + 2*D1*fd*(56*r**2 - 2*r - 3) + 2*Dd*f*(56*r**2 - 2*r - 3)))/(3003*d**2) + 2*D1**3*Pk2*Pkdd1*st**2*(11*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*r*(D1*bd1*f*(3*r - 1) + D1*fd*(K*r + 8*f*r - f + r) + Dd*f*(4*r - 1)*(K + 4*f + 1)) + b1*(D1*(f**2*(11*bd1*r*(8*r - 3) + fd*(27*r**2 + 15*r - 8)) + 11*f*r*(bd1*(K + 1)*(2*r - 1) + fd*(K + 1)*(2*r - 1) + r*(bd2 - 2*gd2)) + 11*fd*r**2*(b2 - 2*g2)) + Dd*f*(4*r - 1)*(f**2*(9*r + 8) + 11*f*r*(K + 1) + r*(11*b2 - 22*g2))) + f*r*(D1*bd1*(f**2*(9*r + 8) + 11*f*r*(K + 1) - 22*g2*(r - 1)) + 11*D1*f*r*(bd2 - 2*gd2) + 11*D1*fd*g2*(2 - 4*r) + 22*Dd*f*g2*(1 - 4*r) + 11*b2*(D1*bd1*(r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1))))/(231*d**2) - 4*D1**3*Pk2*Pkdd1*(D1*bd1*f*r*(b2 - 2*g2)*(r - 1) + b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(bd1*f*r*(3*r - 1) + f*fd*(1 - 2*r)**2 + fd*(K + 1)*(r - 1)**2) + Dd*f*(4*r - 1)*(f*(2*r - 1) + (K + 1)*(r - 1))) + b1*(D1*f*r*(2*bd1*(f*(2*r - 1) + (K + 1)*(r - 1)) + (bd2 - 2*gd2)*(r - 1)) - 2*D1*fd*g2*(r - 1)**2 - 2*Dd*f*g2*(4*r**2 - 5*r + 1) + b2*(r - 1)*(D1*fd*(r - 1) + Dd*f*(4*r - 1))))/(21*d**2) + D1**3*Pkd1*ct**7*f*k2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(33*D1*bd1*f*(r*(8*s - 5) - 10*s + 5) + 33*b1*(8*D1*fd*r*(2*s - 1) + Dd*f*(32*r*s - 18*r - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(36*s - 23) + Dd*f*(144*r*s - 97*r - 31*s + 23)))/(693*d**2*k3**2) - 10*D1**3*Pkd1*ct**6*f**2*(4*Pk2 - Pkd2*k2)*(13*D1*bd1*f*(7*r*(15*s - 8) - 135*s + 56) + 13*b1*(3*D1*fd*r*(105*s - 46) + Dd*f*(420*r*s - 194*r - 135*s + 56)) + 28*f*(4*r - 1)*(37*s - 19)*(D1*fd + Dd*f))/(9009*d**2*np.sqrt(k1**2)) + 4*D1**3*Pkd1*ct**6*f*(33*D1*bd1*f*(-52*C*Pk2*k2**2*r**2 + 52*C*Pk2*k2**2*r + 52*Pk2*k2**2*r**2 - 16*Pk2*k2**2*r*s - 42*Pk2*k2**2*r + 20*Pk2*k2**2*s - 10*Pk2*k2**2 + 20*Pkd2*k2**3*r*s - 5*Pkd2*k2**3*r - 10*Pkd2*k2**3*s + 5*Pkd2*k2**3 - 12*Pkd2*r*s*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(4*C*(5*r*(s - 1) - 7*s + 5) + r*(25 - 28*s) + 38*s - 25)*np.sqrt(k1**2)) + 33*b1*(4*D1*fd*r*(2*Pk2*k2**2*(-r*(13*C - 13) - 4*s + 2) + 5*Pkd2*k2**3*(2*s - 1) + 3*Pkd2*(1 - 2*s)*(k2**2)**(3/2) + 2*k1*(4*Pk2 - Pkd2*k2)*(C*(5*s - 4) - 7*s + 5)*np.sqrt(k1**2)) + Dd*f*(-2*Pk2*k2**2*(r**2*(104*C - 104) + r*(-26*C + 32*s + 8) - 10*s + 5) + 5*Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 12*Pkd2*r*(1 - 4*s)*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(4*C*(2*r*(10*s - 9) - 7*s + 5) + r*(90 - 112*s) + 38*s - 25)*np.sqrt(k1**2))) + f*(D1*fd*(-3240*C*Pk2*k2**2*r**2 - 348*C*Pk2*k2**2*r + 476*C*Pk2*k2**2 + 3240*Pk2*k2**2*r**2 - 1080*Pk2*k2**2*r*s + 1038*Pk2*k2**2*r + 360*Pk2*k2**2*s - 706*Pk2*k2**2 + 1530*Pkd2*k2**3*r*s - 675*Pkd2*k2**3*r - 180*Pkd2*k2**3*s + 115*Pkd2*k2**3 - 990*Pkd2*r*s*(k2**2)**(3/2) + 330*Pkd2*r*(k2**2)**(3/2) + 5*k1*(4*Pk2 - Pkd2*k2)*(3*r - 1)*(C*(78*s - 92) - 114*s + 115)*np.sqrt(k1**2)) + Dd*f*(-2*Pk2*k2**2*(C*(2160*r**2 + 412*r - 238) - 2160*r**2 + r*(720*s - 897) - 155*s + 353) + 5*Pkd2*k2**3*(r*(408*s - 163) - 31*s + 23) + 330*Pkd2*r*(1 - 4*s)*(k2**2)**(3/2) + 5*k1*(4*Pk2 - Pkd2*k2)*(C*(4*r*(78*s - 97) - 58*s + 92) + r*(485 - 456*s) + 89*s - 115)*np.sqrt(k1**2))))/(693*d**2*k3**2*np.sqrt(k1**2)) + D1**3*Pkd1*ct**5*f*k2*st**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(33*D1*bd1*f*(r*(14*s - 5) - 10*s + 5) + 33*b1*(14*D1*fd*r*(2*s - 1) + Dd*f*(8*r*(7*s - 3) - 10*s + 5)) + f*(D1*fd*(9*r*(96*s - 43) - 156*s + 85) + Dd*f*(128*r*(9*s - 4) - 116*s + 85)))/(693*d**2*k3**2) + 2*D1**3*Pkd1*ct**5*(858*b1**2*k1**2*(D1*fd*r*(8*Pk2*(-5*K*s + 5*K + f*(2*s - 1) + 5*s - 5)*np.sqrt(k2**2) + k2*(-20*Pk2*(-3*K*s + 3*K + f*(4*s - 2) + 3*s - 3) + Pkd2*(-5*K*s + 5*K + 8*f*(2*s - 1) + 5*s - 5)*np.sqrt(k2**2))) + Dd*f*(Pk2*(f*(2*r*(16*s - 9) - 10*s + 5) - (2*K - 2)*(r*(80*s - 29) - 3*s + 3))*np.sqrt(k2**2) + k2*(-5*Pk2*(f*(2*r*(16*s - 9) - 10*s + 5) + (6 - 6*K)*(r*(8*s - 5) - s + 1)) + Pkd2*(f*(2*r*(16*s - 9) - 10*s + 5) - (K - 1)*(r*(20*s - 23) - 6*s + 6))*np.sqrt(k2**2)))) + 13*b1*(66*D1*bd1*f*k1**2*(Pk2*(f*(2*r*(8*s - 5) - 10*s + 5) - (2*K - 2)*(r*(40*s - 6) - 3*s + 3))*np.sqrt(k2**2) + k2*(-5*Pk2*(f*(2*r*(8*s - 5) - 10*s + 5) + (6 - 6*K)*(r*(4*s - 2) - s + 1)) + Pkd2*(f*(2*r*(8*s - 5) - 10*s + 5) + (2 - 2*K)*(r*(5*s - 6) - 3*s + 3))*np.sqrt(k2**2))) + D1*(5*f**2*fd*(153*Pk2*r**2*(k2**2)**(3/2) + 2*k1**2*(9*r - 1)*(36*s - 23)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) - 132*f*k1**2*(fd*(K - 1)*(Pk2*(r*(32*s - 19) - s + 2)*np.sqrt(k2**2) + k2*(-5*Pk2*(8*r*s - 7*r - s + 2) + Pkd2*(2*r - 1)*(s - 2)*np.sqrt(k2**2))) + gd2*r*(30*Pk2*k2*(2*s - 1) + 2*Pk2*(3 - 20*s)*np.sqrt(k2**2) + Pkd2*k2*(6 - 5*s)*np.sqrt(k2**2))) + 660*fd*g2*k1**2*r*(s - 1)*(-12*Pk2*k2 + 8*Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + Dd*f*(5*f**2*(51*Pk2*r*(4*r - 1)*(k2**2)**(3/2) + 2*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(3*r*(144*s - 97) - 133*s + 79)) - 132*f*k1**2*(K - 1)*(2*Pk2*(4*r*(8*s - 3) + 1)*np.sqrt(k2**2) + k2*(-10*Pk2*(8*r*s - 6*r + 1) + Pkd2*(4*r*s - 9*r + 2)*np.sqrt(k2**2))) + 132*g2*k1**2*(2*Pk2*(r*(80*s - 29) - 3*s + 3)*np.sqrt(k2**2) + k2*(-30*Pk2*(8*r*s - 5*r - s + 1) + Pkd2*(20*r*s - 23*r - 6*s + 6)*np.sqrt(k2**2))))) + f*(13*D1*bd1*(5*f**2*(51*Pk2*r*(r - 1)*(k2**2)**(3/2) + 2*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(12*r*(9*s - 7) - 97*s + 56)) - 66*f*k1**2*(K - 1)*(Pk2*(r*(32*s - 5) + s)*np.sqrt(k2**2) + k2*(-5*Pk2*(8*r*s - 5*r + s) + Pkd2*(2*r*s - 5*r + s)*np.sqrt(k2**2))) + 132*g2*k1**2*(2*Pk2*(r*(20*s - 3) - 3*s + 3)*np.sqrt(k2**2) + k2*(-30*Pk2*(2*r*s - r - s + 1) + Pkd2*(5*r*s - 6*r - 6*s + 6)*np.sqrt(k2**2)))) - 5*D1*f**2*fd*(4*r - 1)*(3*Pk2*(7*r - 278)*(k2**2)**(3/2) - 56*k1**2*(24*s - 19)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + 1716*D1*f*gd2*k1**2*(Pk2*(r*(32*s - 5) + s)*np.sqrt(k2**2) + k2*(-5*Pk2*(8*r*s - 5*r + s) + Pkd2*(2*r*s - 5*r + s)*np.sqrt(k2**2))) + 3432*D1*fd*g2*k1**2*(Pk2*(r*(32*s - 19) - s + 2)*np.sqrt(k2**2) + k2*(-5*Pk2*(8*r*s - 7*r - s + 2) + Pkd2*(2*r - 1)*(s - 2)*np.sqrt(k2**2))) - 5*Dd*f**3*(4*r - 1)*(3*Pk2*(7*r - 278)*(k2**2)**(3/2) - 56*k1**2*(24*s - 19)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + 3432*Dd*f*g2*k1**2*(2*Pk2*(4*r*(8*s - 3) + 1)*np.sqrt(k2**2) + k2*(-10*Pk2*(8*r*s - 6*r + 1) + Pkd2*(4*r*s - 9*r + 2)*np.sqrt(k2**2)))))/(9009*d**2*k1**2*k2*np.sqrt(k2**2)) + 4*D1**3*Pkd1*ct**5*(66*D1*bd1*f*(b1*k1**2*(C - 1)*(2*Pk2 - Pkd2*k2)*(10*r*s + r - 6*s)*(k2**2)**(3/2) + f*(9*Pk2*k2**5*r*(r - 1) + k1**4*(Pk2*(C*(r*(5 - 32*s) + 4*s - 5) + r*(37*s - 10) - 11*s + 10)*np.sqrt(k2**2) + k2*(5*Pk2*(C*(8*r*s - 5*r - 4*s + 5) - 13*r*s + 10*r + 11*s - 10) + Pkd2*(C*(-2*r*s + 5*r + 4*s - 5) + 7*r*s - 10*r - 11*s + 10)*np.sqrt(k2**2))) + k1**2*(-Pk2*(C*(25*r**2 + 22*r*s - 49*r - 42*s + 22) - 30*r**2 + 4*r*s + 34*r + 8*s - 2) + Pkd2*k2*(C*(18*r*s - 13*r - 23*s + 12) - 5*r*s + 3*r + 6*s - 2))*(k2**2)**(3/2))) - 66*b1**2*k1**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(5*D1*fd*r*s + Dd*f*(20*r*s + r - 6*s))*(k2**2)**(3/2) + 66*b1*f*(2*D1*fd*(9*Pk2*k2**5*r**2 + k1**4*r*(Pk2*(C*(19 - 32*s) + 37*s - 23)*np.sqrt(k2**2) + k2*(5*Pk2*(8*C*s - 7*C - 13*s + 11) + Pkd2*(-2*C*s + 4*C + 7*s - 8)*np.sqrt(k2**2))) + k1**2*(Pk2*(r**2*(30 - 25*C) + r*(-22*C*s + 13*C - 4*s + 3) - s*(2*C - 2)) + Pkd2*k2*(r*(2*C*(9*s - 5) - 5*s + 2) + s*(C - 1)))*(k2**2)**(3/2)) + Dd*f*(9*Pk2*k2**5*r*(4*r - 1) + k1**4*(Pk2*(C*(-16*r*(8*s - 3) + 4*s - 5) + 2*r*(74*s - 33) - 11*s + 10)*np.sqrt(k2**2) + k2*(5*Pk2*(C*(8*r*(4*s - 3) - 4*s + 5) + r*(42 - 52*s) + 11*s - 10) + Pkd2*(C*(r*(18 - 8*s) + 4*s - 5) + 4*r*(7*s - 9) - 11*s + 10)*np.sqrt(k2**2))) + k1**2*(-Pk2*(C*(100*r**2 + r*(88*s - 95) - 40*s + 22) - 120*r**2 + 4*r*(4*s + 7) + 6*s - 2) + Pkd2*k2*(2*C*(r*(36*s - 22) - 11*s + 6) - (4*r - 1)*(5*s - 2)))*(k2**2)**(3/2))) + f**2*(D1*fd*(4*Pk2*k2**5*(270*r**2 + 51*r - 47) - 5*k1**4*(Pk2*(2*C*(18*r*(28*s - 13) - 3*s + 23) + r*(606 - 1125*s) + 45*s - 92)*np.sqrt(k2**2) + k2*(-5*Pk2*(C*(12*r*(18*s - 17) - 6*s + 46) - 9*r*(37*s - 38) + 45*s - 92) + Pkd2*(3*r - 1)*(C*(6*s - 46) - 45*s + 92)*np.sqrt(k2**2))) + k1**2*(-2*Pk2*(C*(765*r**2 + 1170*r*s + 321*r - 324*s - 214) - 855*r**2 + 495*r*s - 2103*r - 231*s + 818) + 5*Pkd2*k2*(3*r - 1)*(4*C*(51*s - 28) - 93*s + 20))*(k2**2)**(3/2)) + Dd*f*(4*Pk2*k2**5*(360*r**2 + 98*r - 47) - 5*k1**4*(Pk2*(2*C*(672*r*s - 262*r + 2*s + 23) - 1500*r*s + 718*r + 25*s - 92)*np.sqrt(k2**2) + k2*(-5*Pk2*(C*(4*r*(72*s - 65) + 4*s + 46) - 444*r*s + 454*r + 25*s - 92) + Pkd2*(2*C*(12*r*s - 97*r + 2*s + 23) - 180*r*s + 388*r + 25*s - 92)*np.sqrt(k2**2))) + k1**2*(-2*Pk2*(C*(1020*r**2 + 1560*r*s + 303*r - 92*s - 214) - 1140*r**2 + 660*r*s - 2789*r - 363*s + 818) + 5*Pkd2*k2*(2*C*(408*r*s - 229*r - 97*s + 56) - 372*r*s + 70*r + 103*s - 20))*(k2**2)**(3/2))))/(693*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 5*D1**3*Pkd1*ct**4*f**2*st**2*(4*Pk2 - Pkd2*k2)*(39*D1*bd1*f*(5*r*(27*s - 10) - 128*s + 50) + 39*b1*(D1*fd*r*(405*s - 157) + Dd*f*(9*r*(60*s - 23) - 128*s + 50)) + 5*f*(D1*fd + Dd*f)*(r*(2908*s - 1117) - 402*s + 198))/(9009*d**2*np.sqrt(k1**2)) + 4*D1**3*Pkd1*ct**4*f*st**2*(33*D1*bd1*f*(-26*C*Pk2*k2**2*r**2 + 26*C*Pk2*k2**2*r + 26*Pk2*k2**2*r**2 - 28*Pk2*k2**2*r*s - 16*Pk2*k2**2*r + 20*Pk2*k2**2*s - 10*Pk2*k2**2 + 20*Pkd2*k2**3*r*s - 5*Pkd2*k2**3*r - 10*Pkd2*k2**3*s + 5*Pkd2*k2**3 - 6*Pkd2*r*s*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(3*C*(2*r*(5*s - 2) - 7*s + 4) + r*(17 - 44*s) + 31*s - 17)*np.sqrt(k1**2)) + 33*b1*(D1*fd*r*(4*Pk2*k2**2*(-r*(13*C - 13) - 14*s + 7) + 20*Pkd2*k2**3*(2*s - 1) + 6*Pkd2*(1 - 2*s)*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(C*(60*s - 33) - 88*s + 47)*np.sqrt(k1**2)) + Dd*f*(-2*Pk2*k2**2*(r**2*(52*C - 52) + r*(-13*C + 56*s - 11) - 10*s + 5) + 5*Pkd2*k2**3*(2*r*(8*s - 3) - 2*s + 1) + 6*Pkd2*r*(1 - 4*s)*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(3*C*(r*(40*s - 19) - 7*s + 4) + r*(81 - 176*s) + 31*s - 17)*np.sqrt(k1**2))) + f*(D1*fd*(-2*Pk2*k2**2*(C*(999*r**2 - 303*r - 10) - 999*r**2 + 12*r*(72*s - 7) - 156*s + 95) + Pkd2*k2**3*(9*r*(162*s - 65) - 156*s + 85) + 198*Pkd2*r*(1 - 3*s)*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(3*C*(r*(612*s - 303) - 105*s + 68) - 108*r*(25*s - 12) + 471*s - 289)*np.sqrt(k1**2)) + Dd*f*(2*Pk2*k2**2*(C*(-1332*r**2 + 293*r + 10) + 1332*r**2 - 3*r*(384*s - 73) + 116*s - 95) + Pkd2*k2**3*(2*r*(972*s - 355) - 116*s + 85) + 198*Pkd2*r*(1 - 4*s)*(k2**2)**(3/2) + k1*(4*Pk2 - Pkd2*k2)*(3*C*(r*(816*s - 403) - 73*s + 68) + r*(1721 - 3600*s) + 335*s - 289)*np.sqrt(k1**2))))/(693*d**2*k3**2*np.sqrt(k1**2)) + 2*D1**3*Pkd1*ct**4*(858*b1**2*(D1*fd*r*(k1*(-4*Pk2*(10*f*s - 8*f + 5*s - 5)*np.sqrt(k2**2) + Pkd2*k2*(k2*(28*f*s - 17*f - 7*s + 7) + 3*(-6*f*s + 3*f + 4*s - 4)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (4*Pk2*f*(r - 10*s + 4) - 5*Pk2*(r*(3*K - 3) + 2*s - 2) + Pkd2*k2*(20*f*s - 8*f + 5*s - 5))*(k2**2)**(3/2)) + Dd*f*(k1*(-4*Pk2*(f*(2*r*(10*s - 9) - 7*s + 5) + r*(20*s - 23) - 6*s + 6)*np.sqrt(k2**2) + Pkd2*k2*(f*k2*(r*(56*s - 27) - 7*s + 5) + 9*f*r*(1 - 4*s)*np.sqrt(k2**2) + 7*k2*r*(1 - 4*s) + 6*(r*(8*s - 5) - s + 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(2*f*(4*r**2 - 5*r*(8*s - 3) + 14*s - 5) + r**2*(60 - 60*K) + r*(15*K - 40*s + 31) + 12*s - 12) + Pkd2*k2*(f*(8*r*(5*s - 2) - 14*s + 5) + r*(20*s - 23) - 6*s + 6))*(k2**2)**(3/2))) + 13*b1*(66*D1*bd1*f*(-k1*(4*Pk2*(f*(10*r*(s - 1) - 7*s + 5) + 2*r*(5*s - 6) - 6*s + 6)*np.sqrt(k2**2) + Pkd2*k2*(f*k2*(r*(10 - 28*s) + 7*s - 5) + 18*f*r*s*np.sqrt(k2**2) + 14*k2*r*s + 12*r*(1 - 2*s)*np.sqrt(k2**2) + 6*(s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(2*f*(2*r**2 + r*(7 - 20*s) + 14*s - 5) + r**2*(30 - 30*K) + r*(15*K - 20*s + 9) + 12*s - 12) + Pkd2*k2*(f*(4*r*(5*s - 2) - 14*s + 5) + 2*r*(5*s - 6) - 6*s + 6))*(k2**2)**(3/2)) + D1*(1980*Pk2*fd*g2*r**2*(k2**2)**(3/2) + f**2*fd*(-5*k1*(4*Pk2*(6*r - 1)*(39*s - 46)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-828*r*s + 474*r + 39*s - 46) + 198*r*(3*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-3*Pk2*(720*r**2 - r*(45*s + 631) - 260*s + 312) - 5*Pkd2*k2*(3*r*(87*s - 20) + 78*s - 46))*(k2**2)**(3/2)) + 66*f*(30*Pk2*gd2*r**2*(k2**2)**(3/2) + 2*fd*k1*(4*Pk2*(-2*r*(s - 2) + s - 2)*np.sqrt(k2**2) + Pkd2*k2*(k2*r*(3 - 6*s) + (r*(8*s - 7) - s + 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) + fd*(2*r - 1)*(Pk2*(-K*(7*r + 8) + 7*r - 4*s + 16) + 2*Pkd2*k2*(s - 2))*(k2**2)**(3/2))) + Dd*f*(1980*Pk2*g2*r*(4*r - 1)*(k2**2)**(3/2) + f**2*(-10*k1*(4*Pk2*(2*r*(78*s - 97) - 49*s + 51)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-552*r*s + 293*r + 49*s - 51) + 99*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(-2880*r**2 + r*(180*s + 2449) - 1070*s - 176) + 5*Pkd2*k2*(-4*r*(87*s - 25) + 107*s - 30))*(k2**2)**(3/2)) + 66*f*(2*k1*(-4*Pk2*(r*(4*s - 9) + 2)*np.sqrt(k2**2) + Pkd2*k2*(3*k2*r*(1 - 4*s) + 2*(8*r*s - 6*r + 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(K*(-28*r**2 - 25*r + 8) + 28*r**2 - 16*r*s + 61*r - 16) + 2*Pkd2*k2*(r*(4*s - 9) + 2))*(k2**2)**(3/2)))) + f*(1716*D1*Pk2*f*gd2*r*(7*r + 8)*(k2**2)**(3/2) + 1716*D1*Pk2*fd*g2*(14*r**2 + 9*r - 8)*(k2**2)**(3/2) - 13*D1*bd1*(-1980*Pk2*g2*r*(r - 1)*(k2**2)**(3/2) + f**2*(5*k1*(4*Pk2*(2*r*(39*s - 56) - 59*s + 56)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-276*r*s + 112*r + 59*s - 56) + 198*r*s*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(720*r**2 - r*(45*s + 556) + 1850*s - 760) + 5*Pkd2*k2*(r*(87*s - 40) - 185*s + 76))*(k2**2)**(3/2)) - 66*f*(k1*(-4*Pk2*(r*(2*s - 5) + s)*np.sqrt(k2**2) + Pkd2*k2*(-6*k2*r*s + r*(8*s - 5)*np.sqrt(k2**2) + s*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-Pk2*(r**2*(7*K - 7) + 2*r*(4*K + 2*s - 9) + 2*s) + Pkd2*k2*(r*(2*s - 5) + s))*(k2**2)**(3/2))) - 5*D1*f**2*fd*(28*k1*(4*Pk2*(4*r - 1)*(11*s - 19)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-200*r*s + 115*r + 11*s - 19) + 39*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(9632*r**2 - 5460*r*s - 6571*r + 1040*s + 1122) + 364*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2)) + 1716*Dd*Pk2*f*g2*(28*r**2 + 25*r - 8)*(k2**2)**(3/2) - 5*Dd*f**3*(28*k1*(4*Pk2*(4*r - 1)*(11*s - 19)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-200*r*s + 115*r + 11*s - 19) + 39*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(9632*r**2 - 5460*r*s - 6571*r + 1040*s + 1122) + 364*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2))))/(9009*d**2*np.sqrt(k1**2)*(k2**2)**(3/2)) + 4*D1**3*Pkd1*ct**4*(33*D1*bd1*f*(b1*(2*Pk2*k1*(r*(4*C*(3*s + 1) - 22*s - 5) + s*(16 - 10*C))*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(30 - 30*C)*(2*r - 1)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(r*(-4*C*(3*s + 1) + 22*s + 5) + s*(10*C - 16))*np.sqrt(k1**2)*np.sqrt(k2**2) + 7*Pkd2*k2**6*r*(1 - 2*s) + 6*Pkd2*k2**5*(r*(4*s - 1) - s)*np.sqrt(k2**2)) + f*(k1**4*(-4*Pk2*(r*(2*s - 5) - 4*s + 5)*np.sqrt(k2**2) + Pkd2*k2*(-6*k2*r*s + r*(8*s - 5)*np.sqrt(k2**2) + (5 - 4*s)*np.sqrt(k2**2))) + k1*(Pk2*(2*C*(r**2 - 35*r*s + 47*r + 60*s - 44) - 3*r**2 + 36*r*s - 58*r - 80*s + 51) + Pkd2*k2*(C*(60*r*s - 52*r - 68*s + 48) - 48*r*s + 35*r + 49*s - 30))*np.sqrt(k1**2)*(k2**2)**(3/2) - k2**4*(Pk2*(68*C*r + r**2*(19 - 38*C) + 10*r*(s - 5) - 2*s + 1)*np.sqrt(k2**2) + Pkd2*k2*(6*k2*(r*(3*s - 2) - 2*s + 1) - (r*(8*s - 4) + s - 1)*np.sqrt(k2**2))))) + 33*b1**2*(D1*fd*r*(Pk2*k1*s*(12*C - 22)*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(30 - 30*C)*np.sqrt(k2**2) + Pkd2*k1*k2**3*s*(11 - 6*C)*np.sqrt(k1**2)*np.sqrt(k2**2) - 7*Pkd2*k2**6*s + 12*Pkd2*k2**5*s*np.sqrt(k2**2)) + Dd*f*(2*Pk2*k1*(r*(4*C*(6*s + 1) - 44*s - 5) + s*(16 - 10*C))*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(30 - 30*C)*(4*r - 1)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(r*(-4*C*(6*s + 1) + 44*s + 5) + s*(10*C - 16))*np.sqrt(k1**2)*np.sqrt(k2**2) + 7*Pkd2*k2**6*r*(1 - 4*s) + 6*Pkd2*k2**5*(r*(8*s - 1) - s)*np.sqrt(k2**2))) + 33*b1*f*(2*D1*fd*(Pk2*k1*(-8*k1**3*r*(s - 2) + k2**2*(r**2*(2*C - 3) + r*(C*(55 - 70*s) + 36*s - 22) + s*(4*C - 2))*np.sqrt(k1**2))*np.sqrt(k2**2) + Pk2*k2**4*(C*(38*r**2 - 9*r + 8) - 19*r**2 - 2*r*(5*s - 7) - 8)*np.sqrt(k2**2) + 3*Pkd2*k1**4*k2**2*r*(1 - 2*s) + Pkd2*k1**4*k2*r*(8*s - 7)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(-2*C*s + r*(20*C*(3*s - 2) - 48*s + 26) + s)*np.sqrt(k1**2)*np.sqrt(k2**2) + 6*Pkd2*k2**6*r*(1 - 3*s) + Pkd2*k2**5*s*(8*r - 1)*np.sqrt(k2**2)) + Dd*f*(k1**4*(-4*Pk2*(2*r*(4*s - 9) - 4*s + 5)*np.sqrt(k2**2) + Pkd2*k2*(6*k2*r*(1 - 4*s) + (8*r*(4*s - 3) - 4*s + 5)*np.sqrt(k2**2))) + k1*(Pk2*(4*C*(2*r**2 - 70*r*s + 71*r + 34*s - 22) - 12*r**2 + 144*r*s - 143*r - 94*s + 51) + 2*Pkd2*k2*(2*C*(60*r*s - 44*r - 19*s + 12) - 96*r*s + 56*r + 28*s - 15))*np.sqrt(k1**2)*(k2**2)**(3/2) - k2**4*(Pk2*(-2*C*(76*r**2 - 51*r + 8) + 76*r**2 + 40*r*s - 95*r - 2*s + 17)*np.sqrt(k2**2) + Pkd2*k2*(6*k2*(12*r*s - 5*r - 2*s + 1) + (-32*r*s + 4*r + 1)*np.sqrt(k2**2))))) + f**2*(D1*fd*(2*Pk2*k2**4*(2*C*(810*r**2 + 87*r - 119) - 1890*r**2 - 3*r*(240*s - 511) + 273*s - 312)*np.sqrt(k2**2) - 165*Pkd2*k2**6*(3*r - 1)*(2*s - 1) + 5*k1**4*(-4*Pk2*(3*r - 1)*(3*s - 23)*np.sqrt(k2**2) + Pkd2*k2*(33*k2*r*(1 - 3*s) + (6*r*(18*s - 17) - 3*s + 23)*np.sqrt(k2**2))) + k1*(2*Pk2*(C*(855*r**2 - 855*r*s + 1068*r + 186*s - 418) - 1665*r**2 - 90*r*s + 1635*r + 162*s - 404) + 5*Pkd2*k2*(3*r - 1)*(4*C*(69*s - 56) - 261*s + 142))*np.sqrt(k1**2)*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(C*(4320*r**2 + 824*r - 476) - 5040*r**2 + r*(3533 - 1920*s) + 703*s - 624)*np.sqrt(k2**2) - 165*Pkd2*k2**6*(4*r - 1)*(2*s - 1) + 5*k1**4*(-4*Pk2*(r*(12*s - 97) + 2*s + 23)*np.sqrt(k2**2) + Pkd2*k2*(-33*k2*r*(4*s - 1) + (2*r*(72*s - 65) + 2*s + 23)*np.sqrt(k2**2))) + k1*(Pk2*(4*C*(570*r**2 - 570*r*s + 942*r - 106*s - 209) - 4440*r**2 - 240*r*s + 3375*r + 1027*s - 808) + 5*Pkd2*k2*(4*C*(276*r*s - 229*r - 64*s + 56) - 1044*r*s + 563*r + 266*s - 142))*np.sqrt(k1**2)*(k2**2)**(3/2))))/(693*d**2*k3**2*np.sqrt(k1**2)*(k2**2)**(3/2)) + D1**3*Pkd1*ct**3*f*k2*st**4*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(2*D1*(33*b1*fd*r*(2*s - 1) + 33*bd1*f*r*s + 5*f*fd*(3*r - 1)*(3*s - 1)) + Dd*f*(66*b1*r*(4*s - 1) + 5*f*(24*r*s - 7*r - 7*s + 2)))/(231*d**2*k3**2) - 2*D1**3*Pkd1*ct**3*st**2*(-429*b1**2*k1**2*(D1*fd*r*(2*Pk2*(14*f*(2*s - 1) + (11*K - 11)*(s - 1))*np.sqrt(k2**2) + k2*(-10*Pk2*(-3*K*s + 3*K + 14*f*(2*s - 1) + 3*s - 3) + Pkd2*(28*f*(2*s - 1) + (13 - 13*K)*(s - 1))*np.sqrt(k2**2))) + Dd*f*(Pk2*(2*f*(8*r*(7*s - 3) - 10*s + 5) + (K - 1)*(88*r*s - 13*r + 3*s - 3))*np.sqrt(k2**2) + k2*(-5*Pk2*(2*f*(8*r*(7*s - 3) - 10*s + 5) - (3*K - 3)*(r*(8*s - 5) - s + 1)) + Pkd2*(2*f*(8*r*(7*s - 3) - 10*s + 5) - (K - 1)*(r*(52*s - 22) - 3*s + 3))*np.sqrt(k2**2)))) + 13*b1*(-33*D1*bd1*f*k1**2*(Pk2*(2*f*(2*r*(14*s - 5) - 10*s + 5) + (K - 1)*(44*r*s + 6*r + 3*s - 3))*np.sqrt(k2**2) + k2*(-5*Pk2*(2*f*(2*r*(14*s - 5) - 10*s + 5) + (3 - 3*K)*(r*(4*s - 2) - s + 1)) + Pkd2*(2*f*(2*r*(14*s - 5) - 10*s + 5) - (K - 1)*(r*(26*s - 6) - 3*s + 3))*np.sqrt(k2**2))) + D1*(2*f**2*fd*(675*Pk2*r**2*(k2**2)**(3/2) - k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(27*r*(96*s - 43) - 156*s + 85)) + 33*f*k1**2*(fd*(K - 1)*(Pk2*(r*(24*s - 13) - 5*s + 3)*np.sqrt(k2**2) + k2*(-5*Pk2*(16*r*s - 9*r - 5*s + 3) + Pkd2*(14*r*s - 8*r - 5*s + 3)*np.sqrt(k2**2))) + 2*gd2*r*(15*Pk2*k2*(2*s - 1) + Pk2*(22*s + 3)*np.sqrt(k2**2) + Pkd2*k2*(3 - 13*s)*np.sqrt(k2**2))) - 66*fd*g2*k1**2*r*(s - 1)*(-30*Pk2*k2 - 22*Pk2*np.sqrt(k2**2) + 13*Pkd2*k2*np.sqrt(k2**2))) + Dd*f*(2*f**2*(225*Pk2*r*(4*r - 1)*(k2**2)**(3/2) - k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(384*r*(9*s - 4) - 668*s + 335)) + 33*f*k1**2*(K - 1)*(Pk2*(r*(48*s - 19) - 5*s + 3)*np.sqrt(k2**2) + k2*(-5*Pk2*(32*r*s - 15*r - 5*s + 3) + Pkd2*(28*r*s - 14*r - 5*s + 3)*np.sqrt(k2**2))) - 66*g2*k1**2*(Pk2*(r*(13 - 88*s) - 3*s + 3)*np.sqrt(k2**2) + k2*(-15*Pk2*(8*r*s - 5*r - s + 1) + Pkd2*(52*r*s - 22*r - 3*s + 3)*np.sqrt(k2**2))))) + f*(13*D1*bd1*(2*f**2*(225*Pk2*r*(r - 1)*(k2**2)**(3/2) - k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(r*(864*s - 375) - 512*s + 250)) + 33*f*k1**2*r*(K - 1)*(-5*Pk2*k2*(8*s - 3) + 3*Pk2*(4*s - 1)*np.sqrt(k2**2) + Pkd2*k2*(7*s - 3)*np.sqrt(k2**2)) - 66*g2*k1**2*(-15*Pk2*k2*(r*(2*s - 1) - s + 1) - Pk2*(22*r*s + 3*r + 3*s - 3)*np.sqrt(k2**2) + Pkd2*k2*(r*(13*s - 3) - 3*s + 3)*np.sqrt(k2**2))) + 10*D1*f**2*fd*(3*Pk2*(1100*r**2 - 459*r + 46)*(k2**2)**(3/2) - 10*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(8*r*(53*s - 23) - 54*s + 33)) - 858*D1*f*gd2*k1**2*r*(-5*Pk2*k2*(8*s - 3) + 3*Pk2*(4*s - 1)*np.sqrt(k2**2) + Pkd2*k2*(7*s - 3)*np.sqrt(k2**2)) - 858*D1*fd*g2*k1**2*(Pk2*(r*(24*s - 13) - 5*s + 3)*np.sqrt(k2**2) + k2*(-5*Pk2*(16*r*s - 9*r - 5*s + 3) + Pkd2*(14*r*s - 8*r - 5*s + 3)*np.sqrt(k2**2))) + 10*Dd*f**3*(3*Pk2*(1100*r**2 - 459*r + 46)*(k2**2)**(3/2) - 10*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(8*r*(53*s - 23) - 54*s + 33)) - 858*Dd*f*g2*k1**2*(Pk2*(r*(48*s - 19) - 5*s + 3)*np.sqrt(k2**2) + k2*(-5*Pk2*(32*r*s - 15*r - 5*s + 3) + Pkd2*(28*r*s - 14*r - 5*s + 3)*np.sqrt(k2**2)))))/(9009*d**2*k1**2*k2*np.sqrt(k2**2)) + 2*D1**3*Pkd1*ct**3*(858*b1**3*k1**2*(5*D1*fd*r*s + Dd*f*(20*r*s + r - 6*s))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + 429*b1**2*(2*D1*(Pk2*fd*r**2*(10*f + 10)*(k2**2)**(3/2) + bd1*f*k1**2*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(15*r*s + r - 6*s) + fd*k1**2*(Pk2*(r**2*(6 - 11*f) + r*(42*K*s - 40*K + f*(4 - 8*s) - 32*s + 30) - s*(2*K + 2*f - 2))*np.sqrt(k2**2) + k2*(Pk2*(r*(-73*K*s + 67*K + 6*f*(2*s - 1) + 43*s - 37) + s*(6*K + 6*f - 6)) - 2*Pkd2*(r*(-7*K*s + 6*K + f*(4*s - 2) + 2*s - 1) + s*(K + f - 1))*np.sqrt(k2**2)))) + Dd*f*(Pk2*r*(10*f + 20)*(4*r - 1)*(k2**2)**(3/2) + k1**2*(Pk2*(K*(336*r*s - 202*r - 50*s + 42) - f*(44*r**2 + r*(32*s - 35) + 4) + 48*r**2 - 256*r*s + 98*r + 26*s - 18)*np.sqrt(k2**2) + 2*k2*(Pk2*(K*(-292*r*s + 202*r + 59*s - 47) + 6*f*(r*(4*s - 5) + 1) + 172*r*s - 64*r - 23*s + 11) - 2*Pkd2*(K*(-28*r*s + 26*r + 9*s - 7) + f*r*(8*s - 6) + f + 8*r*s - 3*r - 3*s + 1)*np.sqrt(k2**2))))) + 13*b1*(-5808*D1*K*Pk2*f*fd*k1**2*k2*r*s + 5676*D1*K*Pk2*f*fd*k1**2*k2*r + 1188*D1*K*Pk2*f*fd*k1**2*k2*s - 1980*D1*K*Pk2*f*fd*k1**2*k2 + 5148*D1*K*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 3762*D1*K*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) - 924*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 1056*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 1056*D1*K*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 1320*D1*K*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) - 528*D1*K*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) + 660*D1*K*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) - 990*D1*Pk2*bd2*f*k1**2*k2*r*s + 1188*D1*Pk2*bd2*f*k1**2*k2*r + 330*D1*Pk2*bd2*f*k1**2*r*s*np.sqrt(k2**2) - 396*D1*Pk2*bd2*f*k1**2*r*np.sqrt(k2**2) + 11070*D1*Pk2*f**2*fd*k1**2*k2*r*s - 4860*D1*Pk2*f**2*fd*k1**2*k2*r - 918*D1*Pk2*f**2*fd*k1**2*k2*s + 36*D1*Pk2*f**2*fd*k1**2*k2 - 4410*D1*Pk2*f**2*fd*k1**2*r**2*np.sqrt(k2**2) - 5670*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) + 4641*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 570*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) - 642*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 810*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) + 2322*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) - 684*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 4224*D1*Pk2*f*fd*k1**2*k2*r*s - 2508*D1*Pk2*f*fd*k1**2*k2*r - 396*D1*Pk2*f*fd*k1**2*k2*s + 396*D1*Pk2*f*fd*k1**2*k2 - 396*D1*Pk2*f*fd*k1**2*r**2*np.sqrt(k2**2) - 4620*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) + 4224*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 660*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 1188*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 660*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) + 462*D1*Pk2*f*fd*r*(k2**2)**(3/2) - 396*D1*Pk2*f*fd*(k2**2)**(3/2) + 9636*D1*Pk2*f*gd2*k1**2*k2*r*s - 5808*D1*Pk2*f*gd2*k1**2*k2*r - 396*D1*Pk2*f*gd2*k1**2*k2*s - 5544*D1*Pk2*f*gd2*k1**2*r*s*np.sqrt(k2**2) + 2640*D1*Pk2*f*gd2*k1**2*r*np.sqrt(k2**2) + 132*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 9636*D1*Pk2*fd*g2*k1**2*k2*r*s - 8844*D1*Pk2*fd*g2*k1**2*k2*r - 792*D1*Pk2*fd*g2*k1**2*k2*s - 5544*D1*Pk2*fd*g2*k1**2*r*s*np.sqrt(k2**2) + 5280*D1*Pk2*fd*g2*k1**2*r*np.sqrt(k2**2) + 264*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 330*D1*Pkd2*bd2*f*k1**2*k2*r*s*np.sqrt(k2**2) - 396*D1*Pkd2*bd2*f*k1**2*k2*r*np.sqrt(k2**2) - 5670*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 2280*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 570*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) - 100*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) - 528*D1*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 264*D1*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) + 264*D1*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) - 132*D1*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) - 1848*D1*Pkd2*f*gd2*k1**2*k2*r*s*np.sqrt(k2**2) + 1716*D1*Pkd2*f*gd2*k1**2*k2*r*np.sqrt(k2**2) + 132*D1*Pkd2*f*gd2*k1**2*k2*s*np.sqrt(k2**2) - 1848*D1*Pkd2*fd*g2*k1**2*k2*r*s*np.sqrt(k2**2) + 1584*D1*Pkd2*fd*g2*k1**2*k2*r*np.sqrt(k2**2) + 264*D1*Pkd2*fd*g2*k1**2*k2*s*np.sqrt(k2**2) + 33*D1*bd1*f*(Pk2*r*(10*f + 20)*(2*r - 1)*(k2**2)**(3/2) + k1**2*(Pk2*(2*K*(84*r*s - 41*r - 22*s + 21) + f*(-22*r**2 - 16*r*s + 27*r + 4*s - 4) + 24*r**2 - 128*r*s + 22*r + 20*s - 18)*np.sqrt(k2**2) + 2*k2*(Pk2*(K*(-146*r*s + 91*r + 50*s - 47) + 6*f*(2*r*(s - 2) - s + 1) + 86*r*s - 19*r - 14*s + 11) + Pkd2*(K*(28*r*s - 27*r - 15*s + 14) - 2*f*(4*r - 1)*(s - 1) - 8*r*s + 3*r + 3*s - 2)*np.sqrt(k2**2)))) - 11616*Dd*K*Pk2*f**2*k1**2*k2*r*s + 10560*Dd*K*Pk2*f**2*k1**2*k2*r + 264*Dd*K*Pk2*f**2*k1**2*k2*s - 1980*Dd*K*Pk2*f**2*k1**2*k2 + 10296*Dd*K*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 6006*Dd*K*Pk2*f**2*k1**2*r*np.sqrt(k2**2) - 792*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 1056*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) + 2112*Dd*K*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) - 2772*Dd*K*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) - 396*Dd*K*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) + 660*Dd*K*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) + 14760*Dd*Pk2*f**3*k1**2*k2*r*s - 7890*Dd*Pk2*f**3*k1**2*k2*r - 5064*Dd*Pk2*f**3*k1**2*k2*s + 2316*Dd*Pk2*f**3*k1**2*k2 - 5880*Dd*Pk2*f**3*k1**2*r**2*np.sqrt(k2**2) - 7560*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) + 6928*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) + 2040*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) - 1402*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 1080*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) + 3006*Dd*Pk2*f**3*r*(k2**2)**(3/2) - 684*Dd*Pk2*f**3*(k2**2)**(3/2) + 8448*Dd*Pk2*f**2*k1**2*k2*r*s - 3432*Dd*Pk2*f**2*k1**2*k2*r - 264*Dd*Pk2*f**2*k1**2*k2*s + 396*Dd*Pk2*f**2*k1**2*k2 - 792*Dd*Pk2*f**2*k1**2*r**2*np.sqrt(k2**2) - 9240*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) + 6468*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 792*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 1188*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) + 1320*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) + 1254*Dd*Pk2*f**2*r*(k2**2)**(3/2) - 396*Dd*Pk2*f**2*(k2**2)**(3/2) + 38544*Dd*Pk2*f*g2*k1**2*k2*r*s - 26664*Dd*Pk2*f*g2*k1**2*k2*r - 7788*Dd*Pk2*f*g2*k1**2*k2*s + 6204*Dd*Pk2*f*g2*k1**2*k2 - 22176*Dd*Pk2*f*g2*k1**2*r*s*np.sqrt(k2**2) + 13332*Dd*Pk2*f*g2*k1**2*r*np.sqrt(k2**2) + 3300*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 2772*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) - 7560*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) + 3290*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) + 2040*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) - 860*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) - 1056*Dd*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) + 396*Dd*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) + 396*Dd*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) - 132*Dd*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) - 7392*Dd*Pkd2*f*g2*k1**2*k2*r*s*np.sqrt(k2**2) + 6864*Dd*Pkd2*f*g2*k1**2*k2*r*np.sqrt(k2**2) + 2376*Dd*Pkd2*f*g2*k1**2*k2*s*np.sqrt(k2**2) - 1848*Dd*Pkd2*f*g2*k1**2*k2*np.sqrt(k2**2) + 66*b2*k1**2*(5*D1*fd*r*(s - 1) + Dd*f*(r*(20*s - 23) - 6*s + 6))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + f*(-13*D1*bd1*(f**2*(18*Pk2*r*(15*r - 38)*(k2**2)**(3/2) + k1**2*(Pk2*(1470*r**2 + r*(1890*s - 2287) - 1470*s + 760)*np.sqrt(k2**2) - 2*k2*(3*Pk2*(615*r*s - 505*r - 691*s + 380) + 5*Pkd2*(-189*r*s + 101*r + 147*s - 76)*np.sqrt(k2**2)))) - 66*f*(Pk2*r*(5*r + 6)*(k2**2)**(3/2) + k1**2*(Pk2*(-3*r**2 + r*(39*K*s - 17*K - 35*s + 17) + s*(K + 1))*np.sqrt(k2**2) + k2*(Pk2*(-7*K*s + r*(-44*K*s + 37*K + 32*s - 7) + s) + Pkd2*(8*K*r*s - 11*K*r + K*s - 4*r*s + r + s)*np.sqrt(k2**2)))) + 132*g2*k1**2*(21*Pk2*(r*(2*s - 1) - s + 1)*np.sqrt(k2**2) + k2*(Pk2*r*(47 - 73*s) + 47*Pk2*(s - 1) + 14*Pkd2*(r - 1)*(s - 1)*np.sqrt(k2**2)))) + 858*b2*k1**2*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(D1*bd1*(r*(5*s - 6) - 6*s + 6) + 2*D1*fd*(2*r - 1)*(s - 2) + 2*Dd*f*(4*r*s - 9*r + 2)) - k1**2*(5*D1*f**2*fd*(Pk2*(4*r - 1)*(2387*r + 2912*s - 2550)*np.sqrt(k2**2) - 104*k2*(Pk2*(7*r*(28*s - 19) - 44*s + 32) - 14*Pkd2*(4*r - 1)*(2*s - 1)*np.sqrt(k2**2))) - 858*D1*f*(bd2*(r*(2*s - 5) + s)*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) - 2*gd2*(Pk2*(r*(39*s - 17) + s)*np.sqrt(k2**2) + k2*(Pk2*(-44*r*s + 37*r - 7*s) + Pkd2*(8*r*s - 11*r + s)*np.sqrt(k2**2)))) + 1716*D1*fd*g2*(-2*Pk2*k2*(r*(44*s - 43) - 9*s + 15) + Pk2*(r*(78*s - 57) - 14*s + 16)*np.sqrt(k2**2) + 2*Pkd2*k2*(2*r - 1)*(4*s - 5)*np.sqrt(k2**2)) + 5*Dd*f**3*(Pk2*(4*r - 1)*(2387*r + 2912*s - 2550)*np.sqrt(k2**2) - 104*k2*(Pk2*(7*r*(28*s - 19) - 44*s + 32) - 14*Pkd2*(4*r - 1)*(2*s - 1)*np.sqrt(k2**2))) + 1716*Dd*f*g2*(Pk2*(13*r*(12*s - 7) - 12*s + 16)*np.sqrt(k2**2) - 2*k2*(Pk2*(88*r*s - 80*r - 2*s + 15) + Pkd2*(-16*r*s + 21*r + 3*s - 5)*np.sqrt(k2**2))))))/(9009*d**2*k1**2*k2*np.sqrt(k2**2)) + 2*D1**3*Pkd1*ct**3*st**2*(33*D1*bd1*f*(-2*b1*k1**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*r*(13*s - 5) - 3*s)*(k2**2)**(3/2) + f*(-2*Pk2*k2**5*r*(r - 1) + k1**4*(Pk2*(C*(r*(6 - 24*s) + 10*s - 6) + 18*r*(3*s - 1) - 31*s + 18)*np.sqrt(k2**2) + k2*(5*Pk2*(2*C*(8*r*s - 3*r - 5*s + 3) - 46*r*s + 18*r + 31*s - 18) + Pkd2*(-2*C*(7*r*s - 3*r - 5*s + 3) + 44*r*s - 18*r - 31*s + 18)*np.sqrt(k2**2))) + k1**2*(-2*C*(2*Pk2*(27*r**2 + 69*r*s - 41*r - 32*s + 16) + Pkd2*k2*(-27*r*s + 11*r + 26*s - 13)) + 2*Pk2*(65*r**2 + 52*r*s - 61*r - 3*s) + Pkd2*k2*(32*r*s - 10*r - 9*s + 6))*(k2**2)**(3/2))) - 66*b1**2*k1**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(13*D1*fd*r*s + Dd*f*(2*r*(26*s - 5) - 3*s))*(k2**2)**(3/2) + 33*b1*f*(D1*fd*(-4*Pk2*k2**5*r**2 + k1**4*r*(Pk2*(C*(26 - 48*s) + 108*s - 59)*np.sqrt(k2**2) + k2*(5*Pk2*(32*C*s - 18*C - 92*s + 51) + Pkd2*(-28*C*s + 16*C + 88*s - 49)*np.sqrt(k2**2))) + k1**2*(Pk2*(r**2*(260 - 216*C) + r*(-552*C*s + 304*C + 208*s - 126) - s*(20*C - 20)) + Pkd2*k2*(r*(108*C*s - 68*C + 64*s - 21) + s*(10*C - 10)))*(k2**2)**(3/2)) + Dd*f*(2*Pk2*k2**5*r*(1 - 4*r) + k1**4*(Pk2*(C*(-96*r*s + 38*r + 10*s - 6) + 216*r*s - 95*r - 31*s + 18)*np.sqrt(k2**2) + k2*(5*Pk2*(2*C*(32*r*s - 15*r - 5*s + 3) - 184*r*s + 87*r + 31*s - 18) + Pkd2*(C*(-56*r*s + 28*r + 10*s - 6) + 176*r*s - 85*r - 31*s + 18)*np.sqrt(k2**2))) + k1**2*(-2*C*(Pk2*(216*r**2 + 552*r*s - 266*r - 54*s + 32) + Pkd2*k2*(-108*r*s + 58*r + 21*s - 13)) + 2*Pk2*(260*r**2 + 4*r*(52*s - 31) + 7*s) + Pkd2*k2*(r*(128*s - 37) - 19*s + 6))*(k2**2)**(3/2))) + f**2*(D1*fd*(2*Pk2*k2**5*(135*r**2 - 57*r + 4) - 3*k1**4*(Pk2*(C*(636*r*s - 256*r - 58*s + 34) - 1248*r*s + 559*r + 163*s - 102)*np.sqrt(k2**2) + k2*(-5*Pk2*(2*C*(186*r*s - 84*r - 29*s + 17) - 984*r*s + 471*r + 163*s - 102) + Pkd2*(2*C*(153*r*s - 73*r - 29*s + 17) - 918*r*s + 449*r + 163*s - 102)*np.sqrt(k2**2))) + k1**2*(-2*C*Pk2*(2214*r**2 + 54*r*(120*s - 71) - 840*s + 592) + 22*Pk2*(243*r**2 + 6*r*(18*s - 19) + 9*s - 4) + Pkd2*k2*(2*C*(9*r*(258*s - 119) - 510*s + 269) + 9*r*(72*s - 35) + 81*s + 6))*(k2**2)**(3/2)) + Dd*f*(2*Pk2*k2**5*(180*r**2 - 61*r + 4) - 3*k1**4*(Pk2*(C*(848*r*s - 306*r - 42*s + 34) - 1664*r*s + 709*r + 115*s - 102)*np.sqrt(k2**2) + k2*(-5*Pk2*(C*(496*r*s - 218*r - 42*s + 34) - 1312*r*s + 621*r + 115*s - 102) + Pkd2*(2*C*(204*r*s - 98*r - 21*s + 17) - 1224*r*s + 599*r + 115*s - 102)*np.sqrt(k2**2))) + k1**2*(-4*C*Pk2*(1476*r**2 + r*(4320*s - 2341) - 292*s + 296) + 22*Pk2*(324*r**2 + 2*r*(72*s - 55) + 9*s - 4) + Pkd2*k2*(C*(8*r*(774*s - 355) - 860*s + 538) + 864*r*s - 417*r + 177*s + 6))*(k2**2)**(3/2))))/(693*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 4*D1**3*Pkd1*ct**3*(33*D1*bd1*f*(b1*(10*Pk2*k2**5*r*(1 - 2*r) - k1**4*(r*(C*(8*s - 2) - 2*s + 4) - s*(2*C + 3))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) - k1**2*(-2*Pk2*(r**2*(18*C - 24) + r*(6*C*s - 14*C - 6*s + 17) + s*(2*C - 2)) + Pkd2*k2*(2*r*(24*C*s + C - 11*s + 1) + s*(9 - 26*C)))*(k2**2)**(3/2)) + f*(Pk2*k2**5*r*(7*r - 18) + k1**4*(Pk2*(C*(r*(38 - 86*s) + 34*s - 36) + 11*r**2 + r*(102*s - 55) - 46*s + 40)*np.sqrt(k2**2) + k2*(Pk2*(2*C*(r*(56*s - 43) - 35*s + 40) + r*(102 - 143*s) + 102*s - 90) + 2*Pkd2*(C*(r*(13 - 12*s) + 11*s - 12) + 4*r*(5*s - 4) - 17*s + 14)*np.sqrt(k2**2))) + k1**2*(Pk2*(-2*C*(38*r**2 + 5*r*(s - 10) - 4*s + 4) + 116*r**2 + 39*r*s - 149*r - 12*s + 10) + 2*Pkd2*k2*(C*(4*r*(s - 2) - 13*s + 7) + 16*r*s - 8*r - 10*s + 7))*(k2**2)**(3/2))) - 33*b1**2*(D1*fd*r*(Pk2*k1**2*(k1**2*s*(4*C - 1) - 6*k2**2*(r*(3*C - 4) + s*(C - 1)))*np.sqrt(k2**2) + 10*Pk2*k2**5*r + Pkd2*k1**2*k2**3*s*(24*C - 11)*np.sqrt(k2**2) - k1**4*k2*s*(4*C - 1)*(3*Pk2 - Pkd2*np.sqrt(k2**2))) + Dd*f*(10*Pk2*k2**5*r*(4*r - 1) + k1**4*(2*r*(C*(8*s - 1) - 2*s + 2) - s*(2*C + 3))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(Pk2*(r**2*(96 - 72*C) + r*(-24*C*s + 28*C + 24*s - 34) - s*(4*C - 4)) + Pkd2*k2*(2*r*(48*C*s + C - 22*s + 1) + s*(9 - 26*C)))*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(-2*Pk2*k1**2*(k1**2*(-11*r**2 + r*(86*C*s - 57*C - 102*s + 61) + s*(5 - 4*C)) + k2**2*(C*(76*r**2 + 10*r*s - 43*r - 12*s + 18) - 116*r**2 - 39*r*s + 69*r + 12*s - 23))*np.sqrt(k2**2) + Pk2*k2**5*(14*r**2 - 7*r + 6) + 2*Pkd2*k1**2*k2**3*(4*r*(C*(2*s - 3) + 8*s - 3) + s*(8*C - 7))*np.sqrt(k2**2) + k1**4*k2*(Pk2*(r*(4*C*(56*s - 43) - 286*s + 179) + s*(30 - 24*C)) + 2*Pkd2*(-4*r*(6*C*s - 5*C - 10*s + 6) + s*(4*C - 5))*np.sqrt(k2**2))) + Dd*f*(Pk2*k2**5*(28*r**2 - 31*r + 6) + k1**4*(Pk2*(C*(-344*r*s + 186*r + 44*s - 36) + 44*r**2 + 408*r*s - 213*r - 60*s + 40)*np.sqrt(k2**2) + k2*(Pk2*(4*C*(112*r*s - 83*r - 25*s + 20) - 572*r*s + 359*r + 144*s - 90) - 4*Pkd2*(C*(24*r*s - 22*r - 8*s + 6) - 40*r*s + 26*r + 12*s - 7)*np.sqrt(k2**2))) + k1**2*(Pk2*(C*(-304*r**2 - 40*r*s + 222*r + 40*s - 44) + 464*r**2 + 156*r*s - 335*r - 44*s + 56) + 2*Pkd2*k2*(C*(16*r*s - 26*r - 6*s + 7) + 64*r*s - 26*r - 18*s + 7))*(k2**2)**(3/2))) + f**2*(D1*fd*(330*Pk2*k2**5*r*(3*r - 1) + k1**4*(Pk2*(C*(r*(4056 - 6228*s) + 690*s - 890) + 1800*r**2 + 3*r*(2541*s - 2006) - 1155*s + 1344)*np.sqrt(k2**2) + k2*(Pk2*(2*C*(2799*r*s - 3243*r - 207*s + 839) - 7398*r*s + 6591*r + 915*s - 1680) - 5*Pkd2*(3*r - 1)*(8*C*(9*s - 14) - 165*s + 132)*np.sqrt(k2**2))) + k1**2*(Pk2*(-2*C*(765*r**2 + r*(1701 - 990*s) + 396*s - 674) + 7830*r**2 + 9*r*(265*s - 463) - 894*s + 552) + 165*Pkd2*k2*(3*r - 1)*(C*(4*s - 2) + 3*s - 2))*(k2**2)**(3/2)) + Dd*f*(330*Pk2*k2**5*r*(4*r - 1) + k1**4*(Pk2*(C*(-8304*r*s + 4996*r + 640*s - 890) + 2400*r**2 + 10164*r*s - 7362*r - 1155*s + 1344)*np.sqrt(k2**2) + k2*(Pk2*(2*C*(3732*r*s - 4273*r - 16*s + 839) - 9864*r*s + 8751*r + 435*s - 1680) - 5*Pkd2*(2*C*(144*r*s - 229*r - 31*s + 56) + (33 - 132*r)*(5*s - 4))*np.sqrt(k2**2))) + k1**2*(Pk2*(-2*C*(1020*r**2 - 1320*r*s + 2243*r + 528*s - 674) + 10440*r**2 + 3180*r*s - 4471*r - 1142*s + 552) + 165*Pkd2*k2*(4*r - 1)*(C*(4*s - 2) + 3*s - 2))*(k2**2)**(3/2))))/(693*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 10*D1**3*Pkd1*ct**2*f**2*st**4*(4*Pk2 - Pkd2*k2)*(78*D1*bd1*f*(r*(6*s - 1) - 3*s + 1) + 78*b1*(6*D1*fd*r*(3*s - 1) + Dd*f*(24*r*s - 7*r - 3*s + 1)) + f*(D1*fd + Dd*f)*(2*r*(518*s - 149) - 129*s + 42))/(3003*d**2*np.sqrt(k1**2)) + 4*D1**3*Pkd1*ct**2*f*st**4*(2*D1*(33*b1*fd*r*(2*Pk2*k2**2*(-r*(4*C - 4) - 2*s + 1) + Pkd2*(2*s - 1)*(k2**2)**(3/2) + k1*(C - 2)*(4*Pk2 - Pkd2*k2)*(2*s - 1)*np.sqrt(k1**2)) + f*(-33*bd1*r*(2*Pk2*k2**2*(2*C*(r - 1) - 2*r + s + 2) + Pkd2*k1*k2*s*(C - 2)*np.sqrt(k1**2) - s*(Pk2*k1*(4*C - 8)*np.sqrt(k1**2) + Pkd2*(k2**2)**(3/2))) + fd*(3*r - 1)*(k1*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*np.sqrt(k1**2) + k2**2*(Pk2*(C*(44 - 66*r) + 66*r - 30*s - 34) + 5*Pkd2*k2*(3*s - 1))))) + Dd*f*(-66*b1*r*(2*Pk2*k2**2*(C*(8*r - 2) - 8*r + 4*s + 1) + Pkd2*(1 - 4*s)*(k2**2)**(3/2) - k1*(C - 2)*(4*Pk2 - Pkd2*k2)*(4*s - 1)*np.sqrt(k1**2)) + f*(k1*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) - 7*s + 2)*np.sqrt(k1**2) + k2**2*(Pk2*(-44*C*(12*r**2 - 11*r + 2) + 528*r**2 - 6*r*(40*s + 69) + 70*s + 68) + 5*Pkd2*k2*(r*(24*s - 7) - 7*s + 2)))))/(231*d**2*k3**2*np.sqrt(k1**2)) + D1**3*Pkd1*ct**2*st**2*(143*b1**2*(D1*fd*r*(k1*(-4*Pk2*(f*(60*s - 33) + 26*s - 26)*np.sqrt(k2**2) + Pkd2*k2*(2*k2*(39*f*s - 21*f + 7*s - 7) + 3*(-6*f*s + 3*f + 4*s - 4)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(-42*K*r - 6*f*(4*r + 40*s - 11) + 42*r - 52*s + 52) + Pkd2*k2*(3*f*(40*s - 11) + 26*s - 26))*(k2**2)**(3/2)) + Dd*f*(k1*(-4*Pk2*(3*f*(r*(40*s - 19) - 7*s + 4) + 4*r*(26*s - 11) - 6*s + 6)*np.sqrt(k2**2) + Pkd2*k2*(3*f*k2*(r*(52*s - 22) - 7*s + 4) + 9*f*r*(1 - 4*s)*np.sqrt(k2**2) + 14*k2*r*(4*s - 1) + 6*(r*(8*s - 5) - s + 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 2*(Pk2*(-6*f*(4*r**2 + 4*r*(10*s - 3) - 7*s + 2) + r**2*(84 - 84*K) + r*(21*K - 104*s + 23) + 6*s - 6) + Pkd2*k2*(3*f*(r*(40*s - 11) - 7*s + 2) + r*(52*s - 22) - 3*s + 3))*(k2**2)**(3/2))) + 13*b1*(11*D1*bd1*f*(k1*(-4*Pk2*(3*f*(4*r*(5*s - 2) - 7*s + 4) + 4*r*(13*s - 3) - 6*s + 6)*np.sqrt(k2**2) + Pkd2*k2*(3*f*(k2*(26*r*s - 8*r - 7*s + 4) - 6*r*s*np.sqrt(k2**2)) + 4*r*(7*k2*s + 3*(2*s - 1)*np.sqrt(k2**2)) - 6*(s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-2*Pk2*(3*f*(4*r**2 + r*(40*s - 13) - 14*s + 4) + r**2*(42*K - 42) + r*(-21*K + 52*s + 9) - 6*s + 6) + Pkd2*k2*(3*f*(r*(40*s - 11) - 14*s + 4) + 4*r*(13*s - 3) - 6*s + 6))*(k2**2)**(3/2)) + D1*(924*Pk2*fd*g2*r**2*(k2**2)**(3/2) + f**2*fd*(k1*(-4*Pk2*(6*r*(204*s - 101) - 105*s + 68)*np.sqrt(k2**2) + Pkd2*k2*(k2*(1818*r*s - 804*r - 105*s + 68) + 198*r*(1 - 3*s)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-6*Pk2*(270*r**2 + r*(59 - 252*s) - 70*s + 40) + Pkd2*k2*(3*r*(78*s + 31) - 210*s + 68))*(k2**2)**(3/2)) + 22*f*(42*Pk2*gd2*r**2*(k2**2)**(3/2) + fd*k1*(-4*Pk2*(2*r*(7*s - 4) - 5*s + 3)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-2*r*s + r) + (16*r*s - 9*r - 5*s + 3)*np.sqrt(k2**2)))*np.sqrt(k1**2) + fd*(Pk2*(K*(-26*r**2 + 33*r - 10) + 26*r**2 - 28*r*s - 17*r + 10*s + 4) + Pkd2*k2*(2*r*(7*s - 4) - 5*s + 3))*(k2**2)**(3/2))) + 2*Dd*f*(462*Pk2*g2*r*(4*r - 1)*(k2**2)**(3/2) + f**2*(k1*(-4*Pk2*(r*(816*s - 403) - 137*s + 84)*np.sqrt(k2**2) + Pkd2*k2*(k2*(1212*r*s - 502*r - 137*s + 84) + 99*r*(1 - 4*s)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-2*Pk2*(540*r**2 - r*(504*s + 13) + 92*s - 22) + Pkd2*k2*(r*(156*s + 61) + 92*s - 48))*(k2**2)**(3/2)) + 11*f*(k1*(-4*Pk2*(14*r*(2*s - 1) - 5*s + 3)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-4*r*s + r) + (32*r*s - 15*r - 5*s + 3)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(K*(-52*r**2 + 53*r - 10) + 52*r**2 - 56*r*s - 25*r + 10*s + 4) + Pkd2*k2*(14*r*(2*s - 1) - 5*s + 3))*(k2**2)**(3/2)))) + f*(572*D1*Pk2*f*gd2*r*(13*r - 10)*(k2**2)**(3/2) + 572*D1*Pk2*fd*g2*(26*r**2 - 33*r + 10)*(k2**2)**(3/2) + 13*D1*bd1*(924*Pk2*g2*r*(r - 1)*(k2**2)**(3/2) + f**2*(k1*(4*Pk2*(-8*r*(51*s - 25) + 169*s - 100)*np.sqrt(k2**2) + Pkd2*k2*(k2*(606*r*s - 200*r - 169*s + 100) - 198*r*s*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(-540*r**2 + 14*r*(36*s + 29) - 788*s + 328) + Pkd2*k2*(r*(78*s + 29) + 394*s - 164))*(k2**2)**(3/2)) - 22*f*r*(k1*(4*Pk2*(7*s - 3)*np.sqrt(k2**2) + Pkd2*k2*(k2*s + (3 - 8*s)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(K*(13*r - 10) - 13*r + 14*s + 4) + Pkd2*k2*(3 - 7*s))*(k2**2)**(3/2))) + D1*f**2*fd*(-5*k1*(4*Pk2*(r*(1592*s - 723) - 203*s + 132)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-2372*r*s + 918*r + 203*s - 132) + 195*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 2*(Pk2*(-17360*r**2 + 2*r*(7800*s + 1181) + 910*s - 708) - 325*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2)) + 572*Dd*Pk2*f*g2*(52*r**2 - 53*r + 10)*(k2**2)**(3/2) + Dd*f**3*(-5*k1*(4*Pk2*(r*(1592*s - 723) - 203*s + 132)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-2372*r*s + 918*r + 203*s - 132) + 195*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 2*(Pk2*(-17360*r**2 + 2*r*(7800*s + 1181) + 910*s - 708) - 325*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2))))/(3003*d**2*np.sqrt(k1**2)*(k2**2)**(3/2)) - 2*D1**3*Pkd1*ct**2*(-33*b1**3*(D1*fd*r*(2*Pk2*(-3*k1*s*np.sqrt(k1**2) + k2**2*r)*np.sqrt(k2**2) + Pkd2*k2*s*(k1*(10*k2 - 7*np.sqrt(k2**2))*np.sqrt(k1**2) + 3*(k2**2)**(3/2))) + Dd*f*(-k1*(2*Pk2*(2*r*(6*s + 1) - 5*s)*np.sqrt(k2**2) + Pkd2*k2*(5*k2*(-8*r*s + r + s) + 7*r*(4*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (2*Pk2*r*(4*r - 1) + Pkd2*k2*(12*r*s + 2*r - 5*s))*(k2**2)**(3/2))) + 33*b1**2*(D1*(Pk2*fd*(k1*(r*(-70*f*s + 39*f - 46*s + 38) + s*(4*f + 8))*np.sqrt(k1**2) + k2**2*(2*K*(-17*r**2 + 4*r - 2) + f*(80*r**2 + r*(36*s - 51) + 16) + 30*r**2 - 10*r*s + 2*r + 4))*np.sqrt(k2**2) - 2*Pkd2*fd*k2*(k1*(k2*(f*s + r*(8*f*s - 7*s + 7)) + 2*(3*f*r*(2 - 5*s) - r*s + s)*np.sqrt(k2**2))*np.sqrt(k1**2) + (r*(f*(12 - 38*s) - 9*s + 7) + s*(f + 2))*(k2**2)**(3/2)) + bd1*f*k1*(2*Pk2*(r*(9*s + 2) - 5*s)*np.sqrt(k2**2) + Pkd2*k2*(5*k2*(-6*r*s + r + s) + 7*r*(3*s - 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + bd1*f*(2*Pk2*r*(1 - 3*r) + Pkd2*k2*(-r*(9*s + 2) + 5*s))*(k2**2)**(3/2)) + Dd*f*(k1*(Pk2*(f*(r*(103 - 140*s) + 44*s - 28) + (2 - 8*r)*(23*s - 15))*np.sqrt(k2**2) + 2*Pkd2*k2*(k2*(f*r*(2 - 16*s) - 2*f*s + f + (28*r - 7)*(s - 1)) + (f*(30*r*(2*s - 1) - 9*s + 6) + r*(8*s - 1) - 5*s + 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 2*(Pk2*(K*(-68*r**2 + 25*r - 2) + f*(80*r**2 + r*(36*s - 61) + 8) + 60*r**2 - 20*r*s - 21*r - s + 3) + Pkd2*k2*(f*(r*(76*s - 26) - 21*s + 7) + r*(36*s - 29) - 12*s + 8))*(k2**2)**(3/2))) + b1*(33*D1*bd1*f*(2*k1*(Pk2*(f*(r*(32 - 35*s) + 20*s - 14) + r*(28 - 46*s) + 17*s - 15)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-f*(8*r*s - 2*r + s - 1) + (14*r - 7)*(s - 1)) + (3*f*(10*r*s - 6*r - 3*s + 2) + 4*r*s - r - 2*s + 1)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (Pk2*(r**2*(-68*K + 80*f + 60) + r*(38*K + f*(36*s - 71) - 20*s - 38) - 2*s + 2) + 2*Pkd2*k2*(f*(2*r*(19*s - 7) - 20*s + 7) + 3*r*(6*s - 5) - 9*s + 8))*(k2**2)**(3/2)) + 3*D1*(22*Pk2*fd*(-b2*r**2 + g2*(34*r**2 - 8*r + 4))*(k2**2)**(3/2) + f**2*fd*(k1*(-2*Pk2*(45*r*(14*s - 11) - 111*s + 77)*np.sqrt(k2**2) - 5*Pkd2*k2*(6*k2*r*s + 9*k2*s + 33*r*(4 - 7*s)*np.sqrt(k2**2) + 11*(3*s - 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (3*Pk2*(630*r**2 + r*(330*s - 673) - 132*s + 158) + 110*Pkd2*k2*(3*r - 1)*(3*s - 1))*(k2**2)**(3/2)) + 22*f*(Pk2*r*(-bd2*r + gd2*(34*r - 4))*(k2**2)**(3/2) + fd*(k1*(Pk2*(-10*r*s + 17*r + 4*s - 8)*np.sqrt(k2**2) + 6*Pkd2*k2**2*(2*r - 1)*(s - 1))*np.sqrt(k1**2) + (Pk2*(K*(-14*r**2 - 9*r + 8) + 34*r**2 + 2*r*(7*s - 20) - 8*s + 12) + 6*Pkd2*k2*(2*r - 1)*(s - 1))*(k2**2)**(3/2)))) + Dd*f*(-66*Pk2*(4*r - 1)*(b2*r + g2*(4 - 34*r))*(k2**2)**(3/2) + f**2*(k1*(-2*Pk2*(45*r*(56*s - 51) - 779*s + 611)*np.sqrt(k2**2) + 5*Pkd2*k2*(k2*(-24*r*s + 3*r - 37*s + 10) + 33*(28*r*s - 17*r - 6*s + 4)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 6*(6*Pk2*(210*r**2 + 2*r*(55*s - 108) - 44*s + 45) + 55*Pkd2*k2*(4*r - 1)*(3*s - 1))*(k2**2)**(3/2)) + 66*f*(-k1*(Pk2*(20*r*s - 39*r + 2*s + 8)*np.sqrt(k2**2) + 6*Pkd2*k2**2*(-4*r*(s - 1) + s - 1))*np.sqrt(k1**2) + (K*Pk2*(-28*r**2 - 25*r + 8) + 2*Pk2*(2*r - 1)*(17*r + 7*s - 6) + 6*Pkd2*k2*(4*r - 1)*(s - 1))*(k2**2)**(3/2)))) + f*(D1*bd1*(Pk2*r*(-66*b2 + 2244*g2)*(r - 1)*(k2**2)**(3/2) + f**2*(k1*(-4*Pk2*(45*r*(7*s - 9) - 223*s + 190)*np.sqrt(k2**2) + 5*Pkd2*k2*(k2*(-6*r*s + 3*r - 10*s + 10) + 33*(7*r*s - 5*r - 3*s + 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 3*(3*Pk2*(210*r**2 + r*(110*s - 191) - 44*s + 22) + 110*Pkd2*k2*r*(3*s - 1))*(k2**2)**(3/2)) + 66*f*(k1*(Pk2*(r*(11 - 5*s) - 3*s)*np.sqrt(k2**2) + 6*Pkd2*k2**2*r*(s - 1))*np.sqrt(k1**2) + (-Pk2*(r**2*(7*K - 17) + r*(8*K - 7*s + 9) + 3*s) + 6*Pkd2*k2*r*(s - 1))*(k2**2)**(3/2))) + (66*D1*Pk2*f*k2**2*r*(bd2*(5*r - 8) + 2*gd2*(7*r + 8)) + 66*D1*Pk2*fd*k2**2*(2*r - 1)*(b2*(5*r - 8) + 2*g2*(7*r + 8)) - 5*D1*f**2*fd*k1*(Pk2*(7*r*(36*s - 49) - 48*s + 82) - 28*Pkd2*k2*(4*r - 1)*(3*s - 2))*np.sqrt(k1**2) + 66*Dd*Pk2*f*k2**2*(4*r - 1)*(b2*(5*r - 8) + 2*g2*(7*r + 8)) - 5*Dd*f**3*k1*(Pk2*(7*r*(36*s - 49) - 48*s + 82) - 28*Pkd2*k2*(4*r - 1)*(3*s - 2))*np.sqrt(k1**2))*np.sqrt(k2**2)))/(693*d**2*np.sqrt(k1**2)*(k2**2)**(3/2)) + 2*D1**3*Pkd1*ct**2*st**2*(11*D1*bd1*f*(b1*(2*Pk2*k1*(2*r*(C*(22*s - 9) - 35*s + 14) + s*(7 - 4*C))*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(42 - 42*C)*(2*r - 1)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(r*(C*(18 - 44*s) + 70*s - 28) + s*(4*C - 7))*np.sqrt(k1**2)*np.sqrt(k2**2) + 7*Pkd2*k2**6*r*(2*s - 1) + 3*Pkd2*k2**5*(r*(4*s - 1) - s)*np.sqrt(k2**2)) + f*(k1**4*(-4*Pk2*(r*(7*s - 3) - 5*s + 3)*np.sqrt(k2**2) - Pkd2*k2*(k2*r*s + r*(3 - 8*s)*np.sqrt(k2**2) + (5*s - 3)*np.sqrt(k2**2))) + k1*(Pk2*(-2*C*(17*r**2 + 110*r*s - 51*r - 60*s + 36) + 82*r**2 + 156*r*s - 101*r - 44*s + 27) + Pkd2*k2*(C*(56*r*s - 26*r - 48*s + 28) + 12*r*s + 7*s - 4))*np.sqrt(k1**2)*(k2**2)**(3/2) + k2**4*(Pk2*(r**2*(26 - 14*C) + r*(8*C + 72*s - 23) - 6*s + 3)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-7*r*s + 4*r + 6*s - 3) + r*(8*s - 3)*np.sqrt(k2**2))))) + 11*b1**2*(D1*fd*r*(Pk2*k1*s*(44*C - 70)*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(42 - 42*C)*np.sqrt(k2**2) + Pkd2*k1*k2**3*s*(35 - 22*C)*np.sqrt(k1**2)*np.sqrt(k2**2) + 7*Pkd2*k2**6*s + 6*Pkd2*k2**5*s*np.sqrt(k2**2)) + Dd*f*(2*Pk2*k1*(2*r*(C*(44*s - 9) - 70*s + 14) + s*(7 - 4*C))*np.sqrt(k1**2)*(k2**2)**(3/2) + Pk2*k2**4*r*(42 - 42*C)*(4*r - 1)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(-2*r*(C*(44*s - 9) - 70*s + 14) + s*(4*C - 7))*np.sqrt(k1**2)*np.sqrt(k2**2) + 7*Pkd2*k2**6*r*(4*s - 1) + 3*Pkd2*k2**5*(r*(8*s - 1) - s)*np.sqrt(k2**2))) + 11*b1*f*(D1*fd*(2*Pk2*k1*(-4*k1**3*r*(7*s - 4) + k2**2*(r**2*(82 - 34*C) - 4*r*(11*C*(5*s - 3) - 39*s + 25) + s*(13 - 8*C))*np.sqrt(k1**2))*np.sqrt(k2**2) + 2*Pk2*k2**4*(C*(-14*r**2 + 33*r - 10) + 26*r**2 + r*(72*s - 69) + 10)*np.sqrt(k2**2) + Pkd2*k1**4*k2**2*r*(1 - 2*s) + Pkd2*k1**4*k2*r*(16*s - 9)*np.sqrt(k2**2) + Pkd2*k1*k2**3*(2*r*(C*(56*s - 37) + 12*s + 3) + s*(8*C - 13))*np.sqrt(k1**2)*np.sqrt(k2**2) + 2*Pkd2*k2**6*r*(3 - 7*s) + Pkd2*k2**5*s*(16*r - 5)*np.sqrt(k2**2)) + Dd*f*(k1**4*(-4*Pk2*(14*r*(2*s - 1) - 5*s + 3)*np.sqrt(k2**2) + Pkd2*k2*(k2*(-4*r*s + r) + (32*r*s - 15*r - 5*s + 3)*np.sqrt(k2**2))) + k1*(Pk2*(-2*C*(68*r**2 + r*(440*s - 219) - 52*s + 36) + 328*r**2 + 8*r*(78*s - 41) - 18*s + 27) + 2*Pkd2*k2*(2*C*(8*r*(7*s - 4) - 10*s + 7) + r*(24*s + 5) - 3*s - 2))*np.sqrt(k1**2)*(k2**2)**(3/2) + k2**4*(Pk2*(C*(-56*r**2 + 94*r - 20) + 104*r**2 + 8*r*(36*s - 23) - 6*s + 23)*np.sqrt(k2**2) + Pkd2*k2*(k2*(r*(13 - 28*s) + 6*s - 3) + (r*(32*s - 3) - 5*s)*np.sqrt(k2**2))))) + f**2*(D1*fd*(Pk2*k2**4*(4*C*(63*r**2 + 57*r - 26) - 666*r**2 + 21*r*(24*s - 1) + 30*s + 15)*np.sqrt(k2**2) - 33*Pkd2*k2**6*(3*r - 1)*(2*s - 1) + k1**4*(-4*Pk2*(r*(153*s - 73) - 29*s + 17)*np.sqrt(k2**2) + Pkd2*k2*(11*k2*r*(1 - 3*s) + (186*r*s - 84*r - 29*s + 17)*np.sqrt(k2**2))) + k1*(Pk2*(C*(-450*r**2 - 3672*r*s + 2250*r + 432*s - 436) + 792*r**2 + 1818*r*s - 1255*r - 56*s + 147) + Pkd2*k2*(6*C*(3*r*(79*s - 41) - 46*s + 30) - 243*r*s + 158*r + 103*s - 60))*np.sqrt(k1**2)*(k2**2)**(3/2)) + Dd*f*(Pk2*k2**4*(4*C*(84*r**2 + 83*r - 26) - 888*r**2 + r*(672*s - 52) + 46*s + 15)*np.sqrt(k2**2) - 33*Pkd2*k2**6*(4*r - 1)*(2*s - 1) + k1**4*(4*Pk2*(r*(98 - 204*s) + 21*s - 17)*np.sqrt(k2**2) + Pkd2*k2*(11*k2*r*(1 - 4*s) + (248*r*s - 109*r - 21*s + 17)*np.sqrt(k2**2))) + k1*(Pk2*(C*(-600*r**2 - 4896*r*s + 2878*r + 240*s - 436) + 1056*r**2 + 2424*r*s - 1466*r + 8*s + 147) + Pkd2*k2*(2*C*(948*r*s - 491*r - 106*s + 90) - 324*r*s + 210*r + 111*s - 60))*np.sqrt(k1**2)*(k2**2)**(3/2))))/(231*d**2*k3**2*np.sqrt(k1**2)*(k2**2)**(3/2)) + 4*D1**3*Pkd1*ct**2*(33*D1*bd1*f*(b1*(Pk2*k2**4*(r**2*(60*C - 44) - 2*r*(15*C + 9*s - 8) + 15*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*s*(1 - 2*r) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) - s)*np.sqrt(k2**2) + k1*(Pk2*(r**2*(24*C - 28) + r*(C*(4*s - 6) + 6*s + 2) + s*(9 - 8*C)) + Pkd2*k2*(C*r*(40*s + 4) - 46*r*s + r + s*(22 - 24*C)))*np.sqrt(k1**2)*(k2**2)**(3/2)) + f*(Pk2*k2**4*(r**2*(14*C - 53) + r*(16*C - 19*s + 37) + 3*s - 3)*np.sqrt(k2**2) - 6*Pkd2*k2**6*r*s + k1**4*(Pk2*(r*(13*s - 15) - 12*s + 13)*np.sqrt(k2**2) + Pkd2*k2*(6*k2*(-r*s + r + s - 1) + (-4*r*s + 2*r + s - 1)*np.sqrt(k2**2))) + k1*(Pk2*(2*C*(19*r**2 + 10*r*(s - 2) - 6*s + 6) - 109*r**2 - 52*r*s + 112*r + 17*s - 16) + Pkd2*k2*(-4*C*(7*r*s - 8*r - 10*s + 7) - 28*r*s + 8*r + 7*s - 7))*np.sqrt(k1**2)*(k2**2)**(3/2))) + 33*b1**2*(D1*fd*r*(Pk2*k1*(4*k1**3*s + k2**2*(r*(12*C - 14) + s*(2*C + 3))*np.sqrt(k1**2))*np.sqrt(k2**2) + Pk2*k2**4*(r*(30*C - 22) - 9*s)*np.sqrt(k2**2) - 2*Pkd2*k1**4*k2*s*np.sqrt(k2**2) + Pkd2*k1*k2**3*s*(20*C - 23)*np.sqrt(k1**2)*np.sqrt(k2**2) - 7*Pkd2*k2**6*s) + Dd*f*(Pk2*k2**4*(r**2*(120*C - 88) - 2*r*(15*C + 18*s - 8) + 15*s)*np.sqrt(k2**2) + 7*Pkd2*k2**6*s*(1 - 4*r) + k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) - s)*np.sqrt(k2**2) + k1*(Pk2*(r**2*(48*C - 56) + 2*r*(C*(4*s - 3) + 6*s + 1) + s*(9 - 8*C)) + Pkd2*k2*(C*r*(80*s + 4) - 92*r*s + r + s*(22 - 24*C)))*np.sqrt(k1**2)*(k2**2)**(3/2))) + 33*b1*f*(D1*fd*(Pk2*k1*(k1**3*(r*(26*s - 17) - 8*s) + 2*k2**2*(C*(38*r**2 + r*(20*s - 31) - 20*s + 10) - 109*r**2 - 52*r*s + 79*r + 24*s - 21)*np.sqrt(k1**2))*np.sqrt(k2**2) + Pk2*k2**4*(2*C*(14*r**2 + 9*r - 8) - 106*r**2 + r*(63 - 38*s) + 20*s - 14)*np.sqrt(k2**2) - 12*Pkd2*k1**4*k2**2*r*(s - 1) + 4*Pkd2*k1**4*k2*s*(1 - 2*r)*np.sqrt(k2**2) + 2*Pkd2*k1*k2**3*(r*(-4*C*(7*s - 6) - 28*s + 6) + s*(11 - 4*C))*np.sqrt(k1**2)*np.sqrt(k2**2) + 6*Pkd2*k2**6*s*(1 - 2*r)) + Dd*f*(Pk2*k2**4*(2*C*(28*r**2 + 25*r - 8) - 212*r**2 - 38*r*(2*s - 3) + 26*s - 17)*np.sqrt(k2**2) + 6*Pkd2*k2**6*s*(1 - 4*r) + k1**4*(Pk2*(r*(52*s - 43) - 22*s + 13)*np.sqrt(k2**2) - Pkd2*k2*(6*k2*(4*r - 1)*(s - 1) + (16*r*s - 2*r - 6*s + 1)*np.sqrt(k2**2))) + k1*(Pk2*(2*C*(76*r**2 + 40*r*s - 61*r - 32*s + 16) - 436*r**2 - 208*r*s + 313*r + 80*s - 58) + Pkd2*k2*(-4*C*(28*r*s - 26*r - 9*s + 7) - 112*r*s + 26*r + 30*s - 7))*np.sqrt(k1**2)*(k2**2)**(3/2))) + f**2*(D1*fd*(495*Pk2*k2**4*r*(1 - 3*r)*np.sqrt(k2**2) + k1**4*(Pk2*(45*r*(s - 15) + 18*s + 214)*np.sqrt(k2**2) - 165*Pkd2*k2**2*(3*r - 1)*(s - 1)) - k1*(Pk2*(2*C*(855*r**2 + 9*r*(165*s - 188) - 594*s + 502) + 3465*r**2 + 105*r*(9*s - 14) - 348*s + 116) + 165*Pkd2*k2*(3*r - 1)*(C*(6*s - 4) + s - 1))*np.sqrt(k1**2)*(k2**2)**(3/2)) + Dd*f*(495*Pk2*k2**4*r*(1 - 4*r)*np.sqrt(k2**2) + k1**4*(Pk2*(20*r*(3*s - 49) + 109*s + 214)*np.sqrt(k2**2) - 165*Pkd2*k2**2*(4*r - 1)*(s - 1)) - k1*(Pk2*(4*C*(570*r**2 + r*(990*s - 998) - 396*s + 251) + 4620*r**2 + 5*r*(252*s - 299) - 439*s + 116) + 165*Pkd2*k2*(4*r - 1)*(C*(6*s - 4) + s - 1))*np.sqrt(k1**2)*(k2**2)**(3/2))))/(693*d**2*k3**2*np.sqrt(k1**2)*(k2**2)**(3/2)) + 2*D1**3*Pkd1*ct*f*st**4*(13*D1*bd1*f*(264*b1*k1**2*r*s*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + 5*f*(3*Pk2*r*(r - 1)*(k2**2)**(3/2) + 2*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(3*r*(6*s - 1) - 7*s + 2))) + 1716*b1**2*k1**2*r*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + 65*b1*f*(D1*fd*(9*Pk2*r**2*(k2**2)**(3/2) + 4*k1**2*(9*r - 1)*(3*s - 1)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + Dd*f*(3*Pk2*r*(4*r - 1)*(k2**2)**(3/2) + 2*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(3*r*(24*s - 7) - 13*s + 4))) - f**2*(D1*fd + Dd*f)*(15*Pk2*(76*r**2 + 53*r - 18)*(k2**2)**(3/2) - 4*k1**2*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(4*r*(218*s - 61) - 114*s + 35)))/(3003*d**2*k1**2*k2*np.sqrt(k2**2)) + 4*D1**3*Pkd1*ct*f*st**4*(D1*(-33*b1*fd*r*(-4*Pk2*k2**5*r - k1**4*(2*s - 1)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(2*Pk2*(4*C*(r + 2*s - 1) - 6*r + 2*s - 1) - Pkd2*k2*(4*C + 1)*(2*s - 1))*(k2**2)**(3/2)) + f*(33*bd1*r*(Pk2*k1**2*(k1**2*s - 2*k2**2*(2*C*(r + 2*s - 1) - 3*r + s + 3))*np.sqrt(k2**2) + 2*Pk2*k2**5*(r - 1) + Pkd2*k1**2*k2**3*s*(4*C + 1)*np.sqrt(k2**2) + k1**4*k2*s*(-5*Pk2 + Pkd2*np.sqrt(k2**2))) - 2*fd*(3*r - 1)*(Pk2*k2**5*(17 - 18*r) - 2*k1**4*(3*s - 1)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(Pk2*(8*C*(3*r + 9*s - 4) - 48*r + 27) + Pkd2*k2*(-10*C - 2)*(3*s - 1))*(k2**2)**(3/2)))) + Dd*f*(-33*b1*r*(2*Pk2*k2**5*(1 - 4*r) - k1**4*(4*s - 1)*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(4*Pk2*(C*(4*r + 8*s - 3) - 6*r + 2*s + 1) - Pkd2*k2*(4*C + 1)*(4*s - 1))*(k2**2)**(3/2)) + 2*f*(Pk2*k2**5*(72*r**2 - 86*r + 17) + k1**4*(-5*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(r*(24*s - 7) - 7*s + 2) + k1**2*(Pk2*(-4*C*(24*r**2 + 72*r*s - 35*r - 21*s + 8) + 192*r**2 - 156*r + 27) + Pkd2*k2*(5*C + 1)*(r*(24*s - 7) - 7*s + 2))*(k2**2)**(3/2))))/(231*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 2*D1**3*Pkd1*ct*st**2*(-143*b1**3*k1**2*(13*D1*fd*r*s + Dd*f*(2*r*(26*s - 5) - 3*s))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + 143*b1**2*(-D1*bd1*f*k1**2*(r*(39*s - 10) - 3*s)*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + D1*fd*(Pk2*r**2*(12*f - 8)*(k2**2)**(3/2) + k1**2*(Pk2*(f*r*(2 - 44*s) + 5*f*s + r**2*(-18*f - 12) - r*(13*K + 13)*(s - 1))*np.sqrt(k2**2) + k2*(Pk2*(6*f*r*(2*s + 9) - 15*f*s + r*(43*K + 35)*(s - 1)) + Pkd2*(f*r*(2 - 44*s) + 5*f*s - r*(13*K + 13)*(s - 1))*np.sqrt(k2**2)))) + 2*Dd*Pk2*f*r*(3*f - 4)*(4*r - 1)*(k2**2)**(3/2) + Dd*f*k1**2*(Pk2*(K*(-52*r*s + 22*r + 3*s - 3) + 14*f*s - r**2*(36*f + 48) + r*(-88*f*s + 17*f - 52*s + 34) + 3*s - 3)*np.sqrt(k2**2) + k2*(Pk2*(K*(172*r*s - 76*r - 11*s + 11) - 42*f*s + 4*r*(6*f*s + 9*f + 35*s - 14) - 7*s + 7) + Pkd2*(K*(-52*r*s + 22*r + 3*s - 3) + 14*f*s + r*(-88*f*s + 8*f - 52*s + 22) + 3*s - 3)*np.sqrt(k2**2)))) + 13*b1*(550*D1*K*Pk2*f*fd*k1**2*k2*r*s - 330*D1*K*Pk2*f*fd*k1**2*k2*r - 187*D1*K*Pk2*f*fd*k1**2*k2*s + 121*D1*K*Pk2*f*fd*k1**2*k2 - 154*D1*K*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) + 88*D1*K*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 55*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 33*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 154*D1*K*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 88*D1*K*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) + 55*D1*K*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) - 33*D1*K*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) + 429*D1*Pk2*bd2*f*k1**2*k2*r*s - 99*D1*Pk2*bd2*f*k1**2*k2*r - 143*D1*Pk2*bd2*f*k1**2*r*s*np.sqrt(k2**2) + 33*D1*Pk2*bd2*f*k1**2*r*np.sqrt(k2**2) - 1593*D1*Pk2*f**2*fd*k1**2*k2*r*s + 1068*D1*Pk2*f**2*fd*k1**2*k2*r - 63*D1*Pk2*f**2*fd*k1**2*k2*s - 48*D1*Pk2*f**2*fd*k1**2*k2 + 270*D1*Pk2*f**2*fd*k1**2*r**2*np.sqrt(k2**2) + 135*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 347*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) + 21*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 42*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) + 486*D1*Pk2*f**2*fd*r**2*(k2**2)**(3/2) - 126*D1*Pk2*f**2*fd*r*(k2**2)**(3/2) - 12*D1*Pk2*f**2*fd*(k2**2)**(3/2) + 374*D1*Pk2*f*fd*k1**2*k2*r*s - 198*D1*Pk2*f*fd*k1**2*k2*r - 143*D1*Pk2*f*fd*k1**2*k2*s + 77*D1*Pk2*f*fd*k1**2*k2 - 220*D1*Pk2*f*fd*k1**2*r**2*np.sqrt(k2**2) - 154*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) + 374*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) + 55*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) - 121*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) - 132*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) + 242*D1*Pk2*f*fd*r*(k2**2)**(3/2) - 88*D1*Pk2*f*fd*(k2**2)**(3/2) - 946*D1*Pk2*f*gd2*k1**2*k2*r*s + 242*D1*Pk2*f*gd2*k1**2*k2*r + 286*D1*Pk2*f*gd2*k1**2*r*s*np.sqrt(k2**2) - 66*D1*Pk2*f*gd2*k1**2*r*np.sqrt(k2**2) - 946*D1*Pk2*fd*g2*k1**2*k2*r*s + 946*D1*Pk2*fd*g2*k1**2*k2*r + 286*D1*Pk2*fd*g2*k1**2*r*s*np.sqrt(k2**2) - 286*D1*Pk2*fd*g2*k1**2*r*np.sqrt(k2**2) - 143*D1*Pkd2*bd2*f*k1**2*k2*r*s*np.sqrt(k2**2) + 33*D1*Pkd2*bd2*f*k1**2*k2*r*np.sqrt(k2**2) + 135*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 224*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) + 21*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) + 16*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) - 154*D1*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) + 88*D1*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) + 55*D1*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) - 33*D1*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) + 286*D1*Pkd2*f*gd2*k1**2*k2*r*s*np.sqrt(k2**2) - 66*D1*Pkd2*f*gd2*k1**2*k2*r*np.sqrt(k2**2) + 286*D1*Pkd2*fd*g2*k1**2*k2*r*s*np.sqrt(k2**2) - 286*D1*Pkd2*fd*g2*k1**2*k2*r*np.sqrt(k2**2) + 11*D1*bd1*f*(Pk2*r*(6*f - 8)*(2*r - 1)*(k2**2)**(3/2) + k1**2*(Pk2*(K*(-26*r*s + 6*r + 3*s - 3) + 9*f*s + r**2*(-18*f - 24) + r*(-44*f*s + 15*f - 26*s + 18) + 3*s - 3)*np.sqrt(k2**2) + k2*(Pk2*(K*(86*r*s - 22*r - 11*s + 11) - 27*f*s + 2*r*(6*f*s - 9*f + 35*s - 7) - 7*s + 7) + Pkd2*(K*(-26*r*s + 6*r + 3*s - 3) + 9*f*s + r*(-44*f*s + 6*f - 26*s + 6) + 3*s - 3)*np.sqrt(k2**2)))) + 1100*Dd*K*Pk2*f**2*k1**2*k2*r*s - 572*Dd*K*Pk2*f**2*k1**2*k2*r - 187*Dd*K*Pk2*f**2*k1**2*k2*s + 121*Dd*K*Pk2*f**2*k1**2*k2 - 308*Dd*K*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) + 154*Dd*K*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 55*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 33*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) - 308*Dd*K*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) + 154*Dd*K*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) + 55*Dd*K*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) - 33*Dd*K*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) - 2124*Dd*Pk2*f**3*k1**2*k2*r*s + 1302*Dd*Pk2*f**3*k1**2*k2*r + 405*Dd*Pk2*f**3*k1**2*k2*s - 294*Dd*Pk2*f**3*k1**2*k2 + 360*Dd*Pk2*f**3*k1**2*r**2*np.sqrt(k2**2) + 180*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 496*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 135*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 124*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) + 648*Dd*Pk2*f**3*r**2*(k2**2)**(3/2) - 114*Dd*Pk2*f**3*r*(k2**2)**(3/2) - 12*Dd*Pk2*f**3*(k2**2)**(3/2) + 748*Dd*Pk2*f**2*k1**2*k2*r*s - 352*Dd*Pk2*f**2*k1**2*k2*r - 143*Dd*Pk2*f**2*k1**2*k2*s + 77*Dd*Pk2*f**2*k1**2*k2 - 440*Dd*Pk2*f**2*k1**2*r**2*np.sqrt(k2**2) - 308*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) + 616*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) + 55*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) - 121*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) - 264*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) + 418*Dd*Pk2*f**2*r*(k2**2)**(3/2) - 88*Dd*Pk2*f**2*(k2**2)**(3/2) - 3784*Dd*Pk2*f*g2*k1**2*k2*r*s + 1672*Dd*Pk2*f*g2*k1**2*k2*r + 242*Dd*Pk2*f*g2*k1**2*k2*s - 242*Dd*Pk2*f*g2*k1**2*k2 + 1144*Dd*Pk2*f*g2*k1**2*r*s*np.sqrt(k2**2) - 484*Dd*Pk2*f*g2*k1**2*r*np.sqrt(k2**2) - 66*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) + 66*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 180*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 302*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 135*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) + 98*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) - 308*Dd*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) + 154*Dd*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) + 55*Dd*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) - 33*Dd*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) + 1144*Dd*Pkd2*f*g2*k1**2*k2*r*s*np.sqrt(k2**2) - 484*Dd*Pkd2*f*g2*k1**2*k2*r*np.sqrt(k2**2) - 66*Dd*Pkd2*f*g2*k1**2*k2*s*np.sqrt(k2**2) + 66*Dd*Pkd2*f*g2*k1**2*k2*np.sqrt(k2**2) - 11*b2*k1**2*(13*D1*fd*r*(s - 1) + Dd*f*(r*(52*s - 22) - 3*s + 3))*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))) + f*(13*D1*bd1*(f**2*(6*Pk2*r*(27*r + 2)*(k2**2)**(3/2) + k1**2*(Pk2*(90*r**2 + r*(45*s - 149) - 156*s + 82)*np.sqrt(k2**2) + k2*(-3*Pk2*(177*r*s - 78*r - 156*s + 82) + Pkd2*(45*r*s - 78*r - 156*s + 82)*np.sqrt(k2**2)))) - 11*f*r*(2*Pk2*(3*r - 4)*(k2**2)**(3/2) + k1**2*(Pk2*(K*(7*s - 3) + 10*r + 7*s - 11)*np.sqrt(k2**2) + k2*(Pk2*(-25*K*s + 11*K - 17*s + 7) + Pkd2*(K + 1)*(7*s - 3)*np.sqrt(k2**2)))) + 22*g2*k1**2*(Pk2*(r*(13*s - 3) - 3*s + 3)*np.sqrt(k2**2) + k2*(Pk2*(-43*r*s + 11*r + 11*s - 11) + Pkd2*(13*r*s - 3*r - 3*s + 3)*np.sqrt(k2**2)))) - 143*b2*k1**2*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2))*(D1*bd1*(r*(13*s - 3) - 3*s + 3) + D1*fd*(14*r*s - 8*r - 5*s + 3) + Dd*f*(28*r*s - 14*r - 5*s + 3)) + k1**2*(D1*f**2*fd*(-26*Pk2*k2*(40*r*(17*s - 8) - 22*s + 43) + Pk2*(4*r - 1)*(1345*r + 1300*s - 996)*np.sqrt(k2**2) + 650*Pkd2*k2*(4*r - 1)*(2*s - 1)*np.sqrt(k2**2)) - 143*D1*f*r*(bd2*(7*s - 3)*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + 2*gd2*(Pk2*k2*(25*s - 11) + Pk2*(3 - 7*s)*np.sqrt(k2**2) + Pkd2*k2*(3 - 7*s)*np.sqrt(k2**2))) + 286*D1*fd*g2*(Pk2*(2*r*(7*s - 4) - 5*s + 3)*np.sqrt(k2**2) + k2*(Pk2*(-50*r*s + 30*r + 17*s - 11) + Pkd2*(14*r*s - 8*r - 5*s + 3)*np.sqrt(k2**2))) + Dd*f**3*(-26*Pk2*k2*(40*r*(17*s - 8) - 22*s + 43) + Pk2*(4*r - 1)*(1345*r + 1300*s - 996)*np.sqrt(k2**2) + 650*Pkd2*k2*(4*r - 1)*(2*s - 1)*np.sqrt(k2**2)) + 286*Dd*f*g2*(Pk2*(14*r*(2*s - 1) - 5*s + 3)*np.sqrt(k2**2) + k2*(Pk2*(-100*r*s + 52*r + 17*s - 11) + Pkd2*(28*r*s - 14*r - 5*s + 3)*np.sqrt(k2**2))))))/(3003*d**2*k1**2*k2*np.sqrt(k2**2)) + 2*D1**3*Pkd1*ct*(11*b1**3*(D1*fd*r*(3*Pk2*r*(k2**2)**(3/2) - k1**2*(Pk2*(-32*k2*s + 5*r*np.sqrt(k2**2) + 18*s*np.sqrt(k2**2)) + 18*Pkd2*k2*s*np.sqrt(k2**2))) + Dd*f*(3*Pk2*r*(4*r - 1)*(k2**2)**(3/2) + k1**2*(Pk2*(-20*r**2 + r*(7 - 72*s) + 16*s)*np.sqrt(k2**2) + 2*k2*(8*Pk2*r*(8*s - 1) - 8*Pk2*s + Pkd2*(-36*r*s + r + 8*s)*np.sqrt(k2**2))))) - 11*b1**2*(D1*(3*Pk2*bd1*f*r*(1 - 3*r)*(k2**2)**(3/2) + Pk2*fd*(f*(18*r**2 - 29*r + 10) + 14*r**2)*(k2**2)**(3/2) + bd1*f*k1**2*(Pk2*(15*r**2 + r*(54*s - 7) - 16*s)*np.sqrt(k2**2) - 2*k2*(8*Pk2*r*(6*s - 1) - 8*Pk2*s + Pkd2*(-27*r*s + r + 8*s)*np.sqrt(k2**2))) + fd*k1**2*(Pk2*(f*(k2*(-64*r*s + 18*r + 12*s) + (100*r**2 + 112*r*s - 85*r - 20*s + 18)*np.sqrt(k2**2)) - 4*k2*(-3*K*s + r*(10*K*s - 7*K + 6*s - 7) + s) + 2*(-2*K*s + 11*r**2 + r*(9*K*s - 7*K + 9*s - 15) - 2*s + 4)*np.sqrt(k2**2)) + 2*Pkd2*k2*(4*f*r*(14*s - 3) + r*(K + 1)*(9*s - 7) + s*(-2*K - 10*f - 2))*np.sqrt(k2**2))) + Dd*f*(Pk2*(4*r - 1)*(f*(9*r - 10) + 14*r)*(k2**2)**(3/2) + 2*k1**2*(Pk2*(K*(36*r*s - 29*r - 12*s + 8) + f*(100*r**2 + r*(112*s - 87) - 30*s + 16) + 44*r**2 + 36*r*s - 56*r - 12*s + 12)*np.sqrt(k2**2) + k2*(Pk2*(2*K*(-40*r*s + 19*r + 11*s - 5) + f*(r*(14 - 64*s) + 22*s - 5) - 48*r*s + 34*r + 2*s - 6) + Pkd2*(f*(2*r*(56*s - 13) - 30*s + 7) + (K + 1)*(r*(36*s - 29) - 12*s + 8))*np.sqrt(k2**2))))) - b1*(-132*D1*K*Pk2*f*fd*k1**2*k2*r*s + 198*D1*K*Pk2*f*fd*k1**2*k2*r + 44*D1*K*Pk2*f*fd*k1**2*k2*s - 88*D1*K*Pk2*f*fd*k1**2*k2 + 264*D1*K*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 264*D1*K*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) - 132*D1*K*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 132*D1*K*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 264*D1*K*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 264*D1*K*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) - 132*D1*K*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) + 132*D1*K*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) - 352*D1*Pk2*bd2*f*k1**2*k2*r*s + 154*D1*Pk2*bd2*f*k1**2*k2*r + 22*D1*Pk2*bd2*f*k1**2*k2*s + 198*D1*Pk2*bd2*f*k1**2*r*s*np.sqrt(k2**2) - 154*D1*Pk2*bd2*f*k1**2*r*np.sqrt(k2**2) - 22*D1*Pk2*bd2*f*k1**2*s*np.sqrt(k2**2) + 220*D1*Pk2*f**2*fd*k1**2*k2*r - 66*D1*Pk2*f**2*fd*k1**2*k2*s - 66*D1*Pk2*f**2*fd*k1**2*k2 + 1125*D1*Pk2*f**2*fd*k1**2*r**2*np.sqrt(k2**2) + 990*D1*Pk2*f**2*fd*k1**2*r*s*np.sqrt(k2**2) - 1179*D1*Pk2*f**2*fd*k1**2*r*np.sqrt(k2**2) - 330*D1*Pk2*f**2*fd*k1**2*s*np.sqrt(k2**2) + 268*D1*Pk2*f**2*fd*k1**2*np.sqrt(k2**2) - 132*D1*Pk2*f*fd*k1**2*k2*r*s + 198*D1*Pk2*f*fd*k1**2*k2*r + 44*D1*Pk2*f*fd*k1**2*k2*s - 88*D1*Pk2*f*fd*k1**2*k2 + 264*D1*Pk2*f*fd*k1**2*r**2*np.sqrt(k2**2) + 264*D1*Pk2*f*fd*k1**2*r*s*np.sqrt(k2**2) - 396*D1*Pk2*f*fd*k1**2*r*np.sqrt(k2**2) - 132*D1*Pk2*f*fd*k1**2*s*np.sqrt(k2**2) + 132*D1*Pk2*f*fd*k1**2*np.sqrt(k2**2) + 264*D1*Pk2*f*fd*r**2*(k2**2)**(3/2) - 132*D1*Pk2*f*fd*r*(k2**2)**(3/2) + 880*D1*Pk2*f*gd2*k1**2*k2*r*s - 308*D1*Pk2*f*gd2*k1**2*k2*r - 132*D1*Pk2*f*gd2*k1**2*k2*s - 396*D1*Pk2*f*gd2*k1**2*r*s*np.sqrt(k2**2) + 308*D1*Pk2*f*gd2*k1**2*r*np.sqrt(k2**2) + 44*D1*Pk2*f*gd2*k1**2*s*np.sqrt(k2**2) + 880*D1*Pk2*fd*g2*k1**2*k2*r*s - 616*D1*Pk2*fd*g2*k1**2*k2*r - 264*D1*Pk2*fd*g2*k1**2*k2*s - 396*D1*Pk2*fd*g2*k1**2*r*s*np.sqrt(k2**2) + 308*D1*Pk2*fd*g2*k1**2*r*np.sqrt(k2**2) + 88*D1*Pk2*fd*g2*k1**2*s*np.sqrt(k2**2) + 198*D1*Pkd2*bd2*f*k1**2*k2*r*s*np.sqrt(k2**2) - 154*D1*Pkd2*bd2*f*k1**2*k2*r*np.sqrt(k2**2) - 22*D1*Pkd2*bd2*f*k1**2*k2*s*np.sqrt(k2**2) + 990*D1*Pkd2*f**2*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 330*D1*Pkd2*f**2*fd*k1**2*k2*r*np.sqrt(k2**2) - 330*D1*Pkd2*f**2*fd*k1**2*k2*s*np.sqrt(k2**2) + 110*D1*Pkd2*f**2*fd*k1**2*k2*np.sqrt(k2**2) + 264*D1*Pkd2*f*fd*k1**2*k2*r*s*np.sqrt(k2**2) - 264*D1*Pkd2*f*fd*k1**2*k2*r*np.sqrt(k2**2) - 132*D1*Pkd2*f*fd*k1**2*k2*s*np.sqrt(k2**2) + 132*D1*Pkd2*f*fd*k1**2*k2*np.sqrt(k2**2) - 396*D1*Pkd2*f*gd2*k1**2*k2*r*s*np.sqrt(k2**2) + 308*D1*Pkd2*f*gd2*k1**2*k2*r*np.sqrt(k2**2) + 44*D1*Pkd2*f*gd2*k1**2*k2*s*np.sqrt(k2**2) - 396*D1*Pkd2*fd*g2*k1**2*k2*r*s*np.sqrt(k2**2) + 308*D1*Pkd2*fd*g2*k1**2*k2*r*np.sqrt(k2**2) + 88*D1*Pkd2*fd*g2*k1**2*k2*s*np.sqrt(k2**2) + 11*D1*bd1*f*(2*Pk2*r*(f*(9*r - 10) + 14*r - 7)*(k2**2)**(3/2) + k1**2*(Pk2*(2*K*(3*r*(6*s - 5) - 9*s + 8) + f*(100*r**2 + r*(112*s - 89) - 40*s + 14) + 44*r**2 + 12*r*(3*s - 5) - 18*s + 16)*np.sqrt(k2**2) - 2*k2*(Pk2*(K*(40*r*s - 17*r - 13*s + 10) + f*(r*(32*s - 5) - 16*s + 5) + 24*r*s - 13*r - 5*s + 6) + Pkd2*(f*(r*(14 - 56*s) + 20*s - 7) - (K + 1)*(3*r*(6*s - 5) - 9*s + 8))*np.sqrt(k2**2)))) - 264*Dd*K*Pk2*f**2*k1**2*k2*r*s + 462*Dd*K*Pk2*f**2*k1**2*k2*r - 44*Dd*K*Pk2*f**2*k1**2*k2*s - 88*Dd*K*Pk2*f**2*k1**2*k2 + 528*Dd*K*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 528*Dd*K*Pk2*f**2*k1**2*r*np.sqrt(k2**2) - 132*Dd*K*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 132*Dd*K*Pk2*f**2*k1**2*np.sqrt(k2**2) + 528*Dd*K*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) - 528*Dd*K*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) - 132*Dd*K*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) + 132*Dd*K*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) + 110*Dd*Pk2*f**3*k1**2*k2*r - 198*Dd*Pk2*f**3*k1**2*k2*s + 22*Dd*Pk2*f**3*k1**2*k2 + 1500*Dd*Pk2*f**3*k1**2*r**2*np.sqrt(k2**2) + 1320*Dd*Pk2*f**3*k1**2*r*s*np.sqrt(k2**2) - 1447*Dd*Pk2*f**3*k1**2*r*np.sqrt(k2**2) - 330*Dd*Pk2*f**3*k1**2*s*np.sqrt(k2**2) + 268*Dd*Pk2*f**3*k1**2*np.sqrt(k2**2) - 264*Dd*Pk2*f**2*k1**2*k2*r*s + 462*Dd*Pk2*f**2*k1**2*k2*r - 44*Dd*Pk2*f**2*k1**2*k2*s - 88*Dd*Pk2*f**2*k1**2*k2 + 528*Dd*Pk2*f**2*k1**2*r**2*np.sqrt(k2**2) + 528*Dd*Pk2*f**2*k1**2*r*s*np.sqrt(k2**2) - 660*Dd*Pk2*f**2*k1**2*r*np.sqrt(k2**2) - 132*Dd*Pk2*f**2*k1**2*s*np.sqrt(k2**2) + 132*Dd*Pk2*f**2*k1**2*np.sqrt(k2**2) + 528*Dd*Pk2*f**2*r**2*(k2**2)**(3/2) - 132*Dd*Pk2*f**2*r*(k2**2)**(3/2) + 3520*Dd*Pk2*f*g2*k1**2*k2*r*s - 1672*Dd*Pk2*f*g2*k1**2*k2*r - 968*Dd*Pk2*f*g2*k1**2*k2*s + 440*Dd*Pk2*f*g2*k1**2*k2 - 1584*Dd*Pk2*f*g2*k1**2*r*s*np.sqrt(k2**2) + 1276*Dd*Pk2*f*g2*k1**2*r*np.sqrt(k2**2) + 528*Dd*Pk2*f*g2*k1**2*s*np.sqrt(k2**2) - 352*Dd*Pk2*f*g2*k1**2*np.sqrt(k2**2) + 1320*Dd*Pkd2*f**3*k1**2*k2*r*s*np.sqrt(k2**2) - 440*Dd*Pkd2*f**3*k1**2*k2*r*np.sqrt(k2**2) - 330*Dd*Pkd2*f**3*k1**2*k2*s*np.sqrt(k2**2) + 110*Dd*Pkd2*f**3*k1**2*k2*np.sqrt(k2**2) + 528*Dd*Pkd2*f**2*k1**2*k2*r*s*np.sqrt(k2**2) - 528*Dd*Pkd2*f**2*k1**2*k2*r*np.sqrt(k2**2) - 132*Dd*Pkd2*f**2*k1**2*k2*s*np.sqrt(k2**2) + 132*Dd*Pkd2*f**2*k1**2*k2*np.sqrt(k2**2) - 1584*Dd*Pkd2*f*g2*k1**2*k2*r*s*np.sqrt(k2**2) + 1276*Dd*Pkd2*f*g2*k1**2*k2*r*np.sqrt(k2**2) + 528*Dd*Pkd2*f*g2*k1**2*k2*s*np.sqrt(k2**2) - 352*Dd*Pkd2*f*g2*k1**2*k2*np.sqrt(k2**2) + 22*b2*k1**2*(D1*fd*(Pk2*(r*(9*s - 7) - 2*s)*np.sqrt(k2**2) + k2*(2*Pk2*(-8*r*s + 7*r + s) + Pkd2*(9*r*s - 7*r - 2*s)*np.sqrt(k2**2))) + Dd*f*(Pk2*(r*(36*s - 29) - 12*s + 8)*np.sqrt(k2**2) + k2*(-4*Pk2*(16*r*s - 9*r - 3*s + 2) + Pkd2*(36*r*s - 29*r - 12*s + 8)*np.sqrt(k2**2))))) + f*(D1*bd1*(f**2*k1**2*(Pk2*r*(-375*r - 330*s + 268)*np.sqrt(k2**2) + 22*k2*(Pk2*(5*r + 6*s - 4) + 5*Pkd2*r*(1 - 3*s)*np.sqrt(k2**2))) - 22*f*(6*Pk2*r**2*(k2**2)**(3/2) + k1**2*(6*Pk2*r*(K*(s - 1) + r + s - 1)*np.sqrt(k2**2) - k2*(K + 1)*(3*Pk2*r*(s - 2) + 2*Pk2*s - 6*Pkd2*r*(s - 1)*np.sqrt(k2**2)))) + 44*g2*k1**2*(Pk2*(r*(9*s - 8) - 8*s + 8)*np.sqrt(k2**2) + k2*(-10*Pk2*(2*r*s - r - s + 1) + Pkd2*(9*r*s - 8*r - 8*s + 8)*np.sqrt(k2**2)))) - 22*b2*k1**2*(D1*bd1*(Pk2*(r*(9*s - 8) - 8*s + 8)*np.sqrt(k2**2) + k2*(8*Pk2*(-2*r*s + r + s - 1) + Pkd2*(9*r*s - 8*r - 8*s + 8)*np.sqrt(k2**2))) + D1*fd*(Pk2*k2*(-6*r*s + 9*r + 2*s - 4) + 6*Pk2*(2*r - 1)*(s - 1)*np.sqrt(k2**2) + 6*Pkd2*k2*(2*r - 1)*(s - 1)*np.sqrt(k2**2)) + Dd*f*(6*Pk2*(4*r - 1)*(s - 1)*np.sqrt(k2**2) - k2*(Pk2*(12*r*s - 21*r + 2*s + 4) + 6*Pkd2*(-4*r*s + 4*r + s - 1)*np.sqrt(k2**2)))) + 22*k1**2*(D1*(-f*(bd2 - 2*gd2)*(Pk2*k2*(-3*r*(s - 2) - 2*s) + 6*Pk2*r*(s - 1)*np.sqrt(k2**2) + 6*Pkd2*k2*r*(s - 1)*np.sqrt(k2**2)) + 2*fd*g2*(Pk2*k2*(-6*r*s + 9*r + 2*s - 4) + 6*Pk2*(2*r - 1)*(s - 1)*np.sqrt(k2**2) + 6*Pkd2*k2*(2*r - 1)*(s - 1)*np.sqrt(k2**2))) + 2*Dd*f*g2*(6*Pk2*(4*r - 1)*(s - 1)*np.sqrt(k2**2) - k2*(Pk2*(12*r*s - 21*r + 2*s + 4) + 6*Pkd2*(-4*r*s + 4*r + s - 1)*np.sqrt(k2**2))))))/(231*d**2*k1**2*k2*np.sqrt(k2**2)) + 2*D1**3*Pkd1*ct*st**2*(33*D1*bd1*f*(b1*(8*Pk2*k2**5*r*(2*r - 1) + k1**4*(r*(22*s - 9) - 2*s)*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(-4*Pk2*(-C*s + r**2*(22*C - 28) + r*(4*C*(s - 3) - 4*s + 15) + s) + Pkd2*k2*(-6*C*s + r*(52*C*s - 20*C + 22*s - 9) - 2*s))*(k2**2)**(3/2)) + f*(-2*Pk2*k2**5*r + k1**4*(Pk2*(2*C*(r*(7*s - 3) - 5*s + 3) + 14*r**2 + r*(2*s - 13) + 3*s - 2)*np.sqrt(k2**2) + k2*(Pk2*(C*(-50*r*s + 22*r + 34*s - 22) + 44*r*s - 11*r - 19*s + 14) + Pkd2*(2*C*(7*r*s - 3*r - 5*s + 3) + 2*r*s + r + 3*s - 2)*np.sqrt(k2**2))) + k1**2*(2*Pk2*(r**2*(14*C + 11) + r*(56*C*s - 18*C + 25*s - 8) - 3*s + 2) + Pkd2*k2*(2*C*(r*s + r + 6*s - 3) + 2*r*s + r + 3*s - 2))*(k2**2)**(3/2))) + 33*b1**2*(D1*fd*r*(Pk2*k1**2*(11*k1**2*s + k2**2*(-44*C*r - 8*C*s + 56*r + 8*s))*np.sqrt(k2**2) + 8*Pk2*k2**5*r + Pkd2*k1**2*k2**3*s*(26*C + 11)*np.sqrt(k2**2) + 11*k1**4*k2*s*(-3*Pk2 + Pkd2*np.sqrt(k2**2))) + Dd*f*(8*Pk2*k2**5*r*(4*r - 1) + k1**4*(r*(44*s - 9) - 2*s)*(-3*Pk2*k2 + Pk2*np.sqrt(k2**2) + Pkd2*k2*np.sqrt(k2**2)) + k1**2*(-4*Pk2*(-C*s + r**2*(44*C - 56) + r*(8*C*s - 12*C - 8*s + 15) + s) + Pkd2*k2*(-6*C*s + r*(4*C*(26*s - 5) + 44*s - 9) - 2*s))*(k2**2)**(3/2))) + 33*b1*f*(2*D1*fd*(Pk2*k1**2*(2*k1**2*(7*r**2 + r*(7*C*s - 4*C + s + 1) - s) + k2**2*(2*C*(14*r**2 + 7*r*(8*s - 3) + s - 2) + 22*r**2 + 50*r*s - 53*r - 2*s + 8))*np.sqrt(k2**2) + Pk2*k2**5*(4 - 11*r) + Pkd2*k1**2*k2**3*(2*r*(C*(s + 3) + s + 1) - s*(5*C + 2))*np.sqrt(k2**2) + 2*k1**4*k2*(Pk2*(r*(-25*C*s + 15*C + 22*s - 17) + 3*s) + Pkd2*(r*(7*C*s - 4*C + s + 1) - s)*np.sqrt(k2**2))) + Dd*f*(8*Pk2*k2**5*(1 - 4*r) + k1**4*(Pk2*(2*C*(14*r*(2*s - 1) - 5*s + 3) + 56*r**2 + r*(8*s - 7) - s - 2)*np.sqrt(k2**2) + k2*(Pk2*(C*(-200*r*s + 104*r + 34*s - 22) + 176*r*s - 93*r - 7*s + 14) + Pkd2*(2*C*(28*r*s - 14*r - 5*s + 3) + 8*r*s + 7*r - s - 2)*np.sqrt(k2**2))) + k1**2*(2*Pk2*(2*C*(28*r**2 + 28*r*(4*s - 1) + s - 2) + 44*r**2 + 100*r*s - 71*r - 5*s + 10) + Pkd2*k2*(2*C*(4*r*s + 10*r + s - 3) + 8*r*s + 7*r - s - 2))*(k2**2)**(3/2))) + f**2*(D1*fd*(198*Pk2*k2**5*r*(1 - 3*r) + k1**4*(Pk2*(6*C*(r*(153*s - 73) - 29*s + 17) + (3*r - 1)*(108*r - 99*s + 74))*np.sqrt(k2**2) + k2*(Pk2*(-22*C*(15*r*(9*s - 5) - 21*s + 17) + 3*r*(675*s - 478) - 147*s + 302) + 3*Pkd2*(2*C*(r*(153*s - 73) - 29*s + 17) + 11*r*(6 - 9*s) + 33*s - 22)*np.sqrt(k2**2))) - 3*k1**2*(2*Pk2*(4*C*(18*r**2 - 3*r*(33*s + 4) + 13) + 261*r**2 - 153*r*s + 9*r - 15*s - 10) + 11*Pkd2*k2*(3*r - 1)*(6*C*(2*s - 1) + 3*s - 2))*(k2**2)**(3/2)) + Dd*f*(198*Pk2*k2**5*r*(1 - 4*r) + k1**4*(Pk2*(6*C*(r*(204*s - 98) - 21*s + 17) + (4*r - 1)*(108*r - 99*s + 74))*np.sqrt(k2**2) + k2*(Pk2*(-22*C*(20*r*(9*s - 5) - 13*s + 17) + 4*r*(675*s - 454) - 67*s + 302) + 3*Pkd2*(2*C*(r*(204*s - 98) - 21*s + 17) + (11 - 44*r)*(3*s - 2))*np.sqrt(k2**2))) - 3*k1**2*(2*Pk2*(4*C*(24*r**2 - 132*r*s - 25*r + 13) + 348*r**2 - 204*r*s + 27*r - 23*s - 10) + 11*Pkd2*k2*(4*r - 1)*(6*C*(2*s - 1) + 3*s - 2))*(k2**2)**(3/2))))/(693*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 4*D1**3*Pkd1*ct*(D1*bd1*f*(b1*(7*Pk2*k2**5*r*(2*r - 1) + k1**4*(Pk2*(16*r**2 + 2*r*(C*(4*s - 1) + 7*s - 4) - s*(2*C + 7))*np.sqrt(k2**2) + k2*(-Pk2*(6*C + 1)*(r*(4*s - 1) - s) + Pkd2*(C*r*(8*s - 2) - 2*C*s + s*(14*r - 7))*np.sqrt(k2**2))) + k1**2*(Pk2*(r**2*(78 - 36*C) + r*(4*C*(7*s + 8) + 22*s - 34) - s*(28*C + 16)) + Pkd2*k2*s*(14*C + 7)*(2*r - 1))*(k2**2)**(3/2)) + f*(6*Pk2*k2**5*r**2 + k1**4*(2*Pk2*(C*(2*r*(5*s - 4) - 7*s + 7) + 3*r*(5*r + s - 3))*np.sqrt(k2**2) + k2*(Pk2*(-6*C*(r*(5*s - 4) - 3*s + 3) + 3*r*(7*s - 5) - 8*s + 8) + 2*Pkd2*(C*(2*r*(5*s - 4) - 7*s + 7) + 3*r*s)*np.sqrt(k2**2))) + k1**2*(Pk2*(C*(26*r**2 + 6*r*(5*s - 7) - 4*s + 4) + 52*r**2 + 23*r*s - 21*r - 4*s + 4) + Pkd2*k2*r*s*(12*C + 6))*(k2**2)**(3/2))) + b1**2*(D1*fd*r*(Pk2*k1**2*(k1**2*(4*C*s + 8*r + 7*s) + k2**2*(-18*C*r + 14*C*s + 39*r + 11*s))*np.sqrt(k2**2) + 7*Pk2*k2**5*r + Pkd2*k1**2*k2**3*s*(14*C + 7)*np.sqrt(k2**2) + k1**4*k2*s*(Pk2*(-12*C - 2) + Pkd2*(4*C + 7)*np.sqrt(k2**2))) + Dd*f*(7*Pk2*k2**5*r*(4*r - 1) + k1**4*(Pk2*(32*r**2 + 2*r*(C*(8*s - 1) + 14*s - 4) - s*(2*C + 7))*np.sqrt(k2**2) + k2*(-Pk2*(6*C + 1)*(r*(8*s - 1) - s) + Pkd2*(2*C*r*(8*s - 1) - 2*C*s + s*(28*r - 7))*np.sqrt(k2**2))) + k1**2*(-2*Pk2*(r**2*(36*C - 78) - r*(4*C*(7*s + 4) + 22*s - 17) + s*(14*C + 8)) + Pkd2*k2*s*(14*C + 7)*(4*r - 1))*(k2**2)**(3/2))) + b1*f*(2*D1*fd*(3*Pk2*k2**5*r*(2*r - 1) + k1**4*(Pk2*(C*k2*(r*(9 - 30*s) + 12*s) + 4*C*(r*(5*s - 3) - s)*np.sqrt(k2**2) + 21*k2*r*s - 11*k2*s + 30*r**2*np.sqrt(k2**2) + 6*r*(s - 4)*np.sqrt(k2**2) - 3*s*np.sqrt(k2**2) + 6*np.sqrt(k2**2)) + Pkd2*k2*(4*C*r*(5*s - 3) - 4*C*s + s*(6*r - 3))*np.sqrt(k2**2)) + k1**2*(Pk2*(C*(26*r**2 + 30*r*s - 49*r - 16*s + 18) + 52*r**2 + 23*r*s - 31*r - 12*s + 4) + Pkd2*k2*s*(6*C + 3)*(2*r - 1))*(k2**2)**(3/2)) + Dd*f*(6*Pk2*k2**5*r*(4*r - 1) + k1**4*(2*Pk2*(C*(r*(40*s - 26) - 12*s + 7) + (12*r - 3)*(5*r + s - 2))*np.sqrt(k2**2) + k2*(Pk2*(-6*C*(20*r*s - 9*r - 8*s + 3) + 84*r*s - 15*r - 38*s + 8) + 2*Pkd2*(C*(40*r*s - 26*r - 12*s + 7) + s*(12*r - 3))*np.sqrt(k2**2))) + k1**2*(Pk2*(8*C*(13*r**2 + 15*r*s - 22*r - 5*s + 5) + 208*r**2 + 92*r*s - 91*r - 32*s + 12) + Pkd2*k2*s*(12*C + 6)*(4*r - 1))*(k2**2)**(3/2))) + f**2*k1**2*(2*C*k1**2*(D1*fd*(Pk2*k2*(10*r - s - 3) + 5*Pk2*(3*r - 1)*(s - 1)*np.sqrt(k2**2) + 5*Pkd2*k2*(3*r - 1)*(s - 1)*np.sqrt(k2**2)) + Dd*f*(3*Pk2*k2*(5*r - s - 1) + 5*Pk2*(4*r - 1)*(s - 1)*np.sqrt(k2**2) + 5*Pkd2*k2*(4*r - 1)*(s - 1)*np.sqrt(k2**2))) + 5*Pk2*r*(k1**2 + k2**2)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))*np.sqrt(k2**2)))/(21*d**2*k1**2*k2*k3**2*np.sqrt(k2**2)) - 5*D1**3*Pkd1*f**2*st**6*(4*Pk2 - Pkd2*k2)*(13*D1*bd1*f*(r*(21*s + 2) + 6*s - 2) + 13*b1*(21*D1*fd*r*(3*s - 1) + Dd*f*(84*r*s - 19*r + 6*s - 2)) + f*(87*r - 38)*(4*s - 1)*(D1*fd + Dd*f))/(9009*d**2*np.sqrt(k1**2)) + 2*D1**3*Pkd1*f*st**4*(13*D1*bd1*f*(33*b1*r*(2*Pk2*(-4*k1*s*np.sqrt(k1**2) + k2**2*(1 - 4*s))*np.sqrt(k2**2) + Pkd2*k2**2*(2*k1*s*np.sqrt(k1**2) + k2*(4*s - 1)*np.sqrt(k2**2))) + f*(-2*k1*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*(2*r*(6*s - 1) - 4*s + 1)*np.sqrt(k1**2) + (Pk2*(108*r**2 + r*(117*s - 112) + 8*s - 4) + 2*Pkd2*k2*(4*r*(3*s - 1) - 2*s + 1))*(k2**2)**(3/2))) + 429*b1**2*r*(D1*fd*(-k1*(2*s - 1)*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*np.sqrt(k1**2) + (-2*Pk2 + Pkd2*k2)*(4*s - 1)*(k2**2)**(3/2)) + Dd*f*(4*s - 1)*(k1*(-4*Pk2*np.sqrt(k2**2) + Pkd2*k2**2)*np.sqrt(k1**2) + 2*(-2*Pk2 + Pkd2*k2)*(k2**2)**(3/2))) + 13*b1*f*(D1*fd*(-4*k1*(6*r - 1)*(3*s - 1)*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*np.sqrt(k1**2) + (Pk2*(324*r**2 + r*(351*s - 345) + 48*s + 48) + 4*Pkd2*k2*(3*r - 1)*(6*s - 1))*(k2**2)**(3/2)) + Dd*f*(-2*k1*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*(2*r*(24*s - 7) - 10*s + 3)*np.sqrt(k1**2) + (Pk2*(432*r**2 + r*(468*s - 457) + 56*s + 44) + 2*Pkd2*k2*(2*r*(24*s - 5) - 14*s + 3))*(k2**2)**(3/2))) + f**2*(D1*fd + Dd*f)*(-k1*(95*r - 14)*(4*s - 1)*(4*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*np.sqrt(k1**2) + (Pk2*(64*r**2 + r*(2340*s - 1319) - 650*s + 342) - 13*Pkd2*k2*(4*r - 1)*(5*s - 2))*(k2**2)**(3/2)))/(3003*d**2*np.sqrt(k1**2)*(k2**2)**(3/2)) - 4*D1**3*Pkd1*f*st**4*(D1*(-66*b1*fd*r*(-C*k1*(2*Pk2 - Pkd2*k2)*(2*s - 1)*np.sqrt(k1**2) + Pk2*r*(k1*np.sqrt(k1**2) + k2**2)) + f*(-33*bd1*r*(Pk2*k2**2*(r - 1) + k1*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r - 1))*np.sqrt(k1**2)) - 2*fd*(3*r - 1)*(Pk2*k2**2*(18*C*r - 28*C + 6*r + 3*s - 3) + k1*(4*C*Pkd2*k2*(3*s - 1) + Pk2*(-24*C*s + 8*C + 6*r + 3*s - 3))*np.sqrt(k1**2)))) + Dd*f*(-33*Pk2*b1*k2**2*r*(4*r - 1) - Pk2*f*k2**2*(4*C*(36*r**2 - 65*r + 14) + 48*r**2 + r*(24*s - 35) - 7*s + 6) + 33*b1*k1*r*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2)*np.sqrt(k1**2) + f*k1*(4*C*Pkd2*k2*(r*(7 - 24*s) + 7*s - 2) + Pk2*(8*C*(24*r*s - 7*r - 7*s + 2) - 48*r**2 - 24*r*s + 35*r + 7*s - 6))*np.sqrt(k1**2)))/(231*d**2*k3**2*np.sqrt(k1**2)) + D1**3*Pkd1*st**2*(33*b1**3*(D1*fd*r*(-2*Pk2*(11*k1*s*np.sqrt(k1**2) + k2**2*r)*np.sqrt(k2**2) + 11*Pkd2*k2**2*s*(k1*np.sqrt(k1**2) + k2*np.sqrt(k2**2))) + Dd*f*(-k1*(2*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*(r*(44*s - 9) - 2*s)*np.sqrt(k1**2) + (2*Pk2*r*(1 - 4*r) + Pkd2*k2*(44*r*s - 9*r - 2*s))*(k2**2)**(3/2))) - 33*b1**2*(2*D1*Pk2*fd*r*(-2*k1*(s - 1)*np.sqrt(k1**2) + k2**2*(K*r + r - 2*s + 2))*np.sqrt(k2**2) + D1*f*(-2*Pk2*fd*(k1*(r*(16*s - 19) + 4*s)*np.sqrt(k1**2) + 6*k2**2*(4*r**2 + 5*r*(2*s - 1) + 1))*np.sqrt(k2**2) + 2*Pkd2*fd*k2*(k1*(-10*k2*r*s + 2*k2*s + r*(3*s - 2)*np.sqrt(k2**2))*np.sqrt(k1**2) + (r*(s - 2) + 2*s)*(k2**2)**(3/2)) + bd1*k1*(2*Pk2*np.sqrt(k2**2) - Pkd2*k2**2)*(r*(33*s - 9) - 2*s)*np.sqrt(k1**2) + bd1*(2*Pk2*r*(3*r - 1) + Pkd2*k2*(r*(9 - 33*s) + 2*s))*(k2**2)**(3/2)) + Dd*f*k1*(-2*Pk2*(f*(r*(32*s - 21) + 5*s + 2) + r*(8*s - 5) - s + 1)*np.sqrt(k2**2) + Pkd2*f*k2*(k2*r*(2 - 40*s) + 8*k2*s + (4*r - 1)*(3*s - 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) + Dd*f*(-2*Pk2*(6*f*(8*r**2 + r*(20*s - 11) + 1) - r**2*(4*K + 4) + r*(K + 8*s - 4) - s + 1) + Pkd2*f*k2*(r*(4*s - 7) - 2*s + 2))*(k2**2)**(3/2)) + b1*(-33*D1*bd1*f*(k1*(-2*Pk2*(f*(2*r*(8*s - 1) + s + 2) + r*(4*s - 2) - s + 1)*np.sqrt(k2**2) + Pkd2*f*k2*(k2*r*(2 - 20*s) + 4*k2*s + (2*r - 1)*(3*s - 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) + (-2*Pk2*(r**2*(-2*K + 24*f - 2) + r*(K + 60*f*s - 36*f + 4*s - 1) - s + 1) + Pkd2*f*k2*(r*(2*s - 3) - 6*s + 2))*(k2**2)**(3/2)) - 3*D1*(-22*Pk2*f*(fd*k1*(r*(4*s - 3) - s + 1)*np.sqrt(k1**2) + fd*k2**2*(3*K*(2*r**2 - 5*r + 2) + 6*r**2 + 2*r*(2*s - 9) - s + 7) - k2**2*r**2*(bd2 - 2*gd2))*np.sqrt(k2**2) + 22*Pk2*fd*r**2*(b2 - 2*g2)*(k2**2)**(3/2) + f**2*fd*(k1*(-2*Pk2*(9*r*(29*s - 22) + s + 22)*np.sqrt(k2**2) + Pkd2*k2*(-135*k2*r*s + 34*k2*s + 66*r*(3*s - 2)*np.sqrt(k2**2) + 11*(2 - 3*s)*np.sqrt(k2**2)))*np.sqrt(k1**2) + 2*(3*Pk2*(81*r**2 - 2*r*(33*s + 5) - 2) + 11*Pkd2*k2*(3*r - 1)*(3*s - 1))*(k2**2)**(3/2))) + Dd*f*(66*Pk2*f*(k1*(r*(8*s - 5) - s + 1)*np.sqrt(k1**2) + k2**2*(3*K*(4*r**2 - 9*r + 2) + 12*r**2 + 8*r*(s - 4) - s + 7))*np.sqrt(k2**2) + Pk2*r*(-66*b2 + 132*g2)*(4*r - 1)*(k2**2)**(3/2) + f**2*(k1*(2*Pk2*(3*r*(348*s - 247) - 112*s + 148)*np.sqrt(k2**2) + Pkd2*k2*(k2*(540*r*s + 15*r - 86*s - 16) - 66*(4*r - 1)*(3*s - 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) - 6*(3*Pk2*(108*r**2 + r*(3 - 88*s) - 2) + 11*Pkd2*k2*(4*r - 1)*(3*s - 1))*(k2**2)**(3/2)))) + f*(D1*bd1*(66*Pk2*f*r*(k1*(2*s - 1)*np.sqrt(k1**2) + k2**2*(3*K*(r - 2) + 3*r + 2*s - 7))*np.sqrt(k2**2) + Pk2*r*(-66*b2 + 132*g2)*(r - 1)*(k2**2)**(3/2) + f**2*(k1*(2*Pk2*(3*r*(87*s - 49) - 115*s + 82)*np.sqrt(k2**2) + Pkd2*k2*(15*k2*r*(9*s + 1) + 16*k2*(s - 1) - 33*(2*r - 1)*(3*s - 2)*np.sqrt(k2**2)))*np.sqrt(k1**2) - 6*r*(Pk2*(81*r - 66*s + 39) + 11*Pkd2*k2*(3*s - 1))*(k2**2)**(3/2))) + (198*D1*Pk2*f*k2**2*r*(bd2 - 2*gd2)*(r - 2) + 198*D1*Pk2*fd*k2**2*(b2 - 2*g2)*(2*r**2 - 5*r + 2) + D1*f**2*fd*k1*(Pk2*(10*r*(72*s - 43) + 42*s + 52) - 25*Pkd2*k2*(4*r - 1)*(3*s - 2))*np.sqrt(k1**2) + 198*Dd*Pk2*f*k2**2*(b2 - 2*g2)*(4*r**2 - 9*r + 2) + Dd*f**3*k1*(Pk2*(10*r*(72*s - 43) + 42*s + 52) - 25*Pkd2*k2*(4*r - 1)*(3*s - 2))*np.sqrt(k1**2))*np.sqrt(k2**2)))/(693*d**2*np.sqrt(k1**2)*(k2**2)**(3/2)) - 2*D1**3*Pkd1*(D1*bd1*f*(Pk2*k2**2*r*(4*b2 - 8*g2)*(r - 1) + f**2*k1*(Pk2*(5*r - 2)*(s - 1) + 5*Pkd2*k2*r*s)*np.sqrt(k1**2)) + b1**3*(D1*fd*r*(-7*Pk2*k1*s*np.sqrt(k1**2) + Pk2*k2**2*(4*r + 7*s) + 7*Pkd2*k1*k2*s*np.sqrt(k1**2) + 7*Pkd2*k2**3*s) + Dd*f*(-7*k1*(Pk2*r*(4*s - 1) + Pkd2*k2*s*(1 - 4*r))*np.sqrt(k1**2) + k2**2*(Pk2*(16*r**2 + 28*r*s + 3*r - 14*s) + 7*Pkd2*k2*s*(4*r - 1)))) + b1**2*(D1*bd1*f*(-7*k1*(Pk2*r*(3*s - 1) + Pkd2*k2*s*(1 - 3*r))*np.sqrt(k1**2) + k2**2*(Pk2*(12*r**2 + 21*r*s + 3*r - 14*s) + 7*Pkd2*k2*s*(3*r - 1))) + 2*D1*fd*(2*Pk2*k1*s*(f*(3*r - 1) + r - 1)*np.sqrt(k1**2) + Pk2*k2**2*(f*(24*r**2 + 3*r*(5*s - 8) - 8*s + 6) + (2*r - 2)*(K*(r - 1) + r + s - 1)) + 3*Pkd2*f*k1*k2*s*(4*r - 1)*np.sqrt(k1**2) + 3*Pkd2*f*k2**3*s*(2*r - 1)) + 2*Dd*f*k1*(Pk2*(f*(3*r - 1)*(4*s - 1) + 8*r*s - r - 5*s + 1) + 6*Pkd2*f*k2*s*(4*r - 1))*np.sqrt(k1**2) + Dd*f*k2**2*(Pk2*f*(96*r**2 + 15*r*(4*s - 5) - 20*s + 14) + 2*Pk2*(2*K*(4*r**2 - 5*r + 1) + 8*r**2 + r*(8*s - 11) - 5*s + 3) + 6*Pkd2*f*k2*s*(4*r - 1))) + b1*(D1*bd1*f*(2*k1*(Pk2*(f*(3*r - 1)*(2*s - 1) + 4*r*s - r - 2*s + 1) + 3*Pkd2*f*k2*s*(4*r - 1))*np.sqrt(k1**2) + k2**2*(Pk2*(f*(48*r**2 + 3*r*(10*s - 9) - 4*s + 2) + r**2*(8*K + 8) - 2*r*(4*K - 4*s + 5) - 4*s + 2) + 12*Pkd2*f*k2*r*s)) + D1*(4*Pk2*b2*fd*k2**2*(r - 1)**2 + 4*Pk2*f*k2**2*r*(bd2 - 2*gd2)*(r - 1) - 8*Pk2*fd*g2*k2**2*(r - 1)**2 + f**2*fd*k1*s*(3*Pk2*(5*r - 2) + 5*Pkd2*k2*(3*r - 1))*np.sqrt(k1**2)) + 4*Dd*Pk2*f*k2**2*(b2 - 2*g2)*(4*r**2 - 5*r + 1) + Dd*f**3*k1*(Pk2*(5*r - 2)*(4*s - 1) + 5*Pkd2*k2*s*(4*r - 1))*np.sqrt(k1**2)))/(21*d**2*k2**2*np.sqrt(k1**2)) + 2*D1**3*Pkd1*st**2*(33*D1*bd1*f*(-b1*k2**2*(Pk2*k2**2*(r**2*(4*C - 22) - 2*r*(C + 2*s - 6) + s) + k1*(2*C*Pkd2*k2*(r*(9 - 22*s) + 2*s) + Pk2*(-22*r**2 - 4*r*(s - 3) + s))*np.sqrt(k1**2)) + f*(Pk2*k1**4*(r*(2*s - 1) - s + 1) + 2*Pk2*k2**4*r*(3*C*(r - 2) + r + s) + k1*k2**2*(2*C*Pkd2*k2*(2*r*s + r + 3*s - 2) + Pk2*(r**2*(14*C + 2) + r*(60*C*s - 14*C + 4*s - 1) - s + 1))*np.sqrt(k1**2))) + 33*b1**2*k2**2*(D1*fd*r*(Pk2*k2**2*(-2*C*r + 11*r + 2*s) + k1*(22*C*Pkd2*k2*s + 11*Pk2*r + 2*Pk2*s)*np.sqrt(k1**2)) + Dd*f*(-Pk2*k2**2*(r**2*(8*C - 44) - 2*r*(C + 4*s - 6) + s) + k1*(2*C*Pkd2*k2*(44*r*s - 9*r - 2*s) + Pk2*(44*r**2 + 8*r*s - 12*r - s))*np.sqrt(k1**2))) + 33*b1*f*(D1*fd*(Pk2*k1**4*r*(4*s - 3) + Pk2*k2**4*(6*C*(2*r**2 - 5*r + 2) + (4*r - 1)*(r + s - 2)) + k1*k2**2*(8*C*Pkd2*k2*(r*s + r - s) + Pk2*(r**2*(28*C + 4) + 4*r*(30*C*s - 15*C + 2*s - 3) - s + 2))*np.sqrt(k1**2)) + Dd*f*(Pk2*k1**4*(r*(8*s - 5) - s + 1) + Pk2*k2**4*(6*C*(4*r**2 - 9*r + 2) + 8*r**2 + r*(8*s - 11) - s + 2) + k1*k2**2*(2*C*Pkd2*k2*(r*(8*s + 7) - s - 2) + Pk2*(r**2*(56*C + 8) + 2*r*(120*C*s - 37*C + 8*s - 8) - 2*s + 3))*np.sqrt(k1**2))) + f**2*(D1*fd*(Pk2*k1**4*(6*r*(9*s - 14) + 15*s + 17) + 99*Pk2*k2**4*r*(1 - 3*r) + k1*k2**2*(-66*C*Pkd2*k2*(3*r - 1)*(3*s - 2) + Pk2*(-2*C*(135*r**2 - 594*r*s + 75*r + 26) - 297*r**2 + 54*r*s + 15*r + 15*s + 17))*np.sqrt(k1**2)) + Dd*f*(Pk2*k1**4*(r*(72*s - 109) + 23*s + 17) + 99*Pk2*k2**4*r*(1 - 4*r) + k1*k2**2*(-66*C*Pkd2*k2*(4*r - 1)*(3*s - 2) + Pk2*(-2*C*(180*r**2 - 792*r*s + 49*r + 26) - 396*r**2 + 72*r*s - 10*r + 23*s + 17))*np.sqrt(k1**2))))/(693*d**2*k2**2*k3**2*np.sqrt(k1**2)) - 4*D1**3*Pkd1*(D1*bd1*f*(b1*(Pk2*k1**4*(r*(4*s - 1) - s) + 7*Pk2*k2**4*r*(2*r - 1) + k1*k2**2*(14*C*Pkd2*k2*s*(2*r - 1) + Pk2*(r**2*(24*C + 14) + 2*r*(14*C*s + C + 2*s - 4) - s*(28*C + 1)))*np.sqrt(k1**2)) + f*(Pk2*k1**4*(r*(4*s - 2) - s + 1) + 6*Pk2*k2**4*r**2 + k1*k2**2*(12*C*Pkd2*k2*r*s + Pk2*(C*(40*r**2 + 30*r*s - 26*r - 4*s + 4) + 6*r**2 + 4*r*s - 2*r - s + 1))*np.sqrt(k1**2))) + b1*(D1*fd*(2*C*k1*k2**2*(2*Pk2*f*(20*r**2 + 5*r*(3*s - 4) - 8*s + 5) + 6*Pkd2*f*k2*s*(2*r - 1) + b1*r*(6*Pk2*r + 7*Pk2*s + 7*Pkd2*k2*s))*np.sqrt(k1**2) + Pk2*(b1*r*(2*k1**4*s + k1*k2**2*(7*r + 2*s)*np.sqrt(k1**2) + 7*k2**4*r) + 2*f*(2*r - 1)*(2*k1**4*s + k1*k2**2*(3*r + 2*s)*np.sqrt(k1**2) + 3*k2**4*r))) + Dd*f*(b1*(Pk2*k1**4*(r*(8*s - 1) - s) + 7*Pk2*k2**4*r*(4*r - 1) + k1*k2**2*(14*C*Pkd2*k2*s*(4*r - 1) + Pk2*(r**2*(48*C + 28) + 2*r*(28*C*s + C + 4*s - 4) - s*(28*C + 1)))*np.sqrt(k1**2)) + f*(Pk2*k1**4*(2*r*(8*s - 1) - 6*s + 1) + 6*Pk2*k2**4*r*(4*r - 1) + k1*k2**2*(12*C*Pkd2*k2*s*(4*r - 1) + Pk2*(2*C*(80*r**2 + 60*r*s - 63*r - 20*s + 12) + 24*r**2 + 16*r*s - 8*r - 6*s + 1))*np.sqrt(k1**2)))))/(21*d**2*k2**2*k3**2*np.sqrt(k1**2))
        perm13 = 32*D1**3*Pk1*Pk3*b1*ct*st**4*(s - 1)*(D1*b1*fd*(s - 1) + 2*D1*bd1*f*s + 2*Dd*b1*f*(2*s - 1))/(7*d**2*k1*k2) - 8*D1**3*Pk1*Pk3*b1*st**4*(D1*bd1*f*(k1**2*s*(16*C - 8)*(s - 1) + k2**2*(r*(4*s - 2) - s + 1)) + b1*(2*D1*fd*(s - 1)*(k1**2*(4*C - 2)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(16*C - 8)*(2*s**2 - 3*s + 1) + k2**2*(r*(8*s - 6) - s + 1))))/(7*d**2*k1**2*k2**2) - D1**3*Pk1*Pk3*ct**8*f*k2**6*(320*C - 320)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(51*r + 51*s - 23))/(231*d**2*k3**8) - D1**3*Pk1*Pk3*ct**8*f*k2**4*(320*C - 320)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) + Dd*f*(r*(408*s - 214) + 408*s**2 - 459*s + 130)))/(693*d**2*k3**6) - D1**3*Pk1*Pk3*ct**8*f*k2**2*(320*C - 320)*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(153*s**2 - 135*s + 28) + 2*Dd*f*(102*s**2 - 107*s + 28)))/(693*d**2*k3**4) - 16*D1**3*Pk1*Pk3*ct**7*f*k2**5*(13*D1*bd1*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(r + s - 1) + 13*b1*(D1*fd*(5*f*k2**2*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + 66*k1**2*(2*r + 2*s - 1)*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43)) + Dd*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(4*r + 4*s - 3)) + 10*f*(D1*fd*(21*f*k2**2*(136*r**2 + 2*r*(136*s - 89) + 136*s**2 - 178*s + 57) + 13*k1**2*(3*r + 3*s - 2)*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187)) + Dd*f*(21*f*k2**2*(34*r + 34*s - 19) + 13*k1**2*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187))*(4*r + 4*s - 3)))/(3003*d**2*k1*k3**8) - 32*D1**3*Pk1*Pk3*ct**7*f*k2**3*(33*D1*bd1*f*(k1**2*(2*C*(76*r*s - 25*r + 76*s**2 - 88*s + 25) - 132*r*s + 45*r - 132*s**2 + 156*s - 45) - k2**2*(r + s - 1)*(r*(24*C - 34) - 10*s + 5)) + 33*b1*(D1*fd*(2*k1**2*(2*C*(76*r*s - 41*r + 76*s**2 - 82*s + 22) - 132*r*s + 72*r - 132*s**2 + 144*s - 39) - k2**2*(2*r + 2*s - 1)*(r*(24*C - 34) - 10*s + 5)) + Dd*f*(k1**2*(C*(8*r*(76*s - 41) + 608*s**2 - 744*s + 226) - 48*r*(11*s - 6) - 528*s**2 + 654*s - 201) - k2**2*(4*r + 4*s - 3)*(r*(24*C - 34) - 10*s + 5))) + f*(D1*fd*(5*k1**2*(4*C*(9*r*(63*s - 32) + 567*s**2 - 633*s + 181) - 3*r*(654*s - 339) - 1962*s**2 + 2226*s - 645) - k2**2*(3*r + 3*s - 2)*(C*(531*r + 263) - 786*r - 255*s - 148)) + Dd*f*(5*k1**2*(4*C*(756*r*s - 436*r + 756*s**2 - 933*s + 292) - 2616*r*s + 1530*r - 2616*s**2 + 3273*s - 1038) + k2**2*(C*(-2124*r**2 - 2124*r*s + 507*r - 1069*s + 806) + 3144*r**2 + 4164*r*s - 1732*r + 1020*s**2 - 156*s - 461))))/(693*d**2*k1*k3**6) - 160*D1**3*Pk1*Pk3*ct**7*f*k2*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(153*s**2 - 135*s + 28) + 2*Dd*f*(102*s**2 - 107*s + 28)))/(693*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct**7*f*k2*(66*b1*(2*s - 1)*(2*D1*fd*(k1**2*(68*C*s - 40*C - 58*s + 35) + k2**2*(-12*C*r + 22*r + 10*s - 5)) + Dd*f*(4*k1**2*(68*C*s - 40*C - 58*s + 35) + k2**2*(-48*C*r + 88*r + 40*s - 25))) + f*(66*D1*bd1*(2*k1**2*s*(C*(68*s - 40) - 58*s + 35) + k2**2*(r*(-24*C*s + 44*s - 5) + 5*(1 - 2*s)**2)) + D1*fd*(20*k1**2*(3*s - 1)*(C*(342*s - 224) - 291*s + 196) + k2**2*(C*(-3384*r*s + 1161*r - 1512*s + 493) + 6444*r*s - 2511*r + 3060*s**2 - 1548*s + 297)) + 40*Dd*f*k1**2*(2*s - 1)*(C*(342*s - 224) - 291*s + 196) + Dd*f*k2**2*(C*(r*(2188 - 4512*s) - 2072*s + 1053) + 8*r*(1074*s - 541) + 4080*s**2 - 2518*s + 247)))/(693*d**2*k1*k3**4) - D1**3*Pk1*Pk3*ct**6*f*k2**6*st**2*(160*C - 160)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(53*r + 53*s - 28))/(77*d**2*k3**8) - D1**3*Pk1*Pk3*ct**6*f*k2**4*st**2*(160*C - 160)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(159*r*s - 64*r + 159*s**2 - 159*s + 39) + Dd*f*(424*r*s - 206*r + 424*s**2 - 477*s + 131)))/(231*d**2*k3**6) - D1**3*Pk1*Pk3*ct**6*f*k2**2*st**2*(160*C - 160)*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(159*s**2 - 128*s + 25) + 2*Dd*f*(106*s**2 - 103*s + 25)))/(231*d**2*k3**4) + 16*D1**3*Pk1*Pk3*ct**6*k2**4*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K - 10*b1*(2*r + 2*s - 1) + 20*r + 20*s - 13)) + k2**2*(r + s)*(792*K*b1 - 792*b1 - 792*g2)) + 858*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (6 - 6*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (6 - 6*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) + 66*f*(fd*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 792*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13)) - 792*g2*k2**2*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(1208*r**2 + 2*r*(1208*s - 815) + 1208*s**2 - 1630*s + 543) + 26*f*(5*fd*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 33*gd2*k2**2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1)) - 858*fd*g2*k2**2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(302*r + 302*s - 181) + 130*f*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1)) - 858*g2*k2**2*(4*r + 4*s + 1))))/(3003*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct**6*k2**2*(13*D1*bd1*f*(3168*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(1275*r**2 + r*(1275*s - 1964) - 1215*s + 689) + 132*f*k1**2*(8*k1**2*(C*(55*r*s - 25*r + 55*s**2 - 76*s + 25) - 41*r*s + 20*r - 41*s**2 + 59*s - 20) + k2**2*(-C*(233*r**2 + 403*r*s - 291*r + 170*s**2 - 182*s + 58) + 237*r**2 + 431*r*s - 308*r + 194*s**2 - 214*s + 71))) + 41184*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 13*b1*f*(3*D1*fd*(3*f*k2**4*r*(425*r + 425*s - 243) + 176*k1**4*(2*C*(110*r*s - 67*r + 110*s**2 - 131*s + 38) - 164*r*s + 103*r - 164*s**2 + 200*s - 59) - 44*k1**2*k2**2*(C*(466*r**2 + 806*r*s - 382*r + 340*s**2 - 308*s + 61) - 474*r**2 - 862*r*s + 422*r - 388*s**2 + 368*s - 79)) + Dd*f*(f*k2**4*(5100*r**2 + r*(5100*s - 4151) - 1215*s + 689) + 528*k1**4*(C*(440*r*s - 268*r + 440*s**2 - 600*s + 202) - 328*r*s + 206*r - 328*s**2 + 459*s - 158) - 132*k1**2*k2**2*(C*(932*r**2 + 1612*r*s - 1029*r + 680*s**2 - 737*s + 196) - 948*r**2 - 1724*r*s + 1113*r - 776*s**2 + 871*s - 245))) + f**2*(D1*fd*(5*f*k2**4*(13964*r**2 + r*(13964*s - 19255) - 10771*s + 7581) + 520*k1**4*(14*C*(75*s - 47)*(3*r + 3*s - 2) - 2322*r*s + 1533*r - 2322*s**2 + 3114*s - 1033) - 52*k1**2*k2**2*(C*(14913*r**2 + 9*r*(3183*s - 853) + 13734*s**2 - 5010*s - 2137) - 15390*r**2 - 30744*r*s + 9849*r - 15354*s**2 + 7779*s + 956)) + Dd*f*(5*f*k2**4*(13964*r**2 + r*(13964*s - 19255) - 10771*s + 7581) + 520*k1**4*(28*C*(r*(150*s - 101) + 150*s**2 - 210*s + 74) + r*(2170 - 3096*s) - 3096*s**2 + 4473*s - 1618) - 52*k1**2*k2**2*(C*(19884*r**2 + 3*r*(12732*s - 4357) + 18312*s**2 - 8795*s - 2930) - 20520*r**2 - 96*r*(427*s - 169) - 20472*s**2 + 12769*s + 1084))))/(9009*d**2*k1**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**6*(3168*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 66*b1*f*(-96*D1*bd1*k1**2*s*(C - 1)*(s - 1) + 4*D1*fd*(2*s - 1)*(k1**2*(s*(12*C - 16) + 5) + k2**2*r) + Dd*f*(2*s - 1)*(8*k1**2*(s*(12*C - 16) + 5) + k2**2*(8*r + 5))) - f**2*(66*D1*bd1*(4*k1**2*s*(s*(12*C - 16) + 5) + k2**2*(r*(4*s + 5) + 10*s - 5)) + D1*fd*(80*k1**2*(3*s - 1)*(C*(51*s - 28) - 60*s + 42) + 3*k2**2*(9*r*(12*s + 7) + 624*s - 241)) + 160*Dd*f*k1**2*(2*s - 1)*(C*(51*s - 28) - 60*s + 42) + 3*Dd*f*k2**2*(16*r*(9*s - 1) + 794*s - 411)))/(693*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**6*(-6336*b1**2*k1**2*k2**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 33*b1*f*(D1*(-192*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-96*k1**4*(2*s - 1)*(4*C*(7*s - 5) - 20*s + 15) + 8*k1**2*k2**2*(C*(r*(421*s - 198) + 388*s**2 - 332*s + 57) + r*(222 - 445*s) - 452*s**2 + 420*s - 85) + k2**4*r*(3*f*(5*s - 3) + r*(448*C - 384) + 64*s - 32))) + Dd*f*(-192*k1**4*(2*s - 1)*(4*C*(7*s - 5) - 20*s + 15) + 4*k1**2*k2**2*(C*(4*r*(421*s - 198) + 1552*s**2 - 1589*s + 394) + r*(888 - 1780*s) - 1808*s**2 + 1977*s - 536) + k2**4*(-224*C*r + f*(4*r - 1)*(5*s - 3) + 8*r**2*(112*C - 96) + 128*r*(s + 1) + 80*s - 40))) + f**2*(D1*(-33*bd1*(96*k1**4*s*(4*C*(7*s - 5) - 20*s + 15) - 4*k1**2*k2**2*(C*(421*r*s - 86*r + 388*s**2 - 383*s + 126) - 445*r*s + 116*r - 452*s**2 + 475*s - 156) + k2**4*(-f*(r - 1)*(5*s - 3) - 8*r**2*(28*C - 24) - 8*r*(-28*C + 4*s + 29) - 80*s + 40)) + fd*(-960*k1**4*(3*s - 1)*(C*(69*s - 56) - 49*s + 42) + 12*k1**2*k2**2*(C*(9*r*(1187*s - 590) + 11196*s**2 - 7395*s + 1804) + r*(6053 - 11295*s) - 12636*s**2 + 10099*s - 2725) + k2**4*(32*C*(513*r**2 - 111*r - 20) + 75*f*(4*r - 1)*(5*s - 3) - 15912*r**2 + 72*r*(7*s + 134) + 7752*s - 4088))) + Dd*f*(-1920*k1**4*(2*s - 1)*(C*(69*s - 56) - 49*s + 42) + 4*k1**2*k2**2*(C*(4*r*(10683*s - 5950) + 44784*s**2 - 34763*s + 6794) - 36*r*(1255*s - 742) - 50544*s**2 + 46305*s - 11547) + k2**4*(32*C*(684*r**2 - 91*r - 20) + 75*f*(4*r - 1)*(5*s - 3) - 21216*r**2 + 672*r*s + 9896*r + 9792*s - 6128))))/(693*d**2*k1**2*k3**4) - 8*D1**3*Pk1*Pk3*ct**5*f*k2**5*st**2*(39*D1*bd1*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(r + s - 1) + 39*b1*(D1*fd*(5*f*k2**2*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + 22*k1**2*(2*r + 2*s - 1)*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113)) + Dd*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(7076*r**2 + r*(14152*s - 9639) + 7076*s**2 - 9639*s + 3249) + 26*k1**2*(3*r + 3*s - 2)*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016)) + Dd*f*(15*f*k2**2*(1769*r + 1769*s - 1083) + 26*k1**2*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016))*(4*r + 4*s - 3)))/(3003*d**2*k1*k3**8) - 16*D1**3*Pk1*Pk3*ct**5*f*k2**3*st**2*(33*D1*bd1*f*(3*k1**2*(8*C*(18*r*s - 5*r + 18*s**2 - 19*s + 5) - 124*r*s + 35*r - 124*s**2 + 132*s - 35) + k2**2*(-2*C*(32*r**2 + 32*r*s - 37*r - 10*s + 5) + 94*r**2 + 124*r*s - 119*r + 30*s**2 - 65*s + 25)) + 33*b1*(D1*fd*(6*k1**2*(2*C*(72*r*s - 37*r + 72*s**2 - 74*s + 19) - 124*r*s + 64*r - 124*s**2 + 128*s - 33) - k2**2*(2*r + 2*s - 1)*(r*(64*C - 94) - 30*s + 15)) + Dd*f*(3*k1**2*(4*C*(144*r*s - 74*r + 144*s**2 - 167*s + 48) - 496*r*s + 256*r - 496*s**2 + 578*s - 167) + k2**2*(-2*C*(128*r**2 + 32*r*(4*s - 3) - 10*s + 5) + 376*r**2 + 496*r*s - 342*r + 120*s**2 - 170*s + 55))) + f*(D1*fd*(6*k1**2*(4*C*(1392*r*s - 585*r + 1392*s**2 - 1447*s + 368) - 4773*r*s + 2020*r - 4773*s**2 + 4993*s - 1277) + k2**2*(-2*C*(2304*r**2 + 3*r*(768*s - 449) + 24*s - 71) + 6993*r**2 + 9378*r*s - 5544*r + 2385*s**2 - 2802*s + 698)) + Dd*f*(3*k1**2*(8*C*(1856*r*s - 920*r + 1856*s**2 - 2154*s + 611) - 12728*r*s + 6330*r - 12728*s**2 + 14847*s - 4233) + k2**2*(C*(-6144*r**2 - 6144*r*s + 3636*r - 298*s + 392) + 9324*r**2 + 12504*r*s - 7701*r + 3180*s**2 - 3767*s + 868))))/(693*d**2*k1*k3**6) - 80*D1**3*Pk1*Pk3*ct**5*f*k2*st**2*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(159*s**2 - 128*s + 25) + 2*Dd*f*(106*s**2 - 103*s + 25)))/(231*d**2*k1*k3**2) - 8*D1**3*Pk1*Pk3*ct**5*f*k2*st**2*(33*b1*(2*s - 1)*(2*D1*fd*(k1**2*(4*C*(47*s - 25) - 158*s + 85) + k2**2*(r*(62 - 32*C) + 30*s - 15)) + Dd*f*(4*k1**2*(4*C*(47*s - 25) - 158*s + 85) + k2**2*(-2*C*(64*r - 5) + 248*r + 120*s - 85))) + f*(D1*(66*bd1*k1**2*s*(4*C*(47*s - 25) - 158*s + 85) + 33*bd1*k2**2*(-2*C*(32*r*s - 5*r - 10*s + 5) + 124*r*s - 25*r + 60*s**2 - 80*s + 25) + 2*fd*k1**2*(3*s - 1)*(4*C*(1248*s - 625) - 4197*s + 2125) + fd*k2**2*(C*(-4806*r*s + 1965*r + 18*s - 127) + 9576*r*s - 3885*r + 4770*s**2 - 4788*s + 1297)) + Dd*f*(4*k1**2*(2*s - 1)*(4*C*(1248*s - 625) - 4197*s + 2125) + k2**2*(C*(-6408*r*s + 3176*r - 232*s + 123) + 12768*r*s - 6266*r + 6360*s**2 - 6923*s + 1842))))/(693*d**2*k1*k3**4) + 16*D1**3*Pk1*Pk3*ct**5*k2**3*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 12*K*r + 12*K*s + 6*K + b1*(-58*r - 58*s + 32) + 88*r + 88*s - 59)) + k1**2*k2**2*(r + s)*(-264*b1*(8 - 11*K) - 2904*g2)) + 858*b1**2*k1**2*k2**2*(D1*fd*(f*(58*r**2 + r*(116*s - 61) + 58*s**2 - 61*s + 16) + (16 - 22*K)*(r + s)**2) + Dd*f*(f*(29*r + 29*s - 16) + (16 - 22*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*k1**2*(fd*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59))*(2*r + 2*s - 1) - 44*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2904*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59)) - 2904*g2*k1**2*k2**2*(r + s))) - 2*f*(D1*(70*f**2*fd*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 13*f*k1**2*(5*fd*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 396*gd2*k2**2*(2*r**2 + r*(4*s - 1) + 2*s**2 - s - 1)) - 5148*fd*g2*k1**2*k2**2*(4*r**2 + 8*r*s + 4*s**2 - 1)) + Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3)) + 65*f*k1**2*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 5148*g2*k1**2*k2**2*(2*r + 2*s + 1))))/(3003*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct**5*k2*(13*D1*bd1*f*(f**2*k2**4*(1791*r**2 + 4*r*(504*s - 503) + 225*s**2 - 1532*s + 255) + 33*f*(8*k1**4*(2*C*(r*(37*s - 25) + 37*s**2 - 64*s + 25) + r*(35 - 47*s) - 47*s**2 + 86*s - 35) + k1**2*k2**2*(-4*C*(152*r**2 + 21*r*(18*s - 11) + 226*s**2 - 240*s + 79) + 471*r**2 + 1221*r*s - 721*r + 750*s**2 - 770*s + 250) + 2*k2**4*(48*C*r**2 + 48*C*r*s - 48*C*r - K*(6*r**2 + 6*r*s + 5*r + 10*s - 10) + 2*b1*(28*r**2 + r*(56*s - 39) + 28*s**2 - 39*s + 11) - 58*r**2 - 74*r*s + 83*r - 16*s**2 + 40*s - 24)) + 264*k2**2*(r + s - 1)*(b1*k1**2*(17*C - 14)*(2*r + 2*s - 1) + b1*k2**2*(r*(13 - 7*K) + 6*s) + 7*g2*k2**2*r)) + 1716*b1**2*k2**2*(D1*fd*(k1**2*(34*C - 28)*(r + s - 1)**2 + k2**2*(f*(28*r**2 + r*(56*s - 39) + 28*s**2 - 39*s + 16) - (r + s)*(r*(7*K - 13) - 6*s))) + Dd*f*(k1**2*(34*C - 28)*(r + s - 1) + k2**2*(-7*K*r + f*(14*r + 14*s - 9) + 13*r + 6*s))*(4*r + 4*s - 3)) + 13*b1*(3*D1*(f**2*fd*k2**4*(1791*r**2 + r*(2016*s - 827) + 225*s**2 - 47*s + 8) + 11*f*(fd*(8*k1**4*(2*C*(r*(74*s - 55) + 74*s**2 - 101*s + 32) + r*(74 - 94*s) - 94*s**2 + 133*s - 43) + k1**2*k2**2*(-8*C*(152*r**2 + 6*r*(63*s - 32) + 226*s**2 - 231*s + 54) + 942*r**2 + 6*r*(407*s - 213) + 1500*s**2 - 1596*s + 391) - 2*k2**4*(2*r + 2*s - 1)*(K*(6*r + 9) + r*(58 - 48*C) + 16*s - 23)) + 56*gd2*k2**4*r*(r + s - 1)) + 616*fd*g2*k2**4*r*(r + s)) + Dd*f*(f**2*k2**4*(7164*r**2 + r*(8064*s - 4493) + 900*s**2 - 1673*s + 279) + 33*f*(8*k1**4*(2*C*(2*r*(74*s - 55) + 148*s**2 - 234*s + 89) - 4*r*(47*s - 37) - 188*s**2 + 309*s - 121) + k1**2*k2**2*(-4*C*(608*r**2 + 24*r*(63*s - 40) + 904*s**2 - 1056*s + 315) + 1884*r**2 + r*(4884*s - 3155) + 3000*s**2 - 3571*s + 1096) - 2*k2**4*(K*(24*r**2 + r*(24*s + 22) + 38*s - 29) - r**2*(192*C - 232) - 2*r*(96*C*s - 72*C - 148*s + 135) + 64*s**2 - 142*s + 71)) + 1848*g2*k2**4*r*(4*r + 4*s - 3))) + f*(D1*(5*f**2*fd*k2**4*(14564*r**2 + r*(6504*s - 24431) - 8060*s**2 - 12351*s + 12575) + 13*f*(fd*(20*k1**4*(2*C*(9*r*(109*s - 95) + 981*s**2 - 1575*s + 592) - 3*r*(405*s - 388) - 1215*s**2 + 2073*s - 809) + k1**2*k2**2*(-4*C*(6867*r**2 + 9*r*(2627*s - 442) + 16776*s**2 - 8307*s - 1159) + 19701*r**2 + 9*r*(8159*s - 1319) + 53730*s**2 - 27000*s - 3361) + 132*k2**4*(C*(66*r**2 + r*(66*s - 45) - 2*s + 1) - 96*r**2 + r*(80 - 126*s) - 30*s**2 + 37*s - 11)) + 132*gd2*k2**4*(6*r**2 + r*(6*s + 5) + 10*s - 10)) + 5148*fd*g2*k2**4*(2*r + 3)*(2*r + 2*s - 1)) + Dd*f*(5*f**2*k2**4*(14564*r**2 + r*(6504*s - 24431) - 8060*s**2 - 12351*s + 12575) + 13*f*(20*k1**4*(4*C*(654*r*s - 575*r + 654*s**2 - 1107*s + 452) - 1620*r*s + 1544*r - 1620*s**2 + 2895*s - 1226) + k1**2*k2**2*(-4*C*(9156*r**2 + 31524*r*s - 8169*r + 22368*s**2 - 13991*s - 1067) + 26268*r**2 + 97908*r*s - 25879*r + 71640*s**2 - 45901*s - 2370) + 132*k2**4*(C*(88*r**2 + 88*r*s - 66*r - 2*s + 1) - 128*r**2 - 168*r*s + 116*r - 40*s**2 + 52*s - 16)) + 1716*g2*k2**4*(24*r**2 + r*(24*s + 22) + 38*s - 29))))/(9009*d**2*k1*k3**6) - 32*D1**3*Pk1*Pk3*ct**5*(D1*bd1*f**2*s*(4*s - 5) + 6*b1**2*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(12*D1*bd1*s*(s - 1) + D1*fd*(8*s**2 - 14*s + 5) + 2*Dd*f*(8*s**2 - 14*s + 5)))/(21*d**2*k1*k2) - 2*D1**3*Pk1*Pk3*ct**5*(528*b1**2*k1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))*(k1**2*(24*C - 18)*(s - 1) + k2**2*r*(7 - 7*C)) - 33*b1*f*(2*D1*(-16*bd1*k1**2*s*(k1**2*(24*C - 18)*(s - 1) + k2**2*r*(7 - 7*C)) + fd*(k1**4*s*(96*C - 48)*(2*s - 1) + k1**2*k2**2*(C*(4*r*(13*s - 7) + 70*s - 34) + r*(s + 2) + 260*s**2 - 330*s + 99) + 64*k2**4*r**2)) + Dd*f*(k1**4*s*(384*C - 192)*(2*s - 1) + k1**2*k2**2*(4*C*(4*r*(13*s - 7) + 75*s - 37) + 4*r*(s + 2) + 1040*s**2 - 1353*s + 414) + 64*k2**4*r*(4*r - 1))) - f**2*(D1*(33*bd1*(k1**4*s**2*(192*C - 96) + k1**2*k2**2*(80*C*s + r*(52*C*s - 12*C + s + 6) + 260*s**2 - 223*s + 6) + 64*k2**4*r*(r - 1)) + fd*(80*k1**4*(3*s - 1)*(2*C*(69*s - 56) - 87*s + 84) + k1**2*k2**2*(4*C*(576*r*s - 159*r - 1512*s + 493) + 441*r*s - 708*r + 19188*s**2 - 8649*s + 938) + 2*k2**4*(2115*r**2 + 174*r - 293))) + Dd*f*(160*k1**4*(2*s - 1)*(2*C*(69*s - 56) - 87*s + 84) + k1**2*k2**2*(4*C*(768*r*s - 452*r - 2072*s + 1053) + 588*r*s - 344*r + 25584*s**2 - 15447*s + 1340) + 2*k2**4*(2820*r**2 + 467*r - 293))))/(693*d**2*k1**3*k2*k3**2) - 2*D1**3*Pk1*Pk3*ct**5*(6864*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(29*C - 23)*(s - 1) + k2**2*r*(7 - 7*C))*(r + s - 1) + Dd*f*(k1**2*(2*C*(58*r*s - 47*r + 58*s**2 - 96*s + 38) - 92*r*s + 76*r - 92*s**2 + 153*s - 61) + k2**2*r*(7 - 7*C)*(4*r + 4*s - 3))) - 39*b1*f*(-2*D1*(88*bd1*k1**2*k2**2*(k1**2*(2*C*(29*r*s - 18*r + 29*s**2 - 38*s + 9) - 46*r*s + 30*r - 46*s**2 + 61*s - 15) + k2**2*r*(7 - 7*C)*(2*r + 2*s - 1)) + fd*(-105*f*k2**6*r**2 + 88*k1**6*(2*s - 1)*(C*(44*s - 40) - 26*s + 25) - 11*k1**4*k2**2*(4*C*(3*r*(86*s - 47) + 504*s**2 - 494*s + 103) + r*(450 - 755*s) - 1676*s**2 + 1716*s - 379) - 11*k1**2*k2**4*(4*C*(17*r**2 + r*(85 - 146*s) + 18*s - 18) + 2*K*r*s - K*s + f*(12*r*s - 9*r + 2*s - 1) + 46*r**2 + 956*r*s - 526*r + 260*s**2 - 331*s + 137))) + Dd*f*(70*f*k2**6*r*(4*r - 1) - 352*k1**6*(2*s - 1)*(C*(44*s - 40) - 26*s + 25) + 11*k1**4*k2**2*(4*C*(12*r*(86*s - 47) + 2016*s**2 - 2306*s + 661) - 20*r*(151*s - 90) - 6704*s**2 + 7899*s - 2346) + 22*k1**2*k2**4*(2*C*(68*r**2 + r*(347 - 584*s) + 80*s - 58) + 4*K*r*s - K*s + f*(4*r - 1)*(4*s - 3) + 92*r**2 + 1912*r*s - 1123*r + 520*s**2 - 684*s + 248))) - f*(D1*(2*f**2*k2**4*(39*bd1*(11*k1**2*(r*(4*s - 3) - 6*s + 4) + 35*k2**2*r*(r - 1)) + 100*fd*(4*r - 1)*(13*k1**2*(3*s - 2) + 9*k2**2*(r + 3))) - 13*f*k1**2*(33*bd1*(16*k1**4*s*(C*(44*s - 40) - 26*s + 25) + k1**2*k2**2*(-4*C*(129*r*(2*s - 1) + 504*s**2 - 548*s + 189) + 5*r*(151*s - 86) + 1676*s**2 - 1833*s + 630) - 2*k2**4*(C*(34*r**2 + r*(26 - 292*s) + 48*s - 4) + 23*r**2 + r*(s*(K + 478) - 85) + 130*s**2 - 118*s + 6)) + fd*(80*k1**4*(3*s - 1)*(14*C*(15*s - 16) - 123*s + 140) + k1**2*k2**2*(-12*C*(11*r*(567*s - 473) + 13824*s**2 - 12857*s + 3791) + r*(53523*s - 50808) + 134820*s**2 - 133395*s + 40474) - 2*k2**4*(6*C*(1137*r**2 - 4*r*(705*s + 191) - 2338*s + 1221) - 3582*r**2 + 3*r*(9783*s + 527) + 9594*s**2 + 9264*s - 7544)) + 132*gd2*k2**4*r*s) + 1716*fd*g2*k1**2*k2**4*s*(1 - 2*r)) + Dd*f*(200*f**2*k2**4*(4*r - 1)*(13*k1**2*(3*s - 2) + 9*k2**2*(r + 3)) - 13*f*k1**2*(160*k1**4*(2*s - 1)*(14*C*(15*s - 16) - 123*s + 140) + k1**2*k2**2*(-12*C*(8316*r*s - 6644*r + 18432*s**2 - 19375*s + 5701) + 71364*r*s - 64264*r + 179760*s**2 - 200133*s + 62272) + 2*k2**4*(-2*C*(4548*r**2 - 11280*r*s - 901*r - 9404*s + 6053) + 4776*r**2 - 39132*r*s + 4554*r - 12792*s**2 - 10349*s + 11827)) + 1716*g2*k1**2*k2**4*s*(1 - 4*r))))/(9009*d**2*k1**3*k2*k3**4) - D1**3*Pk1*Pk3*ct**4*f**2*k2**6*st**4*(960*C - 960)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)/(77*d**2*k3**8) - D1**3*Pk1*Pk3*ct**4*f**2*k2**4*st**4*(320*C - 320)*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7))/(77*d**2*k3**6) - D1**3*Pk1*Pk3*ct**4*f**2*k2**2*st**4*(320*C - 320)*(3*s - 1)*(D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1))/(77*d**2*k3**4) + 8*D1**3*Pk1*Pk3*ct**4*k2**4*st**2*(-39*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K + 10*b1*(2*r + 2*s - 1) - 5*r - 5*s + 3)) + k2**2*(r + s)*(264*K*b1 - 264*b1 - 264*g2)) + 2574*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (2 - 2*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (2 - 2*K)*(r + s))*(4*r + 4*s - 3)) - 39*b1*(D1*(5*f**2*fd*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) + 22*f*(fd*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 264*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3)) - 264*g2*k2**2*(r + s))) + f*(D1*(-125*f**2*fd*k2**2*(2156*r**2 + r*(4312*s - 3013) + 2156*s**2 - 3013*s + 1047) - 26*f*(fd*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 198*gd2*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 5148*fd*g2*k2**2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) - Dd*f*(4*r + 4*s - 3)*(125*f**2*k2**2*(539*r + 539*s - 349) + 26*f*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1)) - 5148*g2*k2**2*(3*r + 3*s - 1))))/(3003*d**2*k3**8) + 16*D1**3*Pk1*Pk3*ct**4*k2**2*(429*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 6*K*r + 6*K*s + 15*K + b1*(-50*r - 50*s + 34) + 152*r + 152*s - 106) + 6*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) + 4*k2**2*(r + s)*(b1*k1**2*(11 - 27*K) + 7*b1*k2**2*(K - 1) + g2*(27*k1**2 - 7*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(27*K - 11) - k2**2*(7*K - 7))) + Dd*f*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1)) - (r + s)*(k1**2*(27*K - 11) - k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 2*gd2*k2**2*(-27*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 4*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(70*f**2*fd*k2**2*(-3*k1**2*(r + s - 4) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) + 198*gd2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(r + s - 1)) + 2574*fd*g2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(3*k1**2*(r + s - 4) - 13*k2**2*(17*r + 17*s - 11)) - 65*f*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) + 2574*g2*k2**2*(-k1**2*(2*r + 2*s + 5) + 2*k2**2*(r + s)))))/(3003*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct**4*k2**2*st**2*(39*D1*bd1*f*(264*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(455*r**2 + r*(455*s - 614) - 255*s + 159) + 11*f*k1**2*(6*k1**2*(C*(200*r*s - 62*r + 200*s**2 - 224*s + 62) - 148*r*s + 47*r - 148*s**2 + 168*s - 47) + k2**2*(-2*C*(291*r**2 + 479*r*s - 399*r + 188*s**2 - 284*s + 108) + 586*r**2 + 1026*r*s - 825*r + 440*s**2 - 640*s + 239))) + 10296*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 39*b1*f*(D1*fd*(f*k2**4*r*(1365*r + 1365*s - 877) + 132*k1**4*(2*C*(100*r*s - 53*r + 100*s**2 - 106*s + 28) - 148*r*s + 79*r - 148*s**2 + 158*s - 42) - 22*k1**2*k2**2*(C*(582*r**2 + 958*r*s - 460*r + 376*s**2 - 340*s + 67) - 586*r**2 - 1026*r*s + 500*r - 440*s**2 + 410*s - 86)) + Dd*f*(f*k2**4*(1820*r**2 + 7*r*(260*s - 213) - 255*s + 159) + 66*k1**4*(C*(800*r*s - 424*r + 800*s**2 - 960*s + 286) - 592*r*s + 316*r - 592*s**2 + 716*s - 215) - 11*k1**2*k2**2*(2*C*(1164*r**2 + 1916*r*s - 1247*r + 752*s**2 - 897*s + 260) - 2344*r**2 - 4104*r*s + 2658*r - 1760*s**2 + 2108*s - 619))) + f**2*(D1*fd*(f*k2**4*(74420*r**2 + r*(74420*s - 79659) - 26730*s + 19326) + 156*k1**4*(C*(7482*r*s - 3297*r + 7482*s**2 - 8120*s + 2143) - 5493*r*s + 2447*r - 5493*s**2 + 6021*s - 1602) - 26*k1**2*k2**2*(C*(19719*r**2 + 34479*r*s - 18501*r + 14760*s**2 - 15162*s + 3559) - 20133*r**2 - 36954*r*s + 20526*r - 16821*s**2 + 18087*s - 4659)) + Dd*f*(f*k2**4*(74420*r**2 + r*(74420*s - 79659) - 26730*s + 19326) + 78*k1**4*(2*C*(9976*r*s - 5044*r + 9976*s**2 - 11982*s + 3511) - 14648*r*s + 7438*r - 14648*s**2 + 17733*s - 5233) - 13*k1**2*k2**2*(2*C*(26292*r**2 + 45972*r*s - 26561*r + 19680*s**2 - 21707*s + 5184) - 53688*r**2 - 98544*r*s + 59288*r - 44856*s**2 + 52009*s - 13939))))/(9009*d**2*k1**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**4*st**2*(1584*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 33*b1*f*(4*D1*(-24*bd1*k1**2*s*(C - 1)*(s - 1) + fd*(2*s - 1)*(k1**2*(6*C*(7*s - 3) - 46*s + 23) + k2**2*r)) + Dd*f*(2*s - 1)*(8*k1**2*(6*C*(7*s - 3) - 46*s + 23) + k2**2*(8*r + 5))) - f**2*(33*D1*bd1*(4*k1**2*s*(6*C*(7*s - 3) - 46*s + 23) + k2**2*(r*(4*s + 5) + 10*s - 5)) + D1*fd*(4*k1**2*(3*s - 1)*(30*C*(53*s - 25) - 1701*s + 875) + k2**2*(9*r*(4*s - 5) + 912*s - 293)) + 8*Dd*f*k1**2*(2*s - 1)*(30*C*(53*s - 25) - 1701*s + 875) + Dd*f*k2**2*(r*(48*s - 86) + 1207*s - 588)))/(693*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**4*st**2*(-3168*b1**2*k1**2*k2**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 33*b1*f*(D1*(-96*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-16*k1**4*(2*s - 1)*(2*C*(107*s - 61) - 150*s + 87) + 8*k1**2*k2**2*(C*(587*r*s - 302*r + 460*s**2 - 418*s + 91) - 599*r*s + 314*r - 532*s**2 + 502*s - 115) + k2**4*r*(32*C*r + 15*f*s - 9*f + 32*s - 16))) + Dd*f*(-32*k1**4*(2*s - 1)*(2*C*(107*s - 61) - 150*s + 87) + 4*k1**2*k2**2*(C*(4*r*(587*s - 302) + 1840*s**2 - 2051*s + 574) - 2396*r*s + 1256*r - 2128*s**2 + 2405*s - 685) + k2**4*(64*C*r**2 + f*(4*r - 1)*(5*s - 3) - 16*r*(C - 4*s + 2) + 40*s - 20))) + f**2*(D1*(-33*bd1*(16*k1**4*s*(2*C*(107*s - 61) - 150*s + 87) - 4*k1**2*k2**2*(C*(587*r*s - 162*r + 460*s**2 - 549*s + 186) - 599*r*s + 177*r - 532*s**2 + 615*s - 201) - k2**4*(16*C*r**2 + f*(r - 1)*(5*s - 3) + 4*r*(-4*C + 4*s + 5) + 40*s - 20)) + fd*(-16*k1**4*(3*s - 1)*(C*(5718*s - 3050) - 4017*s + 2175) + 4*k1**2*k2**2*(C*(3*r*(15447*s - 6854) + 39060*s**2 - 35613*s + 9236) - 3*r*(15879*s - 7163) - 43848*s**2 + 42009*s - 11001) + k2**4*(8*C*(1197*r**2 - 1458*r + 353) + 183*f*(4*r - 1)*(5*s - 3) - 10224*r**2 - 648*r*s + 16008*r + 3912*s - 5432))) + Dd*f*(-32*k1**4*(2*s - 1)*(C*(5718*s - 3050) - 4017*s + 2175) + 4*k1**2*k2**2*(C*(228*r*(271*s - 134) + 52080*s**2 - 52583*s + 13186) + r*(31910 - 63516*s) - 58464*s**2 + 62092*s - 16468) + k2**4*(8*C*(1596*r**2 - 1811*r + 353) + 183*f*(4*r - 1)*(5*s - 3) - 13632*r**2 - 864*r*s + 20104*r + 5092*s - 6612))))/(693*d**2*k1**2*k3**4) + 4*D1**3*Pk1*Pk3*ct**4*(-13*D1*bd1*f*(f**2*k2**4*(k1**2*(5280*r**2 + 43*r*(306*s - 161) + 7878*s**2 - 10969*s + 1057) - 297*k2**2*(r - 1)*(5*r + 5*s - 3)) + 33*f*k1**2*(16*k1**4*(C*(r*(22*s - 25) + 22*s**2 - 52*s + 25) - 3*r*(4*s - 5) - 12*s**2 + 30*s - 15) - 2*k1**2*k2**2*(2*C*(55*r**2 + r*(446*s - 181) + 391*s**2 - 407*s + 126) - 43*r**2 + r*(179 - 547*s) - 504*s**2 + 504*s - 136) + k2**4*(4*C*(279*r**2 + 429*r*s - 353*r + 150*s**2 - 198*s + 74) - 2*K*(15*r**2 + 22*r*s + 107*r + 7*s**2 + 109*s - 116) + b1*(342*r**2 + r*(702*s - 509) + 360*s**2 - 483*s + 145) - 1142*r**2 - 1872*r*s + 1710*r - 730*s**2 + 1182*s - 580)) - 132*k1**2*k2**2*(12*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(38 - 60*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(28*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(125*r**2 + 166*r*s - 127*r + 41*s**2 - 43*s + 2) - 173*r**2 - 286*r*s + 209*r - 113*s**2 + 137*s - 30)) + k2**2*(12*b2*(r + s) - g2*(125*r + 41*s))*(r + s - 1))) + 20592*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 429*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(120*C - 76)*(r + s - 1)**2 + k2**2*(-56*C*(r + s - 1)**2 - 125*K*r**2 - 166*K*r*s + 8*K*r - 41*K*s**2 + 8*K*s - 4*K + f*(171*r**2 + 351*r*s - 209*r + 180*s**2 - 208*s + 69) + 173*r**2 + 286*r*s - 120*r + 113*s**2 - 120*s + 60)) + Dd*f*(k1**2*(240*C - 152)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-112*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*K*(500*r**2 + 664*r*s - 391*r + 164*s**2 - 139*s + 12) + f*(684*r**2 + 9*r*(156*s - 103) + 720*s**2 - 899*s + 283) + 1384*r**2 + 2288*r*s - 1566*r + 904*s**2 - 1134*s + 360))) - 13*b1*(-3*D1*(f**2*fd*k2**4*(-k1**2*(5280*r**2 + r*(13158*s - 3595) + 7878*s**2 - 5261*s + 323) + 297*k2**2*r*(5*r + 5*s - 3)) - 22*f*k1**2*(fd*(8*k1**4*(C*(r*(44*s - 46) + 44*s**2 - 74*s + 26) - 3*r*(8*s - 9) - 24*s**2 + 42*s - 15) + k1**2*k2**2*(-2*C*(110*r**2 + r*(892*s - 547) + 782*s**2 - 975*s + 280) + 86*r**2 + 2*r*(547*s - 352) + 1008*s**2 - 1354*s + 413) + k2**4*(2*C*(558*r**2 + r*(858*s - 394) + 300*s**2 - 252*s + 39) - K*(30*r**2 + 44*r*s + 197*r + 14*s**2 + 209*s - 106) - 1142*r**2 - 1872*r*s + 1089*r - 730*s**2 + 873*s - 222)) + 2*k2**4*(-12*bd2*(r + s) + gd2*(125*r + 41*s - 4))*(r + s - 1)) + 44*fd*k1**2*k2**4*(12*b2*(r + s)**2 - g2*(125*r**2 + 2*r*(83*s - 4) + 41*s**2 - 8*s + 4))) + Dd*f*(f**2*k2**4*(2*k1**2*(10560*r**2 + r*(26316*s - 8854) + 15756*s**2 - 13376*s + 1013) - 297*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 66*f*k1**2*(8*k1**4*(C*(r*(88*s - 92) + 88*s**2 - 174*s + 77) - 6*r*(8*s - 9) - 48*s**2 + 99*s - 45) + k1**2*k2**2*(-2*C*(220*r**2 + r*(1784*s - 1197) + 1564*s**2 - 2077*s + 710) + 172*r**2 + r*(2188*s - 1499) + 2016*s**2 - 2799*s + 986) + k2**4*(2*C*(1116*r**2 + r*(1716*s - 1115) + 600*s**2 - 663*s + 176) - K*(60*r**2 + 88*r*s + 411*r + 28*s**2 + 427*s - 338) - 2284*r**2 - 3744*r*s + 2853*r - 1460*s**2 + 2109*s - 792)) + 132*k1**2*k2**4*(-12*b2*(r + s) + g2*(125*r + 41*s - 4))*(4*r + 4*s - 3))) - f*(D1*(5*f**2*fd*k2**4*(k1**2*(67092*r**2 + r*(113788*s - 134133) + 46696*s**2 - 130705*s + 68795) - 533*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(fd*(20*k1**4*(2*C*(27*r*(9*s - 14) + 243*s**2 - 573*s + 263) - 3*r*(84*s - 149) - 252*s**2 + 648*s - 309) + k1**2*k2**2*(2*C*(11367*r**2 - 18*r*(608*s + 761) - 22311*s**2 + 6444*s + 4850) - 19971*r**2 + 4203*r*s + 25311*r + 24174*s**2 - 2502*s - 8537) + 66*k2**4*(C*(801*r**2 + 1239*r*s - 763*r + 438*s**2 - 492*s + 143) - 825*r**2 - 1353*r*s + 833*r - 528*s**2 + 600*s - 177)) - 66*k2**4*(2*bd2*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - gd2*(15*r**2 + 22*r*s + 107*r + 7*s**2 + 109*s - 116))) - 1716*fd*k1**2*k2**4*(2*b2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1) - g2*(30*r**2 + r*(44*s + 197) + 14*s**2 + 209*s - 106))) + Dd*f*(5*f**2*k2**4*(k1**2*(67092*r**2 + r*(113788*s - 134133) + 46696*s**2 - 130705*s + 68795) - 533*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(20*k1**4*(2*C*(324*r*s - 476*r + 324*s**2 - 777*s + 386) - 336*r*s + 558*r - 336*s**2 + 873*s - 450) + k1**2*k2**2*(2*C*(15156*r**2 - 3*r*(4864*s + 4961) - 29748*s**2 + 13393*s + 5338) - 26628*r**2 + 5604*r*s + 29357*r + 32232*s**2 - 9327*s - 9770) + 66*k2**4*(C*(1068*r**2 + 1652*r*s - 1119*r + 584*s**2 - 711*s + 216) - 1100*r**2 - 1804*r*s + 1223*r - 704*s**2 + 869*s - 270)) - 1716*k1**2*k2**4*(2*b2*(16*r**2 + 8*r*(4*s - 1) + 16*s**2 - 8*s - 3) - g2*(60*r**2 + r*(88*s + 411) + 28*s**2 + 427*s - 338)))))/(9009*d**2*k1**2*k3**6) + 4*D1**3*Pk1*Pk3*ct**4*(D1*bd1*f**2*(k1**2*s*(16*C - 8)*(4*s - 5) + k2**2*(r*(7 - 3*s) + 18*s)) + 4*b1**2*(D1*fd*(s - 1)*(k1**2*(24*C - 12)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(48*C - 24)*(2*s**2 - 3*s + 1) + k2**2*(4*r*(s + 1) + 3*s - 3))) + b1*f*(D1*(96*bd1*k1**2*s*(2*C - 1)*(s - 1) + 4*bd1*k2**2*(2*r*(s + 3) + 3*s - 3) + fd*k1**2*(16*C - 8)*(8*s**2 - 14*s + 5) + fd*k2**2*(r*(14 - 6*s) + 39*s - 25)) + Dd*f*(k1**2*(32*C - 16)*(8*s**2 - 14*s + 5) + k2**2*(-4*r*(3*s - 7) + 75*s - 43))))/(21*d**2*k1**2*k2**2) - 2*D1**3*Pk1*Pk3*ct**4*(-33*b1**2*(-2*D1*fd*(k1**4*(96*C - 48)*(s - 1)**2 - 6*k1**2*k2**2*(s - 1)*(16*C*r + 23*C*(s - 1) - 12*r - 23*s + 23) + k2**4*r*(f*(2 - 3*s) + r*(32 - 32*C))) + Dd*f*(k1**4*(192 - 384*C)*(2*s**2 - 3*s + 1) + 24*k1**2*k2**2*(C*(8*r*(4*s - 3) + 46*s**2 - 73*s + 27) - 6*r*(4*s - 3) - 46*s**2 + 72*s - 26) + k2**4*(4*r - 1)*(f*(3*s - 2) + r*(64*C - 64)))) - 33*b1*f*(D1*bd1*(k1**4*s*(192 - 384*C)*(s - 1) + 24*k1**2*k2**2*(C*(8*r*(2*s - 1) + 23*s**2 - 27*s + 4) + r*(6 - 12*s) - 23*s**2 + 26*s - 3) + k2**4*(2*r - 1)*(f*(3*s - 2) + r*(64*C - 64))) + k2**2*(-D1*fd*(2*k1**2*(2*C*(r*(s + 14) + 150*s**2 - 149*s + 24) - r*(s + 14) - 376*s**2 + 407*s - 90) + k2**2*(C*(-112*r**2 + 40*r + 8) - 3*f*(3*r - 1)*(3*s - 2) + 42*r**2 + 304*r*s - 194*r + 2*s - 8)) + Dd*f*(k1**2*(-2*C*(4*r*(s + 14) + 600*s**2 - 717*s + 194) + 4*r*(s + 14) + 1504*s**2 - 1801*s + 510) + k2**2*(8*C*(28*r**2 - 3*r - 1) + 3*f*(4*r - 1)*(3*s - 2) - 84*r**2 - 608*r*s + 297*r + 6*s + 4)))) + f**2*(D1*(33*bd1*k2**2*(k1**2*(2*C*(r*(s + 6) + 150*s**2 - 169*s + 46) - r*(s + 6) - 376*s**2 + 353*s - 72) + k2**2*(-r**2*(56*C - 21) + r*(-8*C - 9*f*s + 6*f + 152*s + 39) - 8*s + 4)) + fd*(-k1**4*(320*C - 160)*(27*s**2 - 51*s + 14) + k1**2*k2**2*(C*(-6*r*(669*s + 602) + 34056*s**2 - 20706*s + 4768) + 3339*r*s + 3210*r - 38376*s**2 + 32853*s - 8128) + k2**4*(8*C*(9*r**2 + 192*r - 65) - 4041*r**2 + 7164*r*s - 1641*r + 8370*s - 2590))) + Dd*f*(-k1**4*(640*C - 320)*(18*s**2 - 37*s + 14) + k1**2*k2**2*(2*C*(-4*r*(669*s + 142) + 22704*s**2 - 16891*s + 3246) + 4452*r*s + 1720*r - 51168*s**2 + 51423*s - 13906) + k2**4*(8*C*(12*r**2 + 257*r - 65) - 5388*r**2 + 9552*r*s - 4137*r + 11206*s - 5426))))/(693*d**2*k1**2*k2**2*k3**2) - D1**3*Pk1*Pk3*ct**4*(429*b1**2*k2**2*(2*D1*fd*(k1**4*(352*C - 216)*(s - 1)*(r + s - 1) + k1**2*k2**2*(-4*C*(76*r**2 + 145*r*(s - 1) + 69*(s - 1)**2) + 256*r**2 + r*(f*(9*s - 5) + s*(7*K + 525) - 532) + 276*(s - 1)**2) + 4*k2**4*r*(f*(31*r + 31*s - 20) - 2*r*(4*K - 3) - 2*s)) + Dd*f*(32*k1**4*(2*C*(r*(44*s - 40) + 44*s**2 - 75*s + 31) + r*(51 - 54*s) - 54*s**2 + 93*s - 39) + k1**2*k2**2*(-16*C*(152*r**2 + 29*r*(10*s - 7) + 138*s**2 - 217*s + 79) - 14*K*s + f*(4*r - 1)*(9*s - 5) + 2048*r**2 + 8*r*(s*(7*K + 525) - 358) + 2208*s**2 - 3410*s + 1216) + 4*k2**4*(f*(124*r**2 + r*(124*s - 103) - 23*s + 14) - 4*r**2*(16*K - 12) - 4*r*(-4*K + 4*s - 5) - 12*s))) + 13*b1*(3*D1*(f**2*k2**4*(11*bd1*k1**2*(2*r - 1)*(9*s - 5) + 44*bd1*k2**2*(62*r**2 + r*(62*s - 63) - 23*s + 14) + 33*fd*k1**2*(6*r - 9*s + 5) + fd*k2**2*(5004*r**2 + r*(7197*s - 8671) - 4324*s + 3232)) + 22*f*(bd1*k2**2*(16*k1**4*(2*C*(2*r*(11*s - 9) + 22*s**2 - 31*s + 9) - 3*r*(9*s - 8) - 27*s**2 + 39*s - 12) + k1**2*k2**2*(-8*C*(76*r**2 + 29*r*(5*s - 2) + 69*s**2 - 79*s + 10) - 7*K*s + 512*r**2 + 2*r*(s*(7*K + 525) - 184) + 552*s**2 - 601*s + 56) - 8*k2**4*(r**2*(8*K - 6) + r*(-4*K + 2*s - 1) + 3*s)) + fd*(k1**6*(32*C - 16)*(8*s**2 - 14*s + 5) + 2*k1**4*k2**2*(-2*C*(3*r*(67*s - 62) + 962*s**2 - 1105*s + 276) + r*(227*s - 236) + 1344*s**2 - 1606*s + 419) - k1**2*k2**4*(4*C*(8*r**2 + r*(401 - 617*s) - 106*s**2 + 169*s - 109) - 7*K*s + 34*r**2 + 2*r*(7*K*s + 1193*s - 755) + 496*s**2 - 807*s + 454) + 4*k2**6*(K*(-14*r**2 + 5*r + 1) + r**2*(48*C - 30) + r*(4*s - 21) - 20*s + 6)) + 2*gd2*k2**4*r*(-7*k1**2*s + 32*k2**2*r)) + 44*fd*g2*k2**4*r*(-7*k1**2*s + 32*k2**2*r)) + Dd*f*(f**2*k2**4*(198*k1**2*(4*r - 1) + k2**2*(20016*r**2 + 12*r*(2399*s - 2780) - 19457*s + 13219)) + 66*f*(k1**6*(64*C - 32)*(8*s**2 - 14*s + 5) + k1**4*k2**2*(-2*C*(12*r*(67*s - 62) + 3848*s**2 - 4957*s + 1602) + r*(908*s - 944) + 5376*s**2 - 7083*s + 2320) - k1**2*k2**4*(2*C*(32*r**2 - 4*r*(617*s - 417) - 424*s**2 + 779*s - 394) - 7*K*s + 68*r**2 + r*(28*K*s + 4772*s - 3165) + 992*s**2 - 1739*s + 812) + 4*k2**6*(K*(-28*r**2 + 3*r + 1) + r**2*(96*C - 60) + r*(-24*C + 8*s - 9) - 26*s + 18)) + 132*g2*k2**4*(4*r - 1)*(-7*k1**2*s + 32*k2**2*r))) + f*(D1*(f**2*k2**4*(13*bd1*(99*k1**2*(2*r + 9*s - 7) + k2**2*(5004*r**2 + 7197*r*s - 7347*r - 6485*s + 3523)) - 5*fd*(325*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(18624*r**2 + 28*r*(455*s - 431) - 43485*s + 22003))) + 26*f*(33*bd1*(k1**6*s*(32*C - 16)*(4*s - 5) + k1**4*k2**2*(-2*C*(3*r*(67*s - 86) + 962*s**2 - 1113*s + 378) + r*(227*s - 324) + 1344*s**2 - 1529*s + 484) - k1**2*k2**4*(2*C*(8*r**2 + r*(154 - 617*s) - 106*s**2 + 201*s - 42) + 17*r**2 + r*(7*K*s + 1193*s - 281) + 248*s**2 - 378*s + 52) + 4*k2**6*(r**2*(24*C - 7*K - 15) - r*(24*C + K - 2*s - 24) + 3*s + 3)) + fd*(k1**6*(320*C - 160)*(27*s**2 - 51*s + 14) + k1**4*k2**2*(-2*C*(207*r*(47*s - 122) + 73242*s**2 - 84081*s + 27226) + 9117*r*s - 32178*r + 99468*s**2 - 119709*s + 38564) + k1**2*k2**4*(C*(-43776*r**2 + 6*r*(7377*s + 8950) + 21960*s**2 + 77262*s - 46148) + 33885*r**2 - 43848*r*s - 41931*r - 20520*s**2 - 65160*s + 39084) + 264*k2**6*(r**2*(24*C - 21) + r*(-8*C + 3*s + 8) + 4*s - 2)) + 66*gd2*k2**4*r*(7*k1**2*s + 4*k2**2*(7*r + 1))) + 1716*g2*k2**4*(bd1*(r - 1)*(-7*k1**2*s + 32*k2**2*r) + fd*(2*r - 1)*(7*k1**2*s + 4*k2**2*(7*r + 1)))) + Dd*f*(-5*f**2*k2**4*(325*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(18624*r**2 + 28*r*(455*s - 431) - 43485*s + 22003)) + 26*f*(k1**6*(640*C - 320)*(18*s**2 - 37*s + 14) + k1**4*k2**2*(-2*C*(4*r*(3243*s - 7118) + 97656*s**2 - 124703*s + 43434) + 4*r*(3039*s - 9046) + 132624*s**2 - 177343*s + 63042) + k1**2*k2**4*(C*(-58368*r**2 + 8*r*(7377*s + 7268) + 29280*s**2 + 98758*s - 74964) + 45180*r**2 - r*(58464*s + 42211) - 27360*s**2 - 82226*s + 62990) + 264*k2**6*(r**2*(32*C - 28) + r*(-8*C + 4*s + 5) + 4*s - 2)) + 1716*g2*k2**4*(4*r - 1)*(7*k1**2*s + 4*k2**2*(7*r + 1)))))/(9009*d**2*k1**2*k2**2*k3**4) - 160*D1**3*Pk1*Pk3*ct**3*f**2*k2*st**4*(3*s - 1)*(D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1))/(77*d**2*k1*k3**2) - 16*D1**3*Pk1*Pk3*ct**3*f*k2**5*st**4*(26*D1*bd1*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(r + s - 1) + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 + k1**2*(66*C - 66)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(f*k2**2*(1772*r**2 + r*(3544*s - 2541) + 1772*s**2 - 2541*s + 909) + k1**2*(520*C - 442)*(3*r + 3*s - 2)**2) + Dd*f*(f*k2**2*(443*r + 443*s - 303) + k1**2*(520*C - 442)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k1*k3**8) - 32*D1**3*Pk1*Pk3*ct**3*f*k2**3*st**4*(66*b1*(C - 1)*(D1*fd*(k1**2*(8*r*s - 3*r + 8*s**2 - 6*s + 1) + 2*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(k1**2*(16*r*s - 6*r + 16*s**2 - 13*s + 2) + 2*k2**2*r*(4*r + 4*s - 3))) + f*(132*D1*bd1*(C - 1)*(k1**2*s*(2*r + 2*s - 1) + k2**2*r*(r + s - 1)) + D1*fd*(k1**2*(180*C - 150)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(-C*(3*r - 1)*(93*r + 93*s - 73) + 414*r**2 + r*(549*s - 492) + 135*s**2 - 273*s + 133)) + Dd*f*k1**2*(90*C - 75)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + Dd*f*k2**2*(C*(-372*r**2 + r*(405 - 372*s) + 103*s - 83) + 552*r**2 + 12*r*(61*s - 55) + 180*s**2 - 358*s + 173)))/(231*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**3*f*k2*st**4*(D1*(132*b1*fd*(C - 1)*(2*s - 1)*(k1**2*s + k2**2*r) + f*(132*bd1*s*(C - 1)*(k1**2*s + k2**2*r) + fd*k1**2*(1 - 3*s)**2*(160*C - 130) + fd*k2**2*(-C*(3*r - 1)*(93*s - 20) + 3*r*(183*s - 50) + 270*s**2 - 363*s + 80))) + Dd*f*(264*b1*(C - 1)*(2*s - 1)*(k1**2*s + k2**2*r) + f*k1**2*(320*C - 260)*(6*s**2 - 5*s + 1) + f*k2**2*(C*(-4*r*(93*s - 25) + 103*s - 30) + r*(732*s - 250) + 360*s**2 - 508*s + 135)))/(231*d**2*k1*k3**4) + 16*D1**3*Pk1*Pk3*ct**3*k1*k2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 8*K*r + 8*K*s - 10*K + b1*(r + s - 5) - 64*r - 64*s + 47) - 6*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) - 132*k2**2*(r + s)*(b1*k1**2*(8*K + 3) + 7*b1*k2**2*(3 - 4*K) - 8*g2*k1**2 + 28*g2*k2**2)) - 858*b1**2*k2**2*(D1*fd*(-f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(k1**2*(8*K + 3) + k2**2*(21 - 28*K))) - Dd*f*(f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7)) - (r + s)*(k1**2*(8*K + 3) + k2**2*(21 - 28*K)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 8*gd2*k2**2*(2*k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 528*fd*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 528*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(35*f**2*fd*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 264*gd2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(r + s - 1)) - 3432*fd*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5)) + 65*f*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 3432*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s)))))/(3003*d**2*k3**8) + 16*D1**3*Pk1*Pk3*ct**3*k2**3*st**2*(-13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 34*K*r + 34*K*s - 12*K - 2*b1*(79*r + 79*s - 41) + 41*r + 41*s - 27)) + k1**2*k2**2*(r + s)*(-132*b1*(16 - 19*K) - 2508*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(158*r**2 + r*(316*s - 161) + 158*s**2 - 161*s + 41) + (32 - 38*K)*(r + s)**2) + Dd*f*(f*(79*r + 79*s - 41) + (32 - 38*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 33*f*k1**2*(fd*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27))*(2*r + 2*s - 1) - 76*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2508*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27)) - 2508*g2*k1**2*k2**2*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(k1**2*(-1229*r - 1229*s + 847) + 65*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 26*f*k1**2*(fd*(k1**2*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 66*gd2*k2**2*(17*r**2 + r*(34*s - 23) + 17*s**2 - 23*s + 6)) + 1716*fd*g2*k1**2*k2**2*(34*r**2 + r*(68*s - 29) + 34*s**2 - 29*s + 6)) - Dd*f*(4*r + 4*s - 3)*(25*f**2*(k1**2*k2**2*(1229*r + 1229*s - 847) - 65*k2**4*(5*r + 5*s - 3)) + 26*f*(k1**4*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 1716*g2*k1**2*k2**2*(17*r + 17*s - 6))))/(3003*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct**3*k2*st**2*(13*D1*bd1*f*(2*f**2*k2**4*(1578*r**2 + r*(1659*s - 1702) + 81*s**2 - 724*s + 171) + 33*f*(4*k1**4*(C*(r*(199*s - 69) + 199*s**2 - 238*s + 69) + r*(45 - 127*s) - 127*s**2 + 154*s - 45) + k1**2*k2**2*(-4*C*(227*r**2 + r*(484*s - 347) + 257*s**2 - 326*s + 120) + 719*r**2 + 1613*r*s - 1115*r + 894*s**2 - 1092*s + 396) + 2*k2**4*(6*C*(6*r**2 + 6*r*s - 7*r - 2*s + 1) - 8*K*r**2 - 8*K*r*s + 6*K*r + b1*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 31) - 31*r**2 - 34*r*s + 42*r - 3*s**2 + 18*s - 9)) + 66*k2**2*(b1*(k1**2*(50*C - 44)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(r**2*(2*K + 10) + r*(K*(2*s - 5) + 22*s - 7) + 3*s*(K + 4*s - 5))) - 2*g2*k2**2*(r**2 + r*(s - 1) + 3*s))) + 858*b1**2*k2**2*(D1*fd*(k1**2*(50*C - 44)*(r + s - 1)**2 + k2**2*(f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 41) + (r + s)*(r*(K + 5) + 6*s))) + Dd*f*(k1**2*(50*C - 44)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(2*f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 36) + r**2*(4*K + 20) + r*(4*K*s - 9*K + 44*s - 9) + 3*s*(K + 8*s - 7)))) + 13*b1*(3*D1*(2*f**2*fd*k2**4*(1578*r**2 + r*(1659*s - 1018) + 81*s**2 - 86*s + 68) + 11*f*(fd*(4*k1**4*(C*(r*(398*s - 218) + 398*s**2 - 437*s + 119) + r*(140 - 254*s) - 254*s**2 + 281*s - 77) + k1**2*k2**2*(-4*C*(454*r**2 + r*(968*s - 465) + 514*s**2 - 466*s + 92) + 1438*r**2 + 2*r*(1613*s - 781) + 1788*s**2 - 1638*s + 331) + 2*k2**4*(-2*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + r**2*(72*C - 62) + r*(72*C*s - 36*C - 68*s + 29) - 6*s**2 + 3*s + 1)) - 4*gd2*k2**4*r*(r + s - 4)) - 44*fd*g2*k2**4*r*(r + s)) + Dd*f*(2*f**2*k2**4*(6312*r**2 + r*(6636*s - 4756) + 324*s**2 - 982*s + 375) + 33*f*(4*k1**4*(C*(r*(796*s - 436) + 796*s**2 - 993*s + 307) + r*(280 - 508*s) - 508*s**2 + 639*s - 199) + k1**2*k2**2*(-4*C*(908*r**2 + r*(1936*s - 1207) + 1028*s**2 - 1166*s + 329) + 2876*r**2 + r*(6452*s - 4007) + 3576*s**2 - 4037*s + 1140) + 2*k2**4*(6*C*(24*r**2 + 6*r*(4*s - 3) - 2*s + 1) + K*(-32*r**2 - 32*r*s + 28*r + 6*s - 4) - 124*r**2 - 136*r*s + 101*r - 12*s**2 + 27*s - 11)) - 132*g2*k2**4*(4*r**2 + r*(4*s - 9) + 3*s))) + f*(D1*(4*f**2*fd*k2**4*(34048*r**2 + r*(18318*s - 30629) - 15730*s**2 + 3994*s + 5175) + 13*f*(fd*(6*k1**4*(2*C*(r*(4773*s - 2207) + 4773*s**2 - 5433*s + 1486) + r*(2817 - 6042*s) - 6042*s**2 + 6944*s - 1911) + k1**2*k2**2*(-4*C*(13131*r**2 + 9*r*(3441*s - 1786) + 17838*s**2 - 18618*s + 4682) + 41643*r**2 + 9*r*(11261*s - 5995) + 59706*s**2 - 63720*s + 16703) + 396*k2**4*(C*(18*r**2 + r*(18*s - 13) - 2*s + 1) - 24*r**2 + r*(20 - 30*s) - 6*s**2 + 9*s - 3)) + 264*gd2*k2**4*r*(4*r + 4*s - 3)) + 3432*fd*g2*k2**4*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + Dd*f*(4*f**2*k2**4*(34048*r**2 + r*(18318*s - 30629) - 15730*s**2 + 3994*s + 5175) + 13*f*(6*k1**4*(2*C*(6364*r*s - 3264*r + 6364*s**2 - 7935*s + 2397) - 8056*r*s + 4134*r - 8056*s**2 + 10119*s - 3072) + k1**2*k2**2*(-4*C*(17508*r**2 + 41292*r*s - 23667*r + 23784*s**2 - 27194*s + 7312) + 55524*r**2 + 135132*r*s - 80125*r + 79608*s**2 - 93373*s + 26454) + 396*k2**4*(C*(24*r**2 + 6*r*(4*s - 3) - 2*s + 1) - 32*r**2 - 4*r*(10*s - 7) - 8*s**2 + 12*s - 4)) + 3432*g2*k2**4*(16*r**2 + 2*r*(8*s - 7) - 3*s + 2))))/(9009*d**2*k1*k3**6) - 16*D1**3*Pk1*Pk3*ct**3*st**2*(D1*bd1*f**2*s*(3*s - 2) + 2*b1**2*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(4*D1*bd1*s*(s - 1) + D1*fd*(6*s**2 - 7*s + 2) + 2*Dd*f*(6*s**2 - 7*s + 2)))/(7*d**2*k1*k2) - 2*D1**3*Pk1*Pk3*ct**3*(429*b1**2*(D1*fd*(k1**4*(80*C - 40)*(s - 1)*(r + s - 1) + k1**2*k2**2*(-16*C*(10*r**2 + 41*r*(s - 1) + 31*(s - 1)**2) + 100*r**2 + r*(14*K*s + 12*f*s - 8*f + 471*s - 478) + 378*(s - 1)**2) + 2*k2**4*(56*C*r**2 + 56*C*r*s - 56*C*r + K*(-5*r**2 + 31*r*s - 12*r - 6*s + 6) + 2*f*(22*r**2 + r*(34*s + 5) + 12*s**2 - s - 10) - 70*r**2 - 109*r*s + 68*r - 3*s**2 + 6*s - 6)) + Dd*f*(k1**4*(32*C - 16)*(10*r*s - 11*r + 10*s**2 - 18*s + 8) + k1**2*k2**2*(-16*C*(40*r**2 + 2*r*(82*s - 49) + 124*s**2 - 189*s + 65) + 56*K*r*s - 14*K*s + 2*f*(4*r - 1)*(3*s - 2) + 400*r**2 + 1884*r*s - 1072*r + 1512*s**2 - 2269*s + 764) + 2*k2**4*(224*C*r**2 + 224*C*r*s - 168*C*r + K*(-20*r**2 + 124*r*s - 113*r - 80*s + 54) + 2*f*(44*r**2 + r*(68*s - 23) + 24*s**2 - 19*s - 2) - 280*r**2 - 436*r*s + 378*r - 12*s**2 + 69*s - 54))) + 13*b1*(33*D1*bd1*f*(k1**4*(32*C - 16)*(r*(5*s - 6) + 5*s**2 - 8*s + 3) + k1**2*k2**2*(-16*C*(20*r**2 + 2*r*(41*s - 8) + 62*s**2 - 65*s + 3) + 28*K*r*s - 14*K*s + 2*f*(2*r - 1)*(3*s - 2) + 200*r**2 + 942*r*s - 116*r + 756*s**2 - 757*s + 8) + 4*k2**4*(56*C*r**2 + 56*C*r*s - 28*C*r + K*(-5*r**2 + 31*r*s - 24*r - 25*s + 12) + 2*f*(11*r**2 + r*(17*s - 14) + 6*s**2 - 9*s + 4) - 70*r**2 - 109*r*s + 81*r - 3*s**2 + 18*s - 12)) + 3*D1*(2*f**2*fd*k2**2*(22*k1**2*(r*(6*s - 3) - 3*s + 2) + k2**2*(2514*r**2 + 2*r*(531*s - 1963) - 3168*s**2 - 310*s + 1625)) - 11*f*(fd*(2*k1**4*(4*C*(r*(5*s - 27) + 202*s**2 - 275*s + 81) + r*(54 - 10*s) - 474*s**2 + 671*s - 205) + k1**2*k2**2*(4*C*(144*r**2 - 126*r*s + 223*r - 32*s**2 + 156*s - 130) - 8*K*s - 352*r**2 + 4*r*(4*K*s + 55*s - 133) - 160*s**2 - 257*s + 336) - 2*k2**4*(4*C*(23*r**2 + r*(24 - 76*s) - s + 1) + K*(-110*r**2 - 36*r*s + 151*r + 117*s - 48) + 150*r**2 + 714*r*s - 462*r + 230*s**2 - 414*s + 118)) + 4*gd2*k2**2*(7*k1**2*r*s + k2**2*(-5*r**2 + 31*r*s - 53*r - 24*s + 24))) + 44*fd*g2*k2**2*(-7*k1**2*r*s + k2**2*(5*r**2 - 31*r*s + 12*r + 6*s - 6))) + 2*Dd*f*(f**2*k2**2*(66*k1**2*(4*r - 1)*(2*s - 1) + k2**2*(10056*r**2 + 2*r*(2124*s - 8299) - 12672*s**2 - 2702*s + 7509)) - 33*f*(k1**4*(2*C*(4*r*(5*s - 27) + 808*s**2 - 1169*s + 407) - 4*r*(5*s - 27) - 948*s**2 + 1411*s - 493) + k1**2*k2**2*(2*C*(288*r**2 + r*(326 - 252*s) - 64*s**2 + 314*s - 209) - 4*K*s - 352*r**2 + 4*r*(4*K*s + 55*s - 94) - 160*s**2 - 225*s + 241) - k2**4*(2*C*(92*r**2 + r*(125 - 304*s) - 2*s + 2) + K*(-220*r**2 - 72*r*s + 297*r + 241*s - 172) + 300*r**2 + 1428*r*s - 1047*r + 460*s**2 - 851*s + 375)) + 66*g2*k2**2*(7*k1**2*s*(1 - 4*r) + k2**2*(20*r**2 + r*(113 - 124*s) + 80*s - 54)))) + f*(13*D1*bd1*(4*f**2*k2**2*(33*k1**2*(r*(2*s - 1) + s - 1) + k2**2*(1257*r**2 + r*(531*s - 2410) - 1584*s**2 - 886*s + 1317)) - 33*f*(2*k1**4*(2*C*(r*(5*s - 43) + 202*s**2 - 235*s + 63) + r*(43 - 5*s) - 237*s**2 + 278*s - 63) + k1**2*k2**2*(4*C*(72*r**2 - 9*r*(7*s + 3) - 16*s**2 + 72*s - 9) - 176*r**2 + 2*r*(4*K*s + 55*s + 37) - 80*s**2 - 117*s - 10) - 2*k2**4*(K*(-55*r**2 + r*(73 - 18*s) + 62*s - 62) + r**2*(46*C + 75) + r*(-152*C*s + 2*C + 357*s - 168) + 115*s**2 - 169*s + 104)) + 132*g2*k2**2*(-7*k1**2*s*(r - 1) + k2**2*(5*r**2 - r*(31*s + 5) + 26*s))) + D1*(-30*f**2*fd*k2**2*(65*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(2908*r**2 + 11*r*(728*s - 573) + 5720*s**2 - 11466*s + 4696)) + 13*f*(-132*bd2*k2**4*(6*r**2 + 6*r*s - 17*r - 10*s + 10) + 2*fd*k1**4*(12*C*(r*(201*s + 637) - 2337*s**2 + 3273*s - 1066) - 6*r*(201*s + 637) + 16191*s**2 - 23922*s + 7583) + fd*k1**2*k2**2*(-4*C*(21942*r**2 + 6*r*(3297*s - 4813) + 108*s**2 - 28479*s + 14471) + 56124*r**2 + 27*r*(2507*s - 3000) + 17514*s**2 - 95685*s + 43192) - 66*fd*k2**4*(2*C*(51*r**2 + r*(270*s - 109) - 4*s + 2) - 261*r**2 - 963*r*s + 419*r - 258*s**2 + 228*s - 51) + 132*gd2*k2**2*(4*k1**2*r*s + k2**2*(55*r**2 + 18*r*s - 73*r - 62*s + 62))) - 1716*fd*k2**2*(3*b2*k2**2*(2*r - 3)*(2*r + 2*s - 1) + 4*g2*k1**2*s*(1 - 2*r) + g2*k2**2*(-110*r**2 + r*(151 - 36*s) + 117*s - 48))) + Dd*f*(-30*f**2*k2**2*(65*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(2908*r**2 + 11*r*(728*s - 573) + 5720*s**2 - 11466*s + 4696)) + 13*f*(8*k1**4*(C*(4*r*(201*s + 502) - 9348*s**2 + 14447*s - 5489) - 2*r*(201*s + 502) + 5397*s**2 - 8772*s + 3338) + k1**2*k2**2*(-4*C*(29256*r**2 + 12*r*(2198*s - 3317) + 144*s**2 - 37667*s + 23623) + 74832*r**2 + 12*r*(7521*s - 9482) + 23352*s**2 - 129961*s + 71630) - 66*k2**4*(2*C*(68*r**2 + r*(360*s - 197) - 4*s + 2) - 348*r**2 + r*(735 - 1284*s) - 344*s**2 + 357*s - 94)) - 1716*k2**2*(b2*k2**2*(24*r**2 + r*(24*s - 58) - 38*s + 29) + g2*(4*k1**2*s*(1 - 4*r) + k2**2*(-220*r**2 - 72*r*s + 297*r + 241*s - 172))))))/(9009*d**2*k1*k2*k3**4) + 8*D1**3*Pk1*Pk3*ct**3*(13*D1*bd1*f*(f**2*k2**4*(k1**2*(1566*r**2 - r*(2004*s + 1685) - 3570*s**2 + 2661*s + 707) + 66*k2**2*(26*r**2 + r*(s - 26) - 25*s**2 + 4*s + 1)) - 33*f*(k1**6*(8*C - 4)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k1**4*k2**2*(20*C*(11*r**2 + r*(s - 10) - 10*s**2 + 10*s - 1) - 136*r**2 + r*(146 - 57*s) + 79*s**2 - 83*s - 10) + k1**2*k2**4*(4*C*(244*r**2 + 5*r*(89*s - 71) + 201*s**2 - 273*s + 111) + 156*K*r**2 + 250*K*r*s - 426*K*r + 94*K*s**2 - 358*K*s + 264*K - b1*(114*r**2 + r*(270*s - 169) + 156*s**2 - 247*s + 73) - 940*r**2 - 1763*r*s + 1472*r - 823*s**2 + 1215*s - 546) - 2*k2**6*(6*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + r**2*(25 - 13*K) + r*(-13*K*s + 12*K + 37*s - 24) + s*(12*s - 12))) + 66*k2**2*(15*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(-k1**4*(12*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(84*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*K*(61*r**2 + 80*r*s - 65*r + 19*s**2 - 23*s + 4) - 179*r**2 - 314*r*s + 265*r - 135*s**2 + 201*s - 76) - 28*k2**4*(r*(K - 2) - s)*(r + s - 1)) + 2*k2**2*(r + s - 1)*(10*b2*k1**2*(r + s) - g2*k1**2*(61*r + 19*s) + 14*g2*k2**2*r))) + 12870*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k2**2*(D1*fd*(k1**4*(8 - 24*C)*(r + s - 1)**2 + k1**2*k2**2*(168*C*(r + s - 1)**2 + 122*K*r**2 + 160*K*r*s - 32*K*r + 38*K*s**2 - 32*K*s + 16*K + 2*f*(57*r**2 + 135*r*s - 68*r + 78*s**2 - 83*s + 25) - 179*r**2 - 314*r*s + 304*r - 135*s**2 + 304*s - 152) + 4*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-7*r*(K - 2) + 7*s))) + Dd*f*(-k1**4*(24*C - 8)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(168*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 488*K*r**2 + 640*K*r*s - 430*K*r + 152*K*s**2 - 178*K*s + 48*K + f*(228*r**2 + 540*r*s - 305*r + 312*s**2 - 413*s + 123) - 716*r**2 - 1256*r*s + 1185*r - 540*s**2 + 993*s - 456) + 4*k2**4*(4*r + 4*s - 3)*(6*f*(3*r + 3*s - 2) + r*(14 - 7*K) + 7*s))) + 13*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(1566*r**2 - r*(2004*s + 1727) - 3570*s**2 + 1059*s + 757) + 22*k2**2*(78*r**2 + 3*r*(s - 6) - 75*s**2 + 72*s - 10)) - 11*f*(fd*(k1**6*(16*C - 8)*(s - 2)*(2*r + 2*s - 1) + k1**4*k2**2*(4*C*(110*r**2 + 2*r*(5*s + 18) - 100*s**2 + 200*s - 77) - 272*r**2 - 3*r*(38*s + 13) + 158*s**2 - 429*s + 183) + k1**2*k2**4*(4*C*(488*r**2 + r*(890*s - 423) + 402*s**2 - 367*s + 65) + 4*K*(78*r**2 + 125*r*s - 161*r + 47*s**2 - 149*s + 61) - 1880*r**2 - 3526*r*s + 1913*r - 1646*s**2 + 1803*s - 413) + 2*k2**6*(r**2*(26*K - 50) + r*(13*K*(2*s - 1) - 74*s + 25) - s*(K + 24*s - 13))) - 4*k2**4*(r + s - 1)*(10*bd2*k1**2*(r + s) + gd2*k1**2*(-61*r - 19*s + 8) + 14*gd2*k2**2*r)) + 44*fd*k2**4*(10*b2*k1**2*(r + s)**2 - g2*k1**2*(61*r**2 + 16*r*(5*s - 1) + 19*s**2 - 16*s + 8) + 14*g2*k2**2*r*(r + s))) + 2*Dd*f*(f**2*k2**4*(k1**2*(3132*r**2 - r*(4008*s + 3433) - 7140*s**2 + 2919*s + 1489) + 33*k2**2*(104*r**2 + 4*r*(s - 11) - 100*s**2 + 76*s - 9)) - 33*f*(k1**6*(4*C - 2)*(8*r*(s - 2) + 8*s**2 - 24*s + 13) + k1**4*k2**2*(2*C*(220*r**2 + r*(20*s + 9) - 200*s**2 + 373*s - 155) - 272*r**2 + r*(45 - 114*s) + 158*s**2 - 379*s + 170) + k1**2*k2**4*(2*C*(976*r**2 + 2*r*(890*s - 581) + 804*s**2 - 942*s + 277) + 2*K*(156*r**2 + 250*r*s - 374*r + 94*s**2 - 328*s + 193) - 1880*r**2 - 3526*r*s + 2509*r - 1646*s**2 + 2197*s - 756) + k2**6*(r**2*(52*K - 100) + r*(K*(52*s - 37) - 148*s + 73) - s*(K + 48*s - 37))) + 66*k2**4*(4*r + 4*s - 3)*(10*b2*k1**2*(r + s) + g2*k1**2*(-61*r - 19*s + 8) + 14*g2*k2**2*r))) + f*(D1*(-5*f**2*fd*k2**4*(k1**2*(41812*r**2 + r*(112636*s - 96685) + 70824*s**2 - 119497*s + 49521) + 52*k2**2*(120*r**2 + 5*r*(146*s - 83) + 610*s**2 - 701*s + 203)) - 13*f*(fd*k1**2*(k1**4*(40*C - 20)*(3*s - 23)*(3*r + 3*s - 2) + k1**2*k2**2*(4*C*(10107*r**2 + 9*r*(1239*s - 1312) + 1044*s**2 - 4974*s + 3116) - 25164*r**2 - 33543*r*s + 31719*r - 8379*s**2 + 17394*s - 8917) + 33*k2**4*(4*C*(729*r**2 + 1326*r*s - 829*r + 597*s**2 - 697*s + 214) - 2367*r**2 - 4437*r*s + 2773*r - 2070*s**2 + 2420*s - 745)) - 132*k2**4*(4*bd2*k1**2*(r**2 + 2*r*s + s**2 - 1) + gd2*k1**2*(78*r**2 + r*(125*s - 213) + 47*s**2 - 179*s + 132) + gd2*k2**2*r*(13*r + 13*s - 12))) + 1716*fd*k2**4*(4*b2*k1**2*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 2*g2*k1**2*(78*r**2 + r*(125*s - 161) + 47*s**2 - 149*s + 61) + g2*k2**2*(26*r**2 + 13*r*(2*s - 1) - s))) + Dd*f*(-5*f**2*k2**4*(k1**2*(41812*r**2 + r*(112636*s - 96685) + 70824*s**2 - 119497*s + 49521) + 52*k2**2*(120*r**2 + 5*r*(146*s - 83) + 610*s**2 - 701*s + 203)) - 13*f*k1**2*(k1**4*(80*C - 40)*(r*(6*s - 41) + 6*s**2 - 48*s + 32) + 2*k1**2*k2**2*(2*C*(13476*r**2 + 3*r*(4956*s - 5371) + 1392*s**2 - 6371*s + 4165) - 16776*r**2 - 22362*r*s + 21969*r - 5586*s**2 + 11774*s - 6139) + 33*k2**4*(4*C*(972*r**2 + 1768*r*s - 1217*r + 796*s**2 - 1011*s + 329) - 3156*r**2 - 5916*r*s + 4101*r - 2760*s**2 + 3527*s - 1162)) + 1716*k2**4*(4*b2*k1**2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 2*g2*k1**2*(156*r**2 + r*(250*s - 374) + 94*s**2 - 328*s + 193) + g2*k2**2*(52*r**2 + r*(52*s - 37) - s)))))/(9009*d**2*k1*k2*k3**6) + 4*D1**3*Pk1*Pk3*ct**3*(D1*bd1*f**2*(k1**2*(r*(2*C - 1)*(11*s + 3) + s*(-40*C + 35*s - 23)) + 3*k2**2*r*(4*r + 3)) + b1**2*(D1*fd*(59*k1**2*(s - 1)**2 + 18*k2**2*r**2) + 2*Dd*f*(59*k1**2*(2*s**2 - 3*s + 1) + 9*k2**2*r*(4*r - 1))) + b1*f*(D1*(118*bd1*k1**2*s*(s - 1) + 18*bd1*k2**2*r*(2*r - 1) + 2*fd*k1**2*(C*(22*r*s - 10*r - 35*s + 17) - 11*r*s + 5*r + 35*s**2 - 43*s + 13) + 3*fd*k2**2*(8*r**2 + 2*r - 3)) + Dd*f*(k1**2*(2*C*(44*r*s - 20*r - 75*s + 37) - 44*r*s + 20*r + 140*s**2 - 167*s + 49) + 3*k2**2*(16*r**2 + 8*r - 3))))/(21*d**2*k1**3*k2) - 2*D1**3*Pk1*Pk3*ct**3*st**2*(264*b1**2*k1**2*(D1*fd*(s - 1)*(k1**2*(24*C - 18)*(s - 1) + k2**2*r*(C - 1)) + Dd*f*(k1**2*(48*C - 36)*(2*s**2 - 3*s + 1) + k2**2*(C - 1)*(4*r*(s + 1) + 3*s - 3))) - 33*b1*f*(2*D1*(-4*bd1*k1**2*(k1**2*s*(48*C - 36)*(s - 1) + k2**2*(C - 1)*(2*r*(s + 3) + 3*s - 3)) + fd*(k1**4*(1 - 2*s)**2*(64*C - 32) + k1**2*k2**2*(2*C*(2*r*(17*s - 7) - 13*s + 5) - r*(25*s + 2) + 236*s**2 - 210*s + 49) + 8*k2**4*r**2)) + Dd*f*(k1**4*(1 - 2*s)**2*(256*C - 128) + k1**2*k2**2*(4*C*(4*r*(17*s - 7) - 13*s + 5) - 4*r*(25*s + 2) + 944*s**2 - 927*s + 242) + 8*k2**4*r*(4*r - 1))) + f**2*(D1*(-33*bd1*(k1**4*s*(128*C - 64)*(2*s - 1) + k1**2*k2**2*(r*(68*C*s - 20*C - 25*s - 6) + 236*s**2 - 153*s + 26) + 8*k2**4*r*(r - 1)) + fd*(-16*k1**4*(3*s - 1)*(C*(906*s - 500) - 579*s + 325) + k1**2*k2**2*(-4*C*(3*r*(426*s - 109) - 1218*s + 373) + 9*r*(15*s + 116) - 16524*s**2 + 9849*s - 1810) - 4*k2**4*(558*r**2 - 471*r + 95))) + Dd*f*(-32*k1**4*(2*s - 1)*(C*(906*s - 500) - 579*s + 325) + k1**2*k2**2*(-4*C*(1704*r*s - 908*r - 1718*s + 873) + 180*r*s + 24*r - 22032*s**2 + 16135*s - 2588) - 4*k2**4*(744*r**2 - 566*r + 95))))/(693*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct**3*(33*b1**2*(D1*fd*(2*k1**4*(s - 1)*(40*C*r + 236*C*(s - 1) - 20*r - 177*s + 177) + k1**2*k2**2*(2*f*(r*(4*s - 2) + s - 1) + r*(-212*C*(s - 1) + 205*s - 212)) + k2**4*r**2*(8*f + 36)) + Dd*f*(4*k1**4*(4*C*(r*(20*s - 22) + 118*s**2 - 183*s + 65) + r*(44 - 40*s) - 354*s**2 + 543*s - 189) - k1**2*k2**2*(8*C*(r*(106*s - 55) - s + 1) - 2*f*(4*r - 1)*(2*s - 1) - 820*r*s + 440*r + s - 8) + k2**4*r*(4*f + 36)*(4*r - 1))) + 3*b1*f*(11*D1*bd1*(4*k1**4*(4*C*(2*r*(5*s - 6) + 59*s**2 - 65*s + 6) - 4*r*(5*s - 6) - 177*s**2 + 189*s - 12) - k1**2*k2**2*(8*C*(r*(53*s - 2) - s + 1) + f*(-8*r*s + 4*r + 6*s - 4) - 410*r*s + 16*r + s - 8) + k2**4*r*(4*f + 36)*(2*r - 1)) + D1*fd*(-k1**4*(44*C - 22)*(124*s**2 - 101*s + 7) + 11*k1**2*k2**2*(4*C*(24*r**2 - 5*r*(8*s + 3) - 79*s + 51) - 4*K*r*s + 2*K*s + 4*f*(3*r - 1)*(3*s - 2) - 48*r**2 + 108*r + 48*s**2 + 265*s - 182) + 2*k2**4*(4*f*(9*r**2 + 93*r - 32) - 264*r**2 + 66*r - 99)) + 2*Dd*f*(-k1**4*(88*C - 44)*(62*s**2 - 61*s + 15) + 11*k1**2*k2**2*(2*C*(48*r**2 - 2*r*(40*s + 9) - 163*s + 93) - 4*K*r*s + K*s + 2*f*(4*r - 1)*(3*s - 2) - 48*r**2 + 84*r + 48*s**2 + 280*s - 170) + k2**4*(4*r - 1)*(4*f*(3*r + 32) - 132*r + 99))) + f*(3*D1*bd1*f*(-k1**4*(44*C - 22)*(62*s**2 - 51*s + 23) + 11*k1**2*k2**2*(r**2*(48*C - 24) - 2*r*(2*C*(20*s + 9) + K*s - 6*f*s + 4*f - 8) + 24*s**2 + s*(163 - 168*C) - 2) + 2*k2**4*r*(4*f*(3*r + 32) - 132*r + 363)) + D1*(f*fd*(2*k1**4*(4*C*(9*r*(87*s + 59) - 4752*s**2 + 4755*s - 1321) - 18*r*(87*s + 59) + 11673*s**2 - 13794*s + 3829) + k1**2*k2**2*(-4*C*(1818*r**2 + 3*r*(990*s - 943) - 4026*s + 1753) + 6876*r**2 + 39*r*(219*s - 254) + 3168*s**2 - 23835*s + 9182) + 1188*k2**4*r*(1 - 3*r)) - 66*f*k1**2*k2**2*r*s*(bd2 - 2*gd2) - 66*fd*k1**2*k2**2*s*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(f*(8*k1**4*(C*(4*r*(261*s + 92) - 6336*s**2 + 7313*s - 2295) - 2*r*(261*s + 92) + 3891*s**2 - 5205*s + 1741) + k1**2*k2**2*(-4*C*(2424*r**2 + r*(3960*s - 4186) - 5346*s + 3073) + 9168*r**2 + 156*r*(73*s - 91) + 4224*s**2 - 32411*s + 16702) + 1188*k2**4*r*(1 - 4*r)) + k1**2*k2**2*s*(-66*b2 + 132*g2)*(4*r - 1))))/(693*d**2*k1**3*k2*k3**2) - 2*D1**3*Pk1*Pk3*ct**3*st**2*(3432*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(37*C - 31)*(s - 1) + k2**2*r*(C - 1))*(r + s - 1) + Dd*f*(k1**2*(C*(4*r*(37*s - 26) + 148*s**2 - 237*s + 89) - 2*r*(62*s - 43) - 124*s**2 + 198*s - 74) + k2**2*(C - 1)*(4*r**2 + 4*r*s + 3*r + 3*s - 3))) - 39*b1*f*(-2*D1*(44*bd1*k1**2*k2**2*(k1**2*(C*(74*r*s - 30*r + 74*s**2 - 89*s + 15) - 62*r*s + 24*r - 62*s**2 + 74*s - 12) + k2**2*(C - 1)*(2*r**2 + 2*r*s + 5*r + 3*s - 3)) + fd*(360*f*k2**6*r**2 + 44*k1**6*(2*s - 1)*(8*C*(13*s - 8) - 61*s + 38) - 11*k1**4*k2**2*(4*C*(356*r*s - 191*r + 462*s**2 - 420*s + 91) + r*(558 - 1029*s) - 1492*s**2 + 1366*s - 299) - 11*k1**2*k2**4*(4*C*(21*r**2 - r*(18*s + 5) - 6*s + 6) + 2*K*r*s - K*s + f*(12*r*s - 9*r + 2*s - 1) - 18*r**2 + 372*r*s - 142*r + 236*s**2 - 211*s + 35))) + Dd*f*(240*f*k2**6*r*(1 - 4*r) - 176*k1**6*(2*s - 1)*(8*C*(13*s - 8) - 61*s + 38) + 11*k1**4*k2**2*(4*C*(4*r*(356*s - 191) + 1848*s**2 - 2016*s + 559) + r*(2232 - 4116*s) - 5968*s**2 + 6477*s - 1790) + 22*k1**2*k2**4*(2*C*(84*r**2 - 9*r*(8*s + 1) - 16*s + 14) + 4*K*r*s - K*s + f*(4*r - 1)*(4*s - 3) - 36*r**2 + 744*r*s - 339*r + 472*s**2 - 468*s + 110))) + f*(D1*(2*f**2*k2**4*(-429*bd1*k1**2*(r*(4*s - 3) - 6*s + 4) + 4680*bd1*k2**2*r*(r - 1) + 2*fd*(4*r - 1)*(-1118*k1**2*(3*s - 2) + 15*k2**2*(111*r + 34))) + 13*f*k1**2*(33*bd1*(8*k1**4*s*(8*C*(13*s - 8) - 61*s + 38) + k1**2*k2**2*(-4*C*(r*(356*s - 135) + 462*s**2 - 502*s + 165) + 3*r*(343*s - 134) + 1492*s**2 - 1559*s + 498) - 2*k2**4*(C*(42*r**2 - 2*r*(18*s + 19) - 8*s + 4) - 9*r**2 + r*(s*(K + 186) - 15) + 118*s**2 - 80*s + 16)) + fd*(16*k1**4*(3*s - 1)*(10*C*(141*s - 80) - 831*s + 475) - 3*k1**2*k2**2*(4*C*(r*(9483*s - 4679) + 13092*s**2 - 12131*s + 3095) + r*(14032 - 28137*s) - 41772*s**2 + 39229*s - 9986) + 2*k2**4*(C*(-9270*r**2 + 6*r*(642*s + 1729) + 3072*s - 3880) + 5913*r**2 - 3*r*(4929*s + 1321) - 8262*s**2 + 5322*s + 1451)) + 132*gd2*k2**4*r*s) + 1716*fd*g2*k1**2*k2**4*s*(2*r - 1)) + Dd*f*(4*f**2*k2**4*(4*r - 1)*(-1118*k1**2*(3*s - 2) + 15*k2**2*(111*r + 34)) + 13*f*(32*k1**6*(2*s - 1)*(10*C*(141*s - 80) - 831*s + 475) + k1**4*k2**2*(-4*C*(4*r*(9483*s - 4801) + 52368*s**2 - 54335*s + 14135) + 12*r*(9379*s - 4798) + 167088*s**2 - 176109*s + 46608) + 2*k1**2*k2**4*(C*(-12360*r**2 + 5136*r*s + 12506*r + 4376*s - 5184) + 7884*r**2 - 19716*r*s - 2291*r - 11016*s**2 + 8457*s + 1070)) + 1716*g2*k1**2*k2**4*s*(4*r - 1))))/(9009*d**2*k1**3*k2*k3**4) + D1**3*Pk1*Pk3*ct**2*f*k2**6*st**6*(160*C - 160)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(231*d**2*k3**8) + D1**3*Pk1*Pk3*ct**2*f*k2**4*st**6*(160*C - 160)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(693*d**2*k3**6) + D1**3*Pk1*Pk3*ct**2*f*k2**2*st**6*(160*C - 160)*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + 2*Dd*f*(6*s**2 - 5*s + 1)))/(693*d**2*k3**4) - 16*D1**3*Pk1*Pk3*ct**2*k1**2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 24*K*r + 24*K*s - 15*K - 2*b1*(7*r + 7*s - 2) - 52*r - 52*s + 41) - 18*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 132*k2**2*(r + s)*(b1*k1**2*(5 - 8*K) + 21*b1*k2**2*(1 - 2*K) + 8*g2*k1**2 + 42*g2*k2**2)) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(8*K - 5) + k2**2*(42*K - 21))) + Dd*f*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - (r + s)*(k1**2*(8*K - 5) + k2**2*(42*K - 21)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) - 4*gd2*k2**2*(4*k1**2 + 21*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) + 264*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 198*gd2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(r + s - 1)) - 2574*fd*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9)) + 65*f*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 2574*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s)))))/(3003*d**2*k3**8) - 16*D1**3*Pk1*Pk3*ct**2*k2**4*st**4*(78*D1*bd1*f*(r + s - 1)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + k2**2*(r + s)*(-22*K*b1 + 22*b1 + 22*g2)) - 858*b1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 78*b1*(D1*(20*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 11*f*(fd*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 2*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 22*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + 22*g2*k2**2*(r + s))) + f**2*(D1*fd*(5*f*k2**2*(3292*r**2 + r*(6584*s - 4769) + 3292*s**2 - 4769*s + 1725) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2)**2) + Dd*f*(5*f*k2**2*(823*r + 823*s - 575) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k3**8) + 16*D1**3*Pk1*Pk3*ct**2*k2**2*st**2*(429*D1*bd1*f*(r + s - 1)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) - 49*K*r - 49*K*s + 18*K + 12*b1*(13*r + 13*s - 7) - 41*r - 41*s + 30) + k2**4*(-12*b1*(2*r + 2*s - 1) + (K - 1)*(r + s))) + 2*k2**2*(r + s)*(b1*k1**2*(39 - 71*K) - 7*b1*k2**2*(K - 1) + g2*(71*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(71*K - 39) + k2**2*(7*K - 7))) + Dd*f*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1)) - (r + s)*(k1**2*(71*K - 39) + k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(3*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(-92*r - 92*s + 54) + K*(49*r + 49*s - 18) + 41*r + 41*s - 30) - k2**4*(K - 1)*(r + s)) + 2*gd2*k2**2*(71*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*fd*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) + K*(-49*r - 49*s + 18) - 41*r - 41*s + 30) + k2**4*(K - 1)*(r + s)) + 2*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(75*f**2*fd*k2**2*(-40*k1**2*(4*r + 4*s - 3) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 13*f*(fd*k1**2*(k1**2*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(r + s - 1)) - 858*fd*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(75*f**2*(40*k1**2*k2**2*(4*r + 4*s - 3) - 13*k2**4*(17*r + 17*s - 11)) + 13*f*(k1**4*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) + 858*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s)))))/(3003*d**2*k3**8) + 4*D1**3*Pk1*Pk3*ct**2*(1716*b1**3*k2**2*(k1**2 - 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(2*D1*(2*bd1*f*k2**2*(k1**2 - 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(8*C - 4)*(r + s - 1)**2 + k1**2*k2**2*(168*C*(r + s - 1)**2 - 41*K*r**2 - 110*K*r*s - 48*K*r - 69*K*s**2 - 48*K*s + 24*K + f*(263*r**2 + 667*r*s - 333*r + 404*s**2 - 404*s + 99) - 68*r**2 - 112*r*s + 248*r - 44*s**2 + 248*s - 124) + k2**4*(f*(357*r**2 + r*(753*s - 443) + 396*s**2 - 456*s + 147) + (-7*r - 7*s)*(r*(21*K - 21) + s*(9*K - 13))))) + Dd*f*(k1**4*(16*C - 8)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(336*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*K*(164*r**2 + 440*r*s - 27*r + 276*s**2 - 111*s - 72) + f*(1052*r**2 + r*(2668*s - 1611) + 1616*s**2 - 2039*s + 619) - 544*r**2 - 128*r*(7*s - 11) - 352*s**2 + 1252*s - 744) + k2**4*(f*(1428*r**2 + r*(3012*s - 1985) + 1584*s**2 - 2037*s + 653) - 14*r**2*(84*K - 84) - 14*r*(3*K*(40*s - 21) - 136*s + 67) - 14*s*(9*K*(4*s - 3) - 52*s + 37)))) + 13*b1*(33*D1*bd1*f*(k1**4*(16*C - 8)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(336*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 4*K*(41*r**2 + 110*r*s - 29*r + 69*s**2 - 57*s - 12) + f*(526*r**2 + r*(1334*s - 945) + 808*s**2 - 1231*s + 421) - 272*r**2 - 448*r*s + 524*r - 176*s**2 + 420*s - 248) + k2**4*(f*(714*r**2 + r*(1506*s - 1099) + 792*s**2 - 1125*s + 359) - 28*r**2*(21*K - 21) - 28*r*(3*K*(10*s - 7) - 34*s + 22) - 28*s*(9*K*(s - 1) - 13*s + 12))) + 3*D1*(f**2*fd*k2**2*(3*k1**2*(3485*r**2 + r*(5101*s - 4152) + 1616*s**2 - 3181*s + 1377) + 11*k2**2*(720*r**2 + r*(648*s - 439) - 72*s**2 + 77*s + 23)) - 22*f*(fd*(k1**4*(2*C*(92*r**2 + r*(122*s - 47) + 30*s**2 + 31*s - 27) - 92*r**2 + r*(61 - 150*s) - 58*s**2 - 5*s + 21) + k1**2*k2**2*(2*C*(662*r**2 + r*(1396*s - 715) + 734*s**2 - 751*s + 156) + K*(754*r**2 + 1280*r*s - 929*r + 526*s**2 - 833*s + 276) - 1262*r**2 - 2662*r*s + 1404*r - 1400*s**2 + 1530*s - 357) + k2**4*(r**2*(278*K - 274) + r*(K*(400*s - 139) - 444*s + 137) + s*(K*(122*s - 67) - 170*s + 77))) - 2*k2**2*(r + s - 1)*(2*bd2*(k1**2 - 7*k2**2)*(r + s) + gd2*k1**2*(41*r + 69*s + 24) + 21*gd2*k2**2*(7*r + 3*s))) + 44*fd*k2**2*(2*b2*(k1**2 - 7*k2**2)*(r + s)**2 + g2*k1**2*(41*r**2 + 2*r*(55*s + 24) + 69*s**2 + 48*s - 24) + 21*g2*k2**2*(7*r**2 + 10*r*s + 3*s**2))) + Dd*f*(f**2*k2**2*(k1**2*(41820*r**2 + r*(61212*s - 54443) + 19392*s**2 - 41411*s + 19203) + 66*k2**2*(480*r**2 + 4*r*(108*s - 91) - 48*s**2 - 20*s + 29)) - 66*f*(4*k1**4*(C*(92*r**2 + 122*r*s - 78*r + 30*s**2 + 12*s - 15) - 46*r**2 + r*(46 - 75*s) - 29*s**2 + 8*s + 4) + k1**2*k2**2*(2*C*(1324*r**2 + r*(2792*s - 1905) + 1468*s**2 - 1857*s + 606) + K*(1508*r**2 + 2560*r*s - 2279*r + 1052*s**2 - 1951*s + 868) - 2524*r**2 - 5324*r*s + 3671*r - 2800*s**2 + 3703*s - 1246) + k2**4*(r**2*(556*K - 548) + r*(5*K*(160*s - 81) - 888*s + 427) + s*(K*(244*s - 189) - 340*s + 247))) + 132*k2**2*(4*r + 4*s - 3)*(2*b2*(k1**2 - 7*k2**2)*(r + s) + g2*k1**2*(41*r + 69*s + 24) + 21*g2*k2**2*(7*r + 3*s)))) - f*(-13*D1*bd1*(f**2*k2**2*(k1**2*(10455*r**2 + r*(15303*s - 17075) + 4848*s**2 - 12782*s + 6810) + 33*k2**2*(240*r**2 + r*(216*s - 289) - 24*s**2 - 117*s + 35)) - 66*f*(k1**4*(2*C*(46*r**2 + r*(61*s - 62) + 15*s**2 - 11*s + 16) - 46*r**2 + r*(64 - 75*s) - 29*s**2 + 21*s - 18) + k1**2*k2**2*(2*C*(331*r**2 + r*(698*s - 553) + 367*s**2 - 511*s + 222) + K*(377*r**2 + 640*r*s - 675*r + 263*s**2 - 559*s + 296) - 631*r**2 - 1331*r*s + 1047*r - 700*s**2 + 1000*s - 416) + k2**4*(r**2*(139*K - 137) + r*(K*(200*s - 133) - 222*s + 145) + s*(61*K - 85)*(s - 1))) + 132*k2**2*(r + s - 1)*(2*b2*(k1**2 - 7*k2**2)*(r + s) + g2*k1**2*(41*r + 69*s) + 21*g2*k2**2*(7*r + 3*s))) + D1*(5*f**2*fd*k2**2*(4*k1**2*(7924*r**2 + r*(32364*s - 26033) + 24440*s**2 - 37861*s + 14788) + 39*k2**2*(972*r**2 + 3*r*(1300*s - 821) + 2928*s**2 - 3659*s + 1165)) + 26*f*(fd*k1**2*(k1**2*(2*C*(6840*r**2 + 12411*r*s - 9423*r + 5571*s**2 - 7290*s + 2813) - 6840*r**2 - 14301*r*s + 10053*r - 7461*s**2 + 9114*s - 3211) + 33*k2**2*(C*(2082*r**2 + 4296*r*s - 2796*r + 2214*s**2 - 2744*s + 892) - 1383*r**2 - 2931*r*s + 1881*r - 1548*s**2 + 1918*s - 615)) + 66*k2**2*(12*bd2*(k1**2*(r + s - 1) + k2**2*(r + s))*(r + s - 1) - gd2*(k1**2*(377*r**2 + r*(640*s - 675) + 263*s**2 - 559*s + 296) + k2**2*(139*r**2 + r*(200*s - 133) + s*(61*s - 61))))) + 1716*fd*k2**2*(12*b2*(k1**2*(r + s - 1) + k2**2*(r + s))*(2*r + 2*s - 1) - g2*(k1**2*(754*r**2 + r*(1280*s - 929) + 526*s**2 - 833*s + 276) + k2**2*(278*r**2 + r*(400*s - 139) + s*(122*s - 67))))) + Dd*f*(5*f**2*k2**2*(4*k1**2*(7924*r**2 + r*(32364*s - 26033) + 24440*s**2 - 37861*s + 14788) + 39*k2**2*(972*r**2 + 3*r*(1300*s - 821) + 2928*s**2 - 3659*s + 1165)) + 26*f*k1**2*(2*k1**2*(2*C*(4560*r**2 + 8274*r*s - 6861*r + 3714*s**2 - 5269*s + 2102) - 4560*r**2 - 9534*r*s + 7441*r - 4974*s**2 + 6670*s - 2475) + 33*k2**2*(2*C*(1388*r**2 + 2864*r*s - 2061*r + 1476*s**2 - 1993*s + 698) - 1844*r**2 - 3908*r*s + 2805*r - 2064*s**2 + 2801*s - 982)) + 1716*k2**2*(12*b2*(k1**2*(r + s - 1) + k2**2*(r + s))*(4*r + 4*s - 3) - g2*(k1**2*(1508*r**2 + r*(2560*s - 2279) + 1052*s**2 - 1951*s + 868) + k2**2*(556*r**2 + 5*r*(160*s - 81) + s*(244*s - 189)))))))/(9009*d**2*k3**6) - 4*D1**3*Pk1*Pk3*ct**2*k2**2*st**4*(-6864*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 13*b1*f*(3*D1*(-176*bd1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(5*f*k2**4*r*(89*r + 89*s - 63) + 88*k1**4*(2*C*(18*r*s - 7*r + 18*s**2 - 13*s + 2) - 28*r*s + 11*r - 28*s**2 + 20*s - 3) - 88*k1**2*k2**2*(r**2*(16*C - 22) + r*(16*C*s - 6*C - 28*s + 11) - 6*s**2 + 5*s - 1))) + Dd*f*(5*f*k2**4*(356*r**2 + r*(356*s - 293) - 17*s + 15) + 264*k1**4*(4*C*(18*r*s - 7*r + 18*s**2 - 14*s + 2) - 56*r*s + 22*r - 56*s**2 + 43*s - 6) - 264*k1**2*k2**2*(2*C*(16*r**2 + 2*r*(8*s - 5) - 5*s + 2) - 44*r**2 - 56*r*s + 33*r - 12*s**2 + 23*s - 7))) + f**2*(D1*(13*bd1*(5*f*k2**4*(89*r**2 + r*(89*s - 104) - 17*s + 15) + 528*k1**4*s*(C*(9*r + 9*s - 4) - 7*r - 7*s + 3) - 264*k1**2*k2**2*(2*C*(4*r**2 + r*(4*s - 6) - 5*s + 2) - 11*r**2 - 2*r*(7*s - 8) - 3*s**2 + 14*s - 5)) + fd*(f*k2**4*(26100*r**2 + r*(26100*s - 23201) - 5225*s + 3519) + k1**4*(19968*C - 13728)*(3*s - 1)*(3*r + 3*s - 2) - 52*k1**2*k2**2*(2*C*(1071*r**2 + 3*r*(507*s - 440) + 450*s**2 - 807*s + 371) - 2043*r**2 - 9*r*(337*s - 282) - 990*s**2 + 1671*s - 729))) + Dd*f*(f*k2**4*(26100*r**2 + r*(26100*s - 23201) - 5225*s + 3519) + k1**4*(9984*C - 6864)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 52*k1**2*k2**2*(2*C*(1428*r**2 + r*(2028*s - 1777) + 600*s**2 - 1075*s + 489) - 2724*r**2 - 4044*r*s + 3439*r - 1320*s**2 + 2252*s - 980))))/(3003*d**2*k1**2*k3**6) + 8*D1**3*Pk1*Pk3*ct**2*st**4*(264*b1**2*k1**2*(C - 1)*(s - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 132*b1*f*(4*D1*bd1*k1**2*s*(-C*s + C + s - 1) + D1*fd*(2*s - 1)*(k1**2*s + k2**2*r) + 2*Dd*f*(2*s - 1)*(k1**2*s + k2**2*r)) + f**2*(D1*(-132*bd1*s*(k1**2*s + k2**2*r) + fd*k1**2*(1 - 3*s)**2*(120*C - 100) + fd*k2**2*(3*r - 1)*(3*s + 10)) + Dd*f*(k1**2*(240*C - 200)*(6*s**2 - 5*s + 1) + k2**2*(2*r*(6*s + 25) + 2*s - 15))))/(231*d**2*k1**2*k3**2) + D1**3*Pk1*Pk3*ct**2*st**4*(D1*(2112*b1**2*fd*k1**2*k2**2*(C - 1)*(s - 1)*(r + s - 1) + 528*b1*f*(2*bd1*k1**2*k2**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + fd*(-k1**4*s*(8*C - 6)*(2*s - 1) + k1**2*k2**2*(r*(5*C*s - 13*s + 3) - 8*s**2 + 6*s - 1) + 2*k2**4*r*(r*(4*C - 6) - 2*s + 1))) - f**3*k2**4*(5*s - 3)*(55*bd1*(r - 1) + 31*fd*(1 - 4*r)) - f**2*(264*bd1*(k1**4*s**2*(16*C - 12) + k1**2*k2**2*(C*(-5*r*s - 2*r + s + 2) + 13*r*s + 2*r + 8*s**2 - 5*s - 2) + 4*k2**4*r*(-2*C*(r - 1) + 3*r + s - 3)) + fd*(k1**4*(1 - 3*s)**2*(2304*C - 1504) - 8*k1**2*k2**2*(4*C*(3*r*(189*s - 52) + 360*s**2 - 429*s + 92) - 297*r*(7*s - 2) - 1440*s**2 + 1653*s - 358) + k2**4*(-208*C*(1 - 3*r)**2 + 1800*r**2 + r*(825*b1*s - 495*b1 - 72*s - 912) + 24*s + 104)))) + Dd*f*(1056*b1**2*k1**2*k2**2*(C - 1)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) - 264*b1*f*(k1**4*s*(32*C - 24)*(2*s - 1) + k1**2*k2**2*(C*(-20*r*s + s + 2) + 52*r*s - 12*r + 32*s**2 - 27*s + 2) + 4*k2**4*r*(C*(2 - 8*r) + 12*r + 4*s - 5)) + 31*f**3*k2**4*(4*r - 1)*(5*s - 3) + f**2*(k1**4*(3008 - 4608*C)*(6*s**2 - 5*s + 1) + 8*k1**2*k2**2*(4*C*(756*r*s - 260*r + 480*s**2 - 615*s + 158) - 2772*r*s + 990*r - 1920*s**2 + 2392*s - 617) + k2**4*(208*C*(12*r**2 - 7*r + 1) - 55*b1*(4*r - 1)*(5*s - 3) - 2400*r**2 + 96*r*s + 1096*r + 16*s - 144))))/(231*d**2*k1**2*k3**4) - 4*D1**3*Pk1*Pk3*ct**2*st**2*(39*D1*bd1*f*(f**2*k2**4*(k1**2*(2112*r**2 + r*(3144*s - 2581) + 1032*s**2 - 2297*s + 527) - 66*k2**2*(r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(4*k1**4*(4*C*(r*(31*s - 12) + 31*s**2 - 40*s + 12) - 3*r*(23*s - 9) - 69*s**2 + 90*s - 27) - 2*k1**2*k2**2*(2*C*(325*r**2 + r*(853*s - 537) + 528*s**2 - 590*s + 212) - 433*r**2 + r*(724 - 1205*s) - 772*s**2 + 829*s - 291) + k2**4*(4*C*(109*r**2 + r*(137*s - 139) + 28*s**2 - 70*s + 30) - 8*K*(18*r**2 + r*(26*s - 19) + 8*s**2 - 11*s + 3) + b1*(510*r**2 + r*(1062*s - 785) + 552*s**2 - 783*s + 253) - 252*r**2 - 2*r*(142*s - 169) - 32*s**2 + 146*s - 78)) + 44*k1**2*k2**2*(-6*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(66*C - 47)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(14*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-100*r**2 - 150*r*s + 76*r - 50*s**2 + 72*s + 1) + 100*r**2 + 162*r*s - 65*r + 62*s**2 - 67*s - 15)) - 2*k2**2*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(-50*r**2 + r*(50 - 75*s) + s*(48 - 25*s))))) - 10296*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(132*C - 94)*(r + s - 1)**2 + k2**2*(28*C*(r + s - 1)**2 - 2*K*(50*r**2 + r*(75*s + 2) + 25*s**2 + 2*s - 1) + f*(255*r**2 + 531*r*s - 325*r + 276*s**2 - 330*s + 111) + 100*r**2 + 162*r*s + 60*r + 62*s**2 + 60*s - 30)) + Dd*f*(k1**2*(264*C - 188)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(56*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 4*K*(200*r**2 + 100*r*(3*s - 1) + 100*s**2 - 94*s - 3) + f*(1020*r**2 + r*(2124*s - 1435) + 1104*s**2 - 1443*s + 475) + 800*r**2 + 1296*r*s - 200*r + 496*s**2 - 212*s - 180))) + 39*b1*(D1*(3*f**2*fd*k2**4*(k1**2*(2112*r**2 + 3*r*(1048*s - 547) + 1032*s**2 - 1009*s + 293) - 66*k2**2*r*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*(2*k1**4*(4*C*(r*(62*s - 35) + 62*s**2 - 71*s + 20) - 3*r*(46*s - 26) - 138*s**2 + 159*s - 45) + k1**2*k2**2*(-2*C*(650*r**2 + 1706*r*s - 822*r + 1056*s**2 - 942*s + 183) + 866*r**2 + r*(2410*s - 1169) + 1544*s**2 - 1386*s + 275) + k2**4*(2*C*(218*r**2 + 2*r*(137*s - 68) + 56*s**2 - 52*s + 11) - 4*K*(36*r**2 + 52*r*s - 36*r + 16*s**2 - 22*s + 9) - 252*r**2 - 284*r*s + 120*r - 32*s**2 + 15*s + 8)) - 4*k2**4*(3*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-50*r**2 + r*(26 - 75*s) - 25*s**2 + 24*s + 1))) + 88*fd*k1**2*k2**4*(-3*b2*(r + s)**2 + g2*(50*r**2 + r*(75*s + 2) + 25*s**2 + 2*s - 1))) + 2*Dd*f*(f**2*k2**4*(k1**2*(4224*r**2 + 8*r*(786*s - 469) + 2064*s**2 - 2662*s + 703) - 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**4*(8*C*(r*(62*s - 35) + 62*s**2 - 81*s + 26) + (23*s - 13)*(-12*r - 12*s + 9)) + k1**2*k2**2*(-2*C*(1300*r**2 + r*(3412*s - 2065) + 2112*s**2 - 2291*s + 626) + 1732*r**2 + r*(4820*s - 2899) + 3088*s**2 - 3326*s + 905) + k2**4*(2*C*(436*r**2 + r*(548*s - 385) + 112*s**2 - 163*s + 54) - 4*K*(72*r**2 + 104*r*s - 74*r + 32*s**2 - 44*s + 15) - 504*r**2 - 568*r*s + 412*r - 64*s**2 + 115*s - 42)) + 44*k1**2*k2**4*(-3*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(200*r**2 + 100*r*(3*s - 1) + 100*s**2 - 94*s - 3)))) + f*(D1*(f**2*fd*k2**4*(k1**2*(238500*r**2 + r*(138036*s - 228581) - 100464*s**2 + 1683*s + 49259) - 1482*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(fd*(6*k1**4*(2*C*(1422*r*s - 683*r + 1422*s**2 - 1708*s + 481) - 1575*r*s + 756*r - 1575*s**2 + 1905*s - 537) + k1**2*k2**2*(-2*C*(14031*r**2 + 45027*r*s - 22647*r + 30996*s**2 - 32802*s + 8477) + 18549*r**2 + 61641*r*s - 32022*r + 43092*s**2 - 46767*s + 12565) + 66*k2**4*(C*(351*r**2 + 9*r*(53*s - 35) + 126*s**2 - 168*s + 55) - 324*r**2 - 459*r*s + 303*r - 135*s**2 + 177*s - 58)) - 66*k2**4*(3*bd2*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) - 4*gd2*(18*r**2 + 26*r*s - 19*r + 8*s**2 - 11*s + 3))) - 1716*fd*k1**2*k2**4*(3*b2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1) - 4*g2*(36*r**2 + 4*r*(13*s - 9) + 16*s**2 - 22*s + 9))) + Dd*f*(f**2*k2**4*(k1**2*(238500*r**2 + r*(138036*s - 228581) - 100464*s**2 + 1683*s + 49259) - 1482*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(18*k1**4*(2*C*(632*r*s - 322*r + 632*s**2 - 821*s + 254) - 700*r*s + 354*r - 700*s**2 + 914*s - 283) + k1**2*k2**2*(-2*C*(18708*r**2 + 60036*r*s - 34113*r + 41328*s**2 - 48359*s + 13702) + 24732*r**2 + 82188*r*s - 48639*r + 57456*s**2 - 69085*s + 20519) + 66*k2**4*(C*(468*r**2 + 636*r*s - 445*r + 168*s**2 - 231*s + 76) - 432*r**2 - 612*r*s + 430*r - 180*s**2 + 246*s - 82)) - 1716*k1**2*k2**4*(b2*(9*r + 9*s - 3) - 4*g2*(18*r + 8*s - 5))*(4*r + 4*s - 3))))/(9009*d**2*k1**2*k3**6) + 4*D1**3*Pk1*Pk3*ct**2*st**2*(D1*bd1*f**2*(k1**2*s*(24*C - 12)*(3*s - 2) + k2**2*(-r*s + r + 3*s)) + 2*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))*(k1**2*(24*C - 12)*(s - 1) - 7*k2**2*r) + b1*f*(D1*(48*bd1*k1**2*s*(2*C - 1)*(s - 1) - 28*bd1*k2**2*r*s + fd*k1**2*(24*C - 12)*(6*s**2 - 7*s + 2) + fd*k2**2*(-2*r*s + 7*r + 2*s - 4)) + Dd*f*(k1**2*(48*C - 24)*(6*s**2 - 7*s + 2) + k2**2*(r*(14 - 4*s) + 8*s - 7))))/(21*d**2*k1**2*k2**2) + D1**3*Pk1*Pk3*ct**2*(2*D1*bd1*f**2*(k1**2*s*(2 - 4*C)*(31*s - 35) + k2**2*(r*(-16*C + s + 10) - 60*s)) - 7*b1**3*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(-D1*(s - 1)*(7*bd1*f*k2**2*(3*r - 1) + fd*k1**2*(392*C - 196)*(s - 1) + fd*k2**2*(f*(3 - 6*r) + 58*r)) + Dd*f*(-k1**2*(784*C - 392)*(2*s**2 - 3*s + 1) + k2**2*(3*f*(4*r - 1)*(s - 1) - 232*r*s + 132*r + 8*s - 8))) - 2*b1*f*(D1*(196*bd1*k1**2*s*(2*C - 1)*(s - 1) + bd1*k2**2*(r*(-3*f*(s - 1) + 58*s - 8) - 4*s + 4) + fd*k1**2*(4*C - 2)*(62*s**2 - 101*s + 35) + fd*k2**2*(16*C*(2*r - 1) - r*(2*s + 11) + 112*s - 50)) + 2*Dd*f*(k1**2*(4*C - 2)*(62*s**2 - 101*s + 35) + k2**2*(8*C*(4*r - 1) - 2*r*s - 11*r + 116*s - 55))))/(21*d**2*k1**2*k2**2) - 2*D1**3*Pk1*Pk3*ct**2*st**2*(11*b1**2*(2*D1*fd*(k1**4*(48*C - 24)*(s - 1)**2 - 12*k1**2*k2**2*(s - 1)*(2*C*(2*r + s - 1) - 3*r - 2*s + 2) + k2**4*r*(5*f*(3*s - 2) + r*(32 - 32*C))) + Dd*f*(k1**4*(192*C - 96)*(2*s**2 - 3*s + 1) - 12*k1**2*k2**2*(4*C*(4*s - 3)*(2*r + s - 1) - 6*r*(4*s - 3) - 16*s**2 + 27*s - 11) + k2**4*(4*r - 1)*(5*f*(3*s - 2) + r*(64 - 64*C)))) - 11*b1*f*(D1*bd1*(k1**4*s*(96 - 192*C)*(s - 1) + 12*k1**2*k2**2*(4*C*(2*s - 1)*(2*r + s - 1) + r*(6 - 12*s) - 8*s**2 + 11*s - 3) + k2**4*(2*r - 1)*(-5*f*(3*s - 2) + r*(64*C - 64))) + k2**2*(D1*fd*(2*k1**2*(C*(r*(50*s + 8) - 288*s**2 + 244*s - 58) - r*(25*s + 4) + 288*s**2 - 238*s + 53) + k2**2*(8*C*(8*r**2 - 10*r + 3) + 3*f*(3*r - 1)*(3*s - 2) + 14*r**2 + 112*r*s + 26*r - 2*s - 24)) + Dd*f*(k1**2*(2*C*(4*r*(25*s + 4) - 576*s**2 + 595*s - 170) - 4*r*(25*s + 4) + 1152*s**2 - 1115*s + 286) + k2**2*(8*C*(16*r**2 - 16*r + 3) + 3*f*(4*r - 1)*(3*s - 2) + 28*r**2 + 224*r*s - 19*r - 14*s - 18)))) - f**2*(D1*(11*bd1*k2**2*(k1**2*(C*(50*r*s + 28*r - 288*s**2 + 258*s - 68) - 25*r*s - 14*r + 288*s**2 - 215*s + 44) + k2**2*(r**2*(32*C + 7) + r*(-24*C + 9*f*s - 6*f + 56*s - 21) - 12*s + 6)) + fd*(k1**4*(32*C - 16)*(126*s**2 - 117*s + 25) + k1**2*k2**2*(2*C*(369*r*s + 174*r - 4356*s**2 + 2715*s - 520) + 75*r*s - 454*r + 8748*s**2 - 6429*s + 1314) + k2**4*(8*C*(1 - 3*r)**2 + 1413*r**2 + 630*r*s - 1515*r - 540*s + 458))) + Dd*f*(k1**4*(64*C - 32)*(84*s**2 - 92*s + 25) + k1**2*k2**2*(2*C*(4*r*(123*s - 76) - 5808*s**2 + 4361*s - 714) + 4*r*(25*s - 4) + 11664*s**2 - 10213*s + 2182) + k2**4*(8*C*(12*r**2 - 7*r + 1) + 1884*r**2 + 3*r*(280*s - 681) - 740*s + 658))))/(231*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*ct**2*(-33*D1*b1*bd1*f*(f*k2**2*(3*k1**2*(s - 1) + 2*k2**2*(r*(30*s - 44) - 63*s + 42)) - k1**4*s*(784*C - 392)*(s - 1) + 2*k1**2*k2**2*s*(8*C*(49*r + 19*s - 19) - 14*K*r + 7*K - 294*r - 152*s + 152) + 4*k2**4*(r**2*(56*C + 8*K - 87) + r*(-28*C - 8*K + 29*s + 49) - 16*s)) + 231*b1**3*k1**2*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) - 33*b1**2*(D1*(7*bd1*f*k1**2*k2**2*(-3*r*(s - 1) + s - 1) + fd*(k1**4*(196 - 392*C)*(s - 1)**2 + k1**2*k2**2*(8*C*(s - 1)*(49*r + 19*s - 19) - 3*f*(s - 1) - 14*r*(s*(K + 21) - 21) - 152*(s - 1)**2) + 2*k2**4*(56*C*r**2 + 8*K*(r - 1)**2 + f*(r*(30*s + 4) - 8) - 87*r**2 + 29*r*s + 16*r - 8))) + 2*Dd*f*(k1**4*(196 - 392*C)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(8*C*(2*s - 1)*(49*r + 19*s - 19) + 7*K*s - r*s*(28*K + 588) + 294*r - 304*s**2 + 456*s - 152) + k2**4*(224*C*r**2 - 56*C*r + 8*K*(4*r**2 - 5*r + 1) + f*(20*r*(3*s - 2) - 63*s + 34) - 348*r**2 + 116*r*s + 125*r - 32*s - 8))) + 3*b1*k2**2*(D1*(f**2*fd*(55*k1**2*(3*r - 1)*(s - 1) + 2*k2**2*(1296*r**2 + 21*r*(99*s - 82) - 2805*s + 1486)) - 22*f*(-7*bd2*k1**2*r*s + fd*k1**2*(4*C*(r*(29*s + 31) - 10*s**2 + 153*s - 90) - 3*K*s + r*(6*K*s - 58*s - 62) + 4*s**2 - 430*s + 248) + fd*k2**2*(8*K*(2*r - 1) + r**2*(80*C - 84) + r*(-40*C - 166*s + 169) + 92*s - 8) - 2*gd2*r*(-7*k1**2*s + 8*k2**2*(r - 1))) + 22*fd*(7*b2*k1**2*r*s + 2*g2*(-7*k1**2*r*s + 8*k2**2*(r - 1)**2))) + Dd*f*(f**2*(55*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(1728*r**2 + 4*r*(693*s - 538) - 3861*s + 2014)) - 22*f*(k1**2*(2*C*(4*r*(29*s + 17) - 40*s**2 + 609*s - 326) - 3*K*s + 4*r*(3*K*s - 29*s - 17) + 8*s**2 - 857*s + 458) + 4*k2**2*(K*(8*r - 2) + r**2*(40*C - 42) + r*(-10*C - 83*s + 74) + 53*s - 32)) + (88*r - 22)*(7*b2*k1**2*s + 2*g2*(-7*k1**2*s + 8*k2**2*(r - 1))))) - f*(D1*(-3*bd1*f**2*k2**2*(55*k1**2*r*(s - 1) + 2*k2**2*(432*r**2 + r*(693*s - 430) - 1056*s + 528)) + 2*f*(fd*(k1**4*(132*C - 66)*(63*s**2 - 108*s + 29) + k1**2*k2**2*(2*C*(5976*r**2 + 3*r*(5445*s - 3638) + 1188*s**2 - 13167*s + 5416) - 5976*r**2 - 3*r*(7512*s - 4459) - 5346*s**2 + 21273*s - 7788) + 297*k2**4*r*(7*r - 22*s + 5)) + 33*k2**2*(bd1*k1**2*(C*(r*(58*s + 4) - 20*s**2 + 290*s + 4) + r*(3*K*s - 29*s - 2) + 2*s**2 - 211*s - 4) + bd1*k2**2*(r**2*(40*C - 42) + r*(8*K - 83*s + 8) + 60*s - 60) + r*(bd2 - 2*gd2)*(3*k1**2*s + 8*k2**2))) + 66*k2**2*(-7*b2*bd1*k1**2*s*(r - 1) + b2*fd*(2*r - 1)*(3*k1**2*s + 8*k2**2) - 2*bd1*g2*(r - 1)*(-7*k1**2*s + 8*k2**2*r) - 2*fd*g2*(2*r - 1)*(3*k1**2*s + 8*k2**2))) + 2*Dd*f*(f*(k1**4*(264*C - 132)*(42*s**2 - 79*s + 29) + k1**2*k2**2*(2*C*(7968*r**2 + 20*r*(1089*s - 866) + 1584*s**2 - 17721*s + 9574) - 7968*r**2 - 30048*r*s + 21854*r - 7128*s**2 + 29389*s - 14122) + 99*k2**4*r*(28*r - 88*s + 37)) + k2**2*(33*b2 - 66*g2)*(4*r - 1)*(3*k1**2*s + 8*k2**2))))/(693*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*ct**2*st**2*(-429*b1**2*k2**2*(2*D1*fd*(k1**4*(304*C - 204)*(s - 1)*(r + s - 1) + k1**2*k2**2*(-8*C*(23*r**2 + 29*r*(s - 1) + 6*(s - 1)**2) + 160*r**2 + r*(7*K*s - 45*f*s + 25*f + 201*s - 208) + 48*(s - 1)**2) + 2*k2**4*r*(f*(78*r + 78*s - 61) + r*(30 - 16*K) + 14*s)) + Dd*f*(8*k1**4*(8*C*(r*(38*s - 25) + 38*s**2 - 60*s + 22) - 3*r*(68*s - 44) - 204*s**2 + 321*s - 117) + k1**2*k2**2*(-16*C*(92*r**2 + r*(116*s - 131) + 24*s**2 - 61*s + 37) - 14*K*s - 5*f*(4*r - 1)*(9*s - 5) + 1280*r**2 + 8*r*(s*(7*K + 201) - 238) + 384*s**2 - 938*s + 568) + 4*k2**4*(f*(156*r**2 + r*(156*s - 131) - 9*s + 8) + 2*r*(K*(8 - 32*r) + 60*r + 28*s - 29)))) - 39*b1*(D1*(f**2*k2**4*(-55*bd1*k1**2*(2*r - 1)*(9*s - 5) + 44*bd1*k2**2*(78*r**2 + r*(78*s - 70) - 9*s + 8) + 3*fd*(11*k1**2*(6*r - 9*s + 5) + 4*k2**2*(531*r**2 + 189*r*s - 354*r - 173*s + 138))) + 22*f*(bd1*k2**2*(4*k1**4*(8*C*(r*(19*s - 6) + 19*s**2 - 22*s + 3) - 6*r*(17*s - 5) - 102*s**2 + 117*s - 15) + k1**2*k2**2*(-8*C*(46*r**2 + r*(58*s - 73) + 12*s**2 - 37*s + 25) - 7*K*s + 320*r**2 + 2*r*(7*K*s + 201*s - 268) + 96*s**2 - 277*s + 188) + 8*k2**4*r*(K*(4 - 8*r) + 15*r + 7*s - 11)) + fd*(k1**6*(48*C - 24)*(6*s**2 - 7*s + 2) - 2*k1**4*k2**2*(2*C*(r*(319*s - 172) + 640*s**2 - 568*s + 119) + r*(197 - 373*s) - 856*s**2 + 766*s - 163) + k1**2*k2**4*(8*C*(10*r**2 + 47*r*(5*s - 2) + 174*s**2 - 149*s + 23) + 7*K*s - 170*r**2 - 2*r*(7*K*s + 1055*s - 451) - 1680*s**2 + 1461*s - 256) + 2*k2**6*(-2*K*(8*r**2 - 10*r + 3) + 44*r**2 + r*(28*s - 30) - 3*s + 4)) + 2*gd2*k2**4*r*(-7*k1**2*s + 32*k2**2*r)) + 44*fd*g2*k2**4*r*(-7*k1**2*s + 32*k2**2*r)) + 2*Dd*f*(f**2*k2**4*(33*k1**2*(4*r - 1) + 2*k2**2*(2124*r**2 + 27*r*(28*s - 59) - 820*s + 581)) + 11*f*(k1**6*(96*C - 48)*(6*s**2 - 7*s + 2) + k1**4*k2**2*(-2*C*(4*r*(319*s - 172) + 2560*s**2 - 2699*s + 722) + 4*r*(373*s - 197) + 3424*s**2 - 3579*s + 944) + k1**2*k2**4*(4*C*(40*r**2 + r*(940*s - 462) + 696*s**2 - 705*s + 174) + 7*K*s - 340*r**2 + r*(-s*(28*K + 4220) + 2145) - 3360*s**2 + 3381*s - 838) - 2*k2**6*(K*(32*r**2 - 32*r + 6) - 88*r**2 - 8*r*(7*s - 9) + 9*s - 10)) + 22*g2*k2**4*(4*r - 1)*(-7*k1**2*s + 32*k2**2*r))) + f*(D1*(f**2*k2**4*(-39*bd1*(33*k1**2*(2*r + 9*s - 7) + 4*k2**2*(531*r**2 + 9*r*(21*s - 59) - 301*s + 167)) + fd*(2015*k1**2*(4*r - 1)*(9*s - 7) + 24*k2**2*(5208*r**2 + 14170*r*s - 12133*r - 4095*s + 2984))) - 78*f*(11*bd1*(k1**6*s*(48*C - 24)*(3*s - 2) + k1**4*k2**2*(-2*C*(r*(319*s - 150) + 640*s**2 - 637*s + 198) + r*(373*s - 172) + 856*s**2 - 805*s + 232) + k1**2*k2**4*(4*C*(10*r**2 + r*(235*s - 58) + 174*s**2 - 151*s + 46) - 85*r**2 + r*(-7*K*s - 1055*s + 291) - 840*s**2 + 700*s - 202) + 2*k2**6*(r**2*(22 - 8*K) + r*(6*K + 14*s - 21) - 3*s + 3)) + fd*(k1**6*(32*C - 16)*(126*s**2 - 117*s + 25) + k1**4*k2**2*(-2*C*(8655*r*s - 4678*r + 18612*s**2 - 16987*s + 4192) + 10323*r*s - 5542*r + 24624*s**2 - 22541*s + 5478) - k1**2*k2**4*(8*C*(1011*r**2 - 1539*r*s - 601*r - 1314*s**2 + 762*s + 151) - 4833*r**2 + 14748*r*s + 275*r + 11556*s**2 - 9298*s + 622) + 264*k2**6*r*(3*r + 3*s - 2)) + 22*gd2*k2**4*r*(7*k1**2*s + 4*k2**2*(4*r - 3))) - 1716*g2*k2**4*(bd1*(r - 1)*(-7*k1**2*s + 32*k2**2*r) + fd*(2*r - 1)*(7*k1**2*s + 4*k2**2*(4*r - 3)))) + Dd*f*(f**2*k2**4*(2015*k1**2*(4*r - 1)*(9*s - 7) + 24*k2**2*(5208*r**2 + r*(14170*s - 12133) - 4095*s + 2984)) - 78*f*(k1**6*(64*C - 32)*(84*s**2 - 92*s + 25) + k1**4*k2**2*(-2*C*(11540*r*s - 5824*r + 24816*s**2 - 25617*s + 6618) + 13764*r*s - 6912*r + 32832*s**2 - 34141*s + 8870) + k1**2*k2**4*(-8*C*(1348*r**2 - 19*r*(108*s + 29) - 1752*s**2 + 1206*s + 145) + 6444*r**2 - 19664*r*s + 2073*r - 15408*s**2 + 14278*s - 1750) + 264*k2**6*r*(4*r + 4*s - 3)) - 1716*g2*k2**4*(4*r - 1)*(7*k1**2*s + 4*k2**2*(4*r - 3)))))/(9009*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*Pk3*ct**2*(6006*b1**3*k1**2*k2**4*(D1*fd*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) + Dd*f*(4*r**2 + r*(12*s - 17) + 8*s**2 - 17*s + 9)) - 429*b1**2*k2**2*(2*D1*(-7*bd1*f*k1**2*k2**2*(3*r**2 + r*(9*s - 14) + 6*s**2 - 13*s + 7) + fd*(k1**4*(4*C*(8*r**2 - 61*r*(s - 1) - 69*(s - 1)**2) - 16*r**2 + r*(7*K*s + 3*f*(s - 1) + 142*s - 142) + 158*(s - 1)**2) + k1**2*k2**2*(28*C*(12*r**2 + 17*r*(s - 1) + 5*(s - 1)**2) + 20*K*r**2 + 35*K*r*s - 104*K*r - 30*K*s**2 - 68*K*s + 52*K + f*(280*r**2 + 1103*r*s - 418*r + 832*s**2 - 833*s + 175) - 297*r**2 - 414*r*s + 484*r - 72*s**2 + 328*s - 172) - 4*k2**4*r*(11*f*(3*r + 3*s - 2) + r*(7 - 7*K)))) + Dd*f*(k1**4*(16*C*(16*r**2 + r*(49 - 122*s) - 138*s**2 + 203*s - 65) - 14*K*s + 3*f*(4*r - 1)*(s - 1) - 128*r**2 + 8*r*(7*K*s + 142*s - 57) + 1264*s**2 - 1856*s + 592) + k1**2*k2**2*(112*C*(24*r**2 + r*(34*s - 27) + 10*s**2 - 17*s + 7) + 2*K*(80*r**2 + 140*r*s - 564*r - 120*s**2 - 447*s + 372) + f*(1120*r**2 + 4*r*(1103*s - 523) + 3328*s**2 - 3667*s + 903) - 2376*r**2 - 3312*r*s + 3302*r - 576*s**2 + 2210*s - 1224) - 4*k2**4*(11*f*(4*r - 1)*(3*r + 3*s - 2) - 14*r**2*(4*K - 4) + 14*r*(K + 1) - 14*s))) - 13*b1*(-3*D1*(f**2*k2**2*(-11*bd1*(3*k1**4*(2*r - 1)*(s - 1) + k1**2*k2**2*(560*r**2 + 2206*r*s - 1256*r + 1664*s**2 - 2001*s + 553) - 44*k2**4*(2*r - 1)*(3*r + 3*s - 2)) + fd*(-55*k1**4*(3*r - 1)*(s - 1) - k1**2*k2**2*(21438*r**2 + 6*r*(5479*s - 5477) + 396*s**2 - 21045*s + 13237) + 308*k2**4*(3*r - 1)*(3*r + 3*s - 2))) + 22*f*(fd*(k1**6*(4*C - 2)*(62*s**2 - 101*s + 35) + k1**4*k2**2*(4*C*(88*r**2 + 31*r*(7*s - 1) + 74*s**2 + 17*s - 54) - 3*K*s - 176*r**2 + r*(6*K*s - 548*s + 123) - 252*s**2 + 38*s + 98) + k1**2*k2**4*(4*C*(32*r**2 + 7*r*(56*s - 15) + 82*s**2 - 17*s - 26) + K*(840*r**2 + 950*r*s - 1084*r + 260*s**2 - 879*s + 332) - 876*r**2 - 2796*r*s + 1341*r - 952*s**2 + 1129*s - 214) - 4*k2**6*(r**2*(10*K - 8) + r*(-5*K + 2*s + 4) + 5*s)) + k2**2*(bd1*k1**4*(-8*C*(8*r**2 - r*(61*s + 12) - 69*s**2 + 65*s + 4) + 7*K*s + 32*r**2 - 2*r*(7*K*s + 142*s + 28) - 316*s**2 + 296*s + 20) + bd1*k1**2*k2**2*(-56*C*(12*r**2 + r*(17*s - 10) + 5*s**2 - 7*s + 2) + K*(-40*r**2 - 70*r*s + 240*r + 60*s**2 + 249*s - 160) + 594*r**2 + 828*r*s - 606*r + 144*s**2 - 457*s + 192) - 28*bd1*k2**4*(K*r*(2*r - 1) - 2*r**2 + s) + 14*bd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(7*k1**4*r*s + 5*k1**2*k2**2*(4*r**2 + r*(7*s - 44) - 6*s**2 - 26*s + 32) + 28*k2**4*r**2))) + 44*fd*k2**2*(7*b2*k1**2*k2**2*(r + s)**2 + g2*(7*k1**4*r*s + k1**2*k2**2*(20*r**2 + 35*r*s - 104*r - 30*s**2 - 68*s + 52) + 28*k2**4*r**2))) + Dd*f*(f**2*k2**2*(165*k1**4*(4*r - 1)*(s - 1) + 2*k1**2*k2**2*(42876*r**2 + r*(65748*s - 72107) + 792*s**2 - 47111*s + 30486) - 924*k2**4*(4*r - 1)*(3*r + 3*s - 2)) - 66*f*(k1**6*(8*C - 4)*(62*s**2 - 101*s + 35) + k1**4*k2**2*(2*C*(352*r**2 + 4*r*(217*s - 83) + 296*s**2 + 9*s - 126) - 3*K*s - 352*r**2 + 2*r*(6*K*s - 548*s + 227) - 504*s**2 + 159*s + 92) + k1**2*k2**4*(4*C*(64*r**2 + 14*r*(56*s - 27) + 164*s**2 - 101*s + 2) + K*(1680*r**2 + 76*r*(25*s - 33) + 520*s**2 - 1923*s + 1116) - 1752*r**2 - 5592*r*s + 3724*r - 1904*s**2 + 2771*s - 1032) - 4*k2**6*(r**2*(20*K - 16) + r*(-5*K + 4*s - 8) + 5*s)) - 132*k2**2*(7*b2*k1**2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(7*k1**4*s*(4*r - 1) + k1**2*k2**2*(80*r**2 + 140*r*s - 564*r - 120*s**2 - 447*s + 372) + 28*k2**4*r*(4*r - 1))))) + f*(D1*(f**2*k2**2*(-13*bd1*(165*k1**4*r*(s - 1) + k1**2*k2**2*(21438*r**2 + 32874*r*s - 45628*r + 396*s**2 - 31087*s + 21261) - 924*k2**4*r*(3*r + 3*s - 2)) + 5*fd*k1**2*k2**2*(54048*r**2 + 4*r*(66339*s - 47641) + 247104*s**2 - 396279*s + 147457)) + 26*f*(33*bd1*(k1**6*s*(4*C - 2)*(31*s - 35) + k1**4*k2**2*(2*C*(88*r**2 + r*(217*s - 102) + 74*s**2 + 9*s + 22) - 88*r**2 + r*(3*K*s - 274*s + 108) - 126*s**2 + 21*s - 32) + k1**2*k2**4*(4*C*(16*r**2 + 2*r*(98*s - 45) + 41*s**2 - 41*s + 26) + K*(420*r**2 + 475*r*s - 712*r + 130*s**2 - 522*s + 392) - 438*r**2 - 1398*r*s + 952*r - 476*s**2 + 756*s - 408) - 4*k2**6*r*(r*(5*K - 4) + s - 6)) + 66*bd2*k1**2*k2**4*(57*r**2 + r*(74*s - 123) + 17*s**2 - 81*s + 64) + fd*k1**6*(132*C - 66)*(63*s**2 - 108*s + 29) + fd*k1**4*k2**2*(2*C*(22536*r**2 + r*(52299*s - 37374) + 14364*s**2 - 40143*s + 15928) - 22536*r**2 + r*(42357 - 66060*s) - 25380*s**2 + 55209*s - 19858) + 33*fd*k1**2*k2**4*(4*C*(276*r**2 + r*(801*s - 398) + 198*s**2 - 204*s + 59) - 1077*r**2 + r*(1585 - 3276*s) - 972*s**2 + 1012*s - 274) + 66*gd2*k2**2*(-3*k1**4*r*s - k1**2*k2**2*(420*r**2 + 475*r*s - 712*r + 130*s**2 - 522*s + 392) + 20*k2**4*r**2)) + 1716*k2**2*(b2*k1**2*k2**2*(7*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(114*r**2 + r*(148*s - 173) + 34*s**2 - 137*s + 58)) - g2*(bd1*(-7*k1**4*s*(r - 1) + k1**2*k2**2*(-20*r**2 - 5*r*(7*s - 4) + s*(30*s + 119)) - 28*k2**4*r*(r - 1)) + fd*(3*k1**4*s*(2*r - 1) + k1**2*k2**2*(840*r**2 + 950*r*s - 1084*r + 260*s**2 - 879*s + 332) + 20*k2**4*r*(1 - 2*r))))) + Dd*f*(5*f**2*k1**2*k2**4*(54048*r**2 + 4*r*(66339*s - 47641) + 247104*s**2 - 396279*s + 147457) + 26*f*k1**2*(k1**4*(264*C - 132)*(42*s**2 - 79*s + 29) + k1**2*k2**2*(2*C*(30048*r**2 + 52*r*(1341*s - 1108) + 19152*s**2 - 56049*s + 27046) - 30048*r**2 + r*(66790 - 88080*s) - 33840*s**2 + 78321*s - 34510) + 33*k2**4*(4*C*(368*r**2 + 4*r*(267*s - 163) + 264*s**2 - 303*s + 92) - 1436*r**2 + r*(2651 - 4368*s) - 1296*s**2 + 1530*s - 468)) + 1716*k2**2*(b2*k1**2*k2**2*(228*r**2 + r*(296*s - 419) + 68*s**2 - 299*s + 186) - g2*(3*k1**4*s*(4*r - 1) + k1**2*k2**2*(1680*r**2 + 76*r*(25*s - 33) + 520*s**2 - 1923*s + 1116) + 20*k2**4*r*(1 - 4*r))))))/(9009*d**2*k1**2*k2**2*k3**4) + 40*D1**3*Pk1*Pk3*ct*f*k2**5*st**6*(13*D1*bd1*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(r + s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 3) + 27*s**2 - 3*s - 10) + k1**2*(264*C - 198)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - f*(D1*fd*(3*f*k2**2*(276*r**2 + r*(552*s - 427) + 276*s**2 - 427*s + 165) + k1**2*(78 - 104*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(69*r + 69*s - 55) + k1**2*(78 - 104*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(3003*d**2*k1*k3**8) + 80*D1**3*Pk1*Pk3*ct*f*k2**3*st**6*(33*D1*bd1*f*(k1**2*(4*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(-2*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 10*r**2 + r*(12*s - 13) + 2*s**2 - 7*s + 3)) + 33*b1*(-D1*fd*(-k1**2*(8*C - 6)*(2*s - 1) + k2**2*(r*(8*C - 10) - 2*s + 1))*(2*r + 2*s - 1) + Dd*f*(k1**2*(4*C - 3)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(C*(-32*r**2 - 8*r*(4*s - 3) + 4*s - 2) + 40*r**2 + r*(48*s - 34) + 8*s**2 - 14*s + 5))) + f*(D1*fd*(k1**2*(8*C - 6)*(3*s - 1) + k2**2*(C*(4 - 12*r) + 15*r + 3*s - 6))*(3*r + 3*s - 2) + Dd*f*(k1**2*(4*C - 3)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(-2*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 60*r**2 + 72*r*s - 65*r + 12*s**2 - 31*s + 16))))/(693*d**2*k1*k3**6) + 80*D1**3*Pk1*Pk3*ct*f*k2*st**6*(33*b1*(1 - 2*s)**2*(D1*fd + 2*Dd*f) + f*(33*D1*bd1*s*(2*s - 1) + D1*fd*(1 - 3*s)**2 + 2*Dd*f*(6*s**2 - 5*s + 1)))/(693*d**2*k1*k3**2) + 40*D1**3*Pk1*Pk3*ct*f*k2*st**6*(33*b1*(2*s - 1)*(2*D1*fd*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + Dd*f*(k1**2*(16*C - 12)*(2*s - 1) + k2**2*(-16*C*r + 2*C + 24*r + 8*s - 7))) + f*(33*D1*bd1*(k1**2*s*(8*C - 6)*(2*s - 1) + k2**2*(C*(-8*r*s + 2*r + 4*s - 2) + 12*r*s - 3*r + 4*s**2 - 8*s + 3)) + 2*D1*fd*(3*s - 1)*(k1**2*(4*C - 3)*(3*s - 1) + k2**2*(C*(2 - 6*r) + 9*r + 3*s - 4)) + Dd*f*k1**2*(16*C - 12)*(6*s**2 - 5*s + 1) + Dd*f*k2**2*(C*(r*(20 - 48*s) + 14*s - 6) + 6*r*(12*s - 5) + 24*s**2 - 41*s + 13)))/(693*d**2*k1*k3**4) - 16*D1**3*Pk1*Pk3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*(k1**2*(-12*C*(r + s - 1) - 12*K*r - 12*K*s + 6*K + b1*(4*r + 4*s - 2) + 8*r + 8*s - 7) + 6*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(132*b1*k1**2*(1 - 6*K) + 924*b1*k2**2*(1 - 4*K) + 792*g2*k1**2 + 3696*g2*k2**2)) + 66*b1**2*(D1*fd*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(6*K - 1) + k2**2*(28*K - 7))) + Dd*f*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5)) - (r + s)*(k1**2*(6*K - 1) + k2**2*(28*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*(fd*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s))*(2*r + 2*s - 1) - 4*gd2*(3*k1**2 + 14*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*(3*k1**2 + 14*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) - 66*f*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s)) + 264*g2*(3*k1**2 + 14*k2**2)*(r + s))) - 2*f*(D1*(140*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 33*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 12*gd2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))*(r + s - 1) - 396*fd*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k2**2*(r + s - 1) + f*k1**2*(330*C - 165)*(r + s - 1) - 396*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))))/(231*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct*k1*k2*st**2*(39*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 32*K*r + 32*K*s - 12*K + b1*(-69*r - 69*s + 39) + 19*r + 19*s - 15) + k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) - 44*k2**2*(r + s)*(13*b1*k1**2*(4*K - 1) + 7*b1*k2**2*(2*K - 1) - 2*g2*(26*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7))*(2*r + 2*s - 1) + (r + s)**2*(-2*k1**2*(52*K - 13) - 2*k2**2*(14*K - 7))) + Dd*f*(3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7)) + (r + s)*(-2*k1**2*(52*K - 13) - 2*k2**2*(14*K - 7)))*(4*r + 4*s - 3)) + 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 22*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) - 4*gd2*k2**2*(26*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 88*fd*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) + 88*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(-8*k1**2*(17*r + 17*s - 16) + 117*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(fd*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 132*gd2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(r + s - 1)) - 3432*fd*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(8*k1**2*(17*r + 17*s - 16) - 117*k2**2*(7*r + 7*s - 5)) + 26*f*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 3432*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s)))))/(3003*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct*k1*(66*b1**3*k2**2*(2*k1**2 + 21*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(2*D1*bd1*f*(2*k1**2 + 21*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - D1*fd*(k1**2*(56*C*(r + s - 1)**2 - 8*K*(11*r**2 + r*(22*s + 4) + 11*s**2 + 4*s - 2) + f*(90*r**2 + 3*r*(100*s - 57) + 210*s**2 - 227*s + 57) - 10*r**2 - 4*r*s + 64*r + 6*s**2 + 64*s - 32) + k2**2*(f*(252*r**2 + r*(582*s - 305) + 330*s**2 - 331*s + 77) + (-7*r - 7*s)*(r*(30*K - 15) + s*(18*K - 11)))) - Dd*f*(k1**2*(56*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 8*K*(44*r**2 + 88*r*s - 25*r + 44*s**2 - 25*s - 6) + f*(180*r**2 + r*(600*s - 403) + 420*s**2 - 563*s + 191) - 40*r**2 - 16*r*s + 142*r + 24*s**2 + 118*s - 96) + k2**2*(2*f*(252*r**2 + r*(582*s - 380) + 330*s**2 - 406*s + 127) - 7*r**2*(120*K - 60) - 7*r*(192*K*s - 90*K - 104*s + 53) - 7*s*(72*K*s - 54*K - 44*s + 29)))) - b1*(3*D1*(f**2*k2**2*(22*bd1*k1**2*(45*r**2 + 2*r*(75*s - 58) + 105*s**2 - 168*s + 67) + 11*bd1*k2**2*(252*r**2 + r*(582*s - 455) + 330*s**2 - 481*s + 177) + fd*k1**2*(2175*r**2 + r*(4950*s - 3551) + 2775*s**2 - 3951*s + 1408) + 11*fd*k2**2*(354*r**2 + r*(564*s - 355) + 210*s**2 - 217*s + 69)) - 11*f*(fd*(k1**4*(4*C - 2)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(4*C*(74*r**2 + 2*r*(101*s - 57) + 128*s**2 - 154*s + 39) + 2*K*(286*r**2 + 502*r*s - 297*r + 216*s**2 - 267*s + 77) - 292*r**2 - 754*r*s + 385*r - 462*s**2 + 523*s - 133) + k2**4*(r**2*(400*K - 198) + r*(4*K*(161*s - 50) - 344*s + 99) + s*(4*K*(61*s - 32) - 146*s + 51))) + 2*k2**2*(-2*bd1*k1**2*(14*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-44*r**2 - 88*r*s + 40*r - 44*s**2 + 40*s + 4) - 5*r**2 - 2*r*s + 11*r + 3*s**2 + 7*s - 8) + 7*bd1*k2**2*(r**2*(30*K - 15) + r*(6*K*(8*s - 5) - 26*s + 17) + s*(18*K*(s - 1) - 11*s + 9)) + (-2*r - 2*s + 2)*(-2*bd2*(2*k1**2 + 7*k2**2)*(r + s) + gd2*k1**2*(44*r + 44*s + 8) + 21*gd2*k2**2*(5*r + 3*s)))) + 44*fd*k2**2*(-2*b2*(2*k1**2 + 7*k2**2)*(r + s)**2 + 4*g2*k1**2*(11*r**2 + r*(22*s + 4) + 11*s**2 + 4*s - 2) + 21*g2*k2**2*(5*r**2 + 8*r*s + 3*s**2))) + Dd*f*(f**2*k2**2*(k1**2*(8700*r**2 + r*(19800*s - 15569) + 11100*s**2 - 17269*s + 6733) + 66*k2**2*(236*r**2 + 376*r*s - 277*r + 140*s**2 - 185*s + 65)) - 33*f*(k1**4*(8*C - 4)*(2*s - 1)*(3*r + 3*s - 1) + 2*k1**2*k2**2*(C*(296*r**2 + r*(808*s - 578) + 512*s**2 - 714*s + 254) + K*(572*r**2 + 1004*r*s - 747*r + 432*s**2 - 647*s + 241) - 292*r**2 - 754*r*s + 500*r - 462*s**2 + 620*s - 207) + k2**4*(r**2*(800*K - 396) + r*(28*K*(46*s - 21) - 688*s + 341) + s*(4*K*(122*s - 93) - 292*s + 197))) + 132*k2**2*(4*r + 4*s - 3)*(-2*b2*(2*k1**2 + 7*k2**2)*(r + s) + g2*k1**2*(44*r + 44*s + 8) + 21*g2*k2**2*(5*r + 3*s)))) + f*(D1*(f**2*k2**2*(-bd1*(k1**2*(2175*r**2 + 4950*r*s - 4916*r + 2775*s**2 - 5416*s + 2509) + 33*k2**2*(118*r**2 + 188*r*s - 199*r + 70*s**2 - 153*s + 61)) + 20*fd*(k1**2*(7*r*(26*s - 21) + 182*s**2 - 281*s + 109) + k2**2*(142*r**2 + r*(691*s - 452) + 549*s**2 - 737*s + 249))) + 33*f*(bd1*(k1**4*s*(4*C - 2)*(3*r + 3*s - 1) + k1**2*k2**2*(4*C*(37*r**2 + r*(101*s - 74) + 64*s**2 - 88*s + 37) + 2*K*(143*r**2 + 251*r*s - 225*r + 108*s**2 - 190*s + 82) - 146*r**2 - 377*r*s + 268*r - 231*s**2 + 319*s - 114) + k2**4*(r**2*(200*K - 99) + r*(2*K*(161*s - 97) - 172*s + 121) + s*(122*K - 73)*(s - 1))) + fd*(k1**4*(4*C - 2)*(3*s - 1)*(5*r + 5*s - 3) + k1**2*k2**2*(4*C*(126*r**2 + 106*r*(3*s - 2) + 192*s**2 - 255*s + 85) - 282*r**2 + r*(465 - 729*s) - 447*s**2 + 594*s - 191)) + 4*k2**2*(4*bd2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(r + s - 1) - gd2*(k1**2*(143*r**2 + 251*r*s - 225*r + 108*s**2 - 190*s + 82) + k2**2*(100*r**2 + r*(161*s - 97) + s*(61*s - 61))))) + 132*k2**2*(2*b2*(bd1*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*fd*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(2*r + 2*s - 1)) - g2*(bd1*(44*k1**2*(r + s) + 21*k2**2*(5*r + 3*s))*(r + s - 1) + fd*(k1**2*(286*r**2 + r*(502*s - 297) + 216*s**2 - 267*s + 77) + 2*k2**2*(100*r**2 + r*(161*s - 50) + s*(61*s - 32)))))) + 2*Dd*f*(10*f**2*k2**2*(k1**2*(7*r*(26*s - 21) + 182*s**2 - 281*s + 109) + k2**2*(142*r**2 + r*(691*s - 452) + 549*s**2 - 737*s + 249)) + 33*f*k1**2*(k1**2*(4*C - 2)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(4*C*(84*r**2 + 53*r*(4*s - 3) + 128*s**2 - 186*s + 69) - 188*r**2 - 486*r*s + 354*r - 298*s**2 + 435*s - 159)) + 66*k2**2*(4*b2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(4*r + 4*s - 3) - g2*(k1**2*(572*r**2 + r*(1004*s - 747) + 432*s**2 - 647*s + 241) + 2*k2**2*(200*r**2 + 7*r*(46*s - 21) + s*(122*s - 93)))))))/(693*d**2*k2*k3**6) + 16*D1**3*Pk1*Pk3*ct*k2**3*st**4*(-26*D1*bd1*f*k1**2*(r + s - 1)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(b1*(-7*r - 7*s + 3) + (4*C - 3)*(2*r + 2*s - 1))) + k2**2*(r + s)*(-132*K*b1 + 66*b1 + 132*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) + (4*K - 2)*(r + s)**2) + Dd*f*(f*(7*r + 7*s - 3) + (4*K - 2)*(r + s))*(4*r + 4*s - 3)) - 26*b1*k1**2*(D1*(25*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 33*f*(fd*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 4*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1)) + 132*g2*k2**2*(r + s))) + f**2*(D1*fd*(-f*k1**2*k2**2*(9812*r**2 + r*(19624*s - 14315) + 9812*s**2 - 14315*s + 5217) + 65*f*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + k1**4*(988 - 1664*C)*(3*r + 3*s - 2)**2) - Dd*f*(4*r + 4*s - 3)*(f*k1**2*k2**2*(2453*r + 2453*s - 1739) - 65*f*k2**4*(5*r + 5*s - 3) + k1**4*(1664*C - 988)*(3*r + 3*s - 2))))/(1001*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct*k2*st**4*(D1*f*(-3432*bd1*g2*k2**4*(2*r**2 + 2*r*(s - 1) - s) + f**2*k2**4*(13*bd1*(183*r**2 + 2*r*(69*s - 76) - 45*s**2 + 148*s - 51) + fd*(13396*r**2 + r*(10016*s - 9639) - 3380*s**2 + 2605*s - 137)) + 52*f*(33*bd1*(k1**4*s*(4*C*(3*r + 3*s - 1) - 7*r - 7*s + 2) + k1**2*k2**2*(-2*C*(12*r**2 + 14*r*s - 15*r + 2*s**2 - 10*s + 3) + 17*r**2 + 20*r*s - 21*r + 3*s**2 - 15*s + 4) + k2**4*(-2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 10*r**2 + 12*r*s - 13*r + 2*s**2 - 7*s + 3)) + fd*k1**2*(k1**2*(84*C - 48)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(-C*(1089*r**2 + 9*r*(193*s - 156) + 648*s**2 - 1011*s + 419) + 783*r**2 + 252*r*(5*s - 4) + 477*s**2 - 738*s + 302)))) + Dd*f**3*(f*k2**4*(13396*r**2 + r*(10016*s - 9639) - 3380*s**2 + 2605*s - 137) + k1**4*(2184*C - 1248)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 52*k1**2*k2**2*(C*(1452*r**2 + 3*r*(772*s - 637) + 864*s**2 - 1379*s + 571) - 1044*r**2 - 5*r*(336*s - 275) - 636*s**2 + 1009*s - 414)) + 858*b1**2*k2**2*(D1*fd*(k1**2*(6 - 8*C)*(r + s - 1)**2 + k2**2*(f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + (r + s)*(2*r*(2*K - 3) - 2*s))) + 2*Dd*f*(-k1**2*(4*C - 3)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + r**2*(8*K - 12) + r*(8*K*s - 4*K - 16*s + 7) - s*(K + 4*s - 4)))) + 13*b1*(3*D1*(f**2*k2**4*(22*bd1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + fd*(183*r**2 + 3*r*(46*s - 49) - 45*s**2 + 93*s - 28)) + 22*f*(fd*(2*k1**4*(2*C*(r*(12*s - 5) + 12*s**2 - 8*s + 1) + r*(6 - 14*s) - 14*s**2 + 9*s - 1) - k1**2*k2**2*(r**2*(96*C - 68) + r*(8*C*(14*s - 5) - 80*s + 25) + (2*s - 1)*(s*(8*C - 6) - 1)) - 2*k2**4*(2*r + 2*s - 1)*(r*(8*C - 10) - 2*s + 1)) - 2*k2**2*(bd1*k1**2*(4*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + bd1*k2**2*(r**2*(6 - 4*K) + r*(K*(3 - 4*s) + 8*s - 5) + s*(K + 2*s - 3)) + 2*gd2*k2**2*r*(2*r + 2*s - 1))) - 176*fd*g2*k2**4*r*(r + s)) + Dd*f*(f**2*k2**4*(732*r**2 + r*(552*s - 593) - 180*s**2 + 427*s - 135) + 66*f*(k1**4*(C*(96*r*s - 40*r + 96*s**2 - 68*s + 8) - 56*r*s + 24*r - 56*s**2 + 38*s - 4) + k1**2*k2**2*(-4*C*(48*r**2 + 8*r*(7*s - 4) + 8*s**2 - 14*s + 3) + 136*r**2 + 160*r*s - 84*r + 24*s**2 - 39*s + 6) + 2*k2**4*(C*(-32*r**2 - 32*r*s + 24*r + 4*s - 2) + 40*r**2 + 48*r*s - 34*r + 8*s**2 - 14*s + 5)) - 264*g2*k2**4*(8*r**2 + r*(8*s - 4) - s))))/(3003*d**2*k1*k3**6) - 2*D1**3*Pk1*Pk3*ct*st**2*(429*b1**2*(D1*fd*(k1**4*(104*C - 52)*(s - 1)*(r + s - 1) + k1**2*k2**2*(-8*C*(26*r**2 + 27*r*(s - 1) + (s - 1)**2) + 130*r**2 + r*(4*f*(3*s - 2) + s*(14*K + 133) - 140) + 10*(s - 1)**2) + 2*k2**4*(-56*C*r**2 - 56*C*r*s + 56*C*r + K*(r**2 + 19*r*s + 8*r + 4*s - 4) + f*(24*r**2 - 8*r*(3*s - 4) - 48*s**2 + 96*s - 46) + 28*r**2 - 17*r*s - 64*r - 27*s**2 - 4*s + 4)) + Dd*f*(k1**4*(8*C - 4)*(4*r*(13*s - 8) + 52*s**2 - 81*s + 29) + k1**2*k2**2*(-16*C*(52*r**2 + r*(54*s - 64) + 2*s**2 - 15*s + 13) + 56*K*r*s - 14*K*s + 2*f*(4*r - 1)*(3*s - 2) + 520*r**2 + 532*r*s - 690*r + 40*s**2 - 193*s + 160) - 2*k2**4*(28*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 4*K*r**2 - 76*K*r*s - 17*K*r + 12*K*s + 8*K + f*(-48*r**2 + 48*r*s - 36*r + 96*s**2 - 184*s + 74) - 112*r**2 + 68*r*s + 188*r + 108*s**2 - 79*s - 36))) + 39*b1*(11*D1*bd1*f*(k1**4*(8*C - 4)*(r*(26*s - 6) + 26*s**2 - 29*s + 3) + k1**2*k2**2*(-16*C*(26*r**2 + r*(27*s - 37) + s**2 - 13*s + 12) + 28*K*r*s - 14*K*s + 2*f*(2*r - 1)*(3*s - 2) + 260*r**2 + 266*r*s - 410*r + 20*s**2 - 153*s + 140) - 4*k2**4*(14*C*(4*r**2 + 4*r*(s - 1) - s + 1) - K*r**2 - 19*K*r*s - 2*K*r + 9*K*s + K - 2*f*(6*r**2 - 6*r*s + r - 12*s**2 + 22*s - 7) - 28*r**2 + 17*r*s + 38*r + 27*s**2 - 29*s - 15)) + D1*(2*f**2*fd*k2**2*(22*k1**2*(r*(6*s - 3) - 3*s + 2) + k2**2*(1476*r**2 - r*(504*s + 535) - 1386*s**2 + 960*s + 10)) - 11*f*(fd*(2*k1**4*(4*C*(r*(23*s - 10) + 82*s**2 - 70*s + 14) + r*(20 - 46*s) - 186*s**2 + 165*s - 35) + k1**2*k2**2*(-4*C*(96*r**2 + r*(630*s - 271) + 524*s**2 - 430*s + 70) - 8*K*s + 236*r**2 + 2*r*(8*K*s + 877*s - 371) + 1608*s**2 - 1289*s + 202) + 2*k2**4*(-4*C*(4*r - 1)*(r + s - 1) + K*(34*r**2 - 2*r*s - 21*r + 2*s + 2) - 26*r**2 + 24*r*s - 9*r + 14*s**2 - 29*s + 9)) + 4*gd2*k2**2*(7*k1**2*r*s + k2**2*(r**2 + 19*r*s + 5*r + 2*s - 2))) - 44*fd*g2*k2**2*(7*k1**2*r*s + k2**2*(r**2 + 19*r*s + 8*r + 4*s - 4))) + Dd*f*(4*f**2*k2**2*(11*k1**2*(4*r - 1)*(2*s - 1) + 2*k2**2*(492*r**2 - r*(168*s + 271) - 462*s**2 + 269*s + 39)) - 11*f*(2*k1**4*(2*C*(r*(92*s - 40) + 328*s**2 - 325*s + 79) + r*(40 - 92*s) - 372*s**2 + 375*s - 93) + k1**2*k2**2*(-8*C*(96*r**2 + 5*r*(126*s - 65) + 524*s**2 - 501*s + 116) - 8*K*s + 472*r**2 + 2*r*(s*(16*K + 1754) - 883) + 3216*s**2 - 2997*s + 668) - 2*k2**4*(4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + K*(-68*r**2 + 4*r*s + 43*r + 6*s - 10) + 52*r**2 - 48*r*s + 13*r - 28*s**2 + 55*s - 21)) - 44*g2*k2**2*(7*k1**2*s*(4*r - 1) + k2**2*(4*r**2 + 76*r*s + 17*r - 12*s - 8)))) + f*(39*D1*bd1*(2*f**2*k2**2*(22*k1**2*(r*(2*s - 1) + s - 1) + k2**2*(492*r**2 - 3*r*(56*s + 183) - 462*s**2 + 116*s + 146)) - 11*f*(2*k1**4*(2*C*(r*(23*s - 11) + 82*s**2 - 69*s + 17) + r*(11 - 23*s) - 93*s**2 + 76*s - 17) + k1**2*k2**2*(-4*C*(48*r**2 + 3*r*(105*s - 34) + 262*s**2 - 206*s + 58) + 118*r**2 + r*(8*K*s + 877*s - 272) + 804*s**2 - 606*s + 168) - 2*k2**4*(4*C*r*(2*r + 2*s - 1) + K*(-17*r**2 + r*(s + 11) + 4*s - 4) + 13*r**2 - 12*r*s - 7*s**2 + 13*s - 6)) - 44*g2*k2**2*(7*k1**2*s*(r - 1) + k2**2*(r**2 + r*(19*s - 1) - 20*s))) - 2*D1*(3*f**2*fd*k2**2*(325*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(9780*r**2 + r*(26832*s - 19645) + 8580*s**2 - 15522*s + 6562)) + 13*f*(66*bd2*k2**4*(3*r**2 + r*(3*s - 5) - 3*s + 3) + fd*(3*k1**4*(8*C*r*(159*s - 86) + 12*C*(432*s**2 - 371*s + 83) + r*(344 - 636*s) - 2943*s**2 + 2526*s - 559) + k1**2*k2**2*(6*C*(1218*r**2 - 1983*r*s - 371*r - 2628*s**2 + 1940*s - 146) - 3960*r**2 + r*(9567*s - 483) + 11205*s**2 - 9768*s + 1549) + 33*k2**4*(r**2*(36*C - 99) + 3*r*(12*C*(2*s - 1) - 57*s + 32) - 36*s**2 + 36*s - 10)) + 66*gd2*k2**2*(-4*k1**2*r*s + k2**2*(-17*r**2 + r*s + 11*r + 4*s - 4))) - 858*fd*k2**2*(b2*k2**2*(-6*r**2 + r*(3 - 6*s) + 4*s) + g2*(4*k1**2*s*(2*r - 1) + k2**2*(34*r**2 - 2*r*s - 21*r + 2*s + 2)))) - 2*Dd*f*(3*f**2*k2**2*(325*k1**2*(4*r - 1)*(s - 1) + 2*k2**2*(9780*r**2 + r*(26832*s - 19645) + 8580*s**2 - 15522*s + 6562)) + 13*f*(6*k1**4*(4*C*(4*r*(53*s - 23) + 864*s**2 - 857*s + 209) - 8*r*(53*s - 23) - 1962*s**2 + 1953*s - 479) + k1**2*k2**2*(4*C*(2436*r**2 - 2*r*(1983*s + 173) - 5256*s**2 + 4522*s - 517) - 5280*r**2 + 4*r*(3189*s - 490) + 14940*s**2 - 14889*s + 2935) + 33*k2**4*(r**2*(48*C - 132) + r*(12*C*(8*s - 5) - 228*s + 151) - 48*s**2 + 54*s - 16)) + 858*k2**2*(b2*k2**2*(12*r**2 + r*(12*s - 13) - 10*s + 6) + g2*(4*k1**2*s*(1 - 4*r) + k2**2*(-68*r**2 + 4*r*s + 43*r + 6*s - 10))))))/(9009*d**2*k1*k2*k3**4) + 2*D1**3*Pk1*Pk3*ct*(462*b1**3*k1**2*k2**2*(D1*fd*(r**2 + 4*r*(s - 1) + 3*(s - 1)**2) + Dd*f*(4*r**2 + r*(16*s - 19) + 12*s**2 - 23*s + 11)) - 33*b1**2*(D1*(-14*bd1*f*k1**2*k2**2*(3*r**2 + 3*r*(4*s - 5) + 9*s**2 - 17*s + 8) + fd*(k1**4*(28 - 56*C)*(s - 1)*(r + s - 1) + k1**2*k2**2*(56*C*(4*r**2 + 7*r*(s - 1) + 3*(s - 1)**2) - 44*K*r**2 - 130*K*r*s - 136*K*r - 88*K*s**2 - 100*K*s + 68*K + 2*f*(84*r**2 + 9*r*(50*s - 21) + 372*s**2 - 335*s + 51) - 126*r**2 - 183*r*s + 306*r - 48*s**2 + 296*s - 146) + 2*k2**4*(f*(8*r**2 + r*(164*s - 119) + 156*s**2 - 219*s + 89) + 7*r**2*(K + 2) - 7*r*s*(3*K - 9) + 21*s**2))) + Dd*f*(k1**4*(56 - 112*C)*(2*s - 1)*(r + s - 1) + k1**2*k2**2*(112*C*(8*r**2 + r*(14*s - 11) + 6*s**2 - 10*s + 4) - 176*K*r**2 - 520*K*r*s - 364*K*r - 352*K*s**2 - 330*K*s + 420*K + 2*f*(168*r**2 + 900*r*s - 466*r + 744*s**2 - 813*s + 214) - 504*r**2 - 732*r*s + 774*r - 192*s**2 + 867*s - 456) + 2*k2**4*(2*f*(8*r**2 + 4*r*(41*s - 21) + 156*s**2 - 184*s + 53) + 7*r**2*(4*K + 8) + 7*r*(-12*K*s + 5*K + 36*s - 22) + 7*s*(12*s - 5)))) - b1*(3*D1*(2*f**2*k2**2*(11*bd1*(k1**2*(84*r**2 + 450*r*s - 277*r + 372*s**2 - 478*s + 163) + k2**2*(8*r**2 + 164*r*s - 49*r + 156*s**2 - 149*s + 17)) + fd*(3*k1**2*(1120*r**2 + 36*r*(83*s - 59) + 1155*s**2 - 2063*s + 806) + 11*k2**2*(36*r**2 + 9*r*(26*s - 15) + 198*s**2 - 243*s + 85))) - 11*f*(bd1*(k1**4*s*(112*C - 56)*(r + s - 1) + k1**2*k2**2*(-112*C*(4*r**2 + r*(7*s - 4) + 3*s**2 - 4*s + 1) + 2*K*(44*r**2 + 130*r*s + 46*r + 88*s**2 + 71*s - 88) + 252*r**2 + 366*r*s - 220*r + 96*s**2 - 333*s + 120) - 28*k2**4*(r**2*(K + 2) + r*(-3*K*s + K + 9*s - 6) + s*(3*s - 1))) + fd*(4*k1**4*(C*(r*(70*s - 36) + 28*s**2 - 22*s + 4) - 35*r*s + 18*r - 18*s**2 + 15*s - 3) + k1**2*k2**2*(4*C*(4*r**2 + r*(214*s - 57) + 56*s**2 - 6*s - 24) + 4*K*(310*r**2 + 446*r*s - 335*r + 156*s**2 - 276*s + 90) - 452*r**2 - 1574*r*s + 610*r - 596*s**2 + 511*s - 50) + 2*k2**4*(r**2*(14*K - 62) + r*(K*(54*s - 7) - 154*s + 31) + s*(-2*K - 50*s + 3))) + 4*k2**2*(14*bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - gd2*k1**2*(22*r**2 + r*(65*s + 68) + 44*s**2 + 44*s - 88) + 7*gd2*k2**2*r*(r - 3*s + 3))) - 44*fd*k2**2*(14*b2*k1**2*(r + s)**2 - g2*k1**2*(22*r**2 + r*(65*s + 68) + 44*s**2 + 50*s - 34) + 7*g2*k2**2*r*(r - 3*s))) + Dd*f*(2*f**2*k2**2*(k1**2*(13440*r**2 + r*(35856*s - 28742) + 13860*s**2 - 27937*s + 12367) + 264*k2**2*(6*r**2 + r*(39*s - 22) + 33*s**2 - 40*s + 12)) - 33*f*(2*k1**4*(2*C*(4*r*(35*s - 18) + 56*s**2 - 45*s + 9) + r*(72 - 140*s) - 72*s**2 + 61*s - 13) + k1**2*k2**2*(16*C*(2*r**2 + r*(107*s - 54) + 28*s**2 - 16*s + 1) + 4*K*(620*r**2 + 892*r*s - 821*r + 312*s**2 - 638*s + 296) - 904*r**2 - 3148*r*s + 1930*r - 1192*s**2 + 1479*s - 474) + 2*k2**4*(r**2*(28*K - 124) + r*(3*K*(36*s - 19) - 308*s + 179) + s*(-2*K - 100*s + 53))) - 132*k2**2*(14*b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - g2*k1**2*(88*r**2 + 26*r*(10*s + 7) + 176*s**2 + 165*s - 210) + 7*g2*k2**2*r*(4*r - 12*s + 5)))) + f*(-2*D1*bd1*f**2*k2**2*(k1**2*(3360*r**2 + r*(8964*s - 9626) + 3465*s**2 - 9370*s + 5113) + 33*k2**2*(12*r**2 + 78*r*s - 41*r + 66*s**2 - 77*s + 11)) + 33*D1*bd1*f*(2*k1**4*(2*C*(r*(35*s - 1) + 14*s**2 - 5*s + 1) - 35*r*s + r - 18*s**2 + 7*s - 1) + k1**2*k2**2*(4*C*(2*r**2 + r*(107*s - 52) + 28*s**2 - 28*s + 26) + 4*K*(155*r**2 + 223*r*s - 243*r + 78*s**2 - 181*s + 103) - 226*r**2 - 787*r*s + 566*r - 298*s**2 + 482*s - 236) + 2*k2**4*(r**2*(7*K - 31) + r*(K*(27*s - 25) - 77*s + 74) - s*(25*s - 25))) + 132*D1*bd1*k2**2*(14*b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - g2*k1**2*(22*r**2 + r*(65*s - 22) + s*(44*s + 27)) + 7*g2*k2**2*r*(r - 3*s - 1)) + 2*D1*(5*f**2*fd*k1**2*k2**2*(4*r*(413*s - 285) + 2376*s**2 - 3561*s + 1265) + 33*f*(fd*(2*k1**4*(4*C*(45*r*s - 16*r + 21*s**2 - 36*s + 10) - 90*r*s + 32*r - 51*s**2 + 78*s - 21) + k1**2*k2**2*(2*C*(144*r**2 + 531*r*s - 273*r + 198*s**2 - 222*s + 68) - 210*r**2 - 786*r*s + 380*r - 261*s**2 + 306*s - 89)) + 2*k2**2*(bd2*k1**2*(51*r**2 + r*(81*s - 85) + 30*s**2 - 64*s + 34) + bd2*k2**2*r*(r + s) - 2*gd2*k1**2*(155*r**2 + r*(223*s - 243) + 78*s**2 - 181*s + 103) - gd2*k2**2*r*(7*r + 27*s - 25))) + 66*fd*k2**2*(b2*k1**2*(102*r**2 + r*(162*s - 113) + 60*s**2 - 95*s + 31) + b2*k2**2*(r + s)*(2*r - 1) - 2*g2*k1**2*(310*r**2 + 446*r*s - 335*r + 156*s**2 - 276*s + 90) - g2*k2**2*(14*r**2 + r*(54*s - 7) - 2*s))) + 2*Dd*f*(5*f**2*k1**2*k2**2*(4*r*(413*s - 285) + 2376*s**2 - 3561*s + 1265) + 66*f*(k1**4*(2*C*(120*r*s - 62*r + 56*s**2 - 105*s + 39) - 120*r*s + 62*r - 68*s**2 + 115*s - 41) + k1**2*k2**2*(2*C*(96*r**2 + 354*r*s - 225*r + 132*s**2 - 166*s + 56) - 140*r**2 - 524*r*s + 321*r - 174*s**2 + 229*s - 77)) + 66*k2**2*(b2*k1**2*(204*r**2 + r*(324*s - 283) + 120*s**2 - 223*s + 99) + b2*k2**2*(r + s)*(4*r - 1) - 2*g2*k1**2*(620*r**2 + r*(892*s - 821) + 312*s**2 - 638*s + 296) - g2*k2**2*(28*r**2 + 3*r*(36*s - 19) - 2*s)))))/(693*d**2*k1*k2*k3**4) - 8*D1**3*Pk1*Pk3*ct*st**2*(39*D1*bd1*f*(f**2*k2**4*(k1**2*(409*r**2 + r*(846*s - 716) + 437*s**2 - 930*s + 293) - 33*k2**2*(6*r**2 + r*(2*s - 7) - 4*s**2 - s + 1)) + 11*f*(k1**6*(4*C - 2)*(7*s - 3)*(r + s - 1) + k1**4*k2**2*(-4*C*(54*r**2 + r*(173*s - 93) + 119*s**2 - 113*s + 39) + 123*r**2 + r*(418*s - 215) + 295*s**2 - 273*s + 92) + k1**2*k2**4*(4*C*(45*r**2 + 61*r*s - 62*r + 16*s**2 - 37*s + 17) - 96*K*r**2 - 156*K*r*s + 114*K*r - 60*K*s**2 + 84*K*s - 24*K + b1*(200*r**2 + r*(448*s - 319) + 248*s**2 - 319*s + 95) - 74*r**2 - 81*r*s + 100*r - 7*s**2 + 41*s - 26) - k2**6*(3*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + 2*r**2*(3 - 2*K) + 2*r*(-2*K*s + K + 4*s - 2) + 2*s*(s - 1))) - 11*k2**2*(39*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*b1*(k1**4*(30*C - 16)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(28*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*K*(103*r**2 + 167*r*s - 87*r + 64*s**2 - 78*s - 1) + 61*r**2 + 96*r*s - 22*r + 35*s**2 - 30*s - 22) - 7*k2**4*(r**2*(4*K - 6) + r*(K*(4*s - 3) - 8*s + 5) - s*(K + 2*s - 3))) + 4*k2**2*(13*b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(k1**2*(-103*r**2 - 167*r*s + 103*r - 64*s**2 + 94*s) + 7*k2**2*(-2*r**2 - 2*r*s + 2*r + s))))) - 16731*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k2**2*(D1*fd*(k1**4*(60*C - 32)*(r + s - 1)**2 + k1**2*k2**2*(56*C*(r + s - 1)**2 - 206*K*r**2 - 334*K*r*s - 8*K*r - 128*K*s**2 - 8*K*s + 4*K + f*(200*r**2 + 448*r*s - 213*r + 248*s**2 - 225*s + 49) + 61*r**2 + 96*r*s + 88*r + 35*s**2 + 88*s - 44) + k2**4*(-3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-14*r*(2*K - 3) + 14*s))) + Dd*f*(k1**4*(60*C - 32)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(56*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 824*K*r**2 - 1336*K*r*s + 482*K*r - 512*K*s**2 + 428*K*s + 12*K + 4*f*(100*r**2 + 7*r*(32*s - 19) + 124*s**2 - 136*s + 36) + 244*r**2 + 384*r*s + 61*r + 140*s**2 + 37*s - 132) - 2*k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 7*r**2*(8*K - 12) + 7*r*(8*K*s - 4*K - 16*s + 7) - 7*s*(K + 4*s - 4)))) + 39*b1*(D1*(f**2*fd*k2**4*(k1**2*(1227*r**2 + r*(2538*s - 1067) + 1311*s**2 - 1189*s + 250) - 33*k2**2*(18*r**2 + r*(6*s - 7) - 12*s**2 + 11*s - 1)) + 11*f*(fd*(k1**6*(4*C - 2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + k1**4*k2**2*(-4*C*(108*r**2 + 2*r*(173*s - 83) + 238*s**2 - 202*s + 37) + 246*r**2 + r*(836*s - 404) + 590*s**2 - 505*s + 95) + k1**2*k2**4*(4*C*(90*r**2 + r*(122*s - 63) + 32*s**2 - 32*s + 7) - 6*K*(32*r**2 + 52*r*s - 32*r + 20*s**2 - 23*s + 8) - 148*r**2 - 162*r*s + 74*r - 14*s**2 + 7*s + 6) + 2*k2**6*(r**2*(4*K - 6) + r*(K*(4*s - 2) - 8*s + 3) - s*(K + 2*s - 2))) + 4*k2**4*(-13*bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(k1**2*(103*r**2 + 167*r*s - 71*r + 64*s**2 - 62*s - 2) + 7*k2**2*r*(2*r + 2*s - 1)))) + 44*fd*k2**4*(-13*b2*k1**2*(r + s)**2 + g2*k1**2*(103*r**2 + r*(167*s + 4) + 64*s**2 + 4*s - 2) + 14*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(1636*r**2 + r*(3384*s - 1783) + 1748*s**2 - 2119*s + 543) - 66*k2**2*(12*r**2 + r*(4*s - 7) + s*(5 - 8*s))) + 11*f*(k1**6*(4*C - 2)*(4*r*(7*s - 4) + 28*s**2 - 39*s + 13) + k1**4*k2**2*(-8*C*(108*r**2 + r*(346*s - 202) + 238*s**2 - 240*s + 61) + 492*r**2 + 1672*r*s - 971*r + 1180*s**2 - 1188*s + 302) + k1**2*k2**4*(4*C*(180*r**2 + r*(244*s - 175) + 64*s**2 - 94*s + 33) - 6*K*(64*r**2 + 104*r*s - 70*r + 40*s**2 - 51*s + 16) - 296*r**2 - 324*r*s + 246*r - 28*s**2 + 61*s - 26) + 2*k2**6*(r**2*(8*K - 12) + r*(K*(8*s - 4) - 16*s + 7) - s*(K + 4*s - 4))) + 44*k2**4*(-13*b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(412*r**2 + 668*r*s - 241*r + 256*s**2 - 214*s - 6) + 7*k2**2*(8*r**2 + 8*r*s - 4*r - s))))) + f*(D1*(2*f**2*fd*k2**4*(k1**2*(24880*r**2 + 4*r*(6220*s - 7897) - 16178*s + 11321) + 78*k2**2*(48*r**2 + r*(318*s - 179) + 270*s**2 - 309*s + 89)) + 13*f*(fd*k1**2*(k1**4*(12*C - 6)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) + k1**2*k2**2*(-4*C*(1368*r**2 + 6984*r*s - 3471*r + 5616*s**2 - 6105*s + 1640) + 3141*r**2 + 16506*r*s - 8685*r + 13365*s**2 - 15072*s + 4251) + 33*k2**4*(4*C*(159*r**2 + 3*r*(83*s - 55) + 90*s**2 - 115*s + 38) - 453*r**2 - 711*r*s + 472*r - 258*s**2 + 326*s - 108)) - 132*k2**4*(bd2*k1**2*(8*r**2 + r*(16*s - 11) + 8*s**2 - 11*s + 3) - gd2*(3*k1**2*(16*r**2 + 26*r*s - 19*r + 10*s**2 - 14*s + 4) + k2**2*r*(-2*r - 2*s + 1)))) - 1716*fd*k2**4*(b2*k1**2*(16*r**2 + 2*r*(16*s - 7) + 16*s**2 - 14*s + 3) - g2*(3*k1**2*(32*r**2 + 52*r*s - 32*r + 20*s**2 - 23*s + 8) + k2**2*(-4*r**2 - 4*r*s + 2*r + s)))) + Dd*f*(2*f**2*k2**4*(k1**2*(24880*r**2 + 4*r*(6220*s - 7897) - 16178*s + 11321) + 78*k2**2*(48*r**2 + r*(318*s - 179) + 270*s**2 - 309*s + 89)) + 13*f*k1**2*(k1**4*(36*C - 18)*(4*r*(17*s - 8) + 68*s**2 - 93*s + 29) + k1**2*k2**2*(-4*C*(1824*r**2 + 9312*r*s - 5362*r + 7488*s**2 - 9055*s + 2718) + 4188*r**2 + 22008*r*s - 13439*r + 17820*s**2 - 22336*s + 7060) + 33*k2**4*(4*C*(212*r**2 + 332*r*s - 235*r + 120*s**2 - 162*s + 55) - 604*r**2 - 948*r*s + 677*r - 344*s**2 + 462*s - 158)) - 1716*k2**4*(b2*k1**2*(32*r**2 + 4*r*(16*s - 9) + 32*s**2 - 36*s + 9) - g2*(3*k1**2*(64*r**2 + 104*r*s - 70*r + 40*s**2 - 51*s + 16) + k2**2*(-8*r**2 - 8*r*s + 4*r + s))))))/(9009*d**2*k1*k2*k3**6) + 4*D1**3*Pk1*Pk3*ct*st**2*(D1*bd1*f**2*(k1**2*(r*(2*C - 1)*(5*s - 1) + s*(-12*C + 11*s - 1)) + 7*k2**2*r*(r - 1)) - b1**2*(D1*fd*(k1**2*(s - 1)**2 - 9*k2**2*r**2) + Dd*f*(k1**2*(4*s**2 - 6*s + 2) + 9*k2**2*r*(1 - 4*r))) + b1*f*(D1*(2*C*fd*k1**2*(2*r*(5*s - 6) - 7*s + 7) - 2*bd1*k1**2*s*(s - 1) + 9*bd1*k2**2*r*(2*r - 1) + 2*fd*k1**2*(r*(6 - 5*s) + s*(11*s - 9)) + 7*fd*k2**2*(2*r**2 - 3*r + 1)) + Dd*f*(k1**2*(C*(8*r*(5*s - 6) - 38*s + 26) - 20*r*s + 24*r + 44*s**2 - 31*s + 1) + 7*k2**2*(4*r**2 - 5*r + 1))))/(21*d**2*k1**3*k2) + 4*D1**3*Pk1*Pk3*ct*(D1*bd1*f**2*(k1**2*(-r*(2*C - 1)*(23*s - 1) + 2*s*(24*C + 2*s - 13)) - 11*k2**2*r**2) + b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(-D1*(bd1*f*k2**2*r*(1 - 3*r) + 14*fd*k1**2*(s - 1)**2 + fd*k2**2*(f*(4 - 8*r) + 19*r**2 - 10*r + 5)) + Dd*f*(-28*k1**2*(2*s**2 - 3*s + 1) + k2**2*(4*r - 1)*(4*f - 19*r + 5))) + b1*f*(D1*(-28*bd1*k1**2*s*(s - 1) + 2*bd1*k2**2*r*(4*f - 19*r + 12) + fd*k1**2*(C*(-92*r*s + 48*r + 98*s - 50) + 46*r*s - 24*r + 8*s**2 - 57*s + 27) + 11*fd*k2**2*r*(1 - 2*r)) + Dd*f*(k1**2*(-2*C*(92*r*s - 48*r - 97*s + 49) + 92*r*s - 48*r + 16*s**2 - 113*s + 53) + 11*k2**2*r*(1 - 4*r))))/(21*d**2*k1**3*k2) + 4*D1**3*Pk1*Pk3*ct*st**4*(264*b1**2*k1**2*(D1*fd*(s - 1)*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + Dd*f*(k1**2*(8*C - 6)*(2*s**2 - 3*s + 1) - k2**2*(C - 1)*(r*(8*s - 6) - s + 1))) + 33*b1*f*(8*D1*bd1*k1**2*(k1**2*s*(8*C - 6)*(s - 1) - k2**2*(C - 1)*(r*(4*s - 2) - s + 1)) + 2*D1*fd*(k1**4*s*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(r*s + r - 4*s**2 + 4*s - 1) + 4*k2**4*r**2) + Dd*f*(k1**4*s*(32*C - 16)*(2*s - 1) + k1**2*k2**2*(4*r*(s + 1) - 16*s**2 + 17*s - 6) + 4*k2**4*r*(4*r - 1))) + f**2*(D1*(33*bd1*(k1**4*s**2*(16*C - 8) + k1**2*k2**2*(r*(s + 2) - 4*s**2 + 3*s - 2) + 4*k2**4*r*(r - 1)) + fd*(k1**4*(1 - 3*s)**2*(160*C - 88) + 2*k1**2*k2**2*(2*C*(3*r - 1)*(27*s - 20) + r*(48 - 45*s) + 90*s**2 - 45*s - 6) + k2**4*(243*r**2 - 228*r + 49))) + Dd*f*(k1**4*(320*C - 176)*(6*s**2 - 5*s + 1) + 2*k1**2*k2**2*(C*(8*r*(27*s - 25) - 74*s + 60) - 60*r*s + 80*r + 120*s**2 - 77*s - 4) + k2**4*(324*r**2 - 277*r + 49))))/(231*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct*st**2*(11*b1**2*(4*C*k1**2*(D1*fd*(s - 1)*(k1**2*(26*r - 2*s + 2) + 5*k2**2*r) + 2*Dd*f*(k1**2*(52*r*s - 32*r - 4*s**2 + 3*s + 1) + k2**2*(10*r*s + 3*r + 4*s - 4))) + D1*fd*(-2*k1**4*(s - 1)*(26*r - 3*s + 3) + k1**2*k2**2*(2*f*(4*r*s - 2*r + s - 1) + r*(20 - 27*s)) + 18*k2**4*r**2) + Dd*f*(8*k1**4*(r*(16 - 26*s) + s*(3*s - 3)) + k1**2*k2**2*(2*f*(4*r - 1)*(2*s - 1) - 12*r*(9*s + 2) - 25*s + 32) + 18*k2**4*r*(4*r - 1))) + b1*f*(11*D1*bd1*(4*k1**4*(-2*C*(r*(6 - 26*s) + 2*s**2 + s - 3) - 26*r*s + 6*r + 3*s**2 - 3) + k1**2*k2**2*(8*C*(5*r*s + 8*r + 4*s - 4) + f*(8*r*s - 4*r - 6*s + 4) - 54*r*s - 64*r - 25*s + 32) + 18*k2**4*r*(2*r - 1)) + D1*fd*(-k1**4*(44*C - 22)*(76*s**2 - 47*s + 7) - 11*k1**2*k2**2*(4*C*(r*(22*s - 7) - 12*s + 4) + 4*K*r*s - 2*K*s - 4*f*(3*r - 1)*(3*s - 2) + 26*r*s - 48*r + 264*s**2 - 213*s + 52) + 2*k2**4*(-6*f*(9*r**2 + 27*r - 10) + 22*r**2 - 231*r + 77)) + Dd*f*(-k1**4*(176*C - 88)*(38*s**2 - 31*s + 6) - 11*k1**2*k2**2*(8*C*(r*(22*s - 7) - 8*s + 3) + 8*K*r*s - 2*K*s - 4*f*(4*r - 1)*(3*s - 2) + 52*r*s - 96*r + 528*s**2 - 497*s + 134) - 2*k2**4*(4*r - 1)*(18*f*r + 60*f - 11*r + 77))) + f*(D1*bd1*f*(-k1**4*(44*C - 22)*(38*s**2 - 27*s + 5) - 11*k1**2*k2**2*(r*(C*(44*s - 8) + 2*K*s - 12*f*s + 8*f + 13*s - 18) + 132*s**2 - s*(8*C + 94) + 24) - 2*k2**4*r*(18*f*r + 60*f - 11*r + 11)) - 2*D1*(f*fd*(k1**4*(4*C*(12*r*s - 26*r + 792*s**2 - 587*s + 115) - 24*r*s + 52*r - 1935*s**2 + 1474*s - 291) + k1**2*k2**2*(4*C*(189*r**2 + 396*r*s - 291*r - 198*s + 98) - 642*r**2 - 909*r*s + 841*r + 198*s**2 + 270*s - 220) + 66*k2**4*r*(3*r - 1)) + 11*f*k1**2*k2**2*r*s*(bd2 - 2*gd2) + 11*fd*k1**2*k2**2*s*(b2 - 2*g2)*(2*r - 1)) - 2*Dd*f*(f*(2*k1**4*(16*C*(2*r*s + r + 132*s**2 - 117*s + 25) - 8*r*(2*s + 1) - 1290*s**2 + 1175*s - 261) + k1**2*k2**2*(4*C*(252*r**2 + r*(528*s - 455) - 264*s + 164) - 856*r**2 - 2*r*(606*s - 647) + 264*s**2 + 337*s - 353) + 66*k2**4*r*(4*r - 1)) + k1**2*k2**2*s*(11*b2 - 22*g2)*(4*r - 1))))/(231*d**2*k1**3*k2*k3**2) + 2*D1**3*Pk1*Pk3*ct*(11*b1**2*(D1*fd*(-28*k1**4*(s - 1)*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(84*C*r*s - 84*C*r - 4*K*(r - 1)*(3*r - s - 3) + 2*f*(r*(100*s - 43) + 168*s**2 - 187*s + 63) - 97*r*s + 72*r + 14*s**2 + 4*s + 6) - 28*k2**4*r**2) + Dd*f*(-56*k1**4*(2*s - 1)*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(336*C*r*s - 168*C*r - 4*K*(12*r**2 - 4*r*s + 7*r + 34*s - 19) + 2*f*(4*r*(50*s - 17) + 336*s**2 - 302*s + 59) - 388*r*s + 164*r + 56*s**2 + 151*s - 82) + 28*k2**4*r*(1 - 4*r))) + b1*(D1*(2*f**2*k1**2*k2**2*(11*bd1*(25*r*(4*s - 1) + 168*s**2 - 115*s - 4) + 2*fd*(405*r**2 + 1683*r*s - 1117*r + 1188*s**2 - 2277*s + 936)) + 11*f*(bd1*(-56*k1**4*s*(2*C*(r + 2*s - 2) - r - 3*s + 3) + k1**2*k2**2*(-4*K*(6*r**2 + r*(5 - 2*s) + 22*s - 11) + 2*r*(84*C*s - 97*s + 2) + 28*s**2 + 117*s - 44) + 28*k2**4*r*(1 - 2*r)) + fd*(k1**4*(4*C - 2)*(4*s**2 - 59*s + 29) + k1**2*k2**2*(-2*K*(52*r**2 + r*(50*s - 58) - 51*s + 16) + r**2*(16*C + 96) + 2*r*(100*C*s - 54*C + 79*s - 38) + 116*s**2 - 147*s + 26) + 22*k2**4*r*(1 - 2*r)) + 8*gd2*k1**2*k2**2*(3*r**2 - r*(s - 8) + 11*s - 11)) + 88*fd*g2*k1**2*k2**2*(r - 1)*(3*r - s - 3)) + Dd*f*(4*f**2*k1**2*k2**2*(540*r**2 + 17*r*(132*s - 91) + 1584*s**2 - 3003*s + 1178) + 11*f*(k1**4*(16*C - 8)*(2*s**2 - 29*s + 14) + k1**2*k2**2*(-2*K*(104*r**2 + 2*r*(50*s - 67) - 99*s + 64) + r**2*(32*C + 192) + 4*r*(100*C*s - 52*C + 79*s - 80) + 232*s**2 - 415*s + 178) + 22*k2**4*r*(1 - 4*r)) + 88*g2*k1**2*k2**2*(12*r**2 + r*(7 - 4*s) + 34*s - 19))) + f*(D1*bd1*(4*f**2*k1**2*k2**2*(135*r**2 + 561*r*s - 430*r + 396*s**2 - 726*s + 242) + 11*f*(k1**4*(4*C - 2)*(2*s**2 - 27*s - 1) + k1**2*k2**2*(K*(-52*r**2 + r*(76 - 50*s) + 48*s - 48) + r**2*(8*C + 48) + r*(100*C*s + 79*s - 134) + 58*s**2 - 134*s + 76) - 22*k2**4*r**2) + 88*g2*k1**2*k2**2*(3*r**2 - r*(s + 3) + 11*s)) - 22*k1**2*(D1*(f*(4*fd*k1**2*(C*(r*(60*s - 22) + 9*s**2 - 40*s + 13) + r*(11 - 30*s) - 9*s**2 + 23*s - 7) + fd*k2**2*r*(-6*r - 99*s + 35) + k2**2*(bd2 - 2*gd2)*(26*r**2 + 25*r*s - 38*r - 24*s + 24)) + fd*k2**2*(b2 - 2*g2)*(52*r**2 + r*(50*s - 58) - 51*s + 16)) + Dd*f*(2*f*(k1**2*(2*C*(80*r*s - 42*r + 12*s**2 - 55*s + 25) - 80*r*s + 42*r - 24*s**2 + 65*s - 27) - 2*k2**2*r*(2*r + 33*s - 17)) + k2**2*(b2 - 2*g2)*(104*r**2 + 2*r*(50*s - 67) - 99*s + 64)))))/(231*d**2*k1**3*k2*k3**2) + 4*D1**3*Pk1*Pk3*ct*st**4*(D1*(3432*b1**2*fd*k1**2*k2**2*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C))*(r + s - 1) + 858*b1*f*k1**2*(2*bd1*k1**2*k2**2*(4*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*bd1*k2**4*(C - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*k1**4*s*(8*C - 4)*(2*s - 1) + fd*k1**2*k2**2*(r*(4*C*(17*s - 6) - 43*s + 15) + (2*s - 1)*(s*(12*C - 8) - 1)) + fd*k2**4*(r**2*(12 - 4*C) + r*(C*(8*s - 4) - 4*s + 3) - (1 - 2*s)**2)) + 3*f**3*k2**4*(195*bd1*k2**2*r*(r - 1) + 2*fd*(4*r - 1)*(52*k1**2*(3*s - 2) + 15*k2**2*(3*r - 4))) - 13*f**2*(33*bd1*k1**2*(k1**4*s**2*(16*C - 8) + k1**2*k2**2*(-4*C*(r*(17*s + 2) + 6*s**2 - s - 2) + r*(43*s + 6) + 16*s**2 + s - 6) + 4*k2**4*(C*(r**2 - 2*r*(s + 1) - 2*s + 1) - 3*r**2 + r*(s + 5) + s**2 + 4*s - 2)) + fd*(-135*b1*k2**6*r**2 + k1**6*(1 - 3*s)**2*(192*C - 104) + 2*k1**4*k2**2*(-22*C*(3*r*(27*s - 8) + 72*s**2 - 75*s + 16) + 3*r*(381*s - 116) + 1062*s**2 - 1089*s + 234) + k1**2*k2**4*(-8*C*(3*r - 1)*(24*r - 6*s + 5) + 99*r**2 - 396*r*(2*s - 1) - 180*s**2 + 384*s - 163)))) + Dd*f*(1716*b1**2*k1**2*k2**2*(k1**2*(4*C - 3)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(2 - 2*C)*(8*r**2 + 8*r*(s - 1) - s + 1)) - 429*b1*f*k1**2*(k1**4*s*(32*C - 16)*(2*s - 1) + k1**2*k2**2*(C*(-272*r*s + 96*r - 96*s**2 + 52*s + 8) + 172*r*s - 60*r + 64*s**2 - 25*s - 10) + 2*k2**4*(2*C*(4*r**2 - 8*r*s + 3*r - 2*s + 1) - 24*r**2 + 8*r*s + 8*s**2 + s - 2)) + 6*f**3*k2**4*(4*r - 1)*(52*k1**2*(3*s - 2) + 15*k2**2*(3*r - 4)) - 13*f**2*(45*b1*k2**6*r*(1 - 4*r) + k1**6*(384*C - 208)*(6*s**2 - 5*s + 1) - 2*k1**4*k2**2*(22*C*(108*r*s - 40*r + 96*s**2 - 111*s + 28) - 1524*r*s + 580*r - 1416*s**2 + 1619*s - 410) + k1**2*k2**4*(-4*C*(192*r**2 - 48*r*s - 26*r + 3*s - 1) + 132*r**2 - 1056*r*s + 539*r - 240*s**2 + 464*s - 183))))/(3003*d**2*k1**3*k2*k3**4) - 40*D1**3*Pk1*Pk3*f*k2**4*st**6*(-13*D1*bd1*f*(k1**2*(132*C - 66)*(2*r + 2*s - 1) - k2**2*(132*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 17)))*(r + s - 1) + 858*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + k1**2*(66 - 132*C)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s - 17) + k1**2*(66 - 132*C)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(212*r**2 + r*(424*s - 331) + 212*s**2 - 331*s + 129) + k1**2*(26 - 52*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(53*r + 53*s - 43) + k1**2*(26 - 52*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(3003*d**2*k3**8) + 40*D1**3*Pk1*Pk3*f*k2**2*st**6*(13*D1*bd1*f*(2*f*k2**4*(6*r**2 + r*(6*s - 8) - 3*s + 2) + k1**4*(132*C - 66)*(r*(4*s - 1) + (1 - 2*s)**2) - 33*k1**2*k2**2*(4*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 16*r**2 + r*(21 - 20*s) - 4*s**2 + 12*s - 5)) + 13*b1*(6*D1*fd*(2*f*k2**4*r*(3*r + 3*s - 2) + k1**4*(44*C - 22)*(2*s - 1)*(2*r + 2*s - 1) - 11*k1**2*k2**2*(2*r + 2*s - 1)*(2*C*(6*r + 2*s - 1) - 8*r - 2*s + 1)) + Dd*f*(2*f*k2**4*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**4*(132*C - 66)*(2*s - 1)*(8*r + 8*s - 5) - 33*k1**2*k2**2*(8*C*(12*r**2 + r*(16*s - 11) + 4*s**2 - 6*s + 2) - 64*r**2 + r*(56 - 80*s) - 16*s**2 + 26*s - 9))) - f*(D1*fd*(f*k2**4*(696*r**2 + 8*r*(87*s - 100) - 239*s + 189) + k1**4*(52 - 104*C)*(3*s - 1)*(3*r + 3*s - 2) + 26*k1**2*k2**2*(3*r + 3*s - 2)*(2*C*(9*r + 3*s - 4) - 12*r - 3*s + 5)) + Dd*f*(f*k2**4*(696*r**2 + 8*r*(87*s - 100) - 239*s + 189) + k1**4*(26 - 52*C)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 13*k1**2*k2**2*(4*C*(36*r**2 + r*(48*s - 41) + 12*s**2 - 24*s + 11) - 96*r**2 - 2*r*(60*s - 53) - 24*s**2 + 55*s - 27))))/(9009*d**2*k1**2*k3**6) - 20*D1**3*Pk1*Pk3*f*st**6*(33*b1*(2*s - 1)*(4*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + Dd*f*(k1**2*(16*C - 8)*(2*s - 1) + k2**2*(8*r - 1))) + f*(33*D1*bd1*(k1**2*s*(8*C - 4)*(2*s - 1) + k2**2*(r*(4*s - 1) - 2*s + 1)) + 2*D1*fd*(3*s - 1)*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1)) + Dd*f*k1**2*(16*C - 8)*(6*s**2 - 5*s + 1) + Dd*f*k2**2*(2*r*(12*s - 5) - 7*s + 3)))/(693*d**2*k1**2*k3**2) - 5*D1**3*Pk1*Pk3*f*st**6*(33*b1*(D1*fd*(k1**4*(1 - 2*s)**2*(16 - 32*C) + 16*k1**2*k2**2*(2*s - 1)*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1) + k2**4*r*(3*f*(5*s - 3) - r*(32*C - 64) + 32*s - 16)) + Dd*f*(k1**4*(1 - 2*s)**2*(32 - 64*C) + 4*k1**2*k2**2*(2*s - 1)*(8*C*(8*r + 4*s - 3) - 40*r - 16*s + 13) + k2**4*(f*(4*r - 1)*(5*s - 3) - r**2*(64*C - 128) + 16*r*(C + 4*s - 4) - 8*s + 4))) + f*(D1*(-33*bd1*(k1**4*s*(32*C - 16)*(2*s - 1) - 4*k1**2*k2**2*(8*C*(4*r*s - r + 2*s**2 - 3*s + 1) - 20*r*s + 5*r - 8*s**2 + 14*s - 5) + k2**4*(-f*(r - 1)*(5*s - 3) + r**2*(16*C - 32) - 4*r*(4*C + 4*s - 9) + 8*s - 4)) + fd*(k1**4*(1 - 3*s)**2*(16 - 32*C) + 8*k1**2*k2**2*(3*s - 1)*(12*C*(2*r + s - 1) - 15*r - 6*s + 7) + k2**4*(-8*C*(1 - 3*r)**2 + 3*f*(4*r - 1)*(5*s - 3) + (72*r - 24)*(2*r + s - 1)))) + Dd*f*(k1**4*(32 - 64*C)*(6*s**2 - 5*s + 1) + 4*k1**2*k2**2*(8*C*(12*s - 5)*(2*r + s - 1) + r*(50 - 120*s) - 48*s**2 + 75*s - 23) + k2**4*(-8*C*(12*r**2 - 7*r + 1) + 3*f*(4*r - 1)*(5*s - 3) + (96*r - 28)*(2*r + s - 1)))))/(693*d**2*k1**2*k3**4) - 16*D1**3*Pk1*Pk3*k1**4*(D1*(-2*b1*fd*(k1**2 + 7*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 5*bd1*f**3*k2**2*(r + s - 1)**2 + f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(2*r + 2*s - 1) + 6*K*k2**2*(r + s) - 6*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))) + 2*f*(fd*(b1*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) + 2*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)))*(2*r + 2*s - 1) + (k1**2 + 7*k2**2)*(2*b1*gd2 + 2*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(5*b1*f**2*k2**2*(r + s - 1) + 2*b1*f*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) - 2*b1*(k1**2 + 7*k2**2)*(r + s)*(K*b1 - 2*g2) + 4*f*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))))/(7*d**2*k3**8) + 4*D1**3*Pk1*Pk3*k1**2*(-3432*C*D1*b1*f*fd*k1**2*r*s + 1716*C*D1*b1*f*fd*k1**2*r - 3432*C*D1*b1*f*fd*k1**2*s**2 + 5148*C*D1*b1*f*fd*k1**2*s - 1716*C*D1*b1*f*fd*k1**2 - 4356*C*D1*f**2*fd*k1**2*r*s + 1452*C*D1*f**2*fd*k1**2*r - 4356*C*D1*f**2*fd*k1**2*s**2 + 5808*C*D1*f**2*fd*k1**2*s - 1452*C*D1*f**2*fd*k1**2 - 6864*C*Dd*b1*f**2*k1**2*r*s + 3432*C*Dd*b1*f**2*k1**2*r - 6864*C*Dd*b1*f**2*k1**2*s**2 + 10296*C*Dd*b1*f**2*k1**2*s - 3432*C*Dd*b1*f**2*k1**2 - 5808*C*Dd*f**3*k1**2*r*s + 2904*C*Dd*f**3*k1**2*r - 5808*C*Dd*f**3*k1**2*s**2 + 8712*C*Dd*f**3*k1**2*s - 2904*C*Dd*f**3*k1**2 - 1452*D1*K*b1**2*fd*k1**2*r**2 - 2904*D1*K*b1**2*fd*k1**2*r*s - 528*D1*K*b1**2*fd*k1**2*r - 1452*D1*K*b1**2*fd*k1**2*s**2 - 528*D1*K*b1**2*fd*k1**2*s + 264*D1*K*b1**2*fd*k1**2 - 6006*D1*K*b1**2*fd*k2**2*r**2 - 10164*D1*K*b1**2*fd*k2**2*r*s - 4158*D1*K*b1**2*fd*k2**2*s**2 - 8976*D1*K*b1*f*fd*k1**2*r**2 - 16104*D1*K*b1*f*fd*k1**2*r*s + 8976*D1*K*b1*f*fd*k1**2*r - 7128*D1*K*b1*f*fd*k1**2*s**2 + 8184*D1*K*b1*f*fd*k1**2*s - 2244*D1*K*b1*f*fd*k1**2 - 11484*D1*K*b1*f*fd*k2**2*r**2 - 19536*D1*K*b1*f*fd*k2**2*r*s + 5742*D1*K*b1*f*fd*k2**2*r - 8052*D1*K*b1*f*fd*k2**2*s**2 + 4158*D1*K*b1*f*fd*k2**2*s - 924*D1*b1**3*fd*k2**2*r**2 - 1848*D1*b1**3*fd*k2**2*r*s + 1848*D1*b1**3*fd*k2**2*r - 924*D1*b1**3*fd*k2**2*s**2 + 1848*D1*b1**3*fd*k2**2*s - 924*D1*b1**3*fd*k2**2 + 1980*D1*b1**2*f*fd*k1**2*r*s - 1782*D1*b1**2*f*fd*k1**2*r + 1980*D1*b1**2*f*fd*k1**2*s**2 - 2706*D1*b1**2*f*fd*k1**2*s + 858*D1*b1**2*f*fd*k1**2 + 2574*D1*b1**2*f*fd*k2**2*r**2 + 7722*D1*b1**2*f*fd*k2**2*r*s - 4356*D1*b1**2*f*fd*k2**2*r + 5148*D1*b1**2*f*fd*k2**2*s**2 - 5214*D1*b1**2*f*fd*k2**2*s + 924*D1*b1**2*f*fd*k2**2 + 264*D1*b1**2*fd*k1**2*r*s + 264*D1*b1**2*fd*k1**2*s**2 + 924*D1*b1**2*fd*k2**2*r**2 + 1848*D1*b1**2*fd*k2**2*r*s + 924*D1*b1**2*fd*k2**2*s**2 - 264*D1*b1*b2*fd*k1**2*r**2 - 528*D1*b1*b2*fd*k1**2*r*s - 264*D1*b1*b2*fd*k1**2*s**2 - 1848*D1*b1*b2*fd*k2**2*r**2 - 3696*D1*b1*b2*fd*k2**2*r*s - 1848*D1*b1*b2*fd*k2**2*s**2 + 2970*D1*b1*f**2*fd*k1**2*r*s - 2310*D1*b1*f**2*fd*k1**2*r + 2970*D1*b1*f**2*fd*k1**2*s**2 - 4224*D1*b1*f**2*fd*k1**2*s + 1518*D1*b1*f**2*fd*k1**2 + 5445*D1*b1*f**2*fd*k2**2*r**2 + 11781*D1*b1*f**2*fd*k2**2*r*s - 8646*D1*b1*f**2*fd*k2**2*r + 6336*D1*b1*f**2*fd*k2**2*s**2 - 7359*D1*b1*f**2*fd*k2**2*s + 2475*D1*b1*f**2*fd*k2**2 + 2772*D1*b1*f*fd*k1**2*r*s - 858*D1*b1*f*fd*k1**2*r + 2772*D1*b1*f*fd*k1**2*s**2 - 3102*D1*b1*f*fd*k1**2*s + 858*D1*b1*f*fd*k1**2 + 1584*D1*b1*f*fd*k2**2*r**2 + 3168*D1*b1*f*fd*k2**2*r*s - 792*D1*b1*f*fd*k2**2*r + 1584*D1*b1*f*fd*k2**2*s**2 + 2904*D1*b1*f*gd2*k1**2*r**2 + 5808*D1*b1*f*gd2*k1**2*r*s - 2376*D1*b1*f*gd2*k1**2*r + 2904*D1*b1*f*gd2*k1**2*s**2 - 2376*D1*b1*f*gd2*k1**2*s - 528*D1*b1*f*gd2*k1**2 + 12012*D1*b1*f*gd2*k2**2*r**2 + 20328*D1*b1*f*gd2*k2**2*r*s - 12012*D1*b1*f*gd2*k2**2*r + 8316*D1*b1*f*gd2*k2**2*s**2 - 8316*D1*b1*f*gd2*k2**2*s + 2904*D1*b1*fd*g2*k1**2*r**2 + 5808*D1*b1*fd*g2*k1**2*r*s + 1056*D1*b1*fd*g2*k1**2*r + 2904*D1*b1*fd*g2*k1**2*s**2 + 1056*D1*b1*fd*g2*k1**2*s - 528*D1*b1*fd*g2*k1**2 + 12012*D1*b1*fd*g2*k2**2*r**2 + 20328*D1*b1*fd*g2*k2**2*r*s + 8316*D1*b1*fd*g2*k2**2*s**2 - 1056*D1*b2*f*fd*k1**2*r**2 - 2112*D1*b2*f*fd*k1**2*r*s + 1056*D1*b2*f*fd*k1**2*r - 1056*D1*b2*f*fd*k1**2*s**2 + 1056*D1*b2*f*fd*k1**2*s - 264*D1*b2*f*fd*k1**2 - 3168*D1*b2*f*fd*k2**2*r**2 - 6336*D1*b2*f*fd*k2**2*r*s + 1584*D1*b2*f*fd*k2**2*r - 3168*D1*b2*f*fd*k2**2*s**2 + 1584*D1*b2*f*fd*k2**2*s + 33*D1*bd1*f*(-28*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 4*b1*(K*(k1**2*(22*r + 22*s + 2) + 7*k2**2*(13*r + 9*s))*(r + s - 1) + k1**2*(-4*r*s + r + s*(3 - 4*s)) - 7*k2**2*(2*r**2 + r*(4*s - 3) + s*(2*s - 1))) + f**2*(2*k1**2*(s - 1)*(15*r + 15*s - 13) + k2**2*(55*r**2 + r*(119*s - 141) + 64*(s - 1)**2)) + f*(2*k1**2*(-26*C*r*s - 26*C*s**2 + 26*C*s - 2*K*(34*r**2 + 61*r*s - 52*r + 27*s**2 - 45*s + 18) + b1*(3*r*(10*s - 9) + 30*s**2 - 53*s + 25) + 21*r*s - 4*r + 21*s**2 - 23*s + 2) + k2**2*(b1*(78*r**2 + 3*r*(78*s - 73) + 156*s**2 - 245*s + 115) - 2*r**2*(87*K - 12) - 2*r*(148*K*s - 85*K - 24*s + 24) - 2*s*(61*K - 12)*(s - 1))) - 4*(r + s - 1)*(2*b2*(k1**2 + 7*k2**2)*(r + s) - 22*g2*k1**2*(r + s) - 7*g2*k2**2*(13*r + 9*s))) - 264*D1*bd2*f*(r + s - 1)*(b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s)) - 2440*D1*f**3*fd*k2**2*r*s + 1220*D1*f**3*fd*k2**2*r - 2440*D1*f**3*fd*k2**2*s**2 + 3660*D1*f**3*fd*k2**2*s - 1220*D1*f**3*fd*k2**2 + 2178*D1*f**2*fd*k1**2*r*s - 726*D1*f**2*fd*k1**2*r + 2178*D1*f**2*fd*k1**2*s**2 - 2904*D1*f**2*fd*k1**2*s + 726*D1*f**2*fd*k1**2 + 8976*D1*f**2*gd2*k1**2*r**2 + 16104*D1*f**2*gd2*k1**2*r*s - 13728*D1*f**2*gd2*k1**2*r + 7128*D1*f**2*gd2*k1**2*s**2 - 11880*D1*f**2*gd2*k1**2*s + 4752*D1*f**2*gd2*k1**2 + 11484*D1*f**2*gd2*k2**2*r**2 + 19536*D1*f**2*gd2*k2**2*r*s - 11220*D1*f**2*gd2*k2**2*r + 8052*D1*f**2*gd2*k2**2*s**2 - 8052*D1*f**2*gd2*k2**2*s + 17952*D1*f*fd*g2*k1**2*r**2 + 32208*D1*f*fd*g2*k1**2*r*s - 17952*D1*f*fd*g2*k1**2*r + 14256*D1*f*fd*g2*k1**2*s**2 - 16368*D1*f*fd*g2*k1**2*s + 4488*D1*f*fd*g2*k1**2 + 22968*D1*f*fd*g2*k2**2*r**2 + 39072*D1*f*fd*g2*k2**2*r*s - 11484*D1*f*fd*g2*k2**2*r + 16104*D1*f*fd*g2*k2**2*s**2 - 8316*D1*f*fd*g2*k2**2*s - 5808*Dd*K*b1**2*f*k1**2*r**2 - 11616*Dd*K*b1**2*f*k1**2*r*s + 3300*Dd*K*b1**2*f*k1**2*r - 5808*Dd*K*b1**2*f*k1**2*s**2 + 3300*Dd*K*b1**2*f*k1**2*s + 792*Dd*K*b1**2*f*k1**2 - 24024*Dd*K*b1**2*f*k2**2*r**2 - 40656*Dd*K*b1**2*f*k2**2*r*s + 18018*Dd*K*b1**2*f*k2**2*r - 16632*Dd*K*b1**2*f*k2**2*s**2 + 12474*Dd*K*b1**2*f*k2**2*s - 17952*Dd*K*b1*f**2*k1**2*r**2 - 32208*Dd*K*b1*f**2*k1**2*r*s + 22704*Dd*K*b1*f**2*k1**2*r - 14256*Dd*K*b1*f**2*k1**2*s**2 + 20064*Dd*K*b1*f**2*k1**2*s - 6996*Dd*K*b1*f**2*k1**2 - 22968*Dd*K*b1*f**2*k2**2*r**2 - 39072*Dd*K*b1*f**2*k2**2*r*s + 16962*Dd*K*b1*f**2*k2**2*r - 16104*Dd*K*b1*f**2*k2**2*s**2 + 12210*Dd*K*b1*f**2*k2**2*s - 3696*Dd*b1**3*f*k2**2*r**2 - 7392*Dd*b1**3*f*k2**2*r*s + 6468*Dd*b1**3*f*k2**2*r - 3696*Dd*b1**3*f*k2**2*s**2 + 6468*Dd*b1**3*f*k2**2*s - 2772*Dd*b1**3*f*k2**2 + 3960*Dd*b1**2*f**2*k1**2*r*s - 3564*Dd*b1**2*f**2*k1**2*r + 3960*Dd*b1**2*f**2*k1**2*s**2 - 6204*Dd*b1**2*f**2*k1**2*s + 2508*Dd*b1**2*f**2*k1**2 + 5148*Dd*b1**2*f**2*k2**2*r**2 + 15444*Dd*b1**2*f**2*k2**2*r*s - 11583*Dd*b1**2*f**2*k2**2*r + 10296*Dd*b1**2*f**2*k2**2*s**2 - 13299*Dd*b1**2*f**2*k2**2*s + 4719*Dd*b1**2*f**2*k2**2 + 1056*Dd*b1**2*f*k1**2*r*s - 264*Dd*b1**2*f*k1**2*r + 1056*Dd*b1**2*f*k1**2*s**2 - 660*Dd*b1**2*f*k1**2*s + 3696*Dd*b1**2*f*k2**2*r**2 + 7392*Dd*b1**2*f*k2**2*r*s - 4620*Dd*b1**2*f*k2**2*r + 3696*Dd*b1**2*f*k2**2*s**2 - 1848*Dd*b1**2*f*k2**2*s - 1056*Dd*b1*b2*f*k1**2*r**2 - 2112*Dd*b1*b2*f*k1**2*r*s + 792*Dd*b1*b2*f*k1**2*r - 1056*Dd*b1*b2*f*k1**2*s**2 + 792*Dd*b1*b2*f*k1**2*s - 7392*Dd*b1*b2*f*k2**2*r**2 - 14784*Dd*b1*b2*f*k2**2*r*s + 5544*Dd*b1*b2*f*k2**2*r - 7392*Dd*b1*b2*f*k2**2*s**2 + 5544*Dd*b1*b2*f*k2**2*s + 3960*Dd*b1*f**3*k1**2*r*s - 3300*Dd*b1*f**3*k1**2*r + 3960*Dd*b1*f**3*k1**2*s**2 - 6072*Dd*b1*f**3*k1**2*s + 2376*Dd*b1*f**3*k1**2 + 7260*Dd*b1*f**3*k2**2*r**2 + 15708*Dd*b1*f**3*k2**2*r*s - 13299*Dd*b1*f**3*k2**2*r + 8448*Dd*b1*f**3*k2**2*s**2 - 11583*Dd*b1*f**3*k2**2*s + 4587*Dd*b1*f**3*k2**2 + 5544*Dd*b1*f**2*k1**2*r*s - 2244*Dd*b1*f**2*k1**2*r + 5544*Dd*b1*f**2*k1**2*s**2 - 6996*Dd*b1*f**2*k1**2*s + 1980*Dd*b1*f**2*k1**2 + 3168*Dd*b1*f**2*k2**2*r**2 + 6336*Dd*b1*f**2*k2**2*r*s - 3960*Dd*b1*f**2*k2**2*r + 3168*Dd*b1*f**2*k2**2*s**2 - 1584*Dd*b1*f**2*k2**2*s + 11616*Dd*b1*f*g2*k1**2*r**2 + 23232*Dd*b1*f*g2*k1**2*r*s - 6600*Dd*b1*f*g2*k1**2*r + 11616*Dd*b1*f*g2*k1**2*s**2 - 6600*Dd*b1*f*g2*k1**2*s - 1584*Dd*b1*f*g2*k1**2 + 48048*Dd*b1*f*g2*k2**2*r**2 + 81312*Dd*b1*f*g2*k2**2*r*s - 36036*Dd*b1*f*g2*k2**2*r + 33264*Dd*b1*f*g2*k2**2*s**2 - 24948*Dd*b1*f*g2*k2**2*s - 2112*Dd*b2*f**2*k1**2*r**2 - 4224*Dd*b2*f**2*k1**2*r*s + 2640*Dd*b2*f**2*k1**2*r - 2112*Dd*b2*f**2*k1**2*s**2 + 2640*Dd*b2*f**2*k1**2*s - 792*Dd*b2*f**2*k1**2 - 6336*Dd*b2*f**2*k2**2*r**2 - 12672*Dd*b2*f**2*k2**2*r*s + 4752*Dd*b2*f**2*k2**2*r - 6336*Dd*b2*f**2*k2**2*s**2 + 4752*Dd*b2*f**2*k2**2*s - 2440*Dd*f**4*k2**2*r*s + 1220*Dd*f**4*k2**2*r - 2440*Dd*f**4*k2**2*s**2 + 3660*Dd*f**4*k2**2*s - 1220*Dd*f**4*k2**2 + 2904*Dd*f**3*k1**2*r*s - 1452*Dd*f**3*k1**2*r + 2904*Dd*f**3*k1**2*s**2 - 4356*Dd*f**3*k1**2*s + 1452*Dd*f**3*k1**2 + 35904*Dd*f**2*g2*k1**2*r**2 + 64416*Dd*f**2*g2*k1**2*r*s - 45408*Dd*f**2*g2*k1**2*r + 28512*Dd*f**2*g2*k1**2*s**2 - 40128*Dd*f**2*g2*k1**2*s + 13992*Dd*f**2*g2*k1**2 + 45936*Dd*f**2*g2*k2**2*r**2 + 78144*Dd*f**2*g2*k2**2*r*s - 33924*Dd*f**2*g2*k2**2*r + 32208*Dd*f**2*g2*k2**2*s**2 - 24420*Dd*f**2*g2*k2**2*s)/(693*d**2*k3**6) + 8*D1**3*Pk1*Pk3*k1**2*st**2*(13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + 8*K*r + 8*K*s - 3*K + b1*(-11*r - 11*s + 7) + 4*r + 4*s - 3) + k2**4*(-K*(r + s) + 3*b1*(5*r + 5*s - 3))) + k2**2*(13*k1**2 + 7*k2**2)*(r + s)*(-132*K*b1 + 132*g2)) - 429*b1**2*k2**2*(D1*fd*(2*K*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*(k1**2*(11*r + 11*s - 7) - 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**2*(11*r + 11*s - 7) - 3*f*k2**2*(5*r + 5*s - 3))) + 13*b1*(D1*(f**2*fd*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) - 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) + 132*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(-2*k1**2*(r + s - 17) + 65*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) - 26*f*(fd*k1**2*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(r + s - 1)) - 1716*fd*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(r + s - 17) - 65*k2**2*(11*r + 11*s - 9)) + f*k1**2*(52*C - 26)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3)) + 1716*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s)))))/(3003*d**2*k3**8) + 16*D1**3*Pk1*Pk3*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(K*b1 - 2*g2) + f**3*fd*k2**2*(k1**2*(-449*r - 449*s + 327) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 78*f**2*(11*bd1*(r + s - 1)*(-2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(r + s) + k1**2*k2**2*(b1*(-3*r - 3*s + 1) + (2*C - 1)*(2*r + 2*s - 1))) + fd*k1**4*(4*C - 2)*(3*r + 3*s - 2)**2) + 429*f*(b1**2*fd*k2**2*(k1**2*(3*r + 3*s - 1) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 2*b1*k1**2*(fd*(2*C - 1)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*bd1*g2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-429*b1*f*(2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2 - 4*C)*(r + s) + k1**2*k2**2*(b1*(3*r + 3*s - 1) + (2 - 4*C)*(2*r + 2*s - 1))) - 858*b1*k1**2*k2**2*(r + s)*(K*b1 - 2*g2) + f**3*k2**2*(k1**2*(449*r + 449*s - 327) - 13*k2**2*(17*r + 17*s - 11)) + f**2*k1**4*(312*C - 156)*(3*r + 3*s - 2)))/(1001*d**2*k3**8) + 4*D1**3*Pk1*Pk3*st**2*(858*b1**3*k2**2*(13*k1**2 + 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 429*b1**2*(-2*D1*(bd1*f*k2**2*(13*k1**2 + 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(2 - 4*C)*(r + s - 1)**2 + k1**2*k2**2*(-28*C*(r + s - 1)**2 + 90*K*r**2 + 154*K*r*s + 4*K*r + 64*K*s**2 + 4*K*s - 2*K - f*(56*r**2 + 136*r*s - 49*r + 80*s**2 - 55*s + 5) + r**2 + 2*r*s - 28*r + s**2 - 28*s + 14) + k2**4*(f*(11*r**2 + r*(19*s - 14) + 8*s**2 - 13*s + 6) + (14*r + 14*s)*(K*s + r*(3*K - 1))))) + Dd*f*(k1**4*(8*C - 4)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k1**2*k2**2*(28*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 360*K*r**2 - 616*K*r*s + 222*K*r - 256*K*s**2 + 204*K*s + 6*K + 2*f*(56*r**2 + 68*r*(2*s - 1) + 80*s**2 - 71*s + 12) - 4*r**2 - 8*r*s + 73*r - 4*s**2 + 52*s - 42) - k2**4*(112*K*s*(s - 1) + f*(44*r**2 + r*(76*s - 55) + 32*s**2 - 51*s + 19) + 14*r**2*(24*K - 8) + 28*r*(K*(16*s - 7) - 4*s + 2) + 14*s))) - 13*b1*(33*D1*bd1*f*(k1**4*(8*C - 4)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**2*k2**2*(28*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 180*K*r**2 - 308*K*r*s + 158*K*r - 128*K*s**2 + 146*K*s + 2*K + f*(56*r**2 + 136*r*s - 87*r + 80*s**2 - 87*s + 19) - 2*r**2 - 4*r*s + 23*r - 2*s**2 + 9*s - 14) - k2**4*(14*K*s*(4*s - 6) + f*(22*r**2 + r*(38*s - 27) + 16*s**2 - 25*s + 7) + 14*r**2*(12*K - 4) + 14*r*(2*K*(8*s - 5) - 4*s + 3) + 14*s)) + 3*D1*(f**2*fd*k2**2*(2*k1**2*(147*r**2 + 4*r*(117*s - 25) + 321*s**2 - 216*s + 7) - 11*k2**2*(72*r**2 + r*(72*s - 49) - s + 5)) - 22*f*(fd*(k1**4*(4*C*(12*r**2 + r*(50*s - 23) + 38*s**2 - 28*s + 4) - 24*r**2 + r*(49 - 104*s) - 80*s**2 + 62*s - 10) + k1**2*k2**2*(-2*C*(38*r**2 + r*(50*s - 28) + 12*s**2 - 14*s + 3) + 2*K*(42*r**2 + 72*r*s - 41*r + 30*s**2 - 32*s + 10) + 30*r**2 + 34*r*s - 20*r + 4*s**2 - 6*s + 1) - k2**4*(4*K*s*(s - 1) + r**2*(12*K - 4) + 2*r*(K*(8*s - 3) - 2*s + 1) + s)) + 2*k2**2*(bd2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(k1**2*(45*r**2 + r*(77*s - 34) + 32*s**2 - 31*s - 1) + 7*k2**2*(3*r**2 + r*(4*s - 2) + s*(s - 1))))) + 44*fd*k2**2*(-b2*(13*k1**2 + 7*k2**2)*(r + s)**2 + 2*g2*(k1**2*(45*r**2 + 77*r*s + 2*r + 32*s**2 + 2*s - 1) + 7*k2**2*(3*r**2 + 4*r*s + s**2)))) + 2*Dd*f*(f**2*k2**2*(k1**2*(588*r**2 + r*(1872*s - 749) + 1284*s**2 - 1319*s + 255) - 33*k2**2*(48*r**2 + 8*r*(6*s - 5) - 8*s + 5)) - 33*f*(k1**4*(4*C*(24*r**2 + 2*r*(50*s - 27) + 76*s**2 - 65*s + 13) - 48*r**2 + r*(114 - 208*s) - 160*s**2 + 143*s - 31) + k1**2*k2**2*(-2*C*(76*r**2 + r*(100*s - 79) + 24*s**2 - 43*s + 18) + 2*K*(84*r**2 + 144*r*s - 93*r + 60*s**2 - 74*s + 22) + 60*r**2 + 68*r*s - 55*r + 8*s**2 - 19*s + 9) - k2**4*(8*K*s*(s - 1) + r**2*(24*K - 8) + 2*r*(K*(16*s - 7) - 4*s + 2) + s)) + 66*k2**2*(-b2*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(180*r**2 + r*(308*s - 111) + 128*s**2 - 102*s - 3) + 7*k2**2*(12*r**2 + r*(16*s - 7) + s*(4*s - 4)))))) - f*(13*D1*bd1*(f**2*k2**2*(2*k1**2*(147*r**2 + r*(468*s - 449) + 321*s**2 - 671*s + 234) - 33*k2**2*(24*r**2 + r*(24*s - 31) - 15*s + 5)) - 66*f*(k1**4*(4*C*(6*r**2 + 5*r*(5*s - 2) + 19*s**2 - 13*s + 4) - 12*r**2 + r*(21 - 52*s) - 40*s**2 + 29*s - 9) + k1**2*k2**2*(-2*C*(19*r**2 + 25*r*s - 29*r + 6*s**2 - 18*s + 10) + 2*K*(21*r**2 + 36*r*s - 26*r + 15*s**2 - 21*s + 6) + 15*r**2 + 17*r*s - 20*r + 2*s**2 - 9*s + 6) - k2**4*(2*K*s*(s - 1) + r**2*(6*K - 2) + r*(4*K - 1)*(2*s - 1))) - 132*k2**2*(b2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(k1**2*(45*r**2 + r*(77*s - 45) + 2*s*(16*s - 21)) + 7*k2**2*(3*r**2 + r*(4*s - 3) + s*(s - 2))))) + D1*(f**2*fd*k2**2*(2*k1**2*(6400*r**2 + 10*r*(1056*s - 1121) + 4160*s**2 - 10869*s + 5477) + 13*k2**2*(1260*r**2 + r*(5148*s - 3239) + 3888*s**2 - 4851*s + 1541)) - 26*f*(fd*k1**2*(k1**2*(4*C*(27*r**2 + 702*r*s - 384*r + 675*s**2 - 783*s + 233) - 54*r**2 - 1458*r*s + 852*r - 1404*s**2 + 1719*s - 533) - 33*k2**2*(2*C*(81*r**2 + 141*r*s - 97*r + 60*s**2 - 78*s + 27) - 96*r**2 - 165*r*s + 112*r - 69*s**2 + 88*s - 30)) + 66*k2**2*(bd2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(r + s - 1) - 2*gd2*(k1**2*(21*r**2 + 36*r*s - 26*r + 15*s**2 - 21*s + 6) + k2**2*(-3*r**2 - 4*r*s + 2*r - s**2 + s)))) - 1716*fd*k2**2*(b2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(2*r + 2*s - 1) - 2*g2*(k1**2*(42*r**2 + r*(72*s - 41) + 30*s**2 - 32*s + 10) + k2**2*(-6*r**2 + r*(3 - 8*s) - s*(2*s - 2))))) + Dd*f*(f**2*k2**2*(2*k1**2*(6400*r**2 + 10*r*(1056*s - 1121) + 4160*s**2 - 10869*s + 5477) + 13*k2**2*(1260*r**2 + r*(5148*s - 3239) + 3888*s**2 - 4851*s + 1541)) - 26*f*k1**2*(k1**2*(4*C*(36*r**2 + 936*r*s - 609*r + 900*s**2 - 1166*s + 391) - 72*r**2 - 1944*r*s + 1336*r - 1872*s**2 + 2545*s - 891) - 33*k2**2*(2*C*(108*r**2 + 188*r*s - 139*r + 80*s**2 - 111*s + 40) - 128*r**2 - 220*r*s + 162*r - 92*s**2 + 126*s - 45)) + 1716*k2**2*(-b2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(4*r + 4*s - 3) + 2*g2*(k1**2*(84*r**2 + 3*r*(48*s - 31) + 60*s**2 - 74*s + 22) + k2**2*(-12*r**2 + r*(7 - 16*s) - s*(4*s - 4)))))))/(9009*d**2*k3**6) + D1**3*Pk1*Pk3*(14*b1**3*k2**2*(D1*fd*(2*k1**2*(s - 1) + k2**2*(r + 2*s - 2))*(r + s - 1) + Dd*f*(4*k1**2*(r*(2*s - 3) + 2*(s - 1)**2) + k2**2*(4*r**2 + 3*r*(4*s - 3) + 8*s**2 - 13*s + 5))) + b1**2*k2**2*(14*D1*bd1*f*(2*k1**2*(r*(3*s - 5) + 3*(s - 1)**2) + 3*k2**2*(r**2 + r*(3*s - 2) + 2*s**2 - 3*s + 1)) - 2*D1*fd*(k1**2*(28*C*(s - 1)*(r + s - 1) - 28*K*r**2 - 75*K*r*s - 56*K*r - 44*K*s**2 - 44*K*s + 28*K + 3*f*r*(55*s - 41) + 4*f*(42*s**2 - 41*s + 7) + 14*r + 4*s**2 + 36*s - 14) + k2**2*(f*(r*(104*s - 63) + 104*s**2 - 115*s + 37) - 7*r**2*(4*K - 5) - 7*r*s*(10*K - 13) - 7*s**2*(2*K - 4))) + Dd*f*(k1**2*(-112*C*(2*s - 1)*(r + s - 1) + 2*K*(112*r**2 + 100*r*(3*s + 1) + 176*s**2 + 85*s - 156) + f*(r*(492 - 660*s) - 672*s**2 + 833*s - 289) + 56*r - 32*s**2 - 156*s + 72) - 2*k2**2*(52*f*(2*s - 1)*(2*r + 2*s - 1) - 7*r**2*(16*K - 20) - 7*r*(40*K*s - 20*K - 52*s + 31) - 14*s*(4*K*s - 3*K - 8*s + 4)))) - b1*(D1*(f**2*k2**2*(bd1*k1**2*(6*r*(55*s - 41) + 336*s**2 - 505*s + 233) + 2*bd1*k2**2*(r*(104*s - 41) + 104*s**2 - 93*s + 15) + fd*k1**2*(15*r*(47*s - 31) + 468*s**2 - 643*s + 207) + 2*fd*k2**2*(45*r**2 + r*(243*s - 148) + 198*s**2 - 235*s + 81)) - 2*f*(fd*(k1**4*(4*C - 2)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(K*(512*r**2 + r*(802*s - 512) + 312*s**2 - 433*s + 128) + r*(52*C*(2*s - 1) - 198*s + 39) + s*(60 - 108*s)) + k2**4*(r**2*(120*K - 78) + r*(4*K*(53*s - 15) - 170*s + 39) + 2*s*(K*(26*s - 15) - 24*s))) + k2**2*(bd1*(k1**2*(K*(56*r**2 + 2*r*(75*s + 4) + 88*s**2 + 21*s - 64) - 28*r*(2*C*s - 1) - 4*s**2*(14*C + 2) - 4*s*(7 - 14*C) + 4) + 14*k2**2*(r**2*(4*K - 5) + r*(2*K*(5*s - 3) - 13*s + 9) + s*(2*K*(s - 1) - 4*s + 2))) + 14*bd2*(2*k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(k1**2*(28*r**2 + r*(75*s + 36) + 44*s**2 + 20*s - 64) + 14*k2**2*(2*r**2 + r*(5*s - 4) + s*(s - 1))))) + 4*fd*k2**2*(-7*b2*(2*k1**2 + k2**2)*(r + s)**2 + g2*k1**2*(28*r**2 + r*(75*s + 56) + 44*s**2 + 44*s - 28) + 14*g2*k2**2*(2*r**2 + 5*r*s + s**2))) + Dd*f*(f**2*k2**2*(k1**2*(20*r*(47*s - 35) + 624*s**2 - 987*s + 395) + 2*k2**2*(60*r**2 + 9*r*(36*s - 23) + 264*s**2 - 323*s + 103)) - 2*f*(k1**4*(8*C - 4)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(K*(1024*r**2 + 4*r*(401*s - 320) + 624*s**2 - 1033*s + 416) + 2*r*(52*C*(2*s - 1) - 198*s + 87) - 216*s**2 + 216*s - 48) + k2**4*(r**2*(240*K - 156) + r*(212*K*(2*s - 1) - 340*s + 209) + 2*s*(K*(52*s - 41) - 48*s + 24))) + 4*k2**2*(-7*b2*(2*k1**2 + k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(112*r**2 + 100*r*(3*s + 1) + 176*s**2 + 85*s - 156) + 14*k2**2*(8*r**2 + 10*r*(2*s - 1) + s*(4*s - 3)))))) + f*(D1*(-f**2*k2**2*(bd1*k1**2*(s - 1)*(235*r + 156*s - 188) + 2*bd1*k2**2*(15*r**2 + 81*r*s - 59*r + 66*s**2 - 88*s + 22) - 80*fd*k1**2*(2*s**2 - 3*s + 1)) + 2*f*(bd1*(k1**4*s*(4*C - 2)*(s - 1) + k1**2*k2**2*(52*C*r*s + K*(256*r**2 + 401*r*s - 384*r + 156*s**2 - 300*s + 144) - 99*r*s + 48*r - 54*s**2 + 78*s - 24) + k2**4*(r**2*(60*K - 39) + r*(106*K*s - 76*K - 85*s + 85) + s*(26*K - 24)*(s - 1))) + fd*k1**2*(3*s - 1)*(k1**2*(4*C - 2)*(s - 1) + 11*k2**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2)) + 2*k2**2*(bd2*k1**2*(44*r**2 + r*(74*s - 68) + 30*s**2 - 54*s + 24) + bd2*k2**2*(15*r**2 + r*(28*s - 13) + s*(13*s - 13)) - gd2*k1**2*(256*r**2 + 401*r*s - 384*r + 156*s**2 - 300*s + 144) - 2*gd2*k2**2*(30*r**2 + r*(53*s - 38) + s*(13*s - 13)))) + 4*k2**2*(b2*(7*bd1*(2*k1**2 + k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(44*r**2 + r*(74*s - 44) + 30*s**2 - 38*s + 11) + k2**2*(30*r**2 + r*(56*s - 15) + s*(26*s - 15)))) - g2*(bd1*k1**2*(28*r**2 + 75*r*s - 28*r + 44*s**2 + s) + 14*bd1*k2**2*(2*r**2 + r*(5*s - 2) + s*(s - 1)) + fd*k1**2*(512*r**2 + r*(802*s - 512) + 312*s**2 - 433*s + 128) + 2*fd*k2**2*(60*r**2 + 2*r*(53*s - 15) + s*(26*s - 15))))) + 4*Dd*f*(20*f**2*k1**2*k2**2*(2*s**2 - 3*s + 1) + f*k1**2*(2*s - 1)*(k1**2*(4*C - 2)*(s - 1) + 11*k2**2*(4*C*(2*r + s - 1) - 5*r - 2*s + 2)) + k2**2*(2*b2*k1**2*(88*r**2 + 4*r*(37*s - 28) + 60*s**2 - 92*s + 35) + b2*k2**2*(60*r**2 + r*(112*s - 41) + s*(52*s - 41)) - g2*k1**2*(1024*r**2 + 4*r*(401*s - 320) + 624*s**2 - 1033*s + 416) - 2*g2*k2**2*(120*r**2 + 106*r*(2*s - 1) + s*(52*s - 41))))))/(21*d**2*k2**2*k3**4) - 4*D1**3*Pk1*Pk3*st**4*(D1*(3432*b1*fd*k1**2*k2**2*(b1**2*k2**2*(r + s - 1)**2 + b1*(-k1**2*(2*C - 1)*(r + s - 1)**2 + k2**2*(r + s)*(K*s + r*(3*K - 1))) + k2**2*(r + s)*(b2*(r + s) - 2*g2*(3*r + s))) - f**3*k2**4*(26*bd1*k1**2*(r*(81*s - 52) + 81*s**2 - 191*s + 68) + 143*bd1*k2**2*(r - 1)*(5*r + 5*s - 3) - 4*fd*k1**2*(1284*r**2 + 2*r*(5*s - 226) - 1274*s**2 + 1538*s - 419) + 39*fd*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 39*f**2*(44*bd1*k1**2*(k1**4*s*(4*C - 2)*(r + s) + k1**2*k2**2*(r**2*(9 - 16*C) + r*(-16*C*(s - 1) + 10*s - 9) + s*(8*C + s - 6)) + k2**4*(-4*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + b1*(10*r**2 + r*(22*s - 17) + 12*s**2 - 19*s + 7) + 16*r**2 + 20*r*s - 21*r + 4*s**2 - 12*s + 5)) + fd*(-2*b1*k1**2*k2**4*(9*r*(9*s - 2) + 81*s**2 - 149*s + 52) - 11*b1*k2**6*r*(5*r + 5*s - 3) + k1**6*(32*C - 16)*(3*s - 1)*(3*r + 3*s - 2) - 4*k1**4*k2**2*(2*C*(105*r**2 + r*(177*s - 140) + 72*s**2 - 107*s + 43) - 123*r**2 + r*(164 - 213*s) - 90*s**2 + 131*s - 51))) + 1716*f*k1**2*(b1**2*k2**4*(2*bd1*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(10*r**2 + 2*r*(11*s - 7) + 12*s**2 - 15*s + 5)) + b1*(bd1*(k1**2*k2**2*(2 - 4*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**4*(K*s*(4*s - 6) + r**2*(12*K - 4) + r*(2*K*(8*s - 5) - 4*s + 3) + s)) + fd*(k1**4*(4*C - 2)*(r + s)*(2*s - 1) + k1**2*k2**2*(-4*C*(8*r**2 + r*(8*s - 1) + 2*s - 1) + 18*r**2 + r*(20*s - 2) + 2*s**2 + 3*s - 2) - 2*k2**4*(2*r + 2*s - 1)*(2*C*(6*r + 2*s - 1) - 8*r - 2*s + 1)) + 2*k2**4*(bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(3*r**2 + r*(4*s - 2) + s*(s - 1)))) + 2*bd1*k2**4*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(3*r**2 + r*(4*s - 3) + s*(s - 2))))) + Dd*f*(1716*b1*f*k1**2*(k1**4*(8*C - 4)*(r + s)*(2*s - 1) + k1**2*k2**2*(-4*C*(16*r**2 + 2*r*(8*s - 3) + s - 2) + 36*r**2 + r*(40*s - 13) + 4*s**2 - 2*s - 4) + k2**4*(-8*C*(12*r**2 + 16*r*s - 11*r + 4*s**2 - 6*s + 2) + b1*(20*r**2 + r*(44*s - 31) + 24*s**2 - 34*s + 12) + 64*r**2 + 80*r*s - 56*r + 16*s**2 - 26*s + 9)) + 1716*b1*k1**2*k2**2*(2*b1**2*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + b1*(k1**2*(2 - 4*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(8*K*s*(s - 1) + r**2*(24*K - 8) + 2*r*(K*(16*s - 7) - 4*s + 2) + s)) + 2*k2**2*(b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 2*g2*(12*r**2 + r*(16*s - 7) + s*(4*s - 4)))) + f**3*k2**4*(4*k1**2*(1284*r**2 + 2*r*(5*s - 226) - 1274*s**2 + 1538*s - 419) - 39*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 13*f**2*(-4*b1*k1**2*k2**4*(r*(162*s - 53) + 162*s**2 - 319*s + 112) - 11*b1*k2**6*(4*r - 1)*(5*r + 5*s - 3) + k1**6*(48*C - 24)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 12*k1**4*k2**2*(2*C*(140*r**2 + r*(236*s - 191) + 96*s**2 - 147*s + 59) - 164*r**2 + r*(225 - 284*s) - 120*s**2 + 181*s - 71))))/(3003*d**2*k1**2*k3**6) + D1**3*Pk1*Pk3*st**2*(-4*D1*bd1*f**2*(4*C*k1**2*s*(2*s - 1) + 2*C*k2**2*r*(1 - 3*r) + 2*k1**2*s*(1 - 2*s) + k2**2*r*(3*r + 2*s)) - 7*b1**3*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(s - 1)*(7*bd1*f*k2**2*(1 - 3*r) + fd*k1**2*(112*C - 56)*(s - 1) + 3*fd*k2**2*(f*(2*r - 1) + 12*r)) + Dd*f*(k1**2*(224*C - 112)*(2*s**2 - 3*s + 1) + k2**2*(3*f*(4*r - 1)*(s - 1) + 16*r*(9*s - 5) - 4*s + 4))) - 2*b1*f*(D1*(-56*bd1*k1**2*s*(2*C - 1)*(s - 1) + bd1*k2**2*(r*(-3*f*(s - 1) - 36*s + 4) + 2*s - 2) + fd*k1**2*(1 - 2*s)**2*(8*C - 4) + 2*fd*k2**2*(-2*C*(6*r**2 - 5*r + 1) + 6*r**2 + r*(4*s - 2) - 3*s)) + 2*Dd*f*(k1**2*(1 - 2*s)**2*(8*C - 4) - k2**2*(2*C*(12*r**2 - 7*r + 1) - 12*r**2 - 8*r*s + r + 3*s))))/(21*d**2*k1**2*k2**2) + D1**3*Pk1*Pk3*(2*D1*bd1*f*(12*b2*k2**2*r*(r - 1) + f*s*(-k1**2*(4*C - 2)*(s - 1) + 13*k2**2*r) - 24*g2*k2**2*r*(r - 1)) - 7*b1**3*k2**2*(3*D1*fd*r*(s - 1) + Dd*f*(4*r*(3*s - 5) - 7*s + 7)) + b1**2*(-7*D1*bd1*f*k2**2*(r*(9*s - 17) - 7*s + 7) + D1*fd*(k1**2*(56*C - 28)*(s - 1)**2 + k2**2*(24*K*(r - 1)**2 + 5*f*(6*r*(3*s - 1) - 13*s + 5) + 2*r*(5*s - 7) + 4*s)) + Dd*f*k1**2*(112*C - 56)*(2*s**2 - 3*s + 1) + Dd*f*k2**2*(24*K*(4*r**2 - 5*r + 1) + 5*f*(12*r*(3*s - 1) - 29*s + 13) + 40*r*s - 108*r - 116*s + 80)) - 2*b1*(D1*(-5*bd1*f**2*k2**2*(r*(9*s - 3) - 8*s + 4) + f*(-28*bd1*k1**2*s*(2*C - 1)*(s - 1) + 2*bd1*k2**2*(-12*K*r**2 + r*(12*K - 5*s + 10) + 20*s - 10) + fd*(2*s - 1)*(k1**2*(4*C - 2)*(s - 1) - 13*k2**2*r) + 2*k2**2*r*(-6*bd2 + 12*gd2)*(r - 1)) - 12*fd*k2**2*(b2 - 2*g2)*(r - 1)**2) + 2*Dd*f*(f*(2*s - 1)*(k1**2*(4*C - 2)*(s - 1) - 13*k2**2*r) + k2**2*(-6*b2 + 12*g2)*(4*r**2 - 5*r + 1))))/(21*d**2*k1**2*k2**2) + 4*D1**3*Pk1*Pk3*st**4*(-33*b1**2*(-2*D1*fd*(k1**4*(8*C - 4)*(s - 1)**2 - k1**2*k2**2*r*(8*C - 6)*(s - 1) + k2**4*r*(f*(2 - 3*s) + r*(2*C - 2))) + Dd*f*(k1**4*(16 - 32*C)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(8*C - 6)*(r*(8*s - 6) - s + 1) + k2**4*(4*r - 1)*(f*(3*s - 2) + r*(4 - 4*C)))) - 33*b1*f*(D1*bd1*(k1**4*s*(16 - 32*C)*(s - 1) + k1**2*k2**2*(8*C - 6)*(r*(4*s - 2) - s + 1) + k2**4*(2*r - 1)*(f*(3*s - 2) + r*(4 - 4*C))) + k2**2*(2*D1*fd*(k1**2*(2*C*(-8*s**2 + s*(r + 8) - 2) + 6*s**2 - s*(r + 7) + 2) + 2*k2**2*r*(1 - 2*s)) + Dd*f*(k1**2*(C*(8*r*s - 64*s**2 + 70*s - 20) - 4*r*s + 24*s**2 - 31*s + 10) + 8*k2**2*r*(1 - 2*s)))) + f**2*(D1*(33*bd1*k2**2*(k1**2*(-2*C*(r*(s + 2) - 8*s**2 + 7*s - 2) + r*(s + 2) - 6*s**2 + 7*s - 2) + 4*k2**2*r*s) + fd*(k1**4*(1 - 3*s)**2*(16*C - 8) + 4*k1**2*k2**2*(3*s - 1)*(8*C*(3*r - 1) - 9*r + 6*s + 1) + k2**4*(3*r - 1)*(16*C*(3*r - 1) + 24*r - 9*s - 16))) + Dd*f*(k1**4*(32*C - 16)*(6*s**2 - 5*s + 1) + 2*k1**2*k2**2*(8*C*(2*r*(12*s - 5) - 7*s + 3) + r*(30 - 72*s) + 48*s**2 - 19*s - 1) + k2**4*(16*C*(12*r**2 - 7*r + 1) + 96*r**2 - 12*r*(3*s + 8) + 5*s + 20))))/(231*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*st**2*(-33*D1*b1*bd1*f*(3*f*k1**2*k2**2*(s - 1) + 2*f*k2**4*(24*r**2 + r*(36*s - 53) - 36*s + 24) + k1**4*s*(224*C - 112)*(s - 1) + 2*k1**2*k2**2*s*(-8*C*(14*r - s + 1) + K*(7 - 14*r) + 84*r - 8*s + 8) + 4*k2**4*(r**2*(28*C + 2*K - 38) + r*(-14*C - 2*K + 10*s + 21) - 6*s)) + 231*b1**3*k1**2*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) - 33*b1**2*(D1*(7*bd1*f*k1**2*k2**2*(-3*r*(s - 1) + s - 1) + fd*(k1**4*(112*C - 56)*(s - 1)**2 + k1**2*k2**2*(-8*C*(s - 1)*(14*r - s + 1) - 3*f*(s - 1) - 14*r*(s*(K - 6) + 6) - 8*(s - 1)**2) + 2*k2**4*(2*K*(r - 1)**2 + f*(24*r**2 + r*(36*s - 11) - 2) + 2*r**2*(14*C - 19) + 2*r*(5*s + 2) - 2))) + 2*Dd*f*(k1**4*(112*C - 56)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(-8*C*(2*s - 1)*(14*r - s + 1) + 7*K*s - 28*r*(s*(K - 6) + 3) - 16*s**2 + 24*s - 8) + 2*k2**4*(56*C*r**2 - 14*C*r + 4*K*r**2 - 5*K*r + K + f*(24*r**2 + 4*r*(9*s - 8) - 18*s + 11) - 76*r**2 + 20*r*s + 25*r - 6*s - 1))) + 3*b1*k2**2*(D1*(f**2*fd*(55*k1**2*(3*r - 1)*(s - 1) + 2*k2**2*(540*r**2 + 3*r*(396*s - 373) - 330*s + 280)) + 22*f*(7*bd2*k1**2*r*s + fd*k1**2*(4*C*(4*r*(11*s - 3) + 70*s**2 - 61*s + 10) + 3*K*s + r*(-6*K*s - 88*s + 24) - 196*s**2 + 146*s - 22) + 2*fd*k2**2*(K*(6*r**2 - 5*r + 1) + r**2*(4*C + 7) - r*(2*C + 6*s + 13) + 2*s + 4) + 2*gd2*r*(-7*k1**2*s + 2*k2**2*(r - 1))) + 22*fd*(7*b2*k1**2*r*s + 2*g2*(-7*k1**2*r*s + 2*k2**2*(r - 1)**2))) + Dd*f*(f**2*(55*k1**2*(4*r - 1)*(s - 1) + 4*k2**2*(360*r**2 + r*(792*s - 716) - 231*s + 173)) + 22*f*(k1**2*(4*C*(r*(88*s - 38) + 140*s**2 - 139*s + 33) + 3*K*s - 4*r*(3*K*s + 44*s - 19) - 392*s**2 + 342*s - 70) + k2**2*(2*K*(12*r**2 - 7*r + 1) + r**2*(16*C + 28) - r*(4*C + 24*s + 35) + 4*s + 8)) + (88*r - 22)*(7*b2*k1**2*s - 14*g2*k1**2*s + 4*g2*k2**2*(r - 1)))) - f*(D1*(-3*bd1*f**2*k2**2*(55*k1**2*r*(s - 1) + 2*k2**2*(180*r**2 + r*(396*s - 313) - 132*s + 66)) + 2*f*(fd*(k1**4*(1 - 3*s)**2*(264*C - 132) + 2*k1**2*k2**2*(2*C*(486*r**2 + 1485*r*s - 852*r - 594*s + 263) - 486*r**2 - 1296*r*s + 789*r + 297*s**2 + 201*s - 165) + 99*k2**4*r*(3*r - 6*s + 1)) - 33*k2**2*(bd1*(k1**2*(4*C*(r*(22*s - 6) + 35*s**2 - 26*s + 6) + r*(-3*K*s - 44*s + 12) - 98*s**2 + 62*s - 12) + k2**2*r*(K*(6*r - 2) + r*(4*C + 7) - 6*s - 3)) + r*(bd2 - 2*gd2)*(-3*k1**2*s + k2**2*(6*r - 2)))) - 66*k2**2*(b2*(7*bd1*k1**2*s*(r - 1) + fd*(2*r - 1)*(-3*k1**2*s + k2**2*(6*r - 2))) + 2*bd1*g2*(r - 1)*(-7*k1**2*s + 2*k2**2*r) - 2*fd*g2*(2*r - 1)*(-3*k1**2*s + k2**2*(6*r - 2)))) + 2*Dd*f*(f*(k1**4*(528*C - 264)*(6*s**2 - 5*s + 1) + 2*k1**2*k2**2*(2*C*(648*r**2 + 4*r*(495*s - 353) - 792*s + 461) - 648*r**2 - 1728*r*s + 1318*r + 396*s**2 + 218*s - 281) + 99*k2**4*r*(4*r - 8*s + 3)) + k2**2*(-33*b2 + 66*g2)*(4*r - 1)*(-3*k1**2*s + k2**2*(6*r - 2)))))/(693*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*(-7*b1**3*k1**2*k2**2*(s - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(D1*(7*bd1*f*k1**2*k2**2*(-3*r*(s - 1) + s - 1) + fd*(k1**4*(28 - 56*C)*(s - 1)**2 + k1**2*k2**2*(f*(224*s**2 - 151*s + 31) + 2*r*(28*C*(s - 1) + 5*K*s - 21*s + 21) + 4*s*(2*K*(s - 3) + 5*s + 3)) + 14*k2**4*r*(-3*r + s))) + 2*Dd*f*(-k1**4*(56*C - 28)*(2*s**2 - 3*s + 1) + k1**2*k2**2*(K*(4*r*(5*s - 24) + 16*s**2 - 157*s + 96) + 8*f*(28*s**2 - 16*s + 1) + (4*s - 2)*(r*(28*C - 21) + 10*s + 24)) + 7*k2**4*r*(-12*r + 4*s + 1))) + b1*(D1*bd1*f*(k1**4*s*(56 - 112*C)*(s - 1) + k1**2*k2**2*(2*K*(2*r*(5*s - 24) + 8*s**2 - 93*s + 48) + f*(224*s**2 - 105*s - 15) + 40*s**2 + s*(28*r*(4*C - 3) + 112) - 48) + 28*k2**4*r*(-3*r + s + 1)) - k2**2*(D1*(f**2*fd*k1**2*(-5*r*(69*s - 37) - 432*s**2 + 611*s - 211) + 2*f*(7*bd2*k1**2*r*s + fd*(K*k1**2*(160*r**2 + 10*r*(21*s - 16) + 56*s**2 - 129*s + 40) - 2*k1**2*(r*(52*C*s - 26*C + 2*s + 13) + 2*s*(15*s - 7)) + k2**2*r*(18*r - 26*s - 9)) + 2*gd2*k1**2*(5*r*s - 48*r + 4*s**2 - 52*s + 48)) + 2*fd*k1**2*s*(7*b2*r + 10*g2*r + 8*g2*(s - 3))) + Dd*f*(f**2*k1**2*(r*(300 - 460*s) - 576*s**2 + 835*s - 291) + 2*f*(k1**2*(K*(320*r**2 + 12*r*(35*s - 32) + 112*s**2 - 281*s + 136) - 4*r*(52*C*s - 26*C + 2*s - 3) - 120*s**2 + 120*s - 32) + k2**2*r*(36*r - 52*s + 17)) + 2*k1**2*(7*b2*s*(4*r - 1) + 2*g2*(20*r*s - 96*r + 16*s**2 - 157*s + 96))))) + f*(D1*(bd1*f**2*k1**2*k2**2*(s - 1)*(115*r + 144*s - 80) - 2*f*(fd*k1**2*(3*s - 1)*(k1**2*(4*C - 2)*(s - 1) - 11*k2**2*r) + k2**2*(bd1*(k1**2*(K*(80*r**2 + 7*r*(15*s - 16) + 28*s**2 - 76*s + 48) - 2*r*(26*C*s + s - 16) - 30*s**2 + 46*s - 16) + k2**2*r*(9*r - 13*s + 13)) + k1**2*(bd2 - 2*gd2)*(80*r**2 + 7*r*(15*s - 16) + 28*s**2 - 76*s + 48))) - 2*k1**2*k2**2*(b2*(7*bd1*s*(r - 1) + fd*(160*r**2 + 210*r*s - 160*r + 56*s**2 - 129*s + 40)) - 2*g2*(bd1*s*(-5*r - 4*s + 41) + fd*(160*r**2 + 210*r*s - 160*r + 56*s**2 - 129*s + 40)))) - 2*Dd*f*k1**2*(2*f*(2*s - 1)*(k1**2*(4*C - 2)*(s - 1) - 11*k2**2*r) + k2**2*(b2 - 2*g2)*(320*r**2 + 12*r*(35*s - 32) + 112*s**2 - 281*s + 136))))/(21*d**2*k1**2*k2**2*k3**2) + D1**3*Pk1*Pk3*st**4*(D1*(3432*b1*fd*k2**2*(b1*(k1**4*(8*C - 4)*(s - 1)*(r + s - 1) - k1**2*k2**2*r*(8*C - 6)*(r + s - 1) + k2**4*r*(r*(K - 3) - 2*s)) - 2*g2*k2**4*r**2) + f**3*k2**4*(-13*bd1*k2**2*(576*r**2 + r*(769*s - 807) - 449*s + 263) + fd*(130*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(8832*r**2 + 4*r*(2925*s - 3431) - 3445*s + 3139))) - 13*f**2*(66*bd1*k2**2*(2*k1**4*(-2*C*(r*(9*s + 2) + 7*s - 2) + r*(9*s + 2) + 2*s**2 + 7*s - 2) + k1**2*k2**2*(-b1*(2*r - 1)*(9*s - 5) + 4*r**2*(8*C - 6) + 4*r*(-2*C*(5*s + 4) + 4*s + 6) + 4*s*(C*(2 - 8*s) + 3*s + 2)) + 4*k2**4*(r**2*(4*C - 8) + r*(-4*C - 4*s + 9) + 2*s - 1)) + fd*(3*b1*k2**6*(576*r**2 + r*(769*s - 615) - 128*s + 96) + k1**6*(1 - 3*s)**2*(64*C - 32) - 48*k1**4*k2**2*(3*s - 1)*(4*C*(4*r + 5*s - 3) - 9*r - 12*s + 7) + 12*k1**2*k2**4*(4*C*(9*r**2 + r*(30*s - 38) + 3*(s - 2)**2) - 36*r**2 + r*(116 - 177*s) - 48*s**2 + 91*s - 40))) + 1716*f*k2**2*(b1**2*fd*k1**2*k2**2*r*(9*s - 5) + 2*b1*(bd1*(k1**4*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - k1**2*k2**2*(4*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + k2**4*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) + fd*(k1**4*(2*C*(9*r*s - 4*r + 4*s - 2) - 9*r*s + 4*r - 2*s**2 - 3*s + 2) + k1**2*k2**2*(-4*C*(4*r**2 - 5*r*s + 3*r - 4*s**2 + 4*s - 1) + 12*r**2 - 8*r*s + 8*r - 6*s**2 + 7*s - 2) + 4*k2**4*r*(-r*(2*C - 4) + 2*s - 1)) - 2*gd2*k2**4*r**2) - 4*bd1*g2*k2**4*r*(r - 1))) + Dd*f*(858*b1*f*k2**2*(2*k1**4*(C*(8*r*(9*s - 4) + 38*s - 20) - 36*r*s + 16*r - 8*s**2 - 15*s + 10) + k1**2*k2**2*(-8*C*(16*r**2 - 20*r*s + 8*r - 16*s**2 + 15*s - 4) + b1*(4*r - 1)*(9*s - 5) + 96*r**2 - 64*r*s + 40*r - 48*s**2 + 40*s - 16) + 4*k2**4*(-r**2*(16*C - 32) + 4*r*(C + 4*s - 4) - 2*s + 1)) + 3432*b1*k2**2*(b1*(k1**4*(4*C - 2)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) - k1**2*k2**2*(4*C - 3)*(8*r**2 + 8*r*(s - 1) - s + 1) + k2**4*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s)) + 2*g2*k2**4*r*(1 - 4*r)) + f**3*k2**4*(130*k1**2*(4*r - 1)*(9*s - 7) + k2**2*(8832*r**2 + 4*r*(2925*s - 3431) - 3445*s + 3139)) - 13*f**2*(b1*k2**6*(2304*r**2 + 4*r*(769*s - 663) - 833*s + 551) + k1**6*(128*C - 64)*(6*s**2 - 5*s + 1) - 8*k1**4*k2**2*(32*C*(12*r*s - 5*r + 15*s**2 - 16*s + 4) - 216*r*s + 90*r - 288*s**2 + 303*s - 75) + 4*k1**2*k2**4*(4*C*(36*r**2 + r*(120*s - 137) + 12*s**2 - 34*s + 31) - 144*r**2 - 12*r*(59*s - 38) - 192*s**2 + 339*s - 138))))/(3003*d**2*k1**2*k2**2*k3**4) + D1**3*Pk1*Pk3*st**2*(-12012*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + 2*s - 2) + 429*b1**2*k2**2*(2*D1*(-14*bd1*f*k1**2*k2**2*(3*r**2 + r*(9*s - 8) + 6*s**2 - 10*s + 4) + fd*(k1**4*(8*C*(2*r**2 - 3*r*(s - 1) - 5*(s - 1)**2) - 8*r**2 + r*(-7*K*s - 3*f*s + 3*f + 8*s - 8) + 16*(s - 1)**2) + k1**2*k2**2*(-2*K*(25*r**2 + r*(49*s + 8) + 15*s**2 + 4*s - 4) + 116*f*r**2 + f*r*(326*s - 207) + 6*f*(44*s**2 - 57*s + 20) + r**2*(112*C - 46) + 2*r*(56*C*(s - 1) + 46) + 28*s**2 + 4*s - 4) + 2*k2**4*r*(6*f*(3*r + 3*s - 2) + r*(21 - 7*K) + 14*s))) + Dd*f*(k1**4*(64*C*(2*r**2 - 3*r*s - 5*s**2 + 7*s - 2) + 14*K*s - 3*f*(4*r - 1)*(s - 1) - 64*r**2 - 8*r*(7*K*s - 8*s - 3) + 128*s**2 - 172*s + 44) + 4*k1**2*k2**2*(28*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 100*K*r**2 - 196*K*r*s + 37*K*r - 60*K*s**2 + 57*K*s + 8*K + 2*f*(58*r**2 + 163*r*s - 104*r + 132*s**2 - 176*s + 57) - 92*r**2 + 143*r + 56*s**2 - 38*s - 25) + 4*k2**4*(3*f*(4*r - 1)*(3*r + 3*s - 2) - 7*r**2*(4*K - 12) + 7*r*(K + 8*s - 5) - 7*s))) - 13*b1*(3*D1*(-f**2*k2**2*(-33*bd1*k1**4*(2*r - 1)*(s - 1) + 22*bd1*k1**2*k2**2*(116*r**2 + r*(326*s - 209) + 264*s**2 - 362*s + 108) + 132*bd1*k2**4*(2*r - 1)*(3*r + 3*s - 2) - 55*fd*k1**4*(3*r - 1)*(s - 1) - 2*fd*k1**2*k2**2*(1290*r**2 + 3*r*(82*s - 237) - 1188*s**2 + 809*s - 23) + 44*fd*k2**4*(3*r - 1)*(3*r + 3*s - 2)) - 22*f*(fd*(k1**6*(1 - 2*s)**2*(8*C - 4) + k1**4*k2**2*(-4*C*(30*r**2 + r*(196*s - 73) + 186*s**2 - 127*s + 13) - 3*K*s + 60*r**2 + 2*r*(3*K*s + 208*s - 76) + 436*s**2 - 296*s + 30) - 2*k1**2*k2**4*(2*C*(18*r**2 + r*(32*s - 23) + 12*s**2 - 14*s + 5) + K*(-14*r**2 + 6*r*s - 5*r + 2*s**2 - 7*s + 6) - 25*r**2 - 66*r*s + 31*r - 22*s**2 + 31*s - 7) + 2*k2**6*(r**2*(2*K - 6) - r*(K + 4*s - 3) + s)) + k2**2*(bd1*(k1**4*(16*C*(2*r**2 - 3*r*(s + 1) - 5*s**2 + 4*s + 1) + 7*K*s - 16*r**2 + r*(-14*K*s + 16*s + 28) + 32*s**2 - 22*s - 10) + 2*k1**2*k2**2*(28*C*(4*r**2 + 4*r*(s - 1) - s + 1) + K*(-50*r**2 - 98*r*s + 35*r - 30*s**2 + 48*s + 2) - 46*r**2 + 60*r + 28*s**2 - 27*s - 22) - 14*k2**4*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) - 28*bd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(7*k1**4*r*s + 2*k1**2*k2**2*(25*r**2 + r*(49*s - 10) + 15*s**2 - 13*s - 2) + 14*k2**4*r**2))) - 44*fd*k2**2*(-14*b2*k1**2*k2**2*(r + s)**2 + g2*(7*k1**4*r*s + 2*k1**2*k2**2*(25*r**2 + 49*r*s + 8*r + 15*s**2 + 4*s - 4) + 14*k2**4*r**2))) + Dd*f*(f**2*k2**2*(165*k1**4*(4*r - 1)*(s - 1) + 4*k1**2*k2**2*(2580*r**2 + r*(492*s - 2095) - 2376*s**2 + 1358*s + 216) - 132*k2**4*(4*r - 1)*(3*r + 3*s - 2)) - 66*f*(k1**6*(1 - 2*s)**2*(16*C - 8) + k1**4*k2**2*(-4*C*(60*r**2 + r*(392*s - 177) + 372*s**2 - 295*s + 46) - 3*K*s + 120*r**2 + 2*r*(6*K*s + 416*s - 183) + 872*s**2 - 688*s + 106) + k1**2*k2**4*(-4*C*(36*r**2 + r*(64*s - 47) + 24*s**2 - 29*s + 10) + 2*K*(28*r**2 - 12*r*s + r - 4*s**2 + 5*s - 2) + 100*r**2 + 264*r*s - 157*r + 88*s**2 - 136*s + 46) + 2*k2**6*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s)) + 132*k2**2*(14*b2*k1**2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(7*k1**4*s*(1 - 4*r) - 2*k1**2*k2**2*(100*r**2 + 196*r*s - 37*r + 60*s**2 - 57*s - 8) + 14*k2**4*r*(1 - 4*r))))) + f*(D1*(f**2*k2**2*(-13*bd1*(165*k1**4*r*(s - 1) + 2*k1**2*k2**2*(1290*r**2 + 246*r*s - 2057*r - 1188*s**2 + 289*s + 501) - 132*k2**4*r*(3*r + 3*s - 2)) + 4*fd*k1**2*k2**2*(13020*r**2 + 10*r*(5499*s - 3706) + 30888*s**2 - 46917*s + 17314)) + 26*f*(33*bd1*(k1**6*s*(8*C - 4)*(2*s - 1) + k1**4*k2**2*(-4*C*(15*r**2 + r*(98*s - 23) + 93*s**2 - 52*s + 10) + 30*r**2 + r*(3*K*s + 208*s - 48) + 218*s**2 - 122*s + 24) - k1**2*k2**4*(4*C*(9*r**2 + r*(16*s - 9) + 6*s**2 - 6*s + 2) + 2*K*(-7*r**2 + 3*r*s + 2*r + s**2 + s - 2) - 25*r**2 - 66*r*s + 43*r - 22*s**2 + 36*s - 16) + 2*k2**6*r*(r*(K - 3) - 2*s + 1)) + 132*bd2*k1**2*k2**4*(3*r**2 + r*(3*s - 4) - 2*s + 2) + fd*k1**2*(k1**4*(1 - 3*s)**2*(264*C - 132) + 2*k1**2*k2**2*(2*C*(702*r**2 - 9*r*(75*s + 16) - 1809*s**2 + 1398*s - 220) - 702*r**2 + 972*r*s - 87*r + 2187*s**2 - 2013*s + 427) + 33*k2**4*(4*C*(21*r**2 + 54*r*s - 28*r + 18*s**2 - 18*s + 5) - 87*r**2 - 192*r*s + 103*r - 54*s**2 + 56*s - 16)) + 66*gd2*k2**2*(-3*k1**4*r*s + 2*k1**2*k2**2*(-7*r**2 + r*(3*s + 2) + s**2 + s - 2) - 2*k2**4*r**2)) - 1716*k2**2*(-2*b2*k1**2*k2**2*(-7*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(6*r**2 + r*(6*s - 1) - 2*s - 1)) + g2*(bd1*(-7*k1**4*s*(r - 1) - 2*k1**2*k2**2*(25*r**2 + r*(49*s - 25) + 5*s*(3*s - 7)) - 14*k2**4*r*(r - 1)) + fd*(3*k1**4*s*(2*r - 1) + 2*k1**2*k2**2*(14*r**2 - 6*r*s + 5*r - 2*s**2 + 7*s - 6) + 2*k2**4*r*(2*r - 1))))) + 2*Dd*f*(2*f**2*k1**2*k2**4*(13020*r**2 + 10*r*(5499*s - 3706) + 30888*s**2 - 46917*s + 17314) + 13*f*k1**2*(k1**4*(528*C - 264)*(6*s**2 - 5*s + 1) + 2*k1**2*k2**2*(2*C*(936*r**2 - 4*r*(225*s + 29) - 2412*s**2 + 2190*s - 409) - 936*r**2 + 1296*r*s - 214*r + 2916*s**2 - 3072*s + 757) + 33*k2**4*(4*C*(28*r**2 + 9*r*(8*s - 5) + 24*s**2 - 27*s + 8) - 116*r**2 - 256*r*s + 165*r - 72*s**2 + 84*s - 26)) + 858*k2**2*(6*b2*k1**2*k2**2*(4*r**2 + r*(4*s - 3) - 2*s + 1) + g2*(3*k1**4*s*(1 - 4*r) - 2*k1**2*k2**2*(28*r**2 - 12*r*s + r - 4*s**2 + 5*s - 2) + 2*k2**4*r*(1 - 4*r))))))/(9009*d**2*k1**2*k2**2*k3**4) - 8*D1**3*Pk1*Pkd3*b1*ct*k2*st**4*(D1*bd1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + b1*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(8*r*s - 6*r + 8*s**2 - 13*s + 5)))/(7*d**2*k1*k3) + 4*D1**3*Pk1*Pkd3*b1*st**4*(D1*bd1*f*(k1**2*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k2**2*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(2*D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*r)*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(8*r**2 + 8*r*(s - 1) - s + 1))))/(7*d**2*k1**2*k3) + D1**3*Pk1*Pkd3*ct**8*f*k2**6*(40*C - 40)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(51*r + 51*s - 23))/(77*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**8*f*k2**4*(80*C - 80)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) + Dd*f*(r*(408*s - 214) + 408*s**2 - 459*s + 130)))/(693*d**2*k3**5) + 2*D1**3*Pk1*Pkd3*ct**7*f*k2**5*(13*D1*bd1*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(r + s - 1) + 13*b1*(D1*fd*(5*f*k2**2*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + 66*k1**2*(2*r + 2*s - 1)*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43)) + Dd*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(4*r + 4*s - 3)) + 10*f*(D1*fd*(21*f*k2**2*(136*r**2 + 2*r*(136*s - 89) + 136*s**2 - 178*s + 57) + 13*k1**2*(3*r + 3*s - 2)*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187)) + Dd*f*(21*f*k2**2*(34*r + 34*s - 19) + 13*k1**2*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187))*(4*r + 4*s - 3)))/(1001*d**2*k1*k3**7) + 40*D1**3*Pk1*Pkd3*ct**7*f*k2**3*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(D1*fd*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) + Dd*f*(r*(408*s - 214) + 408*s**2 - 459*s + 130)))/(693*d**2*k1*k3**3) + 4*D1**3*Pk1*Pkd3*ct**7*f*k2**3*(33*D1*bd1*f*(2*k1**2*(2*C*(76*r*s - 25*r + 76*s**2 - 88*s + 25) - 132*r*s + 45*r - 132*s**2 + 156*s - 45) - k2**2*(r + s - 1)*(r*(48*C - 98) - 50*s + 25)) + 33*b1*(D1*fd*(4*k1**2*(2*C*(76*r*s - 41*r + 76*s**2 - 82*s + 22) - 132*r*s + 72*r - 132*s**2 + 144*s - 39) - k2**2*(2*r + 2*s - 1)*(r*(48*C - 98) - 50*s + 25)) + Dd*f*(2*k1**2*(C*(8*r*(76*s - 41) + 608*s**2 - 744*s + 226) - 48*r*(11*s - 6) - 528*s**2 + 654*s - 201) - k2**2*(4*r + 4*s - 3)*(r*(48*C - 98) - 50*s + 25))) + f*(D1*fd*(10*k1**2*(4*C*(9*r*(63*s - 32) + 567*s**2 - 633*s + 181) - 3*r*(654*s - 339) - 1962*s**2 + 2226*s - 645) - k2**2*(3*r + 3*s - 2)*(2*C*(531*r + 263) - 2337*r - 1275*s + 49)) + Dd*f*(10*k1**2*(4*C*(756*r*s - 436*r + 756*s**2 - 933*s + 292) - 2616*r*s + 1530*r - 2616*s**2 + 3273*s - 1038) + k2**2*(-2*C*(2124*r**2 + 2124*r*s - 507*r + 1069*s - 806) + 9348*r**2 + 14448*r*s - 7139*r + 5100*s**2 - 3987*s + 113))))/(693*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**6*f*k2**6*st**2*(60*C - 60)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(53*r + 53*s - 28))/(77*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**6*f*k2**4*st**2*(40*C - 40)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(159*r*s - 64*r + 159*s**2 - 159*s + 39) + Dd*f*(424*r*s - 206*r + 424*s**2 - 477*s + 131)))/(231*d**2*k3**5) - 2*D1**3*Pk1*Pkd3*ct**6*k2**4*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K - 10*b1*(2*r + 2*s - 1) + 20*r + 20*s - 13)) + k2**2*(r + s)*(792*K*b1 - 792*b1 - 792*g2)) + 858*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (6 - 6*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (6 - 6*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) + 66*f*(fd*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 792*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13)) - 792*g2*k2**2*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(1208*r**2 + 2*r*(1208*s - 815) + 1208*s**2 - 1630*s + 543) + 26*f*(5*fd*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 33*gd2*k2**2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1)) - 858*fd*g2*k2**2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(302*r + 302*s - 181) + 130*f*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1)) - 858*g2*k2**2*(4*r + 4*s + 1))))/(1001*d**2*k3**7) - 4*D1**3*Pk1*Pkd3*ct**6*k2**2*(-792*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) - 33*b1*f*(24*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*D1*fd*(k1**2*(2*C*(12*r*s - 3*r + 12*s**2 - 5*s - 2) - 40*r*s + 17*r - 40*s**2 + 32*s - 3) + k2**2*r*(2*r + 2*s - 1)) + Dd*f*(-4*k1**2*(2*C*(24*r*s - 6*r + 24*s**2 - 17*s + 1) - 80*r*s + 34*r - 80*s**2 + 85*s - 21) + k2**2*(-16*r**2 - 4*r*(4*s - 3) - 10*s + 5))) + f**2*(33*D1*bd1*(4*k1**2*(C*(12*r*s + 12*s**2 - 11*s + 5) - 20*r*s + 5*r - 20*s**2 + 25*s - 10) + k2**2*(4*r**2 + 4*r*s + r + 10*s - 5)) + D1*fd*(10*k1**2*(2*C*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) - 828*r*s + 441*r - 828*s**2 + 960*s - 283) + 3*k2**2*(21*r**2 + r*(21*s + 254) + 323*s - 197)) + Dd*f*(10*k1**2*(C*(816*r*s - 428*r + 816*s**2 - 918*s + 260) - 1104*r*s + 658*r - 1104*s**2 + 1407*s - 454) + 3*k2**2*(28*r**2 + 28*r*s + 291*r + 408*s - 282))))/(693*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**6*k2**2*(13*D1*bd1*f*(7920*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(1275*r**2 + r*(1275*s - 1964) - 1215*s + 689) + 132*f*k1**2*(8*k1**2*(C*(55*r*s - 25*r + 55*s**2 - 76*s + 25) - 41*r*s + 20*r - 41*s**2 + 59*s - 20) + k2**2*(-C*(269*r**2 + 475*r*s - 357*r + 206*s**2 - 248*s + 88) + 309*r**2 + 575*r*s - 437*r + 266*s**2 - 343*s + 128))) + 102960*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 13*b1*f*(3*D1*fd*(3*f*k2**4*r*(425*r + 425*s - 243) + 176*k1**4*(2*C*(110*r*s - 67*r + 110*s**2 - 131*s + 38) - 164*r*s + 103*r - 164*s**2 + 200*s - 59) - 44*k1**2*k2**2*(C*(538*r**2 + 950*r*s - 406*r + 412*s**2 - 332*s + 43) - 618*r**2 - 1150*r*s + 536*r - 532*s**2 + 482*s - 88)) + Dd*f*(f*k2**4*(5100*r**2 + r*(5100*s - 4151) - 1215*s + 689) + 528*k1**4*(C*(440*r*s - 268*r + 440*s**2 - 600*s + 202) - 328*r*s + 206*r - 328*s**2 + 459*s - 158) - 132*k1**2*k2**2*(C*(1076*r**2 + 1900*r*s - 1161*r + 824*s**2 - 869*s + 214) - 1236*r**2 - 2300*r*s + 1461*r - 1064*s**2 + 1219*s - 344))) + f**2*(D1*fd*(5*f*k2**4*(13964*r**2 + r*(13964*s - 19255) - 10771*s + 7581) + 520*k1**4*(14*C*(75*s - 47)*(3*r + 3*s - 2) - 2322*r*s + 1533*r - 2322*s**2 + 3114*s - 1033) - 52*k1**2*k2**2*(C*(19503*r**2 + 9*r*(4203*s - 1423) + 18324*s**2 - 10140*s - 757) - 22410*r**2 - 44784*r*s + 18219*r - 22374*s**2 + 16149*s - 1504)) + Dd*f*(5*f*k2**4*(13964*r**2 + r*(13964*s - 19255) - 10771*s + 7581) + 520*k1**4*(28*C*(150*r*s - 101*r + 150*s**2 - 210*s + 74) - 3096*r*s + 2170*r - 3096*s**2 + 4473*s - 1618) - 52*k1**2*k2**2*(C*(26004*r**2 + 9*r*(5604*s - 2269) + 24432*s**2 - 16145*s - 860) - 29880*r**2 - 59712*r*s + 28164*r - 29832*s**2 + 24709*s - 2606))))/(9009*d**2*k1**2*k3**5) + D1**3*Pk1*Pkd3*ct**5*f*k2**5*st**2*(39*D1*bd1*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(r + s - 1) + 39*b1*(D1*fd*(5*f*k2**2*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + 22*k1**2*(2*r + 2*s - 1)*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113)) + Dd*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(7076*r**2 + r*(14152*s - 9639) + 7076*s**2 - 9639*s + 3249) + 26*k1**2*(3*r + 3*s - 2)*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016)) + Dd*f*(15*f*k2**2*(1769*r + 1769*s - 1083) + 26*k1**2*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016))*(4*r + 4*s - 3)))/(1001*d**2*k1*k3**7) + 20*D1**3*Pk1*Pkd3*ct**5*f*k2**3*st**2*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(159*r*s - 64*r + 159*s**2 - 159*s + 39) + Dd*f*(424*r*s - 206*r + 424*s**2 - 477*s + 131)))/(231*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**5*f*k2**3*st**2*(33*D1*bd1*f*(6*k1**2*(8*C*(18*r*s - 5*r + 18*s**2 - 19*s + 5) - 124*r*s + 35*r - 124*s**2 + 132*s - 35) + k2**2*(-4*C*(32*r**2 + 32*r*s - 37*r - 10*s + 5) + 278*r**2 + 428*r*s - 373*r + 150*s**2 - 265*s + 95)) + 33*b1*(D1*fd*(12*k1**2*(2*C*(72*r*s - 37*r + 72*s**2 - 74*s + 19) - 124*r*s + 64*r - 124*s**2 + 128*s - 33) - k2**2*(2*r + 2*s - 1)*(r*(128*C - 278) - 150*s + 75)) + Dd*f*(6*k1**2*(4*C*(2*r*(72*s - 37) + 144*s**2 - 167*s + 48) + r*(256 - 496*s) - 496*s**2 + 578*s - 167) + k2**2*(-4*C*(128*r**2 + 32*r*(4*s - 3) - 10*s + 5) + 1112*r**2 + 2*r*(856*s - 567) + 600*s**2 - 790*s + 245))) + f*(D1*fd*(12*k1**2*(4*C*(1392*r*s - 585*r + 1392*s**2 - 1447*s + 368) - 4773*r*s + 2020*r - 4773*s**2 + 4993*s - 1277) + k2**2*(-4*C*(2304*r**2 + 3*r*(768*s - 449) + 24*s - 71) + 21141*r**2 + 33066*r*s - 19638*r + 11925*s**2 - 14154*s + 3916)) + Dd*f*(6*k1**2*(8*C*(1856*r*s - 920*r + 1856*s**2 - 2154*s + 611) - 12728*r*s + 6330*r - 12728*s**2 + 14847*s - 4233) + k2**2*(-4*C*(3072*r**2 + 6*r*(512*s - 303) + 149*s - 196) + 28188*r**2 + 44088*r*s - 27597*r + 15900*s**2 - 19729*s + 5516))))/(693*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct**5*k2**3*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 12*K*r + 12*K*s + 6*K + b1*(-58*r - 58*s + 32) + 88*r + 88*s - 59)) + k1**2*k2**2*(r + s)*(-264*b1*(8 - 11*K) - 2904*g2)) + 858*b1**2*k1**2*k2**2*(D1*fd*(f*(58*r**2 + r*(116*s - 61) + 58*s**2 - 61*s + 16) + (16 - 22*K)*(r + s)**2) + Dd*f*(f*(29*r + 29*s - 16) + (16 - 22*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*k1**2*(fd*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59))*(2*r + 2*s - 1) - 44*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2904*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59)) - 2904*g2*k1**2*k2**2*(r + s))) - 2*f*(D1*(70*f**2*fd*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 13*f*k1**2*(5*fd*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 396*gd2*k2**2*(2*r**2 + r*(4*s - 1) + 2*s**2 - s - 1)) - 5148*fd*g2*k1**2*k2**2*(4*r**2 + 8*r*s + 4*s**2 - 1)) + Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3)) + 65*f*k1**2*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 5148*g2*k1**2*k2**2*(2*r + 2*s + 1))))/(1001*d**2*k1*k3**7) + 8*D1**3*Pk1*Pkd3*ct**5*k2*(D1*bd1*f**2*(r*(8*s - 5) + s*(8*s - 9)) + 6*b1**2*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1*f*(6*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 2*D1*fd*(8*s - 7)*(r + s - 1) + Dd*f*(4*r*(8*s - 7) + 32*s**2 - 56*s + 23)))/(21*d**2*k1*k3) - 2*D1**3*Pk1*Pkd3*ct**5*k2*(-132*b1**2*(D1*fd*(k1**2*(58*C - 46)*(s - 1) + k2**2*(-14*C*r + 17*r + 3*s - 3))*(r + s - 1) + Dd*f*(2*k1**2*(2*C*(58*r*s - 47*r + 58*s**2 - 96*s + 38) - 92*r*s + 76*r - 92*s**2 + 153*s - 61) - k2**2*(4*r + 4*s - 3)*(r*(14*C - 17) - 3*s + 3))) + 33*b1*f*(4*D1*bd1*(-2*k1**2*(2*C*(29*r*s - 18*r + 29*s**2 - 38*s + 9) - 46*r*s + 30*r - 46*s**2 + 61*s - 15) + k2**2*(2*r + 2*s - 1)*(r*(14*C - 17) - 3*s + 3)) + D1*fd*(8*k1**2*(6*C*(6*r*s - r + 6*s**2 - 2*s - 2) - 26*r*s + 7*r - 26*s**2 + 12*s + 8) + k2**2*(24*C*(2*r + 3)*(r + s - 1) + 50*r**2 + 294*r*s - 178*r + 244*s**2 - 300*s + 121)) + Dd*f*(4*k1**2*(12*C*(12*r*s - 2*r + 12*s**2 - 10*s + 1) - 104*r*s + 28*r - 104*s**2 + 110*s - 23) + k2**2*(8*C*(12*r**2 + 12*r*s + 9*r + 19*s - 14) + 100*r**2 + 588*r*s - 445*r + 488*s**2 - 621*s + 220))) + f**2*(33*D1*bd1*(4*k1**2*(6*C*(6*r*s + 6*s**2 - 9*s + 5) - 26*r*s + 5*r - 26*s**2 + 51*s - 30) + k2**2*(r**2*(24*C + 25) + r*(8*C*(3*s + 4) + 147*s - 83) + 122*s**2 + 2*s*(20*C - 51) + 2)) + D1*fd*(60*k1**2*(4*C*(29*s - 17)*(3*r + 3*s - 2) + r*(182 - 249*s) - 249*s**2 + 359*s - 125) + k2**2*(4*C*(129*r - 263)*(3*r + 3*s - 2) + 1287*r**2 + 9*r*(1209*s + 191) + 9594*s**2 - 1608*s - 2455)) + Dd*f*(60*k1**2*(8*C*(58*r*s - 37*r + 58*s**2 - 79*s + 27) - 332*r*s + 252*r - 332*s**2 + 511*s - 194) + k2**2*(4*C*(516*r**2 + 516*r*s - 1473*r - 1069*s + 806) + 1716*r**2 + 14508*r*s + 203*r + 12792*s**2 - 4183*s - 3078))))/(693*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**5*k2*(13*D1*bd1*f*(f**2*k2**4*(3861*r**2 + r*(6156*s - 4277) + 2295*s**2 - 3797*s + 450) + 33*f*(8*k1**4*(2*C*(r*(37*s - 25) + 37*s**2 - 64*s + 25) + r*(35 - 47*s) - 47*s**2 + 86*s - 35) + k1**2*k2**2*(-4*C*(188*r**2 + r*(450*s - 309) + 262*s**2 - 318*s + 121) + 579*r**2 + r*(1437*s - 985) + 858*s**2 - 1034*s + 406) + 2*k2**4*(48*C*r**2 + 48*C*r*s - 48*C*r - K*(6*r**2 + 6*r*s + 5*r + 10*s - 10) + 5*b1*(28*r**2 + r*(56*s - 39) + 28*s**2 - 39*s + 11) - 82*r**2 - 122*r*s + 128*r - 40*s**2 + 85*s - 45)) + 132*k2**2*(r + s - 1)*(5*b1*k1**2*(17*C - 14)*(2*r + 2*s - 1) + 2*b1*k2**2*(r*(22 - 7*K) + 15*s) + 14*g2*k2**2*r)) + 858*b1**2*k2**2*(D1*fd*(k1**2*(170*C - 140)*(r + s - 1)**2 + k2**2*(5*f*(28*r**2 + r*(56*s - 39) + 28*s**2 - 39*s + 16) + (r + s)*(-2*r*(7*K - 22) + 30*s))) + Dd*f*(k1**2*(170*C - 140)*(r + s - 1) + k2**2*(-14*K*r + 5*f*(14*r + 14*s - 9) + 44*r + 30*s))*(4*r + 4*s - 3)) + 13*b1*(3*D1*(f**2*fd*k2**4*(3861*r**2 + r*(6156*s - 3782) + 2295*s**2 - 3002*s + 1173) + 11*f*(fd*(8*k1**4*(2*C*(r*(74*s - 55) + 74*s**2 - 101*s + 32) + r*(74 - 94*s) - 94*s**2 + 133*s - 43) + k1**2*k2**2*(-8*C*(188*r**2 + 9*r*(50*s - 23) + 262*s**2 - 246*s + 45) + 1158*r**2 + 6*r*(479*s - 235) + 1716*s**2 - 1728*s + 355) - 2*k2**4*(2*r + 2*s - 1)*(K*(6*r + 9) + r*(82 - 48*C) + 40*s - 44)) + 56*gd2*k2**4*r*(r + s - 1)) + 616*fd*g2*k2**4*r*(r + s)) + Dd*f*(f**2*k2**4*(15444*r**2 + r*(24624*s - 15623) + 9180*s**2 - 12803*s + 3969) + 33*f*(8*k1**4*(2*C*(2*r*(74*s - 55) + 148*s**2 - 234*s + 89) - 188*r*s + 148*r - 188*s**2 + 309*s - 121) + k1**2*k2**2*(-4*C*(752*r**2 + 36*r*(50*s - 31) + 1048*s**2 - 1212*s + 351) + 2316*r**2 + 5748*r*s - 3719*r + 3432*s**2 - 4135*s + 1276) - 2*k2**4*(K*(24*r**2 + r*(24*s + 22) + 38*s - 29) - 2*r**2*(96*C - 164) - 2*r*(96*C*s - 72*C - 244*s + 213) + 160*s**2 - 298*s + 134)) + 1848*g2*k2**4*r*(4*r + 4*s - 3))) + f*(D1*(5*f**2*fd*k2**4*(14564*r**2 + r*(6504*s - 24431) - 8060*s**2 - 12351*s + 12575) + 13*f*(fd*(20*k1**4*(2*C*(981*r*s - 855*r + 981*s**2 - 1575*s + 592) - 1215*r*s + 1164*r - 1215*s**2 + 2073*s - 809) + k1**2*k2**2*(-4*C*(11592*r**2 + 33093*r*s - 9783*r + 21501*s**2 - 14112*s + 611) + 32931*r**2 + 99891*r*s - 29511*r + 66960*s**2 - 44640*s + 2519) + 66*k2**4*(2*C*(66*r**2 + 66*r*s - 45*r - 2*s + 1) - 282*r**2 - 432*r*s + 265*r - 150*s**2 + 179*s - 52)) + 132*gd2*k2**4*(6*r**2 + r*(6*s + 5) + 10*s - 10)) + 5148*fd*g2*k2**4*(2*r + 3)*(2*r + 2*s - 1)) + Dd*f*(5*f**2*k2**4*(14564*r**2 + r*(6504*s - 24431) - 8060*s**2 - 12351*s + 12575) + 13*f*(20*k1**4*(4*C*(654*r*s - 575*r + 654*s**2 - 1107*s + 452) - 1620*r*s + 1544*r - 1620*s**2 + 2895*s - 1226) + k1**2*k2**2*(-8*C*(7728*r**2 + 22062*r*s - 8217*r + 14334*s**2 - 11128*s + 794) + 43908*r**2 + 133188*r*s - 50869*r + 89280*s**2 - 70891*s + 6450) + 66*k2**4*(2*C*(88*r**2 + 88*r*s - 66*r - 2*s + 1) - 376*r**2 - 576*r*s + 382*r - 200*s**2 + 254*s - 77)) + 1716*g2*k2**4*(24*r**2 + r*(24*s + 22) + 38*s - 29))))/(9009*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**4*f**2*k2**6*st**4*(360*C - 360)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)/(77*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**4*f**2*k2**4*st**4*(80*C - 80)*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7))/(77*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**4*k2**4*st**2*(39*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K + 10*b1*(2*r + 2*s - 1) - 5*r - 5*s + 3)) + k2**2*(r + s)*(264*K*b1 - 264*b1 - 264*g2)) - 2574*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (2 - 2*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (2 - 2*K)*(r + s))*(4*r + 4*s - 3)) + 39*b1*(D1*(5*f**2*fd*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) + 22*f*(fd*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 264*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3)) - 264*g2*k2**2*(r + s))) + f*(D1*(125*f**2*fd*k2**2*(2156*r**2 + r*(4312*s - 3013) + 2156*s**2 - 3013*s + 1047) + 26*f*(fd*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 198*gd2*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 5148*fd*g2*k2**2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(4*r + 4*s - 3)*(125*f**2*k2**2*(539*r + 539*s - 349) + 26*f*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1)) - 5148*g2*k2**2*(3*r + 3*s - 1))))/(1001*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**4*k2**2*(429*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 6*K*r + 6*K*s + 15*K + b1*(-50*r - 50*s + 34) + 152*r + 152*s - 106) + 6*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) + 4*k2**2*(r + s)*(b1*k1**2*(11 - 27*K) + 7*b1*k2**2*(K - 1) + g2*(27*k1**2 - 7*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(27*K - 11) - k2**2*(7*K - 7))) + Dd*f*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1)) - (r + s)*(k1**2*(27*K - 11) - k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 2*gd2*k2**2*(-27*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 4*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(70*f**2*fd*k2**2*(-3*k1**2*(r + s - 4) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) + 198*gd2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(r + s - 1)) + 2574*fd*g2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(3*k1**2*(r + s - 4) - 13*k2**2*(17*r + 17*s - 11)) - 65*f*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) + 2574*g2*k2**2*(-k1**2*(2*r + 2*s + 5) + 2*k2**2*(r + s)))))/(1001*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**4*k2**2*st**2*(-792*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 33*b1*f*(-24*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 4*D1*fd*(3*k1**2*(C*(28*r*s - 13*r + 28*s**2 - 21*s + 3) - 40*r*s + 20*r - 40*s**2 + 35*s - 7) + k2**2*r*(2*r + 2*s - 1)) + Dd*f*(6*k1**2*(2*C*(56*r*s - 26*r + 56*s**2 - 55*s + 13) - (2*s - 1)*(80*r + 80*s - 47)) + k2**2*(16*r**2 + 4*r*(4*s - 3) + 10*s - 5))) + f**2*(33*D1*bd1*(6*k1**2*(2*C*(14*r*s - 3*r + 14*s**2 - 15*s + 5) - 40*r*s + 11*r - 40*s**2 + 46*s - 15) + k2**2*(4*r**2 + 4*r*s + r + 10*s - 5)) + 2*D1*fd*(6*k1**2*(10*C*(159*r*s - 64*r + 159*s**2 - 159*s + 39) - 1989*r*s + 850*r - 1989*s**2 + 2099*s - 541) - k2**2*(27*r - 163)*(3*r + 3*s - 2)) + Dd*f*(6*k1**2*(10*C*(424*r*s - 206*r + 424*s**2 - 477*s + 131) - 5304*r*s + 2650*r - 5304*s**2 + 6231*s - 1789) + k2**2*(-216*r**2 - 108*r*(2*s - 13) + 1273*s - 947))))/(693*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**4*k2**2*st**2*(39*D1*bd1*f*(660*b1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*k2**4*(455*r**2 + r*(455*s - 614) - 255*s + 159) + 11*f*k1**2*(6*k1**2*(C*(r*(200*s - 62) + 200*s**2 - 224*s + 62) + r*(47 - 148*s) - 148*s**2 + 168*s - 47) + k2**2*(-2*C*(354*r**2 + r*(605*s - 507) + 251*s**2 - 392*s + 153) + 808*r**2 + 6*r*(245*s - 199) + 662*s**2 - 1009*s + 386))) + 25740*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 39*b1*f*(D1*fd*(f*k2**4*r*(1365*r + 1365*s - 877) + 132*k1**4*(2*C*(100*r*s - 53*r + 100*s**2 - 106*s + 28) - 148*r*s + 79*r - 148*s**2 + 158*s - 42) - 11*k1**2*k2**2*(4*C*(354*r**2 + 605*r*s - 266*r + 251*s**2 - 206*s + 29) - 1616*r**2 - 2940*r*s + 1354*r - 1324*s**2 + 1174*s - 211)) + Dd*f*(f*k2**4*(1820*r**2 + 7*r*(260*s - 213) - 255*s + 159) + 66*k1**4*(C*(8*r*(100*s - 53) + 800*s**2 - 960*s + 286) + r*(316 - 592*s) - 592*s**2 + 716*s - 215) - 22*k1**2*k2**2*(2*C*(708*r**2 + 2*r*(605*s - 377) + 502*s**2 - 579*s + 157) - 1616*r**2 - 84*r*(35*s - 22) - 1324*s**2 + 1573*s - 449))) + f**2*(D1*fd*(f*k2**4*(74420*r**2 + r*(74420*s - 79659) - 26730*s + 19326) + 156*k1**4*(C*(7482*r*s - 3297*r + 7482*s**2 - 8120*s + 2143) - 5493*r*s + 2447*r - 5493*s**2 + 6021*s - 1602) - 13*k1**2*k2**2*(2*C*(26874*r**2 + 48789*r*s - 27051*r + 21915*s**2 - 23712*s + 6079) - 60759*r**2 - 114894*r*s + 66396*r - 54135*s**2 + 61518*s - 17106)) + Dd*f*(f*k2**4*(74420*r**2 + r*(74420*s - 79659) - 26730*s + 19326) + 78*k1**4*(2*C*(9976*r*s - 5044*r + 9976*s**2 - 11982*s + 3511) - 14648*r*s + 7438*r - 14648*s**2 + 17733*s - 5233) - 13*k1**2*k2**2*(4*C*(17916*r**2 + 32526*r*s - 19378*r + 14610*s**2 - 16951*s + 4482) - 81012*r**2 - 153192*r*s + 95357*r - 72180*s**2 + 88078*s - 25621))))/(9009*d**2*k1**2*k3**5) - 4*D1**3*Pk1*Pkd3*ct**4*(D1*bd1*f**2*(4*k1**2*(r*(8*C*s - 5*C - 5*s + 5) + s*(8*C*s - 9*C - 5*s + 6)) + k2**2*(-2*r**2 + r*(11 - 2*s) + 9*s)) + 2*b1**2*(D1*fd*(k1**2*(24*C - 17)*(s - 1) + k2**2*r)*(r + s - 1) + Dd*f*(2*k1**2*(6*C*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 34*r*s + 29*r - 34*s**2 + 57*s - 23) + k2**2*(4*r**2 + 4*r*s + 3*r + 3*s - 3))) + b1*f*(2*D1*bd1*(2*k1**2*(6*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 17*r*s + 12*r - 17*s**2 + 23*s - 6) + k2**2*(2*r**2 + 2*r*s + 5*r + 3*s - 3)) - 4*D1*fd*(k1**2*(-2*C*(8*s - 7) + 10*s - 11) + k2**2*(r - 5))*(r + s - 1) + Dd*f*(4*k1**2*(C*(4*r*(8*s - 7) + 32*s**2 - 56*s + 23) - 20*r*s + 22*r - 20*s**2 + 38*s - 17) + k2**2*(-8*r**2 + r*(46 - 8*s) + 38*s - 29))))/(21*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*ct**4*(33*b1**2*(2*D1*fd*(k1**4*(88*C - 54)*(s - 1)*(r + s - 1) - k1**2*k2**2*(r + s - 1)*(88*C*r + 81*C*(s - 1) - 75*r - 80*s + 80) + k2**4*r*(f*(31*r + 31*s - 20) - 2*r - 2*s)) + Dd*f*(8*k1**4*(2*C*(44*r*s - 40*r + 44*s**2 - 75*s + 31) - 54*r*s + 51*r - 54*s**2 + 93*s - 39) - 2*k1**2*k2**2*(2*C*(176*r**2 + 338*r*s - 245*r + 162*s**2 - 259*s + 97) - 300*r**2 - 620*r*s + 435*r - 320*s**2 + 505*s - 185) + k2**4*(f*(124*r**2 + 124*r*s - 103*r - 23*s + 14) - 16*r**2 - 16*r*s + 36*r - 12*s))) + b1*f*(33*D1*bd1*(8*k1**4*(2*C*(22*r*s - 18*r + 22*s**2 - 31*s + 9) - 27*r*s + 24*r - 27*s**2 + 39*s - 12) + 2*k1**2*k2**2*(-2*C*(88*r**2 + 169*r*s - 76*r + 81*s**2 - 97*s + 16) + 150*r**2 + 310*r*s - 125*r + 160*s**2 - 185*s + 25) + k2**4*(f*(62*r**2 + 62*r*s - 63*r - 23*s + 14) - 8*r**2 - 8*r*s + 20*r - 12*s)) + D1*fd*(-264*k1**4*(12*C*(r*s + s**2 - 1) - 6*r*s - 6*s**2 - s + 8) - 33*k1**2*k2**2*(C*(68*r**2 - 200*r*s + 258*r - 268*s**2 + 362*s - 208) - 18*r**2 + 294*r*s - 284*r + 312*s**2 - 446*s + 225) + k2**4*(f*(3789*r**2 + r*(3789*s - 5955) - 3243*s + 2554) + 264*r**2 + 264*r*(s - 4) - 1320*s + 462)) + Dd*f*(-264*k1**4*(6*C*(4*r*s + 4*s**2 - 5*s + 1) - 12*r*s - 12*s**2 + 17*s - 4) - 33*k1**2*k2**2*(2*C*(68*r**2 - 200*r*s + 293*r - 268*s**2 + 421*s - 196) - 36*r**2 + 588*r*s - 647*r + 624*s**2 - 963*s + 416) + k2**4*(f*(5052*r**2 + 5052*r*s - 7519*r - 4163*s + 3014) + 528*r**2 + 528*r*s - 1980*r - 1716*s + 1254))) + f**2*(D1*bd1*(-264*k1**4*(3*C*(2*r*s + 2*s**2 - 7*s + 5) - 3*r*s - 3*s**2 + 13*s - 10) - 33*k1**2*k2**2*(2*C*(17*r**2 - 50*r*s + 65*r - 67*s**2 + 103*s - 22) - 9*r**2 + 147*r*s - 125*r + 156*s**2 - 198*s + 28) + k2**4*(f*(1263*r**2 + 1263*r*s - 1564*r - 920*s + 460) + 132*r**2 + 132*r*s - 66*r + 198*s + 198)) + D1*fd*(-20*k1**4*(6*C*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + r*(309 - 234*s) - 234*s**2 + 498*s - 217) - 3*k1**2*k2**2*(2*C*(873*r**2 - 15*r*(131*s + 67) - 2838*s**2 + 842*s + 491) - 1341*r**2 + 5*r*(819*s + 359) + 5436*s**2 - 1942*s - 861) + 132*k2**4*(3*r**2 + 3*r*s + 4*s - 2)) + Dd*f*(-20*k1**4*(6*C*(4*r*(25*s - 26) + 100*s**2 - 195*s + 86) + r*(394 - 312*s) - 312*s**2 + 681*s - 322) - 3*k1**2*k2**2*(2*C*(1164*r**2 - r*(2620*s + 999) - 3784*s**2 + 1657*s + 622) - 1788*r**2 + 7*r*(780*s + 209) + 7248*s**2 - 3733*s - 882) + 132*k2**4*(4*r**2 + r*(4*s - 3) + 4*s - 2))))/(693*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**4*(13*D1*bd1*f*(f**2*k2**4*(k1**2*(10860*r**2 + r*(24318*s - 13073) + 13458*s**2 - 17119*s + 1627) - 297*k2**2*(r - 1)*(5*r + 5*s - 3)) + 33*f*k1**2*(16*k1**4*(C*(r*(22*s - 25) + 22*s**2 - 52*s + 25) - 3*r*(4*s - 5) - 12*s**2 + 30*s - 15) - 2*k1**2*k2**2*(2*C*(91*r**2 + r*(518*s - 289) + 427*s**2 - 515*s + 198) - 67*r**2 - 7*r*(85*s - 41) - 528*s**2 + 612*s - 220) + k2**4*(4*C*(315*r**2 + 501*r*s - 425*r + 186*s**2 - 270*s + 110) - 2*K*(39*r**2 + 70*r*s + 89*r + 31*s**2 + 91*s - 122) + b1*(774*r**2 + r*(1566*s - 1121) + 792*s**2 - 1095*s + 325) - 1454*r**2 - 2496*r*s + 2358*r - 1042*s**2 + 1830*s - 916)) - 132*k1**2*k2**2*(30*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(95 - 150*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(70*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(167*r**2 + 250*r*s - 172*r + 83*s**2 - 88*s + 5) - 323*r**2 - 586*r*s + 404*r - 263*s**2 + 332*s - 75)) + k2**2*(30*b2*(r + s) - g2*(167*r + 83*s))*(r + s - 1))) - 51480*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(300*C - 190)*(r + s - 1)**2 + k2**2*(-140*C*(r + s - 1)**2 - 167*K*r**2 - 250*K*r*s + 20*K*r - 83*K*s**2 + 20*K*s - 10*K + f*(387*r**2 + 783*r*s - 467*r + 396*s**2 - 466*s + 159) + 323*r**2 + 586*r*s - 300*r + 263*s**2 - 300*s + 150)) + Dd*f*(k1**2*(600*C - 380)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(-280*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 1336*K*r**2 - 2000*K*r*s + 1082*K*r - 664*K*s**2 + 578*K*s - 60*K + f*(1548*r**2 + 3132*r*s - 2055*r + 1584*s**2 - 2027*s + 643) + 2584*r**2 + 4688*r*s - 3186*r + 2104*s**2 - 2754*s + 900))) + 13*b1*(-3*D1*(f**2*fd*k2**4*(-k1**2*(10860*r**2 + 7*r*(3474*s - 1555) + 13458*s**2 - 12551*s + 2953) + 297*k2**2*r*(5*r + 5*s - 3)) - 22*f*k1**2*(fd*(8*k1**4*(C*(r*(44*s - 46) + 44*s**2 - 74*s + 26) - 3*r*(8*s - 9) - 24*s**2 + 42*s - 15) + k1**2*k2**2*(-2*C*(182*r**2 + r*(1036*s - 619) + 854*s**2 - 1047*s + 280) + 134*r**2 + 2*r*(595*s - 394) + 1056*s**2 - 1438*s + 425) + k2**4*(2*C*(630*r**2 + 2*r*(501*s - 197) + 372*s**2 - 252*s + 3) - K*(78*r**2 + 5*r*(28*s + 37) + 62*s**2 + 197*s - 112) - 1454*r**2 - 2496*r*s + 1365*r - 1042*s**2 + 1149*s - 246)) + 2*k2**4*(-30*bd2*(r + s) + gd2*(167*r + 83*s - 10))*(r + s - 1)) + 44*fd*k1**2*k2**4*(30*b2*(r + s)**2 - g2*(167*r**2 + 10*r*(25*s - 2) + 83*s**2 - 20*s + 10))) + Dd*f*(f**2*k2**4*(2*k1**2*(21720*r**2 + 4*r*(12159*s - 5716) + 26916*s**2 - 27386*s + 5243) - 297*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 66*f*k1**2*(8*k1**4*(C*(r*(88*s - 92) + 88*s**2 - 174*s + 77) - 6*r*(8*s - 9) - 48*s**2 + 99*s - 45) + k1**2*k2**2*(-2*C*(364*r**2 + 7*r*(296*s - 207) + 1708*s**2 - 2329*s + 818) + 268*r**2 + r*(2380*s - 1763) + 2112*s**2 - 3063*s + 1130) + k2**4*(2*C*(1260*r**2 + r*(2004*s - 1223) + 744*s**2 - 771*s + 176) - K*(156*r**2 + 280*r*s + 363*r + 124*s**2 + 379*s - 356) - 2908*r**2 - 4992*r*s + 3705*r - 2084*s**2 + 2961*s - 1080)) + 132*k1**2*k2**4*(-30*b2*(r + s) + g2*(167*r + 83*s - 10))*(4*r + 4*s - 3))) + f*(D1*(5*f**2*fd*k2**4*(k1**2*(67092*r**2 + r*(113788*s - 134133) + 46696*s**2 - 130705*s + 68795) - 533*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(fd*(20*k1**4*(2*C*(27*r*(9*s - 14) + 243*s**2 - 573*s + 263) - 3*r*(84*s - 149) - 252*s**2 + 648*s - 309) + k1**2*k2**2*(2*C*(7587*r**2 - 36*r*(514*s + 213) - 26091*s**2 + 12474*s + 2510) - 18621*r**2 + 6903*r*s + 21531*r + 25524*s**2 - 6282*s - 6617) + 66*k2**4*(C*(981*r**2 + 1599*r*s - 973*r + 618*s**2 - 702*s + 203) - 1140*r**2 - 1983*r*s + 1223*r - 843*s**2 + 990*s - 297)) - 66*k2**4*(5*bd2*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - gd2*(39*r**2 + 70*r*s + 89*r + 31*s**2 + 91*s - 122))) - 1716*fd*k1**2*k2**4*(5*b2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1) - g2*(78*r**2 + 5*r*(28*s + 37) + 62*s**2 + 197*s - 112))) + Dd*f*(5*f**2*k2**4*(k1**2*(67092*r**2 + r*(113788*s - 134133) + 46696*s**2 - 130705*s + 68795) - 533*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(20*k1**4*(2*C*(324*r*s - 476*r + 324*s**2 - 777*s + 386) - 336*r*s + 558*r - 336*s**2 + 873*s - 450) + k1**2*k2**2*(2*C*(10116*r**2 - 3*r*(8224*s + 2141) - 34788*s**2 + 21853*s + 1828) - 24828*r**2 + 9204*r*s + 24167*r + 34032*s**2 - 14517*s - 6890) + 66*k2**4*(C*(1308*r**2 + 2132*r*s - 1419*r + 824*s**2 - 1011*s + 306) - 1520*r**2 - 2644*r*s + 1778*r - 1124*s**2 + 1424*s - 450)) - 1716*k1**2*k2**4*(5*b2*(16*r**2 + 8*r*(4*s - 1) + 16*s**2 - 8*s - 3) - g2*(156*r**2 + r*(280*s + 363) + 124*s**2 + 379*s - 356)))))/(9009*d**2*k1**2*k3**5) + 40*D1**3*Pk1*Pkd3*ct**3*f**2*k2**3*st**4*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7))/(77*d**2*k1*k3**3) + 6*D1**3*Pk1*Pkd3*ct**3*f*k2**5*st**4*(26*D1*bd1*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(r + s - 1) + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 + k1**2*(66*C - 66)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(f*k2**2*(1772*r**2 + r*(3544*s - 2541) + 1772*s**2 - 2541*s + 909) + k1**2*(520*C - 442)*(3*r + 3*s - 2)**2) + Dd*f*(f*k2**2*(443*r + 443*s - 303) + k1**2*(520*C - 442)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**3*f*k2**3*st**4*(132*b1*(C - 1)*(D1*fd*(k1**2*(8*r*s - 3*r + 8*s**2 - 6*s + 1) + 2*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(k1**2*(16*r*s - 6*r + 16*s**2 - 13*s + 2) + 2*k2**2*r*(4*r + 4*s - 3))) + f*(264*D1*bd1*(C - 1)*(k1**2*s*(2*r + 2*s - 1) + k2**2*r*(r + s - 1)) + D1*fd*(k1**2*(360*C - 300)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(-2*C*(3*r - 1)*(93*r + 93*s - 73) + 1233*r**2 + 12*r*(159*s - 127) + 675*s**2 - 1086*s + 446)) + Dd*f*k1**2*(180*C - 150)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + Dd*f*k2**2*(-2*C*(372*r**2 + r*(372*s - 405) - 103*s + 83) + 1644*r**2 + 3*r*(848*s - 695) + 900*s**2 - 1481*s + 616)))/(231*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct**3*k1*k2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 8*K*r + 8*K*s - 10*K + b1*(r + s - 5) - 64*r - 64*s + 47) - 6*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) - 132*k2**2*(r + s)*(b1*k1**2*(8*K + 3) + 7*b1*k2**2*(3 - 4*K) - 8*g2*k1**2 + 28*g2*k2**2)) - 858*b1**2*k2**2*(D1*fd*(-f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(k1**2*(8*K + 3) + k2**2*(21 - 28*K))) - Dd*f*(f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7)) - (r + s)*(k1**2*(8*K + 3) + k2**2*(21 - 28*K)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 8*gd2*k2**2*(2*k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 528*fd*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 528*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(35*f**2*fd*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 264*gd2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(r + s - 1)) - 3432*fd*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5)) + 65*f*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 3432*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s)))))/(1001*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(-13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 34*K*r + 34*K*s - 12*K - 2*b1*(79*r + 79*s - 41) + 41*r + 41*s - 27)) + k1**2*k2**2*(r + s)*(-132*b1*(16 - 19*K) - 2508*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(158*r**2 + r*(316*s - 161) + 158*s**2 - 161*s + 41) + (32 - 38*K)*(r + s)**2) + Dd*f*(f*(79*r + 79*s - 41) + (32 - 38*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 33*f*k1**2*(fd*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27))*(2*r + 2*s - 1) - 76*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2508*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27)) - 2508*g2*k1**2*k2**2*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(k1**2*(-1229*r - 1229*s + 847) + 65*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 26*f*k1**2*(fd*(k1**2*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 66*gd2*k2**2*(17*r**2 + r*(34*s - 23) + 17*s**2 - 23*s + 6)) + 1716*fd*g2*k1**2*k2**2*(34*r**2 + r*(68*s - 29) + 34*s**2 - 29*s + 6)) - Dd*f*(4*r + 4*s - 3)*(25*f**2*(k1**2*k2**2*(1229*r + 1229*s - 847) - 65*k2**4*(5*r + 5*s - 3)) + 26*f*(k1**4*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 1716*g2*k1**2*k2**2*(17*r + 17*s - 6))))/(1001*d**2*k1*k3**7) + 4*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(D1*bd1*f**2*(r*(6*s - 2) + s*(6*s - 5)) + 2*b1**2*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + b1*f*(2*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*fd*(12*s - 7)*(r + s - 1) + Dd*f*(24*r*s - 14*r + 24*s**2 - 35*s + 12)))/(7*d**2*k1*k3) + 2*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(66*b1**2*(D1*fd*(k1**2*(74*C - 62)*(s - 1) + k2**2*(2*C*r + r + 3*s - 3))*(r + s - 1) + Dd*f*(2*k1**2*(C*(4*r*(37*s - 26) + 148*s**2 - 237*s + 89) - 2*r*(62*s - 43) - 124*s**2 + 198*s - 74) + k2**2*(C*(8*r**2 + 8*r*s + 6*r + 6*s - 6) + 4*r**2 + 16*r*s - 27*r + 12*s**2 - 27*s + 15))) + 33*b1*f*(2*D1*bd1*(2*k1**2*(C*(74*r*s - 30*r + 74*s**2 - 89*s + 15) - 62*r*s + 24*r - 62*s**2 + 74*s - 12) + k2**2*(2*C*(2*r**2 + 2*r*s + 5*r + 3*s - 3) + 2*r**2 + 8*r*s - 19*r + 6*s**2 - 15*s + 9)) + D1*fd*(-2*k1**2*(4*C*(53*r*s - 26*r + 53*s**2 - 34*s + 2) - 152*r*s + 77*r - 152*s**2 + 97*s - 5) + k2**2*(-8*C*(8*r - 3)*(r + s - 1) + 16*r**2 - 202*r*s + 38*r - 218*s**2 + 176*s - 17)) + Dd*f*(k1**2*(-4*C*(4*r*(53*s - 26) + 212*s**2 - 213*s + 53) + 608*r*s - 308*r + 608*s**2 - 630*s + 164) + k2**2*(-8*C*(16*r**2 + 2*r*(8*s - 9) - 3*s + 3) + 32*r**2 - 404*r*s + 150*r - 436*s**2 + 414*s - 87))) - f**2*(33*D1*bd1*(2*k1**2*(2*C*(53*r*s - 15*r + 53*s**2 - 73*s + 30) - 76*r*s + 24*r - 76*s**2 + 113*s - 48) + k2**2*(r**2*(32*C - 8) + r*(8*C*(4*s - 3) + 101*s - 20) + 109*s**2 - 79*s + 20)) + D1*fd*(6*k1**2*(8*C*(597*r*s - 265*r + 597*s**2 - 652*s + 173) - 3504*r*s + 1597*r - 3504*s**2 + 3922*s - 1061) + k2**2*(4*C*(738*r**2 + 738*r*s - 1167*r - 642*s + 439) - 279*r**2 + 7983*r*s - 825*r + 8262*s**2 - 5826*s + 443)) + Dd*f*(6*k1**2*(4*C*(1592*r*s - 810*r + 1592*s**2 - 1923*s + 567) - 4672*r*s + 2394*r - 4672*s**2 + 5751*s - 1722) + k2**2*(4*C*(984*r**2 + 984*r*s - 1710*r - 892*s + 689) - 372*r**2 + 10644*r*s - 2227*r + 11016*s**2 - 9265*s + 1128))))/(693*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct**3*k2*st**2*(13*D1*bd1*f*(f**2*k2**4*(5874*r**2 + r*(8754*s - 6731) + 2880*s**2 - 4775*s + 951) + 33*f*(4*k1**4*(C*(r*(199*s - 69) + 199*s**2 - 238*s + 69) + r*(45 - 127*s) - 127*s**2 + 154*s - 45) + k1**2*k2**2*(-2*C*(565*r**2 + r*(1190*s - 907) + 625*s**2 - 865*s + 342) + 917*r**2 + 2009*r*s - 1496*r + 1092*s**2 - 1473*s + 579) + k2**4*(12*C*(6*r**2 + 6*r*s - 7*r - 2*s + 1) - 16*K*r**2 - 16*K*r*s + 12*K*r + 5*b1*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 31) - 71*r**2 - 86*r*s + 102*r - 15*s**2 + 54*s - 27)) + 66*k2**2*(b1*(k1**2*(125*C - 110)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(r**2*(2*K + 28) + r*(K*(2*s - 5) + 58*s - 25) + 3*s*(K + 10*s - 11))) - 2*g2*k2**2*(r**2 + r*(s - 1) + 3*s))) + 429*b1**2*k2**2*(D1*fd*(k1**2*(250*C - 220)*(r + s - 1)**2 + k2**2*(5*f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 41) + (2*r + 2*s)*(r*(K + 14) + 15*s))) + 2*Dd*f*(k1**2*(125*C - 110)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(5*f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 36) + r**2*(4*K + 56) + r*(4*K*s - 9*K + 116*s - 36) + 3*s*(K + 20*s - 16)))) + 13*b1*(3*D1*(f**2*fd*k2**4*(5874*r**2 + r*(8754*s - 6269) + 2880*s**2 - 4405*s + 1901) + 11*f*(fd*(4*k1**4*(C*(r*(398*s - 218) + 398*s**2 - 437*s + 119) + r*(140 - 254*s) - 254*s**2 + 281*s - 77) + k1**2*k2**2*(-4*C*(565*r**2 + 170*r*(7*s - 3) + 625*s**2 - 511*s + 68) + 1834*r**2 + 7*r*(574*s - 251) + 2184*s**2 - 1833*s + 268) - k2**4*(4*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - r**2*(144*C - 142) + r*(-144*C*s + 72*C + 172*s - 85) + 30*s**2 - 33*s + 7)) - 4*gd2*k2**4*r*(r + s - 4)) - 44*fd*g2*k2**4*r*(r + s)) + Dd*f*(2*f**2*k2**4*(11748*r**2 + r*(17508*s - 12769) + 5760*s**2 - 8995*s + 3327) + 33*f*(4*k1**4*(C*(r*(796*s - 436) + 796*s**2 - 993*s + 307) + r*(280 - 508*s) - 508*s**2 + 639*s - 199) + k1**2*k2**2*(-2*C*(2260*r**2 + 5*r*(952*s - 571) + 2500*s**2 - 2773*s + 739) + 3668*r**2 + r*(8036*s - 4841) + 4368*s**2 - 4871*s + 1320) + k2**4*(12*C*(24*r**2 + 6*r*(4*s - 3) - 2*s + 1) - 4*K*(16*r**2 + 2*r*(8*s - 7) - 3*s + 2) - 284*r**2 - 344*r*s + 265*r - 60*s**2 + 117*s - 49)) - 132*g2*k2**4*(4*r**2 + r*(4*s - 9) + 3*s))) + f*(D1*(4*f**2*fd*k2**4*(34048*r**2 + r*(18318*s - 30629) - 15730*s**2 + 3994*s + 5175) + 13*f*(fd*(6*k1**4*(2*C*(r*(4773*s - 2207) + 4773*s**2 - 5433*s + 1486) + r*(2817 - 6042*s) - 6042*s**2 + 6944*s - 1911) + k1**2*k2**2*(-4*C*(19800*r**2 + 9*r*(4923*s - 2719) + 24507*s**2 - 27015*s + 7316) + 63243*r**2 + 9*r*(16061*s - 9085) + 81306*s**2 - 91530*s + 25643) + 198*k2**4*(C*(36*r**2 + r*(36*s - 26) - 4*s + 2) - 66*r**2 + r*(61 - 96*s) - 30*s**2 + 39*s - 12)) + 264*gd2*k2**4*r*(4*r + 4*s - 3)) + 3432*fd*g2*k2**4*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + Dd*f*(4*f**2*k2**4*(34048*r**2 + r*(18318*s - 30629) - 15730*s**2 + 3994*s + 5175) + 13*f*(6*k1**4*(2*C*(6364*r*s - 3264*r + 6364*s**2 - 7935*s + 2397) - 8056*r*s + 4134*r - 8056*s**2 + 10119*s - 3072) + k1**2*k2**2*(-4*C*(26400*r**2 + 36*r*(1641*s - 989) + 32676*s**2 - 39131*s + 11263) + 84324*r**2 + 192732*r*s - 119605*r + 108408*s**2 - 132853*s + 39864) + 198*k2**4*(C*(48*r**2 + 48*r*s - 36*r - 4*s + 2) - 88*r**2 - 128*r*s + 86*r - 40*s**2 + 54*s - 17)) + 3432*g2*k2**4*(16*r**2 + 2*r*(8*s - 7) - 3*s + 2))))/(9009*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct**3*(D1*bd1*f**2*(k1**2*(8*C - 4)*(r*(2*s - 5) + s*(2*s - 3)) + k2**2*(r**2*(24*C - 6) + r*(8*C*(3*s - 4) + 29*s + 30) + s*(-40*C + 35*s + 1))) + b1**2*(D1*fd*(k1**2*(40*C - 20)*(s - 1) + k2**2*(18*r + 59*s - 59))*(r + s - 1) + 2*Dd*f*(k1**2*(8*C - 4)*(10*r*s - 11*r + 10*s**2 - 18*s + 8) + k2**2*(36*r**2 + 2*r*(77*s - 43) + 118*s**2 - 177*s + 59))) + b1*f*(2*D1*bd1*(k1**2*(8*C - 4)*(r*(5*s - 6) + 5*s**2 - 8*s + 3) + k2**2*(18*r**2 + r*(77*s - 9) + s*(59*s - 59))) + D1*fd*(k1**2*(32*C - 16)*(s - 2) + k2**2*(24*C*(2*r - 3) - 12*r + 70*s + 31))*(r + s - 1) + 4*Dd*f*(k1**2*(2*C - 1)*(8*r*(s - 2) + 8*s**2 - 20*s + 11) + k2**2*(C*(24*r**2 + 6*r*(4*s - 9) - 38*s + 28) - 6*r**2 + 29*r*s + 20*r + 35*s**2 - 18*s - 8))))/(21*d**2*k1*k2*k3) + 2*D1**3*Pk1*Pkd3*ct**3*(165*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(5*bd1*f*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(40*C - 20)*(s - 1)*(r + s - 1) - k1**2*k2**2*(r + s - 1)*(4*C*(25*r + 67*s - 67) - 58*r - 197*s + 197) + k2**4*(56*C*r**2 + 56*C*r*s - 56*C*r + 6*K*(r - 1)*(r + s - 1) + 2*f*(24*r**2 + 38*r*s + r + 14*s**2 - 5*s - 8) - 97*r**2 - 116*r*s + 100*r - 19*s**2 + 38*s - 22))) + Dd*f*(k1**4*(16*C - 8)*(10*r*s - 11*r + 10*s**2 - 18*s + 8) - 2*k1**2*k2**2*(C*(200*r**2 + r*(736*s - 462) + 536*s**2 - 826*s + 290) - 116*r**2 + r*(296 - 510*s) - 394*s**2 + 597*s - 203) + k2**4*(224*C*r**2 + 224*C*r*s - 168*C*r + 6*K*(4*r**2 + 4*r*s - 13*r - 13*s + 9) + 2*f*(48*r**2 + r*(76*s - 30) + 28*s**2 - 26*s + 1) - 388*r**2 - 464*r*s + 455*r - 76*s**2 + 179*s - 102))) + b1*(66*D1*bd1*f*(k1**4*(8*C - 4)*(r*(5*s - 6) + 5*s**2 - 8*s + 3) + k1**2*k2**2*(-2*C*(50*r**2 + r*(184*s - 47) + 134*s**2 - 145*s + 11) + 58*r**2 + r*(255*s - 41) + 197*s**2 - 203*s + 6) + k2**4*(56*C*r**2 + 56*C*r*s - 28*C*r + 6*K*(r**2 + r*(s - 3) - 4*s + 2) + f*(24*r**2 + r*(38*s - 31) + 14*s**2 - 21*s + 9) - 97*r**2 - 116*r*s + 99*r - 19*s**2 + 41*s - 20)) + 3*D1*(2*f**2*fd*k2**4*(1257*r**2 + 3*r*(551*s - 810) + 396*s**2 - 1970*s + 1268) - 11*f*(fd*(k1**4*(16*C - 8)*(s - 2) + 2*k1**2*k2**2*(2*C*(14*r**2 + r*(106 - 54*s) - 68*s**2 + 126*s - 75) - 10*r**2 + 5*r*(10*s - 27) + 60*s**2 - 165*s + 109) - k2**4*(4*C*(26*r - 1)*(r + s - 1) - 6*K*(2*r - 3)*(2*r + 2*s - 1) + 40*r**2 + 246*r*s - 123*r + 206*s**2 - 285*s + 69)) + 12*gd2*k2**4*(r - 4)*(r + s - 1)) - 132*fd*g2*k2**4*(r - 1)*(r + s - 1)) + 2*Dd*f*(f**2*k2**4*(5028*r**2 + 29*r*(228*s - 329) + 1584*s**2 - 7621*s + 4659) + 33*f*(k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(C*(-56*r**2 + r*(216*s - 370) + 272*s**2 - 522*s + 262) + 20*r**2 + r*(231 - 100*s) - 120*s**2 + 323*s - 178) + k2**4*(2*C*(52*r**2 + r*(52*s - 41) - s + 1) + K*(-24*r**2 - 24*r*s + 58*r + 38*s - 29) + 40*r**2 + 246*r*s - 197*r + 206*s**2 - 301*s + 115)) - 198*g2*k2**4*(4*r**2 + r*(4*s - 13) - 13*s + 9))) + f*(D1*bd1*(2*f**2*k2**4*(1257*r**2 + r*(1653*s - 2251) + 396*s**2 - 1711*s + 855) + 33*f*(k1**4*(40*C - 20)*(s - 1) - 2*k1**2*k2**2*(2*C*(7*r**2 + r*(20 - 27*s) - 34*s**2 + 54*s - 9) - 5*r**2 + r*(25*s - 28) + 30*s**2 - 64*s + 5) + k2**4*(-2*K*(6*r**2 + 6*r*s - 17*r - 10*s + 10) + r**2*(52*C + 20) + r*(52*C*s - 4*C + 123*s - 116) + 103*s**2 - 115*s + 62)) - 396*g2*k2**4*(r**2 + r*(s - 1) - 4*s)) + D1*(f*fd*(k1**4*(20 - 40*C)*(3*s - 23)*(3*r + 3*s - 2) - 3*k1**2*k2**2*(4*C*(1179*r**2 - 15*r*(5*s + 72) - 1254*s**2 + 410*s + 240) - 3108*r**2 + r*(3551 - 1467*s) + 1641*s**2 + 154*s - 909) - 33*k2**4*(4*C*(3*r - 1)*(2*r + 2*s - 1) - 189*r**2 - 447*r*s + 223*r - 258*s**2 + 228*s - 51)) - 66*f*k2**4*(bd2 - 2*gd2)*(6*r**2 + 6*r*s - 17*r - 10*s + 10) - 198*fd*k2**4*(b2 - 2*g2)*(2*r - 3)*(2*r + 2*s - 1)) + Dd*f*(f*(-k1**4*(80*C - 40)*(r*(6*s - 41) + 6*s**2 - 48*s + 32) - 6*k1**2*k2**2*(2*C*(1572*r**2 - r*(100*s + 1297) - 1672*s**2 + 823*s + 245) - 2072*r**2 + r*(2289 - 978*s) + 1094*s**2 - 114*s - 537) - 33*k2**4*(4*C*(4*r - 1)*(2*r + 2*s - 1) - 252*r**2 + r*(367 - 596*s) - 344*s**2 + 357*s - 94)) + k2**4*(-66*b2 + 132*g2)*(24*r**2 + r*(24*s - 58) - 38*s + 29))))/(693*d**2*k1*k2*k3**3) - 2*D1**3*Pk1*Pkd3*ct**3*(13*D1*bd1*f*(f**2*k2**4*(k1**2*(2151*r**2 - r*(834*s + 2585) - 2985*s**2 + 1761*s + 1022) + 33*k2**2*(142*r**2 + r*(182*s - 157) + 40*s**2 - 97*s + 17)) - 33*f*(k1**6*(8*C - 4)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k1**4*k2**2*(4*C*(55*r**2 + r*(5*s - 44) - 50*s**2 + 56*s - 11) - 136*r**2 + r*(140 - 57*s) + 79*s**2 - 89*s - 4) + k1**2*k2**4*(4*C*(280*r**2 + 517*r*s - 445*r + 237*s**2 - 363*s + 165) + 132*K*r**2 + 202*K*r*s - 426*K*r + 70*K*s**2 - 358*K*s + 288*K - b1*(114*r**2 + r*(270*s - 151) + 156*s**2 - 229*s + 55) - 1120*r**2 - 2123*r*s + 1904*r - 1003*s**2 + 1647*s - 798) - 2*k2**6*(15*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + r**2*(43 - 13*K) + r*(-13*K*s + 12*K + 73*s - 42) + s*(30*s - 30))) + 33*k2**2*(75*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*b1*(k1**4*(30*C - 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - k1**2*k2**2*(210*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*K*(103*r**2 + 164*r*s - 113*r + 61*s**2 - 71*s + 10) - 413*r**2 - 782*r*s + 613*r - 369*s**2 + 549*s - 190) + 14*k2**4*(r*(2*K - 7) - 5*s)*(r + s - 1)) + 4*k2**2*(r + s - 1)*(25*b2*k1**2*(r + s) - g2*k1**2*(103*r + 61*s) + 14*g2*k2**2*r))) + 32175*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k2**2*(D1*fd*(k1**4*(20 - 60*C)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 + 206*K*r**2 + 328*K*r*s - 80*K*r + 122*K*s**2 - 80*K*s + 40*K + 2*f*(57*r**2 + 135*r*s - 77*r + 78*s**2 - 92*s + 34) - 413*r**2 - 782*r*s + 760*r - 369*s**2 + 760*s - 380) + 2*k2**4*(15*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-7*r*(2*K - 7) + 35*s))) + Dd*f*(-k1**4*(60*C - 20)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(420*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 824*K*r**2 + 1312*K*r*s - 778*K*r + 488*K*s**2 - 526*K*s + 120*K + f*(228*r**2 + 540*r*s - 305*r + 312*s**2 - 413*s + 123) - 1652*r**2 - 3128*r*s + 2799*r - 1476*s**2 + 2607*s - 1140) + 2*k2**4*(4*r + 4*s - 3)*(30*f*(3*r + 3*s - 2) + r*(49 - 14*K) + 35*s))) + 13*b1*(3*D1*(f**2*fd*k2**4*(k1**2*(2151*r**2 - 2*r*(417*s + 1456) - 2985*s**2 - 126*s + 1327) + 11*k2**2*(426*r**2 + 21*r*(26*s - 21) + 120*s**2 - 261*s + 145)) - 11*f*(fd*(k1**6*(16*C - 8)*(s - 2)*(2*r + 2*s - 1) + k1**4*k2**2*(4*C*(110*r**2 + 10*r*s + 66*r - 100*s**2 + 230*s - 95) - 272*r**2 - 3*r*(38*s + 41) + 158*s**2 - 513*s + 237) + k1**2*k2**4*(4*C*(560*r**2 + r*(1034*s - 405) + 474*s**2 - 349*s + 11) + 4*K*(66*r**2 + 101*r*s - 167*r + 35*s**2 - 155*s + 67) - 2240*r**2 - 4246*r*s + 2057*r - 2006*s**2 + 1947*s - 305) + 2*k2**6*(r**2*(26*K - 86) + r*(13*K*(2*s - 1) - 146*s + 43) - s*(K + 60*s - 31))) - 4*k2**4*(r + s - 1)*(25*bd2*k1**2*(r + s) + gd2*k1**2*(-103*r - 61*s + 20) + 14*gd2*k2**2*r)) + 44*fd*k2**4*(25*b2*k1**2*(r + s)**2 - g2*k1**2*(103*r**2 + 4*r*(41*s - 10) + 61*s**2 - 40*s + 20) + 14*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(8604*r**2 - r*(3336*s + 11321) - 11940*s**2 + 1383*s + 5003) + 66*k2**2*(284*r**2 + 13*r*(28*s - 23) + 80*s**2 - 179*s + 81)) - 66*f*(k1**6*(4*C - 2)*(8*r*(s - 2) + 8*s**2 - 24*s + 13) + k1**4*k2**2*(2*C*(220*r**2 + r*(20*s + 57) - 200*s**2 + 421*s - 191) - 272*r**2 - 3*r*(38*s + 5) + 158*s**2 - 439*s + 215) + k1**2*k2**4*(2*C*(1120*r**2 + 2*r*(1034*s - 635) + 948*s**2 - 1050*s + 277) + 2*K*(132*r**2 + 202*r*s - 380*r + 70*s**2 - 334*s + 211) - 2240*r**2 - 4246*r*s + 2923*r - 2006*s**2 + 2611*s - 864) + k2**6*(r**2*(52*K - 172) + r*(K*(52*s - 37) - 292*s + 127) - s*(K + 120*s - 91))) + 132*k2**4*(4*r + 4*s - 3)*(25*b2*k1**2*(r + s) + g2*k1**2*(-103*r - 61*s + 20) + 14*g2*k2**2*r))) + f*(D1*(-5*f**2*fd*k2**4*(k1**2*(41812*r**2 + r*(112636*s - 96685) + 70824*s**2 - 119497*s + 49521) + 52*k2**2*(120*r**2 + 5*r*(146*s - 83) + 610*s**2 - 701*s + 203)) - 13*f*(fd*k1**2*(k1**4*(40*C - 20)*(3*s - 23)*(3*r + 3*s - 2) + k1**2*k2**2*(4*C*(11322*r**2 + 27*r*(503*s - 479) + 2259*s**2 - 6099*s + 3326) - 28944*r**2 - 41103*r*s + 35769*r - 12159*s**2 + 21444*s - 9937) + 33*k2**4*(8*C*(477*r**2 + 888*r*s - 557*r + 411*s**2 - 491*s + 152) - 3177*r**2 - 6057*r*s + 3853*r - 2880*s**2 + 3500*s - 1105)) - 132*k2**4*(10*bd2*k1**2*(r**2 + 2*r*s + s**2 - 1) + gd2*k1**2*(66*r**2 + r*(101*s - 213) + 35*s**2 - 179*s + 144) + gd2*k2**2*r*(13*r + 13*s - 12))) + 1716*fd*k2**4*(10*b2*k1**2*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 2*g2*k1**2*(66*r**2 + r*(101*s - 167) + 35*s**2 - 155*s + 67) + g2*k2**2*(26*r**2 + 13*r*(2*s - 1) - s))) + Dd*f*(-5*f**2*k2**4*(k1**2*(41812*r**2 + r*(112636*s - 96685) + 70824*s**2 - 119497*s + 49521) + 52*k2**2*(120*r**2 + 5*r*(146*s - 83) + 610*s**2 - 701*s + 203)) - 13*f*k1**2*(k1**4*(80*C - 40)*(r*(6*s - 41) + 6*s**2 - 48*s + 32) + 2*k1**2*k2**2*(4*C*(7548*r**2 + 9054*r*s - 8874*r + 1506*s**2 - 4003*s + 2240) - 19296*r**2 - 27402*r*s + 24879*r - 8106*s**2 + 14684*s - 6904) + 33*k2**4*(8*C*(636*r**2 + 1184*r*s - 811*r + 548*s**2 - 708*s + 232) - 4236*r**2 - 8076*r*s + 5631*r - 3840*s**2 + 5057*s - 1702)) + 1716*k2**4*(10*b2*k1**2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 2*g2*k1**2*(132*r**2 + r*(202*s - 380) + 70*s**2 - 334*s + 211) + g2*k2**2*(52*r**2 + r*(52*s - 37) - s)))))/(9009*d**2*k1*k2*k3**5) - D1**3*Pk1*Pkd3*ct**2*f*k2**6*st**6*(20*C - 20)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(77*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**6*(40*C - 40)*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(693*d**2*k3**5) + 2*D1**3*Pk1*Pkd3*ct**2*k1**2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 24*K*r + 24*K*s - 15*K - 2*b1*(7*r + 7*s - 2) - 52*r - 52*s + 41) - 18*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 132*k2**2*(r + s)*(b1*k1**2*(5 - 8*K) + 21*b1*k2**2*(1 - 2*K) + 8*g2*k1**2 + 42*g2*k2**2)) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(8*K - 5) + k2**2*(42*K - 21))) + Dd*f*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - (r + s)*(k1**2*(8*K - 5) + k2**2*(42*K - 21)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) - 4*gd2*k2**2*(4*k1**2 + 21*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) + 264*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 198*gd2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(r + s - 1)) - 2574*fd*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9)) + 65*f*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 2574*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s)))))/(1001*d**2*k3**7) + 6*D1**3*Pk1*Pkd3*ct**2*k2**4*st**4*(78*D1*bd1*f*(r + s - 1)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + k2**2*(r + s)*(-22*K*b1 + 22*b1 + 22*g2)) - 858*b1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 78*b1*(D1*(20*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 11*f*(fd*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 2*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 22*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + 22*g2*k2**2*(r + s))) + f**2*(D1*fd*(5*f*k2**2*(3292*r**2 + r*(6584*s - 4769) + 3292*s**2 - 4769*s + 1725) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2)**2) + Dd*f*(5*f*k2**2*(823*r + 823*s - 575) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k3**7) - 2*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(429*D1*bd1*f*(r + s - 1)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) - 49*K*r - 49*K*s + 18*K + 12*b1*(13*r + 13*s - 7) - 41*r - 41*s + 30) + k2**4*(-12*b1*(2*r + 2*s - 1) + (K - 1)*(r + s))) + 2*k2**2*(r + s)*(b1*k1**2*(39 - 71*K) - 7*b1*k2**2*(K - 1) + g2*(71*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(71*K - 39) + k2**2*(7*K - 7))) + Dd*f*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1)) - (r + s)*(k1**2*(71*K - 39) + k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(3*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(-92*r - 92*s + 54) + K*(49*r + 49*s - 18) + 41*r + 41*s - 30) - k2**4*(K - 1)*(r + s)) + 2*gd2*k2**2*(71*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*fd*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) + K*(-49*r - 49*s + 18) - 41*r - 41*s + 30) + k2**4*(K - 1)*(r + s)) + 2*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(75*f**2*fd*k2**2*(-40*k1**2*(4*r + 4*s - 3) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 13*f*(fd*k1**2*(k1**2*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(r + s - 1)) - 858*fd*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(75*f**2*(40*k1**2*k2**2*(4*r + 4*s - 3) - 13*k2**4*(17*r + 17*s - 11)) + 13*f*(k1**4*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) + 858*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s)))))/(1001*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**2*(4290*b1**3*k2**2*(k1**2 - 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(2*D1*(5*bd1*f*k2**2*(k1**2 - 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(20*C - 10)*(r + s - 1)**2 + k1**2*k2**2*(420*C*(r + s - 1)**2 + K*r**2 - 26*K*r*s - 120*K*r - 27*K*s**2 - 120*K*s + 60*K + f*(311*r**2 + 763*r*s - 351*r + 452*s**2 - 422*s + 93) - 230*r**2 - 436*r*s + 620*r - 206*s**2 + 620*s - 310) + k2**4*(f*(717*r**2 + r*(1473*s - 893) + 756*s**2 - 906*s + 309) + (-7*r - 7*s)*(r*(27*K - 33) + s*(15*K - 25))))) + Dd*f*(k1**4*(40*C - 20)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(840*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(8*r**2 - 2*r*(104*s + 243) - 216*s**2 - 318*s + 360) + f*(1244*r**2 + r*(3052*s - 1755) + 1808*s**2 - 2183*s + 619) - 1840*r**2 - 4*r*(872*s - 967) - 1648*s**2 + 3712*s - 1860) + k2**4*(f*(2868*r**2 + r*(5892*s - 3929) + 3024*s**2 - 3981*s + 1301) - 14*r**2*(108*K - 132) - 14*r*(168*K*s - 81*K - 232*s + 103) - 14*s*(60*K*s - 45*K - 100*s + 73)))) + 13*b1*(33*D1*bd1*f*(k1**4*(40*C - 20)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(840*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 4*K*(r**2 - 26*r*s - 31*r - 27*s**2 - 3*s + 30) + f*(622*r**2 + r*(1526*s - 1053) + 904*s**2 - 1339*s + 433) - 920*r**2 - 1744*r*s + 1544*r - 824*s**2 + 1440*s - 620) + k2**4*(f*(1434*r**2 + r*(2946*s - 2143) + 1512*s**2 - 2169*s + 683) - 28*r**2*(27*K - 33) - 28*r*(3*K*(14*s - 9) - 58*s + 34) - 28*s*(15*K*(s - 1) - 25*s + 24))) + 3*D1*(f**2*fd*k2**2*(k1**2*(13965*r**2 + 3*r*(7441*s - 5802) + 8358*s**2 - 14493*s + 5971) + 11*k2**2*(1800*r**2 + r*(2808*s - 2029) + 1008*s**2 - 1513*s + 653)) - 22*f*(fd*(k1**4*(2*C*(92*r**2 + 122*r*s - 23*r + 30*s**2 + 55*s - 45) - 92*r**2 + r*(37 - 150*s) - 58*s**2 - 29*s + 39) + k1**2*k2**2*(2*C*(734*r**2 + r*(1540*s - 643) + 806*s**2 - 679*s + 48) + K*(826*r**2 + 1424*r*s - 1037*r + 598*s**2 - 941*s + 312) - 1430*r**2 - 2998*r*s + 1392*r - 1568*s**2 + 1518*s - 237) + k2**4*(r**2*(350*K - 418) + r*(K*(544*s - 175) - 732*s + 209) + s*(K*(194*s - 103) - 314*s + 149))) - 2*k2**2*(r + s - 1)*(5*bd2*(k1**2 - 7*k2**2)*(r + s) + gd2*k1**2*(-r + 27*s + 60) + 21*gd2*k2**2*(9*r + 5*s))) + 44*fd*k2**2*(5*b2*(k1**2 - 7*k2**2)*(r + s)**2 + g2*k1**2*(-r**2 + 26*r*s + 120*r + 27*s**2 + 120*s - 60) + 21*g2*k2**2*(9*r**2 + 14*r*s + 5*s**2))) + Dd*f*(f**2*k2**2*(k1**2*(55860*r**2 + r*(89292*s - 74213) + 33432*s**2 - 61181*s + 26133) + 66*k2**2*(1200*r**2 + 8*r*(234*s - 173) + 672*s**2 - 1040*s + 389)) - 66*f*(2*k1**4*(4*C*(46*r**2 + r*(61*s - 33) + 15*s**2 + 12*s - 12) - 92*r**2 + r*(80 - 150*s) - 58*s**2 + 4*s + 17) + k1**2*k2**2*(2*C*(1468*r**2 + 11*r*(280*s - 183) + 1612*s**2 - 1965*s + 606) + K*(1652*r**2 + 2848*r*s - 2531*r + 1196*s**2 - 2203*s + 976) - 2860*r**2 - 5996*r*s + 4019*r - 3136*s**2 + 4051*s - 1318) + k2**4*(r**2*(700*K - 836) + r*(K*(1088*s - 513) - 1464*s + 643) + s*(K*(388*s - 297) - 628*s + 463))) + 132*k2**2*(4*r + 4*s - 3)*(5*b2*(k1**2 - 7*k2**2)*(r + s) + g2*k1**2*(-r + 27*s + 60) + 21*g2*k2**2*(9*r + 5*s)))) - f*(-13*D1*bd1*(f**2*k2**2*(k1**2*(13965*r**2 + r*(22323*s - 21995) + 8358*s**2 - 17702*s + 8220) + 33*k2**2*(600*r**2 + r*(936*s - 739) + 336*s**2 - 567*s + 125)) - 66*f*(k1**4*(2*C*(46*r**2 + r*(61*s - 68) + 15*s**2 - 17*s + 22) - 46*r**2 + r*(70 - 75*s) - 29*s**2 + 27*s - 24) + k1**2*k2**2*(2*C*(367*r**2 + r*(770*s - 697) + 403*s**2 - 655*s + 330) + K*(413*r**2 + 712*r*s - 747*r + 299*s**2 - 631*s + 332) - 715*r**2 - 1499*r*s + 1299*r - 784*s**2 + 1252*s - 584) + k2**4*(r**2*(175*K - 209) + r*(K*(272*s - 169) - 366*s + 217) + s*(97*K - 157)*(s - 1))) + 132*k2**2*(r + s - 1)*(5*b2*(k1**2 - 7*k2**2)*(r + s) - g2*k1**2*(r - 27*s) + 21*g2*k2**2*(9*r + 5*s))) + D1*(5*f**2*fd*k2**2*(4*k1**2*(7924*r**2 + r*(32364*s - 26033) + 24440*s**2 - 37861*s + 14788) + 39*k2**2*(972*r**2 + 3*r*(1300*s - 821) + 2928*s**2 - 3659*s + 1165)) + 26*f*(fd*k1**2*(k1**2*(2*C*(8190*r**2 + 9*r*(1679*s - 1247) + 6921*s**2 - 9090*s + 3413) - 8190*r**2 - 17001*r*s + 11853*r - 8811*s**2 + 10914*s - 3811) + 33*k2**2*(2*C*(1401*r**2 + 2868*r*s - 1908*r + 1467*s**2 - 1882*s + 626) - 1833*r**2 - 3831*r*s + 2541*r - 1998*s**2 + 2578*s - 855)) + 66*k2**2*(30*bd2*(k1**2*(r + s - 1) + k2**2*(r + s))*(r + s - 1) - gd2*(k1**2*(413*r**2 + r*(712*s - 747) + 299*s**2 - 631*s + 332) + k2**2*(175*r**2 + r*(272*s - 169) + s*(97*s - 97))))) + 1716*fd*k2**2*(30*b2*(k1**2*(r + s - 1) + k2**2*(r + s))*(2*r + 2*s - 1) - g2*(k1**2*(826*r**2 + r*(1424*s - 1037) + 598*s**2 - 941*s + 312) + k2**2*(350*r**2 + r*(544*s - 175) + s*(194*s - 103))))) + Dd*f*(5*f**2*k2**2*(4*k1**2*(7924*r**2 + r*(32364*s - 26033) + 24440*s**2 - 37861*s + 14788) + 39*k2**2*(972*r**2 + 3*r*(1300*s - 821) + 2928*s**2 - 3659*s + 1165)) + 26*f*k1**2*(2*k1**2*(4*C*(2730*r**2 + 5037*r*s - 4068*r + 2307*s**2 - 3272*s + 1276) - 5460*r**2 - 11334*r*s + 8716*r - 5874*s**2 + 7945*s - 2925) + 33*k2**2*(2*C*(1868*r**2 + 3824*r*s - 2781*r + 1956*s**2 - 2713*s + 968) - 2444*r**2 - 5108*r*s + 3735*r - 2664*s**2 + 3731*s - 1342)) + 1716*k2**2*(30*b2*(k1**2*(r + s - 1) + k2**2*(r + s))*(4*r + 4*s - 3) - g2*(k1**2*(1652*r**2 + r*(2848*s - 2531) + 1196*s**2 - 2203*s + 976) + k2**2*(700*r**2 + r*(1088*s - 513) + s*(388*s - 297)))))))/(9009*d**2*k3**5) + 4*D1**3*Pk1*Pkd3*ct**2*k2**2*st**4*(-132*b1**2*k1**2*(C - 1)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + 66*b1*f*(-2*D1*bd1*k1**2*(C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*fd*(k1**2*(r*(8*s - 3) + 8*s**2 - 6*s + 1) + 2*k2**2*r*(2*r + 2*s - 1)) + Dd*f*(k1**2*(2*r*(8*s - 3) + 16*s**2 - 13*s + 2) + 2*k2**2*r*(4*r + 4*s - 3))) - f**2*(-132*D1*bd1*(k1**2*s*(2*r + 2*s - 1) + k2**2*r*(r + s - 1)) + D1*fd*(k1**2*(120*C - 120)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(3*r - 1)*(3*r + 3*s - 13)) + Dd*f*k1**2*(60*C - 60)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + Dd*f*k2**2*(12*r**2 + 12*r*s - 45*r + 2*s + 8)))/(231*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**2*k2**2*st**4*(-17160*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 13*b1*f*(3*D1*(-440*bd1*k1**2*k2**2*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(5*f*k2**4*r*(89*r + 89*s - 63) + 88*k1**4*(2*C*(18*r*s - 7*r + 18*s**2 - 13*s + 2) - 28*r*s + 11*r - 28*s**2 + 20*s - 3) - 44*k1**2*k2**2*(r**2*(32*C - 62) + r*(4*C*(8*s - 3) - 92*s + 37) - 30*s**2 + 25*s - 5))) + Dd*f*(5*f*k2**4*(356*r**2 + r*(356*s - 293) - 17*s + 15) + 264*k1**4*(4*C*(18*r*s - 7*r + 18*s**2 - 14*s + 2) - 56*r*s + 22*r - 56*s**2 + 43*s - 6) - 132*k1**2*k2**2*(4*C*(16*r**2 + 2*r*(8*s - 5) - 5*s + 2) - 124*r**2 - 184*r*s + 105*r - 60*s**2 + 85*s - 23))) + f**2*(D1*(13*bd1*(5*f*k2**4*(89*r**2 + r*(89*s - 104) - 17*s + 15) + 528*k1**4*s*(C*(9*r + 9*s - 4) - 7*r - 7*s + 3) - 132*k1**2*k2**2*(4*C*(4*r**2 + r*(4*s - 6) - 5*s + 2) - 31*r**2 + r*(44 - 46*s) - 15*s**2 + 40*s - 13)) + fd*(f*k2**4*(26100*r**2 + r*(26100*s - 23201) - 5225*s + 3519) + k1**4*(19968*C - 13728)*(3*s - 1)*(3*r + 3*s - 2) - 52*k1**2*k2**2*(2*C*(1476*r**2 + 3*r*(777*s - 620) + 855*s**2 - 1347*s + 551) - 2988*r**2 - 9*r*(547*s - 422) - 1935*s**2 + 2931*s - 1149))) + Dd*f*(f*k2**4*(26100*r**2 + r*(26100*s - 23201) - 5225*s + 3519) + k1**4*(9984*C - 6864)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 52*k1**2*k2**2*(2*C*(1968*r**2 + r*(3108*s - 2542) + 1140*s**2 - 1840*s + 759) - 3984*r**2 + r*(5224 - 6564*s) - 2580*s**2 + 4037*s - 1610))))/(3003*d**2*k1**2*k3**5) - 2*D1**3*Pk1*Pkd3*ct**2*st**2*(D1*bd1*f**2*(2*k1**2*(r*(12*C*(3*s - 1) - 25*s + 9) + s*(6*C*(6*s - 5) - 25*s + 20)) + k2**2*(-2*r**2 - 2*r*s + 3*s)) + 2*b1**2*(D1*fd*(k1**2*(24*C - 25)*(s - 1) - 7*k2**2*r)*(r + s - 1) + Dd*f*(k1**2*(12*C*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 100*r*s + 68*r - 100*s**2 + 159*s - 59) - 7*k2**2*r*(4*r + 4*s - 3))) + b1*f*(2*D1*bd1*(k1**2*(12*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 50*r*s + 18*r - 50*s**2 + 59*s - 9) - 7*k2**2*r*(2*r + 2*s - 1)) + D1*fd*(2*k1**2*(6*C*(12*s - 7) - 50*s + 29) + k2**2*(3 - 4*r))*(r + s - 1) + Dd*f*(2*k1**2*(6*C*(24*r*s - 14*r + 24*s**2 - 35*s + 12) - 100*r*s + 58*r - 100*s**2 + 144*s - 49) + k2**2*(-8*r**2 + r*(12 - 8*s) + 9*s - 6))))/(21*d**2*k1**2*k3) + D1**3*Pk1*Pkd3*ct**2*(2*D1*bd1*f**2*(-k1**2*(r**2*(28*C - 14) + r*(-34*C*s - 36*C + 3*s + 20) + s*(-62*C*s + 22*C + 17*s + 1)) + 2*k2**2*r*(r + s + 5)) + b1**3*k2**2*(19*D1*fd*r*(r + s - 1) + Dd*f*(76*r**2 + r*(76*s - 55) + s - 1)) + b1**2*(D1*bd1*f*k2**2*(57*r**2 + r*(57*s - 36) + s - 1) + D1*fd*(k1**2*(196*C - 118)*(s - 1) + k2**2*(70*f*r - 59*f + 4*r - 4))*(r + s - 1) + 4*Dd*f*k1**2*(98*C*(2*s - 1)*(r + s - 1) - 118*r*s + 57*r - 118*s**2 + 176*s - 58) + Dd*f*k2**2*(f*(140*r**2 + r*(140*s - 223) - 123*s + 91) + 16*r**2 + 4*r*(4*s - 13) - 108*s + 64)) + 2*b1*f*(D1*bd1*(2*k1**2*(r*(98*C*s - 59*s - 2) + (s - 1)*(98*C*s - 59*s - 1)) + k2**2*(f*(35*r**2 + 35*r*s - 47*r - 32*s + 16) + 4*r**2 + 4*r*s + 2*r - 30*s + 8)) - D1*fd*(k1**2*(2*C*(28*r - 62*s - 7) - 28*r + 34*s + 21) - 2*k2**2*(2*r + 5))*(r + s - 1) - 2*Dd*f*(k1**2*(4*C*(14*r**2 - r*(17*s + 14) - 31*s**2 + 27*s - 1) - 28*r**2 + 6*r*(s + 7) + 34*s**2 - 14*s - 11) - k2**2*(4*r**2 + 4*r*s + 7*r + 5*s - 5))))/(21*d**2*k1**2*k3) + 2*D1**3*Pk1*Pkd3*ct**2*st**2*(11*b1**2*(D1*fd*(k1**4*(152*C - 102)*(s - 1)*(r + s - 1) - k1**2*k2**2*(r + s - 1)*(4*C*(26*r + 9*s - 9) - 99*r - 43*s + 43) + k2**4*r*(f*(78*r + 78*s - 61) + 14*r + 14*s)) + Dd*f*(k1**4*(16*C*(38*r*s - 25*r + 38*s**2 - 60*s + 22) - 408*r*s + 264*r - 408*s**2 + 642*s - 234) + k1**2*k2**2*(-8*C*(52*r**2 + 70*r*s - 76*r + 18*s**2 - 41*s + 23) + 396*r**2 + 568*r*s - 609*r + 172*s**2 - 371*s + 199) + k2**4*(f*(156*r**2 + 156*r*s - 131*r - 9*s + 8) + 14*r*(4*r + 4*s - 3)))) + b1*f*(11*D1*bd1*(k1**4*(16*C*(19*r*s - 6*r + 19*s**2 - 22*s + 3) - 204*r*s + 60*r - 204*s**2 + 234*s - 30) + k1**2*k2**2*(-8*C*(26*r**2 + 35*r*s - 41*r + 9*s**2 - 23*s + 14) + 198*r**2 + 284*r*s - 325*r + 86*s**2 - 199*s + 113) + k2**4*(f*(78*r**2 + 78*r*s - 70*r - 9*s + 8) + 28*r*(r + s - 1))) + D1*fd*(-22*k1**4*(2*C*(r*(32*s - 17) + 32*s**2 - 7*s - 7) + r*(17 - 32*s) - 32*s**2 + 2*s + 10) - 11*k1**2*k2**2*(2*C*(52*r**2 - 2*r*(37*s + 20) - 126*s**2 + 58*s + 23) - 34*r**2 + 6*r*(61*s - 8) + 400*s**2 - 261*s - 6) + k2**4*(f*(3*r - 1)*(519*r + 519*s - 416) + 308*r**2 + 22*r*(14*s - 5) - 33*s - 22)) + Dd*f*(k1**4*(22 - 44*C)*(r*(64*s - 34) + 64*s**2 - 63*s + 16) - 11*k1**2*k2**2*(C*(208*r**2 - 8*r*(37*s + 3) - 504*s**2 + 396*s - 42) - 68*r**2 + 732*r*s - 239*r + 800*s**2 - 693*s + 119) + k2**4*(f*(2076*r**2 + r*(2076*s - 2183) - 655*s + 484) + 616*r**2 + 88*r*(7*s - 5) - 99*s + 44))) + f**2*(D1*bd1*(-22*k1**4*(2*C*(16*r*s - 6*r + 16*s**2 - 35*s + 18) - 16*r*s + 6*r - 16*s**2 + 40*s - 21) - 11*k1**2*k2**2*(2*C*(26*r**2 - 37*r*s - 2*r - 63*s**2 + 55*s - 22) - 17*r**2 + 183*r*s - 38*r + 200*s**2 - 160*s + 53) + k2**4*(f*(519*r**2 + 519*r*s - 416*r - 136*s + 68) + 154*r**2 + 154*r*s - 165*r - 33*s + 33)) + D1*fd*(-2*k1**4*(6*C*(372*r*s - 179*r + 372*s**2 - 438*s + 123) - 1269*r*s + 610*r - 1269*s**2 + 1511*s - 425) + k1**2*k2**2*(-6*C*(183*r**2 - 543*r*s - 51*r - 726*s**2 + 500*s - 29) + 213*r**2 - 4665*r*s + 1182*r - 4878*s**2 + 4301*s - 791) + 132*k2**4*r*(3*r + 3*s - 2)) + Dd*f*(-6*k1**4*(2*C*(496*r*s - 258*r + 496*s**2 - 635*s + 196) - 564*r*s + 290*r - 564*s**2 + 728*s - 225) + k1**2*k2**2*(-6*C*(244*r**2 - 724*r*s - 13*r - 968*s**2 + 785*s - 72) + 284*r**2 - 6220*r*s + 2217*r - 6504*s**2 + 6609*s - 1473) + 132*k2**4*r*(4*r + 4*s - 3))))/(231*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**2*(-33*b1**3*k1**2*k2**2*(D1*fd*(r**2 + 9*r*(s - 1) + 8*(s - 1)**2) + Dd*f*(4*r**2 + r*(36*s - 77) + 32*s**2 - 77*s + 45)) + 33*b1**2*(D1*(-bd1*f*k1**2*k2**2*(3*r**2 + r*(27*s - 68) + 24*s**2 - 61*s + 37) + fd*(-44*f*k2**4*r*(3*r + 3*s - 2) + 2*k1**4*(r + s - 1)*(2*C*(10*r - 67*s + 67) - 10*r + 77*s - 77) + k1**2*k2**2*(196*C*(2*r**2 + 3*r*(s - 1) + (s - 1)**2) + 2*K*(21*r**2 + 8*r*(3*s - 7) + 3*s**2 - 38*s + 28) + f*(104*r**2 + r*(592*s - 141) + 488*s**2 - 481*s + 83) - 372*r**2 - 36*r*(15*s - 17) - 168*s**2 + 456*s - 236))) + 2*Dd*f*(2*k1**4*(4*C*(10*r**2 + r*(21 - 57*s) - 67*s**2 + 98*s - 31) - 20*r**2 + 2*r*(67*s - 25) + 154*s**2 - 225*s + 71) + k1**2*k2**2*(56*C*(14*r**2 + r*(21*s - 17) + 7*s**2 - 12*s + 5) + 84*K*r**2 + 96*K*r*s - 283*K*r + 12*K*s**2 - 283*K*s + 192*K + 2*f*(52*r**2 + 296*r*s - 103*r + 244*s**2 - 253*s + 51) - 744*r**2 - 1080*r*s + 1054*r - 336*s**2 + 808*s - 402) + k2**4*(-11*f*(4*r - 1)*(3*r + 3*s - 2) - 28*r + 14*s))) + b1*(33*D1*bd1*f*(4*k1**4*(2*C*(10*r**2 - 3*r*(19*s + 5) - 67*s**2 + 62*s + 5) - 10*r**2 + r*(67*s + 17) + 77*s**2 - 71*s - 6) + k1**2*k2**2*(56*C*(14*r**2 + r*(21*s - 13) + 7*s**2 - 10*s + 3) + 4*K*(21*r**2 + r*(24*s - 62) + 3*s**2 - 80*s + 41) + f*(104*r**2 + r*(592*s - 271) + 488*s**2 - 531*s + 121) - 744*r**2 - 8*r*(135*s - 101) - 336*s**2 + 680*s - 256) - 2*k2**4*(11*f*(2*r - 1)*(3*r + 3*s - 2) + 14*r - 14*s)) - 3*D1*(f**2*fd*k2**2*(-3*k1**2*(2245*r**2 + r*(5479*s - 4930) + 3234*s**2 - 6065*s + 2775) + 154*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 22*f*(fd*(2*k1**4*(2*C*(4*r**2 + 18*r*(s - 3) + 14*s**2 - 64*s + 43) - 4*r**2 - 18*r*(s - 3) - 14*s**2 + 72*s - 47) + k1**2*k2**2*(2*C*(98*r**2 + 5*r*(8*s - 27) - 58*s**2 - 31*s + 50) - K*(114*r**2 + 148*r*s - 173*r + 34*s**2 - 137*s + 58) + 34*r**2 + 366*r*s - 22*r + 332*s**2 - 252*s + 1) + 2*k2**4*(2*r**2 + r*(2*s - 1) + 5*s)) - k1**2*k2**2*(bd2*(5*r + 5*s + 2) + 2*gd2*(21*r + 3*s - 82))*(r + s - 1)) + 22*fd*k1**2*k2**2*(b2*(5*r**2 + 2*r*(5*s + 2) + 5*s**2 + 4*s - 2) + 2*g2*(21*r**2 + 8*r*(3*s - 7) + 3*s**2 - 38*s + 28))) + Dd*f*(f**2*k2**2*(k1**2*(26940*r**2 + r*(65748*s - 59231) + 38808*s**2 - 70871*s + 30639) - 462*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 66*f*(2*k1**4*(2*C*(8*r**2 + 4*r*(9*s - 19) + 28*s**2 - 116*s + 65) - 8*r**2 + r*(76 - 36*s) - 28*s**2 + 128*s - 71) + k1**2*k2**2*(2*C*(196*r**2 + r*(80*s - 143) - 116*s**2 + 17*s + 34) - K*(228*r**2 + 296*r*s - 419*r + 68*s**2 - 299*s + 186) + 68*r**2 + 732*r*s - 397*r + 664*s**2 - 713*s + 194) + 2*k2**4*(4*r**2 + r*(4*s - 13) + 5*s)) - 66*k1**2*k2**2*(b2*(20*r**2 + r*(40*s - 7) + 20*s**2 - 7*s - 6) + 2*g2*(84*r**2 + r*(96*s - 283) + 12*s**2 - 283*s + 192)))) + f*(D1*bd1*(f**2*k2**2*(k1**2*(6735*r**2 + r*(16437*s - 14861) + 9702*s**2 - 16286*s + 5664) - 462*k2**2*r*(3*r + 3*s - 2)) + 66*f*(2*k1**4*(2*C*(2*r**2 + r*(9*s - 2) + 7*s**2 - 21*s - 2) - 2*r**2 + r*(2 - 9*s) - 7*s**2 + 22*s + 3) + k1**2*k2**2*(C*(98*r**2 + 10*r*(4*s + 5) - 58*s**2 + 58*s - 52) - K*(57*r**2 + 74*r*s - 123*r + 17*s**2 - 81*s + 64) + 17*r**2 + 183*r*s - 209*r + 166*s**2 - 210*s + 108) + 2*k2**4*r*(r + s - 6)) - 66*k1**2*k2**2*(5*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 6*g2*(7*r**2 + r*(8*s - 7) + s*(s - 25)))) - 2*k1**2*(D1*(f*(fd*(k1**2*(2*C*(4140*r**2 + 5031*r*s - 5163*r + 891*s**2 - 1842*s + 1217) - 4140*r**2 - 6921*r*s + 5793*r - 2781*s**2 + 3666*s - 1615) + 33*k2**2*(2*C*(117*r**2 + 315*r*s - 183*r + 198*s**2 - 204*s + 59) - 279*r**2 - 765*r*s + 415*r - 486*s**2 + 506*s - 137)) + k2**2*(33*bd2 - 66*gd2)*(57*r**2 + r*(74*s - 123) + 17*s**2 - 81*s + 64)) + 33*fd*k2**2*(b2 - 2*g2)*(114*r**2 + r*(148*s - 173) + 34*s**2 - 137*s + 58)) + Dd*f*(f*(2*k1**2*(2*C*(2760*r**2 + 3354*r*s - 3651*r + 594*s**2 - 1267*s + 806) - 2760*r**2 - 4614*r*s + 4231*r - 1854*s**2 + 2668*s - 1179) + 33*k2**2*(2*C*(156*r**2 + 5*r*(84*s - 55) + 264*s**2 - 303*s + 92) - 372*r**2 - 1020*r*s + 657*r - 648*s**2 + 765*s - 234)) + k2**2*(33*b2 - 66*g2)*(228*r**2 + r*(296*s - 419) + 68*s**2 - 299*s + 186)))))/(693*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*ct**2*st**2*(39*D1*bd1*f*(f**2*k2**4*(k1**2*(4848*r**2 + r*(8616*s - 6133) + 3768*s**2 - 5849*s + 1343) - 66*k2**2*(r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(4*k1**4*(4*C*(r*(31*s - 12) + 31*s**2 - 40*s + 12) - 3*r*(23*s - 9) - 69*s**2 + 90*s - 27) - 2*k1**2*k2**2*(2*C*(388*r**2 + r*(979*s - 681) + 591*s**2 - 734*s + 293) - 511*r**2 + r*(910 - 1361*s) - 850*s**2 + 1015*s - 399) + k2**4*(4*C*(142*r**2 + r*(203*s - 190) + 61*s**2 - 121*s + 48) - 2*K*(99*r**2 + 2*r*(79*s - 56) + 59*s**2 - 80*s + 21) + b1*(1086*r**2 + r*(2214*s - 1631) + 1128*s**2 - 1629*s + 523) - 306*r**2 - 2*r*(196*s - 223) - 86*s**2 + 254*s - 132)) + 22*k1**2*k2**2*(-30*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + b1*(k1**2*(330*C - 235)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k2**2*(70*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-230*r**2 - 360*r*s + 179*r - 130*s**2 + 171*s + 5) + 266*r**2 + 456*r*s - 151*r + 190*s**2 - 155*s - 75)) + 2*k2**2*(-15*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(115*r**2 + 5*r*(36*s - 23) + s*(65*s - 111))))) - 25740*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k1**2*k2**2*(2*D1*fd*(k1**2*(330*C - 235)*(r + s - 1)**2 + k2**2*(70*C*(r + s - 1)**2 - 115*K*r**2 - 180*K*r*s - 10*K*r - 65*K*s**2 - 10*K*s + 5*K + f*(543*r**2 + 1107*r*s - 694*r + 564*s**2 - 699*s + 246) + 133*r**2 + 228*r*s + 150*r + 95*s**2 + 150*s - 75)) + Dd*f*(k1**2*(660*C - 470)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*K*(-460*r**2 - 720*r*s + 233*r - 260*s**2 + 221*s + 15) + f*(2172*r**2 + r*(4428*s - 3019) + 2256*s**2 - 3027*s + 1015) + 1064*r**2 + 1824*r*s - 38*r + 760*s**2 - 50*s - 450))) + 39*b1*(D1*(3*f**2*fd*k2**4*(k1**2*(4848*r**2 + r*(8616*s - 5769) + 3768*s**2 - 5137*s + 1953) - 66*k2**2*r*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*(2*k1**4*(4*C*(r*(62*s - 35) + 62*s**2 - 71*s + 20) - 3*r*(46*s - 26) - 138*s**2 + 159*s - 45) + k1**2*k2**2*(-2*C*(776*r**2 + 1958*r*s - 831*r + 1182*s**2 - 951*s + 120) + 1022*r**2 + r*(2722*s - 1175) + 1700*s**2 - 1392*s + 191) + k2**4*(C*(568*r**2 + 28*r*(29*s - 14) + 244*s**2 - 224*s + 46) - K*(198*r**2 + 316*r*s - 189*r + 118*s**2 - 133*s + 45) - 306*r**2 - 392*r*s + 183*r - 86*s**2 + 78*s - 7)) + 2*k2**4*(-15*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(115*r**2 + 4*r*(45*s - 16) + 65*s**2 - 60*s - 5))) + 220*fd*k1**2*k2**4*(-3*b2*(r + s)**2 + g2*(23*r**2 + r*(36*s + 2) + 13*s**2 + 2*s - 1))) + 2*Dd*f*(f**2*k2**4*(k1**2*(9696*r**2 + 8*r*(2154*s - 1465) + 7536*s**2 - 10630*s + 3601) - 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**4*(8*C*(r*(62*s - 35) + 62*s**2 - 81*s + 26) + (23*s - 13)*(-12*r - 12*s + 9)) + k1**2*k2**2*(-2*C*(1552*r**2 + r*(3916*s - 2290) + 2364*s**2 - 2516*s + 653) + 2044*r**2 + r*(5444*s - 3181) + 3400*s**2 - 3608*s + 941) + k2**4*(2*C*(568*r**2 + r*(812*s - 544) + 244*s**2 - 322*s + 99) - K*(396*r**2 + 632*r*s - 413*r + 236*s**2 - 293*s + 87) - 612*r**2 - 784*r*s + 577*r - 172*s**2 + 280*s - 105)) + 22*k1**2*k2**4*(-15*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(460*r**2 + r*(720*s - 233) + 260*s**2 - 221*s - 15)))) + f*(D1*(f**2*fd*k2**4*(k1**2*(238500*r**2 + r*(138036*s - 228581) - 100464*s**2 + 1683*s + 49259) - 1482*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(fd*(6*k1**4*(2*C*(1422*r*s - 683*r + 1422*s**2 - 1708*s + 481) - 1575*r*s + 756*r - 1575*s**2 + 1905*s - 537) + k1**2*k2**2*(-2*C*(22293*r**2 + 61551*r*s - 33663*r + 39258*s**2 - 43818*s + 12149) + 28674*r**2 + 81891*r*s - 45819*r + 53217*s**2 - 60564*s + 17263) + 33*k2**4*(2*C*(459*r**2 + 63*r*(11*s - 7) + 234*s**2 - 294*s + 91) - 891*r**2 - 1404*r*s + 903*r - 513*s**2 + 651*s - 206)) - 33*k2**4*(15*bd2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*gd2*(99*r**2 + 2*r*(79*s - 56) + 59*s**2 - 80*s + 21))) - 858*fd*k1**2*k2**4*(15*b2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1) - 2*g2*(198*r**2 + r*(316*s - 189) + 118*s**2 - 133*s + 45))) + Dd*f*(f**2*k2**4*(k1**2*(238500*r**2 + r*(138036*s - 228581) - 100464*s**2 + 1683*s + 49259) - 1482*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 26*f*k1**2*(18*k1**4*(2*C*(632*r*s - 322*r + 632*s**2 - 821*s + 254) - 700*r*s + 354*r - 700*s**2 + 914*s - 283) - 2*k1**2*k2**2*(C*(29724*r**2 + 82068*r*s - 49719*r + 52344*s**2 - 63965*s + 19210) - 19116*r**2 - 54594*r*s + 34080*r - 35478*s**2 + 44303*s - 13783) + 33*k2**4*(2*C*(612*r**2 + 924*r*s - 625*r + 312*s**2 - 411*s + 130) - 1188*r**2 - 1872*r*s + 1283*r - 684*s**2 + 915*s - 299)) - 858*k1**2*k2**4*(15*b2*(3*r + 3*s - 1) - 2*g2*(99*r + 59*s - 29))*(4*r + 4*s - 3))))/(9009*d**2*k1**2*k3**5) - 5*D1**3*Pk1*Pkd3*ct*f*k2**5*st**6*(13*D1*bd1*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(r + s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 3) + 27*s**2 - 3*s - 10) + k1**2*(264*C - 198)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - f*(D1*fd*(3*f*k2**2*(276*r**2 + r*(552*s - 427) + 276*s**2 - 427*s + 165) + k1**2*(78 - 104*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(69*r + 69*s - 55) + k1**2*(78 - 104*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k1*k3**7) - 20*D1**3*Pk1*Pkd3*ct*f*k2**3*st**6*(33*D1*bd1*f*(r*(4*s - 1) + (1 - 2*s)**2) + 33*b1*(2*s - 1)*(2*D1*fd*(2*r + 2*s - 1) + Dd*f*(8*r + 8*s - 5)) + f*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(24*r*s - 10*r + 24*s**2 - 27*s + 7)))/(693*d**2*k1*k3**3) - 10*D1**3*Pk1*Pkd3*ct*f*k2**3*st**6*(33*D1*bd1*f*(k1**2*(8*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(-4*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9)) + 33*b1*(D1*fd*(k1**2*(16*C - 12)*(2*s - 1) + k2**2*(r*(26 - 16*C) + 10*s - 5))*(2*r + 2*s - 1) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(C*(-64*r**2 + r*(48 - 64*s) + 8*s - 4) + 104*r**2 + 2*r*(72*s - 49) + 40*s**2 - 58*s + 19))) + f*(D1*fd*(k1**2*(16*C - 12)*(3*s - 1) + k2**2*(-24*C*r + 8*C + 39*r + 15*s - 18))*(3*r + 3*s - 2) + Dd*f*(k1**2*(8*C - 6)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(-4*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 156*r**2 + 216*r*s - 181*r + 60*s**2 - 113*s + 50))))/(693*d**2*k1*k3**5) + 2*D1**3*Pk1*Pkd3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*(k1**2*(-12*C*(r + s - 1) - 12*K*r - 12*K*s + 6*K + b1*(4*r + 4*s - 2) + 8*r + 8*s - 7) + 6*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(132*b1*k1**2*(1 - 6*K) + 924*b1*k2**2*(1 - 4*K) + 792*g2*k1**2 + 3696*g2*k2**2)) + 66*b1**2*(D1*fd*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(6*K - 1) + k2**2*(28*K - 7))) + Dd*f*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5)) - (r + s)*(k1**2*(6*K - 1) + k2**2*(28*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*(fd*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s))*(2*r + 2*s - 1) - 4*gd2*(3*k1**2 + 14*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*(3*k1**2 + 14*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) - 66*f*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s)) + 264*g2*(3*k1**2 + 14*k2**2)*(r + s))) - 2*f*(D1*(140*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 33*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 12*gd2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))*(r + s - 1) - 396*fd*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k2**2*(r + s - 1) + f*k1**2*(330*C - 165)*(r + s - 1) - 396*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))))/(77*d**2*k3**7) + D1**3*Pk1*Pkd3*ct*k1*k2*st**2*(-39*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 32*K*r + 32*K*s - 12*K + b1*(-69*r - 69*s + 39) + 19*r + 19*s - 15) + k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) - 44*k2**2*(r + s)*(13*b1*k1**2*(4*K - 1) + 7*b1*k2**2*(2*K - 1) - 2*g2*(26*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(-3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7))*(2*r + 2*s - 1) + (r + s)**2*(2*k1**2*(52*K - 13) + 2*k2**2*(14*K - 7))) - Dd*f*(3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7)) + (r + s)*(-2*k1**2*(52*K - 13) - 2*k2**2*(14*K - 7)))*(4*r + 4*s - 3)) - 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 22*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) - 4*gd2*k2**2*(26*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 88*fd*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) + 88*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(8*k1**2*(17*r + 17*s - 16) - 117*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 26*f*(fd*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 132*gd2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(r + s - 1)) + 3432*fd*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(8*k1**2*(17*r + 17*s - 16) - 117*k2**2*(7*r + 7*s - 5)) + 26*f*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 3432*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s)))))/(1001*d**2*k3**7) + 2*D1**3*Pk1*Pkd3*ct*k1*(165*b1**3*k2**2*(2*k1**2 + 21*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(5*D1*bd1*f*(2*k1**2 + 21*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + D1*fd*(k1**2*(-140*C*(r + s - 1)**2 + 8*K*(11*r**2 + 22*r*s + 10*r + 11*s**2 + 10*s - 5) - f*(90*r**2 + 3*r*(100*s - 49) + 210*s**2 - 203*s + 39) + 52*r**2 + 88*r*s - 160*r + 36*s**2 - 160*s + 80) - k2**2*(f*(396*r**2 + r*(870*s - 431) + 474*s**2 - 457*s + 95) + (-7*r - 7*s)*(r*(42*K - 21) + s*(30*K - 17)))) - Dd*f*(k1**2*(140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 8*K*(44*r**2 + 88*r*s - 13*r + 44*s**2 - 13*s - 15) + f*(180*r**2 + r*(600*s - 379) + 420*s**2 - 539*s + 173) - 208*r**2 - 352*r*s + 460*r - 144*s**2 + 436*s - 240) + k2**2*(2*f*(396*r**2 + 10*r*(87*s - 56) + 474*s**2 - 586*s + 181) - 7*r**2*(168*K - 84) - 7*r*(18*K*(16*s - 7) - 152*s + 71) - 7*s*(30*K*(4*s - 3) - 68*s + 47)))) - b1*(3*D1*(f**2*k2**2*(22*bd1*k1**2*(45*r**2 + 2*r*(75*s - 58) + 105*s**2 - 168*s + 67) + 11*bd1*k2**2*(396*r**2 + r*(870*s - 689) + 474*s**2 - 715*s + 267) + fd*k1**2*(2625*r**2 + r*(5850*s - 4151) + 3225*s**2 - 4551*s + 1608) + 11*fd*k2**2*(669*r**2 + 2*r*(597*s - 410) + 525*s**2 - 682*s + 249)) - 11*f*(fd*(k1**4*(4*C - 2)*(2*s - 1)*(3*r + 3*s - 1) + k1**2*k2**2*(4*C*(74*r**2 + r*(202*s - 96) + 128*s**2 - 136*s + 21) + 2*K*(334*r**2 + 598*r*s - 345*r + 264*s**2 - 315*s + 89) - 316*r**2 - 802*r*s + 373*r - 486*s**2 + 511*s - 103) + k2**4*(r**2*(544*K - 270) + r*(4*K*(233*s - 68) - 488*s + 135) + s*(4*K*(97*s - 50) - 218*s + 87))) + 2*k2**2*(bd1*(-2*k1**2*(35*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*K*(22*r**2 + r*(44*s - 17) + 22*s**2 - 17*s - 5) - 26*r**2 - 44*r*(s - 1) - 18*s**2 + 40*s - 20) + 7*k2**2*(r**2*(42*K - 21) + r*(6*K*(12*s - 7) - 38*s + 23) + s*(30*K*(s - 1) - 17*s + 15))) + (-2*r - 2*s + 2)*(-5*bd2*(2*k1**2 + 7*k2**2)*(r + s) + 4*gd2*k1**2*(11*r + 11*s + 5) + 21*gd2*k2**2*(7*r + 5*s)))) + 44*fd*k2**2*(-5*b2*(2*k1**2 + 7*k2**2)*(r + s)**2 + 4*g2*k1**2*(11*r**2 + 2*r*(11*s + 5) + 11*s**2 + 10*s - 5) + 21*g2*k2**2*(7*r**2 + 12*r*s + 5*s**2))) + Dd*f*(f**2*k2**2*(k1**2*(10500*r**2 + r*(23400*s - 18119) + 12900*s**2 - 19819*s + 7633) + 33*k2**2*(892*r**2 + r*(1592*s - 1169) + 700*s**2 - 985*s + 355)) - 33*f*(k1**4*(8*C - 4)*(2*s - 1)*(3*r + 3*s - 1) + 2*k1**2*k2**2*(C*(296*r**2 + r*(808*s - 578) + 512*s**2 - 714*s + 254) + K*(668*r**2 + 1196*r*s - 867*r + 528*s**2 - 767*s + 277) - 316*r**2 - 802*r*s + 530*r - 486*s**2 + 650*s - 216) + k2**4*(r**2*(1088*K - 540) + r*(4*K*(466*s - 201) - 976*s + 449) + s*(K*(776*s - 588) - 436*s + 305))) + 132*k2**2*(4*r + 4*s - 3)*(-5*b2*(2*k1**2 + 7*k2**2)*(r + s) + 4*g2*k1**2*(11*r + 11*s + 5) + 21*g2*k2**2*(7*r + 5*s)))) + f*(D1*(f**2*k2**2*(-bd1*(k1**2*(2625*r**2 + 5850*r*s - 5666*r + 3225*s**2 - 6166*s + 2809) + 33*k2**2*(223*r**2 + 398*r*s - 349*r + 175*s**2 - 303*s + 106)) + 20*fd*(k1**2*(7*r*(26*s - 21) + 182*s**2 - 281*s + 109) + k2**2*(142*r**2 + r*(691*s - 452) + 549*s**2 - 737*s + 249))) + 33*f*(2*bd1*k1**4*s*(2*C - 1)*(3*r + 3*s - 1) + bd1*k1**2*k2**2*(4*C*(37*r**2 + r*(101*s - 92) + 64*s**2 - 106*s + 55) + 2*K*(167*r**2 + 299*r*s - 261*r + 132*s**2 - 226*s + 94) - 158*r**2 - 401*r*s + 322*r - 243*s**2 + 373*s - 156) + bd1*k2**4*(r**2*(272*K - 135) + r*(K*(466*s - 266) - 244*s + 157) + s*(194*K - 109)*(s - 1)) + 40*bd2*k2**2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(r + s - 1) + fd*k1**4*(4*C - 2)*(3*s - 1)*(5*r + 5*s - 3) + fd*k1**2*k2**2*(4*C*(171*r**2 + r*(408*s - 287) + 237*s**2 - 330*s + 115) - 372*r**2 + r*(615 - 909*s) - 537*s**2 + 744*s - 251) - 4*gd2*k2**2*(k1**2*(167*r**2 + r*(299*s - 261) + 132*s**2 - 226*s + 94) + k2**2*(136*r**2 + r*(233*s - 133) + s*(97*s - 97)))) + 132*k2**2*(5*b2*(bd1*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*fd*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(2*r + 2*s - 1)) - g2*(bd1*(44*k1**2*(r + s) + 21*k2**2*(7*r + 5*s))*(r + s - 1) + fd*(k1**2*(334*r**2 + 23*r*(26*s - 15) + 264*s**2 - 315*s + 89) + 2*k2**2*(136*r**2 + r*(233*s - 68) + s*(97*s - 50)))))) + 2*Dd*f*(10*f**2*k2**2*(k1**2*(7*r*(26*s - 21) + 182*s**2 - 281*s + 109) + k2**2*(142*r**2 + r*(691*s - 452) + 549*s**2 - 737*s + 249)) + 33*f*k1**2*(k1**2*(4*C - 2)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(2*C*(228*r**2 + 544*r*s - 423*r + 316*s**2 - 477*s + 183) - 248*r**2 - 606*r*s + 459*r - 358*s**2 + 540*s - 204)) + 66*k2**2*(10*b2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(4*r + 4*s - 3) - g2*(k1**2*(668*r**2 + r*(1196*s - 867) + 528*s**2 - 767*s + 277) + 2*k2**2*(272*r**2 + r*(466*s - 201) + s*(194*s - 147)))))))/(693*d**2*k2*k3**5) - 6*D1**3*Pk1*Pkd3*ct*k2**3*st**4*(-26*D1*bd1*f*k1**2*(r + s - 1)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(b1*(-7*r - 7*s + 3) + (4*C - 3)*(2*r + 2*s - 1))) + k2**2*(r + s)*(-132*K*b1 + 66*b1 + 132*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) + (4*K - 2)*(r + s)**2) + Dd*f*(f*(7*r + 7*s - 3) + (4*K - 2)*(r + s))*(4*r + 4*s - 3)) - 26*b1*k1**2*(D1*(25*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 33*f*(fd*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 4*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1)) + 132*g2*k2**2*(r + s))) + f**2*(D1*fd*(-f*k1**2*k2**2*(9812*r**2 + r*(19624*s - 14315) + 9812*s**2 - 14315*s + 5217) + 65*f*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + k1**4*(988 - 1664*C)*(3*r + 3*s - 2)**2) - Dd*f*(4*r + 4*s - 3)*(f*k1**2*k2**2*(2453*r + 2453*s - 1739) - 65*f*k2**4*(5*r + 5*s - 3) + k1**4*(1664*C - 988)*(3*r + 3*s - 2))))/(1001*d**2*k1*k3**7) - 4*D1**3*Pk1*Pkd3*ct*k2*st**4*(33*b1**2*(D1*fd*(k1**2*(16*C - 12)*(s - 1) + k2**2*(r*(9 - 8*C) + s - 1))*(r + s - 1) + Dd*f*(k1**2*(8*C - 6)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k2**2*(-4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 36*r**2 + r*(40*s - 39) + 4*s**2 - 11*s + 7))) + 33*b1*f*(D1*bd1*(k1**2*(8*C - 6)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k2**2*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*r**2 + r*(20*s - 19) + 2*s**2 - 7*s + 5)) + D1*fd*(2*k1**2*(2*C*(8*r*s - 3*r + 8*s**2 - 6*s + 1) - 10*r*s + 4*r - 10*s**2 + 7*s - 1) + k2**2*(8*r**2 + r*(4*s - 1) - (1 - 2*s)**2)) + Dd*f*(2*k1**2*(2*C*(16*r*s - 6*r + 16*s**2 - 13*s + 2) - 20*r*s + 8*r - 20*s**2 + 15*s - 2) + k2**2*(16*r**2 + r*(8*s - 6) + s*(3 - 8*s)))) + 2*f**2*(33*D1*bd1*(k1**2*s*(C*(8*r + 8*s - 4) - 5*r - 5*s + 2) + k2**2*(2*r**2 + r*(s - 3) - s**2 - 2*s + 1)) + D1*fd*(k1**2*(60*C - 36)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(C*(3*r - 1)*(27*r + 27*s - 7) + 36*r**2 + r*(81*s - 84) + 45*s**2 - 57*s + 29)) + Dd*f*k1**2*(30*C - 18)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + Dd*f*k2**2*(C*(108*r**2 + 3*r*(36*s - 25) - 37*s + 17) + 48*r**2 + 2*r*(54*s - 53) + 60*s**2 - 76*s + 33)))/(231*d**2*k1*k3**3) + 2*D1**3*Pk1*Pkd3*ct*k2*st**4*(D1*f*(-3432*bd1*g2*k2**4*(2*r**2 + 2*r*(s - 1) - s) + f**2*k2**4*(13*bd1*(363*r**2 + r*(498*s - 392) + 135*s**2 - 92*s + 9) + fd*(13396*r**2 + r*(10016*s - 9639) - 3380*s**2 + 2605*s - 137)) + 26*f*(33*bd1*(2*k1**4*s*(4*C*(3*r + 3*s - 1) - 7*r - 7*s + 2) + k1**2*k2**2*(-2*C*(33*r**2 + 46*r*s - 42*r + 13*s**2 - 32*s + 9) + 46*r**2 + 64*r*s - 57*r + 18*s**2 - 45*s + 11) + k2**4*(-4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 26*r**2 + 36*r*s - 35*r + 10*s**2 - 23*s + 9)) + 2*fd*k1**2*(k1**2*(84*C - 48)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(-C*(1629*r**2 + 9*r*(313*s - 236) + 1188*s**2 - 1731*s + 659) + 1134*r**2 + 18*r*(109*s - 82) + 828*s**2 - 1206*s + 458)))) + Dd*f**3*(f*k2**4*(13396*r**2 + r*(10016*s - 9639) - 3380*s**2 + 2605*s - 137) + k1**4*(2184*C - 1248)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 52*k1**2*k2**2*(C*(2172*r**2 + 3*r*(1252*s - 977) + 1584*s**2 - 2399*s + 931) - 1512*r**2 - 2*r*(1308*s - 1019) - 1104*s**2 + 1672*s - 648)) + 429*b1**2*k2**2*(D1*fd*(k1**2*(30 - 40*C)*(r + s - 1)**2 + k2**2*(5*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + (r + s)*(2*r*(4*K - 9) - 10*s))) + 2*Dd*f*(k1**2*(15 - 20*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(5*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + r**2*(16*K - 36) + r*(16*K*s - 8*K - 56*s + 23) + s*(-2*K - 20*s + 17)))) + 13*b1*(3*D1*(f**2*k2**4*(55*bd1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 3*fd*(121*r**2 + r*(166*s - 149) + 45*s**2 - 69*s + 34)) + 22*f*(-5*bd1*k1**2*k2**2*(4*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*bd1*k2**4*(r**2*(4*K - 9) + r*(K*(4*s - 3) - 14*s + 8) - s*(K + 5*s - 6)) + fd*(2*k1**4*(2*C*(12*r*s - 5*r + 12*s**2 - 8*s + 1) - 14*r*s + 6*r - 14*s**2 + 9*s - 1) + k1**2*k2**2*(-2*C*(66*r**2 + 92*r*s - 35*r + 26*s**2 - 19*s + 3) + 92*r**2 + 128*r*s - 43*r + 36*s**2 - 22*s + 2) - k2**4*(2*r + 2*s - 1)*(r*(16*C - 26) - 10*s + 5)) - 4*gd2*k2**4*r*(2*r + 2*s - 1)) - 176*fd*g2*k2**4*r*(r + s)) + Dd*f*(f**2*k2**4*(1452*r**2 + r*(1992*s - 1733) + 540*s**2 - 713*s + 315) + 66*f*(k1**4*(C*(8*r*(12*s - 5) + 96*s**2 - 68*s + 8) - 8*r*(7*s - 3) - 56*s**2 + 38*s - 4) + k1**2*k2**2*(-2*C*(132*r**2 + r*(184*s - 103) + 52*s**2 - 67*s + 15) + 184*r**2 + 4*r*(64*s - 33) + 72*s**2 - 87*s + 15) + k2**4*(C*(-64*r**2 + r*(48 - 64*s) + 8*s - 4) + 104*r**2 + 2*r*(72*s - 49) + 40*s**2 - 58*s + 19)) - 264*g2*k2**4*(8*r**2 + r*(8*s - 4) - s))))/(3003*d**2*k1*k3**5) - 2*D1**3*Pk1*Pkd3*ct*st**2*(D1*bd1*f**2*(k1**2*(4*C - 2)*(r*(7*s - 3) + s*(7*s - 5)) + k2**2*(r**2*(12*C + 1) + 4*r*(3*C*s - C + 3*s - 2) + s*(-12*C + 11*s - 5))) + b1**2*(D1*fd*(k1**2*(52*C - 26)*(s - 1) + k2**2*(9*r - s + 1))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(4*r*(13*s - 8) + 52*s**2 - 81*s + 29) + k2**2*(36*r**2 + r*(32*s - 61) - 4*s**2 - 12*s + 16))) + b1*f*(D1*bd1*(k1**2*(4*C - 2)*(r*(26*s - 6) + 26*s**2 - 29*s + 3) + k2**2*(18*r**2 + r*(16*s - 45) - 2*s**2 - 16*s + 18)) + D1*fd*(k1**2*(8*C - 4)*(7*s - 4) + k2**2*(8*C*(3*r - 2) + 2*r + 22*s - 13))*(r + s - 1) + Dd*f*(k1**2*(4*C - 2)*(4*r*(7*s - 4) + 28*s**2 - 39*s + 13) + k2**2*(4*C*(12*r**2 + 12*r*s - 17*r - 10*s + 7) + 4*r**2 + 48*r*s - 29*r + 44*s**2 - 56*s + 18))))/(21*d**2*k1*k2*k3) - 2*D1**3*Pk1*Pkd3*ct*(D1*bd1*f*(6*b2*k2**2*(r**2 + r*(s - 1) - 4*s) + f*(k1**2*s*(12*C - 6)*(r + s - 1) + k2**2*(r**2*(4*C - 14) + r*(4*C*(s - 1) - 39*s + 2) - s*(25*s - 25))) - 12*g2*k2**2*(r**2 + r*(s - 1) - 4*s)) + b1**3*k2**2*(D1*fd*(r**2 - 6*r*(s - 1) - 7*(s - 1)**2) + Dd*f*(4*r**2 + r*(17 - 24*s) - 28*s**2 + 45*s - 17)) - b1**2*(D1*bd1*f*k2**2*(-3*r**2 + r*(18*s - 11) + 21*s**2 - 31*s + 10) + D1*fd*(k1**2*(28*C - 14)*(s - 1) + k2**2*(-6*K*r + 6*K + f*(26*r + 30*s - 52) + 16*r + 25*s - 23))*(r + s - 1) + Dd*f*k1**2*(56*C - 28)*(2*s - 1)*(r + s - 1) + Dd*f*k2**2*(-6*K*(4*r**2 + 4*r*s - 13*r - 13*s + 9) + f*(52*r**2 + r*(112*s - 143) + 60*s**2 - 159*s + 83) + 64*r**2 + 164*r*s - 142*r + 100*s**2 - 212*s + 92)) + b1*(-D1*(bd1*f**2*k2**2*(26*r**2 + r*(56*s - 65) + 30*s**2 - 77*s + 31) + f*(28*bd1*k1**2*s*(2*C - 1)*(r + s - 1) + 2*bd1*k2**2*(-6*K*(r**2 + r*(s - 3) - 4*s + 2) + 16*r**2 + r*(41*s - 21) + 25*s**2 - 47*s + 12) - fd*(k1**2*(12*C - 6)*(2*s - 1) + k2**2*(C*(8*r - 4) - 28*r - 50*s + 27))*(r + s - 1) + k2**2*(-6*bd2 + 12*gd2)*(r - 4)*(r + s - 1)) - 6*fd*k2**2*(b2 - 2*g2)*(r - 1)*(r + s - 1)) + 2*Dd*f*(2*f*(k1**2*(6*C - 3)*(2*s - 1)*(r + s - 1) + k2**2*(C*(4*r - 1)*(r + s - 1) - 14*r**2 + r*(24 - 39*s) - 25*s**2 + 38*s - 13)) + k2**2*(3*b2 - 6*g2)*(4*r**2 + r*(4*s - 13) - 13*s + 9))))/(21*d**2*k1*k2*k3) + D1**3*Pk1*Pkd3*ct*st**2*(33*D1*b1*bd1*f*(k1**4*(8*C - 4)*(r*(26*s - 6) + 26*s**2 - 29*s + 3) - 2*k1**2*k2**2*(2*C*(130*r**2 + r*(160*s - 187) + 30*s**2 - 91*s + 61) - 158*r**2 + r*(247 - 196*s) - 38*s**2 + 122*s - 84) - k2**4*(56*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 4*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + f*(-66*r**2 + r*(12*s + 19) + 78*s**2 - 149*s + 47) - 164*r**2 - 88*r*s + 212*r + 76*s**2 - 24*s - 76)) + 429*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(13*bd1*f*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*fd*(k1**4*(52*C - 26)*(s - 1)*(r + s - 1) - k1**2*k2**2*(r + s - 1)*(10*C*(13*r + 3*s - 3) - 79*r - 19*s + 19) + k2**4*(-56*C*r**2 - 56*C*r*s + 56*C*r - 4*K*(r - 1)*(r + s - 1) + f*(33*r**2 + r*(14 - 6*s) - 39*s**2 + 78*s - 37) + 41*r**2 + 22*r*s - 80*r - 19*s**2 - 20*s + 12))) + Dd*f*(k1**4*(8*C - 4)*(4*r*(13*s - 8) + 52*s**2 - 81*s + 29) - 2*k1**2*k2**2*(2*C*(260*r**2 + r*(320*s - 347) + 60*s**2 - 151*s + 91) - 316*r**2 - 392*r*s + 443*r - 76*s**2 + 198*s - 122) + k2**4*(-56*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 4*K*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + f*(132*r**2 + r*(9 - 24*s) - 156*s**2 + 305*s - 121) + 328*r**2 + 176*r*s - 502*r - 152*s**2 + 2*s + 120))) + 6*b1*(D1*(2*f**2*fd*k2**4*(738*r**2 + r*(540*s - 689) - 198*s**2 + 51*s + 89) - 11*f*(fd*(k1**4*(4*C - 2)*(5*s - 3) + k1**2*k2**2*(4*C*(5*r**2 + r*(7 - 82*s) - 87*s**2 + 43*s + 9) - 12*r**2 + r*(236*s - 21) + 248*s**2 - 114*s - 30) + k2**4*(-4*C*(4*r - 1)*(r + s - 1) - 8*K*s + r**2*(12*K - 2) + 2*r*(6*K*s - 3*K + 7*s - 15) + 16*s**2 - 23*s + 14)) - 4*gd2*k2**4*(2*r - 1)*(r + s - 1)) + 88*fd*g2*k2**4*(r - 1)*(r + s - 1)) + Dd*f*k2**2*(4*f**2*k2**2*(492*r**2 + r*(360*s - 439) - 132*s**2 + 38*s + 48) - 11*f*(2*k1**2*(C*(20*r**2 + r*(97 - 328*s) - 348*s**2 + 263*s - 29) - 12*r**2 + 236*r*s - 67*r + 248*s**2 - 176*s + 14) + k2**2*(-4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 2*K*(12*r**2 + 12*r*s - 13*r - 10*s + 6) - 4*r**2 + 28*r*s - 41*r + 32*s**2 - 48*s + 23)) + 44*g2*k2**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 2*f*(3*D1*bd1*(2*f**2*k2**4*(246*r**2 + 9*r*(20*s - 21) - 66*s**2 + 25*s + 7) + 11*f*(k1**4*(4*C - 2)*(5*s - 3) + k1**2*k2**2*(-2*C*(5*r**2 + r*(15 - 82*s) - 87*s**2 + 67*s - 24) + 6*r**2 - 118*r*s + 19*r - 124*s**2 + 88*s - 32) + k2**4*(-2*K*(3*r**2 + r*(3*s - 5) - 3*s + 3) + r**2*(8*C + 1) + r*(8*C*s - 4*C - 7*s + 3) - 8*s**2 + 12*s - 4)) + 44*g2*k2**4*(2*r**2 + 2*r*(s - 1) - s)) + D1*(f*(fd*(-k1**4*(12*C - 6)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) + k1**2*k2**2*(-12*C*(129*r**2 - 861*r*s + 157*r - 990*s**2 + 870*s - 151) + 531*r**2 - 7380*r*s + 2271*r - 7911*s**2 + 7668*s - 1673) + 33*k2**4*(63*r**2 + r*(99*s - 60) + 36*s**2 - 36*s + 10)) + k2**4*(-66*bd2 + 132*gd2)*(3*r**2 + r*(3*s - 5) - 3*s + 3)) - 66*fd*k2**4*(b2 - 2*g2)*(6*r**2 + r*(6*s - 3) - 4*s)) + Dd*f*(f*(k1**4*(18 - 36*C)*(4*r*(17*s - 8) + 68*s**2 - 93*s + 29) + k1**2*k2**2*(-12*C*(172*r**2 - 1148*r*s + 323*r - 1320*s**2 + 1334*s - 285) + 708*r**2 - 9840*r*s + 4083*r - 10548*s**2 + 11660*s - 3028) + 33*k2**4*(84*r**2 + r*(132*s - 91) + 48*s**2 - 54*s + 16)) + k2**4*(-66*b2 + 132*g2)*(12*r**2 + r*(12*s - 13) - 10*s + 6))))/(693*d**2*k1*k2*k3**3) - 2*D1**3*Pk1*Pkd3*ct*(33*b1**3*k2**2*(D1*fd*(k1**2*(9*r + 23*s - 23) + 7*k2**2*(r + s - 1))*(r + s - 1) + Dd*f*(k1**2*(36*r**2 + r*(128*s - 147) + 92*s**2 - 175*s + 83) + 7*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + 33*b1**2*(D1*(bd1*f*k2**2*(k1**2*(27*r**2 + r*(96*s - 115) + 69*s**2 - 129*s + 60) + 7*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2)) + fd*(k1**4*(28*C - 14)*(s - 1)*(r + s - 1) + k1**2*k2**2*(-28*C*(5*r**2 + 9*r*(s - 1) + 4*(s - 1)**2) - 10*K*r**2 - 2*K*r*s + 76*K*r + 8*K*s**2 + 58*K*s - 38*K + f*(8*r**2 - 104*r*s - 19*r - 112*s**2 + 53*s + 27) + 86*r**2 + 151*r*s - 185*r + 65*s**2 - 180*s + 89) + k2**4*(f*(4*r**2 + r*(95 - 140*s) - 144*s**2 + 195*s - 77) - 21*(r + s)**2))) + Dd*f*(k1**4*(56*C - 28)*(2*s - 1)*(r + s - 1) - 2*k1**2*k2**2*(14*C*(20*r**2 + r*(36*s - 29) + 16*s**2 - 27*s + 11) + 20*K*r**2 + 4*K*r*s - 145*K*r - 16*K*s**2 - 145*K*s + 111*K - 2*f*(4*r**2 - 52*r*s + 3*r - 56*s**2 + 43*s - 2) - 172*r**2 - 302*r*s + 286*r - 130*s**2 + 295*s - 138) + k2**4*(2*f*(4*r**2 - 7*r*(20*s - 9) - 144*s**2 + 163*s - 44) - 84*r**2 - 7*r*(24*s - 17) - 7*s*(12*s - 5)))) - b1*(D1*(f**2*k2**2*(-33*bd1*(k1**2*(8*r**2 - 104*r*s + 31*r - 112*s**2 + 119*s - 35) + k2**2*(4*r**2 - 140*r*s + 31*r - 144*s**2 + 131*s - 11)) + fd*(k1**2*(3825*r**2 + 3*r*(4740*s - 3541) + 10395*s**2 - 15993*s + 6262) + 33*k2**2*(36*r**2 + 9*r*(26*s - 15) + 198*s**2 - 243*s + 85))) - 33*f*(2*bd1*(k1**4*s*(28*C - 14)*(r + s - 1) + k1**2*k2**2*(-14*C*(10*r**2 + r*(18*s - 11) + 8*s**2 - 11*s + 3) - 2*K*(5*r**2 + r*(s - 28) - 4*s**2 - 37*s + 23) + 86*r**2 + 151*r*s - 99*r + 65*s**2 - 117*s + 38) - 7*k2**4*(3*r**2 + r*(6*s - 5) + s*(3*s - 1))) + fd*(k1**4*(8*C - 4)*(2*s - 1) - 2*k1**2*k2**2*(C*(72*r**2 + r*(40*s - 94) - 32*s**2 - 42*s + 48) - K*(102*r**2 + 162*r*s - 113*r + 60*s**2 - 95*s + 31) + 70*r*s + 17*r + 70*s**2 - 25*s - 15) + k2**4*(r**2*(4*K - 54) + r*(K*(4*s - 2) - 104*s + 27) + s*(-2*K - 50*s + 3))) + 4*k1**2*k2**2*(bd2*(6*r + 6*s + 1) + gd2*(5*r - 4*s - 46))*(r + s - 1)) - 132*fd*k1**2*k2**2*(b2*(6*r**2 + 2*r*(6*s + 1) + 6*s**2 + 2*s - 1) + g2*(5*r**2 + r*(s - 38) - 4*s**2 - 29*s + 19))) + Dd*f*(f**2*k2**2*(k1**2*(5100*r**2 + 3*r*(6320*s - 4923) + 13860*s**2 - 21469*s + 8273) + 264*k2**2*(6*r**2 + r*(39*s - 22) + 33*s**2 - 40*s + 12)) - 33*f*(k1**4*(16*C - 8)*(2*s - 1) - 2*k1**2*k2**2*(4*C*(36*r**2 + 5*r*(4*s - 5) - 16*s**2 - 5*s + 8) - K*(204*r**2 + 324*r*s - 283*r + 120*s**2 - 223*s + 99) + 140*r*s - 58*r + 140*s**2 - 118*s + 21) + k2**4*(r**2*(8*K - 108) + r*(K*(8*s - 2) - 208*s + 125) + s*(-2*K - 100*s + 53))) - 132*k1**2*k2**2*(b2*(24*r**2 + 2*r*(24*s - 7) + 24*s**2 - 14*s - 3) + g2*(20*r**2 + r*(4*s - 145) - 16*s**2 - 145*s + 111)))) + f*(D1*(-bd1*f**2*k2**2*(k1**2*(1275*r**2 + 6*r*(790*s - 691) + 3465*s**2 - 5476*s + 2011) + 33*k2**2*(12*r**2 + 78*r*s - 41*r + 66*s**2 - 77*s + 11)) + 33*f*(bd1*(k1**4*s*(8*C - 4) - 2*k1**2*k2**2*(2*C*(18*r**2 + r*(10*s + 7) - 8*s**2 + 8*s - 13) - K*(51*r**2 + 81*r*s - 85*r + 30*s**2 - 64*s + 34) + 35*r*s - 49*r + 35*s**2 - 49*s + 27) + k2**4*(r**2*(2*K - 27) + r*(s*(2*K - 52) + 49) - s*(25*s - 25))) + fd*(k1**4*(4*C - 2)*(3*s - 1)*(5*r + 5*s - 3) + k1**2*k2**2*(4*C*(36*r**2 + 27*r*(5*s - 3) + 99*s**2 - 111*s + 34) - 102*r**2 + r*(203 - 363*s) - 261*s**2 + 306*s - 89)) + k2**2*(2*bd2 - 4*gd2)*(k1**2*(51*r**2 + r*(81*s - 85) + 30*s**2 - 64*s + 34) + k2**2*r*(r + s))) + 66*k2**2*(12*b2*bd1*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + b2*fd*(k1**2*(102*r**2 + r*(162*s - 113) + 60*s**2 - 95*s + 31) + k2**2*(r + s)*(2*r - 1)) + 2*bd1*g2*k1**2*(5*r**2 + r*(s - 5) - 4*s*(s + 8)) + 2*fd*g2*(-k1**2*(102*r**2 + r*(162*s - 113) + 60*s**2 - 95*s + 31) - k2**2*(r + s)*(2*r - 1)))) + 66*Dd*f*(f*k1**2*(k1**2*(4*C - 2)*(2*s - 1)*(5*r + 5*s - 3) + k2**2*(4*C*(24*r**2 + 90*r*s - 63*r + 66*s**2 - 83*s + 28) - 68*r**2 - 242*r*s + 162*r - 174*s**2 + 229*s - 77)) + k2**2*(b2 - 2*g2)*(k1**2*(204*r**2 + r*(324*s - 283) + 120*s**2 - 223*s + 99) + k2**2*(r + s)*(4*r - 1)))))/(693*d**2*k1*k2*k3**3) + D1**3*Pk1*Pkd3*ct*st**2*(39*D1*bd1*f*(f**2*k2**4*(k1**2*(2129*r**2 + r*(4314*s - 3256) + 2185*s**2 - 3684*s + 1099) - 33*k2**2*(30*r**2 + 5*r*(8*s - 7) + 10*s**2 - 23*s + 5)) + 11*f*(k1**6*(8*C - 4)*(7*s - 3)*(r + s - 1) - 2*k1**4*k2**2*(10*C*(24*r**2 + r*(74*s - 45) + 50*s**2 - 53*s + 21) - 135*r**2 + r*(257 - 442*s) - 307*s**2 + 315*s - 122) + k1**2*k2**4*(4*C*(129*r**2 + 10*r*(20*s - 19) + 71*s**2 - 140*s + 61) - 12*K*(24*r**2 + 6*r*(7*s - 5) + 18*s**2 - 25*s + 7) + b1*(640*r**2 + r*(1376*s - 995) + 736*s**2 - 995*s + 307) - 196*r**2 - 258*r*s + 302*r - 62*s**2 + 184*s - 106) - k2**6*(15*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) - 2*r**2*(4*K - 9) - 2*r*(2*K - 7)*(2*s - 1) + 2*s*(5*s - 5))) - 11*k2**2*(195*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 4*b1*(k1**4*(75*C - 40)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(70*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-278*r**2 - 478*r*s + 243*r - 200*s**2 + 225*s + 5) + 34*r**2 + 42*r*s + 38*r + 8*s**2 + 30*s - 55) - 7*k2**4*(r**2*(4*K - 9) + r*(K*(4*s - 3) - 14*s + 8) - s*(K + 5*s - 6))) + 4*k2**2*(65*b2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(k1**2*(139*r**2 + r*(239*s - 139) + 10*s*(10*s - 13)) + 7*k2**2*(2*r**2 + 2*r*(s - 1) - s))))) - 83655*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*k2**2*(D1*fd*(k1**4*(300*C - 160)*(r + s - 1)**2 + k1**2*k2**2*(280*C*(r + s - 1)**2 - 4*K*(139*r**2 + 239*r*s + 10*r + 100*s**2 + 10*s - 5) + f*(640*r**2 + 43*r*(32*s - 15) + 736*s**2 - 669*s + 143) + 68*r**2 + 84*r*s + 440*r + 16*s**2 + 440*s - 220) + k2**4*(-15*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + (r + s)*(-14*r*(4*K - 9) + 70*s))) + 2*Dd*f*(k1**4*(150*C - 80)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(140*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*K*(-556*r**2 - 956*r*s + 337*r - 400*s**2 + 310*s + 15) + f*(640*r**2 + 4*r*(344*s - 205) + 736*s**2 - 832*s + 225) + 136*r**2 + 168*r*s + 406*r + 32*s**2 + 382*s - 330) + k2**4*(-15*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 7*r**2*(16*K - 36) - 7*r*(16*K*s - 8*K - 56*s + 23) - 7*s*(-2*K - 20*s + 17)))) + 39*b1*(D1*(f**2*fd*k2**4*(k1**2*(6387*r**2 + r*(12942*s - 7735) + 6555*s**2 - 7979*s + 2606) - 33*k2**2*(90*r**2 + 5*r*(24*s - 19) + 30*s**2 - 59*s + 31)) + 22*f*(fd*(k1**6*(4*C - 2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + k1**4*k2**2*(-2*C*(240*r**2 + r*(740*s - 317) + 500*s**2 - 389*s + 47) + 270*r**2 + r*(884*s - 386) + 614*s**2 - 487*s + 65) + k1**2*k2**4*(C*(516*r**2 + r*(800*s - 402) + 284*s**2 - 278*s + 58) - 6*K*(48*r**2 + 84*r*s - 46*r + 36*s**2 - 37*s + 11) - 196*r**2 - 258*r*s + 125*r - 62*s**2 + 58*s - 3) + k2**6*(r**2*(8*K - 18) + r*(K*(8*s - 4) - 28*s + 9) + s*(-2*K - 10*s + 7))) + 2*k2**4*(-65*bd2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(139*r**2 + 239*r*s - 104*r + 100*s**2 - 95*s - 5) + 7*k2**2*r*(2*r + 2*s - 1)))) + 44*fd*k2**4*(-65*b2*k1**2*(r + s)**2 + 2*g2*k1**2*(139*r**2 + 239*r*s + 10*r + 100*s**2 + 10*s - 5) + 28*g2*k2**2*r*(r + s))) + Dd*f*(f**2*k2**4*(k1**2*(8516*r**2 + r*(17256*s - 10991) + 8740*s**2 - 11663*s + 3705) - 66*k2**2*(60*r**2 + r*(80*s - 65) + 20*s**2 - 41*s + 18)) + 22*f*(k1**6*(4*C - 2)*(4*r*(7*s - 4) + 28*s**2 - 39*s + 13) + k1**4*k2**2*(-8*C*(120*r**2 + r*(370*s - 211) + 250*s**2 - 249*s + 61) + 540*r**2 + 1768*r*s - 1007*r + 1228*s**2 - 1224*s + 302) + k1**2*k2**4*(2*C*(516*r**2 + r*(800*s - 551) + 284*s**2 - 389*s + 129) - 6*K*(96*r**2 + 2*r*(84*s - 53) + 72*s**2 - 87*s + 25) - 392*r**2 - 516*r*s + 390*r - 124*s**2 + 205*s - 80) + k2**6*(r**2*(16*K - 36) + r*(8*K*(2*s - 1) - 56*s + 23) + s*(-2*K - 20*s + 17))) + 44*k2**4*(-65*b2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(556*r**2 + 956*r*s - 337*r + 400*s**2 - 310*s - 15) + 7*k2**2*(8*r**2 + 8*r*s - 4*r - s))))) + 2*f*(D1*(2*f**2*fd*k2**4*(k1**2*(24880*r**2 + 4*r*(6220*s - 7897) - 16178*s + 11321) + 78*k2**2*(48*r**2 + r*(318*s - 179) + 270*s**2 - 309*s + 89)) + 13*f*(fd*k1**2*(k1**4*(12*C - 6)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) + k1**2*k2**2*(-2*C*(4599*r**2 + 17694*r*s - 9723*r + 13095*s**2 - 14991*s + 4306) + 5085*r**2 + 20394*r*s - 11673*r + 15309*s**2 - 18060*s + 5379) + 33*k2**4*(2*C*(453*r**2 + 768*r*s - 501*r + 315*s**2 - 401*s + 130) - 624*r**2 - 1053*r*s + 694*r - 429*s**2 + 548*s - 180)) - 66*k2**4*(5*bd2*k1**2*(8*r**2 + r*(16*s - 11) + 8*s**2 - 11*s + 3) - 2*gd2*(3*k1**2*(24*r**2 + 6*r*(7*s - 5) + 18*s**2 - 25*s + 7) + k2**2*r*(-2*r - 2*s + 1)))) - 858*fd*k2**4*(5*b2*k1**2*(16*r**2 + 2*r*(16*s - 7) + 16*s**2 - 14*s + 3) - 2*g2*(3*k1**2*(48*r**2 + 84*r*s - 46*r + 36*s**2 - 37*s + 11) + k2**2*(-4*r**2 - 4*r*s + 2*r + s)))) + Dd*f*(2*f**2*k2**4*(k1**2*(24880*r**2 + 4*r*(6220*s - 7897) - 16178*s + 11321) + 78*k2**2*(48*r**2 + r*(318*s - 179) + 270*s**2 - 309*s + 89)) + 13*f*k1**2*(k1**4*(36*C - 18)*(4*r*(17*s - 8) + 68*s**2 - 93*s + 29) + k1**2*k2**2*(-2*C*(6132*r**2 + 23592*r*s - 14639*r + 17460*s**2 - 22025*s + 6975) + 6780*r**2 + 27192*r*s - 17639*r + 20412*s**2 - 26536*s + 8752) + 33*k2**4*(2*C*(604*r**2 + 1024*r*s - 713*r + 420*s**2 - 567*s + 191) - 832*r**2 - 1404*r*s + 992*r - 572*s**2 + 777*s - 266)) - 858*k2**4*(5*b2*k1**2*(32*r**2 + 4*r*(16*s - 9) + 32*s**2 - 36*s + 9) - 2*g2*(3*k1**2*(96*r**2 + 2*r*(84*s - 53) + 72*s**2 - 87*s + 25) + k2**2*(-8*r**2 + r*(4 - 8*s) + s))))))/(9009*d**2*k1*k2*k3**5) + 5*D1**3*Pk1*Pkd3*f*k2**4*st**6*(-13*D1*bd1*f*(k1**2*(132*C - 66)*(2*r + 2*s - 1) - k2**2*(132*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 17)))*(r + s - 1) + 858*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + k1**2*(66 - 132*C)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s - 17) + k1**2*(66 - 132*C)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(212*r**2 + r*(424*s - 331) + 212*s**2 - 331*s + 129) + k1**2*(26 - 52*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(53*r + 53*s - 43) + k1**2*(26 - 52*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(1001*d**2*k3**7) + 10*D1**3*Pk1*Pkd3*f*k2**2*st**6*(33*D1*bd1*f*(k1**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 33*b1*(4*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r)*(2*r + 2*s - 1) + Dd*f*(k1**2*(4*C - 2)*(2*s - 1)*(8*r + 8*s - 5) + k2**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) + f*(2*D1*fd*(k1**2*(4*C - 2)*(3*s - 1) + k2**2*(3*r - 1))*(3*r + 3*s - 2) + Dd*f*(k1**2*(4*C - 2)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + k2**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(693*d**2*k1**2*k3**3) - 10*D1**3*Pk1*Pkd3*f*k2**2*st**6*(13*D1*bd1*f*(2*f*k2**4*(6*r**2 + r*(6*s - 8) - 3*s + 2) + k1**4*(132*C - 66)*(r*(4*s - 1) + (1 - 2*s)**2) - 33*k1**2*k2**2*(2*C*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) - 22*r**2 + r*(30 - 32*s) - 10*s**2 + 21*s - 8)) + 13*b1*(3*D1*fd*(4*f*k2**4*r*(3*r + 3*s - 2) + k1**4*(88*C - 44)*(2*s - 1)*(2*r + 2*s - 1) - 11*k1**2*k2**2*(2*r + 2*s - 1)*(2*C*(18*r + 10*s - 5) - 22*r - 10*s + 5)) + 2*Dd*f*(f*k2**4*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**4*(66*C - 33)*(2*s - 1)*(8*r + 8*s - 5) - 33*k1**2*k2**2*(C*(72*r**2 + 2*r*(56*s - 37) + 40*s**2 - 54*s + 17) - 44*r**2 + r*(43 - 64*s) - 20*s**2 + 28*s - 9))) - f*(D1*fd*(f*k2**4*(696*r**2 + 8*r*(87*s - 100) - 239*s + 189) + k1**4*(52 - 104*C)*(3*s - 1)*(3*r + 3*s - 2) + 13*k1**2*k2**2*(3*r + 3*s - 2)*(C*(54*r + 30*s - 28) - 33*r - 15*s + 16)) + Dd*f*(f*k2**4*(696*r**2 + 8*r*(87*s - 100) - 239*s + 189) + k1**4*(26 - 52*C)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 13*k1**2*k2**2*(2*C*(108*r**2 + 7*r*(24*s - 19) + 60*s**2 - 99*s + 40) - 132*r**2 + r*(157 - 192*s) - 60*s**2 + 106*s - 45))))/(9009*d**2*k1**2*k3**5) + 6*D1**3*Pk1*Pkd3*k1**4*(D1*(-2*b1*fd*(k1**2 + 7*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 5*bd1*f**3*k2**2*(r + s - 1)**2 + f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(2*r + 2*s - 1) + 6*K*k2**2*(r + s) - 6*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))) + 2*f*(fd*(b1*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) + 2*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)))*(2*r + 2*s - 1) + (k1**2 + 7*k2**2)*(2*b1*gd2 + 2*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(5*b1*f**2*k2**2*(r + s - 1) + 2*b1*f*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) - 2*b1*(k1**2 + 7*k2**2)*(r + s)*(K*b1 - 2*g2) + 4*f*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))))/(7*d**2*k3**7) - D1**3*Pk1*Pkd3*k1**2*(-3432*C*D1*b1*f*fd*k1**2*r*s + 1716*C*D1*b1*f*fd*k1**2*r - 3432*C*D1*b1*f*fd*k1**2*s**2 + 5148*C*D1*b1*f*fd*k1**2*s - 1716*C*D1*b1*f*fd*k1**2 - 4356*C*D1*f**2*fd*k1**2*r*s + 1452*C*D1*f**2*fd*k1**2*r - 4356*C*D1*f**2*fd*k1**2*s**2 + 5808*C*D1*f**2*fd*k1**2*s - 1452*C*D1*f**2*fd*k1**2 - 6864*C*Dd*b1*f**2*k1**2*r*s + 3432*C*Dd*b1*f**2*k1**2*r - 6864*C*Dd*b1*f**2*k1**2*s**2 + 10296*C*Dd*b1*f**2*k1**2*s - 3432*C*Dd*b1*f**2*k1**2 - 5808*C*Dd*f**3*k1**2*r*s + 2904*C*Dd*f**3*k1**2*r - 5808*C*Dd*f**3*k1**2*s**2 + 8712*C*Dd*f**3*k1**2*s - 2904*C*Dd*f**3*k1**2 - 1452*D1*K*b1**2*fd*k1**2*r**2 - 2904*D1*K*b1**2*fd*k1**2*r*s - 1320*D1*K*b1**2*fd*k1**2*r - 1452*D1*K*b1**2*fd*k1**2*s**2 - 1320*D1*K*b1**2*fd*k1**2*s + 660*D1*K*b1**2*fd*k1**2 - 8778*D1*K*b1**2*fd*k2**2*r**2 - 15708*D1*K*b1**2*fd*k2**2*r*s - 6930*D1*K*b1**2*fd*k2**2*s**2 - 10560*D1*K*b1*f*fd*k1**2*r**2 - 19272*D1*K*b1*f*fd*k1**2*r*s + 10560*D1*K*b1*f*fd*k1**2*r - 8712*D1*K*b1*f*fd*k1**2*s**2 + 9768*D1*K*b1*f*fd*k1**2*s - 2640*D1*K*b1*f*fd*k1**2 - 16236*D1*K*b1*f*fd*k2**2*r**2 - 29040*D1*K*b1*f*fd*k2**2*r*s + 8118*D1*K*b1*f*fd*k2**2*r - 12804*D1*K*b1*f*fd*k2**2*s**2 + 6534*D1*K*b1*f*fd*k2**2*s - 2310*D1*b1**3*fd*k2**2*r**2 - 4620*D1*b1**3*fd*k2**2*r*s + 4620*D1*b1**3*fd*k2**2*r - 2310*D1*b1**3*fd*k2**2*s**2 + 4620*D1*b1**3*fd*k2**2*s - 2310*D1*b1**3*fd*k2**2 + 1980*D1*b1**2*f*fd*k1**2*r*s - 1782*D1*b1**2*f*fd*k1**2*r + 1980*D1*b1**2*f*fd*k1**2*s**2 - 2706*D1*b1**2*f*fd*k1**2*s + 858*D1*b1**2*f*fd*k1**2 + 2574*D1*b1**2*f*fd*k2**2*r**2 + 7722*D1*b1**2*f*fd*k2**2*r*s - 3168*D1*b1**2*f*fd*k2**2*r + 5148*D1*b1**2*f*fd*k2**2*s**2 - 4026*D1*b1**2*f*fd*k2**2*s - 264*D1*b1**2*f*fd*k2**2 + 264*D1*b1**2*fd*k1**2*r*s + 264*D1*b1**2*fd*k1**2*s**2 + 924*D1*b1**2*fd*k2**2*r**2 + 1848*D1*b1**2*fd*k2**2*r*s + 924*D1*b1**2*fd*k2**2*s**2 - 660*D1*b1*b2*fd*k1**2*r**2 - 1320*D1*b1*b2*fd*k1**2*r*s - 660*D1*b1*b2*fd*k1**2*s**2 - 4620*D1*b1*b2*fd*k2**2*r**2 - 9240*D1*b1*b2*fd*k2**2*r*s - 4620*D1*b1*b2*fd*k2**2*s**2 + 2970*D1*b1*f**2*fd*k1**2*r*s - 2310*D1*b1*f**2*fd*k1**2*r + 2970*D1*b1*f**2*fd*k1**2*s**2 - 4224*D1*b1*f**2*fd*k1**2*s + 1518*D1*b1*f**2*fd*k1**2 + 8415*D1*b1*f**2*fd*k2**2*r**2 + 17721*D1*b1*f**2*fd*k2**2*r*s - 13596*D1*b1*f**2*fd*k2**2*r + 9306*D1*b1*f**2*fd*k2**2*s**2 - 12309*D1*b1*f**2*fd*k2**2*s + 4455*D1*b1*f**2*fd*k2**2 + 2772*D1*b1*f*fd*k1**2*r*s - 858*D1*b1*f*fd*k1**2*r + 2772*D1*b1*f*fd*k1**2*s**2 - 3102*D1*b1*f*fd*k1**2*s + 858*D1*b1*f*fd*k1**2 + 1584*D1*b1*f*fd*k2**2*r**2 + 3168*D1*b1*f*fd*k2**2*r*s - 792*D1*b1*f*fd*k2**2*r + 1584*D1*b1*f*fd*k2**2*s**2 + 2904*D1*b1*f*gd2*k1**2*r**2 + 5808*D1*b1*f*gd2*k1**2*r*s - 1584*D1*b1*f*gd2*k1**2*r + 2904*D1*b1*f*gd2*k1**2*s**2 - 1584*D1*b1*f*gd2*k1**2*s - 1320*D1*b1*f*gd2*k1**2 + 17556*D1*b1*f*gd2*k2**2*r**2 + 31416*D1*b1*f*gd2*k2**2*r*s - 17556*D1*b1*f*gd2*k2**2*r + 13860*D1*b1*f*gd2*k2**2*s**2 - 13860*D1*b1*f*gd2*k2**2*s + 2904*D1*b1*fd*g2*k1**2*r**2 + 5808*D1*b1*fd*g2*k1**2*r*s + 2640*D1*b1*fd*g2*k1**2*r + 2904*D1*b1*fd*g2*k1**2*s**2 + 2640*D1*b1*fd*g2*k1**2*s - 1320*D1*b1*fd*g2*k1**2 + 17556*D1*b1*fd*g2*k2**2*r**2 + 31416*D1*b1*fd*g2*k2**2*r*s + 13860*D1*b1*fd*g2*k2**2*s**2 - 2640*D1*b2*f*fd*k1**2*r**2 - 5280*D1*b2*f*fd*k1**2*r*s + 2640*D1*b2*f*fd*k1**2*r - 2640*D1*b2*f*fd*k1**2*s**2 + 2640*D1*b2*f*fd*k1**2*s - 660*D1*b2*f*fd*k1**2 - 7920*D1*b2*f*fd*k2**2*r**2 - 15840*D1*b2*f*fd*k2**2*r*s + 3960*D1*b2*f*fd*k2**2*r - 7920*D1*b2*f*fd*k2**2*s**2 + 3960*D1*b2*f*fd*k2**2*s + 33*D1*bd1*f*(-70*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 4*b1*(K*(k1**2*(22*r + 22*s + 5) + 7*k2**2*(19*r + 15*s))*(r + s - 1) + k1**2*(-4*r*s + r + s*(3 - 4*s)) - 7*k2**2*(2*r**2 + r*(4*s - 3) + s*(2*s - 1))) + 2*f**2*k1**2*(s - 1)*(15*r + 15*s - 13) + f**2*k2**2*(85*r**2 + r*(179*s - 201) + 94*(s - 1)**2) + 2*f*k1**2*(-26*C*r*s - 26*C*s**2 + 26*C*s - 2*K*(40*r**2 + 73*r*s - 61*r + 33*s**2 - 54*s + 21) + b1*(3*r*(10*s - 9) + 30*s**2 - 53*s + 25) + 21*r*s - 4*r + 21*s**2 - 23*s + 2) + f*k2**2*(b1*(78*r**2 + 3*r*(78*s - 85) + 156*s**2 - 281*s + 151) + r**2*(24 - 246*K) + r*(-440*K*s + 242*K + 48*s - 48) - s*(194*K - 24)*(s - 1)) - (4*r + 4*s - 4)*(5*b2*(k1**2 + 7*k2**2)*(r + s) - 22*g2*k1**2*(r + s) - 7*g2*k2**2*(19*r + 15*s))) - 660*D1*bd2*f*(r + s - 1)*(b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s)) - 2440*D1*f**3*fd*k2**2*r*s + 1220*D1*f**3*fd*k2**2*r - 2440*D1*f**3*fd*k2**2*s**2 + 3660*D1*f**3*fd*k2**2*s - 1220*D1*f**3*fd*k2**2 + 2178*D1*f**2*fd*k1**2*r*s - 726*D1*f**2*fd*k1**2*r + 2178*D1*f**2*fd*k1**2*s**2 - 2904*D1*f**2*fd*k1**2*s + 726*D1*f**2*fd*k1**2 + 10560*D1*f**2*gd2*k1**2*r**2 + 19272*D1*f**2*gd2*k1**2*r*s - 16104*D1*f**2*gd2*k1**2*r + 8712*D1*f**2*gd2*k1**2*s**2 - 14256*D1*f**2*gd2*k1**2*s + 5544*D1*f**2*gd2*k1**2 + 16236*D1*f**2*gd2*k2**2*r**2 + 29040*D1*f**2*gd2*k2**2*r*s - 15972*D1*f**2*gd2*k2**2*r + 12804*D1*f**2*gd2*k2**2*s**2 - 12804*D1*f**2*gd2*k2**2*s + 21120*D1*f*fd*g2*k1**2*r**2 + 38544*D1*f*fd*g2*k1**2*r*s - 21120*D1*f*fd*g2*k1**2*r + 17424*D1*f*fd*g2*k1**2*s**2 - 19536*D1*f*fd*g2*k1**2*s + 5280*D1*f*fd*g2*k1**2 + 32472*D1*f*fd*g2*k2**2*r**2 + 58080*D1*f*fd*g2*k2**2*r*s - 16236*D1*f*fd*g2*k2**2*r + 25608*D1*f*fd*g2*k2**2*s**2 - 13068*D1*f*fd*g2*k2**2*s - 5808*Dd*K*b1**2*f*k1**2*r**2 - 11616*Dd*K*b1**2*f*k1**2*r*s + 1716*Dd*K*b1**2*f*k1**2*r - 5808*Dd*K*b1**2*f*k1**2*s**2 + 1716*Dd*K*b1**2*f*k1**2*s + 1980*Dd*K*b1**2*f*k1**2 - 35112*Dd*K*b1**2*f*k2**2*r**2 - 62832*Dd*K*b1**2*f*k2**2*r*s + 26334*Dd*K*b1**2*f*k2**2*r - 27720*Dd*K*b1**2*f*k2**2*s**2 + 20790*Dd*K*b1**2*f*k2**2*s - 21120*Dd*K*b1*f**2*k1**2*r**2 - 38544*Dd*K*b1*f**2*k1**2*r*s + 26664*Dd*K*b1*f**2*k1**2*r - 17424*Dd*K*b1*f**2*k1**2*s**2 + 24024*Dd*K*b1*f**2*k1**2*s - 8184*Dd*K*b1*f**2*k1**2 - 32472*Dd*K*b1*f**2*k2**2*r**2 - 58080*Dd*K*b1*f**2*k2**2*r*s + 24090*Dd*K*b1*f**2*k2**2*r - 25608*Dd*K*b1*f**2*k2**2*s**2 + 19338*Dd*K*b1*f**2*k2**2*s - 9240*Dd*b1**3*f*k2**2*r**2 - 18480*Dd*b1**3*f*k2**2*r*s + 16170*Dd*b1**3*f*k2**2*r - 9240*Dd*b1**3*f*k2**2*s**2 + 16170*Dd*b1**3*f*k2**2*s - 6930*Dd*b1**3*f*k2**2 + 3960*Dd*b1**2*f**2*k1**2*r*s - 3564*Dd*b1**2*f**2*k1**2*r + 3960*Dd*b1**2*f**2*k1**2*s**2 - 6204*Dd*b1**2*f**2*k1**2*s + 2508*Dd*b1**2*f**2*k1**2 + 5148*Dd*b1**2*f**2*k2**2*r**2 + 15444*Dd*b1**2*f**2*k2**2*r*s - 11583*Dd*b1**2*f**2*k2**2*r + 10296*Dd*b1**2*f**2*k2**2*s**2 - 13299*Dd*b1**2*f**2*k2**2*s + 4719*Dd*b1**2*f**2*k2**2 + 1056*Dd*b1**2*f*k1**2*r*s - 264*Dd*b1**2*f*k1**2*r + 1056*Dd*b1**2*f*k1**2*s**2 - 660*Dd*b1**2*f*k1**2*s + 3696*Dd*b1**2*f*k2**2*r**2 + 7392*Dd*b1**2*f*k2**2*r*s - 4620*Dd*b1**2*f*k2**2*r + 3696*Dd*b1**2*f*k2**2*s**2 - 1848*Dd*b1**2*f*k2**2*s - 2640*Dd*b1*b2*f*k1**2*r**2 - 5280*Dd*b1*b2*f*k1**2*r*s + 1980*Dd*b1*b2*f*k1**2*r - 2640*Dd*b1*b2*f*k1**2*s**2 + 1980*Dd*b1*b2*f*k1**2*s - 18480*Dd*b1*b2*f*k2**2*r**2 - 36960*Dd*b1*b2*f*k2**2*r*s + 13860*Dd*b1*b2*f*k2**2*r - 18480*Dd*b1*b2*f*k2**2*s**2 + 13860*Dd*b1*b2*f*k2**2*s + 3960*Dd*b1*f**3*k1**2*r*s - 3300*Dd*b1*f**3*k1**2*r + 3960*Dd*b1*f**3*k1**2*s**2 - 6072*Dd*b1*f**3*k1**2*s + 2376*Dd*b1*f**3*k1**2 + 11220*Dd*b1*f**3*k2**2*r**2 + 23628*Dd*b1*f**3*k2**2*r*s - 20229*Dd*b1*f**3*k2**2*r + 12408*Dd*b1*f**3*k2**2*s**2 - 18513*Dd*b1*f**3*k2**2*s + 7557*Dd*b1*f**3*k2**2 + 5544*Dd*b1*f**2*k1**2*r*s - 2244*Dd*b1*f**2*k1**2*r + 5544*Dd*b1*f**2*k1**2*s**2 - 6996*Dd*b1*f**2*k1**2*s + 1980*Dd*b1*f**2*k1**2 + 3168*Dd*b1*f**2*k2**2*r**2 + 6336*Dd*b1*f**2*k2**2*r*s - 3960*Dd*b1*f**2*k2**2*r + 3168*Dd*b1*f**2*k2**2*s**2 - 1584*Dd*b1*f**2*k2**2*s + 11616*Dd*b1*f*g2*k1**2*r**2 + 23232*Dd*b1*f*g2*k1**2*r*s - 3432*Dd*b1*f*g2*k1**2*r + 11616*Dd*b1*f*g2*k1**2*s**2 - 3432*Dd*b1*f*g2*k1**2*s - 3960*Dd*b1*f*g2*k1**2 + 70224*Dd*b1*f*g2*k2**2*r**2 + 125664*Dd*b1*f*g2*k2**2*r*s - 52668*Dd*b1*f*g2*k2**2*r + 55440*Dd*b1*f*g2*k2**2*s**2 - 41580*Dd*b1*f*g2*k2**2*s - 5280*Dd*b2*f**2*k1**2*r**2 - 10560*Dd*b2*f**2*k1**2*r*s + 6600*Dd*b2*f**2*k1**2*r - 5280*Dd*b2*f**2*k1**2*s**2 + 6600*Dd*b2*f**2*k1**2*s - 1980*Dd*b2*f**2*k1**2 - 15840*Dd*b2*f**2*k2**2*r**2 - 31680*Dd*b2*f**2*k2**2*r*s + 11880*Dd*b2*f**2*k2**2*r - 15840*Dd*b2*f**2*k2**2*s**2 + 11880*Dd*b2*f**2*k2**2*s - 2440*Dd*f**4*k2**2*r*s + 1220*Dd*f**4*k2**2*r - 2440*Dd*f**4*k2**2*s**2 + 3660*Dd*f**4*k2**2*s - 1220*Dd*f**4*k2**2 + 2904*Dd*f**3*k1**2*r*s - 1452*Dd*f**3*k1**2*r + 2904*Dd*f**3*k1**2*s**2 - 4356*Dd*f**3*k1**2*s + 1452*Dd*f**3*k1**2 + 42240*Dd*f**2*g2*k1**2*r**2 + 77088*Dd*f**2*g2*k1**2*r*s - 53328*Dd*f**2*g2*k1**2*r + 34848*Dd*f**2*g2*k1**2*s**2 - 48048*Dd*f**2*g2*k1**2*s + 16368*Dd*f**2*g2*k1**2 + 64944*Dd*f**2*g2*k2**2*r**2 + 116160*Dd*f**2*g2*k2**2*r*s - 48180*Dd*f**2*g2*k2**2*r + 51216*Dd*f**2*g2*k2**2*s**2 - 38676*Dd*f**2*g2*k2**2*s)/(693*d**2*k3**5) + D1**3*Pk1*Pkd3*k1**2*st**2*(-13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + 8*K*r + 8*K*s - 3*K + b1*(-11*r - 11*s + 7) + 4*r + 4*s - 3) + k2**4*(-K*(r + s) + 3*b1*(5*r + 5*s - 3))) + k2**2*(13*k1**2 + 7*k2**2)*(r + s)*(-132*K*b1 + 132*g2)) + 429*b1**2*k2**2*(D1*fd*(2*K*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*(k1**2*(11*r + 11*s - 7) - 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**2*(11*r + 11*s - 7) - 3*f*k2**2*(5*r + 5*s - 3))) - 13*b1*(D1*(f**2*fd*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) - 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) + 132*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(2*k1**2*(r + s - 17) - 65*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 26*f*(fd*k1**2*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(r + s - 1)) + 1716*fd*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(r + s - 17) - 65*k2**2*(11*r + 11*s - 9)) + f*k1**2*(52*C - 26)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3)) + 1716*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s)))))/(1001*d**2*k3**7) - 6*D1**3*Pk1*Pkd3*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(K*b1 - 2*g2) + f**3*fd*k2**2*(k1**2*(-449*r - 449*s + 327) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 78*f**2*(11*bd1*(r + s - 1)*(-2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(r + s) + k1**2*k2**2*(b1*(-3*r - 3*s + 1) + (2*C - 1)*(2*r + 2*s - 1))) + fd*k1**4*(4*C - 2)*(3*r + 3*s - 2)**2) + 429*f*(b1**2*fd*k2**2*(k1**2*(3*r + 3*s - 1) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 2*b1*k1**2*(fd*(2*C - 1)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*bd1*g2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-429*b1*f*(2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2 - 4*C)*(r + s) + k1**2*k2**2*(b1*(3*r + 3*s - 1) + (2 - 4*C)*(2*r + 2*s - 1))) - 858*b1*k1**2*k2**2*(r + s)*(K*b1 - 2*g2) + f**3*k2**2*(k1**2*(449*r + 449*s - 327) - 13*k2**2*(17*r + 17*s - 11)) + f**2*k1**4*(312*C - 156)*(3*r + 3*s - 2)))/(1001*d**2*k3**7) - D1**3*Pk1*Pkd3*(-D1*bd1*f*(-2*b2*(12*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + f**2*(2*k1**2*(s - 1)*(15*r + 15*s - 13) + k2**2*(15*r**2 + 81*r*s - 59*r + 66*s**2 - 88*s + 22)) - 2*f*(2*k1**2*(K*(22*r**2 + 37*r*s - 34*r + 15*s**2 - 27*s + 12) - 4*r*s + 2*r - 4*s**2 + 5*s - 1) + k2**2*(r**2*(15*K - 12) + r*(28*K*s - 13*K - 24*s + 24) + s*(13*K - 12)*(s - 1))) + 4*g2*(2*k1**2*(-r**2 + r*(s + 1) + 2*s*(s + 5)) + 7*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)))) + 7*b1**3*(D1*fd*(2*k1**2*(s - 1) + k2**2*(3*r + 4*s - 4))*(r + s - 1) + Dd*f*(4*k1**2*(r*(2*s - 3) + 2*(s - 1)**2) + k2**2*(12*r**2 + r*(28*s - 23) + 16*s**2 - 27*s + 11))) + b1**2*(7*D1*bd1*f*(2*k1**2*(r*(3*s - 5) + 3*(s - 1)**2) + k2**2*(9*r**2 + r*(21*s - 16) + 12*s**2 - 19*s + 7)) + D1*fd*(-2*k1**2*(14*C*(s - 1)*(r + s - 1) + 2*K*r**2 - 2*K*r*s - 32*K*r - 4*K*s**2 - 26*K*s + 16*K + 2*f*(8*s - 7) - 7*r*s + 7*r - 7*s**2 + 18*s - 7) + k2**2*(f*(24*r**2 + r*(15 - 56*s) - 80*s**2 + 67*s - 13) + (14*K - 28)*(r + s)**2)) - 2*Dd*f*(2*k1**2*(14*C*(2*s - 1)*(r + s - 1) + 4*K*r**2 - 4*K*r*s - 53*K*r - 8*K*s**2 - 53*K*s + 42*K + 4*f*s - 2*f - 14*r*s + 7*r - 14*s**2 + 25*s - 9) + k2**2*(f*(-24*r**2 + 2*r*(28*s - 5) + 80*s**2 - 62*s + 8) - 7*r**2*(4*K - 8) - 7*r*(8*K*s - 3*K - 16*s + 10) - 7*s*(4*K*s - 3*K - 8*s + 4)))) + b1*(176*D1*K*f*fd*k1**2*r**2 + 296*D1*K*f*fd*k1**2*r*s - 176*D1*K*f*fd*k1**2*r + 120*D1*K*f*fd*k1**2*s**2 - 152*D1*K*f*fd*k1**2*s + 44*D1*K*f*fd*k1**2 + 60*D1*K*f*fd*k2**2*r**2 + 112*D1*K*f*fd*k2**2*r*s - 30*D1*K*f*fd*k2**2*r + 52*D1*K*f*fd*k2**2*s**2 - 30*D1*K*f*fd*k2**2*s + 24*D1*b2*fd*k1**2*r**2 + 48*D1*b2*fd*k1**2*r*s + 8*D1*b2*fd*k1**2*r + 24*D1*b2*fd*k1**2*s**2 + 8*D1*b2*fd*k1**2*s - 4*D1*b2*fd*k1**2 + 14*D1*b2*fd*k2**2*r**2 + 28*D1*b2*fd*k2**2*r*s + 14*D1*b2*fd*k2**2*s**2 + D1*bd1*f*(4*k1**2*(-14*C*r*s - 14*C*s**2 + 14*C*s + K*(-2*r**2 + 2*r*s + 19*r + 4*s**2 + 25*s - 17) + f*(4*s - 5) + 7*r*s + 7*s**2 - 8*s + 1) + k2**2*(f*(24*r**2 + r*(5 - 56*s) - 80*s**2 + 57*s - 3) + 28*r**2*(K - 2) + 28*r*(K*(2*s - 1) - 4*s + 3) + 28*s*(K*(s - 1) - 2*s + 1))) + 2*D1*bd2*f*(2*k1**2*(6*r + 6*s + 1) + 7*k2**2*(r + s))*(r + s - 1) - 90*D1*f**2*fd*k1**2*r*s + 70*D1*f**2*fd*k1**2*r - 90*D1*f**2*fd*k1**2*s**2 + 128*D1*f**2*fd*k1**2*s - 46*D1*f**2*fd*k1**2 - 45*D1*f**2*fd*k2**2*r**2 - 243*D1*f**2*fd*k2**2*r*s + 148*D1*f**2*fd*k2**2*r - 198*D1*f**2*fd*k2**2*s**2 + 235*D1*f**2*fd*k2**2*s - 81*D1*f**2*fd*k2**2 - 32*D1*f*fd*k1**2*r*s - 32*D1*f*fd*k1**2*s**2 + 16*D1*f*fd*k1**2*s - 48*D1*f*fd*k2**2*r**2 - 96*D1*f*fd*k2**2*r*s + 24*D1*f*fd*k2**2*r - 48*D1*f*fd*k2**2*s**2 + 8*D1*f*gd2*k1**2*r**2 - 8*D1*f*gd2*k1**2*r*s - 144*D1*f*gd2*k1**2*r - 16*D1*f*gd2*k1**2*s**2 - 120*D1*f*gd2*k1**2*s + 136*D1*f*gd2*k1**2 - 28*D1*f*gd2*k2**2*r**2 - 56*D1*f*gd2*k2**2*r*s + 28*D1*f*gd2*k2**2*r - 28*D1*f*gd2*k2**2*s**2 + 28*D1*f*gd2*k2**2*s + 8*D1*fd*g2*k1**2*r**2 - 8*D1*fd*g2*k1**2*r*s - 128*D1*fd*g2*k1**2*r - 16*D1*fd*g2*k1**2*s**2 - 104*D1*fd*g2*k1**2*s + 64*D1*fd*g2*k1**2 - 28*D1*fd*g2*k2**2*r**2 - 56*D1*fd*g2*k2**2*r*s - 28*D1*fd*g2*k2**2*s**2 + 352*Dd*K*f**2*k1**2*r**2 + 592*Dd*K*f**2*k1**2*r*s - 448*Dd*K*f**2*k1**2*r + 240*Dd*K*f**2*k1**2*s**2 - 368*Dd*K*f**2*k1**2*s + 140*Dd*K*f**2*k1**2 + 120*Dd*K*f**2*k2**2*r**2 + 224*Dd*K*f**2*k2**2*r*s - 82*Dd*K*f**2*k2**2*r + 104*Dd*K*f**2*k2**2*s**2 - 82*Dd*K*f**2*k2**2*s + 96*Dd*b2*f*k1**2*r**2 + 192*Dd*b2*f*k1**2*r*s - 56*Dd*b2*f*k1**2*r + 96*Dd*b2*f*k1**2*s**2 - 56*Dd*b2*f*k1**2*s - 12*Dd*b2*f*k1**2 + 56*Dd*b2*f*k2**2*r**2 + 112*Dd*b2*f*k2**2*r*s - 42*Dd*b2*f*k2**2*r + 56*Dd*b2*f*k2**2*s**2 - 42*Dd*b2*f*k2**2*s - 120*Dd*f**3*k1**2*r*s + 100*Dd*f**3*k1**2*r - 120*Dd*f**3*k1**2*s**2 + 184*Dd*f**3*k1**2*s - 72*Dd*f**3*k1**2 - 60*Dd*f**3*k2**2*r**2 - 324*Dd*f**3*k2**2*r*s + 207*Dd*f**3*k2**2*r - 264*Dd*f**3*k2**2*s**2 + 323*Dd*f**3*k2**2*s - 103*Dd*f**3*k2**2 - 64*Dd*f**2*k1**2*r*s + 16*Dd*f**2*k1**2*r - 64*Dd*f**2*k1**2*s**2 + 56*Dd*f**2*k1**2*s - 8*Dd*f**2*k1**2 - 96*Dd*f**2*k2**2*r**2 - 192*Dd*f**2*k2**2*r*s + 120*Dd*f**2*k2**2*r - 96*Dd*f**2*k2**2*s**2 + 48*Dd*f**2*k2**2*s + 32*Dd*f*g2*k1**2*r**2 - 32*Dd*f*g2*k1**2*r*s - 424*Dd*f*g2*k1**2*r - 64*Dd*f*g2*k1**2*s**2 - 424*Dd*f*g2*k1**2*s + 336*Dd*f*g2*k1**2 - 112*Dd*f*g2*k2**2*r**2 - 224*Dd*f*g2*k2**2*r*s + 84*Dd*f*g2*k2**2*r - 112*Dd*f*g2*k2**2*s**2 + 84*Dd*f*g2*k2**2*s) + 2*f*(66*C*D1*f*fd*k1**2*r*s - 22*C*D1*f*fd*k1**2*r + 66*C*D1*f*fd*k1**2*s**2 - 88*C*D1*f*fd*k1**2*s + 22*C*D1*f*fd*k1**2 + 88*C*Dd*f**2*k1**2*r*s - 44*C*Dd*f**2*k1**2*r + 88*C*Dd*f**2*k1**2*s**2 - 132*C*Dd*f**2*k1**2*s + 44*C*Dd*f**2*k1**2 + D1*b2*fd*(2*k1**2*(44*r**2 + r*(74*s - 44) + 30*s**2 - 38*s + 11) + k2**2*(30*r**2 + r*(56*s - 15) + s*(26*s - 15))) + D1*bd2*f*(k1**2*(44*r**2 + r*(74*s - 68) + 30*s**2 - 54*s + 24) + k2**2*(15*r**2 + r*(28*s - 13) + s*(13*s - 13))) - 33*D1*f*fd*k1**2*r*s + 11*D1*f*fd*k1**2*r - 33*D1*f*fd*k1**2*s**2 + 44*D1*f*fd*k1**2*s - 11*D1*f*fd*k1**2 - 88*D1*f*gd2*k1**2*r**2 - 148*D1*f*gd2*k1**2*r*s + 136*D1*f*gd2*k1**2*r - 60*D1*f*gd2*k1**2*s**2 + 108*D1*f*gd2*k1**2*s - 48*D1*f*gd2*k1**2 - 30*D1*f*gd2*k2**2*r**2 - 56*D1*f*gd2*k2**2*r*s + 26*D1*f*gd2*k2**2*r - 26*D1*f*gd2*k2**2*s**2 + 26*D1*f*gd2*k2**2*s - 176*D1*fd*g2*k1**2*r**2 - 296*D1*fd*g2*k1**2*r*s + 176*D1*fd*g2*k1**2*r - 120*D1*fd*g2*k1**2*s**2 + 152*D1*fd*g2*k1**2*s - 44*D1*fd*g2*k1**2 - 60*D1*fd*g2*k2**2*r**2 - 112*D1*fd*g2*k2**2*r*s + 30*D1*fd*g2*k2**2*r - 52*D1*fd*g2*k2**2*s**2 + 30*D1*fd*g2*k2**2*s + Dd*b2*f*(2*k1**2*(88*r**2 + 4*r*(37*s - 28) + 60*s**2 - 92*s + 35) + k2**2*(60*r**2 + r*(112*s - 41) + s*(52*s - 41))) - 44*Dd*f**2*k1**2*r*s + 22*Dd*f**2*k1**2*r - 44*Dd*f**2*k1**2*s**2 + 66*Dd*f**2*k1**2*s - 22*Dd*f**2*k1**2 - 352*Dd*f*g2*k1**2*r**2 - 592*Dd*f*g2*k1**2*r*s + 448*Dd*f*g2*k1**2*r - 240*Dd*f*g2*k1**2*s**2 + 368*Dd*f*g2*k1**2*s - 140*Dd*f*g2*k1**2 - 120*Dd*f*g2*k2**2*r**2 - 224*Dd*f*g2*k2**2*r*s + 82*Dd*f*g2*k2**2*r - 104*Dd*f*g2*k2**2*s**2 + 82*Dd*f*g2*k2**2*s))/(21*d**2*k3**3) - D1**3*Pk1*Pkd3*st**2*(2145*b1**3*k2**2*(13*k1**2 + 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 429*b1**2*(D1*(-5*bd1*f*k2**2*(13*k1**2 + 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(20*C - 10)*(r + s - 1)**2 + k1**2*k2**2*(140*C*(r + s - 1)**2 - 2*K*(126*r**2 + 226*r*s + 10*r + 100*s**2 + 10*s - 5) + f*(136*r**2 + 5*r*(64*s - 19) + 184*s**2 - 107*s - 5) - 44*r**2 - 88*r*s + 140*r - 44*s**2 + 140*s - 70) - k2**4*(f*(82*r**2 + r*(158*s - 103) + 76*s**2 - 101*s + 39) + (14*r + 14*s)*(5*K*s + r*(9*K - 2))))) + Dd*f*(k1**4*(20*C - 10)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k1**2*k2**2*(70*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 504*K*r**2 - 904*K*r*s + 318*K*r - 400*K*s**2 + 300*K*s + 15*K + 2*f*(68*r**2 + 160*r*s - 77*r + 92*s**2 - 80*s + 12) - 88*r**2 - 176*r*s + 220*r - 88*s**2 + 199*s - 105) - k2**4*(14*K*s*(20*s - 17) + f*(164*r**2 + r*(316*s - 217) + 152*s**2 - 213*s + 73) + 14*r**2*(36*K - 8) + 14*r*(K*(56*s - 23) - 8*s + 4) + 14*s))) - 13*b1*(33*D1*bd1*f*(k1**4*(20*C - 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(140*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*K*(252*r**2 + 452*r*s - 227*r + 200*s**2 - 215*s - 5) + f*(136*r**2 + r*(320*s - 213) + 184*s**2 - 213*s + 53) - 88*r**2 - 176*r*s + 172*r - 88*s**2 + 144*s - 70) - 2*k2**4*(14*K*s*(5*s - 6) + f*(41*r**2 + r*(79*s - 57) + 38*s**2 - 56*s + 17) + 7*r**2*(18*K - 4) + 7*r*(4*K*(7*s - 4) - 4*s + 3) + 7*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(861*r**2 + r*(2070*s - 959) + 1209*s**2 - 1191*s + 274) - 44*k2**2*(45*r**2 + r*(72*s - 52) + 27*s**2 - 40*s + 17)) - 22*f*(fd*(k1**4*(2*C*(24*r**2 + r*(100*s - 43) + 76*s**2 - 53*s + 5) - 24*r**2 + r*(46 - 104*s) - 80*s**2 + 59*s - 7) + k1**2*k2**2*(-4*C*(28*r**2 + r*(43*s - 23) + 15*s**2 - 16*s + 3) + K*(132*r**2 + 4*r*(60*s - 31) + 108*s**2 - 106*s + 29) + 48*r**2 + 70*r*s - 38*r + 22*s**2 - 24*s + 4) - k2**4*(K*s*(10*s - 7) + r**2*(18*K - 4) + r*(K*(28*s - 9) - 4*s + 2) + s)) + k2**2*(5*bd2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*gd2*(k1**2*(126*r**2 + r*(226*s - 101) + 100*s**2 - 95*s - 5) + 7*k2**2*(9*r**2 + 7*r*(2*s - 1) + s*(5*s - 5))))) + 22*fd*k2**2*(-5*b2*(13*k1**2 + 7*k2**2)*(r + s)**2 + 2*g2*(k1**2*(126*r**2 + 226*r*s + 10*r + 100*s**2 + 10*s - 5) + 7*k2**2*(9*r**2 + 14*r*s + 5*s**2)))) + Dd*f*(f**2*k2**2*(k1**2*(3444*r**2 + r*(8280*s - 4651) + 4836*s**2 - 5791*s + 1599) - 66*k2**2*(120*r**2 + 2*r*(96*s - 71) + 72*s**2 - 110*s + 41)) - 66*f*(k1**4*(4*C*(24*r**2 + 2*r*(50*s - 27) + 76*s**2 - 65*s + 13) - 48*r**2 + r*(114 - 208*s) - 160*s**2 + 143*s - 31) + k1**2*k2**2*(-4*C*(56*r**2 + r*(86*s - 65) + 30*s**2 - 47*s + 18) + K*(264*r**2 + 6*r*(80*s - 49) + 216*s**2 - 256*s + 71) + 96*r**2 + 140*r*s - 106*r + 44*s**2 - 70*s + 27) - k2**4*(K*s*(20*s - 17) + r**2*(36*K - 8) + r*(K*(56*s - 23) - 8*s + 4) + s)) + 66*k2**2*(-5*b2*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(504*r**2 + r*(904*s - 318) + 400*s**2 - 300*s - 15) + 7*k2**2*(36*r**2 + r*(56*s - 23) + s*(20*s - 17)))))) - f*(13*D1*bd1*(f**2*k2**2*(k1**2*(861*r**2 + 2*r*(1035*s - 887) + 1209*s**2 - 2218*s + 777) - 66*k2**2*(30*r**2 + r*(48*s - 38) + 18*s**2 - 30*s + 7)) - 66*f*(2*k1**4*(C*(12*r**2 + r*(50*s - 23) + 38*s**2 - 29*s + 11) - 6*r**2 - 2*r*(13*s - 6) - 20*s**2 + 16*s - 6) + k1**2*k2**2*(-2*C*(28*r**2 + r*(43*s - 47) + 15*s**2 - 36*s + 19) + K*(66*r**2 + 120*r*s - 85*r + 54*s**2 - 75*s + 21) + 24*r**2 + 35*r*s - 38*r + 11*s**2 - 27*s + 15) - k2**4*(5*K*s*(s - 1) + r**2*(9*K - 2) + r*(7*K - 1)*(2*s - 1))) - 66*k2**2*(5*b2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(2*k1**2*(63*r**2 + r*(113*s - 63) + 10*s*(5*s - 6)) + 7*k2**2*(9*r**2 + r*(14*s - 9) + s*(5*s - 7))))) + D1*(f**2*fd*k2**2*(2*k1**2*(6400*r**2 + 10*r*(1056*s - 1121) + 4160*s**2 - 10869*s + 5477) + 13*k2**2*(1260*r**2 + r*(5148*s - 3239) + 3888*s**2 - 4851*s + 1541)) - 26*f*(fd*k1**2*(k1**2*(2*C*(135*r**2 + 1566*r*s - 975*r + 1431*s**2 - 1773*s + 568) - 135*r**2 - 1620*r*s + 1059*r - 1485*s**2 + 1926*s - 635) - 33*k2**2*(2*C*(117*r**2 + 213*r*s - 148*r + 96*s**2 - 129*s + 45) - 132*r**2 - 237*r*s + 163*r - 105*s**2 + 139*s - 48)) + 33*k2**2*(5*bd2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(r + s - 1) - 2*gd2*(k1**2*(66*r**2 + 5*r*(24*s - 17) + 54*s**2 - 75*s + 21) + k2**2*(-9*r**2 + r*(7 - 14*s) - s*(5*s - 5))))) + 858*fd*k2**2*(-5*b2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(2*r + 2*s - 1) + 2*g2*(k1**2*(132*r**2 + 4*r*(60*s - 31) + 108*s**2 - 106*s + 29) + k2**2*(-18*r**2 + r*(9 - 28*s) + s*(7 - 10*s))))) + Dd*f*(f**2*k2**2*(2*k1**2*(6400*r**2 + 10*r*(1056*s - 1121) + 4160*s**2 - 10869*s + 5477) + 13*k2**2*(1260*r**2 + r*(5148*s - 3239) + 3888*s**2 - 4851*s + 1541)) - 26*f*k1**2*(k1**2*(2*C*(180*r**2 + 9*r*(232*s - 167) + 1908*s**2 - 2617*s + 935) - 180*r**2 - 2160*r*s + 1621*r - 1980*s**2 + 2830*s - 1044) - 66*k2**2*(C*(156*r**2 + 284*r*s - 211*r + 128*s**2 - 183*s + 67) - 88*r**2 - 158*r*s + 117*r - 70*s**2 + 99*s - 36)) + 858*k2**2*(-5*b2*(k1**2*(8*r + 8*s - 3) - k2**2*(r + s))*(4*r + 4*s - 3) + 2*g2*(k1**2*(264*r**2 + 6*r*(80*s - 49) + 216*s**2 - 256*s + 71) + k2**2*(-36*r**2 + r*(23 - 56*s) + s*(17 - 20*s)))))))/(9009*d**2*k3**5) + 2*D1**3*Pk1*Pkd3*st**2*(D1*bd1*f**2*(k1**2*(r**2*(8*C - 4) + r*(4*C*(4*s - 3) - 10*s + 7) + 2*s*(C*(4*s - 2) - 3*s + 2)) + k2**2*r*(2*r + 2*s - 1)) + 2*b1**3*k2**2*(2*D1*fd*r*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + b1**2*(2*D1*bd1*f*k2**2*(6*r**2 + 6*r*(s - 1) - s + 1) + D1*fd*(-k1**2*(28*C - 12)*(s - 1) + k2**2*(f*(20*r - 9) - 16*r + 2))*(r + s - 1) + Dd*f*k1**2*(-56*C*(2*s - 1)*(r + s - 1) + r*(48*s - 22) + 48*s**2 - 71*s + 23) + Dd*f*k2**2*(f*(40*r**2 + 8*r*(5*s - 6) - 13*s + 11) - 64*r**2 + r*(68 - 64*s) + 12*s - 11)) + b1*f*(-D1*bd1*(k1**2*(r*(s*(56*C - 24) - 2) + (s - 1)*(s*(56*C - 24) - 1)) + k2**2*(f*(-20*r**2 - 20*r*s + 19*r + 4*s - 2) + 32*r**2 + 32*r*s - 33*r - 9*s + 8)) + D1*fd*(k1**2*(16*C*(r + s - 1) - 8*r - 12*s + 11) + k2**2*(4*r - 1))*(r + s - 1) + Dd*f*(k1**2*(4*C*(8*r**2 + 2*r*(8*s - 7) + 8*s**2 - 12*s + 5) - 16*r**2 - 40*r*s + 34*r - 24*s**2 + 37*s - 15) + k2**2*(8*r**2 + 8*r*(s - 1) - s + 1))))/(21*d**2*k1**2*k3) + D1**3*Pk1*Pkd3*(2*D1*bd1*f*k1**2*(-6*b2*(r**2 + r*(s - 1) - 4*s) - f*s*(26*C - 13)*(r + s - 1) + 12*g2*(r**2 + r*(s - 1) - 4*s)) + 7*b1**3*(D1*fd*(2*k1**2*(s - 1) - 3*k2**2*r)*(r + s - 1) + Dd*f*(4*k1**2*(r*(2*s - 3) + 2*(s - 1)**2) - 3*k2**2*(4*r - 1)*(r + s - 1))) + b1**2*(7*D1*bd1*f*(2*k1**2*(r*(3*s - 5) + 3*(s - 1)**2) - 3*k2**2*(3*r - 1)*(r + s - 1)) - D1*fd*(9*f*k2**2*(2*r - 1) + 2*k1**2*(14*C*(s - 1) + 6*K*r - 6*K - 30*f*s + 27*f - 11*s + 7))*(r + s - 1) + Dd*f*(-9*f*k2**2*(4*r - 1)*(r + s - 1) - 4*k1**2*(14*C*(2*s - 1)*(r + s - 1) + 12*K*r**2 + 12*K*r*s - 39*K*r - 39*K*s + 27*K - 3*f*(10*r*s - 9*r + 10*s**2 - 17*s + 7) - 22*r*s + 9*r - 22*s**2 + 30*s - 9))) + 2*b1*(D1*bd1*f*(-9*f*k2**2*r*(r + s - 1) + k1**2*(-28*C*r*s - 28*C*s**2 + 28*C*s - 12*K*(r**2 + r*(s - 3) - 4*s + 2) + 3*f*(10*r*s - 9*r + 10*s**2 - 15*s + 5) + 22*r*s - 2*r + 22*s**2 - 22*s + 2)) + k1**2*(-52*C*D1*f*fd*r*s + 26*C*D1*f*fd*r - 52*C*D1*f*fd*s**2 + 78*C*D1*f*fd*s - 26*C*D1*f*fd - 104*C*Dd*f**2*r*s + 52*C*Dd*f**2*r - 104*C*Dd*f**2*s**2 + 156*C*Dd*f**2*s - 52*C*Dd*f**2 - 6*D1*bd2*f*(r - 4)*(r + s - 1) + 26*D1*f*fd*r*s - 13*D1*f*fd*r + 26*D1*f*fd*s**2 - 39*D1*f*fd*s + 13*D1*f*fd + 12*D1*f*gd2*r**2 + 12*D1*f*gd2*r*s - 60*D1*f*gd2*r - 48*D1*f*gd2*s + 48*D1*f*gd2 + 12*D1*fd*g2*r**2 + 12*D1*fd*g2*r*s - 24*D1*fd*g2*r - 12*D1*fd*g2*s + 12*D1*fd*g2 + 52*Dd*f**2*r*s - 26*Dd*f**2*r + 52*Dd*f**2*s**2 - 78*Dd*f**2*s + 26*Dd*f**2 + 48*Dd*f*g2*r**2 + 48*Dd*f*g2*r*s - 156*Dd*f*g2*r - 156*Dd*f*g2*s + 108*Dd*f*g2 - 6*b2*(D1*fd*(r - 1)*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s - 13*r - 13*s + 9)))))/(21*d**2*k1**2*k3) - 4*D1**3*Pk1*Pkd3*st**4*(33*b1**2*(D1*fd*(k1**4*(8*C - 4)*(s - 1)*(r + s - 1) - k1**2*k2**2*(r + s - 1)*(2*C*(5*r + s - 1) - 7*r - s + 1) - 2*k2**4*r*(r + s)) + Dd*f*(k1**4*(4*C - 2)*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + k1**2*k2**2*(-2*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) + 28*r**2 + r*(32*s - 31) + 4*s**2 - 10*s + 6) + k2**4*(-8*r**2 + r*(4 - 8*s) + s))) + b1*f*(33*D1*bd1*(k1**4*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + k1**2*k2**2*(-2*C*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3) + 14*r**2 + 16*r*s - 15*r + 2*s**2 - 6*s + 4) + k2**4*(-4*r**2 + r*(3 - 4*s) + s)) + D1*fd*(k1**4*(132*C - 66)*(r + s)*(2*s - 1) - 33*k1**2*k2**2*(4*C*(2*r**2 - 2*r*s + r - (1 - 2*s)**2) - 6*r**2 - 2*r + 6*s**2 - 7*s + 2) - 4*k2**4*(2*f*(3*r - 1)*(6*r + 6*s - 5) - 33*r*(2*r + 2*s - 1))) + Dd*f*(k1**4*(264*C - 132)*(r + s)*(2*s - 1) - 33*k1**2*k2**2*(4*C*(4*r**2 - 4*r*s + r - 2*(1 - 2*s)**2) - 12*r**2 - r + 12*s**2 - 12*s + 4) + k2**4*(-4*f*(48*r**2 + r*(48*s - 52) - 14*s + 11) + 528*r**2 + 132*r*(4*s - 3) - 66*s + 33))) + f**2*(D1*bd1*(k1**4*s*(132*C - 66)*(r + s) - 33*k1**2*k2**2*(r**2*(4*C - 3) + r*(-4*C*(s + 1) + 3) + s*(C*(4 - 8*s) + 3*s)) + k2**4*(f*(-48*r**2 - 48*r*s + 40*r + 8*s - 4) + 132*r**2 + 132*r*s - 165*r - 66*s + 33)) + 3*D1*fd*k1**2*(k1**2*(8*C - 4)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(2*C*(3*r - 1)*(r + s + 3) + 15*r**2 + r*(33*s - 32) + 18*s**2 - 23*s + 11)) + Dd*f*k1**4*(12*C - 6)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 3*Dd*f*k1**2*k2**2*(2*C*(4*r**2 + r*(4*s + 7) - 3*s - 1) + 20*r**2 + r*(44*s - 41) + 24*s**2 - 31*s + 13)))/(231*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*st**2*(-33*D1*b1*bd1*f*(2*k1**4*(2*C*(10*r**2 - r*(8*s + 15) - 18*s**2 + 13*s + 5) - 10*r**2 + r*(4*s + 17) + 14*s**2 - 8*s - 6) + k1**2*k2**2*(28*C*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3) + 2*K*(-18*r**2 - 44*r*s + 15*r - 26*s**2 + 21*s + 3) + f*(22*r**2 + r*(108*s - 49) + 86*s**2 - 143*s + 41) - 152*r**2 - 128*r*s + 182*r + 24*s**2 + 22*s - 58) + 2*k2**4*(3*f*(2*r - 1)*(3*r + 3*s - 2) + 28*r**2 + 7*r*(4*s - 3) - 7*s)) + 33*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(25*r + 39*s - 39) - 33*b1**2*(D1*(-bd1*f*k1**2*k2**2*(75*r**2 + r*(192*s - 167) + 117*s**2 - 195*s + 78) + 2*fd*(k1**4*(r + s - 1)*(2*C*(5*r - 9*s + 9) - 5*r + 7*s - 7) + k1**2*k2**2*(14*C*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 9*K*r**2 - 22*K*r*s - 10*K*r - 13*K*s**2 - 6*K*s + 5*K + f*(11*r**2 + 6*r*(9*s - 7) + 43*s**2 - 77*s + 34) - 38*r**2 - 32*r*s + 60*r + 6*s**2 + 16*s - 9) + 2*k2**4*r*(f*(9*r + 9*s - 6) + 7*r + 7*s))) + Dd*f*(2*k1**4*(2*C*(20*r**2 - r*(16*s + 7) - 36*s**2 + 49*s - 13) - 20*r**2 + 8*r*s + 13*r + 28*s**2 - 36*s + 8) + k1**2*k2**2*(28*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) - 72*K*r**2 - 176*K*r*s + 22*K*r - 104*K*s**2 + 50*K*s + 22*K + f*(44*r**2 + 216*r*s - 133*r + 172*s**2 - 297*s + 109) - 304*r**2 - 256*r*s + 408*r + 48*s**2 + 58*s - 92) + 2*k2**4*(3*f*(4*r - 1)*(3*r + 3*s - 2) + 56*r**2 + 7*r*(8*s - 4) - 7*s))) + 2*b1*(3*D1*(f**2*fd*k2**2*(k1**2*(321*r**2 + 3*r*(41*s - 93) - 198*s**2 + 124*s + 28) - 11*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 11*f*(fd*(k1**4*(4*C*(r**2 - 24*r*s - 25*s**2 + 5*s + 6) - 2*r**2 + 48*r*s + 50*s**2 - 9*s - 13) + k1**2*k2**2*(-2*C*(16*r**2 + 6*r*(5*s - 4) + 14*s**2 - 18*s + 7) + 2*K*(6*r**2 + 6*r*s - r - 2*s - 1) + 28*r**2 + 50*r*s - 37*r + 22*s**2 - 27*s + 10) + k2**4*(-4*r**2 + r*(2 - 4*s) + s)) - k1**2*k2**2*(bd2*(13*r + 13*s + 1) - 2*gd2*(9*r + 13*s + 3))*(r + s - 1)) + 11*fd*k1**2*k2**2*(b2*(13*r**2 + r*(26*s + 2) + 13*s**2 + 2*s - 1) - 2*g2*(9*r**2 + 2*r*(11*s + 5) + 13*s**2 + 6*s - 5))) + Dd*f*(f**2*k2**2*(k1**2*(1284*r**2 + r*(492*s - 1123) - 792*s**2 + 566*s + 54) - 33*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 33*f*(k1**4*(2*C - 1)*(4*r**2 + r*(17 - 96*s) - 100*s**2 + 43*s + 11) + k1**2*k2**2*(-2*C*(32*r**2 + r*(60*s - 46) + 28*s**2 - 36*s + 13) + 6*K*(4*r**2 + 4*r*s - 3*r - 2*s + 1) + 56*r**2 + 100*r*s - 78*r + 44*s**2 - 61*s + 23) + k2**4*(-8*r**2 + r*(4 - 8*s) + s)) + 33*k1**2*k2**2*(b2*(52*r**2 + r*(104*s - 35) + 52*s**2 - 35*s - 3) + 2*g2*(-36*r**2 + r*(11 - 88*s) - 52*s**2 + 25*s + 11)))) + 2*f*(D1*bd1*(f**2*k2**2*(k1**2*(321*r**2 + 123*r*s - 286*r - 198*s**2 + 194*s - 30) - 33*k2**2*r*(3*r + 3*s - 2)) - 33*f*(k1**4*(2*C*(r**2 - r*(24*s + 1) - 25*s**2 + 9*s - 2) - r**2 + 24*r*s + r + 25*s**2 - 10*s + 3) + k1**2*k2**2*(-2*C*(8*r**2 + r*(15*s - 8) + 7*s**2 - 7*s + 2) + K*(6*r**2 + 6*r*s - 8*r - 4*s + 4) + 14*r**2 + 25*r*s - 18*r + 11*s**2 - 16*s + 6) + k2**4*r*(-2*r - 2*s + 1)) + 33*k1**2*k2**2*(13*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(9*r**2 + r*(22*s - 9) + s*(13*s - 11)))) + k1**2*(D1*(f*(fd*(k1**2*(-4*C*(54*r**2 - 540*r*s + 177*r - 594*s**2 + 576*s - 131) + 108*r**2 - 1134*r*s + 438*r - 1242*s**2 + 1305*s - 329) - 33*k2**2*(2*C*(9*r**2 + 3*r*(9*s - 5) + 18*s**2 - 18*s + 5) - 24*r**2 - 51*r*s + 30*r - 27*s**2 + 28*s - 8)) + k2**2*(-66*bd2 + 132*gd2)*(3*r**2 + r*(3*s - 4) - 2*s + 2)) - 66*fd*k2**2*(b2 - 2*g2)*(6*r**2 + r*(6*s - 1) - 2*s - 1)) + Dd*f*(f*(k1**2*(-4*C*(72*r**2 - 720*r*s + 324*r - 792*s**2 + 881*s - 238) + 144*r**2 - 1512*r*s + 766*r - 1656*s**2 + 1975*s - 585) - 33*k2**2*(2*C*(12*r**2 + 36*r*s - 23*r + 24*s**2 - 27*s + 8) - 32*r**2 - 68*r*s + 46*r - 36*s**2 + 42*s - 13)) + k2**2*(-198*b2 + 396*g2)*(4*r**2 + r*(4*s - 3) - 2*s + 1)))))/(693*d**2*k1**2*k3**3) + D1**3*Pk1*Pkd3*st**4*(D1*(1716*b1*fd*k1**2*k2**2*(5*b1**2*k2**2*(r + s - 1)**2 + b1*(k1**2*(5 - 10*C)*(r + s - 1)**2 + k2**2*(r + s)*(5*K*s + r*(9*K - 2))) + k2**2*(r + s)*(5*b2*(r + s) - 2*g2*(9*r + 5*s))) + f**3*k2**4*(26*bd1*k1**2*(126*r**2 + r*(171*s - 122) + 45*s**2 + 17*s - 20) - 143*bd1*k2**2*(r - 1)*(5*r + 5*s - 3) + 4*fd*k1**2*(1284*r**2 + 2*r*(5*s - 226) - 1274*s**2 + 1538*s - 419) - 39*fd*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 39*f**2*(22*bd1*k1**2*(k1**4*s*(8*C - 4)*(r + s) - 2*k1**2*k2**2*(r**2*(22*C - 12) + 2*r*(14*C*s - 11*C - 8*s + 6) + s*(6*C*s - 14*C - 4*s + 9)) + k2**4*(-4*C*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + b1*(32*r**2 + r*(68*s - 55) + 36*s**2 - 59*s + 23) + 44*r**2 + 64*r*s - 60*r + 20*s**2 - 42*s + 16)) + fd*(2*b1*k1**2*k2**4*(126*r**2 + 3*r*(57*s - 62) + 45*s**2 - 55*s + 34) - 11*b1*k2**6*r*(5*r + 5*s - 3) + k1**6*(32*C - 16)*(3*s - 1)*(3*r + 3*s - 2) - 4*k1**4*k2**2*(2*C*(159*r**2 + r*(285*s - 212) + 126*s**2 - 179*s + 67) - 177*r**2 + r*(236 - 321*s) - 144*s**2 + 203*s - 75))) + 858*f*k1**2*(b1**2*k2**4*(10*bd1*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(32*r**2 + r*(68*s - 49) + 36*s**2 - 51*s + 19)) - 2*b1*(bd1*(k1**2*k2**2*(10*C - 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - k2**4*(2*K*s*(5*s - 6) + r**2*(18*K - 4) + r*(4*K*(7*s - 4) - 4*s + 3) + s)) + fd*(k1**4*(2 - 4*C)*(r + s)*(2*s - 1) + k1**2*k2**2*(2*C*(22*r**2 + r*(28*s - 5) + 6*s**2 + s - 2) - 24*r**2 + r*(5 - 32*s) - 8*s**2 + 2) + k2**4*(2*r + 2*s - 1)*(2*C*(18*r + 10*s - 5) - 22*r - 10*s + 5)) + k2**4*(-5*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(9*r**2 + 7*r*(2*s - 1) + s*(5*s - 5)))) + 2*bd1*k2**4*(5*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(9*r**2 + r*(14*s - 9) + s*(5*s - 7))))) + Dd*f*(1716*b1*f*k1**2*(k1**4*(8*C - 4)*(r + s)*(2*s - 1) + k1**2*k2**2*(-2*C*(44*r**2 + 7*r*(8*s - 3) + 12*s**2 - 7*s - 4) + 48*r**2 + 64*r*s - 22*r + 16*s**2 - 11*s - 4) + k2**4*(-2*C*(72*r**2 + 2*r*(56*s - 37) + 40*s**2 - 54*s + 17) + b1*(32*r**2 + r*(68*s - 52) + 36*s**2 - 55*s + 21) + 88*r**2 + 128*r*s - 86*r + 40*s**2 - 56*s + 18)) + 1716*b1*k1**2*k2**2*(5*b1**2*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + b1*(k1**2*(5 - 10*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(K*s*(20*s - 17) + r**2*(36*K - 8) + r*(K*(56*s - 23) - 8*s + 4) + s)) + k2**2*(5*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) - 2*g2*(36*r**2 + r*(56*s - 23) + s*(20*s - 17)))) + f**3*k2**4*(4*k1**2*(1284*r**2 + 2*r*(5*s - 226) - 1274*s**2 + 1538*s - 419) - 39*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 13*f**2*(4*b1*k1**2*k2**4*(252*r**2 + r*(342*s - 340) + 90*s**2 - 74*s + 41) - 11*b1*k2**6*(4*r - 1)*(5*r + 5*s - 3) + k1**6*(48*C - 24)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 12*k1**4*k2**2*(2*C*(212*r**2 + r*(380*s - 293) + 168*s**2 - 249*s + 95) - 236*r**2 + r*(327 - 428*s) - 192*s**2 + 283*s - 107))))/(3003*d**2*k1**2*k3**5) + 4*D1**3*Pk1*Pkdd3*b1*ct*k2**3*st**4*(r + s - 1)*(D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(7*d**2*k1*k3**2) - 4*D1**3*Pk1*Pkdd3*b1*k2**2*st**4*(2*C - 1)*(r + s - 1)*(D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(7*d**2*k3**2) - D1**3*Pk1*Pkdd3*ct**8*f*k2**6*(40*C - 40)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(51*r + 51*s - 23))/(693*d**2*k3**6) - 20*D1**3*Pk1*Pkdd3*ct**7*f*k2**5*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(51*r + 51*s - 23))/(693*d**2*k1*k3**4) - 2*D1**3*Pk1*Pkdd3*ct**7*f*k2**5*(13*D1*bd1*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(r + s - 1) + 13*b1*(D1*fd*(5*f*k2**2*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + 66*k1**2*(2*r + 2*s - 1)*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43)) + Dd*f*(5*f*k2**2*(135*r + 135*s - 79) + 66*k1**2*(12*C*(7*r + 7*s - 4) - 74*r - 74*s + 43))*(4*r + 4*s - 3)) + 10*f*(D1*fd*(21*f*k2**2*(136*r**2 + 2*r*(136*s - 89) + 136*s**2 - 178*s + 57) + 13*k1**2*(3*r + 3*s - 2)*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187)) + Dd*f*(21*f*k2**2*(34*r + 34*s - 19) + 13*k1**2*(6*C*(69*r + 69*s - 35) - 363*r - 363*s + 187))*(4*r + 4*s - 3)))/(9009*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**6*f*k2**6*st**2*(20*C - 20)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(53*r + 53*s - 28))/(231*d**2*k3**6) - 4*D1**3*Pk1*Pkdd3*ct**6*k2**4*(396*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(12*D1*bd1*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*fd*(C*(-24*r**2 + r*(8 - 48*s) - 24*s**2 + 8*s + 6) + 48*r**2 + r*(96*s - 38) + 48*s**2 - 38*s + 3) - Dd*f*(4*r + 4*s - 3)*(2*C*(6*r + 6*s - 1) - 24*r - 24*s + 11)) + f**2*(-33*D1*bd1*(r + s - 1)*(2*C*(6*r + 6*s - 5) - 24*r - 24*s + 19) - (10*D1*fd*(3*r + 3*s - 2) + 10*Dd*f*(4*r + 4*s - 3))*(C*(51*r + 51*s - 23) - 78*r - 78*s + 41)))/(693*d**2*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**6*k2**4*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K - 10*b1*(2*r + 2*s - 1) + 20*r + 20*s - 13)) + k2**2*(r + s)*(792*K*b1 - 792*b1 - 792*g2)) + 858*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (6 - 6*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (6 - 6*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) + 66*f*(fd*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 792*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(309*r + 309*s - 217) + 66*f*(k1**2*(6*C*(22*r + 22*s - 15) - 100*r - 100*s + 71) + k2**2*(-12*C*(2*r + 2*s - 1) + 4*K*r + 4*K*s + K + 20*r + 20*s - 13)) - 792*g2*k2**2*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(1208*r**2 + 2*r*(1208*s - 815) + 1208*s**2 - 1630*s + 543) + 26*f*(5*fd*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 33*gd2*k2**2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1)) - 858*fd*g2*k2**2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(302*r + 302*s - 181) + 130*f*(k1**2*(3*C*(101*r + 101*s - 60) - 225*r - 225*s + 139) + k2**2*(33 - 33*C)*(2*r + 2*s - 1)) - 858*g2*k2**2*(4*r + 4*s + 1))))/(9009*d**2*k3**6) - 10*D1**3*Pk1*Pkdd3*ct**5*f*k2**5*st**2*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(53*r + 53*s - 28))/(231*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**5*f*k2**5*st**2*(39*D1*bd1*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(r + s - 1) + 39*b1*(D1*fd*(5*f*k2**2*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + 22*k1**2*(2*r + 2*s - 1)*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113)) + Dd*f*(5*f*k2**2*(177*r + 177*s - 107) + 22*k1**2*(4*C*(61*r + 61*s - 32) - 214*r - 214*s + 113))*(4*r + 4*s - 3)) + f*(D1*fd*(15*f*k2**2*(7076*r**2 + r*(14152*s - 9639) + 7076*s**2 - 9639*s + 3249) + 26*k1**2*(3*r + 3*s - 2)*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016)) + Dd*f*(15*f*k2**2*(1769*r + 1769*s - 1083) + 26*k1**2*(4*C*(1536*r + 1536*s - 859) - 5349*r - 5349*s + 3016))*(4*r + 4*s - 3)))/(9009*d**2*k1*k3**6) - 8*D1**3*Pk1*Pkdd3*ct**5*k2**3*(r + s - 1)*(2*D1*bd1*f**2*(r + s) + 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(2*r + 2*s - 1) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))/(21*d**2*k1*k3**2) - 2*D1**3*Pk1*Pkdd3*ct**5*k2**3*(66*b1**2*(D1*fd*(k1**2*(34*C - 28)*(r + s - 1)**2 + k2**2*(f*(28*r**2 + r*(56*s - 39) + 28*s**2 - 39*s + 16) + 6*(r + s)**2)) + Dd*f*(k1**2*(34*C - 28)*(r + s - 1) + k2**2*(f*(14*r + 14*s - 9) + 6*r + 6*s))*(4*r + 4*s - 3)) + b1*f*(66*D1*bd1*(k1**2*(34*C - 28)*(2*r + 2*s - 1) + k2**2*(f*(28*r + 28*s - 11) + 12*r + 12*s))*(r + s - 1) + D1*fd*(-132*k1**2*(2*C*(12*r**2 + 24*r*s - 5*r + 12*s**2 - 5*s - 3) - 18*r**2 - 36*r*s + 11*r - 18*s**2 + 11*s + 3) + k2**2*(5*f*(414*r**2 + 828*r*s - 591*r + 414*s**2 - 591*s + 233) - 1056*r**2 - 2112*r*s + 1452*r - 1056*s**2 + 1452*s - 462)) + 2*Dd*f*(-66*k1**2*(4*C*(3*r + 3*s - 1) - 9*r - 9*s + 5) + k2**2*(5*f*(69*r + 69*s - 41) - 264*r - 264*s + 231))*(4*r + 4*s - 3)) + f**2*(-D1*bd1*(132*k1**2*(2*C*(6*r + 6*s - 7) - 9*r - 9*s + 13) + k2**2*(f*(-690*r - 690*s + 65) + 528*r + 528*s - 462))*(r + s - 1) - (k1**2*(2*C*(105*r + 105*s - 59) - 147*r - 147*s + 98) + 33*k2**2*(2*r + 2*s - 1))*(10*D1*fd*(3*r + 3*s - 2) + 10*Dd*f*(4*r + 4*s - 3))))/(693*d**2*k1*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**5*k2**3*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 12*K*r + 12*K*s + 6*K + b1*(-58*r - 58*s + 32) + 88*r + 88*s - 59)) + k1**2*k2**2*(r + s)*(-264*b1*(8 - 11*K) - 2904*g2)) + 858*b1**2*k1**2*k2**2*(D1*fd*(f*(58*r**2 + r*(116*s - 61) + 58*s**2 - 61*s + 16) + (16 - 22*K)*(r + s)**2) + Dd*f*(f*(29*r + 29*s - 16) + (16 - 22*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*k1**2*(fd*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59))*(2*r + 2*s - 1) - 44*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2904*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3)) + 66*f*k1**2*(k1**2*(C*(88*r + 88*s - 80) - 54*r - 54*s + 54) + k2**2*(-12*C*(9*r + 9*s - 5) + 6*K*(2*r + 2*s + 1) + 88*r + 88*s - 59)) - 2904*g2*k1**2*k2**2*(r + s))) - 2*f*(D1*(70*f**2*fd*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 13*f*k1**2*(5*fd*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9))*(3*r + 3*s - 2) - 396*gd2*k2**2*(2*r**2 + r*(4*s - 1) + 2*s**2 - s - 1)) - 5148*fd*g2*k1**2*k2**2*(4*r**2 + 8*r*s + 4*s**2 - 1)) + Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(k1**2*(133*r + 133*s - 90) - 13*k2**2*(5*r + 5*s - 3)) + 65*f*k1**2*(k1**2*(4*C*(81*r + 81*s - 65) - 177*r - 177*s + 162) - 33*k2**2*(2*C*(9*r + 9*s - 5) - 16*r - 16*s + 9)) - 5148*g2*k1**2*k2**2*(2*r + 2*s + 1))))/(9009*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**4*f**2*k2**6*st**4*(40*C - 40)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)/(77*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**4*k2**4*st**2*(396*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*f*(12*D1*bd1*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*fd*(-6*C*(14*r**2 + 4*r*(7*s - 2) + 14*s**2 - 8*s - 1) + 148*r**2 + 2*r*(148*s - 59) + 148*s**2 - 118*s + 13) - Dd*f*(4*r + 4*s - 3)*(6*C*(7*r + 7*s - 2) - 74*r - 74*s + 31)) + f**2*(-33*D1*bd1*(r + s - 1)*(6*C*(7*r + 7*s - 5) - 74*r - 74*s + 49) - (D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(30*C*(53*r + 53*s - 28) - 2277*r - 2277*s + 1298)))/(693*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct**4*k2**4*st**2*(-39*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K + 10*b1*(2*r + 2*s - 1) - 5*r - 5*s + 3)) + k2**2*(r + s)*(264*K*b1 - 264*b1 - 264*g2)) + 2574*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1)**2 + (2 - 2*K)*(r + s)**2) + Dd*f*(5*f*(2*r + 2*s - 1) + (2 - 2*K)*(r + s))*(4*r + 4*s - 3)) - 39*b1*(D1*(5*f**2*fd*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) + 22*f*(fd*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3))*(2*r + 2*s - 1) - 12*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 264*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(347*r + 347*s - 235) + 22*f*(k1**2*(C*(398*r + 398*s - 220) - 306*r - 306*s + 171) - 3*k2**2*(C*(8*r + 8*s - 4) - 3*K*r - 3*K*s + K - 5*r - 5*s + 3)) - 264*g2*k2**2*(r + s))) + f*(D1*(-125*f**2*fd*k2**2*(2156*r**2 + r*(4312*s - 3013) + 2156*s**2 - 3013*s + 1047) - 26*f*(fd*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1))*(3*r + 3*s - 2) - 198*gd2*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 5148*fd*g2*k2**2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) - Dd*f*(4*r + 4*s - 3)*(125*f**2*k2**2*(539*r + 539*s - 349) + 26*f*(k1**2*(C*(9354*r + 9354*s - 5576) - 7077*r - 7077*s + 4278) + k2**2*(396 - 396*C)*(2*r + 2*s - 1)) - 5148*g2*k2**2*(3*r + 3*s - 1))))/(9009*d**2*k3**6) + 4*D1**3*Pk1*Pkdd3*ct**4*k2**2*(r + s - 1)*(2*D1*bd1*f**2*(4*C - 3)*(r + s) + b1**2*(12*C - 11)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(12*C - 11)*(2*r + 2*s - 1) + (8*C - 6)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k3**2) + 2*D1**3*Pk1*Pkdd3*ct**4*k2**2*(-D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(186*r + 186*s - 19) - 66*f*(2*k1**2*(6*C*(r + s - 2) - 2*r - 2*s + 7) + k2**2*(-12*C*(r + s - 1) + 4*K*r + 4*K*s + K + 26*r + 26*s - 28)) + k2**2*(-396*b2 + 924*g2)*(r + s)) + 396*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 66*b1**2*(D1*(-6*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(30*C - 19)*(r + s - 1)**2 - k2**2*(14*C*(r + s - 1)**2 + 7*K*r**2 + 14*K*r*s - 2*K*r + 7*K*s**2 - 2*K*s + K - f*(36*r**2 + 72*r*s - 43*r + 36*s**2 - 43*s + 15) - 25*r**2 - 50*r*s + 30*r - 25*s**2 + 30*s - 15))) + Dd*f*(k1**2*(30*C - 19)*(r + s - 1) + k2**2*(-14*C*(r + s - 1) - 7*K*r - 7*K*s + K + 2*f*(9*r + 9*s - 5) + 25*r + 25*s - 15))*(4*r + 4*s - 3)) - b1*(66*D1*bd1*f*(k1**2*(30*C - 19)*(2*r + 2*s - 1) + k2**2*(-14*C*(2*r + 2*s - 1) - 14*K*r - 14*K*s + K + 3*f*(12*r + 12*s - 5) + 50*r + 50*s - 15))*(r + s - 1) + D1*(5*f**2*fd*k2**2*(558*r**2 + 9*r*(124*s - 81) + 558*s**2 - 729*s + 263) - 66*f*(fd*(2*k1**2*(r**2*(12*C - 4) + r*(12*C*(2*s - 1) - 8*s + 7) + s**2*(12*C - 4) + s*(7 - 12*C) - 1) - k2**2*(12*C*(2*r**2 + 4*r*s + 2*s**2 - 1) + K*(-8*r**2 - 16*r*s + 2*r - 8*s**2 + 2*s + 1) - 52*r**2 - 104*r*s + 46*r - 52*s**2 + 46*s - 4)) + 2*k2**2*(3*bd2*(r + s) + gd2*(-7*r - 7*s + 1))*(r + s - 1)) + 132*fd*k2**2*(-3*b2*(r + s)**2 + g2*(7*r**2 + 2*r*(7*s - 1) + 7*s**2 - 2*s + 1))) + 2*Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(93*r + 93*s - 47) - 33*f*(4*k1**2*(3*C*(r + s - 1) - r - s + 2) + k2**2*(-12*C*r - 12*C*s + 4*K*r + 4*K*s + K + 26*r + 26*s - 16)) - 66*k2**2*(3*b2*(r + s) + g2*(-7*r - 7*s + 1)))) + 2*f*(D1*(f*(5*fd*(k1**2*(C*(84*r + 84*s - 78) - 15*r - 15*s + 32) - 33*k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 4))*(3*r + 3*s - 2) + k2**2*(33*bd2 - 66*gd2)*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1)) + 33*fd*k2**2*(b2 - 2*g2)*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 1)) + Dd*f*(5*f*(k1**2*(C*(84*r + 84*s - 78) - 15*r - 15*s + 32) - 33*k2**2*(C*(4*r + 4*s - 2) - 7*r - 7*s + 4)) + k2**2*(33*b2 - 66*g2)*(4*r + 4*s + 1))*(4*r + 4*s - 3)))/(693*d**2*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**4*k2**2*(429*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 6*K*r + 6*K*s + 15*K + b1*(-50*r - 50*s + 34) + 152*r + 152*s - 106) + 6*k2**4*(b1*(4*r + 4*s - 2) - (K - 1)*(r + s))) + 4*k2**2*(r + s)*(b1*k1**2*(11 - 27*K) + 7*b1*k2**2*(K - 1) + g2*(27*k1**2 - 7*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(27*K - 11) - k2**2*(7*K - 7))) + Dd*f*(f*(k1**2*(25*r + 25*s - 17) - 6*k2**2*(2*r + 2*s - 1)) - (r + s)*(k1**2*(27*K - 11) - k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(5*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 2*gd2*k2**2*(-27*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) - 2*f*(2*k1**4*(3*C*(2*r + 2*s - 5) - r - s + 8) + k1**2*k2**2*(-24*C*(8*r + 8*s - 5) + 3*K*(2*r + 2*s + 5) + 152*r + 152*s - 106) + k2**4*(6 - 6*K)*(r + s)) + 4*g2*k2**2*(27*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(70*f**2*fd*k2**2*(-3*k1**2*(r + s - 4) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16))*(3*r + 3*s - 2) + 198*gd2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(r + s - 1)) + 2574*fd*g2*k2**2*(k1**2*(2*r + 2*s + 5) - 2*k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(70*f**2*k2**2*(3*k1**2*(r + s - 4) - 13*k2**2*(17*r + 17*s - 11)) - 65*f*k1**2*(k1**2*(6*C*(9*r + 9*s + 5) - 69*r - 69*s + 2) + 33*k2**2*(4*C*(8*r + 8*s - 5) - 25*r - 25*s + 16)) + 2574*g2*k2**2*(-k1**2*(2*r + 2*s + 5) + 2*k2**2*(r + s)))))/(9009*d**2*k3**6) - 20*D1**3*Pk1*Pkdd3*ct**3*f**2*k2**5*st**4*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)/(77*d**2*k1*k3**4) - 2*D1**3*Pk1*Pkdd3*ct**3*f*k2**5*st**4*(26*D1*bd1*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(r + s - 1) + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 + k1**2*(66*C - 66)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 66)*(3*r + 3*s - 1))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(f*k2**2*(1772*r**2 + r*(3544*s - 2541) + 1772*s**2 - 2541*s + 909) + k1**2*(520*C - 442)*(3*r + 3*s - 2)**2) + Dd*f*(f*k2**2*(443*r + 443*s - 303) + k1**2*(520*C - 442)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(3003*d**2*k1*k3**6) + 2*D1**3*Pk1*Pkdd3*ct**3*k1*k2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 8*K*r + 8*K*s - 10*K + b1*(r + s - 5) - 64*r - 64*s + 47) - 6*k2**4*(b1*(13*r + 13*s - 7) - (4*K - 3)*(r + s))) - 132*k2**2*(r + s)*(b1*k1**2*(8*K + 3) + 7*b1*k2**2*(3 - 4*K) - 8*g2*k1**2 + 28*g2*k2**2)) - 858*b1**2*k2**2*(D1*fd*(-f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7))*(2*r + 2*s - 1) + (r + s)**2*(k1**2*(8*K + 3) + k2**2*(21 - 28*K))) - Dd*f*(f*(k1**2*(r + s - 5) - 3*k2**2*(13*r + 13*s - 7)) - (r + s)*(k1**2*(8*K + 3) + k2**2*(21 - 28*K)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) + 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 8*gd2*k2**2*(2*k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 528*fd*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1)) + 66*f*(k1**4*(r*(12*C - 8) + s*(12*C - 8) + 1) + 2*k1**2*k2**2*(12*C*(7*r + 7*s - 5) + 2*K*(4*r + 4*s - 5) - 64*r - 64*s + 47) + k2**4*(24*K - 18)*(r + s)) + 528*g2*k2**2*(2*k1**2 - 7*k2**2)*(r + s))) + 2*f*(D1*(35*f**2*fd*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14))*(3*r + 3*s - 2) - 264*gd2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(r + s - 1)) - 3432*fd*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(k1**2*(88*r + 88*s - 53) + 78*k2**2*(7*r + 7*s - 5)) + 65*f*k1**2*(k1**2*(6*C*(19*r + 19*s - 9) - 72*r - 72*s + 37) + 33*k2**2*(4*C*(7*r + 7*s - 5) - 19*r - 19*s + 14)) - 3432*g2*k2**2*(k1**2*(4*r + 4*s - 5) + 6*k2**2*(r + s)))))/(9009*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(r + s - 1)*(3*D1*bd1*f**2*(r + s) + 2*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(2*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(7*d**2*k1*k3**2) - 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(33*b1**2*(D1*fd*(k1**2*(50*C - 44)*(r + s - 1)**2 + k2**2*(f*(68*r**2 + r*(136*s - 99) + 68*s**2 - 99*s + 41) + 6*(r + s)**2)) + 2*Dd*f*(k1**2*(25*C - 22)*(r + s - 1) + k2**2*(f*(17*r + 17*s - 12) + 3*r + 3*s))*(4*r + 4*s - 3)) + b1*f*(33*D1*bd1*(k1**2*(50*C - 44)*(2*r + 2*s - 1) + k2**2*(f*(68*r + 68*s - 31) + 12*r + 12*s))*(r + s - 1) + D1*fd*(-33*k1**2*(4*C*(37*r**2 + 74*r*s - 15*r + 37*s**2 - 15*s - 8) - 132*r**2 - 264*r*s + 65*r - 132*s**2 + 65*s + 21) + k2**2*(f*(2718*r**2 + 5436*r*s - 4233*r + 2718*s**2 - 4233*s + 1765) - 198*r**2 - 396*r*s + 297*r - 198*s**2 + 297*s - 99)) + Dd*f*(-66*k1**2*(C*(37*r + 37*s - 9) - 33*r - 33*s + 10) + k2**2*(f*(906*r + 906*s - 656) - 99*r - 99*s + 99))*(4*r + 4*s - 3)) + f**2*(-D1*bd1*(33*k1**2*(C*(74*r + 74*s - 68) - 66*r - 66*s + 61) + k2**2*(f*(-906*r - 906*s + 203) + 99*r + 99*s - 99))*(r + s - 1) - (k1**2*(2*C*(741*r + 741*s - 439) - 1200*r - 1200*s + 745) + 99*k2**2*(2*r + 2*s - 1))*(2*D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(4*r + 4*s - 3))))/(693*d**2*k1*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**3*k2**3*st**2*(-13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 34*K*r + 34*K*s - 12*K - 2*b1*(79*r + 79*s - 41) + 41*r + 41*s - 27)) + k1**2*k2**2*(r + s)*(-132*b1*(16 - 19*K) - 2508*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(158*r**2 + r*(316*s - 161) + 158*s**2 - 161*s + 41) + (32 - 38*K)*(r + s)**2) + Dd*f*(f*(79*r + 79*s - 41) + (32 - 38*K)*(r + s))*(4*r + 4*s - 3)) - 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 33*f*k1**2*(fd*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27))*(2*r + 2*s - 1) - 76*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2508*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3)) + 33*f*k1**2*(k1**2*(2*C*(165*r + 165*s - 97) - 223*r - 223*s + 133) + k2**2*(-6*C*(13*r + 13*s - 7) + 2*K*(17*r + 17*s - 6) + 41*r + 41*s - 27)) - 2508*g2*k1**2*k2**2*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(k1**2*(-1229*r - 1229*s + 847) + 65*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 26*f*k1**2*(fd*(k1**2*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6))*(3*r + 3*s - 2) - 66*gd2*k2**2*(17*r**2 + r*(34*s - 23) + 17*s**2 - 23*s + 6)) + 1716*fd*g2*k1**2*k2**2*(34*r**2 + r*(68*s - 29) + 34*s**2 - 29*s + 6)) - Dd*f*(4*r + 4*s - 3)*(25*f**2*(k1**2*k2**2*(1229*r + 1229*s - 847) - 65*k2**4*(5*r + 5*s - 3)) + 26*f*(k1**4*(C*(3525*r + 3525*s - 2273) - 2325*r - 2325*s + 1528) - 99*k1**2*k2**2*(C*(13*r + 13*s - 7) - 11*r - 11*s + 6)) - 1716*g2*k1**2*k2**2*(17*r + 17*s - 6))))/(9009*d**2*k1*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**3*k2*(r + s - 1)*(-4*D1*bd1*f**2*(r + s)*(2*C*k1**2 + 3*k2**2) + 5*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(5*bd1*f*k2**2*(3*r + 3*s - 2) - 4*fd*(k1**2*(5*C - 2) - k2**2*(f - 4))*(r + s - 1)) + 2*Dd*f*(k1**2*(4 - 10*C) + k2**2*(f - 8))*(4*r + 4*s - 3)) + 2*b1*f*(-D1*bd1*(k1**2*(10*C - 4) - k2**2*(f - 8))*(2*r + 2*s - 1) - (4*C*k1**2 + 6*k2**2)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k1*k3**2) + 2*D1**3*Pk1*Pkdd3*ct**3*k2*(495*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(15*bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*fd*(k1**4*(6*C - 2)*(r + s - 1)**2 + k1**2*k2**2*(-42*C*(r + s - 1)**2 - 14*K*r**2 - 28*K*r*s + 8*K*r - 14*K*s**2 + 8*K*s - 4*K + 3*f*(r + s - 1) + 39*r**2 + 78*r*s - 76*r + 39*s**2 - 76*s + 38) - k2**4*(3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + 7*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(2 - 6*C)*(r + s - 1) + k1**2*k2**2*(42*C*(r + s - 1) + 2*K*(7*r + 7*s - 2) - 39*r - 39*s + 38) + k2**4*(6*f*(3*r + 3*s - 2) + 7*r + 7*s))) + 3*b1*(-22*D1*bd1*f*(r + s - 1)*(k1**4*(6*C - 2)*(2*r + 2*s - 1) - k1**2*k2**2*(42*C*(2*r + 2*s - 1) + 28*K*r + 28*K*s - 4*K + 3*f - 78*r - 78*s + 38) - k2**4*(3*f*(12*r + 12*s - 5) + 14*r + 14*s)) + D1*(5*f**2*fd*k2**2*(k1**2*(39*r**2 + r*(78*s - 79) + 39*s**2 - 79*s + 38) + 11*k2**2*(18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 11)) - 22*f*(fd*(k1**4*(4*C*(5*r + 5*s - 3) - 14*r - 14*s + 9) + 2*k1**2*k2**2*(6*C*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 2*K*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) - 30*r**2 - 60*r*s + 12*r - 30*s**2 + 12*s + 9) - 6*k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + 2*k1**2*k2**2*(-5*bd2*(r + s) + 2*gd2*(7*r + 7*s - 2))*(r + s - 1)) + 44*fd*k1**2*k2**2*(5*b2*(r + s)**2 - 2*g2*(7*r**2 + 2*r*(7*s - 2) + 7*s**2 - 4*s + 2))) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(13*r + 13*s - 15) + 22*k2**2*(3*r + 3*s - 2)) - 22*f*(k1**4*(8*C - 5) - 2*k1**2*k2**2*(-12*C*r - 12*C*s + 2*K*(r + s + 1) + 15*r + 15*s - 6) - 6*k2**4*(r + s)) + 44*k1**2*k2**2*(5*b2*(r + s) - 2*g2*(7*r + 7*s - 2)))) + f*(3*D1*bd1*(r + s - 1)*(5*f**2*k2**2*(k1**2*(13*r + 13*s - 7) + 11*k2**2*(6*r + 6*s - 1)) - 22*f*(k1**4*(4*C - 1) + 2*k1**2*k2**2*(6*C*(2*r + 2*s - 3) - 2*K*(r + s + 1) - 15*r - 15*s + 21) - 6*k2**4*(r + s)) + k1**2*k2**2*(220*b2 - 616*g2)*(r + s)) + 2*k1**2*(D1*(-5*f*fd*(k1**2*(2*C*(27*r + 27*s - 7) - 42*r - 42*s + 17) + 33*k2**2*(2*C*(5*r + 5*s - 3) - 9*r - 9*s + 6))*(3*r + 3*s - 2) + 132*f*k2**2*(bd2 - 2*gd2)*(r**2 + 2*r*s + s**2 - 1) + 132*fd*k2**2*(b2 - 2*g2)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1)) - Dd*f*(5*f*(k1**2*(2*C*(27*r + 27*s - 7) - 42*r - 42*s + 17) + 33*k2**2*(2*C*(5*r + 5*s - 3) - 9*r - 9*s + 6)) + k2**2*(-132*b2 + 264*g2)*(r + s + 1))*(4*r + 4*s - 3))))/(693*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*ct**2*f*k2**6*st**6*(20*C - 20)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(693*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**2*k1**2*(13*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 24*K*r + 24*K*s - 15*K - 2*b1*(7*r + 7*s - 2) - 52*r - 52*s + 41) - 18*k2**4*(b1*(5*r + 5*s - 3) - (2*K - 1)*(r + s))) + 132*k2**2*(r + s)*(b1*k1**2*(5 - 8*K) + 21*b1*k2**2*(1 - 2*K) + 8*g2*k1**2 + 42*g2*k2**2)) + 858*b1**2*k2**2*(D1*fd*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(8*K - 5) + k2**2*(42*K - 21))) + Dd*f*(f*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(5*r + 5*s - 3)) - (r + s)*(k1**2*(8*K - 5) + k2**2*(42*K - 21)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) - 4*gd2*k2**2*(4*k1**2 + 21*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(12*C*(6*r + 6*s - 5) + 3*K*(8*r + 8*s - 5) - 52*r - 52*s + 41) + k2**4*(36*K - 18)*(r + s)) + 264*g2*k2**2*(4*k1**2 + 21*k2**2)*(r + s))) - 2*f*(D1*(35*f**2*fd*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) + 13*f*(5*fd*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6))*(3*r + 3*s - 2) - 198*gd2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(r + s - 1)) - 2574*fd*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(11*r + 11*s - 9)) + 65*f*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(6*r + 6*s - 5) - 7*r - 7*s + 6)) - 2574*g2*k2**2*(k1**2*(8*r + 8*s - 5) + 12*k2**2*(r + s)))))/(9009*d**2*k3**6) + 4*D1**3*Pk1*Pkdd3*ct**2*k2**4*st**4*(66*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1*(2*D1*bd1*f*(C - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - f*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 1)) + f**2*(-33*D1*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + (30*C - 35)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)))/(231*d**2*k3**4) - 2*D1**3*Pk1*Pkdd3*ct**2*k2**4*st**4*(78*D1*bd1*f*(r + s - 1)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + k2**2*(r + s)*(-22*K*b1 + 22*b1 + 22*g2)) - 858*b1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 78*b1*(D1*(20*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 11*f*(fd*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 2*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 22*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2*(3*r + 3*s - 2) + 11*f*(k1**2*(2*C*(7*r + 7*s - 2) - 11*r - 11*s + 3) + k2**2*(2*C - 2)*(2*r + 2*s - 1)) + 22*g2*k2**2*(r + s))) + f**2*(D1*fd*(5*f*k2**2*(3292*r**2 + r*(6584*s - 4769) + 3292*s**2 - 4769*s + 1725) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2)**2) + Dd*f*(5*f*k2**2*(823*r + 823*s - 575) + k1**2*(3172*C - 2262)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(3003*d**2*k3**6) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(r + s - 1)*(2*D1*bd1*f**2*(9*C - 8)*(r + s) + b1**2*(12*C - 19)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(12*C - 19)*(2*r + 2*s - 1) + (18*C - 16)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k3**2) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(66*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 11*b1**2*(D1*(-6*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(66*C - 47)*(r + s - 1)**2 + k2**2*(14*C*(r + s - 1)**2 - 5*K*r**2 - 10*K*r*s - 2*K*r - 5*K*s**2 - 2*K*s + K + 3*f*(32*r**2 + 64*r*s - 41*r + 32*s**2 - 41*s + 15) + 11*r**2 + 22*r*s + 30*r + 11*s**2 + 30*s - 15))) + Dd*f*(k1**2*(66*C - 47)*(r + s - 1) + k2**2*(14*C*(r + s - 1) - 5*K*r - 5*K*s - K + 6*f*(8*r + 8*s - 5) + 11*r + 11*s + 15))*(4*r + 4*s - 3)) - b1*(11*D1*bd1*f*(k1**2*(66*C - 47)*(2*r + 2*s - 1) + k2**2*(14*C*(2*r + 2*s - 1) - 10*K*r - 10*K*s - K + f*(96*r + 96*s - 45) + 22*r + 22*s + 15))*(r + s - 1) + D1*(2*f**2*fd*k2**2*(684*r**2 + 24*r*(57*s - 43) + 684*s**2 - 1032*s + 415) - 11*f*(fd*(2*k1**2*(3*C*(14*r**2 + 28*r*s - r + 14*s**2 - s - 7) - 26*r**2 - 52*r*s + r - 26*s**2 + s + 14) + k2**2*(-4*C*(11*r**2 + 2*r*(11*s - 5) + 11*s**2 - 10*s + 2) + (3*r + 3*s - 1)*(K*(6*r + 6*s - 3) + 6*r + 6*s - 5))) - 2*k2**2*(-3*bd2*(r + s) + gd2*(5*r + 5*s + 1))*(r + s - 1)) + 22*fd*k2**2*(-3*b2*(r + s)**2 + g2*(5*r**2 + 2*r*(5*s + 1) + 5*s**2 + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(2*f**2*k2**2*(228*r + 228*s - 161) - 11*f*(k1**2*(6*C*(7*r + 7*s - 1) - 26*r - 26*s + 4) + k2**2*(-2*C*(11*r + 11*s - 5) + K*(9*r + 9*s - 3) + 9*r + 9*s - 7)) + 22*k2**2*(-3*b2*(r + s) + g2*(5*r + 5*s + 1)))) + f*(-D1*bd1*(r + s - 1)*(8*f**2*k2**2*(57*r + 57*s - 17) - 11*f*(k1**2*(6*C*(7*r + 7*s - 9) - 26*r - 26*s + 36) + k2**2*(-2*C*(11*r + 11*s - 6) + K*(9*r + 9*s - 3) + 9*r + 9*s - 9)) + k2**2*(-66*b2 + 110*g2)*(r + s)) + 3*D1*(f*(fd*(k1**2*(68*C*(3*r + 3*s - 2) - 125*r - 125*s + 87) - 11*k2**2*(C*(8*r + 8*s - 4) - 9*r - 9*s + 5))*(3*r + 3*s - 2) + k2**2*(11*bd2 - 22*gd2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*fd*k2**2*(b2 - 2*g2)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + 3*Dd*f*(4*r + 4*s - 3)*(f*k1**2*(68*C*(3*r + 3*s - 2) - 125*r - 125*s + 87) - 11*f*k2**2*(C*(8*r + 8*s - 4) - 9*r - 9*s + 5) + k2**2*(11*b2 - 22*g2)*(3*r + 3*s - 1))))/(231*d**2*k3**4) + 2*D1**3*Pk1*Pkdd3*ct**2*k2**2*st**2*(429*D1*bd1*f*(r + s - 1)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) - 49*K*r - 49*K*s + 18*K + 12*b1*(13*r + 13*s - 7) - 41*r - 41*s + 30) + k2**4*(-12*b1*(2*r + 2*s - 1) + (K - 1)*(r + s))) + 2*k2**2*(r + s)*(b1*k1**2*(39 - 71*K) - 7*b1*k2**2*(K - 1) + g2*(71*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(71*K - 39) + k2**2*(7*K - 7))) + Dd*f*(6*f*(k1**2*(13*r + 13*s - 7) + k2**2*(-2*r - 2*s + 1)) - (r + s)*(k1**2*(71*K - 39) + k2**2*(7*K - 7)))*(4*r + 4*s - 3)) + 429*b1*(D1*(3*f**2*fd*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(-fd*(2*r + 2*s - 1)*(2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(-92*r - 92*s + 54) + K*(49*r + 49*s - 18) + 41*r + 41*s - 30) - k2**4*(K - 1)*(r + s)) + 2*gd2*k2**2*(71*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*fd*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(3*f**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9)) + f*(-2*k1**4*(C*(72*r + 72*s - 46) - 43*r - 43*s + 28) + k1**2*k2**2*(C*(92*r + 92*s - 54) + K*(-49*r - 49*s + 18) - 41*r - 41*s + 30) + k2**4*(K - 1)*(r + s)) + 2*g2*k2**2*(71*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(75*f**2*fd*k2**2*(-40*k1**2*(4*r + 4*s - 3) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 13*f*(fd*k1**2*(k1**2*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(r + s - 1)) - 858*fd*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(75*f**2*(40*k1**2*k2**2*(4*r + 4*s - 3) - 13*k2**4*(17*r + 17*s - 11)) + 13*f*(k1**4*(2*C*(1341*r + 1341*s - 971) - 1557*r - 1557*s + 1159) - 33*k1**2*k2**2*(C*(92*r + 92*s - 54) - 65*r - 65*s + 39)) + 858*g2*k2**2*(k1**2*(-49*r - 49*s + 18) + k2**2*(r + s)))))/(9009*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct**2*(r + s - 1)*(2*D1*bd1*f*(r + s)*(2*f*(k1**2*(2*C - 1) + k2**2*(6*C - 6)) + k2**2*(b2 - 2*g2)) + 3*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(3*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(2*C - 1) + k2**2*(14*C + K - 2*f - 16))*(r + s - 1)) - 2*Dd*f*(k1**2*(1 - 2*C) + k2**2*(-14*C - K + f + 16))*(4*r + 4*s - 3)) + 2*b1*(D1*bd1*f*(k1**2*(2*C - 1) + k2**2*(14*C + K - f - 16))*(2*r + 2*s - 1) + D1*(r + s - 1)*(4*f*fd*(k1**2*(2*C - 1) + k2**2*(6*C - 6)) + f*k2**2*(bd2 - 2*gd2) + fd*k2**2*(b2 - 2*g2)) + Dd*f*(2*f*(k1**2*(2*C - 1) + k2**2*(6*C - 6)) + k2**2*(b2 - 2*g2))*(4*r + 4*s - 3)))/(21*d**2*k3**2) + 2*D1**3*Pk1*Pkdd3*ct**2*(33*b1**3*k2**2*(k1**2 - 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(bd1*f*k2**2*(k1**2 - 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*fd*(k1**4*(2*C - 1)*(r + s - 1)**2 + k1**2*k2**2*(42*C*(r + s - 1)**2 + 7*K*r**2 + 14*K*r*s - 12*K*r + 7*K*s**2 - 12*K*s + 6*K + f*(8*r**2 + 16*r*s - 3*r + 8*s**2 - 3*s - 1) - 27*r**2 - 54*r*s + 62*r - 27*s**2 + 62*s - 31) + k2**4*(3*f*(20*r**2 + 5*r*(8*s - 5) + 20*s**2 - 25*s + 9) + (14 - 7*K)*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(42*C*(r + s - 1) + K*(7*r + 7*s - 6) + 4*f*r + 4*f*s - 27*r - 27*s + 31) + k2**4*(6*f*(5*r + 5*s - 3) + (14 - 7*K)*(r + s)))) + b1*(66*D1*bd1*f*(r + s - 1)*(k1**4*(2*C - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(42*C*(2*r + 2*s - 1) + 14*K*r + 14*K*s - 6*K + f*(8*r + 8*s - 1) - 54*r - 54*s + 31) + k2**4*(3*f*(20*r + 20*s - 9) + (28 - 14*K)*(r + s))) + D1*(5*f**2*fd*k2**2*(k1**2*(351*r**2 + 9*r*(78*s - 55) + 351*s**2 - 495*s + 184) + 33*k2**2*(36*r**2 + r*(72*s - 53) + 36*s**2 - 53*s + 21)) - 66*f*(fd*(k1**4*(2*C - 1)*(4*r + 4*s - 3) + 2*k1**2*k2**2*(6*C*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 3) + 3*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s - r - 14*s**2 - s + 10) + k2**4*(6*K - 12)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - k2**2*(r + s - 1)*(bd2*(k1**2 - 7*k2**2)*(r + s) - 2*gd2*k1**2*(7*r + 7*s - 6) + 14*gd2*k2**2*(r + s))) + 66*fd*k2**2*(b2*(k1**2 - 7*k2**2)*(r + s)**2 - 2*g2*k1**2*(7*r**2 + 2*r*(7*s - 6) + 7*s**2 - 12*s + 6) + 14*g2*k2**2*(r + s)**2)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(k1**2*(117*r + 117*s - 77) + 132*k2**2*(3*r + 3*s - 2)) - 66*f*(k1**4*(2*C - 1) + 2*k1**2*k2**2*(6*C*s + 3*K*(r + s - 1) + r*(6*C - 7) - 7*s + 2) + k2**4*(6*K - 12)*(r + s)) + 66*k2**2*(b2*(k1**2 - 7*k2**2)*(r + s) - 2*g2*k1**2*(7*r + 7*s - 6) + 14*g2*k2**2*(r + s)))) + f*(D1*bd1*(r + s - 1)*(5*f**2*k2**2*(k1**2*(117*r + 117*s - 47) + 99*k2**2*(4*r + 4*s - 1)) + 66*f*(k1**4*(2*C - 1) - 2*k1**2*k2**2*(6*C*(r + s - 3) + 3*K*(r + s - 1) - 7*r - 7*s + 14) - k2**4*(6*K - 12)*(r + s)) + 66*k2**2*(r + s)*(b2*(k1**2 - 7*k2**2) + 14*g2*(-k1**2 + k2**2))) - 2*D1*(f*(5*fd*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(C*(8*r + 8*s - 6) - 5*r - 5*s + 4))*(3*r + 3*s - 2) + k2**2*(198*bd2 - 396*gd2)*(k1**2*(r + s - 1) + k2**2*(r + s))*(r + s - 1)) + 198*fd*k2**2*(b2 - 2*g2)*(k1**2*(r + s - 1) + k2**2*(r + s))*(2*r + 2*s - 1)) - 2*Dd*f*(5*f*k1**2*(k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*k2**2*(C*(8*r + 8*s - 6) - 5*r - 5*s + 4)) + k2**2*(198*b2 - 396*g2)*(k1**2*(r + s - 1) + k2**2*(r + s)))*(4*r + 4*s - 3)))/(693*d**2*k3**4) + 10*D1**3*Pk1*Pkdd3*ct*f*k2**5*st**6*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(693*d**2*k1*k3**4) + 5*D1**3*Pk1*Pkdd3*ct*f*k2**5*st**6*(13*D1*bd1*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(r + s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 3) + 27*s**2 - 3*s - 10) + k1**2*(264*C - 198)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s + 5) + k1**2*(264*C - 198)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - f*(D1*fd*(3*f*k2**2*(276*r**2 + r*(552*s - 427) + 276*s**2 - 427*s + 165) + k1**2*(78 - 104*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(69*r + 69*s - 55) + k1**2*(78 - 104*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(9009*d**2*k1*k3**6) - 2*D1**3*Pk1*Pkdd3*ct*k1**3*k2*(D1*bd1*f*(r + s - 1)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*(k1**2*(-12*C*(r + s - 1) - 12*K*r - 12*K*s + 6*K + b1*(4*r + 4*s - 2) + 8*r + 8*s - 7) + 6*k2**2*(b1*(7*r + 7*s - 5) - (4*K - 1)*(r + s))) + (r + s)*(132*b1*k1**2*(1 - 6*K) + 924*b1*k2**2*(1 - 4*K) + 792*g2*k1**2 + 3696*g2*k2**2)) + 66*b1**2*(D1*fd*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5))*(2*r + 2*s - 1) - (r + s)**2*(k1**2*(6*K - 1) + k2**2*(28*K - 7))) + Dd*f*(f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(7*r + 7*s - 5)) - (r + s)*(k1**2*(6*K - 1) + k2**2*(28*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(5*f**2*fd*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*(fd*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s))*(2*r + 2*s - 1) - 4*gd2*(3*k1**2 + 14*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*(3*k1**2 + 14*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) - 66*f*(k1**2*(12*C*(r + s - 1) + 6*K*(2*r + 2*s - 1) - 8*r - 8*s + 7) + k2**2*(24*K - 6)*(r + s)) + 264*g2*(3*k1**2 + 14*k2**2)*(r + s))) - 2*f*(D1*(140*f**2*fd*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 33*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 12*gd2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))*(r + s - 1) - 396*fd*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k2**2*(r + s - 1) + f*k1**2*(330*C - 165)*(r + s - 1) - 396*g2*(k1**2*(2*r + 2*s - 1) + 4*k2**2*(r + s)))))/(693*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct*k1*k2*(-D1*bd1*f*(r + s - 1)*(5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(7*r + 7*s - 3)) + 66*f*(k1**2*(12*C + K*(-8*r - 8*s + 4) + 2*r + 2*s - 7) + k2**2*(6 - 12*K)*(r + s)) + (r + s)*(-264*b2*k1**2 - 924*b2*k2**2 + 1848*g2*k2**2)) + 33*b1**3*(2*k1**2 + 21*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*bd1*f*(2*k1**2 + 21*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*D1*fd*(k1**2*(14*C*(r + s - 1)**2 - 8*K*r - 8*K*s + 4*K + f*(4*r + 4*s - 3) - 7*r**2 - 14*r*s + 16*r - 7*s**2 + 16*s - 8) + k2**2*(3*f*(8*r**2 + r*(16*s - 7) + 8*s**2 - 7*s + 1) + (7 - 14*K)*(r + s)**2)) - 2*Dd*f*(k1**2*(14*C*(r + s - 1) - 4*K + f - 7*r - 7*s + 8) + k2**2*(6*f*(2*r + 2*s - 1) + (7 - 14*K)*(r + s)))*(4*r + 4*s - 3)) - b1*(66*D1*bd1*f*(2*k1**2*(7*C*(2*r + 2*s - 1) - 2*K - 7*r - 7*s + 4) + k2**2*(3*f*(8*r + 8*s - 5) + (14 - 28*K)*(r + s)))*(r + s - 1) + D1*(5*f**2*fd*(10*k1**2*(3*r + 3*s - 2)**2 + 33*k2**2*(21*r**2 + r*(42*s - 31) + 21*s**2 - 31*s + 12)) - 66*f*(fd*(k1**2*(12*C*(r + s - 1) + 4*K*(2*r + 2*s - 1)**2 - 4*r**2 - 8*r*s - 2*r - 4*s**2 - 2*s + 5) + k2**2*(12*K - 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + (-2*r - 2*s + 2)*(-bd2*(2*k1**2 + 7*k2**2)*(r + s) + 4*gd2*k1**2 + 14*gd2*k2**2*(r + s))) - 132*fd*(b2*(2*k1**2 + 7*k2**2)*(r + s)**2 - 2*g2*(k1**2*(4*r + 4*s - 2) + 7*k2**2*(r + s)**2))) + Dd*f*(4*r + 4*s - 3)*(-132*b2*(2*k1**2 + 7*k2**2)*(r + s) + 5*f**2*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(7*r + 7*s - 5)) - 66*f*(k1**2*(4*K - 1)*(2*r + 2*s - 1) + k2**2*(12*K - 6)*(r + s)) + 264*g2*(2*k1**2 + 7*k2**2*(r + s)))) + 66*f*(30*C*D1*f*fd*k1**2*r**2 + 60*C*D1*f*fd*k1**2*r*s - 50*C*D1*f*fd*k1**2*r + 30*C*D1*f*fd*k1**2*s**2 - 50*C*D1*f*fd*k1**2*s + 20*C*D1*f*fd*k1**2 + 40*C*Dd*f**2*k1**2*r**2 + 80*C*Dd*f**2*k1**2*r*s - 70*C*Dd*f**2*k1**2*r + 40*C*Dd*f**2*k1**2*s**2 - 70*C*Dd*f**2*k1**2*s + 30*C*Dd*f**2*k1**2 + 4*D1*bd2*f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(r + s - 1) - 15*D1*f*fd*k1**2*r**2 - 30*D1*f*fd*k1**2*r*s + 25*D1*f*fd*k1**2*r - 15*D1*f*fd*k1**2*s**2 + 25*D1*f*fd*k1**2*s - 10*D1*f*fd*k1**2 - 16*D1*f*gd2*k1**2*r**2 - 32*D1*f*gd2*k1**2*r*s + 24*D1*f*gd2*k1**2*r - 16*D1*f*gd2*k1**2*s**2 + 24*D1*f*gd2*k1**2*s - 8*D1*f*gd2*k1**2 - 24*D1*f*gd2*k2**2*r**2 - 48*D1*f*gd2*k2**2*r*s + 24*D1*f*gd2*k2**2*r - 24*D1*f*gd2*k2**2*s**2 + 24*D1*f*gd2*k2**2*s - 32*D1*fd*g2*k1**2*r**2 - 64*D1*fd*g2*k1**2*r*s + 32*D1*fd*g2*k1**2*r - 32*D1*fd*g2*k1**2*s**2 + 32*D1*fd*g2*k1**2*s - 8*D1*fd*g2*k1**2 - 48*D1*fd*g2*k2**2*r**2 - 96*D1*fd*g2*k2**2*r*s + 24*D1*fd*g2*k2**2*r - 48*D1*fd*g2*k2**2*s**2 + 24*D1*fd*g2*k2**2*s - 20*Dd*f**2*k1**2*r**2 - 40*Dd*f**2*k1**2*r*s + 35*Dd*f**2*k1**2*r - 20*Dd*f**2*k1**2*s**2 + 35*Dd*f**2*k1**2*s - 15*Dd*f**2*k1**2 - 64*Dd*f*g2*k1**2*r**2 - 128*Dd*f*g2*k1**2*r*s + 80*Dd*f*g2*k1**2*r - 64*Dd*f*g2*k1**2*s**2 + 80*Dd*f*g2*k1**2*s - 24*Dd*f*g2*k1**2 - 96*Dd*f*g2*k2**2*r**2 - 192*Dd*f*g2*k2**2*r*s + 72*Dd*f*g2*k2**2*r - 96*Dd*f*g2*k2**2*s**2 + 72*Dd*f*g2*k2**2*s + 4*b2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(693*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct*k1*k2*st**2*(39*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 32*K*r + 32*K*s - 12*K + b1*(-69*r - 69*s + 39) + 19*r + 19*s - 15) + k2**4*(3*b1*(13*r + 13*s - 7) - (2*K - 1)*(r + s))) - 44*k2**2*(r + s)*(13*b1*k1**2*(4*K - 1) + 7*b1*k2**2*(2*K - 1) - 2*g2*(26*k1**2 + 7*k2**2))) + 429*b1**2*k2**2*(D1*fd*(3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7))*(2*r + 2*s - 1) + (r + s)**2*(-2*k1**2*(52*K - 13) - 2*k2**2*(14*K - 7))) + Dd*f*(3*f*(k1**2*(23*r + 23*s - 13) + k2**2*(-13*r - 13*s + 7)) + (r + s)*(-2*k1**2*(52*K - 13) - 2*k2**2*(14*K - 7)))*(4*r + 4*s - 3)) + 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(3*r + 3*s - 2) - 22*f*(fd*(2*r + 2*s - 1)*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) - 4*gd2*k2**2*(26*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 88*fd*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1)) - 22*f*(2*k1**4*(C*(15*r + 15*s - 11) - 8*r - 8*s + 6) + k1**2*k2**2*(C*(-46*r - 46*s + 30) + 4*K*(8*r + 8*s - 3) + 19*r + 19*s - 15) - k2**4*(2*K - 1)*(r + s)) + 88*g2*k2**2*(26*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(25*f**2*fd*k2**2*(-8*k1**2*(17*r + 17*s - 16) + 117*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(fd*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18))*(3*r + 3*s - 2) + 132*gd2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(r + s - 1)) - 3432*fd*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(8*k1**2*(17*r + 17*s - 16) - 117*k2**2*(7*r + 7*s - 5)) + 26*f*k1**2*(k1**2*(10*C*(45*r + 45*s - 41) - 234*r - 234*s + 222) - 33*k2**2*(C*(46*r + 46*s - 30) - 27*r - 27*s + 18)) + 3432*g2*k2**2*(-2*k1**2*(8*r + 8*s - 3) + k2**2*(r + s)))))/(9009*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*ct*k2**3*st**4*(33*b1**2*(D1*fd*(k1**2*(6 - 8*C)*(r + s - 1)**2 + k2**2*(f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 2*(r + s)**2)) + 2*Dd*f*(-k1**2*(4*C - 3)*(r + s - 1) + k2**2*(f*(r + s - 1) - r - s))*(4*r + 4*s - 3)) + b1*f*(-33*D1*bd1*(k1**2*(8*C - 6)*(2*r + 2*s - 1) + k2**2*(f*(-4*r - 4*s + 3) + 4*r + 4*s))*(r + s - 1) + 2*D1*fd*(-33*k1**2*(2*r + 2*s - 1)*(C*(6*r + 6*s - 2) - 4*r - 4*s + 1) + k2**2*(5*f*(18*r**2 + 6*r*(6*s - 5) + 18*s**2 - 30*s + 13) + 33*(2*r + 2*s - 1)**2)) + 2*Dd*f*(-33*k1**2*(C*(6*r + 6*s - 2) - 4*r - 4*s + 1) + k2**2*(5*f*(6*r + 6*s - 5) + 66*r + 66*s - 33))*(4*r + 4*s - 3)) - 2*f**2*(D1*bd1*(33*k1**2*(C*(6*r + 6*s - 2) - 4*r - 4*s + 1) - k2**2*(10*f*(3*r + 3*s - 1) + 66*r + 66*s - 33))*(r + s - 1) + k1**2*(40*C - 26)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)))/(231*d**2*k1*k3**4) + 2*D1**3*Pk1*Pkdd3*ct*k2**3*st**4*(-26*D1*bd1*f*k1**2*(r + s - 1)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(b1*(-7*r - 7*s + 3) + (4*C - 3)*(2*r + 2*s - 1))) + k2**2*(r + s)*(-132*K*b1 + 66*b1 + 132*g2)) + 429*b1**2*k1**2*k2**2*(D1*fd*(f*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) + (4*K - 2)*(r + s)**2) + Dd*f*(f*(7*r + 7*s - 3) + (4*K - 2)*(r + s))*(4*r + 4*s - 3)) - 26*b1*k1**2*(D1*(25*f**2*fd*k2**2*(3*r + 3*s - 2)**2 + 33*f*(fd*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1))*(2*r + 2*s - 1) + 4*gd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2*(3*r + 3*s - 2) + 33*f*(k1**2*(2*C*(5*r + 5*s - 1) - 6*r - 6*s + 1) + k2**2*(4*C - 3)*(2*r + 2*s - 1)) + 132*g2*k2**2*(r + s))) + f**2*(D1*fd*(-f*k1**2*k2**2*(9812*r**2 + r*(19624*s - 14315) + 9812*s**2 - 14315*s + 5217) + 65*f*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + k1**4*(988 - 1664*C)*(3*r + 3*s - 2)**2) - Dd*f*(4*r + 4*s - 3)*(f*k1**2*k2**2*(2453*r + 2453*s - 1739) - 65*f*k2**4*(5*r + 5*s - 3) + k1**4*(1664*C - 988)*(3*r + 3*s - 2))))/(3003*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct*k2*st**2*(r + s - 1)*(-2*D1*bd1*f**2*(r + s)*(k1**2*(14*C - 8) + k2**2) + 13*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(13*bd1*f*k2**2*(3*r + 3*s - 2) - 2*fd*(k1**2*(26*C - 14) - k2**2*(9*f + 8))*(r + s - 1)) + Dd*f*(k1**2*(28 - 52*C) + k2**2*(9*f + 16))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(k1**2*(52*C - 28) - k2**2*(9*f + 16))*(2*r + 2*s - 1) - (2*k1**2*(14*C - 8) + 2*k2**2)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k1*k3**2) + 2*D1**3*Pk1*Pkdd3*ct*k2*(r + s - 1)*(-4*D1*bd1*f*k1**2*(r + s)*(b2 + f*(6*C - 3) - 2*g2) + b1**3*(2*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*bd1*f*(2*k1**2 + 7*k2**2)*(3*r + 3*s - 2) - 4*D1*fd*(-3*f*k2**2 + k1**2*(7*C + K - 2*f - 4))*(r + s - 1) + 2*Dd*f*(3*f*k2**2 + k1**2*(-14*C - 2*K + 2*f + 8))*(4*r + 4*s - 3)) + 2*b1*(D1*bd1*f*(3*f*k2**2 + k1**2*(-14*C - 2*K + 2*f + 8))*(2*r + 2*s - 1) - 2*k1**2*(12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + D1*b2*fd*(r + s - 1) + D1*bd2*f*(r + s - 1) - 6*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd - 2*D1*f*gd2*r - 2*D1*f*gd2*s + 2*D1*f*gd2 - 2*D1*fd*g2*r - 2*D1*fd*g2*s + 2*D1*fd*g2 + Dd*b2*f*(4*r + 4*s - 3) - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 8*Dd*f*g2*r - 8*Dd*f*g2*s + 6*Dd*f*g2)))/(21*d**2*k1*k3**2) + D1**3*Pk1*Pkdd3*ct*k2*st**2*(1287*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*(D1*(-39*bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(60*C - 32)*(r + s - 1)**2 + k1**2*k2**2*(56*C*(r + s - 1)**2 - 2*K*(24*r**2 + 48*r*s + 4*r + 24*s**2 + 4*s - 2) + f*(80*r**2 + r*(160*s - 73) + 80*s**2 - 73*s + 15) - 18*r**2 - 36*r*s + 88*r - 18*s**2 + 88*s - 44) + k2**4*(-3*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 7) + 14*(r + s)**2))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(30*C - 16)*(r + s - 1) + k1**2*k2**2*(28*C*(r + s - 1) - 24*K*r - 24*K*s - 2*K + f*(20*r + 20*s - 9) - 9*r - 9*s + 22) + k2**4*(f*(-9*r - 9*s + 6) + 7*r + 7*s))) - 3*b1*(11*D1*bd1*f*(r + s - 1)*(k1**4*(60*C - 32)*(2*r + 2*s - 1) + k1**2*k2**2*(56*C*(2*r + 2*s - 1) - 96*K*r - 96*K*s - 4*K + f*(80*r + 80*s - 39) - 36*r - 36*s + 44) + k2**4*(-3*f*(12*r + 12*s - 5) + 28*r + 28*s)) + D1*(f**2*fd*k2**2*(k1**2*(1311*r**2 + r*(2622*s - 1867) + 1311*s**2 - 1867*s + 702) - 33*k2**2*(18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 11)) - 22*f*(fd*(2*k1**4*(C*(8*r**2 + r*(16*s + 5) + 8*s**2 + 5*s - 9) - 4*r**2 - r*(8*s + 3) - 4*s**2 - 3*s + 5) + k1**2*k2**2*(-2*C*(26*r**2 + r*(52*s - 25) + 26*s**2 - 25*s + 5) + K*(32*r**2 + 64*r*s - 28*r + 32*s**2 - 28*s + 6) + 16*r**2 + 32*r*s - 17*r + 16*s**2 - 17*s + 3) + k2**4*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 2*k1**2*k2**2*(-13*bd2*(r + s) + gd2*(24*r + 24*s + 2))*(r + s - 1)) + 44*fd*k1**2*k2**2*(-13*b2*(r + s)**2 + g2*(24*r**2 + r*(48*s + 4) + 24*s**2 + 4*s - 2))) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(437*r + 437*s - 291) - 66*k2**2*(3*r + 3*s - 2)) - 22*f*(k1**4*(8*C - 4)*(r + s) + 2*k1**2*k2**2*(C*(-13*r - 13*s + 7) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3) + k2**4*(r + s)) + 44*k1**2*k2**2*(-13*b2*(r + s) + g2*(24*r + 24*s + 2)))) + f*(-3*D1*bd1*(r + s - 1)*(f**2*k2**2*(19*k1**2*(23*r + 23*s - 9) - 33*k2**2*(6*r + 6*s - 1)) - 22*f*(2*k1**4*(C*(4*r + 4*s - 9) - 2*r - 2*s + 5) + k1**2*k2**2*(-2*C*(13*r + 13*s - 9) + 2*K*(8*r + 8*s - 3) + 8*r + 8*s - 9) + k2**4*(r + s)) + k1**2*k2**2*(-572*b2 + 1056*g2)*(r + s)) + 2*k1**2*(D1*(f*(fd*(2*k1**2*(9*C*(23*r + 23*s - 19) - 108*r - 108*s + 94) - 33*k2**2*(6*C*(5*r + 5*s - 3) - 19*r - 19*s + 12))*(3*r + 3*s - 2) + k2**2*(66*bd2 - 132*gd2)*(8*r**2 + r*(16*s - 11) + 8*s**2 - 11*s + 3)) + 66*fd*k2**2*(b2 - 2*g2)*(16*r**2 + 2*r*(16*s - 7) + 16*s**2 - 14*s + 3)) + Dd*f*(4*r + 4*s - 3)*(2*f*k1**2*(9*C*(23*r + 23*s - 19) - 108*r - 108*s + 94) - 33*f*k2**2*(6*C*(5*r + 5*s - 3) - 19*r - 19*s + 12) + k2**2*(66*b2 - 132*g2)*(8*r + 8*s - 3)))))/(693*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*f*k2**4*st**6*(20*C - 10)*(33*D1*bd1*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(693*d**2*k3**4) - 5*D1**3*Pk1*Pkdd3*f*k2**4*st**6*(-13*D1*bd1*f*(k1**2*(132*C - 66)*(2*r + 2*s - 1) - k2**2*(132*b1*(2*r + 2*s - 1) + f*(9*r + 9*s - 17)))*(r + s - 1) + 858*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1) + 13*b1*(D1*fd*(f*k2**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + k1**2*(66 - 132*C)*(2*r + 2*s - 1)**2) + Dd*f*(f*k2**2*(9*r + 9*s - 17) + k1**2*(66 - 132*C)*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + f*(D1*fd*(3*f*k2**2*(212*r**2 + r*(424*s - 331) + 212*s**2 - 331*s + 129) + k1**2*(26 - 52*C)*(3*r + 3*s - 2)**2) + Dd*f*(3*f*k2**2*(53*r + 53*s - 43) + k1**2*(26 - 52*C)*(3*r + 3*s - 2))*(4*r + 4*s - 3)))/(9009*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*k1**4*(D1*(-2*b1*fd*(k1**2 + 7*k2**2)*(r + s)**2*(K*b1 - 2*g2) + 5*bd1*f**3*k2**2*(r + s - 1)**2 + f**2*(r + s - 1)*(5*b1*fd*k2**2*(3*r + 3*s - 2) - 2*bd1*(K*k1**2*(2*r + 2*s - 1) + 6*K*k2**2*(r + s) - 6*b1*k2**2*(r + s - 1)) + 4*gd2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))) + 2*f*(fd*(b1*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) + 2*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)))*(2*r + 2*s - 1) + (k1**2 + 7*k2**2)*(2*b1*gd2 + 2*bd1*(-K*b1 + g2))*(r**2 + r*(2*s - 1) + s*(s - 1)))) + Dd*f*(4*r + 4*s - 3)*(5*b1*f**2*k2**2*(r + s - 1) + 2*b1*f*(K*k1**2*(-2*r - 2*s + 1) - 6*K*k2**2*(r + s) + 3*b1*k2**2*(r + s - 1)) - 2*b1*(k1**2 + 7*k2**2)*(r + s)*(K*b1 - 2*g2) + 4*f*g2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))))/(21*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*k1**2*(4*D1*K*b1**2*fd*k1**2*r + 4*D1*K*b1**2*fd*k1**2*s - 2*D1*K*b1**2*fd*k1**2 + 14*D1*K*b1**2*fd*k2**2*r**2 + 28*D1*K*b1**2*fd*k2**2*r*s + 14*D1*K*b1**2*fd*k2**2*s**2 + 2*D1*K*b1*bd1*f*k1**2*r + 2*D1*K*b1*bd1*f*k1**2*s - 2*D1*K*b1*bd1*f*k1**2 + 28*D1*K*b1*bd1*f*k2**2*r**2 + 56*D1*K*b1*bd1*f*k2**2*r*s - 28*D1*K*b1*bd1*f*k2**2*r + 28*D1*K*b1*bd1*f*k2**2*s**2 - 28*D1*K*b1*bd1*f*k2**2*s + 8*D1*K*b1*f*fd*k1**2*r**2 + 16*D1*K*b1*f*fd*k1**2*r*s - 8*D1*K*b1*f*fd*k1**2*r + 8*D1*K*b1*f*fd*k1**2*s**2 - 8*D1*K*b1*f*fd*k1**2*s + 2*D1*K*b1*f*fd*k1**2 + 24*D1*K*b1*f*fd*k2**2*r**2 + 48*D1*K*b1*f*fd*k2**2*r*s - 12*D1*K*b1*f*fd*k2**2*r + 24*D1*K*b1*f*fd*k2**2*s**2 - 12*D1*K*b1*f*fd*k2**2*s + 4*D1*K*bd1*f**2*k1**2*r**2 + 8*D1*K*bd1*f**2*k1**2*r*s - 6*D1*K*bd1*f**2*k1**2*r + 4*D1*K*bd1*f**2*k1**2*s**2 - 6*D1*K*bd1*f**2*k1**2*s + 2*D1*K*bd1*f**2*k1**2 + 12*D1*K*bd1*f**2*k2**2*r**2 + 24*D1*K*bd1*f**2*k2**2*r*s - 12*D1*K*bd1*f**2*k2**2*r + 12*D1*K*bd1*f**2*k2**2*s**2 - 12*D1*K*bd1*f**2*k2**2*s + 7*D1*b1**3*fd*k2**2*r**2 + 14*D1*b1**3*fd*k2**2*r*s - 14*D1*b1**3*fd*k2**2*r + 7*D1*b1**3*fd*k2**2*s**2 - 14*D1*b1**3*fd*k2**2*s + 7*D1*b1**3*fd*k2**2 + 21*D1*b1**2*bd1*f*k2**2*r**2 + 42*D1*b1**2*bd1*f*k2**2*r*s - 35*D1*b1**2*bd1*f*k2**2*r + 21*D1*b1**2*bd1*f*k2**2*s**2 - 35*D1*b1**2*bd1*f*k2**2*s + 14*D1*b1**2*bd1*f*k2**2 - 6*D1*b1**2*f*fd*k2**2*r - 6*D1*b1**2*f*fd*k2**2*s + 6*D1*b1**2*f*fd*k2**2 + 6*D1*b1*bd1*f**2*k2**2*r + 6*D1*b1*bd1*f**2*k2**2*s - 6*D1*b1*bd1*f**2*k2**2 - 15*D1*b1*f**2*fd*k2**2*r**2 - 30*D1*b1*f**2*fd*k2**2*r*s + 25*D1*b1*f**2*fd*k2**2*r - 15*D1*b1*f**2*fd*k2**2*s**2 + 25*D1*b1*f**2*fd*k2**2*s - 10*D1*b1*f**2*fd*k2**2 - 4*D1*b1*f*gd2*k1**2*r - 4*D1*b1*f*gd2*k1**2*s + 4*D1*b1*f*gd2*k1**2 - 28*D1*b1*f*gd2*k2**2*r**2 - 56*D1*b1*f*gd2*k2**2*r*s + 28*D1*b1*f*gd2*k2**2*r - 28*D1*b1*f*gd2*k2**2*s**2 + 28*D1*b1*f*gd2*k2**2*s - 8*D1*b1*fd*g2*k1**2*r - 8*D1*b1*fd*g2*k1**2*s + 4*D1*b1*fd*g2*k1**2 - 28*D1*b1*fd*g2*k2**2*r**2 - 56*D1*b1*fd*g2*k2**2*r*s - 28*D1*b1*fd*g2*k2**2*s**2 - 5*D1*bd1*f**3*k2**2*r**2 - 10*D1*bd1*f**3*k2**2*r*s + 10*D1*bd1*f**3*k2**2*r - 5*D1*bd1*f**3*k2**2*s**2 + 10*D1*bd1*f**3*k2**2*s - 5*D1*bd1*f**3*k2**2 - 28*D1*bd1*f*g2*k2**2*r**2 - 56*D1*bd1*f*g2*k2**2*r*s + 28*D1*bd1*f*g2*k2**2*r - 28*D1*bd1*f*g2*k2**2*s**2 + 28*D1*bd1*f*g2*k2**2*s + 2*D1*bd2*f*(r + s - 1)*(b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s)) - 8*D1*f**2*gd2*k1**2*r**2 - 16*D1*f**2*gd2*k1**2*r*s + 12*D1*f**2*gd2*k1**2*r - 8*D1*f**2*gd2*k1**2*s**2 + 12*D1*f**2*gd2*k1**2*s - 4*D1*f**2*gd2*k1**2 - 24*D1*f**2*gd2*k2**2*r**2 - 48*D1*f**2*gd2*k2**2*r*s + 24*D1*f**2*gd2*k2**2*r - 24*D1*f**2*gd2*k2**2*s**2 + 24*D1*f**2*gd2*k2**2*s - 16*D1*f*fd*g2*k1**2*r**2 - 32*D1*f*fd*g2*k1**2*r*s + 16*D1*f*fd*g2*k1**2*r - 16*D1*f*fd*g2*k1**2*s**2 + 16*D1*f*fd*g2*k1**2*s - 4*D1*f*fd*g2*k1**2 - 48*D1*f*fd*g2*k2**2*r**2 - 96*D1*f*fd*g2*k2**2*r*s + 24*D1*f*fd*g2*k2**2*r - 48*D1*f*fd*g2*k2**2*s**2 + 24*D1*f*fd*g2*k2**2*s + 8*Dd*K*b1**2*f*k1**2*r + 8*Dd*K*b1**2*f*k1**2*s - 6*Dd*K*b1**2*f*k1**2 + 56*Dd*K*b1**2*f*k2**2*r**2 + 112*Dd*K*b1**2*f*k2**2*r*s - 42*Dd*K*b1**2*f*k2**2*r + 56*Dd*K*b1**2*f*k2**2*s**2 - 42*Dd*K*b1**2*f*k2**2*s + 16*Dd*K*b1*f**2*k1**2*r**2 + 32*Dd*K*b1*f**2*k1**2*r*s - 20*Dd*K*b1*f**2*k1**2*r + 16*Dd*K*b1*f**2*k1**2*s**2 - 20*Dd*K*b1*f**2*k1**2*s + 6*Dd*K*b1*f**2*k1**2 + 48*Dd*K*b1*f**2*k2**2*r**2 + 96*Dd*K*b1*f**2*k2**2*r*s - 36*Dd*K*b1*f**2*k2**2*r + 48*Dd*K*b1*f**2*k2**2*s**2 - 36*Dd*K*b1*f**2*k2**2*s + 28*Dd*b1**3*f*k2**2*r**2 + 56*Dd*b1**3*f*k2**2*r*s - 49*Dd*b1**3*f*k2**2*r + 28*Dd*b1**3*f*k2**2*s**2 - 49*Dd*b1**3*f*k2**2*s + 21*Dd*b1**3*f*k2**2 - 20*Dd*b1*f**3*k2**2*r**2 - 40*Dd*b1*f**3*k2**2*r*s + 35*Dd*b1*f**3*k2**2*r - 20*Dd*b1*f**3*k2**2*s**2 + 35*Dd*b1*f**3*k2**2*s - 15*Dd*b1*f**3*k2**2 - 16*Dd*b1*f*g2*k1**2*r - 16*Dd*b1*f*g2*k1**2*s + 12*Dd*b1*f*g2*k1**2 - 112*Dd*b1*f*g2*k2**2*r**2 - 224*Dd*b1*f*g2*k2**2*r*s + 84*Dd*b1*f*g2*k2**2*r - 112*Dd*b1*f*g2*k2**2*s**2 + 84*Dd*b1*f*g2*k2**2*s - 32*Dd*f**2*g2*k1**2*r**2 - 64*Dd*f**2*g2*k1**2*r*s + 40*Dd*f**2*g2*k1**2*r - 32*Dd*f**2*g2*k1**2*s**2 + 40*Dd*f**2*g2*k1**2*s - 12*Dd*f**2*g2*k1**2 - 96*Dd*f**2*g2*k2**2*r**2 - 192*Dd*f**2*g2*k2**2*r*s + 72*Dd*f**2*g2*k2**2*r - 96*Dd*f**2*g2*k2**2*s**2 + 72*Dd*f**2*g2*k2**2*s + 2*b2*(D1*(b1*fd*(k1**2 + 7*k2**2)*(r + s)**2 + bd1*f*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*fd*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(b1*(k1**2 + 7*k2**2)*(r + s) + f*k1**2*(2*r + 2*s - 1) + 6*f*k2**2*(r + s))))/(21*d**2*k3**4) + D1**3*Pk1*Pkdd3*k1**2*st**2*(13*D1*bd1*f*(r + s - 1)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + 8*K*r + 8*K*s - 3*K + b1*(-11*r - 11*s + 7) + 4*r + 4*s - 3) + k2**4*(-K*(r + s) + 3*b1*(5*r + 5*s - 3))) + k2**2*(13*k1**2 + 7*k2**2)*(r + s)*(-132*K*b1 + 132*g2)) - 429*b1**2*k2**2*(D1*fd*(2*K*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*(k1**2*(11*r + 11*s - 7) - 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**2*(11*r + 11*s - 7) - 3*f*k2**2*(5*r + 5*s - 3))) + 13*b1*(D1*(f**2*fd*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(2*r + 2*s - 1)*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) - 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s)) - 66*f*(-K*k2**4*(r + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(C*(-8*r - 8*s + 6) + K*(8*r + 8*s - 3) + 4*r + 4*s - 3)) + 132*g2*k2**2*(13*k1**2 + 7*k2**2)*(r + s))) + f*(D1*(5*f**2*fd*k2**2*(-2*k1**2*(r + s - 17) + 65*k2**2*(11*r + 11*s - 9))*(4*r + 4*s - 3) - 26*f*(fd*k1**2*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(r + s - 1)) - 1716*fd*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2*(2*k1**2*(r + s - 17) - 65*k2**2*(11*r + 11*s - 9)) + f*k1**2*(52*C - 26)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3)) + 1716*g2*k2**2*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s)))))/(9009*d**2*k3**6) - 2*D1**3*Pk1*Pkdd3*k2**2*st**4*(2*D1*f*(bd1*f**2*k2**2*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) + 33*bd1*k2**2*(b2 - 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - f*(6*C - 3)*(11*bd1*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1) + 2*fd*k1**2*(3*r + 3*s - 2)**2)) + 2*Dd*f**3*k1**2*(6 - 12*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 66*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(2*bd1*f*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(2 - 4*C)*(r + s - 1)**2 + k2**2*(2*K*(r + s)**2 + f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 2*Dd*f*(-k1**2*(2*C - 1)*(r + s - 1) + k2**2*(K*(r + s) + f*(r + s - 1)))*(4*r + 4*s - 3)) + b1*(33*D1*bd1*f*(k1**2*(2 - 4*C)*(2*r + 2*s - 1) + k2**2*(4*K*(r + s) + f*(4*r + 4*s - 3)))*(r + s - 1) + 2*D1*(f**2*fd*k2**2*(63*r**2 + 6*r*(21*s - 17) + 63*s**2 - 102*s + 43) - 33*f*(fd*(2*C - 1)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - k2**2*(bd2 - 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*fd*k2**2*(b2 - 2*g2)*(r + s)**2) + 2*Dd*f*(4*r + 4*s - 3)*(f**2*k2**2*(21*r + 21*s - 17) - f*(66*C - 33)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + k2**2*(33*b2 - 66*g2)*(r + s))))/(231*d**2*k3**4) + 2*D1**3*Pk1*Pkdd3*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(K*b1 - 2*g2) + f**3*fd*k2**2*(k1**2*(-449*r - 449*s + 327) + 13*k2**2*(17*r + 17*s - 11))*(4*r + 4*s - 3) - 78*f**2*(11*bd1*(r + s - 1)*(-2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2*C - 1)*(r + s) + k1**2*k2**2*(b1*(-3*r - 3*s + 1) + (2*C - 1)*(2*r + 2*s - 1))) + fd*k1**4*(4*C - 2)*(3*r + 3*s - 2)**2) + 429*f*(b1**2*fd*k2**2*(k1**2*(3*r + 3*s - 1) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) - 2*b1*k1**2*(fd*(2*C - 1)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*bd1*g2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-429*b1*f*(2*b1*k2**4*(2*r + 2*s - 1) + k1**4*(2 - 4*C)*(r + s) + k1**2*k2**2*(b1*(3*r + 3*s - 1) + (2 - 4*C)*(2*r + 2*s - 1))) - 858*b1*k1**2*k2**2*(r + s)*(K*b1 - 2*g2) + f**3*k2**2*(k1**2*(449*r + 449*s - 327) - 13*k2**2*(17*r + 17*s - 11)) + f**2*k1**4*(312*C - 156)*(3*r + 3*s - 2)))/(3003*d**2*k3**6) - D1**3*Pk1*Pkdd3*st**2*(r + s - 1)*(-2*D1*bd1*f*(r + s)*(f*(2*C - 1)*(k1**2 - k2**2) + k2**2*(b2 - 2*g2)) + 11*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(11*bd1*f*k2**2*(3*r + 3*s - 2) - 2*fd*(k1**2*(2*C - 1) + k2**2*(14*C + K - 5*f - 7))*(r + s - 1)) + Dd*f*(k1**2*(2 - 4*C) + k2**2*(-28*C - 2*K + 5*f + 14))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(k1**2*(2 - 4*C) + k2**2*(-28*C - 2*K + 5*f + 14))*(2*r + 2*s - 1) - 2*D1*(r + s - 1)*(f*fd*(4*C - 2)*(k1**2 - k2**2) + f*k2**2*(bd2 - 2*gd2) + fd*k2**2*(b2 - 2*g2)) - 2*Dd*f*(f*(2*C - 1)*(k1**2 - k2**2) + k2**2*(b2 - 2*g2))*(4*r + 4*s - 3)))/(21*d**2*k3**2) + 2*D1**3*Pk1*Pkdd3*(r + s - 1)*(-2*D1*bd1*f*k1**2*(b2 - 2*g2)*(r + s) + 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(7*D1*bd1*f*k2**2*(3*r + 3*s - 2) - 2*D1*fd*(K*k1**2 - 6*f*k2**2)*(r + s - 1) + 2*Dd*f*(-K*k1**2 + 3*f*k2**2)*(4*r + 4*s - 3)) - 2*b1*(2*D1*K*bd1*f*k1**2*r + 2*D1*K*bd1*f*k1**2*s - D1*K*bd1*f*k1**2 - 6*D1*bd1*f**2*k2**2*r - 6*D1*bd1*f**2*k2**2*s + 3*D1*bd1*f**2*k2**2 + D1*bd2*f*k1**2*(r + s - 1) - 2*D1*f*gd2*k1**2*r - 2*D1*f*gd2*k1**2*s + 2*D1*f*gd2*k1**2 - 2*D1*fd*g2*k1**2*r - 2*D1*fd*g2*k1**2*s + 2*D1*fd*g2*k1**2 - 8*Dd*f*g2*k1**2*r - 8*Dd*f*g2*k1**2*s + 6*Dd*f*g2*k1**2 + b2*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k3**2) + D1**3*Pk1*Pkdd3*st**2*(33*b1**3*k2**2*(13*k1**2 + 14*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*(D1*(-bd1*f*k2**2*(13*k1**2 + 14*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**4*(4*C - 2)*(r + s - 1)**2 + k1**2*k2**2*(28*C*(r + s - 1)**2 - 2*K*(12*r**2 + 24*r*s + 2*r + 12*s**2 + 2*s - 1) + f*(8*r**2 + 16*r*s + r + 8*s**2 + s - 5) - 14*(r + s - 1)**2) - k2**4*(14*K*(r + s)**2 + f*(20*r**2 + 5*r*(8*s - 5) + 20*s**2 - 25*s + 9)))) + 2*Dd*f*(4*r + 4*s - 3)*(k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(14*C*(r + s - 1) - K*(12*r + 12*s + 1) + 2*f*r + 2*f*s - 7*r - 7*s + 7) - k2**4*(7*K*(r + s) + f*(5*r + 5*s - 3)))) + b1*(-33*D1*bd1*f*(r + s - 1)*(k1**4*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(28*C*(2*r + 2*s - 1) - 48*K*r - 48*K*s - 2*K + f*(8*r + 8*s - 5) - 28*r - 28*s + 14) - k2**4*(28*K*(r + s) + f*(20*r + 20*s - 9))) + D1*(f**2*fd*k2**2*(-k1**2*(567*r**2 + 3*r*(378*s - 253) + 567*s**2 - 759*s + 260) + 33*k2**2*(36*r**2 + r*(72*s - 53) + 36*s**2 - 53*s + 21)) + 66*f*(fd*(K*k2**4*(-2*r**2 - 4*r*s + r - 2*s**2 + s) + k1**4*(2*C - 1)*(r + s - 1) + k1**2*k2**2*(-2*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + K*(16*r**2 + 32*r*s - 14*r + 16*s**2 - 14*s + 3) + 6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 1)) - k2**2*(-bd2*(13*k1**2 + 7*k2**2)*(r + s) + 2*gd2*(k1**2*(12*r + 12*s + 1) + 7*k2**2*(r + s)))*(r + s - 1)) - 66*fd*k2**2*(-b2*(13*k1**2 + 7*k2**2)*(r + s)**2 + 2*g2*(k1**2*(12*r**2 + r*(24*s + 2) + 12*s**2 + 2*s - 1) + 7*k2**2*(r + s)**2))) + Dd*f*k2**2*(4*r + 4*s - 3)*(66*b2*(13*k1**2 + 7*k2**2)*(r + s) + f**2*(k1**2*(-189*r - 189*s + 121) + 132*k2**2*(3*r + 3*s - 2)) - 66*f*(K*k2**2*(r + s) + k1**2*(C*(6*r + 6*s - 4) + K*(-8*r - 8*s + 3) - 3*r - 3*s + 2)) - 132*g2*(k1**2*(12*r + 12*s + 1) + 7*k2**2*(r + s)))) + f*(-D1*bd1*(r + s - 1)*(f**2*k2**2*(k1**2*(189*r + 189*s - 103) - 99*k2**2*(4*r + 4*s - 1)) + 66*f*(K*k2**4*(r + s) + k1**4*(2*C - 1) + k1**2*k2**2*(6*C*(r + s - 1) + K*(-8*r - 8*s + 3) - 3*r - 3*s + 3)) - 66*k2**2*(r + s)*(13*b2*k1**2 + 7*b2*k2**2 - 24*g2*k1**2 - 14*g2*k2**2)) + 2*D1*(f*(fd*k1**2*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + k2**2*(-33*bd2 + 66*gd2)*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(r + s - 1)) - 33*fd*k2**2*(b2 - 2*g2)*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s))*(2*r + 2*s - 1)) + 2*Dd*f*(f*k1**2*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3)) + k2**2*(-33*b2 + 66*g2)*(k1**2*(-8*r - 8*s + 3) + k2**2*(r + s)))*(4*r + 4*s - 3)))/(693*d**2*k3**4) + D1**3*Pk3*Pkd1*ct**7*f*k2**5*(32*C - 32)*(33*D1*bd1*f*(8*r**2 + r*(8*s - 13) - 10*s + 5) + 33*b1*(8*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(32*r**2 + 8*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(36*r + 36*s - 13) + Dd*f*(144*r**2 + 144*r*s - 78*r - 31*s + 8)))/(693*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**7*f*k2**3*(16*C - 16)*(33*D1*bd1*f*(r*(8*s - 5) - 10*s + 5) + 33*b1*(2*s - 1)*(8*D1*fd*r + Dd*f*(16*r - 5)) + 5*f*(D1*fd*(3*r - 1)*(36*s - 23) + Dd*f*(144*r*s - 82*r - 31*s + 18)))/(693*d**2*k3**4) + 8*D1**3*Pk3*Pkd1*ct**6*f*k2**4*(13*D1*bd1*f*(5*f*k2**2*(105*r**2 + r*(105*s - 184) - 135*s + 79) + 66*k1**2*(C*(44*r**2 + 44*r*s - 82*r - 64*s + 38) - 36*r**2 - 36*r*s + 69*r + 54*s - 33)) + 13*b1*(3*D1*fd*r*(5*f*k2**2*(105*r + 105*s - 59) + 176*k1**2*(C*(11*r + 11*s - 7) - 9*r - 9*s + 6)) + Dd*f*(5*f*k2**2*(420*r**2 + r*(420*s - 361) - 135*s + 79) + 66*k1**2*(2*C*(88*r**2 + 88*r*s - 78*r - 32*s + 19) - 144*r**2 - 144*r*s + 132*r + 54*s - 33))) + 10*f*(D1*fd*(14*f*k2**2*(4*r - 1)*(37*r + 37*s - 18) + 13*k1**2*(3*r - 1)*(2*C*(81*r + 81*s - 32) - 126*r - 126*s + 51)) + Dd*f*(14*f*k2**2*(4*r - 1)*(37*r + 37*s - 18) + 13*k1**2*(2*C*(324*r**2 + 324*r*s - 159*r - 56*s + 7) - 504*r**2 - 504*r*s + 240*r + 81*s - 6))))/(9009*d**2*k1*k3**6) + 8*D1**3*Pk3*Pkd1*ct**6*f*k2**2*(33*D1*bd1*f*(r*(8*s - 5) - 10*s + 5) + 33*b1*(2*s - 1)*(8*D1*fd*r + Dd*f*(16*r - 5)) + 5*f*(D1*fd*(3*r - 1)*(36*s - 23) + Dd*f*(144*r*s - 82*r - 31*s + 18)))/(693*d**2*k1*k3**2) + 8*D1**3*Pk3*Pkd1*ct**6*f*k2**2*(33*D1*bd1*f*(k1**2*(C*(52*r*s - 40*r - 68*s + 40) - 44*r*s + 35*r + 58*s - 35) + k2**2*(r**2*(34 - 26*C) + r*(26*C + 8*s - 39) - 10*s + 5)) + 33*b1*(4*D1*fd*r*(2*k1**2*(13*C*s - 8*C - 11*s + 7) + k2**2*(-13*C*r + 17*r + 4*s - 2)) + Dd*f*(k1**2*(4*C*(52*r*s - 32*r - 17*s + 10) - 176*r*s + 112*r + 58*s - 35) + k2**2*(-r**2*(104*C - 136) + r*(26*C + 32*s - 50) - 10*s + 5))) + f*(D1*fd*(3*r - 1)*(5*k1**2*(2*C*(111*s - 92) - 186*s + 161) + k2**2*(-2*C*(270*r + 119) + 720*r + 180*s + 173)) + Dd*f*(5*k1**2*(2*C*(444*r*s - 328*r - 91*s + 72) - 744*r*s + 574*r + 151*s - 126) + k2**2*(C*(-2160*r**2 - 412*r + 238) + 2880*r**2 + 720*r*s + 22*r - 155*s - 198))))/(693*d**2*k1*k3**4) + D1**3*Pk3*Pkd1*ct**5*f*k2**5*st**2*(32*C - 32)*(33*D1*bd1*f*(14*r**2 + r*(14*s - 19) - 10*s + 5) + 33*b1*(14*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(56*r**2 + 56*r*s - 42*r - 10*s + 5)) + f*(D1*fd*(864*r**2 + r*(864*s - 633) - 156*s + 71) + Dd*f*(1152*r**2 + 36*r*(32*s - 21) - 116*s + 31)))/(693*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**5*f*k2**3*st**2*(16*C - 16)*(33*D1*bd1*f*(r*(14*s - 5) - 10*s + 5) + 33*b1*(2*s - 1)*(14*D1*fd*r + Dd*f*(28*r - 5)) + f*(D1*fd*(9*r*(96*s - 43) - 156*s + 85) + Dd*f*(4*r*(288*s - 131) - 116*s + 45)))/(693*d**2*k3**4) - 16*D1**3*Pk3*Pkd1*ct**5*k2**3*(-13*D1*bd1*f*(5*f**2*k2**2*(42*r**2 + r*(42*s - 167) - 143*s + 97) + 33*f*(2*k1**2*(2*C*(7*r**2 + r*(7*s - 20) - 17*s + 13) - 7*r**2 + r*(26 - 7*s) + 23*s - 19) + k2**2*(-12*C*(r - 1)*(2*r + 2*s - 1) + 2*K*r**2 + 2*K*r*s + 4*K*r + K*s - K + b1*(-16*r**2 - 16*r*(s - 1) + 10*s - 5) + 22*r**2 + 22*r*s - 40*r - 25*s + 13)) + 66*k2**2*(b1*(K - 1)*(5*r**2 + r*(5*s - 2) - 3*s) + g2*(-5*r**2 - 5*r*(s - 1) + 6*s))) + 429*b1**2*k2**2*(D1*fd*r*(8*f*(2*r + 2*s - 1) + (5 - 5*K)*(r + s)) + Dd*f*(f*(32*r**2 + 8*r*(4*s - 3) - 10*s + 5) - (K - 1)*(20*r**2 + r*(20*s - 3) - 6*s))) - 13*b1*(D1*(5*f**2*fd*k2**2*(126*r**2 + 9*r*(14*s - 9) + 36*s - 13) + 66*f*(2*fd*k1**2*r*(2*C*(7*r + 7*s - 8) - 7*r - 7*s + 11) + fd*k2**2*(K*(2*r - 1)*(r + s + 1) + r**2*(22 - 24*C) + r*(-24*C*s + 12*C + 22*s - 13) + s + 1) - gd2*k2**2*r*(5*r + 5*s + 1)) - 330*fd*g2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(168*r**2 + 8*r*(21*s - 31) - 107*s + 84) + 66*f*(k1**2*(C*(56*r**2 + r*(56*s - 78) - 34*s + 26) - 28*r**2 + r*(51 - 28*s) + 23*s - 19) + k2**2*(-6*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s + 5*r - 2) + 44*r**2 + 44*r*s - 41*r - 12*s + 8)) - 66*g2*k2**2*(20*r**2 + r*(20*s - 3) - 6*s))) + f*(D1*(-280*f**2*fd*k2**2*(4*r - 1)*(11*r + 11*s - 5) + 65*f*fd*(3*r - 1)*(k1**2*(C*(6*r + 6*s - 4) - 51*r - 51*s + 23) + k2**2*(66*C - 66)*(2*r + 2*s - 1)) + 858*f*gd2*k2**2*(2*r**2 + 2*r*(s + 2) + s - 1) + 1716*fd*g2*k2**2*(2*r - 1)*(r + s + 1)) + Dd*f*(-280*f**2*k2**2*(4*r - 1)*(11*r + 11*s - 5) + 65*f*(k1**2*(2*C*(12*r**2 + 3*r*(4*s - 37) - 53*s + 52) - 204*r**2 + r*(303 - 204*s) + 131*s - 103) + k2**2*(66*C - 66)*(4*r - 1)*(2*r + 2*s - 1)) + 1716*g2*k2**2*(4*r**2 + r*(4*s + 5) - 2))))/(9009*d**2*k3**6) - 8*D1**3*Pk3*Pkd1*ct**5*k2*(-66*b1**2*k1**2*(C - 1)*(5*D1*fd*r*(s - 1) + 2*Dd*f*(r*(10*s - 11) - 3*s + 3)) + 33*b1*f*(-4*D1*bd1*k1**2*(C - 1)*(r*(5*s - 6) - 3*s + 3) + 2*D1*fd*(2*k1**2*(C*(6*r*s + s - 2) - 7*r*s + 2*r - s + 2) + 9*k2**2*r**2) + Dd*f*(k1**2*(4*C*(12*r*s - 5*s + 1) - 56*r*s + 16*r + 24*s - 9) + 9*k2**2*r*(4*r - 1))) + f**2*(33*D1*bd1*(k1**2*(2*C*(6*r*s - 11*s + 5) - 14*r*s + 5*r + 26*s - 15) + 9*k2**2*r*(r - 1)) + D1*fd*(3*r - 1)*(5*k1**2*(C*(72*s - 46) - 75*s + 69) + 2*k2**2*(90*r + 47)) + 2*Dd*f*(5*k1**2*(C*(144*r*s - 82*r - 31*s + 18) - 150*r*s + 123*r + 30*s - 27) + k2**2*(360*r**2 + 98*r - 47))))/(693*d**2*k1**2*k3**2) + 2*D1**3*Pk3*Pkd1*ct**5*k2*(-39*D1*bd1*f*(-88*b1*k1**2*k2**2*(C - 1)*(10*r**2 + r*(10*s - 17) - 6*s + 6) + 85*f**2*k2**4*r*(r - 1) - 44*f*k1**2*(k1**2*(12*C*(5*r*(s - 1) - 7*s + 5) + r*(45 - 42*s) + 60*s - 45) + k2**2*(C*(-57*r**2 + r*(2*s + 63) + 18*s - 8) + 50*r**2 - 4*r*(s + 15) - 20*s + 12))) + 3432*b1**2*k1**2*k2**2*(C - 1)*(5*D1*fd*r*(r + s - 1) + Dd*f*(20*r**2 + r*(20*s - 27) - 6*s + 6)) - 39*b1*f*(D1*fd*(255*f*k2**4*r**2 - 528*k1**4*r*(2*C*(5*s - 4) - 7*s + 6) + 88*k1**2*k2**2*(C*(57*r**2 - 2*r*s + 5*r + 2*s - 2) - 50*r**2 + r*(4*s - 3) - 2*s + 2)) + Dd*f*(85*f*k2**4*r*(4*r - 1) - 132*k1**4*(4*C*(4*r*(5*s - 4) - 7*s + 5) - 56*r*s + 48*r + 20*s - 15) + 44*k1**2*k2**2*(C*(228*r**2 - 8*r*s - 45*r - 16*s + 6) - 200*r**2 + 16*r*s + 46*r + 18*s - 10))) + f**2*(D1*fd*(15*f*k2**4*(28*r**2 - 1119*r + 278) + 780*k1**4*(3*r - 1)*(C*(78*s - 92) - 53*s + 69) - 52*k1**2*k2**2*(C*(2205*r**2 - 810*r*s + 2859*r + 336*s - 1220) - 1710*r**2 + 3*r*(405*s - 899) - 471*s + 1111)) + Dd*f*(15*f*k2**4*(28*r**2 - 1119*r + 278) + 1560*k1**4*(C*(4*r*(39*s - 41) - 29*s + 36) - 106*r*s + 123*r + 19*s - 27) - 52*k1**2*k2**2*(C*(2940*r**2 - 1080*r*s + 4477*r + 568*s - 1452) - 2280*r**2 + 1620*r*s - 4306*r - 753*s + 1393))))/(9009*d**2*k1**2*k3**4) + 4*D1**3*Pk3*Pkd1*ct**4*f*k2**4*st**2*(39*D1*bd1*f*(5*f*k2**2*(135*r**2 + 3*r*(45*s - 71) - 128*s + 78) + 44*k1**2*(C*(98*r**2 + 98*r*s - 133*r - 67*s + 35) - 84*r**2 - 84*r*s + 114*r + 57*s - 30)) + 39*b1*(D1*fd*r*(5*f*k2**2*(405*r + 405*s - 248) + 44*k1**2*(196*C*r + 196*C*s - 101*C - 168*r - 168*s + 87)) + Dd*f*(5*f*k2**2*(540*r**2 + r*(540*s - 461) - 128*s + 78) + 44*k1**2*(C*(392*r**2 + 4*r*(98*s - 75) - 67*s + 35) - 336*r**2 - 336*r*s + 258*r + 57*s - 30))) + f*(D1*fd*(25*f*k2**2*(2908*r**2 + r*(2908*s - 2193) - 402*s + 204) + 52*k1**2*(C*(5616*r**2 + 6*r*(936*s - 683) - 849*s + 401) - 4752*r**2 - 99*r*(48*s - 35) + 693*s - 330)) + Dd*f*(25*f*k2**2*(2908*r**2 + r*(2908*s - 2193) - 402*s + 204) + 52*k1**2*(C*(7488*r**2 + 234*r*(32*s - 21) - 545*s + 97) - 6336*r**2 - 198*r*(32*s - 21) + 429*s - 66))))/(9009*d**2*k1*k3**6) + 8*D1**3*Pk3*Pkd1*ct**4*f*k2**2*st**2*(33*D1*bd1*f*(r*(14*s - 5) - 10*s + 5) + 33*b1*(2*s - 1)*(14*D1*fd*r + Dd*f*(28*r - 5)) + f*(D1*fd*(9*r*(96*s - 43) - 156*s + 85) + Dd*f*(4*r*(288*s - 131) - 116*s + 45)))/(693*d**2*k1*k3**2) + 8*D1**3*Pk3*Pkd1*ct**4*f*k2**2*st**2*(33*D1*bd1*f*(k1**2*(C*(86*r*s - 32*r - 61*s + 32) - 72*r*s + 27*r + 51*s - 27) + k2**2*(r**2*(27 - 13*C) + r*(13*C + 14*s - 32) - 10*s + 5)) + 33*b1*(D1*fd*r*(k1**2*(172*C*s - 89*C - 144*s + 75) + 2*k2**2*(-13*C*r + 27*r + 14*s - 7)) + Dd*f*(k1**2*(C*(344*r*s - 178*r - 61*s + 32) - 288*r*s + 150*r + 51*s - 27) + k2**2*(r**2*(108 - 52*C) + r*(13*C + 56*s - 55) - 10*s + 5))) + f*(D1*fd*(k1**2*(C*(189*r*(28*s - 13) - 939*s + 544) - 9*r*(492*s - 230) + 783*s - 459) + k2**2*(C*(-999*r**2 + 303*r + 10) + 1863*r**2 + 864*r*s - 936*r - 156*s + 61)) + Dd*f*(k1**2*(C*(7056*r*s - 3314*r - 683*s + 288) - 5904*r*s + 2790*r + 567*s - 243) + k2**2*(C*(-1332*r**2 + 293*r + 10) + 2484*r**2 + 1152*r*s - 1049*r - 116*s + 21))))/(693*d**2*k1*k3**4) - 8*D1**3*Pk3*Pkd1*ct**4*k2**2*(13*D1*bd1*f*(5*f**2*k2**2*(k1**2*(120*r**2 + 3*r*(40*s + 41) + 157*s - 151) + 33*k2**2*(r - 1)*(5*r + 5*s - 3)) + 66*f*k1**2*(4*k1**2*(C*(5*r**2 + r*(5*s + 2) + 5*s - 7) - 5*r**2 - 5*r*s + r - 2*s + 4) + k2**2*(12*C*(r - 1)*(7*r + 7*s - 4) + 2*K*r**2 + 2*K*r*s - 20*K*r - 5*K*s + 5*K + b1*(22*r**2 + r*(22*s - 25) - 19*s + 11) - 76*r**2 - 76*r*s + 130*r + 76*s - 46)) - 132*k1**2*k2**2*(b1*(K*r*(11*s - 3) + r**2*(11*K - 6) - 6*r*s + r + s*(5 - 8*K)) + g2*(-11*r**2 - 11*r*(s - 1) + 16*s))) + 858*b1**2*k1**2*k2**2*(D1*fd*r*(2*f*(11*r + 11*s - 7) - (11*K - 6)*(r + s)) + Dd*f*(f*(44*r**2 + r*(44*s - 39) - 19*s + 11) + r**2*(24 - 44*K) + r*(-44*K*s + K + 24*s + 2) + s*(16*K - 10))) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(360*r**2 + 9*r*(40*s - 11) - 57*s + 5) + 99*k2**2*r*(5*r + 5*s - 3)) + 132*f*k1**2*(2*fd*k1**2*r*(2*C*(5*r + 5*s + 2) - 10*r - 10*s - 1) + fd*k2**2*(K*(2*r - 1)*(r + s - 5) + 2*r**2*(42*C - 38) + 2*r*(6*C*(7*s - 4) - 38*s + 26) + 2*s - 4) + gd2*k2**2*r*(11*r + 11*s + 5)) + 1452*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(2*k1**2*(240*r**2 + 12*r*(20*s + 1) + 50*s - 73) + 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 132*f*k1**2*(2*k1**2*(C*(20*r**2 + r*(20*s + 3) + 5*s - 7) - 20*r**2 + r*(3 - 20*s) - 2*s + 4) + k2**2*(6*C*(4*r - 1)*(7*r + 7*s - 4) + K*(4*r**2 + 4*r*s - 31*r - 6*s + 10) - 152*r**2 - 152*r*s + 146*r + 42*s - 29)) + 132*g2*k1**2*k2**2*(44*r**2 + r*(44*s - 1) - 16*s))) + 2*f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(k1**2*(51*r + 51*s - 35) + 13*k2**2*(5*r + 5*s - 3)) + 13*f*k1**2*(5*fd*(3*r - 1)*(k1**2*(2*C*(135*r + 135*s - 68) - 222*r - 222*s + 115) + 33*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 66*gd2*k2**2*(2*r**2 + 2*r*(s - 10) - 5*s + 5)) - 1716*fd*g2*k1**2*k2**2*(2*r - 1)*(r + s - 5)) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(k1**2*(51*r + 51*s - 35) + 13*k2**2*(5*r + 5*s - 3)) + 65*f*k1**2*(k1**2*(2*C*(540*r**2 + 540*r*s - 507*r - 185*s + 118) - 888*r**2 - 888*r*s + 822*r + 292*s - 185) + 33*k2**2*(4*r - 1)*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 1716*g2*k1**2*k2**2*(4*r**2 + r*(4*s - 31) - 6*s + 10))))/(9009*d**2*k1*k3**6) + 8*D1**3*Pk3*Pkd1*ct**4*(D1*bd1*f**2*(r*(2*s - 5) + s) + b1**2*(5*D1*fd*r*(s - 1) + 2*Dd*f*(r*(10*s - 11) - 3*s + 3)) + b1*f*(2*D1*bd1*(r*(5*s - 6) - 3*s + 3) + 2*D1*fd*(2*r - 1)*(s - 2) + Dd*f*(8*r*(s - 2) + 3)))/(21*d**2*k1) + 4*D1**3*Pk3*Pkd1*ct**4*(66*b1**2*(5*D1*fd*r*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(3 - 3*C)) + Dd*f*(k1**2*(8*C - 6)*(r*(10*s - 11) - 3*s + 3) + k2**2*r*(15 - 15*C)*(4*r - 1))) - 33*b1*f*(-4*D1*bd1*k1**2*(4*C - 3)*(r*(5*s - 6) - 3*s + 3) + 30*D1*bd1*k2**2*r*(C - 1)*(2*r - 1) + 4*D1*fd*k1**2*(4*C*(3*r*s + s - 2) - 6*r*s - 3*s + 6) + 2*D1*fd*k2**2*(C*(10*r**2 + 9*r - 8) + 3*r**2 - 2*r*(5*s + 2) + 8) + 4*Dd*f*k1**2*(2*C*(s*(12*r - 7) + 2) + s*(9 - 12*r) - 3) + Dd*f*k2**2*(2*C*(20*r**2 + 27*r - 8) + 12*r**2 - r*(40*s + 47) + 2*s + 15)) + f**2*(-33*D1*bd1*(2*k1**2*(4*C*(3*r*s - 8*s + 5) - 6*r*s + 21*s - 15) + k2**2*(r**2*(10*C + 3) + 2*r*(10*C - 5*s - 16) + 2*s - 1)) - 2*D1*fd*(5*k1**2*(3*r - 1)*(C*(78*s - 92) - 42*s + 69) + k2**2*(C*(360*r**2 - 834*r + 238) - 90*r**2 - 720*r*s + 1290*r + 273*s - 431)) + Dd*f*(-10*k1**2*(C*(8*r*(39*s - 41) - 58*s + 72) + 3*r*(82 - 56*s) + 27*s - 54) + k2**2*(-4*C*(240*r**2 - 536*r + 119) + 240*r**2 + 30*r*(64*s - 123) - 703*s + 1019))))/(693*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**4*(13*D1*bd1*f*(f**2*k2**4*(1260*r**2 + 21*r*(155*s - 74) - 1450*s + 890) + 66*f*(k1**4*(8*C*(r*(7*s - 10) - 11*s + 10) + r*(50 - 32*s) + 52*s - 50) + k1**2*k2**2*(-6*C*(r**2 - r*(11*s + 3) - 6*s + 4) - 7*r**2 + r*(4 - 76*s) - 12*s + 13) + k2**4*(2*b1*(22*r**2 + r*(20*s - 27) - 14*s + 9) + r**2*(48*C - 7*K - 61) - 4*r*(12*C + 2*K + 5*s - 25) + 26*s - 14)) + 66*k2**2*(2*b1*k1**2*(C*(32*r**2 + 32*r*s - 60*r - 22*s + 22) - 22*r**2 + r*(43 - 22*s) + 16*s - 16) + b1*k2**2*(r**2*(50 - 30*K) + r*(15*K + 20*s - 23) - 12*s) + 30*g2*k2**2*r*(r - 1))) + 858*b1**2*k2**2*(D1*fd*r*(k1**2*(32*C - 22)*(r + s - 1) + k2**2*(4*f*(11*r + 10*s - 6) + r*(25 - 15*K) + 10*s)) + Dd*f*(2*k1**2*(C*(64*r**2 + 64*r*s - 92*r - 22*s + 22) - 44*r**2 + r*(65 - 44*s) + 16*s - 16) + k2**2*(2*f*(44*r**2 + r*(40*s - 39) - 14*s + 9) + r**2*(100 - 60*K) + r*(15*K + 40*s - 21) - 12*s))) + 13*b1*(3*D1*(f**2*fd*k2**4*(1260*r**2 + r*(3255*s - 1564) - 260*s - 52) + 22*f*(fd*(16*k1**4*r*(C*(7*s - 8) - 4*s + 5) - 2*k1**2*k2**2*(r**2*(6*C + 7) + r*(C*(21 - 66*s) + 76*s - 22) + 2*s - 2) - k2**4*(K*(14*r**2 + 9*r - 8) + r**2*(122 - 96*C) + r*(40*s - 37) + 4*s + 12)) + 30*gd2*k2**4*r**2) + 660*fd*g2*k2**4*r**2) + 2*Dd*f*(f**2*k2**4*(2520*r**2 + r*(6510*s - 3123) - 1115*s + 367) + 33*f*(2*k1**4*(4*C*(4*r*(7*s - 8) - 11*s + 10) + r*(80 - 64*s) + 26*s - 25) - k1**2*k2**2*(6*C*(4*r**2 + r*(13 - 44*s) - 8*s + 6) + 28*r**2 + r*(304*s - 103) + 26*s - 27) - k2**4*(K*(28*r**2 + 25*r - 8) - r**2*(192*C - 244) + r*(48*C + 80*s - 165) - 24*s + 28)) + 990*g2*k2**4*r*(4*r - 1))) + 2*f*(D1*(5*f**2*fd*k2**4*(7224*r**2 + r*(11830*s - 14233) - 3120*s + 3188) + 26*f*(fd*(5*k1**4*(3*r - 1)*(2*C*(45*s - 92) - 48*s + 115) + k1**2*k2**2*(3*C*(1695*r**2 + r*(1965*s - 3116) - 732*s + 876) - 4635*r**2 - 9*r*(685*s - 887) + 2253*s - 2212) + 165*k2**4*(3*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 33*gd2*k2**4*r*(7*r + 8)) + 858*fd*g2*k2**4*(14*r**2 + 9*r - 8)) + Dd*f*(5*f**2*k2**4*(7224*r**2 + r*(11830*s - 14233) - 3120*s + 3188) + 13*f*(10*k1**4*(2*C*(4*r*(45*s - 82) - 25*s + 72) + r*(410 - 192*s) + 23*s - 90) + k1**2*k2**2*(6*C*(2260*r**2 + r*(2620*s - 4423) - 986*s + 1130) - 12360*r**2 - 24*r*(685*s - 947) + 5873*s - 5791) + 330*k2**4*(4*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 858*g2*k2**4*(28*r**2 + 25*r - 8))))/(9009*d**2*k1*k3**4) + D1**3*Pk3*Pkd1*ct**3*f*k2**5*st**4*(32*C - 32)*(2*D1*(33*b1*fd*r*(2*r + 2*s - 1) + 33*bd1*f*r*(r + s - 1) + 5*f*fd*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(66*b1*r*(4*r + 4*s - 3) + 5*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)))/(231*d**2*k3**6) + D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**4*(16*C - 16)*(2*D1*(33*b1*fd*r*(2*s - 1) + 33*bd1*f*r*s + 5*f*fd*(3*r - 1)*(3*s - 1)) + Dd*f*(132*b1*r*(2*s - 1) + 5*f*(24*r*s - 10*r - 7*s + 3)))/(231*d**2*k3**4) - 8*D1**3*Pk3*Pkd1*ct**3*k2**3*st**2*(-13*D1*bd1*f*(2*f**2*k2**2*(666*r**2 + 2*r*(333*s - 701) - 913*s + 611) + 33*f*(k1**2*(2*C*(131*r**2 + r*(131*s - 178) - 85*s + 47) - 192*r**2 - 3*r*(64*s - 87) + 123*s - 69) + k2**2*(-6*C*(r - 1)*(2*r + 2*s - 1) + 7*K*r**2 + 7*K*r*s - 4*K*r - 2*b1*(28*r**2 + 28*r*(s - 1) - 10*s + 5) + 5*r**2 + 5*r*s - 14*r - 12*s + 6)) + 33*k2**2*(b1*(K - 1)*(26*r**2 + r*(26*s - 23) - 3*s) + 2*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k2**2*(D1*fd*r*(28*f*(2*r + 2*s - 1) + (13 - 13*K)*(r + s)) + Dd*f*(2*f*(56*r**2 + 56*r*s - 42*r - 10*s + 5) - (K - 1)*(52*r**2 + 52*r*s - 33*r - 3*s))) - 13*b1*(D1*(2*f**2*fd*k2**2*(1998*r**2 + 54*r*(37*s - 23) + 156*s - 71) + 33*f*(fd*k1**2*r*(4*C*(131*r + 131*s - 70) - 384*r - 384*s + 207) + fd*k2**2*(K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(10 - 24*C) + r*(-24*C*s + 12*C + 10*s - 1) + 5*s - 2) - 2*gd2*k2**2*r*(13*r + 13*s - 10)) - 858*fd*g2*k2**2*r*(r + s)) + Dd*f*(2*f**2*k2**2*(2664*r**2 + 4*r*(666*s - 661) - 757*s + 540) + 33*f*(k1**2*(2*C*(524*r**2 + r*(524*s - 411) - 85*s + 47) - 768*r**2 + r*(606 - 768*s) + 123*s - 69) + k2**2*(-6*C*(4*r - 1)*(2*r + 2*s - 1) + K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 20*r**2 + 20*r*s - 17*r - 7*s + 4)) - 66*g2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(-50*f**2*fd*k2**2*(1280*r**2 + 2*r*(640*s - 471) - 99*s + 45) - 13*f*(fd*k1**2*(22*C*(621*r**2 + 9*r*(69*s - 50) - 69*s + 35) - 9774*r**2 + r*(7068 - 9774*s) + 981*s - 511) + fd*k2**2*(198 - 198*C)*(3*r - 1)*(2*r + 2*s - 1) - 66*gd2*k2**2*r*(7*r + 7*s - 4)) + 858*fd*g2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(-50*f**2*k2**2*(1280*r**2 + 2*r*(640*s - 471) - 99*s + 45) - 13*f*(k1**2*(22*C*(828*r**2 + r*(828*s - 543) - 29*s - 5) - 13032*r**2 - 13032*r*s + 8544*r + 325*s + 145) + k2**2*(198 - 198*C)*(4*r - 1)*(2*r + 2*s - 1)) + 858*g2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**6) + 16*D1**3*Pk3*Pkd1*ct**3*k2*(-13*D1*bd1*f*(66*C*f*k1**2*(k1**2*(14*r**2 + r*(14*s - 13) - 4*s - 1) + 18*k2**2*(r - 1)*(3*r + 3*s - 2)) + 5*f**2*k2**2*(k1**2*(6*r**2 + r*(6*s + 20) + 3*s - 23) + 33*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 66*f*(k1**4*(9*r**2 + 9*r*(s - 1) - 3*s) + k1**2*k2**2*(K*(-11*r**2 - 11*r*s + 20*r + 5*s - 5) + 3*b1*(2*r + 1)*(r + s - 1) + 48*r**2 + 48*r*s - 78*r - 42*s + 30) + 3*k2**4*(b1*(2*r - 1)*(2*r + 2*s - 1) - r*(K - 1)*(r + s))) - 33*k2**2*(b1*k1**2*(-11*K*s + r**2*(2*K + 10) + r*(K*(2*s + 9) + 10*s - 11) + s) - 7*b1*k2**2*(K - 1)*(r + s)*(2*r - 1) - 2*g2*k1**2*(r**2 + r*(s - 1) - 11*s) + 14*g2*k2**2*(r - 1)*(r + s))) + 429*b1**2*k2**2*(D1*fd*r*(12*f*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + (r + s)*(k1**2*(K + 5) - k2**2*(7*K - 7))) + Dd*f*(6*f*(k1**2*(4*r**2 + r*(4*s - 1) + s - 1) + k2**2*(4*r - 1)*(2*r + 2*s - 1)) + k1**2*(-11*K*s + r**2*(4*K + 20) + r*(K*(4*s + 19) + 20*s - 17) + s) + k2**2*(7 - 7*K)*(r + s)*(4*r - 1))) - 13*b1*(66*C*f*k1**2*(4*D1*fd*r*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(3*r + 3*s - 2)) + Dd*f*(k1**2*(56*r**2 + 56*r*s - 30*r - 4*s - 1) + 18*k2**2*(4*r - 1)*(3*r + 3*s - 2))) + 3*D1*(5*f**2*fd*k2**2*(k1**2*(6*r**2 + 6*r*s + 34*r + 27*s - 18) + 11*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) - 22*f*(fd*(6*k1**4*r*(3*r + 3*s - 1) + k1**2*k2**2*(-K*(2*r - 1)*(11*r + 11*s - 10) + 96*r**2 + r*(96*s - 75) - 9*s + 6) + k2**4*(3 - 3*K)*(r + s)*(2*r - 1)) + gd2*k2**2*r*(-k1**2*(r + s + 10) + 7*k2**2*(r + s))) + 22*fd*g2*k2**2*r*(k1**2 - 7*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(k1**2*(24*r**2 + 2*r*(12*s + 61) + 84*s - 77) + 33*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 66*f*(3*k1**4*(12*r**2 + r*(12*s - 7) - s) + k1**2*k2**2*(K*(-44*r**2 + r*(71 - 44*s) + 21*s - 20) + 192*r**2 + 192*r*(s - 1) - 54*s + 39) + k2**4*(3 - 3*K)*(r + s)*(4*r - 1)) + 66*g2*k2**2*(k1**2*(4*r**2 + r*(4*s + 19) - 11*s) - 7*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-140*f**2*fd*k2**2*(4*r - 1)*(k1**2*(43*r + 43*s - 29) + 26*k2**2*(3*r + 3*s - 2)) - 65*f*fd*k1**2*(3*r - 1)*(k1**2*(2*C*(117*r + 117*s - 67) - 147*r - 147*s + 87) + 33*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 1716*f*gd2*k2**2*(k1**2*(11*r**2 + r*(11*s - 20) - 5*s + 5) + 3*k2**2*r*(r + s)) + 1716*fd*g2*k2**2*(2*r - 1)*(k1**2*(11*r + 11*s - 10) + 3*k2**2*(r + s))) + Dd*f*(-140*f**2*k2**2*(4*r - 1)*(k1**2*(43*r + 43*s - 29) + 26*k2**2*(3*r + 3*s - 2)) - 65*f*k1**2*(k1**2*(2*C*(468*r**2 + 468*r*s - 435*r - 142*s + 92) - 588*r**2 - 588*r*s + 555*r + 177*s - 117) + 33*k2**2*(4*r - 1)*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 1716*g2*k2**2*(k1**2*(44*r**2 + r*(44*s - 71) - 21*s + 20) + 3*k2**2*(r + s)*(4*r - 1)))))/(9009*d**2*k3**6) - 2*D1**3*Pk3*Pkd1*ct**3*(13*D1*bd1*f*(f**2*k2**4*(1020*r**2 - 2940*r*s + 619*r + 3196*s - 2076) - 33*f*(k1**4*(8*C - 4)*(r*(2*s - 5) - 4*s + 5) + 2*k1**2*k2**2*(r**2*(98*C - 60) + r*(2*C*(51*s - 55) - 79*s + 74) - 2*s*(6*C - 8) - 6) + k2**4*(48*C*(6*r**2 + r*(s - 7) - 2*s + 1) + 2*K*(15*r**2 + 19*r*s - 53*r - 6*s + 6) - 98*b1*r**2 - 152*b1*r*s + 101*b1*r + 8*b1*s - 344*r**2 - 142*r*s + 478*r + 140*s - 92)) + 132*k2**2*(b1**2*k2**2*(15*r**2 + r*(15*s - 22) - 6*s + 6) + b1*(-k1**2*(2*C*(2*r**2 + 2*r*s - 9*r - 4*s + 4) + 2*r**2 + 2*r*s + 5*r + 3*s - 3) + k2**2*(14*C*(2*r - 1)*(r + s - 1) + 35*K*r**2 + 3*K*r*s - 22*K*r + K - 49*r**2 - 23*r*s + 55*r + 12*s - 15)) + k2**2*(b2*(5*r**2 + 5*r*(s - 1) - 6*s) - g2*(35*r**2 + r*(3*s - 35) + 2*s)))) + 1716*b1**3*k2**4*(5*D1*fd*r*(r + s - 1) + Dd*f*(20*r**2 + r*(20*s - 27) - 6*s + 6)) + 429*b1**2*k2**2*(2*D1*fd*(k1**2*r*(-4*C - 2)*(r + s - 1) + k2**2*(28*C*r**2 + 28*C*r*s - 28*C*r + K*(35*r**2 + 3*r*s - 8*r - 4*s + 4) + f*(49*r**2 + r*(76*s - 50) - 4*s + 4) - 49*r**2 - 23*r*s + 36*r + 4*s - 4)) + Dd*f*(-4*k1**2*(C*(8*r**2 + r*(8*s - 22) - 8*s + 8) + 4*r**2 + 4*r*s + 3*r + 3*s - 3) + k2**2*(56*C*(4*r - 1)*(r + s - 1) + 2*K*(140*r**2 + 12*r*s - 61*r - 6*s + 8) + f*(196*r**2 + r*(304*s - 201) - 16*s + 8) - 392*r**2 - 184*r*s + 358*r + 60*s - 72))) + 13*b1*(3*D1*(f**2*fd*k2**4*(1020*r**2 - r*(2940*s + 701) - 1044*s + 1210) - 22*f*(fd*(k1**4*r*(16*C - 8)*(s - 2) + k1**2*k2**2*(2*C*(98*r**2 + 3*r*(34*s - 5) + 12*s - 12) - 120*r**2 - 158*r*s + 27*r - 20*s + 20) + k2**4*(24*C*(12*r**2 + 2*r*s + r + s - 1) + K*(30*r**2 + 38*r*s - 99*r - 20*s + 42) - 344*r**2 - 142*r*s + 108*r + 12*s - 16)) - 2*k2**4*(bd2*r*(5*r + 5*s + 1) + gd2*(-35*r**2 - 3*r*s + 9*r + 2*s - 2))) + 44*fd*k2**4*(5*b2*r*(r + s) + g2*(-35*r**2 - 3*r*s + 8*r + 4*s - 4))) + 2*Dd*f*(f**2*k2**4*(2040*r**2 - 14*r*(420*s + 53) + 32*s + 777) - 33*f*(k1**4*(4*C - 2)*(8*r*(s - 2) - 4*s + 5) + 2*k1**2*k2**2*(C*(196*r**2 + 204*r*s - 103*r + 12*s - 18) - 120*r**2 + r*(77 - 158*s) - 6*s + 11) + k2**4*(-24*C*s + K*(60*r**2 + r*(76*s - 205) - 32*s + 54) + r**2*(576*C - 688) + 2*r*(48*C*s - 72*C - 142*s + 209) + 92*s - 72)) - 66*k2**4*(b2*(-20*r**2 + r*(3 - 20*s) + 6*s) + g2*(140*r**2 + r*(12*s - 61) - 6*s + 8)))) + f*(D1*(-5*f**2*fd*k2**4*(28644*r**2 + r*(56784*s - 54505) - 14976*s + 12226) - 26*f*(fd*(k1**4*(20*C - 10)*(3*r - 1)*(3*s - 23) + k1**2*k2**2*(2*C*(9315*r**2 + 15*r*(591*s - 710) - 3252*s + 2614) - 12015*r**2 - 9*r*(1505*s - 1608) + 4944*s - 3632) + 330*k2**4*(3*r - 1)*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) - 66*k2**4*(bd2*(2*r**2 + 2*r*(s + 2) + s - 1) + gd2*(15*r**2 + r*(19*s - 53) - 6*s + 6))) + 1716*fd*k2**4*(2*b2*(2*r - 1)*(r + s + 1) + g2*(30*r**2 + r*(38*s - 99) - 20*s + 42))) + Dd*f*(-5*f**2*k2**4*(28644*r**2 + r*(56784*s - 54505) - 14976*s + 12226) - 26*f*(k1**4*(40*C - 20)*(r*(6*s - 41) + s + 9) + k1**2*k2**2*(C*(24840*r**2 + 10*r*(2364*s - 2951) - 8292*s + 7016) - 16020*r**2 + r*(20291 - 18060*s) + 6252*s - 4940) + 330*k2**4*(4*r - 1)*(2*C*(7*r + 2*s - 1) - 14*r - 5*s + 3)) + 1716*k2**4*(2*b2*(4*r**2 + r*(4*s + 5) - 2) + g2*(60*r**2 + r*(76*s - 205) - 32*s + 54)))))/(9009*d**2*k2*k3**4) + 4*D1**3*Pk3*Pkd1*ct**3*k2*st**2*(66*b1**2*k1**2*(C - 1)*(13*D1*fd*r*(s - 1) + Dd*f*(4*r*(13*s - 8) - 3*s + 3)) + 33*b1*f*(2*D1*bd1*k1**2*(C - 1)*(r*(26*s - 6) - 3*s + 3) + D1*fd*(k1**2*(C*(-84*r*s + 40*r - 10*s + 6) + 88*r*s - 45*r + 10*s - 6) + 2*k2**2*r**2) + Dd*f*(k1**2*(-2*C*(84*r*s - 40*r - 15*s + 7) + 176*r*s - 90*r - 31*s + 16) + k2**2*r*(4*r - 1))) - f**2*(33*D1*bd1*(k1**2*(2*C*(21*r*s - 7*r - 20*s + 10) - 44*r*s + 16*r + 41*s - 22) - k2**2*r*(r - 1)) + D1*fd*(k1**2*(4*C*(9*r*(96*s - 43) - 156*s + 85) - 99*r*(36*s - 17) + 627*s - 374) + k2**2*(135*r**2 - 57*r + 4)) + Dd*f*(k1**2*(4*C*(1152*r*s - 524*r - 116*s + 45) - 4752*r*s + 2266*r + 451*s - 198) + k2**2*(180*r**2 - 61*r + 4))))/(693*d**2*k1**2*k3**2) + 4*D1**3*Pk3*Pkd1*ct**3*k2*st**2*(39*D1*bd1*f*(22*b1*k1**2*k2**2*(C - 1)*(26*r**2 + r*(26*s - 19) - 3*s + 3) + 75*f**2*k2**4*r*(r - 1) + 11*f*k1**2*(k1**2*(2*C*(r*(95*s - 37) - 67*s + 37) + r*(52 - 132*s) + 93*s - 52) + k2**2*(-2*C*(70*r**2 + r*(63*s - 85) - 26*s + 13) + 143*r**2 + 2*r*(70*s - 89) - 59*s + 31))) + 858*b1**2*k1**2*k2**2*(C - 1)*(13*D1*fd*r*(r + s - 1) + Dd*f*(52*r**2 + r*(52*s - 45) - 3*s + 3)) + 39*b1*f*(D1*fd*(225*f*k2**4*r**2 + 11*k1**4*r*(4*C*(95*s - 51) - 264*s + 143) - 11*k1**2*k2**2*(2*C*(140*r**2 + 126*r*s - 51*r + 5*s - 5) - 286*r**2 - 280*r*s + 119*r - 10*s + 10)) + Dd*f*(75*f*k2**4*r*(4*r - 1) + 11*k1**4*(2*C*(4*r*(95*s - 51) - 67*s + 37) - 528*r*s + 286*r + 93*s - 52) - 11*k1**2*k2**2*(2*C*(280*r**2 + 6*r*(42*s - 31) - 21*s + 8) - 572*r**2 - 560*r*s + 409*r + 49*s - 21))) + f**2*(D1*fd*(15*f*k2**4*(1100*r**2 - 459*r + 46) + 13*k1**4*(2*C*(5859*r*s - 2811*r - 1029*s + 629) - 8154*r*s + 3939*r + 1431*s - 884) - 13*k1**2*k2**2*(6*C*(1251*r**2 + 882*r*s - 622*r - 74*s - 5) - 7479*r**2 - 5724*r*s + 4155*r + 357*s - 37)) + Dd*f*(15*f*k2**4*(1100*r**2 - 459*r + 46) + 13*k1**4*(2*C*(7812*r*s - 3772*r - 733*s + 333) - 10872*r*s + 5278*r + 1015*s - 468) - 13*k1**2*k2**2*(2*C*(5004*r**2 + 3528*r*s - 2255*r - 94*s - 143) - 9972*r**2 - 7632*r*s + 5103*r + 37*s + 283))))/(9009*d**2*k1**2*k3**4) - 4*D1**3*Pk3*Pkd1*ct**3*(D1*bd1*f**2*(k1**2*(4*C - 2)*(r*(2*s - 5) + s) + k2**2*r*(5*r + 6)) + 2*b1**2*(5*D1*fd*r*(k1**2*(2*C - 1)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(4*C - 2)*(r*(10*s - 11) - 3*s + 3) + 5*k2**2*r*(4*r - 1))) + b1*f*(2*D1*bd1*(k1**2*(4*C - 2)*(r*(5*s - 6) - 3*s + 3) + 5*k2**2*r*(2*r - 1)) + D1*fd*(2*r - 1)*(k1**2*(8*C - 4)*(s - 2) + k2**2*(5*r + 6)) + Dd*f*(k1**2*(4*C - 2)*(8*r*(s - 2) + 3) + k2**2*(20*r**2 + 19*r - 6))))/(21*d**2*k1**2*k2) + 4*D1**3*Pk3*Pkd1*ct**3*(-33*b1**2*(2*D1*fd*r*(-k1**4*(10*C - 5)*(s - 1) + 3*k1**2*k2**2*(C*(4*r + s - 1) - 3*r - s + 1) + k2**4*r*(5*f + 5)) + Dd*f*(-k1**4*(8*C - 4)*(r*(10*s - 11) - 3*s + 3) + 2*k1**2*k2**2*(2*C*(24*r**2 + r*(6*s - 7) + s - 1) - 36*r**2 + r*(11 - 12*s) - 2*s + 2) + k2**4*r*(5*f + 10)*(4*r - 1))) + 3*b1*f*(11*D1*bd1*(k1**4*(8*C - 4)*(r*(5*s - 6) - 3*s + 3) - 2*k1**2*k2**2*(2*C*(12*r**2 + r*(3*s - 4) + s - 1) - 18*r**2 + r*(5 - 6*s) - 2*s + 2) + k2**4*r*(-5*f - 10)*(2*r - 1)) + D1*fd*(-k1**4*(88*C - 44)*(s - 2) - 22*k1**2*k2**2*(C*(10*r**2 + r*(51 - 10*s) + 12*s - 26) - 5*r**2 - r*(s + 34) - 12*s + 21) + k2**4*(3*f*(45*r**2 - 129*r + 38) + 154*r**2 - 77*r + 66)) + Dd*f*(k1**4*(88*C - 44)*(2*s - 1) - 11*k1**2*k2**2*(10*C*(4*r**2 - 4*r*s + 17*r + 4*s - 6) - 20*r**2 - 4*r*s - 113*r - 36*s + 48) + k2**4*(4*r - 1)*(3*f*(15*r - 38) + 77*r - 66))) + f**2*(3*D1*bd1*(k1**4*(220*C - 110)*(s - 1) - 11*k1**2*k2**2*(8*C*s + r**2*(10*C - 5) - r*(10*C*s - 22*C + s + 18) - 4*s - 2) + k2**4*r*(3*f*(15*r - 38) + 77*r - 198)) + D1*fd*(-k1**4*(20*C - 10)*(3*r - 1)*(3*s - 23) + k1**2*k2**2*(-2*C*(2205*r**2 + 990*r*s - 2691*r - 396*s + 674) + 3105*r**2 + 3375*r*s - 4548*r - 1290*s + 1226) + 330*k2**4*r*(3*r - 1)) + Dd*f*(-k1**4*(40*C - 20)*(r*(6*s - 41) + s + 9) + k1**2*k2**2*(-2*C*(2940*r**2 + 1320*r*s - 3563*r - 528*s + 806) + 4140*r**2 + 4500*r*s - 6369*r - 1670*s + 1606) + 330*k2**4*r*(4*r - 1))))/(693*d**2*k1**2*k2*k3**2) + 8*D1**3*Pk3*Pkd1*ct**2*f*k2**4*st**4*(D1*(1716*b1*fd*k1**2*r*(5*C - 4)*(2*r + 2*s - 1) + 5*f**2*k2**2*(78*bd1*(6*r**2 + r*(6*s - 8) - 3*s + 2) + fd*(1036*r**2 + r*(1036*s - 867) - 129*s + 87)) + 52*f*(33*bd1*k1**2*r*(5*C - 4)*(r + s - 1) + fd*(45*b1*k2**2*r + k1**2*(26*C - 21)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(1716*b1*k1**2*r*(5*C - 4)*(4*r + 4*s - 3) + 5*f**2*k2**2*(1036*r**2 + r*(1036*s - 867) - 129*s + 87) + 26*f*(15*b1*k2**2*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**2*(26*C - 21)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k1*k3**6) + 8*D1**3*Pk3*Pkd1*ct**2*f*k2**2*st**4*(2*D1*(33*b1*fd*r*(2*s - 1) + 33*bd1*f*r*s + 5*f*fd*(3*r - 1)*(3*s - 1)) + Dd*f*(132*b1*r*(2*s - 1) + 5*f*(24*r*s - 10*r - 7*s + 3)))/(231*d**2*k1*k3**2) + 8*D1**3*Pk3*Pkd1*ct**2*f*k2**2*st**4*(2*D1*(-33*b1*fd*r*(-k1**2*(5*C - 4)*(2*s - 1) + k2**2*(r*(4*C - 6) - 2*s + 1)) + f*(33*bd1*r*(k1**2*s*(5*C - 4) + k2**2*(-2*C*(r - 1) + 3*r + s - 3)) + fd*(3*r - 1)*(k1**2*(24*C - 19)*(3*s - 1) + k2**2*(C*(22 - 33*r) + 48*r + 15*s - 32)))) + Dd*f*(66*b1*r*(k1**2*(10*C - 8)*(2*s - 1) + k2**2*(C*(2 - 8*r) + 12*r + 4*s - 5)) + f*(k1**2*(24*C - 19)*(2*r*(12*s - 5) - 7*s + 3) + k2**2*(-22*C*(12*r**2 - 11*r + 2) + 384*r**2 + 120*r*s - 362*r - 35*s + 69))))/(231*d**2*k1*k3**4) + 8*D1**3*Pk3*Pkd1*ct**2*k1*(13*D1*bd1*f*(5*f**2*k2**2*(k1**2*(147*r**2 + 147*r*s - 127*r - 10*s + 20) + 33*k2**2*(11*r + 9*s - 7)) - 66*f*(k1**4*(2*C - 1)*(4*r**2 + r*(4*s - 5) - 2*s + 1) - k1**2*k2**2*(-12*C*(r - 1)*(5*r + 5*s - 4) - 2*K*(17*r**2 + r*(17*s - 20) - 5*s + 5) + 26*b1*r**2 + b1*r*(26*s - 23) - 5*b1*s + b1 + 52*r**2 + 52*r*s - 82*r - 40*s + 34) - 3*k2**4*(b1*(2*r - 1)*(9*r + 9*s - 5) + r*(4 - 6*K)*(r + s))) - 66*k2**2*(b1*k1**2*(r**2*(26*K - 16) + r*(K*(26*s - 23) - 16*s + 12) + s*(4 - 3*K)) + 7*b1*k2**2*(3*K - 2)*(r + s)*(2*r - 1) + 2*g2*k1**2*(-13*r**2 - 13*r*(s - 1) + 3*s) - 42*g2*k2**2*(r - 1)*(r + s))) + 858*b1**2*k2**2*(D1*fd*r*(2*f*(k1**2*(13*r + 13*s - 5) + 3*k2**2*(9*r + 9*s - 5)) - (r + s)*(k1**2*(13*K - 8) + k2**2*(21*K - 14))) + Dd*f*(f*(k1**2*(52*r**2 + 52*r*s - 33*r - 5*s + 1) + 3*k2**2*(4*r - 1)*(9*r + 9*s - 5)) + k1**2*(r**2*(32 - 52*K) + r*(-52*K*s + 33*K + 32*s - 16) + s*(3*K - 4)) + k2**2*(14 - 21*K)*(r + s)*(4*r - 1))) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(441*r**2 + 9*r*(49*s - 52) - 207*s + 127) - 33*k2**2*(3*r + 9*s - 5)) - 132*f*(fd*(k1**4*r*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(K*(2*r - 1)*(17*r + 17*s - 10) + r**2*(60*C - 52) + r*(60*C*s - 48*C - 52*s + 46) + 8*s - 4) + k2**4*(9*K - 6)*(r + s)*(2*r - 1)) - gd2*k2**2*r*(k1**2*(13*r + 13*s - 10) + 21*k2**2*(r + s))) + 132*fd*g2*k2**2*r*(13*k1**2 + 21*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(7*k1**2*(84*r**2 + r*(84*s - 85) - 31*s + 21) + 66*k2**2*(4*r - 1)) - 66*f*(k1**4*(2*C - 1)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 2*k1**2*k2**2*(6*C*(4*r - 1)*(5*r + 5*s - 4) + K*(68*r**2 + 68*r*s - 77*r - 27*s + 20) - 104*r**2 - 104*r*s + 110*r + 30*s - 23) + k2**4*(18*K - 12)*(r + s)*(4*r - 1)) + 132*g2*k2**2*(k1**2*(52*r**2 + r*(52*s - 33) - 3*s) + 21*k2**2*(r + s)*(4*r - 1)))) - 2*f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(7*k1**2*(4*r + 4*s - 3) + 13*k2**2*(9*r + 9*s - 7)) + 13*f*(5*fd*k1**2*(3*r - 1)*(k1**2*(20*C - 10)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 132*gd2*k2**2*(k1**2*(17*r**2 + r*(17*s - 20) - 5*s + 5) + 9*k2**2*r*(r + s))) - 1716*fd*g2*k2**2*(2*r - 1)*(k1**2*(17*r + 17*s - 10) + 9*k2**2*(r + s))) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(7*k1**2*(4*r + 4*s - 3) + 13*k2**2*(9*r + 9*s - 7)) + 65*f*k1**2*(k1**2*(10*C - 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 1716*g2*k2**2*(k1**2*(68*r**2 + r*(68*s - 77) - 27*s + 20) + 9*k2**2*(r + s)*(4*r - 1)))))/(9009*d**2*k3**6) - 4*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(-39*D1*bd1*f*(f**2*k2**2*(k1**2*(144*r**2 + 3*r*(48*s - 349) - 839*s + 635) - 66*k2**2*(r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**2*(4*C*(41*r**2 + r*(41*s - 56) - 25*s + 15) - 103*r**2 + r*(141 - 103*s) + 62*s - 38) + k2**2*(-4*C*(r - 1)*(15*r + 15*s - 8) + 42*K*r**2 + 42*K*r*s - 24*K*r - 3*b1*(76*r**2 + r*(76*s - 77) - 25*s + 13) + 20*r**2 + 20*r*s - 58*r - 48*s + 26)) + 22*k1**2*k2**2*(b1*(3*K - 2)*(26*r**2 + r*(26*s - 23) - 3*s) + 6*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k1**2*k2**2*(D1*fd*r*(3*f*(76*r + 76*s - 39) + (52 - 78*K)*(r + s)) + Dd*f*(f*(456*r**2 + 456*r*s - 348*r - 75*s + 39) + (4 - 6*K)*(52*r**2 + 52*r*s - 33*r - 3*s))) - 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(432*r**2 + 432*r*s - 297*r + 255*s - 115) - 198*k2**2*r*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*k1**2*r*(8*C*(41*r + 41*s - 23) - 206*r - 206*s + 117) + fd*k2**2*(3*K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(20 - 60*C) - 4*r*(15*C*s - 8*C - 5*s + 1) + 10*s - 4) - 6*gd2*k2**2*r*(13*r + 13*s - 10)) - 1716*fd*g2*k1**2*k2**2*r*(r + s)) + 2*Dd*f*(f**2*k2**2*(4*k1**2*(72*r**2 + 24*r*(3*s - 7) - 73*s + 65) - 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(k1**2*(4*C*(164*r**2 + r*(164*s - 133) - 25*s + 15) - 412*r**2 + r*(337 - 412*s) + 62*s - 38) + k2**2*(-2*C*(4*r - 1)*(15*r + 15*s - 8) + 3*K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 40*r**2 + 40*r*s - 38*r - 14*s + 9)) - 66*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(15*f**2*fd*k2**2*(-3*k1**2*(1624*r**2 + 8*r*(203*s - 138) + 49*s - 53) + 130*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(fd*k1**2*(8*C*(315*r - 17)*(3*r + 3*s - 2) - 4617*r**2 - 4617*r*s + 3330*r + 186*s - 146) - 33*fd*k2**2*(3*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13) - 198*gd2*k2**2*r*(7*r + 7*s - 4)) + 5148*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(15*f**2*k2**2*(-3*k1**2*(1624*r**2 + 8*r*(203*s - 138) + 49*s - 53) + 130*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(k1**2*(8*C*(1260*r**2 + 1260*r*s - 831*r + 23*s - 40) - 6156*r**2 - 6156*r*s + 4077*r - 190*s + 230) - 33*k2**2*(4*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 5148*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k1*k3**6) + 4*D1**3*Pk3*Pkd1*ct**2*st**2*(D1*bd1*f**2*r*(7*s - 3) + b1**2*(13*D1*fd*r*(s - 1) + Dd*f*(4*r*(13*s - 8) - 3*s + 3)) + b1*f*(D1*bd1*(r*(26*s - 6) - 3*s + 3) + D1*fd*(2*r*(7*s - 4) - 5*s + 3) + Dd*f*(4*r*(7*s - 4) - 5*s + 3)))/(21*d**2*k1) + 4*D1**3*Pk3*Pkd1*ct**2*(D1*bd1*f**2*(r**2*(5 - 10*C) + r*(16*C + 7*s - 9) - 3*s) + b1**2*(D1*fd*r*(r*(2*C - 1) - 5*s + 5) + Dd*f*(r**2*(8*C - 4) + r*(-2*C - 20*s + 9) - s + 1)) - b1*f*(D1*bd1*(r**2*(2 - 4*C) + r*(2*C + 10*s + 1) + s - 1) + 2*D1*fd*(C*(10*r**2 - 21*r + 8) - 5*r**2 - 7*r*(s - 2) + 4*s - 6) + Dd*f*(2*C*(20*r**2 - 37*r + 8) - 20*r**2 + r*(51 - 28*s) + 14*s - 15)))/(21*d**2*k1) + 2*D1**3*Pk3*Pkd1*ct**2*st**2*(22*b1**2*(D1*fd*r*(k1**2*(52*C - 39)*(s - 1) + k2**2*r*(21 - 21*C)) + Dd*f*(k1**2*(4*C - 3)*(4*r*(13*s - 8) - 3*s + 3) + k2**2*r*(21 - 21*C)*(4*r - 1))) + 11*b1*f*(2*D1*bd1*(k1**2*(4*C - 3)*(r*(26*s - 6) - 3*s + 3) + k2**2*r*(21 - 21*C)*(2*r - 1)) + 2*D1*fd*(k1**2*(C*(-64*r*s + 34*r - 20*s + 12) + 32*r*s - 17*r + 15*s - 9) + k2**2*(C*(-38*r**2 + 33*r - 10) + 8*r**2 - 72*r*s + 3*r + 10)) + Dd*f*(-k1**2*(4*C - 2)*(r*(64*s - 34) - 11*s + 6) + k2**2*(-2*C*(76*r**2 - 59*r + 10) + 32*r**2 - 288*r*s + 56*r + 6*s + 17))) + f**2*(-11*D1*bd1*(2*k1**2*(2*C*(16*r*s - 6*r - 21*s + 12) - 16*r*s + 6*r + 26*s - 15) + k2**2*(r**2*(38*C - 8) + r*(-32*C + 72*s - 1) - 6*s + 3)) + D1*fd*(-2*k1**2*(2*C*(612*r*s - 303*r - 105*s + 68) - 765*r*s + 376*r + 134*s - 85) + k2**2*(-4*C*(135*r**2 - 123*r + 26) + 144*r**2 - 504*r*s + 39*r - 30*s + 37)) + Dd*f*(-2*k1**2*(2*C*(816*r*s - 406*r - 73*s + 36) - 1020*r*s + 502*r + 94*s - 45) + k2**2*(-4*C*(180*r**2 - 149*r + 26) + 192*r**2 - 672*r*s + 168*r - 46*s + 53))))/(231*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**2*(66*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + 33*b1**2*(D1*(2*bd1*f*k2**2*r*(3*r - 1) + 2*fd*k1**2*r*(C*(6*r - 20*s + 20) - 3*r + 15*s - 15) + fd*k2**2*(56*C*r**2 + K*(6*r**2 - 8*r + 4) + f*(40*r**2 + 9*r*(20*s - 9) - 16) - 72*r**2 + 18*r*s + 8*r - 4)) + 2*Dd*f*(k1**2*(C*(24*r**2 + r*(26 - 80*s) - 4*s + 4) - 12*r**2 + 3*r*(20*s - 7) + 3*s - 3) + k2**2*(112*C*r**2 - 28*C*r + K*(12*r**2 - 11*r + 2) + 4*f*(10*r**2 + r*(45*s - 23) - 9*s + 4) - 144*r**2 + 36*r*s + 56*r - 15*s - 2))) + 3*b1*(11*D1*bd1*f*(2*k1**2*(2*C*(6*r**2 - 20*r*s - 7*r - 2*s + 2) - 6*r**2 + 30*r*s + 9*r + 3*s - 3) + k2**2*(f*(40*r**2 + r*(180*s - 103) - 72*s + 48) + 2*r**2*(56*C + 6*K - 72) + 2*r*(-28*C - 5*K + 18*s + 44) - 30*s)) + D1*(f**2*fd*k2**2*(1890*r**2 + 3*r*(990*s - 1223) - 1056*s + 1046) + 22*f*(fd*(2*k1**2*(2*C*(r*(5*s - 21) - 8*s + 10) + r*(21 - 5*s) + 12*s - 12) + k2**2*(K*(-10*r**2 + 21*r - 8) + r**2*(48*C + 10) + r*(-24*C + 38*s - 15) - 20*s + 14)) + k2**2*r*(bd2*r + gd2*(4 - 6*r))) + 22*fd*k2**2*(b2*r**2 + g2*(-6*r**2 + 8*r - 4))) + 2*Dd*f*(f**2*k2**2*(1260*r**2 + r*(1980*s - 2341) - 594*s + 556) + 11*f*(2*k1**2*(C*(r*(20*s - 58) - 28*s + 26) - 10*r*s + 29*r + 20*s - 16) + k2**2*(K*(-20*r**2 + 37*r - 8) + r**2*(96*C + 20) + r*(-24*C + 76*s - 71) - 26*s + 20)) + 11*k2**2*(4*r - 1)*(b2*r + g2*(4 - 6*r)))) + f*(3*D1*bd1*(f**2*k2**2*(630*r**2 + r*(990*s - 1013) - 132*s + 66) + 22*f*(k1**2*(-12*C*s + r*(2*C - 1)*(5*s - 1) + 7*s + 1) + k2**2*(r**2*(24*C - 5*K + 5) + r*(8*K + 19*s - 37) - 3*s + 3)) + k2**2*r*(22*b2 - 132*g2)*(r - 1)) - 2*D1*(f*(fd*k1**2*(2*C*(1845*r**2 + 3*r*(495*s - 674) - 594*s + 502) - 1845*r**2 - 3*r*(810*s - 779) + 942*s - 618) + 495*fd*k2**2*r*(1 - 3*r) + k2**2*r*(33*bd2 - 66*gd2)*(5*r - 8)) + 33*fd*k2**2*(b2 - 2*g2)*(10*r**2 - 21*r + 8)) - 2*Dd*f*(f*k1**2*(2*C*(2460*r**2 + r*(1980*s - 2821) - 792*s + 700) - 2460*r**2 + r*(3401 - 3240*s) + 1231*s - 907) + 495*f*k2**2*r*(1 - 4*r) + k2**2*(33*b2 - 66*g2)*(20*r**2 - 37*r + 8))))/(693*d**2*k1*k3**2) + 2*D1**3*Pk3*Pkd1*ct**2*st**2*(13*D1*bd1*f*(f**2*k2**4*(588*r**2 + r*(408*s - 657) - 266*s + 166) + 11*f*(2*k1**4*(C*(4*r*(22*s - 9) - 62*s + 36) + r*(21 - 51*s) + 36*s - 21) + k1**2*k2**2*(-2*C*(183*r**2 + r*(250*s - 237) - 78*s + 44) + 268*r**2 + r*(396*s - 353) - 118*s + 69) + k2**4*(3*b1*(36*r**2 + r*(40*s - 41) - 14*s + 10) + r**2*(24*C - 13*K - 9) + 2*r*(-12*C + 5*K + s + 12) + 12*s - 6)) + 11*k2**2*(2*b1*k1**2*(14*C*(8*r**2 + r*(8*s - 6) - s + 1) - 86*r**2 + r*(65 - 86*s) + 11*s - 11) + b1*k2**2*(r**2*(94 - 42*K) + r*(21*K + 52*s - 67) - 6*s) + 42*g2*k2**2*r*(r - 1))) + 143*b1**2*k2**2*(D1*fd*r*(k1**2*(112*C - 86)*(r + s - 1) + k2**2*(-21*K*r + 3*f*(36*r + 40*s - 29) + 47*r + 26*s)) + Dd*f*(k1**2*(28*C*(16*r**2 + 2*r*(8*s - 7) - s + 1) - 344*r**2 + r*(302 - 344*s) + 22*s - 22) + k2**2*(6*f*(36*r**2 + 5*r*(8*s - 7) - 7*s + 5) + r**2*(188 - 84*K) + r*(21*K + 104*s - 87) - 6*s))) + 13*b1*(D1*(3*f**2*fd*k2**4*(588*r**2 + 3*r*(136*s - 91) - 70*s + 30) + 11*f*(fd*(2*k1**4*r*(2*C*(88*s - 49) - 102*s + 57) + 2*k1**2*k2**2*(C*(-366*r**2 - 500*r*s + 206*r - 22*s + 22) + 268*r**2 + 2*r*(198*s - 83) + 17*s - 17) + k2**4*(K*(-26*r**2 + 33*r - 10) + r**2*(48*C - 18) + r*(4*s - 43) - 10*s + 14)) + 42*gd2*k2**4*r**2) + 462*fd*g2*k2**4*r**2) + Dd*f*(4*f**2*k2**4*(588*r**2 + r*(408*s - 369) - 119*s + 64) + 11*f*(2*k1**4*(4*C*r*(88*s - 49) - 62*C*s + 36*C + 3*r*(38 - 68*s) + 36*s - 21) + k1**2*k2**2*(-2*C*(732*r**2 + r*(1000*s - 659) - 56*s + 22) + 1072*r**2 + 24*r*(66*s - 43) - 84*s + 35) + k2**4*(K*(-52*r**2 + 53*r - 10) + r**2*(96*C - 36) + r*(-24*C + 8*s - 31) + 2*s + 8)) + 462*g2*k2**4*r*(4*r - 1))) + f*(D1*(2*f**2*fd*k2**4*(13020*r**2 + r*(5200*s - 9409) - 3705*s + 2741) + 13*f*(fd*(2*k1**4*(2*C*(918*r*s - 449*r - 163*s + 102) - 1071*r*s + 522*r + 192*s - 119) + k1**2*k2**2*(C*(-4590*r**2 - 5724*r*s + 2790*r + 60*s + 196) + 3384*r**2 + 4302*r*s - 2315*r + 62*s - 103) + 66*k2**4*(3*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 22*gd2*k2**4*r*(13*r - 10)) + 286*fd*g2*k2**4*(26*r**2 - 33*r + 10)) + Dd*f*(2*f**2*k2**4*(13020*r**2 + r*(5200*s - 9409) - 3705*s + 2741) + 13*f*(2*k1**4*(2*C*(1224*r*s - 598*r - 115*s + 54) - 1428*r*s + 694*r + 136*s - 63) + k1**2*k2**2*(C*(-6120*r**2 - 7632*r*s + 3802*r - 260*s + 516) + 4512*r**2 + 5736*r*s - 3196*r + 318*s - 359) + 66*k2**4*(4*r - 1)*(r*(4*C - 6) - 2*s + 1)) + 286*g2*k2**4*(52*r**2 - 53*r + 10))))/(3003*d**2*k1*k3**4) + 2*D1**3*Pk3*Pkd1*ct**2*(858*b1**3*k1**2*k2**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s + 3*r + 3*s - 3)) - 429*b1**2*(D1*(-2*bd1*f*k1**2*k2**2*(3*r**2 + 3*r*s + 4*r + 3*s - 3) + fd*(k1**4*r*(16*C - 8)*(r + s - 1) + k1**2*k2**2*(2*K*(r**2 - 19*r*s - 24*r - 12*s + 12) + f*(220*r**2 + r*(334*s - 143) + 20*s - 20) + 2*r**2*(56*C - 30) + 4*r*(28*C*(s - 1) - 7*s + 29) + 16*s - 16) + 4*k2**4*r*(12*f*(3*r + 3*s - 2) + r*(14 - 7*K) + 7*s))) + 2*Dd*f*(k1**4*(4*C - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(56*C*(4*r - 1)*(r + s - 1) + 4*K*r**2 - 76*K*r*s - 79*K*r + 10*K*s + 24*K + f*(220*r**2 + 334*r*s - 210*r - 46*s + 20) - 120*r**2 - 56*r*s + 244*r + 23*s - 58) + 2*k2**4*(4*r - 1)*(6*f*(3*r + 3*s - 2) + r*(14 - 7*K) + 7*s))) - 13*b1*(33*D1*bd1*f*(k1**4*(8*C - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(112*C*(2*r - 1)*(r + s - 1) + 4*K*(r**2 - r*(19*s + 14) + 14*s + 3) + f*(220*r**2 + r*(334*s - 277) - 112*s + 60) - 120*r**2 - 56*r*s + 258*r + 22*s - 92) + 4*k2**4*(2*r - 1)*(6*f*(3*r + 3*s - 2) + r*(14 - 7*K) + 7*s)) + 3*D1*(f**2*fd*k2**2*(k1**2*(4530*r**2 + 9*r*(230*s - 451) - 2274*s + 1846) + 220*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 22*f*(fd*(2*k1**4*(C*(42*r**2 + 46*r*s - 7*r + 8*s - 8) - 21*r**2 + r*(7 - 30*s) - 4*s + 4) + k1**2*k2**2*(48*C*(5*r**2 + r*s + r + s - 1) + 3*K*(66*r**2 + 54*r*s - 85*r - 28*s + 26) - 322*r**2 - 172*r*s + 123*r + 40*s - 8) + 12*k2**4*(2*r - 1)*(r*(K - 2) - s)) - 2*k2**2*(bd2*k1**2*r*(r + s + 3) + gd2*k1**2*(-r**2 + 19*r*s + 27*r + 6*s - 6) + 14*gd2*k2**2*r**2)) + 44*fd*k2**2*(b2*k1**2*r*(r + s) + g2*k1**2*(-r**2 + r*(19*s + 24) + 12*s - 12) + 14*g2*k2**2*r**2)) + 2*Dd*f*(f**2*k2**2*(k1**2*(9060*r**2 + r*(4140*s - 7733) - 2423*s + 2061) + 330*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 33*f*(k1**4*(2*C*(84*r**2 + r*(92*s - 51) + 4*s - 6) - 84*r**2 + r*(65 - 120*s) - 2*s + 5) + k1**2*k2**2*(-24*C*s + 3*K*(132*r**2 + 3*r*(36*s - 53) - 40*s + 38) + r**2*(480*C - 644) + r*(24*C*(4*s - 5) - 344*s + 393) + 118*s - 74) + 12*k2**4*(4*r - 1)*(r*(K - 2) - s)) + 66*k2**2*(b2*k1**2*(4*r**2 + r*(4*s + 5) - 4*s) + g2*(k1**2*(-4*r**2 + 76*r*s + 79*r - 10*s - 24) + 14*k2**2*r*(4*r - 1))))) + f*(-13*D1*bd1*(f**2*k2**2*(k1**2*(4530*r**2 + 23*r*(90*s - 143) + 1976*s - 1416) + 660*k2**2*r*(3*r + 3*s - 2)) - 66*f*(k1**4*(2*C*(21*r**2 + r*(23*s - 27) - 6*s + 4) - 21*r**2 + r*(28 - 30*s) + 8*s - 5) + k1**2*k2**2*(24*C*(5*r**2 + r*(s - 7) - 3*s + 2) + 3*K*(33*r**2 + 27*r*s - 37*r - 6*s + 6) - 161*r**2 - 86*r*s + 198*r + 63*s - 51) + 12*k2**4*r*(r*(K - 2) - s)) + 132*k2**2*(b2*k1**2*(r**2 + r*(s - 1) - 4*s) + g2*(k1**2*(-r**2 + 19*r*s + r - 34*s) + 14*k2**2*r*(r - 1)))) + 2*D1*(10*f**2*fd*k1**2*k2**2*(3570*r**2 + r*(10647*s - 9260) - 2808*s + 2165) + 13*f*(fd*k1**2*(k1**2*(C*(7290*r**2 + 8550*r*s - 8304*r - 3180*s + 2068) - 3645*r**2 - 5220*r*s + 4467*r + 1938*s - 1150) + 165*k2**2*(3*r - 1)*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) - 198*k2**2*(-bd2*k1**2*(2*r**2 + 2*r*(s - 2) - s + 1) + gd2*(k1**2*(33*r**2 + 27*r*s - 37*r - 6*s + 6) + 4*k2**2*r**2))) + 2574*fd*k2**2*(2*b2*k1**2*(2*r - 1)*(r + s - 1) + g2*k1**2*(-66*r**2 + r*(85 - 54*s) + 28*s - 26) + 4*g2*k2**2*r*(1 - 2*r))) + 2*Dd*f*(10*f**2*k1**2*k2**2*(3570*r**2 + r*(10647*s - 9260) - 2808*s + 2165) + 13*f*k1**2*(k1**2*(2*C*(4860*r**2 + 5700*r*s - 5881*r - 2020*s + 1464) - 4860*r**2 - 6960*r*s + 6461*r + 2459*s - 1671) + 165*k2**2*(4*r - 1)*(4*C*(7*r + 3*s - 2) - 21*r - 8*s + 6)) + 2574*k2**2*(2*b2*k1**2*(4*r**2 + r*(4*s - 7) - 2*s + 2) + g2*(k1**2*(-132*r**2 - 108*r*s + 159*r + 40*s - 38) + 4*k2**2*r*(1 - 4*r))))))/(9009*d**2*k1*k3**4) + 16*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(D1*(-429*b1*fd*r*(2*b1*k2**2 + k1**2*(5 - 8*C))*(2*r + 2*s - 1) + f**2*k2**2*(65*bd1*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + 2*fd*(1588*r**2 + r*(1588*s - 1315) - 176*s + 119)) + 13*f*(33*bd1*r*(-4*b1*k2**2 + k1**2*(8*C - 5))*(r + s - 1) + 2*fd*(5*b1*k2**2*(9*r + 1) + k1**2*(22*C - 14)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(-429*b1*r*(2*b1*k2**2 + k1**2*(5 - 8*C))*(4*r + 4*s - 3) + 2*f**2*k2**2*(1588*r**2 + r*(1588*s - 1315) - 176*s + 119) + 13*f*(5*b1*k2**2*(72*r**2 + 8*r*(9*s - 7) - 5*s + 3) + k1**2*(22*C - 14)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k3**6) - 8*D1**3*Pk3*Pkd1*ct*f*k2*st**4*(D1*(33*b1*fd*r*(k1**2*(4*C - 3)*(2*s - 1) + 2*k2**2*r) + f*(33*bd1*r*(k1**2*s*(4*C - 3) + k2**2*(r - 1)) + fd*(3*r - 1)*(k1**2*(20*C - 14)*(3*s - 1) + k2**2*(18*r - 17)))) + Dd*f*(33*b1*r*(k1**2*(8*C - 6)*(2*s - 1) + k2**2*(4*r - 1)) + f*(k1**2*(10*C - 7)*(24*r*s - 10*r - 7*s + 3) + k2**2*(72*r**2 - 86*r + 17))))/(231*d**2*k1**2*k3**2) + 2*D1**3*Pk3*Pkd1*ct*f*k2*st**4*(D1*(1716*b1*fd*k1**2*r*(k1**2*(8*C - 5)*(2*s - 1) + k2**2*(-4*C*(5*r + 2*s - 1) + 16*r + 6*s - 3)) + 15*f**2*k2**4*(-13*bd1*r*(r - 1) + fd*(76*r**2 + 53*r - 18)) + 13*f*(132*bd1*k1**2*r*(k1**2*s*(8*C - 5) + k2**2*(-2*C*(5*r + 2*s - 5) + 8*r + 3*s - 8)) + fd*(-45*b1*k2**4*r**2 + k1**4*(144*C - 88)*(3*r - 1)*(3*s - 1) - 4*k1**2*k2**2*(3*r - 1)*(4*C*(45*r + 18*s - 32) - 144*r - 60*s + 101)))) + Dd*f*(3432*b1*k1**2*r*(k1**2*(8*C - 5)*(2*s - 1) + k2**2*(C*(-20*r - 8*s + 9) + 16*r + 6*s - 7)) + 15*f**2*k2**4*(76*r**2 + 53*r - 18) + 13*f*(15*b1*k2**4*r*(1 - 4*r) + k1**4*(72*C - 44)*(2*r*(12*s - 5) - 7*s + 3) - 4*k1**2*k2**2*(4*C*(180*r**2 + r*(72*s - 179) - 21*s + 35) - 576*r**2 - 8*r*(30*s - 71) + 70*s - 111))))/(3003*d**2*k1**2*k3**4) + 16*D1**3*Pk3*Pkd1*ct*k1**2*k2*(D1*bd1*f*(-33*b1*k1**2*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s) - 231*b1*k2**2*(3*K - 1)*(r + s)*(2*r - 1) + 5*f**2*(5*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 33*k2**2*(2*r**2 + 2*r*s + s - 1)) + 33*f*(k1**2*(-12*C*(r - 1)*(r + s - 1) - 20*K*r**2 - 20*K*r*s + 20*K*r + 5*K*s - 5*K + b1*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 10*r**2 + 10*r*s - 16*r - 7*s + 7) + 6*k2**2*(b1*(2*r - 1)*(3*r + 3*s - 2) - r*(3*K - 1)*(r + s))) + 330*g2*k1**2*(2*r**2 + 2*r*(s - 1) - s) + 1386*g2*k2**2*(r - 1)*(r + s)) + 33*b1**2*(D1*fd*r*(4*f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(3*r + 3*s - 2)) - (r + s)*(k1**2*(10*K - 2) + k2**2*(21*K - 7))) + Dd*f*(f*(k1**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 6*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - k1**2*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s) + k2**2*(7 - 21*K)*(r + s)*(4*r - 1))) + b1*(D1*(5*f**2*fd*(10*k1**2*(3*r - 1)*(3*r + 3*s - 2) + 33*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2)) - 66*f*(fd*k1**2*(5*K*(2*r - 1)*(2*r + 2*s - 1) + r**2*(12*C - 10) + r*(12*C - 10)*(s - 1) + 2*s - 1) + 3*fd*k2**2*(3*K - 1)*(r + s)*(2*r - 1) - 5*gd2*k1**2*r*(2*r + 2*s - 1) - 21*gd2*k2**2*r*(r + s)) + 66*fd*g2*r*(10*k1**2 + 21*k2**2)*(r + s)) + Dd*f*(5*f**2*(5*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 66*f*(k1**2*(6*C*(4*r - 1)*(r + s - 1) + 5*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 20*r**2 - 20*r*s + 23*r + 6*s - 5) + k2**2*(9*K - 3)*(r + s)*(4*r - 1)) + 66*g2*(5*k1**2*(8*r**2 + r*(8*s - 4) - s) + 21*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-140*f**2*fd*k2**2*(4*r - 1)*(r + s - 1) - 33*f*(fd*k1**2*(10*C - 5)*(3*r - 1)*(r + s - 1) - 2*gd2*(5*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*k2**2*r*(r + s))) + 132*fd*g2*(2*r - 1)*(5*k1**2*(2*r + 2*s - 1) + 9*k2**2*(r + s))) + Dd*f*(-140*f**2*k2**2*(4*r - 1)*(r + s - 1) + f*k1**2*(165 - 330*C)*(4*r - 1)*(r + s - 1) + 132*g2*(5*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 9*k2**2*(r + s)*(4*r - 1)))))/(693*d**2*k3**6) - 8*D1**3*Pk3*Pkd1*ct*k2*st**2*(39*D1*bd1*f*(f**2*k2**2*(k1**2*(102*r**2 + 102*r*s + 87*r + 128*s - 116) + 33*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 11*f*(3*b1*k2**4*(2*r - 1)*(2*r + 2*s - 1) + k1**4*(2*C*(23*r**2 + r*(23*s - 32) - 13*s + 9) - 25*r**2 - 25*r*s + 35*r + 14*s - 10) + k1**2*k2**2*(-2*C*(r - 1)*(12*r + 12*s - 7) + 21*K*r**2 + 21*K*r*s - 12*K*r + b1*(-78*r**2 + r*(80 - 78*s) + 24*s - 13) + 8*r**2 + 8*r*s - 20*r - 15*s + 9)) - 11*k1**2*k2**2*(b1*(3*K - 1)*(26*r**2 + r*(26*s - 23) - 3*s) + 6*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k2**2*(D1*fd*r*(f*k1**2*(78*r + 78*s - 41) - 6*f*k2**2*(2*r + 2*s - 1) + k1**2*(13 - 39*K)*(r + s)) + Dd*f*(f*(k1**2*(156*r**2 + 156*r*s - 121*r - 24*s + 13) - 3*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - k1**2*(3*K - 1)*(52*r**2 + r*(52*s - 33) - 3*s))) + 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(306*r**2 + r*(306*s - 169) - 42*s + 17) + 33*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) - 11*f*k1**2*(fd*k1**2*r*(C*(92*r + 92*s - 56) - 50*r - 50*s + 31) + fd*k2**2*(3*K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(16 - 48*C) + r*(-48*C*s + 28*C + 16*s - 7) + 5*s - 2) - 6*gd2*k2**2*r*(13*r + 13*s - 10)) + 858*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(408*r**2 + r*(408*s - 82) + 86*s - 99) + 33*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 11*f*k1**2*(k1**2*(2*C*(92*r**2 + r*(92*s - 79) - 13*s + 9) - 100*r**2 - 100*r*s + 87*r + 14*s - 10) + k2**2*(-2*C*(4*r - 1)*(12*r + 12*s - 7) + 3*K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 32*r**2 + 32*r*s - 32*r - 10*s + 7)) + 66*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(-1396*r**2 + r*(811 - 1396*s) - 366*s + 242) + 390*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 13*f*k1**2*(fd*k1**2*(22*C*(81*r**2 + r*(81*s - 60) + 3*s + 1) - 945*r**2 - 21*r*(45*s - 34) - 48*s - 12) - 33*fd*k2**2*(3*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) - 198*gd2*k2**2*r*(7*r + 7*s - 4)) + 2574*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(5*f**2*k2**2*(k1**2*(-1396*r**2 + r*(811 - 1396*s) - 366*s + 242) + 390*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 13*f*k1**2*(k1**2*(22*C*(108*r**2 + 108*r*s - 75*r + 11*s - 7) - 1260*r**2 - 1260*r*s + 897*r - 144*s + 84) - 33*k2**2*(4*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**6) + 2*D1**3*Pk3*Pkd1*ct*st**2*(39*D1*bd1*f*(f**2*k2**4*(378*r**2 + r*(378*s - 565) - 316*s + 216) + 11*f*(k1**4*(4*C - 2)*(r*(7*s - 3) - 5*s + 3) - 2*k1**2*k2**2*(2*C*(43*r**2 + r*(82*s - 59) - 18*s + 12) - 50*r**2 + r*(71 - 105*s) + 23*s - 16) + k2**4*(12*C*(r - 1)*(5*r + 2*s - 1) + b1*(158*r**2 + r*(200*s - 187) - 30*s + 22) - 2*r**2*(22*K + 7) + 2*r*(-9*K*s + 15*K + 18) + 18*s - 10)) - 22*k2**2*(b1**2*k2**2*(39*r**2 + r*(39*s - 32) - 3*s + 3) + b1*(k1**2*(-2*C*(34*r**2 + 34*r*s - 27*r - 5*s + 5) + 38*r**2 + 38*r*s - 31*r - 6*s + 6) + k2**2*(r**2*(72*K - 60) + r*(30*K*s - 47*K - 30*s + 41) - s*(4*K - 4))) + k2**2*(b2*(13*r**2 + 13*r*(s - 1) - 3*s) + 2*g2*(-36*r**2 + r*(36 - 15*s) + 4*s)))) - 858*b1**3*k2**4*(13*D1*fd*r*(r + s - 1) + Dd*f*(52*r**2 + r*(52*s - 45) - 3*s + 3)) + 429*b1**2*k2**2*(2*D1*fd*(f*k2**2*(79*r**2 + 50*r*(2*s - 1) + 5*s - 5) + r*(k1**2*(34*C - 19)*(r + s - 1) + 3*k2**2*(-12*K*r - 5*K*s + 10*r + 5*s))) + Dd*f*(2*k1**2*(2*C*(68*r**2 + 68*r*s - 61*r - 5*s + 5) - 76*r**2 - 76*r*s + 69*r + 6*s - 6) + k2**2*(f*(316*r**2 + r*(400*s - 287) - 20*s + 12) + r**2*(240 - 288*K) - 4*r*(K*(30*s - 29) - 30*s + 26) + s*(8*K - 8)))) + 39*b1*(D1*(f**2*fd*k2**4*(1134*r**2 + r*(1134*s - 485) + 18*s - 88) + 22*f*(fd*(k1**4*r*(4*C - 2)*(7*s - 4) + k1**2*k2**2*(-2*C*(86*r**2 + 164*r*s - 70*r + 7*s - 7) + 100*r**2 + 210*r*s - 93*r + 8*s - 8) - k2**4*(2*K*(22*r**2 + r*(9*s - 23) - 3*s + 6) + r**2*(14 - 60*C) + r*(-24*C*s + 12*C + 23) + 6*s - 8)) + k2**4*r*(bd2*(-13*r - 13*s + 10) + 2*gd2*(36*r + 15*s - 11))) - 22*fd*k2**4*r*(13*b2*(r + s) - 6*g2*(12*r + 5*s))) + 2*Dd*f*(f**2*k2**4*(756*r**2 + 21*r*(36*s - 25) - 149*s + 64) + 11*f*(k1**4*(2*C - 1)*(4*r*(7*s - 4) - 5*s + 3) + k1**2*k2**2*(-2*C*(172*r**2 + 41*r*(8*s - 5) - 11*s + 5) + 200*r**2 + r*(420*s - 262) - 15*s + 8) + k2**4*(6*C*(4*r - 1)*(5*r + 2*s - 1) - 2*K*(44*r**2 + 18*r*s - 38*r - 3*s + 6) - 28*r**2 - 11*r + 3*s + 3)) - 11*k2**4*(b2*(52*r**2 + r*(52*s - 33) - 3*s) + 4*g2*(-72*r**2 + r*(29 - 30*s) + 2*s)))) + f*(D1*(3*f**2*fd*k2**4*(16140*r**2 + r*(12480*s - 17027) - 8892*s + 6134) + 26*f*(fd*(k1**4*(6*C - 3)*(r*(153*s - 73) - 29*s + 17) + k1**2*k2**2*(-6*C*(342*r**2 + 3*r*(261*s - 97) + 36*s - 40) + 1242*r**2 + 9*r*(324*s - 145) + 183*s - 88) + 33*k2**4*(3*r - 1)*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) - 33*k2**4*r*(bd2*(7*r + 7*s - 4) - 2*gd2*(22*r + 9*s - 15))) - 858*fd*k2**4*(b2*(14*r**2 + r*(14*s - 11) - 5*s + 2) - 4*g2*(22*r**2 + r*(9*s - 23) - 3*s + 6))) + Dd*f*(3*f**2*k2**4*(16140*r**2 + r*(12480*s - 17027) - 8892*s + 6134) + 26*f*(k1**4*(18*C - 9)*(4*r*(17*s - 8) - 7*s + 3) + k1**2*k2**2*(-8*C*(342*r**2 + r*(783*s - 347) + 59*s - 62) + 1656*r**2 + 4*r*(972*s - 509) + 351*s - 256) + 33*k2**4*(4*r - 1)*(6*C*(5*r + 2*s - 1) - 24*r - 9*s + 5)) - 858*k2**4*(b2*(28*r**2 + r*(28*s - 19) - 5*s + 2) - 4*g2*(44*r**2 + 2*r*(9*s - 19) - 3*s + 6)))))/(9009*d**2*k2*k3**4) + 2*D1**3*Pk3*Pkd1*ct*(D1*(66*b1*fd*k2**2*(2*b1**2*r*(2*k1**2 + 7*k2**2)*(r + s - 1) + b1*k1**2*(K*(29*r**2 + 3*r*(11*s + 8) + 12*s - 12) + r**2*(6 - 28*C) - r*(28*C*(s - 1) + s + 22) - 4*s + 4) + 7*b1*k2**2*r*(r*(6*K - 5) + s*(2*K - 2)) + 2*b2*r*(6*k1**2 + 7*k2**2)*(r + s) - 2*g2*k1**2*(29*r**2 + 3*r*(11*s + 8) + 12*s - 12) - 28*g2*k2**2*r*(3*r + s)) - f**3*k2**2*(bd1*(k1**2*(2325*r**2 + 172*r*(15*s - 17) + 164*s - 164) + 660*k2**2*r*(3*r + 3*s - 2)) + 20*fd*k1**2*(-7*r*(26*s - 21) + 48*s - 38)) + 3*f**2*(-11*bd1*(k1**4*r*s*(6 - 12*C) + k1**2*k2**2*(-48*C*(r**2 - 2*r - s + 1) - 2*K*(113*r**2 + 93*r*s - 95*r - 18*s + 18) + b1*(82*r**2 + 5*r*(36*s - 31) - 72*s + 48) + 100*r**2 + 78*r*s - 122*r - 40*s + 40) + 12*k2**4*(2*b1*(4*r**2 + r*(4*s - 5) - 3*s + 2) + r*(r*(5 - 6*K) - s*(2*K - 2)))) + fd*(-220*b1*k2**4*(3*r - 1)*(3*r + 3*s - 2) + k1**4*(44*C - 22)*(5*r - 2)*(3*s - 1) + k1**2*k2**2*(b1*(-2325*r**2 - 3*r*(860*s - 873) + 1256*s - 930) + (330*r - 110)*(4*C*(2*r + s - 1) - 5*r - 2*s + 2))) + 44*k2**2*(3*bd2*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*bd2*k2**2*r*(r + s) - gd2*k1**2*(113*r**2 + 93*r*s - 95*r - 18*s + 18) - 12*gd2*k2**2*r*(3*r + s))) + 66*f*(b1**2*k2**2*(2*bd1*(k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 7*k2**2*(3*r - 1)*(r + s - 1)) - fd*(k1**2*(41*r**2 + 90*r*s - 41*r + 8*s - 8) + 12*k2**2*(4*r**2 + 4*r*s - r + s - 1))) + b1*(bd1*k1**2*k2**2*(-28*C*(2*r - 1)*(r + s - 1) + K*(58*r**2 + 66*r*s - 2*r - 42*s - 6) + 12*r**2 - 2*r*s - 41*r + 2*s + 16) + 7*bd1*k2**4*(2*r - 1)*(r*(6*K - 5) + s*(2*K - 2)) + 2*bd2*k2**2*r*(k1**2*(6*r + 6*s - 3) + 7*k2**2*(r + s)) + fd*k1**4*r*(6*C - 3)*(2*s - 1) + fd*k1**2*k2**2*(24*C*(2*r**2 + r + s - 1) + K*(226*r**2 + 3*r*(62*s - 79) - 96*s + 62) - 100*r**2 - 78*r*s + 52*r + 28*s - 4) + 6*fd*k2**4*(2*r - 1)*(r*(6*K - 5) + s*(2*K - 2)) - 2*gd2*k2**2*(k1**2*(29*r**2 + 33*r*s + 27*r + 6*s - 6) + 14*k2**2*r*(3*r + s))) + 2*k2**2*(b2*(bd1*(k1**2*(6*r**2 + 6*r*(s - 1) - 3*s) + 7*k2**2*(r - 1)*(r + s)) + 6*fd*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + k2**2*(r + s))) + g2*(bd1*k1**2*(-29*r**2 + r*(29 - 33*s) + 48*s) - 14*bd1*k2**2*(r - 1)*(3*r + s) + fd*k1**2*(-226*r**2 - 3*r*(62*s - 79) + 96*s - 62) - 12*fd*k2**2*(2*r - 1)*(3*r + s))))) + Dd*f*(66*b1*k2**2*(2*b1**2*(k1**2*(8*r**2 + 8*r*(s - 1) - s + 1) + 7*k2**2*(4*r - 1)*(r + s - 1)) + b1*(k1**2*(-28*C*(4*r - 1)*(r + s - 1) + K*(116*r**2 + r*(132*s + 49) - 24*s - 24) + 24*r**2 - 4*r*s - 84*r - 4*s + 22) + 7*k2**2*(4*r - 1)*(r*(6*K - 5) + s*(2*K - 2))) + 6*b2*k1**2*(8*r**2 + r*(8*s - 4) - s) + 14*b2*k2**2*(r + s)*(4*r - 1) + 2*g2*k1**2*(-116*r**2 - r*(132*s + 49) + 24*s + 24) - 28*g2*k2**2*(3*r + s)*(4*r - 1)) + 20*f**3*k1**2*k2**2*(7*r*(26*s - 21) - 48*s + 38) + f**2*(-660*b1*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(264*C - 132)*(5*r - 2)*(2*s - 1) + k1**2*k2**2*(b1*(-9300*r**2 + r*(10781 - 10320*s) + 3604*s - 2626) + (1320*r - 330)*(4*C*(2*r + s - 1) - 5*r - 2*s + 2))) - 33*f*(b1**2*k2**2*(k1**2*(164*r**2 + 3*r*(120*s - 79) - 56*s + 32) + 24*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 2*b1*(k1**4*r*(12*C - 6)*(2*s - 1) + k1**2*k2**2*(K*(452*r**2 + r*(372*s - 427) - 132*s + 98) + 4*r**2*(24*C - 50) + 4*r*(-6*C - 39*s + 36) + 56*s - 32) + 6*k2**4*(4*r - 1)*(r*(6*K - 5) + s*(2*K - 2))) - 4*k2**2*(6*b2*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 6*b2*k2**2*(r + s)*(4*r - 1) + g2*k1**2*(-452*r**2 + r*(427 - 372*s) + 132*s - 98) - 12*g2*k2**2*(3*r + s)*(4*r - 1)))))/(693*d**2*k2*k3**4) - 4*D1**3*Pk3*Pkd1*ct*st**2*(D1*bd1*f**2*r*(k1**2*(2*C - 1)*(7*s - 3) + k2**2*(3*r - 4)) + b1**2*(D1*fd*r*(k1**2*(26*C - 13)*(s - 1) + 4*k2**2*r) + Dd*f*(k1**2*(2*C - 1)*(4*r*(13*s - 8) - 3*s + 3) + 4*k2**2*r*(4*r - 1))) + b1*f*(D1*bd1*(k1**2*(2*C - 1)*(r*(26*s - 6) - 3*s + 3) + 4*k2**2*r*(2*r - 1)) + D1*fd*(k1**2*(2*C - 1)*(2*r*(7*s - 4) - 5*s + 3) + k2**2*(6*r**2 - 11*r + 4)) + Dd*f*(k1**2*(2*C - 1)*(4*r*(7*s - 4) - 5*s + 3) + k2**2*(12*r**2 - 19*r + 4))))/(21*d**2*k1**2*k2) - 2*D1**3*Pk3*Pkd1*ct*(-2*D1*bd1*f**2*(k1**2*s*(C*(4 - 6*r) + 3*r - 2) + 6*k2**2*r**2) + 3*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) - b1**2*(D1*(f*k2**2*(3*bd1*r*(1 - 3*r) + fd*(18*r**2 - 29*r + 10)) + 14*fd*r*(k1**2*(2*C - 1)*(s - 1) + k2**2*r)) + Dd*f*(f*k2**2*(36*r**2 - 49*r + 10) + 14*r*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(4*r - 1)))) + 2*b1*f*(D1*(14*bd1*k1**2*r*s*(1 - 2*C) + bd1*k2**2*r*(f*(10 - 9*r) - 14*r + 7) + fd*k1**2*(2*C - 1)*(3*r - 2)*(2*s - 1) + 6*fd*k2**2*r*(1 - 2*r)) + 2*Dd*f*(k1**2*(2*C - 1)*(3*r - 2)*(2*s - 1) + 3*k2**2*r*(1 - 4*r))))/(21*d**2*k1**2*k2) + 4*D1**3*Pk3*Pkd1*ct*st**2*(11*b1**2*(D1*fd*r*(k1**4*(26*C - 13)*(s - 1) + 2*k1**2*k2**2*(-2*C*(6*r + s - 1) + 9*r + 2*s - 2) + k2**4*r*(6*f - 4)) + Dd*f*(k1**4*(2*C - 1)*(4*r*(13*s - 8) - 3*s + 3) - 2*k1**2*k2**2*(C*(48*r**2 + 2*r*(4*s - 9) - s + 1) - 36*r**2 + r*(15 - 8*s) + s - 1) + k2**4*r*(3*f - 4)*(4*r - 1))) + b1*f*(11*D1*bd1*(k1**4*(2*C - 1)*(r*(26*s - 6) - 3*s + 3) - 2*k1**2*k2**2*(C*(24*r**2 + 2*r*(2*s - 7) - s + 1) - 18*r**2 + r*(11 - 4*s) + s - 1) + k2**4*r*(3*f - 4)*(2*r - 1)) + D1*fd*(-k1**4*(22*C - 11)*(5*s - 3) - 11*k1**2*k2**2*(2*C*(2*r**2 - 56*r*s + r - s + 9) - 2*r**2 + 94*r*s - 7*r + 2*s - 14) + k2**4*(3*f*(81*r**2 - 21*r - 2) + 121*r - 44)) + Dd*f*k2**2*(-11*k1**2*(2*C*(4*r**2 - 112*r*s + 21*r - s + 9) - 4*r**2 + 188*r*s - 43*r - s - 12) + k2**2*(4*r - 1)*(f*(81*r + 6) + 44))) + f**2*(D1*bd1*(k1**4*(22*C - 11)*(5*s - 3) - 11*k1**2*k2**2*(r**2*(2*C - 1) + r*(-56*C*s + 47*s - 2) - 3*s + 2) + k2**4*r*(f*(81*r + 6) + 11)) + D1*fd*(-k1**4*(2*C - 1)*(r*(153*s - 73) - 29*s + 17) + k1**2*k2**2*(C*(-270*r**2 + 6*r*(66*s + 19) - 52) + 99*r**2 - 351*r*s + 51*r - 15*s + 16) + 33*k2**4*r*(3*r - 1)) + Dd*f*(-k1**4*(6*C - 3)*(4*r*(17*s - 8) - 7*s + 3) + k1**2*k2**2*(C*(-360*r**2 + 528*r*s + 34*r - 52) + 132*r**2 - 468*r*s + 151*r - 23*s + 24) + 33*k2**4*r*(4*r - 1))))/(231*d**2*k1**2*k2*k3**2) - 2*D1**3*Pk3*Pkd1*ct*(11*b1**3*k1**2*k2**2*(D1*fd*r*(5*r + 14*s - 14) + Dd*f*(20*r**2 + 56*r*s - 89*r - 28*s + 28)) + 11*b1**2*(D1*bd1*f*k1**2*k2**2*(15*r**2 + 42*r*s - 75*r - 28*s + 28) + D1*fd*(k1**4*r*(28*C - 14)*(s - 1) + k1**2*k2**2*(-2*K*(3*r**2 - r*(3*s + 16) - 4*s + 8) + f*(r*(5 - 120*s) - 32*s + 46) - 2*r**2*(28*C - 21) - 2*r*(7*s + 8) - 8*s + 8) - 14*k2**4*r**2) - 2*Dd*f*(-k1**4*r*(28*C - 14)*(2*s - 1) + k1**2*k2**2*(112*C*r**2 - 28*C*r + K*(12*r**2 - 12*r*s - 53*r + 4*s + 12) + f*(24*r*(5*s - 1) - 16*s - 1) - 84*r**2 + 28*r*s + 51*r - 6*s - 8) + 7*k2**4*r*(4*r - 1))) + b1*(D1*(f**2*k1**2*k2**2*(-11*bd1*(r*(120*s - 43) - 64*s + 44) + fd*(-1125*r**2 + r*(2609 - 2970*s) + 1056*s - 774)) + 22*f*(bd1*(k1**4*r*s*(28*C - 14) - 2*k1**2*k2**2*(K*(3*r**2 - r*(3*s + 10) + 5*s + 1) + r**2*(28*C - 21) + r*(-14*C + 7*s + 16) - 6*s - 1) + 7*k2**4*r*(1 - 2*r)) + fd*(k1**4*(4*C - 2)*(2*s - 1) + k1**2*k2**2*(K*(50*r**2 + r*(30*s - 61) - 16*s + 18) - r**2*(48*C + 8) + 2*r*(12*C - 23*s + 7) + 24*s - 8) + 6*k2**4*r*(1 - 2*r)) + k1**2*k2**2*(bd2*r*(5*r + 7*s + 7) + gd2*(6*r**2 - 2*r*(3*s + 17) - 4*s + 4))) + 22*fd*k1**2*k2**2*(b2*r*(5*r + 7*s) + 2*g2*(3*r**2 - r*(3*s + 16) - 4*s + 8))) + Dd*f*(f**2*k1**2*k2**2*(-1500*r**2 + r*(3427 - 3960*s) + 1188*s - 862) + 22*f*(k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(K*(100*r**2 + r*(60*s - 103) - 20*s + 22) - 2*r**2*(48*C + 8) - 2*r*(-12*C + 46*s - 25) + 32*s - 16) + 6*k2**4*r*(1 - 4*r)) + 22*k1**2*k2**2*(20*b2*r**2 + b2*r*(28*s + 9) - 14*b2*s + 24*g2*r**2 - 2*g2*r*(12*s + 53) + 8*g2*(s + 3)))) + f*(D1*(-bd1*f**2*k1**2*k2**2*(375*r**2 + r*(990*s - 818) - 132*s + 88) + 22*f*(bd1*(k1**4*s*(4*C - 2) + k1**2*k2**2*(K*(25*r**2 + 3*r*(5*s - 7) - 2*s + 2) + r**2*(-24*C - 4) + r*(21 - 23*s) + 4*s - 4) - 6*k2**4*r**2) + fd*(k1**4*(2*C - 1)*(5*r - 2)*(3*s - 1) + 5*k1**2*k2**2*r*(1 - 3*r)) + k1**2*k2**2*(bd2 - 2*gd2)*(25*r**2 + 3*r*(5*s - 7) - 2*s + 2)) + 22*k1**2*k2**2*(b2*bd1*(5*r**2 + r*(7*s - 5) - 14*s) + b2*fd*(50*r**2 + r*(30*s - 61) - 16*s + 18) + 6*bd1*g2*(r**2 - r*(s + 1) + 4*s) - 2*fd*g2*(50*r**2 + r*(30*s - 61) - 16*s + 18))) + 22*Dd*f*k1**2*(f*(k1**2*(4*C - 2)*(5*r - 2)*(2*s - 1) + 5*k2**2*r*(1 - 4*r)) + k2**2*(b2 - 2*g2)*(100*r**2 + r*(60*s - 103) - 20*s + 22))))/(231*d**2*k1**2*k2*k3**2) + 20*D1**3*Pk3*Pkd1*f**2*k2**6*st**6*(13*D1*bd1*f*(21*r**2 + r*(21*s - 17) + 6*s - 4) + 13*b1*(21*D1*fd*r*(3*r + 3*s - 2) + Dd*f*(84*r**2 + r*(84*s - 59) + 6*s - 4)) + f*(87*r - 38)*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(9009*d**2*k1*k3**6) - 8*D1**3*Pk3*Pkd1*f*k2**2*st**4*(D1*(429*b1*fd*k1**2*r*(3*b1*k2**2 + k1**2*(2 - 4*C))*(2*r + 2*s - 1) + f**2*k2**2*(-52*bd1*k1**2*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + fd*(k1**2*(-1812*r**2 - 1812*r*s + 1487*r + 180*s - 122) + 13*k2**2*(4*r - 1)*(5*r + 5*s - 3))) - 26*f*k1**2*(33*bd1*r*(-3*b1*k2**2 + k1**2*(2*C - 1))*(r + s - 1) + 2*fd*(2*b1*k2**2*(3*r + 2) + k1**2*(6*C - 3)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(429*b1*k1**2*r*(3*b1*k2**2 + k1**2*(2 - 4*C))*(4*r + 4*s - 3) + f**2*k2**2*(k1**2*(-1812*r**2 - 1812*r*s + 1487*r + 180*s - 122) + 13*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(2*b1*k2**2*(24*r**2 + 12*r*(2*s - 1) + 5*s - 4) + k1**2*(6*C - 3)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k1*k3**6) - 4*D1**3*Pk3*Pkd1*f*st**4*(D1*(66*b1*fd*r*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + f*(33*bd1*r*(k1**2*s*(4*C - 2) + k2**2*(r - 1)) + 2*fd*(3*r - 1)*(k1**2*(8*C - 4)*(3*s - 1) + k2**2*(C*(28 - 18*r) + 15*r + 3*s - 17)))) + Dd*f*(33*b1*r*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1)) + f*(k1**2*(8*C - 4)*(2*r*(12*s - 5) - 7*s + 3) + k2**2*(-4*C*(36*r**2 - 65*r + 14) + 120*r**2 + 24*r*(s - 7) - 7*s + 35))))/(231*d**2*k1*k3**2) - 2*D1**3*Pk3*Pkd1*f*st**4*(D1*(-858*b1*fd*r*(b1*k2**4*(4*r + 4*s - 3) + k1**4*(4*C - 2)*(2*s - 1) - 2*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + f**2*k2**4*(13*bd1*(24*r**2 + 3*r*(39*s - 4) + 8*s - 4) + 2*fd*(48*r**2 + r*(650*s - 791) - 195*s + 211)) - 13*f*(66*bd1*r*(b1*k2**4*(4*r + 4*s - 3) + k1**4*s*(4*C - 2) + k1**2*k2**2*(-4*C*(2*r + s - 2) + 5*r + 2*s - 5)) + fd*(-3*b1*k2**4*(24*r**2 + r*(117*s + 14) + 16*s - 32) + k1**4*(32*C - 16)*(3*r - 1)*(3*s - 1) - 4*k1**2*k2**2*(3*r - 1)*(C*(90*r + 48*s - 68) - 51*r - 27*s + 37)))) + 2*Dd*f*(-429*b1*r*(2*b1*k2**4*(4*r + 4*s - 3) + k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(-16*C*(2*r + s - 1) + 20*r + 8*s - 9)) + f**2*k2**4*(48*r**2 + r*(650*s - 791) - 195*s + 211) - 13*f*(-b1*k2**4*(48*r**2 + 3*r*(78*s + 5) + 28*s - 50) + k1**4*(8*C - 4)*(2*r*(12*s - 5) - 7*s + 3) + k1**2*k2**2*(-4*C*(180*r**2 + 3*r*(32*s - 63) - 28*s + 38) + 408*r**2 + 8*r*(27*s - 52) - 63*s + 83))))/(3003*d**2*k1*k3**4) + 8*D1**3*Pk3*Pkd1*k1**3*(D1*(-2*b1*fd*r*(2*k1**2 + 7*k2**2)*(r + s)*(K*b1 - 2*g2) + 5*bd1*f**3*k2**2*r*(r + s - 1) + f**2*(5*b1*fd*k2**2*(3*r - 1)*(r + s - 1) - 2*bd1*(K*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*K*k2**2*r*(r + s) - 3*b1*k2**2*(2*r - 1)*(r + s - 1)) + 4*gd2*(k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*k2**2*r*(r + s))) + 2*f*(2*b1*gd2*r*(k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s)) + bd1*(K*b1*(k1**2*(-4*r**2 - 4*r*s + 3*r + s) - 7*k2**2*(r + s)*(2*r - 1)) + 2*g2*(k1**2*(2*r**2 + 2*r*(s - 1) - s) + 7*k2**2*(r - 1)*(r + s))) + 2*fd*(b1*(-K*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s)) + 3*b1*k2**2*r*(r + s - 1)) + 2*g2*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))))) + Dd*f*(5*b1*f**2*k2**2*(4*r - 1)*(r + s - 1) - 2*b1*(K*b1 - 2*g2)*(k1**2*(8*r**2 + r*(8*s - 4) - s) + 7*k2**2*(r + s)*(4*r - 1)) + 2*f*(b1*(-2*K*(k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 3*k2**2*(r + s)*(4*r - 1)) + 3*b1*k2**2*(4*r - 1)*(r + s - 1)) + 4*g2*(k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 3*k2**2*(r + s)*(4*r - 1)))))/(21*d**2*k3**6) - 2*D1**3*Pk3*Pkd1*k1*(-20*D1*K*b1**2*fd*k1**2*r**2 - 22*D1*K*b1**2*fd*k1**2*r*s - 16*D1*K*b1**2*fd*k1**2*r - 8*D1*K*b1**2*fd*k1**2*s + 8*D1*K*b1**2*fd*k1**2 - 56*D1*K*b1**2*fd*k2**2*r**2 - 28*D1*K*b1**2*fd*k2**2*r*s - 144*D1*K*b1*f*fd*k1**2*r**2 - 124*D1*K*b1*f*fd*k1**2*r*s + 144*D1*K*b1*f*fd*k1**2*r + 64*D1*K*b1*f*fd*k1**2*s - 36*D1*K*b1*f*fd*k1**2 - 96*D1*K*b1*f*fd*k2**2*r**2 - 48*D1*K*b1*f*fd*k2**2*r*s + 48*D1*K*b1*f*fd*k2**2*r + 24*D1*K*b1*f*fd*k2**2*s - 14*D1*b1**3*fd*k2**2*r**2 - 14*D1*b1**3*fd*k2**2*r*s + 14*D1*b1**3*fd*k2**2*r + 30*D1*b1**2*f*fd*k1**2*r*s - 27*D1*b1**2*f*fd*k1**2*r + 12*D1*b1**2*f*fd*k2**2*r + 12*D1*b1**2*f*fd*k2**2*s - 12*D1*b1**2*f*fd*k2**2 + 4*D1*b1**2*fd*k1**2*r*s + 14*D1*b1**2*fd*k2**2*r**2 - 8*D1*b1*b2*fd*k1**2*r**2 - 8*D1*b1*b2*fd*k1**2*r*s - 28*D1*b1*b2*fd*k2**2*r**2 - 28*D1*b1*b2*fd*k2**2*r*s + 45*D1*b1*f**2*fd*k1**2*r*s - 35*D1*b1*f**2*fd*k1**2*r - 16*D1*b1*f**2*fd*k1**2*s + 12*D1*b1*f**2*fd*k1**2 + 30*D1*b1*f**2*fd*k2**2*r**2 + 30*D1*b1*f**2*fd*k2**2*r*s - 40*D1*b1*f**2*fd*k2**2*r - 10*D1*b1*f**2*fd*k2**2*s + 10*D1*b1*f**2*fd*k2**2 + 16*D1*b1*f*fd*k1**2*r*s - 8*D1*b1*f*fd*k1**2*s + 24*D1*b1*f*fd*k2**2*r**2 - 12*D1*b1*f*fd*k2**2*r + 40*D1*b1*f*gd2*k1**2*r**2 + 44*D1*b1*f*gd2*k1**2*r*s + 36*D1*b1*f*gd2*k1**2*r + 8*D1*b1*f*gd2*k1**2*s - 8*D1*b1*f*gd2*k1**2 + 112*D1*b1*f*gd2*k2**2*r**2 + 56*D1*b1*f*gd2*k2**2*r*s + 40*D1*b1*fd*g2*k1**2*r**2 + 44*D1*b1*fd*g2*k1**2*r*s + 32*D1*b1*fd*g2*k1**2*r + 16*D1*b1*fd*g2*k1**2*s - 16*D1*b1*fd*g2*k1**2 + 112*D1*b1*fd*g2*k2**2*r**2 + 56*D1*b1*fd*g2*k2**2*r*s - 32*D1*b2*f*fd*k1**2*r**2 - 32*D1*b2*f*fd*k1**2*r*s + 32*D1*b2*f*fd*k1**2*r + 16*D1*b2*f*fd*k1**2*s - 8*D1*b2*f*fd*k1**2 - 48*D1*b2*f*fd*k2**2*r**2 - 48*D1*b2*f*fd*k2**2*r*s + 24*D1*b2*f*fd*k2**2*r + 24*D1*b2*f*fd*k2**2*s + D1*bd1*f*(-14*b1**2*k2**2*(3*r - 1)*(r + s - 1) - 2*b1*(K*k1**2*(20*r**2 + 22*r*s - r - 14*s - 2) + 14*K*k2**2*(2*r - 1)*(2*r + s) + k1**2*(-4*r*s + r + s) + 7*k2**2*r*(1 - 2*r)) - 4*b2*k1**2*(2*r**2 + 2*r*(s - 1) - s) - 28*b2*k2**2*(r - 1)*(r + s) + f**2*(k1**2*(15*r - 2)*(s - 1) + 10*k2**2*r*(r + s - 1)) + f*(k1**2*(-2*K*(36*r**2 + 31*r*s - 29*r - 6*s + 6) + 3*b1*(r*(10*s - 9) - 4*s + 4) + 8*r*s - 4*r - 2*s + 2) - 12*k2**2*(b1*(r + s - 1) + r*(4*K*r + 2*K*s - r))) - 4*g2*k1**2*(-10*r**2 + r*(10 - 11*s) + 16*s) + 56*g2*k2**2*(r - 1)*(2*r + s)) - 4*D1*bd2*f*(b1*k1**2*r*(2*r + 2*s - 1) + 7*b1*k2**2*r*(r + s) + f*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*f*k2**2*r*(r + s)) + 144*D1*f**2*gd2*k1**2*r**2 + 124*D1*f**2*gd2*k1**2*r*s - 116*D1*f**2*gd2*k1**2*r - 24*D1*f**2*gd2*k1**2*s + 24*D1*f**2*gd2*k1**2 + 96*D1*f**2*gd2*k2**2*r**2 + 48*D1*f**2*gd2*k2**2*r*s + 288*D1*f*fd*g2*k1**2*r**2 + 248*D1*f*fd*g2*k1**2*r*s - 288*D1*f*fd*g2*k1**2*r - 128*D1*f*fd*g2*k1**2*s + 72*D1*f*fd*g2*k1**2 + 192*D1*f*fd*g2*k2**2*r**2 + 96*D1*f*fd*g2*k2**2*r*s - 96*D1*f*fd*g2*k2**2*r - 48*D1*f*fd*g2*k2**2*s - 80*Dd*K*b1**2*f*k1**2*r**2 - 88*Dd*K*b1**2*f*k1**2*r*s - 32*Dd*K*b1**2*f*k1**2*r + 16*Dd*K*b1**2*f*k1**2*s + 16*Dd*K*b1**2*f*k1**2 - 224*Dd*K*b1**2*f*k2**2*r**2 - 112*Dd*K*b1**2*f*k2**2*r*s + 56*Dd*K*b1**2*f*k2**2*r + 28*Dd*K*b1**2*f*k2**2*s - 288*Dd*K*b1*f**2*k1**2*r**2 - 248*Dd*K*b1*f**2*k1**2*r*s + 260*Dd*K*b1*f**2*k1**2*r + 88*Dd*K*b1*f**2*k1**2*s - 60*Dd*K*b1*f**2*k1**2 - 192*Dd*K*b1*f**2*k2**2*r**2 - 96*Dd*K*b1*f**2*k2**2*r*s + 48*Dd*K*b1*f**2*k2**2*r + 24*Dd*K*b1*f**2*k2**2*s - 56*Dd*b1**3*f*k2**2*r**2 - 56*Dd*b1**3*f*k2**2*r*s + 70*Dd*b1**3*f*k2**2*r + 14*Dd*b1**3*f*k2**2*s - 14*Dd*b1**3*f*k2**2 + 60*Dd*b1**2*f**2*k1**2*r*s - 54*Dd*b1**2*f**2*k1**2*r - 12*Dd*b1**2*f**2*k1**2*s + 12*Dd*b1**2*f**2*k1**2 + 16*Dd*b1**2*f*k1**2*r*s - 4*Dd*b1**2*f*k1**2*r - 2*Dd*b1**2*f*k1**2*s + 56*Dd*b1**2*f*k2**2*r**2 - 14*Dd*b1**2*f*k2**2*r - 32*Dd*b1*b2*f*k1**2*r**2 - 32*Dd*b1*b2*f*k1**2*r*s + 16*Dd*b1*b2*f*k1**2*r + 4*Dd*b1*b2*f*k1**2*s - 112*Dd*b1*b2*f*k2**2*r**2 - 112*Dd*b1*b2*f*k2**2*r*s + 28*Dd*b1*b2*f*k2**2*r + 28*Dd*b1*b2*f*k2**2*s + 60*Dd*b1*f**3*k1**2*r*s - 50*Dd*b1*f**3*k1**2*r - 18*Dd*b1*f**3*k1**2*s + 14*Dd*b1*f**3*k1**2 + 40*Dd*b1*f**3*k2**2*r**2 + 40*Dd*b1*f**3*k2**2*r*s - 50*Dd*b1*f**3*k2**2*r - 10*Dd*b1*f**3*k2**2*s + 10*Dd*b1*f**3*k2**2 + 32*Dd*b1*f**2*k1**2*r*s - 8*Dd*b1*f**2*k1**2*r - 12*Dd*b1*f**2*k1**2*s + 4*Dd*b1*f**2*k1**2 + 48*Dd*b1*f**2*k2**2*r**2 - 12*Dd*b1*f**2*k2**2*r + 160*Dd*b1*f*g2*k1**2*r**2 + 176*Dd*b1*f*g2*k1**2*r*s + 64*Dd*b1*f*g2*k1**2*r - 32*Dd*b1*f*g2*k1**2*s - 32*Dd*b1*f*g2*k1**2 + 448*Dd*b1*f*g2*k2**2*r**2 + 224*Dd*b1*f*g2*k2**2*r*s - 112*Dd*b1*f*g2*k2**2*r - 56*Dd*b1*f*g2*k2**2*s - 64*Dd*b2*f**2*k1**2*r**2 - 64*Dd*b2*f**2*k1**2*r*s + 64*Dd*b2*f**2*k1**2*r + 24*Dd*b2*f**2*k1**2*s - 16*Dd*b2*f**2*k1**2 - 96*Dd*b2*f**2*k2**2*r**2 - 96*Dd*b2*f**2*k2**2*r*s + 24*Dd*b2*f**2*k2**2*r + 24*Dd*b2*f**2*k2**2*s + 576*Dd*f**2*g2*k1**2*r**2 + 496*Dd*f**2*g2*k1**2*r*s - 520*Dd*f**2*g2*k1**2*r - 176*Dd*f**2*g2*k1**2*s + 120*Dd*f**2*g2*k1**2 + 384*Dd*f**2*g2*k2**2*r**2 + 192*Dd*f**2*g2*k2**2*r*s - 96*Dd*f**2*g2*k2**2*r - 48*Dd*f**2*g2*k2**2*s)/(21*d**2*k3**4) - 4*D1**3*Pk3*Pkd1*k1*st**2*(13*D1*bd1*f*(f**2*k2**2*(k1**2*(207*r**2 + r*(207*s - 41) + 82*s - 98) - 33*k2**2*(11*r + 9*s - 7)) - 33*f*(b1*k2**4*(2*r - 1)*(9*r + 9*s - 5) + k1**4*(4*C - 2)*(2*r - 1)*(r + s - 1) - 2*k1**2*k2**2*(2*C*(r - 1)*(3*r + 3*s - 2) - 7*K*r**2 - 7*K*r*s + 4*K*r + b1*(17*r**2 + r*(17*s - 18) - 5*s + 3) - 3*r**2 - 3*r*s + 5*r + 3*s - 2)) + 66*k1**2*k2**2*(K*b1*(-26*r**2 + r*(23 - 26*s) + 3*s) + g2*(26*r**2 + 26*r*(s - 1) - 6*s))) - 429*b1**2*k2**2*(D1*fd*r*(26*K*k1**2*(r + s) + f*k1**2*(-34*r - 34*s + 19) + 2*f*k2**2*(9*r + 9*s - 5)) + Dd*f*(2*K*k1**2*(52*r**2 + r*(52*s - 33) - 3*s) + f*(k1**2*(-68*r**2 - 68*r*s + 55*r + 10*s - 6) + k2**2*(4*r - 1)*(9*r + 9*s - 5)))) + 13*b1*(D1*(f**2*fd*k2**2*(k1**2*(621*r**2 + 9*r*(69*s - 40) - 12*s + 8) + 33*k2**2*(3*r + 9*s - 5)) - 66*f*k1**2*(K*fd*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2) + fd*r*(2*C - 1)*(k1**2*(4*r + 4*s - 3) - 2*k2**2*(3*r + 3*s - 2)) - 2*gd2*k2**2*r*(13*r + 13*s - 10)) + 1716*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(828*r**2 + r*(828*s - 401) + 70*s - 90) + 66*k2**2*(1 - 4*r)) - 66*f*k1**2*(k1**2*(2*C - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + k2**2*(-2*C*(4*r - 1)*(3*r + 3*s - 2) + K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + (4*r - 1)*(3*r + 3*s - 2))) + 132*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(-2*k1**2*(8*r**2 + 8*r*(s - 1) + 63*s - 31) + 65*k2**2*(4*r - 1)*(9*r + 9*s - 7)) - 26*f*k1**2*(fd*(2*C - 1)*(k1**2*(54*r**2 + 54*r*(s - 1) + 15*s + 1) - 33*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 66*gd2*k2**2*r*(7*r + 7*s - 4)) + 1716*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(5*f**2*k2**2*(-2*k1**2*(8*r**2 + 8*r*(s - 1) + 63*s - 31) + 65*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + f*k1**2*(26 - 52*C)*(k1**2*(72*r**2 + 72*r*(s - 1) + 23*s - 7) - 33*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**6) + 2*D1**3*Pk3*Pkd1*st**2*(D1*bd1*f**2*r*(6*C*(r - 2) - 3*r - 2*s + 7) + b1**2*(D1*fd*r*(-2*C*r + r - 2*s + 2) + Dd*f*(r**2*(4 - 8*C) + r*(2*C - 8*s + 5) + s - 1)) + b1*f*(D1*bd1*(r**2*(2 - 4*C) + r*(2*C - 4*s + 1) + s - 1) + D1*fd*(6*C*(2*r**2 - 5*r + 2) - 6*r**2 - 4*r*s + 18*r + s - 7) + Dd*f*(6*C*(4*r**2 - 9*r + 2) - 12*r**2 - 8*r*s + 33*r + s - 7)))/(21*d**2*k1) + 2*D1**3*Pk3*Pkd1*(-4*D1*bd1*f*r*(b2 - 2*g2)*(r - 1) + 7*b1**3*(D1*fd*r*(s - 1) + 2*Dd*f*(r*(2*s - 3) - s + 1)) + b1**2*(7*D1*bd1*f*(r*(3*s - 5) - 2*s + 2) + D1*fd*(f*(3*r*(10*s - 9) - 16*s + 14) + (4 - 4*r)*(K*(r - 1) - s)) + 2*Dd*f*(-2*K*(4*r**2 - 5*r + 1) + f*(3*r*(10*s - 9) - 10*s + 8) + 8*r*s - 2*r - 5*s + 2)) + b1*(D1*bd1*f*(-8*K*r**2 + f*(3*r*(10*s - 9) - 4*s + 2) + r*(8*K + 8*s - 2) - 4*s + 2) + (4 - 4*r)*(D1*b2*fd*(r - 1) + D1*f*r*(bd2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + Dd*b2*f*(4*r - 1) + 2*Dd*f*g2*(1 - 4*r))))/(21*d**2*k1) - 2*D1**3*Pk3*Pkd1*st**2*(33*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + 33*b1**2*(D1*f*k2**2*(bd1*r*(3*r - 1) + 2*fd*(6*r**2 + r*(24*s - 11) - 3)) + D1*fd*r*(k1**2*(C*(6*r + 8*s - 8) - 3*r - 6*s + 6) + k2**2*(r*(K + 11) + 2*s)) + Dd*f*k1**2*(C*(24*r**2 + r*(32*s - 30) - 4*s + 4) - 12*r**2 - 3*r*(8*s - 7) + 3*s - 3) + Dd*f*k2**2*(2*f*(12*r**2 + r*(48*s - 13) + 3*s - 5) + r**2*(4*K + 44) - r*(K - 8*s + 13) - s)) + 3*b1*(11*D1*bd1*f*(k1**2*(2*C*(6*r**2 + r*(8*s - 7) - 2*s + 2) - 6*r**2 + 3*r*(3 - 4*s) + 3*s - 3) + k2**2*(2*f*(6*r**2 + r*(24*s - 2) + 3*s - 2) + r**2*(2*K + 22) - r*(K - 4*s + 12) - s)) + D1*(f**2*fd*k2**2*(-243*r**2 + 96*r + 66*s - 38) - 11*f*(fd*k1**2*(2*C*(52*r*s - 5*r + 2*s - 8) - 52*r*s + 5*r - 3*s + 9) + fd*k2**2*(3*K*(2*r**2 - 5*r + 2) - (4*r - 1)*(r + s - 2)) - k2**2*r**2*(bd2 - 2*gd2)) + 11*fd*k2**2*r**2*(b2 - 2*g2)) + Dd*f*(f**2*k2**2*(-324*r**2 + 101*r + 66*s - 38) - 11*f*(k1**2*(4*C - 2)*(4*r*(13*s - 3) + s - 4) + k2**2*(3*K*(4*r**2 - 9*r + 2) - 8*r**2 - 8*r*s + 12*r + s - 2)) + k2**2*r*(11*b2 - 22*g2)*(4*r - 1))) + f*(-3*D1*bd1*(f**2*k2**2*r*(81*r - 5) + 11*f*(k1**2*(r*(2*C - 1)*(26*s + 1) + s - 1) + k2**2*r*(3*K*(r - 2) - 2*r - 2*s)) + k2**2*r*(-11*b2 + 22*g2)*(r - 1)) + D1*(f*(fd*k1**2*(2*C*(135*r**2 - 594*r*s + 75*r + 26) - 135*r**2 + 648*r*s - 159*r + 15*s - 9) + 99*fd*k2**2*r*(1 - 3*r) - k2**2*r*(99*bd2 - 198*gd2)*(r - 2)) - 99*fd*k2**2*(b2 - 2*g2)*(2*r**2 - 5*r + 2)) + Dd*f*(f*k1**2*(2*C*(180*r**2 + r*(247 - 792*s) + 26) - 180*r**2 + r*(864*s - 365) + 23*s - 17) + 99*f*k2**2*r*(1 - 4*r) - k2**2*(99*b2 - 198*g2)*(4*r**2 - 9*r + 2))))/(693*d**2*k1*k3**2) - 2*D1**3*Pk3*Pkd1*(7*b1**3*k1**2*(D1*fd*r*(s - 1) + 2*Dd*f*(r*(2*s - 3) - s + 1)) + b1**2*(7*D1*bd1*f*k1**2*(r*(3*s - 5) - 2*s + 2) - 2*D1*fd*(-K*k1**2*(3*r*(s + 4) + 4*s - 6) + f*k1**2*(8*s - 7) + 2*k1**2*s + 7*k2**2*r**2) - 2*Dd*f*(-2*k1**2*(K*(6*r*s + 21*r - 2*s - 5) - 2*f*s + f - 2*s + 1) + 7*k2**2*r*(4*r - 1))) + b1*(2*D1*bd1*f*(k1**2*(K*(6*r*s + 15*r - 10*s - 2) + f*(4*s - 5) - s + 1) + 7*k2**2*r*(1 - 2*r)) + D1*(f**2*fd*k1**2*(-45*r*s + 35*r + 16*s - 12) - 2*f*(-2*K*fd*k1**2*(20*r**2 + 5*r*(3*s - 4) - 8*s + 5) - bd2*k1**2*r*(6*r + 7*s + 7) + 2*fd*(2*r - 1)*(2*k1**2*s + 3*k2**2*r) + 2*gd2*k1**2*(3*r*(s + 5) + 2*s - 2)) + 2*fd*k1**2*(b2*r*(6*r + 7*s) - 2*g2*(3*r*(s + 4) + 4*s - 6))) - 2*Dd*f*(f**2*k1**2*(5*r*(6*s - 5) - 9*s + 7) - 2*f*(k1**2*(K*(40*r**2 + 30*r*s - 33*r - 10*s + 7) - 8*r*s + 2*r + 3*s - 1) + 3*k2**2*r*(1 - 4*r)) + 2*k1**2*(-b2*(12*r**2 + 14*r*s + 4*r - 7*s) + 2*g2*(6*r*s + 21*r - 2*s - 5)))) + f*(D1*bd1*(-f**2*k1**2*(15*r - 2)*(s - 1) + 2*f*(k1**2*(K*(20*r**2 + 15*r*s - 13*r - 2*s + 2) - 4*r*s + 2*r + s - 1) - 6*k2**2*r**2) + 2*k1**2*(b2*(6*r**2 + 7*r*s - 6*r - 14*s) - 6*g2*s*(r - 4))) + 2*k1**2*(D1*bd2*f*(20*r**2 + r*(15*s - 13) - 2*s + 2) - 2*D1*(f*gd2*(20*r**2 + r*(15*s - 13) - 2*s + 2) + 2*fd*g2*(20*r**2 + 5*r*(3*s - 4) - 8*s + 5)) - 4*Dd*f*g2*(40*r**2 + r*(30*s - 33) - 10*s + 7) + 2*b2*(D1*fd*(20*r**2 + 5*r*(3*s - 4) - 8*s + 5) + Dd*f*(40*r**2 + r*(30*s - 33) - 10*s + 7)))))/(21*d**2*k1*k3**2) - 2*D1**3*Pk3*Pkd1*st**2*(429*b1**3*k1**2*k2**2*(15*D1*fd*r*(r + s - 1) + Dd*f*(60*r**2 + r*(60*s - 53) - 4*s + 4)) - 429*b1**2*(D1*(bd1*f*k1**2*k2**2*(-45*r**2 - 45*r*s + 38*r + 4*s - 4) + fd*(2*f*k1**2*k2**2*(29*r**2 + 44*r*s - 16*r + 3*s - 3) - 4*f*k2**4*r*(3*r + 3*s - 2) + k1**4*r*(8*C - 4)*(r + s - 1) + k1**2*k2**2*r*(r*(11 - 51*K) + s*(2 - 30*K)))) + Dd*f*(-2*f*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(4*C - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(f*(116*r**2 + 176*r*s - 107*r + 5*s - 5) + r**2*(44 - 204*K) + r*(-120*K*s + 95*K + 8*s - 13) + s*(8*K - 1)))) - 13*b1*(33*D1*bd1*f*(-2*f*k2**4*(2*r - 1)*(3*r + 3*s - 2) + k1**4*(4*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(f*(58*r**2 + r*(88*s - 75) - s + 1) + r**2*(22 - 102*K) + r*(-60*K*s + 73*K + 4*s - 12) + s*(8*K - 1))) - 3*D1*(f**2*fd*k2**2*(-k1**2*(153*r**2 + 243*r*s + 95*s - 89) + 22*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + 11*f*k1**2*(fd*(k1**2*(4*C*(11*r**2 + 2*r*(17*s - 8) + s - 1) - 22*r**2 + r*(35 - 72*s) - 2*s + 2) + k2**2*(K*(62*r**2 + r*(36*s - 59) - 12*s + 14) + r**2*(20 - 48*C) + r*(-24*C*s + 16*C + 8*s + 1) + s - 2)) + 2*k2**2*r*(bd2*(13*r + 13*s - 10) + gd2*(-51*r - 30*s + 22))) + 22*fd*k1**2*k2**2*r*(13*b2*(r + s) - 3*g2*(17*r + 10*s))) + Dd*f*(f**2*k2**2*(k1**2*(612*r**2 + r*(972*s - 407) + 52*s - 84) - 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 33*f*k1**2*(k1**2*(2*C*(44*r**2 + r*(136*s - 83) - 2*s + 2) - 44*r**2 - 144*r*s + 89*r + 3*s - 3) + k2**2*(-4*C*(4*r - 1)*(6*r + 3*s - 2) + K*(124*r**2 + 72*r*s - 99*r - 12*s + 14) + 40*r**2 + 16*r*s - 16*r - 5*s + 2)) - 66*k1**2*k2**2*(b2*(52*r**2 + r*(52*s - 33) - 3*s) + g2*(-204*r**2 + r*(95 - 120*s) + 8*s)))) + f*(-13*D1*bd1*(f**2*k2**2*(k1**2*(153*r**2 + r*(243*s - 407) - 233*s + 183) - 66*k2**2*r*(3*r + 3*s - 2)) - 33*f*k1**2*(k1**2*(C*(22*r**2 + 34*r*(2*s - 1) - 8*s + 8) - 11*r**2 - 36*r*s + 18*r + 5*s - 5) + k2**2*(-4*C*(r - 1)*(6*r + 3*s - 2) + r**2*(31*K + 10) + 2*r*(9*K*s - 10*K + 2*s - 8) - 6*s + 4)) - 66*k1**2*k2**2*(b2*(13*r**2 + 13*r*(s - 1) - 3*s) + g2*(-51*r**2 + r*(51 - 30*s) + 8*s))) + k1**2*(D1*(f**2*fd*k2**2*(-6420*r**2 + r*(11335 - 9360*s) + 6669*s - 4597) + 13*f*(fd*(k1**2*(2*C*(27*r + 2)*(3*r + 30*s - 11) - 81*r**2 + r*(375 - 864*s) - 75*s + 5) - 33*k2**2*(3*r - 1)*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) + 66*k2**2*r*(bd2*(7*r + 7*s - 4) + gd2*(-31*r - 18*s + 20))) + 858*fd*k2**2*(b2*(14*r**2 + r*(14*s - 11) - 5*s + 2) + g2*(-62*r**2 - 36*r*s + 59*r + 12*s - 14))) + Dd*f*(f**2*k2**2*(-6420*r**2 + r*(11335 - 9360*s) + 6669*s - 4597) + 13*f*(k1**2*(2*C*(108*r**2 + 1080*r*s - 535*r + 92*s - 54) - 108*r**2 - 1152*r*s + 653*r - 115*s + 45) - 33*k2**2*(4*r - 1)*(4*C*(6*r + 3*s - 2) - 15*r - 6*s + 4)) + 858*k2**2*(b2*(28*r**2 + r*(28*s - 19) - 5*s + 2) + g2*(-124*r**2 - 72*r*s + 99*r + 12*s - 14))))))/(9009*d**2*k1*k3**4) + 4*D1**3*Pk3*Pkdd1*b1*ct*k2*(2*D1*bd1*f*r*(f*(2*r - 1) + r - 1) + b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*(D1*(bd1*f*r*(3*r - 1) + fd*(f*(1 - 2*r)**2 + (r - 1)**2)) + Dd*f*(4*r - 1)*(f*(2*r - 1) + r - 1)))/(21*d**2*k1) + D1**3*Pk3*Pkdd1*ct**6*f*k2**4*(8*C - 8)*(D1*(132*b1*fd*r**2 + 66*bd1*f*r*(r - 1) + 25*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(66*b1*r + 25*f*(3*r - 1)))/(693*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**5*f*k2**3*(D1*(132*b1*fd*r**2 + 66*bd1*f*r*(r - 1) + 25*f*fd*(1 - 3*r)**2) + Dd*f*(4*r - 1)*(66*b1*r + 25*f*(3*r - 1)))/(693*d**2*k1*k3**2) + 4*D1**3*Pk3*Pkdd1*ct**5*f*k2**3*(D1*(1716*b1*fd*k1**2*r**2*(8*C - 7) + 5*f**2*k2**2*(195*bd1*r*(r - 1) + 49*fd*(1 - 4*r)**2) + 13*f*(66*bd1*k1**2*r*(8*C - 7)*(r - 1) + 25*fd*(9*b1*k2**2*r**2 + k1**2*(1 - 3*r)**2*(8*C - 7)))) + Dd*f*(4*r - 1)*(858*b1*k1**2*r*(8*C - 7) + 245*f**2*k2**2*(4*r - 1) + 325*f*(3*b1*k2**2*r + k1**2*(8*C - 7)*(3*r - 1))))/(9009*d**2*k1*k3**4) - D1**3*Pk3*Pkdd1*ct**4*f*k2**4*st**2*(8*C - 8)*(D1*(66*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + f*fd*(27*r**2 + 15*r - 8)) + Dd*f*(4*r - 1)*(33*b1*r + f*(9*r + 8)))/(231*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**4*k2**2*(66*b1**2*r*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) - 66*b1*f*(D1*bd1*r*(-2*C*r + C + 2*r - 1) - D1*fd*(-4*C*r + C + 2*r**2 + 4*r - 1) + Dd*f*(4*r - 1)*(C - r - 1)) + f**2*(66*D1*bd1*r*(C + r - 2) + D1*fd*(1 - 3*r)**2*(75 - 50*C) - Dd*f*(50*C - 75)*(12*r**2 - 7*r + 1)))/(693*d**2*k3**2) - 4*D1**3*Pk3*Pkdd1*ct**4*k2**2*(D1*(-429*b1*fd*k2**2*r**2*(b1*(K - 1) - 2*g2) - 5*f**3*k2**2*(130*bd1*r*(3*r - 4) + 147*fd*(1 - 4*r)**2) - 13*f**2*(25*fd*(b1*k2**2*(18*r**2 + 6*r - 1) + k1**2*(1 - 3*r)**2*(12*C - 9)) + 33*r*(6*bd1*k1**2*(4*C - 3)*(r - 1) - bd1*k2**2*(2*r - 1)*(-K + 2*b1 + 1) + 2*gd2*k2**2*(1 - 2*r))) + 429*f*(4*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(36 - 48*C) - k2**2*(1 - 2*r)**2*(K - 1)) + k2**2*r*(bd1*(-2*K*r + K + 2*r - 1) + 2*gd2*r)) + 2*g2*k2**2*(bd1*r*(r - 1) + fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(429*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 735*f**3*k2**2*(4*r - 1) + 325*f**2*(b1*k2**2*(6*r + 1) + k1**2*(12*C - 9)*(3*r - 1)) - 429*f*(2*b1**2*k2**2*r + 6*b1*k1**2*r*(3 - 4*C) + b1*k2**2*(-2*K*r + K + 2*r - 1) + 2*g2*k2**2*(2*r - 1))))/(9009*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*ct**3*f*k2**3*st**2*(D1*(66*b1*fd*r**2 + 33*bd1*f*r*(r - 1) + f*fd*(27*r**2 + 15*r - 8)) + Dd*f*(4*r - 1)*(33*b1*r + f*(9*r + 8)))/(231*d**2*k1*k3**2) - 4*D1**3*Pk3*Pkdd1*ct**3*f*k2**3*st**2*(D1*(2574*b1*fd*k1**2*r**2*(6*C - 5) + 5*f**2*k2**2*(117*bd1*r*(r - 1) + 5*fd*(4*r**2 + 63*r - 16)) + 39*f*(45*b1*fd*k2**2*r**2 + 33*bd1*k1**2*r*(6*C - 5)*(r - 1) + fd*k1**2*(6*C - 5)*(27*r**2 + 15*r - 8))) + Dd*f*(4*r - 1)*(1287*b1*k1**2*r*(6*C - 5) + 25*f**2*k2**2*(r + 16) + 39*f*(15*b1*k2**2*r + k1**2*(6*C - 5)*(9*r + 8))))/(9009*d**2*k1*k3**4) - 4*D1**3*Pk3*Pkdd1*ct**3*k1*k2*(D1*(-429*b1*fd*k2**2*r**2*(b1*(4*K - 3) - 8*g2) - 15*f**3*k2**2*(-130*bd1*r + 49*fd*(1 - 4*r)**2) - 13*f**2*(25*fd*(3*b1*k2**2*(6*r - 1) + k1**2*(1 - 3*r)**2*(8*C - 5)) + 33*r*(2*bd1*k1**2*(8*C - 5)*(r - 1) - bd1*k2**2*(2*r - 1)*(-4*K + 6*b1 + 3) + 8*gd2*k2**2*(1 - 2*r))) + 429*f*(12*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(20 - 32*C) - k2**2*(1 - 2*r)**2*(4*K - 3)) + k2**2*r*(bd1*(-8*K*r + 4*K + 6*r - 3) + 8*gd2*r)) + 8*g2*k2**2*(bd1*r*(r - 1) + fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(429*b1*k2**2*r*(b1*(4*K - 3) - 8*g2) + 735*f**3*k2**2*(4*r - 1) + 325*f**2*(3*b1*k2**2 + k1**2*(8*C - 5)*(3*r - 1)) - 429*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(5 - 8*C) + b1*k2**2*(K*(4 - 8*r) + 6*r - 3) + 8*g2*k2**2*(2*r - 1))))/(9009*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*ct**3*k2*(D1*bd1*f**2*r*(2*r - 1) + b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(D1*bd1*r + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2*k1) + 4*D1**3*Pk3*Pkdd1*ct**3*k2*(33*b1**2*r*(D1*fd*r*(k1**2*(4*C - 3) + k2**2*(8*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(4*C - 3) + k2**2*(4*f + 1))) + b1*f*(D1*(33*bd1*r*(2*r - 1)*(k1**2*(4*C - 3) + k2**2*(4*f + 1)) + fd*(-k1**2*(132*C - 99)*(4*r - 1) + k2**2*(50*f*(1 - 3*r)**2 + 33*(1 - 2*r)**2))) + Dd*f*(4*r - 1)*(k1**2*(99 - 132*C) + k2**2*(50*f*(3*r - 1) + 66*r - 33))) + f**2*(D1*bd1*r*(k1**2*(132*C - 99) + k2**2*(50*f*(3*r - 1) + 66*r - 33)) + D1*fd*k1**2*(1 - 3*r)**2*(75 - 100*C) - Dd*f*k1**2*(100*C - 75)*(12*r**2 - 7*r + 1)))/(693*d**2*k1*k3**2) - D1**3*Pk3*Pkdd1*ct**2*f**2*k2**4*st**4*(8*C - 8)*(3*r - 1)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*ct**2*k1**2*(D1*(-1287*b1*fd*k2**2*r**2*(b1*(2*K - 1) - 4*g2) - 5*f**3*k2**2*(-390*bd1*r**2 + 49*fd*(1 - 4*r)**2) - 13*f**2*(25*fd*(-3*b1*k2**2*(6*r**2 - 6*r + 1) + k1**2*(1 - 3*r)**2*(2*C - 1)) + 33*r*(2*bd1*k1**2*(2*C - 1)*(r - 1) - 3*bd1*k2**2*(2*r - 1)*(-2*K + 2*b1 + 1) + 12*gd2*k2**2*(1 - 2*r))) + 429*f*(12*b1**2*fd*k2**2*r**2 + b1*(fd*(k1**2*r**2*(4 - 8*C) + k2**2*(1 - 2*r)**2*(3 - 6*K)) - 3*k2**2*r*(bd1*(2*K - 1)*(2*r - 1) - 4*gd2*r)) + 12*g2*k2**2*(bd1*r*(r - 1) + fd*(1 - 2*r)**2))) - Dd*f*(4*r - 1)*(1287*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 245*f**3*k2**2*(4*r - 1) + 325*f**2*(3*b1*k2**2*(1 - 2*r) + k1**2*(2*C - 1)*(3*r - 1)) - 429*f*(6*b1**2*k2**2*r + 2*b1*k1**2*r*(1 - 2*C) - 3*b1*k2**2*(2*K - 1)*(2*r - 1) + 12*g2*k2**2*(2*r - 1))))/(9009*d**2*k3**4) + D1**3*Pk3*Pkdd1*ct**2*k2**2*st**2*(4*C - 4)*(D1*(-11*b1**2*fd*r**2 + 11*b1*f*r*(-2*bd1*r + bd1 + 10*fd*r + fd) + f**2*(11*bd1*r*(5*r - 6) + 2*fd*(27*r**2 + 15*r - 8))) + Dd*f*(4*r - 1)*(-11*b1**2*r + 55*b1*f*r + 2*f**2*(9*r + 8)))/(231*d**2*k3**2) + 2*D1**3*Pk3*Pkdd1*ct**2*k2**2*st**2*(D1*(-429*b1*fd*k2**2*r**2*(b1*(K - 1) - 2*g2) - 6*f**3*k2**2*(13*bd1*r*(18*r - 35) + 15*fd*(4*r**2 + 63*r - 16)) - 13*f**2*(2*fd*(3*b1*k2**2*(54*r**2 - 15*r + 8) + k1**2*(19*C - 13)*(27*r**2 + 15*r - 8)) + 33*r*(2*bd1*k1**2*(19*C - 13)*(r - 1) + bd1*k2**2*(b1*(6 - 12*r) + r*(K - 1)) - 2*gd2*k2**2*r)) + 429*f*r*(12*b1**2*fd*k2**2*r + b1*(bd1*k2**2*(-2*K*r + K + 2*r - 1) + fd*k1**2*r*(52 - 76*C) + fd*k2**2*(-2*K*r + K + 2*r - 1) + 2*gd2*k2**2*r) + 2*g2*k2**2*(bd1*(r - 1) + fd*(2*r - 1)))) - Dd*f*(4*r - 1)*(429*b1*k2**2*r*(b1*(K - 1) - 2*g2) + 90*f**3*k2**2*(r + 16) + 26*f**2*(6*b1*k2**2*(9*r - 4) + k1**2*(19*C - 13)*(9*r + 8)) - 429*f*r*(6*b1**2*k2**2 + b1*k1**2*(26 - 38*C) - b1*k2**2*(K - 1) + 2*g2*k2**2)))/(9009*d**2*k3**4) - D1**3*Pk3*Pkdd1*ct**2*(8*C - 4)*(D1*bd1*f**2*r*(2*r - 1) + b1**2*r*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(2*r - 1)*(D1*bd1*r + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2) - 4*D1**3*Pk3*Pkdd1*ct**2*(33*b1**3*k2**2*r*(D1*fd*r + Dd*f*(4*r - 1)) - 33*b1**2*(D1*(bd1*f*k2**2*r*(1 - 3*r) + fd*k1**2*r**2*(2*C - 1) + fd*k2**2*(-2*K*r + K + f*(8*r**2 + 4*r - 1) + r**2 + 2*r - 1)) + Dd*f*(4*r - 1)*(k1**2*r*(2*C - 1) + k2**2*(-K + 4*f*r + f + r + 1))) - 3*b1*(D1*(f**2*k2**2*(44*bd1*r*(2*r - 1) + 25*fd*(1 - 3*r)**2) - 11*f*(bd1*k1**2*r*(C*(2 - 4*r) + 2*r - 1) + bd1*k2**2*r*(K - 2*r) + fd*k1**2*(2*C - 1)*(4*r - 1) + fd*k2**2*(1 - 2*r)**2*(K - 2) + k2**2*r*(bd2*r - 2*gd2)) - 11*fd*k2**2*(b2*r**2 + g2*(2 - 4*r))) + Dd*f*(4*r - 1)*(25*f**2*k2**2*(3*r - 1) - 11*f*(k1**2*(2*C - 1) + k2**2*(K - 2)*(2*r - 1)) + 11*k2**2*(-b2*r + 2*g2))) + f*(D1*(-75*bd1*f**2*k2**2*r*(3*r - 1) + f*(fd*k1**2*(1 - 3*r)**2*(50*C - 25) + 33*r*(bd1*k1**2*(1 - 2*C) + bd1*k2**2*(K - 2)*(2*r - 1) + k2**2*(bd2 - 2*gd2)*(2*r - 1))) + 33*k2**2*(b2*bd1*r*(r - 1) + b2*fd*(1 - 2*r)**2 - 2*fd*g2*(1 - 2*r)**2)) + Dd*f*(4*r - 1)*(f*k1**2*(50*C - 25)*(3*r - 1) + k2**2*(33*b2 - 66*g2)*(2*r - 1))))/(693*d**2*k3**2) - 4*D1**3*Pk3*Pkdd1*ct*f**2*k2**3*st**4*(3*r - 1)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k1*k3**2) - 4*D1**3*Pk3*Pkdd1*ct*f**2*k2**3*st**4*(D1*(195*bd1*f*k2**2*r*(r - 1) + fd*k1**2*(1 - 3*r)**2*(52*C - 39) + 5*fd*k2**2*(117*b1*r**2 + f*(56*r**2 - 2*r - 3))) + Dd*f*(4*r - 1)*(k1**2*(52*C - 39)*(3*r - 1) + 5*k2**2*(39*b1*r + f*(14*r + 3))))/(3003*d**2*k1*k3**4) - 4*D1**3*Pk3*Pkdd1*ct*k1**3*k2*(33*b1**2*r*(D1*fd*r*(-4*K + 4*f + 1) + Dd*f*(4*r - 1)*(-4*K + 2*f + 1)) + b1*(D1*(f**2*(66*bd1*r*(2*r - 1) + 25*fd*(1 - 3*r)**2) - 33*f*(fd*(1 - 2*r)**2*(4*K - 1) + r*(bd1*(4*K - 1)*(2*r - 1) - 8*gd2*r)) + 264*fd*g2*r**2) + Dd*f*(4*r - 1)*(25*f**2*(3*r - 1) - 33*f*(4*K - 1)*(2*r - 1) + 264*g2*r)) + f*(D1*(bd1*r*(25*f**2*(3*r - 1) - 33*f*(4*K - 1)*(2*r - 1) + 264*g2*(r - 1)) + 264*f*gd2*r*(2*r - 1) + 264*fd*g2*(1 - 2*r)**2) + 264*Dd*f*g2*(8*r**2 - 6*r + 1)))/(693*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*ct*k1*k2*(33*b1**3*r*(D1*fd*r + Dd*f*(4*r - 1)) - 33*b1**2*(D1*bd1*f*r*(1 - 3*r) - D1*fd*(-4*f*r + f + (2*K - 1)*(2*r - 1)) + Dd*f*(4*r - 1)*(-2*K + f + 1)) + b1*(D1*(-25*f**2*fd*(1 - 3*r)**2 + 33*f*(fd*(1 - 2*r)**2*(2*K - 1) + r*(2*K*bd1 - bd1 + 2*bd2*r - 4*gd2)) + 66*fd*(b2*r**2 + g2*(2 - 4*r))) - Dd*f*(4*r - 1)*(-66*b2*r + 25*f**2*(3*r - 1) - 33*f*(2*K - 1)*(2*r - 1) + 132*g2)) + f*(D1*f*r*(bd1*f*(25 - 75*r) + 33*bd1*(2*K - 1)*(2*r - 1) + (66*bd2 - 132*gd2)*(2*r - 1)) - 132*D1*fd*g2*(1 - 2*r)**2 - 132*Dd*f*g2*(8*r**2 - 6*r + 1) + 66*b2*(D1*bd1*r*(r - 1) + D1*fd*(1 - 2*r)**2 + Dd*f*(8*r**2 - 6*r + 1))))/(693*d**2*k3**2) + 2*D1**3*Pk3*Pkdd1*ct*k1*k2*st**2*(D1*(-429*b1*fd*k2**2*r**2*(b1*(2*K - 1) - 4*g2) - 9*f**3*k2**2*(-221*bd1*r + 5*fd*(4*r**2 + 63*r - 16)) - 13*f**2*(fd*(9*b1*k2**2*(8 - 15*r) + k1**2*(16*C - 9)*(27*r**2 + 15*r - 8)) - 33*r*(-bd1*k1**2*(16*C - 9)*(r - 1) + bd1*k2**2*(-2*K*r + 9*b1*(2*r - 1) + r) + 4*gd2*k2**2*r)) + 429*f*r*(18*b1**2*fd*k2**2*r + b1*(-bd1*k2**2*(2*K - 1)*(2*r - 1) - fd*(k1**2*r*(32*C - 18) + k2**2*(2*K - 1)*(2*r - 1)) + 4*gd2*k2**2*r) + 4*g2*k2**2*(bd1*(r - 1) + fd*(2*r - 1)))) - Dd*f*(4*r - 1)*(429*b1*k2**2*r*(b1*(2*K - 1) - 4*g2) + 45*f**3*k2**2*(r + 16) + 13*f**2*(-72*b1*k2**2 + k1**2*(16*C - 9)*(9*r + 8)) - 429*f*r*(9*b1**2*k2**2 + b1*k1**2*(9 - 16*C) + b1*k2**2*(1 - 2*K) + 4*g2*k2**2)))/(9009*d**2*k3**4) - 2*D1**3*Pk3*Pkdd1*ct*k2*r*st**2*(D1*bd1*f**2*r + b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2*k1) - 2*D1**3*Pk3*Pkdd1*ct*k2*st**2*(D1*(33*b1**2*fd*r**2*(k1**2*(4*C - 3) + k2**2) + 33*b1*f*r*(bd1*(2*r - 1)*(k1**2*(4*C - 3) + k2**2) + fd*(k1**2*(-4*C*(4*r + 1) + 8*r + 3) + k2**2*(r*(12*b1 + 2) - 1))) + 6*bd1*f**3*k2**2*r*(9*r + 8) + f**2*(33*bd1*r*(k1**2*(C*(12 - 8*r) + 4*r - 7) + k2**2*(6*b1*(2*r - 1) + r)) - fd*(-6*b1*k2**2 + k1**2*(12*C - 7))*(27*r**2 + 15*r - 8))) - Dd*f*(4*r - 1)*(-33*b1**2*r*(k1**2*(4*C - 3) + k2**2) - 33*b1*f*r*(k1**2*(4 - 8*C) + k2**2*(6*b1 + 1)) + f**2*(9*r + 8)*(-6*b1*k2**2 + k1**2*(12*C - 7))))/(693*d**2*k1*k3**2) + D1**3*Pk3*Pkdd1*f**2*k2**2*st**4*(8*C - 4)*(3*r - 1)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))/(231*d**2*k3**2) - 4*D1**3*Pk3*Pkdd1*f**2*k2**2*st**4*(D1*(26*bd1*f*k2**2*r*(3*r - 4) + fd*k1**2*(1 - 3*r)**2*(26*C - 13) + fd*k2**2*(13*b1*(18*r**2 + 6*r - 1) + 3*f*(56*r**2 - 2*r - 3))) + Dd*f*(4*r - 1)*(k1**2*(26*C - 13)*(3*r - 1) + k2**2*(78*b1*r + 13*b1 + 42*f*r + 9*f)))/(3003*d**2*k3**4) + 4*D1**3*Pk3*Pkdd1*k1**4*(D1*(b1*fd*r**2*(K*b1 - 2*g2) - f**2*r*(2*r - 1)*(-K*bd1 + 2*gd2) - f*fd*(1 - 2*r)**2*(-K*b1 + 2*g2) - f*r*(K*b1*bd1*(1 - 2*r) + 2*b1*gd2*r + 2*bd1*g2*(r - 1))) - Dd*f*(4*r - 1)*(-K*b1 + 2*g2)*(b1*r + f*(2*r - 1)))/(21*d**2*k3**4) - 4*D1**3*Pk3*Pkdd1*k1**2*(K*b1**2*(D1*fd*(2*r - 1) + Dd*f*(4*r - 1)) + b1*(D1*(f*r*(K*bd1 + bd2*r - 2*gd2) + fd*(2*r - 1)*(K*f*(2*r - 1) - 2*g2)) + Dd*f*(4*r - 1)*(K*f*(2*r - 1) - 2*g2)) + b2*(D1*(b1*fd*r**2 + bd1*f*r*(r - 1) + f*fd*(1 - 2*r)**2) + Dd*f*(4*r - 1)*(b1*r + f*(2*r - 1))) - f*(2*r - 1)*(-D1*f*r*(K*bd1 + bd2 - 2*gd2) + 2*D1*fd*g2*(2*r - 1) + 2*Dd*f*g2*(4*r - 1)))/(21*d**2*k3**2) + 2*D1**3*Pk3*Pkdd1*k1**2*st**2*(D1*(-429*b1*fd*k2**2*r**2*(K*b1 - 2*g2) + f**3*k2**2*(39*bd1*r*(6*r + 11) - 5*fd*(4*r**2 + 63*r - 16)) - 13*f**2*(fd*(-3*b1*k2**2*(18*r**2 + 15*r - 8) + k1**2*(2*C - 1)*(27*r**2 + 15*r - 8)) + 33*r*(bd1*k1**2*(2*C - 1)*(r - 1) + bd1*k2**2*(K*r + b1*(3 - 6*r)) - 2*gd2*k2**2*r)) + 429*f*r*(2*b1*gd2*k2**2*r + bd1*k2**2*(K*b1*(1 - 2*r) + 2*g2*(r - 1)) + fd*(K*b1*k2**2*(1 - 2*r) + 2*b1*r*(3*b1*k2**2 + k1**2*(1 - 2*C)) + 2*g2*k2**2*(2*r - 1)))) - Dd*f*(4*r - 1)*(429*b1*k2**2*r*(K*b1 - 2*g2) + 5*f**3*k2**2*(r + 16) + 13*f**2*(-6*b1*k2**2*(3*r + 4) + k1**2*(2*C - 1)*(9*r + 8)) - 429*f*r*(-K*b1*k2**2 + 3*b1**2*k2**2 + b1*k1**2*(1 - 2*C) + 2*g2*k2**2)))/(9009*d**2*k3**4) + D1**3*Pk3*Pkdd1*r*st**2*(4*C - 2)*(D1*bd1*f**2*r + b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(21*d**2) - 4*D1**3*Pk3*Pkdd1*(r - 1)*(D1*bd1*f*r*(b2 - 2*g2) + K*b1**2*(D1*fd*(r - 1) + Dd*f*(4*r - 1)) + b1*(D1*b2*fd*(r - 1) + D1*f*r*(2*K*bd1 + bd2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + Dd*b2*f*(4*r - 1) + 2*Dd*f*g2*(1 - 4*r)))/(21*d**2) - 2*D1**3*Pk3*Pkdd1*st**2*(D1*(-33*b1*fd*r**2*(K*b1*k2**2 + b1**2*k2**2 + b1*k1**2*(1 - 2*C) + k2**2*(b2 - 2*g2)) + 3*bd1*f**3*k2**2*r*(9*r + 8) + f**2*(-fd*(-3*b1*k2**2 + k1**2*(2*C - 1))*(27*r**2 + 15*r - 8) + 33*r*(bd1*k1**2*(2*C - 1) + bd1*k2**2*(-K*r + b1*(4*r - 3)) - k2**2*r*(bd2 - 2*gd2))) - 33*f*r*(b1**2*k2**2*(bd1*(3*r - 1) - fd*(4*r + 1)) - b1*(K*fd*k2**2*(1 - 2*r) + bd1*(2*r - 1)*(-K*k2**2 + k1**2*(2*C - 1)) + fd*k1**2*(1 - 2*C) - k2**2*r*(bd2 - 2*gd2)) + k2**2*(b2 - 2*g2)*(bd1*(r - 1) + fd*(2*r - 1)))) - Dd*f*(4*r - 1)*(33*b1*r*(K*b1*k2**2 + b1**2*k2**2 + b1*k1**2*(1 - 2*C) + k2**2*(b2 - 2*g2)) + f**2*(9*r + 8)*(-3*b1*k2**2 + k1**2*(2*C - 1)) - 33*f*k2**2*r*(-K*b1 + 2*b1**2 - b2 + 2*g2)))/(693*d**2*k3**2) - D1**3*Pkd1*Pkd3*ct**7*f*k2**5*(8*C - 8)*(33*D1*bd1*f*(8*r**2 + r*(8*s - 13) - 10*s + 5) + 33*b1*(8*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(32*r**2 + 8*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(36*r + 36*s - 13) + Dd*f*(144*r**2 + 144*r*s - 78*r - 31*s + 8)))/(693*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**6*f*k2**4*(33*D1*bd1*f*(8*r**2 + r*(8*s - 13) - 10*s + 5) + 33*b1*(8*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(32*r**2 + 8*r*(4*s - 3) - 10*s + 5)) + 5*f*(D1*fd*(3*r - 1)*(36*r + 36*s - 13) + Dd*f*(144*r**2 + 144*r*s - 78*r - 31*s + 8)))/(693*d**2*k1*k3**3) - 2*D1**3*Pkd1*Pkd3*ct**6*f*k2**4*(13*D1*bd1*f*(5*f*k2**2*(105*r**2 + r*(105*s - 184) - 135*s + 79) + 66*k1**2*(C*(44*r**2 + 44*r*s - 82*r - 64*s + 38) - 36*r**2 - 36*r*s + 69*r + 54*s - 33)) + 13*b1*(3*D1*fd*r*(5*f*k2**2*(105*r + 105*s - 59) + 176*k1**2*(C*(11*r + 11*s - 7) - 9*r - 9*s + 6)) + Dd*f*(5*f*k2**2*(420*r**2 + r*(420*s - 361) - 135*s + 79) + 66*k1**2*(2*C*(88*r**2 + 88*r*s - 78*r - 32*s + 19) - 144*r**2 - 144*r*s + 132*r + 54*s - 33))) + 10*f*(D1*fd*(14*f*k2**2*(4*r - 1)*(37*r + 37*s - 18) + 13*k1**2*(3*r - 1)*(2*C*(81*r + 81*s - 32) - 126*r - 126*s + 51)) + Dd*f*(14*f*k2**2*(4*r - 1)*(37*r + 37*s - 18) + 13*k1**2*(2*C*(324*r**2 + 324*r*s - 159*r - 56*s + 7) - 504*r**2 - 504*r*s + 240*r + 81*s - 6))))/(9009*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*ct**5*f*k2**5*st**2*(8*C - 8)*(33*D1*bd1*f*(14*r**2 + r*(14*s - 19) - 10*s + 5) + 33*b1*(14*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(56*r**2 + 56*r*s - 42*r - 10*s + 5)) + f*(D1*fd*(864*r**2 + r*(864*s - 633) - 156*s + 71) + Dd*f*(1152*r**2 + 36*r*(32*s - 21) - 116*s + 31)))/(693*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**5*k2**3*(66*b1**2*(C - 1)*(5*D1*fd*r*(r + s - 1) + Dd*f*(20*r**2 + r*(20*s - 27) - 6*s + 6)) + 66*b1*f*(D1*bd1*(C - 1)*(10*r**2 + r*(10*s - 17) - 6*s + 6) - 2*D1*fd*(C*(6*r**2 + 6*r*s - r + s - 1) - 5*r**2 - 5*r*s + 2*r - s + 1) + Dd*f*(-2*C*(12*r**2 + 12*r*s - 7*r - 5*s + 2) + 20*r**2 + 20*r*s - 17*r - 11*s + 6)) - f**2*(66*D1*bd1*(C*(6*r**2 + 6*r*s - 10*r - 11*s + 5) - 5*r**2 - 5*r*s + 11*r + 12*s - 7) + 5*D1*fd*(3*r - 1)*(C*(72*r + 72*s - 26) - 45*r - 45*s + 19) + 5*Dd*f*(2*C*(144*r**2 + 144*r*s - 78*r - 31*s + 8) - 180*r**2 - 180*r*s + 81*r + 25*s + 1)))/(693*d**2*k3**3) + 4*D1**3*Pkd1*Pkd3*ct**5*k2**3*(-13*D1*bd1*f*(5*f**2*k2**2*(42*r**2 + r*(42*s - 167) - 143*s + 97) + 33*f*(2*k1**2*(2*C*(7*r**2 + r*(7*s - 20) - 17*s + 13) - 7*r**2 + r*(26 - 7*s) + 23*s - 19) + k2**2*(-12*C*(r - 1)*(2*r + 2*s - 1) + 2*K*r**2 + 2*K*r*s + 4*K*r + K*s - K + b1*(-16*r**2 - 16*r*(s - 1) + 10*s - 5) + 22*r**2 + 22*r*s - 40*r - 25*s + 13)) + 66*k2**2*(b1*(K - 1)*(5*r**2 + r*(5*s - 2) - 3*s) + g2*(-5*r**2 - 5*r*(s - 1) + 6*s))) + 429*b1**2*k2**2*(D1*fd*r*(8*f*(2*r + 2*s - 1) + (5 - 5*K)*(r + s)) + Dd*f*(f*(32*r**2 + 8*r*(4*s - 3) - 10*s + 5) - (K - 1)*(20*r**2 + r*(20*s - 3) - 6*s))) - 13*b1*(D1*(5*f**2*fd*k2**2*(126*r**2 + 9*r*(14*s - 9) + 36*s - 13) + 66*f*(2*fd*k1**2*r*(2*C*(7*r + 7*s - 8) - 7*r - 7*s + 11) + fd*k2**2*(K*(2*r - 1)*(r + s + 1) + r**2*(22 - 24*C) + r*(-24*C*s + 12*C + 22*s - 13) + s + 1) - gd2*k2**2*r*(5*r + 5*s + 1)) - 330*fd*g2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(168*r**2 + 8*r*(21*s - 31) - 107*s + 84) + 66*f*(k1**2*(C*(56*r**2 + r*(56*s - 78) - 34*s + 26) - 28*r**2 + r*(51 - 28*s) + 23*s - 19) + k2**2*(-6*C*(4*r - 1)*(2*r + 2*s - 1) + K*(4*r**2 + 4*r*s + 5*r - 2) + 44*r**2 + 44*r*s - 41*r - 12*s + 8)) - 66*g2*k2**2*(20*r**2 + r*(20*s - 3) - 6*s))) + f*(D1*(-280*f**2*fd*k2**2*(4*r - 1)*(11*r + 11*s - 5) + 65*f*fd*(3*r - 1)*(k1**2*(C*(6*r + 6*s - 4) - 51*r - 51*s + 23) + k2**2*(66*C - 66)*(2*r + 2*s - 1)) + 858*f*gd2*k2**2*(2*r**2 + 2*r*(s + 2) + s - 1) + 1716*fd*g2*k2**2*(2*r - 1)*(r + s + 1)) + Dd*f*(-280*f**2*k2**2*(4*r - 1)*(11*r + 11*s - 5) + 65*f*(k1**2*(2*C*(12*r**2 + 3*r*(4*s - 37) - 53*s + 52) - 204*r**2 + r*(303 - 204*s) + 131*s - 103) + k2**2*(66*C - 66)*(4*r - 1)*(2*r + 2*s - 1)) + 1716*g2*k2**2*(4*r**2 + r*(4*s + 5) - 2))))/(9009*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**4*f*k2**4*st**2*(33*D1*bd1*f*(14*r**2 + r*(14*s - 19) - 10*s + 5) + 33*b1*(14*D1*fd*r*(2*r + 2*s - 1) + Dd*f*(56*r**2 + 56*r*s - 42*r - 10*s + 5)) + f*(D1*fd*(864*r**2 + r*(864*s - 633) - 156*s + 71) + Dd*f*(1152*r**2 + 36*r*(32*s - 21) - 116*s + 31)))/(693*d**2*k1*k3**3) - D1**3*Pkd1*Pkd3*ct**4*f*k2**4*st**2*(39*D1*bd1*f*(5*f*k2**2*(135*r**2 + 3*r*(45*s - 71) - 128*s + 78) + 44*k1**2*(C*(98*r**2 + 98*r*s - 133*r - 67*s + 35) - 84*r**2 - 84*r*s + 114*r + 57*s - 30)) + 39*b1*(D1*fd*r*(5*f*k2**2*(405*r + 405*s - 248) + 44*k1**2*(196*C*r + 196*C*s - 101*C - 168*r - 168*s + 87)) + Dd*f*(5*f*k2**2*(540*r**2 + r*(540*s - 461) - 128*s + 78) + 44*k1**2*(C*(392*r**2 + 4*r*(98*s - 75) - 67*s + 35) - 336*r**2 - 336*r*s + 258*r + 57*s - 30))) + f*(D1*fd*(25*f*k2**2*(2908*r**2 + r*(2908*s - 2193) - 402*s + 204) + 52*k1**2*(C*(5616*r**2 + 6*r*(936*s - 683) - 849*s + 401) - 4752*r**2 - 99*r*(48*s - 35) + 693*s - 330)) + Dd*f*(25*f*k2**2*(2908*r**2 + r*(2908*s - 2193) - 402*s + 204) + 52*k1**2*(C*(7488*r**2 + 234*r*(32*s - 21) - 545*s + 97) - 6336*r**2 - 198*r*(32*s - 21) + 429*s - 66))))/(9009*d**2*k1*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**4*k2**2*(D1*bd1*f**2*(2*r**2 + r*(2*s - 3) + s) + b1**2*(5*D1*fd*r*(r + s - 1) + Dd*f*(20*r**2 + r*(20*s - 27) - 6*s + 6)) + b1*f*(D1*bd1*(10*r**2 + r*(10*s - 17) - 6*s + 6) + 2*D1*fd*(2*r - 1)*(r + s - 1) + Dd*f*(8*r**2 + 8*r*s - 10*r + 1)))/(21*d**2*k1*k3) - 4*D1**3*Pkd1*Pkd3*ct**4*k2**2*(33*b1**2*(D1*fd*r*(k1**2*(16*C - 11)*(r + s - 1) + k2**2*(4*f*(5*r + 5*s - 3) + 5*r + 5*s)) + Dd*f*(k1**2*(C*(64*r**2 + 64*r*s - 92*r - 22*s + 22) - 44*r**2 - 44*r*s + 65*r + 16*s - 16) + k2**2*(f*(40*r**2 + 40*r*s - 38*r - 14*s + 9) + 20*r**2 + 20*r*s - 3*r - 6*s))) + b1*f*(33*D1*bd1*(k1**2*(C*(32*r**2 + 32*r*s - 60*r - 22*s + 22) - 22*r**2 - 22*r*s + 43*r + 16*s - 16) + k2**2*(f*(20*r**2 + 20*r*s - 26*r - 14*s + 9) + 10*r**2 + 10*r*s - 4*r - 6*s)) - D1*fd*(66*k1**2*(r**2*(12*C - 2) + r*(12*C*(s - 1) - 2*s + 9) + s - 1) + k2**2*(-5*f*(3*r - 1)*(39*r + 39*s - 16) + 660*r**2 + 660*r*s - 462*r + 66*s + 66)) + Dd*f*(-33*k1**2*(12*C*(4*r**2 + 4*r*s - 5*r - 3*s + 2) - 8*r**2 - 8*r*s + 34*r + 24*s - 19) + k2**2*(5*f*(156*r**2 + 156*r*s - 103*r - 29*s + 11) - 1320*r**2 - 1320*r*s + 1518*r + 396*s - 330))) + f**2*(D1*bd1*(-33*k1**2*(6*C*(2*r**2 + 2*r*(s - 2) - 5*s + 3) - 2*r**2 - 2*r*s + 9*r + 17*s - 12) + k2**2*(5*f*(39*r**2 + 39*r*s - 16*r + 10*s - 5) - 330*r**2 - 330*r*s + 726*r + 429*s - 231)) - 15*D1*fd*(3*r - 1)*(k1**2*(C*(6*r + 6*s - 4) + 16*r + 16*s - 7) + 11*k2**2*(2*r + 2*s - 1)) - 15*Dd*f*(k1**2*(C*(24*r**2 + r*(24*s - 2) + 4*s - 6) + 64*r**2 + 64*r*(s - 1) - 26*s + 17) + 11*k2**2*(4*r - 1)*(2*r + 2*s - 1))))/(693*d**2*k1*k3**3) + 2*D1**3*Pkd1*Pkd3*ct**4*k2**2*(13*D1*bd1*f*(5*f**2*k2**2*(k1**2*(120*r**2 + 3*r*(40*s + 41) + 157*s - 151) + 33*k2**2*(r - 1)*(5*r + 5*s - 3)) + 66*f*k1**2*(4*k1**2*(C*(5*r**2 + r*(5*s + 2) + 5*s - 7) - 5*r**2 - 5*r*s + r - 2*s + 4) + k2**2*(12*C*(r - 1)*(7*r + 7*s - 4) + 2*K*r**2 + 2*K*r*s - 20*K*r - 5*K*s + 5*K + b1*(22*r**2 + r*(22*s - 25) - 19*s + 11) - 76*r**2 - 76*r*s + 130*r + 76*s - 46)) - 132*k1**2*k2**2*(b1*(K*r*(11*s - 3) + r**2*(11*K - 6) - 6*r*s + r + s*(5 - 8*K)) + g2*(-11*r**2 - 11*r*(s - 1) + 16*s))) + 858*b1**2*k1**2*k2**2*(D1*fd*r*(2*f*(11*r + 11*s - 7) - (11*K - 6)*(r + s)) + Dd*f*(f*(44*r**2 + r*(44*s - 39) - 19*s + 11) + r**2*(24 - 44*K) + r*(-44*K*s + K + 24*s + 2) + s*(16*K - 10))) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(360*r**2 + 9*r*(40*s - 11) - 57*s + 5) + 99*k2**2*r*(5*r + 5*s - 3)) + 132*f*k1**2*(2*fd*k1**2*r*(2*C*(5*r + 5*s + 2) - 10*r - 10*s - 1) + fd*k2**2*(K*(2*r - 1)*(r + s - 5) + 2*r**2*(42*C - 38) + 2*r*(6*C*(7*s - 4) - 38*s + 26) + 2*s - 4) + gd2*k2**2*r*(11*r + 11*s + 5)) + 1452*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(5*f**2*k2**2*(2*k1**2*(240*r**2 + 12*r*(20*s + 1) + 50*s - 73) + 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 132*f*k1**2*(2*k1**2*(C*(20*r**2 + r*(20*s + 3) + 5*s - 7) - 20*r**2 + r*(3 - 20*s) - 2*s + 4) + k2**2*(6*C*(4*r - 1)*(7*r + 7*s - 4) + K*(4*r**2 + 4*r*s - 31*r - 6*s + 10) - 152*r**2 - 152*r*s + 146*r + 42*s - 29)) + 132*g2*k1**2*k2**2*(44*r**2 + r*(44*s - 1) - 16*s))) + 2*f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(k1**2*(51*r + 51*s - 35) + 13*k2**2*(5*r + 5*s - 3)) + 13*f*k1**2*(5*fd*(3*r - 1)*(k1**2*(2*C*(135*r + 135*s - 68) - 222*r - 222*s + 115) + 33*k2**2*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 66*gd2*k2**2*(2*r**2 + 2*r*(s - 10) - 5*s + 5)) - 1716*fd*g2*k1**2*k2**2*(2*r - 1)*(r + s - 5)) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(k1**2*(51*r + 51*s - 35) + 13*k2**2*(5*r + 5*s - 3)) + 65*f*k1**2*(k1**2*(2*C*(540*r**2 + 540*r*s - 507*r - 185*s + 118) - 888*r**2 - 888*r*s + 822*r + 292*s - 185) + 33*k2**2*(4*r - 1)*(2*C*(7*r + 7*s - 4) - 12*r - 12*s + 7)) - 1716*g2*k1**2*k2**2*(4*r**2 + r*(4*s - 31) - 6*s + 10))))/(9009*d**2*k1*k3**5) - D1**3*Pkd1*Pkd3*ct**3*f*k2**5*st**4*(8*C - 8)*(2*D1*(33*b1*fd*r*(2*r + 2*s - 1) + 33*bd1*f*r*(r + s - 1) + 5*f*fd*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(66*b1*r*(4*r + 4*s - 3) + 5*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)))/(231*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**3*k2**3*st**2*(66*b1**2*(C - 1)*(13*D1*fd*r*(r + s - 1) + Dd*f*(52*r**2 + r*(52*s - 45) - 3*s + 3)) + 33*b1*f*(2*D1*bd1*(C - 1)*(26*r**2 + r*(26*s - 19) - 3*s + 3) + D1*fd*(-2*C*(42*r**2 + 42*r*s - 9*r + 5*s - 5) + 112*r**2 + 7*r*(16*s - 5) + 10*s - 10) + Dd*f*(-2*C*(84*r**2 + r*(84*s - 53) - 15*s + 5) + 224*r**2 + 14*r*(16*s - 11) - 37*s + 15)) + f**2*(-33*D1*bd1*(C*(42*r**2 + 6*r*(7*s - 11) - 40*s + 20) - 56*r**2 + r*(85 - 56*s) + 47*s - 25) + D1*fd*(-4*C*(864*r**2 + r*(864*s - 633) - 156*s + 71) + 3888*r**2 + 48*r*(81*s - 59) - 537*s + 259) + Dd*f*(-4*C*(1152*r**2 + 36*r*(32*s - 21) - 116*s + 31) + 5184*r**2 + 162*r*(32*s - 21) - 313*s + 35)))/(693*d**2*k3**3) + 2*D1**3*Pkd1*Pkd3*ct**3*k2**3*st**2*(-13*D1*bd1*f*(2*f**2*k2**2*(666*r**2 + 2*r*(333*s - 701) - 913*s + 611) + 33*f*(k1**2*(2*C*(131*r**2 + r*(131*s - 178) - 85*s + 47) - 192*r**2 - 3*r*(64*s - 87) + 123*s - 69) + k2**2*(-6*C*(r - 1)*(2*r + 2*s - 1) + 7*K*r**2 + 7*K*r*s - 4*K*r - 2*b1*(28*r**2 + 28*r*(s - 1) - 10*s + 5) + 5*r**2 + 5*r*s - 14*r - 12*s + 6)) + 33*k2**2*(b1*(K - 1)*(26*r**2 + r*(26*s - 23) - 3*s) + 2*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k2**2*(D1*fd*r*(28*f*(2*r + 2*s - 1) + (13 - 13*K)*(r + s)) + Dd*f*(2*f*(56*r**2 + 56*r*s - 42*r - 10*s + 5) - (K - 1)*(52*r**2 + 52*r*s - 33*r - 3*s))) - 13*b1*(D1*(2*f**2*fd*k2**2*(1998*r**2 + 54*r*(37*s - 23) + 156*s - 71) + 33*f*(fd*k1**2*r*(4*C*(131*r + 131*s - 70) - 384*r - 384*s + 207) + fd*k2**2*(K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(10 - 24*C) + r*(-24*C*s + 12*C + 10*s - 1) + 5*s - 2) - 2*gd2*k2**2*r*(13*r + 13*s - 10)) - 858*fd*g2*k2**2*r*(r + s)) + Dd*f*(2*f**2*k2**2*(2664*r**2 + 4*r*(666*s - 661) - 757*s + 540) + 33*f*(k1**2*(2*C*(524*r**2 + r*(524*s - 411) - 85*s + 47) - 768*r**2 + r*(606 - 768*s) + 123*s - 69) + k2**2*(-6*C*(4*r - 1)*(2*r + 2*s - 1) + K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 20*r**2 + 20*r*s - 17*r - 7*s + 4)) - 66*g2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(-50*f**2*fd*k2**2*(1280*r**2 + 2*r*(640*s - 471) - 99*s + 45) - 13*f*(fd*k1**2*(22*C*(621*r**2 + 9*r*(69*s - 50) - 69*s + 35) - 9774*r**2 + r*(7068 - 9774*s) + 981*s - 511) + fd*k2**2*(198 - 198*C)*(3*r - 1)*(2*r + 2*s - 1) - 66*gd2*k2**2*r*(7*r + 7*s - 4)) + 858*fd*g2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(-50*f**2*k2**2*(1280*r**2 + 2*r*(640*s - 471) - 99*s + 45) - 13*f*(k1**2*(22*C*(828*r**2 + r*(828*s - 543) - 29*s - 5) - 13032*r**2 - 13032*r*s + 8544*r + 325*s + 145) + k2**2*(198 - 198*C)*(4*r - 1)*(2*r + 2*s - 1)) + 858*g2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**5) + 4*D1**3*Pkd1*Pkd3*ct**3*k2*(2*D1*bd1*f**2*(C*(2*r**2 + r*(2*s - 3) + s) + r**2 + r*s - s) + b1**2*(D1*fd*r*(10*C - 3)*(r + s - 1) + Dd*f*(2*C*(20*r**2 + 20*r*s - 27*r - 6*s + 6) - 12*r**2 - 12*r*s + 19*r + 5*s - 5)) + b1*f*(D1*bd1*(2*C*(10*r**2 + r*(10*s - 17) - 6*s + 6) - 6*r**2 - 6*r*s + 13*r + 5*s - 5) + 2*D1*fd*(2*C + 1)*(2*r - 1)*(r + s - 1) + 2*Dd*f*(8*C*r**2 + 2*C*r*(4*s - 5) + C + 4*r**2 + r*(4*s - 5) - 3*s + 2)))/(21*d**2*k3) + 4*D1**3*Pkd1*Pkd3*ct**3*k2*(33*b1**3*k2**2*(5*D1*fd*r*(r + s - 1) + Dd*f*(20*r**2 + r*(20*s - 27) - 6*s + 6)) + 33*b1**2*(D1*bd1*f*k2**2*(15*r**2 + r*(15*s - 22) - 6*s + 6) + D1*fd*(-k1**2*r*(2*C + 1)*(r + s - 1) + k2**2*(14*C*r**2 + 14*C*r*s - 14*C*r + K*(7*r**2 + 7*r*s - 4*r - 2*s + 2) + 2*f*(4*r - 1)*(r + s - 1) - 17*r**2 - 17*r*s + 18*r + 2*s - 2)) - Dd*f*k1**2*(C*(8*r**2 + r*(8*s - 22) - 8*s + 8) + 4*r**2 + 4*r*s + 3*r + 3*s - 3) + Dd*f*k2**2*(14*C*(4*r - 1)*(r + s - 1) + 28*K*r**2 + 28*K*r*s - 15*K*r - 11*K*s + 4*K + 4*f*(4*r**2 + 4*r*s - 3*r + 2*s - 1) - 68*r**2 - 68*r*s + 77*r + 23*s - 18)) + b1*(33*D1*bd1*f*(-k1**2*(2*C*(2*r**2 + r*(2*s - 9) - 4*s + 4) + 2*r**2 + 2*r*s + 5*r + 3*s - 3) + k2**2*(14*C*(2*r - 1)*(r + s - 1) + 14*K*r**2 + 14*K*r*s - 9*K*r - 8*K*s + K + 2*f*(4*r**2 + 4*r*s - r + 5*s - 3) - 34*r**2 - 34*r*s + 45*r + 20*s - 15)) + 3*D1*(5*f**2*fd*k2**2*(3*r - 1)*(17*r + 17*s - 18) - 11*f*(2*fd*(k1**2*(6*C*(3*r + s - 1) - 13*r - 5*s + 5) + k2**2*(6*C*(2*r**2 + 2*r*s + r + s - 1) - K*(2*r - 1)*(r + s + 1) - 24*r**2 - 24*r*s + 9*r - 3*s + 3)) + k2**2*(-bd2*r*(5*r + 5*s + 1) + 2*gd2*(7*r**2 + r*(7*s - 2) - s + 1))) + 11*fd*k2**2*(5*b2*r*(r + s) - 2*g2*(7*r**2 + r*(7*s - 4) - 2*s + 2))) + Dd*f*(5*f**2*k2**2*(204*r**2 + r*(204*s - 277) - 76*s + 69) - 66*f*(k1**2*(12*C - 8)*(2*r + s - 1) - k2**2*(6*C*s + K*(4*r**2 + r*(4*s + 5) - 2) - 3*r**2*(8*C - 16) - 6*r*(4*C*s - C - 8*s + 7) - 15*s + 9)) + 33*k2**2*(b2*(20*r**2 + 20*r*s - 3*r - 6*s) + g2*(-56*r**2 - 56*r*s + 30*r + 22*s - 8)))) + f*(D1*bd1*(5*f**2*k2**2*(51*r**2 + r*(51*s - 64) - 25*s + 15) - 33*f*(2*k1**2*(3*C*(s - 1) + r - s + 1) + k2**2*(12*C*(r**2 + r*(s - 2) - 2*s + 1) - K*(2*r**2 + 2*r*(s + 2) + s - 1) - 24*r**2 - 24*r*(s - 2) + 33*s - 21)) + 33*k2**2*(b2*(5*r**2 + 5*r*(s - 1) - 6*s) - 14*g2*(r - 1)*(r + s))) + D1*(-5*f*fd*(3*r - 1)*(k1**2*(6*C*(19*r + 19*s - 9) - 87*r - 87*s + 47) + 33*k2**2*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3)) + 33*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + 2*r*(s + 2) + s - 1) + 66*fd*k2**2*(b2 - 2*g2)*(2*r - 1)*(r + s + 1)) + Dd*f*(-5*f*(k1**2*(6*C*(76*r**2 + 76*r*s - 65*r - 24*s + 14) - 348*r**2 - 348*r*s + 315*r + 107*s - 67) + 33*k2**2*(4*r - 1)*(C*(4*r + 4*s - 2) - 5*r - 5*s + 3)) + k2**2*(66*b2 - 132*g2)*(4*r**2 + r*(4*s + 5) - 2))))/(693*d**2*k3**3) - 4*D1**3*Pkd1*Pkd3*ct**3*k2*(-13*D1*bd1*f*(66*C*f*k1**2*(k1**2*(14*r**2 + r*(14*s - 13) - 4*s - 1) + 18*k2**2*(r - 1)*(3*r + 3*s - 2)) + 5*f**2*k2**2*(k1**2*(6*r**2 + r*(6*s + 20) + 3*s - 23) + 33*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 66*f*(k1**4*(9*r**2 + 9*r*(s - 1) - 3*s) + k1**2*k2**2*(K*(-11*r**2 - 11*r*s + 20*r + 5*s - 5) + 3*b1*(2*r + 1)*(r + s - 1) + 48*r**2 + 48*r*s - 78*r - 42*s + 30) + 3*k2**4*(b1*(2*r - 1)*(2*r + 2*s - 1) - r*(K - 1)*(r + s))) - 33*k2**2*(b1*k1**2*(-11*K*s + r**2*(2*K + 10) + r*(K*(2*s + 9) + 10*s - 11) + s) - 7*b1*k2**2*(K - 1)*(r + s)*(2*r - 1) - 2*g2*k1**2*(r**2 + r*(s - 1) - 11*s) + 14*g2*k2**2*(r - 1)*(r + s))) + 429*b1**2*k2**2*(D1*fd*r*(12*f*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + (r + s)*(k1**2*(K + 5) - k2**2*(7*K - 7))) + Dd*f*(6*f*(k1**2*(4*r**2 + r*(4*s - 1) + s - 1) + k2**2*(4*r - 1)*(2*r + 2*s - 1)) + k1**2*(-11*K*s + r**2*(4*K + 20) + r*(K*(4*s + 19) + 20*s - 17) + s) + k2**2*(7 - 7*K)*(r + s)*(4*r - 1))) - 13*b1*(66*C*f*k1**2*(4*D1*fd*r*(k1**2*(7*r + 7*s - 2) + 9*k2**2*(3*r + 3*s - 2)) + Dd*f*(k1**2*(56*r**2 + 56*r*s - 30*r - 4*s - 1) + 18*k2**2*(4*r - 1)*(3*r + 3*s - 2))) + 3*D1*(5*f**2*fd*k2**2*(k1**2*(6*r**2 + 6*r*s + 34*r + 27*s - 18) + 11*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) - 22*f*(fd*(6*k1**4*r*(3*r + 3*s - 1) + k1**2*k2**2*(-K*(2*r - 1)*(11*r + 11*s - 10) + 96*r**2 + r*(96*s - 75) - 9*s + 6) + k2**4*(3 - 3*K)*(r + s)*(2*r - 1)) + gd2*k2**2*r*(-k1**2*(r + s + 10) + 7*k2**2*(r + s))) + 22*fd*g2*k2**2*r*(k1**2 - 7*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(k1**2*(24*r**2 + 2*r*(12*s + 61) + 84*s - 77) + 33*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 66*f*(3*k1**4*(12*r**2 + r*(12*s - 7) - s) + k1**2*k2**2*(K*(-44*r**2 + r*(71 - 44*s) + 21*s - 20) + 192*r**2 + 192*r*(s - 1) - 54*s + 39) + k2**4*(3 - 3*K)*(r + s)*(4*r - 1)) + 66*g2*k2**2*(k1**2*(4*r**2 + r*(4*s + 19) - 11*s) - 7*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-140*f**2*fd*k2**2*(4*r - 1)*(k1**2*(43*r + 43*s - 29) + 26*k2**2*(3*r + 3*s - 2)) - 65*f*fd*k1**2*(3*r - 1)*(k1**2*(2*C*(117*r + 117*s - 67) - 147*r - 147*s + 87) + 33*k2**2*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 1716*f*gd2*k2**2*(k1**2*(11*r**2 + r*(11*s - 20) - 5*s + 5) + 3*k2**2*r*(r + s)) + 1716*fd*g2*k2**2*(2*r - 1)*(k1**2*(11*r + 11*s - 10) + 3*k2**2*(r + s))) + Dd*f*(-140*f**2*k2**2*(4*r - 1)*(k1**2*(43*r + 43*s - 29) + 26*k2**2*(3*r + 3*s - 2)) - 65*f*k1**2*(k1**2*(2*C*(468*r**2 + 468*r*s - 435*r - 142*s + 92) - 588*r**2 - 588*r*s + 555*r + 177*s - 117) + 33*k2**2*(4*r - 1)*(6*C*(3*r + 3*s - 2) - 13*r - 13*s + 9)) + 1716*g2*k2**2*(k1**2*(44*r**2 + r*(44*s - 71) - 21*s + 20) + 3*k2**2*(r + s)*(4*r - 1)))))/(9009*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct**2*f*k2**4*st**4*(2*D1*(33*b1*fd*r*(2*r + 2*s - 1) + 33*bd1*f*r*(r + s - 1) + 5*f*fd*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(66*b1*r*(4*r + 4*s - 3) + 5*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)))/(231*d**2*k1*k3**3) - 2*D1**3*Pkd1*Pkd3*ct**2*f*k2**4*st**4*(D1*(1716*b1*fd*k1**2*r*(5*C - 4)*(2*r + 2*s - 1) + 5*f**2*k2**2*(78*bd1*(6*r**2 + r*(6*s - 8) - 3*s + 2) + fd*(1036*r**2 + r*(1036*s - 867) - 129*s + 87)) + 52*f*(33*bd1*k1**2*r*(5*C - 4)*(r + s - 1) + fd*(45*b1*k2**2*r + k1**2*(26*C - 21)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(1716*b1*k1**2*r*(5*C - 4)*(4*r + 4*s - 3) + 5*f**2*k2**2*(1036*r**2 + r*(1036*s - 867) - 129*s + 87) + 26*f*(15*b1*k2**2*(24*r**2 + 4*r*(6*s - 5) - 3*s + 2) + k1**2*(26*C - 21)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k1*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**2*k1*(13*D1*bd1*f*(5*f**2*k2**2*(k1**2*(147*r**2 + 147*r*s - 127*r - 10*s + 20) + 33*k2**2*(11*r + 9*s - 7)) - 66*f*(k1**4*(2*C - 1)*(4*r**2 + r*(4*s - 5) - 2*s + 1) - k1**2*k2**2*(-12*C*(r - 1)*(5*r + 5*s - 4) - 2*K*(17*r**2 + r*(17*s - 20) - 5*s + 5) + 26*b1*r**2 + b1*r*(26*s - 23) - 5*b1*s + b1 + 52*r**2 + 52*r*s - 82*r - 40*s + 34) - 3*k2**4*(b1*(2*r - 1)*(9*r + 9*s - 5) + r*(4 - 6*K)*(r + s))) - 66*k2**2*(b1*k1**2*(r**2*(26*K - 16) + r*(K*(26*s - 23) - 16*s + 12) + s*(4 - 3*K)) + 7*b1*k2**2*(3*K - 2)*(r + s)*(2*r - 1) + 2*g2*k1**2*(-13*r**2 - 13*r*(s - 1) + 3*s) - 42*g2*k2**2*(r - 1)*(r + s))) + 858*b1**2*k2**2*(D1*fd*r*(2*f*(k1**2*(13*r + 13*s - 5) + 3*k2**2*(9*r + 9*s - 5)) - (r + s)*(k1**2*(13*K - 8) + k2**2*(21*K - 14))) + Dd*f*(f*(k1**2*(52*r**2 + 52*r*s - 33*r - 5*s + 1) + 3*k2**2*(4*r - 1)*(9*r + 9*s - 5)) + k1**2*(r**2*(32 - 52*K) + r*(-52*K*s + 33*K + 32*s - 16) + s*(3*K - 4)) + k2**2*(14 - 21*K)*(r + s)*(4*r - 1))) + 13*b1*(D1*(5*f**2*fd*k2**2*(k1**2*(441*r**2 + 9*r*(49*s - 52) - 207*s + 127) - 33*k2**2*(3*r + 9*s - 5)) - 132*f*(fd*(k1**4*r*(4*C - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(K*(2*r - 1)*(17*r + 17*s - 10) + r**2*(60*C - 52) + r*(60*C*s - 48*C - 52*s + 46) + 8*s - 4) + k2**4*(9*K - 6)*(r + s)*(2*r - 1)) - gd2*k2**2*r*(k1**2*(13*r + 13*s - 10) + 21*k2**2*(r + s))) + 132*fd*g2*k2**2*r*(13*k1**2 + 21*k2**2)*(r + s)) + Dd*f*(5*f**2*k2**2*(7*k1**2*(84*r**2 + r*(84*s - 85) - 31*s + 21) + 66*k2**2*(4*r - 1)) - 66*f*(k1**4*(2*C - 1)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 2*k1**2*k2**2*(6*C*(4*r - 1)*(5*r + 5*s - 4) + K*(68*r**2 + 68*r*s - 77*r - 27*s + 20) - 104*r**2 - 104*r*s + 110*r + 30*s - 23) + k2**4*(18*K - 12)*(r + s)*(4*r - 1)) + 132*g2*k2**2*(k1**2*(52*r**2 + r*(52*s - 33) - 3*s) + 21*k2**2*(r + s)*(4*r - 1)))) - 2*f*(D1*(70*f**2*fd*k2**2*(4*r - 1)*(7*k1**2*(4*r + 4*s - 3) + 13*k2**2*(9*r + 9*s - 7)) + 13*f*(5*fd*k1**2*(3*r - 1)*(k1**2*(20*C - 10)*(3*r + 3*s - 2) + 33*k2**2*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 132*gd2*k2**2*(k1**2*(17*r**2 + r*(17*s - 20) - 5*s + 5) + 9*k2**2*r*(r + s))) - 1716*fd*g2*k2**2*(2*r - 1)*(k1**2*(17*r + 17*s - 10) + 9*k2**2*(r + s))) + Dd*f*(70*f**2*k2**2*(4*r - 1)*(7*k1**2*(4*r + 4*s - 3) + 13*k2**2*(9*r + 9*s - 7)) + 65*f*k1**2*(k1**2*(10*C - 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(2*C*(5*r + 5*s - 4) - 6*r - 6*s + 5)) - 1716*g2*k2**2*(k1**2*(68*r**2 + r*(68*s - 77) - 27*s + 20) + 9*k2**2*(r + s)*(4*r - 1)))))/(9009*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(D1*bd1*f**2*r*(7*r + 7*s - 5) + b1**2*(13*D1*fd*r*(r + s - 1) + Dd*f*(52*r**2 + r*(52*s - 45) - 3*s + 3)) + b1*f*(D1*bd1*(26*r**2 + r*(26*s - 19) - 3*s + 3) + D1*fd*(14*r - 5)*(r + s - 1) + Dd*f*(28*r**2 + 28*r*s - 31*r - 5*s + 5)))/(21*d**2*k1*k3) - D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(11*b1**2*(D1*fd*r*(k1**2*(112*C - 86)*(r + s - 1) + k2**2*(3*f*(40*r + 40*s - 29) + 26*r + 26*s)) + 2*Dd*f*(k1**2*(14*C*(16*r**2 + 2*r*(8*s - 7) - s + 1) - 172*r**2 - 172*r*s + 151*r + 11*s - 11) + k2**2*(3*f*(40*r**2 + 40*r*s - 36*r - 7*s + 5) + 52*r**2 + 52*r*s - 33*r - 3*s))) + b1*f*(11*D1*bd1*(2*k1**2*(14*C*(8*r**2 + 8*r*s - 6*r - s + 1) - 86*r**2 - 86*r*s + 65*r + 11*s - 11) + k2**2*(3*f*(40*r**2 + 40*r*s - 43*r - 14*s + 10) + 52*r**2 + 52*r*s - 46*r - 6*s)) + D1*fd*(-22*k1**2*(2*C*(52*r**2 + 52*r*s - 2*r + 11*s - 11) - 72*r**2 - 72*r*s - 17*s + 17) + k2**2*(f*(1224*r**2 + 3*r*(408*s - 377) - 210*s + 142) + 44*r**2 + 22*r*(2*s - 5) - 110*s + 44)) + 2*Dd*f*(-11*k1**2*(4*C*(52*r**2 + 52*r*s - 31*r - 8*s + 2) - 144*r**2 - 144*r*s + 86*r + 21*s - 5) + k2**2*(f*(816*r**2 + 816*r*s - 686*r - 73*s + 55) + 44*r**2 + 44*r*s - 11*r + 11*s - 11))) + f**2*(D1*bd1*(-44*k1**2*(C*(26*r**2 + 26*r*s - 46*r - 27*s + 15) - 18*r**2 - 18*r*s + 33*r + 19*s - 11) + k2**2*(f*(408*r**2 + r*(408*s - 241) + 64*s - 32) + 22*r**2 + 22*r*(s + 5) + 132*s - 66)) - 2*D1*fd*(k1**2*(6*C*(240*r**2 + 6*r*(40*s - 29) - 25*s + 13) - 981*r**2 - 981*r*s + 706*r + 74*s - 42) + 33*k2**2*(3*r - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(k1**2*(6*C*(320*r**2 + 320*r*s - 210*r - 9*s - 3) - 1308*r**2 - 1308*r*s + 857*r + 2*s + 30) + 33*k2**2*(4*r - 1)*(2*r + 2*s - 1))))/(231*d**2*k1*k3**3) + D1**3*Pkd1*Pkd3*ct**2*k2**2*st**2*(-39*D1*bd1*f*(f**2*k2**2*(k1**2*(144*r**2 + 3*r*(48*s - 349) - 839*s + 635) - 66*k2**2*(r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(2*k1**2*(4*C*(41*r**2 + r*(41*s - 56) - 25*s + 15) - 103*r**2 + r*(141 - 103*s) + 62*s - 38) + k2**2*(-4*C*(r - 1)*(15*r + 15*s - 8) + 42*K*r**2 + 42*K*r*s - 24*K*r - 3*b1*(76*r**2 + r*(76*s - 77) - 25*s + 13) + 20*r**2 + 20*r*s - 58*r - 48*s + 26)) + 22*k1**2*k2**2*(b1*(3*K - 2)*(26*r**2 + r*(26*s - 23) - 3*s) + 6*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k1**2*k2**2*(D1*fd*r*(3*f*(76*r + 76*s - 39) + (52 - 78*K)*(r + s)) + Dd*f*(f*(456*r**2 + 456*r*s - 348*r - 75*s + 39) + (4 - 6*K)*(52*r**2 + 52*r*s - 33*r - 3*s))) - 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(432*r**2 + 432*r*s - 297*r + 255*s - 115) - 198*k2**2*r*(5*r + 5*s - 3)) + 22*f*k1**2*(fd*k1**2*r*(8*C*(41*r + 41*s - 23) - 206*r - 206*s + 117) + fd*k2**2*(3*K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(20 - 60*C) - 4*r*(15*C*s - 8*C - 5*s + 1) + 10*s - 4) - 6*gd2*k2**2*r*(13*r + 13*s - 10)) - 1716*fd*g2*k1**2*k2**2*r*(r + s)) + 2*Dd*f*(f**2*k2**2*(4*k1**2*(72*r**2 + 24*r*(3*s - 7) - 73*s + 65) - 33*k2**2*(4*r - 1)*(5*r + 5*s - 3)) + 11*f*k1**2*(k1**2*(4*C*(164*r**2 + r*(164*s - 133) - 25*s + 15) - 412*r**2 + r*(337 - 412*s) + 62*s - 38) + k2**2*(-2*C*(4*r - 1)*(15*r + 15*s - 8) + 3*K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 40*r**2 + 40*r*s - 38*r - 14*s + 9)) - 66*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(15*f**2*fd*k2**2*(-3*k1**2*(1624*r**2 + 8*r*(203*s - 138) + 49*s - 53) + 130*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(fd*k1**2*(8*C*(315*r - 17)*(3*r + 3*s - 2) - 4617*r**2 - 4617*r*s + 3330*r + 186*s - 146) - 33*fd*k2**2*(3*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13) - 198*gd2*k2**2*r*(7*r + 7*s - 4)) + 5148*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(15*f**2*k2**2*(-3*k1**2*(1624*r**2 + 8*r*(203*s - 138) + 49*s - 53) + 130*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(k1**2*(8*C*(1260*r**2 + 1260*r*s - 831*r + 23*s - 40) - 6156*r**2 - 6156*r*s + 4077*r - 190*s + 230) - 33*k2**2*(4*r - 1)*(2*C*(15*r + 15*s - 8) - 24*r - 24*s + 13)) + 5148*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k1*k3**5) - 2*D1**3*Pkd1*Pkd3*ct**2*(2*D1*bd1*f**2*(k1**2*(2*C - 1)*(4*r**2 + r*(4*s - 3) - s) - 6*k2**2*r*(r + s - 1)) + b1**3*k2**2*(3*D1*fd*r*(r + s - 1) + Dd*f*(12*r**2 + r*(12*s - 19) - 5*s + 5)) - b1**2*(D1*bd1*f*k2**2*(-9*r**2 - 9*r*s + 16*r + 5*s - 5) + 2*D1*fd*(k1**2*r*(2 - 4*C) + k2**2*(f*(2*r - 1) + 9*r - 2))*(r + s - 1) + Dd*f*k1**2*(2 - 4*C)*(8*r**2 + 8*r*(s - 1) - s + 1) + 2*Dd*f*k2**2*(f*(4*r**2 + r*(4*s - 5) - 3*s + 2) + 36*r**2 + r*(36*s - 47) - 12*s + 11)) - 2*b1*f*(D1*bd1*(-k1**2*(2*C - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + k2**2*(f*(2*r**2 + 2*r*(s - 1) - 2*s + 1) + 18*r**2 + 18*r*s - 26*r - 9*s + 8)) - 2*D1*fd*(2*r - 1)*(k1**2*(4*C - 2) - 3*k2**2)*(r + s - 1) + Dd*f*(-k1**2*(2*C - 1)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 6*k2**2*(4*r - 1)*(r + s - 1))))/(21*d**2*k1*k3) - 2*D1**3*Pkd1*Pkd3*ct**2*(-D1*bd1*f*(5*f**2*k2**2*(k1**2*(207*r**2 + r*(207*s - 187) - 40*s + 30) + 66*k2**2*r*(3*r + 3*s - 2)) + 66*f*(k1**4*(2*C - 1)*(2*r + s - 1) - 3*k1**2*k2**2*(4*C*(r**2 + r*(s - 3) - 3*s + 2) + K*(2*r**2 + 2*r*(s - 2) - s + 1) - 6*r**2 - 6*r*s + 12*r + 9*s - 7) + 6*k2**4*r*(r + s)) + 66*k1**2*k2**2*(b2*(r**2 + r*(s - 1) - 4*s) - 14*g2*(r - 1)*(r + s))) + 33*b1**3*k1**2*k2**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*s + 3*r + 3*s - 3)) - 33*b1**2*(D1*(-bd1*f*k1**2*k2**2*(3*r**2 + 3*r*s + 4*r + 3*s - 3) + 2*fd*(k1**4*r*(4*C - 2)*(r + s - 1) + k1**2*k2**2*(28*C*r**2 + 28*C*r*s - 28*C*r + K*(7*r**2 + 7*r*s - 12*r - 6*s + 6) + f*(16*r**2 + 16*r*s + r + 5*s - 5) - 19*r**2 - 19*r*s + 29*r + 4*s - 4) + k2**4*r*(12*f*(3*r + 3*s - 2) + 7*r + 7*s))) + 2*Dd*f*(k1**4*(2*C - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(28*C*(4*r - 1)*(r + s - 1) + 28*K*r**2 + 28*K*r*s - 31*K*r - 19*K*s + 12*K + f*(32*r**2 + 4*r*(8*s - 3) + 4*s - 5) - 76*r**2 - 76*r*s + 117*r + 28*s - 29) + k2**4*(4*r - 1)*(6*f*(3*r + 3*s - 2) + 7*r + 7*s))) - b1*(66*D1*bd1*f*(k1**4*(2*C - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(28*C*(2*r - 1)*(r + s - 1) + K*(14*r**2 + 14*r*s - 13*r - 10*s + 3) + 16*f*r**2 + 16*f*r*s - 13*f*r - f*s - 38*r**2 - 38*r*s + 64*r + 22*s - 23) + k2**4*(2*r - 1)*(6*f*(3*r + 3*s - 2) + 7*r + 7*s)) + 3*D1*(5*f**2*fd*k2**2*(3*r - 1)*(k1**2*(69*r + 69*s - 49) + 22*k2**2*(3*r + 3*s - 2)) - 22*f*(2*fd*(k1**4*(4*C - 2)*(2*r + s - 1) + 3*k1**2*k2**2*(4*C*(r**2 + r*s + r + s - 1) + K*(2*r - 1)*(r + s - 1) - 6*r**2 - 6*r*s + r - s + 2) - 3*k2**4*(r + s)*(2*r - 1)) + k1**2*k2**2*(-bd2*r*(r + s + 3) + 2*gd2*(7*r**2 + r*(7*s - 6) - 3*s + 3))) + 22*fd*k1**2*k2**2*(b2*r*(r + s) - 2*g2*(7*r**2 + r*(7*s - 12) - 6*s + 6))) + Dd*f*(5*f**2*k2**2*(k1**2*(828*r**2 + r*(828*s - 835) - 247*s + 177) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 132*f*(k1**4*(4*C - 2)*(2*r + s - 1) + 3*k1**2*k2**2*(-2*C*s + K*(4*r**2 + r*(4*s - 7) - 2*s + 2) + r**2*(8*C - 12) + r*(8*C*s - 2*C - 12*s + 9) + 4*s - 2) - 3*k2**4*(r + s)*(4*r - 1)) + 66*k1**2*k2**2*(b2*(4*r**2 + r*(4*s + 5) - 4*s) + g2*(-56*r**2 + r*(62 - 56*s) + 38*s - 24)))) + 2*f*k1**2*(D1*(5*f*fd*(3*r - 1)*(k1**2*(20*C - 10)*(3*r + 3*s - 2) + 33*k2**2*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + 99*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + 2*r*(s - 2) - s + 1) + 198*fd*k2**2*(b2 - 2*g2)*(2*r - 1)*(r + s - 1)) + Dd*f*(5*f*(k1**2*(10*C - 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(C*(6*r + 6*s - 4) - 4*r - 4*s + 3)) + k2**2*(198*b2 - 396*g2)*(4*r**2 + r*(4*s - 7) - 2*s + 2))))/(693*d**2*k1*k3**3) + 4*D1**3*Pkd1*Pkd3*ct*f*k2**3*st**4*(D1*(33*b1*fd*r*(4*C - 3)*(2*r + 2*s - 1) + 33*bd1*f*r*(4*C - 3)*(r + s - 1) + f*fd*(20*C - 16)*(3*r - 1)*(3*r + 3*s - 2)) + Dd*f*(33*b1*r*(4*C - 3)*(4*r + 4*s - 3) + f*(10*C - 8)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)))/(231*d**2*k3**3) - 4*D1**3*Pkd1*Pkd3*ct*f*k2**3*st**4*(D1*(-429*b1*fd*r*(2*b1*k2**2 + k1**2*(5 - 8*C))*(2*r + 2*s - 1) + f**2*k2**2*(65*bd1*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + 2*fd*(1588*r**2 + r*(1588*s - 1315) - 176*s + 119)) + 13*f*(33*bd1*r*(-4*b1*k2**2 + k1**2*(8*C - 5))*(r + s - 1) + 2*fd*(5*b1*k2**2*(9*r + 1) + k1**2*(22*C - 14)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(-429*b1*r*(2*b1*k2**2 + k1**2*(5 - 8*C))*(4*r + 4*s - 3) + 2*f**2*k2**2*(1588*r**2 + r*(1588*s - 1315) - 176*s + 119) + 13*f*(5*b1*k2**2*(72*r**2 + 8*r*(9*s - 7) - 5*s + 3) + k1**2*(22*C - 14)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k3**5) - 4*D1**3*Pkd1*Pkd3*ct*k1**2*k2*(D1*bd1*f*(-33*b1*k1**2*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s) - 231*b1*k2**2*(3*K - 1)*(r + s)*(2*r - 1) + 5*f**2*(5*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 33*k2**2*(2*r**2 + 2*r*s + s - 1)) + 33*f*(k1**2*(-12*C*(r - 1)*(r + s - 1) - 20*K*r**2 - 20*K*r*s + 20*K*r + 5*K*s - 5*K + b1*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 10*r**2 + 10*r*s - 16*r - 7*s + 7) + 6*k2**2*(b1*(2*r - 1)*(3*r + 3*s - 2) - r*(3*K - 1)*(r + s))) + 330*g2*k1**2*(2*r**2 + 2*r*(s - 1) - s) + 1386*g2*k2**2*(r - 1)*(r + s)) + 33*b1**2*(D1*fd*r*(4*f*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(3*r + 3*s - 2)) - (r + s)*(k1**2*(10*K - 2) + k2**2*(21*K - 7))) + Dd*f*(f*(k1**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 6*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - k1**2*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s) + k2**2*(7 - 21*K)*(r + s)*(4*r - 1))) + b1*(D1*(5*f**2*fd*(10*k1**2*(3*r - 1)*(3*r + 3*s - 2) + 33*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2)) - 66*f*(fd*k1**2*(5*K*(2*r - 1)*(2*r + 2*s - 1) + r**2*(12*C - 10) + r*(12*C - 10)*(s - 1) + 2*s - 1) + 3*fd*k2**2*(3*K - 1)*(r + s)*(2*r - 1) - 5*gd2*k1**2*r*(2*r + 2*s - 1) - 21*gd2*k2**2*r*(r + s)) + 66*fd*g2*r*(10*k1**2 + 21*k2**2)*(r + s)) + Dd*f*(5*f**2*(5*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - 66*f*(k1**2*(6*C*(4*r - 1)*(r + s - 1) + 5*K*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 20*r**2 - 20*r*s + 23*r + 6*s - 5) + k2**2*(9*K - 3)*(r + s)*(4*r - 1)) + 66*g2*(5*k1**2*(8*r**2 + r*(8*s - 4) - s) + 21*k2**2*(r + s)*(4*r - 1)))) + f*(D1*(-140*f**2*fd*k2**2*(4*r - 1)*(r + s - 1) - 33*f*(fd*k1**2*(10*C - 5)*(3*r - 1)*(r + s - 1) - 2*gd2*(5*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*k2**2*r*(r + s))) + 132*fd*g2*(2*r - 1)*(5*k1**2*(2*r + 2*s - 1) + 9*k2**2*(r + s))) + Dd*f*(-140*f**2*k2**2*(4*r - 1)*(r + s - 1) + f*k1**2*(165 - 330*C)*(4*r - 1)*(r + s - 1) + 132*g2*(5*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 9*k2**2*(r + s)*(4*r - 1)))))/(693*d**2*k3**5) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(D1*bd1*f**2*r*(2*C*(7*r + 7*s - 5) - 9*r - 9*s + 6) + b1**2*(D1*fd*r*(26*C - 15)*(r + s - 1) + Dd*f*(2*C*(52*r**2 + 52*r*s - 45*r - 3*s + 3) - 60*r**2 - 60*r*s + 53*r + 4*s - 4)) + b1*f*(D1*bd1*(C*(52*r**2 + 52*r*s - 38*r - 6*s + 6) - 30*r**2 - 30*r*s + 23*r + 4*s - 4) + 2*D1*fd*(r + s - 1)*(C*(14*r - 5) - 9*r + 3) + Dd*f*(2*C*(28*r**2 + 28*r*s - 31*r - 5*s + 5) - 36*r**2 - 36*r*s + 39*r + 6*s - 6)))/(21*d**2*k3) + 4*D1**3*Pkd1*Pkd3*ct*k2*(D1*bd1*f*(b2*(-2*r**2 - 2*r*(s - 1) + s) - 2*f*r*(6*C - 3)*(r + s - 1) - 2*g2*(-2*r**2 - 2*r*s + 2*r + s)) + b1**3*(2*D1*fd*r*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + b1**2*(D1*bd1*f*(6*r**2 + 6*r*(s - 1) - s + 1) + D1*fd*(r + s - 1)*(-14*C*r - 2*K*(r - 1) + f*(8*r - 4) + 9*r - 2) + Dd*f*(-14*C*(4*r - 1)*(r + s - 1) - 8*K*r**2 - 8*K*r*s + 12*K*r + 5*K*s - 4*K + f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 36*r**2 + 36*r*s - 47*r - 12*s + 11)) + b1*(-24*C*D1*f*fd*r**2 - 24*C*D1*f*fd*r*s + 36*C*D1*f*fd*r + 12*C*D1*f*fd*s - 12*C*D1*f*fd - 48*C*Dd*f**2*r**2 - 48*C*Dd*f**2*r*s + 60*C*Dd*f**2*r + 12*C*Dd*f**2*s - 12*C*Dd*f**2 - 2*D1*b2*fd*r**2 - 2*D1*b2*fd*r*s + 4*D1*b2*fd*r + 2*D1*b2*fd*s - 2*D1*b2*fd + D1*bd1*f*(-14*C*(2*r - 1)*(r + s - 1) - 4*K*r**2 - 4*K*r*s + 5*K*r + 2*K*s - K + f*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 18*r**2 + 18*r*s - 26*r - 9*s + 8) - D1*bd2*f*(2*r - 1)*(r + s - 1) + 12*D1*f*fd*r**2 + 12*D1*f*fd*r*s - 18*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd + 4*D1*f*gd2*r**2 + 4*D1*f*gd2*r*s - 6*D1*f*gd2*r - 2*D1*f*gd2*s + 2*D1*f*gd2 + 4*D1*fd*g2*r**2 + 4*D1*fd*g2*r*s - 8*D1*fd*g2*r - 4*D1*fd*g2*s + 4*D1*fd*g2 - 8*Dd*b2*f*r**2 - 8*Dd*b2*f*r*s + 12*Dd*b2*f*r + 5*Dd*b2*f*s - 4*Dd*b2*f + 24*Dd*f**2*r**2 + 24*Dd*f**2*r*s - 30*Dd*f**2*r - 6*Dd*f**2*s + 6*Dd*f**2 + 16*Dd*f*g2*r**2 + 16*Dd*f*g2*r*s - 24*Dd*f*g2*r - 10*Dd*f*g2*s + 8*Dd*f*g2))/(21*d**2*k3) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(33*b1**3*k2**2*(13*D1*fd*r*(r + s - 1) + Dd*f*(52*r**2 + r*(52*s - 45) - 3*s + 3)) - 33*b1**2*(D1*bd1*f*k2**2*(-39*r**2 - 39*r*s + 32*r + 3*s - 3) + D1*fd*(f*k2**2*(52*r**2 + 52*r*s - 26*r + 5*s - 5) + k1**2*r*(34*C - 19)*(r + s - 1) - k2**2*r*(13*K - 13)*(r + s)) + Dd*f*k1**2*(2*C*(68*r**2 + r*(68*s - 61) - 5*s + 5) - 76*r**2 - 76*r*s + 69*r + 6*s - 6) + Dd*f*k2**2*(f*(104*r**2 + 2*r*(52*s - 41) - 16*s + 9) - (K - 1)*(52*r**2 + r*(52*s - 33) - 3*s))) - 3*b1*(11*D1*bd1*f*(k1**2*(2*C*(34*r**2 + 34*r*s - 27*r - 5*s + 5) - 38*r**2 - 38*r*s + 31*r + 6*s - 6) + k2**2*(f*(52*r**2 + 52*r*s - 56*r - 21*s + 14) - (K - 1)*(26*r**2 + 26*r*s - 23*r - 3*s))) + D1*(f**2*fd*k2**2*(567*r**2 + r*(567*s - 460) - 57*s + 28) - 11*f*(fd*k1**2*(2*C*(16*r**2 + 16*r*s + 7*r + 7*s - 7) - 16*r**2 - r*(16*s + 9) - 8*s + 8) + fd*k2**2*(K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(4 - 24*C) + r*(-24*C*s + 12*C + 4*s + 1) + 5*s - 2) + k2**2*r*(bd2 - 2*gd2)*(13*r + 13*s - 10)) - 143*fd*k2**2*r*(b2 - 2*g2)*(r + s)) + Dd*f*(f**2*k2**2*(756*r**2 + 9*r*(84*s - 61) - 17*s + 4) + 11*f*(k1**2*(4 - 8*C)*(8*r**2 + r*(8*s - 4) - s) + k2**2*(6*C*(4*r - 1)*(2*r + 2*s - 1) + K*(-28*r**2 - 28*r*s + 19*r + 5*s - 2) - (2*r - 1)*(4*r + 4*s - 3))) + k2**2*(-11*b2 + 22*g2)*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(-3*D1*bd1*(f**2*k2**2*(189*r**2 + 189*r*s - 89*r + 40*s - 24) - 11*f*(k1**2*(2*C*(8*r**2 + r*(8*s - 19) - 11*s + 7) - 8*r**2 + r*(21 - 8*s) + 12*s - 8) + k2**2*(-6*C*(r - 1)*(2*r + 2*s - 1) + r**2*(7*K + 2) + r*(7*K*s - 4*K + 2*s - 10) - 9*s + 5)) + k2**2*(-11*b2 + 22*g2)*(13*r**2 + 13*r*(s - 1) - 3*s)) + D1*(f*(fd*k1**2*(6*C*(261*r**2 + r*(261*s - 184) + s + 3) - 837*r**2 + r*(606 - 837*s) - 18*s - 10) - 33*fd*k2**2*(3*r - 1)*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5) + k2**2*r*(33*bd2 - 66*gd2)*(7*r + 7*s - 4)) + 33*fd*k2**2*(b2 - 2*g2)*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(f*(k1**2*(6*C*(348*r**2 + 348*r*s - 227*r + 25*s - 21) - 1116*r**2 - 1116*r*s + 753*r - 98*s + 70) - 33*k2**2*(4*r - 1)*(6*C*(2*r + 2*s - 1) - 9*r - 9*s + 5)) + k2**2*(33*b2 - 66*g2)*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(693*d**2*k3**3) - 4*D1**3*Pkd1*Pkd3*ct*k2*(-D1*bd1*f*(-33*b2*k1**2*(6*r**2 + 6*r*(s - 1) - 3*s) - 231*b2*k2**2*(r - 1)*(r + s) + 5*f**2*(5*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 33*k2**2*r*(3*r + 3*s - 2)) + 33*f*(k1**2*(12*C*(r + s - 1) - 3*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 4*r**2 + 4*r*s - 10*r - 7*s + 7) + k2**2*r*(6 - 6*K)*(r + s)) + 462*g2*k2**2*(r - 1)*(r + s)) + 33*b1**3*(D1*fd*r*(2*k1**2 + 7*k2**2)*(r + s - 1) + Dd*f*(k1**2*(8*r**2 + 8*r*(s - 1) - s + 1) + 7*k2**2*(4*r - 1)*(r + s - 1))) + 33*b1**2*(D1*bd1*f*(k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 7*k2**2*(3*r - 1)*(r + s - 1)) + D1*fd*(k1**2*(-14*C*r**2 - 14*C*r*s + 14*C*r + 6*K*(2*r + s - 1) - 4*f*(2*r + s - 1) + 7*r**2 + 7*r*s - 11*r - 2*s + 2) + k2**2*(-6*f*(4*r**2 + r*(4*s - 1) + s - 1) + r*(7*K - 7)*(r + s))) + Dd*f*(k1**2*(-14*C*(4*r - 1)*(r + s - 1) + 24*K*r + 12*K*s - 12*K - 4*f*(2*r + s - 1) + 28*r**2 + 28*r*s - 43*r - 11*s + 11) - k2**2*(4*r - 1)*(6*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)))) - b1*(33*D1*bd1*f*(k1**2*(14*C*(2*r - 1)*(r + s - 1) - 3*K*(2*r + s - 1) - 14*r**2 - 14*r*s + 23*r + 8*s - 8) + k2**2*(6*f*(4*r**2 + r*(4*s - 5) - 3*s + 2) + (7 - 7*K)*(r + s)*(2*r - 1))) + D1*(5*f**2*fd*(10*k1**2 + 33*k2**2)*(3*r - 1)*(3*r + 3*s - 2) - 33*f*(bd2*k1**2*r*(6*r + 6*s - 3) + 7*bd2*k2**2*r*(r + s) + 2*fd*k1**2*(6*C*(r + s - 1) + 3*K*(2*r - 1)*(2*r + 2*s - 1) - 4*r**2 - 4*r*s + r - s + 2) + 6*fd*k2**2*(K - 1)*(r + s)*(2*r - 1) - 6*gd2*k1**2*(2*r + s - 1) - 14*gd2*k2**2*r*(r + s)) + 33*fd*(-b2*r*(6*k1**2 + 7*k2**2)*(r + s) + 2*g2*(6*k1**2*(2*r + s - 1) + 7*k2**2*r*(r + s)))) + Dd*f*(-99*b2*k1**2*(8*r**2 + r*(8*s - 4) - s) - 231*b2*k2**2*(r + s)*(4*r - 1) + 5*f**2*(5*k1**2*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 33*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 66*f*(k1**2*(3*K - 1)*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + k2**2*(3*K - 3)*(r + s)*(4*r - 1)) + 792*g2*k1**2*(2*r + s - 1) + 462*g2*k2**2*(r + s)*(4*r - 1))) + 33*f*(30*C*D1*f*fd*k1**2*r**2 + 30*C*D1*f*fd*k1**2*r*s - 40*C*D1*f*fd*k1**2*r - 10*C*D1*f*fd*k1**2*s + 10*C*D1*f*fd*k1**2 + 40*C*Dd*f**2*k1**2*r**2 + 40*C*Dd*f**2*k1**2*r*s - 50*C*Dd*f**2*k1**2*r - 10*C*Dd*f**2*k1**2*s + 10*C*Dd*f**2*k1**2 + 3*D1*bd2*f*(k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 2*k2**2*r*(r + s)) - 15*D1*f*fd*k1**2*r**2 - 15*D1*f*fd*k1**2*r*s + 20*D1*f*fd*k1**2*r + 5*D1*f*fd*k1**2*s - 5*D1*f*fd*k1**2 - 24*D1*f*gd2*k1**2*r**2 - 24*D1*f*gd2*k1**2*r*s + 24*D1*f*gd2*k1**2*r + 6*D1*f*gd2*k1**2*s - 6*D1*f*gd2*k1**2 - 12*D1*f*gd2*k2**2*r**2 - 12*D1*f*gd2*k2**2*r*s - 48*D1*fd*g2*k1**2*r**2 - 48*D1*fd*g2*k1**2*r*s + 48*D1*fd*g2*k1**2*r + 24*D1*fd*g2*k1**2*s - 12*D1*fd*g2*k1**2 - 24*D1*fd*g2*k2**2*r**2 - 24*D1*fd*g2*k2**2*r*s + 12*D1*fd*g2*k2**2*r + 12*D1*fd*g2*k2**2*s - 20*Dd*f**2*k1**2*r**2 - 20*Dd*f**2*k1**2*r*s + 25*Dd*f**2*k1**2*r + 5*Dd*f**2*k1**2*s - 5*Dd*f**2*k1**2 - 96*Dd*f*g2*k1**2*r**2 - 96*Dd*f*g2*k1**2*r*s + 96*Dd*f*g2*k1**2*r + 36*Dd*f*g2*k1**2*s - 24*Dd*f*g2*k1**2 - 48*Dd*f*g2*k2**2*r**2 - 48*Dd*f*g2*k2**2*r*s + 12*Dd*f*g2*k2**2*r + 12*Dd*f*g2*k2**2*s + 6*b2*(D1*fd*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + k2**2*(r + s)) + Dd*f*(k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + k2**2*(r + s)*(4*r - 1)))))/(693*d**2*k3**3) + 2*D1**3*Pkd1*Pkd3*ct*k2*st**2*(39*D1*bd1*f*(f**2*k2**2*(k1**2*(102*r**2 + 102*r*s + 87*r + 128*s - 116) + 33*k2**2*(4*r**2 + r*(4*s - 9) - 6*s + 4)) - 11*f*(3*b1*k2**4*(2*r - 1)*(2*r + 2*s - 1) + k1**4*(2*C*(23*r**2 + r*(23*s - 32) - 13*s + 9) - 25*r**2 - 25*r*s + 35*r + 14*s - 10) + k1**2*k2**2*(-2*C*(r - 1)*(12*r + 12*s - 7) + 21*K*r**2 + 21*K*r*s - 12*K*r + b1*(-78*r**2 + r*(80 - 78*s) + 24*s - 13) + 8*r**2 + 8*r*s - 20*r - 15*s + 9)) - 11*k1**2*k2**2*(b1*(3*K - 1)*(26*r**2 + r*(26*s - 23) - 3*s) + 6*g2*(-13*r**2 - 13*r*(s - 1) + 3*s))) + 429*b1**2*k2**2*(D1*fd*r*(f*k1**2*(78*r + 78*s - 41) - 6*f*k2**2*(2*r + 2*s - 1) + k1**2*(13 - 39*K)*(r + s)) + Dd*f*(f*(k1**2*(156*r**2 + 156*r*s - 121*r - 24*s + 13) - 3*k2**2*(4*r - 1)*(2*r + 2*s - 1)) - k1**2*(3*K - 1)*(52*r**2 + r*(52*s - 33) - 3*s))) + 39*b1*(D1*(f**2*fd*k2**2*(k1**2*(306*r**2 + r*(306*s - 169) - 42*s + 17) + 33*k2**2*(12*r**2 + r*(12*s - 7) + 2*s - 1)) - 11*f*k1**2*(fd*k1**2*r*(C*(92*r + 92*s - 56) - 50*r - 50*s + 31) + fd*k2**2*(3*K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r**2*(16 - 48*C) + r*(-48*C*s + 28*C + 16*s - 7) + 5*s - 2) - 6*gd2*k2**2*r*(13*r + 13*s - 10)) + 858*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(408*r**2 + r*(408*s - 82) + 86*s - 99) + 33*k2**2*(4*r - 1)*(4*r + 4*s - 3)) - 11*f*k1**2*(k1**2*(2*C*(92*r**2 + r*(92*s - 79) - 13*s + 9) - 100*r**2 - 100*r*s + 87*r + 14*s - 10) + k2**2*(-2*C*(4*r - 1)*(12*r + 12*s - 7) + 3*K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + 32*r**2 + 32*r*s - 32*r - 10*s + 7)) + 66*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(k1**2*(-1396*r**2 + r*(811 - 1396*s) - 366*s + 242) + 390*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 13*f*k1**2*(fd*k1**2*(22*C*(81*r**2 + r*(81*s - 60) + 3*s + 1) - 945*r**2 - 21*r*(45*s - 34) - 48*s - 12) - 33*fd*k2**2*(3*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9) - 198*gd2*k2**2*r*(7*r + 7*s - 4)) + 2574*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(5*f**2*k2**2*(k1**2*(-1396*r**2 + r*(811 - 1396*s) - 366*s + 242) + 390*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 13*f*k1**2*(k1**2*(22*C*(108*r**2 + 108*r*s - 75*r + 11*s - 7) - 1260*r**2 - 1260*r*s + 897*r - 144*s + 84) - 33*k2**2*(4*r - 1)*(2*C*(12*r + 12*s - 7) - 15*r - 15*s + 9)) + 2574*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**5) - 5*D1**3*Pkd1*Pkd3*f**2*k2**6*st**6*(13*D1*bd1*f*(21*r**2 + r*(21*s - 17) + 6*s - 4) + 13*b1*(21*D1*fd*r*(3*r + 3*s - 2) + Dd*f*(84*r**2 + r*(84*s - 59) + 6*s - 4)) + f*(87*r - 38)*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(9009*d**2*k1*k3**5) - 2*D1**3*Pkd1*Pkd3*f*k2**2*st**4*(D1*(33*b1*fd*r*(b1*k2**2*(4*r + 4*s - 3) + k1**2*(2 - 4*C)*(2*r + 2*s - 1)) + 2*bd1*f**2*k2**2*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + f*(33*bd1*r*(b1*k2**2*(4*r + 4*s - 3) + k1**2*(2 - 4*C)*(r + s - 1)) - 4*fd*(3*r - 1)*(b1*k2**2*(-6*r - 6*s + 5) + k1**2*(6*C - 3)*(3*r + 3*s - 2)))) - 2*Dd*f*(-33*b1*r*(b1*k2**2 + k1**2*(1 - 2*C))*(4*r + 4*s - 3) + f*(b1*k2**2*(-48*r**2 + r*(52 - 48*s) + 14*s - 11) + k1**2*(6*C - 3)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(231*d**2*k1*k3**3) + 2*D1**3*Pkd1*Pkd3*f*k2**2*st**4*(D1*(429*b1*fd*k1**2*r*(3*b1*k2**2 + k1**2*(2 - 4*C))*(2*r + 2*s - 1) + f**2*k2**2*(-52*bd1*k1**2*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + fd*(k1**2*(-1812*r**2 - 1812*r*s + 1487*r + 180*s - 122) + 13*k2**2*(4*r - 1)*(5*r + 5*s - 3))) - 26*f*k1**2*(33*bd1*r*(-3*b1*k2**2 + k1**2*(2*C - 1))*(r + s - 1) + 2*fd*(2*b1*k2**2*(3*r + 2) + k1**2*(6*C - 3)*(3*r - 1))*(3*r + 3*s - 2))) + Dd*f*(429*b1*k1**2*r*(3*b1*k2**2 + k1**2*(2 - 4*C))*(4*r + 4*s - 3) + f**2*k2**2*(k1**2*(-1812*r**2 - 1812*r*s + 1487*r + 180*s - 122) + 13*k2**2*(4*r - 1)*(5*r + 5*s - 3)) - 26*f*k1**2*(2*b1*k2**2*(24*r**2 + 12*r*(2*s - 1) + 5*s - 4) + k1**2*(6*C - 3)*(24*r**2 + 24*r*(s - 1) - 7*s + 5))))/(3003*d**2*k1*k3**5) - 2*D1**3*Pkd1*Pkd3*k1**3*(D1*(-2*b1*fd*r*(2*k1**2 + 7*k2**2)*(r + s)*(K*b1 - 2*g2) + 5*bd1*f**3*k2**2*r*(r + s - 1) + f**2*(5*b1*fd*k2**2*(3*r - 1)*(r + s - 1) - 2*bd1*(K*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*K*k2**2*r*(r + s) - 3*b1*k2**2*(2*r - 1)*(r + s - 1)) + 4*gd2*(k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*k2**2*r*(r + s))) + 2*f*(2*b1*gd2*r*(k1**2*(2*r + 2*s - 1) + 7*k2**2*(r + s)) + bd1*(K*b1*(k1**2*(-4*r**2 - 4*r*s + 3*r + s) - 7*k2**2*(r + s)*(2*r - 1)) + 2*g2*(k1**2*(2*r**2 + 2*r*(s - 1) - s) + 7*k2**2*(r - 1)*(r + s))) + 2*fd*(b1*(-K*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s)) + 3*b1*k2**2*r*(r + s - 1)) + 2*g2*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))))) + Dd*f*(5*b1*f**2*k2**2*(4*r - 1)*(r + s - 1) - 2*b1*(K*b1 - 2*g2)*(k1**2*(8*r**2 + r*(8*s - 4) - s) + 7*k2**2*(r + s)*(4*r - 1)) + 2*f*(b1*(-2*K*(k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 3*k2**2*(r + s)*(4*r - 1)) + 3*b1*k2**2*(4*r - 1)*(r + s - 1)) + 4*g2*(k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 3*k2**2*(r + s)*(4*r - 1)))))/(21*d**2*k3**5) - 2*D1**3*Pkd1*Pkd3*k1*(8*D1*K*b1**2*fd*k1**2*r + 4*D1*K*b1**2*fd*k1**2*s - 4*D1*K*b1**2*fd*k1**2 + 14*D1*K*b1**2*fd*k2**2*r**2 + 14*D1*K*b1**2*fd*k2**2*r*s + 4*D1*K*b1*bd1*f*k1**2*r + 2*D1*K*b1*bd1*f*k1**2*s - 2*D1*K*b1*bd1*f*k1**2 + 28*D1*K*b1*bd1*f*k2**2*r**2 + 28*D1*K*b1*bd1*f*k2**2*r*s - 14*D1*K*b1*bd1*f*k2**2*r - 14*D1*K*b1*bd1*f*k2**2*s + 16*D1*K*b1*f*fd*k1**2*r**2 + 16*D1*K*b1*f*fd*k1**2*r*s - 16*D1*K*b1*f*fd*k1**2*r - 8*D1*K*b1*f*fd*k1**2*s + 4*D1*K*b1*f*fd*k1**2 + 24*D1*K*b1*f*fd*k2**2*r**2 + 24*D1*K*b1*f*fd*k2**2*r*s - 12*D1*K*b1*f*fd*k2**2*r - 12*D1*K*b1*f*fd*k2**2*s + 8*D1*K*bd1*f**2*k1**2*r**2 + 8*D1*K*bd1*f**2*k1**2*r*s - 8*D1*K*bd1*f**2*k1**2*r - 2*D1*K*bd1*f**2*k1**2*s + 2*D1*K*bd1*f**2*k1**2 + 12*D1*K*bd1*f**2*k2**2*r**2 + 12*D1*K*bd1*f**2*k2**2*r*s + 7*D1*b1**3*fd*k2**2*r**2 + 7*D1*b1**3*fd*k2**2*r*s - 7*D1*b1**3*fd*k2**2*r + 21*D1*b1**2*bd1*f*k2**2*r**2 + 21*D1*b1**2*bd1*f*k2**2*r*s - 28*D1*b1**2*bd1*f*k2**2*r - 7*D1*b1**2*bd1*f*k2**2*s + 7*D1*b1**2*bd1*f*k2**2 - 6*D1*b1**2*f*fd*k2**2*r - 6*D1*b1**2*f*fd*k2**2*s + 6*D1*b1**2*f*fd*k2**2 + 6*D1*b1*bd1*f**2*k2**2*r + 6*D1*b1*bd1*f**2*k2**2*s - 6*D1*b1*bd1*f**2*k2**2 - 15*D1*b1*f**2*fd*k2**2*r**2 - 15*D1*b1*f**2*fd*k2**2*r*s + 20*D1*b1*f**2*fd*k2**2*r + 5*D1*b1*f**2*fd*k2**2*s - 5*D1*b1*f**2*fd*k2**2 - 8*D1*b1*f*gd2*k1**2*r - 4*D1*b1*f*gd2*k1**2*s + 4*D1*b1*f*gd2*k1**2 - 28*D1*b1*f*gd2*k2**2*r**2 - 28*D1*b1*f*gd2*k2**2*r*s - 16*D1*b1*fd*g2*k1**2*r - 8*D1*b1*fd*g2*k1**2*s + 8*D1*b1*fd*g2*k1**2 - 28*D1*b1*fd*g2*k2**2*r**2 - 28*D1*b1*fd*g2*k2**2*r*s - 5*D1*bd1*f**3*k2**2*r**2 - 5*D1*bd1*f**3*k2**2*r*s + 5*D1*bd1*f**3*k2**2*r - 28*D1*bd1*f*g2*k2**2*r**2 - 28*D1*bd1*f*g2*k2**2*r*s + 28*D1*bd1*f*g2*k2**2*r + 28*D1*bd1*f*g2*k2**2*s + 2*D1*bd2*f*(b1*k1**2*r*(2*r + 2*s - 1) + 7*b1*k2**2*r*(r + s) + f*k1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*f*k2**2*r*(r + s)) - 16*D1*f**2*gd2*k1**2*r**2 - 16*D1*f**2*gd2*k1**2*r*s + 16*D1*f**2*gd2*k1**2*r + 4*D1*f**2*gd2*k1**2*s - 4*D1*f**2*gd2*k1**2 - 24*D1*f**2*gd2*k2**2*r**2 - 24*D1*f**2*gd2*k2**2*r*s - 32*D1*f*fd*g2*k1**2*r**2 - 32*D1*f*fd*g2*k1**2*r*s + 32*D1*f*fd*g2*k1**2*r + 16*D1*f*fd*g2*k1**2*s - 8*D1*f*fd*g2*k1**2 - 48*D1*f*fd*g2*k2**2*r**2 - 48*D1*f*fd*g2*k2**2*r*s + 24*D1*f*fd*g2*k2**2*r + 24*D1*f*fd*g2*k2**2*s + 16*Dd*K*b1**2*f*k1**2*r + 8*Dd*K*b1**2*f*k1**2*s - 8*Dd*K*b1**2*f*k1**2 + 56*Dd*K*b1**2*f*k2**2*r**2 + 56*Dd*K*b1**2*f*k2**2*r*s - 14*Dd*K*b1**2*f*k2**2*r - 14*Dd*K*b1**2*f*k2**2*s + 32*Dd*K*b1*f**2*k1**2*r**2 + 32*Dd*K*b1*f**2*k1**2*r*s - 32*Dd*K*b1*f**2*k1**2*r - 12*Dd*K*b1*f**2*k1**2*s + 8*Dd*K*b1*f**2*k1**2 + 48*Dd*K*b1*f**2*k2**2*r**2 + 48*Dd*K*b1*f**2*k2**2*r*s - 12*Dd*K*b1*f**2*k2**2*r - 12*Dd*K*b1*f**2*k2**2*s + 28*Dd*b1**3*f*k2**2*r**2 + 28*Dd*b1**3*f*k2**2*r*s - 35*Dd*b1**3*f*k2**2*r - 7*Dd*b1**3*f*k2**2*s + 7*Dd*b1**3*f*k2**2 - 20*Dd*b1*f**3*k2**2*r**2 - 20*Dd*b1*f**3*k2**2*r*s + 25*Dd*b1*f**3*k2**2*r + 5*Dd*b1*f**3*k2**2*s - 5*Dd*b1*f**3*k2**2 - 32*Dd*b1*f*g2*k1**2*r - 16*Dd*b1*f*g2*k1**2*s + 16*Dd*b1*f*g2*k1**2 - 112*Dd*b1*f*g2*k2**2*r**2 - 112*Dd*b1*f*g2*k2**2*r*s + 28*Dd*b1*f*g2*k2**2*r + 28*Dd*b1*f*g2*k2**2*s - 64*Dd*f**2*g2*k1**2*r**2 - 64*Dd*f**2*g2*k1**2*r*s + 64*Dd*f**2*g2*k1**2*r + 24*Dd*f**2*g2*k1**2*s - 16*Dd*f**2*g2*k1**2 - 96*Dd*f**2*g2*k2**2*r**2 - 96*Dd*f**2*g2*k2**2*r*s + 24*Dd*f**2*g2*k2**2*r + 24*Dd*f**2*g2*k2**2*s + 2*b2*(D1*(b1*fd*r*(2*k1**2 + 7*k2**2)*(r + s) + bd1*f*(k1**2*(2*r**2 + 2*r*(s - 1) - s) + 7*k2**2*(r - 1)*(r + s)) + 2*f*fd*(2*r - 1)*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(r + s))) + Dd*f*(b1*k1**2*(8*r**2 + r*(8*s - 4) - s) + 7*b1*k2**2*(r + s)*(4*r - 1) + 2*f*k1**2*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 6*f*k2**2*(r + s)*(4*r - 1))))/(21*d**2*k3**3) + D1**3*Pkd1*Pkd3*k1*st**2*(13*D1*bd1*f*(f**2*k2**2*(k1**2*(207*r**2 + r*(207*s - 41) + 82*s - 98) - 33*k2**2*(11*r + 9*s - 7)) - 33*f*(b1*k2**4*(2*r - 1)*(9*r + 9*s - 5) + k1**4*(4*C - 2)*(2*r - 1)*(r + s - 1) - 2*k1**2*k2**2*(2*C*(r - 1)*(3*r + 3*s - 2) - 7*K*r**2 - 7*K*r*s + 4*K*r + b1*(17*r**2 + r*(17*s - 18) - 5*s + 3) - 3*r**2 - 3*r*s + 5*r + 3*s - 2)) + 66*k1**2*k2**2*(K*b1*(-26*r**2 + r*(23 - 26*s) + 3*s) + g2*(26*r**2 + 26*r*(s - 1) - 6*s))) - 429*b1**2*k2**2*(D1*fd*r*(26*K*k1**2*(r + s) + f*k1**2*(-34*r - 34*s + 19) + 2*f*k2**2*(9*r + 9*s - 5)) + Dd*f*(2*K*k1**2*(52*r**2 + r*(52*s - 33) - 3*s) + f*(k1**2*(-68*r**2 - 68*r*s + 55*r + 10*s - 6) + k2**2*(4*r - 1)*(9*r + 9*s - 5)))) + 13*b1*(D1*(f**2*fd*k2**2*(k1**2*(621*r**2 + 9*r*(69*s - 40) - 12*s + 8) + 33*k2**2*(3*r + 9*s - 5)) - 66*f*k1**2*(K*fd*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2) + fd*r*(2*C - 1)*(k1**2*(4*r + 4*s - 3) - 2*k2**2*(3*r + 3*s - 2)) - 2*gd2*k2**2*r*(13*r + 13*s - 10)) + 1716*fd*g2*k1**2*k2**2*r*(r + s)) + Dd*f*(f**2*k2**2*(k1**2*(828*r**2 + r*(828*s - 401) + 70*s - 90) + 66*k2**2*(1 - 4*r)) - 66*f*k1**2*(k1**2*(2*C - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + k2**2*(-2*C*(4*r - 1)*(3*r + 3*s - 2) + K*(28*r**2 + 28*r*s - 19*r - 5*s + 2) + (4*r - 1)*(3*r + 3*s - 2))) + 132*g2*k1**2*k2**2*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*(5*f**2*fd*k2**2*(-2*k1**2*(8*r**2 + 8*r*(s - 1) + 63*s - 31) + 65*k2**2*(4*r - 1)*(9*r + 9*s - 7)) - 26*f*k1**2*(fd*(2*C - 1)*(k1**2*(54*r**2 + 54*r*(s - 1) + 15*s + 1) - 33*k2**2*(3*r - 1)*(3*r + 3*s - 2)) - 66*gd2*k2**2*r*(7*r + 7*s - 4)) + 1716*fd*g2*k1**2*k2**2*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(5*f**2*k2**2*(-2*k1**2*(8*r**2 + 8*r*(s - 1) + 63*s - 31) + 65*k2**2*(4*r - 1)*(9*r + 9*s - 7)) + f*k1**2*(26 - 52*C)*(k1**2*(72*r**2 + 72*r*(s - 1) + 23*s - 7) - 33*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + 1716*g2*k1**2*k2**2*(28*r**2 + r*(28*s - 19) - 5*s + 2))))/(9009*d**2*k3**5) - D1**3*Pkd1*Pkd3*st**2*(-2*D1*bd1*f**2*k1**2*r*(2*C - 1)*(2*r + 2*s - 1) + b1**3*k2**2*(11*D1*fd*r*(r + s - 1) + Dd*f*(44*r**2 + r*(44*s - 37) - 2*s + 2)) + b1**2*(D1*(bd1*f*k2**2*(33*r**2 + r*(33*s - 26) - 2*s + 2) + 2*fd*(f*k2**2*(5*r - 2) + k1**2*r*(2 - 4*C))*(r + s - 1)) + Dd*f*(f*k2**2*(20*r**2 + r*(20*s - 23) - 4*s + 4) + k1**2*(2 - 4*C)*(8*r**2 + 8*r*(s - 1) - s + 1))) + b1*f*(D1*bd1*(f*k2**2*r*(10*r + 10*s - 9) + k1**2*(2 - 4*C)*(4*r**2 + 4*r*(s - 1) - s + 1)) + k1**2*(2 - 4*C)*(D1*fd*(4*r - 1)*(r + s - 1) + Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1))))/(21*d**2*k1*k3) + 2*D1**3*Pkd1*Pkd3*(-2*D1*bd1*f*k1**2*(b2 - 2*g2)*(2*r**2 + 2*r*(s - 1) - s) + 7*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1))*(r + s - 1) + b1**2*(-D1*(r + s - 1)*(4*K*fd*k1**2*(r - 1) + 7*bd1*f*k2**2*(1 - 3*r) + 6*f*fd*k2**2*(1 - 2*r)) + 2*Dd*f*(K*k1**2*(-8*r**2 + r*(12 - 8*s) + 5*s - 4) + 3*f*k2**2*(4*r - 1)*(r + s - 1))) - 2*b1*(4*D1*K*bd1*f*k1**2*r**2 + 4*D1*K*bd1*f*k1**2*r*s - 5*D1*K*bd1*f*k1**2*r - 2*D1*K*bd1*f*k1**2*s + D1*K*bd1*f*k1**2 - 6*D1*bd1*f**2*k2**2*r**2 - 6*D1*bd1*f**2*k2**2*r*s + 6*D1*bd1*f**2*k2**2*r + D1*bd2*f*k1**2*(2*r - 1)*(r + s - 1) - 4*D1*f*gd2*k1**2*r**2 - 4*D1*f*gd2*k1**2*r*s + 6*D1*f*gd2*k1**2*r + 2*D1*f*gd2*k1**2*s - 2*D1*f*gd2*k1**2 - 4*D1*fd*g2*k1**2*r**2 - 4*D1*fd*g2*k1**2*r*s + 8*D1*fd*g2*k1**2*r + 4*D1*fd*g2*k1**2*s - 4*D1*fd*g2*k1**2 - 16*Dd*f*g2*k1**2*r**2 - 16*Dd*f*g2*k1**2*r*s + 24*Dd*f*g2*k1**2*r + 10*Dd*f*g2*k1**2*s - 8*Dd*f*g2*k1**2 + b2*k1**2*(2*D1*fd*(r - 1)*(r + s - 1) + Dd*f*(8*r**2 + 8*r*s - 12*r - 5*s + 4))))/(21*d**2*k1*k3) + D1**3*Pkd1*Pkd3*st**2*(33*b1**3*k1**2*k2**2*(15*D1*fd*r*(r + s - 1) + Dd*f*(60*r**2 + r*(60*s - 53) - 4*s + 4)) - 33*b1**2*(D1*(bd1*f*k1**2*k2**2*(-45*r**2 - 45*r*s + 38*r + 4*s - 4) + fd*(-26*K*k1**2*k2**2*r*(r + s) + f*k1**2*k2**2*(16*r**2 + 16*r*s + 3*r + 6*s - 6) - 4*f*k2**4*r*(3*r + 3*s - 2) + k1**4*r*(8*C - 4)*(r + s - 1))) + 2*Dd*f*(-f*k2**4*(4*r - 1)*(3*r + 3*s - 2) + k1**4*(2*C - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + k1**2*k2**2*(K*(-52*r**2 + r*(33 - 52*s) + 3*s) + 2*f*(8*r**2 + r*(8*s - 4) - s)))) + b1*(-33*D1*bd1*f*(-2*f*k2**4*(2*r - 1)*(3*r + 3*s - 2) + k1**4*(4*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + k1**2*k2**2*(2*K*(-26*r**2 + r*(23 - 26*s) + 3*s) + f*(16*r**2 + r*(16*s - 19) - 10*s + 6))) + 3*D1*(f**2*fd*k2**2*(k1**2*(-243*r**2 - 243*r*s + 156*r + 4*s + 8) + 22*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + 22*f*k1**2*(fd*k1**2*(2*C - 1)*(2*r + s - 1) + fd*k2**2*(K*(14*r**2 + r*(14*s - 11) - 5*s + 2) + r*(2 - 4*C)*(3*r + 3*s - 2)) + k2**2*r*(bd2 - 2*gd2)*(13*r + 13*s - 10)) + 286*fd*k1**2*k2**2*r*(b2 - 2*g2)*(r + s)) + Dd*f*k2**2*(f**2*(k1**2*(-972*r**2 + r*(545 - 972*s) - 52*s + 72) + 66*k2**2*(4*r - 1)*(3*r + 3*s - 2)) - 66*f*k1**2*(2*C*(4*r - 1)*(3*r + 3*s - 2) + K*(-28*r**2 - 28*r*s + 19*r + 5*s - 2) - (4*r - 1)*(3*r + 3*s - 2)) + k1**2*(66*b2 - 132*g2)*(52*r**2 + r*(52*s - 33) - 3*s))) + f*(D1*bd1*(f**2*k2**2*(k1**2*(-243*r**2 + r*(77 - 243*s) - 64*s + 48) + 66*k2**2*r*(3*r + 3*s - 2)) - 66*f*k1**2*(k1**2*(2*C - 1)*(2*r + s - 1) + k2**2*(2*C*(r - 1)*(3*r + 3*s - 2) - r**2*(7*K + 3) + r*(-7*K*s + 4*K - 3*s + 5) + 3*s - 2)) + k1**2*k2**2*(66*b2 - 132*g2)*(13*r**2 + 13*r*(s - 1) - 3*s)) + 2*k1**2*(D1*(f*(fd*(2*C - 1)*(k1**2*(54*r**2 + 54*r*(s - 1) + 15*s + 1) - 33*k2**2*(3*r - 1)*(3*r + 3*s - 2)) + k2**2*r*(33*bd2 - 66*gd2)*(7*r + 7*s - 4)) + 33*fd*k2**2*(b2 - 2*g2)*(14*r**2 + r*(14*s - 11) - 5*s + 2)) + Dd*f*(f*(2*C - 1)*(k1**2*(72*r**2 + 72*r*(s - 1) + 23*s - 7) - 33*k2**2*(4*r - 1)*(3*r + 3*s - 2)) + k2**2*(33*b2 - 66*g2)*(28*r**2 + r*(28*s - 19) - 5*s + 2)))))/(693*d**2*k1*k3**3)
        perm23 = -160*D1**3*Pk2*Pk3*ct**8*f*k1**2*k2**4*(3978*C*D1*f*fd*r**2 + 7956*C*D1*f*fd*r*s - 4446*C*D1*f*fd*r + 3978*C*D1*f*fd*s**2 - 4446*C*D1*f*fd*s + 1196*C*D1*f*fd + 5304*C*Dd*f**2*r**2 + 10608*C*Dd*f**2*r*s - 6370*C*Dd*f**2*r + 5304*C*Dd*f**2*s**2 - 6370*C*Dd*f**2*s + 1794*C*Dd*f**2 + 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3584*D1*f**2*fd*r**2 + 7168*D1*f**2*fd*r*s - 5012*D1*f**2*fd*r + 3584*D1*f**2*fd*s**2 - 5012*D1*f**2*fd*s + 1743*D1*f**2*fd - 3978*D1*f*fd*r**2 - 7956*D1*f*fd*r*s + 4446*D1*f*fd*r - 3978*D1*f*fd*s**2 + 4446*D1*f*fd*s - 1196*D1*f*fd - 1716*D1*f*gd2*r**2 - 3432*D1*f*gd2*r*s + 2574*D1*f*gd2*r - 1716*D1*f*gd2*s**2 + 2574*D1*f*gd2*s - 858*D1*f*gd2 - 3432*D1*fd*g2*r**2 - 6864*D1*fd*g2*r*s + 3432*D1*fd*g2*r - 3432*D1*fd*g2*s**2 + 3432*D1*fd*g2*s - 858*D1*fd*g2 + 3584*Dd*f**3*r**2 + 7168*Dd*f**3*r*s - 5012*Dd*f**3*r + 3584*Dd*f**3*s**2 - 5012*Dd*f**3*s + 1743*Dd*f**3 - 5304*Dd*f**2*r**2 - 10608*Dd*f**2*r*s + 6370*Dd*f**2*r - 5304*Dd*f**2*s**2 + 6370*Dd*f**2*s - 1794*Dd*f**2 - 6864*Dd*f*g2*r**2 - 13728*Dd*f*g2*r*s + 8580*Dd*f*g2*r - 6864*Dd*f*g2*s**2 + 8580*Dd*f*g2*s - 2574*Dd*f*g2 + 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**7*f*k1*k2**3*(-13*D1*bd1*f*(k1**2*(132*K - 132)*(11*r + 11*s - 7) - 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) - 2*D1*(35*f**2*fd*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 13*f*(5*fd*(k1**2*(2*C - 2)*(315*r**2 + 9*r*(70*s - 43) + 315*s**2 - 387*s + 118) + k2**2*(4*C*(153*r**2 + 504*r*s - 204*r + 153*s**2 - 303*s + 79) - 459*r**2 - 1314*r*s + 579*r - 459*s**2 + 777*s - 204)) - 132*gd2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(r + s - 1)) - 1716*fd*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - 2*Dd*f*(35*f**2*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 65*f*(k1**2*(2*C - 2)*(420*r**2 + r*(840*s - 551) + 420*s**2 - 551*s + 177) + k2**2*(4*C*(204*r**2 + 672*r*s - 278*r + 204*s**2 - 443*s + 102) - 612*r**2 - 1752*r*s + 801*r - 612*s**2 + 1131*s - 273)) - 1716*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(k1**2*(132 - 132*K)*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7) + 5*k2**2*(f*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(132 - 132*K)*(11*r + 11*s - 7) + 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(3003*d**2*k3**8) - 80*D1**3*Pk2*Pk3*ct**6*f*k1**2*k2**4*st**2*(12402*C*D1*f*fd*r**2 + 24804*C*D1*f*fd*r*s - 14820*C*D1*f*fd*r + 12402*C*D1*f*fd*s**2 - 14820*C*D1*f*fd*s + 4368*C*D1*f*fd + 16536*C*Dd*f**2*r**2 + 33072*C*Dd*f**2*r*s - 21138*C*Dd*f**2*r + 16536*C*Dd*f**2*s**2 - 21138*C*Dd*f**2*s + 6552*C*Dd*f**2 + 1287*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 16492*D1*f**2*fd*r**2 + 32984*D1*f**2*fd*r*s - 23373*D1*f**2*fd*r + 16492*D1*f**2*fd*s**2 - 23373*D1*f**2*fd*s + 8253*D1*f**2*fd - 12402*D1*f*fd*r**2 - 24804*D1*f*fd*r*s + 14820*D1*f*fd*r - 12402*D1*f*fd*s**2 + 14820*D1*f*fd*s - 4368*D1*f*fd - 5148*D1*f*gd2*r**2 - 10296*D1*f*gd2*r*s + 7722*D1*f*gd2*r - 5148*D1*f*gd2*s**2 + 7722*D1*f*gd2*s - 2574*D1*f*gd2 - 10296*D1*fd*g2*r**2 - 20592*D1*fd*g2*r*s + 10296*D1*fd*g2*r - 10296*D1*fd*g2*s**2 + 10296*D1*fd*g2*s - 2574*D1*fd*g2 + 16492*Dd*f**3*r**2 + 32984*Dd*f**3*r*s - 23373*Dd*f**3*r + 16492*Dd*f**3*s**2 - 23373*Dd*f**3*s + 8253*Dd*f**3 - 16536*Dd*f**2*r**2 - 33072*Dd*f**2*r*s + 21138*Dd*f**2*r - 16536*Dd*f**2*s**2 + 21138*Dd*f**2*s - 6552*Dd*f**2 - 20592*Dd*f*g2*r**2 - 41184*Dd*f*g2*r*s + 25740*Dd*f*g2*r - 20592*Dd*f*g2*s**2 + 25740*Dd*f*g2*s - 7722*Dd*f*g2 + 1287*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(3003*d**2*k3**8) - 16*D1**3*Pk2*Pk3*ct**6*k2**2*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + k1**2*k2**2*(r + s)*(-792*K*b1 + 792*b1 + 792*g2)) + 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k1**2*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) - 66*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 792*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + 792*g2*k1**2*k2**2*(r + s))) + 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**4*(6*C - 6)*(42*r**2 + r*(84*s - 67) + 42*s**2 - 67*s + 26) + k1**2*k2**2*(2*C*(432*r**2 + 6*r*(309*s - 118) + 432*s**2 - 1203*s + 335) - 549*r**2 - 72*r*(29*s - 12) - 549*s**2 + 1359*s - 387) + k2**4*(2*C - 1)*(153*r**2 + 12*r*(42*s - 17) + 153*s**2 - 303*s + 79)) - 66*gd2*(12*k1**4*(r + s - 1)**2 + 2*k1**2*k2**2*(16*r**2 + r*(32*s - 27) + 16*s**2 - 27*s + 11) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 858*fd*g2*(12*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**2*k2**2*(32*r**2 + r*(64*s - 38) + 32*s**2 - 38*s + 11) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(70*f**2*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 65*f*(k1**4*(6*C - 6)*(56*r**2 + 2*r*(56*s - 47) + 56*s**2 - 94*s + 39) + k1**2*k2**2*(2*C*(576*r**2 + r*(2472*s - 937) + 576*s**2 - 1762*s + 420) - 732*r**2 - 3*r*(928*s - 386) - 732*s**2 + 1983*s - 498) + k2**4*(2*C - 1)*(204*r**2 + r*(672*s - 278) + 204*s**2 - 443*s + 102)) - 858*g2*(12*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k1**2*k2**2*(64*r**2 + 4*r*(32*s - 23) + 64*s**2 - 92*s + 33) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3003*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct**5*f*k1*k2**3*st**2*(-231192*C*D1*f*fd*k1**2*r**2 - 462384*C*D1*f*fd*k1**2*r*s + 291096*C*D1*f*fd*k1**2*r - 231192*C*D1*f*fd*k1**2*s**2 + 291096*C*D1*f*fd*k1**2*s - 91312*C*D1*f*fd*k1**2 - 248040*C*D1*f*fd*k2**2*r**2 - 702000*C*D1*f*fd*k2**2*r*s + 330720*C*D1*f*fd*k2**2*r - 248040*C*D1*f*fd*k2**2*s**2 + 433680*C*D1*f*fd*k2**2*s - 121680*C*D1*f*fd*k2**2 - 308256*C*Dd*f**2*k1**2*r**2 - 616512*C*Dd*f**2*k1**2*r*s + 413816*C*Dd*f**2*k1**2*r - 308256*C*Dd*f**2*k1**2*s**2 + 413816*C*Dd*f**2*k1**2*s - 136968*C*Dd*f**2*k1**2 - 330720*C*Dd*f**2*k2**2*r**2 - 936000*C*Dd*f**2*k2**2*r*s + 457080*C*Dd*f**2*k2**2*r - 330720*C*Dd*f**2*k2**2*s**2 + 628680*C*Dd*f**2*k2**2*s - 165360*C*Dd*f**2*k2**2 - 39*D1*bd1*f*(k1**2*(44*K - 44)*(31*r + 31*s - 17) - 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) - 437100*D1*f**2*fd*k1**2*r**2 - 874200*D1*f**2*fd*k1**2*r*s + 637125*D1*f**2*fd*k1**2*r - 437100*D1*f**2*fd*k1**2*s**2 + 637125*D1*f**2*fd*k1**2*s - 231975*D1*f**2*fd*k1**2 + 231192*D1*f*fd*k1**2*r**2 + 462384*D1*f*fd*k1**2*r*s - 291096*D1*f*fd*k1**2*r + 231192*D1*f*fd*k1**2*s**2 - 291096*D1*f*fd*k1**2*s + 91312*D1*f*fd*k1**2 + 186030*D1*f*fd*k2**2*r**2 + 475020*D1*f*fd*k2**2*r*s - 239460*D1*f*fd*k2**2*r + 186030*D1*f*fd*k2**2*s**2 - 290940*D1*f*fd*k2**2*s + 82680*D1*f*fd*k2**2 + 106392*D1*f*gd2*k1**2*r**2 + 212784*D1*f*gd2*k1**2*r*s - 164736*D1*f*gd2*k1**2*r + 106392*D1*f*gd2*k1**2*s**2 - 164736*D1*f*gd2*k1**2*s + 58344*D1*f*gd2*k1**2 + 102960*D1*f*gd2*k2**2*r**2 + 205920*D1*f*gd2*k2**2*r*s - 154440*D1*f*gd2*k2**2*r + 102960*D1*f*gd2*k2**2*s**2 - 154440*D1*f*gd2*k2**2*s + 51480*D1*f*gd2*k2**2 + 212784*D1*fd*g2*k1**2*r**2 + 425568*D1*fd*g2*k1**2*r*s - 223080*D1*fd*g2*k1**2*r + 212784*D1*fd*g2*k1**2*s**2 - 223080*D1*fd*g2*k1**2*s + 58344*D1*fd*g2*k1**2 + 205920*D1*fd*g2*k2**2*r**2 + 411840*D1*fd*g2*k2**2*r*s - 205920*D1*fd*g2*k2**2*r + 205920*D1*fd*g2*k2**2*s**2 - 205920*D1*fd*g2*k2**2*s + 51480*D1*fd*g2*k2**2 - 437100*Dd*f**3*k1**2*r**2 - 874200*Dd*f**3*k1**2*r*s + 637125*Dd*f**3*k1**2*r - 437100*Dd*f**3*k1**2*s**2 + 637125*Dd*f**3*k1**2*s - 231975*Dd*f**3*k1**2 + 308256*Dd*f**2*k1**2*r**2 + 616512*Dd*f**2*k1**2*r*s - 413816*Dd*f**2*k1**2*r + 308256*Dd*f**2*k1**2*s**2 - 413816*Dd*f**2*k1**2*s + 136968*Dd*f**2*k1**2 + 248040*Dd*f**2*k2**2*r**2 + 633360*Dd*f**2*k2**2*r*s - 334230*Dd*f**2*k2**2*r + 248040*Dd*f**2*k2**2*s**2 - 420030*Dd*f**2*k2**2*s + 115440*Dd*f**2*k2**2 + 425568*Dd*f*g2*k1**2*r**2 + 851136*Dd*f*g2*k1**2*r*s - 552552*Dd*f*g2*k1**2*r + 425568*Dd*f*g2*k1**2*s**2 - 552552*Dd*f*g2*k1**2*s + 175032*Dd*f*g2*k1**2 + 411840*Dd*f*g2*k2**2*r**2 + 823680*Dd*f*g2*k2**2*r*s - 514800*Dd*f*g2*k2**2*r + 411840*Dd*f*g2*k2**2*s**2 - 514800*Dd*f*g2*k2**2*s + 154440*Dd*f*g2*k2**2 + 39*b1*(D1*fd*(k1**2*(44 - 44*K)*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17) + 5*k2**2*(f*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(44 - 44*K)*(31*r + 31*s - 17) + 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**5*k1*k2*(13*D1*bd1*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 66*f*(k1**4*(2*K - 2)*(r**2 + 2*r*s + s**2 - 1) - 2*k1**2*k2**2*(r + s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5) + 2*K*r**2 + 4*K*r*s + 2*K*s**2 - 2*K + 2*b1*(7*r**2 + r*(14*s - 9) + 7*s**2 - 9*s + 2) + 24*r*s - 3*r - 3*s + 3)) + 264*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-5*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*k2**2*(14*r**2 + r*(28*s - 11) + 14*s**2 - 11*s + 2) + (r + s)**2*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(7*r + 7*s - 2) + (r + s)*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*(fd*(k1**4*(2*K - 2)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) - 2*k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 2*K*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 6*r*(8*s + 3) - 18*s - 9)) + 4*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 66*f*(k1**4*(2*K - 2)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 2*k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 2*K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 96*r*s + 24*r - 36*s - 15)) + 264*g2*k2**2*(5*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*fd*(k1**4*(2*C - 2)*(81*r**2 + 3*r*(54*s - 25) + 81*s**2 - 75*s + 14) + 3*k1**2*k2**2*(2*C*(81*r**2 - 102*r*s - 31*r + 81*s**2 + 101*s - 30) - 204*r**2 - 144*r*s + 173*r - 204*s**2 + 41*s - 10) + k2**4*(2*C*(81*r**2 - 9*r*(26*s + 1) + 81*s**2 + 189*s - 52) - 279*r**2 - 162*r*s + 240*r - 279*s**2 + 42*s - 14)) + 1716*f*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + 2*r*s + s**2 - 1) + 1716*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1)) + Dd*f*(70*f**2*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*(k1**4*(2*C - 2)*(108*r**2 + r*(216*s - 109) + 108*s**2 - 109*s + 21) + 3*k1**2*k2**2*(2*C*(108*r**2 - 136*r*s - 65*r + 108*s**2 + 155*s - 23) - 272*r**2 - 192*r*s + 268*r - 272*s**2 + 48*s - 37) + k2**4*(C*(216*r**2 - 624*r*s - 86*r + 216*s**2 + 574*s - 90) - 372*r**2 - 216*r*s + 373*r - 372*s**2 + 43*s - 54)) + 1716*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3))))/(3003*d**2*k3**8) - 160*D1**3*Pk2*Pk3*ct**4*f**2*k1**2*k2**4*st**4*(D1*fd*(78*C*(3*r + 3*s - 2)**2 + 7*f*(268*r**2 + 536*r*s - 389*r + 268*s**2 - 389*s + 141) - 78*(3*r + 3*s - 2)**2) + Dd*f*(4*r + 4*s - 3)*(78*C*(3*r + 3*s - 2) + 7*f*(67*r + 67*s - 47) - 234*r - 234*s + 156))/(1001*d**2*k3**8) - 8*D1**3*Pk2*Pk3*ct**4*k2**2*st**2*(-39*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + k1**2*k2**2*(r + s)*(-264*K*b1 + 264*b1 + 264*g2)) + 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 39*b1*(D1*(5*f**2*fd*k1**2*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) - 22*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + 264*g2*k1**2*k2**2*(r + s))) + f*(D1*(375*f**2*fd*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 26*f*(fd*(k1**4*(612*C - 612)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(3852*r**2 + 18*r*(659*s - 311) + 3852*s**2 - 7677*s + 2251) - 5481*r**2 - 72*r*(210*s - 107) - 5481*s**2 + 9783*s - 2931) + k2**4*(30*C - 15)*(159*r**2 + r*(450*s - 212) + 159*s**2 - 278*s + 78)) - 66*gd2*(9*k1**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 2*k1**2*k2**2*(56*r**2 + r*(112*s - 87) + 56*s**2 - 87*s + 31) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 1716*fd*g2*(9*k1**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k1**2*k2**2*(112*r**2 + 2*r*(112*s - 59) + 112*s**2 - 118*s + 31) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(375*f**2*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 26*f*(k1**4*(612*C - 612)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(5136*r**2 + r*(15816*s - 7661) + 5136*s**2 - 11126*s + 3030) - 7308*r**2 - 30*r*(672*s - 355) - 7308*s**2 + 14115*s - 4050) + k2**4*(30*C - 15)*(212*r**2 + r*(600*s - 293) + 212*s**2 - 403*s + 106)) - 1716*g2*(9*k1**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k1**2*k2**2*(224*r**2 + 4*r*(112*s - 73) + 224*s**2 - 292*s + 93) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**4*(-429*D1*bd1*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 2*f*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**4*k2**2*(r + s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) + 2*k1**2*k2**4*(-2*C*(r**2 + 4*r*(8*s - 3) + s**2 - 12*s + 11) + 12*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1*(17*r**2 + r*(34*s - 21) + 17*s**2 - 21*s + 4) - 15*r**2 + 15*r - 15*s*(s - 1)) + k2**6*(-2*C*(4*r**2 + r*(20*s - 9) + 4*s**2 - 9*s + 5) + 6*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5)) + 4*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)) - g2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 858*b1**2*k2**2*(D1*fd*(f*k1**2*k2**2*(34*r**2 + r*(68*s - 25) + 34*s**2 - 25*s + 4) - (r + s)**2*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3))) + Dd*f*(f*k1**2*k2**2*(17*r + 17*s - 4) - (r + s)*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)))*(4*r + 4*s - 3)) - 429*b1*(D1*(5*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(k1**6*(K - 1)*(2*r + 2*s - 1)**2 + 2*k1**4*k2**2*(2*r + 2*s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(2*r**2 + 64*r*s + 7*r + 2*s**2 - 38*s - 4) - 12*K*(2*r + 2*s - 1)**2 + 30*r**2 - 45*r + 30*s**2 + 15) + k2**6*(-2*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 6*K*(2*r + 2*s - 1)**2 + 8*r**2 + 40*r*s - 2*r + 8*s**2 - 20*s - 1)) + 2*gd2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*fd*g2*k2**2*(r + s)**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)) + Dd*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 2*f*(k1**6*(K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 2*k1**4*k2**2*(4*r + 4*s - 3)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(4*r**2 + 2*r*(64*s - 1) + 4*s**2 - 77*s + 3) - 12*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 60*r**2 - 90*r + 60*s**2 - 15*s + 30) + k2**6*(-2*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 6*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 16*r**2 + 80*r*s - 14*r + 16*s**2 - 44*s + 3)) - 4*g2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + 2*f*(D1*(35*f**2*fd*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**6*(10*C - 10)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(558*r**2 + r*(918*s - 678) + 558*s**2 - 579*s + 193) - 1035*r**2 - 18*r*(104*s - 73) - 1035*s**2 + 1215*s - 405) + 3*k1**2*k2**4*(2*C*(288*r**2 + 170*r*(3*s - 2) + 288*s**2 - 307*s + 95) - 453*r**2 + r*(549 - 840*s) - 453*s**2 + 516*s - 161) + k2**6*(66*C - 33)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 858*fd*g2*(2*r + 2*s - 1)**2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)) + Dd*f*(35*f**2*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 65*f*(k1**6*(10*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(2*C*(744*r**2 + r*(1224*s - 977) + 744*s**2 - 812*s + 306) - 1380*r**2 - 3*r*(832*s - 626) - 1380*s**2 + 1713*s - 624) + 3*k1**2*k2**4*(2*C*(384*r**2 + r*(680*s - 489) + 384*s**2 - 434*s + 148) - 604*r**2 + r*(786 - 1120*s) - 604*s**2 + 731*s - 247) + k2**6*(66*C - 33)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 858*g2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**3*f*k1*k2**3*st**4*(-9360*C*D1*f*fd*k1**2*r**2 - 18720*C*D1*f*fd*k1**2*r*s + 12480*C*D1*f*fd*k1**2*r - 9360*C*D1*f*fd*k1**2*s**2 + 12480*C*D1*f*fd*k1**2*s - 4160*C*D1*f*fd*k1**2 - 14040*C*D1*f*fd*k2**2*r**2 - 28080*C*D1*f*fd*k2**2*r*s + 18720*C*D1*f*fd*k2**2*r - 14040*C*D1*f*fd*k2**2*s**2 + 18720*C*D1*f*fd*k2**2*s - 6240*C*D1*f*fd*k2**2 - 12480*C*Dd*f**2*k1**2*r**2 - 24960*C*Dd*f**2*k1**2*r*s + 17680*C*Dd*f**2*k1**2*r - 12480*C*Dd*f**2*k1**2*s**2 + 17680*C*Dd*f**2*k1**2*s - 6240*C*Dd*f**2*k1**2 - 18720*C*Dd*f**2*k2**2*r**2 - 37440*C*Dd*f**2*k2**2*r*s + 26520*C*Dd*f**2*k2**2*r - 18720*C*Dd*f**2*k2**2*s**2 + 26520*C*Dd*f**2*k2**2*s - 9360*C*Dd*f**2*k2**2 - 26*D1*bd1*f*(-35*f*k2**2*(3*r + 3*s - 2) + k1**2*(33*K - 33)*(3*r + 3*s - 1))*(r + s - 1) - 39100*D1*f**2*fd*k1**2*r**2 - 78200*D1*f**2*fd*k1**2*r*s + 57545*D1*f**2*fd*k1**2*r - 39100*D1*f**2*fd*k1**2*s**2 + 57545*D1*f**2*fd*k1**2*s - 21165*D1*f**2*fd*k1**2 + 9360*D1*f*fd*k1**2*r**2 + 18720*D1*f*fd*k1**2*r*s - 12480*D1*f*fd*k1**2*r + 9360*D1*f*fd*k1**2*s**2 - 12480*D1*f*fd*k1**2*s + 4160*D1*f*fd*k1**2 + 10530*D1*f*fd*k2**2*r**2 + 21060*D1*f*fd*k2**2*r*s - 14040*D1*f*fd*k2**2*r + 10530*D1*f*fd*k2**2*s**2 - 14040*D1*f*fd*k2**2*s + 4680*D1*f*fd*k2**2 + 5148*D1*f*gd2*k1**2*r**2 + 10296*D1*f*gd2*k1**2*r*s - 6864*D1*f*gd2*k1**2*r + 5148*D1*f*gd2*k1**2*s**2 - 6864*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 10296*D1*fd*g2*k1**2*r**2 + 20592*D1*fd*g2*k1**2*r*s - 8580*D1*fd*g2*k1**2*r + 10296*D1*fd*g2*k1**2*s**2 - 8580*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 - 39100*Dd*f**3*k1**2*r**2 - 78200*Dd*f**3*k1**2*r*s + 57545*Dd*f**3*k1**2*r - 39100*Dd*f**3*k1**2*s**2 + 57545*Dd*f**3*k1**2*s - 21165*Dd*f**3*k1**2 + 12480*Dd*f**2*k1**2*r**2 + 24960*Dd*f**2*k1**2*r*s - 17680*Dd*f**2*k1**2*r + 12480*Dd*f**2*k1**2*s**2 - 17680*Dd*f**2*k1**2*s + 6240*Dd*f**2*k1**2 + 14040*Dd*f**2*k2**2*r**2 + 28080*Dd*f**2*k2**2*r*s - 19890*Dd*f**2*k2**2*r + 14040*Dd*f**2*k2**2*s**2 - 19890*Dd*f**2*k2**2*s + 7020*Dd*f**2*k2**2 + 20592*Dd*f*g2*k1**2*r**2 + 41184*Dd*f*g2*k1**2*r*s - 22308*Dd*f*g2*k1**2*r + 20592*Dd*f*g2*k1**2*s**2 - 22308*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 - k1**2*(33*K - 33)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) - k1**2*(33*K - 33)*(3*r + 3*s - 1))*(4*r + 4*s - 3)))/(1001*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**3*k1*k2*st**2*(13*D1*bd1*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(r + s - 1) - 33*f*(k1**4*(K - 1)*(13*r**2 + r*(26*s - 22) + 13*s**2 - 22*s + 9) + k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(3*r**2 + 8*r*s - 5*r + 3*s**2 - 5*s + 2) + 38*K*r**2 + 76*K*r*s - 60*K*r + 38*K*s**2 - 60*K*s + 22*K - 2*b1*(17*r**2 + r*(34*s - 24) + 17*s**2 - 24*s + 7) - 15*r**2 - 42*r*s + 24*r - 15*s**2 + 24*s - 9)) + 132*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-13*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(13*k1**2 + 6*k2**2))) + 429*b1**2*k2**2*(D1*fd*(f*k2**2*(34*r**2 + r*(68*s - 31) + 34*s**2 - 31*s + 7) + (r + s)**2*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(17*r + 17*s - 7) + (r + s)*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 33*f*(fd*(k1**4*(K - 1)*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) + 2*K*(38*r**2 + 76*r*s - 41*r + 38*s**2 - 41*s + 11) - 30*r**2 - 84*r*s + 21*r - 30*s**2 + 39*s - 3)) - 4*gd2*k2**2*(13*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 33*f*(k1**4*(K - 1)*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(12*r**2 + 2*r*(16*s - 7) + 12*s**2 - 19*s + 4) + 2*K*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33) - 60*r**2 - 21*r*(8*s - 3) - 60*s**2 + 93*s - 15)) + 132*g2*k2**2*(13*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-25*f**2*fd*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(fd*(k1**4*(9*C - 9)*(69*r**2 + r*(138*s - 103) + 69*s**2 - 103*s + 38) + 3*k1**2*k2**2*(C*(1341*r**2 + 4530*r*s - 2129*r + 1341*s**2 - 3053*s + 926) - 882*r**2 - 2688*r*s + 1363*r - 882*s**2 + 1825*s - 568) + k2**4*(2*C*(1035*r**2 + 3654*r*s - 1677*r + 1035*s**2 - 2469*s + 746) - 441*r**2 - 2466*r*s + 984*r - 441*s**2 + 1776*s - 548)) - 33*gd2*(k1**4*(13*r**2 + 26*r*s - 22*r + 13*s**2 - 22*s + 9) + 15*k1**2*k2**2*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3) + 2*k2**4*(19*r**2 + 38*r*s - 30*r + 19*s**2 - 30*s + 11))) + 858*fd*g2*(k1**4*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + 15*k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k2**4*(38*r**2 + r*(76*s - 41) + 38*s**2 - 41*s + 11))) + Dd*f*(-25*f**2*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(k1**4*(9*C - 9)*(92*r**2 + r*(184*s - 145) + 92*s**2 - 145*s + 57) + 3*k1**2*k2**2*(C*(1788*r**2 + 6040*r*s - 2885*r + 1788*s**2 - 4425*s + 1235) - 1176*r**2 - 3584*r*s + 1864*r - 1176*s**2 + 2634*s - 775) + k2**4*(2*C*(1380*r**2 + 4872*r*s - 2263*r + 1380*s**2 - 3583*s + 987) - 588*r**2 - 3288*r*s + 1273*r - 588*s**2 + 2593*s - 690)) + 858*g2*(k1**4*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + 15*k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k2**4*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33)))))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**3*k1*(D1*(858*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) + 5*f**3*k1**2*(-13*bd1*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(r + s - 1) + 14*fd*k1**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 13*f**2*k2**2*(66*bd1*(k1**4*(r + s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(2*r**2 - r + 2*s**2 - s - 1) + 25*K*r**2 + 50*K*r*s - 42*K*r + 25*K*s**2 - 42*K*s + 17*K + b1*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s - 1) - 33*r**2 - 42*r*s + 39*r - 33*s**2 + 39*s - 6) - 2*k2**4*(-8*C*(r**2 - r*s + s**2 - 1) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 2*r*s - 3*r + 7*s**2 - 3*s - 4)) - 5*fd*(3*r + 3*s - 2)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 264*gd2*(k1**4*(5*r**2 + r*(10*s - 9) + 5*s**2 - 9*s + 4) + k1**2*k2**2*(25*r**2 + r*(50*s - 42) + 25*s**2 - 42*s + 17) + 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 858*f*k2**2*(-b1**2*fd*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - b1*(fd*(k1**4*(2*r + 2*s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(4*r**2 - 4*r + 4*s**2 + 2*s + 1) + K*(50*r**2 + 100*r*s - 59*r + 50*s**2 - 59*s + 17) - 66*r**2 - 84*r*s + 69*r - 66*s**2 + 33*s - 18) + 2*k2**4*(4*C*(4*r**2 - 4*r*(s + 1) + 4*s**2 + 5*s + 1) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 14*r**2 - 4*r*s + 11*r - 14*s**2 - 7*s - 2)) + (2*bd1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(2*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(10*r**2 + r*(20*s - 13) + 10*s**2 - 13*s + 4) + k1**2*k2**2*(50*r**2 + r*(100*s - 59) + 50*s**2 - 59*s + 17) + 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(858*b1*k2**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 70*f**3*k1**4*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 65*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 858*f*k2**2*(-b1**2*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - b1*(k1**4*(4*r + 4*s - 3)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(8*r**2 - 8*r + 8*s**2 + 2*s + 1) + K*(100*r**2 + 200*r*s - 143*r + 100*s**2 - 143*s + 51) - 132*r**2 - 168*r*s + 159*r - 132*s**2 + 99*s - 42) + 2*k2**4*(-4*C*r*(8*s + 7) + 32*C*s*(s + 1) + 3*K*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + r**2*(32*C - 28) - 8*r*s + 23*r - 7*s*(4*s + 1))) + 4*g2*(k1**4*(20*r**2 + r*(40*s - 31) + 20*s**2 - 31*s + 12) + k1**2*k2**2*(100*r**2 + r*(200*s - 143) + 100*s**2 - 143*s + 51) + 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(3003*d**2*k2*k3**8) - 80*D1**3*Pk2*Pk3*ct**2*f*k1**2*k2**4*st**6*(-234*C*D1*f*fd*r**2 - 468*C*D1*f*fd*r*s + 312*C*D1*f*fd*r - 234*C*D1*f*fd*s**2 + 312*C*D1*f*fd*s - 104*C*D1*f*fd - 312*C*Dd*f**2*r**2 - 624*C*Dd*f**2*r*s + 442*C*Dd*f**2*r - 312*C*Dd*f**2*s**2 + 442*C*Dd*f**2*s - 156*C*Dd*f**2 - 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1708*D1*f**2*fd*r**2 + 3416*D1*f**2*fd*r*s - 2653*D1*f**2*fd*r + 1708*D1*f**2*fd*s**2 - 2653*D1*f**2*fd*s + 1029*D1*f**2*fd + 234*D1*f*fd*r**2 + 468*D1*f*fd*r*s - 312*D1*f*fd*r + 234*D1*f*fd*s**2 - 312*D1*f*fd*s + 104*D1*f*fd + 1716*D1*f*gd2*r**2 + 3432*D1*f*gd2*r*s - 2574*D1*f*gd2*r + 1716*D1*f*gd2*s**2 - 2574*D1*f*gd2*s + 858*D1*f*gd2 + 3432*D1*fd*g2*r**2 + 6864*D1*fd*g2*r*s - 3432*D1*fd*g2*r + 3432*D1*fd*g2*s**2 - 3432*D1*fd*g2*s + 858*D1*fd*g2 + 1708*Dd*f**3*r**2 + 3416*Dd*f**3*r*s - 2653*Dd*f**3*r + 1708*Dd*f**3*s**2 - 2653*Dd*f**3*s + 1029*Dd*f**3 + 312*Dd*f**2*r**2 + 624*Dd*f**2*r*s - 442*Dd*f**2*r + 312*Dd*f**2*s**2 - 442*Dd*f**2*s + 156*Dd*f**2 + 6864*Dd*f*g2*r**2 + 13728*Dd*f*g2*r*s - 8580*Dd*f*g2*r + 6864*Dd*f*g2*s**2 - 8580*Dd*f*g2*s + 2574*Dd*f*g2 - 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**2*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(b1*(K - 1) - 2*g2) - 15*f**3*k1**2*(-104*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 26*f**2*(fd*(3*r + 3*s - 2)**2*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 33*k1**2*(bd1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*gd2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))*(r + s - 1)) - 858*f*k1**2*(b1*fd*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2))*(2*r + 2*s - 1) + 2*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-K*bd1 + bd1 + gd2) + 2*bd1*g2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*fd*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3))*(2*r + 2*s - 1))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k1**2*k2**2*(r + s)*(b1*(K - 1) - 2*g2) + 15*f**3*k1**2*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2)) + 26*f**2*(3*r + 3*s - 2)*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 858*f*k1**2*(b1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))))/(1001*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct**2*st**2*(-429*D1*bd1*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + f*(k1**6*(K - 1)*(r + s - 1)**2 + k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(31*r**2 + 84*r*s - 54*r + 31*s**2 - 54*s + 23) + 15*K*r**2 + 30*K*r*s - 24*K*r + 15*K*s**2 - 24*K*s + 9*K - 12*b1*(7*r**2 + 2*r*(7*s - 5) + 7*s**2 - 10*s + 3) - 31*r**2 - 84*r*s + 51*r - 31*s**2 + 51*s - 20) + 3*k2**6*(2*C*(3*r**2 + r*(8*s - 5) + 3*s**2 - 5*s + 2) - 2*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 3*r**2 - 8*r*s + 5*r - 3*s**2 + 5*s - 2)) + 2*k2**2*(b1*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)) - g2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 429*b1**2*k2**2*(D1*fd*(6*f*k1**2*k2**2*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) - (r + s)**2*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33))) + Dd*f*(6*f*k1**2*k2**2*(7*r + 7*s - 3) - (r + s)*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)))*(4*r + 4*s - 3)) - 429*b1*(D1*(3*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(62*r**2 + r*(168*s - 55) + 62*s**2 - 88*s + 12) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 62*r**2 - 168*r*s + 49*r - 62*s**2 + 82*s - 9) + 3*k2**6*(2*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) - 2*K*(2*r + 2*s - 1)**2 - 6*r**2 - 16*r*s + 5*r - 6*s**2 + 8*s - 1)) - 2*gd2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*fd*g2*k2**2*(r + s)**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)) + Dd*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(k1**6*(K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(C*(248*r**2 + 16*r*(42*s - 19) + 248*s**2 - 414*s + 94) + 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 124*r**2 - 336*r*s + 140*r - 124*s**2 + 195*s - 38) + 3*k2**6*(C*(24*r**2 + 4*r*(16*s - 7) + 24*s**2 - 38*s + 8) - 2*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 12*r**2 - 32*r*s + 14*r - 12*s**2 + 19*s - 4)) - 2*g2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-75*f**2*fd*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(fd*(k1**6*(2*C - 2)*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 3*k1**4*k2**2*(2*C*(282*r**2 + r*(960*s - 497) + 282*s**2 - 695*s + 228) - 357*r**2 + r*(619 - 1110*s) - 357*s**2 + 817*s - 276) - 9*k1**2*k2**4*(4*C*(12*r**2 + r*(6 - 42*s) + 12*s**2 + 39*s - 13) - 189*r**2 + r*(197 - 246*s) - 189*s**2 + 131*s - 40) + k2**6*(198 - 396*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6*(r + s - 1)**2 + k1**4*k2**2*(22*r**2 + r*(44*s - 37) + 22*s**2 - 37*s + 15) + 3*k1**2*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 6*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*g2*(k1**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(44*r**2 + r*(88*s - 52) + 44*s**2 - 52*s + 15) + 3*k1**2*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 6*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-75*f**2*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(k1**6*(2*C - 2)*(36*r**2 + r*(72*s - 95) + 36*s**2 - 95*s + 51) + 3*k1**4*k2**2*(2*C*(376*r**2 + 32*r*(40*s - 21) + 376*s**2 - 1002*s + 309) - 476*r**2 + r*(843 - 1480*s) - 476*s**2 + 1173*s - 381) - 9*k1**2*k2**4*(4*C*(16*r**2 - 56*r*s + 3*r + 16*s**2 + 58*s - 14) - 252*r**2 + r*(291 - 328*s) - 252*s**2 + 181*s - 71) + k2**6*(198 - 396*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 858*g2*(k1**6*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(88*r**2 + 2*r*(88*s - 63) + 88*s**2 - 126*s + 45) + 3*k1**2*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 6*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(3003*d**2*k3**8) - 16*D1**3*Pk2*Pk3*ct**2*(D1*bd1*f*(-5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(r + s - 1) - 66*f*(k1**6*(2*C - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(C*(44*r**2 + 64*r*s - 48*r + 44*s**2 - 48*s + 4) + 14*K*r**2 + 28*K*r*s - 27*K*r + 14*K*s**2 - 27*K*s + 13*K - 2*b1*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) - 42*r**2 - 72*r*s + 54*r - 42*s**2 + 54*s - 12) - 6*k1**2*k2**4*(-10*C*r**2 - 16*C*r*s + 10*C*r - 10*C*s**2 + 10*C*s - K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 12*r*s - 7*r + 7*s**2 - 7*s) + k2**6*(12*C - 6)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (-132*b1*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)) + 132*g2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 66*b1**2*(D1*fd*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14))) + Dd*f*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1)) - (r + s)*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(k1**6*(2*C - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(4*C*(22*r**2 + r*(32*s - 19) + 22*s**2 - 10*s + 4) + K*(28*r**2 + 8*r*(7*s - 5) + 28*s**2 - 40*s + 13) - 84*r**2 - 6*r*(24*s - 13) - 84*s**2 + 60*s - 18) + 6*k1**2*k2**4*(2*C*(10*r**2 + r*(16*s - 7) + 10*s**2 - 4*s + 1) + K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*r**2 - 24*r*s + 9*r - 14*s**2 + 6*s - 1) + k2**6*(12*C - 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 2*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) + 132*fd*g2*(r + s)**2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) - Dd*f*(5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(4*r + 4*s - 3) + 66*f*(k1**6*(2*C - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*C*(44*r**2 + r*(64*s - 46) + 44*s**2 - 31*s + 9) + K*(56*r**2 + 112*r*s - 94*r + 56*s**2 - 94*s + 39) - 168*r**2 - 288*r*s + 192*r - 168*s**2 + 162*s - 48) + 6*k1**2*k2**4*(C*(40*r**2 + 4*r*(16*s - 9) + 40*s**2 - 26*s + 4) + K*(4*r + 4*s - 3)**2 - 28*r**2 - 48*r*s + 24*r - 28*s**2 + 19*s - 2) + k2**6*(12*C - 6)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 132*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))) - 2*f*k1**2*(D1*(210*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + f*k2**2*(5*fd*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 66*gd2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 66*fd*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**4*(r + s - 1) + 5*f*k2**2*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3)) - 66*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3)))))/(231*d**2*k3**8) - 40*D1**3*Pk2*Pk3*ct*f*k1*k2**3*st**6*(D1*(f**2*(13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 2) + 9*s**2 - 4*s - 5) + fd*k1**2*(4972*r**2 + r*(9944*s - 7653) + 4972*s**2 - 7653*s + 2943)) - 13*f*k2**2*(66*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 264*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 858*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(1243*r + 1243*s - 981) + 13*f*k2**2*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(-1716*K*b1 + 858*b1 + 3432*g2)))/(3003*d**2*k3**8) + 16*D1**3*Pk2*Pk3*ct*k1*k2*st**4*(D1*(858*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(650*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - fd*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 26*f**2*k2**2*(fd*(k1**2*(-24*C + 25*b1 + 18) + k2**2*(20 - 40*C))*(3*r + 3*s - 2)**2 + (33*r + 33*s - 33)*(-bd1*k1**2*(2*K - 1)*(r + s) + bd1*k2**2*(K*(-7*r - 7*s + 3) + b1*(r + s - 1) + 2*r + 2*s - 1) + 4*gd2*k1**2*(r + s) + 2*gd2*k2**2*(7*r + 7*s - 3))) + 429*f*k2**2*(b1**2*fd*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(fd*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1))*(2*r + 2*s - 1) + k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-4*K*bd1 + 2*bd1 + 4*gd2)) + 4*g2*(-2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5)) + 26*f**2*k2**2*(k1**2*(24*C - 25*b1 - 18) + k2**2*(40*C - 20))*(3*r + 3*s - 2) - 429*f*k2**2*(b1**2*k2**2*(r + s - 1) - 2*b1*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1)) + 4*g2*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3)))))/(1001*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct*k1*st**2*(D1*(-858*b1*fd*k2**4*(r + s)**2*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) - 3*f**3*k1**2*(13*bd1*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 13*f**2*k2**2*(66*bd1*(k1**4*(2*K - 1)*(r + s - 1)**2 + k1**2*k2**2*(8*C*(4*r**2 + 11*r*s - 7*r + 4*s**2 - 7*s + 3) + 5*K*r**2 + 10*K*r*s - 8*K*r + 5*K*s**2 - 8*K*s + 3*K - 3*b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 20*r**2 - 52*r*s + 32*r - 20*s**2 + 32*s - 12) + k2**4*(4*C*(7*r**2 + 6*r*(3*s - 2) + 7*s**2 - 12*s + 5) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 13*r**2 - 34*r*s + 23*r - 13*s**2 + 23*s - 10)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) - 132*gd2*(2*k1**4*(r + s - 1)**2 + k1**2*k2**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) + 429*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(2*r + 2*s - 1) - 2*b1*fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(4*C*(16*r**2 + 2*r*(22*s - 7) + 16*s**2 - 23*s + 3) + K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 40*r**2 - 104*r*s + 32*r - 40*s**2 + 50*s - 6) + k2**4*(4*C*(14*r**2 + r*(36*s - 13) + 14*s**2 - 19*s + 3) - 3*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 26*r**2 - 68*r*s + 25*r - 26*s**2 + 37*s - 6)) + 4*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(13 - 26*K) + bd1*k2**2*(7 - 40*K) + 26*gd2*k1**2 + 40*gd2*k2**2) + 4*g2*(2*bd1*k2**2*(13*k1**2 + 20*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(-858*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) - 15*f**3*k1**4*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 13*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) + 429*f*k2**2*(3*b1**2*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(4*C*(32*r**2 + r*(88*s - 39) + 32*s**2 - 54*s + 12) + K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 80*r**2 - 208*r*s + 90*r - 80*s**2 + 120*s - 24) + k2**4*(4*C*(28*r**2 + r*(72*s - 35) + 28*s**2 - 45*s + 11) - 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 52*r**2 - 136*r*s + 67*r - 52*s**2 + 87*s - 22)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(3003*d**2*k2*k3**8) - 16*D1**3*Pk2*Pk3*ct*k1*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(-k1**4*(-4*C + 10*b1 + 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*r + 3*K*s - 3*K - 9*b1*(3*r + 3*s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) + 132*k2**2*(r + s)*(b1*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)) - 2*g2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) + 66*b1**2*k2**2*(D1*fd*(f*k1**2*(5*k1**2*(2*r + 2*s - 1) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7))) + Dd*f*(f*(5*k1**4*(2*r + 2*s - 1) + 9*k1**2*k2**2*(3*r + 3*s - 1)) - (r + s)*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*k2**2*(fd*(2*r + 2*s - 1)*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 4*gd2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(r + s)**2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 264*g2*k2**2*(r + s)*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) - 66*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 12*f*gd2*(r + s - 1) - 12*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1))/(231*d**2*k2*k3**8) + 160*D1**3*Pk2*Pk3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(429*d**2*k3**8) - 40*D1**3*Pk2*Pk3*f*k2**2*st**6*(D1*(f**2*k1**2*(-13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 13) + 9*s**2 - 26*s + 17) + fd*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 13*f*k2**2*(b1*fd*k1**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-33*K*bd1 + 66*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2)) - 13*f*k2**2*(b1*k1**2*(9*r + 9*s - 17) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(-858*K*b1 + 1716*g2)*(2*r + 2*s - 1)))/(3003*d**2*k3**8) - 16*D1**3*Pk2*Pk3*k1**2*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)) + 2*b1**2*(D1*fd*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s)**2 + f*k1**2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(4*D1*bd1*f*(r + s - 1)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1)) + D1*(-5*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1) - 2*gd2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s))))/(7*d**2*k3**8) + 16*D1**3*Pk2*Pk3*st**4*(D1*(858*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) - f**3*fd*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 78*f**2*k2**4*(11*b1*bd1*k1**2*(r + s - 1)**2 - fd*k1**2*(4*C - 2)*(3*r + 3*s - 2)**2 + (-11*K*bd1 + 22*gd2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 429*f*k2**4*(b1**2*fd*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(K*fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(bd1*k2**2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7)) + f**2*k1**2*k2**4*(312*C - 156)*(3*r + 3*s - 2) - 429*f*k2**4*(-2*K*b1*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + b1**2*k1**2*(r + s - 1) + 4*g2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)))))/(1001*d**2*k3**8) + 8*D1**3*Pk2*Pk3*st**2*(D1*bd1*f*(-f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(r + s - 1) + 66*f*k2**2*(-k1**4*(C*(4*r*s - 2*r - 2*s + 2) + K*r**2 + 2*K*r*s - 2*K*r + K*s**2 - 2*K*s + K - b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 2*r*s + r + s - 1) + k1**2*k2**2*(-4*C*(4*r**2 + 9*r*s - 6*r + 4*s**2 - 6*s + 2) + 4*K*r**2 + 8*K*r*s - 7*K*r + 4*K*s**2 - 7*K*s + 3*K - 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 18*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(13*k1**2 + 7*k2**2)*(-132*K*b1 + 132*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 33*b1**2*k2**2*(D1*fd*(2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*k1**2*(k1**2*(25*r + 25*s - 11) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**4*(25*r + 25*s - 11) - 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(D1*(-f**2*fd*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) + 66*f*k2**2*(fd*(-K*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1) - (2*C - 1)*(k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + 2*r*(18*s - 7) + 16*s**2 - 17*s + 3) + k2**4*(-2*r**2 - 4*r*s + r - 2*s**2 + s))) + 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**4*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(-f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(4*r + 4*s - 3) + 66*f*k2**2*(-k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 8*r*s + r + 6*s - 1) + k1**2*k2**2*(-2*C*(32*r**2 + r*(72*s - 37) + 32*s**2 - 42*s + 10) + K*(4*r + 4*s - 3)**2 + 32*r**2 + 72*r*s - 37*r + 32*s**2 - 42*s + 10) + k2**4*(2*C - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 132*g2*k2**4*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*k1**2*(D1*(75*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(-fd*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(75*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(-9*r - 9*s + 17) + 33*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3)))))/(231*d**2*k3**8) + 20*D1**3*Pk2*Pkd3*ct**8*f*k1**2*k2**4*(3978*C*D1*f*fd*r**2 + 7956*C*D1*f*fd*r*s - 4446*C*D1*f*fd*r + 3978*C*D1*f*fd*s**2 - 4446*C*D1*f*fd*s + 1196*C*D1*f*fd + 5304*C*Dd*f**2*r**2 + 10608*C*Dd*f**2*r*s - 6370*C*Dd*f**2*r + 5304*C*Dd*f**2*s**2 - 6370*C*Dd*f**2*s + 1794*C*Dd*f**2 + 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3584*D1*f**2*fd*r**2 + 7168*D1*f**2*fd*r*s - 5012*D1*f**2*fd*r + 3584*D1*f**2*fd*s**2 - 5012*D1*f**2*fd*s + 1743*D1*f**2*fd - 3978*D1*f*fd*r**2 - 7956*D1*f*fd*r*s + 4446*D1*f*fd*r - 3978*D1*f*fd*s**2 + 4446*D1*f*fd*s - 1196*D1*f*fd - 1716*D1*f*gd2*r**2 - 3432*D1*f*gd2*r*s + 2574*D1*f*gd2*r - 1716*D1*f*gd2*s**2 + 2574*D1*f*gd2*s - 858*D1*f*gd2 - 3432*D1*fd*g2*r**2 - 6864*D1*fd*g2*r*s + 3432*D1*fd*g2*r - 3432*D1*fd*g2*s**2 + 3432*D1*fd*g2*s - 858*D1*fd*g2 + 3584*Dd*f**3*r**2 + 7168*Dd*f**3*r*s - 5012*Dd*f**3*r + 3584*Dd*f**3*s**2 - 5012*Dd*f**3*s + 1743*Dd*f**3 - 5304*Dd*f**2*r**2 - 10608*Dd*f**2*r*s + 6370*Dd*f**2*r - 5304*Dd*f**2*s**2 + 6370*Dd*f**2*s - 1794*Dd*f**2 - 6864*Dd*f*g2*r**2 - 13728*Dd*f*g2*r*s + 8580*Dd*f*g2*r - 6864*Dd*f*g2*s**2 + 8580*Dd*f*g2*s - 2574*Dd*f*g2 + 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**7*f*k1*k2**3*(-13*D1*bd1*f*(k1**2*(132*K - 132)*(11*r + 11*s - 7) - 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) - 2*D1*(35*f**2*fd*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 13*f*(5*fd*(k1**2*(2*C - 2)*(315*r**2 + 9*r*(70*s - 43) + 315*s**2 - 387*s + 118) + k2**2*(4*C*(153*r**2 + 504*r*s - 204*r + 153*s**2 - 303*s + 79) - 459*r**2 - 1314*r*s + 579*r - 459*s**2 + 777*s - 204)) - 132*gd2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(r + s - 1)) - 1716*fd*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - 2*Dd*f*(35*f**2*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 65*f*(k1**2*(2*C - 2)*(420*r**2 + r*(840*s - 551) + 420*s**2 - 551*s + 177) + k2**2*(4*C*(204*r**2 + 672*r*s - 278*r + 204*s**2 - 443*s + 102) - 612*r**2 - 1752*r*s + 801*r - 612*s**2 + 1131*s - 273)) - 1716*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(k1**2*(132 - 132*K)*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7) + 5*k2**2*(f*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(132 - 132*K)*(11*r + 11*s - 7) + 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(1001*d**2*k3**7) + 10*D1**3*Pk2*Pkd3*ct**6*f*k1**2*k2**4*st**2*(12402*C*D1*f*fd*r**2 + 24804*C*D1*f*fd*r*s - 14820*C*D1*f*fd*r + 12402*C*D1*f*fd*s**2 - 14820*C*D1*f*fd*s + 4368*C*D1*f*fd + 16536*C*Dd*f**2*r**2 + 33072*C*Dd*f**2*r*s - 21138*C*Dd*f**2*r + 16536*C*Dd*f**2*s**2 - 21138*C*Dd*f**2*s + 6552*C*Dd*f**2 + 1287*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 16492*D1*f**2*fd*r**2 + 32984*D1*f**2*fd*r*s - 23373*D1*f**2*fd*r + 16492*D1*f**2*fd*s**2 - 23373*D1*f**2*fd*s + 8253*D1*f**2*fd - 12402*D1*f*fd*r**2 - 24804*D1*f*fd*r*s + 14820*D1*f*fd*r - 12402*D1*f*fd*s**2 + 14820*D1*f*fd*s - 4368*D1*f*fd - 5148*D1*f*gd2*r**2 - 10296*D1*f*gd2*r*s + 7722*D1*f*gd2*r - 5148*D1*f*gd2*s**2 + 7722*D1*f*gd2*s - 2574*D1*f*gd2 - 10296*D1*fd*g2*r**2 - 20592*D1*fd*g2*r*s + 10296*D1*fd*g2*r - 10296*D1*fd*g2*s**2 + 10296*D1*fd*g2*s - 2574*D1*fd*g2 + 16492*Dd*f**3*r**2 + 32984*Dd*f**3*r*s - 23373*Dd*f**3*r + 16492*Dd*f**3*s**2 - 23373*Dd*f**3*s + 8253*Dd*f**3 - 16536*Dd*f**2*r**2 - 33072*Dd*f**2*r*s + 21138*Dd*f**2*r - 16536*Dd*f**2*s**2 + 21138*Dd*f**2*s - 6552*Dd*f**2 - 20592*Dd*f*g2*r**2 - 41184*Dd*f*g2*r*s + 25740*Dd*f*g2*r - 20592*Dd*f*g2*s**2 + 25740*Dd*f*g2*s - 7722*Dd*f*g2 + 1287*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(1001*d**2*k3**7) + 2*D1**3*Pk2*Pkd3*ct**6*k2**2*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + k1**2*k2**2*(r + s)*(-792*K*b1 + 792*b1 + 792*g2)) + 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k1**2*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) - 66*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 792*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + 792*g2*k1**2*k2**2*(r + s))) + 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**4*(6*C - 6)*(42*r**2 + r*(84*s - 67) + 42*s**2 - 67*s + 26) + k1**2*k2**2*(2*C*(432*r**2 + 6*r*(309*s - 118) + 432*s**2 - 1203*s + 335) - 549*r**2 - 72*r*(29*s - 12) - 549*s**2 + 1359*s - 387) + k2**4*(2*C - 1)*(153*r**2 + 12*r*(42*s - 17) + 153*s**2 - 303*s + 79)) - 66*gd2*(12*k1**4*(r + s - 1)**2 + 2*k1**2*k2**2*(16*r**2 + r*(32*s - 27) + 16*s**2 - 27*s + 11) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 858*fd*g2*(12*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**2*k2**2*(32*r**2 + r*(64*s - 38) + 32*s**2 - 38*s + 11) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(70*f**2*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 65*f*(k1**4*(6*C - 6)*(56*r**2 + 2*r*(56*s - 47) + 56*s**2 - 94*s + 39) + k1**2*k2**2*(2*C*(576*r**2 + r*(2472*s - 937) + 576*s**2 - 1762*s + 420) - 732*r**2 - 3*r*(928*s - 386) - 732*s**2 + 1983*s - 498) + k2**4*(2*C - 1)*(204*r**2 + r*(672*s - 278) + 204*s**2 - 443*s + 102)) - 858*g2*(12*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k1**2*k2**2*(64*r**2 + 4*r*(32*s - 23) + 64*s**2 - 92*s + 33) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1001*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**5*f*k1*k2**3*st**2*(231192*C*D1*f*fd*k1**2*r**2 + 462384*C*D1*f*fd*k1**2*r*s - 291096*C*D1*f*fd*k1**2*r + 231192*C*D1*f*fd*k1**2*s**2 - 291096*C*D1*f*fd*k1**2*s + 91312*C*D1*f*fd*k1**2 + 248040*C*D1*f*fd*k2**2*r**2 + 702000*C*D1*f*fd*k2**2*r*s - 330720*C*D1*f*fd*k2**2*r + 248040*C*D1*f*fd*k2**2*s**2 - 433680*C*D1*f*fd*k2**2*s + 121680*C*D1*f*fd*k2**2 + 308256*C*Dd*f**2*k1**2*r**2 + 616512*C*Dd*f**2*k1**2*r*s - 413816*C*Dd*f**2*k1**2*r + 308256*C*Dd*f**2*k1**2*s**2 - 413816*C*Dd*f**2*k1**2*s + 136968*C*Dd*f**2*k1**2 + 330720*C*Dd*f**2*k2**2*r**2 + 936000*C*Dd*f**2*k2**2*r*s - 457080*C*Dd*f**2*k2**2*r + 330720*C*Dd*f**2*k2**2*s**2 - 628680*C*Dd*f**2*k2**2*s + 165360*C*Dd*f**2*k2**2 + 39*D1*bd1*f*(k1**2*(44*K - 44)*(31*r + 31*s - 17) - 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) + 437100*D1*f**2*fd*k1**2*r**2 + 874200*D1*f**2*fd*k1**2*r*s - 637125*D1*f**2*fd*k1**2*r + 437100*D1*f**2*fd*k1**2*s**2 - 637125*D1*f**2*fd*k1**2*s + 231975*D1*f**2*fd*k1**2 - 231192*D1*f*fd*k1**2*r**2 - 462384*D1*f*fd*k1**2*r*s + 291096*D1*f*fd*k1**2*r - 231192*D1*f*fd*k1**2*s**2 + 291096*D1*f*fd*k1**2*s - 91312*D1*f*fd*k1**2 - 186030*D1*f*fd*k2**2*r**2 - 475020*D1*f*fd*k2**2*r*s + 239460*D1*f*fd*k2**2*r - 186030*D1*f*fd*k2**2*s**2 + 290940*D1*f*fd*k2**2*s - 82680*D1*f*fd*k2**2 - 106392*D1*f*gd2*k1**2*r**2 - 212784*D1*f*gd2*k1**2*r*s + 164736*D1*f*gd2*k1**2*r - 106392*D1*f*gd2*k1**2*s**2 + 164736*D1*f*gd2*k1**2*s - 58344*D1*f*gd2*k1**2 - 102960*D1*f*gd2*k2**2*r**2 - 205920*D1*f*gd2*k2**2*r*s + 154440*D1*f*gd2*k2**2*r - 102960*D1*f*gd2*k2**2*s**2 + 154440*D1*f*gd2*k2**2*s - 51480*D1*f*gd2*k2**2 - 212784*D1*fd*g2*k1**2*r**2 - 425568*D1*fd*g2*k1**2*r*s + 223080*D1*fd*g2*k1**2*r - 212784*D1*fd*g2*k1**2*s**2 + 223080*D1*fd*g2*k1**2*s - 58344*D1*fd*g2*k1**2 - 205920*D1*fd*g2*k2**2*r**2 - 411840*D1*fd*g2*k2**2*r*s + 205920*D1*fd*g2*k2**2*r - 205920*D1*fd*g2*k2**2*s**2 + 205920*D1*fd*g2*k2**2*s - 51480*D1*fd*g2*k2**2 + 437100*Dd*f**3*k1**2*r**2 + 874200*Dd*f**3*k1**2*r*s - 637125*Dd*f**3*k1**2*r + 437100*Dd*f**3*k1**2*s**2 - 637125*Dd*f**3*k1**2*s + 231975*Dd*f**3*k1**2 - 308256*Dd*f**2*k1**2*r**2 - 616512*Dd*f**2*k1**2*r*s + 413816*Dd*f**2*k1**2*r - 308256*Dd*f**2*k1**2*s**2 + 413816*Dd*f**2*k1**2*s - 136968*Dd*f**2*k1**2 - 248040*Dd*f**2*k2**2*r**2 - 633360*Dd*f**2*k2**2*r*s + 334230*Dd*f**2*k2**2*r - 248040*Dd*f**2*k2**2*s**2 + 420030*Dd*f**2*k2**2*s - 115440*Dd*f**2*k2**2 - 425568*Dd*f*g2*k1**2*r**2 - 851136*Dd*f*g2*k1**2*r*s + 552552*Dd*f*g2*k1**2*r - 425568*Dd*f*g2*k1**2*s**2 + 552552*Dd*f*g2*k1**2*s - 175032*Dd*f*g2*k1**2 - 411840*Dd*f*g2*k2**2*r**2 - 823680*Dd*f*g2*k2**2*r*s + 514800*Dd*f*g2*k2**2*r - 411840*Dd*f*g2*k2**2*s**2 + 514800*Dd*f*g2*k2**2*s - 154440*Dd*f*g2*k2**2 - 39*b1*(D1*fd*(k1**2*(44 - 44*K)*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17) + 5*k2**2*(f*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(44 - 44*K)*(31*r + 31*s - 17) + 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**5*k1*k2*(13*D1*bd1*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 66*f*(k1**4*(2*K - 2)*(r**2 + 2*r*s + s**2 - 1) - 2*k1**2*k2**2*(r + s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5) + 2*K*r**2 + 4*K*r*s + 2*K*s**2 - 2*K + 2*b1*(7*r**2 + r*(14*s - 9) + 7*s**2 - 9*s + 2) + 24*r*s - 3*r - 3*s + 3)) + 264*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-5*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*k2**2*(14*r**2 + r*(28*s - 11) + 14*s**2 - 11*s + 2) + (r + s)**2*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(7*r + 7*s - 2) + (r + s)*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*(fd*(k1**4*(2*K - 2)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) - 2*k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 2*K*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 6*r*(8*s + 3) - 18*s - 9)) + 4*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 66*f*(k1**4*(2*K - 2)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 2*k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 2*K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 96*r*s + 24*r - 36*s - 15)) + 264*g2*k2**2*(5*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*fd*(k1**4*(2*C - 2)*(81*r**2 + 3*r*(54*s - 25) + 81*s**2 - 75*s + 14) + 3*k1**2*k2**2*(2*C*(81*r**2 - 102*r*s - 31*r + 81*s**2 + 101*s - 30) - 204*r**2 - 144*r*s + 173*r - 204*s**2 + 41*s - 10) + k2**4*(2*C*(81*r**2 - 9*r*(26*s + 1) + 81*s**2 + 189*s - 52) - 279*r**2 - 162*r*s + 240*r - 279*s**2 + 42*s - 14)) + 1716*f*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + 2*r*s + s**2 - 1) + 1716*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1)) + Dd*f*(70*f**2*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*(k1**4*(2*C - 2)*(108*r**2 + r*(216*s - 109) + 108*s**2 - 109*s + 21) + 3*k1**2*k2**2*(2*C*(108*r**2 - 136*r*s - 65*r + 108*s**2 + 155*s - 23) - 272*r**2 - 192*r*s + 268*r - 272*s**2 + 48*s - 37) + k2**4*(C*(216*r**2 - 624*r*s - 86*r + 216*s**2 + 574*s - 90) - 372*r**2 - 216*r*s + 373*r - 372*s**2 + 43*s - 54)) + 1716*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3))))/(1001*d**2*k3**7) + 60*D1**3*Pk2*Pkd3*ct**4*f**2*k1**2*k2**4*st**4*(D1*fd*(78*C*(3*r + 3*s - 2)**2 + 7*f*(268*r**2 + 536*r*s - 389*r + 268*s**2 - 389*s + 141) - 78*(3*r + 3*s - 2)**2) + Dd*f*(4*r + 4*s - 3)*(78*C*(3*r + 3*s - 2) + 7*f*(67*r + 67*s - 47) - 234*r - 234*s + 156))/(1001*d**2*k3**7) + D1**3*Pk2*Pkd3*ct**4*k2**2*st**2*(-39*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + k1**2*k2**2*(r + s)*(-264*K*b1 + 264*b1 + 264*g2)) + 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 39*b1*(D1*(5*f**2*fd*k1**2*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) - 22*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + 264*g2*k1**2*k2**2*(r + s))) + f*(D1*(375*f**2*fd*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 26*f*(fd*(k1**4*(612*C - 612)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(3852*r**2 + 18*r*(659*s - 311) + 3852*s**2 - 7677*s + 2251) - 5481*r**2 - 72*r*(210*s - 107) - 5481*s**2 + 9783*s - 2931) + k2**4*(30*C - 15)*(159*r**2 + r*(450*s - 212) + 159*s**2 - 278*s + 78)) - 66*gd2*(9*k1**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 2*k1**2*k2**2*(56*r**2 + r*(112*s - 87) + 56*s**2 - 87*s + 31) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 1716*fd*g2*(9*k1**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k1**2*k2**2*(112*r**2 + 2*r*(112*s - 59) + 112*s**2 - 118*s + 31) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(375*f**2*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 26*f*(k1**4*(612*C - 612)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(5136*r**2 + r*(15816*s - 7661) + 5136*s**2 - 11126*s + 3030) - 7308*r**2 - 30*r*(672*s - 355) - 7308*s**2 + 14115*s - 4050) + k2**4*(30*C - 15)*(212*r**2 + r*(600*s - 293) + 212*s**2 - 403*s + 106)) - 1716*g2*(9*k1**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k1**2*k2**2*(224*r**2 + 4*r*(112*s - 73) + 224*s**2 - 292*s + 93) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**4*(-429*D1*bd1*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 2*f*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**4*k2**2*(r + s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) + 2*k1**2*k2**4*(-2*C*(r**2 + 4*r*(8*s - 3) + s**2 - 12*s + 11) + 12*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1*(17*r**2 + r*(34*s - 21) + 17*s**2 - 21*s + 4) - 15*r**2 + 15*r - 15*s*(s - 1)) + k2**6*(-2*C*(4*r**2 + r*(20*s - 9) + 4*s**2 - 9*s + 5) + 6*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5)) + 4*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)) - g2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 858*b1**2*k2**2*(D1*fd*(f*k1**2*k2**2*(34*r**2 + r*(68*s - 25) + 34*s**2 - 25*s + 4) - (r + s)**2*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3))) + Dd*f*(f*k1**2*k2**2*(17*r + 17*s - 4) - (r + s)*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)))*(4*r + 4*s - 3)) - 429*b1*(D1*(5*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(k1**6*(K - 1)*(2*r + 2*s - 1)**2 + 2*k1**4*k2**2*(2*r + 2*s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(2*r**2 + 64*r*s + 7*r + 2*s**2 - 38*s - 4) - 12*K*(2*r + 2*s - 1)**2 + 30*r**2 - 45*r + 30*s**2 + 15) + k2**6*(-2*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 6*K*(2*r + 2*s - 1)**2 + 8*r**2 + 40*r*s - 2*r + 8*s**2 - 20*s - 1)) + 2*gd2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*fd*g2*k2**2*(r + s)**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)) + Dd*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 2*f*(k1**6*(K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 2*k1**4*k2**2*(4*r + 4*s - 3)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(4*r**2 + 2*r*(64*s - 1) + 4*s**2 - 77*s + 3) - 12*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 60*r**2 - 90*r + 60*s**2 - 15*s + 30) + k2**6*(-2*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 6*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 16*r**2 + 80*r*s - 14*r + 16*s**2 - 44*s + 3)) - 4*g2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + 2*f*(D1*(35*f**2*fd*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**6*(10*C - 10)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(558*r**2 + r*(918*s - 678) + 558*s**2 - 579*s + 193) - 1035*r**2 - 18*r*(104*s - 73) - 1035*s**2 + 1215*s - 405) + 3*k1**2*k2**4*(2*C*(288*r**2 + 170*r*(3*s - 2) + 288*s**2 - 307*s + 95) - 453*r**2 + r*(549 - 840*s) - 453*s**2 + 516*s - 161) + k2**6*(66*C - 33)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 858*fd*g2*(2*r + 2*s - 1)**2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)) + Dd*f*(35*f**2*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 65*f*(k1**6*(10*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(2*C*(744*r**2 + r*(1224*s - 977) + 744*s**2 - 812*s + 306) - 1380*r**2 - 3*r*(832*s - 626) - 1380*s**2 + 1713*s - 624) + 3*k1**2*k2**4*(2*C*(384*r**2 + r*(680*s - 489) + 384*s**2 - 434*s + 148) - 604*r**2 + r*(786 - 1120*s) - 604*s**2 + 731*s - 247) + k2**6*(66*C - 33)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 858*g2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(1001*d**2*k3**7) - 6*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**3*st**4*(-9360*C*D1*f*fd*k1**2*r**2 - 18720*C*D1*f*fd*k1**2*r*s + 12480*C*D1*f*fd*k1**2*r - 9360*C*D1*f*fd*k1**2*s**2 + 12480*C*D1*f*fd*k1**2*s - 4160*C*D1*f*fd*k1**2 - 14040*C*D1*f*fd*k2**2*r**2 - 28080*C*D1*f*fd*k2**2*r*s + 18720*C*D1*f*fd*k2**2*r - 14040*C*D1*f*fd*k2**2*s**2 + 18720*C*D1*f*fd*k2**2*s - 6240*C*D1*f*fd*k2**2 - 12480*C*Dd*f**2*k1**2*r**2 - 24960*C*Dd*f**2*k1**2*r*s + 17680*C*Dd*f**2*k1**2*r - 12480*C*Dd*f**2*k1**2*s**2 + 17680*C*Dd*f**2*k1**2*s - 6240*C*Dd*f**2*k1**2 - 18720*C*Dd*f**2*k2**2*r**2 - 37440*C*Dd*f**2*k2**2*r*s + 26520*C*Dd*f**2*k2**2*r - 18720*C*Dd*f**2*k2**2*s**2 + 26520*C*Dd*f**2*k2**2*s - 9360*C*Dd*f**2*k2**2 - 26*D1*bd1*f*(-35*f*k2**2*(3*r + 3*s - 2) + k1**2*(33*K - 33)*(3*r + 3*s - 1))*(r + s - 1) - 39100*D1*f**2*fd*k1**2*r**2 - 78200*D1*f**2*fd*k1**2*r*s + 57545*D1*f**2*fd*k1**2*r - 39100*D1*f**2*fd*k1**2*s**2 + 57545*D1*f**2*fd*k1**2*s - 21165*D1*f**2*fd*k1**2 + 9360*D1*f*fd*k1**2*r**2 + 18720*D1*f*fd*k1**2*r*s - 12480*D1*f*fd*k1**2*r + 9360*D1*f*fd*k1**2*s**2 - 12480*D1*f*fd*k1**2*s + 4160*D1*f*fd*k1**2 + 10530*D1*f*fd*k2**2*r**2 + 21060*D1*f*fd*k2**2*r*s - 14040*D1*f*fd*k2**2*r + 10530*D1*f*fd*k2**2*s**2 - 14040*D1*f*fd*k2**2*s + 4680*D1*f*fd*k2**2 + 5148*D1*f*gd2*k1**2*r**2 + 10296*D1*f*gd2*k1**2*r*s - 6864*D1*f*gd2*k1**2*r + 5148*D1*f*gd2*k1**2*s**2 - 6864*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 10296*D1*fd*g2*k1**2*r**2 + 20592*D1*fd*g2*k1**2*r*s - 8580*D1*fd*g2*k1**2*r + 10296*D1*fd*g2*k1**2*s**2 - 8580*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 - 39100*Dd*f**3*k1**2*r**2 - 78200*Dd*f**3*k1**2*r*s + 57545*Dd*f**3*k1**2*r - 39100*Dd*f**3*k1**2*s**2 + 57545*Dd*f**3*k1**2*s - 21165*Dd*f**3*k1**2 + 12480*Dd*f**2*k1**2*r**2 + 24960*Dd*f**2*k1**2*r*s - 17680*Dd*f**2*k1**2*r + 12480*Dd*f**2*k1**2*s**2 - 17680*Dd*f**2*k1**2*s + 6240*Dd*f**2*k1**2 + 14040*Dd*f**2*k2**2*r**2 + 28080*Dd*f**2*k2**2*r*s - 19890*Dd*f**2*k2**2*r + 14040*Dd*f**2*k2**2*s**2 - 19890*Dd*f**2*k2**2*s + 7020*Dd*f**2*k2**2 + 20592*Dd*f*g2*k1**2*r**2 + 41184*Dd*f*g2*k1**2*r*s - 22308*Dd*f*g2*k1**2*r + 20592*Dd*f*g2*k1**2*s**2 - 22308*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 - k1**2*(33*K - 33)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) - k1**2*(33*K - 33)*(3*r + 3*s - 1))*(4*r + 4*s - 3)))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**3*k1*k2*st**2*(13*D1*bd1*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(r + s - 1) - 33*f*(k1**4*(K - 1)*(13*r**2 + r*(26*s - 22) + 13*s**2 - 22*s + 9) + k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(3*r**2 + 8*r*s - 5*r + 3*s**2 - 5*s + 2) + 38*K*r**2 + 76*K*r*s - 60*K*r + 38*K*s**2 - 60*K*s + 22*K - 2*b1*(17*r**2 + r*(34*s - 24) + 17*s**2 - 24*s + 7) - 15*r**2 - 42*r*s + 24*r - 15*s**2 + 24*s - 9)) + 132*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-13*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(13*k1**2 + 6*k2**2))) + 429*b1**2*k2**2*(D1*fd*(f*k2**2*(34*r**2 + r*(68*s - 31) + 34*s**2 - 31*s + 7) + (r + s)**2*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(17*r + 17*s - 7) + (r + s)*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 33*f*(fd*(k1**4*(K - 1)*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) + 2*K*(38*r**2 + 76*r*s - 41*r + 38*s**2 - 41*s + 11) - 30*r**2 - 84*r*s + 21*r - 30*s**2 + 39*s - 3)) - 4*gd2*k2**2*(13*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 33*f*(k1**4*(K - 1)*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(12*r**2 + 2*r*(16*s - 7) + 12*s**2 - 19*s + 4) + 2*K*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33) - 60*r**2 - 21*r*(8*s - 3) - 60*s**2 + 93*s - 15)) + 132*g2*k2**2*(13*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-25*f**2*fd*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(fd*(k1**4*(9*C - 9)*(69*r**2 + r*(138*s - 103) + 69*s**2 - 103*s + 38) + 3*k1**2*k2**2*(C*(1341*r**2 + 4530*r*s - 2129*r + 1341*s**2 - 3053*s + 926) - 882*r**2 - 2688*r*s + 1363*r - 882*s**2 + 1825*s - 568) + k2**4*(2*C*(1035*r**2 + 3654*r*s - 1677*r + 1035*s**2 - 2469*s + 746) - 441*r**2 - 2466*r*s + 984*r - 441*s**2 + 1776*s - 548)) - 33*gd2*(k1**4*(13*r**2 + 26*r*s - 22*r + 13*s**2 - 22*s + 9) + 15*k1**2*k2**2*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3) + 2*k2**4*(19*r**2 + 38*r*s - 30*r + 19*s**2 - 30*s + 11))) + 858*fd*g2*(k1**4*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + 15*k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k2**4*(38*r**2 + r*(76*s - 41) + 38*s**2 - 41*s + 11))) + Dd*f*(-25*f**2*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(k1**4*(9*C - 9)*(92*r**2 + r*(184*s - 145) + 92*s**2 - 145*s + 57) + 3*k1**2*k2**2*(C*(1788*r**2 + 6040*r*s - 2885*r + 1788*s**2 - 4425*s + 1235) - 1176*r**2 - 3584*r*s + 1864*r - 1176*s**2 + 2634*s - 775) + k2**4*(2*C*(1380*r**2 + 4872*r*s - 2263*r + 1380*s**2 - 3583*s + 987) - 588*r**2 - 3288*r*s + 1273*r - 588*s**2 + 2593*s - 690)) + 858*g2*(k1**4*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + 15*k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k2**4*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33)))))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**3*k1*(D1*(858*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) + 5*f**3*k1**2*(-13*bd1*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(r + s - 1) + 14*fd*k1**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 13*f**2*k2**2*(66*bd1*(k1**4*(r + s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(2*r**2 - r + 2*s**2 - s - 1) + 25*K*r**2 + 50*K*r*s - 42*K*r + 25*K*s**2 - 42*K*s + 17*K + b1*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s - 1) - 33*r**2 - 42*r*s + 39*r - 33*s**2 + 39*s - 6) - 2*k2**4*(-8*C*(r**2 - r*s + s**2 - 1) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 2*r*s - 3*r + 7*s**2 - 3*s - 4)) - 5*fd*(3*r + 3*s - 2)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 264*gd2*(k1**4*(5*r**2 + r*(10*s - 9) + 5*s**2 - 9*s + 4) + k1**2*k2**2*(25*r**2 + r*(50*s - 42) + 25*s**2 - 42*s + 17) + 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 858*f*k2**2*(-b1**2*fd*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - b1*(fd*(k1**4*(2*r + 2*s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(4*r**2 - 4*r + 4*s**2 + 2*s + 1) + K*(50*r**2 + 100*r*s - 59*r + 50*s**2 - 59*s + 17) - 66*r**2 - 84*r*s + 69*r - 66*s**2 + 33*s - 18) + 2*k2**4*(4*C*(4*r**2 - 4*r*(s + 1) + 4*s**2 + 5*s + 1) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 14*r**2 - 4*r*s + 11*r - 14*s**2 - 7*s - 2)) + (2*bd1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(2*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(10*r**2 + r*(20*s - 13) + 10*s**2 - 13*s + 4) + k1**2*k2**2*(50*r**2 + r*(100*s - 59) + 50*s**2 - 59*s + 17) + 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(858*b1*k2**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 70*f**3*k1**4*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 65*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 858*f*k2**2*(-b1**2*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - b1*(k1**4*(4*r + 4*s - 3)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(8*r**2 - 8*r + 8*s**2 + 2*s + 1) + K*(100*r**2 + 200*r*s - 143*r + 100*s**2 - 143*s + 51) - 132*r**2 - 168*r*s + 159*r - 132*s**2 + 99*s - 42) + 2*k2**4*(-4*C*r*(8*s + 7) + 32*C*s*(s + 1) + 3*K*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + r**2*(32*C - 28) - 8*r*s + 23*r - 7*s*(4*s + 1))) + 4*g2*(k1**4*(20*r**2 + r*(40*s - 31) + 20*s**2 - 31*s + 12) + k1**2*k2**2*(100*r**2 + r*(200*s - 143) + 100*s**2 - 143*s + 51) + 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(1001*d**2*k2*k3**7) + 10*D1**3*Pk2*Pkd3*ct**2*f*k1**2*k2**4*st**6*(-234*C*D1*f*fd*r**2 - 468*C*D1*f*fd*r*s + 312*C*D1*f*fd*r - 234*C*D1*f*fd*s**2 + 312*C*D1*f*fd*s - 104*C*D1*f*fd - 312*C*Dd*f**2*r**2 - 624*C*Dd*f**2*r*s + 442*C*Dd*f**2*r - 312*C*Dd*f**2*s**2 + 442*C*Dd*f**2*s - 156*C*Dd*f**2 - 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1708*D1*f**2*fd*r**2 + 3416*D1*f**2*fd*r*s - 2653*D1*f**2*fd*r + 1708*D1*f**2*fd*s**2 - 2653*D1*f**2*fd*s + 1029*D1*f**2*fd + 234*D1*f*fd*r**2 + 468*D1*f*fd*r*s - 312*D1*f*fd*r + 234*D1*f*fd*s**2 - 312*D1*f*fd*s + 104*D1*f*fd + 1716*D1*f*gd2*r**2 + 3432*D1*f*gd2*r*s - 2574*D1*f*gd2*r + 1716*D1*f*gd2*s**2 - 2574*D1*f*gd2*s + 858*D1*f*gd2 + 3432*D1*fd*g2*r**2 + 6864*D1*fd*g2*r*s - 3432*D1*fd*g2*r + 3432*D1*fd*g2*s**2 - 3432*D1*fd*g2*s + 858*D1*fd*g2 + 1708*Dd*f**3*r**2 + 3416*Dd*f**3*r*s - 2653*Dd*f**3*r + 1708*Dd*f**3*s**2 - 2653*Dd*f**3*s + 1029*Dd*f**3 + 312*Dd*f**2*r**2 + 624*Dd*f**2*r*s - 442*Dd*f**2*r + 312*Dd*f**2*s**2 - 442*Dd*f**2*s + 156*Dd*f**2 + 6864*Dd*f*g2*r**2 + 13728*Dd*f*g2*r*s - 8580*Dd*f*g2*r + 6864*Dd*f*g2*s**2 - 8580*Dd*f*g2*s + 2574*Dd*f*g2 - 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(1001*d**2*k3**7) - 6*D1**3*Pk2*Pkd3*ct**2*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(b1*(K - 1) - 2*g2) - 15*f**3*k1**2*(-104*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 26*f**2*(fd*(3*r + 3*s - 2)**2*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 33*k1**2*(bd1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*gd2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))*(r + s - 1)) - 858*f*k1**2*(b1*fd*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2))*(2*r + 2*s - 1) + 2*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-K*bd1 + bd1 + gd2) + 2*bd1*g2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*fd*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3))*(2*r + 2*s - 1))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k1**2*k2**2*(r + s)*(b1*(K - 1) - 2*g2) + 15*f**3*k1**2*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2)) + 26*f**2*(3*r + 3*s - 2)*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 858*f*k1**2*(b1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))))/(1001*d**2*k3**7) - 2*D1**3*Pk2*Pkd3*ct**2*st**2*(-429*D1*bd1*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + f*(k1**6*(K - 1)*(r + s - 1)**2 + k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(31*r**2 + 84*r*s - 54*r + 31*s**2 - 54*s + 23) + 15*K*r**2 + 30*K*r*s - 24*K*r + 15*K*s**2 - 24*K*s + 9*K - 12*b1*(7*r**2 + 2*r*(7*s - 5) + 7*s**2 - 10*s + 3) - 31*r**2 - 84*r*s + 51*r - 31*s**2 + 51*s - 20) + 3*k2**6*(2*C*(3*r**2 + r*(8*s - 5) + 3*s**2 - 5*s + 2) - 2*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 3*r**2 - 8*r*s + 5*r - 3*s**2 + 5*s - 2)) + 2*k2**2*(b1*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)) - g2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 429*b1**2*k2**2*(D1*fd*(6*f*k1**2*k2**2*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) - (r + s)**2*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33))) + Dd*f*(6*f*k1**2*k2**2*(7*r + 7*s - 3) - (r + s)*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)))*(4*r + 4*s - 3)) - 429*b1*(D1*(3*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(62*r**2 + r*(168*s - 55) + 62*s**2 - 88*s + 12) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 62*r**2 - 168*r*s + 49*r - 62*s**2 + 82*s - 9) + 3*k2**6*(2*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) - 2*K*(2*r + 2*s - 1)**2 - 6*r**2 - 16*r*s + 5*r - 6*s**2 + 8*s - 1)) - 2*gd2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*fd*g2*k2**2*(r + s)**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)) + Dd*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(k1**6*(K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(C*(248*r**2 + 16*r*(42*s - 19) + 248*s**2 - 414*s + 94) + 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 124*r**2 - 336*r*s + 140*r - 124*s**2 + 195*s - 38) + 3*k2**6*(C*(24*r**2 + 4*r*(16*s - 7) + 24*s**2 - 38*s + 8) - 2*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 12*r**2 - 32*r*s + 14*r - 12*s**2 + 19*s - 4)) - 2*g2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-75*f**2*fd*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(fd*(k1**6*(2*C - 2)*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 3*k1**4*k2**2*(2*C*(282*r**2 + r*(960*s - 497) + 282*s**2 - 695*s + 228) - 357*r**2 + r*(619 - 1110*s) - 357*s**2 + 817*s - 276) - 9*k1**2*k2**4*(4*C*(12*r**2 + r*(6 - 42*s) + 12*s**2 + 39*s - 13) - 189*r**2 + r*(197 - 246*s) - 189*s**2 + 131*s - 40) + k2**6*(198 - 396*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6*(r + s - 1)**2 + k1**4*k2**2*(22*r**2 + r*(44*s - 37) + 22*s**2 - 37*s + 15) + 3*k1**2*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 6*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*g2*(k1**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(44*r**2 + r*(88*s - 52) + 44*s**2 - 52*s + 15) + 3*k1**2*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 6*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-75*f**2*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(k1**6*(2*C - 2)*(36*r**2 + r*(72*s - 95) + 36*s**2 - 95*s + 51) + 3*k1**4*k2**2*(2*C*(376*r**2 + 32*r*(40*s - 21) + 376*s**2 - 1002*s + 309) - 476*r**2 + r*(843 - 1480*s) - 476*s**2 + 1173*s - 381) - 9*k1**2*k2**4*(4*C*(16*r**2 - 56*r*s + 3*r + 16*s**2 + 58*s - 14) - 252*r**2 + r*(291 - 328*s) - 252*s**2 + 181*s - 71) + k2**6*(198 - 396*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 858*g2*(k1**6*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(88*r**2 + 2*r*(88*s - 63) + 88*s**2 - 126*s + 45) + 3*k1**2*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 6*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(1001*d**2*k3**7) + 2*D1**3*Pk2*Pkd3*ct**2*(D1*bd1*f*(-5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(r + s - 1) - 66*f*(k1**6*(2*C - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(C*(44*r**2 + 64*r*s - 48*r + 44*s**2 - 48*s + 4) + 14*K*r**2 + 28*K*r*s - 27*K*r + 14*K*s**2 - 27*K*s + 13*K - 2*b1*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) - 42*r**2 - 72*r*s + 54*r - 42*s**2 + 54*s - 12) - 6*k1**2*k2**4*(-10*C*r**2 - 16*C*r*s + 10*C*r - 10*C*s**2 + 10*C*s - K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 12*r*s - 7*r + 7*s**2 - 7*s) + k2**6*(12*C - 6)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (-132*b1*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)) + 132*g2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 66*b1**2*(D1*fd*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14))) + Dd*f*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1)) - (r + s)*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(k1**6*(2*C - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(4*C*(22*r**2 + r*(32*s - 19) + 22*s**2 - 10*s + 4) + K*(28*r**2 + 8*r*(7*s - 5) + 28*s**2 - 40*s + 13) - 84*r**2 - 6*r*(24*s - 13) - 84*s**2 + 60*s - 18) + 6*k1**2*k2**4*(2*C*(10*r**2 + r*(16*s - 7) + 10*s**2 - 4*s + 1) + K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*r**2 - 24*r*s + 9*r - 14*s**2 + 6*s - 1) + k2**6*(12*C - 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 2*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) + 132*fd*g2*(r + s)**2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) - Dd*f*(5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(4*r + 4*s - 3) + 66*f*(k1**6*(2*C - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*C*(44*r**2 + r*(64*s - 46) + 44*s**2 - 31*s + 9) + K*(56*r**2 + 112*r*s - 94*r + 56*s**2 - 94*s + 39) - 168*r**2 - 288*r*s + 192*r - 168*s**2 + 162*s - 48) + 6*k1**2*k2**4*(C*(40*r**2 + 4*r*(16*s - 9) + 40*s**2 - 26*s + 4) + K*(4*r + 4*s - 3)**2 - 28*r**2 - 48*r*s + 24*r - 28*s**2 + 19*s - 2) + k2**6*(12*C - 6)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 132*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))) - 2*f*k1**2*(D1*(210*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + f*k2**2*(5*fd*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 66*gd2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 66*fd*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**4*(r + s - 1) + 5*f*k2**2*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3)) - 66*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3)))))/(77*d**2*k3**7) + 5*D1**3*Pk2*Pkd3*ct*f*k1*k2**3*st**6*(D1*(f**2*(13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 2) + 9*s**2 - 4*s - 5) + fd*k1**2*(4972*r**2 + r*(9944*s - 7653) + 4972*s**2 - 7653*s + 2943)) - 13*f*k2**2*(66*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 264*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 858*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(1243*r + 1243*s - 981) + 13*f*k2**2*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(-1716*K*b1 + 858*b1 + 3432*g2)))/(1001*d**2*k3**7) - 6*D1**3*Pk2*Pkd3*ct*k1*k2*st**4*(D1*(858*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(650*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - fd*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 26*f**2*k2**2*(fd*(k1**2*(-24*C + 25*b1 + 18) + k2**2*(20 - 40*C))*(3*r + 3*s - 2)**2 + (33*r + 33*s - 33)*(-bd1*k1**2*(2*K - 1)*(r + s) + bd1*k2**2*(K*(-7*r - 7*s + 3) + b1*(r + s - 1) + 2*r + 2*s - 1) + 4*gd2*k1**2*(r + s) + 2*gd2*k2**2*(7*r + 7*s - 3))) + 429*f*k2**2*(b1**2*fd*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(fd*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1))*(2*r + 2*s - 1) + k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-4*K*bd1 + 2*bd1 + 4*gd2)) + 4*g2*(-2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5)) + 26*f**2*k2**2*(k1**2*(24*C - 25*b1 - 18) + k2**2*(40*C - 20))*(3*r + 3*s - 2) - 429*f*k2**2*(b1**2*k2**2*(r + s - 1) - 2*b1*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1)) + 4*g2*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3)))))/(1001*d**2*k3**7) + D1**3*Pk2*Pkd3*ct*k1*st**2*(D1*(858*b1*fd*k2**4*(r + s)**2*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) + 3*f**3*k1**2*(13*bd1*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 13*f**2*k2**2*(66*bd1*(k1**4*(2*K - 1)*(r + s - 1)**2 + k1**2*k2**2*(8*C*(4*r**2 + 11*r*s - 7*r + 4*s**2 - 7*s + 3) + 5*K*r**2 + 10*K*r*s - 8*K*r + 5*K*s**2 - 8*K*s + 3*K - 3*b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 20*r**2 - 52*r*s + 32*r - 20*s**2 + 32*s - 12) + k2**4*(4*C*(7*r**2 + 6*r*(3*s - 2) + 7*s**2 - 12*s + 5) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 13*r**2 - 34*r*s + 23*r - 13*s**2 + 23*s - 10)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) - 132*gd2*(2*k1**4*(r + s - 1)**2 + k1**2*k2**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 429*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(2*r + 2*s - 1) - 2*b1*fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(4*C*(16*r**2 + 2*r*(22*s - 7) + 16*s**2 - 23*s + 3) + K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 40*r**2 - 104*r*s + 32*r - 40*s**2 + 50*s - 6) + k2**4*(4*C*(14*r**2 + r*(36*s - 13) + 14*s**2 - 19*s + 3) - 3*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 26*r**2 - 68*r*s + 25*r - 26*s**2 + 37*s - 6)) + 4*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(13 - 26*K) + bd1*k2**2*(7 - 40*K) + 26*gd2*k1**2 + 40*gd2*k2**2) + 4*g2*(2*bd1*k2**2*(13*k1**2 + 20*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(858*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) + 15*f**3*k1**4*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) + 13*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) - 429*f*k2**2*(3*b1**2*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(4*C*(32*r**2 + r*(88*s - 39) + 32*s**2 - 54*s + 12) + K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 80*r**2 - 208*r*s + 90*r - 80*s**2 + 120*s - 24) + k2**4*(4*C*(28*r**2 + r*(72*s - 35) + 28*s**2 - 45*s + 11) - 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 52*r**2 - 136*r*s + 67*r - 52*s**2 + 87*s - 22)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(1001*d**2*k2*k3**7) + 2*D1**3*Pk2*Pkd3*ct*k1*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(-k1**4*(-4*C + 10*b1 + 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*r + 3*K*s - 3*K - 9*b1*(3*r + 3*s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) + 132*k2**2*(r + s)*(b1*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)) - 2*g2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) + 66*b1**2*k2**2*(D1*fd*(f*k1**2*(5*k1**2*(2*r + 2*s - 1) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7))) + Dd*f*(f*(5*k1**4*(2*r + 2*s - 1) + 9*k1**2*k2**2*(3*r + 3*s - 1)) - (r + s)*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*k2**2*(fd*(2*r + 2*s - 1)*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 4*gd2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(r + s)**2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 264*g2*k2**2*(r + s)*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) - 66*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 12*f*gd2*(r + s - 1) - 12*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1))/(77*d**2*k2*k3**7) - 20*D1**3*Pk2*Pkd3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(143*d**2*k3**7) + 5*D1**3*Pk2*Pkd3*f*k2**2*st**6*(D1*(f**2*k1**2*(-13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 13) + 9*s**2 - 26*s + 17) + fd*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 13*f*k2**2*(b1*fd*k1**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-33*K*bd1 + 66*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2)) - 13*f*k2**2*(b1*k1**2*(9*r + 9*s - 17) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(-858*K*b1 + 1716*g2)*(2*r + 2*s - 1)))/(1001*d**2*k3**7) + 6*D1**3*Pk2*Pkd3*k1**2*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)) + 2*b1**2*(D1*fd*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s)**2 + f*k1**2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(4*D1*bd1*f*(r + s - 1)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1)) + D1*(-5*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1) - 2*gd2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s))))/(7*d**2*k3**7) - 6*D1**3*Pk2*Pkd3*st**4*(D1*(858*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) - f**3*fd*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 78*f**2*k2**4*(11*b1*bd1*k1**2*(r + s - 1)**2 - fd*k1**2*(4*C - 2)*(3*r + 3*s - 2)**2 + (-11*K*bd1 + 22*gd2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 429*f*k2**4*(b1**2*fd*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(K*fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(bd1*k2**2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7)) + f**2*k1**2*k2**4*(312*C - 156)*(3*r + 3*s - 2) - 429*f*k2**4*(-2*K*b1*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + b1**2*k1**2*(r + s - 1) + 4*g2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)))))/(1001*d**2*k3**7) + D1**3*Pk2*Pkd3*st**2*(D1*bd1*f*(f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(r + s - 1) - 66*f*k2**2*(-k1**4*(C*(4*r*s - 2*r - 2*s + 2) + K*r**2 + 2*K*r*s - 2*K*r + K*s**2 - 2*K*s + K - b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 2*r*s + r + s - 1) + k1**2*k2**2*(-4*C*(4*r**2 + 9*r*s - 6*r + 4*s**2 - 6*s + 2) + 4*K*r**2 + 8*K*r*s - 7*K*r + 4*K*s**2 - 7*K*s + 3*K - 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 18*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(13*k1**2 + 7*k2**2)*(132*K*b1 - 132*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 33*b1**2*k2**2*(D1*fd*(2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*k1**2*(k1**2*(25*r + 25*s - 11) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**4*(25*r + 25*s - 11) - 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(D1*(f**2*fd*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*k2**2*(fd*(-K*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1) - (2*C - 1)*(k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + 2*r*(18*s - 7) + 16*s**2 - 17*s + 3) + k2**4*(-2*r**2 - 4*r*s + r - 2*s**2 + s))) + 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 132*fd*g2*k2**4*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(4*r + 4*s - 3) - 66*f*k2**2*(-k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 8*r*s + r + 6*s - 1) + k1**2*k2**2*(-2*C*(32*r**2 + r*(72*s - 37) + 32*s**2 - 42*s + 10) + K*(4*r + 4*s - 3)**2 + 32*r**2 + 72*r*s - 37*r + 32*s**2 - 42*s + 10) + k2**4*(2*C - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 132*g2*k2**4*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - f*k1**2*(D1*(75*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(-fd*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(75*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(-9*r - 9*s + 17) + 33*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3)))))/(77*d**2*k3**7) - 2*D1**3*Pk2*Pkdd3*b1*ct*k1*k2*st**4*(r + s - 1)*(2*D1*b1*fd*(f - 1)*(r + s - 1) + D1*bd1*f*(f - 2)*(2*r + 2*s - 1) + Dd*b1*f*(f - 2)*(4*r + 4*s - 3))/(7*d**2*k3**2) + 2*D1**3*Pk2*Pkdd3*b1*k1**2*(D1*bd1*f*(7*b1*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + (2 - 4*C)*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6)) + b1*(D1*fd*(7*b1*(r + s - 1)**2 - (4*C - 2)*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1)) + Dd*f*(7*b1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + (2 - 4*C)*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4))))/(21*d**2*k3**2) - 20*D1**3*Pk2*Pkdd3*ct**8*f*k1**2*k2**4*(3978*C*D1*f*fd*r**2 + 7956*C*D1*f*fd*r*s - 4446*C*D1*f*fd*r + 3978*C*D1*f*fd*s**2 - 4446*C*D1*f*fd*s + 1196*C*D1*f*fd + 5304*C*Dd*f**2*r**2 + 10608*C*Dd*f**2*r*s - 6370*C*Dd*f**2*r + 5304*C*Dd*f**2*s**2 - 6370*C*Dd*f**2*s + 1794*C*Dd*f**2 + 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3584*D1*f**2*fd*r**2 + 7168*D1*f**2*fd*r*s - 5012*D1*f**2*fd*r + 3584*D1*f**2*fd*s**2 - 5012*D1*f**2*fd*s + 1743*D1*f**2*fd - 3978*D1*f*fd*r**2 - 7956*D1*f*fd*r*s + 4446*D1*f*fd*r - 3978*D1*f*fd*s**2 + 4446*D1*f*fd*s - 1196*D1*f*fd - 1716*D1*f*gd2*r**2 - 3432*D1*f*gd2*r*s + 2574*D1*f*gd2*r - 1716*D1*f*gd2*s**2 + 2574*D1*f*gd2*s - 858*D1*f*gd2 - 3432*D1*fd*g2*r**2 - 6864*D1*fd*g2*r*s + 3432*D1*fd*g2*r - 3432*D1*fd*g2*s**2 + 3432*D1*fd*g2*s - 858*D1*fd*g2 + 3584*Dd*f**3*r**2 + 7168*Dd*f**3*r*s - 5012*Dd*f**3*r + 3584*Dd*f**3*s**2 - 5012*Dd*f**3*s + 1743*Dd*f**3 - 5304*Dd*f**2*r**2 - 10608*Dd*f**2*r*s + 6370*Dd*f**2*r - 5304*Dd*f**2*s**2 + 6370*Dd*f**2*s - 1794*Dd*f**2 - 6864*Dd*f*g2*r**2 - 13728*Dd*f*g2*r*s + 8580*Dd*f*g2*r - 6864*Dd*f*g2*s**2 + 8580*Dd*f*g2*s - 2574*Dd*f*g2 + 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(9009*d**2*k3**6) - 10*D1**3*Pk2*Pkdd3*ct**7*f*k1*k2**3*(D1*bd1*f*(r + s - 1)*(f*(135*r + 135*s - 79) + 132*r + 132*s - 66) + b1*(D1*fd*(f*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + 66*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(135*r + 135*s - 79) + 132*r + 132*s - 66)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(51*r + 51*s - 23))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**7*f*k1*k2**3*(-13*D1*bd1*f*(k1**2*(132*K - 132)*(11*r + 11*s - 7) - 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) - 2*D1*(35*f**2*fd*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 13*f*(5*fd*(k1**2*(2*C - 2)*(315*r**2 + 9*r*(70*s - 43) + 315*s**2 - 387*s + 118) + k2**2*(4*C*(153*r**2 + 504*r*s - 204*r + 153*s**2 - 303*s + 79) - 459*r**2 - 1314*r*s + 579*r - 459*s**2 + 777*s - 204)) - 132*gd2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(r + s - 1)) - 1716*fd*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - 2*Dd*f*(35*f**2*k1**2*(1624*r**2 + r*(3248*s - 2358) + 1624*s**2 - 2358*s + 855) + 65*f*(k1**2*(2*C - 2)*(420*r**2 + r*(840*s - 551) + 420*s**2 - 551*s + 177) + k2**2*(4*C*(204*r**2 + 672*r*s - 278*r + 204*s**2 - 443*s + 102) - 612*r**2 - 1752*r*s + 801*r - 612*s**2 + 1131*s - 273)) - 1716*g2*(k1**2*(11*r + 11*s - 7) + 5*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(k1**2*(132 - 132*K)*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7) + 5*k2**2*(f*(405*r**2 + r*(810*s - 507) + 405*s**2 - 507*s + 158) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(132 - 132*K)*(11*r + 11*s - 7) + 5*k2**2*(f*(135*r + 135*s - 79) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(9009*d**2*k3**6) - 10*D1**3*Pk2*Pkdd3*ct**6*f*k1**2*k2**4*st**2*(12402*C*D1*f*fd*r**2 + 24804*C*D1*f*fd*r*s - 14820*C*D1*f*fd*r + 12402*C*D1*f*fd*s**2 - 14820*C*D1*f*fd*s + 4368*C*D1*f*fd + 16536*C*Dd*f**2*r**2 + 33072*C*Dd*f**2*r*s - 21138*C*Dd*f**2*r + 16536*C*Dd*f**2*s**2 - 21138*C*Dd*f**2*s + 6552*C*Dd*f**2 + 1287*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 16492*D1*f**2*fd*r**2 + 32984*D1*f**2*fd*r*s - 23373*D1*f**2*fd*r + 16492*D1*f**2*fd*s**2 - 23373*D1*f**2*fd*s + 8253*D1*f**2*fd - 12402*D1*f*fd*r**2 - 24804*D1*f*fd*r*s + 14820*D1*f*fd*r - 12402*D1*f*fd*s**2 + 14820*D1*f*fd*s - 4368*D1*f*fd - 5148*D1*f*gd2*r**2 - 10296*D1*f*gd2*r*s + 7722*D1*f*gd2*r - 5148*D1*f*gd2*s**2 + 7722*D1*f*gd2*s - 2574*D1*f*gd2 - 10296*D1*fd*g2*r**2 - 20592*D1*fd*g2*r*s + 10296*D1*fd*g2*r - 10296*D1*fd*g2*s**2 + 10296*D1*fd*g2*s - 2574*D1*fd*g2 + 16492*Dd*f**3*r**2 + 32984*Dd*f**3*r*s - 23373*Dd*f**3*r + 16492*Dd*f**3*s**2 - 23373*Dd*f**3*s + 8253*Dd*f**3 - 16536*Dd*f**2*r**2 - 33072*Dd*f**2*r*s + 21138*Dd*f**2*r - 16536*Dd*f**2*s**2 + 21138*Dd*f**2*s - 6552*Dd*f**2 - 20592*Dd*f*g2*r**2 - 41184*Dd*f*g2*r*s + 25740*Dd*f*g2*r - 20592*Dd*f*g2*s**2 + 25740*Dd*f*g2*s - 7722*Dd*f*g2 + 1287*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(9009*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**6*k2**2*(396*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1*(396*D1*bd1*f*k1**2*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(5*f**2*fd*k1**2*(1233*r**2 + 9*r*(274*s - 209) + 1233*s**2 - 1881*s + 740) + 66*f*(-5*K*fd*k2**2*(2*r + 2*s - 1)**2 + 2*fd*k1**2*(8*C*(r + s - 1)**2 + 14*r**2 + r*(28*s - 9) + 14*s**2 - 9*s - 1) - 12*gd2*k1**2*(r + s - 1)**2) - 792*fd*g2*k1**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*(411*r + 411*s - 319) + 66*f*(-5*K*k2**2*(2*r + 2*s - 1) + 2*k1**2*(4*C*(r + s - 1) + 7*r + 7*s - 3)) - 792*g2*k1**2*(r + s - 1))) + f*(D1*bd1*(r + s - 1)*(5*f**2*k1**2*(411*r + 411*s - 217) + 66*f*(-5*K*k2**2*(2*r + 2*s - 1) + 2*k1**2*(4*C*r + 4*C*s + 7*r + 7*s - 7)) - 792*g2*k1**2*(r + s)) + 10*D1*(f*fd*(k1**2*(315*r**2 + 9*r*(70*s - 43) + 315*s**2 - 387*s + 118) - k2**2*(2*C - 1)*(153*r**2 + 12*r*(42*s - 17) + 153*s**2 - 303*s + 79)) - 33*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 33*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)**2) + 10*Dd*f*(f*(k1**2*(420*r**2 + r*(840*s - 551) + 420*s**2 - 551*s + 177) - k2**2*(2*C - 1)*(204*r**2 + r*(672*s - 278) + 204*s**2 - 443*s + 102)) + k2**2*(-33*b2 + 66*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(693*d**2*k3**4) - 2*D1**3*Pk2*Pkdd3*ct**6*k2**2*(-13*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + k1**2*k2**2*(r + s)*(-792*K*b1 + 792*b1 + 792*g2)) + 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 13*b1*(D1*(5*f**2*fd*k1**2*k2**2*(927*r**2 + 9*r*(206*s - 141) + 927*s**2 - 1269*s + 434) - 66*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 792*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(309*r + 309*s - 217) - 66*f*(5*K*k2**4*(2*r + 2*s - 1) + k1**4*(12*K - 12)*(r + s - 1) + 2*k1**2*k2**2*(C*(4*r + 4*s + 1) + K*(16*r + 16*s - 11) - 9*r - 9*s + 3)) + 792*g2*k1**2*k2**2*(r + s))) + 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**4*(6*C - 6)*(42*r**2 + r*(84*s - 67) + 42*s**2 - 67*s + 26) + k1**2*k2**2*(2*C*(432*r**2 + 6*r*(309*s - 118) + 432*s**2 - 1203*s + 335) - 549*r**2 - 72*r*(29*s - 12) - 549*s**2 + 1359*s - 387) + k2**4*(2*C - 1)*(153*r**2 + 12*r*(42*s - 17) + 153*s**2 - 303*s + 79)) - 66*gd2*(12*k1**4*(r + s - 1)**2 + 2*k1**2*k2**2*(16*r**2 + r*(32*s - 27) + 16*s**2 - 27*s + 11) + 5*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 858*fd*g2*(12*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**2*k2**2*(32*r**2 + r*(64*s - 38) + 32*s**2 - 38*s + 11) + 5*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(70*f**2*k1**2*(k1**2*(211*r + 211*s - 168) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + 65*f*(k1**4*(6*C - 6)*(56*r**2 + 2*r*(56*s - 47) + 56*s**2 - 94*s + 39) + k1**2*k2**2*(2*C*(576*r**2 + r*(2472*s - 937) + 576*s**2 - 1762*s + 420) - 732*r**2 - 3*r*(928*s - 386) - 732*s**2 + 1983*s - 498) + k2**4*(2*C - 1)*(204*r**2 + r*(672*s - 278) + 204*s**2 - 443*s + 102)) - 858*g2*(12*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k1**2*k2**2*(64*r**2 + 4*r*(32*s - 23) + 64*s**2 - 92*s + 33) + 5*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(9009*d**2*k3**6) - 5*D1**3*Pk2*Pkdd3*ct**5*f*k1*k2**3*st**2*(D1*bd1*f*(r + s - 1)*(f*(177*r + 177*s - 107) + 132*r + 132*s - 66) + b1*(D1*fd*(f*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + 66*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(177*r + 177*s - 107) + 132*r + 132*s - 66)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(53*r + 53*s - 28))/(231*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**5*f*k1*k2**3*st**2*(-231192*C*D1*f*fd*k1**2*r**2 - 462384*C*D1*f*fd*k1**2*r*s + 291096*C*D1*f*fd*k1**2*r - 231192*C*D1*f*fd*k1**2*s**2 + 291096*C*D1*f*fd*k1**2*s - 91312*C*D1*f*fd*k1**2 - 248040*C*D1*f*fd*k2**2*r**2 - 702000*C*D1*f*fd*k2**2*r*s + 330720*C*D1*f*fd*k2**2*r - 248040*C*D1*f*fd*k2**2*s**2 + 433680*C*D1*f*fd*k2**2*s - 121680*C*D1*f*fd*k2**2 - 308256*C*Dd*f**2*k1**2*r**2 - 616512*C*Dd*f**2*k1**2*r*s + 413816*C*Dd*f**2*k1**2*r - 308256*C*Dd*f**2*k1**2*s**2 + 413816*C*Dd*f**2*k1**2*s - 136968*C*Dd*f**2*k1**2 - 330720*C*Dd*f**2*k2**2*r**2 - 936000*C*Dd*f**2*k2**2*r*s + 457080*C*Dd*f**2*k2**2*r - 330720*C*Dd*f**2*k2**2*s**2 + 628680*C*Dd*f**2*k2**2*s - 165360*C*Dd*f**2*k2**2 - 39*D1*bd1*f*(k1**2*(44*K - 44)*(31*r + 31*s - 17) - 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(r + s - 1) - 437100*D1*f**2*fd*k1**2*r**2 - 874200*D1*f**2*fd*k1**2*r*s + 637125*D1*f**2*fd*k1**2*r - 437100*D1*f**2*fd*k1**2*s**2 + 637125*D1*f**2*fd*k1**2*s - 231975*D1*f**2*fd*k1**2 + 231192*D1*f*fd*k1**2*r**2 + 462384*D1*f*fd*k1**2*r*s - 291096*D1*f*fd*k1**2*r + 231192*D1*f*fd*k1**2*s**2 - 291096*D1*f*fd*k1**2*s + 91312*D1*f*fd*k1**2 + 186030*D1*f*fd*k2**2*r**2 + 475020*D1*f*fd*k2**2*r*s - 239460*D1*f*fd*k2**2*r + 186030*D1*f*fd*k2**2*s**2 - 290940*D1*f*fd*k2**2*s + 82680*D1*f*fd*k2**2 + 106392*D1*f*gd2*k1**2*r**2 + 212784*D1*f*gd2*k1**2*r*s - 164736*D1*f*gd2*k1**2*r + 106392*D1*f*gd2*k1**2*s**2 - 164736*D1*f*gd2*k1**2*s + 58344*D1*f*gd2*k1**2 + 102960*D1*f*gd2*k2**2*r**2 + 205920*D1*f*gd2*k2**2*r*s - 154440*D1*f*gd2*k2**2*r + 102960*D1*f*gd2*k2**2*s**2 - 154440*D1*f*gd2*k2**2*s + 51480*D1*f*gd2*k2**2 + 212784*D1*fd*g2*k1**2*r**2 + 425568*D1*fd*g2*k1**2*r*s - 223080*D1*fd*g2*k1**2*r + 212784*D1*fd*g2*k1**2*s**2 - 223080*D1*fd*g2*k1**2*s + 58344*D1*fd*g2*k1**2 + 205920*D1*fd*g2*k2**2*r**2 + 411840*D1*fd*g2*k2**2*r*s - 205920*D1*fd*g2*k2**2*r + 205920*D1*fd*g2*k2**2*s**2 - 205920*D1*fd*g2*k2**2*s + 51480*D1*fd*g2*k2**2 - 437100*Dd*f**3*k1**2*r**2 - 874200*Dd*f**3*k1**2*r*s + 637125*Dd*f**3*k1**2*r - 437100*Dd*f**3*k1**2*s**2 + 637125*Dd*f**3*k1**2*s - 231975*Dd*f**3*k1**2 + 308256*Dd*f**2*k1**2*r**2 + 616512*Dd*f**2*k1**2*r*s - 413816*Dd*f**2*k1**2*r + 308256*Dd*f**2*k1**2*s**2 - 413816*Dd*f**2*k1**2*s + 136968*Dd*f**2*k1**2 + 248040*Dd*f**2*k2**2*r**2 + 633360*Dd*f**2*k2**2*r*s - 334230*Dd*f**2*k2**2*r + 248040*Dd*f**2*k2**2*s**2 - 420030*Dd*f**2*k2**2*s + 115440*Dd*f**2*k2**2 + 425568*Dd*f*g2*k1**2*r**2 + 851136*Dd*f*g2*k1**2*r*s - 552552*Dd*f*g2*k1**2*r + 425568*Dd*f*g2*k1**2*s**2 - 552552*Dd*f*g2*k1**2*s + 175032*Dd*f*g2*k1**2 + 411840*Dd*f*g2*k2**2*r**2 + 823680*Dd*f*g2*k2**2*r*s - 514800*Dd*f*g2*k2**2*r + 411840*Dd*f*g2*k2**2*s**2 - 514800*Dd*f*g2*k2**2*s + 154440*Dd*f*g2*k2**2 + 39*b1*(D1*fd*(k1**2*(44 - 44*K)*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17) + 5*k2**2*(f*(531*r**2 + 9*r*(118*s - 75) + 531*s**2 - 675*s + 214) + (66 - 132*K)*(2*r + 2*s - 1)**2)) + Dd*f*(k1**2*(44 - 44*K)*(31*r + 31*s - 17) + 5*k2**2*(f*(177*r + 177*s - 107) + (66 - 132*K)*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(9009*d**2*k3**6) - 4*D1**3*Pk2*Pkdd3*ct**5*k1*k2*(r + s - 1)*(4*D1*bd1*f**2*(r + s) + b1**2*(2*D1*fd*(7*f + 3)*(r + s - 1) + Dd*f*(7*f + 6)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(7*f + 6)*(2*r + 2*s - 1) + 8*D1*fd*(r + s - 1) + 4*Dd*f*(4*r + 4*s - 3)))/(21*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**5*k1*k2*(66*b1**2*(D1*fd*(k1**2*(5*K - 5)*(r + s - 1)**2 + k2**2*(12*K*(r + s - 1)**2 + f*(17*r + 17*s - 12) + 12*r + 12*s - 6)) + Dd*f*(k1**2*(5*K - 5)*(r + s - 1) + k2**2*(12*K*(r + s - 1) + 5*f + 6))*(4*r + 4*s - 3)) + 3*b1*(22*D1*bd1*f*(k1**2*(5*K - 5)*(2*r + 2*s - 1) + 3*k2**2*(K*(8*r + 8*s - 4) + f + 2))*(r + s - 1) + D1*(5*f**2*fd*(k1**2*(324*r**2 + r*(648*s - 581) + 324*s**2 - 581*s + 259) - 11*k2**2*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6)) + 22*f*(4*fd*k1**2*(r + s - 1)*(2*C*(r + s - 1) + 4*r + 4*s - 1) + fd*k2**2*(8*C*(4*r**2 + r*(20*s - 11) + 4*s**2 - 17*s + 7) - 2*K*(22*r**2 + 44*r*s - 25*r + 22*s**2 - 25*s + 7) - 40*r**2 - 128*r*s + 82*r - 40*s**2 + 106*s - 43) - 2*gd2*(5*k1**2 + 12*k2**2)*(r + s - 1)**2) - 44*fd*g2*(5*k1**2 + 12*k2**2)*(r + s - 1)**2) + Dd*f*(5*f**2*(2*k1**2*(54*r + 54*s - 53) - 11*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 22*f*(k1**2*(4*C + 8)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(8*C*(8*r**2 + r*(40*s - 17) + 8*s**2 - 32*s + 9) - 2*K*(44*r**2 + 88*r*s - 61*r + 44*s**2 - 61*s + 21) - 80*r**2 - 256*r*s + 148*r - 80*s**2 + 208*s - 69)) - 44*g2*(5*k1**2 + 12*k2**2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + f*(3*D1*bd1*(5*f**2*(k1**2*(108*r + 108*s - 59) - 11*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 22*f*(4*k1**2*(r + s - 1)*(r*(C + 2) + s*(C + 2) - 3) - k2**2*(-16*C*s**2 + 40*C*s + 2*K*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) - r**2*(16*C - 20) + r*(-80*C*s + 16*C + 64*s - 27) + 20*s**2 - 39*s + 7)) - 44*g2*(5*k1**2 + 12*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*(f*(5*fd*(3*k1**2*(42*r**2 + r*(84*s - 67) + 42*s**2 - 67*s + 26) + k2**2*(-2*C*(315*r**2 + 1026*r*s - 453*r + 315*s**2 - 651*s + 184) + 117*r**2 + 630*r*s - 222*r + 117*s**2 - 420*s + 118)) + k2**2*(-66*bd2 + 132*gd2)*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7)) - 66*fd*k2**2*(b2 - 2*g2)*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7)) + 2*Dd*f*(5*f*(3*k1**2*(56*r**2 + 2*r*(56*s - 47) + 56*s**2 - 94*s + 39) + k2**2*(-2*C*(420*r**2 + 1368*r*s - 617*r + 420*s**2 - 947*s + 243) + 156*r**2 + 840*r*s - 287*r + 156*s**2 - 617*s + 144)) + k2**2*(-66*b2 + 132*g2)*(44*r**2 + r*(88*s - 61) + 44*s**2 - 61*s + 21))))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**5*k1*k2*(13*D1*bd1*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 66*f*(k1**4*(2*K - 2)*(r**2 + 2*r*s + s**2 - 1) - 2*k1**2*k2**2*(r + s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5) + 2*K*r**2 + 4*K*r*s + 2*K*s**2 - 2*K + 2*b1*(7*r**2 + r*(14*s - 9) + 7*s**2 - 9*s + 2) + 24*r*s - 3*r - 3*s + 3)) + 264*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-5*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(5*k1**2 + 6*k2**2))) + 858*b1**2*k2**2*(D1*fd*(f*k2**2*(14*r**2 + r*(28*s - 11) + 14*s**2 - 11*s + 2) + (r + s)**2*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(7*r + 7*s - 2) + (r + s)*(-2*k1**2*(5*K - 5) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(5*f**2*fd*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) + 66*f*(fd*(k1**4*(2*K - 2)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) - 2*k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 2*K*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 6*r*(8*s + 3) - 18*s - 9)) + 4*gd2*k2**2*(5*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(5*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(5*f**2*k2**2*(2*k1**2*(57*r + 57*s - 82) - 33*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 66*f*(k1**4*(2*K - 2)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 2*k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(r + s + 1) - 3*K*(r + s + 1) + 5*r + 5*s - 7) + k2**4*(-4*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 2*K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 96*r*s + 24*r - 36*s - 15)) + 264*g2*k2**2*(5*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) - 2*f*(D1*(70*f**2*fd*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*fd*(k1**4*(2*C - 2)*(81*r**2 + 3*r*(54*s - 25) + 81*s**2 - 75*s + 14) + 3*k1**2*k2**2*(2*C*(81*r**2 - 102*r*s - 31*r + 81*s**2 + 101*s - 30) - 204*r**2 - 144*r*s + 173*r - 204*s**2 + 41*s - 10) + k2**4*(2*C*(81*r**2 - 9*r*(26*s + 1) + 81*s**2 + 189*s - 52) - 279*r**2 - 162*r*s + 240*r - 279*s**2 + 42*s - 14)) + 1716*f*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + 2*r*s + s**2 - 1) + 1716*fd*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1)) + Dd*f*(70*f**2*k1**2*(k1**2*(55*r + 55*s - 64) - 39*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 65*f*(k1**4*(2*C - 2)*(108*r**2 + r*(216*s - 109) + 108*s**2 - 109*s + 21) + 3*k1**2*k2**2*(2*C*(108*r**2 - 136*r*s - 65*r + 108*s**2 + 155*s - 23) - 272*r**2 - 192*r*s + 268*r - 272*s**2 + 48*s - 37) + k2**4*(C*(216*r**2 - 624*r*s - 86*r + 216*s**2 + 574*s - 90) - 372*r**2 - 216*r*s + 373*r - 372*s**2 + 43*s - 54)) + 1716*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3))))/(9009*d**2*k3**6) - 20*D1**3*Pk2*Pkdd3*ct**4*f**2*k1**2*k2**4*st**4*(D1*fd*(78*C*(3*r + 3*s - 2)**2 + 7*f*(268*r**2 + 536*r*s - 389*r + 268*s**2 - 389*s + 141) - 78*(3*r + 3*s - 2)**2) + Dd*f*(4*r + 4*s - 3)*(78*C*(3*r + 3*s - 2) + 7*f*(67*r + 67*s - 47) - 234*r - 234*s + 156))/(3003*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct**4*k2**2*st**2*(-396*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 3*b1*(132*D1*bd1*f*k1**2*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(5*f**2*fd*k1**2*(1359*r**2 + r*(2718*s - 2035) + 1359*s**2 - 2035*s + 788) + 22*f*(-15*K*fd*k2**2*(2*r + 2*s - 1)**2 + 2*fd*k1**2*(18*C*(r + s - 1)**2 + 44*r**2 + r*(88*s - 29) + 44*s**2 - 29*s - 1) - 12*gd2*k1**2*(r + s - 1)**2) - 264*fd*g2*k1**2*(r + s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(-330*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(453*r + 453*s - 341) + 44*f*k1**2*(9*C*(r + s - 1) + 22*r + 22*s - 8) - 264*g2*k1**2*(r + s - 1))) - f*(3*D1*bd1*(r + s - 1)*(-330*K*f*k2**2*(2*r + 2*s - 1) + 5*f**2*k1**2*(453*r + 453*s - 235) + 44*f*k1**2*(r*(9*C + 22) + s*(9*C + 22) - 17) - 264*g2*k1**2*(r + s)) + 2*D1*(f*fd*(2*k1**2*(2223*r**2 + 9*r*(494*s - 311) + 2223*s**2 - 2799*s + 878) + k2**2*(15 - 30*C)*(159*r**2 + r*(450*s - 212) + 159*s**2 - 278*s + 78)) - 495*f*k2**2*(bd2 - 2*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 495*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)**2) + 2*Dd*f*(f*(2*k1**2*(2964*r**2 + r*(5928*s - 3979) + 2964*s**2 - 3979*s + 1317) + k2**2*(15 - 30*C)*(212*r**2 + r*(600*s - 293) + 212*s**2 - 403*s + 106)) + k2**2*(-495*b2 + 990*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(693*d**2*k3**4) + D1**3*Pk2*Pkdd3*ct**4*k2**2*st**2*(39*D1*bd1*f*(r + s - 1)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + k1**2*k2**2*(r + s)*(-264*K*b1 + 264*b1 + 264*g2)) - 5148*b1**2*k1**2*k2**2*(K - 1)*(r + s)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 39*b1*(D1*(5*f**2*fd*k1**2*k2**2*(1041*r**2 + r*(2082*s - 1399) + 1041*s**2 - 1399*s + 470) - 22*f*(fd*(2*r + 2*s - 1)*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) - 12*gd2*k1**2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k1**2*k2**2*(r + s)**2) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**2*k2**2*(347*r + 347*s - 235) - 22*f*(15*K*k2**4*(2*r + 2*s - 1) + k1**4*(9*K - 9)*(5*r + 5*s - 3) + 2*k1**2*k2**2*(C*(9*r + 9*s - 3) + K*(56*r + 56*s - 31) - 34*r - 34*s + 17)) + 264*g2*k1**2*k2**2*(r + s))) + f*(D1*(-375*f**2*fd*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 26*f*(fd*(k1**4*(612*C - 612)*(3*r + 3*s - 2)**2 + 2*k1**2*k2**2*(2*C*(3852*r**2 + 18*r*(659*s - 311) + 3852*s**2 - 7677*s + 2251) - 5481*r**2 - 72*r*(210*s - 107) - 5481*s**2 + 9783*s - 2931) + k2**4*(30*C - 15)*(159*r**2 + r*(450*s - 212) + 159*s**2 - 278*s + 78)) - 66*gd2*(9*k1**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 2*k1**2*k2**2*(56*r**2 + r*(112*s - 87) + 56*s**2 - 87*s + 31) + 15*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 1716*fd*g2*(9*k1**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k1**2*k2**2*(112*r**2 + 2*r*(112*s - 59) + 112*s**2 - 118*s + 31) + 15*k2**4*(2*r + 2*s - 1)**2)) + Dd*f*(-375*f**2*k1**2*(k1**2*(277*r + 277*s - 211) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) - 26*f*(k1**4*(612*C - 612)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 2*k1**2*k2**2*(2*C*(5136*r**2 + r*(15816*s - 7661) + 5136*s**2 - 11126*s + 3030) - 7308*r**2 - 30*r*(672*s - 355) - 7308*s**2 + 14115*s - 4050) + k2**4*(30*C - 15)*(212*r**2 + r*(600*s - 293) + 212*s**2 - 403*s + 106)) + 1716*g2*(9*k1**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k1**2*k2**2*(224*r**2 + 4*r*(112*s - 73) + 224*s**2 - 292*s + 93) + 15*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(9009*d**2*k3**6) - 4*D1**3*Pk2*Pkdd3*ct**4*(-2*D1*bd1*f*(f*(k1**2*(-r**2 - 2*r*s + r - s**2 + s) + k2**2*(2*C - 1)*(2*r**2 + 2*r*(5*s - 1) + s*(2*s - 5))) + k2**2*(3*b2 - 6*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + b1**2*(D1*fd*(-6*K*k2**2 + k1**2*(10*f + 5))*(r + s - 1) + Dd*f*(-6*K*k2**2 + k1**2*(5*f + 5))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(-6*K*k2**2 + k1**2*(5*f + 5))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*D1*(f*(2*fd*k1**2*(r + s - 1)**2 - fd*k2**2*(2*C - 1)*(4*r**2 + r*(20*s - 11) + 4*s**2 - 17*s + 7) - k2**2*(3*bd2 - 6*gd2)*(r + s - 1)**2) - 3*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + 2*Dd*f*(f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - k2**2*(2*C - 1)*(8*r**2 + r*(40*s - 17) + 8*s**2 - 32*s + 9)) + k2**2*(-3*b2 + 6*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(21*d**2*k3**2) + 2*D1**3*Pk2*Pkdd3*ct**4*(-66*b1**2*(D1*fd*(-6*K*k2**4*(2*r + 2*s - 1) - k1**4*(K - 1)*(r + s - 1)**2 + k1**2*k2**2*(-2*C*(r + s - 1)**2 + 3*K*r**2 + 6*K*r*s - 6*K*r + 3*K*s**2 - 6*K*s + 3*K + f*(16*r**2 + 32*r*s - 3*r + 16*s**2 - 3*s - 5) + 14*r**2 + 28*r*s - 8*r + 14*s**2 - 8*s + 4)) + Dd*f*(4*r + 4*s - 3)*(-6*K*k2**4 - k1**4*(K - 1)*(r + s - 1) + k1**2*k2**2*(-2*C*(r + s - 1) + 3*K*(r + s - 1) + 8*f*r + 8*f*s + 14*r + 14*s - 4))) + b1*(66*D1*bd1*f*(r + s - 1)*(6*K*k2**4 + k1**4*(K - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(C*(4*r + 4*s - 2) - 6*K*r - 6*K*s + 3*K + f*(-16*r - 16*s + 5) - 28*r - 28*s + 4)) + D1*(5*f**2*fd*k1**2*(k1**2*(36*r**2 + r*(72*s + 69) + 36*s**2 + 69*s - 65) + 33*k2**2*(51*r**2 + r*(102*s - 77) + 51*s**2 - 77*s + 30)) + 66*f*(fd*(2*k1**4*(4*C*(r + s - 1)**2 - 2*r**2 + r*(9 - 4*s) - 2*s**2 + 9*s - 5) + 4*k1**2*k2**2*(C*(2*r**2 + r*(11 - 56*s) + 2*s**2 + 41*s - 13) + 3*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 10*r**2 + 50*r*s - 19*r + 10*s**2 - 34*s + 10) + k2**4*(C*(40*r + 28*s - 30) - 6*K*(2*r + 2*s - 1)**2 - 20*r - 14*s + 15)) + (-3*bd2*k2**4*(r + s) + gd2*(k1**4*(r + s - 1) - 3*k1**2*k2**2*(r + s - 1) + 6*k2**4))*(-2*r - 2*s + 2)) - 132*fd*(-3*b2*k2**4*(r + s)**2 + g2*(k1**4*(r + s - 1)**2 - 3*k1**2*k2**2*(r + s - 1)**2 + 6*k2**4*(2*r + 2*s - 1)))) + Dd*f*(5*f**2*k1**2*(4*k1**2*(3*r + 3*s + 7) + 33*k2**2*(17*r + 17*s - 13))*(4*r + 4*s - 3) + 66*f*(2*k1**4*(4*r + 4*s - 3)*(2*C*(r + s - 1) - r - s + 3) + 2*k1**2*k2**2*(2*C*(4*r**2 + r*(8 - 112*s) + 4*s**2 + 83*s - 12) + 6*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 40*r**2 + 200*r*s - 77*r + 40*s**2 - 152*s + 39) + k2**4*(10*C - 6*K*(2*r + 2*s - 1) - 5)*(4*r + 4*s - 3)) - (-3*b2*k2**4*(r + s) + g2*(k1**4*(r + s - 1) - 3*k1**2*k2**2*(r + s - 1) + 6*k2**4))*(528*r + 528*s - 396))) + f*(D1*bd1*(5*f**2*k1**2*(k1**2*(12*r + 12*s + 19) + 33*k2**2*(17*r + 17*s - 9))*(r + s - 1) + 66*f*(2*k1**4*(r + s - 1)*(r*(2*C - 1) + s*(2*C - 1) + 1) + 2*k1**2*k2**2*(2*C*s**2 + 28*C*s + 6*K*(r + s - 1)**2 + r**2*(2*C + 10) - r*(56*C*s + 2*C - 50*s + 21) + 10*s**2 - 36*s + 11) - k2**4*(2*C*(5*r - s - 5) + 6*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 5*r + s + 5)) + (r**2 + r*(2*s - 1) + s*(s - 1))*(396*b2*k2**4 - 132*g2*k1**4 + 396*g2*k1**2*k2**2)) + 2*D1*(f*(5*fd*(k1**4*(81*r**2 + 3*r*(54*s - 25) + 81*s**2 - 75*s + 14) + 3*k1**2*k2**2*(2*C*(42*r**2 + 6*r*(25*s - 13) + 42*s**2 - 111*s + 37) + 123*r**2 + r*(180*s - 131) + 123*s**2 - 98*s + 29) + k2**4*(33 - 66*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + k2**2*(198*bd2 - 396*gd2)*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(r + s - 1)) + 198*fd*k2**2*(b2 - 2*g2)*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1)) + 2*Dd*f*(5*f*(k1**4*(108*r**2 + r*(216*s - 109) + 108*s**2 - 109*s + 21) + 3*k1**2*k2**2*(2*C*(56*r**2 + 5*r*(40*s - 21) + 56*s**2 - 160*s + 50) + 164*r**2 + 48*r*(5*s - 4) + 164*s**2 - 137*s + 49) + k2**4*(33 - 66*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + k2**2*(198*b2 - 396*g2)*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(4*r + 4*s - 3))))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**4*(-429*D1*bd1*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) - 2*f*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*k1**4*k2**2*(r + s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) + 2*k1**2*k2**4*(-2*C*(r**2 + 4*r*(8*s - 3) + s**2 - 12*s + 11) + 12*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1*(17*r**2 + r*(34*s - 21) + 17*s**2 - 21*s + 4) - 15*r**2 + 15*r - 15*s*(s - 1)) + k2**6*(-2*C*(4*r**2 + r*(20*s - 9) + 4*s**2 - 9*s + 5) + 6*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 4*r**2 + 20*r*s - 9*r + 4*s**2 - 9*s + 5)) + 4*k2**2*(b1*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)) - g2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 858*b1**2*k2**2*(D1*fd*(f*k1**2*k2**2*(34*r**2 + r*(68*s - 25) + 34*s**2 - 25*s + 4) - (r + s)**2*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3))) + Dd*f*(f*k1**2*k2**2*(17*r + 17*s - 4) - (r + s)*(6*K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(13*K - 3)))*(4*r + 4*s - 3)) - 429*b1*(D1*(5*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) - 2*f*(fd*(k1**6*(K - 1)*(2*r + 2*s - 1)**2 + 2*k1**4*k2**2*(2*r + 2*s - 1)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(2*r**2 + 64*r*s + 7*r + 2*s**2 - 38*s - 4) - 12*K*(2*r + 2*s - 1)**2 + 30*r**2 - 45*r + 30*s**2 + 15) + k2**6*(-2*C*(8*r**2 + r*(40*s - 2) + 8*s**2 - 20*s - 1) + 6*K*(2*r + 2*s - 1)**2 + 8*r**2 + 40*r*s - 2*r + 8*s**2 - 20*s - 1)) + 2*gd2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*fd*g2*k2**2*(r + s)**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)) + Dd*f*(5*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) - 2*f*(k1**6*(K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 2*k1**4*k2**2*(4*r + 4*s - 3)*(6*C*(r + s - 1) + 7*K*(2*r + 2*s - 1) - 19*r - 19*s + 14) - 2*k1**2*k2**4*(2*C*(4*r**2 + 2*r*(64*s - 1) + 4*s**2 - 77*s + 3) - 12*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 60*r**2 - 90*r + 60*s**2 - 15*s + 30) + k2**6*(-2*C*(16*r**2 + 2*r*(40*s - 7) + 16*s**2 - 44*s + 3) + 6*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 16*r**2 + 80*r*s - 14*r + 16*s**2 - 44*s + 3)) - 4*g2*k2**2*(k1**4 + 13*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + 2*f*(D1*(35*f**2*fd*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 13*f*(5*fd*(k1**6*(10*C - 10)*(3*r + 3*s - 2)**2 + k1**4*k2**2*(2*C*(558*r**2 + r*(918*s - 678) + 558*s**2 - 579*s + 193) - 1035*r**2 - 18*r*(104*s - 73) - 1035*s**2 + 1215*s - 405) + 3*k1**2*k2**4*(2*C*(288*r**2 + 170*r*(3*s - 2) + 288*s**2 - 307*s + 95) - 453*r**2 + r*(549 - 840*s) - 453*s**2 + 516*s - 161) + k2**6*(66*C - 33)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 858*fd*g2*(2*r + 2*s - 1)**2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)) + Dd*f*(35*f**2*k1**4*(k1**2*(62*r + 62*s - 27) + 78*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 65*f*(k1**6*(10*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k1**4*k2**2*(2*C*(744*r**2 + r*(1224*s - 977) + 744*s**2 - 812*s + 306) - 1380*r**2 - 3*r*(832*s - 626) - 1380*s**2 + 1713*s - 624) + 3*k1**2*k2**4*(2*C*(384*r**2 + r*(680*s - 489) + 384*s**2 - 434*s + 148) - 604*r**2 + r*(786 - 1120*s) - 604*s**2 + 731*s - 247) + k2**6*(66*C - 33)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 858*g2*(k1**6 + 14*k1**4*k2**2 + 24*k1**2*k2**4 + 6*k2**6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))))/(9009*d**2*k3**6) - 20*D1**3*Pk2*Pkdd3*ct**3*f**2*k1*k2**3*st**4*(7*D1*bd1*f*(r + s - 1) + (7*b1 + 3)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))*(3*r + 3*s - 2)/(231*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**3*f*k1*k2**3*st**4*(-9360*C*D1*f*fd*k1**2*r**2 - 18720*C*D1*f*fd*k1**2*r*s + 12480*C*D1*f*fd*k1**2*r - 9360*C*D1*f*fd*k1**2*s**2 + 12480*C*D1*f*fd*k1**2*s - 4160*C*D1*f*fd*k1**2 - 14040*C*D1*f*fd*k2**2*r**2 - 28080*C*D1*f*fd*k2**2*r*s + 18720*C*D1*f*fd*k2**2*r - 14040*C*D1*f*fd*k2**2*s**2 + 18720*C*D1*f*fd*k2**2*s - 6240*C*D1*f*fd*k2**2 - 12480*C*Dd*f**2*k1**2*r**2 - 24960*C*Dd*f**2*k1**2*r*s + 17680*C*Dd*f**2*k1**2*r - 12480*C*Dd*f**2*k1**2*s**2 + 17680*C*Dd*f**2*k1**2*s - 6240*C*Dd*f**2*k1**2 - 18720*C*Dd*f**2*k2**2*r**2 - 37440*C*Dd*f**2*k2**2*r*s + 26520*C*Dd*f**2*k2**2*r - 18720*C*Dd*f**2*k2**2*s**2 + 26520*C*Dd*f**2*k2**2*s - 9360*C*Dd*f**2*k2**2 - 26*D1*bd1*f*(-35*f*k2**2*(3*r + 3*s - 2) + k1**2*(33*K - 33)*(3*r + 3*s - 1))*(r + s - 1) - 39100*D1*f**2*fd*k1**2*r**2 - 78200*D1*f**2*fd*k1**2*r*s + 57545*D1*f**2*fd*k1**2*r - 39100*D1*f**2*fd*k1**2*s**2 + 57545*D1*f**2*fd*k1**2*s - 21165*D1*f**2*fd*k1**2 + 9360*D1*f*fd*k1**2*r**2 + 18720*D1*f*fd*k1**2*r*s - 12480*D1*f*fd*k1**2*r + 9360*D1*f*fd*k1**2*s**2 - 12480*D1*f*fd*k1**2*s + 4160*D1*f*fd*k1**2 + 10530*D1*f*fd*k2**2*r**2 + 21060*D1*f*fd*k2**2*r*s - 14040*D1*f*fd*k2**2*r + 10530*D1*f*fd*k2**2*s**2 - 14040*D1*f*fd*k2**2*s + 4680*D1*f*fd*k2**2 + 5148*D1*f*gd2*k1**2*r**2 + 10296*D1*f*gd2*k1**2*r*s - 6864*D1*f*gd2*k1**2*r + 5148*D1*f*gd2*k1**2*s**2 - 6864*D1*f*gd2*k1**2*s + 1716*D1*f*gd2*k1**2 + 10296*D1*fd*g2*k1**2*r**2 + 20592*D1*fd*g2*k1**2*r*s - 8580*D1*fd*g2*k1**2*r + 10296*D1*fd*g2*k1**2*s**2 - 8580*D1*fd*g2*k1**2*s + 1716*D1*fd*g2*k1**2 - 39100*Dd*f**3*k1**2*r**2 - 78200*Dd*f**3*k1**2*r*s + 57545*Dd*f**3*k1**2*r - 39100*Dd*f**3*k1**2*s**2 + 57545*Dd*f**3*k1**2*s - 21165*Dd*f**3*k1**2 + 12480*Dd*f**2*k1**2*r**2 + 24960*Dd*f**2*k1**2*r*s - 17680*Dd*f**2*k1**2*r + 12480*Dd*f**2*k1**2*s**2 - 17680*Dd*f**2*k1**2*s + 6240*Dd*f**2*k1**2 + 14040*Dd*f**2*k2**2*r**2 + 28080*Dd*f**2*k2**2*r*s - 19890*Dd*f**2*k2**2*r + 14040*Dd*f**2*k2**2*s**2 - 19890*Dd*f**2*k2**2*s + 7020*Dd*f**2*k2**2 + 20592*Dd*f*g2*k1**2*r**2 + 41184*Dd*f*g2*k1**2*r*s - 22308*Dd*f*g2*k1**2*r + 20592*Dd*f*g2*k1**2*s**2 - 22308*Dd*f*g2*k1**2*s + 5148*Dd*f*g2*k1**2 + 26*b1*(D1*fd*(35*f*k2**2*(3*r + 3*s - 2)**2 - k1**2*(33*K - 33)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1)) + Dd*f*(35*f*k2**2*(3*r + 3*s - 2) - k1**2*(33*K - 33)*(3*r + 3*s - 1))*(4*r + 4*s - 3)))/(3003*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(r + s - 1)*(9*D1*bd1*f**2*(r + s) + b1**2*(2*D1*fd*(17*f + 3)*(r + s - 1) + Dd*f*(17*f + 6)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(17*f + 6)*(2*r + 2*s - 1) + 18*D1*fd*(r + s - 1) + 9*Dd*f*(4*r + 4*s - 3)))/(21*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(33*b1**2*(D1*fd*(k1**2*(13*K - 13)*(r + s - 1)**2 + k2**2*(12*K*(r + s - 1)**2 + f*(37*r + 37*s - 27) + 12*r + 12*s - 6)) + Dd*f*(k1**2*(13*K - 13)*(r + s - 1) + 2*k2**2*(6*K*(r + s - 1) + 5*f + 3))*(4*r + 4*s - 3)) + 3*b1*(11*D1*bd1*f*(k1**2*(13*K - 13)*(2*r + 2*s - 1) + 3*k2**2*(K*(8*r + 8*s - 4) + f + 2))*(r + s - 1) + D1*(f**2*fd*(k1**2*(2724*r**2 + r*(5448*s - 4505) + 2724*s**2 - 4505*s + 1907) - 55*k2**2*(15*r**2 + r*(30*s - 19) + 15*s**2 - 19*s + 6)) + 11*f*(fd*k1**2*(28*C*(r + s - 1)**2 + 62*r**2 + r*(124*s - 43) + 62*s**2 - 43*s - 1) + fd*k2**2*(12*C*(6*r**2 + r*(16*s - 13) + 6*s**2 - 15*s + 7) - 2*K*(62*r**2 + 124*r*s - 65*r + 62*s**2 - 65*s + 17) - 60*r**2 - 144*r*s + 123*r - 60*s**2 + 135*s - 63) - 2*gd2*(13*k1**2 + 12*k2**2)*(r + s - 1)**2) - 22*fd*g2*(13*k1**2 + 12*k2**2)*(r + s - 1)**2) + Dd*f*(f**2*(k1**2*(908*r + 908*s - 782) - 55*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 11*f*(k1**2*(4*r + 4*s - 3)*(14*C*(r + s - 1) + 31*r + 31*s - 13) + 2*k2**2*(6*C*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) - K*(124*r**2 + 248*r*s - 161*r + 124*s**2 - 161*s + 51) - 60*r**2 - 144*r*s + 108*r - 60*s**2 + 123*s - 48)) - 22*g2*(13*k1**2 + 12*k2**2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + f*(3*D1*bd1*(f**2*(k1**2*(908*r + 908*s - 439) - 55*k2**2*(5*r + 5*s - 3))*(r + s - 1) + 11*f*(k1**2*(r + s - 1)*(r*(14*C + 31) + s*(14*C + 31) - 27) - k2**2*(-36*C*s**2 + 48*C*s + 2*K*(31*r**2 + r*(62*s - 48) + 31*s**2 - 48*s + 17) - r**2*(36*C - 30) + r*(-96*C*s + 36*C + 72*s - 33) + 30*s**2 - 39*s + 3)) - 22*g2*(13*k1**2 + 12*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*(f*(fd*(153*k1**2*(3*r + 3*s - 2)**2 + k2**2*(-2*C*(2223*r**2 + r*(6030*s - 3063) + 2223*s**2 - 3855*s + 1142) + 1629*r**2 + 6*r*(807*s - 395) + 1629*s**2 - 3162*s + 944)) + k2**2*(-33*bd2 + 66*gd2)*(31*r**2 + r*(62*s - 48) + 31*s**2 - 48*s + 17)) - 33*fd*k2**2*(b2 - 2*g2)*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17)) + 2*Dd*f*(f*(153*k1**2*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + k2**2*(-2*C*(2964*r**2 + 8040*r*s - 4243*r + 2964*s**2 - 5563*s + 1581) + 2172*r**2 + 6456*r*s - 3253*r + 2172*s**2 - 4573*s + 1284)) + k2**2*(-33*b2 + 66*g2)*(124*r**2 + r*(248*s - 161) + 124*s**2 - 161*s + 51))))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**3*k1*k2*st**2*(13*D1*bd1*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(r + s - 1) - 33*f*(k1**4*(K - 1)*(13*r**2 + r*(26*s - 22) + 13*s**2 - 22*s + 9) + k1**2*k2**2*(r + s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(3*r**2 + 8*r*s - 5*r + 3*s**2 - 5*s + 2) + 38*K*r**2 + 76*K*r*s - 60*K*r + 38*K*s**2 - 60*K*s + 22*K - 2*b1*(17*r**2 + r*(34*s - 24) + 17*s**2 - 24*s + 7) - 15*r**2 - 42*r*s + 24*r - 15*s**2 + 24*s - 9)) + 132*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-13*b1*k1**2*(K - 1) + 3*b1*k2**2*(1 - 2*K) + g2*(13*k1**2 + 6*k2**2))) + 429*b1**2*k2**2*(D1*fd*(f*k2**2*(34*r**2 + r*(68*s - 31) + 34*s**2 - 31*s + 7) + (r + s)**2*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3))) + Dd*f*(f*k2**2*(17*r + 17*s - 7) + (r + s)*(-2*k1**2*(13*K - 13) - 2*k2**2*(6*K - 3)))*(4*r + 4*s - 3)) + 13*b1*(D1*(f**2*fd*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 33*f*(fd*(k1**4*(K - 1)*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + k1**2*k2**2*(2*r + 2*s - 1)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) + 2*K*(38*r**2 + 76*r*s - 41*r + 38*s**2 - 41*s + 11) - 30*r**2 - 84*r*s + 21*r - 30*s**2 + 39*s - 3)) - 4*gd2*k2**2*(13*k1**2 + 6*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**2*(13*k1**2 + 6*k2**2)*(r + s)**2) + Dd*f*(f**2*k2**2*(2*k1**2*(621*r + 621*s - 557) - 165*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) - 33*f*(k1**4*(K - 1)*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + k1**2*k2**2*(4*r + 4*s - 3)*(4*C*(8*r + 8*s - 3) + 15*K*(5*r + 5*s - 3) - 62*r - 62*s + 30) + k2**4*(12*C*(12*r**2 + 2*r*(16*s - 7) + 12*s**2 - 19*s + 4) + 2*K*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33) - 60*r**2 - 21*r*(8*s - 3) - 60*s**2 + 93*s - 15)) + 132*g2*k2**2*(13*k1**2 + 6*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-25*f**2*fd*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(fd*(k1**4*(9*C - 9)*(69*r**2 + r*(138*s - 103) + 69*s**2 - 103*s + 38) + 3*k1**2*k2**2*(C*(1341*r**2 + 4530*r*s - 2129*r + 1341*s**2 - 3053*s + 926) - 882*r**2 - 2688*r*s + 1363*r - 882*s**2 + 1825*s - 568) + k2**4*(2*C*(1035*r**2 + 3654*r*s - 1677*r + 1035*s**2 - 2469*s + 746) - 441*r**2 - 2466*r*s + 984*r - 441*s**2 + 1776*s - 548)) - 33*gd2*(k1**4*(13*r**2 + 26*r*s - 22*r + 13*s**2 - 22*s + 9) + 15*k1**2*k2**2*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3) + 2*k2**4*(19*r**2 + 38*r*s - 30*r + 19*s**2 - 30*s + 11))) + 858*fd*g2*(k1**4*(26*r**2 + r*(52*s - 31) + 26*s**2 - 31*s + 9) + 15*k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) + 2*k2**4*(38*r**2 + r*(76*s - 41) + 38*s**2 - 41*s + 11))) + Dd*f*(-25*f**2*k1**2*(k1**2*(839*r + 839*s - 717) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3) - 26*f*(k1**4*(9*C - 9)*(92*r**2 + r*(184*s - 145) + 92*s**2 - 145*s + 57) + 3*k1**2*k2**2*(C*(1788*r**2 + 6040*r*s - 2885*r + 1788*s**2 - 4425*s + 1235) - 1176*r**2 - 3584*r*s + 1864*r - 1176*s**2 + 2634*s - 775) + k2**4*(2*C*(1380*r**2 + 4872*r*s - 2263*r + 1380*s**2 - 3583*s + 987) - 588*r**2 - 3288*r*s + 1273*r - 588*s**2 + 2593*s - 690)) + 858*g2*(k1**4*(52*r**2 + r*(104*s - 75) + 52*s**2 - 75*s + 27) + 15*k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + 2*k2**4*(76*r**2 + r*(152*s - 101) + 76*s**2 - 101*s + 33)))))/(9009*d**2*k3**6) + 2*D1**3*Pk2*Pkdd3*ct**3*k1*(2*D1*bd1*f*(2*f*(k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*k2**2*(r**2*(C + 1) + r*(C*(14*s - 1) - 4*s - 1) + s*(C*(s - 7) + s + 2))) + k2**2*(5*b2 - 10*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 5*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*(-5*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(4*f + 1) + k2**2*(5*K + 18*f + 8))*(r + s - 1)) + 2*Dd*f*(k1**2*(2*f + 1) + k2**2*(5*K + 9*f + 8))*(4*r + 4*s - 3))*(r + s - 1) + 2*b1*(D1*bd1*f*(k1**2*(2*f + 1) + k2**2*(5*K + 9*f + 8))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(4*f*fd*(k1**2*(r + s - 1)**2 + k2**2*(2*C*(r**2 + r*(14*s - 5) + s**2 - 11*s + 4) + 2*r**2 - r*(8*s + 1) + 2*s**2 + 5*s - 1)) + 5*f*k2**2*(bd2 - 2*gd2)*(r + s - 1)**2 + 5*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + Dd*f*(2*f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k2**2*(C*(4*r**2 + r*(56*s - 13) + 4*s**2 - 43*s + 9) + 4*r**2 - 4*r*(4*s + 1) + s*(4*s + 11))) + k2**2*(5*b2 - 10*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(21*d**2*k2*k3**2) + 2*D1**3*Pk2*Pkdd3*ct**3*k1*(D1*bd1*f*(5*f**2*k1**2*(20*k1**2*(3*r + 3*s - 1) + 297*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 66*f*(k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(-2*K*(r**2 + 2*r*s + s**2 - 1) - 3*b1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 4*r**2*(5*C + 3) - 4*r*(C*(14*s + 5) - 18*s + 9) + 4*s**2*(5*C + 3) + 4*s*(7*C - 15) + 24) + k2**4*(4*C*(7*r**2 + r*(14*s - 11) + 7*s**2 - 5*s + 4) - 6*K*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3) + 3*b1*(r + s - 1) - 14*r**2 - 28*r*s + 22*r - 14*s**2 + 10*s - 8)) + 33*k2**2*(5*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*b1*(k1**2*(r + s - 1)*(C*(8*r + 8*s - 4) + 9*K*(2*r + 2*s - 1) - 26*r - 26*s + 12) + k2**2*(4*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) + K*(38*r**2 + 76*r*s - 47*r + 38*s**2 - 47*s + 9) - 6*r**2 + 44*r*s + 2*r - 6*s**2 - 12*s + 4)) + (r**2 + r*(2*s - 1) + s*(s - 1))*(20*b2*k2**2 - 36*g2*k1**2 - 76*g2*k2**2))) + 165*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 66*b1**2*k2**2*(D1*fd*(k1**2*(4*C*(r + s - 1)**2 + 9*K*r**2 + 18*K*r*s - 18*K*r + 9*K*s**2 - 18*K*s + 9*K - 3*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 13*r**2 - 26*r*s + 24*r - 13*s**2 + 24*s - 12) + k2**2*(4*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 19*K*r**2 + 38*K*r*s - 18*K*r + 19*K*s**2 - 18*K*s + 9*K + 3*f*(7*r + 7*s - 5) - 3*r**2 + 22*r*s + 20*r - 3*s**2 - 8*s - 10)) + Dd*f*(k1**2*(4*r + 4*s - 3)*(4*C*(r + s - 1) + 9*K*r + 9*K*s - 9*K - 6*f*(r + s - 1) - 13*r - 13*s + 12) + k2**2*(4*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 76*K*r**2 + 152*K*r*s - 93*K*r + 76*K*s**2 - 93*K*s + 27*K + 6*f*(4*r + 4*s - 3) - 12*r**2 + 88*r*s + 35*r - 12*s**2 - 35*s - 16))) + b1*(D1*(5*f**2*fd*k1**2*(10*k1**2*(18*r**2 + 6*r*(6*s - 5) + 18*s**2 - 30*s + 13) + 33*k2**2*(54*r**2 + r*(108*s - 91) + 54*s**2 - 91*s + 39)) + 66*f*(fd*(k1**4*(2*r + 2*s - 1)**2 + 2*k1**2*k2**2*(4*C*(5*r**2 - 2*r*(7*s + 2) + 5*s**2 + 8*s - 1) - K*(2*r**2 + 4*r*s + r + 2*s**2 + s - 1) + 12*r**2 + 72*r*s - 15*r + 12*s**2 - 39*s + 6) + 2*k2**4*(4*C*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 9*s + 1) - 3*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 14*r**2 - 28*r*s + 21*r - 14*s**2 + 27*s - 8)) - 2*k2**2*(r + s - 1)*(-5*bd2*k2**2*(r + s) + 9*gd2*k1**2*(r + s - 1) + gd2*k2**2*(19*r + 19*s - 9))) - 132*fd*k2**2*(-5*b2*k2**2*(r + s)**2 + 9*g2*k1**2*(r + s - 1)**2 + g2*k2**2*(19*r**2 + 2*r*(19*s - 9) + 19*s**2 - 18*s + 9))) + 2*Dd*f*(5*f**2*k1**2*(5*k1**2*(6*r + 6*s - 5) + 33*k2**2*(9*r + 9*s - 8))*(4*r + 4*s - 3) + 33*f*(k1**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 2*k1**2*k2**2*(2*C*(20*r**2 - r*(56*s + 23) + 20*s**2 + 37*s + 3) - K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + 24*r**2 + 144*r*s - 42*r + 24*s**2 - 102*s + 21) + 2*k2**4*(4*r + 4*s - 3)*(2*C*(7*r + 7*s - 3) - 3*K*(5*r + 5*s - 3) - 7*r - 7*s + 6)) - 66*k2**2*(4*r + 4*s - 3)*(-5*b2*k2**2*(r + s) + 9*g2*k1**2*(r + s - 1) + g2*k2**2*(19*r + 19*s - 9)))) + 2*f*(D1*(f*(5*fd*(3*r + 3*s - 2)*(5*k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(27*r + 27*s - 7) + 159*r + 159*s - 106) - k2**4*(66*C - 33)*(5*r + 5*s - 3)) + k2**2*(-66*bd2 + 132*gd2)*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(r + s - 1)) - 66*fd*k2**2*(b2 - 2*g2)*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(5*f*(5*k1**4*(3*r + 3*s - 2) + k1**2*k2**2*(-2*C*(27*r + 27*s - 7) + 159*r + 159*s - 106) - k2**4*(66*C - 33)*(5*r + 5*s - 3)) + k2**2*(-66*b2 + 132*g2)*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)))/(693*d**2*k2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**3*k1*(D1*(858*b1*fd*k2**2*(r + s)**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4)) + 5*f**3*k1**2*(-13*bd1*k2**2*(k1**2*(15*r + 15*s + 1) + 264*k2**2*(r + s - 1))*(r + s - 1) + 14*fd*k1**2*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) + 13*f**2*k2**2*(66*bd1*(k1**4*(r + s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(2*r**2 - r + 2*s**2 - s - 1) + 25*K*r**2 + 50*K*r*s - 42*K*r + 25*K*s**2 - 42*K*s + 17*K + b1*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s - 1) - 33*r**2 - 42*r*s + 39*r - 33*s**2 + 39*s - 6) - 2*k2**4*(-8*C*(r**2 - r*s + s**2 - 1) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 2*r*s - 3*r + 7*s**2 - 3*s - 4)) - 5*fd*(3*r + 3*s - 2)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 264*gd2*(k1**4*(5*r**2 + r*(10*s - 9) + 5*s**2 - 9*s + 4) + k1**2*k2**2*(25*r**2 + r*(50*s - 42) + 25*s**2 - 42*s + 17) + 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) - 858*f*k2**2*(-b1**2*fd*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - b1*(fd*(k1**4*(2*r + 2*s - 1)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(4*r**2 - 4*r + 4*s**2 + 2*s + 1) + K*(50*r**2 + 100*r*s - 59*r + 50*s**2 - 59*s + 17) - 66*r**2 - 84*r*s + 69*r - 66*s**2 + 33*s - 18) + 2*k2**4*(4*C*(4*r**2 - 4*r*(s + 1) + 4*s**2 + 5*s + 1) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 14*r**2 - 4*r*s + 11*r - 14*s**2 - 7*s - 2)) + (2*bd1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*gd2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(2*bd1*(k1**4 + 3*k1**2*k2**2 + k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(10*r**2 + r*(20*s - 13) + 10*s**2 - 13*s + 4) + k1**2*k2**2*(50*r**2 + r*(100*s - 59) + 50*s**2 - 59*s + 17) + 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(858*b1*k2**2*(b1*(k1**4*(4*K - 4) + k1**2*k2**2*(12*K - 13) + k2**4*(4*K - 7)) - 8*g2*(k1**4 + 3*k1**2*k2**2 + k2**4))*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 70*f**3*k1**4*(7*k1**2*(4*r + 4*s - 3) + 26*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 65*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(-4*C*(63*r + 63*s - 53) + b1*(15*r + 15*s + 1) + 222*r + 222*s - 192) + 2*k1**2*k2**2*(C*(-582*r - 582*s + 410) + 132*b1*(r + s - 1) + 423*r + 423*s - 304) + k2**4*(66 - 132*C)*(5*r + 5*s - 3)) - 858*f*k2**2*(-b1**2*k2**2*(k1**2*(7*r + 7*s + 1) - 3*k2**2*(3*r + 3*s - 1))*(4*r + 4*s - 3) - b1*(k1**4*(4*r + 4*s - 3)*(8*C*(2*r + 2*s - 1) + 2*K*(5*r + 5*s - 4) - 24*r - 24*s + 15) + 2*k1**2*k2**2*(12*C*(8*r**2 - 8*r + 8*s**2 + 2*s + 1) + K*(100*r**2 + 200*r*s - 143*r + 100*s**2 - 143*s + 51) - 132*r**2 - 168*r*s + 159*r - 132*s**2 + 99*s - 42) + 2*k2**4*(-4*C*r*(8*s + 7) + 32*C*s*(s + 1) + 3*K*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) + r**2*(32*C - 28) - 8*r*s + 23*r - 7*s*(4*s + 1))) + 4*g2*(k1**4*(20*r**2 + r*(40*s - 31) + 20*s**2 - 31*s + 12) + k1**2*k2**2*(100*r**2 + r*(200*s - 143) + 100*s**2 - 143*s + 51) + 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(9009*d**2*k2*k3**6) - 10*D1**3*Pk2*Pkdd3*ct**2*f*k1**2*k2**4*st**6*(-234*C*D1*f*fd*r**2 - 468*C*D1*f*fd*r*s + 312*C*D1*f*fd*r - 234*C*D1*f*fd*s**2 + 312*C*D1*f*fd*s - 104*C*D1*f*fd - 312*C*Dd*f**2*r**2 - 624*C*Dd*f**2*r*s + 442*C*Dd*f**2*r - 312*C*Dd*f**2*s**2 + 442*C*Dd*f**2*s - 156*C*Dd*f**2 - 429*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1708*D1*f**2*fd*r**2 + 3416*D1*f**2*fd*r*s - 2653*D1*f**2*fd*r + 1708*D1*f**2*fd*s**2 - 2653*D1*f**2*fd*s + 1029*D1*f**2*fd + 234*D1*f*fd*r**2 + 468*D1*f*fd*r*s - 312*D1*f*fd*r + 234*D1*f*fd*s**2 - 312*D1*f*fd*s + 104*D1*f*fd + 1716*D1*f*gd2*r**2 + 3432*D1*f*gd2*r*s - 2574*D1*f*gd2*r + 1716*D1*f*gd2*s**2 - 2574*D1*f*gd2*s + 858*D1*f*gd2 + 3432*D1*fd*g2*r**2 + 6864*D1*fd*g2*r*s - 3432*D1*fd*g2*r + 3432*D1*fd*g2*s**2 - 3432*D1*fd*g2*s + 858*D1*fd*g2 + 1708*Dd*f**3*r**2 + 3416*Dd*f**3*r*s - 2653*Dd*f**3*r + 1708*Dd*f**3*s**2 - 2653*Dd*f**3*s + 1029*Dd*f**3 + 312*Dd*f**2*r**2 + 624*Dd*f**2*r*s - 442*Dd*f**2*r + 312*Dd*f**2*s**2 - 442*Dd*f**2*s + 156*Dd*f**2 + 6864*Dd*f*g2*r**2 + 13728*Dd*f*g2*r*s - 8580*Dd*f*g2*r + 6864*Dd*f*g2*s**2 - 8580*Dd*f*g2*s + 2574*Dd*f*g2 - 429*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1))/(9009*d**2*k3**6) + 4*D1**3*Pk2*Pkdd3*ct**2*k2**2*st**4*(33*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 3*b1*k1**2*(11*D1*bd1*f*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*(5*f**2*fd*(45*r**2 + r*(90*s - 66) + 45*s**2 - 66*s + 25) + 11*f*(fd*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1) + 2*gd2*(r + s - 1)**2) + 22*fd*g2*(r + s - 1)**2) - Dd*f*(4*r + 4*s - 3)*(f**2*(75*r + 75*s - 55) + 11*f*(3*r + 3*s - 1) + 22*g2*(r + s - 1))) - f*(3*D1*bd1*k1**2*(r + s - 1)*(5*f**2*(15*r + 15*s - 8) + 11*f*(3*r + 3*s - 1) + 22*g2*(r + s)) + 5*f*(4*k1**2 + k2**2*(3 - 6*C))*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2)))/(231*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**2*k2**2*st**4*(D1*(858*b1*fd*k1**2*k2**2*(r + s)**2*(b1*(K - 1) - 2*g2) - 15*f**3*k1**2*(-104*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 26*f**2*(fd*(3*r + 3*s - 2)**2*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 33*k1**2*(bd1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*gd2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))*(r + s - 1)) - 858*f*k1**2*(b1*fd*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2))*(2*r + 2*s - 1) + 2*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-K*bd1 + bd1 + gd2) + 2*bd1*g2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*fd*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3))*(2*r + 2*s - 1))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k1**2*k2**2*(r + s)*(b1*(K - 1) - 2*g2) + 15*f**3*k1**2*(k1**2*(475*r + 475*s - 353) - 26*k2**2*(3*r + 3*s - 2)) + 26*f**2*(3*r + 3*s - 2)*(k1**4*(12*C - 12) - k1**2*k2**2*(-80*C + 60*b1 + 60) + k2**4*(30*C - 15)) + 858*f*k1**2*(b1*(k1**2*(K - 1)*(r + s) + k2**2*(K*(8*r + 8*s - 3) - 5*r - 5*s + 2)) - 2*g2*(k1**2*(r + s) + k2**2*(8*r + 8*s - 3)))))/(3003*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(D1*bd1*f*(f*(7*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - k2**2*(6*C - 3)*(3*r**2 + r*(8*s - 3) + s*(3*s - 4))) + k2**2*(-6*b2 + 12*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + b1**2*(D1*fd*(-6*K*k2**2 + k1**2*(30*f + 13))*(r + s - 1) + Dd*f*(-6*K*k2**2 + k1**2*(15*f + 13))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(-6*K*k2**2 + k1**2*(15*f + 13))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(14*fd*k1**2*(r + s - 1)**2 - fd*k2**2*(6*C - 3)*(6*r**2 + r*(16*s - 13) + 6*s**2 - 15*s + 7) - k2**2*(6*bd2 - 12*gd2)*(r + s - 1)**2) - 6*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + Dd*f*(f*(7*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - k2**2*(6*C - 3)*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10)) + k2**2*(-6*b2 + 12*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(21*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**2*(2*D1*bd1*f*(b2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*f*(k1**2*(r**2*(2*C - 4) - 2*r*(4*C*s + C + s - 2) + s*(2*C*(s + 2) - 4*s + 1)) + k2**2*(6*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*g2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*b1**3*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(3*D1*bd1*f*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*D1*fd*(-k1**2*(-K + 18*f + 9)*(r + s - 1)**2 + k2**2*(2*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 7*K*(r + s - 1)**2 - r**2 + 12*r*s + 2*r - s**2 - 12*s - 1)) + 2*Dd*f*(-k1**2*(-K + 9*f + 9)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k2**2*(C*(8*r**2 - 96*r*s + 8*s**2 + 70*s - 8) + 7*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 4*r**2 + 48*r*s - 4*s**2 - 35*s + 4))) - 2*b1*(-8*C*D1*f*fd*k1**2*r**2 + 32*C*D1*f*fd*k1**2*r*s + 4*C*D1*f*fd*k1**2*r - 8*C*D1*f*fd*k1**2*s**2 - 20*C*D1*f*fd*k1**2*s + 4*C*D1*f*fd*k1**2 - 24*C*D1*f*fd*k2**2*r**2 - 48*C*D1*f*fd*k2**2*r*s + 48*C*D1*f*fd*k2**2*r - 24*C*D1*f*fd*k2**2*s**2 + 48*C*D1*f*fd*k2**2*s - 24*C*D1*f*fd*k2**2 - 16*C*Dd*f**2*k1**2*r**2 + 64*C*Dd*f**2*k1**2*r*s + 16*C*Dd*f**2*k1**2*r - 16*C*Dd*f**2*k1**2*s**2 - 44*C*Dd*f**2*k1**2*s - 48*C*Dd*f**2*k2**2*r**2 - 96*C*Dd*f**2*k2**2*r*s + 84*C*Dd*f**2*k2**2*r - 48*C*Dd*f**2*k2**2*s**2 + 84*C*Dd*f**2*k2**2*s - 36*C*Dd*f**2*k2**2 - D1*b2*fd*k1**2*r**2 - 2*D1*b2*fd*k1**2*r*s + 2*D1*b2*fd*k1**2*r - D1*b2*fd*k1**2*s**2 + 2*D1*b2*fd*k1**2*s - D1*b2*fd*k1**2 - 7*D1*b2*fd*k2**2*r**2 - 14*D1*b2*fd*k2**2*r*s + 14*D1*b2*fd*k2**2*r - 7*D1*b2*fd*k2**2*s**2 + 14*D1*b2*fd*k2**2*s - 7*D1*b2*fd*k2**2 + D1*bd1*f*(k1**2*(-K + 9*f + 9)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - k2**2*(2*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 2*r**2 + 24*r*s - 4*r - 2*s**2 - 11*s + 6)) - D1*bd2*f*(k1**2 + 7*k2**2)*(r + s - 1)**2 + 16*D1*f*fd*k1**2*r**2 + 8*D1*f*fd*k1**2*r*s - 26*D1*f*fd*k1**2*r + 16*D1*f*fd*k1**2*s**2 - 14*D1*f*fd*k1**2*s + 10*D1*f*fd*k1**2 + 12*D1*f*fd*k2**2*r**2 + 24*D1*f*fd*k2**2*r*s - 24*D1*f*fd*k2**2*r + 12*D1*f*fd*k2**2*s**2 - 24*D1*f*fd*k2**2*s + 12*D1*f*fd*k2**2 + 2*D1*f*gd2*k1**2*r**2 + 4*D1*f*gd2*k1**2*r*s - 4*D1*f*gd2*k1**2*r + 2*D1*f*gd2*k1**2*s**2 - 4*D1*f*gd2*k1**2*s + 2*D1*f*gd2*k1**2 + 14*D1*f*gd2*k2**2*r**2 + 28*D1*f*gd2*k2**2*r*s - 28*D1*f*gd2*k2**2*r + 14*D1*f*gd2*k2**2*s**2 - 28*D1*f*gd2*k2**2*s + 14*D1*f*gd2*k2**2 + 2*D1*fd*g2*k1**2*r**2 + 4*D1*fd*g2*k1**2*r*s - 4*D1*fd*g2*k1**2*r + 2*D1*fd*g2*k1**2*s**2 - 4*D1*fd*g2*k1**2*s + 2*D1*fd*g2*k1**2 + 14*D1*fd*g2*k2**2*r**2 + 28*D1*fd*g2*k2**2*r*s - 28*D1*fd*g2*k2**2*r + 14*D1*fd*g2*k2**2*s**2 - 28*D1*fd*g2*k2**2*s + 14*D1*fd*g2*k2**2 - 4*Dd*b2*f*k1**2*r**2 - 8*Dd*b2*f*k1**2*r*s + 7*Dd*b2*f*k1**2*r - 4*Dd*b2*f*k1**2*s**2 + 7*Dd*b2*f*k1**2*s - 3*Dd*b2*f*k1**2 - 28*Dd*b2*f*k2**2*r**2 - 56*Dd*b2*f*k2**2*r*s + 49*Dd*b2*f*k2**2*r - 28*Dd*b2*f*k2**2*s**2 + 49*Dd*b2*f*k2**2*s - 21*Dd*b2*f*k2**2 + 32*Dd*f**2*k1**2*r**2 + 16*Dd*f**2*k1**2*r*s - 50*Dd*f**2*k1**2*r + 32*Dd*f**2*k1**2*s**2 - 20*Dd*f**2*k1**2*s + 18*Dd*f**2*k1**2 + 24*Dd*f**2*k2**2*r**2 + 48*Dd*f**2*k2**2*r*s - 42*Dd*f**2*k2**2*r + 24*Dd*f**2*k2**2*s**2 - 42*Dd*f**2*k2**2*s + 18*Dd*f**2*k2**2 + 8*Dd*f*g2*k1**2*r**2 + 16*Dd*f*g2*k1**2*r*s - 14*Dd*f*g2*k1**2*r + 8*Dd*f*g2*k1**2*s**2 - 14*Dd*f*g2*k1**2*s + 6*Dd*f*g2*k1**2 + 56*Dd*f*g2*k2**2*r**2 + 112*Dd*f*g2*k2**2*r*s - 98*Dd*f*g2*k2**2*r + 56*Dd*f*g2*k2**2*s**2 - 98*Dd*f*g2*k2**2*s + 42*Dd*f*g2*k2**2))/(21*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(11*b1**2*(D1*fd*(-6*K*k2**4*(2*r + 2*s - 1) + k1**4*(K - 1)*(r + s - 1)**2 + k1**2*k2**2*(2*C*(r + s - 1)**2 + 33*K*r**2 + 66*K*r*s - 66*K*r + 33*K*s**2 - 66*K*s + 33*K + 3*f*(12*r**2 + 24*r*s - r + 12*s**2 - s - 5) + 4*r**2 + 8*r*s + 44*r + 4*s**2 + 44*s - 22)) + Dd*f*(4*r + 4*s - 3)*(-6*K*k2**4 + k1**4*(K - 1)*(r + s - 1) + k1**2*k2**2*(2*C*(r + s - 1) + 33*K*(r + s - 1) + 18*f*r + 18*f*s + 4*r + 4*s + 22))) + b1*(11*D1*bd1*f*(r + s - 1)*(-6*K*k2**4 + k1**4*(K - 1)*(2*r + 2*s - 1) + k1**2*k2**2*(C*(4*r + 4*s - 2) + 66*K*r + 66*K*s - 33*K + 3*f*(12*r + 12*s - 5) + 8*r + 8*s + 22)) + D1*(f**2*fd*k1**2*(2*k1**2*(387*r**2 + 18*r*(43*s - 39) + 387*s**2 - 702*s + 316) - 33*k2**2*(51*r**2 + r*(102*s - 77) + 51*s**2 - 77*s + 30)) + 11*f*(fd*(k1**4*(4*C*(r + s - 1)**2 + 22*r**2 + r*(44*s - 23) + 22*s**2 - 23*s + 5) + k1**2*k2**2*(2*C*(26*r**2 + r*(96*s - 63) + 26*s**2 - 85*s + 37) - 9*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 36*r**2 - 116*r*s + 92*r - 36*s**2 + 114*s - 52) + 3*k2**4*(-2*C*(8*r + 7*s - 6) + 2*K*(2*r + 2*s - 1)**2 + 8*r + 7*s - 6)) + (3*bd2*k2**4*(r + s) + gd2*(k1**4*(r + s - 1) + 33*k1**2*k2**2*(r + s - 1) - 6*k2**4))*(-2*r - 2*s + 2)) - 22*fd*(3*b2*k2**4*(r + s)**2 + g2*(k1**4*(r + s - 1)**2 + 33*k1**2*k2**2*(r + s - 1)**2 - 6*k2**4*(2*r + 2*s - 1)))) + Dd*f*(f**2*k1**2*(k1**2*(258*r + 258*s - 256) - 33*k2**2*(17*r + 17*s - 13))*(4*r + 4*s - 3) + 11*f*(k1**4*(4*r + 4*s - 3)*(2*C*(r + s - 1) + 11*r + 11*s - 7) + k1**2*k2**2*(2*C*(52*r**2 + 6*r*(32*s - 17) + 52*s**2 - 157*s + 50) - 9*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 72*r**2 - 232*r*s + 153*r - 72*s**2 + 208*s - 77) + 6*k2**4*(-2*C + K*(2*r + 2*s - 1) + 1)*(4*r + 4*s - 3)) - (3*b2*k2**4*(r + s) + g2*(k1**4*(r + s - 1) + 33*k1**2*k2**2*(r + s - 1) - 6*k2**4))*(88*r + 88*s - 66))) + f*(D1*bd1*(f**2*k1**2*(2*k1**2*(129*r + 129*s - 68) - 33*k2**2*(17*r + 17*s - 9))*(r + s - 1) + 11*f*(k1**4*(r + s - 1)*(r*(2*C + 11) + s*(2*C + 11) - 9) - k1**2*k2**2*(-26*C*s**2 + 48*C*s + 9*K*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + r**2*(18 - 26*C) + r*(-96*C*s + 26*C + 58*s - 21) + 18*s**2 - 32*s + 3) + 3*k2**4*(2*C*(2*r + s - 2) + K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 2) - 2*r - s + 2)) + (-66*b2*k2**4 - 22*g2*(k1**4 + 33*k1**2*k2**2))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 3*D1*(f*(fd*(k1**4*(69*r**2 + r*(138*s - 103) + 69*s**2 - 103*s + 38) + k1**2*k2**2*(-4*C*(153*r**2 + r*(372*s - 215) + 153*s**2 - 248*s + 79) + 141*r**2 + r*(414*s - 221) + 141*s**2 - 287*s + 92) + k2**4*(44*C - 22)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + k2**2*(11*bd2 - 22*gd2)*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 11*fd*k2**2*(b2 - 2*g2)*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + 3*Dd*f*(f*(k1**4*(92*r**2 + r*(184*s - 145) + 92*s**2 - 145*s + 57) + k1**2*k2**2*(-4*C*(204*r**2 + 4*r*(124*s - 75) + 204*s**2 - 355*s + 113) + 188*r**2 + r*(552*s - 303) + 188*s**2 - 413*s + 127) + k2**4*(44*C - 22)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + k2**2*(11*b2 - 22*g2)*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3))))/(231*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**2*(33*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(D1*(bd1*f*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*fd*(k1**4*(2*C*(r + s - 1)**2 + f*(12*r**2 + r*(24*s - 11) + 12*s**2 - 11*s + 3) + 2*r**2 + 4*r*(s + 1) + 2*s**2 + 4*s - 2) + k1**2*k2**2*(4*C*(2*r**2 - r*(31*s + 4) + 2*s**2 + 31*s + 2) + 16*K*r**2 + 32*K*r*s - 30*K*r + 16*K*s**2 - 30*K*s + 15*K + 3*f*(8*r**2 + 16*r*s - r + 8*s**2 - s - 3) + r**2 + 72*r*s + 26*r + s**2 - 44*s - 13) + k2**4*(2*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) - 7*K*(2*r + 2*s - 1) - r**2 + 12*r*s + 2*r - s**2 - 12*s - 1))) + 2*Dd*f*(2*k1**4*(4*r + 4*s - 3)*(C*(r + s - 1) + f*(3*r + 3*s - 1) + r + s + 1) + k1**2*k2**2*(2*C*(16*r**2 + r*(7 - 248*s) + 16*s**2 + 182*s - 23) + K*(64*r**2 + 4*r*(32*s - 27) + 64*s**2 - 108*s + 45) + 48*f*r**2 + 96*f*r*s - 36*f*r + 48*f*s**2 - 36*f*s + 4*r**2 + 288*r*s + 14*r + 4*s**2 - 161*s - 4) + k2**4*(C*(8*r**2 - 96*r*s + 8*s**2 + 70*s - 8) - 7*K*(4*r + 4*s - 3) - 4*r**2 + 48*r*s - 4*s**2 - 35*s + 4))) + 33*b1*(2*D1*bd1*f*(k1**4*(r + s - 1)*(C*(4*r + 4*s - 2) + 3*f*(4*r + 4*s - 1) + 4*r + 4*s + 2) + k1**2*k2**2*(2*C*(8*r**2 + r*(23 - 124*s) + 8*s**2 + 58*s - 31) + 32*K*r**2 + 64*K*r*s - 47*K*r + 32*K*s**2 - 47*K*s + 15*K + 3*f*(8*r**2 + 16*r*s - 11*r + 8*s**2 - 11*s + 3) + 2*r**2 + 144*r*s - 24*r + 2*s**2 - 59*s + 22) + k2**4*(2*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 7*K*(r + s - 1) - 2*r**2 + 24*r*s - 4*r - 2*s**2 - 11*s + 6)) + D1*(15*f**2*fd*k1**4*(6*r**2 + r*(12*s - 11) + 6*s**2 - 11*s + 5) - 2*f*(fd*(k1**4*(12*C*(r*(4*s - 1) - 3*s + 1) + K*(2*r + 2*s - 1)**2 - 28*r**2 - 80*r*s + 40*r - 28*s**2 + 52*s - 16) + 2*k1**2*k2**2*(-2*C*(8*r**2 + 16*r*(s - 1) + 8*s**2 - 19*s + 8) + 3*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 2*r**2 + 4*r*s - 22*r + 2*s**2 - 25*s + 14) + k2**4*(12*C - 6)*(3*r + 3*s - 2)) + k2**2*(-bd2*(k1**2 - 7*k2**2)*(r + s) + 2*gd2*(k1**2*(16*r + 16*s - 15) - 7*k2**2))*(r + s - 1)) + 2*fd*k2**2*(b2*(k1**2 - 7*k2**2)*(r + s)**2 - 2*g2*k1**2*(16*r**2 + r*(32*s - 30) + 16*s**2 - 30*s + 15) + 14*g2*k2**2*(2*r + 2*s - 1))) + 2*Dd*f*(15*f**2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - f*(k1**4*(12*C*(r*(8*s - 1) - 6*s + 1) + K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 56*r**2 - 2*r*(80*s - 44) - 56*s**2 + 118*s - 36) + 2*k1**2*k2**2*(4*r + 4*s - 3)*(-8*C*(r + s - 1) + 3*K*(4*r + 4*s - 3) + r + s - 7) + k2**4*(12*C - 6)*(4*r + 4*s - 3)) - k2**2*(-b2*(k1**2 - 7*k2**2)*(r + s) + 2*g2*(k1**2*(16*r + 16*s - 15) - 7*k2**2))*(4*r + 4*s - 3))) + f*(33*D1*bd1*(15*f**2*k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*f*k1**2*(k1**2*(K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*r**2 + 8*r*(s*(3*C - 5) + 3) - 14*s**2 - 2*s*(6*C - 15) - 10) + 2*k2**2*(3*K*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + r**2*(1 - 8*C) - r*(8*C - 1)*(2*s - 1) + s*(-8*C*s + 2*C + s + 2))) + 2*k2**2*(b2*(k1**2 - 7*k2**2) - 32*g2*k1**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*k1**2*(450*C*D1*f*fd*k1**2*r**2 + 900*C*D1*f*fd*k1**2*r*s - 600*C*D1*f*fd*k1**2*r + 450*C*D1*f*fd*k1**2*s**2 - 600*C*D1*f*fd*k1**2*s + 200*C*D1*f*fd*k1**2 + 3960*C*D1*f*fd*k2**2*r**2 + 7920*C*D1*f*fd*k2**2*r*s - 5610*C*D1*f*fd*k2**2*r + 3960*C*D1*f*fd*k2**2*s**2 - 5610*C*D1*f*fd*k2**2*s + 1980*C*D1*f*fd*k2**2 + 600*C*Dd*f**2*k1**2*r**2 + 1200*C*Dd*f**2*k1**2*r*s - 850*C*Dd*f**2*k1**2*r + 600*C*Dd*f**2*k1**2*s**2 - 850*C*Dd*f**2*k1**2*s + 300*C*Dd*f**2*k1**2 + 5280*C*Dd*f**2*k2**2*r**2 + 10560*C*Dd*f**2*k2**2*r*s - 7920*C*Dd*f**2*k2**2*r + 5280*C*Dd*f**2*k2**2*s**2 - 7920*C*Dd*f**2*k2**2*s + 2970*C*Dd*f**2*k2**2 + 33*D1*bd2*f*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1) - 720*D1*f*fd*k1**2*r**2 - 1440*D1*f*fd*k1**2*r*s + 1125*D1*f*fd*k1**2*r - 720*D1*f*fd*k1**2*s**2 + 1125*D1*f*fd*k1**2*s - 430*D1*f*fd*k1**2 - 1980*D1*f*fd*k2**2*r**2 - 3960*D1*f*fd*k2**2*r*s + 2805*D1*f*fd*k2**2*r - 1980*D1*f*fd*k2**2*s**2 + 2805*D1*f*fd*k2**2*s - 990*D1*f*fd*k2**2 - 132*D1*f*gd2*k1**2*r**2 - 264*D1*f*gd2*k1**2*r*s + 198*D1*f*gd2*k1**2*r - 132*D1*f*gd2*k1**2*s**2 + 198*D1*f*gd2*k1**2*s - 66*D1*f*gd2*k1**2 - 1584*D1*f*gd2*k2**2*r**2 - 3168*D1*f*gd2*k2**2*r*s + 2772*D1*f*gd2*k2**2*r - 1584*D1*f*gd2*k2**2*s**2 + 2772*D1*f*gd2*k2**2*s - 1188*D1*f*gd2*k2**2 - 264*D1*fd*g2*k1**2*r**2 - 528*D1*fd*g2*k1**2*r*s + 264*D1*fd*g2*k1**2*r - 264*D1*fd*g2*k1**2*s**2 + 264*D1*fd*g2*k1**2*s - 66*D1*fd*g2*k1**2 - 3168*D1*fd*g2*k2**2*r**2 - 6336*D1*fd*g2*k2**2*r*s + 3960*D1*fd*g2*k2**2*r - 3168*D1*fd*g2*k2**2*s**2 + 3960*D1*fd*g2*k2**2*s - 1188*D1*fd*g2*k2**2 - 960*Dd*f**2*k1**2*r**2 - 1920*Dd*f**2*k1**2*r*s + 1580*Dd*f**2*k1**2*r - 960*Dd*f**2*k1**2*s**2 + 1580*Dd*f**2*k1**2*s - 645*Dd*f**2*k1**2 - 2640*Dd*f**2*k2**2*r**2 - 5280*Dd*f**2*k2**2*r*s + 3960*Dd*f**2*k2**2*r - 2640*Dd*f**2*k2**2*s**2 + 3960*Dd*f**2*k2**2*s - 1485*Dd*f**2*k2**2 - 528*Dd*f*g2*k1**2*r**2 - 1056*Dd*f*g2*k1**2*r*s + 660*Dd*f*g2*k1**2*r - 528*Dd*f*g2*k1**2*s**2 + 660*Dd*f*g2*k1**2*s - 198*Dd*f*g2*k1**2 - 6336*Dd*f*g2*k2**2*r**2 - 12672*Dd*f*g2*k2**2*r*s + 9504*Dd*f*g2*k2**2*r - 6336*Dd*f*g2*k2**2*s**2 + 9504*Dd*f*g2*k2**2*s - 3564*Dd*f*g2*k2**2 + 33*b2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct**2*st**2*(-429*D1*bd1*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(r + s - 1) + f*(k1**6*(K - 1)*(r + s - 1)**2 + k1**4*k2**2*(r + s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(31*r**2 + 84*r*s - 54*r + 31*s**2 - 54*s + 23) + 15*K*r**2 + 30*K*r*s - 24*K*r + 15*K*s**2 - 24*K*s + 9*K - 12*b1*(7*r**2 + 2*r*(7*s - 5) + 7*s**2 - 10*s + 3) - 31*r**2 - 84*r*s + 51*r - 31*s**2 + 51*s - 20) + 3*k2**6*(2*C*(3*r**2 + r*(8*s - 5) + 3*s**2 - 5*s + 2) - 2*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 3*r**2 - 8*r*s + 5*r - 3*s**2 + 5*s - 2)) + 2*k2**2*(b1*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)) - g2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 429*b1**2*k2**2*(D1*fd*(6*f*k1**2*k2**2*(14*r**2 + r*(28*s - 13) + 14*s**2 - 13*s + 3) - (r + s)**2*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33))) + Dd*f*(6*f*k1**2*k2**2*(7*r + 7*s - 3) - (r + s)*(6*K*k2**4 + k1**4*(13*K - 13) + k1**2*k2**2*(59*K - 33)))*(4*r + 4*s - 3)) - 429*b1*(D1*(3*f**2*fd*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(3*r + 3*s - 2) + f*(fd*(k1**6*(K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(2*r + 2*s - 1)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(2*C*(62*r**2 + r*(168*s - 55) + 62*s**2 - 88*s + 12) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) - 62*r**2 - 168*r*s + 49*r - 62*s**2 + 82*s - 9) + 3*k2**6*(2*C*(6*r**2 + r*(16*s - 5) + 6*s**2 - 8*s + 1) - 2*K*(2*r + 2*s - 1)**2 - 6*r**2 - 16*r*s + 5*r - 6*s**2 + 8*s - 1)) - 2*gd2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*fd*g2*k2**2*(r + s)**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)) + Dd*f*(3*f**2*k1**2*k2**2*(4*k1**2*(r + s) + k2**2*(13*r + 13*s - 9))*(4*r + 4*s - 3) + f*(k1**6*(K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(4*r + 4*s - 3)*(2*C*(8*r + 8*s - 3) + K*(22*r + 22*s - 15) - 25*r - 25*s + 12) + k1**2*k2**4*(C*(248*r**2 + 16*r*(42*s - 19) + 248*s**2 - 414*s + 94) + 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 124*r**2 - 336*r*s + 140*r - 124*s**2 + 195*s - 38) + 3*k2**6*(C*(24*r**2 + 4*r*(16*s - 7) + 24*s**2 - 38*s + 8) - 2*K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 12*r**2 - 32*r*s + 14*r - 12*s**2 + 19*s - 4)) - 2*g2*k2**2*(13*k1**4 + 59*k1**2*k2**2 + 6*k2**4)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*(D1*(-75*f**2*fd*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(fd*(k1**6*(2*C - 2)*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 3*k1**4*k2**2*(2*C*(282*r**2 + r*(960*s - 497) + 282*s**2 - 695*s + 228) - 357*r**2 + r*(619 - 1110*s) - 357*s**2 + 817*s - 276) - 9*k1**2*k2**4*(4*C*(12*r**2 + r*(6 - 42*s) + 12*s**2 + 39*s - 13) - 189*r**2 + r*(197 - 246*s) - 189*s**2 + 131*s - 40) + k2**6*(198 - 396*C)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - 66*gd2*(k1**6*(r + s - 1)**2 + k1**4*k2**2*(22*r**2 + r*(44*s - 37) + 22*s**2 - 37*s + 15) + 3*k1**2*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 6*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*g2*(k1**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(44*r**2 + r*(88*s - 52) + 44*s**2 - 52*s + 15) + 3*k1**2*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 6*k2**6*(2*r + 2*s - 1)**2)) + Dd*f*(-75*f**2*k1**4*(k1**2*(41*r + 41*s - 47) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) - 13*f*(k1**6*(2*C - 2)*(36*r**2 + r*(72*s - 95) + 36*s**2 - 95*s + 51) + 3*k1**4*k2**2*(2*C*(376*r**2 + 32*r*(40*s - 21) + 376*s**2 - 1002*s + 309) - 476*r**2 + r*(843 - 1480*s) - 476*s**2 + 1173*s - 381) - 9*k1**2*k2**4*(4*C*(16*r**2 - 56*r*s + 3*r + 16*s**2 + 58*s - 14) - 252*r**2 + r*(291 - 328*s) - 252*s**2 + 181*s - 71) + k2**6*(198 - 396*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 858*g2*(k1**6*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**4*k2**2*(88*r**2 + 2*r*(88*s - 63) + 88*s**2 - 126*s + 45) + 3*k1**2*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 6*k2**6*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)))))/(9009*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct**2*(D1*bd1*f*(-5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(r + s - 1) - 66*f*(k1**6*(2*C - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*k2**2*(C*(44*r**2 + 64*r*s - 48*r + 44*s**2 - 48*s + 4) + 14*K*r**2 + 28*K*r*s - 27*K*r + 14*K*s**2 - 27*K*s + 13*K - 2*b1*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) - 42*r**2 - 72*r*s + 54*r - 42*s**2 + 54*s - 12) - 6*k1**2*k2**4*(-10*C*r**2 - 16*C*r*s + 10*C*r - 10*C*s**2 + 10*C*s - K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*r**2 + 12*r*s - 7*r + 7*s**2 - 7*s) + k2**6*(12*C - 6)*(r**2 + r*(2*s - 1) + s*(s - 1))) + (-132*b1*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)) + 132*g2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))*(r**2 + r*(2*s - 1) + s*(s - 1))) + 66*b1**2*(D1*fd*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14))) + Dd*f*(f*k1**2*k2**2*(k1**2*(11*r + 11*s - 7) + 9*k2**2*(3*r + 3*s - 1)) - (r + s)*(7*K*k2**6 + k1**6*(K - 1) + k1**4*k2**2*(15*K - 11) + k1**2*k2**4*(27*K - 14)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(3*r + 3*s - 2) - 66*f*(fd*(k1**6*(2*C - 2)*(2*r + 2*s - 1)**2 + k1**4*k2**2*(4*C*(22*r**2 + r*(32*s - 19) + 22*s**2 - 10*s + 4) + K*(28*r**2 + 8*r*(7*s - 5) + 28*s**2 - 40*s + 13) - 84*r**2 - 6*r*(24*s - 13) - 84*s**2 + 60*s - 18) + 6*k1**2*k2**4*(2*C*(10*r**2 + r*(16*s - 7) + 10*s**2 - 4*s + 1) + K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*r**2 - 24*r*s + 9*r - 14*s**2 + 6*s - 1) + k2**6*(12*C - 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 2*gd2*(r**2 + r*(2*s - 1) + s*(s - 1))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) + 132*fd*g2*(r + s)**2*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6)) - Dd*f*(5*f**2*k1**4*(k1**2*(87*r + 87*s - 47) + 132*k2**2*(r + s))*(4*r + 4*s - 3) + 66*f*(k1**6*(2*C - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + k1**4*k2**2*(4*C*(44*r**2 + r*(64*s - 46) + 44*s**2 - 31*s + 9) + K*(56*r**2 + 112*r*s - 94*r + 56*s**2 - 94*s + 39) - 168*r**2 - 288*r*s + 192*r - 168*s**2 + 162*s - 48) + 6*k1**2*k2**4*(C*(40*r**2 + 4*r*(16*s - 9) + 40*s**2 - 26*s + 4) + K*(4*r + 4*s - 3)**2 - 28*r**2 - 48*r*s + 24*r - 28*s**2 + 19*s - 2) + k2**6*(12*C - 6)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 132*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(k1**6 + 15*k1**4*k2**2 + 27*k1**2*k2**4 + 7*k2**6))) - 2*f*k1**2*(D1*(210*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + f*k2**2*(5*fd*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 66*gd2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1)) - 66*fd*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**4*(r + s - 1) + 5*f*k2**2*(k1**2*(2*C*(81*r + 81*s - 76) - 114*r - 114*s + 109) + k2**2*(66*C - 33)*(4*r + 4*s - 3)) - 66*g2*k2**2*(k1**2*(14*r + 14*s - 13) + 6*k2**2*(4*r + 4*s - 3)))))/(693*d**2*k3**6) + 5*D1**3*Pk2*Pkdd3*ct*f*k1*k2**3*st**6*(D1*bd1*f*(r + s - 1)*(f*(9*r + 9*s + 5) + 132*r + 132*s - 66) + b1*(D1*fd*(f*(27*r**2 + r*(54*s - 3) + 27*s**2 - 3*s - 10) + 66*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f*(9*r + 9*s + 5) + 132*r + 132*s - 66)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))*(3*r + 3*s - 2))/(693*d**2*k3**4) - 5*D1**3*Pk2*Pkdd3*ct*f*k1*k2**3*st**6*(D1*(f**2*(13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 2) + 9*s**2 - 4*s - 5) + fd*k1**2*(4972*r**2 + r*(9944*s - 7653) + 4972*s**2 - 7653*s + 2943)) - 13*f*k2**2*(66*bd1*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2))*(3*r + 3*s - 2) - 264*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 858*fd*k2**2*(2*r + 2*s - 1)**2*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(1243*r + 1243*s - 981) + 13*f*k2**2*(b1*(9*r + 9*s + 5) + (6 - 8*C)*(3*r + 3*s - 2)) + k2**2*(2*r + 2*s - 1)*(-1716*K*b1 + 858*b1 + 3432*g2)))/(9009*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct*k1*k2*st**4*(3*D1*bd1*f*(r + s - 1)*(10*f**2*k1**2*(9*r + 9*s - 4) - 11*f*(-2*k1**2*(r + s) + k2**2*(K*(6*r + 6*s - 2) + b1 - 4*r - 4*s + 2)) - 22*k2**2*(K*b1*(4*r + 4*s - 2) + b1 - 4*g2*(r + s))) + D1*(-66*b1*fd*k2**2*(b1*(2*K*(r + s - 1)**2 + 2*r + 2*s - 1) - 4*g2*(r + s - 1)**2) + 2*f**2*(fd*(3*k1**2*(5*b1*(27*r**2 + 6*r*(9*s - 7) + 27*s**2 - 42*s + 17) + 2*(3*r + 3*s - 2)**2) + k2**2*(20 - 40*C)*(3*r + 3*s - 2)**2) + k2**2*(-33*bd2 + 66*gd2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 33*f*(b1**2*fd*k2**2*(r + s - 1) - 2*b1*fd*(-k1**2*(r + s) + k2**2*(K*(3*r + 3*s - 1) - 2*r - 2*s + 1))*(2*r + 2*s - 1) + 8*b1*gd2*k2**2*(r + s - 1)**2 - 2*fd*k2**2*(b2 - 2*g2)*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1))) + 2*Dd*f*(4*r + 4*s - 3)*(-33*b1*k2**2*(2*K*b1*(r + s - 1) + b1 - 4*g2*(r + s - 1)) + f**2*(3*k1**2*(5*b1*(9*r + 9*s - 7) + 6*r + 6*s - 4) + k2**2*(20 - 40*C)*(3*r + 3*s - 2)) - 33*f*(-b1*k1**2*(r + s) + b1*k2**2*(K*(3*r + 3*s - 1) - 2*r - 2*s + 1) + k2**2*(b2 - 2*g2)*(3*r + 3*s - 1))))/(231*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct*k1*k2*st**4*(D1*(858*b1*fd*k2**4*(r + s)**2*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(650*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - fd*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5))*(4*r + 4*s - 3)) + 26*f**2*k2**2*(fd*(k1**2*(-24*C + 25*b1 + 18) + k2**2*(20 - 40*C))*(3*r + 3*s - 2)**2 + (33*r + 33*s - 33)*(-bd1*k1**2*(2*K - 1)*(r + s) + bd1*k2**2*(K*(-7*r - 7*s + 3) + b1*(r + s - 1) + 2*r + 2*s - 1) + 4*gd2*k1**2*(r + s) + 2*gd2*k2**2*(7*r + 7*s - 3))) + 429*f*k2**2*(b1**2*fd*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(fd*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1))*(2*r + 2*s - 1) + k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(-4*K*bd1 + 2*bd1 + 4*gd2)) + 4*g2*(-2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + f**3*k1**2*(k1**2*(2063*r + 2063*s - 1609) - 195*k2**2*(7*r + 7*s - 5)) + 26*f**2*k2**2*(k1**2*(24*C - 25*b1 - 18) + k2**2*(40*C - 20))*(3*r + 3*s - 2) - 429*f*k2**2*(b1**2*k2**2*(r + s - 1) - 2*b1*(k1**2*(2*K - 1)*(r + s) + k2**2*(K*(7*r + 7*s - 3) - 2*r - 2*s + 1)) + 4*g2*(2*k1**2*(r + s) + k2**2*(7*r + 7*s - 3)))))/(3003*d**2*k3**6) - D1**3*Pk2*Pkdd3*ct*k1*st**2*(-2*D1*bd1*f*(f*(k1**2*(-r**2 - 2*r*s + r - s**2 + s) + 2*k2**2*(r**2*(7*C - 3) + r*(22*C*s - 7*C - 10*s + 3) + s*(7*C*s - 11*C - 3*s + 5))) + k2**2*(13*b2 - 26*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 13*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*(13*bd1*f*k2**2*(3*r + 3*s - 2) + 2*fd*(k1**2*(6*f + 1) + k2**2*(-13*K - 9*f + 8))*(r + s - 1)) + Dd*f*(k1**2*(6*f + 2) + k2**2*(-26*K - 9*f + 16))*(4*r + 4*s - 3))*(r + s - 1) + b1*(D1*bd1*f*(k1**2*(6*f + 2) + k2**2*(-26*K - 9*f + 16))*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*D1*(f*(2*fd*k1**2*(r + s - 1)**2 - 4*fd*k2**2*(C*(7*r**2 + 2*r*(11*s - 8) + 7*s**2 - 20*s + 9) - 3*r**2 + r*(7 - 10*s) - 3*s**2 + 9*s - 4) - k2**2*(13*bd2 - 26*gd2)*(r + s - 1)**2) - 13*fd*k2**2*(b2 - 2*g2)*(r + s - 1)**2) + 2*Dd*f*(f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k2**2*(-C*(28*r**2 + 88*r*s - 53*r + 28*s**2 - 73*s + 25) + 12*r**2 + 40*r*s - 23*r + 12*s**2 - 33*s + 11)) + k2**2*(-13*b2 + 26*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))))/(21*d**2*k2*k3**2) + 2*D1**3*Pk2*Pkdd3*ct*k1*(-2*D1*bd1*f*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(12*C*f + 7*b2 - 6*f - 14*g2) + b1**3*(2*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*bd1*f*(2*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*D1*fd*(k1**2*(r + s - 1)**2 - k2**2*(4*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 7*K*(r + s - 1)**2 - 2*r**2 + 4*r*(6*s + 1) - 2*s**2 - 24*s - 2)) + 2*Dd*f*(k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - k2**2*(4*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 7*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 8*r**2 + 96*r*s - 8*s**2 - 70*s + 8))) + 2*b1*(D1*bd1*f*(k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - k2**2*(4*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) + 7*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 4*r**2 + 48*r*s - 8*r - 4*s**2 - 22*s + 12)) - k2**2*(r + s - 1)*(7*D1*bd2*f*(r + s - 1) - 2*D1*(r + s - 1)*(f*fd*(6 - 12*C) + 7*f*gd2 + 7*fd*g2) + 2*Dd*f*(f*(6*C - 3) - 7*g2)*(4*r + 4*s - 3) + 7*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(21*d**2*k2*k3**2) - D1**3*Pk2*Pkdd3*ct*k1*st**2*(3*D1*bd1*f*(f**2*k1**2*(k1**2*(36*r + 36*s - 34) - 297*k2**2*(2*r + 2*s - 1))*(r + s - 1) + 11*f*(2*k1**4*(r + s - 1)**2 + k1**2*k2**2*(-2*K*(13*r**2 + r*(26*s - 22) + 13*s**2 - 22*s + 9) + b1*(92*r**2 + r*(184*s - 137) + 92*s**2 - 137*s + 45) + 2*r**2*(4*C + 1) + 2*r*(4*C*(8*s - 1) - 10*s - 1) + 2*s*(4*C*(s - 4) + s + 5)) + k2**4*(-4*C*(11*r**2 + 22*r*s - 21*r + 11*s**2 - 17*s + 10) + 30*K*r**2 + 60*K*r*s - 48*K*r + 30*K*s**2 - 48*K*s + 18*K - 3*b1*(r + s - 1) + 22*r**2 + 44*r*s - 42*r + 22*s**2 - 34*s + 20)) - 11*k2**2*(r + s - 1)*(13*b1**2*k2**2*(3*r + 3*s - 2) - 2*b1*(k1**2*(K*(4*r + 4*s - 2) + 24*r + 24*s + 1) + k2**2*(C*(8*r + 8*s - 4) + K*(2*r + 2*s - 27) - 6*r - 6*s + 10)) + (r + s)*(52*b2*k2**2 + 4*g2*(2*k1**2 + k2**2)))) - 429*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(k1**2*(4*K*(r + s - 1)**2 + f*(92*r**2 + r*(184*s - 97) + 92*s**2 - 97*s + 27) + 24*r**2 + 48*r*s + 4*r + 24*s**2 + 4*s - 2) + k2**2*(8*C*(r + s - 1)**2 + 2*K*(r**2 + 2*r*(s - 27) + s**2 - 54*s + 27) - 3*f*(7*r + 7*s - 5) - 6*r**2 - 12*r*s + 40*r - 6*s**2 + 40*s - 20)) + 2*Dd*f*(k1**2*(2*K*(r + s - 1) + f*(23*r + 23*s - 12) + 12*r + 12*s + 1) + k2**2*(4*C*(r + s - 1) + K*r + K*s - 27*K - 3*f - 3*r - 3*s + 10))*(4*r + 4*s - 3)) + 3*b1*(D1*(f**2*fd*k1**2*(2*k1**2*(54*r**2 + 3*r*(36*s - 41) + 54*s**2 - 123*s + 61) - 33*k2**2*(54*r**2 + r*(108*s - 91) + 54*s**2 - 91*s + 39)) + 22*f*(fd*(k1**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(4*C*(2*r**2 + r*(16*s - 7) + 2*s**2 - 13*s + 5) - K*(26*r**2 + 52*r*s - 31*r + 26*s**2 - 31*s + 9) + 2*r**2 - 20*r*s + 14*r + 2*s**2 + 26*s - 12) + k2**4*(-4*C*(11*r**2 + r*(22*s - 2) + 11*s**2 - 4*s - 4) + K*(30*r**2 + 60*r*s - 33*r + 30*s**2 - 33*s + 9) + 22*r**2 + 44*r*s - 7*r + 22*s**2 - 11*s - 6)) - 2*k2**2*(r + s - 1)*(13*bd2*k2**2*(r + s) + 2*gd2*k1**2*(r + s - 1) + gd2*k2**2*(r + s - 27))) - 44*fd*k2**2*(13*b2*k2**2*(r + s)**2 + 2*g2*k1**2*(r + s - 1)**2 + g2*k2**2*(r**2 + 2*r*(s - 27) + s**2 - 54*s + 27))) + 2*Dd*f*(f**2*k1**2*(2*k1**2*(9*r + 9*s - 13) - 33*k2**2*(9*r + 9*s - 8))*(4*r + 4*s - 3) + 11*f*(k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(4*C*(4*r**2 + 2*r*(16*s - 5) + 4*s**2 - 25*s + 6) - K*(52*r**2 + 104*r*s - 75*r + 52*s**2 - 75*s + 27) + 4*r**2 - 40*r*s + 15*r + 4*s**2 + 45*s - 15) + k2**4*(4*r + 4*s - 3)*(C*(-22*r - 22*s + 2) + 3*K*(5*r + 5*s - 3) + 11*r + 11*s - 2)) - 22*k2**2*(4*r + 4*s - 3)*(13*b2*k2**2*(r + s) + 2*g2*k1**2*(r + s - 1) + g2*k2**2*(r + s - 27)))) + 2*f*(D1*(f*(fd*(3*r + 3*s - 2)*(k1**4*(9*r + 9*s - 17) + 3*k1**2*k2**2*(-6*C*(23*r + 23*s - 19) + 25*r + 25*s - 24) + k2**4*(198*C - 99)*(5*r + 5*s - 3)) + k2**2*(33*bd2 - 66*gd2)*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(r + s - 1)) + 33*fd*k2**2*(b2 - 2*g2)*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1)) + Dd*f*(f*(k1**4*(9*r + 9*s - 17) + 3*k1**2*k2**2*(-6*C*(23*r + 23*s - 19) + 25*r + 25*s - 24) + k2**4*(198*C - 99)*(5*r + 5*s - 3)) + k2**2*(33*b2 - 66*g2)*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3)))*(4*r + 4*s - 3)))/(693*d**2*k2*k3**4) + 2*D1**3*Pk2*Pkdd3*ct*k1*(D1*bd1*f*(-b1**2*k2**2*(6*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*b1*(2*k1**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + k1**2*k2**2*(4*C*(2*r**2 + r*(11 - 52*s) + 2*s**2 + 25*s - 13) - 8*K*s**2 + 8*K*s - r**2*(8*K - 8) + r*(-16*K*s + 8*K + 128*s - 33) + 8*s**2 - 61*s + 25) + k2**4*(4*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 7*K*(2*r**2 + 4*r*s - r + 2*s**2 - s - 1) - 4*r**2 + 48*r*s - 8*r - 4*s**2 - 22*s + 12)) + 2*f*(r + s - 1)*(k1**4*(4*b1 + 1)*(2*r + 2*s - 1) + k1**2*k2**2*(-2*C*(8*r + 8*s - 4) - 6*K*(r + s - 1) + 3*b1*(12*r + 12*s - 7) + 14*r + 14*s - 4) + k2**4*(6 - 12*C)*(r + s)) - 4*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(2*b2*k1**2 + 7*b2*k2**2 - 4*g2*k1**2 - 7*g2*k2**2)) - b1**3*k2**2*(6*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 2*b1**2*(D1*fd*(f*(k1**4*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 3*k1**2*k2**2*(12*r**2 + 3*r*(8*s - 5) + 12*s**2 - 15*s + 5)) + k1**4*(r + s)**2 + k1**2*k2**2*(4*C*(r**2 - 2*r*(13*s + 1) + s**2 + 26*s + 1) - 4*K*s**2 - r**2*(4*K - 4) + r*(-s*(8*K - 64) + 6) + 4*s**2 - 50*s - 3) + k2**4*(4*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) - 7*K*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) - 2*r**2 + 4*r*(6*s + 1) - 2*s**2 - 24*s - 2)) + Dd*f*(f*k1**2*(k1**2*(4*r + 4*s - 3) + 6*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3) + k1**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + k1**2*k2**2*(4*C*(4*r**2 + r*(7 - 104*s) + 4*s**2 + 77*s - 11) - 16*K*s**2 + 12*K*s - r**2*(16*K - 16) - 4*r*(8*K*s - 3*K - 64*s + 7) + 16*s**2 - 168*s + 19) + k2**4*(4*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) - 7*K*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) - 8*r**2 + 96*r*s - 8*s**2 - 70*s + 8))) + 2*b1*(D1*(f*(fd*(k1**4*(2*r + 2*s - 1)**2 - 2*k1**2*k2**2*(2*r + 2*s - 1)*(C*(8*r + 8*s - 4) + 3*K*(r + s - 1) - 7*r - 7*s + 2) - k2**4*(24*C - 12)*(r**2 + 2*r*s + r + s**2 + s - 1)) + 2*k2**2*(r + s - 1)*(-bd2*(2*k1**2 + 7*k2**2)*(r + s) + 4*gd2*k1**2*(r + s) + 7*gd2*k2**2*(r + s + 1))) + 2*fd*k2**2*(-b2*(2*k1**2 + 7*k2**2)*(r + s)**2 + 4*g2*k1**2*(r + s)**2 + 7*g2*k2**2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1))) + Dd*f*(f*(k1**4*(2*r + 2*s - 1) - 2*k1**2*k2**2*(C*(8*r + 8*s - 4) + 3*K*(r + s - 1) - 7*r - 7*s + 2) + k2**4*(6 - 12*C)*(r + s + 1)) + 2*k2**2*(-b2*(2*k1**2 + 7*k2**2)*(r + s) + 4*g2*k1**2*(r + s) + 7*g2*k2**2*(r + s + 1)))*(4*r + 4*s - 3)) - 2*f*k1**2*k2**2*(r + s - 1)*(30*C*D1*f*fd*r + 30*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 6*D1*bd2*f*(r + s - 1) - 15*D1*f*fd*r - 15*D1*f*fd*s + 10*D1*f*fd - 12*D1*f*gd2*r - 12*D1*f*gd2*s + 12*D1*f*gd2 - 24*D1*fd*g2*r - 24*D1*fd*g2*s + 12*D1*fd*g2 - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 48*Dd*f*g2*r - 48*Dd*f*g2*s + 36*Dd*f*g2 + 6*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(21*d**2*k2*k3**4) + D1**3*Pk2*Pkdd3*ct*k1*st**2*(D1*(-858*b1*fd*k2**4*(r + s)**2*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) - 3*f**3*k1**2*(13*bd1*k2**2*(k1**2*(299*r + 299*s - 137) + 264*k2**2*(r + s - 1))*(r + s - 1) + 5*fd*k1**2*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3)) - 13*f**2*k2**2*(66*bd1*(k1**4*(2*K - 1)*(r + s - 1)**2 + k1**2*k2**2*(8*C*(4*r**2 + 11*r*s - 7*r + 4*s**2 - 7*s + 3) + 5*K*r**2 + 10*K*r*s - 8*K*r + 5*K*s**2 - 8*K*s + 3*K - 3*b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 20*r**2 - 52*r*s + 32*r - 20*s**2 + 32*s - 12) + k2**4*(4*C*(7*r**2 + 6*r*(3*s - 2) + 7*s**2 - 12*s + 5) - 15*K*r**2 - 30*K*r*s + 24*K*r - 15*K*s**2 + 24*K*s - 9*K + 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 13*r**2 - 34*r*s + 23*r - 13*s**2 + 23*s - 10)) + fd*(3*r + 3*s - 2)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) - 132*gd2*(2*k1**4*(r + s - 1)**2 + k1**2*k2**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) - 3*k2**4*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3))) + 429*f*k2**2*(3*b1**2*fd*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(2*r + 2*s - 1) - 2*b1*fd*(k1**4*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**2*k2**2*(4*C*(16*r**2 + 2*r*(22*s - 7) + 16*s**2 - 23*s + 3) + K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 40*r**2 - 104*r*s + 32*r - 40*s**2 + 50*s - 6) + k2**4*(4*C*(14*r**2 + r*(36*s - 13) + 14*s**2 - 19*s + 3) - 3*K*(10*r**2 + 20*r*s - 11*r + 10*s**2 - 11*s + 3) - 26*r**2 - 68*r*s + 25*r - 26*s**2 + 37*s - 6)) + 4*b1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(bd1*k1**2*(13 - 26*K) + bd1*k2**2*(7 - 40*K) + 26*gd2*k1**2 + 40*gd2*k2**2) + 4*g2*(2*bd1*k2**2*(13*k1**2 + 20*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3) - 3*k2**4*(10*r**2 + r*(20*s - 11) + 10*s**2 - 11*s + 3))))) + Dd*f*(-858*b1*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))*(13*b1*k1**2*(2*K - 1) + b1*k2**2*(40*K - 7) - 4*g2*(13*k1**2 + 20*k2**2)) - 15*f**3*k1**4*(2*k1**2*(r + s - 17) - 65*k2**2*(15*r + 15*s - 13))*(4*r + 4*s - 3) - 13*f**2*k2**2*(4*r + 4*s - 3)*(k1**4*(b1*(897*r + 897*s - 411) + (8*C - 6)*(9*r + 9*s - 17)) + 6*k1**2*k2**2*(-2*C*(19*r + 19*s - 9) + 132*b1*(r + s - 1) + 63*r + 63*s - 42) + k2**4*(198 - 396*C)*(5*r + 5*s - 3)) + 429*f*k2**2*(3*b1**2*k2**2*(k1**2*(25*r + 25*s - 11) + k2**2*(-3*r - 3*s + 1))*(4*r + 4*s - 3) - 2*b1*(k1**4*(2*K - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(4*C*(32*r**2 + r*(88*s - 39) + 32*s**2 - 54*s + 12) + K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 80*r**2 - 208*r*s + 90*r - 80*s**2 + 120*s - 24) + k2**4*(4*C*(28*r**2 + r*(72*s - 35) + 28*s**2 - 45*s + 11) - 3*K*(20*r**2 + 40*r*s - 27*r + 20*s**2 - 27*s + 9) - 52*r**2 - 136*r*s + 67*r - 52*s**2 + 87*s - 22)) + 4*g2*(2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*k2**2*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9) - 3*k2**4*(20*r**2 + r*(40*s - 27) + 20*s**2 - 27*s + 9)))))/(9009*d**2*k2*k3**6) - 2*D1**3*Pk2*Pkdd3*ct*k1*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(-k1**4*(-4*C + 10*b1 + 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*r + 3*K*s - 3*K - 9*b1*(3*r + 3*s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) + 132*k2**2*(r + s)*(b1*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)) - 2*g2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) + 66*b1**2*k2**2*(D1*fd*(f*k1**2*(5*k1**2*(2*r + 2*s - 1) + 9*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1) - (r + s)**2*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7))) + Dd*f*(f*(5*k1**4*(2*r + 2*s - 1) + 9*k1**2*k2**2*(3*r + 3*s - 1)) - (r + s)*(14*K*k2**4 + k1**4*(2*K - 1) + k1**2*k2**2*(18*K - 7)))*(4*r + 4*s - 3)) + b1*(D1*(-5*f**2*fd*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3))*(3*r + 3*s - 2) - 66*f*k2**2*(fd*(2*r + 2*s - 1)*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 4*gd2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 264*fd*g2*k2**2*(r + s)**2*(k1**4 + 9*k1**2*k2**2 + 7*k2**4)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(10*k1**2*(3*r + 3*s - 2) + 33*k2**2*(5*r + 5*s - 3)) + 66*f*k2**2*(k1**4*(4*C - 3)*(2*r + 2*s - 1) + 2*k1**2*k2**2*(4*C*(5*r + 5*s - 1) + 3*K*(r + s - 1) - 13*r - 13*s + 2) + k2**4*(24*C - 12)*(r + s)) - 264*g2*k2**2*(r + s)*(k1**4 + 9*k1**2*k2**2 + 7*k2**4))) - 66*f*k1**2*k2**4*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 12*f*gd2*(r + s - 1) - 12*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1))/(693*d**2*k2*k3**6) + 20*D1**3*Pk2*Pkdd3*f**3*k1**2*k2**4*st**8*(D1*fd + Dd*f)*(4*r + 4*s - 3)**2/(1287*d**2*k3**6) - 5*D1**3*Pk2*Pkdd3*f*k2**2*st**6*(D1*bd1*f*(66*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(3*r + 3*s - 17))*(r + s - 1) + b1*(D1*fd*(66*K*k2**2*(2*r + 2*s - 1)**2 + f*k1**2*(9*r**2 + 3*r*(6*s - 11) + 9*s**2 - 33*s + 16)) + Dd*f*(66*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(3*r + 3*s - 11))*(4*r + 4*s - 3)) + 2*k2**2*(18*C*D1*f*fd*r**2 + 36*C*D1*f*fd*r*s - 24*C*D1*f*fd*r + 18*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 8*C*D1*f*fd + 24*C*Dd*f**2*r**2 + 48*C*Dd*f**2*r*s - 34*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 34*C*Dd*f**2*s + 12*C*Dd*f**2 + 33*D1*bd2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 9*D1*f*fd*r**2 - 18*D1*f*fd*r*s + 12*D1*f*fd*r - 9*D1*f*fd*s**2 + 12*D1*f*fd*s - 4*D1*f*fd - 132*D1*f*gd2*r**2 - 264*D1*f*gd2*r*s + 198*D1*f*gd2*r - 132*D1*f*gd2*s**2 + 198*D1*f*gd2*s - 66*D1*f*gd2 - 264*D1*fd*g2*r**2 - 528*D1*fd*g2*r*s + 264*D1*fd*g2*r - 264*D1*fd*g2*s**2 + 264*D1*fd*g2*s - 66*D1*fd*g2 - 12*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 17*Dd*f**2*r - 12*Dd*f**2*s**2 + 17*Dd*f**2*s - 6*Dd*f**2 - 528*Dd*f*g2*r**2 - 1056*Dd*f*g2*r*s + 660*Dd*f*g2*r - 528*Dd*f*g2*s**2 + 660*Dd*f*g2*s - 198*Dd*f*g2 + 33*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))*(2*r + 2*s - 1)))/(693*d**2*k3**4) - 5*D1**3*Pk2*Pkdd3*f*k2**2*st**6*(D1*(f**2*k1**2*(-13*bd1*k2**2*(9*r**2 + 2*r*(9*s - 13) + 9*s**2 - 26*s + 17) + fd*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2))*(4*r + 4*s - 3)) - 13*f*k2**2*(b1*fd*k1**2*(27*r**2 + r*(54*s - 69) + 27*s**2 - 69*s + 34) + 2*k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2)**2 - (-33*K*bd1 + 66*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 858*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)**2) + Dd*f*(4*r + 4*s - 3)*(f**2*k1**2*(k1**2*(383*r + 383*s - 297) + 26*k2**2*(3*r + 3*s - 2)) - 13*f*k2**2*(b1*k1**2*(9*r + 9*s - 17) + k2**2*(4*C - 2)*(3*r + 3*s - 2)) + k2**4*(-858*K*b1 + 1716*g2)*(2*r + 2*s - 1)))/(9009*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*k1**2*(2*D1*bd1*f*(f*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) + (b2 - 2*g2)*(k1**2 + 7*k2**2)*(r + s))*(r + s - 1) + b1**3*(2*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + b1**2*(D1*bd1*f*(2*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*D1*fd*(-3*f*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + k1**2*(K*(r + s)**2 + s*(28*C - 14)*(r - 1)) + k2**2*(-2*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 7*K*s**2 + r**2*(7*K + 1) + 2*r*(7*K*s - 6*s - 1) + s**2 + 12*s + 1)) + 2*Dd*f*(k1**2*(14*C*(r*(8*s - 1) - 6*s + 1) + 4*K*r**2 + 8*K*r*s - 3*K*r + 4*K*s**2 - 3*K*s - 6*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 56*r*s + 7*r + 42*s - 7) + k2**2*(C*(-8*r**2 + 96*r*s - 8*s**2 - 70*s + 8) + 7*K*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 4*r**2 - 48*r*s + 4*s**2 + 35*s - 4))) - 2*b1*(D1*bd1*f*(k1**2*(-14*C*(r*(4*s - 1) - 2*s + 1) - 2*K*r**2 - 4*K*r*s + 2*K*r - 2*K*s**2 + 2*K*s + 3*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r*s - 7*r - 14*s + 7) + k2**2*(2*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 14*K*s**2 + 14*K*s - r**2*(14*K + 2) + r*(-28*K*s + 14*K + 24*s - 4) - 2*s**2 - 11*s + 6)) + D1*(-f*fd*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1) - f*(bd2 - 2*gd2)*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - fd*(b2 - 2*g2)*(k1**2 + 7*k2**2)*(r + s)**2) - Dd*f*(f*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) + (b2 - 2*g2)*(k1**2 + 7*k2**2)*(r + s))*(4*r + 4*s - 3)))/(21*d**2*k3**4) - 2*D1**3*Pk2*Pkdd3*k1**2*(-D1*bd1*f*(r + s - 1)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)) + 2*b1**2*(D1*fd*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s)**2 + f*k1**2*(k1**2*(2*r + 2*s - 1) + 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(4*D1*bd1*f*(r + s - 1)*(-K*k2**2*(k1**2 + 7*k2**2)*(r + s) + f*k1**4*(2*r + 2*s - 1) + 3*f*k1**2*k2**2*(3*r + 3*s - 1)) + D1*(-5*f**2*fd*k1**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*f*k2**2*(fd*(2*C - 1)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s))*(2*r + 2*s - 1) - 2*gd2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*fd*g2*k2**2*(k1**2 + 7*k2**2)*(r + s)**2) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(r + s)) - 4*g2*k2**2*(k1**2 + 7*k2**2)*(r + s))))/(21*d**2*k3**6) - 2*D1**3*Pk2*Pkdd3*st**4*(r + s - 1)*(2*D1*bd1*f*k2**2*(b2 - 2*g2)*(r + s) + b1**2*(2*D1*fd*(K*k2**2 + f*k1**2)*(r + s - 1) + Dd*f*(2*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(2*K*k2**2 + f*k1**2)*(2*r + 2*s - 1) + 2*k2**2*(D1*b2*fd*(r + s - 1) + D1*bd2*f*(r + s - 1) - 2*D1*(f*gd2 + fd*g2)*(r + s - 1) + Dd*b2*f*(4*r + 4*s - 3) - 2*Dd*f*g2*(4*r + 4*s - 3))))/(7*d**2*k3**2) + D1**3*Pk2*Pkdd3*st**2*(2*D1*bd1*f*(b2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*C - 1)*(k1**2*(r**2 + r*(4*s - 1) + s*(s - 2)) + k2**2*(-r**2 - 2*r*s + r - s**2 + s)) - 2*g2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 11*b1**3*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - b1**2*(r + s - 1)*(11*D1*bd1*f*k1**2*(3*r + 3*s - 2) - 2*D1*fd*(r + s - 1)*(K*(k1**2 + 7*k2**2) + 3*f*k1**2 + k2**2*(2*C - 1)) - Dd*f*(4*r + 4*s - 3)*(2*K*(k1**2 + 7*k2**2) + 3*f*k1**2 + k2**2*(4*C - 2))) + b1*(8*C*D1*bd1*f*k2**2*r**2 + 16*C*D1*bd1*f*k2**2*r*s - 12*C*D1*bd1*f*k2**2*r + 8*C*D1*bd1*f*k2**2*s**2 - 12*C*D1*bd1*f*k2**2*s + 4*C*D1*bd1*f*k2**2 + 8*C*D1*f*fd*k1**2*r**2 + 32*C*D1*f*fd*k1**2*r*s - 20*C*D1*f*fd*k1**2*r + 8*C*D1*f*fd*k1**2*s**2 - 28*C*D1*f*fd*k1**2*s + 12*C*D1*f*fd*k1**2 - 8*C*D1*f*fd*k2**2*r**2 - 16*C*D1*f*fd*k2**2*r*s + 16*C*D1*f*fd*k2**2*r - 8*C*D1*f*fd*k2**2*s**2 + 16*C*D1*f*fd*k2**2*s - 8*C*D1*f*fd*k2**2 + 16*C*Dd*f**2*k1**2*r**2 + 64*C*Dd*f**2*k1**2*r*s - 32*C*Dd*f**2*k1**2*r + 16*C*Dd*f**2*k1**2*s**2 - 52*C*Dd*f**2*k1**2*s + 16*C*Dd*f**2*k1**2 - 16*C*Dd*f**2*k2**2*r**2 - 32*C*Dd*f**2*k2**2*r*s + 28*C*Dd*f**2*k2**2*r - 16*C*Dd*f**2*k2**2*s**2 + 28*C*Dd*f**2*k2**2*s - 12*C*Dd*f**2*k2**2 + 4*D1*K*bd1*f*k1**2*r**2 + 8*D1*K*bd1*f*k1**2*r*s - 6*D1*K*bd1*f*k1**2*r + 4*D1*K*bd1*f*k1**2*s**2 - 6*D1*K*bd1*f*k1**2*s + 2*D1*K*bd1*f*k1**2 + 28*D1*K*bd1*f*k2**2*r**2 + 56*D1*K*bd1*f*k2**2*r*s - 42*D1*K*bd1*f*k2**2*r + 28*D1*K*bd1*f*k2**2*s**2 - 42*D1*K*bd1*f*k2**2*s + 14*D1*K*bd1*f*k2**2 + 6*D1*bd1*f**2*k1**2*r**2 + 12*D1*bd1*f**2*k1**2*r*s - 9*D1*bd1*f**2*k1**2*r + 6*D1*bd1*f**2*k1**2*s**2 - 9*D1*bd1*f**2*k1**2*s + 3*D1*bd1*f**2*k1**2 - 4*D1*bd1*f*k2**2*r**2 - 8*D1*bd1*f*k2**2*r*s + 6*D1*bd1*f*k2**2*r - 4*D1*bd1*f*k2**2*s**2 + 6*D1*bd1*f*k2**2*s - 2*D1*bd1*f*k2**2 + 2*D1*bd2*f*(k1**2 + 7*k2**2)*(r + s - 1)**2 - 4*D1*f*fd*k1**2*r**2 - 16*D1*f*fd*k1**2*r*s + 10*D1*f*fd*k1**2*r - 4*D1*f*fd*k1**2*s**2 + 14*D1*f*fd*k1**2*s - 6*D1*f*fd*k1**2 + 4*D1*f*fd*k2**2*r**2 + 8*D1*f*fd*k2**2*r*s - 8*D1*f*fd*k2**2*r + 4*D1*f*fd*k2**2*s**2 - 8*D1*f*fd*k2**2*s + 4*D1*f*fd*k2**2 - 4*D1*f*gd2*k1**2*r**2 - 8*D1*f*gd2*k1**2*r*s + 8*D1*f*gd2*k1**2*r - 4*D1*f*gd2*k1**2*s**2 + 8*D1*f*gd2*k1**2*s - 4*D1*f*gd2*k1**2 - 28*D1*f*gd2*k2**2*r**2 - 56*D1*f*gd2*k2**2*r*s + 56*D1*f*gd2*k2**2*r - 28*D1*f*gd2*k2**2*s**2 + 56*D1*f*gd2*k2**2*s - 28*D1*f*gd2*k2**2 - 4*D1*fd*g2*k1**2*r**2 - 8*D1*fd*g2*k1**2*r*s + 8*D1*fd*g2*k1**2*r - 4*D1*fd*g2*k1**2*s**2 + 8*D1*fd*g2*k1**2*s - 4*D1*fd*g2*k1**2 - 28*D1*fd*g2*k2**2*r**2 - 56*D1*fd*g2*k2**2*r*s + 56*D1*fd*g2*k2**2*r - 28*D1*fd*g2*k2**2*s**2 + 56*D1*fd*g2*k2**2*s - 28*D1*fd*g2*k2**2 - 8*Dd*f**2*k1**2*r**2 - 32*Dd*f**2*k1**2*r*s + 16*Dd*f**2*k1**2*r - 8*Dd*f**2*k1**2*s**2 + 26*Dd*f**2*k1**2*s - 8*Dd*f**2*k1**2 + 8*Dd*f**2*k2**2*r**2 + 16*Dd*f**2*k2**2*r*s - 14*Dd*f**2*k2**2*r + 8*Dd*f**2*k2**2*s**2 - 14*Dd*f**2*k2**2*s + 6*Dd*f**2*k2**2 - 16*Dd*f*g2*k1**2*r**2 - 32*Dd*f*g2*k1**2*r*s + 28*Dd*f*g2*k1**2*r - 16*Dd*f*g2*k1**2*s**2 + 28*Dd*f*g2*k1**2*s - 12*Dd*f*g2*k1**2 - 112*Dd*f*g2*k2**2*r**2 - 224*Dd*f*g2*k2**2*r*s + 196*Dd*f*g2*k2**2*r - 112*Dd*f*g2*k2**2*s**2 + 196*Dd*f*g2*k2**2*s - 84*Dd*f*g2*k2**2 + 2*b2*(k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1)))/(21*d**2*k3**2) - 2*D1**3*Pk2*Pkdd3*st**4*(D1*bd1*f*(r + s - 1)*(2*f**2*k1**4*(21*r + 21*s - 8) - 33*f*k2**2*(2*K*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + b1*k1**2) + 66*k2**4*(K*b1 + b2*(r + s))) + 33*b1**2*k2**2*(D1*fd*(2*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(r + s - 1)) + 2*Dd*K*f*k2**2*(4*r + 4*s - 3)) + 2*b1*(D1*(f**2*fd*k1**4*(63*r**2 + 6*r*(21*s - 17) + 63*s**2 - 102*s + 43) - 33*f*k2**2*(K*fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + bd2*k2**2*(-r**2 - 2*r*s + r - s**2 + s) + 2*gd2*k2**2*(r + s - 1)) + 33*fd*k2**4*(b2*(r + s)**2 + g2*(-4*r - 4*s + 2))) + Dd*f*(4*r + 4*s - 3)*(-33*K*f*k2**2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + f**2*k1**4*(21*r + 21*s - 17) + 33*k2**4*(b2*(r + s) - 2*g2))) - 6*f*k2**2*(D1*(f*(fd*k1**2*(4*C - 2)*(3*r + 3*s - 2)**2 + (11*bd2 - 22*gd2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 11*fd*(b2 - 2*g2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(4*C - 2)*(3*r + 3*s - 2) + (11*b2 - 22*g2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)))*(4*r + 4*s - 3)))/(231*d**2*k3**4) + D1**3*Pk2*Pkdd3*st**2*(429*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*(D1*(f*k1**2*(-13*bd1*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + fd*(k1**2*(28*r**2 + 56*r*s - 39*r + 28*s**2 - 39*s + 15) + k2**2*(-8*r**2 - 16*r*s + r - 8*s**2 + s + 3))) - 2*fd*k2**2*(K*k1**2*(12*r**2 + r*(24*s + 2) + 12*s**2 + 2*s - 1) + 7*K*k2**2*(2*r + 2*s - 1) - k2**2*(2*C - 1)*(r + s - 1)**2)) + 2*Dd*f*(4*r + 4*s - 3)*(-K*k1**2*k2**2*(12*r + 12*s + 1) - 7*K*k2**4 + f*k1**4*(7*r + 7*s - 5) - 2*f*k1**2*k2**2*(r + s) + k2**4*(2*C - 1)*(r + s - 1))) - 33*b1*(D1*bd1*f*(r + s - 1)*(-2*K*k1**2*k2**2*(24*r + 24*s + 1) - 14*K*k2**4 + f*k1**4*(28*r + 28*s - 15) + f*k1**2*k2**2*(-8*r - 8*s + 3) + k2**4*(4*C - 2)*(2*r + 2*s - 1)) - D1*(3*f**2*fd*k1**4*(6*r**2 + r*(12*s - 11) + 6*s**2 - 11*s + 5) - 2*f*(fd*(k1**4*(C*(r*(8*s - 2) - 6*s + 2) - K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 4*r*s + r + 3*s - 1) + k1**2*k2**2*(K*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - (2*C - 1)*(14*r**2 + r*(28*s - 9) + 2*s*(7*s - 5))) + k2**4*(2*C - 1)*(3*r + 3*s - 2)) + k2**2*(-bd2*(13*k1**2 + 7*k2**2)*(r + s) + 2*gd2*(k1**2*(12*r + 12*s + 1) + 7*k2**2))*(r + s - 1)) + 2*fd*k2**2*(b2*(13*k1**2 + 7*k2**2)*(r + s)**2 - 2*g2*(k1**2*(12*r**2 + 24*r*s + 2*r + 12*s**2 + 2*s - 1) + 7*k2**2*(2*r + 2*s - 1)))) - 2*Dd*f*(3*f**2*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + f*(k1**4*(-2*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 8*r*s - r - 6*s + 1) + k1**2*k2**2*(4*r + 4*s - 3)*(2*C*(7*r + 7*s - 2) + K*(-4*r - 4*s + 3) - 7*r - 7*s + 2) - k2**4*(2*C - 1)*(4*r + 4*s - 3)) + k2**2*(b2*(13*k1**2 + 7*k2**2)*(r + s) - 2*g2*(k1**2*(12*r + 12*s + 1) + 7*k2**2))*(4*r + 4*s - 3))) + f*(66*D1*bd2*f*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1) + 66*b2*(D1*(bd1*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1)) + Dd*f*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(4*r + 4*s - 3)) + k1**2*(33*D1*bd1*(3*f**2*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*f*(K*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1) + (2*C - 1)*(k1**2*s*(1 - 2*r) + k2**2*(7*r**2 + r*(14*s - 11) + 7*s**2 - 10*s + 4))) - 48*g2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*(f*(fd*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) - 66*gd2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1)) - 66*fd*g2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1)) + 2*Dd*f*(f*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3)) - 66*g2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3)))*(4*r + 4*s - 3))))/(693*d**2*k3**4) + 2*D1**3*Pk2*Pkdd3*st**4*(D1*(858*b1*fd*k2**6*(r + s)**2*(K*b1 - 2*g2) - f**3*fd*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7))*(4*r + 4*s - 3) + 78*f**2*k2**4*(11*b1*bd1*k1**2*(r + s - 1)**2 - fd*k1**2*(4*C - 2)*(3*r + 3*s - 2)**2 + (-11*K*bd1 + 22*gd2)*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1)) + 429*f*k2**4*(b1**2*fd*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*b1*(K*fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + k2**2*(-2*K*bd1 + 2*gd2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*g2*(bd1*k2**2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(-858*b1*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(k1**2*(179*r + 179*s - 157) - 39*k2**2*(9*r + 9*s - 7)) + f**2*k1**2*k2**4*(312*C - 156)*(3*r + 3*s - 2) - 429*f*k2**4*(-2*K*b1*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)) + b1**2*k1**2*(r + s - 1) + 4*g2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1)))))/(3003*d**2*k3**6) + D1**3*Pk2*Pkdd3*st**2*(D1*bd1*f*(-f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(r + s - 1) + 66*f*k2**2*(-k1**4*(C*(4*r*s - 2*r - 2*s + 2) + K*r**2 + 2*K*r*s - 2*K*r + K*s**2 - 2*K*s + K - b1*(25*r**2 + r*(50*s - 36) + 25*s**2 - 36*s + 11) - 2*r*s + r + s - 1) + k1**2*k2**2*(-4*C*(4*r**2 + 9*r*s - 6*r + 4*s**2 - 6*s + 2) + 4*K*r**2 + 8*K*r*s - 7*K*r + 4*K*s**2 - 7*K*s + 3*K - 3*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 8*r**2 + 18*r*s - 12*r + 8*s**2 - 12*s + 4) + k2**4*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1))) + k2**4*(13*k1**2 + 7*k2**2)*(-132*K*b1 + 132*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) - 33*b1**2*k2**2*(D1*fd*(2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s)**2 - f*k1**2*(k1**2*(25*r + 25*s - 11) - 3*k2**2*(3*r + 3*s - 1))*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(-2*K*k2**2*(13*k1**2 + 7*k2**2)*(r + s) + f*k1**4*(25*r + 25*s - 11) - 3*f*k1**2*k2**2*(3*r + 3*s - 1))) + b1*(D1*(-f**2*fd*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(3*r + 3*s - 2) + 66*f*k2**2*(fd*(-K*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1) - (2*C - 1)*(k1**4*s*(4*r - 3) + k1**2*k2**2*(16*r**2 + 2*r*(18*s - 7) + 16*s**2 - 17*s + 3) + k2**4*(-2*r**2 - 4*r*s + r - 2*s**2 + s))) + 2*gd2*k2**2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 132*fd*g2*k2**4*(13*k1**2 + 7*k2**2)*(r + s)**2) + Dd*f*(-f**2*k1**4*(k1**2*(171*r + 171*s - 103) - 132*k2**2*(r + s))*(4*r + 4*s - 3) + 66*f*k2**2*(-k1**4*(2*C*(r*(8*s - 1) - 6*s + 1) + K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 8*r*s + r + 6*s - 1) + k1**2*k2**2*(-2*C*(32*r**2 + r*(72*s - 37) + 32*s**2 - 42*s + 10) + K*(4*r + 4*s - 3)**2 + 32*r**2 + 72*r*s - 37*r + 32*s**2 - 42*s + 10) + k2**4*(2*C - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 132*g2*k2**4*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)))) + f*k1**2*(D1*(75*f**2*fd*k1**4*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*f*k2**2*(-fd*(2*C - 1)*(k1**2*(9*r + 9*s - 17) - 33*k2**2*(4*r + 4*s - 3))*(3*r + 3*s - 2) + 66*gd2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1)) + 132*fd*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(75*f**2*k1**4*(r + s - 1) + f*k2**2*(4*C - 2)*(k1**2*(-9*r - 9*s + 17) + 33*k2**2*(4*r + 4*s - 3)) + 132*g2*k2**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3)))))/(693*d**2*k3**6) - 2*D1**3*Pk3*b1*ct*k1*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*D1*bd1*f*s*(s*(f - 2) + 2) + b1*(D1*fd*(s**2*(2*f - 2) - s*(f - 4) - 2) + Dd*f*(4*s - 1)*(s*(f - 2) + 2)))/(7*d**2*k2**3) - 80*D1**3*Pk3*ct**8*f*k1**2*k2**2*(4*Pk2 - Pkd2*k2)*(429*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 2*D1*(7*f**2*fd*(2*r*(256*s - 77) + 512*s**2 - 512*s + 109) + 13*f*(fd*(C - 1)*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) - 33*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 858*fd*g2*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(7*f**2*(2*r*(256*s - 77) + 512*s**2 - 512*s + 109) + f*(13*C - 13)*(r*(408*s - 163) + 408*s**2 - 408*s + 107) - 858*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 858*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2)))/(9009*d**2*k3**6) - 20*D1**3*Pk3*ct**8*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(512*s**2 - 308*s + 45) + f*fd*(26*C - 26)*(153*s**2 - 135*s + 28) - 429*f*s*(2*s - 1)*(-K*bd1 + bd1 + 2*gd2) - 858*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(128*s - 45) + f*(26*C - 26)*(51*s - 28) + 858*g2*(1 - 2*s)) + 429*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d**2*k3**4) - 8*D1**3*Pk3*ct**7*f*k1*k2*(26*D1*bd1*f*(k1**2*(99*K - 99)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + 5*k2**2*(Pk2*f*(135*r**2 - 158*r - 135*s**2 + 56*s + 23) - 66*Pk2*(K*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) - 6*r**2 + r*(7 - 4*s) + 2*s**2 + s - 1) + Pkd2*f*k2*(r*(135*s - 28) + 135*s**2 - 135*s + 28) - Pkd2*k2*(66*K - 33)*(r*(4*s - 1) + (1 - 2*s)**2))) - 2*D1*(-10*f**2*fd*(-13*Pk2*k2**2*(184*r**2 + 2*r*(92*s - 73) - 36*s + 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(r*(1424*s - 499) + 1424*s**2 - 1554*s + 371)) - 13*f*(fd*k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(29*s - 17)*(3*r + 3*s - 2) + fd*k2**2*(-2*Pk2*(C*(2673*r**2 + r*(2337 - 7407*s) - 6120*s**2 + 9189*s - 2636) - 3438*r**2 + 9*r*(263*s - 53) + 3825*s**2 - 5484*s + 1681) - 5*Pkd2*k2*(8*C*(3*s - 1)*(84*r + 51*s - 56) - 3*r*(438*s - 157) - 918*s**2 + 1182*s - 303)) - 198*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + 660*gd2*k2**2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + 1716*fd*g2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4) - 10*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1))) - 2*Dd*f*(-10*f**2*(-13*Pk2*k2**2*(184*r**2 + 2*r*(92*s - 73) - 36*s + 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(r*(1424*s - 499) + 1424*s**2 - 1554*s + 371)) + 13*f*(k1**2*(60 - 60*C)*(4*Pk2 - Pkd2*k2)*(r*(116*s - 65) + 116*s**2 - 149*s + 48) + k2**2*(2*Pk2*(2*C*(1782*r**2 - 4938*r*s + 1036*r - 4080*s**2 + 6159*s - 1631) - 4584*r**2 + 3156*r*s + 298*r + 5100*s**2 - 7073*s + 2052) + 5*Pkd2*k2*(8*C*(336*r*s - 98*r + 204*s**2 - 303*s + 70) - 1752*r*s + 555*r - 1224*s**2 + 1620*s - 387))) + 1716*g2*(9*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) - 10*k2**2*(Pk2*(8*r**2 - r*(8*s + 1) - 16*s**2 + 14*s - 3) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)))) + 13*b1*(D1*fd*(k1**2*(396*K - 396)*(4*Pk2 - Pkd2*k2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4) + 5*k2**2*(6*Pk2*(f*(135*r**2 - 68*r - 135*s**2 + 101*s - 11) + (-44*r - 44*s + 22)*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1)) + Pkd2*k2*(f*(r*(810*s - 303) + 810*s**2 - 810*s + 191) + (132 - 264*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(1188*K - 1188)*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) + 5*k2**2*(2*Pk2*(-132*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + f*(540*r**2 - 362*r - 540*s**2 + 359*s - 10) + 1584*r**2 + 1056*r*s - 1188*r - 528*s**2 + 132*s + 66) + Pkd2*k2*(f*(1080*r*s - 359*r + 1080*s**2 - 1080*s + 247) + (132 - 264*K)*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k3**6) - 10*D1**3*Pk3*ct**7*f*k1*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(405*s**2 - 303*s + 56) + 66*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(135*f*s - 56*f + 132*s - 66)) + f*(D1*bd1*s*(135*f*s - 56*f + 132*s - 66) + D1*fd*(306*s**2 - 270*s + 56) + 2*Dd*f*(204*s**2 - 163*s + 28)))/(693*d**2*k2*k3**2) - 2*D1**3*Pk3*ct**7*f*k1*(D1*(5*f**2*(-13*bd1*k2**2*(-8*Pk2*(r*(270*s - 56) + 135*s**2 - 214*s + 56) + k2*(Pkd2*(540*r*s - 112*r - 135*s**2 - 260*s + 112) + Pkdd2*k2*s*(135*s - 56))) + 2*fd*(63*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(136*s**2 - 94*s + 15) + 26*k2**2*(Pk2*(r*(326 - 826*s) + 189*s - 107) + Pkd2*k2*(r*(214*s - 84) - 51*s + 28)))) + 26*f*(33*bd1*(Pk2*k1**2*s*(48*K - 48)*(7*s - 5) - Pkd2*k1**2*k2*s*(18*K - 18)*(7*s - 5) + 5*Pkd2*k2**3*(K*(r*(8*s - 2) - 20*s**2 + 6*s + 2) + r*(4 - 16*s) + 2*s**2 + 7*s - 4) + Pkdd2*k2**4*s*(10*K - 5)*(2*s - 1) - 2*k2**2*(20*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) - Pkdd2*k1**2*s*(K - 1)*(7*s - 5))) + fd*k1**2*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 237*s + 56) + fd*k2**2*(-2*Pk2*(C*(33*r*(342*s - 157) - 12240*s**2 + 12318*s - 2273) - 17406*r*s + 7881*r + 3060*s**2 - 3498*s + 133) + k2*(Pkd2*(2*C*(33*r*(87*s - 40) - 7650*s**2 + 7113*s - 1400) - 8802*r*s + 3990*r + 8415*s**2 - 7791*s + 1310) + Pkdd2*k2*(20*C - 15)*(153*s**2 - 135*s + 28))) - 132*gd2*(24*Pk2*k1**2*s*(7*s - 5) - 9*Pkd2*k1**2*k2*s*(7*s - 5) - 5*Pkd2*k2**3*(-4*r*s + r + 10*s**2 - 3*s - 1) + 5*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(20*Pk2*(-4*r*s + r + 4*s**2 - 1) + Pkdd2*k1**2*s*(7*s - 5)))) - 3432*fd*g2*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7*s - 5) + 5*k2**2*(-8*Pk2*(2*r - 2*s + 1) + k2*(Pkd2*(4*r - 10*s + 5) + Pkdd2*k2*(2*s - 1))))) + 2*Dd*f*(5*f**2*(63*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(136*s**2 - 94*s + 15) + 26*k2**2*(Pk2*(r*(326 - 826*s) + 189*s - 107) + Pkd2*k2*(r*(214*s - 84) - 51*s + 28))) + 13*f*(k1**2*(10*C - 10)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 293*s + 56) + k2**2*(-4*Pk2*(C*(66*r*(114*s - 49) - 8160*s**2 + 6718*s - 493) - 11604*r*s + 4864*r + 2040*s**2 - 1008*s - 857) + k2*(Pkd2*(4*C*(33*r*(58*s - 25) - 5100*s**2 + 4108*s - 535) - 11736*r*s + 4930*r + 11220*s**2 - 8277*s + 370) + Pkdd2*k2*(20*C - 15)*(204*s**2 - 163*s + 28)))) - 1716*g2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(28*s**2 - 27*s + 5) + 5*k2**2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))) + 13*b1*(D1*fd*(k1**2*(132*K - 132)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(14*s**2 - 17*s + 5) - 5*k2**2*(-24*Pk2*(f*(r*(270*s - 101) + 135*s**2 - 169*s + 45) + (44*s - 22)*(K*(-4*r + 4*s - 2) + 8*r + 2*s - 1)) + k2*(3*Pkd2*f*(r*(540*s - 202) - 135*s**2 - 35*s + 34) + 66*Pkd2*(2*s - 1)*(-2*K*(4*r - 10*s + 5) + 16*r - 2*s + 1) + Pkdd2*f*k2*(405*s**2 - 303*s + 56) + Pkdd2*k2*(1 - 2*s)**2*(66 - 132*K)))) + Dd*f*(k1**2*(132*K - 132)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(28*s**2 - 27*s + 5) - 5*k2**2*(-8*Pk2*(f*(r*(1080*s - 359) + 540*s**2 - 721*s + 191) + 66*r*(4 - 2*K)*(8*s - 3) + 66*(2*s - 1)*(8*K*s + 4*s - 5)) + k2*(Pkd2*(-132*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) + f*(r*(2160*s - 718) - 540*s**2 - 365*s + 214) + 4224*r*s - 1584*r - 528*s**2 - 660*s + 462) + Pkdd2*k2*(4*s - 1)*(f*(135*s - 56) + (66 - 132*K)*(2*s - 1)))))))/(9009*d**2*k2*k3**4) + 40*D1**3*Pk3*ct**6*f*k1**2*k2**2*st**2*(-4*Pk2 + Pkd2*k2)*(24804*C*D1*f*fd*r*s - 9984*C*D1*f*fd*r + 24804*C*D1*f*fd*s**2 - 24804*C*D1*f*fd*s + 6084*C*D1*f*fd + 33072*C*Dd*f**2*r*s - 11934*C*Dd*f**2*r + 33072*C*Dd*f**2*s**2 - 33072*C*Dd*f**2*s + 8034*C*Dd*f**2 + 1287*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 32984*D1*f**2*fd*r*s - 9611*D1*f**2*fd*r + 32984*D1*f**2*fd*s**2 - 32984*D1*f**2*fd*s + 6867*D1*f**2*fd - 24804*D1*f*fd*r*s + 9984*D1*f*fd*r - 24804*D1*f*fd*s**2 + 24804*D1*f*fd*s - 6084*D1*f*fd - 10296*D1*f*gd2*r*s + 2574*D1*f*gd2*r - 10296*D1*f*gd2*s**2 + 10296*D1*f*gd2*s - 2574*D1*f*gd2 - 20592*D1*fd*g2*r*s + 10296*D1*fd*g2*r - 20592*D1*fd*g2*s**2 + 20592*D1*fd*g2*s - 5148*D1*fd*g2 + 32984*Dd*f**3*r*s - 9611*Dd*f**3*r + 32984*Dd*f**3*s**2 - 32984*Dd*f**3*s + 6867*Dd*f**3 - 33072*Dd*f**2*r*s + 11934*Dd*f**2*r - 33072*Dd*f**2*s**2 + 33072*Dd*f**2*s - 8034*Dd*f**2 - 41184*Dd*f*g2*r*s + 15444*Dd*f*g2*r - 41184*Dd*f*g2*s**2 + 41184*Dd*f*g2*s - 10296*Dd*f*g2 + 2574*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(9009*d**2*k3**6) - 10*D1**3*Pk3*ct**6*f*k1**2*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*(7*f**2*fd*(2356*s**2 - 1373*s + 196) + 39*f*(fd*(2*C - 2)*(159*s**2 - 128*s + 25) + s*(2*s - 1)*(33*K*bd1 - 33*bd1 - 66*gd2)) - 2574*fd*g2*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(7*f**2*(589*s - 196) + f*(78*C - 78)*(53*s - 25) + 2574*g2*(1 - 2*s)) + 1287*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d**2*k3**4) - 4*D1**3*Pk3*ct**6*(13*D1*bd1*f*(f**2*k2**2*(33*Pk2*k2**2*(r - 1)*(25*r + 25*s - 7) + 10*k1**2*(2*Pk2*(411*r**2 + 309*r*s - 506*r - 102*s**2 - 29*s + 39) + Pkd2*k2*(513*r*s - 122*r + 513*s**2 - 599*s + 178))) + 66*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + k1**2*k2**2*(Pk2*(8*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s - 1) + K*(-153*r**2 - 107*r*s + 111*r + 46*s**2 - 142*s + 42) + 209*r**2 + 299*r*s - 251*r + 90*s**2 - 106*s + 82) + 2*Pkd2*k2*(-2*C*(r*(8*s - 4) + 8*s**2 - 7*s - 1) - 24*K*(2*s - 1)*(r + s - 1) + 28*r*s - 17*r + 28*s**2 - 38*s + 7)) - 10*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 792*k1**2*k2**2*(-b1*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 10296*b1**2*k1**2*k2**2*(K - 1)*(2*D1*fd*(Pk2*(r**2 + 4*r*s - 2*r + 3*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + Dd*f*(2*Pk2*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 13*b1*(D1*(f**2*fd*k2**2*(33*Pk2*k2**2*(75*r**2 + r*(75*s - 26) + 15*s - 13) + 10*k1**2*(6*Pk2*(411*r**2 + 309*r*s - 311*r - 102*s**2 + 53*s + 36) + Pkd2*k2*(1539*r*s - 948*r + 1539*s**2 - 2040*s + 632))) + 66*f*(fd*(k1**4*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(16*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 9*s + 4) + K*(-306*r**2 - 214*r*s + 94*r + 92*s**2 - 188*s + 71) + 418*r**2 + 598*r*s - 334*r + 180*s**2 - 204*s + 17) - 4*Pkd2*k2*(16*C*s**2 - 2*C*s + 6*K*(r*(8*s - 5) + 8*s**2 - 10*s + 3) + r*(s*(16*C - 28) + 9) - 28*s**2 + 20*s - 6)) - 20*k2**4*(2*r + 2*s - 1)*(K*Pk2*(6*r + 2*s - 1) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 24*gd2*k1**2*k2**2*(-2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 3168*fd*g2*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))) + 2*Dd*f*(f**2*k2**2*(33*Pk2*k2**2*(50*r**2 + r*(50*s - 29) - 5*s - 3) + 5*k1**2*(Pk2*(3288*r**2 + 2472*r*s - 2878*r - 816*s**2 + 260*s + 294) + Pkd2*k2*(2052*r*s - 1070*r + 2052*s**2 - 2639*s + 810))) + 33*f*(k1**4*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + k1**2*k2**2*(Pk2*(8*C*(16*r**2 + 32*r*(2*s - 1) + 48*s**2 - 40*s + 11) + K*(-612*r**2 - 428*r*s + 316*r + 184*s**2 - 472*s + 155) + 836*r**2 + 1196*r*s - 836*r + 360*s**2 - 416*s + 141) - 4*Pkd2*k2*(C*(4*r*(8*s - 1) + 32*s**2 - 12*s - 1) + 6*K*(16*r*s - 9*r + 16*s**2 - 22*s + 7) - 56*r*s + 22*r - 56*s**2 + 54*s - 14)) - 20*k2**4*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1))) + 792*g2*k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 2*f*(D1*(5*f**2*fd*k1**2*(28*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(113*s - 51) + 1356*s**2 - 1681*s + 472) + 13*k2**2*(-Pk2*(1486*r**2 + r*(8338*s - 2822) + 6852*s**2 - 6384*s + 1165) + 56*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(-330*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + k1**2*k2**2*(Pk2*(C*(-7821*r**2 + 135*r*(47*s - 45) + 2286*s**2 - 21954*s + 9253) + 10971*r**2 + 45*r*(247*s - 41) + 6084*s**2 + 7584*s - 5043) - 15*Pkd2*k2*(4*C*(207*r*s - 91*r + 108*s**2 - 218*s + 68) - 456*r*s + 229*r - 258*s**2 + 522*s - 171)) + k2**4*(Pk2*(-12*C*(636*r**2 + 3*r*(638*s - 167) + 255*s**2 - 863*s + 143) + 4959*r**2 + 3*r*(4209*s - 998) + 1530*s**2 - 4569*s + 397) + Pkd2*k2*(10 - 20*C)*(3*s - 1)*(84*r + 51*s - 56))) - 33*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + k1**2*k2**2*(Pk2*(-153*r**2 + r*(111 - 107*s) + 46*s**2 - 142*s + 42) - 48*Pkd2*k2*(2*s - 1)*(r + s - 1)) - 10*k2**4*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 858*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + g2*(12*k1**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(-306*r**2 + r*(94 - 214*s) + 92*s**2 - 188*s + 71) - 24*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 20*k2**4*(Pk2*(6*r + 2*s - 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-8580*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*f**2*k1**2*(28*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(113*s - 51) + 1356*s**2 - 1681*s + 472) + 13*k2**2*(-Pk2*(1486*r**2 + r*(8338*s - 2822) + 6852*s**2 - 6384*s + 1165) + 56*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(4*r*(25*s - 27) + 100*s**2 - 199*s + 85) + k1**2*k2**2*(Pk2*(C*(-10428*r**2 + r*(8460*s - 6928) + 3048*s**2 - 31560*s + 12713) + 14628*r**2 + 4*r*(3705*s - 868) + 8112*s**2 + 11170*s - 7073) - 15*Pkd2*k2*(2*C*(r*(552*s - 227) + 288*s**2 - 618*s + 181) + r*(291 - 608*s) - 344*s**2 + 740*s - 233)) + k2**4*(Pk2*(-4*C*(2544*r**2 + 7656*r*s - 2098*r + 1020*s**2 - 3983*s + 388) + 6612*r**2 + 16836*r*s - 4409*r + 2040*s**2 - 7358*s + 159) + Pkd2*k2*(10 - 20*C)*(14*r*(24*s - 7) + 204*s**2 - 303*s + 70))) - 858*g2*(12*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + k1**2*k2**2*(Pk2*(-612*r**2 + r*(316 - 428*s) + 184*s**2 - 472*s + 155) - 24*Pkd2*k2*(r*(16*s - 9) + 16*s**2 - 22*s + 7)) - 20*k2**4*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(9009*d**2*k3**6) - D1**3*Pk3*ct**6*(792*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 3*b1*(88*C*f*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 5)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + D1*(f**2*fd*(20*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(153*s**2 - 135*s + 28) + 11*k2**2*(Pk2*(r*(154 - 345*s) - 45*s + 2) + 10*Pkd2*k2*(r*(9*s - 4) + s))) - 44*f*(fd*(2*s - 1)*(5*K*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) - 144*Pk2*k1**2*s + 54*Pkd2*k1**2*k2*s - 20*Pkd2*k2**3*r + k2**2*(80*Pk2*r - 6*Pkdd2*k1**2*s)) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(-12*K*bd1 + 12*bd1 + 12*gd2)) - 528*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f**2*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(204*s**2 - 163*s + 28) + 11*k2**2*(Pk2*(r*(116 - 230*s) + 35*s - 38) + 10*Pkd2*k2*(r*(6*s - 3) - s + 1))) - 22*f*(5*K*Pkdd2*k2**4*(8*s**2 - 6*s + 1) + 144*Pk2*k1**2*s*(1 - 4*s) + 54*Pkd2*k1**2*k2*s*(4*s - 1) - 5*Pkd2*k2**3*(5*K*(8*s**2 - 6*s + 1) + 16*r*s - 6*r - 4*s + 2) + 2*k2**2*(20*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + 3*Pkdd2*k1**2*s*(1 - 4*s))) - 264*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*(-660*b2*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 3*bd1*f**2*(480*Pk2*k1**2*s*(51*s - 28) - 180*Pkd2*k1**2*k2*s*(51*s - 28) + 110*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(-11*Pk2*(r - 1)*(115*s - 78) + 20*Pkdd2*k1**2*s*(51*s - 28))) + 4*f*(33*bd1*(5*K*Pkdd2*k2**4*s*(1 - 2*s) + 48*Pk2*k1**2*s*(C*(4*s - 5) + 3*s) - 18*Pkd2*k1**2*k2*s*(C*(4*s - 5) + 3*s) + 5*Pkd2*k2**3*(r*(4*s - 1) + (2*s - 1)*(5*K*s - 1)) + k2**2*(-20*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + 2*Pkdd2*k1**2*s*(C*(4*s - 5) + 3*s))) + 5*fd*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 237*s + 56) + fd*k2**2*(Pk2*(-80*C*(153*s**2 - 135*s + 28) - 5166*r*s + 2481*r + 6120*s**2 - 7638*s + 1613) + k2*(Pkd2*(50*C*(153*s**2 - 135*s + 28) + 1341*r*s - 645*r - 3825*s**2 + 3918*s - 815) + Pkdd2*k2*(5 - 10*C)*(153*s**2 - 135*s + 28))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-165*bd2 + 330*gd2)*(2*s - 1)) + 264*g2*(-6*bd1*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 5*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)))) + 4*Dd*f*(f*(5*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 293*s + 56) + k2**2*(-2*Pk2*(40*C*(204*s**2 - 163*s + 28) + 4*r*(861*s - 401) - 4080*s**2 + 4278*s - 443) + k2*(Pkd2*(50*C*(204*s**2 - 163*s + 28) + 1788*r*s - 835*r - 5100*s**2 + 4551*s - 625) + Pkdd2*k2*(5 - 10*C)*(204*s**2 - 163*s + 28)))) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-165*b2 + 330*g2)*(8*s**2 - 6*s + 1))))/(693*d**2*k2**2*k3**2) + D1**3*Pk3*ct**6*(-10296*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2)) + Dd*f*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 13*b1*(3*D1*(-f**2*fd*k2**2*(-20*k1**2*(4*Pk2*(r*(717*s - 316) + 513*s**2 - 614*s + 192) - k2*(Pkd2*(717*r*s - 316*r + 207*s**2 - 209*s + 108) + Pkdd2*k2*(102*s**2 - 135*s + 28))) + 11*k2**2*(Pk2*(3*r - 1)*(50*r - 15*s + 28) + 10*Pkd2*k2*(9*r*s - 4*r + s))) + 22*f*(fd*(k1**4*(2*K - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5) + k1**2*k2**2*(2*Pk2*(32*C*(r*(8*s - 7) + 12*s**2 - 15*s + 7) + K*(-493*r*s + 318*r - 328*s**2 + 232*s - 34) + 813*r*s - 430*r + 744*s**2 - 696*s + 82) + k2*(-Pkd2*(16*C*(r*(8*s - 7) + 18*s**2 - 15*s + 7) + K*(-248*r*s + 160*r + 28*s**2 - 148*s + 67) + 408*r*s - 216*r + 252*s**2 - 288*s + 17) + 4*Pkdd2*k2*(K*(16*s**2 - 22*s + 7) + s**2*(8*C - 10) + 5*s - 2))) + 10*k2**4*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2)))) + 12*k1**2*k2**2*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2)))) - 528*fd*g2*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + 2*Dd*f*(-f**2*k2**2*(-10*k1**2*(4*Pk2*(4*r*(717*s - 293) + 2052*s**2 - 2579*s + 744) - k2*(Pkd2*(4*r*(717*s - 293) + 828*s**2 - 1265*s + 492) + 6*Pkdd2*k2*(68*s**2 - 73*s + 14))) + 33*k2**2*(Pk2*(2*r - 1)*(50*r - 15*s + 28) + 10*Pkd2*k2*(6*r*s - 3*r - s + 1))) + 33*f*(k1**4*(2*K - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5) + k1**2*k2**2*(2*Pk2*(16*C*(8*r*(4*s - 3) + 48*s**2 - 56*s + 19) + K*(-986*r*s + 572*r - 656*s**2 + 665*s - 288) + 1626*r*s - 764*r + 1488*s**2 - 1641*s + 496) + k2*(Pkd2*(-8*C*(8*r*(4*s - 3) + 72*s**2 - 62*s + 19) + K*(496*r*s - 288*r - 56*s**2 + 98*s + 61) - 816*r*s + 384*r - 504*s**2 + 666*s - 225) + 4*Pkdd2*k2*(4*s - 1)*(K*(8*s - 7) + s*(4*C - 5) + 2))) + 10*k2**4*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1))) - 792*g2*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1))))) + f*(D1*(20592*bd1*g2*k1**2*k2**2*(8*Pk2*(r*(2*s - 1) + s*(3*s - 3)) + k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + f**2*(34320*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 260*bd1*k1**2*k2**2*(4*Pk2*(r*(717*s - 224) + 513*s**2 - 737*s + 168) + k2*(Pkd2*(-717*r*s + 224*r - 207*s**2 + 638*s - 168) + 3*Pkdd2*k2*s*(11 - 34*s))) + 429*bd1*k2**4*(r - 1)*(Pk2*(50*r - 15*s + 28) + 10*Pkd2*k2*(3*s - 2)) - 420*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(304*s**2 - 256*s + 45) + 130*fd*k1**2*k2**2*(3*Pk2*(6*r*(567*s - 326) + 7344*s**2 - 5345*s + 1430) + k2*(-3*Pkd2*(888*r*s - 504*r + 2508*s**2 - 1747*s + 421) + 56*Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 26*f*(33*bd1*(k1**4*s*(2*K - 2)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 5) + k1**2*k2**2*(Pk2*(384*C*s**2 - 416*C*s + K*(r*(254 - 493*s) - 328*s**2 + 433*s - 254) + r*(32*C*(8*s - 5) + 813*s - 334) + 744*s**2 - 945*s + 494) + k2*(Pkd2*(-144*C*s**2 + 152*C*s + K*(4*r*(31*s - 16) - 14*s**2 - 25*s + 64) + r*(-64*C*s + 40*C - 204*s + 84) - 126*s**2 + 165*s - 124) + 4*Pkdd2*k2*s*(4*C*(s - 1) + K*(8*s - 7) - 5*s + 6))) + 10*k2**4*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 660*bd2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + 2*fd*(k1**4*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(27*s**2 - 51*s + 14) + k1**2*k2**2*(Pk2*(C*(-297*r*(101*s - 78) - 25416*s**2 + 7803*s - 4166) + 9*r*(5653*s - 3934) + 54576*s**2 - 43443*s + 14566) + k2*(Pkd2*(C*(594*r*(13*s - 10) - 126*s**2 + 7245*s - 1279) - 12942*r*s + 9000*r - 10269*s**2 + 5220*s - 2161) + 5*Pkdd2*k2*(3*s - 1)*(2*C*(72*s - 79) - 75*s + 102))) + k2**4*(Pk2*(12*C*(123*r**2 + r*(1535 - 4026*s) - 1020*s**2 + 2242*s - 712) - 3762*r**2 + 165*r*(150*s - 71) + 6120*s**2 - 13650*s + 5443) + k2*(Pkd2*(30*C*(3*s - 1)*(264*r + 51*s - 116) - 13221*r*s + 4605*r - 2295*s**2 + 5442*s - 1625) + Pkdd2*k2*(10*C - 5)*(153*s**2 - 135*s + 28)))) + 66*gd2*(-2*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 5) + k1**2*k2**2*(Pk2*(r*(493*s - 254) + 328*s**2 - 433*s + 254) + k2*(Pkd2*(-124*r*s + 64*r + 14*s**2 + 25*s - 64) + 4*Pkdd2*k2*s*(7 - 8*s))) - 10*k2**4*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 1716*fd*(-20*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + g2*(2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5) + k1**2*k2**2*(Pk2*(r*(636 - 986*s) - 656*s**2 + 464*s - 68) + k2*(Pkd2*(8*r*(31*s - 20) - 28*s**2 + 148*s - 67) + 4*Pkdd2*k2*(16*s**2 - 22*s + 7))) + 10*k2**4*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1)))))) - 2*Dd*f*(17160*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 5*f**2*(-3432*Pk2*k2**4*(2*r**2 - 3*r + 1) + 42*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(304*s**2 - 256*s + 45) - 13*k1**2*k2**2*(3*Pk2*(6*r*(567*s - 326) + 7344*s**2 - 5345*s + 1430) + k2*(-3*Pkd2*(888*r*s - 504*r + 2508*s**2 - 1747*s + 421) + 56*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 26*f*(k1**4*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 65*s + 14) + k1**2*k2**2*(-2*Pk2*(C*(198*r*(101*s - 78) + 16944*s**2 - 7123*s + 5944) - 33918*r*s + 23244*r - 36384*s**2 + 30863*s - 12824) + k2*(Pkd2*(C*(792*r*(13*s - 10) - 168*s**2 + 7930*s + 701) - 17256*r*s + 11820*r - 13692*s**2 + 8335*s - 4981) + 5*Pkdd2*k2*(4*s - 1)*(2*C*(72*s - 79) - 75*s + 102))) + k2**4*(2*Pk2*(4*C*(246*r**2 + r*(2699 - 8052*s) - 2040*s**2 + 4996*s - 1526) - 2508*r**2 + 132*r*(125*s - 51) + 4080*s**2 - 10190*s + 4223) + k2*(Pkd2*(30*C*(44*r*(24*s - 7) + 204*s**2 - 603*s + 160) - 17628*r*s + 5455*r - 3060*s**2 + 8569*s - 2475) + Pkdd2*k2*(10*C - 5)*(204*s**2 - 163*s + 28)))) - 858*g2*(2*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5) + k1**2*k2**2*(-2*Pk2*(r*(986*s - 572) + 656*s**2 - 665*s + 288) + k2*(Pkd2*(496*r*s - 288*r - 56*s**2 + 98*s + 61) + 4*Pkdd2*k2*(32*s**2 - 36*s + 7))) + 10*k2**4*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(9009*d**2*k2**2*k3**4) + 4*D1**3*Pk3*ct**5*f*k1*k2*st**2*(-1490112*C*D1*Pk2*f*fd*k1**2*r*s + 661440*C*D1*Pk2*f*fd*k1**2*r - 1490112*C*D1*Pk2*f*fd*k1**2*s**2 + 1627392*C*D1*Pk2*f*fd*k1**2*s - 431808*C*D1*Pk2*f*fd*k1**2 + 419328*C*D1*Pk2*f*fd*k2**2*r**2 - 984672*C*D1*Pk2*f*fd*k2**2*r*s + 196248*C*D1*Pk2*f*fd*k2**2*r - 992160*C*D1*Pk2*f*fd*k2**2*s**2 + 1236768*C*D1*Pk2*f*fd*k2**2*s - 304616*C*D1*Pk2*f*fd*k2**2 + 372528*C*D1*Pkd2*f*fd*k1**2*k2*r*s - 165360*C*D1*Pkd2*f*fd*k1**2*k2*r + 372528*C*D1*Pkd2*f*fd*k1**2*k2*s**2 - 406848*C*D1*Pkd2*f*fd*k1**2*k2*s + 107952*C*D1*Pkd2*f*fd*k1**2*k2 + 702000*C*D1*Pkd2*f*fd*k2**3*r*s - 234000*C*D1*Pkd2*f*fd*k2**3*r + 496080*C*D1*Pkd2*f*fd*k2**3*s**2 - 633360*C*D1*Pkd2*f*fd*k2**3*s + 156000*C*D1*Pkd2*f*fd*k2**3 - 1986816*C*Dd*Pk2*f**2*k1**2*r*s + 817440*C*Dd*Pk2*f**2*k1**2*r - 1986816*C*Dd*Pk2*f**2*k1**2*s**2 + 2206464*C*Dd*Pk2*f**2*k1**2*s - 587808*C*Dd*Pk2*f**2*k1**2 + 559104*C*Dd*Pk2*f**2*k2**2*r**2 - 1312896*C*Dd*Pk2*f**2*k2**2*r*s + 105768*C*Dd*Pk2*f**2*k2**2*r - 1322880*C*Dd*Pk2*f**2*k2**2*s**2 + 1632176*C*Dd*Pk2*f**2*k2**2*s - 353912*C*Dd*Pk2*f**2*k2**2 + 496704*C*Dd*Pkd2*f**2*k1**2*k2*r*s - 204360*C*Dd*Pkd2*f**2*k1**2*k2*r + 496704*C*Dd*Pkd2*f**2*k1**2*k2*s**2 - 551616*C*Dd*Pkd2*f**2*k1**2*k2*s + 146952*C*Dd*Pkd2*f**2*k1**2*k2 + 936000*C*Dd*Pkd2*f**2*k2**3*r*s - 273000*C*Dd*Pkd2*f**2*k2**3*r + 661440*C*Dd*Pkd2*f**2*k2**3*s**2 - 867360*C*Dd*Pkd2*f**2*k2**3*s + 195000*C*Dd*Pkd2*f**2*k2**3 - 3022080*D1*Pk2*f**2*fd*k1**2*r*s + 970020*D1*Pk2*f**2*fd*k1**2*r - 3022080*D1*Pk2*f**2*fd*k1**2*s**2 + 3201480*D1*Pk2*f**2*fd*k1**2*s - 718740*D1*Pk2*f**2*fd*k1**2 + 168480*D1*Pk2*f**2*fd*k2**2*r**2 + 168480*D1*Pk2*f**2*fd*k2**2*r*s - 133900*D1*Pk2*f**2*fd*k2**2*r - 29640*D1*Pk2*f**2*fd*k2**2*s + 11180*D1*Pk2*f**2*fd*k2**2 + 1490112*D1*Pk2*f*fd*k1**2*r*s - 661440*D1*Pk2*f*fd*k1**2*r + 1490112*D1*Pk2*f*fd*k1**2*s**2 - 1627392*D1*Pk2*f*fd*k1**2*s + 431808*D1*Pk2*f*fd*k1**2 - 543348*D1*Pk2*f*fd*k2**2*r**2 + 282672*D1*Pk2*f*fd*k2**2*r*s + 86112*D1*Pk2*f*fd*k2**2*r + 620100*D1*Pk2*f*fd*k2**2*s**2 - 703248*D1*Pk2*f*fd*k2**2*s + 165776*D1*Pk2*f*fd*k2**2 + 658944*D1*Pk2*f*gd2*k1**2*r*s - 205920*D1*Pk2*f*gd2*k1**2*r + 658944*D1*Pk2*f*gd2*k1**2*s**2 - 741312*D1*Pk2*f*gd2*k1**2*s + 205920*D1*Pk2*f*gd2*k1**2 - 205920*D1*Pk2*f*gd2*k2**2*r**2 + 205920*D1*Pk2*f*gd2*k2**2*r*s + 154440*D1*Pk2*f*gd2*k2**2*r + 411840*D1*Pk2*f*gd2*k2**2*s**2 - 308880*D1*Pk2*f*gd2*k2**2*s + 51480*D1*Pk2*f*gd2*k2**2 + 1317888*D1*Pk2*fd*g2*k1**2*r*s - 700128*D1*Pk2*fd*g2*k1**2*r + 1317888*D1*Pk2*fd*g2*k1**2*s**2 - 1400256*D1*Pk2*fd*g2*k1**2*s + 370656*D1*Pk2*fd*g2*k1**2 - 411840*D1*Pk2*fd*g2*k2**2*r**2 + 411840*D1*Pk2*fd*g2*k2**2*r*s - 205920*D1*Pk2*fd*g2*k2**2*r + 823680*D1*Pk2*fd*g2*k2**2*s**2 - 823680*D1*Pk2*fd*g2*k2**2*s + 205920*D1*Pk2*fd*g2*k2**2 + 755520*D1*Pkd2*f**2*fd*k1**2*k2*r*s - 242505*D1*Pkd2*f**2*fd*k1**2*k2*r + 755520*D1*Pkd2*f**2*fd*k1**2*k2*s**2 - 800370*D1*Pkd2*f**2*fd*k1**2*k2*s + 179685*D1*Pkd2*f**2*fd*k1**2*k2 - 372528*D1*Pkd2*f*fd*k1**2*k2*r*s + 165360*D1*Pkd2*f*fd*k1**2*k2*r - 372528*D1*Pkd2*f*fd*k1**2*k2*s**2 + 406848*D1*Pkd2*f*fd*k1**2*k2*s - 107952*D1*Pkd2*f*fd*k1**2*k2 - 475020*D1*Pkd2*f*fd*k2**3*r*s + 166920*D1*Pkd2*f*fd*k2**3*r - 372060*D1*Pkd2*f*fd*k2**3*s**2 + 440700*D1*Pkd2*f*fd*k2**3*s - 108420*D1*Pkd2*f*fd*k2**3 - 164736*D1*Pkd2*f*gd2*k1**2*k2*r*s + 51480*D1*Pkd2*f*gd2*k1**2*k2*r - 164736*D1*Pkd2*f*gd2*k1**2*k2*s**2 + 185328*D1*Pkd2*f*gd2*k1**2*k2*s - 51480*D1*Pkd2*f*gd2*k1**2*k2 - 205920*D1*Pkd2*f*gd2*k2**3*r*s + 51480*D1*Pkd2*f*gd2*k2**3*r - 205920*D1*Pkd2*f*gd2*k2**3*s**2 + 205920*D1*Pkd2*f*gd2*k2**3*s - 51480*D1*Pkd2*f*gd2*k2**3 - 329472*D1*Pkd2*fd*g2*k1**2*k2*r*s + 175032*D1*Pkd2*fd*g2*k1**2*k2*r - 329472*D1*Pkd2*fd*g2*k1**2*k2*s**2 + 350064*D1*Pkd2*fd*g2*k1**2*k2*s - 92664*D1*Pkd2*fd*g2*k1**2*k2 - 411840*D1*Pkd2*fd*g2*k2**3*r*s + 205920*D1*Pkd2*fd*g2*k2**3*r - 411840*D1*Pkd2*fd*g2*k2**3*s**2 + 411840*D1*Pkd2*fd*g2*k2**3*s - 102960*D1*Pkd2*fd*g2*k2**3 - 78*D1*bd1*f*(k1**2*(66*K - 66)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + 5*k2**2*(Pk2*f*(177*r**2 - 214*r - 177*s**2 + 70*s + 37) - 66*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*f*k2*(r*(177*s - 35) + 177*s**2 - 177*s + 35) - Pkd2*k2*(66*K - 33)*(r*(4*s - 1) + (1 - 2*s)**2))) - 3022080*Dd*Pk2*f**3*k1**2*r*s + 970020*Dd*Pk2*f**3*k1**2*r - 3022080*Dd*Pk2*f**3*k1**2*s**2 + 3201480*Dd*Pk2*f**3*k1**2*s - 718740*Dd*Pk2*f**3*k1**2 + 168480*Dd*Pk2*f**3*k2**2*r**2 + 168480*Dd*Pk2*f**3*k2**2*r*s - 133900*Dd*Pk2*f**3*k2**2*r - 29640*Dd*Pk2*f**3*k2**2*s + 11180*Dd*Pk2*f**3*k2**2 + 1986816*Dd*Pk2*f**2*k1**2*r*s - 817440*Dd*Pk2*f**2*k1**2*r + 1986816*Dd*Pk2*f**2*k1**2*s**2 - 2206464*Dd*Pk2*f**2*k1**2*s + 587808*Dd*Pk2*f**2*k1**2 - 724464*Dd*Pk2*f**2*k2**2*r**2 + 376896*Dd*Pk2*f**2*k2**2*r*s + 259272*Dd*Pk2*f**2*k2**2*r + 826800*Dd*Pk2*f**2*k2**2*s**2 - 884156*Dd*Pk2*f**2*k2**2*s + 173732*Dd*Pk2*f**2*k2**2 + 2635776*Dd*Pk2*f*g2*k1**2*r*s - 1111968*Dd*Pk2*f*g2*k1**2*r + 2635776*Dd*Pk2*f*g2*k1**2*s**2 - 2882880*Dd*Pk2*f*g2*k1**2*s + 782496*Dd*Pk2*f*g2*k1**2 - 823680*Dd*Pk2*f*g2*k2**2*r**2 + 823680*Dd*Pk2*f*g2*k2**2*r*s + 102960*Dd*Pk2*f*g2*k2**2*r + 1647360*Dd*Pk2*f*g2*k2**2*s**2 - 1441440*Dd*Pk2*f*g2*k2**2*s + 308880*Dd*Pk2*f*g2*k2**2 + 755520*Dd*Pkd2*f**3*k1**2*k2*r*s - 242505*Dd*Pkd2*f**3*k1**2*k2*r + 755520*Dd*Pkd2*f**3*k1**2*k2*s**2 - 800370*Dd*Pkd2*f**3*k1**2*k2*s + 179685*Dd*Pkd2*f**3*k1**2*k2 - 496704*Dd*Pkd2*f**2*k1**2*k2*r*s + 204360*Dd*Pkd2*f**2*k1**2*k2*r - 496704*Dd*Pkd2*f**2*k1**2*k2*s**2 + 551616*Dd*Pkd2*f**2*k1**2*k2*s - 146952*Dd*Pkd2*f**2*k1**2*k2 - 633360*Dd*Pkd2*f**2*k2**3*r*s + 196170*Dd*Pkd2*f**2*k2**3*r - 496080*Dd*Pkd2*f**2*k2**3*s**2 + 599040*Dd*Pkd2*f**2*k2**3*s - 137670*Dd*Pkd2*f**2*k2**3 - 658944*Dd*Pkd2*f*g2*k1**2*k2*r*s + 277992*Dd*Pkd2*f*g2*k1**2*k2*r - 658944*Dd*Pkd2*f*g2*k1**2*k2*s**2 + 720720*Dd*Pkd2*f*g2*k1**2*k2*s - 195624*Dd*Pkd2*f*g2*k1**2*k2 - 823680*Dd*Pkd2*f*g2*k2**3*r*s + 308880*Dd*Pkd2*f*g2*k2**3*r - 823680*Dd*Pkd2*f*g2*k2**3*s**2 + 823680*Dd*Pkd2*f*g2*k2**3*s - 205920*Dd*Pkd2*f*g2*k2**3 - 39*b1*(D1*fd*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 17) + 32*s**2 - 34*s + 9) + 5*k2**2*(6*Pk2*(f*(177*r**2 - 96*r - 177*s**2 + 129*s - 11) + (-44*r - 44*s + 22)*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1)) + Pkd2*k2*(f*(9*r*(118*s - 43) + 1062*s**2 - 1062*s + 247) + (132 - 264*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 27) + 64*s**2 - 70*s + 19) + 5*k2**2*(2*Pk2*(-132*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + f*(708*r**2 - 502*r - 708*s**2 + 457*s + 4) + 1584*r**2 + 1056*r*s - 1188*r - 528*s**2 + 132*s + 66) + Pkd2*k2*(f*(1416*r*s - 457*r + 1416*s**2 - 1416*s + 317) + (132 - 264*K)*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k3**6) - 5*D1**3*Pk3*ct**5*f*k1*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(531*s**2 - 387*s + 70) + 66*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(177*f*s - 70*f + 132*s - 66)) + f*(D1*bd1*s*(177*f*s - 70*f + 132*s - 66) + D1*fd*(318*s**2 - 256*s + 50) + 2*Dd*f*(212*s**2 - 153*s + 25)))/(231*d**2*k2*k3**2) - D1**3*Pk3*ct**5*f*k1*st**2*(D1*(5*f**2*(-39*bd1*k2**2*(-8*Pk2*(r*(354*s - 70) + 177*s**2 - 284*s + 70) + k2*(Pkd2*(708*r*s - 140*r - 177*s**2 - 358*s + 140) + Pkdd2*k2*s*(177*s - 70))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7076*s**2 - 4513*s + 686) + 52*k2**2*(Pk2*(-4*r*(801*s - 298) + 762*s - 386) + 3*Pkd2*k2*(r*(284*s - 105) - 72*s + 35)))) + 26*f*(33*bd1*(Pk2*k1**2*s*(48*K - 48)*(17*s - 10) - Pkd2*k1**2*k2*s*(18*K - 18)*(17*s - 10) + 15*Pkd2*k2**3*(K*(r*(8*s - 2) - 20*s**2 + 6*s + 2) + r*(4 - 16*s) + 2*s**2 + 7*s - 4) + Pkdd2*k2**4*s*(30*K - 15)*(2*s - 1) + 2*k2**2*(-60*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + Pkdd2*k1**2*s*(K - 1)*(17*s - 10))) + fd*k1**2*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1359*s**2 - 1203*s + 250) + fd*k2**2*(4*Pk2*(C*(r*(7125 - 16722*s) + 19080*s**2 - 14010*s + 2033) + 3*r*(8754*s - 3655) - 4770*s**2 + 630*s + 1057) + k2*(Pkd2*(4*C*(6*r*(705*s - 301) - 11925*s**2 + 9246*s - 1625) - 26460*r*s + 11064*r + 26235*s**2 - 17844*s + 2285) + Pkdd2*k2*(60*C - 45)*(159*s**2 - 128*s + 25))) - 132*gd2*(24*Pk2*k1**2*s*(17*s - 10) + 9*Pkd2*k1**2*k2*s*(10 - 17*s) - 15*Pkd2*k2**3*(-4*r*s + r + 10*s**2 - 3*s - 1) + 15*Pkdd2*k2**4*s*(2*s - 1) + k2**2*(60*Pk2*(-4*r*s + r + 4*s**2 - 1) + Pkdd2*k1**2*s*(17*s - 10)))) - 3432*fd*g2*(2*s - 1)*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(17*s - 10) + 15*k2**2*(-8*Pk2*(2*r - 2*s + 1) + k2*(Pkd2*(4*r - 10*s + 5) + Pkdd2*k2*(2*s - 1))))) + Dd*f*(5*f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(7076*s**2 - 4513*s + 686) + 52*k2**2*(Pk2*(-4*r*(801*s - 298) + 762*s - 386) + 3*Pkd2*k2*(r*(284*s - 105) - 72*s + 35))) + 26*f*(k1**2*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1812*s**2 - 1453*s + 250) + k2**2*(-8*Pk2*(C*(11148*r*s - 4456*r - 12720*s**2 + 7010*s - 123) - 17508*r*s + 6751*r + 3180*s**2 + 1645*s - 1797) + k2*(Pkd2*(4*C*(5640*r*s - 2261*r - 15900*s**2 + 10357*s - 1170) - 35280*r*s + 13634*r + 34980*s**2 - 17233*s - 285) + Pkdd2*k2*(60*C - 45)*(212*s**2 - 153*s + 25)))) - 3432*g2*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 57*s + 10) + 15*k2**2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))) + 39*b1*(D1*fd*(k1**2*(44*K - 44)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(34*s**2 - 37*s + 10) - 5*k2**2*(-24*Pk2*(f*(3*r*(118*s - 43) + 177*s**2 - 225*s + 59) + (44*s - 22)*(K*(-4*r + 4*s - 2) + 8*r + 2*s - 1)) + k2*(9*Pkd2*f*(r*(236*s - 86) - 59*s**2 - 21*s + 16) + 66*Pkd2*(2*s - 1)*(-2*K*(4*r - 10*s + 5) + 16*r - 2*s + 1) + Pkdd2*k2*(f*(531*s**2 - 387*s + 70) + (1 - 2*s)**2*(66 - 132*K))))) + Dd*f*(k1**2*(44*K - 44)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(68*s**2 - 57*s + 10) - 5*k2**2*(-8*Pk2*(f*(r*(1416*s - 457) + 708*s**2 - 959*s + 247) + 66*r*(4 - 2*K)*(8*s - 3) + 66*(2*s - 1)*(8*K*s + 4*s - 5)) + k2*(Pkd2*(-132*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) + f*(r*(2832*s - 914) - 708*s**2 - 547*s + 284) + 4224*r*s - 1584*r - 528*s**2 - 660*s + 462) + Pkdd2*k2*(4*s - 1)*(f*(177*s - 70) + (66 - 132*K)*(2*s - 1)))))))/(9009*d**2*k2*k3**4) - 4*D1**3*Pk3*ct**5*k1*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*bd1*f**2*s*(4*s - 5) + b1**2*(D1*fd*(f*(14*s**2 - 17*s + 5) + 6*(s - 1)**2) + Dd*f*(4*s - 1)*(7*f*s - 5*f + 6*s - 6)) + b1*f*(2*D1*bd1*s*(7*f*s - 5*f + 6*s - 6) + D1*fd*(8*s**2 - 14*s + 5) + Dd*f*(16*s**2 - 24*s + 5)))/(21*d**2*k2**3) - 8*D1**3*Pk3*ct**5*(13*D1*bd1*f*k1**2*(f**2*k2**2*(5*k1**2*(4*Pk2*(162*r**2 + 9*r*(28*s - 19) + 90*s**2 - 56*s - 37) + Pkd2*k2*(3*r*(48*s - 53) + 144*s**2 - 389*s + 251)) - 33*k2**2*(Pk2*(37*r**2 - 2*r*(24*s + 7) - 85*s**2 + 66*s - 5) + 10*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) + 33*f*(k1**4*(2*K - 2)*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) - 2*k1**2*k2**2*(-Pk2*(4*C*(2*r**2 + 2*r*(5*s - 1) + 8*s**2 - 5*s - 3) + K*(-19*r**2 - 115*r*s + 4*r - 96*s**2 + 26*s + 15) + 35*r**2 + 159*r*s - 74*r + 124*s**2 - 126*s + 51) - 3*Pkd2*k2*(C*(-4*s**2 + s*(2 - 4*r) + 2) + 4*K*(r*s + r + s**2 + s - 1) - 6*r*s + r - 6*s**2 + 6*s - 3)) + k2**4*(Pk2*(4*C*(6*r**2 + 70*r*s - 29*r + 16*s**2 - 52*s + 12) - 154*K*r**2 - 502*K*r*s + 262*K*r - 348*K*s**2 + 332*K*s - 108*K + 12*b1*(r + s - 1) - 55*r**2 - 101*r*s + 161*r + 50*s**2 + 134*s - 62) + 2*Pkd2*k2*(-4*C*(10*r*(2*s - 1) + 8*s**2 - 13*s + 5) + 3*K*(4*r*s + r + 4*s**2 - 1) + b1*(7*r*(4*s - 1) + 28*s**2 - 25*s + 2) + 24*r*s - 18*r - 9*s + 3))) - 132*k2**2*(-b1*k1**2*(K - 1)*(Pk2*(10*r**2 + r*(50*s - 19) + 40*s**2 - 41*s + 5) + Pkd2*k2*(r*(2 - 15*s) + s*(13 - 15*s))) + 3*b1*k2**2*(-2*Pk2*(K*(4*r*s - 3*r + 4*s**2 - 5*s + 2) + 4*r**2 + 4*r*s - 2*r - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + g2*k1**2*(2*Pk2*(5*r**2 + r*(25*s - 9) + s*(20*s - 20)) + Pkd2*k2*(r*(4 - 15*s) - s*(15*s - 15))) - 12*g2*k2**2*(-Pk2 + Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)))) + 858*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(5*K - 5)*(2*Pk2*(r**2 + r*(5*s - 2) + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + k2**2*(2*Pk2*(12*K*(r*(s - 2) + (s - 1)**2) + f*(17*r + 17*s - 12) + 12*r**2 + 12*r*(s + 1) + 12*s - 6) + Pkd2*k2*s*(f*(28*r + 28*s - 11) + (12 - 24*K)*(r + s)))) + Dd*f*(k1**2*(K - 1)*(2*Pk2*(20*r**2 + r*(100*s - 39) + 80*s**2 - 72*s + 15) + Pkd2*k2*(r*(4 - 60*s) + s*(37 - 60*s))) + k2**2*(2*Pk2*(6*K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 5*f*(4*r + 4*s - 3) + 48*r**2 + 48*r*s - 6*r + 12*s - 18) + Pkd2*k2*(f*(56*r*s - 7*r + 56*s**2 - 36*s + 2) + (6 - 12*K)*(8*r*s - r + 8*s**2 - 4*s))))) + 13*b1*k1**2*(3*D1*(f**2*fd*k2**2*(5*k1**2*(4*Pk2*(162*r**2 + 252*r*s - 103*r + 90*s**2 - 22*s - 1) + 3*Pkd2*k2*(48*r*s - 125*r + 48*s**2 - 179*s + 87)) - 11*k2**2*(Pk2*(111*r**2 - 3*r*(48*s + 23) - 255*s**2 + 121*s + 8) + 5*Pkd2*k2*(r*(30*s - 11) + 30*s**2 - 30*s + 7))) + 11*f*(4*fd*k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) - 2*fd*k1**2*k2**2*(-Pk2*(16*C*(r**2 + r*(5*s - 2) + 4*s**2 - 2*s + 1) - K*(38*r**2 + 230*r*s - 102*r + 192*s**2 - 182*s + 43) + 70*r**2 + 318*r*s - 202*r + 248*s**2 - 330*s + 87) + 6*Pkd2*k2*(4*C*s**2 - K*(4*r*s + r + 4*s**2 - 1) + r*(4*C*s + 6*s - 4) + 6*s**2 - 9*s + 2)) + fd*k2**4*(Pk2*(4*C*(12*r**2 + 4*r*(35*s - 26) + 32*s**2 - 150*s + 69) - 2*K*(154*r**2 + 502*r*s - 286*r + 348*s**2 - 360*s + 93) - 110*r**2 - 202*r*s + 254*r + 100*s**2 + 220*s - 159) + 4*Pkd2*k2*(r*(-80*C*s + 3*K*(4*s - 1) + 24*s + 12) - s**2*(32*C - 12*K) + s*(40*C - 6*K + 3) - 6)) + 4*gd2*k1**2*k2**2*(-2*Pk2*(5*r**2 + 5*r*(5*s - 2) + 20*s**2 - 21*s + 5) + Pkd2*k2*s*(15*r + 15*s - 11)) + 48*gd2*k2**4*(Pk2*(-2*r*(s - 1) - 2*s**2 + 3*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1))) + 44*fd*g2*k2**2*(-5*k1**2*(2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + 24*k2**2*(-Pk2*(r*(s - 2) + (s - 1)**2) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(10*k1**2*(4*Pk2*(324*r**2 + 504*r*s - 240*r + 180*s**2 - 61*s - 20) + Pkd2*k2*(288*r*s - 642*r + 288*s**2 - 1000*s + 517)) - 33*k2**2*(Pk2*(148*r**2 - 192*r*s - 83*r - 340*s**2 + 187*s + 3) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 33*f*(k1**4*(4*K - 4)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) - 2*k1**2*k2**2*(-Pk2*(4*C*(8*r**2 + 2*r*(20*s - 7) + 32*s**2 - 20*s + 3) - K*(76*r**2 + 460*r*s - 110*r + 384*s**2 - 234*s + 13) + 140*r**2 + 636*r*s - 342*r + 496*s**2 - 574*s + 169) - 6*Pkd2*k2*(-8*C*s**2 + C*s*(2 - 8*r) + C + K*(r*(8*s + 5) + 8*s**2 + 4*s - 5) - 12*r*s + 5*r - 12*s**2 + 15*s - 4)) + k2**4*(-8*C*Pkd2*k2*(10*r*(8*s - 1) + 32*s**2 - 48*s + 5) + Pk2*(8*C*(12*r**2 + 28*r*(5*s - 3) + 32*s**2 - 142*s + 55) - 2*K*(308*r**2 + 1004*r*s - 548*r + 696*s**2 - 692*s + 201) - 220*r**2 - 404*r*s + 584*r + 200*s**2 + 544*s - 335) + 6*Pkd2*k2*(2*K*(8*s**2 + s*(8*r - 2) - 1) + 4*r*(8*s + 1) - 4*s - 5))) + 132*g2*k2**2*(-k1**2*(2*Pk2*(20*r**2 + r*(100*s - 39) + 80*s**2 - 72*s + 15) + Pkd2*k2*(r*(4 - 60*s) + s*(37 - 60*s))) + 12*k2**2*(Pk2*(-8*r*s + 9*r - 8*s**2 + 12*s - 6) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(5*f**2*fd*k1**2*(3172*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(r*(488*s - 343) + 488*s**2 - 748*s + 267) + 13*k1**2*k2**2*(Pk2*(1788*r**2 - 3*r*(4672*s - 599) - 15804*s**2 + 14269*s - 2173) + 28*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(fd*(Pk2*k2**6*(4*C - 2)*(3*r - 1)*(129*r - 234*s - 196) + k1**6*(20*C - 20)*(4*Pk2 - Pkd2*k2)*(3*s - 23)*(3*r + 3*s - 2) + 6*k1**4*k2**2*(2*Pk2*(C*(429*r**2 - 15*r*(93*s + 68) - 2484*s**2 + 130*s + 680) - 219*r**2 + 2520*r*s + 230*r + 3069*s**2 - 1390*s - 210) + 5*Pkd2*k2*(C*(96*r*s + 78*r + 228*s**2 + 36*s - 74) - 237*r*s + 13*r - 303*s**2 + 149*s + 6)) + k1**2*k2**4*(-Pk2*(4*C*(1593*r**2 + 38196*r*s - 6204*r + 12744*s**2 - 23571*s + 4088) + 6489*r**2 - 72351*r*s + 2433*r - 31122*s**2 + 44436*s - 4847) + 60*Pkd2*k2*(C*(24*r*s + 3*r + 90*s**2 - 2*s - 13) - (3*s - 1)*(26*r + 37*s - 10)))) - 132*k1**2*(2*Pk2*bd2*k2**4*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k1**2*k2**2*(Pk2*(-19*r**2 + r*(4 - 115*s) - 96*s**2 + 26*s + 15) + 12*Pkd2*k2*(r*s + r + s**2 + s - 1)) + k2**4*(-Pk2*(77*r**2 + 251*r*s - 131*r + 174*s**2 - 166*s + 54) + 3*Pkd2*k2*(4*r*s + r + 4*s**2 - 1))))) - 1716*fd*k1**2*(2*Pk2*b2*k2**4*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7) + g2*(2*k1**4*(4*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(-Pk2*(38*r**2 + 230*r*s - 102*r + 192*s**2 - 182*s + 43) + 6*Pkd2*k2*(4*r*s + r + 4*s**2 - 1)) + k2**4*(-Pk2*(154*r**2 + 502*r*s - 286*r + 348*s**2 - 360*s + 93) + 6*Pkd2*k2*(4*r*s - r + 4*s**2 - 2*s))))) + Dd*f*(5*f**2*k1**2*(3172*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(r*(488*s - 343) + 488*s**2 - 748*s + 267) + 13*k1**2*k2**2*(Pk2*(1788*r**2 - 3*r*(4672*s - 599) - 15804*s**2 + 14269*s - 2173) + 28*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(Pk2*k2**6*(8*C - 4)*(258*r**2 - 78*r*(6*s + 7) + 184*s + 221) + k1**6*(20*C - 20)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 97) + 12*s**2 - 111*s + 74) + 6*k1**4*k2**2*(2*Pk2*(C*(572*r**2 - 2*r*(930*s + 859) - 3312*s**2 - 318*s + 1235) - 292*r**2 + 3360*r*s + 653*r + 4092*s**2 - 1477*s - 560) + 5*Pkd2*k2*(4*C*(32*r*s + 31*r + 76*s**2 + 23*s - 30) - 316*r*s - 5*r - 404*s**2 + 173*s + 24)) + k1**2*k2**4*(Pk2*(-4*C*(2124*r**2 + 50928*r*s - 6042*r + 16992*s**2 - 33332*s + 3395) - 8652*r**2 + 96468*r*s + 3422*r + 41496*s**2 - 61420*s + 1155) + 30*Pkd2*k2*(2*C*(32*r*s + 9*r + 120*s**2 + 12*s - 19) - 208*r*s + 57*r - 296*s**2 + 164*s - 25))) - 1716*k1**2*(2*Pk2*b2*k2**4*(44*r**2 + r*(88*s - 61) + 44*s**2 - 61*s + 21) + g2*(2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) + k1**2*k2**2*(-Pk2*(76*r**2 + 460*r*s - 110*r + 384*s**2 - 234*s + 13) + 6*Pkd2*k2*(8*r*s + 5*r + 8*s**2 + 4*s - 5)) + k2**4*(-Pk2*(308*r**2 + 1004*r*s - 548*r + 696*s**2 - 692*s + 201) + 6*Pkd2*k2*(8*r*s + 8*s**2 - 2*s - 1)))))))/(9009*d**2*k1*k2*k3**6) - 2*D1**3*Pk3*ct**5*(66*b1**2*k1**2*k2**2*(D1*fd*(8*Pk2*(-12*K*(s - 1)*(r - s + 1) + f*(17*s - 5) + 12*r*s - 12*r + 12*s - 6) + k2*(Pkd2*f*(25 - 85*s) + 6*Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*f*k2*(17*s - 5) + 6*Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) + Dd*f*(8*Pk2*(48*K*s**2 - 48*K*s + 5*f*(4*s - 1) - r*(6*K - 6)*(8*s - 5) + 12*s + 6) + k2*(Pkd2*(12*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) - 25*f*(4*s - 1) - 96*r*s + 60*r - 96*s + 6) + Pkdd2*k2*(4*s - 1)*(12*K*(s - 1) + 5*f + 6)))) + b1*k1**2*(D1*(f**2*(198*bd1*k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + fd*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(207*s**2 - 237*s + 56) - 33*k2**2*(6*Pk2*(r*(102*s - 77) + 370*s**2 - 294*s + 76) + k2*(-2*Pkd2*(81*r*s - 60*r + 390*s**2 - 305*s + 73) + 5*Pkdd2*k2*(15*s**2 - 11*s + 2))))) + 33*f*(fd*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5) + k2**2*(-2*Pk2*(2*C*(r*(86*s - 94) - 128*s**2 + 277*s - 81) + 16*K*(14*s**2 - 17*s + 5) + 97*r*s + 6*r + 840*s**2 - 1154*s + 300) + k2*(Pkd2*(4*C*(r*(22*s - 24) - 80*s**2 + 153*s - 50) + 20*K*(14*s**2 - 17*s + 5) + 48*r*s + 4*r + 660*s**2 - 972*s + 275) + 2*Pkdd2*k2*(4*C*(8*s**2 - 14*s + 5) - 2*K*(14*s**2 - 17*s + 5) - 40*s**2 + 66*s - 21)))) + 12*k2**2*(-8*Pk2*bd1*(K*(r*(4*s - 2) - 4*s**2 + 3*s + 1) + r*(2 - 4*s) - 1) + 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*k2*(Pkd2*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2) + Pkdd2*k2*s*(4*K*(s - 1) + 1)) - 4*gd2*k2*(Pkd2*(r*(2*s - 1) - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1)))) - 1584*fd*g2*k2**2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + Dd*f*(f**2*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 293*s + 56) - 33*k2**2*(4*Pk2*(6*r*(34*s - 29) + 740*s**2 - 551*s + 153) + k2*(-2*Pkd2*(18*r*(6*s - 5) + 520*s**2 - 376*s + 93) + 5*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 33*f*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5) + k2**2*(-2*Pk2*(4*C*(r*(86*s - 94) - 128*s**2 + 245*s - 17) + 16*K*(28*s**2 - 27*s + 5) + 194*r*s + 20*r + 1680*s**2 - 2077*s + 380) + k2*(Pkd2*(8*C*(r*(22*s - 24) - 80*s**2 + 133*s - 19) + 20*K*(28*s**2 - 27*s + 5) + 96*r*s + 12*r + 1320*s**2 - 1662*s + 315) + 2*Pkdd2*k2*(4*s - 1)*(4*C*(4*s - 5) - 2*K*(7*s - 5) - 20*s + 21)))) - 1584*g2*k2**2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1)))) + f*(D1*(bd1*f**2*k1**2*(240*Pk2*k1**2*s*(69*s - 56) - 90*Pkd2*k1**2*k2*s*(69*s - 56) + 66*Pkd2*k2**3*(3*r*(9*s - 10) + 130*s**2 - 71*s + 20) - 165*Pkdd2*k2**4*s*(5*s - 2) - 2*k2**2*(33*Pk2*(3*r*(34*s - 39) + 370*s**2 - 220*s + 78) + 5*Pkdd2*k1**2*s*(56 - 69*s))) + f*(fd*(20*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(27*s**2 - 51*s + 14) + k1**2*k2**2*(-160*C*Pk2*(207*s**2 - 237*s + 56) - 3*Pk2*(r*(4479*s - 4562) + 12552*s**2 - 7001*s + 1962) + Pkd2*k2*(100*C*(207*s**2 - 237*s + 56) + 6*r*(597*s - 595) + 9144*s**2 - 3165*s + 831) - 10*Pkdd2*k2**2*(3*s - 1)*(2*C*(69*s - 56) - 3*s + 23)) - 2*k2**4*(3*r - 1)*(Pk2*(C*(466 - 1332*s) + 135*r + 666*s - 366) + Pkd2*k2*(200*C - 100)*(3*s - 1))) + 33*k1**2*(bd1*(48*Pk2*k1**2*s*(4*s - 5) + 18*Pkd2*k1**2*k2*s*(5 - 4*s) + Pkd2*k2**3*(4*r*(C*(11*s - 12) + 6*s + 1) + s**2*(-160*C + 140*K + 330) + s*(248*C - 100*K - 347) + 44) + 2*Pkdd2*k2**4*s*(4*C*(4*s - 5) - 2*K*(7*s - 5) - 20*s + 17) - k2**2*(Pk2*(r*(4*C*(43*s - 47) + 97*s + 14) + s**2*(-256*C + 224*K + 840) + s*(512*C - 160*K - 977) + 174) + 2*Pkdd2*k1**2*s*(5 - 4*s))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-4*bd2 + 8*gd2)*(7*s - 5))) - 132*k1**2*k2**2*(b2*fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(14*s**2 - 17*s + 5) - 2*g2*(6*bd1*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) + fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(14*s**2 - 17*s + 5)))) + Dd*f*(f*(20*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(36*s**2 - 65*s + 14) + k1**2*k2**2*(-2*Pk2*(80*C*(276*s**2 - 293*s + 56) + 8958*r*s - 9584*r + 25104*s**2 - 14323*s + 5684) + k2*(Pkd2*(100*C*(276*s**2 - 293*s + 56) + 4776*r*s - 4990*r + 12192*s**2 - 4460*s + 2251) - 10*Pkdd2*k2*(4*s - 1)*(2*C*(69*s - 56) - 3*s + 23))) - 4*k2**4*(Pk2*(C*(-2664*r*s + 832*r + 1132*s - 366) + 270*r**2 + 1332*r*s - 817*r - 566*s + 316) + Pkd2*k2*(50*C - 25)*(r*(24*s - 7) - 10*s + 3))) + k1**2*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-132*b2 + 264*g2)*(28*s**2 - 27*s + 5))))/(693*d**2*k1*k2**3*k3**2) + 2*D1**3*Pk3*ct**5*(D1*(-858*b1*fd*k1**2*k2**2*(5*b1*k1**2*(K - 1)*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) + 6*b1*k2**2*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1))) - 10*g2*k1**2*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) - 24*g2*k2**2*(-4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(-2*r*s + 4*r - 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + f**3*k1**2*(13*bd1*k2**2*(-80*Pk2*k1**2*(2*r*(123*s - 70) + 246*s**2 - 335*s + 84) + 66*Pk2*k2**2*(27*r**2 + 222*r*s + 17*r + 100*s**2 - 36*s - 44) + 5*k1**2*k2*(Pkd2*(8*r*(123*s - 70) + 984*s**2 - 1457*s + 336) + 39*Pkdd2*k2*s) - 33*k2**3*(Pkd2*r*(64*s + 60) - 60*Pkd2*(s**2 - s + 1) + 5*Pkdd2*k2*s*(5*s - 2))) - 5*fd*(70*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(40*s**2 - 46*s + 9) - 13*k1**2*k2**2*(4*Pk2*(12*r*(154*s - 163) + 11940*s**2 - 8597*s + 2150) + k2*(Pkd2*(-48*r*(41*s - 42) - 16980*s**2 + 11933*s - 2684) + 84*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 52*k2**4*(Pk2*(1188*r**2 + 2*r*(15*s - 731) - 411*s + 533) + 66*Pkd2*k2*(2*r - 1)*(3*s - 1)))) - 13*f**2*k2**2*(-33*bd1*(2*k1**4*(Pk2*(-64*C*s**2 + 80*C*s + K*(r*(59*s - 87) + 424*s**2 - 339*s + 87) + r*(-32*C*s + 80*C - 171*s + 127) - 536*s**2 + 587*s - 207) + k2*(Pkd2*(K*(r*(22 - 15*s) - 136*s**2 + 91*s - 22) + r*(4*C*(2*s - 5) + 43*s - 32) + s**2*(28*C + 164) - s*(32*C + 156) + 52) + Pkdd2*k2*s*(-4*C*(s - 1) + 2*K*(5*s - 1) - 10*s + 3))) + k1**2*k2**2*(Pk2*(4*C*(20*r**2 - 117*r*s + 44*r - 64*s**2 + 168*s - 24) - 74*K*r**2 + 114*K*r*s - 182*K*r + 808*K*s**2 - 818*K*s + 256*K - 24*b1*(r + 2*s - 1) + 156*r**2 + 1075*r*s - 418*r + 320*s**2 - 703*s + 182) + k2*(Pkd2*(4*C*(69*r*s - 20*r + 40*s**2 - 80*s + 12) - 184*K*r*s + 124*K*r - 424*K*s**2 + 406*K*s - 124*K + 2*b1*(6*r - 14*s**2 + 19*s - 6) - 240*r*s + 48*r - 30*s**2 + 203*s - 56) + 2*Pkdd2*k2*s*(-16*C*(s - 1) + 10*K*s - 2*K + 7*b1*(2*s - 1) - 6)))) + fd*(k1**4*(8*Pk2*(C*(-693*r*s + 3201*r - 15624*s**2 + 15003*s - 4255) + 30*b1*(2*r*(123*s - 74) + 246*s**2 - 245*s + 97) + 2943*r*s - 5601*r + 18414*s**2 - 20253*s + 6245) + k2*(Pkd2*(4*C*(66*r*(6*s - 25) + 10647*s**2 - 8913*s + 2294) - 15*b1*(8*r*(123*s - 74) + 984*s**2 - 269*s + 220) - 6084*r*s + 11400*r - 49788*s**2 + 49212*s - 13996) + 5*Pkdd2*k2*(3*b1*(237*s - 56) - (12*s - 4)*(63*C*s - 10*C - 72*s + 24)))) + k1**2*k2**2*(-Pk2*(4*C*(1197*r**2 + 3*r*(4809*s - 5290) + 29628*s**2 - 39477*s + 13421) + 66*b1*(81*r**2 + 6*r*(111*s - 31) + 300*s**2 - 370*s + 67) + 414*r**2 + 31653*r*s + 31116*r - 43416*s**2 + 80697*s - 36010) + k2*(Pkd2*(12*C*(3165*r*s - 1924*r + 5253*s**2 - 5547*s + 1555) + 66*b1*(r*(96*s + 5) - 90*s**2 + 18*s - 8) - 5940*r*s + 8118*r - 35172*s**2 + 32193*s - 8869) + 5*Pkdd2*k2*(3*s - 1)*(-252*C*s + 40*C + 33*b1*(5*s - 2) + 258*s - 86))) + 2*k2**4*(3*r - 1)*(Pk2*(C*(-1056*r + 540*s + 1514) + 663*r - 270*s - 890) + Pkd2*k2*(200*C - 100)*(3*s - 1))) + 132*k1**2*(3*bd2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + gd2*(k1**2*(Pk2*(r*(59*s - 87) + 424*s**2 - 339*s + 87) + k2*(Pkd2*(-15*r*s + 22*r - 136*s**2 + 91*s - 22) + 2*Pkdd2*k2*s*(5*s - 1))) + k2**2*(Pk2*(-37*r**2 + r*(57*s - 91) + 404*s**2 - 409*s + 128) + k2*(Pkd2*(-92*r*s + 62*r - 212*s**2 + 203*s - 62) + 2*Pkdd2*k2*s*(5*s - 1)))))) - 429*f*k1**2*k2**2*(-4*b1**2*fd*k2**2*(-34*Pk2*(r + 2*s - 1) + k2*(Pkd2*(17*r - 7*s**2 + 34*s - 17) + 7*Pkdd2*k2*s**2)) + b1*(2*bd1*(k1**2*(K - 1)*(8*Pk2*(2*r*(5*s - 6) + 20*s**2 - 21*s + 6) + k2*(Pkd2*(-20*r*s + 24*r - 70*s**2 + 57*s - 12) + 5*Pkdd2*k2*s*(2*s - 1))) + 6*k2**2*(-2*K*(2*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s))) + 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-8*r*s + 2*s**2 - 3*s + 2) + Pkdd2*k2**2*s*(1 - 2*s))) + 2*fd*k1**2*(2*Pk2*(32*C*(r*(s - 2) + 2*s**2 - 3*s + 2) + K*(-59*r*s + 79*r - 424*s**2 + 476*s - 132) + 171*r*s - 135*r + 536*s**2 - 652*s + 160) + k2*(Pkd2*(-8*C*(2*r*(s - 2) + 7*s**2 - 6*s + 4) + K*(30*r*s - 40*r + 272*s**2 - 280*s + 72) - 86*r*s + 68*r - 328*s**2 + 410*s - 101) + Pkdd2*k2*(-2*K*(10*s**2 - 7*s + 1) + s**2*(8*C + 20) - 28*s + 7))) + fd*k2**2*(-2*Pk2*(C*(80*r**2 + r*(296 - 468*s) - 256*s**2 + 874*s - 376) - 2*K*(37*r**2 - 57*r*s + 65*r - 404*s**2 + 428*s - 113) + 156*r**2 + 1075*r*s - 654*r + 320*s**2 - 794*s + 320) + k2*(Pkd2*(-4*C*(2*r*(69*s - 40) + 80*s**2 - 205*s + 80) + K*(368*r*s - 256*r + 848*s**2 - 884*s + 230) + 480*r*s - 316*r + 60*s**2 - 432*s + 187) - 4*Pkdd2*k2*(-16*C*s**2 + 10*K*s**2 - 7*K*s + K + 12*s - 3))) - 4*gd2*k1**2*(8*Pk2*(r*(5*s - 6) + 10*s**2 - 11*s + 6) + k2*(Pkd2*(-10*r*s + 12*r - 35*s**2 + 22*s - 12) + 5*Pkdd2*k2*s**2)) - 48*gd2*k2**2*(2*Pk2*(-2*r**2 + r + (1 - 2*s)**2) + k2*(Pkd2*(-2*r*s + 2*r - 5*s**2 + 5*s - 2) + Pkdd2*k2*s**2))) + 4*bd1*g2*(k1**2*(-8*Pk2*(r*(5*s - 6) + s*(10*s - 10)) + k2*(2*Pkd2*r*(5*s - 6) + 35*Pkd2*s*(s - 1) - 5*Pkdd2*k2*s*(s - 1))) - 12*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))) + 4*fd*(6*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4) + 2*g2*k1**2*(Pk2*(r*(59*s - 79) + 424*s**2 - 476*s + 132) + k2*(-5*Pkd2*r*(3*s - 4) - 4*Pkd2*(34*s**2 - 35*s + 9) + Pkdd2*k2*(10*s**2 - 7*s + 1))) + g2*k2**2*(-2*Pk2*(37*r**2 + r*(65 - 57*s) - 404*s**2 + 428*s - 113) + k2*(Pkd2*(-184*r*s + 128*r - 424*s**2 + 442*s - 115) + 2*Pkdd2*k2*(10*s**2 - 7*s + 1)))))) + Dd*f*(-858*b1*k1**2*k2**2*(b1*k1**2*(K - 1)*(8*Pk2*(r*(20*s - 23) + 40*s**2 - 42*s + 17) + k2*(Pkd2*(-40*r*s + 46*r - 140*s**2 + 99*s - 34) + 5*Pkdd2*k2*s*(4*s - 1))) + 6*b1*k2**2*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) + 2*g2*k1**2*(-8*Pk2*(r*(20*s - 23) + 40*s**2 - 42*s + 17) + k2*(Pkd2*(40*r*s - 46*r + 140*s**2 - 99*s + 34) + 5*Pkdd2*k2*s*(1 - 4*s))) - 24*g2*k2**2*(-4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(-8*r*s + 9*r - 20*s**2 + 23*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 5*f**3*k1**2*(70*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(40*s**2 - 46*s + 9) - 13*k1**2*k2**2*(4*Pk2*(12*r*(154*s - 163) + 11940*s**2 - 8597*s + 2150) + k2*(Pkd2*(-48*r*(41*s - 42) - 16980*s**2 + 11933*s - 2684) + 84*Pkdd2*k2*(20*s**2 - 13*s + 2))) - 52*k2**4*(Pk2*(1188*r**2 + 2*r*(15*s - 731) - 411*s + 533) + 66*Pkd2*k2*(2*r - 1)*(3*s - 1))) - 13*f**2*k2**2*(4*k1**4*(4*Pk2*(C*(-66*r*(7*s - 34) - 10416*s**2 + 9431*s - 2771) + 5*b1*(8*r*(123*s - 73) + 984*s**2 - 1070*s + 375) + 6*r*(327*s - 644) + 12276*s**2 - 13066*s + 4186) + k2*(Pkd2*(C*(66*r*(8*s - 35) + 14196*s**2 - 11009*s + 2954) - 5*b1*(8*r*(123*s - 73) + 984*s**2 - 566*s + 249) - 2028*r*s + 3930*r - 16596*s**2 + 15619*s - 4579) + 5*Pkdd2*k2*(4*s - 1)*(C*(10 - 63*s) + 42*b1 + 72*s - 24))) + k1**2*k2**2*(-2*Pk2*(4*C*(798*r**2 + 9618*r*s - 10997*r + 19752*s**2 - 26843*s + 9573) + 33*b1*(108*r**2 + r*(888*s - 169) + 400*s**2 - 406*s + 23) + 276*r**2 + 21102*r*s + 24000*r - 28944*s**2 + 54473*s - 26516) + k2*(Pkd2*(4*C*(12660*r*s - 7636*r + 21012*s**2 - 22427*s + 6529) + 66*b1*(r*(128*s + 35) - 120*s**2 + 48*s - 38) - 7920*r*s + 11814*r - 46896*s**2 + 42316*s - 12565) + 5*Pkdd2*k2*(4*s - 1)*(-252*C*s + 40*C + 33*b1*(5*s - 2) + 258*s - 86))) + 4*k2**4*(Pk2*(-2*C*(1056*r**2 - 4*r*(135*s + 523) + 170*s + 807) + 1326*r**2 - 9*r*(60*s + 277) + 170*s + 940) + Pkd2*k2*(50*C - 25)*(r*(24*s - 7) - 10*s + 3))) + 429*f*k1**2*k2**2*(2*b1**2*k2**2*(-80*Pk2*(r + 2*s - 1) + k2*(Pkd2*(40*r - 28*s**2 + 87*s - 40) + 7*Pkdd2*k2*s*(4*s - 1))) + b1*(-2*k1**2*(2*Pk2*(8*C*(2*r*(4*s - 9) + 16*s**2 - 24*s + 13) + K*(-118*r*s + 166*r - 848*s**2 + 815*s - 219) + 342*r*s - 262*r + 1072*s**2 - 1223*s + 327) + k2*(Pkd2*(-4*C*(2*r*(4*s - 9) + 28*s**2 - 27*s + 13) + 2*K*(6*r*(5*s - 7) + 272*s**2 - 231*s + 58) - 172*r*s + 132*r - 656*s**2 + 726*s - 185) + Pkdd2*k2*(4*s - 1)*(K*(2 - 10*s) + s*(4*C + 10) - 7))) + k2**2*(2*Pk2*(4*C*(40*r**2 - 18*r*(13*s - 6) - 128*s**2 + 405*s - 128) - 2*K*(74*r**2 - 114*r*s + 156*r - 808*s**2 + 837*s - 241) + 312*r**2 + 2150*r*s - 1048*r + 640*s**2 - 1523*s + 518) + k2*(Pkd2*(8*C*(6*r*(23*s - 10) + 80*s**2 - 193*s + 56) - 2*K*(4*r*(92*s - 63) + 848*s**2 - 848*s + 239) - 960*r*s + 428*r - 120*s**2 + 882*s - 307) - 4*Pkdd2*k2*(4*s - 1)*(8*C*s - 5*K*s + K - 3)))) - 72*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) - 8*g2*k1**2*(Pk2*(2*r*(59*s - 83) + 848*s**2 - 815*s + 219) + k2*(Pkd2*(-30*r*s + 42*r - 272*s**2 + 231*s - 58) + Pkdd2*k2*(20*s**2 - 9*s + 1))) - 4*g2*k2**2*(-2*Pk2*(74*r**2 - 6*r*(19*s - 26) - 808*s**2 + 837*s - 241) + k2*(Pkd2*(-368*r*s + 252*r - 848*s**2 + 848*s - 239) + 2*Pkdd2*k2*(20*s**2 - 9*s + 1))))))/(9009*d**2*k1*k2**3*k3**4) + 80*D1**3*Pk3*ct**4*f**2*k1**2*k2**2*st**4*(-4*Pk2 + Pkd2*k2)*(D1*fd*(156*C*(3*s - 1)*(3*r + 3*s - 2) + 7*f*(536*r*s - 147*r + 536*s**2 - 536*s + 107) + (156 - 468*s)*(3*r + 3*s - 2)) + Dd*f*(78*C*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 7*f*(536*r*s - 147*r + 536*s**2 - 536*s + 107) - 1872*r*s + 546*r - 1872*s**2 + 1872*s - 390))/(3003*d**2*k3**6) - 20*D1**3*Pk3*ct**4*f**2*k1**2*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd*(78*C*(1 - 3*s)**2 + 7*f*(268*s**2 - 147*s + 20) - 78*(1 - 3*s)**2) + Dd*f*(4*s - 1)*(78*C*(3*s - 1) + 7*f*(67*s - 20) - 234*s + 78))/(3003*d**2*k3**4) - 4*D1**3*Pk3*ct**4*st**2*(39*D1*bd1*f*(f**2*k2**2*(44*Pk2*k2**2*(r - 1)*(10*r + 10*s - 3) + 5*k1**2*(2*Pk2*(453*r**2 + 347*r*s - 594*r - 106*s**2 - 97*s + 91) + Pkd2*k2*(559*r*s - 94*r + 559*s**2 - 591*s + 144))) + 22*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(Pk2*(12*C*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 10*s + 1) + K*(-213*r**2 - 23*r*s + 183*r + 190*s**2 - 178*s + 30) + 301*r**2 + 319*r*s - 363*r + 18*s**2 - 110*s + 86) - 6*Pkd2*k2*(C*(r*(6*s - 3) + 6*s**2 - 7*s + 1) + K*(28*r*s - 9*r + 28*s**2 - 32*s + 9) - 18*r*s + 7*r - 18*s**2 + 21*s - 5)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 132*k1**2*k2**2*(-b1*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 5148*b1**2*k1**2*k2**2*(K - 1)*(2*D1*fd*(Pk2*(r**2 + 4*r*s - 2*r + 3*s**2 - 2*s + 1) - Pkd2*k2*s*(r + s)) + Dd*f*(2*Pk2*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 39*b1*(D1*(f**2*fd*k2**2*(22*Pk2*k2**2*(60*r**2 + r*(60*s - 23) + 10*s - 9) + 5*k1**2*(Pk2*(2718*r**2 + 6*r*(347*s - 370) - 636*s**2 + 82*s + 350) + Pkd2*k2*(r*(1677*s - 925) + 1677*s**2 - 2076*s + 613))) + 22*f*(fd*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(12*C*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 17*s + 6) + K*(-426*r**2 - 46*r*s + 22*r + 380*s**2 - 428*s + 119) + 602*r**2 + 638*r*s - 342*r + 36*s**2 - 36*s - 15) - 6*Pkd2*k2*(12*C*s**2 - 5*C*s + 2*K*(r*(28*s - 15) + 28*s**2 - 30*s + 8) + r*(s*(12*C - 36) + 13) - 36*s**2 + 31*s - 7)) - 30*k2**4*(2*r + 2*s - 1)*(K*Pk2*(6*r + 2*s - 1) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 12*gd2*k1**2*k2**2*(-2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(2*r + 2*s - 1))) + 528*fd*g2*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(22*Pk2*k2**2*(80*r**2 + r*(80*s - 49) - 10*s - 3) + 5*k1**2*(4*Pk2*(906*r**2 + 694*r*s - 852*r - 212*s**2 - 28*s + 133) + Pkd2*k2*(2236*r*s - 1019*r + 2236*s**2 - 2667*s + 757))) + 22*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + k1**2*k2**2*(Pk2*(12*C*(12*r**2 + 24*r*(2*s - 1) + 36*s**2 - 37*s + 10) + K*(-852*r**2 - 92*r*s + 388*r + 760*s**2 - 784*s + 179) + 1204*r**2 + 1276*r*s - 1068*r + 72*s**2 - 256*s + 133) - 6*Pkd2*k2*(3*C*r*(8*s - 1) + 24*C*s**2 - 16*C*s + C + 2*K*(8*r*(7*s - 3) + 56*s**2 - 62*s + 17) - 72*r*s + 24*r - 72*s**2 + 70*s - 16)) - 30*k2**4*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1))) + 264*g2*k1**2*k2**2*(-2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(8156*s - 2949) + 24468*s**2 - 27653*s + 6749) + 26*k2**2*(-Pk2*(13980*r**2 + 3*r*(20300*s - 8023) + 46920*s**2 - 46610*s + 9647) + 375*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 52*f*(-495*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(9*C - 9)*(4*Pk2 - Pkd2*k2)*(r*(372*s - 179) + 372*s**2 - 438*s + 123) + k1**2*k2**2*(Pk2*(C*(-12681*r**2 + 3*r*(3843*s + 107) + 13914*s**2 - 23316*s + 6247) + 17127*r**2 + 3*r*(3225*s - 3363) - 2304*s**2 + 6198*s - 1425) - 3*Pkd2*k2*(4*C*(5*r*(285*s - 106) + 996*s**2 - 1414*s + 379) - 57*r*(64*s - 25) - 2790*s**2 + 3736*s - 1005)) + k2**4*(-2*C*Pk2*(5679*r**2 + 144*r*(100*s - 39) + 2385*s**2 - 7248*s + 1792) + 3*Pk2*(2442*r**2 + r*(5349*s - 2113) + 795*s**2 - 2357*s + 536) + Pkd2*k2*(15 - 30*C)*(3*s - 1)*(75*r + 53*s - 50))) - 33*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(Pk2*(-213*r**2 - 23*r*s + 183*r + 190*s**2 - 178*s + 30) - 6*Pkd2*k2*(r*(28*s - 9) + 28*s**2 - 32*s + 9)) - 15*k2**4*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 1716*fd*(15*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(-426*r**2 + r*(22 - 46*s) + 380*s**2 - 428*s + 119) - 12*Pkd2*k2*(r*(28*s - 15) + 28*s**2 - 30*s + 8)) - 30*k2**4*(Pk2*(6*r + 2*s - 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-25740*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(8156*s - 2949) + 24468*s**2 - 27653*s + 6749) + 26*k2**2*(-Pk2*(13980*r**2 + 3*r*(20300*s - 8023) + 46920*s**2 - 46610*s + 9647) + 375*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(r*(496*s - 229) + 496*s**2 - 606*s + 173) - 2*k1**2*k2**2*(Pk2*(C*(16908*r**2 - 2*r*(7686*s + 1693) - 18552*s**2 + 31824*s - 7409) - 22836*r**2 - 12900*r*s + 16264*r + 3072*s**2 - 7846*s + 959) + 6*Pkd2*k2*(C*(3800*r*s - 1277*r + 2656*s**2 - 3910*s + 975) - 2432*r*s + 867*r - 1860*s**2 + 2575*s - 657)) + k2**4*(Pk2*(-4*C*(7572*r**2 + 48*r*(400*s - 167) + 3180*s**2 - 11131*s + 2299) + 19536*r**2 + 3*r*(14264*s - 6221) + 6360*s**2 - 22464*s + 4317) + Pkd2*k2*(15 - 30*C)*(25*r*(24*s - 7) + 424*s**2 - 556*s + 125))) - 1716*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + k1**2*k2**2*(Pk2*(-852*r**2 + r*(388 - 92*s) + 760*s**2 - 784*s + 179) - 12*Pkd2*k2*(8*r*(7*s - 3) + 56*s**2 - 62*s + 17)) - 30*k2**4*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(9009*d**2*k3**6) + D1**3*Pk3*ct**4*(4*D1*bd1*f*(f*(Pk2*(r*(11*s - 27) + 4*s*(4*C*(4*s - 5) - 8*s + 21)) + k2*(Pkd2*r*(7 - 3*s) + 2*Pkd2*s*(-20*C*s + 25*C + 10*s - 18) + Pkdd2*k2*s*(2*C - 1)*(4*s - 5))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*b2 - 12*g2)*(s - 1)) + b1**2*(D1*fd*(f*(Pk2*(r*(90*s - 92) + 51*s - 2) - 12*Pkd2*k2*(2*r*(s - 1) + s)) + (s - 1)*(24*K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + 192*Pk2*r - 48*Pkd2*k2*r)) + 2*Dd*f*(Pk2*(96*K*(4*s**2 - 5*s + 1) + f*(10*r*(9*s - 14) + 51*s + 46) + 384*r*s - 240*r - 96*s + 96) - 12*k2*(K*Pkdd2*k2*(-4*s**2 + 5*s - 1) + Pkd2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2)))) + b1*(D1*bd1*f*(48*K*Pkdd2*k2**2*s*(s - 1) + Pk2*f*(2*r*(45*s - 94) + 51*s + 94) + 96*Pk2*(r*(4*s - 2) + (s - 1)*(4*K*s - 1)) - 12*Pkd2*k2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1))) + 4*D1*(f*(fd*(Pk2*(16*C*(8*s**2 - 14*s + 5) + 22*r*s - 38*r - 64*s**2 + 173*s - 57) + k2*(Pkd2*(-10*C*(8*s**2 - 14*s + 5) - 6*r*s + 10*r + 40*s**2 - 85*s + 29) + Pkdd2*k2*(2*C - 1)*(8*s**2 - 14*s + 5))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*bd2 - 12*gd2)*(s - 1)) - 12*fd*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 4*Dd*f*(f*(2*Pk2*(8*C*(16*s**2 - 24*s + 5) + r*(22*s - 46) - 64*s**2 + 157*s - 15) + k2*(-2*Pkd2*(5*C*(16*s**2 - 24*s + 5) + 6*r*(s - 2) - 40*s**2 + 75*s - 11) + Pkdd2*k2*(2*C - 1)*(16*s**2 - 24*s + 5))) - 12*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 24*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(21*d**2*k2**2) - D1**3*Pk3*ct**4*st**2*(396*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 3*b1*(D1*(f**2*fd*(30*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(159*s**2 - 128*s + 25) + 11*k2**2*(Pk2*(r*(234 - 525*s) - 65*s + 2) + 15*Pkd2*k2*(r*(9*s - 4) + s))) + 22*f*(fd*(2*s - 1)*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(C*(9*s - 6) + 8*s - 4) - 15*k2**2*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + r*(16*Pk2 - 4*Pkd2*k2))) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(12*K*bd1 - 12*bd1 - 12*gd2)) - 264*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f**2*(15*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(212*s**2 - 153*s + 25) + 11*k2**2*(Pk2*(r*(176 - 350*s) + 55*s - 58) + 15*Pkd2*k2*(r*(6*s - 3) - s + 1))) + 11*f*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(C*(9*s - 6) + 8*s - 4) - 15*k2**2*(8*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-5*K*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 4*s - 2)))) - 132*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) + f*(D1*(-990*b2*fd*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 3*bd1*f**2*(720*Pk2*k1**2*s*(53*s - 25) - 270*Pkd2*k1**2*k2*s*(53*s - 25) + 165*Pkd2*k2**3*(r - 1)*(3*s - 2) + k2**2*(-11*Pk2*(r - 1)*(175*s - 118) + 30*Pkdd2*k1**2*s*(53*s - 25))) - 792*bd1*g2*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 2*f*(33*bd1*(15*K*Pkdd2*k2**4*s*(1 - 2*s) + 48*Pk2*k1**2*s*(C*(9*s - 6) + 8*s - 4) - 18*Pkd2*k1**2*k2*s*(C*(9*s - 6) + 8*s - 4) + 15*Pkd2*k2**3*(r*(4*s - 1) + (2*s - 1)*(5*K*s - 1)) - 2*k2**2*(30*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*s*(C*(6 - 9*s) - 8*s + 4))) + 2*fd*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1359*s**2 - 1203*s + 250) + fd*k2**2*(-2*Pk2*(120*C*(159*s**2 - 128*s + 25) + 9*r*(798*s - 365) - 9540*s**2 + 8190*s - 1373) + k2*(Pkd2*(150*C*(159*s**2 - 128*s + 25) + 18*r*(205*s - 94) - 11925*s**2 + 9822*s - 1795) + Pkdd2*k2*(15 - 30*C)*(159*s**2 - 128*s + 25))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-495*bd2 + 990*gd2)*(2*s - 1)) + 1980*fd*g2*k2**2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))) + 2*Dd*f*(f*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1812*s**2 - 1453*s + 250) + k2**2*(-4*Pk2*(60*C*(212*s**2 - 153*s + 25) + 4788*r*s - 2161*r - 6360*s**2 + 4190*s - 168) + k2*(Pkd2*(150*C*(212*s**2 - 153*s + 25) + 4920*r*s - 2227*r - 15900*s**2 + 11009*s - 1260) + Pkdd2*k2*(15 - 30*C)*(212*s**2 - 153*s + 25)))) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-495*b2 + 990*g2)*(8*s**2 - 6*s + 1))))/(693*d**2*k2**2*k3**2) + D1**3*Pk3*ct**4*st**2*(-5148*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2)) + Dd*f*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))) - 39*b1*(D1*(-f**2*fd*k2**2*(-10*k1**2*(4*Pk2*(r*(2313*s - 925) + 1677*s**2 - 1944*s + 563) - k2*(Pkd2*(2313*r*s - 925*r + 723*s**2 - 792*s + 338) + 3*Pkdd2*k2*(106*s**2 - 128*s + 25))) + 11*k2**2*(Pk2*(3*r - 1)*(80*r - 15*s + 38) + 15*Pkd2*k2*(9*r*s - 4*r + s))) + 22*f*(fd*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2) + k1**2*k2**2*(2*Pk2*(24*C*(r*(12*s - 7) + 18*s**2 - 19*s + 7) + K*(-583*r*s + 330*r - 136*s**2 + 88*s - 10) + 1063*r*s - 570*r + 744*s**2 - 744*s + 138) + k2*(-Pkd2*(12*C*(r*(12*s - 7) + 27*s**2 - 19*s + 7) + K*(-284*r*s + 160*r + 268*s**2 - 328*s + 97) + 524*r*s - 280*r + 132*s**2 - 222*s + 27) + 2*Pkdd2*k2*(K*(56*s**2 - 62*s + 17) + s**2*(18*C - 40) + 25*s - 7))) + 15*k2**4*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2)))) + 6*k1**2*k2**2*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2)))) - 264*fd*g2*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + 2*Dd*f*(f**2*k2**2*(5*k1**2*(4*Pk2*(3*r*(1028*s - 375) + 2236*s**2 - 2703*s + 713) - k2*(Pkd2*(3084*r*s - 1125*r + 964*s**2 - 1485*s + 488) + Pkdd2*k2*(424*s**2 - 406*s + 75))) - 11*k2**2*(Pk2*(2*r - 1)*(80*r - 15*s + 38) + 15*Pkd2*k2*(6*r*s - 3*r - s + 1))) + 11*f*(k1**4*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2) + k1**2*k2**2*(2*Pk2*(24*C*(r*(24*s - 11) + 36*s**2 - 35*s + 9) + K*(-1166*r*s + 548*r - 272*s**2 + 467*s - 228) + 2126*r*s - 932*r + 1488*s**2 - 1763*s + 548) + k2*(Pkd2*(-6*C*(r*(48*s - 22) + 108*s**2 - 79*s + 18) + K*(8*r*(71*s - 33) - 536*s**2 + 350*s + 7) - 1048*r*s + 456*r - 264*s**2 + 586*s - 227) + 2*Pkdd2*k2*(4*s - 1)*(K*(28*s - 17) + s*(9*C - 20) + 7))) + 15*k2**4*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1))) - 132*g2*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1))))) + f*(D1*(10296*bd1*g2*k1**2*k2**2*(8*Pk2*(r*(2*s - 1) + s*(3*s - 3)) + k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + f**2*(51480*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 390*bd1*k1**2*k2**2*(4*Pk2*(r*(771*s - 200) + 559*s**2 - 759*s + 150) + k2*(Pkd2*(-771*r*s + 200*r - 241*s**2 + 693*s - 150) + 2*Pkdd2*k2*s*(11 - 53*s))) + 429*bd1*k2**4*(r - 1)*(Pk2*(80*r - 15*s + 38) + 15*Pkd2*k2*(3*s - 2)) - 150*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1312*s**2 - 916*s + 147) + 26*fd*k1**2*k2**2*(Pk2*(18*r*(4555*s - 2128) + 151680*s**2 - 113035*s + 27682) + 5*k2*(-81*Pkd2*r*(54*s - 25) - 4*Pkd2*(2571*s**2 - 1841*s + 416) + 75*Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 26*f*(33*bd1*(k1**4*s*(3*K - 3)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 2) + k1**2*k2**2*(Pk2*(432*C*s**2 - 384*C*s + K*(r*(218 - 583*s) - 136*s**2 + 379*s - 218) + r*(96*C*(3*s - 1) + 1063*s - 362) + 744*s**2 - 1019*s + 458) + k2*(Pkd2*(-162*C*s**2 + 150*C*s + K*(2*r*(71*s - 26) - 134*s**2 + 11*s + 52) + r*(-72*C*s + 24*C - 262*s + 88) - 66*s**2 + 155*s - 112) + 2*Pkdd2*k2*s*(9*C*(s - 1) + K*(28*s - 17) - 20*s + 16))) + 15*k2**4*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1))) + 990*bd2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(k1**4*(12*C - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(126*s**2 - 117*s + 25) + 2*k1**2*k2**2*(Pk2*(C*(r*(20886 - 42165*s) - 5976*s**2 + 7611*s - 4150) + 9*r*(7869*s - 3734) + 45504*s**2 - 48531*s + 14454) + k2*(Pkd2*(C*(6*r*(1794*s - 895) - 11250*s**2 + 9489*s - 1319) - 18*r*(996*s - 475) - 2709*s**2 + 4350*s - 2007) + Pkdd2*k2*(3*s - 1)*(2*C*(708*s - 401) - 963*s + 552))) + k2**4*(2*Pk2*(2*C*(963*r**2 - 84*r*(357*s - 131) - 9540*s**2 + 18732*s - 5627) - 5220*r**2 + 30582*r*s - 12291*r + 9540*s**2 - 18930*s + 6529) + k2*(2*C*Pkd2*(3*s - 1)*(9864*r + 2385*s - 4765) - 3*Pkd2*(6*r*(1849*s - 642) + 2385*s**2 - 5486*s + 1615) + Pkdd2*k2*(30*C - 15)*(159*s**2 - 128*s + 25)))) + 66*gd2*(-3*k1**4*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 2) + k1**2*k2**2*(Pk2*(r*(583*s - 218) + 136*s**2 - 379*s + 218) + k2*(Pkd2*(-142*r*s + 52*r + 134*s**2 - 11*s - 52) + 2*Pkdd2*k2*s*(17 - 28*s))) - 15*k2**4*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 1716*fd*(-30*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2) + k1**2*k2**2*(-2*Pk2*(583*r*s - 330*r + 136*s**2 - 88*s + 10) + k2*(Pkd2*(4*r*(71*s - 40) - 268*s**2 + 328*s - 97) + 2*Pkdd2*k2*(56*s**2 - 62*s + 17))) + 15*k2**4*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1)))))) - 2*Dd*f*(25740*b2*k2**4*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + f**2*(-25740*Pk2*k2**4*(2*r**2 - 3*r + 1) + 75*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1312*s**2 - 916*s + 147) - 13*k1**2*k2**2*(Pk2*(18*r*(4555*s - 2128) + 151680*s**2 - 113035*s + 27682) + 5*k2*(-81*Pkd2*r*(54*s - 25) - 4*Pkd2*(2571*s**2 - 1841*s + 416) + 75*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 13*f*(k1**4*(12*C - 12)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(168*s**2 - 142*s + 25) + 2*k1**2*k2**2*(-2*Pk2*(C*(28110*r*s - 13520*r + 3984*s**2 - 8619*s + 5152) - 47214*r*s + 21380*r - 30336*s**2 + 35647*s - 11804) + k2*(Pkd2*(C*(14352*r*s - 6958*r - 15000*s**2 + 9414*s + 269) - 23904*r*s + 10888*r - 3612*s**2 + 8459*s - 4345) + Pkdd2*k2*(4*s - 1)*(2*C*(708*s - 401) - 963*s + 552))) + k2**4*(4*Pk2*(2*C*(642*r**2 - 19992*r*s + 6495*r - 6360*s**2 + 13822*s - 3967) - 3480*r**2 + 20388*r*s - 6880*r + 6360*s**2 - 14020*s + 4869) + k2*(2*C*Pkd2*(4*r*(9864*s - 2921) + 9540*s**2 - 25085*s + 6585) - 3*Pkd2*(r*(14792*s - 4637) + 3180*s**2 - 8517*s + 2400) + Pkdd2*k2*(30*C - 15)*(212*s**2 - 153*s + 25)))) - 858*g2*(3*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2) + k1**2*k2**2*(-2*Pk2*(2*r*(583*s - 274) + 272*s**2 - 467*s + 228) + k2*(Pkd2*(8*r*(71*s - 33) - 536*s**2 + 350*s + 7) + 2*Pkdd2*k2*(112*s**2 - 96*s + 17))) + 15*k2**4*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(9009*d**2*k2**2*k3**4) + 4*D1**3*Pk3*ct**4*(D1*(858*b1*fd*k2**2*(24*Pk2*b2*k2**4*(r + s)**2 + b1*(k1**4*(2*K - 2)*(2*Pk2*(r**2 + r*(s - 2) - 2*s + 1) + Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(8*C*(r + s - 1)**2 + K*(41*r**2 + 98*r*s + 24*r + 57*s**2 + 24*s - 12) - 109*r**2 - 234*r*s + 32*r - 125*s**2 + 32*s - 16) + Pkd2*k2*s*(32*K - 2)*(r + s)) + 24*k2**4*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s))) - 2*g2*(2*k1**4*(2*Pk2*(r**2 + r*(s - 2) - 2*s + 1) + Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(41*r**2 + 98*r*s + 24*r + 57*s**2 + 24*s - 12) + 32*Pkd2*k2*s*(r + s)) + 24*k2**4*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + f**3*(13*bd1*k2**2*(363*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 20*k1**4*(Pk2*(12*r**2 - 120*r*s - 199*r - 132*s**2 - 101*s + 193) + Pkd2*k2*(72*r*s + 103*r + 72*s**2 + 54*s - 106)) + 33*k1**2*k2**2*(Pk2*(460*r**2 + 506*r*s - 591*r + 46*s**2 - 313*s + 129) + 10*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) - 10*fd*k1**2*(793*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 19)*(4*r + 4*s - 3) + 13*k1**2*k2**2*(Pk2*(4358*r**2 - 2*r*(3839*s + 700) - 12036*s**2 + 11302*s - 1503) + 28*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) + 13*f**2*k2**2*(1584*Pk2*bd2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(r + s - 1) + 33*bd1*(2*k1**4*(Pk2*(8*C*(2*r**2 + 2*r*(5*s - 4) + 8*s**2 - 11*s + 3) + K*(-22*r**2 + 71*r*s + 10*r + 93*s**2 - 117*s + 12) + 14*r**2 - 143*r*s + 74*r - 157*s**2 + 237*s - 64) - 2*Pkd2*k2*(6*C*(s - 1)*(2*r + 2*s - 1) + K*(26*r*s - 8*r + 26*s**2 - 32*s + 8) - 40*r*s + 25*r - 40*s**2 + 58*s - 19)) - 2*k1**2*k2**2*(Pk2*(2*C*(25*r**2 + 218*r*s - 75*r - 47*s**2 - 153*s + 80) + 179*K*r**2 - 7*K*r*s - 169*K*r - 186*K*s**2 + 122*K*s - 10*K + 4*b1*(16*r**2 + r*(32*s - 21) + 16*s**2 - 21*s + 5) - 375*r**2 - 611*r*s + 619*r + 4*s**2 + 444*s - 304) + 2*Pkd2*k2*(-24*C*(r*(3*s - 1) - s + 1) - 3*K*(-26*r*s + 7*r - 26*s**2 + 28*s - 7) + 2*b1*(r*(29*s - 5) + 29*s**2 - 26*s + 1) - 18*r*s + 12*r - 54*s**2 + 57*s - 9)) + k2**4*(-Pk2*(-16*C*(2*r**2 + 47*r*s - 18*r + 8*s**2 - 19*s + 17) + 270*K*r**2 + 330*K*r*s - 370*K*r + 60*K*s**2 - 252*K*s + 100*K + b1*(18*r**2 + r*(18*s + 41) + 15*s - 37) - 72*r**2 + 288*r*s + 36*r + 64*s**2 - 60*s + 68) + 4*Pkd2*k2*(2*C*(10*r*(2*s - 1) + 8*s**2 - 13*s + 5) - 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 10*r - 8*s**2 + 13*s - 5))) + fd*(4*k1**4*(Pk2*(C*(-3960*r**2 + 27*r*(47*s + 109) + 5229*s**2 - 5658*s + 623) + 15*b1*(12*r**2 - 3*r*(40*s + 61) - 132*s**2 - 109*s + 123) + 4770*r**2 + 261*r*s - 3003*r - 4509*s**2 + 5658*s - 943) + 5*Pkd2*k2*(-2*C*(477*r*s - 192*r + 477*s**2 - 543*s + 139) + b1*(3*r*(72*s + 103) + 216*s**2 + 198*s - 217) + 963*r*s - 453*r + 963*s**2 - 1161*s + 324)) + 3*k1**2*k2**2*(11*Pk2*b1*(1380*r**2 + 3*r*(506*s - 453) + 138*s**2 - 605*s + 351) + 4*Pk2*(C*(-8943*r**2 + r*(7653*s + 6139) + 2538*s**2 - 8610*s + 685) + 10209*r**2 + 7*r*(573*s - 1333) + 831*s**2 + 573*s + 1247) + 110*Pkd2*b1*k2*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) - 20*Pkd2*k2*(C*(r*(906*s - 368) + 906*s**2 - 950*s + 238) + r*(316 - 717*s) - 717*s**2 + 783*s - 207)) + 3*k2**4*(Pk2*(-4*C*(5097*r**2 + 1929*r*s - 4987*r + 1122*s**2 - 720*s + 997) + 121*b1*(3*r - 1)*(5*r + 5*s - 3) + 13098*r**2 + 6762*r*s - 12174*r + 2244*s**2 - 1968*s + 2258) + Pkd2*k2*(220 - 440*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + 132*gd2*(k1**4*(Pk2*(22*r**2 - 71*r*s - 10*r - 93*s**2 + 117*s - 12) + 4*Pkd2*k2*(13*r*s - 4*r + 13*s**2 - 16*s + 4)) + k1**2*k2**2*(Pk2*(179*r**2 - 7*r*s - 169*r - 186*s**2 + 122*s - 10) + 6*Pkd2*k2*(26*r*s - 7*r + 26*s**2 - 28*s + 7)) + k2**4*(Pk2*(135*r**2 + 5*r*(33*s - 37) + 30*s**2 - 126*s + 50) + 12*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 429*f*k2**2*(-48*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1**2*fd*k2**2*(Pk2*k2**2*(18*r**2 + r*(18*s + 17) + 15*s - 13) + 4*k1**2*(2*Pk2*(16*r**2 + 32*r*s - 3*r + 16*s**2 - 3*s - 5) + Pkd2*k2*s*(58*r + 58*s - 23))) - 2*b1*(24*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*bd1*(k1**4*(K - 1)*(2*Pk2*(2*r**2 + 2*r*(s - 3) + 2*s + 1) + Pkd2*k2*(r*(2*s + 3) + s*(2*s - 5))) + k1**2*k2**2*(Pk2*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(41*r**2 + 98*r*s - 53*r + 57*s**2 - 33*s - 6) - 109*r**2 - 234*r*s + 135*r - 125*s**2 + 115*s - 8) + Pkd2*k2*(r*(K*(32*s - 1) - 2*s - 3) + s*(K*(32*s - 31) - 2*s + 5))) + 6*k2**4*(K*(2*Pk2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(Pk2*(16*C*(2*r**2 + 2*r*(5*s - 2) + 8*s**2 - 7*s + 2) + K*(-44*r**2 + 142*r*s - 69*r + 186*s**2 - 275*s + 91) + 28*r**2 - 286*r*s + 173*r - 314*s**2 + 435*s - 147) - 4*Pkd2*k2*(K*(2*s - 1)*(13*r + 13*s - 8) + r*(12*C*s - 40*s + 17) + (4*s - 2)*(3*C*s - 10*s + 5))) + k1**2*k2**2*(Pk2*(-2*C*(50*r**2 + r*(436*s - 285) - 94*s**2 - 481*s + 186) + K*(-358*r**2 + 14*r*s - 86*r + 372*s**2 - 548*s + 181) + 750*r**2 + 1222*r*s - 924*r - 8*s**2 - 774*s + 289) + 12*Pkd2*k2*(-16*C*s - K*(2*s - 1)*(13*r + 13*s - 7) + 3*r*(8*C*s + 2*s - 3) + 18*s**2 - 11*s + 5)) + k2**4*(8*C*Pk2*(4*r**2 + r*(94*s + 40) + 16*s**2 - 33*s - 26) - K*Pk2*(270*r**2 + 22*r*(15*s - 7) + 15*(1 - 2*s)**2) - 24*K*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1) + 2*Pk2*(36*r**2 - 4*r*(36*s + 31) - 32*s**2 + 50*s + 63) + Pkd2*k2*s*(16*C - 8)*(10*r + 4*s - 5))) - 2*gd2*(2*k1**4*(2*Pk2*(r**2 + r*(s - 2) + 2*s + 1) + Pkd2*k2*s*(r + s - 4)) + k1**2*k2**2*(Pk2*(41*r**2 + 98*r*s - 29*r + 57*s**2 - 9*s - 12) + 2*Pkd2*k2*s*(16*r + 16*s - 15)) + 12*k2**4*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 4*bd1*g2*(2*k1**4*(2*Pk2*r*(r + s - 4) + Pkd2*k2*(r*(s + 3) + s*(s - 1))) + k1**2*k2**2*(Pk2*(41*r**2 + r*(98*s - 77) + s*(57*s - 57)) + 2*Pkd2*k2*(r*(16*s - 1) + s*(16*s - 16))) + 12*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 4*fd*(12*Pk2*b2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1) + g2*(k1**4*(Pk2*(44*r**2 - 142*r*s + 69*r - 186*s**2 + 275*s - 91) + 4*Pkd2*k2*(2*s - 1)*(13*r + 13*s - 8)) + k1**2*k2**2*(Pk2*(358*r**2 - 14*r*s + 86*r - 372*s**2 + 548*s - 181) + 12*Pkd2*k2*(2*s - 1)*(13*r + 13*s - 7)) + k2**4*(Pk2*(270*r**2 + 22*r*(15*s - 7) + 15*(1 - 2*s)**2) + 24*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))))) - 2*Dd*f*(-429*b1*k2**2*(24*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(2*K - 2)*(Pk2*(8*r**2 + 4*r*(2*s - 5) + 4*s + 6) + Pkd2*k2*(r*(4*s + 3) + s*(4*s - 9))) + k1**2*k2**2*(Pk2*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(164*r**2 + 392*r*s - 111*r + 228*s**2 - 51*s - 36) - 436*r**2 - 936*r*s + 427*r - 500*s**2 + 367*s - 48) + 2*Pkd2*k2*(r*(K*(64*s - 1) - 4*s - 3) + s*(K*(64*s - 46) - 4*s + 9))) + 12*k2**4*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(2*k1**4*(Pk2*(8*r**2 + 4*r*(2*s - 5) + 4*s + 6) + Pkd2*k2*(r*(4*s + 3) + s*(4*s - 9))) + k1**2*k2**2*(Pk2*(164*r**2 + 392*r*s - 111*r + 228*s**2 - 51*s - 36) + 2*Pkd2*k2*(64*r*s - r + 64*s**2 - 46*s)) + 12*k2**4*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 5*f**3*k1**2*(793*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 19)*(4*r + 4*s - 3) + 13*k1**2*k2**2*(Pk2*(4358*r**2 - 2*r*(3839*s + 700) - 12036*s**2 + 11302*s - 1503) + 28*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 13*f**2*k2**2*(2*k1**4*(Pk2*(C*(-5280*r**2 + 1692*r*s + 4825*r + 6972*s**2 - 7203*s + 61) + 10*b1*(24*r**2 - 2*r*(120*s + 187) - 264*s**2 - 214*s + 281) + 6360*r**2 + 348*r*s - 4945*r - 6012*s**2 + 7223*s - 591) + 5*Pkd2*k2*(-2*C*(636*r*s - 235*r + 636*s**2 - 735*s + 182) + b1*(4*r*(72*s + 103) + 288*s**2 + 252*s - 323) + 1284*r*s - 567*r + 1284*s**2 - 1581*s + 438)) + 3*k1**2*k2**2*(Pk2*(C*(-23848*r**2 + 4*r*(5102*s + 5353) + 6768*s**2 - 23664*s - 1802) + 11*b1*(920*r**2 + r*(1012*s - 975) + 92*s**2 - 459*s + 240) + 27224*r**2 + 10696*r*s - 29000*r + 2216*s**2 + 770*s + 6026) + 5*Pkd2*k2*(-4*C*(r*(604*s - 222) + 604*s**2 - 637*s + 157) + 11*b1*(21*s - 10)*(4*r + 4*s - 3) + 1912*r*s - 774*r + 1912*s**2 - 2110*s + 556)) + 3*k2**4*(Pk2*(-2*C*(6796*r**2 + 2572*r*s - 7750*r + 1496*s**2 - 1200*s + 2061) + 121*b1*(2*r - 1)*(5*r + 5*s - 3) + 8732*r**2 + 4508*r*s - 9466*r + 1496*s**2 - 1728*s + 2325) + Pkd2*k2*(220 - 440*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 429*f*k2**2*(-24*Pk2*b2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(4*r + 4*s - 3) + b1**2*k2**2*(32*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pk2*k2**2*(18*r**2 + 18*r*s + 29*r + 15*s - 25) + 2*Pkd2*k1**2*k2*(2*r*(58*s - 5) + 116*s**2 - 75*s + 2)) - b1*(k1**4*(Pk2*(8*C*(8*r**2 + 20*r*(2*s - 1) + 32*s**2 - 32*s + 9) + K*(-88*r**2 + 284*r*s - 49*r + 372*s**2 - 509*s + 115) + 56*r**2 - 572*r*s + 289*r - 628*s**2 + 877*s - 267) - 4*Pkd2*k2*(3*C*(4*s - 1)*(2*r + 2*s - 1) + K*(52*r*s - 21*r + 52*s**2 - 61*s + 16) - 80*r*s + 36*r - 80*s**2 + 92*s - 26)) + k1**2*k2**2*(Pk2*(-2*C*(100*r**2 + r*(872*s - 459) - 188*s**2 - 931*s + 340) + K*(-716*r**2 + 28*r*(s + 9) + 744*s**2 - 792*s + 201) + 1500*r**2 + 2444*r*s - 2202*r - 16*s**2 - 1822*s + 877) + 6*Pkd2*k2*(8*C*(r*(12*s - 1) - 8*s + 1) - 2*K*(52*r*s - 20*r + 52*s**2 - 55*s + 14) + 24*r*s - 28*r + 72*s**2 - 50*s + 19)) + k2**4*(Pk2*(8*C*(8*r**2 + 4*r*(47*s + 9) + 32*s**2 - 82*s - 25) - K*(540*r**2 + r*(660*s - 524) + 120*s**2 - 312*s + 115) + 144*r**2 - 16*r*(36*s + 25) - 128*s**2 + 216*s + 190) + 2*Pkd2*k2*(2*C*(10*r*(8*s - 1) + 32*s**2 - 48*s + 5) - 12*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 80*r*s + 10*r - 32*s**2 + 48*s - 5))) - 2*g2*(k1**4*(Pk2*(88*r**2 - 284*r*s + 49*r - 372*s**2 + 509*s - 115) + 4*Pkd2*k2*(52*r*s - 21*r + 52*s**2 - 61*s + 16)) + k1**2*k2**2*(Pk2*(716*r**2 - 28*r*(s + 9) - 744*s**2 + 792*s - 201) + 12*Pkd2*k2*(4*r*(13*s - 5) + 52*s**2 - 55*s + 14)) + k2**4*(Pk2*(540*r**2 + 660*r*s - 524*r + 120*s**2 - 312*s + 115) + 24*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k2**2*k3**6) + D1**3*Pk3*ct**4*(-66*b1**2*k1**2*(D1*fd*(k1**2*(4*Pk2*(-8*C*s**2 - 97*K*(s - 1)**2 + 4*f*(16*s**2 + 14*s - 5) + 125*s**2 - 194*s + 97) + k2*(Pkd2*(20*C*s**2 + 139*K*(s - 1)**2 - 10*f*(16*s**2 + 14*s - 5) - 209*s**2 + 278*s - 139) + 2*Pkdd2*k2*(-2*C*s**2 - 7*K*(s - 1)**2 + f*(16*s**2 + 14*s - 5) + 14*s**2 - 14*s + 7))) + k2**2*(24*K*Pk2*r*(r - 4*s + 4) - 12*K*Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) - 12*K*Pkdd2*k2**2*(2*s - 1) - 24*Pk2*r*(r + 2) + 24*Pkd2*k2*r + f*(-26*Pk2*r + Pk2 + 12*Pkd2*k2*r))) + Dd*f*(k1**2*(4*s - 1)*(4*Pk2*(-8*C*s - 97*K*(s - 1) + 4*f*(8*s + 5) + 125*s - 97) + k2*(Pkd2*(20*C*s + 139*K*(s - 1) - 10*f*(8*s + 5) - 209*s + 139) + 2*Pkdd2*k2*(-2*C*s - 7*K*(s - 1) + f*(8*s + 5) + 14*s - 7))) + 2*k2**2*(Pk2*(48*K*(r**2 - 4*r*s + 2*r + s - 1) + f*(25 - 50*r) - 48*r**2 - 24*r + 24) + 6*k2*(K*Pkdd2*k2*(1 - 4*s) + Pkd2*(K*(2*r*(8*s - 5) + 3) + f*(4*r - 2) + 4*r - 2))))) + 33*b1*k1**2*(D1*(f**2*(2*bd1*(32*Pk2*k1**2*s*(1 - 8*s) + 20*Pkd2*k1**2*k2*s*(8*s - 1) + 12*Pkd2*k2**3*(2 - 3*r) + k2**2*(Pk2*(74*r - 49) + 4*Pkdd2*k1**2*s*(1 - 8*s))) + fd*(k1**2*(Pk2*(42*r*(9*s - 22) + 9072*s**2 - 7797*s + 1990) + 2*k2*(Pkd2*(-54*r*s + 120*r - 1674*s**2 + 1428*s - 341) + 30*Pkdd2*k2*(6*s**2 - 5*s + 1))) + k2**2*(Pk2*(432*r**2 + 15*r*s - 462*r - 245*s + 218) + 12*Pkd2*k2*(3*r - 1)*(5*s - 2)))) + 2*f*(2*bd1*(6*K*Pkdd2*k2**4*s + 4*Pk2*k1**2*s*(C*(8*s - 4) + 97*K*(s - 1) - 125*s + 111) + Pkd2*k1**2*k2*s*(C*(10 - 20*s) - 139*K*(s - 1) + 209*s - 174) - 6*Pkd2*k2**3*(K*(r*(8*s - 4) - s + 2) + r - 1) + k2**2*(-12*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + Pkdd2*k1**2*s*(C*(4*s - 2) + 14*K*(s - 1) - 28*s + 21))) + 12*bd2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) + 2*fd*k1**2*(2*Pk2*(6*C*(42*s**2 - 71*s + 25) + 4*K*(8*s**2 - 14*s + 5) + 27*r*s - 51*r + 180*s**2 - 110*s + 6) + k2*(-Pkd2*(3*C*(66*s**2 - 107*s + 37) + 5*K*(8*s**2 - 14*s + 5) + 14*r*s - 26*r + 114*s**2 - 73*s + 3) + Pkdd2*k2*(12*C*(2*s**2 - 3*s + 1) + K*(8*s**2 - 14*s + 5) + 2*s*(4*s - 3)))) + fd*k2**2*(2*Pk2*(4*C*(2*r - 1)*(2*r + 57*s - 37) + K*r*(26 - 27*s) - 57*K*(1 - 2*s)**2 - 25*r**2 - 438*r*s + 315*r + 114*s - 83) + k2*(Pkd2*(-4*C*(56*r*(2*s - 1) - 42*s + 23) + 24*K*r*(s - 1) + 69*K*(1 - 2*s)**2 + 320*r*s - 180*r - 84*s + 38) - 2*Pkdd2*k2*(C*(10 - 28*s) + 6*K*(1 - 2*s)**2 + 14*s - 5))) + 2*gd2*(-388*Pk2*k1**2*s*(s - 1) + 139*Pkd2*k1**2*k2*s*(s - 1) + 12*Pkd2*k2**3*(r*(4*s - 2) - s + 2) - 12*Pkdd2*k2**4*s + 2*k2**2*(12*Pk2*(r**2 - 4*r*s + r + 2*s - 2) - 7*Pkdd2*k1**2*s*(s - 1)))) + 4*fd*(6*b2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) - g2*k1**2*(388*Pk2 + k2*(-139*Pkd2 + 14*Pkdd2*k2))*(s - 1)**2 - 12*g2*k2**2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + Pkdd2*k2**2*(2*s - 1)))) + 2*Dd*f*(12*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + f**2*(k1**2*(2*Pk2*(6*r*(21*s - 58) + 3024*s**2 - 2347*s + 556) + k2*(Pkd2*(-72*r*s + 180*r - 2232*s**2 + 1718*s - 371) + 30*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(288*r**2 + 10*r*s - 304*r - 125*s + 110) + 12*Pkd2*k2*(2*r - 1)*(5*s - 2))) + f*(2*k1**2*(2*Pk2*(6*C*(84*s**2 - 121*s + 25) + 4*K*(16*s**2 - 24*s + 5) + 54*r*s - 118*r + 360*s**2 - 173*s + 73) + k2*(-Pkd2*(3*C*(132*s**2 - 181*s + 37) + 5*K*(16*s**2 - 24*s + 5) + 28*r*s - 60*r + 228*s**2 - 99*s + 37) + Pkdd2*k2*(4*s - 1)*(12*C*(s - 1) + K*(4*s - 5) + 4*s))) + k2**2*(2*Pk2*(8*C*(2*r - 1)*(2*r + 57*s - 30) + K*(-54*r*s + 76*r - 456*s**2 + 417*s - 107) - 50*r**2 - 876*r*s + 518*r + 276*s - 206) + k2*(Pkd2*(-4*C*(28*r*(8*s - 3) - 92*s + 37) + 3*K*(8*r*(2*s - 3) + 184*s**2 - 162*s + 39) + 640*r*s - 296*r - 232*s + 126) + 2*Pkdd2*k2*(4*s - 1)*(10*C + K*(6 - 12*s) - 5)))) - 2*g2*k1**2*(388*Pk2 + k2*(-139*Pkd2 + 14*Pkdd2*k2))*(4*s**2 - 5*s + 1) - 24*g2*k2**2*(-8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(-16*r*s + 10*r - 3) + Pkdd2*k2*(4*s - 1))))) + f*(33*D1*bd1*k1**2*(24*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + f**2*k1**2*(Pk2*(18*r*(7*s - 26) + 3024*s**2 - 1591*s + 234) + 4*k2*(Pkd2*(-9*r*s + 30*r - 279*s**2 + 145*s - 15) + 15*Pkdd2*k2*s*(2*s - 1))) + f**2*k2**2*(r - 1)*(Pk2*(144*r + 5*s - 2) + 12*Pkd2*k2*(5*s - 2)) + 4*f*k1**2*(Pk2*(r*(27*s - 67) + s**2*(252*C + 32*K + 180) - s*(300*C + 40*K + 55) + 67) + k2*(Pkd2*(r*(17 - 7*s) - s**2*(99*C + 20*K + 57) + s*(111*C + 25*K + 8) - 17) + Pkdd2*k2*s*(12*C*(s - 1) + K*(4*s - 5) + 4*s + 2))) + 2*f*k2**2*(-Pk2*(K*(r*(27*s - 50) + 228*s**2 - 189*s + 50) + r**2*(25 - 16*C) + r*(-8*C*(57*s - 23) + 438*s - 203) + s*(112*C - 104) + 68) + k2*(Pkd2*(52*C*s + 3*K*(4*r*(s - 2) + 46*s**2 - 35*s + 8) + r*(-224*C*s + 56*C + 160*s - 62) - 50*s + 34) + 2*Pkdd2*k2*s*(2*C + K*(6 - 12*s) - 1))) + 4*g2*(-388*Pk2*k1**2*s*(s - 1) + 139*Pkd2*k1**2*k2*s*(s - 1) + 24*Pkd2*k2**3*r*(2*s - 1) + 2*k2**2*(12*Pk2*r*(r - 4*s + 2) - 7*Pkdd2*k1**2*s*(s - 1)))) + 2*D1*(f*(fd*(Pk2*k2**4*(4 - 8*C)*(9*r**2 + 192*r - 65) + 2*k1**4*(160*C*Pk2*(27*s**2 - 51*s + 14) + 6*Pk2*(-r*(129*s + 727) + 5178*s**2 - 5081*s + 1375) + Pkd2*k2*(-100*C*(27*s**2 - 51*s + 14) + 12*r*(12*s + 95) - 11412*s**2 + 10563*s - 2649) + 5*Pkdd2*k2**2*(3*s - 1)*(4*C*(9*s - 14) + 81*s - 38)) + k1**2*k2**2*(Pk2*(C*(6*r*(75*s + 998) - 34056*s**2 + 21894*s - 5560) + 5085*r**2 - 3*r*(3711*s + 2071) + 17028*s**2 - 19653*s + 7402) - k2*(Pkd2*(2*C*(6*r*(93*s + 200) - 10494*s**2 + 6975*s - 1621) - 5310*r*s + 846*r + 10494*s**2 - 6051*s + 1159) + Pkdd2*k2*(660*C - 330)*(6*s**2 - 5*s + 1)))) + k1**2*(33*bd2 - 66*gd2)*(16*Pk2*k1**2*s*(4*s - 5) + 10*Pkd2*k1**2*k2*s*(5 - 4*s) + 3*Pkd2*k2**3*(4*r*(s - 2) + 46*s**2 - 35*s + 8) + 12*Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(Pk2*(-27*r*s + 50*r - 228*s**2 + 189*s - 50) + 2*Pkdd2*k1**2*s*(4*s - 5)))) - 66*fd*g2*k1**2*(2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5) + k2**2*(-2*Pk2*(r*(27*s - 26) + 57*(1 - 2*s)**2) - 3*k2*(-8*Pkd2*r*(s - 1) - 23*Pkd2*(1 - 2*s)**2 + 4*Pkdd2*k2*(1 - 2*s)**2)))) + 2*Dd*f*(f*(Pk2*k2**4*(8 - 16*C)*(6*r**2 + 127*r - 65) + 2*k1**4*(8*Pk2*(20*C*(36*s**2 - 65*s + 14) - r*(129*s + 797) + 5178*s**2 - 4768*s + 1283) + k2*(Pkd2*(-100*C*(36*s**2 - 65*s + 14) + 4*r*(48*s + 415) - 15216*s**2 + 13064*s - 3169) + 5*Pkdd2*k2*(4*s - 1)*(4*C*(9*s - 14) + 81*s - 38))) + k1**2*k2**2*(2*Pk2*(2*C*(150*r*s + 2456*r - 11352*s**2 + 7247*s - 2349) + 3390*r**2 - 7422*r*s - 5492*r + 11352*s**2 - 12489*s + 5239) - k2*(Pkd2*(2*C*(744*r*s + 2060*r - 13992*s**2 + 8930*s - 2481) - 7080*r*s + 448*r + 13992*s**2 - 7082*s + 1557) + Pkdd2*k2*(660*C - 330)*(8*s**2 - 6*s + 1)))) - 66*g2*k1**2*(2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5) + k2**2*(-2*Pk2*(r*(54*s - 76) + 456*s**2 - 417*s + 107) + 3*k2*(Pkd2*(8*r*(2*s - 3) + 184*s**2 - 162*s + 39) - 4*Pkdd2*k2*(8*s**2 - 6*s + 1))))) + 66*b2*k1**2*(D1*fd*(2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 14*s + 5) + k2**2*(-2*Pk2*(r*(27*s - 26) + 57*(1 - 2*s)**2) - 3*k2*(-8*Pkd2*r*(s - 1) - 23*Pkd2*(1 - 2*s)**2 + 4*Pkdd2*k2*(1 - 2*s)**2))) + Dd*f*(2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(16*s**2 - 24*s + 5) + k2**2*(-2*Pk2*(r*(54*s - 76) + 456*s**2 - 417*s + 107) + 3*k2*(Pkd2*(8*r*(2*s - 3) + 184*s**2 - 162*s + 39) - 4*Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(693*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*ct**4*(D1*bd1*f*k1**2*(-1584*Pkd2*b2*k2**5*(r*(2*s - 1) + s*(2*s - 2)) - 66*b1*(k1**4*s*(2 - 2*K)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + k1**2*k2**2*(Pk2*(-16*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(80*r**2 + 510*r*s + 88*r + 616*s**2 - 483*s - 56) + 80*r**2 + 894*r*s - 56*r + 1000*s**2 - 883*s + 8) + k2*(Pkd2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(84*r*s + 48*r + 158*s**2 - 109*s - 20) - 276*r*s + 24*r - 370*s**2 + 319*s - 12) + Pkdd2*k2*s*(6*K + 4)*(2*s - 1))) + 12*k2**4*(-2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s)))) - f**2*(20*k1**4*(4*Pk2*(2*r*(39*s - 56) + 150*s**2 - 183*s + 56) + k2*(Pkd2*(-78*r*s + 112*r - 258*s**2 + 261*s - 56) + 2*Pkdd2*k2*s*(18*s - 13))) + 33*k1**2*k2**2*(Pk2*(324*r**2 - 4*r*(442*s + 191) - 1404*s**2 + 991*s + 440) + 4*k2*(Pkd2*(145*r*s + 50*r + 39*s**2 - 54*s - 50) + 5*Pkdd2*k2*s*(4*s - 1))) + 33*k2**4*(r - 1)*(Pk2*(206*r + 225*s - 160) + 12*Pkd2*k2*(5*s - 2))) + 33*f*(-2*k1**4*(4*Pk2*(4*r*(2*s - 5) + s**2*(-16*C - 63*K + 87) + s*(16*C + 75*K - 123) + 20) + k2*(Pkd2*(r*(20 - 8*s) + s**2*(40*C + 99*K - 147) + s*(-40*C - 111*K + 183) - 20) + Pkdd2*k2*s*(s - 1)*(-8*C - 12*K + 20))) + 2*k1**2*k2**2*(Pk2*(-2*C*(12*r**2 + 7*r*(29*s - 28) - 220*s**2 - 76*s + 96) + 20*K*r**2 - 325*K*r*s - 146*K*r + 544*K*s**2 - 543*K*s + 126*K - 8*b1*(2*r*(16*s + 5) + 32*s**2 - 23*s - 3) + 8*r**2 + 1205*r*s - 580*r + 48*s**2 - 663*s + 460) + k2*(Pkd2*(2*C*(8*r*(17*s - 8) - 75*s**2 - 53*s + 48) + 86*K*r*s + 52*K*r - 314*K*s**2 + 281*K*s - 52*K + 4*b1*(2*r*(16*s + 5) + 20*s**2 - 17*s - 3) - 460*r*s + 222*r + 56*s**2 + 261*s - 222) + 2*Pkdd2*k2*s*(4*C*(s - 1) + 32*K*s - 19*K + 12*b1*(2*s - 1) - 24*s + 18))) + k2**4*(Pk2*(96*C*r**2 + 912*C*r*s + 32*C*r - 224*C*s + K*(24*r**2 - 930*r*s + 52*r - 456*s**2 + 342*s - 76) + b1*(-2*r*(9*s - 68) + 9*s - 92) - 334*r**2 - 432*r*s + 446*r + 208*s - 136) + 2*k2*(Pkd2*(-8*C*(28*r*s - 19*r + 6*s**2 - 11*s + 12) + 180*K*r*s - 24*K*r + 54*K*s**2 - 87*K*s + 24*K + 6*b1*(2*r*(s + 1) + s - 2) + 70*r*s - 56*r + 24*s**2 + 2*s + 14) + 4*Pkdd2*k2*s*(-4*C*(s - 1) + 6*K*s - 3*K + 2*s - 2)))) - 132*g2*(2*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + k1**2*k2**2*(Pk2*(40*r**2 + 3*r*(85*s + 24) + s*(308*s - 308)) - k2*(14*Pkd2*r*(3*s + 2) + 79*Pkd2*s*(s - 1) + 6*Pkdd2*k2*s*(s - 1))) - 12*k2**4*(-2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(4*s - 2) + 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))))) + 33*b1**2*k1**2*(D1*fd*(k1**4*s**2*(4*K - 4)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 2*k1**2*k2**2*(-Pk2*(-32*C*r*s - 32*C*s**2 + 32*C*s - K*(40*r**2 + 255*r*s - 210*r + 308*s**2 - 340*s + 170) + 8*f*(r*(32*s + 22) + 32*s**2 + 11*s - 22) + 40*r**2 + 447*r*s - 250*r + 500*s**2 - 452*s + 210) + k2*(Pkd2*(-16*C*r*s - 16*C*s**2 + 16*C*s + K*(-42*r*s + 16*r - 79*s**2 + 32*s - 16) + 4*f*(r*(32*s + 22) + 20*s**2 + 11*s - 22) + 138*r*s - 36*r + 185*s**2 - 88*s + 36) + Pkdd2*k2*s**2*(-6*K + 48*f - 4))) + k2**4*(-24*K*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) + f*(Pk2*(-18*r*s + 40*r + 9*s + 4) + 12*Pkd2*k2*s*(2*r + 1)) + 48*r*(Pk2*(r + 2) + Pkd2*k2*s))) + 2*Dd*f*(k1**4*s*(2*K - 2)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 80*K*r**2 + 510*K*r*s - 53*K*r + 616*K*s**2 - 499*K*s + 29*K - 4*f*(64*r*s + 32*r + 64*s**2 - 12*s - 25) - 80*r**2 - 894*r*s + 169*r - 1000*s**2 + 859*s - 105) + k2*(Pkd2*(-8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 168*K*r*s - 52*K*r - 316*K*s**2 + 171*K*s + 24*K + 4*f*(64*r*s + 32*r + 40*s**2 - 6*s - 25) + 552*r*s - 64*r + 740*s**2 - 541*s + 52) + Pkdd2*k2*s*(4*s - 1)*(-6*K + 24*f - 4))) + k2**4*(Pk2*(48*K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) - f*(2*r - 1)*(9*s - 44) + 96*r**2 + 48*r - 48) - 12*k2*(K*Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + K*Pkdd2*k2*s*(4*s - 1) - Pkd2*f*(2*r*s + r + s - 1) + Pkd2*(-8*r*s + r + 2*s))))) + b1*k1**2*(D1*(-f**2*fd*(20*k1**4*(12*Pk2*(r*(78*s - 92) + 150*s**2 - 89*s + 58) + k2*(-3*Pkd2*(78*r*s - 92*r + 258*s**2 + 13*s + 30) + 2*Pkdd2*k2*(54*s**2 + 51*s - 14))) + 33*k1**2*k2**2*(Pk2*(972*r**2 - 8*r*(663*s - 40) - 4212*s**2 + 4341*s - 640) + 2*k2*(Pkd2*(30*r*(29*s - 6) + 234*s**2 - 266*s + 69) + 30*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 33*k2**4*(Pk2*(618*r**2 + 675*r*s - 614*r - 465*s + 184) + 12*Pkd2*k2*(3*r - 1)*(5*s - 2))) + 66*f*(-24*Pkd2*bd2*k2**5*s*(2*r + 2*s - 1) + fd*k1**4*(4*Pk2*(32*C*s**2 + 3*K*(42*s**2 - 71*s + 25) - 16*r*(s - 2) - 174*s**2 + 253*s - 91) + k2*(Pkd2*(-80*C*s**2 - 3*K*(66*s**2 - 107*s + 37) + 16*r*(s - 2) + 294*s**2 - 361*s + 127) + 4*Pkdd2*k2*(K*(6*s**2 - 9*s + 3) + s**2*(4*C - 10) + 9*s - 3))) + fd*k1**2*k2**2*(2*Pk2*(C*(-24*r**2 + r*(182 - 406*s) + 440*s**2 + 303*s - 158) + K*(20*r**2 - 325*r*s + 72*r + 544*s**2 - 744*s + 236) + 8*r**2 + 1205*r*s - 708*r + 48*s**2 - 639*s + 216) + k2*(Pkd2*(4*C*(8*r*(17*s - 4) - 75*s**2 - 108*s + 32) + K*(172*r*s - 628*s**2 + 840*s - 263) - 920*r*s + 412*r + 112*s**2 + 400*s - 75) + 2*Pkdd2*k2*(K*(64*s**2 - 70*s + 19) + s**2*(8*C - 48) + 42*s - 12))) + fd*k2**4*(2*Pk2*(12*C*(2*r - 1)*(2*r + 19*s - 4) + K*(12*r**2 + r*(242 - 465*s) - 57*(1 - 2*s)**2) - 167*r**2 - 216*r*s + 103*r + 117*s - 30) + k2*(Pkd2*(-32*C*(r*(14*s + 5) + 3*s**2 - 5) + 3*K*(8*r*(15*s - 7) + 9*(1 - 2*s)**2) + 4*r*(35*s + 32) + 48*s**2 + 30*s - 80) + 4*Pkdd2*k2*(3*K*(1 - 2*s)**2 + s**2*(4 - 8*C)))) - 2*gd2*(2*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*(40*r**2 + r*(255*s + 16) + 308*s**2 - 175*s - 56) - k2*(Pkd2*(42*r*s + 20*r + 79*s**2 - 30*s - 20) + 6*Pkdd2*k2*s**2)) - 12*k2**4*(-2*Pk2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + k2*(Pkd2*(4*r*s + 2*r + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2)))) - 132*fd*(24*Pkd2*b2*k2**5*s*(r + s) + g2*(2*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(Pk2*(40*r**2 + 15*r*(17*s - 14) + 308*s**2 - 340*s + 170) - k2*(Pkd2*(42*r*s - 16*r + 79*s**2 - 32*s + 16) + 6*Pkdd2*k2*s**2)) - 12*k2**4*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2)))) - 2*Dd*f*(792*Pkd2*b2*k2**5*(r*(8*s - 1) + 4*s*(2*s - 1)) + f**2*(20*k1**4*(8*Pk2*r*(78*s - 97) + 20*Pk2*(60*s**2 - 45*s + 23) + Pkd2*k2*(-2*r*(78*s - 97) - 516*s**2 + 111*s - 73) + 2*Pkdd2*k2**2*(36*s**2 + 19*s - 7)) + 33*k1**2*k2**2*(2*Pk2*(324*r**2 - r*(1768*s + 111) - 1404*s**2 + 1333*s - 50) + k2*(Pkd2*(40*r*(29*s - 2) + 312*s**2 - 374*s - 31) + 10*Pkdd2*k2*(16*s**2 - 16*s + 3))) + 33*k2**4*(Pk2*(412*r**2 + 450*r*s - 490*r - 345*s + 172) + 12*Pkd2*k2*(2*r - 1)*(5*s - 2))) - 33*f*(k1**4*(4*Pk2*(64*C*s**2 - 16*C*s + 3*K*(84*s**2 - 121*s + 25) - 8*r*(4*s - 9) - 348*s**2 + 483*s - 131) + k2*(Pkd2*(-160*C*s**2 + 40*C*s - 3*K*(132*s**2 - 181*s + 37) + 8*r*(4*s - 9) + 588*s**2 - 687*s + 167) + 4*Pkdd2*k2*(4*s - 1)*(3*K*(s - 1) + s*(2*C - 5) + 3))) + k1**2*k2**2*(-2*Pk2*(C*(48*r**2 + 14*r*(58*s - 35) - 880*s**2 - 670*s + 354) + K*(-40*r**2 + 650*r*s + 74*r - 1088*s**2 + 1287*s - 362) - 16*r**2 - 2410*r*s + 1204*r - 96*s**2 + 1429*s - 648) + k2*(Pkd2*(2*C*(16*r*(34*s - 9) - 300*s**2 - 421*s + 128) + K*(8*r*(43*s + 13) - 1256*s**2 + 1402*s - 367) - 1840*r*s + 760*r + 224*s**2 + 1036*s - 423) + 2*Pkdd2*k2*(4*s - 1)*(K*(32*s - 19) + s*(4*C - 24) + 12))) + k2**4*(2*Pk2*(8*C*(2*r - 1)*(6*r + 57*s - 5) + K*(24*r**2 - 930*r*s + 268*r - 456*s**2 + 399*s - 95) - 334*r**2 - 432*r*s + 334*r + 282*s - 100) + k2*(Pkd2*(-8*C*(2*r*(56*s + 3) + 24*s**2 - 22*s - 13) + 3*K*(240*r*s - 72*r + 72*s**2 - 94*s + 25) + 280*r*s + 104*r + 96*s**2 + 20*s - 98) + 4*Pkdd2*k2*(4*s - 1)*(K*(6*s - 3) + s*(2 - 4*C))))) + 66*g2*(2*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(80*r**2 + r*(510*s - 53) + 616*s**2 - 499*s + 29) + k2*(Pkd2*(-4*r*(42*s + 13) - 316*s**2 + 171*s + 24) + 6*Pkdd2*k2*s*(1 - 4*s))) - 12*k2**4*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) - 2*f*(D1*(-5*f**2*fd*k1**4*(k1**2*(Pk2*(10*r*(49*s - 326) + 32352*s**2 - 25981*s + 6042) + k2*(Pkd2*(-160*r*s + 840*r - 12120*s**2 + 9538*s - 2027) + 168*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(9504*r**2 + 18*r*(25*s - 527) - 6720*s**2 + 395*s + 2632) + Pkd2*k2*(1188*r*(5*s - 2) + 3660*s**2 - 5105*s + 1493))) + f*(-fd*(Pk2*k2**6*(8*C - 4)*(9*r**2 + 192*r - 65) + 2*k1**6*(4*Pk2*(C*(4239*s**2 - 7644*s + 2077) - 90*r*s + 690*r - 4329*s**2 + 8394*s - 2537) + k2*(Pkd2*(C*(-7209*s**2 + 11604*s - 3067) + 90*r*s - 690*r + 7299*s**2 - 12354*s + 3527) + Pkdd2*k2*(330*C - 330)*(3*s**2 - 4*s + 1))) + 2*k1**4*k2**2*(Pk2*(9*C*(936*r**2 - 2113*r*s - 1566*r + 4084*s**2 - 7269*s + 2622) - 13248*r**2 + 42237*r*s + 4026*r + 2052*s**2 + 24879*s - 13084) + k2*(Pkd2*(3*C*(4236*r*s + 84*r - 6918*s**2 + 7941*s - 2377) - 22734*r*s + 7248*r + 4032*s**2 - 3690*s + 892) + 5*Pkdd2*k2*(3*s - 1)*(8*C*(45*s - 26) - 279*s + 170))) + k1**2*k2**4*(2*C*Pk2*(20160*r**2 - 3*r*(29055*s + 2198) - 17028*s**2 + 41397*s - 2264) + 3*Pk2*(-12903*r**2 + r*(26883*s + 7231) + 5676*s**2 - 9841*s - 1314) + Pkd2*k2*(2*C*(18*r*(999*s - 344) + 5346*s**2 - 9393*s + 2603) + r*(8238 - 22734*s) - 5346*s**2 + 10317*s - 3065) + Pkdd2*k2**2*(660*C - 330)*(6*s**2 - 5*s + 1))) + 66*k1**2*(6*bd2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + bd2*k2**4*(Pk2*(9*r**2 + r*(123*s - 31) + 114*s**2 - 90*s + 22) - 12*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*gd2*k1**4*s*(4*Pk2*(21*s - 25) + k2*(Pkd2*(37 - 33*s) + 4*Pkdd2*k2*(s - 1))) + gd2*k1**2*k2**2*(Pk2*(20*r**2 - r*(325*s + 146) + 544*s**2 - 543*s + 126) + k2*(Pkd2*(86*r*s + 52*r - 314*s**2 + 281*s - 52) + 2*Pkdd2*k2*s*(32*s - 19))) + gd2*k2**4*(Pk2*(12*r**2 + r*(26 - 465*s) - 228*s**2 + 171*s - 38) + 3*k2*(Pkd2*(60*r*s - 8*r + 18*s**2 - 29*s + 8) + 4*Pkdd2*k2*s*(2*s - 1))))) + 66*fd*k1**2*(12*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + b2*k2**4*(Pk2*(18*r**2 + 2*r*(123*s - 67) + 57*(1 - 2*s)**2) - 24*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)) + 3*g2*k1**4*(2*s - 1)*(4*Pk2*(21*s - 25) + k2*(Pkd2*(37 - 33*s) + 4*Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(2*Pk2*(20*r**2 + r*(72 - 325*s) + 544*s**2 - 744*s + 236) + k2*(Pkd2*(172*r*s - 628*s**2 + 840*s - 263) + 2*Pkdd2*k2*(64*s**2 - 70*s + 19))) + g2*k2**4*(2*Pk2*(12*r**2 + r*(242 - 465*s) - 57*(1 - 2*s)**2) + 3*k2*(8*Pkd2*r*(15*s - 7) + 9*Pkd2*(1 - 2*s)**2 + 4*Pkdd2*k2*(1 - 2*s)**2)))) + Dd*f*(-5*f**2*k1**4*(k1**2*(Pk2*(10*r*(49*s - 326) + 32352*s**2 - 25981*s + 6042) + k2*(Pkd2*(-160*r*s + 840*r - 12120*s**2 + 9538*s - 2027) + 168*Pkdd2*k2*(8*s**2 - 6*s + 1))) + k2**2*(Pk2*(9504*r**2 + 18*r*(25*s - 527) - 6720*s**2 + 395*s + 2632) + Pkd2*k2*(1188*r*(5*s - 2) + 3660*s**2 - 5105*s + 1493))) - f*(Pk2*k2**6*(16*C - 8)*(6*r**2 + 127*r - 65) + 2*k1**6*(4*Pk2*(C*(5652*s**2 - 9721*s + 2077) - 120*r*s + 970*r - 5772*s**2 + 10831*s - 2817) + k2*(Pkd2*(C*(-9612*s**2 + 14671*s - 3067) + 120*r*s - 970*r + 9732*s**2 - 15781*s + 3807) + Pkdd2*k2*(330*C - 330)*(4*s**2 - 5*s + 1))) + 2*k1**4*k2**2*(2*Pk2*(C*(5616*r**2 - 2*r*(6339*s + 5800) + 24504*s**2 - 41995*s + 14948) - 8832*r**2 + 28158*r*s + 5827*r + 1368*s**2 + 15349*s - 8148) + k2*(Pkd2*(C*(4*r*(4236*s + 409) - 27672*s**2 + 29234*s - 8515) - 30312*r*s + 8214*r + 5376*s**2 - 2320*s - 74) + 5*Pkdd2*k2*(4*s - 1)*(8*C*(45*s - 26) - 279*s + 170))) + k1**2*k2**4*(4*C*Pk2*(13440*r**2 - 78*r*(745*s + 128) - 11352*s**2 + 29641*s + 2195) - 6*Pk2*(8602*r**2 - 6*r*(2987*s + 1222) - 3784*s**2 + 7077*s + 2223) + k2*(Pkd2*(2*C*(23976*r*s - 6916*r + 7128*s**2 - 13246*s + 3327) - 30312*r*s + 9424*r - 7128*s**2 + 15094*s - 4251) + Pkdd2*k2*(660*C - 330)*(8*s**2 - 6*s + 1)))) + 66*k1**2*(12*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + b2*k2**4*(Pk2*(36*r**2 + 4*r*(123*s - 49) + 456*s**2 - 408*s + 101) - 24*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 3*g2*k1**4*(4*s - 1)*(4*Pk2*(21*s - 25) + k2*(Pkd2*(37 - 33*s) + 4*Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(2*Pk2*(40*r**2 - 2*r*(325*s + 37) + 1088*s**2 - 1287*s + 362) + k2*(Pkd2*(8*r*(43*s + 13) - 1256*s**2 + 1402*s - 367) + 2*Pkdd2*k2*(128*s**2 - 108*s + 19))) + g2*k2**4*(2*Pk2*(24*r**2 - 930*r*s + 268*r - 456*s**2 + 399*s - 95) + 3*k2*(Pkd2*(240*r*s - 72*r + 72*s**2 - 94*s + 25) + 4*Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(693*d**2*k1**2*k2**2*k3**4) - 20*D1**3*Pk3*ct**3*f**2*k1*st**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1)*(7*D1*bd1*f*s + D1*fd*(7*b1 + 3)*(3*s - 1) + Dd*f*(7*b1 + 3)*(4*s - 1))/(231*d**2*k2*k3**2) - 8*D1**3*Pk3*ct**3*f*k1*k2*st**4*(D1*(5*f**2*(546*bd1*k2**2*(2*Pk2*(3*r**2 - 4*r - 3*s**2 + s + 1) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + fd*(-364*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 6*s + 4) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(13136*s - 3713) + 13136*s**2 - 13422*s + 2749))) + 156*f*(fd*k1**2*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + fd*k2**2*(Pk2*(C*(-459*r**2 + 621*r*s + 132*r + 1080*s**2 - 927*s + 127) + 594*r**2 - 81*r*s - 402*r - 675*s**2 + 477*s - 7) + Pkd2*k2*(45 - 60*C)*(3*s - 1)*(3*r + 3*s - 2)) + k1**2*s*(4*Pk2 - Pkd2*k2)*(2*r + 2*s - 1)*(33*K*bd1 - 33*bd1 - 66*gd2)) - 5148*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1)) + Dd*f*(5*f**2*(-364*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 6*s + 4) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(13136*s - 3713) + 13136*s**2 - 13422*s + 2749)) + 78*f*(k1**2*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + k2**2*(-2*Pk2*(2*C*(306*r**2 - 3*r*(138*s + 53) - 720*s**2 + 587*s - 47) - 792*r**2 + 108*r*s + 678*r + 900*s**2 - 559*s - 71) + Pkd2*k2*(45 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 5148*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1)) + 78*b1*(D1*fd*(70*f*k2**2*(3*Pk2*(r - s) + Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) + k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1)) + Dd*f*(35*f*k2**2*(2*Pk2*(12*r**2 - 10*r - 12*s**2 + 7*s + 1) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1))))/(9009*d**2*k3**6) - 2*D1**3*Pk3*ct**3*f*k1*st**4*(D1*(5*f**2*(-546*bd1*k2**2*(-8*Pk2*(r*(6*s - 1) + 3*s**2 - 5*s + 1) + k2*(Pkd2*(12*r*s - 2*r - 3*s**2 - 7*s + 2) + Pkdd2*k2*s*(3*s - 1))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1772*s**2 - 1003*s + 140) + 364*k2**2*(Pk2*(r*(34 - 114*s) + 33*s - 11) + 3*Pkd2*k2*(r*(10*s - 3) - 3*s + 1)))) + 78*f*(fd*(k1**2*(1 - 3*s)**2*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k2**2*(8*Pk2*(C*(-459*r*s + 120*r + 540*s**2 - 207*s + 20) + 105*b1*(3*s - 1)*(2*r + s - 1) + 729*r*s - 210*r - 135*s**2 - 153*s + 55) + k2*(Pkd2*(2*C*(459*r*s - 120*r - 1350*s**2 + 747*s - 110) - 105*b1*(3*s - 1)*(4*r - s - 1) - 1458*r*s + 420*r + 1485*s**2 - 504*s + 25) + Pkdd2*k2*(1 - 3*s)**2*(60*C - 35*b1 - 45)))) + k1**2*s**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(33*K*bd1 - 33*bd1 - 66*gd2)) - 2574*fd*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1)*(-K*b1 + b1 + 2*g2)) + Dd*f*(5*f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1772*s**2 - 1003*s + 140) + 364*k2**2*(Pk2*(r*(34 - 114*s) + 33*s - 11) + 3*Pkd2*k2*(r*(10*s - 3) - 3*s + 1))) + 78*f*(k1**2*(20*C - 20)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) - k2**2*(-8*Pk2*(720*C*s**2 - 154*C*s + 35*b1*(r*(24*s - 7) + 12*s**2 - 17*s + 4) + r*(-612*C*s + 140*C + 972*s - 245) - 180*s**2 - 311*s + 90) + k2*(Pkd2*(4*C*(r*(70 - 306*s) + 900*s**2 - 392*s + 45) + 35*b1*(2*r*(24*s - 7) - 12*s**2 - 13*s + 5) + 1944*r*s - 490*r - 1980*s**2 + 323*s + 45) + Pkdd2*k2*(-60*C + 35*b1 + 45)*(12*s**2 - 7*s + 1)))) + k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1)*(2574*K*b1 - 2574*b1 - 5148*g2)))/(9009*d**2*k2*k3**4) - 2*D1**3*Pk3*ct**3*k1*st**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*D1*bd1*f**2*s*(3*s - 2) + b1**2*(D1*fd*(f*(34*s**2 - 37*s + 10) + 6*(s - 1)**2) + Dd*f*(4*s - 1)*(17*f*s - 10*f + 6*s - 6)) + b1*f*(2*D1*bd1*s*(17*f*s - 10*f + 6*s - 6) + 3*D1*fd*(6*s**2 - 7*s + 2) + 3*Dd*f*(12*s**2 - 11*s + 2)))/(21*d**2*k2**3) - 8*D1**3*Pk3*ct**3*st**2*(13*D1*bd1*f*k1**2*(f**2*k2**2*(k1**2*(4*Pk2*(1362*r**2 + 6*r*(358*s - 327) + 786*s**2 - 1273*s + 298) + Pkd2*k2*(9*r*(128*s - 13) + 1152*s**2 - 1495*s + 721)) - 66*k2**2*(Pk2*(5*r**2 - 45*r*s + 17*r - 50*s**2 + 57*s - 13) + 5*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + 33*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(7*r**2 + 39*r*s - 18*r + 32*s**2 - 36*s + 4) - 2*K*(32*r**2 + 47*r*s - 35*r + 15*s**2 - 7*s + 3) + 95*r**2 + 154*r*s - 124*r + 59*s**2 - 74*s + 43) + Pkd2*k2*(C*(r*(22 - 50*s) - 50*s**2 + 58*s - 8) - 9*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 74*r*s - 31*r + 74*s**2 - 88*s + 17)) + k2**4*(Pk2*(12*C*r**2 + 132*C*r*s - 32*C*r + 72*C*s**2 - 96*C*s - 2*K*(155*r**2 + 335*r*s - 233*r + 180*s**2 - 226*s + 78) + 6*b1*(r + s - 1) + 69*r**2 + 103*r*s - 81*r + 58*s**2 - 40*s + 32) + Pkd2*k2*(-24*C*(r*(4*s - 2) + 3*s**2 - 4*s + 1) - 6*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + b1*(17*r*(4*s - 1) + 68*s**2 - 65*s + 7) + 42*r*s - 27*r + 30*s**2 - 45*s + 9))) - 33*k2**2*(-b1*k1**2*(K - 1)*(2*Pk2*(26*r**2 + 2*r*(65*s - 31) + 104*s**2 - 94*s + 13) + Pkd2*k2*(r*(23 - 78*s) + s*(55 - 78*s))) + 6*b1*k2**2*(-2*Pk2*(K*(4*r*s - 3*r + 4*s**2 - 5*s + 2) + 4*r**2 + 4*r*s - 2*r - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 2*g2*k1**2*(2*Pk2*(13*r**2 + r*(65*s - 36) + s*(52*s - 52)) + Pkd2*k2*(r*(23 - 39*s) - s*(39*s - 39))) - 24*g2*k2**2*(-Pk2 + Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)))) + 429*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(13*K - 13)*(2*Pk2*(r**2 + r*(5*s - 2) + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + k2**2*(2*Pk2*(12*K*(r*(s - 2) + (s - 1)**2) + f*(37*r + 37*s - 27) + 12*r**2 + 12*r*(s + 1) + 12*s - 6) + Pkd2*k2*s*(f*(68*r + 68*s - 31) + (12 - 24*K)*(r + s)))) + Dd*f*(k1**2*(K - 1)*(2*Pk2*(52*r**2 + 2*r*(130*s - 57) + 208*s**2 - 162*s + 39) + Pkd2*k2*(r*(23 - 156*s) + s*(71 - 156*s))) + k2**2*(4*Pk2*(3*K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 5*f*(4*r + 4*s - 3) + 24*r**2 + 24*r*s - 3*r + 6*s - 9) + Pkd2*k2*(f*(17*r*(8*s - 1) + 136*s**2 - 96*s + 7) + (6 - 12*K)*(r*(8*s - 1) + 4*s*(2*s - 1)))))) + 13*b1*k1**2*(3*D1*(f**2*fd*k2**2*(k1**2*(4*Pk2*(1362*r**2 + 4*r*(537*s - 316) + 786*s**2 - 759*s + 278) + Pkd2*k2*(3*r*(384*s - 659) + 1152*s**2 - 2987*s + 1351)) - 11*k2**2*(2*Pk2*(15*r**2 - 135*r*s + 6*r - 150*s**2 + 101*s - 8) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) + 11*f*(fd*k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + fd*k1**2*k2**2*(2*Pk2*(4*C*(7*r**2 + r*(39*s - 14) + 32*s**2 - 25*s + 7) - 2*K*(64*r**2 + 94*r*s - 48*r + 30*s**2 - 19*s + 2) + 190*r**2 + 308*r*s - 193*r + 118*s**2 - 145*s + 33) + Pkd2*k2*(-100*C*s**2 + 44*C*s - 9*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + r*(-100*C*s + 148*s - 27) + 148*s**2 - 98*s + 15)) + fd*k2**4*(Pk2*(4*C*(6*r**2 + r*(66*s - 51) + 36*s**2 - 79*s + 36) - 2*K*(310*r**2 + 670*r*s - 358*r + 360*s**2 - 366*s + 93) + 138*r**2 + 206*r*s - 66*r + 116*s**2 - 10*s - 43) - 3*Pkd2*k2*(48*C*s**2 - 32*C*s + 2*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 4*r*(16*C*s - 7*s - 2) - 20*s**2 + 5*s + 4)) + 2*gd2*k1**2*k2**2*(-2*Pk2*(13*r**2 + 13*r*(5*s - 2) + 52*s**2 - 42*s + 13) + Pkd2*k2*s*(39*r + 39*s - 16)) + 24*gd2*k2**4*(Pk2*(-2*r*(s - 1) - 2*s**2 + 3*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1))) + 22*fd*g2*k2**2*(-13*k1**2*(2*Pk2*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1) - 3*Pkd2*k2*s*(r + s)) + 24*k2**2*(-Pk2*(r*(s - 2) + (s - 1)**2) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(2*k1**2*(4*Pk2*(2724*r**2 + 3*r*(1432*s - 959) + 1572*s**2 - 1775*s + 566) + Pkd2*k2*(144*r*(16*s - 21) + 2304*s**2 - 5228*s + 2387)) - 33*k2**2*(Pk2*(40*r**2 - 360*r*s + 46*r - 400*s**2 + 316*s - 42) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 33*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + k1**2*k2**2*(2*Pk2*(2*C*(28*r**2 + 12*r*(13*s - 5) + 128*s**2 - 118*s + 25) - 2*K*(128*r**2 + 2*r*(94*s - 59) + 60*s**2 - 33*s + 8) + 380*r**2 + 616*r*s - 449*r + 236*s**2 - 301*s + 113) + Pkd2*k2*(-2*C*(r*(100*s - 11) + 100*s**2 - 69*s + 4) - 9*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) + 296*r*s - 67*r + 296*s**2 - 252*s + 41)) + k2**4*(Pk2*(8*C*(6*r**2 + r*(66*s - 37) + 36*s**2 - 70*s + 24) - 2*K*(620*r**2 + 1340*r*s - 824*r + 720*s**2 - 818*s + 249) + 276*r**2 + 412*r*s - 218*r + 232*s**2 - 68*s - 9) - 3*Pkd2*k2*(8*C*(2*r*(8*s - 1) + 12*s**2 - 11*s + 1) + K*(64*r*s - 30*r + 64*s**2 - 76*s + 22) - 56*r*s - r - 40*s**2 + 28*s + 3))) + 66*g2*k2**2*(-k1**2*(2*Pk2*(52*r**2 + 2*r*(130*s - 57) + 208*s**2 - 162*s + 39) + Pkd2*k2*(r*(23 - 156*s) + s*(71 - 156*s))) + 12*k2**2*(Pk2*(-8*r*s + 9*r - 8*s**2 + 12*s - 6) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(f**2*fd*k1**2*(14040*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 25*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4120*s - 1693) + 4120*s**2 - 5004*s + 1325) + 13*k1**2*k2**2*(-2*Pk2*(2208*r**2 + 3*r*(14356*s - 4231) + 40860*s**2 - 40327*s + 7939) + 125*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(fd*(Pk2*k2**6*(4*C - 2)*(738*r**2 - 9*r*(50*s + 93) + 414*s + 109) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) - 3*k1**4*k2**2*(4*C*Pk2*(987*r**2 + r*(729*s - 758) + 270*s**2 + 171*s - 25) - 6*Pk2*(964*r**2 + r*(1646*s - 1129) + 858*s**2 - 864*s + 279) + Pkd2*k2*(8*C*(492*r*s - 197*r + 360*s**2 - 525*s + 146) - 2292*r*s + 929*r - 1764*s**2 + 2490*s - 689)) + k1**2*k2**4*(Pk2*(-4*C*(7587*r**2 + 9*r*(3927*s - 1409) + 12708*s**2 - 22926*s + 5687) + 13563*r**2 + 9*r*(8329*s - 2813) + 31302*s**2 - 49848*s + 11741) - 12*Pkd2*k2*(C*(3*r*(222*s - 85) + 402*s**2 - 710*s + 203) - (3*s - 1)*(45*r + s - 52)))) - 66*k1**2*(2*Pk2*bd2*k2**4*(31*r**2 + r*(62*s - 48) + 31*s**2 - 48*s + 17) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) - k1**2*k2**2*(4*Pk2*(32*r**2 + r*(47*s - 35) + 15*s**2 - 7*s + 3) + 9*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)) - 2*k2**4*(Pk2*(155*r**2 + r*(335*s - 233) + 180*s**2 - 226*s + 78) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))))) - 858*fd*k1**2*(2*Pk2*b2*k2**4*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) - k1**2*k2**2*(4*Pk2*(64*r**2 + 94*r*s - 48*r + 30*s**2 - 19*s + 2) + 9*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5)) - 2*k2**4*(Pk2*(310*r**2 + 670*r*s - 358*r + 360*s**2 - 366*s + 93) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(f**2*k1**2*(14040*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 25*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4120*s - 1693) + 4120*s**2 - 5004*s + 1325) + 13*k1**2*k2**2*(-2*Pk2*(2208*r**2 + 3*r*(14356*s - 4231) + 40860*s**2 - 40327*s + 7939) + 125*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(Pk2*k2**6*(8*C - 4)*(492*r**2 - 12*r*(25*s + 53) + 334*s + 149) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(r*(204*s - 98) + 204*s**2 - 281*s + 81) - 3*k1**4*k2**2*(2*Pk2*(4*C*(658*r**2 + 486*r*s - 537*r + 180*s**2 + 204*s - 19) - 3856*r**2 - 6584*r*s + 4679*r - 3432*s**2 + 3308*s - 1165) + Pkd2*k2*(2*C*(2624*r*s - 989*r + 1920*s**2 - 2954*s + 785) - 3056*r*s + 1181*r - 2352*s**2 + 3518*s - 941)) + k1**2*k2**4*(Pk2*(-4*C*(10116*r**2 + 84*r*(561*s - 197) + 16944*s**2 - 32918*s + 7025) + 18084*r**2 + 99948*r*s - 32380*r + 41736*s**2 - 70864*s + 14283) - 12*Pkd2*k2*(C*(888*r*s - 314*r + 536*s**2 - 998*s + 262) - 180*r*s + 58*r - 4*s**2 + 235*s - 65))) - 858*k1**2*(2*Pk2*b2*k2**4*(124*r**2 + r*(248*s - 161) + 124*s**2 - 161*s + 51) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) - k1**2*k2**2*(4*Pk2*(128*r**2 + 2*r*(94*s - 59) + 60*s**2 - 33*s + 8) + 9*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) - 2*k2**4*(Pk2*(620*r**2 + 1340*r*s - 824*r + 720*s**2 - 818*s + 249) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(9009*d**2*k1*k2*k3**6) + 8*D1**3*Pk3*ct**3*(D1*bd1*f*(f**2*k1**2*(726*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + 5*k1**4*(2*Pk2*(60*r**2 + 102*r*s - 223*r + 42*s**2 - 175*s + 123) + Pkd2*k2*(18*r*s + 143*r + 18*s**2 + 95*s - 103)) + 33*k1**2*k2**2*(Pk2*(148*r**2 + 368*r*s - 275*r + 220*s**2 - 317*s + 71) + 5*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + 33*f*(Pk2*k2**6*(2 - 4*C)*(6*r**2 - 7*r*s - 5*r + 2*s - 2) + 2*k1**6*(Pk2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(s - 10) + s**2 - 15*s + 10) + 4*r**2 - 9*r*s + 12*r - 13*s**2 + 29*s - 12) - 2*Pkd2*k2*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(s - 1)*(r + s - 1) - 7*r*s + 5*r - 7*s**2 + 11*s - 4)) - k1**4*k2**2*(Pk2*(4*C*(43*r**2 + 125*r*s - 65*r - 14*s**2 - 80*s + 46) + 206*K*r**2 + 362*K*r*s - 272*K*r + 156*K*s**2 - 140*K*s + 66*K + 12*b1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 472*r**2 - 885*r*s + 718*r - 221*s**2 + 593*s - 342) + 2*Pkd2*k2*(K*(r*(58*s - 31) + 58*s**2 - 88*s + 31) + 3*b1*(8*s + 1)*(r + s - 1) + 6*r*(C*(6*s - 4) - 12*s + 7) + (3*s - 3)*(s*(20*C - 28) + 7))) + k1**2*k2**4*(Pk2*(-4*C*(42*r**2 - 196*r*s + 41*r - 27*s**2 + 65*s - 62) - 424*K*r**2 - 820*K*r*s + 650*K*r - 396*K*s**2 + 584*K*s - 226*K + b1*(54*r**2 + r*(66*s - 155) + 12*s**2 - 77*s + 83) + 314*r**2 - 47*r*s - 242*r + 61*s**2 - 81*s - 2) + 6*Pkd2*k2*(-2*C*(s - 1)*(2*r + 6*s + 1) - 16*K*r*s + 6*K*r - 16*K*s**2 + 20*K*s - 6*K + b1*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) + 6*r*s - 4*r + 10*s**2 - 9*s - 1))) + 66*k1**2*(5*Pk2*b1**2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 20*Pk2*b2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(2*Pk2*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(6*r**2 + r*(54*s - 29) + 48*s**2 - 43*s + 9) - 14*r**2 - 10*r*(7*s - 4) - 56*s**2 + 54*s - 12) + Pkd2*k2*(r*(K*(13 - 38*s) + 40*s - 10) + s*(K*(25 - 38*s) + 40*s - 30))) + k2**4*(Pk2*(8*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) + 2*K*(33*r**2 + 104*r*s - 55*r + 71*s**2 - 67*s + 9) + 21*r**2 + 118*r*s - 13*r - 15*s**2 - 37*s + 8) + Pkd2*k2*(r*(K*(10 - 26*s) + 28*s - 7) + s*(-26*K*s + 16*K + 28*s - 21)))) - 2*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + k1**2*k2**2*(Pk2*(6*r**2 + r*(54*s - 34) + s*(48*s - 48)) + Pkd2*k2*(r*(13 - 19*s) - s*(19*s - 19))) + k2**4*(Pk2*(33*r**2 + r*(104*s - 59) + s*(71*s - 71)) + Pkd2*k2*(r*(10 - 13*s) - s*(13*s - 13)))))) + 330*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*k1**2*(D1*fd*(k1**4*s*(4 - 4*K)*(2*Pk2 - Pkd2*k2)*(r + s) + 2*k1**2*k2**2*(-2*Pk2*(4*C*(r + s - 1)**2 + 3*K*r**2 + 27*K*r*s - 18*K*r + 24*K*s**2 - 18*K*s + 9*K - 3*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 7*r**2 - 35*r*s + 24*r - 28*s**2 + 24*s - 12) + Pkd2*k2*s*(3*f*(8*r + 8*s - 3) + (19*K - 20)*(r + s))) - k2**4*(Pk2*(16*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 66*K*r**2 + 208*K*r*s - 72*K*r + 142*K*s**2 - 72*K*s + 36*K + f*(54*r**2 + 66*r*s - 29*r + 12*s**2 + s - 17) + 21*r**2 + 118*r*s + 80*r - 15*s**2 - 32*s - 40) + 2*Pkd2*k2*s*(3*f*(12*r + 12*s - 5) - (13*K - 14)*(r + s)))) + Dd*f*(k1**4*(2 - 2*K)*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 2*k1**2*k2**2*(-2*Pk2*(4*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 12*K*r**2 + 108*K*r*s - 59*K*r + 96*K*s**2 - 80*K*s + 27*K - 6*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 28*r**2 - 140*r*s + 83*r - 112*s**2 + 104*s - 36) + Pkd2*k2*(3*f*(16*r*s + r + 16*s**2 - 10*s - 1) + r*(76*K*s - 13*K - 80*s + 10) + s*(76*K*s - 31*K - 80*s + 40))) - k2**4*(Pk2*(16*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 264*K*r**2 + 832*K*r*s - 394*K*r + 568*K*s**2 - 466*K*s + 108*K + 2*f*(54*r**2 + 66*r*s - 92*r + 12*s**2 - 38*s + 33) + 84*r**2 + 472*r*s + 73*r - 60*s**2 - 195*s - 64) + 2*Pkd2*k2*(f*(9*r*(8*s - 1) + 72*s**2 - 48*s + 3) + r*(-52*K*s + 10*K + 56*s - 7) + s*(-52*K*s + 19*K + 56*s - 28))))) + b1*(D1*(f**2*fd*k1**2*(726*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + 5*k1**4*(6*Pk2*(60*r**2 + 2*r*(51*s - 73) + 42*s**2 - 123*s + 74) + Pkd2*k2*(6*r*(9*s + 23) + 54*s**2 + 69*s - 92)) + 33*k1**2*k2**2*(Pk2*(444*r**2 + 1104*r*s - 561*r + 660*s**2 - 607*s + 191) + 5*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) + 33*f*(fd*(Pk2*k2**6*(2 - 4*C)*(2*r - 1)*(6*r - 7*s - 9) + 2*k1**6*(Pk2*(K*(r*(2*s - 13) + 2*s**2 - 15*s + 7) + 8*r**2 + r*(32*C*s - 18*s + 5) + (2*s - 1)*(16*C*s - 13*s + 5)) - 2*Pkd2*k2*(2*r + 2*s - 1)*(3*K*(s - 1) + s*(4*C - 7) + 3)) + k1**4*k2**2*(Pk2*(-4*C*(86*r**2 + r*(250*s - 117) - 28*s**2 - 183*s + 51) - 2*K*(206*r**2 + 362*r*s - 196*r + 156*s**2 - 116*s + 19) + 944*r**2 + 1770*r*s - 1089*r + 442*s**2 - 1083*s + 293) - 4*Pkd2*k2*(K*(r*(58*s - 38) + 58*s**2 - 73*s + 22) + 3*r*(s*(12*C - 24) + 7) + 3*s**2*(20*C - 28) + 3*s*(17 - 2*C) - 12)) - k1**2*k2**4*(Pk2*(4*C*(84*r**2 - 2*r*(196*s + 81) - 54*s**2 + 237*s + 62) + 4*K*(212*r**2 + 410*r*s - 224*r + 198*s**2 - 203*s + 52) - 628*r**2 + 94*r*s + 749*r - 122*s**2 - 159*s - 197) + 12*Pkd2*k2*(K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(2*C*r + 6*C*s + C - 3*r - 5*s)))) + 4*k1**2*(10*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-k1**4*s*(2*Pk2 - Pkd2*k2)*(2*r + 2*s - 1) + k1**2*k2**2*(-2*Pk2*(3*r**2 + 3*r*(9*s - 4) + 24*s**2 - 19*s + 9) + Pkd2*k2*s*(19*r + 19*s - 6)) + k2**4*(-Pk2*(33*r**2 + 104*r*s - 51*r + 71*s**2 - 63*s + 18) + Pkd2*k2*s*(13*r + 13*s - 3))))) + 132*fd*k1**2*(10*Pk2*b2*k2**4*(r + s)**2 + g2*(-2*k1**4*s*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(-6*Pk2*(r**2 + 9*r*s - 6*r + 8*s**2 - 6*s + 3) + 19*Pkd2*k2*s*(r + s)) + k2**4*(-Pk2*(33*r**2 + 4*r*(26*s - 9) + 71*s**2 - 36*s + 18) + 13*Pkd2*k2*s*(r + s))))) + Dd*f*(f**2*k1**2*(726*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + 5*k1**4*(2*Pk2*(240*r**2 + 408*r*s - 661*r + 168*s**2 - 544*s + 345) + Pkd2*k2*(72*r*s + 281*r + 72*s**2 + 164*s - 195)) + 66*k1**2*k2**2*(Pk2*(296*r**2 + r*(736*s - 418) + 440*s**2 - 462*s + 131) + 5*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) + 33*f*(Pk2*k2**6*(4 - 8*C)*(2*r - 1)*(6*r - 7*s - 8) + 2*k1**6*(Pk2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + K*(4*r*s - 33*r + 4*s**2 - 45*s + 27) + 16*r**2 - 36*r*s + 21*r - 52*s**2 + 73*s - 25) - 2*Pkd2*k2*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 3*K*(s - 1)*(4*r + 4*s - 3) - 28*r*s + 14*r - 28*s**2 + 33*s - 10)) + k1**4*k2**2*(Pk2*(-16*C*(43*r**2 + r*(125*s - 62) - 14*s**2 - 98*s + 30) - 2*K*(412*r**2 + 724*r*s - 468*r + 312*s**2 - 256*s + 85) + 1888*r**2 + 3540*r*s - 2537*r + 884*s**2 - 2377*s + 893) + 2*Pkd2*k2*(-2*K*(r*(116*s - 69) + 116*s**2 - 161*s + 53) - 3*r*(8*C*(6*s - 1) - 96*s + 34) - 3*s**2*(80*C - 112) - 3*s*(92 - 28*C) + 63)) + k1**2*k2**4*(Pk2*(-4*C*(168*r**2 - r*(784*s + 221) - 108*s**2 + 461*s + 58) - 4*K*(424*r**2 + 820*r*s - 549*r + 396*s**2 - 495*s + 165) + 1256*r**2 - 188*r*s - 1517*r + 244*s**2 + 183*s + 407) - 6*Pkd2*k2*(2*C*(4*s - 1)*(2*r + 6*s + 1) + K*(64*r*s - 30*r + 64*s**2 - 76*s + 22) - 24*r*s + 4*r - 40*s**2 + 10*s + 1))) + 132*k1**2*(10*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(-k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(-2*Pk2*(12*r**2 + r*(108*s - 59) + 96*s**2 - 80*s + 27) + Pkd2*k2*(r*(76*s - 13) + s*(76*s - 31))) + k2**4*(-Pk2*(132*r**2 + r*(416*s - 197) + 284*s**2 - 233*s + 54) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))))))) + f*(D1*(-10*f**2*fd*k1**4*(61*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + 2*k1**2*(Pk2*(455*r**2 - 379*r*s - 154*r - 834*s**2 + 955*s - 176) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) + f*(fd*(Pk2*k2**6*(66 - 132*C)*(3*r - 1)*(2*r + 2*s - 1) - 4*k1**6*(C*Pk2*(15*r*(27*s + 35) + 405*s**2 + 288*s - 361) - 3*Pk2*(75*r**2 + 15*r*(19*s + 5) + 210*s**2 - 4*s - 87) + Pkd2*k2*(165*C - 165)*(s - 1)*(3*r + 3*s - 2)) + k1**4*k2**2*(Pk2*(-12*C*(3666*r**2 + 6*r*(905*s - 753) + 3216*s**2 - 2733*s + 1049) + 46242*r**2 + 79821*r*s - 59547*r + 42291*s**2 - 45066*s + 16165) - 10*Pkd2*k2*(2*C*(981*r*s - 591*r + 981*s**2 - 1311*s + 416) - 1476*r*s + 921*r - 1476*s**2 + 2004*s - 647)) - 3*k1**2*k2**4*(Pk2*(4*C*(6756*r**2 + 11178*r*s - 8549*r + 5874*s**2 - 6872*s + 2495) - 17439*r**2 - 29121*r*s + 21421*r - 14586*s**2 + 16868*s - 5969) + Pkd2*k2*(880*C - 440)*(2*s - 1)*(3*r + 3*s - 2))) - 132*k1**2*(2*Pk2*bd2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(r + s - 1) + gd2*(k1**4*(Pk2*(r*(s - 10) + s**2 - 15*s + 10) - 6*Pkd2*k2*(s - 1)*(r + s - 1)) - k1**2*k2**2*(Pk2*(103*r**2 + 181*r*s - 136*r + 78*s**2 - 70*s + 33) + Pkd2*k2*(58*r*s - 31*r + 58*s**2 - 88*s + 31)) - k2**4*(Pk2*(212*r**2 + 5*r*(82*s - 65) + 198*s**2 - 292*s + 113) + 6*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))))) - 132*fd*k1**2*(2*Pk2*b2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + g2*(k1**4*(Pk2*(2*r*s - 13*r + 2*s**2 - 15*s + 7) - 6*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) - k1**2*k2**2*(Pk2*(206*r**2 + 362*r*s - 196*r + 156*s**2 - 116*s + 19) + 2*Pkd2*k2*(58*r*s - 38*r + 58*s**2 - 73*s + 22)) - 2*k2**4*(Pk2*(212*r**2 + 410*r*s - 224*r + 198*s**2 - 203*s + 52) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-10*f**2*k1**4*(61*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + 2*k1**2*(Pk2*(455*r**2 - 379*r*s - 154*r - 834*s**2 + 955*s - 176) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) + f*(Pk2*k2**6*(132 - 264*C)*(2*r - 1)*(2*r + 2*s - 1) - 4*k1**6*(Pk2*(C*(r*(540*s + 805) + 540*s**2 + 549*s - 641) - 300*r**2 - 380*r*(3*s + 1) - 840*s**2 - 124*s + 491) + Pkd2*k2*(165*C - 165)*(s - 1)*(4*r + 4*s - 3)) + k1**4*k2**2*(Pk2*(-4*C*(14664*r**2 + 21720*r*s - 19138*r + 12864*s**2 - 10724*s + 5065) + 61656*r**2 + 106428*r*s - 83351*r + 56388*s**2 - 60485*s + 24555) - 20*Pkd2*k2*(C*(1308*r*s - 761*r + 1308*s**2 - 1803*s + 586) - 984*r*s + 595*r - 984*s**2 + 1380*s - 458)) - 3*k1**2*k2**4*(Pk2*(8*C*(4504*r**2 + 7452*r*s - 6101*r + 3916*s**2 - 4799*s + 1948) - 23252*r**2 - 38828*r*s + 30542*r - 19448*s**2 + 23552*s - 9277) + Pkd2*k2*(220*C - 110)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) - 132*k1**2*(2*Pk2*b2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + g2*(k1**4*(Pk2*(4*r*s - 33*r + 4*s**2 - 45*s + 27) - 6*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) - k1**2*k2**2*(Pk2*(412*r**2 + 724*r*s - 468*r + 312*s**2 - 256*s + 85) + 2*Pkd2*k2*(116*r*s - 69*r + 116*s**2 - 161*s + 53)) - 2*k2**4*(Pk2*(424*r**2 + 820*r*s - 549*r + 396*s**2 - 495*s + 165) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(693*d**2*k1*k2*k3**6) - 2*D1**3*Pk3*ct**3*(D1*bd1*f**2*(4*Pk2*k1**2*s*(67 - 59*s) + Pkd2*k1**2*k2*s*(95*s - 103) - Pkd2*k2**3*(8*C - 4)*(r*(4*s - 1) - s) - 2*k2**2*(Pk2*(6*r**2 + r*(-34*C*s + 10*C + 17*s - 10) + s*(8*C - 4)) + 6*Pkdd2*k1**2*s*(s - 1))) + 5*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - b1**2*k1**2*(D1*(-5*bd1*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + fd*(4*Pk2*(f*(204*s**2 - 242*s + 70) + 91*s**2 - 174*s + 87) + k2*(-Pkd2*(2*f*(156*s**2 - 184*s + 53) + 139*s**2 - 258*s + 129) + 2*Pkdd2*k2*(3*f*(6*s**2 - 7*s + 2) + 8*s**2 - 14*s + 7)))) + Dd*f*(4*s - 1)*(4*Pk2*(2*f*(51*s - 35) + 91*s - 87) + k2*(Pkd2*(-156*f*s + 106*f - 139*s + 129) + 2*Pkdd2*k2*(9*f*s - 6*f + 8*s - 7)))) - b1*f*(2*D1*bd1*k1**2*s*(4*Pk2*(2*f*(51*s - 35) + 91*s - 89) + k2*(Pkd2*(-2*f*(78*s - 53) - 139*s + 134) + Pkdd2*k2*(6*f*(3*s - 2) + 16*s - 15))) + D1*fd*(k1**2*(2*s - 1)*(4*Pk2*(59*s - 67) + k2*(Pkd2*(103 - 95*s) + 12*Pkdd2*k2*(s - 1))) + 2*k2**2*(2*r - 1)*(Pk2*(C*(18 - 34*s) + 6*r + 17*s - 14) + Pkd2*k2*(8*C - 4)*(2*s - 1))) + Dd*f*k1**2*(4*s - 1)*(4*Pk2*(59*s - 67) + k2*(Pkd2*(103 - 95*s) + 12*Pkdd2*k2*(s - 1))) + 4*Dd*f*k2**2*(2*r - 1)*(Pk2*(C*(14 - 34*s) + 6*r + 17*s - 12) + Pkd2*k2*(2*C - 1)*(8*s - 3))))/(21*d**2*k1*k2**3) - 2*D1**3*Pk3*ct**3*st**2*(33*b1**2*k1**2*k2**2*(D1*fd*(8*Pk2*(-12*K*(s - 1)*(r - s + 1) + f*(37*s - 10) + 12*r*s - 12*r + 12*s - 6) + k2*(Pkd2*f*(50 - 185*s) + 6*Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*f*k2*(37*s - 10) + 6*Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) + 2*Dd*f*(8*Pk2*(24*K*s**2 - 24*K*s + 5*f*(4*s - 1) - r*(3*K - 3)*(8*s - 5) + 6*s + 3) + k2*(Pkd2*(6*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) - 25*f*(4*s - 1) - 48*r*s + 30*r - 48*s + 3) + Pkdd2*k2*(4*s - 1)*(6*K*(s - 1) + 5*f + 3)))) + b1*k1**2*(D1*(f**2*(99*bd1*k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + fd*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1359*s**2 - 1203*s + 250) - 33*k2**2*(6*Pk2*(r*(138*s - 77) + 400*s**2 - 320*s + 76) + k2*(Pkd2*(-24*r*(9*s - 5) - 825*s**2 + 649*s - 146) + 5*Pkdd2*k2*(15*s**2 - 11*s + 2))))) + 33*f*(fd*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2) + k2**2*(-2*Pk2*(2*C*(2*r*(63*s - 31) - 144*s**2 + 121*s - 25) + 8*K*(34*s**2 - 37*s + 10) + 59*r*s - 58*r + 712*s**2 - 726*s + 168) + k2*(Pkd2*(4*C*(2*s - 1)*(16*r - 45*s + 24) + 10*K*(34*s**2 - 37*s + 10) + 20*r*s - 22*r + 536*s**2 - 623*s + 155) + Pkdd2*k2*(12*C*(6*s**2 - 7*s + 2) + K*(-68*s**2 + 74*s - 20) - 60*s**2 + 87*s - 24)))) + 6*k2**2*(-8*Pk2*bd1*(K*(r*(4*s - 2) - 4*s**2 + 3*s + 1) + r*(2 - 4*s) - 1) + 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*k2*(Pkd2*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2) + Pkdd2*k2*s*(4*K*(s - 1) + 1)) - 4*gd2*k2*(Pkd2*(r*(2*s - 1) - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1)))) - 792*fd*g2*k2**2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + Dd*f*(f**2*(2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(1812*s**2 - 1453*s + 250) - 33*k2**2*(4*Pk2*(6*r*(46*s - 29) + 800*s**2 - 602*s + 153) + k2*(Pkd2*(-36*r*(8*s - 5) - 1100*s**2 + 803*s - 186) + 5*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 33*f*(3*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2) + k2**2*(-2*Pk2*(4*C*(18*r*(7*s - 3) - 144*s**2 + 85*s - 1) + 8*K*(68*s**2 - 57*s + 10) + 118*r*s - 104*r + 1424*s**2 - 1247*s + 260) + k2*(Pkd2*(4*C*(4*r*(16*s - 7) - 180*s**2 + 141*s - 18) + 10*K*(68*s**2 - 57*s + 10) + 40*r*s - 38*r + 1072*s**2 - 992*s + 195) + 2*Pkdd2*k2*(4*s - 1)*(6*C*(3*s - 2) + K*(10 - 17*s) - 15*s + 12)))) - 792*g2*k2**2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1)))) + f*(D1*(bd1*f**2*k1**2*(48*Pk2*k1**2*s*(453*s - 250) + 18*Pkd2*k1**2*k2*s*(250 - 453*s) + 33*Pkd2*k2**3*(12*r*(6*s - 5) + 275*s**2 - 154*s + 40) - 165*Pkdd2*k2**4*s*(5*s - 2) - 2*k2**2*(33*Pk2*(3*r*(46*s - 39) + 400*s**2 - 244*s + 78) + Pkdd2*k1**2*s*(250 - 453*s))) + f*(fd*(6*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(126*s**2 - 117*s + 25) + k1**2*k2**2*(-Pk2*(32*C*(1359*s**2 - 1203*s + 250) + 3*r*(6807*s - 3754) + 20808*s**2 - 16059*s + 4526) + k2*(Pkd2*(20*C*(1359*s**2 - 1203*s + 250) + 5328*r*s - 2964*r + 612*s**2 + 159*s + 275) - 2*Pkdd2*k2*(3*s - 1)*(C*(906*s - 500) - 255*s + 151))) - 2*k2**4*(Pk2*(C*(-18*r*(166*s - 59) + 2052*s - 706) + 684*r**2 + 9*r*(166*s - 161) - 1026*s + 583) + Pkd2*k2*(16*C - 8)*(27*r - 20)*(3*s - 1))) + 33*k1**2*(bd1*(72*Pk2*k1**2*s*(3*s - 2) + 27*Pkd2*k1**2*k2*s*(2 - 3*s) + 2*Pkd2*k2**3*(r*(4*C*(8*s - 3) + 5*s - 4) + s**2*(-90*C + 85*K + 134) + s*(60*C - 50*K - 93) + 16) + Pkdd2*k2**4*s*(12*C*(3*s - 2) + K*(20 - 34*s) - 30*s + 15) + k2**2*(Pk2*(r*(C*(92 - 252*s) - 59*s + 46) + s**2*(288*C - 272*K - 712) + s*(-192*C + 160*K + 579) - 138) + 3*Pkdd2*k1**2*s*(3*s - 2))) + k2**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-2*bd2 + 4*gd2)*(17*s - 10))) - 66*k1**2*k2**2*(b2*fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(34*s**2 - 37*s + 10) - 2*g2*(6*bd1*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) + fd*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(34*s**2 - 37*s + 10)))) + Dd*f*(f*(6*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(168*s**2 - 142*s + 25) + k1**2*k2**2*(-2*Pk2*(16*C*(1812*s**2 - 1453*s + 250) + 13614*r*s - 7708*r + 13872*s**2 - 12219*s + 4340) + k2*(Pkd2*(20*C*(1812*s**2 - 1453*s + 250) + 7104*r*s - 4052*r + 816*s**2 - 1104*s + 1363) - 2*Pkdd2*k2*(4*s - 1)*(C*(906*s - 500) - 255*s + 151))) - 4*k2**4*(Pk2*(-2*C*(996*r*s - 362*r - 866*s + 273) + 456*r**2 + 996*r*s - 1050*r - 866*s + 503) + Pkd2*k2*(8*C - 4)*(r*(108*s - 37) - 100*s + 30))) + k1**2*k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(-66*b2 + 132*g2)*(68*s**2 - 57*s + 10))))/(693*d**2*k1*k2**3*k3**2) + 2*D1**3*Pk3*ct**3*(165*b1**3*k1**2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*k1**2*(D1*(5*bd1*f*k2**3*s*(Pkd2 - Pkdd2*k2)*(3*s - 1) + fd*(Pk2*k1**2*s**2*(64*f - 16) + Pkd2*k1**2*k2*s**2*(10 - 40*f) + Pkd2*k2**3*(-28*C*r*s + 8*C*s**2 + 28*C*s + 2*K*(-28*r*(s - 1) + 78*s**2 - 146*s + 73) + f*(-8*r*(s - 3) + 182*s - 58) + 90*r*s - 56*r - 6*s**2 + 118*s - 73) - 2*Pkdd2*k2**4*(4*C*s**2 + K*(19*s**2 - 28*s + 14) + 3*f*(7*s - 2) - 3*s**2 + 14*s - 7) + k2**2*(Pk2*(56*C*r*s - 56*C*s + 2*K*(s - 1)*(115*r - 118*s + 118) + f*(r*(8*s - 52) - 274*s + 94) - 291*r*s + 230*r - 180*s + 118) + Pkdd2*k1**2*s**2*(8*f - 2)))) + Dd*f*(Pk2*k1**2*s*(32*f - 16)*(4*s - 1) - Pkd2*k1**2*k2*s*(20*f - 10)*(4*s - 1) + Pkd2*k2**3*(8*C*(r*(7 - 14*s) + 4*s**2 + 20*s - 7) - 224*K*r*s + 140*K*r + 624*K*s**2 - 684*K*s + 90*K - 2*f*(8*r*(s - 9) - 120*s + 65) + 360*r*s - 178*r - 24*s**2 + 26*s + 39) - 2*Pkdd2*k2**4*(4*s - 1)*(4*C*s + K*(19*s - 14) + 6*f - 3*s + 7) + 2*k2**2*(Pk2*(56*C*(r*(2*s - 1) - 3*s + 1) + 460*K*r*s - 193*K*r - 472*K*s**2 + 538*K*s - 66*K + 4*f*(2*r*s - 37*r - 47*s + 30) - 582*r*s + 231*r + 25*s - 49) + Pkdd2*k1**2*s*(2*f - 1)*(4*s - 1)))) + 33*b1*(D1*(2*f**2*k1**2*(bd1*(16*Pk2*k1**2*s*(1 - 2*s) + 10*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(4*r*(s - 15) - 29*s + 36) + 3*Pkdd2*k2**4*s + k2**2*(Pk2*(-4*r*s + 122*r + 51*s - 73) + 2*Pkdd2*k1**2*s*(1 - 2*s))) + fd*(k1**2*(3*s - 1)*(8*Pk2*(39*s - 29) + k2*(Pkd2*(88 - 123*s) + 5*Pkdd2*k2*(3*s - 2))) + k2**2*(Pk2*(216*r**2 + 9*r*(2*s - 21) - 300*s**2 + 116*s + 48) + Pkd2*k2*(108*r*(2*s - 1) + 165*s**2 - 217*s + 70)))) + f*(fd*(k1**4*(4*Pk2*(134*s**2 - 193*s + 67) + k2*(Pkd2*(-230*s**2 + 301*s - 103) + 4*Pkdd2*k2*(8*s**2 - 9*s + 3))) + k1**2*k2**2*(Pk2*(4*C*(3*r*(16*s + 9) + 140*s**2 - 439*s + 159) + 4*K*(r*s + 13*r - 132*s**2 + 158*s - 46) + 64*r**2 - 504*r*s + 88*r - 640*s**2 + 1763*s - 544) + k2*(-Pkd2*(4*C*(2*r*(11*s + 8) + 98*s**2 - 204*s + 65) + 4*K*(r*(s + 6) - 84*s**2 + 100*s - 29) - 232*r*s + 28*r - 400*s**2 + 809*s - 208) + 4*Pkdd2*k2*(4*C*(7*s**2 - 9*s + 3) - 3*K*(6*s**2 - 7*s + 2) - 14*s**2 + 27*s - 9))) + k2**4*(4*C - 2)*(2*r - 1)*(Pk2*(12*r - 13) + 4*Pkd2*k2)) + k1**2*(bd1*(16*Pk2*k1**2*s*(2*s - 1) + 10*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(8*C*(7*r*(s - 1) - 2*s**2 - 13*s + 7) + 2*K*(56*r*s - 28*r - 156*s**2 + 137*s + 14) - 180*r*s + 94*r + 12*s**2 + 85*s - 84) + 2*Pkdd2*k2**4*s*(C*(8*s - 4) + K*(38*s - 33) - 6*s + 10) + k2**2*(Pk2*(-112*C*(r*(s - 1) - 2*s + 1) - 4*K*(115*r*s - 26*r - 118*s**2 + 105*s + 13) + 582*r*s - 180*r - 199*s + 164) + 2*Pkdd2*k1**2*s*(2*s - 1))) + 2*k2**2*(5*bd2*k2*s**2*(-Pkd2 + Pkdd2*k2) + 2*gd2*(Pk2*(r*(115*s - 26) - 118*s**2 + 92*s + 26) + k2*(Pkd2*(-28*r*s + 14*r + 78*s**2 - 59*s - 14) + Pkdd2*k2*s*(14 - 19*s)))))) - 2*fd*k1**2*k2**2*(-2*Pk2*g2*(s - 1)*(115*r - 118*s + 118) + 5*b2*k2*s**2*(Pkd2 - Pkdd2*k2) + 2*g2*k2*(Pkd2*(28*r*(s - 1) - 78*s**2 + 146*s - 73) + Pkdd2*k2*(19*s**2 - 28*s + 14)))) + Dd*f*(2*f**2*k1**2*(k1**2*(4*s - 1)*(8*Pk2*(39*s - 29) + k2*(Pkd2*(88 - 123*s) + 5*Pkdd2*k2*(3*s - 2))) + k2**2*(2*Pk2*(144*r**2 + 6*r*(2*s - 17) - 200*s**2 + 76*s + 7) + Pkd2*k2*(144*r*(2*s - 1) + 220*s**2 - 287*s + 94))) + f*(k1**4*(4*s - 1)*(268*Pk2*(s - 1) + k2*(Pkd2*(103 - 115*s) + 4*Pkdd2*k2*(4*s - 3))) + 4*k1**2*k2**2*(Pk2*(C*(r*(96*s + 77) + 280*s**2 - 808*s + 134) + K*(2*r*(s + 19) - 264*s**2 + 273*s - 71) + 32*r**2 - 252*r*s + 31*r - 320*s**2 + 840*s - 182) + k2*(-Pkd2*(C*(44*r*(s + 1) + 196*s**2 - 363*s + 51) + K*(2*r*(s + 9) - 168*s**2 + 169*s - 41) - 116*r*s + 18*r - 200*s**2 + 372*s - 75) + Pkdd2*k2*(4*s - 1)*(2*C*(7*s - 6) + K*(6 - 9*s) - 7*s + 9))) + k2**4*(8*C - 4)*(2*r - 1)*(Pk2*(12*r - 13) + 2*Pkd2*k2)) - 2*k1**2*k2**2*(5*b2*k2*s*(Pkd2 - Pkdd2*k2)*(4*s - 1) - 2*g2*(Pk2*(r*(460*s - 193) - 472*s**2 + 538*s - 66) + k2*(Pkd2*(-112*r*s + 70*r + 312*s**2 - 342*s + 45) + Pkdd2*k2*(-76*s**2 + 75*s - 14)))))) + f*(D1*(66*bd1*f**2*k1**2*(8*Pk2*k1**2*s*(39*s - 29) + Pkd2*k1**2*k2*s*(88 - 123*s) + Pkd2*k2**3*(36*r*(2*s - 1) + 55*s**2 - 70*s + 24) + k2**2*(Pk2*(72*r**2 + 6*r*s - 15*r - 100*s**2 + 36*s - 34) + 5*Pkdd2*k1**2*s*(3*s - 2))) + f*(33*bd1*(k1**4*s*(4*Pk2*(67*s - 75) + k2*(Pkd2*(123 - 115*s) + 16*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(280*C*s**2 - 736*C*s + 2*K*(r*(s + 25) - 132*s**2 + 115*s - 25) + 32*r**2 + 2*r*(48*C*s + 50*C - 126*s + 35) - 320*s**2 + 809*s - 186) - k2*(Pkd2*(196*C*s**2 - 324*C*s + 2*K*(r*(s + 12) - 84*s**2 + 69*s - 12) + 4*r*(11*C*s + 14*C - 29*s + 12) - 200*s**2 + 343*s - 96) - 4*Pkdd2*k2*s*(14*C*(s - 1) + K*(6 - 9*s) - 7*s + 7))) + k2**4*(2 - 4*C)*(Pk2*r*(13 - 12*r) + 2*Pkd2*k2*(r - 1))) + fd*k1**4*(3*s - 1)*(Pk2*(5532*s - 7388) + k2*(Pkd2*(2837 - 2373*s) + 330*Pkdd2*k2*(s - 1))) + fd*k1**2*k2**2*(Pk2*(8*C*(9*r*(65*s + 81) - 4752*s**2 + 4821*s - 1387) + 7740*r**2 - 81*r*(143*s + 36) + 5148*s**2 - 19305*s + 7262) - k2*(Pkd2*(4*C*(684*r*s + 630*r - 6237*s**2 + 6273*s - 1684) - 12060*r*s + 4878*r + 3960*s**2 - 2877*s + 233) + Pkdd2*k2*(660*C - 330)*(9*s**2 - 9*s + 2))) + 2*fd*k2**4*(Pk2*(C*(-3636*r**2 + 6*r*(990*s + 349) - 2244*s - 206) + 2016*r**2 - 3*r*(990*s + 371) + 1122*s + 103) + Pkd2*k2*(66 - 132*C)*(3*r - 1)*(2*s - 1)) - k1**2*k2**2*(66*bd2 - 132*gd2)*(-Pk2*(r*(s + 25) - 132*s**2 + 115*s - 25) + k2*(Pkd2*(r*(s + 12) - 84*s**2 + 69*s - 12) + 6*Pkdd2*k2*s*(3*s - 2)))) + 66*k1**2*k2**2*(b2*(2*Pk2*fd*(r*(s + 13) - 132*s**2 + 158*s - 46) + 5*bd1*k2*s*(-Pkd2 + Pkdd2*k2)*(s - 1) - 2*fd*k2*(Pkd2*(r*(s + 6) - 84*s**2 + 100*s - 29) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) + 2*g2*(Pk2*bd1*(r*(115*s - 26) + s*(118 - 118*s)) - 2*Pk2*fd*r*(s + 13) + 4*Pk2*fd*(66*s**2 - 79*s + 23) + 2*Pkd2*fd*k2*(r*(s + 6) - 84*s**2 + 100*s - 29) + 6*Pkdd2*fd*k2**2*(6*s**2 - 7*s + 2) + bd1*k2*(Pkd2*r*(14 - 28*s) + 78*Pkd2*s*(s - 1) - 19*Pkdd2*k2*s*(s - 1))))) + Dd*f*(f*(k1**4*(4*s - 1)*(Pk2*(5532*s - 7388) + k2*(Pkd2*(2837 - 2373*s) + 330*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(2*Pk2*(8*C*(390*r*s + 571*r - 3168*s**2 + 3055*s - 900) + 5160*r**2 - 7722*r*s - 2914*r + 3432*s**2 - 11517*s + 3797) + k2*(Pkd2*(4*C*(-2*r*(456*s + 505) + 8316*s**2 - 7859*s + 2064) + 16080*r*s - 5834*r - 5280*s**2 + 2056*s + 723) + Pkdd2*k2*(330 - 660*C)*(12*s**2 - 11*s + 2))) - 4*k2**4*(Pk2*(2*C*(1212*r**2 - 10*r*(198*s + 101) + 858*s + 235) - 1344*r**2 + 4*r*(495*s + 269) - 858*s - 235) + Pkd2*k2*(132*C - 66)*(2*r - 1)*(2*s - 1))) + k1**2*k2**2*(-132*b2 + 264*g2)*(Pk2*(-2*r*(s + 19) + 264*s**2 - 273*s + 71) + k2*(Pkd2*(2*r*(s + 9) - 168*s**2 + 169*s - 41) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))))))/(693*d**2*k1*k2**3*k3**2) + 2*D1**3*Pk3*ct**3*st**2*(D1*(-429*b1*fd*k1**2*k2**2*(13*b1*k1**2*(K - 1)*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) + 6*b1*k2**2*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1))) - 26*g2*k1**2*(8*Pk2*(r*(s - 1) + 2*s**2 - 2*s + 1) + k2*(Pkd2*(-2*r*s + 2*r - 7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) - 24*g2*k2**2*(-4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(-2*r*s + 4*r - 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))) + f**3*k1**2*(13*bd1*k2**2*(k1**2*(-80*Pk2*(r*(354*s - 125) + 354*s**2 - 437*s + 75) + k2*(Pkd2*(7080*r*s - 2500*r + 7080*s**2 - 10567*s + 1500) + 609*Pkdd2*k2*s)) - 33*k2**2*(-2*Pk2*(60*r**2 + r*(258*s - 31) + 100*s**2 - 60*s - 29) + k2*(Pkd2*(52*r*s + 60*r - 75*s**2 + 78*s - 60) + 5*Pkdd2*k2*s*(5*s - 2)))) + fd*(-25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(788*s**2 - 589*s + 98) + 13*k1**2*k2**2*(8*Pk2*(6*r*(1226*s - 707) + 29760*s**2 - 21086*s + 4613) + k2*(Pkd2*(-15744*r*s + 9000*r - 82020*s**2 + 57313*s - 11734) + 375*Pkdd2*k2*(20*s**2 - 13*s + 2))) + 1560*k2**4*(6*Pk2*(33*r**2 + r*(2*s - 41) - 12*s + 15) + 11*Pkd2*k2*(2*r - 1)*(3*s - 1)))) - 13*f**2*k2**2*(-33*bd1*(k1**4*(2*Pk2*(-128*C*s**2 + 112*C*s + K*(7*r*(13*s - 5) + 204*s**2 - 155*s + 35) + r*(-56*C*s + 24*C - 227*s + 83) - 304*s**2 + 307*s - 107) + k2*(Pkd2*(K*(r*(18 - 46*s) - 75*s**2 + 60*s - 18) + 2*r*(2*C*(7*s - 3) + 57*s - 21) + 2*s**2*(59*C + 49) - 2*s*(55*C + 50) + 54) - 3*Pkdd2*k2*s*(6*C*(s - 1) + K*(3*s - 2) - 6*s + 6))) + k1**2*k2**2*(Pk2*(120*C*r**2 - 132*C*r*s - 24*C*r - 288*C*s**2 + 288*C*s - 2*K*(55*r**2 - 159*r*s + 43*r - 428*s**2 + 391*s - 98) - 12*b1*(r + 2*s - 1) + 224*r**2 + 705*r*s - 362*r + 240*s**2 - 357*s + 90) + k2*(Pkd2*(128*C*r*s - 32*C*r + 180*C*s**2 - 180*C*s - 2*K*(146*r*s - 56*r + 209*s**2 - 203*s + 56) + b1*(6*r - 34*s**2 + 29*s - 6) - 54*r*s - 6*r - 17*s**2 + 42*s + 14) + Pkdd2*k2*s*(-36*C*(s - 1) - 10*K*s + 8*K + 17*b1*(2*s - 1) + 15*s - 21)))) + fd*(3*k1**4*(8*Pk2*(C*(-1065*r*s + 553*r - 2394*s**2 + 2325*s - 575) + 2*b1*(2*r*(885*s - 394) + 1770*s**2 - 1685*s + 534) + 2181*r*s - 1090*r + 3762*s**2 - 3873*s + 994) + k2*(Pkd2*b1*(-8*r*(885*s - 394) - 7080*s**2 + 3131*s - 1386) + 2*Pkd2*(C*(2*r*(549*s - 293) + 1773*s**2 - 1823*s + 484) + r*(1123 - 2214*s) - 3519*s**2 + 3722*s - 978) + Pkdd2*b1*k2*(1203*s - 250) + 2*Pkdd2*k2*(3*s - 1)*(C*(69*s - 34) - 27*s + 9))) + k1**2*k2**2*(4*C*Pk2*(585*r**2 - 3*r*(8199*s - 4099) - 30852*s**2 + 36291*s - 10100) - 66*Pk2*b1*(180*r**2 + r*(774*s - 303) + 300*s**2 - 448*s + 109) - 3*Pk2*(4458*r**2 + r*(3148 - 1233*s) - 17400*s**2 + 20459*s - 6294) + Pkd2*k2*(4*C*(24*r*(603*s - 256) + 15255*s**2 - 17568*s + 4601) + 33*b1*(2*r*(78*s + 5) - 225*s**2 + 57*s - 16) - 24768*r*s + 11292*r - 35208*s**2 + 37503*s - 9601) + Pkdd2*k2**2*(3*s - 1)*(4*C*(57*s - 52) + 165*b1*(5*s - 2) + 282*s - 94)) + 2*k2**4*(Pk2*(-6*C*(948*r**2 - 3*r*(34*s + 423) + 210*s + 259) + 3528*r**2 - 9*r*(34*s + 525) + 630*s + 1007) + Pkd2*k2*(16*C - 8)*(27*r - 20)*(3*s - 1))) + 66*k1**2*(6*bd2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + gd2*(k1**2*(2*Pk2*(7*r*(13*s - 5) + 204*s**2 - 155*s + 35) + k2*(Pkd2*(-46*r*s + 18*r - 75*s**2 + 60*s - 18) + 3*Pkdd2*k2*s*(2 - 3*s))) - 2*k2**2*(Pk2*(55*r**2 + r*(43 - 159*s) - 428*s**2 + 391*s - 98) + k2*(Pkd2*(146*r*s - 56*r + 209*s**2 - 203*s + 56) + Pkdd2*k2*s*(5*s - 4)))))) + 429*f*k1**2*k2**2*(2*b1**2*fd*k2**2*(-74*Pk2*(r + 2*s - 1) + k2*(Pkd2*(37*r - 17*s**2 + 74*s - 37) + 17*Pkdd2*k2*s**2)) + b1*(bd1*(-k1**2*(K - 1)*(8*Pk2*(r*(26*s - 6) + 52*s**2 - 42*s + 3) + k2*(Pkd2*(-52*r*s + 12*r - 182*s**2 + 123*s - 6) + 13*Pkdd2*k2*s*(2*s - 1))) - 6*k2**2*(-2*K*(2*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s))) + 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-8*r*s + 2*s**2 - 3*s + 2) + Pkdd2*k2**2*s*(1 - 2*s))) + fd*k1**2*(-4*Pk2*(8*C*(r*(7*s - 4) + 16*s**2 - 11*s + 4) + K*(-91*r*s + 47*r - 204*s**2 + 190*s - 44) + 227*r*s - 123*r + 304*s**2 - 360*s + 84) + k2*(Pkd2*(4*C*(2*r*(7*s - 4) + 59*s**2 - 22*s + 8) + K*(-92*r*s + 48*r - 150*s**2 + 127*s - 26) + 228*r*s - 124*r + 196*s**2 - 360*s + 84) - 3*Pkdd2*k2*(K*(6*s**2 - 7*s + 2) + s**2*(12*C - 12)))) + fd*k2**2*(2*Pk2*(2*C*(60*r**2 + r*(14 - 66*s) - 144*s**2 + 217*s - 74) - 2*K*(55*r**2 - 159*r*s + 95*r - 428*s**2 + 440*s - 113) + 224*r**2 + 705*r*s - 364*r + 240*s**2 - 350*s + 118) - k2*(Pkd2*(-8*C*(8*r*(4*s - 3) + 45*s**2 - 60*s + 24) + K*(8*r*(73*s - 41) + 836*s**2 - 854*s + 218) + 108*r*s - 148*r + 34*s**2 - 136*s + 97) + 2*Pkdd2*k2*(K*(10*s**2 - 13*s + 4) + s**2*(36*C - 15) - 12*s + 3))) + 2*gd2*k1**2*(8*Pk2*(r*(13*s - 3) + 26*s**2 - 16*s + 3) + k2*(Pkd2*(-26*r*s + 6*r - 91*s**2 + 32*s - 6) + 13*Pkdd2*k2*s**2)) + 24*gd2*k2**2*(2*Pk2*(-2*r**2 + r + (1 - 2*s)**2) + k2*(Pkd2*(-2*r*s + 2*r - 5*s**2 + 5*s - 2) + Pkdd2*k2*s**2))) - 12*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(32*s - 17) + 32*s**2 - 34*s + 9) - 2*bd1*g2*k1**2*(-8*Pk2*(r*(13*s - 3) + s*(26*s - 26)) + k2*(Pkd2*r*(26*s - 6) + 91*Pkd2*s*(s - 1) - 13*Pkdd2*k2*s*(s - 1))) + 24*bd1*g2*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1)) - 2*fd*g2*(k1**2*(4*Pk2*(r*(91*s - 47) + 204*s**2 - 190*s + 44) - k2*(Pkd2*(92*r*s - 48*r + 150*s**2 - 127*s + 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) - 2*k2**2*(2*Pk2*(55*r**2 + r*(95 - 159*s) - 428*s**2 + 440*s - 113) + k2*(Pkd2*(4*r*(73*s - 41) + 418*s**2 - 427*s + 109) + Pkdd2*k2*(10*s**2 - 13*s + 4)))))) + Dd*f*(-429*b1*k1**2*k2**2*(b1*k1**2*(K - 1)*(8*Pk2*(r*(52*s - 22) + 104*s**2 - 84*s + 19) + k2*(Pkd2*(-104*r*s + 44*r - 364*s**2 + 207*s - 38) + 13*Pkdd2*k2*s*(4*s - 1))) + 6*b1*k2**2*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) - 2*g2*k1**2*(8*Pk2*(r*(52*s - 22) + 104*s**2 - 84*s + 19) + k2*(Pkd2*(-104*r*s + 44*r - 364*s**2 + 207*s - 38) + 13*Pkdd2*k2*s*(4*s - 1))) - 24*g2*k2**2*(-4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(-8*r*s + 9*r - 20*s**2 + 23*s - 8) + Pkdd2*k2*s*(4*s - 1)))) + f**3*k1**2*(-25*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(788*s**2 - 589*s + 98) + 13*k1**2*k2**2*(8*Pk2*(6*r*(1226*s - 707) + 29760*s**2 - 21086*s + 4613) + k2*(Pkd2*(-15744*r*s + 9000*r - 82020*s**2 + 57313*s - 11734) + 375*Pkdd2*k2*(20*s**2 - 13*s + 2))) + 1560*k2**4*(6*Pk2*(33*r**2 + r*(2*s - 41) - 12*s + 15) + 11*Pkd2*k2*(2*r - 1)*(3*s - 1))) - 13*f**2*k2**2*(2*k1**4*(4*Pk2*(-6*C*(r*(710*s - 362) + 1596*s**2 - 1522*s + 373) + 2*b1*(r*(7080*s - 2989) + 7080*s**2 - 7240*s + 1977) + 8724*r*s - 4233*r + 15048*s**2 - 15438*s + 3945) + k2*(Pkd2*b1*(r*(5978 - 14160*s) - 14160*s**2 + 9980*s - 2829) + 3*Pkd2*(3*C*(8*r*(61*s - 32) + 788*s**2 - 817*s + 222) - 2952*r*s + 1455*r - 4692*s**2 + 4979*s - 1310) + 3*Pkdd2*k2*(4*s - 1)*(69*C*s - 34*C + 125*b1 - 27*s + 9))) + k1**2*k2**2*(-2*Pk2*(-4*C*(390*r**2 - 16398*r*s + 7964*r - 20568*s**2 + 24875*s - 6963) + 66*b1*(120*r**2 + r*(516*s - 167) + 200*s**2 - 254*s + 40) + 8916*r**2 - 2466*r*s + 6404*r - 34800*s**2 + 41617*s - 13352) + k2*(Pkd2*(4*C*(8*r*(2412*s - 973) + 20340*s**2 - 24129*s + 6241) + 33*b1*(r*(208*s + 70) - 300*s**2 + 135*s - 76) - 33024*r*s + 14868*r - 46944*s**2 + 51220*s - 13177) + Pkdd2*k2*(4*s - 1)*(4*C*(57*s - 52) + 165*b1*(5*s - 2) + 282*s - 94))) + 4*k2**4*(Pk2*(-2*C*(1896*r**2 - 2*r*(102*s + 1423) + 470*s + 857) + 2352*r**2 - 6*r*(34*s + 589) + 470*s + 1087) + Pkd2*k2*(8*C - 4)*(r*(108*s - 37) - 100*s + 30))) + 429*f*k1**2*k2**2*(b1**2*k2**2*(-160*Pk2*(r + 2*s - 1) + k2*(Pkd2*(80*r - 68*s**2 + 177*s - 80) + 17*Pkdd2*k2*s*(4*s - 1))) - b1*(k1**2*(4*Pk2*(4*C*(14*r*(2*s - 1) + 64*s**2 - 46*s + 11) + K*(-182*r*s + 82*r - 408*s**2 + 345*s - 79) + 454*r*s - 206*r + 608*s**2 - 683*s + 179) + k2*(Pkd2*(-2*C*(28*r*(2*s - 1) + 236*s**2 - 119*s + 22) + K*(184*r*s - 84*r + 300*s**2 - 247*s + 62) - 456*r*s + 208*r - 392*s**2 + 630*s - 180) + 3*Pkdd2*k2*(4*s - 1)*(K*(3*s - 2) + s*(6*C - 6)))) + k2**2*(-2*Pk2*(4*C*(60*r**2 - 2*r*(33*s + 5) - 144*s**2 + 181*s - 38) - 2*K*(110*r**2 - 318*r*s + 138*r - 856*s**2 + 831*s - 211) + 448*r**2 + 1410*r*s - 700*r + 480*s**2 - 697*s + 206) + k2*(Pkd2*(-4*C*(128*r*s - 68*r + 180*s**2 - 213*s + 60) + 2*K*(584*r*s - 276*r + 836*s**2 - 833*s + 221) + 216*r*s - 170*r + 68*s**2 - 229*s + 111) + Pkdd2*k2*(4*s - 1)*(2*K*(5*s - 4) + s*(36*C - 15) - 6)))) - 12*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(64*s - 27) + 64*s**2 - 70*s + 19) - 2*g2*(k1**2*(4*Pk2*(2*r*(91*s - 41) + 408*s**2 - 345*s + 79) - k2*(Pkd2*(184*r*s - 84*r + 300*s**2 - 247*s + 62) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))) - 2*k2**2*(2*Pk2*(110*r**2 - 6*r*(53*s - 23) - 856*s**2 + 831*s - 211) + k2*(Pkd2*(584*r*s - 276*r + 836*s**2 - 833*s + 221) + Pkdd2*k2*(20*s**2 - 21*s + 4)))))))/(9009*d**2*k1*k2**3*k3**4) - 2*D1**3*Pk3*ct**3*(D1*(33*b1*fd*k1**2*k2**2*(20*Pkd2*b1**2*k2**3*s*(r + s - 1) + 60*Pkd2*b2*k2**3*s*(r + s) - 2*b1*k1**2*(2*Pk2*(8*C*s**2 - 8*C*s + K*(r*(6*s - 17) + 44*s**2 - 34*s + 17) + r*(s*(8*C - 16) + 17) - 54*s**2 + 42*s - 17) + k2*(Pkd2*(-8*C*s**2 + 8*C*s + K*(r*(14 - 3*s) - 50*s**2 + 28*s - 14) + r*(-8*C*s + 13*s - 14) + 59*s**2 - 36*s + 14) + Pkdd2*k2*s**2*(9*K - 8))) + b1*k2**2*(Pk2*(56*C*(r - 1)*(r + s - 1) + 78*K*r**2 - 4*K*r*(s - 41) - 236*K*(s - 1)**2 - 200*r**2 - 333*r*s + 86*r - 180*s + 62) + k2*(Pkd2*(32*C*s**2 + 192*C*s + 4*K*(r*(27*s - 23) + 54*s**2 - 46*s + 23) + r*(-192*C*s + 138*s + 56) - 41*s**2 + 24*s - 56) + Pkdd2*k2*s**2*(14 - 18*K))) + 4*g2*k1**2*(2*Pk2*(r*(6*s - 17) + 44*s**2 - 34*s + 17) + k2*(Pkd2*(-3*r*s + 14*r - 50*s**2 + 28*s - 14) + 9*Pkdd2*k2*s**2)) + 4*g2*k2**2*(Pk2*(-39*r**2 + 2*r*(s - 41) + 118*(s - 1)**2) + k2*(-2*Pkd2*(27*r*s - 23*r + 54*s**2 - 46*s + 23) + 9*Pkdd2*k2*s**2))) + f**3*k1**2*(3*bd1*(5*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + 11*k1**2*k2**2*(2*Pk2*(90*r**2 - r*(166*s + 173) - 276*s**2 + 211*s + 83) + k2*(Pkd2*(216*r*s + 60*r + 240*s**2 - 227*s - 60) + 15*Pkdd2*k2*s)) + 22*k2**4*(Pk2*(132*r**2 + 334*r*s - 231*r + 120*s**2 - 200*s + 75) + Pkd2*k2*(48*r*s - 36*r + 55*s**2 - 94*s + 36))) - 10*fd*k1**2*(k1**2*(4*s - 1)*(Pk2*(828*s - 652) + k2*(Pkd2*(247 - 333*s) + 14*Pkdd2*k2*(3*s - 2))) + 3*k2**2*(4*Pk2*(220*r**2 + 20*r*(s - 6) - 560*s**2 + 266*s - 29) + Pkd2*k2*(528*r*(2*s - 1) + 1220*s**2 - 1321*s + 386)))) + f**2*(2484*C*Pk2*fd*k1**4*k2**2*r*s - 7164*C*Pk2*fd*k1**4*k2**2*r + 13968*C*Pk2*fd*k1**4*k2**2*s**2 + 15072*C*Pk2*fd*k1**4*k2**2*s - 4464*C*Pk2*fd*k1**4*k2**2 - 86580*C*Pk2*fd*k1**2*k2**4*r**2 + 15804*C*Pk2*fd*k1**2*k2**4*r*s + 74100*C*Pk2*fd*k1**2*k2**4*r + 17424*C*Pk2*fd*k1**2*k2**4*s**2 - 2628*C*Pk2*fd*k1**2*k2**4*s - 17896*C*Pk2*fd*k1**2*k2**4 - 10440*C*Pk2*fd*k2**6*r**2 + 8712*C*Pk2*fd*k2**6*r*s + 6828*C*Pk2*fd*k2**6*r - 3432*C*Pk2*fd*k2**6*s - 940*C*Pk2*fd*k2**6 - 13104*C*Pkd2*fd*k1**4*k2**3*r*s + 8064*C*Pkd2*fd*k1**4*k2**3*r - 11952*C*Pkd2*fd*k1**4*k2**3*s**2 + 2700*C*Pkd2*fd*k1**4*k2**3*s - 804*C*Pkd2*fd*k1**4*k2**3 - 77184*C*Pkd2*fd*k1**2*k2**5*r*s + 37872*C*Pkd2*fd*k1**2*k2**5*r - 64548*C*Pkd2*fd*k1**2*k2**5*s**2 + 74304*C*Pkd2*fd*k1**2*k2**5*s - 21644*C*Pkd2*fd*k1**2*k2**5 - 1584*C*Pkd2*fd*k2**7*r*s + 792*C*Pkd2*fd*k2**7*r + 528*C*Pkd2*fd*k2**7*s - 264*C*Pkd2*fd*k2**7 - 3960*C*Pkdd2*fd*k1**4*k2**4*s**2 + 5280*C*Pkdd2*fd*k1**4*k2**4*s - 1320*C*Pkdd2*fd*k1**4*k2**4 - 5940*C*Pkdd2*fd*k1**2*k2**6*s**2 + 5940*C*Pkdd2*fd*k1**2*k2**6*s - 1320*C*Pkdd2*fd*k1**2*k2**6 + 360*Pk2*b1*fd*k1**6*s**2 + 17820*Pk2*b1*fd*k1**4*k2**2*r**2 - 32868*Pk2*b1*fd*k1**4*k2**2*r*s - 5478*Pk2*b1*fd*k1**4*k2**2*r - 54648*Pk2*b1*fd*k1**4*k2**2*s**2 + 32538*Pk2*b1*fd*k1**4*k2**2*s - 4554*Pk2*b1*fd*k1**4*k2**2 + 26136*Pk2*b1*fd*k1**2*k2**4*r**2 + 66132*Pk2*b1*fd*k1**2*k2**4*r*s - 37686*Pk2*b1*fd*k1**2*k2**4*r + 23760*Pk2*b1*fd*k1**2*k2**4*s**2 - 42768*Pk2*b1*fd*k1**2*k2**4*s + 13794*Pk2*b1*fd*k1**2*k2**4 + 8100*Pk2*fd*k1**4*k2**2*r**2 - 9342*Pk2*fd*k1**4*k2**2*r*s + 11178*Pk2*fd*k1**4*k2**2*r - 33264*Pk2*fd*k1**4*k2**2*s**2 + 17172*Pk2*fd*k1**4*k2**2*s - 5616*Pk2*fd*k1**4*k2**2 + 88254*Pk2*fd*k1**2*k2**4*r**2 + 60075*Pk2*fd*k1**2*k2**4*r*s - 84306*Pk2*fd*k1**2*k2**4*r + 11484*Pk2*fd*k1**2*k2**4*s**2 - 36195*Pk2*fd*k1**2*k2**4*s + 22410*Pk2*fd*k1**2*k2**4 + 5616*Pk2*fd*k2**6*r**2 - 4356*Pk2*fd*k2**6*r*s - 3546*Pk2*fd*k2**6*r + 1716*Pk2*fd*k2**6*s + 470*Pk2*fd*k2**6 - 5808*Pk2*gd2*k1**4*k2**2*r*s + 3300*Pk2*gd2*k1**4*k2**2*r - 5280*Pk2*gd2*k1**4*k2**2*s**2 + 924*Pk2*gd2*k1**4*k2**2*s - 3300*Pk2*gd2*k1**4*k2**2 + 18612*Pk2*gd2*k1**2*k2**4*r**2 - 264*Pk2*gd2*k1**2*k2**4*r*s - 16896*Pk2*gd2*k1**2*k2**4*r - 12672*Pk2*gd2*k1**2*k2**4*s**2 + 10824*Pk2*gd2*k1**2*k2**4*s - 1716*Pk2*gd2*k1**2*k2**4 - 225*Pkd2*b1*fd*k1**6*k2*s**2 + 21384*Pkd2*b1*fd*k1**4*k2**3*r*s - 9240*Pkd2*b1*fd*k1**4*k2**3*r + 23760*Pkd2*b1*fd*k1**4*k2**3*s**2 - 10197*Pkd2*b1*fd*k1**4*k2**3*s + 4488*Pkd2*b1*fd*k1**4*k2**3 + 9504*Pkd2*b1*fd*k1**2*k2**5*r*s - 7128*Pkd2*b1*fd*k1**2*k2**5*r + 10890*Pkd2*b1*fd*k1**2*k2**5*s**2 - 9570*Pkd2*b1*fd*k1**2*k2**5*s + 3828*Pkd2*b1*fd*k1**2*k2**5 + 23184*Pkd2*fd*k1**4*k2**3*r*s - 16044*Pkd2*fd*k1**4*k2**3*r + 25191*Pkd2*fd*k1**4*k2**3*s**2 - 23664*Pkd2*fd*k1**4*k2**3*s + 7861*Pkd2*fd*k1**4*k2**3 + 49284*Pkd2*fd*k1**2*k2**5*r*s - 25074*Pkd2*fd*k1**2*k2**5*r + 40788*Pkd2*fd*k1**2*k2**5*s**2 - 46821*Pkd2*fd*k1**2*k2**5*s + 13957*Pkd2*fd*k1**2*k2**5 + 792*Pkd2*fd*k2**7*r*s - 396*Pkd2*fd*k2**7*r - 264*Pkd2*fd*k2**7*s + 132*Pkd2*fd*k2**7 + 4488*Pkd2*gd2*k1**4*k2**3*r*s - 2112*Pkd2*gd2*k1**4*k2**3*r + 3168*Pkd2*gd2*k1**4*k2**3*s**2 - 660*Pkd2*gd2*k1**4*k2**3*s + 2112*Pkd2*gd2*k1**4*k2**3 + 27852*Pkd2*gd2*k1**2*k2**5*r*s - 10032*Pkd2*gd2*k1**2*k2**5*r + 24552*Pkd2*gd2*k1**2*k2**5*s**2 - 30096*Pkd2*gd2*k1**2*k2**5*s + 10032*Pkd2*gd2*k1**2*k2**5 + 45*Pkdd2*b1*fd*k1**6*k2**2*s**2 - 4455*Pkdd2*b1*fd*k1**4*k2**4*s + 990*Pkdd2*b1*fd*k1**4*k2**4 + 2970*Pkdd2*fd*k1**4*k2**4*s**2 - 3960*Pkdd2*fd*k1**4*k2**4*s + 990*Pkdd2*fd*k1**4*k2**4 + 2970*Pkdd2*fd*k1**2*k2**6*s**2 - 2970*Pkdd2*fd*k1**2*k2**6*s + 660*Pkdd2*fd*k1**2*k2**6 + 1584*Pkdd2*gd2*k1**4*k2**4*s**2 - 1584*Pkdd2*gd2*k1**4*k2**4*s + 2376*Pkdd2*gd2*k1**2*k2**6*s**2 - 1584*Pkdd2*gd2*k1**2*k2**6*s - 33*bd1*(k1**4*k2**2*(-2*Pk2*(4*C*(53*r*s - 14*r - 6*s**2 - 16*s + 12) + 44*K*r*s - 25*K*r + 40*K*s**2 - 7*K*s + 25*K + 4*b1*(2*r*(8*s + 7) + 16*s**2 - 7*s - 6) + 26*r**2 - 335*r*s + 159*r - 204*s**2 + 355*s - 165) + k2*(Pkd2*(12*C*(14*r*s - 4*r - 9*s**2 + s + 4) + 68*K*r*s - 32*K*r + 48*K*s**2 - 10*K*s + 32*K + b1*(8*r*(8*s + 7) + 52*s**2 - 22*s - 24) - 340*r*s + 196*r - 143*s**2 + 293*s - 184) + 2*Pkdd2*k2*s*(b1*(6*s - 3) + (s - 1)*(20*C + 12*K - 24)))) - k1**2*k2**4*(Pk2*(4*C*(5*r**2 - 383*r*s - 19*r - 70*s**2 + 304*s - 50) - 282*K*r**2 + 4*K*r*s + 256*K*r + 192*K*s**2 - 164*K*s + 26*K + 2*b1*(16*r**2 + r*(34*s - 26) - 63*s + 38) + 542*r**2 + 1402*r*s - 712*r + 368*s**2 - 1079*s + 446) + k2*(Pkd2*(4*C*(7*r*(5*s + 2) + 61*s**2 - 33*s - 14) - 422*K*r*s + 152*K*r - 372*K*s**2 + 456*K*s - 152*K + 6*b1*(2*r*(s - 5) - 4*s**2 + s + 6) + 128*r*s - 156*r - 19*s**2 - 108*s + 124) + 2*Pkdd2*k2*s*(-20*C*(s - 1) - 18*K*s + 12*K + 9*b1*(2*s - 1) + 16*s - 16))) + 2*k2**6*(Pk2*(2*C*(12*r**2 - 11*r*s + 4*r + 4*s - 8) - 18*r**2 + 11*r*s + r - 4*s + 8) + Pkd2*k2*(2 - 4*C)*(r*(4*s - 2) - s + 1))) + 132*bd2*k1**2*k2**2*(-k1**2*(2*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k2**2*(Pk2*(-17*r**2 + 43*r*s + 8*r + 60*s**2 - 50*s + 9) - 6*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3)))) + 33*f*k2**2*(2*b1**2*k1**2*(5*Pkd2*bd1*k2**3*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + fd*(2*k1**2*(2*Pk2*(8*r*(2*s + 1) + 16*s**2 - 5*s - 8) - k2*(Pkd2*(16*r*s + 8*r + 13*s**2 - 5*s - 8) + 3*Pkdd2*k2*s**2)) + k2**2*(Pk2*(16*r**2 + r*(34*s - 46) - 155*s + 36) + 3*k2*(Pkd2*(2*r*(s + 7) - 4*s**2 + 23*s - 14) + 6*Pkdd2*k2*s**2)))) + b1*(bd1*(-2*k1**4*(4*Pk2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + K*(r*(6*s - 4) + 44*s**2 - 39*s + 6) - 16*r*s + 3*r - 54*s**2 + 52*s - 8) + k2*(Pkd2*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-6*r*(s - 2) - 100*s**2 + 83*s - 14) + 2*r*(13*s - 5) + 118*s**2 - 108*s + 18) + Pkdd2*k2*s*(9*K - 8)*(2*s - 1))) + k1**2*k2**2*(Pk2*(112*C*(r**2 + r*(s - 2) - 2*s + 1) + 2*K*(78*r**2 - 4*r*(s + 43) - 236*s**2 + 181*s + 36) - 400*r**2 - 666*r*s + 728*r + 241*s - 176) + k2*(Pkd2*(32*C*(r*(3 - 12*s) + 2*s**2 + 5*s - 3) + 4*K*(54*r*s - 4*r + 108*s**2 - 101*s + 8) + 276*r*s - 62*r - 82*s**2 + 5*s + 16) + Pkdd2*k2*s*(14 - 18*K)*(2*s - 1)))) + fd*(k1**4*(2*Pk2*(4*C*(106*r*s + r - 12*s**2 - 51*s - 1) + K*(88*r*s - 69*r + 80*s**2 - 4*s - 18) + 52*r**2 - 670*r*s + 214*r - 408*s**2 + 688*s - 136) + k2*(Pkd2*(24*C*(-2*r*(7*s + 1) + 9*s**2 + 3*s + 2) - 2*K*(68*r*s - 48*r + 48*s**2 + 2*s - 13) + 680*r*s - 224*r + 286*s**2 - 529*s + 69) - 4*Pkdd2*k2*(6*K*(2*s**2 - 3*s + 1) + s**2*(20*C - 24) + 9*s - 3))) + k1**2*k2**2*(Pk2*(4*C*(10*r**2 - 766*r*s + 221*r - 140*s**2 + 800*s - 236) - 4*K*(141*r**2 - 2*r*(s - 5) - 96*s**2 + 122*s - 37) + 1084*r**2 + 2804*r*s - 1576*r + 736*s**2 - 2599*s + 772) + k2*(Pkd2*(4*C*(r*(70*s - 44) + 122*s**2 - 123*s + 44) + K*(-844*r*s + 472*r - 744*s**2 + 776*s - 202) + 256*r*s + 20*r - 38*s**2 + 90*s - 109) - 4*Pkdd2*k2*(3*K*(6*s**2 - 7*s + 2) + s**2*(20*C - 16)))) + 2*k2**4*(2*r - 1)*(Pk2*(C*(-24*r + 22*s + 32) + 18*r - 11*s - 21) + Pkd2*k2*s*(16*C - 8))) + 4*k1**2*(Pkd2*bd2*k2**3*s*(15*r + 15*s - 11) + gd2*k1**2*(4*Pk2*(3*r*(s - 2) + 22*s**2 - 17*s + 6) + k2*(Pkd2*(-3*r*s + 14*r - 50*s**2 + 33*s - 14) + 9*Pkdd2*k2*s**2)) + gd2*k2**2*(Pk2*(-39*r**2 + r*(2*s + 75) + 118*s**2 - 63*s - 36) + k2*(-2*Pkd2*(27*r*s - 8*r + 54*s**2 - 47*s + 8) + 9*Pkdd2*k2*s**2)))) + 4*k1**2*(b2*(Pkd2*bd1*k2**3*(r*(15*s - 4) + s*(15*s - 15)) + fd*(-2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) + k2**2*(Pk2*(-34*r**2 + 86*r*s - 54*r + 120*s**2 - 146*s + 43) - 6*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5)))) + g2*(bd1*k1**2*(4*Pk2*r*(3*s + 2) + 88*Pk2*s*(s - 1) - Pkd2*k2*(r*(3*s + 2) + s*(50*s - 50)) + 9*Pkdd2*k2**2*s*(s - 1)) + bd1*k2**2*(Pk2*(-39*r**2 + r*(2*s + 97) + s*(118*s - 118)) + k2*(-2*Pkd2*(r*(27*s + 4) + s*(54*s - 54)) + 9*Pkdd2*k2*s*(s - 1))) + fd*k1**2*(Pk2*(r*(69 - 88*s) - 80*s**2 + 4*s + 18) + k2*(Pkd2*(68*r*s - 48*r + 48*s**2 + 2*s - 13) + 12*Pkdd2*k2*(2*s**2 - 3*s + 1))) + fd*k2**2*(2*Pk2*(141*r**2 - 2*r*(s - 5) - 96*s**2 + 122*s - 37) + k2*(Pkd2*(422*r*s - 236*r + 372*s**2 - 388*s + 101) + 6*Pkdd2*k2*(6*s**2 - 7*s + 2))))))) + Dd*f*(33*b1*k1**2*k2**2*(10*Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 4*Pkd2*b2*k2**3*(r*(60*s - 4) + s*(60*s - 37)) + b1*(-2*k1**2*(2*Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + K*(24*r*s - 37*r + 176*s**2 - 146*s + 41) - 64*r*s + 35*r - 216*s**2 + 196*s - 45) + k2*(Pkd2*(-4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 2*K*(6*r*s - 20*r + 100*s**2 - 72*s + 21) + 52*r*s - 38*r + 236*s**2 - 193*s + 46) + Pkdd2*k2*s*(9*K - 8)*(4*s - 1))) + k2**2*(2*Pk2*(56*C*(2*r**2 + 2*r*(s - 2) - 3*s + 2) + K*(156*r**2 - 8*r*s - 165*r - 472*s**2 + 480*s - 46) - 400*r**2 - 666*r*s + 567*r + 67*s - 117) + k2*(Pkd2*(32*C*(r*(3 - 24*s) + 4*s**2 + 17*s - 3) + 4*K*(108*r*s - 35*r + 216*s**2 - 194*s + 39) + 552*r*s + 22*r - 164*s**2 - 7*s - 68) + Pkdd2*k2*s*(14 - 18*K)*(4*s - 1)))) + 4*g2*(k1**2*(Pk2*(r*(48*s - 74) + 352*s**2 - 292*s + 82) + k2*(-2*Pkd2*(6*r*s - 20*r + 100*s**2 - 72*s + 21) + 9*Pkdd2*k2*s*(4*s - 1))) + k2**2*(Pk2*(-156*r**2 + r*(8*s + 165) + 472*s**2 - 480*s + 46) + k2*(Pkd2*(-216*r*s + 70*r - 432*s**2 + 388*s - 78) + 9*Pkdd2*k2*s*(4*s - 1))))) - 10*f**3*k1**4*(k1**2*(4*s - 1)*(Pk2*(828*s - 652) + k2*(Pkd2*(247 - 333*s) + 14*Pkdd2*k2*(3*s - 2))) + 3*k2**2*(4*Pk2*(220*r**2 + 20*r*(s - 6) - 560*s**2 + 266*s - 29) + Pkd2*k2*(528*r*(2*s - 1) + 1220*s**2 - 1321*s + 386))) + f**2*(15*b1*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**4*k2**2*(2*Pk2*(6*C*(276*r*s - 845*r + 1552*s**2 + 1660*s - 124) + 66*b1*(180*r**2 - 4*r*(83*s + 32) - 552*s**2 + 352*s + 7) + 5400*r**2 - 6228*r*s + 7145*r - 22176*s**2 + 11824*s - 5714) + k2*(Pkd2*(-4*C*(4368*r*s - 2528*r + 3984*s**2 - 976*s + 713) + 132*b1*(r*(216*s - 55) + 240*s**2 - 134*s + 19) + 30912*r*s - 20632*r + 33588*s**2 - 32385*s + 12449) - 330*Pkdd2*k2*(3*b1 + (4*C - 3)*(s - 1))*(4*s - 1))) + k1**2*k2**4*(2*Pk2*(-4*C*(14430*r**2 - 6*r*(439*s + 2422) - 2904*s**2 + 1081*s + 3899) + 66*b1*(264*r**2 + r*(668*s - 401) + 240*s**2 - 424*s + 142) + 58836*r**2 + 6*r*(6675*s - 10427) + 7656*s**2 - 23271*s + 16905) + k2*(Pkd2*(-4*C*(25728*r*s - 11794*r + 21516*s**2 - 25603*s + 7737) + 66*b1*(48*r*(4*s - 3) + 220*s**2 - 239*s + 94) + 65712*r*s - 31442*r + 54384*s**2 - 64868*s + 20325) + Pkdd2*k2*(330 - 660*C)*(12*s**2 - 11*s + 2))) - 4*k2**6*(Pk2*(2*C*(1740*r**2 - 2*r*(726*s + 769) + 594*s + 367) - 1872*r**2 + 4*r*(363*s + 401) - 594*s - 367) + Pkd2*k2*(132*C - 66)*(2*r - 1)*(2*s - 1))) + 33*f*k2**2*(2*b1**2*k1**2*(k1**2*(8*Pk2*(r*(16*s + 11) + 16*s**2 - 6*s - 7) + k2*(Pkd2*(-64*r*s - 44*r - 52*s**2 + 21*s + 28) + 3*Pkdd2*k2*s*(1 - 4*s))) + k2**2*(Pk2*(32*r**2 + r*(68*s - 72) - 218*s + 74) + 3*k2*(4*Pkd2*(r*s + r - 2*s**2 + 6*s - 2) + 3*Pkdd2*k2*s*(4*s - 1)))) + b1*(k1**4*(2*Pk2*(4*C*(r*(212*s - 3) - 24*s**2 - 98*s + 1) + K*(176*r*s - 119*r + 160*s**2 - 18*s + 32) + 104*r**2 - 1340*r*s + 412*r - 816*s**2 + 1410*s - 366) + k2*(Pkd2*(12*C*(-4*r*(14*s + 1) + 36*s**2 + 11*s + 4) - 2*K*(136*r*s - 80*r + 96*s**2 - 8*s + 19) + 1360*r*s - 496*r + 572*s**2 - 1147*s + 329) - 4*Pkdd2*k2*(4*s - 1)*(6*K*(s - 1) + s*(10*C - 12) + 3))) + k1**2*k2**2*(4*Pk2*(C*(20*r**2 + r*(179 - 1532*s) - 280*s**2 + 1530*s - 268) + K*(-282*r**2 + 4*r*s + 118*r + 192*s**2 - 204*s + 50) + 542*r**2 + 1402*r*s - 763*r + 368*s**2 - 1249*s + 360) - k2*(Pkd2*(-4*C*(4*r*(35*s - 11) + 244*s**2 - 219*s + 44) + 2*K*(844*r*s - 388*r + 744*s**2 - 844*s + 253) - 512*r*s + 136*r + 76*s**2 + 25*s - 15) + 4*Pkdd2*k2*(4*s - 1)*(K*(9*s - 6) + s*(10*C - 8)))) + 4*k2**4*(2*r - 1)*(Pk2*(C*(-24*r + 22*s + 20) + 18*r - 11*s - 15) + Pkd2*k2*(2*C - 1)*(8*s - 1))) + 4*k1**2*(-2*b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) + b2*k2**2*(Pk2*(-68*r**2 + 2*r*(86*s - 19) + 240*s**2 - 246*s + 61) - 6*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) + g2*k1**2*(Pk2*(-176*r*s + 119*r - 160*s**2 + 18*s - 32) + k2*(Pkd2*(136*r*s - 80*r + 96*s**2 - 8*s + 19) + 12*Pkdd2*k2*(4*s**2 - 5*s + 1))) + g2*k2**2*(4*Pk2*(141*r**2 - r*(2*s + 59) - 96*s**2 + 102*s - 25) + k2*(Pkd2*(844*r*s - 388*r + 744*s**2 - 844*s + 253) + 6*Pkdd2*k2*(12*s**2 - 11*s + 2)))))))/(693*d**2*k1*k2**3*k3**4) + 40*D1**3*Pk3*ct**2*f*k1**2*k2**2*st**6*(-4*Pk2 + Pkd2*k2)*(-468*C*D1*f*fd*r*s + 156*C*D1*f*fd*r - 468*C*D1*f*fd*s**2 + 468*C*D1*f*fd*s - 104*C*D1*f*fd - 624*C*Dd*f**2*r*s + 182*C*Dd*f**2*r - 624*C*Dd*f**2*s**2 + 624*C*Dd*f**2*s - 130*C*Dd*f**2 - 429*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 3416*D1*f**2*fd*r*s - 763*D1*f**2*fd*r + 3416*D1*f**2*fd*s**2 - 3416*D1*f**2*fd*s + 595*D1*f**2*fd + 468*D1*f*fd*r*s - 156*D1*f*fd*r + 468*D1*f*fd*s**2 - 468*D1*f*fd*s + 104*D1*f*fd + 3432*D1*f*gd2*r*s - 858*D1*f*gd2*r + 3432*D1*f*gd2*s**2 - 3432*D1*f*gd2*s + 858*D1*f*gd2 + 6864*D1*fd*g2*r*s - 3432*D1*fd*g2*r + 6864*D1*fd*g2*s**2 - 6864*D1*fd*g2*s + 1716*D1*fd*g2 + 3416*Dd*f**3*r*s - 763*Dd*f**3*r + 3416*Dd*f**3*s**2 - 3416*Dd*f**3*s + 595*Dd*f**3 + 624*Dd*f**2*r*s - 182*Dd*f**2*r + 624*Dd*f**2*s**2 - 624*Dd*f**2*s + 130*Dd*f**2 + 13728*Dd*f*g2*r*s - 5148*Dd*f*g2*r + 13728*Dd*f*g2*s**2 - 13728*Dd*f*g2*s + 3432*Dd*f*g2 - 858*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(9009*d**2*k3**6) + 10*D1**3*Pk3*ct**2*f*k1**2*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(-D1*(7*f**2*fd*(244*s**2 - 109*s + 12) + f*fd*(1 - 3*s)**2*(26 - 26*C) + 429*f*s*(2*s - 1)*(-K*bd1 + bd1 + 2*gd2) + 858*fd*g2*(1 - 2*s)**2) - Dd*f*(4*s - 1)*(7*f**2*(61*s - 12) - f*(26*C - 26)*(3*s - 1) + 858*g2*(2*s - 1)) + 429*b1*(K - 1)*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d**2*k3**4) - 4*D1**3*Pk3*ct**2*st**4*(D1*(10296*b1*fd*k1**2*k2**2*(-Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + Pkd2*k2*s*(r + s))*(b1*(K - 1) - 2*g2) + f**3*(195*bd1*k2**2*(11*Pk2*k2**2*(r - 1)*(5*r + 5*s - 3) + 12*k1**2*(2*Pk2*(15*r**2 + 12*r*s - 22*r - 3*s**2 - 7*s + 6) + Pkd2*k2*(18*r*s - r + 18*s**2 - 16*s + 2))) + 30*fd*k1**4*(4*Pk2 - Pkd2*k2)*(6*r*(1270*s - 363) + 7620*s**2 - 7919*s + 1640) + 26*fd*k1**2*k2**2*(-Pk2*(7110*r**2 + 6*r*(3215*s - 1794) + 12180*s**2 - 14540*s + 4067) + 90*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 39*f**2*(fd*(k1**4*(48*C - 48)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + 8*k1**2*k2**2*(Pk2*(C*(-531*r**2 + 3*r*(123*s + 88) + 900*s**2 - 723*s + 71) + 45*b1*(15*r**2 + 2*r*(6*s - 7) - 3*s**2 - 2*s + 3) + 711*r**2 + 9*r*(29*s - 66) - 450*s**2 + 213*s + 69) + 15*Pkd2*k2*(3*r + 3*s - 2)*(-12*C*s + 4*C + 9*b1*s - 4*b1 + 9*s - 3)) + k2**4*(Pk2*(-16*C*(324*r**2 + 6*r*(60*s - 67) + 135*s**2 - 210*s + 113) + 55*b1*(3*r - 1)*(5*r + 5*s - 3) + 3348*r**2 + 12*r*(303*s - 342) + 1080*s**2 - 1932*s + 1116) + Pkd2*k2*(120 - 240*C)*(3*s - 1)*(3*r + 3*s - 2))) - 132*k1**2*(bd1*(Pk2*k1**2*s*(4 - 4*K)*(r + s) + 2*Pk2*k2**2*(K*(5*r**2 - r*(7*s + 6) - 12*s**2 + 3*s + 1) - 8*r**2 + r*(10 - 3*s) + 5*s**2 + 3*s - 2) + Pkd2*k1**2*k2*s*(K - 1)*(r + s) + Pkd2*k2**3*(K*(r*(12*s - 1) + 12*s**2 - 8*s + 1) - 8*r*s + r - 8*s**2 + 6*s - 1)) - 2*gd2*(-4*Pk2*k1**2*s*(r + s) + 2*Pk2*k2**2*(5*r**2 - r*(7*s + 6) - 12*s**2 + 3*s + 1) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(12*s - 1) + 12*s**2 - 8*s + 1)))) + 5148*f*k1**2*(b1*(-bd1*k2**2*(K - 1)*(2*Pk2*(2*r**2 + r*(8*s - 4) + 6*s**2 - 6*s + 1) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + fd*(Pk2*k1**2*(4*K - 4)*(r + s)*(2*s - 1) - 2*Pk2*k2**2*(2*K*(5*r**2 - 7*r*s + 3*r - 12*s**2 + 10*s - 2) - 16*r**2 + r*(2 - 6*s) + 10*s**2 - 9*s + 2) - Pkd2*k1**2*k2*(K - 1)*(r + s)*(2*s - 1) + Pkd2*k2**3*(-2*K*(12*r*s - 5*r + 12*s**2 - 10*s + 2) + r*(16*s - 7) + 16*s**2 - 14*s + 3)) + 2*gd2*k2**2*(2*Pk2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + Pkd2*k2*s*(-2*r - 2*s + 1))) + 2*g2*(bd1*k2**2*(2*Pk2*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))) + fd*(-4*Pk2*k1**2*(r + s)*(2*s - 1) + 4*Pk2*k2**2*(5*r**2 - 7*r*s + 3*r - 12*s**2 + 10*s - 2) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(12*r*s - 5*r + 12*s**2 - 10*s + 2))))) + 2*Dd*f*(-2574*b1*k1**2*k2**2*(2*Pk2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 11*s + 3) + Pkd2*k2*(-8*r*s + r + s*(4 - 8*s)))*(b1*(K - 1) - 2*g2) + f**3*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(1270*s - 363) + 7620*s**2 - 7919*s + 1640) + 13*k2**2*(-Pk2*(7110*r**2 + 6*r*(3215*s - 1794) + 12180*s**2 - 14540*s + 4067) + 90*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 39*f**2*(k1**4*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 2*k1**2*k2**2*(2*Pk2*(C*(-708*r**2 + 492*r*s + 496*r + 1200*s**2 - 894*s + 16) + 15*b1*(60*r**2 + 16*r*(3*s - 4) - 12*s**2 - 13*s + 15) + 948*r**2 + 348*r*s - 941*r - 600*s**2 + 194*s + 179) + 15*Pkd2*k2*(b1*(r*(72*s - 25) + 72*s**2 - 76*s + 18) - (4*C - 3)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + k2**4*(Pk2*(-8*C*(432*r**2 + 12*r*(40*s - 49) + 180*s**2 - 305*s + 191) + 55*b1*(2*r - 1)*(5*r + 5*s - 3) + 2232*r**2 + 6*r*(404*s - 503) + 720*s**2 - 1452*s + 966) + Pkd2*k2*(30 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 2574*f*k1**2*(b1*(Pk2*k1**2*(4 - 4*K)*(r + s)*(4*s - 1) + 2*Pk2*k2**2*(K*(20*r**2 - 2*r*(14*s + 3) - 48*s**2 + 26*s - 2) - 32*r**2 + r*(22 - 12*s) + 20*s**2 - 3*s - 2) + Pkd2*k1**2*k2*(K - 1)*(r + s)*(4*s - 1) + Pkd2*k2**3*(6*K*(4*s - 1)*(2*r + 2*s - 1) + r*(9 - 32*s) - 32*s**2 + 26*s - 5)) + 2*g2*(4*Pk2*k1**2*(r + s)*(4*s - 1) + 4*Pk2*k2**2*(-10*r**2 + r*(14*s + 3) + 24*s**2 - 13*s + 1) - Pkd2*k1**2*k2*(r + s)*(4*s - 1) - 6*Pkd2*k2**3*(4*s - 1)*(2*r + 2*s - 1)))))/(9009*d**2*k3**6) + D1**3*Pk3*ct**2*st**2*(2*D1*bd1*f*(f*(2*Pk2*(r*(27*s - 11) + 6*s*(12*C*s - 8*C - 6*s + 5)) + k2*(Pkd2*r*(6 - 14*s) + 3*Pkd2*s*(C*(20 - 30*s) + 15*s - 11) + Pkdd2*k2*s*(6*C - 3)*(3*s - 2))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*b2 - 12*g2)*(s - 1)) + b1**2*(D1*fd*(f*(Pk2*(r*(78*s - 68) + 9*s + 10) - 6*Pkd2*k2*(2*r*(s - 1) + s)) + (s - 1)*(12*K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + 96*Pk2*r - 24*Pkd2*k2*r)) + 2*Dd*f*(Pk2*(48*K*(4*s**2 - 5*s + 1) + f*(r*(78*s - 92) + 9*s + 34) + 192*r*s - 120*r - 48*s + 48) - 6*k2*(K*Pkdd2*k2*(-4*s**2 + 5*s - 1) + Pkd2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2)))) + b1*(D1*bd1*f*(24*K*Pkdd2*k2**2*s*(s - 1) + Pk2*f*(2*r*(39*s - 58) + 9*s + 58) + 48*Pk2*(r*(4*s - 2) + (s - 1)*(4*K*s - 1)) - 6*Pkd2*k2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1))) + 2*D1*(f*(fd*(2*Pk2*(24*C*(6*s**2 - 7*s + 2) + 54*r*s - 20*r - 72*s**2 + 67*s - 19) + k2*(Pkd2*(-30*C*(6*s**2 - 7*s + 2) - 28*r*s + 11*r + 90*s**2 - 96*s + 27) + Pkdd2*k2*(6*C - 3)*(6*s**2 - 7*s + 2))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*bd2 - 12*gd2)*(s - 1)) - 12*fd*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f*(4*Pk2*(12*C*(12*s**2 - 11*s + 2) + 54*r*s - 21*r - 72*s**2 + 49*s - 4) + k2*(Pkd2*(-30*C*(12*s**2 - 11*s + 2) - 56*r*s + 23*r + 180*s**2 - 147*s + 21) + Pkdd2*k2*(6*C - 3)*(12*s**2 - 11*s + 2))) - 12*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 12*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(21*d**2*k2**2) + D1**3*Pk3*ct**2*st**4*(132*b1**2*k1**2*(K - 1)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) - b1*(D1*(5*f**2*fd*(-11*Pk2*k2**2*(3*r - 1)*(5*s - 2) + 36*k1**2*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))) - 132*f*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*bd1*(K - 1)*(s - 1) - 2*fd*s + fd - 2*gd2*(s - 1)) + 264*fd*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(5*f**2*(-11*Pk2*k2**2*(2*r - 1)*(5*s - 2) + 18*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1)) + 66*f*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s - 1) + 132*g2*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(4*s**2 - 5*s + 1))) - f*(D1*(-5*bd1*f**2*(864*Pk2*k1**2*s*(1 - 3*s) + 324*Pkd2*k1**2*k2*s*(3*s - 1) + k2**2*(11*Pk2*(r - 1)*(5*s - 2) + 36*Pkdd2*k1**2*s*(1 - 3*s))) + 264*bd1*g2*k1**2*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1) + 4*f*(33*bd1*k1**2*s**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + fd*(10*k1**2*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + k2**2*(-4*Pk2*(60*C*(1 - 3*s)**2 + 189*r*s - 30*r - 270*s**2 + 117*s - 20) + k2*(Pkd2*(150*C*(1 - 3*s)**2 + 189*r*s - 30*r - 675*s**2 + 387*s - 65) + Pkdd2*k2*(1 - 3*s)**2*(15 - 30*C)))))) + 4*Dd*f**2*(10*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + k2**2*(-4*Pk2*(60*C*(12*s**2 - 7*s + 1) + 7*r*(36*s - 5) - 360*s**2 + 94*s - 15) + k2*(Pkd2*(150*C*(12*s**2 - 7*s + 1) + 7*r*(36*s - 5) - 900*s**2 + 409*s - 60) + Pkdd2*k2*(15 - 30*C)*(12*s**2 - 7*s + 1))))))/(231*d**2*k2**2*k3**2) + D1**3*Pk3*ct**2*(-33*b1**3*k2*(D1*fd*s*(-21*Pk2*k2*(r - 1) - 4*Pkd2*k1**2*s + 14*Pkd2*k2**2*(r - 1) + 4*Pkdd2*k1**2*k2*s) + 2*Dd*f*(2*Pkd2*k1**2*s*(1 - 4*s) + 14*Pkd2*k2**2*(r*(2*s - 1) - 3*s + 1) + k2*s*(Pk2*(21 - 42*r) + 2*Pkdd2*k1**2*(4*s - 1)))) - 33*b1**2*(D1*(bd1*f*k2*(4*Pkd2*k1**2*s*(1 - 3*s) + 14*Pkd2*k2**2*(r*(3*s - 2) - 5*s + 2) + k2*s*(Pk2*(21 - 63*r) + 4*Pkdd2*k1**2*(3*s - 1))) + fd*(k1**2*(Pk2*(216*K*(s - 1)**2 + f*(-496*s**2 + s*(372*r - 635) + 140) + 8*s**2*(8*C - 59) + 8*s*(9*r + 54) - 216) - 2*k2*(Pkd2*(16*C*s**2 + K*(37*s**2 - 70*s + 35) + f*(-172*s**2 + s*(96*r - 197) + 47) + 18*r*s - 113*s**2 + 70*s - 35) + 2*Pkdd2*k2*(6*f*(4*s**2 + 3*s - 1) - s**2*(K - 7)))) - 2*k2**2*(Pk2*(8*C*(r - 1)**2 + 28*K*r**2 - 77*K*r*s + 98*K*r + f*(112*r**2 - 100*r + 15) - 29*r**2 - 33*r - 8) + k2*(7*K*Pkd2*(r*(6*s - 8) + 2*s - 1) + 14*K*Pkdd2*k2*(1 - 2*s) + 14*Pkd2*f*(2*r - 1) + 2*Pkd2*(C*s*(6*s + 64) + r*s*(27 - 64*C) + 14*r - 3*s*(s + 9)) + Pkdd2*k2*s**2*(4*C - 2))))) + 2*Dd*f*(k1**2*(2*Pk2*(64*C*s**2 - 16*C*s + 54*K*(4*s**2 - 5*s + 1) + f*(6*r*(31*s - 12) - 248*s**2 - 219*s + 83) + 72*r*s - 30*r - 472*s**2 + 358*s - 54) + k2*(Pkd2*(-64*C*s**2 + 16*C*s + K*(-148*s**2 + 177*s - 35) + f*(-24*r*(8*s - 3) + 344*s**2 + 246*s - 95) - 72*r*s + 30*r + 452*s**2 - 277*s + 35) + 2*Pkdd2*k2*(4*s - 1)*(-6*f*(2*s + 1) + s*(K - 7)))) + k2**2*(-2*Pk2*(8*C*(2*r**2 - 3*r + 1) + 56*K*r**2 - 154*K*r*s + 21*K*r - 21*K*s + f*(112*r**2 - 114*r + 29) - 58*r**2 + 45*r - 8) + k2*(Pkd2*(4*C*(16*r*(8*s - 1) - 12*s**2 - 93*s + 16) - 168*K*r*s + 112*K*r + 56*K*s - 49*K - 56*f*r + 28*f - 216*r*s - 50*r + 24*s**2 + 114*s + 22) + 2*Pkdd2*k2*(4*s - 1)*(-2*C*s + 7*K + s))))) - 33*b1*(D1*bd1*f*(8*Pk2*k1**2*(3*r*(6*s - 5) + 2*s*(C*(8*s - 4) + 27*K*(s - 1) - 59*s + 46)) - 4*Pkd2*k1**2*k2*(3*r*(6*s - 5) + s*(8*C*(2*s - 1) + 37*K*s - 36*K - 113*s + 80)) - 2*Pkd2*k2**3*(4*C*(r*(16 - 64*s) + 6*s**2 + 29*s - 16) + 7*K*(12*r*s - 4*r - 5*s + 4) + 108*r*s + 8*r - 12*s**2 - 6*s - 8) - 4*Pkdd2*k2**4*s*(C*(4*s - 2) - 7*K - 2*s + 1) + f*(k1**2*(Pk2*(12*r*(31*s - 24) - 496*s**2 - 241*s + 192) + 2*k2*(Pkd2*(-96*r*s + 72*r + 172*s**2 + 49*s - 48) + 12*Pkdd2*k2*s*(1 - 4*s))) - 2*k2**2*(Pk2*(112*r**2 - 128*r + 43) + 14*Pkd2*k2*(2*r - 1))) - 2*k2**2*(Pk2*(-21*K*s + r**2*(16*C + 56*K - 58) - 2*r*(8*C + 77*K*s + 14*K - 43)) + Pkdd2*k1**2*s*(14 - 2*K)*(2*s - 1))) - D1*(9*f**2*fd*k1**2*(Pk2*(r*(6*s + 44) - 240*s**2 + 173*s - 54) + 2*Pkd2*k2*(12*r*(3*s - 2) + 66*s**2 - 73*s + 23)) - 2*f*(bd2*k2*s*(-21*Pk2*k2*(r - 1) - 2*Pkd2*k1**2*s + 7*Pkd2*k2**2*(2*r - s + 2) + 2*Pkdd2*k1**2*k2*s + 14*Pkdd2*k2**3*s) + fd*(k1**2*(Pk2*(8*C*(26*s**2 - 45*s + 16) + 2*K*(62*s**2 - 101*s + 35) + 302*r*s - 123*r + 132*s**2 - 214*s + 8) + k2*(-Pkd2*(2*C*(82*s**2 - 111*s + 37) + K*(86*s**2 - 137*s + 47) + 208*r*s - 92*r + 20*s**2 - 96*s + 2) + 4*Pkdd2*k2*(K*(6*s**2 - 9*s + 3) + s**2*(4*C - 8)))) + k2**2*(Pk2*(-2*C*(56*r**2 - 6*r*(97*s - 27) + 301*s - 100) + 2*K*(28*r**2 + r*(81*s - 40) + 3*(1 - 2*s)**2) - 156*r**2 - 738*r*s + 426*r + 301*s - 102) + k2*(Pkd2*(-2*C*(8*r*(4*s - 11) + 25*s + 33) + 28*K*r*(3*s - 2) + 39*K*(1 - 2*s)**2 + 32*r*s - 132*r + 25*s + 49) + Pkdd2*k2*(24*C - 12)*(3*s - 1)))) - 2*gd2*(108*Pk2*k1**2*s*(s - 1) + Pkd2*k1**2*k2*s*(35 - 37*s) - 7*Pkd2*k2**3*(r*(6*s - 4) - 5*s + 4) + 14*Pkdd2*k2**4*s + k2**2*(7*Pk2*(-4*r**2 + 11*r*s + 4*r + 3*s) + 2*Pkdd2*k1**2*s**2))) + 2*fd*(b2*k2*s*(2*Pkd2*k1**2*s + 7*Pkd2*k2**2*(-2*r + s) - 14*Pkdd2*k2**3*s + k2*(21*Pk2*r - 2*Pkdd2*k1**2*s)) + 2*g2*(k1**2*(108*Pk2*(s - 1)**2 + k2*(Pkd2*(-37*s**2 + 70*s - 35) + 2*Pkdd2*k2*s**2)) + 7*k2**2*(Pk2*r*(-4*r + 11*s - 14) + Pkd2*k2*(-6*r*s + 8*r - 2*s + 1) + 2*Pkdd2*k2**2*(2*s - 1))))) - 2*Dd*f*(b2*k2*(2*Pkd2*k1**2*s*(4*s - 1) + 7*Pkd2*k2**2*(r*(4 - 8*s) + s*(4*s - 5)) + 14*Pkdd2*k2**3*s*(1 - 4*s) + 2*k2*s*(21*Pk2*(2*r - 1) + Pkdd2*k1**2*(1 - 4*s))) + 3*f**2*k1**2*(2*Pk2*(r*(6*s + 56) - 240*s**2 + 153*s - 52) + 3*Pkd2*k2*(16*r*(3*s - 2) + 88*s**2 - 90*s + 27)) - f*(k1**2*(Pk2*(8*C*(52*s**2 - 77*s + 16) + K*(248*s**2 - 342*s + 70) + 604*r*s - 359*r + 264*s**2 - 450*s + 200) + k2*(-Pkd2*(C*(328*s**2 - 378*s + 74) + K*(172*s**2 - 231*s + 47) + 416*r*s - 216*r + 40*s**2 - 202*s + 104) + 4*Pkdd2*k2*(4*s - 1)*(3*K*(s - 1) + s*(2*C - 4)))) + k2**2*(-2*Pk2*(2*C*(56*r**2 + r*(71 - 582*s) + 301*s - 52) - K*(56*r**2 + 162*r*s - 66*r + 24*s**2 - 15*s + 1) + 156*r**2 + 738*r*s - 364*r - 301*s + 126) + k2*(Pkd2*(-2*C*(32*r*(2*s - 3) + 60*s + 25) + K*(56*r*(3*s - 2) + 312*s**2 - 318*s + 95) + 64*r*s - 160*r + 60*s + 57) + Pkdd2*k2*(24*C - 12)*(4*s - 1)))) + 2*g2*(k1**2*(4*s - 1)*(108*Pk2*(s - 1) + k2*(-37*Pkd2*s + 35*Pkd2 + 2*Pkdd2*k2*s)) + 7*k2**2*(2*Pk2*(-8*r**2 + 22*r*s - 3*r + 3*s) + Pkd2*k2*(-24*r*s + 16*r + 8*s - 7) + 2*Pkdd2*k2**2*(4*s - 1))))) + f*(33*D1*bd1*(-2*b2*k2*(-2*Pkd2*k1**2*s*(s - 1) + 7*Pkd2*k2**2*(2*r*(s - 2) - s*(s - 1)) + 14*Pkdd2*k2**3*s*(s - 1) + k2*s*(-21*Pk2*r + 2*Pkdd2*k1**2*(s - 1))) + 3*f**2*k1**2*(Pk2*(r*(6*s + 92) - 240*s**2 + 93*s - 46) + 6*Pkd2*k2*(4*r*(3*s - 2) + 22*s**2 - 17*s + 4)) - 2*f*(k1**2*(Pk2*r*(151*s - 162) + 2*Pk2*(s**2*(52*C + 31*K + 33) - s*(64*C + 35*K + 48) + 59) + Pkd2*k2*(r*(84 - 104*s) - s**2*(82*C + 43*K + 10) + s*(82*C + 47*K + 34) - 62) + Pkdd2*k2**2*s*(s - 1)*(8*C + 12*K - 16)) + k2**2*(Pk2*(-192*C*s + K*(28*r**2 + r*(81*s - 26) + 12*s**2 - 3*s - 2) + r**2*(-56*C - 78) + r*(582*C*s - 8*C - 369*s + 146) + 96*s - 72) + Pkd2*k2*(-8*C*(r*(4*s + 6) + 11*s - 10) + K*(14*r*(3*s - 2) + 78*s**2 - 81*s + 28) + 4*r*(4*s + 5) + 44*s - 40))) - 4*g2*(-108*Pk2*k1**2*s*(s - 1) + 37*Pkd2*k1**2*k2*s*(s - 1) + 42*Pkd2*k2**3*r*s + k2**2*(7*Pk2*r*(4*r - 11*s) - 2*Pkdd2*k1**2*s*(s - 1)))) - 2*D1*(f*(fd*(k1**2*(Pk2*(132*C*(63*s**2 - 108*s + 29) - 477*r*s - 4461*r + 10692*s**2 - 4890*s + 1982) + 33*k2*(-Pkd2*(2*C*(93*s**2 - 148*s + 39) + 4*r*(36*s - 31) + 195*s**2 - 178*s + 63) + Pkdd2*k2*(20*C - 10)*(3*s**2 - 4*s + 1))) + k2**2*(Pk2*(2*C*(5976*r**2 + 14553*r*s - 9726*r + 1188*s**2 - 12573*s + 5020) - 9837*r**2 - 21087*r*s + 13191*r - 1188*s**2 + 12573*s - 5020) + Pkd2*k2*(66*C - 33)*(48*r*(3*s - 2) + 198*s**2 - 213*s + 65))) + (33*bd2 - 66*gd2)*(2*Pk2*k1**2*s*(31*s - 35) + Pkd2*k1**2*k2*s*(47 - 43*s) + Pkd2*k2**3*(14*r*(3*s - 2) + 78*s**2 - 81*s + 28) + k2**2*(Pk2*(28*r**2 + 81*r*s - 26*r + 12*s**2 - 3*s - 2) + 12*Pkdd2*k1**2*s*(s - 1)))) - 66*fd*g2*(k1**2*(2*s - 1)*(Pk2*(62*s - 70) + k2*(Pkd2*(47 - 43*s) + 12*Pkdd2*k2*(s - 1))) + k2**2*(2*Pk2*(28*r**2 + r*(81*s - 40) + 3*(1 - 2*s)**2) + Pkd2*k2*(28*r*(3*s - 2) + 39*(1 - 2*s)**2)))) - 2*Dd*f*(f*(k1**2*(Pk2*(132*C*(84*s**2 - 137*s + 29) - r*(636*s + 6673) + 14256*s**2 - 6676*s + 4194) + 33*k2*(-Pkd2*(C*(248*s**2 - 374*s + 78) + 6*r*(32*s - 27) + 260*s**2 - 241*s + 101) + Pkdd2*k2*(20*C - 10)*(4*s**2 - 5*s + 1))) + k2**2*(2*Pk2*(2*C*(3984*r**2 + 9702*r*s - 6290*r + 792*s**2 - 8217*s + 2941) - 6558*r**2 - 14058*r*s + 8666*r - 792*s**2 + 8217*s - 2941) + Pkd2*k2*(66*C - 33)*(64*r*(3*s - 2) + 264*s**2 - 294*s + 97))) - 66*g2*(k1**2*(4*s - 1)*(Pk2*(62*s - 70) + k2*(Pkd2*(47 - 43*s) + 12*Pkdd2*k2*(s - 1))) + k2**2*(2*Pk2*(56*r**2 + 6*r*(27*s - 11) + 24*s**2 - 15*s + 1) + Pkd2*k2*(56*r*(3*s - 2) + 312*s**2 - 318*s + 95)))) - 66*b2*(D1*fd*(k1**2*(2*s - 1)*(Pk2*(62*s - 70) + k2*(Pkd2*(47 - 43*s) + 12*Pkdd2*k2*(s - 1))) + k2**2*(2*Pk2*(28*r**2 + r*(81*s - 40) + 3*(1 - 2*s)**2) + Pkd2*k2*(28*r*(3*s - 2) + 39*(1 - 2*s)**2))) + Dd*f*(k1**2*(4*s - 1)*(Pk2*(62*s - 70) + k2*(Pkd2*(47 - 43*s) + 12*Pkdd2*k2*(s - 1))) + k2**2*(2*Pk2*(56*r**2 + 6*r*(27*s - 11) + 24*s**2 - 15*s + 1) + Pkd2*k2*(56*r*(3*s - 2) + 312*s**2 - 318*s + 95))))))/(693*d**2*k2**2*k3**2) + D1**3*Pk3*ct**2*st**4*(D1*(5148*b1*fd*k1**2*k2**2*(8*Pk2*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + k2*(Pkd2*(-4*r*s + 4*r - 9*s**2 + 8*s - 4) + Pkdd2*k2*s**2))*(b1*(K - 1) - 2*g2) + f**3*(195*bd1*k2**2*(11*Pk2*k2**2*(r - 1)*(10*r + 15*s - 8) - 24*k1**2*(4*Pk2*(4*r*(6*s - 1) + 18*s**2 - 22*s + 3) - k2*(Pkd2*(24*r*s - 4*r + 9*s**2 - 22*s + 3) + 3*Pkdd2*k2*s**2))) - 360*fd*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(188*s**2 - 107*s + 15) + 26*fd*k1**2*k2**2*(Pk2*(18*r*(1645*s - 478) + 40080*s**2 - 31705*s + 6022) + 5*k2*(Pkd2*(-1620*r*s + 486*r - 2652*s**2 + 2033*s - 383) + 18*Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 39*f**2*(fd*(k1**4*(1 - 3*s)**2*(8*C - 8)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) - 4*k1**2*k2**2*(-8*Pk2*(45*b1*(8*r*(3*s - 1) + 18*s**2 - 20*s + 5) + (6*s - 2)*(C*(-48*r + 30*s + 6) + 93*r + 30*s - 41)) + k2*(Pkd2*(45*b1*(16*r*(3*s - 1) + 18*s**2 - 22*s + 7) + (3*s - 1)*(-96*C*(2*r - 5*s + 1) + 372*r - 150*s - 74)) + 5*Pkdd2*k2*(9*b1*(6*s**2 - 6*s + 1) + (1 - 3*s)**2*(6 - 8*C)))) + k2**4*(Pk2*(96*C*(15*r**2 - 120*r*s + 19*r - 90*s**2 + 100*s - 18) - 55*b1*(3*r - 1)*(10*r + 15*s - 8) - 2952*r**2 + 5760*r*s + 1632*r + 4320*s**2 - 4800*s + 264) + 4*k2*(10*C*Pkd2*(3*s - 1)*(48*r + 27*s - 25) - 3*Pkd2*(r*(303*s - 90) + 135*s**2 - 191*s + 45) + Pkdd2*k2*(1 - 3*s)**2*(30*C - 15)))) + 132*k1**2*k2**2*(Pk2*bd1*(K*(-3*r*(5*s + 2) + 32*s**2 - 9*s + 6) + r*(47*s + 6) + 8*s**2 - 7*s - 6) + 2*Pk2*gd2*(3*r*(5*s + 2) - 32*s**2 + 9*s - 6) + bd1*k2*(Pkd2*(K*(3*r*s + 2*r - 20*s**2 + 6*s - 2) - 11*r*s - 2*r + 7*s**2 - 2*s + 2) + Pkdd2*k2*s*(K*(4*s - 1) - 3*s + 1)) + 2*gd2*k2*(Pkd2*(-r*(3*s + 2) + 20*s**2 - 6*s + 2) + Pkdd2*k2*s*(1 - 4*s)))) + 5148*f*k1**2*k2**2*(b1*(bd1*(K - 1)*(8*Pk2*(r*(4*s - 2) + 6*s**2 - 6*s + 1) + k2*(Pkd2*(-8*r*s + 4*r - 18*s**2 + 15*s - 2) + Pkdd2*k2*s*(2*s - 1))) + fd*(K*Pk2*(30*r*s - 4*r - 64*s**2 + 48*s - 8) - K*k2*(Pkd2*(-40*s**2 + s*(6*r + 30) - 5) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 2*Pk2*(r*(14 - 47*s) + s*(4 - 8*s)) + Pkd2*k2*(r*(22*s - 6) - 14*s**2 + 13*s - 3) + Pkdd2*k2**2*(6*s**2 - 5*s + 1)) - 2*gd2*(8*Pk2*(r*(2*s - 1) + 3*s**2 - 3*s + 1) + k2*(Pkd2*(-4*r*s + 2*r - 9*s**2 + 6*s - 2) + Pkdd2*k2*s**2))) - 2*g2*(8*Pk2*bd1*(r*(2*s - 1) + s*(3*s - 3)) + Pk2*fd*(30*r*s - 4*r - 64*s**2 + 48*s - 8) + bd1*k2*(Pkd2*r*(2 - 4*s) - 9*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1)) - fd*k2*(Pkd2*(-40*s**2 + s*(6*r + 30) - 5) + Pkdd2*k2*(8*s**2 - 6*s + 1))))) - 2*Dd*f*(-2574*b1*k1**2*k2**2*(8*Pk2*(r*(8*s - 5) + 12*s**2 - 13*s + 4) + k2*(Pkd2*(-16*r*s + 10*r - 36*s**2 + 29*s - 8) + Pkdd2*k2*s*(4*s - 1)))*(b1*(K - 1) - 2*g2) + f**3*k1**2*(180*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(188*s**2 - 107*s + 15) - 13*k2**2*(Pk2*(18*r*(1645*s - 478) + 40080*s**2 - 31705*s + 6022) + 5*k2*(Pkd2*(-1620*r*s + 486*r - 2652*s**2 + 2033*s - 383) + 18*Pkdd2*k2*(12*s**2 - 7*s + 1)))) + 39*f**2*(k1**4*(4*C - 4)*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) - 2*k1**2*k2**2*(-8*Pk2*(4*C*(r*(28 - 96*s) + 60*s**2 + 5*s - 7) + 30*b1*(2*r*(24*s - 7) + 36*s**2 - 41*s + 9) + 744*r*s - 217*r + 240*s**2 - 450*s + 113) + k2*(Pkd2*(32*C*(r*(7 - 24*s) + 60*s**2 - 25*s + 2) + 15*b1*(8*r*(24*s - 7) + 72*s**2 - 110*s + 27) + 62*r*(24*s - 7) - 600*s**2 - 270*s + 136) + 5*Pkdd2*k2*(4*s - 1)*(9*b1*(2*s - 1) - (8*C - 6)*(3*s - 1)))) + k2**4*(20*C*Pkd2*k2*(8*r*(24*s - 7) + 108*s**2 - 143*s + 33) - 55*Pk2*b1*(2*r - 1)*(10*r + 15*s - 8) + 8*Pk2*(4*C*(30*r**2 + r*(23 - 240*s) - 180*s**2 + 205*s - 29) - 246*r**2 + r*(480*s + 197) + 360*s**2 - 410*s - 17) - 6*Pkd2*k2*(r*(404*s - 105) + 180*s**2 - 277*s + 60) + Pkdd2*k2**2*(60*C - 30)*(12*s**2 - 7*s + 1))) + 2574*f*k1**2*k2**2*(-2*Pk2*b1*(K*(r*(30*s + 4) - 64*s**2 + 33*s - 10) + r*(8 - 94*s) - 16*s**2 + 11*s + 6) + 4*Pk2*g2*(r*(30*s + 4) - 64*s**2 + 33*s - 10) + b1*k2*(Pkd2*(K*(12*r*s + 4*r - 80*s**2 + 42*s - 9) - 44*r*s + 2*r + 28*s**2 - 17*s + 7) + Pkdd2*k2*(4*s - 1)*(K*(4*s - 1) - 3*s + 1)) - 2*g2*k2*(Pkd2*(4*r*(3*s + 1) - 80*s**2 + 42*s - 9) + Pkdd2*k2*(1 - 4*s)**2))))/(9009*d**2*k2**2*k3**4) - 4*D1**3*Pk3*ct**2*st**2*(D1*(858*b1*fd*k2**2*(-12*Pk2*b2*k2**4*(r + s)**2 + b1*k1**4*(K - 1)*(2*Pk2*(r**2 + r*(15*s - 2) + 14*s**2 - 2*s + 1) - 13*Pkd2*k2*s*(r + s)) + b1*k1**2*k2**2*(2*Pk2*(2*C*(r + s - 1)**2 + K*(-13*r**2 + 14*r*s - 66*r + 27*s**2 - 66*s + 33) + 50*r**2 + 60*r*s + 44*r + 10*s**2 + 44*s - 22) - Pkd2*k2*s*(92*K - 53)*(r + s)) - 12*b1*k2**4*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s)) + 2*g2*(k1**4*(-2*Pk2*(r**2 + 15*r*s - 2*r + 14*s**2 - 2*s + 1) + 13*Pkd2*k2*s*(r + s)) + 2*k1**2*k2**2*(Pk2*(13*r**2 - 14*r*s + 66*r - 27*s**2 + 66*s - 33) + 46*Pkd2*k2*s*(r + s)) + 12*k2**4*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + 3*f**3*(-13*bd1*k2**2*(66*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(2*Pk2*(516*r**2 + 1704*r*s - 901*r + 1188*s**2 - 1373*s + 181) + Pkd2*k2*(-672*r*s + 113*r - 672*s**2 + 585*s + 91)) + 33*k1**2*k2**2*(Pk2*(68*r**2 + 28*r*s - 59*r - 40*s**2 + 13*s + 1) + 2*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + fd*k1**2*(1404*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1592*s - 723) + 1592*s**2 - 2112*s + 591) + 26*k1**2*k2**2*(Pk2*(1050*r**2 + r*(3487 - 14238*s) - 15288*s**2 + 15741*s - 3206) + 25*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 13*f**2*k2**2*(-396*Pk2*bd2*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 33*bd1*(2*k1**4*(2*Pk2*(2*C*(r**2 + r*(11*s - 4) + 10*s**2 - 11*s + 1) - K*(11*r**2 + 38*r*s - 17*r + 27*s**2 - 19*s + 6) + 22*r**2 + 49*r*s - 34*r + 27*s**2 - 29*s + 16) + Pkd2*k2*(-2*C*(r*(9*s - 3) + 9*s**2 - 10*s + 1) - 3*K*(3*s - 1)*(r + s - 1) + 20*r*s - 6*r + 20*s**2 - 22*s + 2)) + k1**2*k2**2*(2*Pk2*(-4*C*(9*r**2 - 17*r*s - 13*r - 4*s**2 + 9*s + 6) - 205*K*r**2 - 613*K*r*s + 339*K*r - 408*K*s**2 + 428*K*s - 134*K + 6*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + 87*r**2 + 199*r*s - 132*r + 156*s**2 - 129*s + 53) + Pkd2*k2*(-4*C*(r*(62*s - 30) + 48*s**2 - 65*s + 17) + 3*b1*(r*(92*s - 21) + 92*s**2 - 89*s + 9) + 122*r*s - 62*r + 94*s**2 - 124*s + 24)) + k2**4*(Pk2*(-8*C*(12*r**2 + 42*r*s - 32*r + 18*s**2 - 33*s + 18) + 2*K*(51*r**2 + 33*r*s - 65*r - 18*s**2 - 30*s + 14) + b1*(42*r**2 + 7*r*(6*s - 1) - 9*s - 13) + 24*r**2 + 6*r*(24*s - 13) + 72*s**2 - 102*s + 54) + 12*Pkd2*k2*(C*(r*(4 - 8*s) - 6*s**2 + 8*s - 2) + K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r*s - 2*r + 3*s**2 - 4*s + 1))) + fd*(k1**4*(-2*Pk2*(-4*C*(405*r**2 + 9*r*(151*s - 128) + 954*s**2 - 1353*s + 533) + 9*b1*(516*r**2 + 3*r*(568*s - 159) + 1188*s**2 - 837*s + 97) + 2862*r**2 + 8838*r*s - 6900*r + 5976*s**2 - 8448*s + 3152) + 3*Pkd2*k2*(4*C*(141*r*s - 36*r + 141*s**2 - 163*s + 35) + b1*(9*r*(224*s + 153) + 2016*s**2 + 297*s - 973) - 258*r*s - 2*r - 258*s**2 + 258*s - 28)) + 3*k1**2*k2**2*(Pk2*(4*C*(1869*r**2 + 14451*r*s - 5293*r + 6642*s**2 - 11280*s + 2973) + 33*b1*(204*r**2 + 21*r*(4*s - 9) - 120*s**2 + 11*s + 45) - 108*r**2 - 27504*r*s + 8382*r - 15516*s**2 + 24198*s - 6068) + 6*Pkd2*k2*(-2*C*(156*r*s - 85*r + 156*s**2 - 178*s + 53) + 11*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 420*r*s - 217*r + 420*s**2 - 486*s + 141)) - 18*k2**4*(Pk2*(2*C*(975*r**2 + 381*r*s - 865*r + 66*s**2 + 16*s + 125) - 11*b1*(3*r - 1)*(5*r + 5*s - 3) - 1239*r**2 - 645*r*s + 1063*r - 66*s**2 + 28*s - 147) + Pkd2*k2*(44*C - 22)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) - 132*gd2*(Pk2*k1**2*k2**2*(205*r**2 + r*(613*s - 339) + 408*s**2 - 428*s + 134) + k1**4*(2*Pk2*(11*r**2 + 38*r*s - 17*r + 27*s**2 - 19*s + 6) + 3*Pkd2*k2*(3*s - 1)*(r + s - 1)) + k2**4*(Pk2*(-51*r**2 - 33*r*s + 65*r + 18*s**2 + 30*s - 14) - 6*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 429*f*k2**2*(-24*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 12*Pk2*b2*fd*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*k2**2*(Pk2*k2**2*(42*r**2 + r*(42*s - 19) - 9*s - 1) + 3*k1**2*(4*Pk2*(12*r**2 + 24*r*s - r + 12*s**2 - s - 5) + Pkd2*k2*s*(92*r + 92*s - 43))) + 2*b1*(-12*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + bd1*(k1**4*(2*K - 2)*(Pk2*(2*r**2 + r*(30*s - 13) + 28*s**2 - 19*s + 1) + Pkd2*k2*(r*(5 - 13*s) + s*(8 - 13*s))) + k1**2*k2**2*(2*Pk2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + K*(-26*r**2 + 28*r*s - 34*r + 54*s**2 - 60*s + 33) + 100*r**2 + 120*r*s - 51*r + 20*s**2 - 25*s - 22) + Pkd2*k2*(r*(K*(53 - 184*s) + 106*s - 30) + s*(K*(131 - 184*s) + 106*s - 76))) - 6*k2**4*(K*(2*Pk2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(2*Pk2*(4*C*(r**2 + r*(11*s - 2) + 10*s**2 - 6*s + 1) - K*(22*r**2 + 76*r*s - 41*r + 54*s**2 - 47*s + 10) + 44*r**2 + 98*r*s - 72*r + 54*s**2 - 71*s + 20) - Pkd2*k2*(36*C*r*s + 36*C*s**2 - 16*C*s + 3*K*(2*s - 1)*(3*r + 3*s - 2) - 40*r*s + r - 40*s**2 + 20*s - 1)) + k1**2*k2**2*(Pk2*(-4*C*(18*r**2 + r*(19 - 34*s) - 8*s**2 + 57*s - 26) - K*(410*r**2 + 1226*r*s - 652*r + 816*s**2 - 806*s + 199) + 174*r**2 + 398*r*s - 191*r + 312*s**2 - 182*s + 11) + Pkd2*k2*(r*(s*(122 - 248*C) + 27) + s**2*(94 - 192*C) + s*(132*C - 33) - 15)) + k2**4*(Pk2*(-4*C*(24*r**2 + 84*r*s + 36*s**2 - 25*s - 12) + K*(102*r**2 + 22*r*(3*s - 1) - 9*(1 - 2*s)**2) + 24*r**2 + 144*r*s + 72*s**2 - 57*s - 18) + 12*Pkd2*k2*(K*(2*s - 1)*(2*r + 2*s - 1) - s*(2*C - 1)*(4*r + 3*s - 2)))) - 2*gd2*(k1**4*(2*Pk2*(r**2 + 15*r*s - 2*r + 14*s**2 - 5*s + 1) + Pkd2*k2*s*(-13*r - 13*s + 3)) + k1**2*k2**2*(Pk2*(-26*r**2 + 28*r*s - 40*r + 54*s**2 - 66*s + 66) + Pkd2*k2*s*(-92*r - 92*s + 39)) - 6*k2**4*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 4*bd1*g2*(k1**4*(-2*Pk2*(r**2 + r*(15*s - 11) + s*(14*s - 14)) + Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + k1**2*k2**2*(Pk2*(26*r**2 - 28*r*(s - 1) - s*(54*s - 54)) + Pkd2*k2*(r*(92*s - 53) + s*(92*s - 92))) + 6*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + 4*fd*g2*(Pk2*k1**2*k2**2*(410*r**2 + 2*r*(613*s - 326) + 816*s**2 - 806*s + 199) + k1**4*(2*Pk2*(22*r**2 + 76*r*s - 41*r + 54*s**2 - 47*s + 10) + 3*Pkd2*k2*(2*s - 1)*(3*r + 3*s - 2)) + k2**4*(Pk2*(-102*r**2 + r*(22 - 66*s) + 9*(1 - 2*s)**2) - 12*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(858*b1*k2**2*(-12*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(K - 1)*(2*Pk2*(4*r**2 + r*(60*s - 17) + 56*s**2 - 26*s + 3) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) + k1**2*k2**2*(2*Pk2*(2*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(-52*r**2 + 56*r*s - 120*r + 108*s**2 - 159*s + 99) + 200*r**2 + 240*r*s - 35*r + 40*s**2 + 4*s - 66) + Pkd2*k2*(r*(K*(53 - 368*s) + 212*s - 30) + s*(K*(170 - 368*s) + 212*s - 99))) - 6*k2**4*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(k1**4*(2*Pk2*(4*r**2 + r*(60*s - 17) + 56*s**2 - 26*s + 3) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) + k1**2*k2**2*(-2*Pk2*(52*r**2 - 56*r*s + 120*r - 108*s**2 + 159*s - 99) + Pkd2*k2*(r*(53 - 368*s) + s*(170 - 368*s))) - 6*k2**4*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 3*f**3*k1**2*(1404*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1592*s - 723) + 1592*s**2 - 2112*s + 591) + 26*k1**2*k2**2*(Pk2*(1050*r**2 + r*(3487 - 14238*s) - 15288*s**2 + 15741*s - 3206) + 25*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) + 26*f**2*k2**2*(k1**4*(2*Pk2*(-4*C*(270*r**2 + 906*r*s - 723*r + 636*s**2 - 820*s + 346) + 6*b1*(516*r**2 + r*(1704*s - 583) + 1188*s**2 - 971*s + 118) + 1908*r**2 + 5892*r*s - 4491*r + 3984*s**2 - 5428*s + 2140) - 3*Pkd2*k2*(2*C*(188*r*s - 53*r + 188*s**2 - 243*s + 52) + 4*b1*(2*r*(168*s + 79) + 336*s**2 - 36*s - 133) - 172*r*s + 8*r - 172*s**2 + 205*s - 23)) - 3*k1**2*k2**2*(Pk2*(2*C*(2492*r**2 + 19268*r*s - 6580*r + 8856*s**2 - 15728*s + 3637) + 33*b1*(136*r**2 + 4*r*(14*s - 31) - 80*s**2 + 12*s + 23) - 72*r**2 - 18336*r*s + 4726*r - 10344*s**2 + 16578*s - 3551) + 3*Pkd2*k2*(-2*C*(208*r*s - 101*r + 208*s**2 - 230*s + 69) + 11*b1*(21*s - 10)*(4*r + 4*s - 3) + 560*r*s - 266*r + 560*s**2 - 648*s + 190)) + 9*k2**4*(Pk2*(2*C*(1300*r**2 + 508*r*s - 1336*r + 88*s**2 + 12*s + 271) - 22*b1*(2*r - 1)*(5*r + 5*s - 3) - 1652*r**2 - 860*r*s + 1644*r - 88*s**2 + 76*s - 315) + Pkd2*k2*(88*C - 44)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 429*f*k2**2*(12*Pk2*b2*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(72*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*Pk2*k2**2*(42*r**2 + r*(42*s - 13) - 9*s - 7) + 3*Pkd2*k1**2*k2*(r*(184*s - 21) + 184*s**2 - 132*s + 9)) + 2*b1*(k1**4*(2*Pk2*(4*C*(2*r**2 + r*(22*s - 5) + 20*s**2 - 16*s + 2) - K*(44*r**2 + 152*r*s - 75*r + 108*s**2 - 85*s + 22) + 88*r**2 + 196*r*s - 144*r + 108*s**2 - 133*s + 52) + Pkd2*k2*(C*(r*(6 - 72*s) - 72*s**2 + 50*s - 2) - 3*K*(12*r*s - 5*r + 12*s**2 - 15*s + 4) + 80*r*s - 7*r + 80*s**2 - 58*s + 3)) + k1**2*k2**2*(Pk2*(4*C*(-36*r**2 + 68*r*s + r + 16*s**2 - 92*s + 22) - K*(820*r**2 + 2452*r*s - 1330*r + 1632*s**2 - 1662*s + 467) + 348*r**2 + 796*r*s - 445*r + 624*s**2 - 408*s + 99) + Pkd2*k2*(C*(r*(60 - 496*s) - 384*s**2 + 360*s - 34) + r*(244*s + 5) + 188*s**2 - 131*s - 12)) + k2**4*(Pk2*(-8*C*(24*r**2 + r*(84*s - 22) + 36*s**2 - 43*s + 3) + K*(204*r**2 + 4*r*(33*s - 38) - 72*s**2 - 24*s + 19) + 48*r**2 + 3*r*(96*s - 17) + 144*s**2 - 162*s + 9) - 6*Pkd2*k2*(C*(4*r*(8*s - 1) + 24*s**2 - 22*s + 2) - 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 16*r*s + 2*r - 12*s**2 + 11*s - 1))) + 4*g2*(Pk2*k1**2*k2**2*(820*r**2 + 2*r*(1226*s - 665) + 1632*s**2 - 1662*s + 467) + k1**4*(2*Pk2*(44*r**2 + 152*r*s - 75*r + 108*s**2 - 85*s + 22) + 3*Pkd2*k2*(12*r*s - 5*r + 12*s**2 - 15*s + 4)) + k2**4*(Pk2*(-204*r**2 - 132*r*s + 152*r + 72*s**2 + 24*s - 19) - 12*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k2**2*k3**6) + 4*D1**3*Pk3*ct**2*(D1*bd1*f*(f**2*k1**2*(1089*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + 10*k1**4*(2*Pk2 - Pkd2*k2)*(3*r*(9*s - 10) + 27*s**2 - 47*s + 20) - 33*k1**2*k2**2*(Pk2*(215*r**2 + r*(11*s - 215) - 204*s**2 + 106*s + 70) + 20*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) - 33*f*k2**2*(-2*k1**4*(Pk2*(-4*C*(30*r**2 + 81*r*s - 54*r + 27*s**2 - 59*s + 20) - 32*K*r**2 - 105*K*r*s + 40*K*r - 73*K*s**2 + 69*K*s - 8*K + 12*b1*(4*r**2 + r*(8*s - 5) + 4*s**2 - 5*s + 1) + 200*r**2 + 463*r*s - 338*r + 215*s**2 - 355*s + 122) + 2*Pkd2*k2*(-4*C*(r*(7*s - 2) + 7*s**2 - 8*s + 1) - 12*K*(s - 1)*(r + s - 1) + 2*b1*(r*(7*s - 4) + 7*s**2 - 7*s + 2) + 30*r*s - 12*r + 30*s**2 - 39*s + 9)) + k1**2*k2**2*(Pk2*(2*C*(566*r**2 + 14*r*(22*s - 39) + 346*s**2 - 402*s + 8) + 2*K*(298*r**2 + 9*r*(81*s - 58) + 431*s**2 - 567*s + 224) - b1*(858*r**2 + 3*r*(478*s - 457) + 576*s**2 - 1085*s + 511) - 1188*r**2 - 16*r*(89*s - 86) - 840*s**2 + 1056*s - 244) - 12*Pkd2*k2*(-2*C*(14*r*s - 6*r + 14*s**2 - 15*s + 1) - 10*K*r*s + 6*K*r - 10*K*s**2 + 16*K*s - 6*K + b1*(6*r*(5*s - 1) + 30*s**2 - 28*s + 2) + 20*r*s - 8*r + 20*s**2 - 21*s + 1)) + k2**4*(26*K*Pk2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) - 13*Pk2*b1*(2*r - 1)*(3*r + 3*s - 1) + 2*Pk2*(r**2*(218*C - 135) + r*(2*C*(72*s - 107) - 98*s + 119) + s*(130*C - 65)*(s - 1)) + Pkd2*k2*(48*C - 24)*(r*(2*s - 1) + s*(2*s - 2)))) + 132*k2**2*(Pk2*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(k1**4*(2*Pk2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) - 5*K*s**2 + 3*K*s + r**2*(15 - 11*K) + r*(-16*K*s + 13*K + 24*s - 15) + 9*s**2 - 5*s - 2) - Pkd2*k2*(r*(K*(22*s - 2) - 18*s + 1) + s*(K*(22*s - 20) - 18*s + 17))) + k1**2*k2**2*(Pk2*(4*C*(8*r**2 + r*(23 - 124*s) + 8*s**2 + 58*s - 31) - K*(79*r**2 + 98*r*s - 41*r + 19*s**2 + 3*s - 30) + 121*r**2 + 466*r*s - 158*r + 65*s**2 - 186*s + 44) + Pkd2*k2*(r*(K*(17 - 82*s) + 42*s - 7) + s*(-82*K*s + 65*K + 42*s - 35))) + k2**4*(7*K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + Pk2*(4*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 7*K*(9*r**2 + 18*r*s - 7*r + 9*s**2 - 7*s - 2) + 24*r**2 + 76*r*s - 29*r - 4*s**2 - 29*s + 12))) + g2*(2*k1**4*(Pk2*(11*r**2 + r*(16*s - 15) + s*(5*s - 5)) + Pkd2*k2*(r*(11*s - 2) + s*(11*s - 11))) + k1**2*k2**2*(Pk2*(79*r**2 + 7*r*(14*s - 9) + s*(19*s - 19)) + 2*Pkd2*k2*(r*(41*s - 17) + s*(41*s - 41))) + 7*k2**4*(9*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 132*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(4*k1**4*(Pk2*(4*C*(r + s - 1)**2 - 11*K*r**2 - 16*K*r*s - 5*K*s**2 + f*(24*r**2 + 48*r*s - 22*r + 24*s**2 - 22*s + 6) + 15*r**2 + 24*r*s + 8*r + 9*s**2 + 8*s - 4) + Pkd2*k2*s*(7*f*(2*r + 2*s - 1) - (11*K - 9)*(r + s))) + k1**2*k2**2*(Pk2*(32*C*(2*r**2 - r*(31*s + 4) + 2*s**2 + 31*s + 2) - 2*K*(79*r**2 + 2*r*(49*s + 60) + 19*s**2 + 120*s - 60) + f*(858*r**2 + 3*r*(478*s - 265) + 576*s**2 - 653*s + 147) + 242*r**2 + 932*r*s + 208*r + 130*s**2 - 352*s - 104) + 4*Pkd2*k2*s*(f*(90*r + 90*s - 39) - (41*K - 21)*(r + s))) - k2**4*(56*K*Pkd2*k2*s*(r + s) + Pk2*(-16*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 14*K*(9*r**2 + 2*r*(9*s + 4) + 9*s**2 + 8*s - 4) - 13*f*(2*r - 1)*(3*r + 3*s - 1) - 48*r**2 - 8*r*(19*s + 2) + 8*s**2 + 96*s + 8))) + 2*Dd*f*(2*k1**4*(Pk2*(4*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 44*K*r**2 - 64*K*r*s + 37*K*r - 20*K*s**2 + 7*K*s + 4*f*(12*r**2 + 24*r*s - 13*r + 12*s**2 - 13*s + 3) + 60*r**2 + 96*r*s - 33*r + 36*s**2 - 3*s - 12) + Pkd2*k2*(f*(4*r*(7*s - 2) + 28*s**2 - 21*s + 4) + r*(-44*K*s + 2*K + 36*s - 1) + s*(-44*K*s + 29*K + 36*s - 25))) + k1**2*k2**2*(Pk2*(8*C*(16*r**2 + r*(7 - 248*s) + 16*s**2 + 182*s - 23) - 316*K*r**2 - 392*K*r*s - 19*K*r - 76*K*s**2 - 151*K*s + 180*K + f*(858*r**2 + 3*r*(478*s - 361) + 576*s**2 - 869*s + 329) + 484*r**2 + 1864*r*s - 281*r + 260*s**2 - 855*s - 16) + 2*Pkd2*k2*(3*f*(r*(60*s - 6) + 60*s**2 - 41*s + 2) + r*(-164*K*s + 17*K + 84*s - 7) + s*(-164*K*s + 89*K + 84*s - 49))) + k2**4*(-14*K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) + Pk2*(8*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) - 252*K*r**2 - 504*K*r*s + 77*K*r - 252*K*s**2 + 77*K*s + 84*K + 13*f*(2*r - 1)*(3*r + 3*s - 1) + 96*r**2 + 304*r*s - 70*r - 16*s**2 - 168*s + 16)))) + b1*(3*D1*(-f**2*fd*k1**2*(-363*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - 90*k1**4*s*(2*Pk2 - Pkd2*k2)*(3*r + 3*s - 2) + 11*k1**2*k2**2*(Pk2*(645*r**2 + r*(33*s - 635) - 612*s**2 + 68*s + 142) + 20*Pkd2*k2*(r*(12*s + 13) + 12*s**2 + 6*s - 9))) - 22*f*k2**2*(-4*Pk2*bd2*k2**2*(k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*k1**4*(Pk2*(4*C*(60*r**2 + 18*r*(9*s - 4) + 54*s**2 - 94*s + 27) + K*(64*r**2 + 105*r*(2*s - 1) + 146*s**2 - 179*s + 53) - 400*r**2 - 926*r*s + 475*r - 430*s**2 + 577*s - 167) + 4*Pkd2*k2*(2*r + 2*s - 1)*(6*K*(s - 1) + s*(14*C - 15) + 3)) + fd*k1**2*k2**2*(Pk2*(2*C*(566*r**2 + 7*r*(44*s - 69) + 346*s**2 + 83*s + 84) + K*(596*r**2 + 1458*r*s - 903*r + 862*s**2 - 1017*s + 293) - 1188*r**2 - 1424*r*s + 1022*r - 840*s**2 + 412*s - 186) + 12*Pkd2*k2*(K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2*C*(14*r + 14*s - 5) - 20*r - 20*s + 7))) + fd*k2**4*(Pk2*(C*(436*r**2 + 18*r*(16*s - 17) + 260*s**2 + 98*s + 20) + 13*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 270*r**2 - 196*r*s + 179*r - 130*s**2 - 35*s - 10) + Pkd2*k2*s*(24*C - 12)*(4*r + 4*s - 1)) - 2*gd2*(2*k1**4*(Pk2*(11*r**2 + r*(16*s - 11) + s*(5*s - 1)) + Pkd2*k2*s*(11*r + 11*s - 9)) + k1**2*k2**2*(Pk2*(79*r**2 + 98*r*s - 19*r + 19*s**2 + 25*s - 60) + 2*Pkd2*k2*s*(41*r + 41*s - 24)) + 7*k2**4*(Pk2*(9*r**2 + 18*r*s - 5*r + 9*s**2 - 5*s - 4) + 2*Pkd2*k2*s*(2*r + 2*s - 1)))) + 44*fd*k2**2*(2*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(r + s)**2 + g2*(2*k1**4*(r + s)*(11*Pk2*r + 5*Pk2*s + 11*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(79*r**2 + 98*r*s + 120*r + 19*s**2 + 120*s - 60) + 82*Pkd2*k2*s*(r + s)) + 7*k2**4*(Pk2*(9*r**2 + 18*r*s + 8*r + 9*s**2 + 8*s - 4) + 4*Pkd2*k2*s*(r + s))))) + 2*Dd*f*(f**2*k1**2*(1089*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(6*r*(18*s - 5) + 108*s**2 - 101*s + 20) - 33*k1**2*k2**2*(Pk2*(430*r**2 + r*(22*s - 425) - 408*s**2 + 87*s + 106) + 10*Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) - 33*f*k2**2*(k1**4*(Pk2*(4*C*(120*r**2 + 9*r*(36*s - 19) + 108*s**2 - 215*s + 62) + K*(128*r**2 + 5*r*(84*s - 37) + 292*s**2 - 317*s + 69) - 800*r**2 - 1852*r*s + 1115*r - 860*s**2 + 1275*s - 391) + 2*Pkd2*k2*(4*C*(r*(28*s - 2) + 28*s**2 - 21*s + 1) + 12*K*(s - 1)*(4*r + 4*s - 3) - (12*s - 3)*(10*r + 10*s - 7))) + k1**2*k2**2*(Pk2*(2*C*(1132*r**2 + 77*r*(8*s - 15) + 692*s**2 - 119*s + 204) + K*(1192*r**2 + 3*r*(972*s - 649) + 1724*s**2 - 2151*s + 741) - 2376*r**2 - 4*r*(712*s - 627) - 1680*s**2 + 1252*s - 512) + 6*Pkd2*k2*(2*C*(r*(56*s - 6) + 56*s**2 - 34*s + 1) + K*(40*r*s - 26*r + 40*s**2 - 58*s + 20) - 80*r*s + 8*r - 80*s**2 + 48*s - 1)) + k2**4*(Pk2*(C*(872*r**2 + r*(576*s - 806) + 520*s**2 - 30*s + 88) + 13*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 540*r**2 - 392*r*s + 467*r - 260*s**2 + 43*s - 44) + Pkd2*k2*(24*C - 12)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 66*k2**2*(2*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*k1**4*(Pk2*(44*r**2 + r*(64*s - 37) + s*(20*s - 7)) + Pkd2*k2*(r*(44*s - 2) + s*(44*s - 29))) + k1**2*k2**2*(Pk2*(316*r**2 + r*(392*s + 19) + 76*s**2 + 151*s - 180) + 2*Pkd2*k2*(r*(164*s - 17) + s*(164*s - 89))) + 7*k2**4*(Pk2*(36*r**2 + 72*r*s - 11*r + 36*s**2 - 11*s - 12) + 2*Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + 2*f*(D1*(5*f**2*fd*k1**4*(-183*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(7*r*(36*s - 49) + 252*s**2 - 547*s + 261) - 28*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*k2**2*(-132*Pk2*bd2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k2**4*(33 - 66*C)*(117*r**2 + 3*r*(105*s - 61) + 198*s**2 - 204*s + 59) - 2*k1**4*(C*Pk2*(2880*r**2 + 3*r*(3543*s - 1601) + 7749*s**2 - 8940*s + 2219) - 2*Pk2*(1710*r**2 + 39*r*(138*s - 71) + 3672*s**2 - 4539*s + 1240) + Pkd2*k2*(660*C - 495)*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(-2*C*(26712*r**2 + 64431*r*s - 43575*r + 37719*s**2 - 48174*s + 16265) + 34038*r**2 + 81261*r*s - 53871*r + 47223*s**2 - 58800*s + 19499) + Pkd2*k2*(330 - 660*C)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + 66*gd2*(13*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**4*(Pk2*(32*r**2 + 5*r*(21*s - 8) + 73*s**2 - 69*s + 8) + 24*Pkd2*k2*(s - 1)*(r + s - 1)) + k1**2*k2**2*(Pk2*(298*r**2 + 9*r*(81*s - 58) + 431*s**2 - 567*s + 224) + 12*Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 66*fd*k2**2*(-2*Pk2*b2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + g2*(13*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**4*(Pk2*(64*r**2 + 105*r*(2*s - 1) + 146*s**2 - 179*s + 53) + 24*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(596*r**2 + 1458*r*s - 903*r + 862*s**2 - 1017*s + 293) + 12*Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))))) + Dd*f*(5*f**2*k1**4*(-183*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(7*r*(36*s - 49) + 252*s**2 - 547*s + 261) - 28*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*k2**2*(Pk2*k2**4*(33 - 66*C)*(156*r**2 + 4*r*(105*s - 62) + 264*s**2 - 276*s + 85) - 2*k1**4*(Pk2*(C*(3840*r**2 + 14172*r*s - 6063*r + 10332*s**2 - 11459*s + 2519) - 4560*r**2 - 14352*r*s + 7183*r - 9792*s**2 + 11758*s - 2985) + Pkd2*k2*(660*C - 495)*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(-2*C*(35616*r**2 + 85908*r*s - 59505*r + 50292*s**2 - 65297*s + 23291) + 45384*r**2 + 108348*r*s - 73365*r + 62964*s**2 - 79157*s + 27647) + Pkd2*k2*(330 - 660*C)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 66*k2**2*(-2*Pk2*b2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + g2*(13*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**4*(Pk2*(128*r**2 + 5*r*(84*s - 37) + 292*s**2 - 317*s + 69) + 24*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(1192*r**2 + 3*r*(972*s - 649) + 1724*s**2 - 2151*s + 741) + 12*Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 29*s + 10)))))))/(693*d**2*k2**2*k3**6) - D1**3*Pk3*ct**2*(2*D1*bd1*f*(f*(Pk2*k2**2*r*(16*C - 8) + k1**2*(Pk2*(3*r*(9*s - 10) + 2*s*(62*C*s - 70*C - 31*s + 71)) + k2*(-4*Pkd2*r*(7*s - 4) - Pkd2*s*(2*C - 1)*(43*s - 47) + Pkdd2*k2*s*(24*C - 12)*(s - 1)))) + k1**2*s*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(7*b2 - 14*g2)*(s - 1)) + 7*b1**3*k1**2*(D1*fd*s*(5*Pk2 - 2*Pkd2*k2)*(r - 1) + 2*Dd*f*(Pk2*(10*r*s - 4*r - 13*s + 4) + 2*Pkd2*k2*(-2*r*s + r + 3*s - 1))) + b1**2*k1**2*(7*D1*bd1*f*(Pk2*(r*(15*s - 8) - 21*s + 8) + 2*Pkd2*k2*(r*(2 - 3*s) + 5*s - 2)) + D1*fd*(-8*C*Pkd2*k2*s**2 + 8*C*Pkdd2*k2**2*s**2 + 14*K*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(s - 1)**2 - 3*Pk2*f*(2*r*(s + 4) - 29*s + 10) + 250*Pk2*r*s - 210*Pk2*r - 40*Pk2*s - 14*Pkd2*f*k2*(2*r - 1)*(3*s - 2) - 76*Pkd2*k2*r*s + 56*Pkd2*k2*r + 4*Pkd2*k2*s**2 + 20*Pkd2*k2*s - 4*Pkdd2*k2**2*s**2) - 2*Dd*f*(Pk2*(-98*K*(4*s**2 - 5*s + 1) + 3*f*(2*r*(s + 11) - 29*s - 4) - 500*r*s + 241*r + 200*s - 108) + k2*(Pkd2*(63*K*(4*s**2 - 5*s + 1) + 14*f*(2*r - 1)*(3*s - 2) + 8*r*(19*s - 12) + s**2*(16*C - 8) - s*(4*C + 98) + 54) - 2*Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(2*C - 1))))) + b1*(D1*bd1*f*k1**2*(Pk2*f*(-6*r*(s + 18) + 87*s + 54) + 4*Pk2*(98*K*s**2 + r*(125*s - 54) - s*(98*K + 66) + 40) + 2*Pkd2*k2*(-8*C*s**2 + 4*C*s - 126*K*s**2 + 126*K*s - 7*f*(2*r - 1)*(3*s - 2) + r*(54 - 76*s) + 4*s**2 + 64*s - 40) + 4*Pkdd2*k2**2*s*(C*(4*s - 2) + 14*K*(s - 1) - 2*s + 1)) + 2*D1*(f*(fd*(Pk2*k2**2*(16*C - 8)*(2*r - 1) + k1**2*(Pk2*(4*C*(62*s**2 - 101*s + 35) + 54*r*s - 55*r - 124*s**2 + 314*s - 112) + k2*(Pkd2*(-2*C*(86*s**2 - 137*s + 47) - 56*r*s + 44*r + 86*s**2 - 121*s + 31) + Pkdd2*k2*(24*C - 12)*(2*s**2 - 3*s + 1)))) + k1**2*s*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(7*bd2 - 14*gd2)*(s - 1)) - 14*fd*g2*k1**2*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(s - 1)**2) + 2*Dd*f*(f*(Pk2*k2**2*(32*C - 16)*(2*r - 1) + k1**2*(Pk2*(4*C*(124*s**2 - 171*s + 35) + 108*r*s - 115*r - 248*s**2 + 566*s - 82) + k2*(Pkd2*(C*(-344*s**2 + 462*s - 94) - 112*r*s + 76*r + 172*s**2 - 199*s + 15) + Pkdd2*k2*(24*C - 12)*(4*s**2 - 5*s + 1)))) - 14*g2*k1**2*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(4*s**2 - 5*s + 1)) + 14*b2*k1**2*(14*Pk2 + k2*(-9*Pkd2 + 2*Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(21*d**2*k1**2*k2**2) + D1**3*Pk3*ct**2*st**2*(-22*b1**2*k1**2*(D1*fd*(k1**2*(8*Pk2*(2*C*s**2 + K*(s - 1)**2 + 3*f*(12*s**2 + 7*s - 2) + 10*s**2 + 2*s - 1) + k2*(-Pkd2*(10*C*s**2 + 23*K*(s - 1)**2 + 15*f*(12*s**2 + 7*s - 2) + 32*s**2 + 46*s - 23) + Pkdd2*k2*(2*C*s**2 + 7*K*(s - 1)**2 + 3*f*(12*s**2 + 7*s - 2) + 4*s**2 + 14*s - 7))) + k2**2*(12*K*Pk2*r*(r - 4*s + 4) - 6*K*Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) - 6*K*Pkdd2*k2**2*(2*s - 1) - 12*Pk2*r*(r + 2) + 12*Pkd2*k2*r + f*(-Pk2*(2*r + 5) + 6*Pkd2*k2*r))) + Dd*f*(k1**2*(4*s - 1)*(8*Pk2*(2*C*s + K*(s - 1) + 6*f*(3*s + 1) + 10*s + 1) + k2*(-Pkd2*(10*C*s + 23*K*(s - 1) + 30*f*(3*s + 1) + 32*s + 23) + Pkdd2*k2*(2*C*s + 7*K*(s - 1) + 6*f*(3*s + 1) + 4*s + 7))) + 2*k2**2*(Pk2*(24*K*(r**2 - 4*r*s + 2*r + s - 1) + f*(7 - 14*r) - 24*r**2 - 12*r + 12) + 3*k2*(K*Pkdd2*k2*(1 - 4*s) + Pkd2*(K*(2*r*(8*s - 5) + 3) + f*(4*r - 2) + 4*r - 2))))) + 11*b1*k1**2*(D1*(f**2*(2*bd1*(24*Pk2*k1**2*s*(5 - 12*s) + 15*Pkd2*k1**2*k2*s*(12*s - 5) - 6*Pkd2*k2**3*(3*r - 2) + k2**2*(Pk2*(26*r - 19) + 3*Pkdd2*k1**2*s*(5 - 12*s))) + 3*fd*(k1**2*(Pk2*(90*r*(3*s - 2) + 2160*s**2 - 1743*s + 386) + 2*k2*(Pkd2*(-36*r*s + 24*r - 378*s**2 + 309*s - 67) + 6*Pkdd2*k2*(6*s**2 - 5*s + 1))) + 2*k2**2*(2*Pk2*(18*r**2 - 19*r - 10*s + 9) + Pkd2*k2*(3*r - 1)*(5*s - 2)))) + 2*f*(bd1*(6*K*Pkdd2*k2**4*s - 8*Pk2*k1**2*s*(C*(4*s - 2) + 2*K*(s - 1) + 20*s - 9) + Pkd2*k1**2*k2*s*(10*C*(2*s - 1) + 46*K*(s - 1) + 64*s - 9) - 6*Pkd2*k2**3*(K*(r*(8*s - 4) - s + 2) + r - 1) - k2**2*(12*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + Pkdd2*k1**2*s*(C*(4*s - 2) + 14*K*(s - 1) + 8*s + 3))) + 6*bd2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) + fd*(k1**2*(4*Pk2*(4*C*(20*s**2 - 24*s + 7) + 6*K*(6*s**2 - 7*s + 2) + 55*r*s - 26*r + 100*s**2 - 112*s + 22) + k2*(-Pkd2*(2*C*(46*s**2 - 57*s + 17) + 15*K*(6*s**2 - 7*s + 2) + 56*r*s - 27*r + 88*s**2 - 157*s + 34) + Pkdd2*k2*(C*(4*s**2 - 6*s + 2) + 3*K*(6*s**2 - 7*s + 2) - 4*s**2 - 15*s + 4))) + k2**2*(-2*Pk2*(4*C*(6*r**2 + r*(15 - 42*s) + 25*s - 11) - K*r*(3*s + 2) + 45*K*(1 - 2*s)**2 - 3*r**2 + 222*r*s - 98*r - 50*s + 22) + k2*(Pkd2*(C*(-80*r*(2*s - 1) + 54*s - 36) + 12*K*r*(s - 1) + 51*K*(1 - 2*s)**2 + 128*r*s - 75*r - 27*s + 21) - 3*Pkdd2*k2*(C*(4 - 14*s) + 2*K*(1 - 2*s)**2 + 7*s - 2)))) + 2*gd2*(8*Pk2*k1**2*s*(s - 1) - 23*Pkd2*k1**2*k2*s*(s - 1) + 6*Pkd2*k2**3*(r*(4*s - 2) - s + 2) - 6*Pkdd2*k2**4*s + k2**2*(12*Pk2*(r**2 - 4*r*s + r + 2*s - 2) + 7*Pkdd2*k1**2*s*(s - 1)))) + 4*fd*(3*b2*k2**3*s**2*(-Pkd2 + Pkdd2*k2) + g2*k1**2*(8*Pk2 + k2*(-23*Pkd2 + 7*Pkdd2*k2))*(s - 1)**2 - 6*g2*k2**2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + Pkdd2*k2**2*(2*s - 1)))) + 2*Dd*f*(6*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 3*f**2*k1**2*(2*Pk2*(r*(90*s - 68) + 720*s**2 - 521*s + 108) + k2*(Pkd2*(-48*r*s + 36*r - 504*s**2 + 370*s - 73) + 6*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 6*f**2*k2**2*(Pk2*(24*r**2 - 25*r - 10*s + 9) + Pkd2*k2*(2*r - 1)*(5*s - 2)) + f*k1**2*(4*Pk2*(4*C*(40*s**2 - 38*s + 7) + 6*K*(12*s**2 - 11*s + 2) + 110*r*s - 49*r + 200*s**2 - 187*s + 45) + k2*(-Pkd2*(2*C*(92*s**2 - 91*s + 17) + 15*K*(12*s**2 - 11*s + 2) + 112*r*s - 51*r + 176*s**2 - 230*s + 58) + Pkdd2*k2*(4*s - 1)*(2*C*(s - 1) + K*(9*s - 6) - 2*s - 4))) + f*k2**2*(-2*Pk2*(8*C*(6*r**2 + r*(11 - 42*s) + 25*s - 8) + K*(-2*r*(3*s + 8) + 360*s**2 - 291*s + 59) - 6*r**2 - 2*r*(73 - 222*s) - 124*s + 50) + k2*(Pkd2*(-4*C*(16*r*(5*s - 2) - 36*s + 15) + 3*K*(8*r*s - 12*r + 136*s**2 - 114*s + 25) + 256*r*s - 124*r - 96*s + 54) + 6*Pkdd2*k2*(4*s - 1)*(2*C - 2*K*s + K - 1))) + 2*g2*k1**2*(8*Pk2 + k2*(-23*Pkd2 + 7*Pkdd2*k2))*(4*s**2 - 5*s + 1) - 12*g2*k2**2*(-8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(-16*r*s + 10*r - 3) + Pkdd2*k2*(4*s - 1))))) + f*(11*D1*bd1*k1**2*(12*b2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + 3*f**2*(k1**2*(Pk2*(r*(90*s - 92) + 720*s**2 - 341*s + 46) + 2*k2*(Pkd2*(-12*r*(s - 1) - 126*s**2 + 61*s - 6) + 6*Pkdd2*k2*s*(2*s - 1))) + 2*k2**2*(r - 1)*(12*Pk2*r + Pkd2*k2*(5*s - 2))) + 2*f*(k1**2*(2*Pk2*(r*(55*s - 23) + s**2*(80*C + 36*K + 100) - s*(56*C + 24*K + 57) + 23) + k2*(Pkd2*(-4*r*(7*s - 3) - s**2*(46*C + 45*K + 44) + s*(34*C + 30*K + 14) - 12) + Pkdd2*k2*s*(2*C*(s - 1) + K*(9*s - 6) - 2*s + 5))) + k2**2*(Pk2*(K*(r*(3*s + 14) - 180*s**2 + 111*s - 14) + r**2*(3 - 24*C) + r*(8*C*(21*s - 5) - 222*s + 61) - 6*s*(8*C - 8) - 18) + k2*(Pkd2*(30*C*s + 3*K*(2*r*(s - 2) + 34*s**2 - 23*s + 4) + r*(-80*C*s + 24*C + 64*s - 25) - 27*s + 9) + 3*Pkdd2*k2*s*(-2*C + K*(2 - 4*s) + 1)))) + 4*g2*(8*Pk2*k1**2*s*(s - 1) - 23*Pkd2*k1**2*k2*s*(s - 1) + 12*Pkd2*k2**3*r*(2*s - 1) + k2**2*(12*Pk2*r*(r - 4*s + 2) + 7*Pkdd2*k1**2*s*(s - 1)))) + 2*D1*(f*(fd*(Pk2*k2**4*(1 - 3*r)**2*(8*C - 4) + k1**4*(4*Pk2*(8*C*(126*s**2 - 117*s + 25) + 561*r*s - 319*r + 2286*s**2 - 2052*s + 474) + k2*(-Pkd2*(20*C*(126*s**2 - 117*s + 25) + 594*r*s - 352*r + 2421*s**2 - 2252*s + 533) + Pkdd2*k2*(3*s - 1)*(4*C*(42*s - 25) + 15*s - 16))) - k1**2*k2**2*(Pk2*(2*C*(225*r*s - 570*r + 4356*s**2 - 2913*s + 652) - 1089*r**2 + 1737*r*s + 939*r - 4356*s**2 + 3249*s - 984) + k2*(Pkd2*(C*(72*r*s + 372*r - 5148*s**2 + 3474*s - 718) - 828*r*s + 144*r + 2574*s**2 - 1605*s + 293) + Pkdd2*k2*(132*C - 66)*(6*s**2 - 5*s + 1)))) + k1**2*(11*bd2 - 22*gd2)*(24*Pk2*k1**2*s*(3*s - 2) + 15*Pkd2*k1**2*k2*s*(2 - 3*s) + 3*Pkd2*k2**3*(2*r*(s - 2) + 34*s**2 - 23*s + 4) + 6*Pkdd2*k2**4*s*(1 - 2*s) + k2**2*(Pk2*(3*r*s + 14*r - 180*s**2 + 111*s - 14) + 3*Pkdd2*k1**2*s*(3*s - 2)))) - 22*fd*g2*k1**2*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2) + k2**2*(Pk2*r*(6*s + 4) - 90*Pk2*(1 - 2*s)**2 + 12*Pkd2*k2*r*(s - 1) + 51*Pkd2*k2*(1 - 2*s)**2 - 6*Pkdd2*k2**2*(1 - 2*s)**2))) + 2*Dd*f*(f*(Pk2*k2**4*(16*C - 8)*(6*r**2 - 5*r + 1) + k1**4*(4*Pk2*(8*C*(168*s**2 - 142*s + 25) + 748*r*s - 440*r + 3048*s**2 - 2636*s + 595) + k2*(-Pkd2*(20*C*(168*s**2 - 142*s + 25) + 792*r*s - 484*r + 3228*s**2 - 2895*s + 665) + Pkdd2*k2*(4*s - 1)*(4*C*(42*s - 25) + 15*s - 16))) - k1**2*k2**2*(4*C*Pk2*(2*r*(75*s - 257) + 2904*s**2 - 1993*s + 555) + 6*Pk2*(-242*r**2 + r*(386*s + 310) - 968*s**2 + 699*s - 257) + k2*(Pkd2*(2*C*(48*r*s + 382*r - 3432*s**2 + 2290*s - 555) - 1104*r*s + 14*r + 3432*s**2 - 2026*s + 423) + Pkdd2*k2*(132*C - 66)*(8*s**2 - 6*s + 1)))) - 22*g2*k1**2*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2) + k2**2*(2*Pk2*(2*r*(3*s + 8) - 360*s**2 + 291*s - 59) + 3*k2*(Pkd2*(8*r*s - 12*r + 136*s**2 - 114*s + 25) - 2*Pkdd2*k2*(8*s**2 - 6*s + 1))))) + 22*b2*k1**2*(D1*fd*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*s**2 - 7*s + 2) + k2**2*(Pk2*r*(6*s + 4) - 90*Pk2*(1 - 2*s)**2 + 12*Pkd2*k2*r*(s - 1) + 51*Pkd2*k2*(1 - 2*s)**2 - 6*Pkdd2*k2**2*(1 - 2*s)**2)) + Dd*f*(3*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(12*s**2 - 11*s + 2) + k2**2*(2*Pk2*(2*r*(3*s + 8) - 360*s**2 + 291*s - 59) + 3*k2*(Pkd2*(8*r*s - 12*r + 136*s**2 - 114*s + 25) - 2*Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(231*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*ct**2*st**2*(-3*D1*bd1*f*k1**2*(264*Pkd2*b2*k2**5*(r*(2*s - 1) + s*(2*s - 2)) + 22*b1*k1**4*s*(K - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + 22*b1*k1**2*k2**2*(Pk2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(104*r**2 + 54*r*s - 188*r - 224*s**2 + 189*s + 28) + 104*r**2 + 438*r*s - 296*r + 160*s**2 - 115*s + 32) + k2*(-Pkd2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(21*r*s - 6*r + 101*s**2 - 94*s + 13) + 150*r*s - 42*r + 16*s**2 + 23*s - 24) + Pkdd2*k2*s*(33*K - 20)*(2*s - 1))) + 132*b1*k2**4*(-2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s))) + f**2*(2*k1**4*(4*Pk2*(8*r*(51*s - 25) + 744*s**2 - 843*s + 100) + k2*(Pkd2*(-408*r*s + 200*r - 1248*s**2 + 1449*s - 100) + 2*Pkdd2*k2*s*(84*s - 101))) + 33*k1**2*k2**2*(-Pk2*(36*r**2 + 4*r*(143*s + 4) + 360*s**2 - 305*s - 52) + 2*k2*(Pkd2*(58*r*s + 20*r + 6*s**2 - 15*s - 20) + 2*Pkdd2*k2*s*(4*s - 1))) + 66*k2**4*(r - 1)*(2*Pk2*(9*r + 10*s - 7) + Pkd2*k2*(5*s - 2))) + 11*f*(2*k1**4*(8*Pk2*(r*(7*s - 3) + s**2*(4*C - 10*K + 13) + s*(-4*C + 7*K - 13) + 3) + k2*(Pkd2*(r*(6 - 14*s) + s**2*(-20*C + 23*K - 17) + s*(20*C - 17*K + 17) - 6) + Pkdd2*k2*s*(s - 1)*(4*C - K - 3))) - 2*k1**2*k2**2*(-2*Pk2*(-C*(36*r**2 + 29*r*s - 36*r + 24*s**2 - 16*s + 8) + 24*K*r**2 + 5*K*r*s + 8*K*r - 168*K*s**2 + 149*K*s - 32*K + 3*b1*(r*(48*s - 5) + 48*s**2 - 44*s + 5) - 68*r**2 - 299*r*s + 120*r - 140*s**2 + 144*s - 64) + k2*(Pkd2*(C*(46*r*s + 46*s**2 - 58*s - 8) - 137*K*r*s + 62*K*r - 279*K*s**2 + 252*K*s - 62*K + 3*b1*(48*r*s - 5*r + 30*s**2 - 35*s + 5) + 11*r*s - 24*r + 72*s**2 - 46*s + 12) + Pkdd2*k2*s*(-34*C*(s - 1) + 9*K*s - 6*K + 27*b1*(2*s - 1) + 16*s - 19))) + k2**4*(Pk2*b1*(-2*r*(45*s + 56) + 45*s + 68) + 2*Pk2*(K*(60*r**2 + r*(447*s - 134) + 180*s**2 - 201*s + 74) + r**2*(75 - 72*C) + r*(-8*C*(21*s - 8) + 48*s - 97) + 6*s*(8*C - 8) + 18) + 2*Pkd2*k2*(2*C*(40*r*s - 28*r + 27*s**2 - 51*s + 24) - 3*K*(30*r*s - 4*r - 2*s**2 - 9*s + 4) - 3*b1*(2*r*(s + 1) + s - 2) - 30*r*s + 21*r - 27*s**2 + 36*s - 15) + 6*Pkdd2*k2**2*s*(6*C*(s - 1) + K*(2 - 4*s) - 3*s + 3))) + 44*g2*(-k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + k1**2*k2**2*(Pk2*(52*r**2 + 27*r*(s - 4) - s*(112*s - 112)) + k2*(7*Pkd2*r*(3*s + 2) + 101*Pkd2*s*(s - 1) - 33*Pkdd2*k2*s*(s - 1))) - 6*k2**4*(-2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(4*s - 2) + 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))))) + 33*b1**2*k1**2*(D1*fd*(k1**4*s**2*(2 - 2*K)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 2*k1**2*k2**2*(-Pk2*(16*C*r*s + 16*C*s**2 - 16*C*s - K*(52*r**2 + 27*r*s + 84*r - 112*s**2 + 272*s - 136) + 6*f*(r*(48*s + 25) + 48*s**2 + 12*s - 25) + 52*r**2 + 219*r*s + 32*r + 80*s**2 + 184*s - 84) + k2*(Pkd2*(8*C*r*s + 8*C*s**2 - 8*C*s + K*(21*r*s - 80*r + 101*s**2 - 160*s + 80) + 3*f*(r*(48*s + 25) + 30*s**2 + 12*s - 25) + 75*r*s + 54*r + 8*s**2 + 116*s - 54) + Pkdd2*k2*s**2*(-33*K + 54*f + 20))) + k2**4*(-12*K*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) + f*(Pk2*r*(90*s + 64) - 5*Pk2*(9*s + 4) + 6*Pkd2*k2*s*(2*r + 1)) + 24*r*(Pk2*(r + 2) + Pkd2*k2*s))) + 2*Dd*f*(-k1**4*s*(K - 1)*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 104*K*r**2 - 54*K*r*s + 92*K*r + 224*K*s**2 - 269*K*s + 40*K + 12*f*(24*r*s + 5*r + 24*s**2 - 8*s - 5) + 104*r**2 + 438*r*s - 178*r + 160*s**2 + 17*s - 6) + k2*(Pkd2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 84*K*r*s - 118*K*r + 404*K*s**2 - 435*K*s + 132*K + 3*f*(96*r*s + 20*r + 60*s**2 - 23*s - 20) + 300*r*s + 32*r + 32*s**2 + 170*s - 98) + Pkdd2*k2*s*(4*s - 1)*(-33*K + 27*f + 20))) + k2**4*(Pk2*(24*K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + f*(2*r - 1)*(45*s + 44) + 48*r**2 + 24*r - 24) - 6*k2*(K*Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + K*Pkdd2*k2*s*(4*s - 1) - Pkd2*f*(2*r*s + r + s - 1) + Pkd2*(-8*r*s + r + 2*s))))) - 3*b1*k1**2*(D1*(f**2*fd*(2*k1**4*(12*Pk2*(r*(408*s - 202) + 744*s**2 - 419*s + 146) + k2*(-3*Pkd2*(408*r*s - 202*r + 1248*s**2 - 185*s + 96) + 2*Pkdd2*k2*(252*s**2 + 117*s - 25))) + 33*k1**2*k2**2*(-Pk2*(108*r**2 + 4*r*(429*s - 136) + 1080*s**2 - 1359*s + 320) + 2*k2*(Pkd2*(6*r*(29*s - 6) + 18*s**2 - 55*s + 15) + 6*Pkdd2*k2*(4*s**2 - 5*s + 1))) + 66*k2**4*(2*Pk2*(27*r**2 + 30*r*s - 27*r - 20*s + 8) + Pkd2*k2*(3*r - 1)*(5*s - 2))) - 22*f*(-12*Pkd2*bd2*k2**5*s*(2*r + 2*s - 1) + fd*k1**4*(8*Pk2*(-8*C*s**2 + K*(20*s**2 - 24*s + 7) + r*(8 - 14*s) - 26*s**2 + 41*s - 12) + k2*(Pkd2*(40*C*s**2 + K*(-46*s**2 + 57*s - 17) + 4*r*(7*s - 4) + 34*s**2 - 91*s + 27) + Pkdd2*k2*(K*(2*s**2 - 3*s + 1) + s**2*(6 - 8*C) + 3*s - 1))) + fd*k1**2*k2**2*(2*Pk2*(C*(72*r**2 + r*(58*s - 60) + 48*s**2 + 35*s - 12) + K*(-48*r**2 - 10*r*s + 8*r + 336*s**2 - 332*s + 82) + 136*r**2 + 598*r*s - 360*r + 280*s**2 - 369*s + 98) + k2*(Pkd2*(2*C*(r*(46*s - 44) + 46*s**2 - 93*s + 44) + K*(-274*r*s + 148*r - 558*s**2 + 557*s - 139) + 22*r*s + 95*r + 144*s**2 - 15*s - 43) + Pkdd2*k2*(3*K*(6*s**2 - 7*s + 2) + s**2*(32 - 68*C) + 21*s - 6))) - fd*k2**4*(-2*Pk2*(4*C*(18*r**2 + r*(42*s - 33) - 25*s + 14) - K*(60*r**2 + r*(447*s - 242) + 45*(1 - 2*s)**2) - 75*r**2 - 48*r*s + 38*r + 53*s - 25) + k2*(Pkd2*(4*C*(8*r*(5*s + 3) + 27*s**2 + 18*s - 24) - 12*K*r*(15*s - 7) + 3*K*(1 - 2*s)**2 - 12*r*(5*s + 6) - 54*s**2 - 27*s + 48) - 6*Pkdd2*k2*(K*(1 - 2*s)**2 + s**2*(3 - 6*C)))) + 2*gd2*(k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(-Pk2*(52*r**2 + r*(27*s - 80) - 112*s**2 + 77*s + 28) + k2*(Pkd2*(-21*r*s + 26*r - 101*s**2 + 87*s - 26) + 33*Pkdd2*k2*s**2)) + 6*k2**4*(-2*Pk2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + k2*(Pkd2*(4*r*s + 2*r + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2)))) - 44*fd*(-12*Pkd2*b2*k2**5*s*(r + s) + g2*(k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(-52*Pk2*r**2 - 3*Pk2*r*(9*s + 28) + 8*Pk2*(14*s**2 - 34*s + 17) + Pkd2*k2*(r*(80 - 21*s) - 101*s**2 + 160*s - 80) + 33*Pkdd2*k2**2*s**2) + 6*k2**4*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2)))) + 2*Dd*f*(132*Pkd2*b2*k2**5*(r*(8*s - 1) + 4*s*(2*s - 1)) + f**2*(2*k1**4*(4*Pk2*(r*(816*s - 403) + 1488*s**2 - 1050*s + 269) + k2*(Pkd2*(-816*r*s + 403*r - 2496*s**2 + 1002*s - 194) + Pkdd2*k2*(336*s**2 + 16*s - 25))) + 33*k1**2*k2**2*(-2*Pk2*(36*r**2 + 44*r*(13*s - 3) + 360*s**2 - 416*s + 67) + k2*(Pkd2*(8*r*(29*s - 2) + 24*s**2 - 70*s - 5) + 2*Pkdd2*k2*(16*s**2 - 16*s + 3))) + 66*k2**4*(Pk2*(36*r**2 + 40*r*s - 43*r - 30*s + 15) + Pkd2*k2*(2*r - 1)*(5*s - 2))) - 11*f*(k1**4*(8*Pk2*(-16*C*s**2 + 4*C*s + K*(40*s**2 - 38*s + 7) - 28*r*s + 14*r - 52*s**2 + 71*s - 18) + k2*(Pkd2*(80*C*s**2 - 20*C*s + K*(-92*s**2 + 91*s - 17) + 56*r*s - 28*r + 68*s**2 - 145*s + 39) + Pkdd2*k2*(4*s - 1)*(-4*C*s + K*(s - 1) + 3*s + 1))) + k1**2*k2**2*(4*Pk2*(C*(72*r**2 + r*(58*s - 74) + 48*s**2 + 11*s + 6) - K*(48*r**2 + 10*r*s + 4*r - 336*s**2 + 315*s - 73) + 136*r**2 + 598*r*s - 303*r + 280*s**2 - 339*s + 110) + k2*(Pkd2*(2*C*(r*(92*s - 54) + 92*s**2 - 161*s + 50) + K*(-548*r*s + 272*r - 1116*s**2 + 1061*s - 263) + 44*r*s + 89*r + 288*s**2 - 76*s - 49) + Pkdd2*k2*(4*s - 1)*(K*(9*s - 6) + s*(16 - 34*C) + 6))) - k2**4*(2*Pk2*(-8*C*(18*r**2 + r*(42*s - 29) - 25*s + 11) + K*(120*r**2 + 894*r*s - 376*r + 360*s**2 - 381*s + 119) + 150*r**2 + 96*r*s - 146*r - 130*s + 56) + k2*(C*Pkd2*(64*r*(5*s + 1) + 216*s**2 - 54*s - 72) - 3*Pkd2*(K*(12*r*(10*s - 3) - 8*s**2 - 14*s + 7) + r*(40*s + 23) + 36*s**2 - 7*s - 17) + 3*Pkdd2*k2*(4*s - 1)*(6*C*s - 4*K*s + 2*K - 3*s)))) + 22*g2*(-k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(104*r**2 + r*(54*s - 92) - 224*s**2 + 269*s - 40) + k2*(Pkd2*(84*r*s - 118*r + 404*s**2 - 435*s + 132) + 33*Pkdd2*k2*s*(1 - 4*s))) - 6*k2**4*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) + 2*f*(D1*(f**2*fd*k1**4*(k1**2*(Pk2*(10*r*(1323*s - 838) + 111456*s**2 - 79215*s + 15374) + 3*k2*(Pkd2*(-1180*r*s + 750*r - 12888*s**2 + 9340*s - 1757) + 150*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 54*k2**2*(Pk2*(528*r**2 + r*(60*s - 541) - 280*s**2 - 50*s + 161) + 3*Pkd2*k2*(22*r*(5*s - 2) + 60*s**2 - 90*s + 27))) + f*(fd*(Pk2*k2**6*(1 - 3*r)**2*(12 - 24*C) + 6*k1**6*(4*Pk2*(2*C*(285*s**2 - 278*s + 61) - 153*r*s + 73*r - 723*s**2 + 753*s - 178) + k2*(Pkd2*(C*(-669*s**2 + 688*s - 155) + 153*r*s - 73*r + 822*s**2 - 885*s + 211) + Pkdd2*k2*(11*C - 11)*(3*s**2 - 4*s + 1))) + k1**4*k2**2*(-2*Pk2*(8*C*(36*r**2 - 117*r*(5*s - 4) - 4185*s**2 + 3942*s - 944) - 2862*r**2 - 747*r*(26*s - 11) + 7344*s**2 - 3834*s + 199) + 3*k2*(-Pkd2*(2*C*(r*(2133*s - 1118) + 6372*s**2 - 6136*s + 1473) + 18*r*(8*s + 1) - 6687*s**2 + 5796*s - 1211) + Pkdd2*k2*(3*s - 1)*(4*C*(57*s - 41) - 213*s + 148))) + 3*k1**2*k2**4*(Pk2*(2*C*(4068*r**2 - 3*r*(4209*s + 458) - 4356*s**2 + 8367*s - 896) - 7533*r**2 + 11421*r*s + 3855*r + 4356*s**2 - 7503*s + 300) + k2*(Pkd2*(2*C*(18*r*(178*s - 63) + 594*s**2 - 1431*s + 433) - 3996*r*s + 1464*r - 594*s**2 + 1563*s - 499) + Pkdd2*k2*(132*C - 66)*(6*s**2 - 5*s + 1)))) - 66*k1**2*(6*bd2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + bd2*k2**4*(Pk2*(21*r**2 + r*(111*s - 43) + 90*s**2 - 78*s + 22) - 6*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)) + gd2*k1**4*s*(8*Pk2*(10*s - 7) + k2*(Pkd2*(17 - 23*s) + Pkdd2*k2*(s - 1))) + gd2*k1**2*k2**2*(-2*Pk2*(24*r**2 + r*(5*s + 8) - 168*s**2 + 149*s - 32) + k2*(Pkd2*(-137*r*s + 62*r - 279*s**2 + 252*s - 62) + 3*Pkdd2*k2*s*(3*s - 2))) + gd2*k2**4*(-Pk2*(60*r**2 + r*(447*s - 134) + 180*s**2 - 201*s + 74) + 3*k2*(Pkd2*(30*r*s - 4*r - 2*s**2 - 9*s + 4) + 2*Pkdd2*k2*s*(2*s - 1))))) - 66*fd*k1**2*(6*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + b2*k2**4*(Pk2*(42*r**2 + 2*r*(111*s - 61) + 45*(1 - 2*s)**2) - 12*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)) + g2*k1**4*(2*s - 1)*(8*Pk2*(10*s - 7) + k2*(Pkd2*(17 - 23*s) + Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(-4*Pk2*(24*r**2 + r*(5*s - 4) - 168*s**2 + 166*s - 41) + k2*(Pkd2*(-274*r*s + 148*r - 558*s**2 + 557*s - 139) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) + g2*k2**4*(-2*Pk2*(60*r**2 + r*(447*s - 242) + 45*(1 - 2*s)**2) + 3*k2*(4*Pkd2*r*(15*s - 7) - Pkd2*(1 - 2*s)**2 + 2*Pkdd2*k2*(1 - 2*s)**2)))) + Dd*f*(f**2*k1**4*(k1**2*(Pk2*(10*r*(1323*s - 838) + 111456*s**2 - 79215*s + 15374) + 3*k2*(Pkd2*(-1180*r*s + 750*r - 12888*s**2 + 9340*s - 1757) + 150*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 54*k2**2*(Pk2*(528*r**2 + r*(60*s - 541) - 280*s**2 - 50*s + 161) + 3*Pkd2*k2*(22*r*(5*s - 2) + 60*s**2 - 90*s + 27))) + f*(Pk2*k2**6*(24 - 48*C)*(6*r**2 - 5*r + 1) + 6*k1**6*(4*Pk2*(2*C*(380*s**2 - 339*s + 61) + r*(98 - 204*s) - 964*s**2 + 959*s - 203) + k2*(C*Pkd2*(-892*s**2 + 843*s - 155) + 2*Pkd2*(r*(102*s - 49) + 548*s**2 - 562*s + 118) + Pkdd2*k2*(11*C - 11)*(4*s**2 - 5*s + 1))) + k1**4*k2**2*(-4*Pk2*(2*C*(96*r**2 - 1560*r*s + 1453*r - 11160*s**2 + 10284*s - 2429) - 1908*r**2 - 12948*r*s + 4789*r + 4896*s**2 - 2004*s - 104) + 3*k2*(-Pkd2*(2*C*(4*r*(711*s - 382) + 8496*s**2 - 8022*s + 1883) + 192*r*s + 208*r - 8916*s**2 + 7321*s - 1401) + Pkdd2*k2*(4*s - 1)*(4*C*(57*s - 41) - 213*s + 148))) + 3*k1**2*k2**4*(2*Pk2*(2*C*(2712*r**2 - 2*r*(4209*s + 869) - 2904*s**2 + 5999*s - 75) - 5022*r**2 + 7614*r*s + 3738*r + 2904*s**2 - 5367*s - 405) + k2*(Pkd2*(2*C*(4272*r*s - 1202*r + 792*s**2 - 1934*s + 501) - 5328*r*s + 1598*r - 792*s**2 + 2198*s - 633) + Pkdd2*k2*(132*C - 66)*(8*s**2 - 6*s + 1)))) - 66*k1**2*(6*b2*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + b2*k2**4*(Pk2*(84*r**2 + 4*r*(111*s - 52) + 360*s**2 - 336*s + 89) - 12*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + g2*k1**4*(4*s - 1)*(8*Pk2*(10*s - 7) + k2*(Pkd2*(17 - 23*s) + Pkdd2*k2*(s - 1))) + g2*k1**2*k2**2*(-4*Pk2*(48*r**2 + 2*r*(5*s + 2) - 336*s**2 + 315*s - 73) + k2*(Pkd2*(-548*r*s + 272*r - 1116*s**2 + 1061*s - 263) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))) + g2*k2**4*(-2*Pk2*(120*r**2 + r*(894*s - 376) + 360*s**2 - 381*s + 119) + 3*k2*(Pkd2*(120*r*s - 36*r - 8*s**2 - 14*s + 7) + 2*Pkdd2*k2*(8*s**2 - 6*s + 1)))))))/(693*d**2*k1**2*k2**2*k3**4) - D1**3*Pk3*ct**2*(33*D1*bd1*f*(f**2*k1**4*(k1**2*(5*Pk2*r*(11*s - 8) + 8*Pk2*(-36*s**2 + 25*s + 5) + 2*Pkd2*k2*(5*r*(3*s + 2) + 122*s**2 - 94*s - 10) - 40*Pkdd2*k2**2*s*(s - 1)) - 3*k2**2*(Pk2*(60*r**2 - 36*r*(11*s + 2) - 280*s**2 + 233*s + 60) + 2*Pkd2*k2*(36*r - 44*s**2 + 65*s - 36))) + f*(Pk2*k2**6*r*(16 - 32*C) - 2*k1**6*(4*Pk2*(-16*C*s**2 + 16*C*s - 13*K*s**2 + 16*K*s + 2*b1*(s - 1)*(4*r + 4*s - 3) + r*(13*s - 15) + 42*s**2 - 61*s + 13) - k2*(Pkd2*(4*b1*(4*r*(s - 1) + 2*s**2 - 6*s + 3) + 8*r*(5*s - 4) - (s - 1)*(s*(32*C + 37*K - 109) + 28)) + 4*Pkdd2*b1*k2*s*(2*s - 1))) + k1**4*k2**2*(Pk2*b1*(888*r**2 + r*(446*s - 886) - 496*s**2 + 31*s + 146) - 2*Pk2*(256*C*r**2 + 22*C*r*(53*s - 20) - 8*C*(27*s**2 + 95*s - 36) + 2*K*(68*r**2 + 2*r*(92*s - 37) + 17*s**2 + s + 6) - 732*r**2 - 1499*r*s + 1086*r - 70*s**2 + 856*s - 526) + 2*Pkd2*k2*(-2*C*(146*r*s - 88*r + 69*s**2 - 125*s + 56) - 224*K*r*s + 152*K*r - 353*K*s**2 + 425*K*s - 152*K + 3*b1*(28*r*(4*s - 1) + 74*s**2 - 85*s + 20) + 364*r*s - 196*r + 290*s**2 - 370*s + 118) + 8*Pkdd2*k2**2*s*(9*b1*(2*s - 1) - (s - 1)*(14*C + 3*K - 10))) + k1**2*k2**4*(Pk2*(2*C*(-400*r**2 + r*(202*s + 200) - 68*s**2 + 212*s + 32) - 2*K*(184*r**2 + 549*r*s - 286*r + 324*s**2 - 315*s + 102) + 3*b1*(112*r**2 + 2*r*(53*s - 62) - 81*s + 48) + 724*r**2 + 108*r*s - 520*r + 68*s**2 - 356*s + 112) - 2*k2*(Pkd2*(2*C*(16*r*(6*s - 5) + 53*s**2 - 93*s + 40) + K*(42*r*s - 28*r + 78*s**2 - 81*s + 28) - 42*b1*r*s + 21*b1*s - 124*r*s + 92*r - 53*s**2 + 93*s - 40) + Pkdd2*k2*s*(24*C - 12)*(s - 1)))) - 2*k1**2*(b1**2*k2**3*(7*Pk2*k2*(3*r**2 + r*(3*s - 8) - 9*s + 5) + 2*Pkd2*k1**2*(r*(3*s - 4) + 3*s**2 - 10*s + 4)) + b1*(4*k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(K*(2 - 4*s) + 8*s - 5)) + k1**2*k2**2*(-Pk2*(16*C*(7*r**2 + r*(11*s - 15) + 4*s**2 - 18*s + 8) + K*(48*r**2 + 294*r*s - 88*r + 136*s**2 - 119*s + 8) - 56*r**2 - 638*r*s + 300*r - 472*s**2 + 591*s - 132) + k2*(Pkd2*(8*C*(19*r*(4*s - 1) - 8*s**2 - 34*s + 19) + K*(64*r*s + 12*r - 62*s**2 + 155*s - 56) - 548*r*s + 102*r - 122*s**2 + 221*s - 44) + Pkdd2*k2*s*(30*K - 14)*(2*s - 1))) + k2**4*(-Pk2*(32*C*(5*r**2 + r*(2 - 28*s) + 2*s**2 + 13*s - 7) + 7*K*(16*r**2 + 26*r*s - 36*r - 4*s**2 - 15*s + 16) - 50*r**2 + 422*r*s + 74*r - 32*s**2 - 132*s + 32) + k2*(14*K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(16*C*(3*r*(4*s - 1) - 2*s**2 - 5*s + 3) + 7*K*(20*r*s - 4*r + 14*s**2 - s - 4) - 152*r*s + 38*r + 16*s**2 + 54*s - 24)))) - 2*b2*k2**3*(-7*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k1**2*(r*(s + 3) + s*(s - 1)) - 14*Pkd2*k2**2*(r*(2*s - 1) + s*(2*s - 2))) - 2*g2*(-8*k1**4*s*(2*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(Pk2*(-24*r**2 - 7*r*(21*s - 8) - s*(68*s - 68)) + k2*(4*Pkd2*r*(8*s - 11) - 31*Pkd2*s*(s - 1) + 30*Pkdd2*k2*s*(s - 1))) + 7*k2**4*(Pk2*(-8*r**2 + r*(12 - 13*s) + s*(2*s - 2)) + k2*(2*Pkd2*r*(5*s - 4) + 7*Pkd2*s*(s - 1) + 2*Pkdd2*k2*s*(s - 1)))))) - 66*b1**3*k1**2*k2**3*(D1*fd*(7*Pk2*k2*(r - 1) + 2*Pkd2*k1**2*s)*(r + s - 1) + 2*Dd*f*(7*Pk2*k2*(2*r**2 + r*(2*s - 5) - 5*s + 3) + Pkd2*k1**2*(4*r*(s - 1) + 4*s**2 - 11*s + 4))) - 33*b1**2*k1**2*(-D1*fd*(-8*k1**4*s*(f*(Pk2*(8*r + 8*s - 6) - k2*(Pkd2*(4*r + 2*s - 3) + 2*Pkdd2*k2*s)) + (4*Pk2 - 2*Pkd2*k2)*(r - s*(K - 2))) + k1**2*k2**2*(Pk2*(16*C*(7*r**2 + r*(11*s - 14) + 4*s**2 - 11*s + 7) + 2*K*(24*r**2 + r*(147*s - 86) + 68*s**2 - 60*s + 30) + f*(888*r**2 + 2*r*(223*s - 541) - 496*s**2 - 357*s + 426) - 56*r**2 - 638*r*s + 436*r - 472*s**2 + 376*s - 212) + 2*k2*(Pkd2*(-304*C*r*s + 32*C*s**2 + 304*C*s + K*(-8*r*(4*s + 7) + 31*s**2 - 112*s + 56) + 6*f*(4*r*(14*s + 5) + 37*s**2 - 4*s - 20) + 274*r*s + 28*r + 61*s**2 - 88*s - 28) + Pkdd2*k2*s**2*(-30*K + 72*f + 14))) - k2**4*(Pk2*(-32*C*(5*r**2 - 2*r*(14*s + 5) + 2*s**2 + 28*s + 5) - 14*K*(8*r**2 + 13*r*s - 18*r - 2*s**2 - 4*s + 2) - 3*f*(112*r**2 + 2*r*(53*s - 48) - 81*s + 20) + 50*r**2 - 422*r*s - 352*r + 32*s**2 + 408*s + 120) + 2*k2*(7*K*(Pkd2*(10*r*s + 8*r + 7*s**2 + 16*s - 8) + 2*Pkdd2*k2*s**2) + Pkd2*s*(16*C*(6*r - s - 6) - 42*f*r + 21*f - 76*r + 8*s + 48)))) + 2*Dd*f*(f*(4*k1**4*(2*Pk2*(2*s - 1)*(4*r + 4*s - 3) + k2*(Pkd2*(-8*r*s + 4*r - 4*s**2 + 9*s - 3) + Pkdd2*k2*s*(1 - 4*s))) + k1**2*k2**2*(Pk2*(-888*r**2 + r*(984 - 446*s) + 496*s**2 + 163*s - 286) - 3*k2*(Pkd2*(4*r*(56*s + 3) + 148*s**2 - 93*s - 20) + 12*Pkdd2*k2*s*(4*s - 1))) - 3*k2**4*(Pk2*(112*r**2 + 2*r*(53*s - 55) - 81*s + 34) + 14*Pkd2*k2*s*(2*r - 1))) + 4*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 2*s*(-4*K*s + K + 8*s - 3)) + k1**2*k2**2*(-2*Pk2*(8*C*(14*r**2 + r*(22*s - 29) + 8*s**2 - 29*s + 15) + K*(48*r**2 + 294*r*s - 103*r + 136*s**2 - 115*s + 23) - 56*r**2 - 638*r*s + 303*r - 472*s**2 + 483*s - 149) + k2*(Pkd2*(8*C*(19*r*(8*s - 1) - 16*s**2 - 110*s + 19) + K*(4*r*(32*s + 31) - 124*s**2 + 391*s - 168) - 1096*r*s + 46*r - 244*s**2 + 469*s + 12) + Pkdd2*k2*s*(30*K - 14)*(4*s - 1))) + k2**4*(Pk2*(-32*C*(10*r**2 - 8*r*(7*s + 1) + 4*s**2 + 41*s - 2) - 14*K*(16*r**2 + 26*r*s - 39*r - 4*s**2 - 18*s + 17) + 100*r**2 - 844*r*s - 363*r + 64*s**2 + 568*s + 116) + k2*(14*K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(16*C*(3*r*(8*s - 1) - 4*s**2 - 17*s + 3) + 7*K*(40*r*s + 8*r + 28*s**2 + 21*s - 16) - 304*r*s + 38*r + 32*s**2 + 164*s - 24))))) + 33*b1*(D1*(f**2*fd*k1**4*(k1**2*(15*Pk2*r*(11*s + 24) - 2*Pk2*(432*s**2 + 35*s + 94) + 2*Pkd2*k2*(15*r*(3*s - 8) + 366*s**2 - 42*s + 61) - 20*Pkdd2*k2**2*(6*s**2 + 4*s - 1)) + 3*k2**2*(Pk2*(-180*r**2 + 36*r*(33*s - 4) + 840*s**2 - 1047*s + 208) - 6*Pkd2*k2*(36*r - 44*s**2 + 37*s - 23))) + 2*f*(fd*(Pk2*k2**6*(8 - 16*C)*(2*r - 1) + k1**6*(4*Pk2*(32*C*s**2 + K*(26*s**2 - 45*s + 16) - 26*r*s + 17*r - 84*s**2 + 76*s - 25) + Pkd2*k2*(-64*C*s**2 - 37*K*(2*s**2 - 3*s + 1) + 80*r*s - 48*r + 218*s**2 - 199*s + 61)) - k1**4*k2**2*(Pk2*(512*C*r**2 + 44*C*r*(53*s - 21) - 6*C*(72*s**2 + 285*s - 98) + 2*K*(136*r**2 + 2*r*(184*s - 93) + 34*s**2 + 5*s - 11) - 1464*r**2 - 2998*r*s + 1897*r - 140*s**2 + 1828*s - 596) + k2*(Pkd2*(4*C*(2*r*(73*s + 24) + 69*s**2 + 11*s - 48) + K*(448*r*s - 352*r + 706*s**2 - 851*s + 249) - 728*r*s - 52*r - 580*s**2 + 290*s + 68) + 4*Pkdd2*k2*(K*(6*s**2 - 9*s + 3) + s**2*(28*C - 20)))) - k1**2*k2**4*(Pk2*(2*C*(400*r**2 - 2*r*(101*s + 251) + 68*s**2 + 101*s + 174) + 2*K*(184*r**2 + r*(549*s - 300) + 81*(1 - 2*s)**2) - 724*r**2 - 108*r*s + 767*r - 68*s**2 + 67*s - 218) + k2*(Pkd2*(4*C*(12*r*(8*s + 3) + 53*s**2 + 24*s - 36) + 28*K*r*(3*s - 2) + 39*K*(1 - 2*s)**2 - 8*r*(31*s + 9) - 106*s**2 - 32*s + 72) + Pkdd2*k2*s**2*(48*C - 24)))) + 2*k1**2*(bd2*k2**3*(-7*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k1**2*s*(r + s - 4) - 14*Pkd2*k2**2*s*(2*r + 2*s - 1)) + gd2*(8*k1**4*s**2*(-2*Pk2 + Pkd2*k2) + k1**2*k2**2*(-Pk2*(24*r**2 + r*(147*s - 32) + 68*s**2 - 51*s + 8) + k2*(Pkd2*(8*r*(4*s + 7) - 31*s**2 + 124*s - 56) + 30*Pkdd2*k2*s**2)) + 7*k2**4*(Pk2*(-8*r**2 + r*(24 - 13*s) + 2*s**2 + 17*s - 16) + k2*(Pkd2*(10*r*s + 4*r + 7*s**2 + 6*s - 4) + 2*Pkdd2*k2*s**2))))) + 4*fd*k1**2*(-b2*k2**3*(r + s)*(7*Pk2*k2*(r + s) - 2*Pkd2*k1**2*s + 28*Pkd2*k2**2*s) + g2*(8*k1**4*s**2*(-2*Pk2 + Pkd2*k2) + k1**2*k2**2*(-Pk2*(24*r**2 + r*(147*s - 86) + 68*s**2 - 60*s + 30) + k2*(Pkd2*(8*r*(4*s + 7) - 31*s**2 + 112*s - 56) + 30*Pkdd2*k2*s**2)) + 7*k2**4*(Pk2*(-8*r**2 - 13*r*s + 18*r + 2*s**2 + 4*s - 2) + k2*(Pkd2*(10*r*s + 8*r + 7*s**2 + 16*s - 8) + 2*Pkdd2*k2*s**2))))) + 2*Dd*f*(f**2*k1**4*(k1**2*(Pk2*(10*r*(11*s + 16) - 576*s**2 + 65*s - 74) + k2*(Pkd2*(60*r*s - 110*r + 488*s**2 - 136*s + 51) - 10*Pkdd2*k2*(8*s**2 + 2*s - 1))) - 3*k2**2*(2*Pk2*(60*r**2 - 396*r*s + 18*r - 280*s**2 + 320*s - 37) + Pkd2*k2*(144*r - 176*s**2 + 176*s - 105))) + f*(Pk2*k2**6*(16 - 32*C)*(2*r - 1) + k1**6*(4*Pk2*(64*C*s**2 - 16*C*s + K*(52*s**2 - 77*s + 16) + r*(43 - 52*s) - 168*s**2 + 178*s - 49) + Pkd2*k2*(-128*C*s**2 + 32*C*s - 37*K*(4*s**2 - 5*s + 1) + 8*r*(20*s - 13) + 436*s**2 - 433*s + 113)) - k1**4*k2**2*(Pk2*(4*C*(256*r**2 + r*(1166*s - 445) - 216*s**2 - 931*s + 259) + 2*K*(272*r**2 + 736*r*s - 334*r + 68*s**2 + 7*s + 1) - 2928*r**2 - 5996*r*s + 4105*r - 280*s**2 + 3834*s - 1512) + k2*(Pkd2*(2*C*(8*r*(73*s + 7) + 276*s**2 - 121*s - 88) + K*(896*r*s - 656*r + 1412*s**2 - 1701*s + 553) - 1456*r*s + 112*r - 1160*s**2 + 866*s - 18) + 4*Pkdd2*k2*(4*s - 1)*(3*K*(s - 1) + s*(14*C - 10)))) - k1**2*k2**4*(Pk2*(4*C*(400*r**2 - r*(202*s + 461) + 68*s**2 + 50*s + 139) + 2*K*(368*r**2 + 1098*r*s - 586*r + 648*s**2 - 639*s + 183) - 1448*r**2 - 216*r*s + 1553*r - 136*s**2 + 236*s - 438) + k2*(Pkd2*(2*C*(16*r*(24*s + 1) + 212*s**2 - 53*s - 56) + K*(56*r*(3*s - 2) + 312*s**2 - 318*s + 95) - 496*r*s - 4*r - 212*s**2 + 85*s + 56) + Pkdd2*k2*s*(24*C - 12)*(4*s - 1)))) + 2*k1**2*(b2*k2**3*(-7*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*Pkd2*k1**2*(r*(4*s + 3) + s*(4*s - 9)) - 14*Pkd2*k2**2*(r*(8*s - 1) + 4*s*(2*s - 1))) + g2*(-8*k1**4*s*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(48*r**2 + r*(294*s - 103) + 136*s**2 - 115*s + 23) + k2*(Pkd2*(4*r*(32*s + 31) - 124*s**2 + 391*s - 168) + 30*Pkdd2*k2*s*(4*s - 1))) + 7*k2**4*(Pk2*(-32*r**2 + r*(78 - 52*s) + 8*s**2 + 36*s - 34) + k2*(Pkd2*(40*r*s + 8*r + 28*s**2 + 21*s - 16) + 2*Pkdd2*k2*s*(4*s - 1))))))) - 2*f*k1**2*(D1*(5*f**2*fd*k1**4*(Pk2*(50*r*(3*s + 31) - 8064*s**2 + 5577*s - 1684) + 3*Pkd2*k2*(220*r*(3*s - 2) + 1464*s**2 - 1428*s + 403)) - f*(-66*bd2*k2**2*(13*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(Pk2*(30*r**2 + 17*r*(s - 2) - 13*s**2 + 21*s + 4) + 12*Pkd2*k2*(5*s - 3)*(r + s - 1))) + fd*(2*k1**4*(4*C*Pk2*(765*s**2 - 1566*s + 437) - 30*Pk2*(3*r*(s - 15) + 105*s**2 - 258*s + 89) - 33*Pkd2*k2*(s - 1)*(31*C*(3*s - 1) - 30*r - 123*s + 51)) + k1**2*k2**2*(Pk2*(-12*C*(2502*r**2 + 12*r*(659*s - 344) + 1683*s**2 - 3692*s + 1263) + 36396*r**2 + 9*r*(12145*s - 6319) + 33264*s**2 - 52638*s + 16618) - 33*k2*(Pkd2*(2*C*(588*r*s - 448*r + 903*s**2 - 1084*s + 345) - 732*r*s + 572*r - 1191*s**2 + 1410*s - 447) + Pkdd2*k2*(20*C - 10)*(3*s**2 - 4*s + 1))) + k2**4*(Pk2*(-2*C*(21420*r**2 + r*(56133*s - 33882) + 27324*s**2 - 39501*s + 12808) + 25281*r**2 + 633*r*(99*s - 59) + 27324*s**2 - 39501*s + 12808) + Pkd2*k2*(33 - 66*C)*(48*r*(3*s - 2) + 198*s**2 - 213*s + 65))) + 66*gd2*(k1**4*s*(Pk2*(64 - 52*s) + 37*Pkd2*k2*(s - 1)) + k1**2*k2**2*(2*Pk2*(68*r**2 + 2*r*(92*s - 37) + 17*s**2 + s + 6) + k2*(Pkd2*(8*r*(28*s - 19) + 353*s**2 - 425*s + 152) + 12*Pkdd2*k2*s*(s - 1))) + k2**4*(Pk2*(184*r**2 + 549*r*s - 286*r + 324*s**2 - 315*s + 102) + Pkd2*k2*(42*r*s - 28*r + 78*s**2 - 81*s + 28)))) + 66*fd*(13*Pk2*b2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + b2*k1**2*k2**2*(Pk2*(60*r**2 + r*(34*s - 19) - 26*s**2 + 67*s - 27) + 12*Pkd2*k2*(r*(10*s - 7) + 10*s**2 - 13*s + 4)) + g2*k1**4*(2*s - 1)*(Pk2*(52*s - 64) - 37*Pkd2*k2*(s - 1)) - g2*k1**2*k2**2*(2*Pk2*(136*r**2 + 2*r*(184*s - 93) + 34*s**2 + 5*s - 11) + k2*(Pkd2*(448*r*s - 352*r + 706*s**2 - 851*s + 249) + 12*Pkdd2*k2*(2*s**2 - 3*s + 1))) - g2*k2**4*(2*Pk2*(184*r**2 + r*(549*s - 300) + 81*(1 - 2*s)**2) + Pkd2*k2*(28*r*(3*s - 2) + 39*(1 - 2*s)**2)))) + Dd*f*(858*Pk2*b2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 66*b2*k1**2*k2**2*(Pk2*(120*r**2 + r*(68*s - 87) - 52*s**2 + 109*s - 19) + 12*Pkd2*k2*(r*(20*s - 13) + 20*s**2 - 29*s + 10)) + 5*f**2*k1**4*(Pk2*(50*r*(3*s + 31) - 8064*s**2 + 5577*s - 1684) + 3*Pkd2*k2*(220*r*(3*s - 2) + 1464*s**2 - 1428*s + 403)) + f*(-2*k1**4*(2*Pk2*(C*(2040*s**2 - 4006*s + 874) - 20*r*(3*s - 49) - 2100*s**2 + 5155*s - 1640) - 33*Pkd2*k2*(s - 1)*(31*C*(4*s - 1) - 40*r - 164*s + 61)) + k1**2*k2**2*(Pk2*(4*C*(10008*r**2 + 4*r*(7908*s - 3935) + 6732*s**2 - 14599*s + 4643) - 48528*r**2 - 145740*r*s + 72987*r - 44352*s**2 + 68920*s - 20602) + 33*k2*(Pkd2*(2*C*(8*r*(98*s - 73) + 1204*s**2 - 1449*s + 481) - 976*r*s + 746*r - 1588*s**2 + 1877*s - 621) + Pkdd2*k2*(20*C - 10)*(4*s**2 - 5*s + 1))) + k2**4*(2*Pk2*(2*C*(14280*r**2 + 37422*r*s - 22658*r + 18216*s**2 - 26433*s + 8551) - 16854*r**2 - 41778*r*s + 25034*r - 18216*s**2 + 26433*s - 8551) + Pkd2*k2*(66*C - 33)*(64*r*(3*s - 2) + 264*s**2 - 294*s + 97))) + 66*g2*k1**4*(4*s - 1)*(Pk2*(52*s - 64) - 37*Pkd2*k2*(s - 1)) - 66*g2*k1**2*k2**2*(2*Pk2*(272*r**2 + r*(736*s - 334) + 68*s**2 + 7*s + 1) + k2*(Pkd2*(896*r*s - 656*r + 1412*s**2 - 1701*s + 553) + 12*Pkdd2*k2*(4*s**2 - 5*s + 1))) - 66*g2*k2**4*(2*Pk2*(368*r**2 + 2*r*(549*s - 293) + 648*s**2 - 639*s + 183) + Pkd2*k2*(56*r*(3*s - 2) + 312*s**2 - 318*s + 95)))))/(693*d**2*k1**2*k2**2*k3**4) + 20*D1**3*Pk3*ct*f*k1*k2*st**6*(D1*(f**2*(26*bd1*k2**2*(Pk2*(9*r**2 + 10*r - 9*s**2 + 14*s - 19) + Pkd2*k2*(r*(9*s - 7) + 9*s**2 - 9*s + 7)) + fd*(52*Pk2*k2**2*(56*r**2 + r*(56*s - 99) - 42*s + 39) - k1**2*(4*Pk2 - Pkd2*k2)*(r*(7456*s - 1721) + 7456*s**2 - 7482*s + 1333))) - 13*f*k2**2*(16*C*fd*(Pk2*(3*r - 6*s + 1) + Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) - b1*fd*(6*Pk2*(9*r**2 + 16*r - 9*s**2 + 17*s - 11) + Pkd2*k2*(r*(54*s - 51) + 54*s**2 - 54*s + 23)) + 66*bd1*(2*Pk2*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 12*fd*(5*Pk2*(r - s) + Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) - 264*gd2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) - 1716*fd*k2**2*(2*r + 2*s - 1)*(Pk2*b1*(4*K*(r - 2*s + 1) - 6*r + 2*s - 1) - 8*Pk2*g2*(r - 2*s + 1) + Pkd2*b1*k2*(2*K - 1)*(2*s - 1) + 4*Pkd2*g2*k2*(1 - 2*s))) + Dd*f*(f**2*(52*Pk2*k2**2*(56*r**2 + r*(56*s - 99) - 42*s + 39) - k1**2*(4*Pk2 - Pkd2*k2)*(r*(7456*s - 1721) + 7456*s**2 - 7482*s + 1333)) + 13*f*k2**2*(2*Pk2*b1*(36*r**2 + 58*r - 36*s**2 + 65*s - 52) - 4*Pk2*(C*(48*r**2 - 2*r*(24*s + 13) - 96*s**2 + 76*s - 6) - 60*r**2 + 50*r + 60*s**2 - 35*s - 5) + Pkd2*b1*k2*(r*(72*s - 65) + 72*s**2 - 72*s + 37) - Pkd2*k2*(8*C - 6)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 1716*k2**2*(b1*(Pk2*(2*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 24*r**2 - 16*r*s + 18*r + 8*s**2 - 2*s - 1) + Pkd2*k2*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 4*g2*(Pk2*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(9009*d**2*k3**6) + 5*D1**3*Pk3*ct*f*k1*st**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(b1*(D1*fd*(f*(27*s**2 - 51*s + 14) + 66*(1 - 2*s)**2) + Dd*f*(4*s - 1)*(9*f*s - 14*f + 132*s - 66)) + f*(D1*bd1*s*(9*f*s - 14*f + 132*s - 66) + 2*D1*fd*(1 - 3*s)**2 + 2*Dd*f*(12*s**2 - 7*s + 1)))/(693*d**2*k2*k3**2) - 5*D1**3*Pk3*ct*f*k1*st**6*(D1*(f**2*(13*bd1*k2**2*(-8*Pk2*(2*r*(9*s - 7) + 9*s**2 - 4*s + 14) + k2*(Pkd2*(4*r*(9*s - 7) - 9*s**2 + 34*s + 28) + Pkdd2*k2*s*(9*s - 14))) + fd*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 125*s + 14) - 52*k2**2*(2*Pk2*(r*(22*s + 32) - 39*s - 9) + Pkd2*k2*(r*(4*s - 21) + 12*s + 7)))) - 13*f*k2**2*(-66*bd1*(8*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) - k2*(Pkd2*(K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) - 16*r*s + 4*r + 2*s**2 + 7*s - 4) + Pkdd2*k2*s*(2*K - 1)*(2*s - 1))) + fd*(8*Pk2*(3*b1*(r*(18*s - 17) + 9*s**2 - s + 3) + (2 - 6*s)*(-12*C*s + r*(12*C - 18) + 3*s + 5)) - k2*(Pkd2*(3*b1*(r*(36*s - 34) - 9*s**2 + 49*s - 8) + (3*s - 1)*(-24*C*(2*r - 5*s + 1) + 72*r - 66*s - 2)) + Pkdd2*k2*(3*s - 1)*(b1*(9*s - 14) + (6 - 8*C)*(3*s - 1)))) + 264*gd2*(-4*Pk2*(-4*r*s + r + 4*s**2 - 1) + k2*(Pkd2*(-4*r*s + r + 10*s**2 - 3*s - 1) + Pkdd2*k2*s*(1 - 2*s)))) - 858*fd*k2**2*(2*s - 1)*(-8*Pk2*b1*(K*(4*r - 4*s + 2) - 8*r - 2*s + 1) + 32*Pk2*g2*(2*r - 2*s + 1) + b1*k2*(Pkd2*(2*K*(4*r - 10*s + 5) - 16*r + 2*s - 1) + Pkdd2*k2*(2*K - 1)*(2*s - 1)) + 4*g2*k2*(Pkd2*(-4*r + 10*s - 5) + Pkdd2*k2*(1 - 2*s)))) + Dd*f*(f**2*(9*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(276*s**2 - 125*s + 14) - 52*k2**2*(2*Pk2*(r*(22*s + 32) - 39*s - 9) + Pkd2*k2*(r*(4*s - 21) + 12*s + 7))) + 13*f*k2**2*(-8*Pk2*b1*(r*(72*s - 65) + 36*s**2 - 7*s + 23) + 16*Pk2*(2*C*(r*(24*s - 7) - 24*s**2 + 4*s + 1) + r*(21 - 72*s) + 12*s**2 + 23*s - 8) + Pkd2*k2*(8*C*(r*(7 - 24*s) + 60*s**2 - 25*s + 2) + b1*(2*r*(72*s - 65) - 36*s**2 + 181*s + 4) + 288*r*s - 84*r - 264*s**2 + 34*s + 14) + Pkdd2*k2**2*(4*s - 1)*(b1*(9*s - 14) + (6 - 8*C)*(3*s - 1))) - 858*k2**2*(b1*(8*Pk2*(r*(4 - 2*K)*(8*s - 3) + (2*s - 1)*(8*K*s + 4*s - 5)) + k2*(Pkd2*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7) + Pkdd2*k2*(2*K - 1)*(8*s**2 - 6*s + 1))) - 4*g2*(8*Pk2*(r*(3 - 8*s) + 4*s*(2*s - 1)) + Pkd2*k2*(2*r*(8*s - 3) - 40*s**2 + 26*s - 3) + Pkdd2*k2**2*(8*s**2 - 6*s + 1)))))/(9009*d**2*k2*k3**4) - 8*D1**3*Pk3*ct*st**4*(D1*(5148*b1*fd*k1**2*k2**4*(-Pk2*b1*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) + Pkd2*b1*k2*s*(2*K - 1)*(r + s) + 4*g2*(Pk2*(r*(s - 2) + (s - 1)**2) - Pkd2*k2*s*(r + s))) + f**3*k1**2*(39*bd1*k2**2*(33*Pk2*k2**2*(9*r**2 + 2*r*(7*s - 8) + 5*s**2 - 16*s + 7) + 20*k1**2*(Pk2*(27*r**2 + 42*r*s - 45*r + 15*s**2 - 35*s + 14) + Pkd2*k2*(6*r*s + 3*r + 6*s**2 - 2*s - 1))) + fd*(1300*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(7912*s - 2199) + 7912*s**2 - 8380*s + 1711) + 39*k1**2*k2**2*(-Pk2*(1524*r**2 + r*(5784*s - 2867) + 4260*s**2 - 4959*s + 1303) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35)))) + 39*f**2*k2**2*(fd*(Pk2*k2**4*(4*C - 2)*(3*r - 1)*(27*r + 60*s - 7) + 12*k1**4*(Pk2*(5*b1*(27*r**2 + 6*r*(7*s - 5) + 15*s**2 - 22*s + 9) + (-18*r - 18*s + 12)*(-2*C*s + r*(2*C - 3) + 1)) + Pkd2*k2*(10*b1*(s - 1) - (4*C - 3)*(3*s - 1))*(3*r + 3*s - 2)) + k1**2*k2**2*(33*Pk2*b1*(27*r**2 + 3*r*(14*s - 9) + 15*s**2 - 27*s + 8) + 2*Pk2*(-2*C*(882*r**2 + 3*r*(375*s - 376) + 540*s**2 - 735*s + 338) + 1143*r**2 + 12*r*(123*s - 121) + 630*s**2 - 912*s + 427) + Pkd2*k2*(60 - 120*C)*(3*s - 1)*(3*r + 3*s - 2))) + 33*k1**2*(-4*Pk2*bd2*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(4*Pk2*k1**2*(-r**2*(K - 2) + r*(K + 3*s - 2) + s*(K*(s + 2) + s - 3)) - 2*Pk2*k2**2*(2*K*(13*r**2 + 14*r*s - 17*r + s**2 - 10*s + 4) + b1*(r + s - 1) - 18*r**2 - 20*r*s + 24*r - 2*s**2 + 14*s - 6) + Pkd2*k1**2*k2*s*(2 - 4*K)*(r + s) + Pkd2*k2**3*(-4*K*(6*r*s - r + 6*s**2 - 5*s + 1) + b1*(4*s - 1)*(r + s - 1) + 8*r*s - 2*r + 8*s**2 - 8*s + 2)) + 8*gd2*(Pk2*k1**2*(r**2 - r - s*(s + 2)) + Pk2*k2**2*(13*r**2 + r*(14*s - 17) + s**2 - 10*s + 4) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(6*s - 1) + 6*s**2 - 5*s + 1)))) + 1287*f*k1**2*k2**2*(-4*Pk2*b2*fd*k2**2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1) + b1**2*fd*k2**2*(2*Pk2*(r + s - 1) + Pkd2*k2*s*(4*r + 4*s - 3)) + 2*b1*(bd1*k2**2*(-2*Pk2*(K*(4*r*s - 3*r + 4*s**2 - 5*s + 2) + 4*r**2 + 4*r*s - 2*r - 1) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + fd*(-2*Pk2*k1**2*(K*(2*r**2 + 2*r - 2*s**2 + s) - 4*r**2 - 6*r*s - 2*s**2 + s) + Pk2*k2**2*(r**2*(36 - 52*K) + r*(-8*K*(7*s - 3) + 40*s - 19) - (2*s - 1)*(s*(2*K - 2) + 1)) - Pkd2*k1**2*k2*(2*K - 1)*(r + s)*(2*s - 1) + Pkd2*k2**3*(K*(-24*r*s + 11*r - 24*s**2 + 22*s - 5) + (4*s - 2)*(2*r + 2*s - 1))) + 4*gd2*k2**2*(Pk2*(2*r*(s - 1) + 2*s**2 - 3*s + 2) + Pkd2*k2*s*(-2*r - 2*s + 1))) + 4*g2*(2*bd1*k2**2*(Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + fd*(2*Pk2*k1**2*(2*r**2 + 2*r - 2*s**2 + s) + 2*Pk2*k2**2*(26*r**2 + 4*r*(7*s - 3) + s*(2*s - 1)) + 2*Pkd2*k1**2*k2*(r + s)*(2*s - 1) + Pkd2*k2**3*(r*(24*s - 11) + 24*s**2 - 22*s + 5))))) + Dd*f*(2574*b1*k1**2*k2**4*(-2*Pk2*b1*(K*(r*(8*s - 9) + 8*s**2 - 12*s + 6) + 8*r**2 + r*(8*s - 1) + 2*s - 3) + 4*Pk2*g2*(r*(8*s - 9) + 8*s**2 - 12*s + 6) + Pkd2*b1*k2*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 4*Pkd2*g2*k2*(-8*r*s + r + s*(4 - 8*s))) + f**3*k1**2*(1300*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(7912*s - 2199) + 7912*s**2 - 8380*s + 1711) + 39*k1**2*k2**2*(-Pk2*(1524*r**2 + r*(5784*s - 2867) + 4260*s**2 - 4959*s + 1303) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 39*f**2*k2**2*(Pk2*k2**4*(16*C - 8)*(27*r**2 + 6*r*(10*s - 3) - 25*s + 1) + 2*k1**4*(10*Pk2*b1*(108*r**2 + 3*r*(56*s - 45) + 60*s**2 - 101*s + 41) - 6*Pk2*(4*C*(12*r**2 - 10*r - 12*s**2 + 7*s + 1) - 72*r**2 - 9*r*(8*s - 9) + 30*s - 21) + 10*Pkd2*b1*k2*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) - Pkd2*k2*(12*C - 9)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + k1**2*k2**2*(Pk2*(-8*C*(588*r**2 + 750*r*s - 816*r + 360*s**2 - 517*s + 274) + 33*b1*(36*r**2 + r*(56*s - 43) + 20*s**2 - 43*s + 15) + 3048*r**2 + 3936*r*s - 4216*r + 1680*s**2 - 2620*s + 1404) + Pkd2*k2*(30 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 1287*f*k1**2*k2**2*(-4*Pk2*b2*k2**2*(12*r**2 + r*(24*s - 13) + 12*s**2 - 13*s + 3) + Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 2*b1*(2*Pk2*k1**2*(r**2*(4*K - 8) + r*(4 - 12*s) - s*(4*K*s + 3*K + 4*s - 7)) + Pk2*k2**2*(2*K*(52*r**2 + 56*r*s - 46*r + 4*s**2 - 21*s + 8) - 72*r**2 - 80*r*s + 67*r - 8*s**2 + 32*s - 13) + Pkd2*k1**2*k2*(2*K - 1)*(r + s)*(4*s - 1) + Pkd2*k2**3*(3*K*(16*r*s - 5*r + 16*s**2 - 14*s + 3) - 16*r*s + 6*r - 16*s**2 + 16*s - 4)) + 4*g2*(2*Pk2*k1**2*(4*r**2 - s*(4*s + 3)) + 2*Pk2*k2**2*(52*r**2 + r*(56*s - 46) + 4*s**2 - 21*s + 8) + 2*Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 3*Pkd2*k2**3*(r*(16*s - 5) + 16*s**2 - 14*s + 3)))))/(9009*d**2*k1*k2*k3**6) - 4*D1**3*Pk3*ct*st**2*(3*D1*bd1*f*(f**2*k1**2*(-132*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + k1**4*(Pk2*(72*r**2 + 932*r*s - 206*r + 860*s**2 - 914*s + 86) + Pkd2*k2*(-394*r*s + 33*r - 394*s**2 + 387*s - 9)) - 11*k1**2*k2**2*(4*Pk2*(35*r**2 + 50*r*s - 45*r + 15*s**2 - 36*s + 10) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) - 11*f*(-4*Pk2*k1**6*(r + s - 1)*(-2*K*s + K + r + 3*s - 2) + Pk2*k2**6*r*(4 - 8*C)*(3*r + 3*s - 2) - k1**4*k2**2*(2*Pk2*(-4*C*(7*r**2 - 13*r + 5*s**2 - 4*s + 5) - 46*K*r**2 - 172*K*r*s + 82*K*r - 126*K*s**2 + 116*K*s - 36*K + b1*(92*r**2 + r*(184*s - 137) + 92*s**2 - 137*s + 45) + 43*r**2 + 96*r*s - 75*r + 77*s**2 - 71*s + 28) + Pkd2*k2*(-4*C*(r*(22*s - 9) + 18*s**2 - 23*s + 5) + 6*K*(s - 1)*(r + s - 1) + b1*(3*r*(64*s - 13) + 192*s**2 - 187*s + 17) + 52*r*s - 18*r + 44*s**2 - 50*s + 6)) + k1**2*k2**4*(-2*Pk2*(-4*C*(28*r**2 + 85*r*s - 66*r + 43*s**2 - 71*s + 32) + 40*K*r**2 - 2*K*r*s - 60*K*r - 42*K*s**2 - 26*K*s + 20*K + b1*(72*r**2 + r*(96*s - 67) + 24*s**2 - 67*s + 19) + 50*r**2 + 171*r*s - 126*r + 93*s**2 - 147*s + 64) + Pkd2*k2*(4*C*(25*r*s - 12*r + 21*s**2 - 28*s + 7) - 6*K*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + b1*(9*r*(4*s - 1) + 36*s**2 - 33*s + 3) - 46*r*s + 22*r - 38*s**2 + 52*s - 14))) - 22*k1**2*k2**2*(13*Pk2*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 52*Pk2*b2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(2*k1**2*(Pk2*(K*(22*r**2 + 44*r*s - 13*r + 22*s**2 - 27*s - 2) - 50*r**2 - 100*r*s + 42*r - 50*s**2 + 56*s + 1) + Pkd2*k2*(2*K - 1)*(r*(13*s - 5) + s*(13*s - 8))) + k2**2*(-2*Pk2*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-132*r**2 - 262*r*s + 101*r - 130*s**2 + 107*s + 27) + 75*r**2 + 96*r*s - 48*r + 21*s**2 - 28*s - 10) + Pkd2*k2*(r*(K*(134*s - 37) - 28*s + 7) + s*(K*(134*s - 97) - 28*s + 21)))) - 2*g2*(k1**2*(Pk2*(22*r**2 + r*(44*s - 8) + s*(22*s - 22)) + 2*Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + k2**2*(2*Pk2*(66*r**2 + r*(131*s - 62) + s*(65*s - 65)) + Pkd2*k2*(r*(67*s - 37) + s*(67*s - 67)))))) - 858*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(2*Pk2*(-2*K*(11*r**2 + 22*r*s + 4*r + 11*s**2 + 4*s - 2) + f*(92*r**2 + r*(184*s - 97) + 92*s**2 - 97*s + 27) + 50*r**2 + 100*r*s + 4*r + 50*s**2 + 4*s - 2) + Pkd2*k2*s*(f*(192*r + 192*s - 91) + (26 - 52*K)*(r + s))) + k2**2*(2*Pk2*(8*C*(r + s - 1)**2 - 132*K*r**2 - 262*K*r*s - 108*K*r - 130*K*s**2 - 108*K*s + 54*K + f*(72*r**2 + 96*r*s - 85*r + 24*s**2 - 73*s + 29) + 75*r**2 + 96*r*s + 40*r + 21*s**2 + 40*s - 20) + Pkd2*k2*s*(-3*f*(12*r + 12*s - 5) + (28 - 134*K)*(r + s)))) + Dd*f*(k1**2*(4*Pk2*(K*(-44*r**2 - 88*r*s + 18*r - 44*s**2 + 39*s + 6) + f*(92*r**2 + r*(184*s - 117) + 92*s**2 - 117*s + 36) + 100*r**2 + 200*r*s - 64*r + 100*s**2 - 85*s - 3) + Pkd2*k2*(f*(r*(384*s - 39) + 384*s**2 - 278*s + 17) + (2 - 4*K)*(2*r*(26*s - 5) + s*(52*s - 19)))) + k2**2*(2*Pk2*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 528*K*r**2 - 1048*K*r*s + 172*K*r - 520*K*s**2 + 190*K*s + 162*K + 4*f*(36*r**2 + 48*r*s - 38*r + 12*s**2 - 35*s + 12) + 300*r**2 + 384*r*s - 111*r + 84*s**2 - 51*s - 60) + Pkd2*k2*(f*(r*(9 - 72*s) - 72*s**2 + 48*s - 3) + 2*r*(-268*K*s + 37*K + 56*s - 7) + 2*s*(-268*K*s + 127*K + 56*s - 28))))) + 3*b1*(D1*(f**2*fd*k1**2*(-132*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + k1**4*(2*Pk2*(108*r**2 + 2*r*(699*s - 50) + 1290*s**2 - 855*s + 10) + Pkd2*k2*(-2*r*(591*s + 73) - 1182*s**2 + 609*s + 112)) - 11*k1**2*k2**2*(4*Pk2*(105*r**2 + 2*r*(75*s - 58) + 45*s**2 - 77*s + 35) + 3*Pkd2*k2*(3*r*(8*s - 15) + 24*s**2 - 67*s + 31))) - 22*f*(fd*(2*Pk2*k1**6*(K*(r*(4*s - 3) + 4*s**2 - 6*s + 2) - 2*r**2 + r*(6 - 8*s) - 6*s**2 + 9*s - 3) + Pk2*k2**6*(2 - 4*C)*(6*r**2 + r*(6*s - 3) - s) + k1**4*k2**2*(Pk2*(4*C*(14*r**2 - 3*r + 10*s**2 + 11*s - 6) + 2*K*(46*r**2 + 172*r*s - 90*r + 126*s**2 - 115*s + 26) - 86*r**2 - 192*r*s + 90*r - 154*s**2 + 85*s - 7) + Pkd2*k2*(72*C*s**2 - 46*C*s - 3*K*(s - 1)*(2*r + 2*s - 1) + r*(88*C*s - 52*s - 7) - 44*s**2 + 18*s + 4)) + k1**2*k2**4*(Pk2*(4*C*(56*r**2 + 5*r*(34*s - 9) + 86*s**2 - 82*s + 4) + K*(-80*r**2 + 4*r*s + 10*r + 84*s**2 - 46*s + 2) - 100*r**2 - 342*r*s + 112*r - 186*s**2 + 193*s - 24) + Pkd2*k2*(-3*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(C*(50*r + 42*s - 27) - 23*r - 19*s + 13)))) - 2*k1**2*k2**2*(-26*Pk2*bd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(2*k1**2*(Pk2*(11*r**2 + 22*r*s - 9*r + 11*s**2 - 16*s - 2) + Pkd2*k2*s*(13*r + 13*s - 3)) + k2**2*(2*Pk2*(66*r**2 + 131*r*s - 39*r + 65*s**2 - 42*s - 27) + Pkd2*k2*s*(67*r + 67*s - 30))))) + 44*fd*k1**2*k2**2*(-26*Pk2*b2*k2**2*(r + s)**2 + g2*k1**2*(Pk2*(22*r**2 + r*(44*s + 8) + 22*s**2 + 8*s - 4) + 26*Pkd2*k2*s*(r + s)) + g2*k2**2*(2*Pk2*(66*r**2 + r*(131*s + 54) + 65*s**2 + 54*s - 27) + 67*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-132*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + k1**4*(2*Pk2*(144*r**2 + 1864*r*s - 203*r + 1720*s**2 - 1312*s + 53) + Pkd2*k2*(-1576*r*s - 113*r - 1576*s**2 + 996*s + 103)) - 22*k1**2*k2**2*(2*Pk2*(140*r**2 + r*(200*s - 161) + 60*s**2 - 113*s + 45) + 3*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) - 22*f*(2*Pk2*k1**6*(K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 4*r**2 - 4*r*(4*s - 3) - 12*s**2 + 19*s - 7) + Pk2*k2**6*(4 - 8*C)*(6*r**2 + r*(6*s - 4) - s) + k1**4*k2**2*(Pk2*(4*C*(28*r**2 - 25*r + 20*s**2 + 13*s + 1) + 2*K*(92*r**2 + 172*r*(2*s - 1) + 252*s**2 - 231*s + 62) - 172*r**2 - 384*r*s + 226*r - 308*s**2 + 201*s - 53) + Pkd2*k2*(2*C*(r*(88*s - 9) + 72*s**2 - 64*s + 5) - 3*K*(s - 1)*(4*r + 4*s - 3) - 104*r*s - r - 88*s**2 + 60*s + 4)) + k1**2*k2**4*(Pk2*(4*C*(112*r**2 + 4*r*(85*s - 38) + 172*s**2 - 217*s + 49) + 2*K*(-80*r**2 + 4*r*s + 65*r + 84*s**2 + 3*s - 19) - 200*r**2 - 684*r*s + 324*r - 372*s**2 + 483*s - 124) + Pkd2*k2*(2*C*(4*r*(25*s - 3) + 84*s**2 - 75*s + 7) - 3*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 92*r*s + 11*r - 76*s**2 + 71*s - 7))) + 44*k1**2*k2**2*(-26*Pk2*b2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*k1**2*(Pk2*(44*r**2 + 2*r*(44*s - 9) + 44*s**2 - 39*s - 6) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))) + k2**2*(2*Pk2*(264*r**2 + r*(524*s - 86) + 260*s**2 - 95*s - 81) + Pkd2*k2*(r*(268*s - 37) + s*(268*s - 127))))))) + f*k1**2*(D1*(3*f**2*fd*k1**2*(108*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(200*r**2 - 1280*r*s + 384*r - 1480*s**2 + 1710*s - 417) + 25*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(-66*Pk2*bd2*k2**2*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(r + s - 1) + fd*(2*Pk2*k1**4*(2*C*(6*r*(9*s - 14) + 54*s**2 - 153*s + 67) - 27*r**2 - 3*r*(54*s - 79) - 135*s**2 + 375*s - 168) + k1**2*k2**2*(Pk2*(4*C*(477*r**2 + 3960*r*s - 2067*r + 2295*s**2 - 3807*s + 1210) + 477*r**2 - 7074*r*s + 3459*r - 5175*s**2 + 8250*s - 2595) - 3*Pkd2*k2*(2*C*(59*s - 49)*(3*r + 3*s - 2) - 342*r*s + 257*r - 342*s**2 + 496*s - 175)) - 3*k2**4*(Pk2*(4*C*(1515*r**2 + 2*r*(906*s - 829) + 693*s**2 - 879*s + 399) - 3921*r**2 - 4911*r*s + 4174*r - 1782*s**2 + 2220*s - 952) + Pkd2*k2*(264*C - 132)*(2*s - 1)*(3*r + 3*s - 2))) - 66*gd2*(2*Pk2*k1**4*(2*s - 1)*(r + s - 1) + k1**2*k2**2*(2*Pk2*(23*r**2 + 86*r*s - 41*r + 63*s**2 - 58*s + 18) - 3*Pkd2*k2*(s - 1)*(r + s - 1)) + k2**4*(Pk2*(-40*r**2 + 2*r*(s + 30) + 42*s**2 + 26*s - 20) - 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)))) + 132*fd*(Pk2*b2*k2**2*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(r*(4*s - 3) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(2*Pk2*(46*r**2 + 172*r*s - 90*r + 126*s**2 - 115*s + 26) - 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k2**4*(Pk2*(-80*r**2 + 4*r*s + 10*r + 84*s**2 - 46*s + 2) - 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(132*Pk2*b2*k2**2*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 3*f**2*k1**2*(108*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(200*r**2 - 1280*r*s + 384*r - 1480*s**2 + 1710*s - 417) + 25*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(2*Pk2*k1**4*(2*C*(72*r*s - 109*r + 72*s**2 - 204*s + 92) - 36*r**2 - 216*r*s + 313*r - 180*s**2 + 503*s - 235) + k1**2*k2**2*(Pk2*(4*C*(636*r**2 + 6*r*(880*s - 433) + 3060*s**2 - 5173*s + 1582) + 636*r**2 - 9432*r*s + 4014*r - 6900*s**2 + 11013*s - 3309) - 3*Pkd2*k2*(C*(8*r*(59*s - 47) + 472*s**2 - 714*s + 278) - 456*r*s + 331*r - 456*s**2 + 676*s - 249)) - 3*k2**4*(Pk2*(4*C*(2020*r**2 + 2416*r*s - 2432*r + 924*s**2 - 1267*s + 668) - 5228*r**2 - 6548*r*s + 6107*r - 2376*s**2 + 3194*s - 1578) + Pkd2*k2*(66*C - 33)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 132*g2*(2*Pk2*k1**4*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k1**2*k2**2*(2*Pk2*(92*r**2 + 172*r*(2*s - 1) + 252*s**2 - 231*s + 62) - 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k2**4*(2*Pk2*(-80*r**2 + 4*r*s + 65*r + 84*s**2 + 3*s - 19) - 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11))))))/(693*d**2*k1*k2*k3**6) - 8*D1**3*Pk3*ct*(11*D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(8*r**2 + r*(8*s - 9) - 3*s + 1) + k1**2*(Pk2*(75*r**2 + 90*r*s - 122*r + 15*s**2 - 62*s + 43) + 5*Pkd2*k2*(6*s + 1)*(r + s - 1))) - f*(Pk2*k2**6*r*(2 - 4*C)*(r + s) + 2*k1**6*(2*Pk2*(-2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 4*b1*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) + Pkd2*b1*k2*(r*(8*s - 2) + 8*s**2 - 8*s + 1)) + k1**4*k2**2*(Pk2*(-8*C*(40*r**2 + 9*r*(8*s - 7) + 45*s**2 - 59*s + 14) - 48*K*r**2 - 152*K*r*s + 96*K*r - 104*K*s**2 + 148*K*s - 48*K + b1*(534*r**2 + r*(948*s - 812) + 414*s**2 - 708*s + 286) + 272*r**2 + 527*r*s - 424*r + 307*s**2 - 395*s + 88) + 2*Pkd2*k2*(C*(-32*r*s + 4*r - 32*s**2 + 34*s - 2) - 6*K*r*s + 6*K*r - 6*K*s**2 + 12*K*s - 6*K + b1*(9*r*(8*s - 1) + 72*s**2 - 69*s + 3) + 22*r*s - 2*r + 22*s**2 - 23*s + 1)) + k1**2*k2**4*(Pk2*(-4*C*(114*r**2 + 191*r*s - 144*r + 103*s**2 - 123*s + 20) - 26*K*r**2 - 104*K*r*s + 52*K*r - 78*K*s**2 + 78*K*s - 26*K + 13*b1*(12*r**2 + r*(18*s - 13) + 6*s**2 - 11*s + 3) + 279*r**2 + 458*r*s - 337*r + 231*s**2 - 271*s + 40) + Pkd2*k2*(12 - 24*C)*(r*(3*s - 1) + s*(3*s - 3)))) + 2*k1**2*(Pk2*b1**2*k2**2*(6*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 4*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(-2*Pk2*k1**4*(2*r**2 + r*(-4*K*s + K + 8*s - 3) + s*(K*(3 - 4*s) + 6*s - 5)) + k1**2*k2**2*(-2*Pk2*(4*C*(2*r**2 + r*(11 - 52*s) + 2*s**2 + 25*s - 13) - 52*K*s**2 + 42*K*s + r**2*(31 - 40*K) + r*(-92*K*s + 50*K + 178*s - 64) + 35*s**2 - 80*s + 25) + Pkd2*k2*(K*r*(32*s - 1) + K*s*(32*s - 31) - 14*s*(r + s - 1))) + k2**4*(7*K*Pkd2*k2*(r*(6*s - 1) + s*(6*s - 5)) - Pk2*(8*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 14*K*(11*r**2 + 24*r*s - 11*r + 13*s**2 - 11*s - 1) + 41*r**2 + 166*r*s - 65*r + 13*s**2 - 65*s + 24))) + 2*g2*(2*Pk2*k1**4*(-2*r*s + r - s*(2*s - 2)) + k1**2*k2**2*(Pk2*(-40*r**2 + r*(60 - 92*s) - s*(52*s - 52)) + Pkd2*k2*(-16*r*s + r - s*(16*s - 16))) - 7*k2**4*(Pk2*(11*r**2 + r*(24*s - 13) + s*(13*s - 13)) + Pkd2*k2*(r*(3*s - 1) + s*(3*s - 3)))))) + 22*Pk2*b1**3*k1**2*k2**2*(6*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 11*b1**2*k1**2*(D1*fd*(4*Pk2*k1**4*(r + s)*(r + s*(3 - 2*K)) + f*(26*Pk2*k2**4*(6*r**2 + r*(9*s - 5) + 3*s**2 - 4*s + 1) + 4*k1**4*(Pk2*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 2*Pkd2*k2*s*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(534*r**2 + 948*r*s - 581*r + 414*s**2 - 525*s + 163) + 6*Pkd2*k2*s*(24*r + 24*s - 11))) - 2*k1**2*k2**2*(Pk2*(-8*C*(r**2 - 2*r*(13*s + 1) + s**2 + 26*s + 1) + 52*K*s**2 + r**2*(40*K - 31) + 2*r*(46*K*s - 89*s - 6) - 35*s**2 + 100*s + 6) + Pkd2*k2*s*(16*K - 7)*(r + s)) - k2**4*(42*K*Pkd2*k2*s*(r + s) + Pk2*(-16*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 14*K*(11*r**2 + 24*r*s + 4*r + 13*s**2 + 4*s - 2) - 41*r**2 - 166*r*s - 16*r - 13*s**2 + 96*s + 8))) + Dd*f*(4*Pk2*k1**4*(4*r**2 + r*(-8*K*s + K + 16*s - 4) + s*(K*(4 - 8*s) + 12*s - 7)) + f*(13*Pk2*k2**4*(24*r**2 + r*(36*s - 23) + 12*s**2 - 19*s + 5) + 2*k1**4*(2*Pk2*(4*r + 4*s - 3)**2 + Pkd2*k2*(16*r*s - 2*r + 16*s**2 - 12*s + 1)) + k1**2*k2**2*(Pk2*(1068*r**2 + 1896*r*s - 1393*r + 828*s**2 - 1233*s + 449) + 6*Pkd2*k2*(48*r*s - 3*r + 48*s**2 - 34*s + 1))) - 2*k1**2*k2**2*(-Pk2*(8*C*(4*r**2 + r*(7 - 104*s) + 4*s**2 + 77*s - 11) - 208*K*s**2 + 116*K*s - r**2*(160*K - 124) + r*(-368*K*s + 140*K + 712*s - 141) + 140*s**2 - 385*s + 38) + Pkd2*k2*(K*r*(64*s - 1) + 2*K*s*(32*s - 23) - 7*s*(4*r + 4*s - 3))) + k2**4*(14*K*Pkd2*k2*(-12*r*s + r + s*(7 - 12*s)) + Pk2*(16*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) - 14*K*(44*r**2 + 96*r*s - 27*r + 52*s**2 - 27*s - 6) + 164*r**2 + 664*r*s - 147*r + 52*s**2 - 343*s + 32)))) + 11*b1*(D1*(f**2*fd*k1**4*(11*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 5*s + 5) + k1**2*(Pk2*(225*r**2 + 270*r*s - 281*r + 45*s**2 - 151*s + 88) + 5*Pkd2*k2*(18*r*s + 6*r + 18*s**2 - 7*s - 4))) + f*(fd*(-4*Pk2*k1**6*(2*r + 2*s - 1)*(2*r + s*(10 - 8*C) - 1) + Pk2*k2**6*(4*C - 2)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(8*C*(80*r**2 + 2*r*(72*s - 37) + 90*s**2 - 54*s + 17) + 4*K*(24*r**2 + 76*r*s - 50*r + 52*s**2 - 76*s + 25) - 544*r**2 - 1054*r*s + 485*r - 614*s**2 + 423*s - 119) + 4*Pkd2*k2*(3*K*(s - 1) + s*(16*C - 11))*(2*r + 2*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(228*r**2 + 2*r*(191*s - 70) + 206*s**2 - 82*s + 7) + 26*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 558*r**2 - 916*r*s + 331*r - 462*s**2 + 191*s - 14) + Pkd2*k2*s*(48*C - 24)*(3*r + 3*s - 1))) - 4*k1**2*(-2*Pk2*bd2*k2**2*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(2*Pk2*k1**4*s*(2*r + 2*s - 1) + 4*Pk2*k1**2*k2**2*(10*r**2 + r*(23*s - 10) + s*(13*s - 8)) + 7*Pk2*k2**4*(11*r**2 + 3*r*(8*s - 3) + 13*s**2 - 9*s - 2) + Pkd2*k1**2*k2**3*s*(16*r + 16*s - 15) + 7*Pkd2*k2**5*s*(3*r + 3*s - 2)))) - 4*fd*k1**2*(-2*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(r + s)**2 + g2*(4*Pk2*k1**4*s*(r + s) + 4*Pk2*k1**2*k2**2*(10*r**2 + 23*r*s + 13*s**2) + 7*Pk2*k2**4*(11*r**2 + 4*r*(6*s + 1) + 13*s**2 + 4*s - 2) + 16*Pkd2*k1**2*k2**3*s*(r + s) + 21*Pkd2*k2**5*s*(r + s)))) + Dd*f*(f**2*k1**4*(22*Pk2*k2**2*(4*r - 1)*(4*r + 4*s - 3) + k1**2*(Pk2*(300*r**2 + 360*r*s - 403*r + 60*s**2 - 213*s + 131) + 5*Pkd2*k2*(24*r*s + 7*r + 24*s**2 - 12*s - 5))) + f*(4*Pk2*k1**6*(C*(4*r*(8*s - 1) + 32*s**2 - 24*s + 2) - 8*r**2 + r*(14 - 48*s) - 40*s**2 + 34*s - 5) + Pk2*k2**6*(8*C - 4)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(8*C*(160*r**2 + 288*r*s - 194*r + 180*s**2 - 153*s + 48) + 4*K*(48*r**2 + 152*r*s - 98*r + 104*s**2 - 150*s + 49) - 1088*r**2 - 2108*r*s + 1275*r - 1228*s**2 + 1103*s - 301) + 2*Pkd2*k2*(2*C*(r*(64*s - 2) + 64*s**2 - 48*s + 1) + 6*K*(s - 1)*(4*r + 4*s - 3) - 88*r*s + 2*r - 88*s**2 + 66*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(456*r**2 + r*(764*s - 417) + 412*s**2 - 291*s + 46) + 26*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) - 1116*r**2 - 1832*r*s + 985*r - 924*s**2 + 661*s - 92) + Pkd2*k2*(24*C - 12)*(r*(12*s - 1) + s*(12*s - 7)))) + 4*k1**2*(2*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*Pk2*k1**4*(-8*r*s + r + s*(4 - 8*s)) - 4*Pk2*k1**2*k2**2*(40*r**2 + r*(92*s - 35) + s*(52*s - 29)) - 7*Pk2*k2**4*(44*r**2 + 3*r*(32*s - 9) + 52*s**2 - 27*s - 6) + Pkd2*k1**2*k2**3*(-64*r*s + r + s*(46 - 64*s)) + 7*Pkd2*k2**5*(-12*r*s + r + s*(7 - 12*s)))))) + f*k1**2*(D1*(305*Pk2*f**2*fd*k1**4*(4*s - 1)*(r + s - 1) + 11*f*k2**2*(24*Pk2*bd2*k1**2*(r + s - 1)**2 + Pk2*fd*k2**2*(4*C - 2)*(36*r**2 + 27*r*(5*s - 3) + 99*s**2 - 111*s + 34) - 52*Pk2*gd2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + fd*k1**2*(Pk2*(8*C*(30*r**2 + 99*r*s - 63*r + 69*s**2 - 99*s + 32) - 150*r**2 - 489*r*s + 293*r - 339*s**2 + 480*s - 149) + Pkd2*k2*(20*C - 10)*(s - 1)*(3*r + 3*s - 2)) - 8*gd2*k1**2*(Pk2*(12*r**2 + r*(38*s - 24) + 26*s**2 - 37*s + 12) + 3*Pkd2*k2*(s - 1)*(r + s - 1))) - 44*fd*k2**2*(-6*Pk2*b2*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + g2*(13*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + 2*k1**2*(Pk2*(24*r**2 + 76*r*s - 50*r + 52*s**2 - 76*s + 25) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))))) + Dd*f*(305*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + 11*f*k2**2*(Pk2*k2**2*(4*C - 2)*(48*r**2 + 15*r*(12*s - 7) + 132*s**2 - 145*s + 46) + k1**2*(Pk2*(8*C*(40*r**2 + 132*r*s - 83*r + 92*s**2 - 131*s + 42) - 200*r**2 - 652*r*s + 383*r - 452*s**2 + 629*s - 189) + Pkd2*k2*(20*C - 10)*(s - 1)*(4*r + 4*s - 3))) - 44*k2**2*(-6*Pk2*b2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + g2*(13*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + 2*k1**2*(Pk2*(48*r**2 + 152*r*s - 98*r + 104*s**2 - 150*s + 49) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(231*d**2*k1*k2*k3**6) + D1**3*Pk3*ct*st**2*(2*D1*bd1*f**2*(4*C*k2**2*r*(3*Pk2*s + Pk2 - 2*Pkd2*k2*s) + k1**2*s*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1))) + 2*k2**2*r*s*(-3*Pk2 + 2*Pkd2*k2)) - 13*b1**3*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) + b1**2*k1**2*(D1*(-13*bd1*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s - 1) + fd*(8*Pk2*(f*(78*s**2 - 71*s + 16) - 17*s**2 + 30*s - 15) + k2*(Pkd2*(-5*f*(42*s**2 - 41*s + 10) + 82*s**2 - 144*s + 72) + Pkdd2*k2*(3*f*(6*s**2 - 7*s + 2) - 16*s**2 + 28*s - 14)))) + Dd*f*(4*s - 1)*(8*Pk2*(f*(39*s - 16) - 17*s + 15) + k2*(Pkd2*(-105*f*s + 50*f + 82*s - 72) + Pkdd2*k2*(9*f*s - 6*f - 16*s + 14)))) + 2*b1*f*(D1*bd1*k1**2*s*(8*Pk2*(f*(39*s - 16) - 17*s + 16) + k2*(Pkd2*(-105*f*s + 50*f + 82*s - 77) + Pkdd2*k2*(9*f*s - 6*f - 16*s + 15))) + D1*fd*(k1**2*(2*s - 1)*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1))) - 2*k2**2*(-2*C*(Pk2*(6*r*s - 2*r + s - 1) + 2*Pkd2*k2*r*(1 - 2*s)) + Pk2*(6*r*s - 4*r + s) + 2*Pkd2*k2*r*(1 - 2*s))) + Dd*f*k1**2*(4*s - 1)*(4*Pk2*(13*s - 9) + k2*(-4*Pkd2*(4*s - 3) + Pkdd2*k2*(s - 1))) - 4*Dd*f*k2**2*(-2*C*(Pk2*(6*r*s + s - 1) + Pkd2*k2*r*(1 - 4*s)) + Pk2*(6*r*s - 2*r + s) + Pkd2*k2*r*(1 - 4*s))))/(21*d**2*k1*k2**3) + 2*D1**3*Pk3*ct*(D1*bd1*f**2*(2*Pk2*k1**2*s*(23 - 21*s) + 2*Pk2*k2**2*(-8*C*s + r**2 + r*(2*C - 1)*(11*s - 1) + 4*s) + 25*Pkd2*k1**2*k2*s*(s - 1) + 4*Pkd2*k2**3*r*(-2*C*(s - 1) + s - 1)) + 7*b1**3*k1**2*s*(6*Pk2 + k2*(-4*Pkd2 + Pkdd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - b1**2*(-7*D1*bd1*f*k1**2*s*(6*Pk2 + k2*(-4*Pkd2 + Pkdd2*k2))*(3*s - 1) + D1*fd*(k1**2*(2*Pk2*(12*f*(6*s**2 - 7*s + 2) + 39*s**2 - 70*s + 35) - Pkd2*k2*(13*f*(6*s**2 - 7*s + 2) + 25*s**2 - 42*s + 21)) + 2*k2**2*(r - 1)*(3*Pk2*(r - 1) + Pkd2*k2*s*(4 - 8*C))) + Dd*f*k1**2*(4*s - 1)*(Pk2*(24*f*(3*s - 2) + 78*s - 70) + Pkd2*k2*(f*(26 - 39*s) - 25*s + 21)) - 4*Dd*f*k2**2*(Pk2*(-6*r**2 + 9*r - 3) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) - 6*s + 1))) + b1*f*(2*D1*bd1*(2*Pk2*k1**2*s*(f*(24 - 36*s) - 39*s + 37) - 6*Pk2*k2**2*r*(r - 1) + Pkd2*k1**2*k2*s*(13*f*(3*s - 2) + 25*s - 23) + Pkd2*k2**3*(4*C - 2)*(r*(4*s - 1) - 2*s + 1)) + D1*fd*(k1**2*(2*s - 1)*(Pk2*(46 - 42*s) + 25*Pkd2*k2*(s - 1)) + 2*k2**2*(Pk2*(2*C*(22*r*s - 8*r - 13*s + 5) + 2*r**2 - 22*r*s + 7*r + 13*s - 5) + Pkd2*k2*(2 - 4*C)*(2*r - 1)*(s - 1))) + Dd*f*k1**2*(4*s - 1)*(Pk2*(46 - 42*s) + 25*Pkd2*k2*(s - 1)) - 4*Dd*f*k2**2*(Pk2*(C*(-44*r*s + 10*r + 26*s - 6) - 2*r**2 + 22*r*s - 4*r - 13*s + 3) + Pkd2*k2*(4*C - 2)*(2*r - 1)*(s - 1))))/(21*d**2*k1*k2**3) - 2*D1**3*Pk3*ct*st**4*(D1*(-66*b1*fd*k1**2*k2**2*(b1*(-8*Pk2*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1) + k2*(Pkd2*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + Pkdd2*k2*(2*K*(s - 1)**2 + 2*s - 1))) - 4*g2*(s - 1)*(-8*Pk2*(r - s + 1) + k2*(Pkd2*(2*r - 5*s + 5) + Pkdd2*k2*(s - 1)))) + bd1*f**3*k1**2*s*(20*k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s - 1) + 33*k2**2*(-4*Pk2 + Pkd2*k2)*(6*r + 5*s - 4)) + f**2*(fd*(k1**4*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*b1 + 2) - k1**2*k2**2*(4*Pk2*(80*C*(1 - 3*s)**2 + 495*b1*s**2 - 429*b1*s + 18*r*(33*b1*s + 12*s - 4) - 180*s**2 + 48*s + 4) + k2*(Pkd2*(-200*C*(1 - 3*s)**2 - 495*b1*s**2 + 429*b1*s - 18*r*(33*b1*s + 12*s - 4) + 720*s**2 - 408*s + 56) + Pkdd2*k2*(1 - 3*s)**2*(40*C - 20))) + 2*k2**4*(3*r - 1)*(Pk2*(-80*C*(3*s - 1) - 3*r + 120*s - 61) + Pkd2*k2*(40*C - 20)*(3*s - 1))) - 33*k1**2*k2**2*(bd1*(2*Pk2*(r*(7*s + 6) + s**2*(8*K - 24) + s*(4*b1 + 17) - 6) + k2*(-Pkd2*(2*r*(s + 2) + s**2*(10*K - 24) + s*(5*b1 + 16) - 4) + Pkdd2*k2*s*(b1 + s*(2*K - 4) + 2))) + s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*bd2 - 4*gd2))) + 33*f*k1**2*k2**2*(b1**2*fd*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 2*b1*(-2*Pk2*fd*(s**2*(8*K - 24) + s*(-4*K + 7*r + 24) - 6) - 16*Pk2*gd2*(r*(2*s - 1) - 2*s**2 + s + 1) + bd1*(8*Pk2*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1) + k2*(Pkd2*(-2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) + 8*r*s - 4*r + 3*s + 2) + Pkdd2*k2*s*(-4*K*(s - 1) - 1))) + fd*k2*(Pkd2*(2*r*s + r + (2*s - 1)*(5*K*s - 12*s + 6)) - Pkdd2*k2*(2*s - 1)*(s*(K - 2) + 1)) + 4*gd2*k2*(Pkd2*(2*r*s - r - 5*s**2 + 4*s + 1) + Pkdd2*k2*s*(s - 1))) - 8*bd1*g2*(Pk2*r*(8*s - 4) - 8*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r + s*(5*s - 5)) - Pkdd2*k2**2*s*(s - 1)) - 2*fd*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(b2 - 2*g2)*(2*s - 1))) + Dd*f*(-66*b1*k1**2*k2**2*(b1*(-8*Pk2*(-8*K*s**2 + 8*K*s + r*(K - 1)*(8*s - 5) - 2*s - 1) + k2*(Pkd2*(2*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) - 16*r*s + 10*r - 16*s + 1) + Pkdd2*k2*(4*s - 1)*(2*K*(s - 1) + 1))) - 4*g2*(4*Pk2*(r*(5 - 8*s) + s*(8*s - 8)) + Pkd2*k2*(r*(8*s - 5) - 20*s**2 + 23*s - 3) + Pkdd2*k2**2*(4*s**2 - 5*s + 1))) + f**2*(k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(20*b1 + 2)*(12*s**2 - 7*s + 1) - k1**2*k2**2*(4*Pk2*(80*C*(12*s**2 - 7*s + 1) + 660*b1*s**2 - 561*b1*s + 12*r*(66*b1*s + 24*s - 7) - 240*s**2 + 20*s + 16) + k2*(Pkd2*(-200*C*(12*s**2 - 7*s + 1) - 660*b1*s**2 + 561*b1*s - 12*r*(66*b1*s + 24*s - 7) + 960*s**2 - 440*s + 44) + Pkdd2*k2*(40*C - 20)*(12*s**2 - 7*s + 1))) + 4*k2**4*(Pk2*(-20*C*(24*r*s - 7*r - 10*s + 3) - 6*r**2 + 240*r*s - 109*r - 100*s + 51) + Pkd2*k2*(10*C - 5)*(r*(24*s - 7) - 10*s + 3))) - 66*f*k1**2*k2**2*(b1*(2*Pk2*(2*r*(7*s + 3) + s**2*(16*K - 48) + s*(41 - 4*K) - 12) + k2*(Pkd2*(-r*(4*s + 5) + s**2*(48 - 20*K) + s*(5*K - 40) + 10) + Pkdd2*k2*(4*s - 1)*(s*(K - 2) + 1))) + s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(b2 - 2*g2)*(4*s - 1))))/(231*d**2*k1*k2**3*k3**2) + D1**3*Pk3*ct*st**2*(429*b1**3*k1**2*k2**3*s*(-Pkd2 + Pkdd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*k1**2*(D1*(-13*bd1*f*k2**3*s*(-Pkd2 + Pkdd2*k2)*(3*s - 1) + fd*(Pk2*k1**2*s**2*(288*f + 16) - Pkd2*k1**2*k2*s**2*(180*f + 10) + Pkd2*k2**3*(-8*C*s**2 - 16*C*s + 2*K*(28*r*(s - 1) - 3*s**2 + 32*s - 16) + f*(4*r*(20*s + 3) + 49*s - 26) + 2*r*(8*C*s - 3*s + 28) + 6*s**2 - 16*s + 16) + Pkdd2*k2**4*(8*C*s**2 + 2*K*(s**2 - 28*s + 14) + f*(6 - 21*s) - 6*s**2 + 28*s - 14) - 2*k2**2*(Pk2*(16*C*r*s - 16*C*s + 2*K*(s - 1)*(29*r - 2*s + 2) + 8*f*r*(11*s + 2) + 22*f*(s - 1) - 15*r*s + 58*r + 12*s + 2) - Pkdd2*k1**2*s**2*(18*f + 1)))) - 2*Dd*f*(Pk2*k1**2*s*(-72*f - 8)*(4*s - 1) + Pkd2*k1**2*k2*s*(45*f + 5)*(4*s - 1) - Pkd2*k2**3*(-4*C*(-8*r*s + r + 4*s**2 + 5*s - 1) + 112*K*r*s - 70*K*r - 12*K*s**2 + 39*K*s + 12*K + f*(80*r*s + 36*r + 12*s - 31) - 12*r*s + 47*r + 12*s**2 + 5*s - 24) + Pkdd2*k2**4*(4*s - 1)*(-4*C*s - K*(s - 14) + 3*f + 3*s - 7) + k2**2*(2*Pk2*(4*C*(r*(8*s - 1) - 6*s + 1) + 116*K*r*s - 41*K*r - 8*K*s**2 + 2*K*s + 6*K + f*(88*r*s + 40*r - 4*s - 30) - 30*r*s + 18*r + 23*s - 11) - Pkdd2*k1**2*s*(9*f + 1)*(4*s - 1)))) + 33*b1*(D1*(f**2*k1**2*(bd1*(144*Pk2*k1**2*s*(1 - 2*s) + 90*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(-20*r*(4*s + 3) + 25*s + 36) + 3*Pkdd2*k2**4*s + 2*k2**2*(Pk2*(88*r*s + 64*r - 30*s - 38) + 9*Pkdd2*k1**2*s*(1 - 2*s))) + 2*fd*(k1**2*(3*s - 1)*(8*Pk2*(33*s - 16) + k2*(-93*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 6*k2**2*(Pk2*(18*r**2 - 15*r - 30*s**2 + 14*s + 3) + Pkd2*k2*(18*r*s - 9*r + 15*s**2 - 19*s + 6)))) + 2*f*(fd*(k1**4*(4*Pk2*(18*s**2 - 31*s + 9) + k2*(-4*Pkd2*(3*s**2 - 10*s + 3) + Pkdd2*k2*(-2*s**2 - 3*s + 1))) + k1**2*k2**2*(-Pk2*(4*C*(r*(22*s - 3) - 44*s**2 + 54*s - 20) + 4*K*(11*r*s - 4*r + 60*s**2 - 50*s + 10) + 44*r**2 + 106*r*s - 110*r + 352*s**2 - 367*s + 108) + k2*(Pkd2*(-4*C*(r*(4*s - 3) + 33*s**2 - 37*s + 13) + K*(20*r*s - 6*r + 138*s**2 - 121*s + 26) - 28*r*s + 7*r + 66*s**2 - 90*s + 32) + Pkdd2*k2*(4*C*(11*s**2 - 3*s + 1) - 3*K*(6*s**2 - 7*s + 2) - 22*s**2 + 9*s - 3))) + k2**4*(2 - 4*C)*(Pk2*(2*r - 1) + 2*Pkd2*k2*r)) + k1**2*(-bd1*(8*Pk2*k1**2*s*(2*s - 1) + 5*Pkd2*k1**2*k2*s*(1 - 2*s) + Pkd2*k2**3*(-4*C*(-4*r*s + r + 2*s**2 + s - 1) + K*(56*r*s - 28*r - 6*s**2 + 5*s + 14) - 6*r*s + 5*r + 6*s**2 + 5*s - 18) + Pkdd2*k2**4*s*(C*(8*s - 4) + K*(2*s - 15) - 6*s + 10) + k2**2*(Pk2*(-8*C*(r*(4*s - 1) - 2*s + 1) + 4*K*(-29*r*s + 4*r + 2*s**2 - 2) + 30*r*s + 30*r - 17*s + 16) + Pkdd2*k1**2*s*(2*s - 1))) + k2**2*(13*bd2*k2*s**2*(-Pkd2 + Pkdd2*k2) + 2*gd2*(Pk2*r*(8 - 58*s) + 4*Pk2*(s**2 + s - 2) + Pkd2*k2*(14*r*(2*s - 1) - 3*s**2 + 2*s + 14) + Pkdd2*k2**2*s*(s - 14))))) + 2*fd*k1**2*k2**2*(13*b2*k2*s**2*(-Pkd2 + Pkdd2*k2) - 2*g2*(2*Pk2*(s - 1)*(29*r - 2*s + 2) + k2*(Pkd2*(-28*r*(s - 1) + 3*s**2 - 32*s + 16) - Pkdd2*k2*(s**2 - 28*s + 14))))) + 2*Dd*f*(f**2*k1**2*(k1**2*(4*s - 1)*(8*Pk2*(33*s - 16) + k2*(-93*Pkd2*s + 50*Pkd2 + 9*Pkdd2*k2*s - 6*Pkdd2*k2)) + 6*k2**2*(2*Pk2*(12*r**2 - 8*r + s*(9 - 20*s)) + Pkd2*k2*(12*r*(2*s - 1) + 20*s**2 - 25*s + 8))) + f*(4*Pk2*k2**4*(C*(2 - 4*r) + 2*r - 1) + k1**4*(4*s - 1)*(36*Pk2*(s - 1) - k2*(6*Pkd2*(s - 2) + Pkdd2*k2*(s + 1))) + k1**2*k2**2*(-2*Pk2*(2*C*(4*s - 1)*(11*r - 22*s + 16) + 2*K*(22*r*s - 11*r + 120*s**2 - 87*s + 17) + 44*r**2 + 106*r*s - 76*r + 352*s**2 - 281*s + 62) + k2*(Pkd2*(C*(r*(4 - 32*s) - 264*s**2 + 266*s - 48) + K*(40*r*s - 18*r + 276*s**2 - 205*s + 38) - 56*r*s + 32*r + 132*s**2 - 117*s + 12) + Pkdd2*k2*(4*s - 1)*(C*(22*s - 4) + K*(6 - 9*s) - 11*s + 3)))) + k1**2*k2**2*(-4*Pk2*g2*(r*(116*s - 41) - 8*s**2 + 2*s + 6) + 13*b2*k2*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 2*g2*k2*(Pkd2*(14*r*(8*s - 5) - 12*s**2 + 39*s + 12) + Pkdd2*k2*(4*s**2 - 57*s + 14))))) + 2*f*(D1*(33*bd1*f**2*k1**2*(8*Pk2*k1**2*s*(33*s - 16) + Pkd2*k1**2*k2*s*(50 - 93*s) + 6*Pkd2*k2**3*(r*(6*s - 3) + 5*s**2 - 6*s + 2) + 3*k2**2*(2*Pk2*(6*r**2 - r - 10*s**2 + 4*s - 3) + Pkdd2*k1**2*s*(3*s - 2))) + f*(-33*bd1*(k1**4*s*(-4*Pk2*(9*s - 5) + k2*(Pkd2*(6*s - 2) + Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(2*K*(r*(11*s - 7) + 60*s**2 - 37*s + 7) + 22*r**2 + r*(4*C*(11*s - 4) + 53*s - 20) - 2*s**2*(44*C - 88) + 2*s*(48*C - 63) + 16) + k2*(Pkd2*(66*C*s**2 - 74*C*s + K*(r*(6 - 10*s) - 69*s**2 + 42*s - 6) + r*(8*C*s + 4*C + 14*s - 13) - 33*s**2 + 21*s + 8) + Pkdd2*k2*s*(-22*C*(s - 1) + K*(9*s - 6) + 11*s - 11))) + k2**4*r*(4*C - 2)*(Pk2 - 2*Pkd2*k2)) + fd*(Pk2*k2**4*(12 - 24*C)*(189*r**2 + 9*r*(22*s - 25) + 32) + 3*k1**4*(3*s - 1)*(4*Pk2*(139*s - 83) + k2*(-4*Pkd2*(43*s - 29) + 11*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(-2*Pk2*(12*C*(78*r*s - 92*r + 792*s**2 - 609*s + 137) - 549*r**2 + 2178*r*s - 393*r - 2970*s**2 + 1980*s - 380) - 3*k2*(Pkd2*(-2*C*(90*r*s - 118*r + 1881*s**2 - 1493*s + 318) - 603*r*s + 245*r + 1485*s**2 - 1031*s + 164) + Pkdd2*k2*(66*C - 33)*(9*s**2 - 9*s + 2)))) - 33*k1**2*k2**2*(bd2 - 2*gd2)*(2*Pk2*(r*(11*s - 7) + 60*s**2 - 37*s + 7) + k2*(Pkd2*(-10*r*s + 6*r - 69*s**2 + 42*s - 6) + 3*Pkdd2*k2*s*(3*s - 2)))) + 33*k1**2*k2**2*(b2*(-4*Pk2*fd*(11*r*s - 4*r + 60*s**2 - 50*s + 10) + 13*bd1*k2*s*(-Pkd2 + Pkdd2*k2)*(s - 1) + fd*k2*(Pkd2*(20*r*s - 6*r + 138*s**2 - 121*s + 26) - 3*Pkdd2*k2*(6*s**2 - 7*s + 2))) + 2*g2*(Pk2*bd1*(r*(8 - 58*s) + s*(4*s - 4)) + 4*Pk2*fd*(11*r*s - 4*r + 60*s**2 - 50*s + 10) + bd1*k2*(14*Pkd2*r*(2*s - 1) - 3*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1)) + fd*k2*(Pkd2*(-20*r*s + 6*r - 138*s**2 + 121*s - 26) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))) + Dd*f*(f*(Pk2*k2**4*(48 - 96*C)*(63*r**2 + r*(66*s - 80) + 16) + 3*k1**4*(4*s - 1)*(4*Pk2*(139*s - 83) + k2*(-4*Pkd2*(43*s - 29) + 11*Pkdd2*k2*(s - 1))) + k1**2*k2**2*(Pk2*(-24*C*(8*r*(13*s - 18) + 1056*s**2 - 784*s + 189) + 1464*r**2 - 5808*r*s + 386*r + 7920*s**2 - 4488*s + 794) - 3*k2*(Pkd2*(C*(-80*r*(3*s - 5) - 5016*s**2 + 3774*s - 800) - 804*r*s + 251*r + 1980*s**2 - 1227*s + 158) + Pkdd2*k2*(66*C - 33)*(12*s**2 - 11*s + 2)))) + k1**2*k2**2*(-33*b2 + 66*g2)*(4*Pk2*(11*r*(2*s - 1) + 120*s**2 - 87*s + 17) + k2*(Pkd2*(-40*r*s + 18*r - 276*s**2 + 205*s - 38) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2))))))/(693*d**2*k1*k2**3*k3**2) - 2*D1**3*Pk3*ct*(7*b1**3*k1**2*k2**3*(D1*fd*s*(2*Pkd2*(r - 1) + Pkdd2*k2*s) + Dd*f*(4*Pkd2*(2*r*s - r - 3*s + 1) + Pkdd2*k2*s*(4*s - 1))) - b1**2*(D1*(-7*bd1*f*k1**2*k2**3*(2*Pkd2*(r*(3*s - 2) - 5*s + 2) + Pkdd2*k2*s*(3*s - 1)) + fd*(4*k1**4*s**2*(Pk2*(18*f - 2) + k2*(-15*Pkd2*f + Pkd2 + 6*Pkdd2*f*k2)) + k1**2*k2**2*(Pk2*(40*C*r*s - 40*C*s + 14*K*(s - 1)*(3*r - 4*s + 4) + 2*f*(168*r**2 + 4*r*(27*s - 53) - 46*s + 69) + 14*r**2 - 103*r*s + 42*r - 16*s + 28) + k2*(-14*K*Pkdd2*k2*s**2 + Pkd2*(-140*C*r*s + 16*C*s**2 + 140*C*s + 14*K*(3*s**2 - s*(r + 6) + 3) + f*(56*r*(2*s + 1) + 7*s - 54) + 98*r*s - 12*s**2 - 28*s - 21))) - 2*k2**4*(r - 1)*(Pk2*(4*C*(3*r + 4*s - 3) - 9*r - 8*s + 9) + Pkd2*k2*s*(8*C - 4)))) + Dd*f*(2*k1**4*s*(4*s - 1)*(Pk2*(18*f - 4) + k2*(Pkd2*(2 - 15*f) + 6*Pkdd2*f*k2)) + k1**2*k2**2*(2*Pk2*(4*C*(r*(20*s - 13) - 36*s + 13) + 84*K*r*s - 21*K*r - 112*K*s**2 + 140*K*s - 28*K + 4*f*(84*r**2 + 54*r*s - 113*r - 25*s + 35) + 28*r**2 - 206*r*s + 66*r + 95*s - 38) + k2*(14*K*Pkdd2*k2*s*(1 - 4*s) + Pkd2*(8*C*(r*(14 - 70*s) + 8*s**2 + 61*s - 14) - 56*K*r*s + 28*K*r + 168*K*s**2 - 238*K*s + 42*K + 2*f*(56*r*(2*s + 1) - 4*s - 41) + 392*r*s - 70*r - 48*s**2 - 184*s + 35))) - 4*k2**4*(Pk2*(8*C*(3*r**2 + 4*r*s - 5*r - 3*s + 2) - 18*r**2 - 16*r*s + 29*r + 12*s - 11) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) - 6*s + 1)))) + b1*(D1*(f**2*k1**2*(bd1*(36*Pk2*k1**2*s*(1 - 2*s) + 30*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(-56*r*(2*s + 1) + 15*s + 28) - 2*k2**2*(Pk2*(168*r**2 + 12*r*(9*s - 20) - 54*s + 71) + 6*Pkdd2*k1**2*s*(2*s - 1))) + 2*fd*k1**2*(20*Pk2 - 11*Pkd2*k2)*(9*s**2 - 9*s + 2)) + f*(bd1*(4*k1**4*s*(2*Pk2 - Pkd2*k2)*(2*s - 1) - k1**2*k2**2*(Pk2*(8*C*(r*(10*s - 13) - 26*s + 13) - 112*K*s**2 + 112*K*s + 28*r**2 + 2*r*(42*K*s - 103*s + 52) + 187*s - 104) + k2*(14*K*Pkdd2*k2*s*(1 - 2*s) + Pkd2*(8*C*(-7*r*(5*s - 2) + 4*s**2 + 26*s - 14) + 84*K*s**2 - 98*K*s - 14*r*(2*K*(s - 1) - 14*s + 5) - 24*s**2 - 93*s + 56))) + 4*k2**4*(Pk2*(4*C*(3*r**2 + 4*r*(s - 1) - 2*s + 1) - 9*r**2 - 8*r*s + 11*r + 4*s - 2) + Pkd2*k2*(2*C - 1)*(r*(4*s - 1) - 2*s + 1))) + fd*(k1**4*(2*Pk2*(58*s**2 - 67*s + 23) + Pkd2*k2*(-66*s**2 + 75*s - 25)) + k1**2*k2**2*(Pk2*(4*C*(118*r*s - 31*r - 16*s**2 - 124*s + 52) + 4*K*(27*r*s - 13*r + 6*s**2 - 7*s + 2) - 300*r**2 - 510*r*s + 338*r + 32*s**2 + 415*s - 162) + k2*(Pkd2*(4*C*(-32*s**2 + s*(44*r + 53) - 25) + 56*K*r*(s - 1) + 26*K*(6*s**2 - 7*s + 2) - 172*r*s + 64*s**2 - 151*s + 75) + Pkdd2*k2*s**2*(48*C - 24))) + k2**4*(4*C - 2)*(Pk2*(48*r**2 - 60*r + 19) + 2*Pkd2*k2*(2*r - 1))) + 14*k1**2*k2**2*s*(bd2*k2*(Pkd2*r + Pkd2 + Pkdd2*k2*s) - 2*gd2*(Pk2*(-3*r + 4*s - 4) + k2*(Pkd2*(r - 3*s + 4) + Pkdd2*k2*s)))) + 14*fd*k1**2*k2**2*(2*Pk2*g2*(s - 1)*(3*r - 4*s + 4) + b2*k2*s*(Pkd2*r + Pkdd2*k2*s) - 2*g2*k2*(Pkd2*(-3*s**2 + s*(r + 6) - 3) + Pkdd2*k2*s**2))) + Dd*f*(2*f**2*k1**4*(20*Pk2 - 11*Pkd2*k2)*(12*s**2 - 11*s + 2) + f*(k1**4*(4*s - 1)*(Pk2*(58*s - 46) + Pkd2*k2*(25 - 33*s)) + k1**2*k2**2*(2*Pk2*(2*C*(236*r*s - 31*r - 32*s**2 - 256*s + 52) + 2*K*(6*r*(9*s - 2) + 12*s**2 - 10*s + 1) - 300*r**2 - 510*r*s + 374*r + 32*s**2 + 431*s - 158) + k2*(Pkd2*(4*C*(4*r*(22*s - 5) - 64*s**2 + 72*s - 15) + 112*K*r*(s - 1) + 6*K*(52*s**2 - 57*s + 18) - 344*r*s + 52*r + 128*s**2 - 184*s + 55) + Pkdd2*k2*s*(24*C - 12)*(4*s - 1))) + k2**4*(8*C - 4)*(2*r - 1)*(3*Pk2*(8*r - 5) + 2*Pkd2*k2)) + 14*k1**2*k2**2*(b2*k2*(2*Pkd2*(2*r*s - r + s) + Pkdd2*k2*s*(4*s - 1)) + 2*g2*(Pk2*(4*s - 1)*(3*r - 4*s + 4) + k2*(Pkd2*(-4*r*s + 2*r + 12*s**2 - 17*s + 3) + Pkdd2*k2*s*(1 - 4*s)))))) + f*(D1*(2*bd1*f**2*k1**4*s*(20*Pk2 - 11*Pkd2*k2)*(3*s - 2) + f*(bd1*(k1**4*s*(Pk2*(58*s - 62) - 33*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(2*K*(27*r*s + r + 6*s**2 - 3*s - 1) - 150*r**2 + r*(s*(236*C - 255) + 198) - 4*s**2*(8*C - 4) - 4*s*(52*C - 50) - 92) + 2*k2*(Pkd2*(4*C*(r*(11*s - 10) - 8*s**2 + 3*s + 5) + K*(14*r*(s - 1) + 39*s**2 - 40*s + 14) - 43*r*s + 26*r + 16*s**2 - 6*s - 10) + Pkdd2*k2*s*(12*C - 6)*(s - 1))) + k2**4*(4*C - 2)*(Pk2*(24*r**2 - 9*r - 4) + 2*Pkd2*k2*r)) + fd*(k1**4*(3*s - 1)*(Pk2*(30*s - 38) - 21*Pkd2*k2*(s - 1)) + 2*k1**2*k2**2*(Pk2*(4*C*(54*r*s - 16*r + 9*s**2 - 38*s + 11) - 36*r**2 - 207*r*s + 77*r - 18*s**2 + 76*s - 22) + Pkd2*k2*(2*C - 1)*(42*r*(s - 1) + 99*s**2 - 113*s + 36))) + k1**2*k2**2*(2*bd2 - 4*gd2)*(Pk2*(27*r*s + r + 6*s**2 - 3*s - 1) + Pkd2*k2*(14*r*(s - 1) + 39*s**2 - 40*s + 14))) + 2*k1**2*k2**2*(b2*(7*bd1*k2*(Pkd2*r*(s - 2) + Pkdd2*k2*s*(s - 1)) + fd*(2*Pk2*(r*(27*s - 13) + 6*s**2 - 7*s + 2) + Pkd2*k2*(28*r*(s - 1) + 78*s**2 - 91*s + 26))) - 2*g2*(7*bd1*(Pk2*s*(-3*r + 4*s - 4) + Pkd2*k2*(r*(s - 2) - s*(3*s - 3)) + Pkdd2*k2**2*s*(s - 1)) + fd*(2*Pk2*(r*(27*s - 13) + 6*s**2 - 7*s + 2) + Pkd2*k2*(28*r*(s - 1) + 78*s**2 - 91*s + 26))))) + Dd*f*k1**2*(f*(k1**2*(4*s - 1)*(Pk2*(30*s - 38) - 21*Pkd2*k2*(s - 1)) + 2*k2**2*(Pk2*(4*C*(72*r*s - 15*r + 12*s**2 - 49*s + 10) - 48*r**2 - 276*r*s + 87*r - 24*s**2 + 98*s - 20) + Pkd2*k2*(2*C - 1)*(56*r*(s - 1) + 132*s**2 - 149*s + 50))) + k2**2*(2*b2 - 4*g2)*(2*Pk2*(6*r*(9*s - 2) + 12*s**2 - 10*s + 1) + Pkd2*k2*(56*r*(s - 1) + 156*s**2 - 171*s + 54)))))/(21*d**2*k1*k2**3*k3**2) + 2*D1**3*Pk3*ct*st**4*(D1*(2574*b1*fd*k1**2*k2**4*(b1*(-8*K*Pk2*(r**2 + r - 2*(s - 1)**2) + 8*Pk2*(r + 1)*(r + 2*s - 1) + k2*(Pkd2*(-2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - 4*r*(s + 1) + s**2 - 8*s + 4) + Pkdd2*k2*s**2*(2*K - 1))) + 4*g2*(4*Pk2*(r**2 + r - 2*(s - 1)**2) + k2*(Pkd2*(2*r*(s - 2) + 5*s**2 - 8*s + 4) - Pkdd2*k2*s**2))) + f**3*k1**2*(39*bd1*k2**2*(-20*k1**2*(4*Pk2*(5*r*(6*s - 1) + 30*s**2 - 32*s + 3) - k2*(Pkd2*(30*r*s - 5*r + 30*s**2 - 41*s + 3) + 3*Pkdd2*k2*s)) + 33*k2**2*(2*Pk2*(11*r**2 + 4*r*(3*s - 4) - 8*s + 5) + Pkd2*k2*s*(4*r + 5*s - 6))) + fd*(-1300*Pk2*k2**4*(2*r - 1)*(3*s - 1) - 15*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(268*s**2 - 147*s + 20) + 39*k1**2*k2**2*(4*Pk2*(96*r*(11*s - 3) + 2580*s**2 - 1765*s + 292) + k2*(-2*Pkd2*(60*r*(10*s - 3) + 1740*s**2 - 1211*s + 209) + 15*Pkdd2*k2*(20*s**2 - 13*s + 2))))) + 39*f**2*k2**2*(fd*(-2*k1**4*(120*Pk2*b1*(10*r*(3*s - 1) + 30*s**2 - 28*s + 7) - 8*Pk2*(3*s - 1)*(4*C*(3*r + 3*s - 2) - 30*r - 33*s + 21) - Pkd2*k2*(15*b1*(20*r*(3*s - 1) + 60*s**2 - 38*s + 11) + (3*s - 1)*(C*(-24*r + 12*s + 4) + 60*r + 39*s - 33)) + Pkdd2*k2**2*(15*b1*(6*s - 1) + (1 - 3*s)**2*(4*C - 3))) + k1**2*k2**2*(66*Pk2*b1*(33*r**2 + r*(36*s - 39) - 26*s + 14) - 12*Pk2*(4*C*(3*r**2 - 84*r*s + 37*r - 120*s**2 + 108*s - 26) - 99*r**2 + 4*r*(9*s + 8) + 240*s**2 - 172*s + 27) + Pkd2*k2*(-4*C*(9*r*(73*s - 28) + 630*s**2 - 639*s + 154) + 495*b1*s**2 - 231*b1*s + 18*r*(22*b1*s + 85*s - 32) + 1440*s**2 - 1470*s + 352) + Pkdd2*k2**2*(1 - 3*s)**2*(20 - 40*C)) + 2*k2**4*(3*r - 1)*(Pk2*(8*C*(15*r + 30*s + 7) - 63*r - 120*s - 49) + Pkd2*k2*(40*C - 20)*(3*s - 1))) - 33*k1**2*(bd1*(16*Pk2*k1**2*s*(r - s*(K - 2)) - 2*Pk2*k2**2*(K*(-6*r**2 + 34*r*s + 16*r + 8*s**2 + 6*s - 10) + 2*b1*(r + 2*s - 1) + 18*r**2 - 27*r*s - 22*r - 16*s**2 + 3*s + 4) - 4*Pkd2*k1**2*k2*s*(r - s*(K - 2)) + Pkd2*k2**3*(K*(36*r*s + 4*r - 2*s**2 - 4) + b1*(2*r + 2*s**2 + 3*s - 2) - 34*r*s + 4*r - 8*s**2 + 16*s - 4) + Pkdd2*k2**4*s*(2*K*(5*s - 2) - 2*b1*s + b1 - 4*s + 2)) + 8*bd2*k2**2*s*(-2*Pk2 + Pkd2*k2)*(2*r + 2*s - 1) + 4*gd2*(8*Pk2*k1**2*s**2 + 2*Pk2*k2**2*(-3*r**2 + r*(17*s + 8) + 4*s**2 + 3*s - 5) - 2*Pkd2*k1**2*k2*s**2 + Pkd2*k2**3*(-2*r*(9*s + 1) + s**2 + 2) + Pkdd2*k2**4*s*(2 - 5*s)))) + 2574*f*k1**2*k2**2*(b1**2*fd*k2**2*(-2*Pk2*(r + 2*s - 1) + k2*(Pkd2*(r - (s - 1)**2) + Pkdd2*k2*s**2)) + b1*(fd*(8*Pk2*k1**2*(-r + s*(K - 2))*(2*s - 1) - 2*Pk2*k2**2*(r**2*(6*K - 18) + r*(-34*K*s + 10*K + 27*s - 12) - (8*s - 4)*(s*(K - 2) + 1)) + 2*Pkd2*k1**2*k2*(r - s*(K - 2))*(2*s - 1) + Pkd2*k2**3*(K*(r*(12 - 36*s) + 2*s**2 - 5*s + 2) + r*(34*s - 15) + 2*(1 - 2*s)**2) - Pkdd2*k2**4*(2*s - 1)*(K*(5*s - 2) - 2*s + 1)) + k2**2*(bd1*(-2*K*(2*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + k2*(Pkd2*(4*r*s - 3*r + 10*s**2 - 10*s + 2) + Pkdd2*k2*s*(1 - 2*s))) + 16*Pk2*r*(r + 2*s - 1) + Pkd2*k2*(-8*r*s + 2*s**2 - 3*s + 2) + Pkdd2*k2**2*s*(1 - 2*s)) + 4*gd2*(Pk2*(4*r**2 - 2*r - 2*(1 - 2*s)**2) + k2*(Pkd2*(2*r*(s - 1) + 5*s**2 - 5*s + 2) - Pkdd2*k2*s**2)))) - 2*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1) - 4*bd1*g2*k2**2*(-4*Pk2*(r**2 - s*(2*s - 2)) + Pkd2*k2*(-2*r*s + r - s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1)) + 2*fd*g2*(8*Pk2*k1**2*s*(1 - 2*s) + 4*Pk2*k2**2*(3*r**2 + r*(5 - 17*s) + s*(2 - 4*s)) + 2*Pkd2*k1**2*k2*s*(2*s - 1) + Pkd2*k2**3*(12*r*(3*s - 1) - 2*s**2 + 5*s - 2) + Pkdd2*k2**4*(10*s**2 - 9*s + 2)))) + Dd*f*(2574*b1*k1**2*k2**4*(b1*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + k2*(-Pkd2*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8) + Pkdd2*k2*s*(2*K - 1)*(4*s - 1))) + 4*g2*(4*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + Pkdd2*k2*s*(1 - 4*s)))) + f**3*k1**2*(-1300*Pk2*k2**4*(2*r - 1)*(3*s - 1) - 15*k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(268*s**2 - 147*s + 20) + 39*k1**2*k2**2*(4*Pk2*(96*r*(11*s - 3) + 2580*s**2 - 1765*s + 292) + k2*(-2*Pkd2*(60*r*(10*s - 3) + 1740*s**2 - 1211*s + 209) + 15*Pkdd2*k2*(20*s**2 - 13*s + 2)))) + 39*f**2*k2**2*(-2*k1**4*(8*Pk2*(-2*C*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + 5*b1*(5*r*(24*s - 7) + 120*s**2 - 116*s + 24) + 120*r*s - 35*r + 132*s**2 - 127*s + 26) + k2*(-Pkd2*(C*(-96*r*s + 28*r + 48*s**2 + 12*s - 8) + 5*b1*(10*r*(24*s - 7) + 240*s**2 - 196*s + 39) + 240*r*s - 70*r + 156*s**2 - 191*s + 43) + Pkdd2*k2*(15*b1 + (4*C - 3)*(3*s - 1))*(4*s - 1))) + k1**2*k2**2*(66*Pk2*b1*(44*r**2 + r*(48*s - 55) - 34*s + 19) - 8*Pk2*(C*(24*r**2 + r*(253 - 672*s) - 960*s**2 + 818*s - 193) - 198*r**2 + 3*r*(24*s + 37) + 480*s**2 - 288*s + 27) + k2*(Pkd2*(-8*C*(3*r*(146*s - 49) + 420*s**2 - 422*s + 98) + 660*b1*s**2 - 429*b1*s + 24*r*(22*b1*s + 85*s - 28) + 1920*s**2 - 1948*s + 448) + Pkdd2*k2*(20 - 40*C)*(12*s**2 - 7*s + 1))) + 4*k2**4*(Pk2*(4*C*(60*r**2 + 3*r*(40*s + 1) - 50*s - 19) - 126*r**2 - 15*r*(16*s + 3) + 100*s + 59) + Pkd2*k2*(10*C - 5)*(r*(24*s - 7) - 10*s + 3))) + 1287*f*k1**2*k2**2*(b1*(-2*K*(8*Pk2*k1**2*s*(1 - 4*s) + 4*Pk2*k2**2*(6*r**2 - r*(34*s + 3) - 8*s**2 - s + 5) + 2*Pkd2*k1**2*k2*s*(4*s - 1) + Pkd2*k2**3*(8*r*(9*s - 1) - 4*s**2 + 5*s - 6) + Pkdd2*k2**4*(20*s**2 - 13*s + 2)) - 16*Pk2*k1**2*(r + 2*s)*(4*s - 1) + 4*Pk2*k2**2*(36*r**2 - 2*r*(27*s + 5) + s*(19 - 32*s)) + 4*Pkd2*k1**2*k2*(r + 2*s)*(4*s - 1) + Pkd2*k2**3*(2*r*(68*s - 19) - s**2*(4*b1 - 32) + s*(b1 - 48) + 12) + Pkdd2*k2**4*(4*s - 1)*(s*(b1 + 4) - 2)) - 4*b2*k2**2*(-2*Pk2 + Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1) + 4*g2*(8*Pk2*k1**2*s*(1 - 4*s) + 4*Pk2*k2**2*(6*r**2 - r*(34*s + 3) - 8*s**2 - s + 5) + 2*Pkd2*k1**2*k2*s*(4*s - 1) + Pkd2*k2**3*(8*r*(9*s - 1) - 4*s**2 + 5*s - 6) + Pkdd2*k2**4*(20*s**2 - 13*s + 2)))))/(9009*d**2*k1*k2**3*k3**4) + D1**3*Pk3*ct*st**2*(D1*(-66*b1*fd*k1**2*k2**2*(26*Pkd2*b1**2*k2**3*s*(r + s - 1) + 78*Pkd2*b2*k2**3*s*(r + s) - b1*(k1**2*(4*Pk2*(K*(r*(4*s - 2) + 13*s**2 - 4*s + 2) + r*(2 - 17*s) - 26*s**2 + 4*s - 2) + k2*s*(Pkd2*r*(30 - 4*K) + Pkd2*s*(47 - 20*K) + Pkdd2*k2*s*(1 - 2*K))) + k2**2*(Pk2*(16*C*(r - 1)*(r + s - 1) + 54*K*r**2 + 8*K*r*(8*s - 13) - 4*K*(s - 1)**2 + 62*r**2 + 27*r*s + 112*r + 12*s - 14) + k2*(Pkd2*(-K*(r*(90*s + 82) + 75*s**2 + 164*s - 82) + r*(s*(16*C + 49) + 28) + 4*s**2*(4*C + 2) + 4*s*(17 - 4*C) - 28) + Pkdd2*k2*s**2*(7 - 27*K)))) + 4*g2*k1**2*(Pk2*(r*(8*s - 4) + 26*s**2 - 8*s + 4) - k2*s*(2*Pkd2*(r + 5*s) + Pkdd2*k2*s)) - 2*g2*k2**2*(Pk2*(-54*r**2 - 8*r*(8*s - 13) + 4*(s - 1)**2) + k2*(Pkd2*(90*r*s + 82*r + 75*s**2 + 164*s - 82) + 27*Pkdd2*k2*s**2))) + f**3*k1**2*(-3*bd1*(95*k1**4*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1) + 11*k1**2*k2**2*(-8*Pk2*(r*(92*s + 7) + 78*s**2 - 74*s - 7) + 3*k2*(Pkd2*(64*r*s + 12*r + 48*s**2 - 57*s - 12) + 3*Pkdd2*k2*s)) + 132*k2**4*(Pk2*(12*r**2 + 3*r*(10*s - 7) + 10*s**2 - 18*s + 7) + Pkd2*k2*(r*(4*s - 3) + 5*s**2 - 8*s + 3))) + fd*k1**2*(5*k1**2*(4*s - 1)*(8*Pk2*(183*s - 80) + k2*(Pkd2*(250 - 501*s) + 15*Pkdd2*k2*(3*s - 2))) + 36*k2**2*(2*Pk2*(220*r**2 + 2*r*(24*s - 67) - 420*s**2 + 161*s - 8) + 3*Pkd2*k2*(88*r*(2*s - 1) + 180*s**2 - 205*s + 62)))) + f**2*(-3384*C*Pk2*fd*k1**4*k2**2*r*s + 3240*C*Pk2*fd*k1**4*k2**2*r + 13392*C*Pk2*fd*k1**4*k2**2*s**2 - 9120*C*Pk2*fd*k1**4*k2**2*s + 848*C*Pk2*fd*k1**4*k2**2 + 24480*C*Pk2*fd*k1**2*k2**4*r**2 - 83664*C*Pk2*fd*k1**2*k2**4*r*s + 3648*C*Pk2*fd*k1**2*k2**4*r - 57024*C*Pk2*fd*k1**2*k2**4*s**2 + 79632*C*Pk2*fd*k1**2*k2**4*s - 14848*C*Pk2*fd*k1**2*k2**4 + 9072*C*Pk2*fd*k2**6*r**2 + 9504*C*Pk2*fd*k2**6*r*s - 10800*C*Pk2*fd*k2**6*r + 1536*C*Pk2*fd*k2**6 - 2088*C*Pkd2*fd*k1**4*k2**3*r*s + 696*C*Pkd2*fd*k1**4*k2**3*r - 10512*C*Pkd2*fd*k1**4*k2**3*s**2 + 10344*C*Pkd2*fd*k1**4*k2**3*s - 2280*C*Pkd2*fd*k1**4*k2**3 + 34560*C*Pkd2*fd*k1**2*k2**5*r*s - 16800*C*Pkd2*fd*k1**2*k2**5*r + 20196*C*Pkd2*fd*k1**2*k2**5*s**2 - 29604*C*Pkd2*fd*k1**2*k2**5*s + 9384*C*Pkd2*fd*k1**2*k2**5 + 792*C*Pkdd2*fd*k1**4*k2**4*s**2 - 1056*C*Pkdd2*fd*k1**4*k2**4*s + 264*C*Pkdd2*fd*k1**4*k2**4 + 3564*C*Pkdd2*fd*k1**2*k2**6*s**2 - 3564*C*Pkdd2*fd*k1**2*k2**6*s + 792*C*Pkdd2*fd*k1**2*k2**6 - 6840*Pk2*b1*fd*k1**6*s**2 + 72864*Pk2*b1*fd*k1**4*k2**2*r*s - 21384*Pk2*b1*fd*k1**4*k2**2*r + 61776*Pk2*b1*fd*k1**4*k2**2*s**2 - 65472*Pk2*b1*fd*k1**4*k2**2*s + 15576*Pk2*b1*fd*k1**4*k2**2 - 14256*Pk2*b1*fd*k1**2*k2**4*r**2 - 35640*Pk2*b1*fd*k1**2*k2**4*r*s + 20988*Pk2*b1*fd*k1**2*k2**4*r - 11880*Pk2*b1*fd*k1**2*k2**4*s**2 + 22176*Pk2*b1*fd*k1**2*k2**4*s - 7524*Pk2*b1*fd*k1**2*k2**4 + 1404*Pk2*fd*k1**4*k2**2*r**2 + 20304*Pk2*fd*k1**4*k2**2*r*s - 13380*Pk2*fd*k1**4*k2**2*r + 6336*Pk2*fd*k1**4*k2**2*s**2 - 14424*Pk2*fd*k1**4*k2**2*s + 6152*Pk2*fd*k1**4*k2**2 - 29880*Pk2*fd*k1**2*k2**4*r**2 + 23904*Pk2*fd*k1**2*k2**4*r*s + 12216*Pk2*fd*k1**2*k2**4*r + 26136*Pk2*fd*k1**2*k2**4*s**2 - 35424*Pk2*fd*k1**2*k2**4*s + 5496*Pk2*fd*k1**2*k2**4 - 4536*Pk2*fd*k2**6*r**2 - 4752*Pk2*fd*k2**6*r*s + 5400*Pk2*fd*k2**6*r - 768*Pk2*fd*k2**6 + 2376*Pk2*gd2*k1**4*k2**2*r*s + 1584*Pk2*gd2*k1**4*k2**2*s**2 + 2112*Pk2*gd2*k1**4*k2**2*s + 12672*Pk2*gd2*k1**2*k2**4*r**2 + 67848*Pk2*gd2*k1**2*k2**4*r*s - 20328*Pk2*gd2*k1**2*k2**4*r + 66528*Pk2*gd2*k1**2*k2**4*s**2 - 44616*Pk2*gd2*k1**2*k2**4*s + 7656*Pk2*gd2*k1**2*k2**4 + 4275*Pkd2*b1*fd*k1**6*k2*s**2 - 19008*Pkd2*b1*fd*k1**4*k2**3*r*s + 5544*Pkd2*b1*fd*k1**4*k2**3*r - 14256*Pkd2*b1*fd*k1**4*k2**3*s**2 + 10197*Pkd2*b1*fd*k1**4*k2**3*s - 2970*Pkd2*b1*fd*k1**4*k2**3 - 4752*Pkd2*b1*fd*k1**2*k2**5*r*s + 3564*Pkd2*b1*fd*k1**2*k2**5*r - 5940*Pkd2*b1*fd*k1**2*k2**5*s**2 + 5148*Pkd2*b1*fd*k1**2*k2**5*s - 1980*Pkd2*b1*fd*k1**2*k2**5 - 1728*Pkd2*fd*k1**4*k2**3*r*s + 1500*Pkd2*fd*k1**4*k2**3*r + 4392*Pkd2*fd*k1**4*k2**3*s**2 - 3144*Pkd2*fd*k1**4*k2**3*s + 252*Pkd2*fd*k1**4*k2**3 - 21438*Pkd2*fd*k1**2*k2**5*r*s + 10578*Pkd2*fd*k1**2*k2**5*r - 12474*Pkd2*fd*k1**2*k2**5*s**2 + 17574*Pkd2*fd*k1**2*k2**5*s - 5616*Pkd2*fd*k1**2*k2**5 + 1320*Pkd2*gd2*k1**4*k2**3*r*s - 528*Pkd2*gd2*k1**4*k2**3*r + 4224*Pkd2*gd2*k1**4*k2**3*s**2 - 3960*Pkd2*gd2*k1**4*k2**3*s + 528*Pkd2*gd2*k1**4*k2**3 - 4224*Pkd2*gd2*k1**2*k2**5*r*s - 528*Pkd2*gd2*k1**2*k2**5*r - 1980*Pkd2*gd2*k1**2*k2**5*s**2 + 2376*Pkd2*gd2*k1**2*k2**5*s + 528*Pkd2*gd2*k1**2*k2**5 - 855*Pkdd2*b1*fd*k1**6*k2**2*s**2 + 2673*Pkdd2*b1*fd*k1**4*k2**4*s - 594*Pkdd2*b1*fd*k1**4*k2**4 - 594*Pkdd2*fd*k1**4*k2**4*s**2 + 792*Pkdd2*fd*k1**4*k2**4*s - 198*Pkdd2*fd*k1**4*k2**4 - 1782*Pkdd2*fd*k1**2*k2**6*s**2 + 1782*Pkdd2*fd*k1**2*k2**6*s - 396*Pkdd2*fd*k1**2*k2**6 - 264*Pkdd2*gd2*k1**4*k2**4*s**2 + 264*Pkdd2*gd2*k1**4*k2**4*s - 1188*Pkdd2*gd2*k1**2*k2**6*s**2 + 792*Pkdd2*gd2*k1**2*k2**6*s + 33*bd1*(-k1**4*k2**2*(4*Pk2*(-4*C*(2*r*s - 3*r + 7*s**2 - 5*s + 1) + 9*K*r*s + 6*K*s**2 + 8*K*s + b1*(2*r*(64*s - 9) + 128*s**2 - 121*s + 16) - 15*r**2 - 67*r*s + 19*r - 48*s**2 + 28*s - 16) + k2*(Pkd2*(-8*C*(2*r - 3*s**2 + s - 1) + 4*K*(5*r*s - 2*r + 16*s**2 - 15*s + 2) + b1*(-4*r*(64*s - 9) - 202*s**2 + 215*s - 32) - 24*r*s + 12*r - 56*s**2 + 36*s + 4) + Pkdd2*k2*s*(b1*(27 - 54*s) + (s - 1)*(16*C - 4*K - 10)))) + k1**2*k2**4*(2*Pk2*(4*C*(19*r**2 + 54*r*s - 17*r + 22*s**2 - 42*s - 2) - 96*K*r**2 - 514*K*r*s + 154*K*r - 504*K*s**2 + 338*K*s - 58*K + 2*b1*(32*r**2 + r*(14*s - 13) - 3*s - 5) - 48*r**2 + 3*r*s + 30*r + 88*s**2 + 6*s + 16) + k2*(Pkd2*(-4*C*(r*(70*s - 38) + 87*s**2 - 111*s + 26) + 2*K*(32*r*s + 4*r + 15*s**2 - 18*s - 4) + 3*b1*(10*r*(4*s + 1) + 22*s**2 - 31*s - 6) + 160*r*s - 90*r + 190*s**2 - 262*s + 68) + Pkdd2*k2*s*(-28*C*(s - 1) + 18*K*s - 12*K + b1*(9 - 18*s) + 12*s - 12))) + 4*k2**6*r*(Pk2*(2*C*(9*s - 4) - 9*s + 3) + Pkd2*k2*(4*C - 2)*(s - 1))) - 132*bd2*k1**2*k2**2*(-k1**2*(2*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) + k2**2*(2*Pk2*(16*r**2 + 4*r*(19*s - 7) + 60*s**2 - 47*s + 12) - 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)))) + 66*f*k2**2*(b1**2*k1**2*(-13*Pkd2*bd1*k2**3*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + fd*(k1**2*(-2*Pk2*(16*r*(8*s + 1) + 128*s**2 - 67*s - 16) + k2*(Pkd2*(16*r*(8*s + 1) + 101*s**2 - 67*s - 16) + 27*Pkdd2*k2*s**2)) + k2**2*(2*Pk2*(32*r**2 + 14*r*s + r + 29*s - 15) + 3*k2*(Pkd2*(20*r*s - 7*r + 11*s**2 - 22*s + 7) - 3*Pkdd2*k2*s**2)))) + b1*(bd1*(k1**4*(4*Pk2*(K*(8*r*s - 3*r + 26*s**2 - 17*s + 1) - 34*r*s + 13*r - 52*s**2 + 33*s - 1) + k2*(Pkd2*(r*(-8*K*s + 2*K + 60*s - 22) + s*(-40*K*s + 22*K + 94*s - 55)) + Pkdd2*k2*s*(K*(2 - 4*s) + 2*s - 1))) + k1**2*k2**2*(Pk2*(8*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 2*K*(54*r**2 + 64*r*s - 146*r - 4*s**2 - 19*s + 54) + 124*r**2 + 54*r*s + 82*r - 25*s - 76) + k2*(Pkd2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-180*r*s + 46*r - 150*s**2 + 17*s + 34) + 98*r*s - 21*r + 16*s**2 + 12*s - 20) - Pkdd2*k2*s*(27*K - 7)*(2*s - 1)))) + fd*(k1**4*(2*Pk2*(K*r*(5 - 18*s) - 6*K*(2*s**2 + 3*s - 2) + 30*r**2 + r*(s*(16*C + 134) - 97) + s**2*(56*C + 96) - s*(16*C + 112) + 26) - k2*(2*Pkd2*(6*C*(r + 2*s**2 + s - 1) + K*(2*s - 1)*(5*r + 16*s - 11) - 12*r*s - 13*r - 28*s**2 + 3*s + 5) + Pkdd2*k2*(K*(-4*s**2 + 6*s - 2) + s**2*(16*C - 10) - 3*s + 1))) + k1**2*k2**2*(Pk2*(4*C*(38*r**2 + r*(108*s - 103) + 44*s**2 - 125*s + 66) - 4*K*(48*r**2 + 257*r*s - 131*r + 252*s**2 - 242*s + 58) - 96*r**2 + 6*r*s + 126*r + 176*s**2 - s - 84) + k2*(Pkd2*(-4*C*(r*(70*s + 5) + 87*s**2 - 33*s - 5) + K*(64*r*s - 34*r + 30*s**2 - 71*s + 28) + 160*r*s - 3*r + 190*s**2 - 86*s - 4) + Pkdd2*k2*(3*K*(6*s**2 - 7*s + 2) + s**2*(12 - 28*C)))) + 2*k2**4*(Pk2*(2*C*(6*r*(3*s + 2) - 5*s - 4) - 2*r*(9*s + 7) + 5*s + 5) + Pkd2*k2*r*s*(8*C - 4))) + 2*k1**2*(Pkd2*bd2*k2**3*s*(-39*r - 39*s + 16) - 2*gd2*k1**2*(Pk2*(r*(8*s - 2) + 26*s**2 - 8*s + 2) + k2*s*(-2*Pkd2*r - 10*Pkd2*s + Pkd2 - Pkdd2*k2*s)) + gd2*k2**2*(-2*Pk2*(27*r**2 + r*(32*s - 81) - 2*s**2 - 21*s + 54) + k2*(Pkd2*(90*r*s + 34*r + 75*s**2 + 58*s - 34) + 27*Pkdd2*k2*s**2)))) + 2*k1**2*(b2*(Pkd2*bd1*k2**3*(r*(23 - 39*s) - s*(39*s - 39)) + fd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + k2**2*(-2*Pk2*(32*r**2 + 152*r*s - 78*r + 120*s**2 - 110*s + 25) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5)))) + g2*(-2*bd1*k1**2*(Pk2*r*(8*s - 4) + 26*Pk2*s*(s - 1) + Pkd2*k2*(-2*r*s + r - s*(10*s - 10)) - Pkdd2*k2**2*s*(s - 1)) + bd1*k2**2*(-2*Pk2*(27*r**2 + r*(32*s - 65) - s*(2*s - 2)) + k2*(10*Pkd2*r*(9*s - 8) + 75*Pkd2*s*(s - 1) + 27*Pkdd2*k2*s*(s - 1))) + 2*fd*k1**2*(Pk2*(r*(18*s - 5) + 12*s**2 + 18*s - 12) + k2*(2*s - 1)*(Pkd2*(5*r + 16*s - 11) - Pkdd2*k2*(s - 1))) + fd*k2**2*(4*Pk2*(48*r**2 + r*(257*s - 131) + 252*s**2 - 242*s + 58) - k2*(Pkd2*(64*r*s - 34*r + 30*s**2 - 71*s + 28) + 3*Pkdd2*k2*(6*s**2 - 7*s + 2))))))) + Dd*f*(-66*b1*k1**2*k2**2*(13*Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 2*Pkd2*b2*k2**3*(r*(156*s - 23) + s*(156*s - 71)) - b1*(k1**2*(4*Pk2*(K*(16*r*s - 6*r + 52*s**2 - 25*s + 4) - 68*r*s + 16*r - 104*s**2 + 44*s - 4) + k2*(Pkd2*(-2*r*(8*K*s - K - 60*s + 11) + s*(-80*K*s + 24*K + 188*s - 63)) + Pkdd2*k2*s*(K*(2 - 8*s) + 4*s - 1))) + k2**2*(2*Pk2*(4*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) + K*(108*r**2 + 128*r*s - 279*r - 8*s**2 - 36*s + 106) + 124*r**2 + 54*r*s + 108*r - 19*s - 87) + k2*(Pkd2*(8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 5*K*(72*r*s + 14*r + 60*s**2 + 41*s - 30) + 196*r*s + 21*r + 32*s**2 + 100*s - 62) - Pkdd2*k2*s*(27*K - 7)*(4*s - 1)))) + 2*g2*(2*k1**2*(2*Pk2*(2*r*(8*s - 3) + 52*s**2 - 25*s + 4) + k2*(Pkd2*(-8*r*s + r + s*(12 - 40*s)) + Pkdd2*k2*s*(1 - 4*s))) - k2**2*(Pk2*(-216*r**2 - 256*r*s + 558*r + 16*s**2 + 72*s - 212) + k2*(5*Pkd2*(72*r*s + 14*r + 60*s**2 + 41*s - 30) + 27*Pkdd2*k2*s*(4*s - 1))))) + f**3*k1**4*(5*k1**2*(4*s - 1)*(8*Pk2*(183*s - 80) + k2*(Pkd2*(250 - 501*s) + 15*Pkdd2*k2*(3*s - 2))) + 36*k2**2*(2*Pk2*(220*r**2 + 2*r*(24*s - 67) - 420*s**2 + 161*s - 8) + 3*Pkd2*k2*(88*r*(2*s - 1) + 180*s**2 - 205*s + 62))) - f**2*(-Pk2*k2**6*(192*C - 96)*(63*r**2 + r*(66*s - 80) + 16) + 285*b1*k1**6*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(4*s - 1) - 2*k1**4*k2**2*(4*Pk2*(C*(-564*r*s + 445*r + 2232*s**2 - 1430*s + 66) + 66*b1*(r*(184*s - 37) + 156*s**2 - 161*s + 26) + 234*r**2 + 3384*r*s - 2062*r + 1056*s**2 - 2466*s + 1100) + 3*k2*(-Pkd2*(4*C*(r*(116*s - 43) + 584*s**2 - 554*s + 109) + 33*b1*(2*r*(64*s - 11) + 96*s**2 - 80*s + 9) + 384*r*s - 310*r - 976*s**2 + 600*s + 18) + 11*Pkdd2*k2*(9*b1 + (4*C - 3)*(s - 1))*(4*s - 1))) - 2*k1**2*k2**4*(8*C*Pk2*(2040*r**2 - r*(6972*s + 299) - 4752*s**2 + 6876*s - 911) - 396*Pk2*b1*(24*r**2 + r*(60*s - 37) + 20*s**2 - 37*s + 13) - 6*Pk2*(3320*r**2 - r*(2656*s + 1937) - 2904*s**2 + 4084*s - 369) + 3*Pkd2*k2*(6*C*(1280*r*s - 564*r + 748*s**2 - 1131*s + 358) - 66*b1*(4*r*(4*s - 3) + 20*s**2 - 21*s + 8) - 4764*r*s + 2143*r - 2772*s**2 + 4053*s - 1316) + Pkdd2*k2**2*(198*C - 99)*(12*s**2 - 11*s + 2))) + 33*f*k2**2*(b1**2*k1**2*(8*Pk2*k1**2*(-128*r*s + r + s*(94 - 128*s)) + Pkd2*k1**2*k2*(r*(512*s - 4) + s*(404*s - 349)) + 3*Pkd2*k2**3*(r*(80*s - 4) + 44*s**2 - 75*s + 8) + 9*Pkdd2*k2**4*s*(1 - 4*s) + k2**2*(8*Pk2*(32*r**2 + 14*r*s - 6*r + 13*s - 10) + 27*Pkdd2*k1**2*s*(4*s - 1))) + 2*b1*(k1**4*(2*Pk2*(4*C*(r*(8*s - 4) + 28*s**2 - 11*s + 2) + K*(-36*r*s + 5*r - 24*s**2 - 34*s + 12) + 60*r**2 + 268*r*s - 149*r + 192*s**2 - 184*s + 60) + k2*(-2*Pkd2*(2*C*(r + 12*s**2 + 3*s - 2) + K*(20*r*s - 9*r + 64*s**2 - 68*s + 15) - 24*r*s - 14*r - 56*s**2 + 14*s + 10) + Pkdd2*k2*(4*s - 1)*(2*K*(s - 1) + s*(5 - 8*C) + 1))) + k1**2*k2**2*(2*Pk2*(2*C*(76*r**2 + r*(216*s - 161) + 88*s**2 - 228*s + 86) - 2*K*(96*r**2 + 514*r*s - 208*r + 504*s**2 - 411*s + 87) - 96*r**2 + 6*r*s + 122*r + 176*s**2 + 21*s - 54) + k2*(Pkd2*(C*(r*(52 - 560*s) - 696*s**2 + 462*s - 28) + K*(128*r*s - 26*r + 60*s**2 - 107*s + 20) + 320*r*s - 56*r + 380*s**2 - 295*s + 38) + Pkdd2*k2*(4*s - 1)*(K*(9*s - 6) + s*(6 - 14*C)))) + 4*k2**4*(Pk2*(2*C*(18*r*s + 6*r - 5*s - 4) - 18*r*s - 8*r + 5*s + 5) + Pkd2*k2*r*(2*C - 1)*(4*s - 1))) + 4*k1**2*(b2*k1**2*(2*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + b2*k2**2*(-2*Pk2*(64*r**2 + 2*r*(152*s - 67) + 240*s**2 - 204*s + 49) + 3*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) + 2*g2*k1**2*(Pk2*(r*(36*s - 5) + 24*s**2 + 34*s - 12) + k2*(Pkd2*(20*r*s - 9*r + 64*s**2 - 68*s + 15) + Pkdd2*k2*(-4*s**2 + 5*s - 1))) + g2*k2**2*(4*Pk2*(96*r**2 + r*(514*s - 208) + 504*s**2 - 411*s + 87) - k2*(Pkd2*(128*r*s - 26*r + 60*s**2 - 107*s + 20) + 3*Pkdd2*k2*(12*s**2 - 11*s + 2)))))))/(693*d**2*k1*k2**3*k3**4) + 2*D1**3*Pk3*ct*(D1*(33*b1*fd*k2**2*(2*b1**2*k1**2*k2*(r + s - 1)*(7*Pk2*k2*(3*r + s - 3) + 4*Pkd2*k1**2*s + 14*Pkd2*k2**2*s) + b1*(Pk2*k2**4*(4 - 8*C)*(r - 1)*(3*r - 4*s - 3) - 4*k1**4*(Pk2*(9*r**2 + r*s*(8*C - 9*K + 9) + s*(8*C*(s - 1) + 5*K*s - 14*s + 8)) + Pkd2*k2*s*(-28*C*(r - 1) - 2*K*r - 11*K*s + 21*r + 15*s - 14)) + k1**2*k2**2*(Pk2*(-8*C*(10*r**2 - r*(143*s + 20) + 8*s**2 + 143*s + 10) + 14*K*(5*r**2 + 8*r*s + 12*r + 16*s - 8) - 66*r**2 - 705*r*s - 190*r + 26*s**2 + 460*s + 102) + k2*(14*K*(Pkd2*(9*r*s + 2*r + 11*s**2 + 4*s - 2) + Pkdd2*k2*s**2) - Pkd2*s*(16*C*(-6*r + s + 6) + 76*r + 13*s - 48)))) - 4*k1**2*(-b2*k2*(r + s)*(14*Pk2*k2*(r + s) + 2*Pkd2*k1**2*s + 21*Pkd2*k2**2*s) + g2*(2*Pk2*k1**2*s*(9*r - 5*s) + 7*Pk2*k2**2*(5*r**2 + 8*r*s + 12*r + 16*s - 8) + 2*Pkd2*k1**2*k2*s*(2*r + 11*s) + 7*Pkd2*k2**3*(9*r*s + 2*r + 11*s**2 + 4*s - 2) + 7*Pkdd2*k2**4*s**2))) + f**3*k1**4*(33*bd1*(10*Pk2*k1**2*s*(s - 1) - 10*Pkd2*k1**2*k2*s*(s - 1) + 3*Pkd2*k2**3*(16*r*(2*s + 1) + 5*s - 16) + k2**2*(2*Pk2*(120*r**2 + 26*r*s - 218*r - 66*s**2 - 11*s + 98) + 5*Pkdd2*k1**2*s*(s - 1))) - 5*fd*k1**2*(112*Pk2 - 61*Pkd2*k2)*(12*s**2 - 11*s + 2)) - 33*f**2*(bd1*k2**2*(k1**4*(2*Pk2*(-4*C*(52*r*s - 22*r + 7*s**2 - 32*s + 11) - 31*K*r*s - 14*K*s**2 + 6*K*s + b1*(180*r**2 + r*(168*s - 241) - 12*s**2 - 77*s + 57) + 64*r**2 + 300*r*s - 188*r + 87*s**2 - 189*s + 76) + k2*(Pkd2*(-8*C*(4*r*s - 2*r + 14*s**2 - 15*s + 1) - 24*K*r*s + 24*K*r - 74*K*s**2 + 98*K*s - 24*K + 3*b1*(8*r*(13*s - 1) + 82*s**2 - 81*s + 8) + 40*r*s - 8*r + 137*s**2 - 141*s + 4) + 18*Pkdd2*b1*k2*s*(2*s - 1))) + k1**2*k2**2*(Pk2*(-4*C*(229*r**2 + 230*r*s - 323*r + 68*s**2 - 192*s + 96) - 104*K*r**2 - 470*K*r*s + 206*K*r - 324*K*s**2 + 318*K*s - 102*K + 2*b1*(356*r**2 + r*(422*s - 467) + 84*s**2 - 242*s + 139) + 740*r**2 + 853*r*s - 1016*r + 194*s**2 - 534*s + 284) + k2*(Pkd2*(-8*C*(4*r*(11*s - 4) + 41*s**2 - 46*s + 5) + K*(-28*r*(s - 1) - 78*s**2 + 80*s - 28) + 168*b1*r*s + 78*b1*s**2 - 123*b1*s + 218*r*s - 76*r + 189*s**2 - 209*s + 20) + Pkdd2*k2*s*(12 - 24*C)*(s - 1))) - 2*k2**4*(Pk2*(2*C*(28*r**2 - 7*r*s - 8*r + 4*s - 4) - 29*r**2 + 7*r*s + 8*r - 4*s + 4) + Pkd2*k2*r*s*(4*C - 2))) - k1**2*(fd*(15*b1*k1**4*s**2*(2*Pk2 + k2*(-2*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(2*Pk2*(2*C*(3*s - 1)*(31*r + 22*s - 10) + b1*(360*r**2 + 6*r*(13*s - 58) - 198*s**2 + 85*s + 50) - 30*r**2 - 249*r*s + 93*r - 147*s**2 + 148*s - 33) + Pkd2*k2*(3*b1*(48*r*(2*s + 1) + 19*s - 38) + (s - 1)*(4*C*(30*r + 93*s - 41) - 60*r - 249*s + 103))) + 2*k2**4*(Pk2*(4*C*(72*r**2 + 324*r*s - 178*r + 207*s**2 - 260*s + 79) - 180*r**2 - 747*r*s + 401*r - 414*s**2 + 520*s - 158) + Pkd2*k2*(2*C - 1)*(42*r*(s - 1) + 99*s**2 - 113*s + 36))) - 4*k2**2*(-bd2*(Pk2*k1**2*s*(3*r + 3*s - 1) + 13*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + 6*Pkd2*k1**2*k2*(s - 1)*(r + s - 1)) + gd2*(Pk2*k1**2*s*(31*r + 14*s - 6) + Pk2*k2**2*(52*r**2 + 235*r*s - 103*r + 162*s**2 - 159*s + 51) + Pkd2*k1**2*k2*(s - 1)*(12*r + 37*s - 12) + Pkd2*k2**3*(14*r*(s - 1) + 39*s**2 - 40*s + 14))))) + 33*f*k2**2*(-2*b1**2*k1**2*(-bd1*k2*(7*Pk2*k2*(9*r**2 + 12*r*s - 17*r + 3*s**2 - 15*s + 8) + 2*Pkd2*k1**2*(6*r*s - r + 6*s**2 - 6*s + 1) + 7*Pkd2*k2**2*(6*r*s - r + 6*s**2 - 6*s + 1)) + fd*(k1**2*(Pk2*(180*r**2 + r*(168*s - 253) - 12*s**2 - 89*s + 101) + 3*k2*(Pkd2*(52*r*s + 8*r + 41*s**2 - 24*s - 8) + 6*Pkdd2*k2*s**2)) + k2**2*(Pk2*(356*r**2 + 422*r*s - 357*r + 84*s**2 - 174*s + 83) + 3*Pkd2*k2*s*(28*r + 13*s - 14)))) - b1*(bd1*(Pk2*k2**4*(16*C - 8)*(3*r**2 - 2*r*(2*s + 1) + 2*s - 1) + 4*k1**4*(Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 10*K*s**2 - 11*K*s + 18*r**2 + r*(-18*K*s + 15*K + 18*s - 31) - 28*s**2 + 31*s - 4) + Pkd2*k2*(-14*C*(r*(4*s - 1) - 2*s + 1) - 22*K*s**2 + 12*K*s + r*(-4*K*s + K + 42*s - 7) + 30*s**2 - 36*s + 7)) + k1**2*k2**2*(Pk2*(16*C*(10*r**2 + r*(31 - 143*s) + 8*s**2 + 78*s - 41) - 14*K*(10*r**2 + 2*r*(8*s - 5) + 5*s - 4) + 132*r**2 + 1410*r*s - 432*r - 52*s**2 - 553*s + 272) + k2*(14*K*Pkdd2*k2*s*(1 - 2*s) + Pkd2*(16*C*(r*(3 - 12*s) + 2*s**2 + 5*s - 3) - 28*K*(9*r*s - r + 11*s**2 - 6*s - 1) + 152*r*s - 38*r + 26*s**2 - 75*s + 24)))) - fd*(k1**4*(2*Pk2*(8*C*(r*(52*s - 7) + 7*s**2 - 33*s + 7) + K*(2*s - 1)*(31*r + 14*s - 6) - 128*r**2 - 600*r*s + 194*r - 174*s**2 + 351*s - 81) + Pkd2*k2*(2*K*(s - 1)*(24*r + 74*s - 37) + s**2*(224*C - 274) + s*(64*C*r - 32*C - 80*r + 115) - 25)) + k1**2*k2**2*(Pk2*(4*C*(458*r**2 + r*(460*s - 377) + 136*s**2 - 67*s + 48) + 4*K*(52*r**2 + r*(235*s - 143) + 162*s**2 - 189*s + 54) - 1480*r**2 - 1706*r*s + 1138*r - 388*s**2 + 275*s - 108) + 2*k2*(Pkd2*(8*C*(r*(44*s + 6) + 41*s**2 - 7*s - 6) + 28*K*r*(s - 1) + 13*K*(6*s**2 - 7*s + 2) - 218*r*s - 24*r - 189*s**2 + 43*s + 24) + Pkdd2*k2*s**2*(24*C - 12))) + 2*k2**4*(Pk2*(2*C*(56*r**2 - 14*r*(s + 4) + 9*s + 14) - 58*r**2 + 14*r*s + 57*r - 9*s - 14) + Pkd2*k2*s*(4*C - 2)*(2*r - 1))) + 4*k1**2*(-bd2*k2*(14*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*s*(2*r + 2*s - 1) + 7*Pkd2*k2**2*s*(3*r + 3*s - 2)) + gd2*(2*Pk2*k1**2*s*(9*r - 5*s + 6) + 7*Pk2*k2**2*(5*r**2 + 8*r*s - r + 5*s - 4) + 2*Pkd2*k1**2*k2*s*(2*r + 11*s - 1) + 7*Pkd2*k2**3*(9*r*s + 2*r + 11*s**2 - s - 2) + 7*Pkdd2*k2**4*s**2))) + 4*k1**2*(b2*(bd1*k2*(14*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + 7*Pkd2*k2**2*(r*(3*s - 1) + s*(3*s - 3))) + fd*(13*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(Pk2*(2*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)))) - g2*(2*bd1*k1**2*(3*Pk2*r*(3*s - 5) - 5*Pk2*s*(s - 1) + Pkd2*k2*r*(2*s - 1) + 11*Pkd2*k2*s*(s - 1)) + 7*bd1*k2**2*(Pk2*r*(5*r + 8*s - 9) + k2*(Pkd2*r*(9*s - 4) + 11*Pkd2*s*(s - 1) + Pkdd2*k2*s*(s - 1))) + fd*k1**2*(Pk2*(2*s - 1)*(31*r + 14*s - 6) + Pkd2*k2*(s - 1)*(24*r + 74*s - 37)) + fd*k2**2*(2*Pk2*(52*r**2 + r*(235*s - 143) + 162*s**2 - 189*s + 54) + Pkd2*k2*(28*r*(s - 1) + 78*s**2 - 91*s + 26)))))) + Dd*f*(33*b1*k2**2*(2*b1**2*k1**2*k2*(7*Pk2*k2*(12*r**2 + r*(16*s - 23) + 4*s**2 - 19*s + 11) + 2*Pkd2*k1**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*Pkd2*k2**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - b1*(Pk2*k2**4*(32*C - 16)*(3*r**2 - 4*r*(s + 1) + 3*s + 1) + 4*k1**4*(Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 20*K*s**2 - 17*K*s + 36*r**2 + r*(-36*K*s + 15*K + 36*s - 40) - 56*s**2 + 56*s - 4) + Pkd2*k2*(-14*C*(r*(8*s - 1) - 6*s + 1) - 44*K*s**2 + 13*K*s + r*(-8*K*s + K + 84*s - 7) + 60*s**2 - 71*s + 7)) + k1**2*k2**2*(2*Pk2*(8*C*(20*r**2 + r*(11 - 286*s) + 16*s**2 + 221*s - 31) - 7*K*(20*r**2 + 32*r*s + r + 26*s - 16) + 132*r**2 + 1410*r*s - 124*r - 52*s**2 - 796*s + 55) + k2*(14*K*Pkdd2*k2*s*(1 - 4*s) + Pkd2*(16*C*(r*(3 - 24*s) + 4*s**2 + 17*s - 3) - 14*K*(36*r*s + 2*r + 44*s**2 - 9*s - 6) + 304*r*s - 38*r + 52*s**2 - 185*s + 24)))) - 4*k1**2*(b2*k2*(-14*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pkd2*k1**2*(-8*r*s + r + s*(4 - 8*s)) + 7*Pkd2*k2**2*(-12*r*s + r + s*(7 - 12*s))) + g2*(2*Pk2*k1**2*(3*r*(12*s - 5) + s*(17 - 20*s)) + 7*Pk2*k2**2*(20*r**2 + 32*r*s + r + 26*s - 16) + 2*Pkd2*k1**2*k2*(r*(8*s - 1) + s*(44*s - 13)) + 7*Pkd2*k2**3*(r*(36*s + 2) + 44*s**2 - 9*s - 6) + 7*Pkdd2*k2**4*s*(4*s - 1)))) - 5*f**3*k1**6*(112*Pk2 - 61*Pkd2*k2)*(12*s**2 - 11*s + 2) + 33*f**2*k1**2*(5*b1*k1**4*s*(2*Pk2 + k2*(-2*Pkd2 + Pkdd2*k2))*(4*s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(4*s - 1)*(31*r + 22*s - 10) + 2*b1*(240*r**2 + r*(52*s - 283) - 132*s**2 + 37*s + 74) - 40*r**2 - 332*r*s + 103*r - 196*s**2 + 181*s - 33) + Pkd2*k2*(6*b1*(64*r*s + 32*r + 12*s - 27) + (s - 1)*(4*C*(40*r + 124*s - 51) - 80*r - 332*s + 123))) + 2*k2**4*(3*Pk2*(4*C*(32*r**2 + 144*r*s - 75*r + 92*s**2 - 113*s + 34) - 80*r**2 - 332*r*s + 169*r - 184*s**2 + 226*s - 68) + Pkd2*k2*(2*C - 1)*(56*r*(s - 1) + 132*s**2 - 149*s + 50))) + 33*f*k2**2*(-b1**2*k1**2*(k1**2*(4*Pk2*(180*r**2 + r*(168*s - 247) - 12*s**2 - 83*s + 79) + 3*k2*(Pkd2*(208*r*s + 8*r + 164*s**2 - 129*s - 8) + 6*Pkdd2*k2*s*(4*s - 1))) + k2**2*(4*Pk2*(356*r**2 + 422*r*s - 412*r + 84*s**2 - 208*s + 111) + 3*Pkd2*k2*s*(112*r + 52*s - 69))) + b1*(k1**4*(2*Pk2*(4*C*(4*r*(52*s - 9) + 28*s**2 - 139*s + 25) + K*(4*s - 1)*(31*r + 14*s - 6) - 256*r**2 - 1200*r*s + 472*r - 348*s**2 + 731*s - 183) + Pkd2*k2*(8*C*(2*r*(8*s - 1) + 56*s**2 - 22*s + 1) + 2*K*(s - 1)*(48*r + 148*s - 61) - 160*r*s + 8*r - 548*s**2 + 317*s - 29)) + k1**2*k2**2*(2*Pk2*(2*C*(916*r**2 + r*(920*s - 1029) + 272*s**2 - 362*s + 244) + K*(208*r**2 + 940*r*s - 492*r + 648*s**2 - 696*s + 210) - 1480*r**2 - 1706*r*s + 1578*r - 388*s**2 + 582*s - 327) + k2*(Pkd2*(8*C*(2*r*(88*s + 1) + 164*s**2 - 81*s - 13) + 112*K*r*(s - 1) + 6*K*(52*s**2 - 57*s + 18) - 872*r*s + 4*r - 756*s**2 + 409*s + 52) + Pkdd2*k2*s*(24*C - 12)*(4*s - 1))) + 4*k2**4*(Pk2*(2*C*(56*r**2 - 14*r*s - 53*r + 9*s + 12) - 58*r**2 + 14*r*s + 54*r - 9*s - 12) + Pkd2*k2*s*(4*C - 2)*(2*r - 1))) + 4*k1**2*(b2*(13*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(Pk2*(4*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(4*r + 4*s - 3))) - g2*(k1**2*(Pk2*(4*s - 1)*(31*r + 14*s - 6) + Pkd2*k2*(s - 1)*(48*r + 148*s - 61)) + k2**2*(Pk2*(208*r**2 + r*(940*s - 492) + 648*s**2 - 696*s + 210) + Pkd2*k2*(56*r*(s - 1) + 156*s**2 - 171*s + 54)))))))/(693*d**2*k1*k2**3*k3**4) - 160*D1**3*Pk3*f**3*k1**2*k2**2*st**8*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(1287*d**2*k3**6) + 20*D1**3*Pk3*f**3*k1**2*st**8*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(D1*fd + Dd*f)/(1287*d**2*k3**4) + 20*D1**3*Pk3*f*st**6*(D1*(f**2*(-858*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) + 13*bd1*k1**2*k2**2*(-2*Pk2*(3*r**2 + r*(9*s - 22) + 6*s**2 - 19*s + 21) + Pkd2*k2*(r*(3*s - 2) + 3*s**2 + s + 4)) - fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(405*r + 405*s - 307) + 26*fd*k1**2*k2**2*(Pk2*(112*r**2 + r*(16*s - 161) - 96*s**2 + 30*s + 49) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 13*f*k2**2*(b1*fd*(66*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(6*Pk2*(3*r**2 + 9*r*s - 16*r + 6*s**2 - 7*s + 5) + Pkd2*k2*(-9*r*s + 15*r - 9*s**2 - 12*s + 1))) + 2*k2**2*(66*Pk2*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 33*bd1*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + 2*fd*(Pk2*(2*C*(9*r + 3*s - 4) - 12*r - 3*s + 5) + Pkd2*k2*(2*C - 1)*(3*s - 1))*(3*r + 3*s - 2) - 66*gd2*(2*Pk2*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 1716*fd*k2**4*(2*r + 2*s - 1)*(K*b1*(-6*Pk2*r - 2*Pk2*s + Pk2 - 2*Pkd2*k2*s + Pkd2*k2) + 2*Pk2*b1*r + Pk2*b2*(-2*r - 2*s + 1) + 2*Pk2*g2*(6*r + 2*s - 1) + 2*Pkd2*g2*k2*(2*s - 1))) + Dd*f*(f**2*k1**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(405*r + 405*s - 307) + 26*k2**2*(Pk2*(112*r**2 + r*(16*s - 161) - 96*s**2 + 30*s + 49) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 13*f*k2**2*(b1*(-66*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(-4*Pk2*(6*r**2 + 18*r*s - 35*r + 12*s**2 - 20*s + 18) + Pkd2*k2*(12*r*s - 17*r + 12*s**2 + 13*s + 3))) - 2*k2**2*(Pk2*(4*C*(36*r**2 + 48*r*s - 44*r + 12*s**2 - 27*s + 13) - 96*r**2 - 120*r*s + 115*r - 24*s**2 + 64*s - 33) + Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 1716*k2**4*(Pk2*b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + b1*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + 7*r + 2*s - 1)) - 2*g2*(Pk2*(24*r**2 + 8*r*(4*s - 3) + 8*s**2 - 14*s + 5) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(9009*d**2*k3**6) + 5*D1**3*Pk3*f*st**6*(3*D1*bd1*f*(22*K*Pkdd2*k2**4*s*(1 - 2*s) + 48*Pk2*f*k1**2*s*(3*s - 1) + 18*Pkd2*f*k1**2*k2*s*(1 - 3*s) + 11*Pkd2*k2**3*(f*(r - 1)*(3*s - 2) + r*(8*s - 2) + (4*s - 2)*(5*K*s - 1)) + k2**2*(-11*Pk2*(f*(r - 1)*(7*s - 6) + 8*r*(4*s - 1) + (16*s - 8)*(2*K*s - 1)) + 2*Pkdd2*f*k1**2*s*(3*s - 1))) + 3*b1*(D1*fd*(f*(2*k1**2*(1 - 3*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + 11*k2**2*(Pk2*(r*(10 - 21*s) - 9*s + 2) + Pkd2*k2*(r*(9*s - 4) + s))) - 22*k2**2*(2*s - 1)*(K*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + r*(16*Pk2 - 4*Pkd2*k2))) + 2*Dd*f*(f*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(12*s**2 - 7*s + 1) + 11*k2**2*(-Pk2*(2*r*(7*s - 4) + s + 2) + Pkd2*k2*(r*(6*s - 3) - s + 1))) - 11*k2**2*(8*Pk2*(8*K*s**2 - 6*K*s + K + 8*r*s - 3*r - 2*s + 1) + k2*(K*Pkdd2*k2*(8*s**2 - 6*s + 1) + Pkd2*(-5*K*(8*s**2 - 6*s + 1) - 16*r*s + 6*r + 4*s - 2))))) - 2*k2**2*(D1*(2*C*f*fd*(1 - 3*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 33*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(bd2 - 2*gd2)*(2*s - 1) - fd*(f*(3*s - 1)*(24*Pk2*(-r + s) + 3*Pkd2*k2*(2*r - 5*s + 1) + Pkdd2*k2**2*(3*s - 1)) + 66*g2*(1 - 2*s)**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)))) + Dd*f*(f*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 24*s**2 + 4*s + 1) + k2*(Pkd2*(-10*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 60*s**2 - 25*s + 2) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) - 66*g2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(8*s**2 - 6*s + 1)) + 33*b2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(693*d**2*k2**2*k3**2) - 5*D1**3*Pk3*f*st**6*(D1*(f**2*(3432*Pk2*fd*k2**4*(2*r**2 - 3*r + 1) - 26*bd1*k1**2*k2**2*(4*Pk2*(r*(15*s - 8) + 3*s**2 - 11*s + 6) + k2*(Pkd2*(-15*r*s + 8*r + 15*s**2 + 11*s - 6) - 6*Pkdd2*k2*s**2)) + 429*bd1*k2**4*(r - 1)*(Pk2*(-4*r - 15*s + 10) + Pkd2*k2*(3*s - 2)) + 18*fd*k1**4*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + 26*fd*k1**2*k2**2*(3*Pk2*(6*r*(15*s - 4) + 96*s**2 - 77*s + 14) + k2*(-9*Pkd2*(10*r*s - 3*r + 12*s**2 - 10*s + 2) + Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 13*f*k2**2*(3*b1*fd*(2*k1**2*(4*Pk2*(5*r*(3*s - 1) + 3*s**2 + 4*s - 1) + k2*(Pkd2*(-15*r*s + 5*r + 15*s**2 - 22*s + 4) + Pkdd2*k2*(-6*s**2 + 6*s - 1))) - 11*k2**2*(-Pk2*(3*r - 1)*(4*r + 15*s - 10) + Pkd2*k2*(9*r*s - 4*r + s))) + 2*k2**2*(4*Pk2*fd*(C*(9*r**2 + r*(18 - 72*s) - 36*s**2 + 48*s - 11) - 18*r**2 + 36*r*s + 18*s**2 - 24*s + 4) + 33*bd1*(4*K*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + K*k2*(Pkd2*(4*r*(4*s - 1) + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1)) - 12*Pk2*r*(r - 1) + Pkd2*k2*(-4*r*s + r + 2*s - 1)) - 66*bd2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*k2*(3*s - 1)*(Pkd2*(2*C*(24*r + 9*s - 11) - 30*r - 9*s + 13) + Pkdd2*k2*(2*C - 1)*(3*s - 1)) - 66*gd2*(4*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + k2*(Pkd2*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + Pkdd2*k2*s*(2*s - 1))))) + 858*fd*k2**4*(-b1*(K*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))) + 4*r*(-6*Pk2*r + k2*(-2*Pkd2*s + Pkd2))) + 4*b2*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(2*r + 2*s - 1) + 2*g2*(8*Pk2*(r**2 + r*(4 - 8*s) - (1 - 2*s)**2) + k2*(2*s - 1)*(Pkd2*(16*r + 6*s - 3) + Pkdd2*k2*(2*s - 1))))) + 2*Dd*f*(f**2*(1716*Pk2*k2**4*(2*r**2 - 3*r + 1) + 9*k1**4*(1 - 4*s)**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)) + 13*k1**2*k2**2*(3*Pk2*(6*r*(15*s - 4) + 96*s**2 - 77*s + 14) + k2*(-9*Pkd2*(10*r*s - 3*r + 12*s**2 - 10*s + 2) + Pkdd2*k2*(12*s**2 - 7*s + 1)))) - 13*f*k2**2*(8*Pk2*k2**2*(C*(6*r**2 + r*(9 - 48*s) - 24*s**2 + 34*s - 7) - 12*r**2 + 3*r*(8*s + 1) + 12*s**2 - 17*s + 2) + b1*k1**2*(4*Pk2*(r*(60*s - 23) + 12*s**2 + s + 3) + k2*(Pkd2*(-60*r*s + 23*r + 60*s**2 - 55*s + 6) - 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) - 33*b1*k2**2*(-Pk2*(2*r - 1)*(4*r + 15*s - 10) + Pkd2*k2*(r*(6*s - 3) - s + 1)) + k2**3*(Pkd2*(2*C*(96*r*s - 28*r + 36*s**2 - 61*s + 15) - 120*r*s + 35*r - 36*s**2 + 71*s - 18) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) + 429*k2**4*(-b1*(8*K*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + K*k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1)) + 24*Pk2*r*(1 - 2*r) - 2*Pkd2*k2*(r*(8*s - 3) - 2*s + 1)) + 4*b2*(2*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 2*g2*(8*Pk2*(2*r**2 + r*(5 - 16*s) - 8*s**2 + 10*s - 3) + k2*(Pkd2*(8*r*(8*s - 3) + 24*s**2 - 34*s + 11) + Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(9009*d**2*k2**2*k3**4) + 2*D1**3*Pk3*st**4*(-2*D1*bd1*f*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(b2 - 2*g2)*(s - 1) + b1**2*(D1*fd*(f*(Pk2*(-2*r*(s - 2) - 7*s + 2) + Pkd2*k2*(2*r*(s - 1) + s)) + (s - 1)*(-2*K*(s - 1)*(8*Pk2 - 5*Pkd2*k2 + Pkdd2*k2**2) - 16*Pk2*r + 4*Pkd2*k2*r)) - 2*Dd*f*(K*Pkdd2*k2**2*(4*s**2 - 5*s + 1) + Pk2*f*(2*r*(s - 4) + 7*s + 2) + 4*Pk2*(2*K*(4*s**2 - 5*s + 1) + r*(8*s - 5) - 2*s + 2) - Pkd2*k2*(5*K*(4*s**2 - 5*s + 1) + f*(r*(2*s - 3) + s + 1) + 8*r*s - 5*r - 2*s + 2))) + b1*(D1*bd1*f*(-Pk2*(f*(2*r*(s - 6) + 7*s + 6) + 8*r*(4*s - 2) + 8*(s - 1)*(4*K*s - 1)) + k2*(-4*K*Pkdd2*k2*s*(s - 1) + Pkd2*(f*(2*r*(s - 2) + s + 2) + r*(8*s - 4) + (2*s - 2)*(10*K*s - 1)))) + (-16*Pk2 - 2*k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*b2*fd*(s - 1) + D1*f*s*(bd2 - 2*gd2) - 2*D1*fd*g2*(s - 1) + Dd*b2*f*(4*s - 1) + 2*Dd*f*g2*(1 - 4*s))))/(7*d**2*k2**2) + D1**3*Pk3*st**2*(33*b1**3*k2*(D1*fd*s*(21*Pk2*k2*(r - 1) - 2*Pkd2*k1**2*s + 7*Pkd2*k2**2*(r - 1) + 2*Pkdd2*k1**2*k2*s) + 2*Dd*f*(Pkd2*k1**2*s*(1 - 4*s) + 7*Pkd2*k2**2*(r*(2*s - 1) - 3*s + 1) + k2*s*(21*Pk2*(2*r - 1) + Pkdd2*k1**2*(4*s - 1)))) + 33*b1**2*(D1*bd1*f*k2*(2*Pkd2*k1**2*s*(1 - 3*s) + 7*Pkd2*k2**2*(r*(3*s - 2) - 5*s + 2) + k2*s*(21*Pk2*(3*r - 1) + 2*Pkdd2*k1**2*(3*s - 1))) + D1*fd*(k1**2*(Pk2*(-4*K*(s - 1)**2 + f*(36*r*s + 64*s**2 + s - 8) + 8*r*s + 48*s**2 - 8*s + 4) + k2*(2*K*Pkdd2*k2*s**2 - Pkd2*f*(40*s**2 + s*(12*r + 11) - 6) - 2*Pkd2*s*(2*r + s*(K + 11)) + 2*Pkdd2*f*k2*(4*s**2 + 3*s - 1))) - 2*k2**2*(Pk2*(4*C*(r - 1)**2 + 14*K*r**2 - 49*K*r*s + 28*K*r + f*(56*r**2 - 61*r + 13) - 4*r**2 - 6*r - 4) + k2*(8*C*Pkd2*r*s + 6*C*Pkd2*s**2 - 8*C*Pkd2*s + 2*C*Pkdd2*k2*s**2 + 7*K*(Pkd2*r*(3*s - 4) - 2*Pkd2*s + Pkd2 + Pkdd2*k2*(1 - 2*s)) + 7*Pkd2*f*(2*r - 1) - 6*Pkd2*r*s + 14*Pkd2*r - 3*Pkd2*s**2 + 6*Pkd2*s - Pkdd2*k2*s**2))) + 2*Dd*f*k1**2*(2*Pk2*(K*(-4*s**2 + 5*s - 1) + f*(6*r*(3*s + 1) + 32*s**2 - 5*s - 6) + 8*r*s - r + 48*s**2 - 18*s + 1) + k2*(K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(-8*r*s + r + s*(-4*K*s + K - 44*s + 13)) - f*(Pkd2*(12*r*s + 6*r + 40*s**2 - 7) + Pkdd2*k2*(-8*s**2 - 2*s + 1)))) - 2*Dd*f*k2**2*(2*Pk2*(4*C*(2*r**2 - 3*r + 1) + 28*K*r**2 - 98*K*r*s + 21*K*s + 4*f*(14*r**2 - 17*r + 5) - 8*r**2 + 12*r - 4) + k2*(Pkd2*(C*(32*r*s - 4*r + 24*s**2 - 30*s + 4) + 84*K*r*s - 56*K*r - 70*K*s + 35*K + 28*f*r - 14*f - 24*r*s + 31*r - 12*s**2 + 21*s - 17) - Pkdd2*k2*(4*s - 1)*(-2*C*s + 7*K + s)))) + 33*b1*(D1*bd1*f*(-4*Pk2*k1**2*(-4*r*s + r + s*(2*K*(s - 1) - 24*s + 14)) - 2*Pkd2*k1**2*k2*(r*(4*s - 1) + s*(K*(2*s - 1) + 22*s - 12)) - 2*Pkd2*k2**3*(2*C*(r*(8*s - 2) + 6*s**2 - 7*s + 2) + 14*K*(3*r*s - r - 2*s + 1) - 12*r*s + 10*r - 6*s**2 + 9*s - 10) - 2*Pkdd2*k2**4*s*(C*(4*s - 2) - 7*K - 2*s + 1) + f*(k1**2*(Pk2*(12*r*(3*s + 2) + 64*s**2 - 21*s - 16) + k2*(Pkd2*(-12*r*(s + 1) - 40*s**2 + 11*s + 8) + 2*Pkdd2*k2*s*(4*s - 1))) - 2*k2**2*(Pk2*(56*r**2 - 75*r + 27) + 7*Pkd2*k2*(2*r - 1))) - 2*k2**2*(K*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(21*K*s + r**2*(8*C + 28*K - 8) - 2*r*(4*C + 49*K*s + 7*K - 11)))) + D1*(3*f**2*fd*k1**2*(2*Pk2*(6*r - 36*s**2 + 27*s - 8) + 3*Pkd2*k2*(r*(6*s - 4) + 12*s**2 - 13*s + 4)) - 2*f*(-bd2*k2*s*(21*Pk2*k2*(r - 1) - Pkd2*k1**2*s + 7*Pkd2*k2**2*(r + s + 1) + Pkdd2*k1**2*k2*s + 7*Pkdd2*k2**3*s) + fd*(k1**2*(4*Pk2*(C*(2*s**2 - 3*s + 1) + K*(1 - 2*s)**2 + 4*r*s - 3*r + 11*s**2 - 8*s + 1) + k2*(Pkd2*(8*C*s**2 + K*(-10*s**2 + 11*s - 3) + 4*r*s + 3*r + 3*s - 2) + Pkdd2*k2*(K*(2*s**2 - 3*s + 1) + s**2*(4 - 8*C)))) + k2**2*(-Pk2*(2*C*(4*r**2 + r*(4 - 42*s) + 27*s - 6) + 28*K*r**2 + 6*K*r*(8*s - 3) + 36*K*(1 - 2*s)**2 + 6*r**2 + 30*r*s - 14*r - 27*s + 10) + k2*(Pkd2*(2*C*(6*r*(s + 1) - 4*s - 3) + K*r*(28 - 42*s) - 3*K*(1 - 2*s)**2 - 6*r*s - 9*r + 4*s + 4) + Pkdd2*k2*(2*C - 1)*(3*s - 1)))) + 2*gd2*(-2*Pk2*k1**2*s*(s - 1) - Pkd2*k1**2*k2*s**2 - 7*Pkd2*k2**3*(r*(3*s - 2) - 4*s + 2) + 7*Pkdd2*k2**4*s + k2**2*(-7*Pk2*(2*r**2 - 7*r*s - 2*r + 3*s) + Pkdd2*k1**2*s**2))) + 2*fd*(b2*k2*s*(-Pkd2*k1**2*s + 7*Pkd2*k2**2*(r + s) + 7*Pkdd2*k2**3*s + k2*(21*Pk2*r + Pkdd2*k1**2*s)) + 2*g2*(k1**2*(2*Pk2*(s - 1)**2 + k2*s**2*(Pkd2 - Pkdd2*k2)) - 7*k2**2*(Pk2*r*(-2*r + 7*s - 4) - Pkd2*k2*(3*r*s - 4*r - 2*s + 1) + Pkdd2*k2**2*(2*s - 1))))) + 2*Dd*f*(b2*k2*(Pkd2*k1**2*s*(1 - 4*s) + 7*Pkd2*k2**2*(4*r*s - 2*r + 4*s**2 + s) + 7*Pkdd2*k2**3*s*(4*s - 1) + k2*s*(42*Pk2*(2*r - 1) + Pkdd2*k1**2*(4*s - 1))) + 3*f**2*k1**2*(2*Pk2*(5*r - 24*s**2 + 16*s - 5) + Pkd2*k2*(4*r*(3*s - 2) + 24*s**2 - 24*s + 7)) - f*(k1**2*(2*Pk2*(2*C*(4*s**2 - 5*s + 1) + 2*K*(8*s**2 - 6*s + 1) + 16*r*s - 8*r + 44*s**2 - 23*s + 5) + k2*(Pkd2*(16*C*s**2 - 4*C*s + K*(-20*s**2 + 17*s - 3) + 8*r*s + 3*r + 2*s - 3) + Pkdd2*k2*(4*s - 1)*(-4*C*s + K*(s - 1) + 2*s))) + k2**2*(-2*Pk2*(2*C*(4*r**2 - 42*r*s + r + 27*s - 3) + K*(28*r**2 + 48*r*s - 11*r + 144*s**2 - 90*s + 6) + 6*r**2 + 30*r*s - 11*r - 27*s + 7) + k2*(Pkd2*(2*C*(2*r - 1)*(6*s + 1) + K*(-84*r*s + 56*r - 24*s**2 + 60*s - 31) + (3 - 6*r)*(2*s + 1)) + Pkdd2*k2*(2*C - 1)*(4*s - 1)))) + 2*g2*(k1**2*(4*s - 1)*(2*Pk2*(s - 1) + k2*s*(Pkd2 - Pkdd2*k2)) - 7*k2**2*(-2*Pk2*(4*r**2 - 14*r*s + 3*s) + Pkd2*k2*(-12*r*s + 8*r + 10*s - 5) + Pkdd2*k2**2*(4*s - 1))))) + f*(33*D1*bd1*(2*b2*k2*(-Pkd2*k1**2*s*(s - 1) + 7*Pkd2*k2**2*(r*(s - 2) + s*(s - 1)) + 7*Pkdd2*k2**3*s*(s - 1) + k2*s*(21*Pk2*r + Pkdd2*k1**2*(s - 1))) + 3*f**2*k1**2*(2*Pk2*(4*r - 12*s**2 + 5*s - 2) + Pkd2*k2*(r*(6*s - 4) + 12*s**2 - 9*s + 2)) - 2*f*(k1**2*(Pk2*(s**2*(4*C + 8*K + 22) - s*(4*C + 4*K - 8*r + 4) + 2) - k2*(Pkd2*(-2*r*s + r + s*(-4*C*s + 4*C + 5*K*s - 3*K + 1)) + Pkdd2*k2*s*(s - 1)*(4*C - K - 2))) + k2**2*(K*(-2*Pk2*(7*r**2 + 12*r*s - r + 36*s**2 - 9*s - 6) + Pkd2*k2*(-21*r*s + 14*r - 6*s**2 + 24*s - 14)) + Pk2*(-r**2*(4*C + 3) + r*s*(42*C - 15) + r + s*(6 - 12*C)) + Pkd2*k2*(2*C - 1)*(3*r - 2)*(s - 2))) + 4*g2*(2*Pk2*k1**2*s*(s - 1) + Pkd2*k1**2*k2*s*(s - 1) + 21*Pkd2*k2**3*r*s + k2**2*(7*Pk2*r*(2*r - 7*s) - Pkdd2*k1**2*s*(s - 1)))) - 2*D1*(f*fd*(k1**2*(2*Pk2*(132*C*(1 - 3*s)**2 + 9*r*(49*s - 31) - 312*s + 148) + 33*k2*(2*C*(3*s - 1)*(Pkd2*(3 - 7*s) + Pkdd2*k2*(s - 1)) + 2*Pkd2*(-3*r*s + 2*r + 6*s**2 - 3*s) - Pkdd2*k2*(3*s**2 - 4*s + 1))) + k2**2*(Pk2*(4*C*(486*r**2 + 1485*r*s - 852*r - 594*s + 263) - (3*r - 1)*(423*r + 1188*s - 526)) + Pkd2*k2*(66*C - 33)*(r*(9*s - 6) + 18*s**2 - 18*s + 5))) - 33*f*(bd2 - 2*gd2)*(4*Pk2*k1**2*s*(1 - 2*s) + Pkd2*k1**2*k2*s*(5*s - 3) + Pkd2*k2**3*(7*r*(3*s - 2) + 6*s**2 - 24*s + 14) + k2**2*(2*Pk2*(7*r**2 + 12*r*s - r + 36*s**2 - 9*s - 6) - Pkdd2*k1**2*s*(s - 1))) - 66*fd*g2*k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 66*fd*g2*k2**2*(28*Pk2*r**2 + 6*Pk2*r*(8*s - 3) + 36*Pk2*(1 - 2*s)**2 + 14*Pkd2*k2*r*(3*s - 2) + 3*Pkd2*k2*(1 - 2*s)**2)) - 2*Dd*f*(f*k1**2*(2*Pk2*(132*C*(12*s**2 - 7*s + 1) + 588*r*s - 353*r - 476*s + 222) + 33*k2*(-Pkd2*(C*(56*s**2 - 38*s + 6) + 8*r*s - 5*r - 16*s**2 + 6*s + 1) + Pkdd2*k2*(2*C - 1)*(4*s**2 - 5*s + 1))) + f*k2**2*(2*Pk2*(2*C*(648*r**2 + 1980*r*s - 1079*r - 792*s + 328) - 846*r**2 - 2376*r*s + 1277*r + 792*s - 328) + Pkd2*k2*(66*C - 33)*(4*r*(3*s - 2) + 24*s**2 - 24*s + 7)) - 66*g2*k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) + 66*g2*k2**2*(2*Pk2*(28*r**2 + r*(48*s - 11) + 144*s**2 - 90*s + 6) + Pkd2*k2*(28*r*(3*s - 2) + 24*s**2 - 60*s + 31))) - 66*b2*(D1*fd*(k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) - k2**2*(28*Pk2*r**2 + 6*Pk2*r*(8*s - 3) + 36*Pk2*(1 - 2*s)**2 + 14*Pkd2*k2*r*(3*s - 2) + 3*Pkd2*k2*(1 - 2*s)**2)) + Dd*f*(k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))) - k2**2*(2*Pk2*(28*r**2 + 48*r*s - 11*r + 144*s**2 - 90*s + 6) + Pkd2*k2*(84*r*s - 56*r + 24*s**2 - 60*s + 31))))))/(693*d**2*k2**2*k3**2) + D1**3*Pk3*(D1*bd1*f*(14*b1**2*k2**2*(Pk2*k2**2*(3*r - 1)*(r + s - 1) + 2*k1**2*(Pk2*(6*r**2 + 9*r*s - 11*r + 3*s**2 - 10*s + 5) + Pkd2*k2*s*(3*r + 3*s - 2))) + 2*b1*(-4*Pk2*k1**4*(r*(4*s - 1) + s*(-2*K*s + K + 6*s - 4)) + 2*k1**2*k2**2*(2*Pk2*(2*C*(r*(146*s - 47) - 8*s**2 - 90*s + 47) + 28*K*s**2 - 14*K*s + r**2*(14*K - 14) + r*(7*K*(8*s - 5) - 191*s + 81) - 9*s**2 + 93*s - 46) + 7*Pkd2*k2*s*(K*(4*r + 8*s - 6) - 2*s + 1)) + k2**4*(7*K*Pkd2*k2*s*(2*s - 1) + Pk2*(-24*C*(2*r**2 - 12*r*s + r + 6*s - 3) + 28*K*s**2 - 49*K*s + r**2*(56*K + 10) + 2*r*(7*K*(9*s - 4) - 79*s + 13) + 72*s - 36))) + 28*b2*k2**2*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))*(r + s - 1) + f**2*k1**4*(5*Pk2*r*(23*s - 24) + 8*Pk2*(s**2 - 10*s + 9) + 60*Pkd2*k2*r*s + 44*Pkd2*k2*s*(s - 1)) - f*(8*k1**4*(Pk2*(b1*(2*s - 1)*(3*r + 3*s - 2) + r*(4*s - 2) - (s - 1)*(s*(4*C - 8) + 1)) + 3*Pkd2*b1*k2*s*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(-16*C*(22*r**2 + r*(65*s - 60) + 30*s**2 - 52*s + 22) + b1*(984*r**2 + 2*r*(737*s - 735) + 544*s**2 - 1011*s + 490) + 224*r**2 - 2*r*(52*K*s - 389*s + 352) - 2*(6*s - 6)*(9*K*s - 29*s + 18)) + 2*Pkd2*k2*s*(-48*C*(r + 2*s - 2) - 13*K*s + 13*K + 6*b1*(21*r + 13*s - 17) + 24*r + 60*s - 60)) + 2*k2**4*(Pk2*(-2*C*(140*r**2 + r*(185*s - 164) + 54*s**2 - 102*s + 48) + 155*r**2 + 3*r*(66*s - 59) + 54*s**2 - 102*s + 48) - Pkd2*k2*s*(2*C - 1)*(18*r + 13*s - 13))) - 4*g2*(4*Pk2*k1**4*s*(s - 1) + 28*k1**2*k2**2*(Pk2*(r**2 + 4*r*(s - 1) + s*(2*s - 2)) + Pkd2*k2*s*(r + 2*s - 2)) + 7*k2**4*(Pk2*(4*r**2 + r*(9*s - 4) + s*(2*s - 2)) + Pkd2*k2*s*(s - 1)))) + 14*b1**3*k2**2*(D1*fd*(Pk2*k2**2*(r - 1) + 2*k1**2*(Pk2*(2*r + s - 2) + Pkd2*k2*s))*(r + s - 1) + 2*Dd*f*(Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(Pk2*(8*r**2 + 3*r*(4*s - 5) + 4*s**2 - 13*s + 7) + Pkd2*k2*s*(4*r + 4*s - 3)))) - b1**2*(D1*fd*(-14*K*Pkd2*k2**5*s**2 - 8*Pk2*k1**4*s*(-2*r + s*(K - 3)) - 4*Pk2*k1**2*k2**2*(r**2*(14*K - 14) + r*s*(292*C + 56*K - 191) + s*(-4*C*(4*s + 73) + 28*K*s - 9*s + 142)) - 2*Pk2*k2**4*(-24*C*(r - 1)*(r - 6*s - 1) + 7*K*(4*r**2 + 9*r*s + 2*r + 2*s**2 + 4*s - 2) + 5*r**2 - 79*r*s - 24*r + 72*s + 12) - 28*Pkd2*k1**2*k2**3*s*(2*K*(r + 2*s) - s) + f*k1**2*(16*Pk2*k1**2*s*(3*r + 3*s - 2) + Pk2*k2**2*(984*r**2 + 22*r*(67*s - 53) + 544*s**2 - 791*s + 350) + 24*Pkd2*k1**2*k2*s*(4*r + 4*s - 3) + 6*Pkd2*k2**3*s*(42*r + 26*s - 21))) + 2*Dd*f*(4*Pk2*k1**4*(r*(8*s - 1) + s*(-4*K*s + K + 12*s - 5)) + f*(4*k1**4*(Pk2*(4*s - 1)*(3*r + 3*s - 2) + 6*Pkd2*k2*s*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(984*r**2 + 2*r*(737*s - 659) + 544*s**2 - 901*s + 420) + 3*Pkd2*k2*s*(84*r + 52*s - 55))) - 2*k1**2*k2**2*(Pk2*(4*C*(r*(292*s - 47) - 16*s**2 - 236*s + 47) + 112*K*s**2 - 28*K*s + r**2*(56*K - 56) + 4*r*(7*K*(8*s - 3) - 191*s + 44) - 36*s**2 + 463*s - 92) + 7*Pkd2*k2*s*(8*K*(r + 2*s - 1) - 4*s + 1)) + k2**4*(7*K*Pkd2*k2*s*(1 - 4*s) + Pk2*(24*C*(4*r**2 - 3*r*(8*s + 1) + 18*s - 1) - 14*K*(8*r**2 + 18*r*s - 5*r + 4*s**2 - 4*s - 1) - 20*r**2 + 316*r*s + 15*r - 216*s + 12)))) + b1*(D1*(f**2*fd*k1**4*(Pk2*(24*s**2 + s*(345*r - 190) - 4) + 2*Pkd2*k2*(66*s**2 + s*(90*r - 16) - 11)) + 2*f*(14*bd2*k2**2*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))*(r + s - 1) + fd*(16*Pk2*k1**4*s*(-2*r + s*(2*C - 4) + 1) + k1**2*k2**2*(Pk2*(8*C*(44*r**2 + 2*r*(65*s - 22) + 60*s**2 - 60*s + 11) + 2*K*(2*s - 1)*(26*r + 27*s - 27) - 224*r**2 - 778*r*s + 213*r - 348*s**2 + 284*s - 44) + Pkd2*k2*(13*K*(2*s**2 - 3*s + 1) + 24*s*(C*(4*r + 8*s - 2) - 2*r - 5*s + 1))) + k2**4*(Pk2*(C*(560*r**2 + 740*r*s - 388*r + 216*s**2 - 210*s + 28) - 310*r**2 - 396*r*s + 209*r - 108*s**2 + 105*s - 14) + Pkd2*k2*s*(4*C - 2)*(18*r + 13*s - 9))) - 2*gd2*(4*Pk2*k1**4*s**2 + 28*k1**2*k2**2*(Pk2*(r**2 + 4*r*s - r + 2*s**2) + Pkd2*k2*s*(r + 2*s - 1)) + 7*k2**4*(Pk2*(4*r**2 + r*(9*s - 4) + s*(2*s - 5)) + Pkd2*k2*s**2))) - 4*fd*(-7*b2*k2**2*(r + s)*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s)) + g2*(4*Pk2*k1**4*s**2 + 28*Pk2*k1**2*k2**2*(r**2 + 4*r*s + 2*s**2) + 7*Pk2*k2**4*(4*r**2 + 9*r*s + 2*r + 2*s**2 + 4*s - 2) + 28*Pkd2*k1**2*k2**3*s*(r + 2*s) + 7*Pkd2*k2**5*s**2))) + 2*Dd*f*(14*b2*k2**2*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))*(4*r + 4*s - 3) + f**2*k1**4*(Pk2*(10*r*(23*s - 6) + 16*s**2 - 135*s + 34) + Pkd2*k2*(88*s**2 + s*(120*r - 38) - 11)) + f*(4*Pk2*k1**4*(r*(2 - 16*s) + s**2*(16*C - 32) - s*(4*C - 16) - 1) + k1**2*k2**2*(Pk2*(8*C*(88*r**2 + 260*r*s - 137*r + 120*s**2 - 150*s + 44) + 2*K*(4*s - 1)*(26*r + 27*s - 27) - 448*r**2 - 1556*r*s + 721*r - 696*s**2 + 742*s - 196) + Pkd2*k2*(13*K*(4*s**2 - 5*s + 1) + 12*s*(16*C*(r + 2*s - 1) - 8*r - 20*s + 9))) + k2**4*(Pk2*(4*C*(280*r**2 + 370*r*s - 269*r + 108*s**2 - 158*s + 51) - 620*r**2 - 792*r*s + 581*r - 216*s**2 + 316*s - 102) + Pkd2*k2*s*(2*C - 1)*(72*r + 52*s - 49))) - 2*g2*(4*Pk2*k1**4*s*(4*s - 1) + 56*Pk2*k1**2*k2**2*(2*r**2 + r*(8*s - 3) + s*(4*s - 1)) + 14*Pk2*k2**4*(8*r**2 + r*(18*s - 5) + 4*s**2 - 4*s - 1) + 112*Pkd2*k1**2*k2**3*s*(r + 2*s - 1) + 7*Pkd2*k2**5*s*(4*s - 1)))) + 2*f*k1**2*k2**2*(D1*(f*(fd*(3*s - 1)*(Pk2*(88*C*r + 92*C*(s - 1) - 55*r - 46*s + 46) + Pkd2*k2*(22*C - 11)*(s - 1)) + 2*s*(13*Pk2*bd2*(r + s - 1) + Pk2*gd2*(-52*r - 54*s + 54) - 13*Pkd2*gd2*k2*(s - 1))) - 2*fd*g2*(2*s - 1)*(52*Pk2*r + 54*Pk2*(s - 1) + 13*Pkd2*k2*(s - 1))) + Dd*f*(4*s - 1)*(Pk2*f*(88*C*r + 92*C*(s - 1) - 55*r - 46*s + 46) - 4*Pk2*g2*(26*r + 27*s - 27) + Pkd2*f*k2*(22*C - 11)*(s - 1) - 26*Pkd2*g2*k2*(s - 1)) + 26*Pk2*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(r + s - 1)))/(21*d**2*k2**2*k3**4) - 4*D1**3*Pk3*st**4*(D1*(10296*b1*fd*k2**6*(Pk2*b2*(r + s)**2 + b1*(K*Pk2*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + K*Pkd2*k2*s*(r + s) - Pk2*r*(r + s)) - 2*g2*(Pk2*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s))) + f**3*(39*bd1*k2**2*(66*Pk2*k1**2*k2**2*(4*r**2 + r*(9*s - 8) + 5*s**2 - 11*s + 4) + 11*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 8*k1**4*(Pk2*(21*r**2 + 54*r*s - 43*r + 33*s**2 - 53*s + 16) + Pkd2*k2*(-6*r*s + 7*r - 6*s**2 + 12*s - 4))) + 2*fd*k1**2*(65*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(95*r + 95*s - 81) + 39*k1**2*k2**2*(-Pk2*(280*r**2 + r*(1300*s - 619) + 1020*s**2 - 1183*s + 309) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 39*f**2*k2**2*(-b1*(66*bd1*k2**2*(4*Pk2*k2**2*(r - 1) - k1**2*(2*Pk2 + Pkd2*k2*(1 - 2*s)))*(r + s - 1) + fd*(66*Pk2*k1**2*k2**2*(12*r**2 + r*(27*s - 13) + 15*s**2 - 22*s + 5) + 11*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 8*k1**4*(3*Pk2*(21*r**2 + 54*r*s - 26*r + 33*s**2 - 34*s + 9) - 2*Pkd2*k2*(3*s + 2)*(3*r + 3*s - 2)))) + 12*k2**2*(22*Pk2*bd2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1) - Pk2*fd*k2**2*(2*C - 1)*(3*r - 1)*(r + 12*s + 3) + 11*bd1*(K*Pkd2*k1**2*k2*s*(r + s) + K*Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*k1**2*(r**2*(4*K - 1) + r*(4*K - 1)*(2*s - 1) + s*(4*K*s - 6*K - s + 2)) + Pk2*k2**2*(2*K*(7*r**2 + 11*r*s - 10*r + 4*s**2 - 8*s + 3) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + fd*k1**2*(Pk2*(2*C*(72*r**2 + 111*r*s - 96*r + 72*s**2 - 85*s + 32) - 90*r**2 - 147*r*s + 120*r - 90*s**2 + 109*s - 40) + Pkd2*k2*(4*C - 2)*(3*s - 1)*(3*r + 3*s - 2)) - 22*gd2*(2*Pk2*k1**2*(2*r**2 + r*(4*s - 2) + s*(2*s - 3)) + 2*Pk2*k2**2*(7*r**2 + r*(11*s - 10) + 4*s**2 - 8*s + 3) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2)))) + 5148*f*k2**4*(2*Pk2*b2*bd1*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*Pk2*b2*fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*(Pk2*k2**2*(r - 1)*(2*r + 2*s - 1) + k1**2*(Pk2 + Pkd2*k2*s)*(r + s - 1)) + b1*(-8*K*Pk2*fd*k1**2*r**2 - 16*K*Pk2*fd*k1**2*r*s + 2*K*Pk2*fd*k1**2*r - 8*K*Pk2*fd*k1**2*s**2 + 4*K*Pk2*fd*k1**2*s - 28*K*Pk2*fd*k2**2*r**2 - 44*K*Pk2*fd*k2**2*r*s + 22*K*Pk2*fd*k2**2*r - 16*K*Pk2*fd*k2**2*s**2 + 16*K*Pk2*fd*k2**2*s - 4*K*Pk2*fd*k2**2 - 2*K*Pkd2*fd*k1**2*k2*r*s + K*Pkd2*fd*k1**2*k2*r - 2*K*Pkd2*fd*k1**2*k2*s**2 + K*Pkd2*fd*k1**2*k2*s - 8*K*Pkd2*fd*k2**3*r*s + 4*K*Pkd2*fd*k2**3*r - 8*K*Pkd2*fd*k2**3*s**2 + 8*K*Pkd2*fd*k2**3*s - 2*K*Pkd2*fd*k2**3 + 2*Pk2*bd2*k2**2*r**2 + 4*Pk2*bd2*k2**2*r*s - 2*Pk2*bd2*k2**2*r + 2*Pk2*bd2*k2**2*s**2 - 2*Pk2*bd2*k2**2*s + 2*Pk2*fd*k1**2*r**2 + 4*Pk2*fd*k1**2*r*s + 2*Pk2*fd*k1**2*s**2 - Pk2*fd*k1**2*s + 8*Pk2*fd*k2**2*r**2 + 8*Pk2*fd*k2**2*r*s - 4*Pk2*fd*k2**2*r + bd1*k2**2*(K*(2*Pk2*(4*r**2 + r*(8*s - 3) + 4*s**2 - 3*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s)) - 2*gd2*k2**2*(Pk2*(4*r**2 + 8*r*s - 2*r + 4*s**2 - 2*s - 2) + Pkd2*k2*s*(2*r + 2*s - 1))) + 2*bd1*g2*k2**2*(-4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))) + 2*fd*g2*(2*Pk2*k1**2*(4*r**2 + r*(8*s - 1) + 2*s*(2*s - 1)) + 2*Pk2*k2**2*(14*r**2 + 11*r*(2*s - 1) + 2*(1 - 2*s)**2) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(2*s - 1)*(2*r + 2*s - 1)))) + 2*Dd*f*(2574*b1*k2**6*(2*Pk2*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(2*K*Pk2*(8*r**2 + 2*r*(8*s - 1) + 8*s**2 - 2*s - 3) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(2*Pk2*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))) + f**3*k1**2*(65*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(95*r + 95*s - 81) + 39*k1**2*k2**2*(-Pk2*(280*r**2 + r*(1300*s - 619) + 1020*s**2 - 1183*s + 309) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) + 39*f**2*k2**2*(33*Pk2*b1*k1**2*k2**2*(16*r**2 + 3*r*(12*s - 7) + 20*s**2 - 33*s + 9) + 11*Pk2*b1*k2**4*(2*r - 1)*(5*r + 5*s - 3) + Pk2*k2**4*(48*C - 24)*(r**2 + 3*r*(4*s + 1) - 5*s - 2) + 4*b1*k1**4*(Pk2*(84*r**2 + r*(216*s - 121) + 132*s**2 - 155*s + 43) + Pkd2*k2*(-r*(24*s + 5) - 24*s**2 + 12*s + 4)) + 6*k1**2*k2**2*(-2*Pk2*(2*C*(48*r**2 + 74*r*s - 68*r + 48*s**2 - 57*s + 24) - 60*r**2 - 98*r*s + 85*r - 60*s**2 + 74*s - 30) - Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 1287*f*k2**4*(-4*Pk2*b2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2*(2*Pk2*k2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*(4*s - 1)*(r + s - 1)) - 2*b1*(K*Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*K*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*k1**2*(r**2*(16*K - 4) + 2*r*(K*(16*s - 5) - 4*s + 1) + s*(16*K*(s - 1) - 4*s + 5)) + 2*Pk2*k2**2*(K*(28*r**2 + 44*r*s - 31*r + 16*s**2 - 24*s + 8) - 8*r**2 - 8*r*s + 7*r + 2*s - 1)) + 4*g2*(2*Pk2*k1**2*(8*r**2 + r*(16*s - 5) + s*(8*s - 8)) + 2*Pk2*k2**2*(28*r**2 + 44*r*s - 31*r + 16*s**2 - 24*s + 8) + Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(9009*d**2*k2**2*k3**6) - 4*D1**3*Pk3*st**2*(D1*bd1*f*(f**2*k1**2*(-99*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(9*s + 1) + 135*s**2 - 136*s + 1) + 66*k1**2*k2**2*(-Pk2*(11*r**2 + r*(29*s - 20) + 18*s**2 - 29*s + 7) + Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) + 33*f*k2**2*(k1**4*(-2*Pk2*(-8*C*r*s + 4*C*s + 2*K*(r**2 + 4*r*s - 3*r + 3*s**2 - 5*s + 2) - b1*(28*r**2 + r*(56*s - 43) + 28*s**2 - 43*s + 15) + 2*r*s + r - 2*s**2 + s - 1) + Pkd2*b1*k2*(r*(46*s - 7) + 46*s**2 - 45*s + 3)) - 2*k1**2*k2**2*(Pk2*(2*C*(32*r**2 + 84*r*s - 65*r + 46*s**2 - 71*s + 27) - 10*K*r**2 + 22*K*r + 10*K*s**2 + 20*K*s - 12*K - b1*(40*r**2 + r*(56*s - 47) + 16*s**2 - 47*s + 19) - 36*r**2 - 92*r*s + 74*r - 50*s**2 + 80*s - 31) + Pkd2*k2*(2*C*(9*r*s - 3*r + 9*s**2 - 10*s + 1) - 5*K*r*s + 3*K*r - 5*K*s**2 + 8*K*s - 3*K + b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) - 9*r*s + 3*r - 9*s**2 + 10*s - 1)) + k2**4*(Pk2*(4*C*(10*r**2 + r*(16*s - 9) + 4*s**2 - 5*s + 1) - 2*K*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + b1*(2*r - 1)*(3*r + 3*s - 1) - 24*r**2 - 4*r*(9*s - 5) - 8*s**2 + 10*s - 2) + Pkd2*k2*(4*C - 2)*(r*(2*s - 1) + s*(2*s - 2)))) - 66*k2**4*(13*Pk2*b1**2*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*b2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(2*K*k1**2*(Pk2*(50*r**2 + 2*r*(63*s - 26) + 76*s**2 - 72*s - 1) + Pkd2*k2*(r*(13*s - 5) + s*(13*s - 8))) + 7*K*k2**2*(2*Pk2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s - 1) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*k1**2*(-26*r**2 + r*(19 - 52*s) + s*(33 - 26*s)) + Pk2*k2**2*(-4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 24*r**2 - 5*r*(4*s - 3) + 4*s**2 + s + 2)) - 2*g2*(k1**2*(2*Pk2*(25*r**2 + 7*r*(9*s - 4) + s*(38*s - 38)) + Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + 7*k2**2*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) - 858*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(f*(Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + 2*k1**4*(Pk2*(28*r**2 + 56*r*s - 39*r + 28*s**2 - 39*s + 15) + Pkd2*k2*s*(23*r + 23*s - 11)) + k1**2*k2**2*(2*Pk2*(40*r**2 + 56*r*s - 51*r + 16*s**2 - 45*s + 17) + Pkd2*k2*s*(-30*r - 30*s + 13))) - 2*k2**2*(K*k1**2*(2*Pk2*(25*r**2 + r*(63*s + 2) + 38*s**2 + 2*s - 1) + 13*Pkd2*k2*s*(r + s)) + 14*K*k2**2*(Pk2*(3*r**2 + r*(6*s + 2) + 3*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)) - 13*Pk2*k1**2*(r + s)**2 - 2*Pk2*k2**2*(2*C*(r + s - 1)**2 + 6*r**2 + r*(5*s + 2) - (s - 1)**2))) + Dd*f*(f*(2*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(4*Pk2*(28*r**2 + 56*r*s - 41*r + 28*s**2 - 41*s + 15) + Pkd2*k2*(92*r*s - 7*r + 92*s**2 - 67*s + 3)) + k1**2*k2**2*(4*Pk2*(40*r**2 + 56*r*s - 49*r + 16*s**2 - 46*s + 18) + Pkd2*k2*(-60*r*s + 6*r - 60*s**2 + 41*s - 2))) + 2*k2**2*(K*k1**2*(Pk2*(-200*r**2 + r*(148 - 504*s) - 304*s**2 + 208*s + 6) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) - 7*K*k2**2*(2*Pk2*(12*r**2 + 24*r*s - 5*r + 12*s**2 - 5*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + Pk2*k1**2*(52*r**2 + 8*r*(13*s - 4) + s*(52*s - 53)) + Pk2*k2**2*(4*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 48*r**2 + 40*r*s - 21*r - 8*s**2 - 6)))) + b1*(3*D1*(44*C*f*fd*k2**2*(2*Pk2*k1**4*(r*(4*s - 1) - 3*s + 1) - k1**2*k2**2*(Pk2*(64*r**2 + 168*r*s - 52*r + 92*s**2 - 79*s + 8) + 2*Pkd2*k2*s*(9*r + 9*s - 4)) + k2**4*(Pk2*(20*r**2 + 32*r*s + 8*s**2 - s - 6) + Pkd2*k2*s*(4*r + 4*s - 1))) + f**2*fd*k1**2*(-33*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) + k1**4*s*(2*Pk2 - Pkd2*k2)*(135*r + 135*s - 101) + 22*k1**2*k2**2*(-Pk2*(33*r**2 + r*(87*s - 35) + 54*s**2 - 49*s + 10) + Pkd2*k2*(r*(12*s + 13) + 12*s**2 + 6*s - 9))) - 22*f*k2**2*(fd*(K*(2*Pk2*k1**4*(2*r**2 + r*(8*s - 6) + 6*s**2 - 9*s + 3) + Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*k2**2*(-2*Pk2*(10*r**2 - 8*r - 10*s**2 - 7*s + 6) + Pkd2*k2*(-10*r*s + 7*r - 10*s**2 + 13*s - 4))) + Pk2*k1**4*(4*r*s + r - 4*s**2) - k1**2*k2**2*(Pk2*(72*r**2 + 184*r*s - 60*r + 100*s**2 - 87*s + 10) + 2*Pkd2*k2*s*(9*r + 9*s - 4)) + k2**4*(Pk2*(24*r**2 + 36*r*s - 2*r + 8*s**2 - 2*s - 6) + Pkd2*k2*s*(4*r + 4*s - 1))) + 2*k2**2*(Pk2*bd2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) - gd2*(k1**2*(2*Pk2*(25*r**2 + 63*r*s - 24*r + 38*s**2 - 34*s - 1) + Pkd2*k2*s*(13*r + 13*s - 3)) + 7*k2**2*(2*Pk2*(3*r**2 + 6*r*s - 2*r + 3*s**2 - 2*s - 1) + Pkd2*k2*s*(2*r + 2*s - 1))))) + 44*fd*k2**4*(-Pk2*b2*(13*k1**2 + 7*k2**2)*(r + s)**2 + g2*k1**2*(2*Pk2*(25*r**2 + r*(63*s + 2) + 38*s**2 + 2*s - 1) + 13*Pkd2*k2*s*(r + s)) + 14*g2*k2**2*(Pk2*(3*r**2 + r*(6*s + 2) + 3*s**2 + 2*s - 1) + Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-198*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(36*s + 1) + 540*s**2 - 439*s + 1) + 66*k1**2*k2**2*(-Pk2*(44*r**2 + r*(116*s - 55) + 72*s**2 - 78*s + 17) + Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) + 66*f*k2**2*(Pk2*k1**4*(4*C*(r*(8*s - 1) - 6*s + 1) - 2*K*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7) - 8*r*s - 3*r + 8*s**2 + 2) + k1**2*k2**2*(Pk2*(-2*C*(128*r**2 + 7*r*(48*s - 23) + 184*s**2 - 208*s + 47) + K*(40*r**2 - 60*r - 40*s**2 - 54*s + 36) + 144*r**2 + 368*r*s - 185*r + 200*s**2 - 232*s + 56) + Pkd2*k2*(C*(r*(6 - 72*s) - 72*s**2 + 50*s - 2) + K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) + 36*r*s - 3*r + 36*s**2 - 25*s + 1)) + k2**4*(Pk2*(2*C*(40*r**2 + r*(64*s - 15) + 16*s**2 - 10*s - 9) - K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 48*r**2 - 72*r*s + 20*r - 16*s**2 + 12*s + 9) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 132*k2**4*(Pk2*b2*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(k1**2*(Pk2*(-200*r**2 + r*(148 - 504*s) - 304*s**2 + 208*s + 6) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) - 7*k2**2*(2*Pk2*(12*r**2 + 24*r*s - 5*r + 12*s**2 - 5*s - 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + f*(D1*(f**2*fd*k1**4*(162*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(-2*Pk2*(5*r*(72*s - 43) + 360*s**2 - 596*s + 189) + 25*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(-66*Pk2*bd2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1) + fd*(Pk2*k1**4*(-4*C*(27*r**2 + 9*r*(12*s - 17) + 81*s**2 - 222*s + 101) + 54*r**2 + 30*r*(9*s - 13) + 216*s**2 - 597*s + 269) + Pk2*k2**4*(66*C - 33)*(9*r**2 + 3*r*(9*s - 5) + 18*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(4*C*(945*r**2 + 3*r*(513*s - 403) + 594*s**2 - 1008*s + 397) - 2385*r**2 - 3870*r*s + 2913*r - 1485*s**2 + 2346*s - 893) + Pkd2*k2*(66*C - 33)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + 66*gd2*(2*Pk2*k1**4*(r**2 + r*(4*s - 3) + 3*s**2 - 5*s + 2) + Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*k2**2*(-2*Pk2*(5*r**2 - 11*r - 5*s**2 - 10*s + 6) - Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 132*fd*k2**2*(-Pk2*b2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(2*r**2 + r*(8*s - 6) + 6*s**2 - 9*s + 3) + Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*k2**2*(-2*Pk2*(10*r**2 - 8*r - 10*s**2 - 7*s + 6) + Pkd2*k2*(-10*r*s + 7*r - 10*s**2 + 13*s - 4))))) + Dd*f*(f**2*k1**4*(162*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(-2*Pk2*(5*r*(72*s - 43) + 360*s**2 - 596*s + 189) + 25*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(Pk2*k1**4*(-4*C*(36*r**2 + 12*r*(12*s - 17) + 108*s**2 - 299*s + 143) + 72*r**2 + r*(360*s - 517) + 288*s**2 - 802*s + 378) + Pk2*k2**4*(66*C - 33)*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*k2**2*(Pk2*(4*C*(1260*r**2 + 3*r*(684*s - 577) + 792*s**2 - 1438*s + 604) - 3180*r**2 - 15*r*(344*s - 277) - 1980*s**2 + 3305*s - 1340) + Pkd2*k2*(66*C - 33)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 132*k2**2*(-Pk2*b2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(4*r + 4*s - 3) + g2*(2*Pk2*k1**4*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7) + Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*k2**2*(Pk2*(-40*r**2 + 60*r + 40*s**2 + 54*s - 36) + Pkd2*k2*(-20*r*s + 13*r - 20*s**2 + 29*s - 10)))))))/(693*d**2*k2**2*k3**6) - 4*D1**3*Pk3*(D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(5*r**2 + r*(9*s - 11) + 4*(s - 1)**2) + 2*k1**2*(Pk2*(s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(r + s - 1))) - f*k2**2*(Pk2*k2**4*(2 - 4*C)*(15*r**2 + r*(28*s - 13) + s*(13*s - 13)) + 2*k1**4*(Pk2*(-8*C*(2*r**2 + r*(8*s - 5) + 6*s**2 - 8*s + 2) + b1*(168*r**2 + 9*r*(34*s - 29) + 138*s**2 - 235*s + 95) + 8*r**2 + 40*r*s - 24*r + 32*s**2 - 42*s + 10) + 36*Pkd2*b1*k2*s*(r + s - 1)) + k1**2*k2**2*(Pk2*(-8*C*(46*r**2 + 97*r*s - 70*r + 51*s**2 - 63*s + 12) - 26*K*r*s - 26*K*s**2 + 26*K*s + 13*b1*(18*r**2 + 3*r*(10*s - 7) + 12*s**2 - 19*s + 5) + 208*r**2 + 436*r*s - 328*r + 228*s**2 - 276*s + 48) + Pkd2*k2*s*(24 - 48*C)*(r + s - 1))) + 4*k2**2*(Pk2*b1**2*k1**2*(2*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1*(7*K*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pk2*k1**4*(28*C*(r*(4*s - 1) - 2*s + 1) + 4*K*r**2 + 12*K*s**2 - 10*K*s + r*(16*K*s - 6*K - 60*s + 15) - 4*s**2 + 31*s - 14) + k1**2*k2**2*(14*K*Pkd2*k2*s*(r + s - 1) - Pk2*(4*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 98*K*s**2 + 84*K*s + r**2*(10 - 70*K) + r*(-168*K*s + 84*K + 76*s - 29) + 10*s**2 - 29*s + 12))) - g2*(4*Pk2*k1**4*(r**2 + r*(4*s - 2) + s*(3*s - 3)) + 7*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 14*k1**2*k2**2*(Pk2*(5*r**2 + r*(12*s - 7) + s*(7*s - 7)) + Pkd2*k2*s*(r + s - 1))))) + 4*Pk2*b1**3*k1**2*k2**2*(2*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 2*Pk2*f*k1**2*k2**4*(D1*(f*fd*(22*C - 11)*(3*s - 1) - 26*f*gd2*s + 26*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(22*C - 11) - 26*g2))*(r + s - 1) - b1**2*k2**2*(D1*fd*(-14*K*Pk2*k2**4*(r + s)**2 + 13*Pk2*f*k1**2*k2**2*(18*r**2 + 15*r*(2*s - 1) + 12*s**2 - 13*s + 3) - 8*Pk2*k1**4*(K*(r**2 + 4*r*s + 3*s**2) + s*(28*C*(r - 1) - 15*r - s + 14)) + 4*f*k1**4*(Pk2*(84*r**2 + 51*r*(3*s - 2) + 69*s**2 - 95*s + 33) + 9*Pkd2*k2*s*(2*r + 2*s - 1)) - 4*k1**2*k2**2*(7*K*Pkd2*k2*s*(r + s) + Pk2*(-4*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 49*K*s**2 + r**2*(35*K - 5) + r*(84*K*s - 38*s - 4) - 5*s**2 + 24*s + 2))) + 2*Dd*f*(-7*K*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + k1**4*(Pk2*(-56*C*(r*(8*s - 1) - 6*s + 1) - 16*K*r**2 + f*(336*r**2 + r*(612*s - 465) + 276*s**2 - 425*s + 161) - 2*r*(8*K*(4*s - 1) - 120*s + 15) - 4*s**2*(12*K - 4) - 4*s*(44 - 7*K) + 28) + 18*Pkd2*f*k2*s*(4*r + 4*s - 3)) + 2*k1**2*k2**2*(-7*K*Pkd2*k2*s*(4*r + 4*s - 3) + Pk2*(4*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) - 140*K*r**2 - 336*K*r*s + 119*K*r - 196*K*s**2 + 119*K*s + 13*f*(9*r**2 + 15*r*s - 9*r + 6*s**2 - 8*s + 2) + 20*r**2 + 152*r*s - 28*r + 20*s**2 - 77*s + 8)))) + b1*(D1*(f**2*fd*k1**4*(6*Pk2*k1**2*s*(5*r + 5*s - 3) + 11*Pk2*k2**2*(15*r**2 + 27*r*s - 23*r + 12*s**2 - 14*s + 8) + 10*Pkd2*k1**2*k2*s*(3*r + 3*s - 2)) + 2*f*k2**2*(4*Pk2*bd2*k1**2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(4*Pk2*k1**4*(2*r + 2*s - 1)*(2*C*(2*r + 6*s - 1) - 2*r - 8*s + 1) + Pk2*k2**4*(2*C - 1)*(30*r**2 + r*(56*s - 15) + s*(26*s - 15)) + k1**2*k2**2*(Pk2*(4*C*(92*r**2 + 2*r*(97*s - 34) + 102*s**2 - 62*s + 11) + 13*K*(2*s - 1)*(r + s - 1) - 208*r**2 - 436*r*s + 148*r - 228*s**2 + 124*s - 22) + Pkd2*k2*s*(24*C - 12)*(2*r + 2*s - 1))) - 2*gd2*(4*Pk2*k1**4*(r**2 + r*(4*s - 1) + s*(3*s - 2)) + 7*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 14*k1**2*k2**2*(Pk2*(5*r**2 + r*(12*s - 5) + s*(7*s - 5)) + Pkd2*k2*s*(r + s - 1)))) - 4*fd*k2**2*(r + s)*(-2*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(r + s) + g2*(4*Pk2*k1**4*(r + 3*s) + 7*Pk2*k2**4*(r + s) + 14*k1**2*k2**2*(5*Pk2*r + 7*Pk2*s + Pkd2*k2*s)))) + 2*Dd*f*(f**2*k1**4*(11*Pk2*k2**2*(10*r**2 + r*(18*s - 17) + 8*s**2 - 11*s + 6) + k1**2*(Pk2*(4*s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(4*r + 4*s - 3))) + f*k2**2*(2*Pk2*k1**4*(8*C*(4*r**2 + 2*r*(8*s - 3) + 12*s**2 - 11*s + 2) - 16*r**2 + r*(26 - 80*s) - 64*s**2 + 56*s - 9) + Pk2*k2**4*(2*C - 1)*(60*r**2 + r*(112*s - 43) + s*(52*s - 43)) + k1**2*k2**2*(Pk2*(4*C*(184*r**2 + r*(388*s - 195) + 204*s**2 - 175*s + 34) + 13*K*(4*s - 1)*(r + s - 1) - 416*r**2 - 872*r*s + 438*r - 456*s**2 + 362*s - 68) + Pkd2*k2*s*(24*C - 12)*(4*r + 4*s - 3))) - 2*k2**2*(-2*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(4*Pk2*k1**4*(4*r**2 + 4*r*(4*s - 1) + s*(12*s - 7)) + 7*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 14*k1**2*k2**2*(Pk2*(20*r**2 + r*(48*s - 17) + s*(28*s - 17)) + Pkd2*k2*s*(4*r + 4*s - 3)))))))/(21*d**2*k2**2*k3**6) + D1**3*Pk3*st**2*(2*D1*bd1*f*(f*(Pk2*k2**2*r*(4*C - 2)*(3*r - 1) + k1**2*(-2*Pk2*(r*(6*s - 1) + s*(4*C - 2)*(2*s - 1)) + k2*(Pkd2*(r*(2*s - 1) + s*(2*C - 1)*(5*s - 3)) + Pkdd2*k2*s*(-2*C*(s - 1) + s - 1)))) + k1**2*s*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(7*b2 - 14*g2)*(s - 1)) + 7*b1**3*k1**2*(D1*fd*s*(Pk2 - Pkd2*k2)*(r - 1) + 2*Dd*f*(Pk2*(2*r*(s - 1) - 5*s + 2) + Pkd2*k2*(-2*r*s + r + 3*s - 1))) + b1**2*k1**2*(7*D1*bd1*f*(Pk2*(r*(3*s - 4) - 9*s + 4) + Pkd2*k2*(r*(2 - 3*s) + 5*s - 2)) + D1*fd*(-4*C*Pkd2*k2*s**2 + 4*C*Pkdd2*k2**2*s**2 + 14*K*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)**2 + Pk2*f*(r*(10 - 36*s) + 60*s - 26) + 92*Pk2*r*s - 84*Pk2*r - 8*Pk2*s - 7*Pkd2*f*k2*(2*r - 1)*(3*s - 2) - 32*Pkd2*k2*r*s + 28*Pkd2*k2*r + 2*Pkd2*k2*s**2 + 4*Pkd2*k2*s - 2*Pkdd2*k2**2*s**2) - 2*Dd*f*(Pk2*(-28*K*(4*s**2 - 5*s + 1) + f*(r*(36*s + 11) - 60*s + 5) - 184*r*s + 86*r + 40*s - 30) - k2*(Pkd2*(-8*C*s**2 + 2*C*s - 21*K*(4*s**2 - 5*s + 1) - 7*f*(2*r - 1)*(3*s - 2) - 64*r*s + 36*r + 4*s**2 + 19*s - 15) + Pkdd2*k2*(4*s - 1)*(7*K*(s - 1) + s*(2*C - 1))))) + b1*(-4*C*f*(D1*fd*(-2*Pk2*k2**2*(6*r**2 - 5*r + 1) + k1**2*(2*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1)))) + Dd*f*(-4*Pk2*k2**2*(6*r**2 - 5*r + 1) + k1**2*(4*s - 1)*(Pk2*(8*s - 4) + k2*(Pkd2*(3 - 5*s) + Pkdd2*k2*(s - 1))))) + 56*D1*Pk2*bd2*f*k1**2*s**2 - 56*D1*Pk2*bd2*f*k1**2*s - 48*D1*Pk2*f*fd*k1**2*r*s + 12*D1*Pk2*f*fd*k1**2*r + 32*D1*Pk2*f*fd*k1**2*s**2 - 12*D1*Pk2*f*fd*k1**2*s + 4*D1*Pk2*f*fd*k1**2 - 24*D1*Pk2*f*fd*k2**2*r**2 + 20*D1*Pk2*f*fd*k2**2*r - 4*D1*Pk2*f*fd*k2**2 - 112*D1*Pk2*f*gd2*k1**2*s**2 + 112*D1*Pk2*f*gd2*k1**2*s - 112*D1*Pk2*fd*g2*k1**2*s**2 + 224*D1*Pk2*fd*g2*k1**2*s - 112*D1*Pk2*fd*g2*k1**2 - 42*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 42*D1*Pkd2*bd2*f*k1**2*k2*s + 8*D1*Pkd2*f*fd*k1**2*k2*r*s - 6*D1*Pkd2*f*fd*k1**2*k2*r - 20*D1*Pkd2*f*fd*k1**2*k2*s**2 + 20*D1*Pkd2*f*fd*k1**2*k2*s - 4*D1*Pkd2*f*fd*k1**2*k2 + 84*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 84*D1*Pkd2*f*gd2*k1**2*k2*s + 84*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 168*D1*Pkd2*fd*g2*k1**2*k2*s + 84*D1*Pkd2*fd*g2*k1**2*k2 + 14*D1*Pkdd2*bd2*f*k1**2*k2**2*s**2 - 14*D1*Pkdd2*bd2*f*k1**2*k2**2*s + 4*D1*Pkdd2*f*fd*k1**2*k2**2*s**2 - 6*D1*Pkdd2*f*fd*k1**2*k2**2*s + 2*D1*Pkdd2*f*fd*k1**2*k2**2 - 28*D1*Pkdd2*f*gd2*k1**2*k2**2*s**2 + 28*D1*Pkdd2*f*gd2*k1**2*k2**2*s - 28*D1*Pkdd2*fd*g2*k1**2*k2**2*s**2 + 56*D1*Pkdd2*fd*g2*k1**2*k2**2*s - 28*D1*Pkdd2*fd*g2*k1**2*k2**2 + D1*bd1*f*k1**2*(-4*Pk2*(-28*K*s**2 + 28*K*s + f*(r*(9*s + 8) - 15*s - 4) + r*(15 - 46*s) + 9*s - 8) + k2*(Pkd2*(-7*f*(2*r - 1)*(3*s - 2) + r*(30 - 64*s) + 4*s**2*(-2*C - 21*K + 1) + 4*s*(C + 21*K + 4) - 16) + 2*Pkdd2*k2*s*(C*(4*s - 2) + 14*K*(s - 1) - 2*s + 1))) - 96*Dd*Pk2*f**2*k1**2*r*s + 20*Dd*Pk2*f**2*k1**2*r + 64*Dd*Pk2*f**2*k1**2*s**2 - 8*Dd*Pk2*f**2*k1**2*s - 48*Dd*Pk2*f**2*k2**2*r**2 + 40*Dd*Pk2*f**2*k2**2*r - 8*Dd*Pk2*f**2*k2**2 - 448*Dd*Pk2*f*g2*k1**2*s**2 + 560*Dd*Pk2*f*g2*k1**2*s - 112*Dd*Pk2*f*g2*k1**2 + 16*Dd*Pkd2*f**2*k1**2*k2*r*s - 10*Dd*Pkd2*f**2*k1**2*k2*r - 40*Dd*Pkd2*f**2*k1**2*k2*s**2 + 30*Dd*Pkd2*f**2*k1**2*k2*s - 2*Dd*Pkd2*f**2*k1**2*k2 + 336*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 420*Dd*Pkd2*f*g2*k1**2*k2*s + 84*Dd*Pkd2*f*g2*k1**2*k2 + 8*Dd*Pkdd2*f**2*k1**2*k2**2*s**2 - 10*Dd*Pkdd2*f**2*k1**2*k2**2*s + 2*Dd*Pkdd2*f**2*k1**2*k2**2 - 112*Dd*Pkdd2*f*g2*k1**2*k2**2*s**2 + 140*Dd*Pkdd2*f*g2*k1**2*k2**2*s - 28*Dd*Pkdd2*f*g2*k1**2*k2**2 + 14*b2*k1**2*(4*Pk2 + k2*(-3*Pkd2 + Pkdd2*k2))*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(21*d**2*k1**2*k2**2) + D1**3*Pk3*(2*D1*bd1*f*k1**2*s*(Pk2*f*(-4*C*(s - 1) + 13*r + 2*s - 2) + Pkd2*f*k2*(13 - 26*C)*(s - 1) + 7*b2*(2*Pk2 - Pkd2*k2)*(s - 1) - 14*g2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 7*Pk2*b1**3*k1**2*s*(D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)) + b1**2*(7*D1*Pk2*bd1*f*k1**2*s*(3*r - 1) + 2*D1*fd*(7*K*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2 + Pk2*k1**2*(r*(13*s - 7) - 6*s) + Pk2*k2**2*(24*C - 12)*(r - 1)**2) + Dd*Pk2*f*k2**2*(96*C - 48)*(2*r**2 - 3*r + 1) + 2*Dd*f*k1**2*(-7*K*Pkd2*k2*(4*s**2 - 5*s + 1) + Pk2*(14*K*(4*s**2 - 5*s + 1) + 52*r*s - 31*r - 60*s + 24))) + 2*b1*(2*D1*bd1*f*(Pk2*k2**2*r*(24*C - 12)*(r - 1) + k1**2*(-7*K*Pkd2*k2*s*(s - 1) + Pk2*(14*K*s**2 + r*(13*s - 12) - s*(14*K + 24) + 12))) + k1**2*(D1*(-f*fd*(2*s - 1)*(Pk2*(4*C*(s - 1) - 13*r - 2*s + 2) + Pkd2*k2*(26*C - 13)*(s - 1)) + 7*f*s*(2*Pk2 - Pkd2*k2)*(bd2 - 2*gd2)*(s - 1) - 14*fd*g2*(2*Pk2 - Pkd2*k2)*(s - 1)**2) - Dd*f*(4*s - 1)*(Pk2*f*(4*C*(s - 1) - 13*r - 2*s + 2) + Pkd2*f*k2*(26*C - 13)*(s - 1) + 14*g2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 7*b2*(2*Pk2 - Pkd2*k2)*(s - 1)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)))))/(21*d**2*k1**2*k2**2) - D1**3*Pk3*st**4*(D1*(132*b1*fd*k1**2*k2**2*(b1*(-2*K*Pk2*r*(r - 4*s + 4) + K*Pkd2*k2*(-4*r*(s - 1) - 2*s + 1) + K*Pkdd2*k2**2*(2*s - 1) + 2*Pk2*r*(r + 2) - 2*Pkd2*k2*r) + b2*k2*s**2*(-Pkd2 + Pkdd2*k2) - 2*g2*(-2*Pk2*r*(r - 4*s + 4) + Pkd2*k2*(-4*r*s + 4*r - 2*s + 1) + Pkdd2*k2**2*(2*s - 1))) + 11*bd1*f**3*k1**2*k2**2*(r - 1)*(Pk2*(72*r + 25*s - 10) + 6*Pkd2*k2*(5*s - 2)) + f**2*(fd*(Pk2*k2**4*(1 - 3*r)**2*(32 - 64*C) - 4*k1**4*(3*s - 1)*(8*Pk2*(C*(6*s - 2) + 3*r + 3*s - 2) + k2*(Pkd2*(-30*C*s + 10*C - 6*r + 3*s + 1) + Pkdd2*k2*(2*C - 1)*(3*s - 1))) + k1**2*k2**2*(Pk2*(11*b1*(216*r**2 + 75*r*s - 258*r - 145*s + 118) + (4 - 12*r)*(96*C*s - 32*C + 24*r - 69*s + 4)) + 2*Pkd2*k2*(3*r - 1)*(33*b1*(5*s - 2) + (32*C - 16)*(3*s - 1)))) + 132*k1**2*(bd1*(K*Pkdd2*k2**4*s*(1 - 2*s) - 4*Pk2*k1**2*s**2 + Pk2*k2**2*(K*(-5*r*s + 6*r - 8*s**2 + 13*s - 6) + b1*(8*r - 5) + 2*r**2 - 12*r*s + 4*s - 2) + Pkd2*k1**2*k2*s**2 + Pkd2*k2**3*(K*(r*(s - 2) + 6*s**2 - 6*s + 2) + b1*(2 - 3*r) + 4*r*s - r - 2*s + 1)) - k2**2*(bd2 - 2*gd2)*(Pk2*(r*(5*s - 6) + 8*s**2 - 13*s + 6) + k2*(-Pkd2*(r*(s - 2) + 6*s**2 - 6*s + 2) + Pkdd2*k2*s*(2*s - 1))))) - 132*f*k1**2*(b1**2*fd*k2**2*(-4*Pk2*r + Pk2 + Pkd2*k2*r) + b1*(10*K*Pk2*fd*k2**2*r*s - 8*K*Pk2*fd*k2**2*r + 16*K*Pk2*fd*k2**2*s**2 - 16*K*Pk2*fd*k2**2*s + 4*K*Pk2*fd*k2**2 - 2*K*Pkd2*fd*k2**3*r*s + 2*K*Pkd2*fd*k2**3*r - 12*K*Pkd2*fd*k2**3*s**2 + 12*K*Pkd2*fd*k2**3*s - 3*K*Pkd2*fd*k2**3 + 4*K*Pkdd2*fd*k2**4*s**2 - 4*K*Pkdd2*fd*k2**4*s + K*Pkdd2*fd*k2**4 + 8*Pk2*fd*k1**2*s**2 - 4*Pk2*fd*k1**2*s - 4*Pk2*fd*k2**2*r**2 + 24*Pk2*fd*k2**2*r*s - 12*Pk2*fd*k2**2*r + Pkd2*bd2*k2**3*s**2 - 2*Pkd2*fd*k1**2*k2*s**2 + Pkd2*fd*k1**2*k2*s - 8*Pkd2*fd*k2**3*r*s + 4*Pkd2*fd*k2**3*r - Pkdd2*bd2*k2**4*s**2 - bd1*k2**2*(-2*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + k2*(K*Pkd2*(r*(4 - 8*s) + s - 2) + K*Pkdd2*k2*s - Pkd2*r + Pkd2)) + 2*gd2*k2**2*(-2*Pk2*(r**2 - 4*r*s + r + 2*s - 2) + k2*(Pkd2*(-4*r*s + 2*r + s - 2) + Pkdd2*k2*s))) + k2**2*(b2*(2*Pk2*fd*(r*(5*s - 4) + 2*(1 - 2*s)**2) + bd1*k2*s*(Pkd2 - Pkdd2*k2)*(s - 1) + fd*k2*(-2*Pkd2*r*(s - 1) - 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2)) - 2*g2*(2*bd1*r*(Pk2*(r - 4*s + 2) + Pkd2*k2*(2*s - 1)) + fd*(2*Pk2*(r*(5*s - 4) + 2*(1 - 2*s)**2) + k2*(-2*Pkd2*r*(s - 1) - 3*Pkd2*(1 - 2*s)**2 + Pkdd2*k2*(1 - 2*s)**2)))))) - 2*Dd*f*(-66*b1*k1**2*k2**2*(-b1*(4*Pk2*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1) + k2*(K*Pkdd2*k2*(1 - 4*s) + Pkd2*(K*(2*r*(8*s - 5) + 3) + 4*r - 2))) + b2*k2*s*(-Pkd2 + Pkdd2*k2)*(4*s - 1) + 2*g2*(8*Pk2*(r**2 + r*(2 - 4*s) + s - 1) + k2*(Pkd2*(2*r*(8*s - 5) + 3) + Pkdd2*k2*(1 - 4*s)))) + f**2*(Pk2*k2**4*(64*C - 32)*(6*r**2 - 5*r + 1) + 2*k1**4*(4*Pk2*(4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 24*s**2 - 24*s + 5) + k2*(Pkd2*(-10*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 12*s**2 + 3*s - 2) + Pkdd2*k2*(2*C - 1)*(12*s**2 - 7*s + 1))) - k1**2*k2**2*(11*Pk2*b1*(144*r**2 + 10*r*(5*s - 17) - 85*s + 64) + 4*Pk2*(-8*C*(r*(24*s - 7) - 10*s + 3) - 48*r**2 + r*(138*s + 19) - 63*s + 1) + 66*Pkd2*b1*k2*(2*r - 1)*(5*s - 2) + Pkd2*k2*(16*C - 8)*(r*(24*s - 7) - 10*s + 3))) + 66*f*k1**2*(2*b1**2*k2**2*(-3*Pk2 + Pkd2*k2)*(2*r - 1) + b1*(K*Pkdd2*k2**4*(8*s**2 - 6*s + 1) + 4*Pk2*k1**2*s*(4*s - 1) + 2*Pk2*k2**2*(K*(10*r*(s - 1) + 16*s**2 - 21*s + 8) - 4*r**2 + 24*r*s - 6*r - 4*s + 2) + Pkd2*k1**2*k2*s*(1 - 4*s) + Pkd2*k2**3*(K*(-4*r*s + 6*r - 24*s**2 + 24*s - 7) - 16*r*s + 6*r + 4*s - 2)) + k2**2*(b2 - 2*g2)*(2*Pk2*(10*r*(s - 1) + 16*s**2 - 21*s + 8) + k2*(Pkd2*(-4*r*s + 6*r - 24*s**2 + 24*s - 7) + Pkdd2*k2*(8*s**2 - 6*s + 1))))))/(231*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*(D1*bd1*f*(21*Pk2*b1**2*k1**2*k2**2*s*(1 - 3*r) + 2*b1*(Pk2*k2**4*r*(24 - 48*C)*(r - 1) + 2*k1**4*(2*Pk2*(7*r*(s - 1) + s*(4*C*s - 2*C - 11*s + 9)) + 7*Pkd2*k2*s*(2*s - 1)) + k1**2*k2**2*(-7*K*Pkd2*k2*s + Pk2*(-72*C*(r*(4*s - 1) - 2*s + 1) + 21*K*s + 14*r**2 - 2*r*(7*K*s - 66*s + 13) - 24*s + 12))) + f*(k1**4*(Pk2*(b1*(12*r*(27*s - 14) + 16*s**2 - 225*s + 112) + 2*r*(57*s - 40) - (4*s - 4)*(s*(K - 3) + 10)) + 2*Pkd2*k2*s*(b1*(84*r + 52*s - 34) - (13*K - 12)*(s - 1))) - 2*k1**2*k2**2*(Pk2*(2*C*(80*r**2 + 73*r*s - 112*r - 48*s + 48) - 95*r**2 - 73*r*s + 125*r + 48*s - 48) + Pkd2*k2*r*s*(36*C - 18))) - 14*k1**2*k2**2*s*(3*Pk2*b2*r - 2*Pk2*g2*r + Pkd2*b2*k2*(s - 1))) - 21*Pk2*b1**3*k1**2*k2**2*s*(D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)) + b1**2*(D1*fd*(14*K*Pkd2*k1**2*k2**3*(1 - 2*s) + 4*Pk2*k1**4*s*(7*r + s*(4*C - 11)) + 2*Pk2*k1**2*k2**2*(7*r**2 + r*(-144*C*s - 7*K*(s + 2) + 66*s + 7) + s*(144*C - 66)) + 2*Pk2*k2**4*(12 - 24*C)*(r - 1)**2 + 28*Pkd2*k1**4*k2*s**2 + f*k1**4*(Pk2*(324*r*s + 16*s**2 - 203*s - 4) + 2*Pkd2*k2*(84*r*s + 52*s**2 - 24*s - 13))) + 2*Dd*f*(Pk2*k2**4*(24 - 48*C)*(2*r**2 - 3*r + 1) + f*k1**4*(2*Pk2*(6*r*(27*s - 7) + 8*s**2 - 107*s + 27) + Pkd2*k2*(104*s**2 + s*(168*r - 58) - 13)) + 2*k1**4*(14*Pk2*r*(2*s - 1) + Pk2*s*(4*C*(4*s - 1) - 44*s + 25) + 7*Pkd2*k2*s*(4*s - 1)) + k1**2*k2**2*(7*K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(36*C*(r*(8*s - 1) - 6*s + 1) - 21*K*s - 14*r**2 + r*(14*K*s + 7*K - 132*s + 13) + 78*s - 6)))) - 2*b1*k1**2*(D1*(f*(fd*(K*k1**2*(2*Pk2 + 13*Pkd2*k2)*(2*s**2 - 3*s + 1) + Pk2*k1**2*(r*(13 - 114*s) + s*(44 - 12*s)) + Pk2*k2**2*(C*(320*r**2 + 4*r*(73*s - 67) - 78*s + 24) - 190*r**2 - 146*r*s + 136*r + 39*s - 12) - 24*Pkd2*k1**2*k2*s**2 + Pkd2*k2**3*(2*C - 1)*(s*(36*r + 21) - 13)) + 7*k2**2*s*(bd2*(3*Pk2*(r - 1) + Pkd2*k2*s) - 2*gd2*(Pk2*(r - 3) + Pkd2*k2))) + 7*fd*k2**2*(b2*s*(3*Pk2*r + Pkd2*k2*s) - 2*g2*(Pk2*r*(s + 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(f*(k1**2*(Pk2*(2*K*(4*s**2 - 5*s + 1) - 228*r*s + 53*r - 24*s**2 + 94*s - 20) + Pkd2*k2*(4*s - 1)*(13*K*(s - 1) - 12*s)) + k2**2*(2*Pk2*(2*C*(160*r**2 + 146*r*s - 183*r - 67*s + 50) - 190*r**2 - 146*r*s + 198*r + 67*s - 50) + Pkd2*k2*(2*C - 1)*(s*(72*r + 16) - 13))) - 7*k2**2*(Pk2*b2*s*(6 - 12*r) + 4*Pk2*g2*(2*r*s + r - 3*s) + Pkd2*b2*k2*s*(1 - 4*s) + 2*Pkd2*g2*k2*(4*s - 1)))) - 2*f*k1**4*(D1*(f*fd*(3*s - 1)*(Pk2*(4*C*(s - 1) - 11*r - 2*s + 2) + Pkd2*k2*(22*C - 11)*(s - 1)) + f*s*(2*Pk2 + 13*Pkd2*k2)*(bd2 - 2*gd2)*(s - 1) - 2*fd*g2*(2*Pk2 + 13*Pkd2*k2)*(2*s**2 - 3*s + 1)) + Dd*f*(4*s - 1)*(Pk2*f*(4*C*(s - 1) - 11*r - 2*s + 2) + Pkd2*f*k2*(22*C - 11)*(s - 1) - 2*g2*(2*Pk2 + 13*Pkd2*k2)*(s - 1)) + b2*(2*Pk2 + 13*Pkd2*k2)*(s - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(21*d**2*k1**2*k2**2*k3**2) + D1**3*Pk3*st**4*(-3*D1*bd1*f*k1**2*(f**2*(-132*Pk2*k1**2*k2**2*(6*r**2 + r*(11*s - 8) + 5*s**2 - 9*s + 2) + 8*k1**4*(Pk2*(8*r*(6*s - 1) + 72*s**2 - 72*s + 4) + k2*(Pkd2*(-12*r*s + 2*r - 27*s**2 + 30*s - 1) + Pkdd2*k2*s*(3*s - 4))) - 11*k2**4*(r - 1)*(Pk2*(58*r + 45*s - 44) + 6*Pkd2*k2*(5*s - 2))) + 66*f*k2**2*(2*K*Pkdd2*k2**4*s*(2*s - 1) - 4*Pk2*k1**2*(r**2 + r*(s*(K + 3) - 1) + s*(4*K*s + K - 3)) + 2*Pk2*k2**2*(K*(12*r**2 - 3*r*(s + 6) - 8*s**2 - 5*s + 6) + (2 - 2*r)*(7*r + 2*s - 1)) + 2*Pkd2*k1**2*k2*s*(2*K*(r + 2*s) - s) + 2*Pkd2*k2**3*(K*(15*r*s - 2*r + 10*s**2 - 10*s + 2) - 4*r*s + r + 2*s - 1) + b1*(-2*k1**2*(2*Pk2 - Pkd2*k2)*(r + s - 1) + k2**2*(Pk2*(r*(4 - 18*s) + 9*s - 4) + Pkd2*k2*(2*r*(s + 1) + s - 2)))) - 132*k2**4*(-2*Pk2*b1*(K*(6*r**2 + r*(8*s - 7) - 2*s + 2) + 2*r**2 - 1) + 2*Pkd2*b2*k2*(r*(2*s - 1) + s*(2*s - 2)) + b1*k2*(K*Pkd2*(6*s**2 + s*(8*r - 1) - 2) + K*Pkdd2*k2*s*(2*s - 1) + Pkd2*(-4*r*s + r + s)) + 2*g2*(2*Pk2*r*(3*r + 4*s - 2) + k2*(Pkd2*r*(2 - 4*s) - 3*Pkd2*s*(s - 1) - Pkdd2*k2*s*(s - 1))))) + 198*b1**2*k1**2*k2**2*(-D1*fd*(-2*K*k2**2*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2) + 2*f*k1**2*(2*Pk2 - Pkd2*k2)*(r + s - 1) + f*k2**2*(Pk2*(-2*r*(9*s + 2) + 9*s + 4) + Pkd2*k2*s*(2*r + 1)) + 4*k2**2*r*(Pk2*(r + 2) + Pkd2*k2*s)) - 2*Dd*f*k2**2*(8*K*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) - K*k2*(Pkd2*(2*r*(8*s + 3) + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)) + Pk2*(2*r - 1)*(-9*f*s + 4*r + 4) + Pkd2*f*k2*(2*r*s + r + s - 1) + Pkd2*k2*(r*(8*s - 1) - 2*s))) - 3*b1*k1**2*(D1*(f**2*fd*(-132*Pk2*k1**2*k2**2*(18*r**2 + r*(33*s - 25) + 15*s**2 - 28*s + 11) + 4*k1**4*(24*Pk2*(12*r*s - 4*r + 18*s**2 - 12*s + 3) + k2*(-3*Pkd2*(24*r*s - 8*r + 54*s**2 - 18*s + 5) + Pkdd2*k2*(18*s**2 + 6*s - 1))) - 11*k2**4*(Pk2*(174*r**2 + 135*r*s - 154*r - 165*s + 56) + 6*Pkd2*k2*(3*r - 1)*(5*s - 2))) + 132*f*k2**2*(-2*Pkd2*bd2*k2**3*s*(2*r + 2*s - 1) + fd*(K*(4*Pk2*k1**2*(-r*s + r + s*(2 - 4*s)) + 2*Pk2*k2**2*(12*r**2 - 3*r*s - 2*(1 - 2*s)**2) + 2*Pkd2*k1**2*k2*(r + 2*s)*(2*s - 1) + Pkd2*k2**3*(2*r*(15*s - 7) + 5*(1 - 2*s)**2) + Pkdd2*k2**4*(1 - 2*s)**2) - 4*Pk2*k1**2*r*(r + 3*s) - 4*Pk2*k2**2*r*(7*r + 2*s - 1) + Pkd2*k1**2*k2*s*(1 - 2*s) + 4*Pkd2*k2**3*r*(1 - 2*s)) + 2*gd2*k2**2*(-2*Pk2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + k2*(Pkd2*(4*r*s + 2*r + 3*s**2 + 2*s - 2) + Pkdd2*k2*s**2))) + 264*fd*k2**4*(-2*Pkd2*b2*k2*s*(r + s) + g2*(-2*Pk2*r*(3*r + 4*s - 4) + Pkd2*k2*(4*r*(s + 1) + 3*s**2 + 8*s - 4) + Pkdd2*k2**2*s**2))) + 2*Dd*f*(f**2*(-66*Pk2*k1**2*k2**2*(24*r**2 + 11*r*(4*s - 3) + 20*s**2 - 37*s + 13) + 2*k1**4*(16*Pk2*(r*(24*s - 7) + 36*s**2 - 27*s + 5) + k2*(Pkd2*(-96*r*s + 28*r - 216*s**2 + 114*s - 17) + Pkdd2*k2*(24*s**2 - 2*s - 1))) - 11*k2**4*(Pk2*(116*r**2 + 90*r*s - 128*r - 105*s + 50) + 6*Pkd2*k2*(2*r - 1)*(5*s - 2))) + 66*f*k2**2*(K*Pkdd2*k2**4*(8*s**2 - 6*s + 1) + 4*Pk2*k1**2*(-2*r**2 + r*(-2*K*s + K - 6*s + 1) + s*(-8*K*s + K + 3)) + 2*Pk2*k2**2*(K*(24*r**2 - 6*r*(s + 3) - 16*s**2 + 3*s + 4) + (2 - 4*r)*(7*r + 2*s - 1)) + Pkd2*k1**2*k2*(4*s - 1)*(2*K*(r + 2*s) - s) + Pkd2*k2**3*(K*(60*r*s - 18*r + 40*s**2 - 40*s + 9) - 16*r*s + 6*r + 4*s - 2)) + 132*k2**4*(Pkd2*b2*k2*(-8*r*s + r + s*(4 - 8*s)) + g2*(-8*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + k2*(Pkd2*(16*r*s + 6*r + 12*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1)))))) + 2*f*(D1*(f**2*fd*k1**4*(6*k1**2*(Pk2*(10*r*(17*s - 4) + 768*s**2 - 461*s + 66) + k2*(Pkd2*(-50*r*s + 15*r - 264*s**2 + 173*s - 28) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 5*k2**2*(Pk2*(-90*r*s + 36*r - 240*s**2 + 185*s - 38) + 5*Pkd2*k2*(12*s**2 - 7*s + 1))) - 6*f*k2**2*(fd*(Pk2*k2**4*(1 - 3*r)**2*(16*C - 8) + k1**4*(12*Pk2*(C*(3*r**2 - 36*r*s + 10*r - 57*s**2 + 50*s - 10) - 12*r**2 - 3*r*s + 9*r + 24*s**2 - 15*s + 1) + k2*(3*s - 1)*(Pkd2*(2*C*(48*r + 57*s - 35) - 54*r - 69*s + 41) + Pkdd2*k2*(2*C - 1)*(3*s - 1))) - k1**2*k2**2*(3*r - 1)*(3*Pk2*(4*C*(9*r + 16*s - 1) - 26*r - 25*s + 6) + Pkd2*k2*(16*C - 8)*(3*s - 1))) + 66*k1**2*(bd2*(-2*Pk2*k1**2*s*(r + s) + 2*Pk2*k2**2*(r**2 - r*(s + 1) - 2*s**2 + s) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2)) + gd2*(2*Pk2*k1**2*s*(r + 4*s + 1) + Pk2*k2**2*(-12*r**2 + 3*r*(s + 6) + 8*s**2 + 5*s - 6) - 2*Pkd2*k1**2*k2*s*(r + 2*s) + Pkd2*k2**3*(-15*r*s + 2*r - 10*s**2 + 10*s - 2) + Pkdd2*k2**4*s*(1 - 2*s)))) - 396*fd*k1**2*k2**2*(b2*(-2*Pk2*k1**2*(r + s)*(2*s - 1) + 2*Pk2*k2**2*(2*r**2 - 2*r*s + r - 4*s**2 + 4*s - 1) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(2*s - 1)*(2*r + 2*s - 1)) - g2*(4*Pk2*k1**2*(-r*s + r + s*(2 - 4*s)) + 2*Pk2*k2**2*(12*r**2 - 3*r*s - 2*(1 - 2*s)**2) + 2*Pkd2*k1**2*k2*(r + 2*s)*(2*s - 1) + Pkd2*k2**3*(2*r*(15*s - 7) + 5*(1 - 2*s)**2) + Pkdd2*k2**4*(1 - 2*s)**2))) + Dd*f*(f**2*k1**4*(6*k1**2*(Pk2*(10*r*(17*s - 4) + 768*s**2 - 461*s + 66) + k2*(Pkd2*(-50*r*s + 15*r - 264*s**2 + 173*s - 28) + 3*Pkdd2*k2*(8*s**2 - 6*s + 1))) + 5*k2**2*(Pk2*(-90*r*s + 36*r - 240*s**2 + 185*s - 38) + 5*Pkd2*k2*(12*s**2 - 7*s + 1))) - 6*f*k2**2*(Pk2*k2**4*(32*C - 16)*(6*r**2 - 5*r + 1) + k1**4*(4*C*Pk2*(12*r**2 - 16*r*(9*s - 2) - 228*s**2 + 193*s - 35) - 6*Pk2*(32*r**2 + r*(8*s - 29) - 64*s**2 + 34*s + 1) + Pkd2*k2*(2*C*(8*r*(24*s - 7) + 228*s**2 - 213*s + 43) - 9*r*(24*s - 7) - 276*s**2 + 251*s - 50) + Pkdd2*k2**2*(2*C - 1)*(12*s**2 - 7*s + 1)) - 2*k1**2*k2**2*(Pk2*(4*C*(54*r**2 + 96*r*s - 29*r - 40*s - 1) - 156*r**2 - 150*r*s + 105*r + 57*s - 9) + Pkd2*k2*(4*C - 2)*(r*(24*s - 7) - 10*s + 3))) - 396*k1**2*k2**2*(b2*(-2*Pk2*k1**2*(r + s)*(4*s - 1) + 2*Pk2*k2**2*(4*r**2 - 4*r*s - r - 8*s**2 + 6*s - 1) + Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*Pkd2*k2**3*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) - g2*(4*Pk2*k1**2*(-2*r*s + r - 8*s**2 + s) + 2*Pk2*k2**2*(24*r**2 - 6*r*(s + 3) - 16*s**2 + 3*s + 4) + 2*Pkd2*k1**2*k2*(r + 2*s)*(4*s - 1) + Pkd2*k2**3*(6*r*(10*s - 3) + 40*s**2 - 40*s + 9) + Pkdd2*k2**4*(8*s**2 - 6*s + 1))))))/(693*d**2*k1**2*k2**2*k3**4) + D1**3*Pk3*st**2*(33*D1*bd1*f*(f**2*k1**4*(k1**2*(Pk2*(r*(83*s + 4) + 96*s**2 - 104*s - 4) + k2*(Pkd2*(-27*r*s - 2*r - 40*s**2 + 44*s + 2) + 4*Pkdd2*k2*s*(s - 1))) + 3*k2**2*(Pk2*(4*r**2 - 4*r*(9*s + 1) - 24*s**2 + 22*s + 4) + Pkd2*k2*(6*r - 8*s**2 + 11*s - 6))) + f*(4*Pk2*k2**6*r*(C*(2 - 6*r) + 3*r - 1) - 4*k1**6*(Pk2*(2*b1*(r*(10*s - 1) + 10*s**2 - 9*s + 1) - 2*r*s + r + (s - 1)*(s*(K - 3) + 1)) + b1*k2*(Pkd2*(-10*r*s + r - 8*s**2 + 8*s - 1) + Pkdd2*k2*s*(1 - 2*s))) + k1**4*k2**2*(Pk2*b1*(128*r**2 + 6*r*(23*s - 26) + 64*s**2 - 101*s + 52) - 4*Pk2*(2*C*(2*r**2 - r*(5*s + 3) - 3*s**2 + 8*s + 2) + K*(7*r**2 + 51*r*s - 11*r + 64*s**2 - 30*s + 4) - 7*r**2 - 9*r*s + 16*r - 15*s**2 + 9*s - 9) + Pkd2*k2*(-8*C*(r*(13*s - 5) + 17*s**2 - 19*s + 2) + 28*K*r*s - 16*K*r + 30*K*s**2 - 46*K*s + 16*K + b1*(-14*r*(s - 1) - 20*s**2 + 13*s - 10) + 56*r*s - 22*r + 72*s**2 - 82*s + 8) - 2*Pkdd2*k2**2*s*(b1*(6*s - 3) + (s - 1)*(4*C - K - 2))) + k1**2*k2**4*(2*Pk2*(2*C*(34*r**2 + 37*r*s - 36*r - 6*s + 4) - 26*K*r**2 - 60*K*r*s + 22*K*r - 96*K*s**2 + 42*K*s + 4*K + b1*(84*r**2 + 5*r*(6*s - 23) - 36*s + 47) - 43*r**2 - 27*r*s + 39*r + 6*s - 4) + k2*(Pkd2*(4*C*(r*(11*s - 10) + 3*s**2 - 7*s + 4) - 2*K*(7*r*(3*s - 2) + 6*s**2 - 24*s + 14) + 42*b1*r*s - 21*b1*s - 26*r*s + 22*r - 6*s**2 + 14*s - 8) + Pkdd2*k2*s*(4*C - 2)*(s - 1)))) - 2*k1**2*k2**2*(b1**2*k2*(14*Pk2*k2*(r - 1)*(3*r + 3*s - 2) + Pkd2*k1**2*(r*(45*s - 11) + 45*s**2 - 52*s + 11)) + b1*(k1**2*(2*Pk2*(K*(2*r**2 + 14*r*s + r - 6*s**2 - 2) - 28*r**2 - 70*r*s + 20*r - 24*s**2 + 38*s + 1) + k2*(K*Pkdd2*k2*s*(2*s - 1) + Pkd2*r*(K*(60*s - 22) - 4*s + 1) + Pkd2*s*(K*(102*s - 59) - 22*s + 12))) + k2**2*(Pk2*(-16*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*K*(4*r**2 + 14*r*s + 6*r + 8*s**2 - 3*s - 8) - 32*r**2 + 12*r*s - 20*r + 16*s**2 - 14*s + 24) + k2*(7*K*Pkdd2*k2*s*(2*s - 1) - Pkd2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 14*K*(5*r*s - r + 5*s**2 - s - 1) + 20*r*s - 5*r - 8*s**2 + s - 2)))) + 2*b2*k2*(14*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*(r*(13*s - 10) + s*(13*s - 13)) + 7*Pkd2*k2**2*(r*(2*s - 1) + s*(2*s - 2))) - 2*g2*(k1**2*(2*Pk2*(r**2 + 7*r*s - s*(3*s - 3)) + Pkd2*k2*(r*(30*s - 22) + s*(51*s - 51)) + Pkdd2*k2**2*s*(s - 1)) + 7*k2**2*(Pk2*(2*r**2 + 7*r*s + s*(4*s - 4)) + Pkd2*k2*(r*(5*s - 4) + s*(5*s - 5)) + Pkdd2*k2**2*s*(s - 1))))) - 66*b1**3*k1**2*k2**3*(D1*fd*(14*Pk2*k2*(r - 1) + 15*Pkd2*k1**2*s)*(r + s - 1) + Dd*f*(14*Pk2*k2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*(r*(60*s - 11) + 60*s**2 - 67*s + 11))) - 33*b1**2*k1**2*(D1*fd*(8*f*k1**4*s*(2*Pk2*(5*r + 5*s - 4) - k2*(Pkd2*(5*r + 4*s - 4) + Pkdd2*k2*s)) + k1**2*k2**2*(-Pk2*(-4*K*(r**2 + r*(7*s + 4) - 3*s**2 + 8*s - 4) + f*(128*r**2 + 46*r*(3*s - 2) + 64*s**2 - 21*s - 4) + 56*r**2 + 140*r*s + 8*r + 48*s**2 + 16*s - 8) + k2*(f*(Pkd2*(2*r*(7*s + 10) + 20*s**2 + 17*s - 20) + 12*Pkdd2*k2*s**2) + 2*s*(K*Pkdd2*k2*s + Pkd2*r*(30*K - 2) + Pkd2*s*(51*K - 11)))) + k2**4*(14*K*k2*(Pkd2*(r*(5*s + 4) + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2) - 2*Pk2*(16*C*(r + s - 1)**2 - 14*K*r**2 - 49*K*r*s - 84*K*r - 28*K*s**2 - 56*K*s + 28*K + f*(84*r**2 + 30*r*s - 94*r - 36*s + 26) + 16*r**2 - 6*r*s + 52*r - 8*s**2 + 20*s - 12) - Pkd2*k2*s*(16*C*(r + s - 1) + 21*f*(2*r - 1) + 20*r - 8*s + 8))) + 2*Dd*f*(f*(2*k1**4*(Pk2*(r*(40*s - 2) + 40*s**2 - 34*s + 2) + k2*(Pkd2*(-20*r*s + r - 16*s**2 + 16*s - 1) + Pkdd2*k2*s*(1 - 4*s))) + k1**2*k2**2*(-Pk2*(128*r**2 + 2*r*(69*s - 62) + 64*s**2 - 61*s + 24) + k2*(Pkd2*(14*r*s + 3*r + 20*s**2 + 2*s - 5) + 3*Pkdd2*k2*s*(4*s - 1))) + k2**4*(Pk2*(-168*r**2 - 60*r*s + 209*r + 72*s - 73) + 21*Pkd2*k2*s*(1 - 2*r))) + k1**2*k2**2*(2*Pk2*(K*(4*r**2 + 28*r*s + 6*r - 12*s**2 + 5*s - 8) - 56*r**2 - 140*r*s + 31*r - 48*s**2 + 60*s + 4) + k2*(K*Pkdd2*k2*s*(4*s - 1) + Pkd2*r*(2*K*(60*s - 11) - 8*s + 1) + Pkd2*s*(K*(204*s - 67) - 44*s + 13))) + k2**4*(-2*Pk2*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 7*K*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) + 32*r**2 - 12*r*s + 41*r - 16*s**2 + 20*s - 31) + k2*(7*K*Pkdd2*k2*s*(4*s - 1) + Pkd2*(-4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*K*(20*r*s + 4*r + 20*s**2 + 9*s - 8) - 40*r*s + 5*r + 16*s**2 - 2*s + 2))))) + 33*b1*(D1*(f**2*fd*k1**4*(k1**2*(Pk2*(3*r*(83*s - 24) + 288*s**2 - 230*s + 56) + k2*(Pkd2*(-81*r*s + 24*r - 120*s**2 + 54*s - 14) + 2*Pkdd2*k2*(6*s**2 + 4*s - 1))) + 3*k2**2*(2*Pk2*(6*r**2 - 54*r*s + 10*r - 36*s**2 + 45*s - 10) + 3*Pkd2*k2*(6*r - 8*s**2 + 7*s - 4))) - 2*f*fd*(2*Pk2*k1**6*(2*K*s**2 - 3*K*s + K - 4*r*s + 3*r - 6*s**2 + 9*s - 3) + Pk2*k2**6*(4*C - 2)*(6*r**2 - 5*r + 1) + k1**4*k2**2*(2*Pk2*(2*C*(4*r**2 + r*(9 - 10*s) - 6*s**2 + 22*s - 12) + K*(14*r**2 + 102*r*s - 39*r + 128*s**2 - 84*s + 10) - 14*r**2 - 18*r*s - 30*s**2 + 3*s + 10) - k2*(Pkd2*(-136*C*s**2 + 48*C*s + K*(4*r*(7*s - 5) + 30*s**2 - 41*s + 13) + r*(-104*C*s + 56*s + 3) + 72*s**2 - 21*s - 2) + Pkdd2*k2*(K*(2*s**2 - 3*s + 1) + s**2*(4 - 8*C)))) + k1**2*k2**4*(Pk2*(-2*C*(68*r**2 + r*(74*s - 48) - 23*s + 10) + 2*K*(26*r**2 + r*(60*s - 29) + 24*(1 - 2*s)**2) + 86*r**2 + 54*r*s - 56*r - 17*s + 12) + k2*(Pkd2*(-2*C*(22*r*s + 6*r + 6*s**2 + 3*s - 6) + 14*K*r*(3*s - 2) + 3*K*(1 - 2*s)**2 + 2*r*(13*s + 3) + 6*s**2 + 2*s - 6) + Pkdd2*k2*s**2*(2 - 4*C)))) + 4*f*k1**2*k2**2*(-bd2*k2*(14*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*s*(13*r + 13*s - 3) + 7*Pkd2*k2**2*s*(2*r + 2*s - 1)) + gd2*(k1**2*(2*Pk2*(r**2 + 7*r*s + r - 3*s**2 - 3*s - 2) + k2*s*(Pkd2*(30*r + 51*s - 8) + Pkdd2*k2*s)) + 7*k2**2*(Pk2*(2*r**2 + r*(7*s + 6) + 4*s**2 + s - 8) + k2*(Pkd2*(5*r*s + 2*r + 5*s**2 + 3*s - 2) + Pkdd2*k2*s**2)))) + 4*fd*k1**2*k2**2*(-b2*k2*(r + s)*(14*Pk2*k2*(r + s) + 13*Pkd2*k1**2*s + 14*Pkd2*k2**2*s) + g2*(k1**2*(2*Pk2*(r**2 + 7*r*s + 4*r - 3*s**2 + 8*s - 4) + k2*s*(30*Pkd2*r + 51*Pkd2*s + Pkdd2*k2*s)) + 7*k2**2*(Pk2*(2*r**2 + 7*r*s + 12*r + 4*s**2 + 8*s - 4) + k2*(Pkd2*(5*r*s + 4*r + 5*s**2 + 8*s - 4) + Pkdd2*k2*s**2))))) + 2*Dd*f*(f**2*k1**4*(k1**2*(Pk2*(2*r*(83*s - 17) + 192*s**2 - 167*s + 26) + k2*(Pkd2*(-54*r*s + 11*r - 80*s**2 + 49*s - 6) + Pkdd2*k2*(8*s**2 + 2*s - 1))) + 3*k2**2*(8*Pk2*(r**2 - 9*r*s + r - 6*s**2 + 7*s - 1) + Pkd2*k2*(12*r - 16*s**2 + 16*s - 9))) + f*(-2*Pk2*k1**6*(4*K*s**2 - 5*K*s + K - 8*r*s + 5*r - 12*s**2 + 17*s - 5) + Pk2*k2**6*(4 - 8*C)*(6*r**2 - 5*r + 1) + k1**4*k2**2*(-2*Pk2*(2*C*(8*r**2 + r*(5 - 20*s) - 12*s**2 + 39*s - 11) + K*(28*r**2 + 204*r*s - 61*r + 256*s**2 - 144*s + 18) - 28*r**2 - 36*r*s + 26*r - 60*s**2 + 17*s - 2) + k2*(Pkd2*(-4*C*(r*(52*s - 5) + 68*s**2 - 41*s + 2) + K*(56*r*s - 36*r + 60*s**2 - 87*s + 29) + 112*r*s - 7*r + 144*s**2 - 82*s + 1) + Pkdd2*k2*(4*s - 1)*(K*(s - 1) + s*(2 - 4*C)))) + k1**2*k2**4*(2*Pk2*(2*C*(68*r**2 + r*(74*s - 63) - 23*s + 11) - K*(52*r**2 + 120*r*s - 51*r + 192*s**2 - 138*s + 20) - 86*r**2 - 54*r*s + 74*r + 17*s - 13) + k2*(Pkd2*(2*C*(r*(44*s - 2) + 12*s**2 - 5*s - 4) + K*(-84*r*s + 56*r - 24*s**2 + 60*s - 31) - 52*r*s + 3*r - 12*s**2 + 7*s + 4) + Pkdd2*k2*s*(2*C - 1)*(4*s - 1)))) + 2*k1**2*k2**2*(b2*k2*(-14*Pk2*k2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pkd2*k1**2*(r*(10 - 52*s) + s*(19 - 52*s)) - 7*Pkd2*k2**2*(r*(8*s - 1) + 4*s*(2*s - 1))) + g2*(k1**2*(2*Pk2*(4*r**2 + r*(28*s + 6) - 12*s**2 + 5*s - 8) + k2*(2*Pkd2*r*(60*s - 11) + Pkd2*s*(204*s - 67) + Pkdd2*k2*s*(4*s - 1))) + 7*k2**2*(2*Pk2*(4*r**2 + 2*r*(7*s + 6) + 8*s**2 + 3*s - 10) + k2*(Pkd2*(20*r*s + 4*r + 20*s**2 + 9*s - 8) + Pkdd2*k2*s*(4*s - 1))))))) + 2*f*k1**2*(D1*(3*f**2*fd*k1**4*(Pk2*(5*r*(12*s + 47) - 1008*s**2 + 660*s - 227) + Pkd2*k2*(110*r*(3*s - 2) + 648*s**2 - 651*s + 191)) + f*(-2*Pk2*fd*k1**4*(2*C*(27*s**2 - 84*s + 25) - 6*r*(9*s - 14) - 108*s**2 + 321*s - 117) - 66*bd2*k2**2*(Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(4*r**2 + 21*r*s - 5*r + 17*s**2 - 8*s + 1) - Pkd2*k2*(5*s - 3)*(r + s - 1))) + fd*k1**2*k2**2*(2*Pk2*(6*C*(69*r**2 - 423*r*s + 172*r - 594*s**2 + 636*s - 164) - 801*r**2 + 423*r*s - 36*r + 1782*s**2 - 1956*s + 508) + 33*k2*(2*C*Pkd2*(14*r*(3*s - 2) + 39*s**2 - 62*s + 21) - 8*Pkd2*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + Pkdd2*k2*(2*C - 1)*(3*s**2 - 4*s + 1))) + fd*k2**4*(Pk2*(4*C*(1080*r**2 + 3267*r*s - 1842*r + 1188*s**2 - 1782*s + 593) - 2457*r**2 - 7128*r*s + 3981*r - 2376*s**2 + 3564*s - 1186) + Pkd2*k2*(66*C - 33)*(r*(9*s - 6) + 18*s**2 - 18*s + 5)) + 66*gd2*(2*Pk2*k1**4*s*(s - 1) + k1**2*k2**2*(2*Pk2*(7*r**2 + r*(51*s - 11) + 64*s**2 - 30*s + 4) + k2*(Pkd2*(-14*r*s + 8*r - 15*s**2 + 23*s - 8) - Pkdd2*k2*s*(s - 1))) + k2**4*(Pk2*(26*r**2 + r*(60*s - 22) + 96*s**2 - 42*s - 4) + Pkd2*k2*(7*r*(3*s - 2) + 6*s**2 - 24*s + 14)))) + 66*fd*(-b2*k2**2*(Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*(2*Pk2*(8*r**2 + 6*r*(7*s - 3) + 34*s**2 - 23*s + 3) + Pkd2*k2*(r*(7 - 10*s) - 10*s**2 + 13*s - 4))) + g2*(2*Pk2*k1**4*(2*s**2 - 3*s + 1) + k1**2*k2**2*(2*Pk2*(14*r**2 + 102*r*s - 39*r + 128*s**2 - 84*s + 10) - k2*(Pkd2*(4*r*(7*s - 5) + 30*s**2 - 41*s + 13) + Pkdd2*k2*(2*s**2 - 3*s + 1))) + k2**4*(2*Pk2*(26*r**2 + r*(60*s - 29) + 24*(1 - 2*s)**2) + Pkd2*k2*(14*r*(3*s - 2) + 3*(1 - 2*s)**2))))) + Dd*f*(-66*b2*k2**2*(Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(16*r**2 + 84*r*s - 28*r + 68*s**2 - 39*s + 5) + Pkd2*k2*(-20*r*s + 13*r - 20*s**2 + 29*s - 10))) + 3*f**2*k1**4*(Pk2*(5*r*(12*s + 47) - 1008*s**2 + 660*s - 227) + Pkd2*k2*(110*r*(3*s - 2) + 648*s**2 - 651*s + 191)) + f*(2*Pk2*k1**4*(C*(-72*s**2 + 218*s - 50) + 72*r*s - 109*r + 144*s**2 - 422*s + 142) + k1**2*k2**2*(2*Pk2*(2*C*(276*r**2 - 1692*r*s + 577*r - 2376*s**2 + 2498*s - 622) - 1068*r**2 + 564*r*s + 93*r + 2376*s**2 - 2578*s + 646) + 33*k2*(Pkd2*(2*C*(56*r*s - 36*r + 52*s**2 - 85*s + 29) - 64*r*s + 41*r - 64*s**2 + 98*s - 33) + Pkdd2*k2*(2*C - 1)*(4*s**2 - 5*s + 1))) + k2**4*(2*Pk2*(2*C*(1440*r**2 + 4356*r*s - 2399*r + 1584*s**2 - 2376*s + 790) - 1638*r**2 - 4752*r*s + 2597*r - 1584*s**2 + 2376*s - 790) + Pkd2*k2*(66*C - 33)*(4*r*(3*s - 2) + 24*s**2 - 24*s + 7))) + 66*g2*(2*Pk2*k1**4*(4*s**2 - 5*s + 1) + k1**2*k2**2*(2*Pk2*(28*r**2 + 204*r*s - 61*r + 256*s**2 - 144*s + 18) - k2*(Pkd2*(56*r*s - 36*r + 60*s**2 - 87*s + 29) + Pkdd2*k2*(4*s**2 - 5*s + 1))) + k2**4*(2*Pk2*(52*r**2 + 120*r*s - 51*r + 192*s**2 - 138*s + 20) + Pkd2*k2*(84*r*s - 56*r + 24*s**2 - 60*s + 31))))))/(693*d**2*k1**2*k2**2*k3**4) + 2*D1**3*Pkd3*b1*ct*k1*st**4*(4*Pk2 - Pkd2*k2)*(D1*bd1*f*(4*r*(s*(f - 2) + 1) + s**2*(4*f - 8) + s*(10 - 3*f) - 2) + b1*(D1*fd*(r + s - 1)*(f*(4*s - 1) - 4*s + 4) + Dd*f*(f*(8*r*s - r + 8*s**2 - 8*s + 1) - 16*r*s + 10*r - 16*s**2 + 24*s - 8)))/(7*d**2*k2*k3) + 20*D1**3*Pkd3*ct**8*f*k1**2*k2**2*(4*Pk2 - Pkd2*k2)*(429*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 2*D1*(7*f**2*fd*(2*r*(256*s - 77) + 512*s**2 - 512*s + 109) + 13*f*(fd*(C - 1)*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) - 33*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 858*fd*g2*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(7*f**2*(2*r*(256*s - 77) + 512*s**2 - 512*s + 109) + f*(13*C - 13)*(r*(408*s - 163) + 408*s**2 - 408*s + 107) - 858*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 858*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2)))/(9009*d**2*k3**5) + 10*D1**3*Pkd3*ct**7*f*k1*k2*(4*Pk2 - Pkd2*k2)*(2*D1*bd1*f*(f*(r*(135*s - 28) + 135*s**2 - 135*s + 28) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) + b1*(D1*fd*(f*(810*r*s - 303*r + 810*s**2 - 810*s + 191) + (264*s - 132)*(2*r + 2*s - 1)) + Dd*f*(f*(1080*r*s - 359*r + 1080*s**2 - 1080*s + 247) + 1056*r*s - 396*r + 1056*s**2 - 1056*s + 264)) + 2*f*(D1*fd*(9*r*(34*s - 15) + 306*s**2 - 306*s + 79) + Dd*f*(r*(408*s - 163) + 408*s**2 - 408*s + 107)))/(693*d**2*k3**3) + 2*D1**3*Pkd3*ct**7*f*k1*k2*(13*D1*bd1*f*(k1**2*(198*K - 198)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + 5*k2**2*(Pk2*f*(675*r**2 + r*(810*s - 958) + 135*s**2 - 530*s + 283) - 66*Pk2*(2*K*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) - 18*r**2 + r*(23 - 20*s) - 2*s**2 + 11*s - 5) + 2*Pkd2*f*k2*(r*(135*s - 28) + 135*s**2 - 135*s + 28) + Pkd2*k2*(66 - 132*K)*(r*(4*s - 1) + (1 - 2*s)**2))) - 2*D1*(-10*f**2*fd*(-13*Pk2*k2**2*(184*r**2 + 2*r*(92*s - 73) - 36*s + 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(r*(1424*s - 499) + 1424*s**2 - 1554*s + 371)) - 13*f*(fd*k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(29*s - 17)*(3*r + 3*s - 2) - fd*k2**2*(Pk2*(2*C*(2673*r**2 + r*(2337 - 7407*s) - 6120*s**2 + 9189*s - 2636) - 9171*r**2 + 9*r*(16*s + 179) + 5355*s**2 - 8403*s + 2672) + 5*Pkd2*k2*(8*C*(3*s - 1)*(84*r + 51*s - 56) - 3*r*(438*s - 157) - 918*s**2 + 1182*s - 303)) - 198*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + 660*gd2*k2**2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) + 1716*fd*g2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4) - 10*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1))) - 2*Dd*f*(-10*f**2*(-13*Pk2*k2**2*(184*r**2 + 2*r*(92*s - 73) - 36*s + 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(r*(1424*s - 499) + 1424*s**2 - 1554*s + 371)) + 13*f*(k1**2*(60 - 60*C)*(4*Pk2 - Pkd2*k2)*(r*(116*s - 65) + 116*s**2 - 149*s + 48) + k2**2*(Pk2*(4*C*(1782*r**2 - 4938*r*s + 1036*r - 4080*s**2 + 6159*s - 1631) - 12228*r**2 + 192*r*s + 4271*r + 7140*s**2 - 10471*s + 3069) + 5*Pkd2*k2*(8*C*(336*r*s - 98*r + 204*s**2 - 303*s + 70) - 1752*r*s + 555*r - 1224*s**2 + 1620*s - 387))) + 1716*g2*(9*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) - 10*k2**2*(Pk2*(8*r**2 - r*(8*s + 1) - 16*s**2 + 14*s - 3) + Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2)))) + 13*b1*(D1*fd*(k1**2*(396*K - 396)*(4*Pk2 - Pkd2*k2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4) + 5*k2**2*(3*Pk2*f*(675*r**2 + r*(810*s - 643) + 135*s**2 - 305*s + 136) - 66*Pk2*(2*r + 2*s - 1)*(8*K*(r - 2*s + 1) - 18*r - 2*s + 1) + Pkd2*f*k2*(r*(810*s - 303) + 810*s**2 - 810*s + 191) - Pkd2*k2*(264*K - 132)*(2*s - 1)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(1188*K - 1188)*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) + 5*k2**2*(Pk2*f*(2700*r**2 + r*(3240*s - 2887) + 540*s**2 - 1445*s + 691) - 66*Pk2*(4*K*(8*r**2 - r*(8*s + 1) - 16*s**2 + 14*s - 3) - 72*r**2 + r*(66 - 80*s) - 8*s**2 + 26*s - 11) + Pkd2*f*k2*(r*(1080*s - 359) + 1080*s**2 - 1080*s + 247) + Pkd2*k2*(132 - 264*K)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(9009*d**2*k3**5) + 10*D1**3*Pkd3*ct**6*f*k1**2*k2**2*st**2*(4*Pk2 - Pkd2*k2)*(24804*C*D1*f*fd*r*s - 9984*C*D1*f*fd*r + 24804*C*D1*f*fd*s**2 - 24804*C*D1*f*fd*s + 6084*C*D1*f*fd + 33072*C*Dd*f**2*r*s - 11934*C*Dd*f**2*r + 33072*C*Dd*f**2*s**2 - 33072*C*Dd*f**2*s + 8034*C*Dd*f**2 + 1287*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 32984*D1*f**2*fd*r*s - 9611*D1*f**2*fd*r + 32984*D1*f**2*fd*s**2 - 32984*D1*f**2*fd*s + 6867*D1*f**2*fd - 24804*D1*f*fd*r*s + 9984*D1*f*fd*r - 24804*D1*f*fd*s**2 + 24804*D1*f*fd*s - 6084*D1*f*fd - 10296*D1*f*gd2*r*s + 2574*D1*f*gd2*r - 10296*D1*f*gd2*s**2 + 10296*D1*f*gd2*s - 2574*D1*f*gd2 - 20592*D1*fd*g2*r*s + 10296*D1*fd*g2*r - 20592*D1*fd*g2*s**2 + 20592*D1*fd*g2*s - 5148*D1*fd*g2 + 32984*Dd*f**3*r*s - 9611*Dd*f**3*r + 32984*Dd*f**3*s**2 - 32984*Dd*f**3*s + 6867*Dd*f**3 - 33072*Dd*f**2*r*s + 11934*Dd*f**2*r - 33072*Dd*f**2*s**2 + 33072*Dd*f**2*s - 8034*Dd*f**2 - 41184*Dd*f*g2*r*s + 15444*Dd*f*g2*r - 41184*Dd*f*g2*s**2 + 41184*Dd*f*g2*s - 10296*Dd*f*g2 + 2574*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(9009*d**2*k3**5) + D1**3*Pkd3*ct**6*(792*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(792*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 3*D1*(f**2*fd*(11*Pk2*k2**2*(75*r**2 + r*(75*s - 26) + 15*s - 13) - 10*k1**2*(4*Pk2 - Pkd2*k2)*(r*(717*s - 316) + 717*s**2 - 884*s + 248)) - 88*f*(fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(8*s - 7)*(r + s - 1) + r*(20*s - 7) + 20*s**2 - 12*s - 2) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1) - 6*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1)) + 1056*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f**2*(-33*Pk2*k2**2*(50*r**2 + r*(50*s - 29) - 5*s - 3) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(717*s - 293) + 2868*s**2 - 3455*s + 912)) + 132*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(8*r*(4*s - 3) + 32*s**2 - 52*s + 19) + 4*r*(10*s - 3) + 40*s**2 - 38*s + 8) + 5*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1))) - 792*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(D1*bd1*(f**2*(-33*Pk2*k2**2*(r - 1)*(25*r + 25*s - 7) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(r*(717*s - 224) + 717*s**2 - 803*s + 168)) + 132*f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*C*(8*s - 5) + 20*s - 5) + s**2*(16*C + 20) - s*(18*C + 30) + 15) + 5*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) - 1584*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 4*D1*(f*fd*(30*k1**2*(4*Pk2 - Pkd2*k2)*(29*s - 17)*(3*r + 3*s - 2) + k2**2*(-40*C*Pk2*(3*s - 1)*(84*r + 51*s - 56) + 3*Pk2*(-381*r**2 + 3*r*(433*s - 188) + 1020*s**2 - 1663*s + 527) + Pkd2*k2*(20*C - 10)*(3*s - 1)*(84*r + 51*s - 56))) + 165*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(4*s - 1) + (1 - 2*s)**2) + 330*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)*(2*r + 2*s - 1)) + 4*Dd*f*(f*(30*k1**2*(4*Pk2 - Pkd2*k2)*(r*(116*s - 65) + 116*s**2 - 149*s + 48) + k2**2*(Pk2*(-40*C*(336*r*s - 98*r + 204*s**2 - 303*s + 70) - 1524*r**2 + 5196*r*s - 1747*r + 4080*s**2 - 6668*s + 2017) + Pkd2*k2*(20*C - 10)*(14*r*(24*s - 7) + 204*s**2 - 303*s + 70))) + k2**2*(-2*Pk2 + Pkd2*k2)*(330*b2 - 660*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))))/(693*d**2*k3**3) + D1**3*Pkd3*ct**6*(13*D1*bd1*f*(f**2*k2**2*(33*Pk2*k2**2*(r - 1)*(25*r + 25*s - 7) + 10*k1**2*(Pk2*(2055*r**2 + 4*r*(771*s - 724) + 1029*s**2 - 1942*s + 729) + Pkd2*k2*(r*(513*s - 122) + 513*s**2 - 599*s + 178))) + 66*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + k1**2*k2**2*(Pk2*(8*C*(10*r**2 + 14*r*(2*s - 1) + 18*s**2 - 17*s - 1) + K*(-153*r**2 - 107*r*s + 111*r + 46*s**2 - 142*s + 42) + 293*r**2 + 467*r*s - 419*r + 174*s**2 - 274*s + 166) + 2*Pkd2*k2*(-2*C*(r*(8*s - 4) + 8*s**2 - 7*s - 1) - 24*K*(2*s - 1)*(r + s - 1) + 28*r*s - 17*r + 28*s**2 - 38*s + 7)) - 10*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 792*k1**2*k2**2*(-b1*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 10296*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) - 2*Pkd2*k2*s*(r + s)) + Dd*f*(Pk2*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 13*b1*(D1*(f**2*fd*k2**2*(33*Pk2*k2**2*(75*r**2 + r*(75*s - 26) + 15*s - 13) + 10*k1**2*(3*Pk2*(2055*r**2 + 3084*r*s - 2503*r + 1029*s**2 - 1775*s + 812) + Pkd2*k2*(1539*r*s - 948*r + 1539*s**2 - 2040*s + 632))) + 66*f*(fd*(k1**4*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(16*C*(10*r**2 + 4*r*(7*s - 5) + 18*s**2 - 21*s + 10) + K*(-306*r**2 - 214*r*s + 94*r + 92*s**2 - 188*s + 71) + 586*r**2 + 934*r*s - 442*r + 348*s**2 - 312*s + 5) - 4*Pkd2*k2*(16*C*s**2 - 2*C*s + 6*K*(r*(8*s - 5) + 8*s**2 - 10*s + 3) + r*(s*(16*C - 28) + 9) - 28*s**2 + 20*s - 6)) - 10*k2**4*(2*r + 2*s - 1)*(K*Pk2*(18*r + 10*s - 5) + 2*K*Pkd2*k2*(2*s - 1) - 4*Pk2*r)) + 24*gd2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 1584*fd*g2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))) + 2*Dd*f*(f**2*k2**2*(33*Pk2*k2**2*(50*r**2 + r*(50*s - 29) - 5*s - 3) + 5*k1**2*(Pk2*(8220*r**2 + 12336*r*s - 10405*r + 4116*s**2 - 7267*s + 3165) + Pkd2*k2*(2052*r*s - 1070*r + 2052*s**2 - 2639*s + 810))) + 33*f*(k1**4*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + k1**2*k2**2*(Pk2*(8*C*(40*r**2 + 2*r*(56*s - 37) + 72*s**2 - 82*s + 29) + K*(-612*r**2 - 428*r*s + 316*r + 184*s**2 - 472*s + 155) + 1172*r**2 + 1868*r*s - 1232*r + 696*s**2 - 812*s + 249) - 4*Pkd2*k2*(C*(4*r*(8*s - 1) + 32*s**2 - 12*s - 1) + 6*K*(16*r*s - 9*r + 16*s**2 - 22*s + 7) - 56*r*s + 22*r - 56*s**2 + 54*s - 14)) - 10*k2**4*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2))) + 792*g2*k1**2*k2**2*(-Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 2*f*(D1*(5*f**2*fd*k1**2*(28*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(113*s - 51) + 1356*s**2 - 1681*s + 472) + 13*k2**2*(-Pk2*(1486*r**2 + r*(8338*s - 2822) + 6852*s**2 - 6384*s + 1165) + 56*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(-825*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + k1**2*k2**2*(Pk2*(C*(-7821*r**2 + 135*r*(47*s - 45) + 2286*s**2 - 21954*s + 9253) + 15696*r**2 + 45*r*(457*s - 170) + 10809*s**2 + 1779*s - 3273) - 15*Pkd2*k2*(4*C*(207*r*s - 91*r + 108*s**2 - 218*s + 68) - 456*r*s + 229*r - 258*s**2 + 522*s - 171)) + k2**4*(Pk2*(-6*C*(2037*r**2 + 6348*r*s - 2022*r + 1275*s**2 - 3241*s + 681) + 7254*r**2 + 20187*r*s - 6054*r + 3825*s**2 - 9114*s + 1582) + Pkd2*k2*(10 - 20*C)*(3*s - 1)*(84*r + 51*s - 56))) - 33*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + k1**2*k2**2*(Pk2*(-153*r**2 + r*(111 - 107*s) + 46*s**2 - 142*s + 42) - 48*Pkd2*k2*(2*s - 1)*(r + s - 1)) - 10*k2**4*(Pk2*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 858*fd*(25*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + g2*(12*k1**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + k1**2*k2**2*(Pk2*(-306*r**2 + r*(94 - 214*s) + 92*s**2 - 188*s + 71) - 24*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*k2**4*(Pk2*(18*r + 10*s - 5) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-21450*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*f**2*k1**2*(28*k1**2*(4*Pk2 - Pkd2*k2)*(12*r*(113*s - 51) + 1356*s**2 - 1681*s + 472) + 13*k2**2*(-Pk2*(1486*r**2 + r*(8338*s - 2822) + 6852*s**2 - 6384*s + 1165) + 56*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(4*r*(25*s - 27) + 100*s**2 - 199*s + 85) + k1**2*k2**2*(Pk2*(C*(-10428*r**2 + 8460*r*s - 6928*r + 3048*s**2 - 31560*s + 12713) + 20928*r**2 + 27420*r*s - 11737*r + 14412*s**2 + 2905*s - 4418) - 15*Pkd2*k2*(2*C*(552*r*s - 227*r + 288*s**2 - 618*s + 181) - 608*r*s + 291*r - 344*s**2 + 740*s - 233)) + k2**4*(Pk2*(-2*C*(8148*r**2 + 25392*r*s - 8366*r + 5100*s**2 - 14611*s + 2306) + 9672*r**2 + 26916*r*s - 8579*r + 5100*s**2 - 14003*s + 1689) + Pkd2*k2*(10 - 20*C)*(14*r*(24*s - 7) + 204*s**2 - 303*s + 70))) - 858*g2*(12*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + k1**2*k2**2*(Pk2*(-612*r**2 + r*(316 - 428*s) + 184*s**2 - 472*s + 155) - 24*Pkd2*k2*(r*(16*s - 9) + 16*s**2 - 22*s + 7)) - 10*k2**4*(Pk2*(72*r**2 + 2*r*(56*s - 39) + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(9009*d**2*k3**5) + 5*D1**3*Pkd3*ct**5*f*k1*k2*st**2*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(f*(9*r*(118*s - 43) + 1062*s**2 - 1062*s + 247) + (264*s - 132)*(2*r + 2*s - 1)) + 2*D1*bd1*f*(f*(r*(177*s - 35) + 177*s**2 - 177*s + 35) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) + 4*D1*f*fd*(159*r*s - 64*r + 159*s**2 - 159*s + 39) + Dd*b1*f*(f*(1416*r*s - 457*r + 1416*s**2 - 1416*s + 317) + 1056*r*s - 396*r + 1056*s**2 - 1056*s + 264) + 2*Dd*f**2*(r*(424*s - 153) + 424*s**2 - 424*s + 103))/(231*d**2*k3**3) + D1**3*Pkd3*ct**5*f*k1*k2*st**2*(1490112*C*D1*Pk2*f*fd*k1**2*r*s - 661440*C*D1*Pk2*f*fd*k1**2*r + 1490112*C*D1*Pk2*f*fd*k1**2*s**2 - 1627392*C*D1*Pk2*f*fd*k1**2*s + 431808*C*D1*Pk2*f*fd*k1**2 - 419328*C*D1*Pk2*f*fd*k2**2*r**2 + 984672*C*D1*Pk2*f*fd*k2**2*r*s - 196248*C*D1*Pk2*f*fd*k2**2*r + 992160*C*D1*Pk2*f*fd*k2**2*s**2 - 1236768*C*D1*Pk2*f*fd*k2**2*s + 304616*C*D1*Pk2*f*fd*k2**2 - 372528*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 165360*C*D1*Pkd2*f*fd*k1**2*k2*r - 372528*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 406848*C*D1*Pkd2*f*fd*k1**2*k2*s - 107952*C*D1*Pkd2*f*fd*k1**2*k2 - 702000*C*D1*Pkd2*f*fd*k2**3*r*s + 234000*C*D1*Pkd2*f*fd*k2**3*r - 496080*C*D1*Pkd2*f*fd*k2**3*s**2 + 633360*C*D1*Pkd2*f*fd*k2**3*s - 156000*C*D1*Pkd2*f*fd*k2**3 + 1986816*C*Dd*Pk2*f**2*k1**2*r*s - 817440*C*Dd*Pk2*f**2*k1**2*r + 1986816*C*Dd*Pk2*f**2*k1**2*s**2 - 2206464*C*Dd*Pk2*f**2*k1**2*s + 587808*C*Dd*Pk2*f**2*k1**2 - 559104*C*Dd*Pk2*f**2*k2**2*r**2 + 1312896*C*Dd*Pk2*f**2*k2**2*r*s - 105768*C*Dd*Pk2*f**2*k2**2*r + 1322880*C*Dd*Pk2*f**2*k2**2*s**2 - 1632176*C*Dd*Pk2*f**2*k2**2*s + 353912*C*Dd*Pk2*f**2*k2**2 - 496704*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 204360*C*Dd*Pkd2*f**2*k1**2*k2*r - 496704*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 551616*C*Dd*Pkd2*f**2*k1**2*k2*s - 146952*C*Dd*Pkd2*f**2*k1**2*k2 - 936000*C*Dd*Pkd2*f**2*k2**3*r*s + 273000*C*Dd*Pkd2*f**2*k2**3*r - 661440*C*Dd*Pkd2*f**2*k2**3*s**2 + 867360*C*Dd*Pkd2*f**2*k2**3*s - 195000*C*Dd*Pkd2*f**2*k2**3 + 3022080*D1*Pk2*f**2*fd*k1**2*r*s - 970020*D1*Pk2*f**2*fd*k1**2*r + 3022080*D1*Pk2*f**2*fd*k1**2*s**2 - 3201480*D1*Pk2*f**2*fd*k1**2*s + 718740*D1*Pk2*f**2*fd*k1**2 - 168480*D1*Pk2*f**2*fd*k2**2*r**2 - 168480*D1*Pk2*f**2*fd*k2**2*r*s + 133900*D1*Pk2*f**2*fd*k2**2*r + 29640*D1*Pk2*f**2*fd*k2**2*s - 11180*D1*Pk2*f**2*fd*k2**2 - 1490112*D1*Pk2*f*fd*k1**2*r*s + 661440*D1*Pk2*f*fd*k1**2*r - 1490112*D1*Pk2*f*fd*k1**2*s**2 + 1627392*D1*Pk2*f*fd*k1**2*s - 431808*D1*Pk2*f*fd*k1**2 + 729378*D1*Pk2*f*fd*k2**2*r**2 + 89388*D1*Pk2*f*fd*k2**2*r*s - 308412*D1*Pk2*f*fd*k2**2*r - 434070*D1*Pk2*f*fd*k2**2*s**2 + 480948*D1*Pk2*f*fd*k2**2*s - 100256*D1*Pk2*f*fd*k2**2 - 658944*D1*Pk2*f*gd2*k1**2*r*s + 205920*D1*Pk2*f*gd2*k1**2*r - 658944*D1*Pk2*f*gd2*k1**2*s**2 + 741312*D1*Pk2*f*gd2*k1**2*s - 205920*D1*Pk2*f*gd2*k1**2 + 205920*D1*Pk2*f*gd2*k2**2*r**2 - 205920*D1*Pk2*f*gd2*k2**2*r*s - 154440*D1*Pk2*f*gd2*k2**2*r - 411840*D1*Pk2*f*gd2*k2**2*s**2 + 308880*D1*Pk2*f*gd2*k2**2*s - 51480*D1*Pk2*f*gd2*k2**2 - 1317888*D1*Pk2*fd*g2*k1**2*r*s + 700128*D1*Pk2*fd*g2*k1**2*r - 1317888*D1*Pk2*fd*g2*k1**2*s**2 + 1400256*D1*Pk2*fd*g2*k1**2*s - 370656*D1*Pk2*fd*g2*k1**2 + 411840*D1*Pk2*fd*g2*k2**2*r**2 - 411840*D1*Pk2*fd*g2*k2**2*r*s + 205920*D1*Pk2*fd*g2*k2**2*r - 823680*D1*Pk2*fd*g2*k2**2*s**2 + 823680*D1*Pk2*fd*g2*k2**2*s - 205920*D1*Pk2*fd*g2*k2**2 - 755520*D1*Pkd2*f**2*fd*k1**2*k2*r*s + 242505*D1*Pkd2*f**2*fd*k1**2*k2*r - 755520*D1*Pkd2*f**2*fd*k1**2*k2*s**2 + 800370*D1*Pkd2*f**2*fd*k1**2*k2*s - 179685*D1*Pkd2*f**2*fd*k1**2*k2 + 372528*D1*Pkd2*f*fd*k1**2*k2*r*s - 165360*D1*Pkd2*f*fd*k1**2*k2*r + 372528*D1*Pkd2*f*fd*k1**2*k2*s**2 - 406848*D1*Pkd2*f*fd*k1**2*k2*s + 107952*D1*Pkd2*f*fd*k1**2*k2 + 475020*D1*Pkd2*f*fd*k2**3*r*s - 166920*D1*Pkd2*f*fd*k2**3*r + 372060*D1*Pkd2*f*fd*k2**3*s**2 - 440700*D1*Pkd2*f*fd*k2**3*s + 108420*D1*Pkd2*f*fd*k2**3 + 164736*D1*Pkd2*f*gd2*k1**2*k2*r*s - 51480*D1*Pkd2*f*gd2*k1**2*k2*r + 164736*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 185328*D1*Pkd2*f*gd2*k1**2*k2*s + 51480*D1*Pkd2*f*gd2*k1**2*k2 + 205920*D1*Pkd2*f*gd2*k2**3*r*s - 51480*D1*Pkd2*f*gd2*k2**3*r + 205920*D1*Pkd2*f*gd2*k2**3*s**2 - 205920*D1*Pkd2*f*gd2*k2**3*s + 51480*D1*Pkd2*f*gd2*k2**3 + 329472*D1*Pkd2*fd*g2*k1**2*k2*r*s - 175032*D1*Pkd2*fd*g2*k1**2*k2*r + 329472*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 350064*D1*Pkd2*fd*g2*k1**2*k2*s + 92664*D1*Pkd2*fd*g2*k1**2*k2 + 411840*D1*Pkd2*fd*g2*k2**3*r*s - 205920*D1*Pkd2*fd*g2*k2**3*r + 411840*D1*Pkd2*fd*g2*k2**3*s**2 - 411840*D1*Pkd2*fd*g2*k2**3*s + 102960*D1*Pkd2*fd*g2*k2**3 + 39*D1*bd1*f*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + 5*k2**2*(Pk2*f*(885*r**2 + 2*r*(531*s - 640) + 177*s**2 - 712*s + 395) - 66*Pk2*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) + 2*Pkd2*f*k2*(r*(177*s - 35) + 177*s**2 - 177*s + 35) + Pkd2*k2*(66 - 132*K)*(r*(4*s - 1) + (1 - 2*s)**2))) + 3022080*Dd*Pk2*f**3*k1**2*r*s - 970020*Dd*Pk2*f**3*k1**2*r + 3022080*Dd*Pk2*f**3*k1**2*s**2 - 3201480*Dd*Pk2*f**3*k1**2*s + 718740*Dd*Pk2*f**3*k1**2 - 168480*Dd*Pk2*f**3*k2**2*r**2 - 168480*Dd*Pk2*f**3*k2**2*r*s + 133900*Dd*Pk2*f**3*k2**2*r + 29640*Dd*Pk2*f**3*k2**2*s - 11180*Dd*Pk2*f**3*k2**2 - 1986816*Dd*Pk2*f**2*k1**2*r*s + 817440*Dd*Pk2*f**2*k1**2*r - 1986816*Dd*Pk2*f**2*k1**2*s**2 + 2206464*Dd*Pk2*f**2*k1**2*s - 587808*Dd*Pk2*f**2*k1**2 + 972504*Dd*Pk2*f**2*k2**2*r**2 + 119184*Dd*Pk2*f**2*k2**2*r*s - 576342*Dd*Pk2*f**2*k2**2*r - 578760*Dd*Pk2*f**2*k2**2*s**2 + 567086*Dd*Pk2*f**2*k2**2*s - 75452*Dd*Pk2*f**2*k2**2 - 2635776*Dd*Pk2*f*g2*k1**2*r*s + 1111968*Dd*Pk2*f*g2*k1**2*r - 2635776*Dd*Pk2*f*g2*k1**2*s**2 + 2882880*Dd*Pk2*f*g2*k1**2*s - 782496*Dd*Pk2*f*g2*k1**2 + 823680*Dd*Pk2*f*g2*k2**2*r**2 - 823680*Dd*Pk2*f*g2*k2**2*r*s - 102960*Dd*Pk2*f*g2*k2**2*r - 1647360*Dd*Pk2*f*g2*k2**2*s**2 + 1441440*Dd*Pk2*f*g2*k2**2*s - 308880*Dd*Pk2*f*g2*k2**2 - 755520*Dd*Pkd2*f**3*k1**2*k2*r*s + 242505*Dd*Pkd2*f**3*k1**2*k2*r - 755520*Dd*Pkd2*f**3*k1**2*k2*s**2 + 800370*Dd*Pkd2*f**3*k1**2*k2*s - 179685*Dd*Pkd2*f**3*k1**2*k2 + 496704*Dd*Pkd2*f**2*k1**2*k2*r*s - 204360*Dd*Pkd2*f**2*k1**2*k2*r + 496704*Dd*Pkd2*f**2*k1**2*k2*s**2 - 551616*Dd*Pkd2*f**2*k1**2*k2*s + 146952*Dd*Pkd2*f**2*k1**2*k2 + 633360*Dd*Pkd2*f**2*k2**3*r*s - 196170*Dd*Pkd2*f**2*k2**3*r + 496080*Dd*Pkd2*f**2*k2**3*s**2 - 599040*Dd*Pkd2*f**2*k2**3*s + 137670*Dd*Pkd2*f**2*k2**3 + 658944*Dd*Pkd2*f*g2*k1**2*k2*r*s - 277992*Dd*Pkd2*f*g2*k1**2*k2*r + 658944*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 720720*Dd*Pkd2*f*g2*k1**2*k2*s + 195624*Dd*Pkd2*f*g2*k1**2*k2 + 823680*Dd*Pkd2*f*g2*k2**3*r*s - 308880*Dd*Pkd2*f*g2*k2**3*r + 823680*Dd*Pkd2*f*g2*k2**3*s**2 - 823680*Dd*Pkd2*f*g2*k2**3*s + 205920*Dd*Pkd2*f*g2*k2**3 + 39*b1*(D1*fd*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 17) + 32*s**2 - 34*s + 9) + 5*k2**2*(9*Pk2*f*(295*r**2 + r*(354*s - 289) + 59*s**2 - 139*s + 64) - 66*Pk2*(2*r + 2*s - 1)*(8*K*(r - 2*s + 1) - 18*r - 2*s + 1) + Pkd2*k2*(f*(9*r*(118*s - 43) + 1062*s**2 - 1062*s + 247) + (132 - 264*K)*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(r*(64*s - 27) + 64*s**2 - 70*s + 19) + 5*k2**2*(Pk2*f*(3540*r**2 + r*(4248*s - 3881) + 708*s**2 - 1963*s + 971) - 66*Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*f*k2*(r*(1416*s - 457) + 1416*s**2 - 1416*s + 317) + Pkd2*k2*(132 - 264*K)*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(9009*d**2*k3**5) + 4*D1**3*Pkd3*ct**5*k1*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*(r*(8*s - 5) + s*(8*s - 9)) + b1**2*(D1*fd*(r + s - 1)*(f*(28*s - 17) + 12*s - 12) + Dd*f*(f*(56*r*s - 27*r + 56*s**2 - 76*s + 22) + 48*r*s - 30*r + 48*s**2 - 72*s + 24)) + b1*f*(D1*bd1*(f*(28*r*s - 10*r + 28*s**2 - 31*s + 5) + 24*r*s - 12*r + 24*s**2 - 30*s + 6) + 2*D1*fd*(8*s - 7)*(r + s - 1) + Dd*f*(8*r*(4*s - 3) + 32*s**2 - 52*s + 19)))/(21*d**2*k2*k3) - 2*D1**3*Pkd3*ct**5*(-66*b1**2*k1**2*(D1*fd*(k1**2*(5*K - 5)*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1) + k2**2*(2*Pk2*f*(7*r**2 + r*(14*s + 3) + 7*s**2 + 20*s - 10) - 6*Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 + r*(2 - 6*s) - s**2 - 6*s + 3) - 17*Pkd2*f*k2*(r + 2*s - 1) - 12*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1))) + Dd*f*(k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(20*s - 23) + 20*s**2 - 37*s + 17) + k2**2*(Pk2*(-12*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + f*(28*r**2 + r*(56*s - 9) + 28*s**2 + 31*s - 19) + 120*r**2 + 144*r*s - 102*r + 24*s**2 + 30*s - 6) - 4*Pkd2*k2*(3*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*f*(r + 2*s - 1) + 6*r + 12*s - 6)))) + b1*k1**2*(-66*D1*bd1*f*(k1**2*(2*K - 2)*(4*Pk2 - Pkd2*k2)*(r*(5*s - 6) + 5*s**2 - 8*s + 3) + k2**2*(Pk2*(-12*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) + f*(14*r**2 + r*(28*s - 15) + 14*s**2 - 9*s + 1) + 60*r**2 + 72*r*s - 54*r + 12*s**2 - 6*s + 6) - 3*Pkd2*k2*(4*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(r + 2*s - 1) + 2*r + 4*s - 2))) + 3*D1*(f**2*fd*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(123*s - 74) + 492*s**2 - 727*s + 250) - 11*k2**2*(-Pk2*(81*r**2 + 786*r*s - 315*r + 705*s**2 - 653*s + 146) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) - 11*f*(fd*(4*k1**2*(4*Pk2 - Pkd2*k2)*(4*C*(s - 2)*(r + s - 1) + 7*r*(2*s - 1) + 14*s**2 - 15*s + 1) - k2**2*(Pk2*(8*C*(10*r**2 + r*(37 - 70*s) - 32*s**2 + 103*s - 47) + 24*K*(12*r*s - 7*r + 12*s**2 - 14*s + 4) + 66*r**2 + 822*r*s - 490*r + 564*s**2 - 972*s + 369) + 4*Pkd2*k2*(8*C*(2*s - 1)*(5*r + 2*s - 5) - 3*K*(12*r*s - 7*r + 12*s**2 - 14*s + 4) - 64*r*s + 39*r - 40*s**2 + 86*s - 33))) + 4*gd2*(-k1**2*(4*Pk2 - Pkd2*k2)*(5*s - 6) + 12*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1)))*(r + s - 1)) - 44*fd*g2*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + 24*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1)))*(r + s - 1)) + Dd*f*(f**2*(-10*k1**2*(4*Pk2 - Pkd2*k2)*(8*r*(123*s - 73) + 984*s**2 - 1406*s + 459) - 33*k2**2*(-Pk2*(108*r**2 + 1048*r*s - 381*r + 940*s**2 - 845*s + 185) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) - 33*f*(4*k1**2*(4*Pk2 - Pkd2*k2)*(C*(2*r*(4*s - 9) + 8*s**2 - 22*s + 13) + 4*r*(7*s - 3) + 28*s**2 - 41*s + 11) - k2**2*(Pk2*(16*C*(10*r**2 + r*(27 - 70*s) - 32*s**2 + 95*s - 29) + 72*K*(2*s - 1)*(4*r + 4*s - 3) + 132*r**2 + 1644*r*s - 832*r + 1128*s**2 - 1800*s + 557) + 4*Pkd2*k2*(2*C*(10*r*(8*s - 3) + 32*s**2 - 88*s + 25) - 9*K*(2*s - 1)*(4*r + 4*s - 3) - 128*r*s + 58*r - 80*s**2 + 156*s - 47))) + 132*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(20*s - 23) + 20*s**2 - 37*s + 17) - 12*k2**2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))) + f*(D1*bd1*k1**2*(f**2*(-5*k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(123*s - 70) + 492*s**2 - 631*s + 168) - 33*k2**2*(-Pk2*(27*r**2 + r*(262*s - 66) + 235*s**2 - 192*s + 39) + 10*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) - 33*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*C*(2*s - 5) + 14*s - 5) + s**2*(4*C + 14) - s*(6*C + 30) + 15) + k2**2*(-Pk2*(-128*C*s**2 + 288*C*s + 12*K*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + r**2*(40*C + 33) + r*(-280*C*s + 88*C + 411*s - 187) + 282*s**2 - 382*s + 66) + 2*Pkd2*k2*(-32*C*s**2 + 60*C*s + 3*K*(r*(12*s - 5) + 12*s**2 - 16*s + 5) + r*(-80*C*s + 20*C + 64*s - 17) + 40*s**2 - 56*s + 7))) + 132*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(5*s - 6) + s*(5*s - 5)) - 12*k2**2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) + D1*(f*fd*(Pk2*k2**4*(4*C - 2)*(3*r - 1)*(129*r - 234*s - 196) - 30*k1**4*(4*Pk2 - Pkd2*k2)*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + k1**2*k2**2*(Pk2*(120*C*(r*(240*s - 113) + 174*s**2 - 262*s + 79) + 2601*r**2 + 45*r*(127*s + 57) + 7074*s**2 + 4434*s - 4043) - 60*Pkd2*k2*(C*(r*(240*s - 113) + 174*s**2 - 262*s + 79) + r*(29 - 54*s) - 21*s**2 + 65*s - 23))) - 198*f*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(12*s - 5) + 12*s**2 - 16*s + 5) - 396*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(12*r*s - 7*r + 12*s**2 - 14*s + 4)) + Dd*f*(f*(Pk2*k2**4*(8*C - 4)*(258*r**2 - 78*r*(6*s + 7) + 184*s + 221) - 30*k1**4*(4*Pk2 - Pkd2*k2)*(4*r*(25*s - 27) + 100*s**2 - 199*s + 85) + k1**2*k2**2*(Pk2*(120*C*(320*r*s - 141*r + 232*s**2 - 364*s + 107) + 3468*r**2 + 7620*r*s + 3638*r + 9432*s**2 + 7020*s - 5983) - 30*Pkd2*k2*(C*(640*r*s - 282*r + 464*s**2 - 728*s + 214) - 144*r*s + 75*r - 56*s**2 + 188*s - 63))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-1188*b2 + 2376*g2)*(2*s - 1)*(4*r + 4*s - 3))))/(693*d**2*k1*k2*k3**3) + 2*D1**3*Pkd3*ct**5*(13*D1*bd1*f*k1**2*(f**2*k2**2*(5*k1**2*(Pk2*(1620*r**2 + 9*r*(328*s - 243) + 1332*s**2 - 1727*s + 383) + Pkd2*k2*(3*r*(48*s - 53) + 144*s**2 - 389*s + 251)) - 66*k2**2*(Pk2*(56*r**2 + 51*r*s - 67*r - 5*s**2 - 27*s + 20) + 5*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + 33*f*(k1**4*(2*K - 2)*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) - 2*k1**2*k2**2*(-Pk2*(4*C*(5*r**2 + r*(16*s - 5) + 11*s**2 - 8*s - 3) + K*(-19*r**2 - 115*r*s + 4*r - 96*s**2 + 26*s + 15) + 59*r**2 + 207*r*s - 134*r + 148*s**2 - 186*s + 87) - 3*Pkd2*k2*(C*(-4*s**2 + s*(2 - 4*r) + 2) + 4*K*(r*s + r + s**2 + s - 1) - 6*r*s + r - 6*s**2 + 6*s - 3)) + k2**4*(Pk2*(4*C*(30*r**2 + 190*r*s - 53*r + 40*s**2 - 112*s + 12) - 286*K*r**2 - 766*K*r*s + 478*K*r - 480*K*s**2 + 548*K*s - 192*K + 30*b1*(r + s - 1) - 175*r**2 - 485*r*s + 323*r - 70*s**2 + 368*s - 104) + 2*Pkd2*k2*(-4*C*(10*r*(2*s - 1) + 8*s**2 - 13*s + 5) + 3*K*(4*r*s + r + 4*s**2 - 1) + b1*(7*r*(4*s - 1) + 28*s**2 - 25*s + 2) + 24*r*s - 18*r - 9*s + 3))) - 66*k2**2*(-b1*k1**2*(K - 1)*(Pk2*(50*r**2 + r*(160*s - 83) + 110*s**2 - 127*s + 25) + 2*Pkd2*k2*(r*(2 - 15*s) + s*(13 - 15*s))) + 6*b1*k2**2*(Pk2*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 2*g2*(k1**2*(Pk2*(25*r**2 + r*(80*s - 33) + s*(55*s - 55)) + Pkd2*k2*(r*(4 - 15*s) - s*(15*s - 15))) - 12*k2**2*(Pk2*(-3*r**2 + r*(4 - 8*s) - s*(5*s - 5)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 858*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(5*K - 5)*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + k2**2*(Pk2*(12*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + f*(85*r + 85*s - 60) + 24*r**2 + 24*r*s + 60*r + 60*s - 30) + Pkd2*k2*s*(f*(28*r + 28*s - 11) + (12 - 24*K)*(r + s)))) + Dd*f*(k1**2*(K - 1)*(Pk2*(100*r**2 + r*(320*s - 183) + 220*s**2 - 249*s + 75) + Pkd2*k2*(r*(4 - 60*s) + s*(37 - 60*s))) + k2**2*(Pk2*(6*K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 25*f*(4*r + 4*s - 3) + 96*r**2 + 96*r*s + 60*r + 96*s - 90) + Pkd2*k2*(f*(56*r*s - 7*r + 56*s**2 - 36*s + 2) + (6 - 12*K)*(8*r*s - r + 8*s**2 - 4*s))))) + 13*b1*k1**2*(3*D1*(f**2*fd*k2**2*(5*k1**2*(Pk2*(1620*r**2 + 2952*r*s - 2155*r + 1332*s**2 - 1831*s + 773) + 3*Pkd2*k2*(48*r*s - 125*r + 48*s**2 - 179*s + 87)) - 11*k2**2*(2*Pk2*(168*r**2 + 3*r*(51*s - 59) - 15*s**2 - 82*s + 49) + 5*Pkd2*k2*(r*(30*s - 11) + 30*s**2 - 30*s + 7))) + 11*f*(4*fd*k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) - 2*fd*k1**2*k2**2*(-Pk2*(8*C*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - K*(38*r**2 + 230*r*s - 102*r + 192*s**2 - 182*s + 43) + 118*r**2 + 414*r*s - 262*r + 296*s**2 - 390*s + 99) + 6*Pkd2*k2*(4*C*s**2 - K*(4*r*s + r + 4*s**2 - 1) + r*(4*C*s + 6*s - 4) + 6*s**2 - 9*s + 2)) + fd*k2**4*(Pk2*(4*C*(60*r**2 + 4*r*(95*s - 59) + 80*s**2 - 354*s + 153) - 2*K*(286*r**2 + 766*r*s - 436*r + 480*s**2 - 510*s + 135) - 350*r**2 - 970*r*s + 746*r - 140*s**2 + 856*s - 417) + 4*Pkd2*k2*(r*(-80*C*s + 3*K*(4*s - 1) + 24*s + 12) - s**2*(32*C - 12*K) + s*(40*C - 6*K + 3) - 6)) + 4*gd2*k1**2*k2**2*(-Pk2*(25*r**2 + 10*r*(8*s - 5) + 55*s**2 - 72*s + 25) + Pkd2*k2*s*(15*r + 15*s - 11)) + 48*gd2*k2**4*(-Pk2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 44*fd*g2*k2**2*(-5*k1**2*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + 12*k2**2*(-Pk2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k2**2*(10*k1**2*(Pk2*(3240*r**2 + 6*r*(984*s - 721) + 2664*s**2 - 3610*s + 1351) + Pkd2*k2*(6*r*(48*s - 107) + 288*s**2 - 1000*s + 517)) - 33*k2**2*(2*Pk2*(224*r**2 + 4*r*(51*s - 61) - 20*s**2 - 109*s + 69) + 5*Pkd2*k2*(r*(40*s - 13) + 40*s**2 - 40*s + 9))) + 33*f*(k1**4*(4*K - 4)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) - 2*k1**2*k2**2*(-Pk2*(4*C*(20*r**2 + r*(64*s - 35) + 44*s**2 - 41*s + 12) - K*(76*r**2 + 460*r*s - 110*r + 384*s**2 - 234*s + 13) + 236*r**2 + 828*r*s - 510*r + 592*s**2 - 742*s + 241) - 6*Pkd2*k2*(-8*C*s**2 + C*s*(2 - 8*r) + C + K*(r*(8*s + 5) + 8*s**2 + 4*s - 5) - 12*r*s + 5*r - 12*s**2 + 15*s - 4)) - k2**4*(Pk2*(-8*C*(60*r**2 + 2*r*(190*s - 93) + 80*s**2 - 334*s + 109) + 2*K*(572*r**2 + 1532*r*s - 914*r + 960*s**2 - 1058*s + 327) + 700*r**2 + 1940*r*s - 1472*r + 280*s**2 - 1792*s + 749) + 2*Pkd2*k2*(4*C*(10*r*(8*s - 1) + 32*s**2 - 48*s + 5) - 6*K*(8*r*s + 8*s**2 - 2*s - 1) - 96*r*s - 12*r + 12*s + 15))) + 132*g2*k2**2*(-k1**2*(Pk2*(100*r**2 + r*(320*s - 183) + 220*s**2 - 249*s + 75) + Pkd2*k2*(r*(4 - 60*s) + s*(37 - 60*s))) + 12*k2**2*(-Pk2*(12*r**2 + 32*r*s - 30*r + 20*s**2 - 33*s + 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(5*f**2*fd*k1**2*(3172*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(r*(488*s - 343) + 488*s**2 - 748*s + 267) + 13*k1**2*k2**2*(Pk2*(1788*r**2 - 3*r*(4672*s - 599) - 15804*s**2 + 14269*s - 2173) + 28*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(fd*(Pk2*k2**6*(4*C - 2)*(3*r - 1)*(129*r - 234*s - 196) + k1**6*(20*C - 20)*(4*Pk2 - Pkd2*k2)*(3*s - 23)*(3*r + 3*s - 2) + 6*k1**4*k2**2*(Pk2*(2*C*(429*r**2 - 15*r*(93*s + 68) - 2484*s**2 + 130*s + 680) + 192*r**2 + 6300*r*s - 545*r + 6768*s**2 - 3785*s - 30) + 5*Pkd2*k2*(C*(96*r*s + 78*r + 228*s**2 + 36*s - 74) - 237*r*s + 13*r - 303*s**2 + 149*s + 6)) + k1**2*k2**4*(-Pk2*(4*C*(6318*r**2 + 53586*r*s - 12999*r + 17469*s**2 - 33336*s + 6848) + 2979*r**2 - 91251*r*s + 9093*r - 34632*s**2 + 57036*s - 8387) + 60*Pkd2*k2*(C*(24*r*s + 3*r + 90*s**2 - 2*s - 13) - (3*s - 1)*(26*r + 37*s - 10)))) - 132*k1**2*(5*Pk2*bd2*k2**4*(11*r**2 + 2*r*(11*s - 9) + 11*s**2 - 18*s + 7) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k1**2*k2**2*(Pk2*(-19*r**2 + r*(4 - 115*s) - 96*s**2 + 26*s + 15) + 12*Pkd2*k2*(r*s + r + s**2 + s - 1)) + k2**4*(-Pk2*(143*r**2 + r*(383*s - 239) + 240*s**2 - 274*s + 96) + 3*Pkd2*k2*(4*r*s + r + 4*s**2 - 1))))) - 1716*fd*k1**2*(5*Pk2*b2*k2**4*(22*r**2 + r*(44*s - 25) + 22*s**2 - 25*s + 7) + g2*(2*k1**4*(4*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) + k1**2*k2**2*(-Pk2*(38*r**2 + 230*r*s - 102*r + 192*s**2 - 182*s + 43) + 6*Pkd2*k2*(4*r*s + r + 4*s**2 - 1)) + k2**4*(-Pk2*(286*r**2 + 766*r*s - 436*r + 480*s**2 - 510*s + 135) + 6*Pkd2*k2*(4*r*s - r + 4*s**2 - 2*s))))) + Dd*f*(5*f**2*k1**2*(3172*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(r*(488*s - 343) + 488*s**2 - 748*s + 267) + 13*k1**2*k2**2*(Pk2*(1788*r**2 - 3*r*(4672*s - 599) - 15804*s**2 + 14269*s - 2173) + 28*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(Pk2*k2**6*(8*C - 4)*(258*r**2 - 78*r*(6*s + 7) + 184*s + 221) + k1**6*(20*C - 20)*(4*Pk2 - Pkd2*k2)*(r*(12*s - 97) + 12*s**2 - 111*s + 74) + 6*k1**4*k2**2*(Pk2*(2*C*(572*r**2 - 2*r*(930*s + 859) - 3312*s**2 - 318*s + 1235) + 256*r**2 + 8400*r*s - 104*r + 9024*s**2 - 4364*s - 535) + 5*Pkd2*k2*(4*C*(32*r*s + 31*r + 76*s**2 + 23*s - 30) - 316*r*s - 5*r - 404*s**2 + 173*s + 24)) + k1**2*k2**4*(-Pk2*(4*C*(8424*r**2 + 71448*r*s - 15297*r + 23292*s**2 - 47537*s + 7040) + 3972*r**2 - 121668*r*s + 5188*r - 46176*s**2 + 79930*s - 5475) + 30*Pkd2*k2*(2*C*(32*r*s + 9*r + 120*s**2 + 12*s - 19) - 208*r*s + 57*r - 296*s**2 + 164*s - 25))) - 1716*k1**2*(5*Pk2*b2*k2**4*(44*r**2 + r*(88*s - 61) + 44*s**2 - 61*s + 21) + g2*(2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) + k1**2*k2**2*(-Pk2*(76*r**2 + 460*r*s - 110*r + 384*s**2 - 234*s + 13) + 6*Pkd2*k2*(8*r*s + 5*r + 8*s**2 + 4*s - 5)) + k2**4*(-Pk2*(572*r**2 + 1532*r*s - 914*r + 960*s**2 - 1058*s + 327) + 6*Pkd2*k2*(8*r*s + 8*s**2 - 2*s - 1)))))))/(9009*d**2*k1*k2*k3**5) + 20*D1**3*Pkd3*ct**4*f**2*k1**2*k2**2*st**4*(4*Pk2 - Pkd2*k2)*(D1*fd*(156*C*(3*s - 1)*(3*r + 3*s - 2) + 7*f*(536*r*s - 147*r + 536*s**2 - 536*s + 107) + (156 - 468*s)*(3*r + 3*s - 2)) + Dd*f*(78*C*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 7*f*(536*r*s - 147*r + 536*s**2 - 536*s + 107) - 1872*r*s + 546*r - 1872*s**2 + 1872*s - 390))/(3003*d**2*k3**5) + D1**3*Pkd3*ct**4*st**2*(396*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*b1*(132*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*(f**2*fd*(-22*Pk2*k2**2*(60*r**2 + r*(60*s - 23) + 10*s - 9) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2313*s - 925) + 2313*s**2 - 2712*s + 713)) + 132*f*(fd*k1**2*(4*Pk2 - Pkd2*k2)*(C*(12*s - 7)*(r + s - 1) + 10*r*(2*s - 1) + 20*s**2 - 15*s + 2) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1) - 2*gd2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)*(r + s - 1)) - 528*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) + Dd*f*(f**2*(-22*Pk2*k2**2*(80*r**2 + r*(80*s - 49) - 10*s - 3) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(1028*s - 375) + 3084*s**2 - 3515*s + 863)) + 132*f*(k1**2*(4*Pk2 - Pkd2*k2)*(C*(r*(24*s - 11) + 24*s**2 - 32*s + 9) + 8*r*(5*s - 2) + 40*s**2 - 38*s + 10) + 5*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1))) - 264*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(3*D1*bd1*(f**2*(-44*Pk2*k2**2*(r - 1)*(10*r + 10*s - 3) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(r*(771*s - 200) + 771*s**2 - 803*s + 150)) + 66*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(C*(6*s - 2) + 10*s - 3) + s**2*(6*C + 10) - s*(5*C + 13) + 5) + 5*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) - 264*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*(2*f*fd*(6*k1**2*(4*Pk2 - Pkd2*k2)*(r*(597*s - 265) + 597*s**2 - 652*s + 173) + k2**2*(Pk2*(-60*C*(3*s - 1)*(75*r + 53*s - 50) - 1647*r**2 + 5103*r*s - 1527*r + 4770*s**2 - 6267*s + 1684) + Pkd2*k2*(30*C - 15)*(3*s - 1)*(75*r + 53*s - 50))) + 495*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(r*(4*s - 1) + (1 - 2*s)**2) + 990*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)*(2*r + 2*s - 1)) + 2*Dd*f*(f*(6*k1**2*(4*Pk2 - Pkd2*k2)*(r*(1592*s - 655) + 1592*s**2 - 1768*s + 471) + k2**2*(Pk2*(-60*C*(25*r*(24*s - 7) + 424*s**2 - 556*s + 125) - 4392*r**2 + 27*r*(504*s - 97) + 12720*s**2 - 16478*s + 4031) + Pkd2*k2*(30*C - 15)*(25*r*(24*s - 7) + 424*s**2 - 556*s + 125))) + k2**2*(-2*Pk2 + Pkd2*k2)*(990*b2 - 1980*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))))/(693*d**2*k3**3) + D1**3*Pkd3*ct**4*st**2*(39*D1*bd1*f*(f**2*k2**2*(44*Pk2*k2**2*(r - 1)*(10*r + 10*s - 3) + 5*k1**2*(Pk2*(2265*r**2 + 4*r*(853*s - 813) + 1147*s**2 - 2258*s + 887) + Pkd2*k2*(r*(559*s - 94) + 559*s**2 - 591*s + 144))) + 22*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(Pk2*(6*C*(15*r**2 + 21*r*(2*s - 1) + 27*s**2 - 29*s + 2) + K*(-213*r**2 - 23*r*s + 183*r + 190*s**2 - 178*s + 30) + 433*r**2 + 583*r*s - 597*r + 150*s**2 - 344*s + 188) - 6*Pkd2*k2*(C*(r*(6*s - 3) + 6*s**2 - 7*s + 1) + K*(28*r*s - 9*r + 28*s**2 - 32*s + 9) - 18*r*s + 7*r - 18*s**2 + 21*s - 5)) - 15*k2**4*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1))) - 132*k1**2*k2**2*(-b1*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + 2*g2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 5148*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) - 2*Pkd2*k2*s*(r + s)) + Dd*f*(Pk2*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s))) + 39*b1*(D1*(f**2*fd*k2**2*(22*Pk2*k2**2*(60*r**2 + r*(60*s - 23) + 10*s - 9) + 5*k1**2*(Pk2*(6795*r**2 + 10236*r*s - 8325*r + 3441*s**2 - 6023*s + 2714) + Pkd2*k2*(1677*r*s - 925*r + 1677*s**2 - 2076*s + 613))) + 22*f*(fd*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(12*C*(15*r**2 + 6*r*(7*s - 5) + 27*s**2 - 35*s + 15) + K*(-426*r**2 - 46*r*s + 22*r + 380*s**2 - 428*s + 119) + 866*r**2 + 1166*r*s - 516*r + 300*s**2 - 210*s - 21) - 6*Pkd2*k2*(12*C*s**2 - 5*C*s + 2*K*(r*(28*s - 15) + 28*s**2 - 30*s + 8) + r*(s*(12*C - 36) + 13) - 36*s**2 + 31*s - 7)) - 15*k2**4*(2*r + 2*s - 1)*(K*Pk2*(18*r + 10*s - 5) + 2*K*Pkd2*k2*(2*s - 1) - 4*Pk2*r)) + 12*gd2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 264*fd*g2*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(22*Pk2*k2**2*(80*r**2 + r*(80*s - 49) - 10*s - 3) + 5*k1**2*(Pk2*(9060*r**2 + 13648*r*s - 11577*r + 4588*s**2 - 8281*s + 3601) + Pkd2*k2*(2236*r*s - 1019*r + 2236*s**2 - 2667*s + 757))) + 22*f*(k1**4*(6*K - 6)*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + k1**2*k2**2*(Pk2*(6*C*(60*r**2 + 3*r*(56*s - 37) + 108*s**2 - 137*s + 47) + K*(-852*r**2 - 92*r*s + 388*r + 760*s**2 - 784*s + 179) + 1732*r**2 + 2332*r*s - 1656*r + 600*s**2 - 844*s + 277) - 6*Pkd2*k2*(3*C*r*(8*s - 1) + 24*C*s**2 - 16*C*s + C + 2*K*(8*r*(7*s - 3) + 56*s**2 - 62*s + 17) - 72*r*s + 24*r - 72*s**2 + 70*s - 16)) - 15*k2**4*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2))) + 264*g2*k1**2*k2**2*(-Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))))) + f*(D1*(f**2*fd*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(8156*s - 2949) + 24468*s**2 - 27653*s + 6749) + 26*k2**2*(-Pk2*(13980*r**2 + 3*r*(20300*s - 8023) + 46920*s**2 - 46610*s + 9647) + 375*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(-2475*Pk2*bd2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(r*(372*s - 179) + 372*s**2 - 438*s + 123) + 2*k1**2*k2**2*(Pk2*(C*(-12681*r**2 + 3*r*(3843*s + 107) + 13914*s**2 - 23316*s + 6247) + 23796*r**2 + 3*r*(7671*s - 6162) + 4365*s**2 - 2199*s + 1209) - 3*Pkd2*k2*(4*C*(5*r*(285*s - 106) + 996*s**2 - 1414*s + 379) - 57*r*(64*s - 25) - 2790*s**2 + 3736*s - 1005)) + k2**4*(-2*C*Pk2*(18513*r**2 + 18*r*(2725*s - 1154) + 11925*s**2 - 27006*s + 7094) + 3*Pk2*(7269*r**2 + 2*r*(8724*s - 3703) + 3975*s**2 - 8884*s + 2242) + Pkd2*k2*(30 - 60*C)*(3*s - 1)*(75*r + 53*s - 50))) - 66*gd2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + k1**2*k2**2*(Pk2*(-213*r**2 - 23*r*s + 183*r + 190*s**2 - 178*s + 30) - 6*Pkd2*k2*(r*(28*s - 9) + 28*s**2 - 32*s + 9)) - 15*k2**4*(Pk2*(18*r**2 + r*(28*s - 25) + 10*s**2 - 19*s + 7) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 858*fd*(75*Pk2*b2*k2**4*(2*r + 2*s - 1)**2 + 2*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(-426*r**2 + r*(22 - 46*s) + 380*s**2 - 428*s + 119) - 12*Pkd2*k2*(r*(28*s - 15) + 28*s**2 - 30*s + 8)) - 15*k2**4*(Pk2*(18*r + 10*s - 5) + 2*Pkd2*k2*(2*s - 1))*(2*r + 2*s - 1)))) + Dd*f*(-64350*Pk2*b2*k2**4*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*k1**2*(25*k1**2*(4*Pk2 - Pkd2*k2)*(3*r*(8156*s - 2949) + 24468*s**2 - 27653*s + 6749) + 26*k2**2*(-Pk2*(13980*r**2 + 3*r*(20300*s - 8023) + 46920*s**2 - 46610*s + 9647) + 375*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 26*f*(k1**4*(18*C - 18)*(4*Pk2 - Pkd2*k2)*(r*(496*s - 229) + 496*s**2 - 606*s + 173) + 2*k1**2*k2**2*(Pk2*(C*(-16908*r**2 + 15372*r*s + 3386*r + 18552*s**2 - 31824*s + 7409) + 31728*r**2 + 30684*r*s - 28201*r + 5820*s**2 - 4091*s + 2992) - 6*Pkd2*k2*(C*(3800*r*s - 1277*r + 2656*s**2 - 3910*s + 975) - 2432*r*s + 867*r - 1860*s**2 + 2575*s - 657)) + k2**4*(Pk2*(-2*C*(24684*r**2 + 3*r*(21800*s - 9739) + 15900*s**2 - 40397*s + 9368) + 29076*r**2 + 24*r*(2908*s - 1327) + 15900*s**2 - 40599*s + 9087) + Pkd2*k2*(15 - 30*C)*(25*r*(24*s - 7) + 424*s**2 - 556*s + 125))) - 1716*g2*(6*k1**4*(4*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + k1**2*k2**2*(Pk2*(-852*r**2 + r*(388 - 92*s) + 760*s**2 - 784*s + 179) - 12*Pkd2*k2*(8*r*(7*s - 3) + 56*s**2 - 62*s + 17)) - 15*k2**4*(Pk2*(72*r**2 + 2*r*(56*s - 39) + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2))))))/(9009*d**2*k3**5) + D1**3*Pkd3*ct**4*(4*D1*bd1*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + s*(2*s - 3)) + k2**2*(Pk2*(-2*r**2 + r*(-80*C*s + 20*C + 38*s - 15) + s*(-32*C*s + 60*C + 16*s - 41)) + Pkd2*k2*(2*C - 1)*(5*r*(4*s - 1) + s*(8*s - 15)))) + k2**2*(-2*Pk2 + Pkd2*k2)*(6*b2 - 12*g2)*(r*(2*s - 1) + s*(2*s - 2))) + b1**2*(-D1*fd*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(10*f*s - 8*f + 5*s - 5) + 3*k2**2*(16*K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(6*r + 5) + 16*Pk2*r))*(r + s - 1) + 2*Dd*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(f*(2*r*(10*s - 9) + 20*s**2 - 31*s + 13) + r*(20*s - 23) + 20*s**2 - 37*s + 17) + 3*k2**2*(4*K*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + Pk2*(-8*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + f*(-6*r**2 + r*(5 - 6*s) - 5*s + 1) - 32*r**2 - 32*r*s + 36*r + 8*s - 8)))) + b1*(D1*bd1*f*(4*k1**2*(4*Pk2 - Pkd2*k2)*(f*(10*r*(s - 1) + 10*s**2 - 13*s + 5) + 2*r*(5*s - 6) + 10*s**2 - 16*s + 6) - 3*k2**2*(-8*K*Pkd2*k2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pk2*(16*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(6*r**2 + r*(6*s - 9) + 5*s + 3) + 32*r**2 + 32*r*(s - 1) - 8*s + 8))) + 8*D1*(2*f*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(s - 2)*(r + s - 1) + k2**2*(-Pk2*(4*C*(2*s - 1)*(5*r + 2*s - 5) + r**2 - 19*r*s + 13*r - 8*s**2 + 28*s - 14) + Pkd2*k2*(2*C - 1)*(2*s - 1)*(5*r + 2*s - 5))) + 3*f*k2**2*(-2*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)*(2*s - 1)*(r + s - 1) + 6*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 4*Dd*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*r*(4*s - 9) + 8*s**2 - 22*s + 13) + k2**2*(Pk2*(-4*C*(80*r*s - 30*r + 32*s**2 - 88*s + 25) - 8*r**2 + 152*r*s - 80*r + 64*s**2 - 208*s + 71) + Pkd2*k2*(2*C - 1)*(10*r*(8*s - 3) + 32*s**2 - 88*s + 25))) + k2**2*(-2*Pk2 + Pkd2*k2)*(6*b2 - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))/(21*d**2*k2**2*k3) + D1**3*Pkd3*ct**4*(D1*bd1*f*(f**2*(363*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 10*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(39*s - 56) + 78*s**2 - 131*s + 56) + 33*k1**2*k2**2*(Pk2*(162*r**2 - 13*r*(68*s + 1) - 1046*s**2 + 893*s - 109) + 10*Pkd2*k2*(r*(29*s - 8) + 29*s**2 - 31*s + 6))) + 66*f*(2*k1**4*(4*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) - 2*k1**2*k2**2*(Pk2*(-6*C*r**2 - 79*C*r*s + 50*C*r + 71*C*s**2 + 29*C*s + 6*K*(6*r*s - 5*r + 6*s**2 - 12*s + 5) - b1*(10*r**2 + r*(84*s + 5) + 74*s**2 - 61*s - 1) + 5*r**2 + 150*r*s - 84*r + 73*s**2 - 149*s + 51) + Pkd2*k2*(56*C*r*s - 8*C*r - 16*C*s**2 - 24*C*s - 3*K*(6*r*s - 5*r + 6*s**2 - 12*s + 5) + b1*(2*r*(16*s + 5) + 32*s**2 - 23*s - 3) - 60*r*s + 21*r - 24*s**2 + 60*s - 21)) + k2**4*(Pk2*(-16*C*s**2 + 96*C*s + K*(9*r**2 + r*(123*s - 31) + 114*s**2 - 90*s + 22) + b1*(23 - 34*r) - r**2*(32*C - 64) - 4*r*(C*(74*s + 6) - 49*s + 17) + 8*s**2 - 72*s + 34) - 2*Pkd2*k2*(2*C*(5*r - 2*s - 5) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 5*r + 2*s + 5))) + 132*k2**2*(b1*(k1**2*(Pk2*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(20*r**2 + 3*r*(35*s + 6) + 85*s**2 - 71*s - 14) + 30*r**2 + 221*r*s - 33*r + 191*s**2 - 186*s + 7) + Pkd2*k2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + K*(2*r*(4*s + 5) + 8*s**2 - 3*s - 5) - 56*r*s + 8*r - 56*s**2 + 53*s - 3)) + 6*k2**2*(K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1))) + 6*b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + g2*(12*Pk2*k2**2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + k1**2*(Pk2*(20*r**2 + 7*r*(15*s + 4) + s*(85*s - 85)) - 2*Pkd2*k2*(r*(4*s + 5) + s*(4*s - 4)))))) - 66*b1**2*k2**2*(D1*fd*(k1**2*(-Pk2*(-16*C*r*s - 16*C*s**2 + 16*C*s - 5*K*(4*r**2 + 21*r*(s - 1) + 17*(s - 1)**2) + 4*f*(5*r**2 + 6*r*(7*s + 2) + 37*s**2 + s - 17) + 30*r**2 + 221*r*s - 145*r + 191*s**2 - 246*s + 115) + 2*Pkd2*k2*(-4*C*r*s - 4*C*s**2 + 4*C*s - 4*K*(s - 1)*(r + s - 1) + f*(r*(32*s + 22) + 32*s**2 + 11*s - 22) + 28*r*s - 9*r + 28*s**2 - 22*s + 9)) + k2**2*(12*K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 24*K*Pkd2*k2*(r + 2*s - 1) + 24*Pk2*r + f*(10*Pk2*r + Pk2))) + Dd*f*(k1**2*(Pk2*(8*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 80*K*r**2 + 420*K*r*s - 61*K*r + 340*K*s**2 - 369*K*s + 29*K - 2*f*(20*r**2 + 168*r*s + 29*r + 148*s**2 - 59*s - 35) - 120*r**2 - 884*r*s + 247*r - 764*s**2 + 799*s - 135) + 2*Pkd2*k2*(-2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 16*K*r*s - 11*K*r - 16*K*s**2 + 10*K*s + 6*K + f*(64*r*s + 32*r + 64*s**2 - 12*s - 25) + 112*r*s - 18*r + 112*s**2 - 100*s + 13)) + 2*k2**2*(-24*K*Pkd2*k2*(r + 2*s - 1) + 11*Pk2*f*(2*r - 1) + 6*Pk2*(K*(20*r**2 + r*(24*s - 25) + 4*s**2 - 11*s + 7) + 4*r - 2)))) + b1*(D1*(f**2*fd*(363*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 10*k1**4*(4*Pk2 - Pkd2*k2)*(39*s - 46)*(6*r + 6*s - 5) + 33*k1**2*k2**2*(Pk2*(486*r**2 + r*(547 - 2652*s) - 3138*s**2 + 3405*s - 691) + 10*Pkd2*k2*(r*(87*s - 36) + 87*s**2 - 104*s + 28))) + 66*f*(fd*(4*k1**4*(4*Pk2 - Pkd2*k2)*(s - 2)*(2*r + 2*s - 1) - 2*k1**2*k2**2*(Pk2*(C*(-12*r**2 + r*(91 - 158*s) + 142*s**2 + 81*s - 79) + 12*K*(6*r*s - 5*r + 6*s**2 - 9*s + 3) + 10*r**2 + 300*r*s - 223*r + 146*s**2 - 321*s + 132) + 2*Pkd2*k2*(4*C*(2*r*(7*s - 2) - 4*s**2 - 9*s + 4) - 3*K*(6*r*s - 5*r + 6*s**2 - 9*s + 3) - 60*r*s + 30*r - 24*s**2 + 57*s - 18)) + k2**4*(Pk2*(-8*C*(8*r**2 + r*(74*s - 17) + 4*s**2 - 44*s + 9) + K*(18*r**2 + 2*r*(123*s - 67) + 57*(1 - 2*s)**2) + 128*r**2 + 4*r*(98*s - 33) + 16*s**2 - 176*s + 26) + 8*Pkd2*k2*(2*C*(5*r + 7*s - 5) - 3*K*(2*s - 1)*(2*r + 2*s - 1) - 5*r - 7*s + 5))) + 2*k2**2*(-6*Pk2*bd2*k2**2*(r + s - 1)**2 + 6*Pkd2*bd2*k2**3*s*(2*r + 2*s - 1) + gd2*k1**2*(Pk2*(20*r + 85*s + 28) - 2*Pkd2*k2*(4*s + 5))*(r + s - 1) - 12*gd2*k2**2*(-Pk2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) + Pkd2*k2*(r + 2*s - 1)))) + 132*fd*k2**2*(6*b2*k2**2*(-Pk2*(r + s - 1)**2 + 2*Pkd2*k2*s*(r + s)) + g2*(k1**2*(r + s - 1)*(20*Pk2*r + 85*Pk2*(s - 1) - 8*Pkd2*k2*(s - 1)) - 12*k2**2*(-Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 2*Pkd2*k2*(r + 2*s - 1))))) + 2*Dd*f*(f**2*(363*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + 10*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(78*s - 97) + 156*s**2 - 301*s + 143) + 33*k1**2*k2**2*(Pk2*(324*r**2 + r*(267 - 1768*s) - 2092*s**2 + 2149*s - 400) + 5*Pkd2*k2*(4*r*(29*s - 11) + 116*s**2 - 135*s + 34))) + 33*f*(4*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4*s - 9) + 4*s**2 - 13*s + 7) - 2*k1**2*k2**2*(Pk2*(C*(-24*r**2 + r*(197 - 316*s) + 284*s**2 + 233*s - 129) + 12*K*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + 20*r**2 + 600*r*s - 395*r + 292*s**2 - 667*s + 266) + 2*Pkd2*k2*(4*C*(r*(28*s - 6) - 8*s**2 - 20*s + 5) - 3*K*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) - 120*r*s + 51*r - 48*s**2 + 126*s - 39)) + k2**4*(Pk2*(-8*C*(16*r**2 + r*(148*s - 15) + 8*s**2 - 86*s + 6) + K*(36*r**2 + 492*r*s - 196*r + 456*s**2 - 408*s + 101) + 256*r**2 + 784*r*s - 276*r + 32*s**2 - 392*s + 72) + 8*Pkd2*k2*(10*C*(r + 2*s - 1) - 3*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 5*r - 10*s + 5))) + 66*k2**2*(6*b2*k2**2*(-Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + g2*(k1**2*(Pk2*(80*r**2 + 420*r*s - 61*r + 340*s**2 - 369*s + 29) - 2*Pkd2*k2*(16*r*s + 11*r + 16*s**2 - 10*s - 6)) - 12*k2**2*(-Pk2*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + 4*Pkd2*k2*(r + 2*s - 1)))))) + 2*f*(D1*(f*(fd*(10*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 23)*(3*r + 3*s - 2) + 6*k1**2*k2**2*(-Pk2*(20*C*(r*(75*s - 80) + 75*s**2 - 141*s + 57) - 804*r**2 + 5*r*(477*s + 67) + 3189*s**2 - 2030*s + 35) + 5*Pkd2*k2*(2*C*(r*(75*s - 80) + 75*s**2 - 141*s + 57) + r*(189*s - 52) + 189*s**2 - 167*s + 31)) - 3*k2**4*(Pk2*(2*C*(873*r**2 - 3*r*(2085*s + 49) - 2838*s**2 + 3988*s - 367) - 2325*r**2 + 4803*r*s + 1247*r + 2838*s**2 - 3724*s + 235) + Pkd2*k2*(220*C - 110)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + k2**2*(-33*bd2 + 66*gd2)*(6*k1**2*(2*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 12*s + 5) + k2**2*(-Pk2*(9*r**2 + r*(123*s - 31) + 114*s**2 - 90*s + 22) + 12*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 33*fd*k2**2*(b2 - 2*g2)*(12*k1**2*(2*Pk2 - Pkd2*k2)*(r*(6*s - 5) + 6*s**2 - 9*s + 3) + k2**2*(-Pk2*(18*r**2 + 2*r*(123*s - 67) + 57*(1 - 2*s)**2) + 24*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(f*(10*k1**4*(4*Pk2 - Pkd2*k2)*(r*(12*s - 97) + 12*s**2 - 111*s + 74) + 6*k1**2*k2**2*(Pk2*(-20*C*(4*r*(25*s - 27) + 100*s**2 - 199*s + 85) + 1072*r**2 - 3180*r*s - 833*r - 4252*s**2 + 2467*s + 195) + 5*Pkd2*k2*(2*C*(4*r*(25*s - 27) + 100*s**2 - 199*s + 85) + 3*r*(84*s - 19) + 252*s**2 - 219*s + 36)) - 3*k2**4*(Pk2*(2*C*(1164*r**2 - 8340*r*s - 798*r - 3784*s**2 + 5576*s - 7) - 3100*r**2 + 6404*r*s + 2514*r + 3784*s**2 - 5048*s - 257) + Pkd2*k2*(440*C - 220)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + k2**2*(-33*b2 + 66*g2)*(12*k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(6*s - 5) + 12*s**2 - 21*s + 8) + k2**2*(-Pk2*(36*r**2 + 492*r*s - 196*r + 456*s**2 - 408*s + 101) + 24*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(693*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**4*(D1*(-858*b1*fd*k2**2*(60*Pk2*b2*k2**4*(r + s)**2 + b1*(k1**4*(2*K - 2)*(Pk2*(5*r**2 + 2*r*(4*s - 5) + 3*s**2 - 10*s + 5) + Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(20*C*(r + s - 1)**2 + K*(23*r**2 + 62*r*s + 60*r + 39*s**2 + 60*s - 30) - 193*r**2 - 402*r*s + 80*r - 209*s**2 + 80*s - 40) + Pkd2*k2*s*(32*K - 2)*(r + s)) + 12*k2**4*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s))) - 2*g2*(2*k1**4*(Pk2*(5*r**2 + 8*r*s - 10*r + 3*s**2 - 10*s + 5) + Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(23*r**2 + 62*r*s + 60*r + 39*s**2 + 60*s - 30) + 32*Pkd2*k2*s*(r + s)) + 12*k2**4*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + f**3*(-13*bd1*k2**2*(363*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 10*k1**4*(Pk2*(60*r**2 - 168*r*s - 377*r - 228*s**2 - 181*s + 329) + 2*Pkd2*k2*(72*r*s + 103*r + 72*s**2 + 54*s - 106)) + 33*k1**2*k2**2*(Pk2*(970*r**2 + 1526*r*s - 1371*r + 556*s**2 - 1093*s + 399) + 10*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + 10*fd*k1**2*(793*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 19)*(4*r + 4*s - 3) + 13*k1**2*k2**2*(Pk2*(4358*r**2 - 2*r*(3839*s + 700) - 12036*s**2 + 11302*s - 1503) + 28*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 13*f**2*k2**2*(3960*Pk2*bd2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(r + s - 1) + 33*bd1*(2*k1**4*(Pk2*(8*C*(5*r**2 + r*(16*s - 11) + 11*s**2 - 14*s + 3) + K*(-22*r**2 + 71*r*s + 10*r + 93*s**2 - 117*s + 12) + 2*r**2 - 167*r*s + 98*r - 169*s**2 + 261*s - 76) - 2*Pkd2*k2*(6*C*(s - 1)*(2*r + 2*s - 1) + K*(26*r*s - 8*r + 26*s**2 - 32*s + 8) - 40*r*s + 25*r - 40*s**2 + 58*s - 19)) - 2*k1**2*k2**2*(Pk2*(2*C*(13*r**2 + 554*r*s - 63*r - 59*s**2 - 321*s + 80) + 107*K*r**2 - 151*K*r*s - 25*K*r - 258*K*s**2 + 266*K*s - 82*K + 10*b1*(16*r**2 + r*(32*s - 21) + 16*s**2 - 21*s + 5) - 495*r**2 - 1211*r*s + 871*r - 116*s**2 + 876*s - 436) + 2*Pkd2*k2*(-24*C*(r*(3*s - 1) - s + 1) - 3*K*(-26*r*s + 7*r - 26*s**2 + 28*s - 7) + 2*b1*(r*(29*s - 5) + 29*s**2 - 26*s + 1) - 18*r*s + 12*r - 54*s**2 + 57*s - 9)) + k2**4*(-Pk2*(-8*C*(4*r**2 + r*(94*s - 51) + 16*s**2 - 35*s + 49) + 2*K*(207*r**2 + r*(309*s - 293) + 102*s**2 - 234*s + 86) + b1*(18*r**2 + r*(18*s + 41) + 15*s - 37) - 72*r**2 - 8*r*(3 - 36*s) + 64*s**2 - 48*s + 128) + 4*Pkd2*k2*(2*C*(10*r*(2*s - 1) + 8*s**2 - 13*s + 5) - 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 10*r - 8*s**2 + 13*s - 5))) + fd*(2*k1**4*(Pk2*(2*C*(-3960*r**2 + 27*r*(47*s + 109) + 5229*s**2 - 5658*s + 623) + 15*b1*(60*r**2 - 3*r*(56*s + 99) - 228*s**2 - 149*s + 181) + 11970*r**2 + 5382*r*s - 8256*r - 6588*s**2 + 9066*s - 1466) + 10*Pkd2*k2*(-2*C*(477*r*s - 192*r + 477*s**2 - 543*s + 139) + b1*(3*r*(72*s + 103) + 216*s**2 + 198*s - 217) + 963*r*s - 453*r + 963*s**2 - 1161*s + 324)) + 3*k1**2*k2**2*(11*Pk2*b1*(2910*r**2 + r*(4578*s - 3669) + 1668*s**2 - 2915*s + 1251) + 4*Pk2*(C*(-7683*r**2 + r*(12153*s + 3799) + 3798*s**2 - 11940*s + 1795) + 12054*r**2 + r*(6711*s - 11296) + 2676*s**2 - 897*s + 1682) + 110*Pkd2*b1*k2*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) - 20*Pkd2*k2*(C*(r*(906*s - 368) + 906*s**2 - 950*s + 238) + r*(316 - 717*s) - 717*s**2 + 783*s - 207)) + 3*k2**4*(Pk2*(-4*C*(7077*r**2 + 5889*r*s - 7297*r + 3102*s**2 - 3030*s + 1657) + 121*b1*(3*r - 1)*(5*r + 5*s - 3) + 17058*r**2 + 14682*r*s - 16794*r + 6204*s**2 - 6588*s + 3578) + Pkd2*k2*(220 - 440*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + 132*gd2*(k1**4*(Pk2*(22*r**2 - 71*r*s - 10*r - 93*s**2 + 117*s - 12) + 4*Pkd2*k2*(13*r*s - 4*r + 13*s**2 - 16*s + 4)) + k1**2*k2**2*(Pk2*(107*r**2 - 151*r*s - 25*r - 258*s**2 + 266*s - 82) + 6*Pkd2*k2*(26*r*s - 7*r + 26*s**2 - 28*s + 7)) + k2**4*(Pk2*(207*r**2 + r*(309*s - 293) + 102*s**2 - 234*s + 86) + 12*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 429*f*k2**2*(-120*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + b1**2*fd*k2**2*(Pk2*k2**2*(18*r**2 + r*(18*s + 17) + 15*s - 13) + 4*k1**2*(5*Pk2*(16*r**2 + 32*r*s - 3*r + 16*s**2 - 3*s - 5) + Pkd2*k2*s*(58*r + 58*s - 23))) - 2*b1*(60*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*bd1*(k1**4*(K - 1)*(Pk2*(10*r**2 + r*(16*s - 21) + 6*s**2 - 5*s + 5) + Pkd2*k2*(r*(2*s + 3) + s*(2*s - 5))) + k1**2*k2**2*(Pk2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(23*r**2 + 62*r*s - 26*r + 39*s**2 - 6*s - 15) - 193*r**2 - 402*r*s + 231*r - 209*s**2 + 211*s - 20) + Pkd2*k2*(r*(K*(32*s - 1) - 2*s - 3) + s*(K*(32*s - 31) - 2*s + 5))) + 6*k2**4*(K*(Pk2*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*(k1**4*(Pk2*(16*C*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 13*s + 5) + K*(-44*r**2 + 142*r*s - 69*r + 186*s**2 - 275*s + 91) + 4*r**2 - 334*r*s + 281*r - 338*s**2 + 543*s - 207) - 4*Pkd2*k2*(K*(2*s - 1)*(13*r + 13*s - 8) + r*(12*C*s - 40*s + 17) + (4*s - 2)*(3*C*s - 10*s + 5))) + k1**2*k2**2*(Pk2*(C*(-52*r**2 + r*(834 - 2216*s) + 236*s**2 + 1946*s - 684) + K*(-214*r**2 + 302*r*(s - 1) + 516*s**2 - 764*s + 253) + 990*r**2 + 2422*r*s - 1380*r + 232*s**2 - 1590*s + 529) + 12*Pkd2*k2*(-16*C*s - K*(2*s - 1)*(13*r + 13*s - 7) + 3*r*(8*C*s + 2*s - 3) + 18*s**2 - 11*s + 5)) + k2**4*(4*C*Pk2*(8*r**2 + 4*r*(47*s + 35) + 32*s**2 - 24*s - 97) - K*Pk2*(414*r**2 + r*(618*s - 298) + 51*(1 - 2*s)**2) - 24*K*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1) + 8*Pk2*(9*r**2 - 2*r*(18*s + 23) - 8*s**2 + 2*s + 27) + Pkd2*k2*s*(16*C - 8)*(10*r + 4*s - 5))) - 2*gd2*(2*k1**4*(Pk2*(5*r**2 + 8*r*s - 10*r + 3*s**2 - 2*s + 5) + Pkd2*k2*s*(r + s - 4)) + k1**2*k2**2*(Pk2*(23*r**2 + 62*r*s + 7*r + 39*s**2 + 27*s - 30) + 2*Pkd2*k2*s*(16*r + 16*s - 15)) + 12*k2**4*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) + 4*bd1*g2*(2*k1**4*(Pk2*(5*r**2 + r*(8*s - 11) + s*(3*s - 3)) + Pkd2*k2*(r*(s + 3) + s*(s - 1))) + k1**2*k2**2*(Pk2*(23*r**2 + r*(62*s - 59) + s*(39*s - 39)) + 2*Pkd2*k2*(r*(16*s - 1) + s*(16*s - 16))) + 12*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 4*fd*(30*Pk2*b2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(2*r + 2*s - 1) + g2*(k1**4*(Pk2*(44*r**2 - 142*r*s + 69*r - 186*s**2 + 275*s - 91) + 4*Pkd2*k2*(2*s - 1)*(13*r + 13*s - 8)) + k1**2*k2**2*(Pk2*(214*r**2 - 302*r*(s - 1) - 516*s**2 + 764*s - 253) + 12*Pkd2*k2*(2*s - 1)*(13*r + 13*s - 7)) + k2**4*(Pk2*(414*r**2 + r*(618*s - 298) + 51*(1 - 2*s)**2) + 24*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))))) + 2*Dd*f*(-429*b1*k2**2*(60*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(k1**4*(2*K - 2)*(Pk2*(20*r**2 + r*(32*s - 41) + 12*s**2 - 17*s + 15) + Pkd2*k2*(r*(4*s + 3) + s*(4*s - 9))) + k1**2*k2**2*(Pk2*(20*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(92*r**2 + 248*r*s + 15*r + 156*s**2 + 75*s - 90) - 772*r**2 - 1608*r*s + 775*r - 836*s**2 + 715*s - 120) + 2*Pkd2*k2*(r*(K*(64*s - 1) - 4*s - 3) + s*(K*(64*s - 46) - 4*s + 9))) + 12*k2**4*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s)) - 2*g2*(2*k1**4*(Pk2*(20*r**2 + r*(32*s - 41) + 12*s**2 - 17*s + 15) + Pkd2*k2*(r*(4*s + 3) + s*(4*s - 9))) + k1**2*k2**2*(Pk2*(92*r**2 + 248*r*s + 15*r + 156*s**2 + 75*s - 90) + 2*Pkd2*k2*(64*r*s - r + 64*s**2 - 46*s)) + 12*k2**4*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 5*f**3*k1**2*(793*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 28*k1**4*(4*Pk2 - Pkd2*k2)*(11*s - 19)*(4*r + 4*s - 3) + 13*k1**2*k2**2*(Pk2*(4358*r**2 - 2*r*(3839*s + 700) - 12036*s**2 + 11302*s - 1503) + 28*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 13*f**2*k2**2*(2*k1**4*(Pk2*(C*(-5280*r**2 + 1692*r*s + 4825*r + 6972*s**2 - 7203*s + 61) + 10*b1*(60*r**2 - r*(168*s + 317) - 228*s**2 - 157*s + 218) + 7980*r**2 + 3588*r*s - 6580*r - 4392*s**2 + 5588*s - 276) + 5*Pkd2*k2*(-2*C*(636*r*s - 235*r + 636*s**2 - 735*s + 182) + b1*(4*r*(72*s + 103) + 288*s**2 + 252*s - 323) + 1284*r*s - 567*r + 1284*s**2 - 1581*s + 438)) + 3*k1**2*k2**2*(Pk2*(2*C*(-10244*r**2 + 16204*r*s + 7556*r + 5064*s**2 - 16632*s + 599) + 11*b1*(1940*r**2 + 28*r*(109*s - 90) + 1112*s**2 - 2004*s + 825) + 32144*r**2 + 17896*r*s - 34760*r + 7136*s**2 - 3340*s + 7496) + 5*Pkd2*k2*(-4*C*(r*(604*s - 222) + 604*s**2 - 637*s + 157) + 11*b1*(21*s - 10)*(4*r + 4*s - 3) + 1912*r*s - 774*r + 1912*s**2 - 2110*s + 556)) + 3*k2**4*(Pk2*(-2*C*(9436*r**2 + 26*r*(302*s - 425) + 4136*s**2 - 4500*s + 3051) + 121*b1*(2*r - 1)*(5*r + 5*s - 3) + 11372*r**2 + 9788*r*s - 12766*r + 4136*s**2 - 5028*s + 3315) + Pkd2*k2*(220 - 440*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 429*f*k2**2*(60*Pk2*b2*k2**2*(2*k1**2*(r + s - 1) + k2**2*(-2*r - 2*s + 1))*(4*r + 4*s - 3) - b1**2*k2**2*(80*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pk2*k2**2*(18*r**2 + 18*r*s + 29*r + 15*s - 25) + 2*Pkd2*k1**2*k2*(2*r*(58*s - 5) + 116*s**2 - 75*s + 2)) + b1*(k1**4*(Pk2*(8*C*(20*r**2 + r*(64*s - 41) + 44*s**2 - 53*s + 18) + K*(-88*r**2 + 284*r*s - 49*r + 372*s**2 - 509*s + 115) + 8*r**2 - 668*r*s + 469*r - 676*s**2 + 1057*s - 375) - 4*Pkd2*k2*(3*C*(4*s - 1)*(2*r + 2*s - 1) + K*(52*r*s - 21*r + 52*s**2 - 61*s + 16) - 80*r*s + 36*r - 80*s**2 + 92*s - 26)) + k1**2*k2**2*(Pk2*(-2*C*(52*r**2 + r*(2216*s - 555) - 236*s**2 - 1927*s + 484) + K*(-428*r**2 + 604*r*s - 252*r + 1032*s**2 - 1296*s + 417) + 1980*r**2 + 4844*r*s - 3126*r + 464*s**2 - 3646*s + 1345) + 6*Pkd2*k2*(8*C*(r*(12*s - 1) - 8*s + 1) - 2*K*(52*r*s - 20*r + 52*s**2 - 55*s + 14) + 24*r*s - 28*r + 72*s**2 - 50*s + 19)) + k2**4*(Pk2*(4*C*(16*r**2 + 4*r*(94*s + 33) + 64*s**2 - 104*s - 95) - K*(828*r**2 + 1236*r*s - 884*r + 408*s**2 - 672*s + 223) + 144*r**2 - 576*r*s - 520*r - 128*s**2 + 96*s + 280) + 2*Pkd2*k2*(2*C*(10*r*(8*s - 1) + 32*s**2 - 48*s + 5) - 12*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 80*r*s + 10*r - 32*s**2 + 48*s - 5))) + 2*g2*(k1**4*(Pk2*(88*r**2 - 284*r*s + 49*r - 372*s**2 + 509*s - 115) + 4*Pkd2*k2*(52*r*s - 21*r + 52*s**2 - 61*s + 16)) + k1**2*k2**2*(Pk2*(428*r**2 - 604*r*s + 252*r - 1032*s**2 + 1296*s - 417) + 12*Pkd2*k2*(52*r*s - 20*r + 52*s**2 - 55*s + 14)) + k2**4*(Pk2*(828*r**2 + 1236*r*s - 884*r + 408*s**2 - 672*s + 223) + 24*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k2**2*k3**5) + 20*D1**3*Pkd3*ct**3*f**2*k1*k2*st**4*(4*Pk2 - Pkd2*k2)*(7*D1*bd1*f*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + (7*b1 + 3)*(2*D1*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*f*(r*(24*s - 7) + 24*s**2 - 24*s + 5)))/(231*d**2*k3**3) + 2*D1**3*Pkd3*ct**3*f*k1*k2*st**4*(D1*(5*f**2*(546*bd1*k2**2*(Pk2*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + fd*(-364*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 6*s + 4) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(13136*s - 3713) + 13136*s**2 - 13422*s + 2749))) + 78*f*(fd*k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + fd*k2**2*(Pk2*(C*(-918*r**2 + 6*r*(207*s + 44) + 2160*s**2 - 1854*s + 254) + 1593*r**2 + 24*r*(27*s - 56) - 945*s**2 + 414*s + 166) + Pkd2*k2*(90 - 120*C)*(3*s - 1)*(3*r + 3*s - 2)) + k1**2*s*(4*Pk2 - Pkd2*k2)*(2*r + 2*s - 1)*(66*K*bd1 - 66*bd1 - 132*gd2)) - 5148*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1)) + Dd*f*(5*f**2*(-364*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 6*s + 4) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(r*(13136*s - 3713) + 13136*s**2 - 13422*s + 2749)) + 78*f*(k1**2*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + k2**2*(Pk2*(-4*C*(306*r**2 - 3*r*(138*s + 53) - 720*s**2 + 587*s - 47) + 2124*r**2 + 864*r*s - 2121*r - 1260*s**2 + 353*s + 412) + Pkd2*k2*(45 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 5148*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1)) + 78*b1*(D1*fd*(35*f*k2**2*(3*Pk2*(5*r + s - 2) + 2*Pkd2*k2*(3*s - 1))*(3*r + 3*s - 2) + k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1)) + Dd*f*(35*f*k2**2*(Pk2*(60*r**2 + r*(72*s - 71) + 12*s**2 - 37*s + 20) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + k1**2*(33*K - 33)*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1))))/(9009*d**2*k3**5) + 2*D1**3*Pkd3*ct**3*k1*st**2*(4*Pk2 - Pkd2*k2)*(3*D1*bd1*f**2*(r*(6*s - 2) + s*(6*s - 5)) + b1**2*(D1*fd*(r + s - 1)*(f*(68*s - 37) + 12*s - 12) + Dd*f*(f*(136*r*s - 57*r + 136*s**2 - 176*s + 47) + 48*r*s - 30*r + 48*s**2 - 72*s + 24)) + b1*f*(D1*bd1*f*(4*r*(17*s - 5) + 68*s**2 - 71*s + 10) + 6*D1*bd1*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*D1*fd*(12*s - 7)*(r + s - 1) + 3*Dd*f*(r*(24*s - 11) + 24*s**2 - 32*s + 9)))/(21*d**2*k2*k3) - 2*D1**3*Pkd3*ct**3*(D1*bd1*f*(2*b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(5*s - 6) + s*(5*s - 5)) + f*(Pk2*k2**2*(4*C - 2)*(6*r**2 - r*(7*s + 8) + 2*s) + k1**2*(Pk2*(-10*r**2 + r*(8*C*(14*s - 5) + 17*s + 22) + s*(8*C*(2*s - 9) + 75*s - 27)) + 2*Pkd2*k2*(r*(-28*C*s + 10*C + 2*s + 1) + s*(-4*C*s + 18*C - 10*s + 3)))) - 4*g2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(5*s - 6) + s*(5*s - 5))) - 5*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*s*(r + s - 1) + Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + b1**2*k1**2*(-5*D1*bd1*f*(2*Pk2 - Pkd2*k2)*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - D1*fd*(Pk2*(-20*K*(s - 1) + 3*f*(10*r - 92*s + 41) - 10*r - 123*s + 115) + 2*Pkd2*k2*(5*K*(s - 1) + 3*f*(12*s - 7) + 16*s - 14))*(r + s - 1) + Dd*f*(Pk2*(4*K*(20*r*s - 23*r + 20*s**2 - 37*s + 17) - 12*f*(5*r**2 + r*(8 - 41*s) - 46*s**2 + 55*s - 11) + 40*r**2 + 532*r*s - 221*r + 492*s**2 - 655*s + 167) - 2*Pkd2*k2*(K*(20*r*s - 23*r + 20*s**2 - 37*s + 17) + 3*f*(r*(24*s - 11) + 24*s**2 - 32*s + 9) + 64*r*s - 36*r + 64*s**2 - 92*s + 29))) + b1*(224*C*D1*Pk2*f*fd*k1**2*r*s - 112*C*D1*Pk2*f*fd*k1**2*r + 32*C*D1*Pk2*f*fd*k1**2*s**2 - 240*C*D1*Pk2*f*fd*k1**2*s + 112*C*D1*Pk2*f*fd*k1**2 + 48*C*D1*Pk2*f*fd*k2**2*r**2 - 56*C*D1*Pk2*f*fd*k2**2*r*s - 72*C*D1*Pk2*f*fd*k2**2*r + 28*C*D1*Pk2*f*fd*k2**2*s + 24*C*D1*Pk2*f*fd*k2**2 - 112*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 56*C*D1*Pkd2*f*fd*k1**2*k2*r - 16*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 120*C*D1*Pkd2*f*fd*k1**2*k2*s - 56*C*D1*Pkd2*f*fd*k1**2*k2 + 448*C*Dd*Pk2*f**2*k1**2*r*s - 192*C*Dd*Pk2*f**2*k1**2*r + 64*C*Dd*Pk2*f**2*k1**2*s**2 - 464*C*Dd*Pk2*f**2*k1**2*s + 152*C*Dd*Pk2*f**2*k1**2 + 96*C*Dd*Pk2*f**2*k2**2*r**2 - 112*C*Dd*Pk2*f**2*k2**2*r*s - 160*C*Dd*Pk2*f**2*k2**2*r + 56*C*Dd*Pk2*f**2*k2**2*s + 56*C*Dd*Pk2*f**2*k2**2 - 224*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 96*C*Dd*Pkd2*f**2*k1**2*k2*r - 32*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 232*C*Dd*Pkd2*f**2*k1**2*k2*s - 76*C*Dd*Pkd2*f**2*k1**2*k2 + 20*D1*Pk2*b2*fd*k1**2*r*s - 20*D1*Pk2*b2*fd*k1**2*r + 20*D1*Pk2*b2*fd*k1**2*s**2 - 40*D1*Pk2*b2*fd*k1**2*s + 20*D1*Pk2*b2*fd*k1**2 - 20*D1*Pk2*f*fd*k1**2*r**2 + 34*D1*Pk2*f*fd*k1**2*r*s + 15*D1*Pk2*f*fd*k1**2*r + 150*D1*Pk2*f*fd*k1**2*s**2 - 107*D1*Pk2*f*fd*k1**2*s + 5*D1*Pk2*f*fd*k1**2 - 24*D1*Pk2*f*fd*k2**2*r**2 + 28*D1*Pk2*f*fd*k2**2*r*s + 36*D1*Pk2*f*fd*k2**2*r - 14*D1*Pk2*f*fd*k2**2*s - 12*D1*Pk2*f*fd*k2**2 - 40*D1*Pk2*f*gd2*k1**2*r*s + 48*D1*Pk2*f*gd2*k1**2*r - 40*D1*Pk2*f*gd2*k1**2*s**2 + 88*D1*Pk2*f*gd2*k1**2*s - 48*D1*Pk2*f*gd2*k1**2 - 40*D1*Pk2*fd*g2*k1**2*r*s + 40*D1*Pk2*fd*g2*k1**2*r - 40*D1*Pk2*fd*g2*k1**2*s**2 + 80*D1*Pk2*fd*g2*k1**2*s - 40*D1*Pk2*fd*g2*k1**2 - 10*D1*Pkd2*b2*fd*k1**2*k2*r*s + 10*D1*Pkd2*b2*fd*k1**2*k2*r - 10*D1*Pkd2*b2*fd*k1**2*k2*s**2 + 20*D1*Pkd2*b2*fd*k1**2*k2*s - 10*D1*Pkd2*b2*fd*k1**2*k2 + 8*D1*Pkd2*f*fd*k1**2*k2*r*s + 8*D1*Pkd2*f*fd*k1**2*k2*r - 40*D1*Pkd2*f*fd*k1**2*k2*s**2 + 24*D1*Pkd2*f*fd*k1**2*k2*s - 8*D1*Pkd2*f*fd*k1**2*k2 + 20*D1*Pkd2*f*gd2*k1**2*k2*r*s - 24*D1*Pkd2*f*gd2*k1**2*k2*r + 20*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 44*D1*Pkd2*f*gd2*k1**2*k2*s + 24*D1*Pkd2*f*gd2*k1**2*k2 + 20*D1*Pkd2*fd*g2*k1**2*k2*r*s - 20*D1*Pkd2*fd*g2*k1**2*k2*r + 20*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 40*D1*Pkd2*fd*g2*k1**2*k2*s + 20*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*f*k1**2*(Pk2*(8*K*(5*r*s - 6*r + 5*s**2 - 8*s + 3) - 3*f*(10*r**2 - 82*r*s + r - 92*s**2 + 87*s - 3) + 20*r**2 + 266*r*s - 62*r + 246*s**2 - 270*s + 28) - 2*Pkd2*k2*(2*K*(5*r*s - 6*r + 5*s**2 - 8*s + 3) + 3*f*(4*r*(3*s - 1) + 12*s**2 - 13*s + 2) + 32*r*s - 15*r + 32*s**2 - 39*s + 8)) + 2*D1*bd2*f*k1**2*(2*Pk2 - Pkd2*k2)*(5*s - 6)*(r + s - 1) + 80*Dd*Pk2*b2*f*k1**2*r*s - 92*Dd*Pk2*b2*f*k1**2*r + 80*Dd*Pk2*b2*f*k1**2*s**2 - 148*Dd*Pk2*b2*f*k1**2*s + 68*Dd*Pk2*b2*f*k1**2 - 40*Dd*Pk2*f**2*k1**2*r**2 + 68*Dd*Pk2*f**2*k1**2*r*s + 69*Dd*Pk2*f**2*k1**2*r + 300*Dd*Pk2*f**2*k1**2*s**2 - 139*Dd*Pk2*f**2*k1**2*s - 17*Dd*Pk2*f**2*k1**2 - 48*Dd*Pk2*f**2*k2**2*r**2 + 56*Dd*Pk2*f**2*k2**2*r*s + 80*Dd*Pk2*f**2*k2**2*r - 28*Dd*Pk2*f**2*k2**2*s - 28*Dd*Pk2*f**2*k2**2 - 160*Dd*Pk2*f*g2*k1**2*r*s + 184*Dd*Pk2*f*g2*k1**2*r - 160*Dd*Pk2*f*g2*k1**2*s**2 + 296*Dd*Pk2*f*g2*k1**2*s - 136*Dd*Pk2*f*g2*k1**2 - 40*Dd*Pkd2*b2*f*k1**2*k2*r*s + 46*Dd*Pkd2*b2*f*k1**2*k2*r - 40*Dd*Pkd2*b2*f*k1**2*k2*s**2 + 74*Dd*Pkd2*b2*f*k1**2*k2*s - 34*Dd*Pkd2*b2*f*k1**2*k2 + 16*Dd*Pkd2*f**2*k1**2*k2*r*s + 12*Dd*Pkd2*f**2*k1**2*k2*r - 80*Dd*Pkd2*f**2*k1**2*k2*s**2 + 28*Dd*Pkd2*f**2*k1**2*k2*s - 10*Dd*Pkd2*f**2*k1**2*k2 + 80*Dd*Pkd2*f*g2*k1**2*k2*r*s - 92*Dd*Pkd2*f*g2*k1**2*k2*r + 80*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 148*Dd*Pkd2*f*g2*k1**2*k2*s + 68*Dd*Pkd2*f*g2*k1**2*k2))/(21*d**2*k1*k2*k3) - 2*D1**3*Pkd3*ct**3*st**2*(-33*b1**2*k1**2*(D1*fd*(k1**2*(13*K - 13)*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1) + k2**2*(2*Pk2*f*(17*r**2 + r*(34*s + 3) + 17*s**2 + 40*s - 20) - 6*Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 + r*(2 - 6*s) - s**2 - 6*s + 3) - 37*Pkd2*f*k2*(r + 2*s - 1) - 12*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1))) + Dd*f*(k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(52*s - 22) + 52*s**2 - 71*s + 19) + k2**2*(Pk2*(-12*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + f*(68*r**2 + r*(136*s - 39) + 68*s**2 + 41*s - 29) + 120*r**2 + 144*r*s - 102*r + 24*s**2 + 30*s - 6) - 4*Pkd2*k2*(3*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 6*r + 12*s - 6)))) + b1*k1**2*(-33*D1*bd1*f*(k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(26*s - 6) + 26*s**2 - 29*s + 3) + k2**2*(Pk2*(-12*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) + f*(34*r**2 + r*(68*s - 45) + 34*s**2 - 39*s + 11) + 60*r**2 + 72*r*s - 54*r + 12*s**2 - 6*s + 6) - 3*Pkd2*k2*(4*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(r + 2*s - 1) + 2*r + 4*s - 2))) + 3*D1*(f**2*fd*(-k1**2*(4*Pk2 - Pkd2*k2)*(4*r*(885*s - 394) + 3540*s**2 - 4573*s + 1318) - 11*k2**2*(-2*Pk2*(90*r**2 + 465*r*s - 216*r + 375*s**2 - 376*s + 94) + 5*Pkd2*k2*(30*r*s - 11*r + 30*s**2 - 30*s + 7))) - 11*f*(fd*(2*k1**2*(4*Pk2 - Pkd2*k2)*(2*C*(7*s - 4)*(r + s - 1) + r*(34*s - 19) + 34*s**2 - 32*s + 7) - k2**2*(Pk2*(4*C*(30*r**2 + r*(7 - 66*s) - 72*s**2 + 121*s - 37) + 12*K*(32*r*s - 17*r + 32*s**2 - 34*s + 9) + 96*r**2 + 602*r*s - 238*r + 458*s**2 - 600*s + 159) + 3*Pkd2*k2*(8*C*(2*s - 1)*(4*r + 3*s - 4) - 2*K*(32*r*s - 17*r + 32*s**2 - 34*s + 9) - 48*r*s + 31*r - 40*s**2 + 74*s - 27))) + 2*gd2*(-k1**2*(4*Pk2 - Pkd2*k2)*(13*s - 3) + 12*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1)))*(r + s - 1)) - 22*fd*g2*(-13*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1) + 24*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1)))*(r + s - 1)) + Dd*f*(f**2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(7080*s - 2989) + 7080*s**2 - 8740*s + 2352) - 33*k2**2*(-2*Pk2*(120*r**2 + 620*r*s - 273*r + 500*s**2 - 493*s + 121) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) - 33*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(C*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + r*(68*s - 31) + 68*s**2 - 77*s + 22) + k2**2*(Pk2*(-8*C*(30*r**2 - 3*r*(22*s + 1) - 72*s**2 + 103*s - 19) - 12*K*(64*r*s - 27*r + 64*s**2 - 70*s + 19) - 192*r**2 - 1204*r*s + 475*r - 916*s**2 + 1113*s - 260) - 6*Pkd2*k2*(4*C*(2*r*(8*s - 3) + 12*s**2 - 19*s + 5) + K*(-64*r*s + 27*r - 64*s**2 + 70*s - 19) - 48*r*s + 22*r - 40*s**2 + 62*s - 18))) + 66*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(52*s - 22) + 52*s**2 - 71*s + 19) - 12*k2**2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))) + f*(D1*bd1*k1**2*(f**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(10*r*(354*s - 125) + 3540*s**2 - 3761*s + 750) - 66*k2**2*(-Pk2*(30*r**2 + r*(155*s - 57) + 125*s**2 - 117*s + 27) + 5*Pkd2*k2*(r*(5*s - 1) + 5*s**2 - 5*s + 1))) - 33*f*(2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(C*(7*s - 3) + 17*s - 6) + s**2*(7*C + 17) - s*(5*C + 25) + 9) + k2**2*(-Pk2*(-144*C*s**2 + 144*C*s + 12*K*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + r**2*(60*C + 48) + r*(-132*C*s + 4*C + 301*s - 144) + 229*s**2 - 241*s + 56) + 3*Pkd2*k2*(-24*C*s**2 + 24*C*s + 2*K*(r*(16*s - 5) + 16*s**2 - 18*s + 5) + r*(-32*C*s + 8*C + 24*s - 5) + 20*s**2 - 18*s + 1))) + 66*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(13*s - 3) + s*(13*s - 13)) - 12*k2**2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) + D1*(f*(fd*(Pk2*k2**4*(4*C - 2)*(738*r**2 - 9*r*(50*s + 93) + 414*s + 109) - 9*k1**4*(4*Pk2 - Pkd2*k2)*(r*(372*s - 179) + 372*s**2 - 438*s + 123) + k1**2*k2**2*(Pk2*(24*C*(9*r*(162*s - 65) + 1194*s**2 - 1502*s + 401) + 5517*r**2 + 9*r*(115*s - 139) - 1314*s**2 + 5712*s - 2069) - 12*Pkd2*k2*(C*(9*r*(162*s - 65) + 1194*s**2 - 1502*s + 401) + r*(210 - 531*s) - 399*s**2 + 553*s - 151))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-198*bd2 + 396*gd2)*(r*(16*s - 5) + 16*s**2 - 18*s + 5)) - 198*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(32*s - 17) + 32*s**2 - 34*s + 9)) + Dd*f*(f*(Pk2*k2**4*(8*C - 4)*(492*r**2 - 12*r*(25*s + 53) + 334*s + 149) - 9*k1**4*(4*Pk2 - Pkd2*k2)*(r*(496*s - 229) + 496*s**2 - 606*s + 173) + k1**2*k2**2*(Pk2*(48*C*(r*(972*s - 355) + 796*s**2 - 1027*s + 263) + 7356*r**2 + 4*r*(345*s - 661) - 1752*s**2 + 7740*s - 2515) - 12*Pkd2*k2*(2*C*(r*(972*s - 355) + 796*s**2 - 1027*s + 263) + r*(256 - 708*s) - 532*s**2 + 763*s - 197))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-198*b2 + 396*g2)*(r*(64*s - 27) + 64*s**2 - 70*s + 19))))/(693*d**2*k1*k2*k3**3) + 2*D1**3*Pkd3*ct**3*(165*b1**3*k1**2*k2**2*(D1*fd*(Pk2*(r + s - 1) + 2*Pkd2*k2*s)*(r + s - 1) + Dd*f*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) - 33*b1**2*k1**2*(-5*D1*bd1*f*k2**2*(Pk2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + D1*fd*(2*k1**2*(Pk2*(8*C*r*s + 8*C*s**2 - 8*C*s + 17*K*(s - 1)*(r + s - 1) + 2*f*(2*r**2 - 12*r*(s + 1) - 14*s**2 + s + 10) + r**2 - 25*r*s + 15*r - 26*s**2 + 40*s - 16) + Pkd2*k2*(-4*C*r*s - 4*C*s**2 + 4*C*s - 7*K*(s - 1)*(r + s - 1) + f*(8*r*(2*s + 1) + 16*s**2 - 5*s - 8) + 12*r*s - 7*r + 12*s**2 - 18*s + 7)) + k2**2*(Pk2*(-28*C*(r - 1)*(r + s - 1) - 26*K*r**2 + 102*K*r*(s - 1) + 128*K*(s - 1)**2 + 20*f*r**2 + 56*f*r*s - 26*f*r + 36*f*s**2 + 74*f*s + 113*r**2 + 129*r*s - 75*r + 16*s**2 + 58*s - 15) - 2*Pkd2*k2*(-48*C*r*s + 8*C*s**2 + 48*C*s + K*(38*r*s - 23*r + 38*s**2 - 46*s + 23) + 21*f*(r + 2*s - 1) + 22*r*s + 14*r - 6*s**2 + 6*s - 14))) + 2*Dd*f*k1**2*(Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 68*K*r*s - 53*K*r + 68*K*s**2 - 109*K*s + 41*K + 2*f*(4*r**2 - 24*r*s - 29*r - 28*s**2 + 5*s + 17) + 4*r**2 - 100*r*s + 44*r - 104*s**2 + 152*s - 42) + Pkd2*k2*(-2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*K*r*s + 28*K*r - 28*K*s**2 + 49*K*s - 21*K + 2*f*(16*r*s + 11*r + 16*s**2 - 6*s - 7) + 48*r*s - 27*r + 48*s**2 - 74*s + 23)) + Dd*f*k2**2*(Pk2*(-56*C*(2*r**2 + 2*r*(s - 2) - 3*s + 2) - 104*K*r**2 + 408*K*r*s + 28*K*r + 512*K*s**2 - 588*K*s + 76*K + 2*f*(20*r**2 + 56*r*s - 27*r + 36*s**2 + 37*s - 10) + 452*r**2 + 516*r*s - 612*r + 64*s**2 - 162*s + 165) + 2*Pkd2*k2*(8*C*(3*r*(8*s - 1) - 4*s**2 - 17*s + 3) - 152*K*r*s + 51*K*r - 152*K*s**2 + 168*K*s - 39*K - 24*f*(r + 2*s - 1) - 88*r*s - 17*r + 24*s**2 + 4*s + 17))) - 33*b1*(2*D1*bd1*f*k1**2*(k1**2*(Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 34*K*r*s - 24*K*r + 34*K*s**2 - 46*K*s + 12*K + 2*f*(2*r**2 - 12*r*s - 17*r - 14*s**2 + 4*s + 7) + 2*r**2 - 50*r*s + 19*r - 52*s**2 + 69*s - 15) + Pkd2*k2*(C*(r*(2 - 8*s) - 2*(1 - 2*s)**2) - 14*K*r*s + 14*K*r - 14*K*s**2 + 21*K*s - 7*K + f*(2*r*(8*s + 7) + 16*s**2 - 7*s - 6) + 24*r*s - 13*r + 24*s**2 - 34*s + 9)) + k2**2*(Pk2*(-28*C*(r**2 + r*(s - 2) - 2*s + 1) - 26*K*r**2 + 102*K*r*s + 39*K*r + 128*K*s**2 - 115*K*s - 13*K + 2*f*(5*r**2 + 14*r*s - 7*r + 9*s**2 - 5) + 113*r**2 + 129*r*s - 174*r + 16*s**2 - 80*s + 52) + Pkd2*k2*(8*C*(3*r*(4*s - 1) - 2*s**2 - 5*s + 3) - 4*K*(19*r*s - 5*r + 19*s**2 - 20*s + 2) - 3*f*(r + 2*s - 1) - 44*r*s + 4*r + 12*s**2 + 2*s - 4))) + D1*(-f**2*fd*k1**2*(22*Pk2*k2**2*(18*r**2 + r*(33*s - 28) + 15*s**2 - 22*s + 10) + k1**2*(Pk2*(270*r**2 - 558*r*s + 3*r - 828*s**2 + 1009*s - 205) + 5*Pkd2*k2*(72*r*s - 36*r + 72*s**2 - 97*s + 30))) + f*(fd*(Pk2*k2**4*(6 - 12*C)*(2*r - 1) + k1**4*(Pk2*(-4*C*(46*r*s + r - 2*s**2 - 21*s - 1) + 8*K*(s - 2)*(2*r + 2*s - 1) - 44*r**2 + 342*r*s - 129*r + 290*s**2 - 419*s + 103) + 4*Pkd2*k2*(6*C*(2*r*s + r - 2*s**2 + s - 1) - K*(s - 2)*(2*r + 2*s - 1) - 36*r*s + 12*r - 24*s**2 + 27*s - 3)) - 2*k1**2*k2**2*(Pk2*(2*C*(66*r**2 + r*(38 - 430*s) - 74*s**2 + 389*s - 104) + K*(-34*r**2 + 86*r*s - 54*r + 120*s**2 - 146*s + 43) + 42*r**2 + 628*r*s - 159*r + 164*s**2 - 550*s + 134) + 2*Pkd2*k2*(C*(r*(56*s - 22) + 56*s**2 - 72*s + 22) - 3*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) - 28*r*s + 20*r - 28*s**2 + 54*s - 20))) - 2*k1**2*(bd2*k2**2*(-5*Pk2*(r + s - 1)**2 + Pkd2*k2*s*(15*r + 15*s - 11)) + 2*gd2*(k1**2*(Pk2*(17*s - 12) - 7*Pkd2*k2*(s - 1))*(r + s - 1) + k2**2*(Pk2*(-13*r**2 + 51*r*s + 26*r + 64*s**2 - 51*s - 13) - 2*Pkd2*k2*(19*r*s - 4*r + 19*s**2 - 21*s + 4))))) - 2*fd*k1**2*(5*b2*k2**2*(-Pk2*(r + s - 1)**2 + 3*Pkd2*k2*s*(r + s)) + 2*g2*(k1**2*(17*Pk2 - 7*Pkd2*k2)*(s - 1)*(r + s - 1) + k2**2*(Pk2*(-13*r**2 + 51*r*(s - 1) + 64*(s - 1)**2) + Pkd2*k2*(r*(23 - 38*s) - 38*s**2 + 46*s - 23))))) + Dd*f*(-2*f**2*k1**2*(11*Pk2*k2**2*(24*r**2 + r*(44*s - 37) + 20*s**2 - 29*s + 13) + k1**2*(2*Pk2*(90*r**2 - 2*r*(93*s + 1) - 276*s**2 + 320*s - 61) + 5*Pkd2*k2*(r*(48*s - 23) + 48*s**2 - 62*s + 18))) + f*(4*Pk2*k2**4*(C*(2 - 4*r) + 2*r - 1) + k1**4*(Pk2*(4*C*(-r*(92*s + 21) + 4*s**2 + 43*s + 11) + 8*K*(4*r*s - 9*r + 4*s**2 - 13*s + 7) - 88*r**2 + 684*r*s - 153*r + 580*s**2 - 889*s + 199) + 2*Pkd2*k2*(12*C*(r*(4*s + 3) - 4*s**2 + s - 2) - 2*K*(4*r*s - 9*r + 4*s**2 - 13*s + 7) - 144*r*s + 42*r - 96*s**2 + 144*s - 33)) - 2*k1**2*k2**2*(Pk2*(2*C*(132*r**2 - r*(860*s + 69) - 148*s**2 + 741*s - 67) + K*(-68*r**2 + 172*r*s - 38*r + 240*s**2 - 246*s + 61) + 84*r**2 + 1256*r*s - 240*r + 328*s**2 - 1058*s + 186) + 2*Pkd2*k2*(2*C*(7*r*(8*s - 3) + 56*s**2 - 64*s + 16) - 3*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 56*r*s + 33*r - 56*s**2 + 88*s - 28))) - 2*k1**2*(b2*k2**2*(-5*Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(r*(60*s - 4) + s*(60*s - 37))) + 2*g2*(k1**2*(Pk2*(68*r*s - 53*r + 68*s**2 - 109*s + 41) - 7*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k2**2*(Pk2*(-52*r**2 + 204*r*s + 14*r + 256*s**2 - 294*s + 38) + Pkd2*k2*(-152*r*s + 51*r - 152*s**2 + 168*s - 39)))))) + f*(-360*C*D1*Pk2*f*fd*k1**4*r*s + 2760*C*D1*Pk2*f*fd*k1**4*r - 360*C*D1*Pk2*f*fd*k1**4*s**2 + 3000*C*D1*Pk2*f*fd*k1**4*s - 1840*C*D1*Pk2*f*fd*k1**4 - 14148*C*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 18324*C*D1*Pk2*f*fd*k1**2*k2**2*r*s + 9792*C*D1*Pk2*f*fd*k1**2*k2**2*r + 15048*C*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 17064*C*D1*Pk2*f*fd*k1**2*k2**2*s + 288*C*D1*Pk2*f*fd*k1**2*k2**2 - 792*C*D1*Pk2*f*fd*k2**4*r**2 - 792*C*D1*Pk2*f*fd*k2**4*r*s + 660*C*D1*Pk2*f*fd*k2**4*r + 264*C*D1*Pk2*f*fd*k2**4*s - 132*C*D1*Pk2*f*fd*k2**4 + 180*C*D1*Pkd2*f*fd*k1**4*k2*r*s - 1380*C*D1*Pkd2*f*fd*k1**4*k2*r + 180*C*D1*Pkd2*f*fd*k1**4*k2*s**2 - 1500*C*D1*Pkd2*f*fd*k1**4*k2*s + 920*C*D1*Pkd2*f*fd*k1**4*k2 - 15840*C*D1*Pkd2*f*fd*k1**2*k2**3*r*s + 7920*C*D1*Pkd2*f*fd*k1**2*k2**3*r - 15840*C*D1*Pkd2*f*fd*k1**2*k2**3*s**2 + 18480*C*D1*Pkd2*f*fd*k1**2*k2**3*s - 5280*C*D1*Pkd2*f*fd*k1**2*k2**3 - 480*C*Dd*Pk2*f**2*k1**4*r*s + 3880*C*Dd*Pk2*f**2*k1**4*r - 480*C*Dd*Pk2*f**2*k1**4*s**2 + 4440*C*Dd*Pk2*f**2*k1**4*s - 2960*C*Dd*Pk2*f**2*k1**4 - 18864*C*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 24432*C*Dd*Pk2*f**2*k1**2*k2**2*r*s + 17328*C*Dd*Pk2*f**2*k1**2*k2**2*r + 20064*C*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 22896*C*Dd*Pk2*f**2*k1**2*k2**2*s - 2532*C*Dd*Pk2*f**2*k1**2*k2**2 - 1056*C*Dd*Pk2*f**2*k2**4*r**2 - 1056*C*Dd*Pk2*f**2*k2**4*r*s + 1056*C*Dd*Pk2*f**2*k2**4*r + 528*C*Dd*Pk2*f**2*k2**4*s - 264*C*Dd*Pk2*f**2*k2**4 + 240*C*Dd*Pkd2*f**2*k1**4*k2*r*s - 1940*C*Dd*Pkd2*f**2*k1**4*k2*r + 240*C*Dd*Pkd2*f**2*k1**4*k2*s**2 - 2220*C*Dd*Pkd2*f**2*k1**4*k2*s + 1480*C*Dd*Pkd2*f**2*k1**4*k2 - 21120*C*Dd*Pkd2*f**2*k1**2*k2**3*r*s + 9900*C*Dd*Pkd2*f**2*k1**2*k2**3*r - 21120*C*Dd*Pkd2*f**2*k1**2*k2**3*s**2 + 25080*C*Dd*Pkd2*f**2*k1**2*k2**3*s - 7260*C*Dd*Pkd2*f**2*k1**2*k2**3 - 528*D1*Pk2*b2*fd*k1**4*r*s + 1056*D1*Pk2*b2*fd*k1**4*r - 528*D1*Pk2*b2*fd*k1**4*s**2 + 1320*D1*Pk2*b2*fd*k1**4*s - 528*D1*Pk2*b2*fd*k1**4 - 2244*D1*Pk2*b2*fd*k1**2*k2**2*r**2 + 5676*D1*Pk2*b2*fd*k1**2*k2**2*r*s - 3564*D1*Pk2*b2*fd*k1**2*k2**2*r + 7920*D1*Pk2*b2*fd*k1**2*k2**2*s**2 - 9636*D1*Pk2*b2*fd*k1**2*k2**2*s + 2838*D1*Pk2*b2*fd*k1**2*k2**2 + 4050*D1*Pk2*f*fd*k1**4*r**2 - 3069*D1*Pk2*f*fd*k1**4*r*s - 753*D1*Pk2*f*fd*k1**4*r - 7119*D1*Pk2*f*fd*k1**4*s**2 + 8838*D1*Pk2*f*fd*k1**4*s - 2013*D1*Pk2*f*fd*k1**4 + 18855*D1*Pk2*f*fd*k1**2*k2**2*r**2 + 11133*D1*Pk2*f*fd*k1**2*k2**2*r*s - 17865*D1*Pk2*f*fd*k1**2*k2**2*r + 990*D1*Pk2*f*fd*k1**2*k2**2*s**2 - 840*D1*Pk2*f*fd*k1**2*k2**2*s + 2793*D1*Pk2*f*fd*k1**2*k2**2 + 396*D1*Pk2*f*fd*k2**4*r**2 + 396*D1*Pk2*f*fd*k2**4*r*s - 330*D1*Pk2*f*fd*k2**4*r - 132*D1*Pk2*f*fd*k2**4*s + 66*D1*Pk2*f*fd*k2**4 + 528*D1*Pk2*f*gd2*k1**4*r*s - 1320*D1*Pk2*f*gd2*k1**4*r + 528*D1*Pk2*f*gd2*k1**4*s**2 - 2112*D1*Pk2*f*gd2*k1**4*s + 1320*D1*Pk2*f*gd2*k1**4 + 2244*D1*Pk2*f*gd2*k1**2*k2**2*r**2 - 5676*D1*Pk2*f*gd2*k1**2*k2**2*r*s - 1056*D1*Pk2*f*gd2*k1**2*k2**2*r - 7920*D1*Pk2*f*gd2*k1**2*k2**2*s**2 + 6600*D1*Pk2*f*gd2*k1**2*k2**2*s - 1188*D1*Pk2*f*gd2*k1**2*k2**2 + 1056*D1*Pk2*fd*g2*k1**4*r*s - 2112*D1*Pk2*fd*g2*k1**4*r + 1056*D1*Pk2*fd*g2*k1**4*s**2 - 2640*D1*Pk2*fd*g2*k1**4*s + 1056*D1*Pk2*fd*g2*k1**4 + 4488*D1*Pk2*fd*g2*k1**2*k2**2*r**2 - 11352*D1*Pk2*fd*g2*k1**2*k2**2*r*s + 7128*D1*Pk2*fd*g2*k1**2*k2**2*r - 15840*D1*Pk2*fd*g2*k1**2*k2**2*s**2 + 19272*D1*Pk2*fd*g2*k1**2*k2**2*s - 5676*D1*Pk2*fd*g2*k1**2*k2**2 + 264*D1*Pkd2*b2*fd*k1**4*k2*r*s - 528*D1*Pkd2*b2*fd*k1**4*k2*r + 264*D1*Pkd2*b2*fd*k1**4*k2*s**2 - 660*D1*Pkd2*b2*fd*k1**4*k2*s + 264*D1*Pkd2*b2*fd*k1**4*k2 - 6336*D1*Pkd2*b2*fd*k1**2*k2**3*r*s + 3564*D1*Pkd2*b2*fd*k1**2*k2**3*r - 6336*D1*Pkd2*b2*fd*k1**2*k2**3*s**2 + 7128*D1*Pkd2*b2*fd*k1**2*k2**3*s - 1980*D1*Pkd2*b2*fd*k1**2*k2**3 + 4860*D1*Pkd2*f*fd*k1**4*k2*r*s - 2610*D1*Pkd2*f*fd*k1**4*k2*r + 4860*D1*Pkd2*f*fd*k1**4*k2*s**2 - 6180*D1*Pkd2*f*fd*k1**4*k2*s + 1850*D1*Pkd2*f*fd*k1**4*k2 + 7920*D1*Pkd2*f*fd*k1**2*k2**3*r*s - 3960*D1*Pkd2*f*fd*k1**2*k2**3*r + 7920*D1*Pkd2*f*fd*k1**2*k2**3*s**2 - 9240*D1*Pkd2*f*fd*k1**2*k2**3*s + 2640*D1*Pkd2*f*fd*k1**2*k2**3 - 264*D1*Pkd2*f*gd2*k1**4*k2*r*s + 660*D1*Pkd2*f*gd2*k1**4*k2*r - 264*D1*Pkd2*f*gd2*k1**4*k2*s**2 + 1056*D1*Pkd2*f*gd2*k1**4*k2*s - 660*D1*Pkd2*f*gd2*k1**4*k2 + 6336*D1*Pkd2*f*gd2*k1**2*k2**3*r*s - 2376*D1*Pkd2*f*gd2*k1**2*k2**3*r + 6336*D1*Pkd2*f*gd2*k1**2*k2**3*s**2 - 7920*D1*Pkd2*f*gd2*k1**2*k2**3*s + 2376*D1*Pkd2*f*gd2*k1**2*k2**3 - 528*D1*Pkd2*fd*g2*k1**4*k2*r*s + 1056*D1*Pkd2*fd*g2*k1**4*k2*r - 528*D1*Pkd2*fd*g2*k1**4*k2*s**2 + 1320*D1*Pkd2*fd*g2*k1**4*k2*s - 528*D1*Pkd2*fd*g2*k1**4*k2 + 12672*D1*Pkd2*fd*g2*k1**2*k2**3*r*s - 7128*D1*Pkd2*fd*g2*k1**2*k2**3*r + 12672*D1*Pkd2*fd*g2*k1**2*k2**3*s**2 - 14256*D1*Pkd2*fd*g2*k1**2*k2**3*s + 3960*D1*Pkd2*fd*g2*k1**2*k2**3 + 33*D1*bd1*(f**2*k1**2*(22*Pk2*k2**2*(6*r**2 + r*(11*s - 9) + 5*s**2 - 7*s + 3) + k1**2*(Pk2*(90*r**2 - 186*r*s - 11*r - 276*s**2 + 271*s - 39) + 5*Pkd2*k2*(24*r*s - 10*r + 24*s**2 - 27*s + 6))) + f*(2*Pk2*k2**4*(C*(4 - 6*r) + 3*r - 2) + k1**4*(Pk2*(-4*C*s**2 - 36*C*s - 4*K*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + 22*r**2 + r*(92*C*s + 40*C - 171*s + 22) - 145*s**2 + 249*s - 72) + 2*Pkd2*k2*(K*(r*(2*s - 5) + 2*s**2 - 8*s + 5) - 12*r*(C*s + C - 3*s + 1) + 3*s**2*(4*C + 8) - 51*s + 21)) - 2*k1**2*k2**2*(Pk2*(74*C*s**2 - 282*C*s + K*(17*r**2 - r*(43*s + 8) - 60*s**2 + 50*s - 9) - r**2*(66*C + 21) + r*(430*C*s + 74*C - 314*s + 69) - 82*s**2 + 224*s - 61) + Pkd2*k2*(C*(r*(26 - 56*s) - 56*s**2 + 48*s - 6) + 6*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 28*r*s - 13*r + 28*s**2 - 24*s + 3))) + 2*k1**2*(b2*k2**2*(-5*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(15*s - 4) + s*(15*s - 15))) + 2*g2*(k1**2*(Pk2*r*(17*s - 12) + 17*Pk2*s*(s - 1) - 7*Pkd2*k2*(r + s)*(s - 1)) + k2**2*(Pk2*(-13*r**2 + r*(51*s + 13) + s*(64*s - 64)) + 2*Pkd2*k2*(r*(6 - 19*s) - s*(19*s - 19)))))) - 66*D1*bd2*f*k1**2*(k1**2*(2*Pk2 - Pkd2*k2)*(r*(2*s - 5) + 2*s**2 - 8*s + 5) + k2**2*(Pk2*(17*r**2 - 43*r*s - 8*r - 60*s**2 + 50*s - 9) + 6*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3))) - 1056*Dd*Pk2*b2*f*k1**4*r*s + 2376*Dd*Pk2*b2*f*k1**4*r - 1056*Dd*Pk2*b2*f*k1**4*s**2 + 3432*Dd*Pk2*b2*f*k1**4*s - 1848*Dd*Pk2*b2*f*k1**4 - 4488*Dd*Pk2*b2*f*k1**2*k2**2*r**2 + 11352*Dd*Pk2*b2*f*k1**2*k2**2*r*s - 2508*Dd*Pk2*b2*f*k1**2*k2**2*r + 15840*Dd*Pk2*b2*f*k1**2*k2**2*s**2 - 16236*Dd*Pk2*b2*f*k1**2*k2**2*s + 4026*Dd*Pk2*b2*f*k1**2*k2**2 + 5400*Dd*Pk2*f**2*k1**4*r**2 - 4092*Dd*Pk2*f**2*k1**4*r*s - 1805*Dd*Pk2*f**2*k1**4*r - 9492*Dd*Pk2*f**2*k1**4*s**2 + 11873*Dd*Pk2*f**2*k1**4*s - 2311*Dd*Pk2*f**2*k1**4 + 25140*Dd*Pk2*f**2*k1**2*k2**2*r**2 + 14844*Dd*Pk2*f**2*k1**2*k2**2*r*s - 27078*Dd*Pk2*f**2*k1**2*k2**2*r + 1320*Dd*Pk2*f**2*k1**2*k2**2*s**2 - 1620*Dd*Pk2*f**2*k1**2*k2**2*s + 5721*Dd*Pk2*f**2*k1**2*k2**2 + 528*Dd*Pk2*f**2*k2**4*r**2 + 528*Dd*Pk2*f**2*k2**4*r*s - 528*Dd*Pk2*f**2*k2**4*r - 264*Dd*Pk2*f**2*k2**4*s + 132*Dd*Pk2*f**2*k2**4 + 2112*Dd*Pk2*f*g2*k1**4*r*s - 4752*Dd*Pk2*f*g2*k1**4*r + 2112*Dd*Pk2*f*g2*k1**4*s**2 - 6864*Dd*Pk2*f*g2*k1**4*s + 3696*Dd*Pk2*f*g2*k1**4 + 8976*Dd*Pk2*f*g2*k1**2*k2**2*r**2 - 22704*Dd*Pk2*f*g2*k1**2*k2**2*r*s + 5016*Dd*Pk2*f*g2*k1**2*k2**2*r - 31680*Dd*Pk2*f*g2*k1**2*k2**2*s**2 + 32472*Dd*Pk2*f*g2*k1**2*k2**2*s - 8052*Dd*Pk2*f*g2*k1**2*k2**2 + 528*Dd*Pkd2*b2*f*k1**4*k2*r*s - 1188*Dd*Pkd2*b2*f*k1**4*k2*r + 528*Dd*Pkd2*b2*f*k1**4*k2*s**2 - 1716*Dd*Pkd2*b2*f*k1**4*k2*s + 924*Dd*Pkd2*b2*f*k1**4*k2 - 12672*Dd*Pkd2*b2*f*k1**2*k2**3*r*s + 5940*Dd*Pkd2*b2*f*k1**2*k2**3*r - 12672*Dd*Pkd2*b2*f*k1**2*k2**3*s**2 + 15048*Dd*Pkd2*b2*f*k1**2*k2**3*s - 4356*Dd*Pkd2*b2*f*k1**2*k2**3 + 6480*Dd*Pkd2*f**2*k1**4*k2*r*s - 3320*Dd*Pkd2*f**2*k1**4*k2*r + 6480*Dd*Pkd2*f**2*k1**4*k2*s**2 - 8460*Dd*Pkd2*f**2*k1**4*k2*s + 2560*Dd*Pkd2*f**2*k1**4*k2 + 10560*Dd*Pkd2*f**2*k1**2*k2**3*r*s - 4950*Dd*Pkd2*f**2*k1**2*k2**3*r + 10560*Dd*Pkd2*f**2*k1**2*k2**3*s**2 - 12540*Dd*Pkd2*f**2*k1**2*k2**3*s + 3630*Dd*Pkd2*f**2*k1**2*k2**3 - 1056*Dd*Pkd2*f*g2*k1**4*k2*r*s + 2376*Dd*Pkd2*f*g2*k1**4*k2*r - 1056*Dd*Pkd2*f*g2*k1**4*k2*s**2 + 3432*Dd*Pkd2*f*g2*k1**4*k2*s - 1848*Dd*Pkd2*f*g2*k1**4*k2 + 25344*Dd*Pkd2*f*g2*k1**2*k2**3*r*s - 11880*Dd*Pkd2*f*g2*k1**2*k2**3*r + 25344*Dd*Pkd2*f*g2*k1**2*k2**3*s**2 - 30096*Dd*Pkd2*f*g2*k1**2*k2**3*s + 8712*Dd*Pkd2*f*g2*k1**2*k2**3))/(693*d**2*k1*k2*k3**3) + 2*D1**3*Pkd3*ct**3*st**2*(13*D1*bd1*f*k1**2*(f**2*k2**2*(k1**2*(Pk2*(13620*r**2 + 3*r*(8312*s - 6657) + 11316*s**2 - 17215*s + 5143) + Pkd2*k2*(9*r*(128*s - 13) + 1152*s**2 - 1495*s + 721)) - 33*k2**2*(Pk2*(85*r**2 + 60*r*s - 86*r - 25*s**2 - 6*s + 19) + 10*Pkd2*k2*(5*r*s - r + 5*s**2 - 5*s + 1))) + 33*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) + k1**2*k2**2*(Pk2*(2*C*(35*r**2 + 3*r*(40*s - 19) + 85*s**2 - 93*s + 8) - 4*K*(32*r**2 + 47*r*s - 35*r + 15*s**2 - 7*s + 3) + 283*r**2 + 494*r*s - 422*r + 211*s**2 - 322*s + 167) + Pkd2*k2*(C*(r*(22 - 50*s) - 50*s**2 + 58*s - 8) - 9*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 74*r*s - 31*r + 74*s**2 - 88*s + 17)) + k2**4*(Pk2*(120*C*r**2 + 420*C*r*s - 140*C*r + 180*C*s**2 - 240*C*s - 2*K*(248*r**2 + 521*r*s - 377*r + 273*s**2 - 370*s + 129) + 15*b1*(r + s - 1) - 21*r**2 - 113*r*s + 18*r - 32*s**2 + 77*s + 23) + Pkd2*k2*(-24*C*(r*(4*s - 2) + 3*s**2 - 4*s + 1) - 6*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + b1*(17*r*(4*s - 1) + 68*s**2 - 65*s + 7) + 42*r*s - 27*r + 30*s**2 - 45*s + 9))) - 33*k2**2*(-b1*k1**2*(K - 1)*(Pk2*(130*r**2 + r*(416*s - 241) + 286*s**2 - 305*s + 65) + Pkd2*k2*(r*(23 - 78*s) + s*(55 - 78*s))) + 6*b1*k2**2*(Pk2*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) + 2*g2*(k1**2*(Pk2*(65*r**2 + r*(208*s - 111) + s*(143*s - 143)) + Pkd2*k2*(r*(23 - 39*s) - s*(39*s - 39))) - 12*k2**2*(Pk2*(-3*r**2 + r*(4 - 8*s) - s*(5*s - 5)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 429*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(13*K - 13)*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + k2**2*(Pk2*(12*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 5*f*(37*r + 37*s - 27) + 24*r**2 + 24*r*s + 60*r + 60*s - 30) + Pkd2*k2*s*(f*(68*r + 68*s - 31) + (12 - 24*K)*(r + s)))) + Dd*f*(k1**2*(K - 1)*(Pk2*(260*r**2 + r*(832*s - 501) + 572*s**2 - 597*s + 195) + Pkd2*k2*(r*(23 - 156*s) + s*(71 - 156*s))) + k2**2*(2*Pk2*(6*K*(12*r**2 + r*(32*s - 30) + 20*s**2 - 33*s + 15) + 25*f*(4*r + 4*s - 3) + 48*r**2 + 48*r*s + 30*r + 48*s - 45) + Pkd2*k2*(f*(17*r*(8*s - 1) + 136*s**2 - 96*s + 7) + (6 - 12*K)*(r*(8*s - 1) + 4*s*(2*s - 1)))))) + 13*b1*k1**2*(-3*D1*f**2*fd*k2**2*(-k1**2*(Pk2*(13620*r**2 + r*(24936*s - 18571) + 11316*s**2 - 16551*s + 6833) + Pkd2*k2*(3*r*(384*s - 659) + 1152*s**2 - 2987*s + 1351)) + 11*k2**2*(Pk2*(255*r**2 + 3*r*(60*s - 91) - 75*s**2 - 83*s + 74) + 5*Pkd2*k2*(r*(30*s - 11) + 30*s**2 - 30*s + 7))) + 33*D1*f*(fd*k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + fd*k1**2*k2**2*(Pk2*(4*C*(35*r**2 + 10*r*(12*s - 7) + 85*s**2 - 92*s + 35) - 4*K*(64*r**2 + 94*r*s - 48*r + 30*s**2 - 19*s + 2) + 566*r**2 + 988*r*s - 515*r + 422*s**2 - 419*s + 63) + Pkd2*k2*(-100*C*s**2 + 44*C*s - 9*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + r*(-100*C*s + 148*s - 27) + 148*s**2 - 98*s + 15)) - fd*k2**4*(Pk2*(-4*C*(60*r**2 + 42*r*(5*s - 4) + 90*s**2 - 214*s + 99) + 2*K*(496*r**2 + 1042*r*s - 553*r + 546*s**2 - 561*s + 144) + 42*r**2 + 226*r*s - 303*r + 64*s**2 - 395*s + 232) + 3*Pkd2*k2*(48*C*s**2 - 32*C*s + 2*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 4*r*(16*C*s - 7*s - 2) - 20*s**2 + 5*s + 4)) + 2*gd2*k1**2*k2**2*(-Pk2*(65*r**2 + 26*r*(8*s - 5) + 143*s**2 - 162*s + 65) + Pkd2*k2*s*(39*r + 39*s - 16)) + 24*gd2*k2**4*(-Pk2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 66*D1*fd*g2*k2**2*(-13*k1**2*(Pk2*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5) - 3*Pkd2*k2*s*(r + s)) + 12*k2**2*(-Pk2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*k2*s*(r + s))) + Dd*f*(f**2*k2**2*(2*k1**2*(Pk2*(27240*r**2 + 6*r*(8312*s - 6307) + 22632*s**2 - 33434*s + 12821) + Pkd2*k2*(144*r*(16*s - 21) + 2304*s**2 - 5228*s + 2387)) - 33*k2**2*(Pk2*(340*r**2 + 240*r*s - 359*r - 100*s**2 - 89*s + 93) + 5*Pkd2*k2*(40*r*s - 13*r + 40*s**2 - 40*s + 9))) + 33*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + k1**2*k2**2*(Pk2*(C*(280*r**2 + 6*r*(160*s - 89) + 680*s**2 - 766*s + 226) - 4*K*(128*r**2 + 2*r*(94*s - 59) + 60*s**2 - 33*s + 8) + 1132*r**2 + 1976*r*s - 1333*r + 844*s**2 - 1037*s + 343) + Pkd2*k2*(-2*C*(r*(100*s - 11) + 100*s**2 - 69*s + 4) - 9*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) + 296*r*s - 67*r + 296*s**2 - 252*s + 41)) - k2**4*(Pk2*(-4*C*(120*r**2 + 4*r*(105*s - 68) + 180*s**2 - 383*s + 138) + 2*K*(992*r**2 + 2084*r*s - 1307*r + 1092*s**2 - 1301*s + 402) + 84*r**2 + 452*r*s - 430*r + 128*s**2 - 670*s + 297) + 3*Pkd2*k2*(8*C*(2*r*(8*s - 1) + 12*s**2 - 11*s + 1) + K*(64*r*s - 30*r + 64*s**2 - 76*s + 22) - 56*r*s - r - 40*s**2 + 28*s + 3))) + 66*g2*k2**2*(-k1**2*(Pk2*(260*r**2 + r*(832*s - 501) + 572*s**2 - 597*s + 195) + Pkd2*k2*(r*(23 - 156*s) + s*(71 - 156*s))) + 12*k2**2*(-Pk2*(12*r**2 + 32*r*s - 30*r + 20*s**2 - 33*s + 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))))) + f*(D1*(f**2*fd*k1**2*(14040*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 25*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4120*s - 1693) + 4120*s**2 - 5004*s + 1325) + 13*k1**2*k2**2*(-2*Pk2*(2208*r**2 + 3*r*(14356*s - 4231) + 40860*s**2 - 40327*s + 7939) + 125*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(fd*(Pk2*k2**6*(4*C - 2)*(738*r**2 - 9*r*(50*s + 93) + 414*s + 109) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) - 3*k1**4*k2**2*(4*C*Pk2*(987*r**2 + r*(729*s - 758) + 270*s**2 + 171*s - 25) - 6*Pk2*(1423*r**2 + 2564*r*s - 1741*r + 1317*s**2 - 1476*s + 483) + Pkd2*k2*(8*C*(492*r*s - 197*r + 360*s**2 - 525*s + 146) - 2292*r*s + 929*r - 1764*s**2 + 2490*s - 689)) + k1**2*k2**4*(Pk2*(-4*C*(14256*r**2 + 27*r*(1979*s - 810) + 19377*s**2 - 34491*s + 9113) + 23337*r**2 + 9*r*(11557*s - 4393) + 41076*s**2 - 68820*s + 17405) - 12*Pkd2*k2*(C*(3*r*(222*s - 85) + 402*s**2 - 710*s + 203) - (3*s - 1)*(45*r + s - 52)))) - 66*k1**2*(5*Pk2*bd2*k2**4*(31*r**2 + r*(62*s - 48) + 31*s**2 - 48*s + 17) + gd2*(k1**4*(4*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) - k1**2*k2**2*(4*Pk2*(32*r**2 + r*(47*s - 35) + 15*s**2 - 7*s + 3) + 9*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)) - 2*k2**4*(Pk2*(248*r**2 + r*(521*s - 377) + 273*s**2 - 370*s + 129) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3))))) - 858*fd*k1**2*(5*Pk2*b2*k2**4*(62*r**2 + r*(124*s - 65) + 62*s**2 - 65*s + 17) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) - k1**2*k2**2*(4*Pk2*(64*r**2 + 94*r*s - 48*r + 30*s**2 - 19*s + 2) + 9*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5)) - 2*k2**4*(Pk2*(496*r**2 + 1042*r*s - 553*r + 546*s**2 - 561*s + 144) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(f**2*k1**2*(14040*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 25*k1**4*(4*Pk2 - Pkd2*k2)*(r*(4120*s - 1693) + 4120*s**2 - 5004*s + 1325) + 13*k1**2*k2**2*(-2*Pk2*(2208*r**2 + 3*r*(14356*s - 4231) + 40860*s**2 - 40327*s + 7939) + 125*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 13*f*(Pk2*k2**6*(8*C - 4)*(492*r**2 - 12*r*(25*s + 53) + 334*s + 149) + k1**6*(6*C - 6)*(4*Pk2 - Pkd2*k2)*(r*(204*s - 98) + 204*s**2 - 281*s + 81) - 3*k1**4*k2**2*(2*Pk2*(4*C*(658*r**2 + 486*r*s - 537*r + 180*s**2 + 204*s - 19) - 5692*r**2 - 10256*r*s + 7280*r - 5268*s**2 + 5909*s - 2083) + Pkd2*k2*(2*C*(2624*r*s - 989*r + 1920*s**2 - 2954*s + 785) - 3056*r*s + 1181*r - 2352*s**2 + 3518*s - 941)) + k1**2*k2**4*(Pk2*(-4*C*(19008*r**2 + 9*r*(7916*s - 3253) + 25836*s**2 - 49607*s + 11768) + 31116*r**2 + 14*r*(9906*s - 3707) + 54768*s**2 - 98302*s + 21987) - 12*Pkd2*k2*(C*(r*(888*s - 314) + 536*s**2 - 998*s + 262) + r*(58 - 180*s) - 4*s**2 + 235*s - 65))) - 858*k1**2*(5*Pk2*b2*k2**4*(124*r**2 + r*(248*s - 161) + 124*s**2 - 161*s + 51) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) - k1**2*k2**2*(4*Pk2*(128*r**2 + 2*r*(94*s - 59) + 60*s**2 - 33*s + 8) + 9*Pkd2*k2*(r*(32*s - 15) + 32*s**2 - 38*s + 11)) - 2*k2**4*(Pk2*(992*r**2 + 2084*r*s - 1307*r + 1092*s**2 - 1301*s + 402) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(9009*d**2*k1*k2*k3**5) - 2*D1**3*Pkd3*ct**3*(D1*bd1*f*(f**2*k1**2*(726*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + 5*k1**4*(Pk2*(300*r**2 + 564*r*s - 686*r + 264*s**2 - 590*s + 306) + Pkd2*k2*(18*r*s + 143*r + 18*s**2 + 95*s - 103)) + 33*k1**2*k2**2*(Pk2*(418*r**2 + 908*r*s - 680*r + 490*s**2 - 722*s + 206) + 5*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) + 33*f*(Pk2*k2**6*(2 - 4*C)*(6*r**2 - 7*r*s - 5*r + 2*s - 2) + 2*k1**6*(Pk2*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(s - 10) + s**2 - 15*s + 10) + 10*r**2 + 3*r*s + 3*r - 7*s**2 + 20*s - 9) - 2*Pkd2*k2*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(s - 1)*(r + s - 1) - 7*r*s + 5*r - 7*s**2 + 11*s - 4)) - k1**4*k2**2*(Pk2*(4*C*(13*r**2 + 209*r*s - 35*r - 44*s**2 - 122*s + 46) + 218*K*r**2 + 386*K*r*s - 272*K*r + 168*K*s**2 - 140*K*s + 54*K + 30*b1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 544*r**2 - 1317*r*s + 934*r - 293*s**2 + 953*s - 486) + 2*Pkd2*k2*(K*(r*(58*s - 31) + 58*s**2 - 88*s + 31) + 3*b1*(8*s + 1)*(r + s - 1) + 6*r*(C*(6*s - 4) - 12*s + 7) + (3*s - 3)*(s*(20*C - 28) + 7))) + k1**2*k2**4*(Pk2*(4*C*(280*r*s - 107*r + 69*s**2 - 95*s + 86) - 604*K*r**2 - 1180*K*r*s + 938*K*r - 576*K*s**2 + 872*K*s - 334*K + b1*(54*r**2 + r*(66*s - 137) + 12*s**2 - 59*s + 65) + 230*r**2 - 215*r*s - 110*r - 23*s**2 - 21*s - 50) + 6*Pkd2*k2*(-2*C*(s - 1)*(2*r + 6*s + 1) - 16*K*r*s + 6*K*r - 16*K*s**2 + 20*K*s - 6*K + b1*(3*r*(4*s - 1) + 12*s**2 - 11*s + 1) + 6*r*s - 4*r + 10*s**2 - 9*s - 1))) + 33*k1**2*(25*Pk2*b1**2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 100*Pk2*b2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*b1*(-k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(-Pk2*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(66*r**2 + 216*r*s - 139*r + 150*s**2 - 167*s + 45) - 106*r**2 - 296*r*s + 194*r - 190*s**2 + 222*s - 60) + Pkd2*k2*(r*(K*(38*s - 13) - 40*s + 10) + s*(K*(38*s - 25) - 40*s + 30))) + k2**4*(-Pk2*(20*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) + K*(180*r**2 + 436*r*s - 251*r + 256*s**2 - 275*s + 45) + 3*r**2 + 250*r*s - 7*r - 33*s**2 - 73*s + 20) + Pkd2*k2*(r*(2*K*(13*s - 5) - 28*s + 7) + s*(2*K*(13*s - 8) - 28*s + 21)))) - 4*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2)) + k1**2*k2**2*(Pk2*(33*r**2 + r*(108*s - 61) + s*(75*s - 75)) + Pkd2*k2*(r*(13 - 19*s) - s*(19*s - 19))) + k2**4*(2*Pk2*(45*r**2 + r*(109*s - 58) + s*(64*s - 64)) + Pkd2*k2*(r*(10 - 13*s) - s*(13*s - 13)))))) + 825*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 33*b1**2*k1**2*(D1*fd*(k1**4*s*(4 - 4*K)*(2*Pk2 - Pkd2*k2)*(r + s) + 2*k1**2*k2**2*(Pk2*(-20*C*(r + s - 1)**2 - 33*K*r**2 - 108*K*r*s + 90*K*r - 75*K*s**2 + 90*K*s - 45*K + 15*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 53*r**2 + 148*r*s - 120*r + 95*s**2 - 120*s + 60) + Pkd2*k2*s*(3*f*(8*r + 8*s - 3) + (19*K - 20)*(r + s))) - k2**4*(Pk2*(40*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 180*K*r**2 + 436*K*r*s - 180*K*r + 256*K*s**2 - 180*K*s + 90*K + f*(54*r**2 + 66*r*s + 97*r + 12*s**2 + 127*s - 107) + 3*r**2 + 250*r*s + 200*r - 33*s**2 - 80*s - 100) + 2*Pkd2*k2*s*(3*f*(12*r + 12*s - 5) - (13*K - 14)*(r + s)))) + Dd*f*(k1**4*(2 - 2*K)*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 2*k1**2*k2**2*(Pk2*(-20*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 132*K*r**2 - 432*K*r*s + 307*K*r - 300*K*s**2 + 349*K*s - 135*K + 30*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 212*r**2 + 592*r*s - 427*r + 380*s**2 - 469*s + 180) + Pkd2*k2*(3*f*(16*r*s + r + 16*s**2 - 10*s - 1) + r*(76*K*s - 13*K - 80*s + 10) + s*(76*K*s - 31*K - 80*s + 40))) - k2**4*(Pk2*(40*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 720*K*r**2 + 1744*K*r*s - 952*K*r + 1024*K*s**2 - 1024*K*s + 270*K + 2*f*(54*r**2 + 66*r*s - 20*r + 12*s**2 + 34*s - 21) + 12*r**2 + 1000*r*s + 283*r - 132*s**2 - 405*s - 160) + 2*Pkd2*k2*(f*(9*r*(8*s - 1) + 72*s**2 - 48*s + 3) + r*(-52*K*s + 10*K + 56*s - 7) + s*(-52*K*s + 19*K + 56*s - 28))))) + b1*(D1*(f**2*fd*k1**2*(726*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + 5*k1**4*(6*Pk2*(150*r**2 + r*(282*s - 296) + 132*s**2 - 273*s + 139) + Pkd2*k2*(6*r*(9*s + 23) + 54*s**2 + 69*s - 92)) + 33*k1**2*k2**2*(2*Pk2*(627*r**2 + 1362*r*s - 963*r + 735*s**2 - 986*s + 388) + 5*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) + 33*f*(fd*(Pk2*k2**6*(2 - 4*C)*(2*r - 1)*(6*r - 7*s - 9) + 2*k1**6*(Pk2*(K*(r*(2*s - 13) + 2*s**2 - 15*s + 7) + 20*r**2 + r*(32*C*s + 6*s - 7) + (2*s - 1)*(16*C*s - 7*s + 2)) - 2*Pkd2*k2*(2*r + 2*s - 1)*(3*K*(s - 1) + s*(4*C - 7) + 3)) + k1**4*k2**2*(Pk2*(-4*C*(26*r**2 + r*(418*s - 69) - 88*s**2 - 279*s + 63) - 2*K*(218*r**2 + 386*r*s - 190*r + 168*s**2 - 110*s + 13) + 1088*r**2 + 2634*r*s - 1269*r + 586*s**2 - 1551*s + 365) - 4*Pkd2*k2*(K*(r*(58*s - 38) + 58*s**2 - 73*s + 22) + 3*r*(s*(12*C - 24) + 7) + 3*s**2*(20*C - 28) + 3*s*(17 - 2*C) - 12)) - k1**2*k2**4*(Pk2*(-4*C*(10*r*(56*s + 9) + 138*s**2 - 345*s - 50) + 4*K*(302*r**2 + 590*r*s - 323*r + 288*s**2 - 302*s + 79) - 460*r**2 + 430*r*s + 497*r + 46*s**2 - 483*s - 101) + 12*Pkd2*k2*(K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(2*C*r + 6*C*s + C - 3*r - 5*s)))) + 4*k1**2*(25*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(-k1**4*s*(2*Pk2 - Pkd2*k2)*(2*r + 2*s - 1) + k1**2*k2**2*(-Pk2*(33*r**2 + 108*r*s - 78*r + 75*s**2 - 92*s + 45) + Pkd2*k2*s*(19*r + 19*s - 6)) + k2**4*(-Pk2*(90*r**2 + 218*r*s - 135*r + 128*s**2 - 147*s + 45) + Pkd2*k2*s*(13*r + 13*s - 3))))) + 132*fd*k1**2*(25*Pk2*b2*k2**4*(r + s)**2 + g2*(-2*k1**4*s*(2*Pk2 - Pkd2*k2)*(r + s) + k1**2*k2**2*(-3*Pk2*(11*r**2 + 6*r*(6*s - 5) + 25*s**2 - 30*s + 15) + 19*Pkd2*k2*s*(r + s)) + k2**4*(-Pk2*(90*r**2 + 218*r*s - 90*r + 128*s**2 - 90*s + 45) + 13*Pkd2*k2*s*(r + s))))) + Dd*f*(f**2*k1**2*(726*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + 5*k1**4*(2*Pk2*(600*r**2 + 1128*r*s - 1231*r + 528*s**2 - 1114*s + 570) + Pkd2*k2*(72*r*s + 281*r + 72*s**2 + 164*s - 195)) + 66*k1**2*k2**2*(Pk2*(836*r**2 + r*(1816*s - 1303) + 980*s**2 - 1347*s + 491) + 5*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) + 33*f*(Pk2*k2**6*(4 - 8*C)*(2*r - 1)*(6*r - 7*s - 8) + 2*k1**6*(Pk2*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + K*(4*r*s - 33*r + 4*s**2 - 45*s + 27) + 40*r**2 + 12*r*s - 9*r - 28*s**2 + 43*s - 16) - 2*Pkd2*k2*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 3*K*(s - 1)*(4*r + 4*s - 3) - 28*r*s + 14*r - 28*s**2 + 33*s - 10)) + k1**4*k2**2*(Pk2*(-8*C*(26*r**2 + 11*r*(38*s - 5) - 88*s**2 - 307*s + 51) - 2*K*(436*r**2 + 772*r*s - 462*r + 336*s**2 - 250*s + 67) + 2176*r**2 + 5268*r*s - 3041*r + 1172*s**2 - 3601*s + 1145) + 2*Pkd2*k2*(-2*K*(r*(116*s - 69) + 116*s**2 - 161*s + 53) - 3*r*(8*C*(6*s - 1) - 96*s + 34) - 3*s**2*(80*C - 112) - 3*s*(92 - 28*C) + 63)) - k1**2*k2**4*(Pk2*(-4*C*(r*(1120*s + 23) + 276*s**2 - 659*s - 4) + 8*K*(302*r**2 + 590*r*s - 396*r + 288*s**2 - 369*s + 123) - 920*r**2 + 860*r*s + 977*r + 92*s**2 - 723*s - 191) + 6*Pkd2*k2*(2*C*(4*s - 1)*(2*r + 6*s + 1) + K*(64*r*s - 30*r + 64*s**2 - 76*s + 22) - 24*r*s + 4*r - 40*s**2 + 10*s + 1))) + 132*k1**2*(25*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(-k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(-Pk2*(132*r**2 + r*(432*s - 307) + 300*s**2 - 349*s + 135) + Pkd2*k2*(r*(76*s - 13) + s*(76*s - 31))) + k2**4*(-Pk2*(360*r**2 + r*(872*s - 476) + 512*s**2 - 512*s + 135) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))))))) - f*(D1*(10*f**2*fd*k1**4*(61*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + 2*k1**2*(Pk2*(455*r**2 - 379*r*s - 154*r - 834*s**2 + 955*s - 176) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) + f*(fd*(Pk2*k2**6*(132*C - 66)*(3*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(2*C*Pk2*(15*r*(27*s + 35) + 405*s**2 + 288*s - 361) + 3*Pk2*(-375*r**2 - 30*r*(34*s - 5) - 645*s**2 + 308*s + 74) + Pkd2*k2*(330*C - 330)*(s - 1)*(3*r + 3*s - 2)) + k1**4*k2**2*(Pk2*(36*C*(1357*r**2 + 2080*r*s - 1631*r + 1207*s**2 - 1036*s + 373) - 60552*r**2 - 108441*r*s + 78627*r - 56601*s**2 + 64146*s - 22525) + 10*Pkd2*k2*(2*C*(981*r*s - 591*r + 981*s**2 - 1311*s + 416) - 1476*r*s + 921*r - 1476*s**2 + 2004*s - 647)) + 3*k1**2*k2**4*(Pk2*(4*C*(9231*r**2 + 4*r*(4032*s - 2921) + 8349*s**2 - 10007*s + 3485) - 22389*r**2 - 39021*r*s + 27691*r - 19536*s**2 + 23138*s - 7949) + Pkd2*k2*(880*C - 440)*(2*s - 1)*(3*r + 3*s - 2))) + 132*k1**2*(5*Pk2*bd2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(r + s - 1) + gd2*(k1**4*(Pk2*(r*(s - 10) + s**2 - 15*s + 10) - 6*Pkd2*k2*(s - 1)*(r + s - 1)) - k1**2*k2**2*(Pk2*(109*r**2 + 193*r*s - 136*r + 84*s**2 - 70*s + 27) + Pkd2*k2*(58*r*s - 31*r + 58*s**2 - 88*s + 31)) - k2**4*(Pk2*(302*r**2 + 590*r*s - 469*r + 288*s**2 - 436*s + 167) + 6*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3))))) + 132*fd*k1**2*(5*Pk2*b2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + g2*(k1**4*(Pk2*(2*r*s - 13*r + 2*s**2 - 15*s + 7) - 6*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) - k1**2*k2**2*(Pk2*(218*r**2 + 386*r*s - 190*r + 168*s**2 - 110*s + 13) + 2*Pkd2*k2*(58*r*s - 38*r + 58*s**2 - 73*s + 22)) - 2*k2**4*(Pk2*(302*r**2 + 590*r*s - 323*r + 288*s**2 - 302*s + 79) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(10*f**2*k1**4*(61*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + 2*k1**2*(Pk2*(455*r**2 - 379*r*s - 154*r - 834*s**2 + 955*s - 176) + 7*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) + f*(Pk2*k2**6*(264*C - 132)*(2*r - 1)*(2*r + 2*s - 1) + 2*k1**6*(Pk2*(2*C*(540*r*s + 805*r + 540*s**2 + 549*s - 641) - 1500*r**2 - 4080*r*s + 515*r - 2580*s**2 + 1027*s + 532) + Pkd2*k2*(330*C - 330)*(s - 1)*(4*r + 4*s - 3)) + k1**4*k2**2*(Pk2*(4*C*(16284*r**2 + 24960*r*s - 20773*r + 14484*s**2 - 12359*s + 5380) - 80736*r**2 - 144588*r*s + 110381*r - 75468*s**2 + 87515*s - 34095) + 20*Pkd2*k2*(C*(1308*r*s - 761*r + 1308*s**2 - 1803*s + 586) - 984*r*s + 595*r - 984*s**2 + 1380*s - 458)) + 3*k1**2*k2**4*(Pk2*(4*C*(12308*r**2 + 21504*r*s - 16657*r + 11132*s**2 - 14053*s + 5381) - 29852*r**2 - 52028*r*s + 39452*r - 26048*s**2 + 32462*s - 12247) + Pkd2*k2*(220*C - 110)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 132*k1**2*(5*Pk2*b2*k2**2*(k1**2*(r + s + 1) + 3*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + g2*(k1**4*(Pk2*(4*r*s - 33*r + 4*s**2 - 45*s + 27) - 6*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) - k1**2*k2**2*(Pk2*(436*r**2 + 772*r*s - 462*r + 336*s**2 - 250*s + 67) + 2*Pkd2*k2*(116*r*s - 69*r + 116*s**2 - 161*s + 53)) - 2*k2**4*(2*Pk2*(302*r**2 + 590*r*s - 396*r + 288*s**2 - 369*s + 123) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(693*d**2*k1*k2*k3**5) - 10*D1**3*Pkd3*ct**2*f*k1**2*k2**2*st**6*(-4*Pk2 + Pkd2*k2)*(-468*C*D1*f*fd*r*s + 156*C*D1*f*fd*r - 468*C*D1*f*fd*s**2 + 468*C*D1*f*fd*s - 104*C*D1*f*fd - 624*C*Dd*f**2*r*s + 182*C*Dd*f**2*r - 624*C*Dd*f**2*s**2 + 624*C*Dd*f**2*s - 130*C*Dd*f**2 - 429*D1*bd1*f*(K - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 3416*D1*f**2*fd*r*s - 763*D1*f**2*fd*r + 3416*D1*f**2*fd*s**2 - 3416*D1*f**2*fd*s + 595*D1*f**2*fd + 468*D1*f*fd*r*s - 156*D1*f*fd*r + 468*D1*f*fd*s**2 - 468*D1*f*fd*s + 104*D1*f*fd + 3432*D1*f*gd2*r*s - 858*D1*f*gd2*r + 3432*D1*f*gd2*s**2 - 3432*D1*f*gd2*s + 858*D1*f*gd2 + 6864*D1*fd*g2*r*s - 3432*D1*fd*g2*r + 6864*D1*fd*g2*s**2 - 6864*D1*fd*g2*s + 1716*D1*fd*g2 + 3416*Dd*f**3*r*s - 763*Dd*f**3*r + 3416*Dd*f**3*s**2 - 3416*Dd*f**3*s + 595*Dd*f**3 + 624*Dd*f**2*r*s - 182*Dd*f**2*r + 624*Dd*f**2*s**2 - 624*Dd*f**2*s + 130*Dd*f**2 + 13728*Dd*f*g2*r*s - 5148*Dd*f*g2*r + 13728*Dd*f*g2*s**2 - 13728*Dd*f*g2*s + 3432*Dd*f*g2 - 858*b1*(K - 1)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))/(9009*d**2*k3**5) + D1**3*Pkd3*ct**2*st**4*(-132*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - b1*(132*D1*bd1*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*(-5*f**2*fd*(-11*Pk2*k2**2*(3*r - 1)*(5*r + 5*s - 3) + 72*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(4*r + 4*s - 3)) - 132*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(r*(8*s - 3) + 8*s**2 - 6*s + 1) + 2*gd2*(2*s - 1)*(r + s - 1)) - 528*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1)) - 2*Dd*f*(5*f**2*(-11*Pk2*k2**2*(2*r - 1)*(5*r + 5*s - 3) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(24*s - 7)*(4*r + 4*s - 3)) + 66*f*k1**2*(4*Pk2 - Pkd2*k2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1) + 132*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + f*(D1*bd1*(5*f**2*(-11*Pk2*k2**2*(r - 1)*(5*r + 5*s - 3) + 12*k1**2*(4*Pk2 - Pkd2*k2)*(6*s - 1)*(4*r + 4*s - 3)) + 264*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(2*r + 2*s - 1) + 264*g2*k1**2*(4*Pk2 - Pkd2*k2)*(r*(2*s - 1) + s*(2*s - 2))) + 4*f*(D1*fd*(30*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + k2**2*(Pk2*(-120*C*(3*s - 1)*(3*r + 3*s - 2) - 189*r**2 + 351*r*s + 42*r + 540*s**2 - 477*s + 67) + Pkd2*k2*(60*C - 30)*(3*s - 1)*(3*r + 3*s - 2))) + Dd*f*(15*k1**2*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + k2**2*(Pk2*(-60*C*(24*r*s - 7*r + 24*s**2 - 24*s + 5) - 252*r**2 + 468*r*s + 123*r + 720*s**2 - 604*s + 49) + Pkd2*k2*(30*C - 15)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))))))/(231*d**2*k3**3) + D1**3*Pkd3*ct**2*st**4*(D1*(5148*b1*fd*k1**2*k2**2*(-Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + 2*Pkd2*k2*s*(r + s))*(b1*(K - 1) - 2*g2) + f**3*(195*bd1*k2**2*(11*Pk2*k2**2*(r - 1)*(5*r + 5*s - 3) + 12*k1**2*(Pk2*(75*r**2 + 114*r*s - 113*r + 39*s**2 - 83*s + 36) + Pkd2*k2*(18*r*s - r + 18*s**2 - 16*s + 2))) + 30*fd*k1**4*(4*Pk2 - Pkd2*k2)*(6*r*(1270*s - 363) + 7620*s**2 - 7919*s + 1640) + 26*fd*k1**2*k2**2*(-Pk2*(7110*r**2 + 6*r*(3215*s - 1794) + 12180*s**2 - 14540*s + 4067) + 90*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 39*f**2*(fd*(k1**4*(48*C - 48)*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2) + 4*k1**2*k2**2*(45*Pk2*b1*(75*r**2 + 2*r*(57*s - 47) + 39*s**2 - 70*s + 31) - 2*Pk2*(C*(531*r**2 - 3*r*(123*s + 88) - 900*s**2 + 723*s - 71) - 981*r**2 + 3*r*(318 - 267*s) + 180*s**2 + 147*s - 189) + 30*Pkd2*k2*(3*r + 3*s - 2)*(-12*C*s + 4*C + 9*b1*s - 4*b1 + 9*s - 3)) + k2**4*(Pk2*(-8*C*(1053*r**2 + 6*r*(255*s - 224) + 675*s**2 - 960*s + 406) + 55*b1*(3*r - 1)*(5*r + 5*s - 3) + 4968*r**2 + 12*r*(573*s - 522) + 2700*s**2 - 4092*s + 1836) + Pkd2*k2*(120 - 240*C)*(3*s - 1)*(3*r + 3*s - 2))) - 132*k1**2*(bd1*(Pk2*k1**2*s*(4 - 4*K)*(r + s) + Pk2*k2**2*(2*K*(5*r**2 - 7*r*s - 6*r - 12*s**2 + 3*s + 1) - 25*r**2 - 24*r*s + 32*r + s**2 + 18*s - 7) + Pkd2*k1**2*k2*s*(K - 1)*(r + s) + Pkd2*k2**3*(K*(12*r*s - r + 12*s**2 - 8*s + 1) - 8*r*s + r - 8*s**2 + 6*s - 1)) - 2*gd2*(-4*Pk2*k1**2*s*(r + s) + 2*Pk2*k2**2*(5*r**2 - r*(7*s + 6) - 12*s**2 + 3*s + 1) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(12*s - 1) + 12*s**2 - 8*s + 1)))) + 5148*f*k1**2*(b1*(-bd1*k2**2*(K - 1)*(Pk2*(10*r**2 + r*(28*s - 17) + 18*s**2 - 21*s + 5) + Pkd2*k2*(-4*r*s + r + s*(3 - 4*s))) + fd*(Pk2*k1**2*(4*K - 4)*(r + s)*(2*s - 1) - Pk2*k2**2*(4*K*(5*r**2 - 7*r*s + 3*r - 12*s**2 + 10*s - 2) - 50*r**2 + r*(19 - 48*s) + 2*s**2 - 3*s + 1) - Pkd2*k1**2*k2*(K - 1)*(r + s)*(2*s - 1) + Pkd2*k2**3*(-2*K*(12*r*s - 5*r + 12*s**2 - 10*s + 2) + r*(16*s - 7) + 16*s**2 - 14*s + 3)) + 2*gd2*k2**2*(Pk2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 12*s + 5) + Pkd2*k2*s*(-2*r - 2*s + 1))) + 2*g2*(bd1*k2**2*(Pk2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))) + fd*(-4*Pk2*k1**2*(r + s)*(2*s - 1) + 4*Pk2*k2**2*(5*r**2 - 7*r*s + 3*r - 12*s**2 + 10*s - 2) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(12*r*s - 5*r + 12*s**2 - 10*s + 2))))) + 2*Dd*f*(-2574*b1*k1**2*k2**2*(Pk2*(20*r**2 + r*(56*s - 37) + 36*s**2 - 43*s + 15) + Pkd2*k2*(-8*r*s + r + s*(4 - 8*s)))*(b1*(K - 1) - 2*g2) + f**3*k1**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(6*r*(1270*s - 363) + 7620*s**2 - 7919*s + 1640) + 13*k2**2*(-Pk2*(7110*r**2 + 6*r*(3215*s - 1794) + 12180*s**2 - 14540*s + 4067) + 90*Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 39*f**2*(k1**4*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 2*k1**2*k2**2*(Pk2*(-4*C*(354*r**2 - 246*r*s - 248*r - 600*s**2 + 447*s - 8) + 15*b1*(300*r**2 + r*(456*s - 395) + 156*s**2 - 293*s + 129) + 2616*r**2 + 2136*r*s - 2902*r - 480*s**2 - 632*s + 718) + 15*Pkd2*k2*(b1*(r*(72*s - 25) + 72*s**2 - 76*s + 18) - (4*C - 3)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + k2**4*(Pk2*(-4*C*(1404*r**2 + 3*r*(680*s - 647) + 900*s**2 - 1375*s + 652) + 55*b1*(2*r - 1)*(5*r + 5*s - 3) + 3312*r**2 + 6*r*(764*s - 758) + 1800*s**2 - 2982*s + 1506) + Pkd2*k2*(30 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 2574*f*k1**2*(b1*(Pk2*k1**2*(4 - 4*K)*(r + s)*(4*s - 1) + Pk2*k2**2*(4*K*(10*r**2 - r*(14*s + 3) - 24*s**2 + 13*s - 1) - 100*r**2 + r*(83 - 96*s) + 4*s**2 + 33*s - 13) + Pkd2*k1**2*k2*(K - 1)*(r + s)*(4*s - 1) + Pkd2*k2**3*(6*K*(4*s - 1)*(2*r + 2*s - 1) + r*(9 - 32*s) - 32*s**2 + 26*s - 5)) + 2*g2*(4*Pk2*k1**2*(r + s)*(4*s - 1) + 4*Pk2*k2**2*(-10*r**2 + r*(14*s + 3) + 24*s**2 - 13*s + 1) - Pkd2*k1**2*k2*(r + s)*(4*s - 1) - 6*Pkd2*k2**3*(4*s - 1)*(2*r + 2*s - 1)))))/(9009*d**2*k3**5) + D1**3*Pkd3*ct**2*st**2*(2*D1*bd1*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(r*(7*s - 3) + s*(7*s - 5)) + k2**2*(Pk2*(-12*r**2 + r*(C*(24 - 96*s) + 36*s - 2) + 3*s*(-24*C*(s - 1) + 12*s - 13)) + Pkd2*k2*(12*C - 6)*(r*(4*s - 1) + s*(3*s - 3)))) + k2**2*(-2*Pk2 + Pkd2*k2)*(6*b2 - 12*g2)*(r*(2*s - 1) + s*(2*s - 2))) + b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(60*s - 33) + 26*s - 26) - 3*k2**2*(8*K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(14*r - 3) + 8*Pk2*r))*(r + s - 1) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(r*(40*s - 19) + 40*s**2 - 52*s + 15) + 2*r*(52*s - 22) + 104*s**2 - 142*s + 38) - 6*k2**2*(-2*K*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + Pk2*(4*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + f*(14*r**2 + r*(14*s - 19) - 3*s + 5) + 16*r**2 + 16*r*s - 18*r - 4*s + 4)))) + b1*(D1*bd1*f*(k1**2*(4*Pk2 - Pkd2*k2)*(3*f*(4*r*(5*s - 2) + 20*s**2 - 21*s + 4) + 4*r*(13*s - 3) + 52*s**2 - 58*s + 6) - 3*k2**2*(-4*K*Pkd2*k2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pk2*(8*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + f*(14*r**2 + 7*r*(2*s - 3) - 3*s + 7) + 16*r**2 + 16*r*(s - 1) - 4*s + 4))) + 2*D1*(f*(2*fd*k1**2*(4*Pk2 - Pkd2*k2)*(7*s - 4)*(r + s - 1) + fd*k2**2*(Pk2*(-24*C*(2*s - 1)*(4*r + 3*s - 4) - 24*r**2 + 72*r*s - 17*r + 72*s**2 - 125*s + 41) + Pkd2*k2*(12*C - 6)*(2*s - 1)*(4*r + 3*s - 4)) + k2**2*(-2*Pk2 + Pkd2*k2)*(6*bd2 - 12*gd2)*(2*s - 1)*(r + s - 1)) + 12*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(k1**2*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + k2**2*(Pk2*(-24*C*(16*r*s - 6*r + 12*s**2 - 19*s + 5) - 48*r**2 + 144*r*s - 9*r + 144*s**2 - 214*s + 43) + Pkd2*k2*(12*C - 6)*(2*r*(8*s - 3) + 12*s**2 - 19*s + 5))) + k2**2*(-2*Pk2 + Pkd2*k2)*(6*b2 - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))/(21*d**2*k2**2*k3) + D1**3*Pkd3*ct**2*(-2*D1*bd1*f*(f*(2*k1**2*(Pk2*r*(5*s - 11) + Pk2*s*(5*s - 6) - 6*Pkd2*k2*(r + s)*(s - 1)) + k2**2*(Pk2*(r**2*(28*C - 40) + r*(-238*C*s - 36*C + 93*s + 32) - s*(2*C - 1)*(31*s - 75)) + Pkd2*k2*(24*C - 12)*(r*(2*s - 1) + s*(2*s - 2)))) + k2**2*(7*b2 - 14*g2)*(-7*Pk2*s*(r + s - 1) + 2*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + b1**3*(D1*fd*(r + s - 1)*(12*Pk2*k1**2*s + 7*Pk2*k2**2*(r - 1) - 6*Pkd2*k1**2*k2*s) + 2*Dd*f*(7*Pk2*k2**2*(2*r**2 + r*(2*s - 5) - 5*s + 3) + k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(6*s + 1) + 12*s**2 - 5*s - 2))) + b1**2*(D1*bd1*f*(7*Pk2*k2**2*(3*r**2 + r*(3*s - 8) - 9*s + 5) + 2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(9*s + 2) + 9*s**2 - 2*s - 2)) + D1*fd*(-2*k1**2*(Pk2*(f*(54*s - 39) + 46*s - 38) + 2*Pkd2*k2*(-6*f*(3*s - 2) - 9*s + 7))*(r + s - 1) + k2**2*(Pk2*(r + s - 1)*(98*K*(s - 1) + 39*f*(2*r - 1) + 76*r - 20) + 8*Pkd2*k2*(-7*K*(s - 1)*(r + s - 1) + s*(2*C - 1)*(6*r - s - 6)))) - 2*Dd*f*(k1**2*(Pk2*(3*f*(36*r*s - 29*r + 36*s**2 - 53*s + 21) + 184*r*s - 120*r + 184*s**2 - 274*s + 94) - 2*Pkd2*k2*(3*f*(3*s - 2)*(4*r + 4*s - 3) + 36*r*s - 29*r + 36*s**2 - 57*s + 22)) + k2**2*(-Pk2*(49*K*(4*s - 1)*(r + s - 1) + 39*f*(2*r - 1)*(r + s - 1) + 152*r**2 + 152*r*s - 212*r - 100*s + 74) - 2*Pkd2*k2*(4*C*(3*r*(8*s - 1) - 4*s**2 - 17*s + 3) - 7*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 48*r*s + 6*r + 8*s**2 + 34*s - 6)))) + b1*(D1*bd1*f*(-4*k1**2*(Pk2*(3*f*(r*(9*s - 8) + 9*s**2 - 11*s + 4) + r*(46*s - 28) + 46*s**2 - 59*s + 15) - Pkd2*k2*(3*f*(3*s - 2)*(2*r + 2*s - 1) + 3*r*(6*s - 5) + 18*s**2 - 25*s + 8)) + k2**2*(Pk2*(196*K*s**2 - 196*K*s + 39*f*(2*r - 1)*(r + s - 1) + 152*r**2 + 4*r*(49*K*s + 38*s - 51) - 132*s + 80) + 4*Pkd2*k2*(4*C*(3*r*(4*s - 1) - 2*s**2 - 5*s + 3) - 7*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 24*r*s + 6*r + 4*s**2 + 10*s - 6))) - 2*D1*(f*fd*(2*k1**2*(Pk2*(10*s - 17) - 12*Pkd2*k2*(s - 1))*(r + s - 1) + k2**2*(Pk2*(2*C*(28*r**2 - 238*r*s + 29*r - 62*s**2 + 221*s - 57) - 80*r**2 + 186*r*s + 37*r + 62*s**2 - 207*s + 43) + Pkd2*k2*(24*C - 12)*(4*s - 3)*(r + s - 1))) + 7*f*k2**2*(bd2 - 2*gd2)*(-7*Pk2*s + 2*Pkd2*k2*(2*s - 1))*(r + s - 1) + 7*fd*k2**2*(-7*Pk2 + 4*Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) - 2*Dd*f*(f*(k1**2*(Pk2*(40*r*s - 78*r + 40*s**2 - 98*s + 56) - 12*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k2**2*(Pk2*(2*C*(56*r**2 - 7*r*(68*s + 3) - 124*s**2 + 411*s - 39) - 160*r**2 + 372*r*s + 141*r + 124*s**2 - 383*s + 11) + Pkd2*k2*(24*C - 12)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + k2**2*(7*b2 - 14*g2)*(-7*Pk2*(4*s - 1)*(r + s - 1) + 2*Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))))/(21*d**2*k2**2*k3) + D1**3*Pkd3*ct**2*st**2*(D1*bd1*f*(f**2*(66*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(8*r*(51*s - 25) + 408*s**2 - 439*s + 100) + 33*k1**2*k2**2*(-Pk2*(18*r**2 + r*(286*s - 67) + 268*s**2 - 247*s + 41) + 2*Pkd2*k2*(r*(29*s - 8) + 29*s**2 - 31*s + 6))) + 11*f*(2*k1**4*(4*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) + k1**2*k2**2*(2*Pk2*(-36*C*r**2 + 32*C*r*s + 16*C*r + 12*C*s**2 - 28*C*s - 12*K*(8*r*s - 3*r + 8*s**2 - 10*s + 3) + 3*b1*(10*r**2 + 4*r*(17*s - 5) + 58*s**2 - 59*s + 10) - 37*r**2 - 216*r*s + 92*r - 151*s**2 + 146*s - 55) + Pkd2*k2*(-48*C*s**2 + 68*C*s + 12*K*(r*(8*s - 3) + 8*s**2 - 10*s + 3) - 3*b1*(r*(48*s - 5) + 48*s**2 - 44*s + 5) + 2*r*(-52*C*s + 10*C + 30*s - 5) + 32*s**2 - 42*s + 10)) - 2*k2**4*(-Pk2*(-66*C*r**2 - 120*C*r*s + 58*C*r - 18*C*s**2 + 48*C*s + K*(21*r**2 + 111*r*s - 43*r + 90*s**2 - 78*s + 22) + b1*(17 - 28*r) + 57*r**2 + 84*r*s - 64*r + 9*s**2 - 36*s + 9) + 6*Pkd2*k2*(2*C*(r + s - 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - r - s + 1))) + 22*k2**2*(b1*(k1**2*(Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 2*K*(26*r**2 - 3*r*(14*s + 9) - 68*s**2 + 61*s + 7) + 78*r**2 + 160*r*s - 147*r + 82*s**2 - 69*s + 29) + Pkd2*k2*(C*r*(2 - 8*s) - 2*C*(1 - 2*s)**2 + K*(r*(26 - 80*s) - 80*s**2 + 93*s - 13) - 16*r*s + r - 16*s**2 - 17*s + 12)) + 6*k2**2*(K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1))) + 6*b2*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 2*g2*(6*Pk2*k2**2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + k1**2*(2*Pk2*(13*r**2 - 7*r*(3*s + 1) - s*(34*s - 34)) + Pkd2*k2*(r*(40*s - 13) + s*(40*s - 40)))))) - 11*b1**2*k2**2*(D1*fd*(k1**2*(-2*Pk2*(8*C*r*s + 8*C*s**2 - 8*C*s + K*(-26*r**2 + 42*r*(s - 1) + 68*(s - 1)**2) + 3*f*(10*r**2 + r*(68*s + 5) + 58*s**2 - 8*s - 15) + 39*r**2 + 80*r*s - 10*r + 41*s**2 + 66*s - 29) + Pkd2*k2*(8*C*s**2 - 8*C*s + 80*K*(s - 1)*(r + s - 1) + 3*f*(r*(48*s + 25) + 48*s**2 + 12*s - 25) + 2*r*(s*(4*C + 8) + 27) + 16*s**2 + 116*s - 54)) + 2*k2**2*(6*K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 12*K*Pkd2*k2*(r + 2*s - 1) + Pk2*f*(16*r - 5) + 12*Pk2*r)) - 2*Dd*f*(k1**2*(Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 104*K*r**2 + 168*K*r*s + 52*K*r + 272*K*s**2 - 312*K*s + 40*K + 3*f*(20*r**2 + 136*r*s - 15*r + 116*s**2 - 67*s - 5) + 156*r**2 + 320*r*s - 229*r + 164*s**2 - 31*s + 33) - Pkd2*k2*(2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 160*K*r*s - 79*K*r + 160*K*s**2 - 226*K*s + 66*K + 6*f*(24*r*s + 5*r + 24*s**2 - 8*s - 5) + 32*r*s + 36*r + 32*s**2 + 100*s - 49)) + 2*k2**2*(12*K*Pkd2*k2*(r + 2*s - 1) - Pk2*(3*K*(20*r**2 + r*(24*s - 25) + 4*s**2 - 11*s + 7) + 11*f*(2*r - 1) + 12*r - 6)))) + b1*(D1*(f**2*fd*(66*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(6*r*(204*s - 101) + 1224*s**2 - 1725*s + 538) + 33*k1**2*k2**2*(-Pk2*(54*r**2 + r*(858*s - 353) + 804*s**2 - 921*s + 233) + 2*Pkd2*k2*(r*(87*s - 36) + 87*s**2 - 104*s + 28))) + 22*f*(6*bd2*k2**4*(-Pk2*(r + s - 1)**2 + Pkd2*k2*s*(2*r + 2*s - 1)) + fd*(k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + k1**2*k2**2*(Pk2*(C*(-72*r**2 + 64*r*s + 60*r + 24*s**2 - 92*s + 12) - 12*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) - 74*r**2 - 432*r*s + 187*r - 302*s**2 + 348*s - 68) + Pkd2*k2*(-4*C*(r*(26*s - 11) + 12*s**2 - 30*s + 11) + 6*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) + 60*r*s - 54*r + 32*s**2 - 107*s + 42)) + k2**4*(Pk2*(-2*C*(66*r**2 + r*(120*s - 119) + 18*s**2 - 89*s + 53) + K*(42*r**2 + 2*r*(111*s - 61) + 45*(1 - 2*s)**2) + 114*r**2 + 168*r*s - 150*r + 18*s**2 - 89*s + 54) + 6*Pkd2*k2*(2*C*(4*r + 7*s - 4) - 2*K*(2*s - 1)*(2*r + 2*s - 1) - 4*r - 7*s + 4))) + 2*gd2*k2**2*(k1**2*(2*Pk2*(13*r - 34*s - 7) + Pkd2*k2*(40*s - 13))*(r + s - 1) - 6*k2**2*(-Pk2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) + Pkd2*k2*(r + 2*s - 1)))) + 44*fd*k2**2*(-3*Pk2*b2*k2**2*(r + s - 1)**2 + 6*Pkd2*b2*k2**3*s*(r + s) + 2*g2*k1**2*(Pk2*(13*r - 34*s + 34) + 20*Pkd2*k2*(s - 1))*(r + s - 1) + 6*g2*k2**2*(Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 2*Pkd2*k2*(r + 2*s - 1)))) + 2*Dd*f*(f**2*(66*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + k1**4*(4*Pk2 - Pkd2*k2)*(r*(816*s - 403) + 816*s**2 - 1082*s + 319) + 33*k1**2*k2**2*(-Pk2*(36*r**2 + r*(572*s - 210) + 536*s**2 - 584*s + 137) + Pkd2*k2*(4*r*(29*s - 11) + 116*s**2 - 135*s + 34))) + 11*f*(k1**4*(4*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) - k1**2*k2**2*(Pk2*(4*C*(36*r**2 - 32*r*(s + 1) - 12*s**2 + 43*s + 1) + 12*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) + 148*r**2 + 864*r*s - 350*r + 604*s**2 - 659*s + 157) + Pkd2*k2*(C*(208*r*s - 64*r + 96*s**2 - 216*s + 54) - 6*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 120*r*s + 75*r - 64*s**2 + 178*s - 63)) + k2**4*(Pk2*(-2*C*(132*r**2 + 30*r*(8*s - 7) + 36*s**2 - 169*s + 82) + K*(84*r**2 + 444*r*s - 208*r + 360*s**2 - 336*s + 89) + 228*r**2 + 336*r*s - 310*r + 36*s**2 - 193*s + 102) + 12*Pkd2*k2*(4*C*(r + 2*s - 1) + K*(-8*r*s + 3*r - 8*s**2 + 8*s - 2) - 2*r - 4*s + 2))) - 22*k2**2*(3*Pk2*b2*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 3*Pkd2*b2*k2**3*(r*(8*s - 1) + 4*s*(2*s - 1)) + g2*k1**2*(-4*Pk2*(26*r**2 - r*(42*s + 13) - 68*s**2 + 78*s - 10) + Pkd2*k2*(r*(79 - 160*s) - 160*s**2 + 226*s - 66)) + 6*g2*k2**2*(-Pk2*(20*r**2 + r*(24*s - 25) + 4*s**2 - 11*s + 7) + 4*Pkd2*k2*(r + 2*s - 1))))) + 2*f*(D1*(f*(fd*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(153*s - 73) + 153*s**2 - 197*s + 56) + k1**2*k2**2*(-Pk2*(12*C*(372*r*s - 179*r + 372*s**2 - 438*s + 123) + 858*r**2 + 2910*r*s - 1421*r + 2052*s**2 - 2019*s + 500) + 3*Pkd2*k2*(C*(744*r*s - 358*r + 744*s**2 - 876*s + 246) - 108*r*s + 47*r - 108*s**2 + 130*s - 35)) - 3*k2**4*(Pk2*(2*C*(183*r**2 - 1203*r*s + 59*r - 726*s**2 + 940*s - 139) - 447*r**2 + 939*r*s + 139*r + 726*s**2 - 896*s + 117) + Pkd2*k2*(44*C - 22)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) + k2**2*(-11*bd2 + 22*gd2)*(6*k1**2*(2*Pk2 - Pkd2*k2)*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + k2**2*(-Pk2*(21*r**2 + r*(111*s - 43) + 90*s**2 - 78*s + 22) + 6*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) - 11*fd*k2**2*(b2 - 2*g2)*(6*k1**2*(2*Pk2 - Pkd2*k2)*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + k2**2*(-Pk2*(42*r**2 + 2*r*(111*s - 61) + 45*(1 - 2*s)**2) + 12*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1)))) + Dd*f*(f*(k1**4*(4*Pk2 - Pkd2*k2)*(r*(204*s - 98) + 204*s**2 - 281*s + 81) + k1**2*k2**2*(-Pk2*(12*C*(496*r*s - 229*r + 496*s**2 - 606*s + 173) + 1144*r**2 + 3880*r*s - 1810*r + 2736*s**2 - 2560*s + 603) + 6*Pkd2*k2*(C*(496*r*s - 229*r + 496*s**2 - 606*s + 173) - 72*r*s + 32*r - 72*s**2 + 94*s - 26)) - 3*k2**4*(Pk2*(2*C*(244*r**2 - 4*r*(401*s + 4) - 968*s**2 + 1332*s - 125) - 596*r**2 + 4*r*(313*s + 81) + 968*s**2 - 1244*s + 81) + Pkd2*k2*(88*C - 44)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + k2**2*(-11*b2 + 22*g2)*(6*k1**2*(2*Pk2 - Pkd2*k2)*(r*(32*s - 15) + 32*s**2 - 38*s + 11) + k2**2*(-Pk2*(84*r**2 + 444*r*s - 208*r + 360*s**2 - 336*s + 89) + 12*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(231*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**2*(-33*D1*bd1*f*(b1**2*k2**2*(7*Pk2*k2**2*(3*r**2 + r*(3*s - 8) - 9*s + 5) - 2*k1**2*(3*Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + Pkd2*k2*(-3*r*s + 4*r - 3*s**2 + 10*s - 4))) - 4*b1*(-k1**4*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + s*(4*s - 3)) + k1**2*k2**2*(Pk2*(4*C*(7*r**2 + r*(11*s - 15) + 4*s**2 - 18*s + 8) + K*(30*r**2 + 47*r*s - 21*r + 17*s**2 - 20*s + 3) - 48*r**2 - 165*r*s + 98*r - 117*s**2 + 162*s - 42) + Pkd2*k2*(2*C*(r*(19 - 76*s) + 8*s**2 + 34*s - 19) + K*(5*r*(6*s - 5) + 30*s**2 - 47*s + 14) + 100*r*s - 11*r + 16*s**2 - 44*s + 11)) + k2**4*(Pk2*(2*C*(22*r**2 - 4*r*(34*s - 3) + 10*s**2 + 63*s - 34) + 7*K*(9*r**2 + 11*r*s - 14*r + 2*s**2 - 7*s + 5) - 32*r**2 + 126*r*s + 18*r - 10*s**2 - 37*s + 14) + Pkd2*k2*(4*C*(r*(3 - 12*s) + 2*s**2 + 5*s - 3) - 7*K*(r + 2*s - 1) + 24*r*s - 6*r - 4*s**2 - 10*s + 6))) + f**2*(-33*Pk2*k1**2*k2**2*(6*r**2 + 9*r*(2*s - 1) + 12*s**2 - 13*s + 3) + k1**4*(Pk2*(60*r*s - 80*r + 60*s**2 - 92*s + 40) - 10*Pkd2*k2*(3*s - 2)*(2*r + 2*s - 1))) + f*(2*Pk2*k2**4*(-42*C*r**2 - 66*C*r*s + 46*C*r - 24*C*s**2 - 64*C*s + 13*K*(3*r**2 + 9*r*s - 5*r + 6*s**2 - 6*s + 2) + b1*(13 - 26*r) + 21*r**2 + 33*r*s - 25*r + 12*s**2 + 32*s) + 4*k1**4*(Pk2*(2*b1*(s - 1)*(4*r + 4*s - 3) + 13*r*s - 15*r + 13*s**2 - 29*s + 13) - Pkd2*k2*(b1*(s - 1)*(4*r + 4*s - 3) + 10*r*s - 8*r + 10*s**2 - 17*s + 7)) - k1**2*k2**2*(Pk2*(-2*K*(30*r**2 + 17*r*(s - 2) - 13*s**2 + 21*s + 4) + b1*(372*r**2 + r*(52*s - 335) - 320*s**2 + 137*s + 37) + 4*r**2*(28*C + 68) - 4*r*(C*(229*s + 8) - 222*s + 130) + 4*s**2*(69*C - 9) + 4*s*(115*C - 124) + 236) + 12*Pkd2*k2*(2*C*(s - 1)*(2*r + 2*s + 1) - 2*K*(5*s - 3)*(r + s - 1) + 16*b1*r*s + 2*b1*r + 16*b1*s**2 - 13*b1*s + 2*r*s + 2*r + 2*s**2 - 3*s + 1))) - 2*k2**2*(b2*(2*k1**2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(s + 3) + s*(s - 1))) - 7*k2**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + 2*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) - 2*g2*(7*Pk2*k2**2*(9*r**2 + r*(11*s - 9) + s*(2*s - 2)) + k1**2*(Pk2*(30*r**2 + r*(47*s - 6) + s*(17*s - 17)) + 2*Pkd2*k2*(r*(15*s - 11) + s*(15*s - 15)))))) - 33*b1**3*k2**2*(-D1*fd*(-7*Pk2*k2**2*(r - 1) + k1**2*(6*Pk2*(r + s - 1) - 2*Pkd2*k2*s))*(r + s - 1) + 2*Dd*f*(7*Pk2*k2**2*(2*r**2 + r*(2*s - 5) - 5*s + 3) + k1**2*(-3*Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(4*r*(s - 1) + 4*s**2 - 11*s + 4)))) - 33*b1**2*(-D1*fd*(-4*k1**4*s*(2*Pk2 - Pkd2*k2)*(f*(4*r + 4*s - 3) + 2*r + 2*s) + k1**2*k2**2*(Pk2*(8*C*(7*r**2 + r*(11*s - 14) + 4*s**2 - 11*s + 7) + 60*K*r**2 + 94*K*r*s - 94*K*r + 34*K*s**2 - 68*K*s + 34*K + f*(372*r**2 + 52*r*s - 397*r - 320*s**2 - 21*s + 141) - 96*r**2 - 330*r*s + 290*r - 234*s**2 + 260*s - 142) + 4*Pkd2*k2*(-76*C*r*s + 8*C*s**2 + 76*C*s + K*(15*r*s - 14*r + 15*s**2 - 28*s + 14) + 3*f*(2*r*(8*s + 5) + 16*s**2 + 5*s - 10) + 50*r*s + 7*r + 8*s**2 - 22*s - 7)) + 2*k2**4*(Pk2*(4*C*(11*r**2 - 68*r*s - 22*r + 5*s**2 + 68*s + 11) + 63*K*r**2 + 77*K*r*s - 91*K*r + 14*K*s**2 - 42*K*s + 21*K + 26*f*r - 13*f - 32*r**2 + 126*r*s + 92*r - 10*s**2 - 126*s - 32) - 4*Pkd2*k2*(7*K*(r + 2*s - 1) + s*(2*C - 1)*(6*r - s - 6)))) + 2*Dd*f*(f*(26*Pk2*k2**4*(1 - 2*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1)*(4*r + 4*s - 3) - k1**2*k2**2*(Pk2*(372*r**2 + r*(52*s - 366) - 320*s**2 + 58*s + 89) + 12*Pkd2*k2*(2*r*(8*s + 3) + 16*s**2 - 4*s - 5))) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + k1**2*k2**2*(-Pk2*(8*C*(14*r**2 + r*(22*s - 29) + 8*s**2 - 29*s + 15) + K*(120*r**2 + 188*r*s - 125*r + 68*s**2 - 97*s + 29) - 192*r**2 - 660*r*s + 437*r - 468*s**2 + 577*s - 203) + 2*Pkd2*k2*(C*(38*r*(8*s - 1) - 32*s**2 - 220*s + 38) + K*(-60*r*s + 53*r - 60*s**2 + 107*s - 42) - 200*r*s - 3*r - 32*s**2 + 102*s + 3)) + k2**4*(Pk2*(-4*C*(44*r**2 - 16*r*(17*s + 2) + 20*s**2 + 199*s - 12) - 7*K*(36*r**2 + 44*r*s - 60*r + 8*s**2 - 32*s + 23) + 128*r**2 - 504*r*s - 206*r + 40*s**2 + 326*s + 50) + 4*Pkd2*k2*(C*(6*r*(8*s - 1) - 8*s**2 - 34*s + 6) + 14*K*(r + 2*s - 1) - 24*r*s + 3*r + 4*s**2 + 17*s - 3)))) - 33*b1*(D1*(f**2*fd*k1**2*(-33*Pk2*k2**2*(18*r**2 + r*(54*s - 39) + 36*s**2 - 51*s + 19) + 2*k1**2*(2*Pk2*(45*r*(s - 1) + 45*s**2 - 84*s + 38) - 5*Pkd2*k2*(3*s - 2)*(6*r + 6*s - 5))) + 2*f*(fd*(2*k1**4*(Pk2*(r*(26*s - 17) + 26*s**2 - 31*s + 9) - 2*Pkd2*k2*(5*s - 3)*(2*r + 2*s - 1)) - k1**2*k2**2*(Pk2*(2*C*(56*r**2 + r*(51 - 458*s) + 138*s**2 + 295*s - 107) + K*(-60*r**2 - 34*r*s + 19*r + 26*s**2 - 67*s + 27) + 272*r**2 + 888*r*s - 404*r - 36*s**2 - 550*s + 182) + 12*Pkd2*k2*(2*C*(2*r*(s - 2) + 2*s**2 - 7*s + 4) + K*(-10*r*s + 7*r - 10*s**2 + 13*s - 4) + 2*r*s + 6*r + 2*s**2 + 9*s - 6)) + k2**4*(Pk2*(-2*C*(42*r**2 + r*(66*s - 50) + 24*s**2 - 52*s + 9) + 13*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 42*r**2 + 66*r*s - 90*r + 24*s**2 - 52*s + 23) + Pkd2*k2*(72*C - 36)*(r + 2*s - 1))) + k2**2*(-2*bd2*k1**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(r + s - 4)) + 7*bd2*k2**2*(-Pk2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2) + 2*Pkd2*k2*s*(2*r + 2*s - 1)) + 2*gd2*(k1**2*(Pk2*(30*r**2 + 47*r*s - 36*r + 17*s**2 - 23*s + 6) + 2*Pkd2*k2*(15*r*s - 14*r + 15*s**2 - 32*s + 14)) - 7*k2**2*(-Pk2*(9*r**2 + r*(11*s - 19) + 2*s**2 - 12*s + 10) + 2*Pkd2*k2*(r + 2*s - 1))))) + 2*fd*k2**2*(-2*b2*k1**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(r + s)) + 7*b2*k2**2*(-Pk2*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) + 4*Pkd2*k2*s*(r + s)) + 2*g2*(k1**2*(Pk2*(30*r**2 + 47*r*(s - 1) + 17*(s - 1)**2) + 2*Pkd2*k2*(r*(15*s - 14) + 15*s**2 - 28*s + 14)) - 7*k2**2*(-Pk2*(9*r**2 + 11*r*s - 13*r + 2*s**2 - 6*s + 3) + 4*Pkd2*k2*(r + 2*s - 1))))) + 2*Dd*f*(f**2*k1**2*(-33*Pk2*k2**2*(12*r**2 + 12*r*(3*s - 2) + 24*s**2 - 32*s + 11) + 2*k1**2*(Pk2*(60*r*s - 65*r + 60*s**2 - 107*s + 48) - 5*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*(2*k1**4*(Pk2*(r*(52*s - 43) + 52*s**2 - 85*s + 33) + Pkd2*k2*(r*(26 - 40*s) - 40*s**2 + 54*s - 19)) - k1**2*k2**2*(Pk2*(2*C*(112*r**2 + r*(7 - 916*s) + 276*s**2 + 659*s - 99) + K*(-120*r**2 - 68*r*s + 87*r + 52*s**2 - 109*s + 19) + 544*r**2 + 1776*r*s - 890*r - 72*s**2 - 1194*s + 390) + 6*Pkd2*k2*(2*C*(2*r*(4*s - 7) + 8*s**2 - 22*s + 11) + K*(-40*r*s + 26*r - 40*s**2 + 58*s - 20) + 8*r*s + 20*r + 8*s**2 + 22*s - 17)) + k2**4*(Pk2*(-2*C*(84*r**2 + 2*r*(66*s - 59) + 48*s**2 - 58*s + 33) + 13*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + 84*r**2 + 132*r*s - 174*r + 48*s**2 - 58*s + 61) + Pkd2*k2*(96*C - 48)*(r + 2*s - 1))) + k2**2*(-2*b2*k1**2*(Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(r*(4*s + 3) + s*(4*s - 9))) + 7*b2*k2**2*(-Pk2*(4*r**2 + 8*r*s - 11*r + 4*s**2 - 11*s + 6) + 2*Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + 2*g2*(k1**2*(Pk2*(120*r**2 + 188*r*s - 125*r + 68*s**2 - 97*s + 29) + 2*Pkd2*k2*(60*r*s - 53*r + 60*s**2 - 107*s + 42)) - 7*k2**2*(-Pk2*(36*r**2 + 44*r*s - 60*r + 8*s**2 - 32*s + 23) + 8*Pkd2*k2*(r + 2*s - 1)))))) - 2*f*(D1*(f*(fd*(Pk2*k2**4*(66*C - 33)*(117*r**2 + 3*r*(105*s - 61) + 198*s**2 - 204*s + 59) + 2*k1**4*(Pk2*(45*r*(s - 15) + 45*s**2 - 738*s + 461) - 165*Pkd2*k2*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(2*C*(4140*r**2 + 5031*r*s - 5163*r + 891*s**2 - 1842*s + 1217) - 11466*r**2 - 21861*r*s + 15459*r - 10395*s**2 + 12468*s - 4451) + Pkd2*k2*(660*C - 330)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + k2**2*(33*bd2 - 66*gd2)*(13*Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(Pk2*(30*r**2 + 17*r*(s - 2) - 13*s**2 + 21*s + 4) + 12*Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 33*fd*k2**2*(b2 - 2*g2)*(13*Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*(Pk2*(60*r**2 + 34*r*s - 19*r - 26*s**2 + 67*s - 27) + 12*Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4)))) + Dd*f*(f*(Pk2*k2**4*(66*C - 33)*(156*r**2 + 4*r*(105*s - 62) + 264*s**2 - 276*s + 85) + 2*k1**4*(Pk2*(20*r*(3*s - 49) + 60*s**2 - 1149*s + 766) - 165*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(2*C*(5520*r**2 + 6708*r*s - 7365*r + 1188*s**2 - 2597*s + 2039) - 15288*r**2 - 29148*r*s + 21225*r - 13860*s**2 + 16457*s - 6395) + Pkd2*k2*(660*C - 330)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + k2**2*(33*b2 - 66*g2)*(13*Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(Pk2*(120*r**2 + 68*r*s - 87*r - 52*s**2 + 109*s - 19) + 12*Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10))))))/(693*d**2*k2**2*k3**3) + D1**3*Pkd3*ct**2*st**2*(D1*(858*b1*fd*k2**2*(-30*Pk2*b2*k2**4*(r + s)**2 + b1*k1**4*(K - 1)*(Pk2*(5*r**2 + 2*r*(18*s - 5) + 31*s**2 - 10*s + 5) - 13*Pkd2*k2*s*(r + s)) + b1*k1**2*k2**2*(Pk2*(10*C*(r + s - 1)**2 + K*(73*r**2 + 226*r*s - 330*r + 153*s**2 - 330*s + 165) + 112*r**2 + 144*r*s + 220*r + 32*s**2 + 220*s - 110) - Pkd2*k2*s*(92*K - 53)*(r + s)) - 6*b1*k2**4*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s)) - 2*g2*(k1**4*(Pk2*(5*r**2 + 36*r*s - 10*r + 31*s**2 - 10*s + 5) - 13*Pkd2*k2*s*(r + s)) + k1**2*k2**2*(Pk2*(73*r**2 + 226*r*s - 330*r + 153*s**2 - 330*s + 165) - 92*Pkd2*k2*s*(r + s)) - 6*k2**4*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + 3*f**3*(-13*bd1*k2**2*(66*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) - k1**4*(2*Pk2*(1290*r**2 + 3252*r*s - 2083*r + 1962*s**2 - 2555*s + 589) + Pkd2*k2*(-672*r*s + 113*r - 672*s**2 + 585*s + 91)) + 33*k1**2*k2**2*(Pk2*(170*r**2 + 232*r*s - 215*r + 62*s**2 - 143*s + 55) + 2*Pkd2*k2*(21*r*s - 4*r + 21*s**2 - 23*s + 6))) + fd*k1**2*(1404*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1592*s - 723) + 1592*s**2 - 2112*s + 591) + 26*k1**2*k2**2*(Pk2*(1050*r**2 + r*(3487 - 14238*s) - 15288*s**2 + 15741*s - 3206) + 25*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 13*f**2*k2**2*(-990*Pk2*bd2*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(r + s - 1) - 33*bd1*(2*k1**4*(Pk2*(2*C*(5*r**2 + r*(28*s - 11) + 23*s**2 - 25*s + 2) - 2*K*(11*r**2 + 38*r*s - 17*r + 27*s**2 - 19*s + 6) + 77*r**2 + 164*r*s - 128*r + 87*s**2 - 118*s + 59) + Pkd2*k2*(-2*C*(r*(9*s - 3) + 9*s**2 - 10*s + 1) - 3*K*(3*s - 1)*(r + s - 1) + 20*r*s - 6*r + 20*s**2 - 22*s + 2)) + k1**2*k2**2*(2*Pk2*(2*C*(21*r**2 + 178*r*s - 13*r + 47*s**2 - 90*s - 12) - 340*K*r**2 - 883*K*r*s + 555*K*r - 543*K*s**2 + 644*K*s - 215*K + 15*b1*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 5) + 33*r**2 + 25*r*s - 69*r + 102*s**2 - 33*s + 44) + Pkd2*k2*(-4*C*(r*(62*s - 30) + 48*s**2 - 65*s + 17) + 3*b1*(r*(92*s - 21) + 92*s**2 - 89*s + 9) + 122*r*s - 62*r + 94*s**2 - 124*s + 24)) + k2**4*(Pk2*(-4*C*(24*r**2 + r*(84*s - 82) + 36*s**2 - 75*s + 54) + 2*K*(87*r**2 + 7*r*(15*s - 17) + 18*s**2 - 84*s + 32) + b1*(42*r**2 + 7*r*(6*s - 1) - 9*s - 13) + 24*r**2 + 144*r*s - 114*r + 72*s**2 - 120*s + 90) + 12*Pkd2*k2*(C*(r*(4 - 8*s) - 6*s**2 + 8*s - 2) + K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r*s - 2*r + 3*s**2 - 4*s + 1))) + fd*(k1**4*(-2*Pk2*(-4*C*(405*r**2 + 9*r*(151*s - 128) + 954*s**2 - 1353*s + 533) + 27*b1*(430*r**2 + r*(1084*s - 627) + 654*s**2 - 747*s + 243) + 4725*r**2 + 12564*r*s - 9681*r + 7839*s**2 - 11229*s + 4178) + 3*Pkd2*k2*(4*C*(141*r*s - 36*r + 141*s**2 - 163*s + 35) + b1*(9*r*(224*s + 153) + 2016*s**2 + 297*s - 973) - 258*r*s - 2*r - 258*s**2 + 258*s - 28)) + 3*k1**2*k2**2*(Pk2*(4*C*(4623*r**2 + 21147*r*s - 9163*r + 9396*s**2 - 15744*s + 4395) + 33*b1*(510*r**2 + r*(696*s - 651) + 186*s**2 - 451*s + 225) - 2646*r**2 - 34956*r*s + 12360*r - 18054*s**2 + 29364*s - 7724) + 6*Pkd2*k2*(-2*C*(156*r*s - 85*r + 156*s**2 - 178*s + 53) + 11*b1*(9*r*(7*s - 4) + 63*s**2 - 80*s + 24) + 420*r*s - 217*r + 420*s**2 - 486*s + 141)) + 18*k2**4*(Pk2*(-2*C*(1371*r**2 + 1173*r*s - 1327*r + 462*s**2 - 446*s + 257) + 11*b1*(3*r - 1)*(5*r + 5*s - 3) + 1635*r**2 + 1437*r*s - 1525*r + 462*s**2 - 490*s + 279) + Pkd2*k2*(22 - 44*C)*(r*(12*s - 5) + 3*(1 - 2*s)**2))) - 132*gd2*(Pk2*k1**2*k2**2*(340*r**2 + r*(883*s - 555) + 543*s**2 - 644*s + 215) + k1**4*(2*Pk2*(11*r**2 + 38*r*s - 17*r + 27*s**2 - 19*s + 6) + 3*Pkd2*k2*(3*s - 1)*(r + s - 1)) - k2**4*(Pk2*(87*r**2 + 7*r*(15*s - 17) + 18*s**2 - 84*s + 32) + 6*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2)))) + 429*f*k2**2*(-60*Pk2*b2*bd1*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 30*Pk2*b2*fd*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1) + b1**2*fd*k2**2*(Pk2*k2**2*(42*r**2 + r*(42*s - 19) - 9*s - 1) + 3*k1**2*(10*Pk2*(12*r**2 + 24*r*s - r + 12*s**2 - s - 5) + Pkd2*k2*s*(92*r + 92*s - 43))) + 2*b1*(-30*Pk2*bd2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + bd1*(k1**4*(K - 1)*(Pk2*(10*r**2 + r*(72*s - 35) + 62*s**2 - 47*s + 5) + 2*Pkd2*k2*(r*(5 - 13*s) + s*(8 - 13*s))) + k1**2*k2**2*(Pk2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(146*r**2 + 452*r*s - 365*r + 306*s**2 - 417*s + 165) + 224*r**2 + 288*r*s - 60*r + 64*s**2 - 8*s - 110) + Pkd2*k2*(r*(K*(53 - 184*s) + 106*s - 30) + s*(K*(131 - 184*s) + 106*s - 76))) - 6*k2**4*(K*(Pk2*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3))) + Pk2*(-4*r**2 + r*(3 - 4*s) + s))) + fd*k1**4*(Pk2*(4*C*(5*r**2 + 2*r*(14*s - 5) + 23*s**2 - 18*s + 5) - 2*K*(22*r**2 + 76*r*s - 41*r + 54*s**2 - 47*s + 10) + 154*r**2 + 328*r*s - 213*r + 174*s**2 - 211*s + 55) - Pkd2*k2*(36*C*r*s + 36*C*s**2 - 16*C*s + 3*K*(2*s - 1)*(3*r + 3*s - 2) - 40*r*s + r - 40*s**2 + 20*s - 1)) + fd*k1**2*k2**2*(Pk2*(2*C*(42*r**2 + r*(356*s - 227) + 94*s**2 - 369*s + 163) - K*(680*r**2 + 1766*r*s - 949*r + 1086*s**2 - 1103*s + 280) + 66*r**2 + 50*r*s + 85*r + 204*s**2 + 160*s - 145) + Pkd2*k2*(r*(s*(122 - 248*C) + 27) + s**2*(94 - 192*C) + s*(132*C - 33) - 15)) + fd*k2**4*(Pk2*(-2*C*(48*r**2 + 24*r*(7*s + 3) + 72*s**2 + 13*s - 78) + K*(174*r**2 + r*(210*s - 94) + 9*(1 - 2*s)**2) + 24*r**2 + 72*r*(2*s + 1) + 72*s**2 + 6*s - 72) + 12*Pkd2*k2*(K*(2*s - 1)*(2*r + 2*s - 1) - s*(2*C - 1)*(4*r + 3*s - 2))) - 2*gd2*(k1**4*(Pk2*(5*r**2 + 36*r*s - 10*r + 31*s**2 - 16*s + 5) + Pkd2*k2*s*(-13*r - 13*s + 3)) + k1**2*k2**2*(Pk2*(73*r**2 + 226*r*s - 238*r + 153*s**2 - 264*s + 165) + Pkd2*k2*s*(-92*r - 92*s + 39)) - 6*k2**4*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1)))) - 4*bd1*g2*(k1**4*(Pk2*(5*r**2 + r*(36*s - 25) + s*(31*s - 31)) + Pkd2*k2*(r*(10 - 13*s) - s*(13*s - 13))) + k1**2*k2**2*(Pk2*(73*r**2 + r*(226*s - 127) + s*(153*s - 153)) + Pkd2*k2*(r*(53 - 92*s) - s*(92*s - 92))) - 6*k2**4*(4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + 4*fd*g2*(Pk2*k1**2*k2**2*(680*r**2 + r*(1766*s - 949) + 1086*s**2 - 1103*s + 280) + k1**4*(2*Pk2*(22*r**2 + 76*r*s - 41*r + 54*s**2 - 47*s + 10) + 3*Pkd2*k2*(2*s - 1)*(3*r + 3*s - 2)) - k2**4*(Pk2*(174*r**2 + r*(210*s - 94) + 9*(1 - 2*s)**2) + 12*Pkd2*k2*(2*s - 1)*(2*r + 2*s - 1))))) + Dd*f*(858*b1*k2**2*(-30*Pk2*b2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*k1**4*(K - 1)*(Pk2*(20*r**2 + r*(144*s - 55) + 124*s**2 - 73*s + 15) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) + b1*k1**2*k2**2*(Pk2*(10*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + K*(292*r**2 + 904*r*s - 933*r + 612*s**2 - 1011*s + 495) + 448*r**2 + 576*r*s + 158*r + 128*s**2 + 236*s - 330) + Pkd2*k2*(r*(K*(53 - 368*s) + 212*s - 30) + s*(K*(170 - 368*s) + 212*s - 99))) - 6*b1*k2**4*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(k1**4*(Pk2*(20*r**2 + r*(144*s - 55) + 124*s**2 - 73*s + 15) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) + k1**2*k2**2*(Pk2*(292*r**2 + r*(904*s - 933) + 612*s**2 - 1011*s + 495) + Pkd2*k2*(r*(53 - 368*s) + s*(170 - 368*s))) - 6*k2**4*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))) + 3*f**3*k1**2*(1404*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(r*(1592*s - 723) + 1592*s**2 - 2112*s + 591) + 26*k1**2*k2**2*(Pk2*(1050*r**2 + r*(3487 - 14238*s) - 15288*s**2 + 15741*s - 3206) + 25*Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) - 26*f**2*k2**2*(k1**4*(-Pk2*(-8*C*(270*r**2 + 906*r*s - 723*r + 636*s**2 - 820*s + 346) + 6*b1*(2580*r**2 + r*(6504*s - 3863) + 3924*s**2 - 4639*s + 1388) + 6300*r**2 + 16752*r*s - 12897*r + 10452*s**2 - 14771*s + 5819) + 3*Pkd2*k2*(2*C*(188*r*s - 53*r + 188*s**2 - 243*s + 52) + 4*b1*(2*r*(168*s + 79) + 336*s**2 - 36*s - 133) - 172*r*s + 8*r - 172*s**2 + 205*s - 23)) + 3*k1**2*k2**2*(Pk2*(2*C*(6164*r**2 + 4*r*(7049*s - 2995) + 12528*s**2 - 22118*s + 5671) + 33*b1*(340*r**2 + r*(464*s - 433) + 124*s**2 - 297*s + 140) - 1764*r**2 - 23304*r*s + 7453*r - 12036*s**2 + 20295*s - 4694) + 3*Pkd2*k2*(-2*C*(208*r*s - 101*r + 208*s**2 - 230*s + 69) + 11*b1*(21*s - 10)*(4*r + 4*s - 3) + 560*r*s - 266*r + 560*s**2 - 648*s + 190)) + 9*k2**4*(Pk2*(-2*C*(1828*r**2 + 4*r*(391*s - 499) + 616*s**2 - 648*s + 469) + 22*b1*(2*r - 1)*(5*r + 5*s - 3) + 2180*r**2 + 1916*r*s - 2304*r + 616*s**2 - 736*s + 513) + Pkd2*k2*(44 - 88*C)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 429*f*k2**2*(30*Pk2*b2*k2**2*(-3*k1**2*(5*r + 5*s - 3) + 2*k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2**2*(180*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*Pk2*k2**2*(42*r**2 + r*(42*s - 13) - 9*s - 7) + 3*Pkd2*k1**2*k2*(r*(184*s - 21) + 184*s**2 - 132*s + 9)) + 2*b1*(k1**4*(Pk2*(2*C*(20*r**2 + r*(112*s - 41) + 92*s**2 - 85*s + 17) - 2*K*(44*r**2 + 152*r*s - 75*r + 108*s**2 - 85*s + 22) + 308*r**2 + 656*r*s - 471*r + 348*s**2 - 449*s + 167) + Pkd2*k2*(C*(r*(6 - 72*s) - 72*s**2 + 50*s - 2) - 3*K*(12*r*s - 5*r + 12*s**2 - 15*s + 4) + 80*r*s - 7*r + 80*s**2 - 58*s + 3)) + k1**2*k2**2*(Pk2*(2*C*(84*r**2 + 8*r*(89*s - 38) + 188*s**2 - 655*s + 194) - K*(1360*r**2 + 3532*r*s - 2059*r + 2172*s**2 - 2391*s + 710) + 132*r**2 + 100*r*s + 14*r + 408*s**2 + 216*s - 132) + Pkd2*k2*(C*(r*(60 - 496*s) - 384*s**2 + 360*s - 34) + r*(244*s + 5) + 188*s**2 - 131*s - 12)) + k2**4*(Pk2*(-4*C*(48*r**2 + 8*r*(21*s - 1) + 72*s**2 - 50*s - 21) + K*(348*r**2 + 420*r*s - 332*r + 72*s**2 - 204*s + 73) + 48*r**2 + 288*r*s + 21*r + 144*s**2 - 90*s - 45) - 6*Pkd2*k2*(C*(4*r*(8*s - 1) + 24*s**2 - 22*s + 2) - 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 16*r*s + 2*r - 12*s**2 + 11*s - 1))) + 4*g2*(Pk2*k1**2*k2**2*(1360*r**2 + r*(3532*s - 2059) + 2172*s**2 - 2391*s + 710) + k1**4*(2*Pk2*(44*r**2 + 152*r*s - 75*r + 108*s**2 - 85*s + 22) + 3*Pkd2*k2*(12*r*s - 5*r + 12*s**2 - 15*s + 4)) - k2**4*(Pk2*(348*r**2 + 420*r*s - 332*r + 72*s**2 - 204*s + 73) + 12*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))))/(9009*d**2*k2**2*k3**5) - D1**3*Pkd3*ct**2*(D1*bd1*f*(f**2*k1**2*(1089*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + 10*k1**4*(2*Pk2 - Pkd2*k2)*(3*r*(9*s - 10) + 27*s**2 - 47*s + 20) - 33*k1**2*k2**2*(Pk2*(35*r**2 + r*(55 - 349*s) - 384*s**2 + 376*s - 20) + 20*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) - 33*f*k2**2*(-2*k1**4*(Pk2*(-4*C*(30*r**2 + 9*r*(13*s - 6) + 27*s**2 - 77*s + 20) - 44*K*r**2 - 129*K*r*s + 58*K*r - 85*K*s**2 + 87*K*s - 14*K + 30*b1*(4*r**2 + r*(8*s - 5) + 4*s**2 - 5*s + 1) + 284*r**2 + 703*r*s - 482*r + 299*s**2 - 535*s + 182) + 2*Pkd2*k2*(-4*C*(r*(7*s - 2) + 7*s**2 - 8*s + 1) - 12*K*(s - 1)*(r + s - 1) + 2*b1*(r*(7*s - 4) + 7*s**2 - 7*s + 2) + 30*r*s - 12*r + 30*s**2 - 39*s + 9)) + k1**2*k2**2*(Pk2*(4*C*(235*r**2 + r*(58*s - 225) + 125*s**2 - 189*s + 4) + 2*K*(442*r**2 + 9*r*(113*s - 86) + 575*s**2 - 819*s + 332) - b1*(1146*r**2 + 3*r*(670*s - 589) + 864*s**2 - 1481*s + 619) - 1164*r**2 - 4*r*(344*s - 338) - 816*s**2 + 1104*s - 244) - 12*Pkd2*k2*(-2*C*(14*r*s - 6*r + 14*s**2 - 15*s + 1) - 10*K*r*s + 6*K*r - 10*K*s**2 + 16*K*s - 6*K + b1*(6*r*(5*s - 1) + 30*s**2 - 28*s + 2) + 20*r*s - 8*r + 20*s**2 - 21*s + 1)) + k2**4*(26*K*Pk2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) - 13*Pk2*b1*(2*r - 1)*(3*r + 3*s - 1) + 2*Pk2*(r**2*(218*C - 135) + r*(2*C*(72*s - 107) - 98*s + 119) + s*(130*C - 65)*(s - 1)) + Pkd2*k2*(48*C - 24)*(r*(2*s - 1) + s*(2*s - 2)))) + 66*k2**2*(5*Pk2*b1**2*k1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 10*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(k1**4*(2*Pk2*(5*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 5*K*s**2 + 3*K*s + r**2*(21 - 11*K) + r*(-16*K*s + 13*K + 36*s - 18) + 15*s**2 - 8*s - 5) - Pkd2*k2*(r*(K*(22*s - 2) - 18*s + 1) + s*(K*(22*s - 20) - 18*s + 17))) + k1**2*k2**2*(Pk2*(10*C*(8*r**2 + r*(23 - 124*s) + 8*s**2 + 58*s - 31) + K*(17*r**2 + 94*r*s - 100*r + 77*s**2 - 144*s + 75) + 127*r**2 + 898*r*s - 230*r + 71*s**2 - 363*s + 110) + Pkd2*k2*(r*(K*(17 - 82*s) + 42*s - 7) + s*(-82*K*s + 65*K + 42*s - 35))) + k2**4*(7*K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + Pk2*(10*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 7*K*(9*r**2 + 18*r*s - 4*r + 9*s**2 - 4*s - 5) + 18*r**2 + 148*r*s - 41*r - 10*s**2 - 62*s + 30))) + 2*g2*(2*k1**4*(Pk2*(11*r**2 + r*(16*s - 15) + s*(5*s - 5)) + Pkd2*k2*(r*(11*s - 2) + s*(11*s - 11))) + k1**2*k2**2*(Pk2*(-17*r**2 + r*(33 - 94*s) - s*(77*s - 77)) + 2*Pkd2*k2*(r*(41*s - 17) + s*(41*s - 41))) + 7*k2**4*(9*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) + 330*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(4*k1**4*(Pk2*(10*C*(r + s - 1)**2 - 11*K*r**2 - 16*K*r*s - 5*K*s**2 + 5*f*(12*r**2 + 24*r*s - 11*r + 12*s**2 - 11*s + 3) + 21*r**2 + 36*r*s + 20*r + 15*s**2 + 20*s - 10) + Pkd2*k2*s*(7*f*(2*r + 2*s - 1) - (11*K - 9)*(r + s))) + k1**2*k2**2*(Pk2*(80*C*(2*r**2 - r*(31*s + 4) + 2*s**2 + 31*s + 2) + 2*K*(17*r**2 + 94*r*s - 300*r + 77*s**2 - 300*s + 150) + f*(1146*r**2 + 3*r*(670*s - 277) + 864*s**2 - 689*s + 39) + 254*r**2 + 1796*r*s + 520*r + 142*s**2 - 880*s - 260) + 4*Pkd2*k2*s*(f*(90*r + 90*s - 39) - (41*K - 21)*(r + s))) - k2**4*(56*K*Pkd2*k2*s*(r + s) + Pk2*(-40*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 14*K*(9*r**2 + 2*r*(9*s + 10) + 9*s**2 + 20*s - 10) - 13*f*(2*r - 1)*(3*r + 3*s - 1) - 36*r**2 - 8*r*(37*s + 5) + 20*s**2 + 240*s + 20))) + 2*Dd*f*(2*k1**4*(Pk2*(10*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 44*K*r**2 - 64*K*r*s + 37*K*r - 20*K*s**2 + 7*K*s + 10*f*(12*r**2 + 24*r*s - 13*r + 12*s**2 - 13*s + 3) + 84*r**2 + 144*r*s - 27*r + 60*s**2 + 3*s - 30) + Pkd2*k2*(f*(4*r*(7*s - 2) + 28*s**2 - 21*s + 4) + r*(-44*K*s + 2*K + 36*s - 1) + s*(-44*K*s + 29*K + 36*s - 25))) + k1**2*k2**2*(Pk2*(20*C*(16*r**2 + r*(7 - 248*s) + 16*s**2 + 182*s - 23) + 68*K*r**2 + 376*K*r*s - 667*K*r + 308*K*s**2 - 799*K*s + 450*K + f*(1146*r**2 + 3*r*(670*s - 433) + 864*s**2 - 1085*s + 329) + 508*r**2 + 3592*r*s - 197*r + 284*s**2 - 1821*s - 40) + 2*Pkd2*k2*(3*f*(r*(60*s - 6) + 60*s**2 - 41*s + 2) + r*(-164*K*s + 17*K + 84*s - 7) + s*(-164*K*s + 89*K + 84*s - 49))) - k2**4*(14*K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) + Pk2*(-20*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 252*K*r**2 + 504*K*r*s + 91*K*r + 252*K*s**2 + 91*K*s - 210*K - 13*f*(2*r - 1)*(3*r + 3*s - 1) - 72*r**2 - 592*r*s + 70*r + 40*s**2 + 378*s - 40)))) + b1*(3*D1*(-f**2*fd*k1**2*(-363*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - 90*k1**4*s*(2*Pk2 - Pkd2*k2)*(3*r + 3*s - 2) + 11*k1**2*k2**2*(Pk2*(105*r**2 - 1047*r*s + 355*r - 1152*s**2 + 1058*s - 308) + 20*Pkd2*k2*(r*(12*s + 13) + 12*s**2 + 6*s - 9))) - 22*f*k2**2*(-10*Pk2*bd2*k2**2*(k1**2 - 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(k1**4*(Pk2*(4*C*(60*r**2 + 18*r*(13*s - 5) + 54*s**2 - 148*s + 45) + K*(88*r**2 + 129*r*(2*s - 1) + 170*s**2 - 203*s + 59) - 568*r**2 - 1406*r*s + 715*r - 598*s**2 + 889*s - 263) + 4*Pkd2*k2*(2*r + 2*s - 1)*(6*K*(s - 1) + s*(14*C - 15) + 3)) + k1**2*k2**2*(Pk2*(C*(940*r**2 + r*(232*s - 582) + 500*s**2 + 622*s - 24) + K*(884*r**2 + 3*r*(678*s - 421) + 1150*s**2 - 1377*s + 401) - 1164*r**2 - 2*r*(688*s - 379) - 816*s**2 + 112*s - 18) + 12*Pkd2*k2*(K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2*C*(14*r + 14*s - 5) - 20*r - 20*s + 7))) + k2**4*(Pk2*(2*C*(218*r**2 + 9*r*(16*s - 5) + 130*s**2 + 157*s - 62) + 13*K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 270*r**2 - 196*r*s + 71*r - 130*s**2 - 143*s + 62) + Pkd2*k2*s*(24*C - 12)*(4*r + 4*s - 1))) - 2*gd2*(2*k1**4*(Pk2*(11*r**2 + r*(16*s - 11) + s*(5*s - 1)) + Pkd2*k2*s*(11*r + 11*s - 9)) + k1**2*k2**2*(-Pk2*(17*r**2 + 94*r*s - 167*r + 77*s**2 - 211*s + 150) + 2*Pkd2*k2*s*(41*r + 41*s - 24)) + 7*k2**4*(Pk2*(9*r**2 + 18*r*s + r + 9*s**2 + s - 10) + 2*Pkd2*k2*s*(2*r + 2*s - 1)))) + 44*fd*k2**2*(5*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(r + s)**2 + g2*(2*k1**4*(r + s)*(11*Pk2*r + 5*Pk2*s + 11*Pkd2*k2*s) + k1**2*k2**2*(-Pk2*(17*r**2 + 94*r*s - 300*r + 77*s**2 - 300*s + 150) + 82*Pkd2*k2*s*(r + s)) + 7*k2**4*(Pk2*(9*r**2 + 18*r*s + 20*r + 9*s**2 + 20*s - 10) + 4*Pkd2*k2*s*(r + s))))) + 2*Dd*f*(f**2*k1**2*(1089*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + 5*k1**4*(2*Pk2 - Pkd2*k2)*(6*r*(18*s - 5) + 108*s**2 - 101*s + 20) - 33*k1**2*k2**2*(Pk2*(70*r**2 + r*(205 - 698*s) - 768*s**2 + 717*s - 164) + 10*Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) - 33*f*k2**2*(k1**4*(Pk2*(4*C*(120*r**2 + 9*r*(52*s - 21) + 108*s**2 - 323*s + 80) + K*(176*r**2 + 516*r*s - 245*r + 340*s**2 - 377*s + 87) - 1136*r**2 - 2812*r*s + 1643*r - 1196*s**2 + 1983*s - 607) + 2*Pkd2*k2*(4*C*(r*(28*s - 2) + 28*s**2 - 21*s + 1) + 12*K*(s - 1)*(4*r + 4*s - 3) - (12*s - 3)*(10*r + 10*s - 7))) + k1**2*k2**2*(Pk2*(2*C*(940*r**2 + r*(232*s - 819) + 500*s**2 + 217*s + 60) + K*(1768*r**2 + 4068*r*s - 2811*r + 2300*s**2 - 3015*s + 1065) - 2328*r**2 - 2752*r*s + 2136*r - 1632*s**2 + 880*s - 260) + 6*Pkd2*k2*(2*C*(r*(56*s - 6) + 56*s**2 - 34*s + 1) + K*(40*r*s - 26*r + 40*s**2 - 58*s + 20) - 80*r*s + 8*r - 80*s**2 + 48*s - 1)) + k2**4*(Pk2*(2*C*(436*r**2 + r*(288*s - 259) + 260*s**2 + 129*s - 64) + 13*K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 540*r**2 - 392*r*s + 323*r - 260*s**2 - 101*s + 64) + Pkd2*k2*(24*C - 12)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 66*k2**2*(5*Pk2*b2*k2**2*(k1**2 - 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*k1**4*(Pk2*(44*r**2 + r*(64*s - 37) + s*(20*s - 7)) + Pkd2*k2*(r*(44*s - 2) + s*(44*s - 29))) + k1**2*k2**2*(-Pk2*(68*r**2 + r*(376*s - 667) + 308*s**2 - 799*s + 450) + 2*Pkd2*k2*(r*(164*s - 17) + s*(164*s - 89))) + 7*k2**4*(Pk2*(36*r**2 + 72*r*s + 13*r + 36*s**2 + 13*s - 30) + 2*Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + 2*f*(D1*(5*f**2*fd*k1**4*(-183*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(7*r*(36*s - 49) + 252*s**2 - 547*s + 261) - 28*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*k2**2*(-330*Pk2*bd2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(r + s - 1) + fd*(Pk2*k2**4*(33 - 66*C)*(117*r**2 + 3*r*(105*s - 61) + 198*s**2 - 204*s + 59) - 2*k1**4*(Pk2*(C*(4230*r**2 + 13329*r*s - 6603*r + 9099*s**2 - 10740*s + 2819) - 5580*r**2 - 15084*r*s + 8913*r - 9504*s**2 + 12453*s - 3770) + Pkd2*k2*(660*C - 495)*(s - 1)*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(-2*C*(38592*r**2 + 88191*r*s - 60405*r + 49599*s**2 - 65004*s + 22205) + 45918*r**2 + 105021*r*s - 70701*r + 59103*s**2 - 75630*s + 25439) + Pkd2*k2*(330 - 660*C)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + 66*gd2*(13*Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**4*(Pk2*(44*r**2 + r*(129*s - 58) + 85*s**2 - 87*s + 14) + 24*Pkd2*k2*(s - 1)*(r + s - 1)) + k1**2*k2**2*(Pk2*(442*r**2 + 9*r*(113*s - 86) + 575*s**2 - 819*s + 332) + 12*Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 66*fd*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(2*r + 2*s - 1) + g2*(13*Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**4*(Pk2*(88*r**2 + 129*r*(2*s - 1) + 170*s**2 - 203*s + 59) + 24*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(884*r**2 + 3*r*(678*s - 421) + 1150*s**2 - 1377*s + 401) + 12*Pkd2*k2*(r*(10*s - 7) + 10*s**2 - 13*s + 4))))) + Dd*f*(5*f**2*k1**4*(-183*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(Pk2*(7*r*(36*s - 49) + 252*s**2 - 547*s + 261) - 28*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*k2**2*(Pk2*k2**4*(33 - 66*C)*(156*r**2 + 4*r*(105*s - 62) + 264*s**2 - 276*s + 85) - 2*k1**4*(Pk2*(C*(5640*r**2 + 17772*r*s - 8613*r + 12132*s**2 - 14009*s + 3419) - 7440*r**2 - 20112*r*s + 11923*r - 12672*s**2 + 16498*s - 4920) + Pkd2*k2*(660*C - 495)*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(-2*C*(51456*r**2 + 3*r*(39196*s - 27755) + 66132*s**2 - 89057*s + 32201) + 61224*r**2 + 21*r*(6668*s - 4625) + 78804*s**2 - 102917*s + 36557) + Pkd2*k2*(330 - 660*C)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 66*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(2*r + 2*s - 1) + 6*k2**2*(4*r + 4*s - 3))*(4*r + 4*s - 3) + g2*(13*Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**4*(Pk2*(176*r**2 + 516*r*s - 245*r + 340*s**2 - 377*s + 87) + 24*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) + k1**2*k2**2*(Pk2*(1768*r**2 + 4068*r*s - 2811*r + 2300*s**2 - 3015*s + 1065) + 12*Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10)))))))/(693*d**2*k2**2*k3**5) + 5*D1**3*Pkd3*ct*f*k1*k2*st**6*(-4*Pk2 + Pkd2*k2)*(D1*b1*fd*(f*(54*r*s - 51*r + 54*s**2 - 54*s + 23) + (264*s - 132)*(2*r + 2*s - 1)) + 2*D1*bd1*f*(f*(r*(9*s - 7) + 9*s**2 - 9*s + 7) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) + 4*D1*f*fd*(3*s - 1)*(3*r + 3*s - 2) + Dd*b1*f*(f*(72*r*s - 65*r + 72*s**2 - 72*s + 37) + 1056*r*s - 396*r + 1056*s**2 - 1056*s + 264) + 2*Dd*f**2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))/(693*d**2*k3**3) - 5*D1**3*Pkd3*ct*f*k1*k2*st**6*(D1*(f**2*(13*bd1*k2**2*(Pk2*(45*r**2 + r*(54*s + 8) + 9*s**2 + 16*s - 53) + 2*Pkd2*k2*(r*(9*s - 7) + 9*s**2 - 9*s + 7)) + fd*(52*Pk2*k2**2*(56*r**2 + r*(56*s - 99) - 42*s + 39) - k1**2*(4*Pk2 - Pkd2*k2)*(r*(7456*s - 1721) + 7456*s**2 - 7482*s + 1333))) - 13*f*k2**2*(66*bd1*(Pk2*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - fd*(3*Pk2*b1*(45*r**2 + r*(54*s + 29) + 9*s**2 + 31*s - 32) - 2*Pk2*(3*r + 3*s - 2)*(8*C*(3*r - 6*s + 1) - 39*r + 21*s + 6) + Pkd2*b1*k2*(r*(54*s - 51) + 54*s**2 - 54*s + 23) + Pkd2*k2*(12 - 16*C)*(3*s - 1)*(3*r + 3*s - 2)) - 264*gd2*(Pk2*(4*r**2 - r*(4*s + 3) - 8*s**2 + 6*s - 1) + Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2))) - 858*fd*k2**2*(b1*(Pk2*(8*K*(r - 2*s + 1) - 18*r - 2*s + 1) + Pkd2*k2*(4*K - 2)*(2*s - 1)) - 8*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))*(2*r + 2*s - 1)) + Dd*f*(f**2*(52*Pk2*k2**2*(56*r**2 + r*(56*s - 99) - 42*s + 39) - k1**2*(4*Pk2 - Pkd2*k2)*(r*(7456*s - 1721) + 7456*s**2 - 7482*s + 1333)) + 13*f*k2**2*(Pk2*b1*(180*r**2 + r*(216*s + 95) + 36*s**2 + 109*s - 149) + 2*Pk2*(4*C*(-24*r**2 + r*(24*s + 13) + 48*s**2 - 38*s + 3) + 156*r**2 + r*(72*s - 151) - 84*s**2 + 19*s + 28) + Pkd2*b1*k2*(r*(72*s - 65) + 72*s**2 - 72*s + 37) + Pkd2*k2*(6 - 8*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 858*k2**2*(b1*(Pk2*(4*K*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) - 72*r**2 - 80*r*s + 66*r - 8*s**2 + 26*s - 11) + Pkd2*k2*(4*K - 2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 8*g2*(Pk2*(8*r**2 - 8*r*s - r - 16*s**2 + 14*s - 3) + Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(9009*d**2*k3**5) + D1**3*Pkd3*ct*st**2*(-2*D1*bd1*f*(b2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(13*s - 3) + s*(13*s - 13)) + f*(Pk2*k2**2*r*(4*C - 2)*(3*r + 3*s - 1) + k1**2*(Pk2*(11*r**2 + 4*r*(C*(11*s - 3) + s - 2) + s*(4*C*(7*s - 8) + s + 1)) + Pkd2*k2*(r*(-22*C*s + 6*C + 9*s - 2) + s*(-14*C*s + 16*C + 5*s - 6)))) - 2*g2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(13*s - 3) + s*(13*s - 13))) + 13*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*s*(r + s - 1) + Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + b1**2*k1**2*(13*D1*bd1*f*(2*Pk2 - Pkd2*k2)*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - D1*fd*(2*Pk2*(26*K*(s - 1) + 12*f*(2*r + 8*s - 5) + 13*r - 33*s + 29) + Pkd2*k2*(-26*K*(s - 1) + f*(21 - 36*s) + 32*s - 28))*(r + s - 1) + Dd*f*(-2*Pk2*(2*K*(52*r*s - 22*r + 52*s**2 - 71*s + 19) + 6*f*(8*r**2 + r*(40*s - 22) + 32*s**2 - 44*s + 13) + 52*r**2 - 80*r*s - 26*r - 132*s**2 + 149*s - 19) + Pkd2*k2*(2*K*(52*r*s - 22*r + 52*s**2 - 71*s + 19) + 3*f*(r*(24*s - 11) + 24*s**2 - 32*s + 9) - 128*r*s + 72*r - 128*s**2 + 184*s - 58))) - b1*(176*C*D1*Pk2*f*fd*k1**2*r*s - 88*C*D1*Pk2*f*fd*k1**2*r + 112*C*D1*Pk2*f*fd*k1**2*s**2 - 232*C*D1*Pk2*f*fd*k1**2*s + 88*C*D1*Pk2*f*fd*k1**2 + 48*C*D1*Pk2*f*fd*k2**2*r**2 + 48*C*D1*Pk2*f*fd*k2**2*r*s - 56*C*D1*Pk2*f*fd*k2**2*r - 8*C*D1*Pk2*f*fd*k2**2*s + 8*C*D1*Pk2*f*fd*k2**2 - 88*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 44*C*D1*Pkd2*f*fd*k1**2*k2*r - 56*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 116*C*D1*Pkd2*f*fd*k1**2*k2*s - 44*C*D1*Pkd2*f*fd*k1**2*k2 + 352*C*Dd*Pk2*f**2*k1**2*r*s - 136*C*Dd*Pk2*f**2*k1**2*r + 224*C*Dd*Pk2*f**2*k1**2*s**2 - 408*C*Dd*Pk2*f**2*k1**2*s + 112*C*Dd*Pk2*f**2*k1**2 + 96*C*Dd*Pk2*f**2*k2**2*r**2 + 96*C*Dd*Pk2*f**2*k2**2*r*s - 96*C*Dd*Pk2*f**2*k2**2*r - 16*C*Dd*Pk2*f**2*k2**2*s + 16*C*Dd*Pk2*f**2*k2**2 - 176*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 68*C*Dd*Pkd2*f**2*k1**2*k2*r - 112*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 204*C*Dd*Pkd2*f**2*k1**2*k2*s - 56*C*Dd*Pkd2*f**2*k1**2*k2 + 44*D1*Pk2*f*fd*k1**2*r**2 + 16*D1*Pk2*f*fd*k1**2*r*s - 58*D1*Pk2*f*fd*k1**2*r + 4*D1*Pk2*f*fd*k1**2*s**2 - 2*D1*Pk2*f*fd*k1**2*s + 14*D1*Pk2*f*fd*k1**2 - 24*D1*Pk2*f*fd*k2**2*r**2 - 24*D1*Pk2*f*fd*k2**2*r*s + 28*D1*Pk2*f*fd*k2**2*r + 4*D1*Pk2*f*fd*k2**2*s - 4*D1*Pk2*f*fd*k2**2 - 104*D1*Pk2*f*gd2*k1**2*r*s + 24*D1*Pk2*f*gd2*k1**2*r - 104*D1*Pk2*f*gd2*k1**2*s**2 + 128*D1*Pk2*f*gd2*k1**2*s - 24*D1*Pk2*f*gd2*k1**2 - 104*D1*Pk2*fd*g2*k1**2*r*s + 104*D1*Pk2*fd*g2*k1**2*r - 104*D1*Pk2*fd*g2*k1**2*s**2 + 208*D1*Pk2*fd*g2*k1**2*s - 104*D1*Pk2*fd*g2*k1**2 + 36*D1*Pkd2*f*fd*k1**2*k2*r*s - 16*D1*Pkd2*f*fd*k1**2*k2*r + 20*D1*Pkd2*f*fd*k1**2*k2*s**2 - 44*D1*Pkd2*f*fd*k1**2*k2*s + 16*D1*Pkd2*f*fd*k1**2*k2 + 52*D1*Pkd2*f*gd2*k1**2*k2*r*s - 12*D1*Pkd2*f*gd2*k1**2*k2*r + 52*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 64*D1*Pkd2*f*gd2*k1**2*k2*s + 12*D1*Pkd2*f*gd2*k1**2*k2 + 52*D1*Pkd2*fd*g2*k1**2*k2*r*s - 52*D1*Pkd2*fd*g2*k1**2*k2*r + 52*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 104*D1*Pkd2*fd*g2*k1**2*k2*s + 52*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*f*k1**2*(2*Pk2*(2*K*(26*r*s - 6*r + 26*s**2 - 29*s + 3) + 6*f*(4*r**2 + 4*r*(5*s - 2) + 16*s**2 - 18*s + 3) + 26*r**2 - 40*r*s - 23*r - 66*s**2 + 60*s + 4) + Pkd2*k2*(-2*K*(26*r*s - 6*r + 26*s**2 - 29*s + 3) - 3*f*(4*r*(3*s - 1) + 12*s**2 - 13*s + 2) + 64*r*s - 30*r + 64*s**2 - 78*s + 16)) + 2*D1*bd2*f*k1**2*(2*Pk2 - Pkd2*k2)*(13*s - 3)*(r + s - 1) + 88*Dd*Pk2*f**2*k1**2*r**2 + 32*Dd*Pk2*f**2*k1**2*r*s - 112*Dd*Pk2*f**2*k1**2*r + 8*Dd*Pk2*f**2*k1**2*s**2 - 2*Dd*Pk2*f**2*k1**2*s + 30*Dd*Pk2*f**2*k1**2 - 48*Dd*Pk2*f**2*k2**2*r**2 - 48*Dd*Pk2*f**2*k2**2*r*s + 48*Dd*Pk2*f**2*k2**2*r + 8*Dd*Pk2*f**2*k2**2*s - 8*Dd*Pk2*f**2*k2**2 - 416*Dd*Pk2*f*g2*k1**2*r*s + 176*Dd*Pk2*f*g2*k1**2*r - 416*Dd*Pk2*f*g2*k1**2*s**2 + 568*Dd*Pk2*f*g2*k1**2*s - 152*Dd*Pk2*f*g2*k1**2 + 72*Dd*Pkd2*f**2*k1**2*k2*r*s - 24*Dd*Pkd2*f**2*k1**2*k2*r + 40*Dd*Pkd2*f**2*k1**2*k2*s**2 - 78*Dd*Pkd2*f**2*k1**2*k2*s + 20*Dd*Pkd2*f**2*k1**2*k2 + 208*Dd*Pkd2*f*g2*k1**2*k2*r*s - 88*Dd*Pkd2*f*g2*k1**2*k2*r + 208*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 284*Dd*Pkd2*f*g2*k1**2*k2*s + 76*Dd*Pkd2*f*g2*k1**2*k2 + 2*b2*k1**2*(2*Pk2 - Pkd2*k2)*(13*D1*fd*(s - 1)*(r + s - 1) + Dd*f*(52*r*s - 22*r + 52*s**2 - 71*s + 19))))/(21*d**2*k1*k2*k3) + 2*D1**3*Pkd3*ct*(D1*bd1*f*(f*(Pk2*k1**2*(12*r**2 + r*s*(92*C - 9) - s*(4*C*(3*s + 11) - 31*s + 3)) + Pk2*k2**2*r*(2 - 4*C)*(r + s - 1) - Pkd2*k1**2*k2*(24*C - 12)*(r + s)*(s - 1)) + k1**2*(-14*b2 + 28*g2)*(-Pk2*s*(r + s - 1) + Pkd2*k2*(r + s)*(s - 1))) + 7*b1**3*k1**2*(D1*fd*(Pk2*(r - 3*s - 1) + 2*Pkd2*k2*s)*(r + s - 1) + Dd*f*(Pk2*(4*r**2 - 8*r*s - 5*r - 12*s**2 + 9*s + 1) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) + b1**2*(7*D1*bd1*f*k1**2*(Pk2*(3*r**2 - 3*r*(2*s + 1) + s*(7 - 9*s)) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + D1*fd*(Pk2*k2**2*(2 - 4*C)*(r - 1)*(3*r - 4*s - 3) + k1**2*(Pk2*(r + s - 1)*(14*K*(s - 1) + 39*f*(2*s - 1) + 24*r + 25*s - 31) - 2*Pkd2*k2*(7*K*(s - 1)*(r + s - 1) + s*(2 - 4*C)*(6*r - s - 6)))) + Dd*Pk2*f*k2**2*(8 - 16*C)*(3*r**2 - 4*r*(s + 1) + 3*s + 1) + Dd*f*k1**2*(Pk2*(14*K*(4*s - 1)*(r + s - 1) + 39*f*(4*s - 1)*(r + s - 1) + 96*r**2 + 196*r*s - 151*r + 100*s**2 - 193*s + 69) + 2*Pkd2*k2*(4*C*(3*r*(8*s - 1) - 4*s**2 - 17*s + 3) - 7*K*(s - 1)*(4*r + 4*s - 3) - 48*r*s + 6*r + 8*s**2 + 34*s - 6))) + b1*(184*C*D1*Pk2*f*fd*k1**2*r*s - 44*C*D1*Pk2*f*fd*k1**2*r - 24*C*D1*Pk2*f*fd*k1**2*s**2 - 124*C*D1*Pk2*f*fd*k1**2*s + 44*C*D1*Pk2*f*fd*k1**2 - 8*C*D1*Pk2*f*fd*k2**2*r**2 - 8*C*D1*Pk2*f*fd*k2**2*r*s + 12*C*D1*Pk2*f*fd*k2**2*r + 4*C*D1*Pk2*f*fd*k2**2*s - 4*C*D1*Pk2*f*fd*k2**2 - 48*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 48*C*D1*Pkd2*f*fd*k1**2*k2*r - 48*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 96*C*D1*Pkd2*f*fd*k1**2*k2*s - 48*C*D1*Pkd2*f*fd*k1**2*k2 + 368*C*Dd*Pk2*f**2*k1**2*r*s - 44*C*Dd*Pk2*f**2*k1**2*r - 48*C*Dd*Pk2*f**2*k1**2*s**2 - 260*C*Dd*Pk2*f**2*k1**2*s + 44*C*Dd*Pk2*f**2*k1**2 - 16*C*Dd*Pk2*f**2*k2**2*r**2 - 16*C*Dd*Pk2*f**2*k2**2*r*s + 24*C*Dd*Pk2*f**2*k2**2*r + 8*C*Dd*Pk2*f**2*k2**2*s - 8*C*Dd*Pk2*f**2*k2**2 - 96*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 96*C*Dd*Pkd2*f**2*k1**2*k2*r - 96*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 168*C*Dd*Pkd2*f**2*k1**2*k2*s - 72*C*Dd*Pkd2*f**2*k1**2*k2 + 14*D1*Pk2*bd2*f*k1**2*r*s + 14*D1*Pk2*bd2*f*k1**2*s**2 - 14*D1*Pk2*bd2*f*k1**2*s + 24*D1*Pk2*f*fd*k1**2*r**2 - 18*D1*Pk2*f*fd*k1**2*r*s - 27*D1*Pk2*f*fd*k1**2*r + 62*D1*Pk2*f*fd*k1**2*s**2 - 13*D1*Pk2*f*fd*k1**2*s + 3*D1*Pk2*f*fd*k1**2 + 4*D1*Pk2*f*fd*k2**2*r**2 + 4*D1*Pk2*f*fd*k2**2*r*s - 6*D1*Pk2*f*fd*k2**2*r - 2*D1*Pk2*f*fd*k2**2*s + 2*D1*Pk2*f*fd*k2**2 - 28*D1*Pk2*f*gd2*k1**2*r*s - 28*D1*Pk2*f*gd2*k1**2*s**2 + 28*D1*Pk2*f*gd2*k1**2*s - 28*D1*Pk2*fd*g2*k1**2*r*s + 28*D1*Pk2*fd*g2*k1**2*r - 28*D1*Pk2*fd*g2*k1**2*s**2 + 56*D1*Pk2*fd*g2*k1**2*s - 28*D1*Pk2*fd*g2*k1**2 - 14*D1*Pkd2*bd2*f*k1**2*k2*r*s + 14*D1*Pkd2*bd2*f*k1**2*k2*r - 14*D1*Pkd2*bd2*f*k1**2*k2*s**2 + 28*D1*Pkd2*bd2*f*k1**2*k2*s - 14*D1*Pkd2*bd2*f*k1**2*k2 + 24*D1*Pkd2*f*fd*k1**2*k2*r*s - 24*D1*Pkd2*f*fd*k1**2*k2*r + 24*D1*Pkd2*f*fd*k1**2*k2*s**2 - 48*D1*Pkd2*f*fd*k1**2*k2*s + 24*D1*Pkd2*f*fd*k1**2*k2 + 28*D1*Pkd2*f*gd2*k1**2*k2*r*s - 28*D1*Pkd2*f*gd2*k1**2*k2*r + 28*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 56*D1*Pkd2*f*gd2*k1**2*k2*s + 28*D1*Pkd2*f*gd2*k1**2*k2 + 28*D1*Pkd2*fd*g2*k1**2*k2*r*s - 28*D1*Pkd2*fd*g2*k1**2*k2*r + 28*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 56*D1*Pkd2*fd*g2*k1**2*k2*s + 28*D1*Pkd2*fd*g2*k1**2*k2 + 2*D1*bd1*f*(Pk2*k2**2*(2 - 4*C)*(3*r**2 - 2*r*(2*s + 1) + 2*s - 1) + k1**2*(Pk2*(24*r**2 + r*(s*(14*K + 39*f + 49) - 31) + s**2*(14*K + 39*f + 25) - s*(14*K + 39*f + 51) + 14) + Pkd2*k2*(4*C*(3*r*(4*s - 1) - 2*s**2 - 5*s + 3) - 7*K*(s - 1)*(2*r + 2*s - 1) - 24*r*s + 6*r + 4*s**2 + 10*s - 6))) + 48*Dd*Pk2*f**2*k1**2*r**2 - 36*Dd*Pk2*f**2*k1**2*r*s - 39*Dd*Pk2*f**2*k1**2*r + 124*Dd*Pk2*f**2*k1**2*s**2 + 5*Dd*Pk2*f**2*k1**2*s + 3*Dd*Pk2*f**2*k1**2 + 8*Dd*Pk2*f**2*k2**2*r**2 + 8*Dd*Pk2*f**2*k2**2*r*s - 12*Dd*Pk2*f**2*k2**2*r - 4*Dd*Pk2*f**2*k2**2*s + 4*Dd*Pk2*f**2*k2**2 - 112*Dd*Pk2*f*g2*k1**2*r*s + 28*Dd*Pk2*f*g2*k1**2*r - 112*Dd*Pk2*f*g2*k1**2*s**2 + 140*Dd*Pk2*f*g2*k1**2*s - 28*Dd*Pk2*f*g2*k1**2 + 48*Dd*Pkd2*f**2*k1**2*k2*r*s - 48*Dd*Pkd2*f**2*k1**2*k2*r + 48*Dd*Pkd2*f**2*k1**2*k2*s**2 - 84*Dd*Pkd2*f**2*k1**2*k2*s + 36*Dd*Pkd2*f**2*k1**2*k2 + 112*Dd*Pkd2*f*g2*k1**2*k2*r*s - 112*Dd*Pkd2*f*g2*k1**2*k2*r + 112*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 196*Dd*Pkd2*f*g2*k1**2*k2*s + 84*Dd*Pkd2*f*g2*k1**2*k2 + 14*b2*k1**2*(D1*fd*(Pk2 - Pkd2*k2)*(s - 1)*(r + s - 1) + Dd*f*(Pk2*(4*s - 1)*(r + s - 1) - Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))/(21*d**2*k1*k2*k3) - 2*D1**3*Pkd3*ct*st**4*(D1*bd1*f*k1**2*(f**2*(33*Pk2*k2**2*(11*r**2 + 16*r*(s - 1) + 5*s**2 - 14*s + 5) - 10*k1**2*(4*Pk2 - Pkd2*k2)*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3)) - 33*f*(8*Pk2*k1**2*s*(r + s) + 4*Pk2*k2**2*(-3*r**2 + r*(-4*K*s + 2*s + 3) + s*(-4*K*s + 2*K + 5*s - 2)) - 2*Pkd2*k1**2*k2*s*(r + s) + 2*Pkd2*k2**3*(r*s*(4*K - 4) + r + (2*s - 1)*(s*(2*K - 2) + 1)) + b1*k2**2*(Pk2*(2*r**2 + 4*r*s - 5*r + 2*s**2 - 7*s + 3) + Pkd2*k2*(r + 2*s - 1))) - 66*k2**2*(b1*(Pk2*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 - 12*r*s + 9*r - 2*s**2 + s - 1) + Pkd2*k2*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 4*g2*(Pk2*(2*r**2 - 2*r*s + r - s*(4*s - 4)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))))) + D1*(-66*b1*fd*k1**2*k2**2*(b1*(Pk2*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 - 6*r*s + 2*r - s**2 - 6*s + 3) + 2*Pkd2*k2*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1)) - 8*g2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))*(r + s - 1)) + f**2*(fd*(Pk2*k2**4*(4*C - 2)*(3*r - 1)*(27*r + 60*s - 7) - 12*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(5*b1*(5*r + 5*s - 4) + 3*r + 3*s - 2) + k1**2*k2**2*(Pk2*(240*C*(3*s - 1)*(3*r + 3*s - 2) + 33*b1*(33*r**2 + r*(48*s - 39) + 15*s**2 - 33*s + 14) + 522*r**2 - 378*r*s - 288*r - 900*s**2 + 726*s - 62) + Pkd2*k2*(60 - 120*C)*(3*s - 1)*(3*r + 3*s - 2))) + k1**2*k2**2*s*(-2*Pk2 + Pkd2*k2)*(-132*bd2 + 264*gd2)*(2*r + 2*s - 1)) + 33*f*k1**2*(b1**2*fd*k2**2*(-2*Pk2*(r**2 + r*(2*s - 1) + s**2) + Pkd2*k2*(r + 2*s - 1)) - 2*b1*fd*(4*Pk2*k1**2*(r + s)*(2*s - 1) + Pk2*k2**2*(-2*K*(r*(8*s - 3) + 8*s**2 - 6*s + 1) - 12*r**2 + r*(8*s - 5) + 5*(1 - 2*s)**2) - Pkd2*k1**2*k2*(r + s)*(2*s - 1) + Pkd2*k2**3*(K*(r*(8*s - 3) + 8*s**2 - 6*s + 1) + (2 - 4*s)*(2*r + 2*s - 1))) + 8*b1*gd2*k2**2*(Pk2*(2*r - 4*s + 1) + Pkd2*k2*(2*s - 1))*(r + s - 1) - 2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(8*s - 3) + 8*s**2 - 6*s + 1))) + Dd*f*(-66*b1*k1**2*k2**2*(b1*(Pk2*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 - 24*r*s + 17*r - 4*s**2 - 5*s + 1) + 2*Pkd2*k2*(K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 2*r + 4*s - 2)) - 4*g2*(Pk2*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + Pkd2*k2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) + f**2*(Pk2*k2**4*(16*C - 8)*(27*r**2 + 6*r*(10*s - 3) - 25*s + 1) - 2*k1**4*(4*Pk2 - Pkd2*k2)*(5*b1*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 3*r*(24*s - 7) + 72*s**2 - 72*s + 15) + k1**2*k2**2*(Pk2*(120*C*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 33*b1*(44*r**2 + r*(64*s - 55) + 20*s**2 - 47*s + 19) + 696*r**2 - 28*r*(18*s + 19) - 1200*s**2 + 888*s + 8) + Pkd2*k2*(30 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 33*f*k1**2*(Pk2*b1**2*k2**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*b1*(4*Pk2*k1**2*(r + s)*(4*s - 1) + Pk2*k2**2*(K*(r*(6 - 32*s) - 32*s**2 + 20*s - 2) - 24*r**2 + r*(16*s + 7) + 40*s**2 - 28*s + 5) - Pkd2*k1**2*k2*(r + s)*(4*s - 1) + Pkd2*k2**3*(K*r*(16*s - 3) + 16*K*s**2 - 10*K*s + K - 2*r*(8*s - 3) - 4*(1 - 2*s)**2)) + k2**2*(-2*Pk2 + Pkd2*k2)*(2*b2 - 4*g2)*(r*(16*s - 3) + 16*s**2 - 10*s + 1))))/(231*d**2*k1*k2*k3**3) + D1**3*Pkd3*ct*st**2*(429*b1**3*k1**2*k2**2*(D1*fd*(Pk2*(r + s - 1) + 2*Pkd2*k2*s)*(r + s - 1) + Dd*f*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1))) + 33*b1**2*k1**2*(13*D1*bd1*f*k2**2*(Pk2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + Pkd2*k2*(r*(6*s - 1) + 6*s**2 - 6*s + 1)) + D1*fd*(k1**2*(2*Pk2*(-4*K*(s - 1)*(r + s - 1) + f*(6*r**2 + 4*r*(35*s + 1) + 134*s**2 - 79*s - 10) + r**2 + 32*r*s - 6*r + 31*s**2 - 10*s + 5) - Pkd2*k2*(f*(16*r*(8*s + 1) + 128*s**2 - 67*s - 16) + 26*s*(r + s))) - k2**2*(2*Pk2*(8*C*(r - 1)*(r + s - 1) + 67*K*r**2 + 78*K*r*s - 78*K*r + 11*K*s**2 - 22*K*s + 11*K + f*(41*r**2 + 50*r*s - 17*r + 9*s**2 + 2*s - 6) - 4*r**2 - 12*r*s + 72*r - 8*s**2 + 22*s - 15) + Pkd2*k2*(2*K*(r*(2*s - 41) + 2*s**2 - 82*s + 41) - 21*f*(r + 2*s - 1) + 4*r*(s*(4*C - 3) + 7) + 4*s**2*(4*C - 3) + 4*s*(17 - 4*C) - 28))) + 2*Dd*f*k1**2*(Pk2*(-2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + f*(12*r**2 + r*(280*s - 23) + 268*s**2 - 209*s + 9) + 4*r**2 + 128*r*s - 37*r + 124*s**2 - 69*s + 11) + Pkd2*k2*(r*(-128*f*s + f - 52*s + 10) + s*(f*(94 - 128*s) - 52*s + 19))) + Dd*f*k2**2*(Pk2*(-8*C*(8*r**2 + r*(8*s - 13) - 6*s + 5) - 536*K*r**2 - 624*K*r*s + 826*K*r - 88*K*s**2 + 378*K*s - 290*K + f*(-164*r**2 - 200*r*s + 87*r - 36*s**2 + 47*s + 13) + 32*r**2 + 96*r*s - 414*r + 64*s**2 - 156*s + 222) - 2*Pkd2*k2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 8*K*r*s - 69*K*r + 8*K*s**2 - 168*K*s + 75*K - 12*f*(r + 2*s - 1) - 24*r*s + 31*r - 24*s**2 + 80*s - 31))) + 33*b1*(D1*bd1*f*k1**2*(k1**2*(2*Pk2*(-2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + f*(6*r**2 + r*(140*s - 27) + 134*s**2 - 130*s + 19) + 2*r**2 + 64*r*s - 27*r + 62*s**2 - 45*s + 3) + Pkd2*k2*(f*(-2*r*(64*s - 9) - 128*s**2 + 121*s - 16) + r*(20 - 52*s) + s*(32 - 52*s))) + k2**2*(Pk2*(-8*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 2*K*(134*r**2 + 3*r*(52*s - 67) + 22*s**2 - 89*s + 67) + f*(-82*r**2 + r*(53 - 100*s) - 18*s**2 + 51*s + 1) + 16*r**2 + 48*r*s - 162*r + 32*s**2 - 64*s + 92) + Pkd2*k2*(-8*C*(r*(4*s - 1) + (1 - 2*s)**2) - 8*K*r*s + 22*K*r - 8*K*s**2 + 88*K*s - 34*K + 3*f*(r + 2*s - 1) + 24*r*s - 20*r + 24*s**2 - 52*s + 20))) + D1*(-3*f**2*fd*k1**2*(-4*Pk2*k2**2*(18*r**2 + r*(33*s - 28) + 15*s**2 - 22*s + 10) + k1**2*(4*Pk2*(78*r*s - 32*r + 78*s**2 - 97*s + 26) + Pkd2*k2*(-72*r*s + 36*r - 72*s**2 + 97*s - 30))) - 2*f*fd*(Pk2*k2**4*(4*C - 2)*(4*r - 1) + k1**4*(Pk2*(16*C*s**2 + 2*K*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + 28*r**2 - 4*r*(4*C*s - 29*s + 18) + 72*s**2 - 83*s + 19) + Pkd2*k2*(2*C*(r*(8*s - 3) - 7*s + 3) + K*(-14*r*s + 8*r - 14*s**2 + 17*s - 5) + 10*r + 8*s**2 + 12*s - 7)) + k1**2*k2**2*(Pk2*(4*C*(25*r**2 + r*(82*s - 67) + 29*s**2 - 85*s + 42) - 2*K*(32*r**2 + 152*r*s - 78*r + 120*s**2 - 110*s + 25) - 66*r**2 - 178*r*s + 145*r - 56*s**2 + 182*s - 91) + Pkd2*k2*(-2*C*(r*(44*s + 5) + 44*s**2 - 14*s - 5) + 3*K*(16*r*s - 9*r + 16*s**2 - 18*s + 5) + 44*r*s + 2*r + 44*s**2 - 20*s - 2))) + 2*f*k1**2*(bd2*k2**2*(-13*Pk2*(r + s - 1)**2 + Pkd2*k2*s*(39*r + 39*s - 16)) + 2*gd2*(2*Pk2*k1**2*(2*s - 1)*(r + s - 1) + k2**2*(Pk2*(67*r**2 + 78*r*s - 134*r + 11*s**2 - 78*s + 67) + Pkd2*k2*(2*r*s - 17*r + 2*s**2 - 42*s + 17)))) + 2*fd*k1**2*(13*b2*k2**2*(-Pk2*(r + s - 1)**2 + 3*Pkd2*k2*s*(r + s)) + 2*g2*(4*Pk2*k1**2*(s - 1)*(r + s - 1) + k2**2*(Pk2*(67*r**2 + 78*r*(s - 1) + 11*(s - 1)**2) + Pkd2*k2*(r*(2*s - 41) + 2*s**2 - 82*s + 41))))) - 2*Dd*f*(3*f**2*k1**2*(-2*Pk2*k2**2*(24*r**2 + r*(44*s - 37) + 20*s**2 - 29*s + 13) + k1**2*(4*Pk2*(52*r*s - 19*r + 52*s**2 - 61*s + 15) + Pkd2*k2*(-48*r*s + 23*r - 48*s**2 + 62*s - 18))) + f*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + k1**4*(Pk2*(4*C*(-2*r*(4*s + 1) + 8*s**2 + 2*s + 1) + K*(56*r*s - 28*r + 56*s**2 - 74*s + 22) + 56*r**2 + 232*r*s - 117*r + 144*s**2 - 150*s + 44) + Pkd2*k2*(C*(r*(32*s - 6) - 28*s + 6) + K*(-28*r*s + 14*r - 28*s**2 + 37*s - 11) + 13*r + 16*s**2 + 18*s - 12)) + k1**2*k2**2*(Pk2*(C*(200*r**2 + r*(656*s - 434) + 232*s**2 - 622*s + 226) - 2*K*(64*r**2 + 304*r*s - 134*r + 240*s**2 - 204*s + 49) - 132*r**2 - 356*r*s + 248*r - 112*s**2 + 326*s - 121) + Pkd2*k2*(-2*C*(r*(88*s - 7) + 88*s**2 - 56*s + 1) + 3*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) + 88*r*s - 11*r + 88*s**2 - 64*s + 5))) - k1**2*(b2*k2**2*(-13*Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(r*(156*s - 23) + s*(156*s - 71))) + 2*g2*(2*Pk2*k1**2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k2**2*(Pk2*(268*r**2 + 312*r*s - 413*r + 44*s**2 - 189*s + 145) + Pkd2*k2*(8*r*s - 69*r + 8*s**2 - 168*s + 75)))))) - f*(33*D1*bd1*(3*f**2*k1**2*(-4*Pk2*k2**2*(6*r**2 + r*(11*s - 9) + 5*s**2 - 7*s + 3) + k1**2*(4*Pk2*(26*r*s - 6*r + 26*s**2 - 25*s + 4) + Pkd2*k2*(-24*r*s + 10*r - 24*s**2 + 27*s - 6))) + 2*f*(Pk2*k2**4*r*(2 - 4*C) + k1**4*(2*Pk2*(4*C*s**2 + 2*C*s + K*(7*s - 3)*(r + s - 1) + 7*r**2 - r*(4*C*s + 2*C - 29*s + 10) + 18*s**2 - 16*s + 7) + Pkd2*k2*(8*C*r*s - 6*C*s - K*(7*s - 3)*(r + s - 1) + 4*s**2 + s - 2)) + k1**2*k2**2*(K*(-2*Pk2*(16*r**2 + 76*r*s - 28*r + 60*s**2 - 47*s + 12) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3)) + Pk2*(r**2*(50*C - 33) + r*(164*C*s - 58*C - 89*s + 40) + 2*s*(29*C*s - 55*C - 14*s + 28)) - Pkd2*k2*(2*C - 1)*(r*(22*s - 13) + 22*s**2 - 28*s + 7))) - 2*k1**2*(b2*k2**2*(-13*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(39*s - 23) + s*(39*s - 39))) + 2*g2*(2*Pk2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + k2**2*(Pk2*(67*r**2 + r*(78*s - 67) + s*(11*s - 11)) + 2*Pkd2*k2*(r*(s + 3) + s*(s - 1)))))) + 2*k1**2*(1836*C*D1*Pk2*f*fd*k1**2*r*s - 876*C*D1*Pk2*f*fd*k1**2*r + 1836*C*D1*Pk2*f*fd*k1**2*s**2 - 2364*C*D1*Pk2*f*fd*k1**2*s + 672*C*D1*Pk2*f*fd*k1**2 + 1548*C*D1*Pk2*f*fd*k2**2*r**2 - 15084*C*D1*Pk2*f*fd*k2**2*r*s + 2676*C*D1*Pk2*f*fd*k2**2*r - 11880*C*D1*Pk2*f*fd*k2**2*s**2 + 13608*C*D1*Pk2*f*fd*k2**2*s - 2604*C*D1*Pk2*f*fd*k2**2 - 918*C*D1*Pkd2*f*fd*k1**2*k2*r*s + 438*C*D1*Pkd2*f*fd*k1**2*k2*r - 918*C*D1*Pkd2*f*fd*k1**2*k2*s**2 + 1182*C*D1*Pkd2*f*fd*k1**2*k2*s - 336*C*D1*Pkd2*f*fd*k1**2*k2 + 4752*C*D1*Pkd2*f*fd*k2**3*r*s - 2376*C*D1*Pkd2*f*fd*k2**3*r + 4752*C*D1*Pkd2*f*fd*k2**3*s**2 - 5544*C*D1*Pkd2*f*fd*k2**3*s + 1584*C*D1*Pkd2*f*fd*k2**3 + 2448*C*Dd*Pk2*f**2*k1**2*r*s - 1176*C*Dd*Pk2*f**2*k1**2*r + 2448*C*Dd*Pk2*f**2*k1**2*s**2 - 3372*C*Dd*Pk2*f**2*k1**2*s + 972*C*Dd*Pk2*f**2*k1**2 + 2064*C*Dd*Pk2*f**2*k2**2*r**2 - 20112*C*Dd*Pk2*f**2*k2**2*r*s + 2364*C*Dd*Pk2*f**2*k2**2*r - 15840*C*Dd*Pk2*f**2*k2**2*s**2 + 18456*C*Dd*Pk2*f**2*k2**2*s - 2808*C*Dd*Pk2*f**2*k2**2 - 1224*C*Dd*Pkd2*f**2*k1**2*k2*r*s + 588*C*Dd*Pkd2*f**2*k1**2*k2*r - 1224*C*Dd*Pkd2*f**2*k1**2*k2*s**2 + 1686*C*Dd*Pkd2*f**2*k1**2*k2*s - 486*C*Dd*Pkd2*f**2*k1**2*k2 + 6336*C*Dd*Pkd2*f**2*k2**3*r*s - 2970*C*Dd*Pkd2*f**2*k2**3*r + 6336*C*Dd*Pkd2*f**2*k2**3*s**2 - 7524*C*Dd*Pkd2*f**2*k2**3*s + 2178*C*Dd*Pkd2*f**2*k2**3 + 351*D1*Pk2*f*fd*k1**2*r**2 + 2394*D1*Pk2*f*fd*k1**2*r*s - 1659*D1*Pk2*f*fd*k1**2*r + 2043*D1*Pk2*f*fd*k1**2*s**2 - 2622*D1*Pk2*f*fd*k1**2*s + 895*D1*Pk2*f*fd*k1**2 - 3447*D1*Pk2*f*fd*k2**2*r**2 + 3681*D1*Pk2*f*fd*k2**2*r*s + 1236*D1*Pk2*f*fd*k2**2*r + 4752*D1*Pk2*f*fd*k2**2*s**2 - 5418*D1*Pk2*f*fd*k2**2*s + 840*D1*Pk2*f*fd*k2**2 - 924*D1*Pk2*f*gd2*k1**2*r*s + 396*D1*Pk2*f*gd2*k1**2*r - 924*D1*Pk2*f*gd2*k1**2*s**2 + 1320*D1*Pk2*f*gd2*k1**2*s - 396*D1*Pk2*f*gd2*k1**2 + 2112*D1*Pk2*f*gd2*k2**2*r**2 + 10032*D1*Pk2*f*gd2*k2**2*r*s - 3696*D1*Pk2*f*gd2*k2**2*r + 7920*D1*Pk2*f*gd2*k2**2*s**2 - 6204*D1*Pk2*f*gd2*k2**2*s + 1584*D1*Pk2*f*gd2*k2**2 - 1848*D1*Pk2*fd*g2*k1**2*r*s + 1056*D1*Pk2*fd*g2*k1**2*r - 1848*D1*Pk2*fd*g2*k1**2*s**2 + 2244*D1*Pk2*fd*g2*k1**2*s - 660*D1*Pk2*fd*g2*k1**2 + 4224*D1*Pk2*fd*g2*k2**2*r**2 + 20064*D1*Pk2*fd*g2*k2**2*r*s - 10296*D1*Pk2*fd*g2*k2**2*r + 15840*D1*Pk2*fd*g2*k2**2*s**2 - 14520*D1*Pk2*fd*g2*k2**2*s + 3300*D1*Pk2*fd*g2*k2**2 - 36*D1*Pkd2*f*fd*k1**2*k2*r*s + 111*D1*Pkd2*f*fd*k1**2*k2*r - 36*D1*Pkd2*f*fd*k1**2*k2*s**2 + 102*D1*Pkd2*f*fd*k1**2*k2*s - 63*D1*Pkd2*f*fd*k1**2*k2 - 2376*D1*Pkd2*f*fd*k2**3*r*s + 1188*D1*Pkd2*f*fd*k2**3*r - 2376*D1*Pkd2*f*fd*k2**3*s**2 + 2772*D1*Pkd2*f*fd*k2**3*s - 792*D1*Pkd2*f*fd*k2**3 + 462*D1*Pkd2*f*gd2*k1**2*k2*r*s - 198*D1*Pkd2*f*gd2*k1**2*k2*r + 462*D1*Pkd2*f*gd2*k1**2*k2*s**2 - 660*D1*Pkd2*f*gd2*k1**2*k2*s + 198*D1*Pkd2*f*gd2*k1**2*k2 - 1584*D1*Pkd2*f*gd2*k2**3*r*s + 594*D1*Pkd2*f*gd2*k2**3*r - 1584*D1*Pkd2*f*gd2*k2**3*s**2 + 1980*D1*Pkd2*f*gd2*k2**3*s - 594*D1*Pkd2*f*gd2*k2**3 + 924*D1*Pkd2*fd*g2*k1**2*k2*r*s - 528*D1*Pkd2*fd*g2*k1**2*k2*r + 924*D1*Pkd2*fd*g2*k1**2*k2*s**2 - 1122*D1*Pkd2*fd*g2*k1**2*k2*s + 330*D1*Pkd2*fd*g2*k1**2*k2 - 3168*D1*Pkd2*fd*g2*k2**3*r*s + 1782*D1*Pkd2*fd*g2*k2**3*r - 3168*D1*Pkd2*fd*g2*k2**3*s**2 + 3564*D1*Pkd2*fd*g2*k2**3*s - 990*D1*Pkd2*fd*g2*k2**3 + 33*D1*bd2*f*(k1**2*(2*Pk2 - Pkd2*k2)*(7*s - 3)*(r + s - 1) + k2**2*(-2*Pk2*(16*r**2 + 76*r*s - 28*r + 60*s**2 - 47*s + 12) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 10*s + 3))) + 468*Dd*Pk2*f**2*k1**2*r**2 + 3192*Dd*Pk2*f**2*k1**2*r*s - 2058*Dd*Pk2*f**2*k1**2*r + 2724*Dd*Pk2*f**2*k1**2*s**2 - 3337*Dd*Pk2*f**2*k1**2*s + 1177*Dd*Pk2*f**2*k1**2 - 4596*Dd*Pk2*f**2*k2**2*r**2 + 4908*Dd*Pk2*f**2*k2**2*r*s + 2547*Dd*Pk2*f**2*k2**2*r + 6336*Dd*Pk2*f**2*k2**2*s**2 - 7248*Dd*Pk2*f**2*k2**2*s + 678*Dd*Pk2*f**2*k2**2 - 3696*Dd*Pk2*f*g2*k1**2*r*s + 1848*Dd*Pk2*f*g2*k1**2*r - 3696*Dd*Pk2*f*g2*k1**2*s**2 + 4884*Dd*Pk2*f*g2*k1**2*s - 1452*Dd*Pk2*f*g2*k1**2 + 8448*Dd*Pk2*f*g2*k2**2*r**2 + 40128*Dd*Pk2*f*g2*k2**2*r*s - 17688*Dd*Pk2*f*g2*k2**2*r + 31680*Dd*Pk2*f*g2*k2**2*s**2 - 26928*Dd*Pk2*f*g2*k2**2*s + 6468*Dd*Pk2*f*g2*k2**2 - 48*Dd*Pkd2*f**2*k1**2*k2*r*s + 135*Dd*Pkd2*f**2*k1**2*k2*r - 48*Dd*Pkd2*f**2*k1**2*k2*s**2 + 114*Dd*Pkd2*f**2*k1**2*k2*s - 87*Dd*Pkd2*f**2*k1**2*k2 - 3168*Dd*Pkd2*f**2*k2**3*r*s + 1485*Dd*Pkd2*f**2*k2**3*r - 3168*Dd*Pkd2*f**2*k2**3*s**2 + 3762*Dd*Pkd2*f**2*k2**3*s - 1089*Dd*Pkd2*f**2*k2**3 + 1848*Dd*Pkd2*f*g2*k1**2*k2*r*s - 924*Dd*Pkd2*f*g2*k1**2*k2*r + 1848*Dd*Pkd2*f*g2*k1**2*k2*s**2 - 2442*Dd*Pkd2*f*g2*k1**2*k2*s + 726*Dd*Pkd2*f*g2*k1**2*k2 - 6336*Dd*Pkd2*f*g2*k2**3*r*s + 2970*Dd*Pkd2*f*g2*k2**3*r - 6336*Dd*Pkd2*f*g2*k2**3*s**2 + 7524*Dd*Pkd2*f*g2*k2**3*s - 2178*Dd*Pkd2*f*g2*k2**3 + 33*b2*(D1*fd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*r*(7*s - 4) + 14*s**2 - 17*s + 5) + k2**2*(-2*Pk2*(32*r**2 + 152*r*s - 78*r + 120*s**2 - 110*s + 25) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))) + Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(14*r*(2*s - 1) + 28*s**2 - 37*s + 11) + k2**2*(-2*Pk2*(64*r**2 + 304*r*s - 134*r + 240*s**2 - 204*s + 49) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11)))))))/(693*d**2*k1*k2*k3**3) - 2*D1**3*Pkd3*ct*(b1**3*k1**2*(2*D1*fd*(k1**2*(Pk2*(r + s - 1) + 2*Pkd2*k2*s) + 7*k2**2*(Pk2*(2*r + s - 2) + Pkd2*k2*s))*(r + s - 1) + Dd*f*(2*k1**2*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(8*r*s - r + 8*s**2 - 8*s + 1)) + 7*k2**2*(2*Pk2*(8*r**2 + 3*r*(4*s - 5) + 4*s**2 - 13*s + 7) + Pkd2*k2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)))) + b1**2*(D1*bd1*f*k1**2*(2*k1**2*(Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + Pkd2*k2*(6*r*s - r + 6*s**2 - 6*s + 1)) + 7*k2**2*(2*Pk2*(6*r**2 + 9*r*s - 11*r + 3*s**2 - 10*s + 5) + Pkd2*k2*(6*r*s - r + 6*s**2 - 6*s + 1))) - D1*fd*(Pk2*k2**4*(4*C - 2)*(r - 1)*(3*r - 4*s - 3) + k1**4*(Pk2*f*(180*r**2 + r*(168*s - 253) - 12*s**2 - 89*s + 101) + 2*Pk2*(8*r**2 + r*(s*(8*C - 2) + 2) + s**2*(8*C - 10) + s*(10 - 8*C) - 1) + 6*Pkd2*f*k2*(4*r*(4*s + 1) + 16*s**2 - 7*s - 4) + 2*Pkd2*k2*s*(-28*C*(r - 1) - 2*K*s + r*(21 - 2*K) + 7*s - 14)) + k1**2*k2**2*(Pk2*(C*(48*r**2 - 4*r*(167*s + 24) + 40*s**2 + 668*s + 48) + 14*K*r**2 + 56*K*r*s - 112*K*r + 42*K*s**2 - 140*K*s + 70*K + 13*f*(8*r**2 + 8*r*s - 7*r + s + 1) + r**2 + 355*r*s + 103*r - 24*s**2 - 278*s - 55) - 2*Pkd2*k2*(7*K*(2*r*s + r + 2*s**2 + 2*s - 1) + s*(4*C - 2)*(6*r - s - 6)))) - Dd*f*(Pk2*k2**4*(16*C - 8)*(3*r**2 - 4*r*(s + 1) + 3*s + 1) + 2*k1**4*(Pk2*(4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + f*(180*r**2 + 168*r*s - 247*r - 12*s**2 - 83*s + 79) + 32*r**2 - 8*r*s - 18*r - 40*s**2 + 46*s - 7) + Pkd2*k2*(-14*C*(r*(8*s - 1) - 6*s + 1) - 8*K*r*s + K*r - 8*K*s**2 + 4*K*s + 6*f*(16*r*s + 3*r + 16*s**2 - 10*s - 2) + 84*r*s - 7*r + 28*s**2 - 63*s + 7)) + k1**2*k2**2*(Pk2*(8*C*(24*r**2 + r*(11 - 334*s) + 20*s**2 + 256*s - 35) + 56*K*r**2 + 224*K*r*s - 238*K*r + 168*K*s**2 - 350*K*s + 154*K + 26*f*(8*r**2 + 8*r*(s - 1) + 1) + 4*r**2 + 1420*r*s - 40*r - 96*s**2 - 894*s + 71) - 2*Pkd2*k2*(4*C*(3*r*(8*s - 1) - 4*s**2 - 17*s + 3) + 7*K*(8*r*s + 3*r + 8*s**2 - 3) - 48*r*s + 6*r + 8*s**2 + 34*s - 6)))) + b1*(-D1*bd1*f*(Pk2*k2**4*(8*C - 4)*(3*r**2 - 2*r*(2*s + 1) + 2*s - 1) + k1**4*(Pk2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + f*(180*r**2 + 168*r*s - 241*r - 12*s**2 - 77*s + 57) + 32*r**2 - 8*r*s - 26*r - 40*s**2 + 46*s - 10) + 2*Pkd2*k2*(-14*C*(r*(4*s - 1) - 2*s + 1) - 4*K*s**2 + 3*K*s + 48*f*s**2 - 39*f*s + r*(-4*K*s + K + 48*f*s + 6*f + 42*s - 7) + 14*s**2 - 28*s + 7)) + k1**2*k2**2*(Pk2*(8*C*(12*r**2 + r*(35 - 167*s) + 10*s**2 + 89*s - 47) + 14*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 9*s + 3) + 13*f*(8*r - 1)*(r + s - 1) + 2*r**2 + 710*r*s - 176*r - 48*s**2 - 296*s + 160) - 2*Pkd2*k2*(4*C*(3*r*(4*s - 1) - 2*s**2 - 5*s + 3) + 7*K*(4*r*s + r + 4*s**2 - 2*s - 1) - 24*r*s + 6*r + 4*s**2 + 10*s - 6))) + D1*(-66*Pk2*f**2*fd*k1**4*(3*s - 1)*(r + s - 1) + f*(fd*(Pk2*k2**4*(4*C - 2)*(2*r - 1) + k1**4*(Pk2*(8*C*(r*(26*s - 7) - 20*s + 7) + 2*K*(2*s - 1)*(3*r + 3*s - 1) - 128*r**2 - 342*r*s + 169*r - 110*s**2 + 239*s - 79) + 4*Pkd2*k2*(3*K*(s - 1) + s*(4*C - 5))*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(4*C*(66*r**2 + r*(34*s - 27) - 32*s**2 + 61*s - 19) + 26*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 210*r**2 - 146*r*s + 56*r + 64*s**2 - 170*s + 63) + Pkd2*k2*(48*C - 24)*(2*r*s + r + 2*s**2 + s - 1))) + 2*k1**2*k2*(bd2*(7*Pk2*k2*(r**2 + 2*r*s + s**2 - 1) + Pkd2*k1**2*s*(2*r + 2*s - 1) + 7*Pkd2*k2**2*s*(3*r + 3*s - 2)) - 2*gd2*(-7*Pk2*k2*(r**2 + 4*r*(s - 1) + 3*(s - 1)**2) + Pkd2*k1**2*s*(2*r + 2*s - 1) + 7*Pkd2*k2**2*(2*r*s + r + 2*s**2 - 1)))) + 2*fd*k1**2*k2*(b2*(7*Pk2*k2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) + 2*Pkd2*k1**2*s*(r + s) + 21*Pkd2*k2**2*s*(r + s)) - 2*g2*(-7*Pk2*k2*(r**2 + 4*r*(s - 2) + 3*s**2 - 10*s + 5) + 2*Pkd2*k1**2*s*(r + s) + 7*Pkd2*k2**2*(2*r*s + r + 2*s**2 + 2*s - 1)))) + Dd*f*(-66*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + f*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + k1**4*(Pk2*(8*C*(r*(52*s - 7) - 40*s + 7) + 2*K*(4*s - 1)*(3*r + 3*s - 1) - 256*r**2 - 684*r*s + 359*r - 220*s**2 + 483*s - 137) + 2*Pkd2*k2*(C*(4*r*(8*s - 1) + 32*s**2 - 24*s + 2) + 6*K*(s - 1)*(4*r + 4*s - 3) - 40*r*s + 2*r - 40*s**2 + 30*s - 1)) + k1**2*k2**2*(Pk2*(8*C*(66*r**2 + r*(34*s - 63) - 32*s**2 + 23*s + 7) + 26*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) - 420*r**2 - 292*r*s + 342*r + 128*s**2 - 138*s - 3) + Pkd2*k2*(24*C - 12)*(r*(8*s + 3) + 8*s**2 - 3))) + 2*k1**2*k2*(b2*(7*Pk2*k2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + Pkd2*k1**2*(r*(8*s - 1) + 4*s*(2*s - 1)) + 7*Pkd2*k2**2*(r*(12*s - 1) + s*(12*s - 7))) - 2*g2*(-7*Pk2*k2*(4*r**2 + 16*r*s - 17*r + 12*s**2 - 25*s + 11) + Pkd2*k1**2*(8*r*s - r + 8*s**2 - 4*s) + 7*Pkd2*k2**2*(8*r*s + 3*r + 8*s**2 - 3))))) + f*(D1*bd1*(-66*Pk2*f**2*k1**4*s*(r + s - 1) + f*(Pk2*k2**4*r*(4*C - 2) + k1**4*(Pk2*(-64*r**2 + r*(s*(104*C + 6*K - 171) + 100) + s**2*(6*K - 55) + s*(-56*C - 2*K + 115) - 32) + 2*Pkd2*k2*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*K*(s - 1)*(r + s - 1) - 10*r*s + 2*r - 10*s**2 + 11*s - 1)) + k1**2*k2**2*(Pk2*(4*C*(33*r**2 + 17*r*s - 53*r - 16*s**2 - 18*s + 20) + 26*K*(r**2 + 4*r*s - 2*r + 3*s**2 - 3*s + 1) - 105*r**2 - 73*r*s + 155*r + 32*s**2 + 36*s - 40) + Pkd2*k2*s*(48*C - 24)*(r + s - 1))) + 2*k1**2*k2*(b2*(7*Pk2*k2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k1**2*(r*(2*s - 1) + s*(2*s - 2)) + 7*Pkd2*k2**2*(r*(3*s - 1) + s*(3*s - 3))) + 2*g2*(7*Pk2*k2*(r**2 + r*(4*s - 1) + s*(3*s - 3)) + Pkd2*k1**2*(-2*r*s + r - s*(2*s - 2)) - 14*Pkd2*k2**2*s*(r + s - 1)))) + k1**2*(D1*(f*(fd*(Pk2*k2**2*(4*C - 2)*(36*r**2 + 27*r*(5*s - 3) + 99*s**2 - 111*s + 34) + k1**2*(Pk2*(4*C*(3*s - 1)*(5*r + 5*s - 3) - 30*r**2 - 123*r*s + 51*r - 93*s**2 + 112*s - 27) + Pkd2*k2*(20*C - 10)*(s - 1)*(3*r + 3*s - 2))) + (2*bd2 - 4*gd2)*(Pk2*k1**2*s*(3*r + 3*s - 1) + 13*Pk2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + 6*Pkd2*k1**2*k2*(s - 1)*(r + s - 1))) - 4*fd*g2*(13*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(Pk2*(2*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)))) + Dd*f*(Pk2*f*k2**2*(4*C - 2)*(48*r**2 + 15*r*(12*s - 7) + 132*s**2 - 145*s + 46) - 52*Pk2*g2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + f*k1**2*(Pk2*(4*C*(4*s - 1)*(5*r + 5*s - 3) - 40*r**2 - 164*r*s + 61*r - 124*s**2 + 139*s - 27) + Pkd2*k2*(20*C - 10)*(s - 1)*(4*r + 4*s - 3)) - 4*g2*k1**2*(Pk2*(4*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(4*r + 4*s - 3))) + 2*b2*(D1*fd*(13*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + k1**2*(Pk2*(2*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))) + Dd*f*(13*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + k1**2*(Pk2*(4*s - 1)*(3*r + 3*s - 1) + 6*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(21*d**2*k1*k2*k3**3) + 2*D1**3*Pkd3*ct*st**4*(D1*(2574*b1*fd*k1**2*k2**4*(-Pk2*b1*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 4*r*s + 10*r + 10*s - 5) + 4*Pk2*g2*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 2*Pkd2*b1*k2*s*(2*K - 1)*(r + s) - 8*Pkd2*g2*k2*s*(r + s)) + f**3*k1**2*(39*bd1*k2**2*(33*Pk2*k2**2*(9*r**2 + 2*r*(7*s - 8) + 5*s**2 - 16*s + 7) + 10*k1**2*(Pk2*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) + 2*Pkd2*k2*(r*(6*s + 3) + 6*s**2 - 2*s - 1))) + fd*(1300*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(7912*s - 2199) + 7912*s**2 - 8380*s + 1711) + 39*k1**2*k2**2*(-Pk2*(1524*r**2 + r*(5784*s - 2867) + 4260*s**2 - 4959*s + 1303) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35)))) + 39*f**2*k2**2*(fd*(Pk2*k2**4*(4*C - 2)*(3*r - 1)*(27*r + 60*s - 7) + 6*k1**4*(Pk2*(5*b1*(135*r**2 + 6*r*(41*s - 31) + 111*s**2 - 170*s + 69) + (-18*r - 18*s + 12)*(-4*C*s + r*(4*C - 9) - 3*s + 4)) + 2*Pkd2*k2*(10*b1*(s - 1) - (4*C - 3)*(3*s - 1))*(3*r + 3*s - 2)) + k1**2*k2**2*(Pk2*(-4*C*(1422*r**2 + 21*r*(105*s - 88) + 1080*s**2 - 1455*s + 578) + 33*b1*(27*r**2 + 3*r*(14*s - 9) + 15*s**2 - 27*s + 8) + 3366*r**2 + 5112*r*s - 4344*r + 2340*s**2 - 3264*s + 1334) + Pkd2*k2*(60 - 120*C)*(3*s - 1)*(3*r + 3*s - 2))) + 33*k1**2*(-10*Pk2*bd2*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(2*Pk2*k1**2*(r**2*(7 - 2*K) + r*(2*K + 12*s - 7) + s*(2*K*(s + 2) + 5*s - 9)) + Pk2*k2**2*(-2*K*(35*r**2 + 46*r*(s - 1) + 11*s**2 - 32*s + 11) - 5*b1*(r + s - 1) + 48*r**2 + 64*r*s - 66*r + 16*s**2 - 46*s + 18) + Pkd2*k1**2*k2*s*(2 - 4*K)*(r + s) + Pkd2*k2**3*(-4*K*(6*r*s - r + 6*s**2 - 5*s + 1) + b1*(4*s - 1)*(r + s - 1) + 8*r*s - 2*r + 8*s**2 - 8*s + 2)) + 4*gd2*(2*Pk2*k1**2*(r**2 - r - s*(s + 2)) + Pk2*k2**2*(35*r**2 + 46*r*(s - 1) + 11*s**2 - 32*s + 11) + 2*Pkd2*k1**2*k2*s*(r + s) + 2*Pkd2*k2**3*(r*(6*s - 1) + 6*s**2 - 5*s + 1)))) + 1287*f*k1**2*k2**2*(-10*Pk2*b2*fd*k2**2*(6*r**2 + r*(12*s - 5) + 6*s**2 - 5*s + 1) + b1**2*fd*k2**2*(5*Pk2*(r + s - 1) + Pkd2*k2*s*(4*r + 4*s - 3)) + 2*b1*(bd1*k2**2*(Pk2*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5) + Pkd2*k2*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - fd*(Pk2*k1**2*(r**2*(4*K - 14) + r*(4*K - 24*s + 3) - s*(2*K + 5)*(2*s - 1)) + Pk2*k2**2*(K*(70*r**2 + r*(92*s - 39) + 22*s**2 - 17*s + 3) - 48*r**2 + r*(31 - 64*s) - 4*(1 - 2*s)**2) + Pkd2*k1**2*k2*(2*K - 1)*(r + s)*(2*s - 1) + Pkd2*k2**3*(K*(r*(24*s - 11) + 24*s**2 - 22*s + 5) + (2 - 4*s)*(2*r + 2*s - 1))) - 4*gd2*k2**2*(-Pk2*(3*r**2 + 8*r*(s - 1) + 5*s**2 - 9*s + 5) + Pkd2*k2*s*(2*r + 2*s - 1))) + 4*g2*(2*bd1*k2**2*(Pk2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))) + fd*(2*Pk2*k1**2*(2*r**2 + 2*r - 2*s**2 + s) + Pk2*k2**2*(70*r**2 + 92*r*s - 39*r + 22*s**2 - 17*s + 3) + 2*Pkd2*k1**2*k2*(r + s)*(2*s - 1) + Pkd2*k2**3*(24*r*s - 11*r + 24*s**2 - 22*s + 5))))) + Dd*f*(2574*b1*k1**2*k2**4*(-Pk2*b1*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15) + Pkd2*b1*k2*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 4*g2*(Pk2*(12*r**2 + r*(32*s - 30) + 20*s**2 - 33*s + 15) + Pkd2*k2*(-8*r*s + r + s*(4 - 8*s)))) + f**3*k1**2*(1300*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(r*(7912*s - 2199) + 7912*s**2 - 8380*s + 1711) + 39*k1**2*k2**2*(-Pk2*(1524*r**2 + r*(5784*s - 2867) + 4260*s**2 - 4959*s + 1303) + 5*Pkd2*k2*(r*(144*s - 47) + 144*s**2 - 154*s + 35))) + 39*f**2*k2**2*(Pk2*k2**4*(16*C - 8)*(27*r**2 + 6*r*(10*s - 3) - 25*s + 1) + 2*k1**4*(Pk2*(-24*C*(12*r**2 - 10*r - 12*s**2 + 7*s + 1) + 5*b1*(540*r**2 + r*(984*s - 765) + 444*s**2 - 697*s + 271) + 648*r**2 + 18*r*(48*s - 44) + 216*s**2 - 486*s + 234) + Pkd2*k2*(10*b1*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) - (12*C - 9)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + k1**2*k2**2*(Pk2*(-8*C*(948*r**2 + 6*r*(245*s - 221) + 720*s**2 - 1027*s + 454) + 33*b1*(36*r**2 + r*(56*s - 43) + 20*s**2 - 43*s + 15) + 4488*r**2 + 6816*r*s - 6256*r + 3120*s**2 - 4660*s + 2124) + Pkd2*k2*(30 - 60*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 1287*f*k1**2*k2**2*(-10*Pk2*b2*k2**2*(12*r**2 + r*(24*s - 13) + 12*s**2 - 13*s + 3) + Pkd2*b1**2*k2**3*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 2*b1*(Pk2*k1**2*(r**2*(8*K - 28) + r*(17 - 48*s) - s*(8*K*s + 6*K + 20*s - 23)) + Pk2*k2**2*(K*(140*r**2 + 184*r*s - 131*r + 44*s**2 - 81*s + 25) - 96*r**2 - 128*r*s + 97*r - 32*s**2 + 62*s - 22) + Pkd2*k1**2*k2*(2*K - 1)*(r + s)*(4*s - 1) + Pkd2*k2**3*(3*K*(16*r*s - 5*r + 16*s**2 - 14*s + 3) - 16*r*s + 6*r - 16*s**2 + 16*s - 4)) + 4*g2*(2*Pk2*k1**2*(4*r**2 - s*(4*s + 3)) + Pk2*k2**2*(140*r**2 + r*(184*s - 131) + 44*s**2 - 81*s + 25) + 2*Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 3*Pkd2*k2**3*(r*(16*s - 5) + 16*s**2 - 14*s + 3)))))/(9009*d**2*k1*k2*k3**5) + D1**3*Pkd3*ct*st**2*(3*D1*bd1*f*(f**2*k1**2*(-132*Pk2*k2**4*(4*r**2 + 9*r*(s - 1) + 5*s**2 - 9*s + 4) + k1**4*(4*Pk2*(45*r**2 + 287*r*s - 104*r + 242*s**2 - 281*s + 47) + Pkd2*k2*(-394*r*s + 33*r - 394*s**2 + 387*s - 9)) - 11*k1**2*k2**2*(Pk2*(302*r**2 + 524*r*s - 423*r + 222*s**2 - 387*s + 121) + 3*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 13*s + 7))) - 11*f*(-2*Pk2*k1**6*(r + s - 1)*(K*(2 - 4*s) + 5*r + 9*s - 7) + Pk2*k2**6*r*(4 - 8*C)*(3*r + 3*s - 2) - k1**4*k2**2*(Pk2*(-8*C*(4*r**2 - 2*r*(12*s + 5) + 2*s**2 + 8*s + 5) - 2*K*(85*r**2 + 250*r*s - 148*r + 165*s**2 - 182*s + 63) + 5*b1*(92*r**2 + r*(184*s - 137) + 92*s**2 - 137*s + 45) + 92*r**2 + 132*r*s - 156*r + 160*s**2 - 112*s + 56) + Pkd2*k2*(-4*C*(r*(22*s - 9) + 18*s**2 - 23*s + 5) + 6*K*(s - 1)*(r + s - 1) + b1*(3*r*(64*s - 13) + 192*s**2 - 187*s + 17) + 52*r*s - 18*r + 44*s**2 - 50*s + 6)) + k1**2*k2**4*(-Pk2*(-4*C*(89*r**2 + r*(236*s - 195) + 119*s**2 - 193*s + 94) + 2*K*(85*r**2 + 44*r*(2*s - 3) + 3*s**2 - 98*s + 47) + b1*(144*r**2 + r*(192*s - 143) + 48*s**2 - 143*s + 47) + 166*r**2 + 474*r*s - 378*r + 252*s**2 - 396*s + 188) + Pkd2*k2*(4*C*(25*r*s - 12*r + 21*s**2 - 28*s + 7) - 6*K*(r*(8*s - 3) + 8*s**2 - 10*s + 3) + b1*(9*r*(4*s - 1) + 36*s**2 - 33*s + 3) - 46*r*s + 22*r - 38*s**2 + 52*s - 14))) - 11*k1**2*k2**2*(65*Pk2*b1**2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 260*Pk2*b2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(k1**2*(Pk2*(2*K*(16*r**2 + 32*r*s - 4*r + 16*s**2 - 18*s - 5) - 172*r**2 - 344*r*s + 153*r - 172*s**2 + 181*s + 5) + Pkd2*k2*(4*K - 2)*(r*(13*s - 5) + s*(13*s - 8))) + k2**2*(-Pk2*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-258*r**2 - 512*r*s + 115*r - 254*s**2 + 127*s + 135) + 132*r**2 + 156*r*s - 48*r + 24*s**2 - 8*s - 50) + Pkd2*k2*(r*(K*(134*s - 37) - 28*s + 7) + s*(K*(134*s - 97) - 28*s + 21)))) - 4*g2*(2*k1**2*(Pk2*(8*r**2 + r*(16*s - 1) + s*(8*s - 8)) + Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + k2**2*(Pk2*(129*r**2 + r*(256*s - 121) + s*(127*s - 127)) + Pkd2*k2*(r*(67*s - 37) + s*(67*s - 67)))))) - 2145*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(Pk2*(-4*K*(8*r**2 + 2*r*(8*s + 5) + 8*s**2 + 10*s - 5) + 5*f*(92*r**2 + r*(184*s - 97) + 92*s**2 - 97*s + 27) + 172*r**2 + 4*r*(86*s + 5) + 172*s**2 + 20*s - 10) + Pkd2*k2*s*(f*(192*r + 192*s - 91) + (26 - 52*K)*(r + s))) + k2**2*(Pk2*(40*C*(r + s - 1)**2 - 2*K*(129*r**2 + r*(256*s + 270) + 127*s**2 + 270*s - 135) + f*(144*r**2 + r*(192*s - 233) + 48*s**2 - 209*s + 103) + 132*r**2 + 4*r*(39*s + 50) + 24*s**2 + 200*s - 100) + Pkd2*k2*s*(-3*f*(12*r + 12*s - 5) + (28 - 134*K)*(r + s)))) + Dd*f*(k1**2*(2*Pk2*(-2*K*(32*r**2 + 64*r*s + 3*r + 32*s**2 - 18*s - 15) + 5*f*(92*r**2 + r*(184*s - 117) + 92*s**2 - 117*s + 36) + 344*r**2 + 688*r*s - 224*r + 344*s**2 - 266*s - 15) + Pkd2*k2*(f*(r*(384*s - 39) + 384*s**2 - 278*s + 17) + (2 - 4*K)*(2*r*(26*s - 5) + s*(52*s - 19)))) + k2**2*(2*Pk2*(20*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 516*K*r**2 - 1024*K*r*s - 161*K*r - 508*K*s**2 - 143*K*s + 405*K + f*(144*r**2 + 4*r*(48*s - 47) + 48*s**2 - 176*s + 75) + 264*r**2 + 312*r*s + 36*r + 48*s**2 + 96*s - 150) + Pkd2*k2*(f*(r*(9 - 72*s) - 72*s**2 + 48*s - 3) + 2*r*(-268*K*s + 37*K + 56*s - 7) + 2*s*(-268*K*s + 127*K + 56*s - 28))))) + 3*b1*(D1*(f**2*fd*k1**2*(-132*Pk2*k2**4*(12*r**2 + r*(27*s - 16) + 15*s**2 - 16*s + 5) + k1**4*(Pk2*(540*r**2 + 14*r*(246*s - 67) + 2904*s**2 - 2448*s + 386) + Pkd2*k2*(-2*r*(591*s + 73) - 1182*s**2 + 609*s + 112)) - 11*k1**2*k2**2*(Pk2*(906*r**2 + 1572*r*s - 1283*r + 666*s**2 - 1127*s + 491) + 3*Pkd2*k2*(24*r*s - 45*r + 24*s**2 - 67*s + 31))) - 22*f*(fd*(Pk2*k1**6*(2*K*(r*(4*s - 3) + 4*s**2 - 6*s + 2) - 10*r**2 - 28*r*s + 21*r - 18*s**2 + 27*s - 9) + Pk2*k2**6*(2 - 4*C)*(6*r**2 + r*(6*s - 3) - s) + k1**4*k2**2*(Pk2*(4*C*(8*r**2 - 6*r*(8*s - 3) + 4*s**2 + 50*s - 21) + K*(170*r**2 + 500*r*s - 273*r + 330*s**2 - 323*s + 79) - 92*r**2 - 132*r*s + 48*r - 160*s**2 + 7*s + 29) + Pkd2*k2*(72*C*s**2 - 46*C*s - 3*K*(s - 1)*(2*r + 2*s - 1) + r*(88*C*s - 52*s - 7) - 44*s**2 + 18*s + 4)) + k1**2*k2**4*(Pk2*(4*C*(89*r**2 + r*(236*s - 51) + 119*s**2 - 94*s - 8) - K*(170*r**2 + 176*r*s - 109*r + 6*s**2 - 53*s + 25) - 166*r**2 - 474*r*s + 133*r - 252*s**2 + 226*s - 6) + Pkd2*k2*(-3*K*(r*(16*s - 9) + 16*s**2 - 18*s + 5) + 2*s*(C*(50*r + 42*s - 27) - 23*r - 19*s + 13)))) - 2*k1**2*k2**2*(-65*Pk2*bd2*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(2*k1**2*(Pk2*(8*r**2 + 16*r*s - 3*r + 8*s**2 - 10*s - 5) + Pkd2*k2*s*(13*r + 13*s - 3)) + k2**2*(Pk2*(129*r**2 + 256*r*s + 6*r + 127*s**2 - 135) + Pkd2*k2*s*(67*r + 67*s - 30))))) + 44*fd*k1**2*k2**2*(-65*Pk2*b2*k2**2*(r + s)**2 + 2*g2*k1**2*(Pk2*(8*r**2 + 2*r*(8*s + 5) + 8*s**2 + 10*s - 5) + 13*Pkd2*k2*s*(r + s)) + g2*k2**2*(Pk2*(129*r**2 + r*(256*s + 270) + 127*s**2 + 270*s - 135) + 67*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-132*Pk2*k2**4*(16*r**2 + r*(36*s - 25) + 20*s**2 - 25*s + 9) + k1**4*(2*Pk2*(360*r**2 + 2296*r*s - 677*r + 1936*s**2 - 1786*s + 287) + Pkd2*k2*(-1576*r*s - 113*r - 1576*s**2 + 996*s + 103)) - 22*k1**2*k2**2*(Pk2*(604*r**2 + r*(1048*s - 853) + 444*s**2 - 757*s + 306) + 3*Pkd2*k2*(8*r*(2*s - 3) + 16*s**2 - 40*s + 19))) - 22*f*(Pk2*k1**6*(2*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 20*r**2 + r*(45 - 56*s) - 36*s**2 + 59*s - 23) + Pk2*k2**6*(4 - 8*C)*(6*r**2 + r*(6*s - 4) - s) + k1**4*k2**2*(Pk2*(4*C*(16*r**2 + r*(5 - 96*s) + 8*s**2 + 88*s - 17) + K*(340*r**2 + 1000*r*s - 569*r + 660*s**2 - 687*s + 205) - 184*r**2 - 264*r*s + 181*r - 320*s**2 + 66*s - 8) + Pkd2*k2*(2*C*(r*(88*s - 9) + 72*s**2 - 64*s + 5) - 3*K*(s - 1)*(4*r + 4*s - 3) - 104*r*s - r - 88*s**2 + 60*s + 4)) + k1**2*k2**4*(Pk2*(2*C*(356*r**2 + r*(944*s - 415) + 476*s**2 - 545*s + 107) - K*(340*r**2 + 352*r*s - 373*r + 12*s**2 - 249*s + 119) - 332*r**2 - 948*r*s + 447*r - 504*s**2 + 606*s - 142) + Pkd2*k2*(2*C*(4*r*(25*s - 3) + 84*s**2 - 75*s + 7) - 3*K*(32*r*s - 15*r + 32*s**2 - 38*s + 11) - 92*r*s + 11*r - 76*s**2 + 71*s - 7))) + 44*k1**2*k2**2*(-65*Pk2*b2*k2**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*k1**2*(Pk2*(32*r**2 + r*(64*s + 3) + 32*s**2 - 18*s - 15) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))) + k2**2*(Pk2*(516*r**2 + r*(1024*s + 161) + 508*s**2 + 143*s - 405) + Pkd2*k2*(r*(268*s - 37) + s*(268*s - 127))))))) + f*k1**2*(D1*(3*f**2*fd*k1**2*(108*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(200*r**2 - 1280*r*s + 384*r - 1480*s**2 + 1710*s - 417) + 25*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(165*Pk2*bd2*k2**2*(k1**2*(13*r + 13*s - 9) - 3*k2**2*(5*r + 5*s - 3))*(r + s - 1) + Pk2*fd*k1**4*(4*C*(6*r*(9*s - 14) + 54*s**2 - 153*s + 67) - 135*r**2 - 3*r*(162*s - 227) - 351*s**2 + 957*s - 438) + fd*k1**2*k2**2*(Pk2*(2*C*(2817*r**2 + 11646*r*s - 6915*r + 6453*s**2 - 10395*s + 3446) - 198*r**2 - 8424*r*s + 4557*r - 5850*s**2 + 9348*s - 3027) - 3*Pkd2*k2*(2*C*(59*s - 49)*(3*r + 3*s - 2) - 342*r*s + 257*r - 342*s**2 + 496*s - 175)) - 3*fd*k2**4*(Pk2*(2*C*(4515*r**2 + 6594*r*s - 5197*r + 2871*s**2 - 3639*s + 1392) - 5406*r**2 - 7881*r*s + 6055*r - 3267*s**2 + 4101*s - 1546) + Pkd2*k2*(264*C - 132)*(2*s - 1)*(3*r + 3*s - 2)) - 66*gd2*(2*Pk2*k1**4*(2*s - 1)*(r + s - 1) + k1**2*k2**2*(Pk2*(85*r**2 + 250*r*s - 148*r + 165*s**2 - 182*s + 63) - 3*Pkd2*k2*(s - 1)*(r + s - 1)) - k2**4*(Pk2*(85*r**2 + 44*r*(2*s - 3) + 3*s**2 - 98*s + 47) + 3*Pkd2*k2*(r*(8*s - 3) + 8*s**2 - 10*s + 3)))) + 66*fd*(5*Pk2*b2*k2**2*(k1**2*(-13*r - 13*s + 9) + 3*k2**2*(5*r + 5*s - 3))*(2*r + 2*s - 1) + 2*g2*(2*Pk2*k1**4*(r*(4*s - 3) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(Pk2*(170*r**2 + 500*r*s - 273*r + 330*s**2 - 323*s + 79) - 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1)) - k2**4*(Pk2*(170*r**2 + 176*r*s - 109*r + 6*s**2 - 53*s + 25) + 3*Pkd2*k2*(16*r*s - 9*r + 16*s**2 - 18*s + 5))))) + Dd*f*(-330*Pk2*b2*k2**2*(k1**2*(13*r + 13*s - 9) - 3*k2**2*(5*r + 5*s - 3))*(4*r + 4*s - 3) + 3*f**2*k1**2*(108*Pk2*k2**2*(48*r**2 + r*(108*s - 79) + 60*s**2 - 83*s + 31) + k1**2*(4*Pk2*(200*r**2 - 1280*r*s + 384*r - 1480*s**2 + 1710*s - 417) + 25*Pkd2*k2*(72*r*s - 35*r + 72*s**2 - 92*s + 27))) - 2*f*(Pk2*k1**4*(4*C*(72*r*s - 109*r + 72*s**2 - 204*s + 92) - 180*r**2 - 648*r*s + 911*r - 468*s**2 + 1291*s - 623) + k1**2*k2**2*(Pk2*(2*C*(3756*r**2 + 15528*r*s - 9111*r + 8604*s**2 - 14261*s + 4703) - 264*r**2 - 11232*r*s + 5553*r - 7800*s**2 + 12552*s - 3957) - 3*Pkd2*k2*(C*(8*r*(59*s - 47) + 472*s**2 - 714*s + 278) - 456*r*s + 331*r - 456*s**2 + 676*s - 249)) - 3*k2**4*(Pk2*(2*C*(6020*r**2 + 8792*r*s - 7537*r + 3828*s**2 - 5207*s + 2227) - 7208*r**2 - 10508*r*s + 8780*r - 4356*s**2 + 5867*s - 2469) + Pkd2*k2*(66*C - 33)*(r*(32*s - 15) + 32*s**2 - 38*s + 11))) + 132*g2*(2*Pk2*k1**4*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k1**2*k2**2*(Pk2*(340*r**2 + 1000*r*s - 569*r + 660*s**2 - 687*s + 205) - 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)) - k2**4*(Pk2*(340*r**2 + 352*r*s - 373*r + 12*s**2 - 249*s + 119) + 3*Pkd2*k2*(32*r*s - 15*r + 32*s**2 - 38*s + 11))))))/(693*d**2*k1*k2*k3**5) + 2*D1**3*Pkd3*ct*(11*D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(8*r**2 + r*(8*s - 9) - 3*s + 1) + k1**2*(Pk2*(75*r**2 + 90*r*s - 122*r + 15*s**2 - 62*s + 43) + 5*Pkd2*k2*(6*s + 1)*(r + s - 1))) - f*(Pk2*k2**6*r*(2 - 4*C)*(r + s) + 2*k1**6*(Pk2*(-4*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 20*b1*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 10*r**2 + 36*r*s - 23*r + 26*s**2 - 35*s + 9) + Pkd2*b1*k2*(r*(8*s - 2) + 8*s**2 - 8*s + 1)) + k1**4*k2**2*(Pk2*(-8*C*(52*r**2 + 96*r*s - 81*r + 57*s**2 - 77*s + 20) - 84*K*r**2 - 224*K*r*s + 168*K*r - 140*K*s**2 + 220*K*s - 84*K + 2*b1*(375*r**2 + r*(690*s - 577) + 315*s**2 - 525*s + 206) + 356*r**2 + 695*r*s - 532*r + 391*s**2 - 503*s + 112) + 2*Pkd2*k2*(C*(-32*r*s + 4*r - 32*s**2 + 34*s - 2) - 6*K*r*s + 6*K*r - 6*K*s**2 + 12*K*s - 6*K + b1*(9*r*(8*s - 1) + 72*s**2 - 69*s + 3) + 22*r*s - 2*r + 22*s**2 - 23*s + 1)) + k1**2*k2**4*(Pk2*(-4*C*(132*r**2 + 227*r*s - 162*r + 121*s**2 - 141*s + 20) - 26*K*r**2 - 104*K*r*s + 52*K*r - 78*K*s**2 + 78*K*s - 26*K + 13*b1*(12*r**2 + r*(18*s - 13) + 6*s**2 - 11*s + 3) + 315*r**2 + 530*r*s - 373*r + 267*s**2 - 307*s + 40) + Pkd2*k2*(12 - 24*C)*(r*(3*s - 1) + s*(3*s - 3)))) + k1**2*(5*Pk2*b1**2*k2**2*(6*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 20*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(-2*Pk2*k1**4*(5*r**2 + r*(-4*K*s + K + 14*s - 6) + s*(K*(3 - 4*s) + 9*s - 8)) + k1**2*k2**2*(-Pk2*(20*C*(2*r**2 + r*(11 - 52*s) + 2*s**2 + 25*s - 13) - 128*K*s**2 + 108*K*s + r**2*(86 - 104*K) + r*(-232*K*s + 124*K + 740*s - 227) + 94*s**2 - 343*s + 125) + Pkd2*k2*(K*r*(32*s - 1) + K*s*(32*s - 31) - 14*s*(r + s - 1))) + k2**4*(7*K*Pkd2*k2*(r*(6*s - 1) + s*(6*s - 5)) - Pk2*(20*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 7*K*(28*r**2 + 60*r*s - 25*r + 32*s**2 - 25*s - 5) + 29*r**2 + 310*r*s - 89*r + s**2 - 131*s + 60))) + 4*g2*(2*Pk2*k1**4*(-2*r*s + r - s*(2*s - 2)) + k1**2*k2**2*(-4*Pk2*(13*r**2 + r*(29*s - 18) + s*(16*s - 16)) + Pkd2*k2*(-16*r*s + r - s*(16*s - 16))) - 7*k2**4*(2*Pk2*(7*r**2 + r*(15*s - 8) + s*(8*s - 8)) + Pkd2*k2*(r*(3*s - 1) + s*(3*s - 3)))))) + 55*Pk2*b1**3*k1**2*k2**2*(6*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 11*b1**2*k1**2*(D1*fd*(2*Pk2*k1**4*(r + s)*(5*r + s*(9 - 4*K)) + f*(26*Pk2*k2**4*(6*r**2 + r*(9*s - 5) + 3*s**2 - 4*s + 1) + 2*k1**4*(5*Pk2*(8*r**2 + 4*r*(4*s - 3) + 8*s**2 - 12*s + 5) + 4*Pkd2*k2*s*(2*r + 2*s - 1)) + k1**2*k2**2*(Pk2*(750*r**2 + 23*r*(60*s - 37) + 630*s**2 - 795*s + 253) + 6*Pkd2*k2*s*(24*r + 24*s - 11))) - 2*k1**2*k2**2*(Pk2*(-20*C*(r**2 - 2*r*(13*s + 1) + s**2 + 26*s + 1) + 64*K*s**2 + r**2*(52*K - 43) + 2*r*(58*K*s - 185*s - 15) - 47*s**2 + 250*s + 15) + Pkd2*k2*s*(16*K - 7)*(r + s)) + k2**4*(-42*K*Pkd2*k2*s*(r + s) + Pk2*(40*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) - 14*K*(14*r**2 + 30*r*s + 10*r + 16*s**2 + 10*s - 5) + 29*r**2 + 310*r*s + 40*r + s**2 - 240*s - 20))) + Dd*f*(2*Pk2*k1**4*(20*r**2 + r*(K*(2 - 16*s) + 56*s - 17) + s*(K*(8 - 16*s) + 36*s - 23)) + f*(13*Pk2*k2**4*(24*r**2 + r*(36*s - 23) + 12*s**2 - 19*s + 5) + 2*k1**4*(5*Pk2*(4*r + 4*s - 3)**2 + Pkd2*k2*(16*r*s - 2*r + 16*s**2 - 12*s + 1)) + k1**2*k2**2*(5*Pk2*(300*r**2 + 552*r*s - 401*r + 252*s**2 - 369*s + 133) + 6*Pkd2*k2*(48*r*s - 3*r + 48*s**2 - 34*s + 1))) - 2*k1**2*k2**2*(-Pk2*(20*C*(4*r**2 + r*(7 - 104*s) + 4*s**2 + 77*s - 11) - 256*K*s**2 + 152*K*s - r**2*(208*K - 172) + r*(-464*K*s + 176*K + 1480*s - 225) + 188*s**2 - 889*s + 95) + Pkd2*k2*(K*r*(64*s - 1) + 2*K*s*(32*s - 23) - 7*s*(4*r + 4*s - 3))) + k2**4*(14*K*Pkd2*k2*(-12*r*s + r + s*(7 - 12*s)) + Pk2*(40*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) - 14*K*(56*r**2 + 24*r*(5*s - 1) + 64*s**2 - 24*s - 15) + 116*r**2 + 1240*r*s - 147*r + 4*s**2 - 763*s + 80)))) + 11*b1*(D1*(f**2*fd*k1**4*(11*Pk2*k2**2*(24*r**2 + r*(24*s - 23) - 5*s + 5) + k1**2*(Pk2*(225*r**2 + 270*r*s - 281*r + 45*s**2 - 151*s + 88) + 5*Pkd2*k2*(18*r*s + 6*r + 18*s**2 - 7*s - 4))) + f*(fd*(-2*Pk2*k1**6*(2*r + 2*s - 1)*(10*r + s*(26 - 16*C) - 5) + Pk2*k2**6*(4*C - 2)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(8*C*(104*r**2 + 2*r*(96*s - 49) + 114*s**2 - 78*s + 23) + 4*K*(42*r**2 + 112*r*s - 77*r + 70*s**2 - 103*s + 34) - 712*r**2 - 1390*r*s + 617*r - 782*s**2 + 555*s - 143) + 4*Pkd2*k2*(3*K*(s - 1) + s*(16*C - 11))*(2*r + 2*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(264*r**2 + 2*r*(227*s - 52) + 242*s**2 - 46*s - 29) + 26*K*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 630*r**2 - 1060*r*s + 259*r - 534*s**2 + 119*s + 58) + Pkd2*k2*s*(48*C - 24)*(3*r + 3*s - 1))) - 4*k1**2*(-5*Pk2*bd2*k2**2*(2*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + gd2*(2*Pk2*k1**4*s*(2*r + 2*s - 1) + 4*Pk2*k1**2*k2**2*(13*r**2 + r*(29*s - 13) + s*(16*s - 11)) + 7*Pk2*k2**4*(14*r**2 + r*(30*s - 9) + 16*s**2 - 9*s - 5) + Pkd2*k1**2*k2**3*s*(16*r + 16*s - 15) + 7*Pkd2*k2**5*s*(3*r + 3*s - 2)))) - 4*fd*k1**2*(-5*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(r + s)**2 + g2*(4*Pk2*k1**4*s*(r + s) + 4*Pk2*k1**2*k2**2*(13*r**2 + 29*r*s + 16*s**2) + 7*Pk2*k2**4*(14*r**2 + 10*r*(3*s + 1) + 16*s**2 + 10*s - 5) + 16*Pkd2*k1**2*k2**3*s*(r + s) + 21*Pkd2*k2**5*s*(r + s)))) + Dd*f*(f**2*k1**4*(22*Pk2*k2**2*(4*r - 1)*(4*r + 4*s - 3) + k1**2*(Pk2*(300*r**2 + 360*r*s - 403*r + 60*s**2 - 213*s + 131) + 5*Pkd2*k2*(24*r*s + 7*r + 24*s**2 - 12*s - 5))) + f*(2*Pk2*k1**6*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) - 40*r**2 + r*(58 - 144*s) - 104*s**2 + 98*s - 19) + Pk2*k2**6*(8*C - 4)*(r + s)*(2*r - 1) + k1**4*k2**2*(Pk2*(8*C*(208*r**2 + 384*r*s - 254*r + 228*s**2 - 213*s + 66) + 4*K*(84*r**2 + 7*r*(32*s - 23) + 140*s**2 - 213*s + 76) - 1424*r**2 - 2780*r*s + 1623*r - 1564*s**2 + 1451*s - 373) + 2*Pkd2*k2*(2*C*(r*(64*s - 2) + 64*s**2 - 48*s + 1) + 6*K*(s - 1)*(4*r + 4*s - 3) - 88*r*s + 2*r - 88*s**2 + 66*s - 1)) + k1**2*k2**4*(Pk2*(4*C*(528*r**2 + r*(908*s - 399) + 484*s**2 - 273*s - 8) + 26*K*(4*r**2 + 16*r*s - 9*r + 12*s**2 - 13*s + 4) - 1260*r**2 - 2120*r*s + 949*r - 1068*s**2 + 625*s + 16) + Pkd2*k2*(24*C - 12)*(r*(12*s - 1) + s*(12*s - 7)))) + 4*k1**2*(5*Pk2*b2*k2**2*(2*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*Pk2*k1**4*(-8*r*s + r + s*(4 - 8*s)) - 8*Pk2*k1**2*k2**2*(26*r**2 + r*(58*s - 22) + s*(32*s - 19)) - 7*Pk2*k2**4*(56*r**2 + 24*r*(5*s - 1) + 64*s**2 - 24*s - 15) + Pkd2*k1**2*k2**3*(-64*r*s + r + s*(46 - 64*s)) + 7*Pkd2*k2**5*(-12*r*s + r + s*(7 - 12*s)))))) + f*k1**2*(D1*(305*Pk2*f**2*fd*k1**4*(4*s - 1)*(r + s - 1) + 11*f*k2**2*(60*Pk2*bd2*k1**2*(r + s - 1)**2 + Pk2*fd*k2**2*(4*C - 2)*(36*r**2 + 27*r*(5*s - 3) + 99*s**2 - 111*s + 34) - 52*Pk2*gd2*k2**2*(r**2 + r*(4*s - 2) + 3*s**2 - 3*s + 1) + fd*k1**2*(Pk2*(4*C*(105*r**2 + 3*r*(96*s - 67) + 183*s**2 - 273*s + 94) - 240*r**2 - 669*r*s + 443*r - 429*s**2 + 630*s - 209) + Pkd2*k2*(20*C - 10)*(s - 1)*(3*r + 3*s - 2)) - 8*gd2*k1**2*(Pk2*(21*r**2 + 14*r*(4*s - 3) + 35*s**2 - 55*s + 21) + 3*Pkd2*k2*(s - 1)*(r + s - 1))) - 44*fd*k2**2*(-15*Pk2*b2*k1**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + g2*(13*Pk2*k2**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + 2*k1**2*(Pk2*(42*r**2 + 112*r*s - 77*r + 70*s**2 - 103*s + 34) + 3*Pkd2*k2*(s - 1)*(2*r + 2*s - 1))))) + Dd*f*(305*Pk2*f**2*k1**4*(4*s - 1)*(r + s - 1) + 11*f*k2**2*(Pk2*k2**2*(4*C - 2)*(48*r**2 + 15*r*(12*s - 7) + 132*s**2 - 145*s + 46) + k1**2*(Pk2*(4*C*(140*r**2 + 384*r*s - 271*r + 244*s**2 - 367*s + 129) - 320*r**2 - 892*r*s + 593*r - 572*s**2 + 839*s - 279) + Pkd2*k2*(20*C - 10)*(s - 1)*(4*r + 4*s - 3))) - 44*k2**2*(-15*Pk2*b2*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + g2*(13*Pk2*k2**2*(4*r**2 + r*(16*s - 9) + 12*s**2 - 13*s + 4) + 2*k1**2*(Pk2*(84*r**2 + 7*r*(32*s - 23) + 140*s**2 - 213*s + 76) + 3*Pkd2*k2*(s - 1)*(4*r + 4*s - 3)))))))/(231*d**2*k1*k2*k3**5) + 40*D1**3*Pkd3*f**3*k1**2*k2**2*st**8*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(1287*d**2*k3**5) - 5*D1**3*Pkd3*f*st**6*(D1*bd1*f*(f*(66*Pk2*k2**2*(r - 1)*(r + s - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(15*s - 8) + 15*s**2 - 11*s + 6)) + 66*k2**2*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) - Pk2*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1))) + b1*(3*D1*fd*(f*(22*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(5*r + 5*s - 1)) + 44*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)*(2*r + 2*s - 1)) + Dd*f*(f*(66*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(4*Pk2 - Pkd2*k2)*(r*(60*s - 23) + 60*s**2 - 35*s + 9)) + 132*k2**2*(K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - Pk2*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + 8*r**2 + r*(8*s - 7) - 2*s + 1)))) + 2*k2**2*(-72*C*D1*Pk2*f*fd*r*s + 24*C*D1*Pk2*f*fd*r - 72*C*D1*Pk2*f*fd*s**2 + 72*C*D1*Pk2*f*fd*s - 16*C*D1*Pk2*f*fd + 36*C*D1*Pkd2*f*fd*k2*r*s - 12*C*D1*Pkd2*f*fd*k2*r + 36*C*D1*Pkd2*f*fd*k2*s**2 - 36*C*D1*Pkd2*f*fd*k2*s + 8*C*D1*Pkd2*f*fd*k2 - 96*C*Dd*Pk2*f**2*r*s + 28*C*Dd*Pk2*f**2*r - 96*C*Dd*Pk2*f**2*s**2 + 96*C*Dd*Pk2*f**2*s - 20*C*Dd*Pk2*f**2 + 48*C*Dd*Pkd2*f**2*k2*r*s - 14*C*Dd*Pkd2*f**2*k2*r + 48*C*Dd*Pkd2*f**2*k2*s**2 - 48*C*Dd*Pkd2*f**2*k2*s + 10*C*Dd*Pkd2*f**2*k2 - 18*D1*Pk2*f*fd*r**2 + 18*D1*Pk2*f*fd*r*s + 6*D1*Pk2*f*fd*r + 36*D1*Pk2*f*fd*s**2 - 30*D1*Pk2*f*fd*s + 4*D1*Pk2*f*fd + 528*D1*Pk2*f*gd2*r*s - 132*D1*Pk2*f*gd2*r + 528*D1*Pk2*f*gd2*s**2 - 528*D1*Pk2*f*gd2*s + 132*D1*Pk2*f*gd2 + 1056*D1*Pk2*fd*g2*r*s - 528*D1*Pk2*fd*g2*r + 1056*D1*Pk2*fd*g2*s**2 - 1056*D1*Pk2*fd*g2*s + 264*D1*Pk2*fd*g2 - 18*D1*Pkd2*f*fd*k2*r*s + 6*D1*Pkd2*f*fd*k2*r - 18*D1*Pkd2*f*fd*k2*s**2 + 18*D1*Pkd2*f*fd*k2*s - 4*D1*Pkd2*f*fd*k2 - 264*D1*Pkd2*f*gd2*k2*r*s + 66*D1*Pkd2*f*gd2*k2*r - 264*D1*Pkd2*f*gd2*k2*s**2 + 264*D1*Pkd2*f*gd2*k2*s - 66*D1*Pkd2*f*gd2*k2 - 528*D1*Pkd2*fd*g2*k2*r*s + 264*D1*Pkd2*fd*g2*k2*r - 528*D1*Pkd2*fd*g2*k2*s**2 + 528*D1*Pkd2*fd*g2*k2*s - 132*D1*Pkd2*fd*g2*k2 - 33*D1*bd2*f*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) + (1 - 2*s)**2) - 24*Dd*Pk2*f**2*r**2 + 24*Dd*Pk2*f**2*r*s + 13*Dd*Pk2*f**2*r + 48*Dd*Pk2*f**2*s**2 - 38*Dd*Pk2*f**2*s + 3*Dd*Pk2*f**2 + 2112*Dd*Pk2*f*g2*r*s - 792*Dd*Pk2*f*g2*r + 2112*Dd*Pk2*f*g2*s**2 - 2112*Dd*Pk2*f*g2*s + 528*Dd*Pk2*f*g2 - 24*Dd*Pkd2*f**2*k2*r*s + 7*Dd*Pkd2*f**2*k2*r - 24*Dd*Pkd2*f**2*k2*s**2 + 24*Dd*Pkd2*f**2*k2*s - 5*Dd*Pkd2*f**2*k2 - 1056*Dd*Pkd2*f*g2*k2*r*s + 396*Dd*Pkd2*f*g2*k2*r - 1056*Dd*Pkd2*f*g2*k2*s**2 + 1056*Dd*Pkd2*f*g2*k2*s - 264*Dd*Pkd2*f*g2*k2 - 66*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1)*(2*r + 2*s - 1) + Dd*f*(8*r*s - 3*r + 8*s**2 - 8*s + 2))))/(693*d**2*k3**3) - 5*D1**3*Pkd3*f*st**6*(D1*(f**2*(-858*Pk2*bd1*k2**4*(r - 1)*(r + s - 1) + 13*bd1*k1**2*k2**2*(-Pk2*(15*r**2 + 4*r*(9*s - 26) + 21*s**2 - 98*s + 93) + Pkd2*k2*(r*(3*s - 2) + 3*s**2 + s + 4)) - fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(405*r + 405*s - 307) + 26*fd*k1**2*k2**2*(Pk2*(112*r**2 + r*(16*s - 161) - 96*s**2 + 30*s + 49) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 13*f*k2**2*(b1*fd*(66*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(3*Pk2*(15*r**2 + 36*r*s - 65*r + 21*s**2 - 47*s + 26) + Pkd2*k2*(-9*r*s + 15*r - 9*s**2 - 12*s + 1))) + 2*k2**2*(162*C*Pk2*fd*r**2 + 252*C*Pk2*fd*r*s - 192*C*Pk2*fd*r + 90*C*Pk2*fd*s**2 - 144*C*Pk2*fd*s + 56*C*Pk2*fd + 36*C*Pkd2*fd*k2*r*s - 12*C*Pkd2*fd*k2*r + 36*C*Pkd2*fd*k2*s**2 - 36*C*Pkd2*fd*k2*s + 8*C*Pkd2*fd*k2 + 165*Pk2*bd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 99*Pk2*fd*r**2 - 144*Pk2*fd*r*s + 114*Pk2*fd*r - 45*Pk2*fd*s**2 + 78*Pk2*fd*s - 32*Pk2*fd - 1188*Pk2*gd2*r**2 - 1848*Pk2*gd2*r*s + 1650*Pk2*gd2*r - 660*Pk2*gd2*s**2 + 1254*Pk2*gd2*s - 462*Pk2*gd2 - 18*Pkd2*fd*k2*r*s + 6*Pkd2*fd*k2*r - 18*Pkd2*fd*k2*s**2 + 18*Pkd2*fd*k2*s - 4*Pkd2*fd*k2 - 264*Pkd2*gd2*k2*r*s + 66*Pkd2*gd2*k2*r - 264*Pkd2*gd2*k2*s**2 + 264*Pkd2*gd2*k2*s - 66*Pkd2*gd2*k2 + 33*bd1*(K*Pkd2*k2*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)))) + 858*fd*k2**4*(2*r + 2*s - 1)*(K*Pk2*b1*(-18*r - 10*s + 5) + 2*K*Pkd2*b1*k2*(1 - 2*s) + 4*Pk2*b1*r - 5*Pk2*b2*(2*r + 2*s - 1) + 2*Pk2*g2*(18*r + 10*s - 5) + 4*Pkd2*g2*k2*(2*s - 1))) + Dd*f*(f**2*k1**2*(-k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(405*r + 405*s - 307) + 26*k2**2*(Pk2*(112*r**2 + r*(16*s - 161) - 96*s**2 + 30*s + 49) + Pkd2*k2*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 13*f*k2**2*(b1*(-66*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(-Pk2*(60*r**2 + 144*r*s - 299*r + 84*s**2 - 239*s + 171) + Pkd2*k2*(12*r*s - 17*r + 12*s**2 + 13*s + 3))) - 2*k2**2*(Pk2*(2*C*(108*r**2 + 168*r*s - 139*r + 60*s**2 - 105*s + 44) - 132*r**2 - 192*r*s + 166*r - 60*s**2 + 115*s - 51) + Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) - 858*k2**4*(5*Pk2*b2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + b1*(2*K*Pkd2*k2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*(K*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) - 16*r**2 - 16*r*s + 14*r + 4*s - 2)) - 2*g2*(Pk2*(72*r**2 + 112*r*s - 78*r + 40*s**2 - 58*s + 19) + 2*Pkd2*k2*(8*r*s - 3*r + 8*s**2 - 8*s + 2)))))/(9009*d**2*k3**5) - 2*D1**3*Pkd3*st**4*(2*D1*bd1*f*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(r*(2*s - 1) + s*(2*s - 2)) + b1**2*(D1*fd*(r + s - 1)*(4*K*k2**2*(-2*Pk2 + Pkd2*k2)*(s - 1) + 4*Pk2*f*k2**2*(r - 1) - 4*Pk2*k2**2*r - f*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(2*K*Pkd2*k2**3*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*Pk2*f*k2**2*(r - 1)*(4*r + 4*s - 3) - 2*Pk2*k2**2*(2*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 8*r**2 + r*(8*s - 9) - 2*s + 2) - f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(r + s - 1))) + 2*b1*(D1*bd1*f*(K*Pkd2*k2**3*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*Pk2*f*k1**2*s*(r + s - 1) + Pk2*k2**2*(-2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + f*(r - 1)*(2*r + 2*s - 1) - 4*r**2 - 4*r*s + 4*r + s - 1) + Pkd2*f*k1**2*k2*s*(r + s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(2*D1*b2*fd*(s - 1)*(r + s - 1) + D1*bd2*f*(2*s - 1)*(r + s - 1) - 2*D1*(f*gd2*(2*s - 1) + 2*fd*g2*(s - 1))*(r + s - 1) + Dd*b2*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 2*Dd*f*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))))/(7*d**2*k2**2*k3) + D1**3*Pkd3*st**2*(2*D1*bd1*f*(f*(Pk2*k1**2*(-2*r*s + r - s*(2*s - 2)) + k2**2*(Pk2*(r**2*(8*C - 2) + r*(12*C*(s - 1) - 4*s + 5) + s*(2*C - 1)*(4*s - 5)) - Pkd2*k2*(2*C - 1)*(r*(2*s - 1) + s*(2*s - 2)))) + k2**2*(7*b2 - 14*g2)*(-2*Pk2*s*(r + s - 1) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))) + b1**3*(-D1*fd*(r + s - 1)*(-22*Pk2*k1**2*s + 14*Pk2*k2**2*(r - 1) + 11*Pkd2*k1**2*k2*s) + Dd*f*(-14*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(2*Pk2 - Pkd2*k2)*(r*(44*s - 9) + 44*s**2 - 51*s + 9))) + b1**2*(D1*bd1*f*(-14*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(2*Pk2 - Pkd2*k2)*(r*(33*s - 9) + 33*s**2 - 40*s + 9)) - D1*fd*(k1**2*(Pk2*(72*f*s - 38*f + 4*s - 4) + 2*Pkd2*f*k2*(2 - 3*s)) + k2**2*(Pk2*(28*K*(s - 1) + f*(6*r - 3) + 32*r - 4) + 4*Pkd2*k2*(-2*C*s - 7*K*(s - 1) + s)))*(r + s - 1) - Dd*f*(k1**2*(2*Pk2*(f*(72*r*s - 23*r + 72*s**2 - 92*s + 21) + 8*r*s - 5*r + 8*s**2 - 12*s + 4) - Pkd2*f*k2*(3*s - 2)*(4*r + 4*s - 3)) - 2*k2**2*(-Pk2*(14*K*(4*s - 1)*(r + s - 1) + 3*f*(2*r - 1)*(r + s - 1) + 64*r**2 + 64*r*s - 76*r - 20*s + 19) + Pkd2*k2*(2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 8*r*s + r - 8*s**2 + 8*s - 1)))) - b1*(D1*bd1*f*(k1**2*(2*Pk2*(f*(36*r*s - 4*r + 36*s**2 - 37*s + 2) + 4*r*s - 2*r + 4*s**2 - 5*s + 1) - Pkd2*f*k2*(3*s - 2)*(2*r + 2*s - 1)) + k2**2*(Pk2*(56*K*s**2 - 56*K*s + 3*f*(2*r - 1)*(r + s - 1) + 64*r**2 + 2*r*(s*(28*K + 32) - 33) - 18*s + 16) - 2*Pkd2*k2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + 7*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - 4*s**2 + 4*s - 1))) + 2*D1*(f*fd*(Pk2*k1**2*(4*s - 3)*(r + s - 1) + k2**2*(-2*Pk2*(C*(8*r**2 + 12*r*s - 19*r + 8*s**2 - 17*s + 11) - 2*r**2 - 4*r*s + 7*r - 4*s**2 + 8*s - 5) + Pkd2*k2*(2*C - 1)*(4*s - 3)*(r + s - 1))) - 7*f*k2**2*(bd2 - 2*gd2)*(-2*Pk2*s + Pkd2*k2*(2*s - 1))*(r + s - 1) - 14*fd*k2**2*(-Pk2 + Pkd2*k2)*(b2 - 2*g2)*(s - 1)*(r + s - 1)) + 2*Dd*f*(f*(Pk2*k1**2*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k2**2*(Pk2*(-2*C*(16*r**2 + 24*r*s - 35*r + 16*s**2 - 30*s + 17) + 8*r**2 + 16*r*s - 26*r + 16*s**2 - 28*s + 15) + Pkd2*k2*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + k2**2*(-7*b2 + 14*g2)*(-2*Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))))/(21*d**2*k2**2*k3) + D1**3*Pkd3*(-2*D1*Pk2*bd1*f*k2**2*s*(7*b2 + f*(26*C - 13) - 14*g2)*(r + s - 1) + 2*Pk2*b1*(2*D1*bd1*f*(k1**2*(r*(4*s - 1) + (1 - 2*s)**2) + k2**2*(-6*C*(2*r**2 - 12*r*s + r + 6*s - 3) - 7*K*s**2 + 7*K*s + 6*r**2 + r*(-7*K*s - 36*s + 3) + 18*s - 9)) - k2**2*(r + s - 1)*(D1*(f*fd*(26*C - 13)*(2*s - 1) + 7*f*s*(bd2 - 2*gd2) - 14*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(26*C - 13) - 14*g2) + 7*b2*(D1*fd*(s - 1) + Dd*f*(4*s - 1)))) - 7*b1**3*(-D1*fd*(r + s - 1)*(-2*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + 2*Pkd2*k1**2*k2*s) + 2*Dd*f*(-Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(Pk2*(4*s - 1)*(r + s - 1) + Pkd2*k2*s*(-4*r - 4*s + 3)))) + b1**2*(-7*D1*bd1*f*(-Pk2*k2**2*(3*r - 1)*(r + s - 1) + 2*k1**2*(Pk2*(3*s - 1)*(r + s - 1) + Pkd2*k2*s*(-3*r - 3*s + 2))) + 2*Pk2*(D1*fd*(4*k1**2*s*(r + s - 1) + k2**2*(-12*C*(r - 1)*(r - 6*s - 1) - 7*K*(s - 1)*(r + s - 1) + (6*r - 6)*(r - 6*s - 1))) + Dd*f*(2*k1**2*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + k2**2*(-12*C*(4*r**2 - 3*r*(8*s + 1) + 18*s - 1) - 7*K*(4*s - 1)*(r + s - 1) + 24*r**2 - 18*r*(8*s + 1) + 108*s - 6)))))/(21*d**2*k2**2*k3) + D1**3*Pkd3*st**4*(D1*bd1*f*(f**2*(-66*Pk2*k1**2*k2**2*(6*r**2 + r*(11*s - 8) + 5*s**2 - 9*s + 2) - 11*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 4*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1)) + 66*f*k2**2*(2*K*Pkd2*k1**2*k2*s*(r + s) + 2*K*Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2) + 2*Pk2*b1*k2**2*(r - 1) - 2*Pk2*k1**2*(r**2 + r*(s*(2*K + 2) - 1) + s*(2*K*s + s - 2)) + 2*Pk2*k2**2*(r**2*(2*K - 4) - r*(2*K*(s + 1) + 4*s - 5) - (2*s - 1)*(2*K*s - 1)) + b1*k1**2*(Pk2*(2*r + 2*s - 3) + Pkd2*k2)*(r + s - 1)) - 132*k2**4*(2*Pk2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)) + b1*(K*Pkd2*k2*(r + 2*s - 1) - Pk2*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) - b2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))))) + 66*b1**2*k2**2*(D1*fd*(f*(2*Pk2*k1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*Pk2*k2**2*(r - 1) - Pkd2*k1**2*k2*(r + s - 1)) + 2*k2**2*(K*Pk2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) - 2*K*Pkd2*k2*(r + 2*s - 1) + 2*Pk2*r)) + Dd*f*(Pk2*f*k1**2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*k2**2*(-4*K*Pkd2*k2*(r + 2*s - 1) + Pk2*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + 4*r - 2)))) + b1*(D1*(f**2*fd*(-66*Pk2*k1**2*k2**2*(18*r**2 + r*(33*s - 25) + 15*s**2 - 28*s + 11) - 11*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 8*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1)*(6*r + 6*s - 5)) - 132*f*k2**2*(K*fd*(2*Pk2*k1**2*(r + s)*(2*s - 1) - 2*Pk2*k2**2*(2*r**2 - 2*r*s + r - (1 - 2*s)**2) - Pkd2*k1**2*k2*(r + s)*(2*s - 1) - 2*Pkd2*k2**3*(2*s - 1)*(2*r + 2*s - 1)) + Pk2*fd*(k1**2*(2*r**2 + 4*r*s + s*(2*s - 1)) + 4*k2**2*r*(2*r + 2*s - 1)) + 2*Pk2*gd2*k2**2*(5*r**2 + r*(6*s - 8) + s**2 - 4*s + 3) - 2*Pkd2*gd2*k2**3*(r + 2*s - 1) + bd2*k2**2*(-Pk2*(r + s - 1)**2 + Pkd2*k2*s*(2*r + 2*s - 1))) - 132*fd*k2**4*(-Pk2*b2*(r + s - 1)**2 + 2*Pk2*g2*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + 2*Pkd2*b2*k2*s*(r + s) - 4*Pkd2*g2*k2*(r + 2*s - 1))) + 2*Dd*f*(f**2*(-33*Pk2*k1**2*k2**2*(24*r**2 + 11*r*(4*s - 3) + 20*s**2 - 37*s + 13) - 11*Pk2*k2**4*(2*r - 1)*(5*r + 5*s - 3) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11)) + 66*f*k2**2*(K*Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*K*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*k1**2*(-4*r**2 - r*(2*K + 2)*(4*s - 1) + s*(-8*K*s + 2*K - 4*s + 5)) + 2*Pk2*k2**2*(K*(4*r**2 - 4*r*s - r - 8*s**2 + 6*s - 1) - 8*r**2 - 8*r*s + 7*r + 2*s - 1)) - 66*k2**4*(-b2*(Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(-8*r*s + r - 8*s**2 + 4*s)) + 2*g2*(Pk2*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) - 4*Pkd2*k2*(r + 2*s - 1))))) - 12*f*k2**2*(D1*(2*C*f*fd*(Pk2*k2**2*(3*r - 1)*(r + 12*s + 3) + 2*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1)*(3*r + 3*s - 2)) + 22*Pk2*bd2*f*k1**2*r*s + 22*Pk2*bd2*f*k1**2*s**2 - 22*Pk2*bd2*f*k2**2*r**2 + 22*Pk2*bd2*f*k2**2*r*s + 22*Pk2*bd2*f*k2**2*r + 44*Pk2*bd2*f*k2**2*s**2 - 22*Pk2*bd2*f*k2**2*s + 18*Pk2*f*fd*k1**2*r**2 - 12*Pk2*f*fd*k1**2*r - 18*Pk2*f*fd*k1**2*s**2 + 12*Pk2*f*fd*k1**2*s - 3*Pk2*f*fd*k2**2*r**2 - 36*Pk2*f*fd*k2**2*r*s - 8*Pk2*f*fd*k2**2*r + 12*Pk2*f*fd*k2**2*s + 3*Pk2*f*fd*k2**2 - 44*Pk2*f*gd2*k1**2*r*s - 44*Pk2*f*gd2*k1**2*s**2 + 44*Pk2*f*gd2*k2**2*r**2 - 44*Pk2*f*gd2*k2**2*r*s - 44*Pk2*f*gd2*k2**2*r - 88*Pk2*f*gd2*k2**2*s**2 + 44*Pk2*f*gd2*k2**2*s - 88*Pk2*fd*g2*k1**2*r*s + 44*Pk2*fd*g2*k1**2*r - 88*Pk2*fd*g2*k1**2*s**2 + 44*Pk2*fd*g2*k1**2*s + 88*Pk2*fd*g2*k2**2*r**2 - 88*Pk2*fd*g2*k2**2*r*s + 44*Pk2*fd*g2*k2**2*r - 176*Pk2*fd*g2*k2**2*s**2 + 176*Pk2*fd*g2*k2**2*s - 44*Pk2*fd*g2*k2**2 - 11*Pkd2*bd2*f*k1**2*k2*r*s - 11*Pkd2*bd2*f*k1**2*k2*s**2 - 44*Pkd2*bd2*f*k2**3*r*s + 11*Pkd2*bd2*f*k2**3*r - 44*Pkd2*bd2*f*k2**3*s**2 + 44*Pkd2*bd2*f*k2**3*s - 11*Pkd2*bd2*f*k2**3 + 18*Pkd2*f*fd*k1**2*k2*r*s - 6*Pkd2*f*fd*k1**2*k2*r + 18*Pkd2*f*fd*k1**2*k2*s**2 - 18*Pkd2*f*fd*k1**2*k2*s + 4*Pkd2*f*fd*k1**2*k2 + 22*Pkd2*f*gd2*k1**2*k2*r*s + 22*Pkd2*f*gd2*k1**2*k2*s**2 + 88*Pkd2*f*gd2*k2**3*r*s - 22*Pkd2*f*gd2*k2**3*r + 88*Pkd2*f*gd2*k2**3*s**2 - 88*Pkd2*f*gd2*k2**3*s + 22*Pkd2*f*gd2*k2**3 + 44*Pkd2*fd*g2*k1**2*k2*r*s - 22*Pkd2*fd*g2*k1**2*k2*r + 44*Pkd2*fd*g2*k1**2*k2*s**2 - 22*Pkd2*fd*g2*k1**2*k2*s + 176*Pkd2*fd*g2*k2**3*r*s - 88*Pkd2*fd*g2*k2**3*r + 176*Pkd2*fd*g2*k2**3*s**2 - 176*Pkd2*fd*g2*k2**3*s + 44*Pkd2*fd*g2*k2**3 - 11*b2*fd*(-2*Pk2*k1**2*(r + s)*(2*s - 1) + 2*Pk2*k2**2*(2*r**2 - 2*r*s + r - 4*s**2 + 4*s - 1) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(2*s - 1)*(2*r + 2*s - 1))) + Dd*f*(f*(Pk2*k2**2*(8*C - 4)*(r**2 + 3*r*(4*s + 1) - 5*s - 2) + k1**2*(2*Pk2*(2*C*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + 12*r**2 - 10*r - 12*s**2 + 7*s + 1) - Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + (-11*b2 + 22*g2)*(-2*Pk2*k1**2*(r + s)*(4*s - 1) + 2*Pk2*k2**2*(4*r**2 - r*(4*s + 1) - 8*s**2 + 6*s - 1) + Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(231*d**2*k2**2*k3**3) + D1**3*Pkd3*st**2*(-33*D1*bd1*f*(f**2*k1**2*(-3*Pk2*k2**2*(6*r**2 + 9*r*(2*s - 1) + 12*s**2 - 13*s + 3) + k1**2*(Pk2*(24*r*s - 8*r + 24*s**2 - 26*s + 4) - Pkd2*k2*(3*s - 2)*(2*r + 2*s - 1))) + f*(2*Pk2*k2**4*(2*C*(5*r**2 + 4*r*s - 6*r - s**2 - s + 1) - 3*K*r**2 - 9*K*r*s + 5*K*r - 6*K*s**2 + 6*K*s - 2*K + b1*(2*r - 1) - 5*r**2 - 4*r*s + 6*r + s**2 + s - 1) - 2*k1**4*(2*Pk2*b1*(r*(10*s - 1) + 10*s**2 - 9*s + 1) - Pk2*(2*s - 1)*(r + s - 1) + Pkd2*b1*k2*(-10*r*s + r - 10*s**2 + 9*s - 1)) + k1**2*k2**2*(Pk2*(20*C*s**2 - 52*C*s - 4*K*(4*r**2 + r*(21*s - 5) + 17*s**2 - 8*s + 1) + b1*(70*r**2 + 3*r*(36*s - 29) + 38*s**2 - 73*s + 29) + 2*r**2*(2*C + 3) + 2*r*(28*C*s - 6*C - 8*s - 5) - 6*s**2 + 12*s + 8) + Pkd2*k2*(-4*C*(r*(9*s - 3) + 9*s**2 - 10*s + 1) + 2*K*(5*s - 3)*(r + s - 1) - 16*b1*r*s - 2*b1*r - 16*b1*s**2 + 13*b1*s + 18*r*s - 6*r + 18*s**2 - 20*s + 2))) - k2**2*(28*Pk2*g2*k2**2*(3*r**2 + r*(4*s - 3) + s*(s - 1)) + b1**2*(14*Pk2*k2**2*(r - 1)*(3*r + 3*s - 2) + k1**2*(11*Pk2*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + Pkd2*k2*(45*r*s - 11*r + 45*s**2 - 52*s + 11))) - 2*b1*(k1**2*(2*K*Pkd2*k2*(r*(5 - 13*s) + s*(8 - 13*s)) + Pk2*(K*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) + 26*r**2 + 48*r*s - 17*r + 22*s**2 - 28*s - 1)) + k2**2*(Pk2*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*K*(6*r**2 + 8*r*s - 11*r + 2*s**2 - 7*s + 5) - 14*r**2 - 24*r*s + 27*r - 10*s**2 + 17*s - 13) + Pkd2*k2*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 - 7*K*(r + 2*s - 1) - 4*r*s + r - 4*s**2 + 4*s - 1))) + 2*b2*k1**2*(Pk2*(-r**2 - 2*r*s + r - s**2 + s) + Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + 14*b2*k2**2*(Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2))) + 4*g2*k1**2*(Pk2*(r**2 + r*(6*s - 3) + s*(5*s - 5)) + Pkd2*k2*(r*(10 - 13*s) - s*(13*s - 13))))) + 33*b1**3*k2**2*(D1*fd*(14*Pk2*k2**2*(r - 1) + k1**2*(11*Pk2*(r + s - 1) + 15*Pkd2*k2*s))*(r + s - 1) + Dd*f*(14*Pk2*k2**2*(r - 1)*(4*r + 4*s - 3) + k1**2*(11*Pk2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + Pkd2*k2*(60*r*s - 11*r + 60*s**2 - 67*s + 11)))) + 33*b1**2*(-D1*fd*(-4*f*k1**4*s*(2*Pk2 - Pkd2*k2)*(5*r + 5*s - 4) + k1**2*k2**2*(2*Pk2*(K*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) + f*(35*r**2 + r*(54*s - 29) + 19*s**2 - 18*s + 2) + 13*r**2 + 24*r*s + 2*r + 11*s**2 + 4*s - 2) - Pkd2*k2*(26*K*s*(r + s) + f*(2*r*(8*s + 5) + 16*s**2 + 5*s - 10))) + 2*k2**4*(Pk2*(10*C*(r + s - 1)**2 + 21*K*r**2 + 28*K*r*s - 56*K*r + 7*K*s**2 - 42*K*s + 21*K + 2*f*r - f - 7*r**2 - 12*r*s + 28*r - 5*s**2 + 12*s - 7) + 2*Pkd2*k2*(-7*K*(r + 2*s - 1) + s*(2*C - 1)*(r + s - 1)))) + Dd*f*(f*(4*Pk2*k2**4*(1 - 2*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(r*(20*s - 1) + 20*s**2 - 17*s + 1) + k1**2*k2**2*(-Pk2*(140*r**2 + r*(216*s - 145) + 76*s**2 - 109*s + 33) + 2*Pkd2*k2*(2*r*(8*s + 3) + 16*s**2 - 4*s - 5))) - 2*k2**2*(k1**2*(K*Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s)) + Pk2*(K*(4*r**2 + 24*r*s - 17*r + 20*s**2 - 31*s + 11) + 52*r**2 + 96*r*s - 27*r + 44*s**2 - 41*s - 4)) + k2**2*(Pk2*(10*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 7*K*(12*r**2 + 16*r*s - 27*r + 4*s**2 - 19*s + 13) - 28*r**2 - 48*r*s + 76*r - 20*s**2 + 41*s - 34) + Pkd2*k2*(2*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*K*(r + 2*s - 1) - 8*r*s + r - 8*s**2 + 8*s - 1))))) - 33*b1*(D1*(f**2*fd*k1**2*(-3*Pk2*k2**2*(18*r**2 + r*(54*s - 39) + 36*s**2 - 51*s + 19) + k1**2*(2*Pk2*(36*r*s - 18*r + 36*s**2 - 51*s + 16) - Pkd2*k2*(3*s - 2)*(6*r + 6*s - 5))) + 2*f*(fd*(Pk2*k1**4*(r*(4*s - 3) + 4*s**2 - 6*s + 2) + k1**2*k2**2*(Pk2*(4*C*(r**2 + r*(14*s - 9) + 5*s**2 - 17*s + 8) - 2*K*(8*r**2 + 6*r*(7*s - 3) + 34*s**2 - 23*s + 3) + 6*r**2 - 16*r*s + 13*r - 6*s**2 + 33*s - 17) + Pkd2*k2*(K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2 - 4*C)*(9*r + 9*s - 4))) + k2**4*(Pk2*(2*C*(10*r**2 + r*(8*s - 1) - 2*s**2 - 1) - K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 10*r**2 - 8*r*s - 2*r + 2*s**2 + 2) + Pkd2*k2*(6*C - 3)*(r + 2*s - 1))) + k2**2*(bd2*k1**2*(Pk2*(r + s - 1)**2 + Pkd2*k2*s*(-13*r - 13*s + 3)) - 7*bd2*k2**2*(Pk2*(r**2 + 2*r*s + s**2 - 1) + Pkd2*k2*s*(2*r + 2*s - 1)) - 2*gd2*k1**2*(Pk2*(r**2 + r*(6*s - 4) + 5*s**2 - 8*s + 3) + Pkd2*k2*s*(-13*r - 13*s + 3)) + 14*gd2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 5) + Pkd2*k2*(r + 2*s - 1)))) - 2*fd*k2**2*(-b2*k1**2*(Pk2*(r + s - 1)**2 - 13*Pkd2*k2*s*(r + s)) + 7*b2*k2**2*(Pk2*(r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) + 2*Pkd2*k2*s*(r + s)) + 2*g2*k1**2*(Pk2*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) - 13*Pkd2*k2*s*(r + s)) - 14*g2*k2**2*(-Pk2*(3*r**2 + 4*r*(s - 2) + s**2 - 6*s + 3) + 2*Pkd2*k2*(r + 2*s - 1)))) + 2*Dd*f*(f**2*k1**2*(-3*Pk2*k2**2*(12*r**2 + 12*r*(3*s - 2) + 24*s**2 - 32*s + 11) + k1**2*(2*Pk2*(24*r*s - 11*r + 24*s**2 - 32*s + 9) - Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + f*(Pk2*k1**4*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + k1**2*k2**2*(Pk2*(2*C*(4*r**2 + r*(56*s - 25) + 20*s**2 - 63*s + 19) - 2*K*(16*r**2 + 84*r*s - 28*r + 68*s**2 - 39*s + 5) + 12*r**2 - 32*r*s + 6*r - 12*s**2 + 51*s - 14) + Pkd2*k2*(C*(r*(6 - 72*s) - 72*s**2 + 50*s - 2) + K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) + 36*r*s - 3*r + 36*s**2 - 25*s + 1)) + k2**4*(Pk2*(C*(40*r**2 + r*(32*s - 22) - 8*s**2 - 2*s - 2) - K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 20*r**2 - 16*r*s + 7*r + 4*s**2 + s + 3) + Pkd2*k2*(8*C - 4)*(r + 2*s - 1))) + k2**2*(b2*k1**2*(Pk2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) - 7*b2*k2**2*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 3) + Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 2*g2*k1**2*(Pk2*(4*r**2 + r*(24*s - 17) + 20*s**2 - 31*s + 11) + Pkd2*k2*(r*(10 - 52*s) + s*(19 - 52*s))) + 14*g2*k2**2*(-Pk2*(12*r**2 + r*(16*s - 27) + 4*s**2 - 19*s + 13) + 4*Pkd2*k2*(r + 2*s - 1))))) - 2*f*(D1*(f*(fd*(Pk2*k1**4*(6*r*(9*s - 14) + 54*s**2 - 153*s + 67) + Pk2*k2**4*(66*C - 33)*(9*r**2 + 3*r*(9*s - 5) + 18*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(4*C*(54*r**2 + r*(177 - 540*s) - 594*s**2 + 576*s - 131) - 603*r**2 + 3*r*(96*s + 47) + 891*s**2 - 822*s + 163) + Pkd2*k2*(66*C - 33)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + k2**2*(-33*bd2 + 66*gd2)*(Pk2*k2**2*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + k1**2*(2*Pk2*(4*r**2 + 21*r*s - 5*r + 17*s**2 - 8*s + 1) - Pkd2*k2*(5*s - 3)*(r + s - 1)))) - 33*fd*k2**2*(b2 - 2*g2)*(Pk2*k2**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + k1**2*(2*Pk2*(8*r**2 + 6*r*(7*s - 3) + 34*s**2 - 23*s + 3) + Pkd2*k2*(r*(7 - 10*s) - 10*s**2 + 13*s - 4)))) + Dd*f*(f*(Pk2*k1**4*(r*(72*s - 109) + 72*s**2 - 204*s + 92) + Pk2*k2**4*(66*C - 33)*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*k2**2*(Pk2*(4*C*(72*r**2 - 720*r*s + 183*r - 792*s**2 + 740*s - 155) - 804*r**2 + 384*r*s + 327*r + 1188*s**2 - 1051*s + 178) + Pkd2*k2*(66*C - 33)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + k2**2*(-33*b2 + 66*g2)*(Pk2*k2**2*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*(2*Pk2*(16*r**2 + 84*r*s - 28*r + 68*s**2 - 39*s + 5) + Pkd2*k2*(-20*r*s + 13*r - 20*s**2 + 29*s - 10))))))/(693*d**2*k2**2*k3**3) + D1**3*Pkd3*(D1*bd1*f*(-7*b1**2*k2**2*(Pk2*k2**2*(3*r - 1)*(r + s - 1) + 2*k1**2*(Pk2*(9*r**2 + 15*r*s - 16*r + 6*s**2 - 15*s + 7) + Pkd2*k2*s*(3*r + 3*s - 2))) + 4*b1*(Pk2*k1**4*(r*(4*s - 1) + s*(4*s - 3)) + Pk2*k2**4*(6*C*(2*r**2 - 12*r*s + r + 6*s - 3) - r**2*(7*K + 6) + r*(-7*K*s + 7*K + 36*s - 3) - 18*s + 9) + k1**2*k2**2*(-14*K*Pkd2*k2*s*(r + s - 1) + Pk2*(2*C*(2*r**2 + r*(51 - 170*s) + 10*s**2 + 101*s - 53) - 14*K*s**2 + 14*K*s + r**2*(12 - 14*K) + r*(-28*K*s + 14*K + 194*s - 71) - 104*s + 52))) + f*(Pk2*k2**4*r*(2 - 4*C)*(15*r + 15*s - 13) + 4*k1**4*(Pk2*(b1*(2*s - 1)*(3*r + 3*s - 2) + 4*r*s - 2*r + 4*s**2 - 5*s + 1) + 3*Pkd2*b1*k2*s*(4*r + 4*s - 3)) + k1**2*k2**2*(13*Pk2*b1*(12*r**2 + r*(20*s - 21) + 8*s**2 - 13*s + 7) - 2*Pk2*(4*C*(22*r**2 + r*(37*s - 34) + 15*s**2 - 27*s + 12) - 56*r**2 + r*(13*K*s - 98*s + 92) + (s - 1)*(13*K*s - 42*s + 24)) + Pkd2*k2*s*(24 - 48*C)*(r + s - 1))) - 14*k2**2*(r + s - 1)*(Pk2*b2*k2**2*(r + s) - 2*Pk2*g2*k2**2*r + 2*b2*k1**2*(Pk2*(r + s) + Pkd2*k2*s) - 4*g2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))) - 2*Pk2*f*k1**2*k2**2*(r + s - 1)*(D1*(f*fd*(22*C - 11)*(3*s - 1) + 13*f*s*(bd2 - 2*gd2) + 26*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(22*C - 11) - 26*g2) + 13*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))) - 7*b1**3*k2**2*(D1*fd*(Pk2*k2**2*(r - 1) + 2*k1**2*(Pk2*(3*r + 2*s - 3) + Pkd2*k2*s))*(r + s - 1) + 2*Dd*f*(Pk2*k2**2*(2*r - 1)*(r + s - 1) + k1**2*(2*Pk2*(6*r**2 + 10*r*s - 11*r + 4*s**2 - 10*s + 5) + Pkd2*k2*s*(4*r + 4*s - 3)))) + b1**2*(D1*fd*(2*Pk2*k2**4*(12*C*(r - 1)*(r - 6*s - 1) - 7*K*(r**2 + r*s + r + 2*s - 1) + (6 - 6*r)*(r - 6*s - 1)) + 4*k1**4*s*(Pk2*f*(6*r + 6*s - 4) + 2*Pk2*(r + s) + 3*Pkd2*f*k2*(4*r + 4*s - 3)) + k1**2*k2**2*(-28*K*Pkd2*k2*s*(r + s) + Pk2*(8*C*(r**2 - r*(85*s + 2) + 5*s**2 + 85*s + 1) - 28*K*s**2 + 13*f*(12*r**2 + r*(20*s - 19) + 8*s**2 - 11*s + 7) - 4*r**2*(7*K - 6) - 4*r*(14*K*s - 97*s - 2) - 332*s - 4))) + 2*Dd*f*(2*Pk2*k1**4*(r*(8*s - 1) + 4*s*(2*s - 1)) + Pk2*k2**4*(12*C*(4*r**2 - 3*r*(8*s + 1) + 18*s - 1) - 7*K*(4*r**2 + 4*r*s - 2*r + 2*s - 1) - 24*r**2 + 144*r*s + 18*r - 108*s + 6) + f*(13*Pk2*k1**2*k2**2*(12*r**2 + 20*r*(s - 1) + 8*s**2 - 12*s + 7) + k1**4*(2*Pk2*(4*s - 1)*(3*r + 3*s - 2) + 12*Pkd2*k2*s*(4*r + 4*s - 3))) - 2*k1**2*k2**2*(7*K*Pkd2*k2*s*(4*r + 4*s - 3) - Pk2*(2*C*(4*r**2 + r*(47 - 340*s) + 20*s**2 + 271*s - 51) - 28*K*s**2 + 21*K*s - r**2*(28*K - 24) + r*(-56*K*s + 21*K + 388*s - 74) - 270*s + 50)))) + 2*b1*(D1*(f*(fd*(8*Pk2*k1**4*s*(2*r + 2*s - 1) - Pk2*k2**4*(2*C - 1)*(30*r**2 + r*(30*s - 2) + 24*s - 13) + k1**2*k2**2*(Pk2*(-4*C*(44*r**2 + r*(74*s - 44) + 30*s**2 - 38*s + 11) - 13*K*(2*s - 1)*(r + s - 1) + 112*r**2 + 196*r*s - 100*r + 84*s**2 - 76*s + 22) + Pkd2*k2*s*(12 - 24*C)*(2*r + 2*s - 1))) - 7*k2**2*(r + s - 1)*(Pk2*bd2*k2**2*(r + s) - 2*Pk2*gd2*k2**2*r + 2*bd2*k1**2*(Pk2*(r + s) + Pkd2*k2*s) - 4*gd2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))) - 7*fd*k2**2*(b2*(r + s)*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s)) - 2*g2*(2*Pk2*k1**2*(r + s)**2 + Pk2*k2**2*(r**2 + r*s + r + 2*s - 1) + 2*Pkd2*k1**2*k2*s*(r + s)))) + Dd*f*(f*(2*Pk2*k1**4*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - Pk2*k2**4*(2*C - 1)*(60*r**2 + 30*r*(2*s - 1) + 22*s - 13) + k1**2*k2**2*(Pk2*(-4*C*(88*r**2 + 37*r*(4*s - 3) + 60*s**2 - 91*s + 34) - 13*K*(4*s - 1)*(r + s - 1) + 224*r**2 + 392*r*s - 270*r + 168*s**2 - 194*s + 68) + Pkd2*k2*s*(12 - 24*C)*(4*r + 4*s - 3))) + 7*k2**2*(-b2*(Pk2*k2**2*(r + s) + 2*k1**2*(Pk2*(r + s) + Pkd2*k2*s))*(4*r + 4*s - 3) + 2*g2*(2*Pk2*k1**2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + Pk2*k2**2*(4*r**2 + r*(4*s - 2) + 2*s - 1) + 2*Pkd2*k1**2*k2*s*(4*r + 4*s - 3))))))/(21*d**2*k2**2*k3**3) + D1**3*Pkd3*st**4*(D1*(5148*b1*fd*k2**6*(5*Pk2*b2*(r + s)**2 + b1*(K*Pk2*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*K*Pkd2*k2*s*(r + s) - 2*Pk2*r*(r + s)) - 2*g2*(Pk2*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s))) + f**3*(39*bd1*k2**2*(66*Pk2*k1**2*k2**2*(4*r**2 + r*(9*s - 8) + 5*s**2 - 11*s + 4) + 11*Pk2*k2**4*(r - 1)*(5*r + 5*s - 3) + 4*k1**4*(Pk2*(105*r**2 + 234*r*s - 173*r + 129*s**2 - 193*s + 56) - 2*Pkd2*k2*(6*r*s - 7*r + 6*s**2 - 12*s + 4))) + 2*fd*k1**2*(65*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(95*r + 95*s - 81) + 39*k1**2*k2**2*(-Pk2*(280*r**2 + r*(1300*s - 619) + 1020*s**2 - 1183*s + 309) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46)))) - 39*f**2*k2**2*(-b1*(66*bd1*k2**2*(4*Pk2*k2**2*(r - 1) - k1**2*(5*Pk2 + Pkd2*k2*(1 - 2*s)))*(r + s - 1) + fd*(66*Pk2*k1**2*k2**2*(12*r**2 + r*(27*s - 13) + 15*s**2 - 22*s + 5) + 11*Pk2*k2**4*(3*r - 1)*(5*r + 5*s - 3) + 4*k1**4*(3*Pk2*(105*r**2 + 234*r*s - 154*r + 129*s**2 - 170*s + 61) - 4*Pkd2*k2*(3*s + 2)*(3*r + 3*s - 2)))) + 12*k2**2*(55*Pk2*bd2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(r + s - 1) - Pk2*fd*k2**2*(2*C - 1)*(3*r - 1)*(r + 12*s + 3) + 11*bd1*(K*Pkd2*k1**2*k2*s*(r + s) + K*Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2) + Pk2*k1**2*(r**2*(7*K - 1) + r*(7*K - 1)*(2*s - 1) + s*(7*K*s - 9*K - s + 2)) + Pk2*k2**2*(K*(20*r**2 + 34*r*s - 29*r + 14*s**2 - 25*s + 9) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + fd*k1**2*(Pk2*(2*C*(126*r**2 + 3*r*(73*s - 56) + 126*s**2 - 157*s + 56) - 144*r**2 - 255*r*s + 192*r - 144*s**2 + 181*s - 64) + Pkd2*k2*(4*C - 2)*(3*s - 1)*(3*r + 3*s - 2)) - 22*gd2*(Pk2*k1**2*(7*r**2 + 7*r*(2*s - 1) + s*(7*s - 9)) + Pk2*k2**2*(20*r**2 + r*(34*s - 29) + 14*s**2 - 25*s + 9) + Pkd2*k1**2*k2*s*(r + s) + Pkd2*k2**3*(r*(4*s - 1) + (1 - 2*s)**2)))) - 2574*f*k2**4*(10*Pk2*b2*(bd1*k2**2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(2*r + 2*s - 1)) - b1**2*fd*(2*Pk2*k2**2*(r - 1)*(2*r + 2*s - 1) + k1**2*(5*Pk2 + 2*Pkd2*k2*s)*(r + s - 1)) + 2*b1*(14*K*Pk2*fd*k1**2*r**2 + 28*K*Pk2*fd*k1**2*r*s - 5*K*Pk2*fd*k1**2*r + 14*K*Pk2*fd*k1**2*s**2 - 7*K*Pk2*fd*k1**2*s + 40*K*Pk2*fd*k2**2*r**2 + 68*K*Pk2*fd*k2**2*r*s - 34*K*Pk2*fd*k2**2*r + 28*K*Pk2*fd*k2**2*s**2 - 28*K*Pk2*fd*k2**2*s + 7*K*Pk2*fd*k2**2 + 2*K*Pkd2*fd*k1**2*k2*r*s - K*Pkd2*fd*k1**2*k2*r + 2*K*Pkd2*fd*k1**2*k2*s**2 - K*Pkd2*fd*k1**2*k2*s + 8*K*Pkd2*fd*k2**3*r*s - 4*K*Pkd2*fd*k2**3*r + 8*K*Pkd2*fd*k2**3*s**2 - 8*K*Pkd2*fd*k2**3*s + 2*K*Pkd2*fd*k2**3 - 5*Pk2*bd2*k2**2*r**2 - 10*Pk2*bd2*k2**2*r*s + 5*Pk2*bd2*k2**2*r - 5*Pk2*bd2*k2**2*s**2 + 5*Pk2*bd2*k2**2*s - 2*Pk2*fd*k1**2*r**2 - 4*Pk2*fd*k1**2*r*s - 2*Pk2*fd*k1**2*s**2 + Pk2*fd*k1**2*s - 8*Pk2*fd*k2**2*r**2 - 8*Pk2*fd*k2**2*r*s + 4*Pk2*fd*k2**2*r + bd1*k2**2*(K*Pk2*(-8*r**2 + r*(3 - 16*s) - 8*s**2 + 3*s + 5) + K*Pkd2*k2*(-4*r*s + r + s*(3 - 4*s)) + 4*Pk2*r**2 + Pk2*r*(4*s - 3) - Pk2*s) + 2*gd2*k2**2*(Pk2*(4*r**2 + 8*r*s + r + 4*s**2 + s - 5) + Pkd2*k2*s*(2*r + 2*s - 1))) - 4*g2*(bd1*k2**2*(-4*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(-2*r*s + r - s*(2*s - 2))) + fd*(Pk2*k1**2*(14*r**2 + r*(28*s - 5) + 7*s*(2*s - 1)) + Pk2*k2**2*(40*r**2 + 34*r*(2*s - 1) + 7*(1 - 2*s)**2) + Pkd2*k1**2*k2*(r + s)*(2*s - 1) + 2*Pkd2*k2**3*(2*s - 1)*(2*r + 2*s - 1))))) + 2*Dd*f*(2574*b1*k2**6*(5*Pk2*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + b1*(K*Pk2*(16*r**2 + 8*r*(4*s + 1) + 16*s**2 + 8*s - 15) + K*Pkd2*k2*(r*(8*s - 1) + 4*s*(2*s - 1)) - 8*Pk2*r**2 + Pk2*r*(5 - 8*s) + 2*Pk2*s) - 2*g2*(Pk2*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s))) + f**3*k1**2*(65*Pk2*k2**4*(90*r**2 + 6*r*(25*s - 21) + 60*s**2 - 100*s + 43) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)*(95*r + 95*s - 81) + 39*k1**2*k2**2*(-Pk2*(280*r**2 + r*(1300*s - 619) + 1020*s**2 - 1183*s + 309) + Pkd2*k2*(12*r*(13*s - 5) + 156*s**2 - 181*s + 46))) + 39*f**2*k2**2*(33*Pk2*b1*k1**2*k2**2*(16*r**2 + 3*r*(12*s - 7) + 20*s**2 - 33*s + 9) + 11*Pk2*b1*k2**4*(2*r - 1)*(5*r + 5*s - 3) + Pk2*k2**4*(48*C - 24)*(r**2 + 3*r*(4*s + 1) - 5*s - 2) + 2*b1*k1**4*(Pk2*(420*r**2 + r*(936*s - 635) + 516*s**2 - 703*s + 239) - 2*Pkd2*k2*(24*r*s + 5*r + 24*s**2 - 12*s - 4)) + 6*k1**2*k2**2*(-2*Pk2*(2*C*(84*r**2 + 146*r*s - 119*r + 84*s**2 - 108*s + 42) - 96*r**2 - 34*r*(5*s - 4) - 96*s**2 + 125*s - 48) - Pkd2*k2*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5))) + 1287*f*k2**4*(-10*Pk2*b2*(k1**2*(r + s) + k2**2*(2*r + 2*s - 1))*(4*r + 4*s - 3) + b1**2*k2*(2*Pk2*k2*(r - 1)*(4*r + 4*s - 3) + Pkd2*k1**2*(4*s - 1)*(r + s - 1)) - 2*b1*(K*Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*K*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Pk2*k1**2*(r**2*(28*K - 4) + r*(56*K*s - 19*K - 8*s + 2) + s*(28*K*s - 25*K - 4*s + 5)) + Pk2*k2**2*(K*(80*r**2 + 136*r*s - 92*r + 56*s**2 - 78*s + 25) - 16*r**2 - 16*r*s + 14*r + 4*s - 2)) + 4*g2*(Pk2*k1**2*(28*r**2 + r*(56*s - 19) + s*(28*s - 25)) + Pk2*k2**2*(80*r**2 + 4*r*(34*s - 23) + 56*s**2 - 78*s + 25) + Pkd2*k1**2*k2*(r + s)*(4*s - 1) + 2*Pkd2*k2**3*(r*(8*s - 3) + 2*(1 - 2*s)**2)))))/(9009*d**2*k2**2*k3**5) + D1**3*Pkd3*st**2*(D1*bd1*f*(f**2*k1**2*(-99*Pk2*k2**4*(r*(8*s - 7) + 8*s**2 - 11*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(9*s + 1) + 135*s**2 - 136*s + 1) + 33*k1**2*k2**2*(-Pk2*(40*r**2 + r*(94*s - 67) + 54*s**2 - 85*s + 23) + 2*Pkd2*k2*(4*r*s + r + 4*s**2 - 2*s - 2))) + 33*f*k2**2*(k1**4*(Pk2*(40*C*r*s - 20*C*s - 2*K*(5*r**2 + 2*r*(7*s - 6) + 9*s**2 - 16*s + 7) + 5*b1*(28*r**2 + r*(56*s - 43) + 28*s**2 - 43*s + 15) - 16*r*s - 2*r + 4*s**2 + 4*s + 2) + Pkd2*b1*k2*(r*(46*s - 7) + 46*s**2 - 45*s + 3)) + k1**2*k2**2*(Pk2*(-4*C*(53*r**2 + 14*r*(9*s - 7) + 67*s**2 - 101*s + 39) + 2*K*(22*r**2 + 24*r*s - 43*r + 2*s**2 - 41*s + 21) + b1*(56*r**2 + r*(64*s - 61) + 8*s**2 - 61*s + 29) + 114*r**2 + 268*r*s - 214*r + 142*s**2 - 220*s + 86) - 2*Pkd2*k2*(2*C*(9*r*s - 3*r + 9*s**2 - 10*s + 1) - 5*K*r*s + 3*K*r - 5*K*s**2 + 8*K*s - 3*K + b1*(3*r*(5*s - 1) + 15*s**2 - 14*s + 1) - 9*r*s + 3*r - 9*s**2 + 10*s - 1)) + k2**4*(Pk2*(4*C*(10*r**2 + r*(16*s - 9) + 4*s**2 - 5*s + 1) - 2*K*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) + b1*(2*r - 1)*(3*r + 3*s - 1) - 24*r**2 - 4*r*(9*s - 5) - 8*s**2 + 10*s - 2) + Pkd2*k2*(4*C - 2)*(r*(2*s - 1) + s*(2*s - 2)))) - 33*k2**4*(65*Pk2*b1**2*k1**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 10*Pk2*b2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(K*(k1**2*(Pk2*(172*r**2 + r*(396*s - 173) + 224*s**2 - 213*s - 5) + 2*Pkd2*k2*(r*(13*s - 5) + s*(13*s - 8))) + 7*k2**2*(Pk2*(12*r**2 + r*(24*s - 7) + 12*s**2 - 7*s - 5) + Pkd2*k2*(r*(4*s - 1) + s*(4*s - 3)))) - Pk2*(k1**2*(26*r**2 + r*(52*s - 19) + s*(26*s - 33)) + k2**2*(10*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 18*r**2 + 8*r*s - 6*r - 10*s**2 + 8*s - 5))) - 4*g2*(k1**2*(2*Pk2*(43*r**2 + r*(99*s - 46) + s*(56*s - 56)) + Pkd2*k2*(r*(13*s - 10) + s*(13*s - 13))) + 7*k2**2*(6*Pk2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pkd2*k2*(r*(2*s - 1) + s*(2*s - 2)))))) - 2145*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*k2**2*(D1*fd*(f*(Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(5*Pk2*(28*r**2 + 56*r*s - 39*r + 28*s**2 - 39*s + 15) + 2*Pkd2*k2*s*(23*r + 23*s - 11)) + k1**2*k2**2*(Pk2*(56*r**2 + 64*r*s - 99*r + 8*s**2 - 87*s + 43) + Pkd2*k2*s*(-30*r - 30*s + 13))) - 2*k2**2*(K*k1**2*(Pk2*(86*r**2 + 2*r*(99*s + 5) + 112*s**2 + 10*s - 5) + 13*Pkd2*k2*s*(r + s)) + 7*K*k2**2*(Pk2*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)) - 13*Pk2*k1**2*(r + s)**2 - Pk2*k2**2*(10*C*(r + s - 1)**2 + 9*r**2 + 2*r*(2*s + 5) - 5*(s - 1)**2))) + Dd*f*(f*(2*Pk2*k2**4*(2*r - 1)*(3*r + 3*s - 1) + k1**4*(10*Pk2*(28*r**2 + 56*r*s - 41*r + 28*s**2 - 41*s + 15) + Pkd2*k2*(92*r*s - 7*r + 92*s**2 - 67*s + 3)) + k1**2*k2**2*(4*Pk2*(28*r**2 + 8*r*(4*s - 5) + 4*s**2 - 37*s + 18) + Pkd2*k2*(r*(6 - 60*s) - 60*s**2 + 41*s - 2))) + 2*k2**2*(-K*k1**2*(Pk2*(344*r**2 + 4*r*(198*s - 61) + 448*s**2 - 304*s - 15) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))) - 7*K*k2**2*(Pk2*(24*r**2 + 48*r*s + 2*r + 24*s**2 + 2*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)) + Pk2*k1**2*(52*r**2 + 8*r*(13*s - 4) + s*(52*s - 53)) + Pk2*k2**2*(10*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 36*r**2 + 16*r*s - 20*s**2 + 21*s - 15)))) + b1*(-3*D1*f**2*fd*k1**2*(33*Pk2*k2**4*(3*r*(8*s - 3) + 24*s**2 - 21*s + 5) - k1**4*s*(2*Pk2 - Pkd2*k2)*(135*r + 135*s - 101) - 11*k1**2*k2**2*(-Pk2*(120*r**2 + 282*r*s - 169*r + 162*s**2 - 197*s + 65) + 2*Pkd2*k2*(12*r*s + 13*r + 12*s**2 + 6*s - 9))) + 66*D1*f*k2**2*(fd*(Pk2*k1**4*(10*C*(r*(4*s - 1) - 3*s + 1) - K*(10*r**2 + 28*r*s - 21*r + 18*s**2 - 27*s + 9) - 16*r*s + 2*r + 4*s**2 + 9*s - 3) + k1**2*k2**2*(Pk2*(-2*C*(106*r**2 + r*(252*s - 79) + 134*s**2 - 109*s + 8) + K*(44*r**2 + 48*r*s - 46*r + 4*s**2 - 44*s + 21) + 114*r**2 + 268*r*s - 87*r + 142*s**2 - 117*s + 10) + Pkd2*k2*(K*(r*(10*s - 7) + 10*s**2 - 13*s + 4) + s*(2 - 4*C)*(9*r + 9*s - 4))) + k2**4*(Pk2*(2*C*(20*r**2 + r*(32*s + 9) + 8*s**2 + 8*s - 12) - K*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 24*r**2 - 36*r*s - 7*r - 8*s**2 - 7*s + 12) + Pkd2*k2*s*(2*C - 1)*(4*r + 4*s - 1))) + k2**2*(-5*Pk2*bd2*(13*k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*gd2*(k1**2*(Pk2*(86*r**2 + 9*r*(22*s - 9) + 112*s**2 - 101*s - 5) + Pkd2*k2*s*(13*r + 13*s - 3)) + 7*k2**2*(Pk2*(6*r**2 + 12*r*s - r + 6*s**2 - s - 5) + Pkd2*k2*s*(2*r + 2*s - 1))))) + 66*D1*fd*k2**4*(-5*Pk2*b2*(13*k1**2 + 7*k2**2)*(r + s)**2 + 2*g2*(k1**2*(Pk2*(86*r**2 + 2*r*(99*s + 5) + 112*s**2 + 10*s - 5) + 13*Pkd2*k2*s*(r + s)) + 7*k2**2*(Pk2*(6*r**2 + 2*r*(6*s + 5) + 6*s**2 + 10*s - 5) + 2*Pkd2*k2*s*(r + s)))) + Dd*f*(f**2*k1**2*(-198*Pk2*k2**4*(8*r*(2*s - 1) + 16*s**2 - 16*s + 5) + k1**4*(2*Pk2 - Pkd2*k2)*(15*r*(36*s + 1) + 540*s**2 - 439*s + 1) + 66*k1**2*k2**2*(-Pk2*(80*r**2 + 2*r*(94*s - 59) + 108*s**2 - 141*s + 44) + Pkd2*k2*(2*r*(8*s + 7) + 16*s**2 + 4*s - 11))) + 66*f*k2**2*(Pk2*k1**4*(10*C*(r*(8*s - 1) - 6*s + 1) - K*(20*r**2 + 56*r*s - 45*r + 36*s**2 - 59*s + 23) - 32*r*s + 8*s**2 + 18*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(212*r**2 + 8*r*(63*s - 31) + 268*s**2 - 295*s + 65) + K*(88*r**2 + 96*r*s - 132*r + 8*s**2 - 126*s + 63) + 228*r**2 + 536*r*s - 272*r + 284*s**2 - 319*s + 74) + Pkd2*k2*(C*(r*(6 - 72*s) - 72*s**2 + 50*s - 2) + K*(20*r*s - 13*r + 20*s**2 - 29*s + 10) + 36*r*s - 3*r + 36*s**2 - 25*s + 1)) + k2**4*(Pk2*(2*C*(40*r**2 + r*(64*s - 3) + 16*s**2 + 2*s - 18) - K*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - 48*r**2 - 8*r*(9*s - 1) - 16*s**2 + 18) + Pkd2*k2*(2*C - 1)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 66*k2**4*(-5*Pk2*b2*(13*k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 2*g2*(k1**2*(Pk2*(344*r**2 + 4*r*(198*s - 61) + 448*s**2 - 304*s - 15) + Pkd2*k2*(2*r*(26*s - 5) + s*(52*s - 19))) + 7*k2**2*(Pk2*(24*r**2 + 48*r*s + 2*r + 24*s**2 + 2*s - 15) + Pkd2*k2*(8*r*s - r + 8*s**2 - 4*s)))))) + f*(D1*(f**2*fd*k1**4*(162*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(-2*Pk2*(5*r*(72*s - 43) + 360*s**2 - 596*s + 189) + 25*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(-165*Pk2*bd2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(r + s - 1) + fd*(Pk2*k1**4*(-2*C*(135*r**2 + 27*r*(14*s - 19) + 243*s**2 - 651*s + 304) + 135*r**2 + r*(432*s - 597) + 297*s**2 - 804*s + 371) + Pk2*k2**4*(66*C - 33)*(9*r**2 + 3*r*(9*s - 5) + 18*s**2 - 18*s + 5) + k1**2*k2**2*(Pk2*(2*C*(3078*r**2 + 5454*r*s - 4101*r + 2376*s**2 - 3699*s + 1388) - 3573*r**2 - 6246*r*s + 4596*r - 2673*s**2 + 4029*s - 1487) + Pkd2*k2*(66*C - 33)*(5*r*(3*s - 2) + 15*s**2 - 21*s + 7))) + 66*gd2*(Pk2*k1**4*(5*r**2 + 2*r*(7*s - 6) + 9*s**2 - 16*s + 7) + Pk2*k2**4*(3*r**2 + r*(9*s - 5) + 6*s**2 - 6*s + 2) - k1**2*k2**2*(Pk2*(22*r**2 + 24*r*s - 43*r + 2*s**2 - 41*s + 21) + Pkd2*k2*(5*s - 3)*(r + s - 1)))) + 66*fd*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(2*r + 2*s - 1) + 2*g2*(Pk2*k1**4*(10*r**2 + 7*r*(4*s - 3) + 18*s**2 - 27*s + 9) + Pk2*k2**4*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - k1**2*k2**2*(Pk2*(44*r**2 + 48*r*s - 46*r + 4*s**2 - 44*s + 21) + Pkd2*k2*(10*r*s - 7*r + 10*s**2 - 13*s + 4))))) + Dd*f*(f**2*k1**4*(162*Pk2*k2**2*(10*r**2 + r*(34*s - 21) + 24*s**2 - 31*s + 10) + k1**2*(-2*Pk2*(5*r*(72*s - 43) + 360*s**2 - 596*s + 189) + 25*Pkd2*k2*(3*s - 2)*(4*r + 4*s - 3))) + 2*f*k2**2*(Pk2*k1**4*(-2*C*(180*r**2 + 63*r*(8*s - 11) + 324*s**2 - 883*s + 439) + 180*r**2 + r*(576*s - 802) + 396*s**2 - 1087*s + 531) + Pk2*k2**4*(66*C - 33)*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) + k1**2*k2**2*(Pk2*(2*C*(4104*r**2 + 7272*r*s - 5838*r + 3168*s**2 - 5252*s + 2099) - 4764*r**2 - 8328*r*s + 6531*r - 3564*s**2 + 5681*s - 2231) + Pkd2*k2*(66*C - 33)*(r*(20*s - 13) + 20*s**2 - 29*s + 10))) + 66*k2**2*(-5*Pk2*b2*k1**2*(k1**2*(r + s - 1) + k2**2*(-4*r - 4*s + 3))*(4*r + 4*s - 3) + 2*g2*(Pk2*k1**4*(20*r**2 + r*(56*s - 45) + 36*s**2 - 59*s + 23) + Pk2*k2**4*(12*r**2 + 4*r*(9*s - 5) + 24*s**2 - 24*s + 7) - k1**2*k2**2*(Pk2*(88*r**2 + 96*r*s - 132*r + 8*s**2 - 126*s + 63) + Pkd2*k2*(20*r*s - 13*r + 20*s**2 - 29*s + 10)))))))/(693*d**2*k2**2*k3**5) + D1**3*Pkd3*(D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(5*r**2 + r*(9*s - 11) + 4*(s - 1)**2) + 2*k1**2*(Pk2*(s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(r + s - 1))) - f*k2**2*(Pk2*k2**4*(2 - 4*C)*(15*r**2 + r*(28*s - 13) + s*(13*s - 13)) + 2*k1**4*(Pk2*(-4*C*(10*r**2 + r*(28*s - 19) + 18*s**2 - 25*s + 7) + b1*(240*r**2 + 9*r*(50*s - 43) + 210*s**2 - 361*s + 149) + 20*r**2 + 64*r*s - 42*r + 44*s**2 - 60*s + 16) + 36*Pkd2*b1*k2*s*(r + s - 1)) + k1**2*k2**2*(Pk2*(-8*C*(64*r**2 + 133*r*s - 88*r + 69*s**2 - 81*s + 12) - 26*K*r*s - 26*K*s**2 + 26*K*s + 13*b1*(18*r**2 + 3*r*(10*s - 7) + 12*s**2 - 19*s + 5) + 280*r**2 + 580*r*s - 400*r + 300*s**2 - 348*s + 48) + Pkd2*k2*s*(24 - 48*C)*(r + s - 1))) + 2*k2**2*(5*Pk2*b1**2*k1**2*(2*k1**2 + 7*k2**2)*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 10*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*b1*(7*K*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pk2*k1**4*(70*C*(r*(4*s - 1) - 2*s + 1) + 10*K*r**2 + 18*K*s**2 - 16*K*s + 4*r*(7*K*s - 3*K - 36*s + 9) - 4*s**2 + 73*s - 35) + k1**2*k2**2*(14*K*Pkd2*k2*s*(r + s - 1) - Pk2*(10*C*(2*r**2 + r*(4 - 24*s) + 2*s**2 + 11*s - 6) - 140*K*s**2 + 126*K*s + r**2*(4 - 112*K) + r*(-252*K*s + 126*K + 148*s - 41) + 4*s**2 - 62*s + 30))) - 2*g2*(2*Pk2*k1**4*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9)) + 7*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 14*k1**2*k2**2*(2*Pk2*(4*r**2 + r*(9*s - 5) + s*(5*s - 5)) + Pkd2*k2*s*(r + s - 1))))) + 10*Pk2*b1**3*k1**2*k2**2*(2*k1**2 + 7*k2**2)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 2*Pk2*f*k1**2*k2**4*(D1*(f*fd*(22*C - 11)*(3*s - 1) - 26*f*gd2*s + 26*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(22*C - 11) - 26*g2))*(r + s - 1) - b1**2*k2**2*(D1*fd*(-14*K*Pk2*k2**4*(r + s)**2 + 13*Pk2*f*k1**2*k2**2*(18*r**2 + 15*r*(2*s - 1) + 12*s**2 - 13*s + 3) - 4*Pk2*k1**4*(K*(5*r**2 + 14*r*s + 9*s**2) + s*(140*C*(r - 1) - 72*r - 2*s + 70)) + 4*f*k1**4*(Pk2*(120*r**2 + 15*r*(15*s - 11) + 105*s**2 - 158*s + 60) + 9*Pkd2*k2*s*(2*r + 2*s - 1)) - 4*k1**2*k2**2*(7*K*Pkd2*k2*s*(r + s) + Pk2*(-10*C*(r**2 - 2*r*(6*s + 1) + s**2 + 12*s + 1) + 70*K*s**2 + r**2*(56*K - 2) + 2*r*(63*K*s - 37*s - 5) - 2*s**2 + 60*s + 5))) + 2*Dd*f*(-7*K*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + k1**4*(Pk2*(-140*C*(r*(8*s - 1) - 6*s + 1) - 40*K*r**2 - 112*K*r*s + 34*K*r - 72*K*s**2 + 46*K*s + f*(480*r**2 + 900*r*s - 717*r + 420*s**2 - 677*s + 269) + 576*r*s - 72*r + 16*s**2 - 428*s + 70) + 18*Pkd2*f*k2*s*(4*r + 4*s - 3)) + 2*k1**2*k2**2*(-7*K*Pkd2*k2*s*(4*r + 4*s - 3) + Pk2*(10*C*(4*r**2 - 48*r*s + 4*s**2 + 35*s - 4) + 13*f*(9*r**2 + 3*r*(5*s - 3) + 6*s**2 - 8*s + 2) + 2*r**2*(4 - 112*K) + 2*r*(-252*K*s + 91*K + 148*s - 14) + 2*s**2*(4 - 140*K) + 2*s*(91*K - 91) + 20)))) + b1*(D1*(f**2*fd*k1**4*(6*Pk2*k1**2*s*(5*r + 5*s - 3) + 11*Pk2*k2**2*(15*r**2 + 27*r*s - 23*r + 12*s**2 - 14*s + 8) + 10*Pkd2*k1**2*k2*s*(3*r + 3*s - 2)) + 2*f*k2**2*(10*Pk2*bd2*k1**2*(k1**2 + 7*k2**2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*Pk2*k1**4*(2*r + 2*s - 1)*(2*C*(10*r + 18*s - 5) - 10*r - 22*s + 5) + Pk2*k2**4*(2*C - 1)*(30*r**2 + r*(56*s - 15) + s*(26*s - 15)) + k1**2*k2**2*(Pk2*(4*C*(128*r**2 + r*(266*s - 86) + 138*s**2 - 80*s + 11) + 13*K*(2*s - 1)*(r + s - 1) - 280*r**2 - 580*r*s + 184*r - 300*s**2 + 160*s - 22) + Pkd2*k2*s*(24*C - 12)*(2*r + 2*s - 1))) - 2*gd2*(2*Pk2*k1**4*(5*r**2 + r*(14*s - 5) + s*(9*s - 7)) + 7*Pk2*k2**4*(r**2 + r*(2*s - 1) + s*(s - 1)) + 14*k1**2*k2**2*(2*Pk2*(4*r**2 + r*(9*s - 4) + s*(5*s - 4)) + Pkd2*k2*s*(r + s - 1)))) - 4*fd*k2**2*(r + s)*(-5*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(r + s) + g2*(2*Pk2*k1**4*(5*r + 9*s) + 7*Pk2*k2**4*(r + s) + 14*k1**2*k2**2*(8*Pk2*r + 10*Pk2*s + Pkd2*k2*s)))) + 2*Dd*f*(f**2*k1**4*(11*Pk2*k2**2*(10*r**2 + r*(18*s - 17) + 8*s**2 - 11*s + 6) + k1**2*(Pk2*(4*s - 1)*(5*r + 5*s - 3) + 5*Pkd2*k2*s*(4*r + 4*s - 3))) + f*k2**2*(4*Pk2*k1**4*(C*(40*r**2 + 2*r*(56*s - 27) + 72*s**2 - 74*s + 17) - 20*r**2 + r*(28 - 64*s) - 44*s**2 + 43*s - 9) + Pk2*k2**4*(2*C - 1)*(60*r**2 + r*(112*s - 43) + s*(52*s - 43)) + k1**2*k2**2*(Pk2*(4*C*(256*r**2 + r*(532*s - 249) + 276*s**2 - 229*s + 34) + 13*K*(4*s - 1)*(r + s - 1) - 560*r**2 - 1160*r*s + 546*r - 600*s**2 + 470*s - 68) + Pkd2*k2*s*(24*C - 12)*(4*r + 4*s - 3))) - 2*k2**2*(-5*Pk2*b2*k1**2*(k1**2 + 7*k2**2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + g2*(2*Pk2*k1**4*(20*r**2 + r*(56*s - 17) + s*(36*s - 23)) + 7*Pk2*k2**4*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 14*k1**2*k2**2*(Pk2*(32*r**2 + 72*r*s - 26*r + 40*s**2 - 26*s) + Pkd2*k2*s*(4*r + 4*s - 3)))))))/(21*d**2*k2**2*k3**5)
        return np.sqrt((4*np.pi)/5)*(perm12+perm13+perm23)